/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/keyCodes","vs/base/common/arrays","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/charCode","vs/base/browser/browser","vs/base/common/scrollable","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/base","vs/base/browser/event","vs/base/common/path","vs/base/common/equals","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/numbers","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/browser/ui/list/list","vs/base/common/assert","vs/base/common/map","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/range","vs/base/common/buffer","vs/base/common/codiconsUtil","vs/base/common/filters","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/observable","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/hash","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/browser/canIUse","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/contextview/contextview","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/common/observableInternal/lazyObservableValue","vs/base/common/observableInternal/api","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/codiconsLibrary","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/contextview/contextview","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/keybindings","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],ve=function(ne){for(var t=[],i=0,n=ne.length;i<n;i++)t[i]=we[ne[i]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Ut,setPrototypeOf:Wt,isFrozen:ai,getPrototypeOf:ui,getOwnPropertyDescriptor:hi}=Object;let{freeze:at,seal:$t,create:ci}=Object,{apply:It,construct:Ot}=typeof Reflect<"u"&&Reflect;It||(It=function(t,i,n){return t.apply(i,n)}),at||(at=function(t){return t}),$t||($t=function(t){return t}),Ot||(Ot=function(t,i){return new t(...i)});const fi=bt(Array.prototype.forEach),Ht=bt(Array.prototype.pop),Et=bt(Array.prototype.push),kt=bt(String.prototype.toLowerCase),Mt=bt(String.prototype.toString),di=bt(String.prototype.match),pt=bt(String.prototype.replace),gi=bt(String.prototype.indexOf),mi=bt(String.prototype.trim),gt=bt(RegExp.prototype.test),yt=bi(TypeError);function bt(ne){return function(t){for(var i=arguments.length,n=new Array(i>1?i-1:0),M=1;M<i;M++)n[M-1]=arguments[M];return It(ne,t,n)}}function bi(ne){return function(){for(var t=arguments.length,i=new Array(t),n=0;n<t;n++)i[n]=arguments[n];return Ot(ne,i)}}function Ke(ne,t,i){var n;i=(n=i)!==null&&n!==void 0?n:kt,Wt&&Wt(ne,null);let M=t.length;for(;M--;){let R=t[M];if(typeof R=="string"){const L=i(R);L!==R&&(ai(t)||(t[M]=L),R=L)}ne[R]=!0}return ne}function vt(ne){const t=ci(null);for(const[i,n]of Ut(ne))t[i]=n;return t}function Nt(ne,t){for(;ne!==null;){const n=hi(ne,t);if(n){if(n.get)return bt(n.get);if(typeof n.value=="function")return bt(n.value)}ne=ui(ne)}function i(n){return console.warn("fallback value for",n),null}return i}const xt=at(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=at(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Bt=at(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),$i=at(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),jt=at(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),pi=at(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),zt=at(["#text"]),Zt=at(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ct=at(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=at(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Lt=at(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),wi=$t(/\{\{[\w\W]*|[\w\W]*\}\}/gm),vi=$t(/<%[\w\W]*|[\w\W]*%>/gm),Di=$t(/\${[\w\W]*}/gm),Ei=$t(/^data-[\-\w.\u00B7-\uFFFF]/),yi=$t(/^aria-[\-\w]+$/),Kt=$t(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),Ai=$t(/^(?:\w+script|data):/i),Si=$t(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),qt=$t(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:wi,ERB_EXPR:vi,TMPLIT_EXPR:Di,DATA_ATTR:Ei,ARIA_ATTR:yi,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:Ai,ATTR_WHITESPACE:Si,DOCTYPE_NAME:qt});const Ti=()=>typeof window>"u"?null:window,ki=function(t,i){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let n=null;const M="data-tt-policy-suffix";i&&i.hasAttribute(M)&&(n=i.getAttribute(M));const R="dompurify"+(n?"#"+n:"");try{return t.createPolicy(R,{createHTML(L){return L},createScriptURL(L){return L}})}catch{return console.warn("TrustedTypes policy "+R+" could not be created."),null}};function Xt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:Ti();const t=Ue=>Xt(Ue);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const i=ne.document,n=i.currentScript;let{document:M}=ne;const{DocumentFragment:R,HTMLTemplateElement:L,Node:v,Element:E,NodeFilter:f,NamedNodeMap:$=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:A,DOMParser:b,trustedTypes:m}=ne,e=E.prototype,s=Nt(e,"cloneNode"),o=Nt(e,"nextSibling"),h=Nt(e,"childNodes"),c=Nt(e,"parentNode");if(typeof L=="function"){const Ue=M.createElement("template");Ue.content&&Ue.content.ownerDocument&&(M=Ue.content.ownerDocument)}let p,k="";const{implementation:y,createNodeIterator:r,createDocumentFragment:d,getElementsByTagName:D}=M,{importNode:T}=i;let U={};t.isSupported=typeof Ut=="function"&&typeof c=="function"&&y&&y.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:_,ERB_EXPR:H,TMPLIT_EXPR:w,DATA_ATTR:C,ARIA_ATTR:W,IS_SCRIPT_OR_DATA:O,ATTR_WHITESPACE:B}=Gt;let{IS_ALLOWED_URI:z}=Gt,J=null;const X=Ke({},[...xt,...Pt,...Bt,...jt,...zt]);let K=null;const Q=Ke({},[...Zt,...Ct,...Vt,...Lt]);let he=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),be=null,Se=null,Fe=!0,se=!0,ee=!1,ce=!0,ae=!1,Ne=!1,te=!1,$e=!1,ye=!1,Oe=!1,Re=!1,Ce=!0,re=!1;const V="user-content-";let j=!0,a=!1,l={},g=null;const I=Ke({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let F=null;const u=Ke({},["audio","video","img","source","image","track"]);let N=null;const S=Ke({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),P="http://www.w3.org/1998/Math/MathML",x="http://www.w3.org/2000/svg",G="http://www.w3.org/1999/xhtml";let ie=G,le=!1,de=null;const Ee=Ke({},[P,x,G],Mt);let De;const Te=["application/xhtml+xml","text/html"],ke="text/html";let fe,Ie=null;const ze=M.createElement("form"),Xe=function(ge){return ge instanceof RegExp||ge instanceof Function},tt=function(ge){if(!(Ie&&Ie===ge)){if((!ge||typeof ge!="object")&&(ge={}),ge=vt(ge),De=Te.indexOf(ge.PARSER_MEDIA_TYPE)===-1?De=ke:De=ge.PARSER_MEDIA_TYPE,fe=De==="application/xhtml+xml"?Mt:kt,J="ALLOWED_TAGS"in ge?Ke({},ge.ALLOWED_TAGS,fe):X,K="ALLOWED_ATTR"in ge?Ke({},ge.ALLOWED_ATTR,fe):Q,de="ALLOWED_NAMESPACES"in ge?Ke({},ge.ALLOWED_NAMESPACES,Mt):Ee,N="ADD_URI_SAFE_ATTR"in ge?Ke(vt(S),ge.ADD_URI_SAFE_ATTR,fe):S,F="ADD_DATA_URI_TAGS"in ge?Ke(vt(u),ge.ADD_DATA_URI_TAGS,fe):u,g="FORBID_CONTENTS"in ge?Ke({},ge.FORBID_CONTENTS,fe):I,be="FORBID_TAGS"in ge?Ke({},ge.FORBID_TAGS,fe):{},Se="FORBID_ATTR"in ge?Ke({},ge.FORBID_ATTR,fe):{},l="USE_PROFILES"in ge?ge.USE_PROFILES:!1,Fe=ge.ALLOW_ARIA_ATTR!==!1,se=ge.ALLOW_DATA_ATTR!==!1,ee=ge.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=ge.ALLOW_SELF_CLOSE_IN_ATTR!==!1,ae=ge.SAFE_FOR_TEMPLATES||!1,Ne=ge.WHOLE_DOCUMENT||!1,ye=ge.RETURN_DOM||!1,Oe=ge.RETURN_DOM_FRAGMENT||!1,Re=ge.RETURN_TRUSTED_TYPE||!1,$e=ge.FORCE_BODY||!1,Ce=ge.SANITIZE_DOM!==!1,re=ge.SANITIZE_NAMED_PROPS||!1,j=ge.KEEP_CONTENT!==!1,a=ge.IN_PLACE||!1,z=ge.ALLOWED_URI_REGEXP||Kt,ie=ge.NAMESPACE||G,he=ge.CUSTOM_ELEMENT_HANDLING||{},ge.CUSTOM_ELEMENT_HANDLING&&Xe(ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(he.tagNameCheck=ge.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&Xe(ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(he.attributeNameCheck=ge.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ge.CUSTOM_ELEMENT_HANDLING&&typeof ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(he.allowCustomizedBuiltInElements=ge.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),ae&&(se=!1),Oe&&(ye=!0),l&&(J=Ke({},[...zt]),K=[],l.html===!0&&(Ke(J,xt),Ke(K,Zt)),l.svg===!0&&(Ke(J,Pt),Ke(K,Ct),Ke(K,Lt)),l.svgFilters===!0&&(Ke(J,Bt),Ke(K,Ct),Ke(K,Lt)),l.mathMl===!0&&(Ke(J,jt),Ke(K,Vt),Ke(K,Lt))),ge.ADD_TAGS&&(J===X&&(J=vt(J)),Ke(J,ge.ADD_TAGS,fe)),ge.ADD_ATTR&&(K===Q&&(K=vt(K)),Ke(K,ge.ADD_ATTR,fe)),ge.ADD_URI_SAFE_ATTR&&Ke(N,ge.ADD_URI_SAFE_ATTR,fe),ge.FORBID_CONTENTS&&(g===I&&(g=vt(g)),Ke(g,ge.FORBID_CONTENTS,fe)),j&&(J["#text"]=!0),Ne&&Ke(J,["html","head","body"]),J.table&&(Ke(J,["tbody"]),delete be.tbody),ge.TRUSTED_TYPES_POLICY){if(typeof ge.TRUSTED_TYPES_POLICY.createHTML!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ge.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw yt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');p=ge.TRUSTED_TYPES_POLICY,k=p.createHTML("")}else p===void 0&&(p=ki(m,n)),p!==null&&typeof k=="string"&&(k=p.createHTML(""));at&&at(ge),Ie=ge}},lt=Ke({},["mi","mo","mn","ms","mtext"]),rt=Ke({},["foreignobject","desc","title","annotation-xml"]),qe=Ke({},["title","style","font","a","script"]),Ye=Ke({},Pt);Ke(Ye,Bt),Ke(Ye,$i);const Y=Ke({},jt);Ke(Y,pi);const ue=function(ge){let Me=c(ge);(!Me||!Me.tagName)&&(Me={namespaceURI:ie,tagName:"template"});const je=kt(ge.tagName),Ge=kt(Me.tagName);return de[ge.namespaceURI]?ge.namespaceURI===x?Me.namespaceURI===G?je==="svg":Me.namespaceURI===P?je==="svg"&&(Ge==="annotation-xml"||lt[Ge]):!!Ye[je]:ge.namespaceURI===P?Me.namespaceURI===G?je==="math":Me.namespaceURI===x?je==="math"&&rt[Ge]:!!Y[je]:ge.namespaceURI===G?Me.namespaceURI===x&&!rt[Ge]||Me.namespaceURI===P&&!lt[Ge]?!1:!Y[je]&&(qe[je]||!Ye[je]):!!(De==="application/xhtml+xml"&&de[ge.namespaceURI]):!1},pe=function(ge){Et(t.removed,{element:ge});try{ge.parentNode.removeChild(ge)}catch{ge.remove()}},Ae=function(ge,Me){try{Et(t.removed,{attribute:Me.getAttributeNode(ge),from:Me})}catch{Et(t.removed,{attribute:null,from:Me})}if(Me.removeAttribute(ge),ge==="is"&&!K[ge])if(ye||Oe)try{pe(Me)}catch{}else try{Me.setAttribute(ge,"")}catch{}},Be=function(ge){let Me,je;if($e)ge="<remove></remove>"+ge;else{const dt=di(ge,/^[\r\n\t ]+/);je=dt&&dt[0]}De==="application/xhtml+xml"&&ie===G&&(ge='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ge+"</body></html>");const Ge=p?p.createHTML(ge):ge;if(ie===G)try{Me=new b().parseFromString(Ge,De)}catch{}if(!Me||!Me.documentElement){Me=y.createDocument(ie,"template",null);try{Me.documentElement.innerHTML=le?k:Ge}catch{}}const it=Me.body||Me.documentElement;return ge&&je&&it.insertBefore(M.createTextNode(je),it.childNodes[0]||null),ie===G?D.call(Me,Ne?"html":"body")[0]:Ne?Me.documentElement:it},He=function(ge){return r.call(ge.ownerDocument||ge,ge,f.SHOW_ELEMENT|f.SHOW_COMMENT|f.SHOW_TEXT,null,!1)},Je=function(ge){return ge instanceof A&&(typeof ge.nodeName!="string"||typeof ge.textContent!="string"||typeof ge.removeChild!="function"||!(ge.attributes instanceof $)||typeof ge.removeAttribute!="function"||typeof ge.setAttribute!="function"||typeof ge.namespaceURI!="string"||typeof ge.insertBefore!="function"||typeof ge.hasChildNodes!="function")},ot=function(ge){return typeof v=="object"?ge instanceof v:ge&&typeof ge=="object"&&typeof ge.nodeType=="number"&&typeof ge.nodeName=="string"},nt=function(ge,Me,je){U[ge]&&fi(U[ge],Ge=>{Ge.call(t,Me,je,Ie)})},ut=function(ge){let Me;if(nt("beforeSanitizeElements",ge,null),Je(ge))return pe(ge),!0;const je=fe(ge.nodeName);if(nt("uponSanitizeElement",ge,{tagName:je,allowedTags:J}),ge.hasChildNodes()&&!ot(ge.firstElementChild)&&(!ot(ge.content)||!ot(ge.content.firstElementChild))&&gt(/<[/\w]/g,ge.innerHTML)&&gt(/<[/\w]/g,ge.textContent))return pe(ge),!0;if(!J[je]||be[je]){if(!be[je]&&ft(je)&&(he.tagNameCheck instanceof RegExp&&gt(he.tagNameCheck,je)||he.tagNameCheck instanceof Function&&he.tagNameCheck(je)))return!1;if(j&&!g[je]){const Ge=c(ge)||ge.parentNode,it=h(ge)||ge.childNodes;if(it&&Ge){const dt=it.length;for(let Qe=dt-1;Qe>=0;--Qe)Ge.insertBefore(s(it[Qe],!0),o(ge))}}return pe(ge),!0}return ge instanceof E&&!ue(ge)||(je==="noscript"||je==="noembed"||je==="noframes")&&gt(/<\/no(script|embed|frames)/i,ge.innerHTML)?(pe(ge),!0):(ae&&ge.nodeType===3&&(Me=ge.textContent,Me=pt(Me,_," "),Me=pt(Me,H," "),Me=pt(Me,w," "),ge.textContent!==Me&&(Et(t.removed,{element:ge.cloneNode()}),ge.textContent=Me)),nt("afterSanitizeElements",ge,null),!1)},st=function(ge,Me,je){if(Ce&&(Me==="id"||Me==="name")&&(je in M||je in ze))return!1;if(!(se&&!Se[Me]&&gt(C,Me))){if(!(Fe&&gt(W,Me))){if(!K[Me]||Se[Me]){if(!(ft(ge)&&(he.tagNameCheck instanceof RegExp&&gt(he.tagNameCheck,ge)||he.tagNameCheck instanceof Function&&he.tagNameCheck(ge))&&(he.attributeNameCheck instanceof RegExp&&gt(he.attributeNameCheck,Me)||he.attributeNameCheck instanceof Function&&he.attributeNameCheck(Me))||Me==="is"&&he.allowCustomizedBuiltInElements&&(he.tagNameCheck instanceof RegExp&&gt(he.tagNameCheck,je)||he.tagNameCheck instanceof Function&&he.tagNameCheck(je))))return!1}else if(!N[Me]){if(!gt(z,pt(je,B,""))){if(!((Me==="src"||Me==="xlink:href"||Me==="href")&&ge!=="script"&&gi(je,"data:")===0&&F[ge])){if(!(ee&&!gt(O,pt(je,B,"")))){if(je)return!1}}}}}}return!0},ft=function(ge){return ge.indexOf("-")>0},ht=function(ge){let Me,je,Ge,it;nt("beforeSanitizeAttributes",ge,null);const{attributes:dt}=ge;if(!dt)return;const Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:K};for(it=dt.length;it--;){Me=dt[it];const{name:mt,namespaceURI:At}=Me;if(je=mt==="value"?Me.value:mi(Me.value),Ge=fe(mt),Qe.attrName=Ge,Qe.attrValue=je,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,nt("uponSanitizeAttribute",ge,Qe),je=Qe.attrValue,Qe.forceKeepAttr||(Ae(mt,ge),!Qe.keepAttr))continue;if(!ce&&gt(/\/>/i,je)){Ae(mt,ge);continue}ae&&(je=pt(je,_," "),je=pt(je,H," "),je=pt(je,w," "));const Ft=fe(ge.nodeName);if(st(Ft,Ge,je)){if(re&&(Ge==="id"||Ge==="name")&&(Ae(mt,ge),je=V+je),p&&typeof m=="object"&&typeof m.getAttributeType=="function"&&!At)switch(m.getAttributeType(Ft,Ge)){case"TrustedHTML":{je=p.createHTML(je);break}case"TrustedScriptURL":{je=p.createScriptURL(je);break}}try{At?ge.setAttributeNS(At,mt,je):ge.setAttribute(mt,je),Ht(t.removed)}catch{}}}nt("afterSanitizeAttributes",ge,null)},wt=function Ue(ge){let Me;const je=He(ge);for(nt("beforeSanitizeShadowDOM",ge,null);Me=je.nextNode();)nt("uponSanitizeShadowNode",Me,null),!ut(Me)&&(Me.content instanceof R&&Ue(Me.content),ht(Me));nt("afterSanitizeShadowDOM",ge,null)};return t.sanitize=function(Ue){let ge=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Me,je,Ge,it;if(le=!Ue,le&&(Ue="<!-->"),typeof Ue!="string"&&!ot(Ue))if(typeof Ue.toString=="function"){if(Ue=Ue.toString(),typeof Ue!="string")throw yt("dirty is not a string, aborting")}else throw yt("toString is not a function");if(!t.isSupported)return Ue;if(te||tt(ge),t.removed=[],typeof Ue=="string"&&(a=!1),a){if(Ue.nodeName){const mt=fe(Ue.nodeName);if(!J[mt]||be[mt])throw yt("root node is forbidden and cannot be sanitized in-place")}}else if(Ue instanceof v)Me=Be("<!---->"),je=Me.ownerDocument.importNode(Ue,!0),je.nodeType===1&&je.nodeName==="BODY"||je.nodeName==="HTML"?Me=je:Me.appendChild(je);else{if(!ye&&!ae&&!Ne&&Ue.indexOf("<")===-1)return p&&Re?p.createHTML(Ue):Ue;if(Me=Be(Ue),!Me)return ye?null:Re?k:""}Me&&$e&&pe(Me.firstChild);const dt=He(a?Ue:Me);for(;Ge=dt.nextNode();)ut(Ge)||(Ge.content instanceof R&&wt(Ge.content),ht(Ge));if(a)return Ue;if(ye){if(Oe)for(it=d.call(Me.ownerDocument);Me.firstChild;)it.appendChild(Me.firstChild);else it=Me;return(K.shadowroot||K.shadowrootmode)&&(it=T.call(i,it,!0)),it}let Qe=Ne?Me.outerHTML:Me.innerHTML;return Ne&&J["!doctype"]&&Me.ownerDocument&&Me.ownerDocument.doctype&&Me.ownerDocument.doctype.name&&gt(qt,Me.ownerDocument.doctype.name)&&(Qe="<!DOCTYPE "+Me.ownerDocument.doctype.name+`>
`+Qe),ae&&(Qe=pt(Qe,_," "),Qe=pt(Qe,H," "),Qe=pt(Qe,w," ")),p&&Re?p.createHTML(Qe):Qe},t.setConfig=function(Ue){tt(Ue),te=!0},t.clearConfig=function(){Ie=null,te=!1},t.isValidAttribute=function(Ue,ge,Me){Ie||tt({});const je=fe(Ue),Ge=fe(ge);return st(je,Ge,Me)},t.addHook=function(Ue,ge){typeof ge=="function"&&(U[Ue]=U[Ue]||[],Et(U[Ue],ge))},t.removeHook=function(Ue){if(U[Ue])return Ht(U[Ue])},t.removeHooks=function(Ue){U[Ue]&&(U[Ue]=[])},t.removeAllHooks=function(){U={}},t}var Ni=Xt();define("vs/base/browser/dompurify/dompurify",function(){return Ni}),define(we[56],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8T=void 0,t.$9T=M;class i{constructor(L){this.domNode=L,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(L){const v=n(L);this.a!==v&&(this.a=v,this.domNode.style.maxWidth=this.a)}setWidth(L){const v=n(L);this.b!==v&&(this.b=v,this.domNode.style.width=this.b)}setHeight(L){const v=n(L);this.c!==v&&(this.c=v,this.domNode.style.height=this.c)}setTop(L){const v=n(L);this.d!==v&&(this.d=v,this.domNode.style.top=this.d)}setLeft(L){const v=n(L);this.e!==v&&(this.e=v,this.domNode.style.left=this.e)}setBottom(L){const v=n(L);this.f!==v&&(this.f=v,this.domNode.style.bottom=this.f)}setRight(L){const v=n(L);this.g!==v&&(this.g=v,this.domNode.style.right=this.g)}setPaddingTop(L){const v=n(L);this.h!==v&&(this.h=v,this.domNode.style.paddingTop=this.h)}setPaddingLeft(L){const v=n(L);this.i!==v&&(this.i=v,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(L){const v=n(L);this.j!==v&&(this.j=v,this.domNode.style.paddingBottom=this.j)}setPaddingRight(L){const v=n(L);this.k!==v&&(this.k=v,this.domNode.style.paddingRight=this.k)}setFontFamily(L){this.l!==L&&(this.l=L,this.domNode.style.fontFamily=this.l)}setFontWeight(L){this.m!==L&&(this.m=L,this.domNode.style.fontWeight=this.m)}setFontSize(L){const v=n(L);this.n!==v&&(this.n=v,this.domNode.style.fontSize=this.n)}setFontStyle(L){this.o!==L&&(this.o=L,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(L){this.p!==L&&(this.p=L,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(L){this.q!==L&&(this.q=L,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(L){this.r!==L&&(this.r=L,this.domNode.style.textDecoration=this.r)}setLineHeight(L){const v=n(L);this.s!==v&&(this.s=v,this.domNode.style.lineHeight=this.s)}setLetterSpacing(L){const v=n(L);this.t!==v&&(this.t=v,this.domNode.style.letterSpacing=this.t)}setClassName(L){this.u!==L&&(this.u=L,this.domNode.className=this.u)}toggleClassName(L,v){this.domNode.classList.toggle(L,v),this.u=this.domNode.className}setDisplay(L){this.v!==L&&(this.v=L,this.domNode.style.display=this.v)}setPosition(L){this.w!==L&&(this.w=L,this.domNode.style.position=this.w)}setVisibility(L){this.x!==L&&(this.x=L,this.domNode.style.visibility=this.x)}setColor(L){this.y!==L&&(this.y=L,this.domNode.style.color=this.y)}setBackgroundColor(L){this.z!==L&&(this.z=L,this.domNode.style.backgroundColor=this.z)}setLayerHinting(L){this.A!==L&&(this.A=L,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(L){this.C!==L&&(this.C=L,this.domNode.style.boxShadow=L)}setContain(L){this.B!==L&&(this.B=L,this.domNode.style.contain=this.B)}setAttribute(L,v){this.domNode.setAttribute(L,v)}removeAttribute(L){this.domNode.removeAttribute(L)}appendChild(L){this.domNode.appendChild(L.domNode)}removeChild(L){this.domNode.removeChild(L.domNode)}}t.$8T=i;function n(R){return typeof R=="number"?`${R}px`:R}function M(R){return new i(R)}}),define(we[86],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fS=void 0,t.$gS=R;const i=new WeakMap;function n(v){if(!v.parent||v.parent===v)return null;try{const E=v.location,f=v.parent.location;if(E.origin!=="null"&&f.origin!=="null"&&E.origin!==f.origin)return null}catch{return null}return v.parent}class M{static a(E){let f=i.get(E);if(!f){f=[],i.set(E,f);let $=E,A;do A=n($),A?f.push({window:new WeakRef($),iframeElement:$.frameElement||null}):f.push({window:new WeakRef($),iframeElement:null}),$=A;while($)}return f.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(E,f){if(!f||E===f)return{top:0,left:0};let $=0,A=0;const b=this.a(E);for(const m of b){const e=m.window.deref();if($+=e?.scrollY??0,A+=e?.scrollX??0,e===f||!m.iframeElement)break;const s=m.iframeElement.getBoundingClientRect();$+=s.top,A+=s.left}return{top:$,left:A}}}t.$fS=M;async function R(v,E){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const f=JSON.stringify({parentOrigin:v,salt:E}),A=new TextEncoder().encode(f),b=await crypto.subtle.digest("sha-256",A);return L(b)}function L(v){const f=Array.from(new Uint8Array(v)).map($=>$.toString(16).padStart(2,"0")).join("");return BigInt(`0x${f}`).toString(32).padStart(52,"0")}}),define(we[34],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cV=n,t.$dV=M;let i={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupManagedHover:()=>null,showManagedHover:()=>{}};function n(R){i=R}function M(){return i}}),define(we[42],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RU=t.$QU=t.$PU=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var i;(function(L){L[L.Copy=0]="Copy",L[L.Move=1]="Move"})(i||(t.ListDragOverEffectType=i={}));var n;(function(L){L.Over="drop-target",L.Before="drop-target-before",L.After="drop-target-after"})(n||(t.ListDragOverEffectPosition=n={})),t.$PU={reject(){return{accept:!1}},accept(){return{accept:!0}}};class M extends Error{constructor(v,E){super(`ListError [${v}] ${E}`)}}t.$QU=M;class R{constructor(){this.c=new WeakMap}getHeight(v){return this.c.get(v)??this.d(v)}setDynamicHeight(v,E){E>0&&this.c.set(v,E)}}t.$RU=R}),define(we[87],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FU=void 0;class i{constructor(M){this.a=M}splice(M,R,L){this.a.forEach(v=>v.splice(M,R,L))}}t.$FU=i}),define(we[57],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bU=void 0;const i=20;class n{constructor(R,L,v,E,f,$){this.a=Math.round(L),this.b=Math.round(v),this.c=Math.round(R),this.d=E,this.e=f,this.f=$,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new n(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(R){const L=Math.round(R);return this.d!==L?(this.d=L,this.m(),!0):!1}setScrollSize(R){const L=Math.round(R);return this.e!==L?(this.e=L,this.m(),!0):!1}setScrollPosition(R){const L=Math.round(R);return this.f!==L?(this.f=L,this.m(),!0):!1}setScrollbarSize(R){this.a=Math.round(R)}setOppositeScrollbarSize(R){this.b=Math.round(R)}static l(R,L,v,E,f){const $=Math.max(0,v-R),A=Math.max(0,$-2*L),b=E>0&&E>v;if(!b)return{computedAvailableSize:Math.round($),computedIsNeeded:b,computedSliderSize:Math.round(A),computedSliderRatio:0,computedSliderPosition:0};const m=Math.round(Math.max(i,Math.floor(v*A/E))),e=(A-m)/(E-v),s=f*e;return{computedAvailableSize:Math.round($),computedIsNeeded:b,computedSliderSize:Math.round(m),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const R=n.l(this.b,this.c,this.d,this.e,this.f);this.g=R.computedAvailableSize,this.h=R.computedIsNeeded,this.i=R.computedSliderSize,this.j=R.computedSliderRatio,this.k=R.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(R){if(!this.h)return 0;const L=R-this.c-this.i/2;return Math.round(L/this.j)}getDesiredScrollPositionFromOffsetPaged(R){if(!this.h)return 0;const L=R-this.c;let v=this.f;return L<this.k?v-=this.d:v+=this.d,v}getDesiredScrollPositionFromDelta(R){if(!this.h)return 0;const L=this.k+R;return Math.round(L/this.j)}}t.$bU=n}),define(we[35],ve([1,0,42]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PW=t.$OW=t.$NW=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(f){f[f.Hidden=0]="Hidden",f[f.Visible=1]="Visible",f[f.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var M;(function(f){f[f.Expanded=0]="Expanded",f[f.Collapsed=1]="Collapsed",f[f.PreserveOrExpanded=2]="PreserveOrExpanded",f[f.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(M||(t.ObjectTreeElementCollapseState=M={}));var R;(function(f){f[f.Unknown=0]="Unknown",f[f.Twistie=1]="Twistie",f[f.Element=2]="Element",f[f.Filter=3]="Filter"})(R||(t.TreeMouseEventTarget=R={}));var L;(function(f){f[f.Down=0]="Down",f[f.Up=1]="Up"})(L||(t.TreeDragOverBubble=L={})),t.$NW={acceptBubbleUp(){return{accept:!0,bubble:L.Up}},acceptBubbleDown(f=!1){return{accept:!0,bubble:L.Down,autoExpand:f}},acceptCopyBubbleUp(){return{accept:!0,bubble:L.Up,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over}}},acceptCopyBubbleDown(f=!1){return{accept:!0,bubble:L.Down,effect:{type:i.ListDragOverEffectType.Copy,position:i.ListDragOverEffectPosition.Over},autoExpand:f}}};class v extends Error{constructor($,A){super(`TreeError [${$}] ${A}`)}}t.$OW=v;class E{constructor($){this.a=$,this.b=new WeakMap}map($){let A=this.b.get($);return A||(A=this.a($),this.b.set($,A)),A}}t.$PW=E}),define(we[25],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VR=void 0,t.$UR=i,t.$WR=n;function i(M,R){const L=M;typeof L.vscodeWindowId!="number"&&Object.defineProperty(L,"vscodeWindowId",{get:()=>R})}t.$VR=window;function n(M){return M===t.$VR?!1:typeof M?.vscodeWindowId=="number"}}),define(we[88],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ob=void 0,t.$hb=i,t.$ib=n,t.$jb=M,t.$kb=R,t.$lb=L,t.$mb=v,t.$nb=E,t.$pb=$,t.$qb=A,t.$rb=b,t.$sb=m,t.$tb=e;function i(s,o){const h=n(s,o);if(h!==-1)return s[h]}function n(s,o,h=s.length-1){for(let c=h;c>=0;c--){const p=s[c];if(o(p))return c}return-1}function M(s,o){const h=R(s,o);return h===-1?void 0:s[h]}function R(s,o,h=0,c=s.length){let p=h,k=c;for(;p<k;){const y=Math.floor((p+k)/2);o(s[y])?p=y+1:k=y}return p-1}function L(s,o){const h=v(s,o);return h===s.length?void 0:s[h]}function v(s,o,h=0,c=s.length){let p=h,k=c;for(;p<k;){const y=Math.floor((p+k)/2);o(s[y])?k=y:p=y+1}return p}function E(s,o,h=0,c=s.length){const p=v(s,o,h,c);return p===s.length?-1:p}class f{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(f.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!o(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const h=R(this.e,o,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}t.$ob=f;function $(s,o){if(s.length===0)return;let h=s[0];for(let c=1;c<s.length;c++){const p=s[c];o(p,h)>0&&(h=p)}return h}function A(s,o){if(s.length===0)return;let h=s[0];for(let c=1;c<s.length;c++){const p=s[c];o(p,h)>=0&&(h=p)}return h}function b(s,o){return $(s,(h,c)=>-o(h,c))}function m(s,o){if(s.length===0)return-1;let h=0;for(let c=1;c<s.length;c++){const p=s[c];o(p,s[h])>0&&(h=c)}return h}function e(s,o){for(const h of s){const c=o(h);if(c!==void 0)return c}}}),define(we[18],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharCode=void 0;var i;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(i||(t.CharCode=i={}))}),define(we[58],ve([1,0]),function(ne,t){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.$O=void 0,t.$K=n,t.$L=M,t.$M=R,t.$N=L;function n(E,f){const $=Object.create(null);for(const A of E){const b=f(A);let m=$[b];m||(m=$[b]=[]),m.push(A)}return $}function M(E,f){const $=[],A=[];for(const b of E)f.has(b)||$.push(b);for(const b of f)E.has(b)||A.push(b);return{removed:$,added:A}}function R(E,f){const $=[],A=[];for(const[b,m]of E)f.has(b)||$.push(m);for(const[b,m]of f)E.has(b)||A.push(m);return{removed:$,added:A}}function L(E,f){const $=new Set;for(const A of f)E.has(A)&&$.add(A);return $}class v{static{i=Symbol.toStringTag}constructor(f,$){this.b=$,this.a=new Map,this[i]="SetWithKey";for(const A of f)this.add(A)}get size(){return this.a.size}add(f){const $=this.b(f);return this.a.set($,f),this}delete(f){return this.a.delete(this.b(f))}has(f){return this.a.has(this.b(f))}*entries(){for(const f of this.a.values())yield[f,f]}keys(){return this.values()}*values(){for(const f of this.a.values())yield f}clear(){this.a.clear()}forEach(f,$){this.a.forEach(A=>f.call($,A,A,this))}[Symbol.iterator](){return this.values()}}t.$O=v}),define(we[89],ve([1,0,18]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hu=t.$gu=t.$fu=t.$eu=void 0;function n(E,f){const $=Math.pow(10,f);return Math.round(E*$)/$}class M{constructor(f,$,A,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,$))|0,this.b=Math.min(255,Math.max(0,A))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(f,$){return f.r===$.r&&f.g===$.g&&f.b===$.b&&f.a===$.a}}t.$eu=M;class R{constructor(f,$,A,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,$),0),3),this.l=n(Math.max(Math.min(1,A),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(f,$){return f.h===$.h&&f.s===$.s&&f.l===$.l&&f.a===$.a}static fromRGBA(f){const $=f.r/255,A=f.g/255,b=f.b/255,m=f.a,e=Math.max($,A,b),s=Math.min($,A,b);let o=0,h=0;const c=(s+e)/2,p=e-s;if(p>0){switch(h=Math.min(c<=.5?p/(2*c):p/(2-2*c),1),e){case $:o=(A-b)/p+(A<b?6:0);break;case A:o=(b-$)/p+2;break;case b:o=($-A)/p+4;break}o*=60,o=Math.round(o)}return new R(o,h,c,m)}static i(f,$,A){return A<0&&(A+=1),A>1&&(A-=1),A<1/6?f+($-f)*6*A:A<1/2?$:A<2/3?f+($-f)*(2/3-A)*6:f}static toRGBA(f){const $=f.h/360,{s:A,l:b,a:m}=f;let e,s,o;if(A===0)e=s=o=b;else{const h=b<.5?b*(1+A):b+A-b*A,c=2*b-h;e=R.i(c,h,$+1/3),s=R.i(c,h,$),o=R.i(c,h,$-1/3)}return new M(Math.round(e*255),Math.round(s*255),Math.round(o*255),m)}}t.$fu=R;class L{constructor(f,$,A,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=n(Math.max(Math.min(1,$),0),3),this.v=n(Math.max(Math.min(1,A),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(f,$){return f.h===$.h&&f.s===$.s&&f.v===$.v&&f.a===$.a}static fromRGBA(f){const $=f.r/255,A=f.g/255,b=f.b/255,m=Math.max($,A,b),e=Math.min($,A,b),s=m-e,o=m===0?0:s/m;let h;return s===0?h=0:m===$?h=((A-b)/s%6+6)%6:m===A?h=(b-$)/s+2:h=($-A)/s+4,new L(Math.round(h*60),o,m,f.a)}static toRGBA(f){const{h:$,s:A,v:b,a:m}=f,e=b*A,s=e*(1-Math.abs($/60%2-1)),o=b-e;let[h,c,p]=[0,0,0];return $<60?(h=e,c=s):$<120?(h=s,c=e):$<180?(c=e,p=s):$<240?(c=s,p=e):$<300?(h=s,p=e):$<=360&&(h=e,p=s),h=Math.round((h+o)*255),c=Math.round((c+o)*255),p=Math.round((p+o)*255),new M(h,c,p,m)}}t.$gu=L;class v{static fromHex(f){return v.Format.CSS.parseHex(f)||v.red}static equals(f,$){return!f&&!$?!0:!f||!$?!1:f.equals($)}get hsla(){return this.i?this.i:R.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:L.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof M)this.rgba=f;else if(f instanceof R)this.i=f,this.rgba=R.toRGBA(f);else if(f instanceof L)this.j=f,this.rgba=L.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&M.equals(this.rgba,f.rgba)&&R.equals(this.hsla,f.hsla)&&L.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=v.k(this.rgba.r),$=v.k(this.rgba.g),A=v.k(this.rgba.b),b=.2126*f+.7152*$+.0722*A;return n(b,4)}static k(f){const $=f/255;return $<=.03928?$/12.92:Math.pow(($+.055)/1.055,2.4)}getContrastRatio(f){const $=this.getRelativeLuminance(),A=f.getRelativeLuminance();return $>A?($+.05)/(A+.05):(A+.05)/($+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const $=this.getRelativeLuminance(),A=f.getRelativeLuminance();return $>A}isDarkerThan(f){const $=this.getRelativeLuminance(),A=f.getRelativeLuminance();return $<A}lighten(f){return new v(new R(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new v(new R(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:$,g:A,b,a:m}=this.rgba;return new v(new M($,A,b,m*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const $=f.rgba,A=this.rgba.a,b=$.a,m=A+b*(1-A);if(m<1e-6)return v.transparent;const e=this.rgba.r*A/m+$.r*b*(1-A)/m,s=this.rgba.g*A/m+$.g*b*(1-A)/m,o=this.rgba.b*A/m+$.b*b*(1-A)/m;return new v(new M(e,s,o,m))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:$,g:A,b,a:m}=this.rgba;return new v(new M(f.rgba.r-m*(f.rgba.r-$),f.rgba.g-m*(f.rgba.g-A),f.rgba.b-m*(f.rgba.b-b),1))}flatten(...f){const $=f.reduceRight((A,b)=>v.o(b,A));return v.o(this,$)}static o(f,$){const A=1-f.rgba.a;return new v(new M(A*$.rgba.r+f.rgba.a*f.rgba.r,A*$.rgba.g+f.rgba.a*f.rgba.g,A*$.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(f,$,A){if(f.isLighterThan($))return f;A=A||.5;const b=f.getRelativeLuminance(),m=$.getRelativeLuminance();return A=A*(m-b)/m,f.lighten(A)}static getDarkerColor(f,$,A){if(f.isDarkerThan($))return f;A=A||.5;const b=f.getRelativeLuminance(),m=$.getRelativeLuminance();return A=A*(b-m)/b,f.darken(A)}static{this.white=new v(new M(255,255,255,1))}static{this.black=new v(new M(0,0,0,1))}static{this.red=new v(new M(255,0,0,1))}static{this.blue=new v(new M(0,0,255,1))}static{this.green=new v(new M(0,255,0,1))}static{this.cyan=new v(new M(0,255,255,1))}static{this.lightgrey=new v(new M(211,211,211,1))}static{this.transparent=new v(new M(0,0,0,0))}}t.$hu=v,function(E){let f;(function($){let A;(function(b){function m(d){return d.rgba.a===1?`rgb(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b})`:E.Format.CSS.formatRGBA(d)}b.formatRGB=m;function e(d){return`rgba(${d.rgba.r}, ${d.rgba.g}, ${d.rgba.b}, ${+d.rgba.a.toFixed(2)})`}b.formatRGBA=e;function s(d){return d.hsla.a===1?`hsl(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(d)}b.formatHSL=s;function o(d){return`hsla(${d.hsla.h}, ${(d.hsla.s*100).toFixed(2)}%, ${(d.hsla.l*100).toFixed(2)}%, ${d.hsla.a.toFixed(2)})`}b.formatHSLA=o;function h(d){const D=d.toString(16);return D.length!==2?"0"+D:D}function c(d){return`#${h(d.rgba.r)}${h(d.rgba.g)}${h(d.rgba.b)}`}b.formatHex=c;function p(d,D=!1){return D&&d.rgba.a===1?E.Format.CSS.formatHex(d):`#${h(d.rgba.r)}${h(d.rgba.g)}${h(d.rgba.b)}${h(Math.round(d.rgba.a*255))}`}b.formatHexA=p;function k(d){return d.isOpaque()?E.Format.CSS.formatHex(d):E.Format.CSS.formatRGBA(d)}b.format=k;function y(d){const D=d.length;if(D===0||d.charCodeAt(0)!==i.CharCode.Hash)return null;if(D===7){const T=16*r(d.charCodeAt(1))+r(d.charCodeAt(2)),U=16*r(d.charCodeAt(3))+r(d.charCodeAt(4)),_=16*r(d.charCodeAt(5))+r(d.charCodeAt(6));return new E(new M(T,U,_,1))}if(D===9){const T=16*r(d.charCodeAt(1))+r(d.charCodeAt(2)),U=16*r(d.charCodeAt(3))+r(d.charCodeAt(4)),_=16*r(d.charCodeAt(5))+r(d.charCodeAt(6)),H=16*r(d.charCodeAt(7))+r(d.charCodeAt(8));return new E(new M(T,U,_,H/255))}if(D===4){const T=r(d.charCodeAt(1)),U=r(d.charCodeAt(2)),_=r(d.charCodeAt(3));return new E(new M(16*T+T,16*U+U,16*_+_))}if(D===5){const T=r(d.charCodeAt(1)),U=r(d.charCodeAt(2)),_=r(d.charCodeAt(3)),H=r(d.charCodeAt(4));return new E(new M(16*T+T,16*U+U,16*_+_,(16*H+H)/255))}return null}b.parseHex=y;function r(d){switch(d){case i.CharCode.Digit0:return 0;case i.CharCode.Digit1:return 1;case i.CharCode.Digit2:return 2;case i.CharCode.Digit3:return 3;case i.CharCode.Digit4:return 4;case i.CharCode.Digit5:return 5;case i.CharCode.Digit6:return 6;case i.CharCode.Digit7:return 7;case i.CharCode.Digit8:return 8;case i.CharCode.Digit9:return 9;case i.CharCode.a:return 10;case i.CharCode.A:return 10;case i.CharCode.b:return 11;case i.CharCode.B:return 11;case i.CharCode.c:return 12;case i.CharCode.C:return 12;case i.CharCode.d:return 13;case i.CharCode.D:return 13;case i.CharCode.e:return 14;case i.CharCode.E:return 14;case i.CharCode.f:return 15;case i.CharCode.F:return 15}return 0}})(A=$.CSS||($.CSS={}))})(f=E.Format||(E.Format={}))}(v||(t.$hu=v={}))}),define(we[36],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0h=n,t.$$h=M,t.$_h=R;function i(L){return(v,E,f)=>{let $=null,A=null;if(typeof f.value=="function"?($="value",A=f.value):typeof f.get=="function"&&($="get",A=f.get),!A)throw new Error("not supported");f[$]=L(A,E)}}function n(L,v,E){let f=null,$=null;if(typeof E.value=="function"?(f="value",$=E.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(f="get",$=E.get),!$)throw new Error("not supported");const A=`$memoize$${v}`;E[f]=function(...b){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,b)}),this[A]}}function M(L,v,E){return i((f,$)=>{const A=`$debounce$${$}`,b=`$debounce$result$${$}`;return function(...m){this[b]||(this[b]=E?E():void 0),clearTimeout(this[A]),v&&(this[b]=v(this[b],...m),m=[this[b]]),this[A]=setTimeout(()=>{f.apply(this,m),this[b]=E?E():void 0},L)}})}function R(L,v,E){return i((f,$)=>{const A=`$throttle$timer$${$}`,b=`$throttle$result$${$}`,m=`$throttle$lastRun$${$}`,e=`$throttle$pending$${$}`;return function(...s){if(this[b]||(this[b]=E?E():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),v&&(this[b]=v(this[b],...s)),this[e])return;const o=this[m]+L;o<=Date.now()?(this[m]=Date.now(),f.apply(this,[this[b]]),this[b]=E?E():void 0):(this[e]=!0,this[A]=setTimeout(()=>{this[e]=!1,this[m]=Date.now(),f.apply(this,[this[b]]),this[b]=E?E():void 0},o-Date.now()))}})}}),define(we[90],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lt=void 0;class i{constructor(M,R,L,v){this.originalStart=M,this.originalLength=R,this.modifiedStart=L,this.modifiedLength=v}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Lt=i}),define(we[6],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eb=t.$db=t.$cb=t.$bb=t.$ab=t.$$=t.$7=t.$Z=t.$Y=void 0,t.setUnexpectedErrorHandler=n,t.$2=M,t.$3=R,t.$4=L,t.$5=v,t.$6=f,t.$8=A,t.$9=b,t.$0=m,t.$_=s;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?p.isErrorNoTelemetry(r)?new p(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(d=>{d(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$Y=i,t.$Z=new i;function n(y){t.$Z.setUnexpectedErrorHandler(y)}function M(y){if(!y||typeof y!="object")return!1;const r=y;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function R(y){f(y)||t.$Z.onUnexpectedError(y)}function L(y){f(y)||t.$Z.onUnexpectedExternalError(y)}function v(y){if(y instanceof Error){const{name:r,message:d}=y,D=y.stacktrace||y.stack;return{$isError:!0,name:r,message:d,stack:D,noTelemetry:p.isErrorNoTelemetry(y)}}return y}const E="Canceled";function f(y){return y instanceof $?!0:y instanceof Error&&y.name===E&&y.message===E}class $ extends Error{constructor(){super(E),this.name=this.message}}t.$7=$;function A(){const y=new Error(E);return y.name=y.message,y}function b(y){return y?new Error(`Illegal argument: ${y}`):new Error("Illegal argument")}function m(y){return y?new Error(`Illegal state: ${y}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$$=e;function s(y){return y?y.message?y.message:y.stack?y.stack.split(`
`)[0]:String(y):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$ab=o;class h extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$bb=h;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$cb=c;class p extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof p)return r;const d=new p;return d.message=r.message,d.stack=r.stack,d}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$db=p;class k extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,k.prototype)}}t.$eb=k}),define(we[9],ve([1,0,6,88]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cc=t.$bc=t.$ac=t.$$b=t.$0b=t.CompareResult=void 0,t.$ub=M,t.$vb=R,t.$wb=L,t.$xb=v,t.$yb=E,t.$zb=f,t.$Ab=$,t.$Bb=A,t.$Cb=b,t.$Db=m,t.$Eb=e,t.$Fb=s,t.$Gb=o,t.top=h,t.$Ib=c,t.$Jb=k,t.$Kb=y,t.$Lb=r,t.$Mb=d,t.$Nb=D,t.$Ob=T,t.$Pb=U,t.$Qb=_,t.$Rb=H,t.$Sb=w,t.$Tb=C,t.$Ub=W,t.$Vb=O,t.$Wb=B,t.$Xb=z,t.$Yb=J,t.$Zb=X,t.$1b=K,t.$2b=Q,t.$3b=he,t.$4b=be,t.$5b=Se,t.$6b=Fe,t.$7b=se,t.$8b=ae,t.$9b=Ne,t.$_b=ye;function M(re,V=0){return re[re.length-(1+V)]}function R(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}function L(re,V,j=(a,l)=>a===l){if(re===V)return!0;if(!re||!V||re.length!==V.length)return!1;for(let a=0,l=re.length;a<l;a++)if(!j(re[a],V[a]))return!1;return!0}function v(re,V){const j=re.length-1;V<j&&(re[V]=re[j]),re.pop()}function E(re,V,j){return f(re.length,a=>j(re[a],V))}function f(re,V){let j=0,a=re-1;for(;j<=a;){const l=(j+a)/2|0,g=V(l);if(g<0)j=l+1;else if(g>0)a=l-1;else return l}return-(j+1)}function $(re,V,j){if(re=re|0,re>=V.length)throw new TypeError("invalid index");const a=V[Math.floor(V.length*Math.random())],l=[],g=[],I=[];for(const F of V){const u=j(F,a);u<0?l.push(F):u>0?g.push(F):I.push(F)}return re<l.length?$(re,l,j):re<l.length+I.length?I[0]:$(re-(l.length+I.length),g,j)}function A(re,V){const j=[];let a;for(const l of re.slice(0).sort(V))!a||V(a[0],l)!==0?(a=[l],j.push(a)):a.push(l);return j}function*b(re,V){let j,a;for(const l of re)a!==void 0&&V(a,l)?j.push(l):(j&&(yield j),j=[l]),a=l;j&&(yield j)}function m(re,V){for(let j=0;j<=re.length;j++)V(j===0?void 0:re[j-1],j===re.length?void 0:re[j])}function e(re,V){for(let j=0;j<re.length;j++)V(j===0?void 0:re[j-1],re[j],j+1===re.length?void 0:re[j+1])}function s(re,V,j){const a=[];function l(F,u,N){if(u===0&&N.length===0)return;const S=a[a.length-1];S&&S.start+S.deleteCount===F?(S.deleteCount+=u,S.toInsert.push(...N)):a.push({start:F,deleteCount:u,toInsert:N})}let g=0,I=0;for(;;){if(g===re.length){l(g,0,V.slice(I));break}if(I===V.length){l(g,re.length-g,[]);break}const F=re[g],u=V[I],N=j(F,u);N===0?(g+=1,I+=1):N<0?(l(g,1,[]),g+=1):N>0&&(l(g,0,[u]),I+=1)}return a}function o(re,V,j){const a=s(re,V,j),l=[],g=[];for(const I of a)l.push(...re.slice(I.start,I.start+I.deleteCount)),g.push(...I.toInsert);return{removed:l,added:g}}function h(re,V,j){if(j===0)return[];const a=re.slice(0,j).sort(V);return p(re,V,a,j,re.length),a}function c(re,V,j,a,l){return j===0?Promise.resolve([]):new Promise((g,I)=>{(async()=>{const F=re.length,u=re.slice(0,j).sort(V);for(let N=j,S=Math.min(j+a,F);N<F;N=S,S=Math.min(S+a,F)){if(N>j&&await new Promise(P=>setTimeout(P)),l&&l.isCancellationRequested)throw new i.$7;p(re,V,u,N,S)}return u})().then(g,I)})}function p(re,V,j,a,l){for(const g=j.length;a<l;a++){const I=re[a];if(V(I,j[g-1])<0){j.pop();const F=(0,n.$mb)(j,u=>V(I,u)<0);j.splice(F,0,I)}}}function k(re){return re.filter(V=>!!V)}function y(re){let V=0;for(let j=0;j<re.length;j++)re[j]&&(re[V]=re[j],V+=1);re.length=V}function r(re,V,j){re.splice(j,0,re.splice(V,1)[0])}function d(re){return!Array.isArray(re)||re.length===0}function D(re){return Array.isArray(re)&&re.length>0}function T(re,V=j=>j){const j=new Set;return re.filter(a=>{const l=V(a);return j.has(l)?!1:(j.add(l),!0)})}function U(re){const V=new Set;return j=>{const a=re(j);return V.has(a)?!1:(V.add(a),!0)}}function _(re,V){return re.length>0?re[0]:V}function H(re,V){return re.length>0?re[re.length-1]:V}function w(re,V,j=(a,l)=>a===l){let a=0;for(let l=0,g=Math.min(re.length,V.length);l<g&&j(re[l],V[l]);l++)a++;return a}function C(re,V){let j=typeof V=="number"?re:0;typeof V=="number"?j=re:(j=0,V=re);const a=[];if(j<=V)for(let l=j;l<V;l++)a.push(l);else for(let l=j;l>V;l--)a.push(l);return a}function W(re,V,j){return re.reduce((a,l)=>(a[V(l)]=j?j(l):l,a),Object.create(null))}function O(re,V){return re.push(V),()=>B(re,V)}function B(re,V){const j=re.indexOf(V);if(j>-1)return re.splice(j,1),V}function z(re,V,j){const a=re.slice(0,V),l=re.slice(V);return a.concat(j,l)}function J(re,V){let j;if(typeof V=="number"){let a=V;j=()=>{const l=Math.sin(a++)*179426549;return l-Math.floor(l)}}else j=Math.random;for(let a=re.length-1;a>0;a-=1){const l=Math.floor(j()*(a+1)),g=re[a];re[a]=re[l],re[l]=g}}function X(re,V){const j=re.indexOf(V);j>-1&&(re.splice(j,1),re.unshift(V))}function K(re,V){const j=re.indexOf(V);j>-1&&(re.splice(j,1),re.push(V))}function Q(re,V){for(const j of V)re.push(j)}function he(re,V){return Array.isArray(re)?re.map(V):V(re)}function be(re){return Array.isArray(re)?re:[re]}function Se(re){return re[Math.floor(Math.random()*re.length)]}function Fe(re,V,j){const a=ee(re,V),l=re.length,g=j.length;re.length=l+g;for(let I=l-1;I>=a;I--)re[I+g]=re[I];for(let I=0;I<g;I++)re[I+a]=j[I]}function se(re,V,j,a){const l=ee(re,V);let g=re.splice(l,j);return g===void 0&&(g=[]),Fe(re,l,a),g}function ee(re,V){return V<0?Math.max(V+re.length,0):Math.min(V,re.length)}var ce;(function(re){function V(g){return g<0}re.isLessThan=V;function j(g){return g<=0}re.isLessThanOrEqual=j;function a(g){return g>0}re.isGreaterThan=a;function l(g){return g===0}re.isNeitherLessOrGreaterThan=l,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(ce||(t.CompareResult=ce={}));function ae(re,V){return(j,a)=>V(re(j),re(a))}function Ne(...re){return(V,j)=>{for(const a of re){const l=a(V,j);if(!ce.isNeitherLessOrGreaterThan(l))return l}return ce.neitherLessOrGreaterThan}}const te=(re,V)=>re-V;t.$0b=te;const $e=(re,V)=>(0,t.$0b)(re?1:0,V?1:0);t.$$b=$e;function ye(re){return(V,j)=>-re(V,j)}class Oe{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let j=this.c;for(;j<this.g.length&&V(this.g[j]);)j++;const a=j===this.c?null:this.g.slice(this.c,j);return this.c=j,a}takeFromEndWhile(V){let j=this.d;for(;j>=0&&V(this.g[j]);)j--;const a=j===this.d?null:this.g.slice(j+1,this.d+1);return this.d=j,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const j=this.g.slice(this.c,this.c+V);return this.c+=V,j}}t.$ac=Oe;class Re{static{this.empty=new Re(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(j=>(V(j),!0))}toArray(){const V=[];return this.iterate(j=>(V.push(j),!0)),V}filter(V){return new Re(j=>this.iterate(a=>V(a)?j(a):!0))}map(V){return new Re(j=>this.iterate(a=>j(V(a))))}some(V){let j=!1;return this.iterate(a=>(j=V(a),!j)),j}findFirst(V){let j;return this.iterate(a=>V(a)?(j=a,!1):!0),j}findLast(V){let j;return this.iterate(a=>(V(a)&&(j=a),!0)),j}findLastMaxBy(V){let j,a=!0;return this.iterate(l=>((a||ce.isGreaterThan(V(l,j)))&&(a=!1,j=l),!0)),j}}t.$bc=Re;class Ce{constructor(V){this.c=V}static createSortPermutation(V,j){const a=Array.from(V.keys()).sort((l,g)=>j(V[l],V[g]));return new Ce(a)}apply(V){return V.map((j,a)=>V[this.c[a]])}inverse(){const V=this.c.slice();for(let j=0;j<this.c.length;j++)V[this.c[j]]=j;return new Ce(V)}}t.$cc=Ce}),define(we[43],ve([1,0,6]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=n,t.$gd=M,t.$hd=R,t.$id=L,t.$jd=v,t.$kd=E;function n(f,$){if(!f)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}function M(f,$="Unreachable"){throw new Error($)}function R(f,$="unexpected state"){if(!f)throw new i.$eb(`Assertion Failed: ${$}`)}function L(f){f||(0,i.$3)(new i.$eb("Soft Assertion Failed"))}function v(f){if(!f()){debugger;f(),(0,i.$3)(new i.$eb("Assertion Failed"))}}function E(f,$){let A=0;for(;A<f.length-1;){const b=f[A],m=f[A+1];if(!$(b,m))return!1;A++}return!0}});var Li=this&&this.__createBinding||(Object.create?function(ne,t,i,n){n===void 0&&(n=i);var M=Object.getOwnPropertyDescriptor(t,i);(!M||("get"in M?!t.__esModule:M.writable||M.configurable))&&(M={enumerable:!0,get:function(){return t[i]}}),Object.defineProperty(ne,n,M)}:function(ne,t,i,n){n===void 0&&(n=i),ne[n]=t[i]}),Fi=this&&this.__setModuleDefault||(Object.create?function(ne,t){Object.defineProperty(ne,"default",{enumerable:!0,value:t})}:function(ne,t){ne.default=t}),We=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var t={};if(ne!=null)for(var i in ne)i!=="default"&&Object.prototype.hasOwnProperty.call(ne,i)&&Li(t,ne,i);return Fi(t,ne),t};define(we[31],ve([1,0,9]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8c=void 0,t.$9c=M,t.$0c=R,t.$$c=L,t.$_c=v,t.$ad=E,t.$bd=f,i=We(i);const n=(m,e)=>m===e;t.$8c=n;function M(m=t.$8c){return(e,s)=>i.$wb(e,s,m)}function R(){return(m,e)=>JSON.stringify(m)===JSON.stringify(e)}function L(){return(m,e)=>m.equals(e)}function v(m,e,s){if(s!==void 0){const o=m;return o==null||e===void 0||e===null?e===o:s(o,e)}else{const o=m;return(h,c)=>h==null||c===void 0||c===null?c===h:o(h,c)}}function E(m,e){if(m===e)return!0;if(Array.isArray(m)&&Array.isArray(e)){if(m.length!==e.length)return!1;for(let s=0;s<m.length;s++)if(!E(m[s],e[s]))return!1;return!0}if(m&&typeof m=="object"&&e&&typeof e=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const s=m,o=e,h=Object.keys(s),c=Object.keys(o),p=new Set(c);if(h.length!==c.length)return!1;for(const k of h)if(!p.has(k)||!E(s[k],o[k]))return!1;return!0}return!1}function f(m){return JSON.stringify(b(m))}let $=0;const A=new WeakMap;function b(m){if(Array.isArray(m))return m.map(b);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const e=m,s=Object.create(null);for(const o of Object.keys(e).sort())s[o]=b(e[o]);return s}else{let e=A.get(m);return e===void 0&&(e=$++,A.set(m,e)),e+"----2b76a038c20c4bcc"}return m}}),define(we[59],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fb=i;function i(n,M){const R=this;let L=!1,v;return function(){if(L)return v;if(L=!0,M)try{v=n.apply(R,arguments)}finally{M()}else v=n.apply(R,arguments);return v}}}),define(we[91],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3P=t.$2P=void 0;class i{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}t.$2P=i,t.$3P=new i("id#")}),define(we[37],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(n){function M(d){return d&&typeof d=="object"&&typeof d[Symbol.iterator]=="function"}n.is=M;const R=Object.freeze([]);function L(){return R}n.empty=L;function*v(d){yield d}n.single=v;function E(d){return M(d)?d:v(d)}n.wrap=E;function f(d){return d||R}n.from=f;function*$(d){for(let D=d.length-1;D>=0;D--)yield d[D]}n.reverse=$;function A(d){return!d||d[Symbol.iterator]().next().done===!0}n.isEmpty=A;function b(d){return d[Symbol.iterator]().next().value}n.first=b;function m(d,D){let T=0;for(const U of d)if(D(U,T++))return!0;return!1}n.some=m;function e(d,D){for(const T of d)if(D(T))return T}n.find=e;function*s(d,D){for(const T of d)D(T)&&(yield T)}n.filter=s;function*o(d,D){let T=0;for(const U of d)yield D(U,T++)}n.map=o;function*h(d,D){let T=0;for(const U of d)yield*D(U,T++)}n.flatMap=h;function*c(...d){for(const D of d)yield*D}n.concat=c;function p(d,D,T){let U=T;for(const _ of d)U=D(U,_);return U}n.reduce=p;function*k(d,D,T=d.length){for(D<0&&(D+=d.length),T<0?T+=d.length:T>d.length&&(T=d.length);D<T;D++)yield d[D]}n.slice=k;function y(d,D=Number.POSITIVE_INFINITY){const T=[];if(D===0)return[T,d];const U=d[Symbol.iterator]();for(let _=0;_<D;_++){const H=U.next();if(H.done)return[T,n.empty()];T.push(H.value)}return[T,{[Symbol.iterator](){return U}}]}n.consume=y;async function r(d){const D=[];for await(const T of d)D.push(T);return Promise.resolve(D)}n.asyncToArray=r})(i||(t.Iterable=i={}))}),define(we[8],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Rr=t.$Qr=t.$Pr=t.$Or=t.$Nr=t.ScanCode=t.KeyCode=void 0,t.$Sr=m;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(t.ScanCode=n={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,o){this._keyCodeToStr[s]=o,this._strToKeyCode[o.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||i.Unknown}}const R=new M,L=new M,v=new M;t.$Nr=new Array(230),t.$Or={};const E=[],f=Object.create(null),$=Object.create(null);t.$Pr={lowerCaseToEnum:e=>$[e]||n.None,toEnum:e=>f[e]||n.None,toString:e=>E[e]||"None"},t.$Qr=[],t.$Rr=[];for(let e=0;e<=n.MAX_VALUE;e++)t.$Qr[e]=i.DependsOnKbLayout;for(let e=0;e<=i.MAX_VALUE;e++)t.$Rr[e]=n.DependsOnKbLayout;(function(){const e="",s=[[1,n.None,"None",i.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",i.Unknown,e,0,e,e,e],[1,n.Super,"Super",i.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",i.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",i.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",i.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",i.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",i.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",i.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",i.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",i.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",i.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",i.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",i.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",i.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",i.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",i.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",i.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",i.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",i.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",i.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",i.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",i.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",i.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",i.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",i.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",i.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",i.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",i.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",i.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",i.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",i.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",i.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",i.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",i.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",i.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",i.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",i.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",i.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",i.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",i.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",i.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",i.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",i.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",i.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",i.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",i.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",i.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",i.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",i.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",i.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",i.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",i.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",i.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",i.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",i.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",i.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",i.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",i.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",i.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",i.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",i.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",i.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",i.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",i.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",i.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",i.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",i.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",i.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",i.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",i.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",i.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",i.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",i.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",i.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",i.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",i.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",i.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",i.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",i.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",i.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",i.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",i.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",i.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",i.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",i.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",i.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",i.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",i.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",i.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",i.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",i.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",i.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",i.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",i.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",i.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",i.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",i.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",i.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",i.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",i.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",i.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",i.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",i.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",i.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",i.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",i.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",i.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",i.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",i.Unknown,e,0,e,e,e],[1,n.F13,"F13",i.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",i.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",i.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",i.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",i.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",i.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",i.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",i.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",i.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",i.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",i.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",i.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",i.Unknown,e,0,e,e,e],[1,n.Help,"Help",i.Unknown,e,0,e,e,e],[1,n.Select,"Select",i.Unknown,e,0,e,e,e],[1,n.Again,"Again",i.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",i.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",i.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",i.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",i.Unknown,e,0,e,e,e],[1,n.Find,"Find",i.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",i.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",i.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",i.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",i.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",i.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",i.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",i.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",i.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",i.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",i.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",i.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",i.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",i.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",i.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",i.Unknown,e,0,e,e,e],[1,n.Props,"Props",i.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",i.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",i.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",i.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",i.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",i.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",i.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",i.Unknown,e,0,e,e,e],[1,n.None,e,i.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,i.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,i.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,i.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",i.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",i.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",i.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",i.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",i.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",i.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",i.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",i.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",i.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",i.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",i.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",i.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",i.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",i.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",i.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",i.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",i.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",i.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",i.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",i.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",i.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",i.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",i.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",i.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",i.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",i.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",i.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",i.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",i.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",i.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",i.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",i.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",i.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",i.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",i.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",i.Unknown,e,0,e,e,e],[1,n.None,e,i.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,i.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,i.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,i.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,i.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,i.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,i.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,i.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,i.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,i.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,i.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,i.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,i.Unknown,e,0,"VK_OEM_CLEAR",e,e]],o=[],h=[];for(const c of s){const[p,k,y,r,d,D,T,U,_]=c;if(h[k]||(h[k]=!0,E[k]=y,f[y]=k,$[y.toLowerCase()]=k,p&&(t.$Qr[k]=r,r!==i.Unknown&&r!==i.Enter&&r!==i.Ctrl&&r!==i.Shift&&r!==i.Alt&&r!==i.Meta&&(t.$Rr[r]=k))),!o[r]){if(o[r]=!0,!d)throw new Error(`String representation missing for key code ${r} around scan code ${y}`);R.define(r,d),L.define(r,U||d),v.define(r,_||U||d)}D&&(t.$Nr[D]=r),T&&(t.$Or[T]=r)}t.$Rr[i.Enter]=n.Enter})();var A;(function(e){function s(y){return R.keyCodeToStr(y)}e.toString=s;function o(y){return R.strToKeyCode(y)}e.fromString=o;function h(y){return L.keyCodeToStr(y)}e.toUserSettingsUS=h;function c(y){return v.keyCodeToStr(y)}e.toUserSettingsGeneral=c;function p(y){return L.strToKeyCode(y)||v.strToKeyCode(y)}e.fromUserSettings=p;function k(y){if(y>=i.Numpad0&&y<=i.NumpadDivide)return null;switch(y){case i.UpArrow:return"Up";case i.DownArrow:return"Down";case i.LeftArrow:return"Left";case i.RightArrow:return"Right"}return R.keyCodeToStr(y)}e.toElectronAccelerator=k})(A||(t.KeyCodeUtils=A={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,s){const o=(s&65535)<<16>>>0;return(e|o)>>>0}}),define(we[26],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$X=void 0;class i{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$X=i}),define(we[15],ve([1,0,26]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qU=v,t.$rU=E,t.$sU=f;let M=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const R=new i.$X(()=>M("mouse",!1)),L=new i.$X(()=>M("element",!1));function v($){M=$}function E($){return $==="element"?L.value:R.value}function f(){return M("element",!0)}}),define(we[60],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(R){this.element=R,this.next=i.Undefined,this.prev=i.Undefined}}class n{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let R=this.a;for(;R!==i.Undefined;){const L=R.next;R.prev=i.Undefined,R.next=i.Undefined,R=L}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const v=new i(R);if(this.a===i.Undefined)this.a=v,this.b=v;else if(L){const f=this.b;this.b=v,v.prev=f,f.next=v}else{const f=this.a;this.a=v,v.next=f,f.prev=v}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(v))}}shift(){if(this.a!==i.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==i.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==i.Undefined&&R.next!==i.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===i.Undefined&&R.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):R.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):R.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==i.Undefined;)yield R.element,R=R.next}}t.$7c=n}),define(we[44],ve([1,0]),function(ne,t){"use strict";var i,n,M;Object.defineProperty(t,"__esModule",{value:!0}),t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.Touch=t.$Dc=t.$Cc=void 0,t.$zc=R,t.$Ac=L,t.$Bc=v,t.$Kc=k;function R(y,r,d){let D=y.get(r);return D===void 0&&(D=d,y.set(r,D)),D}function L(y){const r=[];return y.forEach((d,D)=>{r.push(`${D} => ${d}`)}),`Map(${y.size}) {${r.join(", ")}}`}function v(y){const r=[];return y.forEach(d=>{r.push(d)}),`Set(${y.size}) {${r.join(", ")}}`}class E{constructor(r,d){this.uri=r,this.value=d}}function f(y){return Array.isArray(y)}class ${static{this.c=r=>r.toString()}constructor(r,d){if(this[i]="ResourceMap",r instanceof $)this.d=new Map(r.d),this.e=d??$.c;else if(f(r)){this.d=new Map,this.e=d??$.c;for(const[D,T]of r)this.set(D,T)}else this.d=new Map,this.e=r??$.c}set(r,d){return this.d.set(this.e(r),new E(r,d)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,d){typeof d<"u"&&(r=r.bind(d));for(const[D,T]of this.d)r(T.value,T.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Cc=$;class A{constructor(r,d){this[n]="ResourceSet",!r||typeof r=="function"?this.c=new $(r):(this.c=new $(d),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,d){this.c.forEach((D,T)=>r.call(d,T,T,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Dc=A;var b;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,d=b.None){const D=this.c.get(r);if(D)return d!==b.None&&this.m(D,d),D.value}set(r,d,D=b.None){let T=this.c.get(r);if(T)T.value=d,D!==b.None&&this.m(T,D);else{switch(T={key:r,value:d,next:void 0,previous:void 0},D){case b.None:this.k(T);break;case b.AsOld:this.j(T);break;case b.AsNew:this.k(T);break;default:this.k(T);break}this.c.set(r,T),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const d=this.c.get(r);if(d)return this.c.delete(r),this.l(d),this.f--,d.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,d){const D=this.g;let T=this.d;for(;T;){if(d?r.bind(d)(T.value,T.key,this):r(T.value,T.key,this),this.g!==D)throw new Error("LinkedMap got modified during iteration.");T=T.next}}keys(){const r=this,d=this.g;let D=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(D){const U={value:D.key,done:!1};return D=D.next,U}else return{value:void 0,done:!0}}};return T}values(){const r=this,d=this.g;let D=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(D){const U={value:D.value,done:!1};return D=D.next,U}else return{value:void 0,done:!0}}};return T}entries(){const r=this,d=this.g;let D=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==d)throw new Error("LinkedMap got modified during iteration.");if(D){const U={value:[D.key,D.value],done:!1};return D=D.next,U}else return{value:void 0,done:!0}}};return T}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.d,D=this.size;for(;d&&D>r;)this.c.delete(d.key),d=d.next,D--;this.d=d,this.f=D,d&&(d.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let d=this.e,D=this.size;for(;d&&D>r;)this.c.delete(d.key),d=d.previous,D--;this.e=d,this.f=D,d&&(d.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const d=r.next,D=r.previous;if(!d||!D)throw new Error("Invalid list");d.previous=D,D.next=d}r.next=void 0,r.previous=void 0,this.g++}m(r,d){if(!this.d||!this.e)throw new Error("Invalid list");if(!(d!==b.AsOld&&d!==b.AsNew)){if(d===b.AsOld){if(r===this.d)return;const D=r.next,T=r.previous;r===this.e?(T.next=void 0,this.e=T):(D.previous=T,T.next=D),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(d===b.AsNew){if(r===this.e)return;const D=r.next,T=r.previous;r===this.d?(D.previous=void 0,this.d=D):(D.previous=T,T.next=D),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((d,D)=>{r.push([D,d])}),r}fromJSON(r){this.clear();for(const[d,D]of r)this.set(d,D)}}t.$Ec=m;class e extends m{constructor(r,d=1){super(),this.n=r,this.o=Math.min(Math.max(0,d),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,d=b.AsNew){return super.get(r,d)}peek(r){return super.get(r,b.None)}set(r,d){return super.set(r,d,b.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class s extends e{constructor(r,d=1){super(r,d)}q(r){this.h(r)}set(r,d){return super.set(r,d),this.p(),this}}t.$Fc=s;class o extends e{constructor(r,d=1){super(r,d)}q(r){this.i(r)}set(r,d){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,d),this}}t.$Gc=o;class h{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let d=this.c.get(r)||0;return d===0?!1:(d--,d===0?this.c.delete(r):this.c.set(r,d),!0)}has(r){return this.c.has(r)}}t.$Hc=h;class c{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[d,D]of r)this.set(d,D)}clear(){this.c.clear(),this.d.clear()}set(r,d){this.c.set(r,d),this.d.set(d,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const d=this.c.get(r);return d===void 0?!1:(this.c.delete(r),this.d.delete(d),!0)}forEach(r,d){this.c.forEach((D,T)=>{r.call(d,D,T,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Ic=c;class p{constructor(){this.c=new Map}add(r,d){let D=this.c.get(r);D||(D=new Set,this.c.set(r,D)),D.add(d)}delete(r,d){const D=this.c.get(r);D&&(D.delete(d),D.size===0&&this.c.delete(r))}forEach(r,d){const D=this.c.get(r);D&&D.forEach(d)}get(r){const d=this.c.get(r);return d||new Set}}t.$Jc=p;function k(y,r){if(y===r)return!0;if(y.size!==r.size)return!1;for(const[d,D]of y)if(!r.has(d)||r.get(d)!==D)return!1;for(const[d]of r)if(!y.has(d))return!1;return!0}}),define(we[2],ve([1,0,9,58,44,59,37]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$4c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Lc=void 0,t.$Mc=$,t.$Nc=A,t.$Oc=b,t.$Pc=s,t.$Qc=o,t.$Rc=h,t.$Sc=c,t.$Tc=p,t.$Uc=k,t.$5c=C;const v=!1;let E=null;class f{constructor(){this.b=new Map}static{this.a=0}c(B){let z=this.b.get(B);return z||(z={parent:null,source:null,isSingleton:!1,value:B,idx:f.a++},this.b.set(B,z)),z}trackDisposable(B){const z=this.c(B);z.source||(z.source=new Error().stack)}setParent(B,z){const J=this.c(B);J.parent=z}markAsDisposed(B){this.b.delete(B)}markAsSingleton(B){this.c(B).isSingleton=!0}f(B,z){const J=z.get(B);if(J)return J;const X=B.parent?this.f(this.c(B.parent),z):B;return z.set(B,X),X}getTrackedDisposables(){const B=new Map;return[...this.b.entries()].filter(([,J])=>J.source!==null&&!this.f(J,B).isSingleton).flatMap(([J])=>J)}computeLeakingDisposables(B=10,z){let J;if(z)J=z;else{const be=new Map,Se=[...this.b.values()].filter(se=>se.source!==null&&!this.f(se,be).isSingleton);if(Se.length===0)return;const Fe=new Set(Se.map(se=>se.value));if(J=Se.filter(se=>!(se.parent&&Fe.has(se.parent))),J.length===0)throw new Error("There are cyclic diposable chains!")}if(!J)return;function X(be){function Se(se,ee){for(;se.length>0&&ee.some(ce=>typeof ce=="string"?ce===se[0]:se[0].match(ce));)se.shift()}const Fe=be.source.split(`
`).map(se=>se.trim().replace("at ","")).filter(se=>se!=="");return Se(Fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Fe.reverse()}const K=new M.$Jc;for(const be of J){const Se=X(be);for(let Fe=0;Fe<=Se.length;Fe++)K.add(Se.slice(0,Fe).join(`
`),be)}J.sort((0,i.$8b)(be=>be.idx,i.$0b));let Q="",he=0;for(const be of J.slice(0,B)){he++;const Se=X(be),Fe=[];for(let se=0;se<Se.length;se++){let ee=Se[se];ee=`(shared with ${K.get(Se.slice(0,se+1).join(`
`)).size}/${J.length} leaks) at ${ee}`;const ae=K.get(Se.slice(0,se).join(`
`)),Ne=(0,n.$K)([...ae].map(te=>X(te)[se]),te=>te);delete Ne[Se[se]];for(const[te,$e]of Object.entries(Ne))Fe.unshift(`    - stacktraces of ${$e.length} other leaks continue with ${te}`);Fe.unshift(ee)}Q+=`


==================== Leaking disposable ${he}/${J.length}: ${be.value.constructor.name} ====================
${Fe.join(`
`)}
============================================================

`}return J.length>B&&(Q+=`


... and ${J.length-B} more leaking disposables

`),{leaks:J,details:Q}}}t.$Lc=f;function $(O){E=O}if(v){const O="__is_disposable_tracked__";$(new class{trackDisposable(B){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{B[O]||console.log(z)},3e3)}setParent(B,z){if(B&&B!==r.None)try{B[O]=!0}catch{}}markAsDisposed(B){if(B&&B!==r.None)try{B[O]=!0}catch{}}markAsSingleton(B){}})}function A(O){return E?.trackDisposable(O),O}function b(O){E?.markAsDisposed(O)}function m(O,B){E?.setParent(O,B)}function e(O,B){if(E)for(const z of O)E.setParent(z,B)}function s(O){return E?.markAsSingleton(O),O}function o(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function h(O){if(L.Iterable.is(O)){const B=[];for(const z of O)if(z)try{z.dispose()}catch(J){B.push(J)}if(B.length===1)throw B[0];if(B.length>1)throw new AggregateError(B,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function c(O){for(const B of O)o(B)&&B.dispose();return[]}function p(...O){const B=k(()=>h(O));return e(O,B),B}function k(O){const B=A({dispose:(0,R.$fb)(()=>{b(B),O()})});return B}class y{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(B){if(!B)return B;if(B===this)throw new Error("Cannot register a disposable on itself!");return m(B,this),this.g?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(B),B}delete(B){if(B){if(B===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(B),B.dispose()}}deleteAndLeak(B){B&&this.f.has(B)&&(this.f.delete(B),m(B,null))}}t.$Vc=y;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new y,A(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(B){if(B===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(B)}}t.$Wc=r;class d{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(B){this.b||B===this.a||(this.a?.dispose(),B&&m(B,this),this.a=B)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const B=this.a;return this.a=void 0,B&&m(B,null),B}}t.$Xc=d;class D{constructor(B){this.a=new d,this.b=!1,this.a.value=B}get value(){return this.a.value}set value(B){this.b||B===this.a.value||(this.a.value=B)}dispose(){this.b=!0,this.a.dispose()}}t.$Yc=D;class T{constructor(B){this.b=B,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Zc=T;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(B){let z=B;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,b(this))},this}}t.$1c=U;class _{constructor(){this.a=new Map}acquire(B,...z){let J=this.a.get(B);J||(J={counter:0,object:this.b(B,...z)},this.a.set(B,J));const{object:X}=J,K=(0,R.$fb)(()=>{--J.counter===0&&(this.c(B,J.object),this.a.delete(B))});return J.counter++,{object:X,dispose:K}}}t.$2c=_;class H{constructor(B){this.a=B}async acquire(B,...z){const J=this.a.acquire(B,...z);try{return{object:await J.object,dispose:()=>J.dispose()}}catch(X){throw J.dispose(),X}}}t.$3c=H;class w{constructor(B){this.object=B}dispose(){}}t.$4c=w;function C(O){const B=new y;try{O(B)}finally{B.dispose()}}class W{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(B){return this.a.has(B)}get size(){return this.a.size}get(B){return this.a.get(B)}set(B,z,J=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),J||this.a.get(B)?.dispose(),this.a.set(B,z)}deleteAndDispose(B){this.a.get(B)?.dispose(),this.a.delete(B)}deleteAndLeak(B){const z=this.a.get(B);return this.a.delete(B),z}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$6c=W}),function(ne,t){typeof define=="function"&&define.amd?define(we[92],ve([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(V,j){for(var a=0;a<j.length;a++){var l=j[a];l.enumerable=l.enumerable||!1,l.configurable=!0,"value"in l&&(l.writable=!0),Object.defineProperty(V,l.key,l)}}function i(V,j,a){return j&&t(V.prototype,j),a&&t(V,a),Object.defineProperty(V,"prototype",{writable:!1}),V}function n(V,j){if(V){if(typeof V=="string")return M(V,j);var a=Object.prototype.toString.call(V).slice(8,-1);if(a==="Object"&&V.constructor&&(a=V.constructor.name),a==="Map"||a==="Set")return Array.from(V);if(a==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(a))return M(V,j)}}function M(V,j){(j==null||j>V.length)&&(j=V.length);for(var a=0,l=new Array(j);a<j;a++)l[a]=V[a];return l}function R(V,j){var a=typeof Symbol<"u"&&V[Symbol.iterator]||V["@@iterator"];if(a)return(a=a.call(V)).next.bind(a);if(Array.isArray(V)||(a=n(V))||j&&V&&typeof V.length=="number"){a&&(V=a);var l=0;return function(){return l>=V.length?{done:!0}:{done:!1,value:V[l++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=L();function v(V){ne.defaults=V}var E=/[&<>"']/,f=/[&<>"']/g,$=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(j){return b[j]};function e(V,j){if(j){if(E.test(V))return V.replace(f,m)}else if($.test(V))return V.replace(A,m);return V}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(V){return V.replace(s,function(j,a){return a=a.toLowerCase(),a==="colon"?":":a.charAt(0)==="#"?a.charAt(1)==="x"?String.fromCharCode(parseInt(a.substring(2),16)):String.fromCharCode(+a.substring(1)):""})}var h=/(^|[^\[])\^/g;function c(V,j){V=typeof V=="string"?V:V.source,j=j||"";var a={replace:function(g,I){return I=I.source||I,I=I.replace(h,"$1"),V=V.replace(g,I),a},getRegex:function(){return new RegExp(V,j)}};return a}var p=/[^\w:]/g,k=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function y(V,j,a){if(V){var l;try{l=decodeURIComponent(o(a)).replace(p,"").toLowerCase()}catch{return null}if(l.indexOf("javascript:")===0||l.indexOf("vbscript:")===0||l.indexOf("data:")===0)return null}j&&!k.test(a)&&(a=U(j,a));try{a=encodeURI(a).replace(/%25/g,"%")}catch{return null}return a}var r={},d=/^[^:]+:\/*[^/]*$/,D=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function U(V,j){r[" "+V]||(d.test(V)?r[" "+V]=V+"/":r[" "+V]=C(V,"/",!0)),V=r[" "+V];var a=V.indexOf(":")===-1;return j.substring(0,2)==="//"?a?j:V.replace(D,"$1")+j:j.charAt(0)==="/"?a?j:V.replace(T,"$1")+j:V+j}var _={exec:function(){}};function H(V){for(var j=1,a,l;j<arguments.length;j++){a=arguments[j];for(l in a)Object.prototype.hasOwnProperty.call(a,l)&&(V[l]=a[l])}return V}function w(V,j){var a=V.replace(/\|/g,function(I,F,u){for(var N=!1,S=F;--S>=0&&u[S]==="\\";)N=!N;return N?"|":" |"}),l=a.split(/ \|/),g=0;if(l[0].trim()||l.shift(),l.length>0&&!l[l.length-1].trim()&&l.pop(),l.length>j)l.splice(j);else for(;l.length<j;)l.push("");for(;g<l.length;g++)l[g]=l[g].trim().replace(/\\\|/g,"|");return l}function C(V,j,a){var l=V.length;if(l===0)return"";for(var g=0;g<l;){var I=V.charAt(l-g-1);if(I===j&&!a)g++;else if(I!==j&&a)g++;else break}return V.slice(0,l-g)}function W(V,j){if(V.indexOf(j[1])===-1)return-1;for(var a=V.length,l=0,g=0;g<a;g++)if(V[g]==="\\")g++;else if(V[g]===j[0])l++;else if(V[g]===j[1]&&(l--,l<0))return g;return-1}function O(V){V&&V.sanitize&&!V.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function B(V,j){if(j<1)return"";for(var a="";j>1;)j&1&&(a+=V),j>>=1,V+=V;return a+V}function z(V,j,a,l){var g=j.href,I=j.title?e(j.title):null,F=V[1].replace(/\\([\[\]])/g,"$1");if(V[0].charAt(0)!=="!"){l.state.inLink=!0;var u={type:"link",raw:a,href:g,title:I,text:F,tokens:l.inlineTokens(F)};return l.state.inLink=!1,u}return{type:"image",raw:a,href:g,title:I,text:e(F)}}function J(V,j){var a=V.match(/^(\s+)(?:```)/);if(a===null)return j;var l=a[1];return j.split(`
`).map(function(g){var I=g.match(/^\s+/);if(I===null)return g;var F=I[0];return F.length>=l.length?g.slice(l.length):g}).join(`
`)}var X=function(){function V(a){this.options=a||ne.defaults}var j=V.prototype;return j.space=function(l){var g=this.rules.block.newline.exec(l);if(g&&g[0].length>0)return{type:"space",raw:g[0]}},j.code=function(l){var g=this.rules.block.code.exec(l);if(g){var I=g[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:g[0],codeBlockStyle:"indented",text:this.options.pedantic?I:C(I,`
`)}}},j.fences=function(l){var g=this.rules.block.fences.exec(l);if(g){var I=g[0],F=J(I,g[3]||"");return{type:"code",raw:I,lang:g[2]?g[2].trim():g[2],text:F}}},j.heading=function(l){var g=this.rules.block.heading.exec(l);if(g){var I=g[2].trim();if(/#$/.test(I)){var F=C(I,"#");(this.options.pedantic||!F||/ $/.test(F))&&(I=F.trim())}return{type:"heading",raw:g[0],depth:g[1].length,text:I,tokens:this.lexer.inline(I)}}},j.hr=function(l){var g=this.rules.block.hr.exec(l);if(g)return{type:"hr",raw:g[0]}},j.blockquote=function(l){var g=this.rules.block.blockquote.exec(l);if(g){var I=g[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:g[0],tokens:this.lexer.blockTokens(I,[]),text:I}}},j.list=function(l){var g=this.rules.block.list.exec(l);if(g){var I,F,u,N,S,P,x,G,ie,le,de,Ee,De=g[1].trim(),Te=De.length>1,ke={type:"list",raw:"",ordered:Te,start:Te?+De.slice(0,-1):"",loose:!1,items:[]};De=Te?"\\d{1,9}\\"+De.slice(-1):"\\"+De,this.options.pedantic&&(De=Te?De:"[*+-]");for(var fe=new RegExp("^( {0,3}"+De+")((?:[	 ][^\\n]*)?(?:\\n|$))");l&&(Ee=!1,!(!(g=fe.exec(l))||this.rules.block.hr.test(l)));){if(I=g[0],l=l.substring(I.length),G=g[2].split(`
`,1)[0],ie=l.split(`
`,1)[0],this.options.pedantic?(N=2,de=G.trimLeft()):(N=g[2].search(/[^ ]/),N=N>4?1:N,de=G.slice(N),N+=g[1].length),P=!1,!G&&/^ *$/.test(ie)&&(I+=ie+`
`,l=l.substring(ie.length+1),Ee=!0),!Ee)for(var Ie=new RegExp("^ {0,"+Math.min(3,N-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ze=new RegExp("^ {0,"+Math.min(3,N-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Xe=new RegExp("^ {0,"+Math.min(3,N-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,N-1)+"}#");l&&(le=l.split(`
`,1)[0],G=le,this.options.pedantic&&(G=G.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Xe.test(G)||tt.test(G)||Ie.test(G)||ze.test(l)));){if(G.search(/[^ ]/)>=N||!G.trim())de+=`
`+G.slice(N);else if(!P)de+=`
`+G;else break;!P&&!G.trim()&&(P=!0),I+=le+`
`,l=l.substring(le.length+1)}ke.loose||(x?ke.loose=!0:/\n *\n *$/.test(I)&&(x=!0)),this.options.gfm&&(F=/^\[[ xX]\] /.exec(de),F&&(u=F[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:I,task:!!F,checked:u,loose:!1,text:de}),ke.raw+=I}ke.items[ke.items.length-1].raw=I.trimRight(),ke.items[ke.items.length-1].text=de.trimRight(),ke.raw=ke.raw.trimRight();var lt=ke.items.length;for(S=0;S<lt;S++){this.lexer.state.top=!1,ke.items[S].tokens=this.lexer.blockTokens(ke.items[S].text,[]);var rt=ke.items[S].tokens.filter(function(Ye){return Ye.type==="space"}),qe=rt.every(function(Ye){for(var Y=Ye.raw.split(""),ue=0,pe=R(Y),Ae;!(Ae=pe()).done;){var Be=Ae.value;if(Be===`
`&&(ue+=1),ue>1)return!0}return!1});!ke.loose&&rt.length&&qe&&(ke.loose=!0,ke.items[S].loose=!0)}return ke}},j.html=function(l){var g=this.rules.block.html.exec(l);if(g){var I={type:"html",raw:g[0],pre:!this.options.sanitizer&&(g[1]==="pre"||g[1]==="script"||g[1]==="style"),text:g[0]};if(this.options.sanitize){var F=this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]);I.type="paragraph",I.text=F,I.tokens=this.lexer.inline(F)}return I}},j.def=function(l){var g=this.rules.block.def.exec(l);if(g){g[3]&&(g[3]=g[3].substring(1,g[3].length-1));var I=g[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:I,raw:g[0],href:g[2],title:g[3]}}},j.table=function(l){var g=this.rules.block.table.exec(l);if(g){var I={type:"table",header:w(g[1]).map(function(x){return{text:x}}),align:g[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:g[3]&&g[3].trim()?g[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(I.header.length===I.align.length){I.raw=g[0];var F=I.align.length,u,N,S,P;for(u=0;u<F;u++)/^ *-+: *$/.test(I.align[u])?I.align[u]="right":/^ *:-+: *$/.test(I.align[u])?I.align[u]="center":/^ *:-+ *$/.test(I.align[u])?I.align[u]="left":I.align[u]=null;for(F=I.rows.length,u=0;u<F;u++)I.rows[u]=w(I.rows[u],I.header.length).map(function(x){return{text:x}});for(F=I.header.length,N=0;N<F;N++)I.header[N].tokens=this.lexer.inline(I.header[N].text);for(F=I.rows.length,N=0;N<F;N++)for(P=I.rows[N],S=0;S<P.length;S++)P[S].tokens=this.lexer.inline(P[S].text);return I}}},j.lheading=function(l){var g=this.rules.block.lheading.exec(l);if(g)return{type:"heading",raw:g[0],depth:g[2].charAt(0)==="="?1:2,text:g[1],tokens:this.lexer.inline(g[1])}},j.paragraph=function(l){var g=this.rules.block.paragraph.exec(l);if(g){var I=g[1].charAt(g[1].length-1)===`
`?g[1].slice(0,-1):g[1];return{type:"paragraph",raw:g[0],text:I,tokens:this.lexer.inline(I)}}},j.text=function(l){var g=this.rules.block.text.exec(l);if(g)return{type:"text",raw:g[0],text:g[0],tokens:this.lexer.inline(g[0])}},j.escape=function(l){var g=this.rules.inline.escape.exec(l);if(g)return{type:"escape",raw:g[0],text:e(g[1])}},j.tag=function(l){var g=this.rules.inline.tag.exec(l);if(g)return!this.lexer.state.inLink&&/^<a /i.test(g[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(g[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(g[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(g[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:g[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(g[0]):e(g[0]):g[0]}},j.link=function(l){var g=this.rules.inline.link.exec(l);if(g){var I=g[2].trim();if(!this.options.pedantic&&/^</.test(I)){if(!/>$/.test(I))return;var F=C(I.slice(0,-1),"\\");if((I.length-F.length)%2===0)return}else{var u=W(g[2],"()");if(u>-1){var N=g[0].indexOf("!")===0?5:4,S=N+g[1].length+u;g[2]=g[2].substring(0,u),g[0]=g[0].substring(0,S).trim(),g[3]=""}}var P=g[2],x="";if(this.options.pedantic){var G=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(P);G&&(P=G[1],x=G[3])}else x=g[3]?g[3].slice(1,-1):"";return P=P.trim(),/^</.test(P)&&(this.options.pedantic&&!/>$/.test(I)?P=P.slice(1):P=P.slice(1,-1)),z(g,{href:P&&P.replace(this.rules.inline._escapes,"$1"),title:x&&x.replace(this.rules.inline._escapes,"$1")},g[0],this.lexer)}},j.reflink=function(l,g){var I;if((I=this.rules.inline.reflink.exec(l))||(I=this.rules.inline.nolink.exec(l))){var F=(I[2]||I[1]).replace(/\s+/g," ");if(F=g[F.toLowerCase()],!F||!F.href){var u=I[0].charAt(0);return{type:"text",raw:u,text:u}}return z(I,F,I[0],this.lexer)}},j.emStrong=function(l,g,I){I===void 0&&(I="");var F=this.rules.inline.emStrong.lDelim.exec(l);if(F&&!(F[3]&&I.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var u=F[1]||F[2]||"";if(!u||u&&(I===""||this.rules.inline.punctuation.exec(I))){var N=F[0].length-1,S,P,x=N,G=0,ie=F[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ie.lastIndex=0,g=g.slice(-1*l.length+N);(F=ie.exec(g))!=null;)if(S=F[1]||F[2]||F[3]||F[4]||F[5]||F[6],!!S){if(P=S.length,F[3]||F[4]){x+=P;continue}else if((F[5]||F[6])&&N%3&&!((N+P)%3)){G+=P;continue}if(x-=P,!(x>0)){if(P=Math.min(P,P+x+G),Math.min(N,P)%2){var le=l.slice(1,N+F.index+P);return{type:"em",raw:l.slice(0,N+F.index+P+1),text:le,tokens:this.lexer.inlineTokens(le)}}var de=l.slice(2,N+F.index+P-1);return{type:"strong",raw:l.slice(0,N+F.index+P+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},j.codespan=function(l){var g=this.rules.inline.code.exec(l);if(g){var I=g[2].replace(/\n/g," "),F=/[^ ]/.test(I),u=/^ /.test(I)&&/ $/.test(I);return F&&u&&(I=I.substring(1,I.length-1)),I=e(I,!0),{type:"codespan",raw:g[0],text:I}}},j.br=function(l){var g=this.rules.inline.br.exec(l);if(g)return{type:"br",raw:g[0]}},j.del=function(l){var g=this.rules.inline.del.exec(l);if(g)return{type:"del",raw:g[0],text:g[2],tokens:this.lexer.inlineTokens(g[2])}},j.autolink=function(l,g){var I=this.rules.inline.autolink.exec(l);if(I){var F,u;return I[2]==="@"?(F=e(this.options.mangle?g(I[1]):I[1]),u="mailto:"+F):(F=e(I[1]),u=F),{type:"link",raw:I[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},j.url=function(l,g){var I;if(I=this.rules.inline.url.exec(l)){var F,u;if(I[2]==="@")F=e(this.options.mangle?g(I[0]):I[0]),u="mailto:"+F;else{var N;do N=I[0],I[0]=this.rules.inline._backpedal.exec(I[0])[0];while(N!==I[0]);F=e(I[0]),I[1]==="www."?u="http://"+F:u=F}return{type:"link",raw:I[0],text:F,href:u,tokens:[{type:"text",raw:F,text:F}]}}},j.inlineText=function(l,g){var I=this.rules.inline.text.exec(l);if(I){var F;return this.lexer.state.inRawBlock?F=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]:F=e(this.options.smartypants?g(I[0]):I[0]),{type:"text",raw:I[0],text:F}}},V}(),K={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:_,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};K._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,K._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,K.def=c(K.def).replace("label",K._label).replace("title",K._title).getRegex(),K.bullet=/(?:[*+-]|\d{1,9}[.)])/,K.listItemStart=c(/^( *)(bull) */).replace("bull",K.bullet).getRegex(),K.list=c(K.list).replace(/bull/g,K.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+K.def.source+")").getRegex(),K._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",K._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,K.html=c(K.html,"i").replace("comment",K._comment).replace("tag",K._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),K.paragraph=c(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.blockquote=c(K.blockquote).replace("paragraph",K.paragraph).getRegex(),K.normal=H({},K),K.gfm=H({},K.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),K.gfm.table=c(K.gfm.table).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.gfm.paragraph=c(K._paragraph).replace("hr",K.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",K.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",K._tag).getRegex(),K.pedantic=H({},K.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",K._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:_,paragraph:c(K.normal._paragraph).replace("hr",K.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",K.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:_,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:_,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=c(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=c(K._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=c(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=c(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=c(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=c(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=c(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=c(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=c(Q.reflink).replace("label",Q._label).replace("ref",K._label).getRegex(),Q.nolink=c(Q.nolink).replace("ref",K._label).getRegex(),Q.reflinkSearch=c(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=H({},Q),Q.pedantic=H({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=H({},Q.normal,{escape:c(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),Q.gfm.url=c(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=H({},Q.gfm,{br:c(Q.br).replace("{2,}","*").getRegex(),text:c(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function he(V){return V.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function be(V){var j="",a,l,g=V.length;for(a=0;a<g;a++)l=V.charCodeAt(a),Math.random()>.5&&(l="x"+l.toString(16)),j+="&#"+l+";";return j}var Se=function(){function V(a){this.tokens=[],this.tokens.links=Object.create(null),this.options=a||ne.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var l={block:K.normal,inline:Q.normal};this.options.pedantic?(l.block=K.pedantic,l.inline=Q.pedantic):this.options.gfm&&(l.block=K.gfm,this.options.breaks?l.inline=Q.breaks:l.inline=Q.gfm),this.tokenizer.rules=l}V.lex=function(l,g){var I=new V(g);return I.lex(l)},V.lexInline=function(l,g){var I=new V(g);return I.inlineTokens(l)};var j=V.prototype;return j.lex=function(l){l=l.replace(/\r\n|\r/g,`
`),this.blockTokens(l,this.tokens);for(var g;g=this.inlineQueue.shift();)this.inlineTokens(g.src,g.tokens);return this.tokens},j.blockTokens=function(l,g){var I=this;g===void 0&&(g=[]),this.options.pedantic?l=l.replace(/\t/g,"    ").replace(/^ +$/gm,""):l=l.replace(/^( *)(\t+)/gm,function(x,G,ie){return G+"    ".repeat(ie.length)});for(var F,u,N,S;l;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(x){return(F=x.call({lexer:I},l,g))?(l=l.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.space(l)){l=l.substring(F.raw.length),F.raw.length===1&&g.length>0?g[g.length-1].raw+=`
`:g.push(F);continue}if(F=this.tokenizer.code(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(F=this.tokenizer.fences(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.heading(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.hr(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.blockquote(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.list(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.html(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.def(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&(u.type==="paragraph"||u.type==="text")?(u.raw+=`
`+F.raw,u.text+=`
`+F.raw,this.inlineQueue[this.inlineQueue.length-1].src=u.text):this.tokens.links[F.tag]||(this.tokens.links[F.tag]={href:F.href,title:F.title});continue}if(F=this.tokenizer.table(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.lheading(l)){l=l.substring(F.raw.length),g.push(F);continue}if(N=l,this.options.extensions&&this.options.extensions.startBlock&&function(){var x=1/0,G=l.slice(1),ie=void 0;I.options.extensions.startBlock.forEach(function(le){ie=le.call({lexer:this},G),typeof ie=="number"&&ie>=0&&(x=Math.min(x,ie))}),x<1/0&&x>=0&&(N=l.substring(0,x+1))}(),this.state.top&&(F=this.tokenizer.paragraph(N))){u=g[g.length-1],S&&u.type==="paragraph"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F),S=N.length!==l.length,l=l.substring(F.raw.length);continue}if(F=this.tokenizer.text(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&u.type==="text"?(u.raw+=`
`+F.raw,u.text+=`
`+F.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=u.text):g.push(F);continue}if(l){var P="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(P);break}else throw new Error(P)}}return this.state.top=!0,g},j.inline=function(l,g){return g===void 0&&(g=[]),this.inlineQueue.push({src:l,tokens:g}),g},j.inlineTokens=function(l,g){var I=this;g===void 0&&(g=[]);var F,u,N,S=l,P,x,G;if(this.tokens.links){var ie=Object.keys(this.tokens.links);if(ie.length>0)for(;(P=this.tokenizer.rules.inline.reflinkSearch.exec(S))!=null;)ie.includes(P[0].slice(P[0].lastIndexOf("[")+1,-1))&&(S=S.slice(0,P.index)+"["+B("a",P[0].length-2)+"]"+S.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(P=this.tokenizer.rules.inline.blockSkip.exec(S))!=null;)S=S.slice(0,P.index)+"["+B("a",P[0].length-2)+"]"+S.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(P=this.tokenizer.rules.inline.escapedEmSt.exec(S))!=null;)S=S.slice(0,P.index)+"++"+S.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;l;)if(x||(G=""),x=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(F=de.call({lexer:I},l,g))?(l=l.substring(F.raw.length),g.push(F),!0):!1}))){if(F=this.tokenizer.escape(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.tag(l)){l=l.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.link(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.reflink(l,this.tokens.links)){l=l.substring(F.raw.length),u=g[g.length-1],u&&F.type==="text"&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(F=this.tokenizer.emStrong(l,S,G)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.codespan(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.br(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.del(l)){l=l.substring(F.raw.length),g.push(F);continue}if(F=this.tokenizer.autolink(l,be)){l=l.substring(F.raw.length),g.push(F);continue}if(!this.state.inLink&&(F=this.tokenizer.url(l,be))){l=l.substring(F.raw.length),g.push(F);continue}if(N=l,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Ee=l.slice(1),De=void 0;I.options.extensions.startInline.forEach(function(Te){De=Te.call({lexer:this},Ee),typeof De=="number"&&De>=0&&(de=Math.min(de,De))}),de<1/0&&de>=0&&(N=l.substring(0,de+1))}(),F=this.tokenizer.inlineText(N,he)){l=l.substring(F.raw.length),F.raw.slice(-1)!=="_"&&(G=F.raw.slice(-1)),x=!0,u=g[g.length-1],u&&u.type==="text"?(u.raw+=F.raw,u.text+=F.text):g.push(F);continue}if(l){var le="Infinite loop on byte: "+l.charCodeAt(0);if(this.options.silent){console.error(le);break}else throw new Error(le)}}return g},i(V,null,[{key:"rules",get:function(){return{block:K,inline:Q}}}]),V}(),Fe=function(){function V(a){this.options=a||ne.defaults}var j=V.prototype;return j.code=function(l,g,I){var F=(g||"").match(/\S*/)[0];if(this.options.highlight){var u=this.options.highlight(l,F);u!=null&&u!==l&&(I=!0,l=u)}return l=l.replace(/\n$/,"")+`
`,F?'<pre><code class="'+this.options.langPrefix+e(F,!0)+'">'+(I?l:e(l,!0))+`</code></pre>
`:"<pre><code>"+(I?l:e(l,!0))+`</code></pre>
`},j.blockquote=function(l){return`<blockquote>
`+l+`</blockquote>
`},j.html=function(l){return l},j.heading=function(l,g,I,F){if(this.options.headerIds){var u=this.options.headerPrefix+F.slug(I);return"<h"+g+' id="'+u+'">'+l+"</h"+g+`>
`}return"<h"+g+">"+l+"</h"+g+`>
`},j.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},j.list=function(l,g,I){var F=g?"ol":"ul",u=g&&I!==1?' start="'+I+'"':"";return"<"+F+u+`>
`+l+"</"+F+`>
`},j.listitem=function(l){return"<li>"+l+`</li>
`},j.checkbox=function(l){return"<input "+(l?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},j.paragraph=function(l){return"<p>"+l+`</p>
`},j.table=function(l,g){return g&&(g="<tbody>"+g+"</tbody>"),`<table>
<thead>
`+l+`</thead>
`+g+`</table>
`},j.tablerow=function(l){return`<tr>
`+l+`</tr>
`},j.tablecell=function(l,g){var I=g.header?"th":"td",F=g.align?"<"+I+' align="'+g.align+'">':"<"+I+">";return F+l+("</"+I+`>
`)},j.strong=function(l){return"<strong>"+l+"</strong>"},j.em=function(l){return"<em>"+l+"</em>"},j.codespan=function(l){return"<code>"+l+"</code>"},j.br=function(){return this.options.xhtml?"<br/>":"<br>"},j.del=function(l){return"<del>"+l+"</del>"},j.link=function(l,g,I){if(l=y(this.options.sanitize,this.options.baseUrl,l),l===null)return I;var F='<a href="'+e(l)+'"';return g&&(F+=' title="'+g+'"'),F+=">"+I+"</a>",F},j.image=function(l,g,I){if(l=y(this.options.sanitize,this.options.baseUrl,l),l===null)return I;var F='<img src="'+l+'" alt="'+I+'"';return g&&(F+=' title="'+g+'"'),F+=this.options.xhtml?"/>":">",F},j.text=function(l){return l},V}(),se=function(){function V(){}var j=V.prototype;return j.strong=function(l){return l},j.em=function(l){return l},j.codespan=function(l){return l},j.del=function(l){return l},j.html=function(l){return l},j.text=function(l){return l},j.link=function(l,g,I){return""+I},j.image=function(l,g,I){return""+I},j.br=function(){return""},V}(),ee=function(){function V(){this.seen={}}var j=V.prototype;return j.serialize=function(l){return l.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},j.getNextSafeSlug=function(l,g){var I=l,F=0;if(this.seen.hasOwnProperty(I)){F=this.seen[l];do F++,I=l+"-"+F;while(this.seen.hasOwnProperty(I))}return g||(this.seen[l]=F,this.seen[I]=0),I},j.slug=function(l,g){g===void 0&&(g={});var I=this.serialize(l);return this.getNextSafeSlug(I,g.dryrun)},V}(),ce=function(){function V(a){this.options=a||ne.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new se,this.slugger=new ee}V.parse=function(l,g){var I=new V(g);return I.parse(l)},V.parseInline=function(l,g){var I=new V(g);return I.parseInline(l)};var j=V.prototype;return j.parse=function(l,g){g===void 0&&(g=!0);var I="",F,u,N,S,P,x,G,ie,le,de,Ee,De,Te,ke,fe,Ie,ze,Xe,tt,lt=l.length;for(F=0;F<lt;F++){if(de=l[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(tt=this.options.extensions.renderers[de.type].call({parser:this},de),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){I+=tt||"";continue}switch(de.type){case"space":continue;case"hr":{I+=this.renderer.hr();continue}case"heading":{I+=this.renderer.heading(this.parseInline(de.tokens),de.depth,o(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{I+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(ie="",G="",S=de.header.length,u=0;u<S;u++)G+=this.renderer.tablecell(this.parseInline(de.header[u].tokens),{header:!0,align:de.align[u]});for(ie+=this.renderer.tablerow(G),le="",S=de.rows.length,u=0;u<S;u++){for(x=de.rows[u],G="",P=x.length,N=0;N<P;N++)G+=this.renderer.tablecell(this.parseInline(x[N].tokens),{header:!1,align:de.align[N]});le+=this.renderer.tablerow(G)}I+=this.renderer.table(ie,le);continue}case"blockquote":{le=this.parse(de.tokens),I+=this.renderer.blockquote(le);continue}case"list":{for(Ee=de.ordered,De=de.start,Te=de.loose,S=de.items.length,le="",u=0;u<S;u++)fe=de.items[u],Ie=fe.checked,ze=fe.task,ke="",fe.task&&(Xe=this.renderer.checkbox(Ie),Te?fe.tokens.length>0&&fe.tokens[0].type==="paragraph"?(fe.tokens[0].text=Xe+" "+fe.tokens[0].text,fe.tokens[0].tokens&&fe.tokens[0].tokens.length>0&&fe.tokens[0].tokens[0].type==="text"&&(fe.tokens[0].tokens[0].text=Xe+" "+fe.tokens[0].tokens[0].text)):fe.tokens.unshift({type:"text",text:Xe}):ke+=Xe),ke+=this.parse(fe.tokens,Te),le+=this.renderer.listitem(ke,ze,Ie);I+=this.renderer.list(le,Ee,De);continue}case"html":{I+=this.renderer.html(de.text);continue}case"paragraph":{I+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(le=de.tokens?this.parseInline(de.tokens):de.text;F+1<lt&&l[F+1].type==="text";)de=l[++F],le+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);I+=g?this.renderer.paragraph(le):le;continue}default:{var rt='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(rt);return}else throw new Error(rt)}}}return I},j.parseInline=function(l,g){g=g||this.renderer;var I="",F,u,N,S=l.length;for(F=0;F<S;F++){if(u=l[F],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[u.type]&&(N=this.options.extensions.renderers[u.type].call({parser:this},u),N!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(u.type))){I+=N||"";continue}switch(u.type){case"escape":{I+=g.text(u.text);break}case"html":{I+=g.html(u.text);break}case"link":{I+=g.link(u.href,u.title,this.parseInline(u.tokens,g));break}case"image":{I+=g.image(u.href,u.title,u.text);break}case"strong":{I+=g.strong(this.parseInline(u.tokens,g));break}case"em":{I+=g.em(this.parseInline(u.tokens,g));break}case"codespan":{I+=g.codespan(u.text);break}case"br":{I+=g.br();break}case"del":{I+=g.del(this.parseInline(u.tokens,g));break}case"text":{I+=g.text(u.text);break}default:{var P='Token with "'+u.type+'" type was not found.';if(this.options.silent){console.error(P);return}else throw new Error(P)}}}return I},V}();function ae(V,j,a){if(typeof V>"u"||V===null)throw new Error("marked(): input parameter is undefined or null");if(typeof V!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(V)+", string expected");if(typeof j=="function"&&(a=j,j=null),j=H({},ae.defaults,j||{}),O(j),a){var l=j.highlight,g;try{g=Se.lex(V,j)}catch(S){return a(S)}var I=function(P){var x;if(!P)try{j.walkTokens&&ae.walkTokens(g,j.walkTokens),x=ce.parse(g,j)}catch(G){P=G}return j.highlight=l,P?a(P):a(null,x)};if(!l||l.length<3||(delete j.highlight,!g.length))return I();var F=0;ae.walkTokens(g,function(S){S.type==="code"&&(F++,setTimeout(function(){l(S.text,S.lang,function(P,x){if(P)return I(P);x!=null&&x!==S.text&&(S.text=x,S.escaped=!0),F--,F===0&&I()})},0))}),F===0&&I();return}function u(S){if(S.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+e(S.message+"",!0)+"</pre>";throw S}try{var N=Se.lex(V,j);if(j.walkTokens){if(j.async)return Promise.all(ae.walkTokens(N,j.walkTokens)).then(function(){return ce.parse(N,j)}).catch(u);ae.walkTokens(N,j.walkTokens)}return ce.parse(N,j)}catch(S){u(S)}}ae.options=ae.setOptions=function(V){return H(ae.defaults,V),v(ae.defaults),ae},ae.getDefaults=L,ae.defaults=ne.defaults,ae.use=function(){for(var V=arguments.length,j=new Array(V),a=0;a<V;a++)j[a]=arguments[a];var l=H.apply(void 0,[{}].concat(j)),g=ae.defaults.extensions||{renderers:{},childTokens:{}},I;j.forEach(function(F){if(F.extensions&&(I=!0,F.extensions.forEach(function(N){if(!N.name)throw new Error("extension name required");if(N.renderer){var S=g.renderers?g.renderers[N.name]:null;S?g.renderers[N.name]=function(){for(var P=arguments.length,x=new Array(P),G=0;G<P;G++)x[G]=arguments[G];var ie=N.renderer.apply(this,x);return ie===!1&&(ie=S.apply(this,x)),ie}:g.renderers[N.name]=N.renderer}if(N.tokenizer){if(!N.level||N.level!=="block"&&N.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");g[N.level]?g[N.level].unshift(N.tokenizer):g[N.level]=[N.tokenizer],N.start&&(N.level==="block"?g.startBlock?g.startBlock.push(N.start):g.startBlock=[N.start]:N.level==="inline"&&(g.startInline?g.startInline.push(N.start):g.startInline=[N.start]))}N.childTokens&&(g.childTokens[N.name]=N.childTokens)})),F.renderer&&function(){var N=ae.defaults.renderer||new Fe,S=function(G){var ie=N[G];N[G]=function(){for(var le=arguments.length,de=new Array(le),Ee=0;Ee<le;Ee++)de[Ee]=arguments[Ee];var De=F.renderer[G].apply(N,de);return De===!1&&(De=ie.apply(N,de)),De}};for(var P in F.renderer)S(P);l.renderer=N}(),F.tokenizer&&function(){var N=ae.defaults.tokenizer||new X,S=function(G){var ie=N[G];N[G]=function(){for(var le=arguments.length,de=new Array(le),Ee=0;Ee<le;Ee++)de[Ee]=arguments[Ee];var De=F.tokenizer[G].apply(N,de);return De===!1&&(De=ie.apply(N,de)),De}};for(var P in F.tokenizer)S(P);l.tokenizer=N}(),F.walkTokens){var u=ae.defaults.walkTokens;l.walkTokens=function(N){var S=[];return S.push(F.walkTokens.call(this,N)),u&&(S=S.concat(u.call(this,N))),S}}I&&(l.extensions=g),ae.setOptions(l)})},ae.walkTokens=function(V,j){for(var a=[],l=function(){var u=I.value;switch(a=a.concat(j.call(ae,u)),u.type){case"table":{for(var N=R(u.header),S;!(S=N()).done;){var P=S.value;a=a.concat(ae.walkTokens(P.tokens,j))}for(var x=R(u.rows),G;!(G=x()).done;)for(var ie=G.value,le=R(ie),de;!(de=le()).done;){var Ee=de.value;a=a.concat(ae.walkTokens(Ee.tokens,j))}break}case"list":{a=a.concat(ae.walkTokens(u.items,j));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[u.type]?ae.defaults.extensions.childTokens[u.type].forEach(function(De){a=a.concat(ae.walkTokens(u[De],j))}):u.tokens&&(a=a.concat(ae.walkTokens(u.tokens,j)))}},g=R(V),I;!(I=g()).done;)l();return a},ae.parseInline=function(V,j){if(typeof V>"u"||V===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof V!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(V)+", string expected");j=H({},ae.defaults,j||{}),O(j);try{var a=Se.lexInline(V,j);return j.walkTokens&&ae.walkTokens(a,j.walkTokens),ce.parseInline(a,j)}catch(l){if(l.message+=`
Please report this to https://github.com/markedjs/marked.`,j.silent)return"<p>An error occurred:</p><pre>"+e(l.message+"",!0)+"</pre>";throw l}},ae.Parser=ce,ae.parser=ce.parse,ae.Renderer=Fe,ae.TextRenderer=se,ae.Lexer=Se,ae.lexer=Se.lex,ae.Tokenizer=X,ae.Slugger=ee,ae.parse=ae;var Ne=ae.options,te=ae.setOptions,$e=ae.use,ye=ae.walkTokens,Oe=ae.parseInline,Re=ae,Ce=ce.parse,re=Se.lex;ne.Lexer=Se,ne.Parser=ce,ne.Renderer=Fe,ne.Slugger=ee,ne.TextRenderer=se,ne.Tokenizer=X,ne.getDefaults=L,ne.lexer=re,ne.marked=ae,ne.options=Ne,ne.parse=Re,ne.parseInline=Oe,ne.parser=Ce,ne.setOptions=te,ne.use=$e,ne.walkTokens=ye,Object.defineProperty(ne,"__esModule",{value:!0})}),define(we[61],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MarshalledId=void 0;var i;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(i||(t.MarshalledId=i={}))}),define(we[93],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ek=i;function i(s){const o=R(s);if(o&&o.length>0)return new Uint32Array(o)}let n=0;const M=new Uint32Array(10);function R(s){if(n=0,L(s,A,E.InitialConsonant),n>0||(L(s,b,E.Vowel),n>0)||(L(s,m,E.FinalConsonant),n>0)||(L(s,e,E.CompatibilityJamo),n))return M.subarray(0,n);if(s>=44032&&s<=55203){const o=s-44032,h=o%588,c=Math.floor(o/588),p=Math.floor(h/28),k=h%28-1;if(c<A.length?L(c,A,0):E.InitialConsonant+c-E.CompatibilityJamo<e.length&&L(E.InitialConsonant+c,e,E.CompatibilityJamo),p<b.length?L(p,b,0):E.Vowel+p-E.CompatibilityJamo<e.length&&L(E.Vowel+p-E.CompatibilityJamo,e,E.CompatibilityJamo),k>=0&&(k<m.length?L(k,m,0):E.FinalConsonant+k-E.CompatibilityJamo<e.length&&L(E.FinalConsonant+k-E.CompatibilityJamo,e,E.CompatibilityJamo)),n>0)return M.subarray(0,n)}}function L(s,o,h){s>=h&&s<h+o.length&&v(o[s-h])}function v(s){s!==f.NUL&&(M[n++]=s&255,s>>8&&(M[n++]=s>>8&255),s>>16&&(M[n++]=s>>16&255))}var E;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(E||(E={}));var f;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(f||(f={}));var $;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})($||($={}));const A=new Uint8Array([f.r,f.R,f.s,f.e,f.E,f.f,f.a,f.q,f.Q,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g]),b=new Uint16Array([f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,$.hk,$.ho,$.hl,f.y,f.n,$.nj,$.np,$.nl,f.b,f.m,$.ml,f.l]),m=new Uint16Array([f.r,f.R,$.rt,f.s,$.sw,$.sg,f.e,f.f,$.fr,$.fa,$.fq,$.ft,$.fx,$.fv,$.fg,f.a,f.q,$.qt,f.t,f.T,f.d,f.w,f.c,f.z,f.x,f.v,f.g]),e=new Uint16Array([f.r,f.R,$.rt,f.s,$.sw,$.sg,f.e,f.E,f.f,$.fr,$.fa,$.fq,$.ft,$.fx,$.fv,$.fg,f.a,f.q,f.Q,$.qt,f.t,f.T,f.d,f.w,f.W,f.c,f.z,f.x,f.v,f.g,f.k,f.o,f.i,f.O,f.j,f.p,f.u,f.P,f.h,$.hk,$.ho,$.hl,f.y,f.n,$.nj,$.np,$.nl,f.b,f.m,$.ml,f.l])}),define(we[94],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_V=void 0;class i{constructor(M,R=0,L=M.length,v=R-1){this.a=M,this.b=R,this.c=L,this.d=v}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$_V=i}),define(we[95],ve([1,0,58,94]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bW=t.$aW=void 0;class M{constructor(v=[],E=10){this.h(v),this.b=E,this.d()}getHistory(){return this.j}add(v){this.a.delete(v),this.a.add(v),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(v){return this.a.has(v)}clear(){this.h([]),this.d()}d(){this.f();const v=this.j;this.c=new n.$_V(v,0,v.length,v.length)}f(){const v=this.j;v.length>this.b&&this.h(v.slice(v.length-this.b))}g(){const v=this.c.current();return v?this.j.indexOf(v):-1}h(v){this.a=new Set;for(const E of v)this.a.add(E)}get j(){const v=[];return this.a.forEach(E=>v.push(E)),v}}t.$aW=M;class R{get size(){return this.f}constructor(v,E=10,f=$=>$){if(this.g=E,this.h=f,v.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:v[0],previous:void 0,next:void 0},this.a=new i.$O([v[0]],f);for(let $=1;$<v.length;$++)this.add(v[$])}add(v){const E={value:v,previous:this.c,next:void 0};for(this.c.next=E,this.c=E,this.d=this.c,this.f++,this.a.has(v)?this.j(v):this.a.add(v);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(v){if(this.h(this.c.value)===this.h(v))return v;const E=this.c.value;return this.a.delete(E),this.c.value=v,this.a.has(v)?this.j(v):this.a.add(v),E}prepend(v){if(this.f===this.g||this.a.has(v))return;const E={value:v,previous:void 0,next:this.b};this.b.previous=E,this.b=E,this.f++,this.a.add(v)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(v){return this.a.has(v)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let v=this.b;for(;v;)yield v.value,v=v.next}j(v){let E=this.b;const f=this.h(v);for(;E!==this.c;)this.h(E.value)===f&&(E===this.b?(this.b=this.b.next,this.b.previous=void 0):(E.previous.next=E.next,E.next.previous=E.previous),this.f--),E=E.next}}t.$bW=R}),define(we[38],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Om=t.$Nm=t.$Mm=void 0,t.$Km=i,t.rot=n,t.$Pm=v;function i(E,f,$){return Math.min(Math.max(E,f),$)}function n(E,f){return(f+E%f)%f}class M{constructor(){this.a=0}getNext(){return this.a++}}t.$Mm=M;class R{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Nm=R;class L{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const $=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Om=L;function v(E,f,$,A,b,m,e,s){const o=e-$,h=s-A,c=b-$,p=m-A,k=E-$,y=f-A,r=o*o+h*h,d=o*c+h*p,D=o*k+h*y,T=c*c+p*p,U=c*k+p*y,_=1/(r*T-d*d),H=(T*D-d*U)*_,w=(r*U-d*D)*_;return H>=0&&w>=0&&H+w<1}}),define(we[27],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cd=void 0,t.$dd=R,t.$ed=b;class i{constructor(e,s,o){this.owner=e,this.debugNameSource=s,this.referenceFn=o}getDebugName(e){return R(e,this)}}t.$cd=i;const n=new Map,M=new WeakMap;function R(m,e){const s=M.get(m);if(s)return s;const o=L(m,e);if(o){let h=n.get(o)??0;h++,n.set(o,h);const c=h===1?o:`${o}#${h}`;return M.set(m,c),c}}function L(m,e){const s=M.get(m);if(s)return s;const o=e.owner?$(e.owner)+".":"";let h;const c=e.debugNameSource;if(c!==void 0)if(typeof c=="function"){if(h=c(),h!==void 0)return o+h}else return o+c;const p=e.referenceFn;if(p!==void 0&&(h=b(p),h!==void 0))return o+h;if(e.owner!==void 0){const k=v(e.owner,m);if(k!==void 0)return o+k}}function v(m,e){for(const s in m)if(m[s]===e)return s}const E=new Map,f=new WeakMap;function $(m){const e=f.get(m);if(e)return e;const s=A(m);let o=E.get(s)??0;o++,E.set(s,o);const h=o===1?s:`${s}#${o}`;return f.set(m,h),h}function A(m){const e=m.constructor;return e?e.name:"Object"}function b(m){const e=m.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(we[32],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nd=void 0,t.$Ld=n,t.$Md=M;let i;function n(s){i=s}function M(){return i}class R{constructor(){this.a=0,this.d=new WeakMap}b(o){return L([v(m("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[v(" "),f($(o.oldValue,70),{color:"red",strikeThrough:!0}),v(" "),f($(o.newValue,60),{color:"green"})]:[v(" (unchanged)")]:[v(" "),f($(o.newValue,60),{color:"green"}),v(" (initial)")]}handleObservableChanged(o,h){console.log(...this.b([E("observable value changed"),f(o.debugName,{color:"BlueViolet"}),...this.c(h)]))}formatChanges(o){if(o.size!==0)return f(" (changed deps: "+[...o].map(h=>h.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const h=o.handleChange;this.d.set(o,new Set),o.handleChange=(c,p)=>(this.d.get(o).add(c),h.apply(o,[c,p]))}handleDerivedRecomputed(o,h){const c=this.d.get(o);console.log(...this.b([E("derived recomputed"),f(o.debugName,{color:"BlueViolet"}),...this.c(h),this.formatChanges(c),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),c.clear()}handleFromEventObservableTriggered(o,h){console.log(...this.b([E("observable from event triggered"),f(o.debugName,{color:"BlueViolet"}),...this.c(h),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const h=o.handleChange;this.d.set(o,new Set),o.handleChange=(c,p)=>(this.d.get(o).add(c),h.apply(o,[c,p]))}handleAutorunTriggered(o){const h=this.d.get(o);console.log(...this.b([E("autorun"),f(o.debugName,{color:"BlueViolet"}),this.formatChanges(h),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),h.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let h=o.getDebugName();h===void 0&&(h=""),console.log(...this.b([E("transaction"),f(h,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Nd=R;function L(s){const o=new Array,h=[];let c="";function p(y){if("length"in y)for(const r of y)r&&p(r);else"text"in y?(c+=`%c${y.text}`,o.push(y.style),y.data&&h.push(...y.data)):"data"in y&&h.push(...y.data)}p(s);const k=[c,...o];return k.push(...h),k}function v(s){return f(s,{color:"black"})}function E(s){return f(e(`${s}: `,10),{color:"black",bold:!0})}function f(s,o={color:"black"}){function h(p){return Object.entries(p).reduce((k,[y,r])=>`${k}${y}:${r};`,"")}const c={color:o.color};return o.strikeThrough&&(c["text-decoration"]="line-through"),o.bold&&(c["font-weight"]="bold"),{text:s,style:h(c)}}function $(s,o){switch(typeof s){case"number":return""+s;case"string":return s.length+2<=o?`"${s}"`:`"${s.substr(0,o-7)}"+...`;case"boolean":return s?"true":"false";case"undefined":return"undefined";case"object":return s===null?"null":Array.isArray(s)?A(s,o):b(s,o);case"symbol":return s.toString();case"function":return`[[Function${s.name?" "+s.name:""}]]`;default:return""+s}}function A(s,o){let h="[ ",c=!0;for(const p of s){if(c||(h+=", "),h.length-5>o){h+="...";break}c=!1,h+=`${$(p,o-h.length)}`}return h+=" ]",h}function b(s,o){let h="{ ",c=!0;for(const[p,k]of Object.entries(s)){if(c||(h+=", "),h.length-5>o){h+="...";break}c=!1,h+=`${p}: ${$(k,o-h.length)}`}return h+=" }",h}function m(s,o){let h="";for(let c=1;c<=o;c++)h+=s;return h}function e(s,o){for(;s.length<o;)s+=" ";return s}}),define(we[45],ve([1,0,43,2,27,32]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rd=void 0,t.$ld=L,t.$md=v,t.$nd=E,t.$od=f,t.$pd=$,t.$qd=A;function L(e){return new m(new M.$cd(void 0,void 0,e),e,void 0,void 0)}function v(e,s){return new m(new M.$cd(e.owner,e.debugName,e.debugReferenceFn??s),s,void 0,void 0)}function E(e,s){return new m(new M.$cd(e.owner,e.debugName,e.debugReferenceFn??s),s,e.createEmptyChangeSummary,e.handleChange)}function f(e,s){const o=new n.$Vc,h=E({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn??s,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(c,p)=>{o.clear(),s(c,p,o)});return(0,n.$Uc)(()=>{h.dispose(),o.dispose()})}function $(e){const s=new n.$Vc,o=v({owner:void 0,debugName:void 0,debugReferenceFn:e},h=>{s.clear(),e(h,s)});return(0,n.$Uc)(()=>{o.dispose(),s.dispose()})}function A(e,s){let o;return v({debugReferenceFn:s},h=>{const c=e.read(h),p=o;o=c,s({lastValue:p,newValue:c})})}var b;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(b||(b={}));class m{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(s,o,h,c){this._debugNameData=s,this._runFn=o,this.h=h,this.i=c,this.a=b.stale,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.h?.(),(0,R.$Md)()?.handleAutorunCreated(this),this.j(),(0,n.$Nc)(this)}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear(),(0,n.$Oc)(this)}j(){if(this.a===b.upToDate)return;const s=this.f;this.f=this.e,this.e=s,this.a=b.upToDate;const o=this.c;try{if(!o){(0,R.$Md)()?.handleAutorunTriggered(this);const h=this.g;this.g=this.h?.(),this._runFn(this,h)}}finally{o||(0,R.$Md)()?.handleAutorunFinished(this);for(const h of this.f)h.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===b.upToDate&&(this.a=b.dependenciesMightHaveChanged),this.b++}endUpdate(){if(this.b===1)do{if(this.a===b.dependenciesMightHaveChanged){this.a=b.upToDate;for(const s of this.e)if(s.reportChanges(),this.a===b.stale)break}this.j()}while(this.a!==b.upToDate);this.b--,(0,i.$jd)(()=>this.b>=0)}handlePossibleChange(s){this.a===b.upToDate&&this.e.has(s)&&!this.f.has(s)&&(this.a=b.dependenciesMightHaveChanged)}handleChange(s,o){this.e.has(s)&&!this.f.has(s)&&(!this.i||this.i({changedObservable:s,change:o,didChange:c=>c===s},this.g))&&(this.a=b.stale)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const o=s.get();return this.e.add(s),this.f.delete(s),o}}t.$rd=m,function(e){e.Observer=m}(L||(t.$ld=L={}))}),define(we[28],ve([1,0,31,27,32]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=t.$8d=t.$6d=t.$1d=t.$Zd=void 0,t.$Wd=L,t.$Xd=E,t.$Yd=$,t.$2d=m,t.$3d=s,t.$4d=o,t.$5d=h,t.$7d=p,t.$9d=y;let R;function L(d){R=d}let v;function E(d){v=d}let f;function $(d){f=d}class A{get TChange(){return null}reportChanges(){this.get()}read(D){return D?D.readObservable(this):this.get()}map(D,T){const U=T===void 0?void 0:D,_=T===void 0?D:T;return f({owner:U,debugName:()=>{const H=(0,n.$ed)(_);if(H!==void 0)return H;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(_.toString());if(C)return`${this.debugName}.${C[2]}`;if(!U)return`${this.debugName} (mapped)`},debugReferenceFn:_},H=>_(this.read(H),H))}recomputeInitiallyAndOnChange(D,T){return D.add(R(this,T)),this}keepObserved(D){return D.add(v(this)),this}get a(){return this.get()}}t.$Zd=A;class b extends A{constructor(){super(...arguments),this.b=new Set}addObserver(D){const T=this.b.size;this.b.add(D),T===0&&this.c()}removeObserver(D){this.b.delete(D)&&this.b.size===0&&this.f()}c(){}f(){}}t.$1d=b;function m(d,D){const T=new c(d,D);try{d(T)}finally{T.finish()}}let e;function s(d){if(e)d(e);else{const D=new c(d,void 0);e=D;try{d(D)}finally{D.finish(),e=void 0}}}async function o(d,D){const T=new c(d,D);try{await d(T)}finally{T.finish()}}function h(d,D,T){d?D(d):m(D,T)}class c{constructor(D,T){this._fn=D,this.b=T,this.a=[],(0,M.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,n.$ed)(this._fn)}updateObserver(D,T){this.a.push({observer:D,observable:T}),D.beginUpdate(T)}finish(){const D=this.a;for(let T=0;T<D.length;T++){const{observer:U,observable:_}=D[T];U.endUpdate(_)}this.a=null,(0,M.$Md)()?.handleEndTransaction()}}t.$6d=c;function p(d,D){let T;return typeof d=="string"?T=new n.$cd(void 0,d,void 0):T=new n.$cd(d,void 0,void 0),new k(T,D,i.$8c)}class k extends b{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(D,T,U){super(),this.e=D,this.g=U,this.d=T}get(){return this.d}set(D,T,U){if(U===void 0&&this.g(this.d,D))return;let _;T||(T=_=new c(()=>{},()=>`Setting ${this.debugName}`));try{const H=this.d;this.h(D),(0,M.$Md)()?.handleObservableChanged(this,{oldValue:H,newValue:D,change:U,didChange:!0,hadValue:!0});for(const w of this.b)T.updateObserver(w,this),w.handleChange(this,U)}finally{_&&_.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(D){this.d=D}}t.$8d=k;function y(d,D){let T;return typeof d=="string"?T=new n.$cd(void 0,d,void 0):T=new n.$cd(d,void 0,void 0),new r(T,D,i.$8c)}class r extends k{h(D){this.d!==D&&(this.d&&this.d.dispose(),this.d=D)}dispose(){this.d?.dispose()}}t.$0d=r}),define(we[46],ve([1,0,43,31,2,28,27,32]),function(ne,t,i,n,M,R,L,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vd=t.$Ud=void 0,t.$Od=E,t.$Pd=f,t.$Qd=$,t.$Rd=A,t.$Sd=b,t.$Td=m;function E(h,c){return c!==void 0?new s(new L.$cd(h,void 0,c),c,void 0,void 0,void 0,n.$8c):new s(new L.$cd(void 0,void 0,h),h,void 0,void 0,void 0,n.$8c)}function f(h,c,p){return new o(new L.$cd(h,void 0,c),c,void 0,void 0,void 0,n.$8c,p)}function $(h,c){return new s(new L.$cd(h.owner,h.debugName,h.debugReferenceFn),c,void 0,void 0,h.onLastObserverRemoved,h.equalsFn??n.$8c)}(0,R.$Yd)($);function A(h,c){return new s(new L.$cd(h.owner,h.debugName,void 0),c,h.createEmptyChangeSummary,h.handleChange,void 0,h.equalityComparer??n.$8c)}function b(h,c){let p,k;c===void 0?(p=h,k=void 0):(k=h,p=c);const y=new M.$Vc;return new s(new L.$cd(k,void 0,p),r=>(y.clear(),p(r,y)),void 0,void 0,()=>y.dispose(),n.$8c)}function m(h,c){let p,k;c===void 0?(p=h,k=void 0):(k=h,p=c);const y=new M.$Vc;return new s(new L.$cd(k,void 0,p),r=>{y.clear();const d=p(r);return d&&y.add(d),d},void 0,void 0,()=>y.dispose(),n.$8c)}var e;(function(h){h[h.initial=0]="initial",h[h.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",h[h.stale=2]="stale",h[h.upToDate=3]="upToDate"})(e||(e={}));class s extends R.$1d{get debugName(){return this._debugNameData.getDebugName(this)??"(anonymous)"}constructor(c,p,k,y,r=void 0,d){super(),this._debugNameData=c,this._computeFn=p,this.m=k,this.n=y,this.p=r,this.q=d,this.e=e.initial,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.m?.(),(0,v.$Md)()?.handleDerivedCreated(this)}f(){this.e=e.initial,this.g=void 0;for(const c of this.j)c.removeObserver(this);this.j.clear(),this.p?.()}get(){if(this.b.size===0){const c=this._computeFn(this,this.m?.());return this.f(),c}else{do{if(this.e===e.dependenciesMightHaveChanged){for(const c of this.j)if(c.reportChanges(),this.e===e.stale)break}this.e===e.dependenciesMightHaveChanged&&(this.e=e.upToDate),this.t()}while(this.e!==e.upToDate);return this.g}}t(){if(this.e===e.upToDate)return;const c=this.k;this.k=this.j,this.j=c;const p=this.e!==e.initial,k=this.g;this.e=e.upToDate;const y=this.l;this.l=this.m?.();try{this.g=this._computeFn(this,y)}finally{for(const d of this.k)d.removeObserver(this);this.k.clear()}const r=p&&!this.q(k,this.g);if((0,v.$Md)()?.handleDerivedRecomputed(this,{oldValue:k,newValue:this.g,change:void 0,didChange:r,hadValue:p}),r)for(const d of this.b)d.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(c){this.h++;const p=this.h===1;if(this.e===e.upToDate&&(this.e=e.dependenciesMightHaveChanged,!p))for(const k of this.b)k.handlePossibleChange(this);if(p)for(const k of this.b)k.beginUpdate(this)}endUpdate(c){if(this.h--,this.h===0){const p=[...this.b];for(const k of p)k.endUpdate(this)}(0,i.$jd)(()=>this.h>=0)}handlePossibleChange(c){if(this.e===e.upToDate&&this.j.has(c)&&!this.k.has(c)){this.e=e.dependenciesMightHaveChanged;for(const p of this.b)p.handlePossibleChange(this)}}handleChange(c,p){if(this.j.has(c)&&!this.k.has(c)){const k=this.n?this.n({changedObservable:c,change:p,didChange:r=>r===c},this.l):!0,y=this.e===e.upToDate;if(k&&(this.e===e.dependenciesMightHaveChanged||y)&&(this.e=e.stale,y))for(const r of this.b)r.handlePossibleChange(this)}}readObservable(c){c.addObserver(this);const p=c.get();return this.j.add(c),this.k.delete(c),p}addObserver(c){const p=!this.b.has(c)&&this.h>0;super.addObserver(c),p&&c.beginUpdate(this)}removeObserver(c){const p=this.b.has(c)&&this.h>0;super.removeObserver(c),p&&c.endUpdate(this)}}t.$Ud=s;class o extends s{constructor(c,p,k,y,r=void 0,d,D){super(c,p,k,y,r,d),this.set=D}}t.$Vd=o}),define(we[96],ve([1,0,28]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ee=void 0;class n extends i.$1d{get debugName(){return this.h.getDebugName(this)??"LazyObservableValue"}constructor(R,L,v){super(),this.h=R,this.j=v,this.e=!0,this.g=[],this.l=0,this.d=L}get(){return this.k(),this.d}k(){if(!this.e)if(this.e=!0,this.g.length>0){for(const R of this.b)for(const L of this.g)R.handleChange(this,L);this.g.length=0}else for(const R of this.b)R.handleChange(this,void 0)}m(){if(this.l++,this.l===1)for(const R of this.b)R.beginUpdate(this)}n(){if(this.l--,this.l===0){this.k();const R=[...this.b];for(const L of R)L.endUpdate(this)}}addObserver(R){const L=!this.b.has(R)&&this.l>0;super.addObserver(R),L&&R.beginUpdate(this)}removeObserver(R){const L=this.b.has(R)&&this.l>0;super.removeObserver(R),L&&R.endUpdate(this)}set(R,L,v){if(v===void 0&&this.j(this.d,R))return;let E;L||(L=E=new i.$6d(()=>{},()=>`Setting ${this.debugName}`));try{if(this.e=!1,this.o(R),v!==void 0&&this.g.push(v),L.updateObserver({beginUpdate:()=>this.m(),endUpdate:()=>this.n(),handleChange:(f,$)=>{},handlePossibleChange:f=>{}},this),this.l>1)for(const f of this.b)f.handlePossibleChange(this)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}o(R){this.d=R}}t.$ee=n}),define(we[97],ve([1,0,31,28,27,96]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fe=L;function L(v,E){return v.lazy?new R.$ee(new M.$cd(v.owner,v.debugName,void 0),E,v.equalsFn??i.$8c):new n.$8d(new M.$cd(v.owner,v.debugName,void 0),E,v.equalsFn??i.$8c)}}),define(we[47],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var i;(function(n){function M(E,f){if(E.start>=f.end||f.start>=E.end)return{start:0,end:0};const $=Math.max(E.start,f.start),A=Math.min(E.end,f.end);return A-$<=0?{start:0,end:0}:{start:$,end:A}}n.intersect=M;function R(E){return E.end-E.start<=0}n.isEmpty=R;function L(E,f){return!R(M(E,f))}n.intersects=L;function v(E,f){const $=[],A={start:E.start,end:Math.min(f.start,E.end)},b={start:Math.max(f.end,E.start),end:E.end};return R(A)||$.push(A),R(b)||$.push(b),$}n.relativeComplement=v})(i||(t.Range=i={}))}),define(we[98],ve([1,0,47]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JU=void 0,t.$GU=n,t.$HU=M,t.$IU=R;function n(E,f){const $=[];for(const A of f){if(E.start>=A.range.end)continue;if(E.end<A.range.start)break;const b=i.Range.intersect(E,A.range);i.Range.isEmpty(b)||$.push({range:b,size:A.size})}return $}function M({start:E,end:f},$){return{start:E+$,end:f+$}}function R(E){const f=[];let $=null;for(const A of E){const b=A.range.start,m=A.range.end,e=A.size;if($&&e===$.size){$.range.end=m;continue}$={range:{start:b,end:m},size:e},f.push($)}return f}function L(...E){return R(E.reduce((f,$)=>f.concat($),[]))}class v{get paddingTop(){return this.c}set paddingTop(f){this.b=this.b+f-this.c,this.c=f}constructor(f){this.a=[],this.b=0,this.c=0,this.c=f??0,this.b=this.c}splice(f,$,A=[]){const b=A.length-$,m=n({start:0,end:f},this.a),e=n({start:f+$,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:M(o.range,b),size:o.size})),s=A.map((o,h)=>({range:{start:f+h,end:f+h+1},size:o.size}));this.a=L(m,s,e),this.b=this.c+this.a.reduce((o,h)=>o+h.size*(h.range.end-h.range.start),0)}get count(){const f=this.a.length;return f?this.a[f-1].range.end:0}get size(){return this.b}indexAt(f){if(f<0)return-1;if(f<this.c)return 0;let $=0,A=this.c;for(const b of this.a){const m=b.range.end-b.range.start,e=A+m*b.size;if(f<e)return $+Math.floor((f-A)/b.size);$+=m,A=e}return $}indexAfter(f){return Math.min(this.indexAt(f)+1,this.count)}positionAt(f){if(f<0)return-1;let $=0,A=0;for(const b of this.a){const m=b.range.end-b.range.start,e=A+m;if(f<e)return this.c+$+(f-A)*b.size;$+=m*b.size,A=e}return-1}}t.$JU=v}),define(we[99],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ge=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(R){return new n(R)}constructor(R){this.c=i&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ge=n}),define(we[3],ve([1,0,6,59,2,60,99]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$ie=t.Event=void 0,t.$je=m;const v=!1,E=!1,f=!1;var $;(function(X){X.None=()=>M.$Wc.None;function K(S){if(f){const{onDidAddListener:P}=S,x=s.create();let G=0;S.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),x.print()),P?.()}}}function Q(S,P){return te(S,()=>{},0,void 0,!0,void 0,P)}X.defer=Q;function he(S){return(P,x=null,G)=>{let ie=!1,le;return le=S(de=>{if(!ie)return le?le.dispose():ie=!0,P.call(x,de)},null,G),ie&&le.dispose(),le}}X.once=he;function be(S,P,x){return ae((G,ie=null,le)=>S(de=>G.call(ie,P(de)),null,le),x)}X.map=be;function Se(S,P,x){return ae((G,ie=null,le)=>S(de=>{P(de),G.call(ie,de)},null,le),x)}X.forEach=Se;function Fe(S,P,x){return ae((G,ie=null,le)=>S(de=>P(de)&&G.call(ie,de),null,le),x)}X.filter=Fe;function se(S){return S}X.signal=se;function ee(...S){return(P,x=null,G)=>{const ie=(0,M.$Tc)(...S.map(le=>le(de=>P.call(x,de))));return Ne(ie,G)}}X.any=ee;function ce(S,P,x,G){let ie=x;return be(S,le=>(ie=P(ie,le),ie),G)}X.reduce=ce;function ae(S,P){let x;const G={onWillAddFirstListener(){x=S(ie.fire,ie)},onDidRemoveLastListener(){x?.dispose()}};P||K(G);const ie=new d(G);return P?.add(ie),ie.event}function Ne(S,P){return P instanceof Array?P.push(S):P&&P.add(S),S}function te(S,P,x=100,G=!1,ie=!1,le,de){let Ee,De,Te,ke=0,fe;const Ie={leakWarningThreshold:le,onWillAddFirstListener(){Ee=S(Xe=>{ke++,De=P(De,Xe),G&&!Te&&(ze.fire(De),De=void 0),fe=()=>{const tt=De;De=void 0,Te=void 0,(!G||ke>1)&&ze.fire(tt),ke=0},typeof x=="number"?(clearTimeout(Te),Te=setTimeout(fe,x)):Te===void 0&&(Te=0,queueMicrotask(fe))})},onWillRemoveListener(){ie&&ke>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Ee.dispose()}};de||K(Ie);const ze=new d(Ie);return de?.add(ze),ze.event}X.debounce=te;function $e(S,P=0,x){return X.debounce(S,(G,ie)=>G?(G.push(ie),G):[ie],P,void 0,!0,void 0,x)}X.accumulate=$e;function ye(S,P=(G,ie)=>G===ie,x){let G=!0,ie;return Fe(S,le=>{const de=G||!P(le,ie);return G=!1,ie=le,de},x)}X.latch=ye;function Oe(S,P,x){return[X.filter(S,P,x),X.filter(S,G=>!P(G),x)]}X.split=Oe;function Re(S,P=!1,x=[],G){let ie=x.slice(),le=S(De=>{ie?ie.push(De):Ee.fire(De)});G&&G.add(le);const de=()=>{ie?.forEach(De=>Ee.fire(De)),ie=null},Ee=new d({onWillAddFirstListener(){le||(le=S(De=>Ee.fire(De)),G&&G.add(le))},onDidAddFirstListener(){ie&&(P?setTimeout(de):de())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return G&&G.add(Ee),Ee.event}X.buffer=Re;function Ce(S,P){return(G,ie,le)=>{const de=P(new V);return S(function(Ee){const De=de.evaluate(Ee);De!==re&&G.call(ie,De)},void 0,le)}}X.chain=Ce;const re=Symbol("HaltChainable");class V{constructor(){this.f=[]}map(P){return this.f.push(P),this}forEach(P){return this.f.push(x=>(P(x),x)),this}filter(P){return this.f.push(x=>P(x)?x:re),this}reduce(P,x){let G=x;return this.f.push(ie=>(G=P(G,ie),G)),this}latch(P=(x,G)=>x===G){let x=!0,G;return this.f.push(ie=>{const le=x||!P(ie,G);return x=!1,G=ie,le?ie:re}),this}evaluate(P){for(const x of this.f)if(P=x(P),P===re)break;return P}}function j(S,P,x=G=>G){const G=(...Ee)=>de.fire(x(...Ee)),ie=()=>S.on(P,G),le=()=>S.removeListener(P,G),de=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return de.event}X.fromNodeEventEmitter=j;function a(S,P,x=G=>G){const G=(...Ee)=>de.fire(x(...Ee)),ie=()=>S.addEventListener(P,G),le=()=>S.removeEventListener(P,G),de=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return de.event}X.fromDOMEventEmitter=a;function l(S){return new Promise(P=>he(S)(P))}X.toPromise=l;function g(S){const P=new d;return S.then(x=>{P.fire(x)},()=>{P.fire(void 0)}).finally(()=>{P.dispose()}),P.event}X.fromPromise=g;function I(S,P,x){return P(x),S(G=>P(G))}X.runAndSubscribe=I;class F{constructor(P,x){this._observable=P,this.f=0,this.g=!1;const G={onWillAddFirstListener:()=>{P.addObserver(this)},onDidRemoveLastListener:()=>{P.removeObserver(this)}};x||K(G),this.emitter=new d(G),x&&x.add(this.emitter)}beginUpdate(P){this.f++}handlePossibleChange(P){}handleChange(P,x){this.g=!0}endUpdate(P){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function u(S,P){return new F(S,P).emitter.event}X.fromObservable=u;function N(S){return(P,x,G)=>{let ie=0,le=!1;const de={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(S.reportChanges(),le&&(le=!1,P.call(x)))},handlePossibleChange(){},handleChange(){le=!0}};S.addObserver(de),S.reportChanges();const Ee={dispose(){S.removeObserver(de)}};return G instanceof M.$Vc?G.add(Ee):Array.isArray(G)&&G.push(Ee),Ee}}X.fromObservableLight=N})($||(t.Event=$={}));class A{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${A.f++}`,A.all.add(this)}start(K){this.g=new L.$ge,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}t.$ie=A;let b=-1;function m(X){const K=b;return b=X,{dispose(){b=K}}}class e{static{this.f=1}constructor(K,Q,he=(e.f++).toString(16).padStart(3,"0")){this.j=K,this.threshold=Q,this.name=he,this.h=0}dispose(){this.g?.clear()}check(K,Q){const he=this.threshold;if(he<=0||Q<he)return;this.g||(this.g=new Map);const be=this.g.get(K.value)||0;if(this.g.set(K.value,be+1),this.h-=1,this.h<=0){this.h=he*.5;const[Se,Fe]=this.getMostFrequentStack(),se=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${Fe}):`;console.warn(se),console.warn(Se);const ee=new o(se,Se);this.j(ee)}return()=>{const Se=this.g.get(K.value)||0;this.g.set(K.value,Se-1)}}getMostFrequentStack(){if(!this.g)return;let K,Q=0;for(const[he,be]of this.g)(!K||Q<be)&&(K=[he,be],Q=be);return K}}class s{static create(){const K=new Error;return new s(K.stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o extends Error{constructor(K,Q){super(K),this.name="ListenerLeakError",this.stack=Q}}t.$ke=o;class h extends Error{constructor(K,Q){super(K),this.name="ListenerRefusalError",this.stack=Q}}t.$le=h;let c=0;class p{constructor(K){this.value=K,this.id=c++}}const k=2,y=(X,K)=>{if(X instanceof p)K(X);else for(let Q=0;Q<X.length;Q++){const he=X[Q];he&&K(he)}};let r;if(v){const X=[];setInterval(()=>{X.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(X.join(`
`)),X.length=0)},3e3),r=new FinalizationRegistry(K=>{typeof K=="string"&&X.push(K)})}class d{constructor(K){this.z=0,this.f=K,this.g=b>0||this.f?.leakWarningThreshold?new e(K?.onListenerError??i.$3,this.f?.leakWarningThreshold??b):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(E){const K=this.u;queueMicrotask(()=>{y(K,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,Q,he)=>{if(this.g&&this.z>this.g.threshold**2){const ee=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(ee);const ce=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ae=new h(`${ee}. HINT: Stack shows most frequent listener (${ce[1]}-times)`,ce[0]);return(this.f?.onListenerError||i.$3)(ae),M.$Wc.None}if(this.m)return M.$Wc.None;Q&&(K=K.bind(Q));const be=new p(K);let Se,Fe;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(be.stack=s.create(),Se=this.g.check(be.stack,this.z+1)),E&&(be.stack=Fe??s.create()),this.u?this.u instanceof p?(this.w??=new T,this.u=[this.u,be]):this.u.push(be):(this.f?.onWillAddFirstListener?.(this),this.u=be,this.f?.onDidAddFirstListener?.(this)),this.z++;const se=(0,M.$Uc)(()=>{r?.unregister(se),Se?.(),this.A(be)});if(he instanceof M.$Vc?he.add(se):Array.isArray(he)&&he.push(se),r){const ee=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ce=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(ee);r.register(se,ce?.[2]??ee,se)}return se},this.q}A(K){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,he=Q.indexOf(K);if(he===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[he]=void 0;const be=this.w.current===this;if(this.z*k<=Q.length){let Se=0;for(let Fe=0;Fe<Q.length;Fe++)Q[Fe]?Q[Se++]=Q[Fe]:be&&(this.w.end--,Se<this.w.i&&this.w.i--);Q.length=Se}}B(K,Q){if(!K)return;const he=this.f?.onListenerError||i.$3;if(!he){K.value(Q);return}try{K.value(Q)}catch(be){he(be)}}C(K){const Q=K.current.u;for(;K.i<K.end;)this.B(Q[K.i++],K.value);K.reset()}fire(K){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof p)this.B(this.u,K);else{const Q=this.w;Q.enqueue(this,K,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}t.$me=d;const D=()=>new T;t.$ne=D;class T{constructor(){this.i=-1,this.end=0}enqueue(K,Q,he){this.i=0,this.end=he,this.current=K,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends d{async fireAsync(K,Q,he){if(this.u)for(this.h||(this.h=new R.$7c),y(this.u,be=>this.h.push([be.value,K]));this.h.size>0&&!Q.isCancellationRequested;){const[be,Se]=this.h.shift(),Fe=[],se={...Se,token:Q,waitUntil:ee=>{if(Object.isFrozen(Fe))throw new Error("waitUntil can NOT be called asynchronous");he&&(ee=he(ee,be)),Fe.push(ee)}};try{be(se)}catch(ee){(0,i.$3)(ee);continue}Object.freeze(Fe),await Promise.allSettled(Fe).then(ee=>{for(const ce of ee)ce.status==="rejected"&&(0,i.$3)(ce.reason)})}}}t.$oe=U;class _ extends d{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new R.$7c,this.t=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.t(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.z&&(this.h!==0?this.s.push(K):super.fire(K))}}t.$pe=_;class H extends _{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}t.$qe=H;class w extends d{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}t.$re=w;class C{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const Q={event:K,listener:null};this.h.push(Q),this.g&&this.m(Q);const he=()=>{this.g&&this.o(Q);const be=this.h.indexOf(Q);this.h.splice(be,1)};return(0,M.$Uc)((0,n.$fb)(he))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(Q=>this.f.fire(Q))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}t.$se=C;class W{constructor(K,Q,he,be){this.f=new M.$Vc;const Se=this.f.add(new C),Fe=this.f.add(new M.$6c);function se(ee){Fe.set(ee,Se.add(be(ee)))}for(const ee of K)se(ee);this.f.add(Q(ee=>{se(ee)})),this.f.add(he(ee=>{Fe.deleteAndDispose(ee)})),this.event=Se.event}dispose(){this.f.dispose()}}t.$te=W;class O{constructor(){this.f=[]}wrapEvent(K,Q,he){return(be,Se,Fe)=>K(se=>{const ee=this.f[this.f.length-1];if(!Q){ee?ee.buffers.push(()=>be.call(Se,se)):be.call(Se,se);return}const ce=ee;if(!ce){be.call(Se,Q(he,se));return}ce.items??=[],ce.items.push(se),ce.buffers.length===0&&ee.buffers.push(()=>{ce.reducedResult??=he?ce.items.reduce(Q,he):ce.items.reduce(Q),be.call(Se,ce.reducedResult)})},void 0,Fe)}bufferEvents(K){const Q={buffers:new Array};this.f.push(Q);const he=K();return this.f.pop(),Q.buffers.forEach(be=>be()),he}}t.$ue=O;class B{constructor(){this.f=!1,this.g=$.None,this.h=M.$Wc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ve=B;class z{static const(K){return new J(K)}constructor(K){this.g=K,this.f=new d,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}t.$we=z;class J{constructor(K){this.value=K,this.onDidChange=$.None}}}),define(we[19],ve([1,0,25,3]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bS=t.$aS=t.$_R=t.$$R=t.$0R=t.$9R=t.$8R=t.$7R=t.$2R=void 0,t.$YR=R,t.$ZR=L,t.$1R=v,t.$3R=E,t.$4R=f,t.$5R=$,t.$6R=A,t.$cS=e,t.$dS=s;class M{constructor(){this.a=new Map,this.b=new n.$me,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new n.$me,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new M}getZoomLevel(h){return this.a.get(this.f(h))??0}setZoomLevel(h,c){if(this.getZoomLevel(c)===h)return;const p=this.f(c);this.a.set(p,h),this.b.fire(p)}getZoomFactor(h){return this.c.get(this.f(h))??1}setZoomFactor(h,c){this.c.set(this.f(c),h)}setFullscreen(h,c){if(this.isFullscreen(c)===h)return;const p=this.f(c);this.e.set(p,h),this.d.fire(p)}isFullscreen(h){return!!this.e.get(this.f(h))}f(h){return h.vscodeWindowId}}function R(o,h,c){typeof h=="string"&&(h=o.matchMedia(h)),h.addEventListener("change",c)}function L(o,h){M.INSTANCE.setZoomLevel(o,h)}function v(o){return M.INSTANCE.getZoomLevel(o)}t.$2R=M.INSTANCE.onDidChangeZoomLevel;function E(o){return M.INSTANCE.getZoomFactor(o)}function f(o,h){M.INSTANCE.setZoomFactor(o,h)}function $(o,h){M.INSTANCE.setFullscreen(o,h)}function A(o){return M.INSTANCE.isFullscreen(o)}t.$7R=M.INSTANCE.onDidChangeFullscreen;const b=navigator.userAgent;t.$8R=b.indexOf("Firefox")>=0,t.$9R=b.indexOf("AppleWebKit")>=0,t.$0R=b.indexOf("Chrome")>=0,t.$$R=!t.$0R&&b.indexOf("Safari")>=0,t.$_R=!t.$0R&&!t.$$R&&t.$9R,t.$aS=b.indexOf("Electron/")>=0,t.$bS=b.indexOf("Android")>=0;let m=!1;if(typeof i.$VR.matchMedia=="function"){const o=i.$VR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),h=i.$VR.matchMedia("(display-mode: fullscreen)");m=o.matches,R(i.$VR,o,({matches:c})=>{m&&h.matches||(m=c)})}function e(){return m}function s(){return navigator?.windowControlsOverlay?.visible}}),define(we[29],ve([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BU=void 0;class n{get event(){return this.a.event}constructor(R,L,v){const E=f=>this.a.fire(f);this.a=new i.$me({onWillAddFirstListener:()=>R.addEventListener(L,E,v),onDidRemoveLastListener:()=>R.removeEventListener(L,E,v)})}dispose(){this.a.dispose()}}t.$BU=n}),define(we[39],ve([1,0,3]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xe=t.CancellationToken=void 0,t.$ye=v;const n=Object.freeze(function(E,f){const $=setTimeout(E.bind(f),0);return{dispose(){clearTimeout($)}}});var M;(function(E){function f($){return $===E.None||$===E.Cancelled||$ instanceof R?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}E.isCancellationToken=f,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(M||(t.CancellationToken=M={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new i.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=M.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=M.None}}t.$xe=L;function v(E){const f=new L;return E.add({dispose(){f.cancel()}}),f.token}}),define(we[100],ve([1,0,39]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$af=t.$_e=t.$0e=void 0,t.$$e=M;class n{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new i.$xe,f=this.b(E.token);return this.a={promise:f,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}t.$0e=n;function M(v){return v}class R{constructor(E,f){this.a=void 0,this.b=void 0,typeof E=="function"?(this.c=E,this.d=M):(this.c=f,this.d=E.getCacheKey)}get(E){const f=this.d(E);return this.b!==f&&(this.b=f,this.a=this.c(E)),this.a}}t.$_e=R;class L{get cachedValues(){return this.a}constructor(E,f){this.a=new Map,this.b=new Map,typeof E=="function"?(this.c=E,this.d=M):(this.c=f,this.d=E.getCacheKey)}get(E){const f=this.d(E);if(this.b.has(f))return this.b.get(f);const $=this.c(E);return this.a.set(E,$),this.b.set(f,$),$}}t.$af=L}),define(we[101],ve([1,0,45,28,46,39,27,31,6]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=t.$ae=t.$_d=t.$$d=void 0,t.$ce=m,t.$de=e;class f{get cachedValue(){return this.a}constructor(o){this.b=o,this.a=(0,n.$7d)(this,void 0)}getValue(){let o=this.a.get();return o||(o=this.b(),this.a.set(o,void 0)),o}}t.$$d=f;class ${constructor(o){this.a=(0,n.$7d)(this,void 0),this.promiseResult=this.a,this.promise=o.then(h=>((0,n.$2d)(c=>{this.a.set(new A(h,void 0),c)}),h),h=>{throw(0,n.$2d)(c=>{this.a.set(new A(void 0,h),c)}),h})}}t.$_d=$;class A{constructor(o,h){this.data=o,this.error=h}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$ae=A;class b{constructor(o){this.b=o,this.a=new f(()=>new $(this.b())),this.cachedPromiseResult=(0,M.$Od)(this,h=>this.a.cachedValue.read(h)?.promiseResult.read(h))}getPromise(){return this.a.getValue().promise}}t.$be=b;function m(s,o,h,c){return o||(o=p=>p!=null),new Promise((p,k)=>{let y=!0,r=!1;const d=s.map(T=>({isFinished:o(T),error:h?h(T):!1,state:T})),D=(0,i.$ld)(T=>{const{isFinished:U,error:_,state:H}=d.read(T);(U||_)&&(y?r=!0:D.dispose(),_?k(_===!0?H:_):p(H))});if(c){const T=c.onCancellationRequested(()=>{D.dispose(),T.dispose(),k(new E.$7)});if(c.isCancellationRequested){D.dispose(),T.dispose(),k(new E.$7);return}}y=!1,r&&D.dispose()})}function e(s,o){let h,c;o===void 0?(h=s,c=void 0):(c=s,h=o);let p;return new M.$Ud(new L.$cd(c,void 0,h),k=>(p&&p.dispose(!0),p=new R.$xe,h(k,p.token)),void 0,void 0,()=>p?.dispose(),v.$8c)}}),define(we[102],ve([1,0,3,2,45,28,27,46,32,6,31]),function(ne,t,i,n,M,R,L,v,E,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Id=t.$Ed=t.$wd=void 0,t.$sd=A,t.$td=m,t.$ud=e,t.$vd=s,t.$xd=h,t.$yd=p,t.$zd=y,t.$Ad=r,t.$Bd=d,t.$Cd=D,t.$Dd=T,t.$Fd=_,t.$Gd=H,t.$Hd=w,t.$Jd=O,t.$Kd=B;function A(z){return new b(z)}class b extends R.$Zd{constructor(J){super(),this.b=J}get debugName(){return this.toString()}get(){return this.b}addObserver(J){}removeObserver(J){}toString(){return`Const: ${this.b}`}}function m(z){const J=(0,R.$7d)("promiseValue",{});return z.then(X=>{J.set({value:X},void 0)}),J}function e(...z){let J,X,K;return z.length===3?[J,X,K]=z:[X,K]=z,new o(new L.$cd(J,void 0,K),X,K,()=>o.globalTransaction,$.$8c)}function s(z,J,X){return new o(new L.$cd(z.owner,z.debugName,z.debugReferenceFn??X),J,X,()=>o.globalTransaction,z.equalsFn??$.$8c)}class o extends R.$1d{constructor(J,X,K,Q,he){super(),this.j=J,this.k=X,this._getValue=K,this.l=Q,this.n=he,this.g=!1,this.r=be=>{const Se=this._getValue(be),Fe=this.e,se=!this.g||!this.n(Fe,Se);let ee=!1;se&&(this.e=Se,this.g&&(ee=!0,(0,R.$5d)(this.l(),ce=>{(0,E.$Md)()?.handleFromEventObservableTriggered(this,{oldValue:Fe,newValue:Se,change:void 0,didChange:se,hadValue:this.g});for(const ae of this.b)ce.updateObserver(ae,this),ae.handleChange(this,void 0)},()=>{const ce=this.p();return"Event fired"+(ce?`: ${ce}`:"")})),this.g=!0),ee||(0,E.$Md)()?.handleFromEventObservableTriggered(this,{oldValue:Fe,newValue:Se,change:void 0,didChange:se,hadValue:this.g})}}p(){return this.j.getDebugName(this)}get debugName(){const J=this.p();return"From Event"+(J?`: ${J}`:"")}c(){this.h=this.k(this.r)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.r(void 0),this.e):this._getValue(void 0)}}t.$wd=o,function(z){z.Observer=o;function J(X,K){let Q=!1;o.globalTransaction===void 0&&(o.globalTransaction=X,Q=!0);try{K()}finally{Q&&(o.globalTransaction=void 0)}}z.batchEventsGlobally=J}(e||(t.$ud=e={}));function h(z,J){return new c(z,J)}class c extends R.$1d{constructor(J,X){super(),this.debugName=J,this.g=X,this.j=()=>{(0,R.$2d)(K=>{for(const Q of this.b)K.updateObserver(Q,this),Q.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function p(z){return typeof z=="string"?new k(z):new k(void 0,z)}class k extends R.$1d{get debugName(){return new L.$cd(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}toString(){return this.debugName}constructor(J,X){super(),this.e=J,this.g=X}trigger(J,X){if(!J){(0,R.$2d)(K=>{this.trigger(K,X)},()=>`Trigger signal ${this.debugName}`);return}for(const K of this.b)J.updateObserver(K,this),K.handleChange(this,X)}get(){}}function y(z,J,X){const K=(0,R.$7d)("debounced",void 0);let Q;return X.add((0,M.$ld)(he=>{const be=z.read(he);Q&&clearTimeout(Q),Q=setTimeout(()=>{(0,R.$2d)(Se=>{K.set(be,Se)})},J)})),K}function r(z,J){let X=!1,K,Q;return e(he=>{const be=(0,M.$ld)(Se=>{const Fe=z.read(Se);X?(Q&&clearTimeout(Q),Q=setTimeout(()=>{K=Fe,he()},J)):(X=!0,K=Fe)});return{dispose(){be.dispose(),X=!1,K=void 0}}},()=>X?K:z.get())}function d(z,J,X){const K=(0,R.$7d)("triggeredRecently",!1);let Q;return X.add(z(()=>{K.set(!0,void 0),Q&&clearTimeout(Q),Q=setTimeout(()=>{K.set(!1,void 0)},J)})),K}function D(z){const J=new U(!1,void 0);return z.addObserver(J),(0,n.$Uc)(()=>{z.removeObserver(J)})}(0,R.$Xd)(D);function T(z,J){const X=new U(!0,J);return z.addObserver(X),J?J(z.get()):z.reportChanges(),(0,n.$Uc)(()=>{z.removeObserver(X)})}(0,R.$Wd)(T);class U{constructor(J,X){this.b=J,this.c=X,this.a=0}beginUpdate(J){this.a++}endUpdate(J){this.a--,this.a===0&&this.b&&(this.c?this.c(J.get()):J.reportChanges())}handlePossibleChange(J){}handleChange(J,X){}}t.$Ed=U;function _(z,J){let X;return(0,v.$Qd)({owner:z,debugReferenceFn:J},Q=>(X=J(Q,X),X))}function H(z,J){let X;const K=p("derivedObservableWithWritableCache"),Q=(0,v.$Od)(z,he=>(K.read(he),X=J(he,X),X));return Object.assign(Q,{clearCache:he=>{X=void 0,K.trigger(he)},setCache:(he,be)=>{X=he,K.trigger(be)}})}function w(z,J,X,K){let Q=new C(X,K);return(0,v.$Qd)({debugReferenceFn:X,owner:z,onLastObserverRemoved:()=>{Q.dispose(),Q=new C(X)}},be=>(Q.setItems(J.read(be)),Q.getItems()))}class C{constructor(J,X){this.c=J,this.e=X,this.a=new Map,this.b=[]}dispose(){this.a.forEach(J=>J.store.dispose()),this.a.clear()}setItems(J){const X=[],K=new Set(this.a.keys());for(const Q of J){const he=this.e?this.e(Q):Q;let be=this.a.get(he);if(be)K.delete(he);else{const Se=new n.$Vc;be={out:this.c(Q,Se),store:Se},this.a.set(he,be)}X.push(be.out)}for(const Q of K)this.a.get(Q).store.dispose(),this.a.delete(Q);this.b=X}getItems(){return this.b}}class W{constructor(J){this.observable=J}get onDidChange(){return i.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Id=W;function O(z,J){return J instanceof W?J.observable:e(z,J.onDidChange,()=>J.value)}function B(z,J){if(J.length===0)throw new f.$eb;let X=!1,K;const Q=e(z,he=>{const be=new n.$Vc;for(const Se of J)be.add((0,M.$md)({debugName:()=>(0,L.$dd)(Q,new L.$cd(z,void 0,void 0))+".updateLastChangedValue"},Fe=>{X=!0,K=Se.read(Fe),he()}));return be.add({dispose(){X=!1,K=void 0}}),be},()=>X?K:J[J.length-1].get());return Q}}),define(we[62],ve([1,0,28,46,45,102,101,97,32]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.observableValueOpts=t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return i.$7d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return i.$9d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return i.$2d}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return i.$5d}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return n.$Od}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return n.$Qd}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return n.$Rd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return n.$Sd}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return M.$ld}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return M.$qd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return M.$nd}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return M.$pd}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return M.$md}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return M.$od}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return R.$sd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return R.$zd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return R.$Fd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return R.$Gd}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return R.$Cd}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return R.$Dd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return R.$ud}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return R.$td}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return R.$yd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return R.$xd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return R.$Bd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return L.$$d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return L.$be}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return L.$_d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return L.$ae}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return L.$ce}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return L.$de}}),Object.defineProperty(t,"observableValueOpts",{enumerable:!0,get:function(){return v.$fe}}),!1&&(0,E.$Ld)(new E.$Nd)}),define(we[20],ve([1,0,3,2]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=t.$_s=t.$$s=t.$0s=t.ScrollbarVisibility=void 0;var M;(function(m){m[m.Auto=1]="Auto",m[m.Hidden=2]="Hidden",m[m.Visible=3]="Visible"})(M||(t.ScrollbarVisibility=M={}));class R{constructor(e,s,o,h,c,p,k){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,o=o|0,h=h|0,c=c|0,p=p|0,k=k|0),this.rawScrollLeft=h,this.rawScrollTop=k,s<0&&(s=0),h+s>o&&(h=o-s),h<0&&(h=0),c<0&&(c=0),k+c>p&&(k=p-c),k<0&&(k=0),this.width=s,this.scrollWidth=o,this.scrollLeft=h,this.height=c,this.scrollHeight=p,this.scrollTop=k}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new R(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new R(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const o=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,c=this.scrollLeft!==e.scrollLeft,p=this.height!==e.height,k=this.scrollHeight!==e.scrollHeight,y=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:h,scrollLeftChanged:c,heightChanged:p,scrollHeightChanged:k,scrollTopChanged:y}}}t.$0s=R;class L extends n.$Wc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$me),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new R(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const o=this.g.withScrollDimensions(e,s);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let h;s?h=new $(this.h.from,o,this.h.startTime,this.h.duration):h=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=h}else{const o=this.g.withScrollPosition(e);this.h=$.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,s)))}}t.$$s=L;class v{constructor(e,s,o){this.scrollLeft=e,this.scrollTop=s,this.isDone=o}}t.$_s=v;function E(m,e){const s=e-m;return function(o){return m+s*b(o)}}function f(m,e,s){return function(o){return o<s?m(o/s):e((o-s)/(1-s))}}class ${constructor(e,s,o,h){this.from=e,this.to=s,this.duration=h,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,o){if(Math.abs(e-s)>2.5*o){let c,p;return e<s?(c=e+.75*o,p=s-.75*o):(c=e-.75*o,p=s+.75*o),f(E(e,c),E(p,s),.33)}return E(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const o=this.c(s),h=this.d(s);return new v(o,h,!1)}return new v(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,o){return $.start(e,s,o)}static start(e,s,o){o=o+10;const h=Date.now()-10;return new $(e,s,h,o)}}t.$at=$;function A(m){return Math.pow(m,3)}function b(m){return 1-A(1-m)}}),define(we[103],ve([1,0,6,2]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=M,t.$Ae=R,t.$Be=L,t.$Ce=v,t.$De=f,t.$Ee=$,t.$Fe=A,t.$Ge=b,t.$He=m,t.$Ie=e,t.$Je=s,t.$Ke=o,t.$Le=h,t.$Me=c,t.$Ne=p;function M(k){const y=k;return y?typeof y.read=="function":!1}function R(k){const y=k;return y?[y.on,y.pause,y.resume,y.destroy].every(r=>typeof r=="function"):!1}function L(k){const y=k;return y?R(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}function v(k,y){return new E(k,y)}class E{constructor(y,r){this.e=y,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(r=>r(y))}h(y){this.c.error.length===0?(0,i.$3)(y):this.c.error.slice(0).forEach(r=>r(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,r){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(y,r){if(this.a.destroyed)return;let d;switch(y){case"data":d=this.c.data;break;case"end":d=this.c.end;break;case"error":d=this.c.error;break}if(d){const D=d.indexOf(r);D>=0&&d.splice(D,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(d=>d())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(k,y){const r=[];let d;for(;(d=k.read())!==null;)r.push(d);return y(r)}function $(k,y,r){const d=[];let D;for(;(D=k.read())!==null&&d.length<r;)d.push(D);return D===null&&d.length>0?y(d):{read:()=>{if(d.length>0)return d.shift();if(typeof D<"u"){const T=D;return D=void 0,T}return k.read()}}}function A(k,y){return new Promise((r,d)=>{const D=[];b(k,{onData:T=>{y&&D.push(T)},onError:T=>{y?d(T):r(void 0)},onEnd:()=>{r(y?y(D):void 0)}})})}function b(k,y,r){k.on("error",d=>{r?.isCancellationRequested||y.onError(d)}),k.on("end",()=>{r?.isCancellationRequested||y.onEnd()}),k.on("data",d=>{r?.isCancellationRequested||y.onData(d)})}function m(k,y){return new Promise((r,d)=>{const D=new n.$Vc,T=[],U=w=>{if(T.push(w),T.length>y)return D.dispose(),k.pause(),r({stream:k,buffer:T,ended:!1})},_=w=>(D.dispose(),d(w)),H=()=>(D.dispose(),r({stream:k,buffer:T,ended:!0}));D.add((0,n.$Uc)(()=>k.removeListener("error",_))),k.on("error",_),D.add((0,n.$Uc)(()=>k.removeListener("end",H))),k.on("end",H),D.add((0,n.$Uc)(()=>k.removeListener("data",U))),k.on("data",U)})}function e(k,y){const r=v(y);return r.end(k),r}function s(){const k=v(()=>{throw new Error("not supported")});return k.end(),k}function o(k){let y=!1;return{read:()=>y?null:(y=!0,k)}}function h(k,y,r){const d=v(r);return b(k,{onData:D=>d.write(y.data(D)),onError:D=>d.error(y.error?y.error(D):D),onEnd:()=>d.end()}),d}function c(k,y,r){let d=!1;return{read:()=>{const D=y.read();return d?D:(d=!0,D!==null?r([k,D]):k)}}}function p(k,y,r){let d=!1;const D=v(r);return b(y,{onData:T=>d?D.write(T):(d=!0,D.write(r([k,T]))),onError:T=>D.error(T),onEnd:()=>{d||(d=!0,D.write(k)),D.end()}}),D}}),define(we[48],ve([1,0,26,103]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Oe=void 0,t.$Pe=f,t.$Qe=$,t.$Re=A,t.$Se=b,t.$Te=m,t.$Ue=e,t.$Ve=s,t.$We=o,t.$Xe=h,t.$Ye=c,t.$Ze=p,t.$1e=k,t.$2e=y,t.$3e=r,t.$4e=d,t.$5e=D,t.$6e=T,t.$7e=U,t.$8e=_,t.$9e=C,n=We(n);const M=typeof Buffer<"u",R=new i.$X(()=>new Uint8Array(256));let L,v;class E{static alloc(O){return M?new E(Buffer.allocUnsafe(O)):new E(new Uint8Array(O))}static wrap(O){return M&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new E(O)}static fromString(O,B){return!(B?.dontUseNodeBuffer||!1)&&M?new E(Buffer.from(O)):(L||(L=new TextEncoder),new E(L.encode(O)))}static fromByteArray(O){const B=E.alloc(O.length);for(let z=0,J=O.length;z<J;z++)B.buffer[z]=O[z];return B}static concat(O,B){if(typeof B>"u"){B=0;for(let X=0,K=O.length;X<K;X++)B+=O[X].byteLength}const z=E.alloc(B);let J=0;for(let X=0,K=O.length;X<K;X++){const Q=O[X];z.set(Q,J),J+=Q.byteLength}return z}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=E.alloc(this.byteLength);return O.set(this),O}toString(){return M?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(O,B){return new E(this.buffer.subarray(O,B))}set(O,B){if(O instanceof E)this.buffer.set(O.buffer,B);else if(O instanceof Uint8Array)this.buffer.set(O,B);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),B);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return b(this.buffer,O)}writeUInt32BE(O,B){m(this.buffer,O,B)}readUInt32LE(O){return e(this.buffer,O)}writeUInt32LE(O,B){s(this.buffer,O,B)}readUInt8(O){return o(this.buffer,O)}writeUInt8(O,B){h(this.buffer,O,B)}indexOf(O,B=0){return f(this.buffer,O instanceof E?O.buffer:O,B)}}t.$Oe=E;function f(W,O,B=0){const z=O.byteLength,J=W.byteLength;if(z===0)return 0;if(z===1)return W.indexOf(O[0]);if(z>J-B)return-1;const X=R.value;X.fill(O.length);for(let be=0;be<O.length;be++)X[O[be]]=O.length-be-1;let K=B+O.length-1,Q=K,he=-1;for(;K<J;)if(W[K]===O[Q]){if(Q===0){he=K;break}K--,Q--}else K+=Math.max(O.length-Q,X[W[K]]),Q=O.length-1;return he}function $(W,O){return W[O+0]<<0>>>0|W[O+1]<<8>>>0}function A(W,O,B){W[B+0]=O&255,O=O>>>8,W[B+1]=O&255}function b(W,O){return W[O]*2**24+W[O+1]*2**16+W[O+2]*2**8+W[O+3]}function m(W,O,B){W[B+3]=O,O=O>>>8,W[B+2]=O,O=O>>>8,W[B+1]=O,O=O>>>8,W[B]=O}function e(W,O){return W[O+0]<<0>>>0|W[O+1]<<8>>>0|W[O+2]<<16>>>0|W[O+3]<<24>>>0}function s(W,O,B){W[B+0]=O&255,O=O>>>8,W[B+1]=O&255,O=O>>>8,W[B+2]=O&255,O=O>>>8,W[B+3]=O&255}function o(W,O){return W[O]}function h(W,O,B){W[B]=O}function c(W){return n.$De(W,O=>E.concat(O))}function p(W){return n.$Ke(W)}function k(W){return n.$Fe(W,O=>E.concat(O))}async function y(W){return W.ended?E.concat(W.buffer):E.concat([...W.buffer,await k(W.stream)])}function r(W){return n.$Ie(W,O=>E.concat(O))}function d(W){return n.$Le(W,{data:O=>typeof O=="string"?E.fromString(O):E.wrap(O)},O=>E.concat(O))}function D(W){return n.$Ce(O=>E.concat(O),W)}function T(W,O){return n.$Me(W,O,B=>E.concat(B))}function U(W,O){return n.$Ne(W,O,B=>E.concat(B))}function _(W){let O=0,B=0,z=0;const J=new Uint8Array(Math.floor(W.length/4*3)),X=Q=>{switch(B){case 3:J[z++]=O|Q,B=0;break;case 2:J[z++]=O|Q>>>2,O=Q<<6,B=3;break;case 1:J[z++]=O|Q>>>4,O=Q<<4,B=2;break;default:O=Q<<2,B=1}};for(let Q=0;Q<W.length;Q++){const he=W.charCodeAt(Q);if(he>=65&&he<=90)X(he-65);else if(he>=97&&he<=122)X(he-97+26);else if(he>=48&&he<=57)X(he-48+52);else if(he===43||he===45)X(62);else if(he===47||he===95)X(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${W[Q]}`)}}const K=z;for(;B>0;)X(0);return E.wrap(J).slice(0,K)}const H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:W},O=!0,B=!1){const z=B?w:H;let J="";const X=W.byteLength%3;let K=0;for(;K<W.byteLength-X;K+=3){const Q=W[K+0],he=W[K+1],be=W[K+2];J+=z[Q>>>2],J+=z[(Q<<4|he>>>4)&63],J+=z[(he<<2|be>>>6)&63],J+=z[be&63]}if(X===1){const Q=W[K+0];J+=z[Q>>>2],J+=z[Q<<4&63],O&&(J+="==")}else if(X===2){const Q=W[K+0],he=W[K+1];J+=z[Q>>>2],J+=z[(Q<<4|he>>>4)&63],J+=z[he<<2&63],O&&(J+="=")}return J}}),define(we[63],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$he=void 0,t.$he=Symbol("MicrotaskDelay")}),define(we[10],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fg=i,t.$gg=n,t.$hg=M,t.$ig=R,t.$jg=L,t.$kg=v,t.$lg=E,t.$mg=f,t.$ng=$,t.$og=A,t.$pg=b,t.$qg=m,t.$rg=e,t.$sg=o,t.$tg=h,t.$ug=c,t.$vg=p,t.$wg=k;function i(y){return typeof y=="string"}function n(y){return Array.isArray(y)&&y.every(r=>i(r))}function M(y){return typeof y=="object"&&y!==null&&!Array.isArray(y)&&!(y instanceof RegExp)&&!(y instanceof Date)}function R(y){const r=Object.getPrototypeOf(Uint8Array);return typeof y=="object"&&y instanceof r}function L(y){return typeof y=="number"&&!isNaN(y)}function v(y){return!!y&&typeof y[Symbol.iterator]=="function"}function E(y){return y===!0||y===!1}function f(y){return typeof y>"u"}function $(y){return!A(y)}function A(y){return f(y)||y===null}function b(y,r){if(!y)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function m(y){if(A(y))throw new Error("Assertion Failed: argument is undefined or null");return y}function e(...y){const r=[];for(let d=0;d<y.length;d++){const D=y[d];if(A(D))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);r.push(D)}return r}const s=Object.prototype.hasOwnProperty;function o(y){if(!M(y))return!1;for(const r in y)if(s.call(y,r))return!1;return!0}function h(y){return typeof y=="function"}function c(...y){return y.length>0&&y.every(h)}function p(y,r){const d=Math.min(y.length,r.length);for(let D=0;D<d;D++)k(y[D],r[D])}function k(y,r){if(i(r)){if(typeof y!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(y instanceof r)return}catch{}if(!A(y)&&y.constructor===r||r.length===1&&r.call(void 0,y)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(we[49],ve([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zj=M,t.$1j=R;const n=Object.create(null);function M(L,v){if((0,i.$fg)(v)){const E=n[v];if(E===void 0)throw new Error(`${L} references an unknown codicon: ${v}`);v=E}return n[L]=v,{id:L}}function R(){return n}}),define(we[104],ve([1,0,49]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2j=void 0,t.$2j={add:(0,i.$Zj)("add",6e4),plus:(0,i.$Zj)("plus",6e4),gistNew:(0,i.$Zj)("gist-new",6e4),repoCreate:(0,i.$Zj)("repo-create",6e4),lightbulb:(0,i.$Zj)("lightbulb",60001),lightBulb:(0,i.$Zj)("light-bulb",60001),repo:(0,i.$Zj)("repo",60002),repoDelete:(0,i.$Zj)("repo-delete",60002),gistFork:(0,i.$Zj)("gist-fork",60003),repoForked:(0,i.$Zj)("repo-forked",60003),gitPullRequest:(0,i.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,i.$Zj)("record-keys",60005),keyboard:(0,i.$Zj)("keyboard",60005),tag:(0,i.$Zj)("tag",60006),gitPullRequestLabel:(0,i.$Zj)("git-pull-request-label",60006),tagAdd:(0,i.$Zj)("tag-add",60006),tagRemove:(0,i.$Zj)("tag-remove",60006),person:(0,i.$Zj)("person",60007),personFollow:(0,i.$Zj)("person-follow",60007),personOutline:(0,i.$Zj)("person-outline",60007),personFilled:(0,i.$Zj)("person-filled",60007),gitBranch:(0,i.$Zj)("git-branch",60008),gitBranchCreate:(0,i.$Zj)("git-branch-create",60008),gitBranchDelete:(0,i.$Zj)("git-branch-delete",60008),sourceControl:(0,i.$Zj)("source-control",60008),mirror:(0,i.$Zj)("mirror",60009),mirrorPublic:(0,i.$Zj)("mirror-public",60009),star:(0,i.$Zj)("star",60010),starAdd:(0,i.$Zj)("star-add",60010),starDelete:(0,i.$Zj)("star-delete",60010),starEmpty:(0,i.$Zj)("star-empty",60010),comment:(0,i.$Zj)("comment",60011),commentAdd:(0,i.$Zj)("comment-add",60011),alert:(0,i.$Zj)("alert",60012),warning:(0,i.$Zj)("warning",60012),search:(0,i.$Zj)("search",60013),searchSave:(0,i.$Zj)("search-save",60013),logOut:(0,i.$Zj)("log-out",60014),signOut:(0,i.$Zj)("sign-out",60014),logIn:(0,i.$Zj)("log-in",60015),signIn:(0,i.$Zj)("sign-in",60015),eye:(0,i.$Zj)("eye",60016),eyeUnwatch:(0,i.$Zj)("eye-unwatch",60016),eyeWatch:(0,i.$Zj)("eye-watch",60016),circleFilled:(0,i.$Zj)("circle-filled",60017),primitiveDot:(0,i.$Zj)("primitive-dot",60017),closeDirty:(0,i.$Zj)("close-dirty",60017),debugBreakpoint:(0,i.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,i.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,i.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,i.$Zj)("primitive-square",60018),edit:(0,i.$Zj)("edit",60019),pencil:(0,i.$Zj)("pencil",60019),info:(0,i.$Zj)("info",60020),issueOpened:(0,i.$Zj)("issue-opened",60020),gistPrivate:(0,i.$Zj)("gist-private",60021),gitForkPrivate:(0,i.$Zj)("git-fork-private",60021),lock:(0,i.$Zj)("lock",60021),mirrorPrivate:(0,i.$Zj)("mirror-private",60021),close:(0,i.$Zj)("close",60022),removeClose:(0,i.$Zj)("remove-close",60022),x:(0,i.$Zj)("x",60022),repoSync:(0,i.$Zj)("repo-sync",60023),sync:(0,i.$Zj)("sync",60023),clone:(0,i.$Zj)("clone",60024),desktopDownload:(0,i.$Zj)("desktop-download",60024),beaker:(0,i.$Zj)("beaker",60025),microscope:(0,i.$Zj)("microscope",60025),vm:(0,i.$Zj)("vm",60026),deviceDesktop:(0,i.$Zj)("device-desktop",60026),file:(0,i.$Zj)("file",60027),fileText:(0,i.$Zj)("file-text",60027),more:(0,i.$Zj)("more",60028),ellipsis:(0,i.$Zj)("ellipsis",60028),kebabHorizontal:(0,i.$Zj)("kebab-horizontal",60028),mailReply:(0,i.$Zj)("mail-reply",60029),reply:(0,i.$Zj)("reply",60029),organization:(0,i.$Zj)("organization",60030),organizationFilled:(0,i.$Zj)("organization-filled",60030),organizationOutline:(0,i.$Zj)("organization-outline",60030),newFile:(0,i.$Zj)("new-file",60031),fileAdd:(0,i.$Zj)("file-add",60031),newFolder:(0,i.$Zj)("new-folder",60032),fileDirectoryCreate:(0,i.$Zj)("file-directory-create",60032),trash:(0,i.$Zj)("trash",60033),trashcan:(0,i.$Zj)("trashcan",60033),history:(0,i.$Zj)("history",60034),clock:(0,i.$Zj)("clock",60034),folder:(0,i.$Zj)("folder",60035),fileDirectory:(0,i.$Zj)("file-directory",60035),symbolFolder:(0,i.$Zj)("symbol-folder",60035),logoGithub:(0,i.$Zj)("logo-github",60036),markGithub:(0,i.$Zj)("mark-github",60036),github:(0,i.$Zj)("github",60036),terminal:(0,i.$Zj)("terminal",60037),console:(0,i.$Zj)("console",60037),repl:(0,i.$Zj)("repl",60037),zap:(0,i.$Zj)("zap",60038),symbolEvent:(0,i.$Zj)("symbol-event",60038),error:(0,i.$Zj)("error",60039),stop:(0,i.$Zj)("stop",60039),variable:(0,i.$Zj)("variable",60040),symbolVariable:(0,i.$Zj)("symbol-variable",60040),array:(0,i.$Zj)("array",60042),symbolArray:(0,i.$Zj)("symbol-array",60042),symbolModule:(0,i.$Zj)("symbol-module",60043),symbolPackage:(0,i.$Zj)("symbol-package",60043),symbolNamespace:(0,i.$Zj)("symbol-namespace",60043),symbolObject:(0,i.$Zj)("symbol-object",60043),symbolMethod:(0,i.$Zj)("symbol-method",60044),symbolFunction:(0,i.$Zj)("symbol-function",60044),symbolConstructor:(0,i.$Zj)("symbol-constructor",60044),symbolBoolean:(0,i.$Zj)("symbol-boolean",60047),symbolNull:(0,i.$Zj)("symbol-null",60047),symbolNumeric:(0,i.$Zj)("symbol-numeric",60048),symbolNumber:(0,i.$Zj)("symbol-number",60048),symbolStructure:(0,i.$Zj)("symbol-structure",60049),symbolStruct:(0,i.$Zj)("symbol-struct",60049),symbolParameter:(0,i.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,i.$Zj)("symbol-type-parameter",60050),symbolKey:(0,i.$Zj)("symbol-key",60051),symbolText:(0,i.$Zj)("symbol-text",60051),symbolReference:(0,i.$Zj)("symbol-reference",60052),goToFile:(0,i.$Zj)("go-to-file",60052),symbolEnum:(0,i.$Zj)("symbol-enum",60053),symbolValue:(0,i.$Zj)("symbol-value",60053),symbolRuler:(0,i.$Zj)("symbol-ruler",60054),symbolUnit:(0,i.$Zj)("symbol-unit",60054),activateBreakpoints:(0,i.$Zj)("activate-breakpoints",60055),archive:(0,i.$Zj)("archive",60056),arrowBoth:(0,i.$Zj)("arrow-both",60057),arrowDown:(0,i.$Zj)("arrow-down",60058),arrowLeft:(0,i.$Zj)("arrow-left",60059),arrowRight:(0,i.$Zj)("arrow-right",60060),arrowSmallDown:(0,i.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,i.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,i.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,i.$Zj)("arrow-small-up",60064),arrowUp:(0,i.$Zj)("arrow-up",60065),bell:(0,i.$Zj)("bell",60066),bold:(0,i.$Zj)("bold",60067),book:(0,i.$Zj)("book",60068),bookmark:(0,i.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$Zj)("briefcase",60076),broadcast:(0,i.$Zj)("broadcast",60077),browser:(0,i.$Zj)("browser",60078),bug:(0,i.$Zj)("bug",60079),calendar:(0,i.$Zj)("calendar",60080),caseSensitive:(0,i.$Zj)("case-sensitive",60081),check:(0,i.$Zj)("check",60082),checklist:(0,i.$Zj)("checklist",60083),chevronDown:(0,i.$Zj)("chevron-down",60084),chevronLeft:(0,i.$Zj)("chevron-left",60085),chevronRight:(0,i.$Zj)("chevron-right",60086),chevronUp:(0,i.$Zj)("chevron-up",60087),chromeClose:(0,i.$Zj)("chrome-close",60088),chromeMaximize:(0,i.$Zj)("chrome-maximize",60089),chromeMinimize:(0,i.$Zj)("chrome-minimize",60090),chromeRestore:(0,i.$Zj)("chrome-restore",60091),circleOutline:(0,i.$Zj)("circle-outline",60092),circle:(0,i.$Zj)("circle",60092),debugBreakpointUnverified:(0,i.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,i.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,i.$Zj)("circle-slash",60093),circuitBoard:(0,i.$Zj)("circuit-board",60094),clearAll:(0,i.$Zj)("clear-all",60095),clippy:(0,i.$Zj)("clippy",60096),closeAll:(0,i.$Zj)("close-all",60097),cloudDownload:(0,i.$Zj)("cloud-download",60098),cloudUpload:(0,i.$Zj)("cloud-upload",60099),code:(0,i.$Zj)("code",60100),collapseAll:(0,i.$Zj)("collapse-all",60101),colorMode:(0,i.$Zj)("color-mode",60102),commentDiscussion:(0,i.$Zj)("comment-discussion",60103),creditCard:(0,i.$Zj)("credit-card",60105),dash:(0,i.$Zj)("dash",60108),dashboard:(0,i.$Zj)("dashboard",60109),database:(0,i.$Zj)("database",60110),debugContinue:(0,i.$Zj)("debug-continue",60111),debugDisconnect:(0,i.$Zj)("debug-disconnect",60112),debugPause:(0,i.$Zj)("debug-pause",60113),debugRestart:(0,i.$Zj)("debug-restart",60114),debugStart:(0,i.$Zj)("debug-start",60115),debugStepInto:(0,i.$Zj)("debug-step-into",60116),debugStepOut:(0,i.$Zj)("debug-step-out",60117),debugStepOver:(0,i.$Zj)("debug-step-over",60118),debugStop:(0,i.$Zj)("debug-stop",60119),debug:(0,i.$Zj)("debug",60120),deviceCameraVideo:(0,i.$Zj)("device-camera-video",60121),deviceCamera:(0,i.$Zj)("device-camera",60122),deviceMobile:(0,i.$Zj)("device-mobile",60123),diffAdded:(0,i.$Zj)("diff-added",60124),diffIgnored:(0,i.$Zj)("diff-ignored",60125),diffModified:(0,i.$Zj)("diff-modified",60126),diffRemoved:(0,i.$Zj)("diff-removed",60127),diffRenamed:(0,i.$Zj)("diff-renamed",60128),diff:(0,i.$Zj)("diff",60129),diffSidebyside:(0,i.$Zj)("diff-sidebyside",60129),discard:(0,i.$Zj)("discard",60130),editorLayout:(0,i.$Zj)("editor-layout",60131),emptyWindow:(0,i.$Zj)("empty-window",60132),exclude:(0,i.$Zj)("exclude",60133),extensions:(0,i.$Zj)("extensions",60134),eyeClosed:(0,i.$Zj)("eye-closed",60135),fileBinary:(0,i.$Zj)("file-binary",60136),fileCode:(0,i.$Zj)("file-code",60137),fileMedia:(0,i.$Zj)("file-media",60138),filePdf:(0,i.$Zj)("file-pdf",60139),fileSubmodule:(0,i.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,i.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$Zj)("file-symlink-file",60142),fileZip:(0,i.$Zj)("file-zip",60143),files:(0,i.$Zj)("files",60144),filter:(0,i.$Zj)("filter",60145),flame:(0,i.$Zj)("flame",60146),foldDown:(0,i.$Zj)("fold-down",60147),foldUp:(0,i.$Zj)("fold-up",60148),fold:(0,i.$Zj)("fold",60149),folderActive:(0,i.$Zj)("folder-active",60150),folderOpened:(0,i.$Zj)("folder-opened",60151),gear:(0,i.$Zj)("gear",60152),gift:(0,i.$Zj)("gift",60153),gistSecret:(0,i.$Zj)("gist-secret",60154),gist:(0,i.$Zj)("gist",60155),gitCommit:(0,i.$Zj)("git-commit",60156),gitCompare:(0,i.$Zj)("git-compare",60157),compareChanges:(0,i.$Zj)("compare-changes",60157),gitMerge:(0,i.$Zj)("git-merge",60158),githubAction:(0,i.$Zj)("github-action",60159),githubAlt:(0,i.$Zj)("github-alt",60160),globe:(0,i.$Zj)("globe",60161),grabber:(0,i.$Zj)("grabber",60162),graph:(0,i.$Zj)("graph",60163),gripper:(0,i.$Zj)("gripper",60164),heart:(0,i.$Zj)("heart",60165),home:(0,i.$Zj)("home",60166),horizontalRule:(0,i.$Zj)("horizontal-rule",60167),hubot:(0,i.$Zj)("hubot",60168),inbox:(0,i.$Zj)("inbox",60169),issueReopened:(0,i.$Zj)("issue-reopened",60171),issues:(0,i.$Zj)("issues",60172),italic:(0,i.$Zj)("italic",60173),jersey:(0,i.$Zj)("jersey",60174),json:(0,i.$Zj)("json",60175),kebabVertical:(0,i.$Zj)("kebab-vertical",60176),key:(0,i.$Zj)("key",60177),law:(0,i.$Zj)("law",60178),lightbulbAutofix:(0,i.$Zj)("lightbulb-autofix",60179),linkExternal:(0,i.$Zj)("link-external",60180),link:(0,i.$Zj)("link",60181),listOrdered:(0,i.$Zj)("list-ordered",60182),listUnordered:(0,i.$Zj)("list-unordered",60183),liveShare:(0,i.$Zj)("live-share",60184),loading:(0,i.$Zj)("loading",60185),location:(0,i.$Zj)("location",60186),mailRead:(0,i.$Zj)("mail-read",60187),mail:(0,i.$Zj)("mail",60188),markdown:(0,i.$Zj)("markdown",60189),megaphone:(0,i.$Zj)("megaphone",60190),mention:(0,i.$Zj)("mention",60191),milestone:(0,i.$Zj)("milestone",60192),gitPullRequestMilestone:(0,i.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,i.$Zj)("mortar-board",60193),move:(0,i.$Zj)("move",60194),multipleWindows:(0,i.$Zj)("multiple-windows",60195),mute:(0,i.$Zj)("mute",60196),noNewline:(0,i.$Zj)("no-newline",60197),note:(0,i.$Zj)("note",60198),octoface:(0,i.$Zj)("octoface",60199),openPreview:(0,i.$Zj)("open-preview",60200),package:(0,i.$Zj)("package",60201),paintcan:(0,i.$Zj)("paintcan",60202),pin:(0,i.$Zj)("pin",60203),play:(0,i.$Zj)("play",60204),run:(0,i.$Zj)("run",60204),plug:(0,i.$Zj)("plug",60205),preserveCase:(0,i.$Zj)("preserve-case",60206),preview:(0,i.$Zj)("preview",60207),project:(0,i.$Zj)("project",60208),pulse:(0,i.$Zj)("pulse",60209),question:(0,i.$Zj)("question",60210),quote:(0,i.$Zj)("quote",60211),radioTower:(0,i.$Zj)("radio-tower",60212),reactions:(0,i.$Zj)("reactions",60213),references:(0,i.$Zj)("references",60214),refresh:(0,i.$Zj)("refresh",60215),regex:(0,i.$Zj)("regex",60216),remoteExplorer:(0,i.$Zj)("remote-explorer",60217),remote:(0,i.$Zj)("remote",60218),remove:(0,i.$Zj)("remove",60219),replaceAll:(0,i.$Zj)("replace-all",60220),replace:(0,i.$Zj)("replace",60221),repoClone:(0,i.$Zj)("repo-clone",60222),repoForcePush:(0,i.$Zj)("repo-force-push",60223),repoPull:(0,i.$Zj)("repo-pull",60224),repoPush:(0,i.$Zj)("repo-push",60225),report:(0,i.$Zj)("report",60226),requestChanges:(0,i.$Zj)("request-changes",60227),rocket:(0,i.$Zj)("rocket",60228),rootFolderOpened:(0,i.$Zj)("root-folder-opened",60229),rootFolder:(0,i.$Zj)("root-folder",60230),rss:(0,i.$Zj)("rss",60231),ruby:(0,i.$Zj)("ruby",60232),saveAll:(0,i.$Zj)("save-all",60233),saveAs:(0,i.$Zj)("save-as",60234),save:(0,i.$Zj)("save",60235),screenFull:(0,i.$Zj)("screen-full",60236),screenNormal:(0,i.$Zj)("screen-normal",60237),searchStop:(0,i.$Zj)("search-stop",60238),server:(0,i.$Zj)("server",60240),settingsGear:(0,i.$Zj)("settings-gear",60241),settings:(0,i.$Zj)("settings",60242),shield:(0,i.$Zj)("shield",60243),smiley:(0,i.$Zj)("smiley",60244),sortPrecedence:(0,i.$Zj)("sort-precedence",60245),splitHorizontal:(0,i.$Zj)("split-horizontal",60246),splitVertical:(0,i.$Zj)("split-vertical",60247),squirrel:(0,i.$Zj)("squirrel",60248),starFull:(0,i.$Zj)("star-full",60249),starHalf:(0,i.$Zj)("star-half",60250),symbolClass:(0,i.$Zj)("symbol-class",60251),symbolColor:(0,i.$Zj)("symbol-color",60252),symbolConstant:(0,i.$Zj)("symbol-constant",60253),symbolEnumMember:(0,i.$Zj)("symbol-enum-member",60254),symbolField:(0,i.$Zj)("symbol-field",60255),symbolFile:(0,i.$Zj)("symbol-file",60256),symbolInterface:(0,i.$Zj)("symbol-interface",60257),symbolKeyword:(0,i.$Zj)("symbol-keyword",60258),symbolMisc:(0,i.$Zj)("symbol-misc",60259),symbolOperator:(0,i.$Zj)("symbol-operator",60260),symbolProperty:(0,i.$Zj)("symbol-property",60261),wrench:(0,i.$Zj)("wrench",60261),wrenchSubaction:(0,i.$Zj)("wrench-subaction",60261),symbolSnippet:(0,i.$Zj)("symbol-snippet",60262),tasklist:(0,i.$Zj)("tasklist",60263),telescope:(0,i.$Zj)("telescope",60264),textSize:(0,i.$Zj)("text-size",60265),threeBars:(0,i.$Zj)("three-bars",60266),thumbsdown:(0,i.$Zj)("thumbsdown",60267),thumbsup:(0,i.$Zj)("thumbsup",60268),tools:(0,i.$Zj)("tools",60269),triangleDown:(0,i.$Zj)("triangle-down",60270),triangleLeft:(0,i.$Zj)("triangle-left",60271),triangleRight:(0,i.$Zj)("triangle-right",60272),triangleUp:(0,i.$Zj)("triangle-up",60273),twitter:(0,i.$Zj)("twitter",60274),unfold:(0,i.$Zj)("unfold",60275),unlock:(0,i.$Zj)("unlock",60276),unmute:(0,i.$Zj)("unmute",60277),unverified:(0,i.$Zj)("unverified",60278),verified:(0,i.$Zj)("verified",60279),versions:(0,i.$Zj)("versions",60280),vmActive:(0,i.$Zj)("vm-active",60281),vmOutline:(0,i.$Zj)("vm-outline",60282),vmRunning:(0,i.$Zj)("vm-running",60283),watch:(0,i.$Zj)("watch",60284),whitespace:(0,i.$Zj)("whitespace",60285),wholeWord:(0,i.$Zj)("whole-word",60286),window:(0,i.$Zj)("window",60287),wordWrap:(0,i.$Zj)("word-wrap",60288),zoomIn:(0,i.$Zj)("zoom-in",60289),zoomOut:(0,i.$Zj)("zoom-out",60290),listFilter:(0,i.$Zj)("list-filter",60291),listFlat:(0,i.$Zj)("list-flat",60292),listSelection:(0,i.$Zj)("list-selection",60293),selection:(0,i.$Zj)("selection",60293),listTree:(0,i.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,i.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,i.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,i.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,i.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$Zj)("symbol-string",60301),debugReverseContinue:(0,i.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,i.$Zj)("debug-step-back",60303),debugRestartFrame:(0,i.$Zj)("debug-restart-frame",60304),debugAlt:(0,i.$Zj)("debug-alt",60305),callIncoming:(0,i.$Zj)("call-incoming",60306),callOutgoing:(0,i.$Zj)("call-outgoing",60307),menu:(0,i.$Zj)("menu",60308),expandAll:(0,i.$Zj)("expand-all",60309),feedback:(0,i.$Zj)("feedback",60310),gitPullRequestReviewer:(0,i.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,i.$Zj)("ungroup-by-ref-type",60312),account:(0,i.$Zj)("account",60313),gitPullRequestAssignee:(0,i.$Zj)("git-pull-request-assignee",60313),bellDot:(0,i.$Zj)("bell-dot",60314),debugConsole:(0,i.$Zj)("debug-console",60315),library:(0,i.$Zj)("library",60316),output:(0,i.$Zj)("output",60317),runAll:(0,i.$Zj)("run-all",60318),syncIgnored:(0,i.$Zj)("sync-ignored",60319),pinned:(0,i.$Zj)("pinned",60320),githubInverted:(0,i.$Zj)("github-inverted",60321),serverProcess:(0,i.$Zj)("server-process",60322),serverEnvironment:(0,i.$Zj)("server-environment",60323),pass:(0,i.$Zj)("pass",60324),issueClosed:(0,i.$Zj)("issue-closed",60324),stopCircle:(0,i.$Zj)("stop-circle",60325),playCircle:(0,i.$Zj)("play-circle",60326),record:(0,i.$Zj)("record",60327),debugAltSmall:(0,i.$Zj)("debug-alt-small",60328),vmConnect:(0,i.$Zj)("vm-connect",60329),cloud:(0,i.$Zj)("cloud",60330),merge:(0,i.$Zj)("merge",60331),export:(0,i.$Zj)("export",60332),graphLeft:(0,i.$Zj)("graph-left",60333),magnet:(0,i.$Zj)("magnet",60334),notebook:(0,i.$Zj)("notebook",60335),redo:(0,i.$Zj)("redo",60336),checkAll:(0,i.$Zj)("check-all",60337),pinnedDirty:(0,i.$Zj)("pinned-dirty",60338),passFilled:(0,i.$Zj)("pass-filled",60339),circleLargeFilled:(0,i.$Zj)("circle-large-filled",60340),circleLarge:(0,i.$Zj)("circle-large",60341),circleLargeOutline:(0,i.$Zj)("circle-large-outline",60341),combine:(0,i.$Zj)("combine",60342),gather:(0,i.$Zj)("gather",60342),table:(0,i.$Zj)("table",60343),variableGroup:(0,i.$Zj)("variable-group",60344),typeHierarchy:(0,i.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,i.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$Zj)("git-pull-request-create",60348),runAbove:(0,i.$Zj)("run-above",60349),runBelow:(0,i.$Zj)("run-below",60350),notebookTemplate:(0,i.$Zj)("notebook-template",60351),debugRerun:(0,i.$Zj)("debug-rerun",60352),workspaceTrusted:(0,i.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,i.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,i.$Zj)("workspace-unknown",60355),terminalCmd:(0,i.$Zj)("terminal-cmd",60356),terminalDebian:(0,i.$Zj)("terminal-debian",60357),terminalLinux:(0,i.$Zj)("terminal-linux",60358),terminalPowershell:(0,i.$Zj)("terminal-powershell",60359),terminalTmux:(0,i.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,i.$Zj)("terminal-ubuntu",60361),terminalBash:(0,i.$Zj)("terminal-bash",60362),arrowSwap:(0,i.$Zj)("arrow-swap",60363),copy:(0,i.$Zj)("copy",60364),personAdd:(0,i.$Zj)("person-add",60365),filterFilled:(0,i.$Zj)("filter-filled",60366),wand:(0,i.$Zj)("wand",60367),debugLineByLine:(0,i.$Zj)("debug-line-by-line",60368),inspect:(0,i.$Zj)("inspect",60369),layers:(0,i.$Zj)("layers",60370),layersDot:(0,i.$Zj)("layers-dot",60371),layersActive:(0,i.$Zj)("layers-active",60372),compass:(0,i.$Zj)("compass",60373),compassDot:(0,i.$Zj)("compass-dot",60374),compassActive:(0,i.$Zj)("compass-active",60375),azure:(0,i.$Zj)("azure",60376),issueDraft:(0,i.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,i.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$Zj)("git-pull-request-draft",60379),debugAll:(0,i.$Zj)("debug-all",60380),debugCoverage:(0,i.$Zj)("debug-coverage",60381),runErrors:(0,i.$Zj)("run-errors",60382),folderLibrary:(0,i.$Zj)("folder-library",60383),debugContinueSmall:(0,i.$Zj)("debug-continue-small",60384),beakerStop:(0,i.$Zj)("beaker-stop",60385),graphLine:(0,i.$Zj)("graph-line",60386),graphScatter:(0,i.$Zj)("graph-scatter",60387),pieChart:(0,i.$Zj)("pie-chart",60388),bracket:(0,i.$Zj)("bracket",60175),bracketDot:(0,i.$Zj)("bracket-dot",60389),bracketError:(0,i.$Zj)("bracket-error",60390),lockSmall:(0,i.$Zj)("lock-small",60391),azureDevops:(0,i.$Zj)("azure-devops",60392),verifiedFilled:(0,i.$Zj)("verified-filled",60393),newline:(0,i.$Zj)("newline",60394),layout:(0,i.$Zj)("layout",60395),layoutActivitybarLeft:(0,i.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,i.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,i.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,i.$Zj)("layout-panel-right",60401),layoutPanel:(0,i.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,i.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$Zj)("layout-statusbar",60405),layoutMenubar:(0,i.$Zj)("layout-menubar",60406),layoutCentered:(0,i.$Zj)("layout-centered",60407),target:(0,i.$Zj)("target",60408),indent:(0,i.$Zj)("indent",60409),recordSmall:(0,i.$Zj)("record-small",60410),errorSmall:(0,i.$Zj)("error-small",60411),terminalDecorationError:(0,i.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,i.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,i.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,i.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,i.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$Zj)("layout-sidebar-left-off",60418),blank:(0,i.$Zj)("blank",60419),heartFilled:(0,i.$Zj)("heart-filled",60420),map:(0,i.$Zj)("map",60421),mapHorizontal:(0,i.$Zj)("map-horizontal",60421),foldHorizontal:(0,i.$Zj)("fold-horizontal",60421),mapFilled:(0,i.$Zj)("map-filled",60422),mapHorizontalFilled:(0,i.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,i.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,i.$Zj)("circle-small",60423),bellSlash:(0,i.$Zj)("bell-slash",60424),bellSlashDot:(0,i.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,i.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$Zj)("search-fuzzy",60429),commentDraft:(0,i.$Zj)("comment-draft",60430),send:(0,i.$Zj)("send",60431),sparkle:(0,i.$Zj)("sparkle",60432),insert:(0,i.$Zj)("insert",60433),mic:(0,i.$Zj)("mic",60434),thumbsdownFilled:(0,i.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,i.$Zj)("thumbsup-filled",60436),coffee:(0,i.$Zj)("coffee",60437),snake:(0,i.$Zj)("snake",60438),game:(0,i.$Zj)("game",60439),vr:(0,i.$Zj)("vr",60440),chip:(0,i.$Zj)("chip",60441),piano:(0,i.$Zj)("piano",60442),music:(0,i.$Zj)("music",60443),micFilled:(0,i.$Zj)("mic-filled",60444),repoFetch:(0,i.$Zj)("repo-fetch",60445),copilot:(0,i.$Zj)("copilot",60446),lightbulbSparkle:(0,i.$Zj)("lightbulb-sparkle",60447),robot:(0,i.$Zj)("robot",60448),sparkleFilled:(0,i.$Zj)("sparkle-filled",60449),diffSingle:(0,i.$Zj)("diff-single",60450),diffMultiple:(0,i.$Zj)("diff-multiple",60451),surroundWith:(0,i.$Zj)("surround-with",60452),share:(0,i.$Zj)("share",60453),gitStash:(0,i.$Zj)("git-stash",60454),gitStashApply:(0,i.$Zj)("git-stash-apply",60455),gitStashPop:(0,i.$Zj)("git-stash-pop",60456),vscode:(0,i.$Zj)("vscode",60457),vscodeInsiders:(0,i.$Zj)("vscode-insiders",60458),codeOss:(0,i.$Zj)("code-oss",60459),runCoverage:(0,i.$Zj)("run-coverage",60460),runAllCoverage:(0,i.$Zj)("run-all-coverage",60461),coverage:(0,i.$Zj)("coverage",60462),githubProject:(0,i.$Zj)("github-project",60463),mapVertical:(0,i.$Zj)("map-vertical",60464),foldVertical:(0,i.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,i.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,i.$Zj)("fold-vertical-filled",60465),goToSearch:(0,i.$Zj)("go-to-search",60466),percentage:(0,i.$Zj)("percentage",60467),sortPercentage:(0,i.$Zj)("sort-percentage",60467),attach:(0,i.$Zj)("attach",60468)}}),define(we[21],ve([1,0,49,104]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5j=t.$4j=void 0,t.$3j=M;function M(){return Object.values(t.$5j)}t.$4j={dialogError:(0,i.$Zj)("dialog-error","error"),dialogWarning:(0,i.$Zj)("dialog-warning","warning"),dialogInfo:(0,i.$Zj)("dialog-info","info"),dialogClose:(0,i.$Zj)("dialog-close","close"),treeItemExpanded:(0,i.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,i.$Zj)("tree-item-loading","loading"),menuSelection:(0,i.$Zj)("menu-selection","check"),menuSubmenu:(0,i.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,i.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,i.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$Zj)("toolbar-more","more"),quickInputBack:(0,i.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,i.$Zj)("drop-down-button",60084),symbolCustomColor:(0,i.$Zj)("symbol-customcolor",60252),exportIcon:(0,i.$Zj)("export",60332),workspaceUnspecified:(0,i.$Zj)("workspace-unspecified",60355),newLine:(0,i.$Zj)("newline",60394),thumbsDownFilled:(0,i.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$Zj)("thumbsup-filled",60436),gitFetch:(0,i.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,i.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,i.$Zj)("debug-breakpoint-pending",60377)},t.$5j={...n.$2j,...t.$4j}}),define(we[64],ve([1,0,10]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$co=n,t.$do=M,t.$eo=L,t.$fo=E,t.$go=f,t.$ho=$,t.$io=A,t.$jo=b,t.$ko=m,t.$lo=e,t.$mo=s,t.$no=o,t.$oo=h;function n(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const p=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([k,y])=>{p[k]=y&&typeof y=="object"?n(y):y}),p}function M(c){if(!c||typeof c!="object")return c;const p=[c];for(;p.length>0;){const k=p.shift();Object.freeze(k);for(const y in k)if(R.call(k,y)){const r=k[y];typeof r=="object"&&!Object.isFrozen(r)&&!(0,i.$ig)(r)&&p.push(r)}}return c}const R=Object.prototype.hasOwnProperty;function L(c,p){return v(c,p,new Set)}function v(c,p,k){if((0,i.$og)(c))return c;const y=p(c);if(typeof y<"u")return y;if(Array.isArray(c)){const r=[];for(const d of c)r.push(v(d,p,k));return r}if((0,i.$hg)(c)){if(k.has(c))throw new Error("Cannot clone recursive data-structure");k.add(c);const r={};for(const d in c)R.call(c,d)&&(r[d]=v(c[d],p,k));return k.delete(c),r}return c}function E(c,p,k=!0){return(0,i.$hg)(c)?((0,i.$hg)(p)&&Object.keys(p).forEach(y=>{y in c?k&&((0,i.$hg)(c[y])&&(0,i.$hg)(p[y])?E(c[y],p[y],k):c[y]=p[y]):c[y]=p[y]}),c):p}function f(c,p){if(c===p)return!0;if(c==null||p===null||p===void 0||typeof c!=typeof p||typeof c!="object"||Array.isArray(c)!==Array.isArray(p))return!1;let k,y;if(Array.isArray(c)){if(c.length!==p.length)return!1;for(k=0;k<c.length;k++)if(!f(c[k],p[k]))return!1}else{const r=[];for(y in c)r.push(y);r.sort();const d=[];for(y in p)d.push(y);if(d.sort(),!f(r,d))return!1;for(k=0;k<r.length;k++)if(!f(c[r[k]],p[r[k]]))return!1}return!0}function $(c){const p=new Set;return JSON.stringify(c,(k,y)=>{if((0,i.$hg)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return typeof y=="bigint"?`[BigInt ${y.toString()}]`:y})}function A(c,p){const k=Object.create(null);return!c||!p||Object.keys(p).forEach(r=>{const d=c[r],D=p[r];f(d,D)||(k[r]=D)}),k}function b(c,p){const k=p.toLowerCase(),y=Object.keys(c).find(r=>r.toLowerCase()===k);return y?c[y]:c[p]}function m(c,p){const k=Object.create(null);for(const[y,r]of Object.entries(c))p(y,r)&&(k[y]=r);return k}function e(c){let p=[];for(;Object.prototype!==c;)p=p.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return p}function s(c){const p=[];for(const k of e(c))typeof c[k]=="function"&&p.push(k);return p}function o(c,p){const k=r=>function(){const d=Array.prototype.slice.call(arguments,0);return p(r,d)},y={};for(const r of c)y[r]=k(r);return y}function h(c,p){const k={};for(const[y,r]of Object.entries(c))k[y]=p(r,y);return k}}),define(we[22],ve([1,0,21]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$6j=M;var n;(function(L){function v(E){return E&&typeof E=="object"&&typeof E.id=="string"}L.isThemeColor=v})(n||(t.ThemeColor=n={}));function M(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function E(c){const p=v.exec(c.id);if(!p)return E(i.$5j.error);const[,k,y]=p,r=["codicon","codicon-"+k];return y&&r.push("codicon-modifier-"+y.substring(1)),r}L.asClassNameArray=E;function f(c){return E(c).join(" ")}L.asClassName=f;function $(c){return"."+E(c).join(".")}L.asCSSSelector=$;function A(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||n.isThemeColor(c.color))}L.isThemeIcon=A;const b=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function m(c){const p=b.exec(c);if(!p)return;const[,k]=p;return{id:k}}L.fromString=m;function e(c){return{id:c}}L.fromId=e;function s(c,p){let k=c.id;const y=k.lastIndexOf("~");return y!==-1&&(k=k.substring(0,y)),p&&(k=`${k}~${p}`),{id:k}}L.modify=s;function o(c){const p=c.id.lastIndexOf("~");if(p!==-1)return c.id.substring(p+1)}L.getModifier=o;function h(c,p){return c.id===p.id&&c.color?.id===p.color?.id}L.isEqual=h})(R||(t.ThemeIcon=R={}))}),define(we[65],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Constants=void 0,t.$bf=n,t.$cf=M;var i;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function n(R){return R<0?0:R>i.MAX_UINT_8?i.MAX_UINT_8:R|0}function M(R){return R<0?0:R>i.MAX_UINT_32?i.MAX_UINT_32:R|0}}),define(we[11],ve([1,0,100,18,26,65]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eg=t.$dg=t.$cg=t.GraphemeBreakType=t.$5f=t.$Wf=t.$Pf=t.$Of=void 0,t.$df=L,t.$ef=E,t.$ff=$,t.$gf=A,t.$hf=b,t.$if=m,t.$jf=e,t.$kf=s,t.$lf=o,t.$mf=h,t.$nf=c,t.$of=p,t.$pf=k,t.$qf=y,t.$rf=r,t.$sf=d,t.$tf=D,t.$uf=T,t.$vf=U,t.$wf=_,t.$xf=H,t.$yf=w,t.$zf=C,t.$Af=W,t.$Bf=O,t.$Cf=B,t.$Df=z,t.$Ef=J,t.$Ff=X,t.$Gf=K,t.$Hf=Q,t.$If=he,t.$Jf=be,t.$Kf=Se,t.$Lf=Fe,t.$Mf=se,t.$Nf=ee,t.$Qf=te,t.$Rf=$e,t.$Sf=ye,t.$Tf=Oe,t.$Uf=re,t.$Vf=j,t.$Xf=a,t.$Yf=l,t.$Zf=g,t.$1f=I,t.$2f=u,t.$3f=N,t.$4f=P,t.$6f=x,t.$7f=G,t.$8f=ie,t.$9f=le,t.$0f=de,t.$$f=Ee,t.$_f=De,t.$ag=Te,t.$bg=Xe;function L(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}const v=/{(\d+)}/g;function E(Y,...ue){return ue.length===0?Y:Y.replace(v,function(pe,Ae){const Be=parseInt(Ae,10);return isNaN(Be)||Be<0||Be>=ue.length?pe:ue[Be]})}const f=/{([^}]+)}/g;function $(Y,ue){return Object.keys(ue).length===0?Y:Y.replace(f,(pe,Ae)=>ue[Ae]??pe)}function A(Y){return Y.replace(/[<>"'&]/g,ue=>{switch(ue){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ue})}function b(Y){return Y.replace(/[<>&]/g,function(ue){switch(ue){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ue}})}function m(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function e(Y,ue){let pe=0,Ae=Y.indexOf(ue);for(;Ae!==-1;)pe++,Ae=Y.indexOf(ue,Ae+ue.length);return pe}function s(Y,ue,pe="\u2026"){return Y.length<=ue?Y:`${Y.substr(0,ue)}${pe}`}function o(Y,ue,pe="\u2026"){if(Y.length<=ue)return Y;const Ae=Math.ceil(ue/2)-pe.length/2,Be=Math.floor(ue/2)-pe.length/2;return`${Y.substr(0,Ae)}${pe}${Y.substr(Y.length-Be)}`}function h(Y,ue=" "){const pe=c(Y,ue);return p(pe,ue)}function c(Y,ue){if(!Y||!ue)return Y;const pe=ue.length;if(pe===0||Y.length===0)return Y;let Ae=0;for(;Y.indexOf(ue,Ae)===Ae;)Ae=Ae+pe;return Y.substring(Ae)}function p(Y,ue){if(!Y||!ue)return Y;const pe=ue.length,Ae=Y.length;if(pe===0||Ae===0)return Y;let Be=Ae,He=-1;for(;He=Y.lastIndexOf(ue,Be-1),!(He===-1||He+pe!==Be);){if(He===0)return"";Be=He}return Y.substring(0,Be)}function k(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function y(Y){return Y.replace(/\*/g,"")}function r(Y,ue,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");ue||(Y=m(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let Ae="";return pe.global&&(Ae+="g"),pe.matchCase||(Ae+="i"),pe.multiline&&(Ae+="m"),pe.unicode&&(Ae+="u"),new RegExp(Y,Ae)}function d(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}function D(Y){return Y.split(/\r\n|\r|\n/)}function T(Y){const ue=[],pe=Y.split(/(\r\n|\r|\n)/);for(let Ae=0;Ae<Math.ceil(pe.length/2);Ae++)ue.push(pe[2*Ae]+(pe[2*Ae+1]??""));return ue}function U(Y){for(let ue=0,pe=Y.length;ue<pe;ue++){const Ae=Y.charCodeAt(ue);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return ue}return-1}function _(Y,ue=0,pe=Y.length){for(let Ae=ue;Ae<pe;Ae++){const Be=Y.charCodeAt(Ae);if(Be!==n.CharCode.Space&&Be!==n.CharCode.Tab)return Y.substring(ue,Ae)}return Y.substring(ue,pe)}function H(Y,ue=Y.length-1){for(let pe=ue;pe>=0;pe--){const Ae=Y.charCodeAt(pe);if(Ae!==n.CharCode.Space&&Ae!==n.CharCode.Tab)return pe}return-1}function w(Y,ue,pe){const Ae=[];let Be=0;for(const He of Y.matchAll(ue)){if(Ae.push(Y.slice(Be,He.index)),He.index===void 0)throw new Error("match.index should be defined");Be=He.index+He[0].length,Ae.push(pe(He[0],...He.slice(1),He.index,Y,He.groups))}return Ae.push(Y.slice(Be)),Promise.all(Ae).then(He=>He.join(""))}function C(Y,ue){return Y<ue?-1:Y>ue?1:0}function W(Y,ue,pe=0,Ae=Y.length,Be=0,He=ue.length){for(;pe<Ae&&Be<He;pe++,Be++){const nt=Y.charCodeAt(pe),ut=ue.charCodeAt(Be);if(nt<ut)return-1;if(nt>ut)return 1}const Je=Ae-pe,ot=He-Be;return Je<ot?-1:Je>ot?1:0}function O(Y,ue){return B(Y,ue,0,Y.length,0,ue.length)}function B(Y,ue,pe=0,Ae=Y.length,Be=0,He=ue.length){for(;pe<Ae&&Be<He;pe++,Be++){let nt=Y.charCodeAt(pe),ut=ue.charCodeAt(Be);if(nt===ut)continue;if(nt>=128||ut>=128)return W(Y.toLowerCase(),ue.toLowerCase(),pe,Ae,Be,He);J(nt)&&(nt-=32),J(ut)&&(ut-=32);const st=nt-ut;if(st!==0)return st}const Je=Ae-pe,ot=He-Be;return Je<ot?-1:Je>ot?1:0}function z(Y){return Y>=n.CharCode.Digit0&&Y<=n.CharCode.Digit9}function J(Y){return Y>=n.CharCode.a&&Y<=n.CharCode.z}function X(Y){return Y>=n.CharCode.A&&Y<=n.CharCode.Z}function K(Y,ue){return Y.length===ue.length&&B(Y,ue)===0}function Q(Y,ue){const pe=ue.length;return ue.length>Y.length?!1:B(Y,ue,0,pe)===0}function he(Y,ue){const pe=Math.min(Y.length,ue.length);let Ae;for(Ae=0;Ae<pe;Ae++)if(Y.charCodeAt(Ae)!==ue.charCodeAt(Ae))return Ae;return pe}function be(Y,ue){const pe=Math.min(Y.length,ue.length);let Ae;const Be=Y.length-1,He=ue.length-1;for(Ae=0;Ae<pe;Ae++)if(Y.charCodeAt(Be-Ae)!==ue.charCodeAt(He-Ae))return Ae;return pe}function Se(Y){return 55296<=Y&&Y<=56319}function Fe(Y){return 56320<=Y&&Y<=57343}function se(Y,ue){return(Y-55296<<10)+(ue-56320)+65536}function ee(Y,ue,pe){const Ae=Y.charCodeAt(pe);if(Se(Ae)&&pe+1<ue){const Be=Y.charCodeAt(pe+1);if(Fe(Be))return se(Ae,Be)}return Ae}function ce(Y,ue){const pe=Y.charCodeAt(ue-1);if(Fe(pe)&&ue>1){const Ae=Y.charCodeAt(ue-2);if(Se(Ae))return se(Ae,pe)}return pe}class ae{get offset(){return this.e}constructor(ue,pe=0){this.c=ue,this.d=ue.length,this.e=pe}setOffset(ue){this.e=ue}prevCodePoint(){const ue=ce(this.c,this.e);return this.e-=ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}nextCodePoint(){const ue=ee(this.c,this.d,this.e);return this.e+=ue>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ue}eol(){return this.e>=this.d}}t.$Of=ae;class Ne{get offset(){return this.c.offset}constructor(ue,pe=0){this.c=new ae(ue,pe)}nextGraphemeLength(){const ue=Ie.getInstance(),pe=this.c,Ae=pe.offset;let Be=ue.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const He=pe.offset,Je=ue.getGraphemeBreakType(pe.nextCodePoint());if(ke(Be,Je)){pe.setOffset(He);break}Be=Je}return pe.offset-Ae}prevGraphemeLength(){const ue=Ie.getInstance(),pe=this.c,Ae=pe.offset;let Be=ue.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const He=pe.offset,Je=ue.getGraphemeBreakType(pe.prevCodePoint());if(ke(Je,Be)){pe.setOffset(He);break}Be=Je}return Ae-pe.offset}eol(){return this.c.eol()}}t.$Pf=Ne;function te(Y,ue){return new Ne(Y,ue).nextGraphemeLength()}function $e(Y,ue){return new Ne(Y,ue).prevGraphemeLength()}function ye(Y,ue){ue>0&&Fe(Y.charCodeAt(ue))&&ue--;const pe=ue+te(Y,ue);return[pe-$e(Y,pe),pe]}function Oe(Y){const ue=new Ne(Y);let pe=0;for(;!ue.eol();)pe++,ue.nextGraphemeLength();return pe}let Re;function Ce(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function re(Y){return Re||(Re=Ce()),Re.test(Y)}const V=/^[\t\n\r\x20-\x7E]*$/;function j(Y){return V.test(Y)}t.$Wf=/[\u2028\u2029]/;function a(Y){return t.$Wf.test(Y)}function l(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}function g(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}function I(Y,ue,pe=""){const Ae=Y.trimStart();if(Ae.length<ue)return Ae;const Be=/\b/g;let He=0;for(;Be.test(Ae)&&!(Ae.length-Be.lastIndex<ue);)He=Be.lastIndex,Be.lastIndex+=1;return He===0?Ae:pe+Ae.substring(He).trimStart()}const F=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*u(Y){let ue=0;for(const pe of Y.matchAll(F))ue!==pe.index&&(yield{isCode:!1,str:Y.substring(ue,pe.index)}),yield{isCode:!0,str:pe[0]},ue=pe.index+pe[0].length;ue!==Y.length&&(yield{isCode:!1,str:Y.substring(ue)})}function N(Y){return Y&&(Y=Y.replace(F,"")),Y}const S=/\\\[.*?\\\]/g;function P(Y){return N(Y).replace(S,"")}t.$5f=String.fromCharCode(n.CharCode.UTF8_BOM);function x(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===n.CharCode.UTF8_BOM)}function G(Y){return x(Y)?Y.substr(1):Y}function ie(Y,ue){if(!Y||!ue||Y.length<ue.length)return!1;const pe=ue.length,Ae=Y.toLowerCase();let Be=0,He=-1;for(;Be<pe;){const Je=Ae.indexOf(ue[Be],He+1);if(Je<0)return!1;He=Je,Be++}return!0}function le(Y,ue=!1){return Y?(ue&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}function de(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}function Ee(Y,ue=1){if(ue===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),ue--;while(ue>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}function De(Y){const ue=n.CharCode.Z-n.CharCode.A+1;return Y=Y%(2*ue),Y<ue?String.fromCharCode(n.CharCode.a+Y):String.fromCharCode(n.CharCode.A+Y-ue)}function Te(Y){return Ie.getInstance().getGraphemeBreakType(Y)}function ke(Y,ue){return Y===fe.Other?ue!==fe.Extend&&ue!==fe.SpacingMark:Y===fe.CR&&ue===fe.LF?!1:Y===fe.Control||Y===fe.CR||Y===fe.LF||ue===fe.Control||ue===fe.CR||ue===fe.LF?!0:!(Y===fe.L&&(ue===fe.L||ue===fe.V||ue===fe.LV||ue===fe.LVT)||(Y===fe.LV||Y===fe.V)&&(ue===fe.V||ue===fe.T)||(Y===fe.LVT||Y===fe.T)&&ue===fe.T||ue===fe.Extend||ue===fe.ZWJ||ue===fe.SpacingMark||Y===fe.Prepend||Y===fe.ZWJ&&ue===fe.Extended_Pictographic||Y===fe.Regional_Indicator&&ue===fe.Regional_Indicator)}var fe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(t.GraphemeBreakType=fe={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=ze()}getGraphemeBreakType(ue){if(ue<32)return ue===n.CharCode.LineFeed?fe.LF:ue===n.CharCode.CarriageReturn?fe.CR:fe.Control;if(ue<127)return fe.Other;const pe=this.d,Ae=pe.length/3;let Be=1;for(;Be<=Ae;)if(ue<pe[3*Be])Be=2*Be;else if(ue>pe[3*Be+1])Be=2*Be+1;else return pe[3*Be+2];return fe.Other}}function ze(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Xe(Y,ue){if(Y===0)return 0;const pe=tt(Y,ue);if(pe!==void 0)return pe;const Ae=new ae(ue,Y);return Ae.prevCodePoint(),Ae.offset}function tt(Y,ue){const pe=new ae(ue,Y);let Ae=pe.prevCodePoint();for(;lt(Ae)||Ae===rt.emojiVariantSelector||Ae===rt.enclosingKeyCap;){if(pe.offset===0)return;Ae=pe.prevCodePoint()}if(!g(Ae))return;let Be=pe.offset;return Be>0&&pe.prevCodePoint()===rt.zwj&&(Be=pe.offset),Be}function lt(Y){return 127995<=Y&&Y<=127999}var rt;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),t.$cg="\xA0";class qe{static{this.c=new M.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$_e({getCacheKey:JSON.stringify},ue=>{function pe(st){const ft=new Map;for(let ht=0;ht<st.length;ht+=2)ft.set(st[ht],st[ht+1]);return ft}function Ae(st,ft){const ht=new Map(st);for(const[wt,Ue]of ft)ht.set(wt,Ue);return ht}function Be(st,ft){if(!st)return ft;const ht=new Map;for(const[wt,Ue]of st)ft.has(wt)&&ht.set(wt,Ue);return ht}const He=this.c.value;let Je=ue.filter(st=>!st.startsWith("_")&&st in He);Je.length===0&&(Je=["_default"]);let ot;for(const st of Je){const ft=pe(He[st]);ot=Be(ot,ft)}const nt=pe(He._common),ut=Ae(nt,ot);return new qe(ut)})}static getInstance(ue){return qe.d.get(Array.from(ue))}static{this.e=new M.$X(()=>Object.keys(qe.c.value).filter(ue=>!ue.startsWith("_")))}static getLocales(){return qe.e.value}constructor(ue){this.f=ue}isAmbiguous(ue){return this.f.has(ue)}containsAmbiguousCharacter(ue){for(let pe=0;pe<ue.length;pe++){const Ae=ue.codePointAt(pe);if(typeof Ae=="number"&&this.isAmbiguous(Ae))return!0}return!1}getPrimaryConfusable(ue){return this.f.get(ue)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$dg=qe;class Ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ye.c())),this.d}static isInvisibleCharacter(ue){return Ye.e().has(ue)}static containsInvisibleCharacter(ue){for(let pe=0;pe<ue.length;pe++){const Ae=ue.codePointAt(pe);if(typeof Ae=="number"&&Ye.isInvisibleCharacter(Ae))return!0}return!1}static get codePoints(){return Ye.e()}}t.$eg=Ye}),define(we[50],ve([1,0,18,44,93,11]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sk=t.FuzzyScore=t.$Hk=t.$Gk=void 0,t.or=L,t.$Ik=E,t.$Jk=f,t.$Kk=b,t.$Lk=H,t.$Mk=w,t.$Nk=J,t.$Ok=X,t.$Pk=K,t.$Qk=Q,t.$Rk=Ce,t.$Tk=a,t.$Uk=I,t.$Vk=F,R=We(R);function L(...S){return function(P,x){for(let G=0,ie=S.length;G<ie;G++){const le=S[G](P,x);if(le)return le}return null}}t.$Gk=v.bind(void 0,!1),t.$Hk=v.bind(void 0,!0);function v(S,P,x){if(!x||x.length<P.length)return null;let G;return S?G=R.$Hf(x,P):G=x.indexOf(P)===0,G?P.length>0?[{start:0,end:P.length}]:[]:null}function E(S,P){const x=P.toLowerCase().indexOf(S.toLowerCase());return x===-1?null:[{start:x,end:x+S.length}]}function f(S,P){return $(S.toLowerCase(),P.toLowerCase(),0,0)}function $(S,P,x,G){if(x===S.length)return[];if(G===P.length)return null;if(S[x]===P[G]){let ie=null;return(ie=$(S,P,x+1,G+1))?y({start:G,end:G+1},ie):null}return $(S,P,x,G+1)}function A(S){return i.CharCode.a<=S&&S<=i.CharCode.z}function b(S){return i.CharCode.A<=S&&S<=i.CharCode.Z}function m(S){return i.CharCode.Digit0<=S&&S<=i.CharCode.Digit9}function e(S){return S===i.CharCode.Space||S===i.CharCode.Tab||S===i.CharCode.LineFeed||S===i.CharCode.CarriageReturn}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>s.add(S.charCodeAt(0)));function o(S){return e(S)||s.has(S)}function h(S,P){return S===P||o(S)&&o(P)}const c=new Map;function p(S){if(c.has(S))return c.get(S);let P;const x=(0,M.$Ek)(S);return x&&(P=x),c.set(S,P),P}function k(S){return A(S)||b(S)||m(S)}function y(S,P){return P.length===0?P=[S]:S.end===P[0].start?P[0].start=S.start:P.unshift(S),P}function r(S,P){for(let x=P;x<S.length;x++){const G=S.charCodeAt(x);if(b(G)||m(G)||x>0&&!k(S.charCodeAt(x-1)))return x}return S.length}function d(S,P,x,G){if(x===S.length)return[];if(G===P.length)return null;if(S[x]!==P[G].toLowerCase())return null;{let ie=null,le=G+1;for(ie=d(S,P,x+1,G+1);!ie&&(le=r(P,le))<P.length;)ie=d(S,P,x+1,le),le++;return ie===null?null:y({start:G,end:G+1},ie)}}function D(S){let P=0,x=0,G=0,ie=0,le=0;for(let ke=0;ke<S.length;ke++)le=S.charCodeAt(ke),b(le)&&P++,A(le)&&x++,k(le)&&G++,m(le)&&ie++;const de=P/S.length,Ee=x/S.length,De=G/S.length,Te=ie/S.length;return{upperPercent:de,lowerPercent:Ee,alphaPercent:De,numericPercent:Te}}function T(S){const{upperPercent:P,lowerPercent:x}=S;return x===0&&P>.6}function U(S){const{upperPercent:P,lowerPercent:x,alphaPercent:G,numericPercent:ie}=S;return x>.2&&P<.8&&G>.6&&ie<.2}function _(S){let P=0,x=0,G=0,ie=0;for(let le=0;le<S.length;le++)G=S.charCodeAt(le),b(G)&&P++,A(G)&&x++,e(G)&&ie++;return(P===0||x===0)&&ie===0?S.length<=30:P<=5}function H(S,P){if(!P||(P=P.trim(),P.length===0)||!_(S))return null;P.length>60&&(P=P.substring(0,60));const x=D(P);if(!U(x)){if(!T(x))return null;P=P.toLowerCase()}let G=null,ie=0;for(S=S.toLowerCase();ie<P.length&&(G=d(S,P,0,ie))===null;)ie=r(P,ie+1);return G}function w(S,P,x=!1){if(!P||P.length===0)return null;let G=null,ie=0;for(S=S.toLowerCase(),P=P.toLowerCase();ie<P.length&&(G=C(S,P,0,ie,x),G===null);)ie=W(P,ie+1);return G}function C(S,P,x,G,ie){let le=0;if(x===S.length)return[];if(G===P.length)return null;if(!h(S.charCodeAt(x),P.charCodeAt(G))){const De=p(S.charCodeAt(x));if(!De)return null;for(let Te=0;Te<De.length;Te++)if(!h(De[Te],P.charCodeAt(G+Te)))return null;le+=De.length-1}let de=null,Ee=G+le+1;if(de=C(S,P,x+1,Ee,ie),!ie)for(;!de&&(Ee=W(P,Ee))<P.length;)de=C(S,P,x+1,Ee,ie),Ee++;if(!de)return null;if(S.charCodeAt(x)!==P.charCodeAt(G)){const De=p(S.charCodeAt(x));if(!De)return de;for(let Te=0;Te<De.length;Te++)if(De[Te]!==P.charCodeAt(G+Te))return de}return y({start:G,end:G+le+1},de)}function W(S,P){for(let x=P;x<S.length;x++)if(o(S.charCodeAt(x))||x>0&&o(S.charCodeAt(x-1)))return x;return S.length}const O=L(t.$Hk,H,E),B=L(t.$Hk,H,f),z=new n.$Fc(1e4);function J(S,P,x=!1){if(typeof S!="string"||typeof P!="string")return null;let G=z.get(S);G||(G=new RegExp(R.$pf(S),"i"),z.set(S,G));const ie=G.exec(P);return ie?[{start:ie.index,end:ie.index+ie[0].length}]:x?B(S,P):O(S,P)}function X(S,P){const x=a(S,S.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?Q(x):null}function K(S,P,x,G,ie,le){const de=Math.min(13,S.length);for(;x<de;x++){const Ee=a(S,P,x,G,ie,le,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ee)return Ee}return[0,le]}function Q(S){if(typeof S>"u")return[];const P=[],x=S[1];for(let G=S.length-1;G>1;G--){const ie=S[G]+x,le=P[P.length-1];le&&le.end===ie?le.end=ie+1:P.push({start:ie,end:ie+1})}return P}const he=128;function be(){const S=[],P=[];for(let x=0;x<=he;x++)P[x]=0;for(let x=0;x<=he;x++)S.push(P.slice(0));return S}function Se(S){const P=[];for(let x=0;x<=S;x++)P[x]=0;return P}const Fe=Se(2*he),se=Se(2*he),ee=be(),ce=be(),ae=be(),Ne=!1;function te(S,P,x,G,ie){function le(Ee,De,Te=" "){for(;Ee.length<De;)Ee=Te+Ee;return Ee}let de=` |   |${G.split("").map(Ee=>le(Ee,3)).join("|")}
`;for(let Ee=0;Ee<=x;Ee++)Ee===0?de+=" |":de+=`${P[Ee-1]}|`,de+=S[Ee].slice(0,ie+1).map(De=>le(De.toString(),3)).join("|")+`
`;return de}function $e(S,P,x,G){S=S.substr(P),x=x.substr(G),console.log(te(ce,S,S.length,x,x.length)),console.log(te(ae,S,S.length,x,x.length)),console.log(te(ee,S,S.length,x,x.length))}function ye(S,P){if(P<0||P>=S.length)return!1;const x=S.codePointAt(P);switch(x){case i.CharCode.Underline:case i.CharCode.Dash:case i.CharCode.Period:case i.CharCode.Space:case i.CharCode.Slash:case i.CharCode.Backslash:case i.CharCode.SingleQuote:case i.CharCode.DoubleQuote:case i.CharCode.Colon:case i.CharCode.DollarSign:case i.CharCode.LessThan:case i.CharCode.GreaterThan:case i.CharCode.OpenParen:case i.CharCode.CloseParen:case i.CharCode.OpenSquareBracket:case i.CharCode.CloseSquareBracket:case i.CharCode.OpenCurlyBrace:case i.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Zf(x)}}function Oe(S,P){if(P<0||P>=S.length)return!1;switch(S.charCodeAt(P)){case i.CharCode.Space:case i.CharCode.Tab:return!0;default:return!1}}function Re(S,P,x){return P[S]!==x[S]}function Ce(S,P,x,G,ie,le,de=!1){for(;P<x&&ie<le;)S[P]===G[ie]&&(de&&(Fe[P]=ie),P+=1),ie+=1;return P===x}var re;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(re||(re={}));var V;(function(S){S.Default=[-100,0];function P(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}S.isDefault=P})(V||(t.FuzzyScore=V={}));class j{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,x){this.firstMatchCanBeWeak=P,this.boostFullMatch=x}}t.$Sk=j;function a(S,P,x,G,ie,le,de=j.default){const Ee=S.length>he?he:S.length,De=G.length>he?he:G.length;if(x>=Ee||le>=De||Ee-x>De-le||!Ce(P,x,Ee,ie,le,De,!0))return;l(Ee,De,x,le,P,ie);let Te=1,ke=1,fe=x,Ie=le;const ze=[!1];for(Te=1,fe=x;fe<Ee;Te++,fe++){const qe=Fe[fe],Ye=se[fe],Y=fe+1<Ee?se[fe+1]:De;for(ke=qe-le+1,Ie=qe;Ie<Y;ke++,Ie++){let ue=Number.MIN_SAFE_INTEGER,pe=!1;Ie<=Ye&&(ue=g(S,P,fe,x,G,ie,Ie,De,le,ee[Te-1][ke-1]===0,ze));let Ae=0;ue!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ae=ue+ce[Te-1][ke-1]);const Be=Ie>qe,He=Be?ce[Te][ke-1]+(ee[Te][ke-1]>0?-5:0):0,Je=Ie>qe+1&&ee[Te][ke-1]>0,ot=Je?ce[Te][ke-2]+(ee[Te][ke-2]>0?-5:0):0;if(Je&&(!Be||ot>=He)&&(!pe||ot>=Ae))ce[Te][ke]=ot,ae[Te][ke]=re.LeftLeft,ee[Te][ke]=0;else if(Be&&(!pe||He>=Ae))ce[Te][ke]=He,ae[Te][ke]=re.Left,ee[Te][ke]=0;else if(pe)ce[Te][ke]=Ae,ae[Te][ke]=re.Diag,ee[Te][ke]=ee[Te-1][ke-1]+1;else throw new Error("not possible")}}if(Ne&&$e(S,x,G,le),!ze[0]&&!de.firstMatchCanBeWeak)return;Te--,ke--;const Xe=[ce[Te][ke],le];let tt=0,lt=0;for(;Te>=1;){let qe=ke;do{const Ye=ae[Te][qe];if(Ye===re.LeftLeft)qe=qe-2;else if(Ye===re.Left)qe=qe-1;else break}while(qe>=1);tt>1&&P[x+Te-1]===ie[le+ke-1]&&!Re(qe+le-1,G,ie)&&tt+1>ee[Te][qe]&&(qe=ke),qe===ke?tt++:tt=1,lt||(lt=qe),Te--,ke=qe-1,Xe.push(ke)}De-le===Ee&&de.boostFullMatch&&(Xe[0]+=2);const rt=lt-Ee;return Xe[0]-=rt,Xe}function l(S,P,x,G,ie,le){let de=S-1,Ee=P-1;for(;de>=x&&Ee>=G;)ie[de]===le[Ee]&&(se[de]=Ee,de--),Ee--}function g(S,P,x,G,ie,le,de,Ee,De,Te,ke){if(P[x]!==le[de])return Number.MIN_SAFE_INTEGER;let fe=1,Ie=!1;return de===x-G?fe=S[x]===ie[de]?7:5:Re(de,ie,le)&&(de===0||!Re(de-1,ie,le))?(fe=S[x]===ie[de]?7:5,Ie=!0):ye(le,de)&&(de===0||!ye(le,de-1))?fe=5:(ye(le,de-1)||Oe(le,de-1))&&(fe=5,Ie=!0),fe>1&&x===G&&(ke[0]=!0),Ie||(Ie=Re(de,ie,le)||ye(le,de-1)||Oe(le,de-1)),x===G?de>De&&(fe-=Ie?3:5):Te?fe+=Ie?2:0:fe+=Ie?0:1,de+1===Ee&&(fe-=Ie?3:5),fe}function I(S,P,x,G,ie,le,de){return u(S,P,x,G,ie,le,!0,de)}function F(S,P,x,G,ie,le,de){return u(S,P,x,G,ie,le,!1,de)}function u(S,P,x,G,ie,le,de,Ee){let De=a(S,P,x,G,ie,le,Ee);if(De&&!de)return De;if(S.length>=3){const Te=Math.min(7,S.length-1);for(let ke=x+1;ke<Te;ke++){const fe=N(S,ke);if(fe){const Ie=a(fe,fe.toLowerCase(),x,G,ie,le,Ee);Ie&&(Ie[0]-=3,(!De||Ie[0]>De[0])&&(De=Ie))}}}return De}function N(S,P){if(P+1>=S.length)return;const x=S[P],G=S[P+1];if(x!==G)return S.slice(0,P)+G+x+S.slice(P+2)}}),define(we[66],ve([1,0,11]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zj=t.$xj=void 0,t.$tj=n,t.$uj=M,t.$vj=R,t.$wj=v,t.$yj=s,i=We(i);function n(h){return M(h,0)}function M(h,c){switch(typeof h){case"object":return h===null?R(349,c):Array.isArray(h)?E(h,c):f(h,c);case"string":return v(h,c);case"boolean":return L(h,c);case"number":return R(h,c);case"undefined":return R(937,c);default:return R(617,c)}}function R(h,c){return(c<<5)-c+h|0}function L(h,c){return R(h?433:863,c)}function v(h,c){c=R(149417,c);for(let p=0,k=h.length;p<k;p++)c=R(h.charCodeAt(p),c);return c}function E(h,c){return c=R(104579,c),h.reduce((p,k)=>M(k,p),c)}function f(h,c){return c=R(181387,c),Object.keys(h).sort().reduce((p,k)=>(p=v(k,p),M(h[k],p)),c)}class ${constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=M(c,this.g),this.g}}t.$xj=$;var A;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function b(h,c,p=32){const k=p-c,y=~((1<<k)-1);return(h<<c|(y&h)>>>k)>>>0}function m(h,c=0,p=h.byteLength,k=0){for(let y=0;y<p;y++)h[c+y]=k}function e(h,c,p="0"){for(;h.length<c;)h=p+h;return h}function s(h,c=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(p=>p.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),c/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(A.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const p=c.length;if(p===0)return;const k=this.p;let y=this.r,r=this.u,d,D;for(r!==0?(d=r,D=-1,r=0):(d=c.charCodeAt(0),D=0);;){let T=d;if(i.$Kf(d))if(D+1<p){const U=c.charCodeAt(D+1);i.$Lf(U)?(D++,T=i.$Mf(d,U)):T=A.UNICODE_REPLACEMENT}else{r=d;break}else i.$Lf(d)&&(T=A.UNICODE_REPLACEMENT);if(y=this.w(k,y,T),D++,D<p)d=c.charCodeAt(D);else break}this.r=y,this.u=r}w(c,p,k){return k<128?c[p++]=k:k<2048?(c[p++]=192|(k&1984)>>>6,c[p++]=128|(k&63)>>>0):k<65536?(c[p++]=224|(k&61440)>>>12,c[p++]=128|(k&4032)>>>6,c[p++]=128|(k&63)>>>0):(c[p++]=240|(k&1835008)>>>18,c[p++]=128|(k&258048)>>>12,c[p++]=128|(k&4032)>>>6,c[p++]=128|(k&63)>>>0),p>=A.BLOCK_SIZE&&(this.y(),p-=A.BLOCK_SIZE,this.t+=A.BLOCK_SIZE,c[0]=c[A.BLOCK_SIZE+0],c[1]=c[A.BLOCK_SIZE+1],c[2]=c[A.BLOCK_SIZE+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,A.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=o.g,p=this.q;for(let H=0;H<64;H+=4)c.setUint32(H,p.getUint32(H,!1),!1);for(let H=64;H<320;H+=4)c.setUint32(H,b(c.getUint32(H-12,!1)^c.getUint32(H-32,!1)^c.getUint32(H-56,!1)^c.getUint32(H-64,!1),1),!1);let k=this.h,y=this.l,r=this.m,d=this.n,D=this.o,T,U,_;for(let H=0;H<80;H++)H<20?(T=y&r|~y&d,U=1518500249):H<40?(T=y^r^d,U=1859775393):H<60?(T=y&r|y&d|r&d,U=2400959708):(T=y^r^d,U=3395469782),_=b(k,5)+T+D+U+c.getUint32(H*4,!1)&4294967295,D=d,d=r,r=b(y,30),y=k,k=_;this.h=this.h+k&4294967295,this.l=this.l+y&4294967295,this.m=this.m+r&4294967295,this.n=this.n+d&4294967295,this.o=this.o+D&4294967295}}t.$zj=o}),define(we[105],ve([1,0,90,66,65]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ot=t.$Mt=void 0,t.$Nt=L;class R{constructor(m){this.a=m}getElements(){const m=this.a,e=new Int32Array(m.length);for(let s=0,o=m.length;s<o;s++)e[s]=m.charCodeAt(s);return e}}t.$Mt=R;function L(b,m,e){return new A(new R(b),new R(m)).ComputeDiff(e).changes}class v{static Assert(m,e){if(!m)throw new Error(e)}}class E{static Copy(m,e,s,o,h){for(let c=0;c<h;c++)s[o+c]=m[e+c]}static Copy2(m,e,s,o,h){for(let c=0;c<h;c++)s[o+c]=m[e+c]}}var f;(function(b){b[b.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(f||(f={}));class ${constructor(){this.a=[],this.b=M.Constants.MAX_SAFE_SMALL_INTEGER,this.c=M.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$Lt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=M.Constants.MAX_SAFE_SMALL_INTEGER,this.c=M.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(m,e){this.b=Math.min(this.b,m),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class A{constructor(m,e,s=null){this.a=s,this.b=m,this.c=e;const[o,h,c]=A.o(m),[p,k,y]=A.o(e);this.d=c&&y,this.e=o,this.f=h,this.g=p,this.h=k,this.k=[],this.m=[]}static n(m){return m.length>0&&typeof m[0]=="string"}static o(m){const e=m.getElements();if(A.n(e)){const s=new Int32Array(e.length);for(let o=0,h=e.length;o<h;o++)s[o]=(0,n.$wj)(e[o],0);return[e,s,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(m,e){return this.f[m]!==this.h[e]?!1:this.d?this.e[m]===this.g[e]:!0}q(m,e){if(!this.p(m,e))return!1;const s=A.r(this.b,m),o=A.r(this.c,e);return s===o}static r(m,e){return typeof m.getStrictElement=="function"?m.getStrictElement(e):null}s(m,e){return this.f[m]!==this.f[e]?!1:this.d?this.e[m]===this.e[e]:!0}u(m,e){return this.h[m]!==this.h[e]?!1:this.d?this.g[m]===this.g[e]:!0}ComputeDiff(m){return this.v(0,this.f.length-1,0,this.h.length-1,m)}v(m,e,s,o,h){const c=[!1];let p=this.w(m,e,s,o,c);return h&&(p=this.z(p)),{quitEarly:c[0],changes:p}}w(m,e,s,o,h){for(h[0]=!1;m<=e&&s<=o&&this.p(m,s);)m++,s++;for(;e>=m&&o>=s&&this.p(e,o);)e--,o--;if(m>e||s>o){let d;return s<=o?(v.Assert(m===e+1,"originalStart should only be one more than originalEnd"),d=[new i.$Lt(m,0,s,o-s+1)]):m<=e?(v.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),d=[new i.$Lt(m,e-m+1,s,0)]):(v.Assert(m===e+1,"originalStart should only be one more than originalEnd"),v.Assert(s===o+1,"modifiedStart should only be one more than modifiedEnd"),d=[]),d}const c=[0],p=[0],k=this.y(m,e,s,o,c,p,h),y=c[0],r=p[0];if(k!==null)return k;if(!h[0]){const d=this.w(m,y,s,r,h);let D=[];return h[0]?D=[new i.$Lt(y+1,e-(y+1)+1,r+1,o-(r+1)+1)]:D=this.w(y+1,e,r+1,o,h),this.H(d,D)}return[new i.$Lt(m,e-m+1,s,o-s+1)]}x(m,e,s,o,h,c,p,k,y,r,d,D,T,U,_,H,w,C){let W=null,O=null,B=new $,z=e,J=s,X=T[0]-H[0]-o,K=M.Constants.MIN_SAFE_SMALL_INTEGER,Q=this.k.length-1;do{const he=X+m;he===z||he<J&&y[he-1]<y[he+1]?(d=y[he+1],U=d-X-o,d<K&&B.MarkNextChange(),K=d,B.AddModifiedElement(d+1,U),X=he+1-m):(d=y[he-1]+1,U=d-X-o,d<K&&B.MarkNextChange(),K=d-1,B.AddOriginalElement(d,U+1),X=he-1-m),Q>=0&&(y=this.k[Q],m=y[0],z=1,J=y.length-1)}while(--Q>=-1);if(W=B.getReverseChanges(),C[0]){let he=T[0]+1,be=H[0]+1;if(W!==null&&W.length>0){const Se=W[W.length-1];he=Math.max(he,Se.getOriginalEnd()),be=Math.max(be,Se.getModifiedEnd())}O=[new i.$Lt(he,D-he+1,be,_-be+1)]}else{B=new $,z=c,J=p,X=T[0]-H[0]-k,K=M.Constants.MAX_SAFE_SMALL_INTEGER,Q=w?this.m.length-1:this.m.length-2;do{const he=X+h;he===z||he<J&&r[he-1]>=r[he+1]?(d=r[he+1]-1,U=d-X-k,d>K&&B.MarkNextChange(),K=d+1,B.AddOriginalElement(d+1,U+1),X=he+1-h):(d=r[he-1],U=d-X-k,d>K&&B.MarkNextChange(),K=d,B.AddModifiedElement(d+1,U+1),X=he-1-h),Q>=0&&(r=this.m[Q],h=r[0],z=1,J=r.length-1)}while(--Q>=-1);O=B.getChanges()}return this.H(W,O)}y(m,e,s,o,h,c,p){let k=0,y=0,r=0,d=0,D=0,T=0;m--,s--,h[0]=0,c[0]=0,this.k=[],this.m=[];const U=e-m+(o-s),_=U+1,H=new Int32Array(_),w=new Int32Array(_),C=o-s,W=e-m,O=m-s,B=e-o,J=(W-C)%2===0;H[C]=m,w[W]=e,p[0]=!1;for(let X=1;X<=U/2+1;X++){let K=0,Q=0;r=this.J(C-X,X,C,_),d=this.J(C+X,X,C,_);for(let be=r;be<=d;be+=2){be===r||be<d&&H[be-1]<H[be+1]?k=H[be+1]:k=H[be-1]+1,y=k-(be-C)-O;const Se=k;for(;k<e&&y<o&&this.p(k+1,y+1);)k++,y++;if(H[be]=k,k+y>K+Q&&(K=k,Q=y),!J&&Math.abs(be-W)<=X-1&&k>=w[be])return h[0]=k,c[0]=y,Se<=w[be]&&f.MaxDifferencesHistory>0&&X<=f.MaxDifferencesHistory+1?this.x(C,r,d,O,W,D,T,B,H,w,k,e,h,y,o,c,J,p):null}const he=(K-m+(Q-s)-X)/2;if(this.a!==null&&!this.a(K,he))return p[0]=!0,h[0]=K,c[0]=Q,he>0&&f.MaxDifferencesHistory>0&&X<=f.MaxDifferencesHistory+1?this.x(C,r,d,O,W,D,T,B,H,w,k,e,h,y,o,c,J,p):(m++,s++,[new i.$Lt(m,e-m+1,s,o-s+1)]);D=this.J(W-X,X,W,_),T=this.J(W+X,X,W,_);for(let be=D;be<=T;be+=2){be===D||be<T&&w[be-1]>=w[be+1]?k=w[be+1]-1:k=w[be-1],y=k-(be-W)-B;const Se=k;for(;k>m&&y>s&&this.p(k,y);)k--,y--;if(w[be]=k,J&&Math.abs(be-C)<=X&&k<=H[be])return h[0]=k,c[0]=y,Se>=H[be]&&f.MaxDifferencesHistory>0&&X<=f.MaxDifferencesHistory+1?this.x(C,r,d,O,W,D,T,B,H,w,k,e,h,y,o,c,J,p):null}if(X<=f.MaxDifferencesHistory){let be=new Int32Array(d-r+2);be[0]=C-r+1,E.Copy2(H,r,be,1,d-r+1),this.k.push(be),be=new Int32Array(T-D+2),be[0]=W-D+1,E.Copy2(w,D,be,1,T-D+1),this.m.push(be)}}return this.x(C,r,d,O,W,D,T,B,H,w,k,e,h,y,o,c,J,p)}z(m){for(let e=0;e<m.length;e++){const s=m[e],o=e<m.length-1?m[e+1].originalStart:this.f.length,h=e<m.length-1?m[e+1].modifiedStart:this.h.length,c=s.originalLength>0,p=s.modifiedLength>0;for(;s.originalStart+s.originalLength<o&&s.modifiedStart+s.modifiedLength<h&&(!c||this.s(s.originalStart,s.originalStart+s.originalLength))&&(!p||this.u(s.modifiedStart,s.modifiedStart+s.modifiedLength));){const y=this.q(s.originalStart,s.modifiedStart);if(this.q(s.originalStart+s.originalLength,s.modifiedStart+s.modifiedLength)&&!y)break;s.originalStart++,s.modifiedStart++}const k=[null];if(e<m.length-1&&this.I(m[e],m[e+1],k)){m[e]=k[0],m.splice(e+1,1),e--;continue}}for(let e=m.length-1;e>=0;e--){const s=m[e];let o=0,h=0;if(e>0){const d=m[e-1];o=d.originalStart+d.originalLength,h=d.modifiedStart+d.modifiedLength}const c=s.originalLength>0,p=s.modifiedLength>0;let k=0,y=this.G(s.originalStart,s.originalLength,s.modifiedStart,s.modifiedLength);for(let d=1;;d++){const D=s.originalStart-d,T=s.modifiedStart-d;if(D<o||T<h||c&&!this.s(D,D+s.originalLength)||p&&!this.u(T,T+s.modifiedLength))break;const _=(D===o&&T===h?5:0)+this.G(D,s.originalLength,T,s.modifiedLength);_>y&&(y=_,k=d)}s.originalStart-=k,s.modifiedStart-=k;const r=[null];if(e>0&&this.I(m[e-1],m[e],r)){m[e-1]=r[0],m.splice(e,1),e++;continue}}if(this.d)for(let e=1,s=m.length;e<s;e++){const o=m[e-1],h=m[e],c=h.originalStart-o.originalStart-o.originalLength,p=o.originalStart,k=h.originalStart+h.originalLength,y=k-p,r=o.modifiedStart,d=h.modifiedStart+h.modifiedLength,D=d-r;if(c<5&&y<20&&D<20){const T=this.A(p,y,r,D,c);if(T){const[U,_]=T;(U!==o.originalStart+o.originalLength||_!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=U-o.originalStart,o.modifiedLength=_-o.modifiedStart,h.originalStart=U+c,h.modifiedStart=_+c,h.originalLength=k-h.originalStart,h.modifiedLength=d-h.modifiedStart)}}}return m}A(m,e,s,o,h){if(e<h||o<h)return null;const c=m+e-h+1,p=s+o-h+1;let k=0,y=0,r=0;for(let d=m;d<c;d++)for(let D=s;D<p;D++){const T=this.B(d,D,h);T>0&&T>k&&(k=T,y=d,r=D)}return k>0?[y,r]:null}B(m,e,s){let o=0;for(let h=0;h<s;h++){if(!this.p(m+h,e+h))return 0;o+=this.e[m+h].length}return o}C(m){return m<=0||m>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[m])}D(m,e){if(this.C(m)||this.C(m-1))return!0;if(e>0){const s=m+e;if(this.C(s-1)||this.C(s))return!0}return!1}E(m){return m<=0||m>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[m])}F(m,e){if(this.E(m)||this.E(m-1))return!0;if(e>0){const s=m+e;if(this.E(s-1)||this.E(s))return!0}return!1}G(m,e,s,o){const h=this.D(m,e)?1:0,c=this.F(s,o)?1:0;return h+c}H(m,e){const s=[];if(m.length===0||e.length===0)return e.length>0?e:m;if(this.I(m[m.length-1],e[0],s)){const o=new Array(m.length+e.length-1);return E.Copy(m,0,o,0,m.length-1),o[m.length-1]=s[0],E.Copy(e,1,o,m.length,e.length-1),o}else{const o=new Array(m.length+e.length);return E.Copy(m,0,o,0,m.length),E.Copy(e,0,o,m.length,e.length),o}}I(m,e,s){if(v.Assert(m.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),v.Assert(m.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),m.originalStart+m.originalLength>=e.originalStart||m.modifiedStart+m.modifiedLength>=e.modifiedStart){const o=m.originalStart;let h=m.originalLength;const c=m.modifiedStart;let p=m.modifiedLength;return m.originalStart+m.originalLength>=e.originalStart&&(h=e.originalStart+e.originalLength-m.originalStart),m.modifiedStart+m.modifiedLength>=e.modifiedStart&&(p=e.modifiedStart+e.modifiedLength-m.modifiedStart),s[0]=new i.$Lt(o,h,c,p),!0}else return s[0]=null,!1}J(m,e,s,o){if(m>=0&&m<o)return m;const h=s,c=o-s-1,p=e%2===0;if(m<0){const k=h%2===0;return p===k?0:1}else{const k=c%2===0;return p===k?o-1:o-2}}}t.$Ot=A}),define(we[67],ve([1,0,50,11,22]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wk=E,t.$Xk=$,t.$Yk=b,t.$Zk=m,t.$1k=s,t.$2k=o;const R="$(",L=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${L.source}`,"g");function E(h){return h.replace(v,(c,p)=>p?c:`\\${c}`)}const f=new RegExp(`\\\\${L.source}`,"g");function $(h){return h.replace(f,c=>`\\${c}`)}const A=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function b(h){return h.indexOf(R)===-1?h:h.replace(A,(c,p,k,y)=>k?c:p||y||"")}function m(h){return h?h.replace(/\$\((.*?)\)/g,(c,p)=>` ${p} `).trim():""}const e=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(h){e.lastIndex=0;let c="";const p=[];let k=0;for(;;){const y=e.lastIndex,r=e.exec(h),d=h.substring(y,r?.index);if(d.length>0){c+=d;for(let D=0;D<d.length;D++)p.push(k)}if(!r)break;k+=r[0].length}return{text:c,iconOffsets:p}}function o(h,c,p=!1){const{text:k,iconOffsets:y}=c;if(!y||y.length===0)return(0,i.$Nk)(h,k,p);const r=(0,n.$nf)(k," "),d=k.length-r.length,D=(0,i.$Nk)(h,r,p);if(D)for(const T of D){const U=y[T.start+d]+d;T.start+=U,T.end+=U}return D}}),define(we[106],ve([1,0,9,18,11]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Li=t.$Ki=t.$Ji=t.$Ii=t.$Hi=void 0;class R{constructor(){this.b="",this.c=0}reset(e){return this.b=e,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(e){const s=e.charCodeAt(0),o=this.b.charCodeAt(this.c);return s-o}value(){return this.b[this.c]}}t.$Hi=R;class L{constructor(e=!0){this.e=e}reset(e){return this.b=e,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let e=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===n.CharCode.Period)if(e)this.c++;else break;else e=!1;return this}cmp(e){return this.e?(0,M.$Af)(e,this.b,0,e.length,this.c,this.d):(0,M.$Cf)(e,this.b,0,e.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Ii=L;class v{constructor(e=!0,s=!0){this.f=e,this.g=s}reset(e){this.d=0,this.e=0,this.b=e,this.c=e.length;for(let s=e.length-1;s>=0;s--,this.c--){const o=this.b.charCodeAt(s);if(!(o===n.CharCode.Slash||this.f&&o===n.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let e=!0;for(;this.e<this.c;this.e++){const s=this.b.charCodeAt(this.e);if(s===n.CharCode.Slash||this.f&&s===n.CharCode.Backslash)if(e)this.d++;else break;else e=!1}return this}cmp(e){return this.g?(0,M.$Af)(e,this.b,0,e.length,this.d,this.e):(0,M.$Cf)(e,this.b,0,e.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Ji=v;var E;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(E||(E={}));class f{constructor(e,s){this.f=e,this.g=s,this.d=[],this.e=0}reset(e){return this.c=e,this.d=[],this.c.scheme&&this.d.push(E.Scheme),this.c.authority&&this.d.push(E.Authority),this.c.path&&(this.b=new v(!1,!this.f(e)),this.b.reset(e.path),this.b.value()&&this.d.push(E.Path)),this.g(e)||(this.c.query&&this.d.push(E.Query),this.c.fragment&&this.d.push(E.Fragment)),this.e=0,this}next(){return this.d[this.e]===E.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===E.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(e){if(this.d[this.e]===E.Scheme)return(0,M.$Bf)(e,this.c.scheme);if(this.d[this.e]===E.Authority)return(0,M.$Bf)(e,this.c.authority);if(this.d[this.e]===E.Path)return this.b.cmp(e);if(this.d[this.e]===E.Query)return(0,M.$zf)(e,this.c.query);if(this.d[this.e]===E.Fragment)return(0,M.$zf)(e,this.c.fragment);throw new Error}value(){if(this.d[this.e]===E.Scheme)return this.c.scheme;if(this.d[this.e]===E.Authority)return this.c.authority;if(this.d[this.e]===E.Path)return this.b.value();if(this.d[this.e]===E.Query)return this.c.query;if(this.d[this.e]===E.Fragment)return this.c.fragment;throw new Error}}t.$Ki=f;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const e=this.right;return this.right=e.left,e.left=this,this.updateHeight(),e.updateHeight(),e}rotateRight(){const e=this.left;return this.left=e.right,e.right=this,this.updateHeight(),e.updateHeight(),e}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(A||(A={}));class b{static forUris(e=()=>!1,s=()=>!1){return new b(new f(e,s))}static forPaths(e=!1){return new b(new v(void 0,!e))}static forStrings(){return new b(new R)}static forConfigKeys(){return new b(new L)}constructor(e){this.b=e}clear(){this.c=void 0}fill(e,s){if(s){const o=s.slice(0);(0,i.$Yb)(o);for(const h of o)this.set(h,e)}else{const o=e.slice(0);(0,i.$Yb)(o);for(const h of o)this.set(h[0],h[1])}}set(e,s){const o=this.b.reset(e);let h;this.c||(this.c=new $,this.c.segment=o.value());const c=[];for(h=this.c;;){const k=o.cmp(h.segment);if(k>0)h.left||(h.left=new $,h.left.segment=o.value()),c.push([A.Left,h]),h=h.left;else if(k<0)h.right||(h.right=new $,h.right.segment=o.value()),c.push([A.Right,h]),h=h.right;else if(o.hasNext())o.next(),h.mid||(h.mid=new $,h.mid.segment=o.value()),c.push([A.Mid,h]),h=h.mid;else break}const p=h.value;h.value=s,h.key=e;for(let k=c.length-1;k>=0;k--){const y=c[k][1];y.updateHeight();const r=y.balanceFactor();if(r<-1||r>1){const d=c[k][0],D=c[k+1][0];if(d===A.Right&&D===A.Right)c[k][1]=y.rotateLeft();else if(d===A.Left&&D===A.Left)c[k][1]=y.rotateRight();else if(d===A.Right&&D===A.Left)y.right=c[k+1][1]=c[k+1][1].rotateRight(),c[k][1]=y.rotateLeft();else if(d===A.Left&&D===A.Right)y.left=c[k+1][1]=c[k+1][1].rotateLeft(),c[k][1]=y.rotateRight();else throw new Error;if(k>0)switch(c[k-1][0]){case A.Left:c[k-1][1].left=c[k][1];break;case A.Right:c[k-1][1].right=c[k][1];break;case A.Mid:c[k-1][1].mid=c[k][1];break}else this.c=c[0][1]}}return p}get(e){return this.d(e)?.value}d(e){const s=this.b.reset(e);let o=this.c;for(;o;){const h=s.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(e){const s=this.d(e);return!(s?.value===void 0&&s?.mid===void 0)}delete(e){return this.e(e,!1)}deleteSuperstr(e){return this.e(e,!0)}e(e,s){const o=this.b.reset(e),h=[];let c=this.c;for(;c;){const p=o.cmp(c.segment);if(p>0)h.push([A.Left,c]),c=c.left;else if(p<0)h.push([A.Right,c]),c=c.right;else if(o.hasNext())o.next(),h.push([A.Mid,c]),c=c.mid;else break}if(c){if(s?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const p=this.f(c.right);if(p.key){const{key:k,value:y,segment:r}=p;this.e(p.key,!1),c.key=k,c.value=y,c.segment=r}}else{const p=c.left??c.right;if(h.length>0){const[k,y]=h[h.length-1];switch(k){case A.Left:y.left=p;break;case A.Mid:y.mid=p;break;case A.Right:y.right=p;break}}else this.c=p}for(let p=h.length-1;p>=0;p--){const k=h[p][1];k.updateHeight();const y=k.balanceFactor();if(y>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),h[p][1]=k.rotateLeft()):y<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),h[p][1]=k.rotateRight()),p>0)switch(h[p-1][0]){case A.Left:h[p-1][1].left=h[p][1];break;case A.Right:h[p-1][1].right=h[p][1];break;case A.Mid:h[p-1][1].mid=h[p][1];break}else this.c=h[0][1]}}}f(e){for(;e.left;)e=e.left;return e}findSubstr(e){const s=this.b.reset(e);let o=this.c,h;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),h=o.value||h,o=o.mid;else break}return o&&o.value||h}findSuperstr(e){return this.g(e,!1)}g(e,s){const o=this.b.reset(e);let h=this.c;for(;h;){const c=o.cmp(h.segment);if(c>0)h=h.left;else if(c<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this.h(h.mid):s?h.value:void 0}}hasElementOrSubtree(e){return this.g(e,!0)!==void 0}forEach(e){for(const[s,o]of this)e(o,s)}*[Symbol.iterator](){yield*this.h(this.c)}h(e){const s=[];return this.j(e,s),s[Symbol.iterator]()}j(e,s){e&&(e.left&&this.j(e.left,s),e.value&&s.push([e.key,e.value]),e.mid&&this.j(e.mid,s),e.right&&this.j(e.right,s))}_isBalanced(){const e=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:e(s.left)&&e(s.right)};return e(this.c)}}t.$Li=b}),define(we[107],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zX=t.$yX=void 0,t.$yX="vscode:contextmenu",t.$zX="vscode:onCloseContextMenu"}),define(we[108],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GX=void 0;class i{constructor(M,R){this.a=M,this.onMessage=R}send(M){try{this.a.send("vscode:message",M.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$GX=i}),define(we[40],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=t.$T=t.$S=t.$R=t.$Q=t.$P=void 0;const i=globalThis.vscode;t.$P=i.ipcRenderer,t.$Q=i.ipcMessagePort,t.$R=i.webFrame,t.$S=i.process,t.$T=i.context,t.$U=i.webUtils}),define(we[109],ve([1,0,107,40]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CX=R;let M=0;function R(v,E,f){const $=[],A=M++,b=`vscode:onContextMenu${A}`,m=(e,s,o)=>{$[s].click?.(o)};n.$P.once(b,m),n.$P.once(i.$zX,(e,s)=>{s===A&&(n.$P.removeListener(b,m),f?.())}),n.$P.send(i.$yX,A,v.map(e=>L(e,$)),b,E)}function L(v,E){const f={id:E.length,label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:typeof v.enabled=="boolean"?v.enabled:!0,visible:typeof v.visible=="boolean"?v.visible:!0};return E.push(v),Array.isArray(v.submenu)&&(f.submenu=v.submenu.map($=>L($,E))),f}}),define(we[68],ve([7]),{}),define(we[110],ve([7]),{}),define(we[111],ve([7]),{}),define(we[112],ve([7]),{}),define(we[113],ve([1,0,111,112]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(we[114],ve([7]),{}),define(we[115],ve([7]),{}),define(we[116],ve([7]),{}),define(we[117],ve([7]),{}),define(we[118],ve([7]),{}),define(we[119],ve([7]),{}),define(we[120],ve([7]),{}),define(we[121],ve([7]),{}),define(we[122],ve([7]),{}),define(we[123],ve([7]),{}),define(we[124],ve([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(we[125],ve([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define(we[126],ve([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(we[127],ve([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(we[128],ve([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(we[129],ve([14,13]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define(we[130],ve([14,13]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define(we[51],ve([1,0,3,2,130]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oj=t.$nj=t.$mj=t.$lj=t.$kj=void 0,t.$pj=$,M=We(M);class R extends n.$Wc{constructor(b,m="",e="",s=!0,o){super(),this.j=this.B(new i.$me),this.onDidChange=this.j.event,this.z=!0,this.m=b,this.n=m,this.w=e,this.z=s,this.D=o}get id(){return this.m}get label(){return this.n}set label(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.j.fire({label:b}))}get tooltip(){return this.u||""}set tooltip(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.j.fire({tooltip:b}))}get class(){return this.w}set class(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.j.fire({class:b}))}get enabled(){return this.z}set enabled(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.j.fire({enabled:b}))}get checked(){return this.C}set checked(b){this.J(b)}J(b){this.C!==b&&(this.C=b,this.j.fire({checked:b}))}async run(b,m){this.D&&await this.D(b)}}t.$kj=R;class L extends n.$Wc{constructor(){super(...arguments),this.f=this.B(new i.$me),this.onWillRun=this.f.event,this.m=this.B(new i.$me),this.onDidRun=this.m.event}async run(b,m){if(!b.enabled)return;this.f.fire({action:b});let e;try{await this.u(b,m)}catch(s){e=s}this.m.fire({action:b,error:e})}async u(b,m){await b.run(m)}}t.$lj=L;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let m=[];for(const e of b)e.length&&(m.length?m=[...m,new v,...e]:m=e);return m}static{this.ID="vs.actions.separator"}async run(){}}t.$mj=v;class E{get actions(){return this.a}constructor(b,m,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=m,this.class=s,this.a=e}async run(){}}t.$nj=E;class f extends R{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,M.localize(0,null),void 0,!1)}}t.$oj=f;function $(A){return{id:A.id,label:A.label,tooltip:A.tooltip??A.label,class:A.class,enabled:A.enabled??!0,checked:A.checked,run:async(...b)=>A.run(...b)}}}),define(we[131],ve([14,13]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define(we[5],ve([1,0,131]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=d,t.$D=w,t.$J=C,i=We(i),t.$g="en";let n=!1,M=!1,R=!1,L=!1,v=!1,E=!1,f=!1,$=!1,A=!1,b=!1,m,e=t.$g,s=t.$g,o,h;const c=globalThis;let p;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?p=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const k=typeof p?.versions?.electron=="string",y=k&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",M=p.platform==="darwin",R=p.platform==="linux",L=R&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,f=k,A=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const W=p.env.VSCODE_NLS_CONFIG;if(W)try{const O=JSON.parse(W),B=O.availableLanguages["*"];m=O.locale,s=O.osLocale,e=B||t.$g,o=O._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!y?(h=navigator.userAgent,n=h.indexOf("Windows")>=0,M=h.indexOf("Macintosh")>=0,$=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=h.indexOf("Linux")>=0,b=h?.indexOf("Mobi")>=0,E=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(W){W[W.Web=0]="Web",W[W.Mac=1]="Mac",W[W.Linux=2]="Linux",W[W.Windows=3]="Windows"})(r||(t.Platform=r={}));function d(W){switch(W){case r.Web:return"Web";case r.Mac:return"Mac";case r.Linux:return"Linux";case r.Windows:return"Windows"}}let D=r.Web;M?D=r.Mac:n?D=r.Windows:R&&(D=r.Linux),t.$i=n,t.$j=M,t.$k=R,t.$l=L,t.$m=v,t.$n=f,t.$o=E,t.$p=E&&typeof c.importScripts=="function",t.$q=t.$p?c.origin:void 0,t.$r=$,t.$s=b,t.$t=A,t.$u=D,t.$v=h,t.$w=e;var T;(function(W){function O(){return t.$w}W.value=O;function B(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}W.isDefaultVariant=B;function z(){return t.$w==="en"}W.isDefault=z})(T||(t.Language=T={})),t.$x=m,t.$y=s,t.$z=o,t.$A=typeof c.postMessage=="function"&&!c.importScripts,t.$B=(()=>{if(t.$A){const W=[];c.addEventListener("message",B=>{if(B.data&&B.data.vscodeScheduleAsyncWork)for(let z=0,J=W.length;z<J;z++){const X=W[z];if(X.id===B.data.vscodeScheduleAsyncWork){W.splice(z,1),X.callback();return}}});let O=0;return B=>{const z=++O;W.push({id:z,callback:B}),c.postMessage({vscodeScheduleAsyncWork:z},"*")}}return W=>setTimeout(W)})();var U;(function(W){W[W.Windows=1]="Windows",W[W.Macintosh=2]="Macintosh",W[W.Linux=3]="Linux"})(U||(t.OperatingSystem=U={})),t.OS=M||$?U.Macintosh:n?U.Windows:U.Linux;let _=!0,H=!1;function w(){if(!H){H=!0;const W=new Uint8Array(2);W[0]=1,W[1]=2,_=new Uint16Array(W.buffer)[0]===513}return _}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function C(W){return parseFloat(W)>=20}}),define(we[69],ve([1,0,19,25,5]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eS=t.KeyboardSupport=void 0,i=We(i),M=We(M);var R;(function(L){L[L.Always=0]="Always",L[L.FullScreen=1]="FullScreen",L[L.None=2]="None"})(R||(t.KeyboardSupport=R={})),t.$eS={clipboard:{writeText:M.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:M.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:M.$m||i.$cS()?R.Always:navigator.keyboard||i.$$R?R.FullScreen:R.None,touch:"ontouchstart"in n.$VR||navigator.maxTouchPoints>0,pointerEvents:n.$VR.PointerEvent&&("ontouchstart"in n.$VR||navigator.maxTouchPoints>0)}}),define(we[23],ve([1,0,19,86,5]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jS=t.$iS=t.$hS=void 0,i=We(i),M=We(M);class R{constructor(f,$){this.timestamp=Date.now(),this.browserEvent=$,this.leftButton=$.button===0,this.middleButton=$.button===1,this.rightButton=$.button===2,this.buttons=$.buttons,this.target=$.target,this.detail=$.detail||1,$.type==="dblclick"&&(this.detail=2),this.ctrlKey=$.ctrlKey,this.shiftKey=$.shiftKey,this.altKey=$.altKey,this.metaKey=$.metaKey,typeof $.pageX=="number"?(this.posx=$.pageX,this.posy=$.pageY):(this.posx=$.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=$.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const A=n.$fS.getPositionOfChildWindowRelativeToAncestorWindow(f,$.view);this.posx-=A.left,this.posy-=A.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$hS=R;class L extends R{constructor(f,$){super(f,$),this.dataTransfer=$.dataTransfer}}t.$iS=L;class v{constructor(f,$=0,A=0){this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=A,this.deltaX=$;let b=!1;if(i.$0R){const m=navigator.userAgent.match(/Chrome\/(\d+)/);b=(m?parseInt(m[1]):123)<=122}if(f){const m=f,e=f,s=f.view?.devicePixelRatio||1;if(typeof m.wheelDeltaY<"u")b?this.deltaY=m.wheelDeltaY/(120*s):this.deltaY=m.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const o=f;o.deltaMode===o.DOM_DELTA_LINE?i.$8R&&!M.$j?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof m.wheelDeltaX<"u")i.$$R&&M.$i?this.deltaX=-(m.wheelDeltaX/120):b?this.deltaX=m.wheelDeltaX/(120*s):this.deltaX=m.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const o=f;o.deltaMode===o.DOM_DELTA_LINE?i.$8R&&!M.$j?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(b?this.deltaY=f.wheelDelta/(120*s):this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$jS=v}),define(we[132],ve([1,0,6,8,5]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zr=t.$Yr=t.$Xr=t.$Wr=t.$Vr=void 0,t.$Tr=L,t.$Ur=v;var R;(function(m){m[m.CtrlCmd=2048]="CtrlCmd",m[m.Shift=1024]="Shift",m[m.Alt=512]="Alt",m[m.WinCtrl=256]="WinCtrl",m[m.KeyCode=255]="KeyCode"})(R||(R={}));function L(m,e){if(typeof m=="number"){if(m===0)return null;const s=(m&65535)>>>0,o=(m&4294901760)>>>16;return o!==0?new $([v(s,e),v(o,e)]):new $([v(s,e)])}else{const s=[];for(let o=0;o<m.length;o++)s.push(v(m[o],e));return new $(s)}}function v(m,e){const s=!!(m&R.CtrlCmd),o=!!(m&R.WinCtrl),h=e===M.OperatingSystem.Macintosh?o:s,c=!!(m&R.Shift),p=!!(m&R.Alt),k=e===M.OperatingSystem.Macintosh?s:o,y=m&R.KeyCode;return new E(h,c,p,k,y)}class E{constructor(e,s,o,h,c){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.keyCode=c}equals(e){return e instanceof E&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.keyCode===e.keyCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${e}${s}${o}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===n.KeyCode.Unknown||this.keyCode===n.KeyCode.Ctrl||this.keyCode===n.KeyCode.Meta||this.keyCode===n.KeyCode.Alt||this.keyCode===n.KeyCode.Shift}toKeybinding(){return new $([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===n.KeyCode.Ctrl||this.shiftKey&&this.keyCode===n.KeyCode.Shift||this.altKey&&this.keyCode===n.KeyCode.Alt||this.metaKey&&this.keyCode===n.KeyCode.Meta}}t.$Vr=E;class f{constructor(e,s,o,h,c){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.scanCode=c}equals(e){return e instanceof f&&this.ctrlKey===e.ctrlKey&&this.shiftKey===e.shiftKey&&this.altKey===e.altKey&&this.metaKey===e.metaKey&&this.scanCode===e.scanCode}getHashCode(){const e=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",o=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${e}${s}${o}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===n.ScanCode.ControlLeft||this.scanCode===n.ScanCode.ControlRight)||this.shiftKey&&(this.scanCode===n.ScanCode.ShiftLeft||this.scanCode===n.ScanCode.ShiftRight)||this.altKey&&(this.scanCode===n.ScanCode.AltLeft||this.scanCode===n.ScanCode.AltRight)||this.metaKey&&(this.scanCode===n.ScanCode.MetaLeft||this.scanCode===n.ScanCode.MetaRight)}}t.$Wr=f;class ${constructor(e){if(e.length===0)throw(0,i.$9)("chords");this.chords=e}getHashCode(){let e="";for(let s=0,o=this.chords.length;s<o;s++)s!==0&&(e+=";"),e+=this.chords[s].getHashCode();return e}equals(e){if(e===null||this.chords.length!==e.chords.length)return!1;for(let s=0;s<this.chords.length;s++)if(!this.chords[s].equals(e.chords[s]))return!1;return!0}}t.$Xr=$;class A{constructor(e,s,o,h,c,p){this.ctrlKey=e,this.shiftKey=s,this.altKey=o,this.metaKey=h,this.keyLabel=c,this.keyAriaLabel=p}}t.$Yr=A;class b{}t.$Zr=b}),define(we[16],ve([1,0,19,8,132,5]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mS=void 0,t.$kS=A,t.$lS=b,i=We(i),R=We(R);function L(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return n.KeyCodeUtils.fromString(o)}const s=e.keyCode;if(s===3)return n.KeyCode.PauseBreak;if(i.$8R)switch(s){case 59:return n.KeyCode.Semicolon;case 60:if(R.$k)return n.KeyCode.IntlBackslash;break;case 61:return n.KeyCode.Equal;case 107:return n.KeyCode.NumpadAdd;case 109:return n.KeyCode.NumpadSubtract;case 173:return n.KeyCode.Minus;case 224:if(R.$j)return n.KeyCode.Meta;break}else if(i.$9R){if(R.$j&&s===93)return n.KeyCode.Meta;if(!R.$j&&s===92)return n.KeyCode.Meta}return n.$Nr[s]||n.KeyCode.Unknown}const v=R.$j?n.KeyMod.WinCtrl:n.KeyMod.CtrlCmd,E=n.KeyMod.Alt,f=n.KeyMod.Shift,$=R.$j?n.KeyMod.CtrlCmd:n.KeyMod.WinCtrl;function A(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function b(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${n.KeyCodeUtils.toString(e.keyCode)}')`}class m{constructor(s){this._standardKeyboardEventBrand=!0;const o=s;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=L(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===n.KeyCode.Ctrl,this.altKey=this.altKey||this.keyCode===n.KeyCode.Alt,this.shiftKey=this.shiftKey||this.keyCode===n.KeyCode.Shift,this.metaKey=this.metaKey||this.keyCode===n.KeyCode.Meta,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=n.KeyCode.Unknown;this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode);let o=0;return this.ctrlKey&&(o|=v),this.altKey&&(o|=E),this.shiftKey&&(o|=f),this.metaKey&&(o|=$),o|=s,o}d(){let s=n.KeyCode.Unknown;return this.keyCode!==n.KeyCode.Ctrl&&this.keyCode!==n.KeyCode.Shift&&this.keyCode!==n.KeyCode.Alt&&this.keyCode!==n.KeyCode.Meta&&(s=this.keyCode),new M.$Vr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$mS=m}),define(we[133],ve([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gc=t.$fc=t.env=t.cwd=void 0;let n;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const R=M.process;n={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=n.cwd,t.env=n.env,t.$fc=n.platform,t.$gc=n.arch}),define(we[30],ve([1,0,133]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.sep=t.$tc=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=void 0,i=We(i);const n=65,M=97,R=90,L=122,v=46,E=47,f=92,$=58,A=63;class b extends Error{constructor(d,D,T){let U;typeof D=="string"&&D.indexOf("not ")===0?(U="must not be",D=D.replace(/^not /,"")):U="must be";const _=d.indexOf(".")!==-1?"property":"argument";let H=`The "${d}" ${_} ${U} of type ${D}`;H+=`. Received type ${typeof T}`,super(H),this.code="ERR_INVALID_ARG_TYPE"}}function m(r,d){if(r===null||typeof r!="object")throw new b(d,"Object",r)}function e(r,d){if(typeof r!="string")throw new b(d,"string",r)}const s=i.$fc==="win32";function o(r){return r===E||r===f}function h(r){return r===E}function c(r){return r>=n&&r<=R||r>=M&&r<=L}function p(r,d,D,T){let U="",_=0,H=-1,w=0,C=0;for(let W=0;W<=r.length;++W){if(W<r.length)C=r.charCodeAt(W);else{if(T(C))break;C=E}if(T(C)){if(!(H===W-1||w===1))if(w===2){if(U.length<2||_!==2||U.charCodeAt(U.length-1)!==v||U.charCodeAt(U.length-2)!==v){if(U.length>2){const O=U.lastIndexOf(D);O===-1?(U="",_=0):(U=U.slice(0,O),_=U.length-1-U.lastIndexOf(D)),H=W,w=0;continue}else if(U.length!==0){U="",_=0,H=W,w=0;continue}}d&&(U+=U.length>0?`${D}..`:"..",_=2)}else U.length>0?U+=`${D}${r.slice(H+1,W)}`:U=r.slice(H+1,W),_=W-H-1;H=W,w=0}else C===v&&w!==-1?++w:w=-1}return U}function k(r,d){m(d,"pathObject");const D=d.dir||d.root,T=d.base||`${d.name||""}${d.ext||""}`;return D?D===d.root?`${D}${T}`:`${D}${r}${T}`:T}t.$hc={resolve(...r){let d="",D="",T=!1;for(let U=r.length-1;U>=-1;U--){let _;if(U>=0){if(_=r[U],e(_,"path"),_.length===0)continue}else d.length===0?_=i.cwd():(_=i.env[`=${d}`]||i.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==d.toLowerCase()&&_.charCodeAt(2)===f)&&(_=`${d}\\`));const H=_.length;let w=0,C="",W=!1;const O=_.charCodeAt(0);if(H===1)o(O)&&(w=1,W=!0);else if(o(O))if(W=!0,o(_.charCodeAt(1))){let B=2,z=B;for(;B<H&&!o(_.charCodeAt(B));)B++;if(B<H&&B!==z){const J=_.slice(z,B);for(z=B;B<H&&o(_.charCodeAt(B));)B++;if(B<H&&B!==z){for(z=B;B<H&&!o(_.charCodeAt(B));)B++;(B===H||B!==z)&&(C=`\\\\${J}\\${_.slice(z,B)}`,w=B)}}}else w=1;else c(O)&&_.charCodeAt(1)===$&&(C=_.slice(0,2),w=2,H>2&&o(_.charCodeAt(2))&&(W=!0,w=3));if(C.length>0)if(d.length>0){if(C.toLowerCase()!==d.toLowerCase())continue}else d=C;if(T){if(d.length>0)break}else if(D=`${_.slice(w)}\\${D}`,T=W,W&&d.length>0)break}return D=p(D,!T,"\\",o),T?`${d}\\${D}`:`${d}${D}`||"."},normalize(r){e(r,"path");const d=r.length;if(d===0)return".";let D=0,T,U=!1;const _=r.charCodeAt(0);if(d===1)return h(_)?"\\":r;if(o(_))if(U=!0,o(r.charCodeAt(1))){let w=2,C=w;for(;w<d&&!o(r.charCodeAt(w));)w++;if(w<d&&w!==C){const W=r.slice(C,w);for(C=w;w<d&&o(r.charCodeAt(w));)w++;if(w<d&&w!==C){for(C=w;w<d&&!o(r.charCodeAt(w));)w++;if(w===d)return`\\\\${W}\\${r.slice(C)}\\`;w!==C&&(T=`\\\\${W}\\${r.slice(C,w)}`,D=w)}}}else D=1;else c(_)&&r.charCodeAt(1)===$&&(T=r.slice(0,2),D=2,d>2&&o(r.charCodeAt(2))&&(U=!0,D=3));let H=D<d?p(r.slice(D),!U,"\\",o):"";return H.length===0&&!U&&(H="."),H.length>0&&o(r.charCodeAt(d-1))&&(H+="\\"),T===void 0?U?`\\${H}`:H:U?`${T}\\${H}`:`${T}${H}`},isAbsolute(r){e(r,"path");const d=r.length;if(d===0)return!1;const D=r.charCodeAt(0);return o(D)||d>2&&c(D)&&r.charCodeAt(1)===$&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let d,D;for(let _=0;_<r.length;++_){const H=r[_];e(H,"path"),H.length>0&&(d===void 0?d=D=H:d+=`\\${H}`)}if(d===void 0)return".";let T=!0,U=0;if(typeof D=="string"&&o(D.charCodeAt(0))){++U;const _=D.length;_>1&&o(D.charCodeAt(1))&&(++U,_>2&&(o(D.charCodeAt(2))?++U:T=!1))}if(T){for(;U<d.length&&o(d.charCodeAt(U));)U++;U>=2&&(d=`\\${d.slice(U)}`)}return t.$hc.normalize(d)},relative(r,d){if(e(r,"from"),e(d,"to"),r===d)return"";const D=t.$hc.resolve(r),T=t.$hc.resolve(d);if(D===T||(r=D.toLowerCase(),d=T.toLowerCase(),r===d))return"";let U=0;for(;U<r.length&&r.charCodeAt(U)===f;)U++;let _=r.length;for(;_-1>U&&r.charCodeAt(_-1)===f;)_--;const H=_-U;let w=0;for(;w<d.length&&d.charCodeAt(w)===f;)w++;let C=d.length;for(;C-1>w&&d.charCodeAt(C-1)===f;)C--;const W=C-w,O=H<W?H:W;let B=-1,z=0;for(;z<O;z++){const X=r.charCodeAt(U+z);if(X!==d.charCodeAt(w+z))break;X===f&&(B=z)}if(z!==O){if(B===-1)return T}else{if(W>O){if(d.charCodeAt(w+z)===f)return T.slice(w+z+1);if(z===2)return T.slice(w+z)}H>O&&(r.charCodeAt(U+z)===f?B=z:z===2&&(B=3)),B===-1&&(B=0)}let J="";for(z=U+B+1;z<=_;++z)(z===_||r.charCodeAt(z)===f)&&(J+=J.length===0?"..":"\\..");return w+=B,J.length>0?`${J}${T.slice(w,C)}`:(T.charCodeAt(w)===f&&++w,T.slice(w,C))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const d=t.$hc.resolve(r);if(d.length<=2)return r;if(d.charCodeAt(0)===f){if(d.charCodeAt(1)===f){const D=d.charCodeAt(2);if(D!==A&&D!==v)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(c(d.charCodeAt(0))&&d.charCodeAt(1)===$&&d.charCodeAt(2)===f)return`\\\\?\\${d}`;return r},dirname(r){e(r,"path");const d=r.length;if(d===0)return".";let D=-1,T=0;const U=r.charCodeAt(0);if(d===1)return o(U)?r:".";if(o(U)){if(D=T=1,o(r.charCodeAt(1))){let w=2,C=w;for(;w<d&&!o(r.charCodeAt(w));)w++;if(w<d&&w!==C){for(C=w;w<d&&o(r.charCodeAt(w));)w++;if(w<d&&w!==C){for(C=w;w<d&&!o(r.charCodeAt(w));)w++;if(w===d)return r;w!==C&&(D=T=w+1)}}}}else c(U)&&r.charCodeAt(1)===$&&(D=d>2&&o(r.charCodeAt(2))?3:2,T=D);let _=-1,H=!0;for(let w=d-1;w>=T;--w)if(o(r.charCodeAt(w))){if(!H){_=w;break}}else H=!1;if(_===-1){if(D===-1)return".";_=D}return r.slice(0,_)},basename(r,d){d!==void 0&&e(d,"ext"),e(r,"path");let D=0,T=-1,U=!0,_;if(r.length>=2&&c(r.charCodeAt(0))&&r.charCodeAt(1)===$&&(D=2),d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let H=d.length-1,w=-1;for(_=r.length-1;_>=D;--_){const C=r.charCodeAt(_);if(o(C)){if(!U){D=_+1;break}}else w===-1&&(U=!1,w=_+1),H>=0&&(C===d.charCodeAt(H)?--H===-1&&(T=_):(H=-1,T=w))}return D===T?T=w:T===-1&&(T=r.length),r.slice(D,T)}for(_=r.length-1;_>=D;--_)if(o(r.charCodeAt(_))){if(!U){D=_+1;break}}else T===-1&&(U=!1,T=_+1);return T===-1?"":r.slice(D,T)},extname(r){e(r,"path");let d=0,D=-1,T=0,U=-1,_=!0,H=0;r.length>=2&&r.charCodeAt(1)===$&&c(r.charCodeAt(0))&&(d=T=2);for(let w=r.length-1;w>=d;--w){const C=r.charCodeAt(w);if(o(C)){if(!_){T=w+1;break}continue}U===-1&&(_=!1,U=w+1),C===v?D===-1?D=w:H!==1&&(H=1):D!==-1&&(H=-1)}return D===-1||U===-1||H===0||H===1&&D===U-1&&D===T+1?"":r.slice(D,U)},format:k.bind(null,"\\"),parse(r){e(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const D=r.length;let T=0,U=r.charCodeAt(0);if(D===1)return o(U)?(d.root=d.dir=r,d):(d.base=d.name=r,d);if(o(U)){if(T=1,o(r.charCodeAt(1))){let B=2,z=B;for(;B<D&&!o(r.charCodeAt(B));)B++;if(B<D&&B!==z){for(z=B;B<D&&o(r.charCodeAt(B));)B++;if(B<D&&B!==z){for(z=B;B<D&&!o(r.charCodeAt(B));)B++;B===D?T=B:B!==z&&(T=B+1)}}}}else if(c(U)&&r.charCodeAt(1)===$){if(D<=2)return d.root=d.dir=r,d;if(T=2,o(r.charCodeAt(2))){if(D===3)return d.root=d.dir=r,d;T=3}}T>0&&(d.root=r.slice(0,T));let _=-1,H=T,w=-1,C=!0,W=r.length-1,O=0;for(;W>=T;--W){if(U=r.charCodeAt(W),o(U)){if(!C){H=W+1;break}continue}w===-1&&(C=!1,w=W+1),U===v?_===-1?_=W:O!==1&&(O=1):_!==-1&&(O=-1)}return w!==-1&&(_===-1||O===0||O===1&&_===w-1&&_===H+1?d.base=d.name=r.slice(H,w):(d.name=r.slice(H,_),d.base=r.slice(H,w),d.ext=r.slice(_,w))),H>0&&H!==T?d.dir=r.slice(0,H-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null};const y=(()=>{if(s){const r=/\\/g;return()=>{const d=i.cwd().replace(r,"/");return d.slice(d.indexOf("/"))}}return()=>i.cwd()})();t.$ic={resolve(...r){let d="",D=!1;for(let T=r.length-1;T>=-1&&!D;T--){const U=T>=0?r[T]:y();e(U,"path"),U.length!==0&&(d=`${U}/${d}`,D=U.charCodeAt(0)===E)}return d=p(d,!D,"/",h),D?`/${d}`:d.length>0?d:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===E,D=r.charCodeAt(r.length-1)===E;return r=p(r,!d,"/",h),r.length===0?d?"/":D?"./":".":(D&&(r+="/"),d?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===E},join(...r){if(r.length===0)return".";let d;for(let D=0;D<r.length;++D){const T=r[D];e(T,"path"),T.length>0&&(d===void 0?d=T:d+=`/${T}`)}return d===void 0?".":t.$ic.normalize(d)},relative(r,d){if(e(r,"from"),e(d,"to"),r===d||(r=t.$ic.resolve(r),d=t.$ic.resolve(d),r===d))return"";const D=1,T=r.length,U=T-D,_=1,H=d.length-_,w=U<H?U:H;let C=-1,W=0;for(;W<w;W++){const B=r.charCodeAt(D+W);if(B!==d.charCodeAt(_+W))break;B===E&&(C=W)}if(W===w)if(H>w){if(d.charCodeAt(_+W)===E)return d.slice(_+W+1);if(W===0)return d.slice(_+W)}else U>w&&(r.charCodeAt(D+W)===E?C=W:W===0&&(C=0));let O="";for(W=D+C+1;W<=T;++W)(W===T||r.charCodeAt(W)===E)&&(O+=O.length===0?"..":"/..");return`${O}${d.slice(_+C)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const d=r.charCodeAt(0)===E;let D=-1,T=!0;for(let U=r.length-1;U>=1;--U)if(r.charCodeAt(U)===E){if(!T){D=U;break}}else T=!1;return D===-1?d?"/":".":d&&D===1?"//":r.slice(0,D)},basename(r,d){d!==void 0&&e(d,"ext"),e(r,"path");let D=0,T=-1,U=!0,_;if(d!==void 0&&d.length>0&&d.length<=r.length){if(d===r)return"";let H=d.length-1,w=-1;for(_=r.length-1;_>=0;--_){const C=r.charCodeAt(_);if(C===E){if(!U){D=_+1;break}}else w===-1&&(U=!1,w=_+1),H>=0&&(C===d.charCodeAt(H)?--H===-1&&(T=_):(H=-1,T=w))}return D===T?T=w:T===-1&&(T=r.length),r.slice(D,T)}for(_=r.length-1;_>=0;--_)if(r.charCodeAt(_)===E){if(!U){D=_+1;break}}else T===-1&&(U=!1,T=_+1);return T===-1?"":r.slice(D,T)},extname(r){e(r,"path");let d=-1,D=0,T=-1,U=!0,_=0;for(let H=r.length-1;H>=0;--H){const w=r.charCodeAt(H);if(w===E){if(!U){D=H+1;break}continue}T===-1&&(U=!1,T=H+1),w===v?d===-1?d=H:_!==1&&(_=1):d!==-1&&(_=-1)}return d===-1||T===-1||_===0||_===1&&d===T-1&&d===D+1?"":r.slice(d,T)},format:k.bind(null,"/"),parse(r){e(r,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return d;const D=r.charCodeAt(0)===E;let T;D?(d.root="/",T=1):T=0;let U=-1,_=0,H=-1,w=!0,C=r.length-1,W=0;for(;C>=T;--C){const O=r.charCodeAt(C);if(O===E){if(!w){_=C+1;break}continue}H===-1&&(w=!1,H=C+1),O===v?U===-1?U=C:W!==1&&(W=1):U!==-1&&(W=-1)}if(H!==-1){const O=_===0&&D?1:_;U===-1||W===0||W===1&&U===H-1&&U===_+1?d.base=d.name=r.slice(O,H):(d.name=r.slice(O,U),d.base=r.slice(O,H),d.ext=r.slice(U,H))}return _>0?d.dir=r.slice(0,_-1):D&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},t.$ic.win32=t.$hc.win32=t.$hc,t.$ic.posix=t.$hc.posix=t.$ic,t.$jc=s?t.$hc.normalize:t.$ic.normalize,t.$kc=s?t.$hc.isAbsolute:t.$ic.isAbsolute,t.$lc=s?t.$hc.join:t.$ic.join,t.$mc=s?t.$hc.resolve:t.$ic.resolve,t.$nc=s?t.$hc.relative:t.$ic.relative,t.$oc=s?t.$hc.dirname:t.$ic.dirname,t.$pc=s?t.$hc.basename:t.$ic.basename,t.$qc=s?t.$hc.extname:t.$ic.extname,t.$rc=s?t.$hc.format:t.$ic.format,t.$sc=s?t.$hc.parse:t.$ic.parse,t.$tc=s?t.$hc.toNamespacedPath:t.$ic.toNamespacedPath,t.sep=s?t.$hc.sep:t.$ic.sep,t.$vc=s?t.$hc.delimiter:t.$ic.delimiter}),define(we[134],ve([1,0,18,30,5,11,10]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xg=v,t.$yg=E,t.$zg=f,t.$Ag=$,t.$Bg=A,t.$Cg=s,t.$Dg=o,t.$Eg=h,t.$Fg=c,t.$Gg=p,t.$Hg=k,t.$Ig=y,t.$Jg=r,t.$Kg=d,t.$Lg=D,t.$Mg=T,t.$Ng=H;function v(w){return w===i.CharCode.Slash||w===i.CharCode.Backslash}function E(w){return w.replace(/[\\/]/g,n.$ic.sep)}function f(w){return w.indexOf("/")===-1&&(w=E(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function $(w,C=n.$ic.sep){if(!w)return"";const W=w.length,O=w.charCodeAt(0);if(v(O)){if(v(w.charCodeAt(1))&&!v(w.charCodeAt(2))){let z=3;const J=z;for(;z<W&&!v(w.charCodeAt(z));z++);if(J!==z&&!v(w.charCodeAt(z+1))){for(z+=1;z<W;z++)if(v(w.charCodeAt(z)))return w.slice(0,z+1).replace(/[\\/]/g,C)}}return C}else if(c(O)&&w.charCodeAt(1)===i.CharCode.Colon)return v(w.charCodeAt(2))?w.slice(0,2)+C:w.slice(0,2);let B=w.indexOf("://");if(B!==-1){for(B+=3;B<W;B++)if(v(w.charCodeAt(B)))return w.slice(0,B+1)}return""}function A(w){if(!M.$i||!w||w.length<5)return!1;let C=w.charCodeAt(0);if(C!==i.CharCode.Backslash||(C=w.charCodeAt(1),C!==i.CharCode.Backslash))return!1;let W=2;const O=W;for(;W<w.length&&(C=w.charCodeAt(W),C!==i.CharCode.Backslash);W++);return!(O===W||(C=w.charCodeAt(W+1),isNaN(C)||C===i.CharCode.Backslash))}const b=/[\\/:\*\?"<>\|]/g,m=/[/]/g,e=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(w,C=M.$i){const W=C?b:m;return!(!w||w.length===0||/^\s+$/.test(w)||(W.lastIndex=0,W.test(w))||C&&e.test(w)||w==="."||w===".."||C&&w[w.length-1]==="."||C&&w.length!==w.trim().length||w.length>255)}function o(w,C,W){const O=w===C;return!W||O?O:!w||!C?!1:(0,R.$Gf)(w,C)}function h(w,C,W,O=n.sep){if(w===C)return!0;if(!w||!C||C.length>w.length)return!1;if(W){if(!(0,R.$Hf)(w,C))return!1;if(C.length===w.length)return!0;let z=C.length;return C.charAt(C.length-1)===O&&z--,w.charAt(z)===O}return C.charAt(C.length-1)!==O&&(C+=O),w.indexOf(C)===0}function c(w){return w>=i.CharCode.A&&w<=i.CharCode.Z||w>=i.CharCode.a&&w<=i.CharCode.z}function p(w,C){return M.$i&&w.endsWith(":")&&(w+=n.sep),(0,n.$kc)(w)||(w=(0,n.$lc)(C,w)),w=(0,n.$jc)(w),k(w)}function k(w){return M.$i?(w=(0,R.$of)(w,n.sep),w.endsWith(":")&&(w+=n.sep)):(w=(0,R.$of)(w,n.sep),w||(w=n.sep)),w}function y(w){const C=(0,n.$jc)(w);return M.$i?w.length>3?!1:r(C)&&(w.length===2||C.charCodeAt(2)===i.CharCode.Backslash):C===n.$ic.sep}function r(w,C=M.$i){return C?c(w.charCodeAt(0))&&w.charCodeAt(1)===i.CharCode.Colon:!1}function d(w,C=M.$i){return r(w,C)?w[0]:void 0}function D(w,C,W){return C.length>w.length?-1:w===C?0:(W&&(w=w.toLowerCase(),C=C.toLowerCase()),w.indexOf(C))}function T(w){const C=w.split(":");let W,O,B;for(const z of C){const J=Number(z);(0,L.$jg)(J)?O===void 0?O=J:B===void 0&&(B=J):W=W?[W,z].join(":"):z}if(!W)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:W,line:O!==void 0?O:void 0,column:B!==void 0?B:O!==void 0?1:void 0}}const U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",_="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function H(w,C,W=8){let O="";for(let z=0;z<W;z++){let J;z===0&&M.$i&&!C&&(W===3||W===4)?J=_:J=U,O+=J.charAt(Math.floor(Math.random()*J.length))}let B;return C?B=`${C}-${O}`:B=O,w?(0,n.$lc)(w,B):B}}),define(we[135],ve([1,0,30]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5s=void 0,t.$6s=R,t.$7s=L,t.$8s=v,t.$9s=f,t.$5s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R($){const A=(0,i.$qc)($),b=n[A.toLowerCase()];return b!==void 0?b:L($)}function L($){const A=(0,i.$qc)($);return M[A.toLowerCase()]}function v($){for(const A in M)if(M[A]===$)return A}const E=/^(.+)\/(.+?)(;.+)?$/;function f($,A){const b=E.exec($);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:A?void 0:$}}),define(we[17],ve([1,0,18,61,30,5]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$xc=o,t.$yc=r,M=We(M);const L=/^\w[\w\d+.-]*$/,v=/^\//,E=/^\/\//;function f(_,H){if(!_.scheme&&H)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!L.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!v.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(E.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(_,H){return!_&&!H?"file":_}function A(_,H){switch(_){case"https":case"http":case"file":H?H[0]!==m&&(H=m+H):H=m;break}return H}const b="",m="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(H){return H instanceof s?!0:H?typeof H.authority=="string"&&typeof H.fragment=="string"&&typeof H.path=="string"&&typeof H.query=="string"&&typeof H.scheme=="string"&&typeof H.fsPath=="string"&&typeof H.with=="function"&&typeof H.toString=="function":!1}constructor(H,w,C,W,O,B=!1){typeof H=="object"?(this.scheme=H.scheme||b,this.authority=H.authority||b,this.path=H.path||b,this.query=H.query||b,this.fragment=H.fragment||b):(this.scheme=$(H,B),this.authority=w||b,this.path=A(this.scheme,C||b),this.query=W||b,this.fragment=O||b,f(this,B))}get fsPath(){return r(this,!1)}with(H){if(!H)return this;let{scheme:w,authority:C,path:W,query:O,fragment:B}=H;return w===void 0?w=this.scheme:w===null&&(w=b),C===void 0?C=this.authority:C===null&&(C=b),W===void 0?W=this.path:W===null&&(W=b),O===void 0?O=this.query:O===null&&(O=b),B===void 0?B=this.fragment:B===null&&(B=b),w===this.scheme&&C===this.authority&&W===this.path&&O===this.query&&B===this.fragment?this:new c(w,C,W,O,B)}static parse(H,w=!1){const C=e.exec(H);return C?new c(C[2]||b,U(C[4]||b),U(C[5]||b),U(C[7]||b),U(C[9]||b),w):new c(b,b,b,b,b)}static file(H){let w=b;if(R.$i&&(H=H.replace(/\\/g,m)),H[0]===m&&H[1]===m){const C=H.indexOf(m,2);C===-1?(w=H.substring(2),H=m):(w=H.substring(2,C),H=H.substring(C)||m)}return new c("file",w,H,b,b)}static from(H,w){return new c(H.scheme,H.authority,H.path,H.query,H.fragment,w)}static joinPath(H,...w){if(!H.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return R.$i&&H.scheme==="file"?C=s.file(M.$hc.join(r(H,!0),...w)).path:C=M.$ic.join(H.path,...w),H.with({path:C})}toString(H=!1){return d(this,H)}toJSON(){return this}static revive(H){if(H){if(H instanceof s)return H;{const w=new c(H);return w._formatted=H.external??null,w._fsPath=H._sep===h?H.fsPath??null:null,w}}else return H}}t.URI=s;function o(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const h=R.$i?1:void 0;class c extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(H=!1){return H?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const H={$mid:n.MarshalledId.Uri};return this._fsPath&&(H.fsPath=this._fsPath,H._sep=h),this._formatted&&(H.external=this._formatted),this.path&&(H.path=this.path),this.scheme&&(H.scheme=this.scheme),this.authority&&(H.authority=this.authority),this.query&&(H.query=this.query),this.fragment&&(H.fragment=this.fragment),H}}const p={[i.CharCode.Colon]:"%3A",[i.CharCode.Slash]:"%2F",[i.CharCode.QuestionMark]:"%3F",[i.CharCode.Hash]:"%23",[i.CharCode.OpenSquareBracket]:"%5B",[i.CharCode.CloseSquareBracket]:"%5D",[i.CharCode.AtSign]:"%40",[i.CharCode.ExclamationMark]:"%21",[i.CharCode.DollarSign]:"%24",[i.CharCode.Ampersand]:"%26",[i.CharCode.SingleQuote]:"%27",[i.CharCode.OpenParen]:"%28",[i.CharCode.CloseParen]:"%29",[i.CharCode.Asterisk]:"%2A",[i.CharCode.Plus]:"%2B",[i.CharCode.Comma]:"%2C",[i.CharCode.Semicolon]:"%3B",[i.CharCode.Equals]:"%3D",[i.CharCode.Space]:"%20"};function k(_,H,w){let C,W=-1;for(let O=0;O<_.length;O++){const B=_.charCodeAt(O);if(B>=i.CharCode.a&&B<=i.CharCode.z||B>=i.CharCode.A&&B<=i.CharCode.Z||B>=i.CharCode.Digit0&&B<=i.CharCode.Digit9||B===i.CharCode.Dash||B===i.CharCode.Period||B===i.CharCode.Underline||B===i.CharCode.Tilde||H&&B===i.CharCode.Slash||w&&B===i.CharCode.OpenSquareBracket||w&&B===i.CharCode.CloseSquareBracket||w&&B===i.CharCode.Colon)W!==-1&&(C+=encodeURIComponent(_.substring(W,O)),W=-1),C!==void 0&&(C+=_.charAt(O));else{C===void 0&&(C=_.substr(0,O));const z=p[B];z!==void 0?(W!==-1&&(C+=encodeURIComponent(_.substring(W,O)),W=-1),C+=z):W===-1&&(W=O)}}return W!==-1&&(C+=encodeURIComponent(_.substring(W))),C!==void 0?C:_}function y(_){let H;for(let w=0;w<_.length;w++){const C=_.charCodeAt(w);C===i.CharCode.Hash||C===i.CharCode.QuestionMark?(H===void 0&&(H=_.substr(0,w)),H+=p[C]):H!==void 0&&(H+=_[w])}return H!==void 0?H:_}function r(_,H){let w;return _.authority&&_.path.length>1&&_.scheme==="file"?w=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===i.CharCode.Slash&&(_.path.charCodeAt(1)>=i.CharCode.A&&_.path.charCodeAt(1)<=i.CharCode.Z||_.path.charCodeAt(1)>=i.CharCode.a&&_.path.charCodeAt(1)<=i.CharCode.z)&&_.path.charCodeAt(2)===i.CharCode.Colon?H?w=_.path.substr(1):w=_.path[1].toLowerCase()+_.path.substr(2):w=_.path,R.$i&&(w=w.replace(/\//g,"\\")),w}function d(_,H){const w=H?y:k;let C="",{scheme:W,authority:O,path:B,query:z,fragment:J}=_;if(W&&(C+=W,C+=":"),(O||W==="file")&&(C+=m,C+=m),O){let X=O.indexOf("@");if(X!==-1){const K=O.substr(0,X);O=O.substr(X+1),X=K.lastIndexOf(":"),X===-1?C+=w(K,!1,!1):(C+=w(K.substr(0,X),!1,!1),C+=":",C+=w(K.substr(X+1),!1,!0)),C+="@"}O=O.toLowerCase(),X=O.lastIndexOf(":"),X===-1?C+=w(O,!1,!0):(C+=w(O.substr(0,X),!1,!0),C+=O.substr(X))}if(B){if(B.length>=3&&B.charCodeAt(0)===i.CharCode.Slash&&B.charCodeAt(2)===i.CharCode.Colon){const X=B.charCodeAt(1);X>=i.CharCode.A&&X<=i.CharCode.Z&&(B=`/${String.fromCharCode(X+32)}:${B.substr(3)}`)}else if(B.length>=2&&B.charCodeAt(1)===i.CharCode.Colon){const X=B.charCodeAt(0);X>=i.CharCode.A&&X<=i.CharCode.Z&&(B=`${String.fromCharCode(X+32)}:${B.substr(2)}`)}C+=w(B,!0,!1)}return z&&(C+="?",C+=w(z,!1,!1)),J&&(C+="#",C+=H?J:k(J,!1,!1)),C}function D(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+D(_.substr(3)):_}}const T=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function U(_){return _.match(T)?_.replace(T,H=>D(H)):_}}),define(we[70],ve([1,0,48,17,61]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ai=R,t.$bi=L,t.$ci=E;function R(f){return JSON.stringify(f,v)}function L(f){let $=JSON.parse(f);return $=E($),$}function v(f,$){return $ instanceof RegExp?{$mid:M.MarshalledId.Regexp,source:$.source,flags:$.flags}:$}function E(f,$=0){if(!f||$>200)return f;if(typeof f=="object"){switch(f.$mid){case M.MarshalledId.Uri:return n.URI.revive(f);case M.MarshalledId.Regexp:return new RegExp(f.source,f.flags);case M.MarshalledId.Date:return new Date(f.source)}if(f instanceof i.$Oe||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let A=0;A<f.length;++A)f[A]=E(f[A],$+1);else for(const A in f)Object.hasOwnProperty.call(f,A)&&(f[A]=E(f[A],$+1))}return f}}),define(we[41],ve([1,0,6,5,11,17,30]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Sg=t.$Rg=t.$Qg=t.Schemas=void 0,t.$Og=E,t.$Pg=f,t.$Tg=A,i=We(i),n=We(n),L=We(L);var v;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",e.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(v||(t.Schemas=v={}));function E(e,s){return R.URI.isUri(e)?(0,M.$Gf)(e.scheme,s):(0,M.$Hf)(e,s+":")}function f(e,...s){return s.some(o=>E(e,o))}t.$Qg="vscode-tkn",t.$Rg="tkn";class ${constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=A(s,o)}getServerRootPath(){return this.f}get g(){return L.$ic.join(this.f,v.vscodeRemoteResource)}set(s,o,h){this.a[s]=o,this.b[s]=h}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(y){return i.$3(y),s}const o=s.authority;let h=this.a[o];h&&h.indexOf(":")!==-1&&h.indexOf("[")===-1&&(h=`[${h}]`);const c=this.b[o],p=this.c[o];let k=`path=${encodeURIComponent(s.path)}`;return typeof p=="string"&&(k+=`&${t.$Rg}=${encodeURIComponent(p)}`),R.URI.from({scheme:n.$o?this.d:v.vscodeRemoteResource,authority:`${h}:${c}`,path:this.g,query:k})}}t.$Sg=new $;function A(e,s){return L.$ic.join(s??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Ug="vs/../../extensions",t.$Vg="vs/../../node_modules",t.$Wg="vs/../../node_modules.asar",t.$Xg="vs/../../node_modules.asar.unpacked",t.$Yg="vscode-app";class b{static{this.a=t.$Yg}asBrowserUri(s){const o=this.b(s,ne);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===v.vscodeRemote?t.$Sg.rewrite(s):s.scheme===v.file&&(n.$m||n.$q===`${v.vscodeFileResource}://${b.a}`)?s.with({scheme:v.vscodeFileResource,authority:s.authority||b.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ne);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===v.vscodeFileResource?s.with({scheme:v.file,authority:s.authority!==b.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return R.URI.isUri(s)?s:R.URI.parse(o.toUrl(s))}}t.$Zg=new b;var m;(function(e){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function h(p){let k;typeof p=="string"?k=new URL(p).searchParams:p instanceof URL?k=p.searchParams:R.URI.isUri(p)&&(k=new URL(p.toString(!0)).searchParams);const y=k?.get(o);if(y)return s.get(y)}e.getHeadersFromQuery=h;function c(p,k,y){if(!globalThis.crossOriginIsolated)return;const r=k&&y?"3":y?"2":"1";p instanceof URLSearchParams?p.set(o,r):p[o]=r}e.addSearchParam=c})(m||(t.COI=m={}))}),define(we[52],ve([1,0,18,134,41,30,5,11,17]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=void 0,t.$7g=f,t.$ph=A,t.$qh=m,n=We(n),R=We(R);function f(e){return(0,E.$yc)(e,!0)}class ${constructor(s){this.a=s}compare(s,o,h=!1){return s===o?0:(0,v.$zf)(this.getComparisonKey(s,h),this.getComparisonKey(o,h))}isEqual(s,o,h=!1){return s===o?!0:!s||!o?!1:this.getComparisonKey(s,h)===this.getComparisonKey(o,h)}getComparisonKey(s,o=!1){return s.with({path:this.a(s)?s.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(s){return this.a(s)}isEqualOrParent(s,o,h=!1){if(s.scheme===o.scheme){if(s.scheme===M.Schemas.file)return n.$Eg(f(s),f(o),this.a(s))&&s.query===o.query&&(h||s.fragment===o.fragment);if((0,t.$lh)(s.authority,o.authority))return n.$Eg(s.path,o.path,this.a(s),"/")&&s.query===o.query&&(h||s.fragment===o.fragment)}return!1}joinPath(s,...o){return E.URI.joinPath(s,...o)}basenameOrAuthority(s){return(0,t.$dh)(s)||s.authority}basename(s){return R.$ic.basename(s.path)}extname(s){return R.$ic.extname(s.path)}dirname(s){if(s.path.length===0)return s;let o;return s.scheme===M.Schemas.file?o=E.URI.file(R.$oc(f(s))).path:(o=R.$ic.dirname(s.path),s.authority&&o.length&&o.charCodeAt(0)!==i.CharCode.Slash&&(console.error(`dirname("${s.toString})) resulted in a relative path`),o="/")),s.with({path:o})}normalizePath(s){if(!s.path.length)return s;let o;return s.scheme===M.Schemas.file?o=E.URI.file(R.$jc(f(s))).path:o=R.$ic.normalize(s.path),s.with({path:o})}relativePath(s,o){if(s.scheme!==o.scheme||!(0,t.$lh)(s.authority,o.authority))return;if(s.scheme===M.Schemas.file){const p=R.$nc(f(s),f(o));return L.$i?n.$yg(p):p}let h=s.path||"/";const c=o.path||"/";if(this.a(s)){let p=0;for(const k=Math.min(h.length,c.length);p<k&&!(h.charCodeAt(p)!==c.charCodeAt(p)&&h.charAt(p).toLowerCase()!==c.charAt(p).toLowerCase());p++);h=c.substr(0,p)+h.substr(p)}return R.$ic.relative(h,c)}resolvePath(s,o){if(s.scheme===M.Schemas.file){const h=E.URI.file(R.$mc(f(s),o));return s.with({authority:h.authority,path:h.path})}return o=n.$zg(o),s.with({path:R.$ic.resolve(s.path,o)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,o){return s===o||s!==void 0&&o!==void 0&&(0,v.$Gf)(s,o)}hasTrailingPathSeparator(s,o=R.sep){if(s.scheme===M.Schemas.file){const h=f(s);return h.length>n.$Ag(h).length&&h[h.length-1]===o}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===i.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,o=R.sep){return(0,t.$mh)(s,o)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,o=R.sep){let h=!1;if(s.scheme===M.Schemas.file){const c=f(s);h=c!==void 0&&c.length===n.$Ag(c).length&&c[c.length-1]===o}else{o="/";const c=s.path;h=c.length===1&&c.charCodeAt(c.length-1)===i.CharCode.Slash}return!h&&!(0,t.$mh)(s,o)?s.with({path:s.path+"/"}):s}}t.$8g=$,t.$9g=new $(()=>!1),t.$0g=new $(e=>e.scheme===M.Schemas.file?!L.$k:!0),t.$$g=new $(e=>!0),t.$_g=t.$9g.isEqual.bind(t.$9g),t.$ah=t.$9g.isEqualOrParent.bind(t.$9g),t.$bh=t.$9g.getComparisonKey.bind(t.$9g),t.$ch=t.$9g.basenameOrAuthority.bind(t.$9g),t.$dh=t.$9g.basename.bind(t.$9g),t.$eh=t.$9g.extname.bind(t.$9g),t.$fh=t.$9g.dirname.bind(t.$9g),t.$gh=t.$9g.joinPath.bind(t.$9g),t.$hh=t.$9g.normalizePath.bind(t.$9g),t.$ih=t.$9g.relativePath.bind(t.$9g),t.$jh=t.$9g.resolvePath.bind(t.$9g),t.$kh=t.$9g.isAbsolutePath.bind(t.$9g),t.$lh=t.$9g.isEqualAuthority.bind(t.$9g),t.$mh=t.$9g.hasTrailingPathSeparator.bind(t.$9g),t.$nh=t.$9g.removeTrailingPathSeparator.bind(t.$9g),t.$oh=t.$9g.addTrailingPathSeparator.bind(t.$9g);function A(e,s){const o=[];for(let h=0;h<e.length;h++){const c=s(e[h]);e.some((p,k)=>k===h?!1:(0,t.$ah)(c,s(p)))||o.push(e[h])}return o}var b;(function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime";function s(o){const h=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(k=>{const[y,r]=k.split(":");y&&r&&h.set(y,r)});const p=o.path.substring(0,o.path.indexOf(";"));return p&&h.set(e.META_DATA_MIME,p),h}e.parseMetaData=s})(b||(t.DataUri=b={}));function m(e,s,o){if(s){let h=e.path;return h&&h[0]!==R.$ic.sep&&(h=R.$ic.sep+h),e.with({scheme:o,authority:s,path:h})}return e.with({scheme:o})}}),define(we[12],ve([1,0,39,6,3,2,52,5,63,26]),function(ne,t,i,n,M,R,L,v,E,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9h=t.$7h=t.$6h=t.$5h=t.$4h=t.Promises=t.$3h=t.$2h=t.$1h=t.$Yh=t.$Xh=t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=t.$Rh=t.$Qh=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$Ah=t.$zh=void 0,t.$rh=$,t.$sh=A,t.$th=b,t.$uh=m,t.$vh=e,t.$wh=s,t.$xh=o,t.$yh=h,t.$Gh=_,t.$Hh=H,t.$Ih=w,t.$Jh=C,t.$Kh=W,t.$Zh=ee,t.$8h=V;function $(a){return!!a&&typeof a.then=="function"}function A(a){const l=new i.$xe,g=a(l.token),I=new Promise((F,u)=>{const N=l.token.onCancellationRequested(()=>{N.dispose(),u(new n.$7)});Promise.resolve(g).then(S=>{N.dispose(),l.dispose(),F(S)},S=>{N.dispose(),l.dispose(),u(S)})});return new class{cancel(){l.cancel(),l.dispose()}then(F,u){return I.then(F,u)}catch(F){return this.then(void 0,F)}finally(F){return I.finally(F)}}}function b(a,l,g){return new Promise((I,F)=>{const u=l.onCancellationRequested(()=>{u.dispose(),I(g)});a.then(I,F).finally(()=>u.dispose())})}function m(a,l){return new Promise((g,I)=>{const F=l.onCancellationRequested(()=>{F.dispose(),I(new n.$7)});a.then(g,I).finally(()=>F.dispose())})}async function e(a){let l=-1;const g=a.map((I,F)=>I.then(u=>(l=F,u)));try{return await Promise.race(g)}finally{a.forEach((I,F)=>{F!==l&&I.cancel()})}}function s(a,l,g){let I;const F=setTimeout(()=>{I?.(void 0),g?.()},l);return Promise.race([a.finally(()=>clearTimeout(F)),new Promise(u=>I=u)])}function o(a){return new Promise((l,g)=>{const I=a();$(I)?I.then(l,g):l(I)})}function h(){let a,l;return{promise:new Promise((I,F)=>{a=I,l=F}),resolve:a,reject:l}}class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=l,!this.b){const g=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(g,g).then(I)})}return new Promise((g,I)=>{this.b.then(g,I)})}return this.a=l(),new Promise((g,I)=>{this.a.then(F=>{this.a=null,g(F)},F=>{this.a=null,I(F)})})}dispose(){this.f=!0}}t.$zh=c;class p{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}t.$Ah=p;class k{constructor(){this.a=new Map}queue(l,g){const F=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(g).finally(()=>{this.a.get(l)===F&&this.a.delete(l)});return this.a.set(l,F),F}}t.$Bh=k;const y=(a,l)=>{let g=!0;const I=setTimeout(()=>{g=!1,l()},a);return{isTriggered:()=>g,dispose:()=>{clearTimeout(I),g=!1}}},r=a=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,a())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class d{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,g=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((F,u)=>{this.d=F,this.f=u}).then(()=>{if(this.b=null,this.d=null,this.g){const F=this.g;return this.g=null,F()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=g===E.$he?r(I):y(g,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new n.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Ch=d;class D{constructor(l){this.a=new d(l),this.b=new c}trigger(l,g){return this.a.trigger(()=>this.b.queue(l),g)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Dh=D;class T{constructor(){this.a=!1,this.b=new Promise((l,g)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Eh=T;class U extends T{constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}t.$Fh=U;function _(a,l){return l?new Promise((g,I)=>{const F=setTimeout(()=>{u.dispose(),g()},a),u=l.onCancellationRequested(()=>{clearTimeout(F),u.dispose(),I(new n.$7)})}):A(g=>_(a,g))}function H(a,l=0,g){const I=setTimeout(()=>{a(),g&&F.dispose()},l),F=(0,R.$Uc)(()=>{clearTimeout(I),g?.deleteAndLeak(F)});return g?.add(F),F}function w(a){const l=[];let g=0;const I=a.length;function F(){return g<I?a[g++]():null}function u(N){N!=null&&l.push(N);const S=F();return S?S.then(u):Promise.resolve(l)}return Promise.resolve(null).then(u)}function C(a,l=I=>!!I,g=null){let I=0;const F=a.length,u=()=>{if(I>=F)return Promise.resolve(g);const N=a[I++];return Promise.resolve(N()).then(P=>l(P)?Promise.resolve(P):u())};return u()}function W(a,l=I=>!!I,g=null){if(a.length===0)return Promise.resolve(g);let I=a.length;const F=()=>{I=-1;for(const u of a)u.cancel?.()};return new Promise((u,N)=>{for(const S of a)S.then(P=>{--I>=0&&l(P)?(F(),u(P)):I===0&&u(g)}).catch(P=>{--I>=0&&(F(),N(P))})})}class O{constructor(l){this.a=0,this.b=!1,this.f=l,this.g=[],this.d=0,this.h=new M.$me}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(l){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((g,I)=>{this.g.push({factory:l,c:g,e:I}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const l=this.g.shift();this.d++;const g=l.factory();g.then(l.c,l.e),g.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Lh=O;class B extends O{constructor(){super(1)}}t.$Mh=B;class z{constructor(){this.a=new ce,this.b=0}queue(l){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,l())):this.a.run(this.b++,l())}}t.$Nh=z;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const l=new te;return this.b.add(l),l.p}g(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueSize(l,g=L.$9g){const I=g.getComparisonKey(l);return this.a.get(I)?.size??0}queueFor(l,g,I=L.$9g){const F=I.getComparisonKey(l);let u=this.a.get(F);if(!u){u=new B;const N=this.f++,S=M.Event.once(u.onDrained)(()=>{u?.dispose(),this.a.delete(F),this.h(),this.d?.deleteAndDispose(N),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$6c),this.d.set(N,S),this.a.set(F,u)}return u.queue(g)}h(){this.g()&&this.j()}j(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Oh=J;class X{constructor(l,g){this.b=!1,this.a=-1,typeof l=="function"&&typeof g=="number"&&this.setIfNotSet(l,g)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,g){if(this.b)throw new n.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},g)}setIfNotSet(l,g){if(this.b)throw new n.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},g))}}t.$Ph=X;class K{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(l,g,I=globalThis){if(this.f)throw new n.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const F=I.setInterval(()=>{l()},g);this.d=(0,R.$Uc)(()=>{I.clearInterval(F),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}t.$Qh=K;class Q{constructor(l,g){this.b=-1,this.a=l,this.d=g,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Rh=Q;class he{constructor(l,g){g%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${g}ms is not a multiple of 1000ms.`),this.a=l,this.b=g,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Sh=he;class be extends Q{constructor(l,g){super(l,g),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}t.$Th=be;class Se extends R.$Wc{constructor(l,g){super(),this.g=l,this.h=g,this.a=[],this.b=this.B(new R.$Xc),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const g of l)this.a.push(g);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Uh=Se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Wh=(a,l)=>{(0,v.$B)(()=>{if(g)return;const I=Date.now()+15;l(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,I-Date.now())}}))});let g=!1;return{dispose(){g||(g=!0)}}}:t.$Wh=(a,l,g)=>{const I=a.requestIdleCallback(l,typeof g=="number"?{timeout:g}:void 0);let F=!1;return{dispose(){F||(F=!0,a.cancelIdleCallback(I))}}},t.$Vh=a=>(0,t.$Wh)(globalThis,a)}();class Fe{constructor(l,g){this.g=!1,this.d=()=>{try{this.j=g()}catch(I){this.l=I}finally{this.g=!0}},this.f=(0,t.$Wh)(l,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Xh=Fe;class se extends Fe{constructor(l){super(globalThis,l)}}t.$Yh=se;async function ee(a,l,g){let I;for(let F=0;F<g;F++)try{return await a()}catch(u){I=u,await _(l)}throw I}class ce{isRunning(l){return typeof l=="number"?this.a?.taskId===l:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(l,g,I){return this.a={taskId:l,cancel:()=>I?.(),promise:g},g.then(()=>this.d(l),()=>this.d(l)),g}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}queue(l){if(this.b)this.b.run=l;else{const{promise:g,resolve:I,reject:F}=h();this.b={run:l,promise:g,promiseResolve:I,promiseReject:F}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$1h=ce;class ae{constructor(l,g=()=>Date.now()){this.d=l,this.f=g,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}t.$2h=ae;var Ne;(function(a){a[a.Resolved=0]="Resolved",a[a.Rejected=1]="Rejected"})(Ne||(Ne={}));class te{get isRejected(){return this.d?.outcome===Ne.Rejected}get isResolved(){return this.d?.outcome===Ne.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Ne.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((l,g)=>{this.a=l,this.b=g})}complete(l){return new Promise(g=>{this.a(l),this.d={outcome:Ne.Resolved,value:l},g()})}error(l){return new Promise(g=>{this.b(l),this.d={outcome:Ne.Rejected,value:l},g()})}cancel(){return this.error(new n.$7)}}t.$3h=te;var $e;(function(a){async function l(I){let F;const u=await Promise.all(I.map(N=>N.then(S=>S,S=>{F||(F=S)})));if(typeof F<"u")throw F;return u}a.settled=l;function g(I){return new Promise(async(F,u)=>{try{await I(F,u)}catch(N){u(N)}})}a.withAsyncBody=g})($e||(t.Promises=$e={}));class ye{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(l){this.a=void 0,this.b=void 0,this.d=!1,this.promise=l.then(g=>(this.a=g,this.d=!0,g),g=>{throw this.b=g,this.d=!0,g})}requireValue(){if(!this.d)throw new n.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$4h=ye;class Oe{constructor(l){this.b=l,this.a=new f.$X(()=>new ye(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$5h=Oe;var Re;(function(a){a[a.Initial=0]="Initial",a[a.DoneOK=1]="DoneOK",a[a.DoneError=2]="DoneError"})(Re||(Re={}));class Ce{static fromArray(l){return new Ce(g=>{g.emitMany(l)})}static fromPromise(l){return new Ce(async g=>{g.emitMany(await l)})}static fromPromises(l){return new Ce(async g=>{await Promise.all(l.map(async I=>g.emitOne(await I)))})}static merge(l){return new Ce(async g=>{await Promise.all(l.map(async I=>{for await(const F of I)g.emitOne(F)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(l,g){this.a=Re.Initial,this.b=[],this.d=null,this.f=g,this.g=new M.$me,queueMicrotask(async()=>{const I={emitOne:F=>this.h(F),emitMany:F=>this.j(F),reject:F=>this.l(F)};try{await Promise.resolve(l(I)),this.k()}catch(F){this.l(F)}finally{I.emitOne=void 0,I.emitMany=void 0,I.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===Re.DoneError)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===Re.DoneOK)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(l,g){return new Ce(async I=>{for await(const F of l)I.emitOne(g(F))})}map(l){return Ce.map(this,l)}static filter(l,g){return new Ce(async I=>{for await(const F of l)g(F)&&I.emitOne(F)})}filter(l){return Ce.filter(this,l)}static coalesce(l){return Ce.filter(l,g=>!!g)}coalesce(){return Ce.coalesce(this)}static async toPromise(l){const g=[];for await(const I of l)g.push(I);return g}toPromise(){return Ce.toPromise(this)}h(l){this.a===Re.Initial&&(this.b.push(l),this.g.fire())}j(l){this.a===Re.Initial&&(this.b=this.b.concat(l),this.g.fire())}k(){this.a===Re.Initial&&(this.a=Re.DoneOK,this.g.fire())}l(l){this.a===Re.Initial&&(this.a=Re.DoneError,this.d=l,this.g.fire())}}t.$6h=Ce;class re extends Ce{constructor(l,g){super(g),this.m=l}cancel(){this.m.cancel()}}t.$7h=re;function V(a){const l=new i.$xe,g=a(l.token);return new re(l,async I=>{const F=l.token.onCancellationRequested(()=>{F.dispose(),l.dispose(),I.reject(new n.$7)});try{for await(const u of g){if(l.token.isCancellationRequested)return;I.emitOne(u)}F.dispose(),l.dispose()}catch(u){F.dispose(),l.dispose(),I.reject(u)}})}class j{constructor(l){this.a=new te,this.b=new Ce(F=>{if(g){F.reject(g);return}return I&&F.emitMany(I),this.d=u=>F.reject(u),this.f=u=>F.emitOne(u),this.a.p},l);let g,I;this.f=F=>{I||(I=[]),I.push(F)},this.d=F=>{g||(g=F)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(l){this.d(l),this.a.complete()}emitOne(l){this.f(l)}}t.$9h=j}),define(we[4],ve([1,0,19,69,16,23,12,6,3,136,8,2,41,5,17,66,25,38]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o,h){"use strict";var c;Object.defineProperty(t,"__esModule",{value:!0}),t.$3T=t.$YT=t.$WT=t.$TT=t.DetectedFullscreenMode=t.Namespace=t.$rT=t.$pT=t.$_S=t.$HS=t.$BS=t.$zS=t.$yS=t.$xS=t.$sS=t.$rS=t.$qS=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$oS=p,t.$pS=y,t.$tS=_,t.$uS=H,t.$vS=w,t.$wS=C,t.$AS=O,t.$CS=J,t.$DS=X,t.$ES=be,t.$FS=Se,t.$GS=Fe,t.$IS=ce,t.$JS=ae,t.$KS=Ne,t.$LS=te,t.$MS=$e,t.$NS=ye,t.$OS=Oe,t.$PS=Re,t.$QS=Ce,t.$RS=re,t.$SS=j,t.$TS=a,t.$US=g,t.$VS=F,t.$WS=u,t.$XS=N,t.$YS=S,t.$ZS=P,t.$1S=x,t.$2S=G,t.$3S=ie,t.$4S=le,t.$5S=de,t.$6S=Ee,t.$7S=De,t.$8S=ke,t.$9S=fe,t.$0S=ze,t.$$S=Xe,t.$aT=lt,t.$bT=rt,t.$cT=pe,t.$dT=Ae,t.$eT=He,t.$fT=Je,t.$gT=ot,t.$hT=nt,t.$iT=ut,t.$jT=st,t.$kT=ft,t.$lT=ht,t.$mT=wt,t.$nT=Ue,t.$oT=ge,t.$qT=Me,t.$sT=je,t.$tT=Ge,t.$uT=dt,t.$vT=Qe,t.$wT=mt,t.$xT=At,t.$yT=Ft,t.$=Qt,t.$AT=Ii,t.$BT=Oi,t.$CT=ei,t.$DT=ti,t.$ET=Pi,t.$FT=Bi,t.$GT=ji,t.$HT=Ci,t.$IT=_i,t.$JT=Ui,t.$KT=Wi,t.$LT=Hi,t.$MT=xi,t.$NT=zi,t.$OT=si,t.$PT=Zi,t.$QT=Vi,t.$RT=Ki,t.$ST=ri,t.$UT=Xi,t.$VT=Ji,t.$XT=Qi,t.h=nn,t.$1T=li,t.$2T=rn,i=We(i),E=We(E),f=We(f),m=We(m),c=function(){const Z=new Map;(0,o.$UR)(o.$VR,1);const q={window:o.$VR,disposables:new A.$Vc};Z.set(o.$VR.vscodeWindowId,q);const oe=new E.$me,me=new E.$me,Le=new E.$me;function _e(Pe,Ve){return(typeof Pe=="number"?Z.get(Pe):void 0)??(Ve?q:void 0)}return{onDidRegisterWindow:oe.event,onWillUnregisterWindow:Le.event,onDidUnregisterWindow:me.event,registerWindow(Pe){if(Z.has(Pe.vscodeWindowId))return A.$Wc.None;const Ve=new A.$Vc,xe={window:Pe,disposables:Ve.add(new A.$Vc)};return Z.set(Pe.vscodeWindowId,xe),Ve.add((0,A.$Uc)(()=>{Z.delete(Pe.vscodeWindowId),me.fire(Pe)})),Ve.add(y(Pe,t.$pT.BEFORE_UNLOAD,()=>{Le.fire(Pe)})),oe.fire(xe),Ve},getWindows(){return Z.values()},getWindowsCount(){return Z.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return Z.has(Pe)},getWindowById:_e,getWindow(Pe){const Ve=Pe;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const xe=Pe;return xe?.view?xe.view.window:o.$VR},getDocument(Pe){const Ve=Pe;return(0,t.getWindow)(Ve).document}}}(),t.registerWindow=c.registerWindow,t.getWindow=c.getWindow,t.getDocument=c.getDocument,t.getWindows=c.getWindows,t.getWindowsCount=c.getWindowsCount,t.getWindowId=c.getWindowId,t.getWindowById=c.getWindowById,t.hasWindow=c.hasWindow,t.onDidRegisterWindow=c.onDidRegisterWindow,t.onWillUnregisterWindow=c.onWillUnregisterWindow,t.onDidUnregisterWindow=c.onDidUnregisterWindow;function p(Z){for(;Z.firstChild;)Z.firstChild.remove()}class k{constructor(q,oe,me,Le){this.f=q,this.g=oe,this.d=me,this.j=Le||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function y(Z,q,oe,me){return new k(Z,q,oe,me)}function r(Z,q){return function(oe){return q(new R.$hS(Z,oe))}}function d(Z){return function(q){return Z(new M.$mS(q))}}const D=function(q,oe,me,Le){let _e=me;return oe==="click"||oe==="mousedown"||oe==="contextmenu"?_e=r((0,t.getWindow)(q),me):(oe==="keydown"||oe==="keypress"||oe==="keyup")&&(_e=d(me)),y(q,oe,_e,Le)};t.$qS=D;const T=function(q,oe,me){const Le=r((0,t.getWindow)(q),oe);return _(q,Le,me)};t.$rS=T;const U=function(q,oe,me){const Le=r((0,t.getWindow)(q),oe);return w(q,Le,me)};t.$sS=U;function _(Z,q,oe){return y(Z,m.$r&&n.$eS.pointerEvents?t.$pT.POINTER_DOWN:t.$pT.MOUSE_DOWN,q,oe)}function H(Z,q,oe){return y(Z,m.$r&&n.$eS.pointerEvents?t.$pT.POINTER_MOVE:t.$pT.MOUSE_MOVE,q,oe)}function w(Z,q,oe){return y(Z,m.$r&&n.$eS.pointerEvents?t.$pT.POINTER_UP:t.$pT.MOUSE_UP,q,oe)}function C(Z,q,oe){return(0,L.$Wh)(Z,q,oe)}class W extends L.$Xh{constructor(q,oe){super(q,oe)}}t.$xS=W;function O(Z,q,oe,me){let Le=0;const _e=Z.setInterval(()=>{Le++,(typeof me=="number"&&Le>=me||q()===!0)&&Pe.dispose()},oe),Pe=(0,A.$Uc)(()=>{Z.clearInterval(_e)});return Pe}class B extends L.$Qh{constructor(q){super(),this.g=q&&(0,t.getWindow)(q)}cancelAndSet(q,oe,me){return super.cancelAndSet(q,oe,me??this.g)}}t.$BS=B;class z{constructor(q,oe=0){this.d=q,this.priority=oe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(q){(0,v.$3)(q)}}static sort(q,oe){return oe.priority-q.priority}}(function(){const Z=new Map,q=new Map,oe=new Map,me=new Map,Le=_e=>{oe.set(_e,!1);const Pe=Z.get(_e)??[];for(q.set(_e,Pe),Z.set(_e,[]),me.set(_e,!0);Pe.length>0;)Pe.sort(z.sort),Pe.shift().execute();me.set(_e,!1)};t.$zS=(_e,Pe,Ve=0)=>{const xe=(0,t.getWindowId)(_e),Ze=new z(Pe,Ve);let ct=Z.get(xe);return ct||(ct=[],Z.set(xe,ct)),ct.push(Ze),oe.get(xe)||(oe.set(xe,!0),_e.requestAnimationFrame(()=>Le(xe))),Ze},t.$yS=(_e,Pe,Ve)=>{const xe=(0,t.getWindowId)(_e);if(me.get(xe)){const Ze=new z(Pe,Ve);let ct=q.get(xe);return ct||(ct=[],q.set(xe,ct)),ct.push(Ze),Ze}else return(0,t.$zS)(_e,Pe,Ve)}})();function J(Z,q){return(0,t.$zS)(Z,q,1e4)}function X(Z,q){return(0,t.$zS)(Z,q,-1e4)}const K=8,Q=function(Z,q){return q};class he extends A.$Wc{constructor(q,oe,me,Le=Q,_e=K){super();let Pe=null,Ve=0;const xe=this.B(new L.$Ph),Ze=()=>{Ve=new Date().getTime(),me(Pe),Pe=null};this.B(y(q,oe,ct=>{Pe=Le(Pe,ct);const Rt=new Date().getTime()-Ve;Rt>=_e?(xe.cancel(),Ze()):xe.setIfNotSet(Ze,_e-Rt)}))}}function be(Z,q,oe,me,Le){return new he(Z,q,oe,me,Le)}function Se(Z){return(0,t.getWindow)(Z).getComputedStyle(Z,null)}function Fe(Z,q){const oe=(0,t.getWindow)(Z),me=oe.document;if(Z!==me.body)return new ee(Z.clientWidth,Z.clientHeight);if(m.$r&&oe?.visualViewport)return new ee(oe.visualViewport.width,oe.visualViewport.height);if(oe?.innerWidth&&oe.innerHeight)return new ee(oe.innerWidth,oe.innerHeight);if(me.body&&me.body.clientWidth&&me.body.clientHeight)return new ee(me.body.clientWidth,me.body.clientHeight);if(me.documentElement&&me.documentElement.clientWidth&&me.documentElement.clientHeight)return new ee(me.documentElement.clientWidth,me.documentElement.clientHeight);if(q)return Fe(q);throw new Error("Unable to figure out browser width and height")}class se{static d(q,oe){return parseFloat(oe)||0}static f(q,oe,me){const Le=Se(q),_e=Le?Le.getPropertyValue(oe):"0";return se.d(q,_e)}static getBorderLeftWidth(q){return se.f(q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(q){return se.f(q,"border-right-width","borderRightWidth")}static getBorderTopWidth(q){return se.f(q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(q){return se.f(q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(q){return se.f(q,"padding-left","paddingLeft")}static getPaddingRight(q){return se.f(q,"padding-right","paddingRight")}static getPaddingTop(q){return se.f(q,"padding-top","paddingTop")}static getPaddingBottom(q){return se.f(q,"padding-bottom","paddingBottom")}static getMarginLeft(q){return se.f(q,"margin-left","marginLeft")}static getMarginTop(q){return se.f(q,"margin-top","marginTop")}static getMarginRight(q){return se.f(q,"margin-right","marginRight")}static getMarginBottom(q){return se.f(q,"margin-bottom","marginBottom")}}class ee{static{this.None=new ee(0,0)}constructor(q,oe){this.width=q,this.height=oe}with(q=this.width,oe=this.height){return q!==this.width||oe!==this.height?new ee(q,oe):this}static is(q){return typeof q=="object"&&typeof q.height=="number"&&typeof q.width=="number"}static lift(q){return q instanceof ee?q:new ee(q.width,q.height)}static equals(q,oe){return q===oe?!0:!q||!oe?!1:q.width===oe.width&&q.height===oe.height}}t.$HS=ee;function ce(Z){let q=Z.offsetParent,oe=Z.offsetTop,me=Z.offsetLeft;for(;(Z=Z.parentNode)!==null&&Z!==Z.ownerDocument.body&&Z!==Z.ownerDocument.documentElement;){oe-=Z.scrollTop;const Le=S(Z)?null:Se(Z);Le&&(me-=Le.direction!=="rtl"?Z.scrollLeft:-Z.scrollLeft),Z===q&&(me+=se.getBorderLeftWidth(Z),oe+=se.getBorderTopWidth(Z),oe+=Z.offsetTop,me+=Z.offsetLeft,q=Z.offsetParent)}return{left:me,top:oe}}function ae(Z,q,oe){typeof q=="number"&&(Z.style.width=`${q}px`),typeof oe=="number"&&(Z.style.height=`${oe}px`)}function Ne(Z,q,oe,me,Le,_e="absolute"){typeof q=="number"&&(Z.style.top=`${q}px`),typeof oe=="number"&&(Z.style.right=`${oe}px`),typeof me=="number"&&(Z.style.bottom=`${me}px`),typeof Le=="number"&&(Z.style.left=`${Le}px`),Z.style.position=_e}function te(Z){const q=Z.getBoundingClientRect(),oe=(0,t.getWindow)(Z);return{left:q.left+oe.scrollX,top:q.top+oe.scrollY,width:q.width,height:q.height}}function $e(Z){let q=Z,oe=1;do{const me=Se(q).zoom;me!=null&&me!=="1"&&(oe*=me),q=q.parentElement}while(q!==null&&q!==q.ownerDocument.documentElement);return oe}function ye(Z){const q=se.getMarginLeft(Z)+se.getMarginRight(Z);return Z.offsetWidth+q}function Oe(Z){const q=se.getBorderLeftWidth(Z)+se.getBorderRightWidth(Z),oe=se.getPaddingLeft(Z)+se.getPaddingRight(Z);return Z.offsetWidth-q-oe}function Re(Z){const q=se.getMarginLeft(Z)+se.getMarginRight(Z);return Z.scrollWidth+q}function Ce(Z){const q=se.getBorderTopWidth(Z)+se.getBorderBottomWidth(Z),oe=se.getPaddingTop(Z)+se.getPaddingBottom(Z);return Z.offsetHeight-q-oe}function re(Z){const q=se.getMarginTop(Z)+se.getMarginBottom(Z);return Z.offsetHeight+q}function V(Z,q){if(Z===null)return 0;const oe=ce(Z),me=ce(q);return oe.left-me.left}function j(Z,q){const oe=q.map(Le=>Math.max(Re(Le),ye(Le))+V(Le,Z)||0);return Math.max(...oe)}function a(Z,q){return!!q?.contains(Z)}const l="parentFlowToElementId";function g(Z,q){Z.dataset[l]=q.id}function I(Z){const q=Z.dataset[l];return typeof q=="string"?Z.ownerDocument.getElementById(q):null}function F(Z,q){let oe=Z;for(;oe;){if(oe===q)return!0;if(He(oe)){const me=I(oe);if(me){oe=me;continue}}oe=oe.parentNode}return!1}function u(Z,q,oe){for(;Z&&Z.nodeType===Z.ELEMENT_NODE;){if(Z.classList.contains(q))return Z;if(oe){if(typeof oe=="string"){if(Z.classList.contains(oe))return null}else if(Z===oe)return null}Z=Z.parentNode}return null}function N(Z,q,oe){return!!u(Z,q,oe)}function S(Z){return Z&&!!Z.host&&!!Z.mode}function P(Z){return!!x(Z)}function x(Z){for(;Z.parentNode;){if(Z===Z.ownerDocument?.body)return null;Z=Z.parentNode}return S(Z)?Z:null}function G(){let Z=Ee().activeElement;for(;Z?.shadowRoot;)Z=Z.shadowRoot.activeElement;return Z}function ie(Z){return G()===Z}function le(Z){return a(G(),Z)}function de(Z){return Z.ownerDocument===Ee()}function Ee(){return(0,t.getWindowsCount)()<=1?o.$VR.document:Array.from((0,t.getWindows)()).map(({window:q})=>q.document).find(q=>q.hasFocus())??o.$VR.document}function De(){return Ee().defaultView?.window??o.$VR}const Te=new Map;function ke(Z){return Te.has(Z)}function fe(){return new Ie}class Ie{constructor(){this.d="",this.f=void 0}setStyle(q){q!==this.d&&(this.d=q,this.f?this.f.innerText=q:this.f=ze(o.$VR.document.head,oe=>oe.innerText=q))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function ze(Z=o.$VR.document.head,q,oe){const me=document.createElement("style");if(me.type="text/css",me.media="screen",q?.(me),Z.appendChild(me),oe&&oe.add((0,A.$Uc)(()=>me.remove())),Z===o.$VR.document.head){const Le=new Set;Te.set(me,Le);for(const{window:_e,disposables:Pe}of(0,t.getWindows)()){if(_e===o.$VR)continue;const Ve=Pe.add(tt(me,Le,_e));oe?.add(Ve)}}return me}function Xe(Z){const q=new A.$Vc;for(const[oe,me]of Te)q.add(tt(oe,me,Z));return q}function tt(Z,q,oe){const me=new A.$Vc,Le=Z.cloneNode(!0);oe.document.head.appendChild(Le),me.add((0,A.$Uc)(()=>Le.remove()));for(const _e of ue(Z))Le.sheet?.insertRule(_e.cssText,Le.sheet?.cssRules.length);return me.add(t.$_S.observe(Z,me,{childList:!0})(()=>{Le.textContent=Z.textContent})),q.add(Le),me.add((0,A.$Uc)(()=>q.delete(Le))),me}t.$_S=new class{constructor(){this.mutationObservers=new Map}observe(Z,q,oe){let me=this.mutationObservers.get(Z);me||(me=new Map,this.mutationObservers.set(Z,me));const Le=(0,s.$tj)(oe);let _e=me.get(Le);if(_e)_e.users+=1;else{const Pe=new E.$me,Ve=new MutationObserver(Ze=>Pe.fire(Ze));Ve.observe(Z,oe);const xe=_e={users:1,observer:Ve,onDidMutate:Pe.event};q.add((0,A.$Uc)(()=>{xe.users-=1,xe.users===0&&(Pe.dispose(),Ve.disconnect(),me?.delete(Le),me?.size===0&&this.mutationObservers.delete(Z))})),me.set(Le,_e)}return _e.onDidMutate}};function lt(Z=o.$VR.document.head){return qe("meta",Z)}function rt(Z=o.$VR.document.head){return qe("link",Z)}function qe(Z,q=o.$VR.document.head){const oe=document.createElement(Z);return q.appendChild(oe),oe}let Ye=null;function Y(){return Ye||(Ye=ze()),Ye}function ue(Z){return Z?.sheet?.rules?Z.sheet.rules:Z?.sheet?.cssRules?Z.sheet.cssRules:[]}function pe(Z,q,oe=Y()){if(!(!oe||!q)){oe.sheet?.insertRule(`${Z} {${q}}`,0);for(const me of Te.get(oe)??[])pe(Z,q,me)}}function Ae(Z,q=Y()){if(!q)return;const oe=ue(q),me=[];for(let Le=0;Le<oe.length;Le++){const _e=oe[Le];Be(_e)&&_e.selectorText.indexOf(Z)!==-1&&me.push(Le)}for(let Le=me.length-1;Le>=0;Le--)q.sheet?.deleteRule(me[Le]);for(const Le of Te.get(q)??[])Ae(Z,Le)}function Be(Z){return typeof Z.selectorText=="string"}function He(Z){return Z instanceof HTMLElement||Z instanceof(0,t.getWindow)(Z).HTMLElement}function Je(Z){return Z instanceof HTMLAnchorElement||Z instanceof(0,t.getWindow)(Z).HTMLAnchorElement}function ot(Z){return Z instanceof HTMLSpanElement||Z instanceof(0,t.getWindow)(Z).HTMLSpanElement}function nt(Z){return Z instanceof HTMLTextAreaElement||Z instanceof(0,t.getWindow)(Z).HTMLTextAreaElement}function ut(Z){return Z instanceof HTMLInputElement||Z instanceof(0,t.getWindow)(Z).HTMLInputElement}function st(Z){return Z instanceof HTMLButtonElement||Z instanceof(0,t.getWindow)(Z).HTMLButtonElement}function ft(Z){return Z instanceof HTMLDivElement||Z instanceof(0,t.getWindow)(Z).HTMLDivElement}function ht(Z){return Z instanceof MouseEvent||Z instanceof(0,t.getWindow)(Z).MouseEvent}function wt(Z){return Z instanceof KeyboardEvent||Z instanceof(0,t.getWindow)(Z).KeyboardEvent}function Ue(Z){return Z instanceof PointerEvent||Z instanceof(0,t.getWindow)(Z).PointerEvent}function ge(Z){return Z instanceof DragEvent||Z instanceof(0,t.getWindow)(Z).DragEvent}t.$pT={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$9R?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$9R?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$9R?"webkitAnimationIteration":"animationiteration"};function Me(Z){const q=Z;return!!(q&&typeof q.preventDefault=="function"&&typeof q.stopPropagation=="function")}t.$rT={stop:(Z,q)=>(Z.preventDefault(),q&&Z.stopPropagation(),Z)};function je(Z){const q=[];for(let oe=0;Z&&Z.nodeType===Z.ELEMENT_NODE;oe++)q[oe]=Z.scrollTop,Z=Z.parentNode;return q}function Ge(Z,q){for(let oe=0;Z&&Z.nodeType===Z.ELEMENT_NODE;oe++)Z.scrollTop!==q[oe]&&(Z.scrollTop=q[oe]),Z=Z.parentNode}class it extends A.$Wc{static m(q){if(He(q)){const oe=x(q),me=oe?oe.activeElement:q.ownerDocument.activeElement;return a(me,q)}else{const oe=q;return a(oe.document.activeElement,oe.document)}}constructor(q){super(),this.f=this.B(new E.$me),this.onDidFocus=this.f.event,this.g=this.B(new E.$me),this.onDidBlur=this.g.event;let oe=it.m(q),me=!1;const Le=()=>{me=!1,oe||(oe=!0,this.f.fire())},_e=()=>{oe&&(me=!0,(He(q)?(0,t.getWindow)(q):q).setTimeout(()=>{me&&(me=!1,oe=!1,this.g.fire())},0))};this.j=()=>{it.m(q)!==oe&&(oe?_e():Le())},this.B(y(q,t.$pT.FOCUS,Le,!0)),this.B(y(q,t.$pT.BLUR,_e,!0)),He(q)&&(this.B(y(q,t.$pT.FOCUS_IN,()=>this.j())),this.B(y(q,t.$pT.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function dt(Z){return new it(Z)}function Qe(Z,q){return Z.after(q),q}function mt(Z,...q){if(Z.append(...q),q.length===1&&typeof q[0]!="string")return q[0]}function At(Z,q){return Z.insertBefore(q,Z.firstChild),q}function Ft(Z,...q){Z.innerText="",mt(Z,...q)}const Yt=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var St;(function(Z){Z.HTML="http://www.w3.org/1999/xhtml",Z.SVG="http://www.w3.org/2000/svg"})(St||(t.Namespace=St={}));function Jt(Z,q,oe,...me){const Le=Yt.exec(q);if(!Le)throw new Error("Bad use of emmet");const _e=Le[1]||"div";let Pe;return Z!==St.HTML?Pe=document.createElementNS(Z,_e):Pe=document.createElement(_e),Le[3]&&(Pe.id=Le[3]),Le[4]&&(Pe.className=Le[4].replace(/\./g," ").trim()),oe&&Object.entries(oe).forEach(([Ve,xe])=>{typeof xe>"u"||(/^on\w+$/.test(Ve)?Pe[Ve]=xe:Ve==="selected"?xe&&Pe.setAttribute(Ve,"true"):Pe.setAttribute(Ve,xe))}),Pe.append(...me),Pe}function Qt(Z,q,...oe){return Jt(St.HTML,Z,q,...oe)}Qt.SVG=function(Z,q,...oe){return Jt(St.SVG,Z,q,...oe)};function Ii(Z,q){const oe=[];return Z.forEach((me,Le)=>{Le>0&&(q instanceof Node?oe.push(q.cloneNode()):oe.push(document.createTextNode(q))),oe.push(me)}),oe}function Oi(Z,...q){Z?ei(...q):ti(...q)}function ei(...Z){for(const q of Z)q.style.display="",q.removeAttribute("aria-hidden")}function ti(...Z){for(const q of Z)q.style.display="none",q.setAttribute("aria-hidden","true")}function Mi(Z,q){for(;Z&&Z.nodeType===Z.ELEMENT_NODE;){if(He(Z)&&Z.hasAttribute(q))return Z;Z=Z.parentNode}return null}function Pi(Z){!Z||!Z.hasAttribute("tabIndex")||(Z.ownerDocument.activeElement===Z&&Mi(Z.parentElement,"tabIndex")?.focus(),Z.removeAttribute("tabindex"))}function Bi(Z){return q=>{q.preventDefault(),q.stopPropagation(),Z(q)}}function ji(Z){return new Promise(q=>{if(Z.document.readyState==="complete"||Z.document&&Z.document.body!==null)q(void 0);else{const me=()=>{Z.window.removeEventListener("DOMContentLoaded",me,!1),q()};Z.window.addEventListener("DOMContentLoaded",me,!1)}})}function Ci(Z,q){const oe=Z.devicePixelRatio*q;return Math.max(1,Math.floor(oe))/Z.devicePixelRatio}function _i(Z){o.$VR.open(Z,"_blank","noopener")}const ii=780,ni=640;function Ui(Z){const q=Math.floor(o.$VR.screenLeft+o.$VR.innerWidth/2-ii/2),oe=Math.floor(o.$VR.screenTop+o.$VR.innerHeight/2-ni/2);o.$VR.open(Z,"_blank",`width=${ii},height=${ni},top=${oe},left=${q}`)}function Wi(Z,q=!0){const oe=o.$VR.open();return oe?(q&&(oe.opener=null),oe.location.href=Z,!0):!1}function Hi(Z,q){const oe=()=>{q(),me=(0,t.$zS)(Z,oe)};let me=(0,t.$zS)(Z,oe);return(0,A.$Uc)(()=>me.dispose())}b.$Sg.setPreferredWebSchema(/^https:/.test(o.$VR.location.href)?"https":"http");function xi(Z){return Z?`url('${b.$Zg.uriToBrowserUri(Z).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function zi(Z){return`'${Z.replace(/'/g,"%27")}'`}function si(Z,q){if(Z!==void 0){const oe=Z.match(/^\s*var\((.+)\)$/);if(oe){const me=oe[1].split(",",2);return me.length===2&&(q=si(me[1].trim(),q)),`var(${me[0]}, ${q})`}return Z}return q}function Zi(Z,q){let oe;if(e.URI.isUri(Z))oe=Z.toString(!0);else{const _e=new Blob([Z]);oe=URL.createObjectURL(_e),setTimeout(()=>URL.revokeObjectURL(oe))}const me=De(),Le=document.createElement("a");me.document.body.appendChild(Le),Le.download=q,Le.href=oe,Le.click(),setTimeout(()=>Le.remove())}function Vi(){return new Promise(Z=>{const q=De(),oe=document.createElement("input");q.document.body.appendChild(oe),oe.type="file",oe.multiple=!0,E.Event.once(E.Event.fromDOMEventEmitter(oe,"input"))(()=>{Z(oe.files??void 0)}),oe.click(),setTimeout(()=>oe.remove())})}var Tt;(function(Z){Z[Z.DOCUMENT=1]="DOCUMENT",Z[Z.BROWSER=2]="BROWSER"})(Tt||(t.DetectedFullscreenMode=Tt={}));function Ki(Z){return Z.document.fullscreenElement||Z.document.webkitFullscreenElement||Z.document.webkitIsFullScreen?{mode:Tt.DOCUMENT,guess:!1}:Z.innerHeight===Z.screen.height?{mode:Tt.BROWSER,guess:!1}:(m.$j||m.$k)&&Z.outerHeight===Z.screen.height&&Z.outerWidth===Z.screen.width?{mode:Tt.BROWSER,guess:!0}:null}function ri(Z,q=!1){const oe=document.createElement("a");return f.addHook("afterSanitizeAttributes",me=>{for(const Le of["href","src"])if(me.hasAttribute(Le)){const _e=me.getAttribute(Le);if(Le==="href"&&_e.startsWith("#"))continue;if(oe.href=_e,!Z.includes(oe.protocol.replace(/:$/,""))){if(q&&Le==="src"&&oe.href.startsWith("data:"))continue;me.removeAttribute(Le)}}}),(0,A.$Uc)(()=>{f.removeHook("afterSanitizeAttributes")})}const qi=[b.Schemas.http,b.Schemas.https,b.Schemas.command];t.$TT=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Xi(Z,q){const oe=ri(qi);try{const me=f.sanitize(q,Gi);Z.innerHTML=me}finally{oe.dispose()}}function Yi(Z){const q=new Uint16Array(Z.length);for(let Le=0;Le<q.length;Le++)q[Le]=Z.charCodeAt(Le);let oe="";const me=new Uint8Array(q.buffer);for(let Le=0;Le<me.length;Le++)oe+=String.fromCharCode(me[Le]);return oe}function Ji(Z){return btoa(Yi(Z))}class Dt extends E.$me{constructor(){super(),this.o=new A.$Vc,this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(E.Event.runAndSubscribe(t.onDidRegisterWindow,({window:q,disposables:oe})=>this.G(q,oe),{window:o.$VR,disposables:this.o}))}G(q,oe){oe.add(y(q,"keydown",me=>{if(me.defaultPrevented)return;const Le=new M.$mS(me);if(!(Le.keyCode===$.KeyCode.Alt&&me.repeat)){if(me.altKey&&!this.D.altKey)this.D.lastKeyPressed="alt";else if(me.ctrlKey&&!this.D.ctrlKey)this.D.lastKeyPressed="ctrl";else if(me.metaKey&&!this.D.metaKey)this.D.lastKeyPressed="meta";else if(me.shiftKey&&!this.D.shiftKey)this.D.lastKeyPressed="shift";else if(Le.keyCode!==$.KeyCode.Alt)this.D.lastKeyPressed=void 0;else return;this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyPressed&&(this.D.event=me,this.fire(this.D))}},!0)),oe.add(y(q,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.D.altKey?this.D.lastKeyReleased="alt":!me.ctrlKey&&this.D.ctrlKey?this.D.lastKeyReleased="ctrl":!me.metaKey&&this.D.metaKey?this.D.lastKeyReleased="meta":!me.shiftKey&&this.D.shiftKey?this.D.lastKeyReleased="shift":this.D.lastKeyReleased=void 0,this.D.lastKeyPressed!==this.D.lastKeyReleased&&(this.D.lastKeyPressed=void 0),this.D.altKey=me.altKey,this.D.ctrlKey=me.ctrlKey,this.D.metaKey=me.metaKey,this.D.shiftKey=me.shiftKey,this.D.lastKeyReleased&&(this.D.event=me,this.fire(this.D)))},!0)),oe.add(y(q.document.body,"mousedown",()=>{this.D.lastKeyPressed=void 0},!0)),oe.add(y(q.document.body,"mouseup",()=>{this.D.lastKeyPressed=void 0},!0)),oe.add(y(q.document.body,"mousemove",me=>{me.buttons&&(this.D.lastKeyPressed=void 0)},!0)),oe.add(y(q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.D}get isModifierPressed(){return this.D.altKey||this.D.ctrlKey||this.D.metaKey||this.D.shiftKey}resetKeyStatus(){this.H(),this.fire(this.D)}H(){this.D={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return Dt.F||(Dt.F=new Dt),Dt.F}dispose(){super.dispose(),this.o.dispose()}}t.$WT=Dt;function Qi(Z){const q=document.cookie.match("(^|[^;]+)\\s*"+Z+"\\s*=\\s*([^;]+)");return q?q.pop():void 0}class en extends A.$Wc{constructor(q,oe){super(),this.j=q,this.m=oe,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(y(this.j,t.$pT.DRAG_START,q=>{this.m.onDragStart?.(q)})),this.m.onDrag&&this.B(y(this.j,t.$pT.DRAG,q=>{this.m.onDrag?.(q)})),this.B(y(this.j,t.$pT.DRAG_ENTER,q=>{this.f++,this.g=q.timeStamp,this.m.onDragEnter?.(q)})),this.B(y(this.j,t.$pT.DRAG_OVER,q=>{q.preventDefault(),this.m.onDragOver?.(q,q.timeStamp-this.g)})),this.B(y(this.j,t.$pT.DRAG_LEAVE,q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(q))})),this.B(y(this.j,t.$pT.DRAG_END,q=>{this.f=0,this.g=0,this.m.onDragEnd?.(q)})),this.B(y(this.j,t.$pT.DROP,q=>{this.f=0,this.g=0,this.m.onDrop?.(q)}))}}t.$YT=en;const tn=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function nn(Z,...q){let oe,me;Array.isArray(q[0])?(oe={},me=q[0]):(oe=q[0]||{},me=q[1]);const Le=tn.exec(Z);if(!Le||!Le.groups)throw new Error("Bad use of h");const _e=Le.groups.tag||"div",Pe=document.createElement(_e);Le.groups.id&&(Pe.id=Le.groups.id);const Ve=[];if(Le.groups.class)for(const Ze of Le.groups.class.split("."))Ze!==""&&Ve.push(Ze);if(oe.className!==void 0)for(const Ze of oe.className.split("."))Ze!==""&&Ve.push(Ze);Ve.length>0&&(Pe.className=Ve.join(" "));const xe={};if(Le.groups.name&&(xe[Le.groups.name]=Pe),me)for(const Ze of me)He(Ze)?Pe.appendChild(Ze):typeof Ze=="string"?Pe.append(Ze):"root"in Ze&&(Object.assign(xe,Ze),Pe.appendChild(Ze.root));for(const[Ze,ct]of Object.entries(oe))if(Ze!=="className")if(Ze==="style")for(const[Rt,_t]of Object.entries(ct))Pe.style.setProperty(oi(Rt),typeof _t=="number"?_t+"px":""+_t);else Ze==="tabIndex"?Pe.tabIndex=ct:Pe.setAttribute(oi(Ze),ct.toString());return xe.root=Pe,xe}function oi(Z){return Z.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function li(Z,q,oe){for(const{name:me,value:Le}of Z.attributes)(!oe||oe.includes(me))&&q.setAttribute(me,Le)}function sn(Z,q,oe){const me=Z.getAttribute(oe);me?q.setAttribute(oe,me):q.removeAttribute(oe)}function rn(Z,q,oe){li(Z,q,oe);const me=new A.$Vc;return me.add(t.$_S.observe(Z,me,{attributes:!0,attributeFilter:oe})(Le=>{for(const _e of Le)_e.type==="attributes"&&_e.attributeName&&sn(Z,q,_e.attributeName)})),me}class on{constructor(q,oe,me){this.f=q,this.g=oe,this.d=[];const{top:Le,left:_e,right:Pe,bottom:Ve}=me.getBoundingClientRect(),xe=this.d;let Ze=0;xe[Ze++]=_e,xe[Ze++]=Le,xe[Ze++]=Pe,xe[Ze++]=Le,xe[Ze++]=_e,xe[Ze++]=Le,xe[Ze++]=_e,xe[Ze++]=Ve,xe[Ze++]=Pe,xe[Ze++]=Le,xe[Ze++]=Pe,xe[Ze++]=Ve,xe[Ze++]=_e,xe[Ze++]=Ve,xe[Ze++]=Pe,xe[Ze++]=Ve}contains(q,oe){const{d:me,f:Le,g:_e}=this;for(let Pe=0;Pe<4;Pe++)if((0,h.$Pm)(q,oe,Le,_e,me[2*Pe],me[2*Pe+1],me[2*Pe+2],me[2*Pe+3]))return!0;return!1}}t.$3T=on}),define(we[71],ve([1,0,4,2,135]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5T=t.$4T=void 0,t.$6T=L;class R extends n.$Wc{constructor(E,f){super(),this.B((0,i.$pS)(E,"dragover",$=>{$.preventDefault(),this.a||(this.a=setTimeout(()=>{f(),this.a=null},800))})),["dragleave","drop","dragend"].forEach($=>{this.B((0,i.$pS)(E,$,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$4T=R,t.$5T={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:M.$5s.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function L(v,E,f,$,A){const b=document.createElement("div");b.className=f,b.textContent=E,A&&(b.style.color=A),$&&(b.style.background=$),v.dataTransfer&&((0,i.getWindow)(v).document.body.appendChild(b),v.dataTransfer.setDragImage(b,-10,-10),setTimeout(()=>b.remove(),0))}}),define(we[72],ve([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yU=n,t.$zU=M,t.$AU=R,i=We(i);function n(b,m={}){const e=R(m);return e.textContent=b,e}function M(b,m={}){const e=R(m);return E(e,f(b,!!m.renderCodeSegments),m.actionHandler,m.renderCodeSegments),e}function R(b){const m=b.inline?"span":"div",e=document.createElement(m);return b.className&&(e.className=b.className),e}class L{constructor(m){this.b=m,this.c=0}eos(){return this.c>=this.b.length}next(){const m=this.peek();return this.advance(),m}peek(){return this.b[this.c]}advance(){this.c++}}var v;(function(b){b[b.Invalid=0]="Invalid",b[b.Root=1]="Root",b[b.Text=2]="Text",b[b.Bold=3]="Bold",b[b.Italics=4]="Italics",b[b.Action=5]="Action",b[b.ActionClose=6]="ActionClose",b[b.Code=7]="Code",b[b.NewLine=8]="NewLine"})(v||(v={}));function E(b,m,e,s){let o;if(m.type===v.Text)o=document.createTextNode(m.content||"");else if(m.type===v.Bold)o=document.createElement("b");else if(m.type===v.Italics)o=document.createElement("i");else if(m.type===v.Code&&s)o=document.createElement("code");else if(m.type===v.Action&&e){const h=document.createElement("a");e.disposables.add(i.$qS(h,"click",c=>{e.callback(String(m.index),c)})),o=h}else m.type===v.NewLine?o=document.createElement("br"):m.type===v.Root&&(o=b);o&&b!==o&&b.appendChild(o),o&&Array.isArray(m.children)&&m.children.forEach(h=>{E(o,h,e,s)})}function f(b,m){const e={type:v.Root,children:[]};let s=0,o=e;const h=[],c=new L(b);for(;!c.eos();){let p=c.next();const k=p==="\\"&&A(c.peek(),m)!==v.Invalid;if(k&&(p=c.next()),!k&&$(p,m)&&p===c.peek()){c.advance(),o.type===v.Text&&(o=h.pop());const y=A(p,m);if(o.type===y||o.type===v.Action&&y===v.ActionClose)o=h.pop();else{const r={type:y,children:[]};y===v.Action&&(r.index=s,s++),o.children.push(r),h.push(o),o=r}}else if(p===`
`)o.type===v.Text&&(o=h.pop()),o.children.push({type:v.NewLine});else if(o.type!==v.Text){const y={type:v.Text,content:p};o.children.push(y),h.push(o),o=y}else o.content+=p}return o.type===v.Text&&(o=h.pop()),h.length,e}function $(b,m){return A(b,m)!==v.Invalid}function A(b,m){switch(b){case"*":return v.Bold;case"_":return v.Italics;case"[":return v.Action;case"]":return v.ActionClose;case"`":return m?v.Code:v.Invalid;default:return v.Invalid}}}),define(we[73],ve([1,0,4,2]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0T=void 0,i=We(i);class M{constructor(){this.a=new n.$Vc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(L,v){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const E=this.c;this.c=null,L&&E&&E(v)}isMonitoring(){return!!this.b}startMonitoring(L,v,E,f,$){this.isMonitoring()&&this.stopMonitoring(!1),this.b=f,this.c=$;let A=L;try{L.setPointerCapture(v),this.a.add((0,n.$Uc)(()=>{try{L.releasePointerCapture(v)}catch{}}))}catch{A=i.getWindow(L)}this.a.add(i.$pS(A,i.$pT.POINTER_MOVE,b=>{if(b.buttons!==E){this.stopMonitoring(!0);return}b.preventDefault(),this.b(b)})),this.a.add(i.$pS(A,i.$pT.POINTER_UP,b=>this.stopMonitoring(!0)))}}t.$0T=M});var et=this&&this.__decorate||function(ne,t,i,n){var M=arguments.length,R=M<3?t:n===null?n=Object.getOwnPropertyDescriptor(t,i):n,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ne,t,i,n);else for(var v=ne.length-1;v>=0;v--)(L=ne[v])&&(R=(M<3?L(R):M>3?L(t,i,R):L(t,i))||R);return M>3&&R&&Object.defineProperty(t,i,R),R};define(we[33],ve([1,0,4,25,9,36,3,2,60]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7T=t.EventType=void 0,i=We(i),M=We(M);var f;(function(A){A.Tap="-monaco-gesturetap",A.Change="-monaco-gesturechange",A.Start="-monaco-gesturestart",A.End="-monaco-gesturesend",A.Contextmenu="-monaco-gesturecontextmenu"})(f||(t.EventType=f={}));class $ extends v.$Wc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new E.$7c,this.m=new E.$7c,this.r={},this.n=null,this.s=0,this.B(L.Event.runAndSubscribe(i.onDidRegisterWindow,({window:b,disposables:m})=>{m.add(i.$pS(b.document,"touchstart",e=>this.w(e),{passive:!1})),m.add(i.$pS(b.document,"touchend",e=>this.z(b,e))),m.add(i.$pS(b.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:n.$VR,disposables:this.q}))}static addTarget(b){if(!$.isTouchDevice())return v.$Wc.None;$.f||($.f=(0,v.$Pc)(new $));const m=$.f.j.push(b);return(0,v.$Uc)(m)}static ignoreTarget(b){if(!$.isTouchDevice())return v.$Wc.None;$.f||($.f=(0,v.$Pc)(new $));const m=$.f.m.push(b);return(0,v.$Uc)(m)}static isTouchDevice(){return"ontouchstart"in n.$VR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(b){const m=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,s=b.targetTouches.length;e<s;e++){const o=b.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:m,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[m],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const h=this.C(f.Start,o.target);h.pageX=o.pageX,h.pageY=o.pageY,this.D(h)}this.h&&(b.preventDefault(),b.stopPropagation(),this.h=!1)}z(b,m){const e=Date.now(),s=Object.keys(this.r).length;for(let o=0,h=m.changedTouches.length;o<h;o++){const c=m.changedTouches.item(o);if(!this.r.hasOwnProperty(String(c.identifier))){console.warn("move of an UNKNOWN touch",c);continue}const p=this.r[c.identifier],k=Date.now()-p.initialTimeStamp;if(k<$.g&&Math.abs(p.initialPageX-M.$ub(p.rollingPageX))<30&&Math.abs(p.initialPageY-M.$ub(p.rollingPageY))<30){const y=this.C(f.Tap,p.initialTarget);y.pageX=M.$ub(p.rollingPageX),y.pageY=M.$ub(p.rollingPageY),this.D(y)}else if(k>=$.g&&Math.abs(p.initialPageX-M.$ub(p.rollingPageX))<30&&Math.abs(p.initialPageY-M.$ub(p.rollingPageY))<30){const y=this.C(f.Contextmenu,p.initialTarget);y.pageX=M.$ub(p.rollingPageX),y.pageY=M.$ub(p.rollingPageY),this.D(y)}else if(s===1){const y=M.$ub(p.rollingPageX),r=M.$ub(p.rollingPageY),d=M.$ub(p.rollingTimestamps)-p.rollingTimestamps[0],D=y-p.rollingPageX[0],T=r-p.rollingPageY[0],U=[...this.j].filter(_=>p.initialTarget instanceof Node&&_.contains(p.initialTarget));this.F(b,U,e,Math.abs(D)/d,D>0?1:-1,y,Math.abs(T)/d,T>0?1:-1,r)}this.D(this.C(f.End,p.initialTarget)),delete this.r[c.identifier]}this.h&&(m.preventDefault(),m.stopPropagation(),this.h=!1)}C(b,m){const e=document.createEvent("CustomEvent");return e.initEvent(b,!1,!0),e.initialTarget=m,e.tapCount=0,e}D(b){if(b.type===f.Tap){const m=new Date().getTime();let e=0;m-this.s>$.u?e=1:e=2,this.s=m,b.tapCount=e}else(b.type===f.Change||b.type===f.Contextmenu)&&(this.s=0);if(b.initialTarget instanceof Node){for(const e of this.m)if(e.contains(b.initialTarget))return;const m=[];for(const e of this.j)if(e.contains(b.initialTarget)){let s=0,o=b.initialTarget;for(;o&&o!==e;)s++,o=o.parentElement;m.push([s,e])}m.sort((e,s)=>e[0]-s[0]);for(const[e,s]of m)s.dispatchEvent(b),this.h=!0}}F(b,m,e,s,o,h,c,p,k){this.n=i.$zS(b,()=>{const y=Date.now(),r=y-e;let d=0,D=0,T=!0;s+=$.c*r,c+=$.c*r,s>0&&(T=!1,d=o*s*r),c>0&&(T=!1,D=p*c*r);const U=this.C(f.Change);U.translationX=d,U.translationY=D,m.forEach(_=>_.dispatchEvent(U)),T||this.F(b,m,y,s,o,h+d,c,p,k+D)})}G(b){const m=Date.now();for(let e=0,s=b.changedTouches.length;e<s;e++){const o=b.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const h=this.r[o.identifier],c=this.C(f.Change,h.initialTarget);c.translationX=o.pageX-M.$ub(h.rollingPageX),c.translationY=o.pageY-M.$ub(h.rollingPageY),c.pageX=o.pageX,c.pageY=o.pageY,this.D(c),h.rollingPageX.length>3&&(h.rollingPageX.shift(),h.rollingPageY.shift(),h.rollingTimestamps.shift()),h.rollingPageX.push(o.pageX),h.rollingPageY.push(o.pageY),h.rollingTimestamps.push(m)}this.h&&(b.preventDefault(),b.stopPropagation(),this.h=!1)}}t.$7T=$,et([R.$0h],$,"isTouchDevice",null)}),define(we[74],ve([1,0,4,110]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CU=f,t.$DU=$,t.$EU=A,i=We(i);const n=2e4;let M,R,L,v,E;function f(m){M=document.createElement("div"),M.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),M.appendChild(o),o};R=e(),L=e();const s=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),M.appendChild(o),o};v=s(),E=s(),m.appendChild(M)}function $(m){M&&(R.textContent!==m?(i.$oS(L),b(R,m)):(i.$oS(R),b(L,m)))}function A(m){M&&(v.textContent!==m?(i.$oS(E),b(v,m)):(i.$oS(v),b(E,m)))}function b(m,e){i.$oS(m),e.length>n&&(e=e.substr(0,n)),m.textContent=e,m.style.visibility="hidden",m.style.visibility="visible"}}),define(we[75],ve([1,0,69,4,2,5,47,114]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xU=t.LayoutAnchorMode=t.LayoutAnchorPosition=t.AnchorAxisAlignment=t.AnchorPosition=t.AnchorAlignment=t.ContextViewDOMPosition=void 0,t.$vU=E,t.$wU=e,n=We(n),R=We(R);var v;(function(h){h[h.ABSOLUTE=1]="ABSOLUTE",h[h.FIXED=2]="FIXED",h[h.FIXED_SHADOW=3]="FIXED_SHADOW"})(v||(t.ContextViewDOMPosition=v={}));function E(h){const c=h;return!!c&&typeof c.x=="number"&&typeof c.y=="number"}var f;(function(h){h[h.LEFT=0]="LEFT",h[h.RIGHT=1]="RIGHT"})(f||(t.AnchorAlignment=f={}));var $;(function(h){h[h.BELOW=0]="BELOW",h[h.ABOVE=1]="ABOVE"})($||(t.AnchorPosition=$={}));var A;(function(h){h[h.VERTICAL=0]="VERTICAL",h[h.HORIZONTAL=1]="HORIZONTAL"})(A||(t.AnchorAxisAlignment=A={}));var b;(function(h){h[h.Before=0]="Before",h[h.After=1]="After"})(b||(t.LayoutAnchorPosition=b={}));var m;(function(h){h[h.AVOID=0]="AVOID",h[h.ALIGN=1]="ALIGN"})(m||(t.LayoutAnchorMode=m={}));function e(h,c,p){const k=p.mode===m.ALIGN?p.offset:p.offset+p.size,y=p.mode===m.ALIGN?p.offset+p.size:p.offset;return p.position===b.Before?c<=h-k?k:c<=y?y-c:Math.max(h-c,0):c<=y?y-c:c<=h-k?k:0}class s extends M.$Wc{static{this.a=["click","keydown","focus","blur"]}static{this.b=["click"]}constructor(c,p){super(),this.c=null,this.g=!1,this.h=!1,this.j=null,this.m=M.$Wc.None,this.n=M.$Wc.None,this.r=null,this.s=null,this.f=n.$(".context-view"),n.$DT(this.f),this.setContainer(c,p),this.B((0,M.$Uc)(()=>this.setContainer(null,v.ABSOLUTE)))}setContainer(c,p){this.g=p!==v.ABSOLUTE;const k=this.h;if(this.h=p===v.FIXED_SHADOW,!(c===this.c&&k===this.h)&&(this.c&&(this.n.dispose(),this.f.remove(),this.r&&(this.r=null,this.s?.remove(),this.s=null),this.c=null),c)){if(this.c=c,this.h){this.s=n.$(".shadow-root-host"),this.c.appendChild(this.s),this.r=this.s.attachShadow({mode:"open"});const r=document.createElement("style");r.textContent=o,this.r.appendChild(r),this.r.appendChild(this.f),this.r.appendChild(n.$("slot"))}else this.c.appendChild(this.f);const y=new M.$Vc;s.a.forEach(r=>{y.add(n.$qS(this.c,r,d=>{this.w(d,!1)}))}),s.b.forEach(r=>{y.add(n.$qS(this.c,r,d=>{this.w(d,!0)},!0))}),this.n=y}}show(c){this.u()&&this.hide(),n.$oS(this.f),this.f.className="context-view monaco-component",this.f.style.top="0px",this.f.style.left="0px",this.f.style.zIndex=`${2575+(c.layer??0)}`,this.f.style.position=this.g?"fixed":"absolute",n.$CT(this.f),this.m=c.render(this.f)||M.$Wc.None,this.j=c,this.t(),this.j.focus?.()}getViewElement(){return this.f}layout(){if(this.u()){if(this.j.canRelayout===!1&&!(R.$r&&i.$eS.pointerEvents)){this.hide();return}this.j?.layout?.(),this.t()}}t(){if(!this.u())return;const c=this.j.getAnchor();let p;if(n.$eT(c)){const w=n.$LS(c),C=n.$MS(c);p={top:w.top*C,left:w.left*C,width:w.width*C,height:w.height*C}}else E(c)?p={top:c.y,left:c.x,width:c.width||1,height:c.height||2}:p={top:c.posy,left:c.posx,width:2,height:2};const k=n.$NS(this.f),y=n.$RS(this.f),r=this.j.anchorPosition||$.BELOW,d=this.j.anchorAlignment||f.LEFT,D=this.j.anchorAxisAlignment||A.VERTICAL;let T,U;const _=n.$7S();if(D===A.VERTICAL){const w={offset:p.top-_.pageYOffset,size:p.height,position:r===$.BELOW?b.Before:b.After},C={offset:p.left,size:p.width,position:d===f.LEFT?b.Before:b.After,mode:m.ALIGN};T=e(_.innerHeight,y,w)+_.pageYOffset,L.Range.intersects({start:T,end:T+y},{start:w.offset,end:w.offset+w.size})&&(C.mode=m.AVOID),U=e(_.innerWidth,k,C)}else{const w={offset:p.left,size:p.width,position:d===f.LEFT?b.Before:b.After},C={offset:p.top,size:p.height,position:r===$.BELOW?b.Before:b.After,mode:m.ALIGN};U=e(_.innerWidth,k,w),L.Range.intersects({start:U,end:U+k},{start:w.offset,end:w.offset+w.size})&&(C.mode=m.AVOID),T=e(_.innerHeight,y,C)+_.pageYOffset}this.f.classList.remove("top","bottom","left","right"),this.f.classList.add(r===$.BELOW?"bottom":"top"),this.f.classList.add(d===f.LEFT?"left":"right"),this.f.classList.toggle("fixed",this.g);const H=n.$LS(this.c);this.f.style.top=`${T-(this.g?n.$LS(this.f).top:H.top)}px`,this.f.style.left=`${U-(this.g?n.$LS(this.f).left:H.left)}px`,this.f.style.width="initial"}hide(c){const p=this.j;this.j=null,p?.onHide&&p.onHide(c),this.m.dispose(),n.$DT(this.f)}u(){return!!this.j}w(c,p){this.j&&(this.j.onDOMEvent?this.j.onDOMEvent(c,n.getWindow(c).document.activeElement):p&&!n.$TS(c.target,this.c)&&this.hide())}dispose(){this.hide(),super.dispose()}}t.$xU=s;const o=`
	:host {
		all: initial; /* 1st rule so subsequent properties are reset. */
	}

	.codicon[class*='codicon-'] {
		font: normal normal normal 16px/1 codicon;
		display: inline-block;
		text-decoration: none;
		text-rendering: auto;
		text-align: center;
		-webkit-font-smoothing: antialiased;
		-moz-osx-font-smoothing: grayscale;
		user-select: none;
		-webkit-user-select: none;
		-ms-user-select: none;
	}

	:host {
		font-family: -apple-system, BlinkMacSystemFont, "Segoe WPC", "Segoe UI", "HelveticaNeue-Light", system-ui, "Ubuntu", "Droid Sans", sans-serif;
	}

	:host-context(.mac) { font-family: -apple-system, BlinkMacSystemFont, sans-serif; }
	:host-context(.mac:lang(zh-Hans)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang SC", "Hiragino Sans GB", sans-serif; }
	:host-context(.mac:lang(zh-Hant)) { font-family: -apple-system, BlinkMacSystemFont, "PingFang TC", sans-serif; }
	:host-context(.mac:lang(ja)) { font-family: -apple-system, BlinkMacSystemFont, "Hiragino Kaku Gothic Pro", sans-serif; }
	:host-context(.mac:lang(ko)) { font-family: -apple-system, BlinkMacSystemFont, "Nanum Gothic", "Apple SD Gothic Neo", "AppleGothic", sans-serif; }

	:host-context(.windows) { font-family: "Segoe WPC", "Segoe UI", sans-serif; }
	:host-context(.windows:lang(zh-Hans)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft YaHei", sans-serif; }
	:host-context(.windows:lang(zh-Hant)) { font-family: "Segoe WPC", "Segoe UI", "Microsoft Jhenghei", sans-serif; }
	:host-context(.windows:lang(ja)) { font-family: "Segoe WPC", "Segoe UI", "Yu Gothic UI", "Meiryo UI", sans-serif; }
	:host-context(.windows:lang(ko)) { font-family: "Segoe WPC", "Segoe UI", "Malgun Gothic", "Dotom", sans-serif; }

	:host-context(.linux) { font-family: system-ui, "Ubuntu", "Droid Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hans)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans SC", "Source Han Sans CN", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(zh-Hant)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans TC", "Source Han Sans TW", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ja)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans J", "Source Han Sans JP", "Source Han Sans", sans-serif; }
	:host-context(.linux:lang(ko)) { font-family: system-ui, "Ubuntu", "Droid Sans", "Source Han Sans K", "Source Han Sans JR", "Source Han Sans", "UnDotum", "FBaekmuk Gulim", sans-serif; }
`}),define(we[137],ve([1,0,4,22]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8U=R,t.$9U=L,i=We(i);const M=new RegExp(`(\\\\)?\\$\\((${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?)\\)`,"g");function R(v){const E=new Array;let f,$=0,A=0;for(;(f=M.exec(v))!==null;){A=f.index||0,$<A&&E.push(v.substring($,A)),$=(f.index||0)+f[0].length;const[,b,m]=f;E.push(b?`$(${m})`:L({id:m}))}return $<v.length&&E.push(v.substring($)),E}function L(v){const E=i.$("span");return E.classList.add(...n.ThemeIcon.asClassNameArray(v)),E}}),define(we[138],ve([1,0,4]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KU=void 0;class n{constructor(R){this.d=R,this.a=new Map,this.b=new Set,this.c=!1}alloc(R){let L=this.g(R).pop(),v=!1;if(L)v=this.b.has(L.domNode),v&&this.b.delete(L.domNode);else{const E=(0,i.$)(".monaco-list-row"),$=this.h(R).renderTemplate(E);L={domNode:E,templateId:R,templateData:$}}return{row:L,isReusingConnectedDomNode:v}}release(R){R&&this.e(R)}transact(R){if(this.c)throw new Error("Already in transaction");this.c=!0;try{R()}finally{for(const L of this.b)this.f(L);this.b.clear(),this.c=!1}}e(R){const{domNode:L,templateId:v}=R;L&&(this.c?this.b.add(L):this.f(L)),this.g(v).push(R)}f(R){R.classList.remove("scrolling"),R.remove()}g(R){let L=this.a.get(R);return L||(L=[],this.a.set(R,L)),L}dispose(){this.a.forEach((R,L)=>{for(const v of R)this.h(L).disposeTemplate(v.templateData),v.templateData=null}),this.a.clear(),this.b.clear()}h(R){const L=this.d.get(R);if(!L)throw new Error(`No renderer found for ${R}`);return L}}t.$KU=n}),define(we[139],ve([1,0,12,2,20]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cU=void 0;class R extends n.$Wc{constructor(v,E,f){super(),this.a=v,this.b=E,this.c=f,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$Ph)}setVisibility(v){this.a!==v&&(this.a=v,this.s())}setShouldBeVisible(v){this.g=v,this.s()}r(){return this.a===M.ScrollbarVisibility.Hidden?!1:this.a===M.ScrollbarVisibility.Visible?!0:this.g}s(){const v=this.r();this.h!==v&&(this.h=v,this.ensureVisibility())}setIsNeeded(v){this.j!==v&&(this.j=v,this.ensureVisibility())}setDomNode(v){this.f=v,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(v){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(v?" fade":"")))}}t.$cU=R}),define(we[140],ve([1,0,4,33,9,3,8,2,5]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fV=void 0,i=We(i),M=We(M);class f extends v.$Wc{constructor(A,b,m,e){super(),this.f=0,this.b=e||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new R.$me),this.h=m,this.j(),this.setOptions(A,b)}j(){this.B(n.$7T.addTarget(this.a)),[n.EventType.Tap].forEach(A=>{this.B(i.$pS(this.a,A,b=>{this.a.focus()}))}),this.B(i.$qS(this.a,"click",A=>{i.$rT.stop(A,!0)})),this.B(i.$qS(this.a,"change",A=>{this.a.title=A.target.value,this.g.fire({index:A.target.selectedIndex,selected:A.target.value})})),this.B(i.$qS(this.a,"keydown",A=>{let b=!1;E.$j?(A.keyCode===L.KeyCode.DownArrow||A.keyCode===L.KeyCode.UpArrow||A.keyCode===L.KeyCode.Space)&&(b=!0):(A.keyCode===L.KeyCode.DownArrow&&A.altKey||A.keyCode===L.KeyCode.Space||A.keyCode===L.KeyCode.Enter)&&(b=!0),b&&A.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(A,b){(!this.c||!M.$wb(this.c,A))&&(this.c=A,this.a.options.length=0,this.c.forEach((m,e)=>{this.a.add(this.m(m.text,e,m.isDisabled))})),b!==void 0&&this.select(b)}select(A){this.c.length===0?this.f=0:A>=0&&A<this.c.length?this.f=A:A>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(A){this.b.ariaLabel=A,this.a.setAttribute("aria-label",A)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setEnabled(A){this.a.disabled=!A}setFocusable(A){this.a.tabIndex=A?0:-1}render(A){A.classList.add("select-container"),A.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(A){this.h=A,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(A,b,m){const e=document.createElement("option");return e.value=A,e.text=A,e.disabled=!!m,e}}t.$fV=f}),define(we[76],ve([1,0,35,9,12,63,105,3,37]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SW=void 0,t.$QW=f,t.$RW=$;function f(m){return typeof m=="object"&&"visibility"in m&&"data"in m}function $(m){switch(m){case!0:return i.TreeVisibility.Visible;case!1:return i.TreeVisibility.Hidden;default:return m}}function A(m){return typeof m.collapsible=="boolean"}class b{constructor(e,s,o,h={}){this.p=e,this.q=s,this.rootRef=[],this.d=new v.$ue,this.f=new v.$me,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new v.$me,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new v.$me,this.onDidSplice=this.m.event,this.o=new M.$Ch(R.$he),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.allowNonCollapsibleParents??!1,this.k=h.filter,this.l=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0}}splice(e,s,o=E.Iterable.empty(),h={}){if(e.length===0)throw new i.$OW(this.p,"Invalid tree location");h.diffIdentityProvider?this.s(h.diffIdentityProvider,e,s,o,h):this.t(e,s,o,h)}s(e,s,o,h=E.Iterable.empty(),c,p=c.diffDepth??0){const{parentNode:k}=this.H(s);if(!k.lastDiffIds)return this.t(s,o,h,c);const y=[...h],r=s[s.length-1],d=new L.$Ot({getElements:()=>k.lastDiffIds},{getElements:()=>[...k.children.slice(0,r),...y,...k.children.slice(r+o)].map(H=>e.getId(H.element).toString())}).ComputeDiff(!1);if(d.quitEarly)return k.lastDiffIds=void 0,this.t(s,o,y,c);const D=s.slice(0,-1),T=(H,w,C)=>{if(p>0)for(let W=0;W<C;W++)H--,w--,this.s(e,[...D,H,0],Number.MAX_SAFE_INTEGER,y[w].children,c,p-1)};let U=Math.min(k.children.length,r+o),_=y.length;for(const H of d.changes.sort((w,C)=>C.originalStart-w.originalStart))T(U,_,U-(H.originalStart+H.originalLength)),U=H.originalStart,_=H.modifiedStart-r,this.t([...D,U],H.originalLength,E.Iterable.slice(y,_,_+H.modifiedLength),c);T(U,_,U)}t(e,s,o=E.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:c,diffIdentityProvider:p}){const{parentNode:k,listIndex:y,revealed:r,visible:d}=this.H(e),D=[],T=E.Iterable.map(o,z=>this.x(z,k,k.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,r,D,h)),U=e[e.length-1];let _=0;for(let z=U;z>=0&&z<k.children.length;z--){const J=k.children[z];if(J.visible){_=J.visibleChildIndex;break}}const H=[];let w=0,C=0;for(const z of T)H.push(z),C+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=_+w++);const W=(0,n.$7b)(k.children,U,s,H);p?k.lastDiffIds?(0,n.$7b)(k.lastDiffIds,U,s,H.map(z=>p.getId(z.element).toString())):k.lastDiffIds=k.children.map(z=>p.getId(z.element).toString()):k.lastDiffIds=void 0;let O=0;for(const z of W)z.visible&&O++;if(O!==0)for(let z=U+H.length;z<k.children.length;z++){const J=k.children[z];J.visible&&(J.visibleChildIndex-=O)}if(k.visibleChildrenCount+=w-O,r&&d){const z=W.reduce((J,X)=>J+(X.visible?X.renderNodeCount:0),0);this.C(k,C-z),this.q.splice(y,z,D)}if(W.length>0&&c){const z=J=>{c(J),J.children.forEach(z)};W.forEach(z)}this.m.fire({insertedNodes:H,deletedNodes:W});let B=k;for(;B;){if(B.visibility===i.TreeVisibility.Recurse){this.o.trigger(()=>this.refilter());break}B=B.parent}}rerender(e){if(e.length===0)throw new i.$OW(this.p,"Invalid tree location");const{node:s,listIndex:o,revealed:h}=this.G(e);s.visible&&h&&this.q.splice(o,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new i.$OW(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,s)}has(e){return this.E(e)}getListIndex(e){const{listIndex:s,visible:o,revealed:h}=this.G(e);return o&&h?s:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,s){const o=this.F(e);typeof s>"u"&&(s=!o.collapsible);const h={collapsible:s};return this.d.bufferEvents(()=>this.u(e,h))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,s,o){const h=this.F(e);typeof s>"u"&&(s=!h.collapsed);const c={collapsed:s,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,c))}u(e,s){const{node:o,listIndex:h,revealed:c}=this.G(e),p=this.v(o,h,c,s);if(o!==this.c&&this.l&&p&&!A(s)&&o.collapsible&&!o.collapsed&&!s.recursive){let k=-1;for(let y=0;y<o.children.length;y++)if(o.children[y].visible)if(k>-1){k=-1;break}else k=y;k>-1&&this.u([...e,k],s)}return p}v(e,s,o,h){const c=this.w(e,h,!1);if(!o||!e.visible||!c)return c;const p=e.renderNodeCount,k=this.y(e),y=p-(s===-1?0:1);return this.q.splice(s+1,y,k.slice(1)),c}w(e,s,o){let h;if(e===this.c?h=!1:(A(s)?(h=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(h=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):h=!1,h&&this.f.fire({node:e,deep:o})),!A(s)&&s.recursive)for(const c of e.children)h=this.w(c,s,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let s=this.F(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.A(this.c);this.q.splice(0,e,s),this.o.cancel()}x(e,s,o,h,c,p){const k={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:i.TreeVisibility.Visible,visible:!0,filterData:void 0},y=this.D(k,o);k.visibility=y,h&&c.push(k);const r=e.children||E.Iterable.empty(),d=h&&y!==i.TreeVisibility.Hidden&&!k.collapsed;let D=0,T=1;for(const U of r){const _=this.x(U,k,y,d,c,p);k.children.push(_),T+=_.renderNodeCount,_.visible&&(_.visibleChildIndex=D++)}return this.j||(k.collapsible=k.collapsible||k.children.length>0),k.visibleChildrenCount=D,k.visible=y===i.TreeVisibility.Recurse?D>0:y===i.TreeVisibility.Visible,k.visible?k.collapsed||(k.renderNodeCount=T):(k.renderNodeCount=0,h&&c.pop()),p?.(k),k}y(e){const s=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-s),o}z(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,s);return this.g.fire(e),e.renderNodeCount}A(e){const s=e.renderNodeCount,o=[];return this.B(e,e.visible?i.TreeVisibility.Visible:i.TreeVisibility.Hidden,o),this.C(e.parent,o.length-s),o}B(e,s,o,h=!0){let c;if(e!==this.c){if(c=this.D(e,s),c===i.TreeVisibility.Hidden)return e.visible=!1,e.renderNodeCount=0,!1;h&&o.push(e)}const p=o.length;e.renderNodeCount=e===this.c?0:1;let k=!1;if(!e.collapsed||c!==i.TreeVisibility.Hidden){let y=0;for(const r of e.children)k=this.B(r,c,o,h&&!e.collapsed)||k,r.visible&&(r.visibleChildIndex=y++);e.visibleChildrenCount=y}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=c===i.TreeVisibility.Recurse?k:c===i.TreeVisibility.Visible,e.visibility=c),e.visible?e.collapsed||(e.renderNodeCount+=o.length-p):(e.renderNodeCount=0,h&&o.pop()),this.g.fire(e),e.visible}C(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}D(e,s){const o=this.k?this.k.filter(e.element,s):i.TreeVisibility.Visible;return typeof o=="boolean"?(e.filterData=void 0,o?i.TreeVisibility.Visible:i.TreeVisibility.Hidden):f(o)?(e.filterData=o.data,$(o.visibility)):(e.filterData=void 0,$(o))}E(e,s=this.c){if(!e||e.length===0)return!0;const[o,...h]=e;return o<0||o>s.children.length?!1:this.E(h,s.children[o])}F(e,s=this.c){if(!e||e.length===0)return s;const[o,...h]=e;if(o<0||o>s.children.length)throw new i.$OW(this.p,"Invalid tree location");return this.F(h,s.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:o,revealed:h,visible:c}=this.H(e),p=e[e.length-1];if(p<0||p>s.children.length)throw new i.$OW(this.p,"Invalid tree location");const k=s.children[p];return{node:k,listIndex:o,revealed:h,visible:c&&k.visible}}H(e,s=this.c,o=0,h=!0,c=!0){const[p,...k]=e;if(p<0||p>s.children.length)throw new i.$OW(this.p,"Invalid tree location");for(let y=0;y<p;y++)o+=s.children[y].renderNodeCount;return h=h&&!s.collapsed,c=c&&s.visible,k.length===0?{parentNode:s,listIndex:o,revealed:h,visible:c}:this.H(k,s.children[p],o+1,h,c)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const s=[];let o=e;for(;o.parent;)s.push(o.parent.children.indexOf(o)),o=o.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,n.$vb)(e)[0]}getFirstElementChild(e){const s=this.F(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.F(e);if(s.children.length!==0)return this.I(s)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$SW=b}),define(we[141],ve([1,0,76,35,37]),function(ne,t,i,n,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZW=void 0;class R{get size(){return this.d.size}constructor(v,E,f={}){this.k=v,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$SW(v,E,null,f),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,f.sorter&&(this.j={compare($,A){return f.sorter.compare($.element,A.element)}}),this.h=f.identityProvider}setChildren(v,E=M.Iterable.empty(),f={}){const $=this.o(v);this.l($,this.m(E),f)}l(v,E=M.Iterable.empty(),f){const $=new Set,A=new Set,b=e=>{if(e.element===null)return;const s=e;if($.add(s.element),this.d.set(s.element,s),this.h){const o=this.h.getId(s.element).toString();A.add(o),this.f.set(o,s)}f.onDidCreateNode?.(s)},m=e=>{if(e.element===null)return;const s=e;if($.has(s.element)||this.d.delete(s.element),this.h){const o=this.h.getId(s.element).toString();A.has(o)||this.f.delete(o)}f.onDidDeleteNode?.(s)};this.c.splice([...v,0],Number.MAX_VALUE,E,{...f,onDidCreateNode:b,onDidDeleteNode:m})}m(v=M.Iterable.empty()){return this.j&&(v=[...v].sort(this.j.compare.bind(this.j))),M.Iterable.map(v,E=>{let f=this.d.get(E.element);if(!f&&this.h){const b=this.h.getId(E.element).toString();f=this.f.get(b)}if(!f){let b;return typeof E.collapsed>"u"?b=void 0:E.collapsed===n.ObjectTreeElementCollapseState.Collapsed||E.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed?b=!0:E.collapsed===n.ObjectTreeElementCollapseState.Expanded||E.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?b=!1:b=!!E.collapsed,{...E,children:this.m(E.children),collapsed:b}}const $=typeof E.collapsible=="boolean"?E.collapsible:f.collapsible;let A;return typeof E.collapsed>"u"||E.collapsed===n.ObjectTreeElementCollapseState.PreserveOrCollapsed||E.collapsed===n.ObjectTreeElementCollapseState.PreserveOrExpanded?A=f.collapsed:E.collapsed===n.ObjectTreeElementCollapseState.Collapsed?A=!0:E.collapsed===n.ObjectTreeElementCollapseState.Expanded?A=!1:A=!!E.collapsed,{...E,collapsible:$,collapsed:A,children:this.m(E.children)}})}rerender(v){const E=this.o(v);this.c.rerender(E)}updateElementHeight(v,E){const f=this.o(v);this.c.updateElementHeight(f,E)}resort(v=null,E=!0){if(!this.j)return;const f=this.o(v),$=this.c.getNode(f);this.l(f,this.n($,E),{})}n(v,E,f=!0){let $=[...v.children];return(E||f)&&($=$.sort(this.j.compare.bind(this.j))),M.Iterable.map($,A=>({element:A.element,collapsible:A.collapsible,collapsed:A.collapsed,children:this.n(A,E,!1)}))}getFirstElementChild(v=null){const E=this.o(v);return this.c.getFirstElementChild(E)}getLastElementAncestor(v=null){const E=this.o(v);return this.c.getLastElementAncestor(E)}has(v){return this.d.has(v)}getListIndex(v){const E=this.o(v);return this.c.getListIndex(E)}getListRenderCount(v){const E=this.o(v);return this.c.getListRenderCount(E)}isCollapsible(v){const E=this.o(v);return this.c.isCollapsible(E)}setCollapsible(v,E){const f=this.o(v);return this.c.setCollapsible(f,E)}isCollapsed(v){const E=this.o(v);return this.c.isCollapsed(E)}setCollapsed(v,E,f){const $=this.o(v);return this.c.setCollapsed($,E,f)}expandTo(v){const E=this.o(v);this.c.expandTo(E)}refilter(){this.c.refilter()}getNode(v=null){if(v===null)return this.c.getNode(this.c.rootRef);const E=this.d.get(v);if(!E)throw new n.$OW(this.k,`Tree element not found: ${v}`);return E}getNodeLocation(v){return v.element}getParentNodeLocation(v){if(v===null)throw new n.$OW(this.k,"Invalid getParentNodeLocation call");const E=this.d.get(v);if(!E)throw new n.$OW(this.k,`Tree element not found: ${v}`);const f=this.c.getNodeLocation(E),$=this.c.getParentNodeLocation(f);return this.c.getNode($).element}o(v){if(v===null)return[];const E=this.d.get(v);if(!E)throw new n.$OW(this.k,`Tree element not found: ${v}`);return this.c.getNodeLocation(E)}}t.$ZW=R}),define(we[24],ve([1,0,4,16,23,33,2]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$T=void 0,i=We(i);class v extends L.$Wc{f(f,$){this.B(i.$pS(f,i.$pT.CLICK,A=>$(new M.$hS(i.getWindow(f),A))))}j(f,$){this.B(i.$pS(f,i.$pT.MOUSE_DOWN,A=>$(new M.$hS(i.getWindow(f),A))))}m(f,$){this.B(i.$pS(f,i.$pT.MOUSE_OVER,A=>$(new M.$hS(i.getWindow(f),A))))}u(f,$){this.B(i.$pS(f,i.$pT.MOUSE_LEAVE,A=>$(new M.$hS(i.getWindow(f),A))))}z(f,$){this.B(i.$pS(f,i.$pT.KEY_DOWN,A=>$(new n.$mS(A))))}C(f,$){this.B(i.$pS(f,i.$pT.KEY_UP,A=>$(new n.$mS(A))))}D(f,$){this.B(i.$pS(f,i.$pT.INPUT,$))}F(f,$){this.B(i.$pS(f,i.$pT.BLUR,$))}G(f,$){this.B(i.$pS(f,i.$pT.FOCUS,$))}H(f,$){this.B(i.$pS(f,i.$pT.CHANGE,$))}I(f){return R.$7T.ignoreTarget(f)}}t.$$T=v}),define(we[53],ve([1,0,73,24,12,22,4]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aU=t.$_T=void 0,L=We(L),t.$_T=11;class v extends n.$$T{constructor(f){super(),this.a=f.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=f.bgWidth+"px",this.bgDomNode.style.height=f.bgHeight+"px",typeof f.top<"u"&&(this.bgDomNode.style.top="0px"),typeof f.left<"u"&&(this.bgDomNode.style.left="0px"),typeof f.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof f.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=f.className,this.domNode.classList.add(...R.ThemeIcon.asClassNameArray(f.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$_T+"px",this.domNode.style.height=t.$_T+"px",typeof f.top<"u"&&(this.domNode.style.top=f.top+"px"),typeof f.left<"u"&&(this.domNode.style.left=f.left+"px"),typeof f.bottom<"u"&&(this.domNode.style.bottom=f.bottom+"px"),typeof f.right<"u"&&(this.domNode.style.right=f.right+"px"),this.g=this.B(new i.$0T),this.B(L.$qS(this.bgDomNode,L.$pT.POINTER_DOWN,$=>this.h($))),this.B(L.$qS(this.domNode,L.$pT.POINTER_DOWN,$=>this.h($))),this.b=this.B(new L.$BS),this.c=this.B(new M.$Ph)}h(f){if(!f.target||!(f.target instanceof Element))return;const $=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,L.getWindow(f))};this.a(),this.b.cancel(),this.c.cancelAndSet($,200),this.g.startMonitoring(f.target,f.pointerId,f.buttons,A=>{},()=>{this.b.cancel(),this.c.cancel()}),f.preventDefault()}}t.$aU=v}),define(we[77],ve([1,0,4,56,73,53,139,24,5]),function(ne,t,i,n,M,R,L,v,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dU=void 0,i=We(i),E=We(E);const f=140;class $ extends v.$$T{constructor(b){super(),this.g=b.lazyRender,this.a=b.host,this.b=b.scrollable,this.c=b.scrollByPage,this.h=b.scrollbarState,this.n=this.B(new L.$cU(b.visibility,"visible scrollbar "+b.extraScrollbarClassName,"invisible scrollbar "+b.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new M.$0T),this.s=!0,this.domNode=(0,n.$9T)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$pS(this.domNode.domNode,i.$pT.POINTER_DOWN,m=>this.M(m)))}t(b){const m=this.B(new R.$aU(b));this.domNode.domNode.appendChild(m.bgDomNode),this.domNode.domNode.appendChild(m.domNode)}w(b,m,e,s){this.slider=(0,n.$9T)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(b),this.slider.setLeft(m),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$pS(this.slider.domNode,i.$pT.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(b){return this.h.setVisibleSize(b)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(b){return this.h.setScrollSize(b)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(b){return this.h.setScrollPosition(b)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(b){b.target===this.domNode.domNode&&this.N(b)}delegatePointerDown(b){const m=this.domNode.domNode.getClientRects()[0].top,e=m+this.h.getSliderPosition(),s=m+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(b);e<=o&&o<=s?b.button===0&&(b.preventDefault(),this.O(b)):this.N(b)}N(b){let m,e;if(b.target===this.domNode.domNode&&typeof b.offsetX=="number"&&typeof b.offsetY=="number")m=b.offsetX,e=b.offsetY;else{const o=i.$LS(this.domNode.domNode);m=b.pageX-o.left,e=b.pageY-o.top}const s=this.S(m,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),b.button===0&&(b.preventDefault(),this.O(b))}O(b){if(!b.target||!(b.target instanceof Element))return;const m=this.U(b),e=this.W(b),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(b.target,b.pointerId,b.buttons,o=>{const h=this.W(o),c=Math.abs(h-e);if(E.$i&&c>f){this.P(s.getScrollPosition());return}const k=this.U(o)-m;this.P(s.getDesiredScrollPositionFromDelta(k))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(b){const m={};this.writeScrollPosition(m,b),this.b.setScrollPositionNow(m)}updateScrollbarSize(b){this.X(b),this.h.setScrollbarSize(b),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$dU=$}),define(we[142],ve([1,0,23,77,53,57,21,20]),function(ne,t,i,n,M,R,L,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eU=void 0;class E extends n.$dU{constructor($,A,b){const m=$.getScrollDimensions(),e=$.getCurrentScrollPosition();if(super({lazyRender:A.lazyRender,host:b,scrollbarState:new R.$bU(A.horizontalHasArrows?A.arrowSize:0,A.horizontal===v.ScrollbarVisibility.Hidden?0:A.horizontalScrollbarSize,A.vertical===v.ScrollbarVisibility.Hidden?0:A.verticalScrollbarSize,m.width,m.scrollWidth,e.scrollLeft),visibility:A.horizontal,extraScrollbarClassName:"horizontal",scrollable:$,scrollByPage:A.scrollByPage}),A.horizontalHasArrows){const s=(A.arrowSize-M.$_T)/2,o=(A.horizontalScrollbarSize-M.$_T)/2;this.t({className:"scra",icon:L.$5j.scrollbarButtonLeft,top:o,left:s,bottom:void 0,right:void 0,bgWidth:A.arrowSize,bgHeight:A.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$jS(null,1,0))}),this.t({className:"scra",icon:L.$5j.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:s,bgWidth:A.arrowSize,bgHeight:A.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$jS(null,-1,0))})}this.w(Math.floor((A.horizontalScrollbarSize-A.horizontalSliderSize)/2),0,void 0,A.horizontalSliderSize)}R($,A){this.slider.setWidth($),this.slider.setLeft(A)}Q($,A){this.domNode.setWidth($),this.domNode.setHeight(A),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll($){return this.s=this.J($.scrollWidth)||this.s,this.s=this.L($.scrollLeft)||this.s,this.s=this.y($.width)||this.s,this.s}S($,A){return $}U($){return $.pageX}W($){return $.pageY}X($){this.slider.setHeight($)}writeScrollPosition($,A){$.scrollLeft=A}updateOptions($){this.updateScrollbarSize($.horizontal===v.ScrollbarVisibility.Hidden?0:$.horizontalScrollbarSize),this.h.setOppositeScrollbarSize($.vertical===v.ScrollbarVisibility.Hidden?0:$.verticalScrollbarSize),this.n.setVisibility($.horizontal),this.c=$.scrollByPage}}t.$eU=E}),define(we[143],ve([1,0,23,77,53,57,21,20]),function(ne,t,i,n,M,R,L,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fU=void 0;class E extends n.$dU{constructor($,A,b){const m=$.getScrollDimensions(),e=$.getCurrentScrollPosition();if(super({lazyRender:A.lazyRender,host:b,scrollbarState:new R.$bU(A.verticalHasArrows?A.arrowSize:0,A.vertical===v.ScrollbarVisibility.Hidden?0:A.verticalScrollbarSize,0,m.height,m.scrollHeight,e.scrollTop),visibility:A.vertical,extraScrollbarClassName:"vertical",scrollable:$,scrollByPage:A.scrollByPage}),A.verticalHasArrows){const s=(A.arrowSize-M.$_T)/2,o=(A.verticalScrollbarSize-M.$_T)/2;this.t({className:"scra",icon:L.$5j.scrollbarButtonUp,top:s,left:o,bottom:void 0,right:void 0,bgWidth:A.verticalScrollbarSize,bgHeight:A.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$jS(null,0,1))}),this.t({className:"scra",icon:L.$5j.scrollbarButtonDown,top:void 0,left:o,bottom:s,right:void 0,bgWidth:A.verticalScrollbarSize,bgHeight:A.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$jS(null,0,-1))})}this.w(0,Math.floor((A.verticalScrollbarSize-A.verticalSliderSize)/2),A.verticalSliderSize,void 0)}R($,A){this.slider.setHeight($),this.slider.setTop(A)}Q($,A){this.domNode.setWidth(A),this.domNode.setHeight($),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll($){return this.s=this.J($.scrollHeight)||this.s,this.s=this.L($.scrollTop)||this.s,this.s=this.y($.height)||this.s,this.s}S($,A){return A}U($){return $.pageY}W($){return $.pageX}X($){this.slider.setWidth($)}writeScrollPosition($,A){$.scrollTop=A}updateOptions($){this.updateScrollbarSize($.vertical===v.ScrollbarVisibility.Hidden?0:$.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility($.vertical),this.c=$.scrollByPage}}t.$fU=E}),define(we[78],ve([1,0,19,4,56,23,142,143,24,12,3,2,5,20,118]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kU=t.$jU=t.$iU=t.$hU=t.$gU=void 0,n=We(n),b=We(b);const e=500,s=50,o=!0;class h{constructor(T,U,_){this.timestamp=T,this.deltaX=U,this.deltaY=_,this.score=0}}class c{static{this.INSTANCE=new c}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,U=0,_=1,H=this.d;do{const w=H===this.c?T:Math.pow(2,-_);if(T-=w,U+=this.b[H].score*w,H===this.c)break;H=(this.a+H-1)%this.a,_++}while(!0);return U<=.5}acceptStandardWheelEvent(T){if(i.$0R){const U=n.getWindow(T.browserEvent),_=(0,i.$3R)(U);this.accept(Date.now(),T.deltaX*_,T.deltaY*_)}else this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,U,_){let H=null;const w=new h(T,U,_);this.c===-1&&this.d===-1?(this.b[0]=w,this.c=0,this.d=0):(H=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=w),w.score=this.f(w,H)}f(T,U){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let _=.5;if((!this.g(T.deltaX)||!this.g(T.deltaY))&&(_+=.25),U){const H=Math.abs(T.deltaX),w=Math.abs(T.deltaY),C=Math.abs(U.deltaX),W=Math.abs(U.deltaY),O=Math.max(Math.min(H,C),1),B=Math.max(Math.min(w,W),1),z=Math.max(H,C),J=Math.max(w,W);z%O===0&&J%B===0&&(_-=.5)}return Math.min(Math.max(_,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.$gU=c;class p extends E.$$T{get options(){return this.a}constructor(T,U,_){super(),this.O=this.B(new $.$me),this.onScroll=this.O.event,this.P=this.B(new $.$me),this.onWillScroll=this.P.event,T.style.overflow="hidden",this.a=d(U),this.b=_,this.B(this.b.onScroll(w=>{this.P.fire(w),this.S(w),this.O.fire(w)}));const H={onMouseWheel:w=>this.R(w),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new v.$fU(this.b,this.a,H)),this.g=this.B(new L.$eU(this.b,this.a,H)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,M.$9T)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,M.$9T)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,M.$9T)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,w=>this.Z(w)),this.u(this.t,w=>this.Y(w)),this.L=this.B(new f.$Ph),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,A.$Rc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,b.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(T){this.N=T}delegateScrollFromMouseWheelEvent(T){this.R(new R.$jS(T))}Q(T){if(this.w.length>0!==T&&(this.w=(0,A.$Rc)(this.w),T)){const _=H=>{this.R(new R.$jS(H))};this.w.push(n.$pS(this.t,n.$pT.MOUSE_WHEEL,_,{passive:!1}))}}R(T){if(T.browserEvent?.defaultPrevented)return;const U=c.INSTANCE;o&&U.acceptStandardWheelEvent(T);let _=!1;if(T.deltaY||T.deltaX){let w=T.deltaY*this.a.mouseWheelScrollSensitivity,C=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&C+w===0?C=w=0:Math.abs(w)>=Math.abs(C)?C=0:w=0),this.a.flipAxes&&([w,C]=[C,w]);const W=!b.$j&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||W)&&!C&&(C=w,w=0),T.browserEvent&&T.browserEvent.altKey&&(C=C*this.a.fastScrollSensitivity,w=w*this.a.fastScrollSensitivity);const O=this.b.getFutureScrollPosition();let B={};if(w){const z=s*w,J=O.scrollTop-(z<0?Math.floor(z):Math.ceil(z));this.c.writeScrollPosition(B,J)}if(C){const z=s*C,J=O.scrollLeft-(z<0?Math.floor(z):Math.ceil(z));this.g.writeScrollPosition(B,J)}B=this.b.validateScrollPosition(B),(O.scrollLeft!==B.scrollLeft||O.scrollTop!==B.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&U.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(B):this.b.setScrollPositionNow(B),_=!0)}let H=_;!H&&this.a.alwaysConsumeMouseWheel&&(H=!0),!H&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(H=!0),H&&(T.preventDefault(),T.stopPropagation())}S(T){this.M=this.g.onDidScroll(T)||this.M,this.M=this.c.onDidScroll(T)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),U=T.scrollTop>0,_=T.scrollLeft>0,H=_?" left":"",w=U?" top":"",C=_||U?" top-left-corner":"";this.n.setClassName(`shadow${H}`),this.r.setClassName(`shadow${w}`),this.s.setClassName(`shadow${C}${w}${H}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(T){this.J=!1,this.ab()}Z(T){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$hU=p;class k extends p{constructor(T,U){U=U||{},U.mouseWheelSmoothScroll=!1;const _=new m.$$s({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:H=>n.$zS(n.getWindow(T),H)});super(T,U,_),this.B(_)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$iU=k;class y extends p{constructor(T,U,_){super(T,U,_)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$jU=y;class r extends p{constructor(T,U){U=U||{},U.mouseWheelSmoothScroll=!1;const _=new m.$$s({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:H=>n.$zS(n.getWindow(T),H)});super(T,U,_),this.B(_),this.cb=T,this.B(this.onScroll(H=>{H.scrollTopChanged&&(this.cb.scrollTop=H.scrollTop),H.scrollLeftChanged&&(this.cb.scrollLeft=H.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$kU=r;function d(D){const T={lazyRender:typeof D.lazyRender<"u"?D.lazyRender:!1,className:typeof D.className<"u"?D.className:"",useShadows:typeof D.useShadows<"u"?D.useShadows:!0,handleMouseWheel:typeof D.handleMouseWheel<"u"?D.handleMouseWheel:!0,flipAxes:typeof D.flipAxes<"u"?D.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof D.consumeMouseWheelIfScrollbarIsNeeded<"u"?D.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof D.alwaysConsumeMouseWheel<"u"?D.alwaysConsumeMouseWheel:!1,scrollYToX:typeof D.scrollYToX<"u"?D.scrollYToX:!1,mouseWheelScrollSensitivity:typeof D.mouseWheelScrollSensitivity<"u"?D.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof D.fastScrollSensitivity<"u"?D.fastScrollSensitivity:5,scrollPredominantAxis:typeof D.scrollPredominantAxis<"u"?D.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof D.mouseWheelSmoothScroll<"u"?D.mouseWheelSmoothScroll:!0,arrowSize:typeof D.arrowSize<"u"?D.arrowSize:11,listenOnDomNode:typeof D.listenOnDomNode<"u"?D.listenOnDomNode:null,horizontal:typeof D.horizontal<"u"?D.horizontal:m.ScrollbarVisibility.Auto,horizontalScrollbarSize:typeof D.horizontalScrollbarSize<"u"?D.horizontalScrollbarSize:10,horizontalSliderSize:typeof D.horizontalSliderSize<"u"?D.horizontalSliderSize:0,horizontalHasArrows:typeof D.horizontalHasArrows<"u"?D.horizontalHasArrows:!1,vertical:typeof D.vertical<"u"?D.vertical:m.ScrollbarVisibility.Auto,verticalScrollbarSize:typeof D.verticalScrollbarSize<"u"?D.verticalScrollbarSize:10,verticalHasArrows:typeof D.verticalHasArrows<"u"?D.verticalHasArrows:!1,verticalSliderSize:typeof D.verticalSliderSize<"u"?D.verticalSliderSize:0,scrollByPage:typeof D.scrollByPage<"u"?D.scrollByPage:!1};return T.horizontalSliderSize=typeof D.horizontalSliderSize<"u"?D.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof D.verticalSliderSize<"u"?D.verticalSliderSize:T.verticalScrollbarSize,b.$j&&(T.className+=" mac"),T}}),define(we[79],ve([1,0,71,4,29,33,78,9,12,36,3,2,47,20,42,98,138,6,38]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o,h,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OU=t.$NU=t.$MU=t.$LU=t.ListViewTargetSector=void 0;const p={CurrentDragAndDropData:void 0};var k;(function(H){H[H.TOP=0]="TOP",H[H.CENTER_TOP=1]="CENTER_TOP",H[H.CENTER_BOTTOM=2]="CENTER_BOTTOM",H[H.BOTTOM=3]="BOTTOM"})(k||(t.ListViewTargetSector=k={}));const y={useShadows:!0,verticalScrollMode:m.ScrollbarVisibility.Auto,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(H){return[H]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(w){this.d=w}constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$LU=r;class d{constructor(w){this.elements=w}update(){}getData(){return this.elements}}t.$MU=d;class D{constructor(){this.types=[],this.files=[]}update(w){if(w.types&&this.types.splice(0,this.types.length,...w.types),w.files){this.files.splice(0,this.files.length);for(let C=0;C<w.files.length;C++){const W=w.files.item(C);W&&(W.size||W.type)&&this.files.push(W)}}}getData(){return{types:this.types,files:this.files}}}t.$NU=D;function T(H,w){return Array.isArray(H)&&Array.isArray(w)?(0,v.$wb)(H,w):H===w}class U{constructor(w){w?.getSetSize?this.getSetSize=w.getSetSize.bind(w):this.getSetSize=(C,W,O)=>O,w?.getPosInSet?this.getPosInSet=w.getPosInSet.bind(w):this.getPosInSet=(C,W)=>W+1,w?.getRole?this.getRole=w.getRole.bind(w):this.getRole=C=>"listitem",w?.isChecked?this.isChecked=w.isChecked.bind(w):this.isChecked=C=>{}}}class _{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(w){if(w!==this.P){if(w&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=w,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const C of this.d)this.ab(C);this.X(),this.q.setScrollDimensions({width:(0,n.$OS)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(w,C,W,O=y){if(this.R=C,this.domId=`list_id_${++_.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new E.$Ch(50),this.v=!1,this.x=A.$Wc.None,this.y=0,this.G=!1,this.K=A.$Wc.None,this.L=A.$Wc.None,this.M=new A.$Vc,this.N=new $.$me,this.O=new $.$me,this.onDidChangeContentHeight=$.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=$.Event.latch(this.O.event,void 0,this.M),this.P=!1,O.horizontalScrolling&&O.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(O.paddingTop??0);for(const z of W)this.j.set(z.templateId,z);this.h=this.M.add(new o.$KU(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof O.mouseSupport=="boolean"?O.mouseSupport:!0),this.P=O.horizontalScrolling??y.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof O.paddingBottom>"u"?0:O.paddingBottom,this.D=new U(O.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(O.transformOptimization??y.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(R.$7T.addTarget(this.o)),this.p=this.M.add(new m.$$s({forceIntegerValues:!0,smoothScrollDuration:O.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:z=>(0,n.$zS)((0,n.getWindow)(this.domNode),z)})),this.q=this.M.add(new L.$jU(this.o,{alwaysConsumeMouseWheel:O.alwaysConsumeMouseWheel??y.alwaysConsumeMouseWheel,horizontal:m.ScrollbarVisibility.Auto,vertical:O.verticalScrollMode??y.verticalScrollMode,useShadows:O.useShadows??y.useShadows,mouseWheelScrollSensitivity:O.mouseWheelScrollSensitivity,fastScrollSensitivity:O.fastScrollSensitivity,scrollByPage:O.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),w.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,n.$pS)(this.o,R.EventType.Change,z=>this.jb(z))),this.M.add((0,n.$pS)(this.q.getDomNode(),"scroll",z=>z.target.scrollTop=0)),this.M.add((0,n.$pS)(this.domNode,"dragover",z=>this.lb(this.hb(z)))),this.M.add((0,n.$pS)(this.domNode,"drop",z=>this.nb(this.hb(z)))),this.M.add((0,n.$pS)(this.domNode,"dragleave",z=>this.mb(this.hb(z)))),this.M.add((0,n.$pS)(this.domNode,"dragend",z=>this.ob(z))),this.z=O.setRowLineHeight??y.setRowLineHeight,this.A=O.setRowHeight??y.setRowHeight,this.B=O.supportDynamicHeights??y.supportDynamicHeights,this.F=O.dnd??this.M.add(y.dnd),this.layout(O.initialSize?.height,O.initialSize?.width)}updateOptions(w){w.paddingBottom!==void 0&&(this.C=w.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),w.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(w.smoothScrolling?125:0),w.horizontalScrolling!==void 0&&(this.Q=w.horizontalScrolling);let C;if(w.scrollByPage!==void 0&&(C={...C??{},scrollByPage:w.scrollByPage}),w.mouseWheelScrollSensitivity!==void 0&&(C={...C??{},mouseWheelScrollSensitivity:w.mouseWheelScrollSensitivity}),w.fastScrollSensitivity!==void 0&&(C={...C??{},fastScrollSensitivity:w.fastScrollSensitivity}),C&&this.q.updateOptions(C),w.paddingTop!==void 0&&w.paddingTop!==this.g.paddingTop){const W=this.vb(this.k,this.m),O=w.paddingTop-this.g.paddingTop;this.g.paddingTop=w.paddingTop,this.Y(W,Math.max(0,this.k+O),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(w){this.q.delegateScrollFromMouseWheelEvent(w)}delegateVerticalScrollbarPointerDown(w){this.q.delegateVerticalScrollbarPointerDown(w)}updateElementHeight(w,C,W){if(w<0||w>=this.d.length)return;const O=this.d[w].size;if(typeof C>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[w].lastDynamicHeightWidth=void 0,C=O+this.xb(w)}if(O===C)return;const B=this.vb(this.k,this.m);let z=0;w<B.start||W!==null&&W>w&&W<B.end?z=C-O:z=0,this.g.splice(w,1,[{size:C}]),this.d[w].size=C,this.Y(B,Math.max(0,this.k+z),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(w){return new s.$JU(w)}splice(w,C,W=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(w,C,W)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(w,C,W=[]){const O=this.vb(this.k,this.m),B={start:w,end:w+C},z=b.Range.intersect(O,B),J=new Map;for(let $e=z.end-1;$e>=z.start;$e--){const ye=this.d[$e];if(ye.dragStartDisposable.dispose(),ye.checkedDisposable.dispose(),ye.row){let Oe=J.get(ye.templateId);Oe||(Oe=[],J.set(ye.templateId,Oe));const Re=this.j.get(ye.templateId);Re&&Re.disposeElement&&Re.disposeElement(ye.element,$e,ye.row.templateData,ye.size),Oe.unshift(ye.row)}ye.row=null,ye.stale=!0}const X={start:w+C,end:this.d.length},K=b.Range.intersect(X,O),Q=b.Range.relativeComplement(X,O),he=W.map($e=>({id:String(this.f++),element:$e,templateId:this.R.getTemplateId($e),size:this.R.getHeight($e),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight($e),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:A.$Wc.None,checkedDisposable:A.$Wc.None,stale:!1}));let be;w===0&&C>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,he),be=this.d,this.d=he):(this.g.splice(w,C,he),be=this.d.splice(w,C,...he));const Se=W.length-C,Fe=this.vb(this.k,this.m),se=(0,s.$HU)(K,Se),ee=b.Range.intersect(Fe,se);for(let $e=ee.start;$e<ee.end;$e++)this.bb(this.d[$e],$e);const ce=b.Range.relativeComplement(se,Fe);for(const $e of ce)for(let ye=$e.start;ye<$e.end;ye++)this.db(ye);const ae=Q.map($e=>(0,s.$HU)($e,Se)),te=[{start:w,end:w+W.length},...ae].map($e=>b.Range.intersect(Fe,$e)).reverse();for(const $e of te)for(let ye=$e.end-1;ye>=$e.start;ye--){const Oe=this.d[ye],Ce=J.get(Oe.templateId)?.pop();this.Z(ye,Ce)}for(const $e of J.values())for(const ye of $e)this.h.release(ye);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),be.map($e=>$e.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,n.$zS)((0,n.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let w=0;for(const C of this.d)typeof C.width<"u"&&(w=Math.max(w,C.width));this.E=w,this.q.setScrollDimensions({scrollWidth:w===0?0:w+10}),this.O.fire(this.E)}updateWidth(w){if(!this.Q||typeof this.E>"u")return;const C=this.d[w];this.ab(C),typeof C.width<"u"&&C.width>this.E&&(this.E=C.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const w of this.d)w.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const w=this.firstVisibleIndex,C=this.g.positionAt(w),W=this.g.positionAt(w+1);return W!==-1&&(W-C)/2+C<this.scrollTop?w+1:w}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(w){return this.d[w].element}indexOf(w){return this.d.findIndex(C=>C.element===w)}domElement(w){const C=this.d[w].row;return C&&C.domNode}elementHeight(w){return this.d[w].size}elementTop(w){return this.g.positionAt(w)}indexAt(w){return this.g.indexAt(w)}indexAfter(w){return this.g.indexAfter(w)}layout(w,C){const W={height:typeof w=="number"?w:(0,n.$QS)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,W.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(W),typeof C<"u"&&(this.n=C,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof C=="number"?C:(0,n.$OS)(this.domNode)})}Y(w,C,W,O,B,z=!1){const J=this.vb(C,W),X=b.Range.relativeComplement(J,w).reverse(),K=b.Range.relativeComplement(w,J);if(z){const Q=b.Range.intersect(w,J);for(let he=Q.start;he<Q.end;he++)this.bb(this.d[he],he)}this.h.transact(()=>{for(const Q of K)for(let he=Q.start;he<Q.end;he++)this.db(he);for(const Q of X)for(let he=Q.end-1;he>=Q.start;he--)this.Z(he)}),O!==void 0&&(this.o.style.left=`-${O}px`),this.o.style.top=`-${C}px`,this.Q&&B!==void 0&&(this.o.style.width=`${Math.max(B,this.n)}px`),this.k=C,this.m=W}Z(w,C){const W=this.d[w];if(!W.row)if(C)W.row=C,W.stale=!0;else{const X=this.h.alloc(W.templateId);W.row=X.row,W.stale||=X.isReusingConnectedDomNode}const O=this.D.getRole(W.element)||"listitem";W.row.domNode.setAttribute("role",O);const B=this.D.isChecked(W.element);if(typeof B=="boolean")W.row.domNode.setAttribute("aria-checked",String(!!B));else if(B){const X=K=>W.row.domNode.setAttribute("aria-checked",String(!!K));X(B.value),W.checkedDisposable=B.onDidChange(()=>X(B.value))}if(W.stale||!W.row.domNode.parentElement){const X=this.d.at(w+1)?.row?.domNode??null;(W.row.domNode.parentElement!==this.o||W.row.domNode.nextElementSibling!==X)&&this.o.insertBefore(W.row.domNode,X),W.stale=!1}this.bb(W,w);const z=this.j.get(W.templateId);if(!z)throw new Error(`No renderer found for template id ${W.templateId}`);z?.renderElement(W.element,w,W.row.templateData,W.size);const J=this.F.getDragURI(W.element);W.dragStartDisposable.dispose(),W.row.domNode.draggable=!!J,J&&(W.dragStartDisposable=(0,n.$pS)(W.row.domNode,"dragstart",X=>this.kb(W.element,J,X))),this.Q&&(this.ab(W),this.W())}ab(w){if(!w.row||!w.row.domNode)return;w.row.domNode.style.width="fit-content",w.width=(0,n.$OS)(w.row.domNode);const C=(0,n.getWindow)(w.row.domNode).getComputedStyle(w.row.domNode);C.paddingLeft&&(w.width+=parseFloat(C.paddingLeft)),C.paddingRight&&(w.width+=parseFloat(C.paddingRight)),w.row.domNode.style.width=""}bb(w,C){w.row.domNode.style.top=`${this.elementTop(C)}px`,this.A&&(w.row.domNode.style.height=`${w.size}px`),this.z&&(w.row.domNode.style.lineHeight=`${w.size}px`),w.row.domNode.setAttribute("data-index",`${C}`),w.row.domNode.setAttribute("data-last-element",C===this.length-1?"true":"false"),w.row.domNode.setAttribute("data-parity",C%2===0?"even":"odd"),w.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(w.element,C,this.length))),w.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(w.element,C))),w.row.domNode.setAttribute("id",this.getElementDomId(C)),w.row.domNode.classList.toggle("drop-target",w.dropTarget)}db(w){const C=this.d[w];if(C.dragStartDisposable.dispose(),C.checkedDisposable.dispose(),C.row){const W=this.j.get(C.templateId);W&&W.disposeElement&&W.disposeElement(C.element,w,C.row.templateData,C.size),this.h.release(C.row),C.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(w,C){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:w,reuseAnimation:C})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(w){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:w})}get scrollTop(){return this.getScrollTop()}set scrollTop(w){this.setScrollTop(w)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"click")).event,w=>this.eb(w),this.M)}get onMouseDblClick(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"dblclick")).event,w=>this.eb(w),this.M)}get onMouseMiddleClick(){return $.Event.filter($.Event.map(this.M.add(new M.$BU(this.domNode,"auxclick")).event,w=>this.eb(w),this.M),w=>w.browserEvent.button===1,this.M)}get onMouseUp(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"mouseup")).event,w=>this.eb(w),this.M)}get onMouseDown(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"mousedown")).event,w=>this.eb(w),this.M)}get onMouseOver(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"mouseover")).event,w=>this.eb(w),this.M)}get onMouseMove(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"mousemove")).event,w=>this.eb(w),this.M)}get onMouseOut(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"mouseout")).event,w=>this.eb(w),this.M)}get onContextMenu(){return $.Event.any($.Event.map(this.M.add(new M.$BU(this.domNode,"contextmenu")).event,w=>this.eb(w),this.M),$.Event.map(this.M.add(new M.$BU(this.domNode,R.EventType.Contextmenu)).event,w=>this.gb(w),this.M))}get onTouchStart(){return $.Event.map(this.M.add(new M.$BU(this.domNode,"touchstart")).event,w=>this.fb(w),this.M)}get onTap(){return $.Event.map(this.M.add(new M.$BU(this.o,R.EventType.Tap)).event,w=>this.gb(w),this.M)}eb(w){const C=this.ub(w.target||null),W=typeof C>"u"?void 0:this.d[C],O=W&&W.element;return{browserEvent:w,index:C,element:O}}fb(w){const C=this.ub(w.target||null),W=typeof C>"u"?void 0:this.d[C],O=W&&W.element;return{browserEvent:w,index:C,element:O}}gb(w){const C=this.ub(w.initialTarget||null),W=typeof C>"u"?void 0:this.d[C],O=W&&W.element;return{browserEvent:w,index:C,element:O}}hb(w){const C=this.ub(w.target||null),W=typeof C>"u"?void 0:this.d[C],O=W&&W.element,B=this.tb(w,C);return{browserEvent:w,index:C,element:O,sector:B}}ib(w){try{const C=this.vb(this.k,this.m);this.Y(C,w.scrollTop,w.height,w.scrollLeft,w.scrollWidth),this.B&&this.wb(w.scrollTop,w.height,w.inSmoothScrolling)}catch(C){throw console.error("Got bad scroll event:",w),C}}jb(w){w.preventDefault(),w.stopPropagation(),this.scrollTop-=w.translationY}kb(w,C,W){if(!W.dataTransfer)return;const O=this.F.getDragElements(w);if(W.dataTransfer.effectAllowed="copyMove",W.dataTransfer.setData(i.$5T.TEXT,C),W.dataTransfer.setDragImage){let B;this.F.getDragLabel&&(B=this.F.getDragLabel(O,W)),typeof B>"u"&&(B=String(O.length));const z=(0,n.$)(".monaco-drag-image");z.textContent=B,(K=>{for(;K&&!K.classList.contains("monaco-workbench");)K=K.parentElement;return K||this.domNode.ownerDocument})(this.domNode).appendChild(z),W.dataTransfer.setDragImage(z,-10,-10),setTimeout(()=>z.remove(),0)}this.domNode.classList.add("dragging"),this.H=new r(O),p.CurrentDragAndDropData=new d(O),this.F.onDragStart?.(this.H,W)}lb(w){if(w.browserEvent.preventDefault(),this.L.dispose(),p.CurrentDragAndDropData&&p.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(w.browserEvent),!w.browserEvent.dataTransfer))return!1;if(!this.H)if(p.CurrentDragAndDropData)this.H=p.CurrentDragAndDropData;else{if(!w.browserEvent.dataTransfer.types)return!1;this.H=new D}const C=this.F.onDragOver(this.H,w.element,w.index,w.sector,w.browserEvent);if(this.G=typeof C=="boolean"?C:C.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;w.browserEvent.dataTransfer.dropEffect=typeof C!="boolean"&&C.effect?.type===e.ListDragOverEffectType.Copy?"copy":"move";let W;typeof C!="boolean"&&C.feedback?W=C.feedback:typeof w.index>"u"?W=[-1]:W=[w.index],W=(0,v.$Ob)(W).filter(B=>B>=-1&&B<this.length).sort((B,z)=>B-z),W=W[0]===-1?[-1]:W;let O=typeof C!="boolean"&&C.effect&&C.effect.position?C.effect.position:e.ListDragOverEffectPosition.Over;if(T(this.I,W)&&this.J===O)return!0;if(this.I=W,this.J=O,this.K.dispose(),W[0]===-1)this.domNode.classList.add(O),this.o.classList.add(O),this.K=(0,A.$Uc)(()=>{this.domNode.classList.remove(O),this.o.classList.remove(O)});else{if(W.length>1&&O!==e.ListDragOverEffectPosition.Over)throw new Error("Can't use multiple feedbacks with position different than 'over'");O===e.ListDragOverEffectPosition.After&&W[0]<this.length-1&&(W[0]+=1,O=e.ListDragOverEffectPosition.Before);for(const B of W){const z=this.d[B];z.dropTarget=!0,z.row?.domNode.classList.add(O)}this.K=(0,A.$Uc)(()=>{for(const B of W){const z=this.d[B];z.dropTarget=!1,z.row?.domNode.classList.remove(O)}})}return!0}mb(w){this.L.dispose(),this.L=(0,E.$Hh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,w.element,w.index,w.browserEvent)}nb(w){if(!this.G)return;const C=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,!(!C||!w.browserEvent.dataTransfer)&&(w.browserEvent.preventDefault(),C.update(w.browserEvent.dataTransfer),this.F.drop(C,w.element,w.index,w.sector,w.browserEvent))}ob(w){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,p.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(w)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=A.$Wc.None}qb(w){if(!this.w){const C=(0,n.$IS)(this.domNode).top;this.w=(0,n.$LT)((0,n.getWindow)(this.domNode),this.rb.bind(this,C))}this.x.dispose(),this.x=(0,E.$Hh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=w.pageY}rb(w){if(this.y===void 0)return;const C=this.y-w,W=this.renderHeight-35;C<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(C-35))):C>W&&(this.scrollTop+=Math.min(14,Math.floor(.3*(C-W))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(w,C){if(C===void 0)return;const W=w.offsetY/this.d[C].size,O=Math.floor(W/.25);return(0,c.$Km)(O,0,3)}ub(w){const C=this.q.getDomNode();let W=w;for(;(0,n.$eT)(W)&&W!==this.o&&C.contains(W);){const O=W.getAttribute("data-index");if(O){const B=Number(O);if(!isNaN(B))return B}W=W.parentElement}}vb(w,C){return{start:this.g.indexAt(w),end:this.g.indexAfter(w+C-1)}}wb(w,C,W){const O=this.vb(w,C);let B,z;w===this.elementTop(O.start)?(B=O.start,z=0):O.end-O.start>1&&(B=O.start+1,z=this.elementTop(B)-w);let J=0;for(;;){const X=this.vb(w,C);let K=!1;for(let Q=X.start;Q<X.end;Q++){const he=this.xb(Q);he!==0&&this.g.splice(Q,1,[this.d[Q]]),J+=he,K=K||he!==0}if(!K){J!==0&&this.V();const Q=b.Range.relativeComplement(O,X);for(const be of Q)for(let Se=be.start;Se<be.end;Se++)this.d[Se].row&&this.db(Se);const he=b.Range.relativeComplement(X,O).reverse();for(const be of he)for(let Se=be.end-1;Se>=be.start;Se--)this.Z(Se);for(let be=X.start;be<X.end;be++)this.d[be].row&&this.bb(this.d[be],be);if(typeof B=="number"){const be=this.p.getFutureScrollPosition().scrollTop-w,Se=this.elementTop(B)-z+be;this.setScrollTop(Se,W)}this.N.fire(this.contentHeight);return}}}xb(w){const C=this.d[w];if(this.R.getDynamicHeight){const z=this.R.getDynamicHeight(C.element);if(z!==null){const J=C.size;return C.size=z,C.lastDynamicHeightWidth=this.n,z-J}}if(!C.hasDynamicHeight||C.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(C.element))return 0;const W=C.size;if(C.row)return C.row.domNode.style.height="",C.size=C.row.domNode.offsetHeight,C.size===0&&!(0,n.$TS)(C.row.domNode,(0,n.getWindow)(C.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),C.lastDynamicHeightWidth=this.n,C.size-W;const{row:O}=this.h.alloc(C.templateId);O.domNode.style.height="",this.o.appendChild(O.domNode);const B=this.j.get(C.templateId);if(!B)throw new h.$eb("Missing renderer for templateId: "+C.templateId);return B.renderElement(C.element,w,O.templateData,void 0),C.size=O.domNode.offsetHeight,B.disposeElement?.(C.element,w,O.templateData,void 0),this.R.setDynamicHeight?.(C.element,C.size),C.lastDynamicHeightWidth=this.n,O.domNode.remove(),this.h.release(O),C.size-W}getElementDomId(w){return`${this.domId}_${w}`}dispose(){for(const w of this.d)if(w.dragStartDisposable.dispose(),w.checkedDisposable.dispose(),w.row){const C=this.j.get(w.row.templateId);C&&(C.disposeElement?.(w.element,-1,w.row.templateData,void 0),C.disposeTemplate(w.row.templateData))}this.d=[],this.domNode?.remove(),this.w?.dispose(),this.M.dispose()}}t.$OU=_,et([f.$0h],_.prototype,"onMouseClick",null),et([f.$0h],_.prototype,"onMouseDblClick",null),et([f.$0h],_.prototype,"onMouseMiddleClick",null),et([f.$0h],_.prototype,"onMouseUp",null),et([f.$0h],_.prototype,"onMouseDown",null),et([f.$0h],_.prototype,"onMouseOver",null),et([f.$0h],_.prototype,"onMouseMove",null),et([f.$0h],_.prototype,"onMouseOut",null),et([f.$0h],_.prototype,"onContextMenu",null),et([f.$0h],_.prototype,"onTouchStart",null),et([f.$0h],_.prototype,"onTap",null)}),define(we[54],ve([1,0,4,29,16,33,74,87,9,12,89,36,3,50,8,2,38,5,10,42,79,23,62,117]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o,h,c,p,k,y,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7U=t.$6U=t.$5U=t.$4U=t.$1U=t.TypeNavigationMode=void 0,t.$SU=_,t.$TU=w,t.$UU=C,t.$VU=W,t.$WU=O,t.$XU=B,t.$YU=z,t.$ZU=J,t.$2U=Se,t.$3U=Fe,h=We(h);class d{constructor(a){this.d=a,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(a){return a}renderElement(a,l,g){const I=this.c.findIndex(F=>F.templateData===g);if(I>=0){const F=this.c[I];this.d.unrender(g),F.index=l}else{const F={index:l,templateData:g};this.c.push(F)}this.d.renderIndex(l,g)}splice(a,l,g){const I=[];for(const F of this.c)F.index<a?I.push(F):F.index>=a+l&&I.push({index:F.index+g-l,templateData:F.templateData});this.c=I}renderIndexes(a){for(const{index:l,templateData:g}of this.c)a.indexOf(l)>-1&&this.d.renderIndex(l,g)}disposeTemplate(a){const l=this.c.findIndex(g=>g.templateData===a);l<0||this.c.splice(l,1)}}class D{get name(){return this.g}get renderer(){return new d(this)}constructor(a){this.g=a,this.c=[],this.d=[],this.f=new b.$me,this.onChange=this.f.event}splice(a,l,g){const I=g.length-l,F=a+l,u=[];let N=0;for(;N<this.d.length&&this.d[N]<a;)u.push(this.d[N++]);for(let S=0;S<g.length;S++)g[S]&&u.push(S+a);for(;N<this.d.length&&this.d[N]>=F;)u.push(this.d[N++]+I);this.renderer.splice(a,l,g.length),this.h(u,u)}renderIndex(a,l){l.classList.toggle(this.g,this.contains(a))}unrender(a){a.classList.remove(this.g)}set(a,l){return this.h(a,[...a].sort(Oe),l)}h(a,l,g){const I=this.c,F=this.d;this.c=a,this.d=l;const u=$e(F,a);return this.renderer.renderIndexes(u),this.f.fire({indexes:a,browserEvent:g}),I}get(){return this.c}contains(a){return(0,E.$yb)(this.d,a,Oe)>=0}dispose(){(0,s.$Rc)(this.f)}}et([A.$0h],D.prototype,"renderer",null);class T extends D{constructor(a){super("selected"),this.k=a}renderIndex(a,l){super.renderIndex(a,l),this.k&&(this.contains(a)?l.setAttribute("aria-selected","true"):l.setAttribute("aria-selected","false"))}}class U{constructor(a,l,g){this.c=a,this.d=l,this.f=g}splice(a,l,g){if(!this.f)return this.c.splice(a,l,new Array(g.length).fill(!1));const I=this.c.get().map(N=>this.f.getId(this.d.element(N)).toString());if(I.length===0)return this.c.splice(a,l,new Array(g.length).fill(!1));const F=new Set(I),u=g.map(N=>F.has(this.f.getId(N).toString()));this.c.splice(a,l,u)}}function _(j){return j.tagName==="INPUT"||j.tagName==="TEXTAREA"}function H(j,a){return j.classList.contains(a)?!0:j.classList.contains("monaco-list")||!j.parentElement?!1:H(j.parentElement,a)}function w(j){return H(j,"monaco-editor")}function C(j){return H(j,"monaco-custom-toggle")}function W(j){return H(j,"action-item")}function O(j){return H(j,"monaco-tl-twistie")}function B(j){return H(j,"monaco-tree-sticky-row")}function z(j){return j.classList.contains("monaco-tree-sticky-container")}function J(j){return j.tagName==="A"&&j.classList.contains("monaco-button")||j.tagName==="DIV"&&j.classList.contains("monaco-button-dropdown")?!0:j.classList.contains("monaco-list")||!j.parentElement?!1:J(j.parentElement)}class X{get g(){return b.Event.chain(this.c.add(new n.$BU(this.k.domNode,"keydown")).event,a=>a.filter(l=>!_(l.target)).map(l=>new M.$mS(l)))}constructor(a,l,g){this.h=a,this.k=l,this.c=new s.$Vc,this.d=new s.$Vc,this.f=g.multipleSelectionSupport,this.c.add(this.g(I=>{switch(I.keyCode){case e.KeyCode.Enter:return this.l(I);case e.KeyCode.UpArrow:return this.o(I);case e.KeyCode.DownArrow:return this.p(I);case e.KeyCode.PageUp:return this.q(I);case e.KeyCode.PageDown:return this.s(I);case e.KeyCode.Escape:return this.u(I);case e.KeyCode.KeyA:this.f&&(h.$j?I.metaKey:I.ctrlKey)&&this.t(I)}}))}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.f=a.multipleSelectionSupport)}l(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection(this.h.getFocus(),a.browserEvent)}o(a){a.preventDefault(),a.stopPropagation(),this.h.focusPrevious(1,!1,a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}p(a){a.preventDefault(),a.stopPropagation(),this.h.focusNext(1,!1,a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}q(a){a.preventDefault(),a.stopPropagation(),this.h.focusPreviousPage(a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}s(a){a.preventDefault(),a.stopPropagation(),this.h.focusNextPage(a.browserEvent);const l=this.h.getFocus()[0];this.h.setAnchor(l),this.h.reveal(l),this.k.domNode.focus()}t(a){a.preventDefault(),a.stopPropagation(),this.h.setSelection((0,E.$Tb)(this.h.length),a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(a){this.h.getSelection().length&&(a.preventDefault(),a.stopPropagation(),this.h.setSelection([],a.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}et([A.$0h],X.prototype,"g",null);var K;(function(j){j[j.Automatic=0]="Automatic",j[j.Trigger=1]="Trigger"})(K||(t.TypeNavigationMode=K={}));var Q;(function(j){j[j.Idle=0]="Idle",j[j.Typing=1]="Typing"})(Q||(Q={})),t.$1U=new class{mightProducePrintableCharacter(j){return j.ctrlKey||j.metaKey||j.altKey?!1:j.keyCode>=e.KeyCode.KeyA&&j.keyCode<=e.KeyCode.KeyZ||j.keyCode>=e.KeyCode.Digit0&&j.keyCode<=e.KeyCode.Digit9||j.keyCode>=e.KeyCode.Numpad0&&j.keyCode<=e.KeyCode.Numpad9||j.keyCode>=e.KeyCode.Semicolon&&j.keyCode<=e.KeyCode.Quote}};class he{constructor(a,l,g,I,F){this.o=a,this.p=l,this.q=g,this.s=I,this.t=F,this.c=!1,this.d=Q.Idle,this.f=K.Automatic,this.g=!1,this.h=-1,this.k=new s.$Vc,this.l=new s.$Vc,this.updateOptions(a.options)}updateOptions(a){a.typeNavigationEnabled??!0?this.u():this.v(),this.f=a.typeNavigationMode??K.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let a=!1;const l=b.Event.chain(this.k.add(new n.$BU(this.p.domNode,"keydown")).event,F=>F.filter(u=>!_(u.target)).filter(()=>this.f===K.Automatic||this.g).map(u=>new M.$mS(u)).filter(u=>a||this.s(u)).filter(u=>this.t.mightProducePrintableCharacter(u)).forEach(u=>i.$rT.stop(u,!0)).map(u=>u.browserEvent.key)),g=b.Event.debounce(l,()=>null,800,void 0,void 0,void 0,this.k);b.Event.reduce(b.Event.any(l,g),(F,u)=>u===null?null:(F||"")+u,void 0,this.k)(this.x,this,this.k),g(this.w,this,this.k),l(()=>a=!0,void 0,this.k),g(()=>a=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const a=this.o.getFocus();if(a.length>0&&a[0]===this.h){const l=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(a[0]));typeof l=="string"?(0,L.$DU)(l):l&&(0,L.$DU)(l.get())}this.h=-1}x(a){if(!a){this.d=Q.Idle,this.g=!1;return}const l=this.o.getFocus(),g=l.length>0?l[0]:0,I=this.d===Q.Idle?1:0;this.d=Q.Typing;for(let F=0;F<this.o.length;F++){const u=(g+F+I)%this.o.length,N=this.q.getKeyboardNavigationLabel(this.p.element(u)),S=N&&N.toString();if(this.o.options.typeNavigationEnabled){if(typeof S<"u"){if((0,m.$Hk)(a,S)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}const P=(0,m.$Ok)(a,S);if(P&&P[0].end-P[0].start>1&&P.length===1){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}else if(typeof S>"u"||(0,m.$Hk)(a,S)){this.h=g,this.o.setFocus([u]),this.o.reveal(u);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class be{constructor(a,l){this.d=a,this.f=l,this.c=new s.$Vc;const g=b.Event.chain(this.c.add(new n.$BU(l.domNode,"keydown")).event,F=>F.filter(u=>!_(u.target)).map(u=>new M.$mS(u)));b.Event.chain(g,F=>F.filter(u=>u.keyCode===e.KeyCode.Tab&&!u.ctrlKey&&!u.metaKey&&!u.shiftKey&&!u.altKey))(this.g,this,this.c)}g(a){if(a.target!==this.f.domNode)return;const l=this.d.getFocus();if(l.length===0)return;const g=this.f.domElement(l[0]);if(!g)return;const I=g.querySelector("[tabIndex]");if(!I||!(0,i.$eT)(I)||I.tabIndex===-1)return;const F=(0,i.getWindow)(I).getComputedStyle(I);F.visibility==="hidden"||F.display==="none"||(a.preventDefault(),a.stopPropagation(),I.focus())}dispose(){this.c.dispose()}}function Se(j){return h.$j?j.browserEvent.metaKey:j.browserEvent.ctrlKey}function Fe(j){return j.browserEvent.shiftKey}function se(j){return(0,i.$lT)(j)&&j.button===2}const ee={isSelectionSingleChangeEvent:Se,isSelectionRangeChangeEvent:Fe};class ce{constructor(a){this.k=a,this.f=new s.$Vc,this.g=new b.$me,this.onPointer=this.g.event,a.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ee),this.d=typeof a.options.mouseSupport>"u"||!!a.options.mouseSupport,this.d&&(a.onMouseDown(this.s,this,this.f),a.onContextMenu(this.t,this,this.f),a.onMouseDblClick(this.v,this,this.f),a.onTouchStart(this.s,this,this.f),this.f.add(R.$7T.addTarget(a.getHTMLElement()))),b.Event.any(a.onMouseClick,a.onMouseMiddleClick,a.onTap)(this.u,this,this.f)}updateOptions(a){a.multipleSelectionSupport!==void 0&&(this.c=void 0,a.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ee))}o(a){return this.c?this.c.isSelectionSingleChangeEvent(a):!1}p(a){return this.c?this.c.isSelectionRangeChangeEvent(a):!1}q(a){return this.o(a)||this.p(a)}s(a){w(a.browserEvent.target)||(0,i.$2S)()!==a.browserEvent.target&&this.k.domFocus()}t(a){if(_(a.browserEvent.target)||w(a.browserEvent.target))return;const l=typeof a.index>"u"?[]:[a.index];this.k.setFocus(l,a.browserEvent)}u(a){if(!this.d||_(a.browserEvent.target)||w(a.browserEvent.target)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const l=a.index;if(typeof l>"u"){this.k.setFocus([],a.browserEvent),this.k.setSelection([],a.browserEvent),this.k.setAnchor(void 0);return}if(this.q(a))return this.w(a);this.k.setFocus([l],a.browserEvent),this.k.setAnchor(l),se(a.browserEvent)||this.k.setSelection([l],a.browserEvent),this.g.fire(a)}v(a){if(_(a.browserEvent.target)||w(a.browserEvent.target)||this.q(a)||a.browserEvent.isHandledByList)return;a.browserEvent.isHandledByList=!0;const l=this.k.getFocus();this.k.setSelection(l,a.browserEvent)}w(a){const l=a.index;let g=this.k.getAnchor();if(this.p(a)){typeof g>"u"&&(g=this.k.getFocus()[0]??l,this.k.setAnchor(g));const I=Math.min(g,l),F=Math.max(g,l),u=(0,E.$Tb)(I,F+1),N=this.k.getSelection(),S=te($e(N,[g]),g);if(S.length===0)return;const P=$e(u,ye(N,S));this.k.setSelection(P,a.browserEvent),this.k.setFocus([l],a.browserEvent)}else if(this.o(a)){const I=this.k.getSelection(),F=I.filter(u=>u!==l);this.k.setFocus([l]),this.k.setAnchor(l),I.length===F.length?this.k.setSelection([...F,l],a.browserEvent):this.k.setSelection(F,a.browserEvent)}}dispose(){this.f.dispose()}}t.$4U=ce;class ae{constructor(a,l){this.c=a,this.d=l}style(a){const l=this.d&&`.${this.d}`,g=[];a.listBackground&&g.push(`.monaco-list${l} .monaco-list-rows { background: ${a.listBackground}; }`),a.listFocusBackground&&(g.push(`.monaco-list${l}:focus .monaco-list-row.focused { background-color: ${a.listFocusBackground}; }`),g.push(`.monaco-list${l}:focus .monaco-list-row.focused:hover { background-color: ${a.listFocusBackground}; }`)),a.listFocusForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.focused { color: ${a.listFocusForeground}; }`),a.listActiveSelectionBackground&&(g.push(`.monaco-list${l}:focus .monaco-list-row.selected { background-color: ${a.listActiveSelectionBackground}; }`),g.push(`.monaco-list${l}:focus .monaco-list-row.selected:hover { background-color: ${a.listActiveSelectionBackground}; }`)),a.listActiveSelectionForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.selected { color: ${a.listActiveSelectionForeground}; }`),a.listActiveSelectionIconForeground&&g.push(`.monaco-list${l}:focus .monaco-list-row.selected .codicon { color: ${a.listActiveSelectionIconForeground}; }`),a.listFocusAndSelectionBackground&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { background-color: ${a.listFocusAndSelectionBackground}; }
			`),a.listFocusAndSelectionForeground&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.selected.focused { color: ${a.listFocusAndSelectionForeground}; }
			`),a.listInactiveFocusForeground&&(g.push(`.monaco-list${l} .monaco-list-row.focused { color:  ${a.listInactiveFocusForeground}; }`),g.push(`.monaco-list${l} .monaco-list-row.focused:hover { color:  ${a.listInactiveFocusForeground}; }`)),a.listInactiveSelectionIconForeground&&g.push(`.monaco-list${l} .monaco-list-row.focused .codicon { color:  ${a.listInactiveSelectionIconForeground}; }`),a.listInactiveFocusBackground&&(g.push(`.monaco-list${l} .monaco-list-row.focused { background-color:  ${a.listInactiveFocusBackground}; }`),g.push(`.monaco-list${l} .monaco-list-row.focused:hover { background-color:  ${a.listInactiveFocusBackground}; }`)),a.listInactiveSelectionBackground&&(g.push(`.monaco-list${l} .monaco-list-row.selected { background-color:  ${a.listInactiveSelectionBackground}; }`),g.push(`.monaco-list${l} .monaco-list-row.selected:hover { background-color:  ${a.listInactiveSelectionBackground}; }`)),a.listInactiveSelectionForeground&&g.push(`.monaco-list${l} .monaco-list-row.selected { color: ${a.listInactiveSelectionForeground}; }`),a.listHoverBackground&&g.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${a.listHoverBackground}; }`),a.listHoverForeground&&g.push(`.monaco-list${l}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${a.listHoverForeground}; }`);const I=(0,i.$OT)(a.listFocusAndSelectionOutline,(0,i.$OT)(a.listSelectionOutline,a.listFocusOutline??""));I&&g.push(`.monaco-list${l}:focus .monaco-list-row.focused.selected { outline: 1px solid ${I}; outline-offset: -1px;}`),a.listFocusOutline&&g.push(`
				.monaco-drag-image,
				.monaco-list${l}:focus .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${l}.last-focused .monaco-list-row.focused { outline: 1px solid ${a.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,i.$OT)(a.listSelectionOutline,a.listInactiveFocusOutline??"");F&&g.push(`.monaco-list${l} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),a.listSelectionOutline&&g.push(`.monaco-list${l} .monaco-list-row.selected { outline: 1px dotted ${a.listSelectionOutline}; outline-offset: -1px; }`),a.listInactiveFocusOutline&&g.push(`.monaco-list${l} .monaco-list-row.focused { outline: 1px dotted ${a.listInactiveFocusOutline}; outline-offset: -1px; }`),a.listHoverOutline&&g.push(`.monaco-list${l} .monaco-list-row:hover { outline: 1px dashed ${a.listHoverOutline}; outline-offset: -1px; }`),a.listDropOverBackground&&g.push(`
				.monaco-list${l}.drop-target,
				.monaco-list${l} .monaco-list-rows.drop-target,
				.monaco-list${l} .monaco-list-row.drop-target { background-color: ${a.listDropOverBackground} !important; color: inherit !important; }
			`),a.listDropBetweenBackground&&(g.push(`
			.monaco-list${l} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${l} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`),g.push(`
			.monaco-list${l} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${l} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${a.listDropBetweenBackground};
			}`)),a.tableColumnsBorder&&g.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${a.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),a.tableOddRowsBackgroundColor&&g.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${a.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=g.join(`
`)}}t.$5U=ae,t.$6U={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:$.$hu.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:$.$hu.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:$.$hu.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const Ne={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function te(j,a){const l=j.indexOf(a);if(l===-1)return[];const g=[];let I=l-1;for(;I>=0&&j[I]===a-(l-I);)g.push(j[I--]);for(g.reverse(),I=l;I<j.length&&j[I]===a+(I-l);)g.push(j[I++]);return g}function $e(j,a){const l=[];let g=0,I=0;for(;g<j.length||I<a.length;)if(g>=j.length)l.push(a[I++]);else if(I>=a.length)l.push(j[g++]);else if(j[g]===a[I]){l.push(j[g]),g++,I++;continue}else j[g]<a[I]?l.push(j[g++]):l.push(a[I++]);return l}function ye(j,a){const l=[];let g=0,I=0;for(;g<j.length||I<a.length;)if(g>=j.length)l.push(a[I++]);else if(I>=a.length)l.push(j[g++]);else if(j[g]===a[I]){g++,I++;continue}else j[g]<a[I]?l.push(j[g++]):I++;return l}const Oe=(j,a)=>j-a;class Re{constructor(a,l){this.c=a,this.d=l}get templateId(){return this.c}renderTemplate(a){return this.d.map(l=>l.renderTemplate(a))}renderElement(a,l,g,I){let F=0;for(const u of this.d)u.renderElement(a,l,g[F++],I)}disposeElement(a,l,g,I){let F=0;for(const u of this.d)u.disposeElement?.(a,l,g[F],I),F+=1}disposeTemplate(a){let l=0;for(const g of this.d)g.disposeTemplate(a[l++])}}class Ce{constructor(a){this.c=a,this.templateId="a18n"}renderTemplate(a){return{container:a,disposables:new s.$Vc}}renderElement(a,l,g){const I=this.c.getAriaLabel(a),F=I&&typeof I!="string"?I:(0,r.constObservable)(I);g.disposables.add((0,r.autorun)(N=>{this.d(N.readObservable(F),g.container)}));const u=this.c.getAriaLevel&&this.c.getAriaLevel(a);typeof u=="number"?g.container.setAttribute("aria-level",`${u}`):g.container.removeAttribute("aria-level")}d(a,l){a?l.setAttribute("aria-label",a):l.removeAttribute("aria-label")}disposeElement(a,l,g,I){g.disposables.clear()}disposeTemplate(a){a.disposables.dispose()}}class re{constructor(a,l){this.c=a,this.d=l}getDragElements(a){const l=this.c.getSelectedElements();return l.indexOf(a)>-1?l:[a]}getDragURI(a){return this.d.getDragURI(a)}getDragLabel(a,l){if(this.d.getDragLabel)return this.d.getDragLabel(a,l)}onDragStart(a,l){this.d.onDragStart?.(a,l)}onDragOver(a,l,g,I,F){return this.d.onDragOver(a,l,g,I,F)}onDragLeave(a,l,g,I){this.d.onDragLeave?.(a,l,g,I)}onDragEnd(a){this.d.onDragEnd?.(a)}drop(a,l,g,I,F){this.d.drop(a,l,g,I,F)}dispose(){this.d.dispose()}}class V{get onDidChangeFocus(){return b.Event.map(this.g.wrapEvent(this.c.onChange),a=>this.G(a),this.y)}get onDidChangeSelection(){return b.Event.map(this.g.wrapEvent(this.d.onChange),a=>this.G(a),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let a=!1;const l=b.Event.chain(this.y.add(new n.$BU(this.k.domNode,"keydown")).event,F=>F.map(u=>new M.$mS(u)).filter(u=>a=u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$rT.stop(u,!0)).filter(()=>!1)),g=b.Event.chain(this.y.add(new n.$BU(this.k.domNode,"keyup")).event,F=>F.forEach(()=>a=!1).map(u=>new M.$mS(u)).filter(u=>u.keyCode===e.KeyCode.ContextMenu||u.shiftKey&&u.keyCode===e.KeyCode.F10).map(u=>i.$rT.stop(u,!0)).map(({browserEvent:u})=>{const N=this.getFocus(),S=N.length?N[0]:void 0,P=typeof S<"u"?this.k.element(S):void 0,x=typeof S<"u"?this.k.domElement(S):this.k.domNode;return{index:S,element:P,anchor:x,browserEvent:u}})),I=b.Event.chain(this.k.onContextMenu,F=>F.filter(u=>!a).map(({element:u,index:N,browserEvent:S})=>({element:u,index:N,anchor:new y.$hS((0,i.getWindow)(this.k.domNode),S),browserEvent:S})));return b.Event.any(l,g,I)}get onKeyDown(){return this.y.add(new n.$BU(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new n.$BU(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new n.$BU(this.k.domNode,"keypress")).event}get onDidFocus(){return b.Event.signal(this.y.add(new n.$BU(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return b.Event.signal(this.y.add(new n.$BU(this.k.domNode,"blur",!0)).event)}constructor(a,l,g,I,F=Ne){this.A=a,this.B=F,this.c=new D("focused"),this.f=new D("anchor"),this.g=new b.$ue,this.x="",this.y=new s.$Vc,this.z=new b.$me,this.onDidDispose=this.z.event;const u=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new T(u!=="listbox");const N=[this.c.renderer,this.d.renderer];this.u=F.accessibilityProvider,this.u&&(N.push(new Ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),I=I.map(P=>new Re(P.templateId,[...N,P]));const S={...F,dnd:F.dnd&&new re(this,F.dnd)};if(this.k=this.C(l,g,I,S),this.k.domNode.setAttribute("role",u),F.styleController)this.q=F.styleController(this.k.domId);else{const P=(0,i.$0S)(this.k.domNode);this.q=new ae(P,this.k.domId)}if(this.o=new v.$FU([new U(this.c,this.k,F.identityProvider),new U(this.d,this.k,F.identityProvider),new U(this.f,this.k,F.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new be(this,this.k)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.v=new X(this,this.k,F),this.y.add(this.v)),F.keyboardNavigationLabelProvider){const P=F.keyboardNavigationDelegate||t.$1U;this.t=new he(this,this.k,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),P),this.y.add(this.t)}this.w=this.D(F),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(a,l,g,I){return new k.$OU(a,l,g,I)}D(a){return new ce(this)}updateOptions(a={}){this.B={...this.B,...a},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(a),this.v?.updateOptions(a),this.k.updateOptions(a)}get options(){return this.B}splice(a,l,g=[]){if(a<0||a>this.k.length)throw new p.$QU(this.A,`Invalid start index: ${a}`);if(l<0)throw new p.$QU(this.A,`Invalid delete count: ${l}`);l===0&&g.length===0||this.g.bufferEvents(()=>this.o.splice(a,l,g))}updateWidth(a){this.k.updateWidth(a)}updateElementHeight(a,l){this.k.updateElementHeight(a,l,null)}rerender(){this.k.rerender()}element(a){return this.k.element(a)}indexOf(a){return this.k.indexOf(a)}indexAt(a){return this.k.indexAt(a)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(a){this.k.setScrollTop(a)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(a){this.k.setScrollLeft(a)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(a){this.x=a,this.k.domNode.setAttribute("aria-label",a)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(a,l){this.k.layout(a,l)}triggerTypeNavigation(){this.t?.trigger()}setSelection(a,l){for(const g of a)if(g<0||g>=this.length)throw new p.$QU(this.A,`Invalid index ${g}`);this.d.set(a,l)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(a=>this.k.element(a))}setAnchor(a){if(typeof a>"u"){this.f.set([]);return}if(a<0||a>=this.length)throw new p.$QU(this.A,`Invalid index ${a}`);this.f.set([a])}getAnchor(){return(0,E.$Qb)(this.f.get(),void 0)}getAnchorElement(){const a=this.getAnchor();return typeof a>"u"?void 0:this.element(a)}setFocus(a,l){for(const g of a)if(g<0||g>=this.length)throw new p.$QU(this.A,`Invalid index ${g}`);this.c.set(a,l)}focusNext(a=1,l=!1,g,I){if(this.length===0)return;const F=this.c.get(),u=this.E(F.length>0?F[0]+a:0,l,I);u>-1&&this.setFocus([u],g)}focusPrevious(a=1,l=!1,g,I){if(this.length===0)return;const F=this.c.get(),u=this.F(F.length>0?F[0]-a:0,l,I);u>-1&&this.setFocus([u],g)}async focusNextPage(a,l){let g=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);g=g===0?0:g-1;const I=this.getFocus()[0];if(I!==g&&(I===void 0||g>I)){const F=this.F(g,!1,l);F>-1&&I!==F?this.setFocus([F],a):this.setFocus([g],a)}else{const F=this.k.getScrollTop();let u=F+this.k.renderHeight;g>I&&(u-=this.k.elementHeight(g)),this.k.setScrollTop(u),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,f.$Gh)(0),await this.focusNextPage(a,l))}}async focusPreviousPage(a,l,g=()=>0){let I;const F=g(),u=this.k.getScrollTop()+F;u===0?I=this.k.indexAt(u):I=this.k.indexAfter(u-1);const N=this.getFocus()[0];if(N!==I&&(N===void 0||N>=I)){const S=this.E(I,!1,l);S>-1&&N!==S?this.setFocus([S],a):this.setFocus([I],a)}else{const S=u;this.k.setScrollTop(u-this.k.renderHeight-F),this.k.getScrollTop()+g()!==S&&(this.setFocus([]),await(0,f.$Gh)(0),await this.focusPreviousPage(a,l,g))}}focusLast(a,l){if(this.length===0)return;const g=this.F(this.length-1,!1,l);g>-1&&this.setFocus([g],a)}focusFirst(a,l){this.focusNth(0,a,l)}focusNth(a,l,g){if(this.length===0)return;const I=this.E(a,!1,g);I>-1&&this.setFocus([I],l)}E(a,l=!1,g){for(let I=0;I<this.length;I++){if(a>=this.length&&!l)return-1;if(a=a%this.length,!g||g(this.element(a)))return a;a++}return-1}F(a,l=!1,g){for(let I=0;I<this.length;I++){if(a<0&&!l)return-1;if(a=(this.length+a%this.length)%this.length,!g||g(this.element(a)))return a;a--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(a=>this.k.element(a))}reveal(a,l,g=0){if(a<0||a>=this.length)throw new p.$QU(this.A,`Invalid index ${a}`);const I=this.k.getScrollTop(),F=this.k.elementTop(a),u=this.k.elementHeight(a);if((0,c.$jg)(l)){const N=u-this.k.renderHeight+g;this.k.setScrollTop(N*(0,o.$Km)(l,0,1)+F-g)}else{const N=F+u,S=I+this.k.renderHeight;F<I+g&&N>=S||(F<I+g||N>=S&&u>=this.k.renderHeight?this.k.setScrollTop(F-g):N>=S&&this.k.setScrollTop(N-this.k.renderHeight))}}getRelativeTop(a,l=0){if(a<0||a>=this.length)throw new p.$QU(this.A,`Invalid index ${a}`);const g=this.k.getScrollTop(),I=this.k.elementTop(a),F=this.k.elementHeight(a);if(I<g+l||I+F>g+this.k.renderHeight)return null;const u=F-this.k.renderHeight+l;return Math.abs((g+l-I)/u)}isDOMFocused(){return(0,i.$3S)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(a){return this.k.getElementDomId(a)}getElementTop(a){return this.k.elementTop(a)}style(a){this.q.style(a)}G({indexes:a,browserEvent:l}){return{indexes:a,elements:a.map(g=>this.k.element(g)),browserEvent:l}}H(){const a=this.c.get();this.k.domNode.classList.toggle("element-focused",a.length>0),this.I()}I(){const a=this.c.get();if(a.length>0){let l;this.u?.getActiveDescendantId&&(l=this.u.getActiveDescendantId(this.k.element(a[0]))),this.k.domNode.setAttribute("aria-activedescendant",l||this.k.getElementDomId(a[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const a=this.d.get();this.k.domNode.classList.toggle("selection-none",a.length===0),this.k.domNode.classList.toggle("selection-single",a.length===1),this.k.domNode.classList.toggle("selection-multiple",a.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$7U=V,et([A.$0h],V.prototype,"onDidChangeFocus",null),et([A.$0h],V.prototype,"onDidChangeSelection",null),et([A.$0h],V.prototype,"onContextMenu",null),et([A.$0h],V.prototype,"onKeyDown",null),et([A.$0h],V.prototype,"onKeyUp",null),et([A.$0h],V.prototype,"onKeyPress",null),et([A.$0h],V.prototype,"onDidFocus",null),et([A.$0h],V.prototype,"onDidBlur",null)}),define(we[144],ve([1,0,6,67,52,11,17]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3k=t.MarkdownStringTextNewlineStyle=void 0,t.$4k=f,t.$5k=$,t.$6k=A,t.$7k=b,t.$8k=m,t.$9k=e,t.$0k=s,t.$$k=o;var v;(function(h){h[h.Paragraph=0]="Paragraph",h[h.Break=1]="Break"})(v||(t.MarkdownStringTextNewlineStyle=v={}));class E{constructor(c="",p=!1){if(this.value=c,typeof this.value!="string")throw(0,i.$9)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(c,p=v.Paragraph){return this.value+=b(this.supportThemeIcons?(0,n.$Wk)(c):c).replace(/([ \t]+)/g,(k,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===v.Break?`\\
`:`

`),this}appendMarkdown(c){return this.value+=c,this}appendCodeblock(c,p){return this.value+=`
${m(p,c)}
`,this}appendLink(c,p,k){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(c),")"),k&&(this.value+=` "${this.c(this.c(k,'"'),")")}"`),this.value+=")",this}c(c,p){const k=new RegExp((0,R.$if)(p),"g");return c.replace(k,(y,r)=>c.charAt(r-1)!=="\\"?`\\${y}`:y)}}t.$3k=E;function f(h){return $(h)?!h.value:Array.isArray(h)?h.every(f):!0}function $(h){return h instanceof E?!0:h&&typeof h=="object"?typeof h.value=="string"&&(typeof h.isTrusted=="boolean"||typeof h.isTrusted=="object"||h.isTrusted===void 0)&&(typeof h.supportThemeIcons=="boolean"||h.supportThemeIcons===void 0):!1}function A(h,c){return h===c?!0:!h||!c?!1:h.value===c.value&&h.isTrusted===c.isTrusted&&h.supportThemeIcons===c.supportThemeIcons&&h.supportHtml===c.supportHtml&&(h.baseUri===c.baseUri||!!h.baseUri&&!!c.baseUri&&(0,M.$_g)(L.URI.from(h.baseUri),L.URI.from(c.baseUri)))}function b(h){return h.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(h,c){const p=h.match(/^`+/gm)?.reduce((y,r)=>y.length>r.length?y:r).length??0,k=p>=3?p+1:3;return[`${"`".repeat(k)}${c}`,h,`${"`".repeat(k)}`].join(`
`)}function e(h){return h.replace(/"/g,"&quot;")}function s(h){return h&&h.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(h){const c=[],p=h.split("|").map(y=>y.trim());h=p[0];const k=p[1];if(k){const y=/height=(\d+)/.exec(k),r=/width=(\d+)/.exec(k),d=y?y[1]:"",D=r?r[1]:"",T=isFinite(parseInt(D)),U=isFinite(parseInt(d));T&&c.push(`width="${D}"`),U&&c.push(`height="${d}"`)}return{href:h,dimensions:c}}}),define(we[145],ve([1,0,4,136,29,72,16,23,137,6,3,144,67,91,8,26,2,92,70,41,64,52,11,17]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o,h,c,p,k,y,r,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$U=void 0,t.$0U=T,t.$_U=W,t.$aV=O,t.$bV=se,i=We(i),n=We(n);const D=Object.freeze({image:(a,l,g)=>{let I=[],F=[];return a&&({href:a,dimensions:I}=(0,A.$$k)(a),F.push(`src="${(0,A.$9k)(a)}"`)),g&&F.push(`alt="${(0,A.$9k)(g)}"`),l&&F.push(`title="${(0,A.$9k)(l)}"`),I.length&&(F=F.concat(I)),"<img "+F.join(" ")+">"},paragraph:a=>`<p>${a}</p>`,link:(a,l,g)=>typeof a!="string"?"":(a===g&&(g=(0,A.$0k)(g)),l=typeof l=="string"?(0,A.$9k)((0,A.$0k)(l)):"",a=(0,A.$0k)(a),a=a.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${a}" title="${l||a}" draggable="false">${g}</a>`)});function T(a,l={},g={}){const I=new o.$Vc;let F=!1;const u=(0,R.$AU)(l),N=function(De){let Te;try{Te=(0,c.$bi)(decodeURIComponent(De))}catch{}return Te?(Te=(0,k.$eo)(Te,ke=>{if(a.uris&&a.uris[ke])return d.URI.revive(a.uris[ke])}),encodeURIComponent(JSON.stringify(Te))):De},S=function(De,Te){const ke=a.uris&&a.uris[De];let fe=d.URI.revive(ke);return Te?De.startsWith(p.Schemas.data+":")?De:(fe||(fe=d.URI.parse(De)),p.$Zg.uriToBrowserUri(fe).toString(!0)):!fe||d.URI.parse(De).toString()===fe.toString()?De:(fe.query&&(fe=fe.with({query:N(fe.query)})),fe.toString())},P=new h.marked.Renderer;P.image=D.image,P.link=D.link,P.paragraph=D.paragraph;const x=[],G=[];if(l.codeBlockRendererSync?P.code=(De,Te)=>{const ke=m.$3P.nextId(),fe=l.codeBlockRendererSync(U(Te),De);return G.push([ke,fe]),`<div class="code" data-code="${ke}">${(0,r.$hf)(De)}</div>`}:l.codeBlockRenderer&&(P.code=(De,Te)=>{const ke=m.$3P.nextId(),fe=l.codeBlockRenderer(U(Te),De);return x.push(fe.then(Ie=>[ke,Ie])),`<div class="code" data-code="${ke}">${(0,r.$hf)(De)}</div>`}),l.actionHandler){const De=function(fe){let Ie=fe.target;if(!(Ie.tagName!=="A"&&(Ie=Ie.parentElement,!Ie||Ie.tagName!=="A")))try{let ze=Ie.dataset.href;ze&&(a.baseUri&&(ze=_(d.URI.from(a.baseUri),ze)),l.actionHandler.callback(ze,fe))}catch(ze){(0,f.$3)(ze)}finally{fe.preventDefault()}},Te=l.actionHandler.disposables.add(new M.$BU(u,"click")),ke=l.actionHandler.disposables.add(new M.$BU(u,"auxclick"));l.actionHandler.disposables.add($.Event.any(Te.event,ke.event)(fe=>{const Ie=new v.$hS(i.getWindow(u),fe);!Ie.leftButton&&!Ie.middleButton||De(Ie)})),l.actionHandler.disposables.add(i.$pS(u,"keydown",fe=>{const Ie=new L.$mS(fe);!Ie.equals(e.KeyCode.Space)&&!Ie.equals(e.KeyCode.Enter)||De(Ie)}))}a.supportHtml||(g.sanitizer=De=>l.sanitizerOptions?.replaceWithPlaintext?(0,r.$hf)(De):(a.isTrusted?De.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?De:"",g.sanitize=!0,g.silent=!0),g.renderer=P;let ie=a.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ie=(0,b.$Xk)(ie));let le;if(l.fillInIncompleteTokens){const De={...h.marked.defaults,...g},Te=h.marked.lexer(ie,De),ke=se(Te);le=h.marked.parser(ke,De)}else le=h.marked.parse(ie,g);a.supportThemeIcons&&(le=(0,E.$8U)(le).map(Te=>typeof Te=="string"?Te:Te.outerHTML).join(""));const Ee=new DOMParser().parseFromString(w({isTrusted:a.isTrusted,...l.sanitizerOptions},le),"text/html");if(Ee.body.querySelectorAll("img, audio, video, source").forEach(De=>{const Te=De.getAttribute("src");if(Te){let ke=Te;try{a.baseUri&&(ke=_(d.URI.from(a.baseUri),ke))}catch{}if(De.setAttribute("src",S(ke,!0)),l.remoteImageIsAllowed){const fe=d.URI.parse(ke);fe.scheme!==p.Schemas.file&&fe.scheme!==p.Schemas.data&&!l.remoteImageIsAllowed(fe)&&De.replaceWith(i.$("",void 0,De.outerHTML))}}}),Ee.body.querySelectorAll("a").forEach(De=>{const Te=De.getAttribute("href");if(De.setAttribute("href",""),!Te||/^data:|javascript:/i.test(Te)||/^command:/i.test(Te)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(Te))De.replaceWith(...De.childNodes);else{let ke=S(Te,!1);a.baseUri&&(ke=_(d.URI.from(a.baseUri),Te)),De.dataset.href=ke}}),u.innerHTML=w({isTrusted:a.isTrusted,...l.sanitizerOptions},Ee.body.innerHTML),x.length>0)Promise.all(x).then(De=>{if(F)return;const Te=new Map(De),ke=u.querySelectorAll("div[data-code]");for(const fe of ke){const Ie=Te.get(fe.dataset.code??"");Ie&&i.$yT(fe,Ie)}l.asyncRenderCallback?.()});else if(G.length>0){const De=new Map(G),Te=u.querySelectorAll("div[data-code]");for(const ke of Te){const fe=De.get(ke.dataset.code??"");fe&&i.$yT(ke,fe)}}if(l.asyncRenderCallback)for(const De of u.getElementsByTagName("img")){const Te=I.add(i.$pS(De,"load",()=>{Te.dispose(),l.asyncRenderCallback()}))}return{element:u,dispose:()=>{F=!0,I.dispose()}}}function U(a){if(!a)return"";const l=a.split(/[\s+|:|,|\{|\?]/,1);return l.length?l[0]:a}function _(a,l){return/^\w[\w\d+.-]*:/.test(l)?l:a.path.endsWith("/")?(0,y.$jh)(a,l).toString():(0,y.$jh)((0,y.$fh)(a),l).toString()}const H=["area","base","br","col","command","embed","hr","img","input","keygen","link","meta","param","source","track","wbr"];function w(a,l){const{config:g,allowedSchemes:I}=C(a),F=new o.$Vc;F.add(j("uponSanitizeAttribute",(u,N)=>{if(N.attrName==="style"||N.attrName==="class"){if(u.tagName==="SPAN"){if(N.attrName==="style"){N.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(N.attrValue);return}else if(N.attrName==="class"){N.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(N.attrValue);return}}N.keepAttr=!1;return}else if(u.tagName==="INPUT"&&u.attributes.getNamedItem("type")?.value==="checkbox"){if(N.attrName==="type"&&N.attrValue==="checkbox"||N.attrName==="disabled"||N.attrName==="checked"){N.keepAttr=!0;return}N.keepAttr=!1}})),F.add(j("uponSanitizeElement",(u,N)=>{if(N.tagName==="input"&&(u.attributes.getNamedItem("type")?.value==="checkbox"?u.setAttribute("disabled",""):a.replaceWithPlaintext||u.remove()),a.replaceWithPlaintext&&!N.allowedTags[N.tagName]&&N.tagName!=="body"&&u.parentElement){let S,P;if(N.tagName==="#comment")S=`<!--${u.textContent}-->`;else{const le=H.includes(N.tagName),de=u.attributes.length?" "+Array.from(u.attributes).map(Ee=>`${Ee.name}="${Ee.value}"`).join(" "):"";S=`<${N.tagName}${de}>`,le||(P=`</${N.tagName}>`)}const x=document.createDocumentFragment(),G=u.parentElement.ownerDocument.createTextNode(S);x.appendChild(G);const ie=P?u.parentElement.ownerDocument.createTextNode(P):void 0;for(;u.firstChild;)x.appendChild(u.firstChild);ie&&x.appendChild(ie),u.parentElement.replaceChild(x,u)}})),F.add(i.$ST(I));try{return n.sanitize(l,{...g,RETURN_TRUSTED_TYPE:!0})}finally{F.dispose()}}t.$$U=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function C(a){const l=[p.Schemas.http,p.Schemas.https,p.Schemas.mailto,p.Schemas.data,p.Schemas.file,p.Schemas.vscodeFileResource,p.Schemas.vscodeRemote,p.Schemas.vscodeRemoteResource];return a.isTrusted&&l.push(p.Schemas.command),{config:{ALLOWED_TAGS:a.allowedTags??[...i.$TT],ALLOWED_ATTR:t.$$U,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:l}}function W(a){return typeof a=="string"?a:O(a)}function O(a,l){let g=a.value??"";g.length>1e5&&(g=`${g.substr(0,1e5)}\u2026`);const I=h.marked.parse(g,{renderer:l?X.value:J.value}).replace(/&(#\d+|[a-zA-Z]+);/g,F=>B.get(F)??F);return w({isTrusted:!1},I).toString()}const B=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]);function z(){const a=new h.marked.Renderer;return a.code=l=>l,a.blockquote=l=>l,a.html=l=>"",a.heading=(l,g,I)=>l+`
`,a.hr=()=>"",a.list=(l,g)=>l,a.listitem=l=>l+`
`,a.paragraph=l=>l+`
`,a.table=(l,g)=>l+g+`
`,a.tablerow=l=>l,a.tablecell=(l,g)=>l+" ",a.strong=l=>l,a.em=l=>l,a.codespan=l=>l,a.br=()=>`
`,a.del=l=>l,a.image=(l,g,I)=>"",a.text=l=>l,a.link=(l,g,I)=>I,a}const J=new s.$X(a=>z()),X=new s.$X(()=>{const a=z();return a.code=l=>"\n```\n"+l+"```\n",a});function K(a){let l="";return a.forEach(g=>{l+=g.raw}),l}function Q(a){if(a.tokens)for(let l=a.tokens.length-1;l>=0;l--){const g=a.tokens[l];if(g.type==="text"){const I=g.raw.split(`
`),F=I[I.length-1];if(F.includes("`"))return ae(a);if(F.includes("**"))return Re(a);if(F.match(/\*\w/))return Ne(a);if(F.match(/(^|\s)__\w/))return Ce(a);if(F.match(/(^|\s)_\w/))return te(a);if(he(F)||be(F)&&a.tokens.slice(0,l).some(u=>u.type==="text"&&u.raw.match(/\[[^\]]*$/))){const u=a.tokens.slice(l+1);return u[0]?.type==="link"&&u[1]?.type==="text"&&u[1].raw.match(/^ *"[^"]*$/)||F.match(/^[^"]* +"[^"]*$/)?ye(a):$e(a)}else if(F.match(/(^|\s)\[\w*/))return Oe(a)}}}function he(a){return!!a.match(/(^|\s)\[.*\]\(\w*/)}function be(a){return!!a.match(/^[^\[]*\]\([^\)]*$/)}function Se(a){const l=a.items[a.items.length-1],g=l.tokens?l.tokens[l.tokens.length-1]:void 0;let I;if(g?.type==="text"&&!("inRawBlock"in l)&&(I=Q(g)),!I||I.type!=="paragraph")return;const F=K(a.items.slice(0,-1)),u=l.raw.match(/^(\s*(-|\d+\.) +)/)?.[0];if(!u)return;const N=u+K(l.tokens.slice(0,-1))+I.raw,S=h.marked.lexer(F+N)[0];if(S.type==="list")return S}const Fe=3;function se(a){for(let l=0;l<Fe;l++){const g=ee(a);if(g)a=g;else break}return a}function ee(a){let l,g;for(l=0;l<a.length;l++){const I=a[l];let F;if(I.type==="paragraph"&&(F=I.raw.match(/(\n|^)(````*)/))){const u=F[2];g=ce(a.slice(l),u);break}if(I.type==="paragraph"&&I.raw.match(/(\n|^)\|/)){g=V(a.slice(l));break}if(l===a.length-1&&I.type==="list"){const u=Se(I);if(u){g=[u];break}}if(l===a.length-1&&I.type==="paragraph"){const u=Q(I);if(u){g=[u];break}}}if(g){const I=[...a.slice(0,l),...g];return I.links=a.links,I}return null}function ce(a,l){const g=K(a);return h.marked.lexer(g+`
${l}`)}function ae(a){return re(a,"`")}function Ne(a){return re(a,"*")}function te(a){return re(a,"_")}function $e(a){return re(a,")")}function ye(a){return re(a,'")')}function Oe(a){return re(a,"](https://microsoft.com)")}function Re(a){return re(a,"**")}function Ce(a){return re(a,"__")}function re(a,l){const g=K(Array.isArray(a)?a:[a]);return h.marked.lexer(g+l)[0]}function V(a){const l=K(a),g=l.split(`
`);let I,F=!1;for(let u=0;u<g.length;u++){const N=g[u].trim();if(typeof I>"u"&&N.match(/^\s*\|/)){const S=N.match(/(\|[^\|]+)(?=\||$)/g);S&&(I=S.length)}else if(typeof I=="number")if(N.match(/^\s*\|/)){if(u!==g.length-1)return;F=!0}else return}if(typeof I=="number"&&I>0){const u=F?g.slice(0,-1).join(`
`):l,N=!!u.match(/\|\s*$/),S=u+(N?"":"|")+`
|${" --- |".repeat(I)}`;return h.marked.lexer(S)}}function j(a,l){return n.addHook(a,l),(0,o.$Uc)(()=>n.removeHook(a))}}),define(we[146],ve([1,0,4,29,16,145,75,34,15,54,9,3,8,2,5,20,128,120]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eV=void 0,i=We(i),$=We($);const h=i.$,c="selectOption.entry.template";class p{get templateId(){return c}renderTemplate(r){const d=Object.create(null);return d.root=r,d.text=i.$wT(r,h(".option-text")),d.detail=i.$wT(r,h(".option-detail")),d.decoratorRight=i.$wT(r,h(".option-decorator-right")),d}renderElement(r,d,D){const T=D,U=r.text,_=r.detail,H=r.decoratorRight,w=r.isDisabled;T.text.textContent=U,T.detail.textContent=_||"",T.decoratorRight.innerText=H||"",w?T.root.classList.add("option-disabled"):T.root.classList.remove("option-disabled")}disposeTemplate(r){}}class k extends m.$Wc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(r,d,D,T,U){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=T,this.g=U||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=k.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new A.$me,this.B(this.r),this.Q(),this.P(D),this.n=d||0,r&&this.setOptions(r,d),this.S()}O(r){!this.M&&r?this.M=this.B((0,v.$dV)().setupManagedHover((0,E.$rU)("mouse"),this.h,r)):this.M&&this.M.update(r)}getHeight(){return 22}getTemplateId(){return c}P(r){this.u=r,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$wT(this.w,h(".select-box-details-pane"));const d=i.$wT(this.w,h(".select-box-dropdown-container-width-control")),D=i.$wT(d,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$wT(D,this.D),this.G=L.AnchorPosition.BELOW,this.y=i.$0S(this.w),this.w.setAttribute("draggable","true"),this.B(i.$pS(this.w,i.$pT.DRAG_START,T=>{i.$rT.stop(T,!0)}))}Q(){this.B(i.$qS(this.h,"change",d=>{this.n=d.target.selectedIndex,this.r.fire({index:d.target.selectedIndex,selected:d.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$pS(this.h,i.$pT.CLICK,d=>{i.$rT.stop(d),this.f?this.Z(!0):this.Y()})),this.B(i.$pS(this.h,i.$pT.MOUSE_DOWN,d=>{i.$rT.stop(d)}));let r;this.B(i.$pS(this.h,"touchstart",d=>{r=this.f})),this.B(i.$pS(this.h,"touchend",d=>{i.$rT.stop(d),r?this.Z(!0):this.Y()})),this.B(i.$pS(this.h,i.$pT.KEY_DOWN,d=>{const D=new M.$mS(d);let T=!1;e.$j?(D.keyCode===b.KeyCode.DownArrow||D.keyCode===b.KeyCode.UpArrow||D.keyCode===b.KeyCode.Space||D.keyCode===b.KeyCode.Enter)&&(T=!0):(D.keyCode===b.KeyCode.DownArrow&&D.altKey||D.keyCode===b.KeyCode.UpArrow&&D.altKey||D.keyCode===b.KeyCode.Space||D.keyCode===b.KeyCode.Enter)&&(T=!0),T&&(this.Y(),i.$rT.stop(d,!0))}))}get onDidSelect(){return this.r.event}setOptions(r,d){$.$wb(this.m,r)||(this.m=r,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((D,T)=>{this.h.add(this.X(D.text,T,D.isDisabled)),typeof D.description=="string"&&(this.H=!0)})),d!==void 0&&(this.select(d),this.F=this.n)}setEnabled(r){this.h.disabled=!r}R(){this.z?.splice(0,this.z.length,this.m)}select(r){r>=0&&r<this.m.length?this.n=r:r>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(r){this.g.ariaLabel=r,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(r){this.h.tabIndex=r?0:-1}render(r){this.j=r,r.classList.add("select-container"),r.appendChild(this.h),this.U()}S(){const r=[];this.s.listFocusBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(r.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),r.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&r.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),r.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=r.join(`
`)}U(){const r=this.s.selectBackground??"",d=this.s.selectForeground??"",D=this.s.selectBorder??"";this.h.style.backgroundColor=r,this.h.style.color=d,this.h.style.borderColor=D}W(){const r=this.s.selectBackground??"",d=i.$OT(this.s.selectListBackground,r);this.C.style.backgroundColor=d,this.I.style.backgroundColor=d;const D=this.s.focusBorder??"";this.w.style.outlineColor=D,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(r,d,D){const T=document.createElement("option");return T.value=r,T.text=r,T.disabled=!!D,T}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:r=>this.ab(r,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:r=>this.ab(r),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(r){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),r&&this.h.focus(),this.u.hideContextView())}ab(r,d){return r.appendChild(this.w),this.cb(d),{dispose:()=>{this.w.remove()}}}bb(){let r=0;return this.m.forEach((d,D)=>{this.jb(D),this.I.offsetHeight>r&&(r=this.I.offsetHeight)}),r}cb(r){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const d=i.getWindow(this.h),D=i.$LS(this.h),T=i.getWindow(this.h).getComputedStyle(this.h),U=parseFloat(T.getPropertyValue("--dropdown-padding-top"))+parseFloat(T.getPropertyValue("--dropdown-padding-bottom")),_=d.innerHeight-D.top-D.height-(this.g.minBottomMargin||0),H=D.top-k.b,w=this.h.offsetWidth,C=this.db(this.D),W=Math.max(C,Math.round(w)).toString()+"px";this.w.style.width=W,this.z.getHTMLElement().style.height="",this.z.layout();let O=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const B=this.H?this.L:0,z=O+U+B,J=Math.floor((_-U-B)/this.getHeight()),X=Math.floor((H-U-B)/this.getHeight());if(r)return D.top+D.height>d.innerHeight-22||D.top<k.b||J<1&&X<1?!1:(J<k.c&&X>J&&this.m.length>J?(this.G=L.AnchorPosition.ABOVE,this.C.remove(),this.I.remove(),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=L.AnchorPosition.BELOW,this.C.remove(),this.I.remove(),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(D.top+D.height>d.innerHeight-22||D.top<k.b||this.G===L.AnchorPosition.BELOW&&J<1||this.G===L.AnchorPosition.ABOVE&&X<1)return this.Z(!0),!1;if(this.G===L.AnchorPosition.BELOW){if(this.f&&J+X<1)return this.Z(!0),!1;z>_&&(O=J*this.getHeight())}else z>H&&(O=X*this.getHeight());return this.z.layout(O),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=O+U+"px",this.w.style.height=""):this.w.style.height=O+U+"px",this.jb(this.n),this.w.style.width=W,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(r){let d=0;if(r){let D=0,T=0;this.m.forEach((U,_)=>{const H=U.detail?U.detail.length:0,w=U.decoratorRight?U.decoratorRight.length:0,C=U.text.length+H+w;C>T&&(D=_,T=C)}),r.textContent=this.m[D].text+(this.m[D].decoratorRight?this.m[D].decoratorRight+" ":""),d=i.$NS(r)}return d}eb(r){if(this.z)return;this.C=i.$wT(r,h(".select-box-dropdown-list-container")),this.t=new p,this.z=new f.$7U("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:s.ScrollbarVisibility.Visible,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:T=>{let U=T.text;return T.detail&&(U+=`. ${T.detail}`),T.decoratorRight&&(U+=`. ${T.decoratorRight}`),T.description&&(U+=`. ${T.description}`),U},getWidgetAriaLabel:()=>(0,o.localize)(0,null),getRole:()=>e.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const d=this.B(new n.$BU(this.C,"keydown")),D=A.Event.chain(d.event,T=>T.filter(()=>this.z.length>0).map(U=>new M.$mS(U)));this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.Enter))(this.lb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.Tab))(this.lb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.Escape))(this.kb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.UpArrow))(this.nb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.DownArrow))(this.mb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.PageDown))(this.pb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.PageUp))(this.ob,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.Home))(this.qb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode===b.KeyCode.End))(this.rb,this)),this.B(A.Event.chain(D,T=>T.filter(U=>U.keyCode>=b.KeyCode.Digit0&&U.keyCode<=b.KeyCode.KeyZ||U.keyCode>=b.KeyCode.Semicolon&&U.keyCode<=b.KeyCode.NumpadDivide))(this.sb,this)),this.B(i.$pS(this.z.getHTMLElement(),i.$pT.POINTER_UP,T=>this.fb(T))),this.B(this.z.onMouseOver(T=>typeof T.index<"u"&&this.z.setFocus([T.index]))),this.B(this.z.onDidChangeFocus(T=>this.ib(T))),this.B(i.$pS(this.w,i.$pT.FOCUS_OUT,T=>{!this.f||i.$TS(T.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(r){if(!this.z.length)return;i.$rT.stop(r);const d=r.target;if(!d||d.classList.contains("slider"))return;const D=d.closest(".monaco-list-row");if(!D)return;const T=Number(D.getAttribute("data-index")),U=D.classList.contains("option-disabled");T>=0&&T<this.m.length&&!U&&(this.n=T,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(r,d){const D=U=>{for(let _=0;_<U.childNodes.length;_++){const H=U.childNodes.item(_);(H.tagName&&H.tagName.toLowerCase())==="img"?H.remove():D(H)}},T=(0,R.$0U)({value:r,supportThemeIcons:!0},{actionHandler:d});return T.element.classList.add("select-box-description-markdown"),D(T.element),T.element}ib(r){!this.f||!this.H||this.jb(r.indexes[0])}jb(r){this.I.innerText="";const d=this.m[r],D=d?.description??"",T=d?.descriptionIsMarkdown??!1;if(D){if(T){const U=d.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(D,U))}else this.I.innerText=D;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(r){i.$rT.stop(r),this.select(this.F),this.Z(!0)}lb(r){i.$rT.stop(r),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(r){if(this.n<this.m.length-1){i.$rT.stop(r,!0);const d=this.m[this.n+1].isDisabled;if(d&&this.m.length>this.n+2)this.n+=2;else{if(d)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(r){this.n>0&&(i.$rT.stop(r,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(r){i.$rT.stop(r),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(r){i.$rT.stop(r),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(r){i.$rT.stop(r),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(r){i.$rT.stop(r),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(r){const d=b.KeyCodeUtils.toString(r.keyCode);let D=-1;for(let T=0;T<this.m.length-1;T++)if(D=(T+this.n+1)%this.m.length,this.m[D].text.charAt(0).toUpperCase()===d&&!this.m[D].isDisabled){this.select(D),this.z.setFocus([D]),this.z.reveal(this.z.getFocus()[0]),i.$rT.stop(r);break}}dispose(){this.Z(!1),super.dispose()}}t.$eV=k}),define(we[147],ve([1,0,54,146,140,24,5,119]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hV=t.$gV=void 0,t.$gV={...i.$6U,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class v extends R.$$T{constructor(f,$,A,b,m){super(),L.$j&&!m?.useCustomDrawn?this.a=new M.$fV(f,$,b,m):this.a=new n.$eV(f,$,A,b,m),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(f,$){this.a.setOptions(f,$)}select(f){this.a.select(f)}setAriaLabel(f){this.a.setAriaLabel(f)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(f){this.a.setFocusable(f)}setEnabled(f){this.a.setEnabled(f)}render(f){this.a.render(f)}}t.$hV=v}),define(we[80],ve([1,0,19,71,4,33,15,147,51,2,5,10,124,34,68]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pV=t.$oV=t.$nV=void 0,$=We($),A=We(A),b=We(b);class e extends f.$Wc{get action(){return this._action}constructor(c,p,k={}){super(),this.m=k,this._context=c||this,this._action=p,p instanceof E.$kj&&this.B(p.onDidChange(y=>{this.element&&this.t(y)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.H(),c.class!==void 0&&this.G(),c.label!==void 0&&(this.w(),this.D()),c.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new E.$lj)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const p=this.element=c;this.B(R.$7T.addTarget(c));const k=this.m&&this.m.draggable;k&&(c.draggable=!0,i.$8R&&this.B((0,M.$pS)(c,M.$pT.DRAG_START,y=>y.dataTransfer?.setData(n.$5T.TEXT,this._action.label)))),this.B((0,M.$pS)(p,R.EventType.Tap,y=>this.onClick(y,!0))),this.B((0,M.$pS)(p,M.$pT.MOUSE_DOWN,y=>{k||M.$rT.stop(y,!0),this._action.enabled&&y.button===0&&p.classList.add("active")})),$.$j&&this.B((0,M.$pS)(p,M.$pT.CONTEXT_MENU,y=>{y.button===0&&y.ctrlKey===!0&&this.onClick(y)})),this.B((0,M.$pS)(p,M.$pT.CLICK,y=>{M.$rT.stop(y,!0),this.m&&this.m.isMenu||this.onClick(y)})),this.B((0,M.$pS)(p,M.$pT.DBLCLICK,y=>{M.$rT.stop(y,!0)})),[M.$pT.MOUSE_UP,M.$pT.MOUSE_OUT].forEach(y=>{this.B((0,M.$pS)(p,y,r=>{M.$rT.stop(r),p.classList.remove("active")}))})}onClick(c,p=!1){M.$rT.stop(c,!0);const k=A.$og(this._context)?this.m?.useEventAsContext?c:{preserveFocus:p}:this._context;this.actionRunner.run(this._action,k)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const c=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=c;else if(!this.f&&c!==""){const p=this.m.hoverDelegate??(0,L.$rU)("element");this.f=this.q.add((0,m.$dV)().setupManagedHover(p,this.element,c))}else this.f&&this.f.update(c)}F(){if(this.element){const c=this.C()??"";this.element.setAttribute("aria-label",c)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$nV=e;class s extends e{constructor(c,p,k){super(c,p,k),this.m=k,this.m.icon=k.icon!==void 0?k.icon:!1,this.m.label=k.label!==void 0?k.label:!0,this.L=""}render(c){super.render(c),A.$pg(this.element);const p=document.createElement("a");if(p.classList.add("action-label"),p.setAttribute("role",this.M()),this.I=p,this.element.appendChild(p),this.m.label&&this.m.keybinding){const k=document.createElement("span");k.classList.add("keybinding"),k.textContent=this.m.keybinding,this.element.appendChild(k)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===E.$mj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(c){this.I&&(this.I.tabIndex=c?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=b.localize(0,null,c,this.m.keybinding))),c??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const c=this.C()??"";this.I.setAttribute("aria-label",c)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$oV=s;class o extends e{constructor(c,p,k,y,r,d,D){super(c,p),this.b=new v.$hV(k,y,r,d,D),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,p){this.b.setOptions(c,p)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.n(c.selected,c.index)))}n(c,p){this.actionRunner.run(this._action,this.r(c,p))}r(c,p){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}t.$pV=o}),define(we[81],ve([1,0,4,16,80,15,51,3,8,2,10,68]),function(ne,t,i,n,M,R,L,v,E,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tU=t.ActionsOrientation=void 0,t.$uU=m,i=We(i),$=We($);var A;(function(e){e[e.HORIZONTAL=0]="HORIZONTAL",e[e.VERTICAL=1]="VERTICAL"})(A||(t.ActionsOrientation=A={}));class b extends f.$Wc{constructor(s,o={}){super(),this.j=this.B(new f.$Vc),this.s=this.B(new f.$6c),this.y=!1,this.z=!0,this.D=this.B(new v.$me),this.onDidBlur=this.D.event,this.F=this.B(new v.$me({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new v.$me),this.onDidRun=this.H.event,this.I=this.B(new v.$me),this.onWillRun=this.I.event,this.b=o,this.m=o.context??null,this.n=this.b.orientation??A.HORIZONTAL,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[E.KeyCode.Enter,E.KeyCode.Space]},this.f=o.hoverDelegate??this.B((0,R.$sU)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new L.$lj,this.j.add(this.g)),this.j.add(this.g.onDidRun(p=>this.H.fire(p))),this.j.add(this.g.onWillRun(p=>this.I.fire(p))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let h,c;switch(this.n){case A.HORIZONTAL:h=[E.KeyCode.LeftArrow],c=[E.KeyCode.RightArrow];break;case A.VERTICAL:h=[E.KeyCode.UpArrow],c=[E.KeyCode.DownArrow],this.domNode.className+=" vertical";break}this.B(i.$pS(this.domNode,i.$pT.KEY_DOWN,p=>{const k=new n.$mS(p);let y=!0;const r=typeof this.u=="number"?this.viewItems[this.u]:void 0;h&&(k.equals(h[0])||k.equals(h[1]))?y=this.Q():c&&(k.equals(c[0])||k.equals(c[1]))?y=this.P():k.equals(E.KeyCode.Escape)&&this.G?this.F.fire():k.equals(E.KeyCode.Home)?y=this.N():k.equals(E.KeyCode.End)?y=this.O():k.equals(E.KeyCode.Tab)&&r instanceof M.$nV&&r.trapsArrowNavigation?y=this.P():this.L(k)?this.r.keyDown?this.S(k):this.y=!0:y=!1,y&&(k.preventDefault(),k.stopPropagation())})),this.B(i.$pS(this.domNode,i.$pT.KEY_UP,p=>{const k=new n.$mS(p);this.L(k)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(k)),k.preventDefault(),k.stopPropagation()):(k.equals(E.KeyCode.Tab)||k.equals(E.KeyMod.Shift|E.KeyCode.Tab)||k.equals(E.KeyCode.UpArrow)||k.equals(E.KeyCode.DownArrow)||k.equals(E.KeyCode.LeftArrow)||k.equals(E.KeyCode.RightArrow))&&this.M()})),this.w=this.B(i.$uT(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$2S()===this.domNode||!i.$TS(i.$2S(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),s.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(s){s?this.C.setAttribute("aria-label",s):this.C.removeAttribute("aria-label")}setFocusable(s){if(this.z=s,this.z){const o=this.viewItems.find(h=>h instanceof M.$nV&&h.isEnabled());o instanceof M.$nV&&o.setFocusable(!0)}else this.viewItems.forEach(o=>{o instanceof M.$nV&&o.setFocusable(!1)})}L(s){let o=!1;return this.r.keys.forEach(h=>{o=o||s.equals(h)}),o}M(){for(let s=0;s<this.C.children.length;s++){const o=this.C.children[s];if(i.$TS(i.$2S(),o)){this.u=s,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(s){this.m=s,this.viewItems.forEach(o=>o.setActionContext(s))}get actionRunner(){return this.g}set actionRunner(s){this.g=s,this.j.clear(),this.j.add(this.g.onDidRun(o=>this.H.fire(o))),this.j.add(this.g.onWillRun(o=>this.I.fire(o))),this.viewItems.forEach(o=>o.actionRunner=s)}getContainer(){return this.domNode}hasAction(s){return this.viewItems.findIndex(o=>o.action.id===s.id)!==-1}getAction(s){if(typeof s=="number")return this.viewItems[s]?.action;if(i.$eT(s)){for(;s.parentElement!==this.C;){if(!s.parentElement)return;s=s.parentElement}for(let o=0;o<this.C.childNodes.length;o++)if(this.C.childNodes[o]===s)return this.viewItems[o].action}}push(s,o={}){const h=Array.isArray(s)?s:[s];let c=$.$jg(o.index)?o.index:null;h.forEach(p=>{const k=document.createElement("li");k.className="action-item",k.setAttribute("role","presentation");let y;const r={hoverDelegate:this.f,...o};this.b.actionViewItemProvider&&(y=this.b.actionViewItemProvider(p,r)),y||(y=new M.$oV(this.context,p,r)),this.b.allowContextMenu||this.s.set(y,i.$pS(k,i.$pT.CONTEXT_MENU,d=>{i.$rT.stop(d,!0)})),y.actionRunner=this.g,y.setActionContext(this.context),y.render(k),this.z&&y instanceof M.$nV&&this.viewItems.length===0&&y.setFocusable(!0),c===null||c<0||c>=this.C.children.length?(this.C.appendChild(k),this.viewItems.push(y)):(this.C.insertBefore(k,this.C.children[c]),this.viewItems.splice(c,0,y),c++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(s){if(s>=0&&s<this.C.children.length){const o=this.C.children.item(s);if(o)return o.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.C.children.length){const o=this.C.children.item(s);if(o)return o.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.C.childNodes[s].remove(),this.s.deleteAndDispose(this.viewItems[s]),(0,f.$Rc)(this.viewItems.splice(s,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,f.$Rc)(this.viewItems),this.s.clearAndDisposeAll(),i.$oS(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let o=!1,h;if(s===void 0?o=!0:typeof s=="number"?h=s:typeof s=="boolean"&&(o=s),o&&typeof this.u>"u"){const c=this.viewItems.findIndex(p=>p.isEnabled());this.u=c===-1?void 0:c,this.R(void 0,void 0,!0)}else h!==void 0&&(this.u=h),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(s){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const o=this.u;let h;do{if(!s&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=o,!1;this.u=(this.u+1)%this.viewItems.length,h=this.viewItems[this.u]}while(this.u!==o&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===L.$mj.ID));return this.R(),!0}Q(s){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const o=this.u;let h;do{if(this.u=this.u-1,this.u<0){if(!s&&this.b.preventLoopNavigation)return this.u=o,!1;this.u=this.viewItems.length-1}h=this.viewItems[this.u]}while(this.u!==o&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===L.$mj.ID));return this.R(!0),!0}R(s,o,h=!1){typeof this.u>"u"&&this.C.focus({preventScroll:o}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const c=this.u!==void 0?this.viewItems[this.u]:void 0;if(c){let p=!0;$.$tg(c.focus)||(p=!1),this.b.focusOnlyEnabledItems&&$.$tg(c.isEnabled)&&!c.isEnabled()&&(p=!1),c.action.id===L.$mj.ID&&(p=!1),p?(h||this.t!==this.u)&&(c.focus(s),this.t=this.u):(this.C.focus({preventScroll:o}),this.t=void 0),p&&c.showHover?.()}}S(s){if(typeof this.u>"u")return;const o=this.viewItems[this.u];if(o instanceof M.$nV){const h=o._context===null||o._context===void 0?s:o._context;this.run(o._action,h)}}async run(s,o){await this.g.run(s,o)}dispose(){this.m=void 0,this.viewItems=(0,f.$Rc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$tU=b;function m(e){if(!e.length)return e;let s=-1;for(let h=0;h<e.length;h++)if(e[h].id!==L.$mj.ID){s=h;break}if(s===-1)return[];e=e.slice(s);for(let h=e.length-1;h>=0&&e[h].id===L.$mj.ID;h--)e.splice(h,1);let o=!1;for(let h=e.length-1;h>=0;h--){const c=e[h].id===L.$mj.ID;c&&!o?e.splice(h,1):c?c&&(o=!1):o=!0}return e}}),define(we[82],ve([1,0,4,29,72,81,74,75,34,15,78,24,3,95,64,20,127,116]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eW=t.$dW=t.$cW=t.MessageType=void 0,i=We(i),L=We(L),o=We(o);const h=i.$;var c;(function(y){y[y.INFO=1]="INFO",y[y.WARNING=2]="WARNING",y[y.ERROR=3]="ERROR"})(c||(t.MessageType=c={})),t.$cW={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class p extends A.$$T{constructor(r,d,D){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new b.$me),this.onDidChange=this.P.event,this.Q=this.B(new b.$me),this.onDidHeightChange=this.Q.event,this.a=d,this.g=D,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$wT(r,h(".monaco-inputbox.idle"));const T=this.g.flexibleHeight?"textarea":"input",U=i.$wT(this.element,h(".ibwrapper"));if(this.b=i.$wT(U,h(T+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$wT(U,h("div.mirror")),this.y.innerText="\xA0",this.N=new $.$iU(this.element,{vertical:s.ScrollbarVisibility.Auto}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$wT(r,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(w=>this.b.scrollTop=w.scrollTop));const _=this.B(new n.$BU(r.ownerDocument,"selectionchange")),H=b.Event.filter(_.event,()=>r.ownerDocument.getSelection()?.anchorNode===U);this.B(H(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new R.$tU(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(r){this.n=r,this.b.setAttribute("placeholder",r)}setTooltip(r){this.r=r,this.O?this.O.update(r):this.O=this.B((0,E.$dV)().setupManagedHover((0,f.$rU)("mouse"),this.b,r))}setAriaLabel(r){this.s=r,r?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(r){this.b.value!==r&&(this.b.value=r,this.Z())}get step(){return this.b.step}set step(r){this.b.step=r}get height(){return typeof this.J=="number"?this.J:i.$RS(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$3S(this.b)}select(r=null){this.b.select(),r&&(this.b.setSelectionRange(r.start,r.end),r.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const r=this.b.selectionStart;if(r===null)return null;const d=this.b.selectionEnd??r;return{start:r,end:d}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(r){r?this.enable():this.disable()}get width(){return i.$NS(this.b)}set width(r){if(this.g.flexibleHeight&&this.g.flexibleWidth){let d=0;if(this.y){const D=parseFloat(this.y.style.paddingLeft||"")||0,T=parseFloat(this.y.style.paddingRight||"")||0;d=D+T}this.b.style.width=r-d+"px"}else this.b.style.width=r+"px";this.y&&(this.y.style.width=r+"px")}set paddingRight(r){this.b.style.width=`calc(100% - ${r}px)`,this.y&&(this.y.style.paddingRight=r+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const r=this.L,d=this.J,D=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:r,height:d}),this.N.setScrollPosition({scrollTop:D})}showMessage(r,d){if(this.w==="open"&&(0,e.$go)(this.h,r))return;this.h=r,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(r.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$OT(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||d)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let r=null;return this.t&&(r=this.t(this.value),r?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(r)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),r?.type}stylesForType(r){const d=this.g.inputBoxStyles;switch(r){case c.INFO:return{border:d.inputValidationInfoBorder,background:d.inputValidationInfoBackground,foreground:d.inputValidationInfoForeground};case c.WARNING:return{border:d.inputValidationWarningBorder,background:d.inputValidationWarningBackground,foreground:d.inputValidationWarningForeground};default:return{border:d.inputValidationErrorBorder,background:d.inputValidationErrorBackground,foreground:d.inputValidationErrorForeground}}}W(r){switch(r){case c.INFO:return"info";case c.WARNING:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let r;const d=()=>r.style.width=i.$NS(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:v.AnchorAlignment.RIGHT,render:T=>{if(!this.h)return null;r=i.$wT(T,h(".monaco-inputbox-container")),d();const U={inline:!0,className:"monaco-inputbox-message"},_=this.h.formatContent?(0,M.$zU)(this.h.content,U):(0,M.$yU)(this.h.content,U);_.classList.add(this.W(this.h.type));const H=this.stylesForType(this.h.type);return _.style.backgroundColor=H.background??"",_.style.color=H.foreground??"",_.style.border=H.border?`1px solid ${H.border}`:"",i.$wT(r,_),null},onHide:()=>{this.w="closed"},layout:d});let D;this.h.type===c.ERROR?D=o.localize(0,null,this.h.content):this.h.type===c.WARNING?D=o.localize(1,null,this.h.content):D=o.localize(2,null,this.h.content),L.$DU(D),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const r=this.value,D=r.charCodeAt(r.length-1)===10?" ":"";(r+D).replace(/\u000c/g,"")?this.y.textContent=r+D:this.y.innerText="\xA0",this.layout()}bb(){const r=this.g.inputBoxStyles,d=r.inputBackground??"",D=r.inputForeground??"",T=r.inputBorder??"";this.element.style.backgroundColor=d,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${i.$OT(T,"transparent")}`}layout(){if(!this.y)return;const r=this.L;this.L=i.$RS(this.y),r!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(r){const d=this.inputElement,D=d.selectionStart,T=d.selectionEnd,U=d.value;D!==null&&T!==null&&(this.value=U.substr(0,D)+r+U.substr(T),d.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$dW=p;class k extends p{constructor(r,d,D){const T=o.localize(3,null,"\u21C5"),U=o.localize(4,null,"\u21C5");super(r,d,D),this.eb=this.B(new b.$me),this.onDidFocus=this.eb.event,this.fb=this.B(new b.$me),this.onDidBlur=this.fb.event,this.cb=new m.$aW(D.history,100);const _=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.n.endsWith(T)&&!this.n.endsWith(U)&&this.cb.getHistory().length){const H=this.n.endsWith(")")?T:U,w=this.n+H;D.showPlaceholderOnFocus&&!i.$3S(this.b)?this.n=w:this.setPlaceHolder(w)}};this.db=new MutationObserver((H,w)=>{H.forEach(C=>{C.target.textContent||_()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>_()),this.F(this.b,()=>{const H=w=>{if(this.n.endsWith(w)){const C=this.n.slice(0,this.n.length-w.length);return D.showPlaceholderOnFocus?this.n=C:this.setPlaceHolder(C),!0}else return!1};H(U)||H(T)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(r){this.value&&(r||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(r){const d=this.getHistory();this.clearHistory(),r.forEach(D=>{this.cb.add(D)}),d.forEach(D=>{this.cb.add(D)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let r=this.kb();r&&(r=r===this.value?this.kb():r),this.value=r??"",L.$EU(this.value?this.value:o.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let r=this.jb();r&&(r=r===this.value?this.jb():r),r&&(this.value=r,L.$EU(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(r){super.setPlaceHolder(r),this.setTooltip(r)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let r=this.cb.current();return r||(r=this.cb.last(),this.cb.next()),r}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$eW=k}),define(we[83],ve([1,0,80,24,21,22,3,8,4,15,34,121]),function(ne,t,i,n,M,R,L,v,E,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mV=t.$lV=t.$kV=t.$jV=t.$iV=void 0,t.$iV={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class A extends i.$nV{constructor(o,h,c){super(o,h,c),this.a=this.B(new b({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:c.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:c.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:c.toggleStyles?.inputActiveOptionForeground,hoverDelegate:c.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(o){this.element=o,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(o){this.a.domNode.tabIndex=o?0:-1}}t.$jV=A;class b extends n.$$T{constructor(o){super(),this.a=this.B(new L.$me),this.onChange=this.a.event,this.b=this.B(new L.$me),this.onKeyDown=this.b.event,this.c=o,this.s=this.c.isChecked;const h=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,h.push(...R.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&h.push(...this.c.actionClassName.split(" ")),this.s&&h.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,$.$dV)().setupManagedHover(o.hoverDelegate??(0,f.$rU)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...h),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,c=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),c.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,c=>{if(c.keyCode===v.KeyCode.Space||c.keyCode===v.KeyCode.Enter){this.checked=!this.s,this.a.fire(!0),c.preventDefault(),c.stopPropagation();return}this.b.fire(c)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(o){this.s=o,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(o){this.g&&this.domNode.classList.remove(...R.ThemeIcon.asClassNameArray(this.g)),this.g=o,this.g&&this.domNode.classList.add(...R.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(o){this.t.update(o),this.domNode.setAttribute("aria-label",o)}set visible(o){this.domNode.style.display=o?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$kV=b;class m extends n.$$T{static{this.CLASS_NAME="monaco-checkbox"}constructor(o,h,c){super(),this.g=o,this.h=h,this.a=this.B(new L.$me),this.onChange=this.a.event,this.b=this.B(new b({title:this.g,isChecked:this.h,icon:M.$5j.check,actionClassName:m.CLASS_NAME,...t.$iV})),this.domNode=this.b.domNode,this.c=c,this.n(),this.B(this.b.onChange(p=>{this.n(),this.a.fire(p)}))}get checked(){return this.b.checked}set checked(o){this.b.checked=o,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,E.$3S)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$lV=m;class e extends i.$nV{constructor(o,h,c){super(o,h,c),this.a=this.B(new m(this._action.label,!!this._action.checked,c.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(o){if(this.element=o,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const h=this.element.appendChild((0,E.$)("span.checkbox-label",void 0,this._action.label));this.B((0,E.$pS)(h,E.$pT.CLICK,c=>{this.a.checked=!this.a.checked,c.stopPropagation(),c.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(o){this.a.domNode.tabIndex=o?0:-1}}t.$mV=e}),define(we[148],ve([1,0,15,83,21,126]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kW=t.$jW=t.$iW=void 0,R=We(R);const L=R.localize(0,null),v=R.localize(1,null),E=R.localize(2,null);class f extends n.$kV{constructor(m){super({icon:M.$5j.caseSensitive,title:L+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$rU)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$iW=f;class $ extends n.$kV{constructor(m){super({icon:M.$5j.wholeWord,title:v+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$rU)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$jW=$;class A extends n.$kV{constructor(m){super({icon:M.$5j.regex,title:E+m.appendTitle,isChecked:m.isChecked,hoverDelegate:m.hoverDelegate??(0,i.$rU)("element"),inputActiveOptionBorder:m.inputActiveOptionBorder,inputActiveOptionForeground:m.inputActiveOptionForeground,inputActiveOptionBackground:m.inputActiveOptionBackground})}}t.$kW=A}),define(we[149],ve([1,0,4,148,82,24,3,8,125,2,15,115]),function(ne,t,i,n,M,R,L,v,E,f,$){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lW=void 0,i=We(i),E=We(E);const A=E.localize(0,null);class b extends R.$$T{static{this.OPTION_CHANGE="optionChange"}constructor(e,s,o){super(),this.n=!0,this.s=!1,this.w=this.B(new f.$Xc),this.N=[],this.O=this.B(new L.$me),this.onDidOptionChange=this.O.event,this.P=this.B(new L.$me),this.onKeyDown=this.P.event,this.Q=this.B(new L.$me),this.onMouseDown=this.Q.event,this.R=this.B(new L.$me),this.onInput=this.R.event,this.S=this.B(new L.$me),this.onKeyUp=this.S.event,this.U=this.B(new L.$me),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new L.$me),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=o.placeholder||"",this.b=o.validation,this.c=o.label||A,this.h=!!o.showCommonFindToggles;const h=o.appendCaseSensitiveLabel||"",c=o.appendWholeWordsLabel||"",p=o.appendRegexLabel||"",k=o.history||[],y=!!o.flexibleHeight,r=!!o.flexibleWidth,d=o.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new M.$eW(this.domNode,s,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:k,showHistoryHint:o.showHistoryHint,flexibleHeight:y,flexibleWidth:r,flexibleMaxHeight:d,inputBoxStyles:o.inputBoxStyles}));const D=this.B((0,$.$sU)());if(this.h){this.J=this.B(new n.$kW({appendTitle:p,isChecked:!1,hoverDelegate:D,...o.toggleStyles})),this.B(this.J.onChange(U=>{this.O.fire(U),!U&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(U=>{this.W.fire(U)})),this.L=this.B(new n.$jW({appendTitle:c,isChecked:!1,hoverDelegate:D,...o.toggleStyles})),this.B(this.L.onChange(U=>{this.O.fire(U),!U&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new n.$iW({appendTitle:h,isChecked:!1,hoverDelegate:D,...o.toggleStyles})),this.B(this.M.onChange(U=>{this.O.fire(U),!U&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(U=>{this.U.fire(U)}));const T=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,U=>{if(U.equals(v.KeyCode.LeftArrow)||U.equals(v.KeyCode.RightArrow)||U.equals(v.KeyCode.Escape)){const _=T.indexOf(this.domNode.ownerDocument.activeElement);if(_>=0){let H=-1;U.equals(v.KeyCode.RightArrow)?H=(_+1)%T.length:U.equals(v.KeyCode.LeftArrow)&&(_===0?H=T.length-1:H=_-1),U.equals(v.KeyCode.Escape)?(T[_].blur(),this.inputBox.focus()):H>=0&&T[H].focus(),i.$rT.stop(U,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(o?.additionalToggles),this.y&&this.domNode.appendChild(this.y),e?.appendChild(this.domNode),this.B(i.$pS(this.inputBox.inputElement,"compositionstart",T=>{this.s=!0})),this.B(i.$pS(this.inputBox.inputElement,"compositionend",T=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,T=>this.P.fire(T)),this.C(this.inputBox.inputElement,T=>this.S.fire(T)),this.D(this.inputBox.inputElement,T=>this.R.fire()),this.j(this.inputBox.inputElement,T=>this.Q.fire(T))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(e){this.inputBox.layout(),this.X(e.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const e of this.N)e.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const e of this.N)e.disable()}setFocusInputOnOptionClick(e){this.n=e}setEnabled(e){e?this.enable():this.disable()}setAdditionalToggles(e){for(const s of this.N)s.domNode.remove();this.N=[],this.w.value=new f.$Vc;for(const s of e??[])this.w.value.add(s),this.y.appendChild(s.domNode),this.w.value.add(s.onChange(o=>{this.O.fire(o),!o&&this.n&&this.inputBox.focus()})),this.N.push(s);this.N.length>0&&(this.y.style.display=""),this.X()}X(e=!1){e?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((s,o)=>s+o.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(e){this.inputBox.value!==e&&(this.inputBox.value=e)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(e){this.M&&(this.M.checked=e)}getWholeWords(){return this.L?.checked??!1}setWholeWords(e){this.L&&(this.L.checked=e)}getRegex(){return this.J?.checked??!1}setRegex(e){this.J&&(this.J.checked=e,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(e){this.inputBox.showMessage(e)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$lW=b}),define(we[150],ve([1,0,4,29,16,81,149,82,79,54,83,76,35,51,9,12,21,22,44,3,50,8,2,38,10,129,15,62,122]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o,h,c,p,k,y,r,d,D,T,U,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YW=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$XW=t.$WW=t.$VW=t.RenderIndentGuides=t.$UW=t.$TW=void 0;class H extends E.$LU{set context(u){this.c.context=u}get context(){return this.c.context}constructor(u){super(u.elements.map(N=>N.element)),this.c=u}}function w(F){return F instanceof E.$LU?new H(F):F}class C{constructor(u,N){this.d=u,this.f=N,this.b=r.$Wc.None,this.c=new r.$Vc}getDragURI(u){return this.f.getDragURI(u.element)}getDragLabel(u,N){if(this.f.getDragLabel)return this.f.getDragLabel(u.map(S=>S.element),N)}onDragStart(u,N){this.f.onDragStart?.(w(u),N)}onDragOver(u,N,S,P,x,G=!0){const ie=this.f.onDragOver(w(u),N&&N.element,S,P,x),le=this.a!==N;if(le&&(this.b.dispose(),this.a=N),typeof N>"u")return ie;if(le&&typeof ie!="boolean"&&ie.autoExpand&&(this.b=(0,s.$Hh)(()=>{const ke=this.d(),fe=ke.getNodeLocation(N);ke.isCollapsed(fe)&&ke.setCollapsed(fe,!1),this.a=void 0},500,this.c)),typeof ie=="boolean"||!ie.accept||typeof ie.bubble>"u"||ie.feedback){if(!G){const ke=typeof ie=="boolean"?ie:ie.accept,fe=typeof ie=="boolean"?void 0:ie.effect;return{accept:ke,effect:fe,feedback:[S]}}return ie}if(ie.bubble===b.TreeDragOverBubble.Up){const ke=this.d(),fe=ke.getNodeLocation(N),Ie=ke.getParentNodeLocation(fe),ze=ke.getNode(Ie),Xe=Ie&&ke.getListIndex(Ie);return this.onDragOver(u,ze,Xe,P,x,!1)}const de=this.d(),Ee=de.getNodeLocation(N),De=de.getListIndex(Ee),Te=de.getListRenderCount(Ee);return{...ie,feedback:(0,e.$Tb)(De,De+Te)}}drop(u,N,S,P,x){this.b.dispose(),this.a=void 0,this.f.drop(w(u),N&&N.element,S,P,x)}onDragEnd(u){this.f.onDragEnd?.(u)}dispose(){this.c.dispose(),this.f.dispose()}}function W(F,u){return u&&{...u,identityProvider:u.identityProvider&&{getId(N){return u.identityProvider.getId(N.element)}},dnd:u.dnd&&new C(F,u.dnd),multipleSelectionController:u.multipleSelectionController&&{isSelectionSingleChangeEvent(N){return u.multipleSelectionController.isSelectionSingleChangeEvent({...N,element:N.element})},isSelectionRangeChangeEvent(N){return u.multipleSelectionController.isSelectionRangeChangeEvent({...N,element:N.element})}},accessibilityProvider:u.accessibilityProvider&&{...u.accessibilityProvider,getSetSize(N){const S=F(),P=S.getNodeLocation(N),x=S.getParentNodeLocation(P);return S.getNode(x).visibleChildrenCount},getPosInSet(N){return N.visibleChildIndex+1},isChecked:u.accessibilityProvider&&u.accessibilityProvider.isChecked?N=>u.accessibilityProvider.isChecked(N.element):void 0,getRole:u.accessibilityProvider&&u.accessibilityProvider.getRole?N=>u.accessibilityProvider.getRole(N.element):()=>"treeitem",getAriaLabel(N){return u.accessibilityProvider.getAriaLabel(N.element)},getWidgetAriaLabel(){return u.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:u.accessibilityProvider&&u.accessibilityProvider.getWidgetRole?()=>u.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:u.accessibilityProvider&&u.accessibilityProvider.getAriaLevel?N=>u.accessibilityProvider.getAriaLevel(N.element):N=>N.depth,getActiveDescendantId:u.accessibilityProvider.getActiveDescendantId&&(N=>u.accessibilityProvider.getActiveDescendantId(N.element))},keyboardNavigationLabelProvider:u.keyboardNavigationLabelProvider&&{...u.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(N){return u.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(N.element)}}}}class O{constructor(u){this.a=u}getHeight(u){return this.a.getHeight(u.element)}getTemplateId(u){return this.a.getTemplateId(u.element)}hasDynamicHeight(u){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(u.element)}setDynamicHeight(u,N){this.a.setDynamicHeight?.(u.element,N)}}t.$TW=O;class B{static lift(u){return u instanceof B?u:new B(u)}static empty(u=0){return new B({focus:[],selection:[],expanded:Object.create(null),scrollTop:u})}constructor(u){if(this.focus=new Set(u.focus),this.selection=new Set(u.selection),u.expanded instanceof Array){this.expanded=Object.create(null);for(const N of u.expanded)this.expanded[N]=1}else this.expanded=u.expanded;this.expanded=u.expanded,this.scrollTop=u.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$UW=B;var z;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(z||(t.RenderIndentGuides=z={}));class J{get elements(){return this.b}constructor(u,N=[]){this.b=N,this.a=new r.$Vc,this.onDidChange=p.Event.forEach(u,S=>this.b=S,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(u,N,S,P,x,G={}){this.o=u,this.p=N,this.q=P,this.s=x,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=r.$Wc.None,this.m=new r.$Vc,this.templateId=u.templateId,this.updateOptions(G),p.Event.map(S,ie=>ie.node)(this.u,this,this.m),u.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(u={}){if(typeof u.indent<"u"){const N=(0,d.$Km)(u.indent,0,40);if(N!==this.d){this.d=N;for(const[S,P]of this.c)this.v(S,P)}}if(typeof u.renderIndentGuides<"u"){const N=u.renderIndentGuides!==z.None;if(N!==this.g){this.g=N;for(const[S,P]of this.c)this.w(S,P);if(this.k.dispose(),N){const S=new r.$Vc;this.q.onDidChange(this.x,this,S),this.k=S,this.x(this.q.elements)}}}typeof u.hideTwistiesOfChildlessElements<"u"&&(this.f=u.hideTwistiesOfChildlessElements)}renderTemplate(u){const N=(0,i.$wT)(u,(0,i.$)(".monaco-tl-row")),S=(0,i.$wT)(N,(0,i.$)(".monaco-tl-indent")),P=(0,i.$wT)(N,(0,i.$)(".monaco-tl-twistie")),x=(0,i.$wT)(N,(0,i.$)(".monaco-tl-contents")),G=this.o.renderTemplate(x);return{container:u,indent:S,twistie:P,indentGuidesDisposable:r.$Wc.None,templateData:G}}renderElement(u,N,S,P){this.c.set(u,S),this.b.set(u.element,u),this.v(u,S),this.o.renderElement(u,N,S.templateData,P)}disposeElement(u,N,S,P){S.indentGuidesDisposable.dispose(),this.o.disposeElement?.(u,N,S.templateData,P),typeof P=="number"&&(this.c.delete(u),this.b.delete(u.element))}disposeTemplate(u){this.o.disposeTemplate(u.templateData)}t(u){const N=this.b.get(u);N&&this.u(N)}u(u){const N=this.c.get(u);N&&(this.x(this.q.elements),this.v(u,N))}v(u,N){const S=X.a+(u.depth-1)*this.d;N.twistie.style.paddingLeft=`${S}px`,N.indent.style.width=`${S+this.d-16}px`,u.collapsible?N.container.setAttribute("aria-expanded",String(!u.collapsed)):N.container.removeAttribute("aria-expanded"),N.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(o.$5j.treeItemExpanded));let P=!1;this.o.renderTwistie&&(P=this.o.renderTwistie(u.element,N.twistie)),u.collapsible&&(!this.f||u.visibleChildrenCount>0)?(P||N.twistie.classList.add(...h.ThemeIcon.asClassNameArray(o.$5j.treeItemExpanded)),N.twistie.classList.add("collapsible"),N.twistie.classList.toggle("collapsed",u.collapsed)):N.twistie.classList.remove("collapsible","collapsed"),this.w(u,N)}w(u,N){if((0,i.$oS)(N.indent),N.indentGuidesDisposable.dispose(),!this.g)return;const S=new r.$Vc,P=this.p();for(;;){const x=P.getNodeLocation(u),G=P.getParentNodeLocation(x);if(!G)break;const ie=P.getNode(G),le=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(ie)&&le.classList.add("active"),N.indent.childElementCount===0?N.indent.appendChild(le):N.indent.insertBefore(le,N.indent.firstElementChild),this.s.add(ie,le),S.add((0,r.$Uc)(()=>this.s.delete(ie,le))),u=ie}N.indentGuidesDisposable=S}x(u){if(!this.g)return;const N=new Set,S=this.p();u.forEach(P=>{const x=S.getNodeLocation(P);try{const G=S.getParentNodeLocation(x);P.collapsible&&P.children.length>0&&!P.collapsed?N.add(P):G&&N.add(S.getNode(G))}catch{}}),this.j.forEach(P=>{N.has(P)||this.s.forEach(P,x=>x.classList.remove("active"))}),N.forEach(P=>{this.j.has(P)||this.s.forEach(P,x=>x.classList.add("active"))}),this.j=N}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,r.$Rc)(this.m)}}t.$VW=X;class K{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(u){this.c=u,this.d=u.toLowerCase()}constructor(u,N,S){this.g=u,this.j=N,this.k=S,this.a=0,this.b=0,this.c="",this.d="",this.f=new r.$Vc,u.onWillRefilter(this.m,this,this.f)}filter(u,N){let S=b.TreeVisibility.Visible;if(this.k){const G=this.k.filter(u,N);if(typeof G=="boolean"?S=G?b.TreeVisibility.Visible:b.TreeVisibility.Hidden:(0,A.$QW)(G)?S=(0,A.$RW)(G.visibility):S=G,S===b.TreeVisibility.Hidden)return!1}if(this.a++,!this.c)return this.b++,{data:k.FuzzyScore.Default,visibility:S};const P=this.j.getKeyboardNavigationLabel(u),x=Array.isArray(P)?P:[P];for(const G of x){const ie=G&&G.toString();if(typeof ie>"u")return{data:k.FuzzyScore.Default,visibility:S};let le;if(this.g.findMatchType===Fe.Contiguous){const de=ie.toLowerCase().indexOf(this.d);if(de>-1){le=[Number.MAX_SAFE_INTEGER,0];for(let Ee=this.d.length;Ee>0;Ee--)le.push(de+Ee-1)}}else le=(0,k.$Tk)(this.c,this.d,0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(le)return this.b++,x.length===1?{data:le,visibility:S}:{data:{label:ie,score:le},visibility:S}}return this.g.findMode===Se.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(u):b.TreeVisibility.Recurse:{data:k.FuzzyScore.Default,visibility:S}}m(){this.a=0,this.b=0}dispose(){(0,r.$Rc)(this.f)}}class Q extends $.$kV{constructor(u){super({icon:o.$5j.listFilter,title:(0,T.localize)(0,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,U.$rU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$WW=Q;class he extends $.$kV{constructor(u){super({icon:o.$5j.searchFuzzy,title:(0,T.localize)(1,null),isChecked:u.isChecked??!1,hoverDelegate:u.hoverDelegate??(0,U.$rU)("element"),inputActiveOptionBorder:u.inputActiveOptionBorder,inputActiveOptionForeground:u.inputActiveOptionForeground,inputActiveOptionBackground:u.inputActiveOptionBackground})}}t.$XW=he;const be={inputBoxStyles:v.$cW,toggleStyles:$.$iV,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var Se;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(Se||(t.TreeFindMode=Se={}));var Fe;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Fe||(t.TreeFindMatchType=Fe={}));class se extends r.$Wc{set mode(u){this.b.checked=u===Se.Filter,this.f.inputBox.setPlaceHolder(u===Se.Filter?(0,T.localize)(2,null):(0,T.localize)(3,null))}set matchType(u){this.c.checked=u===Fe.Fuzzy}get value(){return this.f.inputBox.value}set value(u){this.f.inputBox.value=u}constructor(u,N,S,P,x,G){super(),this.t=N,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new p.$me,this.onDidDisable=this._onDidDisable.event,u.appendChild(this.a.root),this.B((0,r.$Uc)(()=>this.a.root.remove()));const ie=G?.styles??be;ie.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=ie.listFilterWidgetBackground),ie.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${ie.listFilterWidgetShadow}`);const le=this.B((0,U.$sU)());this.b=this.B(new Q({...ie.toggleStyles,isChecked:P===Se.Filter,hoverDelegate:le})),this.c=this.B(new he({...ie.toggleStyles,isChecked:x===Fe.Fuzzy,hoverDelegate:le})),this.onDidChangeMode=p.Event.map(this.b.onChange,()=>this.b.checked?Se.Filter:Se.Highlight,this.q),this.onDidChangeMatchType=p.Event.map(this.c.onChange,()=>this.c.checked?Fe.Fuzzy:Fe.Contiguous,this.q),this.f=this.B(new L.$lW(this.a.findInput,S,{label:(0,T.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:ie.inputBoxStyles,toggleStyles:ie.toggleStyles,history:G?.history})),this.g=this.B(new R.$tU(this.a.actionbar)),this.mode=P;const de=this.B(new n.$BU(this.f.inputBox.inputElement,"keydown")),Ee=p.Event.chain(de.event,fe=>fe.map(Ie=>new M.$mS(Ie)));this.B(Ee(fe=>{if(fe.equals(y.KeyCode.Enter)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(fe.equals(y.KeyCode.DownArrow)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(fe.equals(y.KeyCode.UpArrow)){fe.preventDefault(),fe.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const De=this.B(new m.$kj("close",(0,T.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(De,{icon:!0,label:!1});const Te=this.B(new n.$BU(this.a.grab,"mousedown"));this.B(Te.event(fe=>{const Ie=new r.$Vc,ze=Ie.add(new n.$BU((0,i.getWindow)(fe),"mousemove")),Xe=Ie.add(new n.$BU((0,i.getWindow)(fe),"mouseup")),tt=this.m,lt=fe.pageX,rt=this.s,qe=fe.pageY;this.a.grab.classList.add("grabbing");const Ye=this.a.root.style.transition;this.a.root.style.transition="unset";const Y=ue=>{const pe=ue.pageX-lt;this.m=tt-pe;const Ae=ue.pageY-qe;this.s=rt+Ae,this.layout()};Ie.add(ze.event(Y)),Ie.add(Xe.event(ue=>{Y(ue),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Ye,Ie.dispose()}))}));const ke=p.Event.chain(this.B(new n.$BU(this.a.grab,"keydown")).event,fe=>fe.map(Ie=>new M.$mS(Ie)));this.B(ke(fe=>{let Ie,ze;if(fe.keyCode===y.KeyCode.LeftArrow?Ie=Number.POSITIVE_INFINITY:fe.keyCode===y.KeyCode.RightArrow?Ie=0:fe.keyCode===y.KeyCode.Space&&(Ie=this.m===0?Number.POSITIVE_INFINITY:0),fe.keyCode===y.KeyCode.UpArrow?ze=0:fe.keyCode===y.KeyCode.DownArrow&&(ze=Number.POSITIVE_INFINITY),Ie!==void 0&&(fe.preventDefault(),fe.stopPropagation(),this.m=Ie,this.layout()),ze!==void 0){fe.preventDefault(),fe.stopPropagation(),this.s=ze;const Xe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(u=this.j){this.j=u,this.m=(0,d.$Km)(this.m,0,Math.max(0,u-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,d.$Km)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(u){this.f.showMessage(u)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$Gh)(300),super.dispose()}}class ee{get pattern(){return this.b}get mode(){return this.d}set mode(u){u!==this.d&&(this.d=u,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(u))}get matchType(){return this.f}set matchType(u){u!==this.f&&(this.f=u,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(u))}constructor(u,N,S,P,x,G={}){this.t=u,this.u=S,this.v=P,this.w=x,this.x=G,this.b="",this.c="",this.j=0,this.k=new p.$me,this.onDidChangeMode=this.k.event,this.m=new p.$me,this.onDidChangeMatchType=this.m.event,this.o=new p.$me,this.onDidChangePattern=this.o.event,this.p=new p.$me,this.onDidChangeOpenState=this.p.event,this.q=new r.$Vc,this.s=new r.$Vc,this.d=u.options.defaultFindMode??Se.Highlight,this.f=u.options.defaultFindMatchType??Fe.Fuzzy,N.onDidSplice(this.z,this,this.s)}updateOptions(u={}){u.defaultFindMode!==void 0&&(this.mode=u.defaultFindMode),u.defaultFindMatchType!==void 0&&(this.matchType=u.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(u=>this.mode=u,void 0,this.q),this.g.onDidChangeMatchType(u=>this.matchType=u,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(u){this.b=u,this.o.fire(u),this.v.pattern=u,this.t.refilter(),u&&this.t.focusNext(0,!0,void 0,S=>!k.FuzzyScore.isDefault(S.filterData));const N=this.t.getFocus();if(N.length>0){const S=N[0];this.t.getRelativeTop(S)===null&&this.t.reveal(S,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const u=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&u?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:v.MessageType.WARNING,content:(0,T.localize)(6,null)}):this.g?.showMessage({type:v.MessageType.WARNING}):this.g?.clearMessage()}shouldAllowFocus(u){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!k.FuzzyScore.isDefault(u.filterData)}layout(u){this.j=u,this.g?.layout(u)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function ce(F,u){return F.position===u.position&&ae(F,u)}function ae(F,u){return F.node.element===u.node.element&&F.startIndex===u.startIndex&&F.height===u.height&&F.endIndex===u.endIndex}class Ne{constructor(u=[]){this.stickyNodes=u}get count(){return this.stickyNodes.length}equal(u){return(0,e.$wb)(this.stickyNodes,u.stickyNodes,ce)}lastNodePartiallyVisible(){if(this.count===0)return!1;const u=this.stickyNodes[this.count-1];if(this.count===1)return u.position!==0;const N=this.stickyNodes[this.count-2];return N.position+N.height!==u.position}animationStateChanged(u){if(!(0,e.$wb)(this.stickyNodes,u.stickyNodes,ae)||this.count===0)return!1;const N=this.stickyNodes[this.count-1],S=u.stickyNodes[u.count-1];return N.position!==S.position}}class te{constrainStickyScrollNodes(u,N,S){for(let P=0;P<u.length;P++){const x=u[P];if(x.position+x.height>S||P>=N)return u.slice(0,P)}return u}}class $e extends r.$Wc{constructor(u,N,S,P,x,G={}){super(),this.g=u,this.j=N,this.m=S,this.s=x,this.c=.4;const ie=this.validateStickySettings(G);this.b=ie.stickyScrollMaxItemCount,this.a=G.stickyScrollDelegate??new te,this.f=this.B(new ye(S.getScrollableElement(),S,u,P,x,G.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(S.onDidScroll(()=>this.u())),this.B(S.onDidChangeContentHeight(()=>this.u())),this.B(u.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(u){return this.f.getNode(u)}t(u){let N;if(u===0?N=this.m.firstVisibleIndex:N=this.m.indexAt(u+this.m.scrollTop),!(N<0||N>=this.m.length))return this.m.element(N)}u(){const u=this.t(0);if(!u||this.g.scrollTop===0){this.f.setState(void 0);return}const N=this.w(u);this.f.setState(N)}w(u){const N=[];let S=u,P=0,x=this.z(S,void 0,P);for(;x&&(N.push(x),P+=x.height,!(N.length<=this.b&&(S=this.y(x),!S)));)x=this.z(S,x.node,P);const G=this.H(N);return G.length?new Ne(G):void 0}y(u){return this.t(u.position+u.height)}z(u,N,S){const P=this.F(u,N);if(P&&!(P===u&&(!this.J(u)||this.C(u,S))))return this.D(P,S)}C(u,N){const S=this.L(u),P=this.m.getElementTop(S),x=N;return this.m.scrollTop===P-x}D(u,N){const S=this.s.getHeight(u),{startIndex:P,endIndex:x}=this.M(u),G=this.G(x,N,S);return{node:u,position:G,height:S,startIndex:P,endIndex:x}}F(u,N=void 0){let S=u,P=this.I(S);for(;P;){if(P===N)return S;S=P,P=this.I(S)}if(N===void 0)return S}G(u,N,S){let P=this.m.getRelativeTop(u);if(P===null&&this.m.firstVisibleIndex===u&&u+1<this.m.length){const de=this.s.getHeight(this.m.element(u)),Ee=this.m.getRelativeTop(u+1);P=Ee?Ee-de/this.m.renderHeight:null}if(P===null)return N;const x=this.m.element(u),G=this.s.getHeight(x),le=P*this.m.renderHeight+G;return N+S>le&&N<=le?le-S:N}H(u){if(u.length===0)return[];const N=this.m.renderHeight*this.c,S=u[u.length-1];if(u.length<=this.b&&S.position+S.height<=N)return u;const P=this.a.constrainStickyScrollNodes(u,this.b,N);if(!P.length)return[];const x=P[P.length-1];if(P.length>this.b||x.position+x.height>N)throw new Error("stickyScrollDelegate violates constraints");return P}I(u){const N=this.j.getNodeLocation(u),S=this.j.getParentNodeLocation(N);return S?this.j.getNode(S):void 0}J(u){const N=this.j.getNodeLocation(u);return this.j.getListRenderCount(N)>1}L(u){const N=this.j.getNodeLocation(u);return this.j.getListIndex(N)}M(u){const N=this.j.getNodeLocation(u),S=this.j.getListIndex(N);if(S<0)throw new Error("Node not found in tree");const P=this.j.getListRenderCount(N),x=S+P-1;return{startIndex:S,endIndex:x}}nodePositionTopBelowWidget(u){const N=[];let S=this.I(u);for(;S;)N.push(S),S=this.I(S);let P=0;for(let x=0;x<N.length&&x<this.b;x++)P+=this.s.getHeight(N[x]);return P}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(u={}){if(!u.stickyScrollMaxItemCount)return;const N=this.validateStickySettings(u);this.b!==N.stickyScrollMaxItemCount&&(this.b=N.stickyScrollMaxItemCount,this.u())}validateStickySettings(u){let N=7;return typeof u.stickyScrollMaxItemCount=="number"&&(N=Math.max(u.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:N}}}class ye{constructor(u,N,S,P,x,G){this.g=N,this.j=S,this.k=P,this.m=x,this.o=G,this.c=[],this.d=new r.$Vc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),u.appendChild(this.a);const ie=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(ie),this.f=new Oe(this.a,N),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const u=this.b.stickyNodes[this.b.count-1];return u.position+u.height}get count(){return this.b?.count??0}getNode(u){return this.b?.stickyNodes.find(N=>N.node===u)}setState(u){const N=!!this.b&&this.b.count>0,S=!!u&&u.count>0;if(!N&&!S||N&&S&&this.b.equal(u))return;if(N!==S&&this.s(S),!S){this.b=void 0,this.c=[],this.d.clear();return}const P=u.stickyNodes[u.count-1];if(this.b&&u.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${P.position}px`;else{this.d.clear();const x=Array(u.count);for(let G=u.count-1;G>=0;G--){const ie=u.stickyNodes[G],{element:le,disposable:de}=this.p(ie,G,u.count);x[G]=le,this.a.appendChild(le),this.d.add(de)}this.f.updateElements(x,u),this.c=x}this.b=u,this.a.style.height=`${P.position+P.height}px`}p(u,N,S){const P=u.startIndex,x=document.createElement("div");x.style.top=`${u.position}px`,this.j.options.setRowHeight!==!1&&(x.style.height=`${u.height}px`),this.j.options.setRowLineHeight!==!1&&(x.style.lineHeight=`${u.height}px`),x.classList.add("monaco-tree-sticky-row"),x.classList.add("monaco-list-row"),x.setAttribute("data-index",`${P}`),x.setAttribute("data-parity",P%2===0?"even":"odd"),x.setAttribute("id",this.g.getElementID(P));const G=this.q(x,u.node.element,N,S),ie=this.m.getTemplateId(u.node),le=this.k.find(Te=>Te.templateId===ie);if(!le)throw new Error(`No renderer found for template id ${ie}`);let de=u.node;de===this.j.getNode(this.j.getNodeLocation(u.node))&&(de=new Proxy(u.node,{}));const Ee=le.renderTemplate(x);le.renderElement(de,u.startIndex,Ee,u.height);const De=(0,r.$Uc)(()=>{G.dispose(),le.disposeElement(de,u.startIndex,Ee,u.height),le.disposeTemplate(Ee),x.remove()});return{element:x,disposable:De}}q(u,N,S,P){if(!this.o)return r.$Wc.None;this.o.getSetSize&&u.setAttribute("aria-setsize",String(this.o.getSetSize(N,S,P))),this.o.getPosInSet&&u.setAttribute("aria-posinset",String(this.o.getPosInSet(N,S))),this.o.getRole&&u.setAttribute("role",this.o.getRole(N)??"treeitem");const x=this.o.getAriaLabel(N),G=x&&typeof x!="string"?x:(0,_.constObservable)(x),ie=(0,_.autorun)(de=>{const Ee=de.readObservable(G);Ee?u.setAttribute("aria-label",Ee):u.removeAttribute("aria-label")});typeof x=="string"||x&&u.setAttribute("aria-label",x.get());const le=this.o.getAriaLevel&&this.o.getAriaLevel(N);return typeof le=="number"&&u.setAttribute("aria-level",`${le}`),u.setAttribute("aria-selected",String(!1)),ie}s(u){this.a.classList.toggle("empty",!u),u||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class Oe extends r.$Wc{get m(){return this.j}set m(u){u!==this.j&&(this.f.fire(u),this.j=u)}constructor(u,N){super(),this.s=u,this.t=N,this.a=-1,this.b=[],this.f=new p.$me,this.onDidChangeHasFocus=this.f.event,this.g=new p.$me,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(S=>this.w(S))),this.B(this.t.onMouseDown(S=>this.y(S))),this.B(this.t.onContextMenu(S=>this.u(S)))}u(u){const N=u.browserEvent.target;if(!(0,f.$YU)(N)&&!(0,f.$XU)(N)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$mT)(u.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const G=this.c.stickyNodes.findIndex(ie=>ie.node.element===u.element?.element);if(G===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(G);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const P=this.c.stickyNodes[this.a].node.element,x=this.b[this.a];this.g.fire({element:P,anchor:x,browserEvent:u.browserEvent,isStickyScroll:!0})}w(u){if(this.m&&this.c){if(u.key==="ArrowUp")this.z(Math.max(0,this.a-1)),u.preventDefault(),u.stopPropagation();else if(u.key==="ArrowDown"||u.key==="ArrowRight"){if(this.a>=this.c.count-1){const N=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([N]),this.C(N,this.c)}else this.z(this.a+1);u.preventDefault(),u.stopPropagation()}}}y(u){const N=u.browserEvent.target;!(0,f.$YU)(N)&&!(0,f.$XU)(N)||(u.browserEvent.preventDefault(),u.browserEvent.stopPropagation())}updateElements(u,N){if(N&&N.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(N&&N.count!==u.length)throw new Error("Sticky scroll focus received illigel state");const S=this.a;if(this.D(),this.b=u,this.c=N,N){const P=(0,d.$Km)(S,0,N.count-1);this.F(P)}else this.m&&this.t.domFocus();this.s.tabIndex=N?0:-1}z(u){const N=this.c;if(!N)throw new Error("Cannot set focus when state is undefined");if(this.F(u),!(u<N.count-1)&&N.lastNodePartiallyVisible()){const S=N.stickyNodes[u];this.C(S.endIndex+1,N)}}C(u,N){const S=N.stickyNodes[N.count-1],P=N.count>1?N.stickyNodes[N.count-2]:void 0,x=this.t.getElementTop(u),G=P?P.position+P.height+S.height:S.height;this.t.scrollTop=x-G}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(u){if(0>u)throw new Error("addFocus() can not remove focus");if(!this.c&&u>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&u>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const N=this.a;N>=0&&this.G(this.b[N],!1),u>=0&&this.G(this.b[u],!0),this.a=u}G(u,N){this.I(u,N&&this.m),this.J(u,N)}H(u){this.a!==-1&&this.I(this.b[this.a],u)}I(u,N){u.classList.toggle("focused",N)}J(u,N){u.classList.toggle("passive-focused",N)}L(u){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",u)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function Re(F){let u=b.TreeMouseEventTarget.Unknown;return(0,i.$XS)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?u=b.TreeMouseEventTarget.Twistie:(0,i.$XS)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?u=b.TreeMouseEventTarget.Element:(0,i.$XS)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(u=b.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:u}}function Ce(F){const u=(0,f.$YU)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:u}}function re(F,u){u(F),F.children.forEach(N=>re(N,u))}class V{get f(){return this.d||(this.d=this.m()),this.d}constructor(u,N){this.g=u,this.j=N,this.a=[],this.c=new p.$me,this.onDidChange=this.c.event}set(u,N){!N?.__forceEvent&&(0,e.$wb)(this.a,u)||this.k(u,!1,N)}k(u,N,S){if(this.a=[...u],this.b=void 0,this.d=void 0,!N){const P=this;this.c.fire({get elements(){return P.get()},browserEvent:S})}}get(){return this.b||(this.b=this.a.map(u=>u.element)),[...this.b]}getNodes(){return this.a}has(u){return this.f.has(u)}onDidModelSplice({insertedNodes:u,deletedNodes:N}){if(!this.j){const le=this.m(),de=Ee=>le.delete(Ee);N.forEach(Ee=>re(Ee,de)),this.set([...le.values()]);return}const S=new Set,P=le=>S.add(this.j.getId(le.element).toString());N.forEach(le=>re(le,P));const x=new Map,G=le=>x.set(this.j.getId(le.element).toString(),le);u.forEach(le=>re(le,G));const ie=[];for(const le of this.a){const de=this.j.getId(le.element).toString();if(!S.has(de))ie.push(le);else{const De=x.get(de);De&&De.visible&&ie.push(De)}}if(this.a.length>0&&ie.length===0){const le=this.g();le&&ie.push(le)}this.k(ie,!0)}m(){const u=new Set;for(const N of this.a)u.add(N);return u}}class j extends f.$4U{constructor(u,N,S){super(u),this.x=N,this.y=S}u(u){if((0,f.$ZU)(u.browserEvent.target)||(0,f.$SU)(u.browserEvent.target)||(0,f.$TU)(u.browserEvent.target)||u.browserEvent.isHandledByList)return;const N=u.element;if(!N)return super.u(u);if(this.p(u)||this.o(u))return super.u(u);const S=u.browserEvent.target,P=S.classList.contains("monaco-tl-twistie")||S.classList.contains("monaco-icon-label")&&S.classList.contains("folder-icon")&&u.browserEvent.offsetX<16,x=(0,f.$XU)(u.browserEvent.target);let G=!1;if(x?G=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?G=this.x.expandOnlyOnTwistieClick(N.element):G=!!this.x.expandOnlyOnTwistieClick,x)this.A(u,N);else{if(G&&!P&&u.browserEvent.detail!==2)return super.u(u);if(!this.x.expandOnDoubleClick&&u.browserEvent.detail===2)return super.u(u)}if(N.collapsible&&(!x||P)){const ie=this.x.getNodeLocation(N),le=u.browserEvent.altKey;if(this.x.setFocus([ie]),this.x.toggleCollapsed(ie,le),P){u.browserEvent.isHandledByList=!0;return}}x||super.u(u)}A(u,N){if((0,f.$UU)(u.browserEvent.target)||(0,f.$VU)(u.browserEvent.target))return;const S=this.y();if(!S)throw new Error("Sticky scroll controller not found");const P=this.k.indexOf(N),x=this.k.getElementTop(P),G=S.nodePositionTopBelowWidget(N);this.x.scrollTop=x-G,this.k.domFocus(),this.k.setFocus([P]),this.k.setSelection([P])}v(u){u.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||u.browserEvent.isHandledByList||super.v(u)}s(u){const N=u.browserEvent.target;if(!(0,f.$YU)(N)&&!(0,f.$XU)(N)){super.s(u);return}}t(u){const N=u.browserEvent.target;if(!(0,f.$YU)(N)&&!(0,f.$XU)(N)){super.t(u);return}}}class a extends f.$7U{constructor(u,N,S,P,x,G,ie,le){super(u,N,S,P,le),this.p=x,this.s=G,this.K=ie}D(u){return new j(this,u.tree,u.stickyScrollProvider)}splice(u,N,S=[]){if(super.splice(u,N,S),S.length===0)return;const P=[],x=[];let G;S.forEach((ie,le)=>{this.p.has(ie)&&P.push(u+le),this.s.has(ie)&&x.push(u+le),this.K.has(ie)&&(G=u+le)}),P.length>0&&super.setFocus((0,e.$Ob)([...super.getFocus(),...P])),x.length>0&&super.setSelection((0,e.$Ob)([...super.getSelection(),...x])),typeof G=="number"&&super.setAnchor(G)}setFocus(u,N,S=!1){super.setFocus(u,N),S||this.p.set(u.map(P=>this.element(P)),N)}setSelection(u,N,S=!1){super.setSelection(u,N),S||this.s.set(u.map(P=>this.element(P)),N)}setAnchor(u,N=!1){super.setAnchor(u),N||(typeof u>"u"?this.K.set([]):this.K.set([this.element(u)]))}}var l;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(l||(t.AbstractTreePart=l={}));class g{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return p.Event.map(this.j.onMouseClick,Re)}get onMouseDblClick(){return p.Event.filter(p.Event.map(this.j.onMouseDblClick,Re),u=>u.target!==b.TreeMouseEventTarget.Filter)}get onMouseOver(){return p.Event.map(this.j.onMouseOver,Re)}get onMouseOut(){return p.Event.map(this.j.onMouseOut,Re)}get onContextMenu(){return p.Event.any(p.Event.filter(p.Event.map(this.j.onContextMenu,Ce),u=>!u.isStickyScroll),this.B?.onContextMenu??p.Event.None)}get onTap(){return p.Event.map(this.j.onTap,Re)}get onPointer(){return p.Event.map(this.j.onPointer,Re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return p.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??Se.Highlight}set findMode(u){this.z&&(this.z.mode=u)}get findMatchType(){return this.z?.matchType??Fe.Fuzzy}set findMatchType(u){this.z&&(this.z.matchType=u)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:p.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(u,N,S,P,x={}){this.G=u,this.H=x,this.y=new p.$ue,this.onDidChangeFindOpenState=p.Event.None,this.onDidChangeStickyScrollFocused=p.Event.None,this.D=new r.$Vc,this.E=new p.$me,this.onWillRefilter=this.E.event,this.F=new p.$me,this.onDidUpdateOptions=this.F.event,this.p=new O(S);const G=new p.$ve,ie=new p.$ve,le=this.D.add(new J(ie.event)),de=new c.$Jc;this.k=P.map(fe=>new X(fe,()=>this.o,G.event,le,de,x));for(const fe of this.k)this.D.add(fe);let Ee;x.keyboardNavigationLabelProvider&&(Ee=new K(this,x.keyboardNavigationLabelProvider,x.filter),x={...x,filter:Ee},this.D.add(Ee)),this.q=new V(()=>this.j.getFocusedElements()[0],x.identityProvider),this.w=new V(()=>this.j.getSelectedElements()[0],x.identityProvider),this.x=new V(()=>this.j.getAnchorElement(),x.identityProvider),this.j=new a(u,N,this.p,this.k,this.q,this.w,this.x,{...W(()=>this.o,x),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(u,this.j,x),G.input=this.o.onDidChangeCollapseState;const De=p.Event.forEach(this.o.onDidSplice,fe=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(fe),this.w.onDidModelSplice(fe)})},this.D);De(()=>null,null,this.D);const Te=this.D.add(new p.$me),ke=this.D.add(new s.$Ch(0));if(this.D.add(p.Event.any(De,this.q.onDidChange,this.w.onDidChange)(()=>{ke.trigger(()=>{const fe=new Set;for(const Ie of this.q.getNodes())fe.add(Ie);for(const Ie of this.w.getNodes())fe.add(Ie);Te.fire([...fe.values()])})})),ie.input=Te.event,x.keyboardSupport!==!1){const fe=p.Event.chain(this.j.onKeyDown,Ie=>Ie.filter(ze=>!(0,f.$SU)(ze.target)).map(ze=>new M.$mS(ze)));p.Event.chain(fe,Ie=>Ie.filter(ze=>ze.keyCode===y.KeyCode.LeftArrow))(this.J,this,this.D),p.Event.chain(fe,Ie=>Ie.filter(ze=>ze.keyCode===y.KeyCode.RightArrow))(this.K,this,this.D),p.Event.chain(fe,Ie=>Ie.filter(ze=>ze.keyCode===y.KeyCode.Space))(this.L,this,this.D)}if((x.findWidgetEnabled??!0)&&x.keyboardNavigationLabelProvider&&x.contextViewProvider){const fe=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new ee(this,this.o,this.j,Ee,x.contextViewProvider,fe),this.A=Ie=>this.z.shouldAllowFocus(Ie),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=p.Event.None,this.onDidChangeFindMatchType=p.Event.None;x.enableStickyScroll&&(this.B=new $e(this,this.o,this.j,this.k,this.p,x),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$0S)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===z.Always)}updateOptions(u={}){this.H={...this.H,...u};for(const N of this.k)N.updateOptions(u);this.j.updateOptions(this.H),this.z?.updateOptions(u),this.I(u),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===z.Always)}get options(){return this.H}I(u){!this.B&&this.H.enableStickyScroll?(this.B=new $e(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=p.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(u)}updateWidth(u){const N=this.o.getListIndex(u);N!==-1&&this.j.updateWidth(N)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(u){this.j.scrollTop=u}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(u){this.j.scrollLeft=u}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let u=this.j.firstVisibleIndex;return this.B&&(u+=this.B.count),u<0||u>=this.j.length?void 0:this.j.element(u).element}get lastVisibleElement(){const u=this.j.lastVisibleIndex;return this.j.element(u).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(u){this.j.ariaLabel=u}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$3S)(this.getHTMLElement())}layout(u,N){this.j.layout(u,N),(0,D.$jg)(N)&&this.z?.layout(N)}style(u){const N=`.${this.j.domId}`,S=[];u.treeIndentGuidesStroke&&(S.push(`.monaco-list${N}:hover .monaco-tl-indent > .indent-guide, .monaco-list${N}.always .monaco-tl-indent > .indent-guide  { border-color: ${u.treeInactiveIndentGuidesStroke}; }`),S.push(`.monaco-list${N} .monaco-tl-indent > .indent-guide.active { border-color: ${u.treeIndentGuidesStroke}; }`));const P=u.treeStickyScrollBackground??u.listBackground;P&&(S.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${P}; }`),S.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${P}; }`)),u.treeStickyScrollBorder&&S.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${u.treeStickyScrollBorder}; }`),u.treeStickyScrollShadow&&S.push(`.monaco-list${N} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${u.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),u.listFocusForeground&&(S.push(`.monaco-list${N}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),S.push(`.monaco-list${N}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const x=(0,i.$OT)(u.listFocusAndSelectionOutline,(0,i.$OT)(u.listSelectionOutline,u.listFocusOutline??""));x&&(S.push(`.monaco-list${N}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${x}; outline-offset: -1px;}`),S.push(`.monaco-list${N}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),u.listFocusOutline&&(S.push(`.monaco-list${N}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),S.push(`.monaco-list${N}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),S.push(`.monaco-workbench.context-menu-visible .monaco-list${N}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }`),S.push(`.monaco-workbench.context-menu-visible .monaco-list${N}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),S.push(`.monaco-workbench.context-menu-visible .monaco-list${N}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=S.join(`
`),this.j.style(u)}getParentElement(u){const N=this.o.getParentNodeLocation(u);return this.o.getNode(N).element}getFirstElementChild(u){return this.o.getFirstElementChild(u)}getNode(u){return this.o.getNode(u)}getNodeLocation(u){return this.o.getNodeLocation(u)}collapse(u,N=!1){return this.o.setCollapsed(u,!0,N)}expand(u,N=!1){return this.o.setCollapsed(u,!1,N)}toggleCollapsed(u,N=!1){return this.o.setCollapsed(u,void 0,N)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(u){return this.o.isCollapsible(u)}setCollapsible(u,N){return this.o.setCollapsible(u,N)}isCollapsed(u){return this.o.isCollapsed(u)}expandTo(u){this.o.expandTo(u)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(u){if(typeof u>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const N=this.o.getNode(u);this.x.set([N]);const S=this.o.getListIndex(u);S>-1&&this.j.setAnchor(S,!0)})}getAnchor(){return(0,e.$Qb)(this.x.get(),void 0)}setSelection(u,N){this.y.bufferEvents(()=>{const S=u.map(x=>this.o.getNode(x));this.w.set(S,N);const P=u.map(x=>this.o.getListIndex(x)).filter(x=>x>-1);this.j.setSelection(P,N,!0)})}getSelection(){return this.w.get()}setFocus(u,N){this.y.bufferEvents(()=>{const S=u.map(x=>this.o.getNode(x));this.q.set(S,N);const P=u.map(x=>this.o.getListIndex(x)).filter(x=>x>-1);this.j.setFocus(P,N,!0)})}focusNext(u=1,N=!1,S,P=(0,i.$mT)(S)&&S.altKey?void 0:this.A){this.j.focusNext(u,N,S,P)}focusPrevious(u=1,N=!1,S,P=(0,i.$mT)(S)&&S.altKey?void 0:this.A){this.j.focusPrevious(u,N,S,P)}focusNextPage(u,N=(0,i.$mT)(u)&&u.altKey?void 0:this.A){return this.j.focusNextPage(u,N)}focusPreviousPage(u,N=(0,i.$mT)(u)&&u.altKey?void 0:this.A){return this.j.focusPreviousPage(u,N,()=>this.B?.height??0)}focusLast(u,N=(0,i.$mT)(u)&&u.altKey?void 0:this.A){this.j.focusLast(u,N)}focusFirst(u,N=(0,i.$mT)(u)&&u.altKey?void 0:this.A){this.j.focusFirst(u,N)}getFocus(){return this.q.get()}getStickyScrollFocus(){const u=this.B?.getFocus();return u!==void 0?[u]:[]}getFocusedPart(){return this.B?.focusedLast()?l.StickyScroll:l.Tree}reveal(u,N){this.o.expandTo(u);const S=this.o.getListIndex(u);if(S!==-1)if(!this.B)this.j.reveal(S,N);else{const P=this.B.nodePositionTopBelowWidget(this.getNode(u));this.j.reveal(S,N,P)}}getRelativeTop(u){const N=this.o.getListIndex(u);if(N===-1)return null;const S=this.B?.getNode(this.getNode(u));return this.j.getRelativeTop(N,S?.position??this.B?.height)}getViewState(u=this.options.identityProvider){if(!u)throw new b.$OW(this.G,"Can't get tree view state without an identity provider");const N=G=>u.getId(G).toString(),S=B.empty(this.scrollTop);for(const G of this.getFocus())S.focus.add(N(G));for(const G of this.getSelection())S.selection.add(N(G));const P=this.o.getNode(),x=[P];for(;x.length>0;){const G=x.shift();G!==P&&G.collapsible&&(S.expanded[N(G.element)]=G.collapsed?0:1),x.push(...G.children)}return S}J(u){u.preventDefault(),u.stopPropagation();const N=this.j.getFocusedElements();if(N.length===0)return;const S=N[0],P=this.o.getNodeLocation(S);if(!this.o.setCollapsed(P,!0)){const G=this.o.getParentNodeLocation(P);if(!G)return;const ie=this.o.getListIndex(G);this.j.reveal(ie),this.j.setFocus([ie])}}K(u){u.preventDefault(),u.stopPropagation();const N=this.j.getFocusedElements();if(N.length===0)return;const S=N[0],P=this.o.getNodeLocation(S);if(!this.o.setCollapsed(P,!1)){if(!S.children.some(le=>le.visible))return;const[G]=this.j.getFocus(),ie=G+1;this.j.reveal(ie),this.j.setFocus([ie])}}L(u){u.preventDefault(),u.stopPropagation();const N=this.j.getFocusedElements();if(N.length===0)return;const S=N[0],P=this.o.getNodeLocation(S),x=u.browserEvent.altKey;this.o.setCollapsed(P,void 0,x)}navigate(u){return new I(this.j,this.o,u)}dispose(){(0,r.$Rc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$YW=g;class I{constructor(u,N,S){this.b=u,this.c=N,S?this.a=this.c.getListIndex(S):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(we[151],ve([1,0,150,141,35,37]),function(ne,t,i,n,M,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0W=void 0;class L extends i.$YW{constructor(E,f,$,A,b,m={}){super(E,f,$,A,m),this.f=E,this.g=b,this.d=new Map,this.c=m.identityProvider}getInput(){return this.b}setInput(E,f){if(f&&!this.c)throw new M.$OW(this.f,"Can't restore tree view state without an identity provider");if(this.b=E,!E){this.d.clear(),this.o.setChildren(null,R.Iterable.empty());return}if(!f){this.m(E);return}const $=[],A=[],b=e=>{const s=this.c.getId(e).toString();return!f.expanded[s]},m=e=>{const s=this.c.getId(e.element).toString();f.focus.has(s)&&$.push(e.element),f.selection.has(s)&&A.push(e.element)};this.m(E,b,m),this.setFocus($),this.setSelection(A),f&&typeof f.scrollTop=="number"&&(this.scrollTop=f.scrollTop)}updateChildren(E=this.b){if(typeof this.b>"u")throw new M.$OW(this.f,"Tree input not set");let f;this.c&&(f=$=>{const A=this.c.getId($).toString(),b=this.d.get(A);if(b)return b.collapsed}),this.m(E,f)}resort(E=this.b,f=!0){this.o.resort(E===this.b?null:E,f)}refresh(E){if(E===void 0){this.j.rerender();return}this.o.rerender(E)}m(E,f,$){let A;if(this.c){const b=new Set,m=$;$=e=>{const s=this.c.getId(e.element).toString();b.add(s),this.d.set(s,e),m?.(e)},A=e=>{const s=this.c.getId(e.element).toString();b.has(s)||this.d.delete(s)}}this.o.setChildren(E===this.b?null:E,this.s(E,f).elements,{onDidCreateNode:$,onDidDeleteNode:A})}s(E,f){const $=[...this.g.getChildren(E)];return{elements:R.Iterable.map($,b=>{const{elements:m,size:e}=this.s(b,f),s=this.g.hasChildren?this.g.hasChildren(b):void 0,o=e===0?void 0:f&&f(b);return{element:b,children:m,collapsible:s,collapsed:o}}),size:$.length}}M(E,f,$){return new n.$ZW(E,f,$)}}t.$0W=L}),define(we[84],ve([1,0,9,12,48,39,36,6,3,2,70,11,10]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oi=t.ProxyChannel=t.$ni=t.$ki=t.$ji=t.$ii=t.RequestInitiator=t.$hi=t.$ei=t.$di=void 0,t.$fi=_,t.$gi=H,t.$li=z,t.$mi=J,A=We(A);var m;(function(se){se[se.Promise=100]="Promise",se[se.PromiseCancel=101]="PromiseCancel",se[se.EventListen=102]="EventListen",se[se.EventDispose=103]="EventDispose"})(m||(m={}));function e(se){switch(se){case m.Promise:return"req";case m.PromiseCancel:return"cancel";case m.EventListen:return"subscribe";case m.EventDispose:return"unsubscribe"}}var s;(function(se){se[se.Initialize=200]="Initialize",se[se.PromiseSuccess=201]="PromiseSuccess",se[se.PromiseError=202]="PromiseError",se[se.PromiseErrorObj=203]="PromiseErrorObj",se[se.EventFire=204]="EventFire"})(s||(s={}));function o(se){switch(se){case s.Initialize:return"init";case s.PromiseSuccess:return"reply:";case s.PromiseError:case s.PromiseErrorObj:return"replyErr:";case s.EventFire:return"event:"}}var h;(function(se){se[se.Uninitialized=0]="Uninitialized",se[se.Idle=1]="Idle"})(h||(h={}));function c(se){let ee=0;for(let ce=0;;ce+=7){const ae=se.read(1);if(ee|=(ae.buffer[0]&127)<<ce,!(ae.buffer[0]&128))return ee}}const p=D(0);function k(se,ee){if(ee===0){se.write(p);return}let ce=0;for(let Ne=ee;Ne!==0;Ne=Ne>>>7)ce++;const ae=M.$Oe.alloc(ce);for(let Ne=0;ee!==0;Ne++)ae.buffer[Ne]=ee&127,ee=ee>>>7,ee>0&&(ae.buffer[Ne]|=128);se.write(ae)}class y{constructor(ee){this.b=ee,this.a=0}read(ee){const ce=this.b.slice(this.a,this.a+ee);return this.a+=ce.byteLength,ce}}t.$di=y;class r{constructor(){this.a=[]}get buffer(){return M.$Oe.concat(this.a)}write(ee){this.a.push(ee)}}t.$ei=r;var d;(function(se){se[se.Undefined=0]="Undefined",se[se.String=1]="String",se[se.Buffer=2]="Buffer",se[se.VSBuffer=3]="VSBuffer",se[se.Array=4]="Array",se[se.Object=5]="Object",se[se.Int=6]="Int"})(d||(d={}));function D(se){const ee=M.$Oe.alloc(1);return ee.writeUInt8(se,0),ee}const T={Undefined:D(d.Undefined),String:D(d.String),Buffer:D(d.Buffer),VSBuffer:D(d.VSBuffer),Array:D(d.Array),Object:D(d.Object),Uint:D(d.Int)},U=typeof Buffer<"u";function _(se,ee){if(typeof ee>"u")se.write(T.Undefined);else if(typeof ee=="string"){const ce=M.$Oe.fromString(ee);se.write(T.String),k(se,ce.byteLength),se.write(ce)}else if(U&&Buffer.isBuffer(ee)){const ce=M.$Oe.wrap(ee);se.write(T.Buffer),k(se,ce.byteLength),se.write(ce)}else if(ee instanceof M.$Oe)se.write(T.VSBuffer),k(se,ee.byteLength),se.write(ee);else if(Array.isArray(ee)){se.write(T.Array),k(se,ee.length);for(const ce of ee)_(se,ce)}else if(typeof ee=="number"&&(ee|0)===ee)se.write(T.Uint),k(se,ee);else{const ce=M.$Oe.fromString(JSON.stringify(ee));se.write(T.Object),k(se,ce.byteLength),se.write(ce)}}function H(se){switch(se.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return se.read(c(se)).toString();case d.Buffer:return se.read(c(se)).buffer;case d.VSBuffer:return se.read(c(se));case d.Array:{const ce=c(se),ae=[];for(let Ne=0;Ne<ce;Ne++)ae.push(H(se));return ae}case d.Object:return JSON.parse(se.read(c(se)).toString());case d.Int:return c(se)}}class w{constructor(ee,ce,ae=null,Ne=1e3){this.h=ee,this.j=ce,this.k=ae,this.l=Ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:s.Initialize})}registerChannel(ee,ce){this.b.set(ee,ce),setTimeout(()=>this.w(ee),0)}m(ee){switch(ee.type){case s.Initialize:{const ce=this.o([ee.type]);this.k?.logOutgoing(ce,0,C.OtherSide,o(ee.type));return}case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:{const ce=this.o([ee.type,ee.id],ee.data);this.k?.logOutgoing(ce,ee.id,C.OtherSide,o(ee.type),ee.data);return}}}o(ee,ce=void 0){const ae=new r;return _(ae,ee),_(ae,ce),this.p(ae.buffer)}p(ee){try{return this.h.send(ee),ee.byteLength}catch{return 0}}q(ee){const ce=new y(ee),ae=H(ce),Ne=H(ce),te=ae[0];switch(te){case m.Promise:return this.k?.logIncoming(ee.byteLength,ae[1],C.OtherSide,`${e(te)}: ${ae[2]}.${ae[3]}`,Ne),this.s({type:te,id:ae[1],channelName:ae[2],name:ae[3],arg:Ne});case m.EventListen:return this.k?.logIncoming(ee.byteLength,ae[1],C.OtherSide,`${e(te)}: ${ae[2]}.${ae[3]}`,Ne),this.t({type:te,id:ae[1],channelName:ae[2],name:ae[3],arg:Ne});case m.PromiseCancel:return this.k?.logIncoming(ee.byteLength,ae[1],C.OtherSide,`${e(te)}`),this.u({type:te,id:ae[1]});case m.EventDispose:return this.k?.logIncoming(ee.byteLength,ae[1],C.OtherSide,`${e(te)}`),this.u({type:te,id:ae[1]})}}s(ee){const ce=this.b.get(ee.channelName);if(!ce){this.v(ee);return}const ae=new R.$xe;let Ne;try{Ne=ce.call(this.j,ee.name,ee.arg,ae.token)}catch(ye){Ne=Promise.reject(ye)}const te=ee.id;Ne.then(ye=>{this.m({id:te,data:ye,type:s.PromiseSuccess})},ye=>{ye instanceof Error?this.m({id:te,data:{message:ye.message,name:ye.name,stack:ye.stack?ye.stack.split(`
`):void 0},type:s.PromiseError}):this.m({id:te,data:ye,type:s.PromiseErrorObj})}).finally(()=>{$e.dispose(),this.d.delete(ee.id)});const $e=(0,f.$Uc)(()=>ae.cancel());this.d.set(ee.id,$e)}t(ee){const ce=this.b.get(ee.channelName);if(!ce){this.v(ee);return}const ae=ee.id,te=ce.listen(this.j,ee.name,ee.arg)($e=>this.m({id:ae,data:$e,type:s.EventFire}));this.d.set(ee.id,te)}u(ee){const ce=this.d.get(ee.id);ce&&(ce.dispose(),this.d.delete(ee.id))}v(ee){let ce=this.g.get(ee.channelName);ce||(ce=[],this.g.set(ee.channelName,ce));const ae=setTimeout(()=>{console.error(`Unknown channel: ${ee.channelName}`),ee.type===m.Promise&&this.m({id:ee.id,data:{name:"Unknown channel",message:`Channel name '${ee.channelName}' timed out after ${this.l}ms`,stack:void 0},type:s.PromiseError})},this.l);ce.push({request:ee,timeoutTimer:ae})}w(ee){const ce=this.g.get(ee);if(ce){for(const ae of ce)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case m.Promise:this.s(ae.request);break;case m.EventListen:this.t(ae.request);break}this.g.delete(ee)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.$Rc)(this.d.values()),this.d.clear()}}t.$hi=w;var C;(function(se){se[se.LocalSide=0]="LocalSide",se[se.OtherSide=1]="OtherSide"})(C||(t.RequestInitiator=C={}));class W{constructor(ee,ce=null){this.l=ee,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=ce}getChannel(ee){const ce=this;return{call(ae,Ne,te){return ce.a?Promise.reject(new v.$7):ce.m(ee,ae,Ne,te)},listen(ae,Ne){return ce.a?E.Event.None:ce.o(ee,ae,Ne)}}}m(ee,ce,ae,Ne=R.CancellationToken.None){const te=this.g++,$e=m.Promise,ye={id:te,type:$e,channelName:ee,name:ce,arg:ae};if(Ne.isCancellationRequested)return Promise.reject(new v.$7);let Oe;return new Promise((Ce,re)=>{if(Ne.isCancellationRequested)return re(new v.$7);const V=()=>{const g=I=>{switch(I.type){case s.PromiseSuccess:this.f.delete(te),Ce(I.data);break;case s.PromiseError:{this.f.delete(te);const F=new Error(I.data.message);F.stack=Array.isArray(I.data.stack)?I.data.stack.join(`
`):I.data.stack,F.name=I.data.name,re(F);break}case s.PromiseErrorObj:this.f.delete(te),re(I.data);break}};this.f.set(te,g),this.p(ye)};let j=null;this.b===h.Idle?V():(j=(0,n.$sh)(g=>this.u()),j.then(()=>{j=null,V()}));const a=()=>{j?(j.cancel(),j=null):this.p({id:te,type:m.PromiseCancel}),re(new v.$7)},l=Ne.onCancellationRequested(a);Oe=(0,f.$Tc)((0,f.$Uc)(a),l),this.d.add(Oe)}).finally(()=>{Oe.dispose(),this.d.delete(Oe)})}o(ee,ce,ae){const Ne=this.g++,te=m.EventListen,$e={id:Ne,type:te,channelName:ee,name:ce,arg:ae};let ye=null;const Oe=new E.$me({onWillAddFirstListener:()=>{ye=(0,n.$sh)(Ce=>this.u()),ye.then(()=>{ye=null,this.d.add(Oe),this.p($e)})},onDidRemoveLastListener:()=>{ye?(ye.cancel(),ye=null):(this.d.delete(Oe),this.p({id:Ne,type:m.EventDispose}))}}),Re=Ce=>Oe.fire(Ce.data);return this.f.set(Ne,Re),Oe.event}p(ee){switch(ee.type){case m.Promise:case m.EventListen:{const ce=this.q([ee.type,ee.id,ee.channelName,ee.name],ee.arg);this.j?.logOutgoing(ce,ee.id,C.LocalSide,`${e(ee.type)}: ${ee.channelName}.${ee.name}`,ee.arg);return}case m.PromiseCancel:case m.EventDispose:{const ce=this.q([ee.type,ee.id]);this.j?.logOutgoing(ce,ee.id,C.LocalSide,e(ee.type));return}}}q(ee,ce=void 0){const ae=new r;return _(ae,ee),_(ae,ce),this.r(ae.buffer)}r(ee){try{return this.l.send(ee),ee.byteLength}catch{return 0}}s(ee){const ce=new y(ee),ae=H(ce),Ne=H(ce),te=ae[0];switch(te){case s.Initialize:return this.j?.logIncoming(ee.byteLength,0,C.LocalSide,o(te)),this.t({type:ae[0]});case s.PromiseSuccess:case s.PromiseError:case s.EventFire:case s.PromiseErrorObj:return this.j?.logIncoming(ee.byteLength,ae[1],C.LocalSide,o(te),Ne),this.t({type:ae[0],id:ae[1],data:Ne})}}t(ee){if(ee.type===s.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(ee.id)?.(ee)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.$Rc)(this.d.values()),this.d.clear()}}t.$ii=W,et([L.$0h],W.prototype,"onDidInitializePromise",null);class O{get connections(){const ee=[];return this.f.forEach(ce=>ee.push(ce)),ee}constructor(ee,ce,ae){this.a=new Map,this.f=new Set,this.g=new E.$me,this.onDidAddConnection=this.g.event,this.h=new E.$me,this.onDidRemoveConnection=this.h.event,this.j=new f.$Vc,this.j.add(ee(({protocol:Ne,onDidClientDisconnect:te})=>{const $e=E.Event.once(Ne.onMessage);this.j.add($e(ye=>{const Oe=new y(ye),Re=H(Oe),Ce=new w(Ne,Re,ce,ae),re=new W(Ne,ce);this.a.forEach((j,a)=>Ce.registerChannel(a,j));const V={channelServer:Ce,channelClient:re,ctx:Re};this.f.add(V),this.g.fire(V),this.j.add(te(()=>{Ce.dispose(),re.dispose(),this.f.delete(V),this.h.fire(V)}))}))}))}getChannel(ee,ce){const ae=this;return{call(Ne,te,$e){let ye;if((0,b.$tg)(ce)){const Re=(0,i.$5b)(ae.connections.filter(ce));ye=Re?Promise.resolve(Re):E.Event.toPromise(E.Event.filter(ae.onDidAddConnection,ce))}else ye=ce.routeCall(ae,Ne,te);const Oe=ye.then(Re=>Re.channelClient.getChannel(ee));return z(Oe).call(Ne,te,$e)},listen(Ne,te){if((0,b.$tg)(ce))return ae.k(ee,ce,Ne,te);const $e=ce.routeEvent(ae,Ne,te).then(ye=>ye.channelClient.getChannel(ee));return z($e).listen(Ne,te)}}}k(ee,ce,ae,Ne){const te=this;let $e;const ye=new E.$me({onWillAddFirstListener:()=>{$e=new f.$Vc;const Oe=new E.$se,Re=new Map,Ce=V=>{const a=V.channelClient.getChannel(ee).listen(ae,Ne),l=Oe.add(a);Re.set(V,l)},re=V=>{const j=Re.get(V);j&&(j.dispose(),Re.delete(V))};te.connections.filter(ce).forEach(Ce),E.Event.filter(te.onDidAddConnection,ce)(Ce,void 0,$e),te.onDidRemoveConnection(re,void 0,$e),Oe.event(ye.fire,ye,$e),$e.add(Oe)},onDidRemoveLastListener:()=>{$e?.dispose(),$e=void 0}});return ye.event}registerChannel(ee,ce){this.a.set(ee,ce);for(const ae of this.f)ae.channelServer.registerChannel(ee,ce)}dispose(){this.j.dispose();for(const ee of this.f)ee.channelClient.dispose(),ee.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$ji=O;class B{constructor(ee,ce,ae=null){const Ne=new r;_(Ne,ce),ee.send(Ne.buffer),this.a=new W(ee,ae),this.d=new w(ee,ce,ae)}getChannel(ee){return this.a.getChannel(ee)}registerChannel(ee,ce){this.d.registerChannel(ee,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$ki=B;function z(se){return{call(ee,ce,ae){return se.then(Ne=>Ne.call(ee,ce,ae))},listen(ee,ce){const ae=new E.$ve;return se.then(Ne=>ae.input=Ne.listen(ee,ce)),ae.event}}}function J(se){let ee=!1;return{call(ce,ae,Ne){return ee?se.call(ce,ae,Ne):(0,n.$Gh)(0).then(()=>ee=!0).then(()=>se.call(ce,ae,Ne))},listen(ce,ae){if(ee)return se.listen(ce,ae);const Ne=new E.$ve;return(0,n.$Gh)(0).then(()=>ee=!0).then(()=>Ne.input=se.listen(ce,ae)),Ne.event}}}class X{constructor(ee){this.a=ee}routeCall(ee){return this.b(ee)}routeEvent(ee){return this.b(ee)}async b(ee){for(const ce of ee.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await E.Event.toPromise(ee.onDidAddConnection),await this.b(ee)}}t.$ni=X;var K;(function(se){function ee(te,$e,ye){const Oe=te,Re=ye&&ye.disableMarshalling,Ce=new Map;for(const re in Oe)ae(re)&&Ce.set(re,E.Event.buffer(Oe[re],!0,void 0,$e));return new class{listen(re,V,j){const a=Ce.get(V);if(a)return a;const l=Oe[V];if(typeof l=="function"){if(Ne(V))return l.call(Oe,j);if(ae(V))return Ce.set(V,E.Event.buffer(Oe[V],!0,void 0,$e)),Ce.get(V)}throw new v.$db(`Event not found: ${V}`)}call(re,V,j){const a=Oe[V];if(typeof a=="function"){if(!Re&&Array.isArray(j))for(let g=0;g<j.length;g++)j[g]=(0,$.$ci)(j[g]);let l=a.apply(Oe,j);return l instanceof Promise||(l=Promise.resolve(l)),l}throw new v.$db(`Method not found: ${V}`)}}}se.fromService=ee;function ce(te,$e){const ye=$e&&$e.disableMarshalling;return new Proxy({},{get(Oe,Re){if(typeof Re=="string")return $e?.properties?.has(Re)?$e.properties.get(Re):Ne(Re)?function(Ce){return te.listen(Re,Ce)}:ae(Re)?te.listen(Re):async function(...Ce){let re;$e&&!(0,b.$og)($e.context)?re=[$e.context,...Ce]:re=Ce;const V=await te.call(Re,re);return ye?V:(0,$.$ci)(V)};throw new v.$db(`Property not found: ${String(Re)}`)}})}se.toService=ce;function ae(te){return te[0]==="o"&&te[1]==="n"&&A.$Ff(te.charCodeAt(2))}function Ne(te){return/^onDynamic/.test(te)&&A.$Ff(te.charCodeAt(9))}})(K||(t.ProxyChannel=K={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(se){if(Array.isArray(se))return se;if(se&&typeof se=="object"&&typeof se.toString=="function"){const ee=se.toString();if(ee!=="[object Object]")return ee}return se}function be(se){return Array.isArray(se)?se.map(he):he(se)}function Se(se,ee,ce,ae,Ne,te,$e){$e=be($e);const ye=Q[Ne],Oe=ye[ae%ye.length];let Re=[`%c[${se}]%c[${String(ee).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${Oe}`];/\($/.test(te)?(Re=Re.concat($e),Re.push(")")):Re.push($e),console.log.apply(console,Re)}class Fe{constructor(ee,ce){this.d=ee,this.f=ce,this.a=0,this.b=0}logOutgoing(ee,ce,ae,Ne,te){this.b+=ee,Se(this.d,this.b,ee,ce,ae,Ne,te)}logIncoming(ee,ce,ae,Ne,te){this.a+=ee,Se(this.f,this.a,ee,ce,ae,Ne,te)}}t.$oi=Fe}),define(we[152],ve([1,0,48,3,84,108,40]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KX=void 0;class v extends M.$ki{static f(){const f=n.Event.fromNodeEventEmitter(L.$P,"vscode:message",($,A)=>i.$Oe.wrap(A));return L.$P.send("vscode:hello"),new R.$GX(L.$P,f)}constructor(f){const $=v.f();super($,f),this.b=$}dispose(){this.b.disconnect(),super.dispose()}}t.$KX=v}),define(we[153],ve([14,13]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define(we[154],ve([14,13]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define(we[55],ve([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ei=t._util=void 0,t.$Fi=M,t.$Gi=R;var i;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function v(E){return E[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=v})(i||(t._util=i={})),t.$Ei=M("instantiationService");function n(L,v,E){v[i.DI_TARGET]===v?v[i.DI_DEPENDENCIES].push({id:L,index:E}):(v[i.DI_DEPENDENCIES]=[{id:L,index:E}],v[i.DI_TARGET]=v)}function M(L){if(i.serviceIds.has(L))return i.serviceIds.get(L);const v=function(E,f,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(v,E,$)};return v.toString=()=>L,i.serviceIds.set(L,v),v}function R(L){return L}}),define(we[155],ve([1,0,55]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Um=t.$Sm=t.ID=void 0,t.$Tm=n,t.ID="diagnosticsService",t.$Sm=(0,i.$Fi)(t.ID);function n(R){return!!R.hostName&&!!R.errorMessage}class M{async getPerformanceInfo(L,v){return{}}async getSystemInfo(L,v){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,v){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}t.$Um=M}),define(we[156],ve([1,0,106,30,11,10,17,153,55,5,41,26]),function(ne,t,i,n,M,R,L,v,E,f,$,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Hl=t.$El=t.FileKind=t.$Dl=t.$Cl=t.$Bl=t.$Al=t.$zl=t.$yl=t.$xl=t.FileOperationResult=t.$wl=t.$vl=t.$ul=t.$sl=t.FileChangeType=t.$rl=t.FileOperation=t.$ll=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$_k=void 0,t.$al=b,t.$bl=o,t.$cl=c,t.$dl=p,t.$el=k,t.$fl=y,t.$gl=r,t.$hl=d,t.$il=D,t.$jl=T,t.$kl=U,t.$ml=w,t.$nl=C,t.$ol=W,t.$pl=O,t.$ql=B,t.$tl=Q,t.$Fl=ee,t.$Gl=ce,t.$Il=Ne,t.$_k=(0,E.$Fi)("fileService");function b(te){return te.create===!0}var m;(function(te){te[te.Unknown=0]="Unknown",te[te.File=1]="File",te[te.Directory=2]="Directory",te[te.SymbolicLink=64]="SymbolicLink"})(m||(t.FileType=m={}));var e;(function(te){te[te.Readonly=1]="Readonly",te[te.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var s;(function(te){te[te.UPDATED=2]="UPDATED",te[te.ADDED=4]="ADDED",te[te.DELETED=8]="DELETED"})(s||(t.FileChangeFilter=s={}));function o(te){const $e=te;return!!$e&&typeof $e.onDidChange=="function"}var h;(function(te){te[te.None=0]="None",te[te.FileReadWrite=2]="FileReadWrite",te[te.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",te[te.FileReadStream=16]="FileReadStream",te[te.FileFolderCopy=8]="FileFolderCopy",te[te.PathCaseSensitive=1024]="PathCaseSensitive",te[te.Readonly=2048]="Readonly",te[te.Trash=4096]="Trash",te[te.FileWriteUnlock=8192]="FileWriteUnlock",te[te.FileAtomicRead=16384]="FileAtomicRead",te[te.FileAtomicWrite=32768]="FileAtomicWrite",te[te.FileAtomicDelete=65536]="FileAtomicDelete",te[te.FileClone=131072]="FileClone"})(h||(t.FileSystemProviderCapabilities=h={}));function c(te){return!!(te.capabilities&h.FileReadWrite)}function p(te){return!!(te.capabilities&h.FileFolderCopy)}function k(te){return!!(te.capabilities&h.FileClone)}function y(te){return!!(te.capabilities&h.FileOpenReadWriteClose)}function r(te){return!!(te.capabilities&h.FileReadStream)}function d(te){return c(te)?!!(te.capabilities&h.FileAtomicRead):!1}function D(te){return c(te)?!!(te.capabilities&h.FileAtomicWrite):!1}function T(te){return!!(te.capabilities&h.FileAtomicDelete)}function U(te){return!!(te.capabilities&h.Readonly)}var _;(function(te){te.FileExists="EntryExists",te.FileNotFound="EntryNotFound",te.FileNotADirectory="EntryNotADirectory",te.FileIsADirectory="EntryIsADirectory",te.FileExceedsStorageQuota="EntryExceedsStorageQuota",te.FileTooLarge="EntryTooLarge",te.FileWriteLocked="EntryWriteLocked",te.NoPermissions="NoPermissions",te.Unavailable="Unavailable",te.Unknown="Unknown"})(_||(t.FileSystemProviderErrorCode=_={}));class H extends Error{static create($e,ye){const Oe=new H($e.toString(),ye);return W(Oe,ye),Oe}constructor($e,ye){super($e),this.code=ye}}t.$ll=H;function w(te,$e){return H.create(te,$e)}function C(te){return te||w((0,v.localize)(0,null),_.Unknown)}function W(te,$e){return te.name=$e?`${$e} (FileSystemError)`:"FileSystemError",te}function O(te){if(!te)return _.Unknown;if(te instanceof H)return te.code;const $e=/^(.+) \(FileSystemError\)$/.exec(te.name);if(!$e)return _.Unknown;switch($e[1]){case _.FileExists:return _.FileExists;case _.FileIsADirectory:return _.FileIsADirectory;case _.FileNotADirectory:return _.FileNotADirectory;case _.FileNotFound:return _.FileNotFound;case _.FileTooLarge:return _.FileTooLarge;case _.FileWriteLocked:return _.FileWriteLocked;case _.NoPermissions:return _.NoPermissions;case _.Unavailable:return _.Unavailable}return _.Unknown}function B(te){if(te instanceof he)return te.fileOperationResult;switch(O(te)){case _.FileNotFound:return Fe.FILE_NOT_FOUND;case _.FileIsADirectory:return Fe.FILE_IS_DIRECTORY;case _.FileNotADirectory:return Fe.FILE_NOT_DIRECTORY;case _.FileWriteLocked:return Fe.FILE_WRITE_LOCKED;case _.NoPermissions:return Fe.FILE_PERMISSION_DENIED;case _.FileExists:return Fe.FILE_MOVE_CONFLICT;case _.FileTooLarge:return Fe.FILE_TOO_LARGE;default:return Fe.FILE_OTHER_ERROR}}var z;(function(te){te[te.CREATE=0]="CREATE",te[te.DELETE=1]="DELETE",te[te.MOVE=2]="MOVE",te[te.COPY=3]="COPY",te[te.WRITE=4]="WRITE"})(z||(t.FileOperation=z={}));class J{constructor($e,ye,Oe){this.resource=$e,this.operation=ye,this.target=Oe}isOperation($e){return this.operation===$e}}t.$rl=J;var X;(function(te){te[te.UPDATED=0]="UPDATED",te[te.ADDED=1]="ADDED",te[te.DELETED=2]="DELETED"})(X||(t.FileChangeType=X={}));class K{static{this.a=null}constructor($e,ye){this.c=ye,this.b=void 0,this.d=new A.$X(()=>{const Oe=i.$Li.forUris(()=>this.c);return Oe.fill(this.rawAdded.map(Re=>[Re,!0])),Oe}),this.f=new A.$X(()=>{const Oe=i.$Li.forUris(()=>this.c);return Oe.fill(this.rawUpdated.map(Re=>[Re,!0])),Oe}),this.g=new A.$X(()=>{const Oe=i.$Li.forUris(()=>this.c);return Oe.fill(this.rawDeleted.map(Re=>[Re,!0])),Oe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Oe of $e){switch(Oe.type){case X.ADDED:this.rawAdded.push(Oe.resource);break;case X.UPDATED:this.rawUpdated.push(Oe.resource);break;case X.DELETED:this.rawDeleted.push(Oe.resource);break}this.b!==K.a&&(typeof Oe.cId=="number"?this.b===void 0?this.b=Oe.cId:this.b!==Oe.cId&&(this.b=K.a):this.b!==void 0&&(this.b=K.a))}}contains($e,...ye){return this.h($e,{includeChildren:!1},...ye)}affects($e,...ye){return this.h($e,{includeChildren:!0},...ye)}h($e,ye,...Oe){if(!$e)return!1;const Re=Oe.length>0;return!!((!Re||Oe.includes(X.ADDED))&&(this.d.value.get($e)||ye.includeChildren&&this.d.value.findSuperstr($e))||(!Re||Oe.includes(X.UPDATED))&&(this.f.value.get($e)||ye.includeChildren&&this.f.value.findSuperstr($e))||(!Re||Oe.includes(X.DELETED))&&(this.g.value.findSubstr($e)||ye.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}t.$sl=K;function Q(te,$e,ye){return!te||!$e||te===$e||$e.length>te.length?!1:($e.charAt($e.length-1)!==n.sep&&($e+=n.sep),ye?(0,M.$Hf)(te,$e):te.indexOf($e)===0)}class he extends Error{constructor($e,ye,Oe){super($e),this.fileOperationResult=ye,this.options=Oe}}t.$ul=he;class be extends he{constructor($e,ye,Oe,Re){super($e,ye,Re),this.fileOperationResult=ye,this.size=Oe}}t.$vl=be;class Se extends he{constructor($e,ye,Oe){super($e,Fe.FILE_NOT_MODIFIED_SINCE,Oe),this.stat=ye}}t.$wl=Se;var Fe;(function(te){te[te.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",te[te.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",te[te.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",te[te.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",te[te.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",te[te.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",te[te.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",te[te.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",te[te.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",te[te.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",te[te.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Fe||(t.FileOperationResult=Fe={})),t.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$zl="files.associations",t.$Al="files.exclude",t.$Bl="files.readonlyInclude",t.$Cl="files.readonlyExclude",t.$Dl="files.readonlyFromPermissions";var se;(function(te){te[te.FILE=0]="FILE",te[te.FOLDER=1]="FOLDER",te[te.ROOT_FOLDER=2]="ROOT_FOLDER"})(se||(t.FileKind=se={})),t.$El="";function ee(te){if(!(typeof te.size!="number"||typeof te.mtime!="number"))return te.mtime.toString(29)+te.size.toString(31)}async function ce(te,$e){if(!$e.hasProvider(L.URI.from({scheme:te.scheme})))return new Promise(ye=>{const Oe=$e.onDidChangeFileSystemProviderRegistrations(Re=>{Re.scheme===te.scheme&&Re.added&&(Oe.dispose(),ye())})})}class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize($e){return(0,R.$jg)($e)||($e=0),$e<ae.KB?(0,v.localize)(1,null,$e.toFixed(0)):$e<ae.MB?(0,v.localize)(2,null,($e/ae.KB).toFixed(2)):$e<ae.GB?(0,v.localize)(3,null,($e/ae.MB).toFixed(2)):$e<ae.TB?(0,v.localize)(4,null,($e/ae.GB).toFixed(2)):(0,v.localize)(5,null,($e/ae.TB).toFixed(2))}}t.$Hl=ae;function Ne(te){const $e=typeof te=="string"||te?.scheme===$.Schemas.vscodeRemote;return typeof te!="string"&&te?.scheme===$.Schemas.file?1024*ae.MB:$e?10*ae.MB:f.$o?50*ae.MB:1024*ae.MB}}),define(we[157],ve([1,0,55]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cgc=t.$bgc=void 0,t.$bgc=(0,i.$Fi)("mainProcessService");class n{constructor(R,L){this.a=R,this.b=L}getChannel(R){return this.a.getChannel(R,this.b)}registerChannel(R,L){this.a.registerChannel(R,L)}}t.$cgc=n}),define(we[158],ve([1,0,2,152]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dgc=void 0;class M extends i.$Wc{constructor(L){super(),this.a=this.B(new n.$KX(`window:${L}`))}getChannel(L){return this.a.getChannel(L)}registerChannel(L,v){this.a.registerChannel(L,v)}}t.$dgc=M});var Ri=this&&this.__param||function(ne,t){return function(i,n){t(i,n,ne)}};define(we[159],ve([1,0,84,157]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$egc=void 0;let M=class{constructor(L,v){return this.windowId=L,i.ProxyChannel.toService(v.getChannel("nativeHost"),{context:L,properties:(()=>{const E=new Map;return E.set("windowId",L),E})()})}};t.$egc=M,t.$egc=M=et([Ri(1,n.$bgc)],M)}),define(we[85],ve([1,0,43,10]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$po=void 0,i=We(i),n=We(n);class M{constructor(){this.a=new Map}add(L,v){i.ok(n.$fg(L)),i.ok(n.$hg(v)),i.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,v)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}t.$po=new M}),define(we[160],ve([1,0,3,85]),function(ne,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qo=void 0,n=We(n),t.$qo={JSONContribution:"base.contributions.json"};function M(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class R{constructor(){this.b=new i.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,f){this.a[M(E)]=f,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;n.$po.add(t.$qo.JSONContribution,L)}),define(we[161],ve([1,0,12,21,49,22,3,10,17,154,160,85]),function(ne,t,i,n,M,R,L,v,E,f,$,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bx=t.$Ax=t.$zx=t.$yx=t.$xx=t.$wx=t.IconFontDefinition=t.IconContribution=t.$tx=void 0,t.$ux=o,t.$vx=h,A=We(A),t.$tx={IconContribution:"base.contributions.icons"};var b;(function(y){function r(d,D){let T=d.defaults;for(;R.ThemeIcon.isThemeIcon(T);){const U=s.getIcon(T.id);if(!U)return;T=U.defaults}return T}y.getDefinition=r})(b||(t.IconContribution=b={}));var m;(function(y){function r(D){return{weight:D.weight,style:D.style,src:D.src.map(T=>({format:T.format,location:T.location.toString()}))}}y.toJSONObject=r;function d(D){const T=U=>(0,v.$fg)(U)?U:void 0;if(D&&Array.isArray(D.src)&&D.src.every(U=>(0,v.$fg)(U.format)&&(0,v.$fg)(U.location)))return{weight:T(D.weight),style:T(D.style),src:D.src.map(U=>({format:U.format,location:E.URI.parse(U.location)}))}}y.fromJSONObject=d})(m||(t.IconFontDefinition=m={}));class e{constructor(){this.a=new L.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,f.localize)(0,null)},fontCharacter:{type:"string",description:(0,f.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,d,D,T){const U=this.b[r];if(U){if(D&&!U.description){U.description=D,this.d.properties[r].markdownDescription=`${D} $(${r})`;const w=this.e.enum.indexOf(r);w!==-1&&(this.e.enumDescriptions[w]=D),this.a.fire()}return U}const _={id:r,description:D,defaults:d,deprecationMessage:T};this.b[r]=_;const H={$ref:"#/definitions/icons"};return T&&(H.deprecationMessage=T),D&&(H.markdownDescription=`${D}: $(${r})`),this.d.properties[r]=H,this.e.enum.push(r),this.e.enumDescriptions.push(D||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const d=this.e.enum.indexOf(r);d!==-1&&(this.e.enum.splice(d,1),this.e.enumDescriptions.splice(d,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,d){const D=this.f[r];return D||(this.f[r]=d,this.a.fire(),d)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(U,_)=>U.id.localeCompare(_.id),d=U=>{for(;R.ThemeIcon.isThemeIcon(U.defaults);)U=this.b[U.defaults.id];return`codicon codicon-${U?U.id:""}`},D=[];D.push("| preview     | identifier                        | default codicon ID                | description"),D.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const T=Object.keys(this.b).map(U=>this.b[U]);for(const U of T.filter(_=>!!_.description).sort(r))D.push(`|<i class="${d(U)}"></i>|${U.id}|${R.ThemeIcon.isThemeIcon(U.defaults)?U.defaults.id:U.id}|${U.description||""}|`);D.push("| preview     | identifier                        "),D.push("| ----------- | --------------------------------- |");for(const U of T.filter(_=>!R.ThemeIcon.isThemeIcon(_.defaults)).sort(r))D.push(`|<i class="${d(U)}"></i>|${U.id}|`);return D.join(`
`)}}const s=new e;A.$po.add(t.$tx.IconContribution,s);function o(y,r,d,D){return s.registerIcon(y,r,d,D)}function h(){return s}function c(){const y=(0,M.$1j)();for(const r in y){const d="\\"+y[r].toString(16);s.registerIcon(r,{fontCharacter:d})}}c(),t.$wx="vscode://schemas/icons";const p=A.$po.as($.$qo.JSONContribution);p.registerSchema(t.$wx,s.getIconSchema());const k=new i.$Rh(()=>p.notifySchemaChanged(t.$wx),200);s.onDidChange(()=>{k.isScheduled()||k.schedule()}),t.$xx=o("widget-close",n.$5j.close,(0,f.localize)(2,null)),t.$yx=o("goto-previous-location",n.$5j.arrowUp,(0,f.localize)(3,null)),t.$zx=o("goto-next-location",n.$5j.arrowDown,(0,f.localize)(4,null)),t.$Ax=R.ThemeIcon.modify(n.$5j.sync,"spin"),t.$Bx=R.ThemeIcon.modify(n.$5j.loading,"spin")}),define(we[162],ve([1,0,4,3,2,22,161]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zLb=void 0,t.$yLb=v;function v(f){const $=new M.$Vc,A=$.add(new n.$me),b=(0,L.$vx)();return $.add(b.onDidChange(()=>A.fire())),f&&$.add(f.onDidProductIconThemeChange(()=>A.fire())),{dispose:()=>$.dispose(),onDidChange:A.event,getCSS(){const m=f?f.getProductIconTheme():new E,e={},s=[],o=[];for(const h of b.getIcons()){const c=m.getIcon(h);if(!c)continue;const p=c.font,k=`--vscode-icon-${h.id}-font-family`,y=`--vscode-icon-${h.id}-content`;p?(e[p.id]=p.definition,o.push(`${k}: ${(0,i.$NT)(p.id)};`,`${y}: '${c.fontCharacter}';`),s.push(`.codicon-${h.id}:before { content: '${c.fontCharacter}'; font-family: ${(0,i.$NT)(p.id)}; }`)):(o.push(`${y}: '${c.fontCharacter}'; ${k}: 'codicon';`),s.push(`.codicon-${h.id}:before { content: '${c.fontCharacter}'; }`))}for(const h in e){const c=e[h],p=c.weight?`font-weight: ${c.weight};`:"",k=c.style?`font-style: ${c.style};`:"",y=c.src.map(r=>`${(0,i.$MT)(r.location)} format('${r.format}')`).join(", ");s.push(`@font-face { src: ${y}; font-family: ${(0,i.$NT)(h)};${p}${k} font-display: block; }`)}return s.push(`:root { ${o.join(" ")} }`),s.join(`
`)}}}class E{getIcon($){const A=(0,L.$vx)();let b=$.defaults;for(;R.ThemeIcon.isThemeIcon(b);){const m=A.getIcon(b.id);if(!m)return;b=m.defaults}return b}}t.$zLb=E}),define(we[163],ve([1,0,5]),function(ne,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4D=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$UD=void 0,t.$VD=n,t.$WD=M,t.$XD=R,t.$YD=L,t.$ZD=v,t.$1D=A,t.$2D=b,t.$3D=m,t.$5D=e,t.$6D=s,t.$7D=o,t.$UD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function n(h){return typeof h.parentId=="number"}function M(h){return!!h.workspaceUri}function R(h){return!!h.folderUri}function L(h){return!!h.fileUri}function v(h){const c=b(h),p=h.getValue("window.menuBarVisibility");return p==="default"||c&&p==="compact"||i.$j&&i.$m?"classic":p}var E;(function(h){h.TITLE_BAR_STYLE="window.titleBarStyle",h.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(E||(t.TitleBarSetting=E={}));var f;(function(h){h.NATIVE="native",h.CUSTOM="custom"})(f||(t.TitlebarStyle=f={}));var $;(function(h){h.AUTO="auto",h.WINDOWED="windowed",h.NEVER="never"})($||(t.CustomTitleBarVisibility=$={}));function A(h,c){return!0}function b(h,c){return c||(c=m(h)),c===f.NATIVE}function m(h){if(i.$o)return f.CUSTOM;const c=h.getValue("window");if(c){if(i.$j&&c.nativeTabs===!0||i.$j&&c.nativeFullScreen===!1)return f.NATIVE;const y=c.titleBarStyle;if(y===f.NATIVE||y===f.CUSTOM)return y}return i.$k?f.NATIVE:f.CUSTOM}t.$4D=35;function e(h){return!(!i.$i||i.$o||b(h))}function s(h){const c=h.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}function o(h=0){return Math.pow(1.2,h)}}),define(we[164],ve([1,0,19,4,25,40,163]),function(ne,t,i,n,M,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ggc=t.$fgc=t.ApplyZoomTarget=void 0,t.$hgc=E,t.$igc=$,t.$jgc=A;var v;(function(b){b[b.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",b[b.ALL_WINDOWS=2]="ALL_WINDOWS"})(v||(t.ApplyZoomTarget=v={})),t.$fgc=8,t.$ggc=-8;function E(b,m){b=Math.min(Math.max(b,t.$ggc),t.$fgc);const e=[];m===v.ACTIVE_WINDOW?e.push((0,n.$7S)()):m===v.ALL_WINDOWS?e.push(...Array.from((0,n.getWindows)()).map(({window:s})=>s)):e.push(m);for(const s of e)f(s)?.webFrame?.setZoomLevel(b),(0,i.$4R)((0,L.$7D)(b),s),(0,i.$ZR)(b,s)}function f(b){if(b===M.$VR)return{ipcRenderer:R.$P,webFrame:R.$R};{const m=b;if(m?.vscode?.ipcRenderer&&m?.vscode?.webFrame)return m.vscode}}function $(b){E((0,i.$1R)(typeof b=="number"?(0,n.$7S)():b)+1,b)}function A(b){E((0,i.$1R)(typeof b=="number"?(0,n.$7S)():b)-1,b)}}),define(we[165],ve([1,0,13,4,151,12,109,40,155,156,158,159,162,164,16,8,25,123,113]),function(ne,t,i,n,M,R,L,v,E,f,$,A,b,m,e,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=C;const h=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,c=/\s--inspect-port=(?<port>\d+)/;class p{getHeight(O){return 22}getTemplateId(O){return _(O)?"process":T(O)?"machine":(0,E.$Tm)(O)?"error":U(O)?"header":""}}class k{hasChildren(O){return(0,E.$Tm)(O)?!1:_(O)?!!O.children?.length:!0}getChildren(O){return _(O)?O.children?O.children:[]:(0,E.$Tm)(O)?[]:U(O)?O.processRoots.length>1?O.processRoots:[O.processRoots[0].rootProcess]:T(O)?[O.rootProcess]:[O.processes]}}class y{constructor(){this.templateId="header"}renderTemplate(O){const B=(0,n.$wT)(O,(0,n.$)(".row")),z=(0,n.$wT)(B,(0,n.$)(".nameLabel")),J=(0,n.$wT)(B,(0,n.$)(".cpu")),X=(0,n.$wT)(B,(0,n.$)(".memory")),K=(0,n.$wT)(B,(0,n.$)(".pid"));return{name:z,CPU:J,memory:X,PID:K}}renderElement(O,B,z,J){z.name.textContent=(0,i.localize)(0,null),z.CPU.textContent=(0,i.localize)(1,null),z.PID.textContent=(0,i.localize)(2,null),z.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(O){}}class r{constructor(){this.templateId="machine"}renderTemplate(O){const B=Object.create(null),z=(0,n.$wT)(O,(0,n.$)(".row"));return B.name=(0,n.$wT)(z,(0,n.$)(".nameLabel")),B}renderElement(O,B,z,J){z.name.textContent=O.element.name}disposeTemplate(O){}}class d{constructor(){this.templateId="error"}renderTemplate(O){const B=Object.create(null),z=(0,n.$wT)(O,(0,n.$)(".row"));return B.name=(0,n.$wT)(z,(0,n.$)(".nameLabel")),B}renderElement(O,B,z,J){z.name.textContent=O.element.errorMessage}disposeTemplate(O){}}class D{constructor(O,B,z){this.a=O,this.b=B,this.c=z,this.templateId="process"}renderTemplate(O){const B=(0,n.$wT)(O,(0,n.$)(".row")),z=(0,n.$wT)(B,(0,n.$)(".nameLabel")),J=(0,n.$wT)(B,(0,n.$)(".cpu")),X=(0,n.$wT)(B,(0,n.$)(".memory")),K=(0,n.$wT)(B,(0,n.$)(".pid"));return{name:z,CPU:J,PID:K,memory:X}}renderElement(O,B,z,J){const{element:X}=O,K=X.pid.toFixed(0);let Q=X.name;this.c.has(X.pid)&&(Q=this.c.get(X.pid)),z.name.textContent=Q,z.name.title=X.cmd,z.CPU.textContent=X.load.toFixed(0),z.PID.textContent=K,z.PID.parentElement.id=`pid-${K}`;const he=this.a==="win32"?X.mem:this.b*(X.mem/100);z.memory.textContent=(he/f.$Hl.MB).toFixed(0)}disposeTemplate(O){}}function T(W){return!!W.name&&!!W.rootProcess}function U(W){return!!W.processRoots}function _(W){return!!W.pid}class H{constructor(O,B){this.f=B,this.b=new Map;const z=new $.$dgc(O);this.c=new A.$egc(O,z),this.k(B.styles),this.g(B),v.$P.on("vscode:pidToNameResponse",(J,X)=>{this.b.clear();for(const[K,Q]of X)this.b.set(K,Q)}),v.$P.on("vscode:listProcessesResponse",async(J,X)=>{X.forEach((K,Q)=>{_(K.rootProcess)&&(K.rootProcess.name=Q===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:X}}),this.d.layout(o.$VR.innerHeight,o.$VR.innerWidth)):await this.h(X),this.m(0)}),this.a=Date.now(),v.$P.send("vscode:pidToNameRequest"),v.$P.send("vscode:listProcesses")}g(O){o.$VR.document.onkeydown=B=>{const z=O.platform==="darwin"?B.metaKey:B.ctrlKey;z&&B.keyCode===87&&(B.stopPropagation(),B.preventDefault(),v.$P.send("vscode:closeProcessExplorer")),z&&B.keyCode===187&&(0,m.$igc)(o.$VR),z&&B.keyCode===189&&(0,m.$jgc)(o.$VR)}}async h(O){const B=o.$VR.document.getElementById("process-list");if(!B)return;const{totalmem:z}=await this.c.getOSStatistics(),J=[new D(this.f.platform,z,this.b),new y,new r,new d];this.d=new M.$0W("processExplorer",B,new p,J,new k,{identityProvider:{getId:X=>_(X)?X.pid.toString():(0,E.$Tm)(X)?X.hostName:U(X)?"processes":T(X)?X.name:"header"}}),this.d.setInput({processes:{processRoots:O}}),this.d.layout(o.$VR.innerHeight,o.$VR.innerWidth),this.d.onKeyDown(X=>{const K=new e.$mS(X);if(K.keyCode===s.KeyCode.KeyE&&K.altKey){const Q=this.n();Promise.all(Q.map(he=>this.c.killProcess(he,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(X=>{_(X.element)&&this.l(X.element,!0)}),B.style.height=`${o.$VR.innerHeight}px`,o.$VR.addEventListener("resize",()=>{B.style.height=`${o.$VR.innerHeight}px`,this.d?.layout(o.$VR.innerHeight,o.$VR.innerWidth)})}i(O){const B=h.exec(O);return B&&B.groups.port!=="0"||O.indexOf("node ")>=0||O.indexOf("node.exe")>=0}j(O){const B={type:"node",request:"attach",name:`process ${O.pid}`};let z=h.exec(O.cmd);z?B.port=Number(z.groups.port):B.processId=String(O.pid),z=c.exec(O.cmd),z&&(B.port=Number(z.groups.port)),v.$P.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[B]})}k(O){const B=(0,n.$0S)(),z=[];O.listFocusBackground&&(z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${O.listFocusBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${O.listFocusBackground}; }`)),O.listFocusForeground&&z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${O.listFocusForeground}; }`),O.listActiveSelectionBackground&&(z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${O.listActiveSelectionBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${O.listActiveSelectionBackground}; }`)),O.listActiveSelectionForeground&&z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${O.listActiveSelectionForeground}; }`),O.listHoverBackground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${O.listHoverBackground}; }`),O.listHoverForeground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${O.listHoverForeground}; }`),O.listFocusOutline&&z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${O.listFocusOutline}; outline-offset: -1px; }`),O.listHoverOutline&&z.push(`.monaco-list-row:hover { outline: 1px dashed ${O.listHoverOutline}; outline-offset: -1px; }`),O.scrollbarShadowColor&&z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${O.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${O.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),O.scrollbarSliderBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${O.scrollbarSliderBackgroundColor};
				}
			`),O.scrollbarSliderHoverBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${O.scrollbarSliderHoverBackgroundColor};
				}
			`),O.scrollbarSliderActiveBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${O.scrollbarSliderActiveBackgroundColor};
				}
			`),B.textContent=z.join(`
`),O.color&&(o.$VR.document.body.style.color=O.color)}l(O,B){const z=[],J=Number(O.pid);B&&(z.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(J,"SIGTERM")}}),z.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(J,"SIGKILL")}}),z.push({type:"separator"})),z.push({label:(0,i.localize)(6,null),click:()=>{const X=this.n();X?.includes(J)||(X.length=0,X.push(J));const K=X?.map(Q=>o.$VR.document.getElementById(`pid-${Q}`)).filter(Q=>!!Q);if(K){const Q=K.map(he=>he.innerText).filter(he=>!!he);this.c.writeClipboardText(Q.join(`
`))}}}),z.push({label:(0,i.localize)(7,null),click:()=>{const X=o.$VR.document.getElementById("process-list");X&&this.c.writeClipboardText(X.innerText)}}),O&&B&&this.i(O.cmd)&&(z.push({type:"separator"}),z.push({label:(0,i.localize)(8,null),click:()=>{this.j(O)}})),(0,L.$CX)(z)}m(O){setTimeout(()=>{const B=Date.now(),z=O+B-this.a;this.a=B,z>1e3?(v.$P.send("vscode:pidToNameRequest"),v.$P.send("vscode:listProcesses")):this.m(z)},200)}n(){return this.d?.getSelection()?.map(O=>{if(!(!O||!("pid"in O)))return O.pid}).filter(O=>!!O)}}function w(){const W=(0,n.$0S)();W.id="codiconStyles";const O=(0,b.$yLb)(void 0);function B(){W.textContent=O.getCSS()}const z=new R.$Rh(B,0);O.onDidChange(()=>z.schedule()),z.schedule()}function C(W){const O=W.data.platform==="win32"?"windows":W.data.platform==="linux"?"linux":"mac";o.$VR.document.body.classList.add(O),w(),(0,m.$hgc)(W.data.zoomLevel,o.$VR),new H(W.windowId,W.data)}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/0cb5ca1d55b8ac035764b4726b5a01b6da22147d/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
