/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],oe=function(H){for(var e=[],E=0,S=H.length;E<S;E++)e[E]=re[H[E]];return e};define(re[74],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var E;(function(y){y[y.LoaderAvailable=1]="LoaderAvailable",y[y.BeginLoadingScript=10]="BeginLoadingScript",y[y.EndLoadingScriptOK=11]="EndLoadingScriptOK",y[y.EndLoadingScriptError=12]="EndLoadingScriptError",y[y.BeginInvokeFactory=21]="BeginInvokeFactory",y[y.EndInvokeFactory=22]="EndInvokeFactory",y[y.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",y[y.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",y[y.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",y[y.NodeEndNativeRequire=34]="NodeEndNativeRequire",y[y.CachedDataFound=60]="CachedDataFound",y[y.CachedDataMissed=61]="CachedDataMissed",y[y.CachedDataRejected=62]="CachedDataRejected",y[y.CachedDataCreated=63]="CachedDataCreated"})(E||(e.LoaderEventType=E={}));class S{static get(){const k=new Map,A=new Map,I=new Map,g=new Map;function c(m,O){m.has(O.detail)||m.set(O.detail,-O.timestamp)}function l(m,O){const p=m.get(O.detail);p&&(p>=0||m.set(O.detail,p+O.timestamp))}let u=[];typeof H=="function"&&typeof H.getStats=="function"&&(u=H.getStats().slice(0).sort((m,O)=>m.timestamp-O.timestamp));for(const m of u)switch(m.type){case E.BeginLoadingScript:c(k,m);break;case E.EndLoadingScriptOK:case E.EndLoadingScriptError:l(k,m);break;case E.BeginInvokeFactory:c(A,m);break;case E.EndInvokeFactory:l(A,m);break;case E.NodeBeginNativeRequire:c(I,m);break;case E.NodeEndNativeRequire:l(I,m);break;case E.NodeBeginEvaluatingScript:c(g,m);break;case E.NodeEndEvaluatingScript:l(g,m);break}let h=0;I.forEach(m=>h+=m);function w(m){const O=[];return m.forEach((p,f)=>O.push([f,p])),O}return{amdLoad:w(k),amdInvoke:w(A),nodeRequire:w(I),nodeEval:w(g),nodeRequireTotal:h}}static toMarkdownTable(k,A){let I="";const g=[];return k.forEach((c,l)=>{g[l]=c.length}),A.forEach(c=>{c.forEach((l,u)=>{typeof l>"u"&&(l=c[u]="-");const h=l.toString().length;g[u]=Math.max(h,g[u])})}),k.forEach((c,l)=>{I+=`| ${c+" ".repeat(g[l]-c.toString().length)} `}),I+=`|
`,k.forEach((c,l)=>{I+=`| ${"-".repeat(g[l])} `}),I+=`|
`,A.forEach(c=>{c.forEach((l,u)=>{typeof l<"u"&&(I+=`| ${l+" ".repeat(g[u]-l.toString().length)} `)}),I+=`|
`}),I}}e.$W=S}),define(re[55],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=S,e.$$h=y,e.$_h=k;function E(A){return(I,g,c)=>{let l=null,u=null;if(typeof c.value=="function"?(l="value",u=c.value):typeof c.get=="function"&&(l="get",u=c.get),!u)throw new Error("not supported");c[l]=A(u,g)}}function S(A,I,g){let c=null,l=null;if(typeof g.value=="function"?(c="value",l=g.value,l.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(c="get",l=g.get),!l)throw new Error("not supported");const u=`$memoize$${I}`;g[c]=function(...h){return this.hasOwnProperty(u)||Object.defineProperty(this,u,{configurable:!1,enumerable:!1,writable:!1,value:l.apply(this,h)}),this[u]}}function y(A,I,g){return E((c,l)=>{const u=`$debounce$${l}`,h=`$debounce$result$${l}`;return function(...w){this[h]||(this[h]=g?g():void 0),clearTimeout(this[u]),I&&(this[h]=I(this[h],...w),w=[this[h]]),this[u]=setTimeout(()=>{c.apply(this,w),this[h]=g?g():void 0},A)}})}function k(A,I,g){return E((c,l)=>{const u=`$throttle$timer$${l}`,h=`$throttle$result$${l}`,w=`$throttle$lastRun$${l}`,m=`$throttle$pending$${l}`;return function(...O){if(this[h]||(this[h]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),I&&(this[h]=I(this[h],...O)),this[m])return;const p=this[w]+A;p<=Date.now()?(this[w]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0):(this[m]=!0,this[u]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),c.apply(this,[this[h]]),this[h]=g?g():void 0},p-Date.now()))}})}}),define(re[75],oe([0,1,9]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=S,e.$gd=y,e.$hd=k,e.$id=A,e.$jd=I,e.$kd=g;function S(c,l){if(!c)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}function y(c,l="Unreachable"){throw new Error(l)}function k(c,l="unexpected state"){if(!c)throw new E.$eb(`Assertion Failed: ${l}`)}function A(c){c||(0,E.$3)(new E.$eb("Soft Assertion Failed"))}function I(c){if(!c()){debugger;c(),(0,E.$3)(new E.$eb("Assertion Failed"))}}function g(c,l){let u=0;for(;u<c.length-1;){const h=c[u],w=c[u+1];if(!l(h,w))return!1;u++}return!0}}),define(re[34],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=A,e.$Un=u,e.$Vn=h,e.$Wn=w,e.$Xn=m,e.$Yn=O,e.$Zn=p,e.$1n=f,e.$2n=$,e.$3n=P,e.$4n=v,e.$5n=a;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var S;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(S||(e.SyntaxKind=S={}));var y;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(y||(e.ParseErrorCode=y={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function A(i,s=!1){let r=0;const t=i.length;let n="",o=0,d=S.Unknown,R=E.None;function N(ie){let ue=0,ce=0;for(;ue<ie;){const le=i.charCodeAt(r);if(le>=l._0&&le<=l._9)ce=ce*16+le-l._0;else if(le>=l.A&&le<=l.F)ce=ce*16+le-l.A+10;else if(le>=l.a&&le<=l.f)ce=ce*16+le-l.a+10;else break;r++,ue++}return ue<ie&&(ce=-1),ce}function C(ie){r=ie,n="",o=0,d=S.Unknown,R=E.None}function D(){const ie=r;if(i.charCodeAt(r)===l._0)r++;else for(r++;r<i.length&&c(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===l.dot)if(r++,r<i.length&&c(i.charCodeAt(r)))for(r++;r<i.length&&c(i.charCodeAt(r));)r++;else return R=E.UnexpectedEndOfNumber,i.substring(ie,r);let ue=r;if(r<i.length&&(i.charCodeAt(r)===l.E||i.charCodeAt(r)===l.e))if(r++,(r<i.length&&i.charCodeAt(r)===l.plus||i.charCodeAt(r)===l.minus)&&r++,r<i.length&&c(i.charCodeAt(r))){for(r++;r<i.length&&c(i.charCodeAt(r));)r++;ue=r}else R=E.UnexpectedEndOfNumber;return i.substring(ie,ue)}function T(){let ie="",ue=r;for(;;){if(r>=t){ie+=i.substring(ue,r),R=E.UnexpectedEndOfString;break}const ce=i.charCodeAt(r);if(ce===l.doubleQuote){ie+=i.substring(ue,r),r++;break}if(ce===l.backslash){if(ie+=i.substring(ue,r),r++,r>=t){R=E.UnexpectedEndOfString;break}switch(i.charCodeAt(r++)){case l.doubleQuote:ie+='"';break;case l.backslash:ie+="\\";break;case l.slash:ie+="/";break;case l.b:ie+="\b";break;case l.f:ie+="\f";break;case l.n:ie+=`
`;break;case l.r:ie+="\r";break;case l.t:ie+="	";break;case l.u:{const x=N(4);x>=0?ie+=String.fromCharCode(x):R=E.InvalidUnicode;break}default:R=E.InvalidEscapeCharacter}ue=r;continue}if(ce>=0&&ce<=31)if(g(ce)){ie+=i.substring(ue,r),R=E.UnexpectedEndOfString;break}else R=E.InvalidCharacter;r++}return ie}function M(){if(n="",R=E.None,o=r,r>=t)return o=t,d=S.EOF;let ie=i.charCodeAt(r);if(I(ie)){do r++,n+=String.fromCharCode(ie),ie=i.charCodeAt(r);while(I(ie));return d=S.Trivia}if(g(ie))return r++,n+=String.fromCharCode(ie),ie===l.carriageReturn&&i.charCodeAt(r)===l.lineFeed&&(r++,n+=`
`),d=S.LineBreakTrivia;switch(ie){case l.openBrace:return r++,d=S.OpenBraceToken;case l.closeBrace:return r++,d=S.CloseBraceToken;case l.openBracket:return r++,d=S.OpenBracketToken;case l.closeBracket:return r++,d=S.CloseBracketToken;case l.colon:return r++,d=S.ColonToken;case l.comma:return r++,d=S.CommaToken;case l.doubleQuote:return r++,n=T(),d=S.StringLiteral;case l.slash:{const ue=r-1;if(i.charCodeAt(r+1)===l.slash){for(r+=2;r<t&&!g(i.charCodeAt(r));)r++;return n=i.substring(ue,r),d=S.LineCommentTrivia}if(i.charCodeAt(r+1)===l.asterisk){r+=2;const ce=t-1;let le=!1;for(;r<ce;){if(i.charCodeAt(r)===l.asterisk&&i.charCodeAt(r+1)===l.slash){r+=2,le=!0;break}r++}return le||(r++,R=E.UnexpectedEndOfComment),n=i.substring(ue,r),d=S.BlockCommentTrivia}return n+=String.fromCharCode(ie),r++,d=S.Unknown}case l.minus:if(n+=String.fromCharCode(ie),r++,r===t||!c(i.charCodeAt(r)))return d=S.Unknown;case l._0:case l._1:case l._2:case l._3:case l._4:case l._5:case l._6:case l._7:case l._8:case l._9:return n+=D(),d=S.NumericLiteral;default:for(;r<t&&K(ie);)r++,ie=i.charCodeAt(r);if(o!==r){switch(n=i.substring(o,r),n){case"true":return d=S.TrueKeyword;case"false":return d=S.FalseKeyword;case"null":return d=S.NullKeyword}return d=S.Unknown}return n+=String.fromCharCode(ie),r++,d=S.Unknown}}function K(ie){if(I(ie)||g(ie))return!1;switch(ie){case l.closeBrace:case l.closeBracket:case l.openBrace:case l.openBracket:case l.doubleQuote:case l.colon:case l.comma:case l.slash:return!1}return!0}function ae(){let ie;do ie=M();while(ie>=S.LineCommentTrivia&&ie<=S.Trivia);return ie}return{setPosition:C,getPosition:()=>r,scan:s?ae:M,getToken:()=>d,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>R}}function I(i){return i===l.space||i===l.tab||i===l.verticalTab||i===l.formFeed||i===l.nonBreakingSpace||i===l.ogham||i>=l.enQuad&&i<=l.zeroWidthSpace||i===l.narrowNoBreakSpace||i===l.mathematicalSpace||i===l.ideographicSpace||i===l.byteOrderMark}function g(i){return i===l.lineFeed||i===l.carriageReturn||i===l.lineSeparator||i===l.paragraphSeparator}function c(i){return i>=l._0&&i<=l._9}var l;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(l||(l={}));function u(i,s){const r=[],t=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function R(N,C,D,T){o.value=N,o.offset=C,o.length=D,o.type=T,o.colonOffset=void 0,n=o}try{P(i,{onObjectBegin:(N,C)=>{if(s<=N)throw t;n=void 0,d=s>N,r.push("")},onObjectProperty:(N,C,D)=>{if(s<C||(R(N,C,D,"property"),r[r.length-1]=N,s<=C+D))throw t},onObjectEnd:(N,C)=>{if(s<=N)throw t;n=void 0,r.pop()},onArrayBegin:(N,C)=>{if(s<=N)throw t;n=void 0,r.push(0)},onArrayEnd:(N,C)=>{if(s<=N)throw t;n=void 0,r.pop()},onLiteralValue:(N,C,D)=>{if(s<C||(R(N,C,D,a(N)),s<=C+D))throw t},onSeparator:(N,C,D)=>{if(s<=C)throw t;if(N===":"&&n&&n.type==="property")n.colonOffset=C,d=!1,n=void 0;else if(N===","){const T=r[r.length-1];typeof T=="number"?r[r.length-1]=T+1:(d=!0,r[r.length-1]=""),n=void 0}}})}catch(N){if(N!==t)throw N}return{path:r,previousNode:n,isAtPropertyKey:d,matches:N=>{let C=0;for(let D=0;C<N.length&&D<r.length;D++)if(N[C]===r[D]||N[C]==="*")C++;else if(N[C]!=="**")return!1;return C===N.length}}}function h(i,s=[],r=k.DEFAULT){let t=null,n=[];const o=[];function d(N){Array.isArray(n)?n.push(N):t!==null&&(n[t]=N)}return P(i,{onObjectBegin:()=>{const N={};d(N),o.push(n),n=N,t=null},onObjectProperty:N=>{t=N},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const N=[];d(N),o.push(n),n=N,t=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:d,onError:(N,C,D)=>{s.push({error:N,offset:C,length:D})}},r),n[0]}function w(i,s=[],r=k.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(N){t.type==="property"&&(t.length=N-t.offset,t=t.parent)}function o(N){return t.children.push(N),N}P(i,{onObjectBegin:N=>{t=o({type:"object",offset:N,length:-1,parent:t,children:[]})},onObjectProperty:(N,C,D)=>{t=o({type:"property",offset:C,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:N,offset:C,length:D,parent:t})},onObjectEnd:(N,C)=>{t.length=N+C-t.offset,t=t.parent,n(N+C)},onArrayBegin:(N,C)=>{t=o({type:"array",offset:N,length:-1,parent:t,children:[]})},onArrayEnd:(N,C)=>{t.length=N+C-t.offset,t=t.parent,n(N+C)},onLiteralValue:(N,C,D)=>{o({type:a(N),offset:C,length:D,parent:t,value:N}),n(C+D)},onSeparator:(N,C,D)=>{t.type==="property"&&(N===":"?t.colonOffset=C:N===","&&n(C))},onError:(N,C,D)=>{s.push({error:N,offset:C,length:D})}},r);const R=t.children[0];return R&&delete R.parent,R}function m(i,s){if(!i)return;let r=i;for(const t of s)if(typeof t=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===t){r=o.children[1],n=!0;break}if(!n)return}else{const n=t;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function O(i){if(!i.parent||!i.parent.children)return[];const s=O(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}function p(i){switch(i.type){case"array":return i.children.map(p);case"object":{const s=Object.create(null);for(const r of i.children){const t=r.children[1];t&&(s[r.children[0].value]=p(t))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function f(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}function $(i,s,r=!1){if(f(i,s,r)){const t=i.children;if(Array.isArray(t))for(let n=0;n<t.length&&t[n].offset<=s;n++){const o=$(t[n],s,r);if(o)return o}return i}}function P(i,s,r=k.DEFAULT){const t=A(i,!1);function n(Y){return Y?()=>Y(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(Y){return Y?j=>Y(j,t.getTokenOffset(),t.getTokenLength()):()=>!0}const d=n(s.onObjectBegin),R=o(s.onObjectProperty),N=n(s.onObjectEnd),C=n(s.onArrayBegin),D=n(s.onArrayEnd),T=o(s.onLiteralValue),M=o(s.onSeparator),K=n(s.onComment),ae=o(s.onError),ie=r&&r.disallowComments,ue=r&&r.allowTrailingComma;function ce(){for(;;){const Y=t.scan();switch(t.getTokenError()){case E.InvalidUnicode:le(y.InvalidUnicode);break;case E.InvalidEscapeCharacter:le(y.InvalidEscapeCharacter);break;case E.UnexpectedEndOfNumber:le(y.UnexpectedEndOfNumber);break;case E.UnexpectedEndOfComment:ie||le(y.UnexpectedEndOfComment);break;case E.UnexpectedEndOfString:le(y.UnexpectedEndOfString);break;case E.InvalidCharacter:le(y.InvalidCharacter);break}switch(Y){case S.LineCommentTrivia:case S.BlockCommentTrivia:ie?le(y.InvalidCommentToken):K();break;case S.Unknown:le(y.InvalidSymbol);break;case S.Trivia:case S.LineBreakTrivia:break;default:return Y}}}function le(Y,j=[],z=[]){if(ae(Y),j.length+z.length>0){let G=t.getToken();for(;G!==S.EOF;){if(j.indexOf(G)!==-1){ce();break}else if(z.indexOf(G)!==-1)break;G=ce()}}}function x(Y){const j=t.getTokenValue();return Y?T(j):R(j),ce(),!0}function _(){switch(t.getToken()){case S.NumericLiteral:{let Y=0;try{Y=JSON.parse(t.getTokenValue()),typeof Y!="number"&&(le(y.InvalidNumberFormat),Y=0)}catch{le(y.InvalidNumberFormat)}T(Y);break}case S.NullKeyword:T(null);break;case S.TrueKeyword:T(!0);break;case S.FalseKeyword:T(!1);break;default:return!1}return ce(),!0}function B(){return t.getToken()!==S.StringLiteral?(le(y.PropertyNameExpected,[],[S.CloseBraceToken,S.CommaToken]),!1):(x(!1),t.getToken()===S.ColonToken?(M(":"),ce(),Z()||le(y.ValueExpected,[],[S.CloseBraceToken,S.CommaToken])):le(y.ColonExpected,[],[S.CloseBraceToken,S.CommaToken]),!0)}function U(){d(),ce();let Y=!1;for(;t.getToken()!==S.CloseBraceToken&&t.getToken()!==S.EOF;){if(t.getToken()===S.CommaToken){if(Y||le(y.ValueExpected,[],[]),M(","),ce(),t.getToken()===S.CloseBraceToken&&ue)break}else Y&&le(y.CommaExpected,[],[]);B()||le(y.ValueExpected,[],[S.CloseBraceToken,S.CommaToken]),Y=!0}return N(),t.getToken()!==S.CloseBraceToken?le(y.CloseBraceExpected,[S.CloseBraceToken],[]):ce(),!0}function J(){C(),ce();let Y=!1;for(;t.getToken()!==S.CloseBracketToken&&t.getToken()!==S.EOF;){if(t.getToken()===S.CommaToken){if(Y||le(y.ValueExpected,[],[]),M(","),ce(),t.getToken()===S.CloseBracketToken&&ue)break}else Y&&le(y.CommaExpected,[],[]);Z()||le(y.ValueExpected,[],[S.CloseBracketToken,S.CommaToken]),Y=!0}return D(),t.getToken()!==S.CloseBracketToken?le(y.CloseBracketExpected,[S.CloseBracketToken],[]):ce(),!0}function Z(){switch(t.getToken()){case S.OpenBracketToken:return J();case S.OpenBraceToken:return U();case S.StringLiteral:return x(!0);default:return _()}}return ce(),t.getToken()===S.EOF?r.allowEmptyContent?!0:(le(y.ValueExpected,[],[]),!1):Z()?(t.getToken()!==S.EOF&&le(y.EndOfFileExpected,[],[]),!0):(le(y.ValueExpected,[],[]),!1)}function v(i,s){const r=A(i),t=[];let n,o=0,d;do switch(d=r.getPosition(),n=r.scan(),n){case S.LineCommentTrivia:case S.BlockCommentTrivia:case S.EOF:o!==d&&t.push(i.substring(o,d)),s!==void 0&&t.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(n!==S.EOF);return t.join("")}function a(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[76],oe([0,1,34]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=S,e.$7n=y,e.$8n=I,e.$9n=g;function S(c,l,u){let h,w,m,O,p;if(l){for(O=l.offset,p=O+l.length,m=O;m>0&&!g(c,m-1);)m--;let d=p;for(;d<c.length&&!g(c,d);)d++;w=c.substring(m,d),h=A(w,u)}else w=c,h=0,m=0,O=0,p=c.length;const f=I(u,c);let $=!1,P=0,v;u.insertSpaces?v=k(" ",u.tabSize||4):v="	";const a=(0,E.$Tn)(w,!1);let i=!1;function s(){return f+k(v,h+P)}function r(){let d=a.scan();for($=!1;d===E.SyntaxKind.Trivia||d===E.SyntaxKind.LineBreakTrivia;)$=$||d===E.SyntaxKind.LineBreakTrivia,d=a.scan();return i=d===E.SyntaxKind.Unknown||a.getTokenError()!==E.ScanError.None,d}const t=[];function n(d,R,N){!i&&R<p&&N>O&&c.substring(R,N)!==d&&t.push({offset:R,length:N-R,content:d})}let o=r();if(o!==E.SyntaxKind.EOF){const d=a.getTokenOffset()+m,R=k(v,h);n(R,m,d)}for(;o!==E.SyntaxKind.EOF;){let d=a.getTokenOffset()+a.getTokenLength()+m,R=r(),N="";for(;!$&&(R===E.SyntaxKind.LineCommentTrivia||R===E.SyntaxKind.BlockCommentTrivia);){const D=a.getTokenOffset()+m;n(" ",d,D),d=a.getTokenOffset()+a.getTokenLength()+m,N=R===E.SyntaxKind.LineCommentTrivia?s():"",R=r()}if(R===E.SyntaxKind.CloseBraceToken)o!==E.SyntaxKind.OpenBraceToken&&(P--,N=s());else if(R===E.SyntaxKind.CloseBracketToken)o!==E.SyntaxKind.OpenBracketToken&&(P--,N=s());else{switch(o){case E.SyntaxKind.OpenBracketToken:case E.SyntaxKind.OpenBraceToken:P++,N=s();break;case E.SyntaxKind.CommaToken:case E.SyntaxKind.LineCommentTrivia:N=s();break;case E.SyntaxKind.BlockCommentTrivia:$?N=s():N=" ";break;case E.SyntaxKind.ColonToken:N=" ";break;case E.SyntaxKind.StringLiteral:if(R===E.SyntaxKind.ColonToken){N="";break}case E.SyntaxKind.NullKeyword:case E.SyntaxKind.TrueKeyword:case E.SyntaxKind.FalseKeyword:case E.SyntaxKind.NumericLiteral:case E.SyntaxKind.CloseBraceToken:case E.SyntaxKind.CloseBracketToken:R===E.SyntaxKind.LineCommentTrivia||R===E.SyntaxKind.BlockCommentTrivia?N=" ":R!==E.SyntaxKind.CommaToken&&R!==E.SyntaxKind.EOF&&(i=!0);break;case E.SyntaxKind.Unknown:i=!0;break}$&&(R===E.SyntaxKind.LineCommentTrivia||R===E.SyntaxKind.BlockCommentTrivia)&&(N=s())}const C=a.getTokenOffset()+m;n(N,d,C),o=R}return t}function y(c,l){const u=JSON.stringify(c,void 0,l.insertSpaces?l.tabSize||4:"	");return l.eol!==void 0?u.replace(/\r\n|\r|\n/g,l.eol):u}function k(c,l){let u="";for(let h=0;h<l;h++)u+=c;return u}function A(c,l){let u=0,h=0;const w=l.tabSize||4;for(;u<c.length;){const m=c.charAt(u);if(m===" ")h++;else if(m==="	")h+=w;else break;u++}return Math.floor(h/w)}function I(c,l){for(let u=0;u<l.length;u++){const h=l.charAt(u);if(h==="\r")return u+1<l.length&&l.charAt(u+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return c&&c.eol||`
`}function g(c,l){return`\r
`.indexOf(c.charAt(l))!==-1}}),define(re[77],oe([0,1,34,76]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=y,e.$$n=k,e.$_n=A,e.$ao=I,e.$bo=g;function y(c,l,u){return k(c,l,void 0,u)}function k(c,l,u,h,w){const m=l.slice(),O=[],p=(0,E.$Wn)(c,O);let f,$;for(;m.length>0&&($=m.pop(),f=(0,E.$Xn)(p,m),f===void 0&&u!==void 0);)typeof $=="string"?u={[$]:u}:u=[u];if(f)if(f.type==="object"&&typeof $=="string"&&Array.isArray(f.children)){const P=(0,E.$Xn)(f,[$]);if(P!==void 0)if(u===void 0){if(!P.parent)throw new Error("Malformed AST");const v=f.children.indexOf(P.parent);let a,i=P.parent.offset+P.parent.length;if(v>0){const s=f.children[v-1];a=s.offset+s.length}else a=f.offset+1,f.children.length>1&&(i=f.children[1].offset);return A(c,{offset:a,length:i-a,content:""},h)}else return A(c,{offset:P.offset,length:P.length,content:JSON.stringify(u)},h);else{if(u===void 0)return[];const v=`${JSON.stringify($)}: ${JSON.stringify(u)}`,a=w?w(f.children.map(s=>s.children[0].value)):f.children.length;let i;if(a>0){const s=f.children[a-1];i={offset:s.offset+s.length,length:0,content:","+v}}else f.children.length===0?i={offset:f.offset+1,length:0,content:v}:i={offset:f.offset+1,length:0,content:v+","};return A(c,i,h)}}else if(f.type==="array"&&typeof $=="number"&&Array.isArray(f.children))if(u!==void 0){const P=`${JSON.stringify(u)}`;let v;if(f.children.length===0||$===0)v={offset:f.offset+1,length:0,content:f.children.length===0?P:P+","};else{const a=$===-1||$>f.children.length?f.children.length:$,i=f.children[a-1];v={offset:i.offset+i.length,length:0,content:","+P}}return A(c,v,h)}else{const P=$,v=f.children[P];let a;if(f.children.length===1)a={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===P){const i=f.children[P-1],s=i.offset+i.length,r=f.offset+f.length;a={offset:s,length:r-2-s,content:""}}else a={offset:v.offset,length:f.children[P+1].offset-v.offset,content:""};return A(c,a,h)}else throw new Error(`Can not add ${typeof $!="number"?"index":"property"} to parent of type ${f.type}`);else return u===void 0?[]:A(c,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(u)},h)}function A(c,l,u){let h=I(c,l),w=l.offset,m=l.offset+l.content.length;if(l.length===0||l.content.length===0){for(;w>0&&!(0,S.$9n)(h,w-1);)w--;for(;m<h.length&&!(0,S.$9n)(h,m);)m++}const O=(0,S.$6n)(h,{offset:w,length:m-w},u);for(let f=O.length-1;f>=0;f--){const $=O[f];h=I(h,$),w=Math.min(w,$.offset),m=Math.max(m,$.offset+$.length),m+=$.content.length-$.length}const p=c.length-(h.length-m)-w;return[{offset:w,length:p,content:h.substring(w,m)}]}function I(c,l){return c.substring(0,l.offset)+l.content+c.substring(l.offset+l.length)}function g(c,l){const u=l.slice(0).sort((w,m)=>{const O=w.offset-m.offset;return O===0?w.length-m.length:O});let h=c.length;for(let w=u.length-1;w>=0;w--){const m=u[w];if(m.offset+m.length<=h)c=I(c,m);else throw new Error("Overlapping edit");h=m.offset}return c}}),define(re[78],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=E,e.rot=S,e.$Pm=I;function E(g,c,l){return Math.min(Math.max(g,c),l)}function S(g,c){return(c+g%c)%c}class y{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=y;class k{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=k;class A{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const l=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function I(g,c,l,u,h,w,m,O){const p=m-l,f=O-u,$=h-l,P=w-u,v=g-l,a=c-u,i=p*p+f*f,s=p*$+f*P,r=p*v+f*a,t=$*$+P*P,n=$*v+P*a,o=1/(i*t-s*s),d=(t*r-s*n)*o,R=(i*n-s*r)*o;return d>=0&&R>=0&&d+R<1}}),function(){function H(y){const k=[];typeof y=="number"&&k.push("code/timeOrigin",y);function A(g){k.push(g,Date.now())}function I(){const g=[];for(let c=0;c<k.length;c+=2)g.push({name:k[c],startTime:k[c+1]});return g}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?H():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const A of performance.getEntriesByType("mark"))k.push({name:A.name,startTime:Math.round(y+A.startTime)});return k}};if(typeof process=="object"){const y=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return H(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),H()}function E(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=e()),y.MonacoPerformanceMarks}var S;typeof global=="object"?S=global:typeof self=="object"?S=self:S={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(S)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(S):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),S.perf=E(S))}(),function(H,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var S in E)(typeof exports=="object"?exports:H)[S]=E[S]}}(typeof self<"u"?self:this,function(){return function(H){var e={};function E(S){if(e[S])return e[S].exports;var y=e[S]={i:S,l:!1,exports:{}};return H[S].call(y.exports,y,y.exports,E),y.l=!0,y.exports}return E.m=H,E.c=e,E.d=function(S,y,k){E.o(S,y)||Object.defineProperty(S,y,{enumerable:!0,get:k})},E.r=function(S){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(S,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(S,"__esModule",{value:!0})},E.t=function(S,y){if(1&y&&(S=E(S)),8&y||4&y&&typeof S=="object"&&S&&S.__esModule)return S;var k=Object.create(null);if(E.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:S}),2&y&&typeof S!="string")for(var A in S)E.d(k,A,function(I){return S[I]}.bind(null,A));return k},E.n=function(S){var y=S&&S.__esModule?function(){return S.default}:function(){return S};return E.d(y,"a",y),y},E.o=function(S,y){return Object.prototype.hasOwnProperty.call(S,y)},E.p="",E(E.s=0)}([function(H,e,E){(function(S){var y;e=H.exports=z,y=typeof S=="object"&&S.env&&S.env.NODE_DEBUG&&/\bsemver\b/i.test(S.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],g=e.src=[],c=0,l=c++;g[l]="0|[1-9]\\d*";var u=c++;g[u]="[0-9]+";var h=c++;g[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=c++;g[w]="("+g[l]+")\\.("+g[l]+")\\.("+g[l]+")";var m=c++;g[m]="("+g[u]+")\\.("+g[u]+")\\.("+g[u]+")";var O=c++;g[O]="(?:"+g[l]+"|"+g[h]+")";var p=c++;g[p]="(?:"+g[u]+"|"+g[h]+")";var f=c++;g[f]="(?:-("+g[O]+"(?:\\."+g[O]+")*))";var $=c++;g[$]="(?:-?("+g[p]+"(?:\\."+g[p]+")*))";var P=c++;g[P]="[0-9A-Za-z-]+";var v=c++;g[v]="(?:\\+("+g[P]+"(?:\\."+g[P]+")*))";var a=c++,i="v?"+g[w]+g[f]+"?"+g[v]+"?";g[a]="^"+i+"$";var s="[v=\\s]*"+g[m]+g[$]+"?"+g[v]+"?",r=c++;g[r]="^"+s+"$";var t=c++;g[t]="((?:<|>)?=?)";var n=c++;g[n]=g[u]+"|x|X|\\*";var o=c++;g[o]=g[l]+"|x|X|\\*";var d=c++;g[d]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var R=c++;g[R]="[v=\\s]*("+g[n]+")(?:\\.("+g[n]+")(?:\\.("+g[n]+")(?:"+g[$]+")?"+g[v]+"?)?)?";var N=c++;g[N]="^"+g[t]+"\\s*"+g[d]+"$";var C=c++;g[C]="^"+g[t]+"\\s*"+g[R]+"$";var D=c++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=c++;g[T]="(?:~>?)";var M=c++;g[M]="(\\s*)"+g[T]+"\\s+",I[M]=new RegExp(g[M],"g");var K=c++;g[K]="^"+g[T]+g[d]+"$";var ae=c++;g[ae]="^"+g[T]+g[R]+"$";var ie=c++;g[ie]="(?:\\^)";var ue=c++;g[ue]="(\\s*)"+g[ie]+"\\s+",I[ue]=new RegExp(g[ue],"g");var ce=c++;g[ce]="^"+g[ie]+g[d]+"$";var le=c++;g[le]="^"+g[ie]+g[R]+"$";var x=c++;g[x]="^"+g[t]+"\\s*("+s+")$|^$";var _=c++;g[_]="^"+g[t]+"\\s*("+i+")$|^$";var B=c++;g[B]="(\\s*)"+g[t]+"\\s*("+s+"|"+g[d]+")",I[B]=new RegExp(g[B],"g");var U=c++;g[U]="^\\s*("+g[d]+")\\s+-\\s+("+g[d]+")\\s*$";var J=c++;g[J]="^\\s*("+g[R]+")\\s+-\\s+("+g[R]+")\\s*$";var Z=c++;g[Z]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)y(Y,g[Y]),I[Y]||(I[Y]=new RegExp(g[Y]));function j(W,ee){if(W instanceof z)return W;if(typeof W!="string"||W.length>k||!(ee?I[r]:I[a]).test(W))return null;try{return new z(W,ee)}catch{return null}}function z(W,ee){if(W instanceof z){if(W.loose===ee)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof z))return new z(W,ee);y("SemVer",W,ee),this.loose=ee;var te=W.trim().match(ee?I[r]:I[a]);if(!te)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+te[1],this.minor=+te[2],this.patch=+te[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");te[4]?this.prerelease=te[4].split(".").map(function(me){if(/^[0-9]+$/.test(me)){var be=+me;if(be>=0&&be<A)return be}return me}):this.prerelease=[],this.build=te[5]?te[5].split("."):[],this.format()}e.parse=j,e.valid=function(W,ee){var te=j(W,ee);return te?te.version:null},e.clean=function(W,ee){var te=j(W.trim().replace(/^[=v]+/,""),ee);return te?te.version:null},e.SemVer=z,z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},z.prototype.toString=function(){return this.version},z.prototype.compare=function(W){return y("SemVer.compare",this.version,this.loose,W),W instanceof z||(W=new z(W,this.loose)),this.compareMain(W)||this.comparePre(W)},z.prototype.compareMain=function(W){return W instanceof z||(W=new z(W,this.loose)),V(this.major,W.major)||V(this.minor,W.minor)||V(this.patch,W.patch)},z.prototype.comparePre=function(W){if(W instanceof z||(W=new z(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var ee=0;do{var te=this.prerelease[ee],me=W.prerelease[ee];if(y("prerelease compare",ee,te,me),te===void 0&&me===void 0)return 0;if(me===void 0)return 1;if(te===void 0)return-1;if(te!==me)return V(te,me)}while(++ee)},z.prototype.inc=function(W,ee){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var te=this.prerelease.length;--te>=0;)typeof this.prerelease[te]=="number"&&(this.prerelease[te]++,te=-2);te===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,ee,te,me){typeof te=="string"&&(me=te,te=void 0);try{return new z(W,te).inc(ee,me).version}catch{return null}},e.diff=function(W,ee){if(q(W,ee))return null;var te=j(W),me=j(ee);if(te.prerelease.length||me.prerelease.length){for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==me[be])return"pre"+be;return"prerelease"}for(var be in te)if((be==="major"||be==="minor"||be==="patch")&&te[be]!==me[be])return be},e.compareIdentifiers=V;var G=/^[0-9]+$/;function V(W,ee){var te=G.test(W),me=G.test(ee);return te&&me&&(W=+W,ee=+ee),te&&!me?-1:me&&!te?1:W<ee?-1:W>ee?1:0}function b(W,ee,te){return new z(W,te).compare(new z(ee,te))}function L(W,ee,te){return b(W,ee,te)>0}function F(W,ee,te){return b(W,ee,te)<0}function q(W,ee,te){return b(W,ee,te)===0}function Q(W,ee,te){return b(W,ee,te)!==0}function X(W,ee,te){return b(W,ee,te)>=0}function se(W,ee,te){return b(W,ee,te)<=0}function fe(W,ee,te,me){var be;switch(ee){case"===":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W===te;break;case"!==":typeof W=="object"&&(W=W.version),typeof te=="object"&&(te=te.version),be=W!==te;break;case"":case"=":case"==":be=q(W,te,me);break;case"!=":be=Q(W,te,me);break;case">":be=L(W,te,me);break;case">=":be=X(W,te,me);break;case"<":be=F(W,te,me);break;case"<=":be=se(W,te,me);break;default:throw new TypeError("Invalid operator: "+ee)}return be}function he(W,ee){if(W instanceof he){if(W.loose===ee)return W;W=W.value}if(!(this instanceof he))return new he(W,ee);y("comparator",W,ee),this.loose=ee,this.parse(W),this.semver===Ee?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}e.rcompareIdentifiers=function(W,ee){return V(ee,W)},e.major=function(W,ee){return new z(W,ee).major},e.minor=function(W,ee){return new z(W,ee).minor},e.patch=function(W,ee){return new z(W,ee).patch},e.compare=b,e.compareLoose=function(W,ee){return b(W,ee,!0)},e.rcompare=function(W,ee,te){return b(ee,W,te)},e.sort=function(W,ee){return W.sort(function(te,me){return e.compare(te,me,ee)})},e.rsort=function(W,ee){return W.sort(function(te,me){return e.rcompare(te,me,ee)})},e.gt=L,e.lt=F,e.eq=q,e.neq=Q,e.gte=X,e.lte=se,e.cmp=fe,e.Comparator=he;var Ee={};function pe(W,ee){if(W instanceof pe)return W.loose===ee?W:new pe(W.raw,ee);if(W instanceof he)return new pe(W.value,ee);if(!(this instanceof pe))return new pe(W,ee);if(this.loose=ee,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(te){return this.parseRange(te.trim())},this).filter(function(te){return te.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function ge(W){return!W||W.toLowerCase()==="x"||W==="*"}function de(W,ee,te,me,be,Ae,Ie,Ce,Re,Le,qe,De,Te){return((ee=ge(te)?"":ge(me)?">="+te+".0.0":ge(be)?">="+te+"."+me+".0":">="+ee)+" "+(Ce=ge(Re)?"":ge(Le)?"<"+(+Re+1)+".0.0":ge(qe)?"<"+Re+"."+(+Le+1)+".0":De?"<="+Re+"."+Le+"."+qe+"-"+De:"<="+Ce)).trim()}function $e(W,ee){for(var te=0;te<W.length;te++)if(!W[te].test(ee))return!1;if(ee.prerelease.length){for(te=0;te<W.length;te++)if(y(W[te].semver),W[te].semver!==Ee&&W[te].semver.prerelease.length>0){var me=W[te].semver;if(me.major===ee.major&&me.minor===ee.minor&&me.patch===ee.patch)return!0}return!1}return!0}function ve(W,ee,te){try{ee=new pe(ee,te)}catch{return!1}return ee.test(W)}function ke(W,ee,te,me){var be,Ae,Ie,Ce,Re;switch(W=new z(W,me),ee=new pe(ee,me),te){case">":be=L,Ae=se,Ie=F,Ce=">",Re=">=";break;case"<":be=F,Ae=X,Ie=L,Ce="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(W,ee,me))return!1;for(var Le=0;Le<ee.set.length;++Le){var qe=ee.set[Le],De=null,Te=null;if(qe.forEach(function(Fe){Fe.semver===Ee&&(Fe=new he(">=0.0.0")),De=De||Fe,Te=Te||Fe,be(Fe.semver,De.semver,me)?De=Fe:Ie(Fe.semver,Te.semver,me)&&(Te=Fe)}),De.operator===Ce||De.operator===Re||(!Te.operator||Te.operator===Ce)&&Ae(W,Te.semver)||Te.operator===Re&&Ie(W,Te.semver))return!1}return!0}he.prototype.parse=function(W){var ee=this.loose?I[x]:I[_],te=W.match(ee);if(!te)throw new TypeError("Invalid comparator: "+W);this.operator=te[1],this.operator==="="&&(this.operator=""),te[2]?this.semver=new z(te[2],this.loose):this.semver=Ee},he.prototype.toString=function(){return this.value},he.prototype.test=function(W){return y("Comparator.test",W,this.loose),this.semver===Ee||(typeof W=="string"&&(W=new z(W,this.loose)),fe(W,this.operator,this.semver,this.loose))},he.prototype.intersects=function(W,ee){if(!(W instanceof he))throw new TypeError("a Comparator is required");var te;if(this.operator==="")return te=new pe(W.value,ee),ve(this.value,te,ee);if(W.operator==="")return te=new pe(this.value,ee),ve(W.semver,te,ee);var me=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Ae=this.semver.version===W.semver.version,Ie=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ce=fe(this.semver,"<",W.semver,ee)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Re=fe(this.semver,">",W.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return me||be||Ae&&Ie||Ce||Re},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(W){var ee=this.loose;W=W.trim(),y("range",W,ee);var te=ee?I[J]:I[U];W=W.replace(te,de),y("hyphen replace",W),W=W.replace(I[B],"$1$2$3"),y("comparator trim",W,I[B]),W=(W=(W=W.replace(I[M],"$1~")).replace(I[ue],"$1^")).split(/\s+/).join(" ");var me=ee?I[x]:I[_],be=W.split(" ").map(function(Ae){return function(Ie,Ce){return y("comp",Ie),Ie=function(Re,Le){return Re.trim().split(/\s+/).map(function(qe){return function(De,Te){y("caret",De,Te);var Fe=Te?I[le]:I[ce];return De.replace(Fe,function(Ue,Se,Pe,Oe,Ne){var je;return y("caret",De,Ue,Se,Pe,Oe,Ne),ge(Se)?je="":ge(Pe)?je=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(Oe)?je=Se==="0"?">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+".0 <"+(+Se+1)+".0.0":Ne?(y("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+Pe+"."+(+Oe+1):">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Oe+Ne+" <"+(+Se+1)+".0.0"):(y("no pr"),je=Se==="0"?Pe==="0"?">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+Pe+"."+(+Oe+1):">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+(+Pe+1)+".0":">="+Se+"."+Pe+"."+Oe+" <"+(+Se+1)+".0.0"),y("caret return",je),je})}(qe,Le)}).join(" ")}(Ie,Ce),y("caret",Ie),Ie=function(Re,Le){return Re.trim().split(/\s+/).map(function(qe){return function(De,Te){var Fe=Te?I[ae]:I[K];return De.replace(Fe,function(Ue,Se,Pe,Oe,Ne){var je;return y("tilde",De,Ue,Se,Pe,Oe,Ne),ge(Se)?je="":ge(Pe)?je=">="+Se+".0.0 <"+(+Se+1)+".0.0":ge(Oe)?je=">="+Se+"."+Pe+".0 <"+Se+"."+(+Pe+1)+".0":Ne?(y("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=">="+Se+"."+Pe+"."+Oe+Ne+" <"+Se+"."+(+Pe+1)+".0"):je=">="+Se+"."+Pe+"."+Oe+" <"+Se+"."+(+Pe+1)+".0",y("tilde return",je),je})}(qe,Le)}).join(" ")}(Ie,Ce),y("tildes",Ie),Ie=function(Re,Le){return y("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(qe){return function(De,Te){De=De.trim();var Fe=Te?I[C]:I[N];return De.replace(Fe,function(Ue,Se,Pe,Oe,Ne,je){y("xRange",De,Ue,Se,Pe,Oe,Ne,je);var Ve=ge(Pe),Me=Ve||ge(Oe),Be=Me||ge(Ne);return Se==="="&&Be&&(Se=""),Ve?Ue=Se===">"||Se==="<"?"<0.0.0":"*":Se&&Be?(Me&&(Oe=0),Be&&(Ne=0),Se===">"?(Se=">=",Me?(Pe=+Pe+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Se==="<="&&(Se="<",Me?Pe=+Pe+1:Oe=+Oe+1),Ue=Se+Pe+"."+Oe+"."+Ne):Me?Ue=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Be&&(Ue=">="+Pe+"."+Oe+".0 <"+Pe+"."+(+Oe+1)+".0"),y("xRange return",Ue),Ue})}(qe,Le)}).join(" ")}(Ie,Ce),y("xrange",Ie),Ie=function(Re,Le){return y("replaceStars",Re,Le),Re.trim().replace(I[Z],"")}(Ie,Ce),y("stars",Ie),Ie}(Ae,ee)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Ae){return!!Ae.match(me)})),be=be.map(function(Ae){return new he(Ae,ee)})},pe.prototype.intersects=function(W,ee){if(!(W instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(te){return te.every(function(me){return W.set.some(function(be){return be.every(function(Ae){return me.intersects(Ae,ee)})})})})},e.toComparators=function(W,ee){return new pe(W,ee).set.map(function(te){return te.map(function(me){return me.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new z(W,this.loose));for(var ee=0;ee<this.set.length;ee++)if($e(this.set[ee],W))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(W,ee,te){var me=null,be=null;try{var Ae=new pe(ee,te)}catch{return null}return W.forEach(function(Ie){Ae.test(Ie)&&(me&&be.compare(Ie)!==-1||(be=new z(me=Ie,te)))}),me},e.minSatisfying=function(W,ee,te){var me=null,be=null;try{var Ae=new pe(ee,te)}catch{return null}return W.forEach(function(Ie){Ae.test(Ie)&&(me&&be.compare(Ie)!==1||(be=new z(me=Ie,te)))}),me},e.validRange=function(W,ee){try{return new pe(W,ee).range||"*"}catch{return null}},e.ltr=function(W,ee,te){return ke(W,ee,"<",te)},e.gtr=function(W,ee,te){return ke(W,ee,">",te)},e.outside=ke,e.prerelease=function(W,ee){var te=j(W,ee);return te&&te.prerelease.length?te.prerelease:null},e.intersects=function(W,ee,te){return W=new pe(W,te),ee=new pe(ee,te),W.intersects(ee)},e.coerce=function(W){if(W instanceof z)return W;if(typeof W!="string")return null;var ee=W.match(I[D]);return ee==null?null:j((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,E(1))},function(H,e){var E,S,y=H.exports={};function k(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(p){if(E===setTimeout)return setTimeout(p,0);if((E===k||!E)&&setTimeout)return E=setTimeout,setTimeout(p,0);try{return E(p,0)}catch{try{return E.call(null,p,0)}catch{return E.call(this,p,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:k}catch{E=k}try{S=typeof clearTimeout=="function"?clearTimeout:A}catch{S=A}})();var g,c=[],l=!1,u=-1;function h(){l&&g&&(l=!1,g.length?c=g.concat(c):u=-1,c.length&&w())}function w(){if(!l){var p=I(h);l=!0;for(var f=c.length;f;){for(g=c,c=[];++u<f;)g&&g[u].run();u=-1,f=c.length}g=null,l=!1,function($){if(S===clearTimeout)return clearTimeout($);if((S===A||!S)&&clearTimeout)return S=clearTimeout,clearTimeout($);try{S($)}catch{try{return S.call(null,$)}catch{return S.call(this,$)}}}(p)}}function m(p,f){this.fun=p,this.array=f}function O(){}y.nextTick=function(p){var f=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)f[$-1]=arguments[$];c.push(new m(p,f)),c.length!==1||l||I(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=O,y.addListener=O,y.once=O,y.off=O,y.removeListener=O,y.removeAllListeners=O,y.emit=O,y.prependListener=O,y.prependOnceListener=O,y.listeners=function(p){return[]},y.binding=function(p){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(p){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(re[79],oe([0,1]),function(H,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;class S{constructor(I,g,c){this.level=I,this.key=g,this.value=c,this.forward=[]}}const y=void 0;class k{constructor(I,g=2**16){this.comparator=I,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new S(this.c,y,y)}get size(){return this.f}clear(){this.e=new S(this.c,y,y),this.f=0}has(I){return!!k.g(this,I,this.comparator)}get(I){return k.g(this,I,this.comparator)?.value}set(I,g){return k.h(this,I,g,this.comparator)&&(this.f+=1),this}delete(I){const g=k.k(this,I,this.comparator);return g&&(this.f-=1),g}forEach(I,g){let c=this.e.forward[0];for(;c;)I.call(g,c.value,c.key,this),c=c.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",g=this.e.forward[0];for(;g;)I+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return I}static g(I,g,c){let l=I.e;for(let u=I.d-1;u>=0;u--)for(;l.forward[u]&&c(l.forward[u].key,g)<0;)l=l.forward[u];if(l=l.forward[0],l&&c(l.key,g)===0)return l}static h(I,g,c,l){const u=[];let h=I.e;for(let w=I.d-1;w>=0;w--){for(;h.forward[w]&&l(h.forward[w].key,g)<0;)h=h.forward[w];u[w]=h}if(h=h.forward[0],h&&l(h.key,g)===0)return h.value=c,!1;{const w=k.j(I);if(w>I.d){for(let m=I.d;m<w;m++)u[m]=I.e;I.d=w}h=new S(w,g,c);for(let m=0;m<w;m++)h.forward[m]=u[m].forward[m],u[m].forward[m]=h;return!0}}static j(I,g=.5){let c=1;for(;Math.random()<g&&c<I.c;)c+=1;return c}static k(I,g,c){const l=[];let u=I.e;for(let h=I.d-1;h>=0;h--){for(;u.forward[h]&&c(u.forward[h].key,g)<0;)u=u.forward[h];l[h]=u}if(u=u.forward[0],!u||c(u.key,g)!==0)return!1;for(let h=0;h<I.d&&l[h].forward[h]===u;h++)l[h].forward[h]=u.forward[h];for(;I.d>0&&I.e.forward[I.d-1]===y;)I.d-=1;return!0}}e.$Ns=k}),define(re[46],oe([0,1,9,2]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=y,e.$Ae=k,e.$Be=A,e.$Ce=I,e.$De=c,e.$Ee=l,e.$Fe=u,e.$Ge=h,e.$He=w,e.$Ie=m,e.$Je=O,e.$Ke=p,e.$Le=f,e.$Me=$,e.$Ne=P;function y(v){const a=v;return a?typeof a.read=="function":!1}function k(v){const a=v;return a?[a.on,a.pause,a.resume,a.destroy].every(i=>typeof i=="function"):!1}function A(v){const a=v;return a?k(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function I(v,a){return new g(v,a)}class g{constructor(a,i){this.e=a,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(i=>i(a))}h(a){this.c.error.length===0?(0,E.$3)(a):this.c.error.slice(0).forEach(i=>i(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,i){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(a,i){if(this.a.destroyed)return;let s;switch(a){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(i);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(v,a){const i=[];let s;for(;(s=v.read())!==null;)i.push(s);return a(i)}function l(v,a,i){const s=[];let r;for(;(r=v.read())!==null&&s.length<i;)s.push(r);return r===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const t=r;return r=void 0,t}return v.read()}}}function u(v,a){return new Promise((i,s)=>{const r=[];h(v,{onData:t=>{a&&r.push(t)},onError:t=>{a?s(t):i(void 0)},onEnd:()=>{i(a?a(r):void 0)}})})}function h(v,a,i){v.on("error",s=>{i?.isCancellationRequested||a.onError(s)}),v.on("end",()=>{i?.isCancellationRequested||a.onEnd()}),v.on("data",s=>{i?.isCancellationRequested||a.onData(s)})}function w(v,a){return new Promise((i,s)=>{const r=new S.$Vc,t=[],n=R=>{if(t.push(R),t.length>a)return r.dispose(),v.pause(),i({stream:v,buffer:t,ended:!1})},o=R=>(r.dispose(),s(R)),d=()=>(r.dispose(),i({stream:v,buffer:t,ended:!0}));r.add((0,S.$Uc)(()=>v.removeListener("error",o))),v.on("error",o),r.add((0,S.$Uc)(()=>v.removeListener("end",d))),v.on("end",d),r.add((0,S.$Uc)(()=>v.removeListener("data",n))),v.on("data",n)})}function m(v,a){const i=I(a);return i.end(v),i}function O(){const v=I(()=>{throw new Error("not supported")});return v.end(),v}function p(v){let a=!1;return{read:()=>a?null:(a=!0,v)}}function f(v,a,i){const s=I(i);return h(v,{onData:r=>s.write(a.data(r)),onError:r=>s.error(a.error?a.error(r):r),onEnd:()=>s.end()}),s}function $(v,a,i){let s=!1;return{read:()=>{const r=a.read();return s?r:(s=!0,r!==null?i([v,r]):v)}}}function P(v,a,i){let s=!1;const r=I(i);return h(a,{onData:t=>s?r.write(t):(s=!0,r.write(i([v,t]))),onError:t=>r.error(t),onEnd:()=>{s||(s=!0,r.write(v)),r.end()}}),r}});var We=this&&this.__createBinding||(Object.create?function(H,e,E,S){S===void 0&&(S=E);var y=Object.getOwnPropertyDescriptor(e,E);(!y||("get"in y?!e.__esModule:y.writable||y.configurable))&&(y={enumerable:!0,get:function(){return e[E]}}),Object.defineProperty(H,S,y)}:function(H,e,E,S){S===void 0&&(S=E),H[S]=e[E]}),xe=this&&this.__setModuleDefault||(Object.create?function(H,e){Object.defineProperty(H,"default",{enumerable:!0,value:e})}:function(H,e){H.default=e}),ye=this&&this.__importStar||function(H){if(H&&H.__esModule)return H;var e={};if(H!=null)for(var E in H)E!=="default"&&Object.prototype.hasOwnProperty.call(H,E)&&We(e,H,E);return xe(e,H),e};define(re[14],oe([0,1,170,46]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=c,e.$Qe=l,e.$Re=u,e.$Se=h,e.$Te=w,e.$Ue=m,e.$Ve=O,e.$We=p,e.$Xe=f,e.$Ye=$,e.$Ze=P,e.$1e=v,e.$2e=a,e.$3e=i,e.$4e=s,e.$5e=r,e.$6e=t,e.$7e=n,e.$8e=o,e.$9e=N,S=ye(S);const y=typeof Buffer<"u",k=new E.$X(()=>new Uint8Array(256));let A,I;class g{static alloc(D){return y?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return y&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,T){return!(T?.dontUseNodeBuffer||!1)&&y?new g(Buffer.from(D)):(A||(A=new TextEncoder),new g(A.encode(D)))}static fromByteArray(D){const T=g.alloc(D.length);for(let M=0,K=D.length;M<K;M++)T.buffer[M]=D[M];return T}static concat(D,T){if(typeof T>"u"){T=0;for(let ae=0,ie=D.length;ae<ie;ae++)T+=D[ae].byteLength}const M=g.alloc(T);let K=0;for(let ae=0,ie=D.length;ae<ie;ae++){const ue=D[ae];M.set(ue,K),K+=ue.byteLength}return M}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return y?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(D,T){return new g(this.buffer.subarray(D,T))}set(D,T){if(D instanceof g)this.buffer.set(D.buffer,T);else if(D instanceof Uint8Array)this.buffer.set(D,T);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),T);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return h(this.buffer,D)}writeUInt32BE(D,T){w(this.buffer,D,T)}readUInt32LE(D){return m(this.buffer,D)}writeUInt32LE(D,T){O(this.buffer,D,T)}readUInt8(D){return p(this.buffer,D)}writeUInt8(D,T){f(this.buffer,D,T)}indexOf(D,T=0){return c(this.buffer,D instanceof g?D.buffer:D,T)}}e.$Oe=g;function c(C,D,T=0){const M=D.byteLength,K=C.byteLength;if(M===0)return 0;if(M===1)return C.indexOf(D[0]);if(M>K-T)return-1;const ae=k.value;ae.fill(D.length);for(let le=0;le<D.length;le++)ae[D[le]]=D.length-le-1;let ie=T+D.length-1,ue=ie,ce=-1;for(;ie<K;)if(C[ie]===D[ue]){if(ue===0){ce=ie;break}ie--,ue--}else ie+=Math.max(D.length-ue,ae[C[ie]]),ue=D.length-1;return ce}function l(C,D){return C[D+0]<<0>>>0|C[D+1]<<8>>>0}function u(C,D,T){C[T+0]=D&255,D=D>>>8,C[T+1]=D&255}function h(C,D){return C[D]*2**24+C[D+1]*2**16+C[D+2]*2**8+C[D+3]}function w(C,D,T){C[T+3]=D,D=D>>>8,C[T+2]=D,D=D>>>8,C[T+1]=D,D=D>>>8,C[T]=D}function m(C,D){return C[D+0]<<0>>>0|C[D+1]<<8>>>0|C[D+2]<<16>>>0|C[D+3]<<24>>>0}function O(C,D,T){C[T+0]=D&255,D=D>>>8,C[T+1]=D&255,D=D>>>8,C[T+2]=D&255,D=D>>>8,C[T+3]=D&255}function p(C,D){return C[D]}function f(C,D,T){C[T]=D}function $(C){return S.$De(C,D=>g.concat(D))}function P(C){return S.$Ke(C)}function v(C){return S.$Fe(C,D=>g.concat(D))}async function a(C){return C.ended?g.concat(C.buffer):g.concat([...C.buffer,await v(C.stream)])}function i(C){return S.$Ie(C,D=>g.concat(D))}function s(C){return S.$Le(C,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}function r(C){return S.$Ce(D=>g.concat(D),C)}function t(C,D){return S.$Me(C,D,T=>g.concat(T))}function n(C,D){return S.$Ne(C,D,T=>g.concat(T))}function o(C){let D=0,T=0,M=0;const K=new Uint8Array(Math.floor(C.length/4*3)),ae=ue=>{switch(T){case 3:K[M++]=D|ue,T=0;break;case 2:K[M++]=D|ue>>>2,D=ue<<6,T=3;break;case 1:K[M++]=D|ue>>>4,D=ue<<4,T=2;break;default:D=ue<<2,T=1}};for(let ue=0;ue<C.length;ue++){const ce=C.charCodeAt(ue);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${C[ue]}`)}}const ie=M;for(;T>0;)ae(0);return g.wrap(K).slice(0,ie)}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:C},D=!0,T=!1){const M=T?R:d;let K="";const ae=C.byteLength%3;let ie=0;for(;ie<C.byteLength-ae;ie+=3){const ue=C[ie+0],ce=C[ie+1],le=C[ie+2];K+=M[ue>>>2],K+=M[(ue<<4|ce>>>4)&63],K+=M[(ce<<2|le>>>6)&63],K+=M[le&63]}if(ae===1){const ue=C[ie+0];K+=M[ue>>>2],K+=M[ue<<4&63],D&&(K+="==")}else if(ae===2){const ue=C[ie+0],ce=C[ie+1];K+=M[ue>>>2],K+=M[(ue<<4|ce>>>4)&63],K+=M[ce<<2&63],D&&(K+="=")}return K}}),define(re[28],oe([0,1,3]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=S,e.$do=y,e.$eo=A,e.$fo=g,e.$go=c,e.$ho=l,e.$io=u,e.$jo=h,e.$ko=w,e.$lo=m,e.$mo=O,e.$no=p,e.$oo=f;function S($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const P=Array.isArray($)?[]:{};return Object.entries($).forEach(([v,a])=>{P[v]=a&&typeof a=="object"?S(a):a}),P}function y($){if(!$||typeof $!="object")return $;const P=[$];for(;P.length>0;){const v=P.shift();Object.freeze(v);for(const a in v)if(k.call(v,a)){const i=v[a];typeof i=="object"&&!Object.isFrozen(i)&&!(0,E.$ig)(i)&&P.push(i)}}return $}const k=Object.prototype.hasOwnProperty;function A($,P){return I($,P,new Set)}function I($,P,v){if((0,E.$og)($))return $;const a=P($);if(typeof a<"u")return a;if(Array.isArray($)){const i=[];for(const s of $)i.push(I(s,P,v));return i}if((0,E.$hg)($)){if(v.has($))throw new Error("Cannot clone recursive data-structure");v.add($);const i={};for(const s in $)k.call($,s)&&(i[s]=I($[s],P,v));return v.delete($),i}return $}function g($,P,v=!0){return(0,E.$hg)($)?((0,E.$hg)(P)&&Object.keys(P).forEach(a=>{a in $?v&&((0,E.$hg)($[a])&&(0,E.$hg)(P[a])?g($[a],P[a],v):$[a]=P[a]):$[a]=P[a]}),$):P}function c($,P){if($===P)return!0;if($==null||P===null||P===void 0||typeof $!=typeof P||typeof $!="object"||Array.isArray($)!==Array.isArray(P))return!1;let v,a;if(Array.isArray($)){if($.length!==P.length)return!1;for(v=0;v<$.length;v++)if(!c($[v],P[v]))return!1}else{const i=[];for(a in $)i.push(a);i.sort();const s=[];for(a in P)s.push(a);if(s.sort(),!c(i,s))return!1;for(v=0;v<i.length;v++)if(!c($[i[v]],P[i[v]]))return!1}return!0}function l($){const P=new Set;return JSON.stringify($,(v,a)=>{if((0,E.$hg)(a)||Array.isArray(a)){if(P.has(a))return"[Circular]";P.add(a)}return typeof a=="bigint"?`[BigInt ${a.toString()}]`:a})}function u($,P){const v=Object.create(null);return!$||!P||Object.keys(P).forEach(i=>{const s=$[i],r=P[i];c(s,r)||(v[i]=r)}),v}function h($,P){const v=P.toLowerCase(),a=Object.keys($).find(i=>i.toLowerCase()===v);return a?$[a]:$[P]}function w($,P){const v=Object.create(null);for(const[a,i]of Object.entries($))P(a,i)&&(v[a]=i);return v}function m($){let P=[];for(;Object.prototype!==$;)P=P.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return P}function O($){const P=[];for(const v of m($))typeof $[v]=="function"&&P.push(v);return P}function p($,P){const v=i=>function(){const s=Array.prototype.slice.call(arguments,0);return P(i,s)},a={};for(const i of $)a[i]=v(i);return a}function f($,P){const v={};for(const[a,i]of Object.entries($))v[a]=P(i,a);return v}}),define(re[43],oe([0,1,32]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=S,e.$uj=y,e.$vj=k,e.$wj=I,e.$yj=O,E=ye(E);function S(f){return y(f,0)}function y(f,$){switch(typeof f){case"object":return f===null?k(349,$):Array.isArray(f)?g(f,$):c(f,$);case"string":return I(f,$);case"boolean":return A(f,$);case"number":return k(f,$);case"undefined":return k(937,$);default:return k(617,$)}}function k(f,$){return($<<5)-$+f|0}function A(f,$){return k(f?433:863,$)}function I(f,$){$=k(149417,$);for(let P=0,v=f.length;P<v;P++)$=k(f.charCodeAt(P),$);return $}function g(f,$){return $=k(104579,$),f.reduce((P,v)=>y(v,P),$)}function c(f,$){return $=k(181387,$),Object.keys(f).sort().reduce((P,v)=>(P=I(v,P),y(f[v],P)),$)}class l{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}e.$xj=l;var u;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(u||(u={}));function h(f,$,P=32){const v=P-$,a=~((1<<v)-1);return(f<<$|(a&f)>>>v)>>>0}function w(f,$=0,P=f.byteLength,v=0){for(let a=0;a<P;a++)f[$+a]=v}function m(f,$,P="0"){for(;f.length<$;)f=P+f;return f}function O(f,$=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(P=>P.toString(16).padStart(2,"0")).join(""):m((f>>>0).toString(16),$/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(u.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const P=$.length;if(P===0)return;const v=this.p;let a=this.r,i=this.u,s,r;for(i!==0?(s=i,r=-1,i=0):(s=$.charCodeAt(0),r=0);;){let t=s;if(E.$Kf(s))if(r+1<P){const n=$.charCodeAt(r+1);E.$Lf(n)?(r++,t=E.$Mf(s,n)):t=u.UNICODE_REPLACEMENT}else{i=s;break}else E.$Lf(s)&&(t=u.UNICODE_REPLACEMENT);if(a=this.w(v,a,t),r++,r<P)s=$.charCodeAt(r);else break}this.r=a,this.u=i}w($,P,v){return v<128?$[P++]=v:v<2048?($[P++]=192|(v&1984)>>>6,$[P++]=128|(v&63)>>>0):v<65536?($[P++]=224|(v&61440)>>>12,$[P++]=128|(v&4032)>>>6,$[P++]=128|(v&63)>>>0):($[P++]=240|(v&1835008)>>>18,$[P++]=128|(v&258048)>>>12,$[P++]=128|(v&4032)>>>6,$[P++]=128|(v&63)>>>0),P>=u.BLOCK_SIZE&&(this.y(),P-=u.BLOCK_SIZE,this.t+=u.BLOCK_SIZE,$[0]=$[u.BLOCK_SIZE+0],$[1]=$[u.BLOCK_SIZE+1],$[2]=$[u.BLOCK_SIZE+2]),P}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,u.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=p.g,P=this.q;for(let d=0;d<64;d+=4)$.setUint32(d,P.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)$.setUint32(d,h($.getUint32(d-12,!1)^$.getUint32(d-32,!1)^$.getUint32(d-56,!1)^$.getUint32(d-64,!1),1),!1);let v=this.h,a=this.l,i=this.m,s=this.n,r=this.o,t,n,o;for(let d=0;d<80;d++)d<20?(t=a&i|~a&s,n=1518500249):d<40?(t=a^i^s,n=1859775393):d<60?(t=a&i|a&s|i&s,n=2400959708):(t=a^i^s,n=3395469782),o=h(v,5)+t+r+n+$.getUint32(d*4,!1)&4294967295,r=s,s=i,i=h(a,30),a=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+a&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.$zj=p}),define(re[56],oe([0,1,32]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),E=ye(E);var S;(function(y){y[y.Ignore=0]="Ignore",y[y.Info=1]="Info",y[y.Warning=2]="Warning",y[y.Error=3]="Error"})(S||(S={})),function(y){const k="error",A="warning",I="warn",g="info",c="ignore";function l(h){return h?E.$Gf(k,h)?y.Error:E.$Gf(A,h)||E.$Gf(I,h)?y.Warning:E.$Gf(g,h)?y.Info:y.Ignore:y.Ignore}y.fromValue=l;function u(h){switch(h){case y.Error:return k;case y.Warning:return A;case y.Info:return g;default:return c}}y.toString=u}(S||(S={})),e.default=S}),define(re[29],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=S;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function S(y){return E.test(y)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(I){for(let g=0;g<I.length;g++)I[g]=Math.floor(Math.random()*256);return I};const k=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){y(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,c="";return c+=A[k[g++]],c+=A[k[g++]],c+=A[k[g++]],c+=A[k[g++]],c+="-",c+=A[k[g++]],c+=A[k[g++]],c+="-",c+=A[k[g++]],c+=A[k[g++]],c+="-",c+=A[k[g++]],c+=A[k[g++]],c+="-",c+=A[k[g++]],c+=A[k[g++]],c+=A[k[g++]],c+=A[k[g++]],c+=A[k[g++]],c+=A[k[g++]],c}}()}),define(re[80],oe([0,1,35]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=k;const S=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function y(A){const I=A.replace(/\-/g,":").toLowerCase();return!S.has(I)}function k(){const A=(0,E.networkInterfaces)();for(const I in A){const g=A[I];if(g){for(const{mac:c}of g)if(y(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[81],oe([7,4]),function(H,e){return H.create("vs/base/common/date",e)}),define(re[82],oe([0,1,81]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=c,e.$2m=l,e.$3m=u;const S=60,y=S*60,k=y*24,A=k*7,I=k*30,g=k*365;function c(h,w,m,O){typeof h!="number"&&(h=h.getTime());const p=Math.round((new Date().getTime()-h)/1e3);if(p<-30)return(0,E.localize)(0,null,c(new Date().getTime()+p*1e3,!1));if(!O&&p<30)return(0,E.localize)(1,null);let f;return p<S?(f=p,w?f===1?m?(0,E.localize)(2,null,f):(0,E.localize)(3,null,f):m?(0,E.localize)(4,null,f):(0,E.localize)(5,null,f):f===1?m?(0,E.localize)(6,null,f):(0,E.localize)(7,null,f):m?(0,E.localize)(8,null,f):(0,E.localize)(9,null,f)):p<y?(f=Math.floor(p/S),w?f===1?m?(0,E.localize)(10,null,f):(0,E.localize)(11,null,f):m?(0,E.localize)(12,null,f):(0,E.localize)(13,null,f):f===1?m?(0,E.localize)(14,null,f):(0,E.localize)(15,null,f):m?(0,E.localize)(16,null,f):(0,E.localize)(17,null,f)):p<k?(f=Math.floor(p/y),w?f===1?m?(0,E.localize)(18,null,f):(0,E.localize)(19,null,f):m?(0,E.localize)(20,null,f):(0,E.localize)(21,null,f):f===1?m?(0,E.localize)(22,null,f):(0,E.localize)(23,null,f):m?(0,E.localize)(24,null,f):(0,E.localize)(25,null,f)):p<A?(f=Math.floor(p/k),w?f===1?(0,E.localize)(26,null,f):(0,E.localize)(27,null,f):f===1?(0,E.localize)(28,null,f):(0,E.localize)(29,null,f)):p<I?(f=Math.floor(p/A),w?f===1?m?(0,E.localize)(30,null,f):(0,E.localize)(31,null,f):m?(0,E.localize)(32,null,f):(0,E.localize)(33,null,f):f===1?m?(0,E.localize)(34,null,f):(0,E.localize)(35,null,f):m?(0,E.localize)(36,null,f):(0,E.localize)(37,null,f)):p<g?(f=Math.floor(p/I),w?f===1?m?(0,E.localize)(38,null,f):(0,E.localize)(39,null,f):m?(0,E.localize)(40,null,f):(0,E.localize)(41,null,f):f===1?m?(0,E.localize)(42,null,f):(0,E.localize)(43,null,f):m?(0,E.localize)(44,null,f):(0,E.localize)(45,null,f)):(f=Math.floor(p/g),w?f===1?m?(0,E.localize)(46,null,f):(0,E.localize)(47,null,f):m?(0,E.localize)(48,null,f):(0,E.localize)(49,null,f):f===1?m?(0,E.localize)(50,null,f):(0,E.localize)(51,null,f):m?(0,E.localize)(52,null,f):(0,E.localize)(53,null,f))}function l(h,w){const m=Math.abs(h/1e3);return m<1?w?(0,E.localize)(54,null,h):(0,E.localize)(55,null,h):m<S?w?(0,E.localize)(56,null,Math.round(h)/1e3):(0,E.localize)(57,null,Math.round(h)/1e3):m<y?w?(0,E.localize)(58,null,Math.round(h/(1e3*S))):(0,E.localize)(59,null,Math.round(h/(1e3*S))):m<k?w?(0,E.localize)(60,null,Math.round(h/(1e3*y))):(0,E.localize)(61,null,Math.round(h/(1e3*y))):(0,E.localize)(62,null,Math.round(h/(1e3*k)))}function u(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[83],oe([7,4]),function(H,e){return H.create("vs/base/common/errorMessage",e)}),define(re[38],oe([0,1,20,3,83]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=g,e.$rj=c,e.$sj=l,E=ye(E),S=ye(S),y=ye(y);function k(u,h){return h&&(u.stack||u.stacktrace)?y.localize(0,null,I(u),A(u.stack)||A(u.stacktrace)):I(u)}function A(u){return Array.isArray(u)?u.join(`
`):u}function I(u){return u.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof u.code=="string"&&typeof u.errno=="number"&&typeof u.syscall=="string"?y.localize(1,null,u.message):u.message||y.localize(2,null)}function g(u=null,h=!1){if(!u)return y.localize(3,null);if(Array.isArray(u)){const w=E.$Jb(u),m=g(w[0],h);return w.length>1?y.localize(4,null,m,w.length):m}if(S.$fg(u))return u;if(u.detail){const w=u.detail;if(w.error)return k(w.error,h);if(w.exception)return k(w.exception,h)}return u.stack?k(u,h):u.message?u.message:y.localize(5,null)}function c(u){const h=u;return h instanceof Error&&Array.isArray(h.actions)}function l(u,h){let w;return typeof u=="string"?w=new Error(u):w=u,w.actions=h,w}}),define(re[84],oe([7,4]),function(H,e){return H.create("vs/base/common/jsonErrorMessages",e)}),define(re[85],oe([0,1,84,34]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=y;function y(k){switch(k){case S.ParseErrorCode.InvalidSymbol:return(0,E.localize)(0,null);case S.ParseErrorCode.InvalidNumberFormat:return(0,E.localize)(1,null);case S.ParseErrorCode.PropertyNameExpected:return(0,E.localize)(2,null);case S.ParseErrorCode.ValueExpected:return(0,E.localize)(3,null);case S.ParseErrorCode.ColonExpected:return(0,E.localize)(4,null);case S.ParseErrorCode.CommaExpected:return(0,E.localize)(5,null);case S.ParseErrorCode.CloseBraceExpected:return(0,E.localize)(6,null);case S.ParseErrorCode.CloseBracketExpected:return(0,E.localize)(7,null);case S.ParseErrorCode.EndOfFileExpected:return(0,E.localize)(8,null);default:return""}}}),define(re[57],oe([0,1,13]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=k,e.$lm=A;var S;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(S||(e.Source=S={}));var y;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(y||(e.TerminateResponseCode=y={}));function k(I,...g){const c=g.reduce((h,w)=>(h[w]=!0,h),{}),l=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(h=>!c[h]).forEach(h=>{for(let w=0;w<l.length;w++)if(h.search(l[w])!==-1){delete I[h];break}})}function A(I){I&&(delete I.DEBUG,E.$j&&delete I.DYLD_LIBRARY_PATH,E.$k&&delete I.LD_PRELOAD)}}),define(re[86],oe([0,1,12]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=S,e.$$q=y,e.$_q=k,e.log=I;function S(c){const l=c;return l&&typeof l.type=="string"&&typeof l.severity=="string"}function y(c){const l=[];let u;try{const h=JSON.parse(c.arguments),w=h[h.length-1];w&&w.__$stack&&(h.pop(),u=w.__$stack),l.push(...h)}catch{l.push("Unable to log remote console arguments",c.arguments)}return{args:l,stack:u}}function k(c){if(typeof c!="string")return k(y(c).stack);const l=c;if(l){const u=A(l),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(u||"");if(h&&h.length===4)return{uri:E.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function A(c){if(!c)return c;const l=c.indexOf(`
`);return l===-1?c:c.substring(0,l)}function I(c,l){const{args:u,stack:h}=y(c),w=typeof u[0]=="string"&&u.length===1;let m=A(h);m&&(m=`(${m.trim()})`);let O=[];if(typeof u[0]=="string"?m&&w?O=[`%c[${l}] %c${u[0]} %c${m}`,g("blue"),g(""),g("grey")]:O=[`%c[${l}] %c${u[0]}`,g("blue"),g(""),...u.slice(1)]:O=[`%c[${l}]%`,g("blue"),...u],m&&!w&&O.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,O)}function g(c){return`color: ${c}`}}),define(re[47],oe([0,1,14,12,171]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=k,e.$bi=A,e.$ci=g;function k(c){return JSON.stringify(c,I)}function A(c){let l=JSON.parse(c);return l=g(l),l}function I(c,l){return l instanceof RegExp?{$mid:y.MarshalledId.Regexp,source:l.source,flags:l.flags}:l}function g(c,l=0){if(!c||l>200)return c;if(typeof c=="object"){switch(c.$mid){case y.MarshalledId.Uri:return S.URI.revive(c);case y.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case y.MarshalledId.Date:return new Date(c.source)}if(c instanceof E.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let u=0;u<c.length;++u)c[u]=g(c[u],l+1);else for(const u in c)Object.hasOwnProperty.call(c,u)&&(c[u]=g(c[u],l+1))}return c}}),define(re[87],oe([0,1,74,15,13,12]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pE=l,y=ye(y);class A{constructor(h,w,m){this.id=h,this.dependencies=w,this.callback=m}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,w,m)=>{typeof h!="string"&&(m=w,w=h,h=null),(typeof w!="object"||!Array.isArray(w))&&(m=w,w=null),this.c.push(new A(h,w,m))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const w=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!w)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h(h){return new Promise((w,m)=>{const O=document.createElement("script");O.setAttribute("async","async"),O.setAttribute("type","text/javascript");const p=()=>{O.removeEventListener("load",f),O.removeEventListener("error",$)},f=P=>{p(),w(this.c.pop())},$=P=>{p(),m(P)};O.addEventListener("load",f),O.addEventListener("error",$),this.f&&(h=this.f.createScriptURL(h)),O.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(O)})}i(h){return new Promise((w,m)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),w(this.c.pop())}catch(O){m(O)}})}async j(h){try{const w=globalThis._VSCODE_NODE_MODULES.fs,m=globalThis._VSCODE_NODE_MODULES.vm,O=globalThis._VSCODE_NODE_MODULES.module,p=k.URI.parse(h).fsPath,f=w.readFileSync(p).toString(),$=O.wrap(f.replace(/^#!.*/,""));return new m.Script($).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}const g=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function l(u,h,w){if(E.$V){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[u]&&(u=c[u]);const m=`${u}/${h}`;if(g.has(m))return g.get(m);let O;if(/^\w[\w\d+.-]*:\/\//.test(m))O=m;else{const P=`${w&&!y.$o?S.$Wg:S.$Vg}/${m}`;O=S.$Zg.asBrowserUri(P).toString(!0)}const p=I.INSTANCE.load(O);return g.set(m,p),p}else return await new Promise((m,O)=>{H([u],m,O)}).then(ye)}}),define(re[88],oe([0,1,35,48,29,80,13]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=g,e.$Rn=u,e.$Sn=h,y=ye(y),e.$Pn=new class{c(w){return this.a||(this.a=S.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,m=0;const O=(0,E.networkInterfaces)();for(const p in O){const f=O[p];if(f)for(const{mac:$,internal:P}of f)P||(m+=1,this.c($.toUpperCase())&&(w+=1))}this.b=m>0?w/m:0}return this.b}};let I;async function g(w){return I||(I=(async()=>await c(w)||y.$2g())()),I}async function c(w){try{const m=await new Promise((p,f)=>{H(["crypto"],p,f)}).then(ye),O=(0,k.$On)();return m.createHash("sha256").update(O,"utf8").digest("hex")}catch(m){w(m);return}}const l="Software\\Microsoft\\SQMClient";async function u(w){if(A.$i){const m=await new Promise((O,p)=>{H(["@vscode/windows-registry"],O,p)}).then(ye);try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",l,"MachineId")||""}catch(O){return w(O),""}}return""}async function h(w){try{return await(await new Promise((p,f)=>{H(["@vscode/deviceid"],p,f)}).then(ye)).getDeviceId()}catch(m){return w(m),""}}}),define(re[89],oe([0,1,35,16,25]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=$,e.$wm=P,E=ye(E),S=ye(S),y=ye(y);const k=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let c;switch(process.arch){case"ia32":c=g.x86;break;case"arm":case"arm64":c=g.ARM;break;default:c=g.x64;break}let l;process.env.PROCESSOR_ARCHITEW6432?l=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?g.ARM:g.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?l=g.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?l=g.x86:l=g.x64;class u{constructor(a,i,s){this.exePath=a,this.displayName=i,this.a=s}async exists(){return this.a===void 0&&(this.a=await y.SymlinkSupport.existsFile(this.exePath)),this.a}}function h({useAlternateBitness:v=!1}={}){return v?c===g.x64?process.env["ProgramFiles(x86)"]||null:l===g.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:v=!1,findPreview:a=!1}={}){const i=h({useAlternateBitness:v});if(!i)return null;const s=S.$lc(i,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(s))return null;let r=-1,t=null;for(const d of await y.Promises.readdir(s)){let R=-1;if(a){const C=d.indexOf("-");if(C<0)continue;const D=d.substring(0,C);if(!k.test(D)||d.substring(C+1)!=="preview")continue;R=parseInt(D,10)}else{if(!k.test(d))continue;R=parseInt(d,10)}if(R<=r)continue;const N=S.$lc(s,d,"pwsh.exe");await y.SymlinkSupport.existsFile(N)&&(t=N,r=R)}if(!t)return null;const n=i.includes("x86")?" (x86)":"",o=a?" Preview":"";return new u(t,`PowerShell${o}${n}`,!0)}async function m({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const a=S.$lc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:i,pwshMsixName:s}=v?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const r of await y.Promises.readdir(a))if(i.test(r)){const t=S.$lc(a,r,"pwsh.exe");return new u(t,s)}return null}function O(){const v=S.$lc(E.homedir(),".dotnet","tools","pwsh.exe");return new u(v,".NET Core PowerShell Global Tool")}function p(){const v=S.$lc(process.env.windir,c===g.x86&&l!==g.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new u(v,"Windows PowerShell",!0)}async function*f(){let v=await w();v&&(yield v),v=await w({useAlternateBitness:!0}),v&&(yield v),v=await m(),v&&(yield v),v=O(),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await m({findPreview:!0}),v&&(yield v),v=await w({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=p(),v&&(yield v)}async function*$(){for await(const v of f())await v.exists()&&(yield v)}async function P(){for await(const v of $())return v;return null}}),define(re[58],oe([0,1,16,13,36,57,3,25]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=g,e.$ym=c,E=ye(E),S=ye(S),y=ye(y),A=ye(A),I=ye(I),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function g(u=y.env){return u.comspec||"cmd.exe"}function c(u){let h=[],w=!1;const m=function(O){if(w){h.push(O);return}(!u.send(O,f=>{if(f&&console.error(f),w=!1,h.length>0){const $=h.slice(0);h=[],$.forEach(P=>m(P))}})||S.$i)&&(w=!0)};return{send:m}}var l;(function(u){async function h(w,m,O){if(E.$kc(w))return w;if(m===void 0&&(m=y.cwd()),E.$oc(w)!=="."||(O===void 0&&A.$fg(y.env.PATH)&&(O=y.env.PATH.split(E.$vc)),O===void 0||O.length===0))return E.$lc(m,w);async function f($){if(await I.Promises.exists($)){let P;try{P=await I.Promises.stat($)}catch(v){v.message.startsWith("EACCES")&&(P=await I.Promises.lstat($))}return P?!P.isDirectory():!1}return!1}for(const $ of O){let P;if(E.$kc($)?P=E.$lc($,w):P=E.$lc(m,$,w),await f(P))return P;let v=P+".com";if(await f(v)||(v=P+".exe",await f(v)))return v}return E.$lc(m,w)}u.findExecutable=h})(l||(e.win32=l={}))}),define(re[90],oe([0,1,35,13,89,58]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=A,S=ye(S),k=ye(k);async function A(u,h){return u===S.OperatingSystem.Windows?S.$i?l():k.$xm(h):g(u,h)}let I=null;function g(u,h){if(S.$k&&u===S.OperatingSystem.Macintosh||S.$j&&u===S.OperatingSystem.Linux)return"/bin/bash";if(!I){let w;if(S.$i)w="/bin/bash";else{if(w=h.SHELL,!w)try{w=(0,E.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}I=w}return I}let c=null;async function l(){return c||(c=(await(0,y.$wm)()).exePath),c}});var we=this&&this.__decorate||function(H,e,E,S){var y=arguments.length,k=y<3?e:S===null?S=Object.getOwnPropertyDescriptor(e,E):S,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(H,e,E,S);else for(var I=H.length-1;I>=0;I--)(A=H[I])&&(k=(y<3?A(k):y>3?A(e,E,k):A(e,E))||k);return y>3&&k&&Object.defineProperty(e,E,k),k};define(re[59],oe([0,1,20,8,14,22,55,9,5,2,47,32,3]),function(H,e,E,S,y,k,A,I,g,c,l,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=o,e.$gi=d,e.$li=M,e.$mi=K,u=ye(u);var w;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(w||(w={}));function m(B){switch(B){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var O;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(O||(O={}));function p(B){switch(B){case O.Initialize:return"init";case O.PromiseSuccess:return"reply:";case O.PromiseError:case O.PromiseErrorObj:return"replyErr:";case O.EventFire:return"event:"}}var f;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(f||(f={}));function $(B){let U=0;for(let J=0;;J+=7){const Z=B.read(1);if(U|=(Z.buffer[0]&127)<<J,!(Z.buffer[0]&128))return U}}const P=r(0);function v(B,U){if(U===0){B.write(P);return}let J=0;for(let Y=U;Y!==0;Y=Y>>>7)J++;const Z=y.$Oe.alloc(J);for(let Y=0;U!==0;Y++)Z.buffer[Y]=U&127,U=U>>>7,U>0&&(Z.buffer[Y]|=128);B.write(Z)}class a{constructor(U){this.b=U,this.a=0}read(U){const J=this.b.slice(this.a,this.a+U);return this.a+=J.byteLength,J}}e.$di=a;class i{constructor(){this.a=[]}get buffer(){return y.$Oe.concat(this.a)}write(U){this.a.push(U)}}e.$ei=i;var s;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(s||(s={}));function r(B){const U=y.$Oe.alloc(1);return U.writeUInt8(B,0),U}const t={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},n=typeof Buffer<"u";function o(B,U){if(typeof U>"u")B.write(t.Undefined);else if(typeof U=="string"){const J=y.$Oe.fromString(U);B.write(t.String),v(B,J.byteLength),B.write(J)}else if(n&&Buffer.isBuffer(U)){const J=y.$Oe.wrap(U);B.write(t.Buffer),v(B,J.byteLength),B.write(J)}else if(U instanceof y.$Oe)B.write(t.VSBuffer),v(B,U.byteLength),B.write(U);else if(Array.isArray(U)){B.write(t.Array),v(B,U.length);for(const J of U)o(B,J)}else if(typeof U=="number"&&(U|0)===U)B.write(t.Uint),v(B,U);else{const J=y.$Oe.fromString(JSON.stringify(U));B.write(t.Object),v(B,J.byteLength),B.write(J)}}function d(B){switch(B.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return B.read($(B)).toString();case s.Buffer:return B.read($(B)).buffer;case s.VSBuffer:return B.read($(B));case s.Array:{const J=$(B),Z=[];for(let Y=0;Y<J;Y++)Z.push(d(B));return Z}case s.Object:return JSON.parse(B.read($(B)).toString());case s.Int:return $(B)}}class R{constructor(U,J,Z=null,Y=1e3){this.h=U,this.j=J,this.k=Z,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(j=>this.q(j)),this.m({type:O.Initialize})}registerChannel(U,J){this.b.set(U,J),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case O.Initialize:{const J=this.o([U.type]);this.k?.logOutgoing(J,0,N.OtherSide,p(U.type));return}case O.PromiseSuccess:case O.PromiseError:case O.EventFire:case O.PromiseErrorObj:{const J=this.o([U.type,U.id],U.data);this.k?.logOutgoing(J,U.id,N.OtherSide,p(U.type),U.data);return}}}o(U,J=void 0){const Z=new i;return o(Z,U),o(Z,J),this.p(Z.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const J=new a(U),Z=d(J),Y=d(J),j=Z[0];switch(j){case w.Promise:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${m(j)}: ${Z[2]}.${Z[3]}`,Y),this.s({type:j,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case w.EventListen:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${m(j)}: ${Z[2]}.${Z[3]}`,Y),this.t({type:j,id:Z[1],channelName:Z[2],name:Z[3],arg:Y});case w.PromiseCancel:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${m(j)}`),this.u({type:j,id:Z[1]});case w.EventDispose:return this.k?.logIncoming(U.byteLength,Z[1],N.OtherSide,`${m(j)}`),this.u({type:j,id:Z[1]})}}s(U){const J=this.b.get(U.channelName);if(!J){this.v(U);return}const Z=new k.$xe;let Y;try{Y=J.call(this.j,U.name,U.arg,Z.token)}catch(G){Y=Promise.reject(G)}const j=U.id;Y.then(G=>{this.m({id:j,data:G,type:O.PromiseSuccess})},G=>{G instanceof Error?this.m({id:j,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split(`
`):void 0},type:O.PromiseError}):this.m({id:j,data:G,type:O.PromiseErrorObj})}).finally(()=>{z.dispose(),this.d.delete(U.id)});const z=(0,c.$Uc)(()=>Z.cancel());this.d.set(U.id,z)}t(U){const J=this.b.get(U.channelName);if(!J){this.v(U);return}const Z=U.id,j=J.listen(this.j,U.name,U.arg)(z=>this.m({id:Z,data:z,type:O.EventFire}));this.d.set(U.id,j)}u(U){const J=this.d.get(U.id);J&&(J.dispose(),this.d.delete(U.id))}v(U){let J=this.g.get(U.channelName);J||(J=[],this.g.set(U.channelName,J));const Z=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===w.Promise&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:O.PromiseError})},this.l);J.push({request:U,timeoutTimer:Z})}w(U){const J=this.g.get(U);if(J){for(const Z of J)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case w.Promise:this.s(Z.request);break;case w.EventListen:this.t(Z.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Rc)(this.d.values()),this.d.clear()}}e.$hi=R;var N;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class C{constructor(U,J=null){this.l=U,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=J}getChannel(U){const J=this;return{call(Z,Y,j){return J.a?Promise.reject(new I.$7):J.m(U,Z,Y,j)},listen(Z,Y){return J.a?g.Event.None:J.o(U,Z,Y)}}}m(U,J,Z,Y=k.CancellationToken.None){const j=this.g++,z=w.Promise,G={id:j,type:z,channelName:U,name:J,arg:Z};if(Y.isCancellationRequested)return Promise.reject(new I.$7);let V;return new Promise((L,F)=>{if(Y.isCancellationRequested)return F(new I.$7);const q=()=>{const fe=he=>{switch(he.type){case O.PromiseSuccess:this.f.delete(j),L(he.data);break;case O.PromiseError:{this.f.delete(j);const Ee=new Error(he.data.message);Ee.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,Ee.name=he.data.name,F(Ee);break}case O.PromiseErrorObj:this.f.delete(j),F(he.data);break}};this.f.set(j,fe),this.p(G)};let Q=null;this.b===f.Idle?q():(Q=(0,S.$sh)(fe=>this.u()),Q.then(()=>{Q=null,q()}));const X=()=>{Q?(Q.cancel(),Q=null):this.p({id:j,type:w.PromiseCancel}),F(new I.$7)},se=Y.onCancellationRequested(X);V=(0,c.$Tc)((0,c.$Uc)(X),se),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(U,J,Z){const Y=this.g++,j=w.EventListen,z={id:Y,type:j,channelName:U,name:J,arg:Z};let G=null;const V=new g.$me({onWillAddFirstListener:()=>{G=(0,S.$sh)(L=>this.u()),G.then(()=>{G=null,this.d.add(V),this.p(z)})},onDidRemoveLastListener:()=>{G?(G.cancel(),G=null):(this.d.delete(V),this.p({id:Y,type:w.EventDispose}))}}),b=L=>V.fire(L.data);return this.f.set(Y,b),V.event}p(U){switch(U.type){case w.Promise:case w.EventListen:{const J=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(J,U.id,N.LocalSide,`${m(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case w.PromiseCancel:case w.EventDispose:{const J=this.q([U.type,U.id]);this.j?.logOutgoing(J,U.id,N.LocalSide,m(U.type));return}}}q(U,J=void 0){const Z=new i;return o(Z,U),o(Z,J),this.r(Z.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const J=new a(U),Z=d(J),Y=d(J),j=Z[0];switch(j){case O.Initialize:return this.j?.logIncoming(U.byteLength,0,N.LocalSide,p(j)),this.t({type:Z[0]});case O.PromiseSuccess:case O.PromiseError:case O.EventFire:case O.PromiseErrorObj:return this.j?.logIncoming(U.byteLength,Z[1],N.LocalSide,p(j),Y),this.t({type:Z[0],id:Z[1],data:Y})}}t(U){if(U.type===O.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Rc)(this.d.values()),this.d.clear()}}e.$ii=C,we([A.$0h],C.prototype,"onDidInitializePromise",null);class D{get connections(){const U=[];return this.f.forEach(J=>U.push(J)),U}constructor(U,J,Z){this.a=new Map,this.f=new Set,this.g=new g.$me,this.onDidAddConnection=this.g.event,this.h=new g.$me,this.onDidRemoveConnection=this.h.event,this.j=new c.$Vc,this.j.add(U(({protocol:Y,onDidClientDisconnect:j})=>{const z=g.Event.once(Y.onMessage);this.j.add(z(G=>{const V=new a(G),b=d(V),L=new R(Y,b,J,Z),F=new C(Y,J);this.a.forEach((Q,X)=>L.registerChannel(X,Q));const q={channelServer:L,channelClient:F,ctx:b};this.f.add(q),this.g.fire(q),this.j.add(j(()=>{L.dispose(),F.dispose(),this.f.delete(q),this.h.fire(q)}))}))}))}getChannel(U,J){const Z=this;return{call(Y,j,z){let G;if((0,h.$tg)(J)){const b=(0,E.$5b)(Z.connections.filter(J));G=b?Promise.resolve(b):g.Event.toPromise(g.Event.filter(Z.onDidAddConnection,J))}else G=J.routeCall(Z,Y,j);const V=G.then(b=>b.channelClient.getChannel(U));return M(V).call(Y,j,z)},listen(Y,j){if((0,h.$tg)(J))return Z.k(U,J,Y,j);const z=J.routeEvent(Z,Y,j).then(G=>G.channelClient.getChannel(U));return M(z).listen(Y,j)}}}k(U,J,Z,Y){const j=this;let z;const G=new g.$me({onWillAddFirstListener:()=>{z=new c.$Vc;const V=new g.$se,b=new Map,L=q=>{const X=q.channelClient.getChannel(U).listen(Z,Y),se=V.add(X);b.set(q,se)},F=q=>{const Q=b.get(q);Q&&(Q.dispose(),b.delete(q))};j.connections.filter(J).forEach(L),g.Event.filter(j.onDidAddConnection,J)(L,void 0,z),j.onDidRemoveConnection(F,void 0,z),V.event(G.fire,G,z),z.add(V)},onDidRemoveLastListener:()=>{z?.dispose(),z=void 0}});return G.event}registerChannel(U,J){this.a.set(U,J);for(const Z of this.f)Z.channelServer.registerChannel(U,J)}dispose(){this.j.dispose();for(const U of this.f)U.channelClient.dispose(),U.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=D;class T{constructor(U,J,Z=null){const Y=new i;o(Y,J),U.send(Y.buffer),this.a=new C(U,Z),this.d=new R(U,J,Z)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,J){this.d.registerChannel(U,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=T;function M(B){return{call(U,J,Z){return B.then(Y=>Y.call(U,J,Z))},listen(U,J){const Z=new g.$ve;return B.then(Y=>Z.input=Y.listen(U,J)),Z.event}}}function K(B){let U=!1;return{call(J,Z,Y){return U?B.call(J,Z,Y):(0,S.$Gh)(0).then(()=>U=!0).then(()=>B.call(J,Z,Y))},listen(J,Z){if(U)return B.listen(J,Z);const Y=new g.$ve;return(0,S.$Gh)(0).then(()=>U=!0).then(()=>Y.input=B.listen(J,Z)),Y.event}}}class ae{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const J of U.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await g.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$ni=ae;var ie;(function(B){function U(j,z,G){const V=j,b=G&&G.disableMarshalling,L=new Map;for(const F in V)Z(F)&&L.set(F,g.Event.buffer(V[F],!0,void 0,z));return new class{listen(F,q,Q){const X=L.get(q);if(X)return X;const se=V[q];if(typeof se=="function"){if(Y(q))return se.call(V,Q);if(Z(q))return L.set(q,g.Event.buffer(V[q],!0,void 0,z)),L.get(q)}throw new I.$db(`Event not found: ${q}`)}call(F,q,Q){const X=V[q];if(typeof X=="function"){if(!b&&Array.isArray(Q))for(let fe=0;fe<Q.length;fe++)Q[fe]=(0,l.$ci)(Q[fe]);let se=X.apply(V,Q);return se instanceof Promise||(se=Promise.resolve(se)),se}throw new I.$db(`Method not found: ${q}`)}}}B.fromService=U;function J(j,z){const G=z&&z.disableMarshalling;return new Proxy({},{get(V,b){if(typeof b=="string")return z?.properties?.has(b)?z.properties.get(b):Y(b)?function(L){return j.listen(b,L)}:Z(b)?j.listen(b):async function(...L){let F;z&&!(0,h.$og)(z.context)?F=[z.context,...L]:F=L;const q=await j.call(b,F);return G?q:(0,l.$ci)(q)};throw new I.$db(`Property not found: ${String(b)}`)}})}B.toService=J;function Z(j){return j[0]==="o"&&j[1]==="n"&&u.$Ff(j.charCodeAt(2))}function Y(j){return/^onDynamic/.test(j)&&u.$Ff(j.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const U=B.toString();if(U!=="[object Object]")return U}return B}function le(B){return Array.isArray(B)?B.map(ce):ce(B)}function x(B,U,J,Z,Y,j,z){z=le(z);const G=ue[Y],V=G[Z%G.length];let b=[`%c[${B}]%c[${String(U).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${j}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(j)?(b=b.concat(z),b.push(")")):b.push(z),console.log.apply(console,b)}class _{constructor(U,J){this.d=U,this.f=J,this.a=0,this.b=0}logOutgoing(U,J,Z,Y,j){this.b+=U,x(this.d,this.b,U,J,Z,Y,j)}logIncoming(U,J,Z,Y,j){this.a+=U,x(this.f,this.a,U,J,Z,Y,j)}}e.$oi=_}),define(re[91],oe([0,1,60,8,14,22,86,9,5,2,28,58,57,59]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0,I=ye(I);class m extends w.$hi{constructor(f){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",$=>y.$Oe.wrap(Buffer.from($,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$br=m;class O{constructor(f,$){this.i=f,this.j=$,this.c=new Set,this.g=new Map,this.h=new g.$me,this.onDidProcessExit=this.h.event;const P=$&&$.timeout?$.timeout:6e4;this.b=new S.$Ch(P),this.d=null,this.f=null}getChannel(f){const $=this;return{call(P,v,a){return $.k(f,P,v,a)},listen(P,v){return $.l(f,P,v)}}}k(f,$,P,v=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(I.$8());this.b.cancel();const a=this.n(f),i=(0,S.$sh)(t=>a.call($,P,t)),s=v.onCancellationRequested(()=>i.cancel()),r=(0,c.$Uc)(()=>i.cancel());return this.c.add(r),i.finally(()=>{s.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(f,$,P){if(!this.b)return g.Event.None;this.b.cancel();let v;const a=new g.$me({onWillAddFirstListener:()=>{v=this.n(f).listen($,P)(a.fire,a),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,l.$co)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$lm)($.env),this.d=(0,E.fork)(this.i,f,$);const P=new g.$me,a=g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$0q)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}P.fire(y.$Oe.wrap(Buffer.from(o,"base64")))}),i=this.j.useQueue?(0,u.$ym)(this.d):this.d,s=o=>this.d&&this.d.connected&&i.send(o.buffer.toString("base64")),r=P.event,t={send:s,onMessage:r};this.f=new w.$ii(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,d)=>{process.removeListener("exit",n),a.dispose(),this.c.forEach(R=>(0,c.$Rc)(R)),this.c.clear(),o!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:d})})}return this.f}n(f){let $=this.g.get(f);return $||($=this.m.getChannel(f),this.g.set(f,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$cr=O}),define(re[92],oe([0,1,8,5,2,47,3]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.StorageState=e.StorageHint=void 0,e.$0p=g;var I;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function g(h){const w=h;return w?.changed instanceof Map||w?.deleted instanceof Set}var c;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(c||(e.StorageState=c={}));class l extends y.$Wc{static{this.a=100}constructor(w,m=Object.create(null)){super(),this.r=w,this.s=m,this.b=this.B(new S.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new E.$Dh(l.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((m,O)=>this.w(O,m)),w.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(w,m){if(this.c===c.Closed)return;let O=!1;(0,A.$og)(m)?O=this.f.delete(w):this.f.get(w)!==m&&(this.f.set(w,m),O=!0),O&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,m){const O=this.f.get(w);return(0,A.$og)(O)?m:O}getBoolean(w,m){const O=this.get(w);return(0,A.$og)(O)?m:O==="true"}getNumber(w,m){const O=this.get(w);return(0,A.$og)(O)?m:parseInt(O,10)}getObject(w,m){const O=this.get(w);return(0,A.$og)(O)?m:(0,k.$bi)(O)}async set(w,m,O=!1){if(this.c===c.Closed)return;if((0,A.$og)(m))return this.delete(w,O);const p=(0,A.$hg)(m)||Array.isArray(m)?(0,k.$ai)(m):String(m);if(this.f.get(w)!==p)return this.f.set(w,p),this.j.set(w,p),this.h.delete(w),this.b.fire({key:w,external:O}),this.D()}async delete(w,m=!1){if(!(this.c===c.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===c.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$$p=l;class u{constructor(){this.onDidChangeItemsExternal=S.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((m,O)=>this.a.set(O,m)),w.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$_p=u}),define(re[93],oe([7,4]),function(H,e){return H.create("vs/base/node/zip",e)}),define(re[49],oe([0,1,94,8,16,3,25,93]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=void 0,e.zip=p,e.$xq=f,e.$yq=P,y=ye(y),I=ye(I),e.$uq="end of central directory record signature not found";const g=new RegExp(e.$uq);class c extends Error{constructor(a,i){let s=i.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=i}}e.$vq=c;function l(v){const a=v.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,s)=>i+s,a&61440)}function u(v){if(v instanceof c)return v;let a;return g.test(v.message)&&(a="CorruptZip"),new c(a,v)}function h(v,a,i,s,r,t){const n=y.$oc(a),o=y.$lc(s,n);if(!o.startsWith(s))return Promise.reject(new Error(I.localize(0,null,a)));const d=y.$lc(s,a);let R;return t.onCancellationRequested(()=>{R?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,C)=>{if(!t.isCancellationRequested)try{R=(0,E.createWriteStream)(d,{mode:i}),R.once("close",()=>N()),R.once("error",C),v.once("error",C),v.pipe(R)}catch(D){C(D)}}))}function w(v,a,i,s){let r=(0,S.$sh)(()=>Promise.resolve()),t=0;const n=s.onCancellationRequested(()=>{r.cancel(),v.close()});return new Promise((o,d)=>{const R=new S.$Ah,N=C=>{C.isCancellationRequested||(t++,v.readEntry())};v.once("error",d),v.once("close",()=>r.then(()=>{s.isCancellationRequested||v.entryCount===t?o():d(new c("Incomplete",new Error(I.localize(1,null,t,v.entryCount))))},d)),v.readEntry(),v.on("entry",C=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(C.fileName)){N(s);return}const D=C.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(D)){const K=y.$lc(a,D);r=(0,S.$sh)(ae=>A.Promises.mkdir(K,{recursive:!0}).then(()=>N(ae)).then(void 0,d));return}const T=O(v,C),M=l(C);r=(0,S.$sh)(K=>R.queue(()=>T.then(ae=>h(ae,D,M,a,i,K).then(()=>N(K)))).then(null,d))})}).finally(()=>n.dispose())}async function m(v,a=!1){const{open:i}=await new Promise((s,r)=>{H(["yauzl"],s,r)}).then(ye);return new Promise((s,r)=>{i(v,a?{lazyEntries:!0}:void 0,(t,n)=>{t?r(u(t)):s((0,k.$qg)(n))})})}function O(v,a){return new Promise((i,s)=>{v.openReadStream(a,(r,t)=>{r?s(u(r)):i((0,k.$qg)(t))})})}async function p(v,a){const{ZipFile:i}=await new Promise((s,r)=>{H(["yazl"],s,r)}).then(ye);return new Promise((s,r)=>{const t=new i;a.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const n=(0,E.createWriteStream)(v);t.outputStream.pipe(n),t.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>s(v))})}function f(v,a,i={},s){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let t=m(v,!0);return i.overwrite&&(t=t.then(n=>A.Promises.rm(a).then(()=>n))),t.then(n=>w(n,a,{sourcePathRegex:r},s))}function $(v,a){return m(v).then(i=>new Promise((s,r)=>{i.on("entry",t=>{t.fileName===a&&O(i,t).then(n=>s(n),n=>r(n))}),i.once("close",()=>r(new Error(I.localize(2,null,a))))}))}function P(v,a){return $(v,a).then(i=>new Promise((s,r)=>{const t=[];i.once("error",r),i.on("data",n=>t.push(n)),i.on("end",()=>s(Buffer.concat(t)))}))}}),define(re[95],oe([7,4]),function(H,e){return H.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[96],oe([7,4]),function(H,e){return H.create("vs/platform/contextkey/common/contextkey",e)}),define(re[97],oe([7,4]),function(H,e){return H.create("vs/platform/contextkey/common/scanner",e)}),define(re[98],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[99],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[100],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(re[101],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[102],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[103],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[104],oe([7,4]),function(H,e){return H.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[105],oe([7,4]),function(H,e){return H.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[106],oe([7,4]),function(H,e){return H.create("vs/platform/files/common/fileService",e)}),define(re[107],oe([7,4]),function(H,e){return H.create("vs/platform/files/common/io",e)}),define(re[108],oe([7,4]),function(H,e){return H.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[109],oe([7,4]),function(H,e){return H.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[110],oe([7,4]),function(H,e){return H.create("vs/platform/log/common/log",e)}),define(re[111],oe([7,4]),function(H,e){return H.create("vs/platform/request/common/request",e)}),define(re[112],oe([7,4]),function(H,e){return H.create("vs/platform/shell/node/shellEnv",e)}),define(re[113],oe([7,4]),function(H,e){return H.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[114],oe([7,4]),function(H,e){return H.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[115],oe([7,4]),function(H,e){return H.create("vs/platform/workspace/common/workspace",e)}),define(re[116],oe([0,1,117,9,97]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var k;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...l){switch(l.length){case 1:return(0,y.localize)(0,null,l[0]);case 2:return(0,y.localize)(1,null,l[0],l[1]);case 3:return(0,y.localize)(2,null,l[0],l[1],l[2]);default:return}}const I=(0,y.localize)(3,null),g=(0,y.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return u.isTripleEq?"===":"==";case k.NotEq:return u.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return u.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return u.lexeme;case k.QuotedStr:return u.lexeme;case k.Error:return u.lexeme;case k.EOF:return"EOF";default:throw(0,S.$0)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case E.CharCode.OpenParen:this.k(k.LParen);break;case E.CharCode.CloseParen:this.k(k.RParen);break;case E.CharCode.ExclamationMark:if(this.h(E.CharCode.Equals)){const h=this.h(E.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:h})}else this.k(k.Neg);break;case E.CharCode.SingleQuote:this.o();break;case E.CharCode.Slash:this.q();break;case E.CharCode.Equals:if(this.h(E.CharCode.Equals)){const h=this.h(E.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:h})}else this.h(E.CharCode.Tilde)?this.k(k.RegexOp):this.l(A("==","=~"));break;case E.CharCode.LessThan:this.k(this.h(E.CharCode.Equals)?k.LtEq:k.Lt);break;case E.CharCode.GreaterThan:this.k(this.h(E.CharCode.Equals)?k.GtEq:k.Gt);break;case E.CharCode.Ampersand:this.h(E.CharCode.Ampersand)?this.k(k.And):this.l(A("&&"));break;case E.CharCode.Pipe:this.h(E.CharCode.Pipe)?this.k(k.Or):this.l(A("||"));break;case E.CharCode.Space:case E.CharCode.CarriageReturn:case E.CharCode.Tab:case E.CharCode.LineFeed:case E.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?E.CharCode.Null:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const h=this.d,w=this.c.substring(this.d,this.e),m={type:k.Error,offset:this.d,lexeme:w};this.g.push({offset:h,lexeme:w,additionalInfo:u}),this.f.push(m)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const h=this.c.substring(this.d,this.e),w=c.b.get(h);w?this.k(w):this.f.push({type:k.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==E.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,h=!1,w=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(g);return}const O=this.c.charCodeAt(u);if(h)h=!1;else if(O===E.CharCode.Slash&&!w){u++;break}else O===E.CharCode.OpenSquareBracket?w=!0:O===E.CharCode.Backslash?h=!0:O===E.CharCode.CloseSquareBracket&&(w=!1);u++}for(;u<this.c.length&&c.a.has(this.c.charCodeAt(u));)u++;this.e=u;const m=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=c}),define(re[118],oe([0,1,82,55,15,16,36,17,12]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=l,e.$7m=u,e.$4m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,k.$oc)(y.$Zg.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,k.$lc)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,I.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:y.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,E.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$lc)(this.userDataPath,"logs",w)}return g.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$gh)(g.URI.file((0,k.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=A.env.VSCODE_PORTABLE;return w?g.URI.file((0,k.$lc)(w,"argv.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,k.$mc)(w):(0,k.$jc)((0,k.$lc)(y.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?g.URI.file((0,k.$mc)(w)):g.URI.file((0,k.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,k.$mc)(w);const m=A.env.VSCODE_EXTENSIONS;if(m)return m;const O=A.env.VSCODE_PORTABLE;return O?(0,k.$lc)(O,"extensions"):(0,I.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(m=>/^[^:/?#]+?:\/\//.test(m)?g.URI.parse(m):g.URI.file((0,k.$jc)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?g.URI.parse(w):g.URI.file((0,k.$jc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return l(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$4m.test(w))}get extensionLogLevel(){const w=[];for(const m of this.args.log||[]){const O=e.$4m.exec(m);O&&O[1]&&O[2]&&w.push([O[1],O[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,I.$gh)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=A.env.VSCODE_PORTABLE;return w?g.URI.file((0,k.$lc)(w,"policy.json")):(0,I.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,m,O){this.a=w,this.b=m,this.c=O,this.editSessionId=this.args.editSessionId}}e.$5m=c,we([S.$0h],c.prototype,"appRoot",null),we([S.$0h],c.prototype,"userHome",null),we([S.$0h],c.prototype,"userDataPath",null),we([S.$0h],c.prototype,"appSettingsHome",null),we([S.$0h],c.prototype,"tmpDir",null),we([S.$0h],c.prototype,"cacheHome",null),we([S.$0h],c.prototype,"stateResource",null),we([S.$0h],c.prototype,"userRoamingDataHome",null),we([S.$0h],c.prototype,"userDataSyncHome",null),we([S.$0h],c.prototype,"sync",null),we([S.$0h],c.prototype,"machineSettingsResource",null),we([S.$0h],c.prototype,"workspaceStorageHome",null),we([S.$0h],c.prototype,"localHistoryHome",null),we([S.$0h],c.prototype,"keyboardLayoutResource",null),we([S.$0h],c.prototype,"argvResource",null),we([S.$0h],c.prototype,"isExtensionDevelopment",null),we([S.$0h],c.prototype,"untitledWorkspacesHome",null),we([S.$0h],c.prototype,"builtinExtensionsPath",null),we([S.$0h],c.prototype,"extensionsPath",null),we([S.$0h],c.prototype,"extensionDevelopmentLocationURI",null),we([S.$0h],c.prototype,"extensionDevelopmentKind",null),we([S.$0h],c.prototype,"extensionTestsLocationURI",null),we([S.$0h],c.prototype,"debugExtensionHost",null),we([S.$0h],c.prototype,"logLevel",null),we([S.$0h],c.prototype,"extensionLogLevel",null),we([S.$0h],c.prototype,"serviceMachineIdResource",null),we([S.$0h],c.prototype,"disableTelemetry",null),we([S.$0h],c.prototype,"disableWorkspaceTrust",null),we([S.$0h],c.prototype,"useInMemorySecretStorage",null),we([S.$0h],c.prototype,"policyFile",null);function l(h,w){return u(h["inspect-extensions"],h["inspect-brk-extensions"],5870,w,h.debugId,h.extensionEnvironment)}function u(h,w,m,O,p,f){const P=Number(w||h)||(O?null:m),v=P?!!w:!1;let a;if(f)try{a=JSON.parse(f)}catch{}return{port:P,break:v,debugId:p,env:a}}}),function(){"use strict";function H(e,E,S){function y(A,I){const g=k(A,I),c=[g];return e.isAbsolute(g)||c.unshift(S),e.resolve(...c)}function k(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,I);const l=A["user-data-dir"];if(l)return l;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const u=process.env.USERPROFILE;if(typeof u!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(u,"AppData","Roaming")}break;case"darwin":c=e.join(E.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,I)}return{getUserDataPath:y}}if(typeof define=="function")define(re[119],oe([172,35,36]),function(e,E,S){return H(e,E,S.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=H(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[120],oe([0,1,35,118,119]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=A,e.$0m=I;class k extends S.$5m{constructor(c,l){super(c,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,y.getUserDataPath)(c,l.nameShort)},l)}}e.$8m=k;function A(g,c){return(0,S.$7m)(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,c,g.extensionEnvironment)}function I(g,c){return(0,S.$7m)(g["inspect-sharedprocess"],g["inspect-brk-sharedprocess"],5879,c,g.extensionEnvironment)}}),define(re[121],oe([0,1,3,101]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=y;function y(A,I,g,c){try{k(A,I,g,c)}catch(l){A.error(l?.message??l)}return I}function k(A,I,g,c){const l=(u,h,w)=>{const m=u[h];if((0,E.$fg)(m)){const O=m,p=O.length;if(p>1&&O[0]==="%"&&O[p-1]==="%"){const f=O.substr(1,p-2);let $=g[f];$===void 0&&c&&($=c[f]);const P=typeof $=="string"?$:$?.message,v=c?.[f],a=typeof v=="string"?v:v?.message;if(!P){a||A.warn(`[${I.name}]: ${(0,S.localize)(0,null,f)}`);return}if(w&&(h==="title"||h==="category")&&a&&a!==P){const i={value:P,original:a};u[h]=i}else u[h]=P}}else if((0,E.$hg)(m))for(const O in m)m.hasOwnProperty(O)&&(O==="commands"?l(m,O,!0):l(m,O,w));else if(Array.isArray(m))for(let O=0;O<m.length;O++)l(m,O,w)};for(const u in I)I.hasOwnProperty(u)&&l(I,u)}});var ze=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[50],oe([0,1,17,56,105,44]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=g,e.$Vp=c,e.$Wp=l,e.$Xp=u,e.$Yp=h,e.$Zp=w,e.$1p=m,S=ze(S),y=ye(y),k=ye(k);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||A.test(f)}function c(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=f.match(A);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}function l(f){if(!f)return null;const $=f.majorBase,P=f.majorMustEqual,v=f.minorBase;let a=f.minorMustEqual;const i=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&($===0||(a=!1),s=!1);let r=0;if(f.preRelease){const t=I.exec(f.preRelease);if(t){const[,n,o,d]=t;r=Date.UTC(Number(n),Number(o)-1,Number(d))}}return{majorBase:$,majorMustEqual:P,minorBase:v,minorMustEqual:a,patchBase:i,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:r}}function u(f,$,P){let v;typeof f=="string"?v=l(c(f)):v=f;let a;$ instanceof Date?a=$.getTime():typeof $=="string"&&(a=new Date($).getTime());let i;if(typeof P=="string"?i=l(c(P)):i=P,!v||!i)return!1;const s=v.majorBase,r=v.minorBase,t=v.patchBase;let n=i.majorBase,o=i.minorBase,d=i.patchBase;const R=i.notBefore;let N=i.majorMustEqual,C=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>n?!0:s<n?!1:r>o?!0:r<o||a&&a<R?!1:t>=d:(s===1&&n===0&&(!N||!C||!D)&&(n=1,o=0,d=0,N=!0,C=!1,D=!1),s<n?!1:s>n?!N:r<o?!1:r>o?!C:t<d?!1:t>d?!D:!(a&&a<R))}function h(f,$,P,v,a){const i=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return i.push([S.default.Error,y.localize(0,null)]),i;if(typeof v.name!="string")return i.push([S.default.Error,y.localize(1,null,"name")]),i;if(typeof v.version!="string")return i.push([S.default.Error,y.localize(2,null,"version")]),i;if(!v.engines)return i.push([S.default.Error,y.localize(3,null,"engines")]),i;if(typeof v.engines.vscode!="string")return i.push([S.default.Error,y.localize(4,null,"engines.vscode")]),i;if(typeof v.extensionDependencies<"u"&&!p(v.extensionDependencies))return i.push([S.default.Error,y.localize(5,null,"extensionDependencies")]),i;if(typeof v.activationEvents<"u"){if(!p(v.activationEvents))return i.push([S.default.Error,y.localize(6,null,"activationEvents")]),i;if(typeof v.main>"u"&&typeof v.browser>"u")return i.push([S.default.Error,y.localize(7,null,"activationEvents","main","browser")]),i}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&i.push([S.default.Warning,y.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return i.push([S.default.Error,y.localize(9,null,"main")]),i;{const t=(0,E.$gh)(P,v.main);(0,E.$ah)(t,P)||i.push([S.default.Warning,y.localize(10,null,t.path,P.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return i.push([S.default.Error,y.localize(11,null,"browser")]),i;{const t=(0,E.$gh)(P,v.browser);(0,E.$ah)(t,P)||i.push([S.default.Warning,y.localize(12,null,t.path,P.path)])}}if(!k.valid(v.version))return i.push([S.default.Error,y.localize(13,null)]),i;const s=[];if(!w(f,$,v,a,s))for(const t of s)i.push([S.default.Error,t]);return i}function w(f,$,P,v,a){return v||typeof P.main>"u"&&typeof P.browser>"u"?!0:O(f,$,P.engines.vscode,a)}function m(f,$,P){return f==="*"||O($,P,f)}function O(f,$,P,v=[]){const a=l(c(P));if(!a)return v.push(y.localize(14,null,P)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return v.push(y.localize(15,null,P)),!1}else if(!a.majorMustEqual)return v.push(y.localize(16,null,P)),!1;return u(f,$,a)?!0:(v.push(y.localize(17,null,f,P)),!1)}function p(f){if(!Array.isArray(f))return!1;for(let $=0,P=f.length;$<P;$++)if(typeof f[$]!="string")return!1;return!0}}),define(re[51],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class E{constructor(y,k=[],A=!1){this.ctor=y,this.staticArguments=k,this.supportsDelayedInstantiation=A}}e.$Ci=E}),define(re[122],oe([0,1,51]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ls=k,e.$Ms=A;const S=[];var y;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(y||(e.InstantiationType=y={}));function k(I,g,c){g instanceof E.$Ci||(g=new E.$Ci(g,[],!!c)),S.push([I,g])}function A(){return S}}),define(re[123],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=void 0;class E{constructor(k,A){this.key=k,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$or=E;class S{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const A of this.a.values())A.outgoing.size===0&&k.push(A);return k}insertEdge(k,A){const I=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(A);I.outgoing.set(g.key,g),g.incoming.set(I.key,I)}removeNode(k){const A=this.b(k);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(k){const A=this.b(k);let I=this.a.get(A);return I||(I=new E(A,k),this.a.set(A,I)),I}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[A,I]of this.a)k.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,A]of this.a){const I=new Set([k]),g=this.c(A,I);if(g)return g}}c(k,A){for(const[I,g]of k.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const c=this.c(g,A);if(c)return c;A.delete(I)}}}e.$pr=S}),define(re[30],oe([0,1,3,12,11]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=k,e.$bj=A,e.$cj=g,e.$dj=c,e.$ej=l,e.$fj=u,e.$gj=h,e.$hj=m,e.$ij=O,e.$jj=p,E=ye(E),e.$_i=(0,y.$Fi)("configurationService");function k(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof S.URI)}function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof S.URI)}var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function g(f){switch(f){case I.APPLICATION:return"APPLICATION";case I.USER:return"USER";case I.USER_LOCAL:return"USER_LOCAL";case I.USER_REMOTE:return"USER_REMOTE";case I.WORKSPACE:return"WORKSPACE";case I.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case I.DEFAULT:return"DEFAULT";case I.MEMORY:return"MEMORY"}}function c(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function l(f,$){const P=Object.create(null);for(const v in f)u(P,v,f[v],$);return P}function u(f,$,P,v){const a=$.split("."),i=a.pop();let s=f;for(let r=0;r<a.length;r++){const t=a[r];let n=s[t];switch(typeof n){case"undefined":n=s[t]=Object.create(null);break;case"object":if(n===null){v(`Ignoring ${$} as ${a.slice(0,r+1).join(".")} is null`);return}break;default:v(`Ignoring ${$} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[i]=P}catch{v(`Ignoring ${$} as ${a.join(".")} is ${JSON.stringify(s)}`)}else v(`Ignoring ${$} as ${a.join(".")} is ${JSON.stringify(s)}`)}function h(f,$){const P=$.split(".");w(f,P)}function w(f,$){const P=$.shift();if($.length===0){delete f[P];return}if(Object.keys(f).indexOf(P)!==-1){const v=f[P];typeof v=="object"&&!Array.isArray(v)&&(w(v,$),Object.keys(v).length===0&&delete f[P])}}function m(f,$,P){function v(s,r){let t=s;for(const n of r){if(typeof t!="object"||t===null)return;t=t[n]}return t}const a=$.split("."),i=v(f,a);return typeof i>"u"?P:i}function O(f,$,P){Object.keys($).forEach(v=>{v!=="__proto__"&&(v in f?E.$hg(f[v])&&E.$hg($[v])?O(f[v],$[v],P):P&&(f[v]=$[v]):f[v]=$[v])})}function p(f){return f.replace(/[\[\]]/g,"")}}),define(re[124],oe([0,1,117,13,32,116,11,96,9]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=l,e.$Ej=r,e.$Fj=t,e.$Yj=j;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",S.$j),c.set("isLinux",S.$k),c.set("isWindows",S.$i),c.set("isWeb",S.$o),c.set("isMacNative",S.$j&&!S.$o),c.set("isEdge",S.$H),c.set("isFirefox",S.$F),c.set("isChrome",S.$E),c.set("isSafari",S.$G);function l(V,b){if(c.get(V)!==void 0)throw(0,g.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(V,b)}const u=Object.prototype.hasOwnProperty;var h;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const w={regexParsingWithErrorRecovery:!0},m=(0,I.localize)(0,null),O=(0,I.localize)(1,null),p=(0,I.localize)(2,null),f=(0,I.localize)(3,null),$=(0,I.localize)(4,null),P=(0,I.localize)(5,null),v=(0,I.localize)(6,null),a=(0,I.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(b=w){this.k=b,this.d=new k.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(b){if(b===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:O});return}this.f=this.d.reset(b).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const F=this.D(),q=F.type===k.TokenType.Str?P:void 0;throw this.h.push({message:$,offset:F.offset,lexeme:k.$Aj.getLexeme(F),additionalInfo:q}),i.c}return L}catch(L){if(L!==i.c)throw L;return}}l(){return this.m()}m(){const b=[this.o()];for(;this.y(k.TokenType.Or);){const L=this.o();b.push(L)}return b.length===1?b[0]:s.or(...b)}o(){const b=[this.s()];for(;this.y(k.TokenType.And);){const L=this.s();b.push(L)}return b.length===1?b[0]:s.and(...b)}s(){if(this.y(k.TokenType.Neg)){const b=this.D();switch(b.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),d.INSTANCE;case k.TokenType.LParen:{this.z();const L=this.l();return this.A(k.TokenType.RParen,f),L?.negate()}case k.TokenType.Str:return this.z(),M.create(b.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",b)}}return this.t()}t(){const b=this.D();switch(b.type){case k.TokenType.True:return this.z(),s.true();case k.TokenType.False:return this.z(),s.false();case k.TokenType.LParen:{this.z();const L=this.l();return this.A(k.TokenType.RParen,f),L}case k.TokenType.Str:{const L=b.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==k.TokenType.RegexStr)throw this.B("REGEX",q);const Q=q.lexeme,X=Q.lastIndexOf("/"),se=X===Q.length-1?void 0:this.w(Q.substring(X+1));let fe;try{fe=new RegExp(Q.substring(1,X),se)}catch{throw this.B("REGEX",q)}return le.create(L,fe)}switch(q.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const Q=[q.lexeme];this.z();let X=this.D(),se=0;for(let ge=0;ge<q.lexeme.length;ge++)q.lexeme.charCodeAt(ge)===E.CharCode.OpenParen?se++:q.lexeme.charCodeAt(ge)===E.CharCode.CloseParen&&se--;for(;!this.E()&&X.type!==k.TokenType.And&&X.type!==k.TokenType.Or;){switch(X.type){case k.TokenType.LParen:se++;break;case k.TokenType.RParen:se--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let ge=0;ge<X.lexeme.length;ge++)X.lexeme.charCodeAt(ge)===E.CharCode.OpenParen?se++:q.lexeme.charCodeAt(ge)===E.CharCode.CloseParen&&se--}if(se<0)break;Q.push(k.$Aj.getLexeme(X)),this.z(),X=this.D()}const fe=Q.join(""),he=fe.lastIndexOf("/"),Ee=he===fe.length-1?void 0:this.w(fe.substring(he+1));let pe;try{pe=new RegExp(fe.substring(1,he),Ee)}catch{throw this.B("REGEX",q)}return s.regex(L,pe)}case k.TokenType.QuotedStr:{const Q=q.lexeme;this.z();let X=null;if(!(0,y.$df)(Q)){const se=Q.indexOf("/"),fe=Q.lastIndexOf("/");if(se!==fe&&se>=0){const he=Q.slice(se+1,fe),Ee=Q[fe+1]==="i"?"i":"";try{X=new RegExp(he,Ee)}catch{throw this.B("REGEX",q)}}}if(X===null)throw this.B("REGEX",q);return le.create(L,X)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,p);const q=this.u();return s.notIn(L,q)}switch(this.D().type){case k.TokenType.Eq:{this.z();const q=this.u();if(this.x().type===k.TokenType.QuotedStr)return s.equals(L,q);switch(q){case"true":return s.has(L);case"false":return s.not(L);default:return s.equals(L,q)}}case k.TokenType.NotEq:{this.z();const q=this.u();if(this.x().type===k.TokenType.QuotedStr)return s.notEquals(L,q);switch(q){case"true":return s.not(L);case"false":return s.has(L);default:return s.notEquals(L,q)}}case k.TokenType.Lt:return this.z(),ue.create(L,this.u());case k.TokenType.LtEq:return this.z(),ce.create(L,this.u());case k.TokenType.Gt:return this.z(),ae.create(L,this.u());case k.TokenType.GtEq:return this.z(),ie.create(L,this.u());case k.TokenType.In:return this.z(),s.in(L,this.u());default:return s.has(L)}}case k.TokenType.EOF:throw this.h.push({message:v,offset:b.offset,lexeme:"",additionalInfo:a}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const b=this.D();switch(b.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),b.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(b){return b.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(b){return this.C(b)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(b,L){if(this.C(b))return this.z();throw this.B(L,this.D())}B(b,L,F){const q=(0,I.localize)(8,null,b,k.$Aj.getLexeme(L)),Q=L.offset,X=k.$Aj.getLexeme(L);return this.h.push({message:q,offset:Q,lexeme:X,additionalInfo:F}),i.c}C(b){return this.D().type===b}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Cj=i;class s{static false(){return o.INSTANCE}static true(){return d.INSTANCE}static has(b){return R.create(b)}static equals(b,L){return N.create(b,L)}static notEquals(b,L){return T.create(b,L)}static regex(b,L){return le.create(b,L)}static in(b,L){return C.create(b,L)}static notIn(b,L){return D.create(b,L)}static not(b){return M.create(b)}static and(...b){return B.create(b,null,!0)}static or(...b){return U.create(b,null,!0)}static greater(b,L){return ae.create(b,L)}static greaterEquals(b,L){return ie.create(b,L)}static smaller(b,L){return ue.create(b,L)}static smallerEquals(b,L){return ce.create(b,L)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(b){return b==null?void 0:this.c.parse(b)}}e.$Dj=s;function r(V){const b=new i({regexParsingWithErrorRecovery:!1});return V.map(L=>(b.parse(L),b.lexingErrors.length>0?b.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,I.localize)(9,null,F.additionalInfo):(0,I.localize)(10,null),offset:F.offset,length:F.lexeme.length})):b.parsingErrors.length>0?b.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}function t(V,b){const L=V?V.substituteConstants():void 0,F=b?b.substituteConstants():void 0;return!L&&!F?!0:!L||!F?!1:L.equals(F)}function n(V,b){return V.cmp(b)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!1}serialize(){return"false"}keys(){return[]}map(b){return this}negate(){return d.INSTANCE}}e.$Gj=o;class d{static{this.INSTANCE=new d}constructor(){this.type=h.True}cmp(b){return this.type-b.type}equals(b){return b.type===this.type}substituteConstants(){return this}evaluate(b){return!0}serialize(){return"true"}keys(){return[]}map(b){return this}negate(){return o.INSTANCE}}e.$Hj=d;class R{static create(b,L=null){const F=c.get(b);return typeof F=="boolean"?F?d.INSTANCE:o.INSTANCE:new R(b,L)}constructor(b,L){this.key=b,this.c=L,this.type=h.Defined}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.key,b.key)}equals(b){return b.type===this.type?this.key===b.key:!1}substituteConstants(){const b=c.get(this.key);return typeof b=="boolean"?b?d.INSTANCE:o.INSTANCE:this}evaluate(b){return!!b.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(b){return b.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Ij=R;class N{static create(b,L,F=null){if(typeof L=="boolean")return L?R.create(b,F):M.create(b,F);const q=c.get(b);return typeof q=="boolean"?L===(q?"true":"false")?d.INSTANCE:o.INSTANCE:new N(b,L,F)}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.Equals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=c.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?d.INSTANCE:o.INSTANCE}return this}evaluate(b){return b.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(b){return b.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Jj=N;class C{static create(b,L){return new C(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.In,this.c=null}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.d,this.f,b.d,b.f)}equals(b){return b.type===this.type?this.d===b.d&&this.f===b.f:!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.f),F=b.getValue(this.d);return Array.isArray(L)?L.includes(F):typeof F=="string"&&typeof L=="object"&&L!==null?u.call(L,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(b){return b.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Kj=C;class D{static create(b,L){return new D(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.NotIn,this.c=C.create(b,L)}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(b){return b.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=D;class T{static create(b,L,F=null){if(typeof L=="boolean")return L?M.create(b,F):R.create(b,F);const q=c.get(b);return typeof q=="boolean"?L===(q?"true":"false")?o.INSTANCE:d.INSTANCE:new T(b,L,F)}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.NotEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){const b=c.get(this.c);if(typeof b=="boolean"){const L=b?"true":"false";return this.d===L?o.INSTANCE:d.INSTANCE}return this}evaluate(b){return b.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(b){return b.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Mj=T;class M{static create(b,L=null){const F=c.get(b);return typeof F=="boolean"?F?o.INSTANCE:d.INSTANCE:new M(b,L)}constructor(b,L){this.c=b,this.d=L,this.type=h.Not}cmp(b){return b.type!==this.type?this.type-b.type:Z(this.c,b.c)}equals(b){return b.type===this.type?this.c===b.c:!1}substituteConstants(){const b=c.get(this.c);return typeof b=="boolean"?b?o.INSTANCE:d.INSTANCE:this}evaluate(b){return!b.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(b){return b.mapNot(this.c)}negate(){return this.d||(this.d=R.create(this.c,this)),this.d}}e.$Nj=M;function K(V,b){if(typeof V=="string"){const L=parseFloat(V);isNaN(L)||(V=L)}return typeof V=="string"||typeof V=="number"?b(V):o.INSTANCE}class ae{static create(b,L,F=null){return K(L,q=>new ae(b,q,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.Greater}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Oj=ae;class ie{static create(b,L,F=null){return K(L,q=>new ie(b,q,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.GreaterEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(b){return b.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Pj=ie;class ue{static create(b,L,F=null){return K(L,q=>new ue(b,q,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.Smaller}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Qj=ue;class ce{static create(b,L,F=null){return K(L,q=>new ce(b,q,F))}constructor(b,L,F){this.c=b,this.d=L,this.f=F,this.type=h.SmallerEquals}cmp(b){return b.type!==this.type?this.type-b.type:Y(this.c,this.d,b.c,b.d)}equals(b){return b.type===this.type?this.c===b.c&&this.d===b.d:!1}substituteConstants(){return this}evaluate(b){return typeof this.d=="string"?!1:parseFloat(b.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(b){return b.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Rj=ce;class le{static create(b,L){return new le(b,L)}constructor(b,L){this.d=b,this.f=L,this.type=h.Regex,this.c=null}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.d<b.d)return-1;if(this.d>b.d)return 1;const L=this.f?this.f.source:"",F=b.f?b.f.source:"";return L<F?-1:L>F?1:0}equals(b){if(b.type===this.type){const L=this.f?this.f.source:"",F=b.f?b.f.source:"";return this.d===b.d&&L===F}return!1}substituteConstants(){return this}evaluate(b){const L=b.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const b=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${b}`}keys(){return[this.d]}map(b){return b.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$Sj=le;class x{static create(b){return new x(b)}constructor(b){this.c=b,this.type=h.NotRegex}cmp(b){return b.type!==this.type?this.type-b.type:this.c.cmp(b.c)}equals(b){return b.type===this.type?this.c.equals(b.c):!1}substituteConstants(){return this}evaluate(b){return!this.c.evaluate(b)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(b){return new x(this.c.map(b))}negate(){return this.c}}e.$Tj=x;function _(V){let b=null;for(let L=0,F=V.length;L<F;L++){const q=V[L].substituteConstants();if(V[L]!==q&&b===null){b=[];for(let Q=0;Q<L;Q++)b[Q]=V[Q]}b!==null&&(b[L]=q)}return b===null?V:b}class B{static create(b,L,F){return B.d(b,L,F)}constructor(b,L){this.expr=b,this.c=L,this.type=h.And}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,F=this.expr.length;L<F;L++){const q=n(this.expr[L],b.expr[L]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,F=this.expr.length;L<F;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:B.create(b,this.c,!1)}evaluate(b){for(let L=0,F=this.expr.length;L<F;L++)if(!this.expr[L].evaluate(b))return!1;return!0}static d(b,L,F){const q=[];let Q=!1;for(const X of b)if(X){if(X.type===h.True){Q=!0;continue}if(X.type===h.False)return o.INSTANCE;if(X.type===h.And){q.push(...X.expr);continue}q.push(X)}if(q.length===0&&Q)return d.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(n);for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];for(;q.length>1;){const X=q[q.length-1];if(X.type!==h.Or)break;q.pop();const se=q.pop(),fe=q.length===0,he=U.create(X.expr.map(Ee=>B.create([Ee,se],null,F)),null,fe);he&&(q.push(he),q.sort(n))}if(q.length===1)return q[0];if(F){for(let X=0;X<q.length;X++)for(let se=X+1;se<q.length;se++)if(q[X].negate().equals(q[se]))return o.INSTANCE;if(q.length===1)return q[0]}return new B(q,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" && ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new B(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());this.c=U.create(b,this,!0)}return this.c}}e.$Uj=B;class U{static create(b,L,F){return U.d(b,L,F)}constructor(b,L){this.expr=b,this.c=L,this.type=h.Or}cmp(b){if(b.type!==this.type)return this.type-b.type;if(this.expr.length<b.expr.length)return-1;if(this.expr.length>b.expr.length)return 1;for(let L=0,F=this.expr.length;L<F;L++){const q=n(this.expr[L],b.expr[L]);if(q!==0)return q}return 0}equals(b){if(b.type===this.type){if(this.expr.length!==b.expr.length)return!1;for(let L=0,F=this.expr.length;L<F;L++)if(!this.expr[L].equals(b.expr[L]))return!1;return!0}return!1}substituteConstants(){const b=_(this.expr);return b===this.expr?this:U.create(b,this.c,!1)}evaluate(b){for(let L=0,F=this.expr.length;L<F;L++)if(this.expr[L].evaluate(b))return!0;return!1}static d(b,L,F){let q=[],Q=!1;if(b){for(let X=0,se=b.length;X<se;X++){const fe=b[X];if(fe){if(fe.type===h.False){Q=!0;continue}if(fe.type===h.True)return d.INSTANCE;if(fe.type===h.Or){q=q.concat(fe.expr);continue}q.push(fe)}}if(q.length===0&&Q)return o.INSTANCE;q.sort(n)}if(q.length!==0){if(q.length===1)return q[0];for(let X=1;X<q.length;X++)q[X-1].equals(q[X])&&(q.splice(X,1),X--);if(q.length===1)return q[0];if(F){for(let X=0;X<q.length;X++)for(let se=X+1;se<q.length;se++)if(q[X].negate().equals(q[se]))return d.INSTANCE;if(q.length===1)return q[0]}return new U(q,L)}}serialize(){return this.expr.map(b=>b.serialize()).join(" || ")}keys(){const b=[];for(const L of this.expr)b.push(...L.keys());return b}map(b){return new U(this.expr.map(L=>L.map(b)),null)}negate(){if(!this.c){const b=[];for(const L of this.expr)b.push(L.negate());for(;b.length>1;){const L=b.shift(),F=b.shift(),q=[];for(const Q of G(L))for(const X of G(F))q.push(B.create([Q,X],null,!1));b.unshift(U.create(q,null,!1))}this.c=U.create(b,this,!0)}return this.c}}e.$Vj=U;class J extends R{static{this.d=[]}static all(){return J.d.values()}constructor(b,L,F){super(b,null),this.f=L,typeof F=="object"?J.d.push({...F,key:b}):F!==!0&&J.d.push({key:b,description:F,type:L!=null?typeof L:void 0})}bindTo(b){return b.createKey(this.key,this.f)}getValue(b){return b.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(b){return N.create(this.key,b)}notEqualsTo(b){return T.create(this.key,b)}}e.$Wj=J,e.$Xj=(0,A.$Fi)("contextKeyService");function Z(V,b){return V<b?-1:V>b?1:0}function Y(V,b,L,F){return V<L?-1:V>L?1:b<F?-1:b>F?1:0}function j(V,b){if(V.type===h.False||b.type===h.True)return!0;if(V.type===h.Or)return b.type===h.Or?z(V.expr,b.expr):!1;if(b.type===h.Or){for(const L of b.expr)if(j(V,L))return!0;return!1}if(V.type===h.And){if(b.type===h.And)return z(b.expr,V.expr);for(const L of V.expr)if(j(L,b))return!0;return!1}return V.equals(b)}function z(V,b){let L=0,F=0;for(;L<V.length&&F<b.length;){const q=V[L].cmp(b[F]);if(q<0)return!1;q===0&&L++,F++}return L===V.length}function G(V){return V.type===h.Or?V.expr:[V]}}),define(re[61],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0,e.$Xo=(0,E.$Fi)("downloadService")}),define(re[18],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,E.$Fi)("environmentService"),e.$Ni=(0,E.$Gi)(e.$Mi)}),define(re[62],oe([0,1,14,9,107,10]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=A;async function A(l,u,h,w,m,O){let p;try{await I(l,u,h,w,m,O)}catch(f){p=f}finally{p&&m.errorTransformer&&(p=m.errorTransformer(p)),typeof p<"u"&&h.error(p),h.end()}}async function I(l,u,h,w,m,O){g(O);const p=await l.open(u,{create:!1});try{g(O);let f=0,$=0,P=m&&typeof m.length=="number"?m.length:void 0,v=E.$Oe.alloc(Math.min(m.bufferSize,typeof P=="number"?P:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,i=0;do $=await l.read(p,a,v.buffer,i,v.byteLength-i),a+=$,i+=$,f+=$,typeof P=="number"&&(P-=$),i===v.byteLength&&(await h.write(w(v)),v=E.$Oe.alloc(Math.min(m.bufferSize,typeof P=="number"?P:m.bufferSize)),i=0);while($>0&&(typeof P!="number"||P>0)&&g(O)&&c(f,m));if(i>0){let s=i;typeof P=="number"&&(s=Math.min(i,P)),h.write(w(v.slice(0,s)))}}catch(f){throw(0,k.$nl)(f)}finally{await l.close(p)}}function g(l){if(l.isCancellationRequested)throw(0,S.$8)();return!0}function c(l,u){if(typeof u?.limits?.size=="number"&&l>u.limits.size)throw(0,k.$ml)((0,y.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[125],oe([0,1,94,2,52,5,10,12,8]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class c extends S.$Wc{constructor(){super(),this.a=this.B(new k.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new S.$6c),this.m=new Set,this.n=this.B(new g.$Dh(this.y())),this.r=5007,this.s=new g.$3h,this.R=!1,this.B(this.f(u=>this.t(u)))}t(u){this.u(u)&&this.z(u)}u(u){return(0,y.$Xq)(u)}async watch(u){this.s.isSettled||this.s.complete(),this.s=new g.$3h;try{this.h.clear(),this.g.clear();for(const h of u)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(u){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),u?this.y():0)}y(){return 800}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async z(u){if(this.j.has(u.correlationId))return;const h=new S.$Vc;this.j.set(u.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(u,h),this.w(!0))}C(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.w(!1)}D(u,h){this.F(u,h)?(this.P(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.G(u,h),this.m.add(u.correlationId))}F(u,h){const w=this.O?.subscribe(u.path,(m,O)=>{h.isDisposed||(m?this.D(u,h):O?.type===A.FileChangeType.ADDED&&this.H(u))});return w?(h.add(w),!0):!1}G(u,h){let w=!1;const m=(O,p)=>{if(h.isDisposed)return;const f=this.I(O),$=this.I(p),P=w;w=f,!f&&($||P)&&this.H(u)};this.P(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,E.watchFile)(u.path,{persistent:!1,interval:this.r},m)}catch(O){this.Q(`fs.watchFile() failed with error ${O} on path ${u.path} (correlationId: ${u.correlationId})`)}h.add((0,S.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,E.unwatchFile)(u.path,m)}catch(O){this.Q(`fs.unwatchFile() failed with error ${O} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}H(u){this.P(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const h={resource:I.URI.file(u.path),type:A.FileChangeType.ADDED,cId:u.correlationId};this.a.fire([h]),this.J(h,u),this.C(u)}I(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(u,h){if(this.R){const w=` >> normalized ${u.type===A.FileChangeType.ADDED?"[ADDED]":u.type===A.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.L(w,h)}}L(u,h){this.R&&this.P(`${u}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,y.$8q)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.R=u}}e.$er=c}),define(re[126],oe([0,1,5,173,125,13,174,63]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class g extends y.$er{constructor(l){super(),this.O=l,this.onDidError=E.Event.None,this.watchers=new Set}async N(l){l=this.Z(l);const u=[],h=new Set(Array.from(this.watchers));for(const w of l){const m=this.W(w);m&&(0,S.$Dk)(m.request.excludes,w.excludes)&&(0,S.$Dk)(m.request.includes,w.includes)?h.delete(m):u.push(w)}u.length&&this.P(`Request to start watching: ${u.map(w=>this.M(w)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map(w=>this.M(w.request)).join(",")}`);for(const w of h)this.Y(w);for(const w of u)this.X(w)}W(l){for(const u of this.watchers)if(typeof l.correlationId=="number"||typeof u.request.correlationId=="number"){if(u.request.correlationId===l.correlationId)return u}else if((0,I.$Dg)(u.request.path,l.path,!k.$k))return u}X(l){const u=new A.$jr(l,this.O,w=>this.a.fire(w),()=>this.c.fire(l),w=>this.b.fire(w),this.R),h={request:l,instance:u};this.watchers.add(h)}async stop(){await super.stop();for(const l of this.watchers)this.Y(l)}Y(l){this.P("stopping file watcher",l),this.watchers.delete(l),l.instance.dispose()}Z(l){const u=new Map;for(const h of l){const w=k.$k?h.path:h.path.toLowerCase();let m=u.get(h.correlationId);m||(m=new Map,u.set(h.correlationId,m)),m.has(w)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),m.set(w,h)}return Array.from(u.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(l){super.setVerboseLogging(l);for(const u of this.watchers)u.instance.setVerboseLogging(l)}P(l,u){this.R&&this.b.fire({type:"trace",message:this.bb(l,u)})}Q(l){this.b.fire({type:"warn",message:this.bb(l)})}bb(l,u){return u?`[File Watcher (node.js)] ${l} (${this.M(u.request)})`:`[File Watcher (node.js)] ${l}`}}e.$lr=g}),define(re[127],oe([0,1,52,126]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class y extends E.$1q{constructor(A,I,g){super(A,I,g),this.s()}r(A){return A.add(new S.$lr(void 0))}}e.$mr=y}),define(re[128],oe([0,1,15,59,91,52]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class A extends k.$2q{constructor(g,c,l){super(g,c,l),this.s()}r(g){const c=g.add(new y.$cr(E.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(c.onDidProcessExit(({code:l,signal:u})=>this.t(`terminated by itself with code ${l}, signal: ${u} (ETERM)`))),S.ProxyChannel.toService((0,S.$mi)(c.getChannel("watcher")))}}e.$dr=A}),define(re[64],oe([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class E{constructor(...y){this.a=new Map;for(const[k,A]of y)this.set(k,A)}set(y,k){const A=this.a.get(y);return this.a.set(y,k),A}has(y){return this.a.has(y)}get(y){return this.a.get(y)}}e.$Di=E}),define(re[129],oe([0,1,8,9,2,51,123,11,64,175]),function(H,e,E,S,y,k,A,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;const l=!1;class u extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class h{constructor(p=new g.$Di,f=!1,$,P=l){this.i=p,this.j=f,this.k=$,this.l=P,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$Ei,this),this._globalGraph=P?$?._globalGraph??new A.$pr(v=>v):void 0}dispose(){if(!this.f){this.f=!0,(0,y.$Rc)(this.h),this.h.clear();for(const p of this.g)(0,y.$Qc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p,f){this.m();const $=this,P=new class extends h{dispose(){$.h.delete(P),super.dispose()}}(p,this.j,this,this.l);return this.h.add(P),f?.add(P),P}invokeFunction(p,...f){this.m();const $=m.traceInvocation(this.l,p);let P=!1;try{return p({get:a=>{if(P)throw(0,S.$0)("service accessor is only valid during the invocation of its target method");const i=this.s(a,$);if(!i)throw new Error(`[invokeFunction] unknown service '${a}'`);return i}},...f)}finally{P=!0,$.stop()}}createInstance(p,...f){this.m();let $,P;return p instanceof k.$Ci?($=m.traceCreation(this.l,p.ctor),P=this.o(p.ctor,p.staticArguments.concat(f),$)):($=m.traceCreation(this.l,p),P=this.o(p,f,$)),$.stop(),P}o(p,f=[],$){const P=I._util.getServiceDependencies(p).sort((i,s)=>i.index-s.index),v=[];for(const i of P){const s=this.s(i.id,$);s||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${i.id}.`,!1),v.push(s)}const a=P.length>0?P[0].index:f.length;if(f.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${f.length} static arguments`);const i=a-f.length;i>0?f=f.concat(new Array(i)):f=f.slice(0,a)}return Reflect.construct(p,f.concat(v))}q(p,f){if(this.i.get(p)instanceof k.$Ci)this.i.set(p,f);else if(this.k)this.k.q(p,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const f=this.i.get(p);return!f&&this.k?this.k.r(p):f}s(p,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const $=this.r(p);return $ instanceof k.$Ci?this.u(p,$,f.branch(p,!0)):(f.branch(p,!1),$)}u(p,f,$){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,f,$)}finally{this.t.delete(p)}}v(p,f,$){const P=new A.$pr(i=>i.id.toString());let v=0;const a=[{id:p,desc:f,_trace:$}];for(;a.length;){const i=a.pop();if(P.lookupOrInsertNode(i),v++>1e3)throw new u(P);for(const s of I._util.getServiceDependencies(i.desc.ctor)){const r=this.r(s.id);if(r||this.y(`[createInstance] ${p} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),r instanceof k.$Ci){const t={id:s.id,desc:r,_trace:i._trace.branch(s.id,!0)};P.insertEdge(i,t),a.push(t)}}}for(;;){const i=P.roots();if(i.length===0){if(!P.isEmpty())throw new u(P);break}for(const{data:s}of i){if(this.r(s.id)instanceof k.$Ci){const t=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,t)}P.removeNode(s)}}return this.r(p)}w(p,f,$=[],P,v){if(this.i.get(p)instanceof k.$Ci)return this.x(p,f,$,P,v,this.g);if(this.k)return this.k.w(p,f,$,P,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(p,f,$=[],P,v,a){if(P){const i=new h(void 0,this.j,this,this.l);i.c=String(p);const s=new Map,r=new E.$Yh(()=>{const t=i.o(f,$,v);for(const[n,o]of s){const d=t[n];if(typeof d=="function")for(const R of o)R.disposable=d.apply(t,R.listener)}return s.clear(),a.add(t),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let R=s.get(n);return R||(R=new c.$7c,s.set(n,R)),(C,D,T)=>{if(r.isInitialized)return r.value[n](C,D,T);{const M={listener:[C,D,T],disposable:void 0},K=R.push(M);return(0,y.$Uc)(()=>{K(),M.disposable?.dispose()})}}}if(n in t)return t[n];const o=r.value;let d=o[n];return typeof d!="function"||(d=d.bind(o),t[n]=d),d},set(t,n,o){return r.value[n]=o,!0},getPrototypeOf(t){return f.prototype}})}else{const i=this.o(f,$,v);return a.add(i),i}}y(p,f){if(f&&console.warn(p),this.j)throw new Error(p)}}e.$qr=h;var w;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})(w||(w={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(w.None,null)}stop(){}branch(){return this}}}static traceInvocation(p,f){return p?new m(w.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(p,f){return p?new m(w.Creation,f.name):m.c}static{this.f=0}constructor(p,f){this.type=p,this.name=f,this.g=Date.now(),this.h=[]}branch(p,f){const $=new m(w.Branch,p.toString());return this.h.push([p,f,$]),$}stop(){const p=Date.now()-this.g;m.f+=p;let f=!1;function $(v,a){const i=[],s=new Array(v+1).join("	");for(const[r,t,n]of a.h)if(t&&n){f=!0,i.push(`${s}CREATES -> ${r}`);const o=$(v+1,n);o&&i.push(o)}else i.push(`${s}uses -> ${r}`);return i.join(`
`)}const P=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(p>2||f)&&m.all.add(P.join(`
`))}}e.$rr=m}),define(re[6],oe([0,1,110,38,5,43,2,31,13,17,3,12,124,11]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=O,e.log=f,e.$nk=d,e.$ok=R,e.$pk=N,e.$qk=C,E=ye(E),e.$_j=(0,w.$Fi)("logService"),e.$ak=(0,w.$Fi)("loggerService");function m(){return new Date().toISOString()}function O(D){return(0,l.$jg)(D)}var p;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$ck=p.Info;function f(D,T,M){switch(T){case p.Trace:D.trace(M);break;case p.Debug:D.debug(M);break;case p.Info:D.info(M);break;case p.Warning:D.warn(M);break;case p.Error:D.error(M);break;case p.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function $(D,T=!1){let M="";for(let K=0;K<D.length;K++){let ae=D[K];if(ae instanceof Error&&(ae=(0,S.$qj)(ae,T)),typeof ae=="object")try{ae=JSON.stringify(ae)}catch{}M+=(K>0?" ":"")+ae}return M}class P extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new y.$me),this.onDidChangeLogLevel=this.c.event}setLevel(T){this.b!==T&&(this.b=T,this.c.fire(this.b))}getLevel(){return this.b}f(T){return this.b!==p.Off&&this.b<=T}}e.$ek=P;class v extends P{constructor(T){super(),this.h=T}f(T){return this.h||super.f(T)}trace(T,...M){this.f(p.Trace)&&this.g(p.Trace,$([T,...M],!0))}debug(T,...M){this.f(p.Debug)&&this.g(p.Debug,$([T,...M]))}info(T,...M){this.f(p.Info)&&this.g(p.Info,$([T,...M]))}warn(T,...M){this.f(p.Warning)&&this.g(p.Warning,$([T,...M]))}error(T,...M){if(this.f(p.Error))if(T instanceof Error){const K=Array.prototype.slice.call(arguments);K[0]=T.stack,this.g(p.Error,$(K))}else this.g(p.Error,$([T,...M]))}flush(){}}e.$fk=v;class a extends P{constructor(T=e.$ck){super(),this.setLevel(T),this.g=!g.$i}trace(T,...M){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...M):console.log(`[main ${m()}]`,T,...M))}debug(T,...M){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...M):console.log(`[main ${m()}]`,T,...M))}info(T,...M){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,T,...M):console.log(`[main ${m()}]`,T,...M))}warn(T,...M){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,T,...M):console.warn(`[main ${m()}]`,T,...M))}error(T,...M){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,T,...M):console.error(`[main ${m()}]`,T,...M))}flush(){}}e.$gk=a;class i extends P{constructor(T=e.$ck,M=!0){super(),this.g=M,this.setLevel(T)}trace(T,...M){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",T,...M):console.log(T,...M))}debug(T,...M){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",T,...M):console.log(T,...M))}info(T,...M){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",T,...M):console.log(T,...M))}warn(T,...M){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",T,...M):console.log(T,...M))}error(T,...M){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",T,...M):console.error(T,...M))}flush(){}}e.$hk=i;class s extends P{constructor(T,M=e.$ck){super(),this.g=T,this.setLevel(M)}trace(T,...M){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(T),...M])}debug(T,...M){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(T),...M])}info(T,...M){this.f(p.Info)&&this.g.log(p.Info,[this.h(T),...M])}warn(T,...M){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(T),...M])}error(T,...M){this.f(p.Error)&&this.g.log(p.Error,[this.h(T),...M])}h(T){return typeof T=="string"?T:(0,S.$qj)(T,this.f(p.Trace))}flush(){}}e.$ik=s;class r extends P{constructor(T){super(),this.g=T,T.length&&this.setLevel(T[0].getLevel())}setLevel(T){for(const M of this.g)M.setLevel(T);super.setLevel(T)}trace(T,...M){for(const K of this.g)K.trace(T,...M)}debug(T,...M){for(const K of this.g)K.debug(T,...M)}info(T,...M){for(const K of this.g)K.info(T,...M)}warn(T,...M){for(const K of this.g)K.warn(T,...M)}error(T,...M){for(const K of this.g)K.error(T,...M)}flush(){for(const T of this.g)T.flush()}dispose(){for(const T of this.g)T.dispose();super.dispose()}}e.$jk=r;class t extends A.$Wc{constructor(T,M,K){if(super(),this.h=T,this.j=M,this.b=new I.$Cc,this.c=this.B(new y.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new y.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new y.$me),this.onDidChangeVisibility=this.g.event,K)for(const ae of K)this.b.set(ae.resource,{logger:void 0,info:ae})}m(T){return(0,l.$fg)(T)?[...this.b.values()].find(M=>M.info.id===T):this.b.get(T)}getLogger(T){return this.m(T)?.logger}createLogger(T,M){const K=this.n(T),ae=(0,l.$fg)(T)?T:M?.id??(0,k.$tj)(K.toString()).toString(16);let ie=this.b.get(K)?.logger;const ue=M?.logLevel==="always"?p.Trace:M?.logLevel;ie||(ie=this.s(K,ue??this.getLogLevel(K)??this.h,{...M,id:ae}));const ce={logger:ie,info:{resource:K,id:ae,logLevel:ue,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(ce.info),this.b.set(K,ce),ie}n(T){return(0,l.$fg)(T)?(0,c.$gh)(this.j,`${T}.log`):T}setLogLevel(T,M){if(u.URI.isUri(T)){const K=T,ae=M,ie=this.b.get(K);ie&&ae!==ie.info.logLevel&&(ie.info.logLevel=ae===this.h?void 0:ae,ie.logger?.setLevel(ae),this.b.set(ie.info.resource,ie),this.f.fire([K,ae]))}else{this.h=T;for(const[K,ae]of this.b.entries())this.b.get(K)?.info.logLevel===void 0&&ae.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(T,M){const K=this.m(T);K&&M!==!K.info.hidden&&(K.info.hidden=!M,this.b.set(K.info.resource,K),this.g.fire([K.info.resource,M]))}getLogLevel(T){let M;return T&&(M=this.b.get(T)?.info.logLevel),M??this.h}registerLogger(T){const M=this.b.get(T.resource);M?M.info.hidden!==T.hidden&&this.setVisibility(T.resource,!T.hidden):(this.b.set(T.resource,{info:T,logger:void 0}),this.c.fire({added:[T],removed:[]}))}deregisterLogger(T){const M=this.b.get(T);M&&(M.logger&&M.logger.dispose(),this.b.delete(T),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const T of this.b.values())yield T.info}getRegisteredLogger(T){return this.b.get(T)?.info}dispose(){this.b.forEach(T=>T.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=t;class n{constructor(){this.onDidChangeLogLevel=new y.$me().event}setLevel(T){}getLevel(){return p.Info}trace(T,...M){}debug(T,...M){}info(T,...M){}warn(T,...M){}error(T,...M){}critical(T,...M){}dispose(){}flush(){}}e.$lk=n;class o extends n{}e.$mk=o;function d(D){if(D.verbose)return p.Trace;if(typeof D.logLevel=="string"){const T=C(D.logLevel.toLowerCase());if(T!==void 0)return T}return e.$ck}function R(D){switch(D){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function N(D){switch(D){case p.Trace:return{original:"Trace",value:E.localize(0,null)};case p.Debug:return{original:"Debug",value:E.localize(1,null)};case p.Info:return{original:"Info",value:E.localize(2,null)};case p.Warning:return{original:"Warning",value:E.localize(3,null)};case p.Error:return{original:"Error",value:E.localize(4,null)};case p.Off:return{original:"Off",value:E.localize(5,null)}}}function C(D){switch(D){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$rk=new h.$Wj("logLevel",R(p.Info))}),define(re[130],oe([0,1,20,8,9,5,63,2,16,52,6]),function(H,e,E,S,y,k,A,I,g,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class u extends I.$Wc{constructor(w,m){super(),this.a=w,this.b=m,this.c=this.B(new k.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new S.$Dh(0)),this.w=[],this.y=this.B(new S.$Dh(0))}watch(w,m){return m.recursive||this.b?.watcher?.forceUniversal?this.n(w,m):this.z(w,m)}n(w,m){const O={path:this.J(w),excludes:m.excludes,includes:m.includes,recursive:m.recursive,filter:m.filter,correlationId:m.correlationId},p=(0,E.$Vb)(this.j,O);return this.r(),(0,I.$Uc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,y.$3)(w))}s(){this.h||(this.h=this.B(this.t(m=>this.c.fire((0,c.$3q)(m)),m=>this.G(m),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const m of this.j)(0,c.$Yq)(m)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const m of this.j)(0,c.$Yq)(m)&&w.includes(m.path)&&(m.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,m){const O={path:this.J(w),excludes:m.excludes,includes:m.includes,recursive:!1,filter:m.filter,correlationId:m.correlationId},p=(0,E.$Vb)(this.w,O);return this.C(),(0,I.$Uc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,y.$3)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,c.$3q)(w)),w=>this.G(w),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,g.$jc)(w.fsPath)}J(w){const m=this.I(w);return(0,A.$Hg)(m)}}e.$9q=u});var ne=this&&this.__param||function(H,e){return function(E,S){e(E,S,H)}};define(re[131],oe([0,1,20,8,14,22,5,43,65,2,48,15,132,17,46,106,10,62,6,9]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;let a=class extends c.$Wc{static{v=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new A.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$me),this.Y=this.B(new A.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new S.$Oh)}registerProvider(s,r){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const t=new c.$Vc;return this.h.set(s,r),this.c.fire({added:!0,scheme:s,provider:r}),t.add(r.onDidChangeFile(n=>{const o=new p.$sl(n,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:s}))),(0,c.$Uc)(()=>{this.c.fire({added:!1,scheme:s,provider:r}),this.h.delete(s),(0,c.$Rc)(t)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const r=[];this.f.fire({scheme:s,join(t){r.push(t)}}),!this.h.has(s)&&await S.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,r){const t=this.h.get(s.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return g.Iterable.map(this.h,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async j(s){if(!(0,w.$kh)(s))throw new p.$ul((0,O.localize)(0,null,this.sb(s)),p.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const r=this.h.get(s.scheme);if(!r){const t=new P.$db;throw t.message=(0,O.localize)(1,null,s.toString()),t}return r}async m(s){const r=await this.j(s);if((0,p.$fl)(r)||(0,p.$cl)(r)||(0,p.$gl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const r=await this.j(s);if((0,p.$fl)(r)||(0,p.$cl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.s(s,r)}catch(t){throw(0,p.$pl)(t)===p.FileSystemProviderErrorCode.FileNotFound?new p.$ul((0,O.localize)(2,null,this.sb(s)),p.FileOperationResult.FILE_NOT_FOUND):(0,p.$nl)(t)}}async s(s,r){const t=await this.j(s),n=this.S(t),o=r?.resolveTo,d=r?.resolveSingleChildDescendants,R=r?.resolveMetadata,N=await t.stat(s);let C;return this.t(t,s,N,void 0,!!R,(D,T)=>(C||(C=l.$Li.forUris(()=>!n),C.set(s,!0),o&&C.fill(!0,o)),C.get(D.resource)||C.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&d?T===1:!1))}async t(s,r,t,n,o,d){const{providerExtUri:R}=this.R(s),N={resource:r,name:R.basename(r),isFile:(t.type&p.FileType.File)!==0,isDirectory:(t.type&p.FileType.Directory)!==0,isSymbolicLink:(t.type&p.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&p.FilePermission.Readonly)||!!(s.capabilities&p.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&p.FilePermission.Locked),etag:(0,p.$Fl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&d(N,n)){try{const C=await s.readdir(r),D=await S.Promises.settled(C.map(async([T,M])=>{try{const K=R.joinPath(r,T),ae=o?await s.stat(K):{type:M};return await this.t(s,K,ae,C.length,o,d)}catch(K){return this.b.trace(K),null}}));N.children=(0,E.$Jb)(D)}catch(C){this.b.trace(C),N.children=[]}return N}return N}async resolveAll(s){return S.Promises.settled(s.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.j(s),t=await r.stat(s);return this.t(r,s,t,void 0,!0,()=>!1)}async exists(s){const r=await this.j(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.u(s,r)}catch(t){return t}return!0}async u(s,r){if(!r?.overwrite&&await this.exists(s))throw new p.$ul((0,O.localize)(3,null,this.sb(s)),p.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(s,r=y.$Oe.fromString(""),t){await this.u(s,t);const n=await this.writeFile(s,r);return this.r.fire(new p.$rl(s,p.FileOperation.CREATE,n)),n}async writeFile(s,r,t){const n=this.qb(await this.n(s),s),{providerExtUri:o}=this.R(n);let d=t;if((0,p.$il)(n)&&!d?.atomic){const R=n.enforceAtomicWriteFile?.(s);R&&(d={...t,atomic:R})}try{await this.w(n,s,d)||await this.U(n,o.dirname(s));let N;if((0,p.$cl)(n)&&!(r instanceof y.$Oe))if((0,m.$Ae)(r)){const C=await(0,m.$He)(r,3);C.ended?N=y.$Oe.concat(C.buffer):N=C}else N=(0,m.$Ee)(r,C=>y.$Oe.concat(C),3);else N=r;!(0,p.$fl)(n)||(0,p.$cl)(n)&&N instanceof y.$Oe||(0,p.$cl)(n)&&(0,p.$il)(n)&&d?.atomic?await this.hb(n,s,d,N):await this.db(n,s,d,N instanceof y.$Oe?(0,y.$Ze)(N):N),this.r.fire(new p.$rl(s,p.FileOperation.WRITE))}catch(R){throw new p.$ul((0,O.localize)(4,null,this.sb(s),(0,p.$nl)(R).toString()),(0,p.$ql)(R),d)}return this.resolve(s,{resolveMetadata:!0})}async w(s,r,t){const n=!!t?.unlock;if(n&&!(s.capabilities&p.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,O.localize)(5,null,this.sb(r)));if(!!t?.atomic){if(!(s.capabilities&p.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,O.localize)(6,null,this.sb(r)));if(!(s.capabilities&p.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,O.localize)(7,null,this.sb(r)));if(n)throw new Error((0,O.localize)(8,null,this.sb(r)))}let d;try{d=await s.stat(r)}catch{return}if(d.type&p.FileType.Directory)throw new p.$ul((0,O.localize)(9,null,this.sb(r)),p.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(r,d),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==p.$El&&typeof d.mtime=="number"&&typeof d.size=="number"&&t.mtime<d.mtime&&t.etag!==(0,p.$Fl)({mtime:t.mtime,size:d.size}))throw new p.$ul((0,O.localize)(10,null),p.FileOperationResult.FILE_MODIFIED_SINCE,t);return d}async readFile(s,r,t){const n=await this.m(s);return r?.atomic?this.z(n,s,r,t):this.C(n,s,r,t)}async z(s,r,t,n){return new Promise((o,d)=>{this.cb.queueFor(r,async()=>{try{const R=await this.C(s,r,t,n);o(R)}catch(R){d(R)}},this.R(s).providerExtUri)})}async C(s,r,t,n){const o=await this.D(s,r,{...t,preferUnbuffered:!0},n);return{...o,value:await(0,y.$1e)(o.value)}}async readFileStream(s,r,t){const n=await this.m(s);return this.D(n,s,r,t)}async D(s,r,t,n){const o=new k.$xe(n);let d=t;(0,p.$hl)(s)&&s.enforceAtomicReadFile?.(r)&&(d={...t,atomic:!0});const R=this.J(r,d).then(C=>C,C=>{throw o.dispose(!0),C});let N;try{return typeof d?.etag=="string"&&d.etag!==p.$El&&await R,d?.atomic&&(0,p.$hl)(s)||!((0,p.$fl)(s)||(0,p.$gl)(s))||(0,p.$cl)(s)&&d?.preferUnbuffered?N=this.I(s,r,d):(0,p.$gl)(s)?N=this.G(s,r,o.token,d):N=this.H(s,r,o.token,d),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await R,value:N}}catch(C){throw N&&await(0,m.$Fe)(N),this.F(C,r,d)}}F(s,r,t){const n=(0,O.localize)(11,null,this.sb(r),(0,p.$nl)(s).toString());return s instanceof p.$wl?new p.$wl(n,s.stat,t):s instanceof p.$vl?new p.$vl(n,s.fileOperationResult,s.size,s.options):new p.$ul(n,(0,p.$ql)(s),t)}G(s,r,t,n=Object.create(null)){const o=s.readFileStream(r,n,t);return(0,m.$Le)(o,{data:d=>d instanceof y.$Oe?d:y.$Oe.wrap(d),error:d=>this.F(d,r,n)},d=>y.$Oe.concat(d))}H(s,r,t,n=Object.create(null)){const o=(0,y.$5e)();return(0,f.$Vq)(s,r,o,d=>d,{...n,bufferSize:this.a,errorTransformer:d=>this.F(d,r,n)},t),o}I(s,r,t){const n=(0,m.$Ce)(o=>y.$Oe.concat(o));return(async()=>{try{let o;t?.atomic&&(0,p.$hl)(s)?o=await s.readFile(r,{atomic:!0}):o=await s.readFile(r),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(r,o.byteLength,t),n.end(y.$Oe.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(s,r){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new p.$ul((0,O.localize)(12,null,this.sb(s)),p.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==p.$El&&r.etag===t.etag)throw new p.$wl((0,O.localize)(13,null),t,r);return this.L(s,t.size,r),t}L(s,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new p.$vl((0,O.localize)(14,null,this.sb(s)),p.FileOperationResult.FILE_TOO_LARGE,r,t)}async canMove(s,r,t){return this.M(s,r,"move",t)}async canCopy(s,r,t){return this.M(s,r,"copy",t)}async M(s,r,t,n){if(s.toString()!==r.toString())try{const o=t==="move"?this.qb(await this.n(s),s):await this.m(s),d=this.qb(await this.n(r),r);await this.Q(o,s,d,r,t,n)}catch(o){return o}return!0}async move(s,r,t){const n=this.qb(await this.n(s),s),o=this.qb(await this.n(r),r),d=await this.N(n,s,o,r,"move",!!t),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$rl(s,d==="move"?p.FileOperation.MOVE:p.FileOperation.COPY,R)),R}async copy(s,r,t){const n=await this.m(s),o=this.qb(await this.n(r),r),d=await this.N(n,s,o,r,"copy",!!t),R=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$rl(s,d==="copy"?p.FileOperation.COPY:p.FileOperation.MOVE,R)),R}async N(s,r,t,n,o,d){if(r.toString()===n.toString())return o;const{exists:R,isSameResourceWithDifferentPathCase:N}=await this.Q(s,r,t,n,o,d);if(R&&!N&&d&&await this.del(n,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(n)),o==="copy"){if(s===t&&(0,p.$dl)(s))await s.copy(r,n,{overwrite:d});else{const C=await this.resolve(r);C.isDirectory?await this.P(s,C,t,n):await this.O(s,r,t,n)}return o}else return s===t?(await s.rename(r,n,{overwrite:d}),o):(await this.N(s,r,t,n,"copy",d),await this.del(r,{recursive:!0}),"copy")}async O(s,r,t,n){if((0,p.$fl)(s)&&(0,p.$fl)(t))return this.jb(s,r,t,n);if((0,p.$fl)(s)&&(0,p.$cl)(t))return this.pb(s,r,t,n);if((0,p.$cl)(s)&&(0,p.$fl)(t))return this.nb(s,r,t,n);if((0,p.$cl)(s)&&(0,p.$cl)(t))return this.lb(s,r,t,n)}async P(s,r,t,n){await t.mkdir(n),Array.isArray(r.children)&&await S.Promises.settled(r.children.map(async o=>{const d=this.R(t).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(s,await this.resolve(o.resource),t,d):this.O(s,o.resource,t,d)}))}async Q(s,r,t,n,o,d){let R=!1;if(s===t){const{providerExtUri:C,isPathCaseSensitive:D}=this.R(s);if(D||(R=C.isEqual(r,n)),R&&o==="copy")throw new Error((0,O.localize)(15,null,this.sb(r),this.sb(n)));if(!R&&C.isEqualOrParent(n,r))throw new Error((0,O.localize)(16,null,this.sb(r),this.sb(n)))}const N=await this.exists(n);if(N&&!R){if(!d)throw new p.$ul((0,O.localize)(17,null,this.sb(r),this.sb(n)),p.FileOperationResult.FILE_MOVE_CONFLICT);if(s===t){const{providerExtUri:C}=this.R(s);if(C.isEqualOrParent(r,n))throw new Error((0,O.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:N,isSameResourceWithDifferentPathCase:R}}R(s){const r=this.S(s);return{providerExtUri:r?w.$9g:w.$$g,isPathCaseSensitive:r}}S(s){return!!(s.capabilities&p.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const r=this.qb(await this.j(s),s);await this.U(r,s);const t=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$rl(s,p.FileOperation.CREATE,t)),t}async U(s,r){const t=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await s.stat(r)).type&p.FileType.Directory))throw new Error((0,O.localize)(19,null,this.sb(r)));break}catch(o){if((0,p.$pl)(o)!==p.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(n.basename(r)),r=n.dirname(r)}for(let o=t.length-1;o>=0;o--){r=n.joinPath(r,t[o]);try{await s.mkdir(r)}catch(d){if((0,p.$pl)(d)!==p.FileSystemProviderErrorCode.FileExists)throw d}}}async canDelete(s,r){try{await this.W(s,r)}catch(t){return t}return!0}async W(s,r){const t=this.qb(await this.j(s),s),n=!!r?.useTrash;if(n&&!(t.capabilities&p.FileSystemProviderCapabilities.Trash))throw new Error((0,O.localize)(20,null,this.sb(s)));const o=r?.atomic;if(o&&!(t.capabilities&p.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,O.localize)(21,null,this.sb(s)));if(n&&o)throw new Error((0,O.localize)(22,null,this.sb(s)));let d;try{d=await t.stat(s)}catch{}if(d)this.rb(s,d);else throw new p.$ul((0,O.localize)(23,null,this.sb(s)),p.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const N=await this.resolve(s);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,O.localize)(24,null,this.sb(s)))}return t}async del(s,r){const t=await this.W(s,r);let n=r;if((0,p.$jl)(t)&&!n?.atomic){const N=t.enforceAtomicDelete?.(s);N&&(n={...r,atomic:N})}const o=!!n?.useTrash,d=!!n?.recursive,R=n?.atomic??!1;await t.delete(s,{recursive:d,useTrash:o,atomic:R}),this.r.fire(new p.$rl(s,p.FileOperation.DELETE))}async cloneFile(s,r){const t=await this.j(s),n=this.qb(await this.n(r),r);if(!(t===n&&this.R(t).providerExtUri.isEqual(s,r)))return t===n&&(0,p.$el)(t)?t.cloneFile(s,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),t===n&&(0,p.$dl)(t)?this.cb.queueFor(s,()=>t.copy(s,r,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(s,()=>this.O(t,s,n,r),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:v.ab++})}watch(s,r={recursive:!1,excludes:[]}){const t=new c.$Vc;let n=!1,o=()=>{n=!0};t.add((0,c.$Uc)(()=>o())),(async()=>{try{const R=await this.bb(s,r);n?(0,c.$Rc)(R):o=()=>(0,c.$Rc)(R)}catch(R){this.b.error(R)}})();const d=r.correlationId;if(typeof d=="number"){const R=t.add(new A.$me);return t.add(this.X.event(C=>{C.correlates(d)&&R.fire(C)})),{onDidChange:R.event,dispose:()=>t.dispose()}}return t}async bb(s,r){const t=await this.j(s),n=(0,I.$tj)([this.R(t).providerExtUri.getComparisonKey(s),r]);let o=this.$.get(n);return o||(o={count:0,disposable:t.watch(s,r)},this.$.set(n,o)),o.count+=1,(0,c.$Uc)(()=>{o&&(o.count--,o.count===0&&((0,c.$Rc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,c.$Rc)(s.disposable);this.$.clear()}async db(s,r,t,n){return this.cb.queueFor(r,async()=>{const o=await s.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,m.$Ae)(n)||(0,m.$Be)(n)?await this.eb(s,o,n):await this.fb(s,o,n)}catch(d){throw(0,p.$nl)(d)}finally{await s.close(o)}},this.R(s).providerExtUri)}async eb(s,r,t){let n=0,o;if((0,m.$Be)(t)){if(t.buffer.length>0){const d=y.$Oe.concat(t.buffer);await this.gb(s,r,d,d.byteLength,n,0),n+=d.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((d,R)=>{(0,m.$Ge)(o,{onData:async N=>{o.pause();try{await this.gb(s,r,N,N.byteLength,n,0)}catch(C){return R(C)}n+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>R(N),onEnd:()=>d()})})}async fb(s,r,t){let n=0,o;for(;(o=t.read())!==null;)await this.gb(s,r,o,o.byteLength,n,0),n+=o.byteLength}async gb(s,r,t,n,o,d){let R=0;for(;R<n;){const N=await s.write(r,o+R,t.buffer,d+R,n-R);R+=N}}async hb(s,r,t,n){return this.cb.queueFor(r,()=>this.ib(s,r,t,n),this.R(s).providerExtUri)}async ib(s,r,t,n){let o;n instanceof y.$Oe?o=n:(0,m.$Ae)(n)?o=await(0,y.$1e)(n):(0,m.$Be)(n)?o=await(0,y.$2e)(n):o=(0,y.$Ye)(n),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(s,r,t,n){return this.cb.queueFor(n,()=>this.kb(s,r,t,n),this.R(t).providerExtUri)}async kb(s,r,t,n){let o,d;try{o=await s.open(r,{create:!1}),d=await t.open(n,{create:!0,unlock:!1});const R=y.$Oe.alloc(this.a);let N=0,C=0,D=0;do D=await s.read(o,N,R.buffer,C,R.byteLength-C),await this.gb(t,d,R,D,N,C),N+=D,C+=D,C===R.byteLength&&(C=0);while(D>0)}catch(R){throw(0,p.$nl)(R)}finally{await S.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof d=="number"?t.close(d):Promise.resolve()])}}async lb(s,r,t,n){return this.cb.queueFor(n,()=>this.mb(s,r,t,n),this.R(t).providerExtUri)}async mb(s,r,t,n){return t.writeFile(n,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,r,t,n){return this.cb.queueFor(n,()=>this.ob(s,r,t,n),this.R(t).providerExtUri)}async ob(s,r,t,n){const o=await t.open(n,{create:!0,unlock:!1});try{const d=await s.readFile(r);await this.gb(t,o,y.$Oe.wrap(d),d.byteLength,0,0)}catch(d){throw(0,p.$nl)(d)}finally{await t.close(o)}}async pb(s,r,t,n){const o=await(0,y.$1e)(this.H(s,r,k.CancellationToken.None));await this.hb(t,n,void 0,o)}qb(s,r){if(s.capabilities&p.FileSystemProviderCapabilities.Readonly)throw new p.$ul((0,O.localize)(25,null,this.sb(r)),p.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,r){if((r.permissions??0)&p.FilePermission.Readonly)throw new p.$ul((0,O.localize)(26,null,this.sb(s)),p.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===u.Schemas.file?s.fsPath:s.toString(!0)}};e.$Wq=a,e.$Wq=a=v=we([ne(0,$.$_j)],a)}),define(re[133],oe([0,1,8,31,14,5,63,2,16,13,17,46,25,108,10,62,130,128,127]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class P extends p.$9q{static{this.L=!1}constructor(a,i){super(a,i),this.onDidChangeCapabilities=k.Event.None,this.P=new S.$Cc(s=>l.$0g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=m.FileSystemProviderCapabilities.FileReadWrite|m.FileSystemProviderCapabilities.FileOpenReadWriteClose|m.FileSystemProviderCapabilities.FileReadStream|m.FileSystemProviderCapabilities.FileFolderCopy|m.FileSystemProviderCapabilities.FileWriteUnlock|m.FileSystemProviderCapabilities.FileAtomicRead|m.FileSystemProviderCapabilities.FileAtomicWrite|m.FileSystemProviderCapabilities.FileAtomicDelete|m.FileSystemProviderCapabilities.FileClone,c.$k&&(this.M|=m.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(a){try{const{stat:i,symbolicLink:s}=await h.SymlinkSupport.stat(this.I(a));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:m.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(a){try{return await this.stat(a)}catch{return}}async readdir(a){try{const i=await h.Promises.readdir(this.I(a),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async r=>{try{let t;r.isSymbolicLink()?t=(await this.stat((0,l.$gh)(a,r.name))).type:t=this.O(r),s.push([r.name,t])}catch(t){this.a.trace(t)}})),s}catch(i){throw this.hb(i)}}O(a,i){let s;return i?.dangling?s=m.FileType.Unknown:a.isFile()?s=m.FileType.File:a.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,i&&(s|=m.FileType.SymbolicLink),s}async Q(a){const i=this.I(a);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(a);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const r=new E.$Eh;return this.P.set(a,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(a)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(a)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(a,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(a)})`),s=await this.Q(a));const r=this.I(a);return await h.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{s?.dispose()}}R(a){P.L&&this.a.trace(a)}readFileStream(a,i,s){const r=(0,u.$Ce)(t=>y.$Oe.concat(t.map(n=>y.$Oe.wrap(n))).buffer);return(0,O.$Vq)(this,a,r,t=>t.buffer,{...i,bufferSize:256*1024},s),r}async writeFile(a,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(a)?this.U(a,(0,l.$gh)((0,l.$fh)(a),`${(0,l.$dh)(a)}${s.atomic.postfix}`),i,s):this.W(a,i,s)}async S(a){try{const i=this.I(a),{symbolicLink:s}=await h.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(a,i,s,r){const t=new I.$Vc;try{t.add(await this.Q(a)),t.add(await this.Q(i)),await this.W(i,s,r,!0);try{await this.rename(i,a,{overwrite:!0})}catch(n){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{t.dispose()}}async W(a,i,s,r){let t;try{const n=this.I(a);if(!s.create||!s.overwrite){if(await h.Promises.exists(n)){if(!s.overwrite)throw(0,m.$ml)((0,w.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$ml)((0,w.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}t=await this.open(a,{create:!0,unlock:s.unlock},r),await this.write(t,0,i,0,i.byteLength)}catch(n){throw await this.ib(a,n)}finally{typeof t=="number"&&await this.close(t)}}static{this.$=!0}static configureFlushOnWrite(a){P.$=a}async open(a,i,s){const r=this.I(a);let t;(0,m.$al)(i)&&!s&&(t=await this.Q(a));let n;try{if((0,m.$al)(i)&&i.unlock)try{const{stat:d}=await h.SymlinkSupport.stat(r);d.mode&128||await h.Promises.chmod(r,d.mode|128)}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}let o;if((0,m.$al)(i)){if(c.$i)try{await h.Promises.truncate(r,0),o="r+"}catch(d){d.code!=="ENOENT"&&this.a.trace(d)}o||(o="w")}else o="r";n=await h.Promises.open(r,o)}catch(o){throw t?.dispose(),(0,m.$al)(i)?await this.ib(a,o):this.hb(o)}if(this.X.set(n,0),(0,m.$al)(i)&&this.Z.set(n,a),t){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${r})`),this.Y.set(n,t),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${r})`),o.dispose())}return n}async close(a){const i=this.Y.get(a);try{if(this.X.delete(a),this.Z.delete(a)&&P.$)try{await h.Promises.fdatasync(a)}catch(s){P.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(a)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(a)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${a}`),this.Y.delete(a)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${a}`),i.dispose())}}async read(a,i,s,r,t){const n=this.ab(a,i);let o=null;try{o=(await h.Promises.read(a,s,r,t,n)).bytesRead}catch(d){throw this.hb(d)}finally{this.bb(a,n,o)}return o}ab(a,i){return i===this.X.get(a)?null:i}bb(a,i,s){const r=this.X.get(a);typeof r=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(a,r+s):this.X.delete(a)))}async write(a,i,s,r,t){return(0,E.$Zh)(()=>this.cb(a,i,s,r,t),100,3)}async cb(a,i,s,r,t){const n=this.ab(a,i);let o=null;try{o=(await h.Promises.write(a,s,r,t,n)).bytesWritten}catch(d){throw await this.ib(this.Z.get(a),d)}finally{this.bb(a,n,o)}return o}async mkdir(a){try{await h.Promises.mkdir(this.I(a))}catch(i){throw this.hb(i)}}async delete(a,i){try{const s=this.I(a);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,g.$lc)((0,g.$oc)(s),`${(0,g.$pc)(s)}${i.atomic.postfix}`)),await h.Promises.rm(s,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let t=!1;try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(s);t=n.isDirectory()&&!o}catch{}if(t)await h.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.hb(s)}}async rename(a,i,s){const r=this.I(a),t=this.I(i);if(r!==t)try{await this.db(a,i,"move",s.overwrite),await h.Promises.rename(r,t)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,w.localize)(2,null,(0,g.$pc)(r),(0,g.$pc)((0,g.$oc)(t)),n.toString()))),this.hb(n)}}async copy(a,i,s){const r=this.I(a),t=this.I(i);if(r!==t)try{await this.db(a,i,"copy",s.overwrite),await h.Promises.copy(r,t,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,w.localize)(3,null,(0,g.$pc)(r),(0,g.$pc)((0,g.$oc)(t)),n.toString()))),this.hb(n)}}async db(a,i,s,r){const t=this.I(a),n=this.I(i);let o=!1;if(!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,A.$Dg)(t,n,!0)),o){if(s==="copy")throw(0,m.$ml)((0,w.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const R=await this.N(a);if(!R)throw(0,m.$ml)((0,w.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const N=await this.N(i);if(N){if(!r)throw(0,m.$ml)((0,w.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);R.type&m.FileType.File&&N.type&m.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(a,i){return this.eb(a,i,!1)}async eb(a,i,s){const r=this.I(a),t=this.I(i),n=!!(this.capabilities&m.FileSystemProviderCapabilities.PathCaseSensitive);if((0,A.$Dg)(r,t,!n))return;const o=new I.$Vc;try{o.add(await this.Q(a)),o.add(await this.Q(i)),s&&await h.Promises.mkdir((0,g.$oc)(t),{recursive:!0}),await h.Promises.copyFile(r,t)}catch(d){if(d.code==="ENOENT"&&!s)return this.eb(a,i,!0);throw this.hb(d)}finally{o.dispose()}}t(a,i,s){return new f.$dr(r=>a(r),r=>i(r),s)}F(a,i,s){return new $.$mr(r=>a(r),r=>i(r),s)}hb(a){if(a instanceof m.$ll)return a;let i=a,s;switch(a.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${a.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$ml)(i,s)}async ib(a,i){let s=this.hb(i);if(a&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(a));r.mode&128||(s=(0,m.$ml)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$nr=P}),define(re[134],oe([0,1,2,6]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;class y extends E.$Wc{constructor(A,I=[]){super(),this.a=new S.$jk([A,...I]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$kR=y}),define(re[135],oe([0,1,10,6]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=void 0;var y;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(y||(y={}));async function k(c,l,u,h,w){try{const m=await new Promise((p,f)=>{H(["@vscode/spdlog"],p,f)}).then(ye);m.setFlushOn(y.Trace);const O=await m.createAsyncRotatingLogger(c,l,u,h);return w?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(m){console.error(m)}return null}function A(c,l,u){switch(l){case S.LogLevel.Trace:c.trace(u);break;case S.LogLevel.Debug:c.debug(u);break;case S.LogLevel.Info:c.info(u);break;case S.LogLevel.Warning:c.warn(u);break;case S.LogLevel.Error:c.error(u);break;case S.LogLevel.Off:break;default:throw new Error(`Invalid log level ${l}`)}}function I(c,l){switch(l){case S.LogLevel.Trace:c.setLevel(y.Trace);break;case S.LogLevel.Debug:c.setLevel(y.Debug);break;case S.LogLevel.Info:c.setLevel(y.Info);break;case S.LogLevel.Warning:c.setLevel(y.Warning);break;case S.LogLevel.Error:c.setLevel(y.Error);break;case S.LogLevel.Off:c.setLevel(y.Off);break;default:throw new Error(`Invalid log level ${l}`)}}class g extends S.$fk{constructor(l,u,h,w,m){super(),this.m=[],this.setLevel(m),this.n=this.s(l,u,h,w),this.B(this.onDidChangeLogLevel(O=>{this.r&&I(this.r,O)}))}async s(l,u,h,w){const m=h?6:1,O=30/m*E.$Hl.MB,p=await k(l,u,O,m,w);if(p){this.r=p,I(this.r,this.getLevel());for(const{level:f,message:$}of this.m)A(this.r,f,$);this.m=[]}}g(l,u){this.r?A(this.r,l,u):this.getLevel()<=l&&this.m.push({level:l,message:u})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$_Q=g}),define(re[136],oe([0,1,29,6,135]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aR=void 0;class k extends S.$kk{s(I,g,c){return new y.$_Q((0,E.$2g)(),I.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,g)}}e.$aR=k}),define(re[39],oe([0,1,5,65,2,11]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=void 0,e.$ro=(0,k.$Fi)("policy");class A extends y.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const l=Object.keys(this.f).length;return this.f={...c,...this.f},l!==Object.keys(this.f).length&&await this.j(c),S.Iterable.reduce(this.g.entries(),(u,[h,w])=>({...u,[h]:w}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return S.Iterable.reduce(Object.entries(this.f),(c,[l,u])=>({...c,[l]:{definition:u,value:this.g.get(l)}}),{})}}e.$so=A;class I{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$to=I}),define(re[137],oe([0,1,8,5,65,3,10,6,39]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;function c(u,h){const w=[];for(const m of new Set(y.Iterable.concat(u.keys(),h.keys())))u.get(m)!==h.get(m)&&w.push(m);return w}let l=class extends g.$so{constructor(h,w,m){super(),this.m=h,this.n=w,this.s=m,this.c=this.B(new E.$Dh(500));const O=S.Event.filter(w.onDidFilesChange,p=>p.affects(h));this.B(w.watch(h)),this.B(O(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const h=new Map;try{const w=await this.n.readFile(this.m),m=JSON.parse(w.value.toString());if(!(0,k.$hg)(m))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(m))this.f[O]&&h.set(O,m[O])}catch(w){w.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",w)}return h}async w(){const h=await this.u(),w=c(this.g,h);this.g=h,w.length>0&&this.h.fire(w)}};e.$_fc=l,e.$_fc=l=we([ne(1,A.$_k),ne(2,I.$_j)],l)}),define(re[138],oe([0,1,39,8,2,6]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=void 0;let A=class extends E.$so{constructor(g,c){super(),this.m=g,this.n=c,this.a=new S.$zh,this.b=this.B(new y.$Xc)}async j(g){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(g).length} policy definitions`);const{createWatcher:c}=await new Promise((l,u)=>{H(["@vscode/policy-watcher"],l,u)}).then(ye);await this.a.queue(()=>new Promise((l,u)=>{try{this.b.value=c(this.n,g,h=>{this.t(h),l()})}catch(h){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",h),u(h)}}))}t(g){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(g)}`);for(const c in g){const l=g[c];l===void 0?this.g.delete(c):this.g.set(c,l)}this.h.fire(Object.keys(g))}};e.$$fc=A,e.$$fc=A=we([ne(0,k.$_j)],A)}),define(re[33],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,E.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(re[37],oe([0,1,75,3]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,E=ye(E),S=ye(S);class y{constructor(){this.a=new Map}add(A,I){E.ok(S.$fg(A)),E.ok(S.$hg(I)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$po=new y}),define(re[139],oe([0,1,5,37]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,S=ye(S),e.$qo={JSONContribution:"base.contributions.json"};function y(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class k{constructor(){this.b=new E.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,c){this.a[y(g)]=c,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new k;S.$po.add(e.$qo.JSONContribution,A)}),define(re[40],oe([0,1,20,5,3,95,30,139,37]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=O,e.$Go=p,e.$Ho=f,e.$Io=P,e.$Jo=v,y=ye(y),k=ye(k);var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$uo={Configuration:"base.contributions.configuration"};var l;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(l||(e.ConfigurationScope=l={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const u=g.$po.as(I.$qo.JSONContribution);class h{constructor(){this.h=new Set,this.i=new S.$me,this.onDidSchemaChange=this.i.event,this.j=new S.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},u.registerSchema(e.$Bo,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const r=new Set;this.n(i,s,r),u.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const s=new Set;this.o(i,s),u.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const r=new Set;this.o(s,r),this.n(i,!1,r),u.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const r=[];for(const{overrides:t,source:n}of i)for(const o in t)if(s.add(o),e.$Eo.test(o)){const d=this.a.get(o),R=d?.valuesSources??new Map;if(n)for(const T of Object.keys(t[o]))R.set(T,n);const N={...d?.value||{},...t[o]};this.a.set(o,{source:n,value:N,valuesSources:R});const C=(0,A.$jj)(o),D={type:"object",default:N,description:k.localize(1,null,C),$ref:e.$Bo,defaultDefaultValue:N,source:y.$fg(n)?void 0:n,defaultValueSource:n};r.push(...O(o)),this.d[o]=D,this.b.properties[o]=D}else{this.a.set(o,{value:t[o],source:n});const d=this.d[o];d&&(this.w(o,d),this.r(o,d))}this.m(r)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:r,source:t}of i)for(const n in r){const o=this.a.get(n),d=y.$fg(t)?t:t?.id,R=y.$fg(o?.source)?o?.source:o?.source?.id;if(d===R)if(s.add(n),this.a.delete(n),e.$Eo.test(n))delete this.d[n],delete this.b.properties[n];else{const N=this.d[n];N&&(this.w(n,N),this.r(n,N))}}this.u()}deltaConfiguration(i){let s=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,r){i.forEach(t=>{this.p(t,s,t.extensionInfo,t.restrictedProperties,void 0,r),this.c.push(t),this.q(t)})}o(i,s){const r=t=>{if(t.properties)for(const n in t.properties){s.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,t.properties[n])}t.allOf?.forEach(n=>r(n))};for(const t of i){r(t);const n=this.c.indexOf(t);n!==-1&&this.c.splice(n,1)}}p(i,s=!0,r,t,n=l.WINDOW,o){n=y.$og(i.scope)?n:i.scope;const d=i.properties;if(d)for(const N in d){const C=d[N];if(s&&P(N,C)){delete d[N];continue}if(C.source=r,C.defaultDefaultValue=d[N].default,this.w(N,C),e.$Eo.test(N)?C.scope=void 0:(C.scope=y.$og(C.scope)?n:C.scope,C.restricted=y.$og(C.restricted)?!!t?.includes(N):C.restricted),d[N].hasOwnProperty("included")&&!d[N].included){this.f[N]=d[N],delete d[N];continue}else this.d[N]=d[N],d[N].policy?.name&&this.e.set(d[N].policy.name,N);!d[N].deprecationMessage&&d[N].markdownDeprecationMessage&&(d[N].deprecationMessage=d[N].markdownDeprecationMessage),o.add(N)}const R=i.allOf;if(R)for(const N of R)this.p(N,s,r,t,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=r=>{const t=r.properties;if(t)for(const o in t)this.r(o,t[o]);r.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$vo.properties[i]=s,s.scope){case l.APPLICATION:e.$wo.properties[i]=s;break;case l.MACHINE:e.$xo.properties[i]=s;break;case l.MACHINE_OVERRIDABLE:e.$yo.properties[i]=s;break;case l.WINDOW:e.$zo.properties[i]=s;break;case l.RESOURCE:e.$Ao.properties[i]=s;break;case l.LANGUAGE_OVERRIDABLE:e.$Ao.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$vo.properties[i],s.scope){case l.APPLICATION:delete e.$wo.properties[i];break;case l.MACHINE:delete e.$xo.properties[i];break;case l.MACHINE_OVERRIDABLE:delete e.$yo.properties[i];break;case l.WINDOW:delete e.$zo.properties[i];break;case l.RESOURCE:case l.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,r={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.$Bo};this.w(s,r),e.$vo.properties[s]=r,e.$wo.properties[s]=r,e.$xo.properties[s]=r,e.$yo.properties[s]=r,e.$zo.properties[s]=r,e.$Ao.properties[s]=r}}v(){const i={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=i,e.$wo.patternProperties[e.$Do]=i,e.$xo.patternProperties[e.$Do]=i,e.$yo.patternProperties[e.$Do]=i,e.$zo.patternProperties[e.$Do]=i,e.$Ao.patternProperties[e.$Do]=i,this.i.fire()}w(i,s){const r=this.a.get(i);let t=r?.value,n=r?.source;y.$mg(t)&&(t=s.defaultDefaultValue,n=void 0),y.$mg(t)&&(t=f(s.type)),s.default=t,s.defaultValueSource=n}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$Do=`^(${w})+$`,e.$Eo=new RegExp(e.$Do);function O(a){const i=[];if(e.$Eo.test(a)){let s=m.exec(a);for(;s?.length;){const r=s[1].trim();r&&i.push(r),s=m.exec(a)}}return(0,E.$Ob)(i)}function p(a){return a.reduce((i,s)=>`${i}[${s}]`,"")}function f(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new h;g.$po.add(e.$uo.Configuration,$);function P(a,i){return a.trim()?e.$Eo.test(a)?k.localize(7,null,a):$.getConfigurationProperties()[a]!==void 0?k.localize(8,null,a):i.policy?.name&&$.getPolicyConfigurations().get(i.policy?.name)!==void 0?k.localize(9,null,a,i.policy?.name,$.getPolicyConfigurations().get(i.policy?.name)):null:k.localize(6,null)}function v(){const a=[],i=$.getConfigurationProperties();for(const s of Object.keys(i))a.push([s,i[s].scope]);return a.push(["launch",l.RESOURCE]),a.push(["task",l.RESOURCE]),a}}),define(re[66],oe([0,1,20,5,34,2,31,28,3,12,30,40,10,37]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=v,E=ye(E),y=ye(y),I=ye(I),g=ye(g);function m(r){return Object.isFrozen(r)?r:I.$do(r)}class O{static createEmptyModel(t){return new O({},[],[],void 0,t)}constructor(t,n,o,d,R){this.b=t,this.c=n,this.d=o,this.raw=d,this.f=R,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof O)return n;const o=new p("",this.f);return o.parseRaw(n),o.configurationModel});this.g=t.reduce((n,o)=>o===n?o:n.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,l.$hj)(this.contents,t):this.contents}inspect(t,n){const o=this;return{get value(){return m(o.rawConfiguration.getValue(t))},get override(){return n?m(o.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return m(n?o.rawConfiguration.override(n).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const d=[];for(const{contents:R,identifiers:N,keys:C}of o.rawConfiguration.overrides){const D=new O(R,C,[],void 0,o.f).getValue(t);D!==void 0&&d.push({identifiers:N,value:D})}return d.length?m(d):void 0}}}getOverrideValue(t,n){const o=this.j(n);return o?t?(0,l.$hj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const o of this.overrides)o.identifiers.includes(t)&&n.push(...o.keys);return E.$Ob(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return E.$Ob(t)}override(t){let n=this.a.get(t);return n||(n=this.h(t),this.a.set(t,n)),n}merge(...t){const n=I.$co(this.contents),o=I.$co(this.overrides),d=[...this.keys],R=this.raw?.length?[...this.raw]:[this];for(const N of t)if(R.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(n,N.contents);for(const C of N.overrides){const[D]=o.filter(T=>E.$wb(T.identifiers,C.identifiers));D?(this.i(D.contents,C.contents),D.keys.push(...C.keys),D.keys=E.$Ob(D.keys)):o.push(I.$co(C))}for(const C of N.keys)d.indexOf(C)===-1&&d.push(C)}return new O(n,d,o,R.every(N=>N instanceof O)?void 0:R,this.f)}h(t){const n=this.j(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const d of E.$Ob([...Object.keys(this.contents),...Object.keys(n)])){let R=this.contents[d];const N=n[d];N&&(typeof R=="object"&&typeof N=="object"?(R=I.$co(R),this.i(R,N)):R=N),o[d]=R}return new O(o,this.keys,this.overrides,void 0,this.f)}i(t,n){for(const o of Object.keys(n)){if(o in t&&g.$hg(t[o])&&g.$hg(n[o])){this.i(t[o],n[o]);continue}t[o]=I.$co(n[o])}}j(t){let n=null,o=null;const d=R=>{R&&(o?this.i(o,R):o=I.$co(R))};for(const R of this.overrides)R.identifiers.length===1&&R.identifiers[0]===t?n=R.contents:R.identifiers.includes(t)&&d(R.contents);return d(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.k(t,n,!0)}setValue(t,n){this.k(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,l.$gj)(this.contents,t),u.$Eo.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>E.$wb(o.identifiers,(0,u.$Fo)(t))),1))}k(t,n,o){(0,l.$fj)(this.contents,t,n,d=>this.f.error(d)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),u.$Eo.test(t)&&this.overrides.push({identifiers:(0,u.$Fo)(t),keys:Object.keys(this.contents[t]),contents:(0,l.$ej)(this.contents[t],d=>this.f.error(d))})}}e.$Ko=O;class p{constructor(t,n){this.f=t,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||O.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!g.$og(t)){const o=this.h(t);this.parseRaw(o,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:o,keys:d,overrides:R,restricted:N,hasExcludedProperties:C}=this.i(t,n);this.b=new O(o,d,R,C?[t]:void 0,this.g),this.c=N||[]}h(t){let n={},o=null,d=[];const R=[],N=[];function C(T){Array.isArray(d)?d.push(T):o!==null&&(d[o]=T)}const D={onObjectBegin:()=>{const T={};C(T),R.push(d),d=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{d=R.pop()},onArrayBegin:()=>{const T=[];C(T),R.push(d),d=T,o=null},onArrayEnd:()=>{d=R.pop()},onLiteralValue:C,onError:(T,M,K)=>{N.push({error:T,offset:M,length:K})}};if(t)try{y.$3n(t,D),n=d[0]||{}}catch(T){this.g.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return n}i(t,n){const o=w.$po.as(u.$uo.Configuration).getConfigurationProperties(),d=this.j(t,o,!0,n);t=d.raw;const R=(0,l.$ej)(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`)),N=Object.keys(t),C=this.l(t,D=>this.g.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:R,keys:N,overrides:C,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}j(t,n,o,d){let R=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:R};const N={},C=[];for(const D in t)if(u.$Eo.test(D)&&o){const T=this.j(t[D],n,!1,d);N[D]=T.raw,R=R||T.hasExcludedProperties,C.push(...T.restricted)}else{const T=n[D],M=T?typeof T.scope<"u"?T.scope:u.ConfigurationScope.WINDOW:void 0;T?.restricted&&C.push(D),!d.exclude?.includes(D)&&(d.include?.includes(D)||(M===void 0||d.scopes===void 0||d.scopes.includes(M))&&!(d.skipRestricted&&T?.restricted))?N[D]=t[D]:R=!0}return{raw:N,restricted:C,hasExcludedProperties:R}}l(t,n){const o=[];for(const d of Object.keys(t))if(u.$Eo.test(d)){const R={};for(const N in t[d])R[N]=t[d][N];o.push({identifiers:(0,u.$Fo)(d),keys:Object.keys(R),contents:(0,l.$ej)(R,n)})}return o}}e.$Lo=p;class f extends k.$Wc{constructor(t,n,o,d,R){super(),this.c=t,this.f=n,this.g=d,this.h=R,this.b=this.B(new S.$me),this.onDidChange=this.b.event,this.a=new p(this.c.toString(),R),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(S.Event.any(S.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),S.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(h.FileOperation.CREATE)||N.isOperation(h.FileOperation.COPY)||N.isOperation(h.FileOperation.DELETE)||N.isOperation(h.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return O.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=f;class ${constructor(t,n,o,d,R,N,C,D,T,M,K,ae,ie){this.a=t,this.b=n,this.c=o,this.overrideIdentifiers=d,this.d=R,this.f=N,this.g=C,this.h=D,this.i=T,this.j=M,this.k=K,this.l=ae,this.m=ie}get value(){return m(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class P{constructor(t,n,o,d,R,N,C,D,T,M){this.j=t,this.l=n,this.m=o,this.n=d,this.p=R,this.q=N,this.r=C,this.s=D,this.t=T,this.u=M,this.h=null,this.i=new A.$Cc,this.v=null}getValue(t,n,o){return this.w(t,n,o).getValue(t)}updateValue(t,n,o={}){let d;o.resource?(d=this.t.get(o.resource),d||(d=O.createEmptyModel(this.u),this.t.set(o.resource,d))):d=this.s,n===void 0?d.removeValue(t):d.setValue(t,n),o.resource||(this.h=null)}inspect(t,n,o){const d=this.w(t,n,o),R=this.A(n.resource,o),N=n.resource?this.t.get(n.resource)||this.s:this.s,C=new Set;for(const D of d.overrides)for(const T of D.identifiers)d.getOverrideValue(t,T)!==void 0&&C.add(T);return new $(t,n,d.getValue(t),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,R||void 0,N)}keys(t){const n=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,n){this.r.set(t,n),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const o=[];if(!n){const{added:d,updated:R,removed:N}=i(this.j,t);n=[...d,...R,...N]}for(const d of n)for(const R of(0,u.$Fo)(d)){const N=this.j.getKeysForOverrideIdentifier(R),C=t.getKeysForOverrideIdentifier(R),D=[...C.filter(T=>N.indexOf(T)===-1),...N.filter(T=>C.indexOf(T)===-1),...N.filter(T=>!I.$go(this.j.override(R).getValue(T),t.override(R).getValue(T)))];o.push([R,D])}return this.updateDefaultConfiguration(t),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:o,removed:d}=i(this.l,t),R=[...n,...o,...d];return R.length&&this.updatePolicyConfiguration(t),{keys:R,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.applicationConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:R}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.localUserConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:R}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.remoteUserConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:R}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:o,removed:d,overrides:R}=i(this.workspaceConfiguration,t),N=[...n,...o,...d];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:R}}compareAndUpdateFolderConfiguration(t,n){const o=this.folderConfigurations.get(t),{added:d,updated:R,removed:N,overrides:C}=i(o,n),D=[...d,...R,...N];return(D.length||!o)&&this.updateFolderConfiguration(t,n),{keys:D,overrides:C}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:d,removed:R,overrides:N}=i(n,void 0);return{keys:[...o,...d,...R],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,n,o){let d=this.x(n,o);return n.overrideIdentifier&&(d=d.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(d=d.merge(this.l)),d}x({resource:t},n){let o=this.y();if(n&&t){const d=n.getFolder(t);d&&(o=this.z(d.uri)||o);const R=this.t.get(t);R&&(o=o.merge(R))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let n=this.i.get(t);if(!n){const o=this.y(),d=this.r.get(t);d?(n=o.merge(d),this.i.set(t,n)):n=o}return n}A(t,n){if(n&&t){const o=n.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,n)=>{const{contents:o,overrides:d,keys:R}=this.r.get(n);return t.push([n,{contents:o,overrides:d,keys:R}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.q.keys.forEach(n=>t.add(n)),this.r.forEach(n=>n.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const n=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(d=>n.add(d))),[...n.values()]}static parse(t,n){const o=this.E(t.defaults,n),d=this.E(t.policy,n),R=this.E(t.application,n),N=this.E(t.user,n),C=this.E(t.workspace,n),D=t.folders.reduce((T,M)=>(T.set(c.URI.revive(M[0]),this.E(M[1],n)),T),new A.$Cc);return new P(o,d,R,N,O.createEmptyModel(n),C,D,O.createEmptyModel(n),new A.$Cc,n)}static E(t,n){return new O(t.contents,t.keys,t.overrides,void 0,n)}}e.$No=P;function v(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const d of r)d.keys.forEach(R=>t.add(R)),d.overrides.forEach(([R,N])=>{const C=(0,A.$zc)(n,R,new Set);N.forEach(D=>C.add(D))});const o=[];return n.forEach((d,R)=>o.push([R,[...d.values()]])),{keys:[...t.values()],overrides:o}}class a{constructor(t,n,o,d,R){this.change=t,this.f=n,this.g=o,this.h=d,this.i=R,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const C of N)this.affectedKeys.add(C);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=P.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,n){const o=this.a+t,d=this.d.indexOf(o);if(d<0)return!1;const R=d+o.length;if(R>=this.d.length)return!1;const N=this.d.charCodeAt(R);if(N!==this.b&&N!==this.c)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,D=this.g.getValue(t,n,this.h);return!I.$go(C,D)}return!0}}e.$Po=a;function i(r,t){const{added:n,removed:o,updated:d}=s(t?.rawConfiguration,r?.rawConfiguration),R=[],N=r?.getAllOverrideIdentifiers()||[],C=t?.getAllOverrideIdentifiers()||[];if(t){const D=C.filter(T=>!N.includes(T));for(const T of D)R.push([T,t.getKeysForOverrideIdentifier(T)])}if(r){const D=N.filter(T=>!C.includes(T));for(const T of D)R.push([T,r.getKeysForOverrideIdentifier(T)])}if(t&&r){for(const D of N)if(C.includes(D)){const T=s({contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)},{contents:t.getOverrideValue(void 0,D)||{},keys:t.getKeysForOverrideIdentifier(D)});R.push([D,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:o,updated:d,overrides:R}}function s(r,t){const n=r?t?r.keys.filter(R=>t.keys.indexOf(R)===-1):[...r.keys]:[],o=t?r?t.keys.filter(R=>r.keys.indexOf(R)===-1):[...t.keys]:[],d=[];if(r&&t){for(const R of t.keys)if(r.keys.indexOf(R)!==-1){const N=(0,l.$hj)(t.contents,R),C=(0,l.$hj)(r.contents,R);I.$go(N,C)||d.push(R)}}return{added:n,removed:o,updated:d}}}),define(re[140],oe([0,1,20,5,2,28,3,66,40,6,39,37]),function(H,e,E,S,y,k,A,I,g,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;class h extends y.$Wc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new S.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ko.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(u.$po.as(g.$uo.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:f})=>this.f(Array.from(p),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,f){this.j(p,u.$po.as(g.$uo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=I.$Ko.createEmptyModel(this.c);const p=u.$po.as(g.$uo.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,f){const $=this.g();for(const P of p){const v=$[P],a=f[P];v!==void 0?this.b.addValue(P,v):a?this.b.addValue(P,a.default):this.b.removeValue(P)}}}e.$Qo=h;class w{constructor(){this.onDidChangeConfiguration=S.Event.None,this.configurationModel=I.$Ko.createEmptyModel(new c.$mk)}async initialize(){return this.configurationModel}}e.$Ro=w;let m=class extends y.$Wc{get configurationModel(){return this.b}constructor(p,f,$){super(),this.c=p,this.f=f,this.g=$,this.a=this.B(new S.$me),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ko.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const f={},$=[],P=u.$po.as(g.$uo.Configuration).getConfigurationProperties();for(const v of p){const a=P[v];if(!a){$.push(v);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}$.push(v),f[a.policy.name]={type:a.type}}}return(0,A.$sg)(f)||await this.f.updatePolicyDefinitions(f),$}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const f=u.$po.as(g.$uo.Configuration).getPolicyConfigurations(),$=(0,E.$Jb)(p.map(P=>f.get(P)));this.m($,!0)}m(p,f){this.g.trace("PolicyConfiguration#update",p);const $=u.$po.as(g.$uo.Configuration).getConfigurationProperties(),P=[],v=this.b.isEmpty();for(const a of p){const i=$[a]?.policy?.name;if(i){const s=this.f.getPolicyValue(i);(v?s!==void 0:!(0,k.$go)(this.b.getValue(a),s))&&P.push([a,s])}else this.b.getValue(a)!==void 0&&P.push([a,void 0])}if(P.length){this.g.trace("PolicyConfiguration#changed",P);const a=this.b;this.b=I.$Ko.createEmptyModel(this.g);for(const i of a.keys)this.b.setValue(i,a.getValue(i));for(const[i,s]of P)s===void 0?this.b.removeValue(i):this.b.setValue(i,s);f&&this.a.fire(this.b)}}};e.$So=m,e.$So=m=we([ne(1,l.$ro),ne(2,c.$_j)],m)}),define(re[141],oe([0,1,20,8,14,5,34,77,2,31,28,13,17,30,66,40,140,10,39]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;class P extends g.$Wc{constructor(i,s,r,t){super(),this.m=i,this.n=t,this.h=this.B(new k.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Qo(t)),this.c=r instanceof $.$to?new p.$Ro:this.B(new p.$So(this.b,r,t)),this.f=this.B(new m.$Mo(this.m,{},h.$0g,s,t)),this.a=new m.$No(this.b.configurationModel,this.c.configurationModel,m.$Ko.createEmptyModel(t),m.$Ko.createEmptyModel(t),m.$Ko.createEmptyModel(t),m.$Ko.createEmptyModel(t),new c.$Cc,m.$Ko.createEmptyModel(t),new c.$Cc,t),this.j=new v(i,s,this),this.g=this.B(new S.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[i,s,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new m.$No(i,s,m.$Ko.createEmptyModel(this.n),r,m.$Ko.createEmptyModel(this.n),m.$Ko.createEmptyModel(this.n),new c.$Cc,m.$Ko.createEmptyModel(this.n),new c.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(i,s){const r=typeof i=="string"?i:void 0,t=(0,w.$aj)(i)?i:(0,w.$aj)(s)?s:{};return this.a.getValue(r,t,void 0)}async updateValue(i,s,r,t,n){const o=(0,w.$bj)(r)?r:(0,w.$aj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,d=o?t:r;if(d!==void 0&&d!==w.ConfigurationTarget.USER_LOCAL&&d!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${i} to target ${d}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,E.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const R=this.inspect(i,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(R.policyValue!==void 0)throw new Error(`Unable to write ${i} because it is configured in system policy.`);if((0,l.$go)(s,R.defaultValue)&&(s=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const C=o.overrideIdentifiers.sort(),D=this.a.localUserConfiguration.overrides.find(T=>(0,E.$wb)([...T.identifiers].sort(),C));D&&(o.overrideIdentifiers=D.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,O.$Go)(o.overrideIdentifiers),i]:[i];await this.j.write(N,s),await this.reloadConfiguration()}inspect(i,s={}){return this.a.inspect(i,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const i=await this.f.loadConfiguration();this.r(i)}r(i){const s=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(i);this.u(r,s,w.ConfigurationTarget.USER)}s(i,s){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(i,s);this.u(t,r,w.ConfigurationTarget.DEFAULT)}t(i){const s=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(i);this.u(r,s,w.ConfigurationTarget.DEFAULT)}u(i,s,r){const t=new m.$Po(i,{data:s},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$To=P;class v{constructor(i,s,r){this.b=i,this.c=s,this.d=r,this.a=new S.$Mh}write(i,s){return this.a.queue(()=>this.e(i,s))}async e(i,s){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const t=[];if((0,A.$Vn)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,i,s);r=(0,I.$bo)(r,n),await this.c.writeFile(this.b,y.$Oe.fromString(r))}f(i,s,r){const{tabSize:t,insertSpaces:n,eol:o}=this.h;if(!s.length){const d=JSON.stringify(r,null,n?" ".repeat(t):"	");return[{content:d,length:d.length,offset:0}]}return(0,I.$$n)(i,s,r,{tabSize:t,insertSpaces:n,eol:o})}get h(){if(!this.g){let i=u.OS===u.OperatingSystem.Linux||u.OS===u.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(i=s),this.g={eol:i,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[67],oe([0,1,15]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=S,e.$hn=y,e.$in=k,e.$jn=A;function S(g){return g.scheme===E.Schemas.vscodeRemote?g.authority:void 0}function y(g){if(!g)return;const c=g.indexOf("+");return c<0?g:g.substr(0,c)}function k(g){const{host:c,port:l}=I(g);if(typeof l>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:l}}function A(g,c){let{host:l,port:u}=I(g);return typeof u>"u"&&(u=c),{host:l,port:u}}function I(g){const c=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const l=g.match(/^(\[[0-9a-z:]+\])$/);if(l)return{host:l[1],port:void 0};const u=g.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:g,port:void 0}}}),define(re[26],oe([0,1,32,11,67]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=k,e.$tn=u,e.$un=h,e.$vn=w,e.$wn=m,E=ye(E),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function k(O){if(typeof O=="object"&&O!==null&&O.supported!==!0)return O.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(O){O[O.System=0]="System",O[O.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function(O){O.WIN32_X64="win32-x64",O.WIN32_ARM64="win32-arm64",O.LINUX_X64="linux-x64",O.LINUX_ARM64="linux-arm64",O.LINUX_ARMHF="linux-armhf",O.ALPINE_X64="alpine-x64",O.ALPINE_ARM64="alpine-arm64",O.DARWIN_X64="darwin-x64",O.DARWIN_ARM64="darwin-arm64",O.WEB="web",O.UNIVERSAL="universal",O.UNKNOWN="unknown",O.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class g{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,f){if(typeof p>"u"||p===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof p=="string"||typeof f=="string"){const $=typeof p=="string"?p:p.value,P=typeof f=="string"?f:f.value;return E.$Gf($,P)}return p._lower===f._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$qn=g;class c{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const f of p)this.add(f)}add(p){this.c.add(g.toKey(p))}delete(p){return this.c.delete(g.toKey(p))}has(p){return this.c.has(g.toKey(p))}}e.$rn=c;class l{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(g.toKey(p))}get(p){return this.c.get(g.toKey(p))}has(p){return this.c.has(g.toKey(p))}set(p,f){this.c.set(g.toKey(p),f)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=l;function u(O){return h(O)}function h(O){return O.contributes&&O.contributes.localizations?O.contributes.localizations.length>0:!1}function w(O){return O.contributes&&O.contributes.authentication?O.contributes.authentication.length>0:!1}function m(O,p){if(p){const f=`onResolveRemoteAuthority:${(0,y.$hn)(p)}`;return!!O.activationEvents?.includes(f)}return!1}e.$xn=(0,S.$Fi)("IBuiltinExtensionsScannerService")}),define(re[21],oe([0,1,13,99,26,11]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=I,e.$cp=g,e.$dp=c,e.$ep=l,e.$fp=u,e.$gp=h,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var A;(function(a){a.COMMAND="command",a.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function I(a){switch(a){case y.TargetPlatform.WIN32_X64:return"Windows 64 bit";case y.TargetPlatform.WIN32_ARM64:return"Windows ARM";case y.TargetPlatform.LINUX_X64:return"Linux 64 bit";case y.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case y.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case y.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case y.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case y.TargetPlatform.DARWIN_X64:return"Mac";case y.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case y.TargetPlatform.WEB:return"Web";case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;case y.TargetPlatform.UNKNOWN:return y.TargetPlatform.UNKNOWN;case y.TargetPlatform.UNDEFINED:return y.TargetPlatform.UNDEFINED}}function g(a){switch(a){case y.TargetPlatform.WIN32_X64:return y.TargetPlatform.WIN32_X64;case y.TargetPlatform.WIN32_ARM64:return y.TargetPlatform.WIN32_ARM64;case y.TargetPlatform.LINUX_X64:return y.TargetPlatform.LINUX_X64;case y.TargetPlatform.LINUX_ARM64:return y.TargetPlatform.LINUX_ARM64;case y.TargetPlatform.LINUX_ARMHF:return y.TargetPlatform.LINUX_ARMHF;case y.TargetPlatform.ALPINE_X64:return y.TargetPlatform.ALPINE_X64;case y.TargetPlatform.ALPINE_ARM64:return y.TargetPlatform.ALPINE_ARM64;case y.TargetPlatform.DARWIN_X64:return y.TargetPlatform.DARWIN_X64;case y.TargetPlatform.DARWIN_ARM64:return y.TargetPlatform.DARWIN_ARM64;case y.TargetPlatform.WEB:return y.TargetPlatform.WEB;case y.TargetPlatform.UNIVERSAL:return y.TargetPlatform.UNIVERSAL;default:return y.TargetPlatform.UNKNOWN}}function c(a,i){switch(a){case E.Platform.Windows:return i==="x64"?y.TargetPlatform.WIN32_X64:i==="arm64"?y.TargetPlatform.WIN32_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Linux:return i==="x64"?y.TargetPlatform.LINUX_X64:i==="arm64"?y.TargetPlatform.LINUX_ARM64:i==="arm"?y.TargetPlatform.LINUX_ARMHF:y.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?y.TargetPlatform.ALPINE_X64:i==="arm64"?y.TargetPlatform.ALPINE_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Mac:return i==="x64"?y.TargetPlatform.DARWIN_X64:i==="arm64"?y.TargetPlatform.DARWIN_ARM64:y.TargetPlatform.UNKNOWN;case E.Platform.Web:return y.TargetPlatform.WEB}}function l(a,i){return i===y.TargetPlatform.WEB&&!a.includes(y.TargetPlatform.WEB)}function u(a,i,s){return l(i,s)?!1:a===y.TargetPlatform.UNDEFINED||a===y.TargetPlatform.UNIVERSAL?!0:a===y.TargetPlatform.UNKNOWN?!1:a===s}function h(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}var w;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var m;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var O;(function(a){a.Install="install",a.Uninstall="uninstall"})(O||(e.StatisticType=O={}));var p;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$hp=(0,k.$Fi)("extensionGalleryService");var f;(function(a){a.Timeout="Timeout",a.Cancelled="Cancelled",a.Failed="Failed",a.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class $ extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$ip=$;var P;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.DownloadSignature="DownloadSignature",a.DownloadFailedWriting="DownloadFailedWriting",a.UpdateMetadata="UpdateMetadata",a.Extract="Extract",a.Scanning="Scanning",a.ScanningExtension="ScanningExtension",a.ReadUninstalled="ReadUninstalled",a.UnsetUninstalled="UnsetUninstalled",a.Delete="Delete",a.Rename="Rename",a.IntializeDefaultProfile="IntializeDefaultProfile",a.AddToProfile="AddToProfile",a.InstalledExtensionNotFound="InstalledExtensionNotFound",a.PostInstall="PostInstall",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.NotAllowed="NotAllowed",a.Gallery="Gallery",a.Cancelled="Cancelled",a.Unknown="Unknown",a.Internal="Internal"})(P||(e.ExtensionManagementErrorCode=P={}));class v extends Error{constructor(i,s){super(i),this.code=s,this.name=s}}e.$jp=v,e.$kp=(0,k.$Fi)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,k.$Fi)("IGlobalExtensionEnablementService"),e.$op=(0,k.$Fi)("IExtensionTipsService"),e.$pp=(0,S.localize2)(0,"Extensions"),e.$qp=(0,S.localize2)(1,"Preferences")}),define(re[142],oe([0,1,2,26,10]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class k extends E.$Wc{constructor(I,g,c,l,u){super(),this.a=I,this.b=g,this.c=c,this.f=u,this.B(l.onDidInstallExtensions(h=>this.g(h))),this.B(l.onDidUninstallExtension(h=>this.h(h)))}g(I){for(const g of I)g.local&&this.invalidate(g.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const g of this.a.profiles)this.c.extUri.isEqual(g.extensionsResource,I)&&await this.j(g);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,S.$kn))}catch(g){(0,y.$ql)(g)!==y.FileOperationResult.FILE_NOT_FOUND&&this.f.error(g)}}}e.$Qq=k}),define(re[68],oe([0,1,22,2,13,109,21,11]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=void 0,e.$5r=g;function g(l){return l.tags.find(u=>u.startsWith("lp-"))?.split("lp-")[1]}e.$6r=(0,I.$Fi)("languagePackService");let c=class extends S.$Wc{constructor(u){super(),this.c=u}async getAvailableLanguages(){const u=new E.$xe;setTimeout(()=>u.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},u.token)}catch{return[]}const m=h.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(p=>p.startsWith("lp-"))).map(O=>{const p=O.properties.localizedLanguages?.[0],f=g(O);return{...this.f(f,p,O),extensionId:O.identifier.id,galleryExtension:O}});return m.push(this.f("en","English")),m}f(u,h,w){const m=h??u;let O;if(m!==u&&(O=`(${u})`),u.toLowerCase()===y.$w.toLowerCase()&&(O??="",O+=(0,k.localize)(0,null)),w?.installCount){O??="";const p=w.installCount;let f;p>1e6?f=`${Math.floor(p/1e5)/10}M`:p>1e3?f=`${Math.floor(p/1e3)}K`:f=String(p),O+=` $(cloud-download) ${f}`}return{id:u,label:m,description:O}}};e.$7r=c,e.$7r=c=we([ne(0,A.$hp)],c)}),define(re[45],oe([0,1,14,9,2,111,40,11,6,37]),function(H,e,E,S,y,k,A,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0,e.$4p=h,e.$5p=w,e.$6p=m,e.$7p=O,e.$8p=p,e.$9p=f,e.$2p=(0,I.$Fi)("requestService");class l{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?a[i]="*****":a[i]=this.b[i];this.a=a}return this.a}}class u extends y.$Wc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,k.localize)(0,null),when:g.$rk.isEqualTo((0,g.$ok)(g.LogLevel.Trace)).serialize()})}async c(a,i,s){const r=`${a} #${++this.b}: ${i.url}`;this.a.trace(`${r} - begin`,i.type,new l(i.headers??{}));try{const t=await s();return this.a.trace(`${r} - end`,i.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${r} - error`,i.type,(0,S.$_)(t)),t}}}e.$3p=u;function h(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}function w(v){return v.res.statusCode===204}async function m(v){return w(v)?null:(await(0,E.$1e)(v.stream)).toString()}async function O(v){if(!h(v))throw new Error("Server returned "+v.res.statusCode);return m(v)}async function p(v){if(!h(v))throw new Error("Server returned "+v.res.statusCode);if(w(v))return null;const i=(await(0,E.$1e)(v.stream)).toString();try{return JSON.parse(i)}catch(s){throw s.message+=`:
`+i,s}}function f(v){P(v)}let $;function P(v){const a=c.$po.as(A.$uo.Configuration),i=$;$={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(6,null),(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null)],default:"override",description:(0,k.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[$],remove:i?[i]:[]})}P(A.ConfigurationScope.APPLICATION)}),define(re[143],oe([0,1,22,15,10,45]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;let A=class{constructor(g,c){this.a=g,this.b=c}async download(g,c,l=E.CancellationToken.None){if(g.scheme===S.Schemas.file||g.scheme===S.Schemas.vscodeRemote){await this.b.copy(g,c);return}const u={type:"GET",url:g.toString(!0)},h=await this.a.request(u,l);if(h.res.statusCode===200)await this.b.writeFile(c,h.stream);else{const w=await(0,k.$7p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${w}`)}}};e.$zR=A,e.$zR=A=we([ne(0,k.$2p),ne(1,y.$_k)],A)}),define(re[144],oe([0,1,145,3]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=k;function y(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function k(A,I,g={}){const c=(0,E.parse)(A),l=g.proxyUrl||y(c,I);if(!l)return null;const u=(0,E.parse)(l);if(!/^https?:$/.test(u.protocol||""))return null;const h={host:u.hostname||"",port:(u.port?+u.port:0)||(u.protocol==="https"?443:80),auth:u.auth,rejectUnauthorized:(0,S.$lg)(g.strictSSL)?g.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((w,m)=>{H(["http-proxy-agent"],w,m)}).then(ye)).HttpProxyAgent(l,h):new(await new Promise((w,m)=>{H(["https-proxy-agent"],w,m)}).then(ye)).HttpsProxyAgent(l,h)}}),define(re[146],oe([0,1,60,16,112,22,38,9,13,29,90,176,8,78]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=O;let m;async function O(f,$,P,v){return P["force-disable-user-env"]?($.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.$i?($.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,u.$Jm)(v)&&!P["force-user-env"]?($.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,u.$Jm)(v)?$.trace("resolveShellEnv(): running (--force-user-env)"):$.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=h.Promises.withAsyncBody(async(a,i)=>{const s=new k.$xe;let r=1e4;const t=f.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(r=(0,w.$Km)(t,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),i(new Error((0,y.localize)(0,null)))},r);try{a(await p($,s.token))}catch(o){!(0,I.$6)(o)&&!s.token.isCancellationRequested?i(new Error((0,y.localize)(1,null,(0,A.$qj)(o)))):a({})}finally{clearTimeout(n),s.dispose()}})),m)}async function p(f,$){const P=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",P);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const a=(0,c.$2g)().replace(/-/g,"").substr(0,12),i=new RegExp(a+"({.*})"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const r=await(0,l.$zm)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",r),new Promise((t,n)=>{if($.isCancellationRequested)return n(new I.$7);const o=(0,S.$pc)(r);let d,R;const N="";/^pwsh(-preview)?$/.test(o)?(d=`& '${process.execPath}' ${N} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,R=["-Login","-Command"]):o==="nu"?(d=`^'${process.execPath}' ${N} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,R=["-i","-l","-c"]):o==="xonsh"?(d=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,R=["-i","-l","-c"]):(d=`'${process.execPath}' ${N} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,o==="tcsh"||o==="csh"?R=["-ic"]:R=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(R),d);const C=(0,E.spawn)(r,[...R,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});$.onCancellationRequested(()=>(C.kill(),n(new I.$7))),C.on("error",M=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,A.$qj)(M)),n(M)});const D=[];C.stdout.on("data",M=>D.push(M));const T=[];C.stderr.on("data",M=>T.push(M)),C.on("close",(M,K)=>{const ae=Buffer.concat(D).toString("utf8");f.trace("getUnixShellEnvironment#raw",ae);const ie=Buffer.concat(T).toString("utf8");if(ie.trim()&&f.trace("getUnixShellEnvironment#stderr",ie),M||K)return n(new Error((0,y.localize)(2,null,M,K)));const ue=i.exec(ae),ce=ue?ue[1]:"{}";try{const le=JSON.parse(ce);P?le.ELECTRON_RUN_AS_NODE=P:delete le.ELECTRON_RUN_AS_NODE,v?le.ELECTRON_NO_ATTACH_CONSOLE=v:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",le),t(le)}catch(le){f.error("getUnixShellEnvironment#errorCaught",(0,A.$qj)(le)),n(le)}})})}}),define(re[147],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cR=e.$bR=void 0,e.$bR=(0,E.$Fi)("stateReadService"),e.$cR=(0,E.$Fi)("stateService")}),define(re[69],oe([0,1,8,14,2,3,18,10,6]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fR=e.$eR=e.$dR=e.SaveStrategy=void 0;var c;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class l extends y.$Wc{constructor(m,O,p,f){super(),this.h=m,this.j=O,this.m=p,this.n=f,this.a=Object.create(null),this.b="",this.c=this.B(new E.$Dh(this.j===c.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==I.FileOperationResult.FILE_NOT_FOUND&&this.m.error(m)}}getItem(m,O){const p=this.a[m];return(0,k.$og)(p)?O:p}setItem(m,O){this.setItems([{key:m,data:O}])}setItems(m){let O=!1;for(const{key:p,data:f}of m)this.a[p]!==f&&((0,k.$og)(f)?(0,k.$mg)(this.a[p])||(this.a[p]=void 0,O=!0):(this.a[p]=f,O=!0));O&&this.s()}removeItem(m){(0,k.$mg)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,S.$Oe.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(O){this.m.error(O)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$dR=l;let u=class extends y.$Wc{constructor(m,O,p,f){super(),this.a=this.B(new l(O.stateResource,m,p,f))}async init(){await this.a.init()}getItem(m,O){return this.a.getItem(m,O)}};e.$eR=u,e.$eR=u=we([ne(1,A.$Mi),ne(2,g.$_j),ne(3,I.$_k)],u);class h extends u{setItem(m,O){this.a.setItem(m,O)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$fR=h}),define(re[70],oe([0,1,13,36,29]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=A,e.$sp=I;function k(g){if(E.$u===E.Platform.Linux&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,c,l,u,h,w,m,O,p,f){const $=Object.create(null);$["common.machineId"]=w,$["common.sqmId"]=m,$["common.devDeviceId"]=O,$.sessionID=(0,y.$2g)()+Date.now(),$.commitHash=u,$.version=h,$["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,E.$h)(E.$u),$["common.nodePlatform"]=S.$fc,$["common.nodeArch"]=l,$["common.product"]=f||"desktop",p&&($["common.msftInternal"]=p);let P=0;const v=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-v,enumerable:!0},"common.sequence":{get:()=>P++,enumerable:!0}}),E.$l&&($["common.snap"]="true");const a=k(c);return a&&($["common.platformDetail"]=a),$}function I(g){const c=S.env.USERDNSDOMAIN;if(!c)return!1;const l=c.toLowerCase();return g.some(u=>l===u)}}),define(re[19],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,E.$Fi)("telemetryService"),e.$_l=(0,E.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var S;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(S||(e.TelemetryLevel=S={}));var y;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(y||(e.TelemetryConfiguration=y={}))}),define(re[71],oe([0,1,9,11,6,19]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.ExtensionSignatureVerificationCode=e.$nq=void 0,e.$nq=(0,S.$Fi)("IExtensionSignatureVerificationService");var A;(function(c){c.Success="Success",c.RequiredArgumentMissing="RequiredArgumentMissing",c.InvalidArgument="InvalidArgument",c.PackageIsUnreadable="PackageIsUnreadable",c.UnhandledException="UnhandledException",c.SignatureManifestIsMissing="SignatureManifestIsMissing",c.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",c.SignatureIsMissing="SignatureIsMissing",c.SignatureIsUnreadable="SignatureIsUnreadable",c.CertificateIsUnreadable="CertificateIsUnreadable",c.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",c.FileAlreadyExists="FileAlreadyExists",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",c.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",c.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",c.SignatureIsInvalid="SignatureIsInvalid",c.SignatureManifestIsInvalid="SignatureManifestIsInvalid",c.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",c.EntryIsMissing="EntryIsMissing",c.EntryIsTampered="EntryIsTampered",c.Untrusted="Untrusted",c.CertificateRevoked="CertificateRevoked",c.SignatureIsNotValid="SignatureIsNotValid",c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class I extends Error{constructor(l){super(l),this.code=l}}e.$oq=I;let g=class{constructor(l,u){this.b=l,this.c=u}d(){return this.a||(this.a=new Promise((l,u)=>H(["@vscode/vsce-sign"],async h=>l(h),u))),this.a}async verify(l,u,h,w){let m;const O=l.identifier.id;try{m=await this.d()}catch(P){return this.b.error("Could not load vsce-sign module",(0,E.$_)(P)),this.b.info(`Extension signature verification is not done: ${O}`),!1}const p=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${O}...`),f=await m.verify(u,h,this.b.getLevel()===y.LogLevel.Trace)}catch(P){f={code:A.UnknownError,didExecute:!1,output:(0,E.$_)(P)}}const $=new Date().getTime()-p;if(this.b.info(`Extension signature verification result for ${O}: ${f.code}. Executed: ${f.didExecute}. Duration: ${$}ms.`),this.b.trace(`Extension signature verification output for ${O}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:O,extensionVersion:l.version,code:f.code,internalCode:f.internalCode,duration:$,didExecute:f.didExecute,clientTargetPlatform:w}),f.code===A.Success)return!0;throw new I(f.code)}};e.$pq=g,e.$pq=g=we([ne(0,y.$_j),ne(1,k.$$l)],g)}),define(re[41],oe([0,1,28,3,67,70,19]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=l,e.$Bp=u,e.$Cp=h,e.$Dp=w,e.$Ep=O,e.$Fp=f,e.$Gp=$,e.$Hp=a;class I{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$tp=I;class g{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=g,e.$vp=new g;class c{async publicLog(s,r,t){}async publicLogError(s,r,t){}}e.$wp=c,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function l(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry)}function u(i,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function h(i){const s=i.getValue(A.$hm),r=i.getValue(A.$im);if(i.getValue(A.$jm)===!1||r===!1)return A.TelemetryLevel.NONE;switch(s??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function w(i){const s={},r={},t={};p(i,t);for(let n in t){n=n.length>150?n.substr(n.length-149):n;const o=t[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function O(i){if(!i)return"none";const s=(0,y.$hn)(i);return m.has(s)?s:"other"}function p(i,s,r=0,t){if(i)for(const n of Object.getOwnPropertyNames(i)){const o=i[n],d=t?t+n:n;Array.isArray(o)?s[d]=(0,E.$ho)(o):o instanceof Date?s[d]=o.toISOString():(0,S.$hg)(o)?r<2?p(o,s,r+1,d+"."):s[d]=(0,E.$ho)(o):s[d]=o}}function f(i,s){const r=i.msftInternalDomains||[],t=s.getValue("telemetry.internalTesting");return(0,k.$sp)(r)||t}function $(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function P(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const t=[];for(const R of s)for(;;){const N=R.exec(i);if(!N)break;t.push([N.index,R.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let d=0;for(r="";;){const R=o.exec(i);if(!R)break;const N=t.some(([C,D])=>R.index<D&&C<o.lastIndex);!n.test(R[0])&&!N&&(r+=i.substring(d,R.index)+"<REDACTED: user-file-path>",d=o.lastIndex)}return d<i.length&&(r+=i.substr(d)),r}function v(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function a(i,s){return(0,E.$eo)(i,r=>{if(r instanceof I||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let t=r.replaceAll("%20"," ");t=P(t,s);for(const n of s)t=t.replace(n,"");return t=v(t),t}})}}),define(re[27],oe([0,1,32,21,26,13,12,9,36,41]),function(H,e,E,S,y,k,A,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=l,e.$Kp=m,e.$Lp=O,e.$Mp=p,e.$Np=f,e.$Op=$,e.$Pp=P,e.$Qp=v,e.$Sp=a,e.$Tp=s;function l(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,E.$Bf)(r.id,t.id)===0}const u=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(t){const n=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new h(t.identifier,n,o)}static parse(t){const n=u.exec(t);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(t,n,o=y.TargetPlatform.UNDEFINED){this.identifier=t,this.version=n,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==y.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof h?l(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Jp=h;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const t=w.exec(r);return t&&t[1]?[p(t[1]),t[2]]:[p(r),void 0]}function O(r,t){return`${r}.${t}`}function p(r){return r.toLowerCase()}function f(r,t){return p(O(r??y.$mn,t))}function $(r,t){const n=[],o=d=>{for(const R of n)if(R.some(N=>l(t(N),t(d))))return R;return null};for(const d of r){const R=o(d);R?R.push(d):n.push([d])}return n}function P(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function v(r){return{id:new c.$tp(r.identifier.id),name:new c.$tp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Rp=new y.$qn("pprice.better-merge");function a(r,t){const n=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const d=o.shift();if(d&&n.every(R=>!l(R.identifier,{id:d}))){const R=r.filter(N=>l(N.identifier,{id:d}));R.length===1&&(n.push(R[0]),o.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function i(r,t){if(!k.$k)return!1;let n;try{n=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){t.debug("Error while getting the os-release file.",(0,I.$_)(d))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,t){const n=await i(r,t),o=(0,S.$dp)(n?"alpine":k.$u,g.$gc);return t.debug("ComputeTargetPlatform:",o),o}}),define(re[148],oe([0,1,22,9,15,17,44,12,100,21,27,26]),function(H,e,E,S,y,k,A,I,g,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;const h=O=>(0,g.localize)(0,null,O),w=(0,g.localize)(1,null,"ms-dotnettools.csharp");let m=class{constructor(p,f,$){this.a=p,this.b=f,this.d=$}get f(){}async listExtensions(p,f,$){let P=await this.b.getInstalled(u.ExtensionType.User,$);const v=u.$pn.map(i=>i.toLowerCase());if(f&&f!==""){if(v.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}P=P.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),v.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,g.localize)(2,null,this.f)),P=P.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let a;for(const i of P)a!==i.identifier.id&&(a=i.identifier.id,this.a.info(p?`${a}@${i.manifest.version}`:a))}async installExtensions(p,f,$,P){const v=[];try{p.length&&this.a.info(this.f?(0,g.localize)(3,null,this.f):(0,g.localize)(4,null));const a=[],i=[],s=(t,n,o)=>{i.push({id:t,version:n!=="prerelease"?n:void 0,installOptions:{...$,isBuiltin:o,installPreReleaseVersion:n==="prerelease"||$.installPreReleaseVersion}})};for(const t of p)if(t instanceof I.URI)a.push({vsix:t,installOptions:$});else{const[n,o]=(0,l.$Kp)(t);s(n,o,!1)}for(const t of f)if(t instanceof I.URI)a.push({vsix:t,installOptions:{...$,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,o]=(0,l.$Kp)(t);s(n,o,!0)}const r=await this.b.getInstalled(void 0,$.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:t,installOptions:n})=>{try{await this.h(t,n,P,r)}catch(o){this.a.error(o),v.push(t.toString())}})),i.length){const t=await this.g(i,r,P);v.push(...t)}}catch(a){throw this.a.error((0,g.localize)(5,null,(0,S.$_)(a))),a}if(v.length)throw new Error((0,g.localize)(6,null,v.join(", ")))}async updateExtensions(p){const f=await this.b.getInstalled(u.ExtensionType.User,p),$=[];for(const i of f)i.identifier.uuid&&$.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,g.localize)(7,null,$.length));const P=await this.d.getExtensions($,{compatible:!0},E.CancellationToken.None),v=[];for(const i of P)for(const s of f)(0,l.$Ip)(s.identifier,i.identifier)&&(0,A.gt)(i.version,s.manifest.version)&&v.push({extension:i,options:{operation:c.InstallOperation.Update,installPreReleaseVersion:s.preRelease,profileLocation:p,isApplicationScoped:s.isApplicationScoped}});if(!v.length){this.a.info((0,g.localize)(8,null));return}this.a.info((0,g.localize)(9,null,v.map(i=>i.extension.identifier.id).join(", ")));const a=await this.b.installGalleryExtensions(v);for(const i of a)i.error?this.a.error((0,g.localize)(10,null,i.identifier.id,(0,S.$_)(i.error))):this.a.info((0,g.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(p,f,$){if(p=p.filter(({id:i,version:s})=>{const r=f.find(t=>(0,l.$Ip)(t.identifier,{id:i}));if(r){if(!$&&(!s||s==="prerelease"&&r.preRelease))return this.a.info((0,g.localize)(12,null,i,r.manifest.version,i)),!1;if(s&&r.manifest.version===s)return this.a.info((0,g.localize)(13,null,`${i}@${s}`)),!1}return!0}),!p.length)return[];const P=[],v=[],a=await this.j(p);if(await Promise.all(p.map(async({id:i,version:s,installOptions:r})=>{const t=a.get(i.toLowerCase());if(!t){this.a.error(`${h(s?`${i}@${s}`:i)}
${w}`),P.push(i);return}try{const o=await this.d.getManifest(t,E.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),P.push(i);return}const n=f.find(o=>(0,l.$Ip)(o.identifier,t.identifier));if(n){if(t.version===n.manifest.version){this.a.info((0,g.localize)(14,null,s?`${i}@${s}`:i));return}this.a.info((0,g.localize)(15,null,i,t.version))}r.isBuiltin?this.a.info(s?(0,g.localize)(16,null,i,s):(0,g.localize)(17,null,i)):this.a.info(s?(0,g.localize)(18,null,i,s):(0,g.localize)(19,null,i)),v.push({extension:t,options:{...r,installGivenVersion:!!s,isApplicationScoped:n?.isApplicationScoped}})})),v.length){const i=await this.b.installGalleryExtensions(v);for(const s of i)s.error?(this.a.error((0,g.localize)(20,null,s.identifier.id,(0,S.$_)(s.error))),P.push(s.identifier.id)):this.a.info((0,g.localize)(21,null,s.identifier.id,s.local?.manifest.version))}return P}async h(p,f,$,P){const v=await this.b.getManifest(p);if(!v)throw new Error("Invalid vsix");if(await this.l(v,$,f.profileLocation,P))try{await this.b.install(p,f),this.a.info((0,g.localize)(22,null,(0,k.$dh)(p)))}catch(i){if((0,S.$6)(i))this.a.info((0,g.localize)(23,null,(0,k.$dh)(p)));else throw i}}async j(p){const f=new Map,$=p.some(a=>a.installOptions.installPreReleaseVersion),P=await this.b.getTargetPlatform(),v=[];for(const a of p)c.$8o.test(a.id)&&v.push({...a,preRelease:$});if(v.length){const a=await this.d.getExtensions(v,{targetPlatform:P},E.CancellationToken.None);for(const i of a)f.set(i.identifier.id.toLowerCase(),i)}return f}k(p){return!0}async l(p,f,$,P){if(!f){const v={id:(0,l.$Np)(p.publisher,p.name)},a=P.find(i=>(0,l.$Ip)(v,i.identifier)&&(0,A.gt)(i.manifest.version,p.version));if(a)return this.a.info((0,g.localize)(24,null,a.identifier.id,a.manifest.version,p.version)),!1}return this.k(p)}async uninstallExtensions(p,f,$){const P=async a=>{if(a instanceof I.URI){const i=await this.b.getManifest(a);return(0,l.$Lp)(i.publisher,i.name)}return a},v=[];for(const a of p){const i=await P(a),r=(await this.b.getInstalled(void 0,$)).filter(t=>(0,l.$Ip)(t.identifier,{id:i}));if(!r.length)throw new Error(`${this.m(i)}
${w}`);if(r.some(t=>t.type===u.ExtensionType.System)){this.a.info((0,g.localize)(25,null,i));return}if(!f&&r.some(t=>t.isBuiltin)){this.a.info((0,g.localize)(26,null,i));return}this.a.info((0,g.localize)(27,null,i));for(const t of r)await this.b.uninstall(t,{profileLocation:$}),v.push(t);this.f?this.a.info((0,g.localize)(28,null,i,this.f)):this.a.info((0,g.localize)(29,null,i))}}async locateExtension(p){const f=await this.b.getInstalled();p.forEach($=>{f.forEach(P=>{if(P.identifier.id===$&&P.location.scheme===y.Schemas.file){this.a.info(P.location.fsPath);return}})})}m(p){return this.f?(0,g.localize)(30,null,p,this.f):(0,g.localize)(31,null,p)}};e.$qq=m,e.$qq=m=we([ne(1,c.$kp),ne(2,c.$hp)],m)}),define(re[149],oe([0,1,5,2,31,27,26,10]),function(H,e,E,S,y,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class g extends S.$Wc{constructor(l,u,h,w,m,O,p){super(),this.f=l,this.g=u,this.h=h,this.j=w,this.m=m,this.n=O,this.r=p,this.a=this.B(new E.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new S.$6c),this.s().then(null,f=>p.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(l=>this.u(l.added))),this.B(this.j.onAddExtensions(l=>this.w(l))),this.B(this.j.onDidAddExtensions(l=>this.y(l))),this.B(this.j.onRemoveExtensions(l=>this.z(l))),this.B(this.j.onDidRemoveExtensions(l=>this.C(l))),this.B(this.n.onDidFilesChange(l=>this.D(l)))}async u(l){try{l.length&&await Promise.all(l.map(u=>(this.c.set(u.id,(0,S.$Tc)(this.n.watch(this.m.extUri.dirname(u.extensionsResource)),this.n.watch(u.extensionsResource))),this.G(u.extensionsResource))))}catch(u){throw this.r.error(u),u}}async w(l){for(const u of l.extensions)this.I(this.L(u.identifier,u.version),l.profileLocation)}async y(l){for(const u of l.extensions){const h=this.L(u.identifier,u.version);l.error?this.J(h,l.profileLocation):this.I(h,l.profileLocation)}}async z(l){for(const u of l.extensions)this.J(this.L(u.identifier,u.version),l.profileLocation)}async C(l){const u=[],h=[];for(const w of l.extensions){const m=this.L(w.identifier,w.version);l.error?this.I(m,l.profileLocation):(this.J(m,l.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),h.push(this.f.scanInstalledExtensionAtLocation(w.location).then(O=>{O?u.push(O):this.r.info("Extension not found at the location",w.location.toString())},O=>this.r.error(O)))))}try{await Promise.all(h),u.length&&await this.H(u)}catch(w){this.r.error(w)}}D(l){for(const u of this.h.profiles)l.contains(u.extensionsResource,I.FileChangeType.UPDATED,I.FileChangeType.ADDED)&&this.F(u.extensionsResource)}async F(l){const u=[],h=[],w=await this.j.scanProfileExtensions(l),m=new Set,O=new Set;for(const[p,f]of this.b)f.has(l)&&O.add(p);for(const p of w){const f=this.L(p.identifier,p.version);m.add(f),O.has(f)||(u.push(p.identifier),this.I(f,l))}for(const p of O)if(!m.has(p)){const f=this.M(p);f&&(h.push(f.identifier),this.J(p,l))}(u.length||h.length)&&this.a.fire({added:u.length?{extensions:u,profileLocation:l}:void 0,removed:h.length?{extensions:h,profileLocation:l}:void 0})}async G(l){const u=await this.j.scanProfileExtensions(l);for(const h of u)this.I(this.L(h.identifier,h.version),l)}async H(l){l||(l=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),l.length&&await this.f.markAsUninstalled(...l)}I(l,u){let h=this.b.get(l);h||this.b.set(l,h=new y.$Dc(w=>this.m.extUri.getComparisonKey(w))),h.add(u)}J(l,u){const h=this.b.get(l);h&&h.delete(u),h?.size||this.b.delete(l)}L(l,u){return`${A.$qn.toKey(l.id)}@${u}`}M(l){const[u,h]=(0,k.$Kp)(l);return h?{identifier:{id:u},version:h}:void 0}}e.$Rq=g}),define(re[150],oe([0,1,177,20,8,2,15,16,25,18,21,27,6,68,12]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;let O=class extends w.$7r{constructor(P,v,a,i){super(a),this.h=P,this.j=i,this.g=this.B(new p(v,i)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(P,v){const i=(await this.g.getLanguagePacks())[v];if(!i){this.j.warn(`No language pack found for ${v}`);return}const s=i.translations[P];return s?m.URI.file(s):void 0}async getInstalledLanguages(){const P=await this.g.getLanguagePacks(),v=Object.keys(P).map(a=>{const i=P[a];return{...this.f(a,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return v.push(this.f("en","English")),v.sort((a,i)=>a.label.localeCompare(i.label)),v}async m(P){P&&P.manifest&&P.manifest.contributes&&P.manifest.contributes.localizations&&P.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",P.identifier.id),await this.update())}async n(P){const v=await this.g.getLanguagePacks();Object.keys(v).some(a=>v[a]&&v[a].extensions.some(i=>(0,u.$Ip)(i.extensionIdentifier,P.identifier)))&&(this.j.info("Removing language packs from the extension",P.identifier.id),await this.update())}async update(){const[P,v]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),a=await this.g.update(v);return!(0,S.$wb)(Object.keys(P),Object.keys(a))}};e.$8r=O,e.$8r=O=we([ne(0,l.$kp),ne(1,c.$Ni),ne(2,l.$hp),ne(3,h.$_j)],O);let p=class extends k.$Wc{constructor(P,v){super(),this.j=v,this.c={},this.f=(0,I.$lc)(P.userDataPath,"languagepacks.json"),this.g=new y.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(P){return this.s(v=>{Object.keys(v).forEach(a=>delete v[a]),this.m(v,...P)}).then(()=>this.c)}m(P,...v){for(const a of v)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.n(P,a);Object.keys(P).forEach(a=>this.r(P[a]))}n(P,v){const a=v.identifier,i=v.manifest.contributes&&v.manifest.contributes.localizations?v.manifest.contributes.localizations:[];for(const s of i)if(v.location.scheme===A.Schemas.file&&f(s)){let r=P[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},P[s.languageId]=r);const t=r.extensions.filter(n=>(0,u.$Ip)(n.extensionIdentifier,a))[0];t?t.version=v.manifest.version:r.extensions.push({extensionIdentifier:a,version:v.manifest.version});for(const n of s.translations)r.translations[n.id]=(0,I.$lc)(v.location.fsPath,n.path)}}r(P){if(P){const v=(0,E.createHash)("md5");for(const a of P.extensions)v.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);P.hash=v.digest("hex")}}s(P=()=>null){return this.g.queue(()=>{let v=null;return g.Promises.readFile(this.f,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(v=P(a),a)).then(a=>{for(const s of Object.keys(a))a[s]||delete a[s];this.c=a,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),g.Promises.writeFile(this.f,i)}).then(()=>v,a=>this.j.error(a))})}};p=we([ne(0,c.$Ni),ne(1,h.$_j)],p);function f($){if(typeof $.languageId!="string"||!Array.isArray($.translations)||$.translations.length===0)return!1;for(const P of $.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!($.languageName&&typeof $.languageName!="string"||$.localizedLanguageName&&typeof $.localizedLanguageName!="string")}}),define(re[151],oe([0,1,87,9,28,41]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function g(l,u,h){const w=await(0,E.$pE)("@microsoft/1ds-core-js","dist/ms.core.js"),m=await(0,E.$pE)("@microsoft/1ds-post-js","dist/ms.post.js"),O=new w.AppInsightsCore,p=new m.PostChannel,f={instrumentationKey:l,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(h){f.extensionConfig={};const $={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[p.identifier]=$}return O.initialize(f,[]),O.addTelemetryInitializer($=>{$.ext=$.ext??{},$.ext.web=$.ext.web??{},$.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',u&&($.ext.utc=$.ext.utc??{},$.ext.utc.flags=8462029)}),O}class c{constructor(u,h,w,m,O){this.e=u,this.f=h,this.g=w,this.h=O,this.c=A,this.d=I,this.g||(this.g={}),typeof m=="function"?this.a=m():this.a=m,this.b=null}i(u){if(this.a){if(typeof this.a!="string"){u(this.a);return}this.b||(this.b=g(this.a,this.e,this.h)),this.b.then(h=>{u(h)},h=>{(0,S.$3)(h),console.error(h)})}}log(u,h){if(!this.a)return;h=(0,y.$fo)(h,this.g),h=(0,k.$Dp)(h);const w=this.f+"/"+u;try{this.i(m=>{m.pluginVersionString=h?.properties.version??"Unknown",m.track({name:w,baseData:{name:w,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(u=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,u(void 0)})})}):Promise.resolve(void 0)}}e.$0Q=c});var ze=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[152],oe([0,1,2,28,13,32,113,30,40,153,33,37,19,41]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,c=ze(c);let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,$,P){this.k=$,this.l=P,this.d={},this.i=new E.$Vc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,k.$if)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$if)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(h.$hm)||v.affectsConfiguration(h.$jm)||v.affectsConfiguration(h.$im))&&this.m()}))}setExperimentProperty(f,$){this.d[f]=$}m(){let f=(0,w.$Cp)(this.k);const $=this.l.enabledTelemetryLevels;if($){this.h=this.sendErrorTelemetry?$.error:!1;const P=$.usage?h.TelemetryLevel.USAGE:$.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,P)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,$,P){this.g<$||(P=(0,S.$fo)(P,this.d),P=(0,w.$Hp)(P,this.j),P=(0,S.$fo)(P,this.c),this.b.forEach(v=>v.log(f,P)))}publicLog(f,$){this.n(f,h.TelemetryLevel.USAGE,$)}publicLog2(f,$){this.publicLog(f,$)}publicLogError(f,$){this.h&&this.n(f,h.TelemetryLevel.ERROR,$)}publicLogError2(f,$){this.publicLogError(f,$)}};e.$bs=m,e.$bs=m=we([ne(1,I.$_i),ne(2,l.$sk)],m);function O(){const p=(0,A.localize)(0,null,c.default.nameLong),f=c.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),$=y.$o?"":(0,A.localize)(3,null),P=(0,A.localize)(4,null),v=(0,A.localize)(5,null),a=(0,A.localize)(6,null),i=(0,A.localize)(7,null),s=`
|       | ${P} | ${v} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,A.localize)(8,null);return`
${p} ${f} ${$}

&nbsp;

${i}
${s}

&nbsp;

${r}
`}u.$po.as(g.$uo.Configuration).registerConfiguration({id:h.$gm,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[h.$hm]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:O(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),u.$po.as(g.$uo.Configuration).registerConfiguration({id:h.$gm,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[h.$jm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${h.$hm}#\``),scope:g.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(re[154],oe([0,1,14,22,178,151]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Q=void 0,y=ye(y);async function A(l,u){const h=await u.request(l,S.CancellationToken.None),w=(await(0,E.$1e)(h.stream)).toString(),m=h.res.statusCode??200;return{headers:h.res.headers,statusCode:m,responseData:w}}async function I(l){const u={method:l.type,headers:l.headers};return new Promise((w,m)=>{const O=y.request(l.url??"",u,p=>{p.on("data",function(f){w({headers:p.headers,statusCode:p.statusCode??200,responseData:f.toString()})}),p.on("error",function(f){m(f)})});O.write(l.data,p=>{p&&m(p)}),O.end()})}async function g(l,u,h){const w=typeof u.data=="string"?u.data:new TextDecoder().decode(u.data),m={type:"POST",headers:{...u.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(u.data).toString()},url:u.urlString,data:w};try{const O=l?await A(m,l):await I(m);h(O.statusCode,O.headers,O.responseData)}catch{h(0,{})}}class c extends k.$0Q{constructor(u,h,w,m,O){const p={sendPOST:(f,$)=>{g(u,f,$)}};super(h,w,m,O,p)}}e.$$Q=c}),define(re[155],oe([0,1,16,25]),function(H,e,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=y;async function y(k,A){const I=Object.create(null),g=(l,u)=>{const h=JSON.parse(l);I[u]=h};if(A){const l=[],u=await S.Promises.readdir(A);for(const w of u)try{(await S.Promises.stat((0,E.$lc)(A,w))).isDirectory()&&l.push(w)}catch{}const h=[];for(const w of l)(await S.Promises.readdir((0,E.$lc)(A,w))).filter(O=>O==="telemetry.json").length===1&&h.push(w);for(const w of h){const m=(await S.Promises.readFile((0,E.$lc)(A,w,"telemetry.json"))).toString();g(m,w)}}let c=(await S.Promises.readFile((0,E.$lc)(k,"telemetry-core.json"))).toString();return g(c,"vscode-core"),c=(await S.Promises.readFile((0,E.$lc)(k,"telemetry-extensions.json"))).toString(),g(c,"vscode-extensions"),JSON.stringify(I,null,4)}}),define(re[156],oe([0,1,13,88,19]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=k,e.$Nfc=A,e.$Ofc=I;async function k(g,c){let l=g.getItem(y.$dm);return(typeof l!="string"||E.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,S.$Qn)(c.error.bind(c))),l}async function A(g,c){let l=g.getItem(y.$em);return typeof l!="string"&&(l=await(0,S.$Rn)(c.error.bind(c))),l}async function I(g,c){let l=g.getItem(y.$fm);return typeof l!="string"&&(l=await(0,S.$Sn)(c.error.bind(c))),l}}),define(re[23],oe([0,1,11]),function(H,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,E.$Fi)("IUriIdentityService")}),define(re[157],oe([0,1,23,122,10,17,79,5,2]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;class c{static{this._clock=0}constructor(h){this.uri=h,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let l=class{constructor(h){this.g=h,this.c=new g.$Vc,this.f=2**16;const w=new Map,m=O=>{let p=w.get(O.scheme);return p===void 0&&(p=h.hasProvider(O)&&!this.g.hasCapability(O,y.FileSystemProviderCapabilities.PathCaseSensitive),w.set(O.scheme,p)),p};this.c.add(I.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(O=>{w.delete(O.scheme)})),this.extUri=new k.$8g(m),this.d=new A.$Ns((O,p)=>this.extUri.compare(O,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,k.$hh)(h));const w=this.d.get(h);return w?w.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new c(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((m,O)=>m[1].time<O[1].time?1:m[1].time>O[1].time?-1:0);c._clock=0,this.d.clear();const w=this.f*.5;for(let m=0;m<w;m++)this.d.set(h[m][0],h[m][1].touch())}};e.$Os=l,e.$Os=l=we([ne(0,y.$_k)],l),(0,S.$Ls)(E.$Jl,l,S.InstantiationType.Delayed)}),define(re[158],oe([0,1,5,2,10,48,31]),function(H,e,E,S,y,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class I extends S.$Wc{constructor(c,l,u,h,w,m){super(),this.f=c,this.g=l,this.h=u,this.j=h,this.m=w,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new E.$me),this.onDidChangeFile=this.a.event,this.b=k.$Li.forUris(()=>!(this.capabilities&y.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new A.$Dc(O=>this.m.extUri.getComparisonKey(this.t(O))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(O=>this.s(O)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,l){return this.g.open(this.t(c),l)}close(c){return this.g.close(c)}read(c,l,u,h,w){return this.g.read(c,l,u,h,w)}write(c,l,u,h,w){return this.g.write(c,l,u,h,w)}watch(c,l){this.b.set(c,c);const u=this.g.watch(this.t(c),l);return(0,S.$Uc)(()=>{this.b.delete(c),u.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,l,u){return this.g.rename(this.t(c),this.t(l),u)}readFile(c,l){return this.g.readFile(this.t(c),l)}readFileStream(c,l,u){return this.g.readFileStream(this.t(c),l,u)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,l,u){return this.g.writeFile(this.t(c),l,u)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,l){return this.g.delete(this.t(c),l)}copy(c,l,u){if((0,y.$dl)(this.g))return this.g.copy(this.t(c),this.t(l),u);throw new Error("copy not supported")}cloneFile(c,l){if((0,y.$el)(this.g))return this.g.cloneFile(this.t(c),this.t(l));throw new Error("clone not supported")}s(c){const l=[];for(const u of c){if(u.resource.scheme!==this.f)continue;const h=this.u(u.resource);this.b.findSubstr(h)&&l.push({resource:h,type:u.type,cId:u.cId})}l.length&&(this.n.debug("User data changed"),this.a.fire(l))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$agc=I}),define(re[159],oe([0,1,115,16,48,17,12,11,15]),function(H,e,E,S,y,k,A,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=c,e.$Qi=l,e.$Ti=u,e.$Ui=h,e.$Vi=w,e.$Wi=O,e.$Xi=p,e.$1i=P,e.$6i=v,e.$7i=a,e.$9i=i,e.$0i=s,e.$$i=r,e.$Oi=(0,I.$Fi)("contextService");function c(t){const n=t;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}function l(t){return typeof t?.id=="string"&&!c(t)&&!h(t)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function u(t,n){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,S.$pc)(t)}:n?e.$Ri:e.$Si;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(t){const n=t;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}function w(t){const n=t;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var m;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function O(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function p(t){const n=t;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,d,R,N){this.h=n,this.j=d,this.k=R,this.l=N,this.c=y.$Li.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=y.$Li.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=f;class ${constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.$gh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=$;function P(t){return new $({uri:t,index:0,name:(0,k.$ch)(t)},{uri:t.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,E.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function v(t,n){return k.$0g.isEqualOrParent(t,n.untitledWorkspacesHome)}function a(t){let n;return A.URI.isUri(t)?n=t:n=t.configuration,n?.scheme===g.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$8i}function s(t,n){return!v(t,n)&&!a(t)}function r(t){return(typeof t=="string"?(0,S.$qc)(t):(0,k.$eh)(t))===e.$3i}}),define(re[24],oe([0,1,43,5,2,17,12,114,18,10,11,6,159,31,23,8,29,32,3]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=v,e.$Ml=a,e.$Nl=i;var P;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(P||(e.ProfileResourceType=P={}));function v(t){const n=t;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Ll=(0,l.$Fi)("IUserDataProfilesService");function a(t,n){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:A.URI.revive(t.location).with({scheme:n}),globalStorageHome:A.URI.revive(t.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(t.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(t.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(t.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(t.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(t.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(t.cacheHome).with({scheme:n}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function i(t,n,o,d,R,N){return{id:t,name:n,location:o,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:N&&R?.useDefaultFlags?.globalState?N.globalStorageHome:(0,k.$gh)(o,"globalStorage"),settingsResource:N&&R?.useDefaultFlags?.settings?N.settingsResource:(0,k.$gh)(o,"settings.json"),keybindingsResource:N&&R?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,k.$gh)(o,"keybindings.json"),tasksResource:N&&R?.useDefaultFlags?.tasks?N.tasksResource:(0,k.$gh)(o,"tasks.json"),snippetsHome:N&&R?.useDefaultFlags?.snippets?N.snippetsHome:(0,k.$gh)(o,"snippets"),extensionsResource:N&&R?.useDefaultFlags?.extensions?N.extensionsResource:(0,k.$gh)(o,"extensions.json"),cacheHome:(0,k.$gh)(d,t),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}let s=class extends y.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,d,R){super(),this.t=n,this.u=o,this.w=d,this.y=R,this.f=!0,this.h=this.B(new S.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new S.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new S.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new S.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new w.$Cc,workspaces:new w.$Cc,emptyWindows:new Map},this.profilesHome=(0,k.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,$.$fg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(i((0,k.$dh)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},n))}}catch(N){this.y.error(N)}const d=new w.$Cc,R=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[C,D]of Object.entries(N.workspaces)){const T=A.URI.parse(C),M=o.find(K=>K.id===D);M&&d.set(T,M)}if(N.emptyWindows)for(const[C,D]of Object.entries(N.emptyWindows)){const T=o.find(M=>M.id===D);T&&R.set(C,T)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:d,emptyWindows:R}}return this.z}D(){const n=i("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",d=new RegExp(`${(0,f.$if)(o)}\\s(\\d+)`);let R=0;for(const C of this.profiles){const D=d.exec(C.name),T=D?parseInt(D[1]):0;R=T>R?T:R}const N=`${o} ${R+1}`;return this.createProfile((0,E.$tj)((0,p.$2g)()).toString(16),N,{transient:!0},n)}async createNamedProfile(n,o,d){return this.createProfile((0,E.$tj)((0,p.$2g)()).toString(16),n,o,d)}async createProfile(n,o,d,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(n,o,d);return R&&await this.setProfileForWorkspace(R,N),N}async F(n,o,d){if(!(0,$.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(o);return R||(R=(async()=>{try{if(this.profiles.find(T=>T.name===o||T.id===n))throw new Error(`Profile with ${o} name already exists`);const C=i(n,o,(0,k.$gh)(this.profilesHome,n),this.g,d,this.defaultProfile);await this.u.createFolder(C.location);const D=[];return this.j.fire({profile:C,join(T){D.push(T)}}),await O.Promises.settled(D),this.I([C],[],[]),C}finally{this.r.delete(o)}})(),this.r.set(o,R)),R}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let d=this.profiles.find(R=>R.id===n.id);if(!d)throw new Error(`Profile '${n.name}' does not exist`);return d=i(d.id,o.name??d.name,d.location,this.g,{shortName:o.shortName??d.shortName,icon:o.icon===null?void 0:o.icon??d.icon,transient:o.transient??d.isTransient,useDefaultFlags:o.useDefaultFlags??d.useDefaultFlags},this.defaultProfile),this.I([],[],[d]),d}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(R=>R.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const d=[];this.m.fire({profile:o,join(R){d.push(R)}});try{await Promise.allSettled(d)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(R){(0,c.$ql)(R)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(R)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const d=this.profiles.find(R=>R.id===o.id);if(!d)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,d)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(d=>!this.w.extUri.isEqual(d.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),d=A.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return d||((0,h.$Pi)(n)?this.s.folders.get(n.uri):(0,h.$Ui)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,h.$Pi)(n)?n.uri:(0,h.$Ui)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,d){const R=[...this.profiles,...n],N=[],C=this.s.profiles;this.s.profiles=[];for(let D of R){if(D.isDefault||o.some(M=>D.id===M.id))continue;D=d.find(M=>D.id===M.id)??D;const T=C.find(M=>D.id===M.id);if(D.isTransient)this.s.profiles.push(D);else{if(T){for(const[M,K]of this.s.emptyWindows.entries())if(D.id===K.id){this.L({id:M},D);break}for(const[M,K]of this.s.workspaces.entries())if(D.id===K.id){this.L({id:"",configPath:M},D);break}for(const[M,K]of this.s.folders.entries())if(D.id===K.id){this.L({id:"",uri:M},D);break}}N.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(n,o,d)}J(n,o,d){this.h.fire({added:n,removed:o,updated:d,all:this.profiles})}L(n,o,d){if(d=o?.isTransient?!0:d,d)(0,h.$Pi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,h.$Ui)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const R=this.G(n);A.URI.isUri(R)?(this.C.workspaces.delete(R),o&&this.C.workspaces.set(R,o)):(this.C.emptyWindows.delete(R),o&&this.C.emptyWindows.set(R,o)),this.M()}}M(){const n={};for(const[d,R]of this.C.workspaces.entries())n[d.toString()]=R.id;const o={};for(const[d,R]of this.C.emptyWindows.entries())o[d.toString()]=R.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},d=this.D();if(n.workspaces)for(const[N,C]of Object.entries(n.workspaces)){const D=A.URI.parse(C);o[N]=this.w.extUri.isEqual(D,d.location)?d.id:this.w.extUri.basename(D)}const R={};if(n.emptyWindows)for(const[N,C]of Object.entries(n.emptyWindows)){const D=A.URI.parse(C);R[N]=this.w.extUri.isEqual(D,d.location)?d.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:R}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ol=s,e.$Ol=s=we([ne(0,g.$Mi),ne(1,c.$_k),ne(2,m.$Jl),ne(3,u.$_j)],s);class r extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pl=r}),define(re[53],oe([0,1,20,8,22,9,5,2,13,3,12,98,21,27,26,6,33,19,23,24]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=void 0,e.$Aq=a,u=ye(u);let v=class extends I.$Wc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,n,o,d,R,N){super(),this.z=t,this.C=n,this.D=o,this.F=d,this.G=R,this.H=N,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$me),this.s=this.B(new A.$me),this.t=this.B(new A.$me),this.u=this.B(new A.$me),this.w=this.B(new A.$me),this.y=[],this.B((0,I.$Uc)(()=>{this.j.forEach(({task:C})=>C.cancel()),this.m.forEach(C=>C.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const n=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,h.$fp)(o,t.allTargetPlatforms,n))}async installFromGallery(t,n={}){try{const d=(await this.installGalleryExtensions([{extension:t,options:n}])).find(({identifier:R})=>(0,w.$Ip)(R,t.identifier));if(d?.local)return d?.local;throw d?.error?d.error:new h.$jp(`Unknown error while installing extension ${t.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(o){throw a(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new h.$jp(u.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(t.map(async({extension:d,options:R})=>{try{const N=await this.N(d,!!R?.installGivenVersion,!!R?.installPreReleaseVersion,R.productVersion??{version:this.G.version,date:this.G.date});o.push({...N,options:R})}catch(N){n.push({identifier:d.identifier,operation:h.InstallOperation.Install,source:d,error:N,profileLocation:R.profileLocation??this.X()})}})),o.length&&n.push(...await this.I(o)),n}async uninstall(t,n={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,n)}async toggleAppliationScope(t,n){if((0,m.$tn)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(o=await this.$(t,this.H.defaultProfile.extensionsResource,n));for(const d of this.H.profiles){const R=(await this.getInstalled(m.ExtensionType.User,d.extensionsResource)).find(N=>(0,w.$Ip)(N.identifier,t.identifier));R?this.w.fire({local:R,profileLocation:d.extensionsResource}):this.u.fire({identifier:t.identifier,profileLocation:d.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:h.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const n=new Map,o=new Map,d=[],R=(C,D)=>`${w.$Jp.create(C).toString()}-${D.toString()}`,N=(C,D,T,M)=>{const K=this.Y(C,D,T),ae=`${(0,w.$Np)(C.publisher,C.name)}-${T.profileLocation.toString()}`;o.set(ae,{task:K,root:M}),this.n.fire({identifier:K.identifier,source:D,profileLocation:T.profileLocation}),this.F.info("Installing extension:",K.identifier.id,T),l.URI.isUri(D)||this.j.set(R(D,T.profileLocation),{task:K,waitingTasks:[]})};try{for(const{manifest:C,extension:D,options:T}of t){const M=T.isApplicationScoped||T.isBuiltin||(0,m.$tn)(C),K={...T,installOnlyNewlyAddedFromExtensionPack:T.installOnlyNewlyAddedFromExtensionPack??!l.URI.isUri(D),isApplicationScoped:M,profileLocation:M?this.H.defaultProfile.extensionsResource:T.profileLocation??this.X(),productVersion:T.productVersion??{version:this.G.version,date:this.G.date}},ae=l.URI.isUri(D)?void 0:this.j.get(R(D,K.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,K.profileLocation.toString()),d.push(ae.task.waitUntilTaskIsFinished())):N(C,D,K,void 0)}return await Promise.all([...o.values()].map(async({task:C})=>{if(C.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",C.identifier.id);else try{const D=await this.M(C.identifier,C.manifest,!!C.options.installOnlyNewlyAddedFromExtensionPack,!!C.options.installPreReleaseVersion,C.options.profileLocation,C.options.productVersion),T=await this.getInstalled(void 0,C.options.profileLocation,C.options.productVersion),M={...C.options,context:{...C.options.context,[h.$_o]:!0}};for(const{gallery:K,manifest:ae}of(0,E.$Ob)(D,({gallery:ie})=>ie.identifier.id)){if(o.has(`${K.identifier.id.toLowerCase()}-${M.profileLocation.toString()}`))continue;const ie=this.j.get(R(K,M.profileLocation));if(ie){if(this.J(C,ie.task)){const ue=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,C.identifier.id,M.profileLocation.toString()),ie.waitingTasks.push(C),d.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,ce=>ce.some(le=>(0,w.$Ip)(le.identifier,ue)))).then(ce=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,C.identifier.id,M.profileLocation.toString()),!ce.find(x=>(0,w.$Ip)(x.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else T.some(({identifier:ue})=>(0,w.$Ip)(ue,K.identifier))||N(ae,K,M,C)}}catch(D){if(l.URI.isUri(C.source))(0,E.$Nb)(C.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",C.identifier.id,D.message),(0,E.$Nb)(C.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",C.identifier.id,D.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",C.identifier.id),D}})),await this.L([...o.entries()].map(async([C,{task:D}])=>{const T=new Date().getTime();let M;try{M=await D.run(),await this.L(this.y.map(K=>K.postInstall(M,D.source,D.options,y.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(K){const ae=a(K);throw l.URI.isUri(D.source)||i(this.C,D.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Qp)(D.source),error:ae,source:D.options.context?.[h.$$o]}),n.set(C,{error:ae,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:D.options.isApplicationScoped}),this.F.error("Error while installing the extension",D.identifier.id,(0,k.$_)(ae),D.options.profileLocation.toString()),ae}if(!l.URI.isUri(D.source)){const K=D.operation===h.InstallOperation.Update,ae=K?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(i(this.C,K?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Qp)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-T,durationSinceUpdate:ae,source:D.options.context?.[h.$$o]}),g.$o&&D.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,h.StatisticType.Install)}catch{}}n.set(C,{local:M,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.options.profileLocation,applicationScoped:M.isApplicationScoped})})),d.length&&await this.L(d),[...n.values()]}catch(C){const D=(K,ae,ie)=>{const ue=[];K.manifest.extensionDependencies?.length&&ue.push(...K.manifest.extensionDependencies),K.manifest.extensionPack?.length&&ue.push(...K.manifest.extensionPack);for(const ce of ue){if(ie.includes(ce.toLowerCase()))continue;ie.push(ce.toLowerCase());const le=n.get(`${ce.toLowerCase()}-${ae.toString()}`);le?.local&&(ie=D(le.local,ae,ie))}return ie},T=K=>({identifier:K.identifier,operation:h.InstallOperation.Install,source:K.source,context:K.options.context,profileLocation:K.options.profileLocation,error:C}),M=[];for(const[K,{task:ae,root:ie}]of o){const ue=n.get(K);ue?ue.local&&ie&&!n.get(`${ie.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(M.push(this.Z(ue.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(K,T(ae))):(ae.cancel(),n.set(K,T(ae)))}for(const[K,{task:ae}]of o){const ie=n.get(K);if(!ie?.local||ae.options.donotIncludePackAndDependencies)continue;D(ie.local,ae.options.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(ce=>o.has(`${ce.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!n.get(`${ce.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(M.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),n.set(K,T(ae)))}throw M.length&&await Promise.allSettled(M.map(async K=>{try{await K.run(),this.F.info("Rollback: Uninstalled extension",K.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",K.extension.identifier.id,(0,k.$_)(ae))}})),C}finally{for(const{task:C}of o.values())C.source&&!l.URI.isUri(C.source)&&this.j.delete(R(C.source,C.options.profileLocation));if(n.size){const C=[...n.values()];for(const D of C)D.local&&this.F.info("Extension installed successfully:",D.identifier.id,D.profileLocation.toString());this.s.fire(C)}}}J(t,n){for(const[,{task:o,waitingTasks:d}]of this.j.entries())if(o===t&&(d.includes(n)||d.some(R=>this.J(R,n)))||o===n&&d[0]&&!this.J(t,d[0]))return!1;return!0}async L(t,n){const o=[],d=[],R=await Promise.allSettled(t);for(const C of R)C.status==="fulfilled"?o.push(C.value):d.push(a(C.reason,n));if(!d.length)return o;if(d.length===1)throw d[0];let N=new h.$jp("",h.ExtensionManagementErrorCode.Unknown);for(const C of d)N=new h.$jp(N.message?`${N.message}, ${C.message}`:C.message,C.code!==h.ExtensionManagementErrorCode.Unknown&&C.code!==h.ExtensionManagementErrorCode.Internal?C.code:N.code);throw N}async M(t,n,o,d,R,N){if(!this.z.isEnabled())return[];const C=await this.getInstalled(void 0,R,N),D=[],T=[],M=async(K,ae)=>{D.push(K);const ie=ae.extensionDependencies||[],ue=[...ie];if(ae.extensionPack){const ce=o?C.find(le=>(0,w.$Ip)(le.identifier,K)):void 0;for(const le of ae.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(x=>(0,w.$Ip)({id:x},{id:le}))||ue.every(x=>!(0,w.$Ip)({id:x},{id:le}))&&ue.push(le)}if(ue.length){const ce=ue.filter(le=>D.every(x=>!(0,w.$Ip)(x,{id:le})));if(ce.length){const le=await this.z.getExtensions(ce.map(x=>({id:x,preRelease:d})),y.CancellationToken.None);for(const x of le){if(D.find(U=>(0,w.$Ip)(U,x.identifier)))continue;const _=ie.some(U=>(0,w.$Ip)({id:U},x.identifier));let B;try{B=await this.N(x,!1,d,N)}catch(U){if(_)throw U;this.F.info("Skipping the packed extension as it cannot be installed",x.identifier.id,(0,k.$_)(U));continue}T.push({gallery:B.extension,manifest:B.manifest}),await M(B.extension.identifier,B.manifest)}}}};return await M(t,n),T}async N(t,n,o,d){let R;const N=await this.getExtensionsControlManifest();if(N.malicious.some(T=>(0,w.$Ip)(t.identifier,T)))throw new h.$jp(u.localize(1,null,t.identifier.id),h.ExtensionManagementErrorCode.Malicious);const C=N.deprecated[t.identifier.id.toLowerCase()];if(C?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${C.extension.id}' extension instead.`),R=(await this.z.getExtensions([{id:C.extension.id,preRelease:C.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:d},y.CancellationToken.None))[0],!R)throw new h.$jp(u.localize(2,null,t.identifier.id,C.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const T=await this.getTargetPlatform();throw new h.$jp(u.localize(3,null,t.identifier.id,this.G.nameLong,(0,h.$bp)(T)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(R=await this.O(t,n,o,d),!R)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],y.CancellationToken.None))[0]?new h.$jp(u.localize(4,null,t.displayName??t.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$jp(u.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",R.identifier.id);const D=await this.z.getManifest(R,y.CancellationToken.None);if(D===null)throw new h.$jp(`Missing manifest for extension ${R.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(D.version!==R.version)throw new h.$jp(`Cannot install '${R.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:R,manifest:D}}async O(t,n,o,d){const R=await this.getTargetPlatform();let N=null;return!n&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(N=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:R,compatible:!0,productVersion:d},y.CancellationToken.None))[0]||null),!N&&await this.z.isExtensionCompatible(t,o,R,d)&&(N=t),N||(n?N=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:R,compatible:!0,productVersion:d},y.CancellationToken.None))[0]||null:N=await this.z.getCompatibleExtension(t,o,R,d)),N}async P(t,n){const o={...n,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},d=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,R=this.m.get(d(t.identifier));if(R)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),R.waitUntilTaskIsFinished();const N=M=>{const K=this.Z(M,o);return this.m.set(d(K.extension.identifier),K),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.t.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),K},C=(M,K)=>{K?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),K.message):this.F.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,K.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),i(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Pp)(M),error:K}),this.u.fire({identifier:M.identifier,error:K?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],T=[];try{D.push(N(t));const M=await this.getInstalled(m.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const K=this.S(t,M);for(const ae of K)this.m.has(d(ae.identifier))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):D.push(N(ae))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(D.map(K=>K.extension),M,t),await this.L(D.map(async K=>{try{if(await K.run(),await this.L(this.y.map(ae=>ae.postUninstall(K.extension,o,y.CancellationToken.None))),K.extension.identifier.uuid)try{await this.z.reportStatistic(K.extension.manifest.publisher,K.extension.manifest.name,K.extension.manifest.version,h.StatisticType.Uninstall)}catch{}C(K.extension)}catch(ae){const ie=a(ae);throw C(K.extension,ie),ie}finally{T.push(K)}}))}catch(M){const K=a(M);for(const ae of D){try{ae.cancel()}catch{}T.includes(ae)||C(ae.extension,K)}throw K}finally{for(const M of D)this.m.delete(d(M.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}Q(t,n,o){for(const d of t){const R=this.U(d,n);if(R.length){const N=R.filter(C=>!t.some(D=>(0,w.$Ip)(D.identifier,C.identifier)));if(N.length)throw new Error(this.R(d,N,o))}}}R(t,n,o){return o===t?n.length===1?u.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?u.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):u.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?u.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?u.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):u.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(t,n,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const d=t.manifest.extensionPack?t.manifest.extensionPack:[];if(d.length){const R=n.filter(C=>!C.isBuiltin&&d.some(D=>(0,w.$Ip)({id:D},C.identifier))),N=[];for(const C of R)N.push(...this.S(C,n,o));return[...R,...N]}return[]}U(t,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(d=>(0,w.$Ip)({id:d},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$_)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$zq=v,e.$zq=v=we([ne(0,h.$hp),ne(1,f.$$l),ne(2,$.$Jl),ne(3,O.$_j),ne(4,p.$sk),ne(5,P.$Ll)],v);function a(r,t){if(r instanceof h.$jp)return r;let n;return r instanceof h.$ip?n=new h.$jp(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.$jp(r.message,(0,k.$6)(r)?h.ExtensionManagementErrorCode.Cancelled:t??h.ExtensionManagementErrorCode.Internal),n.stack=r.stack,n}function i(r,t,{extensionData:n,verificationStatus:o,duration:d,error:R,source:N,durationSinceUpdate:C}){let D,T;(0,c.$ng)(o)&&(o===!0?o="Verified":(o===!1||(D=h.ExtensionManagementErrorCode.Signature,T=o),o="Unverified")),R&&(D=R.code,R.code===h.ExtensionManagementErrorCode.Signature&&(T=R.message)),r.publicLog(t,{...n,verificationStatus:o,success:!R,duration:d,errorcode:D,errorcodeDetail:T,durationSinceUpdate:C,source:N})}class s{constructor(){this.d=new S.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,S.$sh)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,S.$sh)(t=>new Promise((n,o)=>{const d=t.onCancellationRequested(()=>{d.dispose(),o(new k.$7)})})),this.d.open()),this.g.cancel()}}e.$Bq=s}),define(re[42],oe([0,1,8,14,2,5,31,12,21,27,10,11,6,24,23,3,9,19]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=e.ExtensionsProfileScanningErrorCode=void 0;var $;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})($||(e.ExtensionsProfileScanningErrorCode=$={}));class P extends Error{constructor(r,t){super(r),this.code=t}}e.$Cq=P,e.$Dq=(0,u.$Fi)("IExtensionsProfileScannerService");let v=class extends y.$Wc{constructor(r,t,n,o,d,R){super(),this.j=r,this.m=t,this.n=n,this.r=o,this.s=d,this.t=R,this.b=this.B(new k.$me),this.onAddExtensions=this.b.event,this.c=this.B(new k.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$me),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Cc}scanProfileExtensions(r,t){return this.u(r,void 0,t)}async addExtensionsToProfile(r,t,n){const o=[],d=[];try{return await this.u(t,R=>{const N=[];if(n)N.push(...R);else for(const C of R)r.some(([D])=>(0,c.$Ip)(D.identifier,C.identifier)&&D.manifest.version!==C.version)?o.push(C):N.push(C);for(const[C,D]of r){const T=N.findIndex(K=>(0,c.$Ip)(K.identifier,C.identifier)&&K.version===C.manifest.version),M={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:D};T===-1?(d.push(M),N.push(M)):N.splice(T,1,M)}return d.length&&this.b.fire({extensions:d,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),d.length&&this.c.fire({extensions:d,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),d}catch(R){throw d.length&&this.c.fire({extensions:d,error:R,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:R,profileLocation:t}),R}}async updateMetadata(r,t){const n=[];return await this.u(t,o=>{const d=[];for(const R of o){const N=r.find(([C])=>(0,c.$Ip)(C.identifier,R.identifier)&&C.manifest.version===R.version);N&&(R.metadata={...R.metadata,...N[1]},n.push(R)),d.push(R)}return d}),n}async removeExtensionFromProfile(r,t){const n=[];try{await this.u(t,o=>{const d=[];for(const R of o)(0,c.$Ip)(R.identifier,r.identifier)?n.push(R):d.push(R);return n.length&&this.f.fire({extensions:n,profileLocation:t}),d}),n.length&&this.g.fire({extensions:n,profileLocation:t})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:t}),o}}async u(r,t,n){return this.F(r).queue(async()=>{let o=[],d;try{const R=await this.m.readFile(r);d=JSON.parse(R.value.toString().trim()||"[]")}catch(R){if((0,l.$ql)(R)!==l.FileOperationResult.FILE_NOT_FOUND)throw R;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(d=await this.D()),!d&&n?.bailOutWhenFileNotFound)throw new P((0,p.$_)(R),$.ERROR_PROFILE_NOT_FOUND)}if(d){Array.isArray(d)||this.w(r);let R=!1;for(const N of d){a(N)||this.w(r);let C;if((0,O.$fg)(N.relativeLocation)&&N.relativeLocation)C=this.z(N.relativeLocation);else if((0,O.$fg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{C=I.URI.revive(N.location);const D=this.y(C);D&&(R=!0,N.relativeLocation=D)}(0,O.$mg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&(R=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:C,version:N.version,metadata:N.metadata})}R&&await this.m.writeFile(r,S.$Oe.fromString(JSON.stringify(d)))}if(t){o=t(o);const R=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(r,S.$Oe.fromString(JSON.stringify(R)))}return o})}w(r){const t=new P(`Invalid extensions content in ${r.toString()}`,$.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(d){if((0,l.$ql)(d)===l.FileOperationResult.FILE_NOT_FOUND)return;throw d}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const d=JSON.parse(n);Array.isArray(d)&&d.every(R=>a(R))?o=d:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",d)}catch(d){this.t.error(d)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,S.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(d){if((0,l.$ql)(d)===l.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw d}try{await this.m.del(r)}catch(d){(0,l.$ql)(d)!==l.FileOperationResult.FILE_NOT_FOUND&&this.t.error(d)}try{await this.m.del(t)}catch(d){(0,l.$ql)(d)!==l.FileOperationResult.FILE_NOT_FOUND&&this.t.error(d)}return o})()),this.C}F(r){let t=this.h.get(r);return t||(t=new E.$Mh,this.h.set(r,t)),t}};e.$Eq=v,e.$Eq=v=we([ne(1,l.$_k),ne(2,w.$Ll),ne(3,m.$Jl),ne(4,f.$$l),ne(5,h.$_j)],v);function a(s){return(0,O.$hg)(s)&&(0,g.$gp)(s.identifier)&&(i(s.location)||(0,O.$fg)(s.location)&&s.location)&&((0,O.$mg)(s.relativeLocation)||(0,O.$fg)(s.relativeLocation))&&s.version&&(0,O.$fg)(s.version)}function i(s){return s?(0,O.$fg)(s.path)&&(0,O.$fg)(s.scheme):!1}});var ze=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[54],oe([0,1,20,8,28,14,9,34,85,2,15,16,13,17,44,56,3,12,102,18,27,26,50,10,11,6,33,5,47,42,24,23,121]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P,v,a,i,s,r,t,n,o,d,R,N,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Jq=e.$Iq=e.$Hq=e.Translations=void 0,e.$Kq=ue,y=ye(y),u=ye(u),h=ye(h),m=ye(m),O=ze(O);var T;(function(le){function x(_,B){if(_===B)return!0;const U=Object.keys(_),J=new Set;for(const Z of Object.keys(B))J.add(Z);if(U.length!==J.size)return!1;for(const Z of U){if(_[Z]!==B[Z])return!1;J.delete(Z)}return J.size===0}le.equals=x})(T||(e.Translations=T={})),e.$Hq=(0,r.$Fi)("IExtensionsScannerService");let M=class extends c.$Wc{constructor(x,_,B,U,J,Z,Y,j,z,G,V,b){super(),this.systemExtensionsLocation=x,this.userExtensionsLocation=_,this.r=B,this.s=U,this.t=J,this.u=Z,this.w=Y,this.y=j,this.z=z,this.C=G,this.D=V,this.F=b,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,w.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ae,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(a.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(a.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,v.$Tp)(this.w,this.y)),this.G}async scanAllExtensions(x,_,B){const[U,J]=await Promise.all([this.scanSystemExtensions(x),this.scanUserExtensions(_)]),Z=B?await this.scanExtensionsUnderDevelopment(x,[...U,...J]):[];return this.L(U,J,Z,await this.getTargetPlatform(),!0)}async scanSystemExtensions(x){const _=[];_.push(this.M(!!x.useCache,x.language)),_.push(this.N(x.language,!!x.checkControlFile));const[B,U]=await Promise.all(_);return this.J([...B,...U],a.ExtensionType.System,x,!1)}async scanUserExtensions(x){const _=x.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",_);const B=this.D.extUri.isEqual(x.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.P(_,!!x.profileLocation,a.ExtensionType.User,!x.includeUninstalled,x.language,!0,B,x.productVersion??this.R()),J=x.useCache&&!U.devMode&&U.excludeObsolete?this.m:this.n;let Z;try{Z=await J.scanExtensions(U)}catch(Y){if(Y instanceof R.$Cq&&Y.code===R.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),Z=await J.scanExtensions(U);else throw Y}return Z=await this.J(Z,a.ExtensionType.User,x,!0),this.y.trace("Scanned user extensions:",Z.length),Z}async scanExtensionsUnderDevelopment(x,_){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(U=>U.scheme===l.Schemas.file).map(async U=>{const J=await this.P(U,!1,a.ExtensionType.User,!0,x.language,!1,void 0,x.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(J)).map(Y=>(Y.type=_.find(j=>(0,v.$Ip)(j.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,J)))}))).flat();return this.J(B,"development",x,!0)}return[]}async scanExistingExtension(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),J=await this.n.scanExtension(U);return!J||!B.includeInvalid&&!J.isValid?null:J}async scanOneOrMultipleExtensions(x,_,B){const U=await this.P(x,!1,_,!0,B.language,!0,void 0,B.productVersion??this.R()),J=await this.n.scanOneOrMultipleExtensions(U);return this.J(J,_,B,!0)}async scanMultipleExtensions(x,_,B){const U=[];return await Promise.all(x.map(async J=>{const Z=await this.scanOneOrMultipleExtensions(J,_,B);U.push(...Z)})),this.J(U,_,B,!0)}async scanMetadata(x){const _=(0,w.$gh)(x,"package.json"),B=(await this.w.readFile(_)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(x,_){const B=(0,w.$gh)(x,"package.json"),U=(await this.w.readFile(B)).value.toString(),J=JSON.parse(U);_.isMachineScoped===!1&&delete _.isMachineScoped,_.isBuiltin===!1&&delete _.isBuiltin,J.__metadata={...J.__metadata,..._},await this.w.writeFile((0,w.$gh)(x,"package.json"),k.$Oe.fromString(JSON.stringify(J,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(x){if(x instanceof R.$Cq&&x.code===R.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw x}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const x=await this.scanUserExtensions({includeInvalid:!0});if(x.length)await this.u.addExtensionsToProfile(x.map(_=>[_,_.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Oe.fromString(JSON.stringify([])))}catch(_){(0,s.$ql)(_)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$_)(_))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(x){this.y.error(x)}finally{this.H=void 0}})()),this.H}async J(x,_,B,U){return B.includeAllVersions||(x=this.L(_===a.ExtensionType.System?x:void 0,_===a.ExtensionType.User?x:void 0,_==="development"?x:void 0,await this.getTargetPlatform(),U)),B.includeInvalid||(x=x.filter(J=>J.isValid)),x.sort((J,Z)=>{const Y=u.$pc(J.location.fsPath),j=u.$pc(Z.location.fsPath);return Y<j?-1:Y>j?1:0})}L(x,_,B,U,J){const Z=(j,z,G)=>{if(j.isValid&&!z.isValid)return!1;if(j.isValid===z.isValid){if(J&&m.gt(j.manifest.version,z.manifest.version))return this.y.debug(`Skipping extension ${z.location.path} with lower version ${z.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(m.eq(j.manifest.version,z.manifest.version)){if(j.type===a.ExtensionType.System)return this.y.debug(`Skipping extension ${z.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===U)return this.y.debug(`Skipping extension ${z.location.path} from different target platform ${z.targetPlatform}`),!1}}return G?this.y.warn(`Overwriting user extension ${j.location.path} with ${z.location.path}.`):this.y.debug(`Overwriting user extension ${j.location.path} with ${z.location.path}.`),!0},Y=new a.$sn;return x?.forEach(j=>{const z=Y.get(j.identifier.id);(!z||Z(z,j,!1))&&Y.set(j.identifier.id,j)}),_?.forEach(j=>{const z=Y.get(j.identifier.id);if(!z&&x&&j.type===a.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!z||Z(z,j,!1))&&Y.set(j.identifier.id,j)}),B?.forEach(j=>{const z=Y.get(j.identifier.id);(!z||Z(z,j,!0))&&Y.set(j.identifier.id,j),Y.set(j.identifier.id,j)}),[...Y.values()]}async M(x,_){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,a.ExtensionType.System,!0,_,!0,void 0,this.R()),J=await(x&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",J.length),J}async N(x,_){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const U=_?await this.O():{},J=[],Z=f.URI.file(u.$jc(u.$lc(l.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of B){const z=U[j.name]||"marketplace";switch(z){case"disabled":break;case"marketplace":J.push((0,w.$gh)(Z,j.name));break;default:J.push(f.URI.file(z));break}}const Y=await Promise.all(J.map(async j=>this.n.scanExtension(await this.P(j,!1,a.ExtensionType.System,!0,x,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,E.$Jb)(Y)}async O(){try{const x=await this.w.readFile(this.r);return JSON.parse(x.value.toString())}catch{return{}}}async P(x,_,B,U,J,Z,Y,j){const z=await this.f(J??h.$w),G=await this.Q(x),V=_&&!this.D.extUri.isEqual(x,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,b=V?await this.Q(V):void 0;return new K(x,G,V,b,_,Y,B,U,Z,j.version,j.date,this.C.commit,!this.z.isBuilt,J,z)}async Q(x){try{const _=await this.w.stat(x);if(typeof _.mtime=="number")return _.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Iq=M,e.$Iq=M=we([ne(4,N.$Ll),ne(5,R.$Dq),ne(6,s.$_k),ne(7,t.$_j),ne(8,P.$Mi),ne(9,n.$sk),ne(10,C.$Jl),ne(11,r.$Ei)],M);class K{constructor(x,_,B,U,J,Z,Y,j,z,G,V,b,L,F,q){this.location=x,this.mtime=_,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=U,this.profile=J,this.profileScanOptions=Z,this.type=Y,this.excludeObsolete=j,this.validate=z,this.productVersion=G,this.productDate=V,this.productCommit=b,this.devMode=L,this.language=F,this.translations=q}static createNlsConfiguration(x){return{language:x.language,pseudo:x.language==="pseudo",devMode:x.devMode,translations:x.translations}}static equals(x,_){return(0,w.$_g)(x.location,_.location)&&x.mtime===_.mtime&&(0,w.$_g)(x.applicationExtensionslocation,_.applicationExtensionslocation)&&x.applicationExtensionslocationMtime===_.applicationExtensionslocationMtime&&x.profile===_.profile&&y.$go(x.profileScanOptions,_.profileScanOptions)&&x.type===_.type&&x.excludeObsolete===_.excludeObsolete&&x.validate===_.validate&&x.productVersion===_.productVersion&&x.productDate===_.productDate&&x.productCommit===_.productCommit&&x.devMode===_.devMode&&x.language===_.language&&T.equals(x.translations,_.translations)}}e.$Jq=K;let ae=class extends c.$Wc{constructor(x,_,B,U,J){super(),this.f=x,this.g=_,this.h=B,this.j=U,this.m=J}async scanExtensions(x){const _=x.profile?await this.r(x):await this.n(x);let B={};if(x.excludeObsolete&&x.type===a.ExtensionType.User)try{const U=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(U)}catch{}return(0,p.$sg)(B)?_:_.filter(U=>!B[v.$Jp.create(U).toString()])}async n(x){const _=await this.j.resolve(x.location);if(!_.children?.length)return[];const B=await Promise.all(_.children.map(async U=>{if(!U.isDirectory||x.type===a.ExtensionType.User&&(0,w.$dh)(U.resource).indexOf(".")===0)return null;const J=new K(U.resource,x.mtime,x.applicationExtensionslocation,x.applicationExtensionslocationMtime,x.profile,x.profileScanOptions,x.type,x.excludeObsolete,x.validate,x.productVersion,x.productDate,x.productCommit,x.devMode,x.language,x.translations);return this.scanExtension(J)}));return(0,E.$Jb)(B).sort((U,J)=>U.location.path<J.location.path?-1:1)}async r(x){let _=await this.s(x.location,()=>!0,x);if(x.applicationExtensionslocation&&!this.h.extUri.isEqual(x.location,x.applicationExtensionslocation)){_=_.filter(U=>!U.metadata?.isApplicationScoped);const B=await this.s(x.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,x);_.push(...B)}return _}async s(x,_,B){const U=await this.g.scanProfileExtensions(x,B.profileScanOptions);if(!U.length)return[];const J=await Promise.all(U.map(async Z=>{if(_(Z)){const Y=new K(Z.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,Z.metadata)}return null}));return(0,E.$Jb)(J)}async scanOneOrMultipleExtensions(x){try{if(await this.j.exists((0,w.$gh)(x.location,"package.json"))){const _=await this.scanExtension(x);return _?[_]:[]}else return await this.scanExtensions(x)}catch(_){return this.m.error(`Error scanning extensions at ${x.location.path}:`,(0,A.$_)(_)),[]}}async scanExtension(x,_){try{let B=await this.scanExtensionManifest(x.location);if(B){B.publisher||(B.publisher=a.$mn),_=_??B.__metadata,delete B.__metadata;const U=(0,v.$Np)(B.publisher,B.name),J=_?.id?{id:U,uuid:_.id}:{id:U},Z=_?.isSystem?a.ExtensionType.System:x.type,Y=Z===a.ExtensionType.System||!!_?.isBuiltin;B=await this.t(x.location,B,K.createNlsConfiguration(x));const j={type:Z,identifier:J,manifest:B,location:x.location,isBuiltin:Y,targetPlatform:_?.targetPlatform??a.TargetPlatform.UNDEFINED,publisherDisplayName:_?.publisherDisplayName,metadata:_,isValid:!0,validations:[]};return x.validate?this.validate(j,x):j}}catch(B){x.type!==a.ExtensionType.System&&this.m.error(B)}return null}validate(x,_){let B=!0;const U=(0,i.$Yp)(_.productVersion,_.productDate,_.location,x.manifest,x.isBuiltin);for(const[J,Z]of U)J===O.default.Error&&(B=!1,this.m.error(this.z(_.location,Z)));return x.isValid=B,x.validations=U,x}async scanExtensionManifest(x){const _=(0,w.$gh)(x,"package.json");let B;try{B=(await this.j.readFile(_)).value.toString()}catch(J){return(0,s.$ql)(J)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(x,(0,$.localize)(0,null,_.path,J.message))),null}let U;try{U=JSON.parse(B)}catch{const Z=[];(0,I.$Vn)(B,Z);for(const Y of Z)this.m.error(this.z(x,(0,$.localize)(1,null,_.path,Y.offset,Y.length,(0,g.$Fq)(Y.error))));return null}return(0,I.$5n)(U)!=="object"?(this.m.error(this.z(x,(0,$.localize)(2,null,_.path))),null):U}async t(x,_,B){const U=await this.u(x,_,B);if(U)try{const J=[],Z=await this.w(U.default,J);if(J.length>0)return J.forEach(j=>{this.m.error(this.z(x,(0,$.localize)(3,null,U.default?.path,(0,g.$Fq)(j.error))))}),_;if((0,I.$5n)(U)!=="object")return this.m.error(this.z(x,(0,$.localize)(4,null,U.default?.path))),_;const Y=U.values||Object.create(null);return(0,D.$Gq)(this.m,_,Y,Z)}catch{}return _}async u(x,_,B){const U=(0,w.$gh)(x,"package.nls.json"),J=(z,G)=>{G.forEach(V=>{this.m.error(this.z(x,(0,$.localize)(5,null,z?.path,(0,g.$Fq)(V.error))))})},Z=z=>{this.m.error(this.z(x,(0,$.localize)(6,null,z?.path)))},Y=`${_.publisher}.${_.name}`,j=B.translations[Y];if(j)try{const z=f.URI.file(j),G=(await this.j.readFile(z)).value.toString(),V=[],b=(0,I.$Vn)(G,V);return V.length>0?(J(z,V),{values:void 0,default:U}):(0,I.$5n)(b)!=="object"?(Z(z),{values:void 0,default:U}):{values:b.contents?b.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.j.exists(U))return;let G;try{G=await this.y(x,B)}catch{return}if(!G.localized)return{values:void 0,default:G.original};try{const V=(await this.j.readFile(G.localized)).value.toString(),b=[],L=(0,I.$Vn)(V,b);return b.length>0?(J(G.localized,b),{values:void 0,default:G.original}):(0,I.$5n)(L)!=="object"?(Z(G.localized),{values:void 0,default:G.original}):{values:L,default:G.original}}catch{return{values:void 0,default:G.original}}}}async w(x,_){if(x)try{const B=(await this.j.readFile(x)).value.toString();return(0,I.$Vn)(B,_)}catch{}}y(x,_){return new Promise((B,U)=>{const J=Z=>{const Y=(0,w.$gh)(x,`package.nls.${Z}.json`);this.j.exists(Y).then(j=>{j&&B({localized:Y,original:(0,w.$gh)(x,"package.nls.json")});const z=Z.lastIndexOf("-");z===-1?B({localized:(0,w.$gh)(x,"package.nls.json"),original:null}):(Z=Z.substring(0,z),J(Z))})};if(_.devMode||_.pseudo||!_.language)return B({localized:(0,w.$gh)(x,"package.nls.json"),original:null});J(_.language)})}z(x,_){return`[${x.path}]: ${_}`}};ae=we([ne(1,R.$Dq),ne(2,C.$Jl),ne(3,s.$_k),ne(4,t.$_j)],ae);let ie=class extends ae{constructor(x,_,B,U,J,Z,Y){super(_,U,J,Z,Y),this.G=x,this.H=B,this.D=this.B(new S.$Dh(3e3)),this.F=this.B(new o.$me),this.onDidChangeCache=this.F.event}async scanExtensions(x){const _=this.M(x),B=await this.I(_);if(this.C=x,B&&B.input&&K.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",x.type===a.ExtensionType.System?"system":"user",x.location.toString()),this.D.trigger(()=>this.L()),B.result.map(J=>(J.location=f.URI.revive(J.location),J));const U=await super.scanExtensions(x);return await this.J(_,{input:x,result:U}),U}async I(x){try{const _=await this.j.readFile(x),B=JSON.parse(_.value.toString());return{result:B.result,input:(0,d.$ci)(B.input)}}catch(_){this.m.debug("Error while reading the extension cache file:",x.path,(0,A.$_)(_))}return null}async J(x,_){try{await this.j.writeFile(x,k.$Oe.fromString(JSON.stringify(_)))}catch(B){this.m.debug("Error while writing the extension cache file:",x.path,(0,A.$_)(B))}}async L(){if(!this.C)return;const x=this.M(this.C),_=await this.I(x);if(!_)return;const B=_.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!y.$go(U,B))try{this.m.info("Invalidating Cache",B,U),await this.j.del(x),this.F.fire()}catch(J){this.m.error(J)}}M(x){const _=this.N(x);return this.h.extUri.joinPath(_.cacheHome,x.type===a.ExtensionType.System?a.$ln:a.$kn)}N(x){return x.type===a.ExtensionType.System?this.H.defaultProfile:x.profile?this.h.extUri.isEqual(x.location,this.G.extensionsResource)?this.G:this.H.profiles.find(_=>this.h.extUri.isEqual(x.location,_.extensionsResource))??this.G:this.H.defaultProfile}};ie=we([ne(2,N.$Ll),ne(3,R.$Dq),ne(4,C.$Jl),ne(5,s.$_k),ne(6,t.$_j)],ie);function ue(le,x){const _=(0,v.$Lp)(le.manifest.publisher,le.manifest.name);return{id:_,identifier:new a.$qn(_),isBuiltin:le.type===a.ExtensionType.System,isUserBuiltin:le.type===a.ExtensionType.User&&le.isBuiltin,isUnderDevelopment:x,extensionLocation:le.location,uuid:le.identifier.uuid,targetPlatform:le.targetPlatform,publisherDisplayName:le.publisherDisplayName,...le.manifest}}class ce extends M{constructor(x,_,B,U,J,Z,Y,j,z,G,V,b){super(x,_,(0,w.$gh)(B,".vscode-oss-dev","extensions","control.json"),U,J,Z,Y,j,z,G,V,b),this.S=(async()=>{if(h.$z)try{const L=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(L.value.toString())}catch{}return Object.create(null)})()}f(x){return this.S}}e.$Lq=ce}),define(re[160],oe([0,1,60,8,38,5,2,15,16,25,6,24]),function(H,e,E,S,y,k,A,I,g,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;let h=class extends A.$Wc{constructor(m,O){super(),this.b=m,this.f=O,this.a=new S.$Lh(5)}async postUninstall(m){const O=this.g(m,"uninstall");O&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(O.script,"uninstall",O.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(p){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(p)}}));try{await c.Promises.rm(this.m(m))}catch(p){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(p)}}g(m,O){const p=`vscode:${O}`;if(m.location.scheme===I.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[p]=="string"){const f=m.manifest.scripts[p].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${p} should be a node script`),null):{script:(0,g.$lc)(m.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(m,O,p,f,$){return new Promise((P,v)=>{const a=this.j(m,O,p,$);let i;const s=r=>{i&&(clearTimeout(i),i=null),r?v(r):P(void 0)};a.on("error",r=>{s((0,y.$qj)(r)||"Unknown")}),a.on("exit",(r,t)=>{s(r?`post-${O} process exited with code ${r}`:void 0)}),f&&(i=setTimeout(()=>{i=null,a.kill(),v("timed out")},5e3))})}j(m,O,p,f){const $={silent:!0,execArgv:void 0},P=(0,E.fork)(m,[`--type=extension-post-${O}`,...p],$);P.stdout.setEncoding("utf8"),P.stderr.setEncoding("utf8");const v=k.Event.fromNodeEventEmitter(P.stdout,"data"),a=k.Event.fromNodeEventEmitter(P.stderr,"data");this.B(v(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${O}`,r))),this.B(a(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${O}`,r)));const i=k.Event.any(k.Event.map(v,r=>({data:`%c${r}`,format:[""]}),this.q),k.Event.map(a,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return k.Event.debounce(i,(r,t)=>r?{data:r.data+t.data,format:[...r.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),P}m(m){return(0,g.$lc)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};e.$Pq=h,e.$Pq=h=we([ne(0,u.$Ll),ne(1,l.$_j)],h)}),define(re[72],oe([0,1,49,104,53,21]),function(H,e,E,S,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=A,e.$Nq=I;function A(g){let c=k.ExtensionManagementErrorCode.Extract;return g instanceof E.$vq&&(g.type==="CorruptZip"?c=k.ExtensionManagementErrorCode.CorruptZip:g.type==="Incomplete"&&(c=k.ExtensionManagementErrorCode.IncompleteZip)),(0,y.$Aq)(g,c)}async function I(g){let c;try{c=await(0,E.$yq)(g,"extension/package.json")}catch(l){throw A(l)}try{return JSON.parse(c.toString("utf8"))}catch{throw new k.$jp((0,S.localize)(0,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(re[161],oe([0,1,8,9,2,15,17,44,3,29,25,49,30,18,53,21,27,72,71,10,6,19]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P,v,a){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0,I=ye(I);let s=class extends y.$Wc{static{i=this}static{this.c=".sigzip"}constructor(t,n,o,d,R,N,C){super(),this.h=n,this.j=o,this.m=d,this.n=R,this.r=N,this.t=C,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,n,o,d){await this.g;const R=await this.w(t,n);let N=!1;if(o&&this.u(t)){let C;try{C=await this.y(t)}catch(D){try{await this.delete(R)}catch(T){this.t.error(T)}throw D}try{N=await this.n.verify(t,R.fsPath,C.fsPath,d)}catch(D){if(N=D.code,N===$.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===$.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(R)}catch(T){this.t.error(T)}throw new O.$jp(u.$uq,O.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(D){this.t.error(D)}}}return{location:R,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,g.$lg)(n)?n:!0}async w(t,n){try{const o=(0,A.$gh)(this.extensionsDownloadDir,this.G(t)),d=await this.C(t,"vsix",async()=>{await this.z(t,o,R=>this.j.download(t,R,n));try{await this.D(o.fsPath,"extension/package.json")}catch(R){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,S.$_)(N))}throw R}},2);return d>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:d}),o}catch(o){throw(0,m.$Aq)(o,O.ExtensionManagementErrorCode.Download)}}async y(t){try{const n=(0,A.$gh)(this.extensionsDownloadDir,`.${(0,c.$2g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,n);try{await this.D(n.fsPath,".signature.p7s")}catch(d){try{await this.h.del(n)}catch(R){this.t.warn(`Error while deleting: ${n.path}`,(0,S.$_)(R))}throw d}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),n}catch(n){throw(0,m.$Aq)(n,O.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,n,o){if(await this.h.exists(n))return;if(n.scheme!==k.Schemas.file){await o(n);return}const d=(0,A.$gh)(this.extensionsDownloadDir,`.${(0,c.$2g)()}`);try{await o(d)}catch(R){try{await this.h.del(d)}catch{}throw R}try{await l.Promises.rename(d.fsPath,n.fsPath,2*60*1e3)}catch(R){try{await this.h.del(d)}catch{}let N=!1;try{N=await this.h.exists(n)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,S.$_)(R)}. Deleted the file from downloaded location`,d.path),R}}async C(t,n,o,d){let R=1;for(;;)try{return await o(),R}catch(N){if(R++>d)throw N;this.t.warn(`Failed downloading ${n}. ${(0,S.$_)(N)}. Retry again...`,t.identifier.id)}}async D(t,n){try{await(0,u.$yq)(t,n)}catch(o){throw(0,f.$Mq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const n=[],o=[],d=[];for(const C of t.children)if(C.name.endsWith(i.c))d.push(C.resource);else{const D=p.$Jp.parse(C.name);D&&o.push([D,C])}const R=(0,p.$Op)(o,([C])=>C),N=[];for(const C of R)C.sort((D,T)=>I.rcompare(D[0].version,T[0].version)),n.push(...C.slice(1).map(D=>D[1].resource)),N.push(C[0][1]);N.sort((C,D)=>C.mtime-D.mtime),n.push(...N.slice(0,Math.max(0,N.length-this.f)).map(C=>C.resource)),n.push(...d),await E.Promises.settled(n.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(t){this.t.error(t)}}G(t){return this.f?p.$Jp.create(t).toString().toLowerCase():(0,c.$2g)()}};e.$Oq=s,e.$Oq=s=i=we([ne(0,w.$Ni),ne(1,P.$_k),ne(2,O.$hp),ne(3,h.$_i),ne(4,$.$nq),ne(5,a.$$l),ne(6,v.$_j)],s)}),define(re[162],oe([0,1,8,14,22,38,9,5,43,2,31,15,16,17,44,3,12,29,25,49,103,61,18,53,21,27,42,54,161,160,72,142,149,26,50,10,11,6,33,19,23,24]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P,v,a,i,s,r,t,n,o,d,R,N,C,D,T,M,K,ae,ie,ue,ce,le,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0,h=ye(h),m=ye(m),$=ye($),v=ye(v),e.$Sq=(0,ae.$Gi)(r.$kp);const _=".vsctmp";let B=class extends s.$zq{constructor(j,z,G,V,b,L,F,q,Q,X,se,fe){super(j,z,se,G,X,fe),this.eb=b,this.fb=L,this.gb=F,this.hb=q,this.ib=Q,this.db=new Map,this.tb=new l.$Dc;const he=this.B(q.createInstance(R.$Pq));this.ab=this.B(q.createInstance(U,pe=>he.postUninstall(pe))),this.bb=this.B(new C.$Qq(fe,Q,se,this,this.F)),this.cb=this.B(q.createInstance(d.$Oq));const Ee=this.B(new D.$Rq(this,this.eb,fe,L,se,Q,G));this.B(Ee.onDidChangeExtensionsByAnotherSource(pe=>this.sb(pe))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,t.$Tp)(this.ib,this.F)),this.jb}async zip(j){this.F.trace("ExtensionManagementService#zip",j.identifier.id);const z=await this.rb(j),G=await(0,P.zip)((0,w.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)()).fsPath,z);return p.URI.file(G)}async unzip(j){return this.F.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:z,cleanup:G}=await this.lb(j),V=h.$mc(z.fsPath);try{return await(0,N.$Nq)(V)}finally{await G()}}getInstalled(j,z=this.H.defaultProfile.extensionsResource,G={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(j??null,z,G)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(j){return this.ab.scanUserExtensionAtLocation(j)}async install(j,z={}){this.F.trace("ExtensionManagementService#install",j.toString());const{location:G,cleanup:V}=await this.lb(j);try{const b=await(0,N.$Nq)(h.$mc(G.fsPath)),L=(0,t.$Np)(b.publisher,b.name);if(b.engines&&b.engines.vscode&&!(0,M.$1p)(b.engines.vscode,this.G.version,this.G.date))throw new Error(v.localize(0,null,L,this.G.version));const q=(await this.I([{manifest:b,extension:G,options:z}])).find(({identifier:Q})=>(0,t.$Ip)(Q,{id:L}));if(q?.local)return q.local;throw q?.error?q.error:(0,s.$Aq)(new Error(`Unknown error while installing extension ${L}`))}finally{await V()}}async installFromLocation(j,z){this.F.trace("ExtensionManagementService#installFromLocation",j.toString());const G=await this.ab.scanUserExtensionAtLocation(j);if(!G||!G.manifest.name||!G.manifest.version)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.wb([[G,{source:"resource"}]],z),this.F.info("Successfully installed extension",G.identifier.id,z.toString()),G}async installExtensionsFromProfile(j,z,G){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",j,z.toString(),G.toString());const V=(await this.getInstalled(T.ExtensionType.User,z)).filter(b=>j.some(L=>(0,t.$Ip)(L,b.identifier)));if(V.length){const b=await Promise.all(V.map(L=>this.ab.scanMetadata(L,z)));await this.wb(V.map((L,F)=>[L,b[F]]),G),this.F.info("Successfully installed extensions",V.map(L=>L.identifier.id),G.toString())}return V}async updateMetadata(j,z,G){return this.F.trace("ExtensionManagementService#updateMetadata",j.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),j=await this.ab.updateMetadata(j,z,G),this.bb.invalidate(G),this.w.fire({local:j,profileLocation:G}),j}async reinstallFromGallery(j){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.z.isEnabled())throw new Error(v.localize(1,null));const z=await this.getTargetPlatform(),[G]=await this.z.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:z,compatible:!0},y.CancellationToken.None);if(!G)throw new Error(v.localize(2,null));await this.ab.setUninstalled(j);try{await this.ab.removeUninstalledExtension(j)}catch(V){throw new Error(v.localize(3,null,(0,k.$qj)(V)))}return this.installFromGallery(G)}$(j,z,G,V){return this.ab.copyExtension(j,z,G,V)}copyExtensions(j,z){return this.ab.copyExtensions(j,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...j){return this.ab.setUninstalled(...j)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(j){this.F.error(j)}}async download(j,z,G){const{location:V}=await this.cb.download(j,z,!G);return V}async lb(j){if(j.scheme===u.Schemas.file)return{location:j,async cleanup(){}};this.F.trace("Downloading extension from",j.toString());const z=(0,w.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)());return await this.gb.download(j,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch(V){this.F.error(V)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(j,z,G){const V=z instanceof p.URI?new t.$Jp({id:(0,t.$Np)(j.publisher,j.name)},j.version):t.$Jp.create(z);return this.hb.createInstance(J,V,j,z,G,(b,L)=>{if(z instanceof p.URI)return this.qb(V,z,G,L);let F=this.db.get(V.toString());return F||(this.db.set(V.toString(),F=this.pb(V,z,b,G,L)),F.finally(()=>this.db.delete(V.toString()))),F},this.ab)}Z(j,z){return new Z(j,z.profileLocation,this.fb)}async pb(j,z,G,V,b){const{verificationStatus:L,location:F}=await this.cb.download(z,G,!V.donotVerifySignature,V.context?.[r.$ap]);try{if(b.isCancellationRequested)throw new A.$7;return await(0,N.$Nq)(F.fsPath),{local:await this.ab.extractUserExtension(j,F.fsPath,{id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName,targetPlatform:z.properties.targetPlatform,isApplicationScoped:V.isApplicationScoped,isMachineScoped:V.isMachineScoped,isBuiltin:V.isBuiltin,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:V.installGivenVersion?!0:!!V.pinned,preRelease:(0,O.$lg)(V.preRelease)?V.preRelease:V.installPreReleaseVersion||z.properties.isPreReleaseVersion,source:"gallery"},!1,b),verificationStatus:L}}catch(q){try{await this.cb.delete(F)}catch(Q){this.F.warn("Error while deleting the downloaded file",F.toString(),(0,A.$_)(Q))}throw(0,s.$Aq)(q)}}async qb(j,z,G,V){return{local:await this.ab.extractUserExtension(j,h.$mc(z.fsPath),{isApplicationScoped:G.isApplicationScoped,isMachineScoped:G.isMachineScoped,isBuiltin:G.isBuiltin,installedTimestamp:Date.now(),pinned:G.installGivenVersion?!0:!!G.pinned,source:"vsix"},!0,V)}}async rb(j){const z=async V=>{let b=await $.Promises.readdir(V);b=b.map(q=>h.$lc(V,q));const L=await Promise.all(b.map(q=>$.Promises.stat(q)));let F=Promise.resolve([]);return L.forEach((q,Q)=>{const X=b[Q];q.isFile()&&(F=F.then(se=>[...se,X])),q.isDirectory()&&(F=F.then(se=>z(X).then(fe=>[...se,...fe])))}),F};return(await z(j.location.fsPath)).map(V=>({path:`extension/${h.$nc(j.location.fsPath,V)}`,localPath:V}))}async sb({added:j,removed:z}){if(z){const G=j&&this.D.extUri.isEqual(z.profileLocation,j.profileLocation)?z.extensions.filter(V=>j.extensions.every(b=>!(0,t.$Ip)(b,V))):z.extensions;for(const V of G)this.F.info("Extensions removed from another source",V.id,z.profileLocation.toString()),this.u.fire({identifier:V,profileLocation:z.profileLocation})}if(j){const V=(await this.getInstalled(T.ExtensionType.User,j.profileLocation)).filter(b=>j.extensions.some(L=>(0,t.$Ip)(L,b.identifier)));this.s.fire(V.map(b=>(this.F.info("Extensions added from another source",b.identifier.id,j.profileLocation.toString()),{identifier:b.identifier,local:b,profileLocation:j.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(z=>this.tb.add(z)));const j=await this.ib.resolve(this.eb.userExtensionsLocation);for(const z of j.children??[])z.isDirectory&&this.tb.add(z.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.vb(z)))}async vb(j){if(!j.affects(this.eb.userExtensionsLocation,K.FileChangeType.ADDED))return;const z=[];for(const G of j.rawAdded){if(this.tb.has(G)||!this.D.extUri.isEqual(this.D.extUri.dirname(G),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(G,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(G).startsWith(".")||!(await this.ib.stat(G)).isDirectory)continue;const V=await this.ab.scanUserExtensionAtLocation(G);V&&V.installedTimestamp===void 0&&(this.tb.add(G),z.push(V))}z.length&&(await this.wb(z.map(G=>[G,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(G=>G.identifier.id)))}async wb(j,z){const G=j.map(V=>V[0]);await this.xb(G),await this.fb.addExtensionsToProfile(j,z),this.s.fire(G.map(V=>({local:V,identifier:V.identifier,operation:r.InstallOperation.None,profileLocation:z})))}async xb(j){const z=await this.ab.getUninstalledExtensions();for(const G of j){const V=t.$Jp.create(G);z[V.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",V.id),await this.ab.setInstalled(V),this.F.info("Removed the extension from uninstalled list:",V.id))}}};e.$Tq=B,e.$Tq=B=we([ne(0,r.$hp),ne(1,ce.$$l),ne(2,ie.$_j),ne(3,i.$Ni),ne(4,o.$Hq),ne(5,n.$Dq),ne(6,a.$Xo),ne(7,ae.$Ei),ne(8,K.$_k),ne(9,ue.$sk),ne(10,le.$Jl),ne(11,x.$Ll)],B);let U=class extends c.$Wc{constructor(j,z,G,V,b,L){super(),this.n=j,this.s=z,this.t=G,this.u=V,this.w=b,this.y=L,this.h=this.B(new I.$me),this.onExtract=this.h.event,this.j=new l.$Cc,this.m=new l.$Cc,this.c=(0,w.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new E.$Mh}async cleanUp(){await this.I(),await this.H()}async scanExtensions(j,z,G){try{const V={includeInvalid:!0,profileLocation:z,productVersion:G};let b=[];if(j===null||j===T.ExtensionType.System){let L=this.j.get(z);L||(L=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},V,!1).finally(()=>this.j.delete(z)),this.j.set(z,L)),b.push(...await L)}else if(j===T.ExtensionType.User){let L=this.m.get(z);L||(L=this.t.scanUserExtensions(V).finally(()=>this.m.delete(z)),this.m.set(z,L)),b.push(...await L)}return b=j!==null?b.filter(L=>L.type===j):b,await Promise.all(b.map(L=>this.G(L)))}catch(V){throw(0,s.$Aq)(V,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(j){try{const z=await this.t.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return await Promise.all(z.map(G=>this.G(G)))}catch(z){throw(0,s.$Aq)(z,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(j){try{const z=await this.t.scanExistingExtension(j,T.ExtensionType.User,{includeInvalid:!0});if(z)return await this.G(z)}catch(z){this.y.error(z)}return null}async extractUserExtension(j,z,G,V,b){const L=j.toString(),F=p.URI.file(h.$lc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$2g)()}`)),q=p.URI.file(h.$lc(this.t.userExtensionsLocation.fsPath,L));let Q=await this.s.exists(q);if(Q&&V){try{await this.C(j.id,q,"removeExisting")}catch{throw new r.$jp(v.localize(4,null,q.fsPath,j.id),r.ExtensionManagementErrorCode.Delete)}Q=!1}if(Q)try{await this.t.updateMetadata(q,G)}catch(X){throw(0,s.$Aq)(X,r.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(b.isCancellationRequested)throw new A.$7;try{this.y.trace(`Started extracting the extension from ${z} to ${q.fsPath}`),await(0,P.$xq)(z,F.fsPath,{sourcePath:"extension",overwrite:!0},b),this.y.info(`Extracted extension to ${q}:`,j.id)}catch(X){throw(0,N.$Mq)(X)}try{await this.t.updateMetadata(F,G)}catch(X){throw(0,s.$Aq)(X,r.ExtensionManagementErrorCode.UpdateMetadata)}if(b.isCancellationRequested)throw new A.$7;try{this.y.trace(`Started renaming the extension from ${F.fsPath} to ${q.fsPath}`),await this.F(F.fsPath,q.fsPath),this.y.info("Renamed to",q.fsPath)}catch(X){if(X.code==="ENOTEMPTY"){this.y.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);try{await this.s.del(F,{recursive:!0})}catch{}}else throw this.y.info(`Rename failed because of ${(0,A.$_)(X)}. Deleted from extracted location`,F),X}this.h.fire(q)}catch(X){try{await this.s.del(F,{recursive:!0})}catch{}throw X}return this.scanLocalExtension(q,T.ExtensionType.User)}async scanMetadata(j,z){return z?(await this.z(j,z))?.metadata:this.t.scanMetadata(j.location)}async z(j,z){return(await this.u.scanProfileExtensions(z)).find(V=>(0,t.$Ip)(V.identifier,j.identifier))}async updateMetadata(j,z,G){try{G?await this.u.updateMetadata([[j,z]],G):await this.t.updateMetadata(j.location,z)}catch(V){throw(0,s.$Aq)(V,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(j.location,j.type,G)}async getUninstalledExtensions(){try{return await this.D()}catch(j){throw(0,s.$Aq)(j,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...j){const z=j.map(G=>t.$Jp.create(G));await this.D(G=>z.forEach(V=>{G[V.toString()]=!0,this.y.info("Marked extension as uninstalled",V.toString())}))}async setInstalled(j){try{await this.D(z=>delete z[j.toString()])}catch(z){throw(0,s.$Aq)(z,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(j,z){if(this.w.extUri.isEqualOrParent(j.location,this.t.userExtensionsLocation))return this.C(j.identifier.id,j.location,z)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.D(z=>delete z[t.$Jp.create(j).toString()])}async copyExtension(j,z,G,V){const b=await this.z(j,z),L=await this.z(j,G);if(V={...b?.metadata,...V},L)if(this.w.extUri.isEqual(L.location,j.location))await this.u.updateMetadata([[j,{...L.metadata,...V}]],G);else{const F=await this.scanLocalExtension(L.location,j.type,G);await this.u.removeExtensionFromProfile(F,G),await this.u.addExtensionsToProfile([[j,{...L.metadata,...V}]],G)}else await this.u.addExtensionsToProfile([[j,V]],G);return this.scanLocalExtension(j.location,j.type,G)}async copyExtensions(j,z,G){const V=await this.scanExtensions(T.ExtensionType.User,j,G),b=await Promise.all(V.filter(L=>!L.isApplicationScoped).map(async L=>[L,await this.scanMetadata(L,j)]));await this.u.addExtensionsToProfile(b,z)}async C(j,z,G){this.y.trace(`Deleting ${G} extension from disk`,j,z.fsPath);const V=this.w.extUri.joinPath(this.w.extUri.dirname(z),`${this.w.extUri.basename(z)}.${(0,g.$tj)((0,f.$2g)()).toString(16)}${_}`);await this.F(z.fsPath,V.fsPath),await this.s.del(V,{recursive:!0}),this.y.info(`Deleted ${G} extension from disk`,j,z.fsPath)}D(j){return this.g.queue(async()=>{let z;try{z=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(V){if((0,K.$ql)(V)!==K.FileOperationResult.FILE_NOT_FOUND)throw V}let G={};if(z)try{G=JSON.parse(z)}catch{}return j&&(j(G),Object.keys(G).length?await this.s.writeFile(this.c,S.$Oe.fromString(JSON.stringify(G))):await this.s.del(this.c)),G})}async F(j,z){try{await $.Promises.rename(j,z,2*60*1e3)}catch(G){throw(0,s.$Aq)(G,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(j,z,G){try{if(G){const b=(await this.t.scanUserExtensions({profileLocation:G})).find(L=>this.w.extUri.isEqual(L.location,j));if(b)return await this.G(b)}else{const V=await this.t.scanExistingExtension(j,z,{includeInvalid:!0});if(V)return await this.G(V)}throw new r.$jp(v.localize(5,null,j.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(V){throw(0,s.$Aq)(V,r.ExtensionManagementErrorCode.ScanningExtension)}}async G(j){const z=await this.s.resolve(j.location);let G,V;return z.children&&(G=z.children.find(({name:b})=>/^readme(\.txt|\.md|)$/i.test(b))?.resource,V=z.children.find(({name:b})=>/^changelog(\.txt|\.md|)$/i.test(b))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:G,changelogUrl:V,publisherDisplayName:j.metadata?.publisherDisplayName,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!j.metadata?.hasPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned,isWorkspaceScoped:!1,source:j.metadata?.source??(j.identifier.uuid?"gallery":"vsix")}}async H(){const j=await this.getUninstalledExtensions();if(Object.keys(j).length===0){this.y.debug("No uninstalled extensions found.");return}this.y.debug("Removing uninstalled extensions:",Object.keys(j));const z=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),G=new Set;for(const b of z)j[t.$Jp.create(b).toString()]||G.add(b.identifier.id.toLowerCase());try{const b=(0,t.$Op)(z,L=>L.identifier);await E.Promises.settled(b.map(async L=>{const F=L.sort((q,Q)=>m.rcompare(q.manifest.version,Q.manifest.version))[0];G.has(F.identifier.id.toLowerCase())||await this.n(await this.G(F))}))}catch(b){this.y.error(b)}const V=z.filter(b=>b.metadata&&j[t.$Jp.create(b).toString()]);await Promise.allSettled(V.map(b=>this.removeUninstalledExtension(b)))}async I(){this.y.trace("ExtensionManagementService#removeTempDeleteFolders");let j;try{j=await this.s.resolve(this.t.userExtensionsLocation)}catch(z){(0,K.$ql)(z)!==K.FileOperationResult.FILE_NOT_FOUND&&this.y.error(z);return}if(j?.children)try{await Promise.allSettled(j.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(_))){this.y.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.s.del(z.resource,{recursive:!0}),this.y.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(G){(0,K.$ql)(G)!==K.FileOperationResult.FILE_NOT_FOUND&&this.y.error(G)}}}))}catch{}}};e.$Uq=U,e.$Uq=U=we([ne(1,K.$_k),ne(2,o.$Hq),ne(3,n.$Dq),ne(4,le.$Jl),ne(5,ie.$_j)],U);let J=class extends s.$Bq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(j,z,G,V,b,L,F,q,Q,X,se,fe){super(),this.l=j,this.manifest=z,this.source=G,this.options=V,this.m=b,this.n=L,this.o=F,this.p=q,this.q=Q,this.s=X,this.t=se,this.u=fe,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(j){const G=(await this.n.scanExtensions(T.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(F=>(0,t.$Ip)(F.identifier,this.identifier));G&&(this.j=r.InstallOperation.Update);const V={isApplicationScoped:this.options.isApplicationScoped||G?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||G?.isMachineScoped,isBuiltin:this.options.isBuiltin||G?.isBuiltin,isSystem:G?.type===T.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??G?.pinned,source:this.source instanceof p.URI?"vsix":"gallery"};let b;if(this.source instanceof p.URI)if(G){if(this.l.equals(new t.$Jp(G.identifier,G.manifest.version)))try{await this.n.removeExtension(G,"existing")}catch{throw new Error(v.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const F=await this.w(this.l);if(F)try{await this.n.removeExtension(F,"existing")}catch{throw new Error(v.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(V.id=this.source.identifier.uuid,V.publisherId=this.source.publisherId,V.publisherDisplayName=this.source.publisherDisplayName,V.targetPlatform=this.source.properties.targetPlatform,V.updated=!!G,V.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,V.hasPreReleaseVersion=G?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,V.preRelease=(0,O.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||G?.preRelease,G&&G.type!==T.ExtensionType.System&&G.manifest.version===this.source.version)return this.n.updateMetadata(G,V,this.options.profileLocation);b=await this.w(this.l)}if(j.isCancellationRequested)throw(0,s.$Aq)(new A.$7);if(!b){const F=await this.m(this.operation,j);b=F.local,this.k=F.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(F){throw(0,s.$Aq)(F,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(j.isCancellationRequested)throw(0,s.$Aq)(new A.$7);try{await this.t.addExtensionsToProfile([[b,V]],this.options.profileLocation,!b.isValid)}catch(F){throw(0,s.$Aq)(F,r.ExtensionManagementErrorCode.AddToProfile)}const L=await this.n.scanLocalExtension(b.location,T.ExtensionType.User,this.options.profileLocation);if(!L)throw new r.$jp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof p.URI&&this.x(b,j),L}async w(j){return(await this.n.getUninstalledExtensions())[j.toString()]?(this.u.trace("Removing the extension from uninstalled list:",j.id),await this.n.setInstalled(j),this.u.info("Removed the extension from uninstalled list:",j.id),(await this.n.scanAllUserExtensions(!0)).find(V=>t.$Jp.create(V).equals(j))):void 0}async x(j,z){try{let[G]=await this.p.getExtensions([{id:j.identifier.id,version:j.manifest.version}],z);if(G||([G]=await this.p.getExtensions([{id:j.identifier.id}],z)),G){const V={id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,hasPreReleaseVersion:j.hasPreReleaseVersion||G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(j,V,this.options.profileLocation)}}catch{}}};J=we([ne(6,le.$Jl),ne(7,r.$hp),ne(8,x.$Ll),ne(9,o.$Hq),ne(10,n.$Dq),ne(11,ie.$_j)],J);class Z extends s.$Bq{constructor(j,z,G){super(),this.extension=j,this.j=z,this.k=G}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(re[163],oe([0,1,6,24,23,19,42,10,18,12]),function(H,e,E,S,y,k,A,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=void 0;let l=class extends A.$Eq{constructor(h,w,m,O,p,f){super(c.URI.file(h.extensionsPath),w,m,O,p,f)}};e.$jR=l,e.$jR=l=we([ne(0,g.$Ni),ne(1,I.$_k),ne(2,S.$Ll),ne(3,y.$Jl),ne(4,k.$$l),ne(5,E.$_j)],l)}),define(re[164],oe([0,1,12,18,42,54,10,11,6,33,23,24]),function(H,e,E,S,y,k,A,I,g,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let h=class extends k.$Lq{constructor(m,O,p,f,$,P,v,a){super(E.URI.file($.builtinExtensionsPath),E.URI.file($.extensionsPath),$.userHome,m.defaultProfile,m,O,p,f,$,P,v,a)}};e.$Jfc=h,e.$Jfc=h=we([ne(0,u.$Ll),ne(1,y.$Dq),ne(2,A.$_k),ne(3,g.$_j),ne(4,S.$Ni),ne(5,c.$sk),ne(6,l.$Jl),ne(7,I.$Ei)],h)}),define(re[73],oe([0,1,8,5,2,132,3,92,11,24]),function(H,e,E,S,y,k,A,I,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$eq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$cq=e.$bq=e.$aq=void 0,e.$dq=w,e.$fq=O,e.$hq=f,e.$aq="__$__isNewStorageMarker",e.$bq="__$__targetStorageMarker",e.$cq=(0,g.$Fi)("storageService");var l;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(l||(e.WillSaveStateReason=l={}));var u;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(u||(e.StorageScope=u={}));var h;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function w($){const P=$.get(e.$bq);if(P)try{return JSON.parse(P)}catch{}return Object.create(null)}class m extends y.$Wc{static{this.a=60*1e3}constructor(P={flushInterval:m.a}){super(),this.m=P,this.b=this.B(new S.$pe),this.c=this.B(new S.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new S.$me),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new y.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(P,v,a){return S.Event.filter(this.b.event,i=>i.scope===P&&(v===void 0||i.key===v),a)}n(){this.j.value=(0,E.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,y.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(P,v){const{key:a,external:i}=v;if(a===e.$bq){switch(P){case u.APPLICATION:this.H=void 0;break;case u.PROFILE:this.F=void 0;break;case u.WORKSPACE:this.C=void 0;break}this.c.fire({scope:P})}else this.b.fire({scope:P,key:a,target:this.J(P)[a],external:i})}w(P){this.f.fire({reason:P})}get(P,v,a){return this.P(v)?.get(P,a)}getBoolean(P,v,a){return this.P(v)?.getBoolean(P,a)}getNumber(P,v,a){return this.P(v)?.getNumber(P,a)}getObject(P,v,a){return this.P(v)?.getObject(P,a)}storeAll(P,v){this.y(()=>{for(const a of P)this.store(a.key,a.value,a.scope,a.target,v)})}store(P,v,a,i,s=!1){if((0,A.$og)(v)){this.remove(P,a,s);return}this.y(()=>{this.z(P,a,i),this.P(a)?.set(P,v,s)})}remove(P,v,a=!1){this.y(()=>{this.z(P,v,void 0),this.P(v)?.delete(P,a)})}y(P){this.b.pause(),this.c.pause();try{P()}finally{this.b.resume(),this.c.resume()}}keys(P,v){const a=[],i=this.J(P);for(const s of Object.keys(i))i[s]===v&&a.push(s);return a}z(P,v,a,i=!1){const s=this.J(v);typeof a=="number"?s[P]!==a&&(s[P]=a,this.P(v)?.set(e.$bq,JSON.stringify(s),i)):typeof s[P]=="number"&&(delete s[P],this.P(v)?.set(e.$bq,JSON.stringify(s),i))}get D(){return this.C||(this.C=this.L(u.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(u.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(u.APPLICATION)),this.H}J(P){switch(P){case u.APPLICATION:return this.I;case u.PROFILE:return this.G;default:return this.D}}L(P){const v=this.P(P);return v?w(v):Object.create(null)}isNew(P){return this.getBoolean(e.$aq,P)===!0}async flush(P=l.NONE){this.f.fire({reason:P});const v=this.P(u.APPLICATION),a=this.P(u.PROFILE),i=this.P(u.WORKSPACE);switch(P){case l.NONE:await E.Promises.settled([v?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case l.SHUTDOWN:await E.Promises.settled([v?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const P=this.P(u.APPLICATION)?.items??new Map,v=this.P(u.PROFILE)?.items??new Map,a=this.P(u.WORKSPACE)?.items??new Map;return f(P,v,a,this.Q(u.APPLICATION)??"",this.Q(u.PROFILE)??"",this.Q(u.WORKSPACE)??"")}async optimize(P){return await this.flush(),this.P(P)?.optimize()}async switch(P,v){return this.w(l.NONE),(0,c.$Kl)(P)?this.R(P,v):this.S(P,v)}M(P,v){return!(P.id===v.id||O(v)&&O(P))}N(P,v,a){this.y(()=>{const i=new Set;for(const[s,r]of P)i.add(s),v.get(s)!==r&&this.u(a,{key:s,external:!0});for(const[s]of v.items)i.has(s)||this.u(a,{key:s,external:!0})})}}e.$eq=m;function O($){return $.isDefault||!!$.useDefaultFlags?.globalState}class p extends m{constructor(){super(),this.U=this.B(new I.$$p(new I.$_p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$$p(new I.$_p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$$p(new I.$_p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(P=>this.u(u.WORKSPACE,P))),this.B(this.W.onDidChangeStorage(P=>this.u(u.PROFILE,P))),this.B(this.U.onDidChangeStorage(P=>this.u(u.APPLICATION,P)))}P(P){switch(P){case u.APPLICATION:return this.U;case u.PROFILE:return this.W;default:return this.X}}Q(P){switch(P){case u.APPLICATION:return"inMemory (application)";case u.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(P){return!1}}e.$gq=p;async function f($,P,v,a,i,s){const r=T=>{try{return JSON.parse(T)}catch{return T}},t=new Map,n=new Map;$.forEach((T,M)=>{t.set(M,T),n.set(M,r(T))});const o=new Map,d=new Map;P.forEach((T,M)=>{o.set(M,T),d.set(M,r(T))});const R=new Map,N=new Map;v.forEach((T,M)=>{R.set(M,T),N.set(M,r(T))}),console.group(a!==i?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const C=[];if(t.forEach((T,M)=>{C.push({key:M,value:T})}),console.table(C),console.groupEnd(),console.log(n),a!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const T=[];o.forEach((M,K)=>{T.push({key:K,value:M})}),console.table(T),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${s})`);const D=[];R.forEach((T,M)=>{D.push({key:M,value:T})}),console.table(D),console.groupEnd(),console.log(N)}}),define(re[165],oe([0,1,14,29,73]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=k;async function k(A,I,g){let c=g&&g.get("storage.serviceMachineId",y.StorageScope.APPLICATION)||null;if(c)return c;try{const u=(await I.readFile(A.serviceMachineIdResource)).value.toString();c=(0,S.$1g)(u)?u:null}catch{c=null}if(!c){c=(0,S.$2g)();try{await I.writeFile(A.serviceMachineIdResource,E.$Oe.fromString(c))}catch{}}return g?.store("storage.serviceMachineId",c,y.StorageScope.APPLICATION,y.StorageTarget.MACHINE),c}}),define(re[166],oe([0,1,165,19,41]),function(H,e,E,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=k;async function k(A,I,g,c,l,u,h){const w={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,y.$Ap)(I,g)&&(0,y.$Cp)(c)===S.TelemetryLevel.USAGE){const m=await(0,E.$iq)(g,l,u);w["X-Market-User-Id"]=m,w["VSCode-SessionId"]=h.machineId||m}return w}}),define(re[167],oe([0,1,20,22,9,13,36,3,12,30,18,21,27,26,50,10,6,33,45,166,73,19,179]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P,v,a,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0,e.$kq=Y;const s=k.$o?w.TargetPlatform.WEB:(0,u.$dp)(k.$u,A.$gc),r="X-Market-Search-Activity-Id";var t;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...L){return String(L.reduce((F,q)=>F|q,0))}var o;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const d={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},R={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},C={pageNumber:1,pageSize:10,sortBy:u.SortBy.NoneOrRelevance,sortOrder:u.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class D{constructor(F=C){this.d=F}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(F,q=this.d.pageSize){return new D({...this.d,pageNumber:F,pageSize:q})}withFilter(F,...q){const Q=[...this.d.criteria,...q.length?q.map(X=>({filterType:F,value:X})):[{filterType:F}]];return new D({...this.d,criteria:Q})}withSortBy(F){return new D({...this.d,sortBy:F})}withSortOrder(F){return new D({...this.d,sortOrder:F})}withFlags(...F){return new D({...this.d,flags:F.reduce((q,Q)=>q|Q,0)})}withAssetTypes(...F){return new D({...this.d,assetTypes:F})}withSource(F){return new D({...this.d,source:F})}get raw(){const{criteria:F,pageNumber:q,pageSize:Q,sortBy:X,sortOrder:se,flags:fe,assetTypes:he}=this.d;return{filters:[{criteria:F,pageNumber:q,pageSize:Q,sortBy:X,sortOrder:se}],assetTypes:he,flags:fe}}get searchText(){const F=this.d.criteria.filter(q=>q.filterType===o.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(F=>String(F.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function T(L,F){const q=(L||[]).filter(Q=>Q.statisticName===F)[0];return q?q.value:0}function M(L){const F="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(Q=>Q.assetType.indexOf(F)===0).reduce((Q,X)=>{const se=ie(L,X.assetType);return se&&Q.push([X.assetType.substring(F.length),se]),Q},[])}function K(L){if(L.properties){const F=L.properties.filter(X=>X.key===d.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=F.filter(X=>q.test(X.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return ie(L,d.Repository)}function ae(L){return{uri:`${L.fallbackAssetUri}/${d.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${d.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function ie(L,F){return L.files.filter(Q=>Q.assetType===F)[0]?{uri:`${L.assetUri}/${F}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${F}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ue(L,F){const q=L.properties?L.properties.filter(X=>X.key===F):[],Q=q.length>0&&q[0].value;return Q?Q.split(",").map(X=>(0,h.$Mp)(X)):[]}function ce(L){const F=L.properties?L.properties.filter(q=>q.key===R.Engine):[];return F.length>0&&F[0].value||""}function le(L){const F=L.properties?L.properties.filter(q=>q.key===R.PreRelease):[];return F.length>0&&F[0].value==="true"}function x(L){const F=L.properties?L.properties.filter(Q=>Q.key===R.LocalizedLanguages):[],q=F.length>0&&F[0].value||"";return q?q.split(","):[]}function _(L){return L.properties?.find(F=>F.key===R.SponsorLink)?.value}function B(L){return L.properties?.find(F=>F.key===R.SupportLink)?.value}function U(L){return L.indexOf("preview")!==-1}function J(L){return L.targetPlatform?(0,u.$cp)(L.targetPlatform):w.TargetPlatform.UNDEFINED}function Z(L){const F=(0,E.$Ob)(L.versions.map(J)),q=!!L.tags?.includes(u.$9o),Q=F.indexOf(w.TargetPlatform.WEB);return q?Q===-1&&F.push(w.TargetPlatform.WEB):Q!==-1&&F.splice(Q,1),F}function Y(L,F){for(let q=0;q<L.length;q++){const Q=L[q];if(Q.version===L[q-1]?.version){let X=q;if(J(Q)===F)for(;X>0&&L[X-1].version===Q.version;)X--;X!==q&&(L.splice(q,1),L.splice(X,0,Q))}}return L}function j(L,F,q){L.telemetryData={index:F,querySource:q,queryActivityId:L.queryContext?.[r]}}function z(L,F,q,Q){const X=L.versions[0],se={manifest:ie(F,d.Manifest),readme:ie(F,d.Details),changelog:ie(F,d.Changelog),license:ie(F,d.License),repository:K(F),download:ae(F),icon:ie(F,d.Icon),signature:ie(F,d.Signature),coreTranslations:M(F)};return{type:"gallery",identifier:{id:(0,h.$Np)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:F.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(X),description:L.shortDescription??"",installCount:T(L.statistics,"install"),rating:T(L.statistics,"averagerating"),ratingCount:T(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:q,assets:se,properties:{dependencies:ue(F,R.Dependency),extensionPack:ue(F,R.ExtensionPack),engine:ce(F),localizedLanguages:x(F),targetPlatform:J(F),isPreReleaseVersion:le(F)},hasPreReleaseVersion:le(X),hasReleaseVersion:!0,preview:U(L.flags),isSigned:!!se.signature,queryContext:Q,supportLink:B(X)}}let G=class{constructor(F,q,Q,X,se,fe,he,Ee){this.k=q,this.l=Q,this.n=X,this.o=se,this.q=fe,this.u=he,this.w=Ee;const pe=he.extensionsGallery,ge=pe?.servicePPEUrl&&Ee.getValue("_extensionsGallery.enablePPE");this.d=ge?pe.servicePPEUrl:pe?.serviceUrl,this.g=ge?void 0:pe?.searchUrl,this.h=pe?.controlUrl,this.j=(0,P.$jq)(he.version,he,this.n,this.w,this.q,F,this.o)}x(F=""){return`${this.d}${F}`}isEnabled(){return!!this.d}async getExtensions(F,q,Q){const X=S.CancellationToken.isCancellationToken(q)?{}:q,se=S.CancellationToken.isCancellationToken(q)?q:Q,fe=[],he=[],Ee=[],pe=[];let ge=!0;for(const ve of F){ve.uuid?he.push(ve.uuid):fe.push(ve.id);const ke=!!(ve.version||ve.preRelease);Ee.push({id:ve.id,uuid:ve.uuid,includePreRelease:ke}),ve.version&&pe.push({id:ve.id,uuid:ve.uuid,version:ve.version}),ge=ge&&!!ve.hasPreRelease&&!ke}if(!he.length&&!fe.length)return[];let de=new D().withPage(1,F.length);he.length&&(de=de.withFilter(o.ExtensionId,...he)),fe.length&&(de=de.withFilter(o.ExtensionName,...fe)),(X.queryAllVersions||ge)&&(de=de.withFlags(de.flags,t.IncludeVersions)),X.source&&(de=de.withSource(X.source));const{extensions:$e}=await this.z(de,{targetPlatform:X.targetPlatform??s,includePreRelease:Ee,versions:pe,compatible:!!X.compatible,productVersion:X.productVersion??{version:this.u.version,date:this.u.date}},se);return X.source&&$e.forEach((ve,ke)=>j(ve,ke,X.source)),$e}async getCompatibleExtension(F,q,Q,X={version:this.u.version,date:this.u.date}){if((0,u.$ep)(F.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(F,q,Q))return F;const se=new D().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,F.identifier.uuid),{extensions:fe}=await this.z(se,{targetPlatform:Q,compatible:!0,includePreRelease:q,productVersion:X},S.CancellationToken.None);return fe[0]||null}async isExtensionCompatible(F,q,Q,X={version:this.u.version,date:this.u.date}){if(!(0,u.$fp)(F.properties.targetPlatform,F.allTargetPlatforms,Q)||!q&&F.properties.isPreReleaseVersion)return!1;let se=F.properties.engine;if(!se){const fe=await this.getManifest(F,S.CancellationToken.None);if(!fe)throw new Error("Manifest was not found");se=fe.engines.vscode}return(0,m.$1p)(se,X.version,X.date)}async y(F,q,Q,X,se,fe,he={version:this.u.version,date:this.u.date}){if(!(0,u.$fp)(J(q),se,fe)||Q!=="any"&&le(q)!==(Q==="prerelease"))return!1;if(X)try{const Ee=await this.E(F,q);if(!(0,m.$1p)(Ee,he.version,he.date))return!1}catch(Ee){return this.l.error(`Error while getting the engine for the version ${q.version}.`,(0,y.$_)(Ee)),!1}return!0}async query(F,q){let Q=F.text||"";const X=F.pageSize??50;let se=new D().withPage(1,X);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(se=se.withFilter(o.Category,$e||de),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,de,$e)=>(se=se.withFilter(o.Tag,$e||de),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(o.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),se=se.withFilter(o.SearchText,Q)),se=se.withSortBy(u.SortBy.NoneOrRelevance)):F.ids?se=se.withFilter(o.ExtensionId,...F.ids):F.names?se=se.withFilter(o.ExtensionName,...F.names):se=se.withSortBy(u.SortBy.InstallCount),typeof F.sortBy=="number"&&(se=se.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(se=se.withSortOrder(F.sortOrder)),F.source&&(se=se.withSource(F.source));const fe=async(ge,de)=>{const{extensions:$e,total:ve}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!F.includePreRelease,productVersion:F.productVersion??{version:this.u.version,date:this.u.date}},de);return $e.forEach((ke,W)=>j(ke,(ge.pageNumber-1)*ge.pageSize+W,F.source)),{extensions:$e,total:ve}},{extensions:he,total:Ee}=await fe(se,q),pe=async(ge,de)=>{if(de.isCancellationRequested)throw new y.$7;const{extensions:$e}=await fe(se.withPage(ge+1),de);return $e};return{firstPage:he,total:Ee,pageSize:se.pageSize,getPage:pe}}async z(F,q,Q){const X=F.flags;F.flags&t.IncludeLatestVersionOnly&&F.flags&t.IncludeVersions&&(F=F.withFlags(F.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(F.flags&t.IncludeLatestVersionOnly)&&!(F.flags&t.IncludeVersions)&&(F=F.withFlags(F.flags,t.IncludeLatestVersionOnly)),q.versions?.length&&(F=F.withFlags(F.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),F=F.withFlags(F.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:se,total:fe,context:he}=await this.B(F,Q);if(!(F.flags&t.IncludeLatestVersionOnly)){const de=[];for(const $e of se){const ve=await this.A($e,q,he);ve&&de.push(ve)}return{extensions:de,total:fe}}const pe=[],ge=new Map;for(let de=0;de<se.length;de++){const $e=se[de],ve={id:(0,h.$Np)($e.publisher.publisherName,$e.extensionName),uuid:$e.extensionId},ke=(0,I.$lg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ee=>(0,h.$Ip)(ee,ve))?.includePreRelease;if(q.compatible&&(0,u.$ep)(Z($e),q.targetPlatform))continue;const W=await this.A($e,q,he);!W||W.properties.isPreReleaseVersion&&(!ke||!W.hasReleaseVersion)||!W.properties.isPreReleaseVersion&&W.properties.targetPlatform!==q.targetPlatform&&W.hasPreReleaseVersion?ge.set($e.extensionId,de):pe.push([de,W])}if(ge.size){const de=new i.$ge,$e=new D().withFlags(X&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(o.ExtensionId,...ge.keys()),{extensions:ve}=await this.z($e,q,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ge.size});for(const ke of ve){const W=ge.get(ke.identifier.uuid);pe.push([W,ke])}}return{extensions:pe.sort((de,$e)=>de[0]-$e[0]).map(([,de])=>de),total:fe}}async A(F,q,Q){const X={id:(0,h.$Np)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},se=q.versions?.find(pe=>(0,h.$Ip)(pe,X))?.version,fe=(0,I.$lg)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(pe=>(0,h.$Ip)(pe,X))?.includePreRelease,he=Z(F),Ee=Y(F.versions,q.targetPlatform);if(q.compatible&&(0,u.$ep)(he,q.targetPlatform))return null;for(let pe=0;pe<Ee.length;pe++){const ge=Ee[pe];if(!(se&&ge.version!==se)){if(await this.y((0,h.$Np)(F.publisher.publisherName,F.extensionName),ge,fe?"any":"release",q.compatible,he,q.targetPlatform,q.productVersion))return z(F,ge,he,Q);if(se&&ge.version===se)return null}}return se||q.compatible?null:z(F,F.versions[0],he)}async B(F,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(t.Unpublished));const Q=await this.j,X=JSON.stringify(F.raw),se={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},fe=new i.$ge;let he,Ee,pe=0;try{if(he=await this.k.request({type:"POST",url:this.g&&F.criteria.some(de=>de.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:X,headers:se},q),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:pe};const ge=await(0,$.$8p)(he);if(ge){const de=ge.results[0],$e=de.extensions,ve=de.resultMetadata&&de.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return pe=ve&&ve.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:$e,total:pe,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:pe}}catch(ge){if((0,y.$6)(ge))throw Ee=u.ExtensionGalleryErrorCode.Cancelled,ge;{const de=(0,y.$_)(ge);throw Ee=de.startsWith("XHR timeout")?u.ExtensionGalleryErrorCode.Timeout:u.ExtensionGalleryErrorCode.Failed,new u.$ip(de,Ee)}}finally{this.o.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(X.length),duration:fe.elapsed(),success:!!he&&(0,$.$4p)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:Ee,count:String(pe)})}}async reportStatistic(F,q,Q,X){if(!this.isEnabled())return;const se=k.$o?this.x(`/itemName/${F}.${q}/version/${Q}/statType/${X===u.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${F}/extensions/${q}/${Q}/stats?statType=${X}`),fe=k.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.j,Accept:fe};try{await this.k.request({type:"POST",url:se,headers:Ee},S.CancellationToken.None)}catch{}}async download(F,q,Q){this.l.trace("ExtensionGalleryService#download",F.identifier.id);const X=(0,h.$Qp)(F),se=new Date().getTime(),fe=Q===u.InstallOperation.Install?"install":Q===u.InstallOperation.Update?"update":"",he=fe?{uri:`${F.assets.download.uri}${g.URI.parse(F.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${F.assets.download.fallbackUri}${g.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:F.assets.download,Ee=F.queryContext?.[r]?{[r]:F.queryContext[r]}:void 0,pe=await this.D(F.identifier.id,he,d.VSIX,Ee?{headers:Ee}:void 0);try{await this.q.writeFile(q,pe.stream)}catch(ge){try{await this.q.del(q)}catch(de){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,y.$_)(de))}throw new u.$ip((0,y.$_)(ge),u.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...X,duration:new Date().getTime()-se})}async downloadSignatureArchive(F,q){if(!F.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",F.identifier.id);const Q=await this.D(F.identifier.id,F.assets.signature,d.Signature);try{await this.q.writeFile(q,Q.stream)}catch(X){try{await this.q.del(q)}catch(se){this.l.warn(`Error while deleting the file ${q.toString()}`,(0,y.$_)(se))}throw new u.$ip((0,y.$_)(X),u.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(F,q){if(F.assets.readme){const Q=await this.D(F.identifier.id,F.assets.readme,d.Details,{},q);return await(0,$.$7p)(Q)||""}return""}async getManifest(F,q){if(F.assets.manifest){const Q=await this.D(F.identifier.id,F.assets.manifest,d.Manifest,{},q),X=await(0,$.$7p)(Q);return X?JSON.parse(X):null}return null}async C(F,q,Q){const X=ie(q,d.Manifest);if(!X)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},fe=await this.D(F,X,d.Manifest,{headers:se});return await(0,$.$8p)(fe)}async getCoreTranslation(F,q){const Q=F.assets.coreTranslations.filter(X=>X[0]===q.toUpperCase())[0];if(Q){const X=await this.D(F.identifier.id,Q[1],Q[0]),se=await(0,$.$7p)(X);return se?JSON.parse(se):null}return null}async getChangelog(F,q){if(F.assets.changelog){const Q=await this.D(F.identifier.id,F.assets.changelog,d.Changelog,{},q);return await(0,$.$7p)(Q)||""}return""}async getAllCompatibleVersions(F,q,Q){let X=new D().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?X=X.withFilter(o.ExtensionId,F.identifier.uuid):X=X.withFilter(o.ExtensionName,F.identifier.id);const{galleryExtensions:se}=await this.B(X,S.CancellationToken.None);if(!se.length)return[];const fe=Z(se[0]);if((0,u.$ep)(fe,Q))return[];const he=[];await Promise.all(se[0].versions.map(async ge=>{try{await this.y(F.identifier.id,ge,q?"any":"release",!0,fe,Q)&&he.push(ge)}catch{}}));const Ee=[],pe=new Set;for(const ge of Y(he,Q))pe.has(ge.version)||(pe.add(ge.version),Ee.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:le(ge)}));return Ee}async D(F,q,Q,X={},se=S.CancellationToken.None){const fe=await this.j,he={type:"GET"},Ee={...fe,...X.headers||{}};X={...X,...he,headers:Ee};const pe=q.uri,ge=q.fallbackUri,de={...X,url:pe};try{const $e=await this.k.request(de,se);if($e.res.statusCode===200)return $e;const ve=await(0,$.$7p)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${ve}`)}catch($e){if((0,y.$6)($e))throw $e;const ve=(0,y.$_)($e);this.o.publicLog2("galleryService:cdnFallback",{extension:F,assetType:Q,message:ve});const ke={...X,url:ge};return this.k.request(ke,se)}}async E(F,q){let Q=ce(q);if(!Q){this.o.publicLog2("galleryService:engineFallback",{extension:F,version:q.version});const X=await this.C(F,q,S.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Q=X.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const F=await this.k.request({type:"GET",url:this.h},S.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,$.$8p)(F),Q=[],X={},se=[];if(q){for(const fe of q.malicious)Q.push({id:fe});if(q.migrateToPreRelease)for(const[fe,he]of Object.entries(q.migrateToPreRelease))(!he.engine||(0,m.$1p)(he.engine,this.u.version,this.u.date))&&(X[fe.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[fe,he]of Object.entries(q.deprecated))he&&(X[fe.toLowerCase()]=(0,I.$lg)(he)?{}:he);if(q.search)for(const fe of q.search)se.push(fe)}return{malicious:Q,deprecated:X,search:se}}};G=we([ne(1,$.$2p),ne(2,p.$_j),ne(3,l.$Mi),ne(4,a.$$l),ne(5,O.$_k),ne(6,f.$sk),ne(7,c.$_i)],G);let V=class extends G{constructor(F,q,Q,X,se,fe,he,Ee){super(F,q,Q,X,se,fe,he,Ee)}};e.$lq=V,e.$lq=V=we([ne(0,v.$cq),ne(1,$.$2p),ne(2,p.$_j),ne(3,l.$Mi),ne(4,a.$$l),ne(5,O.$_k),ne(6,f.$sk),ne(7,c.$_i)],V);let b=class extends G{constructor(F,q,Q,X,se,fe,he){super(void 0,F,q,Q,X,se,fe,he)}};e.$mq=b,e.$mq=b=we([ne(0,$.$2p),ne(1,p.$_j),ne(2,l.$Mi),ne(3,a.$$l),ne(4,O.$_k),ne(5,f.$sk),ne(6,c.$_i)],b)}),define(re[168],oe([0,1,12,18,10,6,147,23,24,3,69]),function(H,e,E,S,y,k,A,I,g,c,l){"use strict";var u,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$iR=e.$hR=e.$gR=void 0;let w=class extends g.$Ol{static{u=this}static{this.a="profileAssociationsMigration"}constructor(f,$,P,v,a){super(P,v,$,a),this.U=f,this.W=P}O(){return this.U.getItem(u.b,[]).map($=>({...$,location:(0,c.$fg)($.location)?this.w.extUri.joinPath(this.profilesHome,$.location):E.URI.revive($.location)}))}Q(){const f=this.U.getItem(u.c,{});return this.U.getItem(u.a,!1)?f:this.N(f)}S(){return this.w.extUri.joinPath(E.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$gR=w,e.$gR=w=u=we([ne(0,A.$bR),ne(1,I.$Jl),ne(2,S.$Ni),ne(3,y.$_k),ne(4,k.$_j)],w);let m=h=class extends w{constructor(f,$,P,v,a){super(f,$,P,v,a),this.$=f}P(f){f.length?this.$.setItem(h.b,f.map($=>({...$,location:this.w.extUri.basename($.location)}))):this.$.removeItem(h.b)}O(){const f=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(f),this.$.setItem("userDataProfilesMigration",!0)),f}R(f){f.emptyWindows||f.workspaces?this.$.setItem(h.c,f):this.$.removeItem(h.c)}Q(){const f="workspaceAndProfileInfo",$=this.$.getItem(f,void 0);if($){this.$.removeItem(f);const v=$.reduce((a,{workspace:i,profile:s})=>(a[E.URI.revive(i).toString()]=E.URI.revive(s).toString(),a),{});this.$.setItem(h.c,{workspaces:v})}const P=super.Q();return this.$.getItem(h.a,!1)||(this.R(P),this.$.setItem(h.a,!0)),P}};e.$hR=m,e.$hR=m=h=we([ne(0,A.$cR),ne(1,I.$Jl),ne(2,S.$Ni),ne(3,y.$_k),ne(4,k.$_j)],m);let O=class extends m{constructor(f,$,P,v){super(new l.$fR(l.SaveStrategy.IMMEDIATE,$,v,P),f,$,P,v)}async init(){return await this.$.init(),super.init()}};e.$iR=O,e.$iR=O=we([ne(0,I.$Jl),ne(1,S.$Ni),ne(2,y.$_k),ne(3,k.$_j)],O)}),define(re[169],oe([0,1,145,8,14,9,3,30,18,146,6,45,144,180]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=void 0,e.$as=p;let m=class extends u.$3p{constructor($,P,v,a){super(a),this.m=$,this.n=P,this.r=v,this.s(),this.B($.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const $=this.m.getValue("http");this.f=$?.proxy,this.g=!!$?.proxyStrictSSL,this.h=$?.proxyAuthorization}async request($,P){const{f:v,g:a}=this;let i;try{i=await(0,c.$Qm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$_)(t)))}const s={...process.env,...i},r=$.agent?$.agent:await(0,h.$$r)($.url||"",s,{proxyUrl:v,strictSSL:a});return $.agent=r,$.strictSSL=a,this.h&&($.headers={...$.headers||{},"Proxy-Authorization":this.h}),this.c($.isChromiumNetwork?"electron":"node",$,()=>p($,P))}async resolveProxy($){}async loadCertificates(){return(await new Promise((P,v)=>{H(["@vscode/proxy-agent"],P,v)}).then(ye)).loadSystemCertificates({log:this.r})}};e.$_r=m,e.$_r=m=we([ne(0,I.$_i),ne(1,g.$Ni),ne(2,l.$_j),ne(3,l.$ak)],m);async function O(f){return((0,E.parse)(f.url).protocol==="https:"?await new Promise((v,a)=>{H(["https"],v,a)}).then(ye):await new Promise((v,a)=>{H(["http"],v,a)}).then(ye)).request}async function p(f,$){return S.Promises.withAsyncBody(async(P,v)=>{const a=(0,E.parse)(f.url),i=f.getRawRequest?f.getRawRequest(f):await O(f),s={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,A.$lg)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(s.auth=f.user+":"+f.password);const r=i(s,t=>{const n=(0,A.$jg)(f.followRedirects)?f.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&n>0&&t.headers.location)p({...f,url:t.headers.location,followRedirects:n-1},$).then(P,v);else{let o=t;!f.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,w.createGunzip)())),P({res:t,stream:(0,y.$4e)(o)})}});r.on("error",v),f.timeout&&r.setTimeout(f.timeout),f.isChromiumNetwork&&r.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&r.write(f.data),r.end(),$.onCancellationRequested(()=>{r.abort(),v(new k.$7)})})}});var ze=this&&this.__importDefault||function(H){return H&&H.__esModule?H:{default:H}};define(re[181],oe([0,1,35,8,38,9,2,15,16,13,36,12,25,30,141,61,143,18,120,167,21,71,148,42,54,162,164,10,131,133,51,129,64,68,150,6,137,39,138,153,33,45,169,69,70,19,152,41,154,155,23,157,24,168,156,163,134,136,4,158,182]),function(H,e,E,S,y,k,A,I,g,c,l,u,h,w,m,O,p,f,$,P,v,a,i,s,r,t,n,o,d,R,N,C,D,T,M,K,ae,ie,ue,ce,le,x,_,B,U,J,Z,Y,j,z,G,V,b,L,F,q,Q,X,se,fe,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=pe,ce=ze(ce);class Ee extends A.$Wc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,$e]=await this.f();return de.invokeFunction(async ve=>{const ke=ve.get(K.$_j),W=ve.get(o.$_k),ee=ve.get(f.$Ni),te=ve.get(b.$Ll);ke.info("CLI main",this.b),this.h(ke),await this.j(ee,W,te,de),await Promise.all($e.map(me=>{(0,S.$wh)(me.flush(),1e3)}))})}async f(){const de=new D.$Di,$e={_serviceBrand:void 0,...ce.default};de.set(le.$sk,$e);const ve=new $.$8m(this.b,$e);de.set(f.$Ni,ve),await Promise.all([this.g(ve.appSettingsHome.with({scheme:I.Schemas.file}).fsPath),this.g(ve.extensionsPath)].map(Pe=>Pe?h.Promises.mkdir(Pe,{recursive:!0}):void 0));const ke=new X.$aR((0,K.$nk)(ve),ve.logsHome);de.set(K.$ak,ke);const W=this.B(ke.createLogger("cli",{name:(0,se.localize)(0,null)})),ee=[];ke.getLogLevel()===K.LogLevel.Trace&&ee.push(new K.$hk(ke.getLogLevel()));const te=this.B(new Q.$kR(W,ee));de.set(K.$_j,te);const me=this.B(new d.$Wq(te));de.set(o.$_k,me);const be=this.B(new R.$nr(te));me.registerProvider(I.Schemas.file,be);const Ae=new V.$Os(me);de.set(G.$Jl,Ae);const Ie=new B.$eR(B.SaveStrategy.DELAYED,ve,te,me),Ce=new L.$gR(Ie,Ae,ve,me,te);de.set(b.$Ll,Ce),me.registerProvider(I.Schemas.vscodeUserData,new fe.$agc(I.Schemas.file,be,I.Schemas.vscodeUserData,Ce,Ae,te));const Re=c.$i&&$e.win32RegValueName?this.B(new ue.$$fc(te,$e.win32RegValueName)):ve.policyFile?this.B(new ae.$_fc(ve.policyFile,me,te)):new ie.$to;de.set(ie.$ro,Re);const Le=this.B(new m.$To(Ce.defaultProfile.settingsResource,me,Re,te));de.set(w.$_i,Le),await Promise.all([Ie.init(),Le.initialize()]);let qe;try{qe=await(0,F.$Mfc)(Ie,te)}catch(Pe){Pe.code!=="ENOENT"&&te.error(Pe)}const De=await(0,F.$Nfc)(Ie,te),Te=await(0,F.$Ofc)(Ie,te);Ce.init(),de.set(G.$Jl,new V.$Os(me));const Fe=new _.$_r(Le,ve,te,ke);de.set(x.$2p,Fe),de.set(O.$Xo,new N.$Ci(p.$zR,void 0,!0)),de.set(s.$Dq,new N.$Ci(q.$jR,void 0,!0)),de.set(r.$Hq,new N.$Ci(n.$Jfc,void 0,!0)),de.set(a.$nq,new N.$Ci(a.$pq,void 0,!0)),de.set(t.$Sq,new N.$Ci(t.$Tq,void 0,!0)),de.set(v.$hp,new N.$Ci(P.$mq,void 0,!0)),de.set(T.$6r,new N.$Ci(M.$8r,void 0,!1));const Ue=[],Se=(0,Y.$Fp)($e,Le);if((0,Y.$Ap)($e,ve)){$e.aiConfig&&$e.aiConfig.ariaKey&&Ue.push(new j.$$Q(Fe,Se,"monacoworkbench",null,$e.aiConfig.ariaKey));const Pe={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,U.$rp)((0,E.release)(),(0,E.hostname)(),process.arch,$e.commit,$e.version,qe,De,Te,Se),piiPaths:(0,Y.$Gp)(ve)};de.set(J.$$l,new N.$Ci(Z.$bs,[Pe],!1))}else de.set(J.$$l,Y.$vp);return[new C.$qr(de),Ue]}g(de){if(c.$i){const $e=(0,he.getUNCHost)(de);$e&&(0,he.addUNCHostToAllowlist)($e)}return de}h(de){(0,k.setUnexpectedErrorHandler)($e=>{const ve=(0,y.$qj)($e,!0);ve&&de.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",$e=>{(0,k.$2)($e)||(0,k.$3)($e)}),process.on("unhandledRejection",$e=>(0,k.$3)($e))}async j(de,$e,ve,ke){let W;if(de.args.profile&&(W=ve.profiles.find(te=>te.name===de.args.profile),!W))throw new Error(`Profile '${de.args.profile}' not found.`);const ee=(W??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$qq,new K.$hk(K.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,ee);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const te={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:ee};return ke.createInstance(i.$qq,new K.$hk(K.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),te,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$qq,new K.$hk(K.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,ee);if(this.b["update-extensions"])return ke.createInstance(i.$qq,new K.$hk(K.LogLevel.Info,!1)).updateExtensions(ee);if(this.b["locate-extension"])return ke.createInstance(i.$qq,new K.$hk(K.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,z.$qgc)(de.appRoot,de.extensionsPath))}}m(de){return de.map($e=>/\.vsix$/i.test($e)?u.URI.file((0,g.$kc)($e)?$e:(0,g.$lc)((0,l.cwd)(),$e)):$e)}}async function pe(ge){const de=new Ee(ge);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/0cb5ca1d55b8ac035764b4726b5a01b6da22147d/core/vs/code/node/cliProcessMain.js.map
