/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","vs/base/common/process","vs/platform/extensions/common/extensions","os","vs/base/common/charCode","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/errorMessage","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","fs","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/externalServices/common/serviceMachineId","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/marshallingIds","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationModels","vs/platform/languagePacks/common/languagePacks","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/uint","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],P=0,a=ne.length;P<a;P++)e[P]=le[ne[P]];return e};define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var P;(function(N){N[N.LoaderAvailable=1]="LoaderAvailable",N[N.BeginLoadingScript=10]="BeginLoadingScript",N[N.EndLoadingScriptOK=11]="EndLoadingScriptOK",N[N.EndLoadingScriptError=12]="EndLoadingScriptError",N[N.BeginInvokeFactory=21]="BeginInvokeFactory",N[N.EndInvokeFactory=22]="EndInvokeFactory",N[N.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",N[N.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",N[N.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",N[N.NodeEndNativeRequire=34]="NodeEndNativeRequire",N[N.CachedDataFound=60]="CachedDataFound",N[N.CachedDataMissed=61]="CachedDataMissed",N[N.CachedDataRejected=62]="CachedDataRejected",N[N.CachedDataCreated=63]="CachedDataCreated"})(P||(e.LoaderEventType=P={}));class a{static get(){const O=new Map,T=new Map,A=new Map,L=new Map;function p(c,m){c.has(m.detail)||c.set(m.detail,-m.timestamp)}function S(c,m){const b=c.get(m.detail);b&&(b>=0||c.set(m.detail,b+m.timestamp))}let d=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(d=ne.getStats().slice(0).sort((c,m)=>c.timestamp-m.timestamp));for(const c of d)switch(c.type){case P.BeginLoadingScript:p(O,c);break;case P.EndLoadingScriptOK:case P.EndLoadingScriptError:S(O,c);break;case P.BeginInvokeFactory:p(T,c);break;case P.EndInvokeFactory:S(T,c);break;case P.NodeBeginNativeRequire:p(A,c);break;case P.NodeEndNativeRequire:S(A,c);break;case P.NodeBeginEvaluatingScript:p(L,c);break;case P.NodeEndEvaluatingScript:S(L,c);break}let h=0;A.forEach(c=>h+=c);function $(c){const m=[];return c.forEach((b,f)=>m.push([f,b])),m}return{amdLoad:$(O),amdInvoke:$(T),nodeRequire:$(A),nodeEval:$(L),nodeRequireTotal:h}}static toMarkdownTable(O,T){let A="";const L=[];return O.forEach((p,S)=>{L[S]=p.length}),T.forEach(p=>{p.forEach((S,d)=>{typeof S>"u"&&(S=p[d]="-");const h=S.toString().length;L[d]=Math.max(h,L[d])})}),O.forEach((p,S)=>{A+=`| ${p+" ".repeat(L[S]-p.toString().length)} `}),A+=`|
`,O.forEach((p,S)=>{A+=`| ${"-".repeat(L[S])} `}),A+=`|
`,T.forEach(p=>{p.forEach((S,d)=>{typeof S<"u"&&(A+=`| ${S+" ".repeat(L[d]-S.toString().length)} `)}),A+=`|
`}),A}}e.$W=a}),define(le[130],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=P,e.$ib=a,e.$jb=N,e.$kb=O,e.$lb=T,e.$mb=A,e.$nb=L,e.$pb=S,e.$qb=d,e.$rb=h,e.$sb=$,e.$tb=c;function P(m,b){const f=a(m,b);if(f!==-1)return m[f]}function a(m,b,f=m.length-1){for(let w=f;w>=0;w--){const I=m[w];if(b(I))return w}return-1}function N(m,b){const f=O(m,b);return f===-1?void 0:m[f]}function O(m,b,f=0,w=m.length){let I=f,g=w;for(;I<g;){const u=Math.floor((I+g)/2);b(m[u])?I=u+1:g=u}return I-1}function T(m,b){const f=A(m,b);return f===m.length?void 0:m[f]}function A(m,b,f=0,w=m.length){let I=f,g=w;for(;I<g;){const u=Math.floor((I+g)/2);b(m[u])?g=u:I=u+1}return I}function L(m,b,f=0,w=m.length){const I=A(m,b,f,w);return I===m.length?-1:I}class p{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(p.assertInvariants){if(this.d){for(const w of this.e)if(this.d(w)&&!b(w))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const f=O(this.e,b,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$ob=p;function S(m,b){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const I=m[w];b(I,f)>0&&(f=I)}return f}function d(m,b){if(m.length===0)return;let f=m[0];for(let w=1;w<m.length;w++){const I=m[w];b(I,f)>=0&&(f=I)}return f}function h(m,b){return S(m,(f,w)=>-b(f,w))}function $(m,b){if(m.length===0)return-1;let f=0;for(let w=1;w<m.length;w++){const I=m[w];b(I,m[f])>0&&(f=w)}return f}function c(m,b){for(const f of m){const w=b(f);if(w!==void 0)return w}}}),define(le[39],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.Backspace=8]="Backspace",a[a.Tab=9]="Tab",a[a.LineFeed=10]="LineFeed",a[a.CarriageReturn=13]="CarriageReturn",a[a.Space=32]="Space",a[a.ExclamationMark=33]="ExclamationMark",a[a.DoubleQuote=34]="DoubleQuote",a[a.Hash=35]="Hash",a[a.DollarSign=36]="DollarSign",a[a.PercentSign=37]="PercentSign",a[a.Ampersand=38]="Ampersand",a[a.SingleQuote=39]="SingleQuote",a[a.OpenParen=40]="OpenParen",a[a.CloseParen=41]="CloseParen",a[a.Asterisk=42]="Asterisk",a[a.Plus=43]="Plus",a[a.Comma=44]="Comma",a[a.Dash=45]="Dash",a[a.Period=46]="Period",a[a.Slash=47]="Slash",a[a.Digit0=48]="Digit0",a[a.Digit1=49]="Digit1",a[a.Digit2=50]="Digit2",a[a.Digit3=51]="Digit3",a[a.Digit4=52]="Digit4",a[a.Digit5=53]="Digit5",a[a.Digit6=54]="Digit6",a[a.Digit7=55]="Digit7",a[a.Digit8=56]="Digit8",a[a.Digit9=57]="Digit9",a[a.Colon=58]="Colon",a[a.Semicolon=59]="Semicolon",a[a.LessThan=60]="LessThan",a[a.Equals=61]="Equals",a[a.GreaterThan=62]="GreaterThan",a[a.QuestionMark=63]="QuestionMark",a[a.AtSign=64]="AtSign",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.OpenSquareBracket=91]="OpenSquareBracket",a[a.Backslash=92]="Backslash",a[a.CloseSquareBracket=93]="CloseSquareBracket",a[a.Caret=94]="Caret",a[a.Underline=95]="Underline",a[a.BackTick=96]="BackTick",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.OpenCurlyBrace=123]="OpenCurlyBrace",a[a.Pipe=124]="Pipe",a[a.CloseCurlyBrace=125]="CloseCurlyBrace",a[a.Tilde=126]="Tilde",a[a.NoBreakSpace=160]="NoBreakSpace",a[a.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",a[a.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",a[a.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",a[a.U_Combining_Tilde=771]="U_Combining_Tilde",a[a.U_Combining_Macron=772]="U_Combining_Macron",a[a.U_Combining_Overline=773]="U_Combining_Overline",a[a.U_Combining_Breve=774]="U_Combining_Breve",a[a.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",a[a.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",a[a.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",a[a.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",a[a.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",a[a.U_Combining_Caron=780]="U_Combining_Caron",a[a.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",a[a.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",a[a.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",a[a.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",a[a.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",a[a.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",a[a.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",a[a.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",a[a.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",a[a.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",a[a.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",a[a.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",a[a.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",a[a.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",a[a.U_Combining_Horn=795]="U_Combining_Horn",a[a.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",a[a.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",a[a.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",a[a.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",a[a.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",a[a.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",a[a.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",a[a.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",a[a.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",a[a.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",a[a.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",a[a.U_Combining_Cedilla=807]="U_Combining_Cedilla",a[a.U_Combining_Ogonek=808]="U_Combining_Ogonek",a[a.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",a[a.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",a[a.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",a[a.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",a[a.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",a[a.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",a[a.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",a[a.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",a[a.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",a[a.U_Combining_Low_Line=818]="U_Combining_Low_Line",a[a.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",a[a.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",a[a.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",a[a.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",a[a.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",a[a.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",a[a.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",a[a.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",a[a.U_Combining_Square_Below=827]="U_Combining_Square_Below",a[a.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",a[a.U_Combining_X_Above=829]="U_Combining_X_Above",a[a.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",a[a.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",a[a.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",a[a.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",a[a.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",a[a.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",a[a.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",a[a.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",a[a.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",a[a.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",a[a.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",a[a.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",a[a.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",a[a.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",a[a.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",a[a.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",a[a.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",a[a.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",a[a.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",a[a.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",a[a.U_Combining_Fermata=850]="U_Combining_Fermata",a[a.U_Combining_X_Below=851]="U_Combining_X_Below",a[a.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",a[a.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",a[a.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",a[a.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",a[a.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",a[a.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",a[a.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",a[a.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",a[a.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",a[a.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",a[a.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",a[a.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",a[a.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",a[a.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",a[a.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",a[a.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",a[a.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",a[a.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",a[a.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",a[a.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",a[a.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",a[a.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",a[a.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",a[a.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",a[a.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",a[a.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",a[a.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",a[a.LINE_SEPARATOR=8232]="LINE_SEPARATOR",a[a.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",a[a.NEXT_LINE=133]="NEXT_LINE",a[a.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",a[a.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",a[a.U_DIAERESIS=168]="U_DIAERESIS",a[a.U_MACRON=175]="U_MACRON",a[a.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",a[a.U_CEDILLA=184]="U_CEDILLA",a[a.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",a[a.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",a[a.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",a[a.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",a[a.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",a[a.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",a[a.U_BREVE=728]="U_BREVE",a[a.U_DOT_ABOVE=729]="U_DOT_ABOVE",a[a.U_RING_ABOVE=730]="U_RING_ABOVE",a[a.U_OGONEK=731]="U_OGONEK",a[a.U_SMALL_TILDE=732]="U_SMALL_TILDE",a[a.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",a[a.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",a[a.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",a[a.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",a[a.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",a[a.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",a[a.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",a[a.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",a[a.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",a[a.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",a[a.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",a[a.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",a[a.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",a[a.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",a[a.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",a[a.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",a[a.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",a[a.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",a[a.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",a[a.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",a[a.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",a[a.U_GREEK_TONOS=900]="U_GREEK_TONOS",a[a.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",a[a.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",a[a.U_GREEK_PSILI=8127]="U_GREEK_PSILI",a[a.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",a[a.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",a[a.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",a[a.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",a[a.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",a[a.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",a[a.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",a[a.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",a[a.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",a[a.U_GREEK_VARIA=8175]="U_GREEK_VARIA",a[a.U_GREEK_OXIA=8189]="U_GREEK_OXIA",a[a.U_GREEK_DASIA=8190]="U_GREEK_DASIA",a[a.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",a[a.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",a[a.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",a[a.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",a[a.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",a[a.U_OVERLINE=8254]="U_OVERLINE",a[a.UTF8_BOM=65279]="UTF8_BOM",a[a.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",a[a.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(P||(e.CharCode=P={}))}),define(le[131],he([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=a,e.$L=N,e.$M=O,e.$N=T;function a(L,p){const S=Object.create(null);for(const d of L){const h=p(d);let $=S[h];$||($=S[h]=[]),$.push(d)}return S}function N(L,p){const S=[],d=[];for(const h of L)p.has(h)||S.push(h);for(const h of p)L.has(h)||d.push(h);return{removed:S,added:d}}function O(L,p){const S=[],d=[];for(const[h,$]of L)p.has(h)||S.push($);for(const[h,$]of p)L.has(h)||d.push($);return{removed:S,added:d}}function T(L,p){const S=new Set;for(const d of p)L.has(d)&&S.add(d);return S}class A{static{P=Symbol.toStringTag}constructor(p,S){this.b=S,this.a=new Map,this[P]="SetWithKey";for(const d of p)this.add(d)}get size(){return this.a.size}add(p){const S=this.b(p);return this.a.set(S,p),this}delete(p){return this.a.delete(this.b(p))}has(p){return this.a.has(this.b(p))}*entries(){for(const p of this.a.values())yield[p,p]}keys(){return this.values()}*values(){for(const p of this.a.values())yield p}clear(){this.a.clear()}forEach(p,S){this.a.forEach(d=>p.call(S,d,d,this))}[Symbol.iterator](){return this.values()}}e.$O=A}),define(le[88],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=a,e.$$h=N,e.$_h=O;function P(T){return(A,L,p)=>{let S=null,d=null;if(typeof p.value=="function"?(S="value",d=p.value):typeof p.get=="function"&&(S="get",d=p.get),!d)throw new Error("not supported");p[S]=T(d,L)}}function a(T,A,L){let p=null,S=null;if(typeof L.value=="function"?(p="value",S=L.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof L.get=="function"&&(p="get",S=L.get),!S)throw new Error("not supported");const d=`$memoize$${A}`;L[p]=function(...h){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,h)}),this[d]}}function N(T,A,L){return P((p,S)=>{const d=`$debounce$${S}`,h=`$debounce$result$${S}`;return function(...$){this[h]||(this[h]=L?L():void 0),clearTimeout(this[d]),A&&(this[h]=A(this[h],...$),$=[this[h]]),this[d]=setTimeout(()=>{p.apply(this,$),this[h]=L?L():void 0},T)}})}function O(T,A,L){return P((p,S)=>{const d=`$throttle$timer$${S}`,h=`$throttle$result$${S}`,$=`$throttle$lastRun$${S}`,c=`$throttle$pending$${S}`;return function(...m){if(this[h]||(this[h]=L?L():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),A&&(this[h]=A(this[h],...m)),this[c])return;const b=this[$]+T;b<=Date.now()?(this[$]=Date.now(),p.apply(this,[this[h]]),this[h]=L?L():void 0):(this[c]=!0,this[d]=setTimeout(()=>{this[c]=!1,this[$]=Date.now(),p.apply(this,[this[h]]),this[h]=L?L():void 0},b-Date.now()))}})}}),define(le[8],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=a,e.$2=N,e.$3=O,e.$4=T,e.$5=A,e.$6=p,e.$8=d,e.$9=h,e.$0=$,e.$_=m;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?I.isErrorNoTelemetry(t)?new I(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$Y=P,e.$Z=new P;function a(u){e.$Z.setUnexpectedErrorHandler(u)}function N(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function O(u){p(u)||e.$Z.onUnexpectedError(u)}function T(u){p(u)||e.$Z.onUnexpectedExternalError(u)}function A(u){if(u instanceof Error){const{name:t,message:s}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:s,stack:r,noTelemetry:I.isErrorNoTelemetry(u)}}return u}const L="Canceled";function p(u){return u instanceof S?!0:u instanceof Error&&u.name===L&&u.message===L}class S extends Error{constructor(){super(L),this.name=this.message}}e.$7=S;function d(){const u=new Error(L);return u.name=u.message,u}function h(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}function $(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=c;function m(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}class b extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$ab=b;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$bb=f;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=w;class I extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof I)return t;const s=new I;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$db=I;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$eb=g}),define(le[19],he([0,1,8,130]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=N,e.$vb=O,e.$wb=T,e.$xb=A,e.$yb=L,e.$zb=p,e.$Ab=S,e.$Bb=d,e.$Cb=h,e.$Db=$,e.$Eb=c,e.$Fb=m,e.$Gb=b,e.top=f,e.$Ib=w,e.$Jb=g,e.$Kb=u,e.$Lb=t,e.$Mb=s,e.$Nb=r,e.$Ob=i,e.$Pb=n,e.$Qb=o,e.$Rb=l,e.$Sb=y,e.$Tb=R,e.$Ub=k,e.$Vb=E,e.$Wb=v,e.$Xb=C,e.$Yb=U,e.$Zb=F,e.$1b=M,e.$2b=X,e.$3b=K,e.$4b=Q,e.$5b=G,e.$6b=ie,e.$7b=V,e.$8b=re,e.$9b=ce,e.$_b=J;function N(j,W=0){return j[j.length-(1+W)]}function O(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}function T(j,W,te=(_,Y)=>_===Y){if(j===W)return!0;if(!j||!W||j.length!==W.length)return!1;for(let _=0,Y=j.length;_<Y;_++)if(!te(j[_],W[_]))return!1;return!0}function A(j,W){const te=j.length-1;W<te&&(j[W]=j[te]),j.pop()}function L(j,W,te){return p(j.length,_=>te(j[_],W))}function p(j,W){let te=0,_=j-1;for(;te<=_;){const Y=(te+_)/2|0,ae=W(Y);if(ae<0)te=Y+1;else if(ae>0)_=Y-1;else return Y}return-(te+1)}function S(j,W,te){if(j=j|0,j>=W.length)throw new TypeError("invalid index");const _=W[Math.floor(W.length*Math.random())],Y=[],ae=[],ue=[];for(const ge of W){const we=te(ge,_);we<0?Y.push(ge):we>0?ae.push(ge):ue.push(ge)}return j<Y.length?S(j,Y,te):j<Y.length+ue.length?ue[0]:S(j-(Y.length+ue.length),ae,te)}function d(j,W){const te=[];let _;for(const Y of j.slice(0).sort(W))!_||W(_[0],Y)!==0?(_=[Y],te.push(_)):_.push(Y);return te}function*h(j,W){let te,_;for(const Y of j)_!==void 0&&W(_,Y)?te.push(Y):(te&&(yield te),te=[Y]),_=Y;te&&(yield te)}function $(j,W){for(let te=0;te<=j.length;te++)W(te===0?void 0:j[te-1],te===j.length?void 0:j[te])}function c(j,W){for(let te=0;te<j.length;te++)W(te===0?void 0:j[te-1],j[te],te+1===j.length?void 0:j[te+1])}function m(j,W,te){const _=[];function Y(ge,we,Ee){if(we===0&&Ee.length===0)return;const pe=_[_.length-1];pe&&pe.start+pe.deleteCount===ge?(pe.deleteCount+=we,pe.toInsert.push(...Ee)):_.push({start:ge,deleteCount:we,toInsert:Ee})}let ae=0,ue=0;for(;;){if(ae===j.length){Y(ae,0,W.slice(ue));break}if(ue===W.length){Y(ae,j.length-ae,[]);break}const ge=j[ae],we=W[ue],Ee=te(ge,we);Ee===0?(ae+=1,ue+=1):Ee<0?(Y(ae,1,[]),ae+=1):Ee>0&&(Y(ae,0,[we]),ue+=1)}return _}function b(j,W,te){const _=m(j,W,te),Y=[],ae=[];for(const ue of _)Y.push(...j.slice(ue.start,ue.start+ue.deleteCount)),ae.push(...ue.toInsert);return{removed:Y,added:ae}}function f(j,W,te){if(te===0)return[];const _=j.slice(0,te).sort(W);return I(j,W,_,te,j.length),_}function w(j,W,te,_,Y){return te===0?Promise.resolve([]):new Promise((ae,ue)=>{(async()=>{const ge=j.length,we=j.slice(0,te).sort(W);for(let Ee=te,pe=Math.min(te+_,ge);Ee<ge;Ee=pe,pe=Math.min(pe+_,ge)){if(Ee>te&&await new Promise(be=>setTimeout(be)),Y&&Y.isCancellationRequested)throw new P.$7;I(j,W,we,Ee,pe)}return we})().then(ae,ue)})}function I(j,W,te,_,Y){for(const ae=te.length;_<Y;_++){const ue=j[_];if(W(ue,te[ae-1])<0){te.pop();const ge=(0,a.$mb)(te,we=>W(ue,we)<0);te.splice(ge,0,ue)}}}function g(j){return j.filter(W=>!!W)}function u(j){let W=0;for(let te=0;te<j.length;te++)j[te]&&(j[W]=j[te],W+=1);j.length=W}function t(j,W,te){j.splice(te,0,j.splice(W,1)[0])}function s(j){return!Array.isArray(j)||j.length===0}function r(j){return Array.isArray(j)&&j.length>0}function i(j,W=te=>te){const te=new Set;return j.filter(_=>{const Y=W(_);return te.has(Y)?!1:(te.add(Y),!0)})}function n(j){const W=new Set;return te=>{const _=j(te);return W.has(_)?!1:(W.add(_),!0)}}function o(j,W){return j.length>0?j[0]:W}function l(j,W){return j.length>0?j[j.length-1]:W}function y(j,W,te=(_,Y)=>_===Y){let _=0;for(let Y=0,ae=Math.min(j.length,W.length);Y<ae&&te(j[Y],W[Y]);Y++)_++;return _}function R(j,W){let te=typeof W=="number"?j:0;typeof W=="number"?te=j:(te=0,W=j);const _=[];if(te<=W)for(let Y=te;Y<W;Y++)_.push(Y);else for(let Y=te;Y>W;Y--)_.push(Y);return _}function k(j,W,te){return j.reduce((_,Y)=>(_[W(Y)]=te?te(Y):Y,_),Object.create(null))}function E(j,W){return j.push(W),()=>v(j,W)}function v(j,W){const te=j.indexOf(W);if(te>-1)return j.splice(te,1),W}function C(j,W,te){const _=j.slice(0,W),Y=j.slice(W);return _.concat(te,Y)}function U(j,W){let te;if(typeof W=="number"){let _=W;te=()=>{const Y=Math.sin(_++)*179426549;return Y-Math.floor(Y)}}else te=Math.random;for(let _=j.length-1;_>0;_-=1){const Y=Math.floor(te()*(_+1)),ae=j[_];j[_]=j[Y],j[Y]=ae}}function F(j,W){const te=j.indexOf(W);te>-1&&(j.splice(te,1),j.unshift(W))}function M(j,W){const te=j.indexOf(W);te>-1&&(j.splice(te,1),j.push(W))}function X(j,W){for(const te of W)j.push(te)}function K(j,W){return Array.isArray(j)?j.map(W):W(j)}function Q(j){return Array.isArray(j)?j:[j]}function G(j){return j[Math.floor(Math.random()*j.length)]}function ie(j,W,te){const _=z(j,W),Y=j.length,ae=te.length;j.length=Y+ae;for(let ue=Y-1;ue>=_;ue--)j[ue+ae]=j[ue];for(let ue=0;ue<ae;ue++)j[ue+_]=te[ue]}function V(j,W,te,_){const Y=z(j,W);let ae=j.splice(Y,te);return ae===void 0&&(ae=[]),ie(j,Y,_),ae}function z(j,W){return W<0?Math.max(W+j.length,0):Math.min(W,j.length)}var ee;(function(j){function W(ae){return ae<0}j.isLessThan=W;function te(ae){return ae<=0}j.isLessThanOrEqual=te;function _(ae){return ae>0}j.isGreaterThan=_;function Y(ae){return ae===0}j.isNeitherLessOrGreaterThan=Y,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function re(j,W){return(te,_)=>W(j(te),j(_))}function ce(...j){return(W,te)=>{for(const _ of j){const Y=_(W,te);if(!ee.isNeitherLessOrGreaterThan(Y))return Y}return ee.neitherLessOrGreaterThan}}const q=(j,W)=>j-W;e.$0b=q;const x=(j,W)=>(0,e.$0b)(j?1:0,W?1:0);e.$$b=x;function J(j){return(W,te)=>-j(W,te)}class H{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let te=this.c;for(;te<this.g.length&&W(this.g[te]);)te++;const _=te===this.c?null:this.g.slice(this.c,te);return this.c=te,_}takeFromEndWhile(W){let te=this.d;for(;te>=0&&W(this.g[te]);)te--;const _=te===this.d?null:this.g.slice(te+1,this.d+1);return this.d=te,_}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const te=this.g.slice(this.c,this.c+W);return this.c+=W,te}}e.$ac=H;class D{static{this.empty=new D(W=>{})}constructor(W){this.iterate=W}forEach(W){this.iterate(te=>(W(te),!0))}toArray(){const W=[];return this.iterate(te=>(W.push(te),!0)),W}filter(W){return new D(te=>this.iterate(_=>W(_)?te(_):!0))}map(W){return new D(te=>this.iterate(_=>te(W(_))))}some(W){let te=!1;return this.iterate(_=>(te=W(_),!te)),te}findFirst(W){let te;return this.iterate(_=>W(_)?(te=_,!1):!0),te}findLast(W){let te;return this.iterate(_=>(W(_)&&(te=_),!0)),te}findLastMaxBy(W){let te,_=!0;return this.iterate(Y=>((_||ee.isGreaterThan(W(Y,te)))&&(_=!1,te=Y),!0)),te}}e.$bc=D;class B{constructor(W){this.c=W}static createSortPermutation(W,te){const _=Array.from(W.keys()).sort((Y,ae)=>te(W[Y],W[ae]));return new B(_)}apply(W){return W.map((te,_)=>W[this.c[_]])}inverse(){const W=this.c.slice();for(let te=0;te<this.c.length;te++)W[this.c[te]]=te;return new B(W)}}e.$cc=B}),define(le[132],he([0,1,8]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=a,e.$gd=N,e.$hd=O,e.$id=T,e.$jd=A,e.$kd=L;function a(p,S){if(!p)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}function N(p,S="Unreachable"){throw new Error(S)}function O(p,S="unexpected state"){if(!p)throw new P.$eb(`Assertion Failed: ${S}`)}function T(p){p||(0,P.$3)(new P.$eb("Soft Assertion Failed"))}function A(p){if(!p()){debugger;p(),(0,P.$3)(new P.$eb("Assertion Failed"))}}function L(p,S){let d=0;for(;d<p.length-1;){const h=p[d],$=p[d+1];if(!S(h,$))return!1;d++}return!0}}),define(le[89],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=P;function P(a,N){const O=this;let T=!1,A;return function(){if(T)return A;if(T=!0,N)try{A=a.apply(O,arguments)}finally{N()}else A=a.apply(O,arguments);return A}}}),define(le[63],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(a){function N(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}a.is=N;const O=Object.freeze([]);function T(){return O}a.empty=T;function*A(s){yield s}a.single=A;function L(s){return N(s)?s:A(s)}a.wrap=L;function p(s){return s||O}a.from=p;function*S(s){for(let r=s.length-1;r>=0;r--)yield s[r]}a.reverse=S;function d(s){return!s||s[Symbol.iterator]().next().done===!0}a.isEmpty=d;function h(s){return s[Symbol.iterator]().next().value}a.first=h;function $(s,r){let i=0;for(const n of s)if(r(n,i++))return!0;return!1}a.some=$;function c(s,r){for(const i of s)if(r(i))return i}a.find=c;function*m(s,r){for(const i of s)r(i)&&(yield i)}a.filter=m;function*b(s,r){let i=0;for(const n of s)yield r(n,i++)}a.map=b;function*f(s,r){let i=0;for(const n of s)yield*r(n,i++)}a.flatMap=f;function*w(...s){for(const r of s)yield*r}a.concat=w;function I(s,r,i){let n=i;for(const o of s)n=r(n,o);return n}a.reduce=I;function*g(s,r,i=s.length){for(r<0&&(r+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);r<i;r++)yield s[r]}a.slice=g;function u(s,r=Number.POSITIVE_INFINITY){const i=[];if(r===0)return[i,s];const n=s[Symbol.iterator]();for(let o=0;o<r;o++){const l=n.next();if(l.done)return[i,a.empty()];i.push(l.value)}return[i,{[Symbol.iterator](){return n}}]}a.consume=u;async function t(s){const r=[];for await(const i of s)r.push(i);return Promise.resolve(r)}a.asyncToArray=t})(P||(e.Iterable=P={}))}),define(le[34],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=T,e.$Un=d,e.$Vn=h,e.$Wn=$,e.$Xn=c,e.$Yn=m,e.$Zn=b,e.$1n=f,e.$2n=w,e.$3n=I,e.$4n=g,e.$5n=u;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var a;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(a||(e.SyntaxKind=a={}));var N;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(N||(e.ParseErrorCode=N={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(t,s=!1){let r=0;const i=t.length;let n="",o=0,l=a.Unknown,y=P.None;function R(M){let X=0,K=0;for(;X<M;){const Q=t.charCodeAt(r);if(Q>=S._0&&Q<=S._9)K=K*16+Q-S._0;else if(Q>=S.A&&Q<=S.F)K=K*16+Q-S.A+10;else if(Q>=S.a&&Q<=S.f)K=K*16+Q-S.a+10;else break;r++,X++}return X<M&&(K=-1),K}function k(M){r=M,n="",o=0,l=a.Unknown,y=P.None}function E(){const M=r;if(t.charCodeAt(r)===S._0)r++;else for(r++;r<t.length&&p(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===S.dot)if(r++,r<t.length&&p(t.charCodeAt(r)))for(r++;r<t.length&&p(t.charCodeAt(r));)r++;else return y=P.UnexpectedEndOfNumber,t.substring(M,r);let X=r;if(r<t.length&&(t.charCodeAt(r)===S.E||t.charCodeAt(r)===S.e))if(r++,(r<t.length&&t.charCodeAt(r)===S.plus||t.charCodeAt(r)===S.minus)&&r++,r<t.length&&p(t.charCodeAt(r))){for(r++;r<t.length&&p(t.charCodeAt(r));)r++;X=r}else y=P.UnexpectedEndOfNumber;return t.substring(M,X)}function v(){let M="",X=r;for(;;){if(r>=i){M+=t.substring(X,r),y=P.UnexpectedEndOfString;break}const K=t.charCodeAt(r);if(K===S.doubleQuote){M+=t.substring(X,r),r++;break}if(K===S.backslash){if(M+=t.substring(X,r),r++,r>=i){y=P.UnexpectedEndOfString;break}switch(t.charCodeAt(r++)){case S.doubleQuote:M+='"';break;case S.backslash:M+="\\";break;case S.slash:M+="/";break;case S.b:M+="\b";break;case S.f:M+="\f";break;case S.n:M+=`
`;break;case S.r:M+="\r";break;case S.t:M+="	";break;case S.u:{const G=R(4);G>=0?M+=String.fromCharCode(G):y=P.InvalidUnicode;break}default:y=P.InvalidEscapeCharacter}X=r;continue}if(K>=0&&K<=31)if(L(K)){M+=t.substring(X,r),y=P.UnexpectedEndOfString;break}else y=P.InvalidCharacter;r++}return M}function C(){if(n="",y=P.None,o=r,r>=i)return o=i,l=a.EOF;let M=t.charCodeAt(r);if(A(M)){do r++,n+=String.fromCharCode(M),M=t.charCodeAt(r);while(A(M));return l=a.Trivia}if(L(M))return r++,n+=String.fromCharCode(M),M===S.carriageReturn&&t.charCodeAt(r)===S.lineFeed&&(r++,n+=`
`),l=a.LineBreakTrivia;switch(M){case S.openBrace:return r++,l=a.OpenBraceToken;case S.closeBrace:return r++,l=a.CloseBraceToken;case S.openBracket:return r++,l=a.OpenBracketToken;case S.closeBracket:return r++,l=a.CloseBracketToken;case S.colon:return r++,l=a.ColonToken;case S.comma:return r++,l=a.CommaToken;case S.doubleQuote:return r++,n=v(),l=a.StringLiteral;case S.slash:{const X=r-1;if(t.charCodeAt(r+1)===S.slash){for(r+=2;r<i&&!L(t.charCodeAt(r));)r++;return n=t.substring(X,r),l=a.LineCommentTrivia}if(t.charCodeAt(r+1)===S.asterisk){r+=2;const K=i-1;let Q=!1;for(;r<K;){if(t.charCodeAt(r)===S.asterisk&&t.charCodeAt(r+1)===S.slash){r+=2,Q=!0;break}r++}return Q||(r++,y=P.UnexpectedEndOfComment),n=t.substring(X,r),l=a.BlockCommentTrivia}return n+=String.fromCharCode(M),r++,l=a.Unknown}case S.minus:if(n+=String.fromCharCode(M),r++,r===i||!p(t.charCodeAt(r)))return l=a.Unknown;case S._0:case S._1:case S._2:case S._3:case S._4:case S._5:case S._6:case S._7:case S._8:case S._9:return n+=E(),l=a.NumericLiteral;default:for(;r<i&&U(M);)r++,M=t.charCodeAt(r);if(o!==r){switch(n=t.substring(o,r),n){case"true":return l=a.TrueKeyword;case"false":return l=a.FalseKeyword;case"null":return l=a.NullKeyword}return l=a.Unknown}return n+=String.fromCharCode(M),r++,l=a.Unknown}}function U(M){if(A(M)||L(M))return!1;switch(M){case S.closeBrace:case S.closeBracket:case S.openBrace:case S.openBracket:case S.doubleQuote:case S.colon:case S.comma:case S.slash:return!1}return!0}function F(){let M;do M=C();while(M>=a.LineCommentTrivia&&M<=a.Trivia);return M}return{setPosition:k,getPosition:()=>r,scan:s?F:C,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>y}}function A(t){return t===S.space||t===S.tab||t===S.verticalTab||t===S.formFeed||t===S.nonBreakingSpace||t===S.ogham||t>=S.enQuad&&t<=S.zeroWidthSpace||t===S.narrowNoBreakSpace||t===S.mathematicalSpace||t===S.ideographicSpace||t===S.byteOrderMark}function L(t){return t===S.lineFeed||t===S.carriageReturn||t===S.lineSeparator||t===S.paragraphSeparator}function p(t){return t>=S._0&&t<=S._9}var S;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(S||(S={}));function d(t,s){const r=[],i=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function y(R,k,E,v){o.value=R,o.offset=k,o.length=E,o.type=v,o.colonOffset=void 0,n=o}try{I(t,{onObjectBegin:(R,k)=>{if(s<=R)throw i;n=void 0,l=s>R,r.push("")},onObjectProperty:(R,k,E)=>{if(s<k||(y(R,k,E,"property"),r[r.length-1]=R,s<=k+E))throw i},onObjectEnd:(R,k)=>{if(s<=R)throw i;n=void 0,r.pop()},onArrayBegin:(R,k)=>{if(s<=R)throw i;n=void 0,r.push(0)},onArrayEnd:(R,k)=>{if(s<=R)throw i;n=void 0,r.pop()},onLiteralValue:(R,k,E)=>{if(s<k||(y(R,k,E,u(R)),s<=k+E))throw i},onSeparator:(R,k,E)=>{if(s<=k)throw i;if(R===":"&&n&&n.type==="property")n.colonOffset=k,l=!1,n=void 0;else if(R===","){const v=r[r.length-1];typeof v=="number"?r[r.length-1]=v+1:(l=!0,r[r.length-1]=""),n=void 0}}})}catch(R){if(R!==i)throw R}return{path:r,previousNode:n,isAtPropertyKey:l,matches:R=>{let k=0;for(let E=0;k<R.length&&E<r.length;E++)if(R[k]===r[E]||R[k]==="*")k++;else if(R[k]!=="**")return!1;return k===R.length}}}function h(t,s=[],r=O.DEFAULT){let i=null,n=[];const o=[];function l(R){Array.isArray(n)?n.push(R):i!==null&&(n[i]=R)}return I(t,{onObjectBegin:()=>{const R={};l(R),o.push(n),n=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const R=[];l(R),o.push(n),n=R,i=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(R,k,E)=>{s.push({error:R,offset:k,length:E})}},r),n[0]}function $(t,s=[],r=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(R){i.type==="property"&&(i.length=R-i.offset,i=i.parent)}function o(R){return i.children.push(R),R}I(t,{onObjectBegin:R=>{i=o({type:"object",offset:R,length:-1,parent:i,children:[]})},onObjectProperty:(R,k,E)=>{i=o({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:R,offset:k,length:E,parent:i})},onObjectEnd:(R,k)=>{i.length=R+k-i.offset,i=i.parent,n(R+k)},onArrayBegin:(R,k)=>{i=o({type:"array",offset:R,length:-1,parent:i,children:[]})},onArrayEnd:(R,k)=>{i.length=R+k-i.offset,i=i.parent,n(R+k)},onLiteralValue:(R,k,E)=>{o({type:u(R),offset:k,length:E,parent:i,value:R}),n(k+E)},onSeparator:(R,k,E)=>{i.type==="property"&&(R===":"?i.colonOffset=k:R===","&&n(k))},onError:(R,k,E)=>{s.push({error:R,offset:k,length:E})}},r);const y=i.children[0];return y&&delete y.parent,y}function c(t,s){if(!t)return;let r=t;for(const i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}function b(t){switch(t.type){case"array":return t.children.map(b);case"object":{const s=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=b(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}function w(t,s,r=!1){if(f(t,s,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const o=w(i[n],s,r);if(o)return o}return t}}function I(t,s,r=O.DEFAULT){const i=T(t,!1);function n(ce){return ce?()=>ce(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(ce){return ce?q=>ce(q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(s.onObjectBegin),y=o(s.onObjectProperty),R=n(s.onObjectEnd),k=n(s.onArrayBegin),E=n(s.onArrayEnd),v=o(s.onLiteralValue),C=o(s.onSeparator),U=n(s.onComment),F=o(s.onError),M=r&&r.disallowComments,X=r&&r.allowTrailingComma;function K(){for(;;){const ce=i.scan();switch(i.getTokenError()){case P.InvalidUnicode:Q(N.InvalidUnicode);break;case P.InvalidEscapeCharacter:Q(N.InvalidEscapeCharacter);break;case P.UnexpectedEndOfNumber:Q(N.UnexpectedEndOfNumber);break;case P.UnexpectedEndOfComment:M||Q(N.UnexpectedEndOfComment);break;case P.UnexpectedEndOfString:Q(N.UnexpectedEndOfString);break;case P.InvalidCharacter:Q(N.InvalidCharacter);break}switch(ce){case a.LineCommentTrivia:case a.BlockCommentTrivia:M?Q(N.InvalidCommentToken):U();break;case a.Unknown:Q(N.InvalidSymbol);break;case a.Trivia:case a.LineBreakTrivia:break;default:return ce}}}function Q(ce,q=[],x=[]){if(F(ce),q.length+x.length>0){let J=i.getToken();for(;J!==a.EOF;){if(q.indexOf(J)!==-1){K();break}else if(x.indexOf(J)!==-1)break;J=K()}}}function G(ce){const q=i.getTokenValue();return ce?v(q):y(q),K(),!0}function ie(){switch(i.getToken()){case a.NumericLiteral:{let ce=0;try{ce=JSON.parse(i.getTokenValue()),typeof ce!="number"&&(Q(N.InvalidNumberFormat),ce=0)}catch{Q(N.InvalidNumberFormat)}v(ce);break}case a.NullKeyword:v(null);break;case a.TrueKeyword:v(!0);break;case a.FalseKeyword:v(!1);break;default:return!1}return K(),!0}function V(){return i.getToken()!==a.StringLiteral?(Q(N.PropertyNameExpected,[],[a.CloseBraceToken,a.CommaToken]),!1):(G(!1),i.getToken()===a.ColonToken?(C(":"),K(),re()||Q(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken])):Q(N.ColonExpected,[],[a.CloseBraceToken,a.CommaToken]),!0)}function z(){l(),K();let ce=!1;for(;i.getToken()!==a.CloseBraceToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||Q(N.ValueExpected,[],[]),C(","),K(),i.getToken()===a.CloseBraceToken&&X)break}else ce&&Q(N.CommaExpected,[],[]);V()||Q(N.ValueExpected,[],[a.CloseBraceToken,a.CommaToken]),ce=!0}return R(),i.getToken()!==a.CloseBraceToken?Q(N.CloseBraceExpected,[a.CloseBraceToken],[]):K(),!0}function ee(){k(),K();let ce=!1;for(;i.getToken()!==a.CloseBracketToken&&i.getToken()!==a.EOF;){if(i.getToken()===a.CommaToken){if(ce||Q(N.ValueExpected,[],[]),C(","),K(),i.getToken()===a.CloseBracketToken&&X)break}else ce&&Q(N.CommaExpected,[],[]);re()||Q(N.ValueExpected,[],[a.CloseBracketToken,a.CommaToken]),ce=!0}return E(),i.getToken()!==a.CloseBracketToken?Q(N.CloseBracketExpected,[a.CloseBracketToken],[]):K(),!0}function re(){switch(i.getToken()){case a.OpenBracketToken:return ee();case a.OpenBraceToken:return z();case a.StringLiteral:return G(!0);default:return ie()}}return K(),i.getToken()===a.EOF?r.allowEmptyContent?!0:(Q(N.ValueExpected,[],[]),!1):re()?(i.getToken()!==a.EOF&&Q(N.EndOfFileExpected,[],[]),!0):(Q(N.ValueExpected,[],[]),!1)}function g(t,s){const r=T(t),i=[];let n,o=0,l;do switch(l=r.getPosition(),n=r.scan(),n){case a.LineCommentTrivia:case a.BlockCommentTrivia:case a.EOF:o!==l&&i.push(t.substring(o,l)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(n!==a.EOF);return i.join("")}function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(le[45],he([0,1,34]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6n=a,e.$7n=N,e.$8n=A,e.$9n=L;function a(p,S,d){let h,$,c,m,b;if(S){for(m=S.offset,b=m+S.length,c=m;c>0&&!L(p,c-1);)c--;let l=b;for(;l<p.length&&!L(p,l);)l++;$=p.substring(c,l),h=T($,d)}else $=p,h=0,c=0,m=0,b=p.length;const f=A(d,p);let w=!1,I=0,g;d.insertSpaces?g=O(" ",d.tabSize||4):g="	";const u=(0,P.$Tn)($,!1);let t=!1;function s(){return f+O(g,h+I)}function r(){let l=u.scan();for(w=!1;l===P.SyntaxKind.Trivia||l===P.SyntaxKind.LineBreakTrivia;)w=w||l===P.SyntaxKind.LineBreakTrivia,l=u.scan();return t=l===P.SyntaxKind.Unknown||u.getTokenError()!==P.ScanError.None,l}const i=[];function n(l,y,R){!t&&y<b&&R>m&&p.substring(y,R)!==l&&i.push({offset:y,length:R-y,content:l})}let o=r();if(o!==P.SyntaxKind.EOF){const l=u.getTokenOffset()+c,y=O(g,h);n(y,c,l)}for(;o!==P.SyntaxKind.EOF;){let l=u.getTokenOffset()+u.getTokenLength()+c,y=r(),R="";for(;!w&&(y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia);){const E=u.getTokenOffset()+c;n(" ",l,E),l=u.getTokenOffset()+u.getTokenLength()+c,R=y===P.SyntaxKind.LineCommentTrivia?s():"",y=r()}if(y===P.SyntaxKind.CloseBraceToken)o!==P.SyntaxKind.OpenBraceToken&&(I--,R=s());else if(y===P.SyntaxKind.CloseBracketToken)o!==P.SyntaxKind.OpenBracketToken&&(I--,R=s());else{switch(o){case P.SyntaxKind.OpenBracketToken:case P.SyntaxKind.OpenBraceToken:I++,R=s();break;case P.SyntaxKind.CommaToken:case P.SyntaxKind.LineCommentTrivia:R=s();break;case P.SyntaxKind.BlockCommentTrivia:w?R=s():R=" ";break;case P.SyntaxKind.ColonToken:R=" ";break;case P.SyntaxKind.StringLiteral:if(y===P.SyntaxKind.ColonToken){R="";break}case P.SyntaxKind.NullKeyword:case P.SyntaxKind.TrueKeyword:case P.SyntaxKind.FalseKeyword:case P.SyntaxKind.NumericLiteral:case P.SyntaxKind.CloseBraceToken:case P.SyntaxKind.CloseBracketToken:y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia?R=" ":y!==P.SyntaxKind.CommaToken&&y!==P.SyntaxKind.EOF&&(t=!0);break;case P.SyntaxKind.Unknown:t=!0;break}w&&(y===P.SyntaxKind.LineCommentTrivia||y===P.SyntaxKind.BlockCommentTrivia)&&(R=s())}const k=u.getTokenOffset()+c;n(R,l,k),o=y}return i}function N(p,S){const d=JSON.stringify(p,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?d.replace(/\r\n|\r|\n/g,S.eol):d}function O(p,S){let d="";for(let h=0;h<S;h++)d+=p;return d}function T(p,S){let d=0,h=0;const $=S.tabSize||4;for(;d<p.length;){const c=p.charAt(d);if(c===" ")h++;else if(c==="	")h+=$;else break;d++}return Math.floor(h/$)}function A(p,S){for(let d=0;d<S.length;d++){const h=S.charAt(d);if(h==="\r")return d+1<S.length&&S.charAt(d+1)===`
`?`\r
`:"\r";if(h===`
`)return`
`}return p&&p.eol||`
`}function L(p,S){return`\r
`.indexOf(p.charAt(S))!==-1}}),define(le[64],he([0,1,34,45]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=N,e.$$n=O,e.$_n=T,e.$ao=A,e.$bo=L;function N(p,S,d){return O(p,S,void 0,d)}function O(p,S,d,h,$){const c=S.slice(),m=[],b=(0,P.$Wn)(p,m);let f,w;for(;c.length>0&&(w=c.pop(),f=(0,P.$Xn)(b,c),f===void 0&&d!==void 0);)typeof w=="string"?d={[w]:d}:d=[d];if(f)if(f.type==="object"&&typeof w=="string"&&Array.isArray(f.children)){const I=(0,P.$Xn)(f,[w]);if(I!==void 0)if(d===void 0){if(!I.parent)throw new Error("Malformed AST");const g=f.children.indexOf(I.parent);let u,t=I.parent.offset+I.parent.length;if(g>0){const s=f.children[g-1];u=s.offset+s.length}else u=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return T(p,{offset:u,length:t-u,content:""},h)}else return T(p,{offset:I.offset,length:I.length,content:JSON.stringify(d)},h);else{if(d===void 0)return[];const g=`${JSON.stringify(w)}: ${JSON.stringify(d)}`,u=$?$(f.children.map(s=>s.children[0].value)):f.children.length;let t;if(u>0){const s=f.children[u-1];t={offset:s.offset+s.length,length:0,content:","+g}}else f.children.length===0?t={offset:f.offset+1,length:0,content:g}:t={offset:f.offset+1,length:0,content:g+","};return T(p,t,h)}}else if(f.type==="array"&&typeof w=="number"&&Array.isArray(f.children))if(d!==void 0){const I=`${JSON.stringify(d)}`;let g;if(f.children.length===0||w===0)g={offset:f.offset+1,length:0,content:f.children.length===0?I:I+","};else{const u=w===-1||w>f.children.length?f.children.length:w,t=f.children[u-1];g={offset:t.offset+t.length,length:0,content:","+I}}return T(p,g,h)}else{const I=w,g=f.children[I];let u;if(f.children.length===1)u={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===I){const t=f.children[I-1],s=t.offset+t.length,r=f.offset+f.length;u={offset:s,length:r-2-s,content:""}}else u={offset:g.offset,length:f.children[I+1].offset-g.offset,content:""};return T(p,u,h)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${f.type}`);else return d===void 0?[]:T(p,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(d)},h)}function T(p,S,d){let h=A(p,S),$=S.offset,c=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;$>0&&!(0,a.$9n)(h,$-1);)$--;for(;c<h.length&&!(0,a.$9n)(h,c);)c++}const m=(0,a.$6n)(h,{offset:$,length:c-$},d);for(let f=m.length-1;f>=0;f--){const w=m[f];h=A(h,w),$=Math.min($,w.offset),c=Math.max(c,w.offset+w.length),c+=w.content.length-w.length}const b=p.length-(h.length-c)-$;return[{offset:$,length:b,content:h.substring($,c)}]}function A(p,S){return p.substring(0,S.offset)+S.content+p.substring(S.offset+S.length)}function L(p,S){const d=S.slice(0).sort(($,c)=>{const m=$.offset-c.offset;return m===0?$.length-c.length:m});let h=p.length;for(let $=d.length-1;$>=0;$--){const c=d[$];if(c.offset+c.length<=h)p=A(p,c);else throw new Error("Overlapping edit");h=c.offset}return p}}),define(le[54],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class P{constructor(N){this.d=N,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(N){this.c=N}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=P}),define(le[90],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(O){this.element=O,this.next=P.Undefined,this.prev=P.Undefined}}class a{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let O=this.a;for(;O!==P.Undefined;){const T=O.next;O.prev=P.Undefined,O.next=P.Undefined,O=T}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const A=new P(O);if(this.a===P.Undefined)this.a=A,this.b=A;else if(T){const p=this.b;this.b=A,A.prev=p,p.next=A}else{const p=this.a;this.a=A,A.next=p,p.prev=A}this.c+=1;let L=!1;return()=>{L||(L=!0,this.e(A))}}shift(){if(this.a!==P.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==P.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==P.Undefined&&O.next!==P.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===P.Undefined&&O.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):O.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):O.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==P.Undefined;)yield O.element,O=O.next}}e.$7c=a}),define(le[35],he([0,1]),function(ne,e){"use strict";var P,a,N;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=O,e.$Ac=T,e.$Bc=A,e.$Kc=g;function O(u,t,s){let r=u.get(t);return r===void 0&&(r=s,u.set(t,r)),r}function T(u){const t=[];return u.forEach((s,r)=>{t.push(`${r} => ${s}`)}),`Map(${u.size}) {${t.join(", ")}}`}function A(u){const t=[];return u.forEach(s=>{t.push(s)}),`Set(${u.size}) {${t.join(", ")}}`}class L{constructor(t,s){this.uri=t,this.value=s}}function p(u){return Array.isArray(u)}class S{static{this.c=t=>t.toString()}constructor(t,s){if(this[P]="ResourceMap",t instanceof S)this.d=new Map(t.d),this.e=s??S.c;else if(p(t)){this.d=new Map,this.e=s??S.c;for(const[r,i]of t)this.set(r,i)}else this.d=new Map,this.e=t??S.c}set(t,s){return this.d.set(this.e(t),new L(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[r,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Cc=S;class d{constructor(t,s){this[a]="ResourceSet",!t||typeof t=="function"?this.c=new S(t):(this.c=new S(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((r,i)=>t.call(s,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(a=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=d;var h;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(h||(e.Touch=h={}));class ${constructor(){this[N]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=h.None){const r=this.c.get(t);if(r)return s!==h.None&&this.m(r,s),r.value}set(t,s,r=h.None){let i=this.c.get(t);if(i)i.value=s,r!==h.None&&this.m(i,r);else{switch(i={key:t,value:s,next:void 0,previous:void 0},r){case h.None:this.k(i);break;case h.AsOld:this.j(i);break;case h.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const r=this.g;let i=this.d;for(;i;){if(s?t.bind(s)(i.value,i.key,this):t(i.value,i.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.key,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.value,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:[r.key,r.value],done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.next,r--;this.d=s,this.f=r,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.previous,r--;this.e=s,this.f=r,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,r=t.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==h.AsOld&&s!==h.AsNew)){if(s===h.AsOld){if(t===this.d)return;const r=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(r.previous=i,i.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===h.AsNew){if(t===this.e)return;const r=t.next,i=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=i,i.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,r)=>{t.push([r,s])}),t}fromJSON(t){this.clear();for(const[s,r]of t)this.set(s,r)}}e.$Ec=$;class c extends ${constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=h.AsNew){return super.get(t,s)}peek(t){return super.get(t,h.None)}set(t,s){return super.set(t,s,h.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends c{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Fc=m;class b extends c{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Gc=b;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Hc=f;class w{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,r]of t)this.set(s,r)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((r,i)=>{t.call(s,r,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=w;class I{constructor(){this.c=new Map}add(t,s){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(s)}delete(t,s){const r=this.c.get(t);r&&(r.delete(s),r.size===0&&this.c.delete(t))}forEach(t,s){const r=this.c.get(t);r&&r.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Jc=I;function g(u,t){if(u===t)return!0;if(u.size!==t.size)return!1;for(const[s,r]of u)if(!t.has(s)||t.get(s)!==r)return!1;for(const[s]of t)if(!u.has(s))return!1;return!0}}),define(le[2],he([0,1,19,131,35,89,63]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=S,e.$Nc=d,e.$Oc=h,e.$Pc=m,e.$Qc=b,e.$Rc=f,e.$Sc=w,e.$Tc=I,e.$Uc=g,e.$5c=R;const A=!1;let L=null;class p{constructor(){this.b=new Map}static{this.a=0}c(v){let C=this.b.get(v);return C||(C={parent:null,source:null,isSingleton:!1,value:v,idx:p.a++},this.b.set(v,C)),C}trackDisposable(v){const C=this.c(v);C.source||(C.source=new Error().stack)}setParent(v,C){const U=this.c(v);U.parent=C}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,C){const U=C.get(v);if(U)return U;const F=v.parent?this.f(this.c(v.parent),C):v;return C.set(v,F),F}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,v).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(v=10,C){let U;if(C)U=C;else{const Q=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,Q).isSingleton);if(G.length===0)return;const ie=new Set(G.map(V=>V.value));if(U=G.filter(V=>!(V.parent&&ie.has(V.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function F(Q){function G(V,z){for(;V.length>0&&z.some(ee=>typeof ee=="string"?ee===V[0]:V[0].match(ee));)V.shift()}const ie=Q.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(ie,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ie.reverse()}const M=new N.$Jc;for(const Q of U){const G=F(Q);for(let ie=0;ie<=G.length;ie++)M.add(G.slice(0,ie).join(`
`),Q)}U.sort((0,P.$8b)(Q=>Q.idx,P.$0b));let X="",K=0;for(const Q of U.slice(0,v)){K++;const G=F(Q),ie=[];for(let V=0;V<G.length;V++){let z=G[V];z=`(shared with ${M.get(G.slice(0,V+1).join(`
`)).size}/${U.length} leaks) at ${z}`;const re=M.get(G.slice(0,V).join(`
`)),ce=(0,a.$K)([...re].map(q=>F(q)[V]),q=>q);delete ce[G[V]];for(const[q,x]of Object.entries(ce))ie.unshift(`    - stacktraces of ${x.length} other leaks continue with ${q}`);ie.unshift(z)}X+=`


==================== Leaking disposable ${K}/${U.length}: ${Q.value.constructor.name} ====================
${ie.join(`
`)}
============================================================

`}return U.length>v&&(X+=`


... and ${U.length-v} more leaking disposables

`),{leaks:U,details:X}}}e.$Lc=p;function S(E){L=E}if(A){const E="__is_disposable_tracked__";S(new class{trackDisposable(v){const C=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[E]||console.log(C)},3e3)}setParent(v,C){if(v&&v!==t.None)try{v[E]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[E]=!0}catch{}}markAsSingleton(v){}})}function d(E){return L?.trackDisposable(E),E}function h(E){L?.markAsDisposed(E)}function $(E,v){L?.setParent(E,v)}function c(E,v){if(L)for(const C of E)L.setParent(C,v)}function m(E){return L?.markAsSingleton(E),E}function b(E){return typeof E=="object"&&E!==null&&typeof E.dispose=="function"&&E.dispose.length===0}function f(E){if(T.Iterable.is(E)){const v=[];for(const C of E)if(C)try{C.dispose()}catch(U){v.push(U)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}function w(E){for(const v of E)b(v)&&v.dispose();return[]}function I(...E){const v=g(()=>f(E));return c(E,v),v}function g(E){const v=d({dispose:(0,O.$fb)(()=>{h(v),E()})});return v}class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,d(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return $(v,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),$(v,null))}}e.$Vc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,d(this),$(this.q,this)}dispose(){h(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Wc=t;class s{constructor(){this.b=!1,d(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&$(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&$(v,null),v}}e.$Xc=s;class r{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=r;class i{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,d(this)}set(v){let C=v;return this.unset=()=>C=void 0,this.isset=()=>C!==void 0,this.dispose=()=>{C&&(C(),C=void 0,h(this))},this}}e.$1c=n;class o{constructor(){this.a=new Map}acquire(v,...C){let U=this.a.get(v);U||(U={counter:0,object:this.b(v,...C)},this.a.set(v,U));const{object:F}=U,M=(0,O.$fb)(()=>{--U.counter===0&&(this.c(v,U.object),this.a.delete(v))});return U.counter++,{object:F,dispose:M}}}e.$2c=o;class l{constructor(v){this.a=v}async acquire(v,...C){const U=this.a.acquire(v,...C);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(F){throw U.dispose(),F}}}e.$3c=l;class y{constructor(v){this.object=v}dispose(){}}e.$4c=y;function R(E){const v=new u;try{E(v)}finally{v.dispose()}}class k{constructor(){this.a=new Map,this.b=!1,d(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,C,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(v)?.dispose(),this.a.set(v,C)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const C=this.a.get(v);return this.a.delete(v),C}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=k}),define(le[65],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var P;(function(a){a[a.Uri=1]="Uri",a[a.Regexp=2]="Regexp",a[a.ScmResource=3]="ScmResource",a[a.ScmResourceGroup=4]="ScmResourceGroup",a[a.ScmProvider=5]="ScmProvider",a[a.CommentController=6]="CommentController",a[a.CommentThread=7]="CommentThread",a[a.CommentThreadInstance=8]="CommentThreadInstance",a[a.CommentThreadReply=9]="CommentThreadReply",a[a.CommentNode=10]="CommentNode",a[a.CommentThreadNode=11]="CommentThreadNode",a[a.TimelineActionContext=12]="TimelineActionContext",a[a.NotebookCellActionContext=13]="NotebookCellActionContext",a[a.NotebookActionContext=14]="NotebookActionContext",a[a.TerminalContext=15]="TerminalContext",a[a.TestItemContext=16]="TestItemContext",a[a.Date=17]="Date",a[a.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(P||(e.MarshalledId=P={}))}),define(le[91],he([0,1,35]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=N,e.$nm=T;const a=new P.$Fc(1e4);function N(p){return L(p,"NFC",a)}const O=new P.$Fc(1e4);function T(p){return L(p,"NFD",O)}const A=/[^\u0000-\u0080]/;function L(p,S,d){if(!p)return p;const h=d.get(p);if(h)return h;let $;return A.test(p)?$=p.normalize(S):$=p,d.set(p,$),$}e.$om=function(){const p=/[\u0300-\u036f]/g;return function(S){return T(S).replace(p,"")}}()}),function(){function ne(N){const O=[];typeof N=="number"&&O.push("code/timeOrigin",N);function T(L){O.push(L,Date.now())}function A(){const L=[];for(let p=0;p<O.length;p+=2)L.push({name:O[p],startTime:O[p+1]});return L}return{mark:T,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(N){performance.mark(N)},getMarks(){let N=performance.timeOrigin;typeof N!="number"&&(N=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(N)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(N+T.startTime)});return O}};if(typeof process=="object"){const N=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(N)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function P(N){return N.MonacoPerformanceMarks||(N.MonacoPerformanceMarks=e()),N.MonacoPerformanceMarks}var a;typeof global=="object"?a=global:typeof self=="object"?a=self:a={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(a)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(a):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),a.perf=P(a))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var a in P)(typeof exports=="object"?exports:ne)[a]=P[a]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function P(a){if(e[a])return e[a].exports;var N=e[a]={i:a,l:!1,exports:{}};return ne[a].call(N.exports,N,N.exports,P),N.l=!0,N.exports}return P.m=ne,P.c=e,P.d=function(a,N,O){P.o(a,N)||Object.defineProperty(a,N,{enumerable:!0,get:O})},P.r=function(a){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(a,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(a,"__esModule",{value:!0})},P.t=function(a,N){if(1&N&&(a=P(a)),8&N||4&N&&typeof a=="object"&&a&&a.__esModule)return a;var O=Object.create(null);if(P.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:a}),2&N&&typeof a!="string")for(var T in a)P.d(O,T,function(A){return a[A]}.bind(null,T));return O},P.n=function(a){var N=a&&a.__esModule?function(){return a.default}:function(){return a};return P.d(N,"a",N),N},P.o=function(a,N){return Object.prototype.hasOwnProperty.call(a,N)},P.p="",P(P.s=0)}([function(ne,e,P){(function(a){var N;e=ne.exports=x,N=typeof a=="object"&&a.env&&a.env.NODE_DEBUG&&/\bsemver\b/i.test(a.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],L=e.src=[],p=0,S=p++;L[S]="0|[1-9]\\d*";var d=p++;L[d]="[0-9]+";var h=p++;L[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=p++;L[$]="("+L[S]+")\\.("+L[S]+")\\.("+L[S]+")";var c=p++;L[c]="("+L[d]+")\\.("+L[d]+")\\.("+L[d]+")";var m=p++;L[m]="(?:"+L[S]+"|"+L[h]+")";var b=p++;L[b]="(?:"+L[d]+"|"+L[h]+")";var f=p++;L[f]="(?:-("+L[m]+"(?:\\."+L[m]+")*))";var w=p++;L[w]="(?:-?("+L[b]+"(?:\\."+L[b]+")*))";var I=p++;L[I]="[0-9A-Za-z-]+";var g=p++;L[g]="(?:\\+("+L[I]+"(?:\\."+L[I]+")*))";var u=p++,t="v?"+L[$]+L[f]+"?"+L[g]+"?";L[u]="^"+t+"$";var s="[v=\\s]*"+L[c]+L[w]+"?"+L[g]+"?",r=p++;L[r]="^"+s+"$";var i=p++;L[i]="((?:<|>)?=?)";var n=p++;L[n]=L[d]+"|x|X|\\*";var o=p++;L[o]=L[S]+"|x|X|\\*";var l=p++;L[l]="[v=\\s]*("+L[o]+")(?:\\.("+L[o]+")(?:\\.("+L[o]+")(?:"+L[f]+")?"+L[g]+"?)?)?";var y=p++;L[y]="[v=\\s]*("+L[n]+")(?:\\.("+L[n]+")(?:\\.("+L[n]+")(?:"+L[w]+")?"+L[g]+"?)?)?";var R=p++;L[R]="^"+L[i]+"\\s*"+L[l]+"$";var k=p++;L[k]="^"+L[i]+"\\s*"+L[y]+"$";var E=p++;L[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=p++;L[v]="(?:~>?)";var C=p++;L[C]="(\\s*)"+L[v]+"\\s+",A[C]=new RegExp(L[C],"g");var U=p++;L[U]="^"+L[v]+L[l]+"$";var F=p++;L[F]="^"+L[v]+L[y]+"$";var M=p++;L[M]="(?:\\^)";var X=p++;L[X]="(\\s*)"+L[M]+"\\s+",A[X]=new RegExp(L[X],"g");var K=p++;L[K]="^"+L[M]+L[l]+"$";var Q=p++;L[Q]="^"+L[M]+L[y]+"$";var G=p++;L[G]="^"+L[i]+"\\s*("+s+")$|^$";var ie=p++;L[ie]="^"+L[i]+"\\s*("+t+")$|^$";var V=p++;L[V]="(\\s*)"+L[i]+"\\s*("+s+"|"+L[l]+")",A[V]=new RegExp(L[V],"g");var z=p++;L[z]="^\\s*("+L[l]+")\\s+-\\s+("+L[l]+")\\s*$";var ee=p++;L[ee]="^\\s*("+L[y]+")\\s+-\\s+("+L[y]+")\\s*$";var re=p++;L[re]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)N(ce,L[ce]),A[ce]||(A[ce]=new RegExp(L[ce]));function q(oe,de){if(oe instanceof x)return oe;if(typeof oe!="string"||oe.length>O||!(de?A[r]:A[u]).test(oe))return null;try{return new x(oe,de)}catch{return null}}function x(oe,de){if(oe instanceof x){if(oe.loose===de)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof x))return new x(oe,de);N("SemVer",oe,de),this.loose=de;var me=oe.trim().match(de?A[r]:A[u]);if(!me)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<T)return Oe}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=q,e.valid=function(oe,de){var me=q(oe,de);return me?me.version:null},e.clean=function(oe,de){var me=q(oe.trim().replace(/^[=v]+/,""),de);return me?me.version:null},e.SemVer=x,x.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},x.prototype.toString=function(){return this.version},x.prototype.compare=function(oe){return N("SemVer.compare",this.version,this.loose,oe),oe instanceof x||(oe=new x(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},x.prototype.compareMain=function(oe){return oe instanceof x||(oe=new x(oe,this.loose)),H(this.major,oe.major)||H(this.minor,oe.minor)||H(this.patch,oe.patch)},x.prototype.comparePre=function(oe){if(oe instanceof x||(oe=new x(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var de=0;do{var me=this.prerelease[de],Pe=oe.prerelease[de];if(N("prerelease compare",de,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return H(me,Pe)}while(++de)},x.prototype.inc=function(oe,de){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,de,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new x(oe,me).inc(de,Pe).version}catch{return null}},e.diff=function(oe,de){if(W(oe,de))return null;var me=q(oe),Pe=q(de);if(me.prerelease.length||Pe.prerelease.length){for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in me)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&me[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=H;var J=/^[0-9]+$/;function H(oe,de){var me=J.test(oe),Pe=J.test(de);return me&&Pe&&(oe=+oe,de=+de),me&&!Pe?-1:Pe&&!me?1:oe<de?-1:oe>de?1:0}function D(oe,de,me){return new x(oe,me).compare(new x(de,me))}function B(oe,de,me){return D(oe,de,me)>0}function j(oe,de,me){return D(oe,de,me)<0}function W(oe,de,me){return D(oe,de,me)===0}function te(oe,de,me){return D(oe,de,me)!==0}function _(oe,de,me){return D(oe,de,me)>=0}function Y(oe,de,me){return D(oe,de,me)<=0}function ae(oe,de,me,Pe){var Oe;switch(de){case"===":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),Oe=oe===me;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof me=="object"&&(me=me.version),Oe=oe!==me;break;case"":case"=":case"==":Oe=W(oe,me,Pe);break;case"!=":Oe=te(oe,me,Pe);break;case">":Oe=B(oe,me,Pe);break;case">=":Oe=_(oe,me,Pe);break;case"<":Oe=j(oe,me,Pe);break;case"<=":Oe=Y(oe,me,Pe);break;default:throw new TypeError("Invalid operator: "+de)}return Oe}function ue(oe,de){if(oe instanceof ue){if(oe.loose===de)return oe;oe=oe.value}if(!(this instanceof ue))return new ue(oe,de);N("comparator",oe,de),this.loose=de,this.parse(oe),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,N("comp",this)}e.rcompareIdentifiers=function(oe,de){return H(de,oe)},e.major=function(oe,de){return new x(oe,de).major},e.minor=function(oe,de){return new x(oe,de).minor},e.patch=function(oe,de){return new x(oe,de).patch},e.compare=D,e.compareLoose=function(oe,de){return D(oe,de,!0)},e.rcompare=function(oe,de,me){return D(de,oe,me)},e.sort=function(oe,de){return oe.sort(function(me,Pe){return e.compare(me,Pe,de)})},e.rsort=function(oe,de){return oe.sort(function(me,Pe){return e.rcompare(me,Pe,de)})},e.gt=B,e.lt=j,e.eq=W,e.neq=te,e.gte=_,e.lte=Y,e.cmp=ae,e.Comparator=ue;var ge={};function we(oe,de){if(oe instanceof we)return oe.loose===de?oe:new we(oe.raw,de);if(oe instanceof ue)return new we(oe.value,de);if(!(this instanceof we))return new we(oe,de);if(this.loose=de,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Ee(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function pe(oe,de,me,Pe,Oe,Fe,Te,Le,Ue,qe,He,Me,Be){return((de=Ee(me)?"":Ee(Pe)?">="+me+".0.0":Ee(Oe)?">="+me+"."+Pe+".0":">="+de)+" "+(Le=Ee(Ue)?"":Ee(qe)?"<"+(+Ue+1)+".0.0":Ee(He)?"<"+Ue+"."+(+qe+1)+".0":Me?"<="+Ue+"."+qe+"."+He+"-"+Me:"<="+Le)).trim()}function be(oe,de){for(var me=0;me<oe.length;me++)if(!oe[me].test(de))return!1;if(de.prerelease.length){for(me=0;me<oe.length;me++)if(N(oe[me].semver),oe[me].semver!==ge&&oe[me].semver.prerelease.length>0){var Pe=oe[me].semver;if(Pe.major===de.major&&Pe.minor===de.minor&&Pe.patch===de.patch)return!0}return!1}return!0}function Se(oe,de,me){try{de=new we(de,me)}catch{return!1}return de.test(oe)}function Ie(oe,de,me,Pe){var Oe,Fe,Te,Le,Ue;switch(oe=new x(oe,Pe),de=new we(de,Pe),me){case">":Oe=B,Fe=Y,Te=j,Le=">",Ue=">=";break;case"<":Oe=j,Fe=_,Te=B,Le="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Se(oe,de,Pe))return!1;for(var qe=0;qe<de.set.length;++qe){var He=de.set[qe],Me=null,Be=null;if(He.forEach(function(ze){ze.semver===ge&&(ze=new ue(">=0.0.0")),Me=Me||ze,Be=Be||ze,Oe(ze.semver,Me.semver,Pe)?Me=ze:Te(ze.semver,Be.semver,Pe)&&(Be=ze)}),Me.operator===Le||Me.operator===Ue||(!Be.operator||Be.operator===Le)&&Fe(oe,Be.semver)||Be.operator===Ue&&Te(oe,Be.semver))return!1}return!0}ue.prototype.parse=function(oe){var de=this.loose?A[G]:A[ie],me=oe.match(de);if(!me)throw new TypeError("Invalid comparator: "+oe);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new x(me[2],this.loose):this.semver=ge},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(oe){return N("Comparator.test",oe,this.loose),this.semver===ge||(typeof oe=="string"&&(oe=new x(oe,this.loose)),ae(oe,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(oe,de){if(!(oe instanceof ue))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new we(oe.value,de),Se(this.value,me,de);if(oe.operator==="")return me=new we(this.value,de),Se(oe.semver,me,de);var Pe=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Fe=this.semver.version===oe.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),Le=ae(this.semver,"<",oe.semver,de)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ue=ae(this.semver,">",oe.semver,de)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Pe||Oe||Fe&&Te||Le||Ue},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(oe){var de=this.loose;oe=oe.trim(),N("range",oe,de);var me=de?A[ee]:A[z];oe=oe.replace(me,pe),N("hyphen replace",oe),oe=oe.replace(A[V],"$1$2$3"),N("comparator trim",oe,A[V]),oe=(oe=(oe=oe.replace(A[C],"$1~")).replace(A[X],"$1^")).split(/\s+/).join(" ");var Pe=de?A[G]:A[ie],Oe=oe.split(" ").map(function(Fe){return function(Te,Le){return N("comp",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){N("caret",Me,Be);var ze=Be?A[Q]:A[K];return Me.replace(ze,function(We,Ne,se,fe,$e){var ye;return N("caret",Me,We,Ne,se,fe,$e),Ee(Ne)?ye="":Ee(se)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ee(fe)?ye=Ne==="0"?">="+Ne+"."+se+".0 <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+".0 <"+(+Ne+1)+".0.0":$e?(N("replaceCaret pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=Ne==="0"?se==="0"?">="+Ne+"."+se+"."+fe+$e+" <"+Ne+"."+se+"."+(+fe+1):">="+Ne+"."+se+"."+fe+$e+" <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+"."+fe+$e+" <"+(+Ne+1)+".0.0"):(N("no pr"),ye=Ne==="0"?se==="0"?">="+Ne+"."+se+"."+fe+" <"+Ne+"."+se+"."+(+fe+1):">="+Ne+"."+se+"."+fe+" <"+Ne+"."+(+se+1)+".0":">="+Ne+"."+se+"."+fe+" <"+(+Ne+1)+".0.0"),N("caret return",ye),ye})}(He,qe)}).join(" ")}(Te,Le),N("caret",Te),Te=function(Ue,qe){return Ue.trim().split(/\s+/).map(function(He){return function(Me,Be){var ze=Be?A[F]:A[U];return Me.replace(ze,function(We,Ne,se,fe,$e){var ye;return N("tilde",Me,We,Ne,se,fe,$e),Ee(Ne)?ye="":Ee(se)?ye=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":Ee(fe)?ye=">="+Ne+"."+se+".0 <"+Ne+"."+(+se+1)+".0":$e?(N("replaceTilde pr",$e),$e.charAt(0)!=="-"&&($e="-"+$e),ye=">="+Ne+"."+se+"."+fe+$e+" <"+Ne+"."+(+se+1)+".0"):ye=">="+Ne+"."+se+"."+fe+" <"+Ne+"."+(+se+1)+".0",N("tilde return",ye),ye})}(He,qe)}).join(" ")}(Te,Le),N("tildes",Te),Te=function(Ue,qe){return N("replaceXRanges",Ue,qe),Ue.split(/\s+/).map(function(He){return function(Me,Be){Me=Me.trim();var ze=Be?A[k]:A[R];return Me.replace(ze,function(We,Ne,se,fe,$e,ye){N("xRange",Me,We,Ne,se,fe,$e,ye);var Ae=Ee(se),Ce=Ae||Ee(fe),je=Ce||Ee($e);return Ne==="="&&je&&(Ne=""),Ae?We=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&je?(Ce&&(fe=0),je&&($e=0),Ne===">"?(Ne=">=",Ce?(se=+se+1,fe=0,$e=0):je&&(fe=+fe+1,$e=0)):Ne==="<="&&(Ne="<",Ce?se=+se+1:fe=+fe+1),We=Ne+se+"."+fe+"."+$e):Ce?We=">="+se+".0.0 <"+(+se+1)+".0.0":je&&(We=">="+se+"."+fe+".0 <"+se+"."+(+fe+1)+".0"),N("xRange return",We),We})}(He,qe)}).join(" ")}(Te,Le),N("xrange",Te),Te=function(Ue,qe){return N("replaceStars",Ue,qe),Ue.trim().replace(A[re],"")}(Te,Le),N("stars",Te),Te}(Fe,de)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Fe){return!!Fe.match(Pe)})),Oe=Oe.map(function(Fe){return new ue(Fe,de)})},we.prototype.intersects=function(oe,de){if(!(oe instanceof we))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return oe.set.some(function(Oe){return Oe.every(function(Fe){return Pe.intersects(Fe,de)})})})})},e.toComparators=function(oe,de){return new we(oe,de).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},we.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new x(oe,this.loose));for(var de=0;de<this.set.length;de++)if(be(this.set[de],oe))return!0;return!1},e.satisfies=Se,e.maxSatisfying=function(oe,de,me){var Pe=null,Oe=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Te){Fe.test(Te)&&(Pe&&Oe.compare(Te)!==-1||(Oe=new x(Pe=Te,me)))}),Pe},e.minSatisfying=function(oe,de,me){var Pe=null,Oe=null;try{var Fe=new we(de,me)}catch{return null}return oe.forEach(function(Te){Fe.test(Te)&&(Pe&&Oe.compare(Te)!==1||(Oe=new x(Pe=Te,me)))}),Pe},e.validRange=function(oe,de){try{return new we(oe,de).range||"*"}catch{return null}},e.ltr=function(oe,de,me){return Ie(oe,de,"<",me)},e.gtr=function(oe,de,me){return Ie(oe,de,">",me)},e.outside=Ie,e.prerelease=function(oe,de){var me=q(oe,de);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(oe,de,me){return oe=new we(oe,me),de=new we(de,me),oe.intersects(de)},e.coerce=function(oe){if(oe instanceof x)return oe;if(typeof oe!="string")return null;var de=oe.match(A[E]);return de==null?null:q((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,P(1))},function(ne,e){var P,a,N=ne.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function A(b){if(P===setTimeout)return setTimeout(b,0);if((P===O||!P)&&setTimeout)return P=setTimeout,setTimeout(b,0);try{return P(b,0)}catch{try{return P.call(null,b,0)}catch{return P.call(this,b,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:O}catch{P=O}try{a=typeof clearTimeout=="function"?clearTimeout:T}catch{a=T}})();var L,p=[],S=!1,d=-1;function h(){S&&L&&(S=!1,L.length?p=L.concat(p):d=-1,p.length&&$())}function $(){if(!S){var b=A(h);S=!0;for(var f=p.length;f;){for(L=p,p=[];++d<f;)L&&L[d].run();d=-1,f=p.length}L=null,S=!1,function(w){if(a===clearTimeout)return clearTimeout(w);if((a===T||!a)&&clearTimeout)return a=clearTimeout,clearTimeout(w);try{a(w)}catch{try{return a.call(null,w)}catch{return a.call(this,w)}}}(b)}}function c(b,f){this.fun=b,this.array=f}function m(){}N.nextTick=function(b){var f=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)f[w-1]=arguments[w];p.push(new c(b,f)),p.length!==1||S||A($)},c.prototype.run=function(){this.fun.apply(null,this.array)},N.title="browser",N.browser=!0,N.env={},N.argv=[],N.version="",N.versions={},N.on=m,N.addListener=m,N.once=m,N.off=m,N.removeListener=m,N.removeAllListeners=m,N.emit=m,N.prependListener=m,N.prependOnceListener=m,N.listeners=function(b){return[]},N.binding=function(b){throw new Error("process.binding is not supported")},N.cwd=function(){return"/"},N.chdir=function(b){throw new Error("process.chdir is not supported")},N.umask=function(){return 0}}])}),define(le[133],he([0,1]),function(ne,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ns=void 0;class a{constructor(A,L,p){this.level=A,this.key=L,this.value=p,this.forward=[]}}const N=void 0;class O{constructor(A,L=2**16){this.comparator=A,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(L)|0),this.e=new a(this.c,N,N)}get size(){return this.f}clear(){this.e=new a(this.c,N,N),this.f=0}has(A){return!!O.g(this,A,this.comparator)}get(A){return O.g(this,A,this.comparator)?.value}set(A,L){return O.h(this,A,L,this.comparator)&&(this.f+=1),this}delete(A){const L=O.k(this,A,this.comparator);return L&&(this.f-=1),L}forEach(A,L){let p=this.e.forward[0];for(;p;)A.call(L,p.value,p.key,this),p=p.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",L=this.e.forward[0];for(;L;)A+=`node(${L.key}, ${L.value}, lvl:${L.level})`,L=L.forward[0];return A}static g(A,L,p){let S=A.e;for(let d=A.d-1;d>=0;d--)for(;S.forward[d]&&p(S.forward[d].key,L)<0;)S=S.forward[d];if(S=S.forward[0],S&&p(S.key,L)===0)return S}static h(A,L,p,S){const d=[];let h=A.e;for(let $=A.d-1;$>=0;$--){for(;h.forward[$]&&S(h.forward[$].key,L)<0;)h=h.forward[$];d[$]=h}if(h=h.forward[0],h&&S(h.key,L)===0)return h.value=p,!1;{const $=O.j(A);if($>A.d){for(let c=A.d;c<$;c++)d[c]=A.e;A.d=$}h=new a($,L,p);for(let c=0;c<$;c++)h.forward[c]=d[c].forward[c],d[c].forward[c]=h;return!0}}static j(A,L=.5){let p=1;for(;Math.random()<L&&p<A.c;)p+=1;return p}static k(A,L,p){const S=[];let d=A.e;for(let h=A.d-1;h>=0;h--){for(;d.forward[h]&&p(d.forward[h].key,L)<0;)d=d.forward[h];S[h]=d}if(d=d.forward[0],!d||p(d.key,L)!==0)return!1;for(let h=0;h<A.d&&S[h].forward[h]===d;h++)S[h].forward[h]=d.forward[h];for(;A.d>0&&A.e.forward[A.d-1]===N;)A.d-=1;return!0}}e.$Ns=O}),define(le[55],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class a{static create(O){return new a(O)}constructor(O){this.c=P&&O===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=a}),define(le[3],he([0,1,8,89,2,90,55]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=$;const A=!1,L=!1,p=!1;var S;(function(F){F.None=()=>N.$Wc.None;function M(pe){if(p){const{onDidAddListener:be}=pe,Se=m.create();let Ie=0;pe.onDidAddListener=()=>{++Ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),be?.()}}}function X(pe,be){return q(pe,()=>{},0,void 0,!0,void 0,be)}F.defer=X;function K(pe){return(be,Se=null,Ie)=>{let oe=!1,de;return de=pe(me=>{if(!oe)return de?de.dispose():oe=!0,be.call(Se,me)},null,Ie),oe&&de.dispose(),de}}F.once=K;function Q(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>Ie.call(oe,be(me)),null,de),Se)}F.map=Q;function G(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>{be(me),Ie.call(oe,me)},null,de),Se)}F.forEach=G;function ie(pe,be,Se){return re((Ie,oe=null,de)=>pe(me=>be(me)&&Ie.call(oe,me),null,de),Se)}F.filter=ie;function V(pe){return pe}F.signal=V;function z(...pe){return(be,Se=null,Ie)=>{const oe=(0,N.$Tc)(...pe.map(de=>de(me=>be.call(Se,me))));return ce(oe,Ie)}}F.any=z;function ee(pe,be,Se,Ie){let oe=Se;return Q(pe,de=>(oe=be(oe,de),oe),Ie)}F.reduce=ee;function re(pe,be){let Se;const Ie={onWillAddFirstListener(){Se=pe(oe.fire,oe)},onDidRemoveLastListener(){Se?.dispose()}};be||M(Ie);const oe=new s(Ie);return be?.add(oe),oe.event}function ce(pe,be){return be instanceof Array?be.push(pe):be&&be.add(pe),pe}function q(pe,be,Se=100,Ie=!1,oe=!1,de,me){let Pe,Oe,Fe,Te=0,Le;const Ue={leakWarningThreshold:de,onWillAddFirstListener(){Pe=pe(He=>{Te++,Oe=be(Oe,He),Ie&&!Fe&&(qe.fire(Oe),Oe=void 0),Le=()=>{const Me=Oe;Oe=void 0,Fe=void 0,(!Ie||Te>1)&&qe.fire(Me),Te=0},typeof Se=="number"?(clearTimeout(Fe),Fe=setTimeout(Le,Se)):Fe===void 0&&(Fe=0,queueMicrotask(Le))})},onWillRemoveListener(){oe&&Te>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,Pe.dispose()}};me||M(Ue);const qe=new s(Ue);return me?.add(qe),qe.event}F.debounce=q;function x(pe,be=0,Se){return F.debounce(pe,(Ie,oe)=>Ie?(Ie.push(oe),Ie):[oe],be,void 0,!0,void 0,Se)}F.accumulate=x;function J(pe,be=(Ie,oe)=>Ie===oe,Se){let Ie=!0,oe;return ie(pe,de=>{const me=Ie||!be(de,oe);return Ie=!1,oe=de,me},Se)}F.latch=J;function H(pe,be,Se){return[F.filter(pe,be,Se),F.filter(pe,Ie=>!be(Ie),Se)]}F.split=H;function D(pe,be=!1,Se=[],Ie){let oe=Se.slice(),de=pe(Oe=>{oe?oe.push(Oe):Pe.fire(Oe)});Ie&&Ie.add(de);const me=()=>{oe?.forEach(Oe=>Pe.fire(Oe)),oe=null},Pe=new s({onWillAddFirstListener(){de||(de=pe(Oe=>Pe.fire(Oe)),Ie&&Ie.add(de))},onDidAddFirstListener(){oe&&(be?setTimeout(me):me())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return Ie&&Ie.add(Pe),Pe.event}F.buffer=D;function B(pe,be){return(Ie,oe,de)=>{const me=be(new W);return pe(function(Pe){const Oe=me.evaluate(Pe);Oe!==j&&Ie.call(oe,Oe)},void 0,de)}}F.chain=B;const j=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(be){return this.f.push(be),this}forEach(be){return this.f.push(Se=>(be(Se),Se)),this}filter(be){return this.f.push(Se=>be(Se)?Se:j),this}reduce(be,Se){let Ie=Se;return this.f.push(oe=>(Ie=be(Ie,oe),Ie)),this}latch(be=(Se,Ie)=>Se===Ie){let Se=!0,Ie;return this.f.push(oe=>{const de=Se||!be(oe,Ie);return Se=!1,Ie=oe,de?oe:j}),this}evaluate(be){for(const Se of this.f)if(be=Se(be),be===j)break;return be}}function te(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.on(be,Ie),de=()=>pe.removeListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}F.fromNodeEventEmitter=te;function _(pe,be,Se=Ie=>Ie){const Ie=(...Pe)=>me.fire(Se(...Pe)),oe=()=>pe.addEventListener(be,Ie),de=()=>pe.removeEventListener(be,Ie),me=new s({onWillAddFirstListener:oe,onDidRemoveLastListener:de});return me.event}F.fromDOMEventEmitter=_;function Y(pe){return new Promise(be=>K(pe)(be))}F.toPromise=Y;function ae(pe){const be=new s;return pe.then(Se=>{be.fire(Se)},()=>{be.fire(void 0)}).finally(()=>{be.dispose()}),be.event}F.fromPromise=ae;function ue(pe,be,Se){return be(Se),pe(Ie=>be(Ie))}F.runAndSubscribe=ue;class ge{constructor(be,Se){this._observable=be,this.f=0,this.g=!1;const Ie={onWillAddFirstListener:()=>{be.addObserver(this)},onDidRemoveLastListener:()=>{be.removeObserver(this)}};Se||M(Ie),this.emitter=new s(Ie),Se&&Se.add(this.emitter)}beginUpdate(be){this.f++}handlePossibleChange(be){}handleChange(be,Se){this.g=!0}endUpdate(be){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function we(pe,be){return new ge(pe,be).emitter.event}F.fromObservable=we;function Ee(pe){return(be,Se,Ie)=>{let oe=0,de=!1;const me={beginUpdate(){oe++},endUpdate(){oe--,oe===0&&(pe.reportChanges(),de&&(de=!1,be.call(Se)))},handlePossibleChange(){},handleChange(){de=!0}};pe.addObserver(me),pe.reportChanges();const Pe={dispose(){pe.removeObserver(me)}};return Ie instanceof N.$Vc?Ie.add(Pe):Array.isArray(Ie)&&Ie.push(Pe),Pe}}F.fromObservableLight=Ee})(S||(e.Event=S={}));class d{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${d.f++}`,d.all.add(this)}start(M){this.g=new T.$ge,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$ie=d;let h=-1;function $(F){const M=h;return h=F,{dispose(){h=M}}}class c{static{this.f=1}constructor(M,X,K=(c.f++).toString(16).padStart(3,"0")){this.j=M,this.threshold=X,this.name=K,this.h=0}dispose(){this.g?.clear()}check(M,X){const K=this.threshold;if(K<=0||X<K)return;this.g||(this.g=new Map);const Q=this.g.get(M.value)||0;if(this.g.set(M.value,Q+1),this.h-=1,this.h<=0){this.h=K*.5;const[G,ie]=this.getMostFrequentStack(),V=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${ie}):`;console.warn(V),console.warn(G);const z=new b(V,G);this.j(z)}return()=>{const G=this.g.get(M.value)||0;this.g.set(M.value,G-1)}}getMostFrequentStack(){if(!this.g)return;let M,X=0;for(const[K,Q]of this.g)(!M||X<Q)&&(M=[K,Q],X=Q);return M}}class m{static create(){const M=new Error;return new m(M.stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class b extends Error{constructor(M,X){super(M),this.name="ListenerLeakError",this.stack=X}}e.$ke=b;class f extends Error{constructor(M,X){super(M),this.name="ListenerRefusalError",this.stack=X}}e.$le=f;let w=0;class I{constructor(M){this.value=M,this.id=w++}}const g=2,u=(F,M)=>{if(F instanceof I)M(F);else for(let X=0;X<F.length;X++){const K=F[X];K&&M(K)}};let t;if(A){const F=[];setInterval(()=>{F.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(F.join(`
`)),F.length=0)},3e3),t=new FinalizationRegistry(M=>{typeof M=="string"&&F.push(M)})}class s{constructor(M){this.z=0,this.f=M,this.g=h>0||this.f?.leakWarningThreshold?new c(M?.onListenerError??P.$3,this.f?.leakWarningThreshold??h):void 0,this.j=this.f?._profName?new d(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if(L){const M=this.u;queueMicrotask(()=>{u(M,X=>X.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,X,K)=>{if(this.g&&this.z>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(z);const ee=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],re=new f(`${z}. HINT: Stack shows most frequent listener (${ee[1]}-times)`,ee[0]);return(this.f?.onListenerError||P.$3)(re),N.$Wc.None}if(this.m)return N.$Wc.None;X&&(M=M.bind(X));const Q=new I(M);let G,ie;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Q.stack=m.create(),G=this.g.check(Q.stack,this.z+1)),L&&(Q.stack=ie??m.create()),this.u?this.u instanceof I?(this.w??=new i,this.u=[this.u,Q]):this.u.push(Q):(this.f?.onWillAddFirstListener?.(this),this.u=Q,this.f?.onDidAddFirstListener?.(this)),this.z++;const V=(0,N.$Uc)(()=>{t?.unregister(V),G?.(),this.A(Q)});if(K instanceof N.$Vc?K.add(V):Array.isArray(K)&&K.push(V),t){const z=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),ee=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(z);t.register(V,ee?.[2]??z,V)}return V},this.q}A(M){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const X=this.u,K=X.indexOf(M);if(K===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,X[K]=void 0;const Q=this.w.current===this;if(this.z*g<=X.length){let G=0;for(let ie=0;ie<X.length;ie++)X[ie]?X[G++]=X[ie]:Q&&(this.w.end--,G<this.w.i&&this.w.i--);X.length=G}}B(M,X){if(!M)return;const K=this.f?.onListenerError||P.$3;if(!K){M.value(X);return}try{M.value(X)}catch(Q){K(Q)}}C(M){const X=M.current.u;for(;M.i<M.end;)this.B(X[M.i++],M.value);M.reset()}fire(M){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof I)this.B(this.u,M);else{const X=this.w;X.enqueue(this,M,this.u.length),this.C(X)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=s;const r=()=>new i;e.$ne=r;class i{constructor(){this.i=-1,this.end=0}enqueue(M,X,K){this.i=0,this.end=K,this.current=M,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends s{async fireAsync(M,X,K){if(this.u)for(this.h||(this.h=new O.$7c),u(this.u,Q=>this.h.push([Q.value,M]));this.h.size>0&&!X.isCancellationRequested;){const[Q,G]=this.h.shift(),ie=[],V={...G,token:X,waitUntil:z=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");K&&(z=K(z,Q)),ie.push(z)}};try{Q(V)}catch(z){(0,P.$3)(z);continue}Object.freeze(ie),await Promise.allSettled(ie).then(z=>{for(const ee of z)ee.status==="rejected"&&(0,P.$3)(ee.reason)})}}}e.$oe=n;class o extends s{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new O.$7c,this.t=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.t(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.z&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$pe=o;class l extends o{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$qe=l;class y extends s{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}e.$re=y;class R{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const X={event:M,listener:null};this.h.push(X),this.g&&this.m(X);const K=()=>{this.g&&this.o(X);const Q=this.h.indexOf(X);this.h.splice(Q,1)};return(0,N.$Uc)((0,a.$fb)(K))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(X=>this.f.fire(X))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$se=R;class k{constructor(M,X,K,Q){this.f=new N.$Vc;const G=this.f.add(new R),ie=this.f.add(new N.$6c);function V(z){ie.set(z,G.add(Q(z)))}for(const z of M)V(z);this.f.add(X(z=>{V(z)})),this.f.add(K(z=>{ie.deleteAndDispose(z)})),this.event=G.event}dispose(){this.f.dispose()}}e.$te=k;class E{constructor(){this.f=[]}wrapEvent(M,X,K){return(Q,G,ie)=>M(V=>{const z=this.f[this.f.length-1];if(!X){z?z.buffers.push(()=>Q.call(G,V)):Q.call(G,V);return}const ee=z;if(!ee){Q.call(G,X(K,V));return}ee.items??=[],ee.items.push(V),ee.buffers.length===0&&z.buffers.push(()=>{ee.reducedResult??=K?ee.items.reduce(X,K):ee.items.reduce(X),Q.call(G,ee.reducedResult)})},void 0,ie)}bufferEvents(M){const X={buffers:new Array};this.f.push(X);const K=M();return this.f.pop(),X.buffers.forEach(Q=>Q()),K}}e.$ue=E;class v{constructor(){this.f=!1,this.g=S.None,this.h=N.$Wc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class C{static const(M){return new U(M)}constructor(M){this.g=M,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$we=C;class U{constructor(M){this.value=M,this.onDidChange=S.None}}}),define(le[26],he([0,1,3]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=A;const a=Object.freeze(function(L,p){const S=setTimeout(L.bind(p),0);return{dispose(){clearTimeout(S)}}});var N;(function(L){function p(S){return S===L.None||S===L.Cancelled||S instanceof O?!0:!S||typeof S!="object"?!1:typeof S.isCancellationRequested=="boolean"&&typeof S.onCancellationRequested=="function"}L.isCancellationToken=p,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:a})})(N||(e.CancellationToken=N={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?a:(this.b||(this.b=new P.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new O),this.f}cancel(){this.f?this.f instanceof O&&this.f.cancel():this.f=N.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof O&&this.f.dispose():this.f=N.None}}e.$xe=T;function A(L){const p=new T;return L.add({dispose(){p.cancel()}}),p.token}}),define(le[134],he([0,1,26]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=N;class a{constructor(L){this.b=L,this.a=null}get(){if(this.a)return this.a;const L=new P.$xe,p=this.b(L.token);return this.a={promise:p,dispose:()=>{this.a=null,L.cancel(),L.dispose()}},this.a}}e.$0e=a;function N(A){return A}class O{constructor(L,p){this.a=void 0,this.b=void 0,typeof L=="function"?(this.c=L,this.d=N):(this.c=p,this.d=L.getCacheKey)}get(L){const p=this.d(L);return this.b!==p&&(this.b=p,this.a=this.c(L)),this.a}}e.$_e=O;class T{get cachedValues(){return this.a}constructor(L,p){this.a=new Map,this.b=new Map,typeof L=="function"?(this.c=L,this.d=N):(this.c=p,this.d=L.getCacheKey)}get(L){const p=this.d(L);if(this.b.has(p))return this.b.get(p);const S=this.c(L);return this.a.set(L,S),this.b.set(p,S),S}}e.$af=T}),define(le[51],he([0,1,8,2]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=N,e.$Ae=O,e.$Be=T,e.$Ce=A,e.$De=p,e.$Ee=S,e.$Fe=d,e.$Ge=h,e.$He=$,e.$Ie=c,e.$Je=m,e.$Ke=b,e.$Le=f,e.$Me=w,e.$Ne=I;function N(g){const u=g;return u?typeof u.read=="function":!1}function O(g){const u=g;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}function T(g){const u=g;return u?O(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function A(g,u){return new L(g,u)}class L{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$3)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let s;switch(u){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(g,u){const t=[];let s;for(;(s=g.read())!==null;)t.push(s);return u(t)}function S(g,u,t){const s=[];let r;for(;(r=g.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?u(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return g.read()}}}function d(g,u){return new Promise((t,s)=>{const r=[];h(g,{onData:i=>{u&&r.push(i)},onError:i=>{u?s(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}function h(g,u,t){g.on("error",s=>{t?.isCancellationRequested||u.onError(s)}),g.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),g.on("data",s=>{t?.isCancellationRequested||u.onData(s)})}function $(g,u){return new Promise((t,s)=>{const r=new a.$Vc,i=[],n=y=>{if(i.push(y),i.length>u)return r.dispose(),g.pause(),t({stream:g,buffer:i,ended:!1})},o=y=>(r.dispose(),s(y)),l=()=>(r.dispose(),t({stream:g,buffer:i,ended:!0}));r.add((0,a.$Uc)(()=>g.removeListener("error",o))),g.on("error",o),r.add((0,a.$Uc)(()=>g.removeListener("end",l))),g.on("end",l),r.add((0,a.$Uc)(()=>g.removeListener("data",n))),g.on("data",n)})}function c(g,u){const t=A(u);return t.end(g),t}function m(){const g=A(()=>{throw new Error("not supported")});return g.end(),g}function b(g){let u=!1;return{read:()=>u?null:(u=!0,g)}}function f(g,u,t){const s=A(t);return h(g,{onData:r=>s.write(u.data(r)),onError:r=>s.error(u.error?u.error(r):r),onEnd:()=>s.end()}),s}function w(g,u,t){let s=!1;return{read:()=>{const r=u.read();return s?r:(s=!0,r!==null?t([g,r]):g)}}}function I(g,u,t){let s=!1;const r=A(t);return h(u,{onData:i=>s?r.write(i):(s=!0,r.write(t([g,i]))),onError:i=>r.error(i),onEnd:()=>{s||(s=!0,r.write(g)),r.end()}}),r}});var Ot=this&&this.__createBinding||(Object.create?function(ne,e,P,a){a===void 0&&(a=P);var N=Object.getOwnPropertyDescriptor(e,P);(!N||("get"in N?!e.__esModule:N.writable||N.configurable))&&(N={enumerable:!0,get:function(){return e[P]}}),Object.defineProperty(ne,a,N)}:function(ne,e,P,a){a===void 0&&(a=P),ne[a]=e[P]}),At=this&&this.__setModuleDefault||(Object.create?function(ne,e){Object.defineProperty(ne,"default",{enumerable:!0,value:e})}:function(ne,e){ne.default=e}),ke=this&&this.__importStar||function(ne){if(ne&&ne.__esModule)return ne;var e={};if(ne!=null)for(var P in ne)P!=="default"&&Object.prototype.hasOwnProperty.call(ne,P)&&Ot(e,ne,P);return At(e,ne),e};define(le[15],he([0,1,54,51]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=p,e.$Qe=S,e.$Re=d,e.$Se=h,e.$Te=$,e.$Ue=c,e.$Ve=m,e.$We=b,e.$Xe=f,e.$Ye=w,e.$Ze=I,e.$1e=g,e.$2e=u,e.$3e=t,e.$4e=s,e.$5e=r,e.$6e=i,e.$7e=n,e.$8e=o,e.$9e=R,a=ke(a);const N=typeof Buffer<"u",O=new P.$X(()=>new Uint8Array(256));let T,A;class L{static alloc(E){return N?new L(Buffer.allocUnsafe(E)):new L(new Uint8Array(E))}static wrap(E){return N&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new L(E)}static fromString(E,v){return!(v?.dontUseNodeBuffer||!1)&&N?new L(Buffer.from(E)):(T||(T=new TextEncoder),new L(T.encode(E)))}static fromByteArray(E){const v=L.alloc(E.length);for(let C=0,U=E.length;C<U;C++)v.buffer[C]=E[C];return v}static concat(E,v){if(typeof v>"u"){v=0;for(let F=0,M=E.length;F<M;F++)v+=E[F].byteLength}const C=L.alloc(v);let U=0;for(let F=0,M=E.length;F<M;F++){const X=E[F];C.set(X,U),U+=X.byteLength}return C}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=L.alloc(this.byteLength);return E.set(this),E}toString(){return N?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(E,v){return new L(this.buffer.subarray(E,v))}set(E,v){if(E instanceof L)this.buffer.set(E.buffer,v);else if(E instanceof Uint8Array)this.buffer.set(E,v);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),v);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return h(this.buffer,E)}writeUInt32BE(E,v){$(this.buffer,E,v)}readUInt32LE(E){return c(this.buffer,E)}writeUInt32LE(E,v){m(this.buffer,E,v)}readUInt8(E){return b(this.buffer,E)}writeUInt8(E,v){f(this.buffer,E,v)}indexOf(E,v=0){return p(this.buffer,E instanceof L?E.buffer:E,v)}}e.$Oe=L;function p(k,E,v=0){const C=E.byteLength,U=k.byteLength;if(C===0)return 0;if(C===1)return k.indexOf(E[0]);if(C>U-v)return-1;const F=O.value;F.fill(E.length);for(let Q=0;Q<E.length;Q++)F[E[Q]]=E.length-Q-1;let M=v+E.length-1,X=M,K=-1;for(;M<U;)if(k[M]===E[X]){if(X===0){K=M;break}M--,X--}else M+=Math.max(E.length-X,F[k[M]]),X=E.length-1;return K}function S(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0}function d(k,E,v){k[v+0]=E&255,E=E>>>8,k[v+1]=E&255}function h(k,E){return k[E]*2**24+k[E+1]*2**16+k[E+2]*2**8+k[E+3]}function $(k,E,v){k[v+3]=E,E=E>>>8,k[v+2]=E,E=E>>>8,k[v+1]=E,E=E>>>8,k[v]=E}function c(k,E){return k[E+0]<<0>>>0|k[E+1]<<8>>>0|k[E+2]<<16>>>0|k[E+3]<<24>>>0}function m(k,E,v){k[v+0]=E&255,E=E>>>8,k[v+1]=E&255,E=E>>>8,k[v+2]=E&255,E=E>>>8,k[v+3]=E&255}function b(k,E){return k[E]}function f(k,E,v){k[v]=E}function w(k){return a.$De(k,E=>L.concat(E))}function I(k){return a.$Ke(k)}function g(k){return a.$Fe(k,E=>L.concat(E))}async function u(k){return k.ended?L.concat(k.buffer):L.concat([...k.buffer,await g(k.stream)])}function t(k){return a.$Ie(k,E=>L.concat(E))}function s(k){return a.$Le(k,{data:E=>typeof E=="string"?L.fromString(E):L.wrap(E)},E=>L.concat(E))}function r(k){return a.$Ce(E=>L.concat(E),k)}function i(k,E){return a.$Me(k,E,v=>L.concat(v))}function n(k,E){return a.$Ne(k,E,v=>L.concat(v))}function o(k){let E=0,v=0,C=0;const U=new Uint8Array(Math.floor(k.length/4*3)),F=X=>{switch(v){case 3:U[C++]=E|X,v=0;break;case 2:U[C++]=E|X>>>2,E=X<<6,v=3;break;case 1:U[C++]=E|X>>>4,E=X<<4,v=2;break;default:E=X<<2,v=1}};for(let X=0;X<k.length;X++){const K=k.charCodeAt(X);if(K>=65&&K<=90)F(K-65);else if(K>=97&&K<=122)F(K-97+26);else if(K>=48&&K<=57)F(K-48+52);else if(K===43||K===45)F(62);else if(K===47||K===95)F(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${k[X]}`)}}const M=C;for(;v>0;)F(0);return L.wrap(U).slice(0,M)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function R({buffer:k},E=!0,v=!1){const C=v?y:l;let U="";const F=k.byteLength%3;let M=0;for(;M<k.byteLength-F;M+=3){const X=k[M+0],K=k[M+1],Q=k[M+2];U+=C[X>>>2],U+=C[(X<<4|K>>>4)&63],U+=C[(K<<2|Q>>>6)&63],U+=C[Q&63]}if(F===1){const X=k[M+0];U+=C[X>>>2],U+=C[X<<4&63],E&&(U+="==")}else if(F===2){const X=k[M+0],K=k[M+1];U+=C[X>>>2],U+=C[(X<<4|K>>>4)&63],U+=C[K<<2&63],E&&(U+="=")}return U}}),define(le[135],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(le[13],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=P,e.$gg=a,e.$hg=N,e.$ig=O,e.$jg=T,e.$kg=A,e.$lg=L,e.$mg=p,e.$ng=S,e.$og=d,e.$pg=h,e.$qg=$,e.$rg=c,e.$sg=b,e.$tg=f,e.$ug=w,e.$vg=I,e.$wg=g;function P(u){return typeof u=="string"}function a(u){return Array.isArray(u)&&u.every(t=>P(t))}function N(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}function O(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}function T(u){return typeof u=="number"&&!isNaN(u)}function A(u){return!!u&&typeof u[Symbol.iterator]=="function"}function L(u){return u===!0||u===!1}function p(u){return typeof u>"u"}function S(u){return!d(u)}function d(u){return p(u)||u===null}function h(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function $(u){if(d(u))throw new Error("Assertion Failed: argument is undefined or null");return u}function c(...u){const t=[];for(let s=0;s<u.length;s++){const r=u[s];if(d(r))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(r)}return t}const m=Object.prototype.hasOwnProperty;function b(u){if(!N(u))return!1;for(const t in u)if(m.call(u,t))return!1;return!0}function f(u){return typeof u=="function"}function w(...u){return u.length>0&&u.every(f)}function I(u,t){const s=Math.min(u.length,t.length);for(let r=0;r<s;r++)g(u[r],t[r])}function g(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(u instanceof t)return}catch{}if(!d(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(le[30],he([0,1,13]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=a,e.$do=N,e.$eo=T,e.$fo=L,e.$go=p,e.$ho=S,e.$io=d,e.$jo=h,e.$ko=$,e.$lo=c,e.$mo=m,e.$no=b,e.$oo=f;function a(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const I=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([g,u])=>{I[g]=u&&typeof u=="object"?a(u):u}),I}function N(w){if(!w||typeof w!="object")return w;const I=[w];for(;I.length>0;){const g=I.shift();Object.freeze(g);for(const u in g)if(O.call(g,u)){const t=g[u];typeof t=="object"&&!Object.isFrozen(t)&&!(0,P.$ig)(t)&&I.push(t)}}return w}const O=Object.prototype.hasOwnProperty;function T(w,I){return A(w,I,new Set)}function A(w,I,g){if((0,P.$og)(w))return w;const u=I(w);if(typeof u<"u")return u;if(Array.isArray(w)){const t=[];for(const s of w)t.push(A(s,I,g));return t}if((0,P.$hg)(w)){if(g.has(w))throw new Error("Cannot clone recursive data-structure");g.add(w);const t={};for(const s in w)O.call(w,s)&&(t[s]=A(w[s],I,g));return g.delete(w),t}return w}function L(w,I,g=!0){return(0,P.$hg)(w)?((0,P.$hg)(I)&&Object.keys(I).forEach(u=>{u in w?g&&((0,P.$hg)(w[u])&&(0,P.$hg)(I[u])?L(w[u],I[u],g):w[u]=I[u]):w[u]=I[u]}),w):I}function p(w,I){if(w===I)return!0;if(w==null||I===null||I===void 0||typeof w!=typeof I||typeof w!="object"||Array.isArray(w)!==Array.isArray(I))return!1;let g,u;if(Array.isArray(w)){if(w.length!==I.length)return!1;for(g=0;g<w.length;g++)if(!p(w[g],I[g]))return!1}else{const t=[];for(u in w)t.push(u);t.sort();const s=[];for(u in I)s.push(u);if(s.sort(),!p(t,s))return!1;for(g=0;g<t.length;g++)if(!p(w[t[g]],I[t[g]]))return!1}return!0}function S(w){const I=new Set;return JSON.stringify(w,(g,u)=>{if((0,P.$hg)(u)||Array.isArray(u)){if(I.has(u))return"[Circular]";I.add(u)}return typeof u=="bigint"?`[BigInt ${u.toString()}]`:u})}function d(w,I){const g=Object.create(null);return!w||!I||Object.keys(I).forEach(t=>{const s=w[t],r=I[t];p(s,r)||(g[t]=r)}),g}function h(w,I){const g=I.toLowerCase(),u=Object.keys(w).find(t=>t.toLowerCase()===g);return u?w[u]:w[I]}function $(w,I){const g=Object.create(null);for(const[u,t]of Object.entries(w))I(u,t)&&(g[u]=t);return g}function c(w){let I=[];for(;Object.prototype!==w;)I=I.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return I}function m(w){const I=[];for(const g of c(w))typeof w[g]=="function"&&I.push(g);return I}function b(w,I){const g=t=>function(){const s=Array.prototype.slice.call(arguments,0);return I(t,s)},u={};for(const t of w)u[t]=g(t);return u}function f(w,I){const g={};for(const[u,t]of Object.entries(w))g[u]=I(t,u);return g}}),define(le[136],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=a,e.$cf=N;var P;(function(O){O[O.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",O[O.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",O[O.MAX_UINT_8=255]="MAX_UINT_8",O[O.MAX_UINT_16=65535]="MAX_UINT_16",O[O.MAX_UINT_32=4294967295]="MAX_UINT_32",O[O.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(P||(e.Constants=P={}));function a(O){return O<0?0:O>P.MAX_UINT_8?P.MAX_UINT_8:O|0}function N(O){return O<0?0:O>P.MAX_UINT_32?P.MAX_UINT_32:O|0}}),define(le[27],he([0,1,134,39,54,136]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=T,e.$ef=L,e.$ff=S,e.$gf=d,e.$hf=h,e.$if=$,e.$jf=c,e.$kf=m,e.$lf=b,e.$mf=f,e.$nf=w,e.$of=I,e.$pf=g,e.$qf=u,e.$rf=t,e.$sf=s,e.$tf=r,e.$uf=i,e.$vf=n,e.$wf=o,e.$xf=l,e.$yf=y,e.$zf=R,e.$Af=k,e.$Bf=E,e.$Cf=v,e.$Df=C,e.$Ef=U,e.$Ff=F,e.$Gf=M,e.$Hf=X,e.$If=K,e.$Jf=Q,e.$Kf=G,e.$Lf=ie,e.$Mf=V,e.$Nf=z,e.$Qf=q,e.$Rf=x,e.$Sf=J,e.$Tf=H,e.$Uf=j,e.$Vf=te,e.$Xf=_,e.$Yf=Y,e.$Zf=ae,e.$1f=ue,e.$2f=we,e.$3f=Ee,e.$4f=be,e.$6f=Se,e.$7f=Ie,e.$8f=oe,e.$9f=de,e.$0f=me,e.$$f=Pe,e.$_f=Oe,e.$ag=Fe,e.$bg=He;function T(se){return!se||typeof se!="string"?!0:se.trim().length===0}const A=/{(\d+)}/g;function L(se,...fe){return fe.length===0?se:se.replace(A,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=fe.length?$e:fe[Ae]})}const p=/{([^}]+)}/g;function S(se,fe){return Object.keys(fe).length===0?se:se.replace(p,($e,ye)=>fe[ye]??$e)}function d(se){return se.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function h(se){return se.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function $(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(se,fe){let $e=0,ye=se.indexOf(fe);for(;ye!==-1;)$e++,ye=se.indexOf(fe,ye+fe.length);return $e}function m(se,fe,$e="\u2026"){return se.length<=fe?se:`${se.substr(0,fe)}${$e}`}function b(se,fe,$e="\u2026"){if(se.length<=fe)return se;const ye=Math.ceil(fe/2)-$e.length/2,Ae=Math.floor(fe/2)-$e.length/2;return`${se.substr(0,ye)}${$e}${se.substr(se.length-Ae)}`}function f(se,fe=" "){const $e=w(se,fe);return I($e,fe)}function w(se,fe){if(!se||!fe)return se;const $e=fe.length;if($e===0||se.length===0)return se;let ye=0;for(;se.indexOf(fe,ye)===ye;)ye=ye+$e;return se.substring(ye)}function I(se,fe){if(!se||!fe)return se;const $e=fe.length,ye=se.length;if($e===0||ye===0)return se;let Ae=ye,Ce=-1;for(;Ce=se.lastIndexOf(fe,Ae-1),!(Ce===-1||Ce+$e!==Ae);){if(Ce===0)return"";Ae=Ce}return se.substring(0,Ae)}function g(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(se){return se.replace(/\*/g,"")}function t(se,fe,$e={}){if(!se)throw new Error("Cannot create regex from empty string");fe||(se=$(se)),$e.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(se,ye)}function s(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}function r(se){return se.split(/\r\n|\r|\n/)}function i(se){const fe=[],$e=se.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil($e.length/2);ye++)fe.push($e[2*ye]+($e[2*ye+1]??""));return fe}function n(se){for(let fe=0,$e=se.length;fe<$e;fe++){const ye=se.charCodeAt(fe);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return fe}return-1}function o(se,fe=0,$e=se.length){for(let ye=fe;ye<$e;ye++){const Ae=se.charCodeAt(ye);if(Ae!==a.CharCode.Space&&Ae!==a.CharCode.Tab)return se.substring(fe,ye)}return se.substring(fe,$e)}function l(se,fe=se.length-1){for(let $e=fe;$e>=0;$e--){const ye=se.charCodeAt($e);if(ye!==a.CharCode.Space&&ye!==a.CharCode.Tab)return $e}return-1}function y(se,fe,$e){const ye=[];let Ae=0;for(const Ce of se.matchAll(fe)){if(ye.push(se.slice(Ae,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Ae=Ce.index+Ce[0].length,ye.push($e(Ce[0],...Ce.slice(1),Ce.index,se,Ce.groups))}return ye.push(se.slice(Ae)),Promise.all(ye).then(Ce=>Ce.join(""))}function R(se,fe){return se<fe?-1:se>fe?1:0}function k(se,fe,$e=0,ye=se.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){const Je=se.charCodeAt($e),Qe=fe.charCodeAt(Ae);if(Je<Qe)return-1;if(Je>Qe)return 1}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function E(se,fe){return v(se,fe,0,se.length,0,fe.length)}function v(se,fe,$e=0,ye=se.length,Ae=0,Ce=fe.length){for(;$e<ye&&Ae<Ce;$e++,Ae++){let Je=se.charCodeAt($e),Qe=fe.charCodeAt(Ae);if(Je===Qe)continue;if(Je>=128||Qe>=128)return k(se.toLowerCase(),fe.toLowerCase(),$e,ye,Ae,Ce);U(Je)&&(Je-=32),U(Qe)&&(Qe-=32);const Ve=Je-Qe;if(Ve!==0)return Ve}const je=ye-$e,xe=Ce-Ae;return je<xe?-1:je>xe?1:0}function C(se){return se>=a.CharCode.Digit0&&se<=a.CharCode.Digit9}function U(se){return se>=a.CharCode.a&&se<=a.CharCode.z}function F(se){return se>=a.CharCode.A&&se<=a.CharCode.Z}function M(se,fe){return se.length===fe.length&&v(se,fe)===0}function X(se,fe){const $e=fe.length;return fe.length>se.length?!1:v(se,fe,0,$e)===0}function K(se,fe){const $e=Math.min(se.length,fe.length);let ye;for(ye=0;ye<$e;ye++)if(se.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return $e}function Q(se,fe){const $e=Math.min(se.length,fe.length);let ye;const Ae=se.length-1,Ce=fe.length-1;for(ye=0;ye<$e;ye++)if(se.charCodeAt(Ae-ye)!==fe.charCodeAt(Ce-ye))return ye;return $e}function G(se){return 55296<=se&&se<=56319}function ie(se){return 56320<=se&&se<=57343}function V(se,fe){return(se-55296<<10)+(fe-56320)+65536}function z(se,fe,$e){const ye=se.charCodeAt($e);if(G(ye)&&$e+1<fe){const Ae=se.charCodeAt($e+1);if(ie(Ae))return V(ye,Ae)}return ye}function ee(se,fe){const $e=se.charCodeAt(fe-1);if(ie($e)&&fe>1){const ye=se.charCodeAt(fe-2);if(G(ye))return V(ye,$e)}return $e}class re{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=ee(this.c,this.e);return this.e-=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}nextCodePoint(){const fe=z(this.c,this.d,this.e);return this.e+=fe>=O.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,fe}eol(){return this.e>=this.d}}e.$Of=re;class ce{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new re(fe,$e)}nextGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.nextCodePoint());if(Te(Ae,je)){$e.setOffset(Ce);break}Ae=je}return $e.offset-ye}prevGraphemeLength(){const fe=Ue.getInstance(),$e=this.c,ye=$e.offset;let Ae=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Ce=$e.offset,je=fe.getGraphemeBreakType($e.prevCodePoint());if(Te(je,Ae)){$e.setOffset(Ce);break}Ae=je}return ye-$e.offset}eol(){return this.c.eol()}}e.$Pf=ce;function q(se,fe){return new ce(se,fe).nextGraphemeLength()}function x(se,fe){return new ce(se,fe).prevGraphemeLength()}function J(se,fe){fe>0&&ie(se.charCodeAt(fe))&&fe--;const $e=fe+q(se,fe);return[$e-x(se,$e),$e]}function H(se){const fe=new ce(se);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}let D;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(se){return D||(D=B()),D.test(se)}const W=/^[\t\n\r\x20-\x7E]*$/;function te(se){return W.test(se)}e.$Wf=/[\u2028\u2029]/;function _(se){return e.$Wf.test(se)}function Y(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}function ae(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}function ue(se,fe,$e=""){const ye=se.trimStart();if(ye.length<fe)return ye;const Ae=/\b/g;let Ce=0;for(;Ae.test(ye)&&!(ye.length-Ae.lastIndex<fe);)Ce=Ae.lastIndex,Ae.lastIndex+=1;return Ce===0?ye:$e+ye.substring(Ce).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(se){let fe=0;for(const $e of se.matchAll(ge))fe!==$e.index&&(yield{isCode:!1,str:se.substring(fe,$e.index)}),yield{isCode:!0,str:$e[0]},fe=$e.index+$e[0].length;fe!==se.length&&(yield{isCode:!1,str:se.substring(fe)})}function Ee(se){return se&&(se=se.replace(ge,"")),se}const pe=/\\\[.*?\\\]/g;function be(se){return Ee(se).replace(pe,"")}e.$5f=String.fromCharCode(a.CharCode.UTF8_BOM);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===a.CharCode.UTF8_BOM)}function Ie(se){return Se(se)?se.substr(1):se}function oe(se,fe){if(!se||!fe||se.length<fe.length)return!1;const $e=fe.length,ye=se.toLowerCase();let Ae=0,Ce=-1;for(;Ae<$e;){const je=ye.indexOf(fe[Ae],Ce+1);if(je<0)return!1;Ce=je,Ae++}return!0}function de(se,fe=!1){return se?(fe&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}function me(se){return se.charAt(0).toUpperCase()+se.slice(1)}function Pe(se,fe=1){if(fe===0)return"";let $e=-1;do $e=se.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?se:(se[$e-1]==="\r"&&$e--,se.substr(0,$e))}function Oe(se){const fe=a.CharCode.Z-a.CharCode.A+1;return se=se%(2*fe),se<fe?String.fromCharCode(a.CharCode.a+se):String.fromCharCode(a.CharCode.A+se-fe)}function Fe(se){return Ue.getInstance().getGraphemeBreakType(se)}function Te(se,fe){return se===Le.Other?fe!==Le.Extend&&fe!==Le.SpacingMark:se===Le.CR&&fe===Le.LF?!1:se===Le.Control||se===Le.CR||se===Le.LF||fe===Le.Control||fe===Le.CR||fe===Le.LF?!0:!(se===Le.L&&(fe===Le.L||fe===Le.V||fe===Le.LV||fe===Le.LVT)||(se===Le.LV||se===Le.V)&&(fe===Le.V||fe===Le.T)||(se===Le.LVT||se===Le.T)&&fe===Le.T||fe===Le.Extend||fe===Le.ZWJ||fe===Le.SpacingMark||se===Le.Prepend||se===Le.ZWJ&&fe===Le.Extended_Pictographic||se===Le.Regional_Indicator&&fe===Le.Regional_Indicator)}var Le;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=qe()}getGraphemeBreakType(fe){if(fe<32)return fe===a.CharCode.LineFeed?Le.LF:fe===a.CharCode.CarriageReturn?Le.CR:Le.Control;if(fe<127)return Le.Other;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(fe<$e[3*Ae])Ae=2*Ae;else if(fe>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return Le.Other}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(se,fe){if(se===0)return 0;const $e=Me(se,fe);if($e!==void 0)return $e;const ye=new re(fe,se);return ye.prevCodePoint(),ye.offset}function Me(se,fe){const $e=new re(fe,se);let ye=$e.prevCodePoint();for(;Be(ye)||ye===ze.emojiVariantSelector||ye===ze.enclosingKeyCap;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!ae(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===ze.zwj&&(Ae=$e.offset),Ae}function Be(se){return 127995<=se&&se<=127999}var ze;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.$cg="\xA0";class We{static{this.c=new N.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$_e({getCacheKey:JSON.stringify},fe=>{function $e(Ve){const _e=new Map;for(let Ye=0;Ye<Ve.length;Ye+=2)_e.set(Ve[Ye],Ve[Ye+1]);return _e}function ye(Ve,_e){const Ye=new Map(Ve);for(const[nt,at]of _e)Ye.set(nt,at);return Ye}function Ae(Ve,_e){if(!Ve)return _e;const Ye=new Map;for(const[nt,at]of Ve)_e.has(nt)&&Ye.set(nt,at);return Ye}const Ce=this.c.value;let je=fe.filter(Ve=>!Ve.startsWith("_")&&Ve in Ce);je.length===0&&(je=["_default"]);let xe;for(const Ve of je){const _e=$e(Ce[Ve]);xe=Ae(xe,_e)}const Je=$e(Ce._common),Qe=ye(Je,xe);return new We(Qe)})}static getInstance(fe){return We.d.get(Array.from(fe))}static{this.e=new N.$X(()=>Object.keys(We.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return We.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}containsAmbiguousCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&this.isAmbiguous(ye))return!0}return!1}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=We;class Ne{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ne.c())),this.d}static isInvisibleCharacter(fe){return Ne.e().has(fe)}static containsInvisibleCharacter(fe){for(let $e=0;$e<fe.length;$e++){const ye=fe.codePointAt($e);if(typeof ye=="number"&&Ne.isInvisibleCharacter(ye))return!0}return!1}static get codePoints(){return Ne.e()}}e.$eg=Ne}),define(le[56],he([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=a,e.$uj=N,e.$vj=O,e.$wj=A,e.$yj=m,P=ke(P);function a(f){return N(f,0)}function N(f,w){switch(typeof f){case"object":return f===null?O(349,w):Array.isArray(f)?L(f,w):p(f,w);case"string":return A(f,w);case"boolean":return T(f,w);case"number":return O(f,w);case"undefined":return O(937,w);default:return O(617,w)}}function O(f,w){return(w<<5)-w+f|0}function T(f,w){return O(f?433:863,w)}function A(f,w){w=O(149417,w);for(let I=0,g=f.length;I<g;I++)w=O(f.charCodeAt(I),w);return w}function L(f,w){return w=O(104579,w),f.reduce((I,g)=>N(g,I),w)}function p(f,w){return w=O(181387,w),Object.keys(f).sort().reduce((I,g)=>(I=A(g,I),N(f[g],I)),w)}class S{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=N(w,this.g),this.g}}e.$xj=S;var d;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function h(f,w,I=32){const g=I-w,u=~((1<<g)-1);return(f<<w|(u&f)>>>g)>>>0}function $(f,w=0,I=f.byteLength,g=0){for(let u=0;u<I;u++)f[w+u]=g}function c(f,w,I="0"){for(;f.length<w;)f=I+f;return f}function m(f,w=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(I=>I.toString(16).padStart(2,"0")).join(""):c((f>>>0).toString(16),w/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(d.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const I=w.length;if(I===0)return;const g=this.p;let u=this.r,t=this.u,s,r;for(t!==0?(s=t,r=-1,t=0):(s=w.charCodeAt(0),r=0);;){let i=s;if(P.$Kf(s))if(r+1<I){const n=w.charCodeAt(r+1);P.$Lf(n)?(r++,i=P.$Mf(s,n)):i=d.UNICODE_REPLACEMENT}else{t=s;break}else P.$Lf(s)&&(i=d.UNICODE_REPLACEMENT);if(u=this.w(g,u,i),r++,r<I)s=w.charCodeAt(r);else break}this.r=u,this.u=t}w(w,I,g){return g<128?w[I++]=g:g<2048?(w[I++]=192|(g&1984)>>>6,w[I++]=128|(g&63)>>>0):g<65536?(w[I++]=224|(g&61440)>>>12,w[I++]=128|(g&4032)>>>6,w[I++]=128|(g&63)>>>0):(w[I++]=240|(g&1835008)>>>18,w[I++]=128|(g&258048)>>>12,w[I++]=128|(g&4032)>>>6,w[I++]=128|(g&63)>>>0),I>=d.BLOCK_SIZE&&(this.y(),I-=d.BLOCK_SIZE,this.t+=d.BLOCK_SIZE,w[0]=w[d.BLOCK_SIZE+0],w[1]=w[d.BLOCK_SIZE+1],w[2]=w[d.BLOCK_SIZE+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,d.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,$(this.p,this.r),this.r>56&&(this.y(),$(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=b.g,I=this.q;for(let l=0;l<64;l+=4)w.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)w.setUint32(l,h(w.getUint32(l-12,!1)^w.getUint32(l-32,!1)^w.getUint32(l-56,!1)^w.getUint32(l-64,!1),1),!1);let g=this.h,u=this.l,t=this.m,s=this.n,r=this.o,i,n,o;for(let l=0;l<80;l++)l<20?(i=u&t|~u&s,n=1518500249):l<40?(i=u^t^s,n=1859775393):l<60?(i=u&t|u&s|t&s,n=2400959708):(i=u^t^s,n=3395469782),o=h(g,5)+i+r+n+w.getUint32(l*4,!1)&4294967295,r=s,s=t,t=h(u,30),u=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.$zj=b}),define(le[92],he([0,1,27]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),P=ke(P);var a;(function(N){N[N.Ignore=0]="Ignore",N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(a||(a={})),function(N){const O="error",T="warning",A="warn",L="info",p="ignore";function S(h){return h?P.$Gf(O,h)?N.Error:P.$Gf(T,h)||P.$Gf(A,h)?N.Warning:P.$Gf(L,h)?N.Info:N.Ignore:N.Ignore}N.fromValue=S;function d(h){switch(h){case N.Error:return O;case N.Warning:return T;case N.Info:return L;default:return p}}N.toString=d}(a||(a={})),e.default=a}),define(le[52],he([0,1,19,39,27]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class O{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const m=c.charCodeAt(0),b=this.b.charCodeAt(this.c);return m-b}value(){return this.b[this.c]}}e.$Hi=O;class T{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===a.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$Af)(c,this.b,0,c.length,this.c,this.d):(0,N.$Cf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=T;class A{constructor(c=!0,m=!0){this.f=c,this.g=m}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let m=c.length-1;m>=0;m--,this.c--){const b=this.b.charCodeAt(m);if(!(b===a.CharCode.Slash||this.f&&b===a.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===a.CharCode.Slash||this.f&&m===a.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$Af)(c,this.b,0,c.length,this.d,this.e):(0,N.$Cf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=A;var L;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(L||(L={}));class p{constructor(c,m){this.f=c,this.g=m,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(L.Scheme),this.c.authority&&this.d.push(L.Authority),this.c.path&&(this.b=new A(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(L.Path)),this.g(c)||(this.c.query&&this.d.push(L.Query),this.c.fragment&&this.d.push(L.Fragment)),this.e=0,this}next(){return this.d[this.e]===L.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===L.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===L.Scheme)return(0,N.$Bf)(c,this.c.scheme);if(this.d[this.e]===L.Authority)return(0,N.$Bf)(c,this.c.authority);if(this.d[this.e]===L.Path)return this.b.cmp(c);if(this.d[this.e]===L.Query)return(0,N.$zf)(c,this.c.query);if(this.d[this.e]===L.Fragment)return(0,N.$zf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===L.Scheme)return this.c.scheme;if(this.d[this.e]===L.Authority)return this.c.authority;if(this.d[this.e]===L.Path)return this.b.value();if(this.d[this.e]===L.Query)return this.c.query;if(this.d[this.e]===L.Fragment)return this.c.fragment;throw new Error}}e.$Ki=p;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(d||(d={}));class h{static forUris(c=()=>!1,m=()=>!1){return new h(new p(c,m))}static forPaths(c=!1){return new h(new A(void 0,!c))}static forStrings(){return new h(new O)}static forConfigKeys(){return new h(new T)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,m){if(m){const b=m.slice(0);(0,P.$Yb)(b);for(const f of b)this.set(f,c)}else{const b=c.slice(0);(0,P.$Yb)(b);for(const f of b)this.set(f[0],f[1])}}set(c,m){const b=this.b.reset(c);let f;this.c||(this.c=new S,this.c.segment=b.value());const w=[];for(f=this.c;;){const g=b.cmp(f.segment);if(g>0)f.left||(f.left=new S,f.left.segment=b.value()),w.push([d.Left,f]),f=f.left;else if(g<0)f.right||(f.right=new S,f.right.segment=b.value()),w.push([d.Right,f]),f=f.right;else if(b.hasNext())b.next(),f.mid||(f.mid=new S,f.mid.segment=b.value()),w.push([d.Mid,f]),f=f.mid;else break}const I=f.value;f.value=m,f.key=c;for(let g=w.length-1;g>=0;g--){const u=w[g][1];u.updateHeight();const t=u.balanceFactor();if(t<-1||t>1){const s=w[g][0],r=w[g+1][0];if(s===d.Right&&r===d.Right)w[g][1]=u.rotateLeft();else if(s===d.Left&&r===d.Left)w[g][1]=u.rotateRight();else if(s===d.Right&&r===d.Left)u.right=w[g+1][1]=w[g+1][1].rotateRight(),w[g][1]=u.rotateLeft();else if(s===d.Left&&r===d.Right)u.left=w[g+1][1]=w[g+1][1].rotateLeft(),w[g][1]=u.rotateRight();else throw new Error;if(g>0)switch(w[g-1][0]){case d.Left:w[g-1][1].left=w[g][1];break;case d.Right:w[g-1][1].right=w[g][1];break;case d.Mid:w[g-1][1].mid=w[g][1];break}else this.c=w[0][1]}}return I}get(c){return this.d(c)?.value}d(c){const m=this.b.reset(c);let b=this.c;for(;b;){const f=m.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(m.hasNext())m.next(),b=b.mid;else break}return b}has(c){const m=this.d(c);return!(m?.value===void 0&&m?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,m){const b=this.b.reset(c),f=[];let w=this.c;for(;w;){const I=b.cmp(w.segment);if(I>0)f.push([d.Left,w]),w=w.left;else if(I<0)f.push([d.Right,w]),w=w.right;else if(b.hasNext())b.next(),f.push([d.Mid,w]),w=w.mid;else break}if(w){if(m?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const I=this.f(w.right);if(I.key){const{key:g,value:u,segment:t}=I;this.e(I.key,!1),w.key=g,w.value=u,w.segment=t}}else{const I=w.left??w.right;if(f.length>0){const[g,u]=f[f.length-1];switch(g){case d.Left:u.left=I;break;case d.Mid:u.mid=I;break;case d.Right:u.right=I;break}}else this.c=I}for(let I=f.length-1;I>=0;I--){const g=f[I][1];g.updateHeight();const u=g.balanceFactor();if(u>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),f[I][1]=g.rotateLeft()):u<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),f[I][1]=g.rotateRight()),I>0)switch(f[I-1][0]){case d.Left:f[I-1][1].left=f[I][1];break;case d.Right:f[I-1][1].right=f[I][1];break;case d.Mid:f[I-1][1].mid=f[I][1];break}else this.c=f[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const m=this.b.reset(c);let b=this.c,f;for(;b;){const w=m.cmp(b.segment);if(w>0)b=b.left;else if(w<0)b=b.right;else if(m.hasNext())m.next(),f=b.value||f,b=b.mid;else break}return b&&b.value||f}findSuperstr(c){return this.g(c,!1)}g(c,m){const b=this.b.reset(c);let f=this.c;for(;f;){const w=b.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(b.hasNext())b.next(),f=f.mid;else return f.mid?this.h(f.mid):m?f.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[m,b]of this)c(b,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const m=[];return this.j(c,m),m[Symbol.iterator]()}j(c,m){c&&(c.left&&this.j(c.left,m),c.value&&m.push([c.key,c.value]),c.mid&&this.j(c.mid,m),c.right&&this.j(c.right,m))}_isBalanced(){const c=m=>{if(!m)return!0;const b=m.balanceFactor();return b<-1||b>1?!1:c(m.left)&&c(m.right)};return c(this.c)}}e.$Li=h}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=a;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function a(N){return P.test(N)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let N;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?N=crypto.getRandomValues.bind(crypto):N=function(A){for(let L=0;L<A.length;L++)A[L]=Math.floor(Math.random()*256);return A};const O=new Uint8Array(16),T=[];for(let A=0;A<256;A++)T.push(A.toString(16).padStart(2,"0"));return function(){N(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let L=0,p="";return p+=T[O[L++]],p+=T[O[L++]],p+=T[O[L++]],p+=T[O[L++]],p+="-",p+=T[O[L++]],p+=T[O[L++]],p+="-",p+=T[O[L++]],p+=T[O[L++]],p+="-",p+=T[O[L++]],p+=T[O[L++]],p+="-",p+=T[O[L++]],p+=T[O[L++]],p+=T[O[L++]],p+=T[O[L++]],p+=T[O[L++]],p+=T[O[L++]],p}}()}),define(le[137],he([0,1,38]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=O;const a=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function N(T){const A=T.replace(/\-/g,":").toLowerCase();return!a.has(A)}function O(){const T=(0,P.networkInterfaces)();for(const A in T){const L=T[A];if(L){for(const{mac:p}of L)if(N(p))return p}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(le[138],he([0,1,276,15]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uX=void 0;class N extends P.Transform{constructor(T){if(super(),typeof T=="number")this.b=T,this.c=1;else{const A=Buffer.isBuffer(T)?T:Buffer.from(T);this.b=A.length===1?A[0]:A,this.c=A.length}}_transform(T,A,L){this.a?this.a=Buffer.concat([this.a,T]):this.a=T;let p=0;for(;p<this.a.length;){const S=typeof this.b=="number"?this.a.indexOf(this.b,p):(0,a.$Pe)(this.a,this.b,p);if(S===-1)break;this.push(this.a.slice(p,S+this.c)),p=S+this.c}this.a=p===this.a.length?void 0:this.a.slice(p),L()}_flush(T){this.a&&this.push(this.a),T()}}e.$uX=N}),define(le[139],he([0,1,66]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=a,e.$6g=O,P=ke(P);function a(A,L,p,S=1){let d=!1;return new Promise(h=>{const $=setTimeout(()=>{if(!d)return d=!0,h(0)},p);N(A,L,S,c=>{if(!d)return d=!0,clearTimeout($),h(c)})})}function N(A,L,p,S){if(L===0)return S(0);const d=new P.Socket;d.once("connect",()=>(T(d),N(A+p,L-1,p,S))),d.once("data",()=>{}),d.once("error",h=>(T(d),h.code!=="ECONNREFUSED"?N(A+p,L-1,p,S):S(A))),d.connect(A,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(A,L,p,S="127.0.0.1"){let d=!1,h,$=1;const c=P.createServer({pauseOnConnect:!0});function m(b,f){d||(d=!0,c.removeAllListeners(),c.close(),h&&clearTimeout(h),f(b))}return new Promise(b=>{h=setTimeout(()=>{m(0,b)},p),c.on("listening",()=>{m(A,b)}),c.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&$<L?(A++,$++,c.listen(A,S)):m(0,b)}),c.on("close",()=>{m(0,b)}),c.listen(A,S)})}function T(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(L){console.error(L)}}}),define(le[140],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MX=P;function P(a){return!!a.parentPort}}),define(le[141],he([12,11]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[67],he([0,1,141]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=p,e.$2m=S,e.$3m=d;const a=60,N=a*60,O=N*24,T=O*7,A=O*30,L=O*365;function p(h,$,c,m){typeof h!="number"&&(h=h.getTime());const b=Math.round((new Date().getTime()-h)/1e3);if(b<-30)return(0,P.localize)(0,null,p(new Date().getTime()+b*1e3,!1));if(!m&&b<30)return(0,P.localize)(1,null);let f;return b<a?(f=b,$?f===1?c?(0,P.localize)(2,null,f):(0,P.localize)(3,null,f):c?(0,P.localize)(4,null,f):(0,P.localize)(5,null,f):f===1?c?(0,P.localize)(6,null,f):(0,P.localize)(7,null,f):c?(0,P.localize)(8,null,f):(0,P.localize)(9,null,f)):b<N?(f=Math.floor(b/a),$?f===1?c?(0,P.localize)(10,null,f):(0,P.localize)(11,null,f):c?(0,P.localize)(12,null,f):(0,P.localize)(13,null,f):f===1?c?(0,P.localize)(14,null,f):(0,P.localize)(15,null,f):c?(0,P.localize)(16,null,f):(0,P.localize)(17,null,f)):b<O?(f=Math.floor(b/N),$?f===1?c?(0,P.localize)(18,null,f):(0,P.localize)(19,null,f):c?(0,P.localize)(20,null,f):(0,P.localize)(21,null,f):f===1?c?(0,P.localize)(22,null,f):(0,P.localize)(23,null,f):c?(0,P.localize)(24,null,f):(0,P.localize)(25,null,f)):b<T?(f=Math.floor(b/O),$?f===1?(0,P.localize)(26,null,f):(0,P.localize)(27,null,f):f===1?(0,P.localize)(28,null,f):(0,P.localize)(29,null,f)):b<A?(f=Math.floor(b/T),$?f===1?c?(0,P.localize)(30,null,f):(0,P.localize)(31,null,f):c?(0,P.localize)(32,null,f):(0,P.localize)(33,null,f):f===1?c?(0,P.localize)(34,null,f):(0,P.localize)(35,null,f):c?(0,P.localize)(36,null,f):(0,P.localize)(37,null,f)):b<L?(f=Math.floor(b/A),$?f===1?c?(0,P.localize)(38,null,f):(0,P.localize)(39,null,f):c?(0,P.localize)(40,null,f):(0,P.localize)(41,null,f):f===1?c?(0,P.localize)(42,null,f):(0,P.localize)(43,null,f):c?(0,P.localize)(44,null,f):(0,P.localize)(45,null,f)):(f=Math.floor(b/L),$?f===1?c?(0,P.localize)(46,null,f):(0,P.localize)(47,null,f):c?(0,P.localize)(48,null,f):(0,P.localize)(49,null,f):f===1?c?(0,P.localize)(50,null,f):(0,P.localize)(51,null,f):c?(0,P.localize)(52,null,f):(0,P.localize)(53,null,f))}function S(h,$){const c=Math.abs(h/1e3);return c<1?$?(0,P.localize)(54,null,h):(0,P.localize)(55,null,h):c<a?$?(0,P.localize)(56,null,Math.round(h)/1e3):(0,P.localize)(57,null,Math.round(h)/1e3):c<N?$?(0,P.localize)(58,null,Math.round(h/(1e3*a))):(0,P.localize)(59,null,Math.round(h/(1e3*a))):c<O?$?(0,P.localize)(60,null,Math.round(h/(1e3*N))):(0,P.localize)(61,null,Math.round(h/(1e3*N))):(0,P.localize)(62,null,Math.round(h/(1e3*O)))}function d(h){return h.getFullYear()+"-"+String(h.getMonth()+1).padStart(2,"0")+"-"+String(h.getDate()).padStart(2,"0")+"T"+String(h.getHours()).padStart(2,"0")+":"+String(h.getMinutes()).padStart(2,"0")+":"+String(h.getSeconds()).padStart(2,"0")+"."+(h.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(le[142],he([12,11]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[41],he([0,1,19,13,142]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=L,e.$rj=p,e.$sj=S,P=ke(P),a=ke(a),N=ke(N);function O(d,h){return h&&(d.stack||d.stacktrace)?N.localize(0,null,A(d),T(d.stack)||T(d.stacktrace)):A(d)}function T(d){return Array.isArray(d)?d.join(`
`):d}function A(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?N.localize(1,null,d.message):d.message||N.localize(2,null)}function L(d=null,h=!1){if(!d)return N.localize(3,null);if(Array.isArray(d)){const $=P.$Jb(d),c=L($[0],h);return $.length>1?N.localize(4,null,c,$.length):c}if(a.$fg(d))return d;if(d.detail){const $=d.detail;if($.error)return O($.error,h);if($.exception)return O($.exception,h)}return d.stack?O(d,h):d.message?d.message:N.localize(5,null)}function p(d){const h=d;return h instanceof Error&&Array.isArray(h.actions)}function S(d,h){let $;return typeof d=="string"?$=new Error(d):$=d,$.actions=h,$}}),define(le[143],he([12,11]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[144],he([0,1,143,34]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=N;function N(O){switch(O){case a.ParseErrorCode.InvalidSymbol:return(0,P.localize)(0,null);case a.ParseErrorCode.InvalidNumberFormat:return(0,P.localize)(1,null);case a.ParseErrorCode.PropertyNameExpected:return(0,P.localize)(2,null);case a.ParseErrorCode.ValueExpected:return(0,P.localize)(3,null);case a.ParseErrorCode.ColonExpected:return(0,P.localize)(4,null);case a.ParseErrorCode.CommaExpected:return(0,P.localize)(5,null);case a.ParseErrorCode.CloseBraceExpected:return(0,P.localize)(6,null);case a.ParseErrorCode.CloseBracketExpected:return(0,P.localize)(7,null);case a.ParseErrorCode.EndOfFileExpected:return(0,P.localize)(8,null);default:return""}}}),define(le[145],he([12,11]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,145]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=y,e.$J=R,P=ke(P),e.$g="en";let a=!1,N=!1,O=!1,T=!1,A=!1,L=!1,p=!1,S=!1,d=!1,h=!1,$,c=e.$g,m=e.$g,b,f;const w=globalThis;let I;typeof w.vscode<"u"&&typeof w.vscode.process<"u"?I=w.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(I=process);const g=typeof I?.versions?.electron=="string",u=g&&I?.type==="renderer";if(typeof I=="object"){a=I.platform==="win32",N=I.platform==="darwin",O=I.platform==="linux",T=O&&!!I.env.SNAP&&!!I.env.SNAP_REVISION,p=g,d=!!I.env.CI||!!I.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$g,c=e.$g;const k=I.env.VSCODE_NLS_CONFIG;if(k)try{const E=JSON.parse(k),v=E.availableLanguages["*"];$=E.locale,m=E.osLocale,c=v||e.$g,b=E._translationsConfigFile}catch{}A=!0}else typeof navigator=="object"&&!u?(f=navigator.userAgent,a=f.indexOf("Windows")>=0,N=f.indexOf("Macintosh")>=0,S=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=f.indexOf("Linux")>=0,h=f?.indexOf("Mobi")>=0,L=!0,$=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,c=$,m=navigator.language):console.error("Unable to resolve platform.");var t;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(k){switch(k){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let r=t.Web;N?r=t.Mac:a?r=t.Windows:O&&(r=t.Linux),e.$i=a,e.$j=N,e.$k=O,e.$l=T,e.$m=A,e.$n=p,e.$o=L,e.$p=L&&typeof w.importScripts=="function",e.$q=e.$p?w.origin:void 0,e.$r=S,e.$s=h,e.$t=d,e.$u=r,e.$v=f,e.$w=c;var i;(function(k){function E(){return e.$w}k.value=E;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}k.isDefaultVariant=v;function C(){return e.$w==="en"}k.isDefault=C})(i||(e.Language=i={})),e.$x=$,e.$y=m,e.$z=b,e.$A=typeof w.postMessage=="function"&&!w.importScripts,e.$B=(()=>{if(e.$A){const k=[];w.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let C=0,U=k.length;C<U;C++){const F=k[C];if(F.id===v.data.vscodeScheduleAsyncWork){k.splice(C,1),F.callback();return}}});let E=0;return v=>{const C=++E;k.push({id:C,callback:v}),w.postMessage({vscodeScheduleAsyncWork:C},"*")}}return k=>setTimeout(k)})();var n;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=N||S?n.Macintosh:a?n.Windows:n.Linux;let o=!0,l=!1;function y(){if(!l){l=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,o=new Uint16Array(k.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function R(k){return parseFloat(k)>=20}}),define(le[36],he([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.process<"u"){const O=N.process;a={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?a={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:a={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=a.cwd,e.env=a.env,e.$fc=a.platform,e.$gc=a.arch}),define(le[146],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bX=T;var a;(function(A){A.UNKNOWN="UNKNOWN",A.CINNAMON="CINNAMON",A.DEEPIN="DEEPIN",A.GNOME="GNOME",A.KDE3="KDE3",A.KDE4="KDE4",A.KDE5="KDE5",A.KDE6="KDE6",A.PANTHEON="PANTHEON",A.UNITY="UNITY",A.XFCE="XFCE",A.UKUI="UKUI",A.LXQT="LXQT"})(a||(a={}));const N="XDG_CURRENT_DESKTOP",O="KDE_SESSION_VERSION";function T(){const A=P.env[N];if(A){const p=A.split(":").map(S=>S.trim()).filter(S=>S.length>0);for(const S of p)switch(S){case"Unity":{const d=P.env.DESKTOP_SESSION;return d&&d.includes("gnome-fallback")?a.GNOME:a.UNITY}case"Deepin":return a.DEEPIN;case"GNOME":return a.GNOME;case"X-Cinnamon":return a.CINNAMON;case"KDE":{const d=P.env[O];return d==="5"?a.KDE5:d==="6"?a.KDE6:a.KDE4}case"Pantheon":return a.PANTHEON;case"XFCE":return a.XFCE;case"UKUI":return a.UKUI;case"LXQt":return a.LXQT}}const L=P.env.DESKTOP_SESSION;if(L)switch(L){case"deepin":return a.DEEPIN;case"gnome":case"mate":return a.GNOME;case"kde4":case"kde-plasma":return a.KDE4;case"kde":return O in P.env?a.KDE4:a.KDE3;case"xfce":case"xubuntu":return a.XFCE;case"ukui":return a.UKUI}return"GNOME_DESKTOP_SESSION_ID"in P.env?a.GNOME:"KDE_FULL_SESSION"in P.env?O in P.env?a.KDE4:a.KDE3:a.UNKNOWN}}),define(le[14],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,P=ke(P);const a=65,N=97,O=90,T=122,A=46,L=47,p=92,S=58,d=63;class h extends Error{constructor(s,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const o=s.indexOf(".")!==-1?"property":"argument";let l=`The "${s}" ${o} ${n} of type ${r}`;l+=`. Received type ${typeof i}`,super(l),this.code="ERR_INVALID_ARG_TYPE"}}function $(t,s){if(t===null||typeof t!="object")throw new h(s,"Object",t)}function c(t,s){if(typeof t!="string")throw new h(s,"string",t)}const m=P.$fc==="win32";function b(t){return t===L||t===p}function f(t){return t===L}function w(t){return t>=a&&t<=O||t>=N&&t<=T}function I(t,s,r,i){let n="",o=0,l=-1,y=0,R=0;for(let k=0;k<=t.length;++k){if(k<t.length)R=t.charCodeAt(k);else{if(i(R))break;R=L}if(i(R)){if(!(l===k-1||y===1))if(y===2){if(n.length<2||o!==2||n.charCodeAt(n.length-1)!==A||n.charCodeAt(n.length-2)!==A){if(n.length>2){const E=n.lastIndexOf(r);E===-1?(n="",o=0):(n=n.slice(0,E),o=n.length-1-n.lastIndexOf(r)),l=k,y=0;continue}else if(n.length!==0){n="",o=0,l=k,y=0;continue}}s&&(n+=n.length>0?`${r}..`:"..",o=2)}else n.length>0?n+=`${r}${t.slice(l+1,k)}`:n=t.slice(l+1,k),o=k-l-1;l=k,y=0}else R===A&&y!==-1?++y:y=-1}return n}function g(t,s){$(s,"pathObject");const r=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${i}`:`${r}${t}${i}`:i}e.$hc={resolve(...t){let s="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let o;if(n>=0){if(o=t[n],c(o,"path"),o.length===0)continue}else s.length===0?o=P.cwd():(o=P.env[`=${s}`]||P.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==s.toLowerCase()&&o.charCodeAt(2)===p)&&(o=`${s}\\`));const l=o.length;let y=0,R="",k=!1;const E=o.charCodeAt(0);if(l===1)b(E)&&(y=1,k=!0);else if(b(E))if(k=!0,b(o.charCodeAt(1))){let v=2,C=v;for(;v<l&&!b(o.charCodeAt(v));)v++;if(v<l&&v!==C){const U=o.slice(C,v);for(C=v;v<l&&b(o.charCodeAt(v));)v++;if(v<l&&v!==C){for(C=v;v<l&&!b(o.charCodeAt(v));)v++;(v===l||v!==C)&&(R=`\\\\${U}\\${o.slice(C,v)}`,y=v)}}}else y=1;else w(E)&&o.charCodeAt(1)===S&&(R=o.slice(0,2),y=2,l>2&&b(o.charCodeAt(2))&&(k=!0,y=3));if(R.length>0)if(s.length>0){if(R.toLowerCase()!==s.toLowerCase())continue}else s=R;if(i){if(s.length>0)break}else if(r=`${o.slice(y)}\\${r}`,i=k,k&&s.length>0)break}return r=I(r,!i,"\\",b),i?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){c(t,"path");const s=t.length;if(s===0)return".";let r=0,i,n=!1;const o=t.charCodeAt(0);if(s===1)return f(o)?"\\":t;if(b(o))if(n=!0,b(t.charCodeAt(1))){let y=2,R=y;for(;y<s&&!b(t.charCodeAt(y));)y++;if(y<s&&y!==R){const k=t.slice(R,y);for(R=y;y<s&&b(t.charCodeAt(y));)y++;if(y<s&&y!==R){for(R=y;y<s&&!b(t.charCodeAt(y));)y++;if(y===s)return`\\\\${k}\\${t.slice(R)}\\`;y!==R&&(i=`\\\\${k}\\${t.slice(R,y)}`,r=y)}}}else r=1;else w(o)&&t.charCodeAt(1)===S&&(i=t.slice(0,2),r=2,s>2&&b(t.charCodeAt(2))&&(n=!0,r=3));let l=r<s?I(t.slice(r),!n,"\\",b):"";return l.length===0&&!n&&(l="."),l.length>0&&b(t.charCodeAt(s-1))&&(l+="\\"),i===void 0?n?`\\${l}`:l:n?`${i}\\${l}`:`${i}${l}`},isAbsolute(t){c(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return b(r)||s>2&&w(r)&&t.charCodeAt(1)===S&&b(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let o=0;o<t.length;++o){const l=t[o];c(l,"path"),l.length>0&&(s===void 0?s=r=l:s+=`\\${l}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&b(r.charCodeAt(0))){++n;const o=r.length;o>1&&b(r.charCodeAt(1))&&(++n,o>2&&(b(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&b(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$hc.normalize(s)},relative(t,s){if(c(t,"from"),c(s,"to"),t===s)return"";const r=e.$hc.resolve(t),i=e.$hc.resolve(s);if(r===i||(t=r.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===p;)n++;let o=t.length;for(;o-1>n&&t.charCodeAt(o-1)===p;)o--;const l=o-n;let y=0;for(;y<s.length&&s.charCodeAt(y)===p;)y++;let R=s.length;for(;R-1>y&&s.charCodeAt(R-1)===p;)R--;const k=R-y,E=l<k?l:k;let v=-1,C=0;for(;C<E;C++){const F=t.charCodeAt(n+C);if(F!==s.charCodeAt(y+C))break;F===p&&(v=C)}if(C!==E){if(v===-1)return i}else{if(k>E){if(s.charCodeAt(y+C)===p)return i.slice(y+C+1);if(C===2)return i.slice(y+C)}l>E&&(t.charCodeAt(n+C)===p?v=C:C===2&&(v=3)),v===-1&&(v=0)}let U="";for(C=n+v+1;C<=o;++C)(C===o||t.charCodeAt(C)===p)&&(U+=U.length===0?"..":"\\..");return y+=v,U.length>0?`${U}${i.slice(y,R)}`:(i.charCodeAt(y)===p&&++y,i.slice(y,R))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$hc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===p){if(s.charCodeAt(1)===p){const r=s.charCodeAt(2);if(r!==d&&r!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(w(s.charCodeAt(0))&&s.charCodeAt(1)===S&&s.charCodeAt(2)===p)return`\\\\?\\${s}`;return t},dirname(t){c(t,"path");const s=t.length;if(s===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(s===1)return b(n)?t:".";if(b(n)){if(r=i=1,b(t.charCodeAt(1))){let y=2,R=y;for(;y<s&&!b(t.charCodeAt(y));)y++;if(y<s&&y!==R){for(R=y;y<s&&b(t.charCodeAt(y));)y++;if(y<s&&y!==R){for(R=y;y<s&&!b(t.charCodeAt(y));)y++;if(y===s)return t;y!==R&&(r=i=y+1)}}}}else w(n)&&t.charCodeAt(1)===S&&(r=s>2&&b(t.charCodeAt(2))?3:2,i=r);let o=-1,l=!0;for(let y=s-1;y>=i;--y)if(b(t.charCodeAt(y))){if(!l){o=y;break}}else l=!1;if(o===-1){if(r===-1)return".";o=r}return t.slice(0,o)},basename(t,s){s!==void 0&&c(s,"ext"),c(t,"path");let r=0,i=-1,n=!0,o;if(t.length>=2&&w(t.charCodeAt(0))&&t.charCodeAt(1)===S&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let l=s.length-1,y=-1;for(o=t.length-1;o>=r;--o){const R=t.charCodeAt(o);if(b(R)){if(!n){r=o+1;break}}else y===-1&&(n=!1,y=o+1),l>=0&&(R===s.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=y))}return r===i?i=y:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=r;--o)if(b(t.charCodeAt(o))){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){c(t,"path");let s=0,r=-1,i=0,n=-1,o=!0,l=0;t.length>=2&&t.charCodeAt(1)===S&&w(t.charCodeAt(0))&&(s=i=2);for(let y=t.length-1;y>=s;--y){const R=t.charCodeAt(y);if(b(R)){if(!o){i=y+1;break}continue}n===-1&&(o=!1,n=y+1),R===A?r===-1?r=y:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||n===-1||l===0||l===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:g.bind(null,"\\"),parse(t){c(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return b(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(b(n)){if(i=1,b(t.charCodeAt(1))){let v=2,C=v;for(;v<r&&!b(t.charCodeAt(v));)v++;if(v<r&&v!==C){for(C=v;v<r&&b(t.charCodeAt(v));)v++;if(v<r&&v!==C){for(C=v;v<r&&!b(t.charCodeAt(v));)v++;v===r?i=v:v!==C&&(i=v+1)}}}}else if(w(n)&&t.charCodeAt(1)===S){if(r<=2)return s.root=s.dir=t,s;if(i=2,b(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let o=-1,l=i,y=-1,R=!0,k=t.length-1,E=0;for(;k>=i;--k){if(n=t.charCodeAt(k),b(n)){if(!R){l=k+1;break}continue}y===-1&&(R=!1,y=k+1),n===A?o===-1?o=k:E!==1&&(E=1):o!==-1&&(E=-1)}return y!==-1&&(o===-1||E===0||E===1&&o===y-1&&o===l+1?s.base=s.name=t.slice(l,y):(s.name=t.slice(l,o),s.base=t.slice(l,y),s.ext=t.slice(o,y))),l>0&&l!==i?s.dir=t.slice(0,l-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(m){const t=/\\/g;return()=>{const s=P.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>P.cwd()})();e.$ic={resolve(...t){let s="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();c(n,"path"),n.length!==0&&(s=`${n}/${s}`,r=n.charCodeAt(0)===L)}return s=I(s,!r,"/",f),r?`/${s}`:s.length>0?s:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===L,r=t.charCodeAt(t.length-1)===L;return t=I(t,!s,"/",f),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===L},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const i=t[r];c(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$ic.normalize(s)},relative(t,s){if(c(t,"from"),c(s,"to"),t===s||(t=e.$ic.resolve(t),s=e.$ic.resolve(s),t===s))return"";const r=1,i=t.length,n=i-r,o=1,l=s.length-o,y=n<l?n:l;let R=-1,k=0;for(;k<y;k++){const v=t.charCodeAt(r+k);if(v!==s.charCodeAt(o+k))break;v===L&&(R=k)}if(k===y)if(l>y){if(s.charCodeAt(o+k)===L)return s.slice(o+k+1);if(k===0)return s.slice(o+k)}else n>y&&(t.charCodeAt(r+k)===L?R=k:k===0&&(R=0));let E="";for(k=r+R+1;k<=i;++k)(k===i||t.charCodeAt(k)===L)&&(E+=E.length===0?"..":"/..");return`${E}${s.slice(o+R)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===L;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===L){if(!i){r=n;break}}else i=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&c(s,"ext"),c(t,"path");let r=0,i=-1,n=!0,o;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let l=s.length-1,y=-1;for(o=t.length-1;o>=0;--o){const R=t.charCodeAt(o);if(R===L){if(!n){r=o+1;break}}else y===-1&&(n=!1,y=o+1),l>=0&&(R===s.charCodeAt(l)?--l===-1&&(i=o):(l=-1,i=y))}return r===i?i=y:i===-1&&(i=t.length),t.slice(r,i)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===L){if(!n){r=o+1;break}}else i===-1&&(n=!1,i=o+1);return i===-1?"":t.slice(r,i)},extname(t){c(t,"path");let s=-1,r=0,i=-1,n=!0,o=0;for(let l=t.length-1;l>=0;--l){const y=t.charCodeAt(l);if(y===L){if(!n){r=l+1;break}continue}i===-1&&(n=!1,i=l+1),y===A?s===-1?s=l:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===r+1?"":t.slice(s,i)},format:g.bind(null,"/"),parse(t){c(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===L;let i;r?(s.root="/",i=1):i=0;let n=-1,o=0,l=-1,y=!0,R=t.length-1,k=0;for(;R>=i;--R){const E=t.charCodeAt(R);if(E===L){if(!y){o=R+1;break}continue}l===-1&&(y=!1,l=R+1),E===A?n===-1?n=R:k!==1&&(k=1):n!==-1&&(k=-1)}if(l!==-1){const E=o===0&&r?1:o;n===-1||k===0||k===1&&n===l-1&&n===o+1?s.base=s.name=t.slice(E,l):(s.name=t.slice(E,n),s.base=t.slice(E,l),s.ext=t.slice(n,l))}return o>0?s.dir=t.slice(0,o-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=m?e.$hc.normalize:e.$ic.normalize,e.$kc=m?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=m?e.$hc.join:e.$ic.join,e.$mc=m?e.$hc.resolve:e.$ic.resolve,e.$nc=m?e.$hc.relative:e.$ic.relative,e.$oc=m?e.$hc.dirname:e.$ic.dirname,e.$pc=m?e.$hc.basename:e.$ic.basename,e.$qc=m?e.$hc.extname:e.$ic.extname,e.$rc=m?e.$hc.format:e.$ic.format,e.$sc=m?e.$hc.parse:e.$ic.parse,e.$tc=m?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=m?e.$hc.sep:e.$ic.sep,e.$vc=m?e.$hc.delimiter:e.$ic.delimiter}),define(le[42],he([0,1,39,14,5,27,13]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=A,e.$yg=L,e.$zg=p,e.$Ag=S,e.$Bg=d,e.$Cg=m,e.$Dg=b,e.$Eg=f,e.$Fg=w,e.$Gg=I,e.$Hg=g,e.$Ig=u,e.$Jg=t,e.$Kg=s,e.$Lg=r,e.$Mg=i,e.$Ng=l;function A(y){return y===P.CharCode.Slash||y===P.CharCode.Backslash}function L(y){return y.replace(/[\\/]/g,a.$ic.sep)}function p(y){return y.indexOf("/")===-1&&(y=L(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function S(y,R=a.$ic.sep){if(!y)return"";const k=y.length,E=y.charCodeAt(0);if(A(E)){if(A(y.charCodeAt(1))&&!A(y.charCodeAt(2))){let C=3;const U=C;for(;C<k&&!A(y.charCodeAt(C));C++);if(U!==C&&!A(y.charCodeAt(C+1))){for(C+=1;C<k;C++)if(A(y.charCodeAt(C)))return y.slice(0,C+1).replace(/[\\/]/g,R)}}return R}else if(w(E)&&y.charCodeAt(1)===P.CharCode.Colon)return A(y.charCodeAt(2))?y.slice(0,2)+R:y.slice(0,2);let v=y.indexOf("://");if(v!==-1){for(v+=3;v<k;v++)if(A(y.charCodeAt(v)))return y.slice(0,v+1)}return""}function d(y){if(!N.$i||!y||y.length<5)return!1;let R=y.charCodeAt(0);if(R!==P.CharCode.Backslash||(R=y.charCodeAt(1),R!==P.CharCode.Backslash))return!1;let k=2;const E=k;for(;k<y.length&&(R=y.charCodeAt(k),R!==P.CharCode.Backslash);k++);return!(E===k||(R=y.charCodeAt(k+1),isNaN(R)||R===P.CharCode.Backslash))}const h=/[\\/:\*\?"<>\|]/g,$=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(y,R=N.$i){const k=R?h:$;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||R&&c.test(y)||y==="."||y===".."||R&&y[y.length-1]==="."||R&&y.length!==y.trim().length||y.length>255)}function b(y,R,k){const E=y===R;return!k||E?E:!y||!R?!1:(0,O.$Gf)(y,R)}function f(y,R,k,E=a.sep){if(y===R)return!0;if(!y||!R||R.length>y.length)return!1;if(k){if(!(0,O.$Hf)(y,R))return!1;if(R.length===y.length)return!0;let C=R.length;return R.charAt(R.length-1)===E&&C--,y.charAt(C)===E}return R.charAt(R.length-1)!==E&&(R+=E),y.indexOf(R)===0}function w(y){return y>=P.CharCode.A&&y<=P.CharCode.Z||y>=P.CharCode.a&&y<=P.CharCode.z}function I(y,R){return N.$i&&y.endsWith(":")&&(y+=a.sep),(0,a.$kc)(y)||(y=(0,a.$lc)(R,y)),y=(0,a.$jc)(y),g(y)}function g(y){return N.$i?(y=(0,O.$of)(y,a.sep),y.endsWith(":")&&(y+=a.sep)):(y=(0,O.$of)(y,a.sep),y||(y=a.sep)),y}function u(y){const R=(0,a.$jc)(y);return N.$i?y.length>3?!1:t(R)&&(y.length===2||R.charCodeAt(2)===P.CharCode.Backslash):R===a.$ic.sep}function t(y,R=N.$i){return R?w(y.charCodeAt(0))&&y.charCodeAt(1)===P.CharCode.Colon:!1}function s(y,R=N.$i){return t(y,R)?y[0]:void 0}function r(y,R,k){return R.length>y.length?-1:y===R?0:(k&&(y=y.toLowerCase(),R=R.toLowerCase()),y.indexOf(R))}function i(y){const R=y.split(":");let k,E,v;for(const C of R){const U=Number(C);(0,T.$jg)(U)?E===void 0?E=U:v===void 0&&(v=U):k=k?[k,C].join(":"):C}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:E!==void 0?E:void 0,column:v!==void 0?v:E!==void 0?1:void 0}}const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l(y,R,k=8){let E="";for(let C=0;C<k;C++){let U;C===0&&N.$i&&!R&&(k===3||k===4)?U=o:U=n,E+=U.charAt(Math.floor(Math.random()*U.length))}let v;return R?v=`${R}-${E}`:v=E,y?(0,a.$lc)(y,v):v}}),define(le[147],he([0,1,14]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$6s=O,e.$7s=T,e.$8s=A,e.$9s=p,e.$5s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const a={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},N={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(S){const d=(0,P.$qc)(S),h=a[d.toLowerCase()];return h!==void 0?h:T(S)}function T(S){const d=(0,P.$qc)(S);return N[d.toLowerCase()]}function A(S){for(const d in N)if(N[d]===S)return d}const L=/^(.+)\/(.+?)(;.+)?$/;function p(S,d){const h=L.exec(S);return h?`${h[1].toLowerCase()}/${h[2].toLowerCase()}${h[3]??""}`:d?void 0:S}}),define(le[93],he([0,1,5]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=O,e.$lm=T;var a;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(a||(e.Source=a={}));var N;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(N||(e.TerminateResponseCode=N={}));function O(A,...L){const p=L.reduce((h,$)=>(h[$]=!0,h),{}),S=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(h=>!p[h]).forEach(h=>{for(let $=0;$<S.length;$++)if(h.search(S[$])!==-1){delete A[h];break}})}function T(A){A&&(delete A.DEBUG,P.$j&&delete A.DYLD_LIBRARY_PATH,P.$k&&delete A.LD_PRELOAD)}}),define(le[9],he([0,1,39,65,14,5]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=b,e.$yc=t,N=ke(N);const T=/^\w[\w\d+.-]*$/,A=/^\//,L=/^\/\//;function p(o,l){if(!o.scheme&&l)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!T.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!A.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(o,l){return!o&&!l?"file":o}function d(o,l){switch(o){case"https":case"http":case"file":l?l[0]!==$&&(l=$+l):l=$;break}return l}const h="",$="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(l){return l instanceof m?!0:l?typeof l.authority=="string"&&typeof l.fragment=="string"&&typeof l.path=="string"&&typeof l.query=="string"&&typeof l.scheme=="string"&&typeof l.fsPath=="string"&&typeof l.with=="function"&&typeof l.toString=="function":!1}constructor(l,y,R,k,E,v=!1){typeof l=="object"?(this.scheme=l.scheme||h,this.authority=l.authority||h,this.path=l.path||h,this.query=l.query||h,this.fragment=l.fragment||h):(this.scheme=S(l,v),this.authority=y||h,this.path=d(this.scheme,R||h),this.query=k||h,this.fragment=E||h,p(this,v))}get fsPath(){return t(this,!1)}with(l){if(!l)return this;let{scheme:y,authority:R,path:k,query:E,fragment:v}=l;return y===void 0?y=this.scheme:y===null&&(y=h),R===void 0?R=this.authority:R===null&&(R=h),k===void 0?k=this.path:k===null&&(k=h),E===void 0?E=this.query:E===null&&(E=h),v===void 0?v=this.fragment:v===null&&(v=h),y===this.scheme&&R===this.authority&&k===this.path&&E===this.query&&v===this.fragment?this:new w(y,R,k,E,v)}static parse(l,y=!1){const R=c.exec(l);return R?new w(R[2]||h,n(R[4]||h),n(R[5]||h),n(R[7]||h),n(R[9]||h),y):new w(h,h,h,h,h)}static file(l){let y=h;if(O.$i&&(l=l.replace(/\\/g,$)),l[0]===$&&l[1]===$){const R=l.indexOf($,2);R===-1?(y=l.substring(2),l=$):(y=l.substring(2,R),l=l.substring(R)||$)}return new w("file",y,l,h,h)}static from(l,y){return new w(l.scheme,l.authority,l.path,l.query,l.fragment,y)}static joinPath(l,...y){if(!l.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return O.$i&&l.scheme==="file"?R=m.file(N.$hc.join(t(l,!0),...y)).path:R=N.$ic.join(l.path,...y),l.with({path:R})}toString(l=!1){return s(this,l)}toJSON(){return this}static revive(l){if(l){if(l instanceof m)return l;{const y=new w(l);return y._formatted=l.external??null,y._fsPath=l._sep===f?l.fsPath??null:null,y}}else return l}}e.URI=m;function b(o){return!o||typeof o!="object"?!1:typeof o.scheme=="string"&&(typeof o.authority=="string"||typeof o.authority>"u")&&(typeof o.path=="string"||typeof o.path>"u")&&(typeof o.query=="string"||typeof o.query>"u")&&(typeof o.fragment=="string"||typeof o.fragment>"u")}const f=O.$i?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(l=!1){return l?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const l={$mid:a.MarshalledId.Uri};return this._fsPath&&(l.fsPath=this._fsPath,l._sep=f),this._formatted&&(l.external=this._formatted),this.path&&(l.path=this.path),this.scheme&&(l.scheme=this.scheme),this.authority&&(l.authority=this.authority),this.query&&(l.query=this.query),this.fragment&&(l.fragment=this.fragment),l}}const I={[P.CharCode.Colon]:"%3A",[P.CharCode.Slash]:"%2F",[P.CharCode.QuestionMark]:"%3F",[P.CharCode.Hash]:"%23",[P.CharCode.OpenSquareBracket]:"%5B",[P.CharCode.CloseSquareBracket]:"%5D",[P.CharCode.AtSign]:"%40",[P.CharCode.ExclamationMark]:"%21",[P.CharCode.DollarSign]:"%24",[P.CharCode.Ampersand]:"%26",[P.CharCode.SingleQuote]:"%27",[P.CharCode.OpenParen]:"%28",[P.CharCode.CloseParen]:"%29",[P.CharCode.Asterisk]:"%2A",[P.CharCode.Plus]:"%2B",[P.CharCode.Comma]:"%2C",[P.CharCode.Semicolon]:"%3B",[P.CharCode.Equals]:"%3D",[P.CharCode.Space]:"%20"};function g(o,l,y){let R,k=-1;for(let E=0;E<o.length;E++){const v=o.charCodeAt(E);if(v>=P.CharCode.a&&v<=P.CharCode.z||v>=P.CharCode.A&&v<=P.CharCode.Z||v>=P.CharCode.Digit0&&v<=P.CharCode.Digit9||v===P.CharCode.Dash||v===P.CharCode.Period||v===P.CharCode.Underline||v===P.CharCode.Tilde||l&&v===P.CharCode.Slash||y&&v===P.CharCode.OpenSquareBracket||y&&v===P.CharCode.CloseSquareBracket||y&&v===P.CharCode.Colon)k!==-1&&(R+=encodeURIComponent(o.substring(k,E)),k=-1),R!==void 0&&(R+=o.charAt(E));else{R===void 0&&(R=o.substr(0,E));const C=I[v];C!==void 0?(k!==-1&&(R+=encodeURIComponent(o.substring(k,E)),k=-1),R+=C):k===-1&&(k=E)}}return k!==-1&&(R+=encodeURIComponent(o.substring(k))),R!==void 0?R:o}function u(o){let l;for(let y=0;y<o.length;y++){const R=o.charCodeAt(y);R===P.CharCode.Hash||R===P.CharCode.QuestionMark?(l===void 0&&(l=o.substr(0,y)),l+=I[R]):l!==void 0&&(l+=o[y])}return l!==void 0?l:o}function t(o,l){let y;return o.authority&&o.path.length>1&&o.scheme==="file"?y=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===P.CharCode.Slash&&(o.path.charCodeAt(1)>=P.CharCode.A&&o.path.charCodeAt(1)<=P.CharCode.Z||o.path.charCodeAt(1)>=P.CharCode.a&&o.path.charCodeAt(1)<=P.CharCode.z)&&o.path.charCodeAt(2)===P.CharCode.Colon?l?y=o.path.substr(1):y=o.path[1].toLowerCase()+o.path.substr(2):y=o.path,O.$i&&(y=y.replace(/\//g,"\\")),y}function s(o,l){const y=l?u:g;let R="",{scheme:k,authority:E,path:v,query:C,fragment:U}=o;if(k&&(R+=k,R+=":"),(E||k==="file")&&(R+=$,R+=$),E){let F=E.indexOf("@");if(F!==-1){const M=E.substr(0,F);E=E.substr(F+1),F=M.lastIndexOf(":"),F===-1?R+=y(M,!1,!1):(R+=y(M.substr(0,F),!1,!1),R+=":",R+=y(M.substr(F+1),!1,!0)),R+="@"}E=E.toLowerCase(),F=E.lastIndexOf(":"),F===-1?R+=y(E,!1,!0):(R+=y(E.substr(0,F),!1,!0),R+=E.substr(F))}if(v){if(v.length>=3&&v.charCodeAt(0)===P.CharCode.Slash&&v.charCodeAt(2)===P.CharCode.Colon){const F=v.charCodeAt(1);F>=P.CharCode.A&&F<=P.CharCode.Z&&(v=`/${String.fromCharCode(F+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===P.CharCode.Colon){const F=v.charCodeAt(0);F>=P.CharCode.A&&F<=P.CharCode.Z&&(v=`${String.fromCharCode(F+32)}:${v.substr(2)}`)}R+=y(v,!0,!1)}return C&&(R+="?",R+=y(C,!1,!1)),U&&(R+="#",R+=l?U:g(U,!1,!1)),R}function r(o){try{return decodeURIComponent(o)}catch{return o.length>3?o.substr(0,3)+r(o.substr(3)):o}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(o){return o.match(i)?o.replace(i,l=>r(l)):o}}),define(le[148],he([0,1,9]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=a,e.$$q=N,e.$_q=O,e.log=A;function a(p){const S=p;return S&&typeof S.type=="string"&&typeof S.severity=="string"}function N(p){const S=[];let d;try{const h=JSON.parse(p.arguments),$=h[h.length-1];$&&$.__$stack&&(h.pop(),d=$.__$stack),S.push(...h)}catch{S.push("Unable to log remote console arguments",p.arguments)}return{args:S,stack:d}}function O(p){if(typeof p!="string")return O(N(p).stack);const S=p;if(S){const d=T(S),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(h&&h.length===4)return{uri:P.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}function T(p){if(!p)return p;const S=p.indexOf(`
`);return S===-1?p:p.substring(0,S)}function A(p,S){const{args:d,stack:h}=N(p),$=typeof d[0]=="string"&&d.length===1;let c=T(h);c&&(c=`(${c.trim()})`);let m=[];if(typeof d[0]=="string"?c&&$?m=[`%c[${S}] %c${d[0]} %c${c}`,L("blue"),L(""),L("grey")]:m=[`%c[${S}] %c${d[0]}`,L("blue"),L(""),...d.slice(1)]:m=[`%c[${S}]%`,L("blue"),...d],c&&!$&&m.push(c),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,m)}function L(p){return`color: ${p}`}}),define(le[68],he([0,1,15,9,65]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=O,e.$bi=T,e.$ci=L;function O(p){return JSON.stringify(p,A)}function T(p){let S=JSON.parse(p);return S=L(S),S}function A(p,S){return S instanceof RegExp?{$mid:N.MarshalledId.Regexp,source:S.source,flags:S.flags}:S}function L(p,S=0){if(!p||S>200)return p;if(typeof p=="object"){switch(p.$mid){case N.MarshalledId.Uri:return a.URI.revive(p);case N.MarshalledId.Regexp:return new RegExp(p.source,p.flags);case N.MarshalledId.Date:return new Date(p.source)}if(p instanceof P.$Oe||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let d=0;d<p.length;++d)p[d]=L(p[d],S+1);else for(const d in p)Object.hasOwnProperty.call(p,d)&&(p[d]=L(p[d],S+1))}return p}}),define(le[23],he([0,1,8,5,27,9,14]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=L,e.$Pg=p,e.$Tg=d,P=ke(P),a=ke(a),T=ke(T);var A;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(A||(e.Schemas=A={}));function L(c,m){return O.URI.isUri(c)?(0,N.$Gf)(c.scheme,m):(0,N.$Hf)(c,m+":")}function p(c,...m){return m.some(b=>L(c,b))}e.$Qg="vscode-tkn",e.$Rg="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m,b){this.f=d(m,b)}getServerRootPath(){return this.f}get g(){return T.$ic.join(this.f,A.vscodeRemoteResource)}set(m,b,f){this.a[m]=b,this.b[m]=f}setConnectionToken(m,b){this.c[m]=b}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(u){return P.$3(u),m}const b=m.authority;let f=this.a[b];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const w=this.b[b],I=this.c[b];let g=`path=${encodeURIComponent(m.path)}`;return typeof I=="string"&&(g+=`&${e.$Rg}=${encodeURIComponent(I)}`),O.URI.from({scheme:a.$o?this.d:A.vscodeRemoteResource,authority:`${f}:${w}`,path:this.g,query:g})}}e.$Sg=new S;function d(c,m){return T.$ic.join(m??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class h{static{this.a=e.$Yg}asBrowserUri(m){const b=this.b(m,ne);return this.uriToBrowserUri(b)}uriToBrowserUri(m){return m.scheme===A.vscodeRemote?e.$Sg.rewrite(m):m.scheme===A.file&&(a.$m||a.$q===`${A.vscodeFileResource}://${h.a}`)?m.with({scheme:A.vscodeFileResource,authority:m.authority||h.a,query:null,fragment:null}):m}asFileUri(m){const b=this.b(m,ne);return this.uriToFileUri(b)}uriToFileUri(m){return m.scheme===A.vscodeFileResource?m.with({scheme:A.file,authority:m.authority!==h.a?m.authority:null,query:null,fragment:null}):m}b(m,b){return O.URI.isUri(m)?m:O.URI.parse(b.toUrl(m))}}e.$Zg=new h;var $;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const b="vscode-coi";function f(I){let g;typeof I=="string"?g=new URL(I).searchParams:I instanceof URL?g=I.searchParams:O.URI.isUri(I)&&(g=new URL(I.toString(!0)).searchParams);const u=g?.get(b);if(u)return m.get(u)}c.getHeadersFromQuery=f;function w(I,g,u){if(!globalThis.crossOriginIsolated)return;const t=g&&u?"3":u?"2":"1";I instanceof URLSearchParams?I.set(b,t):I[b]=t}c.addSearchParam=w})($||(e.COI=$={}))}),define(le[149],he([0,1,129,23,5,9]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pE=S,N=ke(N);class T{constructor(h,$,c){this.id=h,this.dependencies=$,this.callback=c}}class A{static{this.INSTANCE=new A}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(h,$,c)=>{typeof h!="string"&&(c=$,$=h,h=null),(typeof $!="object"||!Array.isArray($))&&(c=$,$=null),this.c.push(new T(h,$,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){if(h.startsWith(window.location.origin)||h.startsWith("vscode-file://vscode-app"))return h;throw new Error(`[trusted_script_src] Invalid script url: ${h}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(h){return h}})))}async load(h){this.g();const $=await(this.a?this.i(h):this.b?this.h(h):this.j(h));if(!$)throw new Error(`Did not receive a define call from script ${h}`);if(Array.isArray($.dependencies)&&$.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${h}. The dependencies are: ${$.dependencies.join(", ")}`);return typeof $.callback=="function"?$.callback([]):$.callback}h(h){return new Promise(($,c)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const b=()=>{m.removeEventListener("load",f),m.removeEventListener("error",w)},f=I=>{b(),$(this.c.pop())},w=I=>{b(),c(I)};m.addEventListener("load",f),m.addEventListener("error",w),this.f&&(h=this.f.createScriptURL(h)),m.setAttribute("src",h),window.document.getElementsByTagName("head")[0].appendChild(m)})}i(h){return new Promise(($,c)=>{try{this.f&&(h=this.f.createScriptURL(h)),importScripts(h),$(this.c.pop())}catch(m){c(m)}})}async j(h){try{const $=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,b=O.URI.parse(h).fsPath,f=$.readFileSync(b).toString(),w=m.wrap(f.replace(/^#!.*/,""));return new c.Script(w).runInThisContext().apply(),this.c.pop()}catch($){throw $}}}const L=new Map;let p={};typeof globalThis.require=="object"&&(p=globalThis.require.paths??{});async function S(d,h,$){if(P.$V){$===void 0&&($=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),p[d]&&(d=p[d]);const c=`${d}/${h}`;if(L.has(c))return L.get(c);let m;if(/^\w[\w\d+.-]*:\/\//.test(c))m=c;else{const I=`${$&&!N.$o?a.$Wg:a.$Vg}/${c}`;m=a.$Zg.asBrowserUri(I).toString(!0)}const b=A.INSTANCE.load(m);return L.set(c,b),b}else return await new Promise((c,m)=>{ne([d],c,m)}).then(ke)}}),define(le[21],he([0,1,39,42,23,14,5,27,9]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=p,e.$ph=d,e.$qh=$,a=ke(a),O=ke(O);function p(c){return(0,L.$yc)(c,!0)}class S{constructor(m){this.a=m}compare(m,b,f=!1){return m===b?0:(0,A.$zf)(this.getComparisonKey(m,f),this.getComparisonKey(b,f))}isEqual(m,b,f=!1){return m===b?!0:!m||!b?!1:this.getComparisonKey(m,f)===this.getComparisonKey(b,f)}getComparisonKey(m,b=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,b,f=!1){if(m.scheme===b.scheme){if(m.scheme===N.Schemas.file)return a.$Eg(p(m),p(b),this.a(m))&&m.query===b.query&&(f||m.fragment===b.fragment);if((0,e.$lh)(m.authority,b.authority))return a.$Eg(m.path,b.path,this.a(m),"/")&&m.query===b.query&&(f||m.fragment===b.fragment)}return!1}joinPath(m,...b){return L.URI.joinPath(m,...b)}basenameOrAuthority(m){return(0,e.$dh)(m)||m.authority}basename(m){return O.$ic.basename(m.path)}extname(m){return O.$ic.extname(m.path)}dirname(m){if(m.path.length===0)return m;let b;return m.scheme===N.Schemas.file?b=L.URI.file(O.$oc(p(m))).path:(b=O.$ic.dirname(m.path),m.authority&&b.length&&b.charCodeAt(0)!==P.CharCode.Slash&&(console.error(`dirname("${m.toString})) resulted in a relative path`),b="/")),m.with({path:b})}normalizePath(m){if(!m.path.length)return m;let b;return m.scheme===N.Schemas.file?b=L.URI.file(O.$jc(p(m))).path:b=O.$ic.normalize(m.path),m.with({path:b})}relativePath(m,b){if(m.scheme!==b.scheme||!(0,e.$lh)(m.authority,b.authority))return;if(m.scheme===N.Schemas.file){const I=O.$nc(p(m),p(b));return T.$i?a.$yg(I):I}let f=m.path||"/";const w=b.path||"/";if(this.a(m)){let I=0;for(const g=Math.min(f.length,w.length);I<g&&!(f.charCodeAt(I)!==w.charCodeAt(I)&&f.charAt(I).toLowerCase()!==w.charAt(I).toLowerCase());I++);f=w.substr(0,I)+f.substr(I)}return O.$ic.relative(f,w)}resolvePath(m,b){if(m.scheme===N.Schemas.file){const f=L.URI.file(O.$mc(p(m),b));return m.with({authority:f.authority,path:f.path})}return b=a.$zg(b),m.with({path:O.$ic.resolve(m.path,b)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,b){return m===b||m!==void 0&&b!==void 0&&(0,A.$Gf)(m,b)}hasTrailingPathSeparator(m,b=O.sep){if(m.scheme===N.Schemas.file){const f=p(m);return f.length>a.$Ag(f).length&&f[f.length-1]===b}else{const f=m.path;return f.length>1&&f.charCodeAt(f.length-1)===P.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,b=O.sep){return(0,e.$mh)(m,b)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,b=O.sep){let f=!1;if(m.scheme===N.Schemas.file){const w=p(m);f=w!==void 0&&w.length===a.$Ag(w).length&&w[w.length-1]===b}else{b="/";const w=m.path;f=w.length===1&&w.charCodeAt(w.length-1)===P.CharCode.Slash}return!f&&!(0,e.$mh)(m,b)?m.with({path:m.path+"/"}):m}}e.$8g=S,e.$9g=new S(()=>!1),e.$0g=new S(c=>c.scheme===N.Schemas.file?!T.$k:!0),e.$$g=new S(c=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function d(c,m){const b=[];for(let f=0;f<c.length;f++){const w=m(c[f]);c.some((I,g)=>g===f?!1:(0,e.$ah)(w,m(I)))||b.push(c[f])}return b}var h;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function m(b){const f=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(g=>{const[u,t]=g.split(":");u&&t&&f.set(u,t)});const I=b.path.substring(0,b.path.indexOf(";"));return I&&f.set(c.META_DATA_MIME,I),f}c.parseMetaData=m})(h||(e.DataUri=h={}));function $(c,m,b){if(m){let f=c.path;return f&&f[0]!==O.$ic.sep&&(f=O.$ic.sep+f),c.with({scheme:b,authority:m,path:f})}return c.with({scheme:b})}}),define(le[6],he([0,1,26,8,3,2,21,5,135,54]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=S,e.$sh=d,e.$th=h,e.$uh=$,e.$vh=c,e.$wh=m,e.$xh=b,e.$yh=f,e.$Gh=o,e.$Hh=l,e.$Ih=y,e.$Jh=R,e.$Kh=k,e.$Zh=z,e.$8h=W;function S(_){return!!_&&typeof _.then=="function"}function d(_){const Y=new P.$xe,ae=_(Y.token),ue=new Promise((ge,we)=>{const Ee=Y.token.onCancellationRequested(()=>{Ee.dispose(),we(new a.$7)});Promise.resolve(ae).then(pe=>{Ee.dispose(),Y.dispose(),ge(pe)},pe=>{Ee.dispose(),Y.dispose(),we(pe)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ge,we){return ue.then(ge,we)}catch(ge){return this.then(void 0,ge)}finally(ge){return ue.finally(ge)}}}function h(_,Y,ae){return new Promise((ue,ge)=>{const we=Y.onCancellationRequested(()=>{we.dispose(),ue(ae)});_.then(ue,ge).finally(()=>we.dispose())})}function $(_,Y){return new Promise((ae,ue)=>{const ge=Y.onCancellationRequested(()=>{ge.dispose(),ue(new a.$7)});_.then(ae,ue).finally(()=>ge.dispose())})}async function c(_){let Y=-1;const ae=_.map((ue,ge)=>ue.then(we=>(Y=ge,we)));try{return await Promise.race(ae)}finally{_.forEach((ue,ge)=>{ge!==Y&&ue.cancel()})}}function m(_,Y,ae){let ue;const ge=setTimeout(()=>{ue?.(void 0),ae?.()},Y);return Promise.race([_.finally(()=>clearTimeout(ge)),new Promise(we=>ue=we)])}function b(_){return new Promise((Y,ae)=>{const ue=_();S(ue)?ue.then(Y,ae):Y(ue)})}function f(){let _,Y;return{promise:new Promise((ue,ge)=>{_=ue,Y=ge}),resolve:_,reject:Y}}class w{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const ae=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(ae,ae).then(ue)})}return new Promise((ae,ue)=>{this.b.then(ae,ue)})}return this.a=Y(),new Promise((ae,ue)=>{this.a.then(ge=>{this.a=null,ae(ge)},ge=>{this.a=null,ue(ge)})})}dispose(){this.f=!0}}e.$zh=w;class I{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$Ah=I;class g{constructor(){this.a=new Map}queue(Y,ae){const ge=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Y)===ge&&this.a.delete(Y)});return this.a.set(Y,ge),ge}}e.$Bh=g;const u=(_,Y)=>{let ae=!0;const ue=setTimeout(()=>{ae=!1,Y()},_);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(ue),ae=!1}}},t=_=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,_())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class s{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ae=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ge,we)=>{this.d=ge,this.f=we}).then(()=>{if(this.b=null,this.d=null,this.g){const ge=this.g;return this.g=null,ge()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=ae===L.$he?t(ue):u(ae,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new a.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=s;class r{constructor(Y){this.a=new s(Y),this.b=new w}trigger(Y,ae){return this.a.trigger(()=>this.b.queue(Y),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=r;class i{constructor(){this.a=!1,this.b=new Promise((Y,ae)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=i;class n extends i{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$Fh=n;function o(_,Y){return Y?new Promise((ae,ue)=>{const ge=setTimeout(()=>{we.dispose(),ae()},_),we=Y.onCancellationRequested(()=>{clearTimeout(ge),we.dispose(),ue(new a.$7)})}):d(ae=>o(_,ae))}function l(_,Y=0,ae){const ue=setTimeout(()=>{_(),ae&&ge.dispose()},Y),ge=(0,O.$Uc)(()=>{clearTimeout(ue),ae?.deleteAndLeak(ge)});return ae?.add(ge),ge}function y(_){const Y=[];let ae=0;const ue=_.length;function ge(){return ae<ue?_[ae++]():null}function we(Ee){Ee!=null&&Y.push(Ee);const pe=ge();return pe?pe.then(we):Promise.resolve(Y)}return Promise.resolve(null).then(we)}function R(_,Y=ue=>!!ue,ae=null){let ue=0;const ge=_.length,we=()=>{if(ue>=ge)return Promise.resolve(ae);const Ee=_[ue++];return Promise.resolve(Ee()).then(be=>Y(be)?Promise.resolve(be):we())};return we()}function k(_,Y=ue=>!!ue,ae=null){if(_.length===0)return Promise.resolve(ae);let ue=_.length;const ge=()=>{ue=-1;for(const we of _)we.cancel?.()};return new Promise((we,Ee)=>{for(const pe of _)pe.then(be=>{--ue>=0&&Y(be)?(ge(),we(be)):ue===0&&we(ae)}).catch(be=>{--ue>=0&&(ge(),Ee(be))})})}class E{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new N.$me}whenIdle(){return this.size>0?N.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,ue)=>{this.g.push({factory:Y,c:ae,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const ae=Y.factory();ae.then(Y.c,Y.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=E;class v extends E{constructor(){super(1)}}e.$Mh=v;class C{constructor(){this.a=new ee,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Nh=C;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new q;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,ae=T.$9g){const ue=ae.getComparisonKey(Y);return this.a.get(ue)?.size??0}queueFor(Y,ae,ue=T.$9g){const ge=ue.getComparisonKey(Y);let we=this.a.get(ge);if(!we){we=new v;const Ee=this.f++,pe=N.Event.once(we.onDrained)(()=>{we?.dispose(),this.a.delete(ge),this.h(),this.d?.deleteAndDispose(Ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$6c),this.d.set(Ee,pe),this.a.set(ge,we)}return we.queue(ae)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=U;class F{constructor(Y,ae){this.b=!1,this.a=-1,typeof Y=="function"&&typeof ae=="number"&&this.setIfNotSet(Y,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ae){if(this.b)throw new a.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ae)}setIfNotSet(Y,ae){if(this.b)throw new a.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ae))}}e.$Ph=F;class M{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,ae,ue=globalThis){if(this.f)throw new a.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ge=ue.setInterval(()=>{Y()},ae);this.d=(0,O.$Uc)(()=>{ue.clearInterval(ge),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=M;class X{constructor(Y,ae){this.b=-1,this.a=Y,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=X;class K{constructor(Y,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=K;class Q extends X{constructor(Y,ae){super(Y,ae),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Th=Q;class G extends O.$Wc{constructor(Y,ae){super(),this.g=Y,this.h=ae,this.a=[],this.b=this.B(new O.$Xc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Y)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new X(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(_,Y)=>{(0,A.$B)(()=>{if(ae)return;const ue=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Wh=(_,Y,ae)=>{const ue=_.requestIdleCallback(Y,typeof ae=="number"?{timeout:ae}:void 0);let ge=!1;return{dispose(){ge||(ge=!0,_.cancelIdleCallback(ue))}}},e.$Vh=_=>(0,e.$Wh)(globalThis,_)}();class ie{constructor(Y,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Wh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ie;class V extends ie{constructor(Y){super(globalThis,Y)}}e.$Yh=V;async function z(_,Y,ae){let ue;for(let ge=0;ge<ae;ge++)try{return await _()}catch(we){ue=we,await o(Y)}throw ue}class ee{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,ae,ue){return this.a={taskId:Y,cancel:()=>ue?.(),promise:ae},ae.then(()=>this.d(Y),()=>this.d(Y)),ae}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:ae,resolve:ue,reject:ge}=f();this.b={run:Y,promise:ae,promiseResolve:ue,promiseReject:ge}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=ee;class re{constructor(Y,ae=()=>Date.now()){this.d=Y,this.f=ae,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$2h=re;var ce;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ce||(ce={}));class q{get isRejected(){return this.d?.outcome===ce.Rejected}get isResolved(){return this.d?.outcome===ce.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ce.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Y,ae)=>{this.a=Y,this.b=ae})}complete(Y){return new Promise(ae=>{this.a(Y),this.d={outcome:ce.Resolved,value:Y},ae()})}error(Y){return new Promise(ae=>{this.b(Y),this.d={outcome:ce.Rejected,value:Y},ae()})}cancel(){return this.error(new a.$7)}}e.$3h=q;var x;(function(_){async function Y(ue){let ge;const we=await Promise.all(ue.map(Ee=>Ee.then(pe=>pe,pe=>{ge||(ge=pe)})));if(typeof ge<"u")throw ge;return we}_.settled=Y;function ae(ue){return new Promise(async(ge,we)=>{try{await ue(ge,we)}catch(Ee){we(Ee)}})}_.withAsyncBody=ae})(x||(e.Promises=x={}));class J{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new a.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=J;class H{constructor(Y){this.b=Y,this.a=new p.$X(()=>new J(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=H;var D;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(D||(D={}));class B{static fromArray(Y){return new B(ae=>{ae.emitMany(Y)})}static fromPromise(Y){return new B(async ae=>{ae.emitMany(await Y)})}static fromPromises(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>ae.emitOne(await ue)))})}static merge(Y){return new B(async ae=>{await Promise.all(Y.map(async ue=>{for await(const ge of ue)ae.emitOne(ge)}))})}static{this.EMPTY=B.fromArray([])}constructor(Y,ae){this.a=D.Initial,this.b=[],this.d=null,this.f=ae,this.g=new N.$me,queueMicrotask(async()=>{const ue={emitOne:ge=>this.h(ge),emitMany:ge=>this.j(ge),reject:ge=>this.l(ge)};try{await Promise.resolve(Y(ue)),this.k()}catch(ge){this.l(ge)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===D.DoneError)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===D.DoneOK)return{done:!0,value:void 0};await N.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,ae){return new B(async ue=>{for await(const ge of Y)ue.emitOne(ae(ge))})}map(Y){return B.map(this,Y)}static filter(Y,ae){return new B(async ue=>{for await(const ge of Y)ae(ge)&&ue.emitOne(ge)})}filter(Y){return B.filter(this,Y)}static coalesce(Y){return B.filter(Y,ae=>!!ae)}coalesce(){return B.coalesce(this)}static async toPromise(Y){const ae=[];for await(const ue of Y)ae.push(ue);return ae}toPromise(){return B.toPromise(this)}h(Y){this.a===D.Initial&&(this.b.push(Y),this.g.fire())}j(Y){this.a===D.Initial&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===D.Initial&&(this.a=D.DoneOK,this.g.fire())}l(Y){this.a===D.Initial&&(this.a=D.DoneError,this.d=Y,this.g.fire())}}e.$6h=B;class j extends B{constructor(Y,ae){super(ae),this.m=Y}cancel(){this.m.cancel()}}e.$7h=j;function W(_){const Y=new P.$xe,ae=_(Y.token);return new j(Y,async ue=>{const ge=Y.token.onCancellationRequested(()=>{ge.dispose(),Y.dispose(),ue.reject(new a.$7)});try{for await(const we of ae){if(Y.token.isCancellationRequested)return;ue.emitOne(we)}ge.dispose(),Y.dispose()}catch(we){ge.dispose(),Y.dispose(),ue.reject(we)}})}class te{constructor(Y){this.a=new q,this.b=new B(ge=>{if(ae){ge.reject(ae);return}return ue&&ge.emitMany(ue),this.d=we=>ge.reject(we),this.f=we=>ge.emitOne(we),this.a.p},Y);let ae,ue;this.f=ge=>{ue||(ue=[]),ue.push(ge)},this.d=ge=>{ae||(ae=ge)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$9h=te}),define(le[94],he([0,1,19,6,39,42,35,14,5,27]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=S,e.$xk=m,e.$yk=C,e.$zk=U,e.$Ak=F,e.$Bk=M,e.$Ck=X,e.$Dk=ie;function S(){return Object.create(null)}e.$vk="**",e.$wk="/";const d="[/\\\\]",h="[^/\\\\]",$=/\//g;function c(V,z){switch(V){case 0:return"";case 1:return`${h}*?`;default:return`(?:${d}|${h}+${d}${z?`|${d}${h}+`:""})*?`}}function m(V,z){if(!V)return[];const ee=[];let re=!1,ce=!1,q="";for(const x of V){switch(x){case z:if(!re&&!ce){ee.push(q),q="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}q+=x}return q&&ee.push(q),ee}function b(V){if(!V)return"";let z="";const ee=m(V,e.$wk);if(ee.every(re=>re===e.$vk))z=".*";else{let re=!1;ee.forEach((ce,q)=>{if(ce===e.$vk){if(re)return;z+=c(2,q===ee.length-1)}else{let x=!1,J="",H=!1,D="";for(const B of ce){if(B!=="}"&&x){J+=B;continue}if(H&&(B!=="]"||!D)){let j;B==="-"?j=B:(B==="^"||B==="!")&&!D?j="^":B===e.$wk?j="":j=(0,p.$if)(B),D+=j;continue}switch(B){case"{":x=!0;continue;case"[":H=!0;continue;case"}":{const W=`(?:${m(J,",").map(te=>b(te)).join("|")})`;z+=W,x=!1,J="";break}case"]":{z+="["+D+"]",H=!1,D="";break}case"?":z+=h;continue;case"*":z+=c(1);continue;default:z+=(0,p.$if)(B)}}q<ee.length-1&&(ee[q+1]!==e.$vk||q+2<ee.length)&&(z+=d)}re=ce===e.$vk})}return z}const f=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.$Fc(1e4),r=function(){return!1},i=function(){return null};function n(V,z){if(!V)return i;let ee;typeof V!="string"?ee=V.pattern:ee=V,ee=ee.trim();const re=`${ee}_${!!z.trimForExclusions}`;let ce=s.get(re);if(ce)return o(ce,V);let q;return f.test(ee)?ce=y(ee.substr(4),ee):(q=w.exec(l(ee,z)))?ce=R(q[1],ee):(z.trimForExclusions?g:I).test(ee)?ce=k(ee,z):(q=u.exec(l(ee,z)))?ce=E(q[1].substr(1),ee,!0):(q=t.exec(l(ee,z)))?ce=E(q[1],ee,!1):ce=v(ee),s.set(re,ce),o(ce,V)}function o(V,z){if(typeof z=="string")return V;const ee=function(re,ce){return(0,O.$Eg)(re,z.base,!L.$k)?V((0,p.$nf)(re.substr(z.base.length),A.sep),ce):null};return ee.allBasenames=V.allBasenames,ee.allPaths=V.allPaths,ee.basenames=V.basenames,ee.patterns=V.patterns,ee}function l(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function y(V,z){return function(ee,re){return typeof ee=="string"&&ee.endsWith(V)?z:null}}function R(V,z){const ee=`/${V}`,re=`\\${V}`,ce=function(x,J){return typeof x!="string"?null:J?J===V?z:null:x===V||x.endsWith(ee)||x.endsWith(re)?z:null},q=[V];return ce.basenames=q,ce.patterns=[z],ce.allBasenames=q,ce}function k(V,z){const ee=G(V.slice(1,-1).split(",").map(J=>n(J,z)).filter(J=>J!==i),V),re=ee.length;if(!re)return i;if(re===1)return ee[0];const ce=function(J,H){for(let D=0,B=ee.length;D<B;D++)if(ee[D](J,H))return V;return null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function E(V,z,ee){const re=A.sep===A.$ic.sep,ce=re?V:V.replace($,A.sep),q=A.sep+ce,x=A.$ic.sep+V;let J;return ee?J=function(H,D){return typeof H=="string"&&(H===ce||H.endsWith(q)||!re&&(H===V||H.endsWith(x)))?z:null}:J=function(H,D){return typeof H=="string"&&(H===ce||!re&&H===V)?z:null},J.allPaths=[(ee?"*/":"./")+V],J}function v(V){try{const z=new RegExp(`^${b(V)}$`);return function(ee){return z.lastIndex=0,typeof ee=="string"&&z.test(ee)?V:null}}catch{return i}}function C(V,z,ee){return!V||typeof z!="string"?!1:U(V)(z,void 0,ee)}function U(V,z={}){if(!V)return r;if(typeof V=="string"||F(V)){const ee=n(V,z);if(ee===i)return r;const re=function(ce,q){return!!ee(ce,q)};return ee.allBasenames&&(re.allBasenames=ee.allBasenames),ee.allPaths&&(re.allPaths=ee.allPaths),re}return K(V,z)}function F(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function M(V){return V.allBasenames||[]}function X(V){return V.allPaths||[]}function K(V,z){const ee=G(Object.getOwnPropertyNames(V).map(J=>Q(J,V[J],z)).filter(J=>J!==i)),re=ee.length;if(!re)return i;if(!ee.some(J=>!!J.requiresSiblings)){if(re===1)return ee[0];const J=function(B,j){let W;for(let te=0,_=ee.length;te<_;te++){const Y=ee[te](B,j);if(typeof Y=="string")return Y;(0,a.$rh)(Y)&&(W||(W=[]),W.push(Y))}return W?(async()=>{for(const te of W){const _=await te;if(typeof _=="string")return _}return null})():null},H=ee.find(B=>!!B.allBasenames);H&&(J.allBasenames=H.allBasenames);const D=ee.reduce((B,j)=>j.allPaths?B.concat(j.allPaths):B,[]);return D.length&&(J.allPaths=D),J}const ce=function(J,H,D){let B,j;for(let W=0,te=ee.length;W<te;W++){const _=ee[W];_.requiresSiblings&&D&&(H||(H=(0,A.$pc)(J)),B||(B=H.substr(0,H.length-(0,A.$qc)(J).length)));const Y=_(J,H,B,D);if(typeof Y=="string")return Y;(0,a.$rh)(Y)&&(j||(j=[]),j.push(Y))}return j?(async()=>{for(const W of j){const te=await W;if(typeof te=="string")return te}return null})():null},q=ee.find(J=>!!J.allBasenames);q&&(ce.allBasenames=q.allBasenames);const x=ee.reduce((J,H)=>H.allPaths?J.concat(H.allPaths):J,[]);return x.length&&(ce.allPaths=x),ce}function Q(V,z,ee){if(z===!1)return i;const re=n(V,ee);if(re===i)return i;if(typeof z=="boolean")return re;if(z){const ce=z.when;if(typeof ce=="string"){const q=(x,J,H,D)=>{if(!D||!re(x,J))return null;const B=ce.replace("$(basename)",()=>H),j=D(B);return(0,a.$rh)(j)?j.then(W=>W?V:null):j?V:null};return q.requiresSiblings=!0,q}}return re}function G(V,z){const ee=V.filter(J=>!!J.basenames);if(ee.length<2)return V;const re=ee.reduce((J,H)=>{const D=H.basenames;return D?J.concat(D):J},[]);let ce;if(z){ce=[];for(let J=0,H=re.length;J<H;J++)ce.push(z)}else ce=ee.reduce((J,H)=>{const D=H.patterns;return D?J.concat(D):J},[]);const q=function(J,H){if(typeof J!="string")return null;if(!H){let B;for(B=J.length;B>0;B--){const j=J.charCodeAt(B-1);if(j===N.CharCode.Slash||j===N.CharCode.Backslash)break}H=J.substr(B)}const D=re.indexOf(H);return D!==-1?ce[D]:null};q.basenames=re,q.patterns=ce,q.allBasenames=re;const x=V.filter(J=>!J.basenames);return x.push(q),x}function ie(V,z){return(0,P.$wb)(V,z,(ee,re)=>typeof ee=="string"&&typeof re=="string"?ee===re:typeof ee!="string"&&typeof re!="string"?ee.base===re.base&&ee.pattern===re.pattern:!1)}}),define(le[95],he([0,1,15,65,9]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=L,e.$Mn=S,e.$Nn=d;function O(h){return h.toJSON()}class T{constructor($){this.a=$}transformIncoming($){const c=this.a.transformIncoming($);return c===$?$:O(N.URI.from(c))}transformOutgoing($){const c=this.a.transformOutgoing($);return c===$?$:O(N.URI.from(c))}transformOutgoingURI($){const c=this.a.transformOutgoing($);return c===$?$:N.URI.from(c)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$Jn=T,e.$Kn=new class{transformIncoming(h){return h}transformOutgoing(h){return h}transformOutgoingURI(h){return h}transformOutgoingScheme(h){return h}};function A(h,$,c){if(!h||c>200)return null;if(typeof h=="object"){if(h instanceof N.URI)return $.transformOutgoing(h);for(const m in h)if(Object.hasOwnProperty.call(h,m)){const b=A(h[m],$,c+1);b!==null&&(h[m]=b)}}return null}function L(h,$){const c=A(h,$,0);return c===null?h:c}function p(h,$,c,m){if(!h||m>200)return null;if(typeof h=="object"){if(h.$mid===a.MarshalledId.Uri)return c?N.URI.revive($.transformIncoming(h)):$.transformIncoming(h);if(h instanceof P.$Oe)return null;for(const b in h)if(Object.hasOwnProperty.call(h,b)){const f=p(h[b],$,c,m+1);f!==null&&(h[b]=f)}}return null}function S(h,$){const c=p(h,$,!1,0);return c===null?h:c}function d(h,$){const c=p(h,$,!0,0);return c===null?h:c}}),define(le[150],he([0,1,38,52,32,137,5]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pn=void 0,e.$Qn=L,e.$Rn=d,e.$Sn=h,N=ke(N),e.$Pn=new class{c($){return this.a||(this.a=a.$Li.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,c=0;const m=(0,P.networkInterfaces)();for(const b in m){const f=m[b];if(f)for(const{mac:w,internal:I}of f)I||(c+=1,this.c(w.toUpperCase())&&($+=1))}this.b=c>0?$/c:0}return this.b}};let A;async function L($){return A||(A=(async()=>await p($)||N.$2g())()),A}async function p($){try{const c=await new Promise((b,f)=>{ne(["crypto"],b,f)}).then(ke),m=(0,O.$On)();return c.createHash("sha256").update(m,"utf8").digest("hex")}catch(c){$(c);return}}const S="Software\\Microsoft\\SQMClient";async function d($){if(T.$i){const c=await new Promise((m,b)=>{ne(["@vscode/windows-registry"],m,b)}).then(ke);try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",S,"MachineId")||""}catch(m){return $(m),""}}return""}async function h($){try{return await(await new Promise((b,f)=>{ne(["@vscode/deviceid"],b,f)}).then(ke)).getDeviceId()}catch(c){return $(c),""}}}),define(le[151],he([0,1,46,152,14,36]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vX=S,e.$wX=d;const T="XDG_SESSION_TYPE",A="WAYLAND_DISPLAY",L="XDG_RUNTIME_DIR";var p;(function(h){h.Wayland="wayland",h.XWayland="xwayland",h.X11="x11",h.Unknown="unknown"})(p||(p={}));async function S(h){const $=O.env[T];if($)return $===p.Wayland||$===p.X11?$:p.Unknown;if(O.env[A]){const m=O.env[L];if(m){const b=(0,N.$lc)(m,"wayland-0");try{return await(0,a.access)(b,P.constants.R_OK),p.Wayland}catch(f){return h(f),p.Unknown}}else return p.Unknown}else return p.X11}function d(h,$){if($)switch($){case"auto":return h;case"x11":return h===p.Wayland?p.XWayland:p.X11;case"wayland":return p.Wayland;default:return p.Unknown}else return h===p.Wayland?p.XWayland:p.X11}}),define(le[153],he([0,1,46,152,277,5]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3g=T,O=ke(O);async function T(A){if(O.$j||O.$i)return;let L;for(const p of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{L=await(0,a.open)(p,P.constants.R_OK);break}catch{}if(!L){A("Unable to retrieve release information from known identifier paths.");return}try{const p=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),S={id:"unknown"};for await(const d of(0,N.createInterface)({input:L.createReadStream(),crlfDelay:1/0})){if(!d.includes("="))continue;const h=d.split("=")[0].toUpperCase().trim();if(p.has(h)){const $=d.split("=")[1].replace(/"/g,"").toLowerCase().trim();h==="ID"||h==="DISTRIB_ID"?S.id=$:h==="ID_LIKE"?S.id_like=$:(h==="VERSION_ID"||h==="DISTRIB_RELEASE")&&(S.version_id=$)}}return S}catch(p){A(p)}}}),define(le[31],he([0,1,46,38,278,6,42,91,14,5,21,9]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=b,e.readdirSync=I,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=y,P=ke(P);var h;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(h||(e.RimRafMode=h={}));async function $(K,Q=h.UNLINK,G){if((0,T.$Ig)(K))throw new Error("rimraf - will refuse to recursively delete root");return Q===h.UNLINK?m(K):c(K,G)}async function c(K,Q=(0,T.$Ng)((0,a.tmpdir)())){try{try{await P.promises.rename(K,Q)}catch(G){return G.code==="ENOENT"?void 0:m(K)}m(Q).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function m(K){return P.promises.rm(K,{recursive:!0,force:!0,maxRetries:3})}function b(K){if((0,T.$Ig)(K))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function f(K,Q){return g(await(Q?w(K):P.promises.readdir(K)))}async function w(K){try{return await P.promises.readdir(K,{withFileTypes:!0})}catch(ie){console.warn("[node.js fs] readdir with filetypes failed with error: ",ie)}const Q=[],G=await f(K);for(const ie of G){let V=!1,z=!1,ee=!1;try{const re=await e.Promises.lstat((0,L.$lc)(K,ie));V=re.isFile(),z=re.isDirectory(),ee=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}Q.push({name:ie,isFile:()=>V,isDirectory:()=>z,isSymbolicLink:()=>ee})}return Q}function I(K){return g(P.readdirSync(K))}function g(K){return K.map(Q=>typeof Q=="string"?p.$j?(0,A.$mm)(Q):Q:(Q.name=p.$j?(0,A.$mm)(Q.name):Q.name,Q))}async function u(K){const Q=await f(K),G=[];for(const ie of Q)await s.existsDirectory((0,L.$lc)(K,ie))&&G.push(ie);return G}function t(K,Q=1e3){return new Promise(G=>{let ie=!1;const V=setInterval(()=>{ie||(ie=!0,P.access(K,z=>{ie=!1,z&&(clearInterval(V),G(void 0))}))},Q)})}var s;(function(K){async function Q(V){let z;try{if(z=await e.Promises.lstat(V),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(p.$i&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw re}throw ee}}K.stat=Q;async function G(V){try{const{stat:z,symbolicLink:ee}=await K.stat(V);return z.isFile()&&ee?.dangling!==!0}catch{}return!1}K.existsFile=G;async function ie(V){try{const{stat:z,symbolicLink:ee}=await K.stat(V);return z.isDirectory()&&ee?.dangling!==!0}catch{}return!1}K.existsDirectory=ie})(s||(e.SymlinkSupport=s={}));const r=new O.$Oh;function i(K,Q,G){return r.queueFor(d.URI.file(K),()=>{const ie=R(G);return new Promise((V,z)=>l(K,Q,ie,ee=>ee?z(ee):V()))},S.$0g)}let n=!0;function o(K){n=K}function l(K,Q,G,ie){if(!n)return P.writeFile(K,Q,{mode:G.mode,flag:G.flag},ie);P.open(K,G.flag,G.mode,(V,z)=>{if(V)return ie(V);P.writeFile(z,Q,ee=>{if(ee)return P.close(z,()=>ie(ee));P.fdatasync(z,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),o(!1)),P.close(z,ce=>ie(ce))))})})}function y(K,Q,G){const ie=R(G);if(!n)return P.writeFileSync(K,Q,{mode:ie.mode,flag:ie.flag});const V=P.openSync(K,ie.flag,ie.mode);try{P.writeFileSync(V,Q);try{P.fdatasyncSync(V)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{P.closeSync(V)}}function R(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function k(K,Q,G=6e4){if(K!==Q)try{p.$i&&typeof G=="number"?await E(K,Q,Date.now(),G):await P.promises.rename(K,Q)}catch(ie){if(K.toLowerCase()!==Q.toLowerCase()&&ie.code==="EXDEV"||K.endsWith("."))await v(K,Q,{preserveSymlinks:!1}),await $(K,h.MOVE);else throw ie}}async function E(K,Q,G,ie,V=0){try{return await P.promises.rename(K,Q)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-G>=ie)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${z}`),z;if(V===0){let ee=!1;try{const{stat:re}=await s.stat(Q);re.isFile()||(ee=!0)}catch{}if(ee)throw z}return await(0,O.$Gh)(Math.min(100,V*10)),E(K,Q,G,ie,V+1)}}async function v(K,Q,G){return U(K,Q,{root:{source:K,target:Q},options:G,handledSourcePaths:new Set})}const C=511;async function U(K,Q,G){if(G.handledSourcePaths.has(K))return;G.handledSourcePaths.add(K);const{stat:ie,symbolicLink:V}=await s.stat(K);if(V){if(G.options.preserveSymlinks)try{return await X(K,Q,G)}catch{}if(V.dangling)return}return ie.isDirectory()?F(K,Q,ie.mode&C,G):M(K,Q,ie.mode&C)}async function F(K,Q,G,ie){await e.Promises.mkdir(Q,{recursive:!0,mode:G});const V=await f(K);for(const z of V)await U((0,L.$lc)(K,z),(0,L.$lc)(Q,z),ie)}async function M(K,Q,G){await e.Promises.copyFile(K,Q),await e.Promises.chmod(Q,G)}async function X(K,Q,G){let ie=await e.Promises.readlink(K);(0,T.$Eg)(ie,G.root.source,!p.$k)&&(ie=(0,L.$lc)(G.root.target,ie.substr(G.root.source.length+1))),await e.Promises.symlink(ie,Q)}e.Promises=new class{get access(){return P.promises.access}get stat(){return P.promises.stat}get lstat(){return P.promises.lstat}get utimes(){return P.promises.utimes}get read(){return(K,Q,G,ie,V)=>new Promise((z,ee)=>{P.read(K,Q,G,ie,V,(re,ce,q)=>re?ee(re):z({bytesRead:ce,buffer:q}))})}get readFile(){return P.promises.readFile}get write(){return(K,Q,G,ie,V)=>new Promise((z,ee)=>{P.write(K,Q,G,ie,V,(re,ce,q)=>re?ee(re):z({bytesWritten:ce,buffer:q}))})}get appendFile(){return P.promises.appendFile}get fdatasync(){return(0,N.promisify)(P.fdatasync)}get truncate(){return P.promises.truncate}get copyFile(){return P.promises.copyFile}get open(){return(0,N.promisify)(P.open)}get close(){return(0,N.promisify)(P.close)}get symlink(){return P.promises.symlink}get readlink(){return P.promises.readlink}get chmod(){return P.promises.chmod}get mkdir(){return P.promises.mkdir}get unlink(){return P.promises.unlink}get rmdir(){return P.promises.rmdir}get realpath(){return(0,N.promisify)(P.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return $}get rename(){return k}get copy(){return v}}}),define(le[154],he([0,1,46,14,5,27,31]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=A,e.$gr=L,e.$hr=p,e.$ir=S,P=ke(P);function A(h){if(N.$k)return h;const $=(0,a.$oc)(h);if(h===$)return h;const c=((0,a.$pc)(h)||h).toLowerCase();try{const b=(0,T.readdirSync)($).filter(f=>f.toLowerCase()===c);if(b.length===1){const f=A($);if(f)return(0,a.$lc)(f,b[0])}else if(b.length>1){const f=b.indexOf(c);if(f>=0){const w=A($);if(w)return(0,a.$lc)(w,b[f])}}}catch{}return null}async function L(h,$){if(N.$k)return h;const c=(0,a.$oc)(h);if(h===c)return h;const m=((0,a.$pc)(h)||h).toLowerCase();try{if($?.isCancellationRequested)return null;const f=(await T.Promises.readdir(c)).filter(w=>w.toLowerCase()===m);if(f.length===1){const w=await L(c,$);if(w)return(0,a.$lc)(w,f[0])}else if(f.length>1){const w=f.indexOf(m);if(w>=0){const I=await L(c,$);if(I)return(0,a.$lc)(I,f[w])}}}catch{}return null}async function p(h){try{return await T.Promises.realpath(h)}catch{const c=d(h);return await T.Promises.access(c,P.constants.R_OK),c}}function S(h){try{return P.realpathSync(h)}catch{const c=d(h);return P.accessSync(c,P.constants.R_OK),c}}function d(h){return(0,O.$of)((0,a.$jc)(h),a.sep)}}),define(le[155],he([0,1,14,5,36,93,13,31]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=L,e.$ym=p,P=ke(P),a=ke(a),N=ke(N),T=ke(T),A=ke(A),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function L(d=N.env){return d.comspec||"cmd.exe"}function p(d){let h=[],$=!1;const c=function(m){if($){h.push(m);return}(!d.send(m,f=>{if(f&&console.error(f),$=!1,h.length>0){const w=h.slice(0);h=[],w.forEach(I=>c(I))}})||a.$i)&&($=!0)};return{send:c}}var S;(function(d){async function h($,c,m){if(P.$kc($))return $;if(c===void 0&&(c=N.cwd()),P.$oc($)!=="."||(m===void 0&&T.$fg(N.env.PATH)&&(m=N.env.PATH.split(P.$vc)),m===void 0||m.length===0))return P.$lc(c,$);async function f(w){if(await A.Promises.exists(w)){let I;try{I=await A.Promises.stat(w)}catch(g){g.message.startsWith("EACCES")&&(I=await A.Promises.lstat(w))}return I?!I.isDirectory():!1}return!1}for(const w of m){let I;if(P.$kc(w)?I=P.$lc(w,$):I=P.$lc(c,w,$),await f(I))return I;let g=I+".com";if(await f(g)||(g=I+".exe",await f(g)))return g}return P.$lc(c,$)}d.findExecutable=h})(S||(e.win32=S={}))}),define(le[156],he([0,1,69,23]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=N;function N(T){return new Promise((A,L)=>{let p;const S=new Map;function d($,c,m,b,f){const w=S.get(c);if($===T||w){const I={name:h(m),cmd:m,pid:$,ppid:c,load:b,mem:f};S.set($,I),$===T&&(p=I),w&&(w.children||(w.children=[]),w.children.push(I),w.children.length>1&&(w.children=w.children.sort((g,u)=>g.pid-u.pid)))}}function h($){const c=/--utility-sub-type=network/i,m=/--crashes-directory/i,b=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,w=/--type=([a-zA-Z-]+)/;if(m.exec($))return"electron-crash-reporter";if(b.exec($))return"winpty-agent";if(f.exec($))return"conpty-agent";let I=w.exec($);if(I&&I.length===2)return I[1]==="renderer"?"window":I[1]==="utility"?c.exec($)?"utility-network-service":"utility-process":I[1]==="extensionHost"?"extension-host":I[1];const g=/[a-zA-Z-]+\.js/g;let u="";do I=g.exec($),I&&(u+=I+" ");while(I);return u&&$.indexOf("node ")<0&&$.indexOf("node.exe")<0?`electron-nodejs (${u})`:$}if(process.platform==="win32"){const $=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,m)=>{ne(["@vscode/windows-process-tree"],c,m)}).then(ke).then(c=>{c.getProcessList(T,m=>{if(!m){L(new Error(`Root process ${T} not found`));return}c.getProcessCpuUsage(m,b=>{const f=new Map;b.forEach(w=>{const I=$(w.commandLine||"");f.set(w.pid,{name:h(I),cmd:I,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),p=f.get(T),p?(f.forEach(w=>{const I=f.get(w.ppid);I&&(I.children||(I.children=[]),I.children.push(w))}),f.forEach(w=>{w.children&&(w.children=w.children.sort((I,g)=>I.pid-g.pid))}),A(p)):L(new Error(`Root process ${T} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let $=function(){let c=[p];const m=[];for(;c.length;){const f=c.shift();f&&(m.push(f.pid),f.children&&(c=c.concat(f.children)))}let b=JSON.stringify(a.$Zg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+m.join(" "),(0,P.exec)(b,{},(f,w,I)=>{if(f||I)L(f||new Error(I.toString()));else{const g=w.toString().split(`
`);for(let u=0;u<m.length;u++){const t=S.get(m[u]);t.load=parseFloat(g[u])}if(!p){L(new Error(`Root process ${T} not found`));return}A(p)}})};(0,P.exec)("which ps",{},(c,m,b)=>{if(c||b)if(process.platform!=="linux")L(c||new Error(b.toString()));else{const f=JSON.stringify(a.$Zg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(f,{},(w,I,g)=>{w||g?L(w||new Error(g.toString())):(O(I,d),$())})}else{const f=m.toString().trim();(0,P.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,g,u)=>{I||u&&!u.includes("screen size is bogus")?L(I||new Error(u.toString())):(O(g,d),process.platform==="linux"?$():p?A(p):L(new Error(`Root process ${T} not found`)))})}})}})}function O(T,A){const L=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=T.toString().split(`
`);for(const S of p){const d=L.exec(S.trim());d&&d.length===6&&A(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}});var ve=this&&this.__decorate||function(ne,e,P,a){var N=arguments.length,O=N<3?e:a===null?a=Object.getOwnPropertyDescriptor(e,P):a,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ne,e,P,a);else for(var A=ne.length-1;A>=0;A--)(T=ne[A])&&(O=(N<3?T(O):N>3?T(e,P,O):T(e,P))||O);return N>3&&O&&Object.defineProperty(e,P,O),O};define(le[43],he([0,1,19,6,15,26,88,8,3,2,68,27,13]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=o,e.$gi=l,e.$li=C,e.$mi=U,d=ke(d);var $;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})($||($={}));function c(V){switch(V){case $.Promise:return"req";case $.PromiseCancel:return"cancel";case $.EventListen:return"subscribe";case $.EventDispose:return"unsubscribe"}}var m;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(m||(m={}));function b(V){switch(V){case m.Initialize:return"init";case m.PromiseSuccess:return"reply:";case m.PromiseError:case m.PromiseErrorObj:return"replyErr:";case m.EventFire:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function w(V){let z=0;for(let ee=0;;ee+=7){const re=V.read(1);if(z|=(re.buffer[0]&127)<<ee,!(re.buffer[0]&128))return z}}const I=r(0);function g(V,z){if(z===0){V.write(I);return}let ee=0;for(let ce=z;ce!==0;ce=ce>>>7)ee++;const re=N.$Oe.alloc(ee);for(let ce=0;z!==0;ce++)re.buffer[ce]=z&127,z=z>>>7,z>0&&(re.buffer[ce]|=128);V.write(re)}class u{constructor(z){this.b=z,this.a=0}read(z){const ee=this.b.slice(this.a,this.a+z);return this.a+=ee.byteLength,ee}}e.$di=u;class t{constructor(){this.a=[]}get buffer(){return N.$Oe.concat(this.a)}write(z){this.a.push(z)}}e.$ei=t;var s;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(s||(s={}));function r(V){const z=N.$Oe.alloc(1);return z.writeUInt8(V,0),z}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},n=typeof Buffer<"u";function o(V,z){if(typeof z>"u")V.write(i.Undefined);else if(typeof z=="string"){const ee=N.$Oe.fromString(z);V.write(i.String),g(V,ee.byteLength),V.write(ee)}else if(n&&Buffer.isBuffer(z)){const ee=N.$Oe.wrap(z);V.write(i.Buffer),g(V,ee.byteLength),V.write(ee)}else if(z instanceof N.$Oe)V.write(i.VSBuffer),g(V,z.byteLength),V.write(z);else if(Array.isArray(z)){V.write(i.Array),g(V,z.length);for(const ee of z)o(V,ee)}else if(typeof z=="number"&&(z|0)===z)V.write(i.Uint),g(V,z);else{const ee=N.$Oe.fromString(JSON.stringify(z));V.write(i.Object),g(V,ee.byteLength),V.write(ee)}}function l(V){switch(V.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return V.read(w(V)).toString();case s.Buffer:return V.read(w(V)).buffer;case s.VSBuffer:return V.read(w(V));case s.Array:{const ee=w(V),re=[];for(let ce=0;ce<ee;ce++)re.push(l(V));return re}case s.Object:return JSON.parse(V.read(w(V)).toString());case s.Int:return w(V)}}class y{constructor(z,ee,re=null,ce=1e3){this.h=z,this.j=ee,this.k=re,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(q=>this.q(q)),this.m({type:m.Initialize})}registerChannel(z,ee){this.b.set(z,ee),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case m.Initialize:{const ee=this.o([z.type]);this.k?.logOutgoing(ee,0,R.OtherSide,b(z.type));return}case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:{const ee=this.o([z.type,z.id],z.data);this.k?.logOutgoing(ee,z.id,R.OtherSide,b(z.type),z.data);return}}}o(z,ee=void 0){const re=new t;return o(re,z),o(re,ee),this.p(re.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const ee=new u(z),re=l(ee),ce=l(ee),q=re[0];switch(q){case $.Promise:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}: ${re[2]}.${re[3]}`,ce),this.s({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case $.EventListen:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}: ${re[2]}.${re[3]}`,ce),this.t({type:q,id:re[1],channelName:re[2],name:re[3],arg:ce});case $.PromiseCancel:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}`),this.u({type:q,id:re[1]});case $.EventDispose:return this.k?.logIncoming(z.byteLength,re[1],R.OtherSide,`${c(q)}`),this.u({type:q,id:re[1]})}}s(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const re=new O.$xe;let ce;try{ce=ee.call(this.j,z.name,z.arg,re.token)}catch(J){ce=Promise.reject(J)}const q=z.id;ce.then(J=>{this.m({id:q,data:J,type:m.PromiseSuccess})},J=>{J instanceof Error?this.m({id:q,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split(`
`):void 0},type:m.PromiseError}):this.m({id:q,data:J,type:m.PromiseErrorObj})}).finally(()=>{x.dispose(),this.d.delete(z.id)});const x=(0,p.$Uc)(()=>re.cancel());this.d.set(z.id,x)}t(z){const ee=this.b.get(z.channelName);if(!ee){this.v(z);return}const re=z.id,q=ee.listen(this.j,z.name,z.arg)(x=>this.m({id:re,data:x,type:m.EventFire}));this.d.set(z.id,q)}u(z){const ee=this.d.get(z.id);ee&&(ee.dispose(),this.d.delete(z.id))}v(z){let ee=this.g.get(z.channelName);ee||(ee=[],this.g.set(z.channelName,ee));const re=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===$.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:m.PromiseError})},this.l);ee.push({request:z,timeoutTimer:re})}w(z){const ee=this.g.get(z);if(ee){for(const re of ee)switch(clearTimeout(re.timeoutTimer),re.request.type){case $.Promise:this.s(re.request);break;case $.EventListen:this.t(re.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Rc)(this.d.values()),this.d.clear()}}e.$hi=y;var R;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(R||(e.RequestInitiator=R={}));class k{constructor(z,ee=null){this.l=z,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new L.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ee}getChannel(z){const ee=this;return{call(re,ce,q){return ee.a?Promise.reject(new A.$7):ee.m(z,re,ce,q)},listen(re,ce){return ee.a?L.Event.None:ee.o(z,re,ce)}}}m(z,ee,re,ce=O.CancellationToken.None){const q=this.g++,x=$.Promise,J={id:q,type:x,channelName:z,name:ee,arg:re};if(ce.isCancellationRequested)return Promise.reject(new A.$7);let H;return new Promise((B,j)=>{if(ce.isCancellationRequested)return j(new A.$7);const W=()=>{const ae=ue=>{switch(ue.type){case m.PromiseSuccess:this.f.delete(q),B(ue.data);break;case m.PromiseError:{this.f.delete(q);const ge=new Error(ue.data.message);ge.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,ge.name=ue.data.name,j(ge);break}case m.PromiseErrorObj:this.f.delete(q),j(ue.data);break}};this.f.set(q,ae),this.p(J)};let te=null;this.b===f.Idle?W():(te=(0,a.$sh)(ae=>this.u()),te.then(()=>{te=null,W()}));const _=()=>{te?(te.cancel(),te=null):this.p({id:q,type:$.PromiseCancel}),j(new A.$7)},Y=ce.onCancellationRequested(_);H=(0,p.$Tc)((0,p.$Uc)(_),Y),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(z,ee,re){const ce=this.g++,q=$.EventListen,x={id:ce,type:q,channelName:z,name:ee,arg:re};let J=null;const H=new L.$me({onWillAddFirstListener:()=>{J=(0,a.$sh)(B=>this.u()),J.then(()=>{J=null,this.d.add(H),this.p(x)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(H),this.p({id:ce,type:$.EventDispose}))}}),D=B=>H.fire(B.data);return this.f.set(ce,D),H.event}p(z){switch(z.type){case $.Promise:case $.EventListen:{const ee=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(ee,z.id,R.LocalSide,`${c(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case $.PromiseCancel:case $.EventDispose:{const ee=this.q([z.type,z.id]);this.j?.logOutgoing(ee,z.id,R.LocalSide,c(z.type));return}}}q(z,ee=void 0){const re=new t;return o(re,z),o(re,ee),this.r(re.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const ee=new u(z),re=l(ee),ce=l(ee),q=re[0];switch(q){case m.Initialize:return this.j?.logIncoming(z.byteLength,0,R.LocalSide,b(q)),this.t({type:re[0]});case m.PromiseSuccess:case m.PromiseError:case m.EventFire:case m.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,re[1],R.LocalSide,b(q),ce),this.t({type:re[0],id:re[1],data:ce})}}t(z){if(z.type===m.Initialize){this.b=f.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return L.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Rc)(this.d.values()),this.d.clear()}}e.$ii=k,ve([T.$0h],k.prototype,"onDidInitializePromise",null);class E{get connections(){const z=[];return this.f.forEach(ee=>z.push(ee)),z}constructor(z,ee,re){this.a=new Map,this.f=new Set,this.g=new L.$me,this.onDidAddConnection=this.g.event,this.h=new L.$me,this.onDidRemoveConnection=this.h.event,this.j=new p.$Vc,this.j.add(z(({protocol:ce,onDidClientDisconnect:q})=>{const x=L.Event.once(ce.onMessage);this.j.add(x(J=>{const H=new u(J),D=l(H),B=new y(ce,D,ee,re),j=new k(ce,ee);this.a.forEach((te,_)=>B.registerChannel(_,te));const W={channelServer:B,channelClient:j,ctx:D};this.f.add(W),this.g.fire(W),this.j.add(q(()=>{B.dispose(),j.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(z,ee){const re=this;return{call(ce,q,x){let J;if((0,h.$tg)(ee)){const D=(0,P.$5b)(re.connections.filter(ee));J=D?Promise.resolve(D):L.Event.toPromise(L.Event.filter(re.onDidAddConnection,ee))}else J=ee.routeCall(re,ce,q);const H=J.then(D=>D.channelClient.getChannel(z));return C(H).call(ce,q,x)},listen(ce,q){if((0,h.$tg)(ee))return re.k(z,ee,ce,q);const x=ee.routeEvent(re,ce,q).then(J=>J.channelClient.getChannel(z));return C(x).listen(ce,q)}}}k(z,ee,re,ce){const q=this;let x;const J=new L.$me({onWillAddFirstListener:()=>{x=new p.$Vc;const H=new L.$se,D=new Map,B=W=>{const _=W.channelClient.getChannel(z).listen(re,ce),Y=H.add(_);D.set(W,Y)},j=W=>{const te=D.get(W);te&&(te.dispose(),D.delete(W))};q.connections.filter(ee).forEach(B),L.Event.filter(q.onDidAddConnection,ee)(B,void 0,x),q.onDidRemoveConnection(j,void 0,x),H.event(J.fire,J,x),x.add(H)},onDidRemoveLastListener:()=>{x?.dispose(),x=void 0}});return J.event}registerChannel(z,ee){this.a.set(z,ee);for(const re of this.f)re.channelServer.registerChannel(z,ee)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=E;class v{constructor(z,ee,re=null){const ce=new t;o(ce,ee),z.send(ce.buffer),this.a=new k(z,re),this.d=new y(z,ee,re)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,ee){this.d.registerChannel(z,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function C(V){return{call(z,ee,re){return V.then(ce=>ce.call(z,ee,re))},listen(z,ee){const re=new L.$ve;return V.then(ce=>re.input=ce.listen(z,ee)),re.event}}}function U(V){let z=!1;return{call(ee,re,ce){return z?V.call(ee,re,ce):(0,a.$Gh)(0).then(()=>z=!0).then(()=>V.call(ee,re,ce))},listen(ee,re){if(z)return V.listen(ee,re);const ce=new L.$ve;return(0,a.$Gh)(0).then(()=>z=!0).then(()=>ce.input=V.listen(ee,re)),ce.event}}}class F{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const ee of z.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await L.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ni=F;var M;(function(V){function z(q,x,J){const H=q,D=J&&J.disableMarshalling,B=new Map;for(const j in H)re(j)&&B.set(j,L.Event.buffer(H[j],!0,void 0,x));return new class{listen(j,W,te){const _=B.get(W);if(_)return _;const Y=H[W];if(typeof Y=="function"){if(ce(W))return Y.call(H,te);if(re(W))return B.set(W,L.Event.buffer(H[W],!0,void 0,x)),B.get(W)}throw new A.$db(`Event not found: ${W}`)}call(j,W,te){const _=H[W];if(typeof _=="function"){if(!D&&Array.isArray(te))for(let ae=0;ae<te.length;ae++)te[ae]=(0,S.$ci)(te[ae]);let Y=_.apply(H,te);return Y instanceof Promise||(Y=Promise.resolve(Y)),Y}throw new A.$db(`Method not found: ${W}`)}}}V.fromService=z;function ee(q,x){const J=x&&x.disableMarshalling;return new Proxy({},{get(H,D){if(typeof D=="string")return x?.properties?.has(D)?x.properties.get(D):ce(D)?function(B){return q.listen(D,B)}:re(D)?q.listen(D):async function(...B){let j;x&&!(0,h.$og)(x.context)?j=[x.context,...B]:j=B;const W=await q.call(D,j);return J?W:(0,S.$ci)(W)};throw new A.$db(`Property not found: ${String(D)}`)}})}V.toService=ee;function re(q){return q[0]==="o"&&q[1]==="n"&&d.$Ff(q.charCodeAt(2))}function ce(q){return/^onDynamic/.test(q)&&d.$Ff(q.charCodeAt(9))}})(M||(e.ProxyChannel=M={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const z=V.toString();if(z!=="[object Object]")return z}return V}function Q(V){return Array.isArray(V)?V.map(K):K(V)}function G(V,z,ee,re,ce,q,x){x=Q(x);const J=X[ce],H=J[re%J.length];let D=[`%c[${V}]%c[${String(z).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${q}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(q)?(D=D.concat(x),D.push(")")):D.push(x),console.log.apply(console,D)}class ie{constructor(z,ee){this.d=z,this.f=ee,this.a=0,this.b=0}logOutgoing(z,ee,re,ce,q){this.b+=z,G(this.d,this.b,z,ee,re,ce,q)}logIncoming(z,ee,re,ce,q){this.a+=z,G(this.f,this.a,z,ee,re,ce,q)}}e.$oi=ie}),define(le[70],he([0,1,15,3,2,43]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(T||(e.SocketDiagnosticsEventType=T={}));var A;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let o=0;function l(R,k){if(!n.has(R)){const E=String(++o);n.set(R,E)}return n.get(R)}function y(R,k,E,v){if(!i.enableDiagnostics)return;const C=l(R,k);if(v instanceof P.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const U=P.$Oe.alloc(v.byteLength);U.set(v),i.records.push({timestamp:Date.now(),id:C,label:k,type:E,buff:U})}else i.records.push({timestamp:Date.now(),id:C,label:k,type:E,data:v})}i.traceSocketEvent=y})(A||(e.SocketDiagnostics=A={}));var L;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(L||(e.SocketCloseEventType=L={}));let p=null;function S(){return p||(p=P.$Oe.alloc(0)),p}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,o){if(n===0)return S();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return o&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return o&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const l=P.$Oe.alloc(n);let y=0,R=0;for(;n>0;){const k=this.a[R];if(k.byteLength>n){const E=k.slice(0,n);l.set(E,y),y+=n,o&&(this.a[R]=k.slice(n),this.b-=n),n-=n}else l.set(k,y),y+=k.byteLength,o?(this.a.shift(),this.b-=k.byteLength):R++,n-=k.byteLength}return l}}e.$pi=d;var h;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(h||(h={}));function $(i){switch(i){case h.None:return"None";case h.Regular:return"Regular";case h.Control:return"Control";case h.Ack:return"Ack";case h.Disconnect:return"Disconnect";case h.ReplayRequest:return"ReplayRequest";case h.Pause:return"PauseWriting";case h.Resume:return"ResumeWriting";case h.KeepAlive:return"KeepAlive"}}var c;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class m{constructor(n,o,l,y){this.type=n,this.id=o,this.ack=l,this.data=y,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends N.$Wc{constructor(n){super(),this.f=this.B(new a.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:c.HeaderLength,messageType:h.None,id:0,ack:0},this.a=n,this.b=!1,this.c=new d,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent(T.ProtocolHeaderRead,{messageType:$(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const l=this.g.messageType,y=this.g.id,R=this.g.ack;if(this.g.readHead=!0,this.g.readLen=c.HeaderLength,this.g.messageType=h.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(T.ProtocolMessageRead,o),this.f.fire(new m(l,y,R,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=P.$Oe.alloc(c.HeaderLength);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent(T.ProtocolHeaderWrite,{messageType:$(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent(T.ProtocolMessageWrite,n.data),this.j(o,n.data)}g(n,o){const l=this.f===0;return this.d.push(n,o),this.f+=n.byteLength+o.byteLength,l}h(){const n=P.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,o){this.g(n,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent(T.ProtocolWrite,{byteLength:n.byteLength}),this.c.write(n)}}class w extends N.$Wc{constructor(n){super(),this.f=new a.$me,this.onMessage=this.f.event,this.g=new a.$me,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(o=>{o.type===h.Regular&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(h.Regular,0,0,n))}}e.$qi=w;class I extends O.$ki{static fromSocket(n,o){return new I(new w(n),o)}get onDidDispose(){return this.b.onDidDispose}constructor(n,o,l=null){super(n,o,l),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$ri=I;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new a.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$si=g;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,o=this.a;for(;o;)o=o.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let o=0,l=this.a;for(;l;)n[o++]=l.data,l=l.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const o=new u(n);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let o=0;o<s.a;o++)this.c[o]=n-1e3*o;setInterval(()=>{for(let o=s.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),o=(1+s.a)*1e3;let l=0;for(let y=0;y<s.a;y++)n-this.c[y]<=o&&l++;return 1-l/s.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new N.$Vc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},c.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(h.Disconnect,0,0,S());this.p.write(n),this.p.flush()}sendPause(){const n=new m(h.Pause,0,0,S());this.p.write(n)}sendResume(){const n=new m(h.Resume,0,0,S());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,o){this.a=!0,this.r.dispose(),this.r=new N.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(h.Ack,0,this.h,S());this.p.write(n);const o=this.b.toArray();for(let l=0,y=o.length;l<y;l++)this.p.write(o[l]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const o=this.b.peek();if(o&&o.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case h.None:break;case h.Regular:{if(n.id>this.g)if(n.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new m(h.ReplayRequest,0,0,S())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case h.Control:{this.u.fire(n.data);break}case h.Ack:break;case h.Disconnect:{this.w.fire();break}case h.ReplayRequest:{const o=this.b.toArray();for(let l=0,y=o.length;l<y;l++)this.p.write(o[l]);this.B();break}case h.Pause:{this.p.pause();break}case h.Resume:{this.p.resume();break}case h.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const o=++this.c;this.h=this.g;const l=new m(h.Regular,o,this.h,n);this.b.push(l),this.a||(this.p.write(l),this.B())}sendControl(n){const o=new m(h.Control,0,0,n);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=c.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},c.AcknowledgeTime-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),o=Date.now()-n.writtenTime,l=Date.now()-this.q.lastReadTime,y=Date.now()-this.n;if(o>=c.TimeoutTime&&l>=c.TimeoutTime&&y>=c.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:l});return}const R=Math.max(c.TimeoutTime-o,c.TimeoutTime-l,c.TimeoutTime-y,500);this.f=setTimeout(()=>{this.f=null,this.B()},R)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(h.Ack,0,this.h,S());this.p.write(n)}D(){this.h=this.g;const n=new m(h.KeepAlive,0,this.h,S());this.p.write(n)}}e.$ti=r}),define(le[96],he([0,1,69,6,15,26,148,8,3,2,30,155,93,43]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0,A=ke(A);class c extends $.$hi{constructor(f){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:L.Event.fromNodeEventEmitter(process,"message",w=>N.$Oe.wrap(Buffer.from(w,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$br=c;class m{constructor(f,w){this.i=f,this.j=w,this.c=new Set,this.g=new Map,this.h=new L.$me,this.onDidProcessExit=this.h.event;const I=w&&w.timeout?w.timeout:6e4;this.b=new a.$Ch(I),this.d=null,this.f=null}getChannel(f){const w=this;return{call(I,g,u){return w.k(f,I,g,u)},listen(I,g){return w.l(f,I,g)}}}k(f,w,I,g=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(A.$8());this.b.cancel();const u=this.n(f),t=(0,a.$sh)(i=>u.call(w,I,i)),s=g.onCancellationRequested(()=>t.cancel()),r=(0,p.$Uc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{s.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,w,I){if(!this.b)return L.Event.None;this.b.cancel();let g;const u=new L.$me({onWillAddFirstListener:()=>{g=this.n(f).listen(w,I)(u.fire,u),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,S.$co)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,h.$lm)(w.env),this.d=(0,P.fork)(this.i,f,w);const I=new L.$me,u=L.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,T.$0q)(o)){(0,T.log)(o,`IPC Library: ${this.j.serverName}`);return}I.fire(N.$Oe.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,d.$ym)(this.d):this.d,s=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),r=I.event,i={send:s,onMessage:r};this.f=new $.$ii(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",n),u.dispose(),this.c.forEach(y=>(0,p.$Rc)(y)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(f){let w=this.g.get(f);return w||(w=this.m.getChannel(f),this.g.set(f,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$cr=m}),define(le[157],he([0,1,140,15,43,3,13,19]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=void 0,e.$OX=S;class L{constructor(h){this.a=h,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",$=>$.data?a.$Oe.wrap($.data):a.$Oe.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}class p extends N.$ji{static b(h){(0,T.$pg)((0,P.$MX)(process),"Electron Utility Process");const $=new O.$me;return process.parentPort.on("message",c=>{if(h?.handledClientConnection(c))return;const m=(0,A.$Qb)(c.ports);m&&$.fire(m)}),O.Event.map($.event,c=>({protocol:new L(c),onDidClientDisconnect:O.Event.fromNodeEventEmitter(c,"close")}))}constructor(h){super(p.b(h))}}e.$NX=p;function S(d,h,$){const c=m=>{m.data===h&&(d.removeListener("message",c),$())};d.on("message",c)}}),define(le[71],he([0,1,6,3,2,68,13]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.StorageState=e.StorageHint=void 0,e.$0p=L;var A;(function(h){h[h.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",h[h.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function L(h){const $=h;return $?.changed instanceof Map||$?.deleted instanceof Set}var p;(function(h){h[h.None=0]="None",h[h.Initialized=1]="Initialized",h[h.Closed=2]="Closed"})(p||(e.StorageState=p={}));class S extends N.$Wc{static{this.a=100}constructor($,c=Object.create(null)){super(),this.r=$,this.s=c,this.b=this.B(new a.$pe),this.onDidChangeStorage=this.b.event,this.c=p.None,this.f=new Map,this.g=this.B(new P.$Dh(S.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal($=>this.u($)))}u($){this.b.pause();try{$.changed?.forEach((c,m)=>this.w(m,c)),$.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w($,c){if(this.c===p.Closed)return;let m=!1;(0,T.$og)(c)?m=this.f.delete($):this.f.get($)!==c&&(this.f.set($,c),m=!0),m&&this.b.fire({key:$,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===p.None&&(this.c=p.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get($,c){const m=this.f.get($);return(0,T.$og)(m)?c:m}getBoolean($,c){const m=this.get($);return(0,T.$og)(m)?c:m==="true"}getNumber($,c){const m=this.get($);return(0,T.$og)(m)?c:parseInt(m,10)}getObject($,c){const m=this.get($);return(0,T.$og)(m)?c:(0,O.$bi)(m)}async set($,c,m=!1){if(this.c===p.Closed)return;if((0,T.$og)(c))return this.delete($,m);const b=(0,T.$hg)(c)||Array.isArray(c)?(0,O.$ai)(c):String(c);if(this.f.get($)!==b)return this.f.set($,b),this.j.set($,b),this.h.delete($),this.b.fire({key:$,external:m}),this.D()}async delete($,c=!1){if(!(this.c===p.Closed||!this.f.delete($)))return this.h.has($)||this.h.add($),this.j.delete($),this.b.fire({key:$,external:c}),this.D()}async optimize(){if(this.c!==p.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=p.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const $={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems($).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush($){if(!(this.c===p.Closed||this.m))return this.D($)}async D($){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),$)}async whenFlushed(){if(this.z)return new Promise($=>this.n.push($))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$$p=S;class d{constructor(){this.onDidChangeItemsExternal=a.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems($){$.insert?.forEach((c,m)=>this.a.set(m,c)),$.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$_p=d}),define(le[158],he([12,11]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[72],he([0,1,46,6,14,13,31,158]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=e.$uq=void 0,e.zip=b,e.$xq=f,e.$yq=I,N=ke(N),A=ke(A),e.$uq="end of central directory record signature not found";const L=new RegExp(e.$uq);class p extends Error{constructor(u,t){let s=t.message;switch(u){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=u,this.cause=t}}e.$vq=p;function S(g){const u=g.externalFileAttributes>>16||33188;return[448,56,7].map(t=>u&t).reduce((t,s)=>t+s,u&61440)}function d(g){if(g instanceof p)return g;let u;return L.test(g.message)&&(u="CorruptZip"),new p(u,g)}function h(g,u,t,s,r,i){const n=N.$oc(u),o=N.$lc(s,n);if(!o.startsWith(s))return Promise.reject(new Error(A.localize(0,null,u)));const l=N.$lc(s,u);let y;return i.onCancellationRequested(()=>{y?.destroy()}),Promise.resolve(T.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((R,k)=>{if(!i.isCancellationRequested)try{y=(0,P.createWriteStream)(l,{mode:t}),y.once("close",()=>R()),y.once("error",k),g.once("error",k),g.pipe(y)}catch(E){k(E)}}))}function $(g,u,t,s){let r=(0,a.$sh)(()=>Promise.resolve()),i=0;const n=s.onCancellationRequested(()=>{r.cancel(),g.close()});return new Promise((o,l)=>{const y=new a.$Ah,R=k=>{k.isCancellationRequested||(i++,g.readEntry())};g.once("error",l),g.once("close",()=>r.then(()=>{s.isCancellationRequested||g.entryCount===i?o():l(new p("Incomplete",new Error(A.localize(1,null,i,g.entryCount))))},l)),g.readEntry(),g.on("entry",k=>{if(s.isCancellationRequested)return;if(!t.sourcePathRegex.test(k.fileName)){R(s);return}const E=k.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(E)){const U=N.$lc(u,E);r=(0,a.$sh)(F=>T.Promises.mkdir(U,{recursive:!0}).then(()=>R(F)).then(void 0,l));return}const v=m(g,k),C=S(k);r=(0,a.$sh)(U=>y.queue(()=>v.then(F=>h(F,E,C,u,t,U).then(()=>R(U)))).then(null,l))})}).finally(()=>n.dispose())}async function c(g,u=!1){const{open:t}=await new Promise((s,r)=>{ne(["yauzl"],s,r)}).then(ke);return new Promise((s,r)=>{t(g,u?{lazyEntries:!0}:void 0,(i,n)=>{i?r(d(i)):s((0,O.$qg)(n))})})}function m(g,u){return new Promise((t,s)=>{g.openReadStream(u,(r,i)=>{r?s(d(r)):t((0,O.$qg)(i))})})}async function b(g,u){const{ZipFile:t}=await new Promise((s,r)=>{ne(["yazl"],s,r)}).then(ke);return new Promise((s,r)=>{const i=new t;u.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const n=(0,P.createWriteStream)(g);i.outputStream.pipe(n),i.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>s(g))})}function f(g,u,t={},s){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=c(g,!0);return t.overwrite&&(i=i.then(n=>T.Promises.rm(u).then(()=>n))),i.then(n=>$(n,u,{sourcePathRegex:r},s))}function w(g,u){return c(g).then(t=>new Promise((s,r)=>{t.on("entry",i=>{i.fileName===u&&m(t,i).then(n=>s(n),n=>r(n))}),t.once("close",()=>r(new Error(A.localize(2,null,u))))}))}function I(g,u){return w(g,u).then(t=>new Promise((s,r)=>{const i=[];t.once("error",r),t.on("data",n=>i.push(n)),t.on("end",()=>s(Buffer.concat(i)))}))}}),define(le[159],he([12,11]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[160],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[161],he([12,11]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[162],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[163],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[164],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[165],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[166],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[167],he([12,11]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[168],he([12,11]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[169],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[170],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[171],he([12,11]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[172],he([12,11]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[173],he([12,11]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[174],he([12,11]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(le[175],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[176],he([12,11]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[177],he([12,11]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[178],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[179],he([12,11]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[180],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[181],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[182],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[183],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[184],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[185],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[186],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[187],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[188],he([12,11]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[189],he([12,11]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[190],he([0,1,39,8,161]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var O;(function(S){S[S.LParen=0]="LParen",S[S.RParen=1]="RParen",S[S.Neg=2]="Neg",S[S.Eq=3]="Eq",S[S.NotEq=4]="NotEq",S[S.Lt=5]="Lt",S[S.LtEq=6]="LtEq",S[S.Gt=7]="Gt",S[S.GtEq=8]="GtEq",S[S.RegexOp=9]="RegexOp",S[S.RegexStr=10]="RegexStr",S[S.True=11]="True",S[S.False=12]="False",S[S.In=13]="In",S[S.Not=14]="Not",S[S.And=15]="And",S[S.Or=16]="Or",S[S.Str=17]="Str",S[S.QuotedStr=18]="QuotedStr",S[S.Error=19]="Error",S[S.EOF=20]="EOF"})(O||(e.TokenType=O={}));function T(...S){switch(S.length){case 1:return(0,N.localize)(0,null,S[0]);case 2:return(0,N.localize)(1,null,S[0],S[1]);case 3:return(0,N.localize)(2,null,S[0],S[1],S[2]);default:return}}const A=(0,N.localize)(3,null),L=(0,N.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return d.isTripleEq?"===":"==";case O.NotEq:return d.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return d.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return d.lexeme;case O.QuotedStr:return d.lexeme;case O.Error:return d.lexeme;case O.EOF:return"EOF";default:throw(0,a.$0)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case P.CharCode.OpenParen:this.k(O.LParen);break;case P.CharCode.CloseParen:this.k(O.RParen);break;case P.CharCode.ExclamationMark:if(this.h(P.CharCode.Equals)){const h=this.h(P.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:h})}else this.k(O.Neg);break;case P.CharCode.SingleQuote:this.o();break;case P.CharCode.Slash:this.q();break;case P.CharCode.Equals:if(this.h(P.CharCode.Equals)){const h=this.h(P.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:h})}else this.h(P.CharCode.Tilde)?this.k(O.RegexOp):this.l(T("==","=~"));break;case P.CharCode.LessThan:this.k(this.h(P.CharCode.Equals)?O.LtEq:O.Lt);break;case P.CharCode.GreaterThan:this.k(this.h(P.CharCode.Equals)?O.GtEq:O.Gt);break;case P.CharCode.Ampersand:this.h(P.CharCode.Ampersand)?this.k(O.And):this.l(T("&&"));break;case P.CharCode.Pipe:this.h(P.CharCode.Pipe)?this.k(O.Or):this.l(T("||"));break;case P.CharCode.Space:case P.CharCode.CarriageReturn:case P.CharCode.Tab:case P.CharCode.LineFeed:case P.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?P.CharCode.Null:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const h=this.d,$=this.c.substring(this.d,this.e),c={type:O.Error,offset:this.d,lexeme:$};this.g.push({offset:h,lexeme:$,additionalInfo:d}),this.f.push(c)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const h=this.c.substring(this.d,this.e),$=p.b.get(h);$?this.k($):this.f.push({type:O.Str,lexeme:h,offset:this.d})}}o(){for(;this.j()!==P.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,h=!1,$=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(L);return}const m=this.c.charCodeAt(d);if(h)h=!1;else if(m===P.CharCode.Slash&&!$){d++;break}else m===P.CharCode.OpenSquareBracket?$=!0:m===P.CharCode.Backslash?h=!0:m===P.CharCode.CloseSquareBracket&&($=!1);d++}for(;d<this.c.length&&p.a.has(this.c.charCodeAt(d));)d++;this.e=d;const c=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=p}),define(le[191],he([0,1,67,88,23,14,36,21,9]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=S,e.$7m=d,e.$4m=/^([^.]+\..+)[:=](.+)$/;class p{get appRoot(){return(0,O.$oc)(N.$Zg.asFileUri("").fsPath)}get userHome(){return L.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return L.URI.file((0,O.$lc)(this.userDataPath,"User"))}get tmpDir(){return L.URI.file(this.b.tmpDir)}get cacheHome(){return L.URI.file(this.userDataPath)}get stateResource(){return(0,A.$gh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$gh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const $=(0,P.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.$lc)(this.userDataPath,"logs",$)}return L.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$gh)(L.URI.file((0,O.$lc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$gh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$gh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$gh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const $=T.env.VSCODE_PORTABLE;return $?L.URI.file((0,O.$lc)($,"argv.json")):(0,A.$gh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return L.URI.file((0,O.$lc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const $=this.args["builtin-extensions-dir"];return $?(0,O.$mc)($):(0,O.$jc)((0,O.$lc)(N.$Zg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const $=this.args["extensions-download-dir"];return $?L.URI.file((0,O.$mc)($)):L.URI.file((0,O.$lc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const $=this.args["extensions-dir"];if($)return(0,O.$mc)($);const c=T.env.VSCODE_EXTENSIONS;if(c)return c;const m=T.env.VSCODE_PORTABLE;return m?(0,O.$lc)(m,"extensions"):(0,A.$gh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const $=this.args.extensionDevelopmentPath;if(Array.isArray($))return $.map(c=>/^[^:/?#]+?:\/\//.test(c)?L.URI.parse(c):L.URI.file((0,O.$jc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map($=>$==="ui"||$==="workspace"||$==="web"?$:"workspace")}get extensionTestsLocationURI(){const $=this.args.extensionTestsPath;if($)return/^[^:/?#]+?:\/\//.test($)?L.URI.parse($):L.URI.file((0,O.$jc)($))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const $=this.args["disable-extension"];if($){if(typeof $=="string")return[$];if(Array.isArray($)&&$.length>0)return $}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find($=>!e.$4m.test($))}get extensionLogLevel(){const $=[];for(const c of this.args.log||[]){const m=e.$4m.exec(c);m&&m[1]&&m[2]&&$.push([m[1],m[2]])}return $.length?$:void 0}get serviceMachineIdResource(){return(0,A.$gh)(L.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const $=T.env.VSCODE_PORTABLE;return $?L.URI.file((0,O.$lc)($,"policy.json")):(0,A.$gh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn($){this.args.continueOn=$}get args(){return this.a}constructor($,c,m){this.a=$,this.b=c,this.c=m,this.editSessionId=this.args.editSessionId}}e.$5m=p,ve([a.$0h],p.prototype,"appRoot",null),ve([a.$0h],p.prototype,"userHome",null),ve([a.$0h],p.prototype,"userDataPath",null),ve([a.$0h],p.prototype,"appSettingsHome",null),ve([a.$0h],p.prototype,"tmpDir",null),ve([a.$0h],p.prototype,"cacheHome",null),ve([a.$0h],p.prototype,"stateResource",null),ve([a.$0h],p.prototype,"userRoamingDataHome",null),ve([a.$0h],p.prototype,"userDataSyncHome",null),ve([a.$0h],p.prototype,"sync",null),ve([a.$0h],p.prototype,"machineSettingsResource",null),ve([a.$0h],p.prototype,"workspaceStorageHome",null),ve([a.$0h],p.prototype,"localHistoryHome",null),ve([a.$0h],p.prototype,"keyboardLayoutResource",null),ve([a.$0h],p.prototype,"argvResource",null),ve([a.$0h],p.prototype,"isExtensionDevelopment",null),ve([a.$0h],p.prototype,"untitledWorkspacesHome",null),ve([a.$0h],p.prototype,"builtinExtensionsPath",null),ve([a.$0h],p.prototype,"extensionsPath",null),ve([a.$0h],p.prototype,"extensionDevelopmentLocationURI",null),ve([a.$0h],p.prototype,"extensionDevelopmentKind",null),ve([a.$0h],p.prototype,"extensionTestsLocationURI",null),ve([a.$0h],p.prototype,"debugExtensionHost",null),ve([a.$0h],p.prototype,"logLevel",null),ve([a.$0h],p.prototype,"extensionLogLevel",null),ve([a.$0h],p.prototype,"serviceMachineIdResource",null),ve([a.$0h],p.prototype,"disableTelemetry",null),ve([a.$0h],p.prototype,"disableWorkspaceTrust",null),ve([a.$0h],p.prototype,"useInMemorySecretStorage",null),ve([a.$0h],p.prototype,"policyFile",null);function S(h,$){return d(h["inspect-extensions"],h["inspect-brk-extensions"],5870,$,h.debugId,h.extensionEnvironment)}function d(h,$,c,m,b,f){const I=Number($||h)||(m?null:c),g=I?!!$:!1;let u;if(f)try{u=JSON.parse(f)}catch{}return{port:I,break:g,debugId:b,env:u}}}),function(){"use strict";function ne(e,P,a){function N(T,A){const L=O(T,A),p=[L];return e.isAbsolute(L)||p.unshift(a),e.resolve(...p)}function O(T,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const L=process.env.VSCODE_PORTABLE;if(L)return e.join(L,"user-data");let p=process.env.VSCODE_APPDATA;if(p)return e.join(p,A);const S=T["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(p=process.env.APPDATA,!p){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");p=e.join(d,"AppData","Roaming")}break;case"darwin":p=e.join(P.homedir(),"Library","Application Support");break;case"linux":p=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(p,A)}return{getUserDataPath:N}}if(typeof define=="function")define(le[192],he([279,38,36]),function(e,P,a){return ne(e,P,a.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=ne(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[193],he([0,1,38,191,192]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=T,e.$0m=A;class O extends a.$5m{constructor(p,S){super(p,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,N.getUserDataPath)(p,S.nameShort)},S)}}e.$8m=O;function T(L,p){return(0,a.$7m)(L["inspect-ptyhost"],L["inspect-brk-ptyhost"],5877,p,L.extensionEnvironment)}function A(L,p){return(0,a.$7m)(L["inspect-sharedprocess"],L["inspect-brk-sharedprocess"],5879,p,L.extensionEnvironment)}}),define(le[194],he([0,1,13,164]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=N;function N(T,A,L,p){try{O(T,A,L,p)}catch(S){T.error(S?.message??S)}return A}function O(T,A,L,p){const S=(d,h,$)=>{const c=d[h];if((0,P.$fg)(c)){const m=c,b=m.length;if(b>1&&m[0]==="%"&&m[b-1]==="%"){const f=m.substr(1,b-2);let w=L[f];w===void 0&&p&&(w=p[f]);const I=typeof w=="string"?w:w?.message,g=p?.[f],u=typeof g=="string"?g:g?.message;if(!I){u||T.warn(`[${A.name}]: ${(0,a.localize)(0,null,f)}`);return}if($&&(h==="title"||h==="category")&&u&&u!==I){const t={value:I,original:u};d[h]=t}else d[h]=I}}else if((0,P.$hg)(c))for(const m in c)c.hasOwnProperty(m)&&(m==="commands"?S(c,m,!0):S(c,m,$));else if(Array.isArray(c))for(let m=0;m<c.length;m++)S(c,m,$)};for(const d in A)A.hasOwnProperty(d)&&S(A,d)}}),define(le[195],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=void 0;class P{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.a.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Xgc=P;class a{constructor(O){this.a=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,A){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(A[0])}throw new Error(`Call not found: ${T}`)}}e.$Ygc=a});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[73],he([0,1,21,92,168,57]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=L,e.$Vp=p,e.$Wp=S,e.$Xp=d,e.$Yp=h,e.$Zp=$,e.$1p=c,a=it(a),N=ke(N),O=ke(O);const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||T.test(f)}function p(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=f.match(T);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function S(f){if(!f)return null;const w=f.majorBase,I=f.majorMustEqual,g=f.minorBase;let u=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(w===0||(u=!1),s=!1);let r=0;if(f.preRelease){const i=A.exec(f.preRelease);if(i){const[,n,o,l]=i;r=Date.UTC(Number(n),Number(o)-1,Number(l))}}return{majorBase:w,majorMustEqual:I,minorBase:g,minorMustEqual:u,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:r}}function d(f,w,I){let g;typeof f=="string"?g=S(p(f)):g=f;let u;w instanceof Date?u=w.getTime():typeof w=="string"&&(u=new Date(w).getTime());let t;if(typeof I=="string"?t=S(p(I)):t=I,!g||!t)return!1;const s=g.majorBase,r=g.minorBase,i=g.patchBase;let n=t.majorBase,o=t.minorBase,l=t.patchBase;const y=t.notBefore;let R=t.majorMustEqual,k=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:r>o?!0:r<o||u&&u<y?!1:i>=l:(s===1&&n===0&&(!R||!k||!E)&&(n=1,o=0,l=0,R=!0,k=!1,E=!1),s<n?!1:s>n?!R:r<o?!1:r>o?!k:i<l?!1:i>l?!E:!(u&&u<y))}function h(f,w,I,g,u){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([a.default.Error,N.localize(0,null)]),t;if(typeof g.name!="string")return t.push([a.default.Error,N.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([a.default.Error,N.localize(2,null,"version")]),t;if(!g.engines)return t.push([a.default.Error,N.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([a.default.Error,N.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!b(g.extensionDependencies))return t.push([a.default.Error,N.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!b(g.activationEvents))return t.push([a.default.Error,N.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([a.default.Error,N.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([a.default.Warning,N.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([a.default.Error,N.localize(9,null,"main")]),t;{const i=(0,P.$gh)(I,g.main);(0,P.$ah)(i,I)||t.push([a.default.Warning,N.localize(10,null,i.path,I.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([a.default.Error,N.localize(11,null,"browser")]),t;{const i=(0,P.$gh)(I,g.browser);(0,P.$ah)(i,I)||t.push([a.default.Warning,N.localize(12,null,i.path,I.path)])}}if(!O.valid(g.version))return t.push([a.default.Error,N.localize(13,null)]),t;const s=[];if(!$(f,w,g,u,s))for(const i of s)t.push([a.default.Error,i]);return t}function $(f,w,I,g,u){return g||typeof I.main>"u"&&typeof I.browser>"u"?!0:m(f,w,I.engines.vscode,u)}function c(f,w,I){return f==="*"||m(w,I,f)}function m(f,w,I,g=[]){const u=S(p(I));if(!u)return g.push(N.localize(14,null,I)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return g.push(N.localize(15,null,I)),!1}else if(!u.majorMustEqual)return g.push(N.localize(16,null,I)),!1;return d(f,w,u)?!0:(g.push(N.localize(17,null,f,I)),!1)}function b(f){if(!Array.isArray(f))return!1;for(let w=0,I=f.length;w<I;w++)if(typeof f[w]!="string")return!1;return!0}}),define(le[74],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class P{constructor(N,O=[],T=!1){this.ctor=N,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.$Ci=P}),define(le[196],he([0,1,74]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ls=O,e.$Ms=T;const a=[];var N;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(N||(e.InstantiationType=N={}));function O(A,L,p){L instanceof P.$Ci||(L=new P.$Ci(L,[],!!p)),a.push([A,L])}function T(){return a}}),define(le[197],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=void 0;class P{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.$or=P;class a{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const A=this.lookupOrInsertNode(O),L=this.lookupOrInsertNode(T);A.outgoing.set(L.key,L),L.incoming.set(A.key,A)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const A of this.a.values())A.outgoing.delete(T),A.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let A=this.a.get(T);return A||(A=new P(T,O),this.a.set(T,A)),A}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,A]of this.a)O.push(`${T}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const A=new Set([O]),L=this.c(T,A);if(L)return L}}c(O,T){for(const[A,L]of O.outgoing){if(T.has(A))return[...T,A].join(" -> ");T.add(A);const p=this.c(L,T);if(p)return p;T.delete(A)}}}e.$pr=a}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=N,e.$Gi=O;var P;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function A(L){return L[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=A})(P||(e._util=P={})),e.$Ei=N("instantiationService");function a(T,A,L){A[P.DI_TARGET]===A?A[P.DI_DEPENDENCIES].push({id:T,index:L}):(A[P.DI_DEPENDENCIES]=[{id:T,index:L}],A[P.DI_TARGET]=A)}function N(T){if(P.serviceIds.has(T))return P.serviceIds.get(T);const A=function(L,p,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");a(A,L,S)};return A.toString=()=>T,P.serviceIds.set(T,A),A}function O(T){return T}}),define(le[198],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0,e.$xgc=(0,P.$Fi)("checksumService")}),define(le[22],he([0,1,13,9,4]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=O,e.$bj=T,e.$cj=L,e.$dj=p,e.$ej=S,e.$fj=d,e.$gj=h,e.$hj=c,e.$ij=m,e.$jj=b,P=ke(P),e.$_i=(0,N.$Fi)("configurationService");function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof a.URI)}function T(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof a.URI)}var A;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function L(f){switch(f){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function p(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function S(f,w){const I=Object.create(null);for(const g in f)d(I,g,f[g],w);return I}function d(f,w,I,g){const u=w.split("."),t=u.pop();let s=f;for(let r=0;r<u.length;r++){const i=u[r];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":if(n===null){g(`Ignoring ${w} as ${u.slice(0,r+1).join(".")} is null`);return}break;default:g(`Ignoring ${w} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=I}catch{g(`Ignoring ${w} as ${u.join(".")} is ${JSON.stringify(s)}`)}else g(`Ignoring ${w} as ${u.join(".")} is ${JSON.stringify(s)}`)}function h(f,w){const I=w.split(".");$(f,I)}function $(f,w){const I=w.shift();if(w.length===0){delete f[I];return}if(Object.keys(f).indexOf(I)!==-1){const g=f[I];typeof g=="object"&&!Array.isArray(g)&&($(g,w),Object.keys(g).length===0&&delete f[I])}}function c(f,w,I){function g(s,r){let i=s;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=w.split("."),t=g(f,u);return typeof t>"u"?I:t}function m(f,w,I){Object.keys(w).forEach(g=>{g!=="__proto__"&&(g in f?P.$hg(f[g])&&P.$hg(w[g])?m(f[g],w[g],I):I&&(f[g]=w[g]):f[g]=w[g])})}function b(f){return f.replace(/[\[\]]/g,"")}}),define(le[97],he([0,1,39,5,27,190,4,160,8]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=S,e.$Ej=r,e.$Fj=i,e.$Yj=q;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",a.$j),p.set("isLinux",a.$k),p.set("isWindows",a.$i),p.set("isWeb",a.$o),p.set("isMacNative",a.$j&&!a.$o),p.set("isEdge",a.$H),p.set("isFirefox",a.$F),p.set("isChrome",a.$E),p.set("isSafari",a.$G);function S(H,D){if(p.get(H)!==void 0)throw(0,L.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(H,D)}const d=Object.prototype.hasOwnProperty;var h;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(h||(e.ContextKeyExprType=h={}));const $={regexParsingWithErrorRecovery:!0},c=(0,A.localize)(0,null),m=(0,A.localize)(1,null),b=(0,A.localize)(2,null),f=(0,A.localize)(3,null),w=(0,A.localize)(4,null),I=(0,A.localize)(5,null),g=(0,A.localize)(6,null),u=(0,A.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(D=$){this.k=D,this.d=new O.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(D){if(D===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(D).scan(),this.g=0,this.h=[];try{const B=this.l();if(!this.E()){const j=this.D(),W=j.type===O.TokenType.Str?I:void 0;throw this.h.push({message:w,offset:j.offset,lexeme:O.$Aj.getLexeme(j),additionalInfo:W}),t.c}return B}catch(B){if(B!==t.c)throw B;return}}l(){return this.m()}m(){const D=[this.o()];for(;this.y(O.TokenType.Or);){const B=this.o();D.push(B)}return D.length===1?D[0]:s.or(...D)}o(){const D=[this.s()];for(;this.y(O.TokenType.And);){const B=this.s();D.push(B)}return D.length===1?D[0]:s.and(...D)}s(){if(this.y(O.TokenType.Neg)){const D=this.D();switch(D.type){case O.TokenType.True:return this.z(),o.INSTANCE;case O.TokenType.False:return this.z(),l.INSTANCE;case O.TokenType.LParen:{this.z();const B=this.l();return this.A(O.TokenType.RParen,f),B?.negate()}case O.TokenType.Str:return this.z(),C.create(D.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",D)}}return this.t()}t(){const D=this.D();switch(D.type){case O.TokenType.True:return this.z(),s.true();case O.TokenType.False:return this.z(),s.false();case O.TokenType.LParen:{this.z();const B=this.l();return this.A(O.TokenType.RParen,f),B}case O.TokenType.Str:{const B=D.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const W=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),W.type!==O.TokenType.RegexStr)throw this.B("REGEX",W);const te=W.lexeme,_=te.lastIndexOf("/"),Y=_===te.length-1?void 0:this.w(te.substring(_+1));let ae;try{ae=new RegExp(te.substring(1,_),Y)}catch{throw this.B("REGEX",W)}return Q.create(B,ae)}switch(W.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const te=[W.lexeme];this.z();let _=this.D(),Y=0;for(let Ee=0;Ee<W.lexeme.length;Ee++)W.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Y++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Y--;for(;!this.E()&&_.type!==O.TokenType.And&&_.type!==O.TokenType.Or;){switch(_.type){case O.TokenType.LParen:Y++;break;case O.TokenType.RParen:Y--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ee=0;Ee<_.lexeme.length;Ee++)_.lexeme.charCodeAt(Ee)===P.CharCode.OpenParen?Y++:W.lexeme.charCodeAt(Ee)===P.CharCode.CloseParen&&Y--}if(Y<0)break;te.push(O.$Aj.getLexeme(_)),this.z(),_=this.D()}const ae=te.join(""),ue=ae.lastIndexOf("/"),ge=ue===ae.length-1?void 0:this.w(ae.substring(ue+1));let we;try{we=new RegExp(ae.substring(1,ue),ge)}catch{throw this.B("REGEX",W)}return s.regex(B,we)}case O.TokenType.QuotedStr:{const te=W.lexeme;this.z();let _=null;if(!(0,N.$df)(te)){const Y=te.indexOf("/"),ae=te.lastIndexOf("/");if(Y!==ae&&Y>=0){const ue=te.slice(Y+1,ae),ge=te[ae+1]==="i"?"i":"";try{_=new RegExp(ue,ge)}catch{throw this.B("REGEX",W)}}}if(_===null)throw this.B("REGEX",W);return Q.create(B,_)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,b);const W=this.u();return s.notIn(B,W)}switch(this.D().type){case O.TokenType.Eq:{this.z();const W=this.u();if(this.x().type===O.TokenType.QuotedStr)return s.equals(B,W);switch(W){case"true":return s.has(B);case"false":return s.not(B);default:return s.equals(B,W)}}case O.TokenType.NotEq:{this.z();const W=this.u();if(this.x().type===O.TokenType.QuotedStr)return s.notEquals(B,W);switch(W){case"true":return s.not(B);case"false":return s.has(B);default:return s.notEquals(B,W)}}case O.TokenType.Lt:return this.z(),X.create(B,this.u());case O.TokenType.LtEq:return this.z(),K.create(B,this.u());case O.TokenType.Gt:return this.z(),F.create(B,this.u());case O.TokenType.GtEq:return this.z(),M.create(B,this.u());case O.TokenType.In:return this.z(),s.in(B,this.u());default:return s.has(B)}}case O.TokenType.EOF:throw this.h.push({message:g,offset:D.offset,lexeme:"",additionalInfo:u}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const D=this.D();switch(D.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),D.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(D){return D.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(D){return this.C(D)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(D,B){if(this.C(D))return this.z();throw this.B(B,this.D())}B(D,B,j){const W=(0,A.localize)(8,null,D,O.$Aj.getLexeme(B)),te=B.offset,_=O.$Aj.getLexeme(B);return this.h.push({message:W,offset:te,lexeme:_,additionalInfo:j}),t.c}C(D){return this.D().type===D}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Cj=t;class s{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(D){return y.create(D)}static equals(D,B){return R.create(D,B)}static notEquals(D,B){return v.create(D,B)}static regex(D,B){return Q.create(D,B)}static in(D,B){return k.create(D,B)}static notIn(D,B){return E.create(D,B)}static not(D){return C.create(D)}static and(...D){return V.create(D,null,!0)}static or(...D){return z.create(D,null,!0)}static greater(D,B){return F.create(D,B)}static greaterEquals(D,B){return M.create(D,B)}static smaller(D,B){return X.create(D,B)}static smallerEquals(D,B){return K.create(D,B)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(D){return D==null?void 0:this.c.parse(D)}}e.$Dj=s;function r(H){const D=new t({regexParsingWithErrorRecovery:!1});return H.map(B=>(D.parse(B),D.lexingErrors.length>0?D.lexingErrors.map(j=>({errorMessage:j.additionalInfo?(0,A.localize)(9,null,j.additionalInfo):(0,A.localize)(10,null),offset:j.offset,length:j.lexeme.length})):D.parsingErrors.length>0?D.parsingErrors.map(j=>({errorMessage:j.additionalInfo?`${j.message}. ${j.additionalInfo}`:j.message,offset:j.offset,length:j.lexeme.length})):[]))}function i(H,D){const B=H?H.substituteConstants():void 0,j=D?D.substituteConstants():void 0;return!B&&!j?!0:!B||!j?!1:B.equals(j)}function n(H,D){return H.cmp(D)}class o{static{this.INSTANCE=new o}constructor(){this.type=h.False}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return l.INSTANCE}}e.$Gj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=h.True}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return o.INSTANCE}}e.$Hj=l;class y{static create(D,B=null){const j=p.get(D);return typeof j=="boolean"?j?l.INSTANCE:o.INSTANCE:new y(D,B)}constructor(D,B){this.key=D,this.c=B,this.type=h.Defined}cmp(D){return D.type!==this.type?this.type-D.type:re(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=p.get(this.key);return typeof D=="boolean"?D?l.INSTANCE:o.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Ij=y;class R{static create(D,B,j=null){if(typeof B=="boolean")return B?y.create(D,j):C.create(D,j);const W=p.get(D);return typeof W=="boolean"?B===(W?"true":"false")?l.INSTANCE:o.INSTANCE:new R(D,B,j)}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.Equals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=p.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?l.INSTANCE:o.INSTANCE}return this}evaluate(D){return D.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(D){return D.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=R;class k{static create(D,B){return new k(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.In,this.c=null}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.d,this.f,D.d,D.f)}equals(D){return D.type===this.type?this.d===D.d&&this.f===D.f:!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.f),j=D.getValue(this.d);return Array.isArray(B)?B.includes(j):typeof j=="string"&&typeof B=="object"&&B!==null?d.call(B,j):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(D){return D.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Kj=k;class E{static create(D,B){return new E(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.NotIn,this.c=k.create(D,B)}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(D){return D.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=E;class v{static create(D,B,j=null){if(typeof B=="boolean")return B?C.create(D,j):y.create(D,j);const W=p.get(D);return typeof W=="boolean"?B===(W?"true":"false")?o.INSTANCE:l.INSTANCE:new v(D,B,j)}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.NotEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){const D=p.get(this.c);if(typeof D=="boolean"){const B=D?"true":"false";return this.d===B?o.INSTANCE:l.INSTANCE}return this}evaluate(D){return D.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(D){return D.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Mj=v;class C{static create(D,B=null){const j=p.get(D);return typeof j=="boolean"?j?o.INSTANCE:l.INSTANCE:new C(D,B)}constructor(D,B){this.c=D,this.d=B,this.type=h.Not}cmp(D){return D.type!==this.type?this.type-D.type:re(this.c,D.c)}equals(D){return D.type===this.type?this.c===D.c:!1}substituteConstants(){const D=p.get(this.c);return typeof D=="boolean"?D?o.INSTANCE:l.INSTANCE:this}evaluate(D){return!D.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(D){return D.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Nj=C;function U(H,D){if(typeof H=="string"){const B=parseFloat(H);isNaN(B)||(H=B)}return typeof H=="string"||typeof H=="number"?D(H):o.INSTANCE}class F{static create(D,B,j=null){return U(B,W=>new F(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.Greater}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Oj=F;class M{static create(D,B,j=null){return U(B,W=>new M(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.GreaterEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(D){return D.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Pj=M;class X{static create(D,B,j=null){return U(B,W=>new X(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.Smaller}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Qj=X;class K{static create(D,B,j=null){return U(B,W=>new K(D,W,j))}constructor(D,B,j){this.c=D,this.d=B,this.f=j,this.type=h.SmallerEquals}cmp(D){return D.type!==this.type?this.type-D.type:ce(this.c,this.d,D.c,D.d)}equals(D){return D.type===this.type?this.c===D.c&&this.d===D.d:!1}substituteConstants(){return this}evaluate(D){return typeof this.d=="string"?!1:parseFloat(D.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(D){return D.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Rj=K;class Q{static create(D,B){return new Q(D,B)}constructor(D,B){this.d=D,this.f=B,this.type=h.Regex,this.c=null}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.d<D.d)return-1;if(this.d>D.d)return 1;const B=this.f?this.f.source:"",j=D.f?D.f.source:"";return B<j?-1:B>j?1:0}equals(D){if(D.type===this.type){const B=this.f?this.f.source:"",j=D.f?D.f.source:"";return this.d===D.d&&B===j}return!1}substituteConstants(){return this}evaluate(D){const B=D.getValue(this.d);return this.f?this.f.test(B):!1}serialize(){const D=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${D}`}keys(){return[this.d]}map(D){return D.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=G.create(this)),this.c}}e.$Sj=Q;class G{static create(D){return new G(D)}constructor(D){this.c=D,this.type=h.NotRegex}cmp(D){return D.type!==this.type?this.type-D.type:this.c.cmp(D.c)}equals(D){return D.type===this.type?this.c.equals(D.c):!1}substituteConstants(){return this}evaluate(D){return!this.c.evaluate(D)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(D){return new G(this.c.map(D))}negate(){return this.c}}e.$Tj=G;function ie(H){let D=null;for(let B=0,j=H.length;B<j;B++){const W=H[B].substituteConstants();if(H[B]!==W&&D===null){D=[];for(let te=0;te<B;te++)D[te]=H[te]}D!==null&&(D[B]=W)}return D===null?H:D}class V{static create(D,B,j){return V.d(D,B,j)}constructor(D,B){this.expr=D,this.c=B,this.type=h.And}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const W=n(this.expr[B],D.expr[B]);if(W!==0)return W}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:V.create(D,this.c,!1)}evaluate(D){for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].evaluate(D))return!1;return!0}static d(D,B,j){const W=[];let te=!1;for(const _ of D)if(_){if(_.type===h.True){te=!0;continue}if(_.type===h.False)return o.INSTANCE;if(_.type===h.And){W.push(..._.expr);continue}W.push(_)}if(W.length===0&&te)return l.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(n);for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];for(;W.length>1;){const _=W[W.length-1];if(_.type!==h.Or)break;W.pop();const Y=W.pop(),ae=W.length===0,ue=z.create(_.expr.map(ge=>V.create([ge,Y],null,j)),null,ae);ue&&(W.push(ue),W.sort(n))}if(W.length===1)return W[0];if(j){for(let _=0;_<W.length;_++)for(let Y=_+1;Y<W.length;Y++)if(W[_].negate().equals(W[Y]))return o.INSTANCE;if(W.length===1)return W[0]}return new V(W,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new V(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());this.c=z.create(D,this,!0)}return this.c}}e.$Uj=V;class z{static create(D,B,j){return z.d(D,B,j)}constructor(D,B){this.expr=D,this.c=B,this.type=h.Or}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let B=0,j=this.expr.length;B<j;B++){const W=n(this.expr[B],D.expr[B]);if(W!==0)return W}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let B=0,j=this.expr.length;B<j;B++)if(!this.expr[B].equals(D.expr[B]))return!1;return!0}return!1}substituteConstants(){const D=ie(this.expr);return D===this.expr?this:z.create(D,this.c,!1)}evaluate(D){for(let B=0,j=this.expr.length;B<j;B++)if(this.expr[B].evaluate(D))return!0;return!1}static d(D,B,j){let W=[],te=!1;if(D){for(let _=0,Y=D.length;_<Y;_++){const ae=D[_];if(ae){if(ae.type===h.False){te=!0;continue}if(ae.type===h.True)return l.INSTANCE;if(ae.type===h.Or){W=W.concat(ae.expr);continue}W.push(ae)}}if(W.length===0&&te)return o.INSTANCE;W.sort(n)}if(W.length!==0){if(W.length===1)return W[0];for(let _=1;_<W.length;_++)W[_-1].equals(W[_])&&(W.splice(_,1),_--);if(W.length===1)return W[0];if(j){for(let _=0;_<W.length;_++)for(let Y=_+1;Y<W.length;Y++)if(W[_].negate().equals(W[Y]))return l.INSTANCE;if(W.length===1)return W[0]}return new z(W,B)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(const B of this.expr)D.push(...B.keys());return D}map(D){return new z(this.expr.map(B=>B.map(D)),null)}negate(){if(!this.c){const D=[];for(const B of this.expr)D.push(B.negate());for(;D.length>1;){const B=D.shift(),j=D.shift(),W=[];for(const te of J(B))for(const _ of J(j))W.push(V.create([te,_],null,!1));D.unshift(z.create(W,null,!1))}this.c=z.create(D,this,!0)}return this.c}}e.$Vj=z;class ee extends y{static{this.d=[]}static all(){return ee.d.values()}constructor(D,B,j){super(D,null),this.f=B,typeof j=="object"?ee.d.push({...j,key:D}):j!==!0&&ee.d.push({key:D,description:j,type:B!=null?typeof B:void 0})}bindTo(D){return D.createKey(this.key,this.f)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return R.create(this.key,D)}notEqualsTo(D){return v.create(this.key,D)}}e.$Wj=ee,e.$Xj=(0,T.$Fi)("contextKeyService");function re(H,D){return H<D?-1:H>D?1:0}function ce(H,D,B,j){return H<B?-1:H>B?1:D<j?-1:D>j?1:0}function q(H,D){if(H.type===h.False||D.type===h.True)return!0;if(H.type===h.Or)return D.type===h.Or?x(H.expr,D.expr):!1;if(D.type===h.Or){for(const B of D.expr)if(q(H,B))return!0;return!1}if(H.type===h.And){if(D.type===h.And)return x(D.expr,H.expr);for(const B of H.expr)if(q(B,D))return!0;return!1}return H.equals(D)}function x(H,D){let B=0,j=0;for(;B<H.length&&j<D.length;){const W=H[B].cmp(D[j]);if(W<0)return!1;W===0&&B++,j++}return B===H.length}function J(H){return H.type===h.Or?H.expr:[H]}}),define(le[98],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Sm=e.ID=void 0,e.$Tm=a,e.ID="diagnosticsService",e.$Sm=(0,P.$Fi)(e.ID);function a(O){return!!O.hostName&&!!O.errorMessage}class N{async getPerformanceInfo(T,A){return{}}async getSystemInfo(T,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,A){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.$Um=N}),define(le[99],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=void 0,e.$Xo=(0,P.$Fi)("downloadService")}),define(le[16],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,P.$Fi)("environmentService"),e.$Ni=(0,P.$Gi)(e.$Mi)}),define(le[75],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$Y5b=N;var a;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(a||(e.RecommendationSource=a={}));function N(T){switch(T){case a.FILE:return"file";case a.WORKSPACE:return"workspace";case a.EXE:return"exe"}}var O;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.$Z5b=(0,P.$Fi)("IExtensionRecommendationNotificationService")}),define(le[7],he([0,1,52,14,27,13,9,170,4,5,23,54]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=h,e.$bl=b,e.$cl=w,e.$dl=I,e.$el=g,e.$fl=u,e.$gl=t,e.$hl=s,e.$il=r,e.$jl=i,e.$kl=n,e.$ml=y,e.$nl=R,e.$ol=k,e.$pl=E,e.$ql=v,e.$tl=X,e.$Fl=z,e.$Gl=ee,e.$Il=ce,e.$_k=(0,L.$Fi)("fileService");function h(q){return q.create===!0}var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var c;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var m;(function(q){q[q.UPDATED=2]="UPDATED",q[q.ADDED=4]="ADDED",q[q.DELETED=8]="DELETED"})(m||(e.FileChangeFilter=m={}));function b(q){const x=q;return!!x&&typeof x.onDidChange=="function"}var f;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function w(q){return!!(q.capabilities&f.FileReadWrite)}function I(q){return!!(q.capabilities&f.FileFolderCopy)}function g(q){return!!(q.capabilities&f.FileClone)}function u(q){return!!(q.capabilities&f.FileOpenReadWriteClose)}function t(q){return!!(q.capabilities&f.FileReadStream)}function s(q){return w(q)?!!(q.capabilities&f.FileAtomicRead):!1}function r(q){return w(q)?!!(q.capabilities&f.FileAtomicWrite):!1}function i(q){return!!(q.capabilities&f.FileAtomicDelete)}function n(q){return!!(q.capabilities&f.Readonly)}var o;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class l extends Error{static create(x,J){const H=new l(x.toString(),J);return k(H,J),H}constructor(x,J){super(x),this.code=J}}e.$ll=l;function y(q,x){return l.create(q,x)}function R(q){return q||y((0,A.localize)(0,null),o.Unknown)}function k(q,x){return q.name=x?`${x} (FileSystemError)`:"FileSystemError",q}function E(q){if(!q)return o.Unknown;if(q instanceof l)return q.code;const x=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!x)return o.Unknown;switch(x[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function v(q){if(q instanceof K)return q.fileOperationResult;switch(E(q)){case o.FileNotFound:return ie.FILE_NOT_FOUND;case o.FileIsADirectory:return ie.FILE_IS_DIRECTORY;case o.FileNotADirectory:return ie.FILE_NOT_DIRECTORY;case o.FileWriteLocked:return ie.FILE_WRITE_LOCKED;case o.NoPermissions:return ie.FILE_PERMISSION_DENIED;case o.FileExists:return ie.FILE_MOVE_CONFLICT;case o.FileTooLarge:return ie.FILE_TOO_LARGE;default:return ie.FILE_OTHER_ERROR}}var C;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(C||(e.FileOperation=C={}));class U{constructor(x,J,H){this.resource=x,this.operation=J,this.target=H}isOperation(x){return this.operation===x}}e.$rl=U;var F;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(x,J){this.c=J,this.b=void 0,this.d=new d.$X(()=>{const H=P.$Li.forUris(()=>this.c);return H.fill(this.rawAdded.map(D=>[D,!0])),H}),this.f=new d.$X(()=>{const H=P.$Li.forUris(()=>this.c);return H.fill(this.rawUpdated.map(D=>[D,!0])),H}),this.g=new d.$X(()=>{const H=P.$Li.forUris(()=>this.c);return H.fill(this.rawDeleted.map(D=>[D,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of x){switch(H.type){case F.ADDED:this.rawAdded.push(H.resource);break;case F.UPDATED:this.rawUpdated.push(H.resource);break;case F.DELETED:this.rawDeleted.push(H.resource);break}this.b!==M.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(x,...J){return this.h(x,{includeChildren:!1},...J)}affects(x,...J){return this.h(x,{includeChildren:!0},...J)}h(x,J,...H){if(!x)return!1;const D=H.length>0;return!!((!D||H.includes(F.ADDED))&&(this.d.value.get(x)||J.includeChildren&&this.d.value.findSuperstr(x))||(!D||H.includes(F.UPDATED))&&(this.f.value.get(x)||J.includeChildren&&this.f.value.findSuperstr(x))||(!D||H.includes(F.DELETED))&&(this.g.value.findSubstr(x)||J.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$sl=M;function X(q,x,J){return!q||!x||q===x||x.length>q.length?!1:(x.charAt(x.length-1)!==a.sep&&(x+=a.sep),J?(0,N.$Hf)(q,x):q.indexOf(x)===0)}class K extends Error{constructor(x,J,H){super(x),this.fileOperationResult=J,this.options=H}}e.$ul=K;class Q extends K{constructor(x,J,H,D){super(x,J,D),this.fileOperationResult=J,this.size=H}}e.$vl=Q;class G extends K{constructor(x,J,H){super(x,ie.FILE_NOT_MODIFIED_SINCE,H),this.stat=J}}e.$wl=G;var ie;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ie||(e.FileOperationResult=ie={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var V;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$El="";function z(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}async function ee(q,x){if(!x.hasProvider(T.URI.from({scheme:q.scheme})))return new Promise(J=>{const H=x.onDidChangeFileSystemProviderRegistrations(D=>{D.scheme===q.scheme&&D.added&&(H.dispose(),J())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(x){return(0,O.$jg)(x)||(x=0),x<re.KB?(0,A.localize)(1,null,x.toFixed(0)):x<re.MB?(0,A.localize)(2,null,(x/re.KB).toFixed(2)):x<re.GB?(0,A.localize)(3,null,(x/re.MB).toFixed(2)):x<re.TB?(0,A.localize)(4,null,(x/re.GB).toFixed(2)):(0,A.localize)(5,null,(x/re.TB).toFixed(2))}}e.$Hl=re;function ce(q){const x=typeof q=="string"||q?.scheme===S.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===S.Schemas.file?1024*re.MB:x?10*re.MB:p.$o?50*re.MB:1024*re.MB}});var Z=this&&this.__param||function(ne,e){return function(P,a){e(P,a,ne)}};define(le[199],he([0,1,76,51,7]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;let O=class{constructor(A){this.a=A}async checksum(A){const L=(await this.a.readFileStream(A)).value;return new Promise((p,S)=>{const d=(0,P.createHash)("sha256");(0,a.$Ge)(L,{onData:h=>d.update(h.buffer),onError:h=>S(h),onEnd:()=>p(d.digest("base64").replace(/=+$/,""))})})}};e.$ygc=O,e.$ygc=O=ve([Z(0,N.$_k)],O)}),define(le[100],he([0,1,15,8,171,7]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=T;async function T(S,d,h,$,c,m){let b;try{await A(S,d,h,$,c,m)}catch(f){b=f}finally{b&&c.errorTransformer&&(b=c.errorTransformer(b)),typeof b<"u"&&h.error(b),h.end()}}async function A(S,d,h,$,c,m){L(m);const b=await S.open(d,{create:!1});try{L(m);let f=0,w=0,I=c&&typeof c.length=="number"?c.length:void 0,g=P.$Oe.alloc(Math.min(c.bufferSize,typeof I=="number"?I:c.bufferSize)),u=c&&typeof c.position=="number"?c.position:0,t=0;do w=await S.read(b,u,g.buffer,t,g.byteLength-t),u+=w,t+=w,f+=w,typeof I=="number"&&(I-=w),t===g.byteLength&&(await h.write($(g)),g=P.$Oe.alloc(Math.min(c.bufferSize,typeof I=="number"?I:c.bufferSize)),t=0);while(w>0&&(typeof I!="number"||I>0)&&L(m)&&p(f,c));if(t>0){let s=t;typeof I=="number"&&(s=Math.min(t,I)),h.write($(g.slice(0,s)))}}catch(f){throw(0,O.$nl)(f)}finally{await S.close(b)}}function L(S){if(S.isCancellationRequested)throw(0,a.$8)();return!0}function p(S,d){if(typeof d?.limits?.size=="number"&&S>d.limits.size)throw(0,O.$ml)((0,N.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[47],he([0,1,94,2,14,5,9,7]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=void 0,e.$Xq=L,e.$Yq=p,e.$3q=$,e.$4q=c,e.$5q=m,e.$6q=b,e.$7q=w,e.$8q=I;function L(g){return typeof g.correlationId=="number"}function p(g){return g.recursive===!0}class S extends a.$Wc{static{this.a=5}constructor(u,t,s,r){super(),this.h=u,this.j=t,this.m=s,this.n=r,this.c=this.B(new a.$Xc),this.f=void 0,this.g=0}s(){const u=new a.$Vc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(t=>this.h(t))),u.add(this.b.onDidLogMessage(t=>this.j(t))),u.add(this.b.onDidError(t=>this.t(t.error,t.request)))}t(u,t){this.u(u,t)?this.g<S.a&&this.f?(this.y(`restarting watcher after unexpected error: ${u}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${u}`):this.y(u)}u(u,t){return!(!this.n.restartOnError||t||u.indexOf("No space left on device")!==-1||u.indexOf("EMFILE")!==-1)}w(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}y(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}z(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Zq=S;class d extends S{constructor(u,t,s){super(u,t,s,{type:"node.js",restartOnError:!1})}}e.$1q=d;class h extends S{constructor(u,t,s){super(u,t,s,{type:"universal",restartOnError:!0})}}e.$2q=h;function $(g){return g.map(u=>({type:u.type,resource:T.URI.revive(u.resource),cId:u.cId}))}function c(g){const u=new f;for(const t of g)u.processEvent(t);return u.coalesce()}function m(g,u){return typeof u=="string"&&!u.startsWith(P.$vk)&&!(0,N.$kc)(u)?{base:g,pattern:u}:u}function b(g,u){const t=[];for(const s of u)t.push((0,P.$zk)(m(g,s)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c(u){return O.$k?u.resource.fsPath:u.resource.fsPath.toLowerCase()}processEvent(u){const t=this.b.get(this.c(u));let s=!1;if(t){const r=t.type,i=u.type;t.resource.fsPath!==u.resource.fsPath&&(u.type===A.FileChangeType.DELETED||u.type===A.FileChangeType.ADDED)?s=!0:r===A.FileChangeType.ADDED&&i===A.FileChangeType.DELETED?(this.b.delete(this.c(u)),this.a.delete(t)):r===A.FileChangeType.DELETED&&i===A.FileChangeType.ADDED?t.type=A.FileChangeType.UPDATED:r===A.FileChangeType.ADDED&&i===A.FileChangeType.UPDATED||(t.type=i)}else s=!0;s&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],t=[];return Array.from(this.a).filter(s=>s.type!==A.FileChangeType.DELETED?(u.push(s),!1):!0).sort((s,r)=>s.resource.fsPath.length-r.resource.fsPath.length).filter(s=>t.some(r=>(0,A.$tl)(s.resource.fsPath,r,!O.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(u)}}function w(g,u){if(typeof u=="number")switch(g.type){case A.FileChangeType.ADDED:return(u&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(u&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(u&A.FileChangeFilter.UPDATED)===0}return!1}function I(g){if(typeof g=="number"){const u=[];return g&A.FileChangeFilter.ADDED&&u.push("Added"),g&A.FileChangeFilter.DELETED&&u.push("Deleted"),g&A.FileChangeFilter.UPDATED&&u.push("Updated"),u.length===0?"<all>":`[${u.join(", ")}]`}return"<none>"}}),define(le[200],he([0,1,15,41,8,3,2,51,32,7,47]),function(ne,e,P,a,N,O,T,A,L,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6Q=e.$5Q=void 0,e.$5Q="localFilesystem";class d extends T.$Wc{constructor($,c){super(),this.a=$,this.b=c,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.$me),this.onDidChangeFile=this.f.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.h=(0,L.$2g)(),this.j()}get capabilities(){return this.c||(this.c=p.FileSystemProviderCapabilities.FileReadWrite|p.FileSystemProviderCapabilities.FileOpenReadWriteClose|p.FileSystemProviderCapabilities.FileReadStream|p.FileSystemProviderCapabilities.FileFolderCopy|p.FileSystemProviderCapabilities.FileWriteUnlock|p.FileSystemProviderCapabilities.FileAtomicRead|p.FileSystemProviderCapabilities.FileAtomicWrite|p.FileSystemProviderCapabilities.FileAtomicDelete|p.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=p.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=p.FileSystemProviderCapabilities.Trash)),this.c}stat($){return this.a.call("stat",[$])}readdir($){return this.a.call("readdir",[$])}async readFile($,c){const{buffer:m}=await this.a.call("readFile",[$,c]);return m}readFileStream($,c,m){const b=(0,A.$Ce)(w=>P.$Oe.concat(w.map(I=>P.$Oe.wrap(I))).buffer),f=new T.$Vc;return f.add(this.a.listen("readFileStream",[$,c])(w=>{if(w instanceof P.$Oe)b.write(w.buffer);else{if(w==="end")b.end();else{let I;if(w instanceof Error)I=w;else{const g=w;I=(0,p.$ml)(g.message??(0,a.$qj)(g),g.code??p.FileSystemProviderErrorCode.Unknown)}b.error(I),b.end()}f.dispose()}})),f.add(m.onCancellationRequested(()=>{b.error((0,N.$8)()),b.end(),f.dispose()})),b}writeFile($,c,m){return this.a.call("writeFile",[$,P.$Oe.wrap(c),m])}open($,c){return this.a.call("open",[$,c])}close($){return this.a.call("close",[$])}async read($,c,m,b,f){const[w,I]=await this.a.call("read",[$,c,f]);return m.set(w.buffer.slice(0,I),b),I}write($,c,m,b,f){return this.a.call("write",[$,c,P.$Oe.wrap(m),b,f])}mkdir($){return this.a.call("mkdir",[$])}delete($,c){return this.a.call("delete",[$,c])}rename($,c,m){return this.a.call("rename",[$,c,m])}copy($,c,m){return this.a.call("copy",[$,c,m])}cloneFile($,c){return this.a.call("cloneFile",[$,c])}j(){this.B(this.a.listen("fileChange",[this.h])($=>{if(Array.isArray($)){const c=$;this.f.fire((0,S.$3q)(c))}else{const c=$;this.g.fire(c)}}))}watch($,c){const m=(0,L.$2g)();return this.a.call("watch",[this.h,m,$,c]),(0,T.$Uc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$6Q=d}),define(le[201],he([0,1,46,2,47,3,7,9,6]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class p extends a.$Wc{constructor(){super(),this.a=this.B(new O.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new O.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new a.$6c),this.m=new Set,this.n=this.B(new L.$Dh(this.y())),this.r=5007,this.s=new L.$3h,this.R=!1,this.B(this.f(d=>this.t(d)))}t(d){this.u(d)&&this.z(d)}u(d){return(0,N.$Xq)(d)}async watch(d){this.s.isSettled||this.s.complete(),this.s=new L.$3h;try{this.h.clear(),this.g.clear();for(const h of d)this.u(h)?this.h.set(h.correlationId,h):this.g.add(h);for(const[h]of this.j)this.h.has(h)||(this.j.deleteAndDispose(h),this.m.delete(h));return await this.w(!1)}finally{this.s.complete()}}w(d){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))]),d?this.y():0)}y(){return 800}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async z(d){if(this.j.has(d.correlationId))return;const h=new a.$Vc;this.j.set(d.correlationId,h),await this.s.p,!h.isDisposed&&(this.D(d,h),this.w(!0))}C(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.w(!1)}D(d,h){this.F(d,h)?(this.P(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.G(d,h),this.m.add(d.correlationId))}F(d,h){const $=this.O?.subscribe(d.path,(c,m)=>{h.isDisposed||(c?this.D(d,h):m?.type===T.FileChangeType.ADDED&&this.H(d))});return $?(h.add($),!0):!1}G(d,h){let $=!1;const c=(m,b)=>{if(h.isDisposed)return;const f=this.I(m),w=this.I(b),I=$;$=f,!f&&(w||I)&&this.H(d)};this.P(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,P.watchFile)(d.path,{persistent:!1,interval:this.r},c)}catch(m){this.Q(`fs.watchFile() failed with error ${m} on path ${d.path} (correlationId: ${d.correlationId})`)}h.add((0,a.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,P.unwatchFile)(d.path,c)}catch(m){this.Q(`fs.unwatchFile() failed with error ${m} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}H(d){this.P(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const h={resource:A.URI.file(d.path),type:T.FileChangeType.ADDED,cId:d.correlationId};this.a.fire([h]),this.J(h,d),this.C(d)}I(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(d,h){if(this.R){const $=` >> normalized ${d.type===T.FileChangeType.ADDED?"[ADDED]":d.type===T.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.L($,h)}}L(d,h){this.R&&this.P(`${d}${typeof h.correlationId=="number"?` <${h.correlationId}> `:""}`)}M(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,N.$8q)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.R=d}}e.$er=p}),define(le[202],he([0,1,46,6,26,42,2,91,14,5,21,9,154,31,7,47]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0,e.$kr=f;class b extends T.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(I,g,u,t,s,r){super(),this.s=I,this.t=g,this.u=u,this.w=t,this.y=s,this.z=r,this.c=this.B(new a.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new a.$Th(i=>this.M(i),b.b)),this.g=(0,m.$6q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,m.$6q)(this.s.path,this.s.includes):void 0,this.j=(0,m.$Xq)(this.s)?this.s.filter:void 0,this.m=new N.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const I=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const g=await $.Promises.stat(I);if(this.m.token.isCancellationRequested)return;this.B(await this.G(I,g.isDirectory()))}catch(I){I.code!=="ENOENT"?this.O(I):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${I})`),this.D()}}D(){this.r=!0,this.w?.()}async F(I){let g=I.path;try{g=await $.Promises.realpath(I.path),I.path===g&&(g=await(0,h.$gr)(I.path,this.m.token)??I.path),I.path!==g&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${I.path}, real: ${g})`)}catch{}return g}async G(I,g){const u=new T.$Vc;return this.H(I,g,u)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(I,g,u)),u}H(I,g,u){if(g)return!1;const t=d.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(r,i)=>{if(!u.isDisposed)if(r){const n=await this.G(I,g);u.isDisposed?n.dispose():u.add(n)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:i.type,cId:this.s.correlationId},!0)});return s?(u.add(s),!0):!1}async I(I,g,u){if(p.$j&&(0,O.$Eg)(I,"/Volumes/",!0)){this.O(`Refusing to watch ${I} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new N.$xe(this.m.token);u.add((0,T.$Uc)(()=>t.dispose(!0)));const s=new T.$Vc;u.add(s);try{const r=d.URI.file(this.s.path),i=(0,L.$pc)(I),n=(0,P.watch)(I);s.add((0,T.$Uc)(()=>{n.removeAllListeners(),n.close()})),this.Q(`Started watching: '${I}'`);const o=new Set;if(g)try{for(const y of await $.Promises.readdir(I))o.add(y)}catch(y){this.O(y)}if(t.token.isCancellationRequested)return;const l=new Map;s.add((0,T.$Uc)(()=>{for(const[,y]of l)y.dispose();l.clear()})),n.on("error",(y,R)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${I} for changes using fs.watch() (${y}, ${R})`),this.D())}),n.on("change",(y,R)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${y}"] ${R}`);let k="";if(R&&(k=R.toString(),p.$j&&(k=(0,A.$mm)(k))),!(!k||y!=="change"&&y!=="rename"))if(g)if(y==="rename"){l.get(k)?.dispose();const E=setTimeout(async()=>{if(l.delete(k),k===i&&!await $.Promises.exists(I)){this.J(r);return}if(t.token.isCancellationRequested)return;const v=await this.N((0,L.$lc)(I,k));if(t.token.isCancellationRequested)return;let C;v?o.has(k)?C=c.FileChangeType.UPDATED:(C=c.FileChangeType.ADDED,o.add(k)):(o.delete(k),C=c.FileChangeType.DELETED),this.L({resource:(0,S.$gh)(r,k),type:C,cId:this.s.correlationId})},b.a);l.set(k,(0,T.$Uc)(()=>clearTimeout(E)))}else{let E;o.has(k)?E=c.FileChangeType.UPDATED:(E=c.FileChangeType.ADDED,o.add(k)),this.L({resource:(0,S.$gh)(r,k),type:E,cId:this.s.correlationId})}else if(y==="rename"||k!==i){const E=setTimeout(async()=>{const v=await $.Promises.exists(I);t.token.isCancellationRequested||(v?(this.L({resource:r,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(I,!1))):this.J(r))},b.a);s.clear(),s.add((0,T.$Uc)(()=>clearTimeout(E)))}else this.L({resource:r,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(r){t.token.isCancellationRequested||this.O(`Failed to watch ${I} for changes using fs.watch() (${r.toString()})`),this.D()}}J(I){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:I,type:c.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(I,g=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${I.type===c.FileChangeType.ADDED?"[ADDED]":I.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${I.resource.fsPath}`),!g&&this.g.some(u=>u(I.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${I.resource.fsPath}`):!g&&this.h&&this.h.length>0&&!this.h.some(u=>u(I.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${I.resource.fsPath}`):this.f.work(I))}M(I){const g=(0,m.$4q)(I),u=[];for(const s of g){if((0,m.$7q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}u.push(s)}if(u.length===0)return;if(this.z)for(const s of u)this.R(` >> normalized ${s.type===c.FileChangeType.ADDED?"[ADDED]":s.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(u)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(I){if(p.$k)return $.Promises.exists(I);try{const g=(0,L.$pc)(I);return(await $.Promises.readdir((0,L.$oc)(I))).some(t=>t===g)}catch(g){return this.Q(g),!1}}setVerboseLogging(I){this.z=I}O(I){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${I}`})}P(I){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${I}`})}Q(I){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${I}`})}R(I){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${I}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$jr=b;async function f(w,I,g,u,t=512){const s=await $.Promises.open(w,"r"),r=Buffer.allocUnsafe(t),i=new N.$xe(u);let n,o=!1;const l={path:w,excludes:[],recursive:!1},y=new b(l,void 0,R=>{(async()=>{for(const{type:k}of R)if(k===c.FileChangeType.UPDATED){if(o)return;o=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:E}=await $.Promises.read(s,r,0,t,null);if(!E||i.token.isCancellationRequested)break;I(r.slice(0,E))}}catch(E){n=new Error(E),i.dispose(!0)}finally{o=!1}}})()});return await y.ready,g(),new Promise((R,k)=>{i.token.onCancellationRequested(async()=>{y.dispose();try{await $.Promises.close(s)}catch(E){n=new Error(E)}n?k(n):R()})})}}),define(le[203],he([0,1,3,94,201,5,202,42]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class L extends N.$er{constructor(S){super(),this.O=S,this.onDidError=P.Event.None,this.watchers=new Set}async N(S){S=this.Z(S);const d=[],h=new Set(Array.from(this.watchers));for(const $ of S){const c=this.W($);c&&(0,a.$Dk)(c.request.excludes,$.excludes)&&(0,a.$Dk)(c.request.includes,$.includes)?h.delete(c):d.push($)}d.length&&this.P(`Request to start watching: ${d.map($=>this.M($)).join(",")}`),h.size&&this.P(`Request to stop watching: ${Array.from(h).map($=>this.M($.request)).join(",")}`);for(const $ of h)this.Y($);for(const $ of d)this.X($)}W(S){for(const d of this.watchers)if(typeof S.correlationId=="number"||typeof d.request.correlationId=="number"){if(d.request.correlationId===S.correlationId)return d}else if((0,A.$Dg)(d.request.path,S.path,!O.$k))return d}X(S){const d=new T.$jr(S,this.O,$=>this.a.fire($),()=>this.c.fire(S),$=>this.b.fire($),this.R),h={request:S,instance:d};this.watchers.add(h)}async stop(){await super.stop();for(const S of this.watchers)this.Y(S)}Y(S){this.P("stopping file watcher",S),this.watchers.delete(S),S.instance.dispose()}Z(S){const d=new Map;for(const h of S){const $=O.$k?h.path:h.path.toLowerCase();let c=d.get(h.correlationId);c||(c=new Map,d.set(h.correlationId,c)),c.has($)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(h)}`),c.set($,h)}return Array.from(d.values()).map(h=>Array.from(h.values())).flat()}async setVerboseLogging(S){super.setVerboseLogging(S);for(const d of this.watchers)d.instance.setVerboseLogging(S)}P(S,d){this.R&&this.b.fire({type:"trace",message:this.bb(S,d)})}Q(S){this.b.fire({type:"warn",message:this.bb(S)})}bb(S,d){return d?`[File Watcher (node.js)] ${S} (${this.M(d.request)})`:`[File Watcher (node.js)] ${S}`}}e.$lr=L}),define(le[204],he([0,1,47,203]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class N extends P.$1q{constructor(T,A,L){super(T,A,L),this.s()}r(T){return T.add(new a.$lr(void 0))}}e.$mr=N}),define(le[205],he([0,1,23,43,96,47]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class T extends O.$2q{constructor(L,p,S){super(L,p,S),this.s()}r(L){const p=L.add(new N.$cr(P.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return L.add(p.onDidProcessExit(({code:S,signal:d})=>this.t(`terminated by itself with code ${S}, signal: ${d} (ETERM)`))),a.ProxyChannel.toService((0,a.$mi)(p.getChannel("watcher")))}}e.$dr=T}),define(le[77],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class P{constructor(...N){this.a=new Map;for(const[O,T]of N)this.set(O,T)}set(N,O){const T=this.a.get(N);return this.a.set(N,O),T}has(N){return this.a.has(N)}get(N){return this.a.get(N)}}e.$Di=P}),define(le[206],he([0,1,6,8,2,74,197,4,77,90]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;const S=!1;class d extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class h{constructor(b=new L.$Di,f=!1,w,I=S){this.i=b,this.j=f,this.k=w,this.l=I,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$Ei,this),this._globalGraph=I?w?._globalGraph??new T.$pr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,N.$Rc)(this.h),this.h.clear();for(const b of this.g)(0,N.$Qc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,f){this.m();const w=this,I=new class extends h{dispose(){w.h.delete(I),super.dispose()}}(b,this.j,this,this.l);return this.h.add(I),f?.add(I),I}invokeFunction(b,...f){this.m();const w=c.traceInvocation(this.l,b);let I=!1;try{return b({get:u=>{if(I)throw(0,a.$0)("service accessor is only valid during the invocation of its target method");const t=this.s(u,w);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...f)}finally{I=!0,w.stop()}}createInstance(b,...f){this.m();let w,I;return b instanceof O.$Ci?(w=c.traceCreation(this.l,b.ctor),I=this.o(b.ctor,b.staticArguments.concat(f),w)):(w=c.traceCreation(this.l,b),I=this.o(b,f,w)),w.stop(),I}o(b,f=[],w){const I=A._util.getServiceDependencies(b).sort((t,s)=>t.index-s.index),g=[];for(const t of I){const s=this.s(t.id,w);s||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(s)}const u=I.length>0?I[0].index:f.length;if(f.length!==u){console.trace(`[createInstance] First service dependency of ${b.name} at position ${u+1} conflicts with ${f.length} static arguments`);const t=u-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,u)}return Reflect.construct(b,f.concat(g))}q(b,f){if(this.i.get(b)instanceof O.$Ci)this.i.set(b,f);else if(this.k)this.k.q(b,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const f=this.i.get(b);return!f&&this.k?this.k.r(b):f}s(b,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const w=this.r(b);return w instanceof O.$Ci?this.u(b,w,f.branch(b,!0)):(f.branch(b,!1),w)}u(b,f,w){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,f,w)}finally{this.t.delete(b)}}v(b,f,w){const I=new T.$pr(t=>t.id.toString());let g=0;const u=[{id:b,desc:f,_trace:w}];for(;u.length;){const t=u.pop();if(I.lookupOrInsertNode(t),g++>1e3)throw new d(I);for(const s of A._util.getServiceDependencies(t.desc.ctor)){const r=this.r(s.id);if(r||this.y(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof O.$Ci){const i={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};I.insertEdge(t,i),u.push(i)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new d(I);break}for(const{data:s}of t){if(this.r(s.id)instanceof O.$Ci){const i=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,i)}I.removeNode(s)}}return this.r(b)}w(b,f,w=[],I,g){if(this.i.get(b)instanceof O.$Ci)return this.x(b,f,w,I,g,this.g);if(this.k)return this.k.w(b,f,w,I,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(b,f,w=[],I,g,u){if(I){const t=new h(void 0,this.j,this,this.l);t.c=String(b);const s=new Map,r=new P.$Yh(()=>{const i=t.o(f,w,g);for(const[n,o]of s){const l=i[n];if(typeof l=="function")for(const y of o)y.disposable=l.apply(i,y.listener)}return s.clear(),u.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let y=s.get(n);return y||(y=new p.$7c,s.set(n,y)),(k,E,v)=>{if(r.isInitialized)return r.value[n](k,E,v);{const C={listener:[k,E,v],disposable:void 0},U=y.push(C);return(0,N.$Uc)(()=>{U(),C.disposable?.dispose()})}}}if(n in i)return i[n];const o=r.value;let l=o[n];return typeof l!="function"||(l=l.bind(o),i[n]=l),l},set(i,n,o){return r.value[n]=o,!0},getPrototypeOf(i){return f.prototype}})}else{const t=this.o(f,w,g);return u.add(t),t}}y(b,f){if(f&&console.warn(b),this.j)throw new Error(b)}}e.$qr=h;var $;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})($||($={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super($.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,f){return b?new c($.Invocation,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(b,f){return b?new c($.Creation,f.name):c.c}static{this.f=0}constructor(b,f){this.type=b,this.name=f,this.g=Date.now(),this.h=[]}branch(b,f){const w=new c($.Branch,b.toString());return this.h.push([b,f,w]),w}stop(){const b=Date.now()-this.g;c.f+=b;let f=!1;function w(g,u){const t=[],s=new Array(g+1).join("	");for(const[r,i,n]of u.h)if(i&&n){f=!0,t.push(`${s}CREATES -> ${r}`);const o=w(g+1,n);o&&t.push(o)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const I=[`${this.type===$.Creation?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(b>2||f)&&c.all.add(I.join(`
`))}}e.$rr=c}),define(le[58],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=void 0,e.$bgc=(0,P.$Fi)("mainProcessService");class a{constructor(O,T){this.a=O,this.b=T}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,T){this.a.registerChannel(O,T)}}e.$cgc=a}),define(le[10],he([0,1,174,41,3,56,2,35,5,21,13,9,97,4]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=m,e.log=f,e.$nk=l,e.$ok=y,e.$pk=R,e.$qk=k,P=ke(P),e.$_j=(0,$.$Fi)("logService"),e.$ak=(0,$.$Fi)("loggerService");function c(){return new Date().toISOString()}function m(E){return(0,S.$jg)(E)}var b;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$ck=b.Info;function f(E,v,C){switch(v){case b.Trace:E.trace(C);break;case b.Debug:E.debug(C);break;case b.Info:E.info(C);break;case b.Warning:E.warn(C);break;case b.Error:E.error(C);break;case b.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function w(E,v=!1){let C="";for(let U=0;U<E.length;U++){let F=E[U];if(F instanceof Error&&(F=(0,a.$qj)(F,v)),typeof F=="object")try{F=JSON.stringify(F)}catch{}C+=(U>0?" ":"")+F}return C}class I extends T.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new N.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==b.Off&&this.b<=v}}e.$ek=I;class g extends I{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...C){this.f(b.Trace)&&this.g(b.Trace,w([v,...C],!0))}debug(v,...C){this.f(b.Debug)&&this.g(b.Debug,w([v,...C]))}info(v,...C){this.f(b.Info)&&this.g(b.Info,w([v,...C]))}warn(v,...C){this.f(b.Warning)&&this.g(b.Warning,w([v,...C]))}error(v,...C){if(this.f(b.Error))if(v instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=v.stack,this.g(b.Error,w(U))}else this.g(b.Error,w([v,...C]))}flush(){}}e.$fk=g;class u extends I{constructor(v=e.$ck){super(),this.setLevel(v),this.g=!L.$i}trace(v,...C){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,v,...C):console.log(`[main ${c()}]`,v,...C))}debug(v,...C){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,v,...C):console.log(`[main ${c()}]`,v,...C))}info(v,...C){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,v,...C):console.log(`[main ${c()}]`,v,...C))}warn(v,...C){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,v,...C):console.warn(`[main ${c()}]`,v,...C))}error(v,...C){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,v,...C):console.error(`[main ${c()}]`,v,...C))}flush(){}}e.$gk=u;class t extends I{constructor(v=e.$ck,C=!0){super(),this.g=C,this.setLevel(v)}trace(v,...C){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...C):console.log(v,...C))}debug(v,...C){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...C):console.log(v,...C))}info(v,...C){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...C):console.log(v,...C))}warn(v,...C){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...C):console.log(v,...C))}error(v,...C){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...C):console.error(v,...C))}flush(){}}e.$hk=t;class s extends I{constructor(v,C=e.$ck){super(),this.g=v,this.setLevel(C)}trace(v,...C){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(v),...C])}debug(v,...C){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(v),...C])}info(v,...C){this.f(b.Info)&&this.g.log(b.Info,[this.h(v),...C])}warn(v,...C){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(v),...C])}error(v,...C){this.f(b.Error)&&this.g.log(b.Error,[this.h(v),...C])}h(v){return typeof v=="string"?v:(0,a.$qj)(v,this.f(b.Trace))}flush(){}}e.$ik=s;class r extends I{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const C of this.g)C.setLevel(v);super.setLevel(v)}trace(v,...C){for(const U of this.g)U.trace(v,...C)}debug(v,...C){for(const U of this.g)U.debug(v,...C)}info(v,...C){for(const U of this.g)U.info(v,...C)}warn(v,...C){for(const U of this.g)U.warn(v,...C)}error(v,...C){for(const U of this.g)U.error(v,...C)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$jk=r;class i extends T.$Wc{constructor(v,C,U){if(super(),this.h=v,this.j=C,this.b=new A.$Cc,this.c=this.B(new N.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$me),this.onDidChangeVisibility=this.g.event,U)for(const F of U)this.b.set(F.resource,{logger:void 0,info:F})}m(v){return(0,S.$fg)(v)?[...this.b.values()].find(C=>C.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,C){const U=this.n(v),F=(0,S.$fg)(v)?v:C?.id??(0,O.$tj)(U.toString()).toString(16);let M=this.b.get(U)?.logger;const X=C?.logLevel==="always"?b.Trace:C?.logLevel;M||(M=this.s(U,X??this.getLogLevel(U)??this.h,{...C,id:F}));const K={logger:M,info:{resource:U,id:F,logLevel:X,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(K.info),this.b.set(U,K),M}n(v){return(0,S.$fg)(v)?(0,p.$gh)(this.j,`${v}.log`):v}setLogLevel(v,C){if(d.URI.isUri(v)){const U=v,F=C,M=this.b.get(U);M&&F!==M.info.logLevel&&(M.info.logLevel=F===this.h?void 0:F,M.logger?.setLevel(F),this.b.set(M.info.resource,M),this.f.fire([U,F]))}else{this.h=v;for(const[U,F]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,C){const U=this.m(v);U&&C!==!U.info.hidden&&(U.info.hidden=!C,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,C]))}getLogLevel(v){let C;return v&&(C=this.b.get(v)?.info.logLevel),C??this.h}registerLogger(v){const C=this.b.get(v.resource);C?C.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const C=this.b.get(v);C&&(C.logger&&C.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=i;class n{constructor(){this.onDidChangeLogLevel=new N.$me().event}setLevel(v){}getLevel(){return b.Info}trace(v,...C){}debug(v,...C){}info(v,...C){}warn(v,...C){}error(v,...C){}critical(v,...C){}dispose(){}flush(){}}e.$lk=n;class o extends n{}e.$mk=o;function l(E){if(E.verbose)return b.Trace;if(typeof E.logLevel=="string"){const v=k(E.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ck}function y(E){switch(E){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function R(E){switch(E){case b.Trace:return{original:"Trace",value:P.localize(0,null)};case b.Debug:return{original:"Debug",value:P.localize(1,null)};case b.Info:return{original:"Info",value:P.localize(2,null)};case b.Warning:return{original:"Warning",value:P.localize(3,null)};case b.Error:return{original:"Error",value:P.localize(4,null)};case b.Off:return{original:"Off",value:P.localize(5,null)}}}function k(E){switch(E){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$rk=new h.$Wj("logLevel",y(b.Info))}),define(le[207],he([0,1,6,8,2,23,14,21,31,16,10]),function(ne,e,P,a,N,O,T,A,L,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;let d=class extends N.$Wc{constructor($,c){super(),this.a=$,this.b=c,this.B(new P.$Rh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const $=(0,A.$dh)(this.a.logsHome),c=(0,A.$fh)(this.a.logsHome.with({scheme:O.Schemas.file})).fsPath,f=(await L.Promises.readdir(c)).filter(I=>/^\d{8}T\d{6}$/.test(I)).sort().filter(I=>I!==$),w=f.slice(0,Math.max(0,f.length-9));w.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(I=>L.Promises.rm((0,T.$lc)(c,I)))))}catch($){(0,a.$3)($)}}};e.$vgc=d,e.$vgc=d=ve([Z(0,p.$Mi),Z(1,S.$_j)],d)}),define(le[208],he([0,1,19,6,8,3,42,2,14,47,10]),function(ne,e,P,a,N,O,T,A,L,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class d extends A.$Wc{constructor($,c){super(),this.a=$,this.b=c,this.c=this.B(new O.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new O.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new a.$Dh(0)),this.w=[],this.y=this.B(new a.$Dh(0))}watch($,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n($,c):this.z($,c)}n($,c){const m={path:this.J($),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},b=(0,P.$Vb)(this.j,m);return this.r(),(0,A.$Uc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch($=>(0,N.$3)($))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,p.$3q)(c)),c=>this.G(c),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const c of this.j)(0,p.$Yq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const c of this.j)(0,p.$Yq)(c)&&$.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z($,c){const m={path:this.J($),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},b=(0,P.$Vb)(this.w,m);return this.C(),(0,A.$Uc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch($=>(0,N.$3)($))}D(){return this.u||(this.u=this.B(this.F($=>this.c.fire((0,p.$3q)($)),$=>this.G($),this.a.getLevel()===S.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===S.LogLevel.Trace)}))),this.u.watch(this.w)}G($){$.type==="error"&&this.g.fire($.message),this.H($)}H($){this.a[$.type]($.message)}I($){return(0,L.$jc)($.fsPath)}J($){const c=this.I($);return(0,T.$Hg)(c)}}e.$9q=d}),define(le[209],he([0,1,19,6,15,26,3,56,63,2,52,23,101,21,51,169,7,100,10,8]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;let u=class extends p.$Wc{static{g=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new T.$me),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.$me),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.$me),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new T.$me),this.onDidRunOperation=this.r.event,this.X=this.B(new T.$me),this.Y=this.B(new T.$me),this.onDidFilesChange=this.Y.event,this.Z=this.B(new T.$me),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new a.$Oh)}registerProvider(s,r){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const i=new p.$Vc;return this.h.set(s,r),this.c.fire({added:!0,scheme:s,provider:r}),i.add(r.onDidChangeFile(n=>{const o=new b.$sl(n,!this.S(r));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:s}))),(0,p.$Uc)(()=>{this.c.fire({added:!1,scheme:s,provider:r}),this.h.delete(s),(0,p.$Rc)(i)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const r=[];this.f.fire({scheme:s,join(i){r.push(i)}}),!this.h.has(s)&&await a.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,r){const i=this.h.get(s.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return L.Iterable.map(this.h,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async j(s){if(!(0,$.$kh)(s))throw new b.$ul((0,m.localize)(0,null,this.sb(s)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(s.scheme);const r=this.h.get(s.scheme);if(!r){const i=new I.$db;throw i.message=(0,m.localize)(1,null,s.toString()),i}return r}async m(s){const r=await this.j(s);if((0,b.$fl)(r)||(0,b.$cl)(r)||(0,b.$gl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const r=await this.j(s);if((0,b.$fl)(r)||(0,b.$cl)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.s(s,r)}catch(i){throw(0,b.$pl)(i)===b.FileSystemProviderErrorCode.FileNotFound?new b.$ul((0,m.localize)(2,null,this.sb(s)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$nl)(i)}}async s(s,r){const i=await this.j(s),n=this.S(i),o=r?.resolveTo,l=r?.resolveSingleChildDescendants,y=r?.resolveMetadata,R=await i.stat(s);let k;return this.t(i,s,R,void 0,!!y,(E,v)=>(k||(k=S.$Li.forUris(()=>!n),k.set(s,!0),o&&k.fill(!0,o)),k.get(E.resource)||k.findSuperstr(E.resource.with({query:null,fragment:null}))?!0:E.isDirectory&&l?v===1:!1))}async t(s,r,i,n,o,l){const{providerExtUri:y}=this.R(s),R={resource:r,name:y.basename(r),isFile:(i.type&b.FileType.File)!==0,isDirectory:(i.type&b.FileType.Directory)!==0,isSymbolicLink:(i.type&b.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&b.FilePermission.Readonly)||!!(s.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Fl)({mtime:i.mtime,size:i.size}),children:void 0};if(R.isDirectory&&l(R,n)){try{const k=await s.readdir(r),E=await a.Promises.settled(k.map(async([v,C])=>{try{const U=y.joinPath(r,v),F=o?await s.stat(U):{type:C};return await this.t(s,U,F,k.length,o,l)}catch(U){return this.b.trace(U),null}}));R.children=(0,P.$Jb)(E)}catch(k){this.b.trace(k),R.children=[]}return R}return R}async resolveAll(s){return a.Promises.settled(s.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.j(s),i=await r.stat(s);return this.t(r,s,i,void 0,!0,()=>!1)}async exists(s){const r=await this.j(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.u(s,r)}catch(i){return i}return!0}async u(s,r){if(!r?.overwrite&&await this.exists(s))throw new b.$ul((0,m.localize)(3,null,this.sb(s)),b.FileOperationResult.FILE_MODIFIED_SINCE,r)}async createFile(s,r=N.$Oe.fromString(""),i){await this.u(s,i);const n=await this.writeFile(s,r);return this.r.fire(new b.$rl(s,b.FileOperation.CREATE,n)),n}async writeFile(s,r,i){const n=this.qb(await this.n(s),s),{providerExtUri:o}=this.R(n);let l=i;if((0,b.$il)(n)&&!l?.atomic){const y=n.enforceAtomicWriteFile?.(s);y&&(l={...i,atomic:y})}try{await this.w(n,s,l)||await this.U(n,o.dirname(s));let R;if((0,b.$cl)(n)&&!(r instanceof N.$Oe))if((0,c.$Ae)(r)){const k=await(0,c.$He)(r,3);k.ended?R=N.$Oe.concat(k.buffer):R=k}else R=(0,c.$Ee)(r,k=>N.$Oe.concat(k),3);else R=r;!(0,b.$fl)(n)||(0,b.$cl)(n)&&R instanceof N.$Oe||(0,b.$cl)(n)&&(0,b.$il)(n)&&l?.atomic?await this.hb(n,s,l,R):await this.db(n,s,l,R instanceof N.$Oe?(0,N.$Ze)(R):R),this.r.fire(new b.$rl(s,b.FileOperation.WRITE))}catch(y){throw new b.$ul((0,m.localize)(4,null,this.sb(s),(0,b.$nl)(y).toString()),(0,b.$ql)(y),l)}return this.resolve(s,{resolveMetadata:!0})}async w(s,r,i){const n=!!i?.unlock;if(n&&!(s.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,m.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(s.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,m.localize)(6,null,this.sb(r)));if(!(s.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,m.localize)(7,null,this.sb(r)));if(n)throw new Error((0,m.localize)(8,null,this.sb(r)))}let l;try{l=await s.stat(r)}catch{return}if(l.type&b.FileType.Directory)throw new b.$ul((0,m.localize)(9,null,this.sb(r)),b.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(r,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==b.$El&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,b.$Fl)({mtime:i.mtime,size:l.size}))throw new b.$ul((0,m.localize)(10,null),b.FileOperationResult.FILE_MODIFIED_SINCE,i);return l}async readFile(s,r,i){const n=await this.m(s);return r?.atomic?this.z(n,s,r,i):this.C(n,s,r,i)}async z(s,r,i,n){return new Promise((o,l)=>{this.cb.queueFor(r,async()=>{try{const y=await this.C(s,r,i,n);o(y)}catch(y){l(y)}},this.R(s).providerExtUri)})}async C(s,r,i,n){const o=await this.D(s,r,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,N.$1e)(o.value)}}async readFileStream(s,r,i){const n=await this.m(s);return this.D(n,s,r,i)}async D(s,r,i,n){const o=new O.$xe(n);let l=i;(0,b.$hl)(s)&&s.enforceAtomicReadFile?.(r)&&(l={...i,atomic:!0});const y=this.J(r,l).then(k=>k,k=>{throw o.dispose(!0),k});let R;try{return typeof l?.etag=="string"&&l.etag!==b.$El&&await y,l?.atomic&&(0,b.$hl)(s)||!((0,b.$fl)(s)||(0,b.$gl)(s))||(0,b.$cl)(s)&&l?.preferUnbuffered?R=this.I(s,r,l):(0,b.$gl)(s)?R=this.G(s,r,o.token,l):R=this.H(s,r,o.token,l),R.on("end",()=>o.dispose()),R.on("error",()=>o.dispose()),{...await y,value:R}}catch(k){throw R&&await(0,c.$Fe)(R),this.F(k,r,l)}}F(s,r,i){const n=(0,m.localize)(11,null,this.sb(r),(0,b.$nl)(s).toString());return s instanceof b.$wl?new b.$wl(n,s.stat,i):s instanceof b.$vl?new b.$vl(n,s.fileOperationResult,s.size,s.options):new b.$ul(n,(0,b.$ql)(s),i)}G(s,r,i,n=Object.create(null)){const o=s.readFileStream(r,n,i);return(0,c.$Le)(o,{data:l=>l instanceof N.$Oe?l:N.$Oe.wrap(l),error:l=>this.F(l,r,n)},l=>N.$Oe.concat(l))}H(s,r,i,n=Object.create(null)){const o=(0,N.$5e)();return(0,f.$Vq)(s,r,o,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,r,n)},i),o}I(s,r,i){const n=(0,c.$Ce)(o=>N.$Oe.concat(o));return(async()=>{try{let o;i?.atomic&&(0,b.$hl)(s)?o=await s.readFile(r,{atomic:!0}):o=await s.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(r,o.byteLength,i),n.end(N.$Oe.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async J(s,r){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new b.$ul((0,m.localize)(12,null,this.sb(s)),b.FileOperationResult.FILE_IS_DIRECTORY,r);if(typeof r?.etag=="string"&&r.etag!==b.$El&&r.etag===i.etag)throw new b.$wl((0,m.localize)(13,null),i,r);return this.L(s,i.size,r),i}L(s,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new b.$vl((0,m.localize)(14,null,this.sb(s)),b.FileOperationResult.FILE_TOO_LARGE,r,i)}async canMove(s,r,i){return this.M(s,r,"move",i)}async canCopy(s,r,i){return this.M(s,r,"copy",i)}async M(s,r,i,n){if(s.toString()!==r.toString())try{const o=i==="move"?this.qb(await this.n(s),s):await this.m(s),l=this.qb(await this.n(r),r);await this.Q(o,s,l,r,i,n)}catch(o){return o}return!0}async move(s,r,i){const n=this.qb(await this.n(s),s),o=this.qb(await this.n(r),r),l=await this.N(n,s,o,r,"move",!!i),y=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$rl(s,l==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,y)),y}async copy(s,r,i){const n=await this.m(s),o=this.qb(await this.n(r),r),l=await this.N(n,s,o,r,"copy",!!i),y=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new b.$rl(s,l==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,y)),y}async N(s,r,i,n,o,l){if(r.toString()===n.toString())return o;const{exists:y,isSameResourceWithDifferentPathCase:R}=await this.Q(s,r,i,n,o,l);if(y&&!R&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),o==="copy"){if(s===i&&(0,b.$dl)(s))await s.copy(r,n,{overwrite:l});else{const k=await this.resolve(r);k.isDirectory?await this.P(s,k,i,n):await this.O(s,r,i,n)}return o}else return s===i?(await s.rename(r,n,{overwrite:l}),o):(await this.N(s,r,i,n,"copy",l),await this.del(r,{recursive:!0}),"copy")}async O(s,r,i,n){if((0,b.$fl)(s)&&(0,b.$fl)(i))return this.jb(s,r,i,n);if((0,b.$fl)(s)&&(0,b.$cl)(i))return this.pb(s,r,i,n);if((0,b.$cl)(s)&&(0,b.$fl)(i))return this.nb(s,r,i,n);if((0,b.$cl)(s)&&(0,b.$cl)(i))return this.lb(s,r,i,n)}async P(s,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await a.Promises.settled(r.children.map(async o=>{const l=this.R(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.P(s,await this.resolve(o.resource),i,l):this.O(s,o.resource,i,l)}))}async Q(s,r,i,n,o,l){let y=!1;if(s===i){const{providerExtUri:k,isPathCaseSensitive:E}=this.R(s);if(E||(y=k.isEqual(r,n)),y&&o==="copy")throw new Error((0,m.localize)(15,null,this.sb(r),this.sb(n)));if(!y&&k.isEqualOrParent(n,r))throw new Error((0,m.localize)(16,null,this.sb(r),this.sb(n)))}const R=await this.exists(n);if(R&&!y){if(!l)throw new b.$ul((0,m.localize)(17,null,this.sb(r),this.sb(n)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(s===i){const{providerExtUri:k}=this.R(s);if(k.isEqualOrParent(r,n))throw new Error((0,m.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:R,isSameResourceWithDifferentPathCase:y}}R(s){const r=this.S(s);return{providerExtUri:r?$.$9g:$.$$g,isPathCaseSensitive:r}}S(s){return!!(s.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(s){const r=this.qb(await this.j(s),s);await this.U(r,s);const i=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$rl(s,b.FileOperation.CREATE,i)),i}async U(s,r){const i=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await s.stat(r)).type&b.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(r)));break}catch(o){if((0,b.$pl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(r)),r=n.dirname(r)}for(let o=i.length-1;o>=0;o--){r=n.joinPath(r,i[o]);try{await s.mkdir(r)}catch(l){if((0,b.$pl)(l)!==b.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(s,r){try{await this.W(s,r)}catch(i){return i}return!0}async W(s,r){const i=this.qb(await this.j(s),s),n=!!r?.useTrash;if(n&&!(i.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,m.localize)(20,null,this.sb(s)));const o=r?.atomic;if(o&&!(i.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,m.localize)(21,null,this.sb(s)));if(n&&o)throw new Error((0,m.localize)(22,null,this.sb(s)));let l;try{l=await i.stat(s)}catch{}if(l)this.rb(s,l);else throw new b.$ul((0,m.localize)(23,null,this.sb(s)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!r?.recursive){const R=await this.resolve(s);if(R.isDirectory&&Array.isArray(R.children)&&R.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(s)))}return i}async del(s,r){const i=await this.W(s,r);let n=r;if((0,b.$jl)(i)&&!n?.atomic){const R=i.enforceAtomicDelete?.(s);R&&(n={...r,atomic:R})}const o=!!n?.useTrash,l=!!n?.recursive,y=n?.atomic??!1;await i.delete(s,{recursive:l,useTrash:o,atomic:y}),this.r.fire(new b.$rl(s,b.FileOperation.DELETE))}async cloneFile(s,r){const i=await this.j(s),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(s,r)))return i===n&&(0,b.$el)(i)?i.cloneFile(s,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,b.$dl)(i)?this.cb.queueFor(s,()=>i.copy(s,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(s,()=>this.O(i,s,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:g.ab++})}watch(s,r={recursive:!1,excludes:[]}){const i=new p.$Vc;let n=!1,o=()=>{n=!0};i.add((0,p.$Uc)(()=>o())),(async()=>{try{const y=await this.bb(s,r);n?(0,p.$Rc)(y):o=()=>(0,p.$Rc)(y)}catch(y){this.b.error(y)}})();const l=r.correlationId;if(typeof l=="number"){const y=i.add(new T.$me);return i.add(this.X.event(k=>{k.correlates(l)&&y.fire(k)})),{onDidChange:y.event,dispose:()=>i.dispose()}}return i}async bb(s,r){const i=await this.j(s),n=(0,A.$tj)([this.R(i).providerExtUri.getComparisonKey(s),r]);let o=this.$.get(n);return o||(o={count:0,disposable:i.watch(s,r)},this.$.set(n,o)),o.count+=1,(0,p.$Uc)(()=>{o&&(o.count--,o.count===0&&((0,p.$Rc)(o.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,p.$Rc)(s.disposable);this.$.clear()}async db(s,r,i,n){return this.cb.queueFor(r,async()=>{const o=await s.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,c.$Ae)(n)||(0,c.$Be)(n)?await this.eb(s,o,n):await this.fb(s,o,n)}catch(l){throw(0,b.$nl)(l)}finally{await s.close(o)}},this.R(s).providerExtUri)}async eb(s,r,i){let n=0,o;if((0,c.$Be)(i)){if(i.buffer.length>0){const l=N.$Oe.concat(i.buffer);await this.gb(s,r,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((l,y)=>{(0,c.$Ge)(o,{onData:async R=>{o.pause();try{await this.gb(s,r,R,R.byteLength,n,0)}catch(k){return y(k)}n+=R.byteLength,setTimeout(()=>o.resume())},onError:R=>y(R),onEnd:()=>l()})})}async fb(s,r,i){let n=0,o;for(;(o=i.read())!==null;)await this.gb(s,r,o,o.byteLength,n,0),n+=o.byteLength}async gb(s,r,i,n,o,l){let y=0;for(;y<n;){const R=await s.write(r,o+y,i.buffer,l+y,n-y);y+=R}}async hb(s,r,i,n){return this.cb.queueFor(r,()=>this.ib(s,r,i,n),this.R(s).providerExtUri)}async ib(s,r,i,n){let o;n instanceof N.$Oe?o=n:(0,c.$Ae)(n)?o=await(0,N.$1e)(n):(0,c.$Be)(n)?o=await(0,N.$2e)(n):o=(0,N.$Ye)(n),await s.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(s,r,i,n){return this.cb.queueFor(n,()=>this.kb(s,r,i,n),this.R(i).providerExtUri)}async kb(s,r,i,n){let o,l;try{o=await s.open(r,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const y=N.$Oe.alloc(this.a);let R=0,k=0,E=0;do E=await s.read(o,R,y.buffer,k,y.byteLength-k),await this.gb(i,l,y,E,R,k),R+=E,k+=E,k===y.byteLength&&(k=0);while(E>0)}catch(y){throw(0,b.$nl)(y)}finally{await a.Promises.settled([typeof o=="number"?s.close(o):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(s,r,i,n){return this.cb.queueFor(n,()=>this.mb(s,r,i,n),this.R(i).providerExtUri)}async mb(s,r,i,n){return i.writeFile(n,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,r,i,n){return this.cb.queueFor(n,()=>this.ob(s,r,i,n),this.R(i).providerExtUri)}async ob(s,r,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const l=await s.readFile(r);await this.gb(i,o,N.$Oe.wrap(l),l.byteLength,0,0)}catch(l){throw(0,b.$nl)(l)}finally{await i.close(o)}}async pb(s,r,i,n){const o=await(0,N.$1e)(this.H(s,r,O.CancellationToken.None));await this.hb(i,n,void 0,o)}qb(s,r){if(s.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$ul((0,m.localize)(25,null,this.sb(r)),b.FileOperationResult.FILE_PERMISSION_DENIED);return s}rb(s,r){if((r.permissions??0)&b.FilePermission.Readonly)throw new b.$ul((0,m.localize)(26,null,this.sb(s)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(s){return s.scheme===d.Schemas.file?s.fsPath:s.toString(!0)}};e.$Wq=u,e.$Wq=u=g=ve([Z(0,w.$_j)],u)}),define(le[210],he([0,1,6,35,15,3,42,2,14,5,21,51,31,172,7,100,208,205,204]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class I extends b.$9q{static{this.L=!1}constructor(u,t){super(u,t),this.onDidChangeCapabilities=O.Event.None,this.P=new a.$Cc(s=>S.$0g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,p.$k&&(this.M|=c.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(u){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.I(u));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:c.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(u){try{return await this.stat(u)}catch{return}}async readdir(u){try{const t=await h.Promises.readdir(this.I(u),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async r=>{try{let i;r.isSymbolicLink()?i=(await this.stat((0,S.$gh)(u,r.name))).type:i=this.O(r),s.push([r.name,i])}catch(i){this.a.trace(i)}})),s}catch(t){throw this.hb(t)}}O(u,t){let s;return t?.dangling?s=c.FileType.Unknown:u.isFile()?s=c.FileType.File:u.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,t&&(s|=c.FileType.SymbolicLink),s}async Q(u){const t=this.I(u);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(u);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const r=new P.$Eh;return this.P.set(u,r),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,A.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(u)===r&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(u)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),r.open()})}async readFile(u,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(u)})`),s=await this.Q(u));const r=this.I(u);return await h.Promises.readFile(r)}catch(r){throw this.hb(r)}finally{s?.dispose()}}R(u){I.L&&this.a.trace(u)}readFileStream(u,t,s){const r=(0,d.$Ce)(i=>N.$Oe.concat(i.map(n=>N.$Oe.wrap(n))).buffer);return(0,m.$Vq)(this,u,r,i=>i.buffer,{...t,bufferSize:256*1024},s),r}async writeFile(u,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(u)?this.U(u,(0,S.$gh)((0,S.$fh)(u),`${(0,S.$dh)(u)}${s.atomic.postfix}`),t,s):this.W(u,t,s)}async S(u){try{const t=this.I(u),{symbolicLink:s}=await h.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(u,t,s,r){const i=new A.$Vc;try{i.add(await this.Q(u)),i.add(await this.Q(t)),await this.W(t,s,r,!0);try{await this.rename(t,u,{overwrite:!0})}catch(n){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw n}}finally{i.dispose()}}async W(u,t,s,r){let i;try{const n=this.I(u);if(!s.create||!s.overwrite){if(await h.Promises.exists(n)){if(!s.overwrite)throw(0,c.$ml)((0,$.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.$ml)((0,$.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(u,{create:!0,unlock:s.unlock},r),await this.write(i,0,t,0,t.byteLength)}catch(n){throw await this.ib(u,n)}finally{typeof i=="number"&&await this.close(i)}}static{this.$=!0}static configureFlushOnWrite(u){I.$=u}async open(u,t,s){const r=this.I(u);let i;(0,c.$al)(t)&&!s&&(i=await this.Q(u));let n;try{if((0,c.$al)(t)&&t.unlock)try{const{stat:l}=await h.SymlinkSupport.stat(r);l.mode&128||await h.Promises.chmod(r,l.mode|128)}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}let o;if((0,c.$al)(t)){if(p.$i)try{await h.Promises.truncate(r,0),o="r+"}catch(l){l.code!=="ENOENT"&&this.a.trace(l)}o||(o="w")}else o="r";n=await h.Promises.open(r,o)}catch(o){throw i?.dispose(),(0,c.$al)(t)?await this.ib(u,o):this.hb(o)}if(this.X.set(n,0),(0,c.$al)(t)&&this.Z.set(n,u),i){const o=this.Y.get(n);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${n} (${r})`),this.Y.set(n,i),o&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${n} (${r})`),o.dispose())}return n}async close(u){const t=this.Y.get(u);try{if(this.X.delete(u),this.Z.delete(u)&&I.$)try{await h.Promises.fdatasync(u)}catch(s){I.configureFlushOnWrite(!1),this.a.error(s)}return await h.Promises.close(u)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(u)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${u}`),this.Y.delete(u)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${u}`),t.dispose())}}async read(u,t,s,r,i){const n=this.ab(u,t);let o=null;try{o=(await h.Promises.read(u,s,r,i,n)).bytesRead}catch(l){throw this.hb(l)}finally{this.bb(u,n,o)}return o}ab(u,t){return t===this.X.get(u)?null:t}bb(u,t,s){const r=this.X.get(u);typeof r=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(u,r+s):this.X.delete(u)))}async write(u,t,s,r,i){return(0,P.$Zh)(()=>this.cb(u,t,s,r,i),100,3)}async cb(u,t,s,r,i){const n=this.ab(u,t);let o=null;try{o=(await h.Promises.write(u,s,r,i,n)).bytesWritten}catch(l){throw await this.ib(this.Z.get(u),l)}finally{this.bb(u,n,o)}return o}async mkdir(u){try{await h.Promises.mkdir(this.I(u))}catch(t){throw this.hb(t)}}async delete(u,t){try{const s=this.I(u);if(t.recursive){let r;t?.atomic!==!1&&t.atomic.postfix&&(r=(0,L.$lc)((0,L.$oc)(s),`${(0,L.$pc)(s)}${t.atomic.postfix}`)),await h.Promises.rm(s,h.RimRafMode.MOVE,r)}else try{await h.Promises.unlink(s)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let i=!1;try{const{stat:n,symbolicLink:o}=await h.SymlinkSupport.stat(s);i=n.isDirectory()&&!o}catch{}if(i)await h.Promises.rmdir(s);else throw r}else throw r}}catch(s){throw this.hb(s)}}async rename(u,t,s){const r=this.I(u),i=this.I(t);if(r!==i)try{await this.db(u,t,"move",s.overwrite),await h.Promises.rename(r,i)}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(2,null,(0,L.$pc)(r),(0,L.$pc)((0,L.$oc)(i)),n.toString()))),this.hb(n)}}async copy(u,t,s){const r=this.I(u),i=this.I(t);if(r!==i)try{await this.db(u,t,"copy",s.overwrite),await h.Promises.copy(r,i,{preserveSymlinks:!0})}catch(n){throw(n.code==="EINVAL"||n.code==="EBUSY"||n.code==="ENAMETOOLONG")&&(n=new Error((0,$.localize)(3,null,(0,L.$pc)(r),(0,L.$pc)((0,L.$oc)(i)),n.toString()))),this.hb(n)}}async db(u,t,s,r){const i=this.I(u),n=this.I(t);let o=!1;if(!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)||(o=(0,T.$Dg)(i,n,!0)),o){if(s==="copy")throw(0,c.$ml)((0,$.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const y=await this.N(u);if(!y)throw(0,c.$ml)((0,$.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const R=await this.N(t);if(R){if(!r)throw(0,c.$ml)((0,$.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);y.type&c.FileType.File&&R.type&c.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(u,t){return this.eb(u,t,!1)}async eb(u,t,s){const r=this.I(u),i=this.I(t),n=!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive);if((0,T.$Dg)(r,i,!n))return;const o=new A.$Vc;try{o.add(await this.Q(u)),o.add(await this.Q(t)),s&&await h.Promises.mkdir((0,L.$oc)(i),{recursive:!0}),await h.Promises.copyFile(r,i)}catch(l){if(l.code==="ENOENT"&&!s)return this.eb(u,t,!0);throw this.hb(l)}finally{o.dispose()}}t(u,t,s){return new f.$dr(r=>u(r),r=>t(r),s)}F(u,t,s){return new w.$mr(r=>u(r),r=>t(r),s)}hb(u){if(u instanceof c.$ll)return u;let t=u,s;switch(u.code){case"ENOENT":s=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${u.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=c.FileSystemProviderErrorCode.Unknown;break;default:s=c.FileSystemProviderErrorCode.Unknown}return(0,c.$ml)(t,s)}async ib(u,t){let s=this.hb(t);if(u&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await h.SymlinkSupport.stat(this.I(u));r.mode&128||(s=(0,c.$ml)(t,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return s}}e.$nr=I}),define(le[102],he([0,1,3,2,4,10]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=void 0,e.$Ugc=(0,N.$Fi)("sharedProcessLifecycleService");let T=class extends a.$Wc{constructor(L){super(),this.b=L,this.a=this.B(new P.$me),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Vgc=T,e.$Vgc=T=ve([Z(0,O.$_j)],T)}),define(le[211],he([0,1,9,3,10,2]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=e.$os=e.$ns=void 0;class T extends N.$kk{constructor(d,h,$,c,m){super(h,$,c),this.r=d,this.t=m,this.B(m.listen("onDidChangeLogLevel",d)(b=>{(0,N.$bk)(b)?super.setLogLevel(b):super.setLogLevel(P.URI.revive(b[0]),b[1])})),this.B(m.listen("onDidChangeVisibility",d)(([b,f])=>super.setVisibility(P.URI.revive(b),f))),this.B(m.listen("onDidChangeLoggers",d)(({added:b,removed:f})=>{for(const w of b)super.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of f)super.deregisterLogger(w.resource)}))}createConsoleMainLogger(){return new N.$ik({log:(d,h)=>{this.t.call("consoleLog",[d,h])}})}registerLogger(d){super.registerLogger(d),this.t.call("registerLogger",[d,this.r])}deregisterLogger(d){super.deregisterLogger(d),this.t.call("deregisterLogger",[d,this.r])}setLogLevel(d,h){super.setLogLevel(d,h),this.t.call("setLogLevel",[d,h])}setVisibility(d,h){super.setVisibility(d,h),this.t.call("setVisibility",[this.n(d),h])}s(d,h,$){return new A(this.t,d,h,$,this.r)}static setLogLevel(d,h,$){return d.call("setLogLevel",[h,$])}}e.$ns=T;class A extends N.$fk{constructor(d,h,$,c,m){super(c?.logLevel==="always"),this.r=d,this.s=h,this.m=!1,this.n=[],this.setLevel($),this.r.call("createLogger",[h,c,m]).then(()=>{this.u(this.n),this.m=!0})}g(d,h){const $=[[d,h]];this.m?this.u($):this.n.push(...$)}u(d){this.r.call("log",[this.s,d])}}class L{constructor(d,h){this.a=d,this.b=h}listen(d,h){const $=this.b(d);switch(h){case"onDidChangeLoggers":return a.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(m=>this.c(m,$)),removed:[...c.removed].map(m=>this.c(m,$))}));case"onDidChangeVisibility":return a.Event.map(this.a.onDidChangeVisibility,c=>[$.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return a.Event.map(this.a.onDidChangeLogLevel,c=>(0,N.$bk)(c)?c:[$.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${h}`)}async call(d,h,$){const c=this.b(d);switch(h){case"setLogLevel":return(0,N.$bk)($[0])?this.a.setLogLevel($[0]):this.a.setLogLevel(P.URI.revive(c.transformIncoming($[0][0])),$[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,c)))}throw new Error(`Call not found: ${h}`)}c(d,h){return{...d,resource:h.transformOutgoingURI(d.resource)}}}e.$os=L;class p extends O.$Wc{constructor(d,h){super(),h.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel($=>h.call("setLogLevel",[$]))),h.call("getRegisteredLoggers").then($=>{for(const c of $)d.registerLogger({...c,resource:P.URI.revive(c.resource)})}),this.B(h.listen("onDidChangeVisibility")(([$,c])=>d.setVisibility(P.URI.revive($),c))),this.B(h.listen("onDidChangeLoggers")(({added:$,removed:c})=>{for(const m of $)d.registerLogger({...m,resource:P.URI.revive(m.resource)});for(const m of c)d.deregisterLogger(m.resource)}))}}e.$ps=p}),define(le[212],he([0,1,2,10]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;class N extends P.$Wc{constructor(T,A=[]){super(),this.a=new a.$jk([T,...A]),this.B(T.onDidChangeLogLevel(L=>this.setLevel(L)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...A){this.a.trace(T,...A)}debug(T,...A){this.a.debug(T,...A)}info(T,...A){this.a.info(T,...A)}warn(T,...A){this.a.warn(T,...A)}error(T,...A){this.a.error(T,...A)}flush(){this.a.flush()}}e.$kR=N}),define(le[59],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wec=void 0,e.$Wec=(0,P.$Fi)("nativeHostService")}),define(le[213],he([0,1,43,58]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;let N=class{constructor(T,A){return this.windowId=T,P.ProxyChannel.toService(A.getChannel("nativeHost"),{context:T,properties:(()=>{const L=new Map;return L.set("windowId",T),L})()})}};e.$egc=N,e.$egc=N=ve([Z(1,a.$bgc)],N)}),define(le[60],he([0,1,3,63,2,4]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$to=e.$so=e.$ro=void 0,e.$ro=(0,O.$Fi)("policy");class T extends N.$Wc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$me),this.onDidChange=this.h.event}async updatePolicyDefinitions(p){const S=Object.keys(this.f).length;return this.f={...p,...this.f},S!==Object.keys(this.f).length&&await this.j(p),a.Iterable.reduce(this.g.entries(),(d,[h,$])=>({...d,[h]:$}),{})}getPolicyValue(p){return this.g.get(p)}serialize(){return a.Iterable.reduce(Object.entries(this.f),(p,[S,d])=>({...p,[S]:{definition:d,value:this.g.get(S)}}),{})}}e.$so=T;class A{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$to=A}),define(le[214],he([0,1,3,2,60]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=e.$Hfc=void 0;class O{constructor(L){this.b=L,this.a=new a.$Vc}listen(L,p){switch(p){case"onDidChange":return P.Event.map(this.b.onDidChange,S=>S.reduce((d,h)=>({...d,[h]:this.b.getPolicyValue(h)??null}),{}),this.a)}throw new Error(`Event not found: ${p}`)}call(L,p,S){switch(p){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(S)}throw new Error(`Call not found: ${p}`)}dispose(){this.a.dispose()}}e.$Hfc=O;class T extends N.$so{constructor(L,p){super(),this.a=p;for(const S in L){const{definition:d,value:h}=L[S];this.f[S]=d,h!==void 0&&this.g.set(S,h)}this.a.listen("onDidChange")(S=>{for(const d in S){const h=S[d];h===null?this.g.delete(d):this.g.set(d,h)}this.h.fire(Object.keys(S))})}async j(L){const p=await this.a.call("updatePolicyDefinitions",L);for(const S in p)this.g.set(S,p[S])}}e.$Ifc=T}),define(le[103],he([0,1,36]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let a;const N=globalThis.vscode;if(typeof N<"u"&&typeof N.context<"u"){const O=N.context.configuration();if(O)a=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(a=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(a,{nameShort:`${a.nameShort} Dev`,nameLong:`${a.nameLong} Dev`,dataFolderName:`${a.dataFolderName}-dev`,serverDataFolderName:a.serverDataFolderName?`${a.serverDataFolderName}-dev`:void 0}),!a.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(a,{version:O.version})}}else a={},Object.keys(a).length===0&&Object.assign(a,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=a}),define(le[24],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,P.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(le[215],he([0,1,6,8,2,14,31,10,24]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;let p=class extends N.$Wc{constructor(d,h,$){super(),this.b=h,this.c=$,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,d&&this.B(new P.$Rh(()=>{this.f(d)},3e4)).schedule()}async f(d){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const h=Date.now(),$=(0,O.$oc)(d),c=(0,O.$pc)(d),m=await T.Promises.readdir($);await Promise.all(m.map(async b=>{if(b===c)return;const f=(0,O.$lc)($,b),w=await T.Promises.stat(f);if(w.isDirectory()&&h-w.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${b}.`),T.Promises.rm(f)}))}catch(h){(0,a.$3)(h)}}};e.$sgc=p,e.$sgc=p=ve([Z(1,L.$sk),Z(2,A.$_j)],p)}),define(le[216],he([0,1,6,8,2,14,31,16,10,24]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let S=class extends N.$Wc{constructor(h,$,c){super(),this.b=h,this.c=$,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new P.$Rh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const h=Object.create(null),$=JSON.parse(await T.Promises.readFile((0,O.$lc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const w of Object.keys($)){const I=$[w];h[`${I.hash}.${w}`]=!0}const c=(0,O.$lc)(this.b.userDataPath,"clp");if(!await T.Promises.exists(c))return;const b=await T.Promises.readdir(c);for(const w of b){if(h[w]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await T.Promises.rm((0,O.$lc)(c,w))}const f=Date.now();for(const w of Object.keys(h)){const I=(0,O.$lc)(c,w),g=await T.Promises.readdir(I);for(const u of g){if(u==="tcf.json")continue;const t=(0,O.$lc)(I,u),s=await T.Promises.stat(t);s.isDirectory()&&f-s.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.$lc)(w,u)}`),await T.Promises.rm(t))}}}catch(h){(0,a.$3)(h)}}};e.$tgc=S,e.$tgc=S=ve([Z(0,A.$Ni),Z(1,L.$_j),Z(2,p.$sk)],S)}),define(le[217],he([0,1,14,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$KG=void 0,e.$KG=(0,a.$Fi)("IV8InspectProfilingService");var N;(function(O){function T(L){return!!(L.samples&&L.timeDeltas)}O.isValidProfile=T;function A(L,p="noAbsolutePaths"){for(const S of L.nodes)S.callFrame&&S.callFrame.url&&((0,P.$kc)(S.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(S.callFrame.url))&&(S.callFrame.url=(0,P.$lc)(p,(0,P.$pc)(S.callFrame.url)));return L}O.rewriteAbsolutePaths=A})(N||(e.Utils=N={}))}),define(le[218],he([0,1,32]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class a{constructor(){this.a=new Map}async startProfiling(O){const A=await(await new Promise((p,S)=>{ne(["v8-inspect-profiler"],p,S)}).then(ke)).startProfiling({host:O.host,port:O.port,checkForPaused:!0}),L=(0,P.$2g)();return this.a.set(L,A),L}async stopProfiling(O){const T=this.a.get(O);if(!T)throw new Error(`UNKNOWN session '${O}'`);const A=await T.stop();return this.a.delete(O),A.profile}}e.$Kgc=a}),define(le[44],he([0,1,132,13]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,P=ke(P),a=ke(a);class N{constructor(){this.a=new Map}add(T,A){P.ok(a.$fg(T)),P.ok(a.$hg(A)),P.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,A)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.$po=new N}),define(le[104],he([0,1,3,44]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,a=ke(a),e.$qo={JSONContribution:"base.contributions.json"};function N(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class O{constructor(){this.b=new P.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(L,p){this.a[N(L)]=p,this.b.fire(L)}notifySchemaChanged(L){this.b.fire(L)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;a.$po.add(e.$qo.JSONContribution,T)}),define(le[48],he([0,1,19,3,13,159,22,104,44]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=m,e.$Go=b,e.$Ho=f,e.$Io=I,e.$Jo=g,N=ke(N),O=ke(O);var p;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.$uo={Configuration:"base.contributions.configuration"};var S;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S||(e.ConfigurationScope=S={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const d=L.$po.as(A.$qo.JSONContribution);class h{constructor(){this.h=new Set,this.i=new a.$me,this.onDidSchemaChange=this.i.event,this.j=new a.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$Bo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.n(t,s,r),d.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.o(t,s),d.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.o(s,r),this.n(t,!1,r),d.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const r=[];for(const{overrides:i,source:n}of t)for(const o in i)if(s.add(o),e.$Eo.test(o)){const l=this.a.get(o),y=l?.valuesSources??new Map;if(n)for(const v of Object.keys(i[o]))y.set(v,n);const R={...l?.value||{},...i[o]};this.a.set(o,{source:n,value:R,valuesSources:y});const k=(0,T.$jj)(o),E={type:"object",default:R,description:O.localize(1,null,k),$ref:e.$Bo,defaultDefaultValue:R,source:N.$fg(n)?void 0:n,defaultValueSource:n};r.push(...m(o)),this.d[o]=E,this.b.properties[o]=E}else{this.a.set(o,{value:i[o],source:n});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(r)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:r,source:i}of t)for(const n in r){const o=this.a.get(n),l=N.$fg(i)?i:i?.id,y=N.$fg(o?.source)?o?.source:o?.source?.id;if(l===y)if(s.add(n),this.a.delete(n),e.$Eo.test(n))delete this.d[n],delete this.b.properties[n];else{const R=this.d[n];R&&(this.w(n,R),this.r(n,R))}}this.u()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,r){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,s){const r=i=>{if(i.properties)for(const n in i.properties){s.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,r,i,n=S.WINDOW,o){n=N.$og(t.scope)?n:t.scope;const l=t.properties;if(l)for(const R in l){const k=l[R];if(s&&I(R,k)){delete l[R];continue}if(k.source=r,k.defaultDefaultValue=l[R].default,this.w(R,k),e.$Eo.test(R)?k.scope=void 0:(k.scope=N.$og(k.scope)?n:k.scope,k.restricted=N.$og(k.restricted)?!!i?.includes(R):k.restricted),l[R].hasOwnProperty("included")&&!l[R].included){this.f[R]=l[R],delete l[R];continue}else this.d[R]=l[R],l[R].policy?.name&&this.e.set(l[R].policy.name,R);!l[R].deprecationMessage&&l[R].markdownDeprecationMessage&&(l[R].deprecationMessage=l[R].markdownDeprecationMessage),o.add(R)}const y=t.allOf;if(y)for(const R of y)this.p(R,s,r,i,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=r=>{const i=r.properties;if(i)for(const o in i)this.r(o,i[o]);r.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$vo.properties[t]=s,s.scope){case S.APPLICATION:e.$wo.properties[t]=s;break;case S.MACHINE:e.$xo.properties[t]=s;break;case S.MACHINE_OVERRIDABLE:e.$yo.properties[t]=s;break;case S.WINDOW:e.$zo.properties[t]=s;break;case S.RESOURCE:e.$Ao.properties[t]=s;break;case S.LANGUAGE_OVERRIDABLE:e.$Ao.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$vo.properties[t],s.scope){case S.APPLICATION:delete e.$wo.properties[t];break;case S.MACHINE:delete e.$xo.properties[t];break;case S.MACHINE_OVERRIDABLE:delete e.$yo.properties[t];break;case S.WINDOW:delete e.$zo.properties[t];break;case S.RESOURCE:case S.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,r={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$Bo};this.w(s,r),e.$vo.properties[s]=r,e.$wo.properties[s]=r,e.$xo.properties[s]=r,e.$yo.properties[s]=r,e.$zo.properties[s]=r,e.$Ao.properties[s]=r}}v(){const t={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=t,e.$wo.patternProperties[e.$Do]=t,e.$xo.patternProperties[e.$Do]=t,e.$yo.patternProperties[e.$Do]=t,e.$zo.patternProperties[e.$Do]=t,e.$Ao.patternProperties[e.$Do]=t,this.i.fire()}w(t,s){const r=this.a.get(t);let i=r?.value,n=r?.source;N.$mg(i)&&(i=s.defaultDefaultValue,n=void 0),N.$mg(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const $="\\[([^\\]]+)\\]",c=new RegExp($,"g");e.$Do=`^(${$})+$`,e.$Eo=new RegExp(e.$Do);function m(u){const t=[];if(e.$Eo.test(u)){let s=c.exec(u);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=c.exec(u)}}return(0,P.$Ob)(t)}function b(u){return u.reduce((t,s)=>`${t}[${s}]`,"")}function f(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new h;L.$po.add(e.$uo.Configuration,w);function I(u,t){return u.trim()?e.$Eo.test(u)?O.localize(7,null,u):w.getConfigurationProperties()[u]!==void 0?O.localize(8,null,u):t.policy?.name&&w.getPolicyConfigurations().get(t.policy?.name)!==void 0?O.localize(9,null,u,t.policy?.name,w.getPolicyConfigurations().get(t.policy?.name)):null:O.localize(6,null)}function g(){const u=[],t=w.getConfigurationProperties();for(const s of Object.keys(t))u.push([s,t[s].scope]);return u.push(["launch",S.RESOURCE]),u.push(["task",S.RESOURCE]),u}}),define(le[78],he([0,1,19,3,34,2,35,30,13,9,22,48,7,44]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=g,P=ke(P),N=ke(N),A=ke(A),L=ke(L);function c(r){return Object.isFrozen(r)?r:A.$do(r)}class m{static createEmptyModel(i){return new m({},[],[],void 0,i)}constructor(i,n,o,l,y){this.b=i,this.c=n,this.d=o,this.raw=l,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof m)return n;const o=new b("",this.f);return o.parseRaw(n),o.configurationModel});this.g=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,S.$hj)(this.contents,i):this.contents}inspect(i,n){const o=this;return{get value(){return c(o.rawConfiguration.getValue(i))},get override(){return n?c(o.rawConfiguration.getOverrideValue(i,n)):void 0},get merged(){return c(n?o.rawConfiguration.override(n).getValue(i):o.rawConfiguration.getValue(i))},get overrides(){const l=[];for(const{contents:y,identifiers:R,keys:k}of o.rawConfiguration.overrides){const E=new m(y,k,[],void 0,o.f).getValue(i);E!==void 0&&l.push({identifiers:R,value:E})}return l.length?c(l):void 0}}}getOverrideValue(i,n){const o=this.j(n);return o?i?(0,S.$hj)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return P.$Ob(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return P.$Ob(i)}override(i){let n=this.a.get(i);return n||(n=this.h(i),this.a.set(i,n)),n}merge(...i){const n=A.$co(this.contents),o=A.$co(this.overrides),l=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const R of i)if(y.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.i(n,R.contents);for(const k of R.overrides){const[E]=o.filter(v=>P.$wb(v.identifiers,k.identifiers));E?(this.i(E.contents,k.contents),E.keys.push(...k.keys),E.keys=P.$Ob(E.keys)):o.push(A.$co(k))}for(const k of R.keys)l.indexOf(k)===-1&&l.push(k)}return new m(n,l,o,y.every(R=>R instanceof m)?void 0:y,this.f)}h(i){const n=this.j(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const l of P.$Ob([...Object.keys(this.contents),...Object.keys(n)])){let y=this.contents[l];const R=n[l];R&&(typeof y=="object"&&typeof R=="object"?(y=A.$co(y),this.i(y,R)):y=R),o[l]=y}return new m(o,this.keys,this.overrides,void 0,this.f)}i(i,n){for(const o of Object.keys(n)){if(o in i&&L.$hg(i[o])&&L.$hg(n[o])){this.i(i[o],n[o]);continue}i[o]=A.$co(n[o])}}j(i){let n=null,o=null;const l=y=>{y&&(o?this.i(o,y):o=A.$co(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===i?n=y.contents:y.identifiers.includes(i)&&l(y.contents);return l(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.k(i,n,!0)}setValue(i,n){this.k(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,S.$gj)(this.contents,i),d.$Eo.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>P.$wb(o.identifiers,(0,d.$Fo)(i))),1))}k(i,n,o){(0,S.$fj)(this.contents,i,n,l=>this.f.error(l)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),d.$Eo.test(i)&&this.overrides.push({identifiers:(0,d.$Fo)(i),keys:Object.keys(this.contents[i]),contents:(0,S.$ej)(this.contents[i],l=>this.f.error(l))})}}e.$Ko=m;class b{constructor(i,n){this.f=i,this.g=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!L.$og(i)){const o=this.h(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:l,overrides:y,restricted:R,hasExcludedProperties:k}=this.i(i,n);this.b=new m(o,l,y,k?[i]:void 0,this.g),this.c=R||[]}h(i){let n={},o=null,l=[];const y=[],R=[];function k(v){Array.isArray(l)?l.push(v):o!==null&&(l[o]=v)}const E={onObjectBegin:()=>{const v={};k(v),y.push(l),l=v,o=null},onObjectProperty:v=>{o=v},onObjectEnd:()=>{l=y.pop()},onArrayBegin:()=>{const v=[];k(v),y.push(l),l=v,o=null},onArrayEnd:()=>{l=y.pop()},onLiteralValue:k,onError:(v,C,U)=>{R.push({error:v,offset:C,length:U})}};if(i)try{N.$3n(i,E),n=l[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return n}i(i,n){const o=$.$po.as(d.$uo.Configuration).getConfigurationProperties(),l=this.j(i,o,!0,n);i=l.raw;const y=(0,S.$ej)(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),R=Object.keys(i),k=this.l(i,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:y,keys:R,overrides:k,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(i,n,o,l){let y=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:y};const R={},k=[];for(const E in i)if(d.$Eo.test(E)&&o){const v=this.j(i[E],n,!1,l);R[E]=v.raw,y=y||v.hasExcludedProperties,k.push(...v.restricted)}else{const v=n[E],C=v?typeof v.scope<"u"?v.scope:d.ConfigurationScope.WINDOW:void 0;v?.restricted&&k.push(E),!l.exclude?.includes(E)&&(l.include?.includes(E)||(C===void 0||l.scopes===void 0||l.scopes.includes(C))&&!(l.skipRestricted&&v?.restricted))?R[E]=i[E]:y=!0}return{raw:R,restricted:k,hasExcludedProperties:y}}l(i,n){const o=[];for(const l of Object.keys(i))if(d.$Eo.test(l)){const y={};for(const R in i[l])y[R]=i[l][R];o.push({identifiers:(0,d.$Fo)(l),keys:Object.keys(y),contents:(0,S.$ej)(y,n)})}return o}}e.$Lo=b;class f extends O.$Wc{constructor(i,n,o,l,y){super(),this.c=i,this.f=n,this.g=l,this.h=y,this.b=this.B(new a.$me),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),y),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(a.Event.any(a.Event.filter(this.g.onDidFilesChange,R=>R.contains(this.c)),a.Event.filter(this.g.onDidRunOperation,R=>(R.isOperation(h.FileOperation.CREATE)||R.isOperation(h.FileOperation.COPY)||R.isOperation(h.FileOperation.DELETE)||R.isOperation(h.FileOperation.WRITE))&&o.isEqual(R.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=f;class w{constructor(i,n,o,l,y,R,k,E,v,C,U,F,M){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=l,this.d=y,this.f=R,this.g=k,this.h=E,this.i=v,this.j=C,this.k=U,this.l=F,this.m=M}get value(){return c(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class I{constructor(i,n,o,l,y,R,k,E,v,C){this.j=i,this.l=n,this.m=o,this.n=l,this.p=y,this.q=R,this.r=k,this.s=E,this.t=v,this.u=C,this.h=null,this.i=new T.$Cc,this.v=null}getValue(i,n,o){return this.w(i,n,o).getValue(i)}updateValue(i,n,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=m.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,n===void 0?l.removeValue(i):l.setValue(i,n),o.resource||(this.h=null)}inspect(i,n,o){const l=this.w(i,n,o),y=this.A(n.resource,o),R=n.resource?this.t.get(n.resource)||this.s:this.s,k=new Set;for(const E of l.overrides)for(const v of E.identifiers)l.getOverrideValue(i,v)!==void 0&&k.add(v);return new w(i,n,l.getValue(i),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,y||void 0,R)}keys(i){const n=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,n){this.r.set(i,n),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:l,updated:y,removed:R}=t(this.j,i);n=[...l,...y,...R]}for(const l of n)for(const y of(0,d.$Fo)(l)){const R=this.j.getKeysForOverrideIdentifier(y),k=i.getKeysForOverrideIdentifier(y),E=[...k.filter(v=>R.indexOf(v)===-1),...R.filter(v=>k.indexOf(v)===-1),...R.filter(v=>!A.$go(this.j.override(y).getValue(v),i.override(y).getValue(v)))];o.push([y,E])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:l}=t(this.l,i),y=[...n,...o,...l];return y.length&&this.updatePolicyConfiguration(i),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.applicationConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateApplicationConfiguration(i),{keys:R,overrides:y}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.localUserConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateLocalUserConfiguration(i),{keys:R,overrides:y}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.remoteUserConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateRemoteUserConfiguration(i),{keys:R,overrides:y}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:l,overrides:y}=t(this.workspaceConfiguration,i),R=[...n,...o,...l];return R.length&&this.updateWorkspaceConfiguration(i),{keys:R,overrides:y}}compareAndUpdateFolderConfiguration(i,n){const o=this.folderConfigurations.get(i),{added:l,updated:y,removed:R,overrides:k}=t(o,n),E=[...l,...y,...R];return(E.length||!o)&&this.updateFolderConfiguration(i,n),{keys:E,overrides:k}}compareAndDeleteFolderConfiguration(i){const n=this.folderConfigurations.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:l,removed:y,overrides:R}=t(n,void 0);return{keys:[...o,...l,...y],overrides:R}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,n,o){let l=this.x(n,o);return n.overrideIdentifier&&(l=l.override(n.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(l=l.merge(this.l)),l}x({resource:i},n){let o=this.y();if(n&&i){const l=n.getFolder(i);l&&(o=this.z(l.uri)||o);const y=this.t.get(i);y&&(o=o.merge(y))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let n=this.i.get(i);if(!n){const o=this.y(),l=this.r.get(i);l?(n=o.merge(l),this.i.set(i,n)):n=o}return n}A(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,n)=>{const{contents:o,overrides:l,keys:y}=this.r.get(n);return i.push([n,{contents:o,overrides:l,keys:y}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.q.keys.forEach(n=>i.add(n)),this.r.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.q.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.r.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}D(i){const n=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.q.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(l=>n.add(l))),[...n.values()]}static parse(i,n){const o=this.E(i.defaults,n),l=this.E(i.policy,n),y=this.E(i.application,n),R=this.E(i.user,n),k=this.E(i.workspace,n),E=i.folders.reduce((v,C)=>(v.set(p.URI.revive(C[0]),this.E(C[1],n)),v),new T.$Cc);return new I(o,l,y,R,m.createEmptyModel(n),k,E,m.createEmptyModel(n),new T.$Cc,n)}static E(i,n){return new m(i.contents,i.keys,i.overrides,void 0,n)}}e.$No=I;function g(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,n=new Map;for(const l of r)l.keys.forEach(y=>i.add(y)),l.overrides.forEach(([y,R])=>{const k=(0,T.$zc)(n,y,new Set);R.forEach(E=>k.add(E))});const o=[];return n.forEach((l,y)=>o.push([y,[...l.values()]])),{keys:[...i.values()],overrides:o}}class u{constructor(i,n,o,l,y){this.change=i,this.f=n,this.g=o,this.h=l,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const R of i.keys)this.affectedKeys.add(R);for(const[,R]of i.overrides)for(const k of R)this.affectedKeys.add(k);this.d=this.a;for(const R of this.affectedKeys)this.d+=R+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=I.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,n){const o=this.a+i,l=this.d.indexOf(o);if(l<0)return!1;const y=l+o.length;if(y>=this.d.length)return!1;const R=this.d.charCodeAt(y);if(R!==this.b&&R!==this.c)return!1;if(n){const k=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,E=this.g.getValue(i,n,this.h);return!A.$go(k,E)}return!0}}e.$Po=u;function t(r,i){const{added:n,removed:o,updated:l}=s(i?.rawConfiguration,r?.rawConfiguration),y=[],R=r?.getAllOverrideIdentifiers()||[],k=i?.getAllOverrideIdentifiers()||[];if(i){const E=k.filter(v=>!R.includes(v));for(const v of E)y.push([v,i.getKeysForOverrideIdentifier(v)])}if(r){const E=R.filter(v=>!k.includes(v));for(const v of E)y.push([v,r.getKeysForOverrideIdentifier(v)])}if(i&&r){for(const E of R)if(k.includes(E)){const v=s({contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)},{contents:i.getOverrideValue(void 0,E)||{},keys:i.getKeysForOverrideIdentifier(E)});y.push([E,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:o,updated:l,overrides:y}}function s(r,i){const n=r?i?r.keys.filter(y=>i.keys.indexOf(y)===-1):[...r.keys]:[],o=i?r?i.keys.filter(y=>r.keys.indexOf(y)===-1):[...i.keys]:[],l=[];if(r&&i){for(const y of i.keys)if(r.keys.indexOf(y)!==-1){const R=(0,S.$hj)(i.contents,y),k=(0,S.$hj)(r.contents,y);A.$go(R,k)||l.push(y)}}return{added:n,removed:o,updated:l}}}),define(le[219],he([0,1,19,3,2,30,13,78,48,10,60,44]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;class h extends N.$Wc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new a.$me),this.onDidChangeConfiguration=this.a.event,this.b=A.$Ko.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(d.$po.as(L.$uo.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:f})=>this.f(Array.from(b),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,f){this.j(b,d.$po.as(L.$uo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=A.$Ko.createEmptyModel(this.c);const b=d.$po.as(L.$uo.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,f){const w=this.g();for(const I of b){const g=w[I],u=f[I];g!==void 0?this.b.addValue(I,g):u?this.b.addValue(I,u.default):this.b.removeValue(I)}}}e.$Qo=h;class ${constructor(){this.onDidChangeConfiguration=a.Event.None,this.configurationModel=A.$Ko.createEmptyModel(new p.$mk)}async initialize(){return this.configurationModel}}e.$Ro=$;let c=class extends N.$Wc{get configurationModel(){return this.b}constructor(b,f,w){super(),this.c=b,this.f=f,this.g=w,this.a=this.B(new a.$me),this.onDidChangeConfiguration=this.a.event,this.b=A.$Ko.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const f={},w=[],I=d.$po.as(L.$uo.Configuration).getConfigurationProperties();for(const g of b){const u=I[g];if(!u){w.push(g);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}w.push(g),f[u.policy.name]={type:u.type}}}return(0,T.$sg)(f)||await this.f.updatePolicyDefinitions(f),w}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const f=d.$po.as(L.$uo.Configuration).getPolicyConfigurations(),w=(0,P.$Jb)(b.map(I=>f.get(I)));this.m(w,!0)}m(b,f){this.g.trace("PolicyConfiguration#update",b);const w=d.$po.as(L.$uo.Configuration).getConfigurationProperties(),I=[],g=this.b.isEmpty();for(const u of b){const t=w[u]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(g?s!==void 0:!(0,O.$go)(this.b.getValue(u),s))&&I.push([u,s])}else this.b.getValue(u)!==void 0&&I.push([u,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const u=this.b;this.b=A.$Ko.createEmptyModel(this.g);for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,s]of I)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};e.$So=c,e.$So=c=ve([Z(1,S.$ro),Z(2,p.$_j)],c)}),define(le[220],he([0,1,19,6,15,3,34,64,2,35,30,5,21,22,78,48,219,7,60]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;class I extends L.$Wc{constructor(t,s,r,i){super(),this.m=t,this.n=i,this.h=this.B(new O.$me),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$Qo(i)),this.c=r instanceof w.$to?new b.$Ro:this.B(new b.$So(this.b,r,i)),this.f=this.B(new c.$Mo(this.m,{},h.$0g,s,i)),this.a=new c.$No(this.b.configurationModel,this.c.configurationModel,c.$Ko.createEmptyModel(i),c.$Ko.createEmptyModel(i),c.$Ko.createEmptyModel(i),c.$Ko.createEmptyModel(i),new p.$Cc,c.$Ko.createEmptyModel(i),new p.$Cc,i),this.j=new g(t,s,this),this.g=this.B(new a.$Rh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:o})=>this.s(n,o))),this.B(this.c.onDidChangeConfiguration(n=>this.t(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,s,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$No(t,s,c.$Ko.createEmptyModel(this.n),r,c.$Ko.createEmptyModel(this.n),c.$Ko.createEmptyModel(this.n),new p.$Cc,c.$Ko.createEmptyModel(this.n),new p.$Cc,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,s){const r=typeof t=="string"?t:void 0,i=(0,$.$aj)(t)?t:(0,$.$aj)(s)?s:{};return this.a.getValue(r,i,void 0)}async updateValue(t,s,r,i,n){const o=(0,$.$bj)(r)?r:(0,$.$aj)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?i:r;if(l!==void 0&&l!==$.ConfigurationTarget.USER_LOCAL&&l!==$.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,P.$Ob)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const y=this.inspect(t,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(y.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,S.$go)(s,y.defaultValue)&&(s=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const k=o.overrideIdentifiers.sort(),E=this.a.localUserConfiguration.overrides.find(v=>(0,P.$wb)([...v.identifiers].sort(),k));E&&(o.overrideIdentifiers=E.identifiers)}const R=o?.overrideIdentifiers?.length?[(0,m.$Go)(o.overrideIdentifiers),t]:[t];await this.j.write(R,s),await this.reloadConfiguration()}inspect(t,s={}){return this.a.inspect(t,s,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const s=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(r,s,$.ConfigurationTarget.USER)}s(t,s){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(t,s);this.u(i,r,$.ConfigurationTarget.DEFAULT)}t(t){const s=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(t);this.u(r,s,$.ConfigurationTarget.DEFAULT)}u(t,s,r){const i=new c.$Po(t,{data:s},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}e.$To=I;class g{constructor(t,s,r){this.b=t,this.c=s,this.d=r,this.a=new a.$Mh}write(t,s){return this.a.queue(()=>this.e(t,s))}async e(t,s){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===f.FileOperationResult.FILE_NOT_FOUND)r="{}";else throw o}const i=[];if((0,T.$Vn)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(r,t,s);r=(0,A.$bo)(r,n),await this.c.writeFile(this.b,N.$Oe.fromString(r))}f(t,s,r){const{tabSize:i,insertSpaces:n,eol:o}=this.h;if(!s.length){const l=JSON.stringify(r,null,n?" ".repeat(i):"	");return[{content:l,length:l.length,offset:0}]}return(0,A.$$n)(t,s,r,{tabSize:i,insertSpaces:n,eol:o})}get h(){if(!this.g){let t=d.OS===d.OperatingSystem.Linux||d.OS===d.OperatingSystem.Macintosh?`
`:`\r
`;const s=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});s&&typeof s=="string"&&s!=="auto"&&(t=s),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[221],he([0,1,15,3,2,70]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hwb=e.$Fwb=e.$Ewb=void 0,e.$Gwb=A;const T=(p,S,d)=>{const h=new Uint8Array(16);for(let m=0;m<16;m++)h[m]=Math.round(Math.random()*256);const $=(0,P.$9e)(P.$Oe.wrap(h));return[`GET ws://localhost${p}?${S}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${$}`].join(`\r
`)+`\r
\r
`};e.$Ewb=T,e.$Fwb=P.$Oe.fromString(`\r
\r
`);async function A(p,S,d,h,$){p.write(P.$Oe.fromString((0,e.$Ewb)(S,d,h)));const c=new N.$Vc;try{return await new Promise((m,b)=>{let f;c.add(p.onData(w=>{f?f=P.$Oe.concat([f,w],f.byteLength+w.byteLength):f=w;const I=f.indexOf(e.$Fwb);if(I===-1)return;m(p),p.pauseData();const g=f.slice(I+e.$Fwb.byteLength);g.byteLength&&$.onData.fire(g)})),c.add(p.onClose(w=>b(w??new Error("socket closed")))),c.add(p.onEnd(()=>b(new Error("socket ended"))))})}catch(m){throw p.dispose(),m}finally{c.dispose()}}class L extends N.$Wc{constructor(S,d){super(),this.g=S,this.a=this.B(new a.$pe),this.onData=(...h)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...h)),this.b=this.B(new a.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(d.onData),this.B(d.onData.event(h=>this.a.fire(h))),this.onClose=this.B(d.onClose).event,this.onEnd=this.B(d.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(S,d){O.SocketDiagnostics.traceSocketEvent(this,this.g,S,d)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Hwb=L}),define(le[105],he([0,1,8,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=p,e.$Ql=(0,a.$Fi)("remoteAuthorityResolverService");var N;(function(S){S[S.WebSocket=0]="WebSocket",S[S.Managed=1]="Managed"})(N||(e.RemoteConnectionType=N={}));class O{constructor(d){this.id=d,this.type=N.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class T{constructor(d,h){this.host=d,this.port=h,this.type=N.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=T;var A;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound",S.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class L extends P.$db{static isNotAvailable(d){return d instanceof L&&d._code===A.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof L&&d._code===A.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof L&&d._code===A.NoResolverFound}static isInvalidAuthority(d){return d instanceof L&&d._code===A.InvalidAuthority}static isHandled(d){return d instanceof L&&d.isHandled}constructor(d,h=A.Unknown,$){super(d),this._message=d,this._code=h,this._detail=$,this.isHandled=h===A.NotAvailable&&$===!0,Object.setPrototypeOf(this,L.prototype)}}e.$Tl=L;function p(S){const d=S.indexOf("+");return d===-1?S:S.substring(0,d)}}),define(le[222],he([0,1,6,15,26,8,3,2,23,101,55,32,70,105]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=y,e.$1l=R,e.$2l=E,p=ke(p);const c=30*1e3;var m;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function b(J){switch(J){case m.Management:return"Management";case m.ExtensionHost:return"ExtensionHost";case m.Tunnel:return"Tunnel"}}function f(J){const H=new N.$xe;return setTimeout(()=>H.cancel(),J),H.token}function w(J,H){if(J.isCancellationRequested||H.isCancellationRequested)return N.CancellationToken.Cancelled;const D=new N.$xe;return J.onCancellationRequested(()=>D.cancel()),H.onCancellationRequested(()=>D.cancel()),D.token}class I{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new A.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,P.$yh)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function g(J,H){const D=new I(H);return D.registerDisposable(J.onControlMessage(B=>{const j=JSON.parse(B.toString()),W=z(j);W?D.reject(W):D.resolve(j)})),D.promise}function u(J,H,D,B,j,W,te,_){const Y=new I(_),ae=S.$ge.create(!1);return J.info(`Creating a socket (${te})...`),p.mark(`code/willCreateSocket/${W}`),H.connect(D,B,j,te).then(ue=>{Y.didTimeout?(p.mark(`code/didCreateSocketError/${W}`),J.info(`Creating a socket (${te}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(p.mark(`code/didCreateSocketOK/${W}`),J.info(`Creating a socket (${te}) was successful after ${ae.elapsed()} ms.`),Y.resolve(ue))},ue=>{p.mark(`code/didCreateSocketError/${W}`),J.info(`Creating a socket (${te}) returned an error after ${ae.elapsed()} ms.`),J.error(ue),Y.reject(ue)}),Y.promise}function t(J,H){const D=new I(H);return J.then(B=>{D.didTimeout||D.resolve(B)},B=>{D.didTimeout||D.reject(B)}),D.promise}async function s(J,H,D,B){const j=q(J,H);J.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let W;try{W=await u(J.logService,J.remoteSocketFactoryService,J.connectTo,L.$Sg.getServerRootPath(),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,b(H),`renderer-${b(H)}-${J.reconnectionToken}`,B)}catch(ue){throw J.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),J.logService.error(ue),ue}J.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let te,_;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(W,null),te=J.reconnectionProtocol,_=!1):(te=new h.$ti({socket:W}),_=!0),J.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const Y=await t(J.signService.createNewMessage((0,d.$2g)()),B),ae={type:"auth",auth:J.connectionToken||"00000000000000000000",data:Y.data};te.sendControl(a.$Oe.fromString(JSON.stringify(ae)));try{const ue=await g(te,w(B,f(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const pe=new Error("Unexpected handshake message");throw pe.code="VSCODE_CONNECTION_ERROR",pe}if(J.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(J.signService.validate(Y,ue.signedData),B)){const pe=new Error("Refused to connect to unsupported server");throw pe.code="VSCODE_CONNECTION_ERROR",pe}const we=await t(J.signService.sign(ue.data),B),Ee={type:"connectionType",commit:J.commit,signedData:we,desiredConnectionType:H};return D&&(Ee.args=D),J.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),te.sendControl(a.$Oe.fromString(JSON.stringify(Ee))),{protocol:te,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(J.logService.error(`${j} the handshake timed out. Error:`),J.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${j} received error control message when negotiating connection. Error:`),J.logService.error(ue)),_&&V(te),ue}}async function r(J,H,D,B){const j=Date.now(),W=q(J,H),{protocol:te,ownsProtocol:_}=await s(J,H,D,B),Y=new I(B);return Y.registerDisposable(te.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),ge=z(ue);ge?(J.logService.error(`${W} received error control message when negotiating connection. Error:`),J.logService.error(ge),_&&V(te),Y.reject(ge)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${W} 6/6. handshake finished, connection is up and running after ${x(j)}!`),Y.resolve({protocol:te,firstMessage:ue}))})),Y.promise}async function i(J,H){const{protocol:D}=await r(J,m.Management,void 0,H);return{protocol:D}}async function n(J,H,D){const{protocol:B,firstMessage:j}=await r(J,m.ExtensionHost,H,D),W=j&&j.debugPort;return{protocol:B,debugPort:W}}async function o(J,H,D){const B=Date.now(),j=q(J,m.Tunnel),{protocol:W}=await s(J,m.Tunnel,H,D);return J.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${x(B)}!`),W}async function l(J,H,D){const{connectTo:B,connectionToken:j}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:B,connectionToken:j,reconnectionToken:H,reconnectionProtocol:D,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function y(J,H,D){return k(J,async B=>{const{protocol:j}=await i(B,N.CancellationToken.None);return new G(J,H,D,B.reconnectionToken,j)})}async function R(J,H){return k(J,async D=>{const{protocol:B,debugPort:j}=await n(D,H,N.CancellationToken.None);return new ie(J,H,D.reconnectionToken,B,j)})}async function k(J,H){for(let B=1;;B++)try{const j=(0,d.$2g)(),W=await l(J,j,null);return await H(W)}catch(j){if(B<5)J.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(j);else throw J.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(j),Q.triggerPermanentFailure(0,0,$.$Tl.isHandled(j)),j}}async function E(J,H,D){const B=await l(J,(0,d.$2g)(),null);return await o(B,{host:H,port:D},N.CancellationToken.None)}function v(J){return(0,P.$sh)(H=>new Promise((D,B)=>{const j=setTimeout(D,J*1e3);H.onCancellationRequested(()=>{clearTimeout(j),D()})}))}var C;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(C||(e.PersistentConnectionEventType=C={}));class U{constructor(H,D){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.type=C.ConnectionLost}}e.$3l=U;class F{constructor(H,D,B,j){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.durationSeconds=B,this.c=j,this.type=C.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=F;class M{constructor(H,D,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=C.ReconnectionRunning}}e.$5l=M;class X{constructor(H,D,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.type=C.ConnectionGain}}e.$6l=X;class K{constructor(H,D,B,j){this.reconnectionToken=H,this.millisSinceLastIncomingData=D,this.attempt=B,this.handled=j,this.type=C.ReconnectionPermanentFailure}}e.$7l=K;class Q extends A.$Wc{static triggerPermanentFailure(H,D,B){this._permanentFailure=!0,this.f=H,this.g=D,this.h=B,this.j.forEach(j=>j.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Q._permanentFailure}constructor(H,D,B,j,W){super(),this.t=H,this.u=D,this.reconnectionToken=B,this.protocol=j,this.w=W,this.m=this.B(new T.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new X(this.reconnectionToken,0,0)),this.B(j.onSocketClose(te=>{const _=ce(this.t,this.reconnectionToken,!0);te?te.type===h.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${_} received socket close event (hadError: ${te.hadError}).`),te.error&&this.u.logService.error(te.error)):(this.u.logService.info(`${_} received socket close event (wasClean: ${te.wasClean}, code: ${te.code}, reason: ${te.reason}).`),te.event&&this.u.logService.error(te.event)):this.u.logService.info(`${_} received socket close event.`),this.y()})),this.B(j.onSocketTimeout(te=>{const _=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${te.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${te.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${te.timeSinceLastReceivedSomeData}).`),this.y()})),Q.j.push(this),this.B((0,A.$Uc)(()=>{const te=Q.j.indexOf(this);te>=0&&Q.j.splice(te,1)})),this.n&&this.D(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=ce(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const D=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const j=B<D.length?D[B]:D[D.length-1];try{if(j>0){const te=v(j);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,te)),this.u.logService.info(`${H} waiting for ${j} seconds before reconnecting...`);try{await te}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${H} resolving connection...`);const W=await l(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${W.connectTo}...`),await this.G(W,f(c)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(W){if(W.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if($.$Tl.isTemporarilyNotAvailable(W)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((W.code==="ETIMEDOUT"||W.code==="ENETUNREACH"||W.code==="ECONNREFUSED"||W.code==="ECONNRESET")&&W.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if((0,O.$6)(W)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(W);continue}if(W instanceof $.$Tl){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,$.$Tl.isHandled(W));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(W),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(H,D,B){this.w?Q.triggerPermanentFailure(H,D,B):this.D(H,D,B)}D(H,D,B){this.m.fire(new K(this.reconnectionToken,H,D,B)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=Q;class G extends Q{constructor(H,D,B,j,W){super(m.Management,H,j,W,!0),this.client=this.B(new h.$ri(W,{remoteAuthority:D,clientId:B},H.ipcLogger))}async G(H,D){await i(H,D)}}e.$9l=G;class ie extends Q{constructor(H,D,B,j,W){super(m.ExtensionHost,H,B,j,!1),this.H=D,this.debugPort=W}async G(H,D){await n(H,this.H,D)}}e.$0l=ie;function V(J){try{J.acceptDisconnect();const H=J.getSocket();J.dispose(),H.dispose()}catch(H){(0,O.$3)(H)}}function z(J){if(J&&J.type==="error"){const H=new Error(`Connection error: ${J.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function ee(J,H){for(;J.length<H;)J+=" ";return J}function re(J,H){return`[remote-connection][${ee(b(J),13)}][${H.substr(0,5)}\u2026]`}function ce(J,H,D){return`${re(J,H)}[${D?"reconnect":"initial"}]`}function q(J,H){return`${ce(H,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function x(J){return`${Date.now()-J} ms`}}),define(le[106],he([0,1,23]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=a,e.$hn=N,e.$in=O,e.$jn=T;function a(L){return L.scheme===P.Schemas.vscodeRemote?L.authority:void 0}function N(L){if(!L)return;const p=L.indexOf("+");return p<0?L:L.substr(0,p)}function O(L){const{host:p,port:S}=A(L);if(typeof S>"u")throw new Error(`Invalid remote authority: ${L}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:p,port:S}}function T(L,p){let{host:S,port:d}=A(L);return typeof d>"u"&&(d=p),{host:S,port:d}}function A(L){const p=L.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const S=L.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const d=L.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:L,port:void 0}}}),define(le[37],he([0,1,27,4,106]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=d,e.$un=h,e.$vn=$,e.$wn=c,P=ke(P),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var T;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(T||(e.ExtensionType=T={}));var A;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class L{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,f){if(typeof b>"u"||b===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof b=="string"||typeof f=="string"){const w=typeof b=="string"?b:b.value,I=typeof f=="string"?f:f.value;return P.$Gf(w,I)}return b._lower===f._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$qn=L;class p{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const f of b)this.add(f)}add(b){this.c.add(L.toKey(b))}delete(b){return this.c.delete(L.toKey(b))}has(b){return this.c.has(L.toKey(b))}}e.$rn=p;class S{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(L.toKey(b))}get(b){return this.c.get(L.toKey(b))}has(b){return this.c.has(L.toKey(b))}set(b,f){this.c.set(L.toKey(b),f)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=S;function d(m){return h(m)}function h(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}function $(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}function c(m,b){if(b){const f=`onResolveRemoteAuthority:${(0,N.$hn)(b)}`;return!!m.activationEvents?.includes(f)}return!1}e.$xn=(0,a.$Fi)("IBuiltinExtensionsScannerService")}),define(le[28],he([0,1,5,163,37,4]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=A,e.$cp=L,e.$dp=p,e.$ep=S,e.$fp=d,e.$gp=h,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var T;(function(u){u.COMMAND="command",u.SETTINGS_SYNC="settingsSync"})(T||(e.ExtensionInstallSource=T={}));function A(u){switch(u){case N.TargetPlatform.WIN32_X64:return"Windows 64 bit";case N.TargetPlatform.WIN32_ARM64:return"Windows ARM";case N.TargetPlatform.LINUX_X64:return"Linux 64 bit";case N.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case N.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case N.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case N.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case N.TargetPlatform.DARWIN_X64:return"Mac";case N.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case N.TargetPlatform.WEB:return"Web";case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;case N.TargetPlatform.UNKNOWN:return N.TargetPlatform.UNKNOWN;case N.TargetPlatform.UNDEFINED:return N.TargetPlatform.UNDEFINED}}function L(u){switch(u){case N.TargetPlatform.WIN32_X64:return N.TargetPlatform.WIN32_X64;case N.TargetPlatform.WIN32_ARM64:return N.TargetPlatform.WIN32_ARM64;case N.TargetPlatform.LINUX_X64:return N.TargetPlatform.LINUX_X64;case N.TargetPlatform.LINUX_ARM64:return N.TargetPlatform.LINUX_ARM64;case N.TargetPlatform.LINUX_ARMHF:return N.TargetPlatform.LINUX_ARMHF;case N.TargetPlatform.ALPINE_X64:return N.TargetPlatform.ALPINE_X64;case N.TargetPlatform.ALPINE_ARM64:return N.TargetPlatform.ALPINE_ARM64;case N.TargetPlatform.DARWIN_X64:return N.TargetPlatform.DARWIN_X64;case N.TargetPlatform.DARWIN_ARM64:return N.TargetPlatform.DARWIN_ARM64;case N.TargetPlatform.WEB:return N.TargetPlatform.WEB;case N.TargetPlatform.UNIVERSAL:return N.TargetPlatform.UNIVERSAL;default:return N.TargetPlatform.UNKNOWN}}function p(u,t){switch(u){case P.Platform.Windows:return t==="x64"?N.TargetPlatform.WIN32_X64:t==="arm64"?N.TargetPlatform.WIN32_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Linux:return t==="x64"?N.TargetPlatform.LINUX_X64:t==="arm64"?N.TargetPlatform.LINUX_ARM64:t==="arm"?N.TargetPlatform.LINUX_ARMHF:N.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?N.TargetPlatform.ALPINE_X64:t==="arm64"?N.TargetPlatform.ALPINE_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Mac:return t==="x64"?N.TargetPlatform.DARWIN_X64:t==="arm64"?N.TargetPlatform.DARWIN_ARM64:N.TargetPlatform.UNKNOWN;case P.Platform.Web:return N.TargetPlatform.WEB}}function S(u,t){return t===N.TargetPlatform.WEB&&!u.includes(N.TargetPlatform.WEB)}function d(u,t,s){return S(t,s)?!1:u===N.TargetPlatform.UNDEFINED||u===N.TargetPlatform.UNIVERSAL?!0:u===N.TargetPlatform.UNKNOWN?!1:u===s}function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}var $;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})($||(e.SortBy=$={}));var c;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var m;(function(u){u.Install="install",u.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var b;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$hp=(0,O.$Fi)("extensionGalleryService");var f;(function(u){u.Timeout="Timeout",u.Cancelled="Cancelled",u.Failed="Failed",u.DownloadFailedWriting="DownloadFailedWriting"})(f||(e.ExtensionGalleryErrorCode=f={}));class w extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$ip=w;var I;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.DownloadSignature="DownloadSignature",u.DownloadFailedWriting="DownloadFailedWriting",u.UpdateMetadata="UpdateMetadata",u.Extract="Extract",u.Scanning="Scanning",u.ScanningExtension="ScanningExtension",u.ReadUninstalled="ReadUninstalled",u.UnsetUninstalled="UnsetUninstalled",u.Delete="Delete",u.Rename="Rename",u.IntializeDefaultProfile="IntializeDefaultProfile",u.AddToProfile="AddToProfile",u.InstalledExtensionNotFound="InstalledExtensionNotFound",u.PostInstall="PostInstall",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.NotAllowed="NotAllowed",u.Gallery="Gallery",u.Cancelled="Cancelled",u.Unknown="Unknown",u.Internal="Internal"})(I||(e.ExtensionManagementErrorCode=I={}));class g extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$jp=g,e.$kp=(0,O.$Fi)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,O.$Fi)("IGlobalExtensionEnablementService"),e.$op=(0,O.$Fi)("IExtensionTipsService"),e.$pp=(0,a.localize2)(0,"Extensions"),e.$qp=(0,a.localize2)(1,"Preferences")}),define(le[223],he([0,1,3,2,30,9,95,28]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=e.$sq=e.$rq=void 0;function L(b,f){return b?O.URI.revive(f?f.transformIncoming(b):b):void 0}function p(b,f){return f?f.transformOutgoingURI(b):b}function S(b,f){f=f||T.$Kn;const w=b.manifest;return{...(0,T.$Nn)({...b,manifest:void 0},f),manifest:w}}function d(b,f){return b?.profileLocation?(0,T.$Nn)(b,f??T.$Kn):b}function h(b,f){return f?(0,N.$eo)(b,w=>w instanceof O.URI?f.transformOutgoingURI(w):void 0):b}class ${constructor(f,w){this.a=f,this.b=w,this.onInstallExtension=P.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=P.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=P.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=P.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=P.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,w){const I=this.b(f);switch(w){case"onInstallExtension":return P.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?p(g.profileLocation,I):g.profileLocation}));case"onDidInstallExtensions":return P.Event.map(this.onDidInstallExtensions,g=>g.map(u=>({...u,local:u.local?h(u.local,I):u.local,profileLocation:u.profileLocation?p(u.profileLocation,I):u.profileLocation})));case"onUninstallExtension":return P.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?p(g.profileLocation,I):g.profileLocation}));case"onDidUninstallExtension":return P.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?p(g.profileLocation,I):g.profileLocation}));case"onDidUpdateExtensionMetadata":return P.Event.map(this.onDidUpdateExtensionMetadata,g=>({local:h(g.local,I),profileLocation:p(g.profileLocation,I)}))}throw new Error("Invalid listen")}async call(f,w,I){const g=this.b(f);switch(w){case"zip":{const u=S(I[0],g),t=await this.a.zip(u);return p(t,g)}case"unzip":return this.a.unzip(L(I[0],g));case"install":return this.a.install(L(I[0],g),d(I[1],g));case"installFromLocation":return this.a.installFromLocation(L(I[0],g),L(I[1],g));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(I[0],L(I[1],g),L(I[2],g));case"getManifest":return this.a.getManifest(L(I[0],g));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(I[0]);case"installFromGallery":return this.a.installFromGallery(I[0],d(I[1],g));case"installGalleryExtensions":{const u=I[0];return this.a.installGalleryExtensions(u.map(({extension:t,options:s})=>({extension:t,options:d(s,g)??{}})))}case"uninstall":return this.a.uninstall(S(I[0],g),d(I[1],g));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(I[0],g));case"getInstalled":return(await this.a.getInstalled(I[0],L(I[1],g),I[2])).map(t=>h(t,g));case"toggleAppliationScope":{const u=await this.a.toggleAppliationScope(S(I[0],g),L(I[1],g));return h(u,g)}case"copyExtensions":return this.a.copyExtensions(L(I[0],g),L(I[1],g));case"updateMetadata":{const u=await this.a.updateMetadata(S(I[0],g),I[1],L(I[2],g));return h(u,g)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(I[0],I[1],I[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$rq=$;class c extends a.$Wc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new P.$me),this.f=this.B(new P.$me),this.g=this.B(new P.$me),this.h=this.B(new P.$me),this.j=this.B(new P.$me),this.B(this.m.listen("onInstallExtension")(w=>this.n(this.c,{...w,source:this.r(w.source)?O.URI.revive(w.source):w.source,profileLocation:O.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(w=>this.n(this.f,w.map(I=>({...I,local:I.local?S(I.local,null):I.local,source:this.r(I.source)?O.URI.revive(I.source):I.source,profileLocation:O.URI.revive(I.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(w=>this.n(this.g,{...w,profileLocation:O.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(w=>this.n(this.h,{...w,profileLocation:O.URI.revive(w.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(w=>this.n(this.j,{profileLocation:O.URI.revive(w.profileLocation),local:S(w.local,null)})))}n(f,w){f.fire(w)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const w=await this.getTargetPlatform();return f.allTargetPlatforms.some(I=>(0,A.$fp)(I,f.allTargetPlatforms,w))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(w=>O.URI.revive(w)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,w){return Promise.resolve(this.m.call("install",[f,w])).then(I=>S(I,null))}installFromLocation(f,w){return Promise.resolve(this.m.call("installFromLocation",[f,w])).then(I=>S(I,null))}async installExtensionsFromProfile(f,w,I){return(await this.m.call("installExtensionsFromProfile",[f,w,I])).map(u=>S(u,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,w){return Promise.resolve(this.m.call("installFromGallery",[f,w])).then(I=>S(I,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(I=>({...I,local:I.local?S(I.local,null):I.local,source:this.r(I.source)?O.URI.revive(I.source):I.source,profileLocation:O.URI.revive(I.profileLocation)}))}uninstall(f,w){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,w]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(w=>S(w,null))}getInstalled(f=null,w,I){return Promise.resolve(this.m.call("getInstalled",[f,w,I])).then(g=>g.map(u=>S(u,null)))}updateMetadata(f,w,I){return Promise.resolve(this.m.call("updateMetadata",[f,w,I])).then(g=>S(g,null))}toggleAppliationScope(f,w){return this.m.call("toggleAppliationScope",[f,w]).then(I=>S(I,null))}copyExtensions(f,w){return this.m.call("copyExtensions",[f,w])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,w,I){const g=await this.m.call("download",[f,w,I]);return O.URI.revive(g)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$sq=c;class m{constructor(f){this.a=f}listen(f,w){throw new Error("Invalid listen")}call(f,w,I){switch(w){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(I[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$tq=m}),define(le[224],he([0,1,2,37,7]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;class O extends P.$Wc{constructor(A,L,p,S,d){super(),this.a=A,this.b=L,this.c=p,this.f=d,this.B(S.onDidInstallExtensions(h=>this.g(h))),this.B(S.onDidUninstallExtension(h=>this.h(h)))}g(A){for(const L of A)L.local&&this.invalidate(L.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const L of this.a.profiles)this.c.extUri.isEqual(L.extensionsResource,A)&&await this.j(L);else await this.j(this.a.defaultProfile)}async j(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,a.$kn))}catch(L){(0,N.$ql)(L)!==N.FileOperationResult.FILE_NOT_FOUND&&this.f.error(L)}}}e.$Qq=O}),define(le[79],he([0,1,26,2,5,173,28,4]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=void 0,e.$5r=L;function L(S){return S.tags.find(d=>d.startsWith("lp-"))?.split("lp-")[1]}e.$6r=(0,A.$Fi)("languagePackService");let p=class extends a.$Wc{constructor(d){super(),this.c=d}async getAvailableLanguages(){const d=new P.$xe;setTimeout(()=>d.cancel(),1e3);let h;try{h=await this.c.query({text:'category:"language packs"',pageSize:20},d.token)}catch{return[]}const c=h.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(b=>b.startsWith("lp-"))).map(m=>{const b=m.properties.localizedLanguages?.[0],f=L(m);return{...this.f(f,b,m),extensionId:m.identifier.id,galleryExtension:m}});return c.push(this.f("en","English")),c}f(d,h,$){const c=h??d;let m;if(c!==d&&(m=`(${d})`),d.toLowerCase()===N.$w.toLowerCase()&&(m??="",m+=(0,O.localize)(0,null)),$?.installCount){m??="";const b=$.installCount;let f;b>1e6?f=`${Math.floor(b/1e5)/10}M`:b>1e3?f=`${Math.floor(b/1e3)}K`:f=String(b),m+=` $(cloud-download) ${f}`}return{id:d,label:c,description:m}}};e.$7r=p,e.$7r=p=ve([Z(0,T.$hp)],p)}),define(le[225],he([0,1,2,79]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=void 0;let N=class extends P.$Wc{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.$ugc=N,e.$ugc=N=ve([Z(0,a.$6r)],N)}),define(le[107],he([0,1,2,4]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,a.$Fi)("remoteSocketFactoryService");class N{constructor(){this.a={}}register(T,A){return this.a[T]??=[],this.a[T].push(A),(0,P.$Uc)(()=>{const L=this.a[T]?.indexOf(A);typeof L=="number"&&L>=0&&this.a[T]?.splice(L,1)})}b(T){return(this.a[T.type]||[]).find(L=>L.supports(T))}connect(T,A,L,p){const S=this.b(T);if(!S)throw new Error(`No socket factory found for ${T}`);return S.connect(T,A,L,p)}}e.$Wl=N}),define(le[226],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0,e.$Hgc=(0,P.$Fi)("sharedProcessTunnelService"),e.$Igc="sharedProcessTunnel"}),define(le[108],he([0,1,4,175]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=e.$Qgc=e.$Pgc=e.$Ogc=e.TunnelStates=e.$Ngc=e.$Mgc=void 0,e.$Mgc=(0,P.$Fi)("IRemoteTunnelService"),e.$Ngc={active:!1};var N;(function(O){O.disconnected=T=>({type:"disconnected",onTokenFailed:T}),O.connected=(T,A)=>({type:"connected",info:T,serviceInstallFailed:A}),O.connecting=T=>({type:"connecting",progress:T}),O.uninitialized={type:"uninitialized"}})(N||(e.TunnelStates=N={})),e.$Ogc="remote.tunnels.access",e.$Pgc=e.$Ogc+".hostNameOverride",e.$Qgc=e.$Ogc+".preventSleep",e.$Rgc="remoteTunnelService",e.$Sgc=(0,a.localize)(0,null)}),define(le[61],he([0,1,15,8,2,177,48,4,10,44]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0,e.$4p=h,e.$5p=$,e.$6p=c,e.$7p=m,e.$8p=b,e.$9p=f,e.$2p=(0,A.$Fi)("requestService");class S{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class d extends N.$Wc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,O.localize)(0,null),when:L.$rk.isEqualTo((0,L.$ok)(L.LogLevel.Trace)).serialize()})}async c(u,t,s){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new S(t.headers??{}));try{const i=await s();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,a.$_)(i)),i}}}e.$3p=d;function h(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function $(g){return g.res.statusCode===204}async function c(g){return $(g)?null:(await(0,P.$1e)(g.stream)).toString()}async function m(g){if(!h(g))throw new Error("Server returned "+g.res.statusCode);return c(g)}async function b(g){if(!h(g))throw new Error("Server returned "+g.res.statusCode);if($(g))return null;const t=(await(0,P.$1e)(g.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function f(g){I(g)}let w;function I(g){const u=p.$po.as(T.$uo.Configuration),t=w;w={id:"http",order:15,title:(0,O.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[w],remove:t?[t]:[]})}I(T.ConfigurationScope.APPLICATION)}),define(le[227],he([0,1,26,23,7,61]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;let T=class{constructor(L,p){this.a=L,this.b=p}async download(L,p,S=P.CancellationToken.None){if(L.scheme===a.Schemas.file||L.scheme===a.Schemas.vscodeRemote){await this.b.copy(L,p);return}const d={type:"GET",url:L.toString(!0)},h=await this.a.request(d,S);if(h.res.statusCode===200)await this.b.writeFile(p,h.stream);else{const $=await(0,O.$7p)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${$}`)}}};e.$zR=T,e.$zR=T=ve([Z(0,O.$2p),Z(1,N.$_k)],T)}),define(le[228],he([0,1,15,26]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=void 0;class N{constructor(A){this.a=A}listen(A,L){throw new Error("Invalid listen")}call(A,L,p,S=a.CancellationToken.None){switch(L){case"request":return this.a.request(p[0],S).then(async({res:d,stream:h})=>{const $=await(0,P.$1e)(h);return[{statusCode:d.statusCode,headers:d.headers},$]});case"resolveProxy":return this.a.resolveProxy(p[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$9r=N;class O{constructor(A){this.a=A}async request(A,L){const[p,S]=await this.a.call("request",[A],L);return{res:p,stream:(0,P.$3e)(S)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$0r=O}),define(le[229],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=e.$gfc=e.$ffc=void 0,e.$ffc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$gfc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$hfc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[230],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(N){try{const O=await this.c();if(O){const T=String(P.a++);return this.b.set(T,O),{id:T,data:O.createNewMessage(N)}}}catch{}return{id:"",data:N}}async validate(N,O){if(!N.id)return!0;const T=this.b.get(N.id);if(!T)return!1;this.b.delete(N.id);try{return T.validate(O)==="ok"}catch{return!1}finally{T.dispose?.()}}async sign(N){try{return await this.d(N)}catch{}return N}}e.$5ac=P}),define(le[109],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,P.$Fi)(e.$Xl)}),define(le[231],he([0,1,230]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class a extends P.$5ac{c(){return this.h().then(O=>new O.validator)}d(O){return this.h().then(T=>new T.signer().sign(O))}h(){return new Promise((O,T)=>ne(["vsda"],O,T))}}e.$0fc=a}),define(le[80],he([0,1,3,2]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dMb=e.$cMb=e.$bMb=e.$aMb=void 0;class N extends a.$Wc{constructor(d,h,$){super(),this.a=d,this.b=h,this.c=$}async getItems(){const d={profile:this.b,workspace:this.c},h=await this.a.call("getItems",d);return new Map(h)}updateItems(d){const h={profile:this.b,workspace:this.c};return d.insert&&(h.insert=Array.from(d.insert.entries())),d.delete&&(h.delete=Array.from(d.delete.values())),this.a.call("updateItems",h)}optimize(){const d={profile:this.b,workspace:this.c};return this.a.call("optimize",d)}}class O extends N{constructor(d,h){super(d,h,void 0),this.f=this.B(new P.$me),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(d=>this.h(d)))}h(d){(Array.isArray(d.changed)||Array.isArray(d.deleted))&&this.f.fire({changed:d.changed?new Map(d.changed):void 0,deleted:d.deleted?new Set(d.deleted):void 0})}}class T extends O{constructor(d){super(d,void 0)}async close(){this.dispose()}}e.$aMb=T;class A extends O{constructor(d,h){super(d,h)}async close(){this.dispose()}}e.$bMb=A;class L extends N{constructor(d,h){super(d,void 0,h),this.onDidChangeItemsExternal=P.Event.None}async close(){this.dispose()}}e.$cMb=L;class p{constructor(d){this.a=d}isUsed(d){const h={payload:d,profile:void 0,workspace:void 0};return this.a.call("isUsed",h)}}e.$dMb=p}),define(le[110],he([0,1,5,36,32]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=T,e.$sp=A;function O(L){if(P.$u===P.Platform.Linux&&/^penguin(\.|$)/i.test(L))return"chromebook"}function T(L,p,S,d,h,$,c,m,b,f){const w=Object.create(null);w["common.machineId"]=$,w["common.sqmId"]=c,w["common.devDeviceId"]=m,w.sessionID=(0,N.$2g)()+Date.now(),w.commitHash=d,w.version=h,w["common.platformVersion"]=(L||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),w["common.platform"]=(0,P.$h)(P.$u),w["common.nodePlatform"]=a.$fc,w["common.nodeArch"]=S,w["common.product"]=f||"desktop",b&&(w["common.msftInternal"]=b);let I=0;const g=Date.now();Object.defineProperties(w,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>I++,enumerable:!0}}),P.$l&&(w["common.snap"]="true");const u=O(p);return u&&(w["common.platformDetail"]=u),w}function A(L){const p=a.env.USERDNSDOMAIN;if(!p)return!1;const S=p.toLowerCase();return L.some(d=>S===d)}}),define(le[18],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,P.$Fi)("telemetryService"),e.$_l=(0,P.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var a;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(a||(e.TelemetryLevel=a={}));var N;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(N||(e.TelemetryConfiguration=N={}))}),define(le[232],he([0,1,38,6,34,23,14,5,55,9,150,31,156,98,7,24,18]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0,e.$Ss=w,e.$Ts=g,e.$Us=u,P=ke(P);const f=new Map;async function w(s,r){const i=`${s}::${r.join(":")}`,n=f.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,y=new Map,R=2e4;function k(v,C,U,F){const M=C.substring(v.length+1);return a.Promises.withAsyncBody(async X=>{let K;F.readdirCount++;try{K=await d.Promises.readdir(C,{withFileTypes:!0})}catch{X();return}if(F.count>=R){F.count+=K.length,F.maxReached=!0,X();return}let Q=K.length;if(Q===0){X();return}let G=K;F.count+K.length>R&&(F.maxReached=!0,Q=R-F.count,G=K.slice(0,Q)),F.count+=K.length;for(const ie of G)if(ie.isDirectory()){if(U.includes(ie.name)||await k(v,(0,T.$lc)(C,ie.name),U,F),--Q===0){X();return}}else{const V=ie.name.lastIndexOf(".");if(V>=0){const z=ie.name.substring(V+1);z&&l.set(z,(l.get(z)??0)+1)}for(const z of o)z.relativePathPattern?.test(M)!==!1&&z.filePattern.test(ie.name)&&y.set(z.tag,(y.get(z.tag)??0)+1);if(--Q===0){X();return}}})}const E=a.Promises.withAsyncBody(async v=>{const C={count:0,maxReached:!1,readdirCount:0},U=new L.$ge(!0);await k(s,s,r,C);const F=await u(s);v({configFiles:I(y),fileTypes:I(l),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:F,totalScanTime:U.elapsed(),totalReaddirCount:C.readdirCount})});return f.set(i,E),E}function I(s){return Array.from(s.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function g(){const s={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/c.$Hl.GB).toFixed(2)}GB (${(P.freemem()/c.$Hl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.$Pn.value()*100)}%`},r=P.cpus();return r&&r.length>0&&(s.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),s}async function u(s){try{const r=new Map,i=(0,T.$lc)(s,".vscode","launch.json"),n=await d.Promises.readFile(i),o=[],l=(0,N.$Vn)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,N.$5n)(l)==="object"&&l.configurations)for(const y of l.configurations){const R=y.type;R&&(r.has(R)?r.set(R,r.get(R)+1):r.set(R,1))}return I(r)}catch{return[]}}let t=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const n=P.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(P.totalmem()/c.$Hl.GB).toFixed(2)}GB (${(P.freemem()/c.$Hl.GB).toFixed(2)}GB free)`),A.$i||i.push(`Load (avg):       ${P.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(S.$Pn.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,h.$Rs)(r.mainPID),this.k(r)]).then(async n=>{let[o,l]=n,y=this.m(r,o);return i.forEach(R=>{if((0,$.$Tm)(R))y+=`
${R.errorMessage}`,l+=`
${R.errorMessage}`;else if(y+=`

Remote: ${R.hostName}`,R.processes&&(y+=`
${this.m(r,R.processes)}`),R.workspaceMetadata){l+=`
|  Remote: ${R.hostName}`;for(const k of Object.keys(R.workspaceMetadata)){const E=R.workspaceMetadata[k];let v=`${E.fileCount} files`;E.maxFilesReached&&(v=`more than ${v}`),l+=`|    Folder (${k}): ${v}`,l+=this.h(E)}}}),{processInfo:y,workspaceInfo:l}})}async getSystemInfo(r,i){const{memory:n,vmHint:o,os:l,cpus:y}=g(),R={os:l,memory:n,cpus:y,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return A.$i||(R.load=`${P.loadavg().map(k=>Math.round(k)).join(", ")}`),A.$k&&(R.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(R)}async getDiagnostics(r,i){const n=[];return(0,h.$Rs)(r.mainPID).then(async o=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,o)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),i.forEach(l=>{if((0,$.$Tm)(l))n.push(`
${l.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${l.hostName}`),n.push(this.f(l.machineInfo)),l.processes&&n.push(this.m(r,l.processes)),l.workspaceMetadata)for(const y of Object.keys(l.workspaceMetadata)){const R=l.workspaceMetadata[y];let k=`${R.fileCount} files`;R.maxFilesReached&&(k=`more than ${k}`),n.push(`Folder (${y}): ${k}`),n.push(this.h(R))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const i=[];let o=0;const l=(E,v)=>{const C=` ${E}(${v})`;o+C.length>60?(i.push(y),y="|                 ",o=y.length):o+=C.length,y+=C};let y="|      File types:";const R=10,k=r.fileTypes.length>R?R:r.fileTypes.length;for(let E=0;E<k;E++){const v=r.fileTypes[E];l(v.name,v.count)}if(i.push(y),r.configFiles.length>=0&&(y="|      Conf files:",o=0,r.configFiles.forEach(E=>{l(E.name,E.count)}),i.push(y)),r.launchConfigFiles.length>0){let E="|      Launch Configs:";r.launchConfigFiles.forEach(v=>{const C=v.count>1?` ${v.name}(${v.count})`:` ${v.name}`;E+=C}),i.push(E)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const i=[],n=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const y=p.URI.revive(l);if(y.scheme===O.Schemas.file){const R=y.fsPath;n.push(w(R,["node_modules",".git"]).then(k=>{let E=`${k.fileCount} files`;k.maxFilesReached&&(E=`more than ${E}`),i.push(`|    Folder (${(0,T.$pc)(R)}): ${E}`),i.push(this.h(k))}).catch(k=>{i.push(`|      Error: Unable to collect workspace stats for folder ${R} (${k.toString()})`)}))}else i.push(`|    Folder (${y.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,i){const n=new Map;r.windows.forEach(l=>n.set(l.pid,`window [${l.id}] (${l.title})`)),r.pidToNames.forEach(({pid:l,name:y})=>n.set(l,y));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,n,o,i,0),o.join(`
`)}n(r,i,n,o,l){const y=l===0;let R;y?R=o.pid===r?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?R=i.get(o.pid):R=`${"  ".repeat(l)} ${o.name}`;const k=process.platform==="win32"?o.mem:P.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(k/c.$Hl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${R}`),Array.isArray(o.children)&&o.children.forEach(E=>this.n(r,i,n,E,l+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:n}of r.folders){const o=p.URI.revive(n);if(o.scheme!==O.Schemas.file)continue;const l=o.fsPath;try{(await w(l,["node_modules",".git"])).fileTypes.forEach(R=>i.add(R.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const n=p.URI.revive(i);if(n.scheme!==O.Schemas.file)continue;const o=n.fsPath;try{const l=await w(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach(y=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.launchConfigFiles.forEach(y=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),l.configFiles.forEach(y=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:y.name,count:y.count})}),this.c.publicLog2("workspace.stats.metadata",{duration:l.totalScanTime,reachedLimit:l.maxFilesReached,fileCount:l.fileCount,readdirCount:l.totalReaddirCount})}catch{}}}};e.$Vs=t,e.$Vs=t=ve([Z(0,b.$$l),Z(1,m.$sk)],t)}),define(le[111],he([0,1,8,4,10,18]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.ExtensionSignatureVerificationCode=e.$nq=void 0,e.$nq=(0,a.$Fi)("IExtensionSignatureVerificationService");var T;(function(p){p.Success="Success",p.RequiredArgumentMissing="RequiredArgumentMissing",p.InvalidArgument="InvalidArgument",p.PackageIsUnreadable="PackageIsUnreadable",p.UnhandledException="UnhandledException",p.SignatureManifestIsMissing="SignatureManifestIsMissing",p.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",p.SignatureIsMissing="SignatureIsMissing",p.SignatureIsUnreadable="SignatureIsUnreadable",p.CertificateIsUnreadable="CertificateIsUnreadable",p.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",p.FileAlreadyExists="FileAlreadyExists",p.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",p.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",p.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",p.SignatureIsInvalid="SignatureIsInvalid",p.SignatureManifestIsInvalid="SignatureManifestIsInvalid",p.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",p.EntryIsMissing="EntryIsMissing",p.EntryIsTampered="EntryIsTampered",p.Untrusted="Untrusted",p.CertificateRevoked="CertificateRevoked",p.SignatureIsNotValid="SignatureIsNotValid",p.UnknownError="UnknownError",p.PackageIsInvalidZip="PackageIsInvalidZip",p.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(T||(e.ExtensionSignatureVerificationCode=T={}));class A extends Error{constructor(S){super(S),this.code=S}}e.$oq=A;let L=class{constructor(S,d){this.b=S,this.c=d}d(){return this.a||(this.a=new Promise((S,d)=>ne(["@vscode/vsce-sign"],async h=>S(h),d))),this.a}async verify(S,d,h,$){let c;const m=S.identifier.id;try{c=await this.d()}catch(I){return this.b.error("Could not load vsce-sign module",(0,P.$_)(I)),this.b.info(`Extension signature verification is not done: ${m}`),!1}const b=new Date().getTime();let f;try{this.b.trace(`Verifying extension signature for ${m}...`),f=await c.verify(d,h,this.b.getLevel()===N.LogLevel.Trace)}catch(I){f={code:T.UnknownError,didExecute:!1,output:(0,P.$_)(I)}}const w=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${m}: ${f.code}. Executed: ${f.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${m}:
${f.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:m,extensionVersion:S.version,code:f.code,internalCode:f.internalCode,duration:w,didExecute:f.didExecute,clientTargetPlatform:$}),f.code===T.Success)return!0;throw new A(f.code)}};e.$pq=L,e.$pq=L=ve([Z(0,N.$_j),Z(1,O.$$l)],L)}),define(le[112],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=e.$kfc=void 0;class P{constructor(O){this.b=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,{eventName:A,data:L}){return this.b.forEach(p=>p.log(A,L)),Promise.resolve(null)}}e.$kfc=P;class a{constructor(O){this.b=O}log(O,T){return this.b.call("log",{eventName:O,data:T}).then(void 0,A=>`Failed to log telemetry: ${console.warn(A)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$lfc=a}),define(le[49],he([0,1,30,13,106,110,18]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=S,e.$Bp=d,e.$Cp=h,e.$Dp=$,e.$Ep=m,e.$Fp=f,e.$Gp=w,e.$Hp=u;class A{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$tp=A;class L{constructor(){this.telemetryLevel=T.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=L,e.$vp=new L;class p{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.$wp=p,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function S(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function d(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function h(t){const s=t.getValue(T.$hm),r=t.getValue(T.$im);if(t.getValue(T.$jm)===!1||r===!1)return T.TelemetryLevel.NONE;switch(s??T.TelemetryConfiguration.ON){case T.TelemetryConfiguration.ON:return T.TelemetryLevel.USAGE;case T.TelemetryConfiguration.ERROR:return T.TelemetryLevel.ERROR;case T.TelemetryConfiguration.CRASH:return T.TelemetryLevel.CRASH;case T.TelemetryConfiguration.OFF:return T.TelemetryLevel.NONE}}function $(t){const s={},r={},i={};b(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const o=i[n];typeof o=="number"?r[n]=o:typeof o=="boolean"?r[n]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${o.length}`),s[n]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(s[n]=o)}return{properties:s,measurements:r}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function m(t){if(!t)return"none";const s=(0,N.$hn)(t);return c.has(s)?s:"other"}function b(t,s,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const o=t[n],l=i?i+n:n;Array.isArray(o)?s[l]=(0,P.$ho)(o):o instanceof Date?s[l]=o.toISOString():(0,a.$hg)(o)?r<2?b(o,s,r+1,l+"."):s[l]=(0,P.$ho)(o):s[l]=o}}function f(t,s){const r=t.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,O.$sp)(r)||i}function w(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function I(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const y of s)for(;;){const R=y.exec(t);if(!R)break;i.push([R.index,y.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const y=o.exec(t);if(!y)break;const R=i.some(([k,E])=>y.index<E&&k<o.lastIndex);!n.test(y[0])&&!R&&(r+=t.substring(l,y.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<t.length&&(r+=t.substr(l)),r}function g(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function u(t,s){return(0,P.$eo)(t,r=>{if(r instanceof A||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=I(i,s);for(const n of s)i=i.replace(n,"");return i=g(i),i}})}}),define(le[33],he([0,1,27,28,37,5,9,8,36,49]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=S,e.$Kp=c,e.$Lp=m,e.$Mp=b,e.$Np=f,e.$Op=w,e.$Pp=I,e.$Qp=g,e.$Sp=u,e.$Tp=s;function S(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$Bf)(r.id,i.id)===0}const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class h{static create(i){const n=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new h(i.identifier,n,o)}static parse(i){const n=d.exec(i);return n&&n[1]&&n[2]?new h({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,o=N.TargetPlatform.UNDEFINED){this.identifier=i,this.version=n,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==N.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof h?S(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Jp=h;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(r){const i=$.exec(r);return i&&i[1]?[b(i[1]),i[2]]:[b(r),void 0]}function m(r,i){return`${r}.${i}`}function b(r){return r.toLowerCase()}function f(r,i){return b(m(r??N.$mn,i))}function w(r,i){const n=[],o=l=>{for(const y of n)if(y.some(R=>S(i(R),i(l))))return y;return null};for(const l of r){const y=o(l);y?y.push(l):n.push([l])}return n}function I(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function g(r){return{id:new p.$tp(r.identifier.id),name:new p.$tp(r.name),version:r.version,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Rp=new N.$qn("pprice.better-merge");function u(r,i){const n=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(y=>!S(y.identifier,{id:l}))){const y=r.filter(R=>S(R.identifier,{id:l}));y.length===1&&(n.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(r,i){if(!O.$k)return!1;let n;try{n=(await r.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,A.$_)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,i){const n=await t(r,i),o=(0,a.$dp)(n?"alpine":O.$u,L.$gc);return i.debug("ComputeTargetPlatform:",o),o}}),define(le[233],he([0,1,26,28,33,37]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=T;async function T(A,L,p,S,d){try{const h=await A.getExtensionsControlManifest();if(!h.deprecated)return;const $=await A.getInstalled(O.ExtensionType.User);for(const[c,m]of Object.entries(h.deprecated)){if(!m?.extension)continue;const{id:b,autoMigrate:f,preRelease:w}=m.extension;if(!f)continue;const I=$.find(u=>(0,N.$Ip)(u.identifier,{id:c}));if(!I)continue;const g=(await L.getExtensions([{id:b,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},P.CancellationToken.None))[0];if(!g){d.info(`Skipping migrating '${I.identifier.id}' extension because, the comaptible target '${b}' extension is not found`);continue}try{d.info(`Migrating '${I.identifier.id}' extension to '${b}' extension...`);const u=!S.getDisabledExtensions().some(s=>(0,N.$Ip)(s,I.identifier));await A.uninstall(I),d.info(`Uninstalled the unsupported extension '${I.identifier.id}'`);let t=$.find(s=>(0,N.$Ip)(s.identifier,{id:b}));(!t||!t.isPreReleaseVersion&&u)&&(t=await A.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:I.isMachineScoped,operation:a.InstallOperation.Migrate}),d.info(`Installed the pre-release extension '${t.identifier.id}'`),u||(await S.disableExtension(t.identifier),d.info(`Disabled the pre-release extension '${t.identifier.id}' because the unsupported extension '${I.identifier.id}' is disabled`)),f.storage&&(p.addToMigrationList((0,N.$Lp)(I.manifest.publisher,I.manifest.name),(0,N.$Lp)(t.manifest.publisher,t.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${I.identifier.id}' extension to '${b}' extension.`)}catch(u){d.error(u)}}}catch(h){d.error(h)}}}),define(le[234],he([0,1,3,2,35,33,37,7]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;class L extends a.$Wc{constructor(S,d,h,$,c,m,b){super(),this.f=S,this.g=d,this.h=h,this.j=$,this.m=c,this.n=m,this.r=b,this.a=this.B(new P.$me),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new a.$6c),this.s().then(null,f=>b.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(S=>this.u(S.added))),this.B(this.j.onAddExtensions(S=>this.w(S))),this.B(this.j.onDidAddExtensions(S=>this.y(S))),this.B(this.j.onRemoveExtensions(S=>this.z(S))),this.B(this.j.onDidRemoveExtensions(S=>this.C(S))),this.B(this.n.onDidFilesChange(S=>this.D(S)))}async u(S){try{S.length&&await Promise.all(S.map(d=>(this.c.set(d.id,(0,a.$Tc)(this.n.watch(this.m.extUri.dirname(d.extensionsResource)),this.n.watch(d.extensionsResource))),this.G(d.extensionsResource))))}catch(d){throw this.r.error(d),d}}async w(S){for(const d of S.extensions)this.I(this.L(d.identifier,d.version),S.profileLocation)}async y(S){for(const d of S.extensions){const h=this.L(d.identifier,d.version);S.error?this.J(h,S.profileLocation):this.I(h,S.profileLocation)}}async z(S){for(const d of S.extensions)this.J(this.L(d.identifier,d.version),S.profileLocation)}async C(S){const d=[],h=[];for(const $ of S.extensions){const c=this.L($.identifier,$.version);S.error?this.I(c,S.profileLocation):(this.J(c,S.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",$.identifier.id,$.version),h.push(this.f.scanInstalledExtensionAtLocation($.location).then(m=>{m?d.push(m):this.r.info("Extension not found at the location",$.location.toString())},m=>this.r.error(m)))))}try{await Promise.all(h),d.length&&await this.H(d)}catch($){this.r.error($)}}D(S){for(const d of this.h.profiles)S.contains(d.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F(d.extensionsResource)}async F(S){const d=[],h=[],$=await this.j.scanProfileExtensions(S),c=new Set,m=new Set;for(const[b,f]of this.b)f.has(S)&&m.add(b);for(const b of $){const f=this.L(b.identifier,b.version);c.add(f),m.has(f)||(d.push(b.identifier),this.I(f,S))}for(const b of m)if(!c.has(b)){const f=this.M(b);f&&(h.push(f.identifier),this.J(b,S))}(d.length||h.length)&&this.a.fire({added:d.length?{extensions:d,profileLocation:S}:void 0,removed:h.length?{extensions:h,profileLocation:S}:void 0})}async G(S){const d=await this.j.scanProfileExtensions(S);for(const h of d)this.I(this.L(h.identifier,h.version),S)}async H(S){S||(S=(await this.f.scanAllUserInstalledExtensions()).filter(h=>!this.b.has(this.L(h.identifier,h.manifest.version)))),S.length&&await this.f.markAsUninstalled(...S)}I(S,d){let h=this.b.get(S);h||this.b.set(S,h=new N.$Dc($=>this.m.extUri.getComparisonKey($))),h.add(d)}J(S,d){const h=this.b.get(S);h&&h.delete(d),h?.size||this.b.delete(S)}L(S,d){return`${T.$qn.toKey(S.id)}@${d}`}M(S){const[d,h]=(0,O.$Kp)(S);return h?{identifier:{id:d},version:h}:void 0}}e.$Rq=L}),define(le[235],he([0,1,76,19,6,2,23,14,31,16,28,33,10,79,9]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=void 0;let m=class extends $.$7r{constructor(I,g,u,t){super(u),this.h=I,this.j=t,this.g=this.B(new b(g,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(I,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.j.warn(`No language pack found for ${g}`);return}const s=t.translations[I];return s?c.URI.file(s):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),g=Object.keys(I).map(u=>{const t=I[u];return{...this.f(u,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort((u,t)=>u.label.localeCompare(t.label)),g}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const g=await this.g.getLanguagePacks();Object.keys(g).some(u=>g[u]&&g[u].extensions.some(t=>(0,d.$Ip)(t.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),u=await this.g.update(g);return!(0,a.$wb)(Object.keys(I),Object.keys(u))}};e.$8r=m,e.$8r=m=ve([Z(0,S.$kp),Z(1,p.$Ni),Z(2,S.$hp),Z(3,h.$_j)],m);let b=class extends O.$Wc{constructor(I,g){super(),this.j=g,this.c={},this.f=(0,A.$lc)(I.userDataPath,"languagepacks.json"),this.g=new N.$Mh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(g=>{Object.keys(g).forEach(u=>delete g[u]),this.m(g,...I)}).then(()=>this.c)}m(I,...g){for(const u of g)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.n(I,u);Object.keys(I).forEach(u=>this.r(I[u]))}n(I,g){const u=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const s of t)if(g.location.scheme===T.Schemas.file&&f(s)){let r=I[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},I[s.languageId]=r);const i=r.extensions.filter(n=>(0,d.$Ip)(n.extensionIdentifier,u))[0];i?i.version=g.manifest.version:r.extensions.push({extensionIdentifier:u,version:g.manifest.version});for(const n of s.translations)r.translations[n.id]=(0,A.$lc)(g.location.fsPath,n.path)}}r(I){if(I){const g=(0,P.createHash)("md5");for(const u of I.extensions)g.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);I.hash=g.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let g=null;return L.Promises.readFile(this.f,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(g=I(u),u)).then(u=>{for(const s of Object.keys(u))u[s]||delete u[s];this.c=u,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),L.Promises.writeFile(this.f,t)}).then(()=>g,u=>this.j.error(u))})}};b=ve([Z(0,p.$Ni),Z(1,h.$_j)],b);function f(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const I of w.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(le[236],he([0,1,149,8,30,49]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function L(S,d,h){const $=await(0,P.$pE)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,P.$pE)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new $.AppInsightsCore,b=new c.PostChannel,f={instrumentationKey:S,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(h){f.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:h};f.extensionConfig[b.identifier]=w}return m.initialize(f,[]),m.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',d&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),m}class p{constructor(d,h,$,c,m){this.e=d,this.f=h,this.g=$,this.h=m,this.c=T,this.d=A,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(d){if(this.a){if(typeof this.a!="string"){d(this.a);return}this.b||(this.b=L(this.a,this.e,this.h)),this.b.then(h=>{d(h)},h=>{(0,a.$3)(h),console.error(h)})}}log(d,h){if(!this.a)return;h=(0,N.$fo)(h,this.g),h=(0,O.$Dp)(h);const $=this.f+"/"+d;try{this.i(c=>{c.pluginVersionString=h?.properties.version??"Unknown",c.track({name:$,baseData:{name:$,properties:h?.properties,measurements:h?.measurements}})})}catch{}}flush(){return this.a?new Promise(d=>{this.i(h=>{h.unload(!0,()=>{this.a=void 0,d(void 0)})})}):Promise.resolve(void 0)}}e.$0Q=p}),define(le[113],he([0,1,2,178,16,10,24,49]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;let L=class extends P.$Wc{constructor(S,d,h,$,c=""){super(),this.b=c;const m=d.getLogger(A.$xp);if(m)this.a=this.B(m);else{const f=(0,A.$Bp)($,h)?" (Not Sent)":"",w=()=>(0,A.$Ap)($,h)&&S.getLevel()===O.LogLevel.Trace;this.a=this.B(d.createLogger(A.$xp,{name:(0,a.localize)(0,null,f),hidden:!w()})),this.B(S.onDidChangeLogLevel(()=>d.setVisibility(A.$xp,w()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(S,d){this.a.trace(`${this.b}telemetry/${S}`,(0,A.$Dp)(d))}};e.$Bcc=L,e.$Bcc=L=ve([Z(0,O.$_j),Z(1,O.$ak),Z(2,N.$Mi),Z(3,T.$sk)],L)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[114],he([0,1,2,30,5,27,179,22,48,103,24,44,18,49]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0,p=it(p);let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,w,I){this.k=w,this.l=I,this.d={},this.i=new P.$Vc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=h.TelemetryLevel.USAGE,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,O.$if)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.$if)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(h.$hm)||g.affectsConfiguration(h.$jm)||g.affectsConfiguration(h.$im))&&this.m()}))}setExperimentProperty(f,w){this.d[f]=w}m(){let f=(0,$.$Cp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const I=w.usage?h.TelemetryLevel.USAGE:w.error?h.TelemetryLevel.ERROR:h.TelemetryLevel.NONE;f=Math.min(f,I)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,w,I){this.g<w||(I=(0,a.$fo)(I,this.d),I=(0,$.$Hp)(I,this.j),I=(0,a.$fo)(I,this.c),this.b.forEach(g=>g.log(f,I)))}publicLog(f,w){this.n(f,h.TelemetryLevel.USAGE,w)}publicLog2(f,w){this.publicLog(f,w)}publicLogError(f,w){this.h&&this.n(f,h.TelemetryLevel.ERROR,w)}publicLogError2(f,w){this.publicLogError(f,w)}};e.$bs=c,e.$bs=c=ve([Z(1,A.$_i),Z(2,S.$sk)],c);function m(){const b=(0,T.localize)(0,null,p.default.nameLong),f=p.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",p.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=N.$o?"":(0,T.localize)(3,null),I=(0,T.localize)(4,null),g=(0,T.localize)(5,null),u=(0,T.localize)(6,null),t=(0,T.localize)(7,null),s=`
|       | ${I} | ${g} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,T.localize)(8,null);return`
${b} ${f} ${w}

&nbsp;

${t}
${s}

&nbsp;

${r}
`}d.$po.as(L.$uo.Configuration).registerConfiguration({id:h.$gm,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[h.$hm]:{type:"string",enum:[h.TelemetryConfiguration.ON,h.TelemetryConfiguration.ERROR,h.TelemetryConfiguration.CRASH,h.TelemetryConfiguration.OFF],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:m(),default:h.TelemetryConfiguration.ON,restricted:!0,scope:L.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),d.$po.as(L.$uo.Configuration).registerConfiguration({id:h.$gm,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[h.$jm]:{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,T.localize)(16,null,p.default.nameLong,p.default.privacyStatementUrl):(0,T.localize)(15,null,p.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${h.$hm}#\``),scope:L.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(le[237],he([0,1,15,26,280,236]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Q=void 0,N=ke(N);async function T(S,d){const h=await d.request(S,a.CancellationToken.None),$=(await(0,P.$1e)(h.stream)).toString(),c=h.res.statusCode??200;return{headers:h.res.headers,statusCode:c,responseData:$}}async function A(S){const d={method:S.type,headers:S.headers};return new Promise(($,c)=>{const m=N.request(S.url??"",d,b=>{b.on("data",function(f){$({headers:b.headers,statusCode:b.statusCode??200,responseData:f.toString()})}),b.on("error",function(f){c(f)})});m.write(S.data,b=>{b&&c(b)}),m.end()})}async function L(S,d,h){const $=typeof d.data=="string"?d.data:new TextDecoder().decode(d.data),c={type:"POST",headers:{...d.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(d.data).toString()},url:d.urlString,data:$};try{const m=S?await T(c,S):await A(c);h(m.statusCode,m.headers,m.responseData)}catch{h(0,{})}}class p extends O.$0Q{constructor(d,h,$,c,m){const b={sendPOST:(f,w)=>{L(d,f,w)}};super(h,$,c,m,b)}}e.$$Q=p}),define(le[238],he([0,1,23,96,22,16,10,24,18,112,113,114]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;let h=class{constructor(c,m,b,f,w,I){this.b=c,this.c=m,this.d=b,this.e=f,this.f=w,this.g=I,this.a=new Map}h(c){if(!this.a.has(c.id)){const m=Object.create(null);m["common.vscodemachineid"]=this.c.machineId,m["common.vscodesessionid"]=this.c.sessionId;const b=[c.id,JSON.stringify(m),c.aiKey],w=new a.$cr(P.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),I=[new p.$lfc(w),new S.$Bcc(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new d.$bs({appenders:I,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,m,b){this.h(c).publicLog(m,b)}publicLogError(c,m,b){this.h(c).publicLogError(m,b)}};e.$zgc=h,e.$zgc=h=ve([Z(0,N.$_i),Z(1,L.$$l),Z(2,T.$_j),Z(3,T.$ak),Z(4,O.$Mi),Z(5,A.$sk)],h)}),define(le[81],he([0,1,3,2,5,9,22,4,10]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iw=e.$Hw=e.$Ew=e.$Cw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$yw=e.$xw=void 0,e.$zw=d,e.$Aw=$,e.$Bw=c,e.$Dw=m,e.$Fw=b,e.$Gw=f,e.$xw=(0,A.$Fi)("tunnelService"),e.$yw=(0,A.$Fi)("sharedTunnelsService");var p;(function(g){g.Http="http",g.Https="https"})(p||(e.TunnelProtocol=p={}));var S;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(S||(e.TunnelPrivacyId=S={}));function d(g){return!!g.forwardPort}var h;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function $(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(u)return{address:u[1],port:+u[2]}}function c(g){if(g.scheme!=="http"&&g.scheme!=="https"||!g.query)return;const u=g.query.split("&");for(const t of u){const s=t.split("=")[1];if(/^https?:/.exec(s)){const r=$(O.URI.parse(s));if(r)return r}}}e.$Cw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(g){return e.$Cw.indexOf(g)>=0}e.$Ew=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(g){return e.$Ew.indexOf(g)>=0}function f(g,u,t,s){if(t===N.OperatingSystem.Windows)return!1;if(t===N.OperatingSystem.Macintosh&&b(u)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(r?.length===4&&parseInt(r[1])>=18)return!1}return g<1024}class w{constructor(u,t,s){this.remoteAddress=u,this.localAddress=t,this.b=s,this.a=new P.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Hw=w;let I=class extends a.$Wc{constructor(u,t){super(),this.r=u,this.s=t,this.a=new P.$me,this.onTunnelOpened=this.a.event,this.b=new P.$me,this.onTunnelClosed=this.b.event,this.c=new P.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const u=this.s.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.g=u,u?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.h=u.elevation,this.m=u.privacyOptions,this.j=u.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const u=[],t=Array.from(this.f.values());for(const s of t){const r=Array.from(s.values());for(const i of r){const n=await i.value;n&&typeof n!="string"&&u.push(n)}}return u}async dispose(){super.dispose();for(const u of this.f.values()){for(const{value:t}of u.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);u.clear()}this.f.clear()}setEnvironmentTunnel(u,t,s,r,i){this.z(u,t,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:t,localAddress:s,privacy:r,protocol:i,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,t){(b(u)||m(u))&&(u=e.$Cw[0]);const s=this.D(u,t);if(s)return++s.refcount,s.value}openTunnel(u,t,s,r,i,n=!1,o,l){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${i}.`);const y=this.g??u;if(!y)return;if(t||(t="localhost"),r||(r=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const R=this.F(y,t,s,r,i,n,o,l);return R?R.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.w(k);return(k.tunnelRemoteHost!==t||k.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&k.privacy!==o&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(E),E}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),R)}w(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const t=this.f.get(u.tunnelRemoteHost);if(t){const s=t.get(u.tunnelRemotePort);s&&(s.refcount--,await this.y(u.tunnelRemoteHost,u.tunnelRemotePort,s))}}}}async y(u,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${t}.`);const r=s.value.then(async i=>{i&&typeof i!="string"&&(await i.dispose(!0),this.b.fire({host:i.tunnelRemoteHost,port:i.tunnelRemotePort}))});return this.f.has(u)&&this.f.get(u).delete(t),r}}async closeTunnel(u,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${t} `);const s=this.f.get(u);if(s&&s.has(t)){const r=s.get(t);r.refcount=0,await this.y(u,t,r)}}z(u,t,s){this.f.has(u)||this.f.set(u,new Map),this.f.get(u).set(t,{refcount:1,value:s})}async C(u,t){const s=this.f.get(u);if(s){const r=s.get(t),i=r?await r.value:void 0;(!i||typeof i=="string")&&s.delete(t),s.size===0&&this.f.delete(u)}}D(u,t){const s=[u];m(u)?(s.push(...e.$Cw),s.push(...e.$Ew)):b(u)&&s.push(...e.$Ew);const r=s.map(i=>this.f.get(i));for(const i of r){const n=i?.get(t);if(n)return n}}canTunnel(u){return!!$(u)}G(u,t,s,r,i,n,o){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${r}.`);const l=s;this.n.add(l);const y=r===void 0?s:r,R={elevationRequired:i?this.isPortPrivileged(y):!1},k={remoteAddress:{host:t,port:s},localAddressPort:r,privacy:n,public:n?n!==S.Private:void 0,protocol:o},E=u.forwardPort(k,R);return E?(this.z(t,s,E),E.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(l)})):this.n.delete(l),E}};e.$Iw=I,e.$Iw=I=ve([Z(0,L.$_j),Z(1,T.$_i)],I)}),define(le[239],he([0,1,10,81,2,8,6]),function(ne,e,P,a,N,O,T){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;class L extends N.$Wc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.$3h),this.b.p)}setAddress(d){this.a=d,this.b&&(this.b.complete(d),this.b=null)}setTunnel(d){this.B(d)}}let p=class extends N.$Wc{static{A=this}static{this.a=0}constructor(d,h){super(),this.f=d,this.g=h,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(d=>d.dispose())}async createTunnel(){return{id:String(++A.a)}}async startTunnel(d,h,$,c,m,b,f){const w=new L,I=await Promise.resolve(this.f.openTunnel(d,w,$,c,m,b,f));if(!I||typeof I=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${$}:${c} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this.c.has(h))throw this.c.delete(h),w.dispose(),await I.dispose(),(0,O.$8)();return w.setTunnel(I),this.b.set(h,w),this.g.info(`[SharedProcessTunnelService] Created tunnel ${h}: ${I.localAddress} (local) to ${$}:${c} (remote).`),{tunnelLocalPort:I.tunnelLocalPort,localAddress:I.localAddress}}async setAddress(d,h){const $=this.b.get(d);$&&$.setAddress(h)}async destroyTunnel(d){const h=this.b.get(d);if(h){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${d}.`),this.b.delete(d),await h.dispose();return}this.c.add(d)}};e.$Jgc=p,e.$Jgc=p=A=ve([Z(0,a.$yw),Z(1,P.$_j)],p)}),define(le[29],he([0,1,4]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,P.$Fi)("IUriIdentityService")}),define(le[240],he([0,1,29,196,7,21,133,3,2]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=void 0;class p{static{this._clock=0}constructor(h){this.uri=h,this.time=p._clock++}touch(){return this.time=p._clock++,this}}let S=class{constructor(h){this.g=h,this.c=new L.$Vc,this.f=2**16;const $=new Map,c=m=>{let b=$.get(m.scheme);return b===void 0&&(b=h.hasProvider(m)&&!this.g.hasCapability(m,N.FileSystemProviderCapabilities.PathCaseSensitive),$.set(m.scheme,b)),b};this.c.add(A.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{$.delete(m.scheme)})),this.extUri=new O.$8g(c),this.d=new T.$Ns((m,b)=>this.extUri.compare(m,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(h){this.g.hasProvider(h)&&(h=(0,O.$hh)(h));const $=this.d.get(h);return $?$.touch().uri.with({fragment:h.fragment}):(this.d.set(h,new p(h)),this.h(),h)}h(){if(this.d.size<this.f)return;const h=[...this.d.entries()].sort((c,m)=>c[1].time<m[1].time?1:c[1].time>m[1].time?-1:0);p._clock=0,this.d.clear();const $=this.f*.5;for(let c=0;c<$;c++)this.d.set(h[c][0],h[c][1].touch())}};e.$Os=S,e.$Os=S=ve([Z(0,N.$_k)],S),(0,a.$Ls)(P.$Jl,S,a.InstantiationType.Delayed)}),define(le[241],he([0,1,3,2,7,52,35]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agc=void 0;class A extends a.$Wc{constructor(p,S,d,h,$,c){super(),this.f=p,this.g=S,this.h=d,this.j=h,this.m=$,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$me),this.onDidChangeFile=this.a.event,this.b=O.$Li.forUris(()=>!(this.capabilities&N.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new T.$Dc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(h.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const p of this.j.profiles)this.c.add(p.settingsResource),this.c.add(p.keybindingsResource),this.c.add(p.tasksResource),this.c.add(p.extensionsResource)}open(p,S){return this.g.open(this.t(p),S)}close(p){return this.g.close(p)}read(p,S,d,h,$){return this.g.read(p,S,d,h,$)}write(p,S,d,h,$){return this.g.write(p,S,d,h,$)}watch(p,S){this.b.set(p,p);const d=this.g.watch(this.t(p),S);return(0,a.$Uc)(()=>{this.b.delete(p),d.dispose()})}stat(p){return this.g.stat(this.t(p))}mkdir(p){return this.g.mkdir(this.t(p))}rename(p,S,d){return this.g.rename(this.t(p),this.t(S),d)}readFile(p,S){return this.g.readFile(this.t(p),S)}readFileStream(p,S,d){return this.g.readFileStream(this.t(p),S,d)}readdir(p){return this.g.readdir(this.t(p))}enforceAtomicReadFile(p){return this.c.has(p)}writeFile(p,S,d){return this.g.writeFile(this.t(p),S,d)}enforceAtomicWriteFile(p){return this.c.has(p)?{postfix:".vsctmp"}:!1}delete(p,S){return this.g.delete(this.t(p),S)}copy(p,S,d){if((0,N.$dl)(this.g))return this.g.copy(this.t(p),this.t(S),d);throw new Error("copy not supported")}cloneFile(p,S){if((0,N.$el)(this.g))return this.g.cloneFile(this.t(p),this.t(S));throw new Error("clone not supported")}s(p){const S=[];for(const d of p){if(d.resource.scheme!==this.f)continue;const h=this.u(d.resource);this.b.findSubstr(h)&&S.push({resource:h,type:d.type,cId:d.cId})}S.length&&(this.n.debug("User data changed"),this.a.fire(S))}t(p){return p.with({scheme:this.f})}u(p){return p.with({scheme:this.h})}}e.$agc=A}),define(le[82],he([0,1,64]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=a,e.$SLb=N,e.$TLb=O;function a(T,A,L,p){const S=(0,P.$$n)(T,A,L,p)[0];return S&&(T=T.substring(0,S.offset)+S.content+T.substring(S.offset+S.length)),T}function N(T,A,L){let p=L;for(;p>=0;){if(T.charAt(p)===A.charAt(A.length-1)&&A.length===1)return p+1;if(p--,A.length===2&&p>=0&&T.charAt(p)===A.charAt(0))return p+2}return 0}function O(T,A,L){let p=L;for(;p>=0;)if(T.charAt(p)===A.charAt(A.length-1)&&A.length===1||(p++,A.length===2&&p>=0&&T.charAt(p)===A.charAt(1)))return p;return T.length-1}}),define(le[242],he([0,1,30,57,13]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=O,a=ke(a);function O($,c,m,b,f,w){const I=[],g=[],u=[];if(!c){const M=$.filter(({identifier:X})=>f.every(K=>K.toLowerCase()!==X.id.toLowerCase()));return{local:{added:I,removed:g,updated:u},remote:M.length>0?{added:M,updated:[],removed:[],all:M}:null}}$=$.map(d),c=c.map(d),m=m?m.map(d):null;const t=new Map,s=M=>{M.uuid&&t.set(M.id.toLowerCase(),M.uuid)};$.forEach(({identifier:M})=>s(M)),c.forEach(({identifier:M})=>s(M)),m?.forEach(({identifier:M})=>s(M)),b?.forEach(({identifier:M})=>s(M)),w?.forEach(M=>s(M));const r=M=>{const X=M.identifier.uuid||t.get(M.identifier.id.toLowerCase());return X?`uuid:${X}`:`id:${M.identifier.id.toLowerCase()}`},i=(M,X)=>(M.set(r(X),X),M),n=$.reduce(i,new Map),o=c.reduce(i,new Map),l=c.reduce((M,X)=>i(M,(0,P.$co)(X)),new Map),y=m?m.reduce(i,new Map):null,R=b.reduce(i,new Map),k=f.reduce((M,X)=>{const K=t.get(X.toLowerCase());return M.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)},new Set),E=w?w.reduce((M,{id:X,uuid:K})=>(K=K??t.get(X.toLowerCase()),M.add(K?`uuid:${K}`:`id:${X.toLowerCase()}`)),new Set):null,v=T(n,o,k,!1);if(v.added.size>0||v.removed.size>0||v.updated.size>0){const M=T(y,n,k,!1),X=T(y,o,k,!0),K=(Q,G,ie,V)=>{let z,ee,re;return G.installed?(z=V.pinned,re=V.preRelease,z&&(ee=V.version)):(z=ie.pinned,re=ie.preRelease,z&&(ee=ie.version)),z===void 0&&(z=G.pinned,z&&(ee=G.version)),re===void 0&&(re=G.preRelease),{...V,installed:G.installed||ie.installed,pinned:z,preRelease:re,version:ee??(ie.version&&(!G.installed||a.gt(ie.version,G.version))?ie.version:G.version),state:L(G,ie,y?.get(Q))}};for(const Q of X.removed.values()){const G=n.get(Q);if(!G)continue;const ie=(0,N.$qg)(y?.get(Q)),V=E&&!E.has(Q)&&ie.installed;G.installed&&V?g.push(G.identifier):l.set(Q,G)}for(const Q of X.added.values()){const G=(0,N.$qg)(o.get(Q)),ie=n.get(Q);if(ie){if(v.updated.has(Q)){const V=K(Q,ie,G,G);A(ie,G,!1,!1)||u.push(h(V,Q)),l.set(Q,V)}}else G.installed&&I.push(h(G,Q))}for(const Q of X.updated.values()){const G=(0,N.$qg)(o.get(Q)),ie=(0,N.$qg)(y?.get(Q)),V=n.get(Q);if(V)if(E&&!E.has(Q)&&ie.installed&&V.installed&&!G.installed)g.push(V.identifier);else{const ee=K(Q,V,G,G);u.push(h(ee,Q)),l.set(Q,ee)}else G.installed&&I.push(h(G,Q))}for(const Q of M.added.values())X.added.has(Q)||l.set(Q,(0,N.$qg)(n.get(Q)));for(const Q of M.updated.values()){if(X.removed.has(Q)||X.updated.has(Q))continue;const G=(0,N.$qg)(n.get(Q)),ie=(0,N.$qg)(o.get(Q));l.set(Q,K(Q,G,ie,G))}for(const Q of M.removed.values())X.updated.has(Q)||X.removed.has(Q)||R.has(Q)||(0,N.$qg)(o.get(Q)).installed&&E&&(E.has(Q)||!(0,N.$qg)(y?.get(Q)).installed||l.delete(Q))}const C=[],U=T(o,l,new Set,!0),F=U.added.size>0||U.updated.size>0||U.removed.size>0;return F&&l.forEach((M,X)=>C.push(h(M,X))),{local:{added:I,removed:g,updated:u},remote:F?{added:[...U.added].map(M=>l.get(M)),updated:[...U.updated].map(M=>l.get(M)),removed:[...U.removed].map(M=>o.get(M)),all:C}:null}}function T($,c,m,b){const f=$?[...$.keys()].filter(t=>!m.has(t)):[],w=[...c.keys()].filter(t=>!m.has(t)),I=w.filter(t=>!f.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),g=f.filter(t=>!w.includes(t)).reduce((t,s)=>(t.add(s),t),new Set),u=new Set;for(const t of f){if(g.has(t))continue;const s=$.get(t),r=c.get(t);(!r||!A(s,r,b,!0))&&u.add(t)}return{added:I,removed:g,updated:u}}function A($,c,m,b){return!($.disabled!==c.disabled||!!$.isApplicationScoped!=!!c.isApplicationScoped||b&&$.installed!==c.installed||$.installed&&c.installed&&($.preRelease!==c.preRelease||$.pinned!==c.pinned||c.pinned&&$.version!==c.version)||!S($.state,c.state)||m&&$.version!==c.version)}function L($,c,m){const b=$.state,f=c.state,w=m?.state;if(!c.version||b&&a.gt($.version,c.version))return b;if(f&&a.gt(c.version,$.version)||!b)return f;if(!f)return b;const I=(0,P.$co)(b),g=w?p(w,f):{added:Object.keys(f).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set},u=w?p(w,b):{added:Object.keys(b).reduce((t,s)=>(t.add(s),t),new Set),removed:new Set,updated:new Set};for(const t of[...g.added.values(),...g.updated.values()])I[t]=f[t];for(const t of g.removed.values())u.updated.has(t)||delete I[t];return I}function p($,c){const m=Object.keys($),b=Object.keys(c),f=b.filter(g=>!m.includes(g)).reduce((g,u)=>(g.add(u),g),new Set),w=m.filter(g=>!b.includes(g)).reduce((g,u)=>(g.add(u),g),new Set),I=new Set;for(const g of m){if(w.has(g))continue;const u=$[g],t=c[g];(0,P.$go)(u,t)||I.add(g)}return{added:f,removed:w,updated:I}}function S($={},c={}){const{added:m,removed:b,updated:f}=p($,c);return m.size===0&&b.size===0&&f.size===0}function d($){return{...$,disabled:!!$.disabled,installed:!!$.installed}}function h($,c){const m={...$,identifier:{id:$.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!$.preRelease,pinned:!!$.pinned};return $.disabled||delete m.disabled,$.installed||delete m.installed,$.state||delete m.state,$.isApplicationScoped||delete m.isApplicationScoped,m}}),define(le[115],he([0,1,19,22,4]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Nb=e.$9Nb=void 0,e.$9Nb=(0,N.$Fi)("IIgnoredExtensionsManagementService");let O=class{constructor(A){this.a=A}hasToNeverSyncExtension(A){return this.b().includes(A.toLowerCase())}hasToAlwaysSyncExtension(A){return this.b().includes(`-${A.toLowerCase()}`)}updateIgnoredExtensions(A,L){let p=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return p=p.filter(S=>S!==A&&S!==`-${A}`),L&&p.push(A.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",p.length?p:void 0,a.ConfigurationTarget.USER)}updateSynchronizedExtensions(A,L){let p=[...this.a.getValue("settingsSync.ignoredExtensions")].map(S=>S.toLowerCase());return p=p.filter(S=>S!==A&&S!==`-${A}`),L&&p.push(`-${A.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",p.length?p:void 0,a.ConfigurationTarget.USER)}getIgnoredExtensions(A){const L=A.filter(h=>h.isMachineScoped).map(h=>h.identifier.id.toLowerCase()),p=this.b().map(h=>h.toLowerCase()),S=[],d=[];if(Array.isArray(p))for(const h of p)h.startsWith("-")?d.push(h.substring(1)):S.push(h);return(0,P.$Ob)([...L,...S].filter(h=>!d.includes(h)))}b(){let A=this.a.inspect("settingsSync.ignoredExtensions").userValue;return A!==void 0||(A=this.a.inspect("sync.ignoredExtensions").userValue,A!==void 0)?A:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(L=>L.toLowerCase())}};e.$0Nb=O,e.$0Nb=O=ve([Z(0,a.$_i)],O)}),define(le[243],he([0,1,19,34,30,97,82]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=L,N=ke(N),T=ke(T);function A(g){return(0,a.$Vn)(g)||[]}async function L(g,u,t,s,r){const i=A(g),n=A(u),o=t?A(t):null,l=[...i,...n,...o||[]].map(K=>K.key),y=await r.resolveUserBindings(l),R=S(i,n,o,y);if(!R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!R.hasLocalForwarded&&R.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(R.hasLocalForwarded&&!R.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const k=h(i),E=h(n),v=o?h(o):null,C=c(k,E,y),U=v?c(v,k,y):{added:[...k.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},F=v?c(v,E,y):{added:[...E.keys()].reduce((K,Q)=>(K.add(Q),K),new Set),removed:new Set,updated:new Set},M=p(C,U,F);let X=g;for(const K of M.removed.values())M.conflicts.has(K)||(X=w(X,K,s));for(const K of M.added.values()){if(M.conflicts.has(K))continue;const Q=E.get(K);if(Q.some(G=>G.command!==`-${K}`&&R.conflicts.has(y[G.key]))){M.conflicts.add(K);continue}X=f(X,Q,s)}for(const K of M.updated.values()){if(M.conflicts.has(K))continue;const Q=E.get(K);if(Q.some(G=>G.command!==`-${K}`&&R.conflicts.has(y[G.key]))){M.conflicts.add(K);continue}X=I(X,K,Q,s)}return{mergeContent:X,hasChanges:!0,hasConflicts:M.conflicts.size>0}}function p(g,u,t){const s=new Set,r=new Set,i=new Set,n=new Set;for(const o of u.removed.values())t.updated.has(o)&&n.add(o);for(const o of t.removed.values())n.has(o)||(u.updated.has(o)?n.add(o):r.add(o));for(const o of u.added.values())n.has(o)||t.added.has(o)&&g.updated.has(o)&&n.add(o);for(const o of t.added.values())n.has(o)||(u.added.has(o)?g.updated.has(o)&&n.add(o):s.add(o));for(const o of u.updated.values())n.has(o)||t.updated.has(o)&&g.updated.has(o)&&n.add(o);for(const o of t.updated.values())n.has(o)||(u.updated.has(o)?g.updated.has(o)&&n.add(o):i.add(o));return{added:s,removed:r,updated:i,conflicts:n}}function S(g,u,t,s){const r=new Set,i=d(g,s),n=d(u,s),o=t?d(t,s):null,l=$(i,n);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const y=o?$(o,i):{added:[...i.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const R=o?$(o,n):{added:[...n.keys()].reduce((U,F)=>(U.add(F),U),new Set),removed:new Set,updated:new Set};if(R.added.size===0&&R.removed.size===0&&R.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:k,removed:E,updated:v,conflicts:C}=p(l,y,R);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:k,removed:E,updated:v,conflicts:C}}function d(g,u){const t=new Map;for(const s of g){const r=u[s.key];let i=t.get(r);i||(i=[],t.set(r,i)),i.push(s)}return t}function h(g){const u=new Map;for(const t of g){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=u.get(s);r||(r=[],u.set(s,r)),r.push(t)}return u}function $(g,u){const t=[...g.keys()],s=[...u.keys()],r=s.filter(o=>!t.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),i=t.filter(o=>!s.includes(o)).reduce((o,l)=>(o.add(l),o),new Set),n=new Set;for(const o of t){if(i.has(o))continue;const l=g.get(o).map(R=>({...R,key:o})),y=u.get(o).map(R=>({...R,key:o}));(0,P.$wb)(l,y,(R,k)=>b(R,k))||n.add(o)}return{added:r,removed:i,updated:n}}function c(g,u,t){const s=[...g.keys()],r=[...u.keys()],i=r.filter(l=>!s.includes(l)).reduce((l,y)=>(l.add(y),l),new Set),n=s.filter(l=>!r.includes(l)).reduce((l,y)=>(l.add(y),l),new Set),o=new Set;for(const l of s){if(n.has(l))continue;const y=g.get(l).map(k=>({...k,key:t[k.key]})),R=u.get(l).map(k=>({...k,key:t[k.key]}));m(y,R)||o.add(l)}return{added:i,removed:n,updated:o}}function m(g,u){return!(!(0,P.$wb)(g.filter(({command:t})=>t[0]!=="-"),u.filter(({command:t})=>t[0]!=="-"),(t,s)=>b(t,s))||!(0,P.$wb)(g.filter(({command:t})=>t[0]==="-"),u.filter(({command:t})=>t[0]==="-"),(t,s)=>b(t,s)))}function b(g,u){if(g.command!==u.command||g.key!==u.key)return!1;const t=O.$Dj.deserialize(g.when),s=O.$Dj.deserialize(u.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!N.$go(g.args,u.args))}function f(g,u,t){for(const s of u)g=T.edit(g,[-1],s,t);return g}function w(g,u,t){const s=A(g);for(let r=s.length-1;r>=0;r--)(s[r].command===u||s[r].command===`-${u}`)&&(g=T.edit(g,[r],void 0,t));return g}function I(g,u,t,s){const r=A(g),i=r.findIndex(n=>n.command===u||n.command===`-${u}`);for(let n=r.length-1;n>=0;n--)(r[n].command===u||r[n].command===`-${u}`)&&(g=T.edit(g,[n],void 0,s));for(let n=t.length-1;n>=0;n--)g=T.edit(g,[i],t[n],s);return g}}),define(le[244],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=P,e.$tbc=N;function P(O,T,A){const L={},p={},S=new Set;if(!T)return{local:{added:L,updated:p,removed:[...S.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const d=a(O,T);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{local:{added:L,updated:p,removed:[...S.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const h=a(A,O),$=a(A,T),c={},m={},b=new Set,f=new Set;for(const w of h.removed.values())$.updated.has(w)?L[w]=T[w]:b.add(w);for(const w of $.removed.values())f.has(w)||(h.updated.has(w)?f.add(w):S.add(w));for(const w of h.updated.values())f.has(w)||($.updated.has(w)?d.updated.has(w)&&f.add(w):m[w]=O[w]);for(const w of $.updated.values())f.has(w)||(h.updated.has(w)?d.updated.has(w)&&f.add(w):O[w]!==void 0&&(p[w]=T[w]));for(const w of h.added.values())f.has(w)||($.added.has(w)?d.updated.has(w)&&f.add(w):c[w]=O[w]);for(const w of $.added.values())f.has(w)||(h.added.has(w)?d.updated.has(w)&&f.add(w):L[w]=T[w]);return{local:{added:L,removed:[...S.values()],updated:p},remote:{added:c,removed:[...b.values()],updated:m},conflicts:[...f.values()]}}function a(O,T){const A=O?Object.keys(O):[],L=T?Object.keys(T):[],p=L.filter(h=>!A.includes(h)).reduce((h,$)=>(h.add($),h),new Set),S=A.filter(h=>!L.includes(h)).reduce((h,$)=>(h.add($),h),new Set),d=new Set;for(const h of A){if(S.has(h))continue;const $=O[h],c=T[h];$!==c&&d.add(h)}return{added:p,removed:S,updated:d}}function N(O,T){const{added:A,removed:L,updated:p}=a(O,T);return A.size===0&&L.size===0&&p.size===0}}),define(le[245],he([0,1,30]),function(ne,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=a;function a(O,T,A,L){const p={added:[],removed:[],updated:[]};let S={added:[],removed:[],updated:[]};if(!T){const h=O.filter(({id:$})=>!L.includes($));return h.length?S.added=h:S=null,{local:p,remote:S}}const d=N(O,T,L);if(d.added.length>0||d.removed.length>0||d.updated.length>0){const h=N(A,O,L),$=N(A,T,L);for(const c of $.removed){const m=O.find(b=>b.id===c);m&&p.removed.push(m)}for(const c of $.added){const m=T.find(b=>b.id===c);h.added.includes(c)?d.updated.includes(c)&&p.updated.push(m):p.added.push(m)}for(const c of $.updated)p.updated.push(T.find(m=>m.id===c));for(const c of h.added)$.added.includes(c)||S.added.push(O.find(m=>m.id===c));for(const c of h.updated)$.removed.includes(c)||$.updated.includes(c)||S.updated.push(O.find(m=>m.id===c));for(const c of h.removed){const m=T.find(b=>b.id===c);m&&S.removed.push(m)}}return S.added.length===0&&S.removed.length===0&&S.updated.length===0&&(S=null),{local:p,remote:S}}function N(O,T,A){O=O?O.filter(({id:$})=>!A.includes($)):[],T=T.filter(({id:$})=>!A.includes($));const L=O.map(({id:$})=>$),p=T.map(({id:$})=>$),S=p.filter($=>!L.includes($)),d=L.filter($=>!p.includes($)),h=[];for(const{id:$,name:c,shortName:m,icon:b,useDefaultFlags:f}of O){if(d.includes($))continue;const w=T.find(I=>I.id===$);(!w||w.name!==c||w.shortName!==m||w.icon!==b||!(0,P.$go)(w.useDefaultFlags,f))&&h.push($)}return{added:S,removed:d,updated:h}}}),define(le[25],he([0,1,19,13,185,48,28,4,104,44]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnb=e.$bnb=e.$anb=e.$_mb=e.$$mb=e.$0mb=e.$9mb=e.$8mb=e.$7mb=e.$5mb=e.MergeState=e.Change=e.SyncStatus=e.$4mb=e.$3mb=e.$2mb=e.UserDataSyncErrorCode=e.$Zmb=e.$Ymb=e.$Xmb=e.$Wmb=e.$Vmb=e.$Smb=e.SyncResource=e.$Pmb=e.$Omb=void 0,e.$Mmb=S,e.$Nmb=d,e.$Qmb=h,e.$Rmb=$,e.$Tmb=m,e.$Umb=b,e.$1mb=f,e.$6mb=i;function S(){const n=p.$po.as(O.$uo.Configuration).getConfigurationProperties();return Object.keys(n).filter(o=>!!n[o].disallowSyncIgnore)}function d(){const n=p.$po.as(O.$uo.Configuration).getConfigurationProperties(),o=Object.keys(n).filter(R=>!!n[R].ignoreSync),l=Object.keys(n).filter(R=>n[R].scope===O.ConfigurationScope.MACHINE||n[R].scope===O.ConfigurationScope.MACHINE_OVERRIDABLE),y=S();return(0,P.$Ob)([...o,...l,...y])}e.$Omb="settingsSync",e.$Pmb="settingsSync.keybindingsPerPlatform";function h(){const n="vscode://schemas/ignoredSettings",o=p.$po.as(O.$uo.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,N.localize)(0,null),type:"object",properties:{[e.$Pmb]:{type:"boolean",description:(0,N.localize)(1,null),default:!0,scope:O.ConfigurationScope.APPLICATION,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,N.localize)(2,null),items:[{type:"string",pattern:T.$7o,errorMessage:(0,N.localize)(3,null)}],default:[],scope:O.ConfigurationScope.APPLICATION,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,N.localize)(4,null),default:[],scope:O.ConfigurationScope.APPLICATION,$ref:n,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=p.$po.as(L.$qo.JSONContribution),y=()=>{const R=S(),k=d(),E=Object.keys(O.$vo.properties).filter(U=>!k.includes(U)),v=k.filter(U=>!R.includes(U)),C={items:{type:"string",enum:[...E,...v.map(U=>`-${U}`)]}};l.registerSchema(n,C)};return o.onDidUpdateConfiguration(()=>y())}function $(n){return n&&(0,a.$hg)(n)&&(0,a.$fg)(n.id)&&Array.isArray(n.scopes)}var c;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState",n.Profiles="profiles",n.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$Smb=[c.Settings,c.Keybindings,c.Snippets,c.Tasks,c.Extensions,c.GlobalState,c.Profiles];function m(n,...o){return n?[n,...o]:o}function b(n,o,l,y){return y.joinPath(l.userDataSyncHome,...m(n,o,`lastSync${o}.json`))}e.$Vmb=(0,A.$Fi)("IUserDataSyncStoreManagementService"),e.$Wmb=(0,A.$Fi)("IUserDataSyncStoreService"),e.$Xmb=(0,A.$Fi)("IUserDataSyncLocalStoreService"),e.$Ymb="x-operation-id",e.$Zmb="X-Execution-Id";function f(n){const o={};return o[e.$Zmb]=n,o}var w;(function(n){n.Unauthorized="Unauthorized",n.Forbidden="Forbidden",n.NotFound="NotFound",n.MethodNotFound="MethodNotFound",n.Conflict="Conflict",n.Gone="Gone",n.PreconditionFailed="PreconditionFailed",n.TooLarge="TooLarge",n.UpgradeRequired="UpgradeRequired",n.PreconditionRequired="PreconditionRequired",n.TooManyRequests="RemoteTooManyRequests",n.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",n.RequestFailed="RequestFailed",n.RequestCanceled="RequestCanceled",n.RequestTimeout="RequestTimeout",n.RequestProtocolNotSupported="RequestProtocolNotSupported",n.RequestPathNotEscaped="RequestPathNotEscaped",n.RequestHeadersNotObject="RequestHeadersNotObject",n.NoCollection="NoCollection",n.NoRef="NoRef",n.EmptyResponse="EmptyResponse",n.TurnedOff="TurnedOff",n.SessionExpired="SessionExpired",n.ServiceChanged="ServiceChanged",n.DefaultServiceChanged="DefaultServiceChanged",n.LocalTooManyProfiles="LocalTooManyProfiles",n.LocalTooManyRequests="LocalTooManyRequests",n.LocalPreconditionFailed="LocalPreconditionFailed",n.LocalInvalidContent="LocalInvalidContent",n.LocalError="LocalError",n.IncompatibleLocalContent="IncompatibleLocalContent",n.IncompatibleRemoteContent="IncompatibleRemoteContent",n.Unknown="Unknown"})(w||(e.UserDataSyncErrorCode=w={}));class I extends Error{constructor(o,l,y,R){super(o),this.code=l,this.resource=y,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$2mb=I;class g extends I{constructor(o,l,y,R,k){super(o,y,void 0,k),this.url=l,this.serverCode=R}}e.$3mb=g;class u extends I{constructor(o,l){super(o,l)}}e.$4mb=u,function(n){function o(l){if(l instanceof n)return l;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(y&&y[1]){const R=y[2]==="unknown"?void 0:y[2],k=y[3]==="unknown"?void 0:y[3];return new n(l.message,y[1],R,k)}return new n(l.message,w.Unknown)}n.toUserDataSyncError=o}(I||(e.$2mb=I={}));var t;(function(n){n.Uninitialized="uninitialized",n.Idle="idle",n.Syncing="syncing",n.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var s;(function(n){n[n.None=0]="None",n[n.Added=1]="Added",n[n.Modified=2]="Modified",n[n.Deleted=3]="Deleted"})(s||(e.Change=s={}));var r;(function(n){n.Preview="preview",n.Conflict="conflict",n.Accepted="accepted"})(r||(e.MergeState=r={})),e.$5mb="sync.store.url.type";function i(n){return`sync.enable.${n}`}e.$7mb=(0,A.$Fi)("IUserDataSyncEnablementService"),e.$8mb=(0,A.$Fi)("IUserDataSyncService"),e.$9mb=(0,A.$Fi)("IUserDataSyncResourceProviderService"),e.$0mb=(0,A.$Fi)("IUserDataAutoSyncService"),e.$$mb=(0,A.$Fi)("IUserDataSyncUtilService"),e.$_mb=(0,A.$Fi)("IUserDataSyncLogService"),e.$anb="userDataSync",e.$bnb="vscode-userdata-sync",e.$cnb="preview"}),define(le[246],he([0,1,30,25]),function(ne,e,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oNb=N,P=ke(P);function N(T,A,L,p,S){if(!A)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const d=O(T,A);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const h=L?O(L,A):{added:Object.keys(A).reduce((w,I)=>(w.add(I),w),new Set),removed:new Set,updated:new Set},$=L?O(L,T):{added:Object.keys(T).reduce((w,I)=>(w.add(I),w),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},m=P.$co(A),b=!L;for(const w of $.added.values())w!==a.$5mb&&b&&h.added.has(w)||(m[w]=T[w]);for(const w of $.updated.values())m[w]=T[w];for(const w of $.removed.values())p.unregistered.includes(w)||delete m[w];for(const w of h.added.values()){const I=A[w];if(p.machine.includes(w)){S.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(L&&$.added.has(w))continue;const g=T[w];g&&g.value===I.value||w===a.$5mb&&b&&$.added.has(w)||(g?c.updated[w]=I:c.added[w]=I)}for(const w of h.updated.values()){const I=A[w];if(p.machine.includes(w)){S.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if($.updated.has(w)||$.removed.has(w))continue;const g=T[w];g&&g.value===I.value||(c.updated[w]=I)}for(const w of h.removed.values()){if(p.machine.includes(w)){S.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}$.updated.has(w)||$.removed.has(w)||c.removed.push(w)}const f=O(A,m);return{local:c,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:m}}}function O(T,A){const L=Object.keys(T),p=Object.keys(A),S=p.filter($=>!L.includes($)).reduce(($,c)=>($.add(c),$),new Set),d=L.filter($=>!p.includes($)).reduce(($,c)=>($.add(c),$),new Set),h=new Set;for(const $ of L){if(d.has($))continue;const c=T[$],m=A[$];P.$go(c,m)||h.add($)}return{added:S,removed:d,updated:h}}}),define(le[247],he([0,1,19,34,64,45,30,82,25]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ULb=p,e.$VLb=h,e.$WLb=$,e.$XLb=c,e.$YLb=b,e.$ZLb=w,T=ke(T),A=ke(A);function p(l,y,R){let k=[];R?k=d(R):k=S(y);const E=[],v=[...(0,L.$Mmb)()];if(Array.isArray(k))for(const C of k)C.startsWith("-")?v.push(C.substring(1)):E.push(C);return(0,P.$Ob)([...l,...E].filter(C=>!v.includes(C)))}function S(l){let y=l.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=l.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:l.getValue("settingsSync.ignoredSettings")||[]}function d(l){const y=(0,a.$Vn)(l);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function h(l,y){const R=(0,a.$Vn)(l)||{};let k="{}";for(const E of Object.keys(R)){const v=(0,N.$$n)(k,[E],R[E],y);k=(0,N.$bo)(k,v)}return k}function $(l,y,R,k){if(R.length){const E=o(y),v=(0,a.$Vn)(y)||{},C=(0,a.$Vn)(l);if(!C)return l;const U=[];for(const F of R){const M=v[F],X=C[F];M===void 0?l=A.edit(l,[F],void 0,k):X!==void 0?l=A.edit(l,[F],M,k):U.push(t(F,E))}U.sort((F,M)=>F.startOffset-M.startOffset),U.forEach(F=>l=w(F.setting.key,y,l,k))}return l}function c(l,y,R,k,E,v){const C=$(l,y,k,v),U=R!==C,F=R!==y;if(!U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(U&&!F)return{conflictsSettings:[],localContent:null,remoteContent:C,hasConflicts:!1};if(F&&!U)return{conflictsSettings:[],localContent:$(y,l,k,v),remoteContent:null,hasConflicts:!1};if(R===null&&b(l)){const D=m(l,y,k)?null:$(y,l,k,v);return{conflictsSettings:[],localContent:D,remoteContent:null,hasConflicts:!1}}let M=l,X=y;const K=(0,a.$Vn)(l),Q=(0,a.$Vn)(y),G=R?(0,a.$Vn)(R):null,ie=k.reduce((D,B)=>(D.add(B),D),new Set),V=f(K,Q,ie),z=f(G,K,ie),ee=f(G,Q,ie),re=new Map,ce=new Set,q=D=>{ce.add(D);const B=E.filter(({key:j})=>j===D)[0];B?(M=A.edit(M,[D],B.value,v),X=A.edit(X,[D],B.value,v)):re.set(D,{key:D,localValue:K[D],remoteValue:Q[D]})};for(const D of z.removed.values())ee.updated.has(D)?q(D):X=A.edit(X,[D],void 0,v);for(const D of ee.removed.values())ce.has(D)||(z.updated.has(D)?q(D):M=A.edit(M,[D],void 0,v));for(const D of z.updated.values())ce.has(D)||(ee.updated.has(D)?V.updated.has(D)&&q(D):X=A.edit(X,[D],K[D],v));for(const D of ee.updated.values())ce.has(D)||(z.updated.has(D)?V.updated.has(D)&&q(D):M=A.edit(M,[D],Q[D],v));for(const D of z.added.values())ce.has(D)||(ee.added.has(D)?V.updated.has(D)&&q(D):X=w(D,M,X,v));for(const D of ee.added.values())ce.has(D)||(z.added.has(D)?V.updated.has(D)&&q(D):M=w(D,X,M,v));const x=re.size>0||!m(M,X,k),J=x||!m(M,l,[]),H=x||!m(X,y,[]);return{localContent:J?M:null,remoteContent:H?X:null,conflictsSettings:[...re.values()],hasConflicts:x}}function m(l,y,R){if(l===y)return!0;const k=(0,a.$Vn)(l),E=(0,a.$Vn)(y),v=R.reduce((F,M)=>(F.add(M),F),new Set),C=o(l).filter(F=>!(F.setting&&v.has(F.setting.key))),U=o(y).filter(F=>!(F.setting&&v.has(F.setting.key)));if(C.length!==U.length)return!1;for(let F=0;F<C.length;F++){const M=C[F],X=U[F];if(M.setting&&X.setting){if(M.setting.key!==X.setting.key||!T.$go(k[M.setting.key],E[M.setting.key]))return!1}else if(!M.setting&&!X.setting){if(M.value!==X.value)return!1}else return!1}return!0}function b(l){return l?o(l).length===0:!0}function f(l,y,R){const k=l?Object.keys(l).filter(F=>!R.has(F)):[],E=Object.keys(y).filter(F=>!R.has(F)),v=E.filter(F=>!k.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),C=k.filter(F=>!E.includes(F)).reduce((F,M)=>(F.add(M),F),new Set),U=new Set;if(l)for(const F of k){if(C.has(F))continue;const M=l[F],X=y[F];T.$go(M,X)||U.add(F)}return{added:v,removed:C,updated:U}}function w(l,y,R,k){const E=(0,a.$Vn)(y),v=o(y),C=o(R),U=I(l,v,C);return g(R,l,E[l],U,C,k)}function I(l,y,R){const k=y.findIndex(v=>v.setting?.key===l),E=y[k-1];if(E){if(E.setting){const C=t(E.setting.key,R);if(C)return{index:R.indexOf(C),insertAfter:!0}}else{const C=s(k,y);if(C){const U=t(C.setting.key,R);if(U){const F=r(R.indexOf(U),R),M=i(y,C,y[k]);if(F){const X=i(R,U,F),K=n(M,X);return K?{index:R.indexOf(K),insertAfter:!0}:{index:R.indexOf(F),insertAfter:!1}}else{const X=i(R,U,R[R.length-1]),K=n(M,X);return K?{index:R.indexOf(K),insertAfter:!0}:{index:R.length-1,insertAfter:!0}}}}}const v=y[k+1];if(v)if(v.setting){const C=t(v.setting.key,R);if(C)return{index:R.indexOf(C),insertAfter:!1}}else{const C=r(k,y);if(C){const U=t(C.setting.key,R);if(U){const F=s(R.indexOf(U),R),M=i(y,y[k],C);if(F){const X=i(R,F,U),K=n(M.reverse(),X.reverse());return K?{index:R.indexOf(K),insertAfter:!1}:{index:R.indexOf(F),insertAfter:!0}}else{const X=i(R,R[0],U),K=n(M.reverse(),X.reverse());return K?{index:R.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:R.length-1,insertAfter:!0}}function g(l,y,R,k,E,v){let C;return k.index===-1?C=(0,N.$$n)(l,[y],R,v):C=u(l,y,R,k,E,v).map(U=>(0,N.$_n)(l,U,v)[0]),(0,N.$bo)(l,C)}function u(l,y,R,k,E,v){const C=`${JSON.stringify(y)}: ${JSON.stringify(R)}`,U=(0,O.$8n)(v,l),F=E[k.index];if(k.insertAfter){const M=[];if(F.setting)M.push({offset:F.endOffset,length:0,content:","+C});else{const X=r(k.index,E),K=s(k.index,E),Q=K?.setting?.commaOffset;K&&Q===void 0&&M.push({offset:K.endOffset,length:0,content:","});const G=Q!==void 0&&Q>F.endOffset;M.push({offset:G?Q+1:F.endOffset,length:0,content:X?U+C+",":U+C})}return M}else{if(F.setting)return[{offset:F.startOffset,length:0,content:C+","}];const M=(E[k.index-1]&&!E[k.index-1].setting?U:"")+C+(r(k.index,E)?",":"")+U;return[{offset:F.startOffset,length:0,content:M}]}}function t(l,y){return y.filter(R=>R.setting?.key===l)[0]}function s(l,y){for(let R=l-1;R>=0;R--)if(y[R].setting)return y[R]}function r(l,y){for(let R=l+1;R<y.length;R++)if(y[R].setting)return y[R]}function i(l,y,R){const k=l.indexOf(y),E=l.indexOf(R);return l.filter((v,C)=>k<C&&C<E)}function n(l,y){if(l.length&&y.length){let R=0;for(;R<y.length&&R<l.length;R++)if(l[R].value!==y[R].value)return y[R-1];return y[R-1]}}function o(l){const y=[];let R=-1,k,E;const v={onObjectBegin:C=>{R++},onObjectProperty:(C,U,F)=>{R===0&&(k=U,E=C)},onObjectEnd:(C,U)=>{R--,R===0&&y.push({startOffset:k,endOffset:C+U,value:l.substring(k,C+U),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(C,U)=>{R++},onArrayEnd:(C,U)=>{R--,R===0&&y.push({startOffset:k,endOffset:C+U,value:l.substring(k,C+U),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(C,U,F)=>{R===0&&y.push({startOffset:k,endOffset:U+F,value:l.substring(k,U+F),setting:{key:E,commaOffset:void 0}})},onSeparator:(C,U,F)=>{if(R===0&&C===","){let M=y.length-1;for(;M>=0&&!y[M].setting;M--);const X=y[M];X&&y.splice(M,1,{startOffset:X.startOffset,endOffset:X.endOffset,value:X.value,setting:{key:X.setting.key,commaOffset:U}})}},onComment:(C,U)=>{R===0&&y.push({startOffset:C,endOffset:C+U,value:l.substring(C,C+U)})}};return(0,a.$3n)(l,v),y}}),define(le[83],he([0,1,3,2,4,25]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FLb=e.$ELb=void 0,e.$ELb=(0,N.$Fi)("IUserDataSyncAccountService");let T=class extends a.$Wc{get account(){return this.a}constructor(L,p){super(),this.g=L,this.h=p,this.b=this.B(new P.$me),this.onDidChangeAccount=this.b.event,this.c=this.B(new P.$me),this.onTokenFailed=this.c.event,this.f=!1,this.B(L.onTokenFailed(S=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,S),this.updateAccount(void 0),S===O.UserDataSyncErrorCode.Forbidden?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(L.onTokenSucceed(()=>this.f=!1))}async updateAccount(L){(L&&this.a?L.token!==this.a.token||L.authenticationProviderId!==this.a.authenticationProviderId:L!==this.a)&&(this.a=L,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(L))}};e.$FLb=T,e.$FLb=T=ve([Z(0,O.$Wmb),Z(1,O.$_mb)],T)}),define(le[248],he([0,1,21,186,16,10,25]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Nb=void 0;let A=class extends O.$ek{constructor(p,S){super(),this.g=this.B(p.createLogger((0,P.$gh)(S.logsHome,`${T.$anb}.log`),{id:T.$anb,name:(0,a.localize)(0,null)}))}trace(p,...S){this.g.trace(p,...S)}debug(p,...S){this.g.debug(p,...S)}info(p,...S){this.g.info(p,...S)}warn(p,...S){this.g.warn(p,...S)}error(p,...S){this.g.error(p,...S)}flush(){this.g.flush()}};e.$$Nb=A,e.$$Nb=A=ve([Z(0,O.$ak),Z(1,N.$Mi)],A)}),define(le[249],he([0,1,6,3,2]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=void 0;class O extends N.$Wc{constructor({onDidOpenMainWindow:A,onDidFocusMainWindow:L,getActiveWindowId:p}){super(),this.a=this.B(new N.$Vc),a.Event.latch(a.Event.any(A,L))(this.f,this,this.a),this.b=(0,P.$sh)(()=>p()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(A){this.b&&(this.b.cancel(),this.b=void 0),this.c=A}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Ffc=O}),define(le[116],he([0,1,189,14,52,21,9,4,23]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=p,e.$Qi=S,e.$Ti=d,e.$Ui=h,e.$Vi=$,e.$Wi=m,e.$Xi=b,e.$1i=I,e.$6i=g,e.$7i=u,e.$9i=t,e.$0i=s,e.$$i=r,e.$Oi=(0,A.$Fi)("contextService");function p(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.uri)}function S(i){return typeof i?.id=="string"&&!p(i)&&!h(i)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function d(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,a.$pc)(i)}:n?e.$Ri:e.$Si;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function h(i){const n=i;return typeof n?.id=="string"&&T.URI.isUri(n.configPath)}function $(i){const n=i;if(n?.uri)return{id:n.id,uri:T.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var c;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function b(i){const n=i;return!!(n&&typeof n=="object"&&T.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class f{constructor(n,o,l,y,R){this.h=n,this.j=l,this.k=y,this.l=R,this.c=N.$Li.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=N.$Li.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=f;class w{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,O.$gh)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=w;function I(i){return new w({uri:i,index:0,name:(0,O.$ch)(i)},{uri:i.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,P.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function g(i,n){return O.$0g.isEqualOrParent(i,n.untitledWorkspacesHome)}function u(i){let n;return T.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===L.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$8i}function s(i,n){return!g(i,n)&&!u(i)}function r(i){return(typeof i=="string"?(0,a.$qc)(i):(0,O.$eh)(i))===e.$3i}}),define(le[20],he([0,1,56,3,2,21,9,180,16,7,4,10,116,35,29,6,32,27,13]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=g,e.$Ml=u,e.$Nl=t;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function g(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&T.URI.isUri(n.location)&&T.URI.isUri(n.globalStorageHome)&&T.URI.isUri(n.settingsResource)&&T.URI.isUri(n.keybindingsResource)&&T.URI.isUri(n.tasksResource)&&T.URI.isUri(n.snippetsHome)&&T.URI.isUri(n.extensionsResource))}e.$Ll=(0,S.$Fi)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:T.URI.revive(i.location).with({scheme:n}),globalStorageHome:T.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:T.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:T.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:T.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:T.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:T.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:T.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,o,l,y,R){return{id:i,name:n,location:o,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:R&&y?.useDefaultFlags?.globalState?R.globalStorageHome:(0,O.$gh)(o,"globalStorage"),settingsResource:R&&y?.useDefaultFlags?.settings?R.settingsResource:(0,O.$gh)(o,"settings.json"),keybindingsResource:R&&y?.useDefaultFlags?.keybindings?R.keybindingsResource:(0,O.$gh)(o,"keybindings.json"),tasksResource:R&&y?.useDefaultFlags?.tasks?R.tasksResource:(0,O.$gh)(o,"tasks.json"),snippetsHome:R&&y?.useDefaultFlags?.snippets?R.snippetsHome:(0,O.$gh)(o,"snippets"),extensionsResource:R&&y?.useDefaultFlags?.extensions?R.extensionsResource:(0,O.$gh)(o,"extensions.json"),cacheHome:(0,O.$gh)(l,i),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let s=class extends N.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,o,l,y){super(),this.t=n,this.u=o,this.w=l,this.y=y,this.f=!0,this.h=this.B(new a.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new a.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new a.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new a.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new $.$Cc,workspaces:new $.$Cc,emptyWindows:new Map},this.profilesHome=(0,O.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),o=[n];if(this.f)try{for(const R of this.O()){if(!R.name||!(0,w.$fg)(R.name)||!R.location){this.y.warn("Skipping the invalid stored profile",R.location||R.name);continue}o.push(t((0,O.$dh)(R.location),R.name,R.location,this.g,{shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags},n))}}catch(R){this.y.error(R)}const l=new $.$Cc,y=new Map;if(o.length)try{const R=this.Q();if(R.workspaces)for(const[k,E]of Object.entries(R.workspaces)){const v=T.URI.parse(k),C=o.find(U=>U.id===E);C&&l.set(v,C)}if(R.emptyWindows)for(const[k,E]of Object.entries(R.emptyWindows)){const v=o.find(C=>C.id===E);v&&y.set(k,v)}}catch(R){this.y.error(R)}this.z={profiles:o,workspaces:l,emptyWindows:y}}return this.z}D(){const n=t("__default__profile__",(0,A.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,f.$if)(o)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const E=l.exec(k.name),v=E?parseInt(E[1]):0;y=v>y?v:y}const R=`${o} ${y+1}`;return this.createProfile((0,P.$tj)((0,b.$2g)()).toString(16),R,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,P.$tj)((0,b.$2g)()).toString(16),n,o,l)}async createProfile(n,o,l,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const R=await this.F(n,o,l);return y&&await this.setProfileForWorkspace(y,R),R}async F(n,o,l){if(!(0,w.$fg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(o);return y||(y=(async()=>{try{if(this.profiles.find(v=>v.name===o||v.id===n))throw new Error(`Profile with ${o} name already exists`);const k=t(n,o,(0,O.$gh)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(k.location);const E=[];return this.j.fire({profile:k,join(v){E.push(v)}}),await m.Promises.settled(E),this.I([k],[],[]),k}finally{this.r.delete(o)}})(),this.r.set(o,y)),y}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(y=>y.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(y=>y.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:o,join(y){l.push(y)}});try{await Promise.allSettled(l)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(y){(0,p.$ql)(y)!==p.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(y=>y.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.G(n),l=T.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return l||((0,h.$Pi)(n)?this.s.folders.get(n.uri):(0,h.$Ui)(n)?this.s.workspaces.get(n.configPath):this.s.emptyWindows.get(n.id))}G(n){return(0,h.$Pi)(n)?n.uri:(0,h.$Ui)(n)?n.configPath:n.id}H(n){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,n.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,n.location)))}I(n,o,l){const y=[...this.profiles,...n],R=[],k=this.s.profiles;this.s.profiles=[];for(let E of y){if(E.isDefault||o.some(C=>E.id===C.id))continue;E=l.find(C=>E.id===C.id)??E;const v=k.find(C=>E.id===C.id);if(E.isTransient)this.s.profiles.push(E);else{if(v){for(const[C,U]of this.s.emptyWindows.entries())if(E.id===U.id){this.L({id:C},E);break}for(const[C,U]of this.s.workspaces.entries())if(E.id===U.id){this.L({id:"",configPath:C},E);break}for(const[C,U]of this.s.folders.entries())if(E.id===U.id){this.L({id:"",uri:C},E);break}}R.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags})}}this.P(R),this.z=void 0,this.J(n,o,l)}J(n,o,l){this.h.fire({added:n,removed:o,updated:l,all:this.profiles})}L(n,o,l){if(l=o?.isTransient?!0:l,l)(0,h.$Pi)(n)?(this.s.folders.delete(n.uri),o&&this.s.folders.set(n.uri,o)):(0,h.$Ui)(n)?(this.s.workspaces.delete(n.configPath),o&&this.s.workspaces.set(n.configPath,o)):(this.s.emptyWindows.delete(n.id),o&&this.s.emptyWindows.set(n.id,o));else{this.L(n,void 0,!0);const y=this.G(n);T.URI.isUri(y)?(this.C.workspaces.delete(y),o&&this.C.workspaces.set(y,o)):(this.C.emptyWindows.delete(y),o&&this.C.emptyWindows.set(y,o)),this.M()}}M(){const n={};for(const[l,y]of this.C.workspaces.entries())n[l.toString()]=y.id;const o={};for(const[l,y]of this.C.emptyWindows.entries())o[l.toString()]=y.id;this.R({workspaces:n,emptyWindows:o}),this.z=void 0}N(n){const o={},l=this.D();if(n.workspaces)for(const[R,k]of Object.entries(n.workspaces)){const E=T.URI.parse(k);o[R]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}const y={};if(n.emptyWindows)for(const[R,k]of Object.entries(n.emptyWindows)){const E=T.URI.parse(k);y[R]=this.w.extUri.isEqual(E,l.location)?l.id:this.w.extUri.basename(E)}return{workspaces:o,emptyWindows:y}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ol=s,e.$Ol=s=ve([Z(0,L.$Mi),Z(1,p.$_k),Z(2,c.$Jl),Z(3,d.$_j)],s);class r extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Pl=r}),define(le[250],he([0,1,6,2,20]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;let O=class extends a.$Wc{constructor(A){super(),this.B(new P.$Rh(()=>{A.cleanUp()},10*1e3)).schedule()}};e.$Lgc=O,e.$Lgc=O=ve([Z(0,N.$Ll)],O)}),define(le[84],he([0,1,19,6,26,8,3,2,5,13,9,162,28,33,37,10,24,18,29,20]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=void 0,e.$Aq=u,d=ke(d);let g=class extends A.$Wc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,n,o,l,y,R){super(),this.z=i,this.C=n,this.D=o,this.F=l,this.G=y,this.H=R,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new T.$me),this.s=this.B(new T.$me),this.t=this.B(new T.$me),this.u=this.B(new T.$me),this.w=this.B(new T.$me),this.y=[],this.B((0,A.$Uc)(()=>{this.j.forEach(({task:k})=>k.cancel()),this.m.forEach(k=>k.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,h.$fp)(o,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const l=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:y})=>(0,$.$Ip)(y,i.identifier));if(l?.local)return l?.local;throw l?.error?l.error:new h.$jp(`Unknown error while installing extension ${i.identifier.id}`,h.ExtensionManagementErrorCode.Unknown)}catch(o){throw u(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new h.$jp(d.localize(0,null),h.ExtensionManagementErrorCode.NotAllowed);const n=[],o=[];return await Promise.allSettled(i.map(async({extension:l,options:y})=>{try{const R=await this.N(l,!!y?.installGivenVersion,!!y?.installPreReleaseVersion,y.productVersion??{version:this.G.version,date:this.G.date});o.push({...R,options:y})}catch(R){n.push({identifier:l.identifier,operation:h.InstallOperation.Install,source:l,error:R,profileLocation:y.profileLocation??this.X()})}})),o.length&&n.push(...await this.I(o)),n}async uninstall(i,n={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,n)}async toggleAppliationScope(i,n){if((0,c.$tn)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,n));for(const l of this.H.profiles){const y=(await this.getInstalled(c.ExtensionType.User,l.extensionsResource)).find(R=>(0,$.$Ip)(R.identifier,i.identifier));y?this.w.fire({local:y,profileLocation:l.extensionsResource}):this.u.fire({identifier:i.identifier,profileLocation:l.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:h.InstallOperation.Install,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const n=new Map,o=new Map,l=[],y=(k,E)=>`${$.$Jp.create(k).toString()}-${E.toString()}`,R=(k,E,v,C)=>{const U=this.Y(k,E,v),F=`${(0,$.$Np)(k.publisher,k.name)}-${v.profileLocation.toString()}`;o.set(F,{task:U,root:C}),this.n.fire({identifier:U.identifier,source:E,profileLocation:v.profileLocation}),this.F.info("Installing extension:",U.identifier.id,v),S.URI.isUri(E)||this.j.set(y(E,v.profileLocation),{task:U,waitingTasks:[]})};try{for(const{manifest:k,extension:E,options:v}of i){const C=v.isApplicationScoped||v.isBuiltin||(0,c.$tn)(k),U={...v,installOnlyNewlyAddedFromExtensionPack:v.installOnlyNewlyAddedFromExtensionPack??!S.URI.isUri(E),isApplicationScoped:C,profileLocation:C?this.H.defaultProfile.extensionsResource:v.profileLocation??this.X(),productVersion:v.productVersion??{version:this.G.version,date:this.G.date}},F=S.URI.isUri(E)?void 0:this.j.get(y(E,U.profileLocation));F?(this.F.info("Extension is already requested to install",F.task.identifier.id,U.profileLocation.toString()),l.push(F.task.waitUntilTaskIsFinished())):R(k,E,U,void 0)}return await Promise.all([...o.values()].map(async({task:k})=>{if(k.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const E=await this.M(k.identifier,k.manifest,!!k.options.installOnlyNewlyAddedFromExtensionPack,!!k.options.installPreReleaseVersion,k.options.profileLocation,k.options.productVersion),v=await this.getInstalled(void 0,k.options.profileLocation,k.options.productVersion),C={...k.options,context:{...k.options.context,[h.$_o]:!0}};for(const{gallery:U,manifest:F}of(0,P.$Ob)(E,({gallery:M})=>M.identifier.id)){if(o.has(`${U.identifier.id.toLowerCase()}-${C.profileLocation.toString()}`))continue;const M=this.j.get(y(U,C.profileLocation));if(M){if(this.J(k,M.task)){const X=M.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,k.identifier.id,C.profileLocation.toString()),M.waitingTasks.push(k),l.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,K=>K.some(Q=>(0,$.$Ip)(Q.identifier,X)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,k.identifier.id,C.profileLocation.toString()),!K.find(G=>(0,$.$Ip)(G.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else v.some(({identifier:X})=>(0,$.$Ip)(X,U.identifier))||R(F,U,C,k)}}catch(E){if(S.URI.isUri(k.source))(0,P.$Nb)(k.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",k.identifier.id,E.message),(0,P.$Nb)(k.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",k.identifier.id,E.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),E}})),await this.L([...o.entries()].map(async([k,{task:E}])=>{const v=new Date().getTime();let C;try{C=await E.run(),await this.L(this.y.map(U=>U.postInstall(C,E.source,E.options,N.CancellationToken.None)),h.ExtensionManagementErrorCode.PostInstall)}catch(U){const F=u(U);throw S.URI.isUri(E.source)||t(this.C,E.operation===h.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Qp)(E.source),error:F,source:E.options.context?.[h.$$o]}),n.set(k,{error:F,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:E.options.isApplicationScoped}),this.F.error("Error while installing the extension",E.identifier.id,(0,O.$_)(F),E.options.profileLocation.toString()),F}if(!S.URI.isUri(E.source)){const U=E.operation===h.InstallOperation.Update,F=U?void 0:(new Date().getTime()-E.source.lastUpdated)/1e3;if(t(this.C,U?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,$.$Qp)(E.source),verificationStatus:E.verificationStatus,duration:new Date().getTime()-v,durationSinceUpdate:F,source:E.options.context?.[h.$$o]}),L.$o&&E.operation!==h.InstallOperation.Update)try{await this.z.reportStatistic(C.manifest.publisher,C.manifest.name,C.manifest.version,h.StatisticType.Install)}catch{}}n.set(k,{local:C,identifier:E.identifier,operation:E.operation,source:E.source,context:E.options.context,profileLocation:E.options.profileLocation,applicationScoped:C.isApplicationScoped})})),l.length&&await this.L(l),[...n.values()]}catch(k){const E=(U,F,M)=>{const X=[];U.manifest.extensionDependencies?.length&&X.push(...U.manifest.extensionDependencies),U.manifest.extensionPack?.length&&X.push(...U.manifest.extensionPack);for(const K of X){if(M.includes(K.toLowerCase()))continue;M.push(K.toLowerCase());const Q=n.get(`${K.toLowerCase()}-${F.toString()}`);Q?.local&&(M=E(Q.local,F,M))}return M},v=U=>({identifier:U.identifier,operation:h.InstallOperation.Install,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,error:k}),C=[];for(const[U,{task:F,root:M}]of o){const X=n.get(U);X?X.local&&M&&!n.get(`${M.identifier.id.toLowerCase()}-${F.options.profileLocation.toString()}`)?.local&&(C.push(this.Z(X.local,{versionOnly:!0,profileLocation:F.options.profileLocation})),n.set(U,v(F))):(F.cancel(),n.set(U,v(F)))}for(const[U,{task:F}]of o){const M=n.get(U);if(!M?.local||F.options.donotIncludePackAndDependencies)continue;E(M.local,F.options.profileLocation,[M.local.identifier.id.toLowerCase()]).slice(1).some(K=>o.has(`${K.toLowerCase()}-${F.options.profileLocation.toString()}`)&&!n.get(`${K.toLowerCase()}-${F.options.profileLocation.toString()}`)?.local)&&(C.push(this.Z(M.local,{versionOnly:!0,profileLocation:F.options.profileLocation})),n.set(U,v(F)))}throw C.length&&await Promise.allSettled(C.map(async U=>{try{await U.run(),this.F.info("Rollback: Uninstalled extension",U.extension.identifier.id)}catch(F){this.F.warn("Rollback: Error while uninstalling extension",U.extension.identifier.id,(0,O.$_)(F))}})),k}finally{for(const{task:k}of o.values())k.source&&!S.URI.isUri(k.source)&&this.j.delete(y(k.source,k.options.profileLocation));if(n.size){const k=[...n.values()];for(const E of k)E.local&&this.F.info("Extension installed successfully:",E.identifier.id,E.profileLocation.toString());this.s.fire(k)}}}J(i,n){for(const[,{task:o,waitingTasks:l}]of this.j.entries())if(o===i&&(l.includes(n)||l.some(y=>this.J(y,n)))||o===n&&l[0]&&!this.J(i,l[0]))return!1;return!0}async L(i,n){const o=[],l=[],y=await Promise.allSettled(i);for(const k of y)k.status==="fulfilled"?o.push(k.value):l.push(u(k.reason,n));if(!l.length)return o;if(l.length===1)throw l[0];let R=new h.$jp("",h.ExtensionManagementErrorCode.Unknown);for(const k of l)R=new h.$jp(R.message?`${R.message}, ${k.message}`:k.message,k.code!==h.ExtensionManagementErrorCode.Unknown&&k.code!==h.ExtensionManagementErrorCode.Internal?k.code:R.code);throw R}async M(i,n,o,l,y,R){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,y,R),E=[],v=[],C=async(U,F)=>{E.push(U);const M=F.extensionDependencies||[],X=[...M];if(F.extensionPack){const K=o?k.find(Q=>(0,$.$Ip)(Q.identifier,U)):void 0;for(const Q of F.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(G=>(0,$.$Ip)({id:G},{id:Q}))||X.every(G=>!(0,$.$Ip)({id:G},{id:Q}))&&X.push(Q)}if(X.length){const K=X.filter(Q=>E.every(G=>!(0,$.$Ip)(G,{id:Q})));if(K.length){const Q=await this.z.getExtensions(K.map(G=>({id:G,preRelease:l})),N.CancellationToken.None);for(const G of Q){if(E.find(z=>(0,$.$Ip)(z,G.identifier)))continue;const ie=M.some(z=>(0,$.$Ip)({id:z},G.identifier));let V;try{V=await this.N(G,!1,l,R)}catch(z){if(ie)throw z;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,O.$_)(z));continue}v.push({gallery:V.extension,manifest:V.manifest}),await C(V.extension.identifier,V.manifest)}}}};return await C(i,n),v}async N(i,n,o,l){let y;const R=await this.getExtensionsControlManifest();if(R.malicious.some(v=>(0,$.$Ip)(i.identifier,v)))throw new h.$jp(d.localize(1,null,i.identifier.id),h.ExtensionManagementErrorCode.Malicious);const k=R.deprecated[i.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),y=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:l},N.CancellationToken.None))[0],!y)throw new h.$jp(d.localize(2,null,i.identifier.id,k.extension.id),h.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const v=await this.getTargetPlatform();throw new h.$jp(d.localize(3,null,i.identifier.id,this.G.nameLong,(0,h.$bp)(v)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(y=await this.O(i,n,o,l),!y)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],N.CancellationToken.None))[0]?new h.$jp(d.localize(4,null,i.displayName??i.identifier.id),h.ExtensionManagementErrorCode.ReleaseVersionNotFound):new h.$jp(d.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),h.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",y.identifier.id);const E=await this.z.getManifest(y,N.CancellationToken.None);if(E===null)throw new h.$jp(`Missing manifest for extension ${y.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(E.version!==y.version)throw new h.$jp(`Cannot install '${y.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:E}}async O(i,n,o,l){const y=await this.getTargetPlatform();let R=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(R=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:y,compatible:!0,productVersion:l},N.CancellationToken.None))[0]||null),!R&&await this.z.isExtensionCompatible(i,o,y,l)&&(R=i),R||(n?R=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:y,compatible:!0,productVersion:l},N.CancellationToken.None))[0]||null:R=await this.z.getCompatibleExtension(i,o,y,l)),R}async P(i,n){const o={...n,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},l=C=>`${C.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.m.get(l(i.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const R=C=>{const U=this.Z(C,o);return this.m.set(l(U.extension.identifier),U),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${C.identifier.id}@${C.manifest.version}`),this.t.fire({identifier:C.identifier,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped}),U},k=(C,U)=>{U?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString(),U.message):this.F.error("Failed to uninstall extension:",`${C.identifier.id}@${C.manifest.version}`,U.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${C.identifier.id}@${C.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,$.$Pp)(C),error:U}),this.u.fire({identifier:C.identifier,error:U?.code,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped})},E=[],v=[];try{E.push(R(i));const C=await this.getInstalled(c.ExtensionType.User,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const U=this.S(i,C);for(const F of U)this.m.has(l(F.identifier))?this.F.info("Extensions is already requested to uninstall",F.identifier.id):E.push(R(F))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(E.map(U=>U.extension),C,i),await this.L(E.map(async U=>{try{if(await U.run(),await this.L(this.y.map(F=>F.postUninstall(U.extension,o,N.CancellationToken.None))),U.extension.identifier.uuid)try{await this.z.reportStatistic(U.extension.manifest.publisher,U.extension.manifest.name,U.extension.manifest.version,h.StatisticType.Uninstall)}catch{}k(U.extension)}catch(F){const M=u(F);throw k(U.extension,M),M}finally{v.push(U)}}))}catch(C){const U=u(C);for(const F of E){try{F.cancel()}catch{}v.includes(F)||k(F.extension,U)}throw U}finally{for(const C of E)this.m.delete(l(C.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",C.extension.identifier.id)}}Q(i,n,o){for(const l of i){const y=this.U(l,n);if(y.length){const R=y.filter(k=>!i.some(E=>(0,$.$Ip)(E.identifier,k.identifier)));if(R.length)throw new Error(this.R(l,R,o))}}}R(i,n,o){return o===i?n.length===1?d.localize(6,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?d.localize(7,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):d.localize(8,null,o.manifest.displayName||o.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?d.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?d.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):d.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(i,n,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const l=i.manifest.extensionPack?i.manifest.extensionPack:[];if(l.length){const y=n.filter(k=>!k.isBuiltin&&l.some(E=>(0,$.$Ip)({id:E},k.identifier))),R=[];for(const k of y)R.push(...this.S(k,n,o));return[...y,...R]}return[]}U(i,n){return n.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,$.$Ip)({id:l},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,O.$_)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$zq=g,e.$zq=g=ve([Z(0,h.$hp),Z(1,f.$$l),Z(2,w.$Jl),Z(3,m.$_j),Z(4,b.$sk),Z(5,I.$Ll)],g);function u(r,i){if(r instanceof h.$jp)return r;let n;return r instanceof h.$ip?n=new h.$jp(r.message,r.code===h.ExtensionGalleryErrorCode.DownloadFailedWriting?h.ExtensionManagementErrorCode.DownloadFailedWriting:h.ExtensionManagementErrorCode.Gallery):n=new h.$jp(r.message,(0,O.$6)(r)?h.ExtensionManagementErrorCode.Cancelled:i??h.ExtensionManagementErrorCode.Internal),n.stack=r.stack,n}function t(r,i,{extensionData:n,verificationStatus:o,duration:l,error:y,source:R,durationSinceUpdate:k}){let E,v;(0,p.$ng)(o)&&(o===!0?o="Verified":(o===!1||(E=h.ExtensionManagementErrorCode.Signature,v=o),o="Unverified")),y&&(E=y.code,y.code===h.ExtensionManagementErrorCode.Signature&&(v=y.message)),r.publicLog(i,{...n,verificationStatus:o,success:!y,duration:l,errorcode:E,errorcodeDetail:v,durationSinceUpdate:k,source:R})}class s{constructor(){this.d=new a.$Eh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,a.$sh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,a.$sh)(i=>new Promise((n,o)=>{const l=i.onCancellationRequested(()=>{l.dispose(),o(new O.$7)})})),this.d.open()),this.g.cancel()}}e.$Bq=s}),define(le[53],he([0,1,6,15,2,3,35,9,28,33,7,4,10,20,29,13,8,18]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=e.$Dq=e.$Cq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class I extends Error{constructor(r,i){super(r),this.code=i}}e.$Cq=I,e.$Dq=(0,d.$Fi)("IExtensionsProfileScannerService");let g=class extends N.$Wc{constructor(r,i,n,o,l,y){super(),this.j=r,this.m=i,this.n=n,this.r=o,this.s=l,this.t=y,this.b=this.B(new O.$me),this.onAddExtensions=this.b.event,this.c=this.B(new O.$me),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.$me),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.$me),this.onDidRemoveExtensions=this.g.event,this.h=new T.$Cc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,n){const o=[],l=[];try{return await this.u(i,y=>{const R=[];if(n)R.push(...y);else for(const k of y)r.some(([E])=>(0,p.$Ip)(E.identifier,k.identifier)&&E.manifest.version!==k.version)?o.push(k):R.push(k);for(const[k,E]of r){const v=R.findIndex(U=>(0,p.$Ip)(U.identifier,k.identifier)&&U.version===k.manifest.version),C={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:E};v===-1?(l.push(C),R.push(C)):R.splice(v,1,C)}return l.length&&this.b.fire({extensions:l,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),R}),l.length&&this.c.fire({extensions:l,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),l}catch(y){throw l.length&&this.c.fire({extensions:l,error:y,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:y,profileLocation:i}),y}}async updateMetadata(r,i){const n=[];return await this.u(i,o=>{const l=[];for(const y of o){const R=r.find(([k])=>(0,p.$Ip)(k.identifier,y.identifier)&&k.manifest.version===y.version);R&&(y.metadata={...y.metadata,...R[1]},n.push(y)),l.push(y)}return l}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,o=>{const l=[];for(const y of o)(0,p.$Ip)(y.identifier,r.identifier)?n.push(y):l.push(y);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:i}),o}}async u(r,i,n){return this.F(r).queue(async()=>{let o=[],l;try{const y=await this.m.readFile(r);l=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,S.$ql)(y)!==S.FileOperationResult.FILE_NOT_FOUND)throw y;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,b.$_)(y),w.ERROR_PROFILE_NOT_FOUND)}if(l){Array.isArray(l)||this.w(r);let y=!1;for(const R of l){u(R)||this.w(r);let k;if((0,m.$fg)(R.relativeLocation)&&R.relativeLocation)k=this.z(R.relativeLocation);else if((0,m.$fg)(R.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${R.location}`);continue}else{k=A.URI.revive(R.location);const E=this.y(k);E&&(y=!0,R.relativeLocation=E)}(0,m.$mg)(R.metadata?.hasPreReleaseVersion)&&R.metadata?.preRelease&&(y=!0,R.metadata.hasPreReleaseVersion=!0),o.push({identifier:R.identifier,location:k,version:R.version,metadata:R.metadata})}y&&await this.m.writeFile(r,a.$Oe.fromString(JSON.stringify(l)))}if(i){o=i(o);const y=o.map(R=>({identifier:R.identifier,version:R.version,location:R.location.toJSON(),relativeLocation:this.y(R.location),metadata:R.metadata}));await this.m.writeFile(r,a.$Oe.fromString(JSON.stringify(y)))}return o})}w(r){const i=new I(`Invalid extensions content in ${r.toString()}`,w.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(l){if((0,S.$ql)(l)===S.FileOperationResult.FILE_NOT_FOUND)return;throw l}this.t.info("Migrating extensions from old default profile location",r.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(y=>u(y))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,a.$Oe.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,S.$ql)(l)===S.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(r)}catch(l){(0,S.$ql)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,S.$ql)(l)!==S.FileOperationResult.FILE_NOT_FOUND&&this.t.error(l)}return o})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$Mh,this.h.set(r,i)),i}};e.$Eq=g,e.$Eq=g=ve([Z(1,S.$_k),Z(2,$.$Ll),Z(3,c.$Jl),Z(4,f.$$l),Z(5,h.$_j)],g);function u(s){return(0,m.$hg)(s)&&(0,L.$gp)(s.identifier)&&(t(s.location)||(0,m.$fg)(s.location)&&s.location)&&((0,m.$mg)(s.relativeLocation)||(0,m.$fg)(s.relativeLocation))&&s.version&&(0,m.$fg)(s.version)}function t(s){return s?(0,m.$fg)(s.path)&&(0,m.$fg)(s.scheme):!1}});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[85],he([0,1,19,6,30,15,8,34,144,2,23,14,5,21,57,92,13,9,165,16,33,37,73,7,4,10,24,3,68,53,20,29,194]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t,s,r,i,n,o,l,y,R,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Jq=e.$Iq=e.$Hq=e.Translations=void 0,e.$Kq=X,N=ke(N),d=ke(d),h=ke(h),c=ke(c),m=it(m);var v;(function(Q){function G(ie,V){if(ie===V)return!0;const z=Object.keys(ie),ee=new Set;for(const re of Object.keys(V))ee.add(re);if(z.length!==ee.size)return!1;for(const re of z){if(ie[re]!==V[re])return!1;ee.delete(re)}return ee.size===0}Q.equals=G})(v||(e.Translations=v={})),e.$Hq=(0,r.$Fi)("IExtensionsScannerService");let C=class extends p.$Wc{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=ie,this.r=V,this.s=z,this.t=ee,this.u=re,this.w=ce,this.y=q,this.z=x,this.C=J,this.D=H,this.F=D,this.g=this.B(new o.$me),this.onDidChangeCache=this.g.event,this.h=(0,$.$gh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(M,this.s,this.h)),this.m=this.B(this.F.createInstance(M,this.s,this.h)),this.n=this.B(this.F.createInstance(F,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(u.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(u.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Tp)(this.w,this.y)),this.G}async scanAllExtensions(G,ie,V){const[z,ee]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(ie)]),re=V?await this.scanExtensionsUnderDevelopment(G,[...z,...ee]):[];return this.L(z,ee,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const ie=[];ie.push(this.M(!!G.useCache,G.language)),ie.push(this.N(G.language,!!G.checkControlFile));const[V,z]=await Promise.all(ie);return this.J([...V,...z],u.ExtensionType.System,G,!1)}async scanUserExtensions(G){const ie=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",ie);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(ie,!!G.profileLocation,u.ExtensionType.User,!G.includeUninstalled,G.language,!0,V,G.productVersion??this.R()),ee=G.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let re;try{re=await ee.scanExtensions(z)}catch(ce){if(ce instanceof y.$Cq&&ce.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),re=await ee.scanExtensions(z);else throw ce}return re=await this.J(re,u.ExtensionType.User,G,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(G,ie){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===S.Schemas.file).map(async z=>{const ee=await this.P(z,!1,u.ExtensionType.User,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ee)).map(ce=>(ce.type=ie.find(q=>(0,g.$Ip)(q.identifier,ce.identifier))?.type??ce.type,this.n.validate(ce,ee)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanExtension(z);return!ee||!V.includeInvalid&&!ee.isValid?null:ee}async scanOneOrMultipleExtensions(G,ie,V){const z=await this.P(G,!1,ie,!0,V.language,!0,void 0,V.productVersion??this.R()),ee=await this.n.scanOneOrMultipleExtensions(z);return this.J(ee,ie,V,!0)}async scanMultipleExtensions(G,ie,V){const z=[];return await Promise.all(G.map(async ee=>{const re=await this.scanOneOrMultipleExtensions(ee,ie,V);z.push(...re)})),this.J(z,ie,V,!0)}async scanMetadata(G){const ie=(0,$.$gh)(G,"package.json"),V=(await this.w.readFile(ie)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,ie){const V=(0,$.$gh)(G,"package.json"),z=(await this.w.readFile(V)).value.toString(),ee=JSON.parse(z);ie.isMachineScoped===!1&&delete ie.isMachineScoped,ie.isBuiltin===!1&&delete ie.isBuiltin,ee.__metadata={...ee.__metadata,...ie},await this.w.writeFile((0,$.$gh)(G,"package.json"),O.$Oe.fromString(JSON.stringify(ee,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof y.$Cq&&G.code===y.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(ie=>[ie,ie.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,O.$Oe.fromString(JSON.stringify([])))}catch(ie){(0,s.$ql)(ie)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.$_)(ie))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,ie,V,z){return V.includeAllVersions||(G=this.L(ie===u.ExtensionType.System?G:void 0,ie===u.ExtensionType.User?G:void 0,ie==="development"?G:void 0,await this.getTargetPlatform(),z)),V.includeInvalid||(G=G.filter(ee=>ee.isValid)),G.sort((ee,re)=>{const ce=d.$pc(ee.location.fsPath),q=d.$pc(re.location.fsPath);return ce<q?-1:ce>q?1:0})}L(G,ie,V,z,ee){const re=(q,x,J)=>{if(q.isValid&&!x.isValid)return!1;if(q.isValid===x.isValid){if(ee&&c.gt(q.manifest.version,x.manifest.version))return this.y.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${q.location.path} with version ${q.manifest.version}`),!1;if(c.eq(q.manifest.version,x.manifest.version)){if(q.type===u.ExtensionType.System)return this.y.debug(`Skipping extension ${x.location.path} in favour of system extension ${q.location.path} with same version`),!1;if(q.targetPlatform===z)return this.y.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${q.location.path} with ${x.location.path}.`):this.y.debug(`Overwriting user extension ${q.location.path} with ${x.location.path}.`),!0},ce=new u.$sn;return G?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),ie?.forEach(q=>{const x=ce.get(q.identifier.id);if(!x&&G&&q.type===u.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${q.location.path}.`);return}(!x||re(x,q,!1))&&ce.set(q.identifier.id,q)}),V?.forEach(q=>{const x=ce.get(q.identifier.id);(!x||re(x,q,!0))&&ce.set(q.identifier.id,q),ce.set(q.identifier.id,q)}),[...ce.values()]}async M(G,ie){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,u.ExtensionType.System,!0,ie,!0,void 0,this.R()),ee=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ee.length),ee}async N(G,ie){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const z=ie?await this.O():{},ee=[],re=f.URI.file(d.$jc(d.$lc(S.$Zg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const q of V){const x=z[q.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":ee.push((0,$.$gh)(re,q.name));break;default:ee.push(f.URI.file(x));break}}const ce=await Promise.all(ee.map(async q=>this.n.scanExtension(await this.P(q,!1,u.ExtensionType.System,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ce.length),(0,P.$Jb)(ce)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,ie,V,z,ee,re,ce,q){const x=await this.f(ee??h.$w),J=await this.Q(G),H=ie&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,D=H?await this.Q(H):void 0;return new U(G,J,H,D,ie,ce,V,z,re,q.version,q.date,this.C.commit,!this.z.isBuilt,ee,x)}async Q(G){try{const ie=await this.w.stat(G);if(typeof ie.mtime=="number")return ie.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Iq=C,e.$Iq=C=ve([Z(4,R.$Ll),Z(5,y.$Dq),Z(6,s.$_k),Z(7,i.$_j),Z(8,I.$Mi),Z(9,n.$sk),Z(10,k.$Jl),Z(11,r.$Ei)],C);class U{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D,B,j,W){this.location=G,this.mtime=ie,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=z,this.profile=ee,this.profileScanOptions=re,this.type=ce,this.excludeObsolete=q,this.validate=x,this.productVersion=J,this.productDate=H,this.productCommit=D,this.devMode=B,this.language=j,this.translations=W}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,ie){return(0,$.$_g)(G.location,ie.location)&&G.mtime===ie.mtime&&(0,$.$_g)(G.applicationExtensionslocation,ie.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===ie.applicationExtensionslocationMtime&&G.profile===ie.profile&&N.$go(G.profileScanOptions,ie.profileScanOptions)&&G.type===ie.type&&G.excludeObsolete===ie.excludeObsolete&&G.validate===ie.validate&&G.productVersion===ie.productVersion&&G.productDate===ie.productDate&&G.productCommit===ie.productCommit&&G.devMode===ie.devMode&&G.language===ie.language&&v.equals(G.translations,ie.translations)}}e.$Jq=U;let F=class extends p.$Wc{constructor(G,ie,V,z,ee){super(),this.f=G,this.g=ie,this.h=V,this.j=z,this.m=ee}async scanExtensions(G){const ie=G.profile?await this.r(G):await this.n(G);let V={};if(G.excludeObsolete&&G.type===u.ExtensionType.User)try{const z=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(z)}catch{}return(0,b.$sg)(V)?ie:ie.filter(z=>!V[g.$Jp.create(z).toString()])}async n(G){const ie=await this.j.resolve(G.location);if(!ie.children?.length)return[];const V=await Promise.all(ie.children.map(async z=>{if(!z.isDirectory||G.type===u.ExtensionType.User&&(0,$.$dh)(z.resource).indexOf(".")===0)return null;const ee=new U(z.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ee)}));return(0,P.$Jb)(V).sort((z,ee)=>z.location.path<ee.location.path?-1:1)}async r(G){let ie=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){ie=ie.filter(z=>!z.metadata?.isApplicationScoped);const V=await this.s(G.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,G);ie.push(...V)}return ie}async s(G,ie,V){const z=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!z.length)return[];const ee=await Promise.all(z.map(async re=>{if(ie(re)){const ce=new U(re.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(ce,re.metadata)}return null}));return(0,P.$Jb)(ee)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,$.$gh)(G.location,"package.json"))){const ie=await this.scanExtension(G);return ie?[ie]:[]}else return await this.scanExtensions(G)}catch(ie){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,T.$_)(ie)),[]}}async scanExtension(G,ie){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=u.$mn),ie=ie??V.__metadata,delete V.__metadata;const z=(0,g.$Np)(V.publisher,V.name),ee=ie?.id?{id:z,uuid:ie.id}:{id:z},re=ie?.isSystem?u.ExtensionType.System:G.type,ce=re===u.ExtensionType.System||!!ie?.isBuiltin;V=await this.t(G.location,V,U.createNlsConfiguration(G));const q={type:re,identifier:ee,manifest:V,location:G.location,isBuiltin:ce,targetPlatform:ie?.targetPlatform??u.TargetPlatform.UNDEFINED,publisherDisplayName:ie?.publisherDisplayName,metadata:ie,isValid:!0,validations:[]};return G.validate?this.validate(q,G):q}}catch(V){G.type!==u.ExtensionType.System&&this.m.error(V)}return null}validate(G,ie){let V=!0;const z=(0,t.$Yp)(ie.productVersion,ie.productDate,ie.location,G.manifest,G.isBuiltin);for(const[ee,re]of z)ee===m.default.Error&&(V=!1,this.m.error(this.z(ie.location,re)));return G.isValid=V,G.validations=z,G}async scanExtensionManifest(G){const ie=(0,$.$gh)(G,"package.json");let V;try{V=(await this.j.readFile(ie)).value.toString()}catch(ee){return(0,s.$ql)(ee)!==s.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(G,(0,w.localize)(0,null,ie.path,ee.message))),null}let z;try{z=JSON.parse(V)}catch{const re=[];(0,A.$Vn)(V,re);for(const ce of re)this.m.error(this.z(G,(0,w.localize)(1,null,ie.path,ce.offset,ce.length,(0,L.$Fq)(ce.error))));return null}return(0,A.$5n)(z)!=="object"?(this.m.error(this.z(G,(0,w.localize)(2,null,ie.path))),null):z}async t(G,ie,V){const z=await this.u(G,ie,V);if(z)try{const ee=[],re=await this.w(z.default,ee);if(ee.length>0)return ee.forEach(q=>{this.m.error(this.z(G,(0,w.localize)(3,null,z.default?.path,(0,L.$Fq)(q.error))))}),ie;if((0,A.$5n)(z)!=="object")return this.m.error(this.z(G,(0,w.localize)(4,null,z.default?.path))),ie;const ce=z.values||Object.create(null);return(0,E.$Gq)(this.m,ie,ce,re)}catch{}return ie}async u(G,ie,V){const z=(0,$.$gh)(G,"package.nls.json"),ee=(x,J)=>{J.forEach(H=>{this.m.error(this.z(G,(0,w.localize)(5,null,x?.path,(0,L.$Fq)(H.error))))})},re=x=>{this.m.error(this.z(G,(0,w.localize)(6,null,x?.path)))},ce=`${ie.publisher}.${ie.name}`,q=V.translations[ce];if(q)try{const x=f.URI.file(q),J=(await this.j.readFile(x)).value.toString(),H=[],D=(0,A.$Vn)(J,H);return H.length>0?(ee(x,H),{values:void 0,default:z}):(0,A.$5n)(D)!=="object"?(re(x),{values:void 0,default:z}):{values:D.contents?D.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let J;try{J=await this.y(G,V)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const H=(await this.j.readFile(J.localized)).value.toString(),D=[],B=(0,A.$Vn)(H,D);return D.length>0?(ee(J.localized,D),{values:void 0,default:J.original}):(0,A.$5n)(B)!=="object"?(re(J.localized),{values:void 0,default:J.original}):{values:B,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(G,ie){if(G)try{const V=(await this.j.readFile(G)).value.toString();return(0,A.$Vn)(V,ie)}catch{}}y(G,ie){return new Promise((V,z)=>{const ee=re=>{const ce=(0,$.$gh)(G,`package.nls.${re}.json`);this.j.exists(ce).then(q=>{q&&V({localized:ce,original:(0,$.$gh)(G,"package.nls.json")});const x=re.lastIndexOf("-");x===-1?V({localized:(0,$.$gh)(G,"package.nls.json"),original:null}):(re=re.substring(0,x),ee(re))})};if(ie.devMode||ie.pseudo||!ie.language)return V({localized:(0,$.$gh)(G,"package.nls.json"),original:null});ee(ie.language)})}z(G,ie){return`[${G.path}]: ${ie}`}};F=ve([Z(1,y.$Dq),Z(2,k.$Jl),Z(3,s.$_k),Z(4,i.$_j)],F);let M=class extends F{constructor(G,ie,V,z,ee,re,ce){super(ie,z,ee,re,ce),this.G=G,this.H=V,this.D=this.B(new a.$Dh(3e3)),this.F=this.B(new o.$me),this.onDidChangeCache=this.F.event}async scanExtensions(G){const ie=this.M(G),V=await this.I(ie);if(this.C=G,V&&V.input&&U.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",G.type===u.ExtensionType.System?"system":"user",G.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ee=>(ee.location=f.URI.revive(ee.location),ee));const z=await super.scanExtensions(G);return await this.J(ie,{input:G,result:z}),z}async I(G){try{const ie=await this.j.readFile(G),V=JSON.parse(ie.value.toString());return{result:V.result,input:(0,l.$ci)(V.input)}}catch(ie){this.m.debug("Error while reading the extension cache file:",G.path,(0,T.$_)(ie))}return null}async J(G,ie){try{await this.j.writeFile(G,O.$Oe.fromString(JSON.stringify(ie)))}catch(V){this.m.debug("Error while writing the extension cache file:",G.path,(0,T.$_)(V))}}async L(){if(!this.C)return;const G=this.M(this.C),ie=await this.I(G);if(!ie)return;const V=ie.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!N.$go(z,V))try{this.m.info("Invalidating Cache",V,z),await this.j.del(G),this.F.fire()}catch(ee){this.m.error(ee)}}M(G){const ie=this.N(G);return this.h.extUri.joinPath(ie.cacheHome,G.type===u.ExtensionType.System?u.$ln:u.$kn)}N(G){return G.type===u.ExtensionType.System?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(ie=>this.h.extUri.isEqual(G.location,ie.extensionsResource))??this.G:this.H.defaultProfile}};M=ve([Z(2,R.$Ll),Z(3,y.$Dq),Z(4,k.$Jl),Z(5,s.$_k),Z(6,i.$_j)],M);function X(Q,G){const ie=(0,g.$Lp)(Q.manifest.publisher,Q.manifest.name);return{id:ie,identifier:new u.$qn(ie),isBuiltin:Q.type===u.ExtensionType.System,isUserBuiltin:Q.type===u.ExtensionType.User&&Q.isBuiltin,isUnderDevelopment:G,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,publisherDisplayName:Q.publisherDisplayName,...Q.manifest}}class K extends C{constructor(G,ie,V,z,ee,re,ce,q,x,J,H,D){super(G,ie,(0,$.$gh)(V,".vscode-oss-dev","extensions","control.json"),z,ee,re,ce,q,x,J,H,D),this.S=(async()=>{if(h.$z)try{const B=await this.w.readFile(f.URI.file(h.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Lq=K}),define(le[251],he([0,1,69,6,41,3,2,23,14,31,10,20]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;let h=class extends T.$Wc{constructor(c,m){super(),this.b=c,this.f=m,this.a=new a.$Lh(5)}async postUninstall(c){const m=this.g(c,"uninstall");m&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(b)}}));try{await p.Promises.rm(this.m(c))}catch(b){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(b)}}g(c,m){const b=`vscode:${m}`;if(c.location.scheme===A.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[b]=="string"){const f=c.manifest.scripts[b].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${b} should be a node script`),null):{script:(0,L.$lc)(c.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(c,m,b,f,w){return new Promise((I,g)=>{const u=this.j(c,m,b,w);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?g(r):I(void 0)};u.on("error",r=>{s((0,N.$qj)(r)||"Unknown")}),u.on("exit",(r,i)=>{s(r?`post-${m} process exited with code ${r}`:void 0)}),f&&(t=setTimeout(()=>{t=null,u.kill(),g("timed out")},5e3))})}j(c,m,b,f){const w={silent:!0,execArgv:void 0},I=(0,P.fork)(c,[`--type=extension-post-${m}`,...b],w);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const g=O.Event.fromNodeEventEmitter(I.stdout,"data"),u=O.Event.fromNodeEventEmitter(I.stderr,"data");this.B(g(r=>this.f.info(f.identifier.id,f.manifest.version,`post-${m}`,r))),this.B(u(r=>this.f.error(f.identifier.id,f.manifest.version,`post-${m}`,r)));const t=O.Event.any(O.Event.map(g,r=>({data:`%c${r}`,format:[""]}),this.q),O.Event.map(u,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return O.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(f.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),I}m(c){return(0,L.$lc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$Pq=h,e.$Pq=h=ve([Z(0,d.$Ll),Z(1,S.$_j)],h)}),define(le[117],he([0,1,72,167,84,28]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=T,e.$Nq=A;function T(L){let p=O.ExtensionManagementErrorCode.Extract;return L instanceof P.$vq&&(L.type==="CorruptZip"?p=O.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(p=O.ExtensionManagementErrorCode.IncompleteZip)),(0,N.$Aq)(L,p)}async function A(L){let p;try{p=await(0,P.$yq)(L,"extension/package.json")}catch(S){throw T(S)}try{return JSON.parse(p.toString("utf8"))}catch{throw new O.$jp((0,a.localize)(0,null),O.ExtensionManagementErrorCode.Invalid)}}}),define(le[252],he([0,1,6,8,2,23,21,57,13,32,31,72,22,16,84,28,33,117,111,7,10,18]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0,A=ke(A);let s=class extends N.$Wc{static{t=this}static{this.c=".sigzip"}constructor(i,n,o,l,y,R,k){super(),this.h=n,this.j=o,this.m=l,this.n=y,this.r=R,this.t=k,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,n,o,l){await this.g;const y=await this.w(i,n);let R=!1;if(o&&this.u(i)){let k;try{k=await this.y(i)}catch(E){try{await this.delete(y)}catch(v){this.t.error(v)}throw E}try{R=await this.n.verify(i,y.fsPath,k.fsPath,l)}catch(E){if(R=E.code,R===w.ExtensionSignatureVerificationCode.PackageIsInvalidZip||R===w.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(y)}catch(v){this.t.error(v)}throw new m.$jp(d.$uq,m.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(k)}catch(E){this.t.error(E)}}}return{location:y,verificationStatus:R}}u(i){if(!i.isSigned)return this.t.info(`Extension is not signed: ${i.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,L.$lg)(n)?n:!0}async w(i,n){try{const o=(0,T.$gh)(this.extensionsDownloadDir,this.G(i)),l=await this.C(i,"vsix",async()=>{await this.z(i,o,y=>this.j.download(i,y,n));try{await this.D(o.fsPath,"extension/package.json")}catch(y){try{await this.h.del(o)}catch(R){this.t.warn(`Error while deleting: ${o.path}`,(0,a.$_)(R))}throw y}},2);return l>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:l}),o}catch(o){throw(0,c.$Aq)(o,m.ExtensionManagementErrorCode.Download)}}async y(i){try{const n=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,p.$2g)()}`),o=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,n);try{await this.D(n.fsPath,".signature.p7s")}catch(l){try{await this.h.del(n)}catch(y){this.t.warn(`Error while deleting: ${n.path}`,(0,a.$_)(y))}throw l}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:o}),n}catch(n){throw(0,c.$Aq)(n,m.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,n,o){if(await this.h.exists(n))return;if(n.scheme!==O.Schemas.file){await o(n);return}const l=(0,T.$gh)(this.extensionsDownloadDir,`.${(0,p.$2g)()}`);try{await o(l)}catch(y){try{await this.h.del(l)}catch{}throw y}try{await S.Promises.rename(l.fsPath,n.fsPath,2*60*1e3)}catch(y){try{await this.h.del(l)}catch{}let R=!1;try{R=await this.h.exists(n)}catch{}if(R)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,n.path);else throw this.t.info(`Rename failed because of ${(0,a.$_)(y)}. Deleted the file from downloaded location`,l.path),y}}async C(i,n,o,l){let y=1;for(;;)try{return await o(),y}catch(R){if(y++>l)throw R;this.t.warn(`Failed downloading ${n}. ${(0,a.$_)(R)}. Retry again...`,i.identifier.id)}}async D(i,n){try{await(0,d.$yq)(i,n)}catch(o){throw(0,f.$Mq)(o)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const n=[],o=[],l=[];for(const k of i.children)if(k.name.endsWith(t.c))l.push(k.resource);else{const E=b.$Jp.parse(k.name);E&&o.push([E,k])}const y=(0,b.$Op)(o,([k])=>k),R=[];for(const k of y)k.sort((E,v)=>A.rcompare(E[0].version,v[0].version)),n.push(...k.slice(1).map(E=>E[1].resource)),R.push(k[0][1]);R.sort((k,E)=>k.mtime-E.mtime),n.push(...R.slice(0,Math.max(0,R.length-this.f)).map(k=>k.resource)),n.push(...l),await P.Promises.settled(n.map(k=>(this.t.trace("Deleting from cache",k.path),this.h.del(k))))}}catch(i){this.t.error(i)}}G(i){return this.f?b.$Jp.create(i).toString().toLowerCase():(0,p.$2g)()}};e.$Oq=s,e.$Oq=s=t=ve([Z(0,$.$Ni),Z(1,I.$_k),Z(2,m.$hp),Z(3,h.$_i),Z(4,w.$nq),Z(5,u.$$l),Z(6,g.$_j)],s)}),define(le[118],he([0,1,6,15,26,41,8,3,56,2,35,23,14,21,57,13,9,32,31,72,166,99,16,84,28,33,53,85,252,251,117,224,234,37,73,7,4,10,24,18,29,20]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t,s,r,i,n,o,l,y,R,k,E,v,C,U,F,M,X,K,Q,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=void 0,h=ke(h),c=ke(c),w=ke(w),g=ke(g),e.$Sq=(0,F.$Gi)(r.$kp);const ie=".vsctmp";let V=class extends s.$zq{constructor(q,x,J,H,D,B,j,W,te,_,Y,ae){super(q,x,Y,J,_,ae),this.eb=D,this.fb=B,this.gb=j,this.hb=W,this.ib=te,this.db=new Map,this.tb=new S.$Dc;const ue=this.B(W.createInstance(y.$Pq));this.ab=this.B(W.createInstance(z,we=>ue.postUninstall(we))),this.bb=this.B(new k.$Qq(ae,te,Y,this,this.F)),this.cb=this.B(W.createInstance(l.$Oq));const ge=this.B(new E.$Rq(this,this.eb,ae,B,Y,te,J));this.B(ge.onDidChangeExtensionsByAnotherSource(we=>this.sb(we))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Tp)(this.ib,this.F)),this.jb}async zip(q){this.F.trace("ExtensionManagementService#zip",q.identifier.id);const x=await this.rb(q),J=await(0,I.zip)((0,$.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)()).fsPath,x);return b.URI.file(J)}async unzip(q){return this.F.trace("ExtensionManagementService#unzip",q.toString()),(await this.install(q)).identifier}async getManifest(q){const{location:x,cleanup:J}=await this.lb(q),H=h.$mc(x.fsPath);try{return await(0,R.$Nq)(H)}finally{await J()}}getInstalled(q,x=this.H.defaultProfile.extensionsResource,J={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(q??null,x,J)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(q){return this.ab.scanUserExtensionAtLocation(q)}async install(q,x={}){this.F.trace("ExtensionManagementService#install",q.toString());const{location:J,cleanup:H}=await this.lb(q);try{const D=await(0,R.$Nq)(h.$mc(J.fsPath)),B=(0,i.$Np)(D.publisher,D.name);if(D.engines&&D.engines.vscode&&!(0,C.$1p)(D.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,B,this.G.version));const W=(await this.I([{manifest:D,extension:J,options:x}])).find(({identifier:te})=>(0,i.$Ip)(te,{id:B}));if(W?.local)return W.local;throw W?.error?W.error:(0,s.$Aq)(new Error(`Unknown error while installing extension ${B}`))}finally{await H()}}async installFromLocation(q,x){this.F.trace("ExtensionManagementService#installFromLocation",q.toString());const J=await this.ab.scanUserExtensionAtLocation(q);if(!J||!J.manifest.name||!J.manifest.version)throw new Error(`Cannot find a valid extension from the location ${q.toString()}`);return await this.wb([[J,{source:"resource"}]],x),this.F.info("Successfully installed extension",J.identifier.id,x.toString()),J}async installExtensionsFromProfile(q,x,J){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",q,x.toString(),J.toString());const H=(await this.getInstalled(v.ExtensionType.User,x)).filter(D=>q.some(B=>(0,i.$Ip)(B,D.identifier)));if(H.length){const D=await Promise.all(H.map(B=>this.ab.scanMetadata(B,x)));await this.wb(H.map((B,j)=>[B,D[j]]),J),this.F.info("Successfully installed extensions",H.map(B=>B.identifier.id),J.toString())}return H}async updateMetadata(q,x,J){return this.F.trace("ExtensionManagementService#updateMetadata",q.identifier.id),x.isPreReleaseVersion&&(x.preRelease=!0,x.hasPreReleaseVersion=!0),x.isMachineScoped===!1&&(x.isMachineScoped=void 0),x.isBuiltin===!1&&(x.isBuiltin=void 0),x.pinned===!1&&(x.pinned=void 0),q=await this.ab.updateMetadata(q,x,J),this.bb.invalidate(J),this.w.fire({local:q,profileLocation:J}),q}async reinstallFromGallery(q){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",q.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const x=await this.getTargetPlatform(),[J]=await this.z.getExtensions([{...q.identifier,preRelease:q.preRelease}],{targetPlatform:x,compatible:!0},N.CancellationToken.None);if(!J)throw new Error(g.localize(2,null));await this.ab.setUninstalled(q);try{await this.ab.removeUninstalledExtension(q)}catch(H){throw new Error(g.localize(3,null,(0,O.$qj)(H)))}return this.installFromGallery(J)}$(q,x,J,H){return this.ab.copyExtension(q,x,J,H)}copyExtensions(q,x){return this.ab.copyExtensions(q,x,{version:this.G.version,date:this.G.date})}markAsUninstalled(...q){return this.ab.setUninstalled(...q)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(q){this.F.error(q)}}async download(q,x,J){const{location:H}=await this.cb.download(q,x,!J);return H}async lb(q){if(q.scheme===d.Schemas.file)return{location:q,async cleanup(){}};this.F.trace("Downloading extension from",q.toString());const x=(0,$.$gh)(this.cb.extensionsDownloadDir,(0,f.$2g)());return await this.gb.download(q,x),this.F.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.ib.del(x)}catch(H){this.F.error(H)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(q,x,J){const H=x instanceof b.URI?new i.$Jp({id:(0,i.$Np)(q.publisher,q.name)},q.version):i.$Jp.create(x);return this.hb.createInstance(ee,H,q,x,J,(D,B)=>{if(x instanceof b.URI)return this.qb(H,x,J,B);let j=this.db.get(H.toString());return j||(this.db.set(H.toString(),j=this.pb(H,x,D,J,B)),j.finally(()=>this.db.delete(H.toString()))),j},this.ab)}Z(q,x){return new re(q,x.profileLocation,this.fb)}async pb(q,x,J,H,D){const{verificationStatus:B,location:j}=await this.cb.download(x,J,!H.donotVerifySignature,H.context?.[r.$ap]);try{if(D.isCancellationRequested)throw new T.$7;return await(0,R.$Nq)(j.fsPath),{local:await this.ab.extractUserExtension(q,j.fsPath,{id:x.identifier.uuid,publisherId:x.publisherId,publisherDisplayName:x.publisherDisplayName,targetPlatform:x.properties.targetPlatform,isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,isPreReleaseVersion:x.properties.isPreReleaseVersion,hasPreReleaseVersion:x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,preRelease:(0,m.$lg)(H.preRelease)?H.preRelease:H.installPreReleaseVersion||x.properties.isPreReleaseVersion,source:"gallery"},!1,D),verificationStatus:B}}catch(W){try{await this.cb.delete(j)}catch(te){this.F.warn("Error while deleting the downloaded file",j.toString(),(0,T.$_)(te))}throw(0,s.$Aq)(W)}}async qb(q,x,J,H){return{local:await this.ab.extractUserExtension(q,h.$mc(x.fsPath),{isApplicationScoped:J.isApplicationScoped,isMachineScoped:J.isMachineScoped,isBuiltin:J.isBuiltin,installedTimestamp:Date.now(),pinned:J.installGivenVersion?!0:!!J.pinned,source:"vsix"},!0,H)}}async rb(q){const x=async H=>{let D=await w.Promises.readdir(H);D=D.map(W=>h.$lc(H,W));const B=await Promise.all(D.map(W=>w.Promises.stat(W)));let j=Promise.resolve([]);return B.forEach((W,te)=>{const _=D[te];W.isFile()&&(j=j.then(Y=>[...Y,_])),W.isDirectory()&&(j=j.then(Y=>x(_).then(ae=>[...Y,...ae])))}),j};return(await x(q.location.fsPath)).map(H=>({path:`extension/${h.$nc(q.location.fsPath,H)}`,localPath:H}))}async sb({added:q,removed:x}){if(x){const J=q&&this.D.extUri.isEqual(x.profileLocation,q.profileLocation)?x.extensions.filter(H=>q.extensions.every(D=>!(0,i.$Ip)(D,H))):x.extensions;for(const H of J)this.F.info("Extensions removed from another source",H.id,x.profileLocation.toString()),this.u.fire({identifier:H,profileLocation:x.profileLocation})}if(q){const H=(await this.getInstalled(v.ExtensionType.User,q.profileLocation)).filter(D=>q.extensions.some(B=>(0,i.$Ip)(B,D.identifier)));this.s.fire(H.map(D=>(this.F.info("Extensions added from another source",D.identifier.id,q.profileLocation.toString()),{identifier:D.identifier,local:D,profileLocation:q.profileLocation,operation:r.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(x=>this.tb.add(x)));const q=await this.ib.resolve(this.eb.userExtensionsLocation);for(const x of q.children??[])x.isDirectory&&this.tb.add(x.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(x=>this.vb(x)))}async vb(q){if(!q.affects(this.eb.userExtensionsLocation,U.FileChangeType.ADDED))return;const x=[];for(const J of q.rawAdded){if(this.tb.has(J)||!this.D.extUri.isEqual(this.D.extUri.dirname(J),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(J,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(J).startsWith(".")||!(await this.ib.stat(J)).isDirectory)continue;const H=await this.ab.scanUserExtensionAtLocation(J);H&&H.installedTimestamp===void 0&&(this.tb.add(J),x.push(H))}x.length&&(await this.wb(x.map(J=>[J,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",x.map(J=>J.identifier.id)))}async wb(q,x){const J=q.map(H=>H[0]);await this.xb(J),await this.fb.addExtensionsToProfile(q,x),this.s.fire(J.map(H=>({local:H,identifier:H.identifier,operation:r.InstallOperation.None,profileLocation:x})))}async xb(q){const x=await this.ab.getUninstalledExtensions();for(const J of q){const H=i.$Jp.create(J);x[H.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",H.id),await this.ab.setInstalled(H),this.F.info("Removed the extension from uninstalled list:",H.id))}}};e.$Tq=V,e.$Tq=V=ve([Z(0,r.$hp),Z(1,K.$$l),Z(2,M.$_j),Z(3,t.$Ni),Z(4,o.$Hq),Z(5,n.$Dq),Z(6,u.$Xo),Z(7,F.$Ei),Z(8,U.$_k),Z(9,X.$sk),Z(10,Q.$Jl),Z(11,G.$Ll)],V);let z=class extends p.$Wc{constructor(q,x,J,H,D,B){super(),this.n=q,this.s=x,this.t=J,this.u=H,this.w=D,this.y=B,this.h=this.B(new A.$me),this.onExtract=this.h.event,this.j=new S.$Cc,this.m=new S.$Cc,this.c=(0,$.$gh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Mh}async cleanUp(){await this.I(),await this.H()}async scanExtensions(q,x,J){try{const H={includeInvalid:!0,profileLocation:x,productVersion:J};let D=[];if(q===null||q===v.ExtensionType.System){let B=this.j.get(x);B||(B=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},H,!1).finally(()=>this.j.delete(x)),this.j.set(x,B)),D.push(...await B)}else if(q===v.ExtensionType.User){let B=this.m.get(x);B||(B=this.t.scanUserExtensions(H).finally(()=>this.m.delete(x)),this.m.set(x,B)),D.push(...await B)}return D=q!==null?D.filter(B=>B.type===q):D,await Promise.all(D.map(B=>this.G(B)))}catch(H){throw(0,s.$Aq)(H,r.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(q){try{const x=await this.t.scanUserExtensions({includeAllVersions:!q,includeInvalid:!0});return await Promise.all(x.map(J=>this.G(J)))}catch(x){throw(0,s.$Aq)(x,r.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(q){try{const x=await this.t.scanExistingExtension(q,v.ExtensionType.User,{includeInvalid:!0});if(x)return await this.G(x)}catch(x){this.y.error(x)}return null}async extractUserExtension(q,x,J,H,D){const B=q.toString(),j=b.URI.file(h.$lc(this.t.userExtensionsLocation.fsPath,`.${(0,f.$2g)()}`)),W=b.URI.file(h.$lc(this.t.userExtensionsLocation.fsPath,B));let te=await this.s.exists(W);if(te&&H){try{await this.C(q.id,W,"removeExisting")}catch{throw new r.$jp(g.localize(4,null,W.fsPath,q.id),r.ExtensionManagementErrorCode.Delete)}te=!1}if(te)try{await this.t.updateMetadata(W,J)}catch(_){throw(0,s.$Aq)(_,r.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(D.isCancellationRequested)throw new T.$7;try{this.y.trace(`Started extracting the extension from ${x} to ${W.fsPath}`),await(0,I.$xq)(x,j.fsPath,{sourcePath:"extension",overwrite:!0},D),this.y.info(`Extracted extension to ${W}:`,q.id)}catch(_){throw(0,R.$Mq)(_)}try{await this.t.updateMetadata(j,J)}catch(_){throw(0,s.$Aq)(_,r.ExtensionManagementErrorCode.UpdateMetadata)}if(D.isCancellationRequested)throw new T.$7;try{this.y.trace(`Started renaming the extension from ${j.fsPath} to ${W.fsPath}`),await this.F(j.fsPath,W.fsPath),this.y.info("Renamed to",W.fsPath)}catch(_){if(_.code==="ENOTEMPTY"){this.y.info("Rename failed because extension was installed by another source. So ignoring renaming.",q.id);try{await this.s.del(j,{recursive:!0})}catch{}}else throw this.y.info(`Rename failed because of ${(0,T.$_)(_)}. Deleted from extracted location`,j),_}this.h.fire(W)}catch(_){try{await this.s.del(j,{recursive:!0})}catch{}throw _}return this.scanLocalExtension(W,v.ExtensionType.User)}async scanMetadata(q,x){return x?(await this.z(q,x))?.metadata:this.t.scanMetadata(q.location)}async z(q,x){return(await this.u.scanProfileExtensions(x)).find(H=>(0,i.$Ip)(H.identifier,q.identifier))}async updateMetadata(q,x,J){try{J?await this.u.updateMetadata([[q,x]],J):await this.t.updateMetadata(q.location,x)}catch(H){throw(0,s.$Aq)(H,r.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(q.location,q.type,J)}async getUninstalledExtensions(){try{return await this.D()}catch(q){throw(0,s.$Aq)(q,r.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...q){const x=q.map(J=>i.$Jp.create(J));await this.D(J=>x.forEach(H=>{J[H.toString()]=!0,this.y.info("Marked extension as uninstalled",H.toString())}))}async setInstalled(q){try{await this.D(x=>delete x[q.toString()])}catch(x){throw(0,s.$Aq)(x,r.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(q,x){if(this.w.extUri.isEqualOrParent(q.location,this.t.userExtensionsLocation))return this.C(q.identifier.id,q.location,x)}async removeUninstalledExtension(q){await this.removeExtension(q,"uninstalled"),await this.D(x=>delete x[i.$Jp.create(q).toString()])}async copyExtension(q,x,J,H){const D=await this.z(q,x),B=await this.z(q,J);if(H={...D?.metadata,...H},B)if(this.w.extUri.isEqual(B.location,q.location))await this.u.updateMetadata([[q,{...B.metadata,...H}]],J);else{const j=await this.scanLocalExtension(B.location,q.type,J);await this.u.removeExtensionFromProfile(j,J),await this.u.addExtensionsToProfile([[q,{...B.metadata,...H}]],J)}else await this.u.addExtensionsToProfile([[q,H]],J);return this.scanLocalExtension(q.location,q.type,J)}async copyExtensions(q,x,J){const H=await this.scanExtensions(v.ExtensionType.User,q,J),D=await Promise.all(H.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,q)]));await this.u.addExtensionsToProfile(D,x)}async C(q,x,J){this.y.trace(`Deleting ${J} extension from disk`,q,x.fsPath);const H=this.w.extUri.joinPath(this.w.extUri.dirname(x),`${this.w.extUri.basename(x)}.${(0,L.$tj)((0,f.$2g)()).toString(16)}${ie}`);await this.F(x.fsPath,H.fsPath),await this.s.del(H,{recursive:!0}),this.y.info(`Deleted ${J} extension from disk`,q,x.fsPath)}D(q){return this.g.queue(async()=>{let x;try{x=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(H){if((0,U.$ql)(H)!==U.FileOperationResult.FILE_NOT_FOUND)throw H}let J={};if(x)try{J=JSON.parse(x)}catch{}return q&&(q(J),Object.keys(J).length?await this.s.writeFile(this.c,a.$Oe.fromString(JSON.stringify(J))):await this.s.del(this.c)),J})}async F(q,x){try{await w.Promises.rename(q,x,2*60*1e3)}catch(J){throw(0,s.$Aq)(J,r.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(q,x,J){try{if(J){const D=(await this.t.scanUserExtensions({profileLocation:J})).find(B=>this.w.extUri.isEqual(B.location,q));if(D)return await this.G(D)}else{const H=await this.t.scanExistingExtension(q,x,{includeInvalid:!0});if(H)return await this.G(H)}throw new r.$jp(g.localize(5,null,q.path),r.ExtensionManagementErrorCode.ScanningExtension)}catch(H){throw(0,s.$Aq)(H,r.ExtensionManagementErrorCode.ScanningExtension)}}async G(q){const x=await this.s.resolve(q.location);let J,H;return x.children&&(J=x.children.find(({name:D})=>/^readme(\.txt|\.md|)$/i.test(D))?.resource,H=x.children.find(({name:D})=>/^changelog(\.txt|\.md|)$/i.test(D))?.resource),{identifier:q.identifier,type:q.type,isBuiltin:q.isBuiltin||!!q.metadata?.isBuiltin,location:q.location,manifest:q.manifest,targetPlatform:q.targetPlatform,validations:q.validations,isValid:q.isValid,readmeUrl:J,changelogUrl:H,publisherDisplayName:q.metadata?.publisherDisplayName,publisherId:q.metadata?.publisherId||null,isApplicationScoped:!!q.metadata?.isApplicationScoped,isMachineScoped:!!q.metadata?.isMachineScoped,isPreReleaseVersion:!!q.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!q.metadata?.hasPreReleaseVersion,preRelease:!!q.metadata?.preRelease,installedTimestamp:q.metadata?.installedTimestamp,updated:!!q.metadata?.updated,pinned:!!q.metadata?.pinned,isWorkspaceScoped:!1,source:q.metadata?.source??(q.identifier.uuid?"gallery":"vsix")}}async H(){const q=await this.getUninstalledExtensions();if(Object.keys(q).length===0){this.y.debug("No uninstalled extensions found.");return}this.y.debug("Removing uninstalled extensions:",Object.keys(q));const x=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),J=new Set;for(const D of x)q[i.$Jp.create(D).toString()]||J.add(D.identifier.id.toLowerCase());try{const D=(0,i.$Op)(x,B=>B.identifier);await P.Promises.settled(D.map(async B=>{const j=B.sort((W,te)=>c.rcompare(W.manifest.version,te.manifest.version))[0];J.has(j.identifier.id.toLowerCase())||await this.n(await this.G(j))}))}catch(D){this.y.error(D)}const H=x.filter(D=>D.metadata&&q[i.$Jp.create(D).toString()]);await Promise.allSettled(H.map(D=>this.removeUninstalledExtension(D)))}async I(){this.y.trace("ExtensionManagementService#removeTempDeleteFolders");let q;try{q=await this.s.resolve(this.t.userExtensionsLocation)}catch(x){(0,U.$ql)(x)!==U.FileOperationResult.FILE_NOT_FOUND&&this.y.error(x);return}if(q?.children)try{await Promise.allSettled(q.children.map(async x=>{if(!(!x.isDirectory||!x.name.endsWith(ie))){this.y.trace("Deleting the temporarily deleted folder",x.resource.toString());try{await this.s.del(x.resource,{recursive:!0}),this.y.trace("Deleted the temporarily deleted folder",x.resource.toString())}catch(J){(0,U.$ql)(J)!==U.FileOperationResult.FILE_NOT_FOUND&&this.y.error(J)}}}))}catch{}}};e.$Uq=z,e.$Uq=z=ve([Z(1,U.$_k),Z(2,o.$Hq),Z(3,n.$Dq),Z(4,Q.$Jl),Z(5,M.$_j)],z);let ee=class extends s.$Bq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(q,x,J,H,D,B,j,W,te,_,Y,ae){super(),this.l=q,this.manifest=x,this.source=J,this.options=H,this.m=D,this.n=B,this.o=j,this.p=W,this.q=te,this.s=_,this.t=Y,this.u=ae,this.j=r.InstallOperation.Install,this.identifier=this.l.identifier}async h(q){const J=(await this.n.scanExtensions(v.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(j=>(0,i.$Ip)(j.identifier,this.identifier));J&&(this.j=r.InstallOperation.Update);const H={isApplicationScoped:this.options.isApplicationScoped||J?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||J?.isMachineScoped,isBuiltin:this.options.isBuiltin||J?.isBuiltin,isSystem:J?.type===v.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??J?.pinned,source:this.source instanceof b.URI?"vsix":"gallery"};let D;if(this.source instanceof b.URI)if(J){if(this.l.equals(new i.$Jp(J.identifier,J.manifest.version)))try{await this.n.removeExtension(J,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const j=await this.w(this.l);if(j)try{await this.n.removeExtension(j,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}else{if(H.id=this.source.identifier.uuid,H.publisherId=this.source.publisherId,H.publisherDisplayName=this.source.publisherDisplayName,H.targetPlatform=this.source.properties.targetPlatform,H.updated=!!J,H.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,H.hasPreReleaseVersion=J?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,H.preRelease=(0,m.$lg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||J?.preRelease,J&&J.type!==v.ExtensionType.System&&J.manifest.version===this.source.version)return this.n.updateMetadata(J,H,this.options.profileLocation);D=await this.w(this.l)}if(q.isCancellationRequested)throw(0,s.$Aq)(new T.$7);if(!D){const j=await this.m(this.operation,q);D=j.local,this.k=j.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(j){throw(0,s.$Aq)(j,r.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(q.isCancellationRequested)throw(0,s.$Aq)(new T.$7);try{await this.t.addExtensionsToProfile([[D,H]],this.options.profileLocation,!D.isValid)}catch(j){throw(0,s.$Aq)(j,r.ExtensionManagementErrorCode.AddToProfile)}const B=await this.n.scanLocalExtension(D.location,v.ExtensionType.User,this.options.profileLocation);if(!B)throw new r.$jp("Cannot find the installed extension",r.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof b.URI&&this.x(D,q),B}async w(q){return(await this.n.getUninstalledExtensions())[q.toString()]?(this.u.trace("Removing the extension from uninstalled list:",q.id),await this.n.setInstalled(q),this.u.info("Removed the extension from uninstalled list:",q.id),(await this.n.scanAllUserExtensions(!0)).find(H=>i.$Jp.create(H).equals(q))):void 0}async x(q,x){try{let[J]=await this.p.getExtensions([{id:q.identifier.id,version:q.manifest.version}],x);if(J||([J]=await this.p.getExtensions([{id:q.identifier.id}],x)),J){const H={id:J.identifier.uuid,publisherDisplayName:J.publisherDisplayName,publisherId:J.publisherId,isPreReleaseVersion:J.properties.isPreReleaseVersion,hasPreReleaseVersion:q.hasPreReleaseVersion||J.properties.isPreReleaseVersion,preRelease:J.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(q,H,this.options.profileLocation)}}catch{}}};ee=ve([Z(6,Q.$Jl),Z(7,r.$hp),Z(8,G.$Ll),Z(9,o.$Hq),Z(10,n.$Dq),Z(11,M.$_j)],ee);class re extends s.$Bq{constructor(q,x,J){super(),this.extension=q,this.j=x,this.k=J}async h(q){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[253],he([0,1,10,20,29,18,53,7,16,9]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jR=void 0;let S=class extends T.$Eq{constructor(h,$,c,m,b,f){super(p.URI.file(h.extensionsPath),$,c,m,b,f)}};e.$jR=S,e.$jR=S=ve([Z(0,L.$Ni),Z(1,A.$_k),Z(2,a.$Ll),Z(3,N.$Jl),Z(4,O.$$l),Z(5,P.$_j)],S)}),define(le[254],he([0,1,9,16,53,85,7,4,10,24,29,20]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;let h=class extends O.$Lq{constructor(c,m,b,f,w,I,g,u){super(P.URI.file(w.builtinExtensionsPath),P.URI.file(w.extensionsPath),w.userHome,c.defaultProfile,c,m,b,f,w,I,g,u)}};e.$Jfc=h,e.$Jfc=h=ve([Z(0,d.$Ll),Z(1,N.$Dq),Z(2,T.$_k),Z(3,L.$_j),Z(4,a.$Ni),Z(5,p.$sk),Z(6,S.$Jl),Z(7,A.$Ei)],h)}),define(le[17],he([0,1,6,3,2,101,13,71,4,20]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$eq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$cq=e.$bq=e.$aq=void 0,e.$dq=$,e.$fq=m,e.$hq=f,e.$aq="__$__isNewStorageMarker",e.$bq="__$__targetStorageMarker",e.$cq=(0,L.$Fi)("storageService");var S;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(S||(e.WillSaveStateReason=S={}));var d;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var h;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(h||(e.StorageTarget=h={}));function $(w){const I=w.get(e.$bq);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}class c extends N.$Wc{static{this.a=60*1e3}constructor(I={flushInterval:c.a}){super(),this.m=I,this.b=this.B(new a.$pe),this.c=this.B(new a.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new a.$me),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new N.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,g,u){return a.Event.filter(this.b.event,t=>t.scope===I&&(g===void 0||t.key===g),u)}n(){this.j.value=(0,P.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,N.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,g){const{key:u,external:t}=g;if(u===e.$bq){switch(I){case d.APPLICATION:this.H=void 0;break;case d.PROFILE:this.F=void 0;break;case d.WORKSPACE:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:u,target:this.J(I)[u],external:t})}w(I){this.f.fire({reason:I})}get(I,g,u){return this.P(g)?.get(I,u)}getBoolean(I,g,u){return this.P(g)?.getBoolean(I,u)}getNumber(I,g,u){return this.P(g)?.getNumber(I,u)}getObject(I,g,u){return this.P(g)?.getObject(I,u)}storeAll(I,g){this.y(()=>{for(const u of I)this.store(u.key,u.value,u.scope,u.target,g)})}store(I,g,u,t,s=!1){if((0,T.$og)(g)){this.remove(I,u,s);return}this.y(()=>{this.z(I,u,t),this.P(u)?.set(I,g,s)})}remove(I,g,u=!1){this.y(()=>{this.z(I,g,void 0),this.P(g)?.delete(I,u)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,g){const u=[],t=this.J(I);for(const s of Object.keys(t))t[s]===g&&u.push(s);return u}z(I,g,u,t=!1){const s=this.J(g);typeof u=="number"?s[I]!==u&&(s[I]=u,this.P(g)?.set(e.$bq,JSON.stringify(s),t)):typeof s[I]=="number"&&(delete s[I],this.P(g)?.set(e.$bq,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(d.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(d.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(d.APPLICATION)),this.H}J(I){switch(I){case d.APPLICATION:return this.I;case d.PROFILE:return this.G;default:return this.D}}L(I){const g=this.P(I);return g?$(g):Object.create(null)}isNew(I){return this.getBoolean(e.$aq,I)===!0}async flush(I=S.NONE){this.f.fire({reason:I});const g=this.P(d.APPLICATION),u=this.P(d.PROFILE),t=this.P(d.WORKSPACE);switch(I){case S.NONE:await P.Promises.settled([g?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await P.Promises.settled([g?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(d.APPLICATION)?.items??new Map,g=this.P(d.PROFILE)?.items??new Map,u=this.P(d.WORKSPACE)?.items??new Map;return f(I,g,u,this.Q(d.APPLICATION)??"",this.Q(d.PROFILE)??"",this.Q(d.WORKSPACE)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,g){return this.w(S.NONE),(0,p.$Kl)(I)?this.R(I,g):this.S(I,g)}M(I,g){return!(I.id===g.id||m(g)&&m(I))}N(I,g,u){this.y(()=>{const t=new Set;for(const[s,r]of I)t.add(s),g.get(s)!==r&&this.u(u,{key:s,external:!0});for(const[s]of g.items)t.has(s)||this.u(u,{key:s,external:!0})})}}e.$eq=c;function m(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class b extends c{constructor(){super(),this.U=this.B(new A.$$p(new A.$_p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$$p(new A.$_p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$$p(new A.$_p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(d.WORKSPACE,I))),this.B(this.W.onDidChangeStorage(I=>this.u(d.PROFILE,I))),this.B(this.U.onDidChangeStorage(I=>this.u(d.APPLICATION,I)))}P(I){switch(I){case d.APPLICATION:return this.U;case d.PROFILE:return this.W;default:return this.X}}Q(I){switch(I){case d.APPLICATION:return"inMemory (application)";case d.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$gq=b;async function f(w,I,g,u,t,s){const r=v=>{try{return JSON.parse(v)}catch{return v}},i=new Map,n=new Map;w.forEach((v,C)=>{i.set(C,v),n.set(C,r(v))});const o=new Map,l=new Map;I.forEach((v,C)=>{o.set(C,v),l.set(C,r(v))});const y=new Map,R=new Map;g.forEach((v,C)=>{y.set(C,v),R.set(C,r(v))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const k=[];if(i.forEach((v,C)=>{k.push({key:C,value:v})}),console.table(k),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const v=[];o.forEach((C,U)=>{v.push({key:U,value:C})}),console.table(v),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${s})`);const E=[];y.forEach((v,C)=>{E.push({key:C,value:v})}),console.table(E),console.groupEnd(),console.log(R)}}),define(le[119],he([0,1,3,2,13,28,33,17]),function(ne,e,P,a,N,O,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DLb=e.$CLb=void 0;let L=class extends a.$Wc{constructor(d,h){super(),this.a=new P.$me,this.onDidChangeEnablement=this.a.event,this.b=this.B(new p(d)),this.B(this.b.onDidChange($=>this.a.fire({extensions:$,source:"storage"}))),this.B(h.onDidInstallExtensions($=>$.forEach(({local:c,operation:m})=>{c&&m===O.InstallOperation.Migrate&&this.f(c.identifier)})))}async enableExtension(d,h){return this.f(d)?(this.a.fire({extensions:[d],source:h}),!0):!1}async disableExtension(d,h){return this.c(d)?(this.a.fire({extensions:[d],source:h}),!0):!1}getDisabledExtensions(){return this.h(O.$lp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(d){const h=this.getDisabledExtensions();return h.every($=>!(0,T.$Ip)($,d))?(h.push(d),this.g(h),!0):!1}f(d){const h=this.getDisabledExtensions();for(let $=0;$<h.length;$++){const c=h[$];if((0,T.$Ip)(c,d))return h.splice($,1),this.g(h),!0}return!1}g(d){this.j(O.$lp,d)}h(d){return this.b.get(d,A.StorageScope.PROFILE)}j(d,h){this.b.set(d,h,A.StorageScope.PROFILE)}};e.$CLb=L,e.$CLb=L=ve([Z(0,A.$cq),Z(1,O.$kp)],L);class p extends a.$Wc{constructor(d){super(),this.c=d,this.a=Object.create(null),this.b=this.B(new P.$me),this.onDidChange=this.b.event,this.B(d.onDidChangeValue(A.StorageScope.PROFILE,void 0,this.B(new a.$Vc))(h=>this.f(h)))}get(d,h){let $;return h===A.StorageScope.PROFILE?((0,N.$og)(this.a[d])&&(this.a[d]=this.g(d,h)),$=this.a[d]):$=this.g(d,h),JSON.parse($)}set(d,h,$){const c=JSON.stringify(h.map(({id:b,uuid:f})=>({id:b,uuid:f})));this.g(d,$)!==c&&($===A.StorageScope.PROFILE&&(h.length?this.a[d]=c:delete this.a[d]),this.h(d,h.length?c:void 0,$))}f(d){if(!(0,N.$og)(this.a[d.key])&&this.g(d.key,d.scope)!==this.a[d.key]){const $=this.get(d.key,d.scope);delete this.a[d.key];const c=this.get(d.key,d.scope),m=$.filter(f=>!c.some(w=>(0,T.$Ip)(f,w))),b=c.filter(f=>!$.some(w=>(0,T.$Ip)(w,f)));(m.length||b.length)&&this.b.fire([...m,...b])}}g(d,h){return this.c.get(d,h,"[]")}h(d,h,$){h?this.c.store(d,h,$,A.StorageTarget.MACHINE):this.c.remove(d,$)}}e.$DLb=p}),define(le[86],he([0,1,4,3,2,17,33,24,19,10,13]),function(ne,e,P,a,N,O,T,A,L,p,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=void 0,e.$jw=(0,P.$Fi)("IExtensionStorageService");const h=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let $=class extends N.$Wc{static{d=this}static{this.a=512*1024}static b(m){return`extensionKeys/${(0,T.$Mp)(m.id)}@${m.version}`}static c(m){const b=h.exec(m);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(m,b){const f=await m.getInstalled(),w=[];for(const[I,g]of d.f(b)){const u=f.find(t=>(0,T.$Ip)(t.identifier,{id:I}))?.manifest.version;for(const t of g)u!==t&&w.push(d.b({id:I,version:t}))}for(const I of w)b.remove(I,O.StorageScope.PROFILE)}static f(m){const b=new Map,f=m.keys(O.StorageScope.PROFILE,O.StorageTarget.MACHINE);for(const w of f){const I=d.c(w);if(I){let g=b.get(I.id.toLowerCase());g||b.set(I.id.toLowerCase(),g=[]),g.push(I.version)}}return b}constructor(m,b,f){super(),this.j=m,this.m=b,this.n=f,this.g=this.B(new a.$me),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=d.f(m),this.B(this.j.onDidChangeValue(O.StorageScope.PROFILE,void 0,this.B(new N.$Vc))(w=>this.r(w)))}r(m){if(this.h.has(m.key.toLowerCase())){this.g.fire();return}const b=d.c(m.key);if(b){if(this.j.get(m.key,O.StorageScope.PROFILE)===void 0)this.h.delete(b.id.toLowerCase());else{let f=this.h.get(b.id.toLowerCase());f||this.h.set(b.id.toLowerCase(),f=[]),f.push(b.version),this.g.fire()}return}}s(m){if((0,S.$fg)(m))return m;const b=m.manifest?m.manifest.publisher:m.publisher,f=m.manifest?m.manifest.name:m.name;return(0,T.$Lp)(b,f)}getExtensionState(m,b){const f=this.s(m),w=this.getExtensionStateRaw(m,b);if(w)try{return JSON.parse(w)}catch(I){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${b}): ${I}`)}}getExtensionStateRaw(m,b){const f=this.s(m),w=this.j.get(f,b?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE);return w&&w?.length>d.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${b}): ${w.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),w}setExtensionState(m,b,f){const w=this.s(m);b===void 0?this.j.remove(w,f?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE):this.j.store(w,JSON.stringify(b),f?O.StorageScope.PROFILE:O.StorageScope.WORKSPACE,O.StorageTarget.MACHINE)}setKeysForSync(m,b){this.j.store(d.b(m),JSON.stringify(b),O.StorageScope.PROFILE,O.StorageTarget.MACHINE)}getKeysForSync(m){const b=this.m.extensionSyncedKeys?.[m.id.toLowerCase()],f=this.j.get(d.b(m),O.StorageScope.PROFILE),w=f?JSON.parse(f):void 0;return w&&b?(0,L.$Ob)([...w,...b]):w||b}addToMigrationList(m,b){if(m!==b){const f=this.t.filter(w=>!w.includes(m)&&!w.includes(b));f.push([m,b]),this.t=f}}getSourceExtensionToMigrate(m){const b=this.t.find(([,f])=>m===f);return b?b[0]:void 0}get t(){const m=this.j.get("extensionStorage.migrationList",O.StorageScope.APPLICATION,"[]");try{const b=JSON.parse(m);if(Array.isArray(b))return b}catch{}return[]}set t(m){m.length?this.j.store("extensionStorage.migrationList",JSON.stringify(m),O.StorageScope.APPLICATION,O.StorageTarget.MACHINE):this.j.remove("extensionStorage.migrationList",O.StorageScope.APPLICATION)}};e.$kw=$,e.$kw=$=d=ve([Z(0,O.$cq),Z(1,A.$sk),Z(2,p.$_j)],$)}),define(le[255],he([0,1,2,28,86,233,118,10,17]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;let p=class extends P.$Wc{constructor(d,h,$,c,m,b){super(),d.cleanUp(),(0,O.$f6b)(d,h,$,c,b),N.$kw.removeOutdatedExtensionVersions(d,m)}};e.$Tgc=p,e.$Tgc=p=ve([Z(0,T.$Sq),Z(1,a.$hp),Z(2,N.$jw),Z(3,a.$np),Z(4,L.$cq),Z(5,A.$_j)],p)}),define(le[256],he([0,1,19,2,21,9,7,24,6,3,14,5,36,33,75,37,17]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=void 0;let f=class extends a.$Wc{constructor(t,s){super(),this.b=t,this.c=s,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,r])=>this.a.set(r.configPath,r))}getConfigBasedTips(t){return this.f(t)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(t){const s=[];for(const[r,i]of this.a)if(!(i.configScheme&&i.configScheme!==t.scheme))try{const n=(await this.b.readFile((0,N.$gh)(t,r))).value.toString();for(const[o,l]of Object.entries(i.recommendations))(!l.contentPattern||new RegExp(l.contentPattern,"mig").test(n))&&s.push({extensionId:o,extensionName:l.name,configName:i.configName,important:!!l.important,isExtensionPack:!!l.isExtensionPack,whenNotInstalled:l.whenNotInstalled})}catch{}return s}};e.$bdc=f,e.$bdc=f=ve([Z(0,T.$_k),Z(1,A.$sk)],f);const w="extensionTips/promptedExecutableTips",I="extensionTips/lastPromptedMediumImpExeTime";class g extends f{constructor(t,s,r,i,n,o,l,y){super(l,y),this.r=t,this.s=s,this.t=r,this.u=i,this.w=n,this.z=o,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,y.exeBasedExtensionTips&&Object.entries(y.exeBasedExtensionTips).forEach(([R,k])=>{const E=[],v=[],C=[];Object.entries(k.recommendations).forEach(([U,F])=>{F.important?k.important?E.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):v.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack}):C.push({extensionId:U,extensionName:F.name,isExtensionPack:!!F.isExtensionPack})}),E.length&&this.g.set(R,{exeFriendlyName:k.friendlyName,windowsPath:k.windowsPath,recommendations:E}),v.length&&this.h.set(R,{exeFriendlyName:k.friendlyName,windowsPath:k.windowsPath,recommendations:v}),C.length&&this.j.set(R,{exeFriendlyName:k.friendlyName,windowsPath:k.windowsPath,recommendations:C})}),(0,L.$Hh)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const t=await this.O(this.g),s=await this.O(this.h);return[...t,...s]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const t=await this.O(this.g),s=await this.O(this.h),r=await this.u.getInstalled();this.m=this.D(t,r),this.n=this.D(s,r)}D(t,s){const r=new Map;t.forEach(y=>r.set(y.extensionId.toLowerCase(),y));const{installed:i,uninstalled:n}=this.N([...r.keys()],s);for(const y of i){const R=r.get(y);R&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:y,exeName:R.exeName})}for(const y of n){const R=r.get(y);R&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:y,exeName:R.exeName})}const o=this.L(),l=new Map;for(const y of n){const R=r.get(y);if(R&&(!o[R.exeName]||!o[R.exeName].includes(R.extensionId))){let k=l.get(R.exeName);k||(k=[],l.set(R.exeName,k)),k.push(R)}}return l}F(){if(this.m.size===0)return;const[t,s]=[...this.m.entries()][0];this.H(s).then(r=>{switch(r){case c.RecommendationsNotificationResult.Accepted:this.M(s[0].exeName,s);break;case c.RecommendationsNotificationResult.Ignored:this.m.delete(t);break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const i=p.Event.once(p.Event.latch(p.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case c.RecommendationsNotificationResult.TooMany:{const i=this.B(new a.$Xc);i.value=(0,L.$Hh)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const t=this.I(),s=Date.now()-t,r=7*24*60*60*1e3;if(s<r){const o=this.B(new a.$Xc);o.value=(0,L.$Hh)(()=>{o.dispose(),this.G()},r-s);return}const[i,n]=[...this.n.entries()][0];this.H(n).then(o=>{switch(o){case c.RecommendationsNotificationResult.Accepted:{this.J(Date.now()),this.n.delete(i),this.M(n[0].exeName,n);const l=this.B(new a.$Xc);l.value=(0,L.$Hh)(()=>{l.dispose(),this.G()},r);break}case c.RecommendationsNotificationResult.Ignored:this.n.delete(i),this.G();break;case c.RecommendationsNotificationResult.IncompatibleWindow:{const l=p.Event.once(p.Event.latch(p.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(l(()=>this.G()));break}case c.RecommendationsNotificationResult.TooMany:{const l=this.B(new a.$Xc);l.value=(0,L.$Hh)(()=>{l.dispose(),this.G()},60*60*1e3);break}}})}async H(t){const s=await this.u.getInstalled(m.ExtensionType.User),r=t.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(n=>s.every(o=>!(0,$.$Ip)(o.identifier,{id:n})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:r,source:c.RecommendationSource.EXE,name:t[0].exeFriendlyName,searchValue:`@exe:"${t[0].exeName}"`})}I(){let t=this.w.getNumber(I,b.StorageScope.APPLICATION);return t||(t=Date.now(),this.J(t)),t}J(t){this.w.store(I,t,b.StorageScope.APPLICATION,b.StorageTarget.MACHINE)}L(){return JSON.parse(this.w.get(w,b.StorageScope.APPLICATION,"{}"))}M(t,s){const r=this.L();r[t]=s.map(({extensionId:i})=>i.toLowerCase()),this.w.store(w,JSON.stringify(r),b.StorageScope.APPLICATION,b.StorageTarget.USER)}N(t,s){const r=[],i=[],n=s.reduce((o,l)=>(o.add(l.identifier.id.toLowerCase()),o),new Set);return t.forEach(o=>{n.has(o.toLowerCase())?r.push(o):i.push(o)}),{installed:r,uninstalled:i}}async O(t){const s=[],r=new Map;for(const i of t.keys()){const n=t.get(i);if(!n||!(0,P.$Nb)(n.recommendations))continue;const o=[];d.$i?n.windowsPath&&o.push(n.windowsPath.replace("%USERPROFILE%",()=>h.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>h.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>h.env.ProgramFiles).replace("%APPDATA%",()=>h.env.APPDATA).replace("%WINDIR%",()=>h.env.WINDIR)):(o.push((0,S.$lc)("/usr/local/bin",i)),o.push((0,S.$lc)("/usr/bin",i)),o.push((0,S.$lc)(this.r.fsPath,i)));for(const l of o){let y=r.get(l);if(y===void 0&&(y=await this.b.exists(O.URI.file(l)),r.set(l,y)),y)for(const{extensionId:R,extensionName:k,isExtensionPack:E,whenNotInstalled:v}of n.recommendations)s.push({extensionId:R,extensionName:k,isExtensionPack:E,exeName:i,exeFriendlyName:n.exeFriendlyName,windowsPath:n.windowsPath,whenNotInstalled:v})}}return s}}e.$cdc=g}),define(le[257],he([0,1,28,7,24,16,75,59,17,18,256]),function(ne,e,P,a,N,O,T,A,L,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=void 0;let d=class extends S.$cdc{constructor($,c,m,b,f,w,I,g){super($.userHome,f,c,m,b,w,I,g)}};e.$1gc=d,e.$1gc=d=ve([Z(0,O.$Ni),Z(1,p.$$l),Z(2,P.$kp),Z(3,L.$cq),Z(4,A.$Wec),Z(5,T.$Z5b),Z(6,a.$_k),Z(7,N.$sk)],d)}),define(le[50],he([0,1,15,32,17]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=O;async function O(T,A,L){let p=L&&L.get("storage.serviceMachineId",N.StorageScope.APPLICATION)||null;if(p)return p;try{const d=(await A.readFile(T.serviceMachineIdResource)).value.toString();p=(0,a.$1g)(d)?d:null}catch{p=null}if(!p){p=(0,a.$2g)();try{await A.writeFile(T.serviceMachineIdResource,P.$Oe.fromString(p))}catch{}}return L?.store("storage.serviceMachineId",p,N.StorageScope.APPLICATION,N.StorageTarget.MACHINE),p}}),define(le[258],he([0,1,50,18,49]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=O;async function O(T,A,L,p,S,d,h){const $={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`};if((0,N.$Ap)(A,L)&&(0,N.$Cp)(p)===a.TelemetryLevel.USAGE){const c=await(0,P.$iq)(L,S,d);$["X-Market-User-Id"]=c,$["VSCode-SessionId"]=h.machineId||c}return $}}),define(le[259],he([0,1,19,26,8,5,36,13,9,22,16,28,33,37,73,7,10,24,61,258,17,18,55]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0,e.$kq=ce;const s=O.$o?$.TargetPlatform.WEB:(0,d.$dp)(O.$u,T.$gc),r="X-Market-Search-Activity-Id";var i;(function(B){B[B.None=0]="None",B[B.IncludeVersions=1]="IncludeVersions",B[B.IncludeFiles=2]="IncludeFiles",B[B.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",B[B.IncludeSharedAccounts=8]="IncludeSharedAccounts",B[B.IncludeVersionProperties=16]="IncludeVersionProperties",B[B.ExcludeNonValidated=32]="ExcludeNonValidated",B[B.IncludeInstallationTargets=64]="IncludeInstallationTargets",B[B.IncludeAssetUri=128]="IncludeAssetUri",B[B.IncludeStatistics=256]="IncludeStatistics",B[B.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",B[B.Unpublished=4096]="Unpublished",B[B.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...B){return String(B.reduce((j,W)=>j|W,0))}var o;(function(B){B[B.Tag=1]="Tag",B[B.ExtensionId=4]="ExtensionId",B[B.Category=5]="Category",B[B.ExtensionName=7]="ExtensionName",B[B.Target=8]="Target",B[B.Featured=9]="Featured",B[B.SearchText=10]="SearchText",B[B.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},y={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:d.SortBy.NoneOrRelevance,sortOrder:d.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class E{constructor(j=k){this.d=j}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(j,W=this.d.pageSize){return new E({...this.d,pageNumber:j,pageSize:W})}withFilter(j,...W){const te=[...this.d.criteria,...W.length?W.map(_=>({filterType:j,value:_})):[{filterType:j}]];return new E({...this.d,criteria:te})}withSortBy(j){return new E({...this.d,sortBy:j})}withSortOrder(j){return new E({...this.d,sortOrder:j})}withFlags(...j){return new E({...this.d,flags:j.reduce((W,te)=>W|te,0)})}withAssetTypes(...j){return new E({...this.d,assetTypes:j})}withSource(j){return new E({...this.d,source:j})}get raw(){const{criteria:j,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Y,flags:ae,assetTypes:ue}=this.d;return{filters:[{criteria:j,pageNumber:W,pageSize:te,sortBy:_,sortOrder:Y}],assetTypes:ue,flags:ae}}get searchText(){const j=this.d.criteria.filter(W=>W.filterType===o.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(j=>String(j.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function v(B,j){const W=(B||[]).filter(te=>te.statisticName===j)[0];return W?W.value:0}function C(B){const j="Microsoft.VisualStudio.Code.Translation.";return B.files.filter(te=>te.assetType.indexOf(j)===0).reduce((te,_)=>{const Y=M(B,_.assetType);return Y&&te.push([_.assetType.substring(j.length),Y]),te},[])}function U(B){if(B.properties){const j=B.properties.filter(_=>_.key===l.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=j.filter(_=>W.test(_.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return M(B,l.Repository)}function F(B){return{uri:`${B.fallbackAssetUri}/${l.VSIX}?redirect=true${B.targetPlatform?`&targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${l.VSIX}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}}function M(B,j){return B.files.filter(te=>te.assetType===j)[0]?{uri:`${B.assetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`,fallbackUri:`${B.fallbackAssetUri}/${j}${B.targetPlatform?`?targetPlatform=${B.targetPlatform}`:""}`}:null}function X(B,j){const W=B.properties?B.properties.filter(_=>_.key===j):[],te=W.length>0&&W[0].value;return te?te.split(",").map(_=>(0,h.$Mp)(_)):[]}function K(B){const j=B.properties?B.properties.filter(W=>W.key===y.Engine):[];return j.length>0&&j[0].value||""}function Q(B){const j=B.properties?B.properties.filter(W=>W.key===y.PreRelease):[];return j.length>0&&j[0].value==="true"}function G(B){const j=B.properties?B.properties.filter(te=>te.key===y.LocalizedLanguages):[],W=j.length>0&&j[0].value||"";return W?W.split(","):[]}function ie(B){return B.properties?.find(j=>j.key===y.SponsorLink)?.value}function V(B){return B.properties?.find(j=>j.key===y.SupportLink)?.value}function z(B){return B.indexOf("preview")!==-1}function ee(B){return B.targetPlatform?(0,d.$cp)(B.targetPlatform):$.TargetPlatform.UNDEFINED}function re(B){const j=(0,P.$Ob)(B.versions.map(ee)),W=!!B.tags?.includes(d.$9o),te=j.indexOf($.TargetPlatform.WEB);return W?te===-1&&j.push($.TargetPlatform.WEB):te!==-1&&j.splice(te,1),j}function ce(B,j){for(let W=0;W<B.length;W++){const te=B[W];if(te.version===B[W-1]?.version){let _=W;if(ee(te)===j)for(;_>0&&B[_-1].version===te.version;)_--;_!==W&&(B.splice(W,1),B.splice(_,0,te))}}return B}function q(B,j,W){B.telemetryData={index:j,querySource:W,queryActivityId:B.queryContext?.[r]}}function x(B,j,W,te){const _=B.versions[0],Y={manifest:M(j,l.Manifest),readme:M(j,l.Details),changelog:M(j,l.Changelog),license:M(j,l.License),repository:U(j),download:F(j),icon:M(j,l.Icon),signature:M(j,l.Signature),coreTranslations:C(j)};return{type:"gallery",identifier:{id:(0,h.$Np)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},name:B.extensionName,version:j.version,displayName:B.displayName,publisherId:B.publisher.publisherId,publisher:B.publisher.publisherName,publisherDisplayName:B.publisher.displayName,publisherDomain:B.publisher.domain?{link:B.publisher.domain,verified:!!B.publisher.isDomainVerified}:void 0,publisherSponsorLink:ie(_),description:B.shortDescription??"",installCount:v(B.statistics,"install"),rating:v(B.statistics,"averagerating"),ratingCount:v(B.statistics,"ratingcount"),categories:B.categories||[],tags:B.tags||[],releaseDate:Date.parse(B.releaseDate),lastUpdated:Date.parse(B.lastUpdated),allTargetPlatforms:W,assets:Y,properties:{dependencies:X(j,y.Dependency),extensionPack:X(j,y.ExtensionPack),engine:K(j),localizedLanguages:G(j),targetPlatform:ee(j),isPreReleaseVersion:Q(j)},hasPreReleaseVersion:Q(_),hasReleaseVersion:!0,preview:z(B.flags),isSigned:!!Y.signature,queryContext:te,supportLink:V(_)}}let J=class{constructor(j,W,te,_,Y,ae,ue,ge){this.k=W,this.l=te,this.n=_,this.o=Y,this.q=ae,this.u=ue,this.w=ge;const we=ue.extensionsGallery,Ee=we?.servicePPEUrl&&ge.getValue("_extensionsGallery.enablePPE");this.d=Ee?we.servicePPEUrl:we?.serviceUrl,this.g=Ee?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,I.$jq)(ue.version,ue,this.n,this.w,this.q,j,this.o)}x(j=""){return`${this.d}${j}`}isEnabled(){return!!this.d}async getExtensions(j,W,te){const _=a.CancellationToken.isCancellationToken(W)?{}:W,Y=a.CancellationToken.isCancellationToken(W)?W:te,ae=[],ue=[],ge=[],we=[];let Ee=!0;for(const Se of j){Se.uuid?ue.push(Se.uuid):ae.push(Se.id);const Ie=!!(Se.version||Se.preRelease);ge.push({id:Se.id,uuid:Se.uuid,includePreRelease:Ie}),Se.version&&we.push({id:Se.id,uuid:Se.uuid,version:Se.version}),Ee=Ee&&!!Se.hasPreRelease&&!Ie}if(!ue.length&&!ae.length)return[];let pe=new E().withPage(1,j.length);ue.length&&(pe=pe.withFilter(o.ExtensionId,...ue)),ae.length&&(pe=pe.withFilter(o.ExtensionName,...ae)),(_.queryAllVersions||Ee)&&(pe=pe.withFlags(pe.flags,i.IncludeVersions)),_.source&&(pe=pe.withSource(_.source));const{extensions:be}=await this.z(pe,{targetPlatform:_.targetPlatform??s,includePreRelease:ge,versions:we,compatible:!!_.compatible,productVersion:_.productVersion??{version:this.u.version,date:this.u.date}},Y);return _.source&&be.forEach((Se,Ie)=>q(Se,Ie,_.source)),be}async getCompatibleExtension(j,W,te,_={version:this.u.version,date:this.u.date}){if((0,d.$ep)(j.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(j,W,te))return j;const Y=new E().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,j.identifier.uuid),{extensions:ae}=await this.z(Y,{targetPlatform:te,compatible:!0,includePreRelease:W,productVersion:_},a.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(j,W,te,_={version:this.u.version,date:this.u.date}){if(!(0,d.$fp)(j.properties.targetPlatform,j.allTargetPlatforms,te)||!W&&j.properties.isPreReleaseVersion)return!1;let Y=j.properties.engine;if(!Y){const ae=await this.getManifest(j,a.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");Y=ae.engines.vscode}return(0,c.$1p)(Y,_.version,_.date)}async y(j,W,te,_,Y,ae,ue={version:this.u.version,date:this.u.date}){if(!(0,d.$fp)(ee(W),Y,ae)||te!=="any"&&Q(W)!==(te==="prerelease"))return!1;if(_)try{const ge=await this.E(j,W);if(!(0,c.$1p)(ge,ue.version,ue.date))return!1}catch(ge){return this.l.error(`Error while getting the engine for the version ${W.version}.`,(0,N.$_)(ge)),!1}return!0}async query(j,W){let te=j.text||"";const _=j.pageSize??50;let Y=new E().withPage(1,_);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(o.Category,be||pe),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,pe,be)=>(Y=Y.withFilter(o.Tag,be||pe),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(o.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),Y=Y.withFilter(o.SearchText,te)),Y=Y.withSortBy(d.SortBy.NoneOrRelevance)):j.ids?Y=Y.withFilter(o.ExtensionId,...j.ids):j.names?Y=Y.withFilter(o.ExtensionName,...j.names):Y=Y.withSortBy(d.SortBy.InstallCount),typeof j.sortBy=="number"&&(Y=Y.withSortBy(j.sortBy)),typeof j.sortOrder=="number"&&(Y=Y.withSortOrder(j.sortOrder)),j.source&&(Y=Y.withSource(j.source));const ae=async(Ee,pe)=>{const{extensions:be,total:Se}=await this.z(Ee,{targetPlatform:s,compatible:!1,includePreRelease:!!j.includePreRelease,productVersion:j.productVersion??{version:this.u.version,date:this.u.date}},pe);return be.forEach((Ie,oe)=>q(Ie,(Ee.pageNumber-1)*Ee.pageSize+oe,j.source)),{extensions:be,total:Se}},{extensions:ue,total:ge}=await ae(Y,W),we=async(Ee,pe)=>{if(pe.isCancellationRequested)throw new N.$7;const{extensions:be}=await ae(Y.withPage(Ee+1),pe);return be};return{firstPage:ue,total:ge,pageSize:Y.pageSize,getPage:we}}async z(j,W,te){const _=j.flags;j.flags&i.IncludeLatestVersionOnly&&j.flags&i.IncludeVersions&&(j=j.withFlags(j.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(j.flags&i.IncludeLatestVersionOnly)&&!(j.flags&i.IncludeVersions)&&(j=j.withFlags(j.flags,i.IncludeLatestVersionOnly)),W.versions?.length&&(j=j.withFlags(j.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),j=j.withFlags(j.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:Y,total:ae,context:ue}=await this.B(j,te);if(!(j.flags&i.IncludeLatestVersionOnly)){const pe=[];for(const be of Y){const Se=await this.A(be,W,ue);Se&&pe.push(Se)}return{extensions:pe,total:ae}}const we=[],Ee=new Map;for(let pe=0;pe<Y.length;pe++){const be=Y[pe],Se={id:(0,h.$Np)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Ie=(0,A.$lg)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(de=>(0,h.$Ip)(de,Se))?.includePreRelease;if(W.compatible&&(0,d.$ep)(re(be),W.targetPlatform))continue;const oe=await this.A(be,W,ue);!oe||oe.properties.isPreReleaseVersion&&(!Ie||!oe.hasReleaseVersion)||!oe.properties.isPreReleaseVersion&&oe.properties.targetPlatform!==W.targetPlatform&&oe.hasPreReleaseVersion?Ee.set(be.extensionId,pe):we.push([pe,oe])}if(Ee.size){const pe=new t.$ge,be=new E().withFlags(_&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ee.size).withFilter(o.ExtensionId,...Ee.keys()),{extensions:Se}=await this.z(be,W,te);this.o.publicLog2("galleryService:additionalQuery",{duration:pe.elapsed(),count:Ee.size});for(const Ie of Se){const oe=Ee.get(Ie.identifier.uuid);we.push([oe,Ie])}}return{extensions:we.sort((pe,be)=>pe[0]-be[0]).map(([,pe])=>pe),total:ae}}async A(j,W,te){const _={id:(0,h.$Np)(j.publisher.publisherName,j.extensionName),uuid:j.extensionId},Y=W.versions?.find(we=>(0,h.$Ip)(we,_))?.version,ae=(0,A.$lg)(W.includePreRelease)?W.includePreRelease:!!W.includePreRelease.find(we=>(0,h.$Ip)(we,_))?.includePreRelease,ue=re(j),ge=ce(j.versions,W.targetPlatform);if(W.compatible&&(0,d.$ep)(ue,W.targetPlatform))return null;for(let we=0;we<ge.length;we++){const Ee=ge[we];if(!(Y&&Ee.version!==Y)){if(await this.y((0,h.$Np)(j.publisher.publisherName,j.extensionName),Ee,ae?"any":"release",W.compatible,ue,W.targetPlatform,W.productVersion))return x(j,Ee,ue,te);if(Y&&Ee.version===Y)return null}}return Y||W.compatible?null:x(j,j.versions[0],ue)}async B(j,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,n(i.Unpublished));const te=await this.j,_=JSON.stringify(j.raw),Y={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(_.length)},ae=new t.$ge;let ue,ge,we=0;try{if(ue=await this.k.request({type:"POST",url:this.g&&j.criteria.some(pe=>pe.filterType===o.SearchText)?this.g:this.x("/extensionquery"),data:_,headers:Y},W),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:we};const Ee=await(0,w.$8p)(ue);if(Ee){const pe=Ee.results[0],be=pe.extensions,Se=pe.resultMetadata&&pe.resultMetadata.filter(Ie=>Ie.metadataType==="ResultCount")[0];return we=Se&&Se.metadataItems.filter(Ie=>Ie.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:we,context:{[r]:ue.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(Ee){if((0,N.$6)(Ee))throw ge=d.ExtensionGalleryErrorCode.Cancelled,Ee;{const pe=(0,N.$_)(Ee);throw ge=pe.startsWith("XHR timeout")?d.ExtensionGalleryErrorCode.Timeout:d.ExtensionGalleryErrorCode.Failed,new d.$ip(pe,ge)}}finally{this.o.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(_.length),duration:ae.elapsed(),success:!!ue&&(0,w.$4p)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:ge,count:String(we)})}}async reportStatistic(j,W,te,_){if(!this.isEnabled())return;const Y=O.$o?this.x(`/itemName/${j}.${W}/version/${te}/statType/${_===d.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${j}/extensions/${W}/${te}/stats?statType=${_}`),ae=O.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:Y,headers:ge},a.CancellationToken.None)}catch{}}async download(j,W,te){this.l.trace("ExtensionGalleryService#download",j.identifier.id);const _=(0,h.$Qp)(j),Y=new Date().getTime(),ae=te===d.InstallOperation.Install?"install":te===d.InstallOperation.Update?"update":"",ue=ae?{uri:`${j.assets.download.uri}${L.URI.parse(j.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${j.assets.download.fallbackUri}${L.URI.parse(j.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:j.assets.download,ge=j.queryContext?.[r]?{[r]:j.queryContext[r]}:void 0,we=await this.D(j.identifier.id,ue,l.VSIX,ge?{headers:ge}:void 0);try{await this.q.writeFile(W,we.stream)}catch(Ee){try{await this.q.del(W)}catch(pe){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,N.$_)(pe))}throw new d.$ip((0,N.$_)(Ee),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{..._,duration:new Date().getTime()-Y})}async downloadSignatureArchive(j,W){if(!j.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",j.identifier.id);const te=await this.D(j.identifier.id,j.assets.signature,l.Signature);try{await this.q.writeFile(W,te.stream)}catch(_){try{await this.q.del(W)}catch(Y){this.l.warn(`Error while deleting the file ${W.toString()}`,(0,N.$_)(Y))}throw new d.$ip((0,N.$_)(_),d.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(j,W){if(j.assets.readme){const te=await this.D(j.identifier.id,j.assets.readme,l.Details,{},W);return await(0,w.$7p)(te)||""}return""}async getManifest(j,W){if(j.assets.manifest){const te=await this.D(j.identifier.id,j.assets.manifest,l.Manifest,{},W),_=await(0,w.$7p)(te);return _?JSON.parse(_):null}return null}async C(j,W,te){const _=M(W,l.Manifest);if(!_)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},ae=await this.D(j,_,l.Manifest,{headers:Y});return await(0,w.$8p)(ae)}async getCoreTranslation(j,W){const te=j.assets.coreTranslations.filter(_=>_[0]===W.toUpperCase())[0];if(te){const _=await this.D(j.identifier.id,te[1],te[0]),Y=await(0,w.$7p)(_);return Y?JSON.parse(Y):null}return null}async getChangelog(j,W){if(j.assets.changelog){const te=await this.D(j.identifier.id,j.assets.changelog,l.Changelog,{},W);return await(0,w.$7p)(te)||""}return""}async getAllCompatibleVersions(j,W,te){let _=new E().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);j.identifier.uuid?_=_.withFilter(o.ExtensionId,j.identifier.uuid):_=_.withFilter(o.ExtensionName,j.identifier.id);const{galleryExtensions:Y}=await this.B(_,a.CancellationToken.None);if(!Y.length)return[];const ae=re(Y[0]);if((0,d.$ep)(ae,te))return[];const ue=[];await Promise.all(Y[0].versions.map(async Ee=>{try{await this.y(j.identifier.id,Ee,W?"any":"release",!0,ae,te)&&ue.push(Ee)}catch{}}));const ge=[],we=new Set;for(const Ee of ce(ue,te))we.has(Ee.version)||(we.add(Ee.version),ge.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:Q(Ee)}));return ge}async D(j,W,te,_={},Y=a.CancellationToken.None){const ae=await this.j,ue={type:"GET"},ge={...ae,..._.headers||{}};_={..._,...ue,headers:ge};const we=W.uri,Ee=W.fallbackUri,pe={..._,url:we};try{const be=await this.k.request(pe,Y);if(be.res.statusCode===200)return be;const Se=await(0,w.$7p)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Se}`)}catch(be){if((0,N.$6)(be))throw be;const Se=(0,N.$_)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:j,assetType:te,message:Se});const Ie={..._,url:Ee};return this.k.request(Ie,Y)}}async E(j,W){let te=K(W);if(!te){this.o.publicLog2("galleryService:engineFallback",{extension:j,version:W.version});const _=await this.C(j,W,a.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const j=await this.k.request({type:"GET",url:this.h},a.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,w.$8p)(j),te=[],_={},Y=[];if(W){for(const ae of W.malicious)te.push({id:ae});if(W.migrateToPreRelease)for(const[ae,ue]of Object.entries(W.migrateToPreRelease))(!ue.engine||(0,c.$1p)(ue.engine,this.u.version,this.u.date))&&(_[ae.toLowerCase()]={disallowInstall:!0,extension:{id:ue.id,displayName:ue.displayName,autoMigrate:{storage:!!ue.migrateStorage},preRelease:!0}});if(W.deprecated)for(const[ae,ue]of Object.entries(W.deprecated))ue&&(_[ae.toLowerCase()]=(0,A.$lg)(ue)?{}:ue);if(W.search)for(const ae of W.search)Y.push(ae)}return{malicious:te,deprecated:_,search:Y}}};J=ve([Z(1,w.$2p),Z(2,b.$_j),Z(3,S.$Mi),Z(4,u.$$l),Z(5,m.$_k),Z(6,f.$sk),Z(7,p.$_i)],J);let H=class extends J{constructor(j,W,te,_,Y,ae,ue,ge){super(j,W,te,_,Y,ae,ue,ge)}};e.$lq=H,e.$lq=H=ve([Z(0,g.$cq),Z(1,w.$2p),Z(2,b.$_j),Z(3,S.$Mi),Z(4,u.$$l),Z(5,m.$_k),Z(6,f.$sk),Z(7,p.$_i)],H);let D=class extends J{constructor(j,W,te,_,Y,ae,ue){super(void 0,j,W,te,_,Y,ae,ue)}};e.$mq=D,e.$mq=D=ve([Z(0,w.$2p),Z(1,b.$_j),Z(2,S.$Mi),Z(3,u.$$l),Z(4,m.$_k),Z(5,f.$sk),Z(6,p.$_i)],D)}),define(le[260],he([0,1,108,3,18,16,2,10,14,69,24,5,6,102,22,176,38,17,13,138,21]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;const u=[P.$Pgc,P.$Qgc],t="remoteTunnelSession",s="remoteTunnelIsService";let r=class extends T.$Wc{constructor(l,y,R,k,E,v,C){super(),this.y=l,this.z=y,this.C=R,this.D=v,this.F=C,this.f=new a.$me,this.onDidTokenFailed=this.f.event,this.g=new a.$me,this.onDidChangeTunnelStatus=this.g.event,this.h=new a.$me,this.onDidChangeMode=this.h.event,this.n=P.$Ngc,this.w=!1,this.I=(U,F)=>{F?this.j.error(U):this.j.info(U)},this.j=this.B(k.createLogger((0,g.$gh)(R.logsHome,`${P.$Rgc}.log`),{id:P.$Rgc,name:P.$Sgc})),this.t=new h.$Ch(100),this.B(this.j.onDidChangeLogLevel(U=>this.j.info("Log level changed to "+(0,A.$ok)(U)))),this.B(E.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(v.onDidChangeConfiguration(U=>{u.some(F=>U.affectsConfiguration(F))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=P.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(l){this.s=l,this.g.fire(l)}H(l){n(this.n,l)||(this.n=l,this.S(l),this.h.fire(this.n),l.active?(this.j.info(`Session updated: ${l.session.accountLabel} (${l.session.providerId}) (service=${l.asService})`),l.session.token&&this.j.info(`Session token updated: ${l.session.accountLabel} (${l.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(l){if(this.w)return this.s;this.w=!0,this.H(l);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}J(){if(!this.u){let l;d.$j?l=this.C.appRoot:l=(0,L.$oc)((0,L.$oc)(this.C.appRoot)),this.u=(0,L.$lc)(l,"bin",`${this.z.tunnelApplicationName}${d.$i?".exe":""}`)}return this.u}async startTunnel(l){if(n(this.n,l)&&this.s.type!=="disconnected")return this.s;this.H(l);try{await this.t.trigger(()=>this.L())}catch(y){this.j.error(y)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const l=this.n.asService;this.H(P.$Ngc);try{l&&this.O("uninstallService",["service","uninstall"])}catch(y){this.j.error(y)}}try{await this.O("stop",["kill"])}catch(l){this.j.error(l)}this.G(P.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let l="",y=!1;const R=(F,M)=>{M?this.j.error(F):l+=F,!this.C.isBuilt&&F.startsWith("   Compiling")&&this.G(P.TunnelStates.connecting((0,m.localize)(0,null)))},k=this.O("status",["status"],R);this.r=k;try{if(await k,this.r!==k)return;let F;try{F=JSON.parse(l.trim().split(`
`).find(M=>M.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(l.trim())}`),this.G(P.TunnelStates.disconnected());return}if(y=F.service_installed,this.j.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.n.active){this.G(P.TunnelStates.disconnected());return}}catch(F){this.j.error(F),this.G(P.TunnelStates.disconnected());return}finally{this.r===k&&(this.r=void 0)}const E=this.n.active?this.n.session:void 0;if(E&&E.token){const F=E.token;this.G(P.TunnelStates.connecting((0,m.localize)(1,null,E.accountLabel,E.providerId)));const M=(K,Q)=>{K=K.replaceAll(F,"*".repeat(4)),R(K,Q)},X=this.O("login",["user","login","--provider",E.providerId,"--log",(0,A.$ok)(this.j.getLevel())],M,{VSCODE_CLI_ACCESS_TOKEN:F});this.r=X;try{if(await X,this.r!==X)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(E),this.G(P.TunnelStates.disconnected(E));return}}const v=this.Q();v?this.G(P.TunnelStates.connecting((0,m.localize)(2,null,v))):this.G(P.TunnelStates.connecting((0,m.localize)(3,null)));const C=["--accept-server-license-terms","--log",(0,A.$ok)(this.j.getLevel())];v?C.push("--name",v):C.push("--random-name");let U=!1;return this.n.active&&this.n.asService&&!y&&(U=await this.M(C)===!1),this.N(E,C,U)}async M(l){let y;try{y=await this.O("serviceInstall",["service","install",...l])}catch(R){this.j.error(R),y=1}if(y!==0){const R=(0,m.localize)(4,null);return this.j.warn(R),this.G(P.TunnelStates.connecting(R)),!1}return!0}async N(l,y,R){y.push("--parent-process-id",String(process.pid)),this.P()&&y.push("--no-sleep");let k=!1;const E=this.O("tunnel",y,(v,C)=>{C?this.j.error(v):this.j.info(v),v.includes("Connected to an existing tunnel process")&&(k=!0);const U=v.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(U){const F={link:U[1],domain:U[2],tunnelName:U[4],isAttached:k};this.G(P.TunnelStates.connected(F,R))}else v.match(/error refreshing token/)&&(E.cancel(),this.f.fire(l),this.G(P.TunnelStates.disconnected(l)))});this.r=E,E.finally(()=>{E===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=P.$Ngc,this.G(P.TunnelStates.disconnected()))})}O(l,y,R=this.I,k){return(0,h.$sh)(E=>new Promise((v,C)=>{E.isCancellationRequested&&v(-1);let U;const F=["ignore","pipe","pipe"];if(E.onCancellationRequested(()=>{U&&(this.j.info(`${l} terminating(${U.pid})`),U.kill())}),!this.C.isBuilt)R(`Building tunnel CLI from sources and run
`,!1),R(`${l} Spawning: cargo run -- tunnel ${y.join(" ")}
`,!1),U=(0,p.spawn)("cargo",["run","--","tunnel",...y],{cwd:(0,L.$lc)(this.C.appRoot,"cli"),stdio:F,env:{...process.env,RUST_BACKTRACE:"1",...k}});else{R(`Running tunnel CLI
`,!1);const M=this.J();R(`${l} Spawning: ${M} tunnel ${y.join(" ")}
`,!1),U=(0,p.spawn)(M,["tunnel",...y],{cwd:(0,b.homedir)(),stdio:F,env:{...process.env,...k}})}U.stdout.pipe(new I.$uX(`
`)).on("data",M=>{if(U){const X=M.toString();R(X,!1)}}),U.stderr.pipe(new I.$uX(`
`)).on("data",M=>{if(U){const X=M.toString();R(X,!0)}}),U.on("exit",M=>{U&&(R(`${l} exit(${U.pid}): + ${M} `,!1),U=void 0,v(M||0))}),U.on("error",M=>{U&&(R(`${l} error(${U.pid}): + ${M} `,!0),U=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(P.$Qgc)}Q(){let l=this.D.getValue(P.$Pgc)||(0,b.hostname)();return l=l.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),l||void 0}R(){try{const l=this.F.get(t,f.StorageScope.APPLICATION),y=this.F.getBoolean(s,f.StorageScope.APPLICATION,!1);if(l){const R=JSON.parse(l);if(R&&(0,w.$fg)(R.accountLabel)&&(0,w.$fg)(R.sessionId)&&(0,w.$fg)(R.providerId))return{active:!0,session:R,asService:y};this.j.error("Problems restoring session from storage, invalid format",R)}}catch(l){this.j.error("Problems restoring session from storage",l)}return P.$Ngc}S(l){if(l.active){const y={providerId:l.session.providerId,sessionId:l.session.sessionId,accountLabel:l.session.accountLabel};this.F.store(t,JSON.stringify(y),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),this.F.store(s,l.asService,f.StorageScope.APPLICATION,f.StorageTarget.MACHINE)}else this.F.remove(t,f.StorageScope.APPLICATION),this.F.remove(s,f.StorageScope.APPLICATION)}};e.$Wgc=r,e.$Wgc=r=ve([Z(0,N.$$l),Z(1,S.$sk),Z(2,O.$Ni),Z(3,A.$ak),Z(4,$.$Ugc),Z(5,c.$_i),Z(6,f.$cq)],r);function i(o,l){return o&&l?o.sessionId===l.sessionId&&o.providerId===l.providerId&&o.token===l.token:o===l}const n=(o,l)=>o.active!==l.active?!1:o.active&&l.active?o.asService===l.asService&&i(o.session,l.session):!0}),define(le[261],he([0,1,6,2,23,21,71,17,80,20]),function(ne,e,P,a,N,O,T,A,L,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=void 0;class S extends A.$eq{constructor(h,$,c,m){super(),this.bb=h,this.cb=$,this.db=c,this.eb=m,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new a.$Vc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new a.$Vc),this.ab=this.hb(this.bb)}fb(){const h=this.B(new L.$aMb(this.db.getChannel("storage"))),$=this.B(new T.$$p(h));return this.B($.onDidChangeStorage(c=>this.u(A.StorageScope.APPLICATION,c))),$}gb(h){this.X.clear(),this.W=h;let $;if((0,A.$fq)(h))$=this.U;else{const c=this.X.add(new L.$bMb(this.db.getChannel("storage"),h));$=this.X.add(new T.$$p(c))}return this.X.add($.onDidChangeStorage(c=>this.u(A.StorageScope.PROFILE,c))),$}hb(h){this.$.clear(),this.Z=h?.id;let $;if(h){const c=this.$.add(new L.$cMb(this.db.getChannel("storage"),h));$=this.$.add(new T.$$p(c)),this.$.add($.onDidChangeStorage(m=>this.u(A.StorageScope.WORKSPACE,m)))}return $}async O(){await P.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(h){switch(h){case A.StorageScope.APPLICATION:return this.U;case A.StorageScope.PROFILE:return this.Y;default:return this.ab}}Q(h){switch(h){case A.StorageScope.APPLICATION:return this.s.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;case A.StorageScope.PROFILE:return this.W?.globalStorageHome.with({scheme:N.Schemas.file}).fsPath;default:return this.Z?`${(0,O.$gh)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:N.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(A.WillSaveStateReason.SHUTDOWN),await P.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(h){if(!this.M(this.W,h))return;const $=this.Y,c=$.items;$!==this.U&&await $.close(),this.Y=this.gb(h),await this.Y.init(),this.N(c,this.Y,A.StorageScope.PROFILE)}async S(h,$){const c=this.ab,m=c?.items??new Map;await c?.close(),this.ab=this.hb(h),await this.ab.init(),this.N(m,this.ab,A.StorageScope.WORKSPACE)}hasScope(h){return(0,p.$Kl)(h)?this.W.id===h.id:this.Z===h.id}}e.$2gc=S}),define(le[262],he([0,1,3,2,20,95]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rR=e.$qR=void 0;class T{constructor(p,S){this.a=p,this.b=S}listen(p,S){const d=this.b(p);switch(S){case"onDidChangeProfiles":return P.Event.map(this.a.onDidChangeProfiles,h=>({all:h.all.map($=>(0,O.$Ln)({...$},d)),added:h.added.map($=>(0,O.$Ln)({...$},d)),removed:h.removed.map($=>(0,O.$Ln)({...$},d)),updated:h.updated.map($=>(0,O.$Ln)({...$},d))}))}throw new Error(`Invalid listen ${S}`)}async call(p,S,d){const h=this.b(p);switch(S){case"createProfile":{const $=await this.a.createProfile(d[0],d[1],d[2]);return(0,O.$Ln)({...$},h)}case"updateProfile":{let $=(0,N.$Ml)((0,O.$Mn)(d[0],h),this.a.profilesHome.scheme);return $=await this.a.updateProfile($,d[1]),(0,O.$Ln)({...$},h)}case"removeProfile":{const $=(0,N.$Ml)((0,O.$Mn)(d[0],h),this.a.profilesHome.scheme);return this.a.removeProfile($)}}throw new Error(`Invalid call ${S}`)}}e.$qR=T;class A extends a.$Wc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(p,S,d){super(),this.profilesHome=S,this.f=d,this.a=[],this.b=this.B(new P.$me),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=p.map(h=>(0,N.$Ml)(h,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(h=>{const $=h.added.map(b=>(0,N.$Ml)(b,this.profilesHome.scheme)),c=h.removed.map(b=>(0,N.$Ml)(b,this.profilesHome.scheme)),m=h.updated.map(b=>(0,N.$Ml)(b,this.profilesHome.scheme));this.a=h.all.map(b=>(0,N.$Ml)(b,this.profilesHome.scheme)),this.b.fire({added:$,removed:c,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(p){this.c=p}isEnabled(){return this.c}async createNamedProfile(p,S,d){const h=await this.f.call("createNamedProfile",[p,S,d]);return(0,N.$Ml)(h,this.profilesHome.scheme)}async createProfile(p,S,d,h){const $=await this.f.call("createProfile",[p,S,d,h]);return(0,N.$Ml)($,this.profilesHome.scheme)}async createTransientProfile(p){const S=await this.f.call("createTransientProfile",[p]);return(0,N.$Ml)(S,this.profilesHome.scheme)}async setProfileForWorkspace(p,S){await this.f.call("setProfileForWorkspace",[p,S])}removeProfile(p){return this.f.call("removeProfile",[p])}async updateProfile(p,S){const d=await this.f.call("updateProfile",[p,S]);return(0,N.$Ml)(d,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$rR=A}),define(le[62],he([0,1,2,71,4,17,3,80,20]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gMb=e.$fMb=e.$eMb=void 0,e.$eMb=(0,N.$Fi)("IUserDataProfileStorageService");let p=class extends P.$Wc{constructor($){super(),this.a=$}async readStorageData($){return this.withProfileScopedStorageService($,async c=>this.b(c))}async updateStorageData($,c,m){return this.withProfileScopedStorageService($,async b=>this.c(b,c,m))}async withProfileScopedStorageService($,c){if(this.a.hasScope($))return c(this.a);const m=await this.g($),b=new d(m);try{await b.initialize();const f=await c(b);return await b.flush(),f}finally{b.dispose(),await this.f(m)}}b($){const c=new Map,m=b=>{for(const f of $.keys(O.StorageScope.PROFILE,b))c.set(f,{value:$.get(f,O.StorageScope.PROFILE),target:b})};return m(O.StorageTarget.USER),m(O.StorageTarget.MACHINE),c}c($,c,m){$.storeAll(Array.from(c.entries()).map(([b,f])=>({key:b,value:f,scope:O.StorageScope.PROFILE,target:m})),!0)}async f($){try{await $.close()}finally{(0,P.$Qc)($)&&$.dispose()}}};e.$fMb=p,e.$fMb=p=ve([Z(0,O.$cq)],p);class S extends p{constructor($,c,m,b){super(m),this.j=$;const f=$.getChannel("profileStorageListener"),w=this.B(new P.$Xc);this.h=this.B(new T.$me({onWillAddFirstListener:()=>{w.value=f.listen("onDidChange")(I=>{b.trace("profile storage changes",I),this.h.fire({targetChanges:I.targetChanges.map(g=>(0,L.$Ml)(g,c.profilesHome.scheme)),valueChanges:I.valueChanges.map(g=>({...g,profile:(0,L.$Ml)(g.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>w.value=void 0})),this.onDidChange=this.h.event}async g($){const c=this.j.getChannel("storage");return(0,O.$fq)($)?new A.$aMb(c):new A.$bMb(c,$)}}e.$gMb=S;class d extends O.$eq{constructor($){super({flushInterval:100}),this.s=this.B(new a.$$p($))}O(){return this.s.init()}P($){return $===O.StorageScope.PROFILE?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[263],he([0,1,17,10,20,58,62]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;let A=class extends T.$gMb{constructor(p,S,d,h){super(p,S,d,h)}};e.$Ggc=A,e.$Ggc=A=ve([Z(0,O.$bgc),Z(1,N.$Ll),Z(2,P.$cq),Z(3,a.$_j)],A)}),define(le[40],he([0,1,19,6,15,26,3,34,2,27,13,181,22,16,7,10,50,17,18,29,25,20]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nNb=e.$mNb=e.$lNb=e.$kNb=void 0,e.$hNb=t,e.$iNb=s,e.$jNb=r;function t(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||s(y.syncData)))}function s(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}function r(y,R){return`${(0,p.$0f)(y)}${R.isDefault?"":` (${R.name})`}`}let i=class extends L.$Wc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(R,k,E,v,C,U,F,M,X,K,Q,G){super(),this.syncResource=R,this.collection=k,this.G=E,this.H=v,this.I=C,this.J=U,this.L=F,this.M=M,this.N=X,this.O=K,this.P=Q,this.c=null,this.m=g.SyncStatus.Idle,this.n=this.B(new T.$me),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new T.$me),this.onDidChangeConflicts=this.t.event,this.u=this.B(new a.$Dh(50)),this.w=this.B(new T.$me),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=r(R.syncResource,R.profile),this.h=G.extUri,this.f=this.h.joinPath(v.userDataSyncHome,...(0,g.$Tmb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource)),this.g=this.h.joinPath(this.f,g.$cnb),this.y=(0,g.$Umb)(R.profile.isDefault?void 0:R.profile.id,R.syncResource,v,this.h),this.j=(0,b.$iq)(v,E,C)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status===g.SyncStatus.HasConflicts){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const R=await this.c;this.c=null;const k=await this.Y(R.remoteUserData,R.lastSyncUserData,!0,this.ob());this.S(k)}else{this.O.trace(`${this.D}: Checking for local changes...`);const R=await this.getLastSyncUserData();(R?await this.ub(R):!0)&&this.w.fire()}}S(R){this.m!==R&&(this.m=R,this.n.fire(R))}async sync(R,k={}){await this.U(R,!0,this.ob(),k)}async preview(R,k,E={}){return this.U(R,!1,k,E)}async apply(R,k={}){try{this.F={...k};const E=await this.ab(R);return this.S(E),this.c}finally{this.F={}}}async U(R,k,E,v){try{if(this.F={...v},this.status===g.SyncStatus.HasConflicts)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status===g.SyncStatus.Syncing)return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);let C=g.SyncStatus.Idle;try{const U=await this.getLastSyncUserData(),F=await this.X(R,U);return C=await this.Y(F,U,k,E),C===g.SyncStatus.HasConflicts?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):C===g.SyncStatus.Idle&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(C)}}finally{this.F={}}}async replace(R){const k=this.kb(R);if(!k)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S(g.SyncStatus.Syncing);const E=await this.getLastSyncUserData(),v=await this.X(null,E),C=await this.W(v),U=await this.qb({ref:v.ref,syncData:k},E,C,this.ob(),O.CancellationToken.None),F=[];for(const M of U){const X=await this.sb(M,M.remoteResource,void 0,O.CancellationToken.None),{remoteChange:K}=await this.sb(M,M.previewResource,M.remoteContent,O.CancellationToken.None);F.push([M,{...X,remoteChange:K!==g.Change.None?K:g.Change.Modified}])}await this.tb(v,E,F,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S(g.SyncStatus.Idle)}return!0}async W(R){const k=await this.j;return!!R.syncData?.machineId&&R.syncData.machineId===k}async X(R,k){if(k){const E=R?R[this.resource]:void 0;if(k.ref===E||E===void 0&&k.syncData===null)return k}return this.getRemoteUserData(k)}async Y(R,k,E,v){if(R.syncData&&R.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new g.$2mb((0,d.localize)(0,null,this.resource,this.pb,R.syncData.version),g.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.Z(R,k,E,v)}catch(C){if(C instanceof g.$2mb)switch(C.code){case g.UserDataSyncErrorCode.LocalPreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(R,k,E,v);case g.UserDataSyncErrorCode.Conflict:case g.UserDataSyncErrorCode.PreconditionFailed:return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),R=await this.getRemoteUserData(null),k=await this.getLastSyncUserData(),this.Y(R,k,E,v)}throw C}}async Z(R,k,E,v){try{const C=await this.W(R),U=!C&&k===null&&this.gb()!==void 0,F=E&&!U;this.c||(this.c=(0,a.$sh)(X=>this.eb(R,k,C,F,v,X)));let M=await this.c;if(E&&U){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const X of M.resourcePreviews)M=await this.accept(X.remoteResource)||M}return this.cb(M.resourcePreviews),M.resourcePreviews.some(({mergeState:X})=>X===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:E?await this.ab(!1):g.SyncStatus.Syncing}catch(C){throw this.c=null,C}}async merge(R){return await this.$(R,async k=>{const E=await this.rb(k,O.CancellationToken.None);await this.G.writeFile(k.previewResource,N.$Oe.fromString(E?.content||""));const v=E&&!E.hasConflicts?await this.sb(k,k.previewResource,void 0,O.CancellationToken.None):void 0;return k.acceptResult=v,k.mergeState=E.hasConflicts?g.MergeState.Conflict:v?g.MergeState.Accepted:g.MergeState.Preview,k.localChange=v?v.localChange:E.localChange,k.remoteChange=v?v.remoteChange:E.remoteChange,k}),this.c}async accept(R,k){return await this.$(R,async E=>{const v=await this.sb(E,R,k,O.CancellationToken.None);return E.acceptResult=v,E.mergeState=g.MergeState.Accepted,E.localChange=v.localChange,E.remoteChange=v.remoteChange,E}),this.c}async discard(R){return await this.$(R,async k=>{const E=await this.rb(k,O.CancellationToken.None);return await this.G.writeFile(k.previewResource,N.$Oe.fromString(E.content||"")),k.acceptResult=void 0,k.mergeState=g.MergeState.Preview,k.localChange=E.localChange,k.remoteChange=E.remoteChange,k}),this.c}async $(R,k){if(!this.c)return;let E=await this.c;const v=E.resourcePreviews.findIndex(({localResource:C,remoteResource:U,previewResource:F})=>this.h.isEqual(C,R)||this.h.isEqual(U,R)||this.h.isEqual(F,R));v!==-1&&(this.c=(0,a.$sh)(async C=>{const U=[...E.resourcePreviews];return U[v]=await k(U[v]),{...E,resourcePreviews:U}}),E=await this.c,this.cb(E.resourcePreviews),E.resourcePreviews.some(({mergeState:C})=>C===g.MergeState.Conflict)?this.S(g.SyncStatus.HasConflicts):this.S(g.SyncStatus.Syncing))}async ab(R){if(!this.c)return g.SyncStatus.Idle;const k=await this.c;return k.resourcePreviews.some(({mergeState:E})=>E===g.MergeState.Conflict)?g.SyncStatus.HasConflicts:k.resourcePreviews.some(({mergeState:E})=>E!==g.MergeState.Accepted)?g.SyncStatus.Syncing:(await this.tb(k.remoteUserData,k.lastSyncUserData,k.resourcePreviews.map(E=>[E,E.acceptResult]),R),this.c=null,await this.bb(),g.SyncStatus.Idle)}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(R){const k=R.filter(({mergeState:E})=>E===g.MergeState.Conflict);(0,P.$wb)(this.s,k,(E,v)=>this.h.isEqual(E.previewResource,v.previewResource))||(this.s=k,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const R=await this.getLastSyncUserData();return!!R&&R.syncData!==null}async db(R){const k=this.c?await this.c:null;if(k)for(const E of k.resourcePreviews){if(this.h.isEqual(E.acceptedResource,R))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,R))return E.remoteContent;if(this.h.isEqual(E.localResource,R))return E.localContent;if(this.h.isEqual(E.baseResource,R))return E.baseContent}return null}async resetLocal(){this.I.remove(this.z,f.StorageScope.APPLICATION);try{await this.G.del(this.y)}catch(R){(0,c.$ql)(R)!==c.FileOperationResult.FILE_NOT_FOUND&&this.O.error(R)}}async eb(R,k,E,v,C,U){const F=await this.qb(R,k,E,C,U),M=[];for(const X of F){const K=X.previewResource.with({scheme:g.$bnb,authority:"accepted"});if(X.localChange===g.Change.None&&X.remoteChange===g.Change.None)M.push({...X,acceptedResource:K,acceptResult:{content:null,localChange:g.Change.None,remoteChange:g.Change.None},mergeState:g.MergeState.Accepted});else{const Q=v?await this.rb(X,U):void 0;if(U.isCancellationRequested)break;await this.G.writeFile(X.previewResource,N.$Oe.fromString(Q?.content||""));const G=Q&&!Q.hasConflicts?await this.sb(X,X.previewResource,void 0,U):void 0;M.push({...X,acceptResult:G,mergeState:Q?.hasConflicts?g.MergeState.Conflict:G?g.MergeState.Accepted:g.MergeState.Preview,localChange:G?G.localChange:Q?Q.localChange:X.localChange,remoteChange:G?G.remoteChange:Q?Q.remoteChange:X.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:R,lastSyncUserData:k,resourcePreviews:M,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let R=this.gb();if(R||(R=await this.jb()),!R)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const k=JSON.parse(R),E=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!k.version&&!!E&&k.version!==E,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${k.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let v,C=1;for(;v===void 0&&C++<6;)try{const U=await this.hb();U&&(U.ref===k.ref?v=U.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(U){if(U instanceof c.$ul&&U.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(U instanceof g.$2mb)throw U;this.O.error(U,C)}}if(v===void 0)try{const U=await this.J.resolveResourceContent(this.resource,k.ref,this.collection,this.F);v=U===null?null:this.kb(U),await this.ib({ref:k.ref,syncData:v})}catch(U){if(U instanceof g.$2mb&&U.code===g.UserDataSyncErrorCode.NotFound)this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw U}return v===void 0?null:{...k,syncData:v}}async fb(R,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const E=this.M.getResourceSyncStateVersion(this.resource),v={ref:R.ref,version:E,...k};this.I.store(this.z,JSON.stringify(v),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib(R)}gb(){return this.I.get(this.z,f.StorageScope.APPLICATION)}async hb(){const R=(await this.G.readFile(this.y)).value.toString();try{const k=R?JSON.parse(R):void 0;if(t(k))return k}catch(k){this.O.error(k)}}async ib(R){await this.G.writeFile(this.y,N.$Oe.fromString(JSON.stringify(R)))}async jb(){try{const R=await this.G.readFile(this.y),k=JSON.parse(R.value.toString());await this.G.del(this.y),k.ref&&k.content!==void 0?(this.I.store(this.z,JSON.stringify({...k,content:void 0}),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.ib({ref:k.ref,syncData:k.content===null?null:JSON.parse(k.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,k)}catch(R){R instanceof c.$ul&&R.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(R)}return this.I.get(this.z,f.StorageScope.APPLICATION)}async getRemoteUserData(R){const{ref:k,content:E}=await this.lb(R);let v=null;return E!==null&&(v=this.kb(E)),{ref:k,syncData:v}}kb(R){try{const k=JSON.parse(R);if(s(k))return k}catch(k){this.O.error(k)}throw new g.$2mb((0,d.localize)(1,null),g.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async lb(R){const k=R?{ref:R.ref,content:R.syncData?JSON.stringify(R.syncData):null}:null;return this.J.readResource(this.resource,k,this.collection,this.F)}async mb(R,k){const E=await this.j,v={version:this.pb,machineId:E,content:R};try{return k=await this.J.writeResource(this.resource,JSON.stringify(v),k,this.collection,this.F),{ref:k,syncData:v}}catch(C){throw C instanceof g.$2mb&&C.code===g.UserDataSyncErrorCode.TooLarge&&(C=new g.$2mb(C.message,C.code,this.resource)),C}}async nb(R){const k={version:this.pb,content:R};return this.L.writeResource(this.resource,JSON.stringify(k),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!==g.SyncStatus.Idle&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S(g.SyncStatus.Idle),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(g.$Omb)}};e.$kNb=i,e.$kNb=i=ve([Z(2,c.$_k),Z(3,$.$Mi),Z(4,f.$cq),Z(5,g.$Wmb),Z(6,g.$Xmb),Z(7,g.$7mb),Z(8,w.$$l),Z(9,g.$_mb),Z(10,h.$_i),Z(11,I.$Jl)],i);let n=class extends i{constructor(R,k,E,v,C,U,F,M,X,K,Q,G,ie){super(k,E,v,C,U,F,M,X,K,Q,G,ie),this.r=R,this.B(this.G.watch(this.h.dirname(R))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(R,k,E){try{k?await this.G.writeFile(this.r,N.$Oe.fromString(R),E?void 0:k):await this.G.createFile(this.r,N.$Oe.fromString(R),{overwrite:E})}catch(v){throw v instanceof c.$ul&&v.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND||v instanceof c.$ul&&v.fileOperationResult===c.FileOperationResult.FILE_MODIFIED_SINCE?new g.$2mb(v.message,g.UserDataSyncErrorCode.LocalPreconditionFailed):v}}async xb(){try{await this.G.del(this.r)}catch(R){if(!(R instanceof c.$ul&&R.fileOperationResult===c.FileOperationResult.FILE_NOT_FOUND))throw R}}yb(R){R.contains(this.r)&&this.Q()}};e.$lNb=n,e.$lNb=n=ve([Z(3,c.$_k),Z(4,$.$Mi),Z(5,f.$cq),Z(6,g.$Wmb),Z(7,g.$Xmb),Z(8,g.$7mb),Z(9,w.$$l),Z(10,g.$_mb),Z(11,h.$_i),Z(12,I.$Jl)],n);let o=class extends n{constructor(R,k,E,v,C,U,F,M,X,K,Q,G,ie,V){super(R,k,E,v,C,U,F,M,X,K,Q,ie,V),this.zb=G,this.Bb=void 0}Ab(R,k){const E=[],v=(0,A.$Vn)(R,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,S.$mg)(v)&&k!==Array.isArray(v)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$mNb=o,e.$mNb=o=ve([Z(3,c.$_k),Z(4,$.$Mi),Z(5,f.$cq),Z(6,g.$Wmb),Z(7,g.$Xmb),Z(8,g.$7mb),Z(9,w.$$l),Z(10,g.$_mb),Z(11,g.$$mb),Z(12,h.$_i),Z(13,I.$Jl)],o);let l=class{constructor(R,k,E,v,C,U,F){this.resource=R,this.g=k,this.h=E,this.j=v,this.k=C,this.l=U,this.d=F.extUri,this.f=(0,g.$Umb)(void 0,this.resource,E,this.d)}async initialize({ref:R,content:k}){if(!k){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(k);if(E)try{await this.o({ref:R,syncData:E})}catch(v){this.j.error(v)}}m(R){try{const k=JSON.parse(R);if(s(k))return k}catch(k){this.j.error(k)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(R,k={}){if(k.ref||k.version)throw new Error("Cannot have core properties as additional");const E={ref:R.ref,version:void 0,...k};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),f.StorageScope.APPLICATION,f.StorageTarget.MACHINE),await this.k.writeFile(this.f,N.$Oe.fromString(JSON.stringify(R)))}};e.$nNb=l,e.$nNb=l=ve([Z(1,u.$Ll),Z(2,$.$Mi),Z(3,m.$_j),Z(4,c.$_k),Z(5,f.$cq),Z(6,I.$Jl)],l)}),define(le[120],he([0,1,6,26,8,3,45,2,27,22,16,119,28,33,86,37,7,4,77,10,17,18,29,20,40,242,115,25,62]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t,s,r,i,n,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=e.$jbc=e.$ibc=void 0,e.$gbc=R,e.$hbc=k;async function y(U,F){const M=JSON.parse(U.content);if(U.version===1||U.version===2){const X=(await F.getInstalled(m.ExtensionType.System)).filter(K=>K.isBuiltin);for(const K of M)U.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),U.version===2&&X.every(Q=>!(0,$.$Ip)(Q.identifier,K.identifier))&&(K.installed=!0)}return M}function R(U){return JSON.parse(U.content)}function k(U,F){return U.sort((M,X)=>!M.identifier.uuid&&X.identifier.uuid?-1:M.identifier.uuid&&!X.identifier.uuid?1:(0,L.$zf)(M.identifier.id,X.identifier.id)),F?(0,T.$7n)(U,{}):JSON.stringify(U)}let E=class extends r.$kNb{constructor(F,M,X,K,Q,G,ie,V,z,ee,re,ce,q,x,J,H,D){super({syncResource:o.SyncResource.Extensions,profile:F},M,K,X,Q,G,ie,ce,q,ee,re,J),this.Cb=V,this.Db=z,this.Eb=D,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$bnb,authority:"base"}),this.yb=this.wb.with({scheme:o.$bnb,authority:"local"}),this.zb=this.wb.with({scheme:o.$bnb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$bnb,authority:"accepted"}),this.Bb=this.Eb.createInstance(v),this.B(O.Event.any(O.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:j})=>!!j)),O.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),O.Event.filter(H.onDidChange,B=>B.valueChanges.some(({profile:j,changes:W})=>this.syncResource.profile.id===j.id&&W.some(te=>te.key===h.$lp))),x.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(F,M){const X=F.syncData?await y(F.syncData,this.Cb):null,K=M?.skippedExtensions??[],Q=M?.builtinExtensions??null,G=M?.syncData?await y(M.syncData,this.Cb):null,{localExtensions:ie,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);X?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:ee}=(0,i.$fbc)(ie,X,G,K,V,Q),re={local:z,remote:ee,content:this.Hb(ie,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ee!==null?o.Change.Modified:o.Change.None},ce=this.Ob(ie,!1);return[{skippedExtensions:K,builtinExtensions:Q,baseResource:this.xb,baseContent:G?this.Ob(G,!1):ce,localResource:this.yb,localContent:ce,localExtensions:ie,remoteResource:this.zb,remoteExtensions:X,remoteContent:X?this.Ob(X,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(F){const M=F.syncData?await y(F.syncData,this.Cb):null,{localExtensions:X,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,i.$fbc)(X,M,M,F.skippedExtensions||[],K,F.builtinExtensions||[]);return Q!==null}Hb(F,M,X,K){const Q=[...M,...X],G=new Set,ie=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};Q.forEach(({identifier:V})=>ie(V)),K.forEach(ie);for(const V of F)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||Q.push(V);return this.Ob(Q,!1)}async rb(F,M){return{...F.previewResult,hasConflicts:!1}}async sb(F,M,X,K){if(this.h.isEqual(M,this.yb))return this.Kb(F);if(this.h.isEqual(M,this.zb))return this.Lb(F);if(this.h.isEqual(M,this.wb))return F.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Kb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(M),K=(0,i.$fbc)(F.localExtensions,null,null,F.skippedExtensions,X,F.builtinExtensions),{local:Q,remote:G}=K;return{content:F.localContent,local:Q,remote:G,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:G!==null?o.Change.Modified:o.Change.None}}async Lb(F){const M=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),X=this.Db.getIgnoredExtensions(M),K=F.remoteContent?JSON.parse(F.remoteContent):null;if(K!==null){const Q=(0,i.$fbc)(F.localExtensions,K,F.localExtensions,[],X,F.builtinExtensions),{local:G,remote:ie}=Q;return{content:F.remoteContent,local:G,remote:ie,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?o.Change.Modified:o.Change.None,remoteChange:ie!==null?o.Change.Modified:o.Change.None}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:o.Change.None,remoteChange:o.Change.None}}async tb(F,M,X,K){let{skippedExtensions:Q,builtinExtensions:G,localExtensions:ie}=X[0][0];const{local:V,remote:z,localChange:ee,remoteChange:re}=X[0][1];if(ee===o.Change.None&&re===o.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ee!==o.Change.None&&(await this.nb(JSON.stringify(ie)),Q=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,Q,this.syncResource.profile)),z){this.O.trace(`${this.D}: Updating remote extensions...`);const ce=JSON.stringify(z.all);F=await this.mb(ce,K?null:F.ref),this.O.info(`${this.D}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(q=>q.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(q=>q.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(q=>q.identifier.id))}.`:""}`)}M?.ref!==F.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(ie,G),await this.fb(F,{skippedExtensions:Q,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ce=>ce.identifier.id))}.`:""}`))}Nb(F,M){const X=new Set,K=[];for(const Q of F)X.add(Q.identifier.id.toLowerCase()),Q.installed||K.push(Q.identifier);if(M)for(const Q of M)X.has(Q.id.toLowerCase())||K.push(Q);return K}async resolveContent(F){if(this.h.isEqual(this.zb,F)||this.h.isEqual(this.xb,F)||this.h.isEqual(this.yb,F)||this.h.isEqual(this.Ab,F)){const M=await this.db(F);return M&&this.Ob(JSON.parse(M),!0)}return null}Ob(F,M){return k(F,M)}async hasLocalData(){try{const{localExtensions:F}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(F.some(M=>M.installed||M.disabled))return!0}catch{}return!1}};e.$ibc=E,e.$ibc=E=ve([Z(2,S.$Mi),Z(3,b.$_k),Z(4,g.$cq),Z(5,o.$Wmb),Z(6,o.$Xmb),Z(7,h.$kp),Z(8,n.$9Nb),Z(9,o.$_mb),Z(10,p.$_i),Z(11,o.$7mb),Z(12,u.$$l),Z(13,c.$jw),Z(14,t.$Jl),Z(15,l.$eMb),Z(16,f.$Ei)],E);let v=class{constructor(F,M,X,K,Q,G){this.a=F,this.b=M,this.c=X,this.d=K,this.f=Q,this.g=G}async getLocalExtensions(F){const M=await this.a.getInstalled(void 0,F.extensionsResource),X=this.d.getIgnoredExtensions(M);return{localExtensions:await this.j(F,async(Q,G)=>{const ie=Q.getDisabledExtensions();return M.map(V=>{const{identifier:z,isBuiltin:ee,manifest:re,preRelease:ce,pinned:q,isApplicationScoped:x}=V,J={identifier:z,preRelease:ce,version:re.version,pinned:!!q};x&&!(0,m.$tn)(re)&&(J.isApplicationScoped=x),ie.some(H=>(0,$.$Ip)(H,z))&&(J.disabled=!0),ee||(J.installed=!0);try{const H=G.getKeysForSync({id:z.id,version:re.version});if(H){const D=G.getExtensionState(V,!0)||{};J.state=Object.keys(D).reduce((B,j)=>(H.includes(j)&&(B[j]=D[j]),B),{})}}catch(H){this.g.info(`${(0,r.$jNb)(o.SyncResource.Extensions,F)}: Error while parsing extension state`,(0,N.$_)(H))}return J})}),ignoredExtensions:X}}async updateLocalExtensions(F,M,X,K,Q){const G=(0,r.$jNb)(o.SyncResource.Extensions,Q),ie=[],V=new Map,z=[],ee=[],re=await this.a.getInstalled(void 0,Q.extensionsResource);if((F.length||X.length)&&await this.j(Q,async(x,J)=>{await P.Promises.settled([...F,...X].map(async H=>{const D=re.find(W=>(0,$.$Ip)(W.identifier,H.identifier));if(D&&D.isBuiltin){H.state&&D.manifest.version===H.version&&this.h(H.state,D,D.manifest.version,J),x.getDisabledExtensions().some(te=>(0,$.$Ip)(te,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id),await x.disableExtension(H.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id),await x.enableExtension(H.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id))),z.push(H.identifier);return}const B=H.pinned?H.version:void 0,j=(await this.c.getExtensions([{...H.identifier,version:B,preRelease:B?void 0:H.preRelease}],a.CancellationToken.None))[0];if(H.state&&(D?D.manifest.version===H.version:j)&&this.h(H.state,D||j,D?.manifest.version,J),j)try{x.getDisabledExtensions().some(te=>(0,$.$Ip)(te,H.identifier))!==!!H.disabled&&(H.disabled?(this.g.trace(`${G}: Disabling extension...`,H.identifier.id,j.version),await x.disableExtension(j.identifier),this.g.info(`${G}: Disabled extension`,H.identifier.id,j.version)):(this.g.trace(`${G}: Enabling extension...`,H.identifier.id,j.version),await x.enableExtension(j.identifier),this.g.info(`${G}: Enabled extension`,H.identifier.id,j.version))),(!D||D.preRelease!==H.preRelease||D.pinned!==H.pinned||B&&D.manifest.version!==B)&&(await this.a.canInstall(j)?(ie.push({extension:j,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:H.pinned&&!!H.version,pinned:H.pinned,installPreReleaseVersion:H.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:H.isApplicationScoped,context:{[h.$0o]:!0,[h.$$o]:h.ExtensionInstallSource.SETTINGS_SYNC}}}),V.set(j.identifier.id.toLowerCase(),H)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,j.displayName||j.identifier.id),ee.push(H)))}catch(W){ee.push(H),this.g.error(W),this.g.info(`${G}: Skipped synchronizing extension`,j.displayName||j.identifier.id)}else ee.push(H),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,H.identifier.id)}))}),M.length){const x=re.filter(({identifier:J,isBuiltin:H})=>!H&&M.some(D=>(0,$.$Ip)(J,D)));await P.Promises.settled(x.map(async J=>{this.g.trace(`${G}: Uninstalling local extension...`,J.identifier.id),await this.a.uninstall(J,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,J.identifier.id),z.push(J.identifier)}))}const ce=await this.a.installGalleryExtensions(ie);for(const{identifier:x,local:J,error:H,source:D}of ce){const B=D;if(J)this.g.info(`${G}: Installed extension.`,x.id,B.version),z.push(x);else{const j=V.get(x.id.toLowerCase());j&&(ee.push(j),this.g.info(`${G}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),H instanceof h.$jp&&[h.ExtensionManagementErrorCode.Incompatible,h.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(H.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):H&&this.g.error(H)}}const q=[];for(const x of K)z.some(J=>(0,$.$Ip)(J,x.identifier))||q.push(x);for(const x of ee)q.some(J=>(0,$.$Ip)(J.identifier,x.identifier))||q.push(x);return q}h(F,M,X,K){const Q=K.getExtensionState(M,!0)||{},G=X?K.getKeysForSync({id:M.identifier.id,version:X}):void 0;G?G.forEach(ie=>{Q[ie]=F[ie]}):Object.keys(F).forEach(ie=>Q[ie]=F[ie]),K.setExtensionState(M,Q,!0)}async j(F,M){return this.b.withProfileScopedStorageService(F,async X=>{const K=new A.$Vc,Q=K.add(this.f.createChild(new w.$Di([g.$cq,X]))),G=K.add(Q.createInstance(d.$CLb)),ie=K.add(Q.createInstance(c.$kw));try{return await M(G,ie)}finally{K.dispose()}})}};e.$jbc=v,e.$jbc=v=ve([Z(0,h.$kp),Z(1,l.$eMb),Z(2,h.$hp),Z(3,n.$9Nb),Z(4,f.$Ei),Z(5,o.$_mb)],v);let C=class extends r.$nNb{constructor(F,M,X,K,Q,G,ie,V){super(o.SyncResource.Extensions,K,Q,G,X,ie,V),this.p=F,this.q=M}async t(F){return F.syncData?await y(F.syncData,this.p):null}u(F,M){const X=[],K=[],Q=[];for(const G of F){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const ie=M.find(V=>(0,$.$Ip)(V.identifier,G.identifier));ie?(X.push(ie),G.disabled&&Q.push(G.identifier)):G.installed&&(K.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&Q.push(G.identifier))}return{installedExtensions:X,newExtensions:K,disabledExtensions:Q,remoteExtensions:F}}};e.$kbc=C,e.$kbc=C=ve([Z(0,h.$kp),Z(1,n.$9Nb),Z(2,b.$_k),Z(3,s.$Ll),Z(4,S.$Mi),Z(5,I.$_j),Z(6,g.$cq),Z(7,t.$Jl)],C)}),define(le[121],he([0,1,15,8,3,34,45,5,32,22,16,7,10,50,17,18,29,40,82,246,25,20,62,4]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tNb=e.$sNb=e.$rNb=e.$qNb=void 0,e.$pNb=n;const r="globalState.argv.",i=["locale"];function n(E,v){const C=E.storage?Object.keys(E.storage).sort():[],U={};return C.forEach(F=>U[F]=E.storage[F]),E.storage=U,v?(0,T.$7n)(E,{}):JSON.stringify(E)}const o=1;let l=class extends f.$kNb{constructor(v,C,U,F,M,X,K,Q,G,ie,V,z,ee,re){super({syncResource:g.SyncResource.GlobalState,profile:v},C,F,Q,z,M,X,G,ie,K,V,ee),this.Bb=U,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:g.$bnb,authority:"base"}),this.xb=this.vb.with({scheme:g.$bnb,authority:"local"}),this.yb=this.vb.with({scheme:g.$bnb,authority:"remote"}),this.zb=this.vb.with({scheme:g.$bnb,authority:"accepted"}),this.Ab=re.createInstance(y),this.B(F.watch(this.h.dirname(this.H.argvResource))),this.B(N.Event.any(N.Event.filter(F.onDidFilesChange,ce=>ce.contains(this.H.argvResource)),N.Event.filter(U.onDidChange,ce=>!!(ce.targetChanges.some(q=>this.syncResource.profile.id===q.id)||ce.valueChanges.some(({profile:q,changes:x})=>this.syncResource.profile.id===q.id&&x.some(J=>J.target===c.StorageTarget.USER)))))(()=>this.Q()))}async qb(v,C,U){const F=v.syncData?JSON.parse(v.syncData.content):null;C=C===null&&U?v:C;const M=C&&C.syncData?JSON.parse(C.syncData.content):null,X=await this.Ab.getLocalGlobalState(this.syncResource.profile);F?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(M),{local:Q,remote:G}=(0,I.$oNb)(X.storage,F?F.storage:null,M?M.storage:null,K,this.O),ie={content:null,local:Q,remote:G,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:G.all!==null?g.Change.Modified:g.Change.None},V=n(X,!1);return[{baseResource:this.wb,baseContent:M?n(M,!1):V,localResource:this.xb,localContent:V,localUserData:X,remoteResource:this.yb,remoteContent:F?n(F,!1):null,previewResource:this.vb,previewResult:ie,localChange:ie.localChange,remoteChange:ie.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(C===null)return!0;const U=await this.Ab.getLocalGlobalState(this.syncResource.profile),F=await this.Jb(C),{remote:M}=(0,I.$oNb)(U.storage,C.storage,C.storage,F,this.O);return M.all!==null}async rb(v,C){return{...v.previewResult,hasConflicts:!1}}async sb(v,C,U,F){if(this.h.isEqual(C,this.xb))return this.Gb(v);if(this.h.isEqual(C,this.yb))return this.Hb(v);if(this.h.isEqual(C,this.vb))return v.previewResult;throw new Error(`Invalid Resource: ${C.toString()}`)}async Gb(v){return{content:v.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(v.localUserData.storage),removed:[],updated:[],all:v.localUserData.storage},localChange:g.Change.None,remoteChange:g.Change.Modified}}async Hb(v){if(v.remoteContent!==null){const C=JSON.parse(v.remoteContent),{local:U,remote:F}=(0,I.$oNb)(v.localUserData.storage,C.storage,null,v.storageKeys,this.O);return{content:v.remoteContent,local:U,remote:F,localChange:Object.keys(U.added).length>0||Object.keys(U.updated).length>0||U.removed.length>0?g.Change.Modified:g.Change.None,remoteChange:F!==null?g.Change.Modified:g.Change.None}}else return{content:v.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:g.Change.None,remoteChange:g.Change.None}}async tb(v,C,U,F){const{localUserData:M}=U[0][0],{local:X,remote:K,localChange:Q,remoteChange:G}=U[0][1];if(Q===g.Change.None&&G===g.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Q!==g.Change.None&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(M)),await this.Ab.writeLocalGlobalState(X,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==g.Change.None){this.O.trace(`${this.D}: Updating remote ui state...`);const ie=JSON.stringify({storage:K.all});v=await this.mb(ie,F?null:v.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}C?.ref!==v.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(v),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(v){if(this.h.isEqual(this.yb,v)||this.h.isEqual(this.wb,v)||this.h.isEqual(this.xb,v)||this.h.isEqual(this.zb,v)){const C=await this.db(v);return C&&n(JSON.parse(C),!0)}return null}async hasLocalData(){try{const{storage:v}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(v).length>1||v[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(v){const C=await this.Bb.readStorageData(this.syncResource.profile),U=[],F=[];for(const[K,Q]of C)Q.target===c.StorageTarget.USER?U.push(K):Q.target===c.StorageTarget.MACHINE&&F.push(K);const M=[...U,...F],X=v?.storage?Object.keys(v.storage).filter(K=>!K.startsWith(r)&&!M.includes(K)&&C.get(K)!==void 0):[];if(!A.$o){const K=[...g.$Smb.map(Q=>(0,g.$6mb)(Q)),g.$5mb];X.push(...K),F.push(...K)}return{user:U,machine:F,unregistered:X}}};e.$qNb=l,e.$qNb=l=ve([Z(2,t.$eMb),Z(3,d.$_k),Z(4,g.$Wmb),Z(5,g.$Xmb),Z(6,g.$_mb),Z(7,S.$Mi),Z(8,g.$7mb),Z(9,m.$$l),Z(10,p.$_i),Z(11,c.$cq),Z(12,b.$Jl),Z(13,s.$Ei)],l);let y=class{constructor(v,C,U,F){this.a=v,this.b=C,this.c=U,this.d=F}async getLocalGlobalState(v){const C={};if(v.isDefault){const F=await this.f(),M=(0,O.$Vn)(F);for(const X of i)M[X]!==void 0&&(C[`${r}${X}`]={version:1,value:M[X]})}const U=await this.c.readStorageData(v);for(const[F,M]of U)M.value&&M.target===c.StorageTarget.USER&&(C[F]={version:1,value:M.value});return{storage:C}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const v=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),v.value.toString()}catch(v){this.d.debug((0,a.$_)(v))}return"{}"}async writeLocalGlobalState({added:v,removed:C,updated:U},F){const M=(0,f.$jNb)(g.SyncResource.GlobalState,F),X={},K=new Map,Q=await this.c.readStorageData(F),G=(ie,V)=>{for(const z of ie){if(z.startsWith(r)){X[z.substring(r.length)]=V?V[z].value:void 0;continue}if(V){const ee=V[z];ee.value!==Q.get(z)?.value&&K.set(z,ee.value)}else Q.get(z)!==void 0&&K.set(z,void 0)}};if(G(Object.keys(v),v),G(Object.keys(U),U),G(C),Object.keys(X).length){this.d.trace(`${M}: Updating locale...`);const ie=await this.f();let V=ie;for(const z of Object.keys(X))V=(0,w.edit)(V,[z],X[z],{});ie!==V&&(this.d.trace(`${M}: Updating locale...`),await this.a.writeFile(this.b.argvResource,P.$Oe.fromString(V)),this.d.info(`${M}: Updated locale.`)),this.d.info(`${M}: Updated locale`)}K.size&&(this.d.trace(`${M}: Updating global state...`),await this.c.updateStorageData(F,K,c.StorageTarget.USER),this.d.info(`${M}: Updated global state`,[...K.keys()]))}};e.$rNb=y,e.$rNb=y=ve([Z(0,d.$_k),Z(1,S.$Mi),Z(2,t.$eMb),Z(3,g.$_mb)],y);let R=class extends f.$nNb{constructor(v,C,U,F,M,X){super(g.SyncResource.GlobalState,U,F,M,C,v,X)}async o(v){const C=v.syncData?JSON.parse(v.syncData.content):null;if(!C){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const U={},F={};for(const M of Object.keys(C.storage))M.startsWith(r)?U[M.substring(r.length)]=C.storage[M].value:this.l.get(M,c.StorageScope.PROFILE)===void 0&&(F[M]=C.storage[M].value);if(Object.keys(U).length){let M="{}";try{M=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const X of Object.keys(U))M=(0,w.edit)(M,[X],U[X],{});await this.k.writeFile(this.h.argvResource,P.$Oe.fromString(M))}if(Object.keys(F).length){const M=[];for(const X of Object.keys(F))M.push({key:X,value:F[X],scope:c.StorageScope.PROFILE,target:c.StorageTarget.USER});this.l.storeAll(M,!0)}}};e.$sNb=R,e.$sNb=R=ve([Z(0,c.$cq),Z(1,d.$_k),Z(2,u.$Ll),Z(3,S.$Mi),Z(4,g.$_mb),Z(5,b.$Jl)],R);let k=class{constructor(v,C,U,F,M){this.a=v,this.b=C,this.c=U,this.d=F,this.f=M}getSyncStoreType(v){return this.h(v)?.storage[g.$5mb]?.value}async sync(v){const C=(0,g.$1mb)((0,L.$2g)());try{return await this.g(v,C)}catch(U){if(U instanceof g.$2mb)switch(U.code){case g.UserDataSyncErrorCode.PreconditionFailed:return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(v,C)}throw U}}async g(v,C){const U=await this.a.readResource(g.SyncResource.GlobalState,null,void 0,C),F=this.h(U)||{storage:{}};F.storage[g.$5mb]={value:v,version:o};const M=await(0,$.$iq)(this.c,this.d,this.b),X={version:o,machineId:M,content:n(F,!1)};await this.a.writeResource(g.SyncResource.GlobalState,JSON.stringify(X),U.ref,void 0,C)}h({content:v}){if(!v)return null;const C=JSON.parse(v);if((0,f.$iNb)(C))return C?JSON.parse(C.content):null;throw new Error("Invalid remote data")}};e.$tNb=k,e.$tNb=k=ve([Z(1,c.$cq),Z(2,S.$Mi),Z(3,d.$_k),Z(4,h.$_j)],k)}),define(le[122],he([0,1,19,15,3,34,5,13,182,22,16,7,17,18,29,20,40,243,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=e.$nbc=void 0,e.$mbc=I;function I(t,s,r){try{const i=JSON.parse(t);if(!s)return(0,A.$mg)(i.all)?null:i.all;switch(T.OS){case T.OperatingSystem.Macintosh:return(0,A.$mg)(i.mac)?null:i.mac;case T.OperatingSystem.Linux:return(0,A.$mg)(i.linux)?null:i.linux;case T.OperatingSystem.Windows:return(0,A.$mg)(i.windows)?null:i.windows}}catch(i){return r.error(i),null}}let g=class extends b.$mNb{constructor(s,r,i,n,o,l,y,R,k,E,v,C,U){super(s.keybindingsResource,{syncResource:w.SyncResource.Keybindings,profile:s},r,R,k,E,i,n,y,C,o,v,l,U),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:w.$bnb,authority:"base"}),this.Gb=this.Eb.with({scheme:w.$bnb,authority:"local"}),this.Hb=this.Eb.with({scheme:w.$bnb,authority:"remote"}),this.Ib=this.Eb.with({scheme:w.$bnb,authority:"accepted"}),this.B(N.Event.filter(l.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(s,r,i,n){const o=s.syncData?I(s.syncData.content,n.keybindingsPerPlatform??this.Qb(),this.O):null;r=r===null&&i?s:r;const l=r?this.Ob(r):null,y=await this.vb(),R=await this.Cb();let k=null,E=!1,v=!1,C=!1;if(o){let M=y?y.value.toString():"[]";if(M=M||"[]",this.Ab(M,!0))throw new w.$2mb((0,L.localize)(0,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!l||l!==M||l!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const X=await(0,f.$lbc)(M,o,l,R,this.zb);X.hasChanges&&(k=X.mergeContent,C=X.hasConflicts,E=C||X.mergeContent!==M,v=C||X.mergeContent!==o)}}else y&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),k=y.value.toString(),v=!0);const U={content:C?l:k,localChange:E?y?w.Change.Modified:w.Change.Added:w.Change.None,remoteChange:v?w.Change.Modified:w.Change.None,hasConflicts:C},F=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Fb,baseContent:l,localResource:this.Gb,localContent:F,localChange:U.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:U.remoteChange,previewResource:this.Eb,previewResult:U,acceptedResource:this.Ib}]}async ub(s){const r=this.Ob(s);if(r===null)return!0;const i=await this.vb(),n=i?i.value.toString():"",o=await this.Cb(),l=await(0,f.$lbc)(n||"[]",r,r,o,this.zb);return l.hasConflicts||l.mergeContent!==r}async rb(s,r){return s.previewResult}async sb(s,r,i,n){if(this.h.isEqual(r,this.Gb))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:w.Change.None,remoteChange:w.Change.Modified};if(this.h.isEqual(r,this.Hb))return{content:s.remoteContent,localChange:w.Change.Modified,remoteChange:w.Change.None};if(this.h.isEqual(r,this.Eb))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:w.Change.Modified,remoteChange:w.Change.Modified};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(s,r,i,n){const{fileContent:o}=i[0][0];let{content:l,localChange:y,remoteChange:R}=i[0][1];if(y===w.Change.None&&R===w.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.Ab(l,!0)))throw new w.$2mb((0,L.localize)(1,null),w.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(y!==w.Change.None&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(l||"[]",o,n),this.O.info(`${this.D}: Updated local keybindings`)),R!==w.Change.None){this.O.trace(`${this.D}: Updating remote keybindings...`);const k=this.Pb(l||"[]",s.syncData?.content);s=await this.mb(k,n?null:s.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}r?.ref!==s.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(s,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.vb();if(s){const r=(0,O.$Vn)(s.value.toString());if((0,P.$Nb)(r))return!0}}catch(s){if(s.fileOperationResult!==d.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(s){return this.h.isEqual(this.Hb,s)||this.h.isEqual(this.Fb,s)||this.h.isEqual(this.Gb,s)||this.h.isEqual(this.Ib,s)?this.db(s):null}Ob(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.Qb()?null:I(s.syncData.content,this.Qb(),this.O)}Pb(s,r){let i={};try{i=JSON.parse(r||"{}")}catch(n){this.O.error(n)}switch(this.Qb()?delete i.all:i.all=s,T.OS){case T.OperatingSystem.Macintosh:i.mac=s;break;case T.OperatingSystem.Linux:i.linux=s;break;case T.OperatingSystem.Windows:i.windows=s;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(w.$Pmb)}};e.$nbc=g,e.$nbc=g=ve([Z(2,w.$Wmb),Z(3,w.$Xmb),Z(4,w.$_mb),Z(5,p.$_i),Z(6,w.$7mb),Z(7,d.$_k),Z(8,S.$Mi),Z(9,h.$cq),Z(10,w.$$mb),Z(11,$.$$l),Z(12,c.$Jl)],g);let u=class extends b.$nNb{constructor(s,r,i,n,o,l){super(w.SyncResource.Keybindings,r,i,n,s,o,l)}async o(s){const r=s.syncData?this.p(s.syncData.content):null;if(!r){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,a.$Oe.fromString(r)),await this.n(s)}async i(){try{const s=await this.k.readFile(this.g.defaultProfile.settingsResource),r=(0,O.$Vn)(s.value.toString());return!(0,P.$Nb)(r)}catch(s){return s.fileOperationResult===d.FileOperationResult.FILE_NOT_FOUND}}p(s){try{return I(s,!0,this.j)}catch(r){return this.j.error(r),null}}};e.$obc=u,e.$obc=u=ve([Z(0,d.$_k),Z(1,m.$Ll),Z(2,S.$Mi),Z(3,w.$_mb),Z(4,h.$cq),Z(5,c.$Jl)],u)}),define(le[123],he([0,1,15,3,183,22,78,16,28,7,17,18,29,20,40,247,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=void 0,e.$pbc=w;function f(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function w(u){const t=JSON.parse(u);return f(t)?t:{settings:u}}let I=class extends c.$mNb{constructor(t,s,r,i,n,o,l,y,R,k,E,v,C,U){super(t.settingsResource,{syncResource:b.SyncResource.Settings,profile:t},s,r,i,n,o,l,E,v,y,R,k,U),this.Eb=C,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:b.$bnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$bnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$bnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$bnb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const s=await this.getLastSyncUserData(),r=await this.X(t,s),i=this.Lb(r),n=new T.$Lo(b.$Omb,this.O);return i?.settings&&n.parse(i.settings),n.configurationModel.getValue(b.$Omb)||{}}async qb(t,s,r){const i=await this.vb(),n=await this.Cb(),o=this.Lb(t);s=s===null&&r?t:s;const l=s?this.Lb(s):null,y=await this.Pb();let R=null,k=!1,E=!1,v=!1;if(o){let M=i?i.value.toString().trim():"{}";M=M||"{}",this.Qb(M),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const X=(0,m.$XLb)(M,o.settings,l?l.settings:null,y,[],n);R=X.localContent||X.remoteContent,k=X.localContent!==null,E=X.remoteContent!==null,v=X.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),R=i.value.toString().trim()||"{}",this.Qb(R),E=!0);const C=i?i.value.toString():null,U=l?.settings??null,F={content:v?U:R,localChange:k?b.Change.Modified:b.Change.None,remoteChange:E?b.Change.Modified:b.Change.None,hasConflicts:v};return[{fileContent:i,baseResource:this.baseResource,baseContent:U,localResource:this.localResource,localContent:C,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async ub(t){const s=this.Lb(t);if(s===null)return!0;const r=await this.vb(),i=r?r.value.toString().trim():"",n=await this.Pb(),o=await this.Cb();return(0,m.$XLb)(i||"{}",s.settings,s.settings,n,[],o).remoteContent!==null}async rb(t,s){const r=await this.Cb(),i=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,m.$WLb)(t.previewResult.content,"{}",i,r):null}}async sb(t,s,r,i){const n=await this.Cb(),o=await this.Pb();if(this.h.isEqual(s,this.localResource))return{content:t.fileContent?(0,m.$WLb)(t.fileContent.value.toString(),"{}",o,n):null,localChange:b.Change.None,remoteChange:b.Change.Modified};if(this.h.isEqual(s,this.remoteResource))return{content:t.remoteContent!==null?(0,m.$WLb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:b.Change.Modified,remoteChange:b.Change.None};if(this.h.isEqual(s,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,m.$WLb)(r,t.fileContent?t.fileContent.value.toString():"{}",o,n):null,localChange:b.Change.Modified,remoteChange:b.Change.Modified};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(t,s,r,i){const{fileContent:n}=r[0][0];let{content:o,localChange:l,remoteChange:y}=r[0][1];if(l===b.Change.None&&y===b.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),l!==b.Change.None&&(this.O.trace(`${this.D}: Updating local settings...`),n&&await this.nb(JSON.stringify(this.Nb(n.value.toString()))),await this.wb(o,n,i),await this.P.reloadConfiguration(O.ConfigurationTarget.USER_LOCAL),this.O.info(`${this.D}: Updated local settings`)),y!==b.Change.None){const R=await this.Cb(),k=this.Lb(t),E=await this.Pb(o);o=(0,m.$WLb)(o,k?k.settings:"{}",E,R),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),i?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}s?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,m.$YLb)(t.value.toString())}catch(t){if(t.fileOperationResult!==p.FileOperationResult.FILE_NOT_FOUND)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let s=await super.db(t);if(s){const r=await this.Cb(),i=await this.Pb();s=(0,m.$WLb)(s,"{}",i,r)}return s}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return w(t)}catch(s){this.O.error(s)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const r=this.B(a.Event.any(a.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:n})=>!!n)),a.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{r.dispose(),this.Ob=void 0}))}const s=await this.Ob;return(0,m.$ULb)(s,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new b.$2mb((0,N.localize)(0,null),b.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}};e.$qbc=I,e.$qbc=I=ve([Z(2,p.$_k),Z(3,A.$Mi),Z(4,S.$cq),Z(5,b.$Wmb),Z(6,b.$Xmb),Z(7,b.$_mb),Z(8,b.$$mb),Z(9,O.$_i),Z(10,b.$7mb),Z(11,d.$$l),Z(12,L.$kp),Z(13,h.$Jl)],I);let g=class extends c.$nNb{constructor(t,s,r,i,n,o){super(b.SyncResource.Settings,s,r,i,t,n,o)}async o(t){const s=t.syncData?this.p(t.syncData.content):null;if(!s){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,P.$Oe.fromString(s.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,m.$YLb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===p.FileOperationResult.FILE_NOT_FOUND}}p(t){try{return w(t)}catch(s){this.j.error(s)}return null}};e.$rbc=g,e.$rbc=g=ve([Z(0,p.$_k),Z(1,$.$Ll),Z(2,A.$Mi),Z(3,b.$_mb),Z(4,S.$cq),Z(5,h.$Jl)],g)}),define(le[124],he([0,1,15,3,30,22,16,7,17,18,29,20,40,244,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=e.$vbc=void 0,e.$ubc=m;function m(w){return JSON.parse(w.content)}let b=class extends h.$kNb{constructor(I,g,u,t,s,r,i,n,o,l,y,R){super({syncResource:c.SyncResource.Snippets,profile:I},g,t,u,s,r,i,l,y,n,o,R),this.pb=1,this.vb=I.snippetsHome,this.B(this.G.watch(u.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(a.Event.filter(this.G.onDidFilesChange,k=>k.affects(this.vb))(()=>this.Q()))}async qb(I,g,u){const t=await this.Hb(),s=this.Gb(t),r=I.syncData?this.Fb(I.syncData):null;g=g===null&&u?I:g;const i=g&&g.syncData?this.Fb(g.syncData):null;r?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,$.$sbc)(s,r,i);return this.Bb(n,t,r||{},i||{})}async ub(I){const g=I.syncData?this.Fb(I.syncData):null;if(g===null)return!0;const u=await this.Hb(),t=this.Gb(u),s=(0,$.$sbc)(t,g,g);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async rb(I,g){return I.previewResult}async sb(I,g,u,t){if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$bnb,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:c.Change.None,remoteChange:I.fileContent?I.remoteContent!==null?c.Change.Modified:c.Change.Added:c.Change.Deleted};if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$bnb,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?c.Change.Modified:c.Change.Added:c.Change.Deleted,remoteChange:c.Change.None};if(this.h.isEqualOrParent(g,this.g))return u===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:u,localChange:u===null?I.fileContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified,remoteChange:u===null?I.remoteContent!==null?c.Change.Deleted:c.Change.None:c.Change.Modified};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(I,g,u,t){const s=u.map(([r,i])=>({...r,acceptResult:i}));s.every(({localChange:r,remoteChange:i})=>r===c.Change.None&&i===c.Change.None)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==c.Change.None)&&(await this.Cb(s),await this.Db(s,t)),s.some(({remoteChange:r})=>r!==c.Change.None)&&(I=await this.Eb(s,I,t)),g?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.G.del(r)}catch{}}Bb(I,g,u,t){const s=new Map;for(const r of Object.keys(I.local.added)){const i={content:I.local.added[r],hasConflicts:!1,localChange:c.Change.Added,remoteChange:c.Change.None};s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of Object.keys(I.local.updated)){const i={content:I.local.updated[r],hasConflicts:!1,localChange:c.Change.Modified,remoteChange:c.Change.None},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of I.local.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.Deleted,remoteChange:c.Change.None},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of Object.keys(I.remote.added)){const i={content:I.remote.added[r],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Added},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of Object.keys(I.remote.updated)){const i={content:I.remote.updated[r],hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Modified},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:g[r],localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of I.remote.removed){const i={content:null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.Deleted};s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:u[r],previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of I.conflicts){const i={content:t[r]??null,hasConflicts:!0,localChange:g[r]?c.Change.Modified:c.Change.Added,remoteChange:u[r]?c.Change.Modified:c.Change.Added},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:g[r]||null,localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:u[r]||null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}for(const r of Object.keys(g))if(!s.has(r)){const i={content:g[r]?g[r].value.toString():null,hasConflicts:!1,localChange:c.Change.None,remoteChange:c.Change.None},n=g[r]?g[r].value.toString():null;s.set(r,{baseResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"base"}),baseContent:t[r]??null,localResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"local"}),fileContent:g[r]||null,localContent:n,remoteResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"remote"}),remoteContent:u[r]||null,previewResource:this.h.joinPath(this.g,r),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,r).with({scheme:c.$bnb,authority:"accepted"})})}return[...s.values()]}async resolveContent(I){return this.h.isEqualOrParent(I,this.g.with({scheme:c.$bnb,authority:"remote"}))||this.h.isEqualOrParent(I,this.g.with({scheme:c.$bnb,authority:"local"}))||this.h.isEqualOrParent(I,this.g.with({scheme:c.$bnb,authority:"base"}))||this.h.isEqualOrParent(I,this.g.with({scheme:c.$bnb,authority:"accepted"}))?this.db(I):null}async hasLocalData(){try{const I=await this.Hb();if(Object.keys(I).length)return!0}catch{}return!1}async Cb(I){const g={};for(const u of I)u.fileContent&&(g[this.h.basename(u.localResource)]=u.fileContent);await this.nb(JSON.stringify(this.Gb(g)))}async Db(I,g){for(const{fileContent:u,acceptResult:t,localResource:s,remoteResource:r,localChange:i}of I)if(i!==c.Change.None){const n=r?this.h.basename(r):this.h.basename(s),o=this.h.joinPath(this.vb,n);i===c.Change.Deleted?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):i===c.Change.Added?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,P.$Oe.fromString(t.content),{overwrite:g}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,P.$Oe.fromString(t.content),g?void 0:u),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(I,g,u){const t=g.syncData?this.Fb(g.syncData):{},s=(0,N.$co)(t);for(const{acceptResult:r,localResource:i,remoteResource:n,remoteChange:o}of I)if(o!==c.Change.None){const l=i?this.h.basename(i):this.h.basename(n);o===c.Change.Deleted?delete s[l]:s[l]=r.content}return(0,$.$tbc)(t,s)||(this.O.trace(`${this.D}: Updating remote snippets...`),g=await this.mb(JSON.stringify(s),u?null:g.ref),this.O.info(`${this.D}: Updated remote snippets`)),g}Fb(I){return m(I)}Gb(I){const g={};for(const u of Object.keys(I))g[u]=I[u].value.toString();return g}async Hb(){const I={};let g;try{g=await this.G.resolve(this.vb)}catch(u){if(u instanceof A.$ul&&u.fileOperationResult===A.FileOperationResult.FILE_NOT_FOUND)return I;throw u}for(const u of g.children||[]){const t=u.resource,s=this.h.extname(t);if(s===".json"||s===".code-snippets"){const r=this.h.relativePath(this.vb,t),i=await this.G.readFile(t);I[r]=i}}return I}};e.$vbc=b,e.$vbc=b=ve([Z(2,T.$Mi),Z(3,A.$_k),Z(4,L.$cq),Z(5,c.$Wmb),Z(6,c.$Xmb),Z(7,c.$_mb),Z(8,O.$_i),Z(9,c.$7mb),Z(10,p.$$l),Z(11,S.$Jl)],b);let f=class extends h.$nNb{constructor(I,g,u,t,s,r){super(c.SyncResource.Snippets,g,u,t,I,s,r)}async o(I){const g=I.syncData?JSON.parse(I.syncData.content):null;if(!g){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(g)){const s=g[t];if(s){const r=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(r,P.$Oe.fromString(s)),this.j.info("Created snippet",this.d.basename(r))}}await this.n(I)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(I){return I.fileOperationResult===A.FileOperationResult.FILE_NOT_FOUND}}};e.$wbc=f,e.$wbc=f=ve([Z(0,A.$_k),Z(1,d.$Ll),Z(2,T.$Mi),Z(3,c.$_mb),Z(4,L.$cq),Z(5,S.$Jl)],f)}),define(le[125],he([0,1,15,22,16,7,17,18,29,20,40,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=e.$ybc=void 0,e.$xbc=h;function h(b,f){try{return JSON.parse(b).tasks??null}catch(w){return f.error(w),null}}let $=class extends S.$lNb{constructor(f,w,I,g,u,t,s,r,i,n,o,l){super(f.tasksResource,{syncResource:d.SyncResource.Tasks,profile:f},w,r,i,n,I,g,s,o,u,t,l),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:d.$bnb,authority:"base"}),this.Cb=this.Ab.with({scheme:d.$bnb,authority:"local"}),this.Db=this.Ab.with({scheme:d.$bnb,authority:"remote"}),this.Eb=this.Ab.with({scheme:d.$bnb,authority:"accepted"})}async qb(f,w,I,g){const u=f.syncData?h(f.syncData.content,this.O):null;w=w===null&&I?f:w;const t=w?.syncData?h(w.syncData.content,this.O):null,s=await this.vb();let r=null,i=!1,n=!1,o=!1;if(f.syncData){const R=s?s.value.toString():null;if(!t||t!==R||t!==u){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const k=m(R,u,t);r=k.content,o=k.hasConflicts,i=k.hasLocalChanged,n=k.hasRemoteChanged}}else s&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),r=s.value.toString(),n=!0);const l={content:o?t:r,localChange:i?s?d.Change.Modified:d.Change.Added:d.Change.None,remoteChange:n?d.Change.Modified:d.Change.None,hasConflicts:o},y=s?s.value.toString():null;return[{fileContent:s,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:y,localChange:l.localChange,remoteResource:this.Db,remoteContent:u,remoteChange:l.remoteChange,previewResource:this.Ab,previewResult:l,acceptedResource:this.Eb}]}async ub(f){const w=f?.syncData?h(f.syncData.content,this.O):null;if(w===null)return!0;const I=await this.vb(),g=I?I.value.toString():null,u=m(g,w,w);return u.hasLocalChanged||u.hasRemoteChanged}async rb(f,w){return f.previewResult}async sb(f,w,I,g){if(this.h.isEqual(w,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:d.Change.None,remoteChange:d.Change.Modified};if(this.h.isEqual(w,this.Db))return{content:f.remoteContent,localChange:d.Change.Modified,remoteChange:d.Change.None};if(this.h.isEqual(w,this.Ab))return I===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:I,localChange:d.Change.Modified,remoteChange:d.Change.Modified};throw new Error(`Invalid Resource: ${w.toString()}`)}async tb(f,w,I,g){const{fileContent:u}=I[0][0],{content:t,localChange:s,remoteChange:r}=I[0][1];if(s===d.Change.None&&r===d.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),s!==d.Change.None&&(this.O.trace(`${this.D}: Updating local tasks...`),u&&await this.nb(JSON.stringify(this.Kb(u.value.toString()))),t?await this.wb(t,u,g):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),r!==d.Change.None){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(t));f=await this.mb(i,g?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$ybc=$,e.$ybc=$=ve([Z(2,d.$Wmb),Z(3,d.$Xmb),Z(4,d.$_mb),Z(5,a.$_i),Z(6,d.$7mb),Z(7,O.$_k),Z(8,N.$Mi),Z(9,T.$cq),Z(10,A.$$l),Z(11,L.$Jl)],$);let c=class extends S.$nNb{constructor(f,w,I,g,u,t){super(d.SyncResource.Tasks,w,I,g,f,u,t),this.c=this.g.defaultProfile.tasksResource}async o(f){const w=f.syncData?h(f.syncData.content,this.j):null;if(!w){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,P.$Oe.fromString(w)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$zbc=c,e.$zbc=c=ve([Z(0,O.$_k),Z(1,p.$Ll),Z(2,N.$Mi),Z(3,d.$_mb),Z(4,T.$cq),Z(5,L.$Jl)],c);function m(b,f,w){if(b===null&&f===null&&w===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(b===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const I=w!==b,g=w!==f;return!I&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:I&&!g?{content:b,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!I?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:b,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[126],he([0,1,45,22,16,7,17,18,29,20,40,245,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0,e.$hdc=c,e.$idc=m;let $=class extends S.$kNb{constructor(f,w,I,g,u,t,s,r,i,n,o,l,y){super({syncResource:h.SyncResource.Profiles,profile:f},w,g,u,t,s,r,o,l,i,n,y),this.vb=I,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:h.$bnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.$bnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.$bnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.$bnb,authority:"accepted"}),this.B(I.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?m(f.syncData):null}async getRemoteSyncedProfiles(f){const w=await this.getLastSyncUserData(),I=await this.X(f,w);return I?.syncData?m(I.syncData):null}async qb(f,w,I){if(!this.vb.isEnabled())throw new h.$2mb("Cannot sync profiles because they are disabled",h.UserDataSyncErrorCode.LocalError);const g=f.syncData?m(f.syncData):null,u=w?.syncData?m(w.syncData):null,t=this.Db(),{local:s,remote:r}=(0,d.$fdc)(t,g,u,[]),i={local:s,remote:r,content:u?this.Eb(u):null,localChange:s.added.length>0||s.removed.length>0||s.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:r!==null?h.Change.Modified:h.Change.None},n=c(t,!1);return[{baseResource:this.baseResource,baseContent:u?this.Eb(u):null,localResource:this.localResource,localContent:n,remoteResource:this.remoteResource,remoteContent:g?this.Eb(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const w=f?.syncData?m(f.syncData):null,I=this.Db(),{remote:g}=(0,d.$fdc)(I,w,w,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async rb(f,w){return{...f.previewResult,hasConflicts:!1}}async sb(f,w,I,g){if(this.h.isEqual(w,this.localResource))return this.Ab(f);if(this.h.isEqual(w,this.remoteResource))return this.Bb(f);if(this.h.isEqual(w,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${w.toString()}`)}async Ab(f){const w=this.Db(),I=(0,d.$fdc)(w,null,null,[]),{local:g,remote:u}=I;return{content:f.localContent,local:g,remote:u,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:u!==null?h.Change.Modified:h.Change.None}}async Bb(f){const w=f.remoteContent?JSON.parse(f.remoteContent):null,I=[],g=[];for(const u of this.Db()){const t=w?.find(s=>s.id===u.id);t&&(I.push({id:u.id,name:u.name,collection:t.collection}),g.push(u))}if(w!==null){const u=(0,d.$fdc)(g,w,I,[]),{local:t,remote:s}=u;return{content:f.remoteContent,local:t,remote:s,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?h.Change.Modified:h.Change.None,remoteChange:s!==null?h.Change.Modified:h.Change.None}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:h.Change.None,remoteChange:h.Change.None}}async tb(f,w,I,g){const{local:u,remote:t,localChange:s,remoteChange:r}=I[0][1];s===h.Change.None&&r===h.Change.None&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=I[0][0].remoteProfiles||[];if(i.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new h.$2mb("Too many profiles to sync. Please remove some profiles and try again.",h.UserDataSyncErrorCode.LocalTooManyProfiles);if(s!==h.Change.None&&(await this.nb(c(this.Db(),!1)),await Promise.all(u.removed.map(async n=>{this.O.trace(`${this.D}: Removing '${n.name}' profile...`),await this.vb.removeProfile(n),this.O.info(`${this.D}: Removed profile '${n.name}'.`)})),await Promise.all(u.added.map(async n=>{this.O.trace(`${this.D}: Creating '${n.name}' profile...`),await this.vb.createProfile(n.id,n.name,{shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${n.name}'.`)})),await Promise.all(u.updated.map(async n=>{const o=this.vb.profiles.find(l=>l.id===n.id);o?(this.O.trace(`${this.D}: Updating '${n.name}' profile...`),await this.vb.updateProfile(o,{name:n.name,shortName:n.shortName,icon:n.icon,useDefaultFlags:n.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${n.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${n.id}' to update.`)}))),r!==h.Change.None){this.O.trace(`${this.D}: Updating remote profiles...`);const n=[],o=i.length+(t?.added.length??0)<=20;if(o)for(const l of t?.added||[]){const y=await this.J.createCollection(this.F);n.push(y),i.push({id:l.id,name:l.name,collection:y,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const l of t?.removed||[])i.splice(i.findIndex(({id:y})=>l.id===y),1);for(const l of t?.updated||[]){const y=i.find(({id:R})=>l.id===R);y&&i.splice(i.indexOf(y),1,{...y,id:l.id,name:l.name,shortName:l.shortName,icon:l.icon,useDefaultFlags:l.useDefaultFlags})}try{f=await this.updateRemoteProfiles(i,g?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(l=>l.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(l=>l.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(l=>l.name))}.`:""}`)}catch(l){if(n.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of n)await this.J.deleteCollection(y,this.F)}throw l}for(const l of t?.removed||[])await this.J.deleteCollection(l.collection,this.F)}w?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,w){return this.mb(this.Eb(f),w)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const w=await this.db(f);return w&&(0,P.$7n)(JSON.parse(w),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((w,I)=>w.name.localeCompare(I.name)))}};e.$gdc=$,e.$gdc=$=ve([Z(2,p.$Ll),Z(3,O.$_k),Z(4,N.$Mi),Z(5,T.$cq),Z(6,h.$Wmb),Z(7,h.$Xmb),Z(8,h.$_mb),Z(9,a.$_i),Z(10,h.$7mb),Z(11,A.$$l),Z(12,L.$Jl)],$);function c(b,f){const w=[...b].sort((I,g)=>I.name.localeCompare(g.name)).map(I=>({id:I.id,name:I.name}));return f?(0,P.$7n)(w,{}):JSON.stringify(w)}function m(b){return JSON.parse(b.content)}}),define(le[264],he([0,1,3,2,5,16,17,18,25]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;const p="sync.enable";let S=class extends a.$Wc{constructor(h,$,c,m){super(),this.c=h,this.f=$,this.g=c,this.h=m,this.a=new P.$me,this.onDidChangeEnablement=this.a.event,this.b=new P.$me,this.onDidChangeResourceEnablement=this.b.event,this.B(h.onDidChangeValue(T.StorageScope.APPLICATION,void 0,this.B(new a.$Vc))(b=>this.m(b)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(p,T.StorageScope.APPLICATION,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(h){h&&!this.canToggleEnablement()||(this.f.publicLog2(p,{enabled:h}),this.c.store(p,h,T.StorageScope.APPLICATION,T.StorageTarget.MACHINE))}isResourceEnabled(h){return this.c.getBoolean((0,L.$6mb)(h),T.StorageScope.APPLICATION,!0)}setResourceEnablement(h,$){if(this.isResourceEnabled(h)!==$){const c=(0,L.$6mb)(h);this.j(c,$)}}getResourceSyncStateVersion(h){}j(h,$){this.c.store(h,$,T.StorageScope.APPLICATION,N.$o?T.StorageTarget.USER:T.StorageTarget.MACHINE)}m(h){if(p===h.key){this.a.fire(this.isEnabled());return}const $=L.$Smb.filter(c=>(0,L.$6mb)(c)===h.key)[0];if($){this.b.fire([$,this.isResourceEnabled($)]);return}}};e.$6cc=S,e.$6cc=S=ve([Z(0,T.$cq),Z(1,A.$$l),Z(2,O.$Mi),Z(3,L.$Vmb)],S)}),define(le[265],he([0,1,6,15,67,2,21,22,16,7,20,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$edc=void 0;let h=class extends O.$Wc{constructor(c,m,b,f,w){super(),this.a=c,this.b=m,this.c=b,this.f=f,this.g=w,this.h()}async h(){for(const m of this.g.profiles)for(const b of d.$Smb)try{await this.m(this.j(b,m.isDefault?void 0:m.id))}catch(f){this.f.error(f)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(m){(0,p.$ql)(m)!==p.FileOperationResult.FILE_NOT_FOUND&&this.f.error(m);return}if(c.children){for(const m of c.children)if(m.isDirectory&&!this.g.profiles.some(b=>b.id===m.name))try{this.f.info("Deleting non existing profile from backup",m.resource.path),await this.b.del(m.resource,{recursive:!0})}catch(b){this.f.error(b)}}}async getAllResourceRefs(c,m,b){const f=this.j(c,m,b);try{const w=await this.b.resolve(f);if(w.children)return w.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.n(g)}))}catch(w){if((0,p.$ql)(w)!==p.FileOperationResult.FILE_NOT_FOUND)throw w}return[]}async resolveResourceContent(c,m,b,f){const w=this.j(c,b,f),I=(0,T.$gh)(w,m);try{return(await this.b.readFile(I)).value.toString()}catch(g){return this.f.error(g),null}}async writeResource(c,m,b,f,w){const I=this.j(c,f,w),g=(0,T.$gh)(I,`${(0,N.$3m)(b).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,a.$Oe.fromString(m))}catch(u){this.f.error(u)}}j(c,m,b=this.a.userDataSyncHome){return(0,T.$gh)(b,...m?[m,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const m=await this.b.resolve(c);if(m.children){const b=m.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let w=b.filter(g=>Date.now()-this.n(g)>f);const I=b.length-w.length;I<10&&(w=w.slice(10-I)),await P.Promises.settled(w.map(async g=>{this.f.info("Deleting from backup",g.resource.path),await this.b.del(g.resource)}))}}catch(m){this.f.error(m)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$edc=h,e.$edc=h=ve([Z(0,L.$Mi),Z(1,p.$_k),Z(2,A.$_i),Z(3,d.$_mb),Z(4,S.$Ll)],h)}),define(le[87],he([0,1,3,2,5,27,187,16,7,4,24,50,17,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmb=e.$Jmb=void 0,e.$Kmb=u,e.$Jmb=(0,p.$Fi)("IUserDataSyncMachinesService");const m="sync.currentMachineName",b="Safari",f="Chrome",w="Edge",I="Firefox",g="Android";function u(r){switch(r){case b:case f:case w:case I:case g:case(0,N.$h)(N.Platform.Web):return!0}return!1}function t(){return N.$G?b:N.$E?f:N.$H?w:N.$F?I:N.$I?g:(0,N.$h)(N.$o?N.Platform.Web:N.$u)}let s=class extends a.$Wc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(i,n,o,l,y,R){super(),this.h=o,this.j=l,this.m=y,this.n=R,this.c=this.B(new P.$me),this.onDidChange=this.c.event,this.g=null,this.f=(0,d.$iq)(i,n,o)}async getMachines(i){const n=await this.f;return(await this.s(i)).machines.map(l=>({...l,isCurrent:l.id===n}))}async addCurrentMachine(i){const n=await this.f,o=await this.s(i);o.machines.some(({id:l})=>l===n)||(o.machines.push({id:n,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(i){const n=await this.f,o=await this.s(i),l=o.machines.filter(({id:y})=>y!==n);l.length!==o.machines.length&&(o.machines=l,await this.t(o))}async renameMachine(i,n,o){const l=await this.s(o),y=l.machines.find(({id:R})=>R===i);if(y){y.name=n,await this.t(l);const R=await this.f;i===R&&this.h.store(m,n,h.StorageScope.APPLICATION,h.StorageTarget.MACHINE)}}async setEnablements(i){const n=await this.s();for(const[o,l]of i){const y=n.machines.find(R=>R.id===o);y&&(y.disabled=l?void 0:!0)}await this.t(n)}r(i){const n=this.h.get(m,h.StorageScope.APPLICATION);if(n)return n;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,l=new RegExp(`${(0,O.$if)(o)}\\s#(\\d+)`);let y=0;for(const R of i){const k=l.exec(R.name),E=k?parseInt(k[1]):0;y=E>y?E:y}return`${o} #${y+1}`}async s(i){this.g=await this.u(i);const n=this.w(this.g);if(n.version!==c.a)throw new Error((0,T.localize)(0,null,this.n.nameLong));return n}async t(i){const n=JSON.stringify(i),o=await this.j.writeResource(c.b,n,this.g?.ref||null);this.g={ref:o,content:n},this.c.fire()}async u(i){if(this.g){const n=i&&i.latest?i.latest[c.b]:void 0;if(this.g.ref===n)return this.g;if(n===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(n){this.m.error(n)}return{version:c.a,machines:[]}}};e.$Lmb=s,e.$Lmb=s=c=ve([Z(0,A.$Mi),Z(1,L.$_k),Z(2,h.$cq),Z(3,$.$Wmb),Z(4,$.$_mb),Z(5,S.$sk)],s)}),define(le[266],he([0,1,6,67,41,8,3,2,5,21,9,184,24,17,18,25,83,87]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;const w="sync.disableMachineEventually",I="sync.sessionId",g="sync.storeUrl",u="sync.productQuality";let t=class extends A.$Wc{get n(){const i=this.H.get(g,$.StorageScope.APPLICATION);return i?S.URI.parse(i):void 0}set n(i){i?this.H.store(g,i.toString(),$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(g,$.StorageScope.APPLICATION)}get s(){return this.H.get(u,$.StorageScope.APPLICATION)}set s(i){i?this.H.store(u,i,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE):this.H.remove(u,$.StorageScope.APPLICATION)}constructor(i,n,o,l,y,R,k,E,v,C){super(),this.u=n,this.w=o,this.y=l,this.z=y,this.C=R,this.D=k,this.F=E,this.G=v,this.H=C,this.a=this.B(new A.$Xc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.$me),this.onError=this.h.event,this.S=[],this.f=this.B(new P.$Dh(this.U())),this.j=this.n,this.n=n.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(n.onDidChangeUserDataSyncStore(()=>{(0,p.$_g)(this.n,n.userDataSyncStore?.url)||(this.j=this.n,this.n=n.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(k.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(y.onDidChangeLocal(U=>this.triggerSync([U],!1,!1))),this.B(T.Event.filter(this.y.onDidChangeResourceEnablement,([,U])=>U)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:n}=this.L();i?this.a.value===void 0&&(this.a.value=new s(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(n&&this.C.info(n),this.a.clear()):n&&this.y.isEnabled()&&this.C.info(n))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,a.$3m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,n,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(I,$.StorageScope.APPLICATION),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(l){if(this.C.error(l),n)this.M(!1);else throw l}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const n=m.$2mb.toUserDataSyncError(i);n instanceof m.$4mb&&this.F.publicLog2("autosync/error",{code:n.code,service:this.u.userDataSyncStore.url.toString()}),n.code===m.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):n.code===m.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):n.code===m.UserDataSyncErrorCode.LocalTooManyRequests?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):n.code===m.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):n.code===m.UserDataSyncErrorCode.MethodNotFound?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):n.code===m.UserDataSyncErrorCode.UpgradeRequired||n.code===m.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):n.code===m.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with newer version than of client. Requires client upgrade.`)):n.code===m.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${n.resource} content with older version than of client. Requires server reset.`)):n.code===m.UserDataSyncErrorCode.ServiceChanged||n.code===m.UserDataSyncErrorCode.DefaultServiceChanged?L.$o&&n.code===m.UserDataSyncErrorCode.DefaultServiceChanged&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(n),this.b++),this.h.fire(n)}async P(){this.H.store(w,!0,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),await(0,P.$Gh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(w,$.StorageScope.APPLICATION,!1)}R(){this.H.remove(w,$.StorageScope.APPLICATION)}async triggerSync(i,n,o){if(this.a.value===void 0)return this.f.cancel();if(n&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const l=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:l}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$kdc=t,e.$kdc=t=ve([Z(0,h.$sk),Z(1,m.$Vmb),Z(2,m.$Wmb),Z(3,m.$7mb),Z(4,m.$8mb),Z(5,m.$_mb),Z(6,b.$ELb),Z(7,c.$$l),Z(8,f.$Jmb),Z(9,$.$cq)],t);class s extends A.$Wc{static{this.a="Interval"}constructor(i,n,o,l,y,R,k,E,v){super(),this.m=i,this.n=n,this.r=o,this.s=l,this.u=y,this.w=R,this.y=k,this.z=E,this.C=v,this.b=this.B(new A.$Xc),this.c=this.B(new T.$me),this.onDidStartSync=this.c.event,this.f=this.B(new T.$me),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,A.$Uc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(s.a,!1)}D(){this.b.value=(0,P.$Hh)(()=>{this.sync(s.a,!1),this.b.value=void 0},this.n)}sync(i,n){const o=(0,P.$sh)(async l=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(y){if((0,O.$6)(y))return}return this.H(i,n,l)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,p.$_g)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),n=this.r.userDataSyncStore;return!!n&&!!i&&(!(0,p.$_g)(n.defaultUrl,i.defaultUrl)||!(0,p.$_g)(n.insidersUrl,i.insidersUrl)||!(0,p.$_g)(n.stableUrl,i.stableUrl))}async H(i,n,o){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let l;try{await this.I(n,o)}catch(y){if(this.y.error(y),l=y,m.$2mb.toUserDataSyncError(y).code===m.UserDataSyncErrorCode.MethodNotFound)try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(n,o),l=void 0}catch(R){this.y.error(R),l=R}}this.f.fire(l)}async I(i,n){if(this.h=await this.u.createSyncTask(this.g,i),n.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new m.$4mb((0,d.localize)(0,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$4mb((0,d.localize)(1,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$4mb((0,d.localize)(2,null),m.UserDataSyncErrorCode.TurnedOff);const o=this.C.get(I,$.StorageScope.APPLICATION);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new m.$4mb((0,d.localize)(3,null),m.UserDataSyncErrorCode.DefaultServiceChanged):new m.$4mb((0,d.localize)(4,null),m.UserDataSyncErrorCode.ServiceChanged):new m.$4mb((0,d.localize)(5,null),m.UserDataSyncErrorCode.SessionExpired);const l=await this.w.getMachines(this.g||void 0);if(n.isCancellationRequested)return;const y=l.find(k=>k.isCurrent);if(y?.disabled)throw new m.$4mb((0,d.localize)(6,null),m.UserDataSyncErrorCode.TurnedOff);const R=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-R}),this.g===null)try{this.g=await this.s.manifest(null)}catch(k){throw new m.$4mb((0,N.$qj)(k),k instanceof m.$2mb?k.code:m.UserDataSyncErrorCode.Unknown)}this.g&&this.g.session!==o&&this.C.store(I,this.g.session,$.StorageScope.APPLICATION,$.StorageTarget.MACHINE),!n.isCancellationRequested&&(y||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[267],he([0,1,9,188,16,7,50,17,29,25,20,40,124,123,122,22,125,120,121,4,126,45,27]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;let r=class{static{s=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,o,l,y,R,k,E,v,C,U){this.e=n,this.f=o,this.g=l,this.h=R,this.i=k,this.j=E,this.k=v,this.l=C,this.n=U,this.d=y.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource(p.SyncResource.Profiles,null,void 0);if(n.content){const o=this.L(n.content,p.SyncResource.Profiles);return(0,g.$idc)(o)}return[]}async getLocalSyncedProfiles(n){const o=await this.f.getAllResourceRefs(p.SyncResource.Profiles,void 0,n);if(o.length){const l=await this.f.resolveResourceContent(p.SyncResource.Profiles,o[0].ref,void 0,n);if(l){const y=this.L(l,p.SyncResource.Profiles);return(0,g.$idc)(y)}}return[]}async getLocalSyncedMachines(n){const o=await this.f.getAllResourceRefs("machines",void 0,n);if(o.length){const l=await this.f.resolveResourceContent("machines",o[0].ref,void 0,n);if(l)return JSON.parse(l).machines.map(R=>({...R,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(n,o){return(await this.e.getAllResourceRefs(n,o?.collection)).map(({created:y,ref:R})=>({created:y,uri:this.J({remote:!0,syncResource:n,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:R,node:void 0})}))}async getLocalSyncResourceHandles(n,o,l){return(await this.f.getAllResourceRefs(n,o?.collection,l)).map(({created:R,ref:k})=>({created:R,uri:this.J({remote:!1,syncResource:n,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:k,node:void 0,location:l})}))}resolveUserDataSyncResource({uri:n}){const o=this.K(n),l=o?this.k.profiles.find(y=>y.id===o.profile):void 0;return o&&l?{profile:l,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:n}){const o=this.K(n);if(!o)return[];const l=this.k.profiles.find(y=>y.id===o.profile);switch(o.syncResource){case p.SyncResource.Settings:return this.s(n,l);case p.SyncResource.Keybindings:return this.u(n,l);case p.SyncResource.Tasks:return this.w(n,l);case p.SyncResource.Snippets:return this.y(n,l);case p.SyncResource.GlobalState:return this.D(n,l);case p.SyncResource.Extensions:return this.A(n,l);case p.SyncResource.Profiles:return this.G(n,l);case p.SyncResource.WorkspaceState:return[]}}async getMachineId({uri:n}){const o=this.K(n);if(o){if(o.remote){if(o.ref){const{content:l}=await this.M(o.syncResource,o.ref,o.collection);if(l)return this.L(l,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const l=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(l)return this.L(l,o.syncResource)?.machineId}return}return(0,T.$iq)(this.h,this.j,this.i)}}async resolveContent(n){const o=this.K(n);if(!o||o.node===s.a)return null;if(o.ref){const l=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&l?this.q(o.syncResource,l,o.node):l}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(n,o,l,y,R){if(n){const{content:k}=await this.M(o,y,l);return k}return this.f.resolveResourceContent(o,y,l,R)}q(n,o,l){const y=this.L(o,n);switch(n){case p.SyncResource.Settings:return this.t(y,l);case p.SyncResource.Keybindings:return this.v(y,l);case p.SyncResource.Tasks:return this.x(y,l);case p.SyncResource.Snippets:return this.z(y,l);case p.SyncResource.GlobalState:return this.E(y,l);case p.SyncResource.Extensions:return this.B(y,l);case p.SyncResource.Profiles:return this.H(y,l);case p.SyncResource.WorkspaceState:return null}}async r(n,o){const l=this.k.profiles.find(y=>y.id===o);if(!l)return null;switch(n){case p.SyncResource.GlobalState:return this.F(l);case p.SyncResource.Extensions:return this.C(l);case p.SyncResource.Profiles:return this.I(l);case p.SyncResource.Settings:return null;case p.SyncResource.Keybindings:return null;case p.SyncResource.Tasks:return null;case p.SyncResource.Snippets:return null;case p.SyncResource.WorkspaceState:return null}}s(n,o){const l=this.d.joinPath(n,"settings.json"),y=o?o.settingsResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}t(n,o){switch(o){case"settings.json":return(0,$.$pbc)(n.content).settings}return null}u(n,o){const l=this.d.joinPath(n,"keybindings.json"),y=o?o.keybindingsResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}v(n,o){switch(o){case"keybindings.json":return(0,c.$mbc)(n.content,!!this.l.getValue(p.$Pmb),this.g)}return null}w(n,o){const l=this.d.joinPath(n,"tasks.json"),y=o?o.tasksResource:this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}x(n,o){switch(o){case"tasks.json":return(0,b.$xbc)(n.content,this.g)}return null}async y(n,o){const l=await this.resolveContent(n);if(l){const y=this.L(l,p.SyncResource.Snippets);if(y){const R=(0,h.$ubc)(y),k=[];for(const E of Object.keys(R)){const v=this.d.joinPath(n,E),C=o?this.d.joinPath(o.snippetsHome,E):this.d.joinPath(n,s.a);k.push({resource:v,comparableResource:C})}return k}}return[]}z(n,o){return(0,h.$ubc)(n)[o]||null}A(n,o){const l=this.d.joinPath(n,"extensions.json"),y=o?this.J({remote:!1,syncResource:p.SyncResource.Extensions,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}B(n,o){switch(o){case"extensions.json":return(0,f.$hbc)((0,f.$gbc)(n),!0)}return null}async C(n){const{localExtensions:o}=await this.n.createInstance(f.$jbc).getLocalExtensions(n);return(0,f.$hbc)(o,!0)}D(n,o){const l=this.d.joinPath(n,"globalState.json"),y=o?this.J({remote:!1,syncResource:p.SyncResource.GlobalState,profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,s.a);return[{resource:l,comparableResource:y}]}E(n,o){switch(o){case"globalState.json":return(0,w.$pNb)(JSON.parse(n.content),!0)}return null}async F(n){const o=await this.n.createInstance(w.$rNb).getLocalGlobalState(n);return(0,w.$pNb)(o,!0)}G(n,o){const l=this.d.joinPath(n,"profiles.json"),y=this.J({remote:!1,syncResource:p.SyncResource.Profiles,profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:l,comparableResource:y}]}H(n,o){switch(o){case"profiles.json":return(0,u.$7n)(JSON.parse(n.content),{})}return null}async I(n){return(0,g.$hdc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(n){const o=n.remote?s.b:s.c,l=[];return n.location&&(l.push(`scheme:${n.location.scheme}`),l.push(`authority:${n.location.authority}`),l.push((0,t.$mf)(n.location.path,"/"))),l.push(`syncResource:${n.syncResource}`),l.push(`profile:${n.profile}`),n.collection&&l.push(`collection:${n.collection}`),n.ref&&l.push(`ref:${n.ref}`),n.node&&l.push(n.node),this.d.joinPath(P.URI.from({scheme:p.$bnb,authority:o,path:"/",query:n.location?.query,fragment:n.location?.fragment}),...l)}K(n){if(n.scheme!==p.$bnb)return;const o=[];for(;n.path!=="/";)o.unshift(this.d.basename(n)),n=this.d.dirname(n);if(o.length<2)return;const l=n.authority===s.b;let y,R;const k=[];let E,v,C,U,F;for(;o.length;){const M=o.shift();M.startsWith("scheme:")?y=M.substring(7):M.startsWith("authority:")?R=M.substring(10):M.startsWith("syncResource:")?E=M.substring(13):M.startsWith("profile:")?v=M.substring(8):M.startsWith("collection:")?C=M.substring(11):M.startsWith("ref:")?U=M.substring(4):E?F=M:k.push(M)}return{remote:l,syncResource:E,profile:v,collection:C,ref:U,node:F,location:y&&R!==void 0?this.d.joinPath(P.URI.from({scheme:y,authority:R,query:n.query,fragment:n.fragment,path:"/"}),...k):void 0}}L(n,o){try{const l=JSON.parse(n);if((0,d.$iNb)(l))return l}catch(l){this.g.error(l)}throw new p.$2mb((0,a.localize)(0,null),p.UserDataSyncErrorCode.IncompatibleRemoteContent,o)}async M(n,o,l){const y=await this.e.resolveResourceContent(n,o,l);return{ref:o,content:y}}};e.$Zdc=r,e.$Zdc=r=s=ve([Z(0,p.$Wmb),Z(1,p.$Xmb),Z(2,p.$_mb),Z(3,L.$Jl),Z(4,N.$Mi),Z(5,A.$cq),Z(6,O.$_k),Z(7,S.$Ll),Z(8,m.$_i),Z(9,I.$Ei)],r)}),define(le[268],he([0,1,19,6,26,41,3,2,21,13,32,22,28,7,4,17,18,20,120,121,122,123,124,125,126,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t,s,r,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;const n="sync.lastSyncTime";let o=class extends A.$Wc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(E,v,C,U,F,M,X,K,Q,G,ie){super(),this.C=E,this.D=v,this.F=C,this.G=U,this.H=F,this.I=M,this.J=X,this.L=K,this.M=Q,this.N=G,this.O=ie,this.f=i.SyncStatus.Uninitialized,this.g=this.B(new T.$me),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.$me),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new T.$me),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new T.$me),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new T.$me),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new T.$me),this.onDidResetLocal=this.w.event,this.y=this.B(new T.$me),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=C.userDataSyncStore?i.SyncStatus.Idle:i.SyncStatus.Uninitialized,this.t=this.J.getNumber(n,m.StorageScope.APPLICATION,void 0),this.B((0,A.$Uc)(()=>this.cb())),this.B(new a.$Rh(()=>this.W(),5*1e3)).schedule()}async createSyncTask(E,v){this.db(),this.H.info("Sync started.");const C=new Date().getTime(),U=(0,S.$2g)();try{const K=(0,i.$1mb)(U);v&&(K["Cache-Control"]="no-cache"),E=await this.D.manifest(E,K)}catch(K){const Q=i.$2mb.toUserDataSyncError(K);throw R(Q,U,this.F,this.I),Q}const F=!1,M=this;let X;return{manifest:E,async run(){if(F)throw new Error("Can run a task only once");X=(0,a.$sh)(K=>M.P(E,!1,U,K)),await X.finally(()=>X=void 0),M.H.info(`Sync done. Took ${new Date().getTime()-C}ms`),M.ab()},stop(){return X?.cancel(),M.U()}}}async createManualSyncTask(){if(this.db(),this.L.isEnabled())throw new i.$2mb("Cannot start manual sync when sync is enabled",i.UserDataSyncErrorCode.LocalError);this.H.info("Sync started.");const E=new Date().getTime(),v=(0,S.$2g)(),C=(0,i.$1mb)(v);let U;try{U=await this.D.manifest(null,C)}catch(X){const K=i.$2mb.toUserDataSyncError(X);throw R(K,v,this.F,this.I),K}await this.resetLocal();const F=this,M=new N.$xe;return{id:v,async merge(){return F.P(U,!0,v,M.token)},async apply(){try{try{await F.R(U,v,M.token)}catch(X){if(i.$2mb.toUserDataSyncError(X).code===i.UserDataSyncErrorCode.MethodNotFound)F.H.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.H.info("Applying manual sync again..."),await F.R(U,v,M.token);else throw X}}catch(X){throw F.H.error(X),X}F.H.info(`Sync done. Took ${new Date().getTime()-E}ms`),F.ab()},async stop(){M.cancel(),await F.U(),await F.resetLocal()}}}async P(E,v,C,U){this.n=[];try{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Syncing);const F=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(F,E,v,C,U));const M=F.enabled.find(X=>X.resource===i.SyncResource.Profiles);if(M){const X=await M.getLastSyncedProfiles()||[];if(U.isCancellationRequested)return;await this.Q(X,E,v,C,U)}}finally{this.status!==i.SyncStatus.HasConflicts&&this.Z(i.SyncStatus.Idle),this.r.fire(this.n)}}async Q(E,v,C,U,F){for(const M of E){if(F.isCancellationRequested)return;const X=this.M.profiles.find(Q=>Q.id===M.id);if(!X){this.H.error(`Profile with id:${M.id} and name: ${M.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",M.name);const K=this.getOrCreateActiveProfileSynchronizer(X,M);this.n.push(...await this.S(K,v,C,U,F))}for(const[M,X]of this.z.entries())this.M.profiles.some(K=>K.id===X[0].profile.id)||(await X[0].resetLocal(),X[1].dispose(),this.z.delete(M))}async R(E,v,C){const U=this.bb();for(const Q of U){if(C.isCancellationRequested)return;await Q.apply(v,C)}const F=U.find(Q=>Q.profile.isDefault);if(!F)return;const M=F.enabled.find(Q=>Q.resource===i.SyncResource.Profiles);if(!M)return;const K=(await M.getRemoteSyncedProfiles(E?.latest??null)||[]).filter(Q=>U.every(G=>G.profile.id!==Q.id));K.length&&await this.Q(K,E,!1,v,C)}async S(E,v,C,U,F){return(await E.sync(v,C,U,F)).map(([X,K])=>({profile:E.profile,syncResource:X,error:K}))}async U(){this.status!==i.SyncStatus.Idle&&await Promise.allSettled(this.bb().map(E=>E.stop()))}async resolveContent(E){const v=await this.N.resolveContent(E);if(v)return v;for(const C of this.bb())for(const U of C.enabled){const F=await U.resolveContent(E);if(F)return F}return null}async replace(E){this.db();const v=this.N.resolveUserDataSyncResource(E);if(!v)return;const C=await this.resolveContent(E.uri);C&&await this.X(v.profile,async U=>{if(v.syncResource===U.resource)return await U.replace(C),!0})}async accept(E,v,C,U){this.db(),await this.X(E.profile,async F=>{if(E.syncResource===F.resource)return await F.accept(v,C),U&&await F.apply((0,p.$lg)(U)?!1:U.force,(0,i.$1mb)((0,S.$2g)())),!0})}async hasLocalData(){return!!await this.X(this.M.defaultProfile,async v=>{if(v.resource!==i.SyncResource.GlobalState&&await v.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.X(this.M.defaultProfile,async v=>{if(await v.hasPreviouslySynced())return!0})}async reset(){this.db(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.db();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(E){this.H.error(E)}this.y.fire()}async resetLocal(){this.db(),this.t=void 0,this.J.remove(n,m.StorageScope.APPLICATION);for(const[E]of this.z.values())try{await E.resetLocal()}catch(v){this.H.error(v)}this.cb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async W(){const E=this.J.keys(m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),v=[];for(const U of E){if(!U.endsWith(".lastSyncUserData"))continue;const F=U.split(".");F.length===3&&v.push([U,F[0]])}if(!v.length)return;const C=new A.$Vc;try{let U=this.z.get(this.M.defaultProfile.id)?.[0];U||(U=C.add(this.G.createInstance(l,this.M.defaultProfile,void 0)));const F=U.enabled.find(K=>K.resource===i.SyncResource.Profiles);if(!F)return;const X=(await F.getLastSyncedProfiles())?.map(K=>K.collection)??[];for(const[K,Q]of v)X.includes(Q)||(this.H.info(`Removing last sync state for stale profile: ${Q}`),this.J.remove(K,m.StorageScope.APPLICATION))}finally{C.dispose()}}async cleanUpRemoteData(){const E=await this.N.getRemoteSyncedProfiles(),v=E.map(M=>M.collection),C=await this.D.getAllCollections(),U=C.filter(M=>!v.includes(M));U.length&&(this.H.info(`Deleting ${U.length} redundant collections on server`),await Promise.allSettled(U.map(M=>this.D.deleteCollection(M))),this.H.info("Deleted redundant collections on server"));const F=E.filter(M=>C.includes(M.collection));if(F.length!==E.length){const M=this.G.createInstance(r.$gdc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await M.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await M.updateRemoteProfiles(F,null),this.H.info("Updated remote profiles on server")}finally{M.dispose()}}}async saveRemoteActivityData(E){this.db();const v=await this.D.getActivityData();await this.C.writeFile(E,v)}async extractActivityData(E,v){const C=(await this.C.readFile(E)).value.toString(),U=JSON.parse(C);if(U.resources)for(const F in U.resources)for(const M of U.resources[F])await this.O.writeResource(F,M.content,new Date(M.created*1e3),void 0,v);if(U.collections)for(const F in U.collections)for(const M in U.collections[F].resources)for(const X of U.collections[F].resources?.[M]??[])await this.O.writeResource(M,X.content,new Date(X.created*1e3),F,v)}async X(E,v){const C=new A.$Vc;try{const U=this.z.get(E.id);if(U){const Q=await this.Y(U[0],v,C);return(0,p.$mg)(Q)?null:Q}if(E.isDefault){const Q=C.add(this.G.createInstance(l,E,void 0)),G=await this.Y(Q,v,C);return(0,p.$mg)(G)?null:G}if(this.M.isEnabled())return null;const F=C.add(this.G.createInstance(r.$gdc,E,void 0)),M=await this.D.manifest(null),K=(await F.getRemoteSyncedProfiles(M?.latest??null)||[]).find(Q=>Q.id===E.id);if(K){const Q=C.add(this.G.createInstance(l,E,K.collection)),G=await this.Y(Q,v,C);return(0,p.$mg)(G)?null:G}return null}finally{C.dispose()}}async Y(E,v,C){const U=[...E.enabled,...E.disabled.reduce((F,M)=>(M!==i.SyncResource.WorkspaceState&&F.push(C.add(E.createSynchronizer(M))),F),[])];for(const F of U){const M=await v(F);if(!(0,p.$mg)(M))return M}}Z(E){const v=this.f;this.f!==E&&(this.f=E,this.g.fire(E),v===i.SyncStatus.HasConflicts&&this.ab())}$(){const E=this.bb().map(v=>v.conflicts).flat();(0,P.$wb)(this.j,E,(v,C)=>v.profile.id===C.profile.id&&v.syncResource===C.syncResource&&(0,P.$wb)(v.conflicts,C.conflicts,(U,F)=>(0,L.$_g)(U.previewResource,F.previewResource)))||(this.j=E,this.m.fire(E))}ab(){this.status===i.SyncStatus.Idle&&(this.t=new Date().getTime(),this.J.store(n,this.t,m.StorageScope.APPLICATION,m.StorageTarget.MACHINE),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(E,v){let C=this.z.get(E.id);if(C&&C[0].collection!==v?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),C[1].dispose(),C=void 0,this.z.delete(E.id)),!C){const U=new A.$Vc,F=U.add(this.G.createInstance(l,E,v?.collection));U.add(F.onDidChangeStatus(M=>this.Z(M))),U.add(F.onDidChangeConflicts(M=>this.$())),U.add(F.onDidChangeLocal(M=>this.h.fire(M))),this.z.set(E.id,C=[F,U])}return C[0]}bb(){const E=[];for(const[v]of this.z.values())E.push(v);return E}cb(){this.z.forEach(([,E])=>E.dispose()),this.z.clear()}db(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$jdc=o,e.$jdc=o=ve([Z(0,$.$_k),Z(1,i.$Wmb),Z(2,i.$Vmb),Z(3,c.$Ei),Z(4,i.$_mb),Z(5,b.$$l),Z(6,m.$cq),Z(7,i.$7mb),Z(8,f.$Ll),Z(9,i.$9mb),Z(10,i.$Xmb)],o);let l=class extends A.$Wc{get enabled(){return this.f.sort((E,v)=>E[1]-v[1]).map(([E])=>E)}get disabled(){return i.$Smb.filter(E=>!this.r.isResourceEnabled(E))}get status(){return this.g}get conflicts(){return this.m}constructor(E,v,C,U,F,M,X,K,Q,G){super(),this.profile=E,this.collection=v,this.r=C,this.t=U,this.u=F,this.w=M,this.y=X,this.z=K,this.C=Q,this.D=G,this.f=[],this.g=i.SyncStatus.Idle,this.h=this.B(new T.$me),this.onDidChangeStatus=this.h.event,this.j=this.B(new T.$me),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new T.$me),this.onDidChangeConflicts=this.n.event,this.B(C.onDidChangeResourceEnablement(([ie,V])=>this.F(ie,V))),this.B((0,A.$Uc)(()=>this.f.splice(0,this.f.length).forEach(([,,ie])=>ie.dispose())));for(const ie of i.$Smb)C.isResourceEnabled(ie)&&this.G(ie)}F(E,v){v?this.G(E):this.H(E)}G(E){if(this.f.some(([F])=>F.resource===E))return;if(E===i.SyncResource.Extensions&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(E===i.SyncResource.Profiles&&(!this.profile.isDefault||!this.C.isEnabled())||E===i.SyncResource.WorkspaceState)return;if(E!==i.SyncResource.Profiles&&this.profile.useDefaultFlags?.[E]){this.z.debug(`Skipping syncing ${E} in ${this.profile.name} because it is already synced by default profile`);return}const v=new A.$Vc,C=v.add(this.createSynchronizer(E));v.add(C.onDidChangeStatus(()=>this.L())),v.add(C.onDidChangeConflicts(()=>this.M())),v.add(C.onDidChangeLocal(()=>this.j.fire(E)));const U=this.N(E);this.f.push([C,U,v])}H(E){const v=this.f.findIndex(([C])=>C.resource===E);if(v!==-1){const[[C,,U]]=this.f.splice(v,1);U.dispose(),this.L(),Promise.allSettled([C.stop(),C.resetLocal()]).then(null,F=>this.z.error(F))}}createSynchronizer(E){switch(E){case i.SyncResource.Settings:return this.t.createInstance(u.$qbc,this.profile,this.collection);case i.SyncResource.Keybindings:return this.t.createInstance(g.$nbc,this.profile,this.collection);case i.SyncResource.Snippets:return this.t.createInstance(t.$vbc,this.profile,this.collection);case i.SyncResource.Tasks:return this.t.createInstance(s.$ybc,this.profile,this.collection);case i.SyncResource.GlobalState:return this.t.createInstance(I.$qNb,this.profile,this.collection);case i.SyncResource.Extensions:return this.t.createInstance(w.$ibc,this.profile,this.collection);case i.SyncResource.Profiles:return this.t.createInstance(r.$gdc,this.profile,this.collection)}}async sync(E,v,C,U){if(U.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const M=[],X=(0,i.$1mb)(C),K=(this.collection?E?.collections?.[this.collection]?.latest:E?.latest)??null,Q=v?await this.I(K):{};for(const G of F){if(U.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(v){const ie=await G.preview(K,Q,X);if(ie)for(const V of ie.resourcePreviews)(V.localChange!==i.Change.None||V.remoteChange!==i.Change.None)&&V.mergeState===i.MergeState.Preview&&await G.merge(V.previewResource)}else await G.sync(K,X)}catch(ie){const V=i.$2mb.toUserDataSyncError(ie);if(R(V,C,this.w,this.y),y(ie))throw V;this.z.error(ie),this.z.error(`${G.resource}: ${(0,O.$qj)(ie)}`),M.push([G.resource,V])}}return M}finally{this.L()}}async apply(E,v){const C=(0,i.$1mb)(E);for(const U of this.enabled){if(v.isCancellationRequested)return;try{await U.apply(!1,C)}catch(F){const M=i.$2mb.toUserDataSyncError(F);if(R(M,E,this.w,this.y),y(F))throw M;this.z.error(F),this.z.error(`${U.resource}: ${(0,O.$qj)(F)}`)}}}async stop(){for(const E of this.enabled)try{E.status!==i.SyncStatus.Idle&&await E.stop()}catch(v){this.z.error(v)}}async resetLocal(){for(const E of this.enabled)try{await E.resetLocal()}catch(v){this.z.error(`${E.resource}: ${(0,O.$qj)(v)}`),this.z.error(v)}}async I(E){if(!this.profile.isDefault)return{};const v=this.D.getValue(i.$Omb),C=this.enabled.find(U=>U instanceof u.$qbc);if(C){const U=await C.getRemoteUserDataSyncConfiguration(E);return{...v,...U}}return v}J(E){this.g!==E&&(this.g=E,this.h.fire(E))}L(){return this.M(),this.enabled.some(E=>E.status===i.SyncStatus.HasConflicts)?this.J(i.SyncStatus.HasConflicts):this.enabled.some(E=>E.status===i.SyncStatus.Syncing)?this.J(i.SyncStatus.Syncing):this.J(i.SyncStatus.Idle)}M(){const E=this.enabled.filter(v=>v.status===i.SyncStatus.HasConflicts).filter(v=>v.conflicts.conflicts.length>0).map(v=>v.conflicts);(0,P.$wb)(this.m,E,(v,C)=>v.syncResource===C.syncResource&&(0,P.$wb)(v.conflicts,C.conflicts,(U,F)=>(0,L.$_g)(U.previewResource,F.previewResource)))||(this.m=E,this.n.fire(E))}N(E){switch(E){case i.SyncResource.Settings:return 0;case i.SyncResource.Keybindings:return 1;case i.SyncResource.Snippets:return 2;case i.SyncResource.Tasks:return 3;case i.SyncResource.GlobalState:return 4;case i.SyncResource.Extensions:return 5;case i.SyncResource.Profiles:return 6;case i.SyncResource.WorkspaceState:return 7}}};l=ve([Z(2,i.$7mb),Z(3,c.$Ei),Z(4,h.$hp),Z(5,i.$Vmb),Z(6,b.$$l),Z(7,i.$_mb),Z(8,f.$Ll),Z(9,d.$_i)],l);function y(k){if(k instanceof i.$2mb)switch(k.code){case i.UserDataSyncErrorCode.MethodNotFound:case i.UserDataSyncErrorCode.TooLarge:case i.UserDataSyncErrorCode.TooManyRequests:case i.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case i.UserDataSyncErrorCode.LocalTooManyRequests:case i.UserDataSyncErrorCode.LocalTooManyProfiles:case i.UserDataSyncErrorCode.Gone:case i.UserDataSyncErrorCode.UpgradeRequired:case i.UserDataSyncErrorCode.IncompatibleRemoteContent:case i.UserDataSyncErrorCode.IncompatibleLocalContent:return!0}return!1}function R(k,E,v,C){C.publicLog2("sync/error",{code:k.code,serverCode:k instanceof i.$3mb?String(k.serverCode):void 0,url:k instanceof i.$3mb?k.url:void 0,resource:k.resource,executionId:E,service:v.userDataSyncStore.url.toString()})}}),define(le[269],he([0,1,3,2,9,20,25]),function(ne,e,P,a,N,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=e.$Egc=void 0;function A(h,$){return{...h,profile:(0,O.$Ml)(h.profile,$.profilesHome.scheme)}}function L(h){return{created:h.created,uri:N.URI.revive(h.uri)}}class p{constructor($,c,m){this.c=$,this.d=c,this.f=m,this.a=new Map,this.b=new P.$me}listen($,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call($,c,m){try{return await this.g($,c,m)}catch(b){throw this.f.error(b),b}}async g($,c,m){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(N.URI.revive(m[0]));case"accept":return this.c.accept(A(m[0],this.d),N.URI.revive(m[1]),m[2],m[3]);case"replace":return this.c.replace(L(m[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(N.URI.revive(m[0]));case"extractActivityData":return this.c.extractActivityData(N.URI.revive(m[0]),N.URI.revive(m[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const b=c.substring(11),f=m[0],w=this.h(f);switch(m=m.slice(1),b){case"merge":return w.merge();case"apply":return w.apply().then(()=>this.a.delete(this.j(w.id)));case"stop":return w.stop().finally(()=>this.a.delete(this.j(w.id)))}}throw new Error("Invalid call")}h($){const c=this.a.get(this.j($));if(!c)throw new Error(`Manual sync taks not found: ${$}`);return c}async i(){const $=await this.c.createManualSyncTask();return this.a.set(this.j($.id),$),$.id}j($){return`manualSyncTask-${$}`}}e.$Egc=p;let S=class extends a.$Wc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor($,c){super(),this.n=c,this.b=T.SyncStatus.Uninitialized,this.c=this.B(new P.$me),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new P.$me),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new P.$me),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new P.$me),this.onSyncErrors=this.m.event,this.a={call(m,b,f){return $.call(m,b,f).then(null,w=>{throw T.$2mb.toUserDataSyncError(w)})},listen(m,b){return $.listen(m,b)}},this.a.call("_getInitialData").then(([m,b,f])=>{this.s(m),this.t(b),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(w=>this.s(w))),this.B(this.a.listen("onDidChangeLastSyncTime")(w=>this.u(w)))}),this.B(this.a.listen("onDidChangeConflicts")(m=>this.t(m))),this.B(this.a.listen("onSyncErrors")(m=>this.m.fire(m.map(b=>({...b,error:T.$2mb.toUserDataSyncError(b.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const $=await this.a.call("createManualSyncTask"),c=this;return new d($,{async call(b,f,w){return c.a.call(`manualSync/${b}`,[$,...Array.isArray(f)?f:[f]],w)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept($,c,m,b){return this.a.call("accept",[$,c,m,b])}resolveContent($){return this.a.call("resolveContent",[$])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace($){return this.a.call("replace",[$])}saveRemoteActivityData($){return this.a.call("getRemoteActivityData",[$])}extractActivityData($,c){return this.a.call("extractActivityData",[$,c])}async s($){this.b=$,this.c.fire($)}async t($){this.f=$.map(c=>({syncResource:c.syncResource,profile:(0,O.$Ml)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(m=>({...m,baseResource:N.URI.revive(m.baseResource),localResource:N.URI.revive(m.localResource),remoteResource:N.URI.revive(m.remoteResource),previewResource:N.URI.revive(m.previewResource)}))})),this.g.fire(this.f)}u($){this.h!==$&&(this.h=$,this.j.fire($))}};e.$Fgc=S,e.$Fgc=S=ve([Z(1,O.$Ll)],S);class d extends a.$Wc{constructor($,c){super(),this.id=$,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[127],he([0,1,6,26,8,3,2,147,5,21,13,9,32,22,16,7,24,61,50,17,25]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gNb=e.$fNb=e.$eNb=e.$dNb=e.$cNb=void 0;const u="configurationSync.store",t="sync.previous.store",s="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",n=100,o=1e3*60*5;let l=class extends T.$Wc{get userDataSyncStore(){return this.b}get c(){return this.h.get(g.$5mb,I.StorageScope.APPLICATION)}set c(C){this.h.store(g.$5mb,C,I.StorageScope.APPLICATION,L.$o?I.StorageTarget.USER:I.StorageTarget.MACHINE)}constructor(C,U,F){super(),this.f=C,this.g=U,this.h=F,this.a=this.B(new O.$me),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const M=this.B(new T.$Vc);this.B(O.Event.filter(F.onDidChangeValue(I.StorageScope.APPLICATION,g.$5mb,M),()=>this.c!==this.userDataSyncStore?.type,M)(()=>this.j()))}j(){this.b=this.m(this.f[u]),this.a.fire()}m(C){if(C&&(C=L.$o&&C.web?{...C,...C.web}:C,(0,S.$fg)(C.url)&&(0,S.$hg)(C.authenticationProviders)&&Object.keys(C.authenticationProviders).every(U=>Array.isArray(C.authenticationProviders[U].scopes)))){const U=C,F=!!U.canSwitch,M=U.url===U.insidersUrl?"insiders":"stable",X=(F?this.c:void 0)||M,K=X==="insiders"?U.insidersUrl:X==="stable"?U.stableUrl:U.url;return{url:d.URI.parse(K),type:X,defaultType:M,defaultUrl:d.URI.parse(U.url),stableUrl:d.URI.parse(U.stableUrl),insidersUrl:d.URI.parse(U.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(U.authenticationProviders).reduce((Q,G)=>(Q.push({id:G,scopes:U.authenticationProviders[G].scopes}),Q),[])}}}};e.$cNb=l,e.$cNb=l=ve([Z(0,b.$sk),Z(1,$.$_i),Z(2,I.$cq)],l);let y=class extends l{constructor(C,U,F){super(C,U,F);const M=this.h.get(t,I.StorageScope.APPLICATION);M&&(this.n=JSON.parse(M));const X=this.f[u];X?this.h.store(t,JSON.stringify(X),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE):this.h.remove(t,I.StorageScope.APPLICATION)}async switch(C){C!==this.c&&(this.c=C,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$dNb=y,e.$dNb=y=ve([Z(0,b.$sk),Z(1,$.$_i),Z(2,I.$cq)],y);let R=class extends T.$Wc{get donotMakeRequestsUntil(){return this.j}constructor(C,U,F,M,X,K,Q){super(),this.n=F,this.r=M,this.s=Q,this.g=this.B(new O.$me),this.onTokenFailed=this.g.event,this.h=this.B(new O.$me),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new O.$me),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(C),this.c=(0,w.$iq)(X,K,Q).then(G=>{const ie={"X-Client-Name":`${U.applicationName}${L.$o?"-web":""}`,"X-Client-Version":U.version};return U.commit&&(ie["X-Client-Commit"]=U.commit),ie}),this.f=new E(n,o,this.n,this.r),this.u(),this.B((0,T.$Uc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(C,U){this.b={token:C,type:U}}t(C){this.a=C?(0,p.$gh)(C,"v1"):void 0}u(){const C=this.s.getNumber(s,I.StorageScope.APPLICATION);C&&Date.now()<C&&this.y(new Date(C))}y(C){this.j?.getTime()!==C?.getTime()&&(this.j=C,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(s,this.j.getTime(),I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),this.w=(0,P.$sh)(U=>(0,P.$Gh)(this.j.getTime()-Date.now(),U).then(()=>this.y(void 0))),this.w.then(null,U=>null)):this.s.remove(s,I.StorageScope.APPLICATION),this.m.fire())}async getAllCollections(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,p.$gh)(this.a,"collection").toString();C={...C},C["Content-Type"]="application/json";const F=await this.D(U,{type:"GET",headers:C},[],a.CancellationToken.None);return(await(0,f.$8p)(F))?.map(({id:M})=>M)||[]}async createCollection(C={}){if(!this.a)throw new Error("No settings sync store url configured.");const U=(0,p.$gh)(this.a,"collection").toString();C={...C},C["Content-Type"]=A.$5s.text;const F=await this.D(U,{type:"POST",headers:C},[],a.CancellationToken.None),M=await(0,f.$7p)(F);if(!M)throw new g.$3mb("Server did not return the collection id",U,g.UserDataSyncErrorCode.NoCollection,F.res.statusCode,F.res.headers[g.$Ymb]);return M}async deleteCollection(C,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=C?(0,p.$gh)(this.a,"collection",C).toString():(0,p.$gh)(this.a,"collection").toString();U={...U},await this.D(F,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async getAllResourceRefs(C,U){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.z(this.a,U,C),M={},X=await this.D(F.toString(),{type:"GET",headers:M},[],a.CancellationToken.None);return(await(0,f.$8p)(X)||[]).map(({url:Q,created:G})=>({ref:(0,p.$ih)(F,F.with({path:Q})),created:G*1e3}))}async resolveResourceContent(C,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,p.$gh)(this.z(this.a,F,C),U).toString();M={...M},M["Cache-Control"]="no-cache";const K=await this.D(X,{type:"GET",headers:M},[],a.CancellationToken.None);return await(0,f.$7p)(K)}async deleteResource(C,U,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=U!==null?(0,p.$gh)(this.z(this.a,F,C),U).toString():this.z(this.a,F,C).toString(),X={};await this.D(M,{type:"DELETE",headers:X},[],a.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,p.$gh)(this.a,"resource").toString(),U={"Content-Type":A.$5s.text};await this.D(C,{type:"DELETE",headers:U},[],a.CancellationToken.None)}async readResource(C,U,F,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const X=(0,p.$gh)(this.z(this.a,F,C),"latest").toString();M={...M},M["Cache-Control"]="no-cache",U&&(M["If-None-Match"]=U.ref);const K=await this.D(X,{type:"GET",headers:M},[304],a.CancellationToken.None);let Q=null;if(K.res.statusCode===304&&(Q=U),Q===null){const G=K.res.headers.etag;if(!G)throw new g.$3mb("Server did not return the ref",X,g.UserDataSyncErrorCode.NoRef,K.res.statusCode,K.res.headers[g.$Ymb]);const ie=await(0,f.$7p)(K);if(!ie&&K.res.statusCode===304)throw new g.$3mb("Empty response",X,g.UserDataSyncErrorCode.EmptyResponse,K.res.statusCode,K.res.headers[g.$Ymb]);Q={ref:G,content:ie}}return Q}async writeResource(C,U,F,M,X={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,M,C).toString();X={...X},X["Content-Type"]=A.$5s.text,F&&(X["If-Match"]=F);const Q=await this.D(K,{type:"POST",data:U,headers:X},[],a.CancellationToken.None),G=Q.res.headers.etag;if(!G)throw new g.$3mb("Server did not return the ref",K,g.UserDataSyncErrorCode.NoRef,Q.res.statusCode,Q.res.headers[g.$Ymb]);return G}async manifest(C,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,p.$gh)(this.a,"manifest").toString();U={...U},U["Content-Type"]="application/json",C&&(U["If-None-Match"]=C.ref);const M=await this.D(F,{type:"GET",headers:U},[304],a.CancellationToken.None);let X=null;if(M.res.statusCode===304&&(X=C),!X){const Q=M.res.headers.etag;if(!Q)throw new g.$3mb("Server did not return the ref",F,g.UserDataSyncErrorCode.NoRef,M.res.statusCode,M.res.headers[g.$Ymb]);const G=await(0,f.$7p)(M);if(!G&&M.res.statusCode===304)throw new g.$3mb("Empty response",F,g.UserDataSyncErrorCode.EmptyResponse,M.res.statusCode,M.res.headers[g.$Ymb]);G&&(X={...JSON.parse(G),ref:Q})}const K=this.s.get(r,I.StorageScope.APPLICATION);return K&&X&&K!==X.session&&this.C(),X===null&&K&&this.C(),X&&this.s.store(r,X.session,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE),X}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const C=(0,p.$gh)(this.a,"download").toString(),U={},F=await this.D(C,{type:"GET",headers:U},[],a.CancellationToken.None);if(!(0,f.$4p)(F))throw new g.$3mb("Server returned "+F.res.statusCode,C,g.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[g.$Ymb]);if((0,f.$5p)(F))throw new g.$3mb("Empty response",C,g.UserDataSyncErrorCode.EmptyResponse,F.res.statusCode,F.res.headers[g.$Ymb]);return F.stream}z(C,U,F){return U?(0,p.$gh)(C,"collection",U,"resource",F):(0,p.$gh)(C,"resource",F)}C(){this.s.remove(r,I.StorageScope.APPLICATION),this.s.remove(i,I.StorageScope.APPLICATION)}async D(C,U,F,M){if(!this.b)throw new g.$3mb("No Auth Token Available",C,g.UserDataSyncErrorCode.Unauthorized,void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new g.$3mb(`${U.type} request '${C}' failed because of too many requests (429).`,C,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0,void 0);this.y(void 0);const X=await this.c;U.headers={...U.headers||{},...X,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(U.headers),this.r.trace("Sending request to server",{url:C,type:U.type,headers:{...U.headers,authorization:void 0}});let K;try{K=await this.f.request(C,U,M)}catch(z){if(!(z instanceof g.$3mb)){let ee=g.UserDataSyncErrorCode.RequestFailed;const re=(0,N.$_)(z).toLowerCase();re.includes("xhr timeout")?ee=g.UserDataSyncErrorCode.RequestTimeout:re.includes("protocol")&&re.includes("not supported")?ee=g.UserDataSyncErrorCode.RequestProtocolNotSupported:re.includes("request path contains unescaped characters")?ee=g.UserDataSyncErrorCode.RequestPathNotEscaped:re.includes("headers must be an object")?ee=g.UserDataSyncErrorCode.RequestHeadersNotObject:(0,N.$6)(z)&&(ee=g.UserDataSyncErrorCode.RequestCanceled),z=new g.$3mb(`Connection refused for the request '${C}'.`,C,ee,void 0,void 0)}throw this.r.info("Request failed",C),z}const Q=K.res.headers[g.$Ymb],G={url:C,status:K.res.statusCode,"execution-id":U.headers[g.$Zmb],"operation-id":Q},ie=(0,f.$4p)(K)||K.res.statusCode&&F.includes(K.res.statusCode);let V="";if(ie?this.r.trace("Request succeeded",G):(V=await(0,f.$6p)(K)||"",this.r.info("Request failed",G,V)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire(g.UserDataSyncErrorCode.Unauthorized),new g.$3mb(`${U.type} request '${C}' failed because of Unauthorized (401).`,C,g.UserDataSyncErrorCode.Unauthorized,K.res.statusCode,Q);if(K.res.statusCode===403)throw this.g.fire(g.UserDataSyncErrorCode.Forbidden),new g.$3mb(`${U.type} request '${C}' failed because the access is forbidden (403).`,C,g.UserDataSyncErrorCode.Forbidden,K.res.statusCode,Q)}if(this.h.fire(),K.res.statusCode===404)throw new g.$3mb(`${U.type} request '${C}' failed because the requested resource is not found (404).`,C,g.UserDataSyncErrorCode.NotFound,K.res.statusCode,Q);if(K.res.statusCode===405)throw new g.$3mb(`${U.type} request '${C}' failed because the requested endpoint is not found (405). ${V}`,C,g.UserDataSyncErrorCode.MethodNotFound,K.res.statusCode,Q);if(K.res.statusCode===409)throw new g.$3mb(`${U.type} request '${C}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,C,g.UserDataSyncErrorCode.Conflict,K.res.statusCode,Q);if(K.res.statusCode===410)throw new g.$3mb(`${U.type} request '${C}' failed because the requested resource is not longer available (410).`,C,g.UserDataSyncErrorCode.Gone,K.res.statusCode,Q);if(K.res.statusCode===412)throw new g.$3mb(`${U.type} request '${C}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,C,g.UserDataSyncErrorCode.PreconditionFailed,K.res.statusCode,Q);if(K.res.statusCode===413)throw new g.$3mb(`${U.type} request '${C}' failed because of too large payload (413).`,C,g.UserDataSyncErrorCode.TooLarge,K.res.statusCode,Q);if(K.res.statusCode===426)throw new g.$3mb(`${U.type} request '${C}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,C,g.UserDataSyncErrorCode.UpgradeRequired,K.res.statusCode,Q);if(K.res.statusCode===429){const z=K.res.headers["retry-after"];throw z?(this.y(new Date(Date.now()+parseInt(z)*1e3)),new g.$3mb(`${U.type} request '${C}' failed because of too many requests (429).`,C,g.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,K.res.statusCode,Q)):new g.$3mb(`${U.type} request '${C}' failed because of too many requests (429).`,C,g.UserDataSyncErrorCode.TooManyRequests,K.res.statusCode,Q)}if(!ie)throw new g.$3mb("Server returned "+K.res.statusCode,C,g.UserDataSyncErrorCode.Unknown,K.res.statusCode,Q);return K}F(C){let U=this.s.get(i,I.StorageScope.APPLICATION);U===void 0&&(U=(0,h.$2g)(),this.s.store(i,U,I.StorageScope.APPLICATION,I.StorageTarget.MACHINE)),C["X-Machine-Session-Id"]=U;const F=this.s.get(r,I.StorageScope.APPLICATION);F!==void 0&&(C["X-User-Session-Id"]=F)}};e.$eNb=R,e.$eNb=R=ve([Z(1,b.$sk),Z(2,f.$2p),Z(3,g.$_mb),Z(4,c.$Mi),Z(5,m.$_k),Z(6,I.$cq)],R);let k=class extends R{constructor(C,U,F,M,X,K,Q){super(C.userDataSyncStore?.url,U,F,M,X,K,Q),this.B(C.onDidChangeUserDataSyncStore(()=>this.t(C.userDataSyncStore?.url)))}};e.$fNb=k,e.$fNb=k=ve([Z(0,g.$Vmb),Z(1,b.$sk),Z(2,f.$2p),Z(3,g.$_mb),Z(4,c.$Mi),Z(5,m.$_k),Z(6,I.$cq)],k);class E{constructor(C,U,F,M){this.c=C,this.d=U,this.f=F,this.g=M,this.a=[],this.b=void 0}request(C,U,F){if(this.h()&&this.i(),U.url=C,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new g.$3mb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,C,g.UserDataSyncErrorCode.LocalTooManyRequests,void 0,void 0);return this.b=this.b||new Date,this.a.push(C),this.f.request(U,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$gNb=E}),define(le[270],he([0,1,3,2,9,22,24,17,127]),function(ne,e,P,a,N,O,T,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=e.$Bgc=e.$Agc=void 0;class p{constructor(c){this.a=c}listen(c,m){switch(m){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${m}`)}call(c,m,b){switch(m){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(b)}throw new Error("Invalid call")}}e.$Agc=p;class S extends a.$Wc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new P.$me),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(m=>{this.a=m,this.B(this.c.listen("onDidChangeAccount")(b=>{this.a=b,this.b.fire(b)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$Bgc=S;class d{constructor(c){this.a=c}listen(c,m){switch(m){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${m}`)}call(c,m,b){switch(m){case"switch":return this.a.switch(b[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$Cgc=d;let h=class extends L.$cNb{constructor(c,m,b,f){super(m,b,f),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:N.URI.revive(c.url),type:c.type,defaultUrl:N.URI.revive(c.defaultUrl),insidersUrl:N.URI.revive(c.insidersUrl),stableUrl:N.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$Dgc=h,e.$Dgc=h=ve([Z(1,T.$sk),Z(2,O.$_i),Z(3,A.$cq)],h)}),define(le[271],he([0,1,3,59,24,17,18,266,25,83,87]),function(ne,e,P,a,N,O,T,A,L,p,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;let d=class extends A.$kdc{constructor($,c,m,b,f,w,I,g,u,t,s){super($,c,m,b,f,I,g,u,t,s),this.B(P.Event.debounce(P.Event.any(P.Event.map(w.onDidFocusMainWindow,()=>"windowFocus"),P.Event.map(w.onDidOpenMainWindow,()=>"windowOpen")),(r,i)=>r?[...r,i]:[i],1e3)(r=>this.triggerSync(r,!0,!1)))}};e.$Zgc=d,e.$Zgc=d=ve([Z(0,N.$sk),Z(1,L.$Vmb),Z(2,L.$Wmb),Z(3,L.$7mb),Z(4,L.$8mb),Z(5,a.$Wec),Z(6,L.$_mb),Z(7,p.$ELb),Z(8,T.$$l),Z(9,S.$Jmb),Z(10,O.$cq)],d)}),define(le[272],he([0,1,76,23,5,21]),function(ne,e,P,a,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0,e.$lec=T,e.$mec=A,e.$nec=L,e.$kec=128/4;function T(p){function S(){let d=p.scheme===a.Schemas.file?(0,O.$7g)(p):p.toString();return N.$k||(d=d.toLowerCase()),(0,P.createHash)("md5").update(d).digest("hex")}return{id:S(),configPath:p}}function A(p,S){function d(){if(p.scheme!==a.Schemas.file)return(0,P.createHash)("md5").update(p.toString()).digest("hex");if(!S)return;let $;return N.$k?$=S.ino:N.$j?$=S.birthtime.getTime():N.$i&&(typeof S.birthtimeMs=="number"?$=Math.floor(S.birthtimeMs):$=S.birthtime.getTime()),(0,P.createHash)("md5").update(p.fsPath).update($?String($):"").digest("hex")}const h=d();if(typeof h=="string")return{id:h,uri:p}}function L(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(le[273],he([0,1,6,8,2,14,31,16,10,80,116,272,59,58,23]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;let m=class extends N.$Wc{constructor(f,w,I,g){super(),this.a=f,this.b=w,this.c=I,this.f=g,this.B(new P.$Rh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,w=await T.Promises.readdir(f),I=new p.$dMb(this.f.getChannel("storage"));await Promise.all(w.map(async g=>{const u=(0,O.$lc)(f,g);g.length===d.$kec||g===S.$Ri.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(r=>r.workspace?.id===g)||await I.isUsed(u)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await T.Promises.rm(u))}))}catch(f){(0,a.$3)(f)}}};e.$wgc=m,e.$wgc=m=ve([Z(0,A.$Ni),Z(1,L.$_j),Z(2,h.$Wec),Z(3,$.$bgc)],m)}),define(le[128],he([0,1,76,66,38,281,15,8,3,2,14,5,32,43,70]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=i,e.$yi=n,e.$Ai=y,e.$Bi=R;const m=3e4;class b{traceSocketEvent(E,v){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,v)}constructor(E,v=""){this.f=!0,this.debugLabel=v,this.socket=E,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=U=>{if(this.traceSocketEvent(c.SocketDiagnosticsEventType.Error,{code:U?.code,message:U?.message}),U){if(U.code==="EPIPE")return;(0,A.$3)(U)}},this.socket.on("error",this.a);let C;this.b=U=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Close,{hadError:U}),this.f=!1,C&&clearTimeout(C)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,C=setTimeout(()=>E.destroy(),m)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const v=C=>{this.traceSocketEvent(c.SocketDiagnosticsEventType.Read,C),E(T.$Oe.wrap(C))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(E){const v=C=>{E({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:C,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(E){const v=()=>{E()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(c.SocketDiagnosticsEventType.Write,E),this.socket.write(E.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,A.$3)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,A.$3)(v)}}end(){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((E,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),E();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent(c.SocketDiagnosticsEventType.NodeDrainEnd),E()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ui=b;var f;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var w;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(w||(w={}));class I extends p.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,v){this.socket.traceSocketEvent(E,v)}constructor(E,v,C,U){super(),this.f=this.B(new L.$me),this.g=this.B(new L.$me),this.h=!1,this.j={state:w.PeekHeader,readLen:f.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent(c.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:C?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new g(this,v,C,U,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,A.$3)(F),this.g.fire({type:c.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:F})})),this.b=new c.$pi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await L.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let v=0;for(;v<E.byteLength;)this.a.writeMessage(E.slice(v,Math.min(v+f.MaxWebSocketMessageLength,E.byteLength)),{compressed:!0,opcode:2}),v+=f.MaxWebSocketMessageLength}m(E,{compressed:v,opcode:C}){if(this.h)return;this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,E);let U=f.MinHeaderByteSize;E.byteLength<126?U+=0:E.byteLength<2**16?U+=2:U+=8;const F=T.$Oe.alloc(U),M=v?64:0,X=C&15;if(F.writeUInt8(128|M|X,0),E.byteLength<126)F.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){F.writeUInt8(126,1);let K=1;F.writeUInt8(E.byteLength>>>8&255,++K),F.writeUInt8(E.byteLength>>>0&255,++K)}else{F.writeUInt8(127,1);let K=1;F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(0,++K),F.writeUInt8(E.byteLength>>>24&255,++K),F.writeUInt8(E.byteLength>>>16&255,++K),F.writeUInt8(E.byteLength>>>8&255,++K),F.writeUInt8(E.byteLength>>>0&255,++K)}this.socket.write(T.$Oe.concat([F,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===w.PeekHeader){const v=this.b.peek(this.j.readLen),C=v.readUInt8(0),U=(C&128)>>>7,F=(C&64)>>>6,M=C&15,X=v.readUInt8(1),K=(X&128)>>>7,Q=X&127;this.j.state=w.ReadHeader,this.j.readLen=f.MinHeaderByteSize+(K?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===w.ReadHeader){const v=this.b.read(this.j.readLen),C=v.readUInt8(1),U=(C&128)>>>7;let F=C&127,M=1;F===126?F=v.readUInt8(++M)*2**8+v.readUInt8(++M):F===127&&(F=v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*0+v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M));let X=0;U&&(X=v.readUInt8(++M)*2**24+v.readUInt8(++M)*2**16+v.readUInt8(++M)*2**8+v.readUInt8(++M)),this.j.state=w.ReadBody,this.j.readLen=F,this.j.mask=X,this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===w.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),s(v,this.j.mask),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=w.PeekHeader,this.j.readLen=f.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await L.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(c.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=I;class g extends p.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.$Oe.alloc(0)}constructor(E,v,C,U,F,M){super(),this.n=E,this.r=F,this.s=M,this.a=this.B(new L.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new L.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new L.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new u(this.n,U,C,{windowBits:15})),this.f=this.B(new t(this.n,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(E,v){this.g.push({data:E,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:v}=this.g.shift();if(this.f&&v.compressed){const C=await this.w(this.f,E);this.s(C,v)}else this.s(E,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,v){return new Promise((C,U)=>{E.write(v),E.flush(F=>C(F))})}acceptFrame(E,v,C){this.h.push({data:E,isCompressed:v,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const v=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,v,C){return new Promise((U,F)=>{E.write(v),C&&E.write(T.$Oe.fromByteArray([0,0,255,255])),E.flush(M=>U(M))})}}class u extends p.$Wc{get recordedInflateBytes(){return this.j?T.$Oe.concat(this.f):T.$Oe.alloc(0)}constructor(E,v,C,U){super(),this.h=E,this.j=v,this.a=this.B(new L.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(U),this.b.on("error",F=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateError,{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateData,F),this.g.push(T.$Oe.wrap(F))}),C&&(this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialWrite,C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateWrite,E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent(c.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=T.$Oe.concat(this.g);this.g.length=0,E(v)})}}class t extends p.$Wc{constructor(E,v){super(),this.g=E,this.a=this.B(new L.$me),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateError,{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateData,C),this.f.push(T.$Oe.wrap(C))})}write(E){this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateWrite,E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent(c.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=T.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),E(v)})}}function s(k,E){if(E===0)return;const v=k.byteLength>>>2;for(let K=0;K<v;K++){const Q=k.readUInt32BE(K*4);k.writeUInt32BE(Q^E,K*4)}const C=v*4,U=k.byteLength-C,F=E>>>24&255,M=E>>>16&255,X=E>>>8&255;U>=1&&k.writeUInt8(k.readUInt8(C)^F,C),U>=2&&k.writeUInt8(k.readUInt8(C+1)^M,C+1),U>=3&&k.writeUInt8(k.readUInt8(C+2)^X,C+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const r={[d.Platform.Linux]:107,[d.Platform.Mac]:103};function i(){const k=(0,h.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const E=process.platform!=="darwin"&&e.$wi?e.$wi:(0,N.tmpdir)(),v=(0,S.$lc)(E,`vscode-ipc-${k}.sock`);return o(v),v}function n(k,E,v){const U=(0,P.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${U}-${v}-${E}-sock`;const F=v.substr(0,4),M=E.substr(0,6);let X;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?X=(0,S.$lc)(e.$wi,`vscode-${U}-${F}-${M}.sock`):X=(0,S.$lc)(k,`${F}-${M}.sock`),o(X),X}function o(k){const E=r[d.$u];typeof E=="number"&&k.length>=E&&console.warn(`WARNING: IPC handle "${k}" is longer than ${E} chars, try a shorter --user-data-dir`)}class l extends $.$ji{static b(E){const v=L.Event.fromNodeEventEmitter(E,"connection");return L.Event.map(v,C=>({protocol:new c.$qi(new b(C,"ipc-server-connection")),onDidClientDisconnect:L.Event.once(L.Event.fromNodeEventEmitter(C,"close"))}))}constructor(E){super(l.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=l;function y(k){return new Promise((E,v)=>{const C=(0,a.createServer)();C.on("error",v),C.listen(k,()=>{C.removeListener("error",v),E(new l(C))})})}function R(k,E){return new Promise((v,C)=>{const U=(0,a.createConnection)(k,()=>{U.removeListener("error",C),v(c.$ri.fromSocket(new b(U,`ipc-client${E}`),E))});U.once("error",C)})}}),define(le[274],he([0,1,66,128,221]),function(ne,e,P,a,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3gc=void 0,P=ke(P),e.$3gc=new class{supports(O){return!0}connect({host:O,port:T},A,L,p){return new Promise((S,d)=>{const h=P.createConnection({host:O,port:T},()=>{h.removeListener("error",d),h.write((0,N.$Ewb)(A,L,p));const $=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(h.off("data",$),S(new a.$ui(h,p)))};h.on("data",$)});h.setNoDelay(!0),h.once("error",d)})}}}),define(le[275],he([0,1,66,38,139,128,6,2,5,22,10,24,222,107,109,81,15]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=e.$6fc=e.$5fc=void 0,P=ke(P),a=ke(a);async function f(t,s,r,i,n){let o;for(let l=3;l&&(o?.dispose(),o=await new w(t,s,r,i,n).waitForReady(),!(n&&N.$5g[n]||!N.$5g[o.tunnelLocalPort]));l--);return o}class w extends A.$Wc{constructor(s,r,i,n,o){super(),this.m=r,this.n=o,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=P.createServer(),this.c=new T.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=l=>this.r(l),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,r=(0,m.$Fw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,N.$6g)(s,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(s){s.pause();const r=(0,m.$Dw)(this.tunnelRemoteHost)||(0,m.$Fw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,h.$2l)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),o=i.readEntireBuffer();i.dispose(),o.byteLength>0&&s.write(o.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),n.end()}),s.on("close",()=>n.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),n instanceof O.$ui?n.socket.destroy():n.end()}),n instanceof O.$ui?this.t(s,n):this.s(s,n),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),n.end()})}s(s,r){r.onClose(()=>s.destroy()),r.onEnd(()=>s.end()),r.onData(i=>s.write(i.buffer)),s.on("data",i=>r.write(b.$Oe.wrap(i))),s.resume()}t(s,r){const i=r.socket;i.on("end",()=>s.end()),i.on("close",()=>s.end()),i.on("error",()=>{s.destroy()}),i.pipe(s),s.pipe(i)}}e.$5fc=w;let I=class extends m.$Iw{constructor(s,r,i,n,o){super(r,o),this.H=s,this.I=i,this.J=n}isPortPrivileged(s){return(0,m.$Gw)(s,this.t,L.OS,a.release())}F(s,r,i,n,o,l,y,R){const k=this.D(r,i);if(k)return++k.refcount,k.value;if((0,m.$zw)(s))return this.G(s,r,i,o,l,y,R);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${o}.`);const E={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=f(E,n,r,i,o);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(r,i,v),v}}};e.$6fc=I,e.$6fc=I=ve([Z(0,$.$Vl),Z(1,S.$_j),Z(2,c.$Yl),Z(3,d.$sk),Z(4,p.$_i)],I);let g=class extends I{constructor(s,r,i,n,o){super(s,r,i,n,o)}};e.$7fc=g,e.$7fc=g=ve([Z(0,$.$Vl),Z(1,S.$_j),Z(2,c.$Yl),Z(3,d.$sk),Z(4,p.$_i)],g);let u=class extends A.$Wc{constructor(s,r,i,n,o){super(),this.b=s,this.c=r,this.f=i,this.g=n,this.h=o,this.a=new Map}async openTunnel(s,r,i,n,o,l,y,R,k){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${l}.`),!this.a.has(s)){const E=new g(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(s,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(r,i,n,o,l,y,R,k)}};e.$8fc=u,e.$8fc=u=ve([Z(0,$.$Vl),Z(1,S.$_j),Z(2,d.$sk),Z(3,c.$Yl),Z(4,p.$_i)],u)});var it=this&&this.__importDefault||function(ne){return ne&&ne.__esModule?ne:{default:ne}};define(le[282],he([0,1,38,41,8,2,23,9,19,3,43,157,215,216,225,207,273,198,199,22,220,98,232,99,227,16,119,259,28,111,223,118,75,7,209,210,74,4,206,77,79,235,10,211,103,24,61,17,110,18,112,113,114,49,238,86,115,25,83,265,270,248,87,264,268,269,127,62,263,249,109,231,81,275,226,239,29,240,5,241,200,218,217,85,254,20,53,214,60,262,237,250,108,267,255,11,212,102,260,253,228,195,59,213,271,257,58,261,107,105,274,193,229,153,146,151]),function(ne,e,P,a,N,O,T,A,L,p,S,d,h,$,c,m,b,f,w,I,g,u,t,s,r,i,n,o,l,y,R,k,E,v,C,U,F,M,X,K,Q,G,ie,V,z,ee,re,ce,q,x,J,H,D,B,j,W,te,_,Y,ae,ue,ge,we,Ee,pe,be,Se,Ie,oe,de,me,Pe,Oe,Fe,Te,Le,Ue,qe,He,Me,Be,ze,We,Ne,se,fe,$e,ye,Ae,Ce,je,xe,Je,Qe,Ve,_e,Ye,nt,at,Lt,Nt,Ct,Tt,Dt,Ut,Ft,yt,Mt,vt,jt,qt,Bt,ht,zt,Wt,Et){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=St,z=it(z);class Vt extends O.$Wc{constructor(Re){super(),this.f=Re,this.a=this.B(new d.$NX(this)),this.b=void 0,this.c=this.B(new p.$me),this.g()}g(){let Re=!1;const De=()=>{Re||(Re=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",De),(0,d.$OX)(process.parentPort,ht.$ffc.exit,De)}async init(){const Re=await this.h();(0,_.$Qmb)(),Re.invokeFunction(De=>{const Ke=De.get(ie.$_j),Ge=De.get(x.$$l),et=De.get(fe.$Ll);Ke.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(De),this.m(Ke),this.n(Ge,et),this.B(et.onDidChangeProfiles(()=>this.n(Ge,et))),this.r(Ge,Ke)}),this.B((0,O.$Tc)(Re.createInstance(h.$sgc,this.f.codeCachePath),Re.createInstance($.$tgc),Re.createInstance(b.$wgc),Re.createInstance(m.$vgc),Re.createInstance(c.$ugc),Re.createInstance(Ve.$Tgc),Re.createInstance(xe.$Lgc)))}async h(){const Re=new K.$Di,De={_serviceBrand:void 0,...z.default};Re.set(ee.$sk,De);const Ke=new S.$ni(Ze=>Ze==="main"),Ge=new yt.$cgc(this.a,Ke);Re.set(yt.$bgc,Ge);const et=this.f.policiesData?new ye.$Ifc(this.f.policiesData,Ge.getChannel("policy")):new Ae.$to;Re.set(Ae.$ro,et);const Xe=new Bt.$8m(this.f.args,De);Re.set(i.$Ni,Xe);const ot=new V.$ns(void 0,this.f.logLevel,Xe.logsHome,this.f.loggers.map(Ze=>({...Ze,resource:A.URI.revive(Ze.resource)})),Ge.getChannel("logger"));Re.set(ie.$ak,ot);const ft=this.B(ot.createLogger("sharedprocess",{name:(0,_e.localize)(0,null)})),$t=this.B(new ie.$hk(ft.getLevel())),tt=this.B(new Ye.$kR(ft,[$t]));Re.set(ie.$_j,tt),this.b=this.B(new nt.$Vgc(tt)),Re.set(nt.$Ugc,this.b);const st=this.B(new C.$Wq(tt));Re.set(v.$_k,st);const pt=this.B(new U.$nr(tt));st.registerProvider(T.Schemas.file,pt);const dt=new qe.$Os(st);Re.set(Ue.$Jl,dt);const rt=this.B(new Ce.$rR(this.f.profiles.all,A.URI.revive(this.f.profiles.home).with({scheme:Xe.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));Re.set(fe.$Ll,rt);const wt=this.B(new Me.$agc(T.Schemas.file,this.B(new Be.$6Q(Ge.getChannel(Be.$5Q),{pathCaseSensitive:He.$k})),T.Schemas.vscodeUserData,rt,dt,tt));st.registerProvider(T.Schemas.vscodeUserData,wt);const ct=this.B(new g.$To(rt.defaultProfile.settingsResource,st,et,tt));Re.set(I.$_i,ct);const bt=new Mt.$2gc(void 0,{defaultProfile:rt.defaultProfile,currentProfile:rt.defaultProfile},Ge,Xe);Re.set(ce.$cq,bt),this.B((0,O.$Uc)(()=>bt.flush())),await Promise.all([ct.initialize(),bt.initialize()]);const It=new Nt.$0r(Ge.getChannel("request"));Re.set(re.$2p,It),Re.set(f.$xgc,new F.$Ci(w.$ygc,void 0,!1)),Re.set(We.$KG,new F.$Ci(ze.$Kgc,void 0,!1));const Rt=new Dt.$egc(-1,Ge);Re.set(Tt.$Wec,Rt),Re.set(s.$Xo,new F.$Ci(r.$zR,void 0,!0));const Gt=this.B(new de.$Ffc(Rt)),Kt=new S.$ni(Ze=>Gt.getActiveClientId().then(mt=>Ze===mt));Re.set(E.$Z5b,new Ct.$Xgc(this.a.getChannel("extensionRecommendationNotification",Kt)));let gt;const lt=[],Pt=(0,B.$Fp)(De,ct);if((0,B.$Ap)(De,Xe)){const Ze=new H.$Bcc(tt,ot,Xe,De);if(lt.push(Ze),!(0,B.$Bp)(De,Xe)&&De.aiConfig?.ariaKey){const mt=new je.$$Q(It,Pt,"monacoworkbench",null,De.aiConfig.ariaKey);this.B((0,O.$Uc)(()=>mt.flush())),lt.push(mt)}gt=new D.$bs({appenders:lt,commonProperties:(0,q.$rp)((0,P.release)(),(0,P.hostname)(),process.arch,De.commit,De.version,this.f.machineId,this.f.sqmId,this.f.devDeviceId,Pt),sendErrorTelemetry:!0,piiPaths:(0,B.$Gp)(Xe)},ct,De)}else{gt=B.$vp;const Ze=B.$zp;lt.push(Ze)}this.a.registerChannel("telemetryAppender",new J.$kfc(lt)),Re.set(x.$$l,gt);const Jt=new j.$zgc(ct,gt,tt,ot,Xe,De);Re.set(x.$_l,Jt),Re.set($e.$Dq,new F.$Ci(Lt.$jR,void 0,!0)),Re.set(Ne.$Hq,new F.$Ci(se.$Jfc,void 0,!0)),Re.set(y.$nq,new F.$Ci(y.$pq,void 0,!0)),Re.set(k.$Sq,new F.$Ci(k.$Tq,void 0,!0)),Re.set(l.$hp,new F.$Ci(o.$lq,void 0,!0)),Re.set(l.$op,new F.$Ci(Ft.$1gc,void 0,!1)),Re.set(Q.$6r,new F.$Ci(G.$8r,void 0,!1)),Re.set(u.$Sm,new F.$Ci(t.$Vs,void 0,!1)),Re.set(Y.$ELb,new F.$Ci(Y.$FLb,void 0,!0)),Re.set(_.$_mb,new F.$Ci(ge.$$Nb,void 0,!0)),Re.set(_.$$mb,S.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ze=>Ze.ctx!=="main"))),Re.set(l.$np,new F.$Ci(n.$CLb,void 0,!1)),Re.set(te.$9Nb,new F.$Ci(te.$0Nb,void 0,!0)),Re.set(W.$jw,new F.$Ci(W.$kw)),Re.set(_.$Vmb,new F.$Ci(Se.$dNb,void 0,!0)),Re.set(_.$Wmb,new F.$Ci(Se.$fNb,void 0,!0)),Re.set(we.$Jmb,new F.$Ci(we.$Lmb,void 0,!0)),Re.set(_.$Xmb,new F.$Ci(ae.$edc,void 0,!1)),Re.set(_.$7mb,new F.$Ci(Ee.$6cc,void 0,!0)),Re.set(_.$8mb,new F.$Ci(pe.$jdc,void 0,!1)),Re.set(Ie.$eMb,new F.$Ci(oe.$Ggc,void 0,!0)),Re.set(_.$9mb,new F.$Ci(Qe.$Zdc,void 0,!0)),Re.set(me.$Yl,new F.$Ci(Pe.$0fc,void 0,!1));const kt=new vt.$Wl;return Re.set(vt.$Vl,kt),kt.register(jt.RemoteConnectionType.WebSocket,qt.$3gc),Re.set(Oe.$yw,new F.$Ci(Fe.$8fc)),Re.set(Te.$Hgc,new F.$Ci(Le.$Jgc)),Re.set(Je.$Mgc,new F.$Ci(at.$Wgc)),new X.$qr(Re)}j(Re){const De=new R.$rq(Re.get(l.$kp),()=>null);this.a.registerChannel("extensions",De);const Ke=S.ProxyChannel.fromService(Re.get(Q.$6r),this.q);this.a.registerChannel("languagePacks",Ke);const Ge=S.ProxyChannel.fromService(Re.get(u.$Sm),this.q);this.a.registerChannel("diagnostics",Ge);const et=new R.$tq(Re.get(l.$op));this.a.registerChannel("extensionTipsService",et);const Xe=S.ProxyChannel.fromService(Re.get(f.$xgc),this.q);this.a.registerChannel("checksum",Xe);const ot=S.ProxyChannel.fromService(Re.get(We.$KG),this.q);this.a.registerChannel("v8InspectProfiling",ot);const ft=S.ProxyChannel.fromService(Re.get(we.$Jmb),this.q);this.a.registerChannel("userDataSyncMachines",ft);const $t=S.ProxyChannel.fromService(Re.get(x.$_l),this.q);this.a.registerChannel("customEndpointTelemetry",$t);const tt=new ue.$Agc(Re.get(Y.$ELb));this.a.registerChannel("userDataSyncAccount",tt);const st=new ue.$Cgc(Re.get(_.$Vmb));this.a.registerChannel("userDataSyncStoreManagement",st);const pt=new be.$Egc(Re.get(_.$8mb),Re.get(fe.$Ll),Re.get(ie.$_j));this.a.registerChannel("userDataSync",pt);const dt=this.B(Re.get(M.$Ei).createInstance(Ut.$Zgc));this.a.registerChannel("userDataAutoSync",S.ProxyChannel.fromService(dt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",S.ProxyChannel.fromService(Re.get(_.$9mb),this.q));const rt=S.ProxyChannel.fromService(Re.get(Te.$Hgc),this.q);this.a.registerChannel(Te.$Igc,rt);const wt=S.ProxyChannel.fromService(Re.get(Je.$Mgc),this.q);this.a.registerChannel("remoteTunnel",wt)}m(Re){process.on("uncaughtException",De=>(0,N.$3)(De)),process.on("unhandledRejection",De=>(0,N.$3)(De)),(0,N.setUnexpectedErrorHandler)(De=>{const Ke=(0,a.$qj)(De,!0);Ke&&Re.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}n(Re,De){Re.publicLog2("profilesInfo",{count:De.profiles.length})}async r(Re,De){if(He.$k){const[Ke,Ge]=await Promise.all([(0,zt.$3g)(De.error.bind(De)),(0,Et.$vX)(De.error.bind(De))]),et=(0,Wt.$bX)(),Xe=(0,Et.$wX)(Ge,this.f.args["ozone-platform"]);Ke&&Re.publicLog2("clientPlatformInfo",{platformId:Ke.id,platformVersionId:Ke.version_id,platformIdLike:Ke.id_like,desktopEnvironment:et,displayProtocol:Ge,codeDisplayProtocol:Xe})}}handledClientConnection(Re){if(Re.data!==ht.$hfc.response)return!1;const De=(0,L.$Qb)(Re.ports);return De?(this.c.fire(De),!0):!1}}async function St(ut){try{const Re=new Vt(ut);process.parentPort.postMessage(ht.$ffc.ipcReady),await Re.init(),process.parentPort.postMessage(ht.$ffc.initDone)}catch(Re){process.parentPort.postMessage({error:Re.toString()})}}const Ht=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",ut=>{clearTimeout(Ht),St(ut.data)})})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/0cb5ca1d55b8ac035764b4726b5a01b6da22147d/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
