/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/common/extpath","vs/base/node/pfs","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/base/common/lazy","vs/base/common/themables","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/marshalling","child_process","vs/base/common/decorators","vs/base/common/hash","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTesting","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/iconLabels","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ce){for(var e=[],r=0,h=ce.length;r<h;r++)e[r]=Ee[ce[r]];return e};define(Ee[173],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W=e.LoaderEventType=e.$V=void 0,e.$V=!1;var r;(function(A){A[A.LoaderAvailable=1]="LoaderAvailable",A[A.BeginLoadingScript=10]="BeginLoadingScript",A[A.EndLoadingScriptOK=11]="EndLoadingScriptOK",A[A.EndLoadingScriptError=12]="EndLoadingScriptError",A[A.BeginInvokeFactory=21]="BeginInvokeFactory",A[A.EndInvokeFactory=22]="EndInvokeFactory",A[A.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",A[A.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",A[A.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",A[A.NodeEndNativeRequire=34]="NodeEndNativeRequire",A[A.CachedDataFound=60]="CachedDataFound",A[A.CachedDataMissed=61]="CachedDataMissed",A[A.CachedDataRejected=62]="CachedDataRejected",A[A.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class h{static get(){const R=new Map,L=new Map,O=new Map,$=new Map;function l(b,c){b.has(c.detail)||b.set(c.detail,-c.timestamp)}function I(b,c){const g=b.get(c.detail);g&&(g>=0||b.set(c.detail,g+c.timestamp))}let E=[];typeof ce=="function"&&typeof ce.getStats=="function"&&(E=ce.getStats().slice(0).sort((b,c)=>b.timestamp-c.timestamp));for(const b of E)switch(b.type){case r.BeginLoadingScript:l(R,b);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(R,b);break;case r.BeginInvokeFactory:l(L,b);break;case r.EndInvokeFactory:I(L,b);break;case r.NodeBeginNativeRequire:l(O,b);break;case r.NodeEndNativeRequire:I(O,b);break;case r.NodeBeginEvaluatingScript:l($,b);break;case r.NodeEndEvaluatingScript:I($,b);break}let u=0;O.forEach(b=>u+=b);function k(b){const c=[];return b.forEach((g,d)=>c.push([d,g])),c}return{amdLoad:k(R),amdInvoke:k(L),nodeRequire:k(O),nodeEval:k($),nodeRequireTotal:u}}static toMarkdownTable(R,L){let O="";const $=[];return R.forEach((l,I)=>{$[I]=l.length}),L.forEach(l=>{l.forEach((I,E)=>{typeof I>"u"&&(I=l[E]="-");const u=I.toString().length;$[E]=Math.max(u,$[E])})}),R.forEach((l,I)=>{O+=`| ${l+" ".repeat($[I]-l.toString().length)} `}),O+=`|
`,R.forEach((l,I)=>{O+=`| ${"-".repeat($[I])} `}),O+=`|
`,L.forEach(l=>{l.forEach((I,E)=>{typeof I<"u"&&(O+=`| ${I+" ".repeat($[E]-I.toString().length)} `)}),O+=`|
`}),O}}e.$W=h}),define(Ee[132],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ob=void 0,e.$hb=r,e.$ib=h,e.$jb=A,e.$kb=R,e.$lb=L,e.$mb=O,e.$nb=$,e.$pb=I,e.$qb=E,e.$rb=u,e.$sb=k,e.$tb=b;function r(c,g){const d=h(c,g);if(d!==-1)return c[d]}function h(c,g,d=c.length-1){for(let m=d;m>=0;m--){const n=c[m];if(g(n))return m}return-1}function A(c,g){const d=R(c,g);return d===-1?void 0:c[d]}function R(c,g,d=0,m=c.length){let n=d,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(c[i])?n=i+1:o=i}return n-1}function L(c,g){const d=O(c,g);return d===c.length?void 0:c[d]}function O(c,g,d=0,m=c.length){let n=d,o=m;for(;n<o;){const i=Math.floor((n+o)/2);g(c[i])?o=i:n=i+1}return n}function $(c,g,d=0,m=c.length){const n=O(c,g,d,m);return n===c.length?-1:n}class l{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(l.assertInvariants){if(this.d){for(const m of this.e)if(this.d(m)&&!g(m))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const d=R(this.e,g,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$ob=l;function I(c,g){if(c.length===0)return;let d=c[0];for(let m=1;m<c.length;m++){const n=c[m];g(n,d)>0&&(d=n)}return d}function E(c,g){if(c.length===0)return;let d=c[0];for(let m=1;m<c.length;m++){const n=c[m];g(n,d)>=0&&(d=n)}return d}function u(c,g){return I(c,(d,m)=>-g(d,m))}function k(c,g){if(c.length===0)return-1;let d=0;for(let m=1;m<c.length;m++){const n=c[m];g(n,c[d])>0&&(d=m)}return d}function b(c,g){for(const d of c){const m=g(d);if(m!==void 0)return m}}}),define(Ee[27],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(h){h[h.Null=0]="Null",h[h.Backspace=8]="Backspace",h[h.Tab=9]="Tab",h[h.LineFeed=10]="LineFeed",h[h.CarriageReturn=13]="CarriageReturn",h[h.Space=32]="Space",h[h.ExclamationMark=33]="ExclamationMark",h[h.DoubleQuote=34]="DoubleQuote",h[h.Hash=35]="Hash",h[h.DollarSign=36]="DollarSign",h[h.PercentSign=37]="PercentSign",h[h.Ampersand=38]="Ampersand",h[h.SingleQuote=39]="SingleQuote",h[h.OpenParen=40]="OpenParen",h[h.CloseParen=41]="CloseParen",h[h.Asterisk=42]="Asterisk",h[h.Plus=43]="Plus",h[h.Comma=44]="Comma",h[h.Dash=45]="Dash",h[h.Period=46]="Period",h[h.Slash=47]="Slash",h[h.Digit0=48]="Digit0",h[h.Digit1=49]="Digit1",h[h.Digit2=50]="Digit2",h[h.Digit3=51]="Digit3",h[h.Digit4=52]="Digit4",h[h.Digit5=53]="Digit5",h[h.Digit6=54]="Digit6",h[h.Digit7=55]="Digit7",h[h.Digit8=56]="Digit8",h[h.Digit9=57]="Digit9",h[h.Colon=58]="Colon",h[h.Semicolon=59]="Semicolon",h[h.LessThan=60]="LessThan",h[h.Equals=61]="Equals",h[h.GreaterThan=62]="GreaterThan",h[h.QuestionMark=63]="QuestionMark",h[h.AtSign=64]="AtSign",h[h.A=65]="A",h[h.B=66]="B",h[h.C=67]="C",h[h.D=68]="D",h[h.E=69]="E",h[h.F=70]="F",h[h.G=71]="G",h[h.H=72]="H",h[h.I=73]="I",h[h.J=74]="J",h[h.K=75]="K",h[h.L=76]="L",h[h.M=77]="M",h[h.N=78]="N",h[h.O=79]="O",h[h.P=80]="P",h[h.Q=81]="Q",h[h.R=82]="R",h[h.S=83]="S",h[h.T=84]="T",h[h.U=85]="U",h[h.V=86]="V",h[h.W=87]="W",h[h.X=88]="X",h[h.Y=89]="Y",h[h.Z=90]="Z",h[h.OpenSquareBracket=91]="OpenSquareBracket",h[h.Backslash=92]="Backslash",h[h.CloseSquareBracket=93]="CloseSquareBracket",h[h.Caret=94]="Caret",h[h.Underline=95]="Underline",h[h.BackTick=96]="BackTick",h[h.a=97]="a",h[h.b=98]="b",h[h.c=99]="c",h[h.d=100]="d",h[h.e=101]="e",h[h.f=102]="f",h[h.g=103]="g",h[h.h=104]="h",h[h.i=105]="i",h[h.j=106]="j",h[h.k=107]="k",h[h.l=108]="l",h[h.m=109]="m",h[h.n=110]="n",h[h.o=111]="o",h[h.p=112]="p",h[h.q=113]="q",h[h.r=114]="r",h[h.s=115]="s",h[h.t=116]="t",h[h.u=117]="u",h[h.v=118]="v",h[h.w=119]="w",h[h.x=120]="x",h[h.y=121]="y",h[h.z=122]="z",h[h.OpenCurlyBrace=123]="OpenCurlyBrace",h[h.Pipe=124]="Pipe",h[h.CloseCurlyBrace=125]="CloseCurlyBrace",h[h.Tilde=126]="Tilde",h[h.NoBreakSpace=160]="NoBreakSpace",h[h.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",h[h.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",h[h.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",h[h.U_Combining_Tilde=771]="U_Combining_Tilde",h[h.U_Combining_Macron=772]="U_Combining_Macron",h[h.U_Combining_Overline=773]="U_Combining_Overline",h[h.U_Combining_Breve=774]="U_Combining_Breve",h[h.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",h[h.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",h[h.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",h[h.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",h[h.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",h[h.U_Combining_Caron=780]="U_Combining_Caron",h[h.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",h[h.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",h[h.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",h[h.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",h[h.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",h[h.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",h[h.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",h[h.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",h[h.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",h[h.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",h[h.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",h[h.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",h[h.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",h[h.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",h[h.U_Combining_Horn=795]="U_Combining_Horn",h[h.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",h[h.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",h[h.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",h[h.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",h[h.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",h[h.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",h[h.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",h[h.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",h[h.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",h[h.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",h[h.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",h[h.U_Combining_Cedilla=807]="U_Combining_Cedilla",h[h.U_Combining_Ogonek=808]="U_Combining_Ogonek",h[h.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",h[h.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",h[h.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",h[h.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",h[h.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",h[h.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",h[h.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",h[h.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",h[h.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",h[h.U_Combining_Low_Line=818]="U_Combining_Low_Line",h[h.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",h[h.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",h[h.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",h[h.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",h[h.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",h[h.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",h[h.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",h[h.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",h[h.U_Combining_Square_Below=827]="U_Combining_Square_Below",h[h.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",h[h.U_Combining_X_Above=829]="U_Combining_X_Above",h[h.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",h[h.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",h[h.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",h[h.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",h[h.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",h[h.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",h[h.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",h[h.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",h[h.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",h[h.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",h[h.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",h[h.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",h[h.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",h[h.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",h[h.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",h[h.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",h[h.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",h[h.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",h[h.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",h[h.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",h[h.U_Combining_Fermata=850]="U_Combining_Fermata",h[h.U_Combining_X_Below=851]="U_Combining_X_Below",h[h.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",h[h.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",h[h.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",h[h.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",h[h.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",h[h.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",h[h.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",h[h.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",h[h.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",h[h.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",h[h.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",h[h.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",h[h.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",h[h.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",h[h.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",h[h.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",h[h.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",h[h.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",h[h.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",h[h.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",h[h.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",h[h.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",h[h.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",h[h.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",h[h.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",h[h.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",h[h.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",h[h.LINE_SEPARATOR=8232]="LINE_SEPARATOR",h[h.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",h[h.NEXT_LINE=133]="NEXT_LINE",h[h.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",h[h.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",h[h.U_DIAERESIS=168]="U_DIAERESIS",h[h.U_MACRON=175]="U_MACRON",h[h.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",h[h.U_CEDILLA=184]="U_CEDILLA",h[h.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",h[h.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",h[h.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",h[h.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",h[h.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",h[h.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",h[h.U_BREVE=728]="U_BREVE",h[h.U_DOT_ABOVE=729]="U_DOT_ABOVE",h[h.U_RING_ABOVE=730]="U_RING_ABOVE",h[h.U_OGONEK=731]="U_OGONEK",h[h.U_SMALL_TILDE=732]="U_SMALL_TILDE",h[h.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",h[h.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",h[h.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",h[h.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",h[h.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",h[h.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",h[h.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",h[h.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",h[h.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",h[h.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",h[h.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",h[h.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",h[h.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",h[h.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",h[h.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",h[h.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",h[h.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",h[h.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",h[h.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",h[h.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",h[h.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",h[h.U_GREEK_TONOS=900]="U_GREEK_TONOS",h[h.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",h[h.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",h[h.U_GREEK_PSILI=8127]="U_GREEK_PSILI",h[h.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",h[h.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",h[h.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",h[h.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",h[h.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",h[h.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",h[h.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",h[h.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",h[h.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",h[h.U_GREEK_VARIA=8175]="U_GREEK_VARIA",h[h.U_GREEK_OXIA=8189]="U_GREEK_OXIA",h[h.U_GREEK_DASIA=8190]="U_GREEK_DASIA",h[h.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",h[h.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",h[h.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",h[h.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",h[h.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",h[h.U_OVERLINE=8254]="U_OVERLINE",h[h.UTF8_BOM=65279]="UTF8_BOM",h[h.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",h[h.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Ee[79],Se([1,0]),function(ce,e){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$O=void 0,e.$K=h,e.$L=A,e.$M=R,e.$N=L;function h($,l){const I=Object.create(null);for(const E of $){const u=l(E);let k=I[u];k||(k=I[u]=[]),k.push(E)}return I}function A($,l){const I=[],E=[];for(const u of $)l.has(u)||I.push(u);for(const u of l)$.has(u)||E.push(u);return{removed:I,added:E}}function R($,l){const I=[],E=[];for(const[u,k]of $)l.has(u)||I.push(k);for(const[u,k]of l)$.has(u)||E.push(k);return{removed:I,added:E}}function L($,l){const I=new Set;for(const E of l)$.has(E)&&I.add(E);return I}class O{static{r=Symbol.toStringTag}constructor(l,I){this.b=I,this.a=new Map,this[r]="SetWithKey";for(const E of l)this.add(E)}get size(){return this.a.size}add(l){const I=this.b(l);return this.a.set(I,l),this}delete(l){return this.a.delete(this.b(l))}has(l){return this.a.has(this.b(l))}*entries(){for(const l of this.a.values())yield[l,l]}keys(){return this.values()}*values(){for(const l of this.a.values())yield l}clear(){this.a.clear()}forEach(l,I){this.a.forEach(E=>l.call(I,E,E,this))}[Symbol.iterator](){return this.values()}}e.$O=O}),define(Ee[59],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=h,e.$$h=A,e.$_h=R;function r(L){return(O,$,l)=>{let I=null,E=null;if(typeof l.value=="function"?(I="value",E=l.value):typeof l.get=="function"&&(I="get",E=l.get),!E)throw new Error("not supported");l[I]=L(E,$)}}function h(L,O,$){let l=null,I=null;if(typeof $.value=="function"?(l="value",I=$.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(l="get",I=$.get),!I)throw new Error("not supported");const E=`$memoize$${O}`;$[l]=function(...u){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,u)}),this[E]}}function A(L,O,$){return r((l,I)=>{const E=`$debounce$${I}`,u=`$debounce$result$${I}`;return function(...k){this[u]||(this[u]=$?$():void 0),clearTimeout(this[E]),O&&(this[u]=O(this[u],...k),k=[this[u]]),this[E]=setTimeout(()=>{l.apply(this,k),this[u]=$?$():void 0},L)}})}function R(L,O,$){return r((l,I)=>{const E=`$throttle$timer$${I}`,u=`$throttle$result$${I}`,k=`$throttle$lastRun$${I}`,b=`$throttle$pending$${I}`;return function(...c){if(this[u]||(this[u]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),O&&(this[u]=O(this[u],...c)),this[b])return;const g=this[k]+L;g<=Date.now()?(this[k]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[k]=Date.now(),l.apply(this,[this[u]]),this[u]=$?$():void 0},g-Date.now()))}})}}),define(Ee[14],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eb=e.$db=e.$cb=e.$bb=e.$ab=e.$$=e.$7=e.$Z=e.$Y=void 0,e.setUnexpectedErrorHandler=h,e.$2=A,e.$3=R,e.$4=L,e.$5=O,e.$6=l,e.$8=E,e.$9=u,e.$0=k,e.$_=c;class r{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$Y=r,e.$Z=new r;function h(i){e.$Z.setUnexpectedErrorHandler(i)}function A(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(i){l(i)||e.$Z.onUnexpectedError(i)}function L(i){l(i)||e.$Z.onUnexpectedExternalError(i)}function O(i){if(i instanceof Error){const{name:t,message:s}=i,f=i.stacktrace||i.stack;return{$isError:!0,name:t,message:s,stack:f,noTelemetry:n.isErrorNoTelemetry(i)}}return i}const $="Canceled";function l(i){return i instanceof I?!0:i instanceof Error&&i.name===$&&i.message===$}class I extends Error{constructor(){super($),this.name=this.message}}e.$7=I;function E(){const i=new Error($);return i.name=i.message,i}function u(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function k(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class b extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$$=b;function c(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$ab=g;class d extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$bb=d;class m extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$cb=m;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const s=new n;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$db=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$eb=o}),define(Ee[19],Se([1,0,14,132]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.$ac=e.$$b=e.$0b=e.CompareResult=void 0,e.$ub=A,e.$vb=R,e.$wb=L,e.$xb=O,e.$yb=$,e.$zb=l,e.$Ab=I,e.$Bb=E,e.$Cb=u,e.$Db=k,e.$Eb=b,e.$Fb=c,e.$Gb=g,e.top=d,e.$Ib=m,e.$Jb=o,e.$Kb=i,e.$Lb=t,e.$Mb=s,e.$Nb=f,e.$Ob=a,e.$Pb=w,e.$Qb=y,e.$Rb=S,e.$Sb=D,e.$Tb=P,e.$Ub=C,e.$Vb=p,e.$Wb=v,e.$Xb=N,e.$Yb=T,e.$Zb=M,e.$1b=j,e.$2b=z,e.$3b=F,e.$4b=B,e.$5b=_,e.$6b=re,e.$7b=U,e.$8b=ee,e.$9b=ue,e.$_b=$e;function A(oe,te=0){return oe[oe.length-(1+te)]}function R(oe){if(oe.length===0)throw new Error("Invalid tail call");return[oe.slice(0,oe.length-1),oe[oe.length-1]]}function L(oe,te,le=(he,X)=>he===X){if(oe===te)return!0;if(!oe||!te||oe.length!==te.length)return!1;for(let he=0,X=oe.length;he<X;he++)if(!le(oe[he],te[he]))return!1;return!0}function O(oe,te){const le=oe.length-1;te<le&&(oe[te]=oe[le]),oe.pop()}function $(oe,te,le){return l(oe.length,he=>le(oe[he],te))}function l(oe,te){let le=0,he=oe-1;for(;le<=he;){const X=(le+he)/2|0,ae=te(X);if(ae<0)le=X+1;else if(ae>0)he=X-1;else return X}return-(le+1)}function I(oe,te,le){if(oe=oe|0,oe>=te.length)throw new TypeError("invalid index");const he=te[Math.floor(te.length*Math.random())],X=[],ae=[],pe=[];for(const be of te){const Fe=le(be,he);Fe<0?X.push(be):Fe>0?ae.push(be):pe.push(be)}return oe<X.length?I(oe,X,le):oe<X.length+pe.length?pe[0]:I(oe-(X.length+pe.length),ae,le)}function E(oe,te){const le=[];let he;for(const X of oe.slice(0).sort(te))!he||te(he[0],X)!==0?(he=[X],le.push(he)):he.push(X);return le}function*u(oe,te){let le,he;for(const X of oe)he!==void 0&&te(he,X)?le.push(X):(le&&(yield le),le=[X]),he=X;le&&(yield le)}function k(oe,te){for(let le=0;le<=oe.length;le++)te(le===0?void 0:oe[le-1],le===oe.length?void 0:oe[le])}function b(oe,te){for(let le=0;le<oe.length;le++)te(le===0?void 0:oe[le-1],oe[le],le+1===oe.length?void 0:oe[le+1])}function c(oe,te,le){const he=[];function X(be,Fe,Be){if(Fe===0&&Be.length===0)return;const ke=he[he.length-1];ke&&ke.start+ke.deleteCount===be?(ke.deleteCount+=Fe,ke.toInsert.push(...Be)):he.push({start:be,deleteCount:Fe,toInsert:Be})}let ae=0,pe=0;for(;;){if(ae===oe.length){X(ae,0,te.slice(pe));break}if(pe===te.length){X(ae,oe.length-ae,[]);break}const be=oe[ae],Fe=te[pe],Be=le(be,Fe);Be===0?(ae+=1,pe+=1):Be<0?(X(ae,1,[]),ae+=1):Be>0&&(X(ae,0,[Fe]),pe+=1)}return he}function g(oe,te,le){const he=c(oe,te,le),X=[],ae=[];for(const pe of he)X.push(...oe.slice(pe.start,pe.start+pe.deleteCount)),ae.push(...pe.toInsert);return{removed:X,added:ae}}function d(oe,te,le){if(le===0)return[];const he=oe.slice(0,le).sort(te);return n(oe,te,he,le,oe.length),he}function m(oe,te,le,he,X){return le===0?Promise.resolve([]):new Promise((ae,pe)=>{(async()=>{const be=oe.length,Fe=oe.slice(0,le).sort(te);for(let Be=le,ke=Math.min(le+he,be);Be<be;Be=ke,ke=Math.min(ke+he,be)){if(Be>le&&await new Promise(Ie=>setTimeout(Ie)),X&&X.isCancellationRequested)throw new r.$7;n(oe,te,Fe,Be,ke)}return Fe})().then(ae,pe)})}function n(oe,te,le,he,X){for(const ae=le.length;he<X;he++){const pe=oe[he];if(te(pe,le[ae-1])<0){le.pop();const be=(0,h.$mb)(le,Fe=>te(pe,Fe)<0);le.splice(be,0,pe)}}}function o(oe){return oe.filter(te=>!!te)}function i(oe){let te=0;for(let le=0;le<oe.length;le++)oe[le]&&(oe[te]=oe[le],te+=1);oe.length=te}function t(oe,te,le){oe.splice(le,0,oe.splice(te,1)[0])}function s(oe){return!Array.isArray(oe)||oe.length===0}function f(oe){return Array.isArray(oe)&&oe.length>0}function a(oe,te=le=>le){const le=new Set;return oe.filter(he=>{const X=te(he);return le.has(X)?!1:(le.add(X),!0)})}function w(oe){const te=new Set;return le=>{const he=oe(le);return te.has(he)?!1:(te.add(he),!0)}}function y(oe,te){return oe.length>0?oe[0]:te}function S(oe,te){return oe.length>0?oe[oe.length-1]:te}function D(oe,te,le=(he,X)=>he===X){let he=0;for(let X=0,ae=Math.min(oe.length,te.length);X<ae&&le(oe[X],te[X]);X++)he++;return he}function P(oe,te){let le=typeof te=="number"?oe:0;typeof te=="number"?le=oe:(le=0,te=oe);const he=[];if(le<=te)for(let X=le;X<te;X++)he.push(X);else for(let X=le;X>te;X--)he.push(X);return he}function C(oe,te,le){return oe.reduce((he,X)=>(he[te(X)]=le?le(X):X,he),Object.create(null))}function p(oe,te){return oe.push(te),()=>v(oe,te)}function v(oe,te){const le=oe.indexOf(te);if(le>-1)return oe.splice(le,1),te}function N(oe,te,le){const he=oe.slice(0,te),X=oe.slice(te);return he.concat(le,X)}function T(oe,te){let le;if(typeof te=="number"){let he=te;le=()=>{const X=Math.sin(he++)*179426549;return X-Math.floor(X)}}else le=Math.random;for(let he=oe.length-1;he>0;he-=1){const X=Math.floor(le()*(he+1)),ae=oe[he];oe[he]=oe[X],oe[X]=ae}}function M(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.unshift(te))}function j(oe,te){const le=oe.indexOf(te);le>-1&&(oe.splice(le,1),oe.push(te))}function z(oe,te){for(const le of te)oe.push(le)}function F(oe,te){return Array.isArray(oe)?oe.map(te):te(oe)}function B(oe){return Array.isArray(oe)?oe:[oe]}function _(oe){return oe[Math.floor(Math.random()*oe.length)]}function re(oe,te,le){const he=G(oe,te),X=oe.length,ae=le.length;oe.length=X+ae;for(let pe=X-1;pe>=he;pe--)oe[pe+ae]=oe[pe];for(let pe=0;pe<ae;pe++)oe[pe+he]=le[pe]}function U(oe,te,le,he){const X=G(oe,te);let ae=oe.splice(X,le);return ae===void 0&&(ae=[]),re(oe,X,he),ae}function G(oe,te){return te<0?Math.max(te+oe.length,0):Math.min(te,oe.length)}var Q;(function(oe){function te(ae){return ae<0}oe.isLessThan=te;function le(ae){return ae<=0}oe.isLessThanOrEqual=le;function he(ae){return ae>0}oe.isGreaterThan=he;function X(ae){return ae===0}oe.isNeitherLessOrGreaterThan=X,oe.greaterThan=1,oe.lessThan=-1,oe.neitherLessOrGreaterThan=0})(Q||(e.CompareResult=Q={}));function ee(oe,te){return(le,he)=>te(oe(le),oe(he))}function ue(...oe){return(te,le)=>{for(const he of oe){const X=he(te,le);if(!Q.isNeitherLessOrGreaterThan(X))return X}return Q.neitherLessOrGreaterThan}}const ne=(oe,te)=>oe-te;e.$0b=ne;const De=(oe,te)=>(0,e.$0b)(oe?1:0,te?1:0);e.$$b=De;function $e(oe){return(te,le)=>-oe(te,le)}class K{constructor(te){this.g=te,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(te){let le=this.c;for(;le<this.g.length&&te(this.g[le]);)le++;const he=le===this.c?null:this.g.slice(this.c,le);return this.c=le,he}takeFromEndWhile(te){let le=this.d;for(;le>=0&&te(this.g[le]);)le--;const he=le===this.d?null:this.g.slice(le+1,this.d+1);return this.d=le,he}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const te=this.g[this.c];return this.c++,te}removeLast(){const te=this.g[this.d];return this.d--,te}takeCount(te){const le=this.g.slice(this.c,this.c+te);return this.c+=te,le}}e.$ac=K;class W{static{this.empty=new W(te=>{})}constructor(te){this.iterate=te}forEach(te){this.iterate(le=>(te(le),!0))}toArray(){const te=[];return this.iterate(le=>(te.push(le),!0)),te}filter(te){return new W(le=>this.iterate(he=>te(he)?le(he):!0))}map(te){return new W(le=>this.iterate(he=>le(te(he))))}some(te){let le=!1;return this.iterate(he=>(le=te(he),!le)),le}findFirst(te){let le;return this.iterate(he=>te(he)?(le=he,!1):!0),le}findLast(te){let le;return this.iterate(he=>(te(he)&&(le=he),!0)),le}findLastMaxBy(te){let le,he=!0;return this.iterate(X=>((he||Q.isGreaterThan(te(X,le)))&&(he=!1,le=X),!0)),le}}e.$bc=W;class se{constructor(te){this.c=te}static createSortPermutation(te,le){const he=Array.from(te.keys()).sort((X,ae)=>le(te[X],te[ae]));return new se(he)}apply(te){return te.map((le,he)=>te[this.c[he]])}inverse(){const te=this.c.slice();for(let le=0;le<this.c.length;le++)te[this.c[le]]=le;return new se(te)}}e.$cc=se}),define(Ee[66],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=h,e.$gd=A,e.$hd=R,e.$id=L,e.$jd=O,e.$kd=$;function h(l,I){if(!l)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function A(l,I="Unreachable"){throw new Error(I)}function R(l,I="unexpected state"){if(!l)throw new r.$eb(`Assertion Failed: ${I}`)}function L(l){l||(0,r.$3)(new r.$eb("Soft Assertion Failed"))}function O(l){if(!l()){debugger;l(),(0,r.$3)(new r.$eb("Assertion Failed"))}}function $(l,I){let E=0;for(;E<l.length-1;){const u=l[E],k=l[E+1];if(!I(u,k))return!1;E++}return!0}});var Un=this&&this.__createBinding||(Object.create?function(ce,e,r,h){h===void 0&&(h=r);var A=Object.getOwnPropertyDescriptor(e,r);(!A||("get"in A?!e.__esModule:A.writable||A.configurable))&&(A={enumerable:!0,get:function(){return e[r]}}),Object.defineProperty(ce,h,A)}:function(ce,e,r,h){h===void 0&&(h=r),ce[h]=e[r]}),Wn=this&&this.__setModuleDefault||(Object.create?function(ce,e){Object.defineProperty(ce,"default",{enumerable:!0,value:e})}:function(ce,e){ce.default=e}),We=this&&this.__importStar||function(ce){if(ce&&ce.__esModule)return ce;var e={};if(ce!=null)for(var r in ce)r!=="default"&&Object.prototype.hasOwnProperty.call(ce,r)&&Un(e,ce,r);return Wn(e,ce),e};define(Ee[174],Se([1,0,19]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=A,e.$0c=R,e.$$c=L,e.$_c=O,e.$ad=$,e.$bd=l,r=We(r);const h=(k,b)=>k===b;e.$8c=h;function A(k=e.$8c){return(b,c)=>r.$wb(b,c,k)}function R(){return(k,b)=>JSON.stringify(k)===JSON.stringify(b)}function L(){return(k,b)=>k.equals(b)}function O(k,b,c){if(c!==void 0){const g=k;return g==null||b===void 0||b===null?b===g:c(g,b)}else{const g=k;return(d,m)=>d==null||m===void 0||m===null?m===d:g(d,m)}}function $(k,b){if(k===b)return!0;if(Array.isArray(k)&&Array.isArray(b)){if(k.length!==b.length)return!1;for(let c=0;c<k.length;c++)if(!$(k[c],b[c]))return!1;return!0}if(k&&typeof k=="object"&&b&&typeof b=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf(b)===Object.prototype){const c=k,g=b,d=Object.keys(c),m=Object.keys(g),n=new Set(m);if(d.length!==m.length)return!1;for(const o of d)if(!n.has(o)||!$(c[o],g[o]))return!1;return!0}return!1}function l(k){return JSON.stringify(u(k))}let I=0;const E=new WeakMap;function u(k){if(Array.isArray(k))return k.map(u);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const b=k,c=Object.create(null);for(const g of Object.keys(b).sort())c[g]=u(b[g]);return c}else{let b=E.get(k);return b===void 0&&(b=I++,E.set(k,b)),b+"----2b76a038c20c4bcc"}return k}}),define(Ee[80],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fb=r;function r(h,A){const R=this;let L=!1,O;return function(){if(L)return O;if(L=!0,A)try{O=h.apply(R,arguments)}finally{A()}else O=h.apply(R,arguments);return O}}}),define(Ee[133],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0;class r{constructor(A){this.a=A,this.b=0}nextId(){return this.a+ ++this.b}}e.$2P=r,e.$3P=new r("id#")}),define(Ee[40],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(h){function A(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}h.is=A;const R=Object.freeze([]);function L(){return R}h.empty=L;function*O(s){yield s}h.single=O;function $(s){return A(s)?s:O(s)}h.wrap=$;function l(s){return s||R}h.from=l;function*I(s){for(let f=s.length-1;f>=0;f--)yield s[f]}h.reverse=I;function E(s){return!s||s[Symbol.iterator]().next().done===!0}h.isEmpty=E;function u(s){return s[Symbol.iterator]().next().value}h.first=u;function k(s,f){let a=0;for(const w of s)if(f(w,a++))return!0;return!1}h.some=k;function b(s,f){for(const a of s)if(f(a))return a}h.find=b;function*c(s,f){for(const a of s)f(a)&&(yield a)}h.filter=c;function*g(s,f){let a=0;for(const w of s)yield f(w,a++)}h.map=g;function*d(s,f){let a=0;for(const w of s)yield*f(w,a++)}h.flatMap=d;function*m(...s){for(const f of s)yield*f}h.concat=m;function n(s,f,a){let w=a;for(const y of s)w=f(w,y);return w}h.reduce=n;function*o(s,f,a=s.length){for(f<0&&(f+=s.length),a<0?a+=s.length:a>s.length&&(a=s.length);f<a;f++)yield s[f]}h.slice=o;function i(s,f=Number.POSITIVE_INFINITY){const a=[];if(f===0)return[a,s];const w=s[Symbol.iterator]();for(let y=0;y<f;y++){const S=w.next();if(S.done)return[a,h.empty()];a.push(S.value)}return[a,{[Symbol.iterator](){return w}}]}h.consume=i;async function t(s){const f=[];for await(const a of s)f.push(a);return Promise.resolve(f)}h.asyncToArray=t})(r||(e.Iterable=r={}))}),define(Ee[175],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=L,e.$Un=E,e.$Vn=u,e.$Wn=k,e.$Xn=b,e.$Yn=c,e.$Zn=g,e.$1n=d,e.$2n=m,e.$3n=n,e.$4n=o,e.$5n=i;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var h;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(h||(e.SyntaxKind=h={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,s=!1){let f=0;const a=t.length;let w="",y=0,S=h.Unknown,D=r.None;function P(j){let z=0,F=0;for(;z<j;){const B=t.charCodeAt(f);if(B>=I._0&&B<=I._9)F=F*16+B-I._0;else if(B>=I.A&&B<=I.F)F=F*16+B-I.A+10;else if(B>=I.a&&B<=I.f)F=F*16+B-I.a+10;else break;f++,z++}return z<j&&(F=-1),F}function C(j){f=j,w="",y=0,S=h.Unknown,D=r.None}function p(){const j=f;if(t.charCodeAt(f)===I._0)f++;else for(f++;f<t.length&&l(t.charCodeAt(f));)f++;if(f<t.length&&t.charCodeAt(f)===I.dot)if(f++,f<t.length&&l(t.charCodeAt(f)))for(f++;f<t.length&&l(t.charCodeAt(f));)f++;else return D=r.UnexpectedEndOfNumber,t.substring(j,f);let z=f;if(f<t.length&&(t.charCodeAt(f)===I.E||t.charCodeAt(f)===I.e))if(f++,(f<t.length&&t.charCodeAt(f)===I.plus||t.charCodeAt(f)===I.minus)&&f++,f<t.length&&l(t.charCodeAt(f))){for(f++;f<t.length&&l(t.charCodeAt(f));)f++;z=f}else D=r.UnexpectedEndOfNumber;return t.substring(j,z)}function v(){let j="",z=f;for(;;){if(f>=a){j+=t.substring(z,f),D=r.UnexpectedEndOfString;break}const F=t.charCodeAt(f);if(F===I.doubleQuote){j+=t.substring(z,f),f++;break}if(F===I.backslash){if(j+=t.substring(z,f),f++,f>=a){D=r.UnexpectedEndOfString;break}switch(t.charCodeAt(f++)){case I.doubleQuote:j+='"';break;case I.backslash:j+="\\";break;case I.slash:j+="/";break;case I.b:j+="\b";break;case I.f:j+="\f";break;case I.n:j+=`
`;break;case I.r:j+="\r";break;case I.t:j+="	";break;case I.u:{const _=P(4);_>=0?j+=String.fromCharCode(_):D=r.InvalidUnicode;break}default:D=r.InvalidEscapeCharacter}z=f;continue}if(F>=0&&F<=31)if($(F)){j+=t.substring(z,f),D=r.UnexpectedEndOfString;break}else D=r.InvalidCharacter;f++}return j}function N(){if(w="",D=r.None,y=f,f>=a)return y=a,S=h.EOF;let j=t.charCodeAt(f);if(O(j)){do f++,w+=String.fromCharCode(j),j=t.charCodeAt(f);while(O(j));return S=h.Trivia}if($(j))return f++,w+=String.fromCharCode(j),j===I.carriageReturn&&t.charCodeAt(f)===I.lineFeed&&(f++,w+=`
`),S=h.LineBreakTrivia;switch(j){case I.openBrace:return f++,S=h.OpenBraceToken;case I.closeBrace:return f++,S=h.CloseBraceToken;case I.openBracket:return f++,S=h.OpenBracketToken;case I.closeBracket:return f++,S=h.CloseBracketToken;case I.colon:return f++,S=h.ColonToken;case I.comma:return f++,S=h.CommaToken;case I.doubleQuote:return f++,w=v(),S=h.StringLiteral;case I.slash:{const z=f-1;if(t.charCodeAt(f+1)===I.slash){for(f+=2;f<a&&!$(t.charCodeAt(f));)f++;return w=t.substring(z,f),S=h.LineCommentTrivia}if(t.charCodeAt(f+1)===I.asterisk){f+=2;const F=a-1;let B=!1;for(;f<F;){if(t.charCodeAt(f)===I.asterisk&&t.charCodeAt(f+1)===I.slash){f+=2,B=!0;break}f++}return B||(f++,D=r.UnexpectedEndOfComment),w=t.substring(z,f),S=h.BlockCommentTrivia}return w+=String.fromCharCode(j),f++,S=h.Unknown}case I.minus:if(w+=String.fromCharCode(j),f++,f===a||!l(t.charCodeAt(f)))return S=h.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return w+=p(),S=h.NumericLiteral;default:for(;f<a&&T(j);)f++,j=t.charCodeAt(f);if(y!==f){switch(w=t.substring(y,f),w){case"true":return S=h.TrueKeyword;case"false":return S=h.FalseKeyword;case"null":return S=h.NullKeyword}return S=h.Unknown}return w+=String.fromCharCode(j),f++,S=h.Unknown}}function T(j){if(O(j)||$(j))return!1;switch(j){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function M(){let j;do j=N();while(j>=h.LineCommentTrivia&&j<=h.Trivia);return j}return{setPosition:C,getPosition:()=>f,scan:s?M:N,getToken:()=>S,getTokenValue:()=>w,getTokenOffset:()=>y,getTokenLength:()=>f-y,getTokenError:()=>D}}function O(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function $(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function l(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,s){const f=[],a=new Object;let w;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function D(P,C,p,v){y.value=P,y.offset=C,y.length=p,y.type=v,y.colonOffset=void 0,w=y}try{n(t,{onObjectBegin:(P,C)=>{if(s<=P)throw a;w=void 0,S=s>P,f.push("")},onObjectProperty:(P,C,p)=>{if(s<C||(D(P,C,p,"property"),f[f.length-1]=P,s<=C+p))throw a},onObjectEnd:(P,C)=>{if(s<=P)throw a;w=void 0,f.pop()},onArrayBegin:(P,C)=>{if(s<=P)throw a;w=void 0,f.push(0)},onArrayEnd:(P,C)=>{if(s<=P)throw a;w=void 0,f.pop()},onLiteralValue:(P,C,p)=>{if(s<C||(D(P,C,p,i(P)),s<=C+p))throw a},onSeparator:(P,C,p)=>{if(s<=C)throw a;if(P===":"&&w&&w.type==="property")w.colonOffset=C,S=!1,w=void 0;else if(P===","){const v=f[f.length-1];typeof v=="number"?f[f.length-1]=v+1:(S=!0,f[f.length-1]=""),w=void 0}}})}catch(P){if(P!==a)throw P}return{path:f,previousNode:w,isAtPropertyKey:S,matches:P=>{let C=0;for(let p=0;C<P.length&&p<f.length;p++)if(P[C]===f[p]||P[C]==="*")C++;else if(P[C]!=="**")return!1;return C===P.length}}}function u(t,s=[],f=R.DEFAULT){let a=null,w=[];const y=[];function S(P){Array.isArray(w)?w.push(P):a!==null&&(w[a]=P)}return n(t,{onObjectBegin:()=>{const P={};S(P),y.push(w),w=P,a=null},onObjectProperty:P=>{a=P},onObjectEnd:()=>{w=y.pop()},onArrayBegin:()=>{const P=[];S(P),y.push(w),w=P,a=null},onArrayEnd:()=>{w=y.pop()},onLiteralValue:S,onError:(P,C,p)=>{s.push({error:P,offset:C,length:p})}},f),w[0]}function k(t,s=[],f=R.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(P){a.type==="property"&&(a.length=P-a.offset,a=a.parent)}function y(P){return a.children.push(P),P}n(t,{onObjectBegin:P=>{a=y({type:"object",offset:P,length:-1,parent:a,children:[]})},onObjectProperty:(P,C,p)=>{a=y({type:"property",offset:C,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:P,offset:C,length:p,parent:a})},onObjectEnd:(P,C)=>{a.length=P+C-a.offset,a=a.parent,w(P+C)},onArrayBegin:(P,C)=>{a=y({type:"array",offset:P,length:-1,parent:a,children:[]})},onArrayEnd:(P,C)=>{a.length=P+C-a.offset,a=a.parent,w(P+C)},onLiteralValue:(P,C,p)=>{y({type:i(P),offset:C,length:p,parent:a,value:P}),w(C+p)},onSeparator:(P,C,p)=>{a.type==="property"&&(P===":"?a.colonOffset=C:P===","&&w(C))},onError:(P,C,p)=>{s.push({error:P,offset:C,length:p})}},f);const D=a.children[0];return D&&delete D.parent,D}function b(t,s){if(!t)return;let f=t;for(const a of s)if(typeof a=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let w=!1;for(const y of f.children)if(Array.isArray(y.children)&&y.children[0].value===a){f=y.children[1],w=!0;break}if(!w)return}else{const w=a;if(f.type!=="array"||w<0||!Array.isArray(f.children)||w>=f.children.length)return;f=f.children[w]}return f}function c(t){if(!t.parent||!t.parent.children)return[];const s=c(t.parent);if(t.parent.type==="property"){const f=t.parent.children[0].value;s.push(f)}else if(t.parent.type==="array"){const f=t.parent.children.indexOf(t);f!==-1&&s.push(f)}return s}function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const s=Object.create(null);for(const f of t.children){const a=f.children[1];a&&(s[f.children[0].value]=g(a))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function d(t,s,f=!1){return s>=t.offset&&s<t.offset+t.length||f&&s===t.offset+t.length}function m(t,s,f=!1){if(d(t,s,f)){const a=t.children;if(Array.isArray(a))for(let w=0;w<a.length&&a[w].offset<=s;w++){const y=m(a[w],s,f);if(y)return y}return t}}function n(t,s,f=R.DEFAULT){const a=L(t,!1);function w(ue){return ue?()=>ue(a.getTokenOffset(),a.getTokenLength()):()=>!0}function y(ue){return ue?ne=>ue(ne,a.getTokenOffset(),a.getTokenLength()):()=>!0}const S=w(s.onObjectBegin),D=y(s.onObjectProperty),P=w(s.onObjectEnd),C=w(s.onArrayBegin),p=w(s.onArrayEnd),v=y(s.onLiteralValue),N=y(s.onSeparator),T=w(s.onComment),M=y(s.onError),j=f&&f.disallowComments,z=f&&f.allowTrailingComma;function F(){for(;;){const ue=a.scan();switch(a.getTokenError()){case r.InvalidUnicode:B(A.InvalidUnicode);break;case r.InvalidEscapeCharacter:B(A.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:B(A.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||B(A.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:B(A.UnexpectedEndOfString);break;case r.InvalidCharacter:B(A.InvalidCharacter);break}switch(ue){case h.LineCommentTrivia:case h.BlockCommentTrivia:j?B(A.InvalidCommentToken):T();break;case h.Unknown:B(A.InvalidSymbol);break;case h.Trivia:case h.LineBreakTrivia:break;default:return ue}}}function B(ue,ne=[],De=[]){if(M(ue),ne.length+De.length>0){let $e=a.getToken();for(;$e!==h.EOF;){if(ne.indexOf($e)!==-1){F();break}else if(De.indexOf($e)!==-1)break;$e=F()}}}function _(ue){const ne=a.getTokenValue();return ue?v(ne):D(ne),F(),!0}function re(){switch(a.getToken()){case h.NumericLiteral:{let ue=0;try{ue=JSON.parse(a.getTokenValue()),typeof ue!="number"&&(B(A.InvalidNumberFormat),ue=0)}catch{B(A.InvalidNumberFormat)}v(ue);break}case h.NullKeyword:v(null);break;case h.TrueKeyword:v(!0);break;case h.FalseKeyword:v(!1);break;default:return!1}return F(),!0}function U(){return a.getToken()!==h.StringLiteral?(B(A.PropertyNameExpected,[],[h.CloseBraceToken,h.CommaToken]),!1):(_(!1),a.getToken()===h.ColonToken?(N(":"),F(),ee()||B(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken])):B(A.ColonExpected,[],[h.CloseBraceToken,h.CommaToken]),!0)}function G(){S(),F();let ue=!1;for(;a.getToken()!==h.CloseBraceToken&&a.getToken()!==h.EOF;){if(a.getToken()===h.CommaToken){if(ue||B(A.ValueExpected,[],[]),N(","),F(),a.getToken()===h.CloseBraceToken&&z)break}else ue&&B(A.CommaExpected,[],[]);U()||B(A.ValueExpected,[],[h.CloseBraceToken,h.CommaToken]),ue=!0}return P(),a.getToken()!==h.CloseBraceToken?B(A.CloseBraceExpected,[h.CloseBraceToken],[]):F(),!0}function Q(){C(),F();let ue=!1;for(;a.getToken()!==h.CloseBracketToken&&a.getToken()!==h.EOF;){if(a.getToken()===h.CommaToken){if(ue||B(A.ValueExpected,[],[]),N(","),F(),a.getToken()===h.CloseBracketToken&&z)break}else ue&&B(A.CommaExpected,[],[]);ee()||B(A.ValueExpected,[],[h.CloseBracketToken,h.CommaToken]),ue=!0}return p(),a.getToken()!==h.CloseBracketToken?B(A.CloseBracketExpected,[h.CloseBracketToken],[]):F(),!0}function ee(){switch(a.getToken()){case h.OpenBracketToken:return Q();case h.OpenBraceToken:return G();case h.StringLiteral:return _(!0);default:return re()}}return F(),a.getToken()===h.EOF?f.allowEmptyContent?!0:(B(A.ValueExpected,[],[]),!1):ee()?(a.getToken()!==h.EOF&&B(A.EndOfFileExpected,[],[]),!0):(B(A.ValueExpected,[],[]),!1)}function o(t,s){const f=L(t),a=[];let w,y=0,S;do switch(S=f.getPosition(),w=f.scan(),w){case h.LineCommentTrivia:case h.BlockCommentTrivia:case h.EOF:y!==S&&a.push(t.substring(y,S)),s!==void 0&&a.push(f.getTokenValue().replace(/[^\r\n]/g,s)),y=f.getPosition();break}while(w!==h.EOF);return a.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[49],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X=void 0;class r{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$X=r}),define(Ee[81],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0;class r{static{this.Undefined=new r(void 0)}constructor(R){this.element=R,this.next=r.Undefined,this.prev=r.Undefined}}class h{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let R=this.a;for(;R!==r.Undefined;){const L=R.next;R.prev=r.Undefined,R.next=r.Undefined,R=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,L){const O=new r(R);if(this.a===r.Undefined)this.a=O,this.b=O;else if(L){const l=this.b;this.b=O,O.prev=l,l.next=O}else{const l=this.a;this.a=O,O.next=l,l.prev=O}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(O))}}shift(){if(this.a!==r.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==r.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==r.Undefined&&R.next!==r.Undefined){const L=R.prev;L.next=R.next,R.next.prev=L}else R.prev===r.Undefined&&R.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):R.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):R.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==r.Undefined;)yield R.element,R=R.next}}e.$7c=h}),define(Ee[29],Se([1,0]),function(ce,e){"use strict";var r,h,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.Touch=e.$Dc=e.$Cc=void 0,e.$zc=R,e.$Ac=L,e.$Bc=O,e.$Kc=o;function R(i,t,s){let f=i.get(t);return f===void 0&&(f=s,i.set(t,f)),f}function L(i){const t=[];return i.forEach((s,f)=>{t.push(`${f} => ${s}`)}),`Map(${i.size}) {${t.join(", ")}}`}function O(i){const t=[];return i.forEach(s=>{t.push(s)}),`Set(${i.size}) {${t.join(", ")}}`}class ${constructor(t,s){this.uri=t,this.value=s}}function l(i){return Array.isArray(i)}class I{static{this.c=t=>t.toString()}constructor(t,s){if(this[r]="ResourceMap",t instanceof I)this.d=new Map(t.d),this.e=s??I.c;else if(l(t)){this.d=new Map,this.e=s??I.c;for(const[f,a]of t)this.set(f,a)}else this.d=new Map,this.e=t??I.c}set(t,s){return this.d.set(this.e(t),new $(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[f,a]of this.d)t(a.value,a.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Cc=I;class E{constructor(t,s){this[h]="ResourceSet",!t||typeof t=="function"?this.c=new I(t):(this.c=new I(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((f,a)=>t.call(s,a,a,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Dc=E;var u;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(u||(e.Touch=u={}));class k{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=u.None){const f=this.c.get(t);if(f)return s!==u.None&&this.m(f,s),f.value}set(t,s,f=u.None){let a=this.c.get(t);if(a)a.value=s,f!==u.None&&this.m(a,f);else{switch(a={key:t,value:s,next:void 0,previous:void 0},f){case u.None:this.k(a);break;case u.AsOld:this.j(a);break;case u.AsNew:this.k(a);break;default:this.k(a);break}this.c.set(t,a),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const f=this.g;let a=this.d;for(;a;){if(s?t.bind(s)(a.value,a.key,this):t(a.value,a.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const t=this,s=this.g;let f=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.key,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return a}values(){const t=this,s=this.g;let f=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.value,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return a}entries(){const t=this,s=this.g;let f=this.d;const a={[Symbol.iterator](){return a},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:[f.key,f.value],done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,f=this.size;for(;s&&f>t;)this.c.delete(s.key),s=s.next,f--;this.d=s,this.f=f,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,f=this.size;for(;s&&f>t;)this.c.delete(s.key),s=s.previous,f--;this.e=s,this.f=f,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,f=t.previous;if(!s||!f)throw new Error("Invalid list");s.previous=f,f.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==u.AsOld&&s!==u.AsNew)){if(s===u.AsOld){if(t===this.d)return;const f=t.next,a=t.previous;t===this.e?(a.next=void 0,this.e=a):(f.previous=a,a.next=f),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===u.AsNew){if(t===this.e)return;const f=t.next,a=t.previous;t===this.d?(f.previous=void 0,this.d=f):(f.previous=a,a.next=f),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,f)=>{t.push([f,s])}),t}fromJSON(t){this.clear();for(const[s,f]of t)this.set(s,f)}}e.$Ec=k;class b extends k{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=u.AsNew){return super.get(t,s)}peek(t){return super.get(t,u.None)}set(t,s){return super.set(t,s,u.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends b{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Fc=c;class g extends b{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Gc=g;class d{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Hc=d;class m{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,f]of t)this.set(s,f)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((f,a)=>{t.call(s,f,a,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Ic=m;class n{constructor(){this.c=new Map}add(t,s){let f=this.c.get(t);f||(f=new Set,this.c.set(t,f)),f.add(s)}delete(t,s){const f=this.c.get(t);f&&(f.delete(s),f.size===0&&this.c.delete(t))}forEach(t,s){const f=this.c.get(t);f&&f.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Jc=n;function o(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[s,f]of i)if(!t.has(s)||t.get(s)!==f)return!1;for(const[s]of t)if(!i.has(s))return!1;return!0}}),define(Ee[3],Se([1,0,19,79,29,80,40]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=e.$4c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Lc=void 0,e.$Mc=I,e.$Nc=E,e.$Oc=u,e.$Pc=c,e.$Qc=g,e.$Rc=d,e.$Sc=m,e.$Tc=n,e.$Uc=o,e.$5c=P;const O=!1;let $=null;class l{constructor(){this.b=new Map}static{this.a=0}c(v){let N=this.b.get(v);return N||(N={parent:null,source:null,isSingleton:!1,value:v,idx:l.a++},this.b.set(v,N)),N}trackDisposable(v){const N=this.c(v);N.source||(N.source=new Error().stack)}setParent(v,N){const T=this.c(v);T.parent=N}markAsDisposed(v){this.b.delete(v)}markAsSingleton(v){this.c(v).isSingleton=!0}f(v,N){const T=N.get(v);if(T)return T;const M=v.parent?this.f(this.c(v.parent),N):v;return N.set(v,M),M}getTrackedDisposables(){const v=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,v).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(v=10,N){let T;if(N)T=N;else{const B=new Map,_=[...this.b.values()].filter(U=>U.source!==null&&!this.f(U,B).isSingleton);if(_.length===0)return;const re=new Set(_.map(U=>U.value));if(T=_.filter(U=>!(U.parent&&re.has(U.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(B){function _(U,G){for(;U.length>0&&G.some(Q=>typeof Q=="string"?Q===U[0]:U[0].match(Q));)U.shift()}const re=B.source.split(`
`).map(U=>U.trim().replace("at ","")).filter(U=>U!=="");return _(re,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),re.reverse()}const j=new A.$Jc;for(const B of T){const _=M(B);for(let re=0;re<=_.length;re++)j.add(_.slice(0,re).join(`
`),B)}T.sort((0,r.$8b)(B=>B.idx,r.$0b));let z="",F=0;for(const B of T.slice(0,v)){F++;const _=M(B),re=[];for(let U=0;U<_.length;U++){let G=_[U];G=`(shared with ${j.get(_.slice(0,U+1).join(`
`)).size}/${T.length} leaks) at ${G}`;const ee=j.get(_.slice(0,U).join(`
`)),ue=(0,h.$K)([...ee].map(ne=>M(ne)[U]),ne=>ne);delete ue[_[U]];for(const[ne,De]of Object.entries(ue))re.unshift(`    - stacktraces of ${De.length} other leaks continue with ${ne}`);re.unshift(G)}z+=`


==================== Leaking disposable ${F}/${T.length}: ${B.value.constructor.name} ====================
${re.join(`
`)}
============================================================

`}return T.length>v&&(z+=`


... and ${T.length-v} more leaking disposables

`),{leaks:T,details:z}}}e.$Lc=l;function I(p){$=p}if(O){const p="__is_disposable_tracked__";I(new class{trackDisposable(v){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{v[p]||console.log(N)},3e3)}setParent(v,N){if(v&&v!==t.None)try{v[p]=!0}catch{}}markAsDisposed(v){if(v&&v!==t.None)try{v[p]=!0}catch{}}markAsSingleton(v){}})}function E(p){return $?.trackDisposable(p),p}function u(p){$?.markAsDisposed(p)}function k(p,v){$?.setParent(p,v)}function b(p,v){if($)for(const N of p)$.setParent(N,v)}function c(p){return $?.markAsSingleton(p),p}function g(p){return typeof p=="object"&&p!==null&&typeof p.dispose=="function"&&p.dispose.length===0}function d(p){if(L.Iterable.is(p)){const v=[];for(const N of p)if(N)try{N.dispose()}catch(T){v.push(T)}if(v.length===1)throw v[0];if(v.length>1)throw new AggregateError(v,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}function m(p){for(const v of p)g(v)&&v.dispose();return[]}function n(...p){const v=o(()=>d(p));return b(p,v),v}function o(p){const v=E({dispose:(0,R.$fb)(()=>{u(v),p()})});return v}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(u(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(v){if(!v)return v;if(v===this)throw new Error("Cannot register a disposable on itself!");return k(v,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(v),v}delete(v){if(v){if(v===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(v),v.dispose()}}deleteAndLeak(v){v&&this.f.has(v)&&(this.f.delete(v),k(v,null))}}e.$Vc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,E(this),k(this.q,this)}dispose(){u(this),this.q.dispose()}B(v){if(v===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(v)}}e.$Wc=t;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(v){this.b||v===this.a||(this.a?.dispose(),v&&k(v,this),this.a=v)}clear(){this.value=void 0}dispose(){this.b=!0,u(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const v=this.a;return this.a=void 0,v&&k(v,null),v}}e.$Xc=s;class f{constructor(v){this.a=new s,this.b=!1,this.a.value=v}get value(){return this.a.value}set value(v){this.b||v===this.a.value||(this.a.value=v)}dispose(){this.b=!0,this.a.dispose()}}e.$Yc=f;class a{constructor(v){this.b=v,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Zc=a;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(v){let N=v;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,u(this))},this}}e.$1c=w;class y{constructor(){this.a=new Map}acquire(v,...N){let T=this.a.get(v);T||(T={counter:0,object:this.b(v,...N)},this.a.set(v,T));const{object:M}=T,j=(0,R.$fb)(()=>{--T.counter===0&&(this.c(v,T.object),this.a.delete(v))});return T.counter++,{object:M,dispose:j}}}e.$2c=y;class S{constructor(v){this.a=v}async acquire(v,...N){const T=this.a.acquire(v,...N);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$3c=S;class D{constructor(v){this.object=v}dispose(){}}e.$4c=D;function P(p){const v=new i;try{p(v)}finally{v.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){u(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(v){return this.a.has(v)}get size(){return this.a.size}get(v){return this.a.get(v)}set(v,N,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(v)?.dispose(),this.a.set(v,N)}deleteAndDispose(v){this.a.get(v)?.dispose(),this.a.delete(v)}deleteAndLeak(v){const N=this.a.get(v);return this.a.delete(v),N}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$6c=C}),function(ce,e){typeof define=="function"&&define.amd?define(Ee[176],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ce=typeof globalThis<"u"?globalThis:ce||self,e(ce.marked={}))}(this,function(ce){"use strict";function e(te,le){for(var he=0;he<le.length;he++){var X=le[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(te,X.key,X)}}function r(te,le,he){return le&&e(te.prototype,le),he&&e(te,he),Object.defineProperty(te,"prototype",{writable:!1}),te}function h(te,le){if(te){if(typeof te=="string")return A(te,le);var he=Object.prototype.toString.call(te).slice(8,-1);if(he==="Object"&&te.constructor&&(he=te.constructor.name),he==="Map"||he==="Set")return Array.from(te);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return A(te,le)}}function A(te,le){(le==null||le>te.length)&&(le=te.length);for(var he=0,X=new Array(le);he<le;he++)X[he]=te[he];return X}function R(te,le){var he=typeof Symbol<"u"&&te[Symbol.iterator]||te["@@iterator"];if(he)return(he=he.call(te)).next.bind(he);if(Array.isArray(te)||(he=h(te))||le&&te&&typeof te.length=="number"){he&&(te=he);var X=0;return function(){return X>=te.length?{done:!0}:{done:!1,value:te[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ce.defaults=L();function O(te){ce.defaults=te}var $=/[&<>"']/,l=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return u[le]};function b(te,le){if(le){if($.test(te))return te.replace(l,k)}else if(I.test(te))return te.replace(E,k);return te}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(te){return te.replace(c,function(le,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var d=/(^|[^\[])\^/g;function m(te,le){te=typeof te=="string"?te:te.source,le=le||"";var he={replace:function(ae,pe){return pe=pe.source||pe,pe=pe.replace(d,"$1"),te=te.replace(ae,pe),he},getRegex:function(){return new RegExp(te,le)}};return he}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(te,le,he){if(te){var X;try{X=decodeURIComponent(g(he)).replace(n,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}le&&!o.test(he)&&(he=w(le,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var t={},s=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(te,le){t[" "+te]||(s.test(te)?t[" "+te]=te+"/":t[" "+te]=P(te,"/",!0)),te=t[" "+te];var he=te.indexOf(":")===-1;return le.substring(0,2)==="//"?he?le:te.replace(f,"$1")+le:le.charAt(0)==="/"?he?le:te.replace(a,"$1")+le:te+le}var y={exec:function(){}};function S(te){for(var le=1,he,X;le<arguments.length;le++){he=arguments[le];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(te[X]=he[X])}return te}function D(te,le){var he=te.replace(/\|/g,function(pe,be,Fe){for(var Be=!1,ke=be;--ke>=0&&Fe[ke]==="\\";)Be=!Be;return Be?"|":" |"}),X=he.split(/ \|/),ae=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>le)X.splice(le);else for(;X.length<le;)X.push("");for(;ae<X.length;ae++)X[ae]=X[ae].trim().replace(/\\\|/g,"|");return X}function P(te,le,he){var X=te.length;if(X===0)return"";for(var ae=0;ae<X;){var pe=te.charAt(X-ae-1);if(pe===le&&!he)ae++;else if(pe!==le&&he)ae++;else break}return te.slice(0,X-ae)}function C(te,le){if(te.indexOf(le[1])===-1)return-1;for(var he=te.length,X=0,ae=0;ae<he;ae++)if(te[ae]==="\\")ae++;else if(te[ae]===le[0])X++;else if(te[ae]===le[1]&&(X--,X<0))return ae;return-1}function p(te){te&&te.sanitize&&!te.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function v(te,le){if(le<1)return"";for(var he="";le>1;)le&1&&(he+=te),le>>=1,te+=te;return he+te}function N(te,le,he,X){var ae=le.href,pe=le.title?b(le.title):null,be=te[1].replace(/\\([\[\]])/g,"$1");if(te[0].charAt(0)!=="!"){X.state.inLink=!0;var Fe={type:"link",raw:he,href:ae,title:pe,text:be,tokens:X.inlineTokens(be)};return X.state.inLink=!1,Fe}return{type:"image",raw:he,href:ae,title:pe,text:b(be)}}function T(te,le){var he=te.match(/^(\s+)(?:```)/);if(he===null)return le;var X=he[1];return le.split(`
`).map(function(ae){var pe=ae.match(/^\s+/);if(pe===null)return ae;var be=pe[0];return be.length>=X.length?ae.slice(X.length):ae}).join(`
`)}var M=function(){function te(he){this.options=he||ce.defaults}var le=te.prototype;return le.space=function(X){var ae=this.rules.block.newline.exec(X);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},le.code=function(X){var ae=this.rules.block.code.exec(X);if(ae){var pe=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:P(pe,`
`)}}},le.fences=function(X){var ae=this.rules.block.fences.exec(X);if(ae){var pe=ae[0],be=T(pe,ae[3]||"");return{type:"code",raw:pe,lang:ae[2]?ae[2].trim():ae[2],text:be}}},le.heading=function(X){var ae=this.rules.block.heading.exec(X);if(ae){var pe=ae[2].trim();if(/#$/.test(pe)){var be=P(pe,"#");(this.options.pedantic||!be||/ $/.test(be))&&(pe=be.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:pe,tokens:this.lexer.inline(pe)}}},le.hr=function(X){var ae=this.rules.block.hr.exec(X);if(ae)return{type:"hr",raw:ae[0]}},le.blockquote=function(X){var ae=this.rules.block.blockquote.exec(X);if(ae){var pe=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},le.list=function(X){var ae=this.rules.block.list.exec(X);if(ae){var pe,be,Fe,Be,ke,Ie,Oe,q,V,J,x,fe,we=ae[1].trim(),Ne=we.length>1,Ge={type:"list",raw:"",ordered:Ne,start:Ne?+we.slice(0,-1):"",loose:!1,items:[]};we=Ne?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Ne?we:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(fe=!1,!(!(ae=Ke.exec(X))||this.rules.block.hr.test(X)));){if(pe=ae[0],X=X.substring(pe.length),q=ae[2].split(`
`,1)[0],V=X.split(`
`,1)[0],this.options.pedantic?(Be=2,x=q.trimLeft()):(Be=ae[2].search(/[^ ]/),Be=Be>4?1:Be,x=q.slice(Be),Be+=ae[1].length),Ie=!1,!q&&/^ *$/.test(V)&&(pe+=V+`
`,X=X.substring(V.length+1),fe=!0),!fe)for(var tt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ot=new RegExp("^ {0,"+Math.min(3,Be-1)+"}(?:```|~~~)"),nt=new RegExp("^ {0,"+Math.min(3,Be-1)+"}#");X&&(J=X.split(`
`,1)[0],q=J,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ot.test(q)||nt.test(q)||tt.test(q)||rt.test(X)));){if(q.search(/[^ ]/)>=Be||!q.trim())x+=`
`+q.slice(Be);else if(!Ie)x+=`
`+q;else break;!Ie&&!q.trim()&&(Ie=!0),pe+=J+`
`,X=X.substring(J.length+1)}Ge.loose||(Oe?Ge.loose=!0:/\n *\n *$/.test(pe)&&(Oe=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(x),be&&(Fe=be[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:pe,task:!!be,checked:Fe,loose:!1,text:x}),Ge.raw+=pe}Ge.items[Ge.items.length-1].raw=pe.trimRight(),Ge.items[Ge.items.length-1].text=x.trimRight(),Ge.raw=Ge.raw.trimRight();var ct=Ge.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,Ge.items[ke].tokens=this.lexer.blockTokens(Ge.items[ke].text,[]);var $t=Ge.items[ke].tokens.filter(function(at){return at.type==="space"}),ht=$t.every(function(at){for(var Pe=at.raw.split(""),ze=0,Ze=R(Pe),Te;!(Te=Ze()).done;){var Me=Te.value;if(Me===`
`&&(ze+=1),ze>1)return!0}return!1});!Ge.loose&&$t.length&&ht&&(Ge.loose=!0,Ge.items[ke].loose=!0)}return Ge}},le.html=function(X){var ae=this.rules.block.html.exec(X);if(ae){var pe={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ae[0]):b(ae[0]);pe.type="paragraph",pe.text=be,pe.tokens=this.lexer.inline(be)}return pe}},le.def=function(X){var ae=this.rules.block.def.exec(X);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var pe=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:ae[0],href:ae[2],title:ae[3]}}},le.table=function(X){var ae=this.rules.block.table.exec(X);if(ae){var pe={type:"table",header:D(ae[1]).map(function(Oe){return{text:Oe}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=ae[0];var be=pe.align.length,Fe,Be,ke,Ie;for(Fe=0;Fe<be;Fe++)/^ *-+: *$/.test(pe.align[Fe])?pe.align[Fe]="right":/^ *:-+: *$/.test(pe.align[Fe])?pe.align[Fe]="center":/^ *:-+ *$/.test(pe.align[Fe])?pe.align[Fe]="left":pe.align[Fe]=null;for(be=pe.rows.length,Fe=0;Fe<be;Fe++)pe.rows[Fe]=D(pe.rows[Fe],pe.header.length).map(function(Oe){return{text:Oe}});for(be=pe.header.length,Be=0;Be<be;Be++)pe.header[Be].tokens=this.lexer.inline(pe.header[Be].text);for(be=pe.rows.length,Be=0;Be<be;Be++)for(Ie=pe.rows[Be],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return pe}}},le.lheading=function(X){var ae=this.rules.block.lheading.exec(X);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},le.paragraph=function(X){var ae=this.rules.block.paragraph.exec(X);if(ae){var pe=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:pe,tokens:this.lexer.inline(pe)}}},le.text=function(X){var ae=this.rules.block.text.exec(X);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},le.escape=function(X){var ae=this.rules.inline.escape.exec(X);if(ae)return{type:"escape",raw:ae[0],text:b(ae[1])}},le.tag=function(X){var ae=this.rules.inline.tag.exec(X);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):b(ae[0]):ae[0]}},le.link=function(X){var ae=this.rules.inline.link.exec(X);if(ae){var pe=ae[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var be=P(pe.slice(0,-1),"\\");if((pe.length-be.length)%2===0)return}else{var Fe=C(ae[2],"()");if(Fe>-1){var Be=ae[0].indexOf("!")===0?5:4,ke=Be+ae[1].length+Fe;ae[2]=ae[2].substring(0,Fe),ae[0]=ae[0].substring(0,ke).trim(),ae[3]=""}}var Ie=ae[2],Oe="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);q&&(Ie=q[1],Oe=q[3])}else Oe=ae[3]?ae[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(pe)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(ae,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},le.reflink=function(X,ae){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var be=(pe[2]||pe[1]).replace(/\s+/g," ");if(be=ae[be.toLowerCase()],!be||!be.href){var Fe=pe[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return N(pe,be,pe[0],this.lexer)}},le.emStrong=function(X,ae,pe){pe===void 0&&(pe="");var be=this.rules.inline.emStrong.lDelim.exec(X);if(be&&!(be[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=be[1]||be[2]||"";if(!Fe||Fe&&(pe===""||this.rules.inline.punctuation.exec(pe))){var Be=be[0].length-1,ke,Ie,Oe=Be,q=0,V=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,ae=ae.slice(-1*X.length+Be);(be=V.exec(ae))!=null;)if(ke=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!ke){if(Ie=ke.length,be[3]||be[4]){Oe+=Ie;continue}else if((be[5]||be[6])&&Be%3&&!((Be+Ie)%3)){q+=Ie;continue}if(Oe-=Ie,!(Oe>0)){if(Ie=Math.min(Ie,Ie+Oe+q),Math.min(Be,Ie)%2){var J=X.slice(1,Be+be.index+Ie);return{type:"em",raw:X.slice(0,Be+be.index+Ie+1),text:J,tokens:this.lexer.inlineTokens(J)}}var x=X.slice(2,Be+be.index+Ie-1);return{type:"strong",raw:X.slice(0,Be+be.index+Ie+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},le.codespan=function(X){var ae=this.rules.inline.code.exec(X);if(ae){var pe=ae[2].replace(/\n/g," "),be=/[^ ]/.test(pe),Fe=/^ /.test(pe)&&/ $/.test(pe);return be&&Fe&&(pe=pe.substring(1,pe.length-1)),pe=b(pe,!0),{type:"codespan",raw:ae[0],text:pe}}},le.br=function(X){var ae=this.rules.inline.br.exec(X);if(ae)return{type:"br",raw:ae[0]}},le.del=function(X){var ae=this.rules.inline.del.exec(X);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},le.autolink=function(X,ae){var pe=this.rules.inline.autolink.exec(X);if(pe){var be,Fe;return pe[2]==="@"?(be=b(this.options.mangle?ae(pe[1]):pe[1]),Fe="mailto:"+be):(be=b(pe[1]),Fe=be),{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},le.url=function(X,ae){var pe;if(pe=this.rules.inline.url.exec(X)){var be,Fe;if(pe[2]==="@")be=b(this.options.mangle?ae(pe[0]):pe[0]),Fe="mailto:"+be;else{var Be;do Be=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(Be!==pe[0]);be=b(pe[0]),pe[1]==="www."?Fe="http://"+be:Fe=be}return{type:"link",raw:pe[0],text:be,href:Fe,tokens:[{type:"text",raw:be,text:be}]}}},le.inlineText=function(X,ae){var pe=this.rules.inline.text.exec(X);if(pe){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):b(pe[0]):pe[0]:be=b(this.options.smartypants?ae(pe[0]):pe[0]),{type:"text",raw:pe[0],text:be}}},te}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=m(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=m(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=m(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=m(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=m(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=m(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=m(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:m(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:m(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=m(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=m(j._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=m(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=m(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=m(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=m(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=m(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=m(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=m(z.reflink).replace("label",z._label).replace("ref",j._label).getRegex(),z.nolink=m(z.nolink).replace("ref",j._label).getRegex(),z.reflinkSearch=m(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=S({},z),z.pedantic=S({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:m(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:m(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=S({},z.normal,{escape:m(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=m(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=S({},z.gfm,{br:m(z.br).replace("{2,}","*").getRegex(),text:m(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(te){return te.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(te){var le="",he,X,ae=te.length;for(he=0;he<ae;he++)X=te.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),le+="&#"+X+";";return le}var _=function(){function te(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ce.defaults,this.options.tokenizer=this.options.tokenizer||new M,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:j.normal,inline:z.normal};this.options.pedantic?(X.block=j.pedantic,X.inline=z.pedantic):this.options.gfm&&(X.block=j.gfm,this.options.breaks?X.inline=z.breaks:X.inline=z.gfm),this.tokenizer.rules=X}te.lex=function(X,ae){var pe=new te(ae);return pe.lex(X)},te.lexInline=function(X,ae){var pe=new te(ae);return pe.inlineTokens(X)};var le=te.prototype;return le.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},le.blockTokens=function(X,ae){var pe=this;ae===void 0&&(ae=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,q,V){return q+"    ".repeat(V.length)});for(var be,Fe,Be,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(be=Oe.call({lexer:pe},X,ae))?(X=X.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.space(X)){X=X.substring(be.raw.length),be.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(be);continue}if(be=this.tokenizer.code(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ae.push(be);continue}if(be=this.tokenizer.fences(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.heading(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.hr(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.blockquote(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.list(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.html(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.def(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.lheading(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(Be=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,q=X.slice(1),V=void 0;pe.options.extensions.startBlock.forEach(function(J){V=J.call({lexer:this},q),typeof V=="number"&&V>=0&&(Oe=Math.min(Oe,V))}),Oe<1/0&&Oe>=0&&(Be=X.substring(0,Oe+1))}(),this.state.top&&(be=this.tokenizer.paragraph(Be))){Fe=ae[ae.length-1],ke&&Fe.type==="paragraph"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ae.push(be),ke=Be.length!==X.length,X=X.substring(be.raw.length);continue}if(be=this.tokenizer.text(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+be.raw,Fe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ae.push(be);continue}if(X){var Ie="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,ae},le.inline=function(X,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:X,tokens:ae}),ae},le.inlineTokens=function(X,ae){var pe=this;ae===void 0&&(ae=[]);var be,Fe,Be,ke=X,Ie,Oe,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)V.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+v("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(q=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(be=x.call({lexer:pe},X,ae))?(X=X.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.escape(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.tag(X)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.link(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(be.raw.length),Fe=ae[ae.length-1],Fe&&be.type==="text"&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.emStrong(X,ke,q)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.codespan(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.br(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.del(X)){X=X.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.autolink(X,B)){X=X.substring(be.raw.length),ae.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(X,B))){X=X.substring(be.raw.length),ae.push(be);continue}if(Be=X,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,fe=X.slice(1),we=void 0;pe.options.extensions.startInline.forEach(function(Ne){we=Ne.call({lexer:this},fe),typeof we=="number"&&we>=0&&(x=Math.min(x,we))}),x<1/0&&x>=0&&(Be=X.substring(0,x+1))}(),be=this.tokenizer.inlineText(Be,F)){X=X.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(q=be.raw.slice(-1)),Oe=!0,Fe=ae[ae.length-1],Fe&&Fe.type==="text"?(Fe.raw+=be.raw,Fe.text+=be.text):ae.push(be);continue}if(X){var J="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return ae},r(te,null,[{key:"rules",get:function(){return{block:j,inline:z}}}]),te}(),re=function(){function te(he){this.options=he||ce.defaults}var le=te.prototype;return le.code=function(X,ae,pe){var be=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(X,be);Fe!=null&&Fe!==X&&(pe=!0,X=Fe)}return X=X.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+b(be,!0)+'">'+(pe?X:b(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:b(X,!0))+`</code></pre>
`},le.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},le.html=function(X){return X},le.heading=function(X,ae,pe,be){if(this.options.headerIds){var Fe=this.options.headerPrefix+be.slug(pe);return"<h"+ae+' id="'+Fe+'">'+X+"</h"+ae+`>
`}return"<h"+ae+">"+X+"</h"+ae+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(X,ae,pe){var be=ae?"ol":"ul",Fe=ae&&pe!==1?' start="'+pe+'"':"";return"<"+be+Fe+`>
`+X+"</"+be+`>
`},le.listitem=function(X){return"<li>"+X+`</li>
`},le.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(X){return"<p>"+X+`</p>
`},le.table=function(X,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ae+`</table>
`},le.tablerow=function(X){return`<tr>
`+X+`</tr>
`},le.tablecell=function(X,ae){var pe=ae.header?"th":"td",be=ae.align?"<"+pe+' align="'+ae.align+'">':"<"+pe+">";return be+X+("</"+pe+`>
`)},le.strong=function(X){return"<strong>"+X+"</strong>"},le.em=function(X){return"<em>"+X+"</em>"},le.codespan=function(X){return"<code>"+X+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(X){return"<del>"+X+"</del>"},le.link=function(X,ae,pe){if(X=i(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var be='<a href="'+b(X)+'"';return ae&&(be+=' title="'+ae+'"'),be+=">"+pe+"</a>",be},le.image=function(X,ae,pe){if(X=i(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var be='<img src="'+X+'" alt="'+pe+'"';return ae&&(be+=' title="'+ae+'"'),be+=this.options.xhtml?"/>":">",be},le.text=function(X){return X},te}(),U=function(){function te(){}var le=te.prototype;return le.strong=function(X){return X},le.em=function(X){return X},le.codespan=function(X){return X},le.del=function(X){return X},le.html=function(X){return X},le.text=function(X){return X},le.link=function(X,ae,pe){return""+pe},le.image=function(X,ae,pe){return""+pe},le.br=function(){return""},te}(),G=function(){function te(){this.seen={}}var le=te.prototype;return le.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(X,ae){var pe=X,be=0;if(this.seen.hasOwnProperty(pe)){be=this.seen[X];do be++,pe=X+"-"+be;while(this.seen.hasOwnProperty(pe))}return ae||(this.seen[X]=be,this.seen[pe]=0),pe},le.slug=function(X,ae){ae===void 0&&(ae={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,ae.dryrun)},te}(),Q=function(){function te(he){this.options=he||ce.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new U,this.slugger=new G}te.parse=function(X,ae){var pe=new te(ae);return pe.parse(X)},te.parseInline=function(X,ae){var pe=new te(ae);return pe.parseInline(X)};var le=te.prototype;return le.parse=function(X,ae){ae===void 0&&(ae=!0);var pe="",be,Fe,Be,ke,Ie,Oe,q,V,J,x,fe,we,Ne,Ge,Ke,tt,rt,ot,nt,ct=X.length;for(be=0;be<ct;be++){if(x=X[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(nt=this.options.extensions.renderers[x.type].call({parser:this},x),nt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){pe+=nt||"";continue}switch(x.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(x.tokens),x.depth,g(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(V="",q="",ke=x.header.length,Fe=0;Fe<ke;Fe++)q+=this.renderer.tablecell(this.parseInline(x.header[Fe].tokens),{header:!0,align:x.align[Fe]});for(V+=this.renderer.tablerow(q),J="",ke=x.rows.length,Fe=0;Fe<ke;Fe++){for(Oe=x.rows[Fe],q="",Ie=Oe.length,Be=0;Be<Ie;Be++)q+=this.renderer.tablecell(this.parseInline(Oe[Be].tokens),{header:!1,align:x.align[Be]});J+=this.renderer.tablerow(q)}pe+=this.renderer.table(V,J);continue}case"blockquote":{J=this.parse(x.tokens),pe+=this.renderer.blockquote(J);continue}case"list":{for(fe=x.ordered,we=x.start,Ne=x.loose,ke=x.items.length,J="",Fe=0;Fe<ke;Fe++)Ke=x.items[Fe],tt=Ke.checked,rt=Ke.task,Ge="",Ke.task&&(ot=this.renderer.checkbox(tt),Ne?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=ot+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=ot+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:ot}):Ge+=ot),Ge+=this.parse(Ke.tokens,Ne),J+=this.renderer.listitem(Ge,rt,tt);pe+=this.renderer.list(J,fe,we);continue}case"html":{pe+=this.renderer.html(x.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(J=x.tokens?this.parseInline(x.tokens):x.text;be+1<ct&&X[be+1].type==="text";)x=X[++be],J+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);pe+=ae?this.renderer.paragraph(J):J;continue}default:{var $t='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},le.parseInline=function(X,ae){ae=ae||this.renderer;var pe="",be,Fe,Be,ke=X.length;for(be=0;be<ke;be++){if(Fe=X[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(Be=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),Be!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){pe+=Be||"";continue}switch(Fe.type){case"escape":{pe+=ae.text(Fe.text);break}case"html":{pe+=ae.html(Fe.text);break}case"link":{pe+=ae.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ae));break}case"image":{pe+=ae.image(Fe.href,Fe.title,Fe.text);break}case"strong":{pe+=ae.strong(this.parseInline(Fe.tokens,ae));break}case"em":{pe+=ae.em(this.parseInline(Fe.tokens,ae));break}case"codespan":{pe+=ae.codespan(Fe.text);break}case"br":{pe+=ae.br();break}case"del":{pe+=ae.del(this.parseInline(Fe.tokens,ae));break}case"text":{pe+=ae.text(Fe.text);break}default:{var Ie='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return pe},te}();function ee(te,le,he){if(typeof te>"u"||te===null)throw new Error("marked(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");if(typeof le=="function"&&(he=le,le=null),le=S({},ee.defaults,le||{}),p(le),he){var X=le.highlight,ae;try{ae=_.lex(te,le)}catch(ke){return he(ke)}var pe=function(Ie){var Oe;if(!Ie)try{le.walkTokens&&ee.walkTokens(ae,le.walkTokens),Oe=Q.parse(ae,le)}catch(q){Ie=q}return le.highlight=X,Ie?he(Ie):he(null,Oe)};if(!X||X.length<3||(delete le.highlight,!ae.length))return pe();var be=0;ee.walkTokens(ae,function(ke){ke.type==="code"&&(be++,setTimeout(function(){X(ke.text,ke.lang,function(Ie,Oe){if(Ie)return pe(Ie);Oe!=null&&Oe!==ke.text&&(ke.text=Oe,ke.escaped=!0),be--,be===0&&pe()})},0))}),be===0&&pe();return}function Fe(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(ke.message+"",!0)+"</pre>";throw ke}try{var Be=_.lex(te,le);if(le.walkTokens){if(le.async)return Promise.all(ee.walkTokens(Be,le.walkTokens)).then(function(){return Q.parse(Be,le)}).catch(Fe);ee.walkTokens(Be,le.walkTokens)}return Q.parse(Be,le)}catch(ke){Fe(ke)}}ee.options=ee.setOptions=function(te){return S(ee.defaults,te),O(ee.defaults),ee},ee.getDefaults=L,ee.defaults=ce.defaults,ee.use=function(){for(var te=arguments.length,le=new Array(te),he=0;he<te;he++)le[he]=arguments[he];var X=S.apply(void 0,[{}].concat(le)),ae=ee.defaults.extensions||{renderers:{},childTokens:{}},pe;le.forEach(function(be){if(be.extensions&&(pe=!0,be.extensions.forEach(function(Be){if(!Be.name)throw new Error("extension name required");if(Be.renderer){var ke=ae.renderers?ae.renderers[Be.name]:null;ke?ae.renderers[Be.name]=function(){for(var Ie=arguments.length,Oe=new Array(Ie),q=0;q<Ie;q++)Oe[q]=arguments[q];var V=Be.renderer.apply(this,Oe);return V===!1&&(V=ke.apply(this,Oe)),V}:ae.renderers[Be.name]=Be.renderer}if(Be.tokenizer){if(!Be.level||Be.level!=="block"&&Be.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[Be.level]?ae[Be.level].unshift(Be.tokenizer):ae[Be.level]=[Be.tokenizer],Be.start&&(Be.level==="block"?ae.startBlock?ae.startBlock.push(Be.start):ae.startBlock=[Be.start]:Be.level==="inline"&&(ae.startInline?ae.startInline.push(Be.start):ae.startInline=[Be.start]))}Be.childTokens&&(ae.childTokens[Be.name]=Be.childTokens)})),be.renderer&&function(){var Be=ee.defaults.renderer||new re,ke=function(q){var V=Be[q];Be[q]=function(){for(var J=arguments.length,x=new Array(J),fe=0;fe<J;fe++)x[fe]=arguments[fe];var we=be.renderer[q].apply(Be,x);return we===!1&&(we=V.apply(Be,x)),we}};for(var Ie in be.renderer)ke(Ie);X.renderer=Be}(),be.tokenizer&&function(){var Be=ee.defaults.tokenizer||new M,ke=function(q){var V=Be[q];Be[q]=function(){for(var J=arguments.length,x=new Array(J),fe=0;fe<J;fe++)x[fe]=arguments[fe];var we=be.tokenizer[q].apply(Be,x);return we===!1&&(we=V.apply(Be,x)),we}};for(var Ie in be.tokenizer)ke(Ie);X.tokenizer=Be}(),be.walkTokens){var Fe=ee.defaults.walkTokens;X.walkTokens=function(Be){var ke=[];return ke.push(be.walkTokens.call(this,Be)),Fe&&(ke=ke.concat(Fe.call(this,Be))),ke}}pe&&(X.extensions=ae),ee.setOptions(X)})},ee.walkTokens=function(te,le){for(var he=[],X=function(){var Fe=pe.value;switch(he=he.concat(le.call(ee,Fe)),Fe.type){case"table":{for(var Be=R(Fe.header),ke;!(ke=Be()).done;){var Ie=ke.value;he=he.concat(ee.walkTokens(Ie.tokens,le))}for(var Oe=R(Fe.rows),q;!(q=Oe()).done;)for(var V=q.value,J=R(V),x;!(x=J()).done;){var fe=x.value;he=he.concat(ee.walkTokens(fe.tokens,le))}break}case"list":{he=he.concat(ee.walkTokens(Fe.items,le));break}default:ee.defaults.extensions&&ee.defaults.extensions.childTokens&&ee.defaults.extensions.childTokens[Fe.type]?ee.defaults.extensions.childTokens[Fe.type].forEach(function(we){he=he.concat(ee.walkTokens(Fe[we],le))}):Fe.tokens&&(he=he.concat(ee.walkTokens(Fe.tokens,le)))}},ae=R(te),pe;!(pe=ae()).done;)X();return he},ee.parseInline=function(te,le){if(typeof te>"u"||te===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof te!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(te)+", string expected");le=S({},ee.defaults,le||{}),p(le);try{var he=_.lexInline(te,le);return le.walkTokens&&ee.walkTokens(he,le.walkTokens),Q.parseInline(he,le)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(X.message+"",!0)+"</pre>";throw X}},ee.Parser=Q,ee.parser=Q.parse,ee.Renderer=re,ee.TextRenderer=U,ee.Lexer=_,ee.lexer=_.lex,ee.Tokenizer=M,ee.Slugger=G,ee.parse=ee;var ue=ee.options,ne=ee.setOptions,De=ee.use,$e=ee.walkTokens,K=ee.parseInline,W=ee,se=Q.parse,oe=_.lex;ce.Lexer=_,ce.Parser=Q,ce.Renderer=re,ce.Slugger=G,ce.TextRenderer=U,ce.Tokenizer=M,ce.getDefaults=L,ce.lexer=oe,ce.marked=ee,ce.options=ue,ce.parse=W,ce.parseInline=K,ce.parser=se,ce.setOptions=ne,ce.use=De,ce.walkTokens=$e,Object.defineProperty(ce,"__esModule",{value:!0})}),define(Ee[41],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(h){h[h.Uri=1]="Uri",h[h.Regexp=2]="Regexp",h[h.ScmResource=3]="ScmResource",h[h.ScmResourceGroup=4]="ScmResourceGroup",h[h.ScmProvider=5]="ScmProvider",h[h.CommentController=6]="CommentController",h[h.CommentThread=7]="CommentThread",h[h.CommentThreadInstance=8]="CommentThreadInstance",h[h.CommentThreadReply=9]="CommentThreadReply",h[h.CommentNode=10]="CommentNode",h[h.CommentThreadNode=11]="CommentThreadNode",h[h.TimelineActionContext=12]="TimelineActionContext",h[h.NotebookCellActionContext=13]="NotebookCellActionContext",h[h.NotebookActionContext=14]="NotebookActionContext",h[h.TerminalContext=15]="TerminalContext",h[h.TestItemContext=16]="TestItemContext",h[h.Date=17]="Date",h[h.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Ee[177],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=r;function r(c){const g=R(c);if(g&&g.length>0)return new Uint32Array(g)}let h=0;const A=new Uint32Array(10);function R(c){if(h=0,L(c,E,$.InitialConsonant),h>0||(L(c,u,$.Vowel),h>0)||(L(c,k,$.FinalConsonant),h>0)||(L(c,b,$.CompatibilityJamo),h))return A.subarray(0,h);if(c>=44032&&c<=55203){const g=c-44032,d=g%588,m=Math.floor(g/588),n=Math.floor(d/28),o=d%28-1;if(m<E.length?L(m,E,0):$.InitialConsonant+m-$.CompatibilityJamo<b.length&&L($.InitialConsonant+m,b,$.CompatibilityJamo),n<u.length?L(n,u,0):$.Vowel+n-$.CompatibilityJamo<b.length&&L($.Vowel+n-$.CompatibilityJamo,b,$.CompatibilityJamo),o>=0&&(o<k.length?L(o,k,0):$.FinalConsonant+o-$.CompatibilityJamo<b.length&&L($.FinalConsonant+o-$.CompatibilityJamo,b,$.CompatibilityJamo)),h>0)return A.subarray(0,h)}}function L(c,g,d){c>=d&&c<d+g.length&&O(g[c-d])}function O(c){c!==l.NUL&&(A[h++]=c&255,c>>8&&(A[h++]=c>>8&255),c>>16&&(A[h++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var l;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(l||(l={}));var I;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(I||(I={}));const E=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),u=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l]),k=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,I.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),b=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.E,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,l.Q,I.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l])}),define(Ee[82],Se([1,0,29]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=A,e.$nm=L;const h=new r.$Fc(1e4);function A(l){return $(l,"NFC",h)}const R=new r.$Fc(1e4);function L(l){return $(l,"NFD",R)}const O=/[^\u0000-\u0080]/;function $(l,I,E){if(!l)return l;const u=E.get(l);if(u)return u;let k;return O.test(l)?k=l.normalize(I):k=l,E.set(l,k),k}e.$om=function(){const l=/[\u0300-\u036f]/g;return function(I){return L(I).replace(l,"")}}()}),define(Ee[134],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=r,e.rot=h,e.$Pm=O;function r($,l,I){return Math.min(Math.max($,l),I)}function h($,l){return(l+$%l)%l}class A{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=A;class R{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=R;class L{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const I=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=L;function O($,l,I,E,u,k,b,c){const g=b-I,d=c-E,m=u-I,n=k-E,o=$-I,i=l-E,t=g*g+d*d,s=g*m+d*n,f=g*o+d*i,a=m*m+n*n,w=m*o+n*i,y=1/(t*a-s*s),S=(a*f-s*w)*y,D=(t*w-s*f)*y;return S>=0&&D>=0&&S+D<1}}),define(Ee[178],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=R,e.$ed=u;class r{constructor(b,c,g){this.owner=b,this.debugNameSource=c,this.referenceFn=g}getDebugName(b){return R(b,this)}}e.$cd=r;const h=new Map,A=new WeakMap;function R(k,b){const c=A.get(k);if(c)return c;const g=L(k,b);if(g){let d=h.get(g)??0;d++,h.set(g,d);const m=d===1?g:`${g}#${d}`;return A.set(k,m),m}}function L(k,b){const c=A.get(k);if(c)return c;const g=b.owner?I(b.owner)+".":"";let d;const m=b.debugNameSource;if(m!==void 0)if(typeof m=="function"){if(d=m(),d!==void 0)return g+d}else return g+m;const n=b.referenceFn;if(n!==void 0&&(d=u(n),d!==void 0))return g+d;if(b.owner!==void 0){const o=O(b.owner,k);if(o!==void 0)return g+o}}function O(k,b){for(const c in k)if(k[c]===b)return c}const $=new Map,l=new WeakMap;function I(k){const b=l.get(k);if(b)return b;const c=E(k);let g=$.get(c)??0;g++,$.set(c,g);const d=g===1?c:`${c}#${g}`;return l.set(k,d),d}function E(k){const b=k.constructor;return b?b.name:"Object"}function u(k){const b=k.toString(),g=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(g?g[1]:void 0)?.trim()}}),define(Ee[179],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=h,e.$Md=A;let r;function h(c){r=c}function A(){return r}class R{constructor(){this.a=0,this.d=new WeakMap}b(g){return L([O(k("|  ",this.a)),g])}c(g){return g.hadValue?g.didChange?[O(" "),l(I(g.oldValue,70),{color:"red",strikeThrough:!0}),O(" "),l(I(g.newValue,60),{color:"green"})]:[O(" (unchanged)")]:[O(" "),l(I(g.newValue,60),{color:"green"}),O(" (initial)")]}handleObservableChanged(g,d){console.log(...this.b([$("observable value changed"),l(g.debugName,{color:"BlueViolet"}),...this.c(d)]))}formatChanges(g){if(g.size!==0)return l(" (changed deps: "+[...g].map(d=>d.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(g){const d=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),d.apply(g,[m,n]))}handleDerivedRecomputed(g,d){const m=this.d.get(g);console.log(...this.b([$("derived recomputed"),l(g.debugName,{color:"BlueViolet"}),...this.c(d),this.formatChanges(m),{data:[{fn:g._debugNameData.referenceFn??g._computeFn}]}])),m.clear()}handleFromEventObservableTriggered(g,d){console.log(...this.b([$("observable from event triggered"),l(g.debugName,{color:"BlueViolet"}),...this.c(d),{data:[{fn:g._getValue}]}]))}handleAutorunCreated(g){const d=g.handleChange;this.d.set(g,new Set),g.handleChange=(m,n)=>(this.d.get(g).add(m),d.apply(g,[m,n]))}handleAutorunTriggered(g){const d=this.d.get(g);console.log(...this.b([$("autorun"),l(g.debugName,{color:"BlueViolet"}),this.formatChanges(d),{data:[{fn:g._debugNameData.referenceFn??g._runFn}]}])),d.clear(),this.a++}handleAutorunFinished(g){this.a--}handleBeginTransaction(g){let d=g.getDebugName();d===void 0&&(d=""),console.log(...this.b([$("transaction"),l(d,{color:"BlueViolet"}),{data:[{fn:g._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=R;function L(c){const g=new Array,d=[];let m="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(m+=`%c${i.text}`,g.push(i.style),i.data&&d.push(...i.data)):"data"in i&&d.push(...i.data)}n(c);const o=[m,...g];return o.push(...d),o}function O(c){return l(c,{color:"black"})}function $(c){return l(b(`${c}: `,10),{color:"black",bold:!0})}function l(c,g={color:"black"}){function d(n){return Object.entries(n).reduce((o,[i,t])=>`${o}${i}:${t};`,"")}const m={color:g.color};return g.strikeThrough&&(m["text-decoration"]="line-through"),g.bold&&(m["font-weight"]="bold"),{text:c,style:d(m)}}function I(c,g){switch(typeof c){case"number":return""+c;case"string":return c.length+2<=g?`"${c}"`:`"${c.substr(0,g-7)}"+...`;case"boolean":return c?"true":"false";case"undefined":return"undefined";case"object":return c===null?"null":Array.isArray(c)?E(c,g):u(c,g);case"symbol":return c.toString();case"function":return`[[Function${c.name?" "+c.name:""}]]`;default:return""+c}}function E(c,g){let d="[ ",m=!0;for(const n of c){if(m||(d+=", "),d.length-5>g){d+="...";break}m=!1,d+=`${I(n,g-d.length)}`}return d+=" ]",d}function u(c,g){let d="{ ",m=!0;for(const[n,o]of Object.entries(c)){if(m||(d+=", "),d.length-5>g){d+="...";break}m=!1,d+=`${n}: ${I(o,g-d.length)}`}return d+=" }",d}function k(c,g){let d="";for(let m=1;m<=g;m++)d+=c;return d}function b(c,g){for(;c.length<g;)c+=" ";return c}}),define(Ee[180],Se([1,0,174,178,179]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=L,e.$Xd=$,e.$Yd=I,e.$2d=k,e.$3d=c,e.$4d=g,e.$5d=d,e.$7d=n,e.$9d=i;let R;function L(s){R=s}let O;function $(s){O=s}let l;function I(s){l=s}class E{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,a){const w=a===void 0?void 0:f,y=a===void 0?f:a;return l({owner:w,debugName:()=>{const S=(0,h.$ed)(y);if(S!==void 0)return S;const P=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(y.toString());if(P)return`${this.debugName}.${P[2]}`;if(!w)return`${this.debugName} (mapped)`},debugReferenceFn:y},S=>y(this.read(S),S))}recomputeInitiallyAndOnChange(f,a){return f.add(R(this,a)),this}keepObserved(f){return f.add(O(this)),this}get a(){return this.get()}}e.$Zd=E;class u extends E{constructor(){super(...arguments),this.b=new Set}addObserver(f){const a=this.b.size;this.b.add(f),a===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function k(s,f){const a=new m(s,f);try{s(a)}finally{a.finish()}}let b;function c(s){if(b)s(b);else{const f=new m(s,void 0);b=f;try{s(f)}finally{f.finish(),b=void 0}}}async function g(s,f){const a=new m(s,f);try{await s(a)}finally{a.finish()}}function d(s,f,a){s?f(s):k(f,a)}class m{constructor(f,a){this._fn=f,this.b=a,this.a=[],(0,A.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,h.$ed)(this._fn)}updateObserver(f,a){this.a.push({observer:f,observable:a}),f.beginUpdate(a)}finish(){const f=this.a;for(let a=0;a<f.length;a++){const{observer:w,observable:y}=f[a];w.endUpdate(y)}this.a=null,(0,A.$Md)()?.handleEndTransaction()}}e.$6d=m;function n(s,f){let a;return typeof s=="string"?a=new h.$cd(void 0,s,void 0):a=new h.$cd(s,void 0,void 0),new o(a,f,r.$8c)}class o extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,a,w){super(),this.e=f,this.g=w,this.d=a}get(){return this.d}set(f,a,w){if(w===void 0&&this.g(this.d,f))return;let y;a||(a=y=new m(()=>{},()=>`Setting ${this.debugName}`));try{const S=this.d;this.h(f),(0,A.$Md)()?.handleObservableChanged(this,{oldValue:S,newValue:f,change:w,didChange:!0,hadValue:!0});for(const D of this.b)a.updateObserver(D,this),D.handleChange(this,w)}finally{y&&y.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$8d=o;function i(s,f){let a;return typeof s=="string"?a=new h.$cd(void 0,s,void 0):a=new h.$cd(s,void 0,void 0),new t(a,f,r.$8c)}class t extends o{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$0d=t}),function(){function ce(A){const R=[];typeof A=="number"&&R.push("code/timeOrigin",A);function L($){R.push($,Date.now())}function O(){const $=[];for(let l=0;l<R.length;l+=2)$.push({name:R[l],startTime:R[l+1]});return $}return{mark:L,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ce():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(A+L.startTime)});return R}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ce(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ce()}function r(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var h;typeof global=="object"?h=global:typeof self=="object"?h=self:h={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(h)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(h):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),h.perf=r(h))}(),define(Ee[181],Se([1,0,40]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=void 0;const h=Symbol("unset");class A{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert($,l,I){this.d($,E=>E._value=l,I)}mutate($,l){this.d($,I=>I._value=l(I._value===h?void 0:I._value))}mutatePath($,l){this.d($,()=>{},I=>l(I))}delete($){const l=this.c($);if(!l)return;let I=l.length-1;const E=l[I].node._value;if(E!==h){for(this.b--,l[I].node._value=h;I>0;I--){const{node:u,part:k}=l[I];if(u.children?.size||u._value!==h)break;l[I-1].node.children.delete(k)}return E}}*deleteRecursive($){const l=this.c($);if(!l)return;const I=l[l.length-1].node;for(let E=l.length-1;E>0;E--){const u=l[E-1];if(u.node.children.delete(l[E].part),u.node.children.size>0||u.node._value!==h)break}for(const E of R(I))E._value!==h&&(this.b--,yield E._value)}find($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return;l=E}return l._value===h?void 0:l._value}hasKeyOrParent($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return!1;if(E._value!==h)return!0;l=E}return!1}hasKeyOrChildren($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return!1;l=E}return!0}hasKey($){let l=this.a;for(const I of $){const E=l.children?.get(I);if(!E)return!1;l=E}return l._value!==h}c($){const l=[{part:"",node:this.a}];let I=0;for(const E of $){const u=l[I].node.children?.get(E);if(!u)return;l.push({part:E,node:u}),I++}return l}d($,l,I){let E=this.a;for(const b of $){if(E.children)if(E.children.has(b))E=E.children.get(b);else{const c=new L;E.children.set(b,c),E=c}else{const c=new L;E.children=new Map([[b,c]]),E=c}I?.(E)}const u=E._value===h?0:1;l(E);const k=E._value===h?0:1;this.b+=k-u}*values(){for(const{_value:$}of R(this.a))$!==h&&(yield $)}}e.$OI=A;function*R(O){const $=[O];for(;$.length>0;){const l=$.pop();if(yield l,l.children)for(const I of l.children.values())$.push(I)}}class L{constructor(){this._value=h}get value(){return this._value===h?void 0:this._value}set value($){this._value=$===void 0?h:$}}}),function(ce,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var h in r)(typeof exports=="object"?exports:ce)[h]=r[h]}}(typeof self<"u"?self:this,function(){return function(ce){var e={};function r(h){if(e[h])return e[h].exports;var A=e[h]={i:h,l:!1,exports:{}};return ce[h].call(A.exports,A,A.exports,r),A.l=!0,A.exports}return r.m=ce,r.c=e,r.d=function(h,A,R){r.o(h,A)||Object.defineProperty(h,A,{enumerable:!0,get:R})},r.r=function(h){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(h,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(h,"__esModule",{value:!0})},r.t=function(h,A){if(1&A&&(h=r(h)),8&A||4&A&&typeof h=="object"&&h&&h.__esModule)return h;var R=Object.create(null);if(r.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:h}),2&A&&typeof h!="string")for(var L in h)r.d(R,L,function(O){return h[O]}.bind(null,L));return R},r.n=function(h){var A=h&&h.__esModule?function(){return h.default}:function(){return h};return r.d(A,"a",A),A},r.o=function(h,A){return Object.prototype.hasOwnProperty.call(h,A)},r.p="",r(r.s=0)}([function(ce,e,r){(function(h){var A;e=ce.exports=De,A=typeof h=="object"&&h.env&&h.env.NODE_DEBUG&&/\bsemver\b/i.test(h.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],$=e.src=[],l=0,I=l++;$[I]="0|[1-9]\\d*";var E=l++;$[E]="[0-9]+";var u=l++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=l++;$[k]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var b=l++;$[b]="("+$[E]+")\\.("+$[E]+")\\.("+$[E]+")";var c=l++;$[c]="(?:"+$[I]+"|"+$[u]+")";var g=l++;$[g]="(?:"+$[E]+"|"+$[u]+")";var d=l++;$[d]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var m=l++;$[m]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var n=l++;$[n]="[0-9A-Za-z-]+";var o=l++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var i=l++,t="v?"+$[k]+$[d]+"?"+$[o]+"?";$[i]="^"+t+"$";var s="[v=\\s]*"+$[b]+$[m]+"?"+$[o]+"?",f=l++;$[f]="^"+s+"$";var a=l++;$[a]="((?:<|>)?=?)";var w=l++;$[w]=$[E]+"|x|X|\\*";var y=l++;$[y]=$[I]+"|x|X|\\*";var S=l++;$[S]="[v=\\s]*("+$[y]+")(?:\\.("+$[y]+")(?:\\.("+$[y]+")(?:"+$[d]+")?"+$[o]+"?)?)?";var D=l++;$[D]="[v=\\s]*("+$[w]+")(?:\\.("+$[w]+")(?:\\.("+$[w]+")(?:"+$[m]+")?"+$[o]+"?)?)?";var P=l++;$[P]="^"+$[a]+"\\s*"+$[S]+"$";var C=l++;$[C]="^"+$[a]+"\\s*"+$[D]+"$";var p=l++;$[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var v=l++;$[v]="(?:~>?)";var N=l++;$[N]="(\\s*)"+$[v]+"\\s+",O[N]=new RegExp($[N],"g");var T=l++;$[T]="^"+$[v]+$[S]+"$";var M=l++;$[M]="^"+$[v]+$[D]+"$";var j=l++;$[j]="(?:\\^)";var z=l++;$[z]="(\\s*)"+$[j]+"\\s+",O[z]=new RegExp($[z],"g");var F=l++;$[F]="^"+$[j]+$[S]+"$";var B=l++;$[B]="^"+$[j]+$[D]+"$";var _=l++;$[_]="^"+$[a]+"\\s*("+s+")$|^$";var re=l++;$[re]="^"+$[a]+"\\s*("+t+")$|^$";var U=l++;$[U]="(\\s*)"+$[a]+"\\s*("+s+"|"+$[S]+")",O[U]=new RegExp($[U],"g");var G=l++;$[G]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var Q=l++;$[Q]="^\\s*("+$[D]+")\\s+-\\s+("+$[D]+")\\s*$";var ee=l++;$[ee]="(<|>)?=?\\s*\\*";for(var ue=0;ue<35;ue++)A(ue,$[ue]),O[ue]||(O[ue]=new RegExp($[ue]));function ne(V,J){if(V instanceof De)return V;if(typeof V!="string"||V.length>R||!(J?O[f]:O[i]).test(V))return null;try{return new De(V,J)}catch{return null}}function De(V,J){if(V instanceof De){if(V.loose===J)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof De))return new De(V,J);A("SemVer",V,J),this.loose=J;var x=V.trim().match(J?O[f]:O[i]);if(!x)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<L)return we}return fe}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ne,e.valid=function(V,J){var x=ne(V,J);return x?x.version:null},e.clean=function(V,J){var x=ne(V.trim().replace(/^[=v]+/,""),J);return x?x.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(V){return A("SemVer.compare",this.version,this.loose,V),V instanceof De||(V=new De(V,this.loose)),this.compareMain(V)||this.comparePre(V)},De.prototype.compareMain=function(V){return V instanceof De||(V=new De(V,this.loose)),K(this.major,V.major)||K(this.minor,V.minor)||K(this.patch,V.patch)},De.prototype.comparePre=function(V){if(V instanceof De||(V=new De(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var J=0;do{var x=this.prerelease[J],fe=V.prerelease[J];if(A("prerelease compare",J,x,fe),x===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(x===void 0)return-1;if(x!==fe)return K(x,fe)}while(++J)},De.prototype.inc=function(V,J){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",J);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",J);break;case"prepatch":this.prerelease.length=0,this.inc("patch",J),this.inc("pre",J);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",J),this.inc("pre",J);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}J&&(this.prerelease[0]===J?isNaN(this.prerelease[1])&&(this.prerelease=[J,0]):this.prerelease=[J,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,J,x,fe){typeof x=="string"&&(fe=x,x=void 0);try{return new De(V,x).inc(J,fe).version}catch{return null}},e.diff=function(V,J){if(te(V,J))return null;var x=ne(V),fe=ne(J);if(x.prerelease.length||fe.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==fe[we])return we},e.compareIdentifiers=K;var $e=/^[0-9]+$/;function K(V,J){var x=$e.test(V),fe=$e.test(J);return x&&fe&&(V=+V,J=+J),x&&!fe?-1:fe&&!x?1:V<J?-1:V>J?1:0}function W(V,J,x){return new De(V,x).compare(new De(J,x))}function se(V,J,x){return W(V,J,x)>0}function oe(V,J,x){return W(V,J,x)<0}function te(V,J,x){return W(V,J,x)===0}function le(V,J,x){return W(V,J,x)!==0}function he(V,J,x){return W(V,J,x)>=0}function X(V,J,x){return W(V,J,x)<=0}function ae(V,J,x,fe){var we;switch(J){case"===":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),we=V===x;break;case"!==":typeof V=="object"&&(V=V.version),typeof x=="object"&&(x=x.version),we=V!==x;break;case"":case"=":case"==":we=te(V,x,fe);break;case"!=":we=le(V,x,fe);break;case">":we=se(V,x,fe);break;case">=":we=he(V,x,fe);break;case"<":we=oe(V,x,fe);break;case"<=":we=X(V,x,fe);break;default:throw new TypeError("Invalid operator: "+J)}return we}function pe(V,J){if(V instanceof pe){if(V.loose===J)return V;V=V.value}if(!(this instanceof pe))return new pe(V,J);A("comparator",V,J),this.loose=J,this.parse(V),this.semver===be?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(V,J){return K(J,V)},e.major=function(V,J){return new De(V,J).major},e.minor=function(V,J){return new De(V,J).minor},e.patch=function(V,J){return new De(V,J).patch},e.compare=W,e.compareLoose=function(V,J){return W(V,J,!0)},e.rcompare=function(V,J,x){return W(J,V,x)},e.sort=function(V,J){return V.sort(function(x,fe){return e.compare(x,fe,J)})},e.rsort=function(V,J){return V.sort(function(x,fe){return e.rcompare(x,fe,J)})},e.gt=se,e.lt=oe,e.eq=te,e.neq=le,e.gte=he,e.lte=X,e.cmp=ae,e.Comparator=pe;var be={};function Fe(V,J){if(V instanceof Fe)return V.loose===J?V:new Fe(V.raw,J);if(V instanceof pe)return new Fe(V.value,J);if(!(this instanceof Fe))return new Fe(V,J);if(this.loose=J,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function Be(V){return!V||V.toLowerCase()==="x"||V==="*"}function ke(V,J,x,fe,we,Ne,Ge,Ke,tt,rt,ot,nt,ct){return((J=Be(x)?"":Be(fe)?">="+x+".0.0":Be(we)?">="+x+"."+fe+".0":">="+J)+" "+(Ke=Be(tt)?"":Be(rt)?"<"+(+tt+1)+".0.0":Be(ot)?"<"+tt+"."+(+rt+1)+".0":nt?"<="+tt+"."+rt+"."+ot+"-"+nt:"<="+Ke)).trim()}function Ie(V,J){for(var x=0;x<V.length;x++)if(!V[x].test(J))return!1;if(J.prerelease.length){for(x=0;x<V.length;x++)if(A(V[x].semver),V[x].semver!==be&&V[x].semver.prerelease.length>0){var fe=V[x].semver;if(fe.major===J.major&&fe.minor===J.minor&&fe.patch===J.patch)return!0}return!1}return!0}function Oe(V,J,x){try{J=new Fe(J,x)}catch{return!1}return J.test(V)}function q(V,J,x,fe){var we,Ne,Ge,Ke,tt;switch(V=new De(V,fe),J=new Fe(J,fe),x){case">":we=se,Ne=X,Ge=oe,Ke=">",tt=">=";break;case"<":we=oe,Ne=he,Ge=se,Ke="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(V,J,fe))return!1;for(var rt=0;rt<J.set.length;++rt){var ot=J.set[rt],nt=null,ct=null;if(ot.forEach(function($t){$t.semver===be&&($t=new pe(">=0.0.0")),nt=nt||$t,ct=ct||$t,we($t.semver,nt.semver,fe)?nt=$t:Ge($t.semver,ct.semver,fe)&&(ct=$t)}),nt.operator===Ke||nt.operator===tt||(!ct.operator||ct.operator===Ke)&&Ne(V,ct.semver)||ct.operator===tt&&Ge(V,ct.semver))return!1}return!0}pe.prototype.parse=function(V){var J=this.loose?O[_]:O[re],x=V.match(J);if(!x)throw new TypeError("Invalid comparator: "+V);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new De(x[2],this.loose):this.semver=be},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(V){return A("Comparator.test",V,this.loose),this.semver===be||(typeof V=="string"&&(V=new De(V,this.loose)),ae(V,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(V,J){if(!(V instanceof pe))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Fe(V.value,J),Oe(this.value,x,J);if(V.operator==="")return x=new Fe(this.value,J),Oe(V.semver,x,J);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Ne=this.semver.version===V.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ke=ae(this.semver,"<",V.semver,J)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),tt=ae(this.semver,">",V.semver,J)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||we||Ne&&Ge||Ke||tt},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(V){var J=this.loose;V=V.trim(),A("range",V,J);var x=J?O[Q]:O[G];V=V.replace(x,ke),A("hyphen replace",V),V=V.replace(O[U],"$1$2$3"),A("comparator trim",V,O[U]),V=(V=(V=V.replace(O[N],"$1~")).replace(O[z],"$1^")).split(/\s+/).join(" ");var fe=J?O[_]:O[re],we=V.split(" ").map(function(Ne){return function(Ge,Ke){return A("comp",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,ct){A("caret",nt,ct);var $t=ct?O[B]:O[F];return nt.replace($t,function(ht,at,Pe,ze,Ze){var Te;return A("caret",nt,ht,at,Pe,ze,Ze),Be(at)?Te="":Be(Pe)?Te=">="+at+".0.0 <"+(+at+1)+".0.0":Be(ze)?Te=at==="0"?">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+".0 <"+(+at+1)+".0.0":Ze?(A("replaceCaret pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),Te=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+ze+Ze+" <"+at+"."+Pe+"."+(+ze+1):">="+at+"."+Pe+"."+ze+Ze+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+ze+Ze+" <"+(+at+1)+".0.0"):(A("no pr"),Te=at==="0"?Pe==="0"?">="+at+"."+Pe+"."+ze+" <"+at+"."+Pe+"."+(+ze+1):">="+at+"."+Pe+"."+ze+" <"+at+"."+(+Pe+1)+".0":">="+at+"."+Pe+"."+ze+" <"+(+at+1)+".0.0"),A("caret return",Te),Te})}(ot,rt)}).join(" ")}(Ge,Ke),A("caret",Ge),Ge=function(tt,rt){return tt.trim().split(/\s+/).map(function(ot){return function(nt,ct){var $t=ct?O[M]:O[T];return nt.replace($t,function(ht,at,Pe,ze,Ze){var Te;return A("tilde",nt,ht,at,Pe,ze,Ze),Be(at)?Te="":Be(Pe)?Te=">="+at+".0.0 <"+(+at+1)+".0.0":Be(ze)?Te=">="+at+"."+Pe+".0 <"+at+"."+(+Pe+1)+".0":Ze?(A("replaceTilde pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),Te=">="+at+"."+Pe+"."+ze+Ze+" <"+at+"."+(+Pe+1)+".0"):Te=">="+at+"."+Pe+"."+ze+" <"+at+"."+(+Pe+1)+".0",A("tilde return",Te),Te})}(ot,rt)}).join(" ")}(Ge,Ke),A("tildes",Ge),Ge=function(tt,rt){return A("replaceXRanges",tt,rt),tt.split(/\s+/).map(function(ot){return function(nt,ct){nt=nt.trim();var $t=ct?O[C]:O[P];return nt.replace($t,function(ht,at,Pe,ze,Ze,Te){A("xRange",nt,ht,at,Pe,ze,Ze,Te);var Me=Be(Pe),Y=Me||Be(ze),de=Y||Be(Ze);return at==="="&&de&&(at=""),Me?ht=at===">"||at==="<"?"<0.0.0":"*":at&&de?(Y&&(ze=0),de&&(Ze=0),at===">"?(at=">=",Y?(Pe=+Pe+1,ze=0,Ze=0):de&&(ze=+ze+1,Ze=0)):at==="<="&&(at="<",Y?Pe=+Pe+1:ze=+ze+1),ht=at+Pe+"."+ze+"."+Ze):Y?ht=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":de&&(ht=">="+Pe+"."+ze+".0 <"+Pe+"."+(+ze+1)+".0"),A("xRange return",ht),ht})}(ot,rt)}).join(" ")}(Ge,Ke),A("xrange",Ge),Ge=function(tt,rt){return A("replaceStars",tt,rt),tt.trim().replace(O[ee],"")}(Ge,Ke),A("stars",Ge),Ge}(Ne,J)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Ne){return!!Ne.match(fe)})),we=we.map(function(Ne){return new pe(Ne,J)})},Fe.prototype.intersects=function(V,J){if(!(V instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(fe){return V.set.some(function(we){return we.every(function(Ne){return fe.intersects(Ne,J)})})})})},e.toComparators=function(V,J){return new Fe(V,J).set.map(function(x){return x.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new De(V,this.loose));for(var J=0;J<this.set.length;J++)if(Ie(this.set[J],V))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(V,J,x){var fe=null,we=null;try{var Ne=new Fe(J,x)}catch{return null}return V.forEach(function(Ge){Ne.test(Ge)&&(fe&&we.compare(Ge)!==-1||(we=new De(fe=Ge,x)))}),fe},e.minSatisfying=function(V,J,x){var fe=null,we=null;try{var Ne=new Fe(J,x)}catch{return null}return V.forEach(function(Ge){Ne.test(Ge)&&(fe&&we.compare(Ge)!==1||(we=new De(fe=Ge,x)))}),fe},e.validRange=function(V,J){try{return new Fe(V,J).range||"*"}catch{return null}},e.ltr=function(V,J,x){return q(V,J,"<",x)},e.gtr=function(V,J,x){return q(V,J,">",x)},e.outside=q,e.prerelease=function(V,J){var x=ne(V,J);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(V,J,x){return V=new Fe(V,x),J=new Fe(J,x),V.intersects(J)},e.coerce=function(V){if(V instanceof De)return V;if(typeof V!="string")return null;var J=V.match(O[p]);return J==null?null:ne((J[1]||"0")+"."+(J[2]||"0")+"."+(J[3]||"0"))}}).call(this,r(1))},function(ce,e){var r,h,A=ce.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function O(g){if(r===setTimeout)return setTimeout(g,0);if((r===R||!r)&&setTimeout)return r=setTimeout,setTimeout(g,0);try{return r(g,0)}catch{try{return r.call(null,g,0)}catch{return r.call(this,g,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:R}catch{r=R}try{h=typeof clearTimeout=="function"?clearTimeout:L}catch{h=L}})();var $,l=[],I=!1,E=-1;function u(){I&&$&&(I=!1,$.length?l=$.concat(l):E=-1,l.length&&k())}function k(){if(!I){var g=O(u);I=!0;for(var d=l.length;d;){for($=l,l=[];++E<d;)$&&$[E].run();E=-1,d=l.length}$=null,I=!1,function(m){if(h===clearTimeout)return clearTimeout(m);if((h===L||!h)&&clearTimeout)return h=clearTimeout,clearTimeout(m);try{h(m)}catch{try{return h.call(null,m)}catch{return h.call(this,m)}}}(g)}}function b(g,d){this.fun=g,this.array=d}function c(){}A.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)d[m-1]=arguments[m];l.push(new b(g,d)),l.length!==1||I||O(k)},b.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=c,A.addListener=c,A.once=c,A.off=c,A.removeListener=c,A.removeAllListeners=c,A.emit=c,A.prependListener=c,A.prependOnceListener=c,A.listeners=function(g){return[]},A.binding=function(g){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(g){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(Ee[43],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class h{static create(R){return new h(R)}constructor(R){this.c=r&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ge=h}),define(Ee[4],Se([1,0,14,80,3,81,43]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$ie=e.Event=void 0,e.$je=k;const O=!1,$=!1,l=!1;var I;(function(M){M.None=()=>A.$Wc.None;function j(ke){if(l){const{onDidAddListener:Ie}=ke,Oe=c.create();let q=0;ke.onDidAddListener=()=>{++q===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Oe.print()),Ie?.()}}}function z(ke,Ie){return ne(ke,()=>{},0,void 0,!0,void 0,Ie)}M.defer=z;function F(ke){return(Ie,Oe=null,q)=>{let V=!1,J;return J=ke(x=>{if(!V)return J?J.dispose():V=!0,Ie.call(Oe,x)},null,q),V&&J.dispose(),J}}M.once=F;function B(ke,Ie,Oe){return ee((q,V=null,J)=>ke(x=>q.call(V,Ie(x)),null,J),Oe)}M.map=B;function _(ke,Ie,Oe){return ee((q,V=null,J)=>ke(x=>{Ie(x),q.call(V,x)},null,J),Oe)}M.forEach=_;function re(ke,Ie,Oe){return ee((q,V=null,J)=>ke(x=>Ie(x)&&q.call(V,x),null,J),Oe)}M.filter=re;function U(ke){return ke}M.signal=U;function G(...ke){return(Ie,Oe=null,q)=>{const V=(0,A.$Tc)(...ke.map(J=>J(x=>Ie.call(Oe,x))));return ue(V,q)}}M.any=G;function Q(ke,Ie,Oe,q){let V=Oe;return B(ke,J=>(V=Ie(V,J),V),q)}M.reduce=Q;function ee(ke,Ie){let Oe;const q={onWillAddFirstListener(){Oe=ke(V.fire,V)},onDidRemoveLastListener(){Oe?.dispose()}};Ie||j(q);const V=new s(q);return Ie?.add(V),V.event}function ue(ke,Ie){return Ie instanceof Array?Ie.push(ke):Ie&&Ie.add(ke),ke}function ne(ke,Ie,Oe=100,q=!1,V=!1,J,x){let fe,we,Ne,Ge=0,Ke;const tt={leakWarningThreshold:J,onWillAddFirstListener(){fe=ke(ot=>{Ge++,we=Ie(we,ot),q&&!Ne&&(rt.fire(we),we=void 0),Ke=()=>{const nt=we;we=void 0,Ne=void 0,(!q||Ge>1)&&rt.fire(nt),Ge=0},typeof Oe=="number"?(clearTimeout(Ne),Ne=setTimeout(Ke,Oe)):Ne===void 0&&(Ne=0,queueMicrotask(Ke))})},onWillRemoveListener(){V&&Ge>0&&Ke?.()},onDidRemoveLastListener(){Ke=void 0,fe.dispose()}};x||j(tt);const rt=new s(tt);return x?.add(rt),rt.event}M.debounce=ne;function De(ke,Ie=0,Oe){return M.debounce(ke,(q,V)=>q?(q.push(V),q):[V],Ie,void 0,!0,void 0,Oe)}M.accumulate=De;function $e(ke,Ie=(q,V)=>q===V,Oe){let q=!0,V;return re(ke,J=>{const x=q||!Ie(J,V);return q=!1,V=J,x},Oe)}M.latch=$e;function K(ke,Ie,Oe){return[M.filter(ke,Ie,Oe),M.filter(ke,q=>!Ie(q),Oe)]}M.split=K;function W(ke,Ie=!1,Oe=[],q){let V=Oe.slice(),J=ke(we=>{V?V.push(we):fe.fire(we)});q&&q.add(J);const x=()=>{V?.forEach(we=>fe.fire(we)),V=null},fe=new s({onWillAddFirstListener(){J||(J=ke(we=>fe.fire(we)),q&&q.add(J))},onDidAddFirstListener(){V&&(Ie?setTimeout(x):x())},onDidRemoveLastListener(){J&&J.dispose(),J=null}});return q&&q.add(fe),fe.event}M.buffer=W;function se(ke,Ie){return(q,V,J)=>{const x=Ie(new te);return ke(function(fe){const we=x.evaluate(fe);we!==oe&&q.call(V,we)},void 0,J)}}M.chain=se;const oe=Symbol("HaltChainable");class te{constructor(){this.f=[]}map(Ie){return this.f.push(Ie),this}forEach(Ie){return this.f.push(Oe=>(Ie(Oe),Oe)),this}filter(Ie){return this.f.push(Oe=>Ie(Oe)?Oe:oe),this}reduce(Ie,Oe){let q=Oe;return this.f.push(V=>(q=Ie(q,V),q)),this}latch(Ie=(Oe,q)=>Oe===q){let Oe=!0,q;return this.f.push(V=>{const J=Oe||!Ie(V,q);return Oe=!1,q=V,J?V:oe}),this}evaluate(Ie){for(const Oe of this.f)if(Ie=Oe(Ie),Ie===oe)break;return Ie}}function le(ke,Ie,Oe=q=>q){const q=(...fe)=>x.fire(Oe(...fe)),V=()=>ke.on(Ie,q),J=()=>ke.removeListener(Ie,q),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:J});return x.event}M.fromNodeEventEmitter=le;function he(ke,Ie,Oe=q=>q){const q=(...fe)=>x.fire(Oe(...fe)),V=()=>ke.addEventListener(Ie,q),J=()=>ke.removeEventListener(Ie,q),x=new s({onWillAddFirstListener:V,onDidRemoveLastListener:J});return x.event}M.fromDOMEventEmitter=he;function X(ke){return new Promise(Ie=>F(ke)(Ie))}M.toPromise=X;function ae(ke){const Ie=new s;return ke.then(Oe=>{Ie.fire(Oe)},()=>{Ie.fire(void 0)}).finally(()=>{Ie.dispose()}),Ie.event}M.fromPromise=ae;function pe(ke,Ie,Oe){return Ie(Oe),ke(q=>Ie(q))}M.runAndSubscribe=pe;class be{constructor(Ie,Oe){this._observable=Ie,this.f=0,this.g=!1;const q={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Oe||j(q),this.emitter=new s(q),Oe&&Oe.add(this.emitter)}beginUpdate(Ie){this.f++}handlePossibleChange(Ie){}handleChange(Ie,Oe){this.g=!0}endUpdate(Ie){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Fe(ke,Ie){return new be(ke,Ie).emitter.event}M.fromObservable=Fe;function Be(ke){return(Ie,Oe,q)=>{let V=0,J=!1;const x={beginUpdate(){V++},endUpdate(){V--,V===0&&(ke.reportChanges(),J&&(J=!1,Ie.call(Oe)))},handlePossibleChange(){},handleChange(){J=!0}};ke.addObserver(x),ke.reportChanges();const fe={dispose(){ke.removeObserver(x)}};return q instanceof A.$Vc?q.add(fe):Array.isArray(q)&&q.push(fe),fe}}M.fromObservableLight=Be})(I||(e.Event=I={}));class E{static{this.all=new Set}static{this.f=0}constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${E.f++}`,E.all.add(this)}start(j){this.g=new L.$ge,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$ie=E;let u=-1;function k(M){const j=u;return u=M,{dispose(){u=j}}}class b{static{this.f=1}constructor(j,z,F=(b.f++).toString(16).padStart(3,"0")){this.j=j,this.threshold=z,this.name=F,this.h=0}dispose(){this.g?.clear()}check(j,z){const F=this.threshold;if(F<=0||z<F)return;this.g||(this.g=new Map);const B=this.g.get(j.value)||0;if(this.g.set(j.value,B+1),this.h-=1,this.h<=0){this.h=F*.5;const[_,re]=this.getMostFrequentStack(),U=`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${re}):`;console.warn(U),console.warn(_);const G=new g(U,_);this.j(G)}return()=>{const _=this.g.get(j.value)||0;this.g.set(j.value,_-1)}}getMostFrequentStack(){if(!this.g)return;let j,z=0;for(const[F,B]of this.g)(!j||z<B)&&(j=[F,B],z=B);return j}}class c{static create(){const j=new Error;return new c(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(j,z){super(j),this.name="ListenerLeakError",this.stack=z}}e.$ke=g;class d extends Error{constructor(j,z){super(j),this.name="ListenerRefusalError",this.stack=z}}e.$le=d;let m=0;class n{constructor(j){this.value=j,this.id=m++}}const o=2,i=(M,j)=>{if(M instanceof n)j(M);else for(let z=0;z<M.length;z++){const F=M[z];F&&j(F)}};let t;if(O){const M=[];setInterval(()=>{M.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(M.join(`
`)),M.length=0)},3e3),t=new FinalizationRegistry(j=>{typeof j=="string"&&M.push(j)})}class s{constructor(j){this.z=0,this.f=j,this.g=u>0||this.f?.leakWarningThreshold?new b(j?.onListenerError??r.$3,this.f?.leakWarningThreshold??u):void 0,this.j=this.f?._profName?new E(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const j=this.u;queueMicrotask(()=>{i(j,z=>z.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(j,z,F)=>{if(this.g&&this.z>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(G);const Q=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new d(`${G}. HINT: Stack shows most frequent listener (${Q[1]}-times)`,Q[0]);return(this.f?.onListenerError||r.$3)(ee),A.$Wc.None}if(this.m)return A.$Wc.None;z&&(j=j.bind(z));const B=new n(j);let _,re;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(B.stack=c.create(),_=this.g.check(B.stack,this.z+1)),$&&(B.stack=re??c.create()),this.u?this.u instanceof n?(this.w??=new a,this.u=[this.u,B]):this.u.push(B):(this.f?.onWillAddFirstListener?.(this),this.u=B,this.f?.onDidAddFirstListener?.(this)),this.z++;const U=(0,A.$Uc)(()=>{t?.unregister(U),_?.(),this.A(B)});if(F instanceof A.$Vc?F.add(U):Array.isArray(F)&&F.push(U),t){const G=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),Q=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(G);t.register(U,Q?.[2]??G,U)}return U},this.q}A(j){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const z=this.u,F=z.indexOf(j);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,z[F]=void 0;const B=this.w.current===this;if(this.z*o<=z.length){let _=0;for(let re=0;re<z.length;re++)z[re]?z[_++]=z[re]:B&&(this.w.end--,_<this.w.i&&this.w.i--);z.length=_}}B(j,z){if(!j)return;const F=this.f?.onListenerError||r.$3;if(!F){j.value(z);return}try{j.value(z)}catch(B){F(B)}}C(j){const z=j.current.u;for(;j.i<j.end;)this.B(z[j.i++],j.value);j.reset()}fire(j){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof n)this.B(this.u,j);else{const z=this.w;z.enqueue(this,j,this.u.length),this.C(z)}this.j?.stop()}hasListeners(){return this.z>0}}e.$me=s;const f=()=>new a;e.$ne=f;class a{constructor(){this.i=-1,this.end=0}enqueue(j,z,F){this.i=0,this.end=F,this.current=j,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class w extends s{async fireAsync(j,z,F){if(this.u)for(this.h||(this.h=new R.$7c),i(this.u,B=>this.h.push([B.value,j]));this.h.size>0&&!z.isCancellationRequested;){const[B,_]=this.h.shift(),re=[],U={..._,token:z,waitUntil:G=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");F&&(G=F(G,B)),re.push(G)}};try{B(U)}catch(G){(0,r.$3)(G);continue}Object.freeze(re),await Promise.allSettled(re).then(G=>{for(const Q of G)Q.status==="rejected"&&(0,r.$3)(Q.reason)})}}}e.$oe=w;class y extends s{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new R.$7c,this.t=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.t(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.z&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$pe=y;class S extends y{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$qe=S;class D extends s{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}e.$re=D;class P{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const z={event:j,listener:null};this.h.push(z),this.g&&this.m(z);const F=()=>{this.g&&this.o(z);const B=this.h.indexOf(z);this.h.splice(B,1)};return(0,A.$Uc)((0,h.$fb)(F))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(z=>this.f.fire(z))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$se=P;class C{constructor(j,z,F,B){this.f=new A.$Vc;const _=this.f.add(new P),re=this.f.add(new A.$6c);function U(G){re.set(G,_.add(B(G)))}for(const G of j)U(G);this.f.add(z(G=>{U(G)})),this.f.add(F(G=>{re.deleteAndDispose(G)})),this.event=_.event}dispose(){this.f.dispose()}}e.$te=C;class p{constructor(){this.f=[]}wrapEvent(j,z,F){return(B,_,re)=>j(U=>{const G=this.f[this.f.length-1];if(!z){G?G.buffers.push(()=>B.call(_,U)):B.call(_,U);return}const Q=G;if(!Q){B.call(_,z(F,U));return}Q.items??=[],Q.items.push(U),Q.buffers.length===0&&G.buffers.push(()=>{Q.reducedResult??=F?Q.items.reduce(z,F):Q.items.reduce(z),B.call(_,Q.reducedResult)})},void 0,re)}bufferEvents(j){const z={buffers:new Array};this.f.push(z);const F=j();return this.f.pop(),z.buffers.forEach(B=>B()),F}}e.$ue=p;class v{constructor(){this.f=!1,this.g=I.None,this.h=A.$Wc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ve=v;class N{static const(j){return new T(j)}constructor(j){this.g=j,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$we=N;class T{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(Ee[21],Se([1,0,4]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xe=e.CancellationToken=void 0,e.$ye=O;const h=Object.freeze(function($,l){const I=setTimeout($.bind(l),0);return{dispose(){clearTimeout(I)}}});var A;(function($){function l(I){return I===$.None||I===$.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}$.isCancellationToken=l,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:h})})(A||(e.CancellationToken=A={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?h:(this.b||(this.b=new r.$me),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=A.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=A.None}}e.$xe=L;function O($){const l=new L;return $.add({dispose(){l.cancel()}}),l.token}}),define(Ee[182],Se([1,0,21]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$af=e.$_e=e.$0e=void 0,e.$$e=A;class h{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new r.$xe,l=this.b($.token);return this.a={promise:l,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$0e=h;function A(O){return O}class R{constructor($,l){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);return this.b!==l&&(this.b=l,this.a=this.c($)),this.a}}e.$_e=R;class L{get cachedValues(){return this.a}constructor($,l){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=A):(this.c=l,this.d=$.getCacheKey)}get($){const l=this.d($);if(this.b.has(l))return this.b.get(l);const I=this.c($);return this.a.set($,I),this.b.set(l,I),I}}e.$af=L}),define(Ee[183],Se([1,0,4,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=e.ScrollbarVisibility=void 0;var A;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(A||(e.ScrollbarVisibility=A={}));class R{constructor(b,c,g,d,m,n,o){this.c=b,this._scrollStateBrand=void 0,this.c&&(c=c|0,g=g|0,d=d|0,m=m|0,n=n|0,o=o|0),this.rawScrollLeft=d,this.rawScrollTop=o,c<0&&(c=0),d+c>g&&(d=g-c),d<0&&(d=0),m<0&&(m=0),o+m>n&&(o=n-m),o<0&&(o=0),this.width=c,this.scrollWidth=g,this.scrollLeft=d,this.height=m,this.scrollHeight=n,this.scrollTop=o}equals(b){return this.rawScrollLeft===b.rawScrollLeft&&this.rawScrollTop===b.rawScrollTop&&this.width===b.width&&this.scrollWidth===b.scrollWidth&&this.scrollLeft===b.scrollLeft&&this.height===b.height&&this.scrollHeight===b.scrollHeight&&this.scrollTop===b.scrollTop}withScrollDimensions(b,c){return new R(this.c,typeof b.width<"u"?b.width:this.width,typeof b.scrollWidth<"u"?b.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof b.height<"u"?b.height:this.height,typeof b.scrollHeight<"u"?b.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(b){return new R(this.c,this.width,this.scrollWidth,typeof b.scrollLeft<"u"?b.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof b.scrollTop<"u"?b.scrollTop:this.rawScrollTop)}createScrollEvent(b,c){const g=this.width!==b.width,d=this.scrollWidth!==b.scrollWidth,m=this.scrollLeft!==b.scrollLeft,n=this.height!==b.height,o=this.scrollHeight!==b.scrollHeight,i=this.scrollTop!==b.scrollTop;return{inSmoothScrolling:c,oldWidth:b.width,oldScrollWidth:b.scrollWidth,oldScrollLeft:b.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:b.height,oldScrollHeight:b.scrollHeight,oldScrollTop:b.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:d,scrollLeftChanged:m,heightChanged:n,scrollHeightChanged:o,scrollTopChanged:i}}}e.$0s=R;class L extends h.$Wc{constructor(b){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$me),this.onScroll=this.j.event,this.c=b.smoothScrollDuration,this.f=b.scheduleAtNextAnimationFrame,this.g=new R(b.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(b){this.c=b}validateScrollPosition(b){return this.g.withScrollPosition(b)}getScrollDimensions(){return this.g}setScrollDimensions(b,c){const g=this.g.withScrollDimensions(b,c);this.n(g,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(b){const c=this.g.withScrollPosition(b);this.h&&(this.h.dispose(),this.h=null),this.n(c,!1)}setScrollPositionSmooth(b,c){if(this.c===0)return this.setScrollPositionNow(b);if(this.h){b={scrollLeft:typeof b.scrollLeft>"u"?this.h.to.scrollLeft:b.scrollLeft,scrollTop:typeof b.scrollTop>"u"?this.h.to.scrollTop:b.scrollTop};const g=this.g.withScrollPosition(b);if(this.h.to.scrollLeft===g.scrollLeft&&this.h.to.scrollTop===g.scrollTop)return;let d;c?d=new I(this.h.from,g,this.h.startTime,this.h.duration):d=this.h.combine(this.g,g,this.c),this.h.dispose(),this.h=d}else{const g=this.g.withScrollPosition(b);this.h=I.start(this.g,g,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const b=this.h.tick(),c=this.g.withScrollPosition(b);if(this.n(c,!0),!!this.h){if(b.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(b,c){const g=this.g;g.equals(b)||(this.g=b,this.j.fire(this.g.createScrollEvent(g,c)))}}e.$$s=L;class O{constructor(b,c,g){this.scrollLeft=b,this.scrollTop=c,this.isDone=g}}e.$_s=O;function $(k,b){const c=b-k;return function(g){return k+c*u(g)}}function l(k,b,c){return function(g){return g<c?k(g/c):b((g-c)/(1-c))}}class I{constructor(b,c,g,d){this.from=b,this.to=c,this.duration=d,this.startTime=g,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(b,c,g){if(Math.abs(b-c)>2.5*g){let m,n;return b<c?(m=b+.75*g,n=c-.75*g):(m=b-.75*g,n=c+.75*g),l($(b,m),$(n,c),.33)}return $(b,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(b){this.to=b.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(b){const c=(b-this.startTime)/this.duration;if(c<1){const g=this.c(c),d=this.d(c);return new O(g,d,!1)}return new O(this.to.scrollLeft,this.to.scrollTop,!0)}combine(b,c,g){return I.start(b,c,g)}static start(b,c,g){g=g+10;const d=Date.now()-10;return new I(b,c,d,g)}}e.$at=I;function E(k){return Math.pow(k,3)}function u(k){return 1-E(1-k)}}),define(Ee[104],Se([1,0,14,3]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=A,e.$Ae=R,e.$Be=L,e.$Ce=O,e.$De=l,e.$Ee=I,e.$Fe=E,e.$Ge=u,e.$He=k,e.$Ie=b,e.$Je=c,e.$Ke=g,e.$Le=d,e.$Me=m,e.$Ne=n;function A(o){const i=o;return i?typeof i.read=="function":!1}function R(o){const i=o;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function L(o){const i=o;return i?R(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function O(o,i){return new $(o,i)}class ${constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,r.$3)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let s;switch(i){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const f=s.indexOf(t);f>=0&&s.splice(f,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(o,i){const t=[];let s;for(;(s=o.read())!==null;)t.push(s);return i(t)}function I(o,i,t){const s=[];let f;for(;(f=o.read())!==null&&s.length<t;)s.push(f);return f===null&&s.length>0?i(s):{read:()=>{if(s.length>0)return s.shift();if(typeof f<"u"){const a=f;return f=void 0,a}return o.read()}}}function E(o,i){return new Promise((t,s)=>{const f=[];u(o,{onData:a=>{i&&f.push(a)},onError:a=>{i?s(a):t(void 0)},onEnd:()=>{t(i?i(f):void 0)}})})}function u(o,i,t){o.on("error",s=>{t?.isCancellationRequested||i.onError(s)}),o.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),o.on("data",s=>{t?.isCancellationRequested||i.onData(s)})}function k(o,i){return new Promise((t,s)=>{const f=new h.$Vc,a=[],w=D=>{if(a.push(D),a.length>i)return f.dispose(),o.pause(),t({stream:o,buffer:a,ended:!1})},y=D=>(f.dispose(),s(D)),S=()=>(f.dispose(),t({stream:o,buffer:a,ended:!0}));f.add((0,h.$Uc)(()=>o.removeListener("error",y))),o.on("error",y),f.add((0,h.$Uc)(()=>o.removeListener("end",S))),o.on("end",S),f.add((0,h.$Uc)(()=>o.removeListener("data",w))),o.on("data",w)})}function b(o,i){const t=O(i);return t.end(o),t}function c(){const o=O(()=>{throw new Error("not supported")});return o.end(),o}function g(o){let i=!1;return{read:()=>i?null:(i=!0,o)}}function d(o,i,t){const s=O(t);return u(o,{onData:f=>s.write(i.data(f)),onError:f=>s.error(i.error?i.error(f):f),onEnd:()=>s.end()}),s}function m(o,i,t){let s=!1;return{read:()=>{const f=i.read();return s?f:(s=!0,f!==null?t([o,f]):o)}}}function n(o,i,t){let s=!1;const f=O(t);return u(i,{onData:a=>s?f.write(a):(s=!0,f.write(t([o,a]))),onError:a=>f.error(a),onEnd:()=>{s||(s=!0,f.write(o)),f.end()}}),f}}),define(Ee[22],Se([1,0,49,104]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=l,e.$Qe=I,e.$Re=E,e.$Se=u,e.$Te=k,e.$Ue=b,e.$Ve=c,e.$We=g,e.$Xe=d,e.$Ye=m,e.$Ze=n,e.$1e=o,e.$2e=i,e.$3e=t,e.$4e=s,e.$5e=f,e.$6e=a,e.$7e=w,e.$8e=y,e.$9e=P,h=We(h);const A=typeof Buffer<"u",R=new r.$X(()=>new Uint8Array(256));let L,O;class ${static alloc(p){return A?new $(Buffer.allocUnsafe(p)):new $(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new $(p)}static fromString(p,v){return!(v?.dontUseNodeBuffer||!1)&&A?new $(Buffer.from(p)):(L||(L=new TextEncoder),new $(L.encode(p)))}static fromByteArray(p){const v=$.alloc(p.length);for(let N=0,T=p.length;N<T;N++)v.buffer[N]=p[N];return v}static concat(p,v){if(typeof v>"u"){v=0;for(let M=0,j=p.length;M<j;M++)v+=p[M].byteLength}const N=$.alloc(v);let T=0;for(let M=0,j=p.length;M<j;M++){const z=p[M];N.set(z,T),T+=z.byteLength}return N}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=$.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(p,v){return new $(this.buffer.subarray(p,v))}set(p,v){if(p instanceof $)this.buffer.set(p.buffer,v);else if(p instanceof Uint8Array)this.buffer.set(p,v);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),v);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),v);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return u(this.buffer,p)}writeUInt32BE(p,v){k(this.buffer,p,v)}readUInt32LE(p){return b(this.buffer,p)}writeUInt32LE(p,v){c(this.buffer,p,v)}readUInt8(p){return g(this.buffer,p)}writeUInt8(p,v){d(this.buffer,p,v)}indexOf(p,v=0){return l(this.buffer,p instanceof $?p.buffer:p,v)}}e.$Oe=$;function l(C,p,v=0){const N=p.byteLength,T=C.byteLength;if(N===0)return 0;if(N===1)return C.indexOf(p[0]);if(N>T-v)return-1;const M=R.value;M.fill(p.length);for(let B=0;B<p.length;B++)M[p[B]]=p.length-B-1;let j=v+p.length-1,z=j,F=-1;for(;j<T;)if(C[j]===p[z]){if(z===0){F=j;break}j--,z--}else j+=Math.max(p.length-z,M[C[j]]),z=p.length-1;return F}function I(C,p){return C[p+0]<<0>>>0|C[p+1]<<8>>>0}function E(C,p,v){C[v+0]=p&255,p=p>>>8,C[v+1]=p&255}function u(C,p){return C[p]*2**24+C[p+1]*2**16+C[p+2]*2**8+C[p+3]}function k(C,p,v){C[v+3]=p,p=p>>>8,C[v+2]=p,p=p>>>8,C[v+1]=p,p=p>>>8,C[v]=p}function b(C,p){return C[p+0]<<0>>>0|C[p+1]<<8>>>0|C[p+2]<<16>>>0|C[p+3]<<24>>>0}function c(C,p,v){C[v+0]=p&255,p=p>>>8,C[v+1]=p&255,p=p>>>8,C[v+2]=p&255,p=p>>>8,C[v+3]=p&255}function g(C,p){return C[p]}function d(C,p,v){C[v]=p}function m(C){return h.$De(C,p=>$.concat(p))}function n(C){return h.$Ke(C)}function o(C){return h.$Fe(C,p=>$.concat(p))}async function i(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await o(C.stream)])}function t(C){return h.$Ie(C,p=>$.concat(p))}function s(C){return h.$Le(C,{data:p=>typeof p=="string"?$.fromString(p):$.wrap(p)},p=>$.concat(p))}function f(C){return h.$Ce(p=>$.concat(p),C)}function a(C,p){return h.$Me(C,p,v=>$.concat(v))}function w(C,p){return h.$Ne(C,p,v=>$.concat(v))}function y(C){let p=0,v=0,N=0;const T=new Uint8Array(Math.floor(C.length/4*3)),M=z=>{switch(v){case 3:T[N++]=p|z,v=0;break;case 2:T[N++]=p|z>>>2,p=z<<6,v=3;break;case 1:T[N++]=p|z>>>4,p=z<<4,v=2;break;default:p=z<<2,v=1}};for(let z=0;z<C.length;z++){const F=C.charCodeAt(z);if(F>=65&&F<=90)M(F-65);else if(F>=97&&F<=122)M(F-97+26);else if(F>=48&&F<=57)M(F-48+52);else if(F===43||F===45)M(62);else if(F===47||F===95)M(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${C[z]}`)}}const j=N;for(;v>0;)M(0);return $.wrap(T).slice(0,j)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function P({buffer:C},p=!0,v=!1){const N=v?D:S;let T="";const M=C.byteLength%3;let j=0;for(;j<C.byteLength-M;j+=3){const z=C[j+0],F=C[j+1],B=C[j+2];T+=N[z>>>2],T+=N[(z<<4|F>>>4)&63],T+=N[(F<<2|B>>>6)&63],T+=N[B&63]}if(M===1){const z=C[j+0];T+=N[z>>>2],T+=N[z<<4&63],p&&(T+="==")}else if(M===2){const z=C[j+0],F=C[j+1];T+=N[z>>>2],T+=N[(z<<4|F>>>4)&63],T+=N[F<<2&63],p&&(T+="=")}return T}}),define(Ee[184],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(Ee[18],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=r,e.$gg=h,e.$hg=A,e.$ig=R,e.$jg=L,e.$kg=O,e.$lg=$,e.$mg=l,e.$ng=I,e.$og=E,e.$pg=u,e.$qg=k,e.$rg=b,e.$sg=g,e.$tg=d,e.$ug=m,e.$vg=n,e.$wg=o;function r(i){return typeof i=="string"}function h(i){return Array.isArray(i)&&i.every(t=>r(t))}function A(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function R(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function L(i){return typeof i=="number"&&!isNaN(i)}function O(i){return!!i&&typeof i[Symbol.iterator]=="function"}function $(i){return i===!0||i===!1}function l(i){return typeof i>"u"}function I(i){return!E(i)}function E(i){return l(i)||i===null}function u(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function k(i){if(E(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function b(...i){const t=[];for(let s=0;s<i.length;s++){const f=i[s];if(E(f))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(f)}return t}const c=Object.prototype.hasOwnProperty;function g(i){if(!A(i))return!1;for(const t in i)if(c.call(i,t))return!1;return!0}function d(i){return typeof i=="function"}function m(...i){return i.length>0&&i.every(d)}function n(i,t){const s=Math.min(i.length,t.length);for(let f=0;f<s;f++)o(i[f],t[f])}function o(i,t){if(r(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(i instanceof t)return}catch{}if(!E(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[105],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=A,e.$1j=R;const h=Object.create(null);function A(L,O){if((0,r.$fg)(O)){const $=h[O];if($===void 0)throw new Error(`${L} references an unknown codicon: ${O}`);O=$}return h[L]=O,{id:L}}function R(){return h}}),define(Ee[185],Se([1,0,105]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=void 0,e.$2j={add:(0,r.$Zj)("add",6e4),plus:(0,r.$Zj)("plus",6e4),gistNew:(0,r.$Zj)("gist-new",6e4),repoCreate:(0,r.$Zj)("repo-create",6e4),lightbulb:(0,r.$Zj)("lightbulb",60001),lightBulb:(0,r.$Zj)("light-bulb",60001),repo:(0,r.$Zj)("repo",60002),repoDelete:(0,r.$Zj)("repo-delete",60002),gistFork:(0,r.$Zj)("gist-fork",60003),repoForked:(0,r.$Zj)("repo-forked",60003),gitPullRequest:(0,r.$Zj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Zj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Zj)("record-keys",60005),keyboard:(0,r.$Zj)("keyboard",60005),tag:(0,r.$Zj)("tag",60006),gitPullRequestLabel:(0,r.$Zj)("git-pull-request-label",60006),tagAdd:(0,r.$Zj)("tag-add",60006),tagRemove:(0,r.$Zj)("tag-remove",60006),person:(0,r.$Zj)("person",60007),personFollow:(0,r.$Zj)("person-follow",60007),personOutline:(0,r.$Zj)("person-outline",60007),personFilled:(0,r.$Zj)("person-filled",60007),gitBranch:(0,r.$Zj)("git-branch",60008),gitBranchCreate:(0,r.$Zj)("git-branch-create",60008),gitBranchDelete:(0,r.$Zj)("git-branch-delete",60008),sourceControl:(0,r.$Zj)("source-control",60008),mirror:(0,r.$Zj)("mirror",60009),mirrorPublic:(0,r.$Zj)("mirror-public",60009),star:(0,r.$Zj)("star",60010),starAdd:(0,r.$Zj)("star-add",60010),starDelete:(0,r.$Zj)("star-delete",60010),starEmpty:(0,r.$Zj)("star-empty",60010),comment:(0,r.$Zj)("comment",60011),commentAdd:(0,r.$Zj)("comment-add",60011),alert:(0,r.$Zj)("alert",60012),warning:(0,r.$Zj)("warning",60012),search:(0,r.$Zj)("search",60013),searchSave:(0,r.$Zj)("search-save",60013),logOut:(0,r.$Zj)("log-out",60014),signOut:(0,r.$Zj)("sign-out",60014),logIn:(0,r.$Zj)("log-in",60015),signIn:(0,r.$Zj)("sign-in",60015),eye:(0,r.$Zj)("eye",60016),eyeUnwatch:(0,r.$Zj)("eye-unwatch",60016),eyeWatch:(0,r.$Zj)("eye-watch",60016),circleFilled:(0,r.$Zj)("circle-filled",60017),primitiveDot:(0,r.$Zj)("primitive-dot",60017),closeDirty:(0,r.$Zj)("close-dirty",60017),debugBreakpoint:(0,r.$Zj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Zj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Zj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Zj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Zj)("primitive-square",60018),edit:(0,r.$Zj)("edit",60019),pencil:(0,r.$Zj)("pencil",60019),info:(0,r.$Zj)("info",60020),issueOpened:(0,r.$Zj)("issue-opened",60020),gistPrivate:(0,r.$Zj)("gist-private",60021),gitForkPrivate:(0,r.$Zj)("git-fork-private",60021),lock:(0,r.$Zj)("lock",60021),mirrorPrivate:(0,r.$Zj)("mirror-private",60021),close:(0,r.$Zj)("close",60022),removeClose:(0,r.$Zj)("remove-close",60022),x:(0,r.$Zj)("x",60022),repoSync:(0,r.$Zj)("repo-sync",60023),sync:(0,r.$Zj)("sync",60023),clone:(0,r.$Zj)("clone",60024),desktopDownload:(0,r.$Zj)("desktop-download",60024),beaker:(0,r.$Zj)("beaker",60025),microscope:(0,r.$Zj)("microscope",60025),vm:(0,r.$Zj)("vm",60026),deviceDesktop:(0,r.$Zj)("device-desktop",60026),file:(0,r.$Zj)("file",60027),fileText:(0,r.$Zj)("file-text",60027),more:(0,r.$Zj)("more",60028),ellipsis:(0,r.$Zj)("ellipsis",60028),kebabHorizontal:(0,r.$Zj)("kebab-horizontal",60028),mailReply:(0,r.$Zj)("mail-reply",60029),reply:(0,r.$Zj)("reply",60029),organization:(0,r.$Zj)("organization",60030),organizationFilled:(0,r.$Zj)("organization-filled",60030),organizationOutline:(0,r.$Zj)("organization-outline",60030),newFile:(0,r.$Zj)("new-file",60031),fileAdd:(0,r.$Zj)("file-add",60031),newFolder:(0,r.$Zj)("new-folder",60032),fileDirectoryCreate:(0,r.$Zj)("file-directory-create",60032),trash:(0,r.$Zj)("trash",60033),trashcan:(0,r.$Zj)("trashcan",60033),history:(0,r.$Zj)("history",60034),clock:(0,r.$Zj)("clock",60034),folder:(0,r.$Zj)("folder",60035),fileDirectory:(0,r.$Zj)("file-directory",60035),symbolFolder:(0,r.$Zj)("symbol-folder",60035),logoGithub:(0,r.$Zj)("logo-github",60036),markGithub:(0,r.$Zj)("mark-github",60036),github:(0,r.$Zj)("github",60036),terminal:(0,r.$Zj)("terminal",60037),console:(0,r.$Zj)("console",60037),repl:(0,r.$Zj)("repl",60037),zap:(0,r.$Zj)("zap",60038),symbolEvent:(0,r.$Zj)("symbol-event",60038),error:(0,r.$Zj)("error",60039),stop:(0,r.$Zj)("stop",60039),variable:(0,r.$Zj)("variable",60040),symbolVariable:(0,r.$Zj)("symbol-variable",60040),array:(0,r.$Zj)("array",60042),symbolArray:(0,r.$Zj)("symbol-array",60042),symbolModule:(0,r.$Zj)("symbol-module",60043),symbolPackage:(0,r.$Zj)("symbol-package",60043),symbolNamespace:(0,r.$Zj)("symbol-namespace",60043),symbolObject:(0,r.$Zj)("symbol-object",60043),symbolMethod:(0,r.$Zj)("symbol-method",60044),symbolFunction:(0,r.$Zj)("symbol-function",60044),symbolConstructor:(0,r.$Zj)("symbol-constructor",60044),symbolBoolean:(0,r.$Zj)("symbol-boolean",60047),symbolNull:(0,r.$Zj)("symbol-null",60047),symbolNumeric:(0,r.$Zj)("symbol-numeric",60048),symbolNumber:(0,r.$Zj)("symbol-number",60048),symbolStructure:(0,r.$Zj)("symbol-structure",60049),symbolStruct:(0,r.$Zj)("symbol-struct",60049),symbolParameter:(0,r.$Zj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Zj)("symbol-type-parameter",60050),symbolKey:(0,r.$Zj)("symbol-key",60051),symbolText:(0,r.$Zj)("symbol-text",60051),symbolReference:(0,r.$Zj)("symbol-reference",60052),goToFile:(0,r.$Zj)("go-to-file",60052),symbolEnum:(0,r.$Zj)("symbol-enum",60053),symbolValue:(0,r.$Zj)("symbol-value",60053),symbolRuler:(0,r.$Zj)("symbol-ruler",60054),symbolUnit:(0,r.$Zj)("symbol-unit",60054),activateBreakpoints:(0,r.$Zj)("activate-breakpoints",60055),archive:(0,r.$Zj)("archive",60056),arrowBoth:(0,r.$Zj)("arrow-both",60057),arrowDown:(0,r.$Zj)("arrow-down",60058),arrowLeft:(0,r.$Zj)("arrow-left",60059),arrowRight:(0,r.$Zj)("arrow-right",60060),arrowSmallDown:(0,r.$Zj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Zj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Zj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Zj)("arrow-small-up",60064),arrowUp:(0,r.$Zj)("arrow-up",60065),bell:(0,r.$Zj)("bell",60066),bold:(0,r.$Zj)("bold",60067),book:(0,r.$Zj)("book",60068),bookmark:(0,r.$Zj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Zj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Zj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Zj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Zj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Zj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Zj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Zj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Zj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Zj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Zj)("briefcase",60076),broadcast:(0,r.$Zj)("broadcast",60077),browser:(0,r.$Zj)("browser",60078),bug:(0,r.$Zj)("bug",60079),calendar:(0,r.$Zj)("calendar",60080),caseSensitive:(0,r.$Zj)("case-sensitive",60081),check:(0,r.$Zj)("check",60082),checklist:(0,r.$Zj)("checklist",60083),chevronDown:(0,r.$Zj)("chevron-down",60084),chevronLeft:(0,r.$Zj)("chevron-left",60085),chevronRight:(0,r.$Zj)("chevron-right",60086),chevronUp:(0,r.$Zj)("chevron-up",60087),chromeClose:(0,r.$Zj)("chrome-close",60088),chromeMaximize:(0,r.$Zj)("chrome-maximize",60089),chromeMinimize:(0,r.$Zj)("chrome-minimize",60090),chromeRestore:(0,r.$Zj)("chrome-restore",60091),circleOutline:(0,r.$Zj)("circle-outline",60092),circle:(0,r.$Zj)("circle",60092),debugBreakpointUnverified:(0,r.$Zj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Zj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Zj)("circle-slash",60093),circuitBoard:(0,r.$Zj)("circuit-board",60094),clearAll:(0,r.$Zj)("clear-all",60095),clippy:(0,r.$Zj)("clippy",60096),closeAll:(0,r.$Zj)("close-all",60097),cloudDownload:(0,r.$Zj)("cloud-download",60098),cloudUpload:(0,r.$Zj)("cloud-upload",60099),code:(0,r.$Zj)("code",60100),collapseAll:(0,r.$Zj)("collapse-all",60101),colorMode:(0,r.$Zj)("color-mode",60102),commentDiscussion:(0,r.$Zj)("comment-discussion",60103),creditCard:(0,r.$Zj)("credit-card",60105),dash:(0,r.$Zj)("dash",60108),dashboard:(0,r.$Zj)("dashboard",60109),database:(0,r.$Zj)("database",60110),debugContinue:(0,r.$Zj)("debug-continue",60111),debugDisconnect:(0,r.$Zj)("debug-disconnect",60112),debugPause:(0,r.$Zj)("debug-pause",60113),debugRestart:(0,r.$Zj)("debug-restart",60114),debugStart:(0,r.$Zj)("debug-start",60115),debugStepInto:(0,r.$Zj)("debug-step-into",60116),debugStepOut:(0,r.$Zj)("debug-step-out",60117),debugStepOver:(0,r.$Zj)("debug-step-over",60118),debugStop:(0,r.$Zj)("debug-stop",60119),debug:(0,r.$Zj)("debug",60120),deviceCameraVideo:(0,r.$Zj)("device-camera-video",60121),deviceCamera:(0,r.$Zj)("device-camera",60122),deviceMobile:(0,r.$Zj)("device-mobile",60123),diffAdded:(0,r.$Zj)("diff-added",60124),diffIgnored:(0,r.$Zj)("diff-ignored",60125),diffModified:(0,r.$Zj)("diff-modified",60126),diffRemoved:(0,r.$Zj)("diff-removed",60127),diffRenamed:(0,r.$Zj)("diff-renamed",60128),diff:(0,r.$Zj)("diff",60129),diffSidebyside:(0,r.$Zj)("diff-sidebyside",60129),discard:(0,r.$Zj)("discard",60130),editorLayout:(0,r.$Zj)("editor-layout",60131),emptyWindow:(0,r.$Zj)("empty-window",60132),exclude:(0,r.$Zj)("exclude",60133),extensions:(0,r.$Zj)("extensions",60134),eyeClosed:(0,r.$Zj)("eye-closed",60135),fileBinary:(0,r.$Zj)("file-binary",60136),fileCode:(0,r.$Zj)("file-code",60137),fileMedia:(0,r.$Zj)("file-media",60138),filePdf:(0,r.$Zj)("file-pdf",60139),fileSubmodule:(0,r.$Zj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Zj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Zj)("file-symlink-file",60142),fileZip:(0,r.$Zj)("file-zip",60143),files:(0,r.$Zj)("files",60144),filter:(0,r.$Zj)("filter",60145),flame:(0,r.$Zj)("flame",60146),foldDown:(0,r.$Zj)("fold-down",60147),foldUp:(0,r.$Zj)("fold-up",60148),fold:(0,r.$Zj)("fold",60149),folderActive:(0,r.$Zj)("folder-active",60150),folderOpened:(0,r.$Zj)("folder-opened",60151),gear:(0,r.$Zj)("gear",60152),gift:(0,r.$Zj)("gift",60153),gistSecret:(0,r.$Zj)("gist-secret",60154),gist:(0,r.$Zj)("gist",60155),gitCommit:(0,r.$Zj)("git-commit",60156),gitCompare:(0,r.$Zj)("git-compare",60157),compareChanges:(0,r.$Zj)("compare-changes",60157),gitMerge:(0,r.$Zj)("git-merge",60158),githubAction:(0,r.$Zj)("github-action",60159),githubAlt:(0,r.$Zj)("github-alt",60160),globe:(0,r.$Zj)("globe",60161),grabber:(0,r.$Zj)("grabber",60162),graph:(0,r.$Zj)("graph",60163),gripper:(0,r.$Zj)("gripper",60164),heart:(0,r.$Zj)("heart",60165),home:(0,r.$Zj)("home",60166),horizontalRule:(0,r.$Zj)("horizontal-rule",60167),hubot:(0,r.$Zj)("hubot",60168),inbox:(0,r.$Zj)("inbox",60169),issueReopened:(0,r.$Zj)("issue-reopened",60171),issues:(0,r.$Zj)("issues",60172),italic:(0,r.$Zj)("italic",60173),jersey:(0,r.$Zj)("jersey",60174),json:(0,r.$Zj)("json",60175),kebabVertical:(0,r.$Zj)("kebab-vertical",60176),key:(0,r.$Zj)("key",60177),law:(0,r.$Zj)("law",60178),lightbulbAutofix:(0,r.$Zj)("lightbulb-autofix",60179),linkExternal:(0,r.$Zj)("link-external",60180),link:(0,r.$Zj)("link",60181),listOrdered:(0,r.$Zj)("list-ordered",60182),listUnordered:(0,r.$Zj)("list-unordered",60183),liveShare:(0,r.$Zj)("live-share",60184),loading:(0,r.$Zj)("loading",60185),location:(0,r.$Zj)("location",60186),mailRead:(0,r.$Zj)("mail-read",60187),mail:(0,r.$Zj)("mail",60188),markdown:(0,r.$Zj)("markdown",60189),megaphone:(0,r.$Zj)("megaphone",60190),mention:(0,r.$Zj)("mention",60191),milestone:(0,r.$Zj)("milestone",60192),gitPullRequestMilestone:(0,r.$Zj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Zj)("mortar-board",60193),move:(0,r.$Zj)("move",60194),multipleWindows:(0,r.$Zj)("multiple-windows",60195),mute:(0,r.$Zj)("mute",60196),noNewline:(0,r.$Zj)("no-newline",60197),note:(0,r.$Zj)("note",60198),octoface:(0,r.$Zj)("octoface",60199),openPreview:(0,r.$Zj)("open-preview",60200),package:(0,r.$Zj)("package",60201),paintcan:(0,r.$Zj)("paintcan",60202),pin:(0,r.$Zj)("pin",60203),play:(0,r.$Zj)("play",60204),run:(0,r.$Zj)("run",60204),plug:(0,r.$Zj)("plug",60205),preserveCase:(0,r.$Zj)("preserve-case",60206),preview:(0,r.$Zj)("preview",60207),project:(0,r.$Zj)("project",60208),pulse:(0,r.$Zj)("pulse",60209),question:(0,r.$Zj)("question",60210),quote:(0,r.$Zj)("quote",60211),radioTower:(0,r.$Zj)("radio-tower",60212),reactions:(0,r.$Zj)("reactions",60213),references:(0,r.$Zj)("references",60214),refresh:(0,r.$Zj)("refresh",60215),regex:(0,r.$Zj)("regex",60216),remoteExplorer:(0,r.$Zj)("remote-explorer",60217),remote:(0,r.$Zj)("remote",60218),remove:(0,r.$Zj)("remove",60219),replaceAll:(0,r.$Zj)("replace-all",60220),replace:(0,r.$Zj)("replace",60221),repoClone:(0,r.$Zj)("repo-clone",60222),repoForcePush:(0,r.$Zj)("repo-force-push",60223),repoPull:(0,r.$Zj)("repo-pull",60224),repoPush:(0,r.$Zj)("repo-push",60225),report:(0,r.$Zj)("report",60226),requestChanges:(0,r.$Zj)("request-changes",60227),rocket:(0,r.$Zj)("rocket",60228),rootFolderOpened:(0,r.$Zj)("root-folder-opened",60229),rootFolder:(0,r.$Zj)("root-folder",60230),rss:(0,r.$Zj)("rss",60231),ruby:(0,r.$Zj)("ruby",60232),saveAll:(0,r.$Zj)("save-all",60233),saveAs:(0,r.$Zj)("save-as",60234),save:(0,r.$Zj)("save",60235),screenFull:(0,r.$Zj)("screen-full",60236),screenNormal:(0,r.$Zj)("screen-normal",60237),searchStop:(0,r.$Zj)("search-stop",60238),server:(0,r.$Zj)("server",60240),settingsGear:(0,r.$Zj)("settings-gear",60241),settings:(0,r.$Zj)("settings",60242),shield:(0,r.$Zj)("shield",60243),smiley:(0,r.$Zj)("smiley",60244),sortPrecedence:(0,r.$Zj)("sort-precedence",60245),splitHorizontal:(0,r.$Zj)("split-horizontal",60246),splitVertical:(0,r.$Zj)("split-vertical",60247),squirrel:(0,r.$Zj)("squirrel",60248),starFull:(0,r.$Zj)("star-full",60249),starHalf:(0,r.$Zj)("star-half",60250),symbolClass:(0,r.$Zj)("symbol-class",60251),symbolColor:(0,r.$Zj)("symbol-color",60252),symbolConstant:(0,r.$Zj)("symbol-constant",60253),symbolEnumMember:(0,r.$Zj)("symbol-enum-member",60254),symbolField:(0,r.$Zj)("symbol-field",60255),symbolFile:(0,r.$Zj)("symbol-file",60256),symbolInterface:(0,r.$Zj)("symbol-interface",60257),symbolKeyword:(0,r.$Zj)("symbol-keyword",60258),symbolMisc:(0,r.$Zj)("symbol-misc",60259),symbolOperator:(0,r.$Zj)("symbol-operator",60260),symbolProperty:(0,r.$Zj)("symbol-property",60261),wrench:(0,r.$Zj)("wrench",60261),wrenchSubaction:(0,r.$Zj)("wrench-subaction",60261),symbolSnippet:(0,r.$Zj)("symbol-snippet",60262),tasklist:(0,r.$Zj)("tasklist",60263),telescope:(0,r.$Zj)("telescope",60264),textSize:(0,r.$Zj)("text-size",60265),threeBars:(0,r.$Zj)("three-bars",60266),thumbsdown:(0,r.$Zj)("thumbsdown",60267),thumbsup:(0,r.$Zj)("thumbsup",60268),tools:(0,r.$Zj)("tools",60269),triangleDown:(0,r.$Zj)("triangle-down",60270),triangleLeft:(0,r.$Zj)("triangle-left",60271),triangleRight:(0,r.$Zj)("triangle-right",60272),triangleUp:(0,r.$Zj)("triangle-up",60273),twitter:(0,r.$Zj)("twitter",60274),unfold:(0,r.$Zj)("unfold",60275),unlock:(0,r.$Zj)("unlock",60276),unmute:(0,r.$Zj)("unmute",60277),unverified:(0,r.$Zj)("unverified",60278),verified:(0,r.$Zj)("verified",60279),versions:(0,r.$Zj)("versions",60280),vmActive:(0,r.$Zj)("vm-active",60281),vmOutline:(0,r.$Zj)("vm-outline",60282),vmRunning:(0,r.$Zj)("vm-running",60283),watch:(0,r.$Zj)("watch",60284),whitespace:(0,r.$Zj)("whitespace",60285),wholeWord:(0,r.$Zj)("whole-word",60286),window:(0,r.$Zj)("window",60287),wordWrap:(0,r.$Zj)("word-wrap",60288),zoomIn:(0,r.$Zj)("zoom-in",60289),zoomOut:(0,r.$Zj)("zoom-out",60290),listFilter:(0,r.$Zj)("list-filter",60291),listFlat:(0,r.$Zj)("list-flat",60292),listSelection:(0,r.$Zj)("list-selection",60293),selection:(0,r.$Zj)("selection",60293),listTree:(0,r.$Zj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Zj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Zj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Zj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Zj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Zj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Zj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Zj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Zj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Zj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Zj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Zj)("symbol-string",60301),debugReverseContinue:(0,r.$Zj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Zj)("debug-step-back",60303),debugRestartFrame:(0,r.$Zj)("debug-restart-frame",60304),debugAlt:(0,r.$Zj)("debug-alt",60305),callIncoming:(0,r.$Zj)("call-incoming",60306),callOutgoing:(0,r.$Zj)("call-outgoing",60307),menu:(0,r.$Zj)("menu",60308),expandAll:(0,r.$Zj)("expand-all",60309),feedback:(0,r.$Zj)("feedback",60310),gitPullRequestReviewer:(0,r.$Zj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Zj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Zj)("ungroup-by-ref-type",60312),account:(0,r.$Zj)("account",60313),gitPullRequestAssignee:(0,r.$Zj)("git-pull-request-assignee",60313),bellDot:(0,r.$Zj)("bell-dot",60314),debugConsole:(0,r.$Zj)("debug-console",60315),library:(0,r.$Zj)("library",60316),output:(0,r.$Zj)("output",60317),runAll:(0,r.$Zj)("run-all",60318),syncIgnored:(0,r.$Zj)("sync-ignored",60319),pinned:(0,r.$Zj)("pinned",60320),githubInverted:(0,r.$Zj)("github-inverted",60321),serverProcess:(0,r.$Zj)("server-process",60322),serverEnvironment:(0,r.$Zj)("server-environment",60323),pass:(0,r.$Zj)("pass",60324),issueClosed:(0,r.$Zj)("issue-closed",60324),stopCircle:(0,r.$Zj)("stop-circle",60325),playCircle:(0,r.$Zj)("play-circle",60326),record:(0,r.$Zj)("record",60327),debugAltSmall:(0,r.$Zj)("debug-alt-small",60328),vmConnect:(0,r.$Zj)("vm-connect",60329),cloud:(0,r.$Zj)("cloud",60330),merge:(0,r.$Zj)("merge",60331),export:(0,r.$Zj)("export",60332),graphLeft:(0,r.$Zj)("graph-left",60333),magnet:(0,r.$Zj)("magnet",60334),notebook:(0,r.$Zj)("notebook",60335),redo:(0,r.$Zj)("redo",60336),checkAll:(0,r.$Zj)("check-all",60337),pinnedDirty:(0,r.$Zj)("pinned-dirty",60338),passFilled:(0,r.$Zj)("pass-filled",60339),circleLargeFilled:(0,r.$Zj)("circle-large-filled",60340),circleLarge:(0,r.$Zj)("circle-large",60341),circleLargeOutline:(0,r.$Zj)("circle-large-outline",60341),combine:(0,r.$Zj)("combine",60342),gather:(0,r.$Zj)("gather",60342),table:(0,r.$Zj)("table",60343),variableGroup:(0,r.$Zj)("variable-group",60344),typeHierarchy:(0,r.$Zj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Zj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Zj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Zj)("git-pull-request-create",60348),runAbove:(0,r.$Zj)("run-above",60349),runBelow:(0,r.$Zj)("run-below",60350),notebookTemplate:(0,r.$Zj)("notebook-template",60351),debugRerun:(0,r.$Zj)("debug-rerun",60352),workspaceTrusted:(0,r.$Zj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Zj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Zj)("workspace-unknown",60355),terminalCmd:(0,r.$Zj)("terminal-cmd",60356),terminalDebian:(0,r.$Zj)("terminal-debian",60357),terminalLinux:(0,r.$Zj)("terminal-linux",60358),terminalPowershell:(0,r.$Zj)("terminal-powershell",60359),terminalTmux:(0,r.$Zj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Zj)("terminal-ubuntu",60361),terminalBash:(0,r.$Zj)("terminal-bash",60362),arrowSwap:(0,r.$Zj)("arrow-swap",60363),copy:(0,r.$Zj)("copy",60364),personAdd:(0,r.$Zj)("person-add",60365),filterFilled:(0,r.$Zj)("filter-filled",60366),wand:(0,r.$Zj)("wand",60367),debugLineByLine:(0,r.$Zj)("debug-line-by-line",60368),inspect:(0,r.$Zj)("inspect",60369),layers:(0,r.$Zj)("layers",60370),layersDot:(0,r.$Zj)("layers-dot",60371),layersActive:(0,r.$Zj)("layers-active",60372),compass:(0,r.$Zj)("compass",60373),compassDot:(0,r.$Zj)("compass-dot",60374),compassActive:(0,r.$Zj)("compass-active",60375),azure:(0,r.$Zj)("azure",60376),issueDraft:(0,r.$Zj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Zj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Zj)("git-pull-request-draft",60379),debugAll:(0,r.$Zj)("debug-all",60380),debugCoverage:(0,r.$Zj)("debug-coverage",60381),runErrors:(0,r.$Zj)("run-errors",60382),folderLibrary:(0,r.$Zj)("folder-library",60383),debugContinueSmall:(0,r.$Zj)("debug-continue-small",60384),beakerStop:(0,r.$Zj)("beaker-stop",60385),graphLine:(0,r.$Zj)("graph-line",60386),graphScatter:(0,r.$Zj)("graph-scatter",60387),pieChart:(0,r.$Zj)("pie-chart",60388),bracket:(0,r.$Zj)("bracket",60175),bracketDot:(0,r.$Zj)("bracket-dot",60389),bracketError:(0,r.$Zj)("bracket-error",60390),lockSmall:(0,r.$Zj)("lock-small",60391),azureDevops:(0,r.$Zj)("azure-devops",60392),verifiedFilled:(0,r.$Zj)("verified-filled",60393),newline:(0,r.$Zj)("newline",60394),layout:(0,r.$Zj)("layout",60395),layoutActivitybarLeft:(0,r.$Zj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Zj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Zj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Zj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Zj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Zj)("layout-panel-right",60401),layoutPanel:(0,r.$Zj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Zj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Zj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Zj)("layout-statusbar",60405),layoutMenubar:(0,r.$Zj)("layout-menubar",60406),layoutCentered:(0,r.$Zj)("layout-centered",60407),target:(0,r.$Zj)("target",60408),indent:(0,r.$Zj)("indent",60409),recordSmall:(0,r.$Zj)("record-small",60410),errorSmall:(0,r.$Zj)("error-small",60411),terminalDecorationError:(0,r.$Zj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Zj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Zj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Zj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Zj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Zj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Zj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Zj)("layout-sidebar-left-off",60418),blank:(0,r.$Zj)("blank",60419),heartFilled:(0,r.$Zj)("heart-filled",60420),map:(0,r.$Zj)("map",60421),mapHorizontal:(0,r.$Zj)("map-horizontal",60421),foldHorizontal:(0,r.$Zj)("fold-horizontal",60421),mapFilled:(0,r.$Zj)("map-filled",60422),mapHorizontalFilled:(0,r.$Zj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Zj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Zj)("circle-small",60423),bellSlash:(0,r.$Zj)("bell-slash",60424),bellSlashDot:(0,r.$Zj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Zj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Zj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Zj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Zj)("search-fuzzy",60429),commentDraft:(0,r.$Zj)("comment-draft",60430),send:(0,r.$Zj)("send",60431),sparkle:(0,r.$Zj)("sparkle",60432),insert:(0,r.$Zj)("insert",60433),mic:(0,r.$Zj)("mic",60434),thumbsdownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Zj)("thumbsup-filled",60436),coffee:(0,r.$Zj)("coffee",60437),snake:(0,r.$Zj)("snake",60438),game:(0,r.$Zj)("game",60439),vr:(0,r.$Zj)("vr",60440),chip:(0,r.$Zj)("chip",60441),piano:(0,r.$Zj)("piano",60442),music:(0,r.$Zj)("music",60443),micFilled:(0,r.$Zj)("mic-filled",60444),repoFetch:(0,r.$Zj)("repo-fetch",60445),copilot:(0,r.$Zj)("copilot",60446),lightbulbSparkle:(0,r.$Zj)("lightbulb-sparkle",60447),robot:(0,r.$Zj)("robot",60448),sparkleFilled:(0,r.$Zj)("sparkle-filled",60449),diffSingle:(0,r.$Zj)("diff-single",60450),diffMultiple:(0,r.$Zj)("diff-multiple",60451),surroundWith:(0,r.$Zj)("surround-with",60452),share:(0,r.$Zj)("share",60453),gitStash:(0,r.$Zj)("git-stash",60454),gitStashApply:(0,r.$Zj)("git-stash-apply",60455),gitStashPop:(0,r.$Zj)("git-stash-pop",60456),vscode:(0,r.$Zj)("vscode",60457),vscodeInsiders:(0,r.$Zj)("vscode-insiders",60458),codeOss:(0,r.$Zj)("code-oss",60459),runCoverage:(0,r.$Zj)("run-coverage",60460),runAllCoverage:(0,r.$Zj)("run-all-coverage",60461),coverage:(0,r.$Zj)("coverage",60462),githubProject:(0,r.$Zj)("github-project",60463),mapVertical:(0,r.$Zj)("map-vertical",60464),foldVertical:(0,r.$Zj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Zj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Zj)("fold-vertical-filled",60465),goToSearch:(0,r.$Zj)("go-to-search",60466),percentage:(0,r.$Zj)("percentage",60467),sortPercentage:(0,r.$Zj)("sort-percentage",60467),attach:(0,r.$Zj)("attach",60468)}}),define(Ee[83],Se([1,0,105,185]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=void 0,e.$3j=A;function A(){return Object.values(e.$5j)}e.$4j={dialogError:(0,r.$Zj)("dialog-error","error"),dialogWarning:(0,r.$Zj)("dialog-warning","warning"),dialogInfo:(0,r.$Zj)("dialog-info","info"),dialogClose:(0,r.$Zj)("dialog-close","close"),treeItemExpanded:(0,r.$Zj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Zj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Zj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Zj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Zj)("tree-item-loading","loading"),menuSelection:(0,r.$Zj)("menu-selection","check"),menuSubmenu:(0,r.$Zj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Zj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Zj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Zj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Zj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Zj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Zj)("toolbar-more","more"),quickInputBack:(0,r.$Zj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Zj)("drop-down-button",60084),symbolCustomColor:(0,r.$Zj)("symbol-customcolor",60252),exportIcon:(0,r.$Zj)("export",60332),workspaceUnspecified:(0,r.$Zj)("workspace-unspecified",60355),newLine:(0,r.$Zj)("newline",60394),thumbsDownFilled:(0,r.$Zj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Zj)("thumbsup-filled",60436),gitFetch:(0,r.$Zj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Zj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Zj)("debug-breakpoint-pending",60377)},e.$5j={...h.$2j,...e.$4j}}),define(Ee[25],Se([1,0,18]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=h,e.$do=A,e.$eo=L,e.$fo=$,e.$go=l,e.$ho=I,e.$io=E,e.$jo=u,e.$ko=k,e.$lo=b,e.$mo=c,e.$no=g,e.$oo=d;function h(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([o,i])=>{n[o]=i&&typeof i=="object"?h(i):i}),n}function A(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const o=n.shift();Object.freeze(o);for(const i in o)if(R.call(o,i)){const t=o[i];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.$ig)(t)&&n.push(t)}}return m}const R=Object.prototype.hasOwnProperty;function L(m,n){return O(m,n,new Set)}function O(m,n,o){if((0,r.$og)(m))return m;const i=n(m);if(typeof i<"u")return i;if(Array.isArray(m)){const t=[];for(const s of m)t.push(O(s,n,o));return t}if((0,r.$hg)(m)){if(o.has(m))throw new Error("Cannot clone recursive data-structure");o.add(m);const t={};for(const s in m)R.call(m,s)&&(t[s]=O(m[s],n,o));return o.delete(m),t}return m}function $(m,n,o=!0){return(0,r.$hg)(m)?((0,r.$hg)(n)&&Object.keys(n).forEach(i=>{i in m?o&&((0,r.$hg)(m[i])&&(0,r.$hg)(n[i])?$(m[i],n[i],o):m[i]=n[i]):m[i]=n[i]}),m):n}function l(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let o,i;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(o=0;o<m.length;o++)if(!l(m[o],n[o]))return!1}else{const t=[];for(i in m)t.push(i);t.sort();const s=[];for(i in n)s.push(i);if(s.sort(),!l(t,s))return!1;for(o=0;o<t.length;o++)if(!l(m[t[o]],n[t[o]]))return!1}return!0}function I(m){const n=new Set;return JSON.stringify(m,(o,i)=>{if((0,r.$hg)(i)||Array.isArray(i)){if(n.has(i))return"[Circular]";n.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function E(m,n){const o=Object.create(null);return!m||!n||Object.keys(n).forEach(t=>{const s=m[t],f=n[t];l(s,f)||(o[t]=f)}),o}function u(m,n){const o=n.toLowerCase(),i=Object.keys(m).find(t=>t.toLowerCase()===o);return i?m[i]:m[n]}function k(m,n){const o=Object.create(null);for(const[i,t]of Object.entries(m))n(i,t)&&(o[i]=t);return o}function b(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}function c(m){const n=[];for(const o of b(m))typeof m[o]=="function"&&n.push(o);return n}function g(m,n){const o=t=>function(){const s=Array.prototype.slice.call(arguments,0);return n(t,s)},i={};for(const t of m)i[t]=o(t);return i}function d(m,n){const o={};for(const[i,t]of Object.entries(m))o[i]=n(t,i);return o}}),define(Ee[50],Se([1,0,83]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=A;var h;(function(L){function O($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=O})(h||(e.ThemeColor=h={}));function A(L){return{id:L}}var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const O=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(m){const n=O.exec(m.id);if(!n)return $(r.$5j.error);const[,o,i]=n,t=["codicon","codicon-"+o];return i&&t.push("codicon-modifier-"+i.substring(1)),t}L.asClassNameArray=$;function l(m){return $(m).join(" ")}L.asClassName=l;function I(m){return"."+$(m).join(".")}L.asCSSSelector=I;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||h.isThemeColor(m.color))}L.isThemeIcon=E;const u=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function k(m){const n=u.exec(m);if(!n)return;const[,o]=n;return{id:o}}L.fromString=k;function b(m){return{id:m}}L.fromId=b;function c(m,n){let o=m.id;const i=o.lastIndexOf("~");return i!==-1&&(o=o.substring(0,i)),n&&(o=`${o}~${n}`),{id:o}}L.modify=c;function g(m){const n=m.id.lastIndexOf("~");if(n!==-1)return m.id.substring(n+1)}L.getModifier=g;function d(m,n){return m.id===n.id&&m.color?.id===n.color?.id}L.isEqual=d})(R||(e.ThemeIcon=R={}))}),define(Ee[84],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$bf=h,e.$cf=A;var r;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function h(R){return R<0?0:R>r.MAX_UINT_8?r.MAX_UINT_8:R|0}function A(R){return R<0?0:R>r.MAX_UINT_32?r.MAX_UINT_32:R|0}}),define(Ee[13],Se([1,0,182,27,49,84]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.GraphemeBreakType=e.$5f=e.$Wf=e.$Pf=e.$Of=void 0,e.$df=L,e.$ef=$,e.$ff=I,e.$gf=E,e.$hf=u,e.$if=k,e.$jf=b,e.$kf=c,e.$lf=g,e.$mf=d,e.$nf=m,e.$of=n,e.$pf=o,e.$qf=i,e.$rf=t,e.$sf=s,e.$tf=f,e.$uf=a,e.$vf=w,e.$wf=y,e.$xf=S,e.$yf=D,e.$zf=P,e.$Af=C,e.$Bf=p,e.$Cf=v,e.$Df=N,e.$Ef=T,e.$Ff=M,e.$Gf=j,e.$Hf=z,e.$If=F,e.$Jf=B,e.$Kf=_,e.$Lf=re,e.$Mf=U,e.$Nf=G,e.$Qf=ne,e.$Rf=De,e.$Sf=$e,e.$Tf=K,e.$Uf=oe,e.$Vf=le,e.$Xf=he,e.$Yf=X,e.$Zf=ae,e.$1f=pe,e.$2f=Fe,e.$3f=Be,e.$4f=Ie,e.$6f=Oe,e.$7f=q,e.$8f=V,e.$9f=J,e.$0f=x,e.$$f=fe,e.$_f=we,e.$ag=Ne,e.$bg=ot;function L(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}const O=/{(\d+)}/g;function $(Pe,...ze){return ze.length===0?Pe:Pe.replace(O,function(Ze,Te){const Me=parseInt(Te,10);return isNaN(Me)||Me<0||Me>=ze.length?Ze:ze[Me]})}const l=/{([^}]+)}/g;function I(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(l,(Ze,Te)=>ze[Te]??Ze)}function E(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}function u(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}function k(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function b(Pe,ze){let Ze=0,Te=Pe.indexOf(ze);for(;Te!==-1;)Ze++,Te=Pe.indexOf(ze,Te+ze.length);return Ze}function c(Pe,ze,Ze="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${Ze}`}function g(Pe,ze,Ze="\u2026"){if(Pe.length<=ze)return Pe;const Te=Math.ceil(ze/2)-Ze.length/2,Me=Math.floor(ze/2)-Ze.length/2;return`${Pe.substr(0,Te)}${Ze}${Pe.substr(Pe.length-Me)}`}function d(Pe,ze=" "){const Ze=m(Pe,ze);return n(Ze,ze)}function m(Pe,ze){if(!Pe||!ze)return Pe;const Ze=ze.length;if(Ze===0||Pe.length===0)return Pe;let Te=0;for(;Pe.indexOf(ze,Te)===Te;)Te=Te+Ze;return Pe.substring(Te)}function n(Pe,ze){if(!Pe||!ze)return Pe;const Ze=ze.length,Te=Pe.length;if(Ze===0||Te===0)return Pe;let Me=Te,Y=-1;for(;Y=Pe.lastIndexOf(ze,Me-1),!(Y===-1||Y+Ze!==Me);){if(Y===0)return"";Me=Y}return Pe.substring(0,Me)}function o(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(Pe){return Pe.replace(/\*/g,"")}function t(Pe,ze,Ze={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=k(Pe)),Ze.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Te="";return Ze.global&&(Te+="g"),Ze.matchCase||(Te+="i"),Ze.multiline&&(Te+="m"),Ze.unicode&&(Te+="u"),new RegExp(Pe,Te)}function s(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}function f(Pe){return Pe.split(/\r\n|\r|\n/)}function a(Pe){const ze=[],Ze=Pe.split(/(\r\n|\r|\n)/);for(let Te=0;Te<Math.ceil(Ze.length/2);Te++)ze.push(Ze[2*Te]+(Ze[2*Te+1]??""));return ze}function w(Pe){for(let ze=0,Ze=Pe.length;ze<Ze;ze++){const Te=Pe.charCodeAt(ze);if(Te!==h.CharCode.Space&&Te!==h.CharCode.Tab)return ze}return-1}function y(Pe,ze=0,Ze=Pe.length){for(let Te=ze;Te<Ze;Te++){const Me=Pe.charCodeAt(Te);if(Me!==h.CharCode.Space&&Me!==h.CharCode.Tab)return Pe.substring(ze,Te)}return Pe.substring(ze,Ze)}function S(Pe,ze=Pe.length-1){for(let Ze=ze;Ze>=0;Ze--){const Te=Pe.charCodeAt(Ze);if(Te!==h.CharCode.Space&&Te!==h.CharCode.Tab)return Ze}return-1}function D(Pe,ze,Ze){const Te=[];let Me=0;for(const Y of Pe.matchAll(ze)){if(Te.push(Pe.slice(Me,Y.index)),Y.index===void 0)throw new Error("match.index should be defined");Me=Y.index+Y[0].length,Te.push(Ze(Y[0],...Y.slice(1),Y.index,Pe,Y.groups))}return Te.push(Pe.slice(Me)),Promise.all(Te).then(Y=>Y.join(""))}function P(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}function C(Pe,ze,Ze=0,Te=Pe.length,Me=0,Y=ze.length){for(;Ze<Te&&Me<Y;Ze++,Me++){const Xe=Pe.charCodeAt(Ze),_e=ze.charCodeAt(Me);if(Xe<_e)return-1;if(Xe>_e)return 1}const de=Te-Ze,Ce=Y-Me;return de<Ce?-1:de>Ce?1:0}function p(Pe,ze){return v(Pe,ze,0,Pe.length,0,ze.length)}function v(Pe,ze,Ze=0,Te=Pe.length,Me=0,Y=ze.length){for(;Ze<Te&&Me<Y;Ze++,Me++){let Xe=Pe.charCodeAt(Ze),_e=ze.charCodeAt(Me);if(Xe===_e)continue;if(Xe>=128||_e>=128)return C(Pe.toLowerCase(),ze.toLowerCase(),Ze,Te,Me,Y);T(Xe)&&(Xe-=32),T(_e)&&(_e-=32);const lt=Xe-_e;if(lt!==0)return lt}const de=Te-Ze,Ce=Y-Me;return de<Ce?-1:de>Ce?1:0}function N(Pe){return Pe>=h.CharCode.Digit0&&Pe<=h.CharCode.Digit9}function T(Pe){return Pe>=h.CharCode.a&&Pe<=h.CharCode.z}function M(Pe){return Pe>=h.CharCode.A&&Pe<=h.CharCode.Z}function j(Pe,ze){return Pe.length===ze.length&&v(Pe,ze)===0}function z(Pe,ze){const Ze=ze.length;return ze.length>Pe.length?!1:v(Pe,ze,0,Ze)===0}function F(Pe,ze){const Ze=Math.min(Pe.length,ze.length);let Te;for(Te=0;Te<Ze;Te++)if(Pe.charCodeAt(Te)!==ze.charCodeAt(Te))return Te;return Ze}function B(Pe,ze){const Ze=Math.min(Pe.length,ze.length);let Te;const Me=Pe.length-1,Y=ze.length-1;for(Te=0;Te<Ze;Te++)if(Pe.charCodeAt(Me-Te)!==ze.charCodeAt(Y-Te))return Te;return Ze}function _(Pe){return 55296<=Pe&&Pe<=56319}function re(Pe){return 56320<=Pe&&Pe<=57343}function U(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}function G(Pe,ze,Ze){const Te=Pe.charCodeAt(Ze);if(_(Te)&&Ze+1<ze){const Me=Pe.charCodeAt(Ze+1);if(re(Me))return U(Te,Me)}return Te}function Q(Pe,ze){const Ze=Pe.charCodeAt(ze-1);if(re(Ze)&&ze>1){const Te=Pe.charCodeAt(ze-2);if(_(Te))return U(Te,Ze)}return Ze}class ee{get offset(){return this.e}constructor(ze,Ze=0){this.c=ze,this.d=ze.length,this.e=Ze}setOffset(ze){this.e=ze}prevCodePoint(){const ze=Q(this.c,this.e);return this.e-=ze>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}nextCodePoint(){const ze=G(this.c,this.d,this.e);return this.e+=ze>=R.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ze}eol(){return this.e>=this.d}}e.$Of=ee;class ue{get offset(){return this.c.offset}constructor(ze,Ze=0){this.c=new ee(ze,Ze)}nextGraphemeLength(){const ze=tt.getInstance(),Ze=this.c,Te=Ze.offset;let Me=ze.getGraphemeBreakType(Ze.nextCodePoint());for(;!Ze.eol();){const Y=Ze.offset,de=ze.getGraphemeBreakType(Ze.nextCodePoint());if(Ge(Me,de)){Ze.setOffset(Y);break}Me=de}return Ze.offset-Te}prevGraphemeLength(){const ze=tt.getInstance(),Ze=this.c,Te=Ze.offset;let Me=ze.getGraphemeBreakType(Ze.prevCodePoint());for(;Ze.offset>0;){const Y=Ze.offset,de=ze.getGraphemeBreakType(Ze.prevCodePoint());if(Ge(de,Me)){Ze.setOffset(Y);break}Me=de}return Te-Ze.offset}eol(){return this.c.eol()}}e.$Pf=ue;function ne(Pe,ze){return new ue(Pe,ze).nextGraphemeLength()}function De(Pe,ze){return new ue(Pe,ze).prevGraphemeLength()}function $e(Pe,ze){ze>0&&re(Pe.charCodeAt(ze))&&ze--;const Ze=ze+ne(Pe,ze);return[Ze-De(Pe,Ze),Ze]}function K(Pe){const ze=new ue(Pe);let Ze=0;for(;!ze.eol();)Ze++,ze.nextGraphemeLength();return Ze}let W;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(Pe){return W||(W=se()),W.test(Pe)}const te=/^[\t\n\r\x20-\x7E]*$/;function le(Pe){return te.test(Pe)}e.$Wf=/[\u2028\u2029]/;function he(Pe){return e.$Wf.test(Pe)}function X(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}function ae(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}function pe(Pe,ze,Ze=""){const Te=Pe.trimStart();if(Te.length<ze)return Te;const Me=/\b/g;let Y=0;for(;Me.test(Te)&&!(Te.length-Me.lastIndex<ze);)Y=Me.lastIndex,Me.lastIndex+=1;return Y===0?Te:Ze+Te.substring(Y).trimStart()}const be=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Fe(Pe){let ze=0;for(const Ze of Pe.matchAll(be))ze!==Ze.index&&(yield{isCode:!1,str:Pe.substring(ze,Ze.index)}),yield{isCode:!0,str:Ze[0]},ze=Ze.index+Ze[0].length;ze!==Pe.length&&(yield{isCode:!1,str:Pe.substring(ze)})}function Be(Pe){return Pe&&(Pe=Pe.replace(be,"")),Pe}const ke=/\\\[.*?\\\]/g;function Ie(Pe){return Be(Pe).replace(ke,"")}e.$5f=String.fromCharCode(h.CharCode.UTF8_BOM);function Oe(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===h.CharCode.UTF8_BOM)}function q(Pe){return Oe(Pe)?Pe.substr(1):Pe}function V(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const Ze=ze.length,Te=Pe.toLowerCase();let Me=0,Y=-1;for(;Me<Ze;){const de=Te.indexOf(ze[Me],Y+1);if(de<0)return!1;Y=de,Me++}return!0}function J(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}function x(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}function fe(Pe,ze=1){if(ze===0)return"";let Ze=-1;do Ze=Pe.indexOf(`
`,Ze+1),ze--;while(ze>0&&Ze>=0);return Ze===-1?Pe:(Pe[Ze-1]==="\r"&&Ze--,Pe.substr(0,Ze))}function we(Pe){const ze=h.CharCode.Z-h.CharCode.A+1;return Pe=Pe%(2*ze),Pe<ze?String.fromCharCode(h.CharCode.a+Pe):String.fromCharCode(h.CharCode.A+Pe-ze)}function Ne(Pe){return tt.getInstance().getGraphemeBreakType(Pe)}function Ge(Pe,ze){return Pe===Ke.Other?ze!==Ke.Extend&&ze!==Ke.SpacingMark:Pe===Ke.CR&&ze===Ke.LF?!1:Pe===Ke.Control||Pe===Ke.CR||Pe===Ke.LF||ze===Ke.Control||ze===Ke.CR||ze===Ke.LF?!0:!(Pe===Ke.L&&(ze===Ke.L||ze===Ke.V||ze===Ke.LV||ze===Ke.LVT)||(Pe===Ke.LV||Pe===Ke.V)&&(ze===Ke.V||ze===Ke.T)||(Pe===Ke.LVT||Pe===Ke.T)&&ze===Ke.T||ze===Ke.Extend||ze===Ke.ZWJ||ze===Ke.SpacingMark||Pe===Ke.Prepend||Pe===Ke.ZWJ&&ze===Ke.Extended_Pictographic||Pe===Ke.Regional_Indicator&&ze===Ke.Regional_Indicator)}var Ke;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ke||(e.GraphemeBreakType=Ke={}));class tt{static{this.c=null}static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=rt()}getGraphemeBreakType(ze){if(ze<32)return ze===h.CharCode.LineFeed?Ke.LF:ze===h.CharCode.CarriageReturn?Ke.CR:Ke.Control;if(ze<127)return Ke.Other;const Ze=this.d,Te=Ze.length/3;let Me=1;for(;Me<=Te;)if(ze<Ze[3*Me])Me=2*Me;else if(ze>Ze[3*Me+1])Me=2*Me+1;else return Ze[3*Me+2];return Ke.Other}}function rt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Pe,ze){if(Pe===0)return 0;const Ze=nt(Pe,ze);if(Ze!==void 0)return Ze;const Te=new ee(ze,Pe);return Te.prevCodePoint(),Te.offset}function nt(Pe,ze){const Ze=new ee(ze,Pe);let Te=Ze.prevCodePoint();for(;ct(Te)||Te===$t.emojiVariantSelector||Te===$t.enclosingKeyCap;){if(Ze.offset===0)return;Te=Ze.prevCodePoint()}if(!ae(Te))return;let Me=Ze.offset;return Me>0&&Ze.prevCodePoint()===$t.zwj&&(Me=Ze.offset),Me}function ct(Pe){return 127995<=Pe&&Pe<=127999}var $t;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})($t||($t={})),e.$cg="\xA0";class ht{static{this.c=new A.$X(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new r.$_e({getCacheKey:JSON.stringify},ze=>{function Ze(lt){const gt=new Map;for(let kt=0;kt<lt.length;kt+=2)gt.set(lt[kt],lt[kt+1]);return gt}function Te(lt,gt){const kt=new Map(lt);for(const[Ot,Wt]of gt)kt.set(Ot,Wt);return kt}function Me(lt,gt){if(!lt)return gt;const kt=new Map;for(const[Ot,Wt]of lt)gt.has(Ot)&&kt.set(Ot,Wt);return kt}const Y=this.c.value;let de=ze.filter(lt=>!lt.startsWith("_")&&lt in Y);de.length===0&&(de=["_default"]);let Ce;for(const lt of de){const gt=Ze(Y[lt]);Ce=Me(Ce,gt)}const Xe=Ze(Y._common),_e=Te(Xe,Ce);return new ht(_e)})}static getInstance(ze){return ht.d.get(Array.from(ze))}static{this.e=new A.$X(()=>Object.keys(ht.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return ht.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}containsAmbiguousCharacter(ze){for(let Ze=0;Ze<ze.length;Ze++){const Te=ze.codePointAt(Ze);if(typeof Te=="number"&&this.isAmbiguous(Te))return!0}return!1}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$dg=ht;class at{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(at.c())),this.d}static isInvisibleCharacter(ze){return at.e().has(ze)}static containsInvisibleCharacter(ze){for(let Ze=0;Ze<ze.length;Ze++){const Te=ze.codePointAt(Ze);if(typeof Te=="number"&&at.isInvisibleCharacter(Te))return!0}return!1}static get codePoints(){return at.e()}}e.$eg=at}),define(Ee[135],Se([1,0,27,29,177,13]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=L,e.$Ik=$,e.$Jk=l,e.$Kk=u,e.$Lk=S,e.$Mk=D,e.$Nk=T,e.$Ok=M,e.$Pk=j,e.$Qk=z,e.$Rk=se,e.$Tk=he,e.$Uk=pe,e.$Vk=be,R=We(R);function L(...ke){return function(Ie,Oe){for(let q=0,V=ke.length;q<V;q++){const J=ke[q](Ie,Oe);if(J)return J}return null}}e.$Gk=O.bind(void 0,!1),e.$Hk=O.bind(void 0,!0);function O(ke,Ie,Oe){if(!Oe||Oe.length<Ie.length)return null;let q;return ke?q=R.$Hf(Oe,Ie):q=Oe.indexOf(Ie)===0,q?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function $(ke,Ie){const Oe=Ie.toLowerCase().indexOf(ke.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+ke.length}]}function l(ke,Ie){return I(ke.toLowerCase(),Ie.toLowerCase(),0,0)}function I(ke,Ie,Oe,q){if(Oe===ke.length)return[];if(q===Ie.length)return null;if(ke[Oe]===Ie[q]){let V=null;return(V=I(ke,Ie,Oe+1,q+1))?i({start:q,end:q+1},V):null}return I(ke,Ie,Oe,q+1)}function E(ke){return r.CharCode.a<=ke&&ke<=r.CharCode.z}function u(ke){return r.CharCode.A<=ke&&ke<=r.CharCode.Z}function k(ke){return r.CharCode.Digit0<=ke&&ke<=r.CharCode.Digit9}function b(ke){return ke===r.CharCode.Space||ke===r.CharCode.Tab||ke===r.CharCode.LineFeed||ke===r.CharCode.CarriageReturn}const c=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>c.add(ke.charCodeAt(0)));function g(ke){return b(ke)||c.has(ke)}function d(ke,Ie){return ke===Ie||g(ke)&&g(Ie)}const m=new Map;function n(ke){if(m.has(ke))return m.get(ke);let Ie;const Oe=(0,A.$Ek)(ke);return Oe&&(Ie=Oe),m.set(ke,Ie),Ie}function o(ke){return E(ke)||u(ke)||k(ke)}function i(ke,Ie){return Ie.length===0?Ie=[ke]:ke.end===Ie[0].start?Ie[0].start=ke.start:Ie.unshift(ke),Ie}function t(ke,Ie){for(let Oe=Ie;Oe<ke.length;Oe++){const q=ke.charCodeAt(Oe);if(u(q)||k(q)||Oe>0&&!o(ke.charCodeAt(Oe-1)))return Oe}return ke.length}function s(ke,Ie,Oe,q){if(Oe===ke.length)return[];if(q===Ie.length)return null;if(ke[Oe]!==Ie[q].toLowerCase())return null;{let V=null,J=q+1;for(V=s(ke,Ie,Oe+1,q+1);!V&&(J=t(Ie,J))<Ie.length;)V=s(ke,Ie,Oe+1,J),J++;return V===null?null:i({start:q,end:q+1},V)}}function f(ke){let Ie=0,Oe=0,q=0,V=0,J=0;for(let Ge=0;Ge<ke.length;Ge++)J=ke.charCodeAt(Ge),u(J)&&Ie++,E(J)&&Oe++,o(J)&&q++,k(J)&&V++;const x=Ie/ke.length,fe=Oe/ke.length,we=q/ke.length,Ne=V/ke.length;return{upperPercent:x,lowerPercent:fe,alphaPercent:we,numericPercent:Ne}}function a(ke){const{upperPercent:Ie,lowerPercent:Oe}=ke;return Oe===0&&Ie>.6}function w(ke){const{upperPercent:Ie,lowerPercent:Oe,alphaPercent:q,numericPercent:V}=ke;return Oe>.2&&Ie<.8&&q>.6&&V<.2}function y(ke){let Ie=0,Oe=0,q=0,V=0;for(let J=0;J<ke.length;J++)q=ke.charCodeAt(J),u(q)&&Ie++,E(q)&&Oe++,b(q)&&V++;return(Ie===0||Oe===0)&&V===0?ke.length<=30:Ie<=5}function S(ke,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!y(ke))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Oe=f(Ie);if(!w(Oe)){if(!a(Oe))return null;Ie=Ie.toLowerCase()}let q=null,V=0;for(ke=ke.toLowerCase();V<Ie.length&&(q=s(ke,Ie,0,V))===null;)V=t(Ie,V+1);return q}function D(ke,Ie,Oe=!1){if(!Ie||Ie.length===0)return null;let q=null,V=0;for(ke=ke.toLowerCase(),Ie=Ie.toLowerCase();V<Ie.length&&(q=P(ke,Ie,0,V,Oe),q===null);)V=C(Ie,V+1);return q}function P(ke,Ie,Oe,q,V){let J=0;if(Oe===ke.length)return[];if(q===Ie.length)return null;if(!d(ke.charCodeAt(Oe),Ie.charCodeAt(q))){const we=n(ke.charCodeAt(Oe));if(!we)return null;for(let Ne=0;Ne<we.length;Ne++)if(!d(we[Ne],Ie.charCodeAt(q+Ne)))return null;J+=we.length-1}let x=null,fe=q+J+1;if(x=P(ke,Ie,Oe+1,fe,V),!V)for(;!x&&(fe=C(Ie,fe))<Ie.length;)x=P(ke,Ie,Oe+1,fe,V),fe++;if(!x)return null;if(ke.charCodeAt(Oe)!==Ie.charCodeAt(q)){const we=n(ke.charCodeAt(Oe));if(!we)return x;for(let Ne=0;Ne<we.length;Ne++)if(we[Ne]!==Ie.charCodeAt(q+Ne))return x}return i({start:q,end:q+J+1},x)}function C(ke,Ie){for(let Oe=Ie;Oe<ke.length;Oe++)if(g(ke.charCodeAt(Oe))||Oe>0&&g(ke.charCodeAt(Oe-1)))return Oe;return ke.length}const p=L(e.$Hk,S,$),v=L(e.$Hk,S,l),N=new h.$Fc(1e4);function T(ke,Ie,Oe=!1){if(typeof ke!="string"||typeof Ie!="string")return null;let q=N.get(ke);q||(q=new RegExp(R.$pf(ke),"i"),N.set(ke,q));const V=q.exec(Ie);return V?[{start:V.index,end:V.index+V[0].length}]:Oe?v(ke,Ie):p(ke,Ie)}function M(ke,Ie){const Oe=he(ke,ke.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?z(Oe):null}function j(ke,Ie,Oe,q,V,J){const x=Math.min(13,ke.length);for(;Oe<x;Oe++){const fe=he(ke,Ie,Oe,q,V,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,J]}function z(ke){if(typeof ke>"u")return[];const Ie=[],Oe=ke[1];for(let q=ke.length-1;q>1;q--){const V=ke[q]+Oe,J=Ie[Ie.length-1];J&&J.end===V?J.end=V+1:Ie.push({start:V,end:V+1})}return Ie}const F=128;function B(){const ke=[],Ie=[];for(let Oe=0;Oe<=F;Oe++)Ie[Oe]=0;for(let Oe=0;Oe<=F;Oe++)ke.push(Ie.slice(0));return ke}function _(ke){const Ie=[];for(let Oe=0;Oe<=ke;Oe++)Ie[Oe]=0;return Ie}const re=_(2*F),U=_(2*F),G=B(),Q=B(),ee=B(),ue=!1;function ne(ke,Ie,Oe,q,V){function J(fe,we,Ne=" "){for(;fe.length<we;)fe=Ne+fe;return fe}let x=` |   |${q.split("").map(fe=>J(fe,3)).join("|")}
`;for(let fe=0;fe<=Oe;fe++)fe===0?x+=" |":x+=`${Ie[fe-1]}|`,x+=ke[fe].slice(0,V+1).map(we=>J(we.toString(),3)).join("|")+`
`;return x}function De(ke,Ie,Oe,q){ke=ke.substr(Ie),Oe=Oe.substr(q),console.log(ne(Q,ke,ke.length,Oe,Oe.length)),console.log(ne(ee,ke,ke.length,Oe,Oe.length)),console.log(ne(G,ke,ke.length,Oe,Oe.length))}function $e(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;const Oe=ke.codePointAt(Ie);switch(Oe){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!R.$Zf(Oe)}}function K(ke,Ie){if(Ie<0||Ie>=ke.length)return!1;switch(ke.charCodeAt(Ie)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function W(ke,Ie,Oe){return Ie[ke]!==Oe[ke]}function se(ke,Ie,Oe,q,V,J,x=!1){for(;Ie<Oe&&V<J;)ke[Ie]===q[V]&&(x&&(re[Ie]=V),Ie+=1),V+=1;return Ie===Oe}var oe;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(oe||(oe={}));var te;(function(ke){ke.Default=[-100,0];function Ie(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}ke.isDefault=Ie})(te||(e.FuzzyScore=te={}));class le{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Oe){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Oe}}e.$Sk=le;function he(ke,Ie,Oe,q,V,J,x=le.default){const fe=ke.length>F?F:ke.length,we=q.length>F?F:q.length;if(Oe>=fe||J>=we||fe-Oe>we-J||!se(Ie,Oe,fe,V,J,we,!0))return;X(fe,we,Oe,J,Ie,V);let Ne=1,Ge=1,Ke=Oe,tt=J;const rt=[!1];for(Ne=1,Ke=Oe;Ke<fe;Ne++,Ke++){const ht=re[Ke],at=U[Ke],Pe=Ke+1<fe?U[Ke+1]:we;for(Ge=ht-J+1,tt=ht;tt<Pe;Ge++,tt++){let ze=Number.MIN_SAFE_INTEGER,Ze=!1;tt<=at&&(ze=ae(ke,Ie,Ke,Oe,q,V,tt,we,J,G[Ne-1][Ge-1]===0,rt));let Te=0;ze!==Number.MAX_SAFE_INTEGER&&(Ze=!0,Te=ze+Q[Ne-1][Ge-1]);const Me=tt>ht,Y=Me?Q[Ne][Ge-1]+(G[Ne][Ge-1]>0?-5:0):0,de=tt>ht+1&&G[Ne][Ge-1]>0,Ce=de?Q[Ne][Ge-2]+(G[Ne][Ge-2]>0?-5:0):0;if(de&&(!Me||Ce>=Y)&&(!Ze||Ce>=Te))Q[Ne][Ge]=Ce,ee[Ne][Ge]=oe.LeftLeft,G[Ne][Ge]=0;else if(Me&&(!Ze||Y>=Te))Q[Ne][Ge]=Y,ee[Ne][Ge]=oe.Left,G[Ne][Ge]=0;else if(Ze)Q[Ne][Ge]=Te,ee[Ne][Ge]=oe.Diag,G[Ne][Ge]=G[Ne-1][Ge-1]+1;else throw new Error("not possible")}}if(ue&&De(ke,Oe,q,J),!rt[0]&&!x.firstMatchCanBeWeak)return;Ne--,Ge--;const ot=[Q[Ne][Ge],J];let nt=0,ct=0;for(;Ne>=1;){let ht=Ge;do{const at=ee[Ne][ht];if(at===oe.LeftLeft)ht=ht-2;else if(at===oe.Left)ht=ht-1;else break}while(ht>=1);nt>1&&Ie[Oe+Ne-1]===V[J+Ge-1]&&!W(ht+J-1,q,V)&&nt+1>G[Ne][ht]&&(ht=Ge),ht===Ge?nt++:nt=1,ct||(ct=ht),Ne--,Ge=ht-1,ot.push(Ge)}we-J===fe&&x.boostFullMatch&&(ot[0]+=2);const $t=ct-fe;return ot[0]-=$t,ot}function X(ke,Ie,Oe,q,V,J){let x=ke-1,fe=Ie-1;for(;x>=Oe&&fe>=q;)V[x]===J[fe]&&(U[x]=fe,x--),fe--}function ae(ke,Ie,Oe,q,V,J,x,fe,we,Ne,Ge){if(Ie[Oe]!==J[x])return Number.MIN_SAFE_INTEGER;let Ke=1,tt=!1;return x===Oe-q?Ke=ke[Oe]===V[x]?7:5:W(x,V,J)&&(x===0||!W(x-1,V,J))?(Ke=ke[Oe]===V[x]?7:5,tt=!0):$e(J,x)&&(x===0||!$e(J,x-1))?Ke=5:($e(J,x-1)||K(J,x-1))&&(Ke=5,tt=!0),Ke>1&&Oe===q&&(Ge[0]=!0),tt||(tt=W(x,V,J)||$e(J,x-1)||K(J,x-1)),Oe===q?x>we&&(Ke-=tt?3:5):Ne?Ke+=tt?2:0:Ke+=tt?0:1,x+1===fe&&(Ke-=tt?3:5),Ke}function pe(ke,Ie,Oe,q,V,J,x){return Fe(ke,Ie,Oe,q,V,J,!0,x)}function be(ke,Ie,Oe,q,V,J,x){return Fe(ke,Ie,Oe,q,V,J,!1,x)}function Fe(ke,Ie,Oe,q,V,J,x,fe){let we=he(ke,Ie,Oe,q,V,J,fe);if(we&&!x)return we;if(ke.length>=3){const Ne=Math.min(7,ke.length-1);for(let Ge=Oe+1;Ge<Ne;Ge++){const Ke=Be(ke,Ge);if(Ke){const tt=he(Ke,Ke.toLowerCase(),Oe,q,V,J,fe);tt&&(tt[0]-=3,(!we||tt[0]>we[0])&&(we=tt))}}}return we}function Be(ke,Ie){if(Ie+1>=ke.length)return;const Oe=ke[Ie],q=ke[Ie+1];if(Oe!==q)return ke.slice(0,Ie)+q+Oe+ke.slice(Ie+2)}}),define(Ee[60],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$xj=void 0,e.$tj=h,e.$uj=A,e.$vj=R,e.$wj=O,e.$yj=c,r=We(r);function h(d){return A(d,0)}function A(d,m){switch(typeof d){case"object":return d===null?R(349,m):Array.isArray(d)?$(d,m):l(d,m);case"string":return O(d,m);case"boolean":return L(d,m);case"number":return R(d,m);case"undefined":return R(937,m);default:return R(617,m)}}function R(d,m){return(m<<5)-m+d|0}function L(d,m){return R(d?433:863,m)}function O(d,m){m=R(149417,m);for(let n=0,o=d.length;n<o;n++)m=R(d.charCodeAt(n),m);return m}function $(d,m){return m=R(104579,m),d.reduce((n,o)=>A(o,n),m)}function l(d,m){return m=R(181387,m),Object.keys(d).sort().reduce((n,o)=>(n=O(o,n),A(d[o],n)),m)}class I{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=A(m,this.g),this.g}}e.$xj=I;var E;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function u(d,m,n=32){const o=n-m,i=~((1<<o)-1);return(d<<m|(i&d)>>>o)>>>0}function k(d,m=0,n=d.byteLength,o=0){for(let i=0;i<n;i++)d[m+i]=o}function b(d,m,n="0"){for(;d.length<m;)d=n+d;return d}function c(d,m=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(n=>n.toString(16).padStart(2,"0")).join(""):b((d>>>0).toString(16),m/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(E.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const n=m.length;if(n===0)return;const o=this.p;let i=this.r,t=this.u,s,f;for(t!==0?(s=t,f=-1,t=0):(s=m.charCodeAt(0),f=0);;){let a=s;if(r.$Kf(s))if(f+1<n){const w=m.charCodeAt(f+1);r.$Lf(w)?(f++,a=r.$Mf(s,w)):a=E.UNICODE_REPLACEMENT}else{t=s;break}else r.$Lf(s)&&(a=E.UNICODE_REPLACEMENT);if(i=this.w(o,i,a),f++,f<n)s=m.charCodeAt(f);else break}this.r=i,this.u=t}w(m,n,o){return o<128?m[n++]=o:o<2048?(m[n++]=192|(o&1984)>>>6,m[n++]=128|(o&63)>>>0):o<65536?(m[n++]=224|(o&61440)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0):(m[n++]=240|(o&1835008)>>>18,m[n++]=128|(o&258048)>>>12,m[n++]=128|(o&4032)>>>6,m[n++]=128|(o&63)>>>0),n>=E.BLOCK_SIZE&&(this.y(),n-=E.BLOCK_SIZE,this.t+=E.BLOCK_SIZE,m[0]=m[E.BLOCK_SIZE+0],m[1]=m[E.BLOCK_SIZE+1],m[2]=m[E.BLOCK_SIZE+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,E.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=g.g,n=this.q;for(let S=0;S<64;S+=4)m.setUint32(S,n.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)m.setUint32(S,u(m.getUint32(S-12,!1)^m.getUint32(S-32,!1)^m.getUint32(S-56,!1)^m.getUint32(S-64,!1),1),!1);let o=this.h,i=this.l,t=this.m,s=this.n,f=this.o,a,w,y;for(let S=0;S<80;S++)S<20?(a=i&t|~i&s,w=1518500249):S<40?(a=i^t^s,w=1859775393):S<60?(a=i&t|i&s|t&s,w=2400959708):(a=i^t^s,w=3395469782),y=u(o,5)+a+f+w+m.getUint32(S*4,!1)&4294967295,f=s,s=t,t=u(i,30),i=o,o=y;this.h=this.h+o&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+f&4294967295}}e.$zj=g}),define(Ee[136],Se([1,0,135,13,50]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=$,e.$Xk=I,e.$Yk=u,e.$Zk=k,e.$1k=c,e.$2k=g;const R="$(",L=new RegExp(`\\$\\(${A.ThemeIcon.iconNameExpression}(?:${A.ThemeIcon.iconModifierExpression})?\\)`,"g"),O=new RegExp(`(\\\\)?${L.source}`,"g");function $(d){return d.replace(O,(m,n)=>n?m:`\\${m}`)}const l=new RegExp(`\\\\${L.source}`,"g");function I(d){return d.replace(l,m=>`\\${m}`)}const E=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function u(d){return d.indexOf(R)===-1?d:d.replace(E,(m,n,o,i)=>o?m:n||i||"")}function k(d){return d?d.replace(/\$\((.*?)\)/g,(m,n)=>` ${n} `).trim():""}const b=new RegExp(`\\$\\(${A.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(d){b.lastIndex=0;let m="";const n=[];let o=0;for(;;){const i=b.lastIndex,t=b.exec(d),s=d.substring(i,t?.index);if(s.length>0){m+=s;for(let f=0;f<s.length;f++)n.push(o)}if(!t)break;o+=t[0].length}return{text:m,iconOffsets:n}}function g(d,m,n=!1){const{text:o,iconOffsets:i}=m;if(!i||i.length===0)return(0,r.$Nk)(d,o,n);const t=(0,h.$nf)(o," "),s=o.length-t.length,f=(0,r.$Nk)(d,t,n);if(f)for(const a of f){const w=i[a.start+s]+s;a.start+=w,a.end+=w}return f}}),define(Ee[44],Se([1,0,13]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=We(r);var h;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(h||(h={})),function(A){const R="error",L="warning",O="warn",$="info",l="ignore";function I(u){return u?r.$Gf(R,u)?A.Error:r.$Gf(L,u)||r.$Gf(O,u)?A.Warning:r.$Gf($,u)?A.Info:A.Ignore:A.Ignore}A.fromValue=I;function E(u){switch(u){case A.Error:return R;case A.Warning:return L;case A.Info:return $;default:return l}}A.toString=E}(h||(h={})),e.default=h}),define(Ee[85],Se([1,0,19,27,13]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class R{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const c=b.charCodeAt(0),g=this.b.charCodeAt(this.c);return c-g}value(){return this.b[this.c]}}e.$Hi=R;class L{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===h.CharCode.Period)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,A.$Af)(b,this.b,0,b.length,this.c,this.d):(0,A.$Cf)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=L;class O{constructor(b=!0,c=!0){this.f=b,this.g=c}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let c=b.length-1;c>=0;c--,this.c--){const g=this.b.charCodeAt(c);if(!(g===h.CharCode.Slash||this.f&&g===h.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===h.CharCode.Slash||this.f&&c===h.CharCode.Backslash)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,A.$Af)(b,this.b,0,b.length,this.d,this.e):(0,A.$Cf)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=O;var $;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})($||($={}));class l{constructor(b,c){this.f=b,this.g=c,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new O(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push($.Path)),this.g(b)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===$.Scheme)return(0,A.$Bf)(b,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,A.$Bf)(b,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(b);if(this.d[this.e]===$.Query)return(0,A.$zf)(b,this.c.query);if(this.d[this.e]===$.Fragment)return(0,A.$zf)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ki=l;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(E||(E={}));class u{static forUris(b=()=>!1,c=()=>!1){return new u(new l(b,c))}static forPaths(b=!1){return new u(new O(void 0,!b))}static forStrings(){return new u(new R)}static forConfigKeys(){return new u(new L)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,c){if(c){const g=c.slice(0);(0,r.$Yb)(g);for(const d of g)this.set(d,b)}else{const g=b.slice(0);(0,r.$Yb)(g);for(const d of g)this.set(d[0],d[1])}}set(b,c){const g=this.b.reset(b);let d;this.c||(this.c=new I,this.c.segment=g.value());const m=[];for(d=this.c;;){const o=g.cmp(d.segment);if(o>0)d.left||(d.left=new I,d.left.segment=g.value()),m.push([E.Left,d]),d=d.left;else if(o<0)d.right||(d.right=new I,d.right.segment=g.value()),m.push([E.Right,d]),d=d.right;else if(g.hasNext())g.next(),d.mid||(d.mid=new I,d.mid.segment=g.value()),m.push([E.Mid,d]),d=d.mid;else break}const n=d.value;d.value=c,d.key=b;for(let o=m.length-1;o>=0;o--){const i=m[o][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const s=m[o][0],f=m[o+1][0];if(s===E.Right&&f===E.Right)m[o][1]=i.rotateLeft();else if(s===E.Left&&f===E.Left)m[o][1]=i.rotateRight();else if(s===E.Right&&f===E.Left)i.right=m[o+1][1]=m[o+1][1].rotateRight(),m[o][1]=i.rotateLeft();else if(s===E.Left&&f===E.Right)i.left=m[o+1][1]=m[o+1][1].rotateLeft(),m[o][1]=i.rotateRight();else throw new Error;if(o>0)switch(m[o-1][0]){case E.Left:m[o-1][1].left=m[o][1];break;case E.Right:m[o-1][1].right=m[o][1];break;case E.Mid:m[o-1][1].mid=m[o][1];break}else this.c=m[0][1]}}return n}get(b){return this.d(b)?.value}d(b){const c=this.b.reset(b);let g=this.c;for(;g;){const d=c.cmp(g.segment);if(d>0)g=g.left;else if(d<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else break}return g}has(b){const c=this.d(b);return!(c?.value===void 0&&c?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,c){const g=this.b.reset(b),d=[];let m=this.c;for(;m;){const n=g.cmp(m.segment);if(n>0)d.push([E.Left,m]),m=m.left;else if(n<0)d.push([E.Right,m]),m=m.right;else if(g.hasNext())g.next(),d.push([E.Mid,m]),m=m.mid;else break}if(m){if(c?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:o,value:i,segment:t}=n;this.e(n.key,!1),m.key=o,m.value=i,m.segment=t}}else{const n=m.left??m.right;if(d.length>0){const[o,i]=d[d.length-1];switch(o){case E.Left:i.left=n;break;case E.Mid:i.mid=n;break;case E.Right:i.right=n;break}}else this.c=n}for(let n=d.length-1;n>=0;n--){const o=d[n][1];o.updateHeight();const i=o.balanceFactor();if(i>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),d[n][1]=o.rotateLeft()):i<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),d[n][1]=o.rotateRight()),n>0)switch(d[n-1][0]){case E.Left:d[n-1][1].left=d[n][1];break;case E.Right:d[n-1][1].right=d[n][1];break;case E.Mid:d[n-1][1].mid=d[n][1];break}else this.c=d[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const c=this.b.reset(b);let g=this.c,d;for(;g;){const m=c.cmp(g.segment);if(m>0)g=g.left;else if(m<0)g=g.right;else if(c.hasNext())c.next(),d=g.value||d,g=g.mid;else break}return g&&g.value||d}findSuperstr(b){return this.g(b,!1)}g(b,c){const g=this.b.reset(b);let d=this.c;for(;d;){const m=g.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(g.hasNext())g.next(),d=d.mid;else return d.mid?this.h(d.mid):c?d.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[c,g]of this)b(g,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const c=[];return this.j(b,c),c[Symbol.iterator]()}j(b,c){b&&(b.left&&this.j(b.left,c),b.value&&c.push([b.key,b.value]),b.mid&&this.j(b.mid,c),b.right&&this.j(b.right,c))}_isBalanced(){const b=c=>{if(!c)return!0;const g=c.balanceFactor();return g<-1||g>1?!1:b(c.left)&&b(c.right)};return b(this.c)}}e.$Li=u}),define(Ee[32],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=h;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function h(A){return r.test(A)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(O){for(let $=0;$<O.length;$++)O[$]=Math.floor(Math.random()*256);return O};const R=new Uint8Array(16),L=[];for(let O=0;O<256;O++)L.push(O.toString(16).padStart(2,"0"));return function(){A(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let $=0,l="";return l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+="-",l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l+=L[R[$++]],l}}()}),define(Ee[186],Se([1,0,19,40,32]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=e.$ku=void 0,e.$iu=R,e.$ju=L,e.$lu=l;function R(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}function L(E,u,k){const b={id:(0,A.$2g)(),name:E,uri:u,data:k};return{asString:async()=>"",asFile:()=>b,value:void 0}}class O{constructor(){this.a=new Map}get size(){let u=0;for(const k of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const k=[...this.a.keys()];return h.Iterable.some(this,([b,c])=>c.asFile())&&k.push("files"),I($(u),k)}get(u){return this.a.get(this.b(u))?.[0]}append(u,k){const b=this.a.get(u);b?b.push(k):this.a.set(this.b(u),[k])}replace(u,k){this.a.set(this.b(u),[k])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,k]of this.a)for(const b of k)yield[u,b]}b(u){return $(u)}}e.$ku=O;function $(E){return E.toLowerCase()}function l(E,u){return I($(E),u.map($))}function I(E,u){if(E==="*/*")return u.length>0;if(u.includes(E))return!0;const k=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[b,c,g]=k;return g==="*"?u.some(d=>d.startsWith(c+"/")):!1}e.$mu=Object.freeze({create:E=>(0,r.$Ob)(E.map(u=>u.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$mu.split(E).filter(u=>!u.startsWith("#"))})}),define(Ee[187],Se([1,0,67]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=void 0,e.$4g=h,e.$6g=R,r=We(r);function h(O,$,l,I=1){let E=!1;return new Promise(u=>{const k=setTimeout(()=>{if(!E)return E=!0,u(0)},l);A(O,$,I,b=>{if(!E)return E=!0,clearTimeout(k),u(b)})})}function A(O,$,l,I){if($===0)return I(0);const E=new r.Socket;E.once("connect",()=>(L(E),A(O+l,$-1,l,I))),E.once("data",()=>{}),E.once("error",u=>(L(E),u.code!=="ECONNREFUSED"?A(O+l,$-1,l,I):I(O))),E.connect(O,"127.0.0.1")}e.$5g={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(O,$,l,I="127.0.0.1"){let E=!1,u,k=1;const b=r.createServer({pauseOnConnect:!0});function c(g,d){E||(E=!0,b.removeAllListeners(),b.close(),u&&clearTimeout(u),d(g))}return new Promise(g=>{u=setTimeout(()=>{c(0,g)},l),b.on("listening",()=>{c(O,g)}),b.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&k<$?(O++,k++,b.listen(O,I)):c(0,g)}),b.on("close",()=>{c(0,g)}),b.listen(O,I)})}function L(O){try{O.removeAllListeners("connect"),O.removeAllListeners("error"),O.end(),O.destroy(),O.unref()}catch($){console.error($)}}}),define(Ee[137],Se([1,0,84]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bu=e.$au=void 0;class h{constructor(O){const $=(0,r.$bf)(O);this.c=$,this.a=h.d($),this.b=new Map}static d(O){const $=new Uint8Array(256);return $.fill(O),$}set(O,$){const l=(0,r.$bf)($);O>=0&&O<256?this.a[O]=l:this.b.set(O,l)}get(O){return O>=0&&O<256?this.a[O]:this.b.get(O)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$au=h;var A;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(A||(A={}));class R{constructor(){this.a=new h(A.False)}add(O){this.a.set(O,A.True)}has(O){return this.a.get(O)===A.True}clear(){return this.a.clear()}}e.$bu=R}),define(Ee[188],Se([1,0,27]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$su=A;var h;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(h||(e.StringEOL=h={}));function A(R){let L=0,O=0,$=0,l=h.Unknown;for(let I=0,E=R.length;I<E;I++){const u=R.charCodeAt(I);u===r.CharCode.CarriageReturn?(L===0&&(O=I),L++,I+1<E&&R.charCodeAt(I+1)===r.CharCode.LineFeed?(l|=h.CRLF,I++):l|=h.Invalid,$=I+1):u===r.CharCode.LineFeed&&(l|=h.LF,L===0&&(O=I),L++,$=I+1)}return L===0&&(O=R.length),[L,O,R.length-$,l]}}),define(Ee[53],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ht=void 0;class r{constructor(A,R){this.lineNumber=A,this.column=R}with(A=this.lineNumber,R=this.column){return A===this.lineNumber&&R===this.column?this:new r(A,R)}delta(A=0,R=0){return this.with(this.lineNumber+A,this.column+R)}equals(A){return r.equals(this,A)}static equals(A,R){return!A&&!R?!0:!!A&&!!R&&A.lineNumber===R.lineNumber&&A.column===R.column}isBefore(A){return r.isBefore(this,A)}static isBefore(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<R.column}isBeforeOrEqual(A){return r.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,R){return A.lineNumber<R.lineNumber?!0:R.lineNumber<A.lineNumber?!1:A.column<=R.column}static compare(A,R){const L=A.lineNumber|0,O=R.lineNumber|0;if(L===O){const $=A.column|0,l=R.column|0;return $-l}return L-O}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new r(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ht=r}),define(Ee[31],Se([1,0,53]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0;class h{constructor(R,L,O,$){R>O||R===O&&L>$?(this.startLineNumber=O,this.startColumn=$,this.endLineNumber=R,this.endColumn=L):(this.startLineNumber=R,this.startColumn=L,this.endLineNumber=O,this.endColumn=$)}isEmpty(){return h.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return h.containsPosition(this,R)}static containsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<R.startColumn||L.lineNumber===R.endLineNumber&&L.column>R.endColumn)}static strictContainsPosition(R,L){return!(L.lineNumber<R.startLineNumber||L.lineNumber>R.endLineNumber||L.lineNumber===R.startLineNumber&&L.column<=R.startColumn||L.lineNumber===R.endLineNumber&&L.column>=R.endColumn)}containsRange(R){return h.containsRange(this,R)}static containsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>R.endColumn)}strictContainsRange(R){return h.strictContainsRange(this,R)}static strictContainsRange(R,L){return!(L.startLineNumber<R.startLineNumber||L.endLineNumber<R.startLineNumber||L.startLineNumber>R.endLineNumber||L.endLineNumber>R.endLineNumber||L.startLineNumber===R.startLineNumber&&L.startColumn<=R.startColumn||L.endLineNumber===R.endLineNumber&&L.endColumn>=R.endColumn)}plusRange(R){return h.plusRange(this,R)}static plusRange(R,L){let O,$,l,I;return L.startLineNumber<R.startLineNumber?(O=L.startLineNumber,$=L.startColumn):L.startLineNumber===R.startLineNumber?(O=L.startLineNumber,$=Math.min(L.startColumn,R.startColumn)):(O=R.startLineNumber,$=R.startColumn),L.endLineNumber>R.endLineNumber?(l=L.endLineNumber,I=L.endColumn):L.endLineNumber===R.endLineNumber?(l=L.endLineNumber,I=Math.max(L.endColumn,R.endColumn)):(l=R.endLineNumber,I=R.endColumn),new h(O,$,l,I)}intersectRanges(R){return h.intersectRanges(this,R)}static intersectRanges(R,L){let O=R.startLineNumber,$=R.startColumn,l=R.endLineNumber,I=R.endColumn;const E=L.startLineNumber,u=L.startColumn,k=L.endLineNumber,b=L.endColumn;return O<E?(O=E,$=u):O===E&&($=Math.max($,u)),l>k?(l=k,I=b):l===k&&(I=Math.min(I,b)),O>l||O===l&&$>I?null:new h(O,$,l,I)}equalsRange(R){return h.equalsRange(this,R)}static equalsRange(R,L){return!R&&!L?!0:!!R&&!!L&&R.startLineNumber===L.startLineNumber&&R.startColumn===L.startColumn&&R.endLineNumber===L.endLineNumber&&R.endColumn===L.endColumn}getEndPosition(){return h.getEndPosition(this)}static getEndPosition(R){return new r.$Ht(R.endLineNumber,R.endColumn)}getStartPosition(){return h.getStartPosition(this)}static getStartPosition(R){return new r.$Ht(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,L){return new h(this.startLineNumber,this.startColumn,R,L)}setStartPosition(R,L){return new h(R,L,this.endLineNumber,this.endColumn)}collapseToStart(){return h.collapseToStart(this)}static collapseToStart(R){return new h(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return h.collapseToEnd(this)}static collapseToEnd(R){return new h(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new h(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,L=R){return new h(R.lineNumber,R.column,L.lineNumber,L.column)}static lift(R){return R?new h(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<R.startColumn)}static areIntersecting(R,L){return!(R.endLineNumber<L.startLineNumber||R.endLineNumber===L.startLineNumber&&R.endColumn<=L.startColumn||L.endLineNumber<R.startLineNumber||L.endLineNumber===R.startLineNumber&&L.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,L){if(R&&L){const l=R.startLineNumber|0,I=L.startLineNumber|0;if(l===I){const E=R.startColumn|0,u=L.startColumn|0;if(E===u){const k=R.endLineNumber|0,b=L.endLineNumber|0;if(k===b){const c=R.endColumn|0,g=L.endColumn|0;return c-g}return k-b}return E-u}return l-I}return(R?1:0)-(L?1:0)}static compareRangesUsingEnds(R,L){return R.endLineNumber===L.endLineNumber?R.endColumn===L.endColumn?R.startLineNumber===L.startLineNumber?R.startColumn-L.startColumn:R.startLineNumber-L.startLineNumber:R.endColumn-L.endColumn:R.endLineNumber-L.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.$It=h}),define(Ee[189],Se([1,0,31]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=void 0;class h{static insert(R,L){return{range:new r.$It(R.lineNumber,R.column,R.lineNumber,R.column),text:L,forceMoveMarkers:!0}}static delete(R){return{range:R,text:null}}static replace(R,L){return{range:R,text:L}}static replaceMove(R,L){return{range:R,text:L,forceMoveMarkers:!0}}}e.$Jt=h}),define(Ee[190],Se([1,0,53,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kt=e.SelectionDirection=void 0;var A;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(A||(e.SelectionDirection=A={}));class R extends h.$It{constructor(O,$,l,I){super(O,$,l,I),this.selectionStartLineNumber=O,this.selectionStartColumn=$,this.positionLineNumber=l,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(O){return R.selectionsEqual(this,O)}static selectionsEqual(O,$){return O.selectionStartLineNumber===$.selectionStartLineNumber&&O.selectionStartColumn===$.selectionStartColumn&&O.positionLineNumber===$.positionLineNumber&&O.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?A.LTR:A.RTL}setEndPosition(O,$){return this.getDirection()===A.LTR?new R(this.startLineNumber,this.startColumn,O,$):new R(O,$,this.startLineNumber,this.startColumn)}getPosition(){return new r.$Ht(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$Ht(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(O,$){return this.getDirection()===A.LTR?new R(O,$,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,O,$)}static fromPositions(O,$=O){return new R(O.lineNumber,O.column,$.lineNumber,$.column)}static fromRange(O,$){return $===A.LTR?new R(O.startLineNumber,O.startColumn,O.endLineNumber,O.endColumn):new R(O.endLineNumber,O.endColumn,O.startLineNumber,O.startColumn)}static liftSelection(O){return new R(O.selectionStartLineNumber,O.selectionStartColumn,O.positionLineNumber,O.positionColumn)}static selectionsArrEqual(O,$){if(O&&!$||!O&&$)return!1;if(!O&&!$)return!0;if(O.length!==$.length)return!1;for(let l=0,I=O.length;l<I;l++)if(!this.selectionsEqual(O[l],$[l]))return!1;return!0}static isISelection(O){return O&&typeof O.selectionStartLineNumber=="number"&&typeof O.selectionStartColumn=="number"&&typeof O.positionLineNumber=="number"&&typeof O.positionColumn=="number"}static createWithDirection(O,$,l,I,E){return E===A.LTR?new R(O,$,l,I):new R(l,I,O,$)}}e.$Kt=R}),define(Ee[191],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=void 0,e.$ft={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[192],Se([1,0,27,29,137]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.WordCharacterClass=void 0,e.$du=$;var R;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class L extends A.$au{constructor(I,E){super(R.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=E,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let u=0,k=I.length;u<k;u++)this.set(I.charCodeAt(u),R.WordSeparator);this.set(r.CharCode.Space,R.Whitespace),this.set(r.CharCode.Tab,R.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,E){let u=null;for(const k of this.h(I)){if(k.index>E)break;u=k}return u}findNextIntlWordAtOrAfterOffset(I,E){for(const u of this.h(I))if(!(u.index<E))return u;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const E=[];for(const u of I)this.k(u)&&E.push(u);return E}k(I){return!!I.isWordLike}}e.$cu=L;const O=new h.$Fc(10);function $(l,I){const E=`${l}/${I.join(",")}`;let u=O.get(E);return u||(u=new L(l,I),O.set(E,u)),u}}),define(Ee[138],Se([1,0,40,3,81]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.$gt=void 0,e.$it=L,e.$jt=$,e.$kt=l,e.$gt="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(E=""){let u="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.$gt)E.indexOf(k)>=0||(u+="\\"+k);return u+="\\s]+)",new RegExp(u,"g")}e.$ht=R();function L(E){let u=e.$ht;if(E&&E instanceof RegExp)if(E.global)u=E;else{let k="g";E.ignoreCase&&(k+="i"),E.multiline&&(k+="m"),E.unicode&&(k+="u"),u=new RegExp(E.source,k)}return u.lastIndex=0,u}const O=new A.$7c;O.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(E){const u=O.unshift(E);return(0,h.$Uc)(u)}function l(E,u,k,b,c){if(u=L(u),c||(c=r.Iterable.first(O)),k.length>c.maxLen){let o=E-c.maxLen/2;return o<0?o=0:b+=o,k=k.substring(o,E+c.maxLen/2),l(E,u,k,b,c)}const g=Date.now(),d=E-1-b;let m=-1,n=null;for(let o=1;!(Date.now()-g>=c.timeBudget);o++){const i=d-c.windowSize*o;u.lastIndex=Math.max(0,i);const t=I(u,k,d,m);if(!t&&n||(n=t,i<=0))break;m=i}if(n){const o={word:n[0],startColumn:b+1+n.index,endColumn:b+1+n.index+n[0].length};return u.lastIndex=0,o}return null}function I(E,u,k,b){let c;for(;c=E.exec(u);){const g=c.index||0;if(g<=k&&E.lastIndex>=k)return c;if(b>0&&g>b)return null}return null}}),define(Ee[106],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function($){$[$.Null=0]="Null",$[$.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var h;(function($){$[$.NotSet=-1]="NotSet",$[$.None=0]="None",$[$.Italic=1]="Italic",$[$.Bold=2]="Bold",$[$.Underline=4]="Underline",$[$.Strikethrough=8]="Strikethrough"})(h||(e.FontStyle=h={}));var A;(function($){$[$.None=0]="None",$[$.DefaultForeground=1]="DefaultForeground",$[$.DefaultBackground=2]="DefaultBackground"})(A||(e.ColorId=A={}));var R;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(R||(e.StandardTokenType=R={}));var L;(function($){$[$.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",$[$.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",$[$.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",$[$.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",$[$.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",$[$.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",$[$.ITALIC_MASK=2048]="ITALIC_MASK",$[$.BOLD_MASK=4096]="BOLD_MASK",$[$.UNDERLINE_MASK=8192]="UNDERLINE_MASK",$[$.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",$[$.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",$[$.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",$[$.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",$[$.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",$[$.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",$[$.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",$[$.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",$[$.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",$[$.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",$[$.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",$[$.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",$[$.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class O{static getLanguageId(l){return(l&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(l){return(l&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(l){return(l&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(l){return(l&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let E="mtk"+this.getForeground(l);const u=this.getFontStyle(l);return u&h.Italic&&(E+=" mtki"),u&h.Bold&&(E+=" mtkb"),u&h.Underline&&(E+=" mtku"),u&h.Strikethrough&&(E+=" mtks"),E}static getInlineStyleFromMetadata(l,I){const E=this.getForeground(l),u=this.getFontStyle(l);let k=`color: ${I[E]};`;u&h.Italic&&(k+="font-style: italic;"),u&h.Bold&&(k+="font-weight: bold;");let b="";return u&h.Underline&&(b+=" underline"),u&h.Strikethrough&&(b+=" line-through"),b&&(k+=`text-decoration:${b};`),k}static getPresentationFromMetadata(l){const I=this.getForeground(l),E=this.getFontStyle(l);return{foreground:I,italic:!!(E&h.Italic),bold:!!(E&h.Bold),underline:!!(E&h.Underline),strikethrough:!!(E&h.Strikethrough)}}}e.$ou=O}),define(Ee[193],Se([1,0,27,106]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.IndentAction=void 0;var A;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(A||(e.IndentAction=A={}));class R{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let I=0,E=l.notIn.length;I<E;I++)switch(l.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case h.StandardTokenType.Other:return!0;case h.StandardTokenType.Comment:return this.c;case h.StandardTokenType.String:return this.b;case h.StandardTokenType.RegEx:return this.d}}shouldAutoClose(l,I){if(l.getTokenCount()===0)return!0;const E=l.findTokenIndexAtOffset(I-2),u=l.getStandardTokenType(E);return this.isOK(u)}g(l,I){for(let E=l;E<=I;E++){const u=String.fromCharCode(E);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Pu=R;class L{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of l)O(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),O(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),O(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),O(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&O(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Qu=L;function O($,l,I){$.has(l)?$.get(l).push(I):$.set(l,[I])}}),define(Ee[194],Se([1,0,27,137]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$93=e.$83=e.State=void 0,e.$03=k;var A;(function(b){b[b.Invalid=0]="Invalid",b[b.Start=1]="Start",b[b.H=2]="H",b[b.HT=3]="HT",b[b.HTT=4]="HTT",b[b.HTTP=5]="HTTP",b[b.F=6]="F",b[b.FI=7]="FI",b[b.FIL=8]="FIL",b[b.BeforeColon=9]="BeforeColon",b[b.AfterColon=10]="AfterColon",b[b.AlmostThere=11]="AlmostThere",b[b.End=12]="End",b[b.Accept=13]="Accept",b[b.LastKnownState=14]="LastKnownState"})(A||(e.State=A={}));class R{constructor(c,g,d){const m=new Uint8Array(c*g);for(let n=0,o=c*g;n<o;n++)m[n]=d;this.a=m,this.rows=c,this.cols=g}get(c,g){return this.a[c*this.cols+g]}set(c,g,d){this.a[c*this.cols+g]=d}}class L{constructor(c){let g=0,d=A.Invalid;for(let n=0,o=c.length;n<o;n++){const[i,t,s]=c[n];t>g&&(g=t),i>d&&(d=i),s>d&&(d=s)}g++,d++;const m=new R(d,g,A.Invalid);for(let n=0,o=c.length;n<o;n++){const[i,t,s]=c[n];m.set(i,t,s)}this.a=m,this.b=g}nextState(c,g){return g<0||g>=this.b?A.Invalid:this.a.get(c,g)}}e.$83=L;let O=null;function $(){return O===null&&(O=new L([[A.Start,r.CharCode.h,A.H],[A.Start,r.CharCode.H,A.H],[A.Start,r.CharCode.f,A.F],[A.Start,r.CharCode.F,A.F],[A.H,r.CharCode.t,A.HT],[A.H,r.CharCode.T,A.HT],[A.HT,r.CharCode.t,A.HTT],[A.HT,r.CharCode.T,A.HTT],[A.HTT,r.CharCode.p,A.HTTP],[A.HTT,r.CharCode.P,A.HTTP],[A.HTTP,r.CharCode.s,A.BeforeColon],[A.HTTP,r.CharCode.S,A.BeforeColon],[A.HTTP,r.CharCode.Colon,A.AfterColon],[A.F,r.CharCode.i,A.FI],[A.F,r.CharCode.I,A.FI],[A.FI,r.CharCode.l,A.FIL],[A.FI,r.CharCode.L,A.FIL],[A.FIL,r.CharCode.e,A.BeforeColon],[A.FIL,r.CharCode.E,A.BeforeColon],[A.BeforeColon,r.CharCode.Colon,A.AfterColon],[A.AfterColon,r.CharCode.Slash,A.AlmostThere],[A.AlmostThere,r.CharCode.Slash,A.End]])),O}var l;(function(b){b[b.None=0]="None",b[b.ForceTermination=1]="ForceTermination",b[b.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let I=null;function E(){if(I===null){I=new h.$au(l.None);const b=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let g=0;g<b.length;g++)I.set(b.charCodeAt(g),l.ForceTermination);const c=".,;:";for(let g=0;g<c.length;g++)I.set(c.charCodeAt(g),l.CannotEndIn)}return I}class u{static a(c,g,d,m,n){let o=n-1;do{const i=g.charCodeAt(o);if(c.get(i)!==l.CannotEndIn)break;o--}while(o>m);if(m>0){const i=g.charCodeAt(m-1),t=g.charCodeAt(o);(i===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||i===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||i===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:d,startColumn:m+1,endLineNumber:d,endColumn:o+2},url:g.substring(m,o+1)}}static computeLinks(c,g=$()){const d=E(),m=[];for(let n=1,o=c.getLineCount();n<=o;n++){const i=c.getLineContent(n),t=i.length;let s=0,f=0,a=0,w=A.Start,y=!1,S=!1,D=!1,P=!1;for(;s<t;){let C=!1;const p=i.charCodeAt(s);if(w===A.Accept){let v;switch(p){case r.CharCode.OpenParen:y=!0,v=l.None;break;case r.CharCode.CloseParen:v=y?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:D=!0,S=!0,v=l.None;break;case r.CharCode.CloseSquareBracket:D=!1,v=S?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:P=!0,v=l.None;break;case r.CharCode.CloseCurlyBrace:v=P?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:a===p?v=l.ForceTermination:a===r.CharCode.SingleQuote||a===r.CharCode.DoubleQuote||a===r.CharCode.BackTick?v=l.None:v=l.ForceTermination;break;case r.CharCode.Asterisk:v=a===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:v=a===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:v=D?l.None:l.ForceTermination;break;default:v=d.get(p)}v===l.ForceTermination&&(m.push(u.a(d,i,n,f,s)),C=!0)}else if(w===A.End){let v;p===r.CharCode.OpenSquareBracket?(S=!0,v=l.None):v=d.get(p),v===l.ForceTermination?C=!0:w=A.Accept}else w=g.nextState(w,p),w===A.Invalid&&(C=!0);C&&(w=A.Start,y=!1,S=!1,P=!1,f=s+1,a=p),s++}w===A.Accept&&m.push(u.a(d,i,n,f,t))}return m}}e.$93=u;function k(b){return!b||typeof b.getLineCount!="function"||typeof b.getLineContent!="function"?[]:u.computeLinks(b)}}),define(Ee[54],Se([1,0,25]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bw=e.$aw=e.$_v=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$0v=e.$9v=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$$v=b,e.$cw=o;var h;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=4]="Right",i[i.Full=7]="Full"})(h||(e.OverviewRulerLane=h={}));var A;(function(i){i[i.Left=1]="Left",i[i.Center=2]="Center",i[i.Right=3]="Right"})(A||(e.GlyphMarginLane=A={}));var R;(function(i){i[i.Inline=1]="Inline",i[i.Gutter=2]="Gutter"})(R||(e.MinimapPosition=R={}));var L;(function(i){i[i.Normal=1]="Normal",i[i.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var O;(function(i){i[i.Both=0]="Both",i[i.Right=1]="Right",i[i.Left=2]="Left",i[i.None=3]="None"})(O||(e.InjectedTextCursorStops=O={}));var $;(function(i){i[i.TextDefined=0]="TextDefined",i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var l;(function(i){i[i.LF=1]="LF",i[i.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var I;(function(i){i[i.LF=0]="LF",i[i.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class E{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.$go)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$9v=E;class u{constructor(t,s){this._findMatchBrand=void 0,this.range=t,this.matches=s}}e.$0v=u;var k;(function(i){i[i.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",i[i.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",i[i.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",i[i.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k||(e.TrackedRangeStickiness=k={}));function b(i){return i&&typeof i.read=="function"}var c;(function(i){i[i.Left=0]="Left",i[i.Right=1]="Right",i[i.None=2]="None",i[i.LeftOfInjectedText=3]="LeftOfInjectedText",i[i.RightOfInjectedText=4]="RightOfInjectedText"})(c||(e.PositionAffinity=c={}));var g;(function(i){i[i.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(g||(e.ModelConstants=g={}));class d{constructor(t,s,f,a,w,y){this.identifier=t,this.range=s,this.text=f,this.forceMoveMarkers=a,this.isAutoWhitespaceEdit=w,this._isTracked=y}}e.$_v=d;class m{constructor(t,s,f){this.regex=t,this.wordSeparators=s,this.simpleSearch=f}}e.$aw=m;class n{constructor(t,s,f){this.reverseEdits=t,this.changes=s,this.trimAutoWhitespaceLineNumbers=f}}e.$bw=n;function o(i){return!i.isTooLargeForSyncing()&&!i.isForSimpleWidget}}),define(Ee[195],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.NodeColor=e.$ZC=void 0,e.$2C=A,e.$3C=R,e.$4C=l,e.$5C=I,e.$6C=E,e.$7C=u,e.$8C=k,e.$9C=b;class r{constructor(g,d){this.piece=g,this.color=d,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$1C)return A(this.right);let g=this;for(;g.parent!==e.$1C&&g.parent.left!==g;)g=g.parent;return g.parent===e.$1C?e.$1C:g.parent}prev(){if(this.left!==e.$1C)return R(this.left);let g=this;for(;g.parent!==e.$1C&&g.parent.right!==g;)g=g.parent;return g.parent===e.$1C?e.$1C:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$ZC=r;var h;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(h||(e.NodeColor=h={})),e.$1C=new r(null,h.Black),e.$1C.parent=e.$1C,e.$1C.left=e.$1C,e.$1C.right=e.$1C,e.$1C.color=h.Black;function A(c){for(;c.left!==e.$1C;)c=c.left;return c}function R(c){for(;c.right!==e.$1C;)c=c.right;return c}function L(c){return c===e.$1C?0:c.size_left+c.piece.length+L(c.right)}function O(c){return c===e.$1C?0:c.lf_left+c.piece.lineFeedCnt+O(c.right)}function $(){e.$1C.parent=e.$1C}function l(c,g){const d=g.right;d.size_left+=g.size_left+(g.piece?g.piece.length:0),d.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=d.left,d.left!==e.$1C&&(d.left.parent=g),d.parent=g.parent,g.parent===e.$1C?c.root=d:g.parent.left===g?g.parent.left=d:g.parent.right=d,d.left=g,g.parent=d}function I(c,g){const d=g.left;g.left=d.right,d.right!==e.$1C&&(d.right.parent=g),d.parent=g.parent,g.size_left-=d.size_left+(d.piece?d.piece.length:0),g.lf_left-=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),g.parent===e.$1C?c.root=d:g===g.parent.right?g.parent.right=d:g.parent.left=d,d.right=g,g.parent=d}function E(c,g){let d,m;if(g.left===e.$1C?(m=g,d=m.right):g.right===e.$1C?(m=g,d=m.left):(m=A(g.right),d=m.right),m===c.root){c.root=d,d.color=h.Black,g.detach(),$(),c.root.parent=e.$1C;return}const n=m.color===h.Red;if(m===m.parent.left?m.parent.left=d:m.parent.right=d,m===g?(d.parent=m.parent,b(c,d)):(m.parent===g?d.parent=m:d.parent=m.parent,b(c,d),m.left=g.left,m.right=g.right,m.parent=g.parent,m.color=g.color,g===c.root?c.root=m:g===g.parent.left?g.parent.left=m:g.parent.right=m,m.left!==e.$1C&&(m.left.parent=m),m.right!==e.$1C&&(m.right.parent=m),m.size_left=g.size_left,m.lf_left=g.lf_left,b(c,m)),g.detach(),d.parent.left===d){const i=L(d),t=O(d);if(i!==d.parent.size_left||t!==d.parent.lf_left){const s=i-d.parent.size_left,f=t-d.parent.lf_left;d.parent.size_left=i,d.parent.lf_left=t,k(c,d.parent,s,f)}}if(b(c,d.parent),n){$();return}let o;for(;d!==c.root&&d.color===h.Black;)d===d.parent.left?(o=d.parent.right,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,l(c,d.parent),o=d.parent.right),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.right.color===h.Black&&(o.left.color=h.Black,o.color=h.Red,I(c,o),o=d.parent.right),o.color=d.parent.color,d.parent.color=h.Black,o.right.color=h.Black,l(c,d.parent),d=c.root)):(o=d.parent.left,o.color===h.Red&&(o.color=h.Black,d.parent.color=h.Red,I(c,d.parent),o=d.parent.left),o.left.color===h.Black&&o.right.color===h.Black?(o.color=h.Red,d=d.parent):(o.left.color===h.Black&&(o.right.color=h.Black,o.color=h.Red,l(c,o),o=d.parent.left),o.color=d.parent.color,d.parent.color=h.Black,o.left.color=h.Black,I(c,d.parent),d=c.root));d.color=h.Black,$()}function u(c,g){for(b(c,g);g!==c.root&&g.parent.color===h.Red;)if(g.parent===g.parent.parent.left){const d=g.parent.parent.right;d.color===h.Red?(g.parent.color=h.Black,d.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,l(c,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,I(c,g.parent.parent))}else{const d=g.parent.parent.left;d.color===h.Red?(g.parent.color=h.Black,d.color=h.Black,g.parent.parent.color=h.Red,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,I(c,g)),g.parent.color=h.Black,g.parent.parent.color=h.Red,l(c,g.parent.parent))}c.root.color=h.Black}function k(c,g,d,m){for(;g!==c.root&&g!==e.$1C;)g.parent.left===g&&(g.parent.size_left+=d,g.parent.lf_left+=m),g=g.parent}function b(c,g){let d=0,m=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,d=L(g.left)-g.size_left,m=O(g.left)-g.lf_left,g.size_left+=d,g.lf_left+=m;g!==c.root&&(d!==0||m!==0);)g.parent.left===g&&(g.parent.size_left+=d,g.parent.lf_left+=m),g=g.parent}}}),define(Ee[196],Se([1,0,19,84]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hw=e.$gw=e.$fw=void 0;class A{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,l){$=(0,h.$cf)($);const I=this.a,E=this.b,u=l.length;return u===0?!1:(this.a=new Uint32Array(I.length+u),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($),$+u),this.a.set(l,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue($,l){return $=(0,h.$cf)($),l=(0,h.$cf)(l),this.a[$]===l?!1:(this.a[$]=l,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,l){$=(0,h.$cf)($),l=(0,h.$cf)(l);const I=this.a,E=this.b;if($>=I.length)return!1;const u=I.length-$;return l>=u&&(l=u),l===0?!1:(this.a=new Uint32Array(I.length-l),this.a.set(I.subarray(0,$),0),this.a.set(I.subarray($+l),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,h.$cf)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),$>=this.a.length&&($=this.a.length-1);for(let I=l;I<=$;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let l=0,I=this.a.length-1,E=0,u=0,k=0;for(;l<=I;)if(E=l+(I-l)/2|0,u=this.b[E],k=u-this.a[E],$<k)I=E-1;else if($>=u)l=E+1;else break;return new L(E,$-k)}}e.$fw=A;class R{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const l=this.e[$],I=l>0?this.d[l-1]:0;return new L(l,$-I)}removeValues($,l){this.a.splice($,l),this.f($)}insertValues($,l){this.a=(0,r.$Xb)(this.a,$,l),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,l=this.a.length;$<l;$++){const I=this.a[$],E=$>0?this.d[$-1]:0;this.d[$]=E+I;for(let u=0;u<I;u++)this.e[E+u]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,l){this.a[$]!==l&&(this.a[$]=l,this.f($))}}e.$gw=R;class L{constructor($,l){this.index=$,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=l}}e.$hw=L}),define(Ee[197],Se([1,0,13,53,196]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=void 0;class R{constructor(O,$,l,I){this.d=O,this.f=$,this.g=l,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(O){O.eol&&O.eol!==this.g&&(this.g=O.eol,this.j=null);const $=O.changes;for(const l of $)this.o(l.range),this.p(new h.$Ht(l.range.startLineNumber,l.range.startColumn),l.text);this.h=O.versionId,this.k=null}l(){if(!this.j){const O=this.g.length,$=this.f.length,l=new Uint32Array($);for(let I=0;I<$;I++)l[I]=this.f[I].length+O;this.j=new A.$fw(l)}}n(O,$){this.f[O]=$,this.j&&this.j.setValue(O,this.f[O].length+this.g.length)}o(O){if(O.startLineNumber===O.endLineNumber){if(O.startColumn===O.endColumn)return;this.n(O.startLineNumber-1,this.f[O.startLineNumber-1].substring(0,O.startColumn-1)+this.f[O.startLineNumber-1].substring(O.endColumn-1));return}this.n(O.startLineNumber-1,this.f[O.startLineNumber-1].substring(0,O.startColumn-1)+this.f[O.endLineNumber-1].substring(O.endColumn-1)),this.f.splice(O.startLineNumber,O.endLineNumber-O.startLineNumber),this.j&&this.j.removeValues(O.startLineNumber,O.endLineNumber-O.startLineNumber)}p(O,$){if($.length===0)return;const l=(0,r.$tf)($);if(l.length===1){this.n(O.lineNumber-1,this.f[O.lineNumber-1].substring(0,O.column-1)+l[0]+this.f[O.lineNumber-1].substring(O.column-1));return}l[l.length-1]+=this.f[O.lineNumber-1].substring(O.column-1),this.n(O.lineNumber-1,this.f[O.lineNumber-1].substring(0,O.column-1)+l[0]);const I=new Uint32Array(l.length-1);for(let E=1;E<l.length;E++)this.f.splice(O.lineNumber+E-1,0,l[E]),I[E-1]=l[E].length+this.g.length;this.j&&this.j.insertValues(O.lineNumber,I)}}e.$iw=R}),define(Ee[107],Se([1,0,27,13,192,53,31,54]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$aD=e.$0C=void 0,e.$$C=I,e.$_C=E,e.$bD=g,h=We(h);const $=999;class l{constructor(n,o,i,t){this.searchString=n,this.isRegex=o,this.matchCase=i,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=I(this.searchString):n=this.searchString.indexOf(`
`)>=0;let o=null;try{o=h.$rf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!o)return null;let i=!this.isRegex&&!n;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new O.$aw(o,this.wordSeparators?(0,A.$du)(this.wordSeparators,[]):null,i?this.searchString:null)}}e.$0C=l;function I(m){if(!m||m.length===0)return!1;for(let n=0,o=m.length;n<o;n++){const i=m.charCodeAt(n);if(i===r.CharCode.LineFeed)return!0;if(i===r.CharCode.Backslash){if(n++,n>=o)break;const t=m.charCodeAt(n);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function E(m,n,o){if(!o)return new O.$0v(m,null);const i=[];for(let t=0,s=n.length;t<s;t++)i[t]=n[t];return new O.$0v(m,i)}class u{constructor(n){const o=[];let i=0;for(let t=0,s=n.length;t<s;t++)n.charCodeAt(t)===r.CharCode.LineFeed&&(o[i++]=t);this.a=o}findLineFeedCountBeforeOffset(n){const o=this.a;let i=0,t=o.length-1;if(t===-1||n<=o[0])return 0;for(;i<t;){const s=i+((t-i)/2>>0);o[s]>=n?t=s-1:o[s+1]>=n?(i=s,t=s):i=s+1}return i+1}}class k{static findMatches(n,o,i,t,s){const f=o.parseSearchRequest();return f?f.regex.multiline?this.b(n,i,new d(f.wordSeparators,f.regex),t,s):this.c(n,i,f,t,s):[]}static a(n,o,i,t,s,f){let a,w=0;t?(w=t.findLineFeedCountBeforeOffset(s),a=o+s+w):a=o+s;let y;if(t){const C=t.findLineFeedCountBeforeOffset(s+f.length)-w;y=a+f.length+C}else y=a+f.length;const S=n.getPositionAt(a),D=n.getPositionAt(y);return new L.$It(S.lineNumber,S.column,D.lineNumber,D.column)}static b(n,o,i,t,s){const f=n.getOffsetAt(o.getStartPosition()),a=n.getValueInRange(o,O.EndOfLinePreference.LF),w=n.getEOL()===`\r
`?new u(a):null,y=[];let S=0,D;for(i.reset(0);D=i.next(a);)if(y[S++]=E(this.a(n,f,a,w,D.index,D[0]),D,t),S>=s)return y;return y}static c(n,o,i,t,s){const f=[];let a=0;if(o.startLineNumber===o.endLineNumber){const y=n.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return a=this.d(i,y,o.startLineNumber,o.startColumn-1,a,f,t,s),f}const w=n.getLineContent(o.startLineNumber).substring(o.startColumn-1);a=this.d(i,w,o.startLineNumber,o.startColumn-1,a,f,t,s);for(let y=o.startLineNumber+1;y<o.endLineNumber&&a<s;y++)a=this.d(i,n.getLineContent(y),y,0,a,f,t,s);if(a<s){const y=n.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);a=this.d(i,y,o.endLineNumber,0,a,f,t,s)}return f}static d(n,o,i,t,s,f,a,w){const y=n.wordSeparators;if(!a&&n.simpleSearch){const P=n.simpleSearch,C=P.length,p=o.length;let v=-C;for(;(v=o.indexOf(P,v+C))!==-1;)if((!y||g(y,o,p,v,C))&&(f[s++]=new O.$0v(new L.$It(i,v+1+t,i,v+1+C+t),null),s>=w))return s;return s}const S=new d(n.wordSeparators,n.regex);let D;S.reset(0);do if(D=S.next(o),D&&(f[s++]=E(new L.$It(i,D.index+1+t,i,D.index+1+D[0].length+t),D,a),s>=w))return s;while(D);return s}static findNextMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const f=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.e(n,i,f,t):this.f(n,i,f,t)}static e(n,o,i,t){const s=new R.$Ht(o.lineNumber,1),f=n.getOffsetAt(s),a=n.getLineCount(),w=n.getValueInRange(new L.$It(s.lineNumber,s.column,a,n.getLineMaxColumn(a)),O.EndOfLinePreference.LF),y=n.getEOL()===`\r
`?new u(w):null;i.reset(o.column-1);const S=i.next(w);return S?E(this.a(n,f,w,y,S.index,S[0]),S,t):o.lineNumber!==1||o.column!==1?this.e(n,new R.$Ht(1,1),i,t):null}static f(n,o,i,t){const s=n.getLineCount(),f=o.lineNumber,a=n.getLineContent(f),w=this.g(i,a,f,o.column,t);if(w)return w;for(let y=1;y<=s;y++){const S=(f+y-1)%s,D=n.getLineContent(S+1),P=this.g(i,D,S+1,1,t);if(P)return P}return null}static g(n,o,i,t,s){n.reset(t-1);const f=n.next(o);return f?E(new L.$It(i,f.index+1,i,f.index+1+f[0].length),f,s):null}static findPreviousMatch(n,o,i,t){const s=o.parseSearchRequest();if(!s)return null;const f=new d(s.wordSeparators,s.regex);return s.regex.multiline?this.h(n,i,f,t):this.j(n,i,f,t)}static h(n,o,i,t){const s=this.b(n,new L.$It(1,1,o.lineNumber,o.column),i,t,10*$);if(s.length>0)return s[s.length-1];const f=n.getLineCount();return o.lineNumber!==f||o.column!==n.getLineMaxColumn(f)?this.h(n,new R.$Ht(f,n.getLineMaxColumn(f)),i,t):null}static j(n,o,i,t){const s=n.getLineCount(),f=o.lineNumber,a=n.getLineContent(f).substring(0,o.column-1),w=this.k(i,a,f,t);if(w)return w;for(let y=1;y<=s;y++){const S=(s+f-y-1)%s,D=n.getLineContent(S+1),P=this.k(i,D,S+1,t);if(P)return P}return null}static k(n,o,i,t){let s=null,f;for(n.reset(0);f=n.next(o);)s=E(new L.$It(i,f.index+1,i,f.index+1+f[0].length),f,t);return s}}e.$aD=k;function b(m,n,o,i,t){if(i===0)return!0;const s=n.charCodeAt(i-1);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const f=n.charCodeAt(i);if(m.get(f)!==A.WordCharacterClass.Regular)return!0}return!1}function c(m,n,o,i,t){if(i+t===o)return!0;const s=n.charCodeAt(i+t);if(m.get(s)!==A.WordCharacterClass.Regular||s===r.CharCode.CarriageReturn||s===r.CharCode.LineFeed)return!0;if(t>0){const f=n.charCodeAt(i+t-1);if(m.get(f)!==A.WordCharacterClass.Regular)return!0}return!1}function g(m,n,o,i,t){return b(m,n,o,i,t)&&c(m,n,o,i,t)}class d{constructor(n,o){this._wordSeparators=n,this.a=o,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const o=n.length;let i;do{if(this.b+this.c===o||(i=this.a.exec(n),!i))return null;const t=i.index,s=i[0].length;if(t===this.b&&s===this.c){if(s===0){h.$Nf(n,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=t,this.c=s,!this._wordSeparators||g(this._wordSeparators,n,o,t,s))return i}while(i);return null}}e.$cD=d}),define(Ee[139],Se([1,0,27,53,31,54,195,107]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=e.$gD=e.$fD=void 0,e.$dD=E,e.$eD=u;const $=65535;function l(m){let n;return m[m.length-1]<65536?n=new Uint16Array(m.length):n=new Uint32Array(m.length),n.set(m,0),n}class I{constructor(n,o,i,t,s){this.lineStarts=n,this.cr=o,this.lf=i,this.crlf=t,this.isBasicASCII=s}}function E(m,n=!0){const o=[0];let i=1;for(let t=0,s=m.length;t<s;t++){const f=m.charCodeAt(t);f===r.CharCode.CarriageReturn?t+1<s&&m.charCodeAt(t+1)===r.CharCode.LineFeed?(o[i++]=t+2,t++):o[i++]=t+1:f===r.CharCode.LineFeed&&(o[i++]=t+1)}return n?l(o):o}function u(m,n){m.length=0,m[0]=0;let o=1,i=0,t=0,s=0,f=!0;for(let w=0,y=n.length;w<y;w++){const S=n.charCodeAt(w);S===r.CharCode.CarriageReturn?w+1<y&&n.charCodeAt(w+1)===r.CharCode.LineFeed?(s++,m[o++]=w+2,w++):(i++,m[o++]=w+1):S===r.CharCode.LineFeed?(t++,m[o++]=w+1):f&&S!==r.CharCode.Tab&&(S<32||S>126)&&(f=!1)}const a=new I(l(m),i,t,s,f);return m.length=0,a}class k{constructor(n,o,i,t,s){this.bufferIndex=n,this.start=o,this.end=i,this.lineFeedCnt=t,this.length=s}}e.$fD=k;class b{constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$gD=b;class c{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==L.$1C&&n.iterate(n.root,i=>(i!==L.$1C&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class g{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const i=this.b[o];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const i=this.b;for(let t=0;t<i.length;t++){const s=i[t];if(s.node.parent===null||s.nodeStartOffset>=n){i[t]=null,o=!0;continue}}if(o){const t=[];for(const s of i)s!==null&&t.push(s);this.b=t}}}class d{constructor(n,o,i){this.create(n,o,i)}create(n,o,i){this.a=[new b("",[0])],this.g={line:0,column:0},this.root=L.$1C,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=i;let t=null;for(let s=0,f=n.length;s<f;s++)if(n[s].buffer.length>0){n[s].lineStarts||(n[s].lineStarts=E(n[s].buffer));const a=new k(s+1,{line:0,column:0},{line:n[s].lineStarts.length-1,column:n[s].buffer.length-n[s].lineStarts[n[s].lineStarts.length-1]},n[s].lineStarts.length-1,n[s].buffer.length);this.a.push(n[s]),t=this.S(t,a)}this.h=new g(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=$,i=o-Math.floor(o/3),t=i*2;let s="",f=0;const a=[];if(this.iterate(this.root,w=>{const y=this.R(w),S=y.length;if(f<=i||f+S<t)return s+=y,f+=S,!0;const D=s.replace(/\r\n|\r|\n/g,n);return a.push(new b(D,E(D))),s=y,f=S,!0}),f>0){const w=s.replace(/\r\n|\r|\n/g,n);a.push(new b(w,E(w)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new c(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,t=>{if(t===L.$1C)return!0;const s=this.R(t),f=s.length,a=n.G(o),w=n.G(o+f),y=n.getValueInRange2(a,w);return o+=f,s===y})}getOffsetAt(n,o){let i=0,t=this.root;for(;t!==L.$1C;)if(t.left!==L.$1C&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const s=this.B(t,n-t.lf_left-2);return i+=s+o-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,i=0;const t=n;for(;o!==L.$1C;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const s=this.A(o,n-o.size_left);if(i+=o.lf_left+s.index,s.index===0){const f=this.getOffsetAt(i+1,1),a=t-f;return new h.$Ht(i+1,a+1)}return new h.$Ht(i+1,s.remainder+1)}else if(n-=o.size_left+o.piece.length,i+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$1C){const s=this.getOffsetAt(i+1,1),f=t-n-s;return new h.$Ht(i+1,f+1)}else o=o.right;return new h.$Ht(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),s=this.getValueInRange2(i,t);return o?o!==this.d||!this.f?s.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?s:s.replace(/\r\n|\r|\n/g,o):s}getValueInRange2(n,o){if(n.node===o.node){const a=n.node,w=this.a[a.piece.bufferIndex].buffer,y=this.u(a.piece.bufferIndex,a.piece.start);return w.substring(y+n.remainder,y+o.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,s=this.u(i.piece.bufferIndex,i.piece.start);let f=t.substring(s+n.remainder,s+i.piece.length);for(i=i.next();i!==L.$1C;){const a=this.a[i.piece.bufferIndex].buffer,w=this.u(i.piece.bufferIndex,i.piece.start);if(i===o.node){f+=a.substring(w,w+o.remainder);break}else f+=a.substr(w,i.piece.length);i=i.next()}return f}getLinesContent(){const n=[];let o=0,i="",t=!1;return this.iterate(this.root,s=>{if(s===L.$1C)return!0;const f=s.piece;let a=f.length;if(a===0)return!0;const w=this.a[f.bufferIndex].buffer,y=this.a[f.bufferIndex].lineStarts,S=f.start.line,D=f.end.line;let P=y[S]+f.start.column;if(t&&(w.charCodeAt(P)===r.CharCode.LineFeed&&(P++,a--),n[o++]=i,i="",t=!1,a===0))return!0;if(S===D)return!this.f&&w.charCodeAt(P+a-1)===r.CharCode.CarriageReturn?(t=!0,i+=w.substr(P,a-1)):i+=w.substr(P,a),!0;i+=this.f?w.substring(P,Math.max(P,y[S+1]-this.e)):w.substring(P,y[S+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;for(let C=S+1;C<D;C++)i=this.f?w.substring(y[C],y[C+1]-this.e):w.substring(y[C],y[C+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=i;return!this.f&&w.charCodeAt(y[D]+f.end.column-1)===r.CharCode.CarriageReturn?(t=!0,f.end.column===0?o--:i=w.substr(y[D],f.end.column-1)):i=w.substr(y[D],f.end.column),!0}),t&&(n[o++]=i,i=""),n[o++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const i=this.a[o.piece.bufferIndex],t=this.u(o.piece.bufferIndex,o.piece.start);return i.buffer.charCodeAt(t)}else{const o=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(t)}}getLineCharCode(n,o){const i=this.H(n,o+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}getNearestChunk(n){const o=this.G(n);if(o.remainder===o.node.piece.length){const i=o.node.next();if(!i||i===L.$1C)return"";const t=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return t.buffer.substring(s,s+i.piece.length)}else{const i=this.a[o.node.piece.bufferIndex],t=this.u(o.node.piece.bufferIndex,o.node.piece.start),s=t+o.remainder,f=t+o.node.piece.length;return i.buffer.substring(s,f)}}findMatchesInNode(n,o,i,t,s,f,a,w,y,S,D){const P=this.a[n.piece.bufferIndex],C=this.u(n.piece.bufferIndex,n.piece.start),p=this.u(n.piece.bufferIndex,s),v=this.u(n.piece.bufferIndex,f);let N;const T={line:0,column:0};let M,j;o._wordSeparators?(M=P.buffer.substring(p,v),j=z=>z+p,o.reset(0)):(M=P.buffer,j=z=>z,o.reset(p));do if(N=o.next(M),N){if(j(N.index)>=v)return S;this.s(n,j(N.index)-C,T);const z=this.t(n.piece.bufferIndex,s,T),F=T.line===s.line?T.column-s.column+t:T.column+1,B=F+N[0].length;if(D[S++]=(0,O.$_C)(new A.$It(i+z,F,i+z,B),N,w),j(N.index)+N[0].length>=v||S>=y)return S}while(N);return S}findMatchesLineByLine(n,o,i,t){const s=[];let f=0;const a=new O.$cD(o.wordSeparators,o.regex);let w=this.H(n.startLineNumber,n.startColumn);if(w===null)return[];const y=this.H(n.endLineNumber,n.endColumn);if(y===null)return[];let S=this.s(w.node,w.remainder);const D=this.s(y.node,y.remainder);if(w.node===y.node)return this.findMatchesInNode(w.node,a,n.startLineNumber,n.startColumn,S,D,o,i,t,f,s),s;let P=n.startLineNumber,C=w.node;for(;C!==y.node;){const v=this.t(C.piece.bufferIndex,S,C.piece.end);if(v>=1){const T=this.a[C.piece.bufferIndex].lineStarts,M=this.u(C.piece.bufferIndex,C.piece.start),j=T[S.line+v],z=P===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(C,a,P,z,S,this.s(C,j-M),o,i,t,f,s),f>=t)return s;P+=v}const N=P===n.startLineNumber?n.startColumn-1:0;if(P===n.endLineNumber){const T=this.getLineContent(P).substring(N,n.endColumn-1);return f=this.n(o,a,T,n.endLineNumber,N,f,s,i,t),s}if(f=this.n(o,a,this.getLineContent(P).substr(N),P,N,f,s,i,t),f>=t)return s;P++,w=this.H(P,1),C=w.node,S=this.s(w.node,w.remainder)}if(P===n.endLineNumber){const v=P===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(P).substring(v,n.endColumn-1);return f=this.n(o,a,N,n.endLineNumber,v,f,s,i,t),s}const p=P===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(y.node,a,P,p,S,D,o,i,t,f,s),s}n(n,o,i,t,s,f,a,w,y){const S=n.wordSeparators;if(!w&&n.simpleSearch){const P=n.simpleSearch,C=P.length,p=i.length;let v=-C;for(;(v=i.indexOf(P,v+C))!==-1;)if((!S||(0,O.$bD)(S,i,p,v,C))&&(a[f++]=new R.$0v(new A.$It(t,v+1+s,t,v+1+C+s),null),f>=y))return f;return f}let D;o.reset(0);do if(D=o.next(i),D&&(a[f++]=(0,O.$_C)(new A.$It(t,D.index+1+s,t,D.index+1+D[0].length+s),D,w),f>=y))return f;while(D);return f}insert(n,o,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==L.$1C){const{node:t,remainder:s,nodeStartOffset:f}=this.G(n),a=t.piece,w=a.bufferIndex,y=this.s(t,s);if(t.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&f+a.length===n&&o.length<$){this.F(t,o),this.y();return}if(f===n)this.o(o,t),this.h.validate(n);else if(f+t.piece.length>n){const S=[];let D=new k(a.bufferIndex,y,a.end,this.t(a.bufferIndex,y,a.end),this.u(w,a.end)-this.u(w,y));if(this.K()&&this.M(o)&&this.I(t,s)===10){const v={line:D.start.line+1,column:0};D=new k(D.bufferIndex,v,D.end,this.t(D.bufferIndex,v,D.end),D.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(t,s-1)===13){const v=this.s(t,s-1);this.C(t,v),o="\r"+o,t.piece.length===0&&S.push(t)}else this.C(t,y);else this.C(t,y);const P=this.w(o);D.length>0&&this.S(t,D);let C=t;for(let p=0;p<P.length;p++)C=this.S(C,P[p]);this.v(S)}else this.q(o,t)}else{const t=this.w(o);let s=this.T(null,t[0]);for(let f=1;f<t.length;f++)s=this.S(s,t[f])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$1C)return;const i=this.G(n),t=this.G(n+o),s=i.node,f=t.node;if(s===f){const P=this.s(s,i.remainder),C=this.s(s,t.remainder);if(i.nodeStartOffset===n){if(o===s.piece.length){const p=s.next();(0,L.$6C)(this,s),this.N(p),this.y();return}this.D(s,C),this.h.validate(n),this.N(s),this.y();return}if(i.nodeStartOffset+s.piece.length===n+o){this.C(s,P),this.O(s),this.y();return}this.E(s,P,C),this.y();return}const a=[],w=this.s(s,i.remainder);this.C(s,w),this.h.validate(n),s.piece.length===0&&a.push(s);const y=this.s(f,t.remainder);this.D(f,y),f.piece.length===0&&a.push(f);const S=s.next();for(let P=S;P!==L.$1C&&P!==f;P=P.next())a.push(P);const D=s.piece.length===0?s.prev():s;this.v(a),this.O(D),this.y()}o(n,o){const i=[];if(this.K()&&this.M(n)&&this.L(o)){const f=o.piece,a={line:f.start.line+1,column:0},w=new k(f.bufferIndex,a,f.end,this.t(f.bufferIndex,a,f.end),f.length-1);o.piece=w,n+=`
`,(0,L.$8C)(this,o,-1,-1),o.piece.length===0&&i.push(o)}const t=this.w(n);let s=this.T(o,t[t.length-1]);for(let f=t.length-2;f>=0;f--)s=this.T(s,t[f]);this.N(s),this.v(i)}q(n,o){this.Q(n,o)&&(n+=`
`);const i=this.w(n),t=this.S(o,i[0]);let s=t;for(let f=1;f<i.length;f++)s=this.S(s,i[f]);this.N(t)}s(n,o,i){const t=n.piece,s=n.piece.bufferIndex,f=this.a[s].lineStarts,w=f[t.start.line]+t.start.column+o;let y=t.start.line,S=t.end.line,D=0,P=0,C=0;for(;y<=S&&(D=y+(S-y)/2|0,C=f[D],D!==S);)if(P=f[D+1],w<C)S=D-1;else if(w>=P)y=D+1;else break;return i?(i.line=D,i.column=w-C,null):{line:D,column:w-C}}t(n,o,i){if(i.column===0)return i.line-o.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-o.line;const s=t[i.line+1],f=t[i.line]+i.column;if(s>f+1)return i.line-o.line;const a=f-1;return this.a[n].buffer.charCodeAt(a)===13?i.line-o.line+1:i.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,L.$6C)(this,n[o])}w(n){if(n.length>$){const S=[];for(;n.length>$;){const P=n.charCodeAt($-1);let C;P===r.CharCode.CarriageReturn||P>=55296&&P<=56319?(C=n.substring(0,$-1),n=n.substring($-1)):(C=n.substring(0,$),n=n.substring($));const p=E(C);S.push(new k(this.a.length,{line:0,column:0},{line:p.length-1,column:C.length-p[p.length-1]},p.length-1,C.length)),this.a.push(new b(C,p))}const D=E(n);return S.push(new k(this.a.length,{line:0,column:0},{line:D.length-1,column:n.length-D[D.length-1]},D.length-1,n.length)),this.a.push(new b(n,D)),S}let o=this.a[0].buffer.length;const i=E(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let S=0;S<i.length;S++)i[S]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let S=0;S<i.length;S++)i[S]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const s=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,a=s-this.a[0].lineStarts[f],w={line:f,column:a},y=new k(0,t,w,this.t(0,t,w),s-o);return this.g=w,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let i=this.root,t="";const s=this.h.get2(n);if(s){i=s.node;const f=this.B(i,n-s.nodeStartLineNumber-1),a=this.a[i.piece.bufferIndex].buffer,w=this.u(i.piece.bufferIndex,i.piece.start);if(s.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=a.substring(w+f,w+i.piece.length);else{const y=this.B(i,n-s.nodeStartLineNumber);return a.substring(w+f,w+y-o)}}else{let f=0;const a=n;for(;i!==L.$1C;)if(i.left!==L.$1C&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const w=this.B(i,n-i.lf_left-2),y=this.B(i,n-i.lf_left-1),S=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);return f+=i.size_left,this.h.set({node:i,nodeStartOffset:f,nodeStartLineNumber:a-(n-1-i.lf_left)}),S.substring(D+w,D+y-o)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const w=this.B(i,n-i.lf_left-2),y=this.a[i.piece.bufferIndex].buffer,S=this.u(i.piece.bufferIndex,i.piece.start);t=y.substring(S+w,S+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,f+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==L.$1C;){const f=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const a=this.B(i,0),w=this.u(i.piece.bufferIndex,i.piece.start);return t+=f.substring(w,w+a-o),t}else{const a=this.u(i.piece.bufferIndex,i.piece.start);t+=f.substr(a,i.piece.length)}i=i.next()}return t}y(){let n=this.root,o=1,i=0;for(;n!==L.$1C;)o+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=i,this.h.validate(this.c)}A(n,o){const i=n.piece,t=this.s(n,o),s=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===o){const f=this.t(n.piece.bufferIndex,i.start,t);if(f!==s)return{index:f,remainder:0}}return{index:s,remainder:t.column}}B(n,o){if(o<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,s=i.start.line+o+1;return s>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[s]-t[i.start.line]-i.start.column}C(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.end),f=o,a=this.u(i.bufferIndex,f),w=this.t(i.bufferIndex,i.start,f),y=w-t,S=a-s,D=i.length+S;n.piece=new k(i.bufferIndex,i.start,f,w,D),(0,L.$8C)(this,n,S,y)}D(n,o){const i=n.piece,t=i.lineFeedCnt,s=this.u(i.bufferIndex,i.start),f=o,a=this.t(i.bufferIndex,f,i.end),w=this.u(i.bufferIndex,f),y=a-t,S=s-w,D=i.length+S;n.piece=new k(i.bufferIndex,f,i.end,a,D),(0,L.$8C)(this,n,S,y)}E(n,o,i){const t=n.piece,s=t.start,f=t.end,a=t.length,w=t.lineFeedCnt,y=o,S=this.t(t.bufferIndex,t.start,y),D=this.u(t.bufferIndex,o)-this.u(t.bufferIndex,s);n.piece=new k(t.bufferIndex,t.start,y,S,D),(0,L.$8C)(this,n,D-a,S-w);const P=new k(t.bufferIndex,i,f,this.t(t.bufferIndex,i,f),this.u(t.bufferIndex,f)-this.u(t.bufferIndex,i)),C=this.S(n,P);this.N(C)}F(n,o){this.Q(o,n)&&(o+=`
`);const i=this.K()&&this.L(o)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=o;const s=E(o,!1);for(let C=0;C<s.length;C++)s[C]+=t;if(i){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(s.slice(1));const f=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[f],w={line:f,column:a},y=n.piece.length+o.length,S=n.piece.lineFeedCnt,D=this.t(0,n.piece.start,w),P=D-S;n.piece=new k(n.piece.bufferIndex,n.piece.start,w,D,y),this.g=w,(0,L.$8C)(this,n,o.length,P)}G(n){let o=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;o!==L.$1C;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){t+=o.size_left;const s={node:o,remainder:n-o.size_left,nodeStartOffset:t};return this.h.set(s),s}else n-=o.size_left+o.piece.length,t+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let i=this.root,t=0;for(;i!==L.$1C;)if(i.left!==L.$1C&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const s=this.B(i,n-i.lf_left-2),f=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(s+o-1,f),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const s=this.B(i,n-i.lf_left-2);if(s+o-1<=i.piece.length)return{node:i,remainder:s+o-1,nodeStartOffset:t};o-=i.piece.length-s;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==L.$1C;){if(i.piece.lineFeedCnt>0){const s=this.B(i,0),f=this.J(i);return{node:i,remainder:Math.min(o-1,s),nodeStartOffset:f}}else if(i.piece.length>=o-1){const s=this.J(i);return{node:i,remainder:o-1,nodeStartOffset:s}}else o-=i.piece.length;i=i.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+o;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$1C||n.piece.lineFeedCnt===0)return!1;const o=n.piece,i=this.a[o.bufferIndex].lineStarts,t=o.start.line,s=i[t]+o.start.column;return t===i.length-1||i[t+1]>s+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(s)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$1C||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let s;n.piece.end.column===0?s={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:s={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new k(n.piece.bufferIndex,n.piece.start,s,a,f),(0,L.$8C)(this,n,-1,-1),n.piece.length===0&&i.push(n);const w={line:o.piece.start.line+1,column:0},y=o.piece.length-1,S=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new k(o.piece.bufferIndex,w,o.piece.end,S,y),(0,L.$8C)(this,o,-1,-1),o.piece.length===0&&i.push(o);const D=this.w(`\r
`);this.S(n,D[0]);for(let P=0;P<i.length;P++)(0,L.$6C)(this,i[P])}Q(n,o){if(this.K()&&this.M(n)){const i=o.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,L.$6C)(this,i);else{const t=i.piece,s={line:t.start.line+1,column:0},f=t.length-1,a=this.t(t.bufferIndex,s,t.end);i.piece=new k(t.bufferIndex,s,t.end,a,f),(0,L.$8C)(this,i,-1,-1)}return!0}}return!1}iterate(n,o){if(n===L.$1C)return o(L.$1C);const i=this.iterate(n.left,o);return i&&o(n)&&this.iterate(n.right,o)}R(n){if(n===L.$1C)return"";const o=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),s=this.u(i.bufferIndex,i.end);return o.buffer.substring(t,s)}getPieceContent(n){const o=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return o.buffer.substring(i,t)}S(n,o){const i=new L.$ZC(o,L.NodeColor.Red);if(i.left=L.$1C,i.right=L.$1C,i.parent=L.$1C,i.size_left=0,i.lf_left=0,this.root===L.$1C)this.root=i,i.color=L.NodeColor.Black;else if(n.right===L.$1C)n.right=i,i.parent=n;else{const s=(0,L.$2C)(n.right);s.left=i,i.parent=s}return(0,L.$7C)(this,i),i}T(n,o){const i=new L.$ZC(o,L.NodeColor.Red);if(i.left=L.$1C,i.right=L.$1C,i.parent=L.$1C,i.size_left=0,i.lf_left=0,this.root===L.$1C)this.root=i,i.color=L.NodeColor.Black;else if(n.left===L.$1C)n.left=i,i.parent=n;else{const t=(0,L.$3C)(n.left);t.right=i,i.parent=t}return(0,L.$7C)(this,i),i}U(n){let o="";return this.iterate(n,i=>(o+=this.R(i),!0)),o}}e.$hD=d}),define(Ee[198],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_=e.$b_=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$b_=r;class h{constructor(R){this.identifier=R}}e.$c_=h}),define(Ee[199],Se([1,0,4,3,106]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ru=void 0;class R{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$me,this.onDidChange=this.c.event,this.d=null}handleChange($){this.c.fire({changedLanguages:$,changedColorMap:!1})}register($,l){return this.a.set($,l),this.handleChange([$]),(0,h.$Uc)(()=>{this.a.get($)===l&&(this.a.delete($),this.handleChange([$]))})}get($){return this.a.get($)||null}registerFactory($,l){this.b.get($)?.dispose();const I=new L(this,$,l);return this.b.set($,I),(0,h.$Uc)(()=>{const E=this.b.get($);!E||E!==I||(this.b.delete($),E.dispose())})}async getOrCreate($){const l=this.get($);if(l)return l;const I=this.b.get($);return!I||I.isResolved?null:(await I.resolve(),this.get($))}isResolved($){if(this.get($))return!0;const I=this.b.get($);return!!(!I||I.isResolved)}setColorMap($){this.d=$,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>A.ColorId.DefaultBackground?this.d[A.ColorId.DefaultBackground]:null}}e.$ru=R;class L extends h.$Wc{get isResolved(){return this.c}constructor($,l,I){super(),this.f=$,this.g=l,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const $=await this.h.tokenizationSupport;this.c=!0,$&&!this.a&&this.B(this.f.register(this.g,$))}}}),define(Ee[200],Se([7,8]),function(ce,e){return ce.create("vs/base/common/actions",e)}),define(Ee[201],Se([1,0,4,3,200]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=I,A=We(A);class R extends h.$Wc{constructor(u,k="",b="",c=!0,g){super(),this.j=this.B(new r.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=k,this.w=b,this.z=c,this.D=g}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,k){this.D&&await this.D(u)}}e.$kj=R;class L extends h.$Wc{constructor(){super(...arguments),this.f=this.B(new r.$me),this.onWillRun=this.f.event,this.m=this.B(new r.$me),this.onDidRun=this.m.event}async run(u,k){if(!u.enabled)return;this.f.fire({action:u});let b;try{await this.u(u,k)}catch(c){b=c}this.m.fire({action:u,error:b})}async u(u,k){await u.run(k)}}e.$lj=L;class O{constructor(){this.id=O.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let k=[];for(const b of u)b.length&&(k.length?k=[...k,new O,...b]:k=b);return k}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=O;class ${get actions(){return this.a}constructor(u,k,b,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=k,this.class=c,this.a=b}async run(){}}e.$nj=$;class l extends R{static{this.ID="vs.actions.empty"}constructor(){super(l.ID,A.localize(0,null),void 0,!1)}}e.$oj=l;function I(E){return{id:E.id,label:E.label,tooltip:E.tooltip??E.label,class:E.class,enabled:E.enabled??!0,checked:E.checked,run:async(...u)=>E.run(...u)}}}),define(Ee[202],Se([7,8]),function(ce,e){return ce.create("vs/base/common/date",e)}),define(Ee[203],Se([1,0,202]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=l,e.$2m=I,e.$3m=E;const h=60,A=h*60,R=A*24,L=R*7,O=R*30,$=R*365;function l(u,k,b,c){typeof u!="number"&&(u=u.getTime());const g=Math.round((new Date().getTime()-u)/1e3);if(g<-30)return(0,r.localize)(0,null,l(new Date().getTime()+g*1e3,!1));if(!c&&g<30)return(0,r.localize)(1,null);let d;return g<h?(d=g,k?d===1?b?(0,r.localize)(2,null,d):(0,r.localize)(3,null,d):b?(0,r.localize)(4,null,d):(0,r.localize)(5,null,d):d===1?b?(0,r.localize)(6,null,d):(0,r.localize)(7,null,d):b?(0,r.localize)(8,null,d):(0,r.localize)(9,null,d)):g<A?(d=Math.floor(g/h),k?d===1?b?(0,r.localize)(10,null,d):(0,r.localize)(11,null,d):b?(0,r.localize)(12,null,d):(0,r.localize)(13,null,d):d===1?b?(0,r.localize)(14,null,d):(0,r.localize)(15,null,d):b?(0,r.localize)(16,null,d):(0,r.localize)(17,null,d)):g<R?(d=Math.floor(g/A),k?d===1?b?(0,r.localize)(18,null,d):(0,r.localize)(19,null,d):b?(0,r.localize)(20,null,d):(0,r.localize)(21,null,d):d===1?b?(0,r.localize)(22,null,d):(0,r.localize)(23,null,d):b?(0,r.localize)(24,null,d):(0,r.localize)(25,null,d)):g<L?(d=Math.floor(g/R),k?d===1?(0,r.localize)(26,null,d):(0,r.localize)(27,null,d):d===1?(0,r.localize)(28,null,d):(0,r.localize)(29,null,d)):g<O?(d=Math.floor(g/L),k?d===1?b?(0,r.localize)(30,null,d):(0,r.localize)(31,null,d):b?(0,r.localize)(32,null,d):(0,r.localize)(33,null,d):d===1?b?(0,r.localize)(34,null,d):(0,r.localize)(35,null,d):b?(0,r.localize)(36,null,d):(0,r.localize)(37,null,d)):g<$?(d=Math.floor(g/O),k?d===1?b?(0,r.localize)(38,null,d):(0,r.localize)(39,null,d):b?(0,r.localize)(40,null,d):(0,r.localize)(41,null,d):d===1?b?(0,r.localize)(42,null,d):(0,r.localize)(43,null,d):b?(0,r.localize)(44,null,d):(0,r.localize)(45,null,d)):(d=Math.floor(g/$),k?d===1?b?(0,r.localize)(46,null,d):(0,r.localize)(47,null,d):b?(0,r.localize)(48,null,d):(0,r.localize)(49,null,d):d===1?b?(0,r.localize)(50,null,d):(0,r.localize)(51,null,d):b?(0,r.localize)(52,null,d):(0,r.localize)(53,null,d))}function I(u,k){const b=Math.abs(u/1e3);return b<1?k?(0,r.localize)(54,null,u):(0,r.localize)(55,null,u):b<h?k?(0,r.localize)(56,null,Math.round(u)/1e3):(0,r.localize)(57,null,Math.round(u)/1e3):b<A?k?(0,r.localize)(58,null,Math.round(u/(1e3*h))):(0,r.localize)(59,null,Math.round(u/(1e3*h))):b<R?k?(0,r.localize)(60,null,Math.round(u/(1e3*A))):(0,r.localize)(61,null,Math.round(u/(1e3*A))):(0,r.localize)(62,null,Math.round(u/(1e3*R)))}function E(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[204],Se([7,8]),function(ce,e){return ce.create("vs/base/common/errorMessage",e)}),define(Ee[55],Se([1,0,19,18,204]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=$,e.$rj=l,e.$sj=I,r=We(r),h=We(h),A=We(A);function R(E,u){return u&&(E.stack||E.stacktrace)?A.localize(0,null,O(E),L(E.stack)||L(E.stacktrace)):O(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function O(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?A.localize(1,null,E.message):E.message||A.localize(2,null)}function $(E=null,u=!1){if(!E)return A.localize(3,null);if(Array.isArray(E)){const k=r.$Jb(E),b=$(k[0],u);return k.length>1?A.localize(4,null,b,k.length):b}if(h.$fg(E))return E;if(E.detail){const k=E.detail;if(k.error)return R(k.error,u);if(k.exception)return R(k.exception,u)}return E.stack?R(E,u):E.message?E.message:A.localize(5,null)}function l(E){const u=E;return u instanceof Error&&Array.isArray(u.actions)}function I(E,u){let k;return typeof E=="string"?k=new Error(E):k=E,k.actions=u,k}}),define(Ee[205],Se([7,8]),function(ce,e){return ce.create("vs/base/common/platform",e)}),define(Ee[11],Se([1,0,205]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=D,e.$J=P,r=We(r),e.$g="en";let h=!1,A=!1,R=!1,L=!1,O=!1,$=!1,l=!1,I=!1,E=!1,u=!1,k,b=e.$g,c=e.$g,g,d;const m=globalThis;let n;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?n=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(n=process);const o=typeof n?.versions?.electron=="string",i=o&&n?.type==="renderer";if(typeof n=="object"){h=n.platform==="win32",A=n.platform==="darwin",R=n.platform==="linux",L=R&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,l=o,E=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,k=e.$g,b=e.$g;const C=n.env.VSCODE_NLS_CONFIG;if(C)try{const p=JSON.parse(C),v=p.availableLanguages["*"];k=p.locale,c=p.osLocale,b=v||e.$g,g=p._translationsConfigFile}catch{}O=!0}else typeof navigator=="object"&&!i?(d=navigator.userAgent,h=d.indexOf("Windows")>=0,A=d.indexOf("Macintosh")>=0,I=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=d.indexOf("Linux")>=0,u=d?.indexOf("Mobi")>=0,$=!0,k=r.getConfiguredDefaultLocale(r.localize(0,null))||e.$g,b=k,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(C){switch(C){case t.Web:return"Web";case t.Mac:return"Mac";case t.Linux:return"Linux";case t.Windows:return"Windows"}}let f=t.Web;A?f=t.Mac:h?f=t.Windows:R&&(f=t.Linux),e.$i=h,e.$j=A,e.$k=R,e.$l=L,e.$m=O,e.$n=l,e.$o=$,e.$p=$&&typeof m.importScripts=="function",e.$q=e.$p?m.origin:void 0,e.$r=I,e.$s=u,e.$t=E,e.$u=f,e.$v=d,e.$w=b;var a;(function(C){function p(){return e.$w}C.value=p;function v(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}C.isDefaultVariant=v;function N(){return e.$w==="en"}C.isDefault=N})(a||(e.Language=a={})),e.$x=k,e.$y=c,e.$z=g,e.$A=typeof m.postMessage=="function"&&!m.importScripts,e.$B=(()=>{if(e.$A){const C=[];m.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let N=0,T=C.length;N<T;N++){const M=C[N];if(M.id===v.data.vscodeScheduleAsyncWork){C.splice(N,1),M.callback();return}}});let p=0;return v=>{const N=++p;C.push({id:N,callback:v}),m.postMessage({vscodeScheduleAsyncWork:N},"*")}}return C=>setTimeout(C)})();var w;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(w||(e.OperatingSystem=w={})),e.OS=A||I?w.Macintosh:h?w.Windows:w.Linux;let y=!0,S=!1;function D(){if(!S){S=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,y=new Uint16Array(C.buffer)[0]===513}return y}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function P(C){return parseFloat(C)>=20}}),define(Ee[56],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gc=e.$fc=e.env=e.cwd=void 0;let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const R=A.process;h={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?h={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:h={get platform(){return r.$i?"win32":r.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=h.cwd,e.env=h.env,e.$fc=h.platform,e.$gc=h.arch}),define(Ee[16],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.sep=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=void 0,r=We(r);const h=65,A=97,R=90,L=122,O=46,$=47,l=92,I=58,E=63;class u extends Error{constructor(s,f,a){let w;typeof f=="string"&&f.indexOf("not ")===0?(w="must not be",f=f.replace(/^not /,"")):w="must be";const y=s.indexOf(".")!==-1?"property":"argument";let S=`The "${s}" ${y} ${w} of type ${f}`;S+=`. Received type ${typeof a}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function k(t,s){if(t===null||typeof t!="object")throw new u(s,"Object",t)}function b(t,s){if(typeof t!="string")throw new u(s,"string",t)}const c=r.$fc==="win32";function g(t){return t===$||t===l}function d(t){return t===$}function m(t){return t>=h&&t<=R||t>=A&&t<=L}function n(t,s,f,a){let w="",y=0,S=-1,D=0,P=0;for(let C=0;C<=t.length;++C){if(C<t.length)P=t.charCodeAt(C);else{if(a(P))break;P=$}if(a(P)){if(!(S===C-1||D===1))if(D===2){if(w.length<2||y!==2||w.charCodeAt(w.length-1)!==O||w.charCodeAt(w.length-2)!==O){if(w.length>2){const p=w.lastIndexOf(f);p===-1?(w="",y=0):(w=w.slice(0,p),y=w.length-1-w.lastIndexOf(f)),S=C,D=0;continue}else if(w.length!==0){w="",y=0,S=C,D=0;continue}}s&&(w+=w.length>0?`${f}..`:"..",y=2)}else w.length>0?w+=`${f}${t.slice(S+1,C)}`:w=t.slice(S+1,C),y=C-S-1;S=C,D=0}else P===O&&D!==-1?++D:D=-1}return w}function o(t,s){k(s,"pathObject");const f=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return f?f===s.root?`${f}${a}`:`${f}${t}${a}`:a}e.$hc={resolve(...t){let s="",f="",a=!1;for(let w=t.length-1;w>=-1;w--){let y;if(w>=0){if(y=t[w],b(y,"path"),y.length===0)continue}else s.length===0?y=r.cwd():(y=r.env[`=${s}`]||r.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==s.toLowerCase()&&y.charCodeAt(2)===l)&&(y=`${s}\\`));const S=y.length;let D=0,P="",C=!1;const p=y.charCodeAt(0);if(S===1)g(p)&&(D=1,C=!0);else if(g(p))if(C=!0,g(y.charCodeAt(1))){let v=2,N=v;for(;v<S&&!g(y.charCodeAt(v));)v++;if(v<S&&v!==N){const T=y.slice(N,v);for(N=v;v<S&&g(y.charCodeAt(v));)v++;if(v<S&&v!==N){for(N=v;v<S&&!g(y.charCodeAt(v));)v++;(v===S||v!==N)&&(P=`\\\\${T}\\${y.slice(N,v)}`,D=v)}}}else D=1;else m(p)&&y.charCodeAt(1)===I&&(P=y.slice(0,2),D=2,S>2&&g(y.charCodeAt(2))&&(C=!0,D=3));if(P.length>0)if(s.length>0){if(P.toLowerCase()!==s.toLowerCase())continue}else s=P;if(a){if(s.length>0)break}else if(f=`${y.slice(D)}\\${f}`,a=C,C&&s.length>0)break}return f=n(f,!a,"\\",g),a?`${s}\\${f}`:`${s}${f}`||"."},normalize(t){b(t,"path");const s=t.length;if(s===0)return".";let f=0,a,w=!1;const y=t.charCodeAt(0);if(s===1)return d(y)?"\\":t;if(g(y))if(w=!0,g(t.charCodeAt(1))){let D=2,P=D;for(;D<s&&!g(t.charCodeAt(D));)D++;if(D<s&&D!==P){const C=t.slice(P,D);for(P=D;D<s&&g(t.charCodeAt(D));)D++;if(D<s&&D!==P){for(P=D;D<s&&!g(t.charCodeAt(D));)D++;if(D===s)return`\\\\${C}\\${t.slice(P)}\\`;D!==P&&(a=`\\\\${C}\\${t.slice(P,D)}`,f=D)}}}else f=1;else m(y)&&t.charCodeAt(1)===I&&(a=t.slice(0,2),f=2,s>2&&g(t.charCodeAt(2))&&(w=!0,f=3));let S=f<s?n(t.slice(f),!w,"\\",g):"";return S.length===0&&!w&&(S="."),S.length>0&&g(t.charCodeAt(s-1))&&(S+="\\"),a===void 0?w?`\\${S}`:S:w?`${a}\\${S}`:`${a}${S}`},isAbsolute(t){b(t,"path");const s=t.length;if(s===0)return!1;const f=t.charCodeAt(0);return g(f)||s>2&&m(f)&&t.charCodeAt(1)===I&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,f;for(let y=0;y<t.length;++y){const S=t[y];b(S,"path"),S.length>0&&(s===void 0?s=f=S:s+=`\\${S}`)}if(s===void 0)return".";let a=!0,w=0;if(typeof f=="string"&&g(f.charCodeAt(0))){++w;const y=f.length;y>1&&g(f.charCodeAt(1))&&(++w,y>2&&(g(f.charCodeAt(2))?++w:a=!1))}if(a){for(;w<s.length&&g(s.charCodeAt(w));)w++;w>=2&&(s=`\\${s.slice(w)}`)}return e.$hc.normalize(s)},relative(t,s){if(b(t,"from"),b(s,"to"),t===s)return"";const f=e.$hc.resolve(t),a=e.$hc.resolve(s);if(f===a||(t=f.toLowerCase(),s=a.toLowerCase(),t===s))return"";let w=0;for(;w<t.length&&t.charCodeAt(w)===l;)w++;let y=t.length;for(;y-1>w&&t.charCodeAt(y-1)===l;)y--;const S=y-w;let D=0;for(;D<s.length&&s.charCodeAt(D)===l;)D++;let P=s.length;for(;P-1>D&&s.charCodeAt(P-1)===l;)P--;const C=P-D,p=S<C?S:C;let v=-1,N=0;for(;N<p;N++){const M=t.charCodeAt(w+N);if(M!==s.charCodeAt(D+N))break;M===l&&(v=N)}if(N!==p){if(v===-1)return a}else{if(C>p){if(s.charCodeAt(D+N)===l)return a.slice(D+N+1);if(N===2)return a.slice(D+N)}S>p&&(t.charCodeAt(w+N)===l?v=N:N===2&&(v=3)),v===-1&&(v=0)}let T="";for(N=w+v+1;N<=y;++N)(N===y||t.charCodeAt(N)===l)&&(T+=T.length===0?"..":"\\..");return D+=v,T.length>0?`${T}${a.slice(D,P)}`:(a.charCodeAt(D)===l&&++D,a.slice(D,P))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$hc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const f=s.charCodeAt(2);if(f!==E&&f!==O)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(m(s.charCodeAt(0))&&s.charCodeAt(1)===I&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return t},dirname(t){b(t,"path");const s=t.length;if(s===0)return".";let f=-1,a=0;const w=t.charCodeAt(0);if(s===1)return g(w)?t:".";if(g(w)){if(f=a=1,g(t.charCodeAt(1))){let D=2,P=D;for(;D<s&&!g(t.charCodeAt(D));)D++;if(D<s&&D!==P){for(P=D;D<s&&g(t.charCodeAt(D));)D++;if(D<s&&D!==P){for(P=D;D<s&&!g(t.charCodeAt(D));)D++;if(D===s)return t;D!==P&&(f=a=D+1)}}}}else m(w)&&t.charCodeAt(1)===I&&(f=s>2&&g(t.charCodeAt(2))?3:2,a=f);let y=-1,S=!0;for(let D=s-1;D>=a;--D)if(g(t.charCodeAt(D))){if(!S){y=D;break}}else S=!1;if(y===-1){if(f===-1)return".";y=f}return t.slice(0,y)},basename(t,s){s!==void 0&&b(s,"ext"),b(t,"path");let f=0,a=-1,w=!0,y;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(f=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let S=s.length-1,D=-1;for(y=t.length-1;y>=f;--y){const P=t.charCodeAt(y);if(g(P)){if(!w){f=y+1;break}}else D===-1&&(w=!1,D=y+1),S>=0&&(P===s.charCodeAt(S)?--S===-1&&(a=y):(S=-1,a=D))}return f===a?a=D:a===-1&&(a=t.length),t.slice(f,a)}for(y=t.length-1;y>=f;--y)if(g(t.charCodeAt(y))){if(!w){f=y+1;break}}else a===-1&&(w=!1,a=y+1);return a===-1?"":t.slice(f,a)},extname(t){b(t,"path");let s=0,f=-1,a=0,w=-1,y=!0,S=0;t.length>=2&&t.charCodeAt(1)===I&&m(t.charCodeAt(0))&&(s=a=2);for(let D=t.length-1;D>=s;--D){const P=t.charCodeAt(D);if(g(P)){if(!y){a=D+1;break}continue}w===-1&&(y=!1,w=D+1),P===O?f===-1?f=D:S!==1&&(S=1):f!==-1&&(S=-1)}return f===-1||w===-1||S===0||S===1&&f===w-1&&f===a+1?"":t.slice(f,w)},format:o.bind(null,"\\"),parse(t){b(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const f=t.length;let a=0,w=t.charCodeAt(0);if(f===1)return g(w)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(g(w)){if(a=1,g(t.charCodeAt(1))){let v=2,N=v;for(;v<f&&!g(t.charCodeAt(v));)v++;if(v<f&&v!==N){for(N=v;v<f&&g(t.charCodeAt(v));)v++;if(v<f&&v!==N){for(N=v;v<f&&!g(t.charCodeAt(v));)v++;v===f?a=v:v!==N&&(a=v+1)}}}}else if(m(w)&&t.charCodeAt(1)===I){if(f<=2)return s.root=s.dir=t,s;if(a=2,g(t.charCodeAt(2))){if(f===3)return s.root=s.dir=t,s;a=3}}a>0&&(s.root=t.slice(0,a));let y=-1,S=a,D=-1,P=!0,C=t.length-1,p=0;for(;C>=a;--C){if(w=t.charCodeAt(C),g(w)){if(!P){S=C+1;break}continue}D===-1&&(P=!1,D=C+1),w===O?y===-1?y=C:p!==1&&(p=1):y!==-1&&(p=-1)}return D!==-1&&(y===-1||p===0||p===1&&y===D-1&&y===S+1?s.base=s.name=t.slice(S,D):(s.name=t.slice(S,y),s.base=t.slice(S,D),s.ext=t.slice(y,D))),S>0&&S!==a?s.dir=t.slice(0,S-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(c){const t=/\\/g;return()=>{const s=r.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>r.cwd()})();e.$ic={resolve(...t){let s="",f=!1;for(let a=t.length-1;a>=-1&&!f;a--){const w=a>=0?t[a]:i();b(w,"path"),w.length!==0&&(s=`${w}/${s}`,f=w.charCodeAt(0)===$)}return s=n(s,!f,"/",d),f?`/${s}`:s.length>0?s:"."},normalize(t){if(b(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$,f=t.charCodeAt(t.length-1)===$;return t=n(t,!s,"/",d),t.length===0?s?"/":f?"./":".":(f&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return b(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let s;for(let f=0;f<t.length;++f){const a=t[f];b(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.$ic.normalize(s)},relative(t,s){if(b(t,"from"),b(s,"to"),t===s||(t=e.$ic.resolve(t),s=e.$ic.resolve(s),t===s))return"";const f=1,a=t.length,w=a-f,y=1,S=s.length-y,D=w<S?w:S;let P=-1,C=0;for(;C<D;C++){const v=t.charCodeAt(f+C);if(v!==s.charCodeAt(y+C))break;v===$&&(P=C)}if(C===D)if(S>D){if(s.charCodeAt(y+C)===$)return s.slice(y+C+1);if(C===0)return s.slice(y+C)}else w>D&&(t.charCodeAt(f+C)===$?P=C:C===0&&(P=0));let p="";for(C=f+P+1;C<=a;++C)(C===a||t.charCodeAt(C)===$)&&(p+=p.length===0?"..":"/..");return`${p}${s.slice(y+P)}`},toNamespacedPath(t){return t},dirname(t){if(b(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===$;let f=-1,a=!0;for(let w=t.length-1;w>=1;--w)if(t.charCodeAt(w)===$){if(!a){f=w;break}}else a=!1;return f===-1?s?"/":".":s&&f===1?"//":t.slice(0,f)},basename(t,s){s!==void 0&&b(s,"ext"),b(t,"path");let f=0,a=-1,w=!0,y;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let S=s.length-1,D=-1;for(y=t.length-1;y>=0;--y){const P=t.charCodeAt(y);if(P===$){if(!w){f=y+1;break}}else D===-1&&(w=!1,D=y+1),S>=0&&(P===s.charCodeAt(S)?--S===-1&&(a=y):(S=-1,a=D))}return f===a?a=D:a===-1&&(a=t.length),t.slice(f,a)}for(y=t.length-1;y>=0;--y)if(t.charCodeAt(y)===$){if(!w){f=y+1;break}}else a===-1&&(w=!1,a=y+1);return a===-1?"":t.slice(f,a)},extname(t){b(t,"path");let s=-1,f=0,a=-1,w=!0,y=0;for(let S=t.length-1;S>=0;--S){const D=t.charCodeAt(S);if(D===$){if(!w){f=S+1;break}continue}a===-1&&(w=!1,a=S+1),D===O?s===-1?s=S:y!==1&&(y=1):s!==-1&&(y=-1)}return s===-1||a===-1||y===0||y===1&&s===a-1&&s===f+1?"":t.slice(s,a)},format:o.bind(null,"/"),parse(t){b(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const f=t.charCodeAt(0)===$;let a;f?(s.root="/",a=1):a=0;let w=-1,y=0,S=-1,D=!0,P=t.length-1,C=0;for(;P>=a;--P){const p=t.charCodeAt(P);if(p===$){if(!D){y=P+1;break}continue}S===-1&&(D=!1,S=P+1),p===O?w===-1?w=P:C!==1&&(C=1):w!==-1&&(C=-1)}if(S!==-1){const p=y===0&&f?1:y;w===-1||C===0||C===1&&w===S-1&&w===y+1?s.base=s.name=t.slice(p,S):(s.name=t.slice(p,w),s.base=t.slice(p,S),s.ext=t.slice(w,S))}return y>0?s.dir=t.slice(0,y-1):f&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$ic.win32=e.$hc.win32=e.$hc,e.$ic.posix=e.$hc.posix=e.$ic,e.$jc=c?e.$hc.normalize:e.$ic.normalize,e.$kc=c?e.$hc.isAbsolute:e.$ic.isAbsolute,e.$lc=c?e.$hc.join:e.$ic.join,e.$mc=c?e.$hc.resolve:e.$ic.resolve,e.$nc=c?e.$hc.relative:e.$ic.relative,e.$oc=c?e.$hc.dirname:e.$ic.dirname,e.$pc=c?e.$hc.basename:e.$ic.basename,e.$qc=c?e.$hc.extname:e.$ic.extname,e.$rc=c?e.$hc.format:e.$ic.format,e.$sc=c?e.$hc.parse:e.$ic.parse,e.$tc=c?e.$hc.toNamespacedPath:e.$ic.toNamespacedPath,e.sep=c?e.$hc.sep:e.$ic.sep,e.$vc=c?e.$hc.delimiter:e.$ic.delimiter}),define(Ee[140],Se([1,0,49,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=O,e.$vr=$,e.$wr=l,e.$xr=I,e.$yr=E,e.$zr=u,e.$Ar=k,e.$Br=b,e.$Cr=c,e.$Dr=g,e.$Er=w,e.$Fr=y,e.$Gr=S;const A=new r.$X(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),R=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function O(D,P,C=!1){const p=D||"",v=P||"",N=A.value.collator.compare(p,v);return A.value.collatorIsNumeric&&N===0&&p!==v?p<v?-1:1:N}function $(D,P){const C=R.value.collator;return D=D||"",P=P||"",o(C,D,P)}function l(D,P){const C=R.value.collator;return D=D||"",P=P||"",f(D,P)||o(C,D,P)}function I(D,P){const C=R.value.collator;return D=D||"",P=P||"",s(D,P)||o(C,D,P)}function E(D,P){return D=D||"",P=P||"",D===P?0:D<P?-1:1}function u(D,P){const[C,p]=m(D),[v,N]=m(P);let T=A.value.collator.compare(p,N);if(T===0){if(A.value.collatorIsNumeric&&p!==N)return p<N?-1:1;if(T=A.value.collator.compare(C,v),A.value.collatorIsNumeric&&T===0&&C!==v)return C<v?-1:1}return T}function k(D,P){D=D||"",P=P||"";const C=n(D),p=n(P),v=R.value.collator,N=L.value.collator;return o(N,C,p)||o(v,D,P)}function b(D,P){D=D||"",P=P||"";const C=n(D),p=n(P),v=R.value.collator,N=L.value.collator;return o(N,C,p)||f(D,P)||o(v,D,P)}function c(D,P){D=D||"",P=P||"";const C=n(D),p=n(P),v=R.value.collator,N=L.value.collator;return o(N,C,p)||s(D,P)||o(v,D,P)}function g(D,P){D=D||"",P=P||"";const C=n(D).toLowerCase(),p=n(P).toLowerCase();return C!==p?C<p?-1:1:D!==P?D<P?-1:1:0}const d=/^(.*?)(\.([^.]*))?$/;function m(D,P=!1){const C=D?d.exec(D):[];let p=[C&&C[1]||"",C&&C[3]||""];return P&&(!p[0]&&p[1]||p[0]&&p[0].charAt(0)===".")&&(p=[p[0]+"."+p[1],""]),p}function n(D){const P=D?d.exec(D):[];return P&&P[1]&&P[1].charAt(0)!=="."&&P[3]||""}function o(D,P,C){const p=D.compare(P,C);return p!==0?p:P.length!==C.length?P.length<C.length?-1:1:0}function i(D){const P=D.charAt(0);return P.toLocaleUpperCase()!==P}function t(D){const P=D.charAt(0);return P.toLocaleLowerCase()!==P}function s(D,P){return i(D)&&t(P)?-1:t(D)&&i(P)?1:0}function f(D,P){return t(D)&&i(P)?-1:i(D)&&t(P)?1:0}function a(D,P,C=!1){return C||(D=D&&D.toLowerCase(),P=P&&P.toLowerCase()),D===P?0:D<P?-1:1}function w(D,P,C=!1){const p=D.split(h.sep),v=P.split(h.sep),N=p.length-1,T=v.length-1;let M,j;for(let z=0;;z++){if(M=N===z,j=T===z,M&&j)return O(p[z],v[z],C);if(M)return-1;if(j)return 1;const F=a(p[z],v[z],C);if(F!==0)return F}}function y(D,P,C){const p=D.toLowerCase(),v=P.toLowerCase(),N=S(D,P,C);if(N)return N;const T=p.endsWith(C),M=v.endsWith(C);if(T!==M)return T?-1:1;const j=O(p,v);return j!==0?j:p.localeCompare(v)}function S(D,P,C){const p=D.toLowerCase(),v=P.toLowerCase(),N=p.startsWith(C),T=v.startsWith(C);if(N!==T)return N?-1:1;if(N&&T){if(p.length<v.length)return-1;if(p.length>v.length)return 1}return 0}}),define(Ee[33],Se([1,0,27,16,11,13,18]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=O,e.$yg=$,e.$zg=l,e.$Ag=I,e.$Bg=E,e.$Cg=c,e.$Dg=g,e.$Eg=d,e.$Fg=m,e.$Gg=n,e.$Hg=o,e.$Ig=i,e.$Jg=t,e.$Kg=s,e.$Lg=f,e.$Mg=a,e.$Ng=S;function O(D){return D===r.CharCode.Slash||D===r.CharCode.Backslash}function $(D){return D.replace(/[\\/]/g,h.$ic.sep)}function l(D){return D.indexOf("/")===-1&&(D=$(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}function I(D,P=h.$ic.sep){if(!D)return"";const C=D.length,p=D.charCodeAt(0);if(O(p)){if(O(D.charCodeAt(1))&&!O(D.charCodeAt(2))){let N=3;const T=N;for(;N<C&&!O(D.charCodeAt(N));N++);if(T!==N&&!O(D.charCodeAt(N+1))){for(N+=1;N<C;N++)if(O(D.charCodeAt(N)))return D.slice(0,N+1).replace(/[\\/]/g,P)}}return P}else if(m(p)&&D.charCodeAt(1)===r.CharCode.Colon)return O(D.charCodeAt(2))?D.slice(0,2)+P:D.slice(0,2);let v=D.indexOf("://");if(v!==-1){for(v+=3;v<C;v++)if(O(D.charCodeAt(v)))return D.slice(0,v+1)}return""}function E(D){if(!A.$i||!D||D.length<5)return!1;let P=D.charCodeAt(0);if(P!==r.CharCode.Backslash||(P=D.charCodeAt(1),P!==r.CharCode.Backslash))return!1;let C=2;const p=C;for(;C<D.length&&(P=D.charCodeAt(C),P!==r.CharCode.Backslash);C++);return!(p===C||(P=D.charCodeAt(C+1),isNaN(P)||P===r.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,k=/[/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(D,P=A.$i){const C=P?u:k;return!(!D||D.length===0||/^\s+$/.test(D)||(C.lastIndex=0,C.test(D))||P&&b.test(D)||D==="."||D===".."||P&&D[D.length-1]==="."||P&&D.length!==D.trim().length||D.length>255)}function g(D,P,C){const p=D===P;return!C||p?p:!D||!P?!1:(0,R.$Gf)(D,P)}function d(D,P,C,p=h.sep){if(D===P)return!0;if(!D||!P||P.length>D.length)return!1;if(C){if(!(0,R.$Hf)(D,P))return!1;if(P.length===D.length)return!0;let N=P.length;return P.charAt(P.length-1)===p&&N--,D.charAt(N)===p}return P.charAt(P.length-1)!==p&&(P+=p),D.indexOf(P)===0}function m(D){return D>=r.CharCode.A&&D<=r.CharCode.Z||D>=r.CharCode.a&&D<=r.CharCode.z}function n(D,P){return A.$i&&D.endsWith(":")&&(D+=h.sep),(0,h.$kc)(D)||(D=(0,h.$lc)(P,D)),D=(0,h.$jc)(D),o(D)}function o(D){return A.$i?(D=(0,R.$of)(D,h.sep),D.endsWith(":")&&(D+=h.sep)):(D=(0,R.$of)(D,h.sep),D||(D=h.sep)),D}function i(D){const P=(0,h.$jc)(D);return A.$i?D.length>3?!1:t(P)&&(D.length===2||P.charCodeAt(2)===r.CharCode.Backslash):P===h.$ic.sep}function t(D,P=A.$i){return P?m(D.charCodeAt(0))&&D.charCodeAt(1)===r.CharCode.Colon:!1}function s(D,P=A.$i){return t(D,P)?D[0]:void 0}function f(D,P,C){return P.length>D.length?-1:D===P?0:(C&&(D=D.toLowerCase(),P=P.toLowerCase()),D.indexOf(P))}function a(D){const P=D.split(":");let C,p,v;for(const N of P){const T=Number(N);(0,L.$jg)(T)?p===void 0?p=T:v===void 0&&(v=T):C=C?[C,N].join(":"):N}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:p!==void 0?p:void 0,column:v!==void 0?v:p!==void 0?1:void 0}}const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(D,P,C=8){let p="";for(let N=0;N<C;N++){let T;N===0&&A.$i&&!P&&(C===3||C===4)?T=y:T=w,p+=T.charAt(Math.floor(Math.random()*T.length))}let v;return P?v=`${P}-${p}`:v=p,D?(0,h.$lc)(D,v):v}}),define(Ee[141],Se([1,0,27,140,135,60,16,11,13]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=E,e.$Ir=d,e.$Jr=a,e.$Kr=p,e.$Lr=z,e.$Mr=B;const l=0,I=[l,[]];function E(_,re,U,G){if(!_||!re)return I;const Q=_.length,ee=re.length;if(Q<ee)return I;const ue=_.toLowerCase();return u(re,U,ee,_,ue,Q,G)}function u(_,re,U,G,Q,ee,ue){const ne=[],De=[];for(let se=0;se<U;se++){const oe=se*ee,te=oe-ee,le=se>0,he=_[se],X=re[se];for(let ae=0;ae<ee;ae++){const pe=ae>0,be=oe+ae,Fe=be-1,Be=te+ae-1,ke=pe?ne[Fe]:0,Ie=le&&pe?ne[Be]:0,Oe=le&&pe?De[Be]:0;let q;!Ie&&le?q=0:q=k(he,X,G,Q,ae,Oe),q&&Ie+q>=ke&&(ue||le||Q.startsWith(re,ae))?(De[be]=Oe+1,ne[be]=Ie+q):(De[be]=l,ne[be]=ke)}}const $e=[];let K=U-1,W=ee-1;for(;K>=0&&W>=0;){const se=K*ee+W;De[se]===l||($e.push(W),K--),W--}return[ne[U*ee-1],$e.reverse()]}function k(_,re,U,G,Q,ee){let ue=0;if(!b(re,G[Q]))return ue;if(ue+=1,ee>0&&(ue+=ee*5),_===U[Q]&&(ue+=1),Q===0)ue+=8;else{const ne=c(U.charCodeAt(Q-1));ne?ue+=ne:(0,A.$Kk)(U.charCodeAt(Q))&&ee===0&&(ue+=2)}return ue}function b(_,re){return _===re?!0:_==="/"||_==="\\"?re==="/"||re==="\\":!1}function c(_){switch(_){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const g=[void 0,[]];function d(_,re,U=0,G=0){const Q=re;return Q.values&&Q.values.length>1?m(_,Q.values,U,G):n(_,re,U,G)}function m(_,re,U,G){let Q=0;const ee=[];for(const ue of re){const[ne,De]=n(_,ue,U,G);if(typeof ne!="number")return g;Q+=ne,ee.push(...De)}return[Q,P(ee)]}function n(_,re,U,G){const Q=(0,A.$Tk)(re.original,re.originalLowercase,U,_,_.toLowerCase(),G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,A.$Qk)(Q)]:g}const o=Object.freeze({score:0}),i=1<<18,t=1<<17,s=65536;function f(_,re,U,G){const Q=G.values?G.values:[G];return(0,R.$tj)({[G.normalized]:{values:Q.map(ue=>({value:ue.normalized,expectContiguousMatch:ue.expectContiguousMatch})),label:_,description:re,allowNonContiguousMatches:U}})}function a(_,re,U,G,Q){if(!_||!re.normalized)return o;const ee=G.getItemLabel(_);if(!ee)return o;const ue=G.getItemDescription(_),ne=f(ee,ue,U,re),De=Q[ne];if(De)return De;const $e=w(ee,ue,G.getItemPath(_),re,U);return Q[ne]=$e,$e}function w(_,re,U,G,Q){const ee=!U||!G.containsPathSeparator;return U&&(O.$k?G.pathNormalized===U:(0,$.$Gf)(G.pathNormalized,U))?{score:i,labelMatch:[{start:0,end:_.length}],descriptionMatch:re?[{start:0,end:re.length}]:void 0}:G.values&&G.values.length>1?y(_,re,U,G.values,ee,Q):S(_,re,U,G,ee,Q)}function y(_,re,U,G,Q,ee){let ue=0;const ne=[],De=[];for(const $e of G){const{score:K,labelMatch:W,descriptionMatch:se}=S(_,re,U,$e,Q,ee);if(K===l)return o;ue+=K,W&&ne.push(...W),se&&De.push(...se)}return{score:ue,labelMatch:P(ne),descriptionMatch:P(De)}}function S(_,re,U,G,Q,ee){if(Q||!re){const[ue,ne]=E(_,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if(ue){const De=(0,A.$Hk)(G.normalized,_);let $e;if(De){$e=t;const K=Math.round(G.normalized.length/_.length*100);$e+=K}else $e=s;return{score:$e+ue,labelMatch:De||D(ne)}}}if(re){let ue=re;U&&(ue=`${re}${L.sep}`);const ne=ue.length,De=`${ue}${_}`,[$e,K]=E(De,G.normalized,G.normalizedLowercase,ee&&!G.expectContiguousMatch);if($e){const W=D(K),se=[],oe=[];return W.forEach(te=>{te.start<ne&&te.end>ne?(se.push({start:0,end:te.end-ne}),oe.push({start:te.start,end:ne})):te.start>=ne?se.push({start:te.start-ne,end:te.end-ne}):oe.push(te)}),{score:$e,labelMatch:se,descriptionMatch:oe}}}return o}function D(_){const re=[];if(!_)return re;let U;for(const G of _)U&&U.end===G?U.end+=1:(U={start:G,end:G+1},re.push(U));return re}function P(_){const re=_.sort((Q,ee)=>Q.start-ee.start),U=[];let G;for(const Q of re)!G||!C(G,Q)?(G=Q,U.push(Q)):(G.start=Math.min(G.start,Q.start),G.end=Math.max(G.end,Q.end));return U}function C(_,re){return!(_.end<re.start||re.end<_.start)}function p(_,re,U,G,Q,ee){const ue=a(_,U,G,Q,ee),ne=a(re,U,G,Q,ee),De=ue.score,$e=ne.score;if((De===i||$e===i)&&De!==$e)return De===i?-1:1;if(De>s||$e>s){if(De!==$e)return De>$e?-1:1;if(De<t&&$e<t){const he=N(ue.labelMatch,ne.labelMatch);if(he!==0)return he}const te=Q.getItemLabel(_)||"",le=Q.getItemLabel(re)||"";if(te.length!==le.length)return te.length-le.length}if(De!==$e)return De>$e?-1:1;const K=Array.isArray(ue.labelMatch)&&ue.labelMatch.length>0,W=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(K&&!W)return-1;if(W&&!K)return 1;const se=v(_,ue,Q),oe=v(re,ne,Q);return se&&oe&&se!==oe?oe>se?-1:1:T(_,re,U,Q)}function v(_,re,U){let G=-1,Q=-1;if(re.descriptionMatch&&re.descriptionMatch.length?G=re.descriptionMatch[0].start:re.labelMatch&&re.labelMatch.length&&(G=re.labelMatch[0].start),re.labelMatch&&re.labelMatch.length){if(Q=re.labelMatch[re.labelMatch.length-1].end,re.descriptionMatch&&re.descriptionMatch.length){const ee=U.getItemDescription(_);ee&&(Q+=ee.length)}}else re.descriptionMatch&&re.descriptionMatch.length&&(Q=re.descriptionMatch[re.descriptionMatch.length-1].end);return Q-G}function N(_,re){if(!_&&!re||(!_||!_.length)&&(!re||!re.length))return 0;if(!re||!re.length)return-1;if(!_||!_.length)return 1;const U=_[0].start,Q=_[_.length-1].end-U,ee=re[0].start,ne=re[re.length-1].end-ee;return Q===ne?0:ne<Q?1:-1}function T(_,re,U,G){const Q=G.getItemLabel(_)||"",ee=G.getItemLabel(re)||"",ue=G.getItemDescription(_),ne=G.getItemDescription(re),De=Q.length+(ue?ue.length:0),$e=ee.length+(ne?ne.length:0);if(De!==$e)return De-$e;const K=G.getItemPath(_),W=G.getItemPath(re);return K&&W&&K.length!==W.length?K.length-W.length:Q!==ee?(0,h.$Fr)(Q,ee,U.normalized):ue&&ne&&ue!==ne?(0,h.$Fr)(ue,ne,U.normalized):K&&W&&K!==W?(0,h.$Fr)(K,W,U.normalized):0}function M(_){return _.startsWith('"')&&_.endsWith('"')}const j=" ";function z(_){typeof _!="string"&&(_="");const re=_.toLowerCase(),{pathNormalized:U,normalized:G,normalizedLowercase:Q}=F(_),ee=U.indexOf(L.sep)>=0,ue=M(_);let ne;const De=_.split(j);if(De.length>1)for(const $e of De){const K=M($e),{pathNormalized:W,normalized:se,normalizedLowercase:oe}=F($e);se&&(ne||(ne=[]),ne.push({original:$e,originalLowercase:$e.toLowerCase(),pathNormalized:W,normalized:se,normalizedLowercase:oe,expectContiguousMatch:K}))}return{original:_,originalLowercase:re,pathNormalized:U,normalized:G,normalizedLowercase:Q,values:ne,containsPathSeparator:ee,expectContiguousMatch:ue}}function F(_){let re;O.$i?re=_.replace(/\//g,L.sep):re=_.replace(/\\/g,L.sep);const U=(0,$.$qf)(re).replace(/\s|"/g,"");return{pathNormalized:re,normalized:U,normalizedLowercase:U.toLowerCase()}}function B(_){return Array.isArray(_)?z(_.map(re=>re.original).join(j)):z(_.original)}}),define(Ee[108],Se([1,0,16]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$6s=R,e.$7s=L,e.$8s=O,e.$9s=l,e.$5s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const h={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(I){const E=(0,r.$qc)(I),u=h[E.toLowerCase()];return u!==void 0?u:L(I)}function L(I){const E=(0,r.$qc)(I);return A[E.toLowerCase()]}function O(I){for(const E in A)if(A[E]===I)return E}const $=/^(.+)\/(.+?)(;.+)?$/;function l(I,E){const u=$.exec(I);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:E?void 0:I}}),define(Ee[109],Se([1,0,11]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=R,e.$lm=L;var h;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(h||(e.Source=h={}));var A;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function R(O,...$){const l=$.reduce((u,k)=>(u[k]=!0,u),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(u=>!l[u]).forEach(u=>{for(let k=0;k<I.length;k++)if(u.search(I[k])!==-1){delete O[u];break}})}function L(O){O&&(delete O.DEBUG,r.$j&&delete O.DYLD_LIBRARY_PATH,r.$k&&delete O.LD_PRELOAD)}}),define(Ee[2],Se([1,0,27,41,16,11]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$xc=g,e.$yc=t,A=We(A);const L=/^\w[\w\d+.-]*$/,O=/^\//,$=/^\/\//;function l(y,S){if(!y.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!L.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!O.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,S){return!y&&!S?"file":y}function E(y,S){switch(y){case"https":case"http":case"file":S?S[0]!==k&&(S=k+S):S=k;break}return S}const u="",k="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(S){return S instanceof c?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,D,P,C,p,v=!1){typeof S=="object"?(this.scheme=S.scheme||u,this.authority=S.authority||u,this.path=S.path||u,this.query=S.query||u,this.fragment=S.fragment||u):(this.scheme=I(S,v),this.authority=D||u,this.path=E(this.scheme,P||u),this.query=C||u,this.fragment=p||u,l(this,v))}get fsPath(){return t(this,!1)}with(S){if(!S)return this;let{scheme:D,authority:P,path:C,query:p,fragment:v}=S;return D===void 0?D=this.scheme:D===null&&(D=u),P===void 0?P=this.authority:P===null&&(P=u),C===void 0?C=this.path:C===null&&(C=u),p===void 0?p=this.query:p===null&&(p=u),v===void 0?v=this.fragment:v===null&&(v=u),D===this.scheme&&P===this.authority&&C===this.path&&p===this.query&&v===this.fragment?this:new m(D,P,C,p,v)}static parse(S,D=!1){const P=b.exec(S);return P?new m(P[2]||u,w(P[4]||u),w(P[5]||u),w(P[7]||u),w(P[9]||u),D):new m(u,u,u,u,u)}static file(S){let D=u;if(R.$i&&(S=S.replace(/\\/g,k)),S[0]===k&&S[1]===k){const P=S.indexOf(k,2);P===-1?(D=S.substring(2),S=k):(D=S.substring(2,P),S=S.substring(P)||k)}return new m("file",D,S,u,u)}static from(S,D){return new m(S.scheme,S.authority,S.path,S.query,S.fragment,D)}static joinPath(S,...D){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let P;return R.$i&&S.scheme==="file"?P=c.file(A.$hc.join(t(S,!0),...D)).path:P=A.$ic.join(S.path,...D),S.with({path:P})}toString(S=!1){return s(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof c)return S;{const D=new m(S);return D._formatted=S.external??null,D._fsPath=S._sep===d?S.fsPath??null:null,D}}else return S}}e.URI=c;function g(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const d=R.$i?1:void 0;class m extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(S=!1){return S?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const S={$mid:h.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=d),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const n={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(y,S,D){let P,C=-1;for(let p=0;p<y.length;p++){const v=y.charCodeAt(p);if(v>=r.CharCode.a&&v<=r.CharCode.z||v>=r.CharCode.A&&v<=r.CharCode.Z||v>=r.CharCode.Digit0&&v<=r.CharCode.Digit9||v===r.CharCode.Dash||v===r.CharCode.Period||v===r.CharCode.Underline||v===r.CharCode.Tilde||S&&v===r.CharCode.Slash||D&&v===r.CharCode.OpenSquareBracket||D&&v===r.CharCode.CloseSquareBracket||D&&v===r.CharCode.Colon)C!==-1&&(P+=encodeURIComponent(y.substring(C,p)),C=-1),P!==void 0&&(P+=y.charAt(p));else{P===void 0&&(P=y.substr(0,p));const N=n[v];N!==void 0?(C!==-1&&(P+=encodeURIComponent(y.substring(C,p)),C=-1),P+=N):C===-1&&(C=p)}}return C!==-1&&(P+=encodeURIComponent(y.substring(C))),P!==void 0?P:y}function i(y){let S;for(let D=0;D<y.length;D++){const P=y.charCodeAt(D);P===r.CharCode.Hash||P===r.CharCode.QuestionMark?(S===void 0&&(S=y.substr(0,D)),S+=n[P]):S!==void 0&&(S+=y[D])}return S!==void 0?S:y}function t(y,S){let D;return y.authority&&y.path.length>1&&y.scheme==="file"?D=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===r.CharCode.Slash&&(y.path.charCodeAt(1)>=r.CharCode.A&&y.path.charCodeAt(1)<=r.CharCode.Z||y.path.charCodeAt(1)>=r.CharCode.a&&y.path.charCodeAt(1)<=r.CharCode.z)&&y.path.charCodeAt(2)===r.CharCode.Colon?S?D=y.path.substr(1):D=y.path[1].toLowerCase()+y.path.substr(2):D=y.path,R.$i&&(D=D.replace(/\//g,"\\")),D}function s(y,S){const D=S?i:o;let P="",{scheme:C,authority:p,path:v,query:N,fragment:T}=y;if(C&&(P+=C,P+=":"),(p||C==="file")&&(P+=k,P+=k),p){let M=p.indexOf("@");if(M!==-1){const j=p.substr(0,M);p=p.substr(M+1),M=j.lastIndexOf(":"),M===-1?P+=D(j,!1,!1):(P+=D(j.substr(0,M),!1,!1),P+=":",P+=D(j.substr(M+1),!1,!0)),P+="@"}p=p.toLowerCase(),M=p.lastIndexOf(":"),M===-1?P+=D(p,!1,!0):(P+=D(p.substr(0,M),!1,!0),P+=p.substr(M))}if(v){if(v.length>=3&&v.charCodeAt(0)===r.CharCode.Slash&&v.charCodeAt(2)===r.CharCode.Colon){const M=v.charCodeAt(1);M>=r.CharCode.A&&M<=r.CharCode.Z&&(v=`/${String.fromCharCode(M+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===r.CharCode.Colon){const M=v.charCodeAt(0);M>=r.CharCode.A&&M<=r.CharCode.Z&&(v=`${String.fromCharCode(M+32)}:${v.substr(2)}`)}P+=D(v,!0,!1)}return N&&(P+="?",P+=D(N,!1,!1)),T&&(P+="#",P+=S?T:o(T,!1,!1)),P}function f(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+f(y.substr(3)):y}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function w(y){return y.match(a)?y.replace(a,S=>f(S)):y}}),define(Ee[206],Se([1,0,2]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=h,e.$$q=A,e.$_q=R,e.log=O;function h(l){const I=l;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function A(l){const I=[];let E;try{const u=JSON.parse(l.arguments),k=u[u.length-1];k&&k.__$stack&&(u.pop(),E=k.__$stack),I.push(...u)}catch{I.push("Unable to log remote console arguments",l.arguments)}return{args:I,stack:E}}function R(l){if(typeof l!="string")return R(A(l).stack);const I=l;if(I){const E=L(I),u=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(u&&u.length===4)return{uri:r.URI.file(u[1]),line:Number(u[2]),column:Number(u[3])}}}function L(l){if(!l)return l;const I=l.indexOf(`
`);return I===-1?l:l.substring(0,I)}function O(l,I){const{args:E,stack:u}=A(l),k=typeof E[0]=="string"&&E.length===1;let b=L(u);b&&(b=`(${b.trim()})`);let c=[];if(typeof E[0]=="string"?b&&k?c=[`%c[${I}] %c${E[0]} %c${b}`,$("blue"),$(""),$("grey")]:c=[`%c[${I}] %c${E[0]}`,$("blue"),$(""),...E.slice(1)]:c=[`%c[${I}]%`,$("blue"),...E],b&&!k&&c.push(b),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,c)}function $(l){return`color: ${l}`}}),define(Ee[57],Se([1,0,22,2,41]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=R,e.$bi=L,e.$ci=$;function R(l){return JSON.stringify(l,O)}function L(l){let I=JSON.parse(l);return I=$(I),I}function O(l,I){return I instanceof RegExp?{$mid:A.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function $(l,I=0){if(!l||I>200)return l;if(typeof l=="object"){switch(l.$mid){case A.MarshalledId.Uri:return h.URI.revive(l);case A.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case A.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.$Oe||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let E=0;E<l.length;++E)l[E]=$(l[E],I+1);else for(const E in l)Object.hasOwnProperty.call(l,E)&&(l[E]=$(l[E],I+1))}return l}}),define(Ee[15],Se([1,0,14,11,13,2,16]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=$,e.$Pg=l,e.$Tg=E,r=We(r),h=We(h),L=We(L);var O;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatCodeBlock="vscode-chat-code-block",b.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",b.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm",b.commentsInput="comment",b.codeSetting="code-setting"})(O||(e.Schemas=O={}));function $(b,c){return R.URI.isUri(b)?(0,A.$Gf)(b.scheme,c):(0,A.$Hf)(b,c+":")}function l(b,...c){return c.some(g=>$(b,g))}e.$Qg="vscode-tkn",e.$Rg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=E(c,g)}getServerRootPath(){return this.f}get g(){return L.$ic.join(this.f,O.vscodeRemoteResource)}set(c,g,d){this.a[c]=g,this.b[c]=d}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(i){return r.$3(i),c}const g=c.authority;let d=this.a[g];d&&d.indexOf(":")!==-1&&d.indexOf("[")===-1&&(d=`[${d}]`);const m=this.b[g],n=this.c[g];let o=`path=${encodeURIComponent(c.path)}`;return typeof n=="string"&&(o+=`&${e.$Rg}=${encodeURIComponent(n)}`),R.URI.from({scheme:h.$o?this.d:O.vscodeRemoteResource,authority:`${d}:${m}`,path:this.g,query:o})}}e.$Sg=new I;function E(b,c){return L.$ic.join(c??"/",`${b.quality??"oss"}-${b.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(c){const g=this.b(c,ce);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$Sg.rewrite(c):c.scheme===O.file&&(h.$m||h.$q===`${O.vscodeFileResource}://${u.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||u.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,ce);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==u.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return R.URI.isUri(c)?c:R.URI.parse(g.toUrl(c))}}e.$Zg=new u;var k;(function(b){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function d(n){let o;typeof n=="string"?o=new URL(n).searchParams:n instanceof URL?o=n.searchParams:R.URI.isUri(n)&&(o=new URL(n.toString(!0)).searchParams);const i=o?.get(g);if(i)return c.get(i)}b.getHeadersFromQuery=d;function m(n,o,i){if(!globalThis.crossOriginIsolated)return;const t=o&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(g,t):n[g]=t}b.addSearchParam=m})(k||(e.COI=k={}))}),define(Ee[207],Se([1,0,173,15,11,2]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pE=I,A=We(A);class L{constructor(u,k,b){this.id=u,this.dependencies=k,this.callback=b}}class O{static{this.INSTANCE=new O}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,k,b)=>{typeof u!="string"&&(b=k,k=u,u=null),(typeof k!="object"||!Array.isArray(k))&&(b=k,k=null),this.c.push(new L(u,k,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const k=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!k)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(k.dependencies)&&k.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${k.dependencies.join(", ")}`);return typeof k.callback=="function"?k.callback([]):k.callback}h(u){return new Promise((k,b)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",d),c.removeEventListener("error",m)},d=n=>{g(),k(this.c.pop())},m=n=>{g(),b(n)};c.addEventListener("load",d),c.addEventListener("error",m),this.f&&(u=this.f.createScriptURL(u)),c.setAttribute("src",u),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(u){return new Promise((k,b)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),k(this.c.pop())}catch(c){b(c)}})}async j(u){try{const k=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=R.URI.parse(u).fsPath,d=k.readFileSync(g).toString(),m=c.wrap(d.replace(/^#!.*/,""));return new b.Script(m).runInThisContext().apply(),this.c.pop()}catch(k){throw k}}}const $=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function I(E,u,k){if(r.$V){k===void 0&&(k=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[E]&&(E=l[E]);const b=`${E}/${u}`;if($.has(b))return $.get(b);let c;if(/^\w[\w\d+.-]*:\/\//.test(b))c=b;else{const n=`${k&&!A.$o?h.$Wg:h.$Vg}/${b}`;c=h.$Zg.asBrowserUri(n).toString(!0)}const g=O.INSTANCE.load(c);return $.set(b,g),g}else return await new Promise((b,c)=>{ce([E],b,c)}).then(We)}}),define(Ee[23],Se([1,0,27,33,15,16,11,13,2]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=l,e.$ph=E,e.$qh=k,h=We(h),R=We(R);function l(b){return(0,$.$yc)(b,!0)}class I{constructor(c){this.a=c}compare(c,g,d=!1){return c===g?0:(0,O.$zf)(this.getComparisonKey(c,d),this.getComparisonKey(g,d))}isEqual(c,g,d=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,d)===this.getComparisonKey(g,d)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,d=!1){if(c.scheme===g.scheme){if(c.scheme===A.Schemas.file)return h.$Eg(l(c),l(g),this.a(c))&&c.query===g.query&&(d||c.fragment===g.fragment);if((0,e.$lh)(c.authority,g.authority))return h.$Eg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(d||c.fragment===g.fragment)}return!1}joinPath(c,...g){return $.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$dh)(c)||c.authority}basename(c){return R.$ic.basename(c.path)}extname(c){return R.$ic.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===A.Schemas.file?g=$.URI.file(R.$oc(l(c))).path:(g=R.$ic.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===A.Schemas.file?g=$.URI.file(R.$jc(l(c))).path:g=R.$ic.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$lh)(c.authority,g.authority))return;if(c.scheme===A.Schemas.file){const n=R.$nc(l(c),l(g));return L.$i?h.$yg(n):n}let d=c.path||"/";const m=g.path||"/";if(this.a(c)){let n=0;for(const o=Math.min(d.length,m.length);n<o&&!(d.charCodeAt(n)!==m.charCodeAt(n)&&d.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);d=m.substr(0,n)+d.substr(n)}return R.$ic.relative(d,m)}resolvePath(c,g){if(c.scheme===A.Schemas.file){const d=$.URI.file(R.$mc(l(c),g));return c.with({authority:d.authority,path:d.path})}return g=h.$zg(g),c.with({path:R.$ic.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,O.$Gf)(c,g)}hasTrailingPathSeparator(c,g=R.sep){if(c.scheme===A.Schemas.file){const d=l(c);return d.length>h.$Ag(d).length&&d[d.length-1]===g}else{const d=c.path;return d.length>1&&d.charCodeAt(d.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=R.sep){return(0,e.$mh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=R.sep){let d=!1;if(c.scheme===A.Schemas.file){const m=l(c);d=m!==void 0&&m.length===h.$Ag(m).length&&m[m.length-1]===g}else{g="/";const m=c.path;d=m.length===1&&m.charCodeAt(m.length-1)===r.CharCode.Slash}return!d&&!(0,e.$mh)(c,g)?c.with({path:c.path+"/"}):c}}e.$8g=I,e.$9g=new I(()=>!1),e.$0g=new I(b=>b.scheme===A.Schemas.file?!L.$k:!0),e.$$g=new I(b=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function E(b,c){const g=[];for(let d=0;d<b.length;d++){const m=c(b[d]);b.some((n,o)=>o===d?!1:(0,e.$ah)(m,c(n)))||g.push(b[d])}return g}var u;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function c(g){const d=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(o=>{const[i,t]=o.split(":");i&&t&&d.set(i,t)});const n=g.path.substring(0,g.path.indexOf(";"));return n&&d.set(b.META_DATA_MIME,n),d}b.parseMetaData=c})(u||(e.DataUri=u={}));function k(b,c,g){if(c){let d=b.path;return d&&d[0]!==R.$ic.sep&&(d=R.$ic.sep+d),b.with({scheme:g,authority:c,path:d})}return b.with({scheme:g})}}),define(Ee[9],Se([1,0,21,14,4,3,23,11,184,49]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=I,e.$sh=E,e.$th=u,e.$uh=k,e.$vh=b,e.$wh=c,e.$xh=g,e.$yh=d,e.$Gh=y,e.$Hh=S,e.$Ih=D,e.$Jh=P,e.$Kh=C,e.$Zh=G,e.$8h=te;function I(he){return!!he&&typeof he.then=="function"}function E(he){const X=new r.$xe,ae=he(X.token),pe=new Promise((be,Fe)=>{const Be=X.token.onCancellationRequested(()=>{Be.dispose(),Fe(new h.$7)});Promise.resolve(ae).then(ke=>{Be.dispose(),X.dispose(),be(ke)},ke=>{Be.dispose(),X.dispose(),Fe(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then(be,Fe){return pe.then(be,Fe)}catch(be){return this.then(void 0,be)}finally(be){return pe.finally(be)}}}function u(he,X,ae){return new Promise((pe,be)=>{const Fe=X.onCancellationRequested(()=>{Fe.dispose(),pe(ae)});he.then(pe,be).finally(()=>Fe.dispose())})}function k(he,X){return new Promise((ae,pe)=>{const be=X.onCancellationRequested(()=>{be.dispose(),pe(new h.$7)});he.then(ae,pe).finally(()=>be.dispose())})}async function b(he){let X=-1;const ae=he.map((pe,be)=>pe.then(Fe=>(X=be,Fe)));try{return await Promise.race(ae)}finally{he.forEach((pe,be)=>{be!==X&&pe.cancel()})}}function c(he,X,ae){let pe;const be=setTimeout(()=>{pe?.(void 0),ae?.()},X);return Promise.race([he.finally(()=>clearTimeout(be)),new Promise(Fe=>pe=Fe)])}function g(he){return new Promise((X,ae)=>{const pe=he();I(pe)?pe.then(X,ae):X(pe)})}function d(){let he,X;return{promise:new Promise((pe,be)=>{he=pe,X=be}),resolve:he,reject:X}}class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const ae=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(ae,ae).then(pe)})}return new Promise((ae,pe)=>{this.b.then(ae,pe)})}return this.a=X(),new Promise((ae,pe)=>{this.a.then(be=>{this.a=null,ae(be)},be=>{this.a=null,pe(be)})})}dispose(){this.f=!0}}e.$zh=m;class n{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=n;class o{constructor(){this.a=new Map}queue(X,ae){const be=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(X)===be&&this.a.delete(X)});return this.a.set(X,be),be}}e.$Bh=o;const i=(he,X)=>{let ae=!0;const pe=setTimeout(()=>{ae=!1,X()},he);return{isTriggered:()=>ae,dispose:()=>{clearTimeout(pe),ae=!1}}},t=he=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,he())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class s{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,ae=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((be,Fe)=>{this.d=be,this.f=Fe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=ae===$.$he?t(pe):i(ae,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new h.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=s;class f{constructor(X){this.a=new s(X),this.b=new m}trigger(X,ae){return this.a.trigger(()=>this.b.queue(X),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=f;class a{constructor(){this.a=!1,this.b=new Promise((X,ae)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=a;class w extends a{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=w;function y(he,X){return X?new Promise((ae,pe)=>{const be=setTimeout(()=>{Fe.dispose(),ae()},he),Fe=X.onCancellationRequested(()=>{clearTimeout(be),Fe.dispose(),pe(new h.$7)})}):E(ae=>y(he,ae))}function S(he,X=0,ae){const pe=setTimeout(()=>{he(),ae&&be.dispose()},X),be=(0,R.$Uc)(()=>{clearTimeout(pe),ae?.deleteAndLeak(be)});return ae?.add(be),be}function D(he){const X=[];let ae=0;const pe=he.length;function be(){return ae<pe?he[ae++]():null}function Fe(Be){Be!=null&&X.push(Be);const ke=be();return ke?ke.then(Fe):Promise.resolve(X)}return Promise.resolve(null).then(Fe)}function P(he,X=pe=>!!pe,ae=null){let pe=0;const be=he.length,Fe=()=>{if(pe>=be)return Promise.resolve(ae);const Be=he[pe++];return Promise.resolve(Be()).then(Ie=>X(Ie)?Promise.resolve(Ie):Fe())};return Fe()}function C(he,X=pe=>!!pe,ae=null){if(he.length===0)return Promise.resolve(ae);let pe=he.length;const be=()=>{pe=-1;for(const Fe of he)Fe.cancel?.()};return new Promise((Fe,Be)=>{for(const ke of he)ke.then(Ie=>{--pe>=0&&X(Ie)?(be(),Fe(Ie)):pe===0&&Fe(ae)}).catch(Ie=>{--pe>=0&&(be(),Be(Ie))})})}class p{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new A.$me}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,pe)=>{this.g.push({factory:X,c:ae,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const ae=X.factory();ae.then(X.c,X.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=p;class v extends p{constructor(){super(1)}}e.$Mh=v;class N{constructor(){this.a=new Q,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=N;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new ne;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,ae=L.$9g){const pe=ae.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,ae,pe=L.$9g){const be=pe.getComparisonKey(X);let Fe=this.a.get(be);if(!Fe){Fe=new v;const Be=this.f++,ke=A.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(Be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$6c),this.d.set(Be,ke),this.a.set(be,Fe)}return Fe.queue(ae)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=T;class M{constructor(X,ae){this.b=!1,this.a=-1,typeof X=="function"&&typeof ae=="number"&&this.setIfNotSet(X,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,ae){if(this.b)throw new h.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},ae)}setIfNotSet(X,ae){if(this.b)throw new h.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},ae))}}e.$Ph=M;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,ae,pe=globalThis){if(this.f)throw new h.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=pe.setInterval(()=>{X()},ae);this.d=(0,R.$Uc)(()=>{pe.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=j;class z{constructor(X,ae){this.b=-1,this.a=X,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=z;class F{constructor(X,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=X,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class B extends z{constructor(X,ae){super(X,ae),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=B;class _ extends R.$Wc{constructor(X,ae){super(),this.g=X,this.h=ae,this.a=[],this.b=this.B(new R.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of X)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=_,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(he,X)=>{(0,O.$B)(()=>{if(ae)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Wh=(he,X,ae)=>{const pe=he.requestIdleCallback(X,typeof ae=="number"?{timeout:ae}:void 0);let be=!1;return{dispose(){be||(be=!0,he.cancelIdleCallback(pe))}}},e.$Vh=he=>(0,e.$Wh)(globalThis,he)}();class re{constructor(X,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=re;class U extends re{constructor(X){super(globalThis,X)}}e.$Yh=U;async function G(he,X,ae){let pe;for(let be=0;be<ae;be++)try{return await he()}catch(Fe){pe=Fe,await y(X)}throw pe}class Q{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,ae,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:ae},ae.then(()=>this.d(X),()=>this.d(X)),ae}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:ae,resolve:pe,reject:be}=d();this.b={run:X,promise:ae,promiseResolve:pe,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=Q;class ee{constructor(X,ae=()=>Date.now()){this.d=X,this.f=ae,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=ee;var ue;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(ue||(ue={}));class ne{get isRejected(){return this.d?.outcome===ue.Rejected}get isResolved(){return this.d?.outcome===ue.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ue.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,ae)=>{this.a=X,this.b=ae})}complete(X){return new Promise(ae=>{this.a(X),this.d={outcome:ue.Resolved,value:X},ae()})}error(X){return new Promise(ae=>{this.b(X),this.d={outcome:ue.Rejected,value:X},ae()})}cancel(){return this.error(new h.$7)}}e.$3h=ne;var De;(function(he){async function X(pe){let be;const Fe=await Promise.all(pe.map(Be=>Be.then(ke=>ke,ke=>{be||(be=ke)})));if(typeof be<"u")throw be;return Fe}he.settled=X;function ae(pe){return new Promise(async(be,Fe)=>{try{await pe(be,Fe)}catch(Be){Fe(Be)}})}he.withAsyncBody=ae})(De||(e.Promises=De={}));class $e{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new h.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=$e;class K{constructor(X){this.b=X,this.a=new l.$X(()=>new $e(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=K;var W;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(W||(W={}));class se{static fromArray(X){return new se(ae=>{ae.emitMany(X)})}static fromPromise(X){return new se(async ae=>{ae.emitMany(await X)})}static fromPromises(X){return new se(async ae=>{await Promise.all(X.map(async pe=>ae.emitOne(await pe)))})}static merge(X){return new se(async ae=>{await Promise.all(X.map(async pe=>{for await(const be of pe)ae.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(X,ae){this.a=W.Initial,this.b=[],this.d=null,this.f=ae,this.g=new A.$me,queueMicrotask(async()=>{const pe={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(X(pe)),this.k()}catch(be){this.l(be)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===W.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===W.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,ae){return new se(async pe=>{for await(const be of X)pe.emitOne(ae(be))})}map(X){return se.map(this,X)}static filter(X,ae){return new se(async pe=>{for await(const be of X)ae(be)&&pe.emitOne(be)})}filter(X){return se.filter(this,X)}static coalesce(X){return se.filter(X,ae=>!!ae)}coalesce(){return se.coalesce(this)}static async toPromise(X){const ae=[];for await(const pe of X)ae.push(pe);return ae}toPromise(){return se.toPromise(this)}h(X){this.a===W.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===W.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===W.Initial&&(this.a=W.DoneOK,this.g.fire())}l(X){this.a===W.Initial&&(this.a=W.DoneError,this.d=X,this.g.fire())}}e.$6h=se;class oe extends se{constructor(X,ae){super(ae),this.m=X}cancel(){this.m.cancel()}}e.$7h=oe;function te(he){const X=new r.$xe,ae=he(X.token);return new oe(X,async pe=>{const be=X.token.onCancellationRequested(()=>{be.dispose(),X.dispose(),pe.reject(new h.$7)});try{for await(const Fe of ae){if(X.token.isCancellationRequested)return;pe.emitOne(Fe)}be.dispose(),X.dispose()}catch(Fe){be.dispose(),X.dispose(),pe.reject(Fe)}})}class le{constructor(X){this.a=new ne,this.b=new se(be=>{if(ae){be.reject(ae);return}return pe&&be.emitMany(pe),this.d=Fe=>be.reject(Fe),this.f=Fe=>be.emitOne(Fe),this.a.p},X);let ae,pe;this.f=be=>{pe||(pe=[]),pe.push(be)},this.d=be=>{ae||(ae=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=le}),define(Ee[39],Se([1,0,19,9,27,33,29,16,11,13]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=I,e.$xk=c,e.$yk=N,e.$zk=T,e.$Ak=M,e.$Bk=j,e.$Ck=z,e.$Dk=re;function I(){return Object.create(null)}e.$vk="**",e.$wk="/";const E="[/\\\\]",u="[^/\\\\]",k=/\//g;function b(U,G){switch(U){case 0:return"";case 1:return`${u}*?`;default:return`(?:${E}|${u}+${E}${G?`|${E}${u}+`:""})*?`}}function c(U,G){if(!U)return[];const Q=[];let ee=!1,ue=!1,ne="";for(const De of U){switch(De){case G:if(!ee&&!ue){Q.push(ne),ne="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}ne+=De}return ne&&Q.push(ne),Q}function g(U){if(!U)return"";let G="";const Q=c(U,e.$wk);if(Q.every(ee=>ee===e.$vk))G=".*";else{let ee=!1;Q.forEach((ue,ne)=>{if(ue===e.$vk){if(ee)return;G+=b(2,ne===Q.length-1)}else{let De=!1,$e="",K=!1,W="";for(const se of ue){if(se!=="}"&&De){$e+=se;continue}if(K&&(se!=="]"||!W)){let oe;se==="-"?oe=se:(se==="^"||se==="!")&&!W?oe="^":se===e.$wk?oe="":oe=(0,l.$if)(se),W+=oe;continue}switch(se){case"{":De=!0;continue;case"[":K=!0;continue;case"}":{const te=`(?:${c($e,",").map(le=>g(le)).join("|")})`;G+=te,De=!1,$e="";break}case"]":{G+="["+W+"]",K=!1,W="";break}case"?":G+=u;continue;case"*":G+=b(1);continue;default:G+=(0,l.$if)(se)}}ne<Q.length-1&&(Q[ne+1]!==e.$vk||ne+2<Q.length)&&(G+=E)}ee=ue===e.$vk})}return G}const d=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.$Fc(1e4),f=function(){return!1},a=function(){return null};function w(U,G){if(!U)return a;let Q;typeof U!="string"?Q=U.pattern:Q=U,Q=Q.trim();const ee=`${Q}_${!!G.trimForExclusions}`;let ue=s.get(ee);if(ue)return y(ue,U);let ne;return d.test(Q)?ue=D(Q.substr(4),Q):(ne=m.exec(S(Q,G)))?ue=P(ne[1],Q):(G.trimForExclusions?o:n).test(Q)?ue=C(Q,G):(ne=i.exec(S(Q,G)))?ue=p(ne[1].substr(1),Q,!0):(ne=t.exec(S(Q,G)))?ue=p(ne[1],Q,!1):ue=v(Q),s.set(ee,ue),y(ue,U)}function y(U,G){if(typeof G=="string")return U;const Q=function(ee,ue){return(0,R.$Eg)(ee,G.base,!$.$k)?U((0,l.$nf)(ee.substr(G.base.length),O.sep),ue):null};return Q.allBasenames=U.allBasenames,Q.allPaths=U.allPaths,Q.basenames=U.basenames,Q.patterns=U.patterns,Q}function S(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function D(U,G){return function(Q,ee){return typeof Q=="string"&&Q.endsWith(U)?G:null}}function P(U,G){const Q=`/${U}`,ee=`\\${U}`,ue=function(De,$e){return typeof De!="string"?null:$e?$e===U?G:null:De===U||De.endsWith(Q)||De.endsWith(ee)?G:null},ne=[U];return ue.basenames=ne,ue.patterns=[G],ue.allBasenames=ne,ue}function C(U,G){const Q=_(U.slice(1,-1).split(",").map($e=>w($e,G)).filter($e=>$e!==a),U),ee=Q.length;if(!ee)return a;if(ee===1)return Q[0];const ue=function($e,K){for(let W=0,se=Q.length;W<se;W++)if(Q[W]($e,K))return U;return null},ne=Q.find($e=>!!$e.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const De=Q.reduce(($e,K)=>K.allPaths?$e.concat(K.allPaths):$e,[]);return De.length&&(ue.allPaths=De),ue}function p(U,G,Q){const ee=O.sep===O.$ic.sep,ue=ee?U:U.replace(k,O.sep),ne=O.sep+ue,De=O.$ic.sep+U;let $e;return Q?$e=function(K,W){return typeof K=="string"&&(K===ue||K.endsWith(ne)||!ee&&(K===U||K.endsWith(De)))?G:null}:$e=function(K,W){return typeof K=="string"&&(K===ue||!ee&&K===U)?G:null},$e.allPaths=[(Q?"*/":"./")+U],$e}function v(U){try{const G=new RegExp(`^${g(U)}$`);return function(Q){return G.lastIndex=0,typeof Q=="string"&&G.test(Q)?U:null}}catch{return a}}function N(U,G,Q){return!U||typeof G!="string"?!1:T(U)(G,void 0,Q)}function T(U,G={}){if(!U)return f;if(typeof U=="string"||M(U)){const Q=w(U,G);if(Q===a)return f;const ee=function(ue,ne){return!!Q(ue,ne)};return Q.allBasenames&&(ee.allBasenames=Q.allBasenames),Q.allPaths&&(ee.allPaths=Q.allPaths),ee}return F(U,G)}function M(U){const G=U;return G?typeof G.base=="string"&&typeof G.pattern=="string":!1}function j(U){return U.allBasenames||[]}function z(U){return U.allPaths||[]}function F(U,G){const Q=_(Object.getOwnPropertyNames(U).map($e=>B($e,U[$e],G)).filter($e=>$e!==a)),ee=Q.length;if(!ee)return a;if(!Q.some($e=>!!$e.requiresSiblings)){if(ee===1)return Q[0];const $e=function(se,oe){let te;for(let le=0,he=Q.length;le<he;le++){const X=Q[le](se,oe);if(typeof X=="string")return X;(0,h.$rh)(X)&&(te||(te=[]),te.push(X))}return te?(async()=>{for(const le of te){const he=await le;if(typeof he=="string")return he}return null})():null},K=Q.find(se=>!!se.allBasenames);K&&($e.allBasenames=K.allBasenames);const W=Q.reduce((se,oe)=>oe.allPaths?se.concat(oe.allPaths):se,[]);return W.length&&($e.allPaths=W),$e}const ue=function($e,K,W){let se,oe;for(let te=0,le=Q.length;te<le;te++){const he=Q[te];he.requiresSiblings&&W&&(K||(K=(0,O.$pc)($e)),se||(se=K.substr(0,K.length-(0,O.$qc)($e).length)));const X=he($e,K,se,W);if(typeof X=="string")return X;(0,h.$rh)(X)&&(oe||(oe=[]),oe.push(X))}return oe?(async()=>{for(const te of oe){const le=await te;if(typeof le=="string")return le}return null})():null},ne=Q.find($e=>!!$e.allBasenames);ne&&(ue.allBasenames=ne.allBasenames);const De=Q.reduce(($e,K)=>K.allPaths?$e.concat(K.allPaths):$e,[]);return De.length&&(ue.allPaths=De),ue}function B(U,G,Q){if(G===!1)return a;const ee=w(U,Q);if(ee===a)return a;if(typeof G=="boolean")return ee;if(G){const ue=G.when;if(typeof ue=="string"){const ne=(De,$e,K,W)=>{if(!W||!ee(De,$e))return null;const se=ue.replace("$(basename)",()=>K),oe=W(se);return(0,h.$rh)(oe)?oe.then(te=>te?U:null):oe?U:null};return ne.requiresSiblings=!0,ne}}return ee}function _(U,G){const Q=U.filter($e=>!!$e.basenames);if(Q.length<2)return U;const ee=Q.reduce(($e,K)=>{const W=K.basenames;return W?$e.concat(W):$e},[]);let ue;if(G){ue=[];for(let $e=0,K=ee.length;$e<K;$e++)ue.push(G)}else ue=Q.reduce(($e,K)=>{const W=K.patterns;return W?$e.concat(W):$e},[]);const ne=function($e,K){if(typeof $e!="string")return null;if(!K){let se;for(se=$e.length;se>0;se--){const oe=$e.charCodeAt(se-1);if(oe===A.CharCode.Slash||oe===A.CharCode.Backslash)break}K=$e.substr(se)}const W=ee.indexOf(K);return W!==-1?ue[W]:null};ne.basenames=ee,ne.patterns=ue,ne.allBasenames=ee;const De=U.filter($e=>!$e.basenames);return De.push(ne),De}function re(U,G){return(0,r.$wb)(U,G,(Q,ee)=>typeof Q=="string"&&typeof ee=="string"?Q===ee:typeof Q!="string"&&typeof ee!="string"?Q.base===ee.base&&Q.pattern===ee.pattern:!1)}}),define(Ee[86],Se([1,0,14,136,23,13,2]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=l,e.$5k=I,e.$6k=E,e.$7k=u,e.$8k=k,e.$9k=b,e.$0k=c,e.$$k=g;var O;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(O||(e.MarkdownStringTextNewlineStyle=O={}));class ${constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,r.$9)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=O.Paragraph){return this.value+=u(this.supportThemeIcons?(0,h.$Wk)(m):m).replace(/([ \t]+)/g,(o,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===O.Break?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+=`
${k(n,m)}
`,this}appendLink(m,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(m,n){const o=new RegExp((0,R.$if)(n),"g");return m.replace(o,(i,t)=>m.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$3k=$;function l(d){return I(d)?!d.value:Array.isArray(d)?d.every(l):!0}function I(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}function E(d,m){return d===m?!0:!d||!m?!1:d.value===m.value&&d.isTrusted===m.isTrusted&&d.supportThemeIcons===m.supportThemeIcons&&d.supportHtml===m.supportHtml&&(d.baseUri===m.baseUri||!!d.baseUri&&!!m.baseUri&&(0,A.$_g)(L.URI.from(d.baseUri),L.URI.from(m.baseUri)))}function u(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(d,m){const n=d.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,o=n>=3?n+1:3;return[`${"`".repeat(o)}${m}`,d,`${"`".repeat(o)}`].join(`
`)}function b(d){return d.replace(/"/g,"&quot;")}function c(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function g(d){const m=[],n=d.split("|").map(i=>i.trim());d=n[0];const o=n[1];if(o){const i=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),s=i?i[1]:"",f=t?t[1]:"",a=isFinite(parseInt(f)),w=isFinite(parseInt(s));a&&m.push(`width="${f}"`),w&&m.push(`height="${s}"`)}return{href:d,dimensions:m}}}),define(Ee[110],Se([1,0,19,33,16,11,23,13]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sw=$,e.$Tw=I,e.$Uw=u,e.$Vw=k,e.$Ww=d,e.$Xw=n,e.$Yw=o,e.$Zw=i,e.$1w=t,e.$2w=s;function $(a,w){const{os:y,tildify:S,relative:D}=w;if(D){const p=l(a,D,y);if(typeof p=="string")return p}let P=a.fsPath;if(y===R.OperatingSystem.Windows&&!R.$i?P=P.replace(/\//g,"\\"):y!==R.OperatingSystem.Windows&&R.$i&&(P=P.replace(/\\/g,"/")),y!==R.OperatingSystem.Windows&&S?.userHome){const p=S.userHome.fsPath;let v;a.scheme!==S.userHome.scheme&&a.path[0]===A.$ic.sep&&a.path[1]!==A.$ic.sep?v=S.userHome.with({path:a.path}).fsPath:v=P,P=u(v,p,y)}return(y===R.OperatingSystem.Windows?A.$hc:A.$ic).normalize(I(P,y===R.OperatingSystem.Windows))}function l(a,w,y){const S=y===R.OperatingSystem.Windows?A.$hc:A.$ic,D=y===R.OperatingSystem.Linux?L.$9g:L.$$g,P=w.getWorkspace(),C=(0,r.$Qb)(P.folders);if(!C)return;a.scheme!==C.uri.scheme&&a.path[0]===A.$ic.sep&&a.path[1]!==A.$ic.sep&&(a=C.uri.with({path:a.path}));const p=w.getWorkspaceFolder(a);if(!p)return;let v;if(D.isEqual(p.uri,a)?v="":v=D.relativePath(p.uri,a)??"",v&&(v=S.normalize(v)),P.folders.length>1&&!w.noPrefix){const N=p.name?p.name:D.basenameOrAuthority(p.uri);v=v?`${N} \u2022 ${v}`:N}return v}function I(a,w=R.$i){return(0,h.$Jg)(a,w)?a.charAt(0).toUpperCase()+a.slice(1):a}let E=Object.create(null);function u(a,w,y=R.OS){if(y===R.OperatingSystem.Windows||!a||!w)return a;let S=E.original===w?E.normalized:void 0;S||(S=w,R.$i&&(S=(0,h.$yg)(S)),S=`${(0,O.$of)(S,A.$ic.sep)}${A.$ic.sep}`,E={original:w,normalized:S});let D=a;return R.$i&&(D=(0,h.$yg)(D)),(y===R.OperatingSystem.Linux?D.startsWith(S):(0,O.$Hf)(D,S))?`~/${D.substr(S.length)}`:a}function k(a,w){return a.replace(/^~($|\/|\\)/,`${w}$1`)}const b="\u2026",c="\\\\",g="~";function d(a,w=A.sep){const y=new Array(a.length);let S=!1;for(let D=0;D<a.length;D++){const P=a[D];if(P===""){y[D]=`.${w}`;continue}if(!P){y[D]=P;continue}S=!0;let C="",p=P;p.indexOf(c)===0?(C=p.substr(0,p.indexOf(c)+c.length),p=p.substr(p.indexOf(c)+c.length)):p.indexOf(w)===0?(C=p.substr(0,p.indexOf(w)+w.length),p=p.substr(p.indexOf(w)+w.length)):p.indexOf(g)===0&&(C=p.substr(0,p.indexOf(g)+g.length),p=p.substr(p.indexOf(g)+g.length));const v=p.split(w);for(let N=1;S&&N<=v.length;N++)for(let T=v.length-N;S&&T>=0;T--){S=!1;let M=v.slice(T,T+N).join(w);for(let j=0;!S&&j<a.length;j++)if(j!==D&&a[j]&&a[j].indexOf(M)>-1){const z=T+N===v.length,F=T>0&&a[j].indexOf(w)>-1?w+M:M,B=a[j].endsWith(F);S=!z||B}if(!S){let j="";(v[0].endsWith(":")||C!=="")&&(T===1&&(T=0,N++,M=v[0]+w+M),T>0&&(j=v[0]+w),j=C+j),T>0&&(j=j+b+w),j=j+M,T+N<v.length&&(j=j+w+b),y[D]=j}}S&&(y[D]=P)}return y}var m;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function n(a,w=Object.create(null)){const y=[];let S=!1,D="";for(const P of a)if(P==="$"||S&&P==="{")D&&y.push({value:D,type:m.TEXT}),D="",S=!0;else if(P==="}"&&S){const C=w[D];if(typeof C=="string")C.length&&y.push({value:C,type:m.VARIABLE});else if(C){const p=y[y.length-1];(!p||p.type!==m.SEPARATOR)&&y.push({value:C.label,type:m.SEPARATOR})}D="",S=!1}else D+=P;return D&&!S&&y.push({value:D,type:m.TEXT}),y.filter((P,C)=>{if(P.type===m.SEPARATOR){const p=y[C-1],v=y[C+1];return[p,v].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(P=>P.value).join("")}function o(a,w){return R.$j||w?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):a.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function i(a,w){return R.$j||w?a.replace(/\(&&\w\)|&&/g,""):R.$i?a.replace(/&&|&/g,y=>y==="&"?"&&":"&"):a.replace(/&&/g,"_")}function t(a){return a.replace(/&/g,"&&")}function s(a){if(a.endsWith("]")){const w=a.lastIndexOf(" [",a.length-2);if(w!==-1){const y=f(a.substring(0,w)),S=a.substring(w);return{name:y.name+S,parentPath:y.parentPath}}}return f(a)}function f(a){const w=a.indexOf("/")!==-1?A.$ic:A.$hc,y=w.basename(a),S=w.dirname(a);return y.length?{name:y,parentPath:S}:{name:S,parentPath:""}}}),define(Ee[142],Se([1,0,22,41,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=$,e.$Mn=I,e.$Nn=E;function R(u){return u.toJSON()}class L{constructor(k){this.a=k}transformIncoming(k){const b=this.a.transformIncoming(k);return b===k?k:R(A.URI.from(b))}transformOutgoing(k){const b=this.a.transformOutgoing(k);return b===k?k:R(A.URI.from(b))}transformOutgoingURI(k){const b=this.a.transformOutgoing(k);return b===k?k:A.URI.from(b)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$Jn=L,e.$Kn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function O(u,k,b){if(!u||b>200)return null;if(typeof u=="object"){if(u instanceof A.URI)return k.transformOutgoing(u);for(const c in u)if(Object.hasOwnProperty.call(u,c)){const g=O(u[c],k,b+1);g!==null&&(u[c]=g)}}return null}function $(u,k){const b=O(u,k,0);return b===null?u:b}function l(u,k,b,c){if(!u||c>200)return null;if(typeof u=="object"){if(u.$mid===h.MarshalledId.Uri)return b?A.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof r.$Oe)return null;for(const g in u)if(Object.hasOwnProperty.call(u,g)){const d=l(u[g],k,b,c+1);d!==null&&(u[g]=d)}}return null}function I(u,k){const b=l(u,k,!1,0);return b===null?u:b}function E(u,k){const b=l(u,k,!0,0);return b===null?u:b}}),define(Ee[34],Se([1,0,61,68,410,9,33,82,16,11,23,2]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=n,e.whenDeleted=t,e.configureFlushOnWrite=y,e.writeFileSync=D,r=We(r);var u;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(u||(e.RimRafMode=u={}));async function k(F,B=u.UNLINK,_){if((0,L.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");return B===u.UNLINK?c(F):b(F,_)}async function b(F,B=(0,L.$Ng)((0,h.tmpdir)())){try{try{await r.promises.rename(F,B)}catch(_){return _.code==="ENOENT"?void 0:c(F)}c(B).catch(_=>{})}catch(_){if(_.code!=="ENOENT")throw _}}async function c(F){return r.promises.rm(F,{recursive:!0,force:!0,maxRetries:3})}function g(F){if((0,L.$Ig)(F))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(F,{recursive:!0,force:!0,maxRetries:3})}async function d(F,B){return o(await(B?m(F):r.promises.readdir(F)))}async function m(F){try{return await r.promises.readdir(F,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const B=[],_=await d(F);for(const re of _){let U=!1,G=!1,Q=!1;try{const ee=await e.Promises.lstat((0,$.$lc)(F,re));U=ee.isFile(),G=ee.isDirectory(),Q=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}B.push({name:re,isFile:()=>U,isDirectory:()=>G,isSymbolicLink:()=>Q})}return B}function n(F){return o(r.readdirSync(F))}function o(F){return F.map(B=>typeof B=="string"?l.$j?(0,O.$mm)(B):B:(B.name=l.$j?(0,O.$mm)(B.name):B.name,B))}async function i(F){const B=await d(F),_=[];for(const re of B)await s.existsDirectory((0,$.$lc)(F,re))&&_.push(re);return _}function t(F,B=1e3){return new Promise(_=>{let re=!1;const U=setInterval(()=>{re||(re=!0,r.access(F,G=>{re=!1,G&&(clearInterval(U),_(void 0))}))},B)})}var s;(function(F){async function B(U){let G;try{if(G=await e.Promises.lstat(U),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(U),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(l.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw ee}throw Q}}F.stat=B;async function _(U){try{const{stat:G,symbolicLink:Q}=await F.stat(U);return G.isFile()&&Q?.dangling!==!0}catch{}return!1}F.existsFile=_;async function re(U){try{const{stat:G,symbolicLink:Q}=await F.stat(U);return G.isDirectory()&&Q?.dangling!==!0}catch{}return!1}F.existsDirectory=re})(s||(e.SymlinkSupport=s={}));const f=new R.$Oh;function a(F,B,_){return f.queueFor(E.URI.file(F),()=>{const re=P(_);return new Promise((U,G)=>S(F,B,re,Q=>Q?G(Q):U()))},I.$0g)}let w=!0;function y(F){w=F}function S(F,B,_,re){if(!w)return r.writeFile(F,B,{mode:_.mode,flag:_.flag},re);r.open(F,_.flag,_.mode,(U,G)=>{if(U)return re(U);r.writeFile(G,B,Q=>{if(Q)return r.close(G,()=>re(Q));r.fdatasync(G,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),y(!1)),r.close(G,ue=>re(ue))))})})}function D(F,B,_){const re=P(_);if(!w)return r.writeFileSync(F,B,{mode:re.mode,flag:re.flag});const U=r.openSync(F,re.flag,re.mode);try{r.writeFileSync(U,B);try{r.fdatasyncSync(U)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),y(!1)}}finally{r.closeSync(U)}}function P(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function C(F,B,_=6e4){if(F!==B)try{l.$i&&typeof _=="number"?await p(F,B,Date.now(),_):await r.promises.rename(F,B)}catch(re){if(F.toLowerCase()!==B.toLowerCase()&&re.code==="EXDEV"||F.endsWith("."))await v(F,B,{preserveSymlinks:!1}),await k(F,u.MOVE);else throw re}}async function p(F,B,_,re,U=0){try{return await r.promises.rename(F,B)}catch(G){if(G.code!=="EACCES"&&G.code!=="EPERM"&&G.code!=="EBUSY")throw G;if(Date.now()-_>=re)throw console.error(`[node.js fs] rename failed after ${U} retries with error: ${G}`),G;if(U===0){let Q=!1;try{const{stat:ee}=await s.stat(B);ee.isFile()||(Q=!0)}catch{}if(Q)throw G}return await(0,R.$Gh)(Math.min(100,U*10)),p(F,B,_,re,U+1)}}async function v(F,B,_){return T(F,B,{root:{source:F,target:B},options:_,handledSourcePaths:new Set})}const N=511;async function T(F,B,_){if(_.handledSourcePaths.has(F))return;_.handledSourcePaths.add(F);const{stat:re,symbolicLink:U}=await s.stat(F);if(U){if(_.options.preserveSymlinks)try{return await z(F,B,_)}catch{}if(U.dangling)return}return re.isDirectory()?M(F,B,re.mode&N,_):j(F,B,re.mode&N)}async function M(F,B,_,re){await e.Promises.mkdir(B,{recursive:!0,mode:_});const U=await d(F);for(const G of U)await T((0,$.$lc)(F,G),(0,$.$lc)(B,G),re)}async function j(F,B,_){await e.Promises.copyFile(F,B),await e.Promises.chmod(B,_)}async function z(F,B,_){let re=await e.Promises.readlink(F);(0,L.$Eg)(re,_.root.source,!l.$k)&&(re=(0,$.$lc)(_.root.target,re.substr(_.root.source.length+1))),await e.Promises.symlink(re,B)}e.Promises=new class{get access(){return r.promises.access}get stat(){return r.promises.stat}get lstat(){return r.promises.lstat}get utimes(){return r.promises.utimes}get read(){return(F,B,_,re,U)=>new Promise((G,Q)=>{r.read(F,B,_,re,U,(ee,ue,ne)=>ee?Q(ee):G({bytesRead:ue,buffer:ne}))})}get readFile(){return r.promises.readFile}get write(){return(F,B,_,re,U)=>new Promise((G,Q)=>{r.write(F,B,_,re,U,(ee,ue,ne)=>ee?Q(ee):G({bytesWritten:ue,buffer:ne}))})}get appendFile(){return r.promises.appendFile}get fdatasync(){return(0,A.promisify)(r.fdatasync)}get truncate(){return r.promises.truncate}get copyFile(){return r.promises.copyFile}get open(){return(0,A.promisify)(r.open)}get close(){return(0,A.promisify)(r.close)}get symlink(){return r.promises.symlink}get readlink(){return r.promises.readlink}get chmod(){return r.promises.chmod}get mkdir(){return r.promises.mkdir}get unlink(){return r.promises.unlink}get rmdir(){return r.promises.rmdir}get realpath(){return(0,A.promisify)(r.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return i}get writeFile(){return a}get rm(){return k}get rename(){return C}get copy(){return v}}}),define(Ee[111],Se([1,0,61,16,11,13,34]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=O,e.$gr=$,e.$hr=l,e.$ir=I,r=We(r);function O(u){if(A.$k)return u;const k=(0,h.$oc)(u);if(u===k)return u;const b=((0,h.$pc)(u)||u).toLowerCase();try{const g=(0,L.readdirSync)(k).filter(d=>d.toLowerCase()===b);if(g.length===1){const d=O(k);if(d)return(0,h.$lc)(d,g[0])}else if(g.length>1){const d=g.indexOf(b);if(d>=0){const m=O(k);if(m)return(0,h.$lc)(m,g[d])}}}catch{}return null}async function $(u,k){if(A.$k)return u;const b=(0,h.$oc)(u);if(u===b)return u;const c=((0,h.$pc)(u)||u).toLowerCase();try{if(k?.isCancellationRequested)return null;const d=(await L.Promises.readdir(b)).filter(m=>m.toLowerCase()===c);if(d.length===1){const m=await $(b,k);if(m)return(0,h.$lc)(m,d[0])}else if(d.length>1){const m=d.indexOf(c);if(m>=0){const n=await $(b,k);if(n)return(0,h.$lc)(n,d[m])}}}catch{}return null}async function l(u){try{return await L.Promises.realpath(u)}catch{const b=E(u);return await L.Promises.access(b,r.constants.R_OK),b}}function I(u){try{return r.realpathSync(u)}catch{const b=E(u);return r.accessSync(b,r.constants.R_OK),b}}function E(u){return(0,R.$of)((0,h.$jc)(u),h.sep)}}),define(Ee[112],Se([1,0,16,11,56,109,18,34]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=$,e.$ym=l,r=We(r),h=We(h),A=We(A),L=We(L),O=We(O),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function $(E=A.env){return E.comspec||"cmd.exe"}function l(E){let u=[],k=!1;const b=function(c){if(k){u.push(c);return}(!E.send(c,d=>{if(d&&console.error(d),k=!1,u.length>0){const m=u.slice(0);u=[],m.forEach(n=>b(n))}})||h.$i)&&(k=!0)};return{send:b}}var I;(function(E){async function u(k,b,c){if(r.$kc(k))return k;if(b===void 0&&(b=A.cwd()),r.$oc(k)!=="."||(c===void 0&&L.$fg(A.env.PATH)&&(c=A.env.PATH.split(r.$vc)),c===void 0||c.length===0))return r.$lc(b,k);async function d(m){if(await O.Promises.exists(m)){let n;try{n=await O.Promises.stat(m)}catch(o){o.message.startsWith("EACCES")&&(n=await O.Promises.lstat(m))}return n?!n.isDirectory():!1}return!1}for(const m of c){let n;if(r.$kc(m)?n=r.$lc(m,k):n=r.$lc(b,m,k),await d(n))return n;let o=n+".com";if(await d(o)||(o=n+".exe",await d(o)))return o}return r.$lc(b,k)}E.findExecutable=u})(I||(e.win32=I={}))});var Je=this&&this.__decorate||function(ce,e,r,h){var A=arguments.length,R=A<3?e:h===null?h=Object.getOwnPropertyDescriptor(e,r):h,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(ce,e,r,h);else for(var O=ce.length-1;O>=0;O--)(L=ce[O])&&(R=(A<3?L(R):A>3?L(e,r,R):L(e,r))||R);return A>3&&R&&Object.defineProperty(e,r,R),R};define(Ee[87],Se([1,0,19,9,22,21,59,14,4,3,57,13,18]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.ProxyChannel=e.$ni=e.$ki=e.$ji=e.$ii=e.RequestInitiator=e.$hi=e.$ei=e.$di=void 0,e.$fi=y,e.$gi=S,e.$li=N,e.$mi=T,E=We(E);var k;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(k||(k={}));function b(U){switch(U){case k.Promise:return"req";case k.PromiseCancel:return"cancel";case k.EventListen:return"subscribe";case k.EventDispose:return"unsubscribe"}}var c;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(c||(c={}));function g(U){switch(U){case c.Initialize:return"init";case c.PromiseSuccess:return"reply:";case c.PromiseError:case c.PromiseErrorObj:return"replyErr:";case c.EventFire:return"event:"}}var d;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(d||(d={}));function m(U){let G=0;for(let Q=0;;Q+=7){const ee=U.read(1);if(G|=(ee.buffer[0]&127)<<Q,!(ee.buffer[0]&128))return G}}const n=f(0);function o(U,G){if(G===0){U.write(n);return}let Q=0;for(let ue=G;ue!==0;ue=ue>>>7)Q++;const ee=A.$Oe.alloc(Q);for(let ue=0;G!==0;ue++)ee.buffer[ue]=G&127,G=G>>>7,G>0&&(ee.buffer[ue]|=128);U.write(ee)}class i{constructor(G){this.b=G,this.a=0}read(G){const Q=this.b.slice(this.a,this.a+G);return this.a+=Q.byteLength,Q}}e.$di=i;class t{constructor(){this.a=[]}get buffer(){return A.$Oe.concat(this.a)}write(G){this.a.push(G)}}e.$ei=t;var s;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(s||(s={}));function f(U){const G=A.$Oe.alloc(1);return G.writeUInt8(U,0),G}const a={Undefined:f(s.Undefined),String:f(s.String),Buffer:f(s.Buffer),VSBuffer:f(s.VSBuffer),Array:f(s.Array),Object:f(s.Object),Uint:f(s.Int)},w=typeof Buffer<"u";function y(U,G){if(typeof G>"u")U.write(a.Undefined);else if(typeof G=="string"){const Q=A.$Oe.fromString(G);U.write(a.String),o(U,Q.byteLength),U.write(Q)}else if(w&&Buffer.isBuffer(G)){const Q=A.$Oe.wrap(G);U.write(a.Buffer),o(U,Q.byteLength),U.write(Q)}else if(G instanceof A.$Oe)U.write(a.VSBuffer),o(U,G.byteLength),U.write(G);else if(Array.isArray(G)){U.write(a.Array),o(U,G.length);for(const Q of G)y(U,Q)}else if(typeof G=="number"&&(G|0)===G)U.write(a.Uint),o(U,G);else{const Q=A.$Oe.fromString(JSON.stringify(G));U.write(a.Object),o(U,Q.byteLength),U.write(Q)}}function S(U){switch(U.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return U.read(m(U)).toString();case s.Buffer:return U.read(m(U)).buffer;case s.VSBuffer:return U.read(m(U));case s.Array:{const Q=m(U),ee=[];for(let ue=0;ue<Q;ue++)ee.push(S(U));return ee}case s.Object:return JSON.parse(U.read(m(U)).toString());case s.Int:return m(U)}}class D{constructor(G,Q,ee=null,ue=1e3){this.h=G,this.j=Q,this.k=ee,this.l=ue,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:c.Initialize})}registerChannel(G,Q){this.b.set(G,Q),setTimeout(()=>this.w(G),0)}m(G){switch(G.type){case c.Initialize:{const Q=this.o([G.type]);this.k?.logOutgoing(Q,0,P.OtherSide,g(G.type));return}case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:{const Q=this.o([G.type,G.id],G.data);this.k?.logOutgoing(Q,G.id,P.OtherSide,g(G.type),G.data);return}}}o(G,Q=void 0){const ee=new t;return y(ee,G),y(ee,Q),this.p(ee.buffer)}p(G){try{return this.h.send(G),G.byteLength}catch{return 0}}q(G){const Q=new i(G),ee=S(Q),ue=S(Q),ne=ee[0];switch(ne){case k.Promise:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,ue),this.s({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case k.EventListen:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}: ${ee[2]}.${ee[3]}`,ue),this.t({type:ne,id:ee[1],channelName:ee[2],name:ee[3],arg:ue});case k.PromiseCancel:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}`),this.u({type:ne,id:ee[1]});case k.EventDispose:return this.k?.logIncoming(G.byteLength,ee[1],P.OtherSide,`${b(ne)}`),this.u({type:ne,id:ee[1]})}}s(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const ee=new R.$xe;let ue;try{ue=Q.call(this.j,G.name,G.arg,ee.token)}catch($e){ue=Promise.reject($e)}const ne=G.id;ue.then($e=>{this.m({id:ne,data:$e,type:c.PromiseSuccess})},$e=>{$e instanceof Error?this.m({id:ne,data:{message:$e.message,name:$e.name,stack:$e.stack?$e.stack.split(`
`):void 0},type:c.PromiseError}):this.m({id:ne,data:$e,type:c.PromiseErrorObj})}).finally(()=>{De.dispose(),this.d.delete(G.id)});const De=(0,l.$Uc)(()=>ee.cancel());this.d.set(G.id,De)}t(G){const Q=this.b.get(G.channelName);if(!Q){this.v(G);return}const ee=G.id,ne=Q.listen(this.j,G.name,G.arg)(De=>this.m({id:ee,data:De,type:c.EventFire}));this.d.set(G.id,ne)}u(G){const Q=this.d.get(G.id);Q&&(Q.dispose(),this.d.delete(G.id))}v(G){let Q=this.g.get(G.channelName);Q||(Q=[],this.g.set(G.channelName,Q));const ee=setTimeout(()=>{console.error(`Unknown channel: ${G.channelName}`),G.type===k.Promise&&this.m({id:G.id,data:{name:"Unknown channel",message:`Channel name '${G.channelName}' timed out after ${this.l}ms`,stack:void 0},type:c.PromiseError})},this.l);Q.push({request:G,timeoutTimer:ee})}w(G){const Q=this.g.get(G);if(Q){for(const ee of Q)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case k.Promise:this.s(ee.request);break;case k.EventListen:this.t(ee.request);break}this.g.delete(G)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Rc)(this.d.values()),this.d.clear()}}e.$hi=D;var P;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(P||(e.RequestInitiator=P={}));class C{constructor(G,Q=null){this.l=G,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$me,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=Q}getChannel(G){const Q=this;return{call(ee,ue,ne){return Q.a?Promise.reject(new O.$7):Q.m(G,ee,ue,ne)},listen(ee,ue){return Q.a?$.Event.None:Q.o(G,ee,ue)}}}m(G,Q,ee,ue=R.CancellationToken.None){const ne=this.g++,De=k.Promise,$e={id:ne,type:De,channelName:G,name:Q,arg:ee};if(ue.isCancellationRequested)return Promise.reject(new O.$7);let K;return new Promise((se,oe)=>{if(ue.isCancellationRequested)return oe(new O.$7);const te=()=>{const ae=pe=>{switch(pe.type){case c.PromiseSuccess:this.f.delete(ne),se(pe.data);break;case c.PromiseError:{this.f.delete(ne);const be=new Error(pe.data.message);be.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,be.name=pe.data.name,oe(be);break}case c.PromiseErrorObj:this.f.delete(ne),oe(pe.data);break}};this.f.set(ne,ae),this.p($e)};let le=null;this.b===d.Idle?te():(le=(0,h.$sh)(ae=>this.u()),le.then(()=>{le=null,te()}));const he=()=>{le?(le.cancel(),le=null):this.p({id:ne,type:k.PromiseCancel}),oe(new O.$7)},X=ue.onCancellationRequested(he);K=(0,l.$Tc)((0,l.$Uc)(he),X),this.d.add(K)}).finally(()=>{K.dispose(),this.d.delete(K)})}o(G,Q,ee){const ue=this.g++,ne=k.EventListen,De={id:ue,type:ne,channelName:G,name:Q,arg:ee};let $e=null;const K=new $.$me({onWillAddFirstListener:()=>{$e=(0,h.$sh)(se=>this.u()),$e.then(()=>{$e=null,this.d.add(K),this.p(De)})},onDidRemoveLastListener:()=>{$e?($e.cancel(),$e=null):(this.d.delete(K),this.p({id:ue,type:k.EventDispose}))}}),W=se=>K.fire(se.data);return this.f.set(ue,W),K.event}p(G){switch(G.type){case k.Promise:case k.EventListen:{const Q=this.q([G.type,G.id,G.channelName,G.name],G.arg);this.j?.logOutgoing(Q,G.id,P.LocalSide,`${b(G.type)}: ${G.channelName}.${G.name}`,G.arg);return}case k.PromiseCancel:case k.EventDispose:{const Q=this.q([G.type,G.id]);this.j?.logOutgoing(Q,G.id,P.LocalSide,b(G.type));return}}}q(G,Q=void 0){const ee=new t;return y(ee,G),y(ee,Q),this.r(ee.buffer)}r(G){try{return this.l.send(G),G.byteLength}catch{return 0}}s(G){const Q=new i(G),ee=S(Q),ue=S(Q),ne=ee[0];switch(ne){case c.Initialize:return this.j?.logIncoming(G.byteLength,0,P.LocalSide,g(ne)),this.t({type:ee[0]});case c.PromiseSuccess:case c.PromiseError:case c.EventFire:case c.PromiseErrorObj:return this.j?.logIncoming(G.byteLength,ee[1],P.LocalSide,g(ne),ue),this.t({type:ee[0],id:ee[1],data:ue})}}t(G){if(G.type===c.Initialize){this.b=d.Idle,this.k.fire();return}this.f.get(G.id)?.(G)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Rc)(this.d.values()),this.d.clear()}}e.$ii=C,Je([L.$0h],C.prototype,"onDidInitializePromise",null);class p{get connections(){const G=[];return this.f.forEach(Q=>G.push(Q)),G}constructor(G,Q,ee){this.a=new Map,this.f=new Set,this.g=new $.$me,this.onDidAddConnection=this.g.event,this.h=new $.$me,this.onDidRemoveConnection=this.h.event,this.j=new l.$Vc,this.j.add(G(({protocol:ue,onDidClientDisconnect:ne})=>{const De=$.Event.once(ue.onMessage);this.j.add(De($e=>{const K=new i($e),W=S(K),se=new D(ue,W,Q,ee),oe=new C(ue,Q);this.a.forEach((le,he)=>se.registerChannel(he,le));const te={channelServer:se,channelClient:oe,ctx:W};this.f.add(te),this.g.fire(te),this.j.add(ne(()=>{se.dispose(),oe.dispose(),this.f.delete(te),this.h.fire(te)}))}))}))}getChannel(G,Q){const ee=this;return{call(ue,ne,De){let $e;if((0,u.$tg)(Q)){const W=(0,r.$5b)(ee.connections.filter(Q));$e=W?Promise.resolve(W):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,Q))}else $e=Q.routeCall(ee,ue,ne);const K=$e.then(W=>W.channelClient.getChannel(G));return N(K).call(ue,ne,De)},listen(ue,ne){if((0,u.$tg)(Q))return ee.k(G,Q,ue,ne);const De=Q.routeEvent(ee,ue,ne).then($e=>$e.channelClient.getChannel(G));return N(De).listen(ue,ne)}}}k(G,Q,ee,ue){const ne=this;let De;const $e=new $.$me({onWillAddFirstListener:()=>{De=new l.$Vc;const K=new $.$se,W=new Map,se=te=>{const he=te.channelClient.getChannel(G).listen(ee,ue),X=K.add(he);W.set(te,X)},oe=te=>{const le=W.get(te);le&&(le.dispose(),W.delete(te))};ne.connections.filter(Q).forEach(se),$.Event.filter(ne.onDidAddConnection,Q)(se,void 0,De),ne.onDidRemoveConnection(oe,void 0,De),K.event($e.fire,$e,De),De.add(K)},onDidRemoveLastListener:()=>{De?.dispose(),De=void 0}});return $e.event}registerChannel(G,Q){this.a.set(G,Q);for(const ee of this.f)ee.channelServer.registerChannel(G,Q)}dispose(){this.j.dispose();for(const G of this.f)G.channelClient.dispose(),G.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ji=p;class v{constructor(G,Q,ee=null){const ue=new t;y(ue,Q),G.send(ue.buffer),this.a=new C(G,ee),this.d=new D(G,Q,ee)}getChannel(G){return this.a.getChannel(G)}registerChannel(G,Q){this.d.registerChannel(G,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ki=v;function N(U){return{call(G,Q,ee){return U.then(ue=>ue.call(G,Q,ee))},listen(G,Q){const ee=new $.$ve;return U.then(ue=>ee.input=ue.listen(G,Q)),ee.event}}}function T(U){let G=!1;return{call(Q,ee,ue){return G?U.call(Q,ee,ue):(0,h.$Gh)(0).then(()=>G=!0).then(()=>U.call(Q,ee,ue))},listen(Q,ee){if(G)return U.listen(Q,ee);const ue=new $.$ve;return(0,h.$Gh)(0).then(()=>G=!0).then(()=>ue.input=U.listen(Q,ee)),ue.event}}}class M{constructor(G){this.a=G}routeCall(G){return this.b(G)}routeEvent(G){return this.b(G)}async b(G){for(const Q of G.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await $.Event.toPromise(G.onDidAddConnection),await this.b(G)}}e.$ni=M;var j;(function(U){function G(ne,De,$e){const K=ne,W=$e&&$e.disableMarshalling,se=new Map;for(const oe in K)ee(oe)&&se.set(oe,$.Event.buffer(K[oe],!0,void 0,De));return new class{listen(oe,te,le){const he=se.get(te);if(he)return he;const X=K[te];if(typeof X=="function"){if(ue(te))return X.call(K,le);if(ee(te))return se.set(te,$.Event.buffer(K[te],!0,void 0,De)),se.get(te)}throw new O.$db(`Event not found: ${te}`)}call(oe,te,le){const he=K[te];if(typeof he=="function"){if(!W&&Array.isArray(le))for(let ae=0;ae<le.length;ae++)le[ae]=(0,I.$ci)(le[ae]);let X=he.apply(K,le);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new O.$db(`Method not found: ${te}`)}}}U.fromService=G;function Q(ne,De){const $e=De&&De.disableMarshalling;return new Proxy({},{get(K,W){if(typeof W=="string")return De?.properties?.has(W)?De.properties.get(W):ue(W)?function(se){return ne.listen(W,se)}:ee(W)?ne.listen(W):async function(...se){let oe;De&&!(0,u.$og)(De.context)?oe=[De.context,...se]:oe=se;const te=await ne.call(W,oe);return $e?te:(0,I.$ci)(te)};throw new O.$db(`Property not found: ${String(W)}`)}})}U.toService=Q;function ee(ne){return ne[0]==="o"&&ne[1]==="n"&&E.$Ff(ne.charCodeAt(2))}function ue(ne){return/^onDynamic/.test(ne)&&E.$Ff(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const G=U.toString();if(G!=="[object Object]")return G}return U}function B(U){return Array.isArray(U)?U.map(F):F(U)}function _(U,G,Q,ee,ue,ne,De){De=B(De);const $e=z[ue],K=$e[ee%$e.length];let W=[`%c[${U}]%c[${String(G).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${K}`];/\($/.test(ne)?(W=W.concat(De),W.push(")")):W.push(De),console.log.apply(console,W)}class re{constructor(G,Q){this.d=G,this.f=Q,this.a=0,this.b=0}logOutgoing(G,Q,ee,ue,ne){this.b+=G,_(this.d,this.b,G,Q,ee,ue,ne)}logIncoming(G,Q,ee,ue,ne){this.a+=G,_(this.f,this.a,G,Q,ee,ue,ne)}}e.$oi=re}),define(Ee[69],Se([1,0,22,4,3,87]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=e.$si=e.$ri=e.$qi=e.ProtocolConstants=e.$pi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(a){a.Created="created",a.Read="read",a.Write="write",a.Open="open",a.Error="error",a.Close="close",a.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",a.NodeEndReceived="nodeEndReceived",a.NodeEndSent="nodeEndSent",a.NodeDrainBegin="nodeDrainBegin",a.NodeDrainEnd="nodeDrainEnd",a.zlibInflateError="zlibInflateError",a.zlibInflateData="zlibInflateData",a.zlibInflateInitialWrite="zlibInflateInitialWrite",a.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",a.zlibInflateWrite="zlibInflateWrite",a.zlibInflateFlushFired="zlibInflateFlushFired",a.zlibDeflateError="zlibDeflateError",a.zlibDeflateData="zlibDeflateData",a.zlibDeflateWrite="zlibDeflateWrite",a.zlibDeflateFlushFired="zlibDeflateFlushFired",a.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",a.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",a.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",a.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",a.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",a.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",a.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",a.ProtocolHeaderRead="protocolHeaderRead",a.ProtocolMessageRead="protocolMessageRead",a.ProtocolHeaderWrite="protocolHeaderWrite",a.ProtocolMessageWrite="protocolMessageWrite",a.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var O;(function(a){a.enableDiagnostics=!1,a.records=[];const w=new WeakMap;let y=0;function S(P,C){if(!w.has(P)){const p=String(++y);w.set(P,p)}return w.get(P)}function D(P,C,p,v){if(!a.enableDiagnostics)return;const N=S(P,C);if(v instanceof r.$Oe||v instanceof Uint8Array||v instanceof ArrayBuffer||ArrayBuffer.isView(v)){const T=r.$Oe.alloc(v.byteLength);T.set(v),a.records.push({timestamp:Date.now(),id:N,label:C,type:p,buff:T})}else a.records.push({timestamp:Date.now(),id:N,label:C,type:p,data:v})}a.traceSocketEvent=D})(O||(e.SocketDiagnostics=O={}));var $;(function(a){a[a.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",a[a.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let l=null;function I(){return l||(l=r.$Oe.alloc(0)),l}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,y){if(w===0)return I();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const C=this.a[0];return y&&(this.a.shift(),this.b-=w),C}if(this.a[0].byteLength>w){const C=this.a[0].slice(0,w);return y&&(this.a[0]=this.a[0].slice(w),this.b-=w),C}const S=r.$Oe.alloc(w);let D=0,P=0;for(;w>0;){const C=this.a[P];if(C.byteLength>w){const p=C.slice(0,w);S.set(p,D),D+=w,y&&(this.a[P]=C.slice(w),this.b-=w),w-=w}else S.set(C,D),D+=C.byteLength,y?(this.a.shift(),this.b-=C.byteLength):P++,w-=C.byteLength}return S}}e.$pi=E;var u;(function(a){a[a.None=0]="None",a[a.Regular=1]="Regular",a[a.Control=2]="Control",a[a.Ack=3]="Ack",a[a.Disconnect=5]="Disconnect",a[a.ReplayRequest=6]="ReplayRequest",a[a.Pause=7]="Pause",a[a.Resume=8]="Resume",a[a.KeepAlive=9]="KeepAlive"})(u||(u={}));function k(a){switch(a){case u.None:return"None";case u.Regular:return"Regular";case u.Control:return"Control";case u.Ack:return"Ack";case u.Disconnect:return"Disconnect";case u.ReplayRequest:return"ReplayRequest";case u.Pause:return"PauseWriting";case u.Resume:return"ResumeWriting";case u.KeepAlive:return"KeepAlive"}}var b;(function(a){a[a.HeaderLength=13]="HeaderLength",a[a.AcknowledgeTime=2e3]="AcknowledgeTime",a[a.TimeoutTime=2e4]="TimeoutTime",a[a.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",a[a.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",a[a.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class c{constructor(w,y,S,D){this.type=w,this.id=y,this.ack=S,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends A.$Wc{constructor(w){super(),this.f=this.B(new h.$me),this.onMessage=this.f.event,this.g={readHead:!0,readLen:b.HeaderLength,messageType:u.None,id:0,ack:0},this.a=w,this.b=!1,this.c=new E,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:k(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,D=this.g.id,P=this.g.ack;if(this.g.readHead=!0,this.g.readLen=b.HeaderLength,this.g.messageType=u.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,y),this.f.fire(new c(S,D,P,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=r.$Oe.alloc(b.HeaderLength);y.writeUInt8(w.type,0),y.writeUInt32BE(w.id,1),y.writeUInt32BE(w.ack,5),y.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:k(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,w.data),this.j(y,w.data)}g(w,y){const S=this.f===0;return this.d.push(w,y),this.f+=w.byteLength+y.byteLength,S}h(){const w=r.$Oe.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,y){this.g(w,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:w.byteLength}),this.c.write(w)}}class m extends A.$Wc{constructor(w){super(),this.f=new h.$me,this.onMessage=this.f.event,this.g=new h.$me,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new d(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(y=>{y.type===u.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new c(u.Regular,0,0,w))}}e.$qi=m;class n extends R.$ki{static fromSocket(w,y){return new n(new m(w),y)}get onDidDispose(){return this.b.onDidDispose}constructor(w,y,S=null){super(w,y,S),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.$ri=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new h.$me({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.$si=o;class i{constructor(w){this.data=w,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let w=0,y=this.a;for(;y;)y=y.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let y=0,S=this.a;for(;S;)w[y++]=S.data,S=S.next;return w}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const y=new i(w);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const w=Date.now();for(let y=0;y<s.a;y++)this.c[y]=w-1e3*y;setInterval(()=>{for(let y=s.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),y=(1+s.a)*1e3;let S=0;for(let D=0;D<s.a;D++)w-this.c[D]<=y&&S++;return 1-S/s.a}hasHighLoad(){return this.d()>=.5}}class f{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=w.loadEstimator??s.getInstance(),this.t=w.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Vc,this.o=w.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.t?this.l=setInterval(()=>{this.D()},b.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new c(u.Disconnect,0,0,I());this.p.write(w),this.p.flush()}sendPause(){const w=new c(u.Pause,0,0,I());this.p.write(w)}sendResume(){const w=new c(u.Resume,0,0,I());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,y){this.a=!0,this.r.dispose(),this.r=new A.$Vc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.h=this.g;const w=new c(u.Ack,0,this.h,I());this.p.write(w);const y=this.b.toArray();for(let S=0,D=y.length;S<D;S++)this.p.write(y[S]);this.B()}acceptDisconnect(){this.w.fire()}z(w){if(w.ack>this.d){this.d=w.ack;do{const y=this.b.peek();if(y&&y.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case u.None:break;case u.Regular:{if(w.id>this.g)if(w.id!==this.g+1){const y=Date.now();y-this.m>1e4&&(this.m=y,this.p.write(new c(u.ReplayRequest,0,0,I())))}else this.g=w.id,this.j=Date.now(),this.A(),this.v.fire(w.data);break}case u.Control:{this.u.fire(w.data);break}case u.Ack:break;case u.Disconnect:{this.w.fire();break}case u.ReplayRequest:{const y=this.b.toArray();for(let S=0,D=y.length;S<D;S++)this.p.write(y[S]);this.B();break}case u.Pause:{this.p.pause();break}case u.Resume:{this.p.resume();break}case u.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const y=++this.c;this.h=this.g;const S=new c(u.Regular,y,this.h,w);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(w){const y=new c(u.Control,0,0,w);this.p.write(y)}A(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=b.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},b.AcknowledgeTime-w+5)}B(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),y=Date.now()-w.writtenTime,S=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(y>=b.TimeoutTime&&S>=b.TimeoutTime&&D>=b.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:S});return}const P=Math.max(b.TimeoutTime-y,b.TimeoutTime-S,b.TimeoutTime-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},P)}C(){if(this.g<=this.h)return;this.h=this.g;const w=new c(u.Ack,0,this.h,I());this.p.write(w)}D(){this.h=this.g;const w=new c(u.KeepAlive,0,this.h,I());this.p.write(w)}}e.$ti=f}),define(Ee[208],Se([1,0,58,9,22,21,206,14,4,3,25,112,109,87]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0,O=We(O);class b extends k.$hi{constructor(d){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",m=>A.$Oe.wrap(Buffer.from(m,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$br=b;class c{constructor(d,m){this.i=d,this.j=m,this.c=new Set,this.g=new Map,this.h=new $.$me,this.onDidProcessExit=this.h.event;const n=m&&m.timeout?m.timeout:6e4;this.b=new h.$Ch(n),this.d=null,this.f=null}getChannel(d){const m=this;return{call(n,o,i){return m.k(d,n,o,i)},listen(n,o){return m.l(d,n,o)}}}k(d,m,n,o=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(O.$8());this.b.cancel();const i=this.n(d),t=(0,h.$sh)(a=>i.call(m,n,a)),s=o.onCancellationRequested(()=>t.cancel()),f=(0,l.$Uc)(()=>t.cancel());return this.c.add(f),t.finally(()=>{s.dispose(),this.c.delete(f),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,m,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const i=new $.$me({onWillAddFirstListener:()=>{o=this.n(d).listen(m,n)(i.fire,i),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,I.$co)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,u.$lm)(m.env),this.d=(0,r.fork)(this.i,d,m);const n=new $.$me,i=$.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,L.$0q)(y)){(0,L.log)(y,`IPC Library: ${this.j.serverName}`);return}n.fire(A.$Oe.wrap(Buffer.from(y,"base64")))}),t=this.j.useQueue?(0,E.$ym)(this.d):this.d,s=y=>this.d&&this.d.connected&&t.send(y.buffer.toString("base64")),f=n.event,a={send:s,onMessage:f};this.f=new k.$ii(a);const w=()=>this.o();process.once("exit",w),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,S)=>{process.removeListener("exit",w),i.dispose(),this.c.forEach(D=>(0,l.$Rc)(D)),this.c.clear(),y!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:S})})}return this.f}n(d){let m=this.g.get(d);return m||(m=this.m.getChannel(d),this.g.set(d,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$cr=c}),define(Ee[209],Se([1,0,9,4,3,57,18]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.StorageState=e.StorageHint=void 0,e.$0p=$;var O;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function $(u){const k=u;return k?.changed instanceof Map||k?.deleted instanceof Set}var l;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(l||(e.StorageState=l={}));class I extends A.$Wc{static{this.a=100}constructor(k,b=Object.create(null)){super(),this.r=k,this.s=b,this.b=this.B(new h.$pe),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new r.$Dh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((b,c)=>this.w(c,b)),k.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(k,b){if(this.c===l.Closed)return;let c=!1;(0,L.$og)(b)?c=this.f.delete(k):this.f.get(k)!==b&&(this.f.set(k,b),c=!0),c&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,b){const c=this.f.get(k);return(0,L.$og)(c)?b:c}getBoolean(k,b){const c=this.get(k);return(0,L.$og)(c)?b:c==="true"}getNumber(k,b){const c=this.get(k);return(0,L.$og)(c)?b:parseInt(c,10)}getObject(k,b){const c=this.get(k);return(0,L.$og)(c)?b:(0,R.$bi)(c)}async set(k,b,c=!1){if(this.c===l.Closed)return;if((0,L.$og)(b))return this.delete(k,c);const g=(0,L.$hg)(b)||Array.isArray(b)?(0,R.$ai)(b):String(b);if(this.f.get(k)!==g)return this.f.set(k,g),this.j.set(k,g),this.h.delete(k),this.b.fire({key:k,external:c}),this.D()}async delete(k,b=!1){if(!(this.c===l.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:b}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===l.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$$p=I;class E{constructor(){this.onDidChangeItemsExternal=h.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((b,c)=>this.a.set(c,b)),k.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$_p=E}),define(Ee[210],Se([1,0,13,11,22]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=void 0,e.$8t=I,e.$9t=E,r=We(r),h=We(h),A=We(A);let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let O;function $(){return O||(O=new TextDecoder("UTF-16BE")),O}let l;function I(){return l||(l=h.$D()?L():$()),l}function E(b,c,g){const d=new Uint16Array(b.buffer,c,g);return g>0&&(d[0]===65279||d[0]===65534)?u(b,c,g):L().decode(d)}function u(b,c,g){const d=[];let m=0;for(let n=0;n<g;n++){const o=A.$Qe(b,c);c+=2,d[m++]=String.fromCharCode(o)}return d.join("")}class k{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return I().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||r.$Kf(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let d=0;d<g;d++)this.b[this.d++]=c.charCodeAt(d)}}e.$0t=k}),define(Ee[211],Se([1,0,22,210]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=void 0,e.$_t=L,r=We(r);function A($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,I,E,u){this.oldPosition=l,this.oldText=I,this.newPosition=E,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${A(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${A(this.oldText)}")`:`(replace@${this.oldPosition} "${A(this.oldText)}" with "${A(this.newText)}")`}static a(l){return 4+2*l.length}static c(l,I,E){const u=I.length;r.$Te(l,u,E),E+=4;for(let k=0;k<u;k++)r.$Re(l,I.charCodeAt(k),E),E+=2;return E}static d(l,I){const E=r.$Se(l,I);return I+=4,(0,h.$9t)(l,I,E)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(l,I){return r.$Te(l,this.oldPosition,I),I+=4,r.$Te(l,this.newPosition,I),I+=4,I=R.c(l,this.oldText,I),I=R.c(l,this.newText,I),I}static read(l,I,E){const u=r.$Se(l,I);I+=4;const k=r.$Se(l,I);I+=4;const b=R.d(l,I);I+=R.a(b);const c=R.d(l,I);return I+=R.a(c),E.push(new R(u,b,k,c)),I}}e.$$t=R;function L($,l){return $===null||$.length===0?l:new O($,l).compress()}class O{constructor(l,I){this.a=l,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let l=0,I=0,E=this.n(l),u=this.l(I);for(;l<this.f||I<this.h;){if(E===null){this.k(u),u=this.l(++I);continue}if(u===null){this.m(E),E=this.n(++l);continue}if(u.oldEnd<=E.newPosition){this.k(u),u=this.l(++I);continue}if(E.newEnd<=u.oldPosition){this.m(E),E=this.n(++l);continue}if(u.oldPosition<E.newPosition){const[d,m]=O.r(u,E.newPosition-u.oldPosition);this.k(d),u=m;continue}if(E.newPosition<u.oldPosition){const[d,m]=O.q(E,u.oldPosition-E.newPosition);this.m(d),E=m;continue}let c,g;if(u.oldEnd===E.newEnd)c=E,g=u,E=this.n(++l),u=this.l(++I);else if(u.oldEnd<E.newEnd){const[d,m]=O.q(E,u.oldLength);c=d,g=u,E=m,u=this.l(++I)}else{const[d,m]=O.r(u,E.newLength);c=E,g=d,E=this.n(++l),u=m}this.d[this.e++]=new R(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const k=O.s(this.d);return O.t(k)}k(l){this.d[this.e++]=O.o(this.g,l),this.j+=l.newLength-l.oldLength}l(l){return l<this.h?this.c[l]:null}m(l){this.d[this.e++]=O.p(this.j,l),this.g+=l.newLength-l.oldLength}n(l){return l<this.f?this.a[l]:null}static o(l,I){return new R(I.oldPosition-l,I.oldText,I.newPosition,I.newText)}static p(l,I){return new R(I.oldPosition,I.oldText,I.newPosition+l,I.newText)}static q(l,I){const E=l.newText.substr(0,I),u=l.newText.substr(I);return[new R(l.oldPosition,l.oldText,l.newPosition,E),new R(l.oldEnd,"",l.newPosition+I,u)]}static r(l,I){const E=l.oldText.substr(0,I),u=l.oldText.substr(I);return[new R(l.oldPosition,E,l.newPosition,l.newText),new R(l.oldPosition+I,u,l.newEnd,"")]}static s(l){if(l.length===0)return l;const I=[];let E=0,u=l[0];for(let k=1;k<l.length;k++){const b=l[k];u.oldEnd===b.oldPosition?u=new R(u.oldPosition,u.oldText+b.oldText,u.newPosition,u.newText+b.newText):(I[E++]=u,u=b)}return I[E++]=u,I}static t(l){if(l.length===0)return l;const I=[];let E=0;for(let u=0;u<l.length;u++){const k=l[u];k.oldText!==k.newText&&(I[E++]=k)}return I}}}),define(Ee[212],Se([1,0,39,16]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=A,e.$qu=R;function A(L,O,$,l,I,E){if(Array.isArray(L)){let u=0;for(const k of L){const b=A(k,O,$,l,I,E);if(b===10)return b;b>u&&(u=b)}return u}else{if(typeof L=="string")return l?L==="*"?5:L===$?10:0:0;if(L){const{language:u,pattern:k,scheme:b,hasAccessToAllModels:c,notebookType:g}=L;if(!l&&!c)return 0;g&&I&&(O=I);let d=0;if(b)if(b===O.scheme)d=10;else if(b==="*")d=5;else return 0;if(u)if(u===$)d=10;else if(u==="*")d=Math.max(d,5);else return 0;if(g)if(g===E)d=10;else if(g==="*"&&E!==void 0)d=Math.max(d,5);else return 0;if(k){let m;if(typeof k=="string"?m=k:m={...k,base:(0,h.$jc)(k.base)},m===O.fsPath||(0,r.$yk)(m,O.fsPath))d=10;else return 0}return d}else return 0}}function R(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(R):!!L.notebookType}}),define(Ee[213],Se([1,0,4,13,31,54,139,188,211,3]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0,h=We(h);class I extends l.$Wc{constructor(u,k,b,c,g,d,m){super(),this.m=this.B(new r.$me),this.onDidChangeContent=this.m.event,this.f=k,this.j=!d,this.g=c,this.h=g,this.c=new L.$hD(u,b,m)}equals(u){return!(u instanceof I)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,k){return this.c.getOffsetAt(u,k)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,k){const b=u+k,c=this.getPositionAt(u),g=this.getPositionAt(b);return new A.$It(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange(u,k=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const b=this.n(k);return this.c.getValueInRange(u,b)}getValueLengthInRange(u,k=R.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const b=this.getOffsetAt(u.startLineNumber,u.startColumn),c=this.getOffsetAt(u.endLineNumber,u.endColumn);let g=0;const d=this.n(k),m=this.getEOL();if(d.length!==m.length){const n=d.length-m.length,o=u.endLineNumber-u.startLineNumber;g=n*o}return c-b+g}getCharacterCountInRange(u,k=R.EndOfLinePreference.TextDefined){if(this.j){let b=0;const c=u.startLineNumber,g=u.endLineNumber;for(let d=c;d<=g;d++){const m=this.getLineContent(d),n=d===c?u.startColumn-1:0,o=d===g?u.endColumn-1:m.length;for(let i=n;i<o;i++)h.$Kf(m.charCodeAt(i))?(b=b+1,i=i+1):b=b+1}return b+=this.n(k).length*(g-c),b}return this.getValueLengthInRange(u,k)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,k){return this.c.getLineCharCode(u,k)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const k=h.$vf(this.getLineContent(u));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(u){const k=h.$xf(this.getLineContent(u));return k===-1?0:k+2}n(u){switch(u){case R.EndOfLinePreference.LF:return`
`;case R.EndOfLinePreference.CRLF:return`\r
`;case R.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,k,b){let c=this.g,g=this.h,d=this.j,m=!0,n=[];for(let w=0;w<u.length;w++){const y=u[w];m&&y._isTracked&&(m=!1);const S=y.range;if(y.text){let v=!0;d||(v=!h.$Vf(y.text),d=v),!c&&v&&(c=h.$Uf(y.text)),!g&&v&&(g=h.$Xf(y.text))}let D="",P=0,C=0,p=0;if(y.text){let v;[P,C,p,v]=(0,O.$su)(y.text);const N=this.getEOL(),T=N===`\r
`?O.StringEOL.CRLF:O.StringEOL.LF;v===O.StringEOL.Unknown||v===T?D=y.text:D=y.text.replace(/\r\n|\r|\n/g,N)}n[w]={sortIndex:w,identifier:y.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:D,eolCount:P,firstLineLength:C,lastLineLength:p,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}n.sort(I.u);let o=!1;for(let w=0,y=n.length-1;w<y;w++){const S=n[w].range.getEndPosition(),D=n[w+1].range.getStartPosition();if(D.isBeforeOrEqual(S)){if(D.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}m&&(n=this.s(n));const i=b||k?I._getInverseEditRanges(n):[],t=[];if(k)for(let w=0;w<n.length;w++){const y=n[w],S=i[w];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let D=S.startLineNumber;D<=S.endLineNumber;D++){let P="";D===S.startLineNumber&&(P=this.getLineContent(y.range.startLineNumber),h.$vf(P)!==-1)||t.push({lineNumber:D,oldContent:P})}}let s=null;if(b){let w=0;s=[];for(let y=0;y<n.length;y++){const S=n[y],D=i[y],P=this.getValueInRange(S.range),C=S.rangeOffset+w;w+=S.text.length-P.length,s[y]={sortIndex:S.sortIndex,identifier:S.identifier,range:D,text:P,textChange:new $.$$t(S.rangeOffset,P,C,S.text)}}o||s.sort((y,S)=>y.sortIndex-S.sortIndex)}this.g=c,this.h=g,this.j=d;const f=this.t(n);let a=null;if(k&&t.length>0){t.sort((w,y)=>y.lineNumber-w.lineNumber),a=[];for(let w=0,y=t.length;w<y;w++){const S=t[w].lineNumber;if(w>0&&t[w-1].lineNumber===S)continue;const D=t[w].oldContent,P=this.getLineContent(S);P.length===0||P===D||h.$vf(P)!==-1||a.push(S)}}return this.m.fire(),new R.$bw(s,f,a)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let k=!1;const b=u[0].range,c=u[u.length-1].range,g=new A.$It(b.startLineNumber,b.startColumn,c.endLineNumber,c.endColumn);let d=b.startLineNumber,m=b.startColumn;const n=[];for(let f=0,a=u.length;f<a;f++){const w=u[f],y=w.range;k=k||w.forceMoveMarkers,n.push(this.getValueInRange(new A.$It(d,m,y.startLineNumber,y.startColumn))),w.text.length>0&&n.push(w.text),d=y.endLineNumber,m=y.endColumn}const o=n.join(""),[i,t,s]=(0,O.$su)(o);return{sortIndex:0,identifier:u[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,R.EndOfLinePreference.TextDefined),text:o,eolCount:i,firstLineLength:t,lastLineLength:s,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(u){u.sort(I.w);const k=[];for(let b=0;b<u.length;b++){const c=u[b],g=c.range.startLineNumber,d=c.range.startColumn,m=c.range.endLineNumber,n=c.range.endColumn;if(g===m&&d===n&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const o=new A.$It(g,d,m,n);k.push({range:o,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return k}findMatchesLineByLine(u,k,b,c){return this.c.findMatchesLineByLine(u,k,b,c)}getPieceTree(){return this.c}static _getInverseEditRange(u,k){const b=u.startLineNumber,c=u.startColumn,[g,d,m]=(0,O.$su)(k);let n;if(k.length>0){const o=g+1;o===1?n=new A.$It(b,c,b,c+d):n=new A.$It(b,c,b+o-1,m+1)}else n=new A.$It(b,c,b,c);return n}static _getInverseEditRanges(u){const k=[];let b=0,c=0,g=null;for(let d=0,m=u.length;d<m;d++){const n=u[d];let o,i;g?g.range.endLineNumber===n.range.startLineNumber?(o=b,i=c+(n.range.startColumn-g.range.endColumn)):(o=b+(n.range.startLineNumber-g.range.endLineNumber),i=n.range.startColumn):(o=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const s=n.eolCount+1;s===1?t=new A.$It(o,i,o,i+n.firstLineLength):t=new A.$It(o,i,o+s-1,n.lastLineLength+1)}else t=new A.$It(o,i,o,i);b=t.endLineNumber,c=t.endColumn,k.push(t),g=n}return k}static u(u,k){const b=A.$It.compareRangesUsingEnds(u.range,k.range);return b===0?u.sortIndex-k.sortIndex:b}static w(u,k){const b=A.$It.compareRangesUsingEnds(u.range,k.range);return b===0?k.sortIndex-u.sortIndex:-b}}e.$iD=I}),define(Ee[214],Se([1,0,27,13,54,139,213]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0,h=We(h);class O{constructor(I,E,u,k,b,c,g,d,m){this.a=I,this.b=E,this.c=u,this.d=k,this.e=b,this.f=c,this.g=g,this.h=d,this.j=m}k(I){const E=this.c+this.d+this.e,u=this.c+this.e;return E===0?I===A.DefaultEndOfLine.LF?`
`:`\r
`:u>E/2?`\r
`:`
`}create(I){const E=this.k(I),u=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let b=0,c=u.length;b<c;b++){const g=u[b].buffer.replace(/\r\n|\r|\n/g,E),d=(0,R.$dD)(g);u[b]=new R.$gD(g,d)}const k=new L.$iD(u,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&h.$6f(I)&&(this.b=h.$5f,I=I.substr(1));const E=I.charCodeAt(I.length-1);E===r.CharCode.CarriageReturn||E>=55296&&E<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=E):(this.m(I,!1),this.c=!1,this.d=E)}m(I,E){!E&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const E=(0,R.$eD)(this.e,I);this.a.push(new R.$gD(I,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=h.$Uf(I)),this.k||(this.k=h.$Xf(I)))}finish(I=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const E=(0,R.$dD)(I.buffer);I.lineStarts=E,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$jD=$}),define(Ee[143],Se([1,0,22,11]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cb=$,e.$$cb=I,h=We(h);var A;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(A||(A={}));function R(E){for(let u=0,k=E.length;u<k;u+=4){const b=E[u+0],c=E[u+1],g=E[u+2],d=E[u+3];E[u+0]=d,E[u+1]=g,E[u+2]=c,E[u+3]=b}}function L(E){const u=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return h.$D()||R(u),r.$Oe.wrap(u)}function O(E){const u=E.buffer;if(h.$D()||R(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const k=new Uint8Array(u.byteLength);return k.set(u),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(E){const u=new Uint32Array(l(E));let k=0;if(u[k++]=E.id,E.type==="full")u[k++]=A.Full,u[k++]=E.data.length,u.set(E.data,k),k+=E.data.length;else{u[k++]=A.Delta,u[k++]=E.deltas.length;for(const b of E.deltas)u[k++]=b.start,u[k++]=b.deleteCount,b.data?(u[k++]=b.data.length,u.set(b.data,k),k+=b.data.length):u[k++]=0}return L(u)}function l(E){let u=0;if(u+=2,E.type==="full")u+=1+E.data.length;else{u+=1,u+=3*E.deltas.length;for(const k of E.deltas)k.data&&(u+=k.data.length)}return u}function I(E){const u=O(E);let k=0;const b=u[k++];if(u[k++]===A.Full){const m=u[k++],n=u.subarray(k,k+m);return k+=m,{id:b,type:"full",data:n}}const g=u[k++],d=[];for(let m=0;m<g;m++){const n=u[k++],o=u[k++],i=u[k++];let t;i>0&&(t=u.subarray(k,k+i),k+=i),d[m]={start:n,deleteCount:o,data:t}}return{id:b,type:"delta",deltas:d}}}),define(Ee[215],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/config/editorOptions",e)}),define(Ee[216],Se([7,8]),function(ce,e){return ce.create("vs/editor/common/languages",e)}),define(Ee[88],Se([1,0,83,2,189,31,199,216]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Ku=e.$Ju=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Iu=e.$Hu=e.SymbolKinds=e.SymbolTag=e.$Fu=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Du=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Cu=e.$Bu=e.$Au=void 0,e.$Eu=f,e.$Gu=w;class ${constructor(G,Q,ee){this.offset=G,this.type=Q,this.language=ee,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Au=$;class l{constructor(G,Q){this.tokens=G,this.endState=Q,this._tokenizationResultBrand=void 0}}e.$Bu=l;class I{constructor(G,Q){this.tokens=G,this.endState=Q,this._encodedTokenizationResultBrand=void 0}}e.$Cu=I;var E;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})(E||(e.HoverVerbosityAction=E={}));var u;(function(U){U[U.Method=0]="Method",U[U.Function=1]="Function",U[U.Constructor=2]="Constructor",U[U.Field=3]="Field",U[U.Variable=4]="Variable",U[U.Class=5]="Class",U[U.Struct=6]="Struct",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Event=10]="Event",U[U.Operator=11]="Operator",U[U.Unit=12]="Unit",U[U.Value=13]="Value",U[U.Constant=14]="Constant",U[U.Enum=15]="Enum",U[U.EnumMember=16]="EnumMember",U[U.Keyword=17]="Keyword",U[U.Text=18]="Text",U[U.Color=19]="Color",U[U.File=20]="File",U[U.Reference=21]="Reference",U[U.Customcolor=22]="Customcolor",U[U.Folder=23]="Folder",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue",U[U.Snippet=27]="Snippet"})(u||(e.CompletionItemKind=u={}));var k;(function(U){const G=new Map;G.set(u.Method,r.$5j.symbolMethod),G.set(u.Function,r.$5j.symbolFunction),G.set(u.Constructor,r.$5j.symbolConstructor),G.set(u.Field,r.$5j.symbolField),G.set(u.Variable,r.$5j.symbolVariable),G.set(u.Class,r.$5j.symbolClass),G.set(u.Struct,r.$5j.symbolStruct),G.set(u.Interface,r.$5j.symbolInterface),G.set(u.Module,r.$5j.symbolModule),G.set(u.Property,r.$5j.symbolProperty),G.set(u.Event,r.$5j.symbolEvent),G.set(u.Operator,r.$5j.symbolOperator),G.set(u.Unit,r.$5j.symbolUnit),G.set(u.Value,r.$5j.symbolValue),G.set(u.Enum,r.$5j.symbolEnum),G.set(u.Constant,r.$5j.symbolConstant),G.set(u.Enum,r.$5j.symbolEnum),G.set(u.EnumMember,r.$5j.symbolEnumMember),G.set(u.Keyword,r.$5j.symbolKeyword),G.set(u.Snippet,r.$5j.symbolSnippet),G.set(u.Text,r.$5j.symbolText),G.set(u.Color,r.$5j.symbolColor),G.set(u.File,r.$5j.symbolFile),G.set(u.Reference,r.$5j.symbolReference),G.set(u.Customcolor,r.$5j.symbolCustomColor),G.set(u.Folder,r.$5j.symbolFolder),G.set(u.TypeParameter,r.$5j.symbolTypeParameter),G.set(u.User,r.$5j.account),G.set(u.Issue,r.$5j.issues);function Q(ne){let De=G.get(ne);return De||(console.info("No codicon found for CompletionItemKind "+ne),De=r.$5j.symbolProperty),De}U.toIcon=Q;const ee=new Map;ee.set("method",u.Method),ee.set("function",u.Function),ee.set("constructor",u.Constructor),ee.set("field",u.Field),ee.set("variable",u.Variable),ee.set("class",u.Class),ee.set("struct",u.Struct),ee.set("interface",u.Interface),ee.set("module",u.Module),ee.set("property",u.Property),ee.set("event",u.Event),ee.set("operator",u.Operator),ee.set("unit",u.Unit),ee.set("value",u.Value),ee.set("constant",u.Constant),ee.set("enum",u.Enum),ee.set("enum-member",u.EnumMember),ee.set("enumMember",u.EnumMember),ee.set("keyword",u.Keyword),ee.set("snippet",u.Snippet),ee.set("text",u.Text),ee.set("color",u.Color),ee.set("file",u.File),ee.set("reference",u.Reference),ee.set("customcolor",u.Customcolor),ee.set("folder",u.Folder),ee.set("type-parameter",u.TypeParameter),ee.set("typeParameter",u.TypeParameter),ee.set("account",u.User),ee.set("issue",u.Issue);function ue(ne,De){let $e=ee.get(ne);return typeof $e>"u"&&!De&&($e=u.Property),$e}U.fromString=ue})(k||(e.CompletionItemKinds=k={}));var b;(function(U){U[U.Deprecated=1]="Deprecated"})(b||(e.CompletionItemTag=b={}));var c;(function(U){U[U.None=0]="None",U[U.KeepWhitespace=1]="KeepWhitespace",U[U.InsertAsSnippet=4]="InsertAsSnippet"})(c||(e.CompletionItemInsertTextRule=c={}));var g;(function(U){U[U.Word=0]="Word",U[U.Line=1]="Line",U[U.Suggest=2]="Suggest"})(g||(e.PartialAcceptTriggerKind=g={}));var d;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d||(e.CompletionTriggerKind=d={}));var m;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class n{constructor(G,Q,ee,ue){this.range=G,this.text=Q,this.completionKind=ee,this.isSnippetText=ue}equals(G){return R.$It.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}e.$Du=n;var o;(function(U){U[U.Invoke=1]="Invoke",U[U.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var i;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(i||(e.DocumentPasteTriggerKind=i={}));var t;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var s;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function f(U){return U&&h.URI.isUri(U.uri)&&R.$It.isIRange(U.range)&&(R.$It.isIRange(U.originSelectionRange)||R.$It.isIRange(U.targetSelectionRange))}var a;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(a||(e.SymbolKind=a={})),e.$Fu={[a.Array]:(0,O.localize)(0,null),[a.Boolean]:(0,O.localize)(1,null),[a.Class]:(0,O.localize)(2,null),[a.Constant]:(0,O.localize)(3,null),[a.Constructor]:(0,O.localize)(4,null),[a.Enum]:(0,O.localize)(5,null),[a.EnumMember]:(0,O.localize)(6,null),[a.Event]:(0,O.localize)(7,null),[a.Field]:(0,O.localize)(8,null),[a.File]:(0,O.localize)(9,null),[a.Function]:(0,O.localize)(10,null),[a.Interface]:(0,O.localize)(11,null),[a.Key]:(0,O.localize)(12,null),[a.Method]:(0,O.localize)(13,null),[a.Module]:(0,O.localize)(14,null),[a.Namespace]:(0,O.localize)(15,null),[a.Null]:(0,O.localize)(16,null),[a.Number]:(0,O.localize)(17,null),[a.Object]:(0,O.localize)(18,null),[a.Operator]:(0,O.localize)(19,null),[a.Package]:(0,O.localize)(20,null),[a.Property]:(0,O.localize)(21,null),[a.String]:(0,O.localize)(22,null),[a.Struct]:(0,O.localize)(23,null),[a.TypeParameter]:(0,O.localize)(24,null),[a.Variable]:(0,O.localize)(25,null)};function w(U,G){return(0,O.localize)(26,null,U,e.$Fu[G])}var y;(function(U){U[U.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var S;(function(U){const G=new Map;G.set(a.File,r.$5j.symbolFile),G.set(a.Module,r.$5j.symbolModule),G.set(a.Namespace,r.$5j.symbolNamespace),G.set(a.Package,r.$5j.symbolPackage),G.set(a.Class,r.$5j.symbolClass),G.set(a.Method,r.$5j.symbolMethod),G.set(a.Property,r.$5j.symbolProperty),G.set(a.Field,r.$5j.symbolField),G.set(a.Constructor,r.$5j.symbolConstructor),G.set(a.Enum,r.$5j.symbolEnum),G.set(a.Interface,r.$5j.symbolInterface),G.set(a.Function,r.$5j.symbolFunction),G.set(a.Variable,r.$5j.symbolVariable),G.set(a.Constant,r.$5j.symbolConstant),G.set(a.String,r.$5j.symbolString),G.set(a.Number,r.$5j.symbolNumber),G.set(a.Boolean,r.$5j.symbolBoolean),G.set(a.Array,r.$5j.symbolArray),G.set(a.Object,r.$5j.symbolObject),G.set(a.Key,r.$5j.symbolKey),G.set(a.Null,r.$5j.symbolNull),G.set(a.EnumMember,r.$5j.symbolEnumMember),G.set(a.Struct,r.$5j.symbolStruct),G.set(a.Event,r.$5j.symbolEvent),G.set(a.Operator,r.$5j.symbolOperator),G.set(a.TypeParameter,r.$5j.symbolTypeParameter);function Q(ee){let ue=G.get(ee);return ue||(console.info("No codicon found for SymbolKind "+ee),ue=r.$5j.symbolProperty),ue}U.toIcon=Q})(S||(e.SymbolKinds=S={}));class D{static asEditOperation(G){return A.$Jt.replace(R.$It.lift(G.range),G.text)}}e.$Hu=D;class P{static{this.Comment=new P("comment")}static{this.Imports=new P("imports")}static{this.Region=new P("region")}static fromValue(G){switch(G){case"comment":return P.Comment;case"imports":return P.Imports;case"region":return P.Region}return new P(G)}constructor(G){this.value=G}}e.$Iu=P;var C;(function(U){U[U.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var p;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(p||(e.NewSymbolNameTriggerKind=p={}));var v;(function(U){function G(Q){return!Q||typeof Q!="object"?!1:typeof Q.id=="string"&&typeof Q.title=="string"}U.is=G})(v||(e.Command=v={}));var N;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(N||(e.CommentThreadCollapsibleState=N={}));var T;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(T||(e.CommentThreadState=T={}));var M;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(M||(e.CommentThreadApplicability=M={}));var j;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var z;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(z||(e.CommentState=z={}));var F;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class B{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Ju=B,e.$Ku=new L.$ru;var _;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(_||(e.ExternalUriOpenerPriority=_={}));var re;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(re||(e.InlineEditTriggerKind=re={}))}),define(Ee[217],Se([7,8]),function(ce,e){return ce.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[218],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[219],Se([7,8]),function(ce,e){return ce.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[220],Se([7,8]),function(ce,e){return ce.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[221],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[222],Se([7,8]),function(ce,e){return ce.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[223],Se([7,8]),function(ce,e){return ce.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[224],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/files",e)}),define(Ee[225],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/common/io",e)}),define(Ee[226],Se([7,8]),function(ce,e){return ce.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[227],Se([7,8]),function(ce,e){return ce.create("vs/platform/log/common/log",e)}),define(Ee[228],Se([7,8]),function(ce,e){return ce.create("vs/platform/markers/common/markers",e)}),define(Ee[229],Se([7,8]),function(ce,e){return ce.create("vs/platform/request/common/request",e)}),define(Ee[230],Se([7,8]),function(ce,e){return ce.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[231],Se([7,8]),function(ce,e){return ce.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[232],Se([7,8]),function(ce,e){return ce.create("vs/platform/workspace/common/workspace",e)}),define(Ee[233],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[234],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[235],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[236],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[237],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[238],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[239],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[240],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[241],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[242],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[243],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[244],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[245],Se([7,8]),function(ce,e){return ce.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[246],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/configuration",e)}),define(Ee[247],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/editor",e)}),define(Ee[248],Se([7,8]),function(ce,e){return ce.create("vs/workbench/common/views",e)}),define(Ee[249],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[250],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[251],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[252],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[253],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[254],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[255],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[256],Se([7,8]),function(ce,e){return ce.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ee[257],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[258],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[259],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[260],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[261],Se([7,8]),function(ce,e){return ce.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[262],Se([1,0,27,14,219]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var R;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(R||(e.TokenType=R={}));function L(...I){switch(I.length){case 1:return(0,A.localize)(0,null,I[0]);case 2:return(0,A.localize)(1,null,I[0],I[1]);case 3:return(0,A.localize)(2,null,I[0],I[1],I[2]);default:return}}const O=(0,A.localize)(3,null),$=(0,A.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case R.LParen:return"(";case R.RParen:return")";case R.Neg:return"!";case R.Eq:return E.isTripleEq?"===":"==";case R.NotEq:return E.isTripleEq?"!==":"!=";case R.Lt:return"<";case R.LtEq:return"<=";case R.Gt:return">=";case R.GtEq:return">=";case R.RegexOp:return"=~";case R.RegexStr:return E.lexeme;case R.True:return"true";case R.False:return"false";case R.In:return"in";case R.Not:return"not";case R.And:return"&&";case R.Or:return"||";case R.Str:return E.lexeme;case R.QuotedStr:return E.lexeme;case R.Error:return E.lexeme;case R.EOF:return"EOF";default:throw(0,h.$0)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",R.Not],["in",R.In],["false",R.False],["true",R.True]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(R.LParen);break;case r.CharCode.CloseParen:this.k(R.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.NotEq,offset:this.d,isTripleEq:u})}else this.k(R.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const u=this.h(r.CharCode.Equals);this.f.push({type:R.Eq,offset:this.d,isTripleEq:u})}else this.h(r.CharCode.Tilde)?this.k(R.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?R.LtEq:R.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?R.GtEq:R.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(R.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(R.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(R.EOF),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const u=this.d,k=this.c.substring(this.d,this.e),b={type:R.Error,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:E}),this.f.push(b)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const u=this.c.substring(this.d,this.e),k=l.b.get(u);k?this.k(k):this.f.push({type:R.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:R.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,u=!1,k=!1;for(;;){if(E>=this.c.length){this.e=E,this.l($);return}const c=this.c.charCodeAt(E);if(u)u=!1;else if(c===r.CharCode.Slash&&!k){E++;break}else c===r.CharCode.OpenSquareBracket?k=!0:c===r.CharCode.Backslash?u=!0:c===r.CharCode.CloseSquareBracket&&(k=!1);E++}for(;E<this.c.length&&l.a.has(this.c.charCodeAt(E));)E++;this.e=E;const b=this.c.substring(this.d,this.e);this.f.push({type:R.RegexStr,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=l});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[263],Se([1,0,23,44,222,411]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=$,e.$Vp=l,e.$Wp=I,e.$Xp=E,e.$Yp=u,e.$Zp=k,e.$1p=b,h=Ut(h),A=We(A),R=We(R);const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function $(d){return d=d.trim(),d==="*"||L.test(d)}function l(d){if(!$(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=d.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}function I(d){if(!d)return null;const m=d.majorBase,n=d.majorMustEqual,o=d.minorBase;let i=d.minorMustEqual;const t=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(m===0||(i=!1),s=!1);let f=0;if(d.preRelease){const a=O.exec(d.preRelease);if(a){const[,w,y,S]=a;f=Date.UTC(Number(w),Number(y)-1,Number(S))}}return{majorBase:m,majorMustEqual:n,minorBase:o,minorMustEqual:i,patchBase:t,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:f}}function E(d,m,n){let o;typeof d=="string"?o=I(l(d)):o=d;let i;m instanceof Date?i=m.getTime():typeof m=="string"&&(i=new Date(m).getTime());let t;if(typeof n=="string"?t=I(l(n)):t=n,!o||!t)return!1;const s=o.majorBase,f=o.minorBase,a=o.patchBase;let w=t.majorBase,y=t.minorBase,S=t.patchBase;const D=t.notBefore;let P=t.majorMustEqual,C=t.minorMustEqual,p=t.patchMustEqual;return t.isMinimum?s>w?!0:s<w?!1:f>y?!0:f<y||i&&i<D?!1:a>=S:(s===1&&w===0&&(!P||!C||!p)&&(w=1,y=0,S=0,P=!0,C=!1,p=!1),s<w?!1:s>w?!P:f<y?!1:f>y?!C:a<S?!1:a>S?!p:!(i&&i<D))}function u(d,m,n,o,i){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([h.default.Error,A.localize(0,null)]),t;if(typeof o.name!="string")return t.push([h.default.Error,A.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([h.default.Error,A.localize(2,null,"version")]),t;if(!o.engines)return t.push([h.default.Error,A.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([h.default.Error,A.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!g(o.extensionDependencies))return t.push([h.default.Error,A.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!g(o.activationEvents))return t.push([h.default.Error,A.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([h.default.Error,A.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([h.default.Warning,A.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([h.default.Error,A.localize(9,null,"main")]),t;{const a=(0,r.$gh)(n,o.main);(0,r.$ah)(a,n)||t.push([h.default.Warning,A.localize(10,null,a.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([h.default.Error,A.localize(11,null,"browser")]),t;{const a=(0,r.$gh)(n,o.browser);(0,r.$ah)(a,n)||t.push([h.default.Warning,A.localize(12,null,a.path,n.path)])}}if(!R.valid(o.version))return t.push([h.default.Error,A.localize(13,null)]),t;const s=[];if(!k(d,m,o,i,s))for(const a of s)t.push([h.default.Error,a]);return t}function k(d,m,n,o,i){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:c(d,m,n.engines.vscode,i)}function b(d,m,n){return d==="*"||c(m,n,d)}function c(d,m,n,o=[]){const i=I(l(n));if(!i)return o.push(A.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return o.push(A.localize(15,null,n)),!1}else if(!i.majorMustEqual)return o.push(A.localize(16,null,n)),!1;return E(d,m,i)?!0:(o.push(A.localize(17,null,d,n)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let m=0,n=d.length;m<n;m++)if(typeof d[m]!="string")return!1;return!0}}),define(Ee[113],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class r{constructor(A,R=[],L=!1){this.ctor=A,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$Ci=r}),define(Ee[89],Se([1,0,113]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ls=R,e.$Ms=L;const h=[];var A;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function R(O,$,l){$ instanceof r.$Ci||($=new r.$Ci($,[],!!l)),h.push([O,$])}function L(){return h}}),define(Ee[264],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=void 0;class r{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$or=r;class h{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const O=this.lookupOrInsertNode(R),$=this.lookupOrInsertNode(L);O.outgoing.set($.key,$),$.incoming.set(O.key,O)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const O of this.a.values())O.outgoing.delete(L),O.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let O=this.a.get(L);return O||(O=new r(L,R),this.a.set(L,O)),O}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,O]of this.a)R.push(`${L}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const O=new Set([R]),$=this.c(L,O);if($)return $}}c(R,L){for(const[O,$]of R.outgoing){if(L.has(O))return[...L,O].join(" -> ");L.add(O);const l=this.c($,L);if(l)return l;L.delete(O)}}}e.$pr=h}),define(Ee[5],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=A,e.$Gi=R;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function O($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=O})(r||(e._util=r={})),e.$Ei=A("instantiationService");function h(L,O,$){O[r.DI_TARGET]===O?O[r.DI_DEPENDENCIES].push({id:L,index:$}):(O[r.DI_DEPENDENCIES]=[{id:L,index:$}],O[r.DI_TARGET]=O)}function A(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const O=function($,l,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");h(O,$,I)};return O.toString=()=>L,r.serviceIds.set(L,O),O}function R(L){return L}}),define(Ee[45],Se([1,0,18,2,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=R,e.$bj=L,e.$cj=$,e.$dj=l,e.$ej=I,e.$fj=E,e.$gj=u,e.$hj=b,e.$ij=c,e.$jj=g,r=We(r),e.$_i=(0,A.$Fi)("configurationService");function R(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof h.URI)}function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof h.URI)}var O;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function $(d){switch(d){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}function I(d,m){const n=Object.create(null);for(const o in d)E(n,o,d[o],m);return n}function E(d,m,n,o){const i=m.split("."),t=i.pop();let s=d;for(let f=0;f<i.length;f++){const a=i[f];let w=s[a];switch(typeof w){case"undefined":w=s[a]=Object.create(null);break;case"object":if(w===null){o(`Ignoring ${m} as ${i.slice(0,f+1).join(".")} is null`);return}break;default:o(`Ignoring ${m} as ${i.slice(0,f+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[t]=n}catch{o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}else o(`Ignoring ${m} as ${i.join(".")} is ${JSON.stringify(s)}`)}function u(d,m){const n=m.split(".");k(d,n)}function k(d,m){const n=m.shift();if(m.length===0){delete d[n];return}if(Object.keys(d).indexOf(n)!==-1){const o=d[n];typeof o=="object"&&!Array.isArray(o)&&(k(o,m),Object.keys(o).length===0&&delete d[n])}}function b(d,m,n){function o(s,f){let a=s;for(const w of f){if(typeof a!="object"||a===null)return;a=a[w]}return a}const i=m.split("."),t=o(d,i);return typeof t>"u"?n:t}function c(d,m,n){Object.keys(m).forEach(o=>{o!=="__proto__"&&(o in d?r.$hg(d[o])&&r.$hg(m[o])?c(d[o],m[o],n):n&&(d[o]=m[o]):d[o]=m[o])})}function g(d){return d.replace(/[\[\]]/g,"")}}),define(Ee[36],Se([1,0,27,11,13,262,5,218,14]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=I,e.$Ej=f,e.$Fj=a,e.$Yj=ne;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",h.$j),l.set("isLinux",h.$k),l.set("isWindows",h.$i),l.set("isWeb",h.$o),l.set("isMacNative",h.$j&&!h.$o),l.set("isEdge",h.$H),l.set("isFirefox",h.$F),l.set("isChrome",h.$E),l.set("isSafari",h.$G);function I(K,W){if(l.get(K)!==void 0)throw(0,$.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(K,W)}const E=Object.prototype.hasOwnProperty;var u;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},b=(0,O.localize)(0,null),c=(0,O.localize)(1,null),g=(0,O.localize)(2,null),d=(0,O.localize)(3,null),m=(0,O.localize)(4,null),n=(0,O.localize)(5,null),o=(0,O.localize)(6,null),i=(0,O.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=k){this.k=W,this.d=new R.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const se=this.l();if(!this.E()){const oe=this.D(),te=oe.type===R.TokenType.Str?n:void 0;throw this.h.push({message:m,offset:oe.offset,lexeme:R.$Aj.getLexeme(oe),additionalInfo:te}),t.c}return se}catch(se){if(se!==t.c)throw se;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(R.TokenType.Or);){const se=this.o();W.push(se)}return W.length===1?W[0]:s.or(...W)}o(){const W=[this.s()];for(;this.y(R.TokenType.And);){const se=this.s();W.push(se)}return W.length===1?W[0]:s.and(...W)}s(){if(this.y(R.TokenType.Neg)){const W=this.D();switch(W.type){case R.TokenType.True:return this.z(),y.INSTANCE;case R.TokenType.False:return this.z(),S.INSTANCE;case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,d),se?.negate()}case R.TokenType.Str:return this.z(),N.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case R.TokenType.True:return this.z(),s.true();case R.TokenType.False:return this.z(),s.false();case R.TokenType.LParen:{this.z();const se=this.l();return this.A(R.TokenType.RParen,d),se}case R.TokenType.Str:{const se=W.lexeme;if(this.z(),this.y(R.TokenType.RegexOp)){const te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),te.type!==R.TokenType.RegexStr)throw this.B("REGEX",te);const le=te.lexeme,he=le.lastIndexOf("/"),X=he===le.length-1?void 0:this.w(le.substring(he+1));let ae;try{ae=new RegExp(le.substring(1,he),X)}catch{throw this.B("REGEX",te)}return B.create(se,ae)}switch(te.type){case R.TokenType.RegexStr:case R.TokenType.Error:{const le=[te.lexeme];this.z();let he=this.D(),X=0;for(let Be=0;Be<te.lexeme.length;Be++)te.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&X--;for(;!this.E()&&he.type!==R.TokenType.And&&he.type!==R.TokenType.Or;){switch(he.type){case R.TokenType.LParen:X++;break;case R.TokenType.RParen:X--;break;case R.TokenType.RegexStr:case R.TokenType.QuotedStr:for(let Be=0;Be<he.lexeme.length;Be++)he.lexeme.charCodeAt(Be)===r.CharCode.OpenParen?X++:te.lexeme.charCodeAt(Be)===r.CharCode.CloseParen&&X--}if(X<0)break;le.push(R.$Aj.getLexeme(he)),this.z(),he=this.D()}const ae=le.join(""),pe=ae.lastIndexOf("/"),be=pe===ae.length-1?void 0:this.w(ae.substring(pe+1));let Fe;try{Fe=new RegExp(ae.substring(1,pe),be)}catch{throw this.B("REGEX",te)}return s.regex(se,Fe)}case R.TokenType.QuotedStr:{const le=te.lexeme;this.z();let he=null;if(!(0,A.$df)(le)){const X=le.indexOf("/"),ae=le.lastIndexOf("/");if(X!==ae&&X>=0){const pe=le.slice(X+1,ae),be=le[ae+1]==="i"?"i":"";try{he=new RegExp(pe,be)}catch{throw this.B("REGEX",te)}}}if(he===null)throw this.B("REGEX",te);return B.create(se,he)}default:throw this.B("REGEX",this.D())}}if(this.y(R.TokenType.Not)){this.A(R.TokenType.In,g);const te=this.u();return s.notIn(se,te)}switch(this.D().type){case R.TokenType.Eq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.equals(se,te);switch(te){case"true":return s.has(se);case"false":return s.not(se);default:return s.equals(se,te)}}case R.TokenType.NotEq:{this.z();const te=this.u();if(this.x().type===R.TokenType.QuotedStr)return s.notEquals(se,te);switch(te){case"true":return s.not(se);case"false":return s.has(se);default:return s.notEquals(se,te)}}case R.TokenType.Lt:return this.z(),z.create(se,this.u());case R.TokenType.LtEq:return this.z(),F.create(se,this.u());case R.TokenType.Gt:return this.z(),M.create(se,this.u());case R.TokenType.GtEq:return this.z(),j.create(se,this.u());case R.TokenType.In:return this.z(),s.in(se,this.u());default:return s.has(se)}}case R.TokenType.EOF:throw this.h.push({message:o,offset:W.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case R.TokenType.Str:case R.TokenType.QuotedStr:return this.z(),W.lexeme;case R.TokenType.True:return this.z(),"true";case R.TokenType.False:return this.z(),"false";case R.TokenType.In:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,se){if(this.C(W))return this.z();throw this.B(se,this.D())}B(W,se,oe){const te=(0,O.localize)(8,null,W,R.$Aj.getLexeme(se)),le=se.offset,he=R.$Aj.getLexeme(se);return this.h.push({message:te,offset:le,lexeme:he,additionalInfo:oe}),t.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===R.TokenType.EOF}}e.$Cj=t;class s{static false(){return y.INSTANCE}static true(){return S.INSTANCE}static has(W){return D.create(W)}static equals(W,se){return P.create(W,se)}static notEquals(W,se){return v.create(W,se)}static regex(W,se){return B.create(W,se)}static in(W,se){return C.create(W,se)}static notIn(W,se){return p.create(W,se)}static not(W){return N.create(W)}static and(...W){return U.create(W,null,!0)}static or(...W){return G.create(W,null,!0)}static greater(W,se){return M.create(W,se)}static greaterEquals(W,se){return j.create(W,se)}static smaller(W,se){return z.create(W,se)}static smallerEquals(W,se){return F.create(W,se)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Dj=s;function f(K){const W=new t({regexParsingWithErrorRecovery:!1});return K.map(se=>(W.parse(se),W.lexingErrors.length>0?W.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,O.localize)(9,null,oe.additionalInfo):(0,O.localize)(10,null),offset:oe.offset,length:oe.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function a(K,W){const se=K?K.substituteConstants():void 0,oe=W?W.substituteConstants():void 0;return!se&&!oe?!0:!se||!oe?!1:se.equals(oe)}function w(K,W){return K.cmp(W)}class y{static{this.INSTANCE=new y}constructor(){this.type=u.False}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return S.INSTANCE}}e.$Gj=y;class S{static{this.INSTANCE=new S}constructor(){this.type=u.True}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return y.INSTANCE}}e.$Hj=S;class D{static create(W,se=null){const oe=l.get(W);return typeof oe=="boolean"?oe?S.INSTANCE:y.INSTANCE:new D(W,se)}constructor(W,se){this.key=W,this.c=se,this.type=u.Defined}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=l.get(this.key);return typeof W=="boolean"?W?S.INSTANCE:y.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Ij=D;class P{static create(W,se,oe=null){if(typeof se=="boolean")return se?D.create(W,oe):N.create(W,oe);const te=l.get(W);return typeof te=="boolean"?se===(te?"true":"false")?S.INSTANCE:y.INSTANCE:new P(W,se,oe)}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Equals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=l.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?S.INSTANCE:y.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Jj=P;class C{static create(W,se){return new C(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.In,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.f),oe=W.getValue(this.d);return Array.isArray(se)?se.includes(oe):typeof oe=="string"&&typeof se=="object"&&se!==null?E.call(se,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Kj=C;class p{static create(W,se){return new p(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.NotIn,this.c=C.create(W,se)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=p;class v{static create(W,se,oe=null){if(typeof se=="boolean")return se?N.create(W,oe):D.create(W,oe);const te=l.get(W);return typeof te=="boolean"?se===(te?"true":"false")?y.INSTANCE:S.INSTANCE:new v(W,se,oe)}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.NotEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=l.get(this.c);if(typeof W=="boolean"){const se=W?"true":"false";return this.d===se?y.INSTANCE:S.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Mj=v;class N{static create(W,se=null){const oe=l.get(W);return typeof oe=="boolean"?oe?y.INSTANCE:S.INSTANCE:new N(W,se)}constructor(W,se){this.c=W,this.d=se,this.type=u.Not}cmp(W){return W.type!==this.type?this.type-W.type:ee(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=l.get(this.c);return typeof W=="boolean"?W?y.INSTANCE:S.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$Nj=N;function T(K,W){if(typeof K=="string"){const se=parseFloat(K);isNaN(se)||(K=se)}return typeof K=="string"||typeof K=="number"?W(K):y.INSTANCE}class M{static create(W,se,oe=null){return T(se,te=>new M(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Greater}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=M;class j{static create(W,se,oe=null){return T(se,te=>new j(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.GreaterEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Pj=j;class z{static create(W,se,oe=null){return T(se,te=>new z(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.Smaller}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Qj=z;class F{static create(W,se,oe=null){return T(se,te=>new F(W,te,oe))}constructor(W,se,oe){this.c=W,this.d=se,this.f=oe,this.type=u.SmallerEquals}cmp(W){return W.type!==this.type?this.type-W.type:ue(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Rj=F;class B{static create(W,se){return new B(W,se)}constructor(W,se){this.d=W,this.f=se,this.type=u.Regex,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const se=this.f?this.f.source:"",oe=W.f?W.f.source:"";return se<oe?-1:se>oe?1:0}equals(W){if(W.type===this.type){const se=this.f?this.f.source:"",oe=W.f?W.f.source:"";return this.d===W.d&&se===oe}return!1}substituteConstants(){return this}evaluate(W){const se=W.getValue(this.d);return this.f?this.f.test(se):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.$Sj=B;class _{static create(W){return new _(W)}constructor(W){this.c=W,this.type=u.NotRegex}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new _(this.c.map(W))}negate(){return this.c}}e.$Tj=_;function re(K){let W=null;for(let se=0,oe=K.length;se<oe;se++){const te=K[se].substituteConstants();if(K[se]!==te&&W===null){W=[];for(let le=0;le<se;le++)W[le]=K[le]}W!==null&&(W[se]=te)}return W===null?K:W}class U{static create(W,se,oe){return U.d(W,se,oe)}constructor(W,se){this.expr=W,this.c=se,this.type=u.And}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:U.create(W,this.c,!1)}evaluate(W){for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].evaluate(W))return!1;return!0}static d(W,se,oe){const te=[];let le=!1;for(const he of W)if(he){if(he.type===u.True){le=!0;continue}if(he.type===u.False)return y.INSTANCE;if(he.type===u.And){te.push(...he.expr);continue}te.push(he)}if(te.length===0&&le)return S.INSTANCE;if(te.length!==0){if(te.length===1)return te[0];te.sort(w);for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];for(;te.length>1;){const he=te[te.length-1];if(he.type!==u.Or)break;te.pop();const X=te.pop(),ae=te.length===0,pe=G.create(he.expr.map(be=>U.create([be,X],null,oe)),null,ae);pe&&(te.push(pe),te.sort(w))}if(te.length===1)return te[0];if(oe){for(let he=0;he<te.length;he++)for(let X=he+1;X<te.length;X++)if(te[he].negate().equals(te[X]))return y.INSTANCE;if(te.length===1)return te[0]}return new U(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new U(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());this.c=G.create(W,this,!0)}return this.c}}e.$Uj=U;class G{static create(W,se,oe){return G.d(W,se,oe)}constructor(W,se){this.expr=W,this.c=se,this.type=u.Or}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let se=0,oe=this.expr.length;se<oe;se++){const te=w(this.expr[se],W.expr[se]);if(te!==0)return te}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let se=0,oe=this.expr.length;se<oe;se++)if(!this.expr[se].equals(W.expr[se]))return!1;return!0}return!1}substituteConstants(){const W=re(this.expr);return W===this.expr?this:G.create(W,this.c,!1)}evaluate(W){for(let se=0,oe=this.expr.length;se<oe;se++)if(this.expr[se].evaluate(W))return!0;return!1}static d(W,se,oe){let te=[],le=!1;if(W){for(let he=0,X=W.length;he<X;he++){const ae=W[he];if(ae){if(ae.type===u.False){le=!0;continue}if(ae.type===u.True)return S.INSTANCE;if(ae.type===u.Or){te=te.concat(ae.expr);continue}te.push(ae)}}if(te.length===0&&le)return y.INSTANCE;te.sort(w)}if(te.length!==0){if(te.length===1)return te[0];for(let he=1;he<te.length;he++)te[he-1].equals(te[he])&&(te.splice(he,1),he--);if(te.length===1)return te[0];if(oe){for(let he=0;he<te.length;he++)for(let X=he+1;X<te.length;X++)if(te[he].negate().equals(te[X]))return S.INSTANCE;if(te.length===1)return te[0]}return new G(te,se)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const se of this.expr)W.push(...se.keys());return W}map(W){return new G(this.expr.map(se=>se.map(W)),null)}negate(){if(!this.c){const W=[];for(const se of this.expr)W.push(se.negate());for(;W.length>1;){const se=W.shift(),oe=W.shift(),te=[];for(const le of $e(se))for(const he of $e(oe))te.push(U.create([le,he],null,!1));W.unshift(G.create(te,null,!1))}this.c=G.create(W,this,!0)}return this.c}}e.$Vj=G;class Q extends D{static{this.d=[]}static all(){return Q.d.values()}constructor(W,se,oe){super(W,null),this.f=se,typeof oe=="object"?Q.d.push({...oe,key:W}):oe!==!0&&Q.d.push({key:W,description:oe,type:se!=null?typeof se:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return P.create(this.key,W)}notEqualsTo(W){return v.create(this.key,W)}}e.$Wj=Q,e.$Xj=(0,L.$Fi)("contextKeyService");function ee(K,W){return K<W?-1:K>W?1:0}function ue(K,W,se,oe){return K<se?-1:K>se?1:W<oe?-1:W>oe?1:0}function ne(K,W){if(K.type===u.False||W.type===u.True)return!0;if(K.type===u.Or)return W.type===u.Or?De(K.expr,W.expr):!1;if(W.type===u.Or){for(const se of W.expr)if(ne(K,se))return!0;return!1}if(K.type===u.And){if(W.type===u.And)return De(W.expr,K.expr);for(const se of K.expr)if(ne(se,W))return!0;return!1}return K.equals(W)}function De(K,W){let se=0,oe=0;for(;se<K.length&&oe<W.length;){const te=K[se].cmp(W[oe]);if(te<0)return!1;te===0&&se++,oe++}return se===K.length}function $e(K){return K.type===u.Or?K.expr:[K]}}),define(Ee[265],Se([1,0,36,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$mt=e.AccessibilitySupport=e.$lt=void 0,e.$nt=R,e.$lt=(0,h.$Fi)("accessibilityService");var A;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(A||(e.AccessibilitySupport=A={})),e.$mt=new r.$Wj("accessibilityModeEnabled",!1);function R(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$ot="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[114],Se([1,0,19,25,11,183,84,191,138,215,265]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=s,e.stringSet=w,e.cursorStyleToString=T,e.filterValidationDecorations=Ie,r=We(r),h=We(h),A=We(A),l=We(l);var E;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(de){this.c=de}hasChanged(de){return this.c[de]}}e.ConfigurationChangedEvent=u;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class b{constructor(de,Ce,Xe,_e){this.id=de,this.name=Ce,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ce){return g(de,Ce)}compute(de,Ce,Xe){return Xe}}class c{constructor(de,Ce){this.newValue=de,this.didChange=Ce}}e.ApplyUpdateResult=c;function g(Y,de){if(typeof Y!="object"||typeof de!="object"||!Y||!de)return new c(de,Y!==de);if(Array.isArray(Y)||Array.isArray(de)){const Xe=Array.isArray(Y)&&Array.isArray(de)&&r.$wb(Y,de);return new c(de,!Xe)}let Ce=!1;for(const Xe in de)if(de.hasOwnProperty(Xe)){const _e=g(Y[Xe],de[Xe]);_e.didChange&&(Y[Xe]=_e.newValue,Ce=!0)}return new c(Y,Ce)}class d{constructor(de){this.schema=void 0,this.id=de,this.name="_never_",this.defaultValue=void 0}applyUpdate(de,Ce){return g(de,Ce)}validate(de){return this.defaultValue}}class m{constructor(de,Ce,Xe,_e){this.id=de,this.name=Ce,this.defaultValue=Xe,this.schema=_e}applyUpdate(de,Ce){return g(de,Ce)}validate(de){return typeof de>"u"?this.defaultValue:de}compute(de,Ce,Xe){return Xe}}function n(Y,de){return typeof Y>"u"?de:Y==="false"?!1:!!Y}class o extends m{constructor(de,Ce,Xe,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Xe),super(de,Ce,Xe,_e)}validate(de){return n(de,this.defaultValue)}}function i(Y,de,Ce,Xe){if(typeof Y>"u")return de;let _e=parseInt(Y,10);return isNaN(_e)?de:(_e=Math.max(Ce,_e),_e=Math.min(Xe,_e),_e|0)}class t extends m{static clampedInt(de,Ce,Xe,_e){return i(de,Ce,Xe,_e)}constructor(de,Ce,Xe,_e,lt,gt=void 0){typeof gt<"u"&&(gt.type="integer",gt.default=Xe,gt.minimum=_e,gt.maximum=lt),super(de,Ce,Xe,gt),this.minimum=_e,this.maximum=lt}validate(de){return t.clampedInt(de,this.defaultValue,this.minimum,this.maximum)}}function s(Y,de,Ce,Xe){if(typeof Y>"u")return de;const _e=f.float(Y,de);return f.clamp(_e,Ce,Xe)}class f extends m{static clamp(de,Ce,Xe){return de<Ce?Ce:de>Xe?Xe:de}static float(de,Ce){if(typeof de=="number")return de;if(typeof de>"u")return Ce;const Xe=parseFloat(de);return isNaN(Xe)?Ce:Xe}constructor(de,Ce,Xe,_e,lt){typeof lt<"u"&&(lt.type="number",lt.default=Xe),super(de,Ce,Xe,lt),this.validationFn=_e}validate(de){return this.validationFn(f.float(de,this.defaultValue))}}class a extends m{static string(de,Ce){return typeof de!="string"?Ce:de}constructor(de,Ce,Xe,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Xe),super(de,Ce,Xe,_e)}validate(de){return a.string(de,this.defaultValue)}}function w(Y,de,Ce,Xe){return typeof Y!="string"?de:Xe&&Y in Xe?Xe[Y]:Ce.indexOf(Y)===-1?de:Y}class y extends m{constructor(de,Ce,Xe,_e,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=Xe),super(de,Ce,Xe,lt),this.c=_e}validate(de){return w(de,this.defaultValue,this.c)}}class S extends b{constructor(de,Ce,Xe,_e,lt,gt,kt=void 0){typeof kt<"u"&&(kt.type="string",kt.enum=lt,kt.default=_e),super(de,Ce,Xe,kt),this.c=lt,this.d=gt}validate(de){return typeof de!="string"?this.defaultValue:this.c.indexOf(de)===-1?this.defaultValue:this.d(de)}}function D(Y){switch(Y){case"none":return E.None;case"keep":return E.Keep;case"brackets":return E.Brackets;case"advanced":return E.Advanced;case"full":return E.Full}}class P extends b{constructor(){super(Me.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(de){switch(de){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(de,Ce,Xe){return Xe===I.AccessibilitySupport.Unknown?de.accessibilitySupport:Xe}}class C extends b{constructor(){const de={insertSpace:!0,ignoreEmptyLines:!0};super(Me.comments,"comments",de,{"editor.comments.insertSpace":{type:"boolean",default:de.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:de.ignoreEmptyLines,description:l.localize(5,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertSpace:n(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var p;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(p||(e.TextEditorCursorBlinkingStyle=p={}));function v(Y){switch(Y){case"blink":return p.Blink;case"smooth":return p.Smooth;case"phase":return p.Phase;case"expand":return p.Expand;case"solid":return p.Solid}}var N;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function T(Y){switch(Y){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function M(Y){switch(Y){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class j extends d{constructor(){super(Me.editorClassName)}compute(de,Ce,Xe){const _e=["monaco-editor"];return Ce.get(Me.extraEditorClassName)&&_e.push(Ce.get(Me.extraEditorClassName)),de.extraEditorClassName&&_e.push(de.extraEditorClassName),Ce.get(Me.mouseStyle)==="default"?_e.push("mouse-default"):Ce.get(Me.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ce.get(Me.showUnused)&&_e.push("showUnused"),Ce.get(Me.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class z extends o{constructor(){super(Me.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(de,Ce,Xe){return Xe&&de.emptySelectionClipboard}}class F extends b{constructor(){const de={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Me.find,"find",de,{"editor.find.cursorMoveOnType":{type:"boolean",default:de.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:de.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:de.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:de.globalFindClipboard,description:l.localize(16,null),included:A.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:de.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:de.loop,description:l.localize(18,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{cursorMoveOnType:n(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof de.seedSearchStringFromSelection=="boolean"?de.seedSearchStringFromSelection?"always":"never":w(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof de.autoFindInSelection=="boolean"?de.autoFindInSelection?"always":"never":w(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(Ce.loop,this.defaultValue.loop)}}}class B extends b{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(Me.fontLigatures,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"||de.length===0?B.OFF:de==="true"?B.ON:de:de?B.ON:B.OFF}}e.EditorFontLigatures=B;class _ extends b{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(Me.fontVariations,"fontVariations",_.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de==="false"?_.OFF:de==="true"?_.TRANSLATE:de:de?_.TRANSLATE:_.OFF}compute(de,Ce,Xe){return de.fontInfo.fontVariationSettings}}e.EditorFontVariations=_;class re extends d{constructor(){super(Me.fontInfo)}compute(de,Ce,Xe){return de.fontInfo}}class U extends m{constructor(){super(Me.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(de){const Ce=f.float(de,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(Ce,6,100)}compute(de,Ce,Xe){return de.fontInfo.fontSize}}class G extends b{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(Me.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(de){return de==="normal"||de==="bold"?de:String(t.clampedInt(de,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class Q extends b{constructor(){const de={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:de.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Me.gotoLocation,"gotoLocation",de,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:de.alternativeDefinitionCommand,enum:Xe,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:de.alternativeTypeDefinitionCommand,enum:Xe,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:de.alternativeDeclarationCommand,enum:Xe,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:de.alternativeImplementationCommand,enum:Xe,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:de.alternativeReferenceCommand,enum:Xe,description:l.localize(41,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{multiple:w(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??w(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??w(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??w(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??w(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??w(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:a.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:a.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:a.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:a.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:a.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ee extends b{constructor(){const de={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Me.hover,"hover",de,{"editor.hover.enabled":{type:"boolean",default:de.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:de.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:de.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:de.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:de.above,description:l.localize(46,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),delay:t.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:n(Ce.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(Ce.above,this.defaultValue.above)}}}var ue;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(ue||(e.RenderMinimap=ue={}));class ne extends d{constructor(){super(Me.layoutInfo)}compute(de,Ce,Xe){return ne.computeLayout(Ce,{memory:de.memory,outerWidth:de.outerWidth,outerHeight:de.outerHeight,isDominatedByLongLines:de.isDominatedByLongLines,lineHeight:de.fontInfo.lineHeight,viewLineCount:de.viewLineCount,lineNumbersDigitCount:de.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:de.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:de.fontInfo.maxDigitWidth,pixelRatio:de.pixelRatio,glyphMarginDecorationLaneCount:de.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(de){const Ce=de.height/de.lineHeight,Xe=Math.floor(de.paddingTop/de.lineHeight);let _e=Math.floor(de.paddingBottom/de.lineHeight);de.scrollBeyondLastLine&&(_e=Math.max(_e,Ce-1));const lt=(Xe+de.viewLineCount+_e)/(de.pixelRatio*de.height),gt=Math.floor(de.viewLineCount/lt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:_e,desiredRatio:lt,minimapLineCount:gt}}static c(de,Ce){const Xe=de.outerWidth,_e=de.outerHeight,lt=de.pixelRatio;if(!de.minimap.enabled)return{renderMinimap:ue.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const gt=Ce.stableMinimapLayoutInput,kt=gt&&de.outerHeight===gt.outerHeight&&de.lineHeight===gt.lineHeight&&de.typicalHalfwidthCharacterWidth===gt.typicalHalfwidthCharacterWidth&&de.pixelRatio===gt.pixelRatio&&de.scrollBeyondLastLine===gt.scrollBeyondLastLine&&de.paddingTop===gt.paddingTop&&de.paddingBottom===gt.paddingBottom&&de.minimap.enabled===gt.minimap.enabled&&de.minimap.side===gt.minimap.side&&de.minimap.size===gt.minimap.size&&de.minimap.showSlider===gt.minimap.showSlider&&de.minimap.renderCharacters===gt.minimap.renderCharacters&&de.minimap.maxColumn===gt.minimap.maxColumn&&de.minimap.scale===gt.minimap.scale&&de.verticalScrollbarWidth===gt.verticalScrollbarWidth&&de.isViewportWrapping===gt.isViewportWrapping,Ot=de.lineHeight,Wt=de.typicalHalfwidthCharacterWidth,ui=de.scrollBeyondLastLine,it=de.minimap.renderCharacters;let Ct=lt>=2?Math.round(de.minimap.scale*2):de.minimap.scale;const Zt=de.minimap.maxColumn,mt=de.minimap.size,bt=de.minimap.side,hi=de.verticalScrollbarWidth,ei=de.viewLineCount,qt=de.remainingWidth,wt=de.isViewportWrapping,Vt=it?2:3;let Jt=Math.floor(lt*_e);const Xt=Jt/lt;let xe=!1,$i=!1,ti=Vt*Ct,si=Ct/lt,Dt=1;if(mt==="fill"||mt==="fit"){const{typicalViewportLineCount:Bt,extraLinesBeforeFirstLine:Qt,extraLinesBeyondLastLine:di,desiredRatio:jt,minimapLineCount:vt}=ne.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:ui,paddingTop:de.paddingTop,paddingBottom:de.paddingBottom,height:_e,lineHeight:Ot,pixelRatio:lt});if(ei/vt>1)xe=!0,$i=!0,Ct=1,ti=1,si=Ct/lt;else{let Tt=!1,It=Ct+1;if(mt==="fit"){const Yt=Math.ceil((Qt+ei+di)*ti);wt&&kt&&qt<=Ce.stableFitRemainingWidth?(Tt=!0,It=Ce.stableFitMaxMinimapScale):Tt=Yt>Jt}if(mt==="fill"||Tt){xe=!0;const Yt=Ct;ti=Math.min(Ot*lt,Math.max(1,Math.floor(1/jt))),wt&&kt&&qt<=Ce.stableFitRemainingWidth&&(It=Ce.stableFitMaxMinimapScale),Ct=Math.min(It,Math.max(1,Math.floor(ti/Vt))),Ct>Yt&&(Dt=Math.min(2,Ct/Yt)),si=Ct/lt/Dt,Jt=Math.ceil(Math.max(Bt,Qt+ei+di)*ti),wt?(Ce.stableMinimapLayoutInput=de,Ce.stableFitRemainingWidth=qt,Ce.stableFitMaxMinimapScale=Ct):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Kt=Math.floor(Zt*si),Lt=Math.min(Kt,Math.max(0,Math.floor((qt-hi-2)*si/(Wt+si)))+e.MINIMAP_GUTTER_WIDTH);let Mt=Math.floor(lt*Lt);const ii=Mt/lt;Mt=Math.floor(Mt*Dt);const ni=it?ue.Text:ue.Blocks,oi=bt==="left"?0:Xe-Lt-hi;return{renderMinimap:ni,minimapLeft:oi,minimapWidth:Lt,minimapHeightIsEditorHeight:xe,minimapIsSampling:$i,minimapScale:Ct,minimapLineHeight:ti,minimapCanvasInnerWidth:Mt,minimapCanvasInnerHeight:Jt,minimapCanvasOuterWidth:ii,minimapCanvasOuterHeight:Xt}}static computeLayout(de,Ce){const Xe=Ce.outerWidth|0,_e=Ce.outerHeight|0,lt=Ce.lineHeight|0,gt=Ce.lineNumbersDigitCount|0,kt=Ce.typicalHalfwidthCharacterWidth,Ot=Ce.maxDigitWidth,Wt=Ce.pixelRatio,ui=Ce.viewLineCount,it=de.get(Me.wordWrapOverride2),Ct=it==="inherit"?de.get(Me.wordWrapOverride1):it,Zt=Ct==="inherit"?de.get(Me.wordWrap):Ct,mt=de.get(Me.wordWrapColumn),bt=Ce.isDominatedByLongLines,hi=de.get(Me.glyphMargin),ei=de.get(Me.lineNumbers).renderType!==Be.Off,qt=de.get(Me.lineNumbersMinChars),wt=de.get(Me.scrollBeyondLastLine),Vt=de.get(Me.padding),Jt=de.get(Me.minimap),Xt=de.get(Me.scrollbar),xe=Xt.verticalScrollbarSize,$i=Xt.verticalHasArrows,ti=Xt.arrowSize,si=Xt.horizontalScrollbarSize,Dt=de.get(Me.folding),Kt=de.get(Me.showFoldingControls)!=="never";let Lt=de.get(Me.lineDecorationsWidth);Dt&&Kt&&(Lt+=16);let Mt=0;if(ei){const pi=Math.max(gt,qt);Mt=Math.round(pi*Ot)}let ii=0;hi&&(ii=lt*Ce.glyphMarginDecorationLaneCount);let ni=0,oi=ni+ii,Bt=oi+Mt,Qt=Bt+Lt;const di=Xe-ii-Mt-Lt;let jt=!1,vt=!1,Pt=-1;Ct==="inherit"&&bt?(jt=!0,vt=!0):Zt==="on"||Zt==="bounded"?vt=!0:Zt==="wordWrapColumn"&&(Pt=mt);const Tt=ne.c({outerWidth:Xe,outerHeight:_e,lineHeight:lt,typicalHalfwidthCharacterWidth:kt,pixelRatio:Wt,scrollBeyondLastLine:wt,paddingTop:Vt.top,paddingBottom:Vt.bottom,minimap:Jt,verticalScrollbarWidth:xe,viewLineCount:ui,remainingWidth:di,isViewportWrapping:vt},Ce.memory||new k);Tt.renderMinimap!==ue.None&&Tt.minimapLeft===0&&(ni+=Tt.minimapWidth,oi+=Tt.minimapWidth,Bt+=Tt.minimapWidth,Qt+=Tt.minimapWidth);const It=di-Tt.minimapWidth,Yt=Math.max(1,Math.floor((It-xe-2)/kt)),Ht=$i?ti:0;return vt&&(Pt=Math.max(1,Yt),Zt==="bounded"&&(Pt=Math.min(Pt,mt))),{width:Xe,height:_e,glyphMarginLeft:ni,glyphMarginWidth:ii,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:oi,lineNumbersWidth:Mt,decorationsLeft:Bt,decorationsWidth:Lt,contentLeft:Qt,contentWidth:It,minimap:Tt,viewportColumn:Yt,isWordWrapMinified:jt,isViewportWrapping:vt,wrappingColumn:Pt,verticalScrollbarWidth:xe,horizontalScrollbarHeight:si,overviewRuler:{top:Ht,width:xe,height:_e-2*Ht,right:0}}}}e.EditorLayoutInfoComputer=ne;class De extends b{constructor(){super(Me.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(de){return w(de,"simple",["simple","advanced"])}compute(de,Ce,Xe){return Ce.get(Me.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var $e;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})($e||(e.ShowLightbulbIconMode=$e={}));class K extends b{constructor(){const de={enabled:$e.On};super(Me.lightbulb,"lightbulb",de,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[$e.Off,$e.OnCode,$e.On],default:de.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{enabled:w(de.enabled,this.defaultValue.enabled,[$e.Off,$e.OnCode,$e.On])}}}class W extends b{constructor(){const de={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Me.stickyScroll,"stickyScroll",de,{"editor.stickyScroll.enabled":{type:"boolean",default:de.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:de.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:de.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:de.scrollWithEditor,description:l.localize(57,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:w(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class se extends b{constructor(){const de={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Me.inlayHints,"inlayHints",de,{"editor.inlayHints.enabled":{type:"string",default:de.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,A.$j?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:de.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:de.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:de.padding,description:l.localize(65,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:w(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:n(Ce.padding,this.defaultValue.padding)}}}class oe extends b{constructor(){super(Me.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(de){return typeof de=="string"&&/^\d+(\.\d+)?ch$/.test(de)?-parseFloat(de.substring(0,de.length-2)):t.clampedInt(de,this.defaultValue,0,1e3)}compute(de,Ce,Xe){return Xe<0?t.clampedInt(-Xe*de.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class te extends f{constructor(){super(Me.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,de=>f.clamp(de,0,150),{markdownDescription:l.localize(66,null)})}compute(de,Ce,Xe){return de.fontInfo.lineHeight}}class le extends b{constructor(){const de={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Me.minimap,"minimap",de,{"editor.minimap.enabled":{type:"boolean",default:de.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:de.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:de.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:de.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:de.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:de.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:de.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:de.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:de.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:de.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:de.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:de.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),autohide:n(Ce.autohide,this.defaultValue.autohide),size:w(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(Ce.side,this.defaultValue.side,["right","left"]),showSlider:w(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Ce.scale,1,1,3),maxColumn:t.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(Y){return Y==="ctrlCmd"?A.$j?"metaKey":"ctrlKey":"altKey"}class X extends b{constructor(){super(Me.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{top:t.clampedInt(Ce.top,0,0,1e3),bottom:t.clampedInt(Ce.bottom,0,0,1e3)}}}class ae extends b{constructor(){const de={enabled:!0,cycle:!0};super(Me.parameterHints,"parameterHints",de,{"editor.parameterHints.enabled":{type:"boolean",default:de.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:de.cycle,description:l.localize(85,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),cycle:n(Ce.cycle,this.defaultValue.cycle)}}}class pe extends d{constructor(){super(Me.pixelRatio)}compute(de,Ce,Xe){return de.pixelRatio}}class be extends b{constructor(){super(Me.placeholder,"placeholder",void 0)}validate(de){return typeof de>"u"?this.defaultValue:typeof de=="string"?de:this.defaultValue}}class Fe extends b{constructor(){const de={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(Me.quickSuggestions,"quickSuggestions",de,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:de.strings,description:l.localize(89,null)},comments:{anyOf:Ce,default:de.comments,description:l.localize(90,null)},other:{anyOf:Ce,default:de.other,description:l.localize(91,null)}},default:de,markdownDescription:l.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=de}validate(de){if(typeof de=="boolean"){const Wt=de?"on":"off";return{comments:Wt,strings:Wt,other:Wt}}if(!de||typeof de!="object")return this.defaultValue;const{other:Ce,comments:Xe,strings:_e}=de,lt=["on","inline","off"];let gt,kt,Ot;return typeof Ce=="boolean"?gt=Ce?"on":"off":gt=w(Ce,this.defaultValue.other,lt),typeof Xe=="boolean"?kt=Xe?"on":"off":kt=w(Xe,this.defaultValue.comments,lt),typeof _e=="boolean"?Ot=_e?"on":"off":Ot=w(_e,this.defaultValue.strings,lt),{other:gt,comments:kt,strings:Ot}}}var Be;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Be||(e.RenderLineNumbersType=Be={}));class ke extends b{constructor(){super(Me.lineNumbers,"lineNumbers",{renderType:Be.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(de){let Ce=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof de<"u"&&(typeof de=="function"?(Ce=Be.Custom,Xe=de):de==="interval"?Ce=Be.Interval:de==="relative"?Ce=Be.Relative:de==="on"?Ce=Be.On:Ce=Be.Off),{renderType:Ce,renderFn:Xe}}}function Ie(Y){const de=Y.get(Me.renderValidationDecorations);return de==="editable"?Y.get(Me.readOnly):de!=="on"}class Oe extends b{constructor(){const de=[],Ce={type:"number",description:l.localize(98,null)};super(Me.rulers,"rulers",de,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:de,description:l.localize(100,null)})}validate(de){if(Array.isArray(de)){const Ce=[];for(const Xe of de)if(typeof Xe=="number")Ce.push({column:t.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const _e=Xe;Ce.push({column:t.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ce.sort((Xe,_e)=>Xe.column-_e.column),Ce}return this.defaultValue}}class q extends b{constructor(){super(Me.readOnlyMessage,"readOnlyMessage",void 0)}validate(de){return!de||typeof de!="object"?this.defaultValue:de}}function V(Y,de){if(typeof Y!="string")return de;switch(Y){case"hidden":return R.ScrollbarVisibility.Hidden;case"visible":return R.ScrollbarVisibility.Visible;default:return R.ScrollbarVisibility.Auto}}class J extends b{constructor(){const de={vertical:R.ScrollbarVisibility.Auto,horizontal:R.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Me.scrollbar,"scrollbar",de,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:de.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:de.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:de.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:de.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de,Xe=t.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=t.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:V(Ce.vertical,this.defaultValue.vertical),horizontal:V(Ce.horizontal,this.defaultValue.horizontal),useShadows:n(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:t.clampedInt(Ce.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:t.clampedInt(Ce.verticalSliderSize,_e,0,1e3),scrollByPage:n(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class x extends b{constructor(){const de={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Me.unicodeHighlighting,"unicodeHighlight",de,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:de.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:de.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:de.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:de.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:de.allowedLocales,description:l.localize(119,null)}})}applyUpdate(de,Ce){let Xe=!1;Ce.allowedCharacters&&de&&(h.$go(de.allowedCharacters,Ce.allowedCharacters)||(de={...de,allowedCharacters:Ce.allowedCharacters},Xe=!0)),Ce.allowedLocales&&de&&(h.$go(de.allowedLocales,Ce.allowedLocales)||(de={...de,allowedLocales:Ce.allowedLocales},Xe=!0));const _e=super.applyUpdate(de,Ce);return Xe?new c(_e.newValue,!0):_e}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{nonBasicASCII:Ke(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(de.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(de.allowedLocales,this.defaultValue.allowedLocales)}}c(de,Ce){if(typeof de!="object"||!de)return Ce;const Xe={};for(const[_e,lt]of Object.entries(de))lt===!0&&(Xe[_e]=!0);return Xe}}class fe extends b{constructor(){const de={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Me.inlineSuggest,"inlineSuggest",de,{"editor.inlineSuggest.enabled":{type:"boolean",default:de.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:de.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(126,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),mode:w(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class we extends b{constructor(){const de={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Me.inlineEdit,"experimentalInlineEdit",de,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:de.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:de.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:de.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:de.backgroundColoring,description:l.localize(133,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showToolbar:w(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:a.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ne extends b{constructor(){const de={enabled:O.$ft.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$ft.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Me.bracketPairColorization,"bracketPairColorization",de,{"editor.bracketPairColorization.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:de.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ge extends b{constructor(){const de={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Me.guides,"guides",de,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:de.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:de.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:de.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:de.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:de.highlightActiveIndentation,description:l.localize(149,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{bracketPairs:Ke(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(Y,de,Ce){const Xe=Ce.indexOf(Y);return Xe===-1?de:Ce[Xe]}class tt extends b{constructor(){const de={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Me.suggest,"suggest",de,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:de.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:de.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:de.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:de.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:de.selectionMode,markdownDescription:l.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:de.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:de.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:de.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:de.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:de.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{insertMode:w(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:w(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:n(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:n(Ce.preview,this.defaultValue.preview),previewMode:w(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(Ce.showMethods,this.defaultValue.showMethods),showFunctions:n(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:n(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(Ce.showFields,this.defaultValue.showFields),showVariables:n(Ce.showVariables,this.defaultValue.showVariables),showClasses:n(Ce.showClasses,this.defaultValue.showClasses),showStructs:n(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:n(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:n(Ce.showModules,this.defaultValue.showModules),showProperties:n(Ce.showProperties,this.defaultValue.showProperties),showEvents:n(Ce.showEvents,this.defaultValue.showEvents),showOperators:n(Ce.showOperators,this.defaultValue.showOperators),showUnits:n(Ce.showUnits,this.defaultValue.showUnits),showValues:n(Ce.showValues,this.defaultValue.showValues),showConstants:n(Ce.showConstants,this.defaultValue.showConstants),showEnums:n(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:n(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(Ce.showKeywords,this.defaultValue.showKeywords),showWords:n(Ce.showWords,this.defaultValue.showWords),showColors:n(Ce.showColors,this.defaultValue.showColors),showFiles:n(Ce.showFiles,this.defaultValue.showFiles),showReferences:n(Ce.showReferences,this.defaultValue.showReferences),showFolders:n(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:n(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:n(Ce.showUsers,this.defaultValue.showUsers),showIssues:n(Ce.showIssues,this.defaultValue.showIssues)}}}class rt extends b{constructor(){super(Me.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(de){return!de||typeof de!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(de.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(de.selectSubwords,this.defaultValue.selectSubwords)}}}class ot extends b{constructor(){const de=[];super(Me.wordSegmenterLocales,"wordSegmenterLocales",de,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(de){if(typeof de=="string"&&(de=[de]),Array.isArray(de)){const Ce=[];for(const Xe of de)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Ce.push(Xe)}catch{}return Ce}return this.defaultValue}}var nt;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ct extends b{constructor(){super(Me.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(de){switch(de){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(de,Ce,Xe){return Ce.get(Me.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Xe}}class $t extends d{constructor(){super(Me.wrappingInfo)}compute(de,Ce,Xe){const _e=Ce.get(Me.layoutInfo);return{isDominatedByLongLines:de.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class ht extends b{constructor(){const de={enabled:!0,showDropSelector:"afterDrop"};super(Me.dropIntoEditor,"dropIntoEditor",de,{"editor.dropIntoEditor.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showDropSelector:w(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends b{constructor(){const de={enabled:!0,showPasteSelector:"afterPaste"};super(Me.pasteAs,"pasteAs",de,{"editor.pasteAs.enabled":{type:"boolean",default:de.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(de){if(!de||typeof de!="object")return this.defaultValue;const Ce=de;return{enabled:n(Ce.enabled,this.defaultValue.enabled),showPasteSelector:w(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",ze="Menlo, Monaco, 'Courier New', monospace",Ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:A.$j?ze:A.$k?Ze:Pe,fontWeight:"normal",fontSize:A.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Te(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var Me;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.placeholder=88]="placeholder",Y[Y.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=90]="quickSuggestions",Y[Y.quickSuggestionsDelay=91]="quickSuggestionsDelay",Y[Y.readOnly=92]="readOnly",Y[Y.readOnlyMessage=93]="readOnlyMessage",Y[Y.renameOnType=94]="renameOnType",Y[Y.renderControlCharacters=95]="renderControlCharacters",Y[Y.renderFinalNewline=96]="renderFinalNewline",Y[Y.renderLineHighlight=97]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=99]="renderValidationDecorations",Y[Y.renderWhitespace=100]="renderWhitespace",Y[Y.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Y[Y.roundedSelection=102]="roundedSelection",Y[Y.rulers=103]="rulers",Y[Y.scrollbar=104]="scrollbar",Y[Y.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=106]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=107]="scrollPredominantAxis",Y[Y.selectionClipboard=108]="selectionClipboard",Y[Y.selectionHighlight=109]="selectionHighlight",Y[Y.selectOnLineNumbers=110]="selectOnLineNumbers",Y[Y.showFoldingControls=111]="showFoldingControls",Y[Y.showUnused=112]="showUnused",Y[Y.snippetSuggestions=113]="snippetSuggestions",Y[Y.smartSelect=114]="smartSelect",Y[Y.smoothScrolling=115]="smoothScrolling",Y[Y.stickyScroll=116]="stickyScroll",Y[Y.stickyTabStops=117]="stickyTabStops",Y[Y.stopRenderingLineAfter=118]="stopRenderingLineAfter",Y[Y.suggest=119]="suggest",Y[Y.suggestFontSize=120]="suggestFontSize",Y[Y.suggestLineHeight=121]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Y[Y.suggestSelection=123]="suggestSelection",Y[Y.tabCompletion=124]="tabCompletion",Y[Y.tabIndex=125]="tabIndex",Y[Y.unicodeHighlighting=126]="unicodeHighlighting",Y[Y.unusualLineTerminators=127]="unusualLineTerminators",Y[Y.useShadowDOM=128]="useShadowDOM",Y[Y.useTabStops=129]="useTabStops",Y[Y.wordBreak=130]="wordBreak",Y[Y.wordSegmenterLocales=131]="wordSegmenterLocales",Y[Y.wordSeparators=132]="wordSeparators",Y[Y.wordWrap=133]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=136]="wordWrapColumn",Y[Y.wordWrapOverride1=137]="wordWrapOverride1",Y[Y.wordWrapOverride2=138]="wordWrapOverride2",Y[Y.wrappingIndent=139]="wrappingIndent",Y[Y.wrappingStrategy=140]="wrappingStrategy",Y[Y.showDeprecated=141]="showDeprecated",Y[Y.inlayHints=142]="inlayHints",Y[Y.editorClassName=143]="editorClassName",Y[Y.pixelRatio=144]="pixelRatio",Y[Y.tabFocusMode=145]="tabFocusMode",Y[Y.layoutInfo=146]="layoutInfo",Y[Y.wrappingInfo=147]="wrappingInfo",Y[Y.defaultColorDecorators=148]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(Me||(e.EditorOption=Me={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Te(new o(Me.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:Te(new y(Me.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:Te(new P),accessibilityPageSize:Te(new t(Me.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:Te(new a(Me.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:Te(new o(Me.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Te(new o(Me.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Te(new y(Me.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:Te(new y(Me.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:Te(new y(Me.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:Te(new y(Me.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:Te(new y(Me.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:Te(new S(Me.autoIndent,"autoIndent",E.Full,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:Te(new o(Me.automaticLayout,"automaticLayout",!1)),autoSurround:Te(new y(Me.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:Te(new Ne),bracketPairGuides:Te(new Ge),stickyTabStops:Te(new o(Me.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:Te(new o(Me.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:Te(new a(Me.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:Te(new t(Me.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:Te(new o(Me.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:Te(new y(Me.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:Te(new t(Me.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:Te(new o(Me.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:Te(new C),contextmenu:Te(new o(Me.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Te(new o(Me.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:Te(new S(Me.cursorBlinking,"cursorBlinking",p.Blink,"blink",["blink","smooth","phase","expand","solid"],v,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:Te(new y(Me.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:Te(new S(Me.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:l.localize(261,null)})),cursorSurroundingLines:Te(new t(Me.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:Te(new y(Me.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:Te(new t(Me.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:Te(new o(Me.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Te(new o(Me.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Te(new o(Me.domReadOnly,"domReadOnly",!1)),dragAndDrop:Te(new o(Me.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:Te(new z),dropIntoEditor:Te(new ht),stickyScroll:Te(new W),experimentalWhitespaceRendering:Te(new y(Me.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:Te(new a(Me.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Te(new f(Me.fastScrollSensitivity,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:l.localize(272,null)})),find:Te(new F),fixedOverflowWidgets:Te(new o(Me.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Te(new o(Me.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:Te(new y(Me.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:Te(new o(Me.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:Te(new o(Me.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:Te(new t(Me.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:Te(new o(Me.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:Te(new a(Me.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:Te(new re),fontLigatures2:Te(new B),fontSize:Te(new U),fontWeight:Te(new G),fontVariations:Te(new _),formatOnPaste:Te(new o(Me.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:Te(new o(Me.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:Te(new o(Me.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:Te(new Q),hideCursorInOverviewRuler:Te(new o(Me.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:Te(new ee),inDiffEditor:Te(new o(Me.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Te(new f(Me.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>f.clamp(Y,-5,20),{description:l.localize(286,null)})),lightbulb:Te(new K),lineDecorationsWidth:Te(new oe),lineHeight:Te(new te),lineNumbers:Te(new ke),lineNumbersMinChars:Te(new t(Me.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Te(new o(Me.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:Te(new o(Me.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:Te(new y(Me.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:Te(new le),mouseStyle:Te(new y(Me.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Te(new f(Me.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:Te(new o(Me.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:A.$j?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:Te(new o(Me.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:Te(new S(Me.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:Te(new y(Me.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:Te(new t(Me.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:Te(new y(Me.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:Te(new o(Me.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:Te(new t(Me.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Te(new X),pasteAs:Te(new at),parameterHints:Te(new ae),peekWidgetDefaultFocus:Te(new y(Me.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),placeholder:Te(new be),definitionLinkOpensInPeek:Te(new o(Me.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:Te(new Fe),quickSuggestionsDelay:Te(new t(Me.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:Te(new o(Me.readOnly,"readOnly",!1)),readOnlyMessage:Te(new q),renameOnType:Te(new o(Me.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:Te(new o(Me.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:Te(new y(Me.renderFinalNewline,"renderFinalNewline",A.$k?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:Te(new y(Me.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Te(new o(Me.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:Te(new y(Me.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Te(new y(Me.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:Te(new t(Me.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Te(new o(Me.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:Te(new Oe),scrollbar:Te(new J),scrollBeyondLastColumn:Te(new t(Me.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:Te(new o(Me.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:Te(new o(Me.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:Te(new o(Me.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:A.$k})),selectionHighlight:Te(new o(Me.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:Te(new o(Me.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Te(new y(Me.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:Te(new o(Me.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:Te(new o(Me.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:Te(new se),snippetSuggestions:Te(new y(Me.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:Te(new rt),smoothScrolling:Te(new o(Me.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:Te(new t(Me.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Te(new tt),inlineSuggest:Te(new fe),inlineEdit:Te(new we),inlineCompletionsAccessibilityVerbose:Te(new o(Me.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:Te(new t(Me.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Te(new t(Me.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Te(new o(Me.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:Te(new y(Me.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:Te(new y(Me.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:Te(new t(Me.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Te(new x),unusualLineTerminators:Te(new y(Me.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:Te(new o(Me.useShadowDOM,"useShadowDOM",!0)),useTabStops:Te(new o(Me.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:Te(new y(Me.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:Te(new ot),wordSeparators:Te(new a(Me.wordSeparators,"wordSeparators",$.$gt,{description:l.localize(360,null)})),wordWrap:Te(new y(Me.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:Te(new a(Me.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Te(new a(Me.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Te(new t(Me.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:Te(new y(Me.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Te(new y(Me.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Te(new j),defaultColorDecorators:Te(new o(Me.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:Te(new pe),tabFocusMode:Te(new o(Me.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:Te(new ne),wrappingInfo:Te(new $t),wrappingIndent:Te(new ct),wrappingStrategy:Te(new De)}});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[266],Se([1,0,23,44,220,5,110,11,25]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$5w=e.$4w=e.$3w=void 0,e.$6w=k,e.$7w=b,h=Ut(h),e.$3w=(0,R.$Fi)("dialogService");var l;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(l||(l={}));class I{a(g){return this.d(g,l.Confirmation)}b(g){return this.d(g,l.Prompt)}c(g){return this.d(g,l.Input)}d(g,d){const m=[];switch(d){case l.Confirmation:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(0,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(1,null));break}case l.Prompt:{const n=g;Array.isArray(n.buttons)&&n.buttons.length>0&&m.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?m.push((0,A.localize)(2,null)):typeof n.cancelButton=="string"?m.push(n.cancelButton):n.cancelButton.label?m.push(n.cancelButton.label):m.push((0,A.localize)(3,null))),m.length===0&&m.push((0,A.localize)(4,null));break}case l.Input:{const n=g;n.primaryButton?m.push(n.primaryButton):m.push((0,A.localize)(5,null)),n.cancelButton?m.push(n.cancelButton):m.push((0,A.localize)(6,null));break}}return m}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===h.default.Info?"info":g===h.default.Error?"error":g===h.default.Warning?"warning":"none"}f(g,d,m){const n=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&n.push(g.cancelButton);let o=n[d]?.run({checkboxChecked:m});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:m}}}e.$4w=I,e.$5w=(0,R.$Fi)("fileDialogService");var E;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(E||(e.ConfirmResult=E={}));const u=10;function k(c){const g=[];return g.push(...c.slice(0,u).map(d=>typeof d=="string"?d:(0,r.$dh)(d))),c.length>u&&(c.length-u===1?g.push((0,A.localize)(7,null)):g.push((0,A.localize)(8,null,c.length-u))),g.push(""),g.join(`
`)}function b(c,g){const d=(0,$.$co)(c);let m=(d.buttons??[]).map(t=>(0,L.$Zw)(t)),n=(c.buttons||[]).map((t,s)=>s),o=0,i=d.cancelId??m.length-1;if(m.length>1){const t=typeof i=="number"?m[i]:void 0;if(O.$k||O.$j){if(typeof t=="string"&&m.length>1&&i!==1){m.splice(i,1),m.splice(1,0,t);const s=n[i];n.splice(i,1),n.splice(1,0,s),i=1}O.$k&&m.length>1&&(m=m.reverse(),n=n.reverse(),o=m.length-1,typeof t=="string"&&(i=o-1))}else if(O.$i&&typeof t=="string"&&m.length>1&&i!==m.length-1){m.splice(i,1),m.push(t);const s=n[i];n.splice(i,1),n.push(s),i=m.length-1}}return d.buttons=m,d.defaultId=o,d.cancelId=i,d.noLink=!0,d.title=d.title||g.nameLong,{options:d,buttonIndeces:n}}}),define(Ee[144],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,r.$Fi)("environmentService"),e.$Ni=(0,r.$Gi)(e.$Mi)}),define(Ee[267],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$88b=e.$78b=void 0,e.$78b=(0,r.$Fi)("externalTerminal"),e.$88b="Terminal.app"}),define(Ee[268],Se([1,0,58,59,15,16,11,109,34,112,223,267]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=e.$Sec=void 0,r=We(r),R=We(R),L=We(L),$=We($),l=We(l),I=We(I);const u=I.localize(0,null);class k{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends k{static{this.b="cmd.exe"}openTerminal(i,t){return this.spawnTerminal(r,i,l.$xm(),t)}spawnTerminal(i,t,s,f){const a=t.windowsExec||b.getDefaultTerminalWindows();f&&f[1]===":"&&(f=f[0].toUpperCase()+f.substr(1));const w=R.$pc(a,".exe").toLowerCase();if(w==="cmder")return i.spawn(a,f?[f]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return a.indexOf(" ")>=0&&y.push('""'),y.push(a),w==="wt"&&y.push("-d ."),new Promise((S,D)=>{const P=d(process),C=i.spawn(s,y,{cwd:f,env:P,detached:!0});C.on("error",D),C.on("exit",()=>S())})}async runInTerminal(i,t,s,f,a){const w="windowsExec"in a&&a.windowsExec?a.windowsExec:b.getDefaultTerminalWindows(),y=await b.f();return new Promise((S,D)=>{const P=`"${t} - ${u}"`,C=`"${s.join('" "')}" & pause`,p=Object.assign({},d(process),f);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const v={cwd:t,env:p,windowsVerbatimArguments:!0};let N,T;R.$pc(w,".exe")==="wt"?(N=w,T=["-d",".",b.b,"/c",C]):y?(N=y,T=["-d",".",w,"/c",C]):(N=b.b,T=["/c","start",P,"/wait",w,"/c",`"${C}"`]),r.spawn(N,T,v).on("error",j=>{D(m(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!b.d){const i=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${i?"Sysnative":"System32"}\\cmd.exe`}return b.d}static async f(){try{const i=await l.win32.findExecutable("wt");return await $.Promises.exists(i)?i:void 0}catch{return}}}e.$Sec=b,Je([h.$0h],b,"f",null);class c extends k{static{this.b="/usr/bin/osascript"}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,f,a){const w=a.osxExec||E.$88b;return new Promise((y,S)=>{if(w===E.$88b||w==="iTerm.app"){const D=w===E.$88b?"TerminalHelper":"iTermHelper",C=[A.$Zg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",i||u,"-w",t];for(const N of s)C.push("-a"),C.push(N);if(f){const N=Object.assign({},d(process),f);for(const T in N){const M=N[T];M===null?(C.push("-u"),C.push(T)):(C.push("-e"),C.push(`${T}=${M}`))}}let p="";const v=r.spawn(c.b,C);v.on("error",N=>{S(m(N))}),v.stderr.on("data",N=>{p+=N.toString()}),v.on("exit",N=>{if(N===0)y(void 0);else if(p){const T=p.split(`
`,1);S(new Error(T[0]))}else S(new Error(I.localize(1,null,D,N)))})}else S(new Error(I.localize(2,null,w)))})}spawnTerminal(i,t,s){const f=t.osxExec||E.$88b;return new Promise((a,w)=>{const y=["-a",f];s&&y.push(s);const S=d(process),D=i.spawn("/usr/bin/open",y,{cwd:s,env:S});D.on("error",w),D.on("exit",()=>a())})}}e.$Tec=c;class g extends k{static{this.b=I.localize(3,null)}openTerminal(i,t){return this.spawnTerminal(r,i,t)}runInTerminal(i,t,s,f,a){const w=a.linuxExec?Promise.resolve(a.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((y,S)=>{const D=[];w.then(P=>{P.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const C=`${n(s)}; echo; read -p "${g.b}" -n1;`;D.push(`''${C}''`);const p=Object.assign({},d(process),f);Object.keys(p).filter(M=>p[M]===null).forEach(M=>delete p[M]);const v={cwd:t,env:p};let N="";const T=r.spawn(P,D,v);T.on("error",M=>{S(m(M))}),T.stderr.on("data",M=>{N+=M.toString()}),T.on("exit",M=>{if(M===0)y(void 0);else if(N){const j=N.split(`
`,1);S(new Error(j[0]))}else S(new Error(I.localize(4,null,P,M)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!L.$k)g.d=Promise.resolve("xterm");else{const i=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{i?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(i,t,s){const f=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,w)=>{f.then(y=>{const S=d(process),D=i.spawn(y,[],{cwd:s,env:S});D.on("error",w),D.on("exit",()=>a())})})}}e.$Uec=g;function d(o){const i={...o.env};return(0,O.$km)(i),i}function m(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function n(o){let i="";for(const t of o)t.indexOf(" ")>=0?i+='"'+t+'"':i+=t,i+=" ";return i}}),define(Ee[28],Se([1,0,85,16,13,18,2,224,5,11,15,49]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=g,e.$cl=m,e.$dl=n,e.$el=o,e.$fl=i,e.$gl=t,e.$hl=s,e.$il=f,e.$jl=a,e.$kl=w,e.$ml=D,e.$nl=P,e.$ol=C,e.$pl=p,e.$ql=v,e.$tl=z,e.$Fl=G,e.$Gl=Q,e.$Il=ue,e.$_k=(0,$.$Fi)("fileService");function u(ne){return ne.create===!0}var k;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var b;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var c;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(c||(e.FileChangeFilter=c={}));function g(ne){const De=ne;return!!De&&typeof De.onDidChange=="function"}var d;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function m(ne){return!!(ne.capabilities&d.FileReadWrite)}function n(ne){return!!(ne.capabilities&d.FileFolderCopy)}function o(ne){return!!(ne.capabilities&d.FileClone)}function i(ne){return!!(ne.capabilities&d.FileOpenReadWriteClose)}function t(ne){return!!(ne.capabilities&d.FileReadStream)}function s(ne){return m(ne)?!!(ne.capabilities&d.FileAtomicRead):!1}function f(ne){return m(ne)?!!(ne.capabilities&d.FileAtomicWrite):!1}function a(ne){return!!(ne.capabilities&d.FileAtomicDelete)}function w(ne){return!!(ne.capabilities&d.Readonly)}var y;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class S extends Error{static create(De,$e){const K=new S(De.toString(),$e);return C(K,$e),K}constructor(De,$e){super(De),this.code=$e}}e.$ll=S;function D(ne,De){return S.create(ne,De)}function P(ne){return ne||D((0,O.localize)(0,null),y.Unknown)}function C(ne,De){return ne.name=De?`${De} (FileSystemError)`:"FileSystemError",ne}function p(ne){if(!ne)return y.Unknown;if(ne instanceof S)return ne.code;const De=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!De)return y.Unknown;switch(De[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function v(ne){if(ne instanceof F)return ne.fileOperationResult;switch(p(ne)){case y.FileNotFound:return re.FILE_NOT_FOUND;case y.FileIsADirectory:return re.FILE_IS_DIRECTORY;case y.FileNotADirectory:return re.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return re.FILE_WRITE_LOCKED;case y.NoPermissions:return re.FILE_PERMISSION_DENIED;case y.FileExists:return re.FILE_MOVE_CONFLICT;case y.FileTooLarge:return re.FILE_TOO_LARGE;default:return re.FILE_OTHER_ERROR}}var N;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class T{constructor(De,$e,K){this.resource=De,this.operation=$e,this.target=K}isOperation(De){return this.operation===De}}e.$rl=T;var M;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class j{static{this.a=null}constructor(De,$e){this.c=$e,this.b=void 0,this.d=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawAdded.map(W=>[W,!0])),K}),this.f=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawUpdated.map(W=>[W,!0])),K}),this.g=new E.$X(()=>{const K=r.$Li.forUris(()=>this.c);return K.fill(this.rawDeleted.map(W=>[W,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of De){switch(K.type){case M.ADDED:this.rawAdded.push(K.resource);break;case M.UPDATED:this.rawUpdated.push(K.resource);break;case M.DELETED:this.rawDeleted.push(K.resource);break}this.b!==j.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(De,...$e){return this.h(De,{includeChildren:!1},...$e)}affects(De,...$e){return this.h(De,{includeChildren:!0},...$e)}h(De,$e,...K){if(!De)return!1;const W=K.length>0;return!!((!W||K.includes(M.ADDED))&&(this.d.value.get(De)||$e.includeChildren&&this.d.value.findSuperstr(De))||(!W||K.includes(M.UPDATED))&&(this.f.value.get(De)||$e.includeChildren&&this.f.value.findSuperstr(De))||(!W||K.includes(M.DELETED))&&(this.g.value.findSubstr(De)||$e.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$sl=j;function z(ne,De,$e){return!ne||!De||ne===De||De.length>ne.length?!1:(De.charAt(De.length-1)!==h.sep&&(De+=h.sep),$e?(0,A.$Hf)(ne,De):ne.indexOf(De)===0)}class F extends Error{constructor(De,$e,K){super(De),this.fileOperationResult=$e,this.options=K}}e.$ul=F;class B extends F{constructor(De,$e,K,W){super(De,$e,W),this.fileOperationResult=$e,this.size=K}}e.$vl=B;class _ extends F{constructor(De,$e,K){super(De,re.FILE_NOT_MODIFIED_SINCE,K),this.stat=$e}}e.$wl=_;var re;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var U;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.$El="";function G(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function Q(ne,De){if(!De.hasProvider(L.URI.from({scheme:ne.scheme})))return new Promise($e=>{const K=De.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(K.dispose(),$e())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(De){return(0,R.$jg)(De)||(De=0),De<ee.KB?(0,O.localize)(1,null,De.toFixed(0)):De<ee.MB?(0,O.localize)(2,null,(De/ee.KB).toFixed(2)):De<ee.GB?(0,O.localize)(3,null,(De/ee.MB).toFixed(2)):De<ee.TB?(0,O.localize)(4,null,(De/ee.GB).toFixed(2)):(0,O.localize)(5,null,(De/ee.TB).toFixed(2))}}e.$Hl=ee;function ue(ne){const De=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*ee.MB:De?10*ee.MB:l.$o?50*ee.MB:1024*ee.MB}}),define(Ee[269],Se([1,0,22,14,225,28]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=L;async function L(I,E,u,k,b,c){let g;try{await O(I,E,u,k,b,c)}catch(d){g=d}finally{g&&b.errorTransformer&&(g=b.errorTransformer(g)),typeof g<"u"&&u.error(g),u.end()}}async function O(I,E,u,k,b,c){$(c);const g=await I.open(E,{create:!1});try{$(c);let d=0,m=0,n=b&&typeof b.length=="number"?b.length:void 0,o=r.$Oe.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),i=b&&typeof b.position=="number"?b.position:0,t=0;do m=await I.read(g,i,o.buffer,t,o.byteLength-t),i+=m,t+=m,d+=m,typeof n=="number"&&(n-=m),t===o.byteLength&&(await u.write(k(o)),o=r.$Oe.alloc(Math.min(b.bufferSize,typeof n=="number"?n:b.bufferSize)),t=0);while(m>0&&(typeof n!="number"||n>0)&&$(c)&&l(d,b));if(t>0){let s=t;typeof n=="number"&&(s=Math.min(t,n)),u.write(k(o.slice(0,s)))}}catch(d){throw(0,R.$nl)(d)}finally{await I.close(g)}}function $(I){if(I.isCancellationRequested)throw(0,h.$8)();return!0}function l(I,E){if(typeof E?.limits?.size=="number"&&I>E.limits.size)throw(0,R.$ml)((0,A.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[70],Se([1,0,39,3,16,11,2,28]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=e.$1q=e.$Zq=void 0,e.$Xq=$,e.$Yq=l,e.$3q=k,e.$4q=b,e.$5q=c,e.$6q=g,e.$7q=m,e.$8q=n;function $(o){return typeof o.correlationId=="number"}function l(o){return o.recursive===!0}class I extends h.$Wc{static{this.a=5}constructor(i,t,s,f){super(),this.h=i,this.j=t,this.m=s,this.n=f,this.c=this.B(new h.$Xc),this.f=void 0,this.g=0}s(){const i=new h.$Vc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(t=>this.h(t))),i.add(this.b.onDidLogMessage(t=>this.j(t))),i.add(this.b.onDidError(t=>this.t(t.error,t.request)))}t(i,t){this.u(i,t)?this.g<I.a&&this.f?(this.y(`restarting watcher after unexpected error: ${i}`),this.w(this.f)):this.y(`gave up attempting to restart watcher after unexpected error: ${i}`):this.y(i)}u(i,t){return!(!this.n.restartOnError||t||i.indexOf("No space left on device")!==-1||i.indexOf("EMFILE")!==-1)}w(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}y(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}z(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Zq=I;class E extends I{constructor(i,t,s){super(i,t,s,{type:"node.js",restartOnError:!1})}}e.$1q=E;class u extends I{constructor(i,t,s){super(i,t,s,{type:"universal",restartOnError:!0})}}e.$2q=u;function k(o){return o.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}function b(o){const i=new d;for(const t of o)i.processEvent(t);return i.coalesce()}function c(o,i){return typeof i=="string"&&!i.startsWith(r.$vk)&&!(0,A.$kc)(i)?{base:o,pattern:i}:i}function g(o,i){const t=[];for(const s of i)t.push((0,r.$zk)(c(o,s)));return t}class d{constructor(){this.a=new Set,this.b=new Map}c(i){return R.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const t=this.b.get(this.c(i));let s=!1;if(t){const f=t.type,a=i.type;t.resource.fsPath!==i.resource.fsPath&&(i.type===O.FileChangeType.DELETED||i.type===O.FileChangeType.ADDED)?s=!0:f===O.FileChangeType.ADDED&&a===O.FileChangeType.DELETED?(this.b.delete(this.c(i)),this.a.delete(t)):f===O.FileChangeType.DELETED&&a===O.FileChangeType.ADDED?t.type=O.FileChangeType.UPDATED:f===O.FileChangeType.ADDED&&a===O.FileChangeType.UPDATED||(t.type=a)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],t=[];return Array.from(this.a).filter(s=>s.type!==O.FileChangeType.DELETED?(i.push(s),!1):!0).sort((s,f)=>s.resource.fsPath.length-f.resource.fsPath.length).filter(s=>t.some(f=>(0,O.$tl)(s.resource.fsPath,f,!R.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(i)}}function m(o,i){if(typeof i=="number")switch(o.type){case O.FileChangeType.ADDED:return(i&O.FileChangeFilter.ADDED)===0;case O.FileChangeType.DELETED:return(i&O.FileChangeFilter.DELETED)===0;case O.FileChangeType.UPDATED:return(i&O.FileChangeFilter.UPDATED)===0}return!1}function n(o){if(typeof o=="number"){const i=[];return o&O.FileChangeFilter.ADDED&&i.push("Added"),o&O.FileChangeFilter.DELETED&&i.push("Deleted"),o&O.FileChangeFilter.UPDATED&&i.push("Updated"),i.length===0?"<all>":`[${i.join(", ")}]`}return"<none>"}}),define(Ee[270],Se([1,0,61,3,70,4,28,2,9]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;class l extends h.$Wc{constructor(){super(),this.a=this.B(new R.$me),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$me),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$me),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new h.$6c),this.m=new Set,this.n=this.B(new $.$Dh(this.y())),this.r=5007,this.s=new $.$3h,this.R=!1,this.B(this.f(E=>this.t(E)))}t(E){this.u(E)&&this.z(E)}u(E){return(0,A.$Xq)(E)}async watch(E){this.s.isSettled||this.s.complete(),this.s=new $.$3h;try{this.h.clear(),this.g.clear();for(const u of E)this.u(u)?this.h.set(u.correlationId,u):this.g.add(u);for(const[u]of this.j)this.h.has(u)||(this.j.deleteAndDispose(u),this.m.delete(u));return await this.w(!1)}finally{this.s.complete()}}w(E){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))]),E?this.y():0)}y(){return 800}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async z(E){if(this.j.has(E.correlationId))return;const u=new h.$Vc;this.j.set(E.correlationId,u),await this.s.p,!u.isDisposed&&(this.D(E,u),this.w(!0))}C(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.w(!1)}D(E,u){this.F(E,u)?(this.P(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.G(E,u),this.m.add(E.correlationId))}F(E,u){const k=this.O?.subscribe(E.path,(b,c)=>{u.isDisposed||(b?this.D(E,u):c?.type===L.FileChangeType.ADDED&&this.H(E))});return k?(u.add(k),!0):!1}G(E,u){let k=!1;const b=(c,g)=>{if(u.isDisposed)return;const d=this.I(c),m=this.I(g),n=k;k=d,!d&&(m||n)&&this.H(E)};this.P(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.watchFile)(E.path,{persistent:!1,interval:this.r},b)}catch(c){this.Q(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}u.add((0,h.$Uc)(()=>{this.P(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,r.unwatchFile)(E.path,b)}catch(c){this.Q(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}H(E){this.P(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const u={resource:O.URI.file(E.path),type:L.FileChangeType.ADDED,cId:E.correlationId};this.a.fire([u]),this.J(u,E),this.C(E)}I(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(E,u){if(this.R){const k=` >> normalized ${E.type===L.FileChangeType.ADDED?"[ADDED]":E.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.L(k,u)}}L(E,u){this.R&&this.P(`${E}${typeof u.correlationId=="number"?` <${u.correlationId}> `:""}`)}M(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,A.$8q)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.R=E}}e.$er=l}),define(Ee[271],Se([1,0,61,9,21,33,3,82,16,11,23,2,111,34,28,70]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0,e.$kr=d;class g extends L.$Wc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(n,o,i,t,s,f){super(),this.s=n,this.t=o,this.u=i,this.w=t,this.y=s,this.z=f,this.c=this.B(new h.$Uh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},a=>this.u(a))),this.f=this.B(new h.$Th(a=>this.M(a),g.b)),this.g=(0,c.$6q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$6q)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Xq)(this.s)?this.s.filter:void 0,this.m=new A.$xe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const n=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await k.Promises.stat(n);if(this.m.token.isCancellationRequested)return;this.B(await this.G(n,o.isDirectory()))}catch(n){n.code!=="ENOENT"?this.O(n):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${n})`),this.D()}}D(){this.r=!0,this.w?.()}async F(n){let o=n.path;try{o=await k.Promises.realpath(n.path),n.path===o&&(o=await(0,u.$gr)(n.path,this.m.token)??n.path),n.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${o})`)}catch{}return o}async G(n,o){const i=new L.$Vc;return this.H(n,o,i)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(n,o,i)),i}H(n,o,i){if(o)return!1;const t=E.URI.file(this.s.path),s=this.t?.subscribe(this.s.path,async(f,a)=>{if(!i.isDisposed)if(f){const w=await this.G(n,o);i.isDisposed?w.dispose():i.add(w)}else a&&(typeof a.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:a.type,cId:this.s.correlationId},!0)});return s?(i.add(s),!0):!1}async I(n,o,i){if(l.$j&&(0,R.$Eg)(n,"/Volumes/",!0)){this.O(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new A.$xe(this.m.token);i.add((0,L.$Uc)(()=>t.dispose(!0)));const s=new L.$Vc;i.add(s);try{const f=E.URI.file(this.s.path),a=(0,$.$pc)(n),w=(0,r.watch)(n);s.add((0,L.$Uc)(()=>{w.removeAllListeners(),w.close()})),this.Q(`Started watching: '${n}'`);const y=new Set;if(o)try{for(const D of await k.Promises.readdir(n))y.add(D)}catch(D){this.O(D)}if(t.token.isCancellationRequested)return;const S=new Map;s.add((0,L.$Uc)(()=>{for(const[,D]of S)D.dispose();S.clear()})),w.on("error",(D,P)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${n} for changes using fs.watch() (${D}, ${P})`),this.D())}),w.on("change",(D,P)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${D}"] ${P}`);let C="";if(P&&(C=P.toString(),l.$j&&(C=(0,O.$mm)(C))),!(!C||D!=="change"&&D!=="rename"))if(o)if(D==="rename"){S.get(C)?.dispose();const p=setTimeout(async()=>{if(S.delete(C),C===a&&!await k.Promises.exists(n)){this.J(f);return}if(t.token.isCancellationRequested)return;const v=await this.N((0,$.$lc)(n,C));if(t.token.isCancellationRequested)return;let N;v?y.has(C)?N=b.FileChangeType.UPDATED:(N=b.FileChangeType.ADDED,y.add(C)):(y.delete(C),N=b.FileChangeType.DELETED),this.L({resource:(0,I.$gh)(f,C),type:N,cId:this.s.correlationId})},g.a);S.set(C,(0,L.$Uc)(()=>clearTimeout(p)))}else{let p;y.has(C)?p=b.FileChangeType.UPDATED:(p=b.FileChangeType.ADDED,y.add(C)),this.L({resource:(0,I.$gh)(f,C),type:p,cId:this.s.correlationId})}else if(D==="rename"||C!==a){const p=setTimeout(async()=>{const v=await k.Promises.exists(n);t.token.isCancellationRequested||(v?(this.L({resource:f,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0),s.add(await this.G(n,!1))):this.J(f))},g.a);s.clear(),s.add((0,L.$Uc)(()=>clearTimeout(p)))}else this.L({resource:f,type:b.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(f){t.token.isCancellationRequested||this.O(`Failed to watch ${n} for changes using fs.watch() (${f.toString()})`),this.D()}}J(n){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:n,type:b.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(n,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${n.type===b.FileChangeType.ADDED?"[ADDED]":n.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!o&&this.g.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${n.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(i=>i(n.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}M(n){const o=(0,c.$4q)(n),i=[];for(const s of o){if((0,c.$7q)(s,this.j)){this.z&&this.R(` >> ignored (filtered) ${s.resource.fsPath}`);continue}i.push(s)}if(i.length===0)return;if(this.z)for(const s of i)this.R(` >> normalized ${s.type===b.FileChangeType.ADDED?"[ADDED]":s.type===b.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(n){if(l.$k)return k.Promises.exists(n);try{const o=(0,$.$pc)(n);return(await k.Promises.readdir((0,$.$oc)(n))).some(t=>t===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(n){this.z=n}O(n){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}P(n){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}Q(n){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}R(n){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${n}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$jr=g;async function d(m,n,o,i,t=512){const s=await k.Promises.open(m,"r"),f=Buffer.allocUnsafe(t),a=new A.$xe(i);let w,y=!1;const S={path:m,excludes:[],recursive:!1},D=new g(S,void 0,P=>{(async()=>{for(const{type:C}of P)if(C===b.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:p}=await k.Promises.read(s,f,0,t,null);if(!p||a.token.isCancellationRequested)break;n(f.slice(0,p))}}catch(p){w=new Error(p),a.dispose(!0)}finally{y=!1}}})()});return await D.ready,o(),new Promise((P,C)=>{a.token.onCancellationRequested(async()=>{D.dispose();try{await k.Promises.close(s)}catch(p){w=new Error(p)}w?C(w):P()})})}}),define(Ee[272],Se([1,0,4,39,270,11,271,33]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;class $ extends A.$er{constructor(I){super(),this.O=I,this.onDidError=r.Event.None,this.watchers=new Set}async N(I){I=this.Z(I);const E=[],u=new Set(Array.from(this.watchers));for(const k of I){const b=this.W(k);b&&(0,h.$Dk)(b.request.excludes,k.excludes)&&(0,h.$Dk)(b.request.includes,k.includes)?u.delete(b):E.push(k)}E.length&&this.P(`Request to start watching: ${E.map(k=>this.M(k)).join(",")}`),u.size&&this.P(`Request to stop watching: ${Array.from(u).map(k=>this.M(k.request)).join(",")}`);for(const k of u)this.Y(k);for(const k of E)this.X(k)}W(I){for(const E of this.watchers)if(typeof I.correlationId=="number"||typeof E.request.correlationId=="number"){if(E.request.correlationId===I.correlationId)return E}else if((0,O.$Dg)(E.request.path,I.path,!R.$k))return E}X(I){const E=new L.$jr(I,this.O,k=>this.a.fire(k),()=>this.c.fire(I),k=>this.b.fire(k),this.R),u={request:I,instance:E};this.watchers.add(u)}async stop(){await super.stop();for(const I of this.watchers)this.Y(I)}Y(I){this.P("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}Z(I){const E=new Map;for(const u of I){const k=R.$k?u.path:u.path.toLowerCase();let b=E.get(u.correlationId);b||(b=new Map,E.set(u.correlationId,b)),b.has(k)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(u)}`),b.set(k,u)}return Array.from(E.values()).map(u=>Array.from(u.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const E of this.watchers)E.instance.setVerboseLogging(I)}P(I,E){this.R&&this.b.fire({type:"trace",message:this.bb(I,E)})}Q(I){this.b.fire({type:"warn",message:this.bb(I)})}bb(I,E){return E?`[File Watcher (node.js)] ${I} (${this.M(E.request)})`:`[File Watcher (node.js)] ${I}`}}e.$lr=$}),define(Ee[273],Se([1,0,70,272]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;class A extends r.$1q{constructor(L,O,$){super(L,O,$),this.s()}r(L){return L.add(new h.$lr(void 0))}}e.$mr=A}),define(Ee[274],Se([1,0,15,87,208,70]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class L extends R.$2q{constructor($,l,I){super($,l,I),this.s()}r($){const l=$.add(new A.$cr(r.$Zg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(l.onDidProcessExit(({code:I,signal:E})=>this.t(`terminated by itself with code ${I}, signal: ${E} (ETERM)`))),h.ProxyChannel.toService((0,h.$mi)(l.getChannel("watcher")))}}e.$dr=L}),define(Ee[115],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class r{constructor(...A){this.a=new Map;for(const[R,L]of A)this.set(R,L)}set(A,R){const L=this.a.get(A);return this.a.set(A,R),L}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$Di=r}),define(Ee[275],Se([1,0,9,14,3,113,264,5,115,81]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;const I=!1;class E extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class u{constructor(g=new $.$Di,d=!1,m,n=I){this.i=g,this.j=d,this.k=m,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Ei,this),this._globalGraph=n?m?._globalGraph??new L.$pr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,A.$Rc)(this.h),this.h.clear();for(const g of this.g)(0,A.$Qc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g,d){this.m();const m=this,n=new class extends u{dispose(){m.h.delete(n),super.dispose()}}(g,this.j,this,this.l);return this.h.add(n),d?.add(n),n}invokeFunction(g,...d){this.m();const m=b.traceInvocation(this.l,g);let n=!1;try{return g({get:i=>{if(n)throw(0,h.$0)("service accessor is only valid during the invocation of its target method");const t=this.s(i,m);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...d)}finally{n=!0,m.stop()}}createInstance(g,...d){this.m();let m,n;return g instanceof R.$Ci?(m=b.traceCreation(this.l,g.ctor),n=this.o(g.ctor,g.staticArguments.concat(d),m)):(m=b.traceCreation(this.l,g),n=this.o(g,d,m)),m.stop(),n}o(g,d=[],m){const n=O._util.getServiceDependencies(g).sort((t,s)=>t.index-s.index),o=[];for(const t of n){const s=this.s(t.id,m);s||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(s)}const i=n.length>0?n[0].index:d.length;if(d.length!==i){console.trace(`[createInstance] First service dependency of ${g.name} at position ${i+1} conflicts with ${d.length} static arguments`);const t=i-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,i)}return Reflect.construct(g,d.concat(o))}q(g,d){if(this.i.get(g)instanceof R.$Ci)this.i.set(g,d);else if(this.k)this.k.q(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const d=this.i.get(g);return!d&&this.k?this.k.r(g):d}s(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const m=this.r(g);return m instanceof R.$Ci?this.u(g,m,d.branch(g,!0)):(d.branch(g,!1),m)}u(g,d,m){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,d,m)}finally{this.t.delete(g)}}v(g,d,m){const n=new L.$pr(t=>t.id.toString());let o=0;const i=[{id:g,desc:d,_trace:m}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new E(n);for(const s of O._util.getServiceDependencies(t.desc.ctor)){const f=this.r(s.id);if(f||this.y(`[createInstance] ${g} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),f instanceof R.$Ci){const a={id:s.id,desc:f,_trace:t._trace.branch(s.id,!0)};n.insertEdge(t,a),i.push(a)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new E(n);break}for(const{data:s}of t){if(this.r(s.id)instanceof R.$Ci){const a=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,a)}n.removeNode(s)}}return this.r(g)}w(g,d,m=[],n,o){if(this.i.get(g)instanceof R.$Ci)return this.x(g,d,m,n,o,this.g);if(this.k)return this.k.w(g,d,m,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}x(g,d,m=[],n,o,i){if(n){const t=new u(void 0,this.j,this,this.l);t.c=String(g);const s=new Map,f=new r.$Yh(()=>{const a=t.o(d,m,o);for(const[w,y]of s){const S=a[w];if(typeof S=="function")for(const D of y)D.disposable=S.apply(a,D.listener)}return s.clear(),i.add(a),a});return new Proxy(Object.create(null),{get(a,w){if(!f.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let D=s.get(w);return D||(D=new l.$7c,s.set(w,D)),(C,p,v)=>{if(f.isInitialized)return f.value[w](C,p,v);{const N={listener:[C,p,v],disposable:void 0},T=D.push(N);return(0,A.$Uc)(()=>{T(),N.disposable?.dispose()})}}}if(w in a)return a[w];const y=f.value;let S=y[w];return typeof S!="function"||(S=S.bind(y),a[w]=S),S},set(a,w,y){return f.value[w]=y,!0},getPrototypeOf(a){return d.prototype}})}else{const t=this.o(d,m,o);return i.add(t),t}}y(g,d){if(d&&console.warn(g),this.j)throw new Error(g)}}e.$qr=u;var k;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(k||(k={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(k.None,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new b(k.Invocation,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(g,d){return g?new b(k.Creation,d.name):b.c}static{this.f=0}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const m=new b(k.Branch,g.toString());return this.h.push([g,d,m]),m}stop(){const g=Date.now()-this.g;b.f+=g;let d=!1;function m(o,i){const t=[],s=new Array(o+1).join("	");for(const[f,a,w]of i.h)if(a&&w){d=!0,t.push(`${s}CREATES -> ${f}`);const y=m(o+1,w);y&&t.push(y)}else t.push(`${s}uses -> ${f}`);return t.join(`
`)}const n=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(g>2||d)&&b.all.add(n.join(`
`))}}e.$rr=b}),define(Ee[12],Se([1,0,227,55,4,60,3,29,11,23,18,2,36,5]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=c,e.log=d,e.$nk=S,e.$ok=D,e.$pk=P,e.$qk=C,r=We(r),e.$_j=(0,k.$Fi)("logService"),e.$ak=(0,k.$Fi)("loggerService");function b(){return new Date().toISOString()}function c(p){return(0,I.$jg)(p)}var g;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$ck=g.Info;function d(p,v,N){switch(v){case g.Trace:p.trace(N);break;case g.Debug:p.debug(N);break;case g.Info:p.info(N);break;case g.Warning:p.warn(N);break;case g.Error:p.error(N);break;case g.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function m(p,v=!1){let N="";for(let T=0;T<p.length;T++){let M=p[T];if(M instanceof Error&&(M=(0,h.$qj)(M,v)),typeof M=="object")try{M=JSON.stringify(M)}catch{}N+=(T>0?" ":"")+M}return N}class n extends L.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new A.$me),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==g.Off&&this.b<=v}}e.$ek=n;class o extends n{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...N){this.f(g.Trace)&&this.g(g.Trace,m([v,...N],!0))}debug(v,...N){this.f(g.Debug)&&this.g(g.Debug,m([v,...N]))}info(v,...N){this.f(g.Info)&&this.g(g.Info,m([v,...N]))}warn(v,...N){this.f(g.Warning)&&this.g(g.Warning,m([v,...N]))}error(v,...N){if(this.f(g.Error))if(v instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=v.stack,this.g(g.Error,m(T))}else this.g(g.Error,m([v,...N]))}flush(){}}e.$fk=o;class i extends n{constructor(v=e.$ck){super(),this.setLevel(v),this.g=!$.$i}trace(v,...N){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...N):console.log(`[main ${b()}]`,v,...N))}debug(v,...N){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...N):console.log(`[main ${b()}]`,v,...N))}info(v,...N){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,v,...N):console.log(`[main ${b()}]`,v,...N))}warn(v,...N){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,v,...N):console.warn(`[main ${b()}]`,v,...N))}error(v,...N){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,v,...N):console.error(`[main ${b()}]`,v,...N))}flush(){}}e.$gk=i;class t extends n{constructor(v=e.$ck,N=!0){super(),this.g=N,this.setLevel(v)}trace(v,...N){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...N):console.log(v,...N))}debug(v,...N){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...N):console.log(v,...N))}info(v,...N){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...N):console.log(v,...N))}warn(v,...N){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...N):console.log(v,...N))}error(v,...N){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...N):console.error(v,...N))}flush(){}}e.$hk=t;class s extends n{constructor(v,N=e.$ck){super(),this.g=v,this.setLevel(N)}trace(v,...N){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(v),...N])}debug(v,...N){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(v),...N])}info(v,...N){this.f(g.Info)&&this.g.log(g.Info,[this.h(v),...N])}warn(v,...N){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(v),...N])}error(v,...N){this.f(g.Error)&&this.g.log(g.Error,[this.h(v),...N])}h(v){return typeof v=="string"?v:(0,h.$qj)(v,this.f(g.Trace))}flush(){}}e.$ik=s;class f extends n{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const N of this.g)N.setLevel(v);super.setLevel(v)}trace(v,...N){for(const T of this.g)T.trace(v,...N)}debug(v,...N){for(const T of this.g)T.debug(v,...N)}info(v,...N){for(const T of this.g)T.info(v,...N)}warn(v,...N){for(const T of this.g)T.warn(v,...N)}error(v,...N){for(const T of this.g)T.error(v,...N)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$jk=f;class a extends L.$Wc{constructor(v,N,T){if(super(),this.h=v,this.j=N,this.b=new O.$Cc,this.c=this.B(new A.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$me),this.onDidChangeVisibility=this.g.event,T)for(const M of T)this.b.set(M.resource,{logger:void 0,info:M})}m(v){return(0,I.$fg)(v)?[...this.b.values()].find(N=>N.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,N){const T=this.n(v),M=(0,I.$fg)(v)?v:N?.id??(0,R.$tj)(T.toString()).toString(16);let j=this.b.get(T)?.logger;const z=N?.logLevel==="always"?g.Trace:N?.logLevel;j||(j=this.s(T,z??this.getLogLevel(T)??this.h,{...N,id:M}));const F={logger:j,info:{resource:T,id:M,logLevel:z,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(F.info),this.b.set(T,F),j}n(v){return(0,I.$fg)(v)?(0,l.$gh)(this.j,`${v}.log`):v}setLogLevel(v,N){if(E.URI.isUri(v)){const T=v,M=N,j=this.b.get(T);j&&M!==j.info.logLevel&&(j.info.logLevel=M===this.h?void 0:M,j.logger?.setLevel(M),this.b.set(j.info.resource,j),this.f.fire([T,M]))}else{this.h=v;for(const[T,M]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,N){const T=this.m(v);T&&N!==!T.info.hidden&&(T.info.hidden=!N,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,N]))}getLogLevel(v){let N;return v&&(N=this.b.get(v)?.info.logLevel),N??this.h}registerLogger(v){const N=this.b.get(v.resource);N?N.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const N=this.b.get(v);N&&(N.logger&&N.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=a;class w{constructor(){this.onDidChangeLogLevel=new A.$me().event}setLevel(v){}getLevel(){return g.Info}trace(v,...N){}debug(v,...N){}info(v,...N){}warn(v,...N){}error(v,...N){}critical(v,...N){}dispose(){}flush(){}}e.$lk=w;class y extends w{}e.$mk=y;function S(p){if(p.verbose)return g.Trace;if(typeof p.logLevel=="string"){const v=C(p.logLevel.toLowerCase());if(v!==void 0)return v}return e.$ck}function D(p){switch(p){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function P(p){switch(p){case g.Trace:return{original:"Trace",value:r.localize(0,null)};case g.Debug:return{original:"Debug",value:r.localize(1,null)};case g.Info:return{original:"Info",value:r.localize(2,null)};case g.Warning:return{original:"Warning",value:r.localize(3,null)};case g.Error:return{original:"Error",value:r.localize(4,null)};case g.Off:return{original:"Off",value:r.localize(5,null)}}}function C(p){switch(p){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$rk=new u.$Wj("logLevel",D(g.Info))}),define(Ee[276],Se([1,0,19,9,14,4,33,3,16,70,12]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class E extends O.$Wc{constructor(k,b){super(),this.a=k,this.b=b,this.c=this.B(new R.$me),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$me),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new h.$Dh(0)),this.w=[],this.y=this.B(new h.$Dh(0))}watch(k,b){return b.recursive||this.b?.watcher?.forceUniversal?this.n(k,b):this.z(k,b)}n(k,b){const c={path:this.J(k),excludes:b.excludes,includes:b.includes,recursive:b.recursive,filter:b.filter,correlationId:b.correlationId},g=(0,r.$Vb)(this.j,c);return this.r(),(0,O.$Uc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,A.$3)(k))}s(){this.h||(this.h=this.B(this.t(b=>this.c.fire((0,l.$3q)(b)),b=>this.G(b),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const b of this.j)(0,l.$Yq)(b)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const b of this.j)(0,l.$Yq)(b)&&k.includes(b.path)&&(b.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,b){const c={path:this.J(k),excludes:b.excludes,includes:b.includes,recursive:!1,filter:b.filter,correlationId:b.correlationId},g=(0,r.$Vb)(this.w,c);return this.C(),(0,O.$Uc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,A.$3)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,l.$3q)(k)),k=>this.G(k),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.H(k)}H(k){this.a[k.type](k.message)}I(k){return(0,$.$jc)(k.fsPath)}J(k){const b=this.I(k);return(0,L.$Hg)(b)}}e.$9q=E}),define(Ee[277],Se([1,0,9,29,22,4,33,3,16,11,23,104,34,226,28,269,276,274,273]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=void 0;class n extends g.$9q{static{this.L=!1}constructor(i,t){super(i,t),this.onDidChangeCapabilities=R.Event.None,this.P=new h.$Cc(s=>I.$0g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=b.FileSystemProviderCapabilities.FileReadWrite|b.FileSystemProviderCapabilities.FileOpenReadWriteClose|b.FileSystemProviderCapabilities.FileReadStream|b.FileSystemProviderCapabilities.FileFolderCopy|b.FileSystemProviderCapabilities.FileWriteUnlock|b.FileSystemProviderCapabilities.FileAtomicRead|b.FileSystemProviderCapabilities.FileAtomicWrite|b.FileSystemProviderCapabilities.FileAtomicDelete|b.FileSystemProviderCapabilities.FileClone,l.$k&&(this.M|=b.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(i){try{const{stat:t,symbolicLink:s}=await u.SymlinkSupport.stat(this.I(i));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:b.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await u.Promises.readdir(this.I(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async f=>{try{let a;f.isSymbolicLink()?a=(await this.stat((0,I.$gh)(i,f.name))).type:a=this.O(f),s.push([f.name,a])}catch(a){this.a.trace(a)}})),s}catch(t){throw this.hb(t)}}O(i,t){let s;return t?.dangling?s=b.FileType.Unknown:i.isFile()?s=b.FileType.File:i.isDirectory()?s=b.FileType.Directory:s=b.FileType.Unknown,t&&(s|=b.FileType.SymbolicLink),s}async Q(i){const t=this.I(i);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(i);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const f=new r.$Eh;return this.P.set(i,f),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,O.$Uc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(i)===f&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(i)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),f.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(i)})`),s=await this.Q(i));const f=this.I(i);return await u.Promises.readFile(f)}catch(f){throw this.hb(f)}finally{s?.dispose()}}R(i){n.L&&this.a.trace(i)}readFileStream(i,t,s){const f=(0,E.$Ce)(a=>A.$Oe.concat(a.map(w=>A.$Oe.wrap(w))).buffer);return(0,c.$Vq)(this,i,f,a=>a.buffer,{...t,bufferSize:256*1024},s),f}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(i)?this.U(i,(0,I.$gh)((0,I.$fh)(i),`${(0,I.$dh)(i)}${s.atomic.postfix}`),t,s):this.W(i,t,s)}async S(i){try{const t=this.I(i),{symbolicLink:s}=await u.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(i,t,s,f){const a=new O.$Vc;try{a.add(await this.Q(i)),a.add(await this.Q(t)),await this.W(t,s,f,!0);try{await this.rename(t,i,{overwrite:!0})}catch(w){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{a.dispose()}}async W(i,t,s,f){let a;try{const w=this.I(i);if(!s.create||!s.overwrite){if(await u.Promises.exists(w)){if(!s.overwrite)throw(0,b.$ml)((0,k.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,b.$ml)((0,k.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(i,{create:!0,unlock:s.unlock},f),await this.write(a,0,t,0,t.byteLength)}catch(w){throw await this.ib(i,w)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(i){n.$=i}async open(i,t,s){const f=this.I(i);let a;(0,b.$al)(t)&&!s&&(a=await this.Q(i));let w;try{if((0,b.$al)(t)&&t.unlock)try{const{stat:S}=await u.SymlinkSupport.stat(f);S.mode&128||await u.Promises.chmod(f,S.mode|128)}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}let y;if((0,b.$al)(t)){if(l.$i)try{await u.Promises.truncate(f,0),y="r+"}catch(S){S.code!=="ENOENT"&&this.a.trace(S)}y||(y="w")}else y="r";w=await u.Promises.open(f,y)}catch(y){throw a?.dispose(),(0,b.$al)(t)?await this.ib(i,y):this.hb(y)}if(this.X.set(w,0),(0,b.$al)(t)&&this.Z.set(w,i),a){const y=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${f})`),this.Y.set(w,a),y&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${f})`),y.dispose())}return w}async close(i){const t=this.Y.get(i);try{if(this.X.delete(i),this.Z.delete(i)&&n.$)try{await u.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await u.Promises.close(i)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(i)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.Y.delete(i)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,f,a){const w=this.ab(i,t);let y=null;try{y=(await u.Promises.read(i,s,f,a,w)).bytesRead}catch(S){throw this.hb(S)}finally{this.bb(i,w,y)}return y}ab(i,t){return t===this.X.get(i)?null:t}bb(i,t,s){const f=this.X.get(i);typeof f=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(i,f+s):this.X.delete(i)))}async write(i,t,s,f,a){return(0,r.$Zh)(()=>this.cb(i,t,s,f,a),100,3)}async cb(i,t,s,f,a){const w=this.ab(i,t);let y=null;try{y=(await u.Promises.write(i,s,f,a,w)).bytesWritten}catch(S){throw await this.ib(this.Z.get(i),S)}finally{this.bb(i,w,y)}return y}async mkdir(i){try{await u.Promises.mkdir(this.I(i))}catch(t){throw this.hb(t)}}async delete(i,t){try{const s=this.I(i);if(t.recursive){let f;t?.atomic!==!1&&t.atomic.postfix&&(f=(0,$.$lc)((0,$.$oc)(s),`${(0,$.$pc)(s)}${t.atomic.postfix}`)),await u.Promises.rm(s,u.RimRafMode.MOVE,f)}else try{await u.Promises.unlink(s)}catch(f){if(f.code==="EPERM"||f.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:y}=await u.SymlinkSupport.stat(s);a=w.isDirectory()&&!y}catch{}if(a)await u.Promises.rmdir(s);else throw f}else throw f}}catch(s){throw this.hb(s)}}async rename(i,t,s){const f=this.I(i),a=this.I(t);if(f!==a)try{await this.db(i,t,"move",s.overwrite),await u.Promises.rename(f,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(2,null,(0,$.$pc)(f),(0,$.$pc)((0,$.$oc)(a)),w.toString()))),this.hb(w)}}async copy(i,t,s){const f=this.I(i),a=this.I(t);if(f!==a)try{await this.db(i,t,"copy",s.overwrite),await u.Promises.copy(f,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,k.localize)(3,null,(0,$.$pc)(f),(0,$.$pc)((0,$.$oc)(a)),w.toString()))),this.hb(w)}}async db(i,t,s,f){const a=this.I(i),w=this.I(t);let y=!1;if(!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)||(y=(0,L.$Dg)(a,w,!0)),y){if(s==="copy")throw(0,b.$ml)((0,k.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.N(i);if(!D)throw(0,b.$ml)((0,k.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(t);if(P){if(!f)throw(0,b.$ml)((0,k.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);D.type&b.FileType.File&&P.type&b.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.eb(i,t,!1)}async eb(i,t,s){const f=this.I(i),a=this.I(t),w=!!(this.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive);if((0,L.$Dg)(f,a,!w))return;const y=new O.$Vc;try{y.add(await this.Q(i)),y.add(await this.Q(t)),s&&await u.Promises.mkdir((0,$.$oc)(a),{recursive:!0}),await u.Promises.copyFile(f,a)}catch(S){if(S.code==="ENOENT"&&!s)return this.eb(i,t,!0);throw this.hb(S)}finally{y.dispose()}}t(i,t,s){return new d.$dr(f=>i(f),f=>t(f),s)}F(i,t,s){return new m.$mr(f=>i(f),f=>t(f),s)}hb(i){if(i instanceof b.$ll)return i;let t=i,s;switch(i.code){case"ENOENT":s=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=b.FileSystemProviderErrorCode.Unknown;break;default:s=b.FileSystemProviderErrorCode.Unknown}return(0,b.$ml)(t,s)}async ib(i,t){let s=this.hb(t);if(i&&s.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:f}=await u.SymlinkSupport.stat(this.I(i));f.mode&128||(s=(0,b.$ml)(t,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(f){this.a.trace(f)}return s}}e.$nr=n}),define(Ee[278],Se([1,0,3,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;class A extends r.$Wc{constructor(L,O=[]){super(),this.a=new h.$jk([L,...O]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...O){this.a.trace(L,...O)}debug(L,...O){this.a.debug(L,...O)}info(L,...O){this.a.info(L,...O)}warn(L,...O){this.a.warn(L,...O)}error(L,...O){this.a.error(L,...O)}flush(){this.a.flush()}}e.$kR=A}),define(Ee[279],Se([1,0,28,12]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=void 0;var A;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(A||(A={}));async function R(l,I,E,u,k){try{const b=await new Promise((g,d)=>{ce(["@vscode/spdlog"],g,d)}).then(We);b.setFlushOn(A.Trace);const c=await b.createAsyncRotatingLogger(l,I,E,u);return k?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(b){console.error(b)}return null}function L(l,I,E){switch(I){case h.LogLevel.Trace:l.trace(E);break;case h.LogLevel.Debug:l.debug(E);break;case h.LogLevel.Info:l.info(E);break;case h.LogLevel.Warning:l.warn(E);break;case h.LogLevel.Error:l.error(E);break;case h.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function O(l,I){switch(I){case h.LogLevel.Trace:l.setLevel(A.Trace);break;case h.LogLevel.Debug:l.setLevel(A.Debug);break;case h.LogLevel.Info:l.setLevel(A.Info);break;case h.LogLevel.Warning:l.setLevel(A.Warning);break;case h.LogLevel.Error:l.setLevel(A.Error);break;case h.LogLevel.Off:l.setLevel(A.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class $ extends h.$fk{constructor(I,E,u,k,b){super(),this.m=[],this.setLevel(b),this.n=this.s(I,E,u,k),this.B(this.onDidChangeLogLevel(c=>{this.r&&O(this.r,c)}))}async s(I,E,u,k){const b=u?6:1,c=30/b*r.$Hl.MB,g=await R(I,E,c,b,k);if(g){this.r=g,O(this.r,this.getLevel());for(const{level:d,message:m}of this.m)L(this.r,d,m);this.m=[]}}g(I,E){this.r?L(this.r,I,E):this.getLevel()<=I&&this.m.push({level:I,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$_Q=$});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[145],Se([1,0,44,228,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,r=Ut(r);var R;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function l(b,c){return c-b}$.compare=l;const I=Object.create(null);I[$.Error]=(0,h.localize)(0,null),I[$.Warning]=(0,h.localize)(1,null),I[$.Info]=(0,h.localize)(2,null);function E(b){return I[b]||""}$.toString=E;function u(b){switch(b){case r.default.Error:return $.Error;case r.default.Warning:return $.Warning;case r.default.Info:return $.Info;case r.default.Ignore:return $.Hint}}$.fromSeverity=u;function k(b){switch(b){case $.Error:return r.default.Error;case $.Warning:return r.default.Warning;case $.Info:return r.default.Info;case $.Hint:return r.default.Ignore}}$.toSeverity=k}(L||(e.MarkerSeverity=L={}));var O;(function($){const l="";function I(u){return E(u,!0)}$.makeKey=I;function E(u,k){const b=[l];return u.source?b.push(u.source.replace("\xA6","\\\xA6")):b.push(l),u.code?typeof u.code=="string"?b.push(u.code.replace("\xA6","\\\xA6")):b.push(u.code.value.replace("\xA6","\\\xA6")):b.push(l),u.severity!==void 0&&u.severity!==null?b.push(L.toString(u.severity)):b.push(l),u.message&&k?b.push(u.message.replace("\xA6","\\\xA6")):b.push(l),u.startLineNumber!==void 0&&u.startLineNumber!==null?b.push(u.startLineNumber.toString()):b.push(l),u.startColumn!==void 0&&u.startColumn!==null?b.push(u.startColumn.toString()):b.push(l),u.endLineNumber!==void 0&&u.endLineNumber!==null?b.push(u.endLineNumber.toString()):b.push(l),u.endColumn!==void 0&&u.endColumn!==null?b.push(u.endColumn.toString()):b.push(l),b.push(l),b.join("\xA6")}$.makeKeyOptionalMessage=E})(O||(e.IMarkerData=O={})),e.$zu=(0,A.$Fi)("markerService")});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[280],Se([1,0,4,44,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=e.$ow=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$mw=e.Severity=void 0,e.$nw=O,h=Ut(h),e.Severity=h.default,e.$mw=(0,A.$Fi)("notificationService");var R;(function(E){E[E.DEFAULT=0]="DEFAULT",E[E.SILENT=1]="SILENT",E[E.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(E){E[E.WORKSPACE=0]="WORKSPACE",E[E.PROFILE=1]="PROFILE",E[E.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function O(E){if(E){const u=E;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(E){E[E.OFF=0]="OFF",E[E.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class l{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$ow=l;class I{infinite(){}done(){}total(u){}worked(u){}}e.$pw=I}),define(Ee[281],Se([1,0,56]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const R=A.context.configuration();if(R)h=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:R.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(Ee[116],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,r.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(ce,e){return function(r,h){e(r,h,ce)}};define(Ee[90],Se([1,0,9,21,3,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$uw=e.$tw=e.$sw=e.$rw=e.ProgressLocation=e.$qw=void 0,e.$qw=(0,R.$Fi)("progressService");var L;(function(E){E[E.Explorer=1]="Explorer",E[E.Scm=3]="Scm",E[E.Extensions=5]="Extensions",E[E.Window=10]="Window",E[E.Notification=15]="Notification",E[E.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$rw=Object.freeze({total(){},worked(){},done(){}});class O{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$sw=O;class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const k=this.d;this.d=()=>{k?.(),u()}}):Promise.resolve()}}e.$tw=$;let l=class extends A.$Wc{constructor(u,k){super(),this.a=new r.$3h,k.withProgress(u,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,A.$Uc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$uw=l,e.$uw=l=Je([Ve(1,e.$qw)],l);class I extends A.$Wc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new A.$Vc)}start(u){this.stop();const k=++this.a,b=new h.$xe;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,A.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,A.$Uc)(()=>b.cancel())),this.b.add((0,A.$Uc)(()=>this.c?this.c.done():void 0)),{id:k,token:b.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$vw=I,e.$ww=(0,R.$Fi)("editorProgressService")}),define(Ee[37],Se([1,0,66,18]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,r=We(r),h=We(h);class A{constructor(){this.a=new Map}add(L,O){r.ok(h.$fg(L)),r.ok(h.$hg(O)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,O)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$po=new A}),define(Ee[117],Se([1,0,4,37]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,h=We(h),e.$qo={JSONContribution:"base.contributions.json"};function A(O){return O.length>0&&O.charAt(O.length-1)==="#"?O.substring(0,O.length-1):O}class R{constructor(){this.b=new r.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,l){this.a[A($)]=l,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;h.$po.add(e.$qo.JSONContribution,L)}),define(Ee[71],Se([1,0,19,4,18,217,45,117,37]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=c,e.$Go=g,e.$Ho=d,e.$Io=n,e.$Jo=o,A=We(A),R=We(R);var l;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$uo={Configuration:"base.contributions.configuration"};var I;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const E=$.$po.as(O.$qo.JSONContribution);class u{constructor(){this.h=new Set,this.i=new h.$me,this.onDidSchemaChange=this.i.event,this.j=new h.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Bo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const f=new Set;this.n(t,s,f),E.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(t){const s=new Set;this.o(t,s),E.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const f=new Set;this.o(s,f),this.n(t,!1,f),E.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const f=[];for(const{overrides:a,source:w}of t)for(const y in a)if(s.add(y),e.$Eo.test(y)){const S=this.a.get(y),D=S?.valuesSources??new Map;if(w)for(const v of Object.keys(a[y]))D.set(v,w);const P={...S?.value||{},...a[y]};this.a.set(y,{source:w,value:P,valuesSources:D});const C=(0,L.$jj)(y),p={type:"object",default:P,description:R.localize(1,null,C),$ref:e.$Bo,defaultDefaultValue:P,source:A.$fg(w)?void 0:w,defaultValueSource:w};f.push(...c(y)),this.d[y]=p,this.b.properties[y]=p}else{this.a.set(y,{value:a[y],source:w});const S=this.d[y];S&&(this.w(y,S),this.r(y,S))}this.m(f)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:f,source:a}of t)for(const w in f){const y=this.a.get(w),S=A.$fg(a)?a:a?.id,D=A.$fg(y?.source)?y?.source:y?.source?.id;if(S===D)if(s.add(w),this.a.delete(w),e.$Eo.test(w))delete this.d[w],delete this.b.properties[w];else{const P=this.d[w];P&&(this.w(w,P),this.r(w,P))}}this.u()}deltaConfiguration(t){let s=!1;const f=new Set;t.removedDefaults&&(this.l(t.removedDefaults,f),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,f),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,f),t.addedConfigurations&&this.n(t.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,f){t.forEach(a=>{this.p(a,s,a.extensionInfo,a.restrictedProperties,void 0,f),this.c.push(a),this.q(a)})}o(t,s){const f=a=>{if(a.properties)for(const w in a.properties){s.add(w);const y=this.d[w];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[w],this.s(w,a.properties[w])}a.allOf?.forEach(w=>f(w))};for(const a of t){f(a);const w=this.c.indexOf(a);w!==-1&&this.c.splice(w,1)}}p(t,s=!0,f,a,w=I.WINDOW,y){w=A.$og(t.scope)?w:t.scope;const S=t.properties;if(S)for(const P in S){const C=S[P];if(s&&n(P,C)){delete S[P];continue}if(C.source=f,C.defaultDefaultValue=S[P].default,this.w(P,C),e.$Eo.test(P)?C.scope=void 0:(C.scope=A.$og(C.scope)?w:C.scope,C.restricted=A.$og(C.restricted)?!!a?.includes(P):C.restricted),S[P].hasOwnProperty("included")&&!S[P].included){this.f[P]=S[P],delete S[P];continue}else this.d[P]=S[P],S[P].policy?.name&&this.e.set(S[P].policy.name,P);!S[P].deprecationMessage&&S[P].markdownDeprecationMessage&&(S[P].deprecationMessage=S[P].markdownDeprecationMessage),y.add(P)}const D=t.allOf;if(D)for(const P of D)this.p(P,s,f,a,w,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=f=>{const a=f.properties;if(a)for(const y in a)this.r(y,a[y]);f.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$vo.properties[t]=s,s.scope){case I.APPLICATION:e.$wo.properties[t]=s;break;case I.MACHINE:e.$xo.properties[t]=s;break;case I.MACHINE_OVERRIDABLE:e.$yo.properties[t]=s;break;case I.WINDOW:e.$zo.properties[t]=s;break;case I.RESOURCE:e.$Ao.properties[t]=s;break;case I.LANGUAGE_OVERRIDABLE:e.$Ao.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$vo.properties[t],s.scope){case I.APPLICATION:delete e.$wo.properties[t];break;case I.MACHINE:delete e.$xo.properties[t];break;case I.MACHINE_OVERRIDABLE:delete e.$yo.properties[t];break;case I.WINDOW:delete e.$zo.properties[t];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,f={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$Bo};this.w(s,f),e.$vo.properties[s]=f,e.$wo.properties[s]=f,e.$xo.properties[s]=f,e.$yo.properties[s]=f,e.$zo.properties[s]=f,e.$Ao.properties[s]=f}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=t,e.$wo.patternProperties[e.$Do]=t,e.$xo.patternProperties[e.$Do]=t,e.$yo.patternProperties[e.$Do]=t,e.$zo.patternProperties[e.$Do]=t,e.$Ao.patternProperties[e.$Do]=t,this.i.fire()}w(t,s){const f=this.a.get(t);let a=f?.value,w=f?.source;A.$mg(a)&&(a=s.defaultDefaultValue,w=void 0),A.$mg(a)&&(a=d(s.type)),s.default=a,s.defaultValueSource=w}}const k="\\[([^\\]]+)\\]",b=new RegExp(k,"g");e.$Do=`^(${k})+$`,e.$Eo=new RegExp(e.$Do);function c(i){const t=[];if(e.$Eo.test(i)){let s=b.exec(i);for(;s?.length;){const f=s[1].trim();f&&t.push(f),s=b.exec(i)}}return(0,r.$Ob)(t)}function g(i){return i.reduce((t,s)=>`${t}[${s}]`,"")}function d(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const m=new u;$.$po.add(e.$uo.Configuration,m);function n(i,t){return i.trim()?e.$Eo.test(i)?R.localize(7,null,i):m.getConfigurationProperties()[i]!==void 0?R.localize(8,null,i):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,i,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function o(){const i=[],t=m.getConfigurationProperties();for(const s of Object.keys(t))i.push([s,t[s].scope]);return i.push(["launch",I.RESOURCE]),i.push(["task",I.RESOURCE]),i}}),define(Ee[282],Se([1,0,19,4,175,3,29,25,18,2,45,71,28,37]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=o,r=We(r),A=We(A),O=We(O),$=We($);function b(f){return Object.isFrozen(f)?f:O.$do(f)}class c{static createEmptyModel(a){return new c({},[],[],void 0,a)}constructor(a,w,y,S,D){this.b=a,this.c=w,this.d=y,this.raw=S,this.f=D,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(w=>{if(w instanceof c)return w;const y=new g("",this.f);return y.parseRaw(w),y.configurationModel});this.g=a.reduce((w,y)=>y===w?y:w.merge(y),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,I.$hj)(this.contents,a):this.contents}inspect(a,w){const y=this;return{get value(){return b(y.rawConfiguration.getValue(a))},get override(){return w?b(y.rawConfiguration.getOverrideValue(a,w)):void 0},get merged(){return b(w?y.rawConfiguration.override(w).getValue(a):y.rawConfiguration.getValue(a))},get overrides(){const S=[];for(const{contents:D,identifiers:P,keys:C}of y.rawConfiguration.overrides){const p=new c(D,C,[],void 0,y.f).getValue(a);p!==void 0&&S.push({identifiers:P,value:p})}return S.length?b(S):void 0}}}getOverrideValue(a,w){const y=this.j(w);return y?a?(0,I.$hj)(y,a):y:void 0}getKeysForOverrideIdentifier(a){const w=[];for(const y of this.overrides)y.identifiers.includes(a)&&w.push(...y.keys);return r.$Ob(w)}getAllOverrideIdentifiers(){const a=[];for(const w of this.overrides)a.push(...w.identifiers);return r.$Ob(a)}override(a){let w=this.a.get(a);return w||(w=this.h(a),this.a.set(a,w)),w}merge(...a){const w=O.$co(this.contents),y=O.$co(this.overrides),S=[...this.keys],D=this.raw?.length?[...this.raw]:[this];for(const P of a)if(D.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(w,P.contents);for(const C of P.overrides){const[p]=y.filter(v=>r.$wb(v.identifiers,C.identifiers));p?(this.i(p.contents,C.contents),p.keys.push(...C.keys),p.keys=r.$Ob(p.keys)):y.push(O.$co(C))}for(const C of P.keys)S.indexOf(C)===-1&&S.push(C)}return new c(w,S,y,D.every(P=>P instanceof c)?void 0:D,this.f)}h(a){const w=this.j(a);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const y={};for(const S of r.$Ob([...Object.keys(this.contents),...Object.keys(w)])){let D=this.contents[S];const P=w[S];P&&(typeof D=="object"&&typeof P=="object"?(D=O.$co(D),this.i(D,P)):D=P),y[S]=D}return new c(y,this.keys,this.overrides,void 0,this.f)}i(a,w){for(const y of Object.keys(w)){if(y in a&&$.$hg(a[y])&&$.$hg(w[y])){this.i(a[y],w[y]);continue}a[y]=O.$co(w[y])}}j(a){let w=null,y=null;const S=D=>{D&&(y?this.i(y,D):y=O.$co(D))};for(const D of this.overrides)D.identifiers.length===1&&D.identifiers[0]===a?w=D.contents:D.identifiers.includes(a)&&S(D.contents);return S(w),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,w){this.k(a,w,!0)}setValue(a,w){this.k(a,w,!1)}removeValue(a){const w=this.keys.indexOf(a);w!==-1&&(this.keys.splice(w,1),(0,I.$gj)(this.contents,a),E.$Eo.test(a)&&this.overrides.splice(this.overrides.findIndex(y=>r.$wb(y.identifiers,(0,E.$Fo)(a))),1))}k(a,w,y){(0,I.$fj)(this.contents,a,w,S=>this.f.error(S)),y=y||this.keys.indexOf(a)===-1,y&&this.keys.push(a),E.$Eo.test(a)&&this.overrides.push({identifiers:(0,E.$Fo)(a),keys:Object.keys(this.contents[a]),contents:(0,I.$ej)(this.contents[a],S=>this.f.error(S))})}}e.$Ko=c;class g{constructor(a,w){this.f=a,this.g=w,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,w){if(!$.$og(a)){const y=this.h(a);this.parseRaw(y,w)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,w){this.a=a;const{contents:y,keys:S,overrides:D,restricted:P,hasExcludedProperties:C}=this.i(a,w);this.b=new c(y,S,D,C?[a]:void 0,this.g),this.c=P||[]}h(a){let w={},y=null,S=[];const D=[],P=[];function C(v){Array.isArray(S)?S.push(v):y!==null&&(S[y]=v)}const p={onObjectBegin:()=>{const v={};C(v),D.push(S),S=v,y=null},onObjectProperty:v=>{y=v},onObjectEnd:()=>{S=D.pop()},onArrayBegin:()=>{const v=[];C(v),D.push(S),S=v,y=null},onArrayEnd:()=>{S=D.pop()},onLiteralValue:C,onError:(v,N,T)=>{P.push({error:v,offset:N,length:T})}};if(a)try{A.$3n(a,p),w=S[0]||{}}catch(v){this.g.error(`Error while parsing settings file ${this.f}: ${v}`),this.d=[v]}return w}i(a,w){const y=k.$po.as(E.$uo.Configuration).getConfigurationProperties(),S=this.j(a,y,!0,w);a=S.raw;const D=(0,I.$ej)(a,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`)),P=Object.keys(a),C=this.l(a,p=>this.g.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:D,keys:P,overrides:C,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(a,w,y,S){let D=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:D};const P={},C=[];for(const p in a)if(E.$Eo.test(p)&&y){const v=this.j(a[p],w,!1,S);P[p]=v.raw,D=D||v.hasExcludedProperties,C.push(...v.restricted)}else{const v=w[p],N=v?typeof v.scope<"u"?v.scope:E.ConfigurationScope.WINDOW:void 0;v?.restricted&&C.push(p),!S.exclude?.includes(p)&&(S.include?.includes(p)||(N===void 0||S.scopes===void 0||S.scopes.includes(N))&&!(S.skipRestricted&&v?.restricted))?P[p]=a[p]:D=!0}return{raw:P,restricted:C,hasExcludedProperties:D}}l(a,w){const y=[];for(const S of Object.keys(a))if(E.$Eo.test(S)){const D={};for(const P in a[S])D[P]=a[S][P];y.push({identifiers:(0,E.$Fo)(S),keys:Object.keys(D),contents:(0,I.$ej)(D,w)})}return y}}e.$Lo=g;class d extends R.$Wc{constructor(a,w,y,S,D){super(),this.c=a,this.f=w,this.g=S,this.h=D,this.b=this.B(new h.$me),this.onDidChange=this.b.event,this.a=new g(this.c.toString(),D),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(h.Event.any(h.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),h.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(u.FileOperation.CREATE)||P.isOperation(u.FileOperation.COPY)||P.isOperation(u.FileOperation.DELETE)||P.isOperation(u.FileOperation.WRITE))&&y.isEqual(P.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=d;class m{constructor(a,w,y,S,D,P,C,p,v,N,T,M,j){this.a=a,this.b=w,this.c=y,this.overrideIdentifiers=S,this.d=D,this.f=P,this.g=C,this.h=p,this.i=v,this.j=N,this.k=T,this.l=M,this.m=j}get value(){return b(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,w,y,S,D,P,C,p,v,N){this.j=a,this.l=w,this.m=y,this.n=S,this.p=D,this.q=P,this.r=C,this.s=p,this.t=v,this.u=N,this.h=null,this.i=new L.$Cc,this.v=null}getValue(a,w,y){return this.w(a,w,y).getValue(a)}updateValue(a,w,y={}){let S;y.resource?(S=this.t.get(y.resource),S||(S=c.createEmptyModel(this.u),this.t.set(y.resource,S))):S=this.s,w===void 0?S.removeValue(a):S.setValue(a,w),y.resource||(this.h=null)}inspect(a,w,y){const S=this.w(a,w,y),D=this.A(w.resource,y),P=w.resource?this.t.get(w.resource)||this.s:this.s,C=new Set;for(const p of S.overrides)for(const v of p.identifiers)S.getOverrideValue(a,v)!==void 0&&C.add(v);return new m(a,w,S.getValue(a),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,D||void 0,P)}keys(a){const w=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,w){this.r.set(a,w),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,w){const y=[];if(!w){const{added:S,updated:D,removed:P}=t(this.j,a);w=[...S,...D,...P]}for(const S of w)for(const D of(0,E.$Fo)(S)){const P=this.j.getKeysForOverrideIdentifier(D),C=a.getKeysForOverrideIdentifier(D),p=[...C.filter(v=>P.indexOf(v)===-1),...P.filter(v=>C.indexOf(v)===-1),...P.filter(v=>!O.$go(this.j.override(D).getValue(v),a.override(D).getValue(v)))];y.push([D,p])}return this.updateDefaultConfiguration(a),{keys:w,overrides:y}}compareAndUpdatePolicyConfiguration(a){const{added:w,updated:y,removed:S}=t(this.l,a),D=[...w,...y,...S];return D.length&&this.updatePolicyConfiguration(a),{keys:D,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.applicationConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateApplicationConfiguration(a),{keys:P,overrides:D}}compareAndUpdateLocalUserConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.localUserConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateLocalUserConfiguration(a),{keys:P,overrides:D}}compareAndUpdateRemoteUserConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.remoteUserConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateRemoteUserConfiguration(a),{keys:P,overrides:D}}compareAndUpdateWorkspaceConfiguration(a){const{added:w,updated:y,removed:S,overrides:D}=t(this.workspaceConfiguration,a),P=[...w,...y,...S];return P.length&&this.updateWorkspaceConfiguration(a),{keys:P,overrides:D}}compareAndUpdateFolderConfiguration(a,w){const y=this.folderConfigurations.get(a),{added:S,updated:D,removed:P,overrides:C}=t(y,w),p=[...S,...D,...P];return(p.length||!y)&&this.updateFolderConfiguration(a,w),{keys:p,overrides:C}}compareAndDeleteFolderConfiguration(a){const w=this.folderConfigurations.get(a);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:y,updated:S,removed:D,overrides:P}=t(w,void 0);return{keys:[...y,...S,...D],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,w,y){let S=this.x(w,y);return w.overrideIdentifier&&(S=S.override(w.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(S=S.merge(this.l)),S}x({resource:a},w){let y=this.y();if(w&&a){const S=w.getFolder(a);S&&(y=this.z(S.uri)||y);const D=this.t.get(a);D&&(y=y.merge(D))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let w=this.i.get(a);if(!w){const y=this.y(),S=this.r.get(a);S?(w=y.merge(S),this.i.set(a,w)):w=y}return w}A(a,w){if(w&&a){const y=w.getFolder(a);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,w)=>{const{contents:y,overrides:S,keys:D}=this.r.get(w);return a.push([w,{contents:y,overrides:S,keys:D}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(w=>a.add(w)),this.userConfiguration.keys.forEach(w=>a.add(w)),this.q.keys.forEach(w=>a.add(w)),this.r.forEach(w=>w.keys.forEach(y=>a.add(y))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.q.getAllOverrideIdentifiers().forEach(w=>a.add(w)),this.r.forEach(w=>w.getAllOverrideIdentifiers().forEach(y=>a.add(y))),[...a.values()]}D(a){const w=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.q.getKeysForOverrideIdentifier(a).forEach(y=>w.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(a).forEach(S=>w.add(S))),[...w.values()]}static parse(a,w){const y=this.E(a.defaults,w),S=this.E(a.policy,w),D=this.E(a.application,w),P=this.E(a.user,w),C=this.E(a.workspace,w),p=a.folders.reduce((v,N)=>(v.set(l.URI.revive(N[0]),this.E(N[1],w)),v),new L.$Cc);return new n(y,S,D,P,c.createEmptyModel(w),C,p,c.createEmptyModel(w),new L.$Cc,w)}static E(a,w){return new c(a.contents,a.keys,a.overrides,void 0,w)}}e.$No=n;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const a=new Set,w=new Map;for(const S of f)S.keys.forEach(D=>a.add(D)),S.overrides.forEach(([D,P])=>{const C=(0,L.$zc)(w,D,new Set);P.forEach(p=>C.add(p))});const y=[];return w.forEach((S,D)=>y.push([D,[...S.values()]])),{keys:[...a.values()],overrides:y}}class i{constructor(a,w,y,S,D){this.change=a,this.f=w,this.g=y,this.h=S,this.i=D,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of a.keys)this.affectedKeys.add(P);for(const[,P]of a.overrides)for(const C of P)this.affectedKeys.add(C);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,w){const y=this.a+a,S=this.d.indexOf(y);if(S<0)return!1;const D=S+y.length;if(D>=this.d.length)return!1;const P=this.d.charCodeAt(D);if(P!==this.b&&P!==this.c)return!1;if(w){const C=this.previousConfiguration?this.previousConfiguration.getValue(a,w,this.f?.workspace):void 0,p=this.g.getValue(a,w,this.h);return!O.$go(C,p)}return!0}}e.$Po=i;function t(f,a){const{added:w,removed:y,updated:S}=s(a?.rawConfiguration,f?.rawConfiguration),D=[],P=f?.getAllOverrideIdentifiers()||[],C=a?.getAllOverrideIdentifiers()||[];if(a){const p=C.filter(v=>!P.includes(v));for(const v of p)D.push([v,a.getKeysForOverrideIdentifier(v)])}if(f){const p=P.filter(v=>!C.includes(v));for(const v of p)D.push([v,f.getKeysForOverrideIdentifier(v)])}if(a&&f){for(const p of P)if(C.includes(p)){const v=s({contents:f.getOverrideValue(void 0,p)||{},keys:f.getKeysForOverrideIdentifier(p)},{contents:a.getOverrideValue(void 0,p)||{},keys:a.getKeysForOverrideIdentifier(p)});D.push([p,[...v.added,...v.removed,...v.updated]])}}return{added:w,removed:y,updated:S,overrides:D}}function s(f,a){const w=f?a?f.keys.filter(D=>a.keys.indexOf(D)===-1):[...f.keys]:[],y=a?f?a.keys.filter(D=>f.keys.indexOf(D)===-1):[...a.keys]:[],S=[];if(f&&a){for(const D of a.keys)if(f.keys.indexOf(D)!==-1){const P=(0,I.$hj)(a.contents,D),C=(0,I.$hj)(f.contents,D);O.$go(P,C)||S.push(D)}}return{added:w,removed:y,updated:S}}}),define(Ee[283],Se([1,0,22,4,3,69]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hwb=e.$Fwb=e.$Ewb=void 0,e.$Gwb=O;const L=(l,I,E)=>{const u=new Uint8Array(16);for(let c=0;c<16;c++)u[c]=Math.round(Math.random()*256);const k=(0,r.$9e)(r.$Oe.wrap(u));return[`GET ws://localhost${l}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${k}`].join(`\r
`)+`\r
\r
`};e.$Ewb=L,e.$Fwb=r.$Oe.fromString(`\r
\r
`);async function O(l,I,E,u,k){l.write(r.$Oe.fromString((0,e.$Ewb)(I,E,u)));const b=new A.$Vc;try{return await new Promise((c,g)=>{let d;b.add(l.onData(m=>{d?d=r.$Oe.concat([d,m],d.byteLength+m.byteLength):d=m;const n=d.indexOf(e.$Fwb);if(n===-1)return;c(l),l.pauseData();const o=d.slice(n+e.$Fwb.byteLength);o.byteLength&&k.onData.fire(o)})),b.add(l.onClose(m=>g(m??new Error("socket closed")))),b.add(l.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw l.dispose(),c}finally{b.dispose()}}class $ extends A.$Wc{constructor(I,E){super(),this.g=I,this.a=this.B(new h.$pe),this.onData=(...u)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...u)),this.b=this.B(new h.$me),this.onDidDispose=this.b.event,this.f=!1,this.B(E.onData),this.B(E.onData.event(u=>this.a.fire(u))),this.onClose=this.B(E.onClose).event,this.onEnd=this.B(E.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,E){R.SocketDiagnostics.traceSocketEvent(this,this.g,I,E)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Hwb=$}),define(Ee[72],Se([1,0,14,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=l,e.$Ql=(0,h.$Fi)("remoteAuthorityResolverService");var A;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class R{constructor(E){this.id=E,this.type=A.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=R;class L{constructor(E,u){this.host=E,this.port=u,this.type=A.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=L;var O;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(O||(e.RemoteAuthorityResolverErrorCode=O={}));class $ extends r.$db{static isNotAvailable(E){return E instanceof $&&E._code===O.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof $&&E._code===O.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof $&&E._code===O.NoResolverFound}static isInvalidAuthority(E){return E instanceof $&&E._code===O.InvalidAuthority}static isHandled(E){return E instanceof $&&E.isHandled}constructor(E,u=O.Unknown,k){super(E),this._message=E,this._code=u,this._detail=k,this.isHandled=u===O.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Tl=$;function l(I){const E=I.indexOf("+");return E===-1?I:I.substring(0,E)}}),define(Ee[284],Se([1,0,9,22,21,14,4,3,15,62,43,32,69,72]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Zl=D,e.$1l=P,e.$2l=p,l=We(l);const b=30*1e3;var c;(function($e){$e[$e.Management=1]="Management",$e[$e.ExtensionHost=2]="ExtensionHost",$e[$e.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g($e){switch($e){case c.Management:return"Management";case c.ExtensionHost:return"ExtensionHost";case c.Tunnel:return"Tunnel"}}function d($e){const K=new A.$xe;return setTimeout(()=>K.cancel(),$e),K.token}function m($e,K){if($e.isCancellationRequested||K.isCancellationRequested)return A.CancellationToken.Cancelled;const W=new A.$xe;return $e.onCancellationRequested(()=>W.cancel()),K.onCancellationRequested(()=>W.cancel()),W.token}class n{get didTimeout(){return this.c==="timedout"}constructor(K){this.c="pending",this.d=new O.$Vc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$yh)(),K.isCancellationRequested?this.h():this.d.add(K.onCancellationRequested(()=>this.h()))}registerDisposable(K){this.c==="pending"?this.d.add(K):K.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const K=new Error("Time limit reached");return K.code="ETIMEDOUT",K.syscall="connect",K}resolve(K){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(K))}reject(K){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(K))}}function o($e,K){const W=new n(K);return W.registerDisposable($e.onControlMessage(se=>{const oe=JSON.parse(se.toString()),te=G(oe);te?W.reject(te):W.resolve(oe)})),W.promise}function i($e,K,W,se,oe,te,le,he){const X=new n(he),ae=I.$ge.create(!1);return $e.info(`Creating a socket (${le})...`),l.mark(`code/willCreateSocket/${te}`),K.connect(W,se,oe,le).then(pe=>{X.didTimeout?(l.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),pe?.dispose()):(l.mark(`code/didCreateSocketOK/${te}`),$e.info(`Creating a socket (${le}) was successful after ${ae.elapsed()} ms.`),X.resolve(pe))},pe=>{l.mark(`code/didCreateSocketError/${te}`),$e.info(`Creating a socket (${le}) returned an error after ${ae.elapsed()} ms.`),$e.error(pe),X.reject(pe)}),X.promise}function t($e,K){const W=new n(K);return $e.then(se=>{W.didTimeout||W.resolve(se)},se=>{W.didTimeout||W.reject(se)}),W.promise}async function s($e,K,W,se){const oe=ne($e,K);$e.logService.trace(`${oe} 1/6. invoking socketFactory.connect().`);let te;try{te=await i($e.logService,$e.remoteSocketFactoryService,$e.connectTo,$.$Sg.getServerRootPath(),`reconnectionToken=${$e.reconnectionToken}&reconnection=${$e.reconnectionProtocol?"true":"false"}`,g(K),`renderer-${g(K)}-${$e.reconnectionToken}`,se)}catch(pe){throw $e.logService.error(`${oe} socketFactory.connect() failed or timed out. Error:`),$e.logService.error(pe),pe}$e.logService.trace(`${oe} 2/6. socketFactory.connect() was successful.`);let le,he;$e.reconnectionProtocol?($e.reconnectionProtocol.beginAcceptReconnection(te,null),le=$e.reconnectionProtocol,he=!1):(le=new u.$ti({socket:te}),he=!0),$e.logService.trace(`${oe} 3/6. sending AuthRequest control message.`);const X=await t($e.signService.createNewMessage((0,E.$2g)()),se),ae={type:"auth",auth:$e.connectionToken||"00000000000000000000",data:X.data};le.sendControl(h.$Oe.fromString(JSON.stringify(ae)));try{const pe=await o(le,m(se,d(1e4)));if(pe.type!=="sign"||typeof pe.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if($e.logService.trace(`${oe} 4/6. received SignRequest control message.`),!await t($e.signService.validate(X,pe.signedData),se)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Fe=await t($e.signService.sign(pe.data),se),Be={type:"connectionType",commit:$e.commit,signedData:Fe,desiredConnectionType:K};return W&&(Be.args=W),$e.logService.trace(`${oe} 5/6. sending ConnectionTypeRequest control message.`),le.sendControl(h.$Oe.fromString(JSON.stringify(Be))),{protocol:le,ownsProtocol:he}}catch(pe){throw pe&&pe.code==="ETIMEDOUT"&&($e.logService.error(`${oe} the handshake timed out. Error:`),$e.logService.error(pe)),pe&&pe.code==="VSCODE_CONNECTION_ERROR"&&($e.logService.error(`${oe} received error control message when negotiating connection. Error:`),$e.logService.error(pe)),he&&U(le),pe}}async function f($e,K,W,se){const oe=Date.now(),te=ne($e,K),{protocol:le,ownsProtocol:he}=await s($e,K,W,se),X=new n(se);return X.registerDisposable(le.onControlMessage(ae=>{const pe=JSON.parse(ae.toString()),be=G(pe);be?($e.logService.error(`${te} received error control message when negotiating connection. Error:`),$e.logService.error(be),he&&U(le),X.reject(be)):($e.reconnectionProtocol?.endAcceptReconnection(),$e.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${De(oe)}!`),X.resolve({protocol:le,firstMessage:pe}))})),X.promise}async function a($e,K){const{protocol:W}=await f($e,c.Management,void 0,K);return{protocol:W}}async function w($e,K,W){const{protocol:se,firstMessage:oe}=await f($e,c.ExtensionHost,K,W),te=oe&&oe.debugPort;return{protocol:se,debugPort:te}}async function y($e,K,W){const se=Date.now(),oe=ne($e,c.Tunnel),{protocol:te}=await s($e,c.Tunnel,K,W);return $e.logService.trace(`${oe} 6/6. handshake finished, connection is up and running after ${De(se)}!`),te}async function S($e,K,W){const{connectTo:se,connectionToken:oe}=await $e.addressProvider.getAddress();return{commit:$e.commit,quality:$e.quality,connectTo:se,connectionToken:oe,reconnectionToken:K,reconnectionProtocol:W,remoteSocketFactoryService:$e.remoteSocketFactoryService,signService:$e.signService,logService:$e.logService}}async function D($e,K,W){return C($e,async se=>{const{protocol:oe}=await a(se,A.CancellationToken.None);return new _($e,K,W,se.reconnectionToken,oe)})}async function P($e,K){return C($e,async W=>{const{protocol:se,debugPort:oe}=await w(W,K,A.CancellationToken.None);return new re($e,K,W.reconnectionToken,se,oe)})}async function C($e,K){for(let se=1;;se++)try{const oe=(0,E.$2g)(),te=await S($e,oe,null);return await K(te)}catch(oe){if(se<5)$e.logService.error(`[remote-connection][attempt ${se}] An error occurred in initial connection! Will retry... Error:`),$e.logService.error(oe);else throw $e.logService.error(`[remote-connection][attempt ${se}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$e.logService.error(oe),B.triggerPermanentFailure(0,0,k.$Tl.isHandled(oe)),oe}}async function p($e,K,W){const se=await S($e,(0,E.$2g)(),null);return await y(se,{host:K,port:W},A.CancellationToken.None)}function v($e){return(0,r.$sh)(K=>new Promise((W,se)=>{const oe=setTimeout(W,$e*1e3);K.onCancellationRequested(()=>{clearTimeout(oe),W()})}))}var N;(function($e){$e[$e.ConnectionLost=0]="ConnectionLost",$e[$e.ReconnectionWait=1]="ReconnectionWait",$e[$e.ReconnectionRunning=2]="ReconnectionRunning",$e[$e.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$e[$e.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class T{constructor(K,W){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.type=N.ConnectionLost}}e.$3l=T;class M{constructor(K,W,se,oe){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.durationSeconds=se,this.c=oe,this.type=N.ReconnectionWait}skipWait(){this.c.cancel()}}e.$4l=M;class j{constructor(K,W,se){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=N.ReconnectionRunning}}e.$5l=j;class z{constructor(K,W,se){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.type=N.ConnectionGain}}e.$6l=z;class F{constructor(K,W,se,oe){this.reconnectionToken=K,this.millisSinceLastIncomingData=W,this.attempt=se,this.handled=oe,this.type=N.ReconnectionPermanentFailure}}e.$7l=F;class B extends O.$Wc{static triggerPermanentFailure(K,W,se){this._permanentFailure=!0,this.f=K,this.g=W,this.h=se,this.j.forEach(oe=>oe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(K=>K.y())}static debugPauseSocketWriting(){this.j.forEach(K=>K.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(K,W,se,oe,te){super(),this.t=K,this.u=W,this.reconnectionToken=se,this.protocol=oe,this.w=te,this.m=this.B(new L.$me),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new z(this.reconnectionToken,0,0)),this.B(oe.onSocketClose(le=>{const he=ue(this.t,this.reconnectionToken,!0);le?le.type===u.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${he} received socket close event (hadError: ${le.hadError}).`),le.error&&this.u.logService.error(le.error)):(this.u.logService.info(`${he} received socket close event (wasClean: ${le.wasClean}, code: ${le.code}, reason: ${le.reason}).`),le.event&&this.u.logService.error(le.event)):this.u.logService.info(`${he} received socket close event.`),this.y()})),this.B(oe.onSocketTimeout(le=>{const he=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${he} received socket timeout event (unacknowledgedMsgCount: ${le.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${le.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${le.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,O.$Uc)(()=>{const le=B.j.indexOf(this);le>=0&&B.j.splice(le,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const K=ue(this.t,this.reconnectionToken,!0);this.u.logService.info(`${K} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let se=-1;do{se++;const oe=se<W.length?W[se]:W[W.length-1];try{if(oe>0){const le=v(oe);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),oe,le)),this.u.logService.info(`${K} waiting for ${oe} seconds before reconnecting...`);try{await le}catch{}}if(this.n){this.u.logService.error(`${K} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1)),this.u.logService.info(`${K} resolving connection...`);const te=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${K} connecting to ${te.connectTo}...`),await this.G(te,d(b)),this.u.logService.info(`${K} reconnected!`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se+1));break}catch(te){if(te.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${K} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(se>360){this.u.logService.error(`${K} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}if(k.$Tl.isTemporarilyNotAvailable(te)){this.u.logService.info(`${K} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((te.code==="ETIMEDOUT"||te.code==="ENETUNREACH"||te.code==="ECONNREFUSED"||te.code==="ECONNRESET")&&te.syscall==="connect"){this.u.logService.info(`${K} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if((0,R.$6)(te)){this.u.logService.info(`${K} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(te);continue}if(te instanceof k.$Tl){this.u.logService.error(`${K} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,k.$Tl.isHandled(te));break}this.u.logService.error(`${K} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(te),this.C(this.protocol.getMillisSinceLastIncomingData(),se+1,!1);break}}while(!this.n&&!this.s)}C(K,W,se){this.w?B.triggerPermanentFailure(K,W,se):this.D(K,W,se)}D(K,W,se){this.m.fire(new F(this.reconnectionToken,K,W,se)),U(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$8l=B;class _ extends B{constructor(K,W,se,oe,te){super(c.Management,K,oe,te,!0),this.client=this.B(new u.$ri(te,{remoteAuthority:W,clientId:se},K.ipcLogger))}async G(K,W){await a(K,W)}}e.$9l=_;class re extends B{constructor(K,W,se,oe,te){super(c.ExtensionHost,K,se,oe,!1),this.H=W,this.debugPort=te}async G(K,W){await w(K,this.H,W)}}e.$0l=re;function U($e){try{$e.acceptDisconnect();const K=$e.getSocket();$e.dispose(),K.dispose()}catch(K){(0,R.$3)(K)}}function G($e){if($e&&$e.type==="error"){const K=new Error(`Connection error: ${$e.reason}`);return K.code="VSCODE_CONNECTION_ERROR",K}return null}function Q($e,K){for(;$e.length<K;)$e+=" ";return $e}function ee($e,K){return`[remote-connection][${Q(g($e),13)}][${K.substr(0,5)}\u2026]`}function ue($e,K,W){return`${ee($e,K)}[${W?"reconnect":"initial"}]`}function ne($e,K){return`${ue(K,$e.reconnectionToken,!!$e.reconnectionProtocol)}[${$e.connectTo}]`}function De($e){return`${Date.now()-$e} ms`}}),define(Ee[91],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=h,e.$hn=A,e.$in=R,e.$jn=L;function h($){return $.scheme===r.Schemas.vscodeRemote?$.authority:void 0}function A($){if(!$)return;const l=$.indexOf("+");return l<0?$:$.substr(0,l)}function R($){const{host:l,port:I}=O($);if(typeof I>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:I}}function L($,l){let{host:I,port:E}=O($);return typeof E>"u"&&(E=l),{host:I,port:E}}function O($){const l=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const I=$.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const E=$.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:$,port:void 0}}}),define(Ee[24],Se([1,0,13,5,91]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=R,e.$tn=E,e.$un=u,e.$vn=k,e.$wn=b,r=We(r),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function R(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(L||(e.ExtensionType=L={}));var O;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const m=typeof g=="string"?g:g.value,n=typeof d=="string"?d:d.value;return r.$Gf(m,n)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$qn=$;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$rn=l;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,d){this.c.set($.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=I;function E(c){return u(c)}function u(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function k(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function b(c,g){if(g){const d=`onResolveRemoteAuthority:${(0,A.$hn)(g)}`;return!!c.activationEvents?.includes(d)}return!1}e.$xn=(0,h.$Fi)("IBuiltinExtensionsScannerService")}),define(Ee[146],Se([1,0,11,221,24,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=O,e.$cp=$,e.$dp=l,e.$ep=I,e.$fp=E,e.$gp=u,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function O(i){switch(i){case A.TargetPlatform.WIN32_X64:return"Windows 64 bit";case A.TargetPlatform.WIN32_ARM64:return"Windows ARM";case A.TargetPlatform.LINUX_X64:return"Linux 64 bit";case A.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case A.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case A.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case A.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case A.TargetPlatform.DARWIN_X64:return"Mac";case A.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case A.TargetPlatform.WEB:return"Web";case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;case A.TargetPlatform.UNKNOWN:return A.TargetPlatform.UNKNOWN;case A.TargetPlatform.UNDEFINED:return A.TargetPlatform.UNDEFINED}}function $(i){switch(i){case A.TargetPlatform.WIN32_X64:return A.TargetPlatform.WIN32_X64;case A.TargetPlatform.WIN32_ARM64:return A.TargetPlatform.WIN32_ARM64;case A.TargetPlatform.LINUX_X64:return A.TargetPlatform.LINUX_X64;case A.TargetPlatform.LINUX_ARM64:return A.TargetPlatform.LINUX_ARM64;case A.TargetPlatform.LINUX_ARMHF:return A.TargetPlatform.LINUX_ARMHF;case A.TargetPlatform.ALPINE_X64:return A.TargetPlatform.ALPINE_X64;case A.TargetPlatform.ALPINE_ARM64:return A.TargetPlatform.ALPINE_ARM64;case A.TargetPlatform.DARWIN_X64:return A.TargetPlatform.DARWIN_X64;case A.TargetPlatform.DARWIN_ARM64:return A.TargetPlatform.DARWIN_ARM64;case A.TargetPlatform.WEB:return A.TargetPlatform.WEB;case A.TargetPlatform.UNIVERSAL:return A.TargetPlatform.UNIVERSAL;default:return A.TargetPlatform.UNKNOWN}}function l(i,t){switch(i){case r.Platform.Windows:return t==="x64"?A.TargetPlatform.WIN32_X64:t==="arm64"?A.TargetPlatform.WIN32_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?A.TargetPlatform.LINUX_X64:t==="arm64"?A.TargetPlatform.LINUX_ARM64:t==="arm"?A.TargetPlatform.LINUX_ARMHF:A.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?A.TargetPlatform.ALPINE_X64:t==="arm64"?A.TargetPlatform.ALPINE_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?A.TargetPlatform.DARWIN_X64:t==="arm64"?A.TargetPlatform.DARWIN_ARM64:A.TargetPlatform.UNKNOWN;case r.Platform.Web:return A.TargetPlatform.WEB}}function I(i,t){return t===A.TargetPlatform.WEB&&!i.includes(A.TargetPlatform.WEB)}function E(i,t,s){return I(t,s)?!1:i===A.TargetPlatform.UNDEFINED||i===A.TargetPlatform.UNIVERSAL?!0:i===A.TargetPlatform.UNKNOWN?!1:i===s}function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var k;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var b;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var c;(function(i){i.Install="install",i.Uninstall="uninstall"})(c||(e.StatisticType=c={}));var g;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$hp=(0,R.$Fi)("extensionGalleryService");var d;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(d||(e.ExtensionGalleryErrorCode=d={}));class m extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$ip=m;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class o extends Error{constructor(t,s){super(t),this.code=s,this.name=s}}e.$jp=o,e.$kp=(0,R.$Fi)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,R.$Fi)("IGlobalExtensionEnablementService"),e.$op=(0,R.$Fi)("IExtensionTipsService"),e.$pp=(0,h.localize2)(0,"Extensions"),e.$qp=(0,h.localize2)(1,"Preferences")}),define(Ee[147],Se([1,0,14,24]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JG=e.$IG=void 0;class A{constructor(){this.a=new Map,this.b=new WeakMap}register(L,O){this.a.set(L,O)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const O=Object.create(null);for(const $ of L){const l=this.readActivationEvents($);l.length>0&&(O[h.$qn.toKey($.identifier)]=l)}return O}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const O=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<O.length;$++)O[$]==="onUri"&&(O[$]=`onUri:${h.$qn.toKey(L.identifier)}`);if(!L.contributes)return O;for(const $ in L.contributes){const l=this.a.get($);if(!l)continue;const I=L.contributes[$],E=Array.isArray(I)?I:[I];try{l(E,O)}catch(u){(0,r.$3)(u)}}return O}}e.$IG=A,e.$JG=new A}),define(Ee[285],Se([1,0,3,5]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wl=e.$Vl=void 0,e.$Vl=(0,h.$Fi)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(L,O){return this.a[L]??=[],this.a[L].push(O),(0,r.$Uc)(()=>{const $=this.a[L]?.indexOf(O);typeof $=="number"&&$>=0&&this.a[L]?.splice($,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,O,$,l){const I=this.b(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,O,$,l)}}e.$Wl=A}),define(Ee[286],Se([1,0,22,14,3,229,71,5,12,37]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0,e.$4p=u,e.$5p=k,e.$6p=b,e.$7p=c,e.$8p=g,e.$9p=d,e.$2p=(0,O.$Fi)("requestService");class I{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class E extends A.$Wc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,R.localize)(0,null),when:$.$rk.isEqualTo((0,$.$ok)($.LogLevel.Trace)).serialize()})}async c(i,t,s){const f=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${f} - begin`,t.type,new I(t.headers??{}));try{const a=await s();return this.a.trace(`${f} - end`,t.type,a.res.statusCode,a.res.headers),a}catch(a){throw this.a.error(`${f} - error`,t.type,(0,h.$_)(a)),a}}}e.$3p=E;function u(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function k(o){return o.res.statusCode===204}async function b(o){return k(o)?null:(await(0,r.$1e)(o.stream)).toString()}async function c(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);return b(o)}async function g(o){if(!u(o))throw new Error("Server returned "+o.res.statusCode);if(k(o))return null;const t=(await(0,r.$1e)(o.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function d(o){n(o)}let m;function n(o){const i=l.$po.as(L.$uo.Configuration),t=m;m={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[m],remove:t?[t]:[]})}n(L.ConfigurationScope.APPLICATION)}),define(Ee[287],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=void 0;class r{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const R=await this.c();if(R){const L=String(r.a++);return this.b.set(L,R),{id:L,data:R.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,R){if(!A.id)return!0;const L=this.b.get(A.id);if(!L)return!1;this.b.delete(A.id);try{return L.validate(R)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$5ac=r}),define(Ee[118],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yl=e.$Xl=void 0,e.$Xl="signService",e.$Yl=(0,r.$Fi)(e.$Xl)}),define(Ee[148],Se([1,0,287]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=void 0;class h extends r.$5ac{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(L=>new L.signer().sign(R))}h(){return new Promise((R,L)=>ce(["vsda"],R,L))}}e.$0fc=h}),define(Ee[288],Se([1,0,11,56,32]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=L,e.$sp=O;function R($){if(r.$u===r.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,l,I,E,u,k,b,c,g,d){const m=Object.create(null);m["common.machineId"]=k,m["common.sqmId"]=b,m["common.devDeviceId"]=c,m.sessionID=(0,A.$2g)()+Date.now(),m.commitHash=E,m.version=u,m["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,r.$h)(r.$u),m["common.nodePlatform"]=h.$fc,m["common.nodeArch"]=I,m["common.product"]=d||"desktop",g&&(m["common.msftInternal"]=g);let n=0;const o=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),r.$l&&(m["common.snap"]="true");const i=R(l);return i&&(m["common.platformDetail"]=i),m}function O($){const l=h.env.USERDNSDOMAIN;if(!l)return!1;const I=l.toLowerCase();return $.some(E=>I===E)}}),define(Ee[149],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,r.$Fi)("telemetryService"),e.$_l=(0,r.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var h;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(h||(e.TelemetryLevel=h={}));var A;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(Ee[92],Se([1,0,25,18,91,288,149]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=I,e.$Bp=E,e.$Cp=u,e.$Dp=k,e.$Ep=c,e.$Fp=d,e.$Gp=m,e.$Hp=i;class O{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$tp=O;class ${constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=$,e.$vp=new $;class l{async publicLog(s,f,a){}async publicLogError(s,f,a){}}e.$wp=l,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function E(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const s=t.getValue(L.$hm),f=t.getValue(L.$im);if(t.getValue(L.$jm)===!1||f===!1)return L.TelemetryLevel.NONE;switch(s??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function k(t){const s={},f={},a={};g(t,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const y=a[w];typeof y=="number"?f[w]=y:typeof y=="boolean"?f[w]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${y.length}`),s[w]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(s[w]=y)}return{properties:s,measurements:f}}const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const s=(0,A.$hn)(t);return b.has(s)?s:"other"}function g(t,s,f=0,a){if(t)for(const w of Object.getOwnPropertyNames(t)){const y=t[w],S=a?a+w:w;Array.isArray(y)?s[S]=(0,r.$ho)(y):y instanceof Date?s[S]=y.toISOString():(0,h.$hg)(y)?f<2?g(y,s,f+1,S+"."):s[S]=(0,r.$ho)(y):s[S]=y}}function d(t,s){const f=t.msftInternalDomains||[],a=s.getValue("telemetry.internalTesting");return(0,R.$sp)(f)||a}function m(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let f=t;const a=[];for(const D of s)for(;;){const P=D.exec(t);if(!P)break;a.push([P.index,D.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(f="";;){const D=y.exec(t);if(!D)break;const P=a.some(([C,p])=>D.index<p&&C<y.lastIndex);!w.test(D[0])&&!P&&(f+=t.substring(S,D.index)+"<REDACTED: user-file-path>",S=y.lastIndex)}return S<t.length&&(f+=t.substr(S)),f}function o(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of s)if(f.regex.test(t))return`<REDACTED: ${f.label}>`;return t}function i(t,s){return(0,r.$eo)(t,f=>{if(f instanceof O||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let a=f.replaceAll("%20"," ");a=n(a,s);for(const w of s)a=a.replace(w,"");return a=o(a),a}})}}),define(Ee[289],Se([1,0,13,146,24,11,2,14,56,92]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=I,e.$Kp=b,e.$Lp=c,e.$Mp=g,e.$Np=d,e.$Op=m,e.$Pp=n,e.$Qp=o,e.$Sp=i,e.$Tp=s;function I(f,a){return f.uuid&&a.uuid?f.uuid===a.uuid:f.id===a.id?!0:(0,r.$Bf)(f.id,a.id)===0}const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(a){const w=a.manifest?a.manifest.version:a.version,y=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new u(a.identifier,w,y)}static parse(a){const w=E.exec(a);return w&&w[1]&&w[2]?new u({id:w[1]},w[2],w[4]||void 0):null}constructor(a,w,y=A.TargetPlatform.UNDEFINED){this.identifier=a,this.version=w,this.targetPlatform=y,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==A.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof u?I(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.$Jp=u;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(f){const a=k.exec(f);return a&&a[1]?[g(a[1]),a[2]]:[g(f),void 0]}function c(f,a){return`${f}.${a}`}function g(f){return f.toLowerCase()}function d(f,a){return g(c(f??A.$mn,a))}function m(f,a){const w=[],y=S=>{for(const D of w)if(D.some(P=>I(a(P),a(S))))return D;return null};for(const S of f){const D=y(S);D?D.push(S):w.push([S])}return w}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function o(f){return{id:new l.$tp(f.identifier.id),name:new l.$tp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Rp=new A.$qn("pprice.better-merge");function i(f,a){const w=[],y=a.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const S=y.shift();if(S&&w.every(D=>!I(D.identifier,{id:S}))){const D=f.filter(P=>I(P.identifier,{id:S}));D.length===1&&(w.push(D[0]),y.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}async function t(f,a){if(!R.$k)return!1;let w;try{w=(await f.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await f.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){a.debug("Error while getting the os-release file.",(0,O.$_)(S))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(f,a){const w=await t(f,a),y=(0,h.$dp)(w?"alpine":R.$u,$.$gc);return a.debug("ComputeTargetPlatform:",y),y}}),define(Ee[290],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=r,e.$As=h,e.$Bs=A,e.$Cs=R,e.$Ds=L,e.$Es=O;function r($){return[...$.entries()]}function h($){return $?[...$.entries()]:[]}function A($){return new Map($)}function R($){return new Map($??[])}function L($){return Array.from($.entries()).map(l=>[l[0],r(l[1].map),h(l[1].descriptionMap)])}function O($){return new Map($.map(l=>[l[0],{map:A(l[1]),descriptionMap:R(l[2])}]))}}),define(Ee[291],Se([1,0,5,36,37]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.$ls=e.$ks=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$js=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$is=void 0,e.$is=new h.$Wj("terminalTabFocusMode",!1,!0);var R;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var L;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var O;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(O||(e.PosixShellType=O={}));var $;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})($||(e.WindowsShellType=$={}));var l;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var I;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var E;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E||(e.ProcessPropertyType=E={})),e.$js=(0,r.$Fi)("ptyService");var u;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var k;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(k||(e.TerminalLocation=k={}));var b;(function(i){i.TerminalView="view",i.Editor="editor"})(b||(e.TerminalLocationString=b={}));var c;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(c||(e.LocalReconnectConstants=c={}));var g;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var d;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var m;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(m||(e.ShellIntegrationStatus=m={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ks={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}A.$po.add(e.$ks.Backend,new o),e.$ls=(0,r.$Fi)("localPtyService"),e.$ms=(0,r.$Fi)("terminalLogService")}),define(Ee[292],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zwb=void 0;class r{constructor(A){this.b=A,this.a=new Map}dispose(){for(const A of this.a.values())A.dispose()}startBuffering(A,R,L=5){const O=R($=>{const l=typeof $=="string"?$:$.data;let I=this.a.get(A);if(I){I.data.push(l);return}const E=setTimeout(()=>this.flushBuffer(A),L);I={data:[l],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(A),O.dispose()}},this.a.set(A,I)});return O}stopBuffering(A){this.a.get(A)?.dispose()}flushBuffer(A){const R=this.a.get(A);R&&(this.a.delete(A),this.b(A,R.data.join("")))}}e.$Zwb=r}),define(Ee[293],Se([1,0,9,83,105,50,4,18,2,230,117,37]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bx=e.$Ax=e.$zx=e.$yx=e.$xx=e.$wx=e.IconFontDefinition=e.IconContribution=e.$tx=void 0,e.$ux=g,e.$vx=d,E=We(E),e.$tx={IconContribution:"base.contributions.icons"};var u;(function(i){function t(s,f){let a=s.defaults;for(;R.ThemeIcon.isThemeIcon(a);){const w=c.getIcon(a.id);if(!w)return;a=w.defaults}return a}i.getDefinition=t})(u||(e.IconContribution=u={}));var k;(function(i){function t(f){return{weight:f.weight,style:f.style,src:f.src.map(a=>({format:a.format,location:a.location.toString()}))}}i.toJSONObject=t;function s(f){const a=w=>(0,O.$fg)(w)?w:void 0;if(f&&Array.isArray(f.src)&&f.src.every(w=>(0,O.$fg)(w.format)&&(0,O.$fg)(w.location)))return{weight:a(f.weight),style:a(f.style),src:f.src.map(w=>({format:w.format,location:$.URI.parse(w.location)}))}}i.fromJSONObject=s})(k||(e.IconFontDefinition=k={}));class b{constructor(){this.a=new L.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${R.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,s,f,a){const w=this.b[t];if(w){if(f&&!w.description){w.description=f,this.d.properties[t].markdownDescription=`${f} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=f),this.a.fire()}return w}const y={id:t,description:f,defaults:s,deprecationMessage:a};this.b[t]=y;const S={$ref:"#/definitions/icons"};return a&&(S.deprecationMessage=a),f&&(S.markdownDescription=`${f}: $(${t})`),this.d.properties[t]=S,this.e.enum.push(t),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const s=this.e.enum.indexOf(t);s!==-1&&(this.e.enum.splice(s,1),this.e.enumDescriptions.splice(s,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,s){const f=this.f[t];return f||(this.f[t]=s,this.a.fire(),s)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(w,y)=>w.id.localeCompare(y.id),s=w=>{for(;R.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const a=Object.keys(this.b).map(w=>this.b[w]);for(const w of a.filter(y=>!!y.description).sort(t))f.push(`|<i class="${s(w)}"></i>|${w.id}|${R.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const w of a.filter(y=>!R.ThemeIcon.isThemeIcon(y.defaults)).sort(t))f.push(`|<i class="${s(w)}"></i>|${w.id}|`);return f.join(`
`)}}const c=new b;E.$po.add(e.$tx.IconContribution,c);function g(i,t,s,f){return c.registerIcon(i,t,s,f)}function d(){return c}function m(){const i=(0,A.$1j)();for(const t in i){const s="\\"+i[t].toString(16);c.registerIcon(t,{fontCharacter:s})}}m(),e.$wx="vscode://schemas/icons";const n=E.$po.as(I.$qo.JSONContribution);n.registerSchema(e.$wx,c.getIconSchema());const o=new r.$Rh(()=>n.notifySchemaChanged(e.$wx),200);c.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$xx=g("widget-close",h.$5j.close,(0,l.localize)(2,null)),e.$yx=g("goto-previous-location",h.$5j.arrowUp,(0,l.localize)(3,null)),e.$zx=g("goto-next-location",h.$5j.arrowDown,(0,l.localize)(4,null)),e.$Ax=R.ThemeIcon.modify(h.$5j.sync,"spin"),e.$Bx=R.ThemeIcon.modify(h.$5j.loading,"spin")}),define(Ee[93],Se([1,0,4,3,11,2,45,5,12]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iw=e.$Hw=e.$Ew=e.$Cw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$yw=e.$xw=void 0,e.$zw=E,e.$Aw=k,e.$Bw=b,e.$Dw=c,e.$Fw=g,e.$Gw=d,e.$xw=(0,O.$Fi)("tunnelService"),e.$yw=(0,O.$Fi)("sharedTunnelsService");var l;(function(o){o.Http="http",o.Https="https"})(l||(e.TunnelProtocol=l={}));var I;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(I||(e.TunnelPrivacyId=I={}));function E(o){return!!o.forwardPort}var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function k(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(i)return{address:i[1],port:+i[2]}}function b(o){if(o.scheme!=="http"&&o.scheme!=="https"||!o.query)return;const i=o.query.split("&");for(const t of i){const s=t.split("=")[1];if(/^https?:/.exec(s)){const f=k(R.URI.parse(s));if(f)return f}}}e.$Cw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function c(o){return e.$Cw.indexOf(o)>=0}e.$Ew=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function g(o){return e.$Ew.indexOf(o)>=0}function d(o,i,t,s){if(t===A.OperatingSystem.Windows)return!1;if(t===A.OperatingSystem.Macintosh&&g(i)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(f?.length===4&&parseInt(f[1])>=18)return!1}return o<1024}class m{constructor(i,t,s){this.remoteAddress=i,this.localAddress=t,this.b=s,this.a=new r.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Hw=m;let n=class extends h.$Wc{constructor(i,t){super(),this.r=i,this.s=t,this.a=new r.$me,this.onTunnelOpened=this.a.event,this.b=new r.$me,this.onTunnelClosed=this.b.event,this.c=new r.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],t=Array.from(this.f.values());for(const s of t){const f=Array.from(s.values());for(const a of f){const w=await a.value;w&&typeof w!="string"&&i.push(w)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:t}of i.values())await t.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,t,s,f,a){this.z(i,t,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:t,localAddress:s,privacy:f,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,t){(g(i)||c(i))&&(i=e.$Cw[0]);const s=this.D(i,t);if(s)return++s.refcount,s.value}openTunnel(i,t,s,f,a,w=!1,y,S){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${s} on local port ${a}.`);const D=this.g??i;if(!D)return;if(t||(t="localhost"),f||(f=this.t),this.g&&this.n.has(s)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const P=this.F(D,t,s,f,a,w,y,S);return P?P.then(C=>{if(C){if(typeof C=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,s),C}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,s);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.w(C);return(C.tunnelRemoteHost!==t||C.tunnelRemotePort!==s)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),y&&C.privacy!==y&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),P)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const t=this.f.get(i.tunnelRemoteHost);if(t){const s=t.get(i.tunnelRemotePort);s&&(s.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async y(i,t,s){if(s.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${t}.`);const f=s.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(t),f}}async closeTunnel(i,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${t} `);const s=this.f.get(i);if(s&&s.has(t)){const f=s.get(t);f.refcount=0,await this.y(i,t,f)}}z(i,t,s){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(t,{refcount:1,value:s})}async C(i,t){const s=this.f.get(i);if(s){const f=s.get(t),a=f?await f.value:void 0;(!a||typeof a=="string")&&s.delete(t),s.size===0&&this.f.delete(i)}}D(i,t){const s=[i];c(i)?(s.push(...e.$Cw),s.push(...e.$Ew)):g(i)&&s.push(...e.$Ew);const f=s.map(a=>this.f.get(a));for(const a of f){const w=a?.get(t);if(w)return w}}canTunnel(i){return!!k(i)}G(i,t,s,f,a,w,y){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${s} on local port ${f}.`);const S=s;this.n.add(S);const D=f===void 0?s:f,P={elevationRequired:a?this.isPortPrivileged(D):!1},C={remoteAddress:{host:t,port:s},localAddressPort:f,privacy:w,public:w?w!==I.Private:void 0,protocol:y},p=i.forwardPort(C,P);return p?(this.z(t,s,p),p.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(S)})):this.n.delete(S),p}};e.$Iw=n,e.$Iw=n=Je([Ve(0,$.$_j),Ve(1,L.$_i)],n)}),define(Ee[294],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,r.$Fi)("IUriIdentityService")}),define(Ee[295],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Jw=void 0,e.$Jw=(0,r.$Fi)("editSessionIdentityService");var h;(function(A){A[A.Complete=100]="Complete",A[A.Partial=50]="Partial",A[A.None=0]="None"})(h||(e.EditSessionIdentityMatch=h={}))}),define(Ee[296],Se([1,0,15]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=h,e.$1M=A,e.$2M=R,e.$3M=L,e.$4M=O;function h($){return $.scheme!==r.Schemas.file&&$.scheme!==r.Schemas.vscodeRemote}function A($){if($.folders.length)return $.folders.every(l=>h(l.uri))?$.folders[0].uri:void 0;if($.configuration&&h($.configuration))return $.configuration}function R($){return A($)?.scheme}function L($){return A($)?.authority}function O($){return A($)!==void 0}}),define(Ee[46],Se([1,0,232,16,85,23,2,5,15]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=l,e.$Qi=I,e.$Ti=E,e.$Ui=u,e.$Vi=k,e.$Wi=c,e.$Xi=g,e.$1i=n,e.$6i=o,e.$7i=i,e.$9i=t,e.$0i=s,e.$$i=f,e.$Oi=(0,O.$Fi)("contextService");function l(a){const w=a;return typeof w?.id=="string"&&L.URI.isUri(w.uri)}function I(a){return typeof a?.id=="string"&&!l(a)&&!u(a)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function E(a,w){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,h.$pc)(a)}:w?e.$Ri:e.$Si;const y=a;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function u(a){const w=a;return typeof w?.id=="string"&&L.URI.isUri(w.configPath)}function k(a){const w=a;if(w?.uri)return{id:w.id,uri:L.URI.revive(w.uri)};const y=a;if(y?.configPath)return{id:y.id,configPath:L.URI.revive(y.configPath)};if(a?.id)return{id:a.id}}var b;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function c(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}function g(a){const w=a;return!!(w&&typeof w=="object"&&L.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}class d{constructor(w,y,S,D,P){this.h=w,this.j=S,this.k=D,this.l=P,this.c=A.$Li.forUris(this.l,()=>!0),this.folders=y}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=A.$Li.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=d;class m{constructor(w,y){this.raw=y,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,R.$gh)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=m;function n(a){return new m({uri:a,index:0,name:(0,R.$ch)(a)},{uri:a.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,r.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function o(a,w){return R.$0g.isEqualOrParent(a,w.untitledWorkspacesHome)}function i(a){let w;return L.URI.isUri(a)?w=a:w=a.configuration,w?.scheme===$.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.$8i}function s(a,w){return!o(a,w)&&!i(a)}function f(a){return(typeof a=="string"?(0,h.$qc)(a):(0,R.$eh)(a))===e.$3i}}),define(Ee[150],Se([1,0,60,4,3,23,2,231,144,28,5,12,46,29,294,9,32,13,18]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=o,e.$Ml=i,e.$Nl=t;var n;(function(a){a.Settings="settings",a.Keybindings="keybindings",a.Snippets="snippets",a.Tasks="tasks",a.Extensions="extensions",a.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(a){const w=a;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&typeof w.isDefault=="boolean"&&typeof w.name=="string"&&L.URI.isUri(w.location)&&L.URI.isUri(w.globalStorageHome)&&L.URI.isUri(w.settingsResource)&&L.URI.isUri(w.keybindingsResource)&&L.URI.isUri(w.tasksResource)&&L.URI.isUri(w.snippetsHome)&&L.URI.isUri(w.extensionsResource))}e.$Ll=(0,I.$Fi)("IUserDataProfilesService");function i(a,w){return{id:a.id,isDefault:a.isDefault,name:a.name,shortName:a.shortName,icon:a.icon,location:L.URI.revive(a.location).with({scheme:w}),globalStorageHome:L.URI.revive(a.globalStorageHome).with({scheme:w}),settingsResource:L.URI.revive(a.settingsResource).with({scheme:w}),keybindingsResource:L.URI.revive(a.keybindingsResource).with({scheme:w}),tasksResource:L.URI.revive(a.tasksResource).with({scheme:w}),snippetsHome:L.URI.revive(a.snippetsHome).with({scheme:w}),extensionsResource:L.URI.revive(a.extensionsResource).with({scheme:w}),cacheHome:L.URI.revive(a.cacheHome).with({scheme:w}),useDefaultFlags:a.useDefaultFlags,isTransient:a.isTransient}}function t(a,w,y,S,D,P){return{id:a,name:w,location:y,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:P&&D?.useDefaultFlags?.globalState?P.globalStorageHome:(0,R.$gh)(y,"globalStorage"),settingsResource:P&&D?.useDefaultFlags?.settings?P.settingsResource:(0,R.$gh)(y,"settings.json"),keybindingsResource:P&&D?.useDefaultFlags?.keybindings?P.keybindingsResource:(0,R.$gh)(y,"keybindings.json"),tasksResource:P&&D?.useDefaultFlags?.tasks?P.tasksResource:(0,R.$gh)(y,"tasks.json"),snippetsHome:P&&D?.useDefaultFlags?.snippets?P.snippetsHome:(0,R.$gh)(y,"snippets"),extensionsResource:P&&D?.useDefaultFlags?.extensions?P.extensionsResource:(0,R.$gh)(y,"extensions.json"),cacheHome:(0,R.$gh)(S,a),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}let s=class extends A.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(w,y,S,D){super(),this.t=w,this.u=y,this.w=S,this.y=D,this.f=!0,this.h=this.B(new h.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new h.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new h.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new h.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new k.$Cc,workspaces:new k.$Cc,emptyWindows:new Map},this.profilesHome=(0,R.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(w){this.f!==w&&(this.z=void 0,this.f=w)}isEnabled(){return this.f}get C(){if(!this.z){const w=this.D(),y=[w];if(this.f)try{for(const P of this.O()){if(!P.name||!(0,m.$fg)(P.name)||!P.location){this.y.warn("Skipping the invalid stored profile",P.location||P.name);continue}y.push(t((0,R.$dh)(P.location),P.name,P.location,this.g,{shortName:P.shortName,icon:P.icon,useDefaultFlags:P.useDefaultFlags},w))}}catch(P){this.y.error(P)}const S=new k.$Cc,D=new Map;if(y.length)try{const P=this.Q();if(P.workspaces)for(const[C,p]of Object.entries(P.workspaces)){const v=L.URI.parse(C),N=y.find(T=>T.id===p);N&&S.set(v,N)}if(P.emptyWindows)for(const[C,p]of Object.entries(P.emptyWindows)){const v=y.find(N=>N.id===p);v&&D.set(C,v)}}catch(P){this.y.error(P)}this.z={profiles:y,workspaces:S,emptyWindows:D}}return this.z}D(){const w=t("__default__profile__",(0,O.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...w,extensionsResource:this.S()??w.extensionsResource,isDefault:!0}}async createTransientProfile(w){const y="Temp",S=new RegExp(`${(0,d.$if)(y)}\\s(\\d+)`);let D=0;for(const C of this.profiles){const p=S.exec(C.name),v=p?parseInt(p[1]):0;D=v>D?v:D}const P=`${y} ${D+1}`;return this.createProfile((0,r.$tj)((0,g.$2g)()).toString(16),P,{transient:!0},w)}async createNamedProfile(w,y,S){return this.createProfile((0,r.$tj)((0,g.$2g)()).toString(16),w,y,S)}async createProfile(w,y,S,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const P=await this.F(w,y,S);return D&&await this.setProfileForWorkspace(D,P),P}async F(w,y,S){if(!(0,m.$fg)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(y);return D||(D=(async()=>{try{if(this.profiles.find(v=>v.name===y||v.id===w))throw new Error(`Profile with ${y} name already exists`);const C=t(w,y,(0,R.$gh)(this.profilesHome,w),this.g,S,this.defaultProfile);await this.u.createFolder(C.location);const p=[];return this.j.fire({profile:C,join(v){p.push(v)}}),await c.Promises.settled(p),this.I([C],[],[]),C}finally{this.r.delete(y)}})(),this.r.set(y,D)),D}async updateProfile(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(D=>D.id===w.id);if(!S)throw new Error(`Profile '${w.name}' does not exist`);return S=t(S.id,y.name??S.name,S.location,this.g,{shortName:y.shortName??S.shortName,icon:y.icon===null?void 0:y.icon??S.icon,transient:y.transient??S.isTransient,useDefaultFlags:y.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(w.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(D=>D.id===w.id);if(!y)throw new Error(`Profile '${w.name}' does not exist`);const S=[];this.m.fire({profile:y,join(D){S.push(D)}});try{await Promise.allSettled(S)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(D){(0,l.$ql)(D)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(D)}}async setProfileForWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(D=>D.id===y.id);if(!S)throw new Error(`Profile '${y.name}' does not exist`);this.L(w,S)}unsetWorkspace(w,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(w,void 0,y)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const w=await this.u.resolve(this.profilesHome);await Promise.all((w.children||[]).filter(y=>y.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const w=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(w.map(y=>this.removeProfile(y)))}getProfileForWorkspace(w){const y=this.G(w),S=L.URI.isUri(y)?this.C.workspaces.get(y):this.C.emptyWindows.get(y);return S||((0,u.$Pi)(w)?this.s.folders.get(w.uri):(0,u.$Ui)(w)?this.s.workspaces.get(w.configPath):this.s.emptyWindows.get(w.id))}G(w){return(0,u.$Pi)(w)?w.uri:(0,u.$Ui)(w)?w.configPath:w.id}H(w){return!!([...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,w.location))||[...this.s.folders.values()].some(y=>this.w.extUri.isEqual(y.location,w.location)))}I(w,y,S){const D=[...this.profiles,...w],P=[],C=this.s.profiles;this.s.profiles=[];for(let p of D){if(p.isDefault||y.some(N=>p.id===N.id))continue;p=S.find(N=>p.id===N.id)??p;const v=C.find(N=>p.id===N.id);if(p.isTransient)this.s.profiles.push(p);else{if(v){for(const[N,T]of this.s.emptyWindows.entries())if(p.id===T.id){this.L({id:N},p);break}for(const[N,T]of this.s.workspaces.entries())if(p.id===T.id){this.L({id:"",configPath:N},p);break}for(const[N,T]of this.s.folders.entries())if(p.id===T.id){this.L({id:"",uri:N},p);break}}P.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags})}}this.P(P),this.z=void 0,this.J(w,y,S)}J(w,y,S){this.h.fire({added:w,removed:y,updated:S,all:this.profiles})}L(w,y,S){if(S=y?.isTransient?!0:S,S)(0,u.$Pi)(w)?(this.s.folders.delete(w.uri),y&&this.s.folders.set(w.uri,y)):(0,u.$Ui)(w)?(this.s.workspaces.delete(w.configPath),y&&this.s.workspaces.set(w.configPath,y)):(this.s.emptyWindows.delete(w.id),y&&this.s.emptyWindows.set(w.id,y));else{this.L(w,void 0,!0);const D=this.G(w);L.URI.isUri(D)?(this.C.workspaces.delete(D),y&&this.C.workspaces.set(D,y)):(this.C.emptyWindows.delete(D),y&&this.C.emptyWindows.set(D,y)),this.M()}}M(){const w={};for(const[S,D]of this.C.workspaces.entries())w[S.toString()]=D.id;const y={};for(const[S,D]of this.C.emptyWindows.entries())y[S.toString()]=D.id;this.R({workspaces:w,emptyWindows:y}),this.z=void 0}N(w){const y={},S=this.D();if(w.workspaces)for(const[P,C]of Object.entries(w.workspaces)){const p=L.URI.parse(C);y[P]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}const D={};if(w.emptyWindows)for(const[P,C]of Object.entries(w.emptyWindows)){const p=L.URI.parse(C);D[P]=this.w.extUri.isEqual(p,S.location)?S.id:this.w.extUri.basename(p)}return{workspaces:y,emptyWindows:D}}O(){return[]}P(w){throw new Error("not implemented")}Q(){return{}}R(w){throw new Error("not implemented")}S(){}};e.$Ol=s,e.$Ol=s=Je([Ve(0,$.$Mi),Ve(1,l.$_k),Ve(2,b.$Jl),Ve(3,E.$_j)],s);class f extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(w){this.a=w}Q(){return this.X}R(w){this.X=w}}e.$Pl=f}),define(Ee[151],Se([1,0,9,4,3,62,18,209,5,150]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$eq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$cq=e.$bq=e.$aq=void 0,e.$dq=k,e.$fq=c,e.$hq=d,e.$aq="__$__isNewStorageMarker",e.$bq="__$__targetStorageMarker",e.$cq=(0,$.$Fi)("storageService");var I;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var E;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var u;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function k(m){const n=m.get(e.$bq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class b extends A.$Wc{static{this.a=60*1e3}constructor(n={flushInterval:b.a}){super(),this.m=n,this.b=this.B(new h.$pe),this.c=this.B(new h.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new h.$me),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,i){return h.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),i)}n(){this.j.value=(0,r.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:i,external:t}=o;if(i===e.$bq){switch(n){case E.APPLICATION:this.H=void 0;break;case E.PROFILE:this.F=void 0;break;case E.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,o,i){return this.P(o)?.get(n,i)}getBoolean(n,o,i){return this.P(o)?.getBoolean(n,i)}getNumber(n,o,i){return this.P(o)?.getNumber(n,i)}getObject(n,o,i){return this.P(o)?.getObject(n,i)}storeAll(n,o){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,o)})}store(n,o,i,t,s=!1){if((0,L.$og)(o)){this.remove(n,i,s);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,o,s)})}remove(n,o,i=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const i=[],t=this.J(n);for(const s of Object.keys(t))t[s]===o&&i.push(s);return i}z(n,o,i,t=!1){const s=this.J(o);typeof i=="number"?s[n]!==i&&(s[n]=i,this.P(o)?.set(e.$bq,JSON.stringify(s),t)):typeof s[n]=="number"&&(delete s[n],this.P(o)?.set(e.$bq,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(E.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(E.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(E.APPLICATION)),this.H}J(n){switch(n){case E.APPLICATION:return this.I;case E.PROFILE:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?k(o):Object.create(null)}isNew(n){return this.getBoolean(e.$aq,n)===!0}async flush(n=I.NONE){this.f.fire({reason:n});const o=this.P(E.APPLICATION),i=this.P(E.PROFILE),t=this.P(E.WORKSPACE);switch(n){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(E.APPLICATION)?.items??new Map,o=this.P(E.PROFILE)?.items??new Map,i=this.P(E.WORKSPACE)?.items??new Map;return d(n,o,i,this.Q(E.APPLICATION)??"",this.Q(E.PROFILE)??"",this.Q(E.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(I.NONE),(0,l.$Kl)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||c(o)&&c(n))}N(n,o,i){this.y(()=>{const t=new Set;for(const[s,f]of n)t.add(s),o.get(s)!==f&&this.u(i,{key:s,external:!0});for(const[s]of o.items)t.has(s)||this.u(i,{key:s,external:!0})})}}e.$eq=b;function c(m){return m.isDefault||!!m.useDefaultFlags?.globalState}class g extends b{constructor(){super(),this.U=this.B(new O.$$p(new O.$_p,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$$p(new O.$_p,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$$p(new O.$_p,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(E.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(E.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(E.APPLICATION,n)))}P(n){switch(n){case E.APPLICATION:return this.U;case E.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case E.APPLICATION:return"inMemory (application)";case E.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$gq=g;async function d(m,n,o,i,t,s){const f=v=>{try{return JSON.parse(v)}catch{return v}},a=new Map,w=new Map;m.forEach((v,N)=>{a.set(N,v),w.set(N,f(v))});const y=new Map,S=new Map;n.forEach((v,N)=>{y.set(N,v),S.set(N,f(v))});const D=new Map,P=new Map;o.forEach((v,N)=>{D.set(N,v),P.set(N,f(v))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const C=[];if(a.forEach((v,N)=>{C.push({key:N,value:v})}),console.table(C),console.groupEnd(),console.log(w),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const v=[];y.forEach((N,T)=>{v.push({key:T,value:N})}),console.table(v),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${s})`);const p=[];D.forEach((v,N)=>{p.push({key:N,value:v})}),console.table(p),console.groupEnd(),console.log(P)}}),define(Ee[119],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class r{static{this.a=!1}constructor(A){this.d=A,this.b=new Map,this.c=1}add(A){const R=this.c++;return this.b.set(R,A),this.e(),R}get(A,R){return this.b.has(A)?this.b.get(A)[R]:void 0}delete(A){this.b.delete(A),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$ync=r}),define(Ee[63],Se([1,0,15,23,28,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Dnc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new h.$8g($=>{const l=this.b.get($.scheme);return!(l===void 0||l&A.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,l){l===null?this.b.delete($.scheme):this.b.set($.scheme,l)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Dnc=L,e.$Enc=(0,R.$Fi)("IExtHostFileSystemInfo")}),define(Ee[30],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0,e.$aQ=(0,r.$Fi)("IExtHostInitDataService")}),define(Ee[297],Se([1,0,237,12,278,30]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0;let L=class extends A.$kR{constructor($,l,I){const E=I.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=I.remote.isRemote?(0,r.localize)(0,null):$?(0,r.localize)(1,null):(0,r.localize)(2,null);super(l.createLogger(E,{name:u}))}};e.$Lpc=L,e.$Lpc=L=Je([Ve(1,h.$ak),Ve(2,R.$aQ)],L)}),define(Ee[298],Se([1,0,9]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=e.$joc=void 0;class h{constructor(L,O,$){this.h=new Map,this.a=L,this.b=O,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(l=>(this.f=l,this)),this.g=this.c.onDidChangeStorage(l=>{l.shared===this.b&&l.key===this.a&&(this.f=l.value)}),this.i=new r.$Rh(()=>{const l=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of l.values())I.complete()}catch(I){for(const E of l.values())E.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,O){let $=this.f[L];return typeof $>"u"&&($=O),$}update(L,O){this.f[L]=O;const $=this.h.get(L);if($!==void 0)return $.p;const l=new r.$3h;return this.h.set(L,l),this.i.isScheduled()||this.i.schedule(),l.p}dispose(){this.g.dispose()}}e.$joc=h;class A extends h{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,O){super(L.identifier.value,!0,O),this.j=L}}e.$koc=A}),define(Ee[299],Se([1,0,4,2]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;class A{constructor(L){this.c=L,this.a=new r.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,O,$,l){const E=this.c.getNotebookDocument(h.URI.revive(L)).acceptModelChanged(O.value,$,l);this.b.fire(E)}$acceptDirtyStateChanged(L,O){this.c.getNotebookDocument(h.URI.revive(L)).acceptDirty(O)}$acceptModelSaved(L){const O=this.c.getNotebookDocument(h.URI.revive(L));this.a.fire(O.apiNotebook)}}e.$dpc=A}),define(Ee[20],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=void 0,e.$WP=(0,r.$Fi)("IExtHostRpcService");class h{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$XP=h}),define(Ee[300],Se([1,0,24,4]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;class A{#e;constructor(L,O){this.b=new h.$me,this.onDidChange=this.b.event,this.a=r.$qn.toKey(L.identifier),this.#e=O,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(L){return this.#e.get(this.a,L)}store(L,O){return this.#e.store(this.a,L,O)}delete(L){return this.#e.delete(this.a,L)}}e.$toc=A}),define(Ee[73],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0,e.$Tnc=(0,r.$Fi)("IURITransformerService");class h{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Unc=h}),define(Ee[301],Se([1,0,302,412,413,67,2,12,414]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hqc=I,r=We(r),h=We(h),A=We(A),R=We(R);const l=!1;function I(n,o,i,t,s,f){const a=f.environment.useHostProxy,w=typeof a=="boolean"?a:!f.remote.isRemote,y={resolveProxy:P=>n.resolveProxy(P),lookupProxyAuthorization:g.bind(void 0,t,s,o,{},f.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>u(o),addCertificatesV2:()=>k(o),log:t,getLogLevel:()=>{const P=t.getLevel();switch(P){case O.LogLevel.Trace:return $.LogLevel.Trace;case O.LogLevel.Debug:return $.LogLevel.Debug;case O.LogLevel.Info:return $.LogLevel.Info;case O.LogLevel.Warning:return $.LogLevel.Warning;case O.LogLevel.Error:return $.LogLevel.Error;case O.LogLevel.Off:return $.LogLevel.Off;default:return C(P)}function C(p){return t.error("Unknown log level",p),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:w,loadAdditionalCertificates:async()=>{const P=[];if(f.remote.isRemote&&P.push((0,$.loadSystemCertificates)({log:t})),w){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const C=n.loadCertificates();C.then(p=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",p.length)),P.push(C)}return(await Promise.all(P)).flat()},env:process.env},S=(0,$.createProxyResolver)(y),D=E(y,S);return c(i,D)}function E(n,o){function i(t,s){return Object.assign({},t,s)}return{http:i(r,(0,$.createHttpPatch)(n,r,o)),https:i(h,(0,$.createHttpPatch)(n,h,o)),net:i(R,(0,$.createNetPatch)(n,R)),tls:i(A,(0,$.createTlsPatch)(n,A))}}function u(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}function k(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}const b=new Map;function c(n,o){return n.getExtensionPathIndex().then(i=>{const t=globalThis._VSCODE_NODE_MODULES.module,s=t._load;t._load=function(a,w,y){if(a==="net")return o.net;if(a==="tls")return o.tls;if(a!=="http"&&a!=="https")return s.apply(this,arguments);const S=i.findSubstr(L.URI.file(w.filename));let D=b.get(S);if(D||b.set(S,D={}),!D[a]){const P=o[a];D[a]={...P}}return D[a]}})}async function g(n,o,i,t,s,f,a,w){const y=t[f];a&&(t[f]=a),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${f}`,`proxyAuthenticate:${a}`,`proxyAuthenticateCache:${y}`);const S=a||y,D=Array.isArray(S)?S:typeof S=="string"?[S]:[];if(m(o,D,s),D.some(P=>/^(Negotiate|Kerberos)( |$)/i.test(P))&&!w.kerberosRequested)try{w.kerberosRequested=!0;const P=await new Promise((T,M)=>{ce(["kerberos"],T,M)}).then(We),C=new URL(f),p=i.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${C.hostname}`:`HTTP@${C.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${f}`,`spn:${p}`),"Negotiate "+await(await P.initializeClient(p)).step("")}catch(P){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",P)}}let d=!1;function m(n,o,i){d||!o.length||(d=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:i?"remote":"local"}))}}),define(Ee[303],Se([1,0,142]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=A;function h(R){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:R,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function A(R){return new r.$Jn(h(R))}});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[152],Se([1,0,247,18,2,3,5,37,28,15,55,201,44]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$bG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$4F=e.EditorInputCapabilities=e.$3F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=void 0,e.$TF=c,e.$UF=g,e.$VF=d,e.$WF=m,e.$XF=n,e.$YF=o,e.$ZF=i,e.$1F=t,e.$2F=s,e.$5F=D,e.$6F=C,e.$7F=p,e.$8F=v,e.$9F=N,e.$0F=T,e.$$F=M,e.$_F=j,e.$aG=U,e.$cG=ee,e.$dG=ne,e.$eG=De,e.$fG=$e,u=Ut(u),e.$OF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$PF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$QF="workbench.editor.sidebysideEditor",e.$RF="workbench.editors.textDiffEditor",e.$SF="workbench.editors.binaryResourceDiffEditor";var k;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var b;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function c(K){const W=K;return!!W&&typeof W.getSelection=="function"&&!!W.onDidChangeSelection}function g(K){const W=K;return!!W&&typeof W.getScrollPosition=="function"&&typeof W.setScrollPosition=="function"&&!!W.onDidChangeScroll}function d(K,W,se){for(const oe of se.visibleEditorPanes)if(oe.group.id===W&&K.matches(oe.input))return oe.getViewState()}function m(K){if(D(K))return!1;const W=K;return A.URI.isUri(W?.resource)}function n(K){if(D(K))return!1;const W=K;return W?.original!==void 0&&W.modified!==void 0}function o(K){if(D(K))return!1;const W=K;return!W||W.resources&&!Array.isArray(W.resources)?!1:!!W.resources||!!W.multiDiffSource}function i(K){if(D(K)||n(K))return!1;const W=K;return W?.primary!==void 0&&W.secondary!==void 0}function t(K){if(D(K))return!1;const W=K;return W?W.resource===void 0||W.resource.scheme===l.Schemas.untitled||W.forceUntitled===!0:!1}function s(K){if(D(K))return!1;const W=K;return A.URI.isUri(W?.base?.resource)&&A.URI.isUri(W?.input1?.resource)&&A.URI.isUri(W?.input2?.resource)&&A.URI.isUri(W?.result?.resource)}var f;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var a;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class w{constructor(){this.a=new Map}registerSource(W,se){let oe=this.a.get(W);return oe||(oe={source:W,label:se},this.a.set(W,oe)),oe.source}getSourceLabel(W){return this.a.get(W)?.label??W}}e.$3F=new w;var y;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription",K[K.CanDropIntoEditor=128]="CanDropIntoEditor",K[K.MultipleEditors=256]="MultipleEditors",K[K.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class S extends R.$Wc{}e.$4F=S;function D(K){return K instanceof S}function P(K){const W=K;return A.URI.isUri(W?.preferredResource)}function C(K){const W=K;return D(W?.primary)&&D(W?.secondary)}function p(K){const W=K;return D(W?.modified)&&D(W?.original)}function v(K,W,se,oe,te){return $e(oe,[(0,E.$pj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const le={...se,limits:{size:Number.MAX_VALUE}};K.openEditor(W,le)}}),(0,E.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>te.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function N(K){return D(K?.editor)}function T(K){const W=K;return N(K)&&W?.group!==void 0}function M(K){const W=K;return typeof W?.groupId=="number"&&D(W.editor)}function j(K){return typeof K?.groupId=="number"}var z;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var F;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LABEL=2]="GROUP_LABEL",K[K.GROUP_LOCKED=3]="GROUP_LOCKED",K[K.EDITORS_SELECTION=4]="EDITORS_SELECTION",K[K.EDITOR_OPEN=5]="EDITOR_OPEN",K[K.EDITOR_CLOSE=6]="EDITOR_CLOSE",K[K.EDITOR_MOVE=7]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=9]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=11]="EDITOR_PIN",K[K.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",K[K.EDITOR_STICKY=13]="EDITOR_STICKY",K[K.EDITOR_DIRTY=14]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var B;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class _{getOriginalUri(W,se){if(!W)return;if(s(W))return e.$bG.getOriginalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getOriginalUri(te,{filterByScheme:se.filterByScheme})??this.getOriginalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===B.PRIMARY?te:le}}if(n(W)||o(W)||i(W)||s(W))return;const oe=P(W)?W.preferredResource:W.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}a(W){return C(W)||i(W)?{primary:W.primary,secondary:W.secondary}:p(W)||n(W)?{primary:W.modified,secondary:W.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(W,se){if(!W)return;if(s(W))return e.$bG.getCanonicalUri(W.result,se);if(se?.supportSideBySide){const{primary:te,secondary:le}=this.a(W);if(te&&le){if(se?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(te,{filterByScheme:se.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:se.filterByScheme})};if(se?.supportSideBySide===B.ANY)return this.getCanonicalUri(te,{filterByScheme:se.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:se.filterByScheme});W=se.supportSideBySide===B.PRIMARY?te:le}}if(n(W)||o(W)||i(W)||s(W))return;const oe=W.resource;return!oe||!se||!se.filterByScheme?oe:this.b(oe,se.filterByScheme)}b(W,se){if(Array.isArray(se)){if(se.some(oe=>W.scheme===oe))return W}else if(se===W.scheme)return W}}var re;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.KEYBOARD=1]="KEYBOARD",K[K.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function U(K,W,se,oe){if(!K.isSticky(W))return!1;switch(oe.preventPinnedEditorClose){case"keyboardAndMouse":return se===re.MOUSE||se===re.KEYBOARD;case"mouse":return se===re.MOUSE;case"keyboard":return se===re.KEYBOARD}return!1}e.$bG=new _;var G;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(G||(e.CloseDirection=G={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(W){const se=this.a=W.get(L.$Ei);for(const[oe,te]of this.c)this.e(oe,te,se);this.c.clear()}e(W,se,oe){const te=oe.createInstance(se);this.d.set(W,te)}registerFileEditorFactory(W){if(this.b)throw new Error("Can only register one file editor factory.");this.b=W}getFileEditorFactory(){return(0,h.$qg)(this.b)}registerEditorSerializer(W,se){if(this.c.has(W)||this.d.has(W))throw new Error(`A editor serializer with type ID '${W}' was already registered.`);return this.a?this.e(W,se,this.a):this.c.set(W,se),(0,R.$Uc)(()=>{this.c.delete(W),this.d.delete(W)})}getEditorSerializer(W){return this.d.get(typeof W=="string"?W:W.typeId)}}O.$po.add(e.$OF.EditorFactory,new Q);async function ee(K,W,se){return!K||!K.length?[]:await Promise.all(K.map(async oe=>{const te=A.URI.revive(oe.fileUri);if(!te){se.info("Cannot resolve the path because it is not valid.",oe);return}if(!await W.canHandleResource(te)){se.info("Cannot resolve the path because it cannot be handled",oe);return}let he=oe.exists,X=oe.type;if(typeof he!="boolean"||typeof X!="number")try{X=(await W.stat(te)).isDirectory?$.FileType.Directory:$.FileType.Unknown,he=!0}catch(pe){se.error(pe),he=!1}if(!he&&oe.openOnlyIfExists){se.info("Cannot resolve the path because it does not exist",oe);return}if(X===$.FileType.Directory){se.info("Cannot resolve the path because it is a directory",oe);return}const ae={...oe.options,pinned:!0};return he?{resource:te,options:ae}:{resource:te,options:ae,forceUntitled:!0}}))}var ue;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function ne(K){const W=K;if(!W)return!1;const se=W;if(se.modified)return ne(se.modified);const oe=W;return!!(oe.contributionsState&&oe.viewState&&Array.isArray(oe.cursorState))}function De(K){return(0,I.$rj)(K)}function $e(K,W,se){const oe=(0,I.$sj)(K,W);return oe.forceMessage=se?.forceMessage,oe.forceSeverity=se?.forceSeverity,oe.allowDialog=se?.allowDialog,oe}}),define(Ee[304],Se([1,0,4,248,5,3,29,37,25,83,293]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$lG=e.ViewContentGroups=e.$jG=e.ViewContainerLocation=e.Extensions=e.$iG=e.$hG=e.$gG=void 0,e.$kG=k,e.$gG="views",e.$hG=(0,h.localize)(0,null),e.$iG=(0,I.$ux)("default-view-icon",l.$5j.window,(0,h.localize)(1,null));var E;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(E||(e.Extensions=E={}));var u;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$jG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function k(t){switch(t){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class b extends R.$Wc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onDidRegister=this.c.event,this.f=this.B(new r.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(s,f,a){const w=this.get(s.id);if(w)return w;const y=s;return y.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,L.$zc)(this.g,f,[]).push(y),a?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:f}),y}deregisterViewContainer(s){for(const f of this.g.keys()){const a=this.g.get(f),w=a?.indexOf(s);if(w!==-1){a?.splice(w,1),a.length===0&&this.g.delete(f),this.f.fire({viewContainer:s,viewContainerLocation:f});return}}}get(s){return this.all.filter(f=>f.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(a=>a?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(f=>this.getViewContainerLocation(f)===s)}}O.$po.add(E.ViewContainersRegistry,new b);var c;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(c||(e.ViewContentGroups=c={}));function g(t,s){const f=t.group??c.More,a=s.group??c.More;return f!==a?f.localeCompare(a):(t.order??5)-(s.order??5)}class d extends R.$Wc{constructor(){super(...arguments),this.c=this.B(new r.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Jc}registerViews(s,f){this.registerViews2([{views:s,viewContainer:f}])}registerViews2(s){s.forEach(({views:f,viewContainer:a})=>this.r(f,a)),this.c.fire(s)}deregisterViews(s,f){const a=this.s(s,f);a.length&&this.f.fire({views:a,viewContainer:f})}moveViews(s,f){for(const a of this.m.keys())if(a!==f){const w=this.s(s,a);w.length&&(this.r(w,f),this.g.fire({views:w,from:a,to:f}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const f of this.j){const a=(this.m.get(f)||[]).filter(w=>w.id===s)[0];if(a)return a}return null}getViewContainer(s){for(const f of this.j)if((this.m.get(f)||[]).filter(w=>w.id===s)[0])return f;return null}registerViewWelcomeContent(s,f){return this.n.add(s,f),this.h.fire(s),(0,R.$Uc)(()=>{this.n.delete(s,f),this.h.fire(s)})}registerViewWelcomeContent2(s,f){const a=new Map;for(const[w,y]of f)this.n.add(s,y),a.set(w,(0,R.$Uc)(()=>{this.n.delete(s,y),this.h.fire(s)}));return this.h.fire(s),a}getViewWelcomeContent(s){const f=[];return this.n.forEach(s,a=>f.push(a)),f.sort(g)}r(s,f){let a=this.m.get(f);a||(a=[],this.m.set(f,a),this.j.push(f));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,h.localize)(2,null,w.id));a.push(w)}}s(s,f){const a=this.m.get(f);if(!a)return[];const w=[],y=[];for(const S of a)s.includes(S)?w.push(S):y.push(S);return w.length&&(y.length?this.m.set(f,y):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),w}}O.$po.add(E.ViewsRegistry,new d),e.$lG=(0,A.$Fi)("viewDescriptorService");var m;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(m||(e.ViewVisibilityState=m={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class o{constructor(s,f){this.c=!1,this.d=!1,(0,$.$fo)(this,s),this.d=!!f,this.resolve=async a=>{if(f&&!this.c){const w=await f(a);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$mG=o;class i extends Error{constructor(s){super((0,h.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$nG=i}),define(Ee[305],Se([1,0,249,36]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=void 0,e.$rG=new h.$Wj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$sG=new h.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$tG=new h.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$uG=new h.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$vG=new h.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$wG=new h.$Wj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$xG=new h.$Wj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$yG=new h.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$zG=new h.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$AG=new h.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$BG=new h.$Wj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$CG=new h.$Wj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$DG=new h.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$EG=new h.$Wj("chatCursorAtTop",!1),e.$FG=new h.$Wj("chatInputHasAgent",!1),e.$GG=new h.$Wj("chatLocation",void 0),e.$HG=new h.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(Ee[306],Se([1,0,132,9,21,4,40,3,57,180,13,36,24,5,12,116,286,151,305]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.ChatAgentLocation=void 0,e.$MH=f,e.$NH=a;var o;(function(w){w.Panel="panel",w.Terminal="terminal",w.Notebook="notebook",w.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(w){function y(S){switch(S){case"panel":return w.Panel;case"terminal":return w.Terminal;case"notebook":return w.Notebook;case"editor":return w.Editor}return w.Panel}w.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.$HH=(0,k.$Fi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(y){this.f=y,this.b=new Map,this.d=new R.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=m.$DG.bindTo(this.f)}registerAgent(y,S){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const P=this,C=S.slashCommands;S={...S,get slashCommands(){return C.filter(v=>!v.when||P.f.contextMatchesRules(E.$Dj.deserialize(v.when)))}};const p={data:S};return this.b.set(y,p),(0,O.$Uc)(()=>{this.b.delete(y),this.d.fire(void 0)})}registerAgentImplementation(y,S){const D=this.b.get(y);if(!D)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(D.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return D.data.isDefault&&this.e.set(!0),D.impl=S,this.d.fire(new t(D.data,S)),(0,O.$Uc)(()=>{D.impl=void 0,this.d.fire(void 0),D.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,S){y.isDynamic=!0;const D={data:y,impl:S};return this.b.set(y.id,D),this.d.fire(new t(y,S)),(0,O.$Uc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,S){return this.g.set(y,S),{dispose:()=>{this.g.delete(y)}}}async getAgentCompletionItems(y,S,D){return await this.g.get(y)?.(S,D)??[]}updateAgent(y,S){const D=this.b.get(y);if(!D?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);D.data.metadata={...D.data.metadata,...S},this.d.fire(new t(D.data,D.impl))}getDefaultAgent(y){return(0,r.$hb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(y))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.h(y))return this.b.get(y)?.data}h(y){const S=this.b.get(y);return!S?.data.when||this.f.contextMatchesRules(E.$Dj.deserialize(S.data.when))}getAgentByFullyQualifiedId(y){const S=L.Iterable.find(this.b.values(),D=>f(D.data)===y)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.h(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.h(y.data.id)).map(y=>new t(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(S=>S.name===y)}agentHasDupeName(y){const S=this.getAgent(y);return S?this.getAgentsByName(S.name).filter(D=>D.extensionId.value!==S.extensionId.value).length>0:!1}async invokeAgent(y,S,D,P,C){const p=this.b.get(y);if(!p?.impl)throw new Error(`No activated agent with id "${y}"`);return await p.impl.invoke(S,D,P,C)}async getFollowups(y,S,D,P,C){const p=this.b.get(y);if(!p?.impl)throw new Error(`No activated agent with id "${y}"`);return p.impl?.provideFollowups?p.impl.provideFollowups(S,D,P,C):[]}};e.$IH=i,e.$IH=i=Je([Ve(0,E.$Xj)],i);class t{constructor(y,S){this.b=y,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,S,D,P){return this.d.invoke(y,S,D,P)}async provideFollowups(y,S,D,P){return this.d.provideFollowups?this.d.provideFollowups(y,S,D,P):[]}provideWelcomeMessage(y,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,S)}provideSampleQuestions(y,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,S)}}e.$JH=t,e.$KH=(0,k.$Fi)("chatAgentNameService");let s=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(y,S,D,P){if(this.g=S,this.h=D,this.i=P,this.e=(0,l.$7d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const C=P.get(n.b,d.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{P.remove(n.b,d.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,h.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},A.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,g.$8p)(y);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const D=S.restrictedChatParticipants;this.e.set(D,void 0),this.i.store(n.b,JSON.stringify(D),d.StorageScope.APPLICATION,d.StorageTarget.MACHINE)}getAgentNameRestriction(y){const S=this.l(y.name,y).get(),D=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return S&&D}l(y,S){return this.e.map(P=>P[y.toLowerCase()]).map(P=>P?P.some(C=>(0,I.$Gf)(C,C.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$LH=s,e.$LH=s=n=Je([Ve(0,c.$sk),Ve(1,g.$2p),Ve(2,b.$_j),Ve(3,d.$cq)],s);function f(w){return`${w.extensionId.value}.${w.id}`}function a(w){const y="name"in w?w:{...w,name:w.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new u.$qn("")),(0,$.$ci)(y)}}),define(Ee[307],Se([1,0,2,31,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gH=e.$fH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$dH=R,e.$eH=L;function R(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof r.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(h.$It.isIRange)}function L(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(R)}var O;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(O||(e.ChatAgentVoteDirection=O={}));var $;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$fH=(0,A.$Fi)("IChatService"),e.$gH="accessibility.voice.keywordActivation"}),define(Ee[153],Se([1,0,4,9,251]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_sb=void 0;class R{constructor(){this.f=new Map,this.m=[],this.n=new r.$me,this.o=new r.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(O){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=O}onEvent(O){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=O}onRequest(O){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=O}sendResponse(O){O.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${O.command}`)):this.u("response",O)}sendRequest(O,$,l,I){const E={command:O};if($&&Object.keys($).length>0&&(E.arguments=$),this.u("request",E),typeof I=="number"){const u=setTimeout(()=>{clearTimeout(u);const k=this.f.get(E.seq);if(k){this.f.delete(E.seq);const b={type:"response",seq:0,request_seq:E.seq,success:!1,command:O,message:(0,A.localize)(0,null,I,O)};k(b)}},I)}return l&&this.f.set(E.seq,l),E.seq}acceptMessage(O){this.k?this.k(O):(this.m.push(O),this.m.length===1&&this.s())}q(O,$){return O.type!=="event"||$.type!=="event"}async s(){let O;for(;this.m.length;){if((!O||this.q(this.m[0],O))&&await(0,h.$Gh)(0),O=this.m.shift(),!O)return;switch(O.type){case"event":this.j?.(O);break;case"request":this.g?.(O);break;case"response":{const $=O,l=this.f.get($.request_seq);l&&(this.f.delete($.request_seq),l($));break}}}}u(O,$){$.type=O,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const O=new Map;this.f.forEach(($,l)=>O.set(l,$)),await(0,h.$Gh)(500),O.forEach(($,l)=>{$({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.f.delete(l)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$_sb=R}),define(Ee[120],Se([1,0,2,252,36,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$yK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$wK=e.MemoryRangeType=e.State=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=void 0,e.$vK=$,e.$xK=I,h=We(h),e.$jJ="workbench.view.debug",e.$kJ="workbench.debug.variablesView",e.$lJ="workbench.debug.watchExpressionsView",e.$mJ="workbench.debug.callStackView",e.$nJ="workbench.debug.loadedScriptsView",e.$oJ="workbench.debug.breakPointsView",e.$pJ="workbench.debug.disassemblyView",e.$qJ="workbench.panel.repl",e.$rJ="workbench.panel.repl.view",e.$sJ=new A.$Wj("debugType",void 0,{type:"string",description:h.localize(0,null)}),e.$tJ=new A.$Wj("debugConfigurationType",void 0,{type:"string",description:h.localize(1,null)}),e.$uJ=new A.$Wj("debugState","inactive",{type:"string",description:h.localize(2,null)}),e.$vJ="debugUx",e.$wJ=new A.$Wj(e.$vJ,"default",{type:"string",description:h.localize(3,null)}),e.$xJ=new A.$Wj("hasDebugged",!1,{type:"boolean",description:h.localize(4,null)}),e.$yJ=new A.$Wj("inDebugMode",!1,{type:"boolean",description:h.localize(5,null)}),e.$zJ=new A.$Wj("inDebugRepl",!1,{type:"boolean",description:h.localize(6,null)}),e.$AJ=new A.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:h.localize(7,null)}),e.$BJ=new A.$Wj("inBreakpointWidget",!1,{type:"boolean",description:h.localize(8,null)}),e.$CJ=new A.$Wj("breakpointsFocused",!0,{type:"boolean",description:h.localize(9,null)}),e.$DJ=new A.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:h.localize(10,null)}),e.$EJ=new A.$Wj("watchExpressionsExist",!1,{type:"boolean",description:h.localize(11,null)}),e.$FJ=new A.$Wj("variablesFocused",!0,{type:"boolean",description:h.localize(12,null)}),e.$GJ=new A.$Wj("expressionSelected",!1,{type:"boolean",description:h.localize(13,null)}),e.$HJ=new A.$Wj("breakpointInputFocused",!1,{type:"boolean",description:h.localize(14,null)}),e.$IJ=new A.$Wj("callStackItemType",void 0,{type:"string",description:h.localize(15,null)}),e.$JJ=new A.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:h.localize(16,null)}),e.$KJ=new A.$Wj("callStackItemStopped",!1,{type:"boolean",description:h.localize(17,null)}),e.$LJ=new A.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:h.localize(18,null)}),e.$MJ=new A.$Wj("watchItemType",void 0,{type:"string",description:h.localize(19,null)}),e.$NJ=new A.$Wj("canViewMemory",void 0,{type:"boolean",description:h.localize(20,null)}),e.$OJ=new A.$Wj("breakpointItemType",void 0,{type:"string",description:h.localize(21,null)}),e.$PJ=new A.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:h.localize(22,null)}),e.$QJ=new A.$Wj("breakpointHasModes",!1,{type:"boolean",description:h.localize(23,null)}),e.$RJ=new A.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:h.localize(24,null)}),e.$SJ=new A.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:h.localize(25,null)}),e.$TJ=new A.$Wj("loadedScriptsItemType",void 0,{type:"string",description:h.localize(26,null)}),e.$UJ=new A.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:h.localize(27,null)}),e.$VJ=new A.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:h.localize(28,null)}),e.$WJ=new A.$Wj("stepBackSupported",!1,{type:"boolean",description:h.localize(29,null)}),e.$XJ=new A.$Wj("restartFrameSupported",!1,{type:"boolean",description:h.localize(30,null)}),e.$YJ=new A.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:h.localize(31,null)}),e.$ZJ=new A.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:h.localize(32,null)}),e.$1J=new A.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:h.localize(33,null)}),e.$2J=new A.$Wj("breakpointsExist",!1,{type:"boolean",description:h.localize(34,null)}),e.$3J=new A.$Wj("debuggersAvailable",!1,{type:"boolean",description:h.localize(35,null)}),e.$4J=new A.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:h.localize(36,null)}),e.$5J=new A.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:h.localize(37,null)}),e.$6J=new A.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:h.localize(38,null)}),e.$7J=new A.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:h.localize(39,null)}),e.$8J=new A.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:h.localize(40,null)}),e.$9J=new A.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:h.localize(41,null)}),e.$0J=new A.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:h.localize(42,null)}),e.$$J=new A.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:h.localize(43,null)}),e.$_J=new A.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:h.localize(44,null)}),e.$aK=new A.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:h.localize(45,null)}),e.$bK=new A.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:h.localize(46,null)}),e.$cK=new A.$Wj("variableIsReadonly",!1,{type:"boolean",description:h.localize(47,null)}),e.$dK=new A.$Wj("variableValue",!1,{type:"string",description:h.localize(48,null)}),e.$eK=new A.$Wj("variableType",!1,{type:"string",description:h.localize(49,null)}),e.$fK=new A.$Wj("variableInterfaces",!1,{type:"array",description:h.localize(50,null)}),e.$gK=new A.$Wj("variableName",!1,{type:"string",description:h.localize(51,null)}),e.$hK=new A.$Wj("variableLanguage",!1,{type:"string",description:h.localize(52,null)}),e.$iK=new A.$Wj("variableExtensionId",!1,{type:"string",description:h.localize(53,null)}),e.$jK=new A.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:h.localize(54,null)}),e.$kK=new A.$Wj("multiSessionRepl",!1,{type:"boolean",description:h.localize(55,null)}),e.$lK=new A.$Wj("multiSessionDebug",!1,{type:"boolean",description:h.localize(56,null)}),e.$mK=new A.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:h.localize(57,null)}),e.$nK=new A.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:h.localize(58,null)}),e.$oK=new A.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:h.localize(59,null)}),e.$pK=new A.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:h.localize(60,null)});const L=n=>h.localize(61,null,n);e.$qK=L,e.$rK="editor.contrib.debug",e.$sK="editor.contrib.breakpoint",e.$tK="debug",e.$uK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:h.localize(62,null)};var O;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(O||(e.State=O={}));function $(n){switch(n){case O.Initializing:return"initializing";case O.Stopped:return"stopped";case O.Running:return"running";default:return"inactive"}}var l;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.$wK="vscode-debug-memory";function I(n){const o=n.presentationHint??n.source.presentationHint;return o==="deemphasize"||o==="subtle"}var E;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(E||(e.DataBreakpointSetType=E={}));var u;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var k;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$yK=(0,R.$Fi)("debugService");var b;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(b||(e.BreakpointWidgetContext=b={}));var c;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(c||(e.DebugVisualizationType=c={}));var g;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(g||(e.DebugTreeItemCollapsibleState=g={}));var d;(function(n){n.deserialize=o=>o,n.serialize=o=>o})(d||(e.IDebugVisualizationTreeItem=d={}));var m;(function(n){n.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),n.serialize=o=>o})(m||(e.IDebugVisualization=m={}))}),define(Ee[308],Se([1,0,13,2,16,25,15,31,21,19]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3H=void 0,e.$QH=E,e.$RH=u,e.$SH=k,e.$TH=b,e.$UH=c,e.$VH=g,e.$WH=d,e.$XH=n,e.$YH=t,e.$ZH=s,e.$1H=a,e.$2H=y;const I=/{([^}]+)}/g;function E(D,P,C){return D.replace(I,function(p,v){return P&&v.length>0&&v[0]!=="_"?p:C&&C.hasOwnProperty(v)?C[v]:p})}function u(D){const P={};for(const C of Object.keys(D))C.startsWith("!")||(P[C]=D[C]);return P}function k(D){return D.configuration.request==="attach"&&!b(D)&&(!D.parentSession||k(D.parentSession))}function b(D){let P=D.configuration.type;if(P)return P==="vslsShare"&&(P=D.configuration.adapterProxy.configuration.type),(0,r.$Gf)(P,"extensionhost")||(0,r.$Gf)(P,"pwa-extensionhost")?D:D.parentSession?b(D.parentSession):void 0}function c(D){return D.type&&(D.label||D.program||D.runtime)}function g(D,P,C){let p,v=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let T=null;for(;T=N.exec(D);){const M=T.index+1,j=M+T[0].length;if(M<=P&&j>=C){p=T[0],v=M;break}}if(p){const M=/\w+/g;let j=null;for(;(j=M.exec(p))&&!(j.index+1+v+j[0].length>=C););j&&(p=p.substring(0,M.lastIndex))}return p?{start:v,end:v+p.length-1}:{start:0,end:0}}async function d(D,P,C,p){if(D.evaluatableExpressionProvider.has(P)){const v=D.evaluatableExpressionProvider.ordered(P),N=(0,l.$Jb)(await Promise.all(v.map(async T=>{try{return await T.provideEvaluatableExpression(P,C,p??$.CancellationToken.None)}catch{return}})));if(N.length>0){let T=N[0].expression;const M=N[0].range;return T||(T=P.getLineContent(C.lineNumber).substring(M.startColumn-1,M.endColumn-1)),{range:M,matchingExpression:T}}}else{const v=P.getLineContent(C.lineNumber),{start:N,end:T}=g(v,C.column,C.column),M=v.substring(N-1,T);return{matchingExpression:M,range:new O.$It(C.lineNumber,N,C.lineNumber,N+M.length)}}return null}const m=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(m))}function o(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return h.URI.parse(D.path);if((0,A.$kc)(D.path))return h.URI.file(D.path)}return D.path}function i(D){if(typeof D.path=="object"){const P=h.URI.revive(D.path);if(P)return P.scheme===L.Schemas.file?P.fsPath:P.toString()}return D.path}function t(D,P){const C=P?o:i,p=(0,R.$co)(D);return f(p,(v,N)=>{v&&N&&(N.path=C(N))}),p}function s(D,P){const C=P?o:i,p=(0,R.$co)(D);return f(p,(v,N)=>{!v&&N&&(N.path=C(N))}),p}function f(D,P){switch(D.type){case"event":{const C=D;switch(C.event){case"output":P(!1,C.body.source);break;case"loadedSource":P(!1,C.body.source);break;case"breakpoint":P(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=D;switch(C.command){case"setBreakpoints":P(!0,C.arguments.source);break;case"breakpointLocations":P(!0,C.arguments.source);break;case"source":P(!0,C.arguments.source);break;case"gotoTargets":P(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(p=>P(!1,p));break;default:break}break}case"response":{const C=D;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(p=>P(!1,p.source));break;case"loadedSources":C.body.sources.forEach(p=>P(!1,p));break;case"scopes":C.body.scopes.forEach(p=>P(!1,p.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(p=>P(!1,p.source));break;case"setBreakpoints":C.body.breakpoints.forEach(p=>P(!1,p.source));break;case"disassemble":C.body?.instructions.forEach(v=>P(!1,v.location));break;default:break}break}}}function a(D){return D.filter(P=>!P.presentation?.hidden).sort((P,C)=>P.presentation?C.presentation?P.presentation.group?C.presentation.group?P.presentation.group!==C.presentation.group?P.presentation.group.localeCompare(C.presentation.group):w(P.presentation.order,C.presentation.order):-1:C.presentation.group?1:w(P.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function w(D,P){return typeof D!="number"?typeof P!="number"?0:1:typeof P!="number"?-1:D-P}async function y(D,P){const C=D.getValue("debug.saveBeforeStart",{overrideIdentifier:P.activeTextEditorLanguageId});if(C!=="none"&&(await P.saveAll(),C==="allEditorsInActiveGroup")){const p=P.activeEditorPane;p&&p.input.resource?.scheme===L.Schemas.untitled&&await P.save({editor:p.input,groupId:p.group.id})}await D.reloadConfiguration()}const S=(D,P)=>!D||!P?D===P:D.name===P.name&&D.path===P.path&&D.sourceReference===P.sourceReference;e.$3H=S}),define(Ee[309],Se([1,0,58,67,25,16,11,13,34,253,153]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpc=e.$Upc=e.$Tpc=e.$Spc=e.$Rpc=void 0,r=We(r),h=We(h),A=We(A),R=We(R),L=We(L),O=We(O),l=We(l);class E extends I.$_sb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(d,m){this.l=m,this.p=Buffer.allocUnsafe(0),this.r=-1,d.on("data",n=>this.v(n))}sendMessage(d){if(this.l){const m=JSON.stringify(d);this.l.write(`Content-Length: ${Buffer.byteLength(m,"utf8")}${E.a}${m}`,"utf8")}}v(d){for(this.p=Buffer.concat([this.p,d]);;){if(this.r>=0){if(this.p.length>=this.r){const m=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,m.length>0)try{this.acceptMessage(JSON.parse(m))}catch(n){this.n.fire(new Error((n.message||n)+`
`+m))}continue}}else{const m=this.p.indexOf(E.a);if(m!==-1){const o=this.p.toString("utf8",0,m).split(E.b);for(const i of o){const t=i.split(E.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(m+E.a.length);continue}}break}}}e.$Rpc=E;class u extends E{startSession(){return new Promise((d,m)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),d(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):m(new Error("connection closed"))}),this.x.on("error",o=>{n?this.n.fire(o):m(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$Spc=u;class k extends u{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.$Tpc=k;class b extends u{constructor(d){super(),this.z=d}y(d){return h.createConnection(this.z.path,d)}}e.$Upc=b;class c extends E{constructor(d,m){super(),this.y=d,this.z=m}async startSession(){const d=this.y.command,m=this.y.args,n=this.y.options||{};try{if(d)if(R.$kc(d)){if(!await $.Promises.exists(d))throw new Error(l.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(l.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=A.$fo(A.$co(process.env),n.env)),d==="node")if(Array.isArray(m)&&m.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const s=r.fork(m[0],m.slice(1),t);if(!s.pid)throw new Error(l.localize(2,null,m[0]));this.x=s}else throw new Error(l.localize(3,null));else{const i={env:o};n.cwd&&(i.cwd=n.cwd),this.x=r.spawn(d,m,i)}this.x.on("error",i=>{this.n.fire(i)}),this.x.on("exit",(i,t)=>{this.o.fire(i)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",i=>{this.n.fire(i)}),this.x.stdin.on("error",i=>{this.n.fire(i)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),L.$i?new Promise((d,m)=>{const n=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,i,t){if(o)return m(o)});n.on("exit",d),n.on("error",m)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,m){if(!d)return;const n=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?n.runtime=R.$lc(m,d.runtime):n.runtime=d.runtime),d.runtimeArgs&&(n.runtimeArgs=d.runtimeArgs),d.program&&(R.$kc(d.program)?n.program=d.program:n.program=R.$lc(m,d.program)),d.args&&(n.args=d.args);const o=d;return o.win&&(n.win=c.A(o.win,m)),o.winx86&&(n.winx86=c.A(o.winx86,m)),o.windows&&(n.windows=c.A(o.windows,m)),o.osx&&(n.osx=c.A(o.osx,m)),o.linux&&(n.linux=c.A(o.linux,m)),n}static platformAdapterExecutable(d,m){let n=Object.create(null);m=m.toLowerCase();for(const a of d)if(a.contributes){const w=a.contributes.debuggers;w&&w.length>0&&w.filter(y=>typeof y.type=="string"&&O.$Gf(y.type,m)).forEach(y=>{const S=c.A(y,a.extensionLocation.fsPath);n=A.$fo(n,S,a.isBuiltin)})}let o;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:L.$i?o=n.win||n.windows:L.$j?o=n.osx:L.$k&&(o=n.linux),o=o||n;const i=o.program||n.program,t=o.args||n.args,s=o.runtime||n.runtime,f=o.runtimeArgs||n.runtimeArgs;if(s)return{type:"executable",command:s,args:(f||[]).concat(typeof i=="string"?[i]:[]).concat(t||[])};if(i)return{type:"executable",command:i,args:t||[]}}}e.$Vpc=c}),define(Ee[310],Se([1,0,58,33,11]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=L,e.$Xpc=$,r=We(r),A=We(A);function R(l,I){return new Promise((E,u)=>{let k="";const b=r.spawn(l,I);b.pid&&b.stdout.on("data",c=>{k+=c.toString()}),b.on("error",c=>{u(c)}),b.on("close",c=>{E(k)})})}async function L(l){if(l)if(A.$i){const I=await new Promise((E,u)=>{ce(["@vscode/windows-process-tree"],E,u)}).then(We);return new Promise(E=>{I.getProcessTree(l,u=>{E(!!u&&u.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(l)]).then(I=>{const E=I.trim();return!(E.length===0||E.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var O;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(O||(O={}));function $(l,I,E,u,k){l=l.trim().toLowerCase();let b;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?b=O.powershell:l.indexOf("cmd.exe")>=0?b=O.cmd:l.indexOf("bash")>=0?b=O.bash:A.$i?b=O.cmd:b=O.bash;let c,g=" ";switch(b){case O.powershell:if(c=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),u){const d=(0,h.$Kg)(u);d&&(g+=`${d}:; `),g+=`cd ${c(u)}; `}if(k)for(const d in k){const m=k[d];m===null?g+=`Remove-Item env:${d}; `:g+=`\${env:${d}}='${m}'; `}if(I.length>0){const d=I.shift(),m=E?d:c(d);g+=m[0]==="'"?`& ${m} `:`${m} `;for(const n of I)g+=n==="<"||n===">"||E?n:c(n),g+=" "}break;case O.cmd:if(c=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(m=>d.includes(m))||d.length===0?`"${d}"`:d),u){const d=(0,h.$Kg)(u);d&&(g+=`${d}: && `),g+=`cd ${c(u)} && `}if(k){g+='cmd /C "';for(const d in k){let m=k[d];m===null?g+=`set "${d}=" && `:(m=m.replace(/[&^|<>]/g,n=>`^${n}`),g+=`set "${d}=${m}" && `)}}for(const d of I)g+=d==="<"||d===">"||E?d:c(d),g+=" ";k&&(g+='"');break;case O.bash:{c=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m);const d=m=>/[^\w@%\/+=,.:^-]/.test(m)?`'${m.replace(/'/g,"'\\''")}'`:m;if(u&&(g+=`cd ${c(u)} ; `),k){g+="/usr/bin/env";for(const m in k){const n=k[m];n===null?g+=` -u ${d(m)}`:g+=` ${d(`${m}=${n}`)}`}g+=" "}for(const m of I)g+=m==="<"||m===">"||E?m:c(m),g+=" ";break}}return g}}),define(Ee[311],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QK=e.CellExecutionUpdateType=void 0;var h;(function(A){A[A.Output=1]="Output",A[A.OutputItems=2]="OutputItems",A[A.ExecutionState=3]="ExecutionState"})(h||(e.CellExecutionUpdateType=h={})),e.$QK=(0,r.$Fi)("INotebookExecutionService")}),define(Ee[312],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.$TK=e.ProxyKernelState=e.$SK=void 0,e.$SK=100;var h;(function(A){A[A.Disconnected=1]="Disconnected",A[A.Connected=2]="Connected",A[A.Initializing=3]="Initializing"})(h||(e.ProxyKernelState=h={})),e.$TK=(0,r.$Fi)("INotebookKernelService"),e.$UK=(0,r.$Fi)("INotebookKernelHistoryService")}),define(Ee[313],Se([1,0,3,31,54,214,107]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VYb=void 0;class O extends r.$Wc{constructor(l,I,E){super(),this._source=l,this.b=I,this.c=E,this.a=void 0}f(l){const I=l.getLineCount();return new h.$It(1,1,I,this.g(l,I))}g(l,I){if(I<1||I>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const l=new R.$jD;l.acceptChunk(this._source);const I=l.finish(!0),{textBuffer:E,disposable:u}=I.create(A.DefaultEndOfLine.LF);this.b=E,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(l=>{const I=new R.$jD;I.acceptChunk(l);const E=I.finish(!0),{textBuffer:u,disposable:k}=E.create(A.DefaultEndOfLine.LF);return this.B(k),u})),this.a}findInInputs(l){const E=new L.$0C(l,!1,!1,null).parseSearchRequest();if(!E)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,E,!0,5e3)}findInOutputs(l){const E=new L.$0C(l,!1,!1,null).parseSearchRequest();return E?this.outputTextBuffers.map(u=>{const k=u.findMatchesLineByLine(this.f(u),E,!0,5e3);if(k.length!==0)return{textBuffer:u,matches:k}}).filter(u=>!!u):[]}}e.$VYb=O}),define(Ee[74],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(R){R.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var h;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(h||(e.TestPosition=h={}));class A{static fromExtHostTestItem(L,O,$=L.parent){if(L._isRoot)return new A([O]);const l=[L.id];for(let I=$;I&&I.id!==O;I=I.parent)l.push(I.id);return l.push(O),new A(l.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const O=L.indexOf(r.Delimiter);return O===-1?L:L.slice(0,O)}static fromString(L){return new A(L.split(r.Delimiter))}static join(L,O){return new A([...L.path,O])}static joinToString(L,O){return L.toString()+r.Delimiter+O}static parentId(L){const O=L.lastIndexOf(r.Delimiter);return O===-1?void 0:L.slice(0,O)}static localId(L){const O=L.lastIndexOf(r.Delimiter);return O===-1?L:L.slice(O+r.Delimiter.length)}static isChild(L,O){return O.startsWith(L)&&O[L.length]===r.Delimiter}static compare(L,O){return L===O?h.IsSame:A.isChild(L,O)?h.IsChild:A.isChild(O,L)?h.IsParent:h.Disconnected}static getLengthOfCommonPrefix(L,O){if(L===0)return 0;let $=0;for(;$<L-1;){for(let l=1;l<L;l++){const I=O(l-1),E=O(l);if(I.path[$]!==E.path[$])return $}$++}return $}constructor(L,O=L.length){if(this.path=L,this.d=O,L.length===0||O<1)throw new Error("cannot create test with empty path")}get rootId(){return new A(this.path,1)}get parentId(){return this.d>1?new A(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new A(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new A(this.path,L)}compare(L){if(typeof L=="string")return A.compare(this.toString(),L);for(let O=0;O<L.d&&O<this.d;O++)if(L.path[O]!==this.path[O])return h.Disconnected;return L.d>this.d?h.IsChild:L.d<this.d?h.IsParent:h.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$PI=A}),define(Ee[75],Se([1,0,2,53,31,74]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$XI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$WI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$VI=e.$UI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$TI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$SI=e.$RI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$QI=e.TestResultState=void 0;var L;(function(z){z[z.Unset=0]="Unset",z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$QI={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var O;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(O||(e.ExtTestRunProfileKind=O={}));var $;(function(z){z[z.Run=2]="Run",z[z.Debug=4]="Debug",z[z.Coverage=8]="Coverage",z[z.HasNonDefaultProfile=16]="HasNonDefaultProfile",z[z.HasConfigurable=32]="HasConfigurable",z[z.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$RI=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const l=z=>"runId"in z;e.$SI=l;var I;(function(z){z.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),z.deserialize=(F,B)=>({range:A.$It.lift(B.range),uri:F.asCanonicalUri(r.URI.revive(B.uri))})})(I||(e.IRichLocation=I={}));var E;(function(z){z[z.Error=0]="Error",z[z.Output=1]="Output"})(E||(e.TestMessageType=E={}));var u;(function(z){z.serialize=F=>({message:F.message,type:E.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.serialize(F.location)}),z.deserialize=(F,B)=>({message:B.message,type:E.Error,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&I.deserialize(F,B.location)})})(u||(e.ITestErrorMessage=u={}));const k=(z,F)=>`${F?"s":"e"}${z}`;e.$TI=k;var b;(function(z){z.serialize=F=>({message:F.message,type:E.Output,offset:F.offset,length:F.length,location:F.location&&I.serialize(F.location)}),z.deserialize=(F,B)=>({message:B.message,type:E.Output,offset:B.offset,length:B.length,location:B.location&&I.deserialize(F,B.location)})})(b||(e.ITestOutputMessage=b={}));var c;(function(z){z.serialize=F=>F.type===E.Error?u.serialize(F):b.serialize(F),z.deserialize=(F,B)=>B.type===E.Error?u.deserialize(F,B):b.deserialize(F,B)})(c||(e.ITestMessage=c={}));var g;(function(z){z.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),z.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(c.serialize)}),z.deserialize=(F,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(_=>c.deserialize(F,_))})})(g||(e.ITestTaskState=g={}));const d="\0",m=(z,F)=>z+d+F;e.$UI=m;const n=z=>{const F=z.indexOf(d);return{ctrlId:z.slice(0,F),tagId:z.slice(F+1)}};e.$VI=n;var o;(function(z){z.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),z.deserialize=(F,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?F.asCanonicalUri(r.URI.revive(B.uri)):void 0,range:B.range?A.$It.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(o||(e.ITestItem=o={}));var i;(function(z){z[z.NotExpandable=0]="NotExpandable",z[z.Expandable=1]="Expandable",z[z.BusyExpanding=2]="BusyExpanding",z[z.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(z){z.serialize=F=>({expand:F.expand,item:o.serialize(F.item)}),z.deserialize=(F,B)=>({controllerId:R.$PI.root(B.item.extId),expand:B.expand,item:o.deserialize(F,B.item)})})(t||(e.InternalTestItem=t={}));var s;(function(z){z.serialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.uri!==void 0&&(B.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(B.range=F.item.range?.toJSON()),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}},z.deserialize=F=>{let B;return F.item&&(B={},F.item.label!==void 0&&(B.label=F.item.label),F.item.tags!==void 0&&(B.tags=F.item.tags),F.item.busy!==void 0&&(B.busy=F.item.busy),F.item.range!==void 0&&(B.range=F.item.range?A.$It.lift(F.item.range):null),F.item.description!==void 0&&(B.description=F.item.description),F.item.error!==void 0&&(B.error=F.item.error),F.item.sortText!==void 0&&(B.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:B}}})(s||(e.ITestItemUpdate=s={}));const f=(z,F)=>{F.expand!==void 0&&(z.expand=F.expand),F.item!==void 0&&(z.item=z.item?Object.assign(z.item,F.item):F.item)};e.$WI=f;var a;(function(z){z.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serializeWithoutMessages)}),z.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(g.serialize)}),z.deserialize=(F,B)=>({...t.deserialize(F,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(_=>g.deserialize(F,_)),retired:!0})})(a||(e.TestResultItem=a={}));var w;(function(z){z.empty=()=>({covered:0,total:0}),z.sum=(F,B)=>{F.covered+=B.covered,F.total+=B.total}})(w||(e.ICoverageCount=w={}));var y;(function(z){z.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),z.deserialize=(F,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,testIds:B.testIds,uri:F.asCanonicalUri(r.URI.revive(B.uri))}),z.empty=(F,B)=>({id:F,uri:B,statement:w.empty()})})(y||(e.IFileCoverage=y={}));function S(z){return{...z,location:z.location?.toJSON()}}function D(z){return z.location=z.location?h.$Ht.isIPosition(z.location)?h.$Ht.lift(z.location):A.$It.lift(z.location):void 0,z}e.$XI=3;var P;(function(z){z[z.Declaration=0]="Declaration",z[z.Statement=1]="Statement",z[z.Branch=2]="Branch"})(P||(e.DetailType=P={}));var C;(function(z){z.serialize=F=>F.type===P.Declaration?v.serialize(F):N.serialize(F),z.deserialize=F=>F.type===P.Declaration?v.deserialize(F):N.deserialize(F)})(C||(e.CoverageDetails=C={}));var p;(function(z){z.serialize=S,z.deserialize=D})(p||(e.IBranchCoverage=p={}));var v;(function(z){z.serialize=S,z.deserialize=D})(v||(e.IDeclarationCoverage=v={}));var N;(function(z){z.serialize=F=>({...S(F),branches:F.branches?.map(p.serialize)}),z.deserialize=F=>({...D(F),branches:F.branches?.map(p.deserialize)})})(N||(e.IStatementCoverage=N={}));var T;(function(z){z[z.Add=0]="Add",z[z.Update=1]="Update",z[z.DocumentSynced=2]="DocumentSynced",z[z.Remove=3]="Remove",z[z.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",z[z.Retire=5]="Retire",z[z.AddTag=6]="AddTag",z[z.RemoveTag=7]="RemoveTag"})(T||(e.TestDiffOpType=T={}));var M;(function(z){z.deserialize=(F,B)=>B.op===T.Add?{op:B.op,item:t.deserialize(F,B.item)}:B.op===T.Update?{op:B.op,item:s.deserialize(B.item)}:B.op===T.DocumentSynced?{op:B.op,uri:F.asCanonicalUri(r.URI.revive(B.uri)),docv:B.docv}:B,z.serialize=F=>F.op===T.Add?{op:F.op,item:t.serialize(F.item)}:F.op===T.Update?{op:F.op,item:s.serialize(F.item)}:F})(M||(e.TestsDiffOp=M={}));class j{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const B=this.w();for(const _ of F)switch(_.op){case T.Add:this.l(t.deserialize(this.k,_.item),B);break;case T.Update:this.p(s.deserialize(_.item),B);break;case T.Remove:this.q(_.itemId,B);break;case T.Retire:this.v(_.itemId);break;case T.IncrementPendingExtHosts:this.updatePendingRoots(_.amount);break;case T.AddTag:this.c.set(_.tag.id,_.tag);break;case T.RemoveTag:this.c.delete(_.id);break}B.complete?.()}l(F,B){const _=R.$PI.parentId(F.item.extId)?.toString();let re;if(!_)re=this.x(F),this.g.add(re),this.f.set(F.item.extId,re);else if(this.f.has(_)){const U=this.f.get(_);U.children.add(F.item.extId),re=this.x(F,U),this.f.set(F.item.extId,re)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return B.add?.(re),F.expand===i.BusyExpanding&&this.h++,re}p(F,B){const _=this.f.get(F.extId);if(_)return F.expand!==void 0&&(_.expand===i.BusyExpanding&&this.h--,F.expand===i.BusyExpanding&&this.h++),(0,e.$WI)(_,F),B.update?.(_),_}q(F,B){const _=this.f.get(F);if(!_)return;const re=R.$PI.parentId(_.item.extId)?.toString();re?this.f.get(re).children.delete(_.item.extId):this.g.delete(_);const U=[[F]];for(;U.length;)for(const G of U.pop()){const Q=this.f.get(G);Q&&(U.push(Q.children),this.f.delete(G),B.remove?.(Q,Q!==_),Q.expand===i.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$YI=j}),define(Ee[314],Se([1,0,136,256,75]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$PFb=e.$OFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var R;(function(E){E.ViewletId="workbench.view.extension.test",E.ExplorerViewId="workbench.view.testing",E.OutputPeekContributionId="editor.contrib.testingOutputPeek",E.DecorationsContributionId="editor.contrib.testingDecorations",E.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",E.CoverageViewId="workbench.view.testCoverage",E.ResultsPanelId="workbench.panel.testResults",E.ResultsViewId="workbench.panel.testResults.view",E.MessageLanguageId="vscodeInternalTestMessage"})(R||(e.Testing=R={}));var L;(function(E){E.List="list",E.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var O;(function(E){E.ByLocation="location",E.ByStatus="status",E.ByDuration="duration"})(O||(e.TestExplorerViewSorting=O={}));const $={[A.TestResultState.Errored]:(0,h.localize)(0,null),[A.TestResultState.Failed]:(0,h.localize)(1,null),[A.TestResultState.Passed]:(0,h.localize)(2,null),[A.TestResultState.Queued]:(0,h.localize)(3,null),[A.TestResultState.Running]:(0,h.localize)(4,null),[A.TestResultState.Skipped]:(0,h.localize)(5,null),[A.TestResultState.Unset]:(0,h.localize)(6,null)},l=(E,u)=>(0,h.localize)(7,null,(0,r.$Yk)(E),$[u]);e.$OFb=l,e.$PFb={[A.TestRunProfileBitset.Debug]:(0,h.localize)(8,null),[A.TestRunProfileBitset.Run]:(0,h.localize)(9,null),[A.TestRunProfileBitset.Coverage]:(0,h.localize)(10,null)};var I;(function(E){E.CancelTestRefreshAction="testing.cancelTestRefresh",E.CancelTestRunAction="testing.cancelRun",E.ClearTestResultsAction="testing.clearTestResults",E.CollapseAllAction="testing.collapseAll",E.ConfigureTestProfilesAction="testing.configureProfile",E.ContinousRunUsingForTest="testing.continuousRunUsingForTest",E.CoverageAtCursor="testing.coverageAtCursor",E.CoverageByUri="testing.coverage.uri",E.CoverageClear="testing.coverage.close",E.CoverageCurrentFile="testing.coverageCurrentFile",E.CoverageFilterToTest="testing.coverageFilterToTest",E.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",E.CoverageLastRun="testing.coverageLastRun",E.CoverageSelectedAction="testing.coverageSelected",E.CoverageToggleToolbar="testing.coverageToggleToolbar",E.CoverageViewChangeSorting="testing.coverageViewChangeSorting",E.DebugAction="testing.debug",E.DebugAllAction="testing.debugAll",E.DebugAtCursor="testing.debugAtCursor",E.DebugByUri="testing.debug.uri",E.DebugCurrentFile="testing.debugCurrentFile",E.DebugFailedTests="testing.debugFailTests",E.DebugLastRun="testing.debugLastRun",E.DebugSelectedAction="testing.debugSelected",E.FilterAction="workbench.actions.treeView.testExplorer.filter",E.GetExplorerSelection="_testing.getExplorerSelection",E.GetSelectedProfiles="testing.getSelectedProfiles",E.GoToTest="testing.editFocusedTest",E.HideTestAction="testing.hideTest",E.OpenCoverage="testing.openCoverage",E.OpenOutputPeek="testing.openOutputPeek",E.RefreshTestsAction="testing.refreshTests",E.ReRunFailedTests="testing.reRunFailTests",E.ReRunLastRun="testing.reRunLastRun",E.RunAction="testing.run",E.RunAllAction="testing.runAll",E.RunAllWithCoverageAction="testing.coverageAll",E.RunAtCursor="testing.runAtCursor",E.RunByUri="testing.run.uri",E.RunCurrentFile="testing.runCurrentFile",E.RunSelectedAction="testing.runSelected",E.RunUsingProfileAction="testing.runUsing",E.RunWithCoverageAction="testing.coverage",E.SearchForTestExtension="testing.searchForTestExtension",E.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",E.ShowMostRecentOutputAction="testing.showMostRecentOutput",E.StartContinousRun="testing.startContinuousRun",E.StopContinousRun="testing.stopContinuousRun",E.TestingSortByDurationAction="testing.sortByDuration",E.TestingSortByLocationAction="testing.sortByLocation",E.TestingSortByStatusAction="testing.sortByStatus",E.TestingViewAsListAction="testing.viewAsList",E.TestingViewAsTreeAction="testing.viewAsTree",E.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",E.ToggleInlineTestOutput="testing.toggleInlineTestOutput",E.UnhideAllTestsAction="testing.unhideAllTests",E.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ee[121],Se([1,0,9,4,3,66,75,74]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.TestItemEventOp=void 0;var $;(function(m){m[m.Upsert=0]="Upsert",m[m.SetTags=1]="SetTags",m[m.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",m[m.RemoveChild=3]="RemoveChild",m[m.SetProp=4]="SetProp",m[m.Bulk=5]="Bulk",m[m.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const l=(m,n)=>m===n,E=Object.entries({range:(m,n)=>m===n?!0:!m||!n?!1:m.equalsRange(n),busy:l,label:l,description:l,error:l,sortText:l,tags:(m,n)=>!(m.length!==n.length||m.some(o=>!n.includes(o)))}),u=(m,n)=>{let o;for(const[i,t]of E)t(m[i],n[i])||(o?o[i]=n[i]:o={[i]:n[i]});return o};class k extends A.$Wc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new r.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new h.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case L.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===L.TestDiffOpType.DocumentSynced&&o.uri===n.uri){o.docv=n.docv;return}break}case L.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===L.TestDiffOpType.Update&&o.item.extId===n.item.extId){(0,L.$WI)(o.item,n.item);return}if(o.op===L.TestDiffOpType.Add&&o.item.item.extId===n.item.extId){(0,L.$WI)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||o>i.expandLevels)&&(i.expandLevels=o),i.expand===L.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,o-1):t.wait().then(()=>this.L(i,o-1))}else if(i.expand===L.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,o-1)):this.L(i,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,o){switch(o.op){case $.RemoveChild:this.O(O.$PI.joinToString(n.fullId,o.id));break;case $.Upsert:this.z(o.item,n);break;case $.Bulk:for(const i of o.ops)this.w(n,i);break;case $.SetTags:this.C(o.new,o.old,n.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(n);break;case $.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:o.update}});break;case $.DocumentSynced:this.y(n.actual.uri);break;default:(0,R.$gd)(o)}}y(n){n&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,o){const i=O.$PI.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let s=this.tree.get(i.toString());if(!s){s={fullId:i,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(n,o),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(n)}}),this.I(n,s,o);return}if(s.actual===n){this.H(n,s,o);return}if(s.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,o);const f=this.s.getChildren(s.actual),a=s.actual,w=u(this.s.toITestItem(a),this.s.toITestItem(n));this.s.getApiFor(a).listener=void 0,s.actual=n,s.resolveBarrier=void 0,s.expand=L.TestItemExpandState.NotExpandable,w&&(w.hasOwnProperty("tags")&&(this.C(n.tags,a.tags,i.toString()),delete w.tags),this.w(s,{op:$.SetProp,update:w})),this.I(n,s,o);for(const[S,D]of f)this.s.getChildren(n).get(D.id)||this.O(O.$PI.joinToString(i,D.id));const y=s.expandLevels;y!==void 0&&queueMicrotask(()=>{s.expand===L.TestItemExpandState.Expandable&&(s.expandLevels=void 0,this.expand(i.toString(),y))}),this.y(s.actual.uri)}C(n,o,i){const t=new Set(o.map(s=>s.id));for(const s of n)t.delete(s.id)||this.D(s);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(s=>(0,L.$UI)(this.s.controllerId,s.id))}}}),t.forEach(this.F,this)}D(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$UI)(this.s.controllerId,n.id)}}))}F(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$UI)(this.s.controllerId,n)}))}G(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}H(n,o,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=s=>this.w(o,s),this.J(o)}I(n,o,i){this.H(n,o,i);for(const[t,s]of this.s.getChildren(n))this.z(s,o)}J(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:o=n.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:o=L.TestItemExpandState.NotExpandable,o!==n.expand&&(n.expand=o,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:o}}),o===L.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,o){if(o<0)return;const i=[];for(const[t,s]of this.s.getChildren(n.actual)){const f=this.expand(O.$PI.joinToString(n.fullId,s.id),o);(0,r.$rh)(f)&&i.push(f)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const s=new r.$Eh;return s.open(),s}n.expand=L.TestItemExpandState.BusyExpanding,this.N(n);const o=n.resolveBarrier=new r.$Eh,i=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(s){i(s)}return(0,r.$rh)(t)?t.catch(i).then(()=>{o.open(),this.J(n)}):(o.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:n});const i=[o];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.F(s.id);this.tree.delete(t.fullId.toString());for(const[s,f]of this.s.getChildren(t.actual))i.push(this.tree.get(O.$PI.joinToString(t.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$MP=k;class b extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$NP=b;class c extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$OP=c;class g extends Error{constructor(n,o,i){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${i}".`)}}e.$PP=g;const d=(m,n,o)=>{let i=new Map;return{get size(){return i.size},forEach(t,s){for(const f of i.values())t.call(s,f,this)},[Symbol.iterator](){return i.entries()},replace(t){const s=new Map,f=new Set(i.keys()),a={op:$.Bulk,ops:[]};for(const w of t){if(!(w instanceof o))throw new c(w.id);const y=n(w).controllerId;if(y!==m.controllerId)throw new g(w.id,y,m.controllerId);if(s.has(w.id))throw new b(w.id);s.set(w.id,w),f.delete(w.id),a.ops.push({op:$.Upsert,item:w})}for(const w of f.keys())a.ops.push({op:$.RemoveChild,id:w});m.listener?.(a),i=s},add(t){if(!(t instanceof o))throw new c(t.id);i.set(t.id,t),m.listener?.({op:$.Upsert,item:t})},delete(t){i.delete(t)&&m.listener?.({op:$.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$QP=d}),define(Ee[154],Se([1,0,121]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=void 0;const h=new WeakMap,A=(L,O)=>{const $={controllerId:O};return h.set(L,$),$};e.$RP=A;const R=L=>{const O=h.get(L);if(!O)throw new r.$OP(L?.id||"<unknown>");return O};e.$SP=R}),define(Ee[122],Se([1,0,27,15,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ECb=e.$DCb=e.$CCb=void 0,e.$FCb=R,e.$GCb=O,e.$CCb="vscode-cdn.net",e.$DCb=`vscode-resource.${e.$CCb}`,e.$ECb=`'self' https://*.${e.$CCb}`;function R($,l){return $.scheme===h.Schemas.http||$.scheme===h.Schemas.https?$:(l&&l.authority&&l.isRemote&&$.scheme===h.Schemas.file&&($=A.URI.from({scheme:h.Schemas.vscodeRemote,authority:l.authority,path:$.path})),A.URI.from({scheme:h.Schemas.https,authority:`${$.scheme}+${L($.authority)}.${e.$DCb}`,path:$.path,fragment:$.fragment,query:$.query}))}function L($){return $.replace(/./g,l=>{const I=l.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?l:"-"+I.toString(16).padStart(4,"0")})}function O($){return $.replace(/-([0-9a-f]{4})/g,(l,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ee[315],Se([1,0,4,3,122]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class R{constructor(O,$,l){this.d=O,this.e=$,this.f=l,this.a=0,this.b=new h.$Vc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const I=$.getVisibleTextEditors();for(const E of this.c.values())I.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(O=>O.inset.dispose()),this.b.dispose()}createWebviewEditorInset(O,$,l,I,E){let u;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===O){u=n;break}if(!u)throw new Error("not a visible editor");const k=this,b=this.a++,c=new r.$me,g=new r.$me,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,A.$FCb)(n,k.f)}get cspSource(){return A.$ECb}set options(n){this.b=n,k.d.$setOptions(b,n)}get options(){return this.b}set html(n){this.a=n,k.d.$setHtml(b,n)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(n){return k.d.$postMessage(b,n)}},m=new class{constructor(){this.editor=O,this.line=$,this.height=l,this.webview=d,this.onDidDispose=g.event}dispose(){k.c.has(b)&&(k.c.delete(b),k.d.$disposeEditorInset(b),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(b,u.id,u.value.document.uri,$+1,l,I||{},E.identifier,E.extensionLocation),this.c.set(b,{editor:O,inset:m,onDidReceiveMessage:c}),m}$onDidDispose(O){const $=this.c.get(O);$&&$.inset.dispose()}$onDidReceiveMessage(O,$){this.c.get(O)?.onDidReceiveMessage.fire($)}}e.$Rnc=R}),define(Ee[155],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=void 0,e.$sM="__",e.$tM=(0,r.$Fi)("IAuthenticationService"),e.$uM=(0,r.$Fi)("IAuthenticationExtensionsService")}),define(Ee[316],Se([1,0,5]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LQ=e.VariableKind=e.$KQ=void 0,e.$KQ=(0,r.$Fi)("configurationResolverService");var h;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(h||(e.VariableKind=h={}));class A extends Error{constructor(L,O){super(O),this.variable=L}}e.$LQ=A}),define(Ee[317],Se([1,0,16,56,18,25,11,110,257,316,13]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Q=void 0,r=We(r),h=We(h),A=We(A),R=We(R);class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(k,b,c,g){this.h=new Map,this.a=k,this.b=b,this.g=c,g&&(this.c=g.then(d=>this.i(d)))}i(k){if(L.$i){const b=Object.create(null);return Object.keys(k).forEach(c=>{b[c.toLowerCase()]=k[c]}),b}return k}resolveWithEnvironment(k,b,c){return this.l({env:this.i(k),userHome:void 0},b?b.uri:void 0,c)}async resolveAsync(k,b){const c={env:await this.c,userHome:await this.g};return this.l(c,k?k.uri:void 0,b)}async j(k,b,c,g){const d=R.$co(b);L.$i&&d.windows?Object.keys(d.windows).forEach(n=>d[n]=d.windows[n]):L.$j&&d.osx?Object.keys(d.osx).forEach(n=>d[n]=d.osx[n]):L.$k&&d.linux&&Object.keys(d.linux).forEach(n=>d[n]=d.linux[n]),delete d.windows,delete d.osx,delete d.linux;const m={env:await this.c,userHome:await this.g};return this.l(m,k?k.uri:void 0,d,c,g)}async resolveAnyAsync(k,b,c){return this.j(k,b,c)}async resolveAnyMap(k,b,c){const g=new Map;return{newConfig:await this.j(k,b,c,g),resolvedVariables:g}}resolveWithInteractionReplace(k,b,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,b,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,b){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,b)}async l(k,b,c,g,d){if(A.$fg(c))return this.m(k,b,c,g,d);if(Array.isArray(c))return Promise.all(c.map(m=>this.l(k,b,m,g,d)));if(A.$hg(c)){const m=Object.create(null),n=await Promise.all(Object.keys(c).map(async o=>[await this.m(k,b,o,g,d),await this.l(k,b,c[o],g,d)]));for(const[o,i]of n)m[o]=i;return m}return c}m(k,b,c,g,d){return(0,I.$yf)(c,E.VARIABLE_REGEXP,async(m,n)=>{if(n.includes(E.VARIABLE_LHS))return m;let o=await this.o(k,m,n,b,g);return d?.set(n,o),o!==m&&A.$fg(o)&&o.match(E.VARIABLE_REGEXP)&&(o=await this.m(k,b,o,g,d)),o})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,b,c,g,d){let m;const n=c.split(":");n.length>1&&(c=n[0],m=n[1]);const o=s=>{const f=this.a.getFilePath();if(f)return(0,O.$Tw)(f);throw new l.$LQ(s,(0,$.localize)(0,null,b))},i=s=>{const f=o(s);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,O.$Tw)(a)}throw new l.$LQ(s,(0,$.localize)(1,null,b,r.$pc(f)))},t=s=>{if(m){const f=this.a.getFolderUri(m);if(f)return f;throw new l.$LQ(s,(0,$.localize)(2,null,b,m))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new l.$LQ(s,(0,$.localize)(3,null,b)):new l.$LQ(s,(0,$.localize)(4,null,b))};switch(c){case"env":if(m){if(k.env){const s=k.env[L.$i?m.toLowerCase():m];if(A.$fg(s))return s}return""}throw new l.$LQ(l.VariableKind.Env,(0,$.localize)(5,null,b));case"config":if(m){const s=this.a.getConfigurationValue(g,m);if(A.$og(s))throw new l.$LQ(l.VariableKind.Config,(0,$.localize)(6,null,b,m));if(A.$hg(s))throw new l.$LQ(l.VariableKind.Config,(0,$.localize)(7,null,b,m));return s}throw new l.$LQ(l.VariableKind.Config,(0,$.localize)(8,null,b));case"command":return this.p(l.VariableKind.Command,b,m,d,"command");case"input":return this.p(l.VariableKind.Input,b,m,d,"input");case"extensionInstallFolder":if(m){const s=await this.a.getExtension(m);if(!s)throw new l.$LQ(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,b,m));return this.n(s.extensionLocation)}throw new l.$LQ(l.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,b));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,O.$Tw)(this.n(t(l.VariableKind.WorkspaceFolder)));case"cwd":return g||m?(0,O.$Tw)(this.n(t(l.VariableKind.Cwd))):h.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,O.$Tw)(r.$pc(this.n(t(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new l.$LQ(l.VariableKind.UserHome,(0,$.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new l.$LQ(l.VariableKind.LineNumber,(0,$.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new l.$LQ(l.VariableKind.SelectedText,(0,$.localize)(13,null,b))}case"file":return o(l.VariableKind.File);case"fileWorkspaceFolder":return i(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$pc(i(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||m?r.$nc(this.n(t(l.VariableKind.RelativeFile)),o(l.VariableKind.RelativeFile)):o(l.VariableKind.RelativeFile);case"relativeFileDirname":{const s=r.$oc(o(l.VariableKind.RelativeFileDirname));if(g||m){const f=r.$nc(this.n(t(l.VariableKind.RelativeFileDirname)),s);return f.length===0?".":f}return s}case"fileDirname":return r.$oc(o(l.VariableKind.FileDirname));case"fileExtname":return r.$qc(o(l.VariableKind.FileExtname));case"fileBasename":return r.$pc(o(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=r.$pc(o(l.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-r.$qc(s).length)}case"fileDirnameBasename":return r.$pc(r.$oc(o(l.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":case"/":return r.sep;default:try{const s=m?`${c}:${m}`:c;return this.p(l.VariableKind.Unknown,b,s,d,void 0)}catch{return b}}}}p(k,b,c,g,d){if(c&&g){const m=d===void 0?g[c]:g[d+":"+c];if(typeof m=="string")return m;throw new l.$LQ(k,(0,$.localize)(14,null,b))}return b}}e.$1Q=E}),define(Ee[156],Se([1,0,5,152]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$gE=void 0,e.$hE=l,e.$iE=u,e.$jE=k,e.$gE=(0,r.$Fi)("editorGroupsService");var A;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(A||(e.GroupDirection=A={}));var R;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var O;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(O||(e.GroupsArrangement=O={}));var $;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function l(b){const c=b;return(0,h.$5F)(c?.editor)&&(0,h.$5F)(c?.replacement)}var I;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var E;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function u(b){const c=b;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}function k(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?A.DOWN:A.RIGHT}}),define(Ee[318],Se([1,0,5,156]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nE=e.$mE=e.$lE=e.$kE=void 0,e.$oE=A,e.$kE=(0,r.$Fi)("editorService"),e.$lE=-1,e.$mE=-2,e.$nE=-3;function A(R){const L=R;return typeof R=="number"||(0,h.$iE)(L)}}),define(Ee[157],Se([1,0,5,144]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0,e.$NM=(0,r.$Gi)(h.$Mi)}),define(Ee[158],Se([1,0,24,4,16,3,9]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=e.$6bc=e.$5bc=e.$4bc=void 0,A=We(A);class O{constructor(m,n){this.versionId=m,this.removedDueToLooping=n}}e.$4bc=O;class ${static isHostExtension(m,n,o){if(n.getExtensionDescription(m))return!1;const i=o.getExtensionDescription(m);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(m,n){this.j=m,this.c=new h.$me,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(c),this.f=new r.$sn,this.g=[],this.h=new Map;for(const m of this.e){if(this.f.has(m.identifier)){console.error("Extension `"+m.identifier.value+"` is already registered");continue}this.f.set(m.identifier,m),this.g.push(m);const n=this.j.readActivationEvents(m);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(m)}}set(m){return this.e=m,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(m,n){this.e=g(this.e,n),this.e=this.e.concat(m);const o=$.l(this.e);return this.e=g(this.e,o.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new O(this.d,o)}static l(m){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,a){this.addNode(f),this.addNode(a),this.c.has(f)?this.c.get(f).push(a):this.c.set(f,[a])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,a){const w=n.getArcs(f);for(let y=0;y<w.length;y++)if(!a.has(w[y]))return!1;return!0}getNodes(){return this.e}},o=new r.$sn;for(const f of m)if(o.set(f.identifier,f),f.extensionDependencies)for(const a of f.extensionDependencies)n.addArc(r.$qn.toKey(f.identifier),r.$qn.toKey(a));const i=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>i.add(f));const t=n.getNodes().filter(f=>!i.has(f));let s;do{s=!1;for(let f=0;f<t.length;f++){const a=t[f];n.hasOnlyGoodArcs(a,i)&&(t.splice(f,1),f--,i.add(a),s=!0)}}while(s);return t.map(f=>o.get(f))}containsActivationEvent(m){return this.h.has(m)}containsExtension(m){return this.f.has(m)}getExtensionDescriptionsForActivationEvent(m){const n=this.h.get(m);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new l(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(m){const n=this.f.get(m);return n||void 0}getExtensionDescriptionByUUID(m){for(const n of this.g)if(n.uuid===m)return n}getExtensionDescriptionByIdOrUUID(m,n){return this.getExtensionDescription(m)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$5bc=$;class l{constructor(m,n){this.versionId=m,this.extensions=n}}e.$6bc=l;class I{constructor(m){this.d=new k,this.c=new $(m,[])}async acquireLock(m){const n=await this.d.acquire(m);return new E(this,n)}deltaExtensions(m,n,o){if(!m.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(m){return this.c.containsActivationEvent(m)}containsExtension(m){return this.c.containsExtension(m)}getExtensionDescriptionsForActivationEvent(m){return this.c.getExtensionDescriptionsForActivationEvent(m)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(m){return this.c.getExtensionDescription(m)}getExtensionDescriptionByUUID(m){return this.c.getExtensionDescriptionByUUID(m)}getExtensionDescriptionByIdOrUUID(m,n){return this.c.getExtensionDescriptionByIdOrUUID(m,n)}}e.$7bc=I;class E extends R.$Wc{constructor(m,n){super(),this.f=m,this.c=!1,this.B(n)}isAcquiredFor(m){return!this.c&&this.f===m}}e.$8bc=E;class u{constructor(m){this.name=m;const n=(0,L.$yh)();this.promise=n.promise,this.c=n.resolve}resolve(m){this.c(m)}}class k{constructor(){this.c=[],this.d=!1}async acquire(m){const n=new u(m);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const m=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${m.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};m.resolve((0,R.$Uc)(i))}}var b;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(b||(b={}));function c(d,m){const n=d.isBuiltin?b.Builtin:d.isUnderDevelopment?b.Dev:b.User,o=m.isBuiltin?b.Builtin:m.isUnderDevelopment?b.Dev:b.User;if(n!==o)return n-o;const i=A.$ic.basename(d.extensionLocation.path),t=A.$ic.basename(m.extensionLocation.path);return i<t?-1:i>t?1:0}function g(d,m){const n=new r.$rn(m);return d.filter(o=>!n.has(o.identifier))}}),define(Ee[319],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.ExtHostConnectionType=void 0,e.$en=O,e.$fn=$;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class h{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(E){this.pipeName=E,this.type=r.IPC}serialize(E){E[h.ENV_KEY]=this.pipeName}}e.$bn=h;class A{constructor(){this.type=r.Socket}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(E){E[A.ENV_KEY]="1"}}e.$cn=A;class R{constructor(){this.type=r.MessagePort}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(E){E[R.ENV_KEY]="1"}}e.$dn=R;function L(I){delete I[h.ENV_KEY],delete I[A.ENV_KEY],delete I[R.ENV_KEY]}function O(I,E){L(E),I.serialize(E)}function $(I){if(I[h.ENV_KEY])return l(I,new h(I[h.ENV_KEY]));if(I[A.ENV_KEY])return l(I,new A);if(I[R.ENV_KEY])return l(I,new R);throw new Error("No connection information defined in environment!")}function l(I,E){return L(I),E}}),define(Ee[94],Se([1,0,22]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=L,e.$zn=O;var h;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(h||(e.UIKind=h={}));var A;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(A||(e.ExtensionHostExitCode=A={}));var R;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(l){const I=r.$Oe.alloc(1);switch(l){case R.Initialized:I.writeUInt8(1,0);break;case R.Ready:I.writeUInt8(2,0);break;case R.Terminate:I.writeUInt8(3,0);break}return I}function O(l,I){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return I===R.Initialized;case 2:return I===R.Ready;case 3:return I===R.Terminate;default:return!1}}var $;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[95],Se([1,0,5,4,149,12,30,94,91,92,25,2,3,240]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$cQ=e.$bQ=void 0,e.$dQ=g;let b=class extends u.$Wc{constructor(m,n){super(),this.s=m,this.t=n,this.a=this.B(new h.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new h.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=A.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=E.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:l.$yp,name:(0,k.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(o=>{(0,R.$bk)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===A.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=A.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=A.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=A.TelemetryLevel.USAGE:!1}}instantiateLogger(m,n,o){const i=this.getTelemetryDetails(),t=new c(n,o,m,this.n,this.j,this.getBuiltInCommonProperties(m),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),s=this.r.get(m.identifier.value)??[];return this.r.set(m.identifier.value,[...s,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(m,n,o){this.f=m,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(m){const n=Object.create(null);switch(n["common.extname"]=`${m.publisher}.${m.name}`,n["common.extversion"]=m.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=g(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case O.UIKind.Web:n["common.uikind"]="web";break;case O.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,$.$hn)((0,l.$Ep)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(m){this.h=this.getTelemetryConfiguration(),this.f=m;const n=this.getTelemetryDetails();this.r.forEach((o,i)=>{const t=o.filter(s=>!s.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(o=>{for(const i of o)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(m,n){const i=this.r.get(m.value)?.filter(s=>!s.isDisposed);if(!i)return this.r.delete(m.value),!1;let t=!1;for(const s of i)s.ignoreUnhandledExtHostErrors||(s.logError(n),t=!0);return t}};e.$bQ=b,e.$bQ=b=Je([Ve(0,L.$aQ),Ve(1,R.$ak)],b);class c{static validateSender(m){if(typeof m!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof m.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof m.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof m.flush<"u"&&typeof m.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(m,n,o,i,t,s,f){this.g=o,this.h=i,this.i=t,this.j=s,this.a=new h.$me,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=m,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(m,n){this.e&&(this.d={isUsageEnabled:m,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(m){let n="properties"in m?m.properties??{}:m;return n=(0,l.$Hp)(n,[]),this.c&&(n=(0,I.$fo)(n,this.c)),this.b||(n=(0,I.$fo)(n,this.j)),"properties"in m?m.properties=n:m=n,m}k(m,n){this.f&&(this.g.publisher==="vscode"?m=this.g.name+"/"+m:m=this.g.identifier.value+"/"+m,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(m,n),this.h.trace(m,n))}logUsage(m,n){this.d.isUsageEnabled&&this.k(m,n)}logError(m,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof m=="string")this.k(m,n);else{const o={name:m.name,message:m.message,stack:m.stack,cause:m.cause},i=(0,l.$Hp)(o,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const m=this,n={logUsage:m.logUsage.bind(m),get isUsageEnabled(){return m.d.isUsageEnabled},get isErrorsEnabled(){return m.d.isErrorsEnabled},logError:m.logError.bind(m),dispose:m.dispose.bind(m),onDidChangeEnableStates:m.a.event.bind(m)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let m=this.f;this.f=void 0,Promise.resolve(m.flush()).then(m=void 0),this.e=void 0}else this.f=void 0}}e.$cQ=c;function g(d){const m=Date.now()-new Date(d).getTime();return isNaN(m)?!1:m<1e3*60*60*24}e.$eQ=(0,r.$Fi)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,289,147,24,5]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.ActivationKind=e.$7G=e.$6G=e.$3G=e.ExtensionHostStartup=e.$2G=e.$1G=e.$ZG=e.$YG=void 0,e.$4G=u,e.$5G=k,e.$8G=d,e.$9G=m,e.$YG=Object.freeze({identifier:new L.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:h.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$ZG="extensions.webWorker",e.$1G=(0,O.$Fi)("extensionService");class ${constructor(i){this.dependency=i}}e.$2G=$;var l;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,s){this.c=i,this.d=t.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$JG.createActivationEventsMap(this.d)}}set(i,t,s){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const f=[],a=[],w=[],y=[],S=E(this.d),D=E(t),P=(T,M)=>T.extensionLocation.toString()===M.extensionLocation.toString()||T.isBuiltin===M.isBuiltin||T.isUserBuiltin===M.isUserBuiltin||T.isUnderDevelopment===M.isUnderDevelopment;for(const T of this.d){const M=D.get(T.identifier);if(!M){f.push(T.identifier),S.delete(T.identifier);continue}if(!P(T,M)){f.push(T.identifier),S.delete(T.identifier);continue}}for(const T of t){const M=S.get(T.identifier);if(!M){a.push(T);continue}if(!P(M,T)){f.push(M.identifier),S.delete(M.identifier);continue}}const C=new L.$rn(this.e),p=new L.$rn(s);for(const T of this.e)p.has(T)||w.push(T);for(const T of s)C.has(T)||y.push(T);const v=R.$JG.createActivationEventsMap(a),N={versionId:i,toRemove:f,toAdd:a,addActivationEvents:v,myToRemove:w,myToAdd:y};return this.delta(N),N}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:s,myToRemove:f,myToAdd:a}=i,w=new L.$rn(t),y=new L.$rn(f);for(let S=0;S<this.d.length;S++)w.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)y.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of a)this.e.push(S);return this.f=null,i}containsExtension(i){for(const t of this.e)if(L.$qn.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const s=R.$JG.readActivationEvents(t);for(const f of s)i.add(f)}return i}}e.$3G=I;function E(o){const i=new L.$sn;for(const t of o)i.set(t.identifier,t);return i}function u(o,i){return o.enabledApiProposals?o.enabledApiProposals.includes(i):!1}function k(o,i){if(!u(o,i))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class b{constructor(i,t,s,f){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=f}}e.$6G=b;class c{constructor(i,t){this.description=i,this.value=t}}e.$7G=c;var g;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function d(o){return{type:o.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,A.$Np)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function m(o,i){const t=(0,A.$Lp)(o.manifest.publisher,o.manifest.name);return{id:t,identifier:new L.$qn(t),isBuiltin:o.type===L.ExtensionType.System,isUserBuiltin:o.type===L.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!i,extensionLocation:o.location,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName,...o.manifest}}class n{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$0G=n}),define(Ee[320],Se([1,0,14,158,24,26,12,9]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$foc=e.$eoc=e.$doc=e.$coc=e.$boc=void 0,r=We(r);class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(d,m,n,o){this.startup=d,this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=o}}e.$boc=$;class l{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,m){return d===-1||m===-1?-1:m-d}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$coc=l;class I{constructor(d,m,n,o,i,t){this.activationFailed=d,this.activationFailedError=m,this.activationTimes=n,this.module=o,this.exports=i,this.subscriptions=t}}e.$doc=I;class E extends I{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.$eoc=E;class u extends I{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$foc=u;class k extends I{constructor(d){super(!0,d,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(d,m,n,o){this.g=o,this.a=d,this.b=m,this.c=n,this.d=new A.$sn,this.f=Object.create(null)}dispose(){for(const[d,m]of this.d)m.dispose()}async waitForActivatingExtensions(){const d=[];for(const[m,n]of this.d)d.push(n.wait());await Promise.all(d)}isActivated(d){const m=this.d.get(d);return!!(m&&m.value)}getActivatedExtension(d){const m=this.d.get(d);if(!m||!m.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return m.value}async activateByEvent(d,m){if(this.f[d])return;const n=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(n.map(o=>({id:o.identifier,reason:{startup:m,extensionId:o.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,m){const n=this.a.getExtensionDescription(d);if(!n)throw new Error(`Extension '${d.value}' is not known`);return this.h([{id:n.identifier,reason:m}])}async h(d){const m=d.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(m.map(n=>n.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const m=this.a.getExtensionDescription(d.id);if(!m){const i=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new k(i));return this.c.onExtensionActivationError(d.id,i,new R.$2G(d.id.value)),t}const n=[],o=typeof m.extensionDependencies>"u"?[]:m.extensionDependencies;for(const i of o){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(i);if(s){if(!s.main&&!s.browser)continue;n.push(this.j({id:s.identifier,reason:d.reason}));continue}const f=m.displayName||m.identifier.value,a=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${i}'`),w=this.k(d,m.displayName,[],new k(a));return this.c.onExtensionActivationError(m.identifier,a,new R.$2G(i)),w}return this.k(d,m.displayName,n,null)}k(d,m,n,o){const i=new c(d.id,m,d.reason,n,o,this.c,this.g);return this.d.set(d.id,i),i}l(d){return h.$5bc.isHostExtension(d,this.a,this.b)}m(d){const m=this.b.getExtensionDescription(d);return m?!m.main&&!m.browser:!1}};e.$goc=b,e.$goc=b=Je([Ve(3,L.$_j)],b);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,m,n,o,i,t,s){this.c=d,this.d=m,this.f=n,this.g=o,this.h=i,this.j=t,this.k=s,this.a=new O.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const m=this.g[d];if(m.value&&!m.value.activationFailed){this.g.splice(d,1),d--;continue}if(m.value&&m.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${m.friendlyName}' failed to activate`);n.detail=m.value.activationFailedError,this.h=new k(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const m=new Error;if(d&&d.name&&(m.name=d.name),d&&d.message?m.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:m.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(m.stack=d.stack),this.h=new k(m),this.b&&r.$6(d))return;this.j.onExtensionActivationError(this.c,m,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};c=Je([Ve(6,L.$_j)],c)}),define(Ee[321],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testRunInDebug:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRunInDebug.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[159],Se([1,0,259,14,44,146,117,37,24,321,116,147]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=void 0,r=We(r),A=Ut(A);const u=O.$po.as(L.$qo.JSONContribution);class k{constructor(i,t,s){this.a=i,this.b=t,this.c=s}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(A.default.Error,i)}warn(i){this.d(A.default.Warning,i)}info(i){this.d(A.default.Info,i)}}e.$SG=k;class b{static a(i){const t=new $.$rn;for(let s=0,f=i.length;s<f;s++)t.add(i[s].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new b(t,[]);if(!t||!t.length)return new b([],i);const s=this.a(i),f=this.a(t),a=t.filter(y=>!s.has(y.description.identifier)),w=i.filter(y=>!f.has(y.description.identifier));return new b(a,w)}constructor(i,t){this.added=i,this.removed=t}}e.$TG=b;class c{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=b.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,h.$3)(i)}}}e.$UG=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.$VG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$pn},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$7o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$7o}},extensionKind:{description:r.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class m{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new c(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&E.$JG.register(i.extensionPoint,i.activationEventsGenerator),e.$VG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,u.registerSchema(d,e.$VG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$WG=m;const n={ExtensionsRegistry:"ExtensionsRegistry"};O.$po.add(n.ExtensionsRegistry,new m),e.$XG=O.$po.as(n.ExtensionsRegistry),u.registerSchema(d,e.$VG),u.registerSchema(I.$tk,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(Ee[322],Se([1,0,4,40,3,13,250,24,5,12,26,159]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.$_G=e.$$G=e.ChatMessageRole=void 0;var u;(function(c){c[c.System=0]="System",c[c.User=1]="User",c[c.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$$G=(0,$.$Fi)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.$_G=E.$XG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(c,g)=>{for(const d of c)g.push(`onLanguageModelChat:${d.vendor}`)}});let b=class{constructor(g,d){this.e=g,this.f=d,this.a=new A.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$_G.setHandler(m=>{this.c.clear();for(const o of m){if(!(0,I.$4G)(o.description,"chatProvider")){o.collector.error((0,L.localize)(2,null));continue}for(const i of h.Iterable.wrap(o.value)){if(this.c.has(i.vendor)){o.collector.error((0,L.localize)(3,null,i.vendor));continue}if((0,R.$df)(i.vendor)){o.collector.error((0,L.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){o.collector.error((0,L.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[o,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(o),n.push(o));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(g){return this.b.get(g)?.metadata}async selectLanguageModels(g){if(g.vendor)await this.e.activateByEvent(`onLanguageModelChat:${g.vendor}}`);else{const m=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(m)}const d=[];for(const[m,n]of this.b)(g.vendor===void 0||n.metadata.vendor===g.vendor)&&(g.family===void 0||n.metadata.family===g.family)&&(g.version===void 0||n.metadata.version===g.version)&&(g.identifier===void 0||n.metadata.id===g.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(o=>O.$qn.equals(o,g.extension)))&&d.push(m);return this.f.trace("[LM] selected language models",g,d),d}registerLanguageModelChat(g,d){if(this.f.trace("[LM] registering language model chat",g,d.metadata),!this.c.has(d.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${d.metadata.vendor}.`);if(this.b.has(g))throw new Error(`Chat response provider with identifier ${g} is already registered.`);return this.b.set(g,d),this.d.fire({added:[{identifier:g,metadata:d.metadata}]}),(0,A.$Uc)(()=>{this.b.delete(g)&&(this.d.fire({removed:[g]}),this.f.trace("[LM] UNregistered language model chat",g,d.metadata))})}makeLanguageModelChatRequest(g,d,m,n,o,i){const t=this.b.get(g);if(!t)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return t.provideChatResponse(m,d,n,o,i)}computeTokenLength(g,d,m){const n=this.b.get(g);if(!n)throw new Error(`Chat response provider with identifier ${g} is not registered.`);return n.provideTokenCount(d,m)}};e.$aH=b,e.$aH=b=Je([Ve(0,I.$1G),Ve(1,l.$_j)],b)}),define(Ee[323],Se([1,0,254,18,25,159,36,4]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=void 0,r=We(r),h=We(h),A=We(A);const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var l;(function(u){function k(b,c,g){if(!b)return;const d=h.$fg(b.type)?b.type:void 0;if(!d||d.length===0){g.error(r.localize(3,null));return}const m=[];if(Array.isArray(b.required))for(const n of b.required)h.$fg(n)&&m.push(n);return{extensionId:c.value,taskType:d,required:m,properties:b.properties?A.$co(b.properties):{},when:b.when?L.$Dj.deserialize(b.when):void 0}}u.from=k})(l||(l={}));const I=R.$XG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,k)=>{for(const b of u)b.type&&k.push(`onTaskType:${b.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:$}});class E{constructor(){this.d=new O.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,b)=>{I.setHandler((c,g)=>{this.c=void 0;try{for(const d of g.removed){const m=d.value;for(const n of m)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const d of g.added){const m=d.value;for(const n of m){const o=l.from(n,d.description.identifier,d.collector);o&&(this.a[o.taskType]=o)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const b of this.all()){const c={type:"object",additionalProperties:!1};b.required.length>0&&(c.required=b.required.slice(0)),b.properties!==void 0?c.properties=A.$co(b.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[b.taskType]},k.push(c)}this.c={oneOf:k}}return this.c}}e.$DI=new E}),define(Ee[324],Se([1,0,255,18,23,25,36,323,45]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$NI=e.JsonSchemaVersion=e.ExecutionEngine=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$HI=e.ShellQuoting=e.$GI=e.$FI=e.$EI=void 0,r=We(r),h=We(h),A=We(A),R=We(R),e.$EI="settings",e.$FI=new L.$Wj("taskRunning",!1,r.localize(0,null)),e.$GI=r.localize2(2,"Tasks");var l;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.$HI="$customized",function(F){function B(_){if(!_)return F.Strong;switch(_.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=B}(l||(e.ShellQuoting=l={}));var I;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var E;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(E||(e.RevealKind=E={})),function(F){function B(_){switch(_.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=B}(E||(e.RevealKind=E={}));var u;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(F){function B(_){switch(_.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=B}(u||(e.RevealProblemKind=u={}));var k;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(k||(e.PanelKind=k={})),function(F){function B(_){switch(_.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=B}(k||(e.PanelKind=k={}));var b;(function(F){F.defaults={echo:!0,reveal:E.Always,revealProblems:u.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var c;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(c||(e.RuntimeType=c={})),function(F){function B(re){switch(re.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=B;function _(re){switch(re){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=_}(c||(e.RuntimeType=c={}));var g;(function(F){function B(_){return h.$fg(_)?_:_.value}F.value=B})(g||(e.CommandString=g={}));var d;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function B(re){return re===F.Clean._id||re===F.Build._id||re===F.Rebuild._id||re===F.Test._id}F.is=B;function _(re){if(re!==void 0)return h.$fg(re)?B(re)?{_id:re,isDefault:!1}:void 0:re}F.from=_})(d||(e.TaskGroup=d={}));var m;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(m||(e.TaskScope=m={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function B(_){switch(_){case F.User:return $.ConfigurationTarget.USER;case F.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=B})(n||(e.TaskSourceKind=n={}));var o;(function(F){F.parallel="parallel",F.sequence="sequence"})(o||(e.DependsOrder=o={}));var i;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class s{constructor(B,_,re,U,G,Q){this._label="",this._id=B,_&&(this._label=_),re&&(this.type=re),this.runOptions=U,this.configurationProperties=G,this._source=Q}getDefinition(B){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const B={folder:this.d(),id:this._id};return JSON.stringify(B)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(B,_=!1){if(B===void 0)return!1;if(h.$fg(B))return B===this._label||B===this.configurationProperties.identifier||_&&B===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===B._key}getQualifiedLabel(){const B=this.getWorkspaceFolder();return B?`${this._label} (${B.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(B){this.c===void 0&&(this.c=[]),B&&(this.c=this.c.concat(B))}get taskLoadMessages(){return this.c}}e.$II=s;class f extends s{constructor(B,_,re,U,G,Q,ee,ue){super(B,re,void 0,ee,ue,_),this.command={},this._source=_,this.hasDefinedMatchers=Q,G&&(this.command=G)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(B=!1){if(B&&this._source.customizes!==void 0)return this._source.customizes;{let _;switch(this.command?this.command.runtime:void 0){case c.Shell:_="shell";break;case c.Process:_="process";break;case c.CustomExecution:_="customExecution";break;case void 0:_="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:_,_key:this._id,id:this._id}}}static is(B){return B instanceof f}getMapKey(){const B=this._source.config.workspaceFolder;return B?`${B.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$EI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const B=this.d();if(!B)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$HI,folder:B,id:_};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(B){return new f(B._id,B._source,B._label,B.type,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$JI=f;class a extends s{constructor(B,_,re,U,G,Q,ee){super(B,re,U,Q,ee,_),this._source=_,this.configures=G}static is(B){return B instanceof a}f(B){return B}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?A.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$EI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const B=this.d();if(!B)return;let _=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(_+=this._source.kind);const re={type:e.$HI,folder:B,id:_};return JSON.stringify(re)}}e.$KI=a;class w extends s{constructor(B,_,re,U,G,Q,ee,ue,ne){super(B,re,U,ue,ne,_),this.defines=G,this.hasDefinedMatchers=ee,this.command=Q,this.icon=ne.icon,this.hide=ne.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(B){return B instanceof w}getMapKey(){const B=this._source.workspaceFolder;return B?`${this._source.scope.toString()}|${B.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===m.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const B={type:"contributed",scope:this._source.scope,id:this._id};return B.folder=this.d(),JSON.stringify(B)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(B){return new w(B._id,B._source,B._label,B.type,B.defines,B.command,B.hasDefinedMatchers,B.runOptions,B.configurationProperties)}}e.$LI=w;class y extends s{constructor(B,_,re,U,G,Q){super(B,re,U,G,Q,_),this._source=_}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(B){return B instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(B){return new y(B._id,B._source,B._label,B.type,B.runOptions,B.configurationProperties)}}e.$MI=y;var S;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(F){F._default=F.Terminal}(S||(e.ExecutionEngine=S={}));var D;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(D||(e.JsonSchemaVersion=D={}));class P{constructor(B){this.c=new Map;for(let _=0;_<B.length;_++)this.c.set(B[_].uri.toString(),_)}compare(B,_){const re=B.getWorkspaceFolder(),U=_.getWorkspaceFolder();if(re&&U){let G=this.c.get(re.uri.toString());G=G===void 0?0:G+1;let Q=this.c.get(U.uri.toString());return Q=Q===void 0?0:Q+1,G===Q?B._label.localeCompare(_._label):G-Q}else return!re&&U?-1:re&&!U?1:0}}e.$NI=P;var C;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(C||(e.TaskEventKind=C={}));var p;(function(F){F.SingleRun="singleRun",F.Background="background"})(p||(e.TaskRunType=p={}));var v;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(v||(e.TaskRunSource=v={}));var N;(function(F){function B(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?p.Background:p.SingleRun,group:ue.configurationProperties.group,__task:ue}}function _(ue,ne,De){return{...B(ue),kind:C.Start,terminalId:ne,resolvedVariables:De}}F.start=_;function re(ue,ne,De){return{...B(ue),kind:C.ProcessStarted,terminalId:ne,processId:De}}F.processStarted=re;function U(ue,ne,De){return{...B(ue),kind:C.ProcessEnded,terminalId:ne,exitCode:De}}F.processEnded=U;function G(ue,ne,De){return{...B(ue),kind:C.Terminated,exitReason:De,terminalId:ne}}F.terminated=G;function Q(ue,ne,De){return{...B(ne),kind:ue,terminalId:De}}F.general=Q;function ee(){return{kind:C.Changed}}F.changed=ee})(N||(e.TaskEvent=N={}));var T;(function(F){function B(re){const U=Object.keys(re).sort();let G="";for(const Q of U){let ee=re[Q];ee instanceof Object?ee=B(ee):typeof ee=="string"&&(ee=ee.replace(/,/g,",,")),G+=Q+","+ee+","}return G}function _(re){const G={_key:B(re),type:re.taskType};return Object.assign(G,re),G}F.create=_})(T||(e.KeyedTaskIdentifier=T={}));var M;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(M||(e.TaskSettingId=M={}));var j;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var z;(function(F){function B(_,re){const U=O.$DI.get(_.type);if(U===void 0){const ue=R.$co(_);return delete ue._key,T.create(ue)}const G=Object.create(null);G.type=U.taskType;const Q=new Set;U.required.forEach(ue=>Q.add(ue));const ee=U.properties;for(const ue of Object.keys(ee)){const ne=_[ue];if(ne!=null)G[ue]=ne;else if(Q.has(ue)){const De=ee[ue];if(De.default!==void 0)G[ue]=R.$co(De.default);else switch(De.type){case"boolean":G[ue]=!1;break;case"number":case"integer":G[ue]=0;break;case"string":G[ue]="";break;default:re.error(r.localize(1,null,JSON.stringify(_,void 0,0),ue));return}}}return T.create(G)}F.createTaskIdentifier=B})(z||(e.TaskDefinition=z={}))}),define(Ee[325],Se([1,0,14]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0;class h{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,O)=>{this.b=L,this.d=O,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$3)(L))}then(L,O){return this.j().then(L,O)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$9bc=h;class A extends h{constructor(){super(),this.h=!0,this.i=new r.$7}}e.$0bc=A}),define(Ee[51],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qw=e.$Nw=void 0,e.$Ow=A,e.$Pw=R;class r{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++r.count}}e.$Nw=r;const h=[];function A(O){const $=new r(O);return h[$.nid]=$,$}function R(O){return h[O].sid}class L{constructor($){this.value=$}}e.$Qw=L}),define(Ee[6],Se([1,0,51]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$pN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var h;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(h||(e.TextEditorRevealType=h={}));var A;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput",c[c.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(A||(e.TabInputKind=A={}));var R;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var O;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(O||(e.WebviewMessageArrayBufferViewType=O={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var l;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var I;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output",c[c.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class E{static{this.a=0}static mixin(g){return g._id=E.a++,g}}e.$pN=E;var u;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var k;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$qN={MainThreadAuthentication:(0,r.$Ow)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Ow)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Ow)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Ow)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Ow)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Ow)("MainThreadChatVariables"),MainThreadClipboard:(0,r.$Ow)("MainThreadClipboard"),MainThreadCommands:(0,r.$Ow)("MainThreadCommands"),MainThreadComments:(0,r.$Ow)("MainThreadComments"),MainThreadConfiguration:(0,r.$Ow)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Ow)("MainThreadConsole"),MainThreadDebugService:(0,r.$Ow)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Ow)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Ow)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Ow)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Ow)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Ow)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Ow)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Ow)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Ow)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Ow)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Ow)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Ow)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Ow)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Ow)("MainThreadLanguages"),MainThreadLogger:(0,r.$Ow)("MainThreadLogger"),MainThreadMessageService:(0,r.$Ow)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Ow)("MainThreadOutputService"),MainThreadProgress:(0,r.$Ow)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Ow)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Ow)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Ow)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Ow)("MainThreadSecretState"),MainThreadStorage:(0,r.$Ow)("MainThreadStorage"),MainThreadSpeech:(0,r.$Ow)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Ow)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Ow)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Ow)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Ow)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Ow)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Ow)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Ow)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Ow)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Ow)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Ow)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Ow)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Ow)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Ow)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Ow)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Ow)("MainThreadSCM"),MainThreadSearch:(0,r.$Ow)("MainThreadSearch"),MainThreadShare:(0,r.$Ow)("MainThreadShare"),MainThreadTask:(0,r.$Ow)("MainThreadTask"),MainThreadWindow:(0,r.$Ow)("MainThreadWindow"),MainThreadLabelService:(0,r.$Ow)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Ow)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Ow)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Ow)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Ow)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Ow)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Ow)("MainThreadInteractive"),MainThreadTheming:(0,r.$Ow)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Ow)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Ow)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Ow)("MainThreadTimeline"),MainThreadTesting:(0,r.$Ow)("MainThreadTesting"),MainThreadLocalization:(0,r.$Ow)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Ow)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Ow)("MainThreadAiEmbeddingVector")},e.$rN={ExtHostCommands:(0,r.$Ow)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Ow)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Ow)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Ow)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Ow)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Ow)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Ow)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Ow)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Ow)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Ow)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Ow)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Ow)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Ow)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Ow)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Ow)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Ow)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Ow)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Ow)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Ow)("ExtHostStatusBar"),ExtHostShare:(0,r.$Ow)("ExtHostShare"),ExtHostExtensionService:(0,r.$Ow)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Ow)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Ow)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Ow)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Ow)("ExtHostSCM"),ExtHostSearch:(0,r.$Ow)("ExtHostSearch"),ExtHostTask:(0,r.$Ow)("ExtHostTask"),ExtHostWorkspace:(0,r.$Ow)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Ow)("ExtHostWindow"),ExtHostWebviews:(0,r.$Ow)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Ow)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Ow)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Ow)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Ow)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Ow)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Ow)("ExtHostProgress"),ExtHostComments:(0,r.$Ow)("ExtHostComments"),ExtHostSecretState:(0,r.$Ow)("ExtHostSecretState"),ExtHostStorage:(0,r.$Ow)("ExtHostStorage"),ExtHostUrls:(0,r.$Ow)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Ow)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Ow)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Ow)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Ow)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Ow)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Ow)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Ow)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Ow)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Ow)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Ow)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Ow)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Ow)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Ow)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.$Ow)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Ow)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Ow)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Ow)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Ow)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Ow)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Ow)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Ow)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Ow)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Ow)("ExtHostTimeline"),ExtHostTesting:(0,r.$Ow)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Ow)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Ow)("ExtHostLocalization")}}),define(Ee[96],Se([1,0,5,12,6,20]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=e.$Anc=void 0,A=We(A),e.$Anc=(0,r.$Fi)("IExtHostApiDeprecationService");let L=class{constructor($,l){this.c=l,this.a=new Set,this.b=$.getProxy(A.$qN.MainThreadTelemetry)}report($,l,I){const E=this.d($,l);this.a.has(E)||(this.a.add(E),l.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:$}))}d($,l){return`${$}-${l.identifier.value}`}};e.$Bnc=L,e.$Bnc=L=Je([Ve(0,R.$WP),Ve(1,h.$_j)],L),e.$Cnc=Object.freeze(new class{report(O,$,l){}})}),define(Ee[326],Se([1,0,6]),function(ce,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;class h{constructor(R){const L=R.getProxy(r.$qN.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(O){return L.$writeText(O)}})}}e.$Pnc=h}),define(Ee[327],Se([1,0,25,6,30,20]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;let L=class{constructor(I,E){this.a=I.getProxy(h.$qN.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,E){const u=this,k=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){u.e(I,E,k,arguments)}})}e(I,E,u,k){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:$(k,this.b)}),this.c&&this.f(I,u,k)}};e.$Kpc=L,e.$Kpc=L=Je([Ve(0,R.$WP),Ve(1,A.$aQ)],L);const O=1e5;function $(l,I){const E=[];if(l.length)for(let u=0;u<l.length;u++){let k=l[u];if(typeof k>"u")k="undefined";else if(k instanceof Error){const b=k;b.stack?k=b.stack:k=b.toString()}E.push(k)}if(I){const u=new Error().stack;u&&E.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,r.$ho)(E);return u.length>O?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ee[328],Se([1,0,2,6,26]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=void 0;class R{constructor(O){this.a=O.getProxy(h.$qN.MainThreadDialogs)}showOpenDialog(O,$){return $?.allowUIResources&&(0,A.$5G)(O,"showLocal"),this.a.$showOpenDialog($).then(l=>l?l.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(O){return this.a.$showSaveDialog(O).then($=>$?r.URI.revive($):void 0)}}e.$Roc=R}),define(Ee[329],Se([1,0,21,4,3,6]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class L{constructor($){this.b=new Map,this.c=new h.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(R.$qN.MainThreadEmbeddings)}registerEmbeddingsProvider($,l,I){if(this.d.has(l))throw new Error("An embeddings provider for this model is already registered");const E=this.e++;return this.a.$registerEmbeddingProvider(E,l),this.b.set(E,{id:l,provider:I}),(0,A.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(E),this.b.delete(E)})}async computeEmbeddings($,l,I){I??=r.CancellationToken.None;let E=!1;typeof l=="string"&&(l=[l],E=!0);const u=await this.a.$computeEmbeddings($,l,I);if(u.length!==l.length)throw new Error;if(E){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,l,I){const E=this.b.get($);if(!E)return[];const u=await E.provider.provideEmbeddings(l,I);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$Uoc=L}),define(Ee[330],Se([1,0,3,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;class A{constructor(L){this.b=0,this.a=L.getProxy(h.$qN.MainThreadLabelService)}$registerResourceLabelFormatter(L){const O=this.b++;return this.a.$registerResourceLabelFormatter(O,L),(0,r.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(O)})}}e.$_oc=A}),define(Ee[123],Se([1,0,11,13,2,5,12,6,30,20]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$uoc=void 0;let I=class{constructor(u,k,b){this.f=b,this.d=new Map,this.a=k.getProxy(O.$qN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===r.$g}getMessage(u,k){const{message:b,args:c,comment:g}=k;if(this.c)return(0,h.$ff)(b,c??{});let d=b;g&&g.length>0&&(d+=`/${Array.isArray(g)?g.join(""):g}`);const m=this.d.get(u)?.contents[d];return m||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,h.$ff)(m??b,c??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let k;const b=await this.g(u);if(!b){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(b),g=JSON.parse(c);k=u.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${u.identifier.value} from ${b}: ${c.message}`);return}k&&this.d.set(u.identifier.value,{contents:k,uri:b})}async g(u){if(u.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return A.URI.revive(k)}return u.l10n?A.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$uoc=I,e.$uoc=I=Je([Ve(0,$.$aQ),Ve(1,l.$WP),Ve(2,L.$_j)],I),e.$voc=(0,R.$Fi)("IExtHostLocalizationService")}),define(Ee[160],Se([1,0,12,6,30,20,2,57]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;let $=class extends r.$kk{constructor(E,u){super(u.logLevel,u.logsLocation,u.loggers.map(k=>(0,O.$ci)(k))),this.r=E.getProxy(h.$qN.MainThreadLogger)}$setLogLevel(E,u){u?this.setLogLevel(L.URI.revive(u),E):this.setLogLevel(E)}setVisibility(E,u){super.setVisibility(E,u),this.r.$setVisibility(E,u)}s(E,u,k){return new l(this.r,E,u,k)}};e.$Jpc=$,e.$Jpc=$=Je([Ve(0,R.$WP),Ve(1,A.$aQ)],$);class l extends r.$fk{constructor(E,u,k,b){super(b?.logLevel==="always"),this.r=E,this.s=u,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(u,b).then(()=>{this.u(this.n),this.m=!0})}g(E,u){const k=[[E,u]];this.m?this.u(k):this.n.push(...k)}u(E){this.r.$log(this.s,E)}flush(){this.r.$flush(this.s)}}}),define(Ee[124],Se([1,0,6,5,3,20,22]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,e.$woc=(0,h.$Fi)("IExtHostManagedSockets");let O=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(r.$qN.MainThreadManagedSockets)}setFactory(E,u){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(E,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const u=++this.b,k=await this.c.makeConnection(),b=new A.$Vc;return this.d.set(u,new l(u,k,b)),b.add((0,A.$Uc)(()=>this.d.delete(u))),b.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),b.dispose()})),b.add(k.onDidClose(c=>{this.a.$onDidManagedSocketClose(u,c?.stack??c?.message),b.dispose()})),b.add(k.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(u,L.$Oe.wrap(c)))),u}$remoteSocketWrite(E,u){this.d.get(E)?.actual.send(u.buffer)}$remoteSocketEnd(E){const u=this.d.get(E);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$xoc=O,e.$xoc=O=Je([Ve(0,R.$WP)],O);class ${constructor(E,u){this.socketFactoryId=E,this.makeConnection=u}}class l extends A.$Wc{constructor(E,u,k){super(),this.socketId=E,this.actual=u,this.B(k)}}}),define(Ee[331],Se([1,0,6,12,26]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0;function R(O){return O&&O.title}let L=class{constructor($,l){this.b=l,this.a=$.getProxy(r.$qN.MainThreadMessageService)}showMessage($,l,I,E,u){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let b;typeof E=="string"||R(E)?b=[E,...u]:(k.modal=E?.modal,k.useCustom=E?.useCustom,k.detail=E?.detail,b=u),k.useCustom&&(0,A.$5G)($,"resolvers");const c=[];let g=!1;for(let d=0;d<b.length;d++){const m=b[d];if(typeof m=="string")c.push({title:m,handle:d,isCloseAffordance:!1});else if(typeof m=="object"){const{title:n,isCloseAffordance:o}=m;c.push({title:n,isCloseAffordance:!!o,handle:d}),o&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,m):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,m)}return this.a.$showMessage(l,I,k,c).then(d=>{if(typeof d=="number")return b[d]})}};e.$bpc=L,e.$bpc=L=Je([Ve(1,h.$_j)],L)}),define(Ee[332],Se([1,0,3,18,2,26,6]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0;class O{constructor(l){this.b=new Map,this.a=l.getProxy(L.$qN.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,I,E){if((0,R.$5G)(l,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,E),this.a.$registerProfileContentHandler(I,E.name,E.description,l.identifier.value),(0,r.$Uc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(l,I,E,u){const k=this.b.get(l);if(!k)throw new Error(`Unknown handler with id: ${l}`);return k.saveProfile(I,E,u)}async $readProfile(l,I,E){const u=this.b.get(l);if(!u)throw new Error(`Unknown handler with id: ${l}`);return u.readProfile((0,h.$fg)(I)?I:A.URI.revive(I),E)}}e.$kpc=O}),define(Ee[125],Se([1,0,6,4,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=e.$roc=void 0;class R{constructor(O){this.b=new h.$me,this.onDidChangePassword=this.b.event,this.a=O.getProxy(r.$qN.MainThreadSecretState)}async $onDidChangePassword(O){this.b.fire(O)}get(O,$){return this.a.$getPassword(O,$)}store(O,$,l){return this.a.$setPassword(O,$,l)}delete(O,$){return this.a.$deletePassword(O,$)}}e.$roc=R,e.$soc=(0,A.$Fi)("IExtHostSecretState")}),define(Ee[333],Se([1,0,21,3,6]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;class R{static{this.a=1}constructor(O){this.c=new Map,this.d=new Map,this.f=new Map,this.b=O.getProxy(A.$qN.MainThreadSpeech)}async $createSpeechToTextSession(O,$,l){const I=this.c.get(O);if(!I)return;const E=new h.$Vc,u=new r.$xe;this.d.set($,u);const k=await I.provideSpeechToTextSession(u.token,l?{language:l}:void 0);k&&(E.add(k.onDidChange(b=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,b)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $cancelSpeechToTextSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}async $createTextToSpeechSession(O,$,l){const I=this.c.get(O);if(!I)return;const E=new h.$Vc,u=new r.$xe;this.d.set($,u);const k=await I.provideTextToSpeechSession(u.token,l?{language:l}:void 0);k&&(this.f.set($,k),E.add(k.onDidChange(b=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,b)})),E.add(u.token.onCancellationRequested(()=>E.dispose())))}async $synthesizeSpeech(O,$){this.f.get(O)?.synthesize($)}async $cancelTextToSpeechSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O),this.f.delete(O)}async $createKeywordRecognitionSession(O,$){const l=this.c.get(O);if(!l)return;const I=new h.$Vc,E=new r.$xe;this.d.set($,E);const u=await l.provideKeywordRecognitionSession(E.token);u&&(I.add(u.onDidChange(k=>{E.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),I.add(E.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(O){this.d.get(O)?.dispose(!0),this.d.delete(O)}registerProvider(O,$,l){const I=R.a++;return this.c.set(I,l),this.b.$registerProvider(I,$,{extension:O,displayName:O.value}),(0,h.$Uc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$rpc=R}),define(Ee[126],Se([1,0,6,4,5]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0;class R{constructor(O,$){this.c=$,this.b=new h.$me,this.onDidChangeStorage=this.b.event,this.a=O.getProxy(r.$qN.MainThreadStorage)}registerExtensionStorageKeysToSync(O,$){this.a.$registerExtensionStorageKeysToSync(O,$)}async initializeExtensionStorage(O,$,l){const I=await this.a.$initializeExtensionStorage(O,$);let E;return I&&(E=this.d(O,$,I)),E||l}setValue(O,$,l){return this.a.$setValue(O,$,l)}$acceptValue(O,$,l){const I=this.d(O,$,l);I&&this.b.fire({shared:O,key:$,value:I})}d(O,$,l){try{return JSON.parse(l)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${O}): ${I}`)}}}e.$hoc=R,e.$ioc=(0,A.$Fi)("IExtHostStorage")}),define(Ee[334],Se([1,0,3,15,2,6]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class L{static{this.a=new Set([h.Schemas.http,h.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(R.$qN.MainThreadUriOpeners)}registerExternalUriOpener($,l,I,E){if(this.c.has(l))throw new Error(`Opener with id '${l}' already registered`);const u=E.schemes.find(k=>!L.a.has(k));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(l,I),this.b.$registerUriOpener(l,E.schemes,$,E.label),(0,r.$Uc)(()=>{this.c.delete(l),this.b.$unregisterUriOpener(l)})}async $canOpenUri($,l,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener with id: ${$}`);const u=A.URI.revive(l);return E.canOpenExternalUri(u,I)}async $openUri($,l,I){const E=this.c.get($);if(!E)throw new Error(`Unknown opener id: '${$}'`);return E.openExternalUri(A.URI.revive(l.resolvedUri),{sourceUri:A.URI.revive(l.sourceUri)},I)}}e.$Dpc=L}),define(Ee[335],Se([1,0,6,2,3,14,24]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class O{static{this.a=0}constructor(l){this.c=new L.$rn,this.d=new Map,this.b=l.getProxy(r.$qN.MainThreadUrls)}registerUriHandler(l,I){const E=l.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const u=O.a++;return this.c.add(E),this.d.set(u,I),this.b.$registerUriHandler(u,E,l.displayName||l.name),(0,A.$Uc)(()=>{this.c.delete(E),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(l,I){const E=this.d.get(l);if(!E)return Promise.resolve(void 0);try{E.handleUri(h.URI.revive(I))}catch(u){(0,R.$3)(u)}return Promise.resolve(void 0)}async createAppUri(l){return h.URI.revive(await this.b.$createAppUri(l))}}e.$Epc=O}),define(Ee[336],Se([1,0,22,6]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ysb=R,e.$Zsb=O,h=We(h);class A{constructor(){this.buffers=[]}add(l){let I=this.buffers.indexOf(l);return I<0&&(I=this.buffers.length,this.buffers.push(l)),I}}function R($,l){if(l.serializeBuffersForPostMessage){const I=new A,u=JSON.stringify($,(b,c)=>{if(c instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(c)};if(ArrayBuffer.isView(c)){const g=L(c);if(g)return{$$vscode_array_buffer_reference$$:!0,index:I.add(c.buffer),view:{type:g,byteLength:c.byteLength,byteOffset:c.byteOffset}}}return c}),k=I.buffers.map(b=>{const c=new Uint8Array(b);return r.$Oe.wrap(c)});return{message:u,buffers:k}}else return{message:JSON.stringify($),buffers:[]}}function L($){switch($.constructor.name){case"Int8Array":return h.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return h.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return h.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return h.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return h.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return h.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return h.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return h.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return h.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return h.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return h.WebviewMessageArrayBufferViewType.BigUint64Array}}function O($,l){const I=l.map(k=>{const b=new ArrayBuffer(k.byteLength);return new Uint8Array(b).set(k.buffer),b}),E=l.length?(k,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const c=b,{index:g}=c,d=I[g];if(c.view)switch(c.view.type){case h.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(d,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(d,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(d,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(d,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(d,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(d,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(d,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(d,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(d,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(d,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case h.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(d,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return b}:void 0;return{message:JSON.parse($,E),arrayBuffers:I}}}),define(Ee[97],Se([1,0,4,3,15,25,2,263,336,122,6]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=e.$5nc=void 0,e.$6nc=u,e.$8nc=c,e.$9nc=g,R=We(R),I=We(I);class E{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(o,i,t,s,f,a,w){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new r.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new r.$me,this._onDidDispose=this.#h.event,this.#e=o,this.#t=i,this.#o=t,this.#n=s,this.#s=f,this.#r=a,this.#u=u(a),this.#d=k(a),this.#i=w}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#l=!0,(0,l.$FCb)(o,this.#n)}get cspSource(){const o=this.#r.extensionLocation;if(o.scheme===A.Schemas.https||o.scheme===A.Schemas.http){let i=o.toString();return i.endsWith("/")||(i+="/"),i+" "+l.$ECb}return l.$ECb}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#o}set options(o){this.a(),R.$go(this.#o,o)||this.#t.$setOptions(this.#e,g(this.#r,this.#s,o)),this.#o=o}async postMessage(o){if(this.#c)return!1;const i=(0,$.$Ysb)(o,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const i=this.#r.extensionLocation?.scheme===A.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===A.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,f,a,w,y,S)=>{const D=L.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),P=(0,l.$FCb)(D,{isRemote:i,authority:t}).toString();return`${f}${P}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,f,a,w,y,S)=>{const D=L.URI.from({scheme:w||"file",path:decodeURIComponent(y)}),P=(0,l.$FCb)(D,{isRemote:i,authority:t}).toString();return`${f}${P}${S}`})}}e.$5nc=E;function u(n){try{const o=(0,O.$Wp)((0,O.$Vp)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}function k(n){try{const o=(0,O.$Wp)((0,O.$Vp)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class b extends h.$Wc{constructor(o,i,t,s,f){super(),this.c=i,this.f=t,this.g=s,this.h=f,this.b=new Map,this.a=o.getProxy(I.$qN.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,i,t){const s=this.j(o);if(s){const{message:f}=(0,$.$Zsb)(i,t.value);s._onMessageEmitter.fire(f)}}$onMissingCsp(o,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,i,t){const s=new E(o,this.a,d(i),this.c,this.f,t,this.h);this.b.set(o,s);const f=s._onDidDispose(()=>{f.dispose(),this.deleteWebview(o)});return s}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$7nc=b;function c(n){return{id:n.identifier,location:n.extensionLocation}}function g(n,o,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||m(n,o)}}function d(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>L.URI.from(o))}}function m(n,o){return[...(o?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(Ee[161],Se([1,0,4,15,13,2,5,20,6]),function(ce,e,r,h,A,R,L,O,$){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0;let I=class{static{l=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new r.$me,this.onDidChangeWindowState=this.c.event,this.d=l.a,this.b=u.getProxy($.$qN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:b})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,k){k!==this.d[u]&&(this.d={...this.d,[u]:k},this.c.fire(this.d))}openUri(u,k){let b;if(typeof u=="string"){b=u;try{u=R.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,A.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===h.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,b,k)}async asExternalUri(u,k){if((0,A.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(u,k);return R.URI.from(b)}};e.$Gpc=I,e.$Gpc=I=l=Je([Ve(0,O.$WP)],I),e.$Hpc=(0,L.$Fi)("IExtHostWindow")}),define(Ee[337],Se([1,0,327,30,20,94]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqc=void 0;const L=1024*1024;let O=class extends r.$Kpc{constructor(l,I){super(l,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(l,I,E){const u=l==="error"||l==="warn"?process.stderr:process.stdout;this.g=!0,u.write(`
${R.NativeLogMarkers.Start}
`),I.apply(console,E),u.write(`
${R.NativeLogMarkers.End}
`),this.g=!1}j(l,I){const E=process[l],u=E.write;let k="";Object.defineProperty(E,"write",{set:()=>{},get:()=>(b,c,g)=>{if(!this.g){k+=b.toString(c);const d=k.length>L?k.length:k.lastIndexOf(`
`);d!==-1&&(console[I](k.slice(0,d)),k=k.slice(d+1))}u.call(E,b,c,g)}})}};e.$jqc=O,e.$jqc=O=Je([Ve(0,A.$WP),Ve(1,h.$aQ)],O)}),define(Ee[338],Se([1,0,160,15,279,32]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vqc=void 0;class L extends r.$Jpc{s($,l,I){return $.scheme===h.Schemas.file?new A.$_Q(I?.name||(0,R.$2g)(),$.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,l):super.s($,l,I)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$vqc=L}),define(Ee[339],Se([1,0,9,22,21,27,14,4,3,41,142,325,51]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.ResponsiveState=e.RequestInitiator=void 0,e.$$bc=m,e.$_bc=n,L=We(L);function b(N,T){try{return JSON.stringify(N,T)}catch{return"null"}}const c="$$ref$$",g={[c]:-1};class d{constructor(T,M){this.jsonString=T,this.referencedBuffers=M}}function m(N,T=null,M=!1){const j=[];return{jsonString:(M?b:JSON.stringify)(N,(F,B)=>{if(typeof B>"u")return g;if(typeof B=="object"){if(B instanceof h.$Oe){const _=j.push(B)-1;return{[c]:_}}if(T)return T(F,B)}return B}),referencedBuffers:j}}function n(N,T,M){return JSON.parse(N,(j,z)=>{if(z){const F=z[c];if(typeof F=="number")return T[F];if(M&&z.$mid===l.MarshalledId.Uri)return M.transformIncoming(z)}return z})}function o(N,T){return JSON.stringify(N,T)}function i(N){return N?(T,M)=>M&&M.$mid===l.MarshalledId.Uri?N.transformOutgoing(M):M:null}var t;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var s;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const f=()=>{},a=Symbol.for("rpcProtocol"),w=Symbol.for("rpcProxy");class y extends $.$Wc{static{k=a}static{this.a=3*1e3}constructor(T,M=null,j=null){super(),this[k]=!0,this.b=this.B(new O.$me),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=M,this.g=j,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,F=u.$Nw.count;z<F;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=s.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(z=>this.L(z)))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const M=this.w[T];delete this.w[T],M.resolveErr(L.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(s.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(s.Unresponsive):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,I.$Mn)(T,this.g):T}getProxy(T){const{nid:M,sid:j}=T;return this.s[M]||(this.s[M]=this.J(M,j)),this.s[M]}J(T,M){const j={get:(z,F)=>(typeof F=="string"&&!z[F]&&F.charCodeAt(0)===R.CharCode.DollarSign&&(z[F]=(...B)=>this.U(T,F,B)),F===w?M:z[F])};return new Proxy(Object.create(null),j)}set(T,M){return this.m[T.nid]=M,M}assertRegistered(T){for(let M=0,j=T.length;M<j;M++){const z=T[M];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(T){if(this.j)return;const M=T.byteLength,j=D.read(T,0),z=j.readUInt8(),F=j.readUInt32();switch(z){case p.RequestJSONArgs:case p.RequestJSONArgsWithCancellation:{let{rpcId:B,method:_,args:re}=C.deserializeRequestJSONArgs(j);this.g&&(re=(0,I.$Mn)(re,this.g)),this.M(M,F,B,_,re,z===p.RequestJSONArgsWithCancellation);break}case p.RequestMixedArgs:case p.RequestMixedArgsWithCancellation:{let{rpcId:B,method:_,args:re}=C.deserializeRequestMixedArgs(j);this.g&&(re=(0,I.$Mn)(re,this.g)),this.M(M,F,B,_,re,z===p.RequestMixedArgsWithCancellation);break}case p.Acknowledged:{this.f?.logIncoming(M,F,t.LocalSide,"ack"),this.G(F);break}case p.Cancel:{this.N(M,F);break}case p.ReplyOKEmpty:{this.O(M,F,void 0);break}case p.ReplyOKJSON:{let B=C.deserializeReplyOKJSON(j);this.g&&(B=(0,I.$Mn)(B,this.g)),this.O(M,F,B);break}case p.ReplyOKJSONWithBuffers:{const B=C.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(M,F,B);break}case p.ReplyOKVSBuffer:{const B=C.deserializeReplyOKVSBuffer(j);this.O(M,F,B);break}case p.ReplyErrError:{let B=C.deserializeReplyErrError(j);this.g&&(B=(0,I.$Mn)(B,this.g)),this.P(M,F,B);break}case p.ReplyErrEmpty:{this.P(M,F,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,M,j,z,F,B){this.f?.logIncoming(T,M,t.OtherSide,`receiveRequest ${(0,u.$Pw)(j)}.${z}(`,F);const _=String(M);let re,U;if(B){const Q=new A.$xe;F.push(Q.token),re=this.Q(j,z,F),U=()=>Q.cancel()}else re=this.Q(j,z,F),U=f;this.u[_]=U;const G=C.serializeAcknowledged(M);this.f?.logOutgoing(G.byteLength,M,t.OtherSide,"ack"),this.c.send(G),re.then(Q=>{delete this.u[_];const ee=C.serializeReplyOK(M,Q,this.h);this.f?.logOutgoing(ee.byteLength,M,t.OtherSide,"reply:",Q),this.c.send(ee)},Q=>{delete this.u[_];const ee=C.serializeReplyErr(M,Q);this.f?.logOutgoing(ee.byteLength,M,t.OtherSide,"replyErr:",Q),this.c.send(ee)})}N(T,M){this.f?.logIncoming(T,M,t.OtherSide,"receiveCancel");const j=String(M);this.u[j]?.()}O(T,M,j){this.f?.logIncoming(T,M,t.LocalSide,"receiveReply:",j);const z=String(M);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z],F.resolveOk(j)}P(T,M,j){this.f?.logIncoming(T,M,t.LocalSide,"receiveReplyErr:",j);const z=String(M);if(!this.w.hasOwnProperty(z))return;const F=this.w[z];delete this.w[z];let B;j&&(j.$isError?(B=new Error,B.name=j.name,B.message=j.message,B.stack=j.stack):B=j),F.resolveErr(B)}Q(T,M,j){try{return Promise.resolve(this.S(T,M,j))}catch(z){return Promise.reject(z)}}S(T,M,j){const z=this.m[T];if(!z)throw new Error("Unknown actor "+(0,u.$Pw)(T));const F=z[M];if(typeof F!="function")throw new Error("Unknown method "+M+" on actor "+(0,u.$Pw)(T));return F.apply(z,j)}U(T,M,j){if(this.j)return new E.$0bc;let z=null;if(j.length>0&&A.CancellationToken.isCancellationToken(j[j.length-1])&&(z=j.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$8());const F=C.serializeRequestArguments(j,this.h),B=++this.t,_=String(B),re=new E.$9bc,U=new $.$Vc;z&&U.add(z.onCancellationRequested(()=>{const Q=C.serializeCancel(B);this.f?.logOutgoing(Q.byteLength,B,t.LocalSide,"cancel"),this.c.send(C.serializeCancel(B))})),this.w[_]=new S(re,U),this.F(B);const G=C.serializeRequest(B,T,M,F,!!z);return this.f?.logOutgoing(G.byteLength,B,t.LocalSide,`request: ${(0,u.$Pw)(T)}.${M}(`,j),this.c.send(G),re}}e.$acc=y;class S{constructor(T,M){this.a=T,this.b=M}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class D{static alloc(T,M,j){const z=new D(h.$Oe.alloc(j+1+4),0);return z.writeUInt8(T),z.writeUInt32(M),z}static read(T,M){return new D(T,M)}get buffer(){return this.a}constructor(T,M){this.a=T,this.b=M}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+T).toString();return this.b+=T,j}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+T).toString();return this.b+=T,j}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+T);return this.b+=T,M}static sizeMixedArray(T){let M=0;M+=1;for(let j=0,z=T.length;j<z;j++){const F=T[j];switch(M+=1,F.type){case v.String:M+=this.sizeLongString(F.value);break;case v.VSBuffer:M+=this.sizeVSBuffer(F.value);break;case v.SerializedObjectWithBuffers:M+=this.sizeUInt32,M+=this.sizeLongString(F.value);for(let B=0;B<F.buffers.length;++B)M+=this.sizeVSBuffer(F.buffers[B]);break;case v.Undefined:break}}return M}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let M=0,j=T.length;M<j;M++){const z=T[M];switch(z.type){case v.String:this.writeUInt8(v.String),this.writeLongString(z.value);break;case v.VSBuffer:this.writeUInt8(v.VSBuffer),this.writeVSBuffer(z.value);break;case v.SerializedObjectWithBuffers:this.writeUInt8(v.SerializedObjectWithBuffers),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let F=0;F<z.buffers.length;++F)this.writeBuffer(z.buffers[F]);break;case v.Undefined:this.writeUInt8(v.Undefined);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const M=new Array(T);for(let j=0;j<T;j++)switch(this.readUInt8()){case v.String:M[j]=this.readLongString();break;case v.VSBuffer:M[j]=this.readVSBuffer();break;case v.SerializedObjectWithBuffers:{const F=this.readUInt32(),B=this.readLongString(),_=[];for(let re=0;re<F;++re)_.push(this.readVSBuffer());M[j]=new u.$Qw(n(B,_,null));break}case v.Undefined:M[j]=void 0;break}return M}}var P;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(P||(P={}));class C{static a(T){for(let M=0,j=T.length;M<j;M++)if(T[M]instanceof h.$Oe||T[M]instanceof u.$Qw||typeof T[M]>"u")return!0;return!1}static serializeRequestArguments(T,M){if(this.a(T)){const j=[];for(let z=0,F=T.length;z<F;z++){const B=T[z];if(B instanceof h.$Oe)j[z]={type:v.VSBuffer,value:B};else if(typeof B>"u")j[z]={type:v.Undefined};else if(B instanceof u.$Qw){const{jsonString:_,referencedBuffers:re}=m(B.value,M);j[z]={type:v.SerializedObjectWithBuffers,value:h.$Oe.fromString(_),buffers:re}}else j[z]={type:v.String,value:h.$Oe.fromString(o(B,M))}}return{type:P.Mixed,args:j}}return{type:P.Simple,args:o(T,M)}}static serializeRequest(T,M,j,z,F){switch(z.type){case P.Simple:return this.b(T,M,j,z.args,F);case P.Mixed:return this.c(T,M,j,z.args,F)}}static b(T,M,j,z,F){const B=h.$Oe.fromString(j),_=h.$Oe.fromString(z);let re=0;re+=D.sizeUInt8(),re+=D.sizeShortString(B),re+=D.sizeLongString(_);const U=D.alloc(F?p.RequestJSONArgsWithCancellation:p.RequestJSONArgs,T,re);return U.writeUInt8(M),U.writeShortString(B),U.writeLongString(_),U.buffer}static deserializeRequestJSONArgs(T){const M=T.readUInt8(),j=T.readShortString(),z=T.readLongString();return{rpcId:M,method:j,args:JSON.parse(z)}}static c(T,M,j,z,F){const B=h.$Oe.fromString(j);let _=0;_+=D.sizeUInt8(),_+=D.sizeShortString(B),_+=D.sizeMixedArray(z);const re=D.alloc(F?p.RequestMixedArgsWithCancellation:p.RequestMixedArgs,T,_);return re.writeUInt8(M),re.writeShortString(B),re.writeMixedArray(z),re.buffer}static deserializeRequestMixedArgs(T){const M=T.readUInt8(),j=T.readShortString(),z=T.readMixedArray(),F=new Array(z.length);for(let B=0,_=z.length;B<_;B++){const re=z[B];typeof re=="string"?F[B]=JSON.parse(re):F[B]=re}return{rpcId:M,method:j,args:F}}static serializeAcknowledged(T){return D.alloc(p.Acknowledged,T,0).buffer}static serializeCancel(T){return D.alloc(p.Cancel,T,0).buffer}static serializeReplyOK(T,M,j){if(typeof M>"u")return this.d(T);if(M instanceof h.$Oe)return this.e(T,M);if(M instanceof u.$Qw){const{jsonString:z,referencedBuffers:F}=m(M.value,j,!0);return this.g(T,z,F)}else return this.f(T,b(M,j))}static d(T){return D.alloc(p.ReplyOKEmpty,T,0).buffer}static e(T,M){let j=0;j+=D.sizeVSBuffer(M);const z=D.alloc(p.ReplyOKVSBuffer,T,j);return z.writeVSBuffer(M),z.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,M){const j=h.$Oe.fromString(M);let z=0;z+=D.sizeLongString(j);const F=D.alloc(p.ReplyOKJSON,T,z);return F.writeLongString(j),F.buffer}static g(T,M,j){const z=h.$Oe.fromString(M);let F=0;F+=D.sizeUInt32,F+=D.sizeLongString(z);for(const _ of j)F+=D.sizeVSBuffer(_);const B=D.alloc(p.ReplyOKJSONWithBuffers,T,F);B.writeUInt32(j.length),B.writeLongString(z);for(const _ of j)B.writeBuffer(_);return B.buffer}static deserializeReplyOKJSON(T){const M=T.readLongString();return JSON.parse(M)}static deserializeReplyOKJSONWithBuffers(T,M){const j=T.readUInt32(),z=T.readLongString(),F=[];for(let B=0;B<j;++B)F.push(T.readVSBuffer());return new u.$Qw(n(z,F,M))}static serializeReplyErr(T,M){const j=M?b(L.$5(M),null):void 0;if(typeof j!="string")return this.h(T);const z=h.$Oe.fromString(j);let F=0;F+=D.sizeLongString(z);const B=D.alloc(p.ReplyErrError,T,F);return B.writeLongString(z),B.buffer}static deserializeReplyErrError(T){const M=T.readLongString();return JSON.parse(M)}static h(T){return D.alloc(p.ReplyErrEmpty,T,0).buffer}}var p;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var v;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(v||(v={}))}),define(Ee[340],Se([1,0,22,29,15,89,5]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$MK=void 0,e.$NK=I,e.$OK=E,e.$MK=(0,L.$Fi)("notebookDocumentService");const O=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${O.join("")}]+`),l=7;function I(k){if(k.scheme!==A.Schemas.vscodeNotebookCell)return;const b=k.fragment.indexOf("s");if(b<0)return;const c=parseInt(k.fragment.substring(0,b).replace($,""),l),g=(0,r.$8e)(k.fragment.substring(b+1)).toString();if(!isNaN(c))return{handle:c,notebook:k.with({scheme:g,fragment:null})}}function E(k,b){const c=b.toString(l),d=`${c.length<O.length?O[c.length-1]:"z"}${c}s${(0,r.$9e)(r.$Oe.fromString(k.scheme),!0,!0)}`;return k.with({scheme:A.Schemas.vscodeNotebookCell,fragment:d})}class u{constructor(){this.a=new h.$Cc}getNotebook(b){if(b.scheme===A.Schemas.vscodeNotebookCell){const c=I(b);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(b)}addNotebookDocument(b){this.a.set(b.uri,b)}removeNotebookDocument(b){this.a.delete(b.uri)}}e.$PK=u,(0,R.$Ls)(e.$MK,u,R.InstantiationType.Delayed)}),define(Ee[127],Se([1,0,22,39,40,108,15,16,11,36,340]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$uL=e.CellStatusbarAlignment=e.$tL=e.NotebookEditorPriority=e.$qL=e.$pL=e.$nL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$mL=e.$lL=e.$kL=e.$jL=e.CellKind=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=void 0,e.$oL=s,e.$rL=a,e.$sL=w,e.$vL=D,e.$wL=C,h=We(h),e.$eL="workbench.editor.notebook",e.$fL="workbench.editor.notebookTextDiffEditor",e.$gL="workbench.editor.interactive",e.$hL="workbench.editor.repl",e.$iL="replNotebook.input.execute";var E;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(E||(e.CellKind=E={})),e.$jL=["application/json","application/javascript","text/html","image/svg+xml",R.$5s.latex,R.$5s.markdown,"image/png","image/jpeg",R.$5s.text],e.$kL=[R.$5s.latex,R.$5s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$5s.text],e.$lL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$mL="_notAvailable";var u;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var k;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var b;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var c;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var d;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var m;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(m||(e.SelectionStateType=m={}));var n;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(B){B.scheme=L.Schemas.vscodeNotebookCell;function _(ue,ne){return(0,I.$OK)(ue,ne)}B.generate=_;function re(ue){return(0,I.$NK)(ue)}B.parse=re;function U(ue,ne){return ue.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${ue.scheme!==L.Schemas.file?ue.scheme:""}`})}B.generateCellOutputUri=U;function G(ue){if(ue.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ue.fragment);if(!ne)return;const De=ne[1]&&ne[1]!==""?ne[1]:void 0,$e=ne[2];return{outputId:De,notebook:ue.with({scheme:$e||L.Schemas.file,fragment:null})}}B.parseCellOutputUri=G;function Q(ue,ne,De){return B.generate(ue,ne).with({scheme:De})}B.generateCellPropertyUri=Q;function ee(ue,ne){if(ue.scheme===ne)return B.parse(ue.with({scheme:B.scheme}))}B.parseCellPropertyUri=ee})(o||(e.CellUri=o={}));const i=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(_=[],re=e.$jL){this.e=re,this.d=[...new Set(_)].map(U=>({pattern:U,matches:h.$zk(i(U))}))}sort(_){const re=new Map(A.Iterable.map(_,G=>[G,i(G)]));let U=[];for(const{matches:G}of this.d)for(const[Q,ee]of re)if(G(ee)){U.push(Q),re.delete(Q);break}return re.size&&(U=U.concat([...re.keys()].sort((G,Q)=>this.e.indexOf(G)-this.e.indexOf(Q)))),U}prioritize(_,re){const U=this.f(_);if(U===-1){this.d.unshift({pattern:_,matches:h.$zk(i(_))});return}const G=new Set(re.map(ee=>this.f(ee,U)));G.delete(-1);const Q=Array.from(G).sort();this.d.splice(U+1,0,...Q.map(ee=>this.d[ee]));for(let ee=Q.length-1;ee>=0;ee--)this.d.splice(Q[ee],1)}toArray(){return this.d.map(_=>_.pattern)}f(_,re=this.d.length){const U=i(_);for(let G=0;G<re;G++)if(this.d[G].matches(U))return G;return-1}}e.$nL=t;function s(B,_,re,U=(G,Q)=>G===Q){const G=[];function Q(ne,De,$e){if(De===0&&$e.length===0)return;const K=G[G.length-1];K&&K.start+K.deleteCount===ne?(K.deleteCount+=De,K.toInsert.push(...$e)):G.push({start:ne,deleteCount:De,toInsert:$e})}let ee=0,ue=0;for(;;){if(ee===B.length){Q(ee,0,_.slice(ue));break}if(ue===_.length){Q(ee,B.length-ee,[]);break}const ne=B[ee],De=_[ue];if(U(ne,De)){ee+=1,ue+=1;continue}re(De)?(Q(ee,1,[]),ee+=1):(Q(ee,0,[De]),ue+=1)}return G}e.$pL=new l.$Wj("notebookEditorCursorAtBoundary","none"),e.$qL=new l.$Wj("notebookEditorCursorAtLineBoundary","none");var f;(function(B){B.default="default",B.option="option"})(f||(e.NotebookEditorPriority=f={}));function a(B){const _=B;return!!((typeof _.include=="string"||h.$Ak(_.include))&&(typeof _.exclude=="string"||h.$Ak(_.exclude)))}function w(B,_,re){if(Array.isArray(B.viewType)&&B.viewType.indexOf(_)>=0||B.viewType===_)return!0;if(B.filenamePattern){const U=a(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,G=a(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(h.$yk(U,(0,O.$pc)(re.fsPath).toLowerCase()))return!(G&&h.$yk(G,(0,O.$pc)(re.fsPath).toLowerCase()))}return!1}e.$tL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class S{static{this.d="notebook/"}static create(_){return`${S.d}${_}`}static parse(_){if(_.startsWith(S.d))return _.substring(S.d.length)}}e.$uL=S;function D(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const P=new TextDecoder;function C(B){const _=[];let re=!1;for(const ee of B)(_.length===0||re)&&(_.push(ee),re=!0);let U=N(_);const G=r.$Oe.concat(_.map(ee=>r.$Oe.wrap(ee))),Q=F(G);return U=U||Q.byteLength!==G.byteLength,{data:Q,didCompression:U}}e.$xL="\x1B[A";const p=e.$xL.split("").map(B=>B.charCodeAt(0)),v=10;function N(B){let _=!1;return B.forEach((re,U)=>{if(U===0||re.length<e.$xL.length)return;const G=B[U-1],Q=re.subarray(0,e.$xL.length);if(Q[0]===p[0]&&Q[1]===p[1]&&Q[2]===p[2]){const ee=G.lastIndexOf(v);if(ee===-1)return;_=!0,B[U-1]=G.subarray(0,ee),B[U]=re.subarray(e.$xL.length)}}),_}function T(B){let _=B;do B=_,_=B.replace(/[^\n]\x08/gm,"");while(_.length<B.length);return B}function M(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const _=B.match(/^(.*)\r+/m)[1];let re=B.match(/\r+(.*)$/m)[1];re=re+_.slice(re.length,_.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,re)}return B}const j=8,z=13;function F(B){return!B.buffer.includes(j)&&!B.buffer.includes(z)?B:r.$Oe.fromString(M(T(P.decode(B.buffer))))}}),define(Ee[10],Se([1,0,19,14,86,29,108,13,18,2,32,24,28,72,127]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b){"use strict";var c,g,d,m,n,o,i,t,s,f,a,w,y,S,D,P,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$LP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$oP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$bP=e.$aP=e.$_O=e.$$O=e.$9O=e.$8O=e.$7O=e.$6O=e.TestRunProfileKind=e.TestResultState=e.$5O=e.$4O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$3O=e.NotebookVariablesRequestKind=e.$2O=e.$1O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ZO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.ColorThemeKind=e.$TO=e.$SO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$RO=e.$QO=e.DebugConsoleMode=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$KO=e.$JO=e.FileChangeType=e.$IO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$HO=e.$GO=e.$FO=e.$EO=e.InlineCompletionTriggerKind=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$rO=e.ConfigurationTarget=e.$qO=e.$pO=e.$oO=e.$nO=e.DocumentPasteTriggerKind=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gO=e.ViewBadge=e.ProgressLocation=e.$fO=e.$eO=e.TaskScope=e.ShellQuoting=e.$dO=e.$cO=e.$bO=e.TaskPanelKind=e.TaskRevealKind=e.$aO=e.TerminalLocation=e.$_N=e.$$N=e.$0N=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9N=e.$8N=e.$7N=e.$6N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$4N=e.$3N=e.$2N=e.$1N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZN=e.$YN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.LanguageStatusSeverity=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.CodeActionTriggerKind=e.$MN=e.$LN=e.SymbolTag=e.SymbolKind=e.$KN=e.$JN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.DiagnosticSeverity=e.DiagnosticTag=e.$DN=e.$CN=e.FileEditType=e.$BN=e.$AN=e.$zN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$5N=_e,e.$sO=Ti,e.$0O=Dn;function p(Z){return Object.assign(Z,{apply:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const Le=me.length===1?[]:me[1];return Reflect.construct(Z,Le,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(Z,[]);{const[Le,...Ye]=me;return Reflect.construct(Z,Ye,Le.constructor)}}})}var v;(function(Z){Z[Z.Top=0]="Top",Z[Z.Bottom=1]="Bottom"})(v||(e.TerminalOutputAnchor=v={}));var N;(function(Z){Z[Z.TerminalCommand=0]="TerminalCommand",Z[Z.Opener=1]="Opener",Z[Z.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let T=c=class{static from(...H){let me=H;return new c(function(){if(me){for(const Le of me)Le&&typeof Le.dispose=="function"&&Le.dispose();me=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$sN=T,e.$sN=T=c=Je([p],T);let M=g=class{static Min(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Le=1;Le<H.length;Le++){const Ye=H[Le];Ye.isBefore(me)&&(me=Ye)}return me}static Max(...H){if(H.length===0)throw new TypeError;let me=H[0];for(let Le=1;Le<H.length;Le++){const Ye=H[Le];Ye.isAfter(me)&&(me=Ye)}return me}static isPosition(H){if(!H)return!1;if(H instanceof g)return!0;const{line:me,character:Le}=H;return typeof me=="number"&&typeof Le=="number"}static of(H){if(H instanceof g)return H;if(this.isPosition(H))return new g(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,me){if(H<0)throw(0,h.$9)("line must be non-negative");if(me<0)throw(0,h.$9)("character must be non-negative");this.c=H,this.e=me}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,me=0){if(H===null||me===null)throw(0,h.$9)();let Le;return typeof H>"u"?Le=0:typeof H=="number"?Le=H:(Le=typeof H.lineDelta=="number"?H.lineDelta:0,me=typeof H.characterDelta=="number"?H.characterDelta:0),Le===0&&me===0?this:new g(this.line+Le,this.character+me)}with(H,me=this.character){if(H===null||me===null)throw(0,h.$9)();let Le;return typeof H>"u"?Le=this.line:typeof H=="number"?Le=H:(Le=typeof H.line=="number"?H.line:this.line,me=typeof H.character=="number"?H.character:this.character),Le===this.line&&me===this.character?this:new g(Le,me)}toJSON(){return{line:this.line,character:this.character}}};e.$tN=M,e.$tN=M=g=Je([p],M);let j=d=class{static isRange(H){return H instanceof d?!0:H?M.isPosition(H.start)&&M.isPosition(H.end):!1}static of(H){if(H instanceof d)return H;if(this.isRange(H))return new d(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,me,Le,Ye){let st,pt;if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"?(st=new M(H,me),pt=new M(Le,Ye)):M.isPosition(H)&&M.isPosition(me)&&(st=M.of(H),pt=M.of(me)),!st||!pt)throw new Error("Invalid arguments");st.isBefore(pt)?(this.c=st,this.e=pt):(this.c=pt,this.e=st)}contains(H){return d.isRange(H)?this.contains(H.start)&&this.contains(H.end):M.isPosition(H)?!(M.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const me=M.Max(H.start,this.c),Le=M.Min(H.end,this.e);if(!me.isAfter(Le))return new d(me,Le)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const me=M.Min(H.start,this.c),Le=M.Max(H.end,this.end);return new d(me,Le)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,me=this.end){if(H===null||me===null)throw(0,h.$9)();let Le;return H?M.isPosition(H)?Le=H:(Le=H.start||this.start,me=H.end||this.end):Le=this.start,Le.isEqual(this.c)&&me.isEqual(this.end)?this:new d(Le,me)}toJSON(){return[this.start,this.end]}};e.$uN=j,e.$uN=j=d=Je([p],j);let z=m=class extends j{static isSelection(H){return H instanceof m?!0:H?j.isRange(H)&&M.isPosition(H.anchor)&&M.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,me,Le,Ye){let st,pt;if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"?(st=new M(H,me),pt=new M(Le,Ye)):M.isPosition(H)&&M.isPosition(me)&&(st=M.of(H),pt=M.of(me)),!st||!pt)throw new Error("Invalid arguments");super(st,pt),this.f=st,this.g=pt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$vN=z,e.$vN=z=m=Je([p],z);const F=Z=>{if(typeof Z!="string"||Z.length===0||!/^[0-9A-Za-z_\-]+$/.test(Z))throw(0,h.$9)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me,Le){if(typeof H!="string"||H.length===0)throw(0,h.$9)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,h.$9)("port");typeof Le<"u"&&F(Le),this.host=H,this.port=Math.round(me),this.connectionToken=Le}}e.$wN=B;class _{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,me){this.makeConnection=H,this.connectionToken=me,typeof me<"u"&&F(me)}}e.$xN=_;class re extends Error{static NotAvailable(H,me){return new re(H,k.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(H){return new re(H,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,me=k.RemoteAuthorityResolverErrorCode.Unknown,Le){super(H),this._message=H,this._code=me,this._detail=Le,Object.setPrototypeOf(this,re.prototype)}}e.$yN=re;var U;(function(Z){Z[Z.LF=1]="LF",Z[Z.CRLF=2]="CRLF"})(U||(e.EndOfLine=U={}));var G;(function(Z){Z[Z.Replace=1]="Replace",Z[Z.Append=2]="Append",Z[Z.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Q=n=class{static isTextEdit(H){return H instanceof n?!0:H?j.isRange(H)&&typeof H.newText=="string":!1}static replace(H,me){return new n(H,me)}static insert(H,me){return n.replace(new j(H,H),me)}static delete(H){return n.replace(H,"")}static setEndOfLine(H){const me=new n(new j(new M(0,0),new M(0,0)),"");return me.newEol=H,me}get range(){return this.c}set range(H){if(H&&!j.isRange(H))throw(0,h.$9)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,h.$9)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,h.$9)("newEol");this.f=H}constructor(H,me){this.c=H,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$zN=Q,e.$zN=Q=n=Je([p],Q);let ee=o=class{static isNotebookCellEdit(H){return H instanceof o?!0:H?Ei.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,me){return new o(H,me)}static insertCells(H,me){return new o(new Ei(H,H),me)}static deleteCells(H){return new o(H,[])}static updateCellMetadata(H,me){const Le=new o(new Ei(H,H),[]);return Le.newCellMetadata=me,Le}static updateNotebookMetadata(H){const me=new o(new Ei(0,0),[]);return me.newNotebookMetadata=H,me}constructor(H,me){this.range=H,this.newCells=me}};e.$AN=ee,e.$AN=ee=o=Je([p],ee);class ue{static isSnippetTextEdit(H){return H instanceof ue?!0:H?j.isRange(H.range)&&$e.isSnippetString(H.snippet):!1}static replace(H,me){return new ue(H,me)}static insert(H,me){return ue.replace(new j(H,H),me)}constructor(H,me){this.range=H,this.snippet=me}}e.$BN=ue;var ne;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.Cell=3]="Cell",Z[Z.CellReplace=5]="CellReplace",Z[Z.Snippet=6]="Snippet"})(ne||(e.FileEditType=ne={}));let De=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,me,Le,Ye){this.c.push({_type:ne.File,from:H,to:me,options:Le,metadata:Ye})}createFile(H,me,Le){this.c.push({_type:ne.File,from:void 0,to:H,options:me,metadata:Le})}deleteFile(H,me,Le){this.c.push({_type:ne.File,from:H,to:void 0,options:me,metadata:Le})}e(H,me,Le){this.c.push({_type:ne.Cell,metadata:Le,uri:H,edit:{editType:b.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(H,me,Le,Ye){const st=me.start,pt=me.end;(st!==pt||Le.length>0)&&this.c.push({_type:ne.CellReplace,uri:H,index:st,count:pt-st,cells:Le,metadata:Ye})}g(H,me,Le,Ye){this.c.push({_type:ne.Cell,metadata:Ye,uri:H,edit:{editType:b.CellEditType.Metadata,index:me,metadata:Le}})}replace(H,me,Le,Ye){this.c.push({_type:ne.Text,uri:H,edit:new Q(me,Le),metadata:Ye})}insert(H,me,Le,Ye){this.replace(H,new j(me,me),Le,Ye)}delete(H,me,Le){this.replace(H,me,"",Le)}has(H){return this.c.some(me=>me._type===ne.Text&&me.uri.toString()===H.toString())}set(H,me){if(me)for(const Le of me){if(!Le)continue;let Ye,st;Array.isArray(Le)?(Ye=Le[0],st=Le[1]):Ye=Le,ee.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(H,Ye.range.start,Ye.newCellMetadata,st):Ye.newNotebookMetadata?this.e(H,Ye.newNotebookMetadata,st):this.f(H,Ye.range,Ye.newCells,st):ue.isSnippetTextEdit(Ye)?this.c.push({_type:ne.Snippet,uri:H,range:Ye.range,edit:Ye.snippet,metadata:st}):this.c.push({_type:ne.Text,uri:H,edit:Ye,metadata:st})}else{for(let Le=0;Le<this.c.length;Le++){const Ye=this.c[Le];switch(Ye._type){case ne.Text:case ne.Snippet:case ne.Cell:case ne.CellReplace:Ye.uri.toString()===H.toString()&&(this.c[Le]=void 0);break}}(0,r.$Kb)(this.c)}}get(H){const me=[];for(const Le of this.c)Le._type===ne.Text&&Le.uri.toString()===H.toString()&&me.push(Le.edit);return me}entries(){const H=new R.$Cc;for(const me of this.c)if(me._type===ne.Text){let Le=H.get(me.uri);Le||(Le=[me.uri,[]],H.set(me.uri,Le)),Le[1].push(me.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$CN=De,e.$CN=De=Je([p],De);let $e=i=class{static isSnippetString(H){return H instanceof i?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=i.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,me=this.e++){if(typeof H=="function"){const Le=new i;Le.e=this.e,H(Le),this.e=Le.e,H=Le.value}else H=i.c(H);return this.value+="${",this.value+=me,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,me=this.e++){const Le=H.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Le,this.value+="|}",this}appendVariable(H,me){if(typeof me=="function"){const Le=new i;Le.e=this.e,me(Le),this.e=Le.e,me=Le.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$DN=$e,e.$DN=$e=i=Je([p],$e);var K;(function(Z){Z[Z.Unnecessary=1]="Unnecessary",Z[Z.Deprecated=2]="Deprecated"})(K||(e.DiagnosticTag=K={}));var W;(function(Z){Z[Z.Hint=3]="Hint",Z[Z.Information=2]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=0]="Error"})(W||(e.DiagnosticSeverity=W={}));let se=t=class{static isLocation(H){return H instanceof t?!0:H?j.isRange(H.range)&&l.URI.isUri(H.uri):!1}constructor(H,me){if(this.uri=H,me)if(j.isRange(me))this.range=j.of(me);else if(M.isPosition(me))this.range=new j(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$EN=se,e.$EN=se=t=Je([p],se);let oe=class{static is(H){return H?typeof H.message=="string"&&H.location&&j.isRange(H.location.range)&&l.URI.isUri(H.location.uri):!1}constructor(H,me){this.location=H,this.message=me}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.location.range.isEqual(me.location.range)&&H.location.uri.toString()===me.location.uri.toString()}};e.$FN=oe,e.$FN=oe=Je([p],oe);let te=class{constructor(H,me,Le=W.Error){if(!j.isRange(H))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=H,this.message=me,this.severity=Le}toJSON(){return{severity:W[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,me){return H===me?!0:!H||!me?!1:H.message===me.message&&H.severity===me.severity&&H.code===me.code&&H.severity===me.severity&&H.source===me.source&&H.range.isEqual(me.range)&&(0,r.$wb)(H.tags,me.tags)&&(0,r.$wb)(H.relatedInformation,me.relatedInformation,oe.isEqual)}};e.$GN=te,e.$GN=te=Je([p],te);let le=class{constructor(H,me){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=me}};e.$HN=le,e.$HN=le=Je([p],le);let he=class extends le{constructor(H,me,Le,Ye){super(H,me),this.canIncreaseHover=Le,this.canDecreaseHover=Ye}};e.$IN=he,e.$IN=he=Je([p],he);var X;(function(Z){Z[Z.Increase=0]="Increase",Z[Z.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var ae;(function(Z){Z[Z.Text=0]="Text",Z[Z.Read=1]="Read",Z[Z.Write=2]="Write"})(ae||(e.DocumentHighlightKind=ae={}));let pe=class{constructor(H,me=ae.Text){this.range=H,this.kind=me}toJSON(){return{range:this.range,kind:ae[this.kind]}}};e.$JN=pe,e.$JN=pe=Je([p],pe);let be=class{constructor(H,me){this.uri=H,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$KN=be,e.$KN=be=Je([p],be);var Fe;(function(Z){Z[Z.File=0]="File",Z[Z.Module=1]="Module",Z[Z.Namespace=2]="Namespace",Z[Z.Package=3]="Package",Z[Z.Class=4]="Class",Z[Z.Method=5]="Method",Z[Z.Property=6]="Property",Z[Z.Field=7]="Field",Z[Z.Constructor=8]="Constructor",Z[Z.Enum=9]="Enum",Z[Z.Interface=10]="Interface",Z[Z.Function=11]="Function",Z[Z.Variable=12]="Variable",Z[Z.Constant=13]="Constant",Z[Z.String=14]="String",Z[Z.Number=15]="Number",Z[Z.Boolean=16]="Boolean",Z[Z.Array=17]="Array",Z[Z.Object=18]="Object",Z[Z.Key=19]="Key",Z[Z.Null=20]="Null",Z[Z.EnumMember=21]="EnumMember",Z[Z.Struct=22]="Struct",Z[Z.Event=23]="Event",Z[Z.Operator=24]="Operator",Z[Z.TypeParameter=25]="TypeParameter"})(Fe||(e.SymbolKind=Fe={}));var Be;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(Be||(e.SymbolTag=Be={}));let ke=s=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,me,Le,Ye,st){this.name=H,this.kind=me,this.containerName=st,typeof Le=="string"&&(this.containerName=Le),Ye instanceof se?this.location=Ye:Le instanceof j&&(this.location=new se(Ye,Le)),s.validate(this)}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};e.$LN=ke,e.$LN=ke=s=Je([p],ke);let Ie=f=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(f.validate)}constructor(H,me,Le,Ye,st){this.name=H,this.detail=me,this.kind=Le,this.range=Ye,this.selectionRange=st,this.children=[],f.validate(this)}};e.$MN=Ie,e.$MN=Ie=f=Je([p],Ie);var Oe;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.Automatic=2]="Automatic"})(Oe||(e.CodeActionTriggerKind=Oe={}));let q=class{constructor(H,me){this.title=H,this.kind=me}};e.$NN=q,e.$NN=q=Je([p],q);let V=class{static{a=this}static{this.c="."}constructor(H){this.value=H}append(H){return new a(this.value?this.value+a.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+a.c)}};e.$ON=V,e.$ON=V=a=Je([p],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let J=class{constructor(H,me){if(this.range=H,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PN=J,e.$PN=J=Je([p],J);class x{constructor(H,me,Le,Ye,st,pt){this.kind=H,this.name=me,this.detail=Le,this.uri=Ye,this.range=st,this.selectionRange=pt}}e.$QN=x;class fe{constructor(H,me){this.fromRanges=me,this.from=H}}e.$RN=fe;class we{constructor(H,me){this.fromRanges=me,this.to=H}}e.$SN=we;var Ne;(function(Z){Z[Z.Information=0]="Information",Z[Z.Warning=1]="Warning",Z[Z.Error=2]="Error"})(Ne||(e.LanguageStatusSeverity=Ne={}));let Ge=class{constructor(H,me){this.range=H,this.command=me}get isResolved(){return!!this.command}};e.$TN=Ge,e.$TN=Ge=Je([p],Ge);let Ke=w=class{#e;static isMarkdownString(H){return H instanceof w?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,me=!1){this.#e=new A.$3k(H,{supportThemeIcons:me})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,me){return this.#e.appendCodeblock(me??"",H),this}};e.$UN=Ke,e.$UN=Ke=w=Je([p],Ke);let tt=class{constructor(H,me){this.label=H,this.documentation=me}};e.$VN=tt,e.$VN=tt=Je([p],tt);let rt=class{constructor(H,me){this.label=H,this.documentation=me,this.parameters=[]}};e.$WN=rt,e.$WN=rt=Je([p],rt);let ot=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XN=ot,e.$XN=ot=Je([p],ot);var nt;(function(Z){Z[Z.Invoke=1]="Invoke",Z[Z.TriggerCharacter=2]="TriggerCharacter",Z[Z.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var ct;(function(Z){Z[Z.Type=1]="Type",Z[Z.Parameter=2]="Parameter"})(ct||(e.InlayHintKind=ct={}));let $t=class{constructor(H){this.value=H}};e.$YN=$t,e.$YN=$t=Je([p],$t);let ht=class{constructor(H,me,Le){this.position=H,this.label=me,this.kind=Le}};e.$ZN=ht,e.$ZN=ht=Je([p],ht);var at;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.TriggerCharacter=1]="TriggerCharacter",Z[Z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var Pe;(function(Z){Z[Z.Text=0]="Text",Z[Z.Method=1]="Method",Z[Z.Function=2]="Function",Z[Z.Constructor=3]="Constructor",Z[Z.Field=4]="Field",Z[Z.Variable=5]="Variable",Z[Z.Class=6]="Class",Z[Z.Interface=7]="Interface",Z[Z.Module=8]="Module",Z[Z.Property=9]="Property",Z[Z.Unit=10]="Unit",Z[Z.Value=11]="Value",Z[Z.Enum=12]="Enum",Z[Z.Keyword=13]="Keyword",Z[Z.Snippet=14]="Snippet",Z[Z.Color=15]="Color",Z[Z.File=16]="File",Z[Z.Reference=17]="Reference",Z[Z.Folder=18]="Folder",Z[Z.EnumMember=19]="EnumMember",Z[Z.Constant=20]="Constant",Z[Z.Struct=21]="Struct",Z[Z.Event=22]="Event",Z[Z.Operator=23]="Operator",Z[Z.TypeParameter=24]="TypeParameter",Z[Z.User=25]="User",Z[Z.Issue=26]="Issue"})(Pe||(e.CompletionItemKind=Pe={}));var ze;(function(Z){Z[Z.Deprecated=1]="Deprecated"})(ze||(e.CompletionItemTag=ze={}));let Ze=class{constructor(H,me){this.label=H,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&Pe[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1N=Ze,e.$1N=Ze=Je([p],Ze);let Te=class{constructor(H=[],me=!1){this.items=H,this.isIncomplete=me}};e.$2N=Te,e.$2N=Te=Je([p],Te);let Me=class{constructor(H,me,Le){this.insertText=H,this.range=me,this.command=Le}};e.$3N=Me,e.$3N=Me=Je([p],Me);let Y=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$4N=Y,e.$4N=Y=Je([p],Y);var de;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Word=1]="Word",Z[Z.Line=2]="Line",Z[Z.Suggest=3]="Suggest"})(de||(e.PartialAcceptTriggerKind=de={}));var Ce;(function(Z){Z[Z.Active=-1]="Active",Z[Z.Beside=-2]="Beside",Z[Z.One=1]="One",Z[Z.Two=2]="Two",Z[Z.Three=3]="Three",Z[Z.Four=4]="Four",Z[Z.Five=5]="Five",Z[Z.Six=6]="Six",Z[Z.Seven=7]="Seven",Z[Z.Eight=8]="Eight",Z[Z.Nine=9]="Nine"})(Ce||(e.ViewColumn=Ce={}));var Xe;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function _e(Z,H){return`${E.$qn.toKey(Z)}.${H}`}var lt;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval"})(lt||(e.TextEditorLineNumbersStyle=lt={}));var gt;(function(Z){Z[Z.Manual=1]="Manual",Z[Z.AfterDelay=2]="AfterDelay",Z[Z.FocusOut=3]="FocusOut"})(gt||(e.TextDocumentSaveReason=gt={}));var kt;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(kt||(e.TextEditorRevealType=kt={}));var Ot;(function(Z){Z[Z.Keyboard=1]="Keyboard",Z[Z.Mouse=2]="Mouse",Z[Z.Command=3]="Command"})(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var Wt;(function(Z){Z[Z.Undo=1]="Undo",Z[Z.Redo=2]="Redo"})(Wt||(e.TextDocumentChangeReason=Wt={}));var ui;(function(Z){Z[Z.OpenOpen=0]="OpenOpen",Z[Z.ClosedClosed=1]="ClosedClosed",Z[Z.OpenClosed=2]="OpenClosed",Z[Z.ClosedOpen=3]="ClosedOpen"})(ui||(e.DecorationRangeBehavior=ui={})),function(Z){function H(me){switch(me){case"keyboard":return Z.Keyboard;case"mouse":return Z.Mouse;case"api":return Z.Command}}Z.fromValue=H}(Ot||(e.TextEditorSelectionChangeKind=Ot={}));var it;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(it||(e.SyntaxTokenType=it={})),function(Z){function H(me){switch(me){case Z.Other:return"other";case Z.Comment:return"comment";case Z.String:return"string";case Z.RegEx:return"regex"}return"other"}Z.toString=H}(it||(e.SyntaxTokenType=it={}));let Ct=class{constructor(H,me){if(me&&!l.URI.isUri(me))throw(0,h.$9)("target");if(!j.isRange(H)||H.isEmpty)throw(0,h.$9)("range");this.range=H,this.target=me}};e.$6N=Ct,e.$6N=Ct=Je([p],Ct);let Zt=class{constructor(H,me,Le,Ye){this.red=H,this.green=me,this.blue=Le,this.alpha=Ye}};e.$7N=Zt,e.$7N=Zt=Je([p],Zt);let mt=class{constructor(H,me){if(me&&!(me instanceof Zt))throw(0,h.$9)("color");if(!j.isRange(H)||H.isEmpty)throw(0,h.$9)("range");this.range=H,this.color=me}};e.$8N=mt,e.$8N=mt=Je([p],mt);let bt=class{constructor(H){if(!H||typeof H!="string")throw(0,h.$9)("label");this.label=H}};e.$9N=bt,e.$9N=bt=Je([p],bt);var hi;(function(Z){Z[Z.RGB=0]="RGB",Z[Z.HEX=1]="HEX",Z[Z.HSL=2]="HSL"})(hi||(e.ColorFormat=hi={}));var ei;(function(Z){Z[Z.Error=0]="Error",Z[Z.Warning=1]="Warning",Z[Z.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var qt;(function(Z){Z[Z.Unknown=0]="Unknown",Z[Z.Shutdown=1]="Shutdown",Z[Z.Process=2]="Process",Z[Z.User=3]="User",Z[Z.Extension=4]="Extension"})(qt||(e.TerminalExitReason=qt={}));var wt;(function(Z){Z[Z.Low=0]="Low",Z[Z.Medium=1]="Medium",Z[Z.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Vt{constructor(H,me,Le){if(this.startIndex=H,this.length=me,this.tooltip=Le,typeof H!="number"||H<0)throw(0,h.$9)("startIndex");if(typeof me!="number"||me<1)throw(0,h.$9)("length");if(Le!==void 0&&typeof Le!="string")throw(0,h.$9)("tooltip")}}e.$0N=Vt;class Jt{constructor(H){this.uri=H}}e.$$N=Jt;class Xt{constructor(H){this.terminalCommand=H}}e.$_N=Xt;var xe;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Editor=2]="Editor"})(xe||(e.TerminalLocation=xe={}));class $i{constructor(H){if(this.options=H,typeof H!="object")throw(0,h.$9)("options")}}e.$aO=$i;var ti;(function(Z){Z[Z.Always=1]="Always",Z[Z.Silent=2]="Silent",Z[Z.Never=3]="Never"})(ti||(e.TaskRevealKind=ti={}));var si;(function(Z){Z[Z.Shared=1]="Shared",Z[Z.Dedicated=2]="Dedicated",Z[Z.New=3]="New"})(si||(e.TaskPanelKind=si={}));let Dt=class{static{y=this}static{this.Clean=new y("clean","Clean")}static{this.Build=new y("build","Build")}static{this.Rebuild=new y("rebuild","Rebuild")}static{this.Test=new y("test","Test")}static from(H){switch(H){case"clean":return y.Clean;case"build":return y.Build;case"rebuild":return y.Rebuild;case"test":return y.Test;default:return}}constructor(H,me){if(this.label=me,typeof H!="string"||typeof me!="string")throw(0,h.$9)("name");this.c=H}get id(){return this.c}};e.$bO=Dt,e.$bO=Dt=y=Je([p],Dt);function Kt(Z){let H="";for(let me=0;me<Z.length;me++)H+=Z[me].replace(/,/g,",,")+",";return H}let Lt=class{constructor(H,me,Le){if(typeof H!="string")throw(0,h.$9)("process");this.e=[],this.c=H,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Le):this.f=me)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,h.$9)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const me of this.e)H.push(me);return Kt(H)}};e.$cO=Lt,e.$cO=Lt=Je([p],Lt);let Mt=class{constructor(H,me,Le){if(this.f=[],Array.isArray(me)){if(!H)throw(0,h.$9)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$9)("command");this.e=H,this.f=me,this.g=Le}else{if(typeof H!="string")throw(0,h.$9)("commandLine");this.c=H,this.g=me}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,h.$9)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,h.$9)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)H.push(typeof me=="string"?me:me.value);return Kt(H)}};e.$dO=Mt,e.$dO=Mt=Je([p],Mt);var ii;(function(Z){Z[Z.Escape=1]="Escape",Z[Z.Strong=2]="Strong",Z[Z.Weak=3]="Weak"})(ii||(e.ShellQuoting=ii={}));var ni;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace"})(ni||(e.TaskScope=ni={}));class oi{constructor(H){this.c=H}computeId(){return"customExecution"+(0,I.$2g)()}set callback(H){this.c=H}get callback(){return this.c}}e.$eO=oi;let Bt=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,me,Le,Ye,st,pt){this.k=!1,this.l=this.definition=H;let Et;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Le,this.execution=Ye,Et=st,this.k=!0):me===ni.Global||me===ni.Workspace?(this.target=me,this.o=this.name=Le,this.w=this.source=Ye,this.execution=st,Et=pt):(this.target=me,this.o=this.name=Le,this.w=this.source=Ye,this.execution=st,Et=pt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:S.e,id:this.q.computeId()}:this.q instanceof Mt?this.l={type:S.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:S.c,id:this.q.computeId()}:this.l={type:S.g,id:(0,I.$2g)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,h.$9)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,h.$9)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const me=this.l.type;(S.g===me||S.e===me||S.f===me||S.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,h.$9)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$fO=Bt,e.$fO=Bt=S=Je([p],Bt);var Qt;(function(Z){Z[Z.SourceControl=1]="SourceControl",Z[Z.Window=10]="Window",Z[Z.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var di;(function(Z){function H(me){const Le=me;return(0,$.$jg)(Le.value)?Le.tooltip&&!(0,$.$fg)(Le.tooltip)?(console.log("INVALID view badge, invalid tooltip",Le.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Le.value),!1)}Z.isViewBadge=H})(di||(e.ViewBadge=di={}));let jt=D=class{static isTreeItem(H,me){const Le=H;if(Le.checkboxState!==void 0){const Ye=(0,$.$jg)(Le.checkboxState)?Le.checkboxState:(0,$.$hg)(Le.checkboxState)&&(0,$.$jg)(Le.checkboxState.state)?Le.checkboxState.state:void 0,st=!(0,$.$jg)(Le.checkboxState)&&(0,$.$hg)(Le.checkboxState)?Le.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==Pt.Checked&&Ye!==Pt.Unchecked||st!==void 0&&!(0,$.$fg)(st))return console.log("INVALID tree item, invalid checkboxState",Le.checkboxState),!1}if(H instanceof D)return!0;if(Le.label!==void 0&&!(0,$.$fg)(Le.label)&&!Le.label?.label)return console.log("INVALID tree item, invalid label",Le.label),!1;if(Le.id!==void 0&&!(0,$.$fg)(Le.id))return console.log("INVALID tree item, invalid id",Le.id),!1;if(Le.iconPath!==void 0&&!(0,$.$fg)(Le.iconPath)&&!l.URI.isUri(Le.iconPath)&&(!Le.iconPath||!(0,$.$fg)(Le.iconPath.id))){const Ye=Le.iconPath;if(!Ye||!(0,$.$fg)(Ye.light)&&!l.URI.isUri(Ye.light)&&!(0,$.$fg)(Ye.dark)&&!l.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Le.iconPath),!1}return Le.description!==void 0&&!(0,$.$fg)(Le.description)&&typeof Le.description!="boolean"?(console.log("INVALID tree item, invalid description",Le.description),!1):Le.resourceUri!==void 0&&!l.URI.isUri(Le.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Le.resourceUri),!1):Le.tooltip!==void 0&&!(0,$.$fg)(Le.tooltip)&&!(Le.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Le.tooltip),!1):Le.command!==void 0&&!Le.command.command?(console.log("INVALID tree item, invalid command",Le.command),!1):Le.collapsibleState!==void 0&&Le.collapsibleState<vt.None&&Le.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Le.collapsibleState),!1):Le.contextValue!==void 0&&!(0,$.$fg)(Le.contextValue)?(console.log("INVALID tree item, invalid contextValue",Le.contextValue),!1):Le.accessibilityInformation!==void 0&&!Le.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Le.accessibilityInformation),!1):!0}constructor(H,me=vt.None){this.collapsibleState=me,l.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$gO=jt,e.$gO=jt=D=Je([p],jt);var vt;(function(Z){Z[Z.None=0]="None",Z[Z.Collapsed=1]="Collapsed",Z[Z.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Pt;(function(Z){Z[Z.Unchecked=0]="Unchecked",Z[Z.Checked=1]="Checked"})(Pt||(e.TreeItemCheckboxState=Pt={}));let Tt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$hO=Tt,e.$hO=Tt=Je([p],Tt);class It extends Tt{}e.$iO=It;class Yt extends It{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$jO=Yt;class Ht{constructor(H,me,Le,Ye){this.name=H,this.uri=me,this._itemId=Le,this.c=Ye}data(){return this.c()}}e.$kO=Ht;let pi=class{#e=new Map;constructor(H){for(const[me,Le]of H??[]){const Ye=this.#e.get(this.#t(me));Ye?Ye.push(Le):this.#e.set(this.#t(me),[Le])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,me){this.#e.set(this.#t(H),[me])}forEach(H,me){for(const[Le,Ye]of this.#e)for(const st of Ye)H.call(me,st,Le,this)}*[Symbol.iterator](){for(const[H,me]of this.#e)for(const Le of me)yield[H,Le]}#t(H){return H.toLowerCase()}};e.$lO=pi,e.$lO=pi=Je([p],pi);let fi=class{constructor(H,me,Le){this.insertText=H,this.title=me,this.kind=Le}};e.$mO=fi,e.$mO=fi=Je([p],fi);var Ai;(function(Z){Z[Z.Automatic=0]="Automatic",Z[Z.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Nt{static{this.c="."}constructor(H){this.value=H}append(...H){return new Nt((this.value?[this.value,...H]:H).join(Nt.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+Nt.c)}}e.$nO=Nt,Nt.Empty=new Nt("");class Oi{constructor(H,me,Le){this.title=me,this.insertText=H,this.kind=Le}}e.$oO=Oi;let ai=class{constructor(H,me){this.id=H,this.color=me}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$pO=ai,e.$pO=ai=Je([p],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Rt=class{constructor(H){this.id=H}};e.$qO=Rt,e.$qO=Rt=Je([p],Rt);var Si;(function(Z){Z[Z.Global=1]="Global",Z[Z.Workspace=2]="Workspace",Z[Z.WorkspaceFolder=3]="WorkspaceFolder"})(Si||(e.ConfigurationTarget=Si={}));let Di=class{get base(){return this.c}set base(H){this.c=H,this.e=l.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,me){if(typeof H!="string"&&(!H||!l.URI.isUri(H)&&!l.URI.isUri(H.uri)))throw(0,h.$9)("base");if(typeof me!="string")throw(0,h.$9)("pattern");typeof H=="string"?this.baseUri=l.URI.file(H):l.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$rO=Di,e.$rO=Di=Je([p],Di);const vi=new WeakMap;function Ti(Z,H){vi.set(Z,H)}let gi=class{constructor(H,me,Le,Ye,st){this.enabled=typeof H=="boolean"?H:!0,typeof me=="string"&&(this.condition=me),typeof Le=="string"&&(this.hitCondition=Le),typeof Ye=="string"&&(this.logMessage=Ye),typeof st=="string"&&(this.mode=st)}get id(){return this.c||(this.c=vi.get(this)??(0,I.$2g)()),this.c}};e.$tO=gi,e.$tO=gi=Je([p],gi);let Gt=class extends gi{constructor(H,me,Le,Ye,st,pt){if(super(me,Le,Ye,st,pt),H===null)throw(0,h.$9)("location");this.location=H}};e.$uO=Gt,e.$uO=Gt=Je([p],Gt);let Ae=class extends gi{constructor(H,me,Le,Ye,st,pt){super(me,Le,Ye,st,pt),this.functionName=H}};e.$vO=Ae,e.$vO=Ae=Je([p],Ae);let je=class extends gi{constructor(H,me,Le,Ye,st,pt,Et,_t){if(super(Ye,st,pt,Et,_t),!me)throw(0,h.$9)("dataId");this.label=H,this.dataId=me,this.canPersist=Le}};e.$wO=je,e.$wO=je=Je([p],je);let ve=class{constructor(H,me,Le){this.command=H,this.args=me||[],this.options=Le}};e.$xO=ve,e.$xO=ve=Je([p],ve);let ie=class{constructor(H,me){this.port=H,this.host=me}};e.$yO=ie,e.$yO=ie=Je([p],ie);let Re=class{constructor(H){this.path=H}};e.$zO=Re,e.$zO=Re=Je([p],Re);let He=class{constructor(H){this.implementation=H}};e.$AO=He,e.$AO=He=Je([p],He);class et{constructor(H,me,Le){this.session=H,this.threadId=me,this.frameId=Le}}e.$BO=et;class Qe{constructor(H,me){this.session=H,this.threadId=me}}e.$CO=Qe;let ft=class{constructor(H,me){this.range=H,this.expression=me}};e.$DO=ft,e.$DO=ft=Je([p],ft);var At;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(At||(e.InlineCompletionTriggerKind=At={}));let xt=class{constructor(H,me){this.range=H,this.text=me}};e.$EO=xt,e.$EO=xt=Je([p],xt);let ci=class{constructor(H,me,Le=!0){this.range=H,this.variableName=me,this.caseSensitiveLookup=Le}};e.$FO=ci,e.$FO=ci=Je([p],ci);let zt=class{constructor(H,me){this.range=H,this.expression=me}};e.$GO=zt,e.$GO=zt=Je([p],zt);let ri=class{constructor(H,me){this.frameId=H,this.stoppedLocation=me}};e.$HO=ri,e.$HO=ri=Je([p],ri);var Bi;(function(Z){Z[Z.AIGenerated=1]="AIGenerated"})(Bi||(e.NewSymbolNameTag=Bi={}));var Yi;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(Yi||(e.NewSymbolNameTriggerKind=Yi={}));class Ui{constructor(H,me){this.newSymbolName=H,this.tags=me}}e.$IO=Ui;var Ni;(function(Z){Z[Z.Changed=1]="Changed",Z[Z.Created=2]="Created",Z[Z.Deleted=3]="Deleted"})(Ni||(e.FileChangeType=Ni={}));let Wi=P=class extends Error{static FileExists(H){return new P(H,u.FileSystemProviderErrorCode.FileExists,P.FileExists)}static FileNotFound(H){return new P(H,u.FileSystemProviderErrorCode.FileNotFound,P.FileNotFound)}static FileNotADirectory(H){return new P(H,u.FileSystemProviderErrorCode.FileNotADirectory,P.FileNotADirectory)}static FileIsADirectory(H){return new P(H,u.FileSystemProviderErrorCode.FileIsADirectory,P.FileIsADirectory)}static NoPermissions(H){return new P(H,u.FileSystemProviderErrorCode.NoPermissions,P.NoPermissions)}static Unavailable(H){return new P(H,u.FileSystemProviderErrorCode.Unavailable,P.Unavailable)}constructor(H,me=u.FileSystemProviderErrorCode.Unknown,Le){super(l.URI.isUri(H)?H.toString(!0):H),this.code=Le?.name??"Unknown",(0,u.$ol)(this,me),Object.setPrototypeOf(this,P.prototype),typeof Error.captureStackTrace=="function"&&typeof Le=="function"&&Error.captureStackTrace(this,Le)}};e.$JO=Wi,e.$JO=Wi=P=Je([p],Wi);let qi=class{constructor(H,me,Le){this.start=H,this.end=me,this.kind=Le}};e.$KO=qi,e.$KO=qi=Je([p],qi);var ki;(function(Z){Z[Z.Comment=1]="Comment",Z[Z.Imports=2]="Imports",Z[Z.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(Z){Z[Z.Collapsed=0]="Collapsed",Z[Z.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(Z){Z[Z.Editing=0]="Editing",Z[Z.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Fi;(function(Z){Z[Z.Published=0]="Published",Z[Z.Draft=1]="Draft"})(Fi||(e.CommentState=Fi={}));var en;(function(Z){Z[Z.Unresolved=0]="Unresolved",Z[Z.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var Vi;(function(Z){Z[Z.Current=0]="Current",Z[Z.Outdated=1]="Outdated"})(Vi||(e.CommentThreadApplicability=Vi={}));class $n{constructor(H,me=[]){this.tokenTypes=H,this.tokenModifiers=me}}e.$LO=$n;function tn(Z){return typeof Z>"u"||(0,$.$gg)(Z)}class Gi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let me=0,Le=H.tokenTypes.length;me<Le;me++)this.k.set(H.tokenTypes[me],me);for(let me=0,Le=H.tokenModifiers.length;me<Le;me++)this.l.set(H.tokenModifiers[me],me)}}push(H,me,Le,Ye,st){if(typeof H=="number"&&typeof me=="number"&&typeof Le=="number"&&typeof Ye=="number"&&(typeof st=="number"||typeof st>"u"))return typeof st>"u"&&(st=0),this.q(H,me,Le,Ye,st);if(j.isRange(H)&&typeof me=="string"&&tn(Le))return this.o(H,me,Le);throw(0,h.$9)()}o(H,me,Le){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,st=H.start.character,pt=H.end.character-H.start.character,Et=this.k.get(me);let _t=0;if(Le)for(const mi of Le){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(mi);_t|=1<<wi>>>0}this.q(Ye,st,pt,Et,_t)}q(H,me,Le,Ye,st){if(this.f&&(H<this.c||H===this.c&&me<this.e)){this.f=!1;const _t=this.g.length/5|0;let mi=0,wi=0;for(let yi=0;yi<_t;yi++){let Ci=this.g[5*yi],Ji=this.g[5*yi+1];Ci===0?(Ci=mi,Ji+=wi):Ci+=mi,this.g[5*yi]=Ci,this.g[5*yi+1]=Ji,mi=Ci,wi=Ji}}let pt=H,Et=me;this.f&&this.j>0&&(pt-=this.c,pt===0&&(Et-=this.e)),this.g[this.j++]=pt,this.g[this.j++]=Et,this.g[this.j++]=Le,this.g[this.j++]=Ye,this.g[this.j++]=st,this.c=H,this.e=me}static r(H){const me=[],Le=H.length/5|0;for(let Et=0;Et<Le;Et++)me[Et]=Et;me.sort((Et,_t)=>{const mi=H[5*Et],wi=H[5*_t];if(mi===wi){const yi=H[5*Et+1],Ci=H[5*_t+1];return yi-Ci}return mi-wi});const Ye=new Uint32Array(H.length);let st=0,pt=0;for(let Et=0;Et<Le;Et++){const _t=5*me[Et],mi=H[_t+0],wi=H[_t+1],yi=H[_t+2],Ci=H[_t+3],Ji=H[_t+4],Bn=mi-st,kr=Bn===0?wi-pt:wi,Xi=5*Et;Ye[Xi+0]=Bn,Ye[Xi+1]=kr,Ye[Xi+2]=yi,Ye[Xi+3]=Ci,Ye[Xi+4]=Ji,st=mi,pt=wi}return Ye}build(H){return this.f?new Ii(new Uint32Array(this.g),H):new Ii(Gi.r(this.g),H)}}e.$MO=Gi;class Ii{constructor(H,me){this.resultId=me,this.data=H}}e.$NO=Ii;class pn{constructor(H,me,Le){this.start=H,this.deleteCount=me,this.data=Le}}e.$OO=pn;class bn{constructor(H,me){this.resultId=me,this.edits=H}}e.$PO=bn;var nn;(function(Z){Z[Z.Separate=0]="Separate",Z[Z.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Hi{constructor(H){this.name=H}}e.$QO=Hi;let Mi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$RO=Mi,e.$RO=Mi=Je([p],Mi);var qe;(function(Z){Z[Z.Separator=-1]="Separator",Z[Z.Default=0]="Default"})(qe||(e.QuickPickItemKind=qe={}));var bi;(function(Z){Z[Z.Info=1]="Info",Z[Z.Warning=2]="Warning",Z[Z.Error=3]="Error"})(bi||(e.InputBoxValidationSeverity=bi={}));var Zi;(function(Z){Z[Z.UI=1]="UI",Z[Z.Workspace=2]="Workspace"})(Zi||(e.ExtensionKind=Zi={}));class ut{static validate(H){if(typeof H.badge=="string"){let me=(0,O.$Qf)(H.badge,0);if(me<H.badge.length&&(me+=(0,O.$Qf)(H.badge,me)),H.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!ai.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,me,Le){this.badge=H,this.tooltip=me,this.color=Le}}e.$SO=ut;let yt=class{constructor(H){this.kind=H}};e.$TO=yt,e.$TO=yt=Je([p],yt);var rn;(function(Z){Z[Z.Light=1]="Light",Z[Z.Dark=2]="Dark",Z[Z.HighContrast=3]="HighContrast",Z[Z.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class Ei{static isNotebookRange(H){return H instanceof Ei?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,me){if(H<0)throw(0,h.$9)("start must be positive");if(me<0)throw(0,h.$9)("end must be positive");H<=me?(this.c=H,this.e=me):(this.c=me,this.e=H)}with(H){let me=this.c,Le=this.e;return H.start!==void 0&&(me=H.start),H.end!==void 0&&(Le=H.end),me===this.c&&Le===this.e?this:new Ei(me,Le)}}e.$UO=Ei;class Li{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(me=>Li.isNotebookCellData(me))}static isNotebookCellData(H){return!0}constructor(H,me,Le,Ye,st,pt,Et){this.kind=H,this.value=me,this.languageId=Le,this.mime=Ye,this.outputs=st??[],this.metadata=pt,this.executionSummary=Et,Li.validate(this)}}e.$VO=Li;class wn{constructor(H){this.cells=H}}e.$WO=wn;class li{static isNotebookCellOutputItem(H){return H instanceof li?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const me={name:H.name,message:H.message,stack:H.stack};return li.json(me,"application/vnd.code.notebook.error")}static stdout(H){return li.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return li.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,me="application/octet-stream"){return new li(H,me)}static#e=new TextEncoder;static text(H,me=L.$5s.text){const Le=li.#e.encode(String(H));return new li(Le,me)}static json(H,me="text/x-json"){const Le=JSON.stringify(H,void 0,"	");return li.text(Le,me)}constructor(H,me){this.data=H,this.mime=me;const Le=(0,L.$9s)(me,!0);if(!Le)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Le}}e.$XO=li;class ji{static isNotebookCellOutput(H){return H instanceof ji?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,me=!1){const Le=new Set,Ye=new Set;for(let st=0;st<H.length;st++){const pt=H[st],Et=(0,L.$9s)(pt.mime);if(!Le.has(Et)||(0,b.$vL)(Et)){Le.add(Et);continue}Ye.add(st),me&&console.warn(`DUPLICATED mime type '${pt.mime}' will be dropped`)}return Ye.size===0?H:H.filter((st,pt)=>!Ye.has(pt))}constructor(H,me,Le){this.items=ji.ensureUniqueMimeTypes(H,!0),typeof me=="string"?(this.id=me,this.metadata=Le):(this.id=(0,I.$2g)(),this.metadata=me??Le)}}e.$YO=ji;var sn;(function(Z){Z[Z.Markup=1]="Markup",Z[Z.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(Z){Z[Z.Idle=1]="Idle",Z[Z.Pending=2]="Pending",Z[Z.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Ki;(function(Z){Z[Z.Left=1]="Left",Z[Z.Right=2]="Right"})(Ki||(e.NotebookCellStatusBarAlignment=Ki={}));var an;(function(Z){Z[Z.Default=0]="Default",Z[Z.InCenter=1]="InCenter",Z[Z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",Z[Z.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(H,me){this.text=H,this.alignment=me}}e.$ZO=vn;var cn;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var ln;(function(Z){Z[Z.Default=1]="Default",Z[Z.Preferred=2]="Preferred",Z[Z.Hidden=-1]="Hidden"})(ln||(e.NotebookControllerAffinity2=ln={}));class En{constructor(H,me=[]){this.uri=H,this.provides=(0,r.$4b)(me)}}e.$1O=En;class yn{constructor(H){this.label=H}}e.$2O=yn;var un;(function(Z){Z[Z.Named=1]="Named",Z[Z.Indexed=2]="Indexed"})(un||(e.NotebookVariablesRequestKind=un={}));let Qi=class{constructor(H,me){this.label=H,this.timestamp=me}};e.$3O=Qi,e.$3O=Qi=Je([p],Qi);var hn;(function(Z){Z[Z.Production=1]="Production",Z[Z.Development=2]="Development",Z[Z.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(Z){Z[Z.Node=1]="Node",Z[Z.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(Z){Z[Z.Other=0]="Other",Z[Z.Comment=1]="Comment",Z[Z.String=2]="String",Z[Z.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ge{constructor(H,me){this.ranges=H,this.wordPattern=me}}e.$4O=ge;class ye{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$5O=ye;var Ue;(function(Z){Z[Z.Queued=1]="Queued",Z[Z.Running=2]="Running",Z[Z.Passed=3]="Passed",Z[Z.Failed=4]="Failed",Z[Z.Skipped=5]="Skipped",Z[Z.Errored=6]="Errored"})(Ue||(e.TestResultState=Ue={}));var dt;(function(Z){Z[Z.Run=1]="Run",Z[Z.Debug=2]="Debug",Z[Z.Coverage=3]="Coverage"})(dt||(e.TestRunProfileKind=dt={}));let St=class{constructor(H=void 0,me=void 0,Le=void 0,Ye=!1,st=!0){this.include=H,this.exclude=me,this.profile=Le,this.continuous=Ye,this.preserveFocus=st}};e.$6O=St,e.$6O=St=Je([p],St);let Ft=C=class{static diff(H,me,Le){const Ye=new C(H);return Ye.expectedOutput=me,Ye.actualOutput=Le,Ye}constructor(H){this.message=H}};e.$7O=Ft,e.$7O=Ft=C=Je([p],Ft);let Pi=class{constructor(H){this.id=H}};e.$8O=Pi,e.$8O=Pi=Je([p],Pi);class zi{constructor(H,me){this.covered=H,this.total=me,Dn(this)}}e.$9O=zi;function Dn(Z){if(Z){if(Z.covered>Z.total)throw new Error(`The total number of covered items (${Z.covered}) cannot be greater than the total (${Z.total})`);if(Z.total<0)throw new Error(`The number of covered items (${Z.total}) cannot be negative`)}}class Sn{static fromDetails(H,me){const Le=new zi(0,0),Ye=new zi(0,0),st=new zi(0,0);for(const Et of me)if("branches"in Et){Le.total+=1,Le.covered+=Et.executed?1:0;for(const _t of Et.branches)Ye.total+=1,Ye.covered+=_t.executed?1:0}else st.total+=1,st.covered+=Et.executed?1:0;const pt=new Sn(H,Le,Ye.total>0?Ye:void 0,st.total>0?st:void 0);return pt.detailedCoverage=me,pt}constructor(H,me,Le,Ye,st=[]){this.uri=H,this.statementCoverage=me,this.branchCoverage=Le,this.declarationCoverage=Ye,this.fromTests=st}}e.$$O=Sn;class qn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le=[]){this.executed=H,this.location=me,this.branches=Le}}e.$_O=qn;class Vn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le){this.executed=H,this.location=me,this.label=Le}}e.$aP=Vn;class Gn{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,me,Le){this.name=H,this.executed=me,this.location=Le}}e.$bP=Gn;var kn;(function(Z){Z[Z.None=0]="None",Z[Z.Option=1]="Option",Z[Z.Default=2]="Default",Z[Z.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var In;(function(Z){Z[Z.Untrusted=0]="Untrusted",Z[Z.Trusted=1]="Trusted",Z[Z.Unspecified=2]="Unspecified"})(In||(e.WorkspaceTrustState=In={}));var Pn;(function(Z){Z[Z.Notify=1]="Notify",Z[Z.OpenBrowser=2]="OpenBrowser",Z[Z.OpenPreview=3]="OpenPreview",Z[Z.Silent=4]="Silent",Z[Z.Ignore=5]="Ignore",Z[Z.OpenBrowserOnce=6]="OpenBrowserOnce"})(Pn||(e.PortAutoForwardAction=Pn={}));class Hn{constructor(H,me,Le,Ye,st,pt){this.kind=H,this.name=me,this.detail=Le,this.uri=Ye,this.range=st,this.selectionRange=pt}}e.$cP=Hn;class Zn{constructor(H){this.uri=H}}e.$dP=Zn;class Kn{constructor(H,me){this.original=H,this.modified=me}}e.$eP=Kn;class Qn{constructor(H,me,Le,Ye){this.base=H,this.input1=me,this.input2=Le,this.result=Ye}}e.$fP=Qn;class Jn{constructor(H,me){this.uri=H,this.viewType=me}}e.$gP=Jn;class Xn{constructor(H){this.viewType=H}}e.$hP=Xn;class Yn{constructor(H,me){this.uri=H,this.notebookType=me}}e.$iP=Yn;class xn{constructor(H,me,Le){this.original=H,this.modified=me,this.notebookType=Le}}e.$jP=xn;class _n{constructor(){}}e.$kP=_n;class er{constructor(H,me){this.uri=H,this.inputBoxUri=me}}e.$lP=er;class tr{constructor(){}}e.$mP=tr;class ir{constructor(H){this.textDiffs=H}}e.$nP=ir;var Cn;(function(Z){Z[Z.Down=0]="Down",Z[Z.Up=1]="Up"})(Cn||(e.InteractiveSessionVoteDirection=Cn={}));var An;(function(Z){Z[Z.Action=1]="Action",Z[Z.Toolbar=2]="Toolbar"})(An||(e.ChatCopyKind=An={}));var Rn;(function(Z){Z[Z.Short=1]="Short",Z[Z.Medium=2]="Medium",Z[Z.Full=3]="Full"})(Rn||(e.ChatVariableLevel=Rn={}));class nr{constructor(H,me,Le){this.id=H,this.label=me,this.values=Le}}e.$oP=nr;var On;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful",Z[Z.Undone=2]="Undone",Z[Z.Accepted=3]="Accepted",Z[Z.Bug=4]="Bug"})(On||(e.InteractiveEditorResponseFeedbackKind=On={}));var Ln;(function(Z){Z[Z.Unhelpful=0]="Unhelpful",Z[Z.Helpful=1]="Helpful"})(Ln||(e.ChatResultFeedbackKind=Ln={}));class rr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$pP=rr;class sr{constructor(H,me){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H,this.vulnerabilities=me}}e.$qP=sr;class or{constructor(H,me){this.participant=H,this.command=me}}e.$rP=or;class ar{constructor(H,me,Le){this.title=H,this.message=me,this.data=Le}}e.$sP=ar;class cr{constructor(H,me){this.value=H,this.baseUri=me}}e.$tP=cr;class lr{constructor(H,me){this.value=H,this.title=me}}e.$uP=lr;class ur{constructor(H){this.value=H}}e.$vP=ur;class hr{constructor(H,me){this.value=H,this.task=me}}e.$wP=hr;class dr{constructor(H){if(typeof H!="string"&&H.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof H=="string"?new Ke(H):H}}e.$xP=dr;class fr{constructor(H){this.value=H}}e.$yP=fr;class gr{constructor(H,me){this.value=H,this.iconPath=me}}e.$zP=gr;class mr{constructor(H,me){this.uri=H,this.edits=Array.isArray(me)?me:[me]}}e.$AP=mr;class $r{constructor(H,me,Le,Ye){this.prompt=H,this.command=me,this.references=Le,this.participant=Ye}}e.$BP=$r;class pr{constructor(H,me,Le,Ye){this.response=H,this.result=me,this.participant=Le,this.command=Ye}}e.$CP=pr;var Tn;(function(Z){Z[Z.Panel=1]="Panel",Z[Z.Terminal=2]="Terminal",Z[Z.Notebook=3]="Notebook",Z[Z.Editor=4]="Editor"})(Tn||(e.ChatLocation=Tn={}));var gn;(function(Z){Z[Z.User=1]="User",Z[Z.Assistant=2]="Assistant",Z[Z.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(H,me,Le){this.name=H,this.content=me,this.isError=Le??!1}}e.$DP=br;class mn{static User(H,me){const Le=new mn(gn.User,typeof H=="string"?H:"",me);return Le.content2=H,Le}static Assistant(H,me){return new mn(gn.Assistant,H,me)}constructor(H,me,Le){this.role=H,this.content=me,this.content2=me,this.name=Le}}e.$EP=mn;class wr{constructor(H,me){this.name=H,this.parameters=me}}e.$FP=wr;class vr{constructor(H){this.value=H}}e.$GP=vr;class Er{constructor(H){this.content=H}}e.$HP=Er;class yr{constructor(H,me){this.content=H,this.name=me}}e.$IP=yr;class Sr{constructor(H,me){this.content=H,this.name=me}}e.$JP=Sr;class Ri extends Error{static NotFound(H){return new Ri(H,Ri.NotFound.name)}static NoPermissions(H){return new Ri(H,Ri.NoPermissions.name)}static Blocked(H){return new Ri(H,Ri.Blocked.name)}constructor(H,me,Le){super(H,{cause:Le}),this.name="LanguageModelError",this.code=me??""}}e.$KP=Ri;var Nn;(function(Z){Z[Z.SymbolInformation=1]="SymbolInformation",Z[Z.CommandInformation=2]="CommandInformation",Z[Z.SearchInformation=3]="SearchInformation",Z[Z.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var Fn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Recognizing=2]="Recognizing",Z[Z.Recognized=3]="Recognized",Z[Z.Stopped=4]="Stopped",Z[Z.Error=5]="Error"})(Fn||(e.SpeechToTextStatus=Fn={}));var Mn;(function(Z){Z[Z.Started=1]="Started",Z[Z.Stopped=2]="Stopped",Z[Z.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var jn;(function(Z){Z[Z.Recognized=1]="Recognized",Z[Z.Stopped=2]="Stopped"})(jn||(e.KeywordRecognitionStatus=jn={}));class Dr{constructor(H,me){this.text=H,this.range=me}}e.$LP=Dr;var zn;(function(Z){Z[Z.Invoke=0]="Invoke",Z[Z.Automatic=1]="Automatic"})(zn||(e.InlineEditTriggerKind=zn={}))}),define(Ee[341],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$qN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,O,$){if(this.a.size===0)throw new Error("No related information providers registered");const l=this.a.get(L);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(O,$)??[]}getRelatedInformation(L,O,$){return this.c.$getAiRelatedInformation(O,$)}registerRelatedInformationProvider(L,O,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiRelatedInformationProvider(l,O),new h.$sN(()=>{this.c.$unregisterAiRelatedInformationProvider(l),this.a.delete(l)})}}e.$znc=A}),define(Ee[128],Se([1,0,4,6,10,24,155,5,20]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=void 0,e.$Knc=(0,O.$Fi)("IExtHostAuthentication");let l=class{constructor(u){this.b=new Map,this.c=new r.$me,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=u.getProxy(h.$qN.MainThreadAuthentication)}async getSession(u,k,b,c={}){const g=R.$qn.toKey(u.identifier),d=[...b].sort().join(" ");return await this.d.getOrCreate(`${g} ${k} ${d}`,async()=>{await this.a.$ensureProvider(k);const m=u.displayName||u.name;return this.a.$getSession(k,b,g,m,c)})}async getSessions(u,k,b){const c=R.$qn.toKey(u.identifier),g=[...b].sort().join(" ");return await this.f.getOrCreate(`${c} ${g}`,async()=>{await this.a.$ensureProvider(k);const d=u.displayName||u.name;return this.a.$getSessions(k,b,c,d)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,k){const b=this.b.get(u);return b?b.provider.removeSession(k):this.a.$removeSession(u,k)}registerAuthenticationProvider(u,k,b,c){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:k,provider:b,options:c??{supportsMultipleAccounts:!1}});const g=b.onDidChangeSessions(d=>this.a.$sendDidChangeSessions(u,d));return this.a.$registerAuthenticationProvider(u,k,c?.supportsMultipleAccounts??!1),new A.$sN(()=>{g.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,k,b){const c=this.b.get(u);if(c)return await c.provider.createSession(k,b);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,k){const b=this.b.get(u);if(b)return await b.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,k,b){const c=this.b.get(u);if(c)return await c.provider.getSessions(k,b);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,k){return u.startsWith(L.$sM)||this.c.fire({provider:{id:u,label:k}}),Promise.resolve()}};e.$Lnc=l,e.$Lnc=l=Je([Ve(0,$.$WP)],l);class I{constructor(){this.a=new Map}getOrCreate(u,k){const b=this.a.get(u);if(b)return b;const c=k().finally(()=>this.a.delete(u));return this.a.set(u,c),c}}}),define(Ee[162],Se([1,0,2,6,10,5,20,12,19,13,16,26]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0;let k=class{static{u=this}static{this.c=0}static{this.d=250}constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(h.$qN.MainThreadDecorations)}registerFileDecorationProvider(c,g){const d=u.c++;this.f.set(d,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(d,g.identifier.value);const m=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(d,null);return}const o=(0,$.$4b)(n);if(o.length<=u.d){this.g.$onDidChange(d,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,o.length);const i=o.map(f=>({uri:f,rank:(0,l.$jf)(f.path,"/")})),t=(0,$.$Bb)(i,(f,a)=>f.rank-a.rank||(0,l.$zf)(f.uri.path,a.uri.path)),s=[];e:for(const f of t){let a;for(const w of f){const y=(0,I.$oc)(w.uri.path);if(a!==y&&(a=y,s.push(w.uri)>=u.d))break e}}this.g.$onDidChange(d,s)});return new A.$sN(()=>{m?.dispose(),this.g.$unregisterDecorationProvider(d),this.f.delete(d)})}async $provideDecorations(c,g,d){if(!this.f.has(c))return Object.create(null);const m=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(c);return await Promise.all(g.map(async i=>{try{const{uri:t,id:s}=i,f=await Promise.resolve(n.provideFileDecoration(r.URI.revive(t),d));if(!f)return;try{A.$SO.validate(f),f.badge&&typeof f.badge!="string"&&(0,E.$5G)(o,"codiconDecoration"),m[s]=[f.propagate,f.tooltip,f.badge,f.color]}catch(a){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${a}`)}}catch(t){this.h.error(t)}})),m}};e.$Poc=k,e.$Poc=k=u=Je([Ve(0,L.$WP),Ve(1,O.$_j)],k),e.$Qoc=(0,R.$Fi)("IExtHostDecorations")}),define(Ee[342],Se([1,0,14,2,10,6,15,21,13]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;class l{static{this.a=0}constructor(E,u,k){this.d=u,this.e=k,this.b=new Map,this.c=E.getProxy(R.$qN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,u){if(Object.keys(L.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const k=l.a++;this.b.set(k,u),this.c.$registerTextContentProvider(k,E);let b;if(typeof u.onDidChange=="function"){let c;b=u.onDidChange(async g=>{if(g.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const d=this.$provideTextDocumentContent(k,g).then(async m=>{if(!m&&typeof m!="string")return;const n=this.d.getDocument(g);if(!n)return;const o=(0,$.$tf)(m);if(!n.equalLines(o))return this.c.$onVirtualDocumentChange(g,m)}).catch(r.$3).finally(()=>{c===d&&(c=void 0)});c=d})}return new A.$sN(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(E,u){const k=this.b.get(E);return k?Promise.resolve(k.provideTextDocumentContent(h.URI.revive(u),O.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Soc=l}),define(Ee[163],Se([1,0,66,15,13,197,138,10,19]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=e.$ZP=void 0,e.$YP=I;const l=new Map;function I(b,c){c?l.set(b,c):l.delete(b)}function E(b){return l.get(b)}class u extends R.$iw{constructor(c,g,d,m,n,o,i){super(g,d,m,n),this.c=c,this.m=o,this.q=i,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$wb)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===h.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?O.EndOfLine.LF:O.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,d){return c.y(g,d)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,r.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,r.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const d=this.g,m=g.start.line,n=g.end.line,o=[];o.push(this.f[m].substring(g.start.character));for(let i=m+1;i<n;i++)o.push(this.f[i]);return o.push(this.f[n].substring(0,g.end.character)),o.join(d)}t(c){let g;if(c instanceof O.$tN?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new k(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),d=this.f[g.index].length;return new O.$tN(g.index,Math.min(g.remainder,d))}w(c){if(!(c instanceof O.$uN))throw new Error("Invalid argument");const g=this.x(c.start),d=this.x(c.end);return g===c.start&&d===c.end?c:new O.$uN(g.line,g.character,d.line,d.character)}x(c){if(!(c instanceof O.$tN))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:d}=c,m=!1;if(g<0)g=0,d=0,m=!0;else if(g>=this.f.length)g=this.f.length-1,d=this.f[g].length,m=!0;else{const n=this.f[g].length;d<0?(d=0,m=!0):d>n&&(d=n,m=!0)}return m?new O.$tN(g,d):c}y(c,g){const d=this.x(c);if(!g)g=E(this.m);else if((0,A.$sf)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const m=(0,L.$kt)(d.character+1,(0,L.$it)(g),this.f[d.line],0);if(m)return new O.$uN(d.line,m.startColumn-1,d.line,m.endColumn-1)}}e.$ZP=u;class k{constructor(c,g,d){this.a=c,this.b=g,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new O.$uN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new O.$uN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$1P=k}),define(Ee[343],Se([1,0,6,10]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class A{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$qN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,O,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const l=this.a.get(L);if(!l)throw new Error("Embedding vector provider not found");const I=await l.provideEmbeddingVector(O,$);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,O,$){const l=this.b;return this.b++,this.a.set(l,$),this.c.$registerAiEmbeddingVectorProvider(O,l),new h.$sN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(l),this.a.delete(l)})}}e.$Voc=A}),define(Ee[76],Se([1,0,6,28,10,22,5,20,63,3,9,23,15]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0,h=We(h);let b=k=class{constructor(g,d){this.b=new Map,this.c=new I.$Oh,this.a=g.getProxy(r.$qN.MainThreadFileSystem);const m=this;this.value=Object.freeze({async stat(n){try{let o;const i=m.b.get(n.scheme);return i?(await m.a.$ensureActivation(n.scheme),o=await i.impl.stat(n)):o=await m.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===h.FilePermission.Readonly?1:void 0}}catch(o){k.e(o)}},async readDirectory(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await m.a.$readdir(n)}catch(o){return k.e(o)}},async createDirectory(n){try{const o=m.b.get(n.scheme);return o&&!o.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(o.impl,o.extUri,n)):await m.a.$mkdir(n)}catch(o){return k.e(o)}},async readFile(n){try{const o=m.b.get(n.scheme);return o?(await m.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await m.a.$readFile(n)).buffer}catch(o){return k.e(o)}},async writeFile(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly?(await m.a.$ensureActivation(n.scheme),await m.d(i.impl,i.extUri,i.extUri.dirname(n)),await m.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await m.a.$writeFile(n,R.$Oe.wrap(o))}catch(i){return k.e(i)}},async delete(n,o){try{const i=m.b.get(n.scheme);return i&&!i.isReadonly&&!o?.useTrash?(await m.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...o})):await m.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(i){return k.e(i)}},async rename(n,o,i){try{return await m.a.$rename(n,o,{overwrite:!1,...i})}catch(t){return k.e(t)}},async copy(n,o,i){try{return await m.a.$copy(n,o,{overwrite:!1,...i})}catch(t){return k.e(t)}},isWritableFileSystem(n){const o=d.getCapabilities(n);if(typeof o=="number")return!(o&h.FileSystemProviderCapabilities.Readonly)}})}async d(g,d,m){const n=[];for(;!d.isEqual(m,d.dirname(m));)try{if(!((await g.stat(m)).type&h.FileType.Directory))throw A.$JO.FileExists(`Unable to create folder '${m.scheme===u.Schemas.file?m.fsPath:m.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(h.$pl(o)!==h.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(d.basename(m)),m=d.dirname(m)}for(let o=n.length-1;o>=0;o--){m=d.joinPath(m,n[o]);try{await g.createDirectory(m)}catch(i){if(h.$pl(i)!==h.FileSystemProviderErrorCode.FileExists)throw i}}}static e(g){if(g instanceof A.$JO)throw g;if(g instanceof h.$ll)switch(g.code){case h.FileSystemProviderErrorCode.FileExists:throw A.$JO.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$JO.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$JO.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$JO.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$JO.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$JO.Unavailable(g.message);default:throw new A.$JO(g.message,g.name)}if(!(g instanceof Error))throw new A.$JO(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw A.$JO.Unavailable(g.message);switch(g.name){case h.FileSystemProviderErrorCode.FileExists:throw A.$JO.FileExists(g.message);case h.FileSystemProviderErrorCode.FileNotFound:throw A.$JO.FileNotFound(g.message);case h.FileSystemProviderErrorCode.FileNotADirectory:throw A.$JO.FileNotADirectory(g.message);case h.FileSystemProviderErrorCode.FileIsADirectory:throw A.$JO.FileIsADirectory(g.message);case h.FileSystemProviderErrorCode.NoPermissions:throw A.$JO.NoPermissions(g.message);case h.FileSystemProviderErrorCode.Unavailable:throw A.$JO.Unavailable(g.message);default:throw new A.$JO(g.message,g.name)}}addFileSystemProvider(g,d,m){return this.b.set(g,{impl:d,extUri:m?.isCaseSensitive?E.$9g:E.$$g,isReadonly:!!m?.isReadonly}),(0,l.$Uc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??E.$9g}};e.$1nc=b,e.$1nc=b=k=Je([Ve(0,O.$WP),Ve(1,$.$Enc)],b),e.$2nc=(0,L.$Fi)("IExtHostConsumerFileSystem")}),define(Ee[98],Se([1,0,5,30,12,76,2]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=e.$3nc=void 0,e.$3nc=(0,r.$Fi)("IExtensionStoragePaths");let O=class{constructor(l,I,E){this.d=I,this.f=E,this.a=l.workspace??void 0,this.b=l.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(l){return L.URI.joinPath(this.b.workspaceStorageHome,l)}async h(){if(!this.a)return Promise.resolve(void 0);const l=this.a.id,I=await this.g(l);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue(l){if(this.c)return L.URI.joinPath(this.c,l.identifier.value)}globalValue(l){return L.URI.joinPath(this.b.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$4nc=O,e.$4nc=O=Je([Ve(0,h.$aQ),Ve(1,A.$_j),Ve(2,R.$2nc)],O)}),define(Ee[344],Se([1,0,10,20,4]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0;let R=class{constructor(O){this.a=new r.$TO(r.ColorThemeKind.Dark),this.b=new A.$me}get activeColorTheme(){return this.a}$onColorThemeChange(O){let $;switch(O){case"light":$=r.ColorThemeKind.Light;break;case"hcDark":$=r.ColorThemeKind.HighContrast;break;case"hcLight":$=r.ColorThemeKind.HighContrastLight;break;default:$=r.ColorThemeKind.Dark}this.a=new r.$TO($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$zpc=R,e.$zpc=R=Je([Ve(0,h.$WP)],R)}),define(Ee[77],Se([1,0,21,4,3,243,5,12,93,6,30,20,10]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nFb=e.$mFb=e.TunnelDtoConverter=void 0,R=We(R),u=We(u);class k extends $.$Hw{}var b;(function(g){function d(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}g.fromApiTunnel=d;function m(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}g.fromServiceTunnel=m})(b||(e.TunnelDtoConverter=b={})),e.$mFb=(0,L.$Fi)("IExtHostTunnelService");let c=class extends A.$Wc{constructor(d,m,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new h.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=d.getProxy(l.$qN.MainThreadTunnelService)}async openTunnel(d,m){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${d.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const n=await this.a.$openTunnel(m,d.displayName);if(n){const o=new k(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(d,m){d.portRange===void 0&&d.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:d,provider:m}),this.a.$registerPortsAttributesProvider(d,n),new u.$sN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(d,m,n,o,i){const t=[];for(const f of d){const a=this.r.get(f);if(!a)return[];t.push(...await Promise.all(m.map(async w=>{let y;try{y=await a.provider.providePortAttributes({port:w,pid:n,commandLine:o},i)}catch{y=await a.provider.providePortAttributes(w,n,o,i)}return{providedAttributes:y,port:w}})))}const s=t.filter(f=>!!f.providedAttributes);return s.length>0?s.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(d){}registerTunnelProvider(d,m){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,i)=>await d.provideTunnel(o,i,r.CancellationToken.None)??void 0;const n=m.tunnelFeatures?{elevation:!!m.tunnelFeatures?.elevation,privacyOptions:m.tunnelFeatures?.privacyOptions,protocol:m.tunnelFeatures.protocol===void 0?!0:m.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,A.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(d,m){if(d){d.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(d.candidatePortSource),d.showCandidatePort&&(this.f=d.showCandidatePort,this.a.$setCandidateFilter());const n=d.tunnelFactory??(m?this.w(m):void 0);if(n){this.b=n;let o=d.tunnelFeatures?.privacyOptions??[];d.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const i=d.tunnelFeatures?{elevation:!!d.tunnelFeatures?.elevation,public:!!d.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,A.$Uc)(()=>{this.b=void 0})}w(d){}async $closeTunnel(d,m){if(this.g.has(d.host)){const n=this.g.get(d.host);n.has(d.port)&&(m&&n.get(d.port).disposeListener.dispose(),await n.get(d.port).tunnel.dispose(),n.delete(d.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(d,m){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(d,m);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(d.remoteAddress.host)||this.g.set(d.remoteAddress.host,new Map);const i=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(d.remoteAddress.host).set(d.remoteAddress.port,{tunnel:o,disposeListener:i}),b.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(d){const m=await Promise.all(d.map(o=>this.f(o.host,o.port,o.detail??""))),n=d.filter((o,i)=>m[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${d.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$nFb=c,e.$nFb=c=Je([Ve(0,E.$WP),Ve(1,I.$aQ),Ve(2,O.$_j)],c)}),define(Ee[17],Se([1,0,19,22,186,80,86,29,176,57,108,25,181,23,50,18,2,114,31,106,88,54,145,90,154,152,306,322,120,127,74,75,318,10]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a,w,y,S,D,P,C,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$TP=ee,e.$UP=ne,e.$VP=De,L=We(L),m=We(m),n=We(n),o=We(o),y=We(y),D=We(D),v=We(v);var N;(function(Ae){function je(ie){const{selectionStartLineNumber:Re,selectionStartColumn:He,positionLineNumber:et,positionColumn:Qe}=ie,ft=new v.$tN(Re-1,He-1),At=new v.$tN(et-1,Qe-1);return new v.$vN(ft,At)}Ae.to=je;function ve(ie){const{anchor:Re,active:He}=ie;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Ae.from=ve})(N||(e.Selection=N={}));var T;(function(Ae){function je(ie){if(!ie)return;const{start:Re,end:He}=ie;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Ae.from=je;function ve(ie){if(!ie)return;const{startLineNumber:Re,startColumn:He,endLineNumber:et,endColumn:Qe}=ie;return new v.$uN(Re-1,He-1,et-1,Qe-1)}Ae.to=ve})(T||(e.Range=T={}));var M;(function(Ae){function je(ie){return{uri:ie.uri,range:T.from(ie.range)}}Ae.from=je;function ve(ie){return new v.$EN(g.URI.revive(ie.uri),T.to(ie.range))}Ae.to=ve})(M||(e.Location=M={}));var j;(function(Ae){function je(ve){switch(ve){case n.StandardTokenType.Comment:return v.StandardTokenType.Comment;case n.StandardTokenType.Other:return v.StandardTokenType.Other;case n.StandardTokenType.RegEx:return v.StandardTokenType.RegEx;case n.StandardTokenType.String:return v.StandardTokenType.String}}Ae.to=je})(j||(e.TokenType=j={}));var z;(function(Ae){function je(ie){return new v.$tN(ie.lineNumber-1,ie.column-1)}Ae.to=je;function ve(ie){return{lineNumber:ie.line+1,column:ie.character+1}}Ae.from=ve})(z||(e.Position=z={}));var F;(function(Ae){function je(Re,He,et){return(0,r.$Jb)((0,r.$4b)(Re).map(Qe=>ve(Qe,He,et)))}Ae.from=je;function ve(Re,He,et){if(typeof Re=="string")return{$serialized:!0,language:Re,isBuiltin:et?.isBuiltin};if(Re)return{$serialized:!0,language:Re.language,scheme:ie(Re.scheme,He),pattern:_e.from(Re.pattern)??void 0,exclusive:Re.exclusive,notebookType:Re.notebookType,isBuiltin:et?.isBuiltin}}function ie(Re,He){return He&&typeof Re=="string"?He.transformOutgoingScheme(Re):Re}})(F||(e.DocumentSelector=F={}));var B;(function(Ae){function je(ie){switch(ie){case v.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case v.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case t.MarkerTag.Unnecessary:return v.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return v.DiagnosticTag.Deprecated;default:return}}Ae.to=ve})(B||(e.DiagnosticTag=B={}));var _;(function(Ae){function je(ie){let Re;return ie.code&&((0,c.$fg)(ie.code)||(0,c.$jg)(ie.code)?Re=String(ie.code):Re={value:String(ie.code.value),target:ie.code.target}),{...T.from(ie.range),message:ie.message,source:ie.source,code:Re,severity:U.from(ie.severity),relatedInformation:ie.relatedInformation&&ie.relatedInformation.map(re.from),tags:Array.isArray(ie.tags)?(0,r.$Jb)(ie.tags.map(B.from)):void 0}}Ae.from=je;function ve(ie){const Re=new v.$GN(T.to(ie),ie.message,U.to(ie.severity));return Re.source=ie.source,Re.code=(0,c.$fg)(ie.code)?ie.code:ie.code?.value,Re.relatedInformation=ie.relatedInformation&&ie.relatedInformation.map(re.to),Re.tags=ie.tags&&(0,r.$Jb)(ie.tags.map(B.to)),Re}Ae.to=ve})(_||(e.Diagnostic=_={}));var re;(function(Ae){function je(ie){return{...T.from(ie.location.range),message:ie.message,resource:ie.location.uri}}Ae.from=je;function ve(ie){return new v.$FN(new v.$EN(ie.resource,T.to(ie)),ie.message)}Ae.to=ve})(re||(e.DiagnosticRelatedInformation=re={}));var U;(function(Ae){function je(ie){switch(ie){case v.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case v.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case v.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case v.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ae.from=je;function ve(ie){switch(ie){case t.MarkerSeverity.Info:return v.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return v.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return v.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return v.DiagnosticSeverity.Hint;default:return v.DiagnosticSeverity.Error}}Ae.to=ve})(U||(e.DiagnosticSeverity=U={}));var G;(function(Ae){function je(ie){return typeof ie=="number"&&ie>=v.ViewColumn.One?ie-1:ie===v.ViewColumn.Beside?p.$mE:p.$lE}Ae.from=je;function ve(ie){if(typeof ie=="number"&&ie>=0)return ie+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=ve})(G||(e.ViewColumn=G={}));function Q(Ae){return typeof Ae.range<"u"}function ee(Ae){return Ae.length===0?!0:!!Q(Ae[0])}var ue;(function(Ae){function je(Qe){return Qe.map(Ae.from)}Ae.fromMany=je;function ve(Qe){return Qe&&typeof Qe=="object"&&typeof Qe.language=="string"&&typeof Qe.value=="string"}function ie(Qe){let ft;if(ve(Qe)){const{language:zt,value:ri}=Qe;ft={value:"```"+zt+`
`+ri+"\n```\n"}}else v.$UN.isMarkdownString(Qe)?ft={value:Qe.value,isTrusted:Qe.isTrusted,supportThemeIcons:Qe.supportThemeIcons,supportHtml:Qe.supportHtml,baseUri:Qe.baseUri}:typeof Qe=="string"?ft={value:Qe}:ft={value:""};const At=Object.create(null);ft.uris=At;const xt=zt=>{try{let ri=g.URI.parse(zt,!0);ri=ri.with({query:Re(ri.query,At)}),At[zt]=ri}catch{}return""},ci=new $.marked.Renderer;return ci.link=xt,ci.image=zt=>typeof zt=="string"?xt(L.$$k(zt).href):"",(0,$.marked)(ft.value,{renderer:ci}),ft}Ae.from=ie;function Re(Qe,ft){if(!Qe)return Qe;let At;try{At=(0,l.$bi)(Qe)}catch{}if(!At)return Qe;let xt=!1;return At=(0,E.$eo)(At,ci=>{if(g.URI.isUri(ci)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[zt]=ci,xt=!0,zt}else return}),xt?JSON.stringify(At):Qe}function He(Qe){const ft=new v.$UN(Qe.value,Qe.supportThemeIcons);return ft.isTrusted=Qe.isTrusted,ft.supportHtml=Qe.supportHtml,ft.baseUri=Qe.baseUri?g.URI.from(Qe.baseUri):void 0,ft}Ae.to=He;function et(Qe){if(Qe)return typeof Qe=="string"?Qe:Ae.from(Qe)}Ae.fromStrict=et})(ue||(e.MarkdownString=ue={}));function ne(Ae){return ee(Ae)?Ae.map(je=>({range:T.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?ue.fromMany(je.hoverMessage):je.hoverMessage?ue.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Ae.map(je=>({range:T.from(je)}))}function De(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?g.URI.file(Ae):Ae}var $e;(function(Ae){function je(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?De(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Ae.from=je})($e||(e.ThemableDecorationAttachmentRenderOptions=$e={}));var K;(function(Ae){function je(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=je})(K||(e.ThemableDecorationRenderOptions=K={}));var W;(function(Ae){function je(ve){if(typeof ve>"u")return ve;switch(ve){case v.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case v.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case v.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Ae.from=je})(W||(e.DecorationRangeBehavior=W={}));var se;(function(Ae){function je(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?W.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?K.from(ve.light):void 0,dark:ve.dark?K.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?De(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?$e.from(ve.before):void 0,after:ve.after?$e.from(ve.after):void 0}}Ae.from=je})(se||(e.DecorationRenderOptions=se={}));var oe;(function(Ae){function je(ie){return{text:ie.newText,eol:ie.newEol&&Me.from(ie.newEol),range:T.from(ie.range)}}Ae.from=je;function ve(ie){const Re=new v.$zN(T.to(ie.range),ie.text);return Re.newEol=typeof ie.eol>"u"?void 0:Me.to(ie.eol),Re}Ae.to=ve})(oe||(e.TextEdit=oe={}));var te;(function(Ae){function je(ie,Re){const He={edits:[]};if(ie instanceof v.$CN){const et=new O.$Dc;for(const Qe of ie._allEntries())Qe._type===v.FileEditType.File&&g.URI.isUri(Qe.to)&&Qe.from===void 0&&et.add(Qe.to);for(const Qe of ie._allEntries())if(Qe._type===v.FileEditType.File){let ft;Qe.options?.contents&&(ArrayBuffer.isView(Qe.options.contents)?ft={type:"base64",value:(0,h.$9e)(h.$Oe.wrap(Qe.options.contents))}:ft={type:"dataTransferItem",id:Qe.options.contents._itemId}),He.edits.push({oldResource:Qe.from,newResource:Qe.to,options:{...Qe.options,contents:ft},metadata:Qe.metadata})}else Qe._type===v.FileEditType.Text?He.edits.push({resource:Qe.uri,textEdit:oe.from(Qe.edit),versionId:et.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Snippet?He.edits.push({resource:Qe.uri,textEdit:{range:T.from(Qe.range),text:Qe.edit.value,insertAsSnippet:!0},versionId:et.has(Qe.uri)?void 0:Re?.getTextDocumentVersion(Qe.uri),metadata:Qe.metadata}):Qe._type===v.FileEditType.Cell?He.edits.push({metadata:Qe.metadata,resource:Qe.uri,cellEdit:Qe.edit,notebookMetadata:Qe.notebookMetadata,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri)}):Qe._type===v.FileEditType.CellReplace&&He.edits.push({metadata:Qe.metadata,resource:Qe.uri,notebookVersionId:Re?.getNotebookDocumentVersion(Qe.uri),cellEdit:{editType:D.CellEditType.Replace,index:Qe.index,count:Qe.count,cells:Qe.cells.map(Ct.from)}})}return He}Ae.from=je;function ve(ie){const Re=new v.$CN,He=new O.$Cc;for(const et of ie.edits)if(et.textEdit){const Qe=et,ft=g.URI.revive(Qe.resource),At=T.to(Qe.textEdit.range),xt=Qe.textEdit.text,ci=Qe.textEdit.insertAsSnippet;let zt;ci?zt=v.$BN.replace(At,new v.$DN(xt)):zt=v.$zN.replace(At,xt);const ri=He.get(ft);ri?ri.push(zt):He.set(ft,[zt])}else Re.renameFile(g.URI.revive(et.oldResource),g.URI.revive(et.newResource),et.options);for(const[et,Qe]of He)Re.set(et,Qe);return Re}Ae.to=ve})(te||(e.WorkspaceEdit=te={}));var le;(function(Ae){const je=Object.create(null);je[v.SymbolKind.File]=o.SymbolKind.File,je[v.SymbolKind.Module]=o.SymbolKind.Module,je[v.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[v.SymbolKind.Package]=o.SymbolKind.Package,je[v.SymbolKind.Class]=o.SymbolKind.Class,je[v.SymbolKind.Method]=o.SymbolKind.Method,je[v.SymbolKind.Property]=o.SymbolKind.Property,je[v.SymbolKind.Field]=o.SymbolKind.Field,je[v.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[v.SymbolKind.Enum]=o.SymbolKind.Enum,je[v.SymbolKind.Interface]=o.SymbolKind.Interface,je[v.SymbolKind.Function]=o.SymbolKind.Function,je[v.SymbolKind.Variable]=o.SymbolKind.Variable,je[v.SymbolKind.Constant]=o.SymbolKind.Constant,je[v.SymbolKind.String]=o.SymbolKind.String,je[v.SymbolKind.Number]=o.SymbolKind.Number,je[v.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[v.SymbolKind.Array]=o.SymbolKind.Array,je[v.SymbolKind.Object]=o.SymbolKind.Object,je[v.SymbolKind.Key]=o.SymbolKind.Key,je[v.SymbolKind.Null]=o.SymbolKind.Null,je[v.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[v.SymbolKind.Struct]=o.SymbolKind.Struct,je[v.SymbolKind.Event]=o.SymbolKind.Event,je[v.SymbolKind.Operator]=o.SymbolKind.Operator,je[v.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ve(Re){return typeof je[Re]=="number"?je[Re]:o.SymbolKind.Property}Ae.from=ve;function ie(Re){for(const He in je)if(je[He]===Re)return Number(He);return v.SymbolKind.Property}Ae.to=ie})(le||(e.SymbolKind=le={}));var he;(function(Ae){function je(ie){switch(ie){case v.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case o.SymbolTag.Deprecated:return v.SymbolTag.Deprecated}}Ae.to=ve})(he||(e.SymbolTag=he={}));var X;(function(Ae){function je(ie){return{name:ie.name,kind:le.from(ie.kind),tags:ie.tags&&ie.tags.map(he.from),containerName:ie.containerName,location:Be.from(ie.location)}}Ae.from=je;function ve(ie){const Re=new v.$LN(ie.name,le.to(ie.kind),ie.containerName,Be.to(ie.location));return Re.tags=ie.tags&&ie.tags.map(he.to),Re}Ae.to=ve})(X||(e.WorkspaceSymbol=X={}));var ae;(function(Ae){function je(ie){const Re={name:ie.name||"!!MISSING: name!!",detail:ie.detail,range:T.from(ie.range),selectionRange:T.from(ie.selectionRange),kind:le.from(ie.kind),tags:ie.tags?.map(he.from)??[]};return ie.children&&(Re.children=ie.children.map(je)),Re}Ae.from=je;function ve(ie){const Re=new v.$MN(ie.name,ie.detail,le.to(ie.kind),T.to(ie.range),T.to(ie.selectionRange));return(0,r.$Nb)(ie.tags)&&(Re.tags=ie.tags.map(he.to)),ie.children&&(Re.children=ie.children.map(ve)),Re}Ae.to=ve})(ae||(e.DocumentSymbol=ae={}));var pe;(function(Ae){function je(ie){const Re=new v.$QN(le.to(ie.kind),ie.name,ie.detail||"",g.URI.revive(ie.uri),T.to(ie.range),T.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=je;function ve(ie,Re,He){if(Re=Re??ie._sessionId,He=He??ie._itemId,Re===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:He,name:ie.name,detail:ie.detail,kind:le.from(ie.kind),uri:ie.uri,range:T.from(ie.range),selectionRange:T.from(ie.selectionRange),tags:ie.tags?.map(he.from)}}Ae.from=ve})(pe||(e.CallHierarchyItem=pe={}));var be;(function(Ae){function je(ve){return new v.$RN(pe.to(ve.from),ve.fromRanges.map(ie=>T.to(ie)))}Ae.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Fe;(function(Ae){function je(ve){return new v.$SN(pe.to(ve.to),ve.fromRanges.map(ie=>T.to(ie)))}Ae.to=je})(Fe||(e.CallHierarchyOutgoingCall=Fe={}));var Be;(function(Ae){function je(ie){return{range:ie.range&&T.from(ie.range),uri:ie.uri}}Ae.from=je;function ve(ie){return new v.$EN(g.URI.revive(ie.uri),T.to(ie.range))}Ae.to=ve})(Be||(e.location=Be={}));var ke;(function(Ae){function je(ie){const Re=ie,He=ie;return{originSelectionRange:Re.originSelectionRange?T.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:He.uri,range:T.from(Re.targetRange?Re.targetRange:He.range),targetSelectionRange:Re.targetSelectionRange?T.from(Re.targetSelectionRange):void 0}}Ae.from=je;function ve(ie){return{targetUri:g.URI.revive(ie.uri),targetRange:T.to(ie.range),targetSelectionRange:ie.targetSelectionRange?T.to(ie.targetSelectionRange):void 0,originSelectionRange:ie.originSelectionRange?T.to(ie.originSelectionRange):void 0}}Ae.to=ve})(ke||(e.DefinitionLink=ke={}));var Ie;(function(Ae){function je(ie){return{range:T.from(ie.range),contents:ue.fromMany(ie.contents),canIncreaseVerbosity:ie.canIncreaseVerbosity,canDecreaseVerbosity:ie.canDecreaseVerbosity}}Ae.from=je;function ve(ie){const Re=ie.contents.map(ue.to),He=T.to(ie.range),et=ie.canIncreaseVerbosity,Qe=ie.canDecreaseVerbosity;return new v.$IN(Re,He,et,Qe)}Ae.to=ve})(Ie||(e.Hover=Ie={}));var Oe;(function(Ae){function je(ie){return{range:T.from(ie.range),expression:ie.expression}}Ae.from=je;function ve(ie){return new v.$DO(T.to(ie.range),ie.expression)}Ae.to=ve})(Oe||(e.EvaluatableExpression=Oe={}));var q;(function(Ae){function je(ie){if(ie instanceof v.$EO)return{type:"text",range:T.from(ie.range),text:ie.text};if(ie instanceof v.$FO)return{type:"variable",range:T.from(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};if(ie instanceof v.$GO)return{type:"expression",range:T.from(ie.range),expression:ie.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=je;function ve(ie){switch(ie.type){case"text":return{range:T.to(ie.range),text:ie.text};case"variable":return{range:T.to(ie.range),variableName:ie.variableName,caseSensitiveLookup:ie.caseSensitiveLookup};case"expression":return{range:T.to(ie.range),expression:ie.expression}}}Ae.to=ve})(q||(e.InlineValue=q={}));var V;(function(Ae){function je(ie){return{frameId:ie.frameId,stoppedLocation:T.from(ie.stoppedLocation)}}Ae.from=je;function ve(ie){return new v.$HO(ie.frameId,T.to(ie.stoppedLocation))}Ae.to=ve})(V||(e.InlineValueContext=V={}));var J;(function(Ae){function je(ie){return{range:T.from(ie.range),kind:ie.kind}}Ae.from=je;function ve(ie){return new v.$JN(T.to(ie.range),ie.kind)}Ae.to=ve})(J||(e.DocumentHighlight=J={}));var x;(function(Ae){function je(ie){return{uri:ie.uri,highlights:ie.highlights.map(J.from)}}Ae.from=je;function ve(ie){return new v.$KN(g.URI.revive(ie.uri),ie.highlights.map(J.to))}Ae.to=ve})(x||(e.MultiDocumentHighlight=x={}));var fe;(function(Ae){function je(ve){switch(ve){case o.CompletionTriggerKind.TriggerCharacter:return v.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return v.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return v.CompletionTriggerKind.Invoke}}Ae.to=je})(fe||(e.CompletionTriggerKind=fe={}));var we;(function(Ae){function je(ve){return{triggerKind:fe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Ae.to=je})(we||(e.CompletionContext=we={}));var Ne;(function(Ae){function je(ie){switch(ie){case v.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Ae.from=je;function ve(ie){switch(ie){case o.CompletionItemTag.Deprecated:return v.CompletionItemTag.Deprecated}}Ae.to=ve})(Ne||(e.CompletionItemTag=Ne={}));var Ge;(function(Ae){const je=new Map([[v.CompletionItemKind.Method,o.CompletionItemKind.Method],[v.CompletionItemKind.Function,o.CompletionItemKind.Function],[v.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[v.CompletionItemKind.Field,o.CompletionItemKind.Field],[v.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[v.CompletionItemKind.Class,o.CompletionItemKind.Class],[v.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[v.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[v.CompletionItemKind.Module,o.CompletionItemKind.Module],[v.CompletionItemKind.Property,o.CompletionItemKind.Property],[v.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[v.CompletionItemKind.Value,o.CompletionItemKind.Value],[v.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[v.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[v.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[v.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[v.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[v.CompletionItemKind.Text,o.CompletionItemKind.Text],[v.CompletionItemKind.Color,o.CompletionItemKind.Color],[v.CompletionItemKind.File,o.CompletionItemKind.File],[v.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[v.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[v.CompletionItemKind.Event,o.CompletionItemKind.Event],[v.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[v.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[v.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[v.CompletionItemKind.User,o.CompletionItemKind.User]]);function ve(He){return je.get(He)??o.CompletionItemKind.Property}Ae.from=ve;const ie=new Map([[o.CompletionItemKind.Method,v.CompletionItemKind.Method],[o.CompletionItemKind.Function,v.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,v.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,v.CompletionItemKind.Field],[o.CompletionItemKind.Variable,v.CompletionItemKind.Variable],[o.CompletionItemKind.Class,v.CompletionItemKind.Class],[o.CompletionItemKind.Interface,v.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,v.CompletionItemKind.Struct],[o.CompletionItemKind.Module,v.CompletionItemKind.Module],[o.CompletionItemKind.Property,v.CompletionItemKind.Property],[o.CompletionItemKind.Unit,v.CompletionItemKind.Unit],[o.CompletionItemKind.Value,v.CompletionItemKind.Value],[o.CompletionItemKind.Constant,v.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,v.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,v.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,v.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,v.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,v.CompletionItemKind.Text],[o.CompletionItemKind.Color,v.CompletionItemKind.Color],[o.CompletionItemKind.File,v.CompletionItemKind.File],[o.CompletionItemKind.Reference,v.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,v.CompletionItemKind.Folder],[o.CompletionItemKind.Event,v.CompletionItemKind.Event],[o.CompletionItemKind.Operator,v.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,v.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,v.CompletionItemKind.User],[o.CompletionItemKind.Issue,v.CompletionItemKind.Issue]]);function Re(He){return ie.get(He)??v.CompletionItemKind.Property}Ae.to=Re})(Ge||(e.CompletionItemKind=Ge={}));var Ke;(function(Ae){function je(ve,ie){const Re=new v.$1N(ve.label);return Re.insertText=ve.insertText,Re.kind=Ge.to(ve.kind),Re.tags=ve.tags?.map(Ne.to),Re.detail=ve.detail,Re.documentation=L.$5k(ve.documentation)?ue.to(ve.documentation):ve.documentation,Re.sortText=ve.sortText,Re.filterText=ve.filterText,Re.preselect=ve.preselect,Re.commitCharacters=ve.commitCharacters,m.$It.isIRange(ve.range)?Re.range=T.to(ve.range):typeof ve.range=="object"&&(Re.range={inserting:T.to(ve.range.insert),replacing:T.to(ve.range.replace)}),Re.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ve.insertTextRules<"u"&&ve.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Re.insertText=new v.$DN(ve.insertText):(Re.insertText=ve.insertText,Re.textEdit=Re.range instanceof v.$uN?new v.$zN(Re.range,Re.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Re.additionalTextEdits=ve.additionalTextEdits.map(He=>oe.to(He))),Re.command=ie&&ve.command?ie.fromInternal(ve.command):void 0,Re}Ae.to=je})(Ke||(e.CompletionItem=Ke={}));var tt;(function(Ae){function je(ie){if(typeof ie.label!="string"&&!Array.isArray(ie.label))throw new TypeError("Invalid label");return{label:ie.label,documentation:ue.fromStrict(ie.documentation)}}Ae.from=je;function ve(ie){return{label:ie.label,documentation:L.$5k(ie.documentation)?ue.to(ie.documentation):ie.documentation}}Ae.to=ve})(tt||(e.ParameterInformation=tt={}));var rt;(function(Ae){function je(ie){return{label:ie.label,documentation:ue.fromStrict(ie.documentation),parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.from):[],activeParameter:ie.activeParameter}}Ae.from=je;function ve(ie){return{label:ie.label,documentation:L.$5k(ie.documentation)?ue.to(ie.documentation):ie.documentation,parameters:Array.isArray(ie.parameters)?ie.parameters.map(tt.to):[],activeParameter:ie.activeParameter}}Ae.to=ve})(rt||(e.SignatureInformation=rt={}));var ot;(function(Ae){function je(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.from):[]}}Ae.from=je;function ve(ie){return{activeSignature:ie.activeSignature,activeParameter:ie.activeParameter,signatures:Array.isArray(ie.signatures)?ie.signatures.map(rt.to):[]}}Ae.to=ve})(ot||(e.SignatureHelp=ot={}));var nt;(function(Ae){function je(ve,ie){const Re=new v.$ZN(z.to(ie.position),typeof ie.label=="string"?ie.label:ie.label.map(ct.to.bind(void 0,ve)),ie.kind&&$t.to(ie.kind));return Re.textEdits=ie.textEdits&&ie.textEdits.map(oe.to),Re.tooltip=L.$5k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,Re.paddingLeft=ie.paddingLeft,Re.paddingRight=ie.paddingRight,Re}Ae.to=je})(nt||(e.InlayHint=nt={}));var ct;(function(Ae){function je(ve,ie){const Re=new v.$YN(ie.label);return Re.tooltip=L.$5k(ie.tooltip)?ue.to(ie.tooltip):ie.tooltip,o.Command.is(ie.command)&&(Re.command=ve.fromInternal(ie.command)),ie.location&&(Re.location=Be.to(ie.location)),Re}Ae.to=je})(ct||(e.InlayHintLabelPart=ct={}));var $t;(function(Ae){function je(ie){return ie}Ae.from=je;function ve(ie){return ie}Ae.to=ve})($t||(e.InlayHintKind=$t={}));var ht;(function(Ae){function je(ie){return{range:T.from(ie.range),url:ie.target,tooltip:ie.tooltip}}Ae.from=je;function ve(ie){let Re;if(ie.url)try{Re=typeof ie.url=="string"?g.URI.parse(ie.url,!0):g.URI.revive(ie.url)}catch{}const He=new v.$6N(T.to(ie.range),Re);return He.tooltip=ie.tooltip,He}Ae.to=ve})(ht||(e.DocumentLink=ht={}));var at;(function(Ae){function je(ie){const Re=new v.$9N(ie.label);return ie.textEdit&&(Re.textEdit=oe.to(ie.textEdit)),ie.additionalTextEdits&&(Re.additionalTextEdits=ie.additionalTextEdits.map(He=>oe.to(He))),Re}Ae.to=je;function ve(ie){return{label:ie.label,textEdit:ie.textEdit?oe.from(ie.textEdit):void 0,additionalTextEdits:ie.additionalTextEdits?ie.additionalTextEdits.map(Re=>oe.from(Re)):void 0}}Ae.from=ve})(at||(e.ColorPresentation=at={}));var Pe;(function(Ae){function je(ie){return new v.$7N(ie[0],ie[1],ie[2],ie[3])}Ae.to=je;function ve(ie){return[ie.red,ie.green,ie.blue,ie.alpha]}Ae.from=ve})(Pe||(e.Color=Pe={}));var ze;(function(Ae){function je(ie){return{range:T.from(ie.range)}}Ae.from=je;function ve(ie){return new v.$PN(T.to(ie.range))}Ae.to=ve})(ze||(e.SelectionRange=ze={}));var Ze;(function(Ae){function je(ve){switch(ve){case a.SaveReason.AUTO:return v.TextDocumentSaveReason.AfterDelay;case a.SaveReason.EXPLICIT:return v.TextDocumentSaveReason.Manual;case a.SaveReason.FOCUS_CHANGE:case a.SaveReason.WINDOW_CHANGE:return v.TextDocumentSaveReason.FocusOut}}Ae.to=je})(Ze||(e.TextDocumentSaveReason=Ze={}));var Te;(function(Ae){function je(ie){switch(ie){case v.TextEditorLineNumbersStyle.Off:return d.RenderLineNumbersType.Off;case v.TextEditorLineNumbersStyle.Relative:return d.RenderLineNumbersType.Relative;case v.TextEditorLineNumbersStyle.Interval:return d.RenderLineNumbersType.Interval;case v.TextEditorLineNumbersStyle.On:default:return d.RenderLineNumbersType.On}}Ae.from=je;function ve(ie){switch(ie){case d.RenderLineNumbersType.Off:return v.TextEditorLineNumbersStyle.Off;case d.RenderLineNumbersType.Relative:return v.TextEditorLineNumbersStyle.Relative;case d.RenderLineNumbersType.Interval:return v.TextEditorLineNumbersStyle.Interval;case d.RenderLineNumbersType.On:default:return v.TextEditorLineNumbersStyle.On}}Ae.to=ve})(Te||(e.TextEditorLineNumbersStyle=Te={}));var Me;(function(Ae){function je(ie){if(ie===v.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(ie===v.EndOfLine.LF)return i.EndOfLineSequence.LF}Ae.from=je;function ve(ie){if(ie===i.EndOfLineSequence.CRLF)return v.EndOfLine.CRLF;if(ie===i.EndOfLineSequence.LF)return v.EndOfLine.LF}Ae.to=ve})(Me||(e.EndOfLine=Me={}));var Y;(function(Ae){function je(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case v.ProgressLocation.SourceControl:return s.ProgressLocation.Scm;case v.ProgressLocation.Window:return s.ProgressLocation.Window;case v.ProgressLocation.Notification:return s.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Ae.from=je})(Y||(e.ProgressLocation=Y={}));var de;(function(Ae){function je(ie){const Re={start:ie.start+1,end:ie.end+1};return ie.kind&&(Re.kind=Ce.from(ie.kind)),Re}Ae.from=je;function ve(ie){const Re={start:ie.start-1,end:ie.end-1};return ie.kind&&(Re.kind=Ce.to(ie.kind)),Re}Ae.to=ve})(de||(e.FoldingRange=de={}));var Ce;(function(Ae){function je(ie){if(ie)switch(ie){case v.FoldingRangeKind.Comment:return o.$Iu.Comment;case v.FoldingRangeKind.Imports:return o.$Iu.Imports;case v.FoldingRangeKind.Region:return o.$Iu.Region}}Ae.from=je;function ve(ie){if(ie)switch(ie.value){case o.$Iu.Comment.value:return v.FoldingRangeKind.Comment;case o.$Iu.Imports.value:return v.FoldingRangeKind.Imports;case o.$Iu.Region.value:return v.FoldingRangeKind.Region}}Ae.to=ve})(Ce||(e.FoldingRangeKind=Ce={}));var Xe;(function(Ae){function je(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?T.from(ve.selection):void 0,override:typeof ve.override=="boolean"?a.$PF.id:void 0}}Ae.from=je})(Xe||(e.TextEditorOpenOptions=Xe={}));var _e;(function(Ae){function je(He){return He instanceof v.$rO?He.toJSON():typeof He=="string"?He:ve(He)||ie(He)?new v.$rO(He.baseUri??He.base,He.pattern).toJSON():He}Ae.from=je;function ve(He){const et=He;return et?g.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ie(He){const et=He;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Re(He){return typeof He=="string"?He:new v.$rO(g.URI.revive(He.baseUri),He.pattern)}Ae.to=Re})(_e||(e.GlobPattern=_e={}));var lt;(function(Ae){function je(ve){if(ve){if(Array.isArray(ve))return ve.map(je);if(typeof ve=="string")return ve;{const ie=ve;return{language:ie.language,scheme:ie.scheme,pattern:_e.from(ie.pattern),exclusive:ie.exclusive,notebookType:ie.notebookType}}}else return}Ae.from=je})(lt||(e.LanguageSelector=lt={}));var gt;(function(Ae){function je(ie){return!!ie&&typeof ie=="object"&&"documents"in ie&&Array.isArray(ie.documents)&&ie.documents.every(Re=>Array.isArray(Re)&&Re.every(He=>He&&typeof He=="object"&&"uri"in He&&g.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(et=>et instanceof v.$uN)))}Ae.is=je;function ve(ie){return{documents:ie.documents.map(Re=>Re.map(He=>({uri:g.URI.from(He.uri),version:He.version,ranges:He.ranges.map(et=>T.from(et))})))}}Ae.from=ve})(gt||(e.MappedEditsContext=gt={}));var kt;(function(Ae){function je(ie){return{start:ie.start,end:ie.end}}Ae.from=je;function ve(ie){return new v.$UO(ie.start,ie.end)}Ae.to=ve})(kt||(e.NotebookRange=kt={}));var Ot;(function(Ae){function je(ie){return{timing:typeof ie.runStartTime=="number"&&typeof ie.runEndTime=="number"?{startTime:ie.runStartTime,endTime:ie.runEndTime}:void 0,executionOrder:ie.executionOrder,success:ie.lastRunSuccess}}Ae.to=je;function ve(ie){return{lastRunSuccess:ie.success,runStartTime:ie.timing?.startTime,runEndTime:ie.timing?.endTime,executionOrder:ie.executionOrder}}Ae.from=ve})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var Wt;(function(Ae){function je(ve){if(ve===D.NotebookCellExecutionState.Unconfirmed)return v.NotebookCellExecutionState.Pending;if(ve===D.NotebookCellExecutionState.Pending)return;if(ve===D.NotebookCellExecutionState.Executing)return v.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Ae.to=je})(Wt||(e.NotebookCellExecutionState=Wt={}));var ui;(function(Ae){function je(ie){switch(ie){case v.NotebookCellKind.Markup:return D.CellKind.Markup;case v.NotebookCellKind.Code:default:return D.CellKind.Code}}Ae.from=je;function ve(ie){switch(ie){case D.CellKind.Markup:return v.NotebookCellKind.Markup;case D.CellKind.Code:default:return v.NotebookCellKind.Code}}Ae.to=ve})(ui||(e.NotebookCellKind=ui={}));var it;(function(Ae){function je(ie){const Re={metadata:ie.metadata??Object.create(null),cells:[]};for(const He of ie.cells)v.$VO.validate(He),Re.cells.push(Ct.from(He));return Re}Ae.from=je;function ve(ie){const Re=new v.$WO(ie.cells.map(Ct.to));return(0,c.$sg)(ie.metadata)||(Re.metadata=ie.metadata),Re}Ae.to=ve})(it||(e.NotebookData=it={}));var Ct;(function(Ae){function je(ie){return{cellKind:ui.from(ie.kind),language:ie.languageId,mime:ie.mime,source:ie.value,metadata:ie.metadata,internalMetadata:Ot.from(ie.executionSummary??{}),outputs:ie.outputs?ie.outputs.map(mt.from):[]}}Ae.from=je;function ve(ie){return new v.$VO(ui.to(ie.cellKind),ie.source,ie.language,ie.mime,ie.outputs?ie.outputs.map(mt.to):void 0,ie.metadata,ie.internalMetadata?Ot.to(ie.internalMetadata):void 0)}Ae.to=ve})(Ct||(e.NotebookCellData=Ct={}));var Zt;(function(Ae){function je(ie){return{mime:ie.mime,valueBytes:h.$Oe.wrap(ie.data)}}Ae.from=je;function ve(ie){return new v.$XO(ie.valueBytes.buffer,ie.mime)}Ae.to=ve})(Zt||(e.NotebookCellOutputItem=Zt={}));var mt;(function(Ae){function je(ie){return{outputId:ie.id,items:ie.items.map(Zt.from),metadata:ie.metadata}}Ae.from=je;function ve(ie){const Re=ie.items.map(Zt.to);return new v.$YO(Re,ie.outputId,ie.metadata)}Ae.to=ve})(mt||(e.NotebookCellOutput=mt={}));var bt;(function(Ae){function je(Re){return ie(Re)?{include:_e.from(Re.include)??void 0,exclude:_e.from(Re.exclude)??void 0}:_e.from(Re)??void 0}Ae.from=je;function ve(Re){return ie(Re)?{include:_e.to(Re.include),exclude:_e.to(Re.exclude)}:_e.to(Re)}Ae.to=ve;function ie(Re){const He=Re;return He?!(0,c.$og)(He.include)&&!(0,c.$og)(He.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var hi;(function(Ae){function je(ve,ie,Re){const He=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===v.NotebookCellStatusBarAlignment.Left?D.CellStatusbarAlignment.Left:D.CellStatusbarAlignment.Right,command:ie.toInternal(He,Re),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Ae.from=je})(hi||(e.NotebookStatusBarItem=hi={}));var ei;(function(Ae){function je(ve,ie,Re){const He=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ie.toInternal(He,Re),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Ae.from=je})(ei||(e.NotebookKernelSourceAction=ei={}));var qt;(function(Ae){function je(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Ae.from=je})(qt||(e.NotebookDocumentContentOptions=qt={}));var wt;(function(Ae){function je(ie){return{uri:ie.uri,provides:ie.provides}}Ae.from=je;function ve(ie){return new v.$1O(g.URI.revive(ie.uri),ie.provides)}Ae.to=ve})(wt||(e.NotebookRendererScript=wt={}));var Vt;(function(Ae){function je(ie){return{message:ue.fromStrict(ie.message)||"",type:C.TestMessageType.Error,expected:ie.expectedOutput,actual:ie.actualOutput,contextValue:ie.contextValue,location:ie.location&&{range:T.from(ie.location.range),uri:ie.location.uri}}}Ae.from=je;function ve(ie){const Re=new v.$7O(typeof ie.message=="string"?ie.message:ue.to(ie.message));return Re.actualOutput=ie.actual,Re.expectedOutput=ie.expected,Re.contextValue=ie.contextValue,Re.location=ie.location?Be.to(ie.location):void 0,Re}Ae.to=ve})(Vt||(e.TestMessage=Vt={}));var Jt;(function(Ae){Ae.namespace=C.$UI,Ae.denamespace=C.$VI})(Jt||(e.TestTag=Jt={}));var Xt;(function(Ae){function je(ie){const Re=(0,f.$SP)(ie).controllerId;return{extId:P.$PI.fromExtHostTestItem(ie,Re).toString(),label:ie.label,uri:g.URI.revive(ie.uri),busy:ie.busy,tags:ie.tags.map(He=>Jt.namespace(Re,He.id)),range:m.$It.lift(T.from(ie.range)),description:ie.description||null,sortText:ie.sortText||null,error:ie.error&&ue.fromStrict(ie.error)||null}}Ae.from=je;function ve(ie){return{parent:void 0,error:void 0,id:P.$PI.fromString(ie.extId).localId,label:ie.label,uri:g.URI.revive(ie.uri),tags:(ie.tags||[]).map(Re=>{const{tagId:He}=Jt.denamespace(Re);return new v.$8O(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:T.to(ie.range||void 0),canResolveChildren:!1,busy:ie.busy,description:ie.description||void 0,sortText:ie.sortText||void 0}}Ae.toPlain=ve})(Xt||(e.TestItem=Xt={})),function(Ae){function je(ie){return{id:ie.id}}Ae.from=je;function ve(ie){return new v.$8O(ie.id)}Ae.to=ve}(Jt||(e.TestTag=Jt={}));var xe;(function(Ae){const je=(ie,Re)=>{const He=ie.value;if(!He)return;const et={...Xt.toPlain(He.item),parent:Re,taskStates:He.tasks.map(Qe=>({state:Qe.state,duration:Qe.duration,messages:Qe.messages.filter(ft=>ft.type===C.TestMessageType.Error).map(Vt.to)})),children:[]};if(ie.children)for(const Qe of ie.children.values()){const ft=je(Qe,et);ft&&et.children.push(ft)}return et};function ve(ie){const Re=new u.$OI;for(const Qe of ie.items)Re.insert(P.$PI.fromString(Qe.item.extId).path,Qe);const He=[Re.nodes],et=[];for(;He.length;)for(const Qe of He.pop())Qe.value?et.push(Qe):Qe.children&&He.push(Qe.children.values());return{completedAt:ie.completedAt,results:et.map(Qe=>je(Qe)).filter(c.$ng)}}Ae.to=ve})(xe||(e.TestResults=xe={}));var $i;(function(Ae){function je(He){return{covered:He.covered,total:He.total}}function ve(He){return"line"in He?z.from(He):T.from(He)}function ie(He){if(typeof He.executed=="number"&&He.executed<0)throw new Error(`Invalid coverage count ${He.executed}`);return"branches"in He?{count:He.executed,location:ve(He.location),type:C.DetailType.Statement,branches:He.branches.length?He.branches.map(et=>({count:et.executed,location:et.location&&ve(et.location),label:et.label})):void 0}:{type:C.DetailType.Declaration,name:He.name,count:He.executed,location:ve(He.location)}}Ae.fromDetails=ie;function Re(He,et,Qe){return v.$0O(Qe.statementCoverage),v.$0O(Qe.branchCoverage),v.$0O(Qe.declarationCoverage),{id:et,uri:Qe.uri,statement:je(Qe.statementCoverage),branch:Qe.branchCoverage&&je(Qe.branchCoverage),declaration:Qe.declarationCoverage&&je(Qe.declarationCoverage),testIds:Qe instanceof v.$$O&&Qe.fromTests.length?Qe.fromTests.map(ft=>P.$PI.fromExtHostTestItem(ft,He).toString()):void 0}}Ae.fromFile=Re})($i||(e.TestCoverage=$i={}));var ti;(function(Ae){function je(ve){switch(ve){case o.CodeActionTriggerType.Invoke:return v.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return v.CodeActionTriggerKind.Automatic}}Ae.to=je})(ti||(e.CodeActionTriggerKind=ti={}));var si;(function(Ae){function je(ie){const Re=new v.$cP(le.to(ie.kind),ie.name,ie.detail||"",g.URI.revive(ie.uri),T.to(ie.range),T.to(ie.selectionRange));return Re._sessionId=ie._sessionId,Re._itemId=ie._itemId,Re}Ae.to=je;function ve(ie,Re,He){if(Re=Re??ie._sessionId,He=He??ie._itemId,Re===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Re,_itemId:He,kind:le.from(ie.kind),name:ie.name,detail:ie.detail??"",uri:ie.uri,range:T.from(ie.range),selectionRange:T.from(ie.selectionRange),tags:ie.tags?.map(he.from)}}Ae.from=ve})(si||(e.TypeHierarchyItem=si={}));var Dt;(function(Ae){function je(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Ae.from=je})(Dt||(e.ViewBadge=Dt={}));var Kt;(function(Ae){function je(He,et,Qe){const ft=et.fileData;return ft?new v.$jO(new v.$kO(ft.name,g.URI.revive(ft.uri),ft.id,(0,R.$fb)(()=>Qe(ft.id)))):He===I.$5s.uriList&&et.uriListData?new v.$iO(Re(et.uriListData)):new v.$iO(et.asString)}Ae.to=je;async function ve(He,et){const Qe=await et.asString();if(He===I.$5s.uriList)return{asString:Qe,fileData:void 0,uriListData:ie(Qe)};const ft=et.asFile();return{asString:Qe,fileData:ft?{name:ft.name,uri:ft.uri,id:ft._itemId??ft.id}:void 0}}Ae.from=ve;function ie(He){return A.$mu.split(He).map(et=>{if(et.startsWith("#"))return et;try{return g.URI.parse(et)}catch{}return et})}function Re(He){return A.$mu.create(He.map(et=>typeof et=="string"?et:g.URI.revive(et)))}})(Kt||(e.DataTransferItem=Kt={}));var Lt;(function(Ae){function je(ie,Re){const He=ie.items.map(([et,Qe])=>[et,Kt.to(et,Qe,Re)]);return new v.$lO(He)}Ae.toDataTransfer=je;async function ve(ie){const Re={items:[]},He=[];for(const[et,Qe]of ie)He.push((async()=>{Re.items.push([et,await Kt.from(et,Qe)])})());return await Promise.all(He),Re}Ae.from=ve})(Lt||(e.DataTransfer=Lt={}));var Mt;(function(Ae){function je(ie,Re){return{kind:"reply",agentId:ie.participant??Re?.agentId??"",subCommand:ie.command??Re?.command,message:ie.prompt,title:ie.label}}Ae.from=je;function ve(ie){return{prompt:ie.message,label:ie.title,participant:ie.agentId,command:ie.subCommand}}Ae.to=ve})(Mt||(e.ChatFollowup=Mt={}));var ii;(function(Ae){function je(ie){switch(ie){case y.ChatMessageRole.System:return v.LanguageModelChatMessageRole.System;case y.ChatMessageRole.User:return v.LanguageModelChatMessageRole.User;case y.ChatMessageRole.Assistant:return v.LanguageModelChatMessageRole.Assistant}}Ae.to=je;function ve(ie){switch(ie){case v.LanguageModelChatMessageRole.System:return y.ChatMessageRole.System;case v.LanguageModelChatMessageRole.User:return y.ChatMessageRole.User;case v.LanguageModelChatMessageRole.Assistant:return y.ChatMessageRole.Assistant}return y.ChatMessageRole.User}Ae.from=ve})(ii||(e.LanguageModelChatMessageRole=ii={}));var ni;(function(Ae){function je(ie){let Re="",He;ie.content.type==="text"?Re=ie.content.value:He=new v.$DP(ie.content.name,ie.content.value,ie.content.isError);const et=ii.to(ie.role),Qe=new v.$EP(et,Re,ie.name);return He!==void 0&&(Qe.content2=He),Qe}Ae.to=je;function ve(ie){const Re=ii.from(ie.role),He=ie.name;let et;return ie.content2 instanceof v.$DP?et={type:"function_result",name:ie.content2.name,value:ie.content2.content,isError:ie.content2.isError}:et={type:"text",value:ie.content},{role:Re,name:He,content:et}}Ae.from=ve})(ni||(e.LanguageModelChatMessage=ni={}));var oi;(function(Ae){function je(ie){return{kind:"markdownContent",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$pP(ue.to(ie.content))}Ae.to=ve})(oi||(e.ChatResponseMarkdownPart=oi={}));var Bt;(function(Ae){function je(ie){return{kind:"markdownVuln",content:ue.from(ie.value),vulnerabilities:ie.vulnerabilities}}Ae.from=je;function ve(ie){return new v.$qP(ue.to(ie.content),ie.vulnerabilities)}Ae.to=ve})(Bt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Bt={}));var Qt;(function(Ae){function je(ie){return{kind:"agentDetection",agentId:ie.participant,command:ie.command}}Ae.from=je;function ve(ie){return new v.$rP(ie.agentId,ie.command)}Ae.to=ve})(Qt||(e.ChatResponseDetectedParticipantPart=Qt={}));var di;(function(Ae){function je(ve){return{kind:"confirmation",title:ve.title,message:ve.message,data:ve.data}}Ae.from=je})(di||(e.ChatResponseConfirmationPart=di={}));var jt;(function(Ae){function je(ie){const{value:Re,baseUri:He}=ie;function et(Qe,ft){return Qe.map(At=>{const xt=g.URI.joinPath(ft,At.name);return{label:At.name,uri:xt,children:At.children&&et(At.children,xt)}})}return{kind:"treeData",treeData:{label:(0,k.$dh)(He),uri:He,children:et(Re,He)}}}Ae.from=je;function ve(ie){const Re=(0,l.$ci)(ie.treeData);function He(ft){return ft.map(At=>({name:At.label,children:At.children&&He(At.children)}))}const et=Re.uri,Qe=Re.children?He(Re.children):[];return new v.$tP(Qe,et)}Ae.to=ve})(jt||(e.ChatResponseFilesPart=jt={}));var vt;(function(Ae){function je(ie){const Re=He=>g.URI.isUri(He);return{kind:"inlineReference",name:ie.title,inlineReference:Re(ie.value)?ie.value:M.from(ie.value)}}Ae.from=je;function ve(ie){const Re=(0,l.$ci)(ie);return new v.$uP(g.URI.isUri(Re.inlineReference)?Re.inlineReference:M.to(Re.inlineReference),ie.name)}Ae.to=ve})(vt||(e.ChatResponseAnchorPart=vt={}));var Pt;(function(Ae){function je(ie){return{kind:"progressMessage",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$vP(ie.content.value)}Ae.to=ve})(Pt||(e.ChatResponseProgressPart=Pt={}));var Tt;(function(Ae){function je(ie){return{kind:"warning",content:ue.from(ie.value)}}Ae.from=je;function ve(ie){return new v.$xP(ie.content.value)}Ae.to=ve})(Tt||(e.ChatResponseWarningPart=Tt={}));var It;(function(Ae){function je(ve){return{kind:"progressTask",content:ue.from(ve.value)}}Ae.from=je})(It||(e.ChatTask=It={}));var Yt;(function(Ae){function je(ve){return{kind:"progressTaskResult",content:typeof ve=="string"?ue.from(ve):void 0}}Ae.from=je})(Yt||(e.ChatTaskResult=Yt={}));var Ht;(function(Ae){function je(ie,Re,He){return{kind:"command",command:Re.toInternal(ie.value,He)??{command:ie.value.command,title:ie.value.title}}}Ae.from=je;function ve(ie,Re){return new v.$yP(Re.fromInternal(ie.command)??{command:ie.command.id,title:ie.command.title})}Ae.to=ve})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var pi;(function(Ae){function je(ie){return{kind:"textEdit",uri:ie.uri,edits:ie.edits.map(Re=>oe.from(Re))}}Ae.from=je;function ve(ie){return new v.$AP(g.URI.revive(ie.uri),ie.edits.map(Re=>oe.to(Re)))}Ae.to=ve})(pi||(e.ChatResponseTextEditPart=pi={}));var fi;(function(Ae){function je(ie){const Re=b.ThemeIcon.isThemeIcon(ie.iconPath)?ie.iconPath:g.URI.isUri(ie.iconPath)?{light:g.URI.revive(ie.iconPath)}:ie.iconPath&&"light"in ie.iconPath&&"dark"in ie.iconPath&&g.URI.isUri(ie.iconPath.light)&&g.URI.isUri(ie.iconPath.dark)?{light:g.URI.revive(ie.iconPath.light),dark:g.URI.revive(ie.iconPath.dark)}:void 0;return"variableName"in ie.value?{kind:"reference",reference:{variableName:ie.value.variableName,value:g.URI.isUri(ie.value.value)||!ie.value.value?ie.value.value:M.from(ie.value.value)},iconPath:Re}:{kind:"reference",reference:g.URI.isUri(ie.value)?ie.value:M.from(ie.value),iconPath:Re}}Ae.from=je;function ve(ie){const Re=(0,l.$ci)(ie),He=et=>g.URI.isUri(et)?et:M.to(et);return new v.$zP("variableName"in Re.reference?{variableName:Re.reference.variableName,value:Re.reference.value&&He(Re.reference.value)}:He(Re.reference))}Ae.to=ve})(fi||(e.ChatResponseReferencePart=fi={}));var Ai;(function(Ae){function je(Re,He,et){return Re instanceof v.$pP?oi.from(Re):Re instanceof v.$uP?vt.from(Re):Re instanceof v.$zP?fi.from(Re):Re instanceof v.$vP?Pt.from(Re):Re instanceof v.$tP?jt.from(Re):Re instanceof v.$yP?Ht.from(Re,He,et):Re instanceof v.$AP?pi.from(Re):Re instanceof v.$qP?Bt.from(Re):Re instanceof v.$rP?Qt.from(Re):Re instanceof v.$xP?Tt.from(Re):{kind:"markdownContent",content:ue.from("")}}Ae.from=je;function ve(Re,He){switch(Re.kind){case"reference":return fi.to(Re);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ie(Re,He)}}Ae.to=ve;function ie(Re,He){switch(Re.kind){case"markdownContent":return oi.to(Re);case"inlineReference":return vt.to(Re);case"progressMessage":return;case"treeData":return jt.to(Re);case"command":return Ht.to(Re,He)}}Ae.toContent=ie})(Ai||(e.ChatResponsePart=Ai={}));var Nt;(function(Ae){function je(ve){return{prompt:ve.message,command:ve.command,attempt:ve.attempt??0,enableCommandDetection:ve.enableCommandDetection??!0,references:ve.variables.variables.map(ai.to),location:Oi.to(ve.location),acceptedConfirmationData:ve.acceptedConfirmationData,rejectedConfirmationData:ve.rejectedConfirmationData}}Ae.to=je})(Nt||(e.ChatAgentRequest=Nt={}));var Oi;(function(Ae){function je(ie){switch(ie){case w.ChatAgentLocation.Notebook:return v.ChatLocation.Notebook;case w.ChatAgentLocation.Terminal:return v.ChatLocation.Terminal;case w.ChatAgentLocation.Panel:return v.ChatLocation.Panel;case w.ChatAgentLocation.Editor:return v.ChatLocation.Editor}}Ae.to=je;function ve(ie){switch(ie){case v.ChatLocation.Notebook:return w.ChatAgentLocation.Notebook;case v.ChatLocation.Terminal:return w.ChatAgentLocation.Terminal;case v.ChatLocation.Panel:return w.ChatAgentLocation.Panel;case v.ChatLocation.Editor:return w.ChatAgentLocation.Editor}}Ae.from=ve})(Oi||(e.ChatLocation=Oi={}));var ai;(function(Ae){function je(ve){const ie=ve.value;if(!ie)throw new Error("Invalid value reference");return{id:ve.id,name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],value:(0,g.$xc)(ie)?g.URI.revive(ie):ie&&typeof ie=="object"&&"uri"in ie&&"range"in ie&&(0,g.$xc)(ie.uri)?M.to((0,l.$ci)(ie)):ie,modelDescription:ve.modelDescription}}Ae.to=je})(ai||(e.ChatAgentValueReference=ai={}));var Rt;(function(Ae){function je(ve,ie,Re){return{id:ve.id,label:ve.label,fullName:ve.fullName,icon:ve.icon?.id,value:ve.values[0].value,insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation,command:ie.toInternal(ve.command,Re)}}Ae.from=je})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Si;(function(Ae){function je(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Ae.to=je})(Si||(e.ChatAgentResult=Si={}));var Di;(function(Ae){function je(ve,ie,Re){if(ie.action.kind==="vote")return;const He=Si.to(ve);if(ie.action.kind==="command"){const et=ie.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Re.fromInternal(et)??{command:et.id,title:et.title}}},result:He}}else return ie.action.kind==="followUp"?{action:{kind:"followUp",followup:Mt.to(ie.action.followup)},result:He}:ie.action.kind==="inlineChat"?{action:{kind:"editor",accepted:ie.action.action==="accepted"},result:He}:{action:ie.action,result:He}}Ae.to=je})(Di||(e.ChatAgentUserActionEvent=Di={}));var vi;(function(Ae){function je(ve,ie,Re){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ie.toInternal(ve,Re)}Ae.from=je})(vi||(e.TerminalQuickFix=vi={}));var Ti;(function(Ae){function je(ve){return{kind:gi.to(ve.kind)}}Ae.to=je})(Ti||(e.PartialAcceptInfo=Ti={}));var gi;(function(Ae){function je(ve){switch(ve){case o.PartialAcceptTriggerKind.Word:return v.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return v.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return v.PartialAcceptTriggerKind.Suggest;default:return v.PartialAcceptTriggerKind.Unknown}}Ae.to=je})(gi||(e.PartialAcceptTriggerKind=gi={}));var Gt;(function(Ae){function je(ve,ie){return{id:ie,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ve.contextValue}}Ae.from=je})(Gt||(e.DebugTreeItem=Gt={}))}),define(Ee[345],Se([1,0,6,20,17,51]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;let L=class{constructor($,l){this.a=$.getProxy(r.$qN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>l.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,l,I){const E=new R.$Qw(A.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(E,void 0,I?.isRefactoring??!1)}};e.$Mnc=L,e.$Mnc=L=Je([Ve(0,h.$WP)],L)}),define(Ee[346],Se([1,0,19,9,55,4,40,3,43,18,2,24,6,17,10,307,26]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0,k=We(k),b=We(b);class d{constructor(i,t,s,f,a){this.j=i,this.k=t,this.l=s,this.m=f,this.n=a,this.b=$.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(f){if(i.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,f),a}};const i=this;this.b.reset();const s=(f,a)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),a){const w=this.l.$handleProgressChunk(this.k.requestId,f),y={report:S=>{w?.then(D=>{D&&(b.$UN.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseWarningPart.from(S),D):this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseReferencePart.from(S),D))})}};Promise.all([w,a?.(y)]).then(([S,D])=>{S!==void 0&&D!==void 0&&this.l.$handleProgressChunk(this.k.requestId,k.ChatTaskResult.from(D),S)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){t(this.markdown);const a=new b.$pP(f),w=k.ChatResponseMarkdownPart.from(a);return s(w),this},markdownWithVulnerabilities(f,a){t(this.markdown),a&&(0,g.$5G)(i.j,"chatParticipantAdditions");const w=new b.$qP(f,a),y=k.ChatResponseMarkdownWithVulnerabilitiesPart.from(w);return s(y),this},filetree(f,a){t(this.filetree);const w=new b.$tP(f,a),y=k.ChatResponseFilesPart.from(w);return s(y),this},anchor(f,a){t(this.anchor);const w=new b.$uP(f,a),y=k.ChatResponseAnchorPart.from(w);return s(y),this},button(f){t(this.anchor);const a=new b.$yP(f),w=k.ChatResponseCommandButtonPart.from(a,i.m,i.n);return s(w),this},progress(f,a){t(this.progress);const w=new b.$wP(f,a),y=a?k.ChatTask.from(w):k.ChatResponseProgressPart.from(w);return s(y,a),this},warning(f){t(this.progress),(0,g.$5G)(i.j,"chatParticipantAdditions");const a=new b.$xP(f),w=k.ChatResponseWarningPart.from(a);return s(w),this},reference(f,a){if(t(this.reference),"variableName"in f&&(0,g.$5G)(i.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const w=i.k.variables.variables.find(y=>y.name===f.variableName);if(w){let y;if(w.references?.length)y=w.references.map(S=>({kind:"reference",reference:{variableName:f.variableName,value:S.reference}}));else{const S=new b.$zP(f,a);y=[k.ChatResponseReferencePart.from(S)]}return y.forEach(S=>s(S)),this}}else{const w=new b.$zP(f,a),y=k.ChatResponseReferencePart.from(w);s(y)}return this},textEdit(f,a){t(this.textEdit),(0,g.$5G)(i.j,"chatParticipantAdditions");const w=new b.$AP(f,a),y=k.ChatResponseTextEditPart.from(w);return s(y),this},detectedParticipant(f,a){t(this.detectedParticipant),(0,g.$5G)(i.j,"chatParticipantAdditions");const w=new b.$rP(f,a),y=k.ChatResponseDetectedParticipantPart.from(w);return s(y),this},confirmation(f,a,w){t(this.confirmation),(0,g.$5G)(i.j,"chatParticipantAdditions");const y=new b.$sP(f,a,w),S=k.ChatResponseConfirmationPart.from(y);return s(S),this},push(f){if(t(this.push),(f instanceof b.$AP||f instanceof b.$qP||f instanceof b.$rP||f instanceof b.$xP||f instanceof b.$sP)&&(0,g.$5G)(i.j,"chatParticipantAdditions"),f instanceof b.$zP)this.reference(f.value,f.iconPath);else{const a=k.ChatResponsePart.from(f,i.m,i.n);s(a)}return this}}}return this.g}}class m extends O.$Wc{static{this.b=0}constructor(i,t,s,f){super(),this.n=t,this.s=s,this.t=f,this.c=new Map,this.j=this.B(new O.$6c),this.m=this.B(new O.$6c),this.g=i.getProxy(u.$qN.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,s){const f=m.b++,a=new n(i,this.t,t,this.g,f,s);return this.c.set(f,a),a.isAgentEnabled()&&this.g.$registerAgent(f,i.identifier,t,{},void 0),a.apiAgent}createDynamicChatAgent(i,t,s,f){const a=m.b++,w=new n(i,this.t,t,this.g,a,f);return this.c.set(a,w),this.g.$registerAgent(a,i.identifier,t,{isSticky:!0},s),w.apiAgent}async $invokeAgent(i,t,s,f){const a=this.c.get(i);if(!a)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let w=this.j.get(t.sessionId);w||(w=new O.$Vc,this.j.set(t.sessionId,w));const y=new d(a.extension,t,this.g,this.s.converter,w);try{const S=await this.u(t.agentId,s),D=a.invoke(k.ChatAgentRequest.to(t),{history:S},y.apiObject,f);return await(0,h.$th)(Promise.resolve(D).then(P=>{if(P?.metadata)try{JSON.stringify(P.metadata)}catch(p){const v=`result.metadata MUST be JSON.stringify-able. Got error: ${p.message}`;return this.n.error(`[${a.extension.identifier.value}] [@${a.id}] ${v}`,a.extension),{errorDetails:{message:v},timings:y.timings}}let C;return P?.errorDetails&&(C={...P.errorDetails,responseIsIncomplete:!0}),C?.responseIsRedacted&&(0,g.$5G)(a.extension,"chatParticipantPrivate"),{errorDetails:C,timings:y.timings,metadata:P?.metadata}}),f)}catch(S){return this.n.error(S,a.extension),S instanceof b.$KP&&S.cause&&(S=S.cause),{errorDetails:{message:(0,A.$qj)(S),responseIsIncomplete:!0}}}finally{y.close()}}async u(i,t){const s=[];for(const f of t.history){const a=k.ChatAgentResult.to(f.result),w=i===f.request.agentId?a:{...a,metadata:void 0};s.push(new b.$BP(f.request.message,f.request.command,f.request.variables.variables.map(k.ChatAgentValueReference.to),f.request.agentId));const y=(0,r.$Jb)(f.response.map(S=>k.ChatResponsePart.toContent(S,this.s.converter)));s.push(new b.$CP(y,w,f.request.agentId,f.request.command))}return s}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,s,f,a){const w=this.c.get(t);if(!w)return Promise.resolve([]);const y=await this.u(w.id,f),S=k.ChatAgentResult.to(s);return(await w.provideFollowups(S,{history:y},a)).filter(D=>{const P=!D.participant||L.Iterable.some(this.c.values(),C=>C.id===D.participant&&E.$qn.equals(C.extension.identifier,w.extension.identifier));return P||this.n.warn(`[@${w.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),P}).map(D=>k.ChatFollowup.from(D,i))}$acceptFeedback(i,t,s,f){const a=this.c.get(i);if(!a)return;const w=k.ChatAgentResult.to(t);let y;switch(s){case c.ChatAgentVoteDirection.Down:y=b.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:y=b.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(f?{result:w,kind:y,reportIssue:f}:{result:w,kind:y}))}$acceptAction(i,t,s){const f=this.c.get(i);if(!f||s.action.kind==="vote")return;const a=k.ChatAgentUserActionEvent.to(t,s,this.s.converter);a&&f.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(i,t,s){const f=this.c.get(i);if(!f)return[];let a=this.m.get(i);return a?a.clear():(a=new O.$Vc,this.m.set(i,a)),(await f.invokeCompletionProvider(t,s)).map(y=>k.ChatAgentCompletionItem.from(y,this.s.converter,a))}async $provideWelcomeMessage(i,t,s){const f=this.c.get(i);if(f)return await f.provideWelcomeMessage(k.ChatLocation.to(t),s)}async $provideSampleQuestions(i,t,s){const f=this.c.get(i);if(f)return(await f.provideSampleQuestions(k.ChatLocation.to(t),s)).map(a=>k.ChatFollowup.from(a,void 0))}}e.$Nnc=m;class n{constructor(i,t,s,f,a,w){this.extension=i,this.w=t,this.id=s,this.x=f,this.y=a,this.z=w,this.m=new R.$me,this.n=new R.$me}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,g.$4G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,s){if(!this.b)return[];const f=await this.b.provideFollowups(i,t,s);return f?f.filter(a=>!(a&&"commandId"in a)).filter(a=>!(a&&"message"in a)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const s=await this.s.provideWelcomeMessage(i,t);return s?s.map(f=>typeof f=="string"?f:k.MarkdownString.from(f)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const s=await this.s.provideSampleQuestions(i,t);return s||[]}get apiAgent(){let i=!1,t=!1;const s=()=>{i||t||(t=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof b.$pO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:k.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(a){f.c=a,s()},get requestHandler(){return f.z},set requestHandler(a){(0,l.$pg)(typeof a=="function","Invalid request handler"),f.z=a},get followupProvider(){return f.b},set followupProvider(a){f.b=a,s()},get isDefault(){return(0,g.$5G)(f.extension,"defaultChatParticipant"),f.d},set isDefault(a){(0,g.$5G)(f.extension,"defaultChatParticipant"),f.d=a,s()},get helpTextPrefix(){return(0,g.$5G)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(a){(0,g.$5G)(f.extension,"defaultChatParticipant"),f.g=a,s()},get helpTextVariablesPrefix(){return(0,g.$5G)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(a){(0,g.$5G)(f.extension,"defaultChatParticipant"),f.j=a,s()},get helpTextPostfix(){return(0,g.$5G)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(a){(0,g.$5G)(f.extension,"defaultChatParticipant"),f.k=a,s()},get isSecondary(){return(0,g.$5G)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(a){(0,g.$5G)(f.extension,"defaultChatParticipant"),f.l=a,s()},get supportIssueReporting(){return(0,g.$5G)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(a){(0,g.$5G)(f.extension,"chatParticipantPrivate"),f.o=a,s()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(a){if((0,g.$5G)(f.extension,"chatParticipantAdditions"),f.q=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,a.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,g.$5G)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(a){(0,g.$5G)(f.extension,"defaultChatParticipant"),f.s=a,s()},get welcomeMessageProvider(){return(0,g.$5G)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,g.$4G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(a){f.t=a,s()},get requester(){return f.t},set supportsSlowReferences(a){(0,g.$5G)(f.extension,"chatParticipantPrivate"),f.u=a,s()},get supportsSlowReferences(){return(0,g.$5G)(f.extension,"chatParticipantPrivate"),f.u},dispose(){i=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(i,t,s,f){return this.z(i,t,s,f)}}}),define(Ee[347],Se([1,0,14,3,50,6,17,10,26]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0,L=We(L),O=We(O);class l{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(R.$qN.MainThreadChatVariables)}async $resolveVariable(u,k,b,c){const g=this.b.get(u);if(g)try{if(g.resolver.resolve2){(0,$.$5G)(g.extension,"chatParticipantAdditions");const d=new I(k,this.c),m=await g.resolver.resolve2(g.data.name,{prompt:b},d.apiObject,c);if(m&&m[0])return m[0].value}else{const d=await g.resolver.resolve(g.data.name,{prompt:b},c);if(d&&d[0])return d[0].value}}catch(d){(0,r.$4)(d)}}registerVariableResolver(u,k,b,c,g,d,m,n,o){const i=l.a++,t=o?A.ThemeIcon.fromId(o):void 0;return this.b.set(i,{extension:u,data:{id:k,name:b,description:c,modelDescription:g,icon:t},resolver:m}),this.c.$registerVariable(i,{id:k,name:b,description:c,modelDescription:g,isSlow:d,fullName:n,icon:t}),(0,h.$Uc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$Onc=l;class I{constructor(u,k){this.c=u,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(c){if(u.a){const g=new Error("Response stream has been closed");throw Error.captureStackTrace(g,c),g}};const u=this,b=c=>{this.d.$handleProgressChunk(this.c,c)};this.b={progress(c){k(this.progress);const g=new O.$vP(c),d=L.ChatResponseProgressPart.from(g);return b(d),this},reference(c){k(this.reference);const g=new O.$zP(c),d=L.ChatResponseReferencePart.from(g);return b(d),this},push(c){return k(this.push),c instanceof O.$zP?b(L.ChatResponseReferencePart.from(c)):c instanceof O.$vP&&b(L.ChatResponseProgressPart.from(c)),this}}}return this.b}}}),define(Ee[348],Se([1,0,9,59,4,3,41,2,88,24,17,10,6,26]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=b,$=We($),I=We(I),E=We(E);function b(c,g,d){const m=c.getProxy(u.$qN.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new l.$sn,g.registerArgumentProcessor({processArgument:D=>{if(D&&D.$mid===L.MarshalledId.CommentController){const P=this.b.get(D.handle);return P?P.value:D}else if(D&&D.$mid===L.MarshalledId.CommentThread){const P=D,C=this.b.get(P.commentControlHandle);if(!C)return P;const p=C.getCommentThread(P.commentThreadHandle);return p?p.value:P}else if(D&&(D.$mid===L.MarshalledId.CommentThreadReply||D.$mid===L.MarshalledId.CommentThreadInstance)){const P=this.b.get(D.thread.commentControlHandle);if(!P)return D;const C=P.getCommentThread(D.thread.commentThreadHandle);return C?D.$mid===L.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:D.text}:D}else if(D&&D.$mid===L.MarshalledId.CommentNode){const P=this.b.get(D.thread.commentControlHandle);if(!P)return D;const C=P.getCommentThread(D.thread.commentThreadHandle);if(!C)return D;const p=D.commentUniqueId,v=C.getCommentByUniqueId(p);return v||D}else if(D&&D.$mid===L.MarshalledId.CommentThreadNode){const P=this.b.get(D.thread.commentControlHandle);if(!P)return D;const C=P.getCommentThread(D.thread.commentThreadHandle);if(!C)return D;const p=D.text,v=D.commentUniqueId,N=C.getCommentByUniqueId(v);return N?(typeof N.body=="string"?N.body=p:N.body=new E.$UN(p),N):D}return D}})}createCommentController(D,P,C){const p=n.a++,v=new i(D,p,P,C);this.b.set(v.handle,v);const N=this.c.get(D.identifier)||[];return N.push(v),this.c.set(D.identifier,N),v.value}async $createCommentThreadTemplate(D,P,C,p){const v=this.b.get(D);v&&v.$createCommentThreadTemplate(P,C,p)}async $setActiveComment(D,P){const C=this.b.get(D);C&&C.$setActiveComment(P??void 0)}async $updateCommentThreadTemplate(D,P,C){const p=this.b.get(D);p&&p.$updateCommentThreadTemplate(P,C)}$deleteCommentThread(D,P){this.b.get(D)?.$deleteCommentThread(P)}async $provideCommentingRanges(D,P,C){const p=this.b.get(D);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const v=await d.ensureDocumentData(O.URI.revive(P));return(0,r.$xh)(async()=>{const N=await p.commentingRangeProvider.provideCommentingRanges(v.document,C);let T;return Array.isArray(N)?T={ranges:N,fileComments:!1}:N?T={ranges:N.ranges||[],fileComments:N.fileComments||!1}:T=N??void 0,T}).then(N=>{let T;return N&&(T={ranges:N.ranges.map(M=>I.Range.from(M)),fileComments:N.fileComments}),T})}$toggleReaction(D,P,C,p,v){const N=this.b.get(D);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,r.$xh)(()=>{const T=N.getCommentThread(P);if(T){const M=T.getCommentByUniqueId(p.uniqueIdInThread);if(N!==void 0&&M&&N.reactionHandler)return N.reactionHandler(M,f(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(D){this.n=D}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(D){(D===void 0!=(this.p===void 0)||!D||!this.p||!D.isEqual(this.p))&&(this.p=D,this.b.range=D,this.c.fire())}get range(){return this.p}set canReply(D){this.d!==D&&(this.d=D,this.b.canReply=D,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(D){this.e=D,this.b.label=D,this.c.fire()}get contextValue(){return this.f}set contextValue(D){this.f=D,this.b.contextValue=D,this.c.fire()}get comments(){return this.q}set comments(D){this.q=D,this.b.comments=D,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(D){this.g=D,this.b.collapsibleState=D,this.c.fire()}get state(){return this.h}set state(D){this.h=D,typeof D=="object"?((0,k.$5G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=D.resolved,this.b.applicability=D.applicability):this.b.state=D,this.c.fire()}get isDisposed(){return this.j}constructor(D,P,C,p,v,N,T,M,j){this.m=P,this.n=C,this.o=p,this.p=v,this.q=N,this.extensionDescription=T,this.r=M,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new A.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Xc,this.l.value=new R.$Vc,this.n===void 0&&(this.n=`${D}.${this.handle}`),m.$createCommentThread(P,this.handle,this.n,this.o,I.Range.from(this.p),T.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{m.$deleteCommentThread(P,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(F){z.range=F},get comments(){return z.comments},set comments(F){z.comments=F},get collapsibleState(){return z.collapsibleState},set collapsibleState(F){z.collapsibleState=F},get canReply(){return z.canReply},set canReply(F){z.canReply=F},get contextValue(){return z.contextValue},set contextValue(F){z.contextValue=F},get label(){return z.label},set label(F){z.label=F},get state(){return z.state},set state(F){z.state=F},reveal:F=>z.reveal(F),dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Vc);const D=C=>Object.prototype.hasOwnProperty.call(this.b,C),P={};D("range")&&(P.range=I.Range.from(this.p)),D("label")&&(P.label=this.label),D("contextValue")&&(P.contextValue=this.contextValue??null),D("comments")&&(P.comments=this.q.map(C=>t(this,C,this.k,this.extensionDescription))),D("collapsibleState")&&(P.collapseState=a(this.g)),D("canReply")&&(P.canReply=this.canReply),D("state")&&(P.state=w(this.h)),D("applicability")&&(P.applicability=y(this.h)),D("isTemplate")&&(P.isTemplate=this.r),this.b={},m.$updateCommentThread(this.m,this.handle,this.n,this.o,P)}getCommentByUniqueId(D){for(const P of this.k){const C=P[0],p=P[1];if(D===p)return C}}async reveal(D){return(0,k.$5G)(this.extensionDescription,"commentReveal"),m.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...D})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(D=>D.dispose())}}Je([(0,h.$$h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(D){this.b=D,D?.resourceHints&&(0,k.$5G)(this.h,"commentingRangeHint"),m.$updateCommentingRanges(this.handle,D?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(D){this.c=D,m.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!D})}get options(){return this.d}set options(D){this.d=D,m.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$5G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$5G)(this.h,"activeComment"),this.f}constructor(D,P,C,p){this.h=D,this.i=P,this.j=C,this.k=p,this.a=new Map,m.$registerCommentController(this.handle,C,p,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(N){v.options=N},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(N){v.commentingRangeProvider=N},get reactionHandler(){return v.reactionHandler},set reactionHandler(N){v.reactionHandler=N},get activeCommentThread(){return v.activeCommentThread},createCommentThread(N,T,M){return v.createCommentThread(N,T,M).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{m.$unregisterCommentController(this.handle)}})}createCommentThread(D,P,C){P===void 0&&(0,k.$5G)(this.h,"fileComments");const p=new o(this.id,this.handle,void 0,D,P,C,this.h,!1);return this.a.set(p.handle,p),p}$setActiveComment(D){if(!D){this.e=void 0,this.f=void 0;return}const P=this.a.get(D.commentThreadHandle);P&&(this.e=D.uniqueIdInThread?P.getCommentByUniqueId(D.uniqueIdInThread):void 0,this.f=P)}$createCommentThreadTemplate(D,P,C){const p=new o(this.id,this.handle,void 0,O.URI.revive(D),I.Range.to(P),[],this.h,!0,C);return p.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(p.handle,p),p}$updateCommentThreadTemplate(D,P){const C=this.a.get(D);C&&(C.range=I.Range.to(P))}$deleteCommentThread(D){this.a.get(D)?.dispose(),this.a.delete(D)}getCommentThread(D){return this.a.get(D)}dispose(){this.a.forEach(D=>{D.dispose()}),this.g.forEach(D=>D.dispose())}}function t(S,D,P,C){let p=P.get(D);return p||(p=++S.commentHandle,P.set(D,p)),D.state!==void 0&&(0,k.$5G)(C,"commentsDraftState"),D.reactions?.some(v=>v.reactors!==void 0)&&(0,k.$5G)(C,"commentReactor"),{mode:D.mode,contextValue:D.contextValue,uniqueIdInThread:p,body:typeof D.body=="string"?D.body:I.MarkdownString.from(D.body),userName:D.author.name,userIconPath:D.author.iconPath,label:D.label,commentReactions:D.reactions?D.reactions.map(v=>s(v)):void 0,state:D.state,timestamp:D.timestamp?.toJSON()}}function s(S){return{label:S.label,iconPath:S.iconPath?I.$VP(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(D=>D.name):S.reactors}}function f(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?O.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(D=>({name:D}))}}function a(S){if(S!==void 0)switch(S){case E.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case E.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function w(S){let D;if(typeof S=="object"?D=S.resolved:D=S,D!==void 0)switch(D){case E.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case E.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function y(S){let D;if(typeof S=="object"&&(D=S.applicability),D!==void 0)switch(D){case E.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case E.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new n}}),define(Ee[349],Se([1,0,21,60,3,15,23,2,17,97,119,6,10]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0,$=We($),E=We(E),u=We(u);class k{constructor(s,f){this.document=s,this.b=f,this.a=1,this.c=new I.$ync("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,f){await this.f(s).undo(),f||this.disposeBackup()}async redo(s,f){await this.f(s).redo(),f||this.disposeBackup()}disposeEdits(s){for(const f of s)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=i(this.document.uri)+this.a++;return(0,L.$gh)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const f=this.c.get(s,0);if(!f)throw new Error("No edit found");return f}}class b{constructor(){this.a=new Map}get(s,f){return this.a.get(this.b(s,f))}add(s,f,a){const w=this.b(s,f.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${f.uri}`);const y=new k(f,a);return this.a.set(w,y),y}delete(s,f){const a=this.b(s,f.uri);this.a.delete(a)}b(s,f){return`${s}@@@${f}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(s,f,a){return this.b(s,{type:c.Text,extension:f,provider:a})}addCustomProvider(s,f,a){return this.b(s,{type:c.Custom,extension:f,provider:a})}get(s){return this.a.get(s)}b(s,f){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,f),new u.$sN(()=>this.a.delete(s))}}class d{constructor(s,f,a,w,y){this.d=f,this.f=a,this.g=w,this.h=y,this.b=new g,this.c=new b,this.a=s.getProxy(E.$qN.MainThreadCustomEditors)}registerCustomEditorProvider(s,f,a,w){const y=new A.$Vc;return n(a)?(y.add(this.b.addTextProvider(f,s,a)),this.a.$registerTextEditorProvider((0,l.$8nc)(s),f,w.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,l.$6nc)(s))):(y.add(this.b.addCustomProvider(f,s,a)),m(a)&&y.add(a.onDidChangeCustomDocument(S=>{const D=this.i(f,S.document.uri);if(o(S)){const P=D.addEdit(S);this.a.$onDidEdit(S.document.uri,f,P,S.label)}else this.a.$onContentChange(S.document.uri,f)})),this.a.$registerCustomEditorProvider((0,l.$8nc)(s),f,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,l.$6nc)(s))),u.$sN.from(y,new u.$sN(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(s,f,a,w,y){const S=this.b.get(f);if(!S)throw new Error(`No provider found for '${f}'`);if(S.type!==c.Custom)throw new Error(`Invalid provide type for '${f}'`);const D=O.URI.revive(s),P=await S.provider.openCustomDocument(D,{backupId:a,untitledDocumentData:w?.buffer},y);let C;return m(S.provider)&&this.f&&(C=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(f,P,C),{editable:m(S.provider)}}async $disposeCustomDocument(s,f){const a=this.b.get(f);if(!a)throw new Error(`No provider found for '${f}'`);if(a.type!==c.Custom)throw new Error(`Invalid provider type for '${f}'`);const w=O.URI.revive(s),{document:y}=this.i(f,w);this.c.delete(f,y),y.dispose()}async $resolveCustomEditor(s,f,a,w,y,S){const D=this.b.get(a);if(!D)throw new Error(`No provider found for '${a}'`);const P=$.ViewColumn.to(y),C=this.g.createNewWebview(f,w.contentOptions,D.extension),p=this.h.createNewWebviewPanel(f,a,w.title,P,w.options,C,w.active),v=O.URI.revive(s);switch(D.type){case c.Custom:{const{document:N}=this.i(a,v);return D.provider.resolveCustomEditor(N,p,S)}case c.Text:{const N=this.d.getDocument(v);return D.provider.resolveCustomTextEditor(N,p,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,f,a){this.i(f,s).disposeEdits(a)}async $onMoveCustomEditor(s,f,a){const w=this.b.get(a);if(!w)throw new Error(`No provider found for '${a}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const y=this.h.getWebviewPanel(s);if(!y)throw new Error("No webview found");const S=O.URI.revive(f),D=this.d.getDocument(S);await w.provider.moveCustomTextEditor(D,y,r.CancellationToken.None)}async $undo(s,f,a,w){return this.i(f,s).undo(a,w)}async $redo(s,f,a,w){return this.i(f,s).redo(a,w)}async $revert(s,f,a){const w=this.i(f,s);await this.j(f).revertCustomDocument(w.document,a),w.disposeBackup()}async $onSave(s,f,a){const w=this.i(f,s);await this.j(f).saveCustomDocument(w.document,a),w.disposeBackup()}async $onSaveAs(s,f,a,w){const y=this.i(f,s);return this.j(f).saveCustomDocumentAs(y.document,O.URI.revive(a),w)}async $backup(s,f,a){const w=this.i(f,s),S=await this.j(f).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},a);return w.updateBackup(S),S.id}i(s,f){const a=this.c.get(s,O.URI.revive(f));if(!a)throw new Error("No custom document found");return a}j(s){const a=this.b.get(s)?.provider;if(!a||!m(a))throw new Error("Custom document is not editable");return a}}e.$$nc=d;function m(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const s=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,h.$tj)(s)+""}}),define(Ee[350],Se([1,0,233,145,2,6,10,17,4,12,29,63]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Fnc=void 0,O=We(O);class k{#e;#t;#i;constructor(g,d,m,n,o,i,t,s){this.d=g,this.e=d,this.f=m,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,m),this.#i=new I.$Cc(f=>i.getComparisonKey(f)),this.#e=t,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,d){if(!g){this.clear();return}this.j();let m=[];if(A.URI.isUri(g)){if(!d){this.delete(g);return}this.#i.set(g,d.slice()),m=[g]}else if(Array.isArray(g)){m=[];let i;g=[...g].sort(k.k);for(const t of g){const[s,f]=t;if((!i||s.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=s,m.push(s),this.#i.set(s,[])),f)this.#i.get(s)?.push(...f);else{const a=this.#i.get(s);a&&(a.length=0)}}}if(this.#t.fire(m),!this.#e)return;const n=[];let o=0;for(const i of m){let t=[];const s=this.#i.get(i);if(s)if(s.length>this.g){t=[];const f=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let a=0;a<4;a++)for(const w of s)if(w.severity===f[a]&&t.push({...O.Diagnostic.from(w),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:h.MarkerSeverity.Info,message:(0,r.localize)(0,null,s.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=s.map(f=>({...O.Diagnostic.from(f),modelVersionId:this.h(i)}));if(n.push([i,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,d){this.j();for(const[m,n]of this)g.call(d,m,n,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const d=this.#i.get(g);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,d){return g[0].toString()<d[0].toString()?-1:g[0].toString()>d[0].toString()?1:0}}e.$Fnc=k;let b=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(g){const d=new I.$Cc;for(const m of g)d.set(m,m);return{uris:Object.freeze(Array.from(d.values()))}}constructor(g,d,m,n){this.j=d,this.k=m,this.l=n,this.g=new Map,this.h=new $.$qe({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,u._mapper),this.f=g.getProxy(R.$qN.MainThreadDiagnostics)}createDiagnosticCollection(g,d){const{g:m,f:n,h:o,j:i,k:t,l:s}=this,f=new class{$changeMany(y,S){n.$changeMany(y,S),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,y,S.length===0?"CLEARING":S)}$clear(y){n.$clear(y),i.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,y)}dispose(){n.dispose()}};let a;if(!d)d="_generated_diagnostic_collection_name_#"+u.c++,a=d;else if(!m.has(d))a=d;else{this.j.warn(`DiagnosticCollection with name '${d}' does already exist.`);do a=d+u.c++;while(m.has(a))}return new class extends k{constructor(){super(d,a,u.e,u.d,y=>s.getDocument(y)?.version,t.extUri,f,o),m.set(a,this)}dispose(){super.dispose(),m.delete(a)}}}getDiagnostics(g){if(g)return this.m(g);{const d=new Map,m=[];for(const n of this.g.values())n.forEach((o,i)=>{let t=d.get(o.toString());typeof t>"u"&&(t=m.length,d.set(o.toString(),t),m.push([o,[]])),m[t][1]=m[t][1].concat(...i)});return m}}m(g){let d=[];for(const m of this.g.values())m.has(g)&&(d=d.concat(m.get(g)));return d}$acceptMarkersChange(g){if(!this.n){const d="_generated_mirror",m=new k(d,d,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(d,m),this.n=m}for(const[d,m]of g)this.n.set(A.URI.revive(d),m.map(O.Diagnostic.to))}};e.$Gnc=b,e.$Gnc=b=u=Je([Ve(1,l.$_j),Ve(2,E.$Enc)],b)}),define(Ee[351],Se([1,0,2,14,10,17,81,51]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class ${constructor(I,E,u,k={timeout:1500,errors:3}){this.c=I,this.d=E,this.f=u,this.g=k,this.a=new L.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(E,u,k)=>{const c={dispose:this.a.push([E,u,I])};return Array.isArray(k)&&k.push(c),c}}async $participateInSave(I,E){const u=r.URI.revive(I);let k=!1;const b=setTimeout(()=>k=!0,this.g.timeout),c=[];try{for(const g of[...this.a]){if(k)break;const d=this.d.getDocument(u),m=await this.h(g,{document:d,reason:R.TextDocumentSaveReason.to(E)});c.push(m)}}finally{clearTimeout(b)}return c}h([I,E,u],k){const b=this.b.get(I);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(u,I,E,k).then(()=>!0,c=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const g=this.b.get(I);this.b.set(I,g?g+1:1),typeof g=="number"&&g>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,E,u,k){const b=[],c=Date.now(),{document:g,reason:d}=k,{version:m}=g,n=Object.freeze({document:g,reason:d,waitUntil(o){if(Object.isFrozen(b))throw(0,h.$0)("waitUntil can not be called async");b.push(Promise.resolve(o))}});try{E.apply(u,[n])}catch(o){return Promise.reject(o)}return Object.freeze(b),new Promise((o,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(b).then(s=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(t),o(s)}).catch(s=>{clearTimeout(t),i(s)})}).then(o=>{const i={edits:[]};for(const t of o)if(Array.isArray(t)&&t.every(s=>s instanceof A.$zN))for(const{newText:s,newEol:f,range:a}of t)i.edits.push({resource:g.uri,versionId:void 0,textEdit:{range:a&&R.Range.from(a),text:s,eol:f&&R.EndOfLine.from(f)}});if(i.edits.length!==0)return m===g.version?this.f.$tryApplyWorkspaceEdit(new O.$Qw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$Toc=$}),define(Ee[352],Se([1,0,4,3,2,6,163,17,18,25,10]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0,O=We(O);class E{constructor(k,b){this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new h.$Vc,this.h=new Map,this.f=k.getProxy(R.$qN.MainThreadDocuments),this.g=b,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const b=this.g.getDocument(k);if(b)return b}getDocument(k){const b=this.getDocumentData(k);if(!b?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return b.document}ensureDocumentData(k){const b=this.g.getDocument(k);if(b)return Promise.resolve(b);let c=this.h.get(k.toString());return c||(c=this.f.$tryOpenDocument(k).then(g=>{this.h.delete(k.toString());const d=A.URI.revive(g);return(0,$.$qg)(this.g.getDocument(d))},g=>(this.h.delete(k.toString()),Promise.reject(g))),this.h.set(k.toString(),c)),c}createDocumentData(k){return this.f.$tryCreateDocument(k).then(b=>A.URI.revive(b))}$acceptModelLanguageChanged(k,b){const c=A.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(b),this.a.fire(g.document)}$acceptModelSaved(k){const b=A.URI.revive(k),c=this.g.getDocument(b);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(k,b){const c=A.URI.revive(k),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(b),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,b,c){const g=A.URI.revive(k),d=this.g.getDocument(g);if(!d)throw new Error("unknown document");d._acceptIsDirty(c),d.onEvents(b);let m;b.isUndoing?m=I.TextDocumentChangeReason.Undo:b.isRedoing&&(m=I.TextDocumentChangeReason.Redo),this.c.fire((0,l.$do)({document:d.document,contentChanges:b.changes.map(n=>({range:O.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:m}))}setWordDefinitionFor(k,b){(0,L.$YP)(k,b)}}e.$Hnc=E}),define(Ee[78],Se([1,0,79,4,18,2,5,6,20,17,10]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0,l=We(l),e.$_nc=(0,L.$Fi)("IExtHostEditorTabs");class E{constructor(g,d,m){this.e=m,this.d=d,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,d={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case O.TabInputKind.TextInput:return new I.$dP(R.URI.revive(this.b.input.uri));case O.TabInputKind.TextDiffInput:return new I.$eP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case O.TabInputKind.TextMergeInput:return new I.$fP(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case O.TabInputKind.CustomEditorInput:return new I.$gP(R.URI.revive(this.b.input.uri),this.b.input.viewType);case O.TabInputKind.WebviewEditorInput:return new I.$hP(this.b.input.viewType);case O.TabInputKind.NotebookInput:return new I.$iP(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case O.TabInputKind.NotebookDiffInput:return new I.$jP(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case O.TabInputKind.TerminalEditorInput:return new I.$kP;case O.TabInputKind.InteractiveEditorInput:return new I.$lP(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case O.TabInputKind.ChatEditorInput:return new I.$mP;case O.TabInputKind.MultiDiffEditorInput:return new I.$nP(this.b.input.diffEditors.map(g=>new I.$eP(R.URI.revive(g.original),R.URI.revive(g.modified))));default:return}}}class u{constructor(g,d){this.c=[],this.d="",this.b=g,this.e=d;for(const m of g.tabs)m.isActive&&(this.d=m.id),this.c.push(new E(m,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,d={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return l.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(m=>m.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(m=>m.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===O.TabModelOperationKind.TAB_OPEN){const m=new E(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,m),g.tabDto.isActive&&(this.d=m.tabId),m}else if(g.kind===O.TabModelOperationKind.TAB_CLOSE){const m=this.c.splice(g.index,1)[0];if(!m)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return m.tabId===this.d&&(this.d=""),m}else if(g.kind===O.TabModelOperationKind.TAB_MOVE){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const m=this.c.splice(g.oldIndex,1)[0];if(!m)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,m),m}const d=this.c.find(m=>m.tabId===g.tabDto.id);if(!d)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(g.tabDto),d}activeTabId(){return this.d}}let k=class{constructor(g){this.b=new h.$me,this.c=new h.$me,this.e=[],this.a=g.getProxy(O.$qN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,d={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(m=>m.apiObject))},get activeTabGroup(){const m=g.d;return(0,A.$qg)(g.e.find(o=>o.groupId===m)?.apiObject)},close:async(m,n)=>{const o=Array.isArray(m)?m:[m];return o.length?b(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(g){const d=new Set(this.e.map(f=>f.groupId)),m=new Set(g.map(f=>f.groupId)),n=(0,r.$L)(d,m),o=this.e.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),i=[],t=[];this.e=g.map(f=>{const a=new u(f,()=>this.d);return n.added.includes(a.groupId)?i.push(a.apiObject):t.push(a.apiObject),a});const s=(0,A.$qg)(g.find(f=>f.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:i,closed:o,changed:t}))}$acceptTabGroupUpdate(g){const d=this.e.find(m=>m.groupId===g.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const d=this.e.find(n=>n.groupId===g.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const m=d.acceptTabOperation(g);switch(g.kind){case O.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[m.apiObject],closed:[],changed:[]}));return;case O.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[m.apiObject],changed:[]}));return;case O.TabModelOperationKind.TAB_MOVE:case O.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[m.apiObject]}));return}}g(g){for(const d of this.e)for(const m of d.tabs)if(m.apiObject===g)return m}h(g){return this.e.find(d=>d.apiObject===g)}async i(g,d){const m=[];for(const n of g){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");m.push(o.tabId)}return this.a.$closeTab(m,d)}async j(g,d){const m=[];for(const n of g){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");m.push(o.groupId)}return this.a.$closeGroup(m,d)}};e.$aoc=k,e.$aoc=k=Je([Ve(0,$.$WP)],k);function b(c){return c.tabs!==void 0}}),define(Ee[353],Se([1,0,2,6,28,3,10,17,194,13,27,22,26,86]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0,A=We(A),O=We(O);class b{constructor(){this.a=[]}add(d){this.b=void 0,this.a.push(d)}delete(d){const m=this.a.indexOf(d);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const d=this.a.sort(),m=[];let n,o,i=$.State.LastKnownState,t=$.State.LastKnownState;for(const s of d){let f=n?(0,l.$If)(n,s):0;for(f===0?o=$.State.Start:o=t;f<s.length;f++)f+1===s.length?(i=t,t=$.State.BeforeColon):t+=1,m.push([o,s.toUpperCase().charCodeAt(f),t]),m.push([o,s.toLowerCase().charCodeAt(f),t]),o=t;n=s,t=i}m.push([$.State.BeforeColon,I.CharCode.Colon,$.State.AfterColon]),m.push([$.State.AfterColon,I.CharCode.Slash,$.State.End]),this.b=new $.$83(m)}}provideDocumentLinks(d){this.c();const m=[],n=$.$93.computeLinks({getLineContent(o){return d.lineAt(o-1).text},getLineCount(){return d.lineCount}},this.b);for(const o of n){const i=O.DocumentLink.to(o);i.target&&m.push(i)}return m}}class c{constructor(d,m){this.i=m,this.b=new b,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=d.getProxy(h.$qN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(d,m,n,o={}){if(c.j(n),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(d,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,n);let t=A.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(t+=A.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(t+=A.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=A.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,u.$5G)(d,"fsChunks"),t+=A.FileSystemProviderCapabilities.FileOpenReadWriteClose);let s;o.isReadonly&&(0,k.$5k)(o.isReadonly)&&o.isReadonly.value!==""&&(s={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,t,s).catch(a=>{console.error(`FAILED to register filesystem provider of ${d.identifier.value}-extension for the scheme ${m}`),console.error(a)});const f=n.onDidChangeFile(a=>{const w=[];for(const y of a){const{uri:S,type:D}=y;if(S.scheme!==m)continue;let P;switch(D){case L.FileChangeType.Changed:P=A.FileChangeType.UPDATED;break;case L.FileChangeType.Created:P=A.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:P=A.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}w.push({resource:S,type:P})}this.a.$onFileSystemChange(i,w)});return(0,R.$Uc)(()=>{f.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(d){if(!d)throw new Error("MISSING provider");if(typeof d.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof d.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof d.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof d.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof d.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof d.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof d.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof d.rename!="function")throw new Error("Provider does NOT implement rename")}static k(d){const{type:m,ctime:n,mtime:o,size:i,permissions:t}=d;return{type:m,ctime:n,mtime:o,size:i,permissions:t}}$stat(d,m){return Promise.resolve(this.l(d).stat(r.URI.revive(m))).then(n=>c.k(n))}$readdir(d,m){return Promise.resolve(this.l(d).readDirectory(r.URI.revive(m)))}$readFile(d,m){return Promise.resolve(this.l(d).readFile(r.URI.revive(m))).then(n=>E.$Oe.wrap(n))}$writeFile(d,m,n,o){return Promise.resolve(this.l(d).writeFile(r.URI.revive(m),n.buffer,o))}$delete(d,m,n){return Promise.resolve(this.l(d).delete(r.URI.revive(m),n))}$rename(d,m,n,o){return Promise.resolve(this.l(d).rename(r.URI.revive(m),r.URI.revive(n),o))}$copy(d,m,n,o){const i=this.l(d);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(r.URI.revive(m),r.URI.revive(n),o))}$mkdir(d,m){return Promise.resolve(this.l(d).createDirectory(r.URI.revive(m)))}$watch(d,m,n,o){const i=this.l(d).watch(r.URI.revive(n),o);this.f.set(m,i)}$unwatch(d,m){const n=this.f.get(m);n&&(n.dispose(),this.f.delete(m))}$open(d,m,n){const o=this.l(d);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive(m),n))}$close(d,m){const n=this.l(d);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(m))}$read(d,m,n,o){const i=this.l(d);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=E.$Oe.alloc(o);return Promise.resolve(i.read(m,n,t.buffer,0,o)).then(s=>t.slice(0,s))}$write(d,m,n,o){const i=this.l(d);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,n,o.buffer,0,o.byteLength))}l(d){const m=this.c.get(d);if(!m){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return m}}e.$Woc=c}),define(Ee[354],Se([1,0,4,39,2,6,17,10,28,49]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0,L=We(L);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(b,c,g,d,m,n){this.a=Math.random(),this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,h.$zk)(m),i=typeof m=="string",t=n?.correlate,s=d(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(t&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const a of f.created){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.b.fire(w)}if(!n?.ignoreChangeEvents)for(const a of f.changed){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.c.fire(w)}if(!n?.ignoreDeleteEvents)for(const a of f.deleted){const w=A.URI.revive(a);o(w.fsPath)&&(!i||c.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=O.$sN.from(this.i(b,g,m,n,n?.correlate),this.b,this.c,this.d,s)}i(b,c,g,d,m){const n=O.$sN.from();if(typeof g=="string"||d?.ignoreChangeEvents&&d?.ignoreCreateEvents&&d?.ignoreDeleteEvents)return n;const o=b.getProxy(R.$qN.MainThreadFileSystemEventService);let i=!1;(g.pattern.includes(h.$vk)||g.pattern.includes(h.$wk))&&(i=!0);let t;return m&&(d?.ignoreChangeEvents||d?.ignoreCreateEvents||d?.ignoreDeleteEvents)&&(t=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,d?.ignoreChangeEvents&&(t&=~$.FileChangeFilter.UPDATED),d?.ignoreCreateEvents&&(t&=~$.FileChangeFilter.ADDED),d?.ignoreDeleteEvents&&(t&=~$.FileChangeFilter.DELETED)),o.$watch(c.identifier.value,this.a,g.baseUri,{recursive:i,excludes:d?.excludes??[],filter:t},!!m),O.$sN.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class E{constructor(b){this.a=b,this.session=this.a.session,this.b=new l.$X(()=>this.a.created.map(A.URI.revive)),this.c=new l.$X(()=>this.a.changed.map(A.URI.revive)),this.d=new l.$X(()=>this.a.deleted.map(A.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(b,c,g){this.j=b,this.k=c,this.l=g,this.a=new r.$me,this.b=new r.$me,this.c=new r.$me,this.d=new r.$me,this.g=new r.$oe,this.h=new r.$oe,this.i=new r.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(b,c,g,d){return new I(this.j,b,c,this.a.event,L.GlobPattern.from(g),d)}$onFileEvent(b){this.a.fire(new E(b))}$onDidRunFileOperation(b,c){switch(b){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:c.map(g=>({oldUri:A.URI.revive(g.source),newUri:A.URI.revive(g.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:c.map(g=>A.URI.revive(g.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:c.map(g=>A.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this.m(b,this.g)}getOnWillCreateFileEvent(b){return this.m(b,this.h)}getOnWillDeleteFileEvent(b){return this.m(b,this.i)}m(b,c){return(g,d,m)=>{const n=function(i){g.call(d,i)};return n.extension=b,c.event(n,void 0,m)}}async $onWillRunFileOperation(b,c,g,d){switch(b){case $.FileOperation.MOVE:return await this.n(this.g,{files:c.map(m=>({oldUri:A.URI.revive(m.source),newUri:A.URI.revive(m.target)}))},g,d);case $.FileOperation.DELETE:return await this.n(this.i,{files:c.map(m=>A.URI.revive(m.target))},g,d);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:c.map(m=>A.URI.revive(m.target))},g,d)}}async n(b,c,g,d){const m=new Set,n=[];if(await b.fireAsync(c,d,async(i,t)=>{const s=Date.now(),f=await Promise.resolve(i);f instanceof O.$CN&&(n.push([t.extension,f]),m.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-s>g&&this.k.warn("SLOW file-participant",t.extension.identifier)}),d.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,i]of n){const{edits:t}=L.WorkspaceEdit.from(i,{getTextDocumentVersion:s=>this.l.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(t)}return{edit:o,extensionNames:Array.from(m)}}}e.$Xoc=u}),define(Ee[355],Se([1,0,19,9,21,14,133,3,25,43,13,18,2,31,190,88,143,235,24,17,10,26,119,6]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0,c=We(c),n=We(n),s=We(s);class f{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const J=this.d.getDocument(q),x=await this.e.provideDocumentSymbols(J,V);if(!(0,r.$Mb)(x))return x[0]instanceof o.$MN?x.map(n.DocumentSymbol.from):f.f(x)}static f(q){q=q.slice(0).sort((x,fe)=>{let we=x.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(x.location.range.end)),we});const V=[],J=[];for(const x of q){const fe={name:x.name||"!!MISSING: name!!",kind:n.SymbolKind.from(x.kind),tags:x.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:n.Range.from(x.location.range),selectionRange:n.Range.from(x.location.range),children:[]};for(;;){if(J.length===0){J.push(fe),V.push(fe);break}const we=J[J.length-1];if(k.$It.containsRange(we.range,fe.range)&&!k.$It.equalsRange(we.range,fe.range)){we.children?.push(fe),J.push(fe);break}J.pop()}}return V}}class a{constructor(q,V,J,x,fe,we){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.l=we,this.d=new t.$ync("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const J=this.f.getDocument(q),x=await this.h.provideCodeLenses(J,V);if(!x||V.isCancellationRequested)return;const fe=this.d.add(x),we=new O.$Vc;this.e.set(fe,we);const Ne={cacheId:fe,lenses:[]};for(let Ge=0;Ge<x.length;Ge++)Ne.lenses.push({cacheId:[fe,Ge],range:n.Range.from(x[Ge].range),command:this.g.toInternal(x[Ge].command,we)});return Ne}async resolveCodeLens(q,V){const J=q.cacheId&&this.d.get(...q.cacheId);if(!J)return;let x;if(typeof this.h.resolveCodeLens!="function"||J.isResolved?x=J:x=await this.h.resolveCodeLens(J,V),x||(x=J),V.isCancellationRequested)return;const fe=q.cacheId&&this.e.get(q.cacheId[0]);if(fe){if(!x.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(x.command,fe),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function w(Oe){return Array.isArray(Oe)?Oe.map(n.DefinitionLink.from):Oe?[n.DefinitionLink.from(Oe)]:[]}class y{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideDefinition(x,fe,J);return w(we)}}class S{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideDeclaration(x,fe,J);return w(we)}}class D{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideImplementation(x,fe,J);return w(we)}}class P{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideTypeDefinition(x,fe,J);return w(we)}}class C{static{this.f=10}constructor(q,V){this.g=q,this.h=V,this.d=0,this.e=new Map}async provideHover(q,V,J,x){const fe=this.g.getDocument(q),we=n.Position.to(V);let Ne;if(J&&J.verbosityRequest){const rt=J.verbosityRequest.previousHover.id,ot=this.e.get(rt);if(!ot)throw new Error(`Hover with id ${rt} not found`);const nt={verbosityDelta:J.verbosityRequest.verbosityDelta,previousHover:ot};Ne=await this.h.provideHover(fe,we,x,nt)}else Ne=await this.h.provideHover(fe,we,x);if(!Ne||(0,r.$Mb)(Ne.contents))return;Ne.range||(Ne.range=fe.getWordRangeAtPosition(we)),Ne.range||(Ne.range=new o.$uN(we,we));const Ge=n.Hover.from(Ne),Ke=this.d;if(this.e.size===C.f){const rt=Math.min(...this.e.keys());this.e.delete(rt)}return this.e.set(Ke,Ne),this.d+=1,{...Ge,id:Ke}}releaseHover(q){this.e.delete(q)}}class p{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideEvaluatableExpression(x,fe,J);if(we)return n.EvaluatableExpression.from(we)}}class v{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,J,x){const fe=this.d.getDocument(q),we=await this.e.provideInlineValues(fe,n.Range.to(V),n.InlineValueContext.to(J),x);if(Array.isArray(we))return we.map(Ne=>n.InlineValue.from(Ne))}}class N{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideDocumentHighlights(x,fe,J);if(Array.isArray(we))return we.map(n.DocumentHighlight.from)}}class T{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,J,x){const fe=this.d.getDocument(q),we=J.map(Ke=>this.d.getDocument(Ke)),Ne=n.Position.to(V),Ge=await this.e.provideMultiDocumentHighlights(fe,Ne,we,x);if(Array.isArray(Ge))return Ge.map(n.MultiDocumentHighlight.from)}}class M{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,J){const x=this.d.getDocument(q),fe=n.Position.to(V),we=await this.e.provideLinkedEditingRanges(x,fe,J);if(we&&Array.isArray(we.ranges))return{ranges:(0,r.$Jb)(we.ranges.map(n.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,J,x){const fe=this.d.getDocument(q),we=n.Position.to(V),Ne=await this.e.provideReferences(fe,we,J,x);if(Array.isArray(Ne))return Ne.map(n.location.from)}}class z{static{this.d=1e3}constructor(q,V,J,x,fe,we,Ne){this.g=q,this.h=V,this.j=J,this.k=x,this.l=fe,this.m=we,this.n=Ne,this.e=new t.$ync("CodeAction"),this.f=new Map}async provideCodeActions(q,V,J,x){const fe=this.g.getDocument(q),we=b.$Kt.isISelection(V)?n.Selection.to(V):n.Range.to(V),Ne=[];for(const nt of this.j.getDiagnostics(q))if(we.intersection(nt.range)&&Ne.push(nt)>z.d)break;const Ge={diagnostics:Ne,only:J.only?new o.$ON(J.only):void 0,triggerKind:n.CodeActionTriggerKind.to(J.trigger)},Ke=await this.k.provideCodeActions(fe,we,Ge,x);if(!(0,r.$Nb)(Ke)||x.isCancellationRequested)return;const tt=this.e.add(Ke),rt=new O.$Vc;this.f.set(tt,rt);const ot=[];for(let nt=0;nt<Ke.length;nt++){const ct=Ke[nt];if(ct)if(z.o(ct))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ot.push({_isSynthetic:!0,title:ct.title,command:this.h.toInternal(ct,rt)});else{Ge.only&&(ct.kind?Ge.only.contains(ct.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action is of kind '${ct.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ge.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=ct.ranges??[];ot.push({cacheId:[tt,nt],title:ct.title,command:ct.command&&this.h.toInternal(ct.command,rt),diagnostics:ct.diagnostics&&ct.diagnostics.map(n.Diagnostic.from),edit:ct.edit&&n.WorkspaceEdit.from(ct.edit,void 0),kind:ct.kind&&ct.kind.value,isPreferred:ct.isPreferred,isAI:(0,i.$4G)(this.m,"codeActionAI")?ct.isAI:!1,ranges:(0,i.$4G)(this.m,"codeActionRanges")?(0,r.$Jb)($t.map(n.Range.from)):void 0,disabled:ct.disabled?.reason})}}return{cacheId:tt,actions:ot}}async resolveCodeAction(q,V){const[J,x]=q,fe=this.e.get(J,x);if(!fe||z.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,V)??fe;let Ne;we.edit&&(Ne=n.WorkspaceEdit.from(we.edit,void 0));let Ge;if(we.command){const Ke=this.f.get(J);Ke&&(Ge=this.h.toInternal(we.command,Ke))}return{edit:Ne,command:Ge}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class F{constructor(q,V,J,x,fe){this.e=q,this.f=V,this.g=J,this.h=x,this.j=fe,this.d=new t.$ync("DocumentPasteEdit")}async prepareDocumentPaste(q,V,J,x){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(q),we=V.map(Ke=>n.Range.to(Ke)),Ne=n.DataTransfer.toDataTransfer(J,()=>{throw new R.$ab});if(await this.g.prepareDocumentPaste(fe,we,Ne,x),x.isCancellationRequested)return;const Ge=Array.from(Ne).filter(([,Ke])=>!(Ke instanceof o.$iO));return n.DataTransfer.from(Ge)}async providePasteEdits(q,V,J,x,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(V),Ge=J.map(ot=>n.Range.to(ot)),Ke=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolvePasteFileData(this.h,q,ot)).buffer),tt=await this.g.provideDocumentPasteEdits(Ne,Ge,Ke,{only:fe.only?new o.$nO(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!tt||we.isCancellationRequested)return[];const rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(0,null,this.j.displayName||this.j.name),kind:ot.kind,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[J,x]=q,fe=this.d.get(J,x);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,V)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideDocumentFormattingEdits(x,V,J);if(Array.isArray(fe))return fe.map(n.TextEdit.from)}}class _{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,J,x){const fe=this.d.getDocument(q),we=n.Range.to(V),Ne=await this.e.provideDocumentRangeFormattingEdits(fe,we,J,x);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,J,x){(0,E.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(q),we=V.map(n.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(fe,we,J,x);if(Array.isArray(Ne))return Ne.map(n.TextEdit.from)}}class re{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,J,x,fe){const we=this.d.getDocument(q),Ne=n.Position.to(V),Ge=await this.e.provideOnTypeFormattingEdits(we,Ne,J,x,fe);if(Array.isArray(Ge))return Ge.map(n.TextEdit.from)}}class U{constructor(q,V){this.e=q,this.f=V,this.d=new t.$ync("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const J=await this.e.provideWorkspaceSymbols(q,V);if(!(0,r.$Nb)(J))return{symbols:[]};const x=this.d.add(J),fe={cacheId:x,symbols:[]};for(let we=0;we<J.length;we++){const Ne=J[we];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}fe.symbols.push({...n.WorkspaceSymbol.from(Ne),cacheId:[x,we]})}return fe}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const J=this.d.get(...q.cacheId);if(J){const x=await this.e.resolveWorkspaceSymbol(J,V);return x&&(0,$.$fo)(q,n.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class G{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideRenameEdits(q,V,J,x){const fe=this.d.getDocument(q),we=n.Position.to(V);try{const Ne=await this.e.provideRenameEdits(fe,we,J,x);return Ne?n.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Ge=G.g(Ne);return Ge?{rejectReason:Ge,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(q,V,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(q),fe=n.Position.to(V);try{const we=await this.e.prepareRename(x,fe,J);let Ne,Ge;if(o.$uN.isRange(we)?(Ne=we,Ge=x.getText(we)):(0,E.$hg)(we)&&(Ne=we.range,Ge=we.placeholder),!Ne||!Ge)return;if(Ne.start.line>fe.line||Ne.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ne),text:Ge}}catch(we){const Ne=G.g(we);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class Q{static{this.d={[c.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[c.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic}}constructor(q,V,J){this.e=q,this.f=V,this.g=J}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(q,V,J,x){const fe=this.e.getDocument(q),we=n.Range.to(V);try{const Ne=Q.d[J],Ge=await this.f.provideNewSymbolNames(fe,we,Ne,x);return Ge?Ge.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ne){this.g.error(Q.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ee{constructor(q,V){this.resultId=q,this.tokens=V}}class ue{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,J){const x=this.f.getDocument(q),fe=V!==0?this.d.get(V):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,fe.resultId,J):await this.g.provideDocumentSemanticTokens(x,J);return fe&&this.d.delete(V),we?(we=ue.h(we),this.o(ue.n(fe,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return ue.j(q)?ue.k(q)?q:new o.$NO(new Uint32Array(q.data),q.resultId):ue.l(q)?ue.m(q)?q:new o.$PO(q.edits.map(V=>new o.$OO(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!ue.j(V)||!q||!q.tokens)return V;const J=q.tokens,x=J.length,fe=V.data,we=fe.length;let Ne=0;const Ge=Math.min(x,we);for(;Ne<Ge&&J[Ne]===fe[Ne];)Ne++;if(Ne===x&&Ne===we)return new o.$PO([],V.resultId);let Ke=0;const tt=Ge-Ne;for(;Ke<tt&&J[x-Ke-1]===fe[we-Ke-1];)Ke++;return new o.$PO([{start:Ne,deleteCount:x-Ne-Ke,data:fe.subarray(Ne,we-Ke)}],V.resultId)}o(q,V){if(ue.j(q)){const J=this.e++;return this.d.set(J,new ee(q.resultId,q.data)),(0,g.$0cb)({id:J,type:"full",data:q.data})}if(ue.l(q)){const J=this.e++;return ue.j(V)?this.d.set(J,new ee(V.resultId,V.data)):this.d.set(J,new ee(q.resultId)),(0,g.$0cb)({id:J,type:"delta",deltas:(q.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class ne{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideDocumentRangeSemanticTokens(x,n.Range.to(V),J);return fe?this.f(fe):null}f(q){return(0,g.$0cb)({id:0,type:"full",data:q.data})}}class De{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,J,x,fe){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.d=new t.$ync("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,J,x){const fe=this.f.getDocument(q),we=n.Position.to(V),Ne=fe.getWordRangeAtPosition(we)||new o.$uN(we,we),Ge=Ne.with({end:we}),Ke=new l.$ge,tt=await this.h.provideCompletionItems(fe,we,x,n.CompletionContext.to(J));if(!tt||x.isCancellationRequested)return;const rt=Array.isArray(tt)?new o.$2N(tt):tt,ot=De.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),nt=new O.$Vc;this.e.set(ot,nt);const ct=[],$t={x:ot,[s.ISuggestResultDtoField.completions]:ct,[s.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ne),insert:n.Range.from(Ge)},[s.ISuggestResultDtoField.isIncomplete]:rt.isIncomplete||void 0,[s.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let ht=0;ht<rt.items.length;ht++){const at=rt.items[ht],Pe=this.l(at,[ot,ht],Ge,Ne);ct.push(Pe)}return $t}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...q);if(!J)return;const x=this.l(J,q),fe=await this.h.resolveCompletionItem(J,V);if(!fe)return;const we=this.l(fe,q);return(x[s.ISuggestDataDtoField.insertText]!==we[s.ISuggestDataDtoField.insertText]||x[s.ISuggestDataDtoField.insertTextRules]!==we[s.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x[s.ISuggestDataDtoField.commandIdent]!==we[s.ISuggestDataDtoField.commandIdent]||x[s.ISuggestDataDtoField.commandId]!==we[s.ISuggestDataDtoField.commandId]||!(0,$.$go)(x[s.ISuggestDataDtoField.commandArguments],we[s.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,[s.ISuggestDataDtoField.documentation]:we[s.ISuggestDataDtoField.documentation],[s.ISuggestDataDtoField.detail]:we[s.ISuggestDataDtoField.detail],[s.ISuggestDataDtoField.additionalTextEdits]:we[s.ISuggestDataDtoField.additionalTextEdits],[s.ISuggestDataDtoField.insertText]:we[s.ISuggestDataDtoField.insertText],[s.ISuggestDataDtoField.insertTextRules]:we[s.ISuggestDataDtoField.insertTextRules],[s.ISuggestDataDtoField.commandIdent]:we[s.ISuggestDataDtoField.commandIdent],[s.ISuggestDataDtoField.commandId]:we[s.ISuggestDataDtoField.commandId],[s.ISuggestDataDtoField.commandArguments]:we[s.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,J,x){const fe=this.e.get(V[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,fe),Ne={x:V,[s.ISuggestDataDtoField.label]:q.label,[s.ISuggestDataDtoField.kind]:q.kind!==void 0?n.CompletionItemKind.from(q.kind):void 0,[s.ISuggestDataDtoField.kindModifier]:q.tags&&q.tags.map(n.CompletionItemTag.from),[s.ISuggestDataDtoField.detail]:q.detail,[s.ISuggestDataDtoField.documentation]:typeof q.documentation>"u"?void 0:n.MarkdownString.fromStrict(q.documentation),[s.ISuggestDataDtoField.sortText]:q.sortText!==q.label?q.sortText:void 0,[s.ISuggestDataDtoField.filterText]:q.filterText!==q.label?q.filterText:void 0,[s.ISuggestDataDtoField.preselect]:q.preselect||void 0,[s.ISuggestDataDtoField.insertTextRules]:q.keepWhitespace?c.CompletionItemInsertTextRule.KeepWhitespace:c.CompletionItemInsertTextRule.None,[s.ISuggestDataDtoField.commitCharacters]:q.commitCharacters?.join(""),[s.ISuggestDataDtoField.additionalTextEdits]:q.additionalTextEdits&&q.additionalTextEdits.map(n.TextEdit.from),[s.ISuggestDataDtoField.commandIdent]:we?.$ident,[s.ISuggestDataDtoField.commandId]:we?.id,[s.ISuggestDataDtoField.commandArguments]:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[s.ISuggestDataDtoField.insertText]=q.textEdit.newText):typeof q.insertText=="string"?Ne[s.ISuggestDataDtoField.insertText]=q.insertText:q.insertText instanceof o.$DN&&(Ne[s.ISuggestDataDtoField.insertText]=q.insertText.value,Ne[s.ISuggestDataDtoField.insertTextRules]|=c.CompletionItemInsertTextRule.InsertAsSnippet);let Ge;return q.textEdit?Ge=q.textEdit.range:q.range&&(Ge=q.range),o.$uN.isRange(Ge)?Ne[s.ISuggestDataDtoField.range]=n.Range.from(Ge):Ge&&(!J?.isEqual(Ge.inserting)||!x?.isEqual(Ge.replacing))&&(Ne[s.ISuggestDataDtoField.range]={insert:n.Range.from(Ge.inserting),replace:n.Range.from(Ge.replacing)}),Ne}}class $e{async provideInlineCompletions(q,V,J,x){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,J){}handlePartialAccept(q,V,J,x){}}class K extends $e{constructor(q,V,J,x){super(),this.f=q,this.g=V,this.h=J,this.j=x,this.d=new se,this.e=(0,i.$4G)(this.f,"inlineCompletionsAdditions"),this.k={[c.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[c.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$4G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,J,x){const fe=this.g.getDocument(q),we=n.Position.to(V),Ne=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:n.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},x);if(!Ne||x.isCancellationRequested)return;const Ge=Array.isArray(Ne)?Ne:Ne.items,Ke=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],tt=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:Ge}),items:Ge.map((nt,ct)=>{let $t;nt.command&&(rt||(rt=new O.$Vc),$t=this.j.toInternal(nt.command,rt));const ht=nt.insertText;return{insertText:typeof ht=="string"?ht:{snippet:ht.value},filterText:nt.filterText,range:nt.range?n.Range.from(nt.range):void 0,command:$t,idx:ct,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Ke.map(nt=>(rt||(rt=new O.$Vc),this.j.toInternal(nt,rt))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,J){const x=this.d.get(q)?.items[V];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,J)}handlePartialAccept(q,V,J,x){const fe=this.d.get(q)?.items[V];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,J),this.h.handleDidPartiallyAcceptCompletionItem(fe,n.PartialAcceptInfo.to(x)))}}class W{async provideInlineEdits(q,V,J){const x=this.f.getDocument(q),fe=await this.g.provideInlineEdit(x,{triggerKind:this.e[V.triggerKind]},J);if(!fe||J.isCancellationRequested)return;let we;const Ne=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let Ge;fe.accepted&&(we||(we=new O.$Vc),Ge=this.h.toInternal(fe.accepted,we));let Ke;return fe.rejected&&(we||(we=new O.$Vc),Ke=this.h.toInternal(fe.rejected,we)),{pid:Ne,text:fe.text,range:n.Range.from(fe.range),accepted:Ge,rejected:Ke}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,J,x){this.f=V,this.g=J,this.h=x,this.d=new se,this.e={[c.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[c.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class se{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class oe{constructor(q,V){this.e=q,this.f=V,this.d=new t.$ync("SignatureHelp")}async provideSignatureHelp(q,V,J,x){const fe=this.e.getDocument(q),we=n.Position.to(V),Ne=this.g(J),Ge=await this.f.provideSignatureHelp(fe,we,x,Ne);if(Ge){const Ke=this.d.add([Ge]);return{...n.SignatureHelp.from(Ge),id:Ke}}}g(q){let V;if(q.activeSignatureHelp){const J=n.SignatureHelp.to(q.activeSignatureHelp),x=this.d.get(q.activeSignatureHelp.id,0);x?(V=x,V.activeSignature=J.activeSignature,V.activeParameter=J.activeParameter):V=J}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class te{constructor(q,V,J,x,fe){this.f=q,this.g=V,this.h=J,this.j=x,this.k=fe,this.d=new t.$ync("InlayHints"),this.e=new Map}async provideInlayHints(q,V,J){const x=this.f.getDocument(q),fe=n.Range.to(V),we=await this.h.provideInlayHints(x,fe,J);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(J.isCancellationRequested)return;const Ne=this.d.add(we);this.e.set(Ne,new O.$Vc);const Ge={hints:[],cacheId:Ne};for(let Ke=0;Ke<we.length;Ke++)this.l(we[Ke],fe)&&Ge.hints.push(this.m(we[Ke],[Ne,Ke]));return this.j.trace(`[InlayHints] ${Ge.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),Ge}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...q);if(!J)return;const x=await this.h.resolveInlayHint(J,V);if(x&&this.l(x))return this.m(x,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const J=this.e.get(V[0]);if(!J)throw Error("DisposableStore is missing...");const x={label:"",cacheId:V,tooltip:n.MarkdownString.fromStrict(q.tooltip),position:n.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(n.TextEdit.from),kind:q.kind&&n.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")x.label=q.label;else{const fe=[];x.label=fe;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:we.value,tooltip:n.MarkdownString.fromStrict(we.tooltip)};o.$EN.isLocation(we.location)&&(Ne.location=n.location.from(we.location)),we.command&&(Ne.command=this.g.toInternal(we.command,J)),fe.push(Ne)}}return x}}class le{constructor(q,V){this.e=q,this.f=V,this.d=new t.$ync("DocumentLink")}async provideLinks(q,V){const J=this.e.getDocument(q),x=await this.f.provideDocumentLinks(J,V);if(!(!Array.isArray(x)||x.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(le.g).map(n.DocumentLink.from)};{const fe=this.d.add(x),we={links:[],cacheId:fe};for(let Ne=0;Ne<x.length;Ne++){if(!le.g(x[Ne]))continue;const Ge=n.DocumentLink.from(x[Ne]);Ge.cacheId=[fe,Ne],we.links.push(Ge)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...q);if(!J)return;const x=await this.f.resolveDocumentLink(J,V);if(!(!x||!le.g(x)))return n.DocumentLink.from(x)}releaseLinks(q){this.d.delete(q)}}class he{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const J=this.d.getDocument(q),x=await this.e.provideDocumentColors(J,V);return Array.isArray(x)?x.map(we=>({color:n.Color.from(we.color),range:n.Range.from(we.range)})):[]}async provideColorPresentations(q,V,J){const x=this.d.getDocument(q),fe=n.Range.to(V.range),we=n.Color.to(V.color),Ne=await this.e.provideColorPresentations(we,{document:x,range:fe},J);if(Array.isArray(Ne))return Ne.map(n.ColorPresentation.from)}}class X{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,J){const x=this.d.getDocument(q),fe=await this.e.provideFoldingRanges(x,V,J);if(Array.isArray(fe))return fe.map(n.FoldingRange.from)}}class ae{constructor(q,V,J){this.d=q,this.e=V,this.f=J}async provideSelectionRanges(q,V,J){const x=this.d.getDocument(q),fe=V.map(n.Position.to),we=await this.e.provideSelectionRanges(x,fe,J);if(!(0,r.$Nb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Ge=0;Ge<fe.length;Ge++){const Ke=[];Ne.push(Ke);let tt=fe[Ge],rt=we[Ge];for(;;){if(!rt.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(rt)),!rt.parent)break;tt=rt.range,rt=rt.parent}}return Ne}}class pe{constructor(q,V){this.f=q,this.g=V,this.d=new L.$2P(""),this.e=new Map}async prepareSession(q,V,J){const x=this.f.getDocument(q),fe=n.Position.to(V),we=await this.g.prepareCallHierarchy(x,fe,J);if(!we)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(we)?we.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,we)]}async provideCallsTo(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(x,J);if(fe)return fe.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(Ne=>n.Range.from(Ne))}))}async provideCallsFrom(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(x,J);if(fe)return fe.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(Ne=>n.Range.from(Ne))}))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),x=n.CallHierarchyItem.from(V,q,J.size.toString(36));return J.set(x._itemId,V),x}j(q,V){return this.e.get(q)?.get(V)}}class be{constructor(q,V){this.f=q,this.g=V,this.d=new L.$2P(""),this.e=new Map}async prepareSession(q,V,J){const x=this.f.getDocument(q),fe=n.Position.to(V),we=await this.g.prepareTypeHierarchy(x,fe,J);if(!we)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(we)?we.map(Ge=>this.h(Ne,Ge)):[this.h(Ne,we)]}async provideSupertypes(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(x,J);if(fe)return fe.map(we=>this.h(q,we))}async provideSubtypes(q,V,J){const x=this.j(q,V);if(!x)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(x,J);if(fe)return fe.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,V){const J=this.e.get(q),x=n.TypeHierarchyItem.from(V,q,J.size.toString(36));return J.set(x._itemId,V),x}j(q,V){return this.e.get(q)?.get(V)}}class Fe{constructor(q,V,J,x,fe){this.e=q,this.f=V,this.g=J,this.h=x,this.j=fe,this.d=new t.$ync("DocumentDropEdit")}async provideDocumentOnDropEdits(q,V,J,x,fe){const we=this.f.getDocument(V),Ne=n.Position.to(J),Ge=n.DataTransfer.toDataTransfer(x,async ot=>(await this.e.$resolveDocumentOnDropFileData(this.h,q,ot)).buffer),Ke=await this.g.provideDocumentDropEdits(we,Ne,Ge,fe);if(!Ke)return;const tt=(0,r.$4b)(Ke),rt=this.d.add(tt);return tt.map((ot,nt)=>({_cacheId:[rt,nt],title:ot.title??(0,d.localize)(1,null,this.j.displayName||this.j.name),kind:ot.kind?.value,yieldTo:ot.yieldTo?.map(ct=>ct.value),insertText:typeof ot.insertText=="string"?ot.insertText:{snippet:ot.insertText.value},additionalEdit:ot.additionalEdit?n.WorkspaceEdit.from(ot.additionalEdit,void 0):void 0}))}async resolveDropEdit(q,V){const[J,x]=q,fe=this.d.get(J,x);if(!fe||!this.g.resolveDocumentDropEdit)return{};const we=await this.g.resolveDocumentDropEdit(fe,V)??fe;return{additionalEdit:we.additionalEdit?n.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releaseDropEdits(q){this.d.delete(q)}}class Be{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,J,x){const fe=u.URI.revive(q),we=this.d.getDocument(fe),Ne=J.documents.map(tt=>tt.map(rt=>({uri:u.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(ot=>n.Range.to(ot))}))),Ge={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(we,V,Ge,x);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(q,V){this.adapter=q,this.extension=V}}class Ie{static{this.d=0}constructor(q,V,J,x,fe,we,Ne,Ge){this.g=V,this.h=J,this.j=x,this.k=fe,this.l=we,this.m=Ne,this.n=Ge,this.f=new Map,this.e=q.getProxy(s.$qN.MainThreadLanguageFeatures)}o(q,V){return n.DocumentSelector.from(q,this.g,V)}p(q){return new o.$sN(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Ie.d++}async s(q,V,J,x,fe,we=!1){const Ne=this.f.get(q);if(!Ne||!(Ne.adapter instanceof V))return x;const Ge=Date.now();we||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Ke=J(Ne.adapter,Ne.extension);return Promise.resolve(Ke).catch(tt=>{(0,R.$6)(tt)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Ne.extension.identifier,tt))}).finally(()=>{we||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Ge}ms`)}),A.CancellationToken.isCancellationToken(fe)?(0,h.$uh)(Ke,fe):Ke}t(q,V){const J=this.q();return this.f.set(J,new ke(q,V)),J}static u(q){return q.displayName||q.name}static w(q){return q.identifier.value}registerDocumentSymbolProvider(q,V,J,x){const fe=this.t(new f(this.h,J),q),we=x&&x.label||Ie.u(q);return this.e.$registerDocumentSymbolProvider(fe,this.o(V,q),we),this.p(fe)}$provideDocumentSymbols(q,V,J){return this.s(q,f,x=>x.provideDocumentSymbols(u.URI.revive(V),J),void 0,J)}registerCodeLensProvider(q,V,J){const x=this.q(),fe=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ke(new a(this.h,this.j.converter,J,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(x,this.o(V,q),fe);let we=this.p(x);if(fe!==void 0){const Ne=J.onDidChangeCodeLenses(Ge=>this.e.$emitCodeLensEvent(fe));we=o.$sN.from(we,Ne)}return we}$provideCodeLenses(q,V,J){return this.s(q,a,x=>x.provideCodeLenses(u.URI.revive(V),J),void 0,J)}$resolveCodeLens(q,V,J){return this.s(q,a,x=>x.resolveCodeLens(V,J),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,a,J=>Promise.resolve(J.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,J){const x=this.t(new y(this.h,J),q);return this.e.$registerDefinitionSupport(x,this.o(V,q)),this.p(x)}$provideDefinition(q,V,J,x){return this.s(q,y,fe=>fe.provideDefinition(u.URI.revive(V),J,x),[],x)}registerDeclarationProvider(q,V,J){const x=this.t(new S(this.h,J),q);return this.e.$registerDeclarationSupport(x,this.o(V,q)),this.p(x)}$provideDeclaration(q,V,J,x){return this.s(q,S,fe=>fe.provideDeclaration(u.URI.revive(V),J,x),[],x)}registerImplementationProvider(q,V,J){const x=this.t(new D(this.h,J),q);return this.e.$registerImplementationSupport(x,this.o(V,q)),this.p(x)}$provideImplementation(q,V,J,x){return this.s(q,D,fe=>fe.provideImplementation(u.URI.revive(V),J,x),[],x)}registerTypeDefinitionProvider(q,V,J){const x=this.t(new P(this.h,J),q);return this.e.$registerTypeDefinitionSupport(x,this.o(V,q)),this.p(x)}$provideTypeDefinition(q,V,J,x){return this.s(q,P,fe=>fe.provideTypeDefinition(u.URI.revive(V),J,x),[],x)}registerHoverProvider(q,V,J,x){const fe=this.t(new C(this.h,J),q);return this.e.$registerHoverProvider(fe,this.o(V,q)),this.p(fe)}$provideHover(q,V,J,x,fe){return this.s(q,C,we=>we.provideHover(u.URI.revive(V),J,x,fe),void 0,fe)}$releaseHover(q,V){this.s(q,C,J=>Promise.resolve(J.releaseHover(V)),void 0,void 0)}registerEvaluatableExpressionProvider(q,V,J,x){const fe=this.t(new p(this.h,J),q);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(V,q)),this.p(fe)}$provideEvaluatableExpression(q,V,J,x){return this.s(q,p,fe=>fe.provideEvaluatableExpression(u.URI.revive(V),J,x),void 0,x)}registerInlineValuesProvider(q,V,J,x){const fe=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new v(this.h,J),q);this.e.$registerInlineValuesProvider(we,this.o(V,q),fe);let Ne=this.p(we);if(fe!==void 0){const Ge=J.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(fe));Ne=o.$sN.from(Ne,Ge)}return Ne}$provideInlineValues(q,V,J,x,fe){return this.s(q,v,we=>we.provideInlineValues(u.URI.revive(V),J,x,fe),void 0,fe)}registerDocumentHighlightProvider(q,V,J){const x=this.t(new N(this.h,J),q);return this.e.$registerDocumentHighlightProvider(x,this.o(V,q)),this.p(x)}registerMultiDocumentHighlightProvider(q,V,J){const x=this.t(new T(this.h,J),q);return this.e.$registerMultiDocumentHighlightProvider(x,this.o(V,q)),this.p(x)}$provideDocumentHighlights(q,V,J,x){return this.s(q,N,fe=>fe.provideDocumentHighlights(u.URI.revive(V),J,x),void 0,x)}$provideMultiDocumentHighlights(q,V,J,x,fe){return this.s(q,T,we=>we.provideMultiDocumentHighlights(u.URI.revive(V),J,x.map(Ne=>u.URI.revive(Ne)),fe),void 0,fe)}registerLinkedEditingRangeProvider(q,V,J){const x=this.t(new M(this.h,J),q);return this.e.$registerLinkedEditingRangeProvider(x,this.o(V,q)),this.p(x)}$provideLinkedEditingRanges(q,V,J,x){return this.s(q,M,async fe=>{const we=await fe.provideLinkedEditingRanges(u.URI.revive(V),J,x);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Ie.y(we.wordPattern):void 0}},void 0,x)}registerReferenceProvider(q,V,J){const x=this.t(new j(this.h,J),q);return this.e.$registerReferenceSupport(x,this.o(V,q)),this.p(x)}$provideReferences(q,V,J,x,fe){return this.s(q,j,we=>we.provideReferences(u.URI.revive(V),J,x,fe),void 0,fe)}registerCodeActionProvider(q,V,J,x){const fe=new O.$Vc,we=this.t(new z(this.h,this.j.converter,this.k,J,this.l,q,this.m),q);return this.e.$registerCodeActionSupport(we,this.o(V,q),{providedKinds:x?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:x?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,fe)}))},Ie.u(q),Ie.w(q),!!J.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(q,V,J,x,fe){return this.s(q,z,we=>we.provideCodeActions(u.URI.revive(V),J,x,fe),void 0,fe)}$resolveCodeAction(q,V,J){return this.s(q,z,x=>x.resolveCodeAction(V,J),{},void 0)}$releaseCodeActions(q,V){this.s(q,z,J=>Promise.resolve(J.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,J){const x=this.t(new B(this.h,J),q);return this.e.$registerDocumentFormattingSupport(x,this.o(V,q),q.identifier,q.displayName||q.name),this.p(x)}$provideDocumentFormattingEdits(q,V,J,x){return this.s(q,B,fe=>fe.provideDocumentFormattingEdits(u.URI.revive(V),J,x),void 0,x)}registerDocumentRangeFormattingEditProvider(q,V,J){const x=typeof J.provideDocumentRangesFormattingEdits=="function",fe=this.t(new _(this.h,J),q);return this.e.$registerRangeFormattingSupport(fe,this.o(V,q),q.identifier,q.displayName||q.name,x),this.p(fe)}$provideDocumentRangeFormattingEdits(q,V,J,x,fe){return this.s(q,_,we=>we.provideDocumentRangeFormattingEdits(u.URI.revive(V),J,x,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(q,V,J,x,fe){return this.s(q,_,we=>we.provideDocumentRangesFormattingEdits(u.URI.revive(V),J,x,fe),void 0,fe)}registerOnTypeFormattingEditProvider(q,V,J,x){const fe=this.t(new re(this.h,J),q);return this.e.$registerOnTypeFormattingSupport(fe,this.o(V,q),x,q.identifier),this.p(fe)}$provideOnTypeFormattingEdits(q,V,J,x,fe,we){return this.s(q,re,Ne=>Ne.provideOnTypeFormattingEdits(u.URI.revive(V),J,x,fe,we),void 0,we)}registerWorkspaceSymbolProvider(q,V){const J=this.t(new U(V,this.l),q);return this.e.$registerNavigateTypeSupport(J,typeof V.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(q,V,J){return this.s(q,U,x=>x.provideWorkspaceSymbols(V,J),{symbols:[]},J)}$resolveWorkspaceSymbol(q,V,J){return this.s(q,U,x=>x.resolveWorkspaceSymbol(V,J),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,U,J=>J.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,J){const x=this.t(new G(this.h,J,this.l),q);return this.e.$registerRenameSupport(x,this.o(V,q),G.supportsResolving(J)),this.p(x)}$provideRenameEdits(q,V,J,x,fe){return this.s(q,G,we=>we.provideRenameEdits(u.URI.revive(V),J,x,fe),void 0,fe)}$resolveRenameLocation(q,V,J,x){return this.s(q,G,fe=>fe.resolveRenameLocation(u.URI.revive(V),J,x),void 0,x)}registerNewSymbolNamesProvider(q,V,J){const x=this.t(new Q(this.h,J,this.l),q);return this.e.$registerNewSymbolNamesProvider(x,this.o(V,q)),this.p(x)}$supportsAutomaticNewSymbolNamesTriggerKind(q){return this.s(q,Q,V=>V.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(q,V,J,x,fe){return this.s(q,Q,we=>we.provideNewSymbolNames(u.URI.revive(V),J,x,fe),void 0,fe)}registerDocumentSemanticTokensProvider(q,V,J,x){const fe=this.t(new ue(this.h,J),q),we=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(V,q),x,we);let Ne=this.p(fe);if(we){const Ge=J.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(we));Ne=o.$sN.from(Ne,Ge)}return Ne}$provideDocumentSemanticTokens(q,V,J,x){return this.s(q,ue,fe=>fe.provideDocumentSemanticTokens(u.URI.revive(V),J,x),null,x)}$releaseDocumentSemanticTokens(q,V){this.s(q,ue,J=>J.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,J,x){const fe=this.t(new ne(this.h,J),q);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(V,q),x),this.p(fe)}$provideDocumentRangeSemanticTokens(q,V,J,x){return this.s(q,ne,fe=>fe.provideDocumentRangeSemanticTokens(u.URI.revive(V),J,x),null,x)}registerCompletionItemProvider(q,V,J,x){const fe=this.t(new De(this.h,this.j.converter,J,this.m,q),q);return this.e.$registerCompletionsProvider(fe,this.o(V,q),x,De.supportsResolving(J),q.identifier),this.p(fe)}$provideCompletionItems(q,V,J,x,fe){return this.s(q,De,we=>we.provideCompletionItems(u.URI.revive(V),J,x,fe),void 0,fe)}$resolveCompletionItem(q,V,J){return this.s(q,De,x=>x.resolveCompletionItem(V,J),void 0,J)}$releaseCompletionItems(q,V){this.s(q,De,J=>J.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,J,x){const fe=new K(q,this.h,J,this.j.converter),we=this.t(fe,q);return this.e.$registerInlineCompletionsSupport(we,this.o(V,q),fe.supportsHandleEvents,m.$qn.toKey(q.identifier.value),x?.yieldTo?.map(Ne=>m.$qn.toKey(Ne))||[]),this.p(we)}$provideInlineCompletions(q,V,J,x,fe){return this.s(q,$e,we=>we.provideInlineCompletions(u.URI.revive(V),J,x,fe),void 0,fe)}$handleInlineCompletionDidShow(q,V,J,x){this.s(q,$e,async fe=>{fe.handleDidShowCompletionItem(V,J,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,J,x,fe){this.s(q,$e,async we=>{we.handlePartialAccept(V,J,x,fe)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,$e,async J=>{J.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,J){const x=new W(q,this.h,J,this.j.converter),fe=this.t(x,q);return this.e.$registerInlineEditProvider(fe,this.o(V,q),q.identifier),this.p(fe)}$provideInlineEdit(q,V,J,x){return this.s(q,W,fe=>fe.provideInlineEdits(u.URI.revive(V),J,x),void 0,x)}$freeInlineEdit(q,V){this.s(q,W,async J=>{J.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,J,x){const fe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,we=this.t(new oe(this.h,J),q);return this.e.$registerSignatureHelpProvider(we,this.o(V,q),fe),this.p(we)}$provideSignatureHelp(q,V,J,x,fe){return this.s(q,oe,we=>we.provideSignatureHelp(u.URI.revive(V),J,x,fe),void 0,fe)}$releaseSignatureHelp(q,V){this.s(q,oe,J=>J.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,J){const x=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new te(this.h,this.j.converter,J,this.l,q),q);this.e.$registerInlayHintsProvider(fe,this.o(V,q),typeof J.resolveInlayHint=="function",x,Ie.u(q));let we=this.p(fe);if(x!==void 0){const Ne=J.onDidChangeInlayHints(Ge=>this.e.$emitInlayHintsEvent(x));we=o.$sN.from(we,Ne)}return we}$provideInlayHints(q,V,J,x){return this.s(q,te,fe=>fe.provideInlayHints(u.URI.revive(V),J,x),void 0,x)}$resolveInlayHint(q,V,J){return this.s(q,te,x=>x.resolveInlayHint(V,J),void 0,J)}$releaseInlayHints(q,V){this.s(q,te,J=>J.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,J){const x=this.t(new le(this.h,J),q);return this.e.$registerDocumentLinkProvider(x,this.o(V,q),typeof J.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(q,V,J){return this.s(q,le,x=>x.provideLinks(u.URI.revive(V),J),void 0,J,V.scheme==="output")}$resolveDocumentLink(q,V,J){return this.s(q,le,x=>x.resolveLink(V,J),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,le,J=>J.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,J){const x=this.t(new he(this.h,J),q);return this.e.$registerDocumentColorProvider(x,this.o(V,q)),this.p(x)}$provideDocumentColors(q,V,J){return this.s(q,he,x=>x.provideColors(u.URI.revive(V),J),[],J)}$provideColorPresentations(q,V,J,x){return this.s(q,he,fe=>fe.provideColorPresentations(u.URI.revive(V),J,x),void 0,x)}registerFoldingRangeProvider(q,V,J){const x=this.q(),fe=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ke(new X(this.h,J),q)),this.e.$registerFoldingRangeProvider(x,this.o(V,q),q.identifier,fe);let we=this.p(x);if(fe!==void 0){const Ne=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=o.$sN.from(we,Ne)}return we}$provideFoldingRanges(q,V,J,x){return this.s(q,X,fe=>fe.provideFoldingRanges(u.URI.revive(V),J,x),void 0,x)}registerSelectionRangeProvider(q,V,J){const x=this.t(new ae(this.h,J,this.l),q);return this.e.$registerSelectionRangeProvider(x,this.o(V,q)),this.p(x)}$provideSelectionRanges(q,V,J,x){return this.s(q,ae,fe=>fe.provideSelectionRanges(u.URI.revive(V),J,x),[],x)}registerCallHierarchyProvider(q,V,J){const x=this.t(new pe(this.h,J),q);return this.e.$registerCallHierarchyProvider(x,this.o(V,q)),this.p(x)}$prepareCallHierarchy(q,V,J,x){return this.s(q,pe,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(V),J,x)),void 0,x)}$provideCallHierarchyIncomingCalls(q,V,J,x){return this.s(q,pe,fe=>fe.provideCallsTo(V,J,x),void 0,x)}$provideCallHierarchyOutgoingCalls(q,V,J,x){return this.s(q,pe,fe=>fe.provideCallsFrom(V,J,x),void 0,x)}$releaseCallHierarchy(q,V){this.s(q,pe,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,J){const x=this.t(new be(this.h,J),q);return this.e.$registerTypeHierarchyProvider(x,this.o(V,q)),this.p(x)}$prepareTypeHierarchy(q,V,J,x){return this.s(q,be,fe=>Promise.resolve(fe.prepareSession(u.URI.revive(V),J,x)),void 0,x)}$provideTypeHierarchySupertypes(q,V,J,x){return this.s(q,be,fe=>fe.provideSupertypes(V,J,x),void 0,x)}$provideTypeHierarchySubtypes(q,V,J,x){return this.s(q,be,fe=>fe.provideSubtypes(V,J,x),void 0,x)}$releaseTypeHierarchy(q,V){this.s(q,be,J=>Promise.resolve(J.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,J,x){const fe=this.q();return this.f.set(fe,new ke(new Fe(this.e,this.h,J,fe,q),q)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(V,q),(0,i.$4G)(q,"documentPaste")&&x?{supportsResolve:!!J.resolveDocumentDropEdit,dropMimeTypes:x.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(q,V,J,x,fe,we){return this.s(q,Fe,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(V,u.URI.revive(J),x,fe,we)),void 0,void 0)}$resolveDropEdit(q,V,J){return this.s(q,Fe,x=>x.resolveDropEdit(V,J),{},void 0)}$releaseDocumentOnDropEdits(q,V){this.s(q,Fe,J=>Promise.resolve(J.releaseDropEdits(V)),void 0,void 0)}registerMappedEditsProvider(q,V,J){const x=this.t(new Be(this.h,J),q);return this.e.$registerMappedEditsProvider(x,this.o(V,q)),this.p(x)}$provideMappedEdits(q,V,J,x,fe){return this.s(q,Be,we=>Promise.resolve(we.provideMappedEdits(V,J,x,fe)),null,fe)}registerDocumentPasteEditProvider(q,V,J,x){const fe=this.q();return this.f.set(fe,new ke(new F(this.e,this.h,J,fe,q),q)),this.e.$registerPasteEditProvider(fe,this.o(V,q),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,supportsResolve:!!J.resolveDocumentPasteEdit,providedPasteEditKinds:x.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(q,V,J,x,fe){return this.s(q,F,we=>we.prepareDocumentPaste(u.URI.revive(V),J,x,fe),void 0,fe)}$providePasteEdits(q,V,J,x,fe,we,Ne){return this.s(q,F,Ge=>Ge.providePasteEdits(V,u.URI.revive(J),x,fe,we,Ne),void 0,Ne)}$resolvePasteEdit(q,V,J){return this.s(q,F,x=>x.resolvePasteEdit(V,J),{},void 0)}$releasePasteEdits(q,V){this.s(q,F,J=>Promise.resolve(J.releasePasteEdits(V)),void 0,void 0)}static y(q){return{pattern:q.source,flags:q.flags}}static z(q){return{decreaseIndentPattern:Ie.y(q.decreaseIndentPattern),increaseIndentPattern:Ie.y(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Ie.y(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Ie.y(q.unIndentedLinePattern):void 0}}static B(q){return{beforeText:Ie.y(q.beforeText),afterText:q.afterText?Ie.y(q.afterText):void 0,previousLineText:q.previousLineText?Ie.y(q.previousLineText):void 0,action:q.action}}static C(q){return q.map(Ie.B)}static D(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>o.SyntaxTokenType.toString(V)):void 0}}static E(q){return q.map(Ie.D)}setLanguageConfiguration(q,V,J){const{wordPattern:x}=J;if(x&&(0,I.$sf)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(V,x):this.h.setWordDefinitionFor(V,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const fe=this.q(),we={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Ie.y(J.wordPattern):void 0,indentationRules:J.indentationRules?Ie.z(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Ie.C(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Ie.E(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,V,we),this.p(fe)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$Inc=Ie}),define(Ee[129],Se([1,0,9,21,14,4,40,3,236,24,5,12,90,6,128,20,17,10,155,26]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=e.$poc=void 0,g=We(g),d=We(d),e.$poc=(0,I.$Fi)("IExtHostLanguageModels");class i{constructor(a,w){this.option=a,this.stream=new r.$9h,this.stream=w??new r.$9h}}class t{constructor(){this.a=new Map,this.b=new r.$9h,this.c=!1,this.d=!1;const a=this;this.apiObject={stream:a.b.asyncIterable,text:r.$6h.map(a.b.asyncIterable,w=>{if(w instanceof d.$GP)return w.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,a]of this.a)yield a.stream;else yield this.b}handleFragment(a){if(this.c)return;this.d=!0;let w=this.a.get(a.index);w||(this.a.size===0?w=new i(a.index,this.b):w=new i(a.index),this.a.set(a.index,w));let y;a.part.type==="text"?y=new d.$GP(a.part.value):y=new d.$FP(a.part.name,a.part.parameters),w.stream.emitOne(y)}get isStreaming(){return this.d}reject(a){this.c=!0;for(const w of this.f())w.reject(a)}resolve(){this.c=!0;for(const a of this.f())a.resolve()}}let s=class{static{o=this}static{this.a=1}constructor(a,w,y){this.j=w,this.k=y,this.c=new R.$me,this.d=new R.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new l.$sn,this.i=new Map,this.r=new Set,this.b=a.getProxy(k.$qN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(a,w,y,S){const D=o.a++;this.f.set(D,{extension:a.identifier,provider:y,languageModelId:w});let P;S.auth&&(P={providerLabel:a.displayName||a.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(D,`${l.$qn.toKey(a.identifier)}/${D}/${w}`,{extension:a.identifier,id:w,vendor:S.vendor??l.$qn.toKey(a.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:P,targetExtensions:S.extensions});const C=y.onDidReceiveLanguageModelResponse2?.(({extensionId:p,participant:v,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(w,new l.$qn(p),v,N)});return(0,O.$Uc)(()=>{this.f.delete(D),this.b.$unregisterProvider(D),C?.dispose()})}async $provideLanguageModelResponse(a,w,y,S,D,P){const C=this.f.get(a);if(!C)return;const p=new u.$sw(async v=>{if(P.isCancellationRequested){this.j.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let N;if(v.part instanceof d.$FP?N={type:"function_use",name:v.part.name,parameters:v.part.parameters}:v.part instanceof d.$GP&&(N={type:"text",value:v.part.value}),!N){this.j.warn(`[CHAT](${C.extension.value}) UNKNOWN part ${JSON.stringify(v)}`);return}this.b.$handleProgressChunk(w,{index:v.index,part:N})});if(C.provider.provideLanguageModelResponse2)return C.provider.provideLanguageModelResponse2(S.map(g.LanguageModelChatMessage.to),D,l.$qn.toKey(y),p,P);{const v=new u.$sw(async N=>{p.report({index:N.index,part:new d.$GP(N.part)})});return C.provider.provideLanguageModelResponse(S.map(g.LanguageModelChatMessage.to),D?.modelOptions??{},l.$qn.toKey(y),v,P)}}$provideTokenLength(a,w,y){const S=this.f.get(a);return S?Promise.resolve(S.provider.provideTokenCount(w,y)):Promise.resolve(0)}$acceptChatModelMetadata(a){if(a.added)for(const{identifier:w,metadata:y}of a.added)this.g.set(w,{metadata:y,apiObjects:new l.$sn});if(a.removed)for(const w of a.removed){this.g.delete(w);for(const[y,S]of this.i)S.languageModelId===w&&(S.res.reject(new A.$7),this.i.delete(y))}a.added?.forEach(w=>this.p(w.metadata)),this.d.fire(void 0)}async selectLanguageModels(a,w){const y=await this.b.$selectChatModels({...w,extension:a.identifier}),S=[],D=this;for(const P of y){const C=this.g.get(P);if(!C)continue;this.o(a.identifier,C.metadata)&&await this.p(C.metadata);let p=C.apiObjects.get(a.identifier);p||(p={id:P,vendor:C.metadata.vendor,family:C.metadata.family,version:C.metadata.version,name:C.metadata.name,maxInputTokens:C.metadata.maxInputTokens,countTokens(v,N){if(!D.g.has(P))throw d.$KP.NotFound(P);return D.q(P,v,N??h.CancellationToken.None)},sendRequest(v,N,T){if(!D.g.has(P))throw d.$KP.NotFound(P);return D.l(a,P,v,N??{},T??h.CancellationToken.None)}},Object.freeze(p),C.apiObjects.set(a.identifier,p)),S.push(p)}return S}async l(a,w,y,S,D){const P=this.m(a,y),C=a.identifier,p=this.g.get(w)?.metadata;if(!p||!this.g.has(w))throw d.$KP.NotFound(`Language model '${w}' is unknown.`);if(this.o(C,p)&&(!await this.n(a,{identifier:p.extension,displayName:p.auth.providerLabel},S.justification,!1)||!this.h.get(C)?.has(p.extension)))throw d.$KP.NoPermissions(`Language model '${w}' cannot be used by '${C.value}'.`);const v=Math.random()*1e6|0,N=this.b.$fetchResponse(C,w,v,P,S,D),T=new r.$Eh,M=new t;this.i.set(v,{languageModelId:w,res:M});let j;if(N.catch(z=>{T.isOpen()?M.reject(z):j=z}).finally(()=>{this.i.delete(v),M.resolve(),T.open()}),await T.wait(),j)throw j.name===d.$KP.name?j:new d.$KP(`Language model '${w}' errored, check cause for more details`,"Unknown",j);return M.apiObject}m(a,w){const y=[];for(const S of w)S.role===d.LanguageModelChatMessageRole.System&&(0,n.$5G)(a,"languageModelSystem"),S.content2 instanceof d.$DP&&(0,n.$5G)(a,"lmTools"),y.push(g.LanguageModelChatMessage.from(S));return y}async $handleResponseFragment(a,w){const y=this.i.get(a);y&&y.res.handleFragment(w)}async n(a,w,y,S){const D=m.$sM+w.identifier.value;if(await this.k.getSession(a,D,[],{silent:!0}))return this.$updateModelAccesslist([{from:a.identifier,to:w.identifier,enabled:!0}]),!0;if(S)return!1;try{const C=y?(0,$.localize)(0,null,w.displayName,y):void 0;return await this.k.getSession(a,D,[],{forceNewSession:{detail:C}}),this.$updateModelAccesslist([{from:a.identifier,to:w.identifier,enabled:!0}]),!0}catch{return!1}}o(a,w){return!!w.auth&&!l.$qn.equals(w.extension,a)}async p(a){if(a.auth)for(const w of this.r)try{await this.n(w,{identifier:a.extension,displayName:""},void 0,!0)}catch(y){this.j.error("Fake Auth request failed"),this.j.error(y)}}async q(a,w,y){if(!this.g.get(a))throw d.$KP.NotFound(`Language model '${a}' is unknown.`);const D=L.Iterable.find(this.f.values(),P=>P.languageModelId===a);return D?D.provider.provideTokenCount(w,y):this.b.$countTokens(a,typeof w=="string"?w:g.LanguageModelChatMessage.from(w),y)}$updateModelAccesslist(a){const w=new Array;for(const{from:y,to:S,enabled:D}of a){const P=this.h.get(y)??new l.$rn;if(P.has(S)!==D){D?P.add(S):P.delete(S),this.h.set(y,P);const p={from:y,to:S};w.push(p),this.c.fire(p)}}}createLanguageModelAccessInformation(a){this.r.add(a);const w=this,y=R.Event.signal(R.Event.filter(this.c.event,D=>l.$qn.equals(D.from,a.identifier))),S=R.Event.signal(this.d.event);return{get onDidChange(){return R.Event.any(y,S)},canSendRequest(D){let P;e:for(const[p,v]of w.g)for(const N of v.apiObjects.values())if(N===D){P=v.metadata;break e}if(!P)return;if(!w.o(a.identifier,P))return!0;const C=w.h.get(a.identifier);if(C)return C.has(P.extension)}}}};e.$qoc=s,e.$qoc=s=o=Je([Ve(0,c.$WP),Ve(1,E.$_j),Ve(2,b.$Knc)],s)});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[356],Se([1,0,6,17,10,44,9,3,26]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0,h=We(h),R=Ut(R);class l{constructor(E,u,k,b){this.c=u,this.d=k,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=E.getProxy(r.$qN.MainThreadLanguages)}$acceptLanguageIds(E){this.b=E}async getLanguages(){return this.b.slice(0)}async changeLanguage(E,u){await this.a.$changeLanguage(E,u);const k=this.c.getDocumentData(E);if(!k)throw new Error(`document '${E.toString()}' NOT found`);return k.document}async tokenAtPosition(E,u){const k=E.version,b=h.Position.from(u),c=await this.a.$tokensAtPosition(E.uri,b),g={type:A.StandardTokenType.Other,range:E.getWordRangeAtPosition(u)??new A.$uN(u.line,u.character,u.line,u.character)};if(!c)return g;const d={range:h.Range.to(c.range),type:h.TokenType.to(c.type)};return!d.range.contains(u)||k!==E.version?g:d}createLanguageStatusItem(E,u,k){const b=this.f++,c=this.a,g=this.g,d=`${E.identifier.value}/${u}`;if(g.has(d))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);g.add(d);const m={selector:k,id:u,name:E.displayName??E.name,severity:A.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new O.$Vc,i=()=>{if(n?.dispose(),!g.has(d)){console.warn(`LanguageStatusItem (${u}) from ${E.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$Hh)(()=>{o.clear(),this.a.$setLanguageStatus(b,{id:d,name:m.name??E.displayName??E.name,source:E.displayName??E.name,selector:h.DocumentSelector.from(m.selector,this.e),label:m.text,detail:m.detail??"",severity:m.severity===A.LanguageStatusSeverity.Error?R.default.Error:m.severity===A.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:m.command&&this.d.toInternal(m.command,o),accessibilityInfo:m.accessibilityInformation,busy:m.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),c.$removeLanguageStatus(b),g.delete(d)},get id(){return m.id},get name(){return m.name},set name(s){m.name=s,i()},get selector(){return m.selector},set selector(s){m.selector=s,i()},get text(){return m.text},set text(s){m.text=s,i()},set text2(s){(0,$.$5G)(E,"languageStatusText"),m.text=s,i()},get text2(){return(0,$.$5G)(E,"languageStatusText"),m.text},get detail(){return m.detail},set detail(s){m.detail=s,i()},get severity(){return m.severity},set severity(s){m.severity=s,i()},get accessibilityInformation(){return m.accessibilityInformation},set accessibilityInformation(s){m.accessibilityInformation=s,i()},get command(){return m.command},set command(s){m.command=s,i()},get busy(){return m.busy},set busy(s){m.busy=s,i()}};return i(),t}}e.$apc=l}),define(Ee[357],Se([1,0,15,2,17,10,127]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=void 0,A=We(A),L=We(L);class O{constructor(E,u,k,b){this.start=E,this.deletedCount=u,this.deletedItems=k,this.items=b}asApiEvent(){return{range:new R.$UO(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1}}constructor(E,u,k){this.notebook=E,this.h=u,this.j=k,this.handle=k.handle,this.uri=h.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(A.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(A.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:A.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return E.g},set mime(b){E.g=b},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(k)}return this.f}setOutputs(E){this.a=E.map(A.NotebookCellOutput.to)}setOutputItems(E,u,k){const b=k.map(A.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===E);if(c&&(u||(c.items.length=0),c.items.push(...b),c.items.length>1&&c.items.every(g=>L.$vL(g.mime)))){const g=new Map,d=[];c.items.forEach(m=>{let n;g.has(m.mime)?n=g.get(m.mime):(n=[],g.set(m.mime,n),d.push(m.mime)),n.push(m.data)}),c.items.length=0,d.forEach(m=>{const n=L.$wL(g.get(m));c.items.push({mime:m,data:n.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(A.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$Yoc=$;class l{static{this.a=0}constructor(E,u,k,b,c){this.k=E,this.l=u,this.m=k,this.uri=b,this.handle=l.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,u={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===r.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(k){return k=E.n(k),E.b[k].apiCell},getCells(k){return(k?E.p(k):E.b).map(c=>c.apiCell)},save(){return E.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,u,k){this.g=E.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:k});const b={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},c=[];for(const d of E.rawEvents)d.kind===L.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,b.contentChanges):d.kind===L.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,b.contentChanges):d.kind===L.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),c.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===L.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),c.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),c.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===L.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),c.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),c.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const g=new Map;for(let d=0;d<c.length;d++){const m=c[d],n=g.get(m.cell);if(n===void 0){const o=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...m});g.set(m.cell,o-1)}else b.cellChanges[n]={...b.cellChanges[n],...m}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let u=E.start|0,k=E.end|0;return u<0&&(u=0),k>this.b.length&&(k=this.b.length),E.with({start:u,end:k})}p(E){E=this.o(E);const u=[];for(let k=E.start;k<E.end;k++)u.push(this.b[k]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,u,k){if(this.j)return;const b=[],c=[],g=[];if(E.reverse().forEach(d=>{const n=d[2].map(t=>{const s=new $(this,this.l,t);return u||c.push($.asModelAddData(t)),s}),o=new O(d[0],d[1],[],n),i=this.b.splice(d[0],d[1],...n);for(const t of i)g.push(t.uri),o.deletedItems.push(t.apiCell);b.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),k)for(const d of b)k.push(d.asApiEvent())}s(E,u,k,b){const c=this.b.splice(E,u);this.b.splice(k,0,...c);const g=[new O(E,u,c.map(d=>d.apiCell),[]),new O(k,0,[],c)];for(const d of g)b.push(d.asApiEvent())}t(E,u){this.b[E].setOutputs(u)}u(E,u,k,b){this.b[E].setOutputItems(u,k,b)}v(E,u){const k=this.b[E];k.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(k.uri,u)}w(E,u){const k=this.b[E];k.apiCell.mime=u}x(E,u){this.b[E].setMetadata(u)}y(E,u){this.b[E].setInternalMetadata(u)}getCellFromApiCell(E){return this.b.find(u=>u.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(u=>u.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$Zoc=l}),define(Ee[358],Se([1,0,4,2,17,10,51]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class O{constructor(l,I,E,u={timeout:1500,errors:3}){this.b=l,this.c=I,this.d=E,this.f=u,this.a=new r.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(I,E,u)=>{const k=function(c){I.call(E,c)};return k.extension=l,this.a.event(k,void 0,u)}}async $participateInSave(l,I,E){const u=h.URI.revive(l),k=this.c.getNotebookDocument(u);if(!k)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:A.TextDocumentSaveReason.to(I)},E,async(g,d)=>{const m=Date.now(),n=await await Promise.resolve(g);Date.now()-m>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!E.isCancellationRequested&&n&&(n instanceof R.$CN?b.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),E.isCancellationRequested)return!1;if(b.length===0)return!0;const c={edits:[]};for(const g of b){const{edits:d}=A.WorkspaceEdit.from(g);c.edits=c.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(new L.$Qw(c))}}e.$cpc=O}),define(Ee[164],Se([1,0,14,17,10]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0,h=We(h),A=We(A);class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(O,$,l,I,E,u){this.id=O,this.f=$,this.notebookData=l,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=I,this.c=u}get apiEditor(){if(!this.e){const O=this;this.e={get notebook(){return O.notebookData.apiNotebook},get selection(){return O.a[0]},set selection($){this.selections=[$]},get selections(){return O.a},set selections($){if(!Array.isArray($)||!$.every(A.$UO.isNotebookRange))throw(0,r.$9)("selections");O.a=$,O.g($)},get visibleRanges(){return O.b},revealRange($,l){O.f.$tryRevealRange(O.id,h.NotebookRange.from($),l??A.NotebookEditorRevealType.Default)},get viewColumn(){return O.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(O){this.d=O}_acceptVisibleRanges(O){this.b=O}_acceptSelections(O){this.a=O}g(O){this.f.$trySetSelections(this.id,O.map(h.NotebookRange.from))}_acceptViewColumn(O){this.c=O}}e.$1oc=R}),define(Ee[359],Se([1,0,4,12,17]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0,A=We(A);let R=class{constructor(O,$){this.c=O,this.d=$,this.a=new r.$me,this.b=new r.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(O,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",O,$);const l=this.d.getEditorById(O);$.visibleRanges&&l._acceptVisibleRanges($.visibleRanges.ranges.map(A.NotebookRange.to)),$.selections&&l._acceptSelections($.selections.selections.map(A.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(O){for(const $ in O)this.d.getEditorById($)._acceptViewColumn(A.ViewColumn.to(O[$]))}};e.$epc=R,e.$epc=R=Je([Ve(0,h.$_j)],R)}),define(Ee[360],Se([1,0,4,6,164]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0;class R{constructor(O,$){this.c=$,this.a=new Map,this.b=O.getProxy(h.$qN.MainThreadNotebookRenderers)}$postRendererMessage(O,$,l){const I=this.c.getEditorById(O);this.a.get($)?.fire({editor:I.apiEditor,message:l})}createRendererMessaging(O,$){if(!O.contributes?.notebookRenderer?.some(I=>I.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(I,E,u)=>this.d($).event(I,E,u),postMessage:(I,E)=>{A.$1oc.apiEditorsToExtHost.has(I)&&([I,E]=[E,I]);const u=E&&A.$1oc.apiEditorsToExtHost.get(E);return this.b.$postMessage(u?.id,$,I)}}}d(O){let $=this.a.get(O);return $||($=new r.$me({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(O)}}),this.a.set(O,$),$)}}e.$hpc=R}),define(Ee[361],Se([1,0,17,90,21,59,14]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;class O{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,u,k){const b=this.b++,{title:c,location:g,cancellable:d}=u,m={label:E.displayName||E.name,id:E.identifier.value};return this.a.$startProgress(b,{location:r.ProgressLocation.from(g),title:c,source:m,cancellable:d},E.isUnderDevelopment?void 0:E.identifier.value).catch(L.$4),this.d(b,k,!!d)}d(E,u,k){let b;k&&(b=new A.$xe,this.c.set(E,b));const c=d=>{this.a.$progressEnd(d),this.c.delete(d),b?.dispose()};let g;try{g=u(new l(this.a,E),k&&b?b.token:A.CancellationToken.None)}catch(d){throw c(E),d}return g.then(d=>c(E),d=>c(E)),g}$acceptProgressCanceled(E){const u=this.c.get(E);u&&(u.cancel(),this.c.delete(E))}}e.$lpc=O;function $(I,E){return I.message=E.message,typeof E.increment=="number"&&(typeof I.increment=="number"?I.increment+=E.increment:I.increment=E.increment),I}class l extends h.$sw{constructor(E,u){super(k=>this.throttledReport(k)),this.c=E,this.d=u}throttledReport(E){this.c.$progressReport(this.d,E)}}Je([(0,R.$_h)(100,(I,E)=>$(I,E),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(Ee[362],Se([1,0,2,6,9,17]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0;class L{static{this.a=0}constructor($,l){this.d=l,this.c=new Map,this.b=$.getProxy(h.$qN.MainThreadQuickDiff)}$provideOriginalResource($,l,I){const E=r.URI.revive(l),u=this.c.get($);return u?(0,A.$xh)(()=>u.provideOriginalResource(E,I)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,l,I,E){const u=L.a++;return this.c.set(u,l),this.b.$registerQuickDiffProvider(u,R.DocumentSelector.from($,this.d),I,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$mpc=L});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[363],Se([1,0,21,4,3,6,2,10,14,19,44,50,26,17]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=b,I=Ut(I);function b(c,g,d){const m=c.getProxy(R.$qN.MainThreadQuickOpen);class n{constructor(S,D){this.e=new Map,this.f=0,this.a=S,this.b=D}showQuickPick(S,D,P,C=r.CancellationToken.None){this.c=void 0;const p=Promise.resolve(D),v=++this.f,N=m.$show(v,{title:P?.title,placeHolder:P?.placeHolder,matchOnDescription:P?.matchOnDescription,matchOnDetail:P?.matchOnDetail,ignoreFocusLost:P?.ignoreFocusOut,canPickMany:P?.canPickMany},C),T={},M=N.then(()=>T);return Promise.race([M,p]).then(j=>{if(j===T)return;const z=(0,u.$4G)(S,"quickPickItemTooltip");return p.then(F=>{const B=[];for(let _=0;_<F.length;_++){const re=F[_];if(typeof re=="string")B.push({label:re,handle:_});else if(re.kind===O.QuickPickItemKind.Separator)B.push({type:"separator",label:re.label});else{re.tooltip&&!z&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const U=re.iconPath?f(re.iconPath):void 0;B.push({label:re.label,iconPath:U?.iconPath,iconClass:U?.iconClass,description:re.description,detail:re.detail,picked:re.picked,alwaysShow:re.alwaysShow,tooltip:z?k.MarkdownString.fromStrict(re.tooltip):void 0,handle:_})}}return P&&typeof P.onDidSelectItem=="function"&&(this.c=_=>{P.onDidSelectItem(F[_])}),m.$setItems(v,B),N.then(_=>{if(typeof _=="number")return F[_];if(Array.isArray(_))return _.map(re=>F[re])})})}).then(void 0,j=>{if(!(0,$.$6)(j))return m.$setError(v,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,D=r.CancellationToken.None){return this.d=S?.validateInput,m.$input(S,typeof this.d=="function",D).then(void 0,P=>{if(!(0,$.$6)(P))return Promise.reject(P)})}async $validateInput(S){if(!this.d)return;const D=await this.d(S);if(!D||typeof D=="string")return D;let P;switch(D.severity){case O.InputBoxValidationSeverity.Info:P=I.default.Info;break;case O.InputBoxValidationSeverity.Warning:P=I.default.Warning;break;case O.InputBoxValidationSeverity.Error:P=I.default.Error;break;default:P=D.message?I.default.Error:I.default.Ignore;break}return{content:D.message,severity:P}}async showWorkspaceFolderPick(S,D=r.CancellationToken.None){const P=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!P)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(p=>p.uri.toString()===P.uri.toString())}createQuickPick(S){const D=new a(S,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(S){const D=new w(S,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(S,D){this.e.get(S)?._fireDidChangeValue(D)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,D){const P=this.e.get(S);P instanceof a&&P._fireDidChangeActive(D)}$onDidChangeSelection(S,D){const P=this.e.get(S);P instanceof a&&P._fireDidChangeSelection(D)}$onDidTriggerButton(S,D){this.e.get(S)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(S,D,P){const C=this.e.get(S);C instanceof a&&C._fireDidTriggerItemButton(D,P)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{static{this.a=1}constructor(S,D){this.x=S,this.y=D,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new h.$me,this.q=new h.$me,this.r=new h.$me,this.s=new h.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((D,P)=>{const C=D===O.$RO.Back?-1:P;this.o.set(C,D)}),this.z({buttons:S.map((D,P)=>({...f(D.iconPath),tooltip:D.tooltip,handle:D===O.$RO.Back?-1:P}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const D=this.o.get(S);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,A.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),m.$dispose(this._id))}z(S){if(!this.v){for(const D of Object.keys(S)){const P=S[D];this.u[D]=P===void 0?null:P}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){m.$createOrUpdate(this.u),this.u={id:this._id}}}function i(y){if(y instanceof O.$pO)return{id:y.id};const S=s(y),D=t(y);return{dark:typeof S=="string"?L.URI.file(S):S,light:typeof D=="string"?L.URI.file(D):D}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function s(y){return typeof y=="object"&&"dark"in y?y.dark:y}function f(y){const S=i(y);let D,P;return"id"in S?P=E.ThemeIcon.asClassName(S):D=S,{iconPath:D,iconClass:P}}class a extends o{constructor(S,D){super(S.identifier,D),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new h.$me,this.L=[],this.M=new h.$me,this.N=new h.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((C,p)=>{this.C.set(p,C),this.D.set(C,p)});const D=(0,u.$4G)(this.O,"quickPickItemTooltip"),P=[];for(let C=0;C<S.length;C++){const p=S[C];if(p.kind===O.QuickPickItemKind.Separator)P.push({type:"separator",label:p.label});else{p.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const v=p.iconPath?f(p.iconPath):void 0;P.push({handle:C,label:p.label,iconPath:v?.iconPath,iconClass:v?.iconClass,description:p.description,detail:p.detail,picked:p.picked,alwaysShow:p.alwaysShow,tooltip:D?k.MarkdownString.fromStrict(p.tooltip):void 0,buttons:p.buttons?.map((N,T)=>({...f(N.iconPath),tooltip:N.tooltip,handle:T}))})}}this.z({items:P})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(S){const D=(0,l.$Jb)(S.map(P=>this.C.get(P)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(S){const D=(0,l.$Jb)(S.map(P=>this.C.get(P)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(S,D){const P=this.C.get(S);if(!P||!P.buttons||!P.buttons.length)return;const C=P.buttons[D];C&&this.N.fire({button:C,item:P})}}class w extends o{constructor(S,D){super(S.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:I.default.Error}):this.z({validationMessage:S.message,severity:S.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new n(g,d)}}),define(Ee[364],Se([1,0,2,4,59,3,9,6,19,140,12,24,41,50,17,26,15,11]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=void 0;function n(N){return N instanceof r.URI}function o(N,T){return N.scheme===g.Schemas.file&&T.scheme===g.Schemas.file&&d.$k?N.toString()===T.toString():N.toString().toLowerCase()===T.toString().toLowerCase()}function i(N){if(N)return typeof N.iconPath=="string"?r.URI.file(N.iconPath):r.URI.isUri(N.iconPath)||k.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function t(N){if(N.icon){if(r.URI.isUri(N.icon))return N.icon;if(k.ThemeIcon.isThemeIcon(N.icon))return N.icon;{const T=N.icon;return{light:T.light,dark:T.dark}}}else return}function s(N,T){if(!N.iconPath&&!T.iconPath)return 0;if(N.iconPath){if(!T.iconPath)return 1}else return-1;const M=typeof N.iconPath=="string"?N.iconPath:r.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,j=typeof T.iconPath=="string"?T.iconPath:r.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id;return(0,l.$Er)(M,j)}function f(N,T){let M=0;if(N.strikeThrough!==T.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==T.faded)return N.faded?1:-1;if(N.tooltip!==T.tooltip)return(N.tooltip||"").localeCompare(T.tooltip||"");if(M=s(N,T),M!==0)return M;if(N.light&&T.light)M=s(N.light,T.light);else{if(N.light)return 1;if(T.light)return-1}if(M!==0)return M;if(N.dark&&T.dark)M=s(N.dark,T.dark);else{if(N.dark)return 1;if(T.dark)return-1}return M}function a(N,T){if(N.command!==T.command)return N.command<T.command?-1:1;if(N.title!==T.title)return N.title<T.title?-1:1;if(N.tooltip!==T.tooltip){if(N.tooltip!==void 0&&T.tooltip!==void 0)return N.tooltip<T.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(T.tooltip!==void 0)return-1}if(N.arguments===T.arguments)return 0;if(N.arguments)if(T.arguments){if(N.arguments.length!==T.arguments.length)return N.arguments.length-T.arguments.length}else return 1;else return-1;for(let M=0;M<N.arguments.length;M++){const j=N.arguments[M],z=T.arguments[M];if(j!==z&&!(n(j)&&n(z)&&o(j,z)))return j<z?-1:1}return 0}function w(N,T){let M=(0,l.$Er)(N.resourceUri.fsPath,T.resourceUri.fsPath,!0);if(M!==0)return M;if(N.command&&T.command)M=a(N.command,T.command);else{if(N.command)return 1;if(T.command)return-1}if(M!==0)return M;if(N.decorations&&T.decorations)M=f(N.decorations,T.decorations);else{if(N.decorations)return 1;if(T.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&T.multiFileDiffEditorModifiedUri)M=(0,l.$Er)(N.multiFileDiffEditorModifiedUri.fsPath,T.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(T.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&T.multiDiffEditorOriginalUri)M=(0,l.$Er)(N.multiDiffEditorOriginalUri.fsPath,T.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(T.multiDiffEditorOriginalUri)return-1}return M}function y(N,T){for(let M=0;M<N.length;M++)if(N[M]!==T[M])return!1;return!0}function S(N,T){return N.command===T.command&&N.title===T.title&&N.tooltip===T.tooltip&&(N.arguments&&T.arguments?y(N.arguments,T.arguments):N.arguments===T.arguments)}function D(N,T){return(0,$.$wb)(N,T,S)}class P{#e;#t;get value(){return this.d}set value(T){T=T??"",this.#e.$setInputBoxValue(this.l,T),this.n(T)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(T){this.#e.$setInputBoxPlaceholder(this.l,T),this.f=T}get validateInput(){return(0,c.$5G)(this.k,"scmValidation"),this.g}set validateInput(T){if((0,c.$5G)(this.k,"scmValidation"),T&&typeof T!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=T,this.#e.$setValidationProviderIsEnabled(this.l,!!T)}get enabled(){return this.h}set enabled(T){T=!!T,this.h!==T&&(this.h=T,this.#e.$setInputBoxEnablement(this.l,T))}get visible(){return this.j}set visible(T){T=!!T,this.j!==T&&(this.j=T,this.#e.$setInputBoxVisibility(this.l,T))}get document(){return(0,c.$5G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(T,M,j,z,F){this.k=T,this.l=z,this.m=F,this.d="",this.e=new h.$me,this.f="",this.h=!0,this.j=!0,this.#t=M,this.#e=j}showValidationMessage(T,M){(0,c.$5G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,T,M)}$onInputBoxValueChange(T){this.n(T)}n(T){this.d=T,this.e.fire(T)}}e.$opc=P;class C{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(T){this.v=T,this.q.$updateGroupLabel(this.t,this.handle,T)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(T){this.p=T,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(T){this.f=[...T],this.k.fire()}constructor(T,M,j,z,F,B,_){this.q=T,this.s=M,this.t=j,this.u=z,this.v=F,this.multiDiffEditorEnableViewChanges=B,this.w=_,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new h.$me,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new h.$me,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=C.d++}getResourceState(T){return this.g.get(T)}$executeResourceCommand(T,M){const j=this.h.get(T);return j?(0,L.$xh)(()=>this.s.executeCommand(j.command,...j.arguments||[],M)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const T=[...this.f].sort(w),j=(0,$.$Fb)(this.o,T,w).map(B=>{const _=B.toInsert.map(re=>{const U=this.e++;this.g.set(U,re);const G=re.resourceUri;let Q;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const X=new R.$Vc;Q=this.s.converter.toInternal(re.command,X),this.j.set(U,X)}else this.h.set(U,re.command);const ee=(0,c.$4G)(this.w,"scmMultiDiffEditor"),ue=ee?re.multiDiffEditorOriginalUri:void 0,ne=ee?re.multiFileDiffEditorModifiedUri:void 0,De=i(re.decorations),$e=re.decorations&&i(re.decorations.light)||De,K=re.decorations&&i(re.decorations.dark)||De,W=[$e,K],se=re.decorations&&re.decorations.tooltip||"",oe=re.decorations&&!!re.decorations.strikeThrough,te=re.decorations&&!!re.decorations.faded,le=re.contextValue||"";return{rawResource:[U,G,W,se,oe,te,le,Q,ue,ne],handle:U}});return{start:B.start,deleteCount:B.deleteCount,toInsert:_}}),z=j.map(({start:B,deleteCount:_,toInsert:re})=>[B,_,re.map(U=>U.rawResource)]),F=j.reverse();for(const{start:B,deleteCount:_,toInsert:re}of F){const U=re.map(Q=>Q.handle),G=this.n.splice(B,_,...U);for(const Q of G)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=T,z}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(T){this.g!==T&&(this.g=T,this.#e.$updateSourceControl(this.w,{count:T}))}get quickDiffProvider(){return this.h}set quickDiffProvider(T){this.h=T;let M;(0,c.$4G)(this.x,"quickDiffProvider")&&(M=T?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!T,quickDiffLabel:M})}get historyProvider(){return(0,c.$5G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(T){(0,c.$5G)(this.x,"scmHistoryProvider"),this.j=T,this.k.value=new R.$Vc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!T}),T&&this.k.value.add(T.onDidChangeCurrentHistoryItemGroup(()=>{this.l=T?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(T){T!==this.m&&(this.m=T,this.#e.$updateSourceControl(this.w,{commitTemplate:T}))}get acceptInputCommand(){return this.o}set acceptInputCommand(T){this.n.value=new R.$Vc,this.o=T;const M=this.y.converter.toInternal(T,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:M})}get actionButton(){return(0,c.$5G)(this.x,"scmActionButton"),this.q}set actionButton(T){(0,c.$5G)(this.x,"scmActionButton"),this.p.value=new R.$Vc,this.q=T;const M=T!==void 0?{command:this.y.converter.toInternal(T.command,this.p.value),secondaryCommands:T.secondaryCommands?.map(j=>j.map(z=>this.y.converter.toInternal(z,this.p.value))),description:T.description,enabled:T.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:M??null})}get statusBarCommands(){return this.t}set statusBarCommands(T){if(this.z.info("ExtHostSourceControl#statusBarCommands",(T??[]).map(j=>j.command).join(", ")),this.t&&T&&D(this.t,T)){this.z.info("ExtHostSourceControl#statusBarCommands are equal");return}this.s.value=new R.$Vc,this.t=T;const M=(T||[]).map(j=>this.y.converter.toInternal(j,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:M})}get selected(){return this.u}constructor(T,M,j,z,F,B,_,re){this.x=T,this.y=z,this.z=F,this.A=B,this.B=_,this.C=re,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Xc,this.m=void 0,this.n=new R.$Xc,this.o=void 0,this.p=new R.$Xc,this.s=new R.$Xc,this.t=void 0,this.u=!1,this.v=new h.$me,this.onDidChangeSelection=this.v.event,this.w=p.d++,this.D=new Map,this.E=new Set,this.#e=j;const U=r.URI.from({scheme:g.Schemas.vscodeSourceControl,path:`${B}/scm${this.w}/input`,query:re?`rootUri=${encodeURIComponent(re.toString())}`:void 0});this.f=new P(T,M,this.#e,this.w,U),this.#e.$registerSourceControl(this.w,B,_,re,U)}createResourceGroup(T,M,j){const z=(0,c.$4G)(this.x,"scmMultiDiffEditor")&&j?.multiDiffEditorEnableViewChanges===!0,F=new C(this.#e,this.y,this.w,T,M,z,this.x),B=h.Event.once(F.onDidDispose)(()=>this.D.delete(F));return this.D.set(F,B),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const T=[],M=[];for(const[j,z]of this.D){z.dispose();const F=j.onDidUpdateResourceStates(()=>{this.E.add(j),this.eventuallyUpdateResourceStates()});h.Event.once(j.onDidDispose)(()=>{this.E.delete(j),F.dispose(),this.e.delete(j.handle),this.#e.$unregisterGroup(this.w,j.handle)}),T.push([j.handle,j.id,j.label,j.features,j.multiDiffEditorEnableViewChanges]);const B=j._takeResourceStateSnapshot();B.length>0&&M.push([j.handle,B]),this.e.set(j.handle,j)}this.#e.$registerGroups(this.w,T,M),this.D.clear()}eventuallyUpdateResourceStates(){const T=[];this.E.forEach(M=>{const j=M._takeResourceStateSnapshot();j.length!==0&&T.push([M.handle,j])}),T.length>0&&this.#e.$spliceResourceStates(this.w,T),this.E.clear()}getResourceGroup(T){return this.e.get(T)}setSelectionState(T){this.u=T,this.v.fire(T)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(T=>T.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,A.$$h)(100)],p.prototype,"eventuallyAddResourceGroups",null),Je([(0,A.$$h)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let v=class{static{m=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(T,M,j,z){this.l=M,this.m=j,this.n=z,this.g=new Map,this.h=new E.$sn,this.j=new h.$me,this.e=T.getProxy(O.$qN.MainThreadSCM),this.f=T.getProxy(O.$qN.MainThreadTelemetry),M.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===u.MarshalledId.ScmResource){const B=this.g.get(F.sourceControlHandle);if(!B)return F;const _=B.getResourceGroup(F.groupHandle);return _?_.getResourceState(F.handle):F}else if(F&&F.$mid===u.MarshalledId.ScmResourceGroup){const B=this.g.get(F.sourceControlHandle);return B?B.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===u.MarshalledId.ScmProvider){const B=this.g.get(F.handle);return B||F}return F}})}createSourceControl(T,M,j,z){this.n.trace("ExtHostSCM#createSourceControl",T.identifier.value,M,j,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:T.identifier.value});const F=m.d++,B=new p(T,this.m,this.e,this.l,this.n,M,j,z);this.g.set(F,B);const _=this.h.get(T.identifier)||[];return _.push(B),this.h.set(T.identifier,_),B}getLastInputBox(T){this.n.trace("ExtHostSCM#getLastInputBox",T.identifier.value);const M=this.h.get(T.identifier),j=M&&M[M.length-1];return j&&j.inputBox}$provideOriginalResource(T,M,j){const z=r.URI.revive(M);this.n.trace("ExtHostSCM#$provideOriginalResource",T,z.toString());const F=this.g.get(T);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$xh)(()=>F.quickDiffProvider.provideOriginalResource(z,j)).then(B=>B||null)}$onInputBoxValueChange(T,M){this.n.trace("ExtHostSCM#$onInputBoxValueChange",T);const j=this.g.get(T);return j&&j.inputBox.$onInputBoxValueChange(M),Promise.resolve(void 0)}$executeResourceCommand(T,M,j,z){this.n.trace("ExtHostSCM#$executeResourceCommand",T,M,j);const F=this.g.get(T);if(!F)return Promise.resolve(void 0);const B=F.getResourceGroup(M);return B?B.$executeResourceCommand(j,z):Promise.resolve(void 0)}$validateInput(T,M,j){this.n.trace("ExtHostSCM#$validateInput",T);const z=this.g.get(T);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,L.$xh)(()=>z.inputBox.validateInput(M,j)).then(F=>{if(!F)return Promise.resolve(void 0);const B=b.MarkdownString.fromStrict(F.message);return B?Promise.resolve([B,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(T){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",T),T!==void 0&&this.g.get(T)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=T,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(T,M,j,z){return await this.g.get(T)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(M,j,z)??void 0}async $provideHistoryItems(T,M,j,z){return(await this.g.get(T)?.historyProvider?.provideHistoryItems(M,j,z))?.map(_=>({..._,icon:t(_)}))??void 0}async $provideHistoryItemSummary(T,M,j,z){const F=this.g.get(T)?.historyProvider;if(typeof F?.provideHistoryItemSummary!="function")return;const B=await F.provideHistoryItemSummary(M,j,z);return B?{...B,icon:t(B)}:void 0}async $provideHistoryItemChanges(T,M,j,z){return await this.g.get(T)?.historyProvider?.provideHistoryItemChanges(M,j,z)??void 0}};e.$ppc=v,e.$ppc=v=m=Je([Ve(3,I.$_j)],v)}),define(Ee[365],Se([1,0,6,17,2]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0;class R{static{this.a=0}constructor(O,$){this.d=$,this.c=new Map,this.b=O.getProxy(r.$qN.MainThreadShare)}async $provideShare(O,$,l){return await this.c.get(O)?.provideShare({selection:h.Range.to($.selection),resourceUri:A.URI.revive($.resourceUri)},l)??void 0}registerShareProvider(O,$){const l=R.a++;return this.c.set(l,$),this.b.$registerShareProvider(l,h.DocumentSelector.from(O,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(l),this.c.delete(l)}}}}e.$qpc=R}),define(Ee[366],Se([1,0,10,6,239,3,17,18]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=e.$spc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new r.$qO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$qO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,k,b,c,g,d=r.StatusBarAlignment.Left,m){if(this.i=!1,this.k="",this.q=new R.$Vc,this.#e=u,this.#t=k,g&&c){this.c=(0,r.$5N)(c.identifier,g);const n=b.get(this.c);n&&(d=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,m=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=g,this.g=d,this.h=this.u(m)}u(u){if((0,O.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!$.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new R.$Vc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let k;this.m?k=this.m:k=(0,A.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=$.b.get(this.o.id));const c=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,k,this.k,c,this.r?.internal,b,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$spc=$;class l{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,A.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const k={message:u};return this.b.unshift(k),this.c(),new r.$sN(()=>{const b=this.b.indexOf(k);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(u,k){this.e=new Map,this.a=u.getProxy(h.$qN.MainThreadStatusBar),this.b=k,this.c=new l(this)}$acceptStaticEntries(u){for(const k of u)this.e.set(k.entryId,k)}createStatusBarEntry(u,k,b,c){return new $(this.a,this.b,this.e,u,k,b,c)}setStatusBarMessage(u,k){const b=this.c.setMessage(u);let c;return typeof k=="number"?c=setTimeout(()=>b.dispose(),k):typeof k<"u"&&k.then(()=>b.dispose(),()=>b.dispose()),new r.$sN(()=>{b.dispose(),clearTimeout(c)})}}e.$tpc=I}),define(Ee[165],Se([1,0,31,154,74,121,75,17,2]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=e.$0P=e.$9P=void 0,r=We(r),O=We(O);const l=(n,o,i,t)=>{let s=o;return{enumerable:!0,configurable:!1,get(){return s},set(f){if(!i(s,f)){const a=s;s=f,n.listener?.(t(f,a))}}}},I=(n,o)=>n===o,E={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(n,o)=>!(n.length!==o.length||n.some(i=>!o.find(t=>i.id===t.id)))},u=n=>o=>({op:R.TestItemEventOp.SetProp,update:n(o)}),k=(n,o)=>({range:(()=>{let i;const t=u(s=>({range:r.$It.lift(O.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return i},set(s){n.listener?.({op:R.TestItemEventOp.DocumentSynced}),E.range(i,s)||(i=s,n.listener?.(t(s)))}}})(),label:l(n,o,E.label,u(i=>({label:i}))),description:l(n,void 0,E.description,u(i=>({description:i}))),sortText:l(n,void 0,E.sortText,u(i=>({sortText:i}))),canResolveChildren:l(n,!1,E.canResolveChildren,i=>({op:R.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:l(n,!1,E.busy,u(i=>({busy:i}))),error:l(n,void 0,E.error,u(i=>({error:O.MarkdownString.fromStrict(i)||null}))),tags:l(n,[],E.tags,(i,t)=>({op:R.TestItemEventOp.SetTags,new:i.map(O.TestTag.from),old:t.map(O.TestTag.from)}))}),b=n=>{const o=A.$PI.fromString(n.extId),i=new g(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return i.range=O.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>O.TestTag.to({id:(0,L.$VI)(t).tagId})),i},c=n=>{let o;for(const i of n.tests){const t=b(i.item);(0,h.$SP)(t).parent=o,o=t}return o};e.$9P=c;class g{constructor(o,i,t,s){if(i.includes(A.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const f=(0,h.$RP)(this,o);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof d?void 0:f.parent}},children:{value:(0,R.$QP)(f,h.$SP,g),enumerable:!0,writable:!1},...k(f,t)})}}e.$0P=g;class d extends g{constructor(o,i){super(o,o,i,void 0),this._isRoot=!0}}e.$$P=d;class m extends R.$MP{constructor(o,i,t){super({controllerId:o,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:h.$SP,getChildren:s=>s.children,root:new d(o,i),toITestItem:O.TestItem.from})}}e.$_P=m}),define(Ee[35],Se([1,0,18,10,17,25,6,19,12,57,31,53,2,3,5,20,165,22,51,55,43,92,95,32]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=void 0,h=We(h),A=We(A);let f=class{#e;#t;#i;constructor(P,C,p){this.b=new Map,this.c=new Map,this.#e=P.getProxy(L.$qN.MainThreadCommands),this.d=C,this.#i=p,this.#t=P.getProxy(L.$qN.MainThreadTelemetry),this.converter=new a(this,v=>{const N=this.c.get(v);return N?.result===y.Void?N:void 0},C),this.f=[{processArgument(v){return(0,l.$ci)(v)}},{processArgument(v){return(0,R.$eo)(v,function(N){if(I.$It.isIRange(N))return A.Range.to(N);if(E.$Ht.isIPosition(N))return A.Position.to(N);if(I.$It.isIRange(N.range)&&u.URI.isUri(N.uri))return A.location.to(N);if(N instanceof d.$Oe)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const C=this.registerCommand(!1,P.id,async(...p)=>{const v=P.args.map((T,M)=>{if(!T.validate(p[M]))throw new Error(`Invalid argument '${T.name}' when running '${P.id}', received: ${typeof p[M]=="object"?JSON.stringify(p[M],null,"	"):p[M]} `);return T.convert(p[M])}),N=await this.executeCommand(P.internalId,...v);return P.result.convert(N,p,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new h.$sN(()=>{C.dispose(),this.c.delete(P.id)})}registerCommand(P,C,p,v,N,T){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:p,thisArg:v,metadata:N,extension:T}),P&&this.#e.$registerCommand(C),new h.$sN(()=>{this.b.delete(C)&&P&&this.#e.$unregisterCommand(C)})}executeCommand(P,...C){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,C,!0)}async g(P,C,p){if(this.b.has(P))return this.#e.$fireCommandActivationEvent(P),this.h(P,C,!1);{let v=!1;const N=(0,R.$eo)(C,function(T){if(T instanceof h.$tN)return A.Position.from(T);if(T instanceof h.$uN)return A.Range.from(T);if(T instanceof h.$EN)return A.location.from(T);if(h.$UO.isNotebookRange(T))return A.NotebookRange.from(T);if(T instanceof ArrayBuffer)return v=!0,d.$Oe.wrap(new Uint8Array(T));if(T instanceof Uint8Array)return v=!0,d.$Oe.wrap(T);if(T instanceof d.$Oe)return v=!0,T;if(!Array.isArray(T))return T});try{const T=await this.#e.$executeCommand(P,v?new m.$Qw(N):N,p);return(0,l.$ci)(T)}catch(T){if(T instanceof Error&&T.message==="$executeCommand:retry")return this.g(P,C,!1);throw T}}}async h(P,C,p){const v=this.b.get(P);if(!v)throw new Error("Unknown command");const{callback:N,thisArg:T,metadata:M}=v;if(M?.args)for(let z=0;z<M.args.length;z++)try{(0,r.$wg)(C[z],M.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${M.args[z].name}' - ${M.args[z].description}`)}const j=o.$ge.create();try{return await N.apply(T,C)}catch(z){if(P===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...C);F&&(P=F.command)}if(this.d.error(z,P,v.extension?.identifier),!p)throw z;if(v.extension?.identifier){const F=this.#i.onExtensionError(v.extension.identifier,z);this.d.trace("forwarded error to extension?",F,v.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$qj)(z)),this.id=P,this.source=v.extension?.displayName??v.extension?.name}}}finally{this.j(v,P,j.elapsed())}}j(P,C,p){P.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new i.$tp(C),duration:p})}$executeContributedCommand(P,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const p=this.b.get(P);return p?(C=C.map(v=>this.f.reduce((N,T)=>T.processArgument(N,p.extension?.identifier),v)),this.h(P,C,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),this.#e.$getCommands().then(C=>(P&&(C=C.filter(p=>p[0]!=="_")),C))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[C,p]of this.b){const{metadata:v}=p;v&&(P[C]=v)}return Promise.resolve(P)}};e.$fQ=f,e.$fQ=f=Je([Ve(0,c.$WP),Ve(1,$.$_j),Ve(2,t.$eQ)],f),e.$gQ=(0,b.$Fi)("IExtHostCommands");class a{constructor(P,C,p){this.d=P,this.f=C,this.g=p,this.delegatingCommandId=`__vsc${(0,s.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,C){if(!P)return;const p={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return p;const v=this.f(P.command);if(v)p.id=v.internalId,p.arguments=v.args.map((N,T)=>N.convert(P.arguments&&P.arguments[T]));else if((0,O.$Nb)(P.arguments)){const N=`${P.command} /${++this.c}`;this.b.set(N,P),C.add((0,k.$Uc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),p.$ident=N,p.id=this.delegatingCommandId,p.arguments=[N],this.g.trace("CommandsConverter#CREATE",P.command,N)}return p}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const C=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$hQ=a;class w{static{this.Uri=new w("uri","Uri of a text document",P=>u.URI.isUri(P),P=>P)}static{this.Position=new w("position","A position in a text document",P=>h.$tN.isPosition(P),A.Position.from)}static{this.Range=new w("range","A range in a text document",P=>h.$uN.isRange(P),A.Range.from)}static{this.Selection=new w("selection","A selection in a text document",P=>h.$vN.isSelection(P),A.Selection.from)}static{this.Number=new w("number","",P=>typeof P=="number",P=>P)}static{this.String=new w("string","",P=>typeof P=="string",P=>P)}static{this.StringArray=w.Arr(w.String)}static Arr(P){return new w(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,C=>Array.isArray(C)&&C.every(p=>P.validate(p)),C=>C.map(p=>P.convert(p)))}static{this.CallHierarchyItem=new w("item","A call hierarchy item",P=>P instanceof h.$QN,A.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new w("item","A type hierarchy item",P=>P instanceof h.$cP,A.TypeHierarchyItem.from)}static{this.TestItem=new w("testItem","A VS Code TestItem",P=>P instanceof g.$0P,A.TestItem.from)}constructor(P,C,p,v){this.name=P,this.description=C,this.validate=p,this.convert=v}optional(){return new w(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,C){return new w(P??this.name,C??this.description,this.validate,this.convert)}}e.$iQ=w;class y{static{this.Void=new y("no result",P=>P)}constructor(P,C){this.description=P,this.convert=C}}e.$jQ=y;class S{constructor(P,C,p,v,N){this.id=P,this.internalId=C,this.description=p,this.args=v,this.result=N}}e.$kQ=S}),define(Ee[367],Se([1,0,19,15,2,88,143,36,35,17,10]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0,R=We(R),l=We(l),I=We(I);const E=[new $.$kQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of DocumentHighlight-instances.",k(l.DocumentHighlight.to))),new $.$kQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$iQ.Uri],new $.$jQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,r.$Mb)(c))return;class d extends I.$LN{static to(n){const o=new d(n.name,l.SymbolKind.to(n.kind),n.containerName||"",new I.$EN(g[0],l.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=l.Range.to(n.selectionRange),o.children=n.children?n.children.map(d.to):[],o}}return c.map(d.to)})),new $.$kQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$iQ.Uri,new $.$iQ("options","Formatting options",c=>!0,c=>c)],new $.$jQ("A promise that resolves to an array of TextEdits.",k(l.TextEdit.to))),new $.$kQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$iQ.Uri,$.$iQ.Range,new $.$iQ("options","Formatting options",c=>!0,c=>c)],new $.$jQ("A promise that resolves to an array of TextEdits.",k(l.TextEdit.to))),new $.$kQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$iQ.Uri,$.$iQ.Position,new $.$iQ("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$iQ("options","Formatting options",c=>!0,c=>c)],new $.$jQ("A promise that resolves to an array of TextEdits.",k(l.TextEdit.to))),new $.$kQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$kQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$kQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$kQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of Location or LocationLink instances.",b)),new $.$kQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of Location-instances.",k(l.location.to))),new $.$kQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of Hover-instances.",k(l.Hover.to))),new $.$kQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$iQ.Uri,new $.$iQ("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>I.$tN.isPosition(g)),c=>c.map(l.Position.from))],new $.$jQ("A promise that resolves to an array of ranges.",c=>c.map(g=>{let d;for(const m of g.reverse())d=new I.$PN(l.Range.to(m),d);return d}))),new $.$kQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$iQ.String.with("query","Search string")],new $.$jQ("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(l.WorkspaceSymbol.to))),new $.$kQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(l.CallHierarchyItem.to))),new $.$kQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$iQ.CallHierarchyItem],new $.$jQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(l.CallHierarchyIncomingCall.to))),new $.$kQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$iQ.CallHierarchyItem],new $.$jQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(l.CallHierarchyOutgoingCall.to))),new $.$kQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:l.Range.to(c.range),placeholder:c.text}})),new $.$kQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$iQ.Uri,$.$iQ.Position,$.$iQ.String.with("newName","The new symbol name")],new $.$jQ("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return l.WorkspaceEdit.to(c)}})),new $.$kQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$iQ.Uri,$.$iQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$jQ("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(l.DocumentLink.to))),new $.$kQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$iQ.Uri],new $.$jQ("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new I.$LO(c.tokenTypes,c.tokenModifiers)})),new $.$kQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$iQ.Uri],new $.$jQ("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,L.$$cb)(c);if(g.type==="full")return new I.$NO(g.data,void 0)})),new $.$kQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$iQ.Uri,$.$iQ.Range.optional()],new $.$jQ("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new I.$LO(c.tokenTypes,c.tokenModifiers)})),new $.$kQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$iQ.Uri,$.$iQ.Range],new $.$jQ("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,L.$$cb)(c);if(g.type==="full")return new I.$NO(g.data,void 0)})),new $.$kQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$iQ.Uri,$.$iQ.Position,$.$iQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$iQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$jQ("A promise that resolves to a CompletionList-instance.",(c,g,d)=>{if(!c)return new I.$2N([]);const m=c.suggestions.map(n=>l.CompletionItem.to(n,d));return new I.$2N(m,c.incomplete)})),new $.$kQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$iQ.Uri,$.$iQ.Position,$.$iQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$jQ("A promise that resolves to SignatureHelp.",c=>{if(c)return l.SignatureHelp.to(c)})),new $.$kQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$iQ.Uri,$.$iQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$jQ("A promise that resolves to an array of CodeLens-instances.",(c,g,d)=>k(m=>new I.$TN(l.Range.to(m.range),m.command&&d.fromInternal(m.command)))(c))),new $.$kQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$iQ.Uri,new $.$iQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>I.$uN.isRange(c),c=>I.$vN.isSelection(c)?l.Selection.from(c):l.Range.from(c)),$.$iQ.String.with("kind","Code action kind to return code actions for").optional(),$.$iQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$jQ("A promise that resolves to an array of Command-instances.",(c,g,d)=>k(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(m.command)}else{const n=new I.$NN(m.title,m.kind?new I.$ON(m.kind):void 0);return m.edit&&(n.edit=l.WorkspaceEdit.to(m.edit)),m.command&&(n.command=d.fromInternal(m.command)),n.isPreferred=m.isPreferred,n}})(c))),new $.$kQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$iQ.Uri],new $.$jQ("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new I.$8N(l.Range.to(g.range),l.Color.to(g.color))):[])),new $.$kQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$iQ("color","The color to show and insert",c=>c instanceof I.$7N,l.Color.from),new $.$iQ("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:l.Range.from(c.range)}))],new $.$jQ("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(l.ColorPresentation.to):[])),new $.$kQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$iQ.Uri,$.$iQ.Range],new $.$jQ("A promise that resolves to an array of Inlay objects",(c,g,d)=>c.map(l.InlayHint.to.bind(void 0,d)))),new $.$kQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$iQ.Uri],new $.$jQ("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(l.FoldingRange.to)})),new $.$kQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$jQ("A promise that resolves to an array of NotebookContentProvider static info objects.",k(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.to(g))})))),new $.$kQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$iQ.Uri,$.$iQ.Range,new $.$iQ("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof I.$uN,c=>l.InlineValueContext.from(c))],new $.$jQ("A promise that resolves to an array of InlineValue objects",c=>c.map(l.InlineValue.to))),new $.$kQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$iQ("uriOrString","Uri-instance or string (only http/https)",c=>A.URI.isUri(c)||typeof c=="string"&&(0,h.$Pg)(c,h.Schemas.http,h.Schemas.https),c=>c),new $.$iQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[l.ViewColumn.from(c),void 0]:[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)])).optional(),$.$iQ.String.with("label","").optional()],$.$jQ.Void),new $.$kQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$iQ.Uri.with("resource","Resource to open"),$.$iQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$iQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[l.ViewColumn.from(c),void 0]:[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)])).optional()],$.$jQ.Void),new $.$kQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$iQ.Uri.with("left","Left-hand side resource of the diff editor"),$.$iQ.Uri.with("right","Right-hand side resource of the diff editor"),$.$iQ.String.with("title","Human readable title for the diff editor").optional(),new $.$iQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[l.ViewColumn.from(c.viewColumn),l.TextEditorOpenOptions.from(c)]).optional()],$.$jQ.Void),new $.$kQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$iQ.String.with("title","Human readable title for the changes editor"),new $.$iQ("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[d,m,n]=g;if(!A.URI.isUri(d)||!A.URI.isUri(m)&&m!==void 0&&m!==null||!A.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},c=>c)],$.$jQ.Void),new $.$kQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$iQ.Uri,$.$iQ.Position],new $.$jQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$kQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$iQ.TypeHierarchyItem],new $.$jQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$kQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$iQ.TypeHierarchyItem],new $.$jQ("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(l.TypeHierarchyItem.to))),new $.$kQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$iQ.TestItem],$.$jQ.Void),new $.$kQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$iQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$jQ.Void),new $.$kQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$iQ.String.with("name","The context key name"),new $.$iQ("value","The context key value",()=>!0,c=>c)],$.$jQ.Void),new $.$kQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$iQ.Uri,$.$iQ.StringArray,new $.$iQ("MappedEditsContext","Mapped Edits Context",c=>l.MappedEditsContext.is(c),c=>l.MappedEditsContext.from(c))],new $.$jQ("A promise that resolves to a workspace edit or null",c=>c?l.WorkspaceEdit.to(c):null)),new $.$kQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$iQ("Run arguments","",c=>!0,c=>{if(c)return{initialRange:c.initialRange?l.Range.from(c.initialRange):void 0,initialSelection:I.$vN.isSelection(c.initialSelection)?l.Selection.from(c.initialSelection):void 0,message:c.message,autoSend:c.autoSend,position:c.position?l.Position.from(c.position):void 0}})],$.$jQ.Void)];class u{static register(g){E.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",O.$Ej)}}e.$Jnc=u;function k(c){return g=>{if(Array.isArray(g))return g.map(c)}}function b(c){if(!Array.isArray(c))return;const g=[];for(const d of c)R.$Eu(d)?g.push(l.DefinitionLink.to(d)):g.push(l.location.to(d));return g}}),define(Ee[368],Se([1,0,2,35]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class A{constructor(L,O,$,l,I){this.a=O,this.b=$,this.c=l;const E=new h.$kQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new h.$iQ("showOptions","Show Options",u=>!0,u=>u),new h.$iQ("resource","Interactive resource Uri",u=>!0,u=>u),new h.$iQ("controllerId","Notebook controller Id",u=>!0,u=>u),new h.$iQ("title","Interactive editor title",u=>!0,u=>u)],new h.$jQ("Notebook and input URI",u=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const k=this.a.getEditorById(u.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri),notebookEditor:k.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:r.URI.revive(u.notebookUri),inputUri:r.URI.revive(u.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(L,O,$,l){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:O,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,O){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$$oc=A}),define(Ee[369],Se([1,0,19,9,21,4,3,29,2,24,12,6,35,17,10,122,311,26,51,312]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0,e.$gpc=w,k=We(k);let o=class{constructor(S,D,P,C,p){this.m=D,this.n=P,this.o=C,this.q=p,this.b=new O.$Cc,this.c=new O.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(E.$qN.MainThreadNotebookKernels);const v=new u.$kQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$iQ("options","Select kernel options",T=>!0,T=>{if(T&&"notebookEditor"in T&&"id"in T){const M=this.n.getIdByEditor(T.notebookEditor);return{id:T.id,extension:T.extension,notebookEditorId:M}}else if(T&&"notebookEditor"in T){const M=this.n.getIdByEditor(T.notebookEditor);if(M===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${T.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:M}}return T})],u.$jQ.Void),N=new u.$kQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$iQ.Uri],new u.$jQ("A promise that resolves to an array of variables",(T,M)=>T.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(v),this.o.registerApiCommand(N)}createNotebookController(S,D,P,C,p,v){for(const ne of this.j.values())if(ne.controller.id===D&&l.$qn.equals(S.identifier,ne.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const N=this.k++,T=this;this.q.trace(`NotebookController[${N}], CREATED by ${S.identifier.value}, ${D}`);const M=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${S.identifier}'`);let j=!1;const z=new R.$me,F=new R.$me,B={id:w(S.identifier,D),notebookType:P,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:C||S.identifier.value,preloads:v?v.map(k.NotebookRendererScript.from):[]};let _=p??M,re,U;this.a.$addKernel(N,B).catch(ne=>{console.log(ne),j=!0});let G=0;const Q=()=>{if(j)return;const ne=++G;Promise.resolve().then(()=>{ne===G&&this.a.$updateKernel(N,B)})},ee=new O.$Cc,ue={get id(){return D},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return B.label},set label(ne){B.label=ne??S.displayName??S.name,Q()},get detail(){return B.detail??""},set detail(ne){B.detail=ne,Q()},get description(){return B.description??""},set description(ne){B.description=ne,Q()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(ne){B.supportedLanguages=ne,Q()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){B.supportsExecutionOrder=ne,Q()},get rendererScripts(){return B.preloads?B.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return _},set executeHandler(ne){_=ne??M},get interruptHandler(){return re},set interruptHandler(ne){re=ne,B.supportsInterrupt=!!ne,Q()},set variableProvider(ne){(0,d.$5G)(S,"notebookVariableProvider"),U=ne,B.hasVariableProvider=!!ne,ne?.onDidChangeVariables(De=>T.a.$variablesUpdated(De.uri)),Q()},get variableProvider(){return U},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.notebook.uri))throw T.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return T._createNotebookCellExecution(ne,w(S.identifier,this.id))},createNotebookExecution(ne){if((0,d.$5G)(S,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!ee.has(ne.uri))throw T.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ee.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return T._createNotebookExecution(ne,w(S.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${N}], DISPOSED`),j=!0,this.j.delete(N),z.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ne,De){De===b.NotebookControllerAffinity2.Hidden&&(0,d.$5G)(S,"notebookControllerAffinityHidden"),T.a.$updateNotebookPriority(N,ne.uri,De)},onDidReceiveMessage:F.event,postMessage(ne,De){return(0,d.$5G)(S,"notebookMessaging"),T.a.$postMessage(N,De&&T.n.getIdByEditor(De),ne)},asWebviewUri(ne){return(0,d.$5G)(S,"notebookMessaging"),(0,c.$FCb)(ne,T.m.remote)}};return this.j.set(N,{extensionId:S.identifier,controller:ue,onDidReceiveMessage:F,onDidChangeSelection:z,associatedNotebooks:ee}),ue}getIdByController(S){for(const[D,P]of this.j)if(P.controller===S)return w(P.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,D){const P=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${P}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(P,D);const p={dispose:()=>{this.f.delete(P),C.a.$removeKernelDetectionTask(P)}};return this.f.set(P,p),p}registerKernelSourceActionProvider(S,D,P){const C=this.i++,p=typeof P.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,v=this;this.h.set(C,P),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,D);let N;return p!==void 0&&(N=P.onDidChangeNotebookKernelSourceActions(T=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(C),v.a.$removeKernelSourceActionProvider(C,C),N?.dispose()}}}async $provideKernelSourceActions(S,D){const P=this.h.get(S);if(P){const C=new L.$Vc;return(await P.provideNotebookKernelSourceActions(D)??[]).map(v=>k.NotebookKernelSourceAction.from(v,this.o.converter,C))}return[]}$acceptNotebookAssociation(S,D,P){const C=this.j.get(S);if(C){const p=this.n.getNotebookDocument($.URI.revive(D));P?C.associatedNotebooks.set(p.uri,!0):C.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,p.uri.toString(),P),C.onDidChangeSelection.fire({selected:P,notebook:p.apiNotebook})}}async $executeCells(S,D,P){const C=this.j.get(S);if(!C)return;const p=this.n.getNotebookDocument($.URI.revive(D)),v=[];for(const N of P){const T=p.getCell(N);T&&v.push(T.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,p.uri.toString(),v.length),await C.controller.executeHandler.call(C.controller,v,p.apiNotebook,C.controller)}catch(N){this.q.error(`NotebookController[${S}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(S,D,P){const C=this.j.get(S);if(!C)return;const p=this.n.getNotebookDocument($.URI.revive(D));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,p.apiNotebook);else for(const v of P){const N=p.getCell(v);N&&this.b.get(N.uri)?.cancel()}if(C.controller.interruptHandler){const v=this.c.get(p.uri);this.c.delete(p.uri),P.length&&Array.isArray(v)&&v.length&&v.forEach(N=>N.dispose())}}async $provideVariables(S,D,P,C,p,v,N){const T=this.j.get(S);if(!T)return;const M=this.n.getNotebookDocument($.URI.revive(P)),j=T.controller.variableProvider;if(!j)return;let z;if(C!==void 0){if(z=this.s[C],!z)return}else this.s={};const F=p==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,B=j.provideVariables(M.apiNotebook,z,F,v,N);let _=0;for await(const re of B){if(N.isCancellationRequested)return;const U={id:this.r++,name:re.variable.name,value:re.variable.value,type:re.variable.type,interfaces:re.variable.interfaces,language:re.variable.language,expression:re.variable.expression,hasNamedChildren:re.hasNamedChildren,indexedChildrenCount:re.indexedChildrenCount,extensionId:T.extensionId.value};if(this.s[U.id]=re.variable,this.a.$receiveVariable(D,U),_++>=n.$SK)return}}$acceptKernelMessageFromRenderer(S,D,P){const C=this.j.get(S);if(!C)return;const p=this.n.getEditorById(D);C.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:P}))}$cellExecutionChanged(S,D,P){const p=this.n.getNotebookDocument($.URI.revive(S)).getCell(D);if(p){const v=P?k.NotebookCellExecutionState.to(P):b.NotebookCellExecutionState.Idle;v!==void 0&&this.l.fire({cell:p.apiCell,state:v})}}_createNotebookCellExecution(S,D){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const p=new t(D,C,this.a);this.b.set(C.uri,p);const v=p.onDidChangeState(()=>{p.state===i.Resolved&&(p.dispose(),v.dispose(),this.b.delete(C.uri))});return p.asApiObject()}_createNotebookExecution(S,D){const P=this.n.getNotebookDocument(S.uri),C=S.getCells().find(N=>{const T=P.getCellFromApiCell(N);return T&&this.b.has(T.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(P.uri))throw new Error(`duplicate notebook execution for ${P.uri}`);const p=new f(D,P,this.a),v=p.onDidChangeState(()=>{p.state===s.Resolved&&(p.dispose(),v.dispose(),this.c.delete(P.uri))});return this.c.set(P.uri,[p,v]),p.asApiObject()}};e.$fpc=o,e.$fpc=o=Je([Ve(4,I.$_j)],o);var i;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(i||(i={}));class t extends L.$Wc{static{this.a=0}get state(){return this.f}constructor(S,D,P){super(),this.m=D,this.n=P,this.b=t.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new A.$xe),this.h=new a(10,C=>this.s(C)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const D=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new m.$Qw(D))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let D=this.m;if(S&&(D=this.m.notebook.getCellFromApiCell(S)),!D)throw new Error("INVALID cell");return D.handle}y(S){return S.map(D=>{const P=b.$YO.ensureUniqueMimeTypes(D.items,!0);return P===D.items?k.NotebookCellOutput.from(D):k.NotebookCellOutput.from({items:P,id:D.id,metadata:D.metadata})})}async z(S,D,P){const C=this.w(D),p=this.y((0,r.$4b)(S));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:C,append:P,outputs:p})}async C(S,D,P){return S=b.$YO.ensureUniqueMimeTypes((0,r.$4b)(S),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:S.map(k.NotebookCellOutputItem.from),outputId:D.id,append:P})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(P){S.j=P,S.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(P){if(S.f===i.Resolved||S.f===i.Started)throw new Error("Cannot call start again");S.f=i.Started,S.c.fire(),S.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:P})},end(P,C,p){if(S.f===i.Resolved)throw new Error("Cannot call resolve twice");S.f=i.Resolved,S.c.fire(),S.h.flush();const v=p?{message:p.message,stack:p.stack,location:p?.location?{startLineNumber:p.location.start.line,startColumn:p.location.start.character,endLineNumber:p.location.end.line,endColumn:p.location.end.character}:void 0,uri:p.uri}:void 0;S.n.$completeExecution(S.b,new m.$Qw({runEndTime:C,lastRunSuccess:P,error:v}))},clearOutput(P){return S.t(),S.z([],P,!1)},appendOutput(P,C){return S.t(),S.z(P,C,!0)},replaceOutput(P,C){return S.t(),S.z(P,C,!1)},appendOutputItems(P,C){return S.t(),S.C(P,C,!0)},replaceOutputItems(P,C){return S.t(),S.C(P,C,!1)}})}}var s;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(s||(s={}));class f extends L.$Wc{static{this.a=0}get state(){return this.f}constructor(S,D,P){super(),this.h=D,this.j=P,this.b=f.a++,this.c=new R.$me,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new A.$xe),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class a{constructor(S,D){this.f=S,this.g=D,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new h.$3h,this.b=Date.now(),(0,h.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>S.complete())}}function w(y,S){return`${y.value}/${S}`}}),define(Ee[47],Se([1,0,4,6,5,2,20,3,10,241,14,290,21,32,291,292,50,9,17,35,41]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=e.$moc=e.$loc=void 0,e.$loc=(0,A.$Fi)("IExtHostTerminalService");class i extends O.$Wc{constructor(p,v,N,T){super(),this.u=p,this._id=v,this.w=N,this.y=T,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const M=this;this.value={get name(){return M.y||""},get processId(){return M.b},get creationOptions(){return M.w},get exitStatus(){return M.j},get state(){return M.m},get selection(){return M.n},get shellIntegration(){return M.shellIntegration},sendText(j,z=!0){M.C(),M.u.$sendText(M._id,j,z)},show(j){M.C(),M.u.$show(M._id,j)},hide(){M.C(),M.u.$hide(M._id)},dispose(){M.a||(M.a=!0,M.u.$dispose(M._id))},get dimensions(){if(!(M.f===void 0||M.h===void 0))return{columns:M.f,rows:M.h}}}}dispose(){this.s.fire(),super.dispose()}async create(p,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??v?.cwd??void 0,env:p.env??void 0,icon:S(p.iconPath)??void 0,color:g.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,forceShellIntegration:v?.forceShellIntegration??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.z(p.location,v?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,v,N,T,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:T,color:g.ThemeColor.isThemeColor(M)?M.id:void 0,location:v?.location||this.z(p,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(p,v){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in p?{viewColumn:m.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.y=p}setExitStatus(p,v){this.j=Object.freeze({code:p,reason:v})}setDimensions(p,v){return p===this.f&&v===this.h||p===0||v===0?!1:(this.f=p,this.h=v,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(p){this.n=p}_setProcessId(p){this.g?(this.g(p),this.g=void 0):this.b.then(v=>{v!==p&&(this.b=Promise.resolve(p))})}}e.$moc=i;class t{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new r.$me,this.onProcessData=this.a.event,this.b=new r.$me,this.d=new r.$me,this.onDidChangeProperty=this.d.event,this.f=new r.$me,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,v){this.g.setDimensions?.({columns:p,rows:v})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:b.ProcessPropertyType.OverrideDimensions,value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:b.ProcessPropertyType.Title,value:v})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,f=class extends O.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,v,N){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new O.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$me,this.onDidCloseTerminal=this.H.event,this.I=new r.$me,this.onDidOpenTerminal=this.I.event,this.J=new r.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$me,this.onDidChangeTerminalState=this.M.event,this.N=new r.$me,this.onDidChangeShell=this.N.event,this.O=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(h.$qN.MainThreadTerminalService),this.y=new c.$Zwb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:T=>{const M=j=>{const z=j;return this.getTerminalById(z.instanceId)?.value};switch(T?.$mid){case o.MarshalledId.TerminalContext:return M(T);default:{if(Array.isArray(T))for(let j=0;j<T.length&&T[j].$mid===o.MarshalledId.TerminalContext;j++)T[j]=M(T[j]);return T}}}}),this.B({dispose:()=>{for(const[T,M]of this.g)M.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,v){const N=new i(this.a,(0,k.$2g)(),p,p.name),T=new t(p.pty);return N.createExtensionTerminal(p.location,v,this.R(p,v).resolvedExtHostIdentifier,S(p.iconPath),D(p.color)).then(M=>{const j=this.S(M,T);this.h[M]=j}),this.f.push(N),N.value}R(p,v){if(v=v||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const N=p.location.parentTerminal;if(N){const T=this.f.find(M=>M.value===N);T&&(v.resolvedExtHostIdentifier=T._id)}}else p.location&&typeof p.location!="object"?v.location=p.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(p,v){if(!this.getTerminalById(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const T=new t(v),M=this.S(p,T);this.h[p]=M}async $acceptActiveTerminalChanged(p){const v=this.b;if(p===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById(p);N&&(this.b=N,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,v){const N=this.getTerminalById(p);N&&this.O.fire({terminal:N.value,data:v})}async $acceptTerminalDimensions(p,v,N){const T=this.getTerminalById(p);T&&T.setDimensions(v,N)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(p,v){const N=this.getTerminalById(p);N&&this.P.fire({terminal:N.value,...v})}async $acceptTerminalMaximumDimensions(p,v,N){this.g.get(p)?.resize(v,N)}async $acceptTerminalTitleChange(p,v){const N=this.getTerminalById(p);N&&(N.name=v)}async $acceptTerminalClosed(p,v,N){const T=this.X(this.f,p);if(T!==null){const M=this.f.splice(T,1)[0];M.setExitStatus(v,N),this.H.fire(M.value)}}$acceptTerminalOpened(p,v,N,T){if(v){const z=this.X(this.f,v);if(z!==null){this.f[z]._id=p,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const M={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:R.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},j=new i(this.a,p,M,N);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(p,v){this.getTerminalById(p)?._setProcessId(v)}async $startExtensionTerminal(p,v){const N=this.getTerminalById(p);if(!N)return{message:(0,l.localize)(0,null,p)};N.isOpen||await new Promise(M=>{const j=this.onDidOpenTerminal(async z=>{z===N.value&&(j.dispose(),M())})});const T=this.g.get(p);T?T.startSendingEvents(v):this.j[p]={initialDimensions:v}}S(p,v){const N=new O.$Vc;N.add(v.onProcessReady(M=>this.a.$sendProcessReady(p,M.pid,M.cwd,M.windowsPty))),N.add(v.onDidChangeProperty(M=>this.a.$sendProcessProperty(p,M))),this.y.startBuffering(p,v.onProcessData),N.add(v.onProcessExit(M=>this.U(p,M))),this.g.set(p,v);const T=this.j[p];return T&&v instanceof t&&(v.startSendingEvents(T.initialDimensions),delete this.j[p]),N}$acceptProcessAckDataEvent(p,v){this.g.get(p)?.acknowledgeDataEvent(v)}$acceptProcessInput(p,v){this.g.get(p)?.input(v)}$acceptTerminalInteraction(p){const v=this.getTerminalById(p);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(p,v){this.getTerminalById(p)?.setSelection(v)}$acceptProcessResize(p,v,N){try{this.g.get(p)?.resize(v,N)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(p,v){this.g.get(p)?.shutdown(v)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(p,{type:b.ProcessPropertyType.InitialCwd,value:v}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(v=>this.a.$sendProcessProperty(p,{type:b.ProcessPropertyType.Cwd,value:v}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new $.$sN(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,v,N){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,N),this.a.$registerProfileProvider(v,p.identifier.value),new $.$sN(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(p,v,N){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,N),this.a.$registerQuickFixProvider(p,v),new $.$sN(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,v){const N=new u.$xe().token;if(N.isCancellationRequested)return;const T=this.D.get(p);if(!T)return;const M=await T.provideTerminalQuickFixes(v,N);if(M===null||Array.isArray(M)&&M.length===0)return;const j=new O.$Vc;if(this.w.value=j,!Array.isArray(M))return M?m.TerminalQuickFix.from(M,this.Q.converter,j):void 0;const z=[];for(const F of M){const B=m.TerminalQuickFix.from(F,this.Q.converter,j);B&&z.push(B)}return z}async $createContributedProfileTerminal(p,v){const N=new u.$xe().token;let T=await this.C.get(p)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,v);return}this.createTerminalFromOptions(T.options,v)}}async $provideLinks(p,v){const N=this.getTerminalById(p);if(!N)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const M=new u.$xe;this.G.set(p,M);const j=[],z={terminal:N.value,line:v},F=[];for(const re of this.z)F.push(d.Promises.withAsyncBody(async U=>{M.token.onCancellationRequested(()=>U({provider:re,links:[]}));const G=await re.provideTerminalLinks(z,M.token)||[];M.token.isCancellationRequested||U({provider:re,links:G})}));const B=await Promise.all(F);if(M.token.isCancellationRequested)return[];const _=new Map;for(const re of B)re&&re.links.length>0&&j.push(...re.links.map(U=>{const G={id:s++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return _.set(G.id,{provider:re.provider,link:U}),G}));return this.F.set(p,_),j}$activateLink(p,v){const N=this.F.get(p)?.get(v);N&&N.provider.handleTerminalLink(N.link)}U(p,v){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const N=this.h[p];N&&(N.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,v)}getTerminalById(p){return this.W(this.f,p)}getTerminalIdByApiObject(p){const v=this.f.findIndex(N=>N.value===p);return v>=0?v:null}W(p,v){const N=this.X(p,v);return N!==null?p[N]:null}X(p,v){const N=p.findIndex(T=>T._id===v);return N>=0?N:null}getEnvironmentVariableCollection(p){let v=this.n.get(p.identifier.value);return v||(v=this.B(new a),this.Z(p.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Y(p,v){const N=(0,E.$zs)(v.map),T=(0,E.$As)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(p,v.persistent,N.length===0?void 0:N,T)}$initEnvironmentVariableCollections(p){p.forEach(v=>{const N=v[0],T=this.B(new a(v[1]));this.Z(N,T)})}$acceptDefaultProfile(p,v){const N=this.s;this.s=p,this.u=v,N?.path!==p.path&&this.N.fire(p.path)}Z(p,v){this.n.set(p,v),this.B(v.onDidChangeCollection(()=>{this.Y(p,v)}))}};e.$noc=f,e.$noc=f=Je([Ve(1,n.$gQ),Ve(2,L.$WP)],f);class a extends O.$Wc{get persistent(){return this.b}set persistent(p){this.b=p,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(p){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new r.$me,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const v=this.j(p);let N=this.a.get(v);return N||(N=new w(this,p),this.a.set(v,N),this.B(N.onDidChangeCollection(()=>this.f.fire()))),N}replace(p,v,N,T){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:T})}append(p,v,N,T){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:T})}prepend(p,v,N,T){this.g(p,{value:v,type:$.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:T})}g(p,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.h(p,v.scope),T=this.map.get(N),M=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==v.value||T.type!==v.type||T.options?.applyAtProcessCreation!==M.applyAtProcessCreation||T.options?.applyAtShellIntegration!==M.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const j=this.h(p,v.scope),z={variable:p,...v,options:M};this.map.set(j,z),this.f.fire()}}get(p,v){const N=this.h(p,v),T=this.map.get(N);return T?P(T):void 0}h(p,v){const N=this.j(v);return N.length?`${p}:::${N}`:p}j(p){return this.m(p?.workspaceFolder)??""}m(p){return p?p.uri.toString():void 0}getVariableMap(p){const v=new Map;for(const[N,T]of this.map)this.j(T.scope)===this.j(p)&&v.set(T.variable,P(T));return v}delete(p,v){const N=this.h(p,v);this.map.delete(N),this.f.fire()}clear(p){if(p?.workspaceFolder){for(const[v,N]of this.map)N.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(v);this.n(p)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(p,v){const N=this.j(v),T=this.descriptionMap.get(N);if(!T||T.description!==p){let M;typeof p=="string"?M=p:M=p?.value.split(`

`)[0];const j={description:M,scope:v};this.descriptionMap.set(N,j),this.f.fire()}}getDescription(p){const v=this.j(p);return this.descriptionMap.get(v)?.description}n(p){const v=this.j(p);this.descriptionMap.delete(v)}}class w{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,v){this.b=p,this.d=v,this.a=new r.$me}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,v,N){this.b.replace(p,v,N,this.d)}append(p,v,N){this.b.append(p,v,N,this.d)}prepend(p,v,N){this.b.prepend(p,v,N,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,v){this.b.getVariableMap(this.d).forEach((N,T)=>p.call(v,T,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends f{constructor(p,v){super(!1,p,v)}createTerminal(p,v,N){throw new I.$bb}createTerminalFromOptions(p,v){throw new I.$bb}};e.$ooc=y,e.$ooc=y=Je([Ve(0,n.$gQ),Ve(1,L.$WP)],y);function S(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function D(C){return g.ThemeColor.isThemeColor(C)?C:void 0}function P(C){const p={...C};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Ee[166],Se([1,0,10,3,5,6,20,47,4,2,9]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=void 0,e.$xpc=(0,A.$Fi)("IExtHostTerminalShellIntegration");let E=class extends h.$Wc{constructor(g,d){super(),this.h=d,this.b=new Map,this.c=new $.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=g.getProxy(R.$qN.MainThreadTerminalShellIntegration),this.B((0,h.$Uc)(()=>{for(const[m,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(g){const d=this.h.getTerminalById(g);if(!d)return;const m=d.value;let n=this.b.get(g);n||(n=new u(d.value,this.f),this.b.set(g,n),n.store.add(d.onWillDispose(()=>this.b.get(g)?.dispose())),n.store.add(n.onDidRequestShellExecution(o=>this.a.$executeCommand(g,o))),n.store.add(n.onDidRequestEndExecution(o=>this.g.fire(o))),n.store.add(n.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),d.shellIntegration=n.value),this.c.fire({terminal:m,shellIntegration:n.value})}$shellExecutionStart(g,d,m,n,o){this.b.has(g)||this.$shellIntegrationChange(g);const i={value:d,confidence:m,isTrusted:n};this.b.get(g)?.startShellExecution(i,o)}$shellExecutionEnd(g,d,m,n,o){const i={value:d,confidence:m,isTrusted:n};this.b.get(g)?.endShellExecution(i,o)}$shellExecutionData(g,d){this.b.get(g)?.emitData(d)}$cwdChange(g,d){this.b.get(g)?.setCwd((0,l.$xc)(d)?l.URI.revive(d):d)}$closeTerminal(g){this.b.get(g)?.dispose(),this.b.delete(g)}};e.$ypc=E,e.$ypc=E=Je([Ve(0,L.$WP),Ve(1,O.$loc)],E);class u extends h.$Wc{get currentExecution(){return this.a}constructor(g,d){super(),this.j=g,this.m=d,this.b=!1,this.store=this.B(new h.$Vc),this.f=this.B(new $.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$me),this.onDidRequestEndExecution=this.h.event;const m=this;this.value={get cwd(){return m.c},executeCommand(n,o){let i=n;o&&(i+=` "${o.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),m.g.fire(i);const t={value:i,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},s=m.startShellExecution(t,m.c,!0).value;return m.b=!0,s}}}startShellExecution(g,d,m){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new k(g,d);m?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(g){this.currentExecution?.emitData(g)}endShellExecution(g,d){this.a&&(this.a.endExecution(g),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:d}),this.a=void 0)}setCwd(g){let d=!1;l.URI.isUri(this.c)?d=!l.URI.isUri(g)||this.c.toString()!==g.toString():this.c!==g&&(d=!0),d&&(this.c=g,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(g,d){this.c=g,this.cwd=d,this.b=!1;const m=this;this.value={get commandLine(){return m.c},get cwd(){return m.cwd},read(){return m.d()}}}d(){if(!this.a){if(this.b)return I.$6h.EMPTY;this.a=new b}return this.a.createIterable()}emitData(g){this.a?.emitData(g)}endExecution(g){g&&(this.c=g),this.a?.endExecution(),this.a=void 0,this.b=!0}}class b extends h.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Eh);const g=this.a;return new I.$6h(async m=>{this.b.push(m),await g.wait()})}emitData(g){for(const d of this.b)d.emitOne(g)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ee[167],Se([1,0,66,14,133,17,10]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=e.$4P=void 0,R=We(R);class O{static{this.c=new A.$2P("TextEditorDecorationType")}constructor(u,k,b){const c=O.c.nextId();u.$registerTextEditorDecorationType(k.identifier,c,R.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:c,dispose(){u.$removeTextEditorDecorationType(c)}})}}e.$4P=O;class ${constructor(u,k){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,k){this.k();let b=null;if(u instanceof L.$tN)b=new L.$uN(u,u);else if(u instanceof L.$uN)b=u;else throw new Error("Unrecognized location");this.l(b,k,!1)}insert(u,k){this.k(),this.l(new L.$uN(u,u),k,!0)}delete(u){this.k();let k=null;if(u instanceof L.$uN)k=u;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(u,k,b){const c=this.c.validateRange(u);this.g.push({range:c,text:k,forceMoveMarkers:b})}setEndOfLine(u){if(this.k(),u!==L.EndOfLine.LF&&u!==L.EndOfLine.CRLF)throw(0,h.$9)("endOfLine");this.h=u}}class l{constructor(u,k,b,c){this.c=u,this.d=k,this._accept(b),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(d){g.n(d)},get indentSize(){return g.g},set indentSize(d){g.p(d)},get insertSpaces(){return g.j},set insertSpaces(d){g.s(d)},get cursorStyle(){return g.k},set cursorStyle(d){g.t(d)},get lineNumbers(){return g.l},set lineNumbers(d){g.u(d)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}n(u){const k=this.m(u);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}p(u){const k=this.o(u);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const k=this.q(u);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(u)})))}assign(u){const k={};let b=!1;if(typeof u.tabSize<"u"){const c=this.m(u.tabSize);c==="auto"?(b=!0,k.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,b=!0,k.tabSize=c)}if(typeof u.indentSize<"u"){const c=this.o(u.indentSize);c==="tabSize"?(b=!0,k.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,b=!0,k.indentSize=c)}if(typeof u.insertSpaces<"u"){const c=this.q(u.insertSpaces);c==="auto"?(b=!0,k.insertSpaces=c):this.j!==c&&(this.j=c,b=!0,k.insertSpaces=c)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,b=!0,k.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,b=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(u.lineNumbers)),b&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(u,k){k.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(b)})}}e.$5P=l;class I{constructor(u,k,b,c,g,d,m,n){this.id=u,this.j=k,this.k=b,this.g=!1,this.h=new Set,this.c=g,this.d=new l(this.j,this.id,d,b),this.e=m,this.f=n;const o=this;this.value=Object.freeze({get document(){return c.value},set document(i){throw new h.$$("document")},get selection(){return o.c&&o.c[0]},set selection(i){if(!(i instanceof L.$vN))throw(0,h.$9)("selection");o.c=[i],o.l()},get selections(){return o.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof L.$vN)))throw(0,h.$9)("selections");o.c=i,o.l()},get visibleRanges(){return o.e},set visibleRanges(i){throw new h.$$("visibleRanges")},get options(){return o.d.value},set options(i){o.g||o.d.assign(i)},get viewColumn(){return o.f},set viewColumn(i){throw new h.$$("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new $(c.value,t);return i(s),o.m(s)},insertSnippet(i,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!t||Array.isArray(t)&&t.length===0)f=o.c.map(a=>R.Range.from(a));else if(t instanceof L.$tN){const{lineNumber:a,column:w}=R.Position.from(t);f=[{startLineNumber:a,startColumn:w,endLineNumber:a,endColumn:w}]}else if(t instanceof L.$uN)f=[R.Range.from(t)];else{f=[];for(const a of t)if(a instanceof L.$uN)f.push(R.Range.from(a));else{const{lineNumber:w,column:y}=R.Position.from(a);f.push({startLineNumber:w,startColumn:y,endLineNumber:w,endColumn:y})}}return k.$tryInsertSnippet(u,c.value.version,i.value,f,s)},setDecorations(i,t){const s=t.length===0;s&&!o.h.has(i.key)||(s?o.h.delete(i.key):o.h.add(i.key),o.n(()=>{if(R.$TP(t))return k.$trySetDecorations(u,i.key,R.$UP(t));{const f=new Array(4*t.length);for(let a=0,w=t.length;a<w;a++){const y=t[a];f[4*a]=y.start.line+1,f[4*a+1]=y.start.character+1,f[4*a+2]=y.end.line+1,f[4*a+3]=y.end.character+1}return k.$trySetDecorationsFast(u,i.key,f)}}))},revealRange(i,t){o.n(()=>k.$tryRevealRange(u,R.Range.from(i),t||L.TextEditorRevealType.Default))},show(i){k.$tryShowEditor(u,R.ViewColumn.from(i))},hide(){k.$tryHideEditor(u)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,r.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,r.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,r.ok)(!this.g),this.f=u}_acceptSelections(u){(0,r.ok)(!this.g),this.c=u}async l(){const u=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const k=u.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const b=k.edits.map(g=>g.range);b.sort((g,d)=>g.end.line===d.end.line?g.end.character===d.end.character?g.start.line===d.start.line?g.start.character-d.start.character:g.start.line-d.start.line:g.end.character-d.end.character:g.end.line-d.end.line);for(let g=0,d=b.length-1;g<d;g++){const m=b[g].end;if(b[g+1].start.isBefore(m))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=k.edits.map(g=>({range:R.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,c,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$6P=I}),define(Ee[64],Se([1,0,66,4,3,2,5,6,163,20,167,17,12,29,15,40,49]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0,r=We(r),E=We(E);class d{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let m=class{constructor(o,i){this.h=o,this.i=i,this.a=null,this.b=new Map,this.c=new k.$Cc,this.d=new h.$me,this.e=new h.$me,this.f=new h.$me,this.g=new h.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const i=[],t=[],s=[];if(o.removedDocuments)for(const f of o.removedDocuments){const a=R.URI.revive(f),w=this.c.get(a);w?.unref()&&(this.c.delete(a),i.push(w.value))}if(o.addedDocuments)for(const f of o.addedDocuments){const a=R.URI.revive(f.uri);let w=this.c.get(a);if(w&&a.scheme!==b.Schemas.vscodeNotebookCell&&a.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);w||(w=new d(new $.$ZP(this.h.getProxy(O.$qN.MainThreadDocuments),a,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(a,w),t.push(w.value)),w.ref()}if(o.removedEditors)for(const f of o.removedEditors){const a=this.b.get(f);this.b.delete(f),a&&s.push(a)}if(o.addedEditors)for(const f of o.addedEditors){const a=R.URI.revive(f.documentUri);r.ok(this.c.has(a),`document '${a}' does not exist`),r.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const w=this.c.get(a).value,y=new I.$6P(f.id,this.h.getProxy(O.$qN.MainThreadTextEditors),this.i,new g.$X(()=>w.document),f.selections.map(E.Selection.to),f.options,f.visibleRanges.map(S=>E.Range.to(S)),typeof f.editorPosition=="number"?E.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,y)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,A.$Rc)(i),(0,A.$Rc)(s),o.removedDocuments&&this.e.fire(i),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return c.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const i=this.b.get(this.a);return o?i:i?.value}allEditors(){return[...this.b.values()]}};e.$7P=m,e.$7P=m=Je([Ve(0,l.$WP),Ve(1,u.$_j)],m),e.$8P=(0,L.$Fi)("IExtHostDocumentsAndEditors")}),define(Ee[99],Se([1,0,9,22,21,4,80,60,3,41,18,32,5,12,6,35,64,20,165,17,10,314,74,121,75,26]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=e.$Hoc=e.$Goc=e.$Foc=void 0,n=We(n);let w=0;const y=new WeakMap;e.$Foc=(0,u.$Fi)("IExtHostTesting");let S=class extends $.$Wc{constructor(U,G,Q,ee){super(),this.C=G,this.D=Q,this.F=ee,this.f=this.B(new R.$me),this.g=new Map,this.w=this.B(new R.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy(b.$qN.MainThreadTesting),this.m=new j(this.h),this.j=new p(this.h,G),Q.registerArgumentProcessor({processArgument:ue=>{switch(ue?.$mid){case l.MarshalledId.TestItemContext:{const ne=ue,De=ne.tests[ne.tests.length-1].item.extId;return this.g.get(t.$PI.root(De))?.collection.tree.get(De)?.actual??(0,m.$9P)(ue)}case l.MarshalledId.TestMessageMenuArgs:{const{test:ne,message:De}=ue,$e=ne.item.extId;return{test:this.g.get(t.$PI.root($e))?.collection.tree.get($e)?.actual??(0,m.$9P)({$mid:l.MarshalledId.TestItemContext,tests:[ne]}),message:n.TestMessage.to(De)}}default:return ue}}}),Q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const ue=await Q.executeCommand(i.TestCommandId.GetExplorerSelection),ne=De=>{const $e=this.g.get(t.$PI.root(De));if($e)return t.$PI.isRoot(De)?$e.controller:$e.collection.tree.get(De)?.actual};return{include:ue?.include.map(ne).filter(I.$ng)||[],exclude:ue?.exclude.map(ne).filter(I.$ng)||[]}})}createTestController(U,G,Q,ee){if(this.g.has(G))throw new Error(`Attempt to insert a duplicate controller with ID "${G}"`);const ue=new $.$Vc,ne=ue.add(new m.$_P(G,Q,this.F));ne.root.label=Q;const De=new Map,$e=new Set,K=this.h,W={items:ne.root.children,get label(){return Q},set label(oe){Q=oe,ne.root.label=oe,K.$updateController(G,{label:Q})},get refreshHandler(){return ee},set refreshHandler(oe){ee=oe,K.$updateController(G,{canRefresh:!!oe})},get id(){return G},createRunProfile:(oe,te,le,he,X,ae)=>{let pe=(0,O.$tj)(oe);for(;De.has(pe);)pe++;return new F(this.h,De,$e,this.w.event,G,pe,oe,te,le,he,X,ae)},createTestItem(oe,te,le){return new m.$0P(G,oe,te,le)},createTestRun:(oe,te,le=!0)=>this.j.createTestRun(U,G,ne,oe,te,le),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const te=oe instanceof Array?oe:[oe];this.h.$markTestRetired(te.map(le=>t.$PI.fromExtHostTestItem(le,G).toString()))}},set resolveHandler(oe){ne.resolveHandler=oe},get resolveHandler(){return ne.resolveHandler},dispose:()=>{ue.dispose()}};K.$registerTestController(G,Q,!!ee),ue.add((0,$.$Uc)(()=>K.$unregisterTestController(G)));const se={controller:W,collection:ne,profiles:De,extension:U,activeProfiles:$e};return this.g.set(G,se),ue.add((0,$.$Uc)(()=>this.g.delete(G))),ue.add(ne.onDidGenerateDiff(oe=>K.$publishDiff(G,oe.map(f.TestsDiffOp.serialize)))),W}createTestObserver(){return this.m.checkout()}async runTests(U,G=A.CancellationToken.None){const Q=v(U);if(!Q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(Q.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:U.preserveFocus??!0,group:B[Q.kind],targets:[{testIds:U.include?.map(ue=>t.$PI.fromExtHostTestItem(ue,ee.collection.root.id).toString())??[ee.collection.root.id],profileId:Q.profileId,controllerId:Q.controllerId}],exclude:U.exclude?.map(ue=>ue.id)},G)}registerTestFollowupProvider(U){return this.y.add(U),{dispose:()=>{this.y.delete(U)}}}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $getCoverageDetails(U,G,Q){return(await this.j.getCoverageDetails(U,G,Q))?.map(n.TestCoverage.fromDetails)}async $disposeRun(U){this.j.disposeTestRun(U)}$configureRunProfile(U,G){this.g.get(U)?.profiles.get(G)?.configureHandler?.()}$setDefaultRunProfiles(U){const G=new Map;for(const[Q,ee]of Object.entries(U)){const ue=this.g.get(Q);if(!ue)continue;const ne=new Map,De=ee.filter(K=>!ue.activeProfiles.has(K)),$e=[...ue.activeProfiles].filter(K=>!ee.includes(K));for(const K of De)ne.set(K,!0),ue.activeProfiles.add(K);for(const K of $e)ne.set(K,!1),ue.activeProfiles.delete(K);ne.size&&G.set(Q,ne)}this.w.fire(G)}async $refreshTests(U,G){await this.g.get(U)?.controller.refreshHandler?.(G)}$publishTestResults(U){this.results=Object.freeze(U.map(G=>{const Q=n.TestResults.to(G);return y.set(Q,G.id),Q}).concat(this.results).sort((G,Q)=>Q.completedAt-G.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,G){const Q=this.g.get(t.$PI.fromString(U).controllerId)?.collection;Q&&(await Q.expand(U,G<0?1/0:G),Q.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(G=>f.TestsDiffOp.deserialize({asCanonicalUri:Q=>Q},G)))}async $runControllerTests(U,G){return Promise.all(U.map(Q=>this.G(Q,!1,G)))}async $startContinuousRun(U,G){const Q=new A.$xe(G),ee=await Promise.all(U.map(ue=>this.G(ue,!0,Q.token)));return!G.isCancellationRequested&&!ee.some(ue=>ue.error)&&await new Promise(ue=>G.onCancellationRequested(ue)),Q.dispose(!0),ee}async $provideTestFollowups(U,G){const Q=this.results.find(ne=>y.get(ne)===U.resultId),ee=Q&&_(t.$PI.fromString(U.extId),Q?.results);if(!ee)return[];let ue=[];return await Promise.all([...this.y].map(async ne=>{try{const De=await ne.provideFollowup(Q,ee,U.taskIndex,U.messageIndex,G);De&&(ue=ue.concat(De))}catch(De){this.C.error("Error thrown while providing followup for test message",De)}})),G.isCancellationRequested?[]:ue.map(ne=>{const De=w++;return this.z.set(De,ne),{title:ne.title,id:De}})}$disposeTestFollowups(U){for(const G of U)this.z.delete(G)}$executeTestFollowup(U){const G=this.z.get(U);return G?this.D.executeCommand(G.command,...G.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}getMetadataForRun(U){for(const G of this.j.trackers){const Q=G.getTaskIdForRun(U);if(Q)return{taskId:Q,runId:G.id}}}async G(U,G,Q){const ee=this.g.get(U.controllerId);if(!ee)return{};const{collection:ue,profiles:ne,extension:De}=ee,$e=ne.get(U.profileId);if(!$e)return{};const K=U.testIds.map(te=>ue.tree.get(te)).filter(I.$ng),W=U.excludeExtIds.map(te=>ee.collection.tree.get(te)).filter(I.$ng).filter(te=>K.some(le=>le.fullId.compare(te.fullId)===t.TestPosition.IsChild));if(!K.length)return{};const se=new o.$6O(K.some(te=>te.actual instanceof m.$$P)?void 0:K.map(te=>te.actual),W.map(te=>te.actual),$e,G),oe=(0,f.$SI)(U)&&this.j.prepareForMainThreadTestRun(De,se,N.fromInternal(U,ee.collection),$e,Q);try{return await $e.runHandler(se,Q),{}}catch(te){return{error:String(te)}}finally{oe&&oe.hasRunningTasks&&!Q.isCancellationRequested&&await R.Event.toPromise(oe.onEnd)}}};e.$Goc=S,e.$Goc=S=Je([Ve(0,d.$WP),Ve(1,k.$_j),Ve(2,c.$gQ),Ve(3,g.$8P)],S);const D=1e4;var P;(function(re){re[re.Running=0]="Running",re[re.Cancelling=1]="Cancelling",re[re.Ended=2]="Ended"})(P||(P={}));class C extends $.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(U,G,Q,ee,ue,ne){super(),this.z=U,this.C=G,this.D=Q,this.F=ee,this.G=ue,this.c=P.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new R.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new A.$xe(ne));const De=this.B(new r.$Rh(()=>this.H(),D));this.B(this.j.token.onCancellationRequested(()=>De.schedule()));const $e=new R.$me;this.w=$e.event,this.B((0,$.$Uc)(()=>{$e.fire(),$e.dispose()}))}getTaskIdForRun(U){for(const[G,{run:Q}]of this.g)if(Q===U)return G}cancel(){this.c===P.Running?(this.j.cancel(),this.c=P.Cancelling):this.c===P.Cancelling&&this.H()}getCoverageDetails(U,G,Q){const[,ee]=t.$PI.fromString(U).path,ue=this.y.get(U);if(!ue)return[];const{report:ne,extIds:De}=ue,$e=this.g.get(ee);if(!$e)throw new Error("unreachable: run task was not found");let K;if(G&&ne instanceof o.$$O){const W=De.indexOf(G);if(W===-1)return[];K=ne.fromTests[W]}return this.F?.loadDetailedCoverage?.($e.run,ne,Q,K)??[]}createRun(U){const G=this.z.id,Q=this.z.controllerId,ee=(0,E.$2g)(),ue=K=>(W,...se)=>{if(De){this.D.warn(`Setting the state of test "${W.id}" is a no-op after the run ends.`);return}this.J(W),K(W,...se)},ne=(K,W)=>{const se=W instanceof Array?W.map(n.TestMessage.from):[n.TestMessage.from(W)];if(K.uri&&K.range){const oe={range:n.Range.from(K.range),uri:K.uri};for(const te of se)te.location=te.location||oe}this.C.$appendTestMessagesInRun(G,ee,t.$PI.fromExtHostTestItem(K,Q).toString(),se)};let De=!1;const $e={isPersisted:this.z.isPersisted,token:this.j.token,name:U,onDidDispose:this.w,addCoverage:K=>{if(De)return;const W=K instanceof o.$$O?K.fromTests:[];if(W.length){(0,a.$5G)(this.G,"attributableCoverage");for(const te of W)this.J(te)}const se=K.uri.toString(),oe=new t.$PI([G,ee,se]).toString();this.y.set(oe,{report:K,extIds:W.map(te=>t.$PI.fromExtHostTestItem(te,Q).toString())}),this.C.$appendCoverage(G,ee,n.TestCoverage.fromFile(Q,oe,K))},enqueued:ue(K=>{this.C.$updateTestStateInRun(G,ee,t.$PI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Queued)}),skipped:ue(K=>{this.C.$updateTestStateInRun(G,ee,t.$PI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Skipped)}),started:ue(K=>{this.C.$updateTestStateInRun(G,ee,t.$PI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Running)}),errored:ue((K,W,se)=>{ne(K,W),this.C.$updateTestStateInRun(G,ee,t.$PI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Errored,se)}),failed:ue((K,W,se)=>{ne(K,W),this.C.$updateTestStateInRun(G,ee,t.$PI.fromExtHostTestItem(K,Q).toString(),f.TestResultState.Failed,se)}),passed:ue((K,W)=>{this.C.$updateTestStateInRun(G,ee,t.$PI.fromExtHostTestItem(K,this.z.controllerId).toString(),f.TestResultState.Passed,W)}),appendOutput:(K,W,se)=>{De||(se&&this.J(se),this.C.$appendOutputToRun(G,ee,h.$Oe.fromString(K),W&&n.location.from(W),se&&t.$PI.fromExtHostTestItem(se,Q).toString()))},end:()=>{De||(De=!0,this.C.$finishedTestRunTask(G,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:$e}),this.C.$startedTestRunTask(G,{id:ee,name:U,running:!0}),$e}H(){for(const{run:U}of this.g.values())U.end()}I(){this.c!==P.Ended&&(this.c=P.Ended,this.m.fire())}J(U){if(!(U instanceof m.$0P))throw new s.$OP(U.id);if(this.h.has(t.$PI.fromExtHostTestItem(U,this.z.controllerId).toString()))return;const G=[],Q=this.z.colllection.root;for(;;){const ee=n.TestItem.from(U);if(G.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),U===Q))break;U=U.parent||Q}this.C.$addTestsToRun(this.z.controllerId,this.z.id,G)}dispose(){this.I(),super.dispose()}}class p{get trackers(){return this.c.values()}constructor(U,G){this.g=U,this.h=G,this.c=new Map,this.f=new Map}getCoverageDetails(U,G,Q){const ee=t.$PI.root(U);return this.f.get(ee)?.getCoverageDetails(U,G,Q)||[]}disposeTestRun(U){this.f.get(U)?.dispose(),this.f.delete(U);for(const[G,{id:Q}]of this.c)Q===U&&this.c.delete(G)}prepareForMainThreadTestRun(U,G,Q,ee,ue){return this.j(G,Q,ee,U,ue)}cancelRunById(U){this.f.get(U)?.cancel()}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,G,Q,ee,ue,ne){const De=this.c.get(ee);if(De)return De.createRun(ue);const $e=N.fromPublic(G,Q,ee,ne),K=v(ee);this.g.$startedExtensionTestRun({controllerId:G,continuous:!!ee.continuous,profile:K&&{group:B[K.kind],id:K.profileId},exclude:ee.exclude?.map(se=>t.$PI.fromExtHostTestItem(se,Q.root.id).toString())??[],id:$e.id,include:ee.include?.map(se=>t.$PI.fromExtHostTestItem(se,Q.root.id).toString())??[Q.root.id],preserveFocus:ee.preserveFocus??!0,persist:ne});const W=this.j(ee,$e,ee.profile,U);return R.Event.once(W.onEnd)(()=>{this.g.$finishedExtensionTestRun($e.id)}),W.createRun(ue)}j(U,G,Q,ee,ue){const ne=new C(G,this.g,this.h,Q,ee,ue);return this.c.set(U,ne),this.f.set(ne.id,ne),ne}}e.$Hoc=p;const v=re=>{if(re.profile){if(!(re.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return re.profile}};class N{static fromPublic(U,G,Q,ee){return new N(U,(0,E.$2g)(),ee,G)}static fromInternal(U,G){return new N(U.controllerId,U.runId,!0,G)}constructor(U,G,Q,ee){this.controllerId=U,this.id=G,this.isPersisted=Q,this.colllection=ee}}e.$Ioc=N;class T{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,n.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const G=t.$PI.parentId(U.item.extId);if(G&&this.h.has(G.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:G,g:Q}=this;return{get added(){return[...U].map(ee=>ee.revived)},get updated(){return[...G].map(ee=>ee.revived)},get removed(){return[...Q].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class M extends f.$YI{constructor(){super(...arguments),this.y=new R.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}x(U,G){return{...U,revived:n.TestItem.toPlain(U.item),depth:G?G.depth+1:0,children:new Set}}w(){return new T(this.y)}}class j{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(G=>G.revived)},dispose:(0,L.$fb)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new M({asCanonicalUri:G=>G});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const z=(re,U,G,Q)=>{G?Object.assign(G,Q):U.$updateTestRunConfig(re.controllerId,re.profileId,Q)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,z(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,z(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),z(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,z(this,this.#e,this.#n,{tag:U?n.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,z(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return R.Event.chain(this.#i,U=>U.map(G=>G.get(this.controllerId)?.get(this.profileId)).filter(I.$ng))}constructor(U,G,Q,ee,ue,ne,De,$e,K,W=!1,se=void 0,oe=!1){this.controllerId=ue,this.profileId=ne,this.f=De,this.kind=$e,this.runHandler=K,this._tag=se,this.g=oe,this.#e=U,this.#s=G,this.#t=Q,this.#i=ee,G.set(ne,this);const te=B[$e];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${$e}`);W&&Q.add(ne),this.#n={profileId:ne,controllerId:ue,tag:se?n.TestTag.namespace(this.controllerId,se.id):null,label:De,group:te,isDefault:W,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Joc=F;const B={[o.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[o.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[o.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function _(re,U){for(let G=0;G<re.path.length;G++){const Q=U.find(ee=>ee.id===re.path[G]);if(!Q)return;if(G===re.path.length-1)return Q;U=Q.children}}}),define(Ee[370],Se([1,0,19,4,3,6,167,17,10]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0,r=We(r),O=We(O);class l extends A.$Wc{constructor(E,u){super(),this.m=u,this.a=new h.$me,this.b=new h.$me,this.c=new h.$me,this.f=new h.$me,this.g=new h.$me,this.h=new h.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=E.getProxy(R.$qN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(k=>this.h.fire(k))),this.B(this.m.onDidChangeActiveTextEditor(k=>this.g.fire(k)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(E){const u=this.m.allEditors();return E?u:u.map(k=>k.value)}async showTextDocument(E,u,k){let b;typeof u=="number"?b={position:O.ViewColumn.from(u),preserveFocus:k}:typeof u=="object"?b={position:O.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?O.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:b={preserveFocus:!1};const c=await this.j.$tryShowTextDocument(E.uri,b),g=c&&this.m.getEditor(c);if(g)return g.value;throw c?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,u){return new L.$4P(this.j,E,u).value}$acceptEditorPropertiesChanged(E,u){const k=this.m.getEditor(E);if(!k)throw new Error("unknown text editor");if(u.options&&k._acceptOptions(u.options),u.selections){const b=u.selections.selections.map(O.Selection.to);k._acceptSelections(b)}if(u.visibleRanges){const b=r.$Jb(u.visibleRanges.map(O.Range.to));k._acceptVisibleRanges(b)}if(u.options&&this.b.fire({textEditor:k.value,options:{...u.options,lineNumbers:O.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const b=$.TextEditorSelectionChangeKind.fromValue(u.selections.source),c=u.selections.selections.map(O.Selection.to);this.a.fire({textEditor:k.value,selections:c,kind:b})}if(u.visibleRanges){const b=r.$Jb(u.visibleRanges.map(O.Range.to));this.c.fire({textEditor:k.value,visibleRanges:b})}}$acceptEditorPositionData(E){for(const u in E){const k=this.m.getEditor(u);if(!k)throw new Error("Unknown text editor");const b=O.ViewColumn.to(E[u]);k.value.viewColumn!==b&&(k._acceptViewColumn(b),this.f.fire({textEditor:k.value,viewColumn:b}))}}getDiffInformation(E){return Promise.resolve(this.j.$getDiffInformation(E))}}e.$Qnc=l}),define(Ee[371],Se([1,0,2,5,6,3,10,17,24,41,18]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=void 0,e.$Apc=(0,h.$Fi)("IExtHostTimeline");class E{constructor(b,c){this.b=new Map,this.c=new Map,this.a=b.getProxy(A.$qN.MainThreadTimeline),c.registerArgumentProcessor({processArgument:(g,d)=>{if(g&&g.$mid===l.MarshalledId.TimelineActionContext)if(this.b.get(g.source)&&$.$qn.equals(d,this.b.get(g.source)?.extension)){const m=g.uri===void 0?void 0:r.URI.revive(g.uri);return this.c.get(g.source)?.get(u(m))?.get(g.handle)}else return;return g}})}async $getTimeline(b,c,g,d){return this.b.get(b)?.provider.provideTimeline(r.URI.revive(c),g,d)}registerTimelineProvider(b,c,g,d){const m=new R.$Vc,n=this.d(c.id,d,m).bind(this);let o;c.onDidChange&&(o=c.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:c.id}),this));const i=this.c;return this.f({...c,scheme:b,onDidChange:void 0,async provideTimeline(t,s,f){s?.resetCache&&(m.clear(),i.get(c.id)?.clear());const a=await c.provideTimeline(t,s,f);if(a==null)return;const w=n(t,s);return{...a,source:c.id,items:a.items.map(w)}},dispose(){for(const t of i.values())t.get(c.id)?.clear();o?.dispose(),m.dispose()}},g)}d(b,c,g){return(d,m)=>{let n;if(m?.cacheResults){let o=this.c.get(b);o===void 0&&(o=new Map,this.c.set(b,o));const i=u(d);n=o.get(i),n===void 0&&(n=new Map,o.set(i,n))}return o=>{const{iconPath:i,...t}=o,s=`${b}|${o.id??o.timestamp}`;n?.set(s,o);let f,a,w;o.iconPath&&(i instanceof L.$pO?w={id:i.id,color:i.color}:r.URI.isUri(i)?(f=i,a=i):{light:f,dark:a}=i);let y;return L.$UN.isMarkdownString(t.tooltip)?y=O.MarkdownString.from(t.tooltip):(0,I.$fg)(t.tooltip)?y=t.tooltip:L.$UN.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=O.MarkdownString.from(t.detail)):(0,I.$fg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=t.detail),{...t,id:t.id??void 0,handle:s,source:b,command:o.command?c.toInternal(o.command,g):void 0,icon:f,iconDark:a,themeIcon:w,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f(b,c){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:c}),(0,R.$Uc)(()=>{for(const d of this.c.values())d.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Bpc=E;function u(k){return k?.toString()}}),define(Ee[372],Se([1,0,242,23,2,4,3,304,9,10,18,19,17,86,21,198,26]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0,l=We(l);function d(o,i){if((0,I.$fg)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class m extends L.$Wc{constructor(i,t,s){super(),this.f=i,this.g=t,this.h=s,this.a=new Map,this.b=new c.$b_;function f(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>f(a)?this.r(a):Array.isArray(a)&&a.length>0?a.map(w=>f(w)?this.r(w):w):a})}registerTreeDataProvider(i,t,s){const f=this.createTreeView(i,{treeDataProvider:t},s);return{dispose:()=>f.dispose()}}createTreeView(i,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],w=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,S=this.m(i,t,s),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:f,dragMimeTypes:a,hasHandleDrag:w,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},P=this.f.$registerTreeViewDataProvider(i,D),C={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,g.$5G)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,g.$5G)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(p){(0,k.$5k)(p)&&(0,g.$5G)(s,"treeViewMarkdownMessage"),S.message=p},get title(){return S.title},set title(p){S.title=p},get description(){return S.description},set description(p){S.description=p},get badge(){return S.badge},set badge(p){p!==void 0&&l.ViewBadge.isViewBadge(p)?S.badge={value:Math.floor(Math.abs(p.value)),tooltip:p.tooltip}:p===void 0&&(S.badge=void 0)},reveal:(p,v)=>S.reveal(p,v),dispose:async()=>{await P,this.a.delete(i),S.dispose()}};return this.B(C),C}$getChildren(i,t){const s=this.a.get(i);return s?s.getChildren(t):Promise.reject(new O.$nG(i))}async $handleDrop(i,t,s,f,a,w,y,S){const D=this.a.get(i);if(!D)return Promise.reject(new O.$nG(i));const P=u.DataTransfer.toDataTransfer(s,async C=>(await this.f.$resolveDropFileData(i,t,C)).buffer);return y===i&&S&&await this.j(P,D,S,a,w),D.onDrop(P,f,a)}async j(i,t,s,f,a){const w=this.b.removeDragOperationTransfer(a);if(w)(await w)?.forEach((y,S)=>{y&&i.set(S,y)});else if(a&&t.handleDrag){const y=t.handleDrag(s,i,f);this.b.addDragOperationTransfer(a,y),await y}return i}async $handleDrag(i,t,s,f){const a=this.a.get(i);if(!a)return Promise.reject(new O.$nG(i));const w=await this.j(new l.$lO,a,t,f,s);if(!(!w||f.isCancellationRequested))return u.DataTransfer.from(w)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new O.$nG(i);return t.hasResolve}$resolve(i,t,s){const f=this.a.get(i);if(!f)throw new O.$nG(i);return f.resolveTreeItem(t,s)}$setExpanded(i,t,s){const f=this.a.get(i);if(!f)throw new O.$nG(i);f.setExpanded(t,s)}$setSelectionAndFocus(i,t,s){const f=this.a.get(i);if(!f)throw new O.$nG(i);f.setSelectionAndFocus(t,s)}$setVisible(i,t){const s=this.a.get(i);if(!s){if(!t)return;throw new O.$nG(i)}s.setVisible(t)}$changeCheckboxState(i,t){const s=this.a.get(i);if(!s)throw new O.$nG(i);s.setCheckboxState(t)}m(i,t,s){const f=this.B(new n(i,t,this.f,this.g.converter,this.h,s));return this.a.set(i,f),f}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$Cpc=m;class n extends L.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,I.$og)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,s,f,a,w){if(super(),this.I=i,this.J=s,this.L=f,this.M=a,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$xe,w.contributes&&w.contributes.views)for(const P in w.contributes.views)for(const C of w.contributes.views[P])C.id===i&&(this.P=C.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(P=>{Array.isArray(P)&&P.length===0||this.F.fire({message:!1,element:P})}));let y,S;const D=R.Event.debounce(this.F.event,(P,C)=>(P||(P={message:!1,elements:[]}),C.element!==!1&&(y||(y=new Promise(p=>S=p),this.G=this.G.then(()=>y)),Array.isArray(C.element)?P.elements.push(...C.element):P.elements.push(C.element)),C.message&&(P.message=!0),P),200,!0);this.B(D(({message:P,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const p=S;return y=null,this.$(C).then(()=>p())})),P&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let s=this.X(i);return s||(s=await this.Y(t)),s?s.map(f=>f.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const s=(0,I.$og)(t.select)?!0:t.select,f=(0,I.$og)(t.focus)?!1:t.focus,a=(0,I.$og)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then(w=>this.W(i,w[w.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:w.map(S=>S.item)},{select:s,focus:f,expand:a})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:f,expand:a})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=u.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const s=this.getExtensionElement(i);s&&(t?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(i,t){const s=!(0,E.$wb)(this.s,i);this.s=i;const f=this.t!==t;this.t=t,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async s=>{const f=this.getExtensionElement(s.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(i,t,s){const f=[];for(const a of i){const w=this.getExtensionElement(a);w&&f.push(w)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,s){const f=t?this.getExtensionElement(t):void 0;if(!(!f&&t||!this.g?.handleDrop))return(0,$.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(f,i,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const s=this.j.get(i);if(s){const f=this.m.get(s);if(f){const a=await this.f.resolveTreeItem(f.extensionItem,s,t)??f.extensionItem;return this.hb(a),f.item.tooltip=this.eb(a.tooltip),f.item.command=this.fb(f.disposableStore,a.command),f.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(s=>this.W(t,s[s.length-1]).then(f=>(s.push(f),s))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$xh)(()=>this.f.getParent(i))}W(i,t){const s=this.m.get(i);return s?Promise.resolve(s):(0,$.$xh)(()=>this.f.getTreeItem(i)).then(f=>this.kb(i,f,t,!0)).then(f=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(f);if(a){const w=this.m.get(a);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const s=this.getExtensionElement(i);t=s?this.m.get(s):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new b.$xe(this.Z.token);try{const s=i?this.m.get(i):void 0,f=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const a=(0,E.$Jb)(f||[]),w=await Promise.all((0,E.$Jb)(a).map(S=>this.f.getTreeItem(S)));if(t.token.isCancellationRequested)return;const y=w.map((S,D)=>S?this.db(a[D],S,s):null);return(0,E.$Jb)(y)}finally{t.dispose()}}$(i){if(i.some(s=>!s))return this.Z.dispose(!0),this.Z=new b.$xe,this.tb(),this.J.$refresh(this.I);{const s=this.ab(i);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(i){const t=new Set,s=i.map(a=>this.m.get(a));for(const a of s)if(a&&!t.has(a.item.handle)){let w=a;for(;w&&w.parent&&s.findIndex(y=>w&&w.parent&&y&&y.item.handle===w.parent.item.handle)===-1;){const y=this.j.get(w.parent.item.handle);w=y?this.m.get(y):void 0}w&&!w.parent&&t.add(a.item.handle)}const f=[];return t.forEach(a=>{const w=this.j.get(a);if(w){const y=this.m.get(w);y&&(!y.parent||!t.has(y.parent.item.handle))&&f.push(a)}}),f}bb(i){const t={};return Promise.all(i.map(s=>this.cb(s).then(f=>{f&&(t[s]=f.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const s=this.m.get(t);if(s)return this.rb(t),(0,$.$xh)(()=>this.f.getTreeItem(t)).then(f=>{if(f){const a=this.ib(t,f,s.parent);return this.pb(t,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}db(i,t,s){const f=this.ib(i,t,s);if(t.id&&this.j.has(f.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.ob(i,f),this.qb(f,s),f}eb(i){return l.$UN.isMarkdownString(i)?u.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,s,f;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,s=i.checkboxState.tooltip,f=i.checkboxState.accessibilityInformation),{isChecked:t===l.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:f}}hb(i){if(!l.$gO.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,s){this.hb(t);const f=this.B(new L.$Vc),a=this.kb(i,t,s),w=this.lb(t);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:d(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(f,t.command),contextValue:t.contextValue,icon:w,iconDark:this.mb(t)||w,themeIcon:this.jb(t),collapsibleState:(0,I.$og)(t.collapsibleState)?l.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(i){return i.iconPath instanceof l.$pO?i.iconPath:void 0}kb(i,{id:t,label:s,resourceUri:f},a,w){if(t)return`${n.b}/${t}`;const y=d(s,this.N),S=a?a.item.handle:n.a;let D=y?y.label:f?(0,h.$dh)(f):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const P=this.m.has(i)?this.m.get(i).item.handle:void 0,C=this.X(a)||[];let p,v=0;do{if(p=`${S}/${v}:${D}`,w||!this.j.has(p)||P===p)break;v++}while(v<=C.length);return p}lb(i){if(i.iconPath&&!(i.iconPath instanceof l.$pO))return typeof i.iconPath=="string"||A.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof l.$pO)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return A.URI.isUri(i)?i:A.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,s,f){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(i,t);const a=this.X(f)||[],w=a.filter(y=>y.item.handle===s.item.handle)[0];w&&a.splice(a.indexOf(w),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const f=this.j.get(s.item.handle);f&&this.sb(f)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const s of t.children){const f=this.j.get(s.item.handle);f&&this.sb(f)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[373],Se([1,0,4,3,2,32,17,97,6,10]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0,L=We(L),$=We($),l=We(l);class I extends h.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(b,c,g,d){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new r.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new r.$me),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=c,this.#n=g,this.#i=d.viewType,this.#s=d.panelOptions,this.#o=d.viewColumn,this.#r=d.title,this.#l=d.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(b){this.c(),this.#r!==b&&(this.#r=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,A.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(b){this.#u||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#l=b.active,this.#c=b.visible,this.#o=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:L.ViewColumn.from(b),preserveFocus:!!c})}c(){if(this.#u)throw new Error("Webview is disposed")}}class E extends h.$Wc{static c(){return(0,R.$2g)()}constructor(b,c,g){super(),this.j=c,this.m=g,this.g=new Map,this.h=new Map,this.f=b.getProxy($.$qN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,c,g,d,m={}){const n=typeof d=="object"?d.viewColumn:d,o={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof d=="object"&&!!d.preserveFocus},i=(0,O.$6nc)(b),t=E.c();this.f.$createWebviewPanel((0,O.$8nc)(b),t,c,{title:g,panelOptions:u(m),webviewOptions:(0,O.$9nc)(b,this.m,m),serializeBuffersForPostMessage:i},o);const s=this.j.createNewWebview(t,m,b);return this.createNewWebviewPanel(t,c,g,n,m,s,!0)}$onDidChangeWebviewPanelViewStates(b){const c=Object.keys(b);c.sort((g,d)=>{const m=b[g],n=b[d];return m.active?1:n.active?-1:+m.visible-+n.visible});for(const g of c){const d=this.getWebviewPanel(g);if(!d)continue;const m=b[g];d._updateViewState({active:m.active,visible:m.visible,viewColumn:L.ViewColumn.to(m.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,c,g){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:g,extension:b}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,O.$6nc)(b)}),new l.$sN(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(b,c,g,d){const m=this.h.get(c);if(!m)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:o}=m,i=this.j.createNewWebview(b,g.webviewOptions,o),t=this.createNewWebviewPanel(b,c,g.title,d,g.panelOptions,i,g.active);await n.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(b,c,g,d,m,n,o){const i=new I(b,this.f,n,{viewType:c,title:g,viewColumn:d,panelOptions:m,active:o});return this.g.set(b,i),i}getWebviewPanel(b){return this.g.get(b)}}e.$0nc=E;function u(k){return{enableFindWidget:k.enableFindWidget,retainContextWhenHidden:k.retainContextWhenHidden}}}),define(Ee[374],Se([1,0,4,3,97,17,6,10]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,L=We(L),O=We(O);class $ extends h.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(E,u,k,b,c,g){super(),this.#s=!1,this.#l=this.B(new r.$me),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new r.$me),this.onDidDispose=this.#u.event,this.#i=k,this.#a=b,this.#e=E,this.#t=u,this.#n=c,this.#r=g}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(E){this.a(),this.#a!==E&&(this.#a=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#o}set description(E){this.a(),this.#o!==E&&(this.#o=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(E){E===this.#r||this.#s||(this.#r=E,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(E){this.a(),!(E?.value===this.#c?.value&&E?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#s)throw new Error("Webview is disposed")}}class l{constructor(E,u){this.d=u,this.b=new Map,this.c=new Map,this.a=E.getProxy(L.$qN.MainThreadWebviewViews)}registerWebviewViewProvider(E,u,k,b){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:k,extension:E}),this.a.$registerWebviewViewProvider((0,A.$8nc)(E),u,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,A.$6nc)(E)}),new O.$sN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(E,u,k,b,c){const g=this.b.get(u);if(!g)throw new Error(`No view provider found for '${u}'`);const{provider:d,extension:m}=g,n=this.d.createNewWebview(E,{},m),o=new $(E,this.a,u,k,n,!0);this.c.set(E,o),await d.resolveWebviewView(o,{state:b},c)}async $onDidChangeWebviewViewVisibility(E,u){this.e(E)._setVisible(u)}async $disposeWebviewView(E){const u=this.e(E);this.c.delete(E),u.dispose(),this.d.deleteWebview(E)}e(E){const u=this.c.get(E);if(!u)throw new Error("No webview found");return u}}e.$Fpc=l}),define(Ee[375],Se([1,0,76,15,12,277,28,11]),function(ce,e,r,h,A,R,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=void 0;let $=class{constructor(E,u){E.addFileSystemProvider(h.Schemas.file,new l(u),{isCaseSensitive:O.$k})}};e.$kqc=$,e.$kqc=$=Je([Ve(0,r.$2nc),Ve(1,A.$_j)],$);class l{constructor(E){this.b=E,this.a=new R.$nr(this.b)}async stat(E){const u=await this.a.stat(E);return{type:u.type,ctime:u.ctime,mtime:u.mtime,size:u.size,permissions:u.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(E){return this.a.readdir(E)}createDirectory(E){return this.a.mkdir(E)}readFile(E){return this.a.readFile(E)}writeFile(E,u,k){return this.a.writeFile(E,u,{...k,unlock:!1,atomic:!1})}delete(E,u){return this.a.delete(E,{...u,useTrash:!1,atomic:!1})}rename(E,u,k){return this.a.rename(E,u,k)}copy(E,u,k){return this.a.copy(E,u,k)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(E,u){throw new Error("Method not implemented.")}}}),define(Ee[376],Se([1,0,16,68,32,35,3,6,2,20]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=void 0;let I=class extends L.$Wc{constructor(u,k){super();const b=u.getProxy(O.$qN.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=$.URI.file((0,r.$lc)((0,h.tmpdir)(),(0,A.$2g)()));return await b.$download(c,g),g})}};e.$iqc=I,e.$iqc=I=Je([Ve(0,l.$WP),Ve(1,R.$gQ)],I)}),define(Ee[377],Se([1,0,61,16,2,98,3,15,9,34]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uqc=void 0,r=We(r),h=We(h);class I extends R.$4nc{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==O.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const f=s.fsPath;let a=0;do{let w;a===0?w=f:w=/[/\\]$/.test(f)?`${f.substr(0,f.length-1)}-${a}`:`${f}-${a}`,await E(w);const y=h.$lc(w,"vscode.lock"),S=await c(this.d,y,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),A.URI.file(w);a++}while(a<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$uqc=I;async function E(i){try{await l.Promises.stat(i);return}catch{}try{await l.Promises.mkdir(i,{recursive:!0})}catch{}}const u=1e3,k=10*60*1e3;class b extends L.$Wc{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new $.$Qh),this.a.cancelAndSet(async()=>{const f=await g(t,s);(!f||f.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await l.Promises.utimes(s,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${s}': Could not update mtime.`)}},u)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await l.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function c(i,t,s){try{const a={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){i.error(a)}const f=await g(i,t);return!f||f.pid!==process.pid?s?(i.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(i.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(i,t)):(i.info(`Lock '${t}': Lock acquired.`),new b(i,t))}async function g(i,t){let s;try{s=await l.Promises.readFile(t)}catch(f){return i.error(f),null}try{return JSON.parse(String(s))}catch(f){return i.error(f),null}}async function d(i,t){let s;try{s=await l.Promises.stat(t)}catch(f){return i.error(f),0}return s.mtime.getTime()}function m(i){try{return process.kill(i,0),!0}catch{return!1}}async function n(i,t){const s=await g(i,t);if(!s)return i.info(`Lock '${t}': Could not read pid of lock holder.`),o(i,t);if(s.willReleaseAt){let S=s.willReleaseAt-Date.now();if(S<5e3){for(S>0?i.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):i.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,$.$Gh)(Math.min(100,S)),await d(i,t)===0)return o(i,t);S=s.willReleaseAt-Date.now()}return o(i,t)}}if(!m(s.pid))return i.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),o(i,t);const f=await d(i,t),a=Date.now()-f;if(a<=k)return i.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;i.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$Gh)(2e3);const w=await d(i,t),y=Date.now()-w;return y<=k?(i.info(`Lock '${t}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(i.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(i,t))}async function o(i,t){i.info(`Lock '${t}': Deleting a stale lock.`);try{await l.Promises.unlink(t)}catch{}return c(i,t,!0)}}),define(Ee[378],Se([1,0,32,20,47,35]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppc=void 0;let L=class extends A.$noc{constructor($,l){super(!0,$,l)}createTerminal($,l,I){return this.createTerminalFromOptions({name:$,shellPath:l,shellArgs:I})}createTerminalFromOptions($,l){const I=new A.$moc(this.a,(0,r.$2g)(),$,$.name);return this.f.push(I),I.create($,this.R($,l)),I.value}};e.$Ppc=L,e.$Ppc=L=Je([Ve(0,R.$gQ),Ve(1,h.$WP)],L)}),define(Ee[379],Se([1,0,4,37,36,5]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.OutputChannelUpdateMode=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=void 0,e.$yM="text/x-code-output",e.$zM="output",e.$AM="Log",e.$BM="text/x-code-log-output",e.$CM="log",e.$DM="workbench.panel.output",e.$EM=new A.$Wj("inOutput",!1),e.$FM=new A.$Wj("activeLogOutput",!1),e.$GM=new A.$Wj("activeLogOutput.levelSettable",!1),e.$HM=new A.$Wj("activeLogOutput.level",""),e.$IM=new A.$Wj("activeLogOutput.levelIsDefault",!1),e.$JM=new A.$Wj("outputView.scrollLock",!1),e.$KM=(0,R.$Fi)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$LM={OutputChannels:"workbench.contributions.outputChannels"};class O{constructor(){this.a=new Map,this.b=new r.$me,this.onDidRegisterChannel=this.b.event,this.c=new r.$me,this.onDidRemoveChannel=this.c.event}registerChannel(l){this.a.has(l.id)||(this.a.set(l.id,l),this.b.fire(l.id))}getChannels(){const l=[];return this.a.forEach(I=>l.push(I)),l}getChannel(l){return this.a.get(l)}removeChannel(l){this.a.delete(l),this.c.fire(l)}}h.$po.add(e.$LM.OutputChannels,new O),e.$MM=new A.$Wj("activeOutputChannel","")}),define(Ee[168],Se([1,0,6,5,20,24,12,379,76,30,63,203,22,18,28,4,3]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=e.$ipc=void 0;class d extends L.$fk{get disposed(){return this.n}constructor(i,t,s,f,a){super(),this.id=i,this.name=t,this.r=s,this.s=f,this.extension=a,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,O.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=u.$Oe.fromString(t).byteLength,(0,L.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,O.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class m extends d{appendLine(i){this.append(i)}}let n=class{constructor(i,t,s,f,a,w){this.i=t,this.j=s,this.k=f,this.l=a,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(r.$qN.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,E.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(i,t,s){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const f=typeof t=="object"&&t.log,a=(0,k.$fg)(t)?t:void 0;if((0,k.$fg)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const y=this.i.environment.extensionLogLevel?.find(([D])=>R.$qn.equals(s.identifier,D))?.[1];y&&(w=(0,L.$qk)(y));const S=f?this.o(i,w,s):this.n(i,a,s);return S.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),f?this.r(i,w??this.m.getLevel(),S):this.q(i,S)}async n(i,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,a=this.k.extUri.joinPath(f,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(i,a,t,s.identifier.value);return new d(y,i,w,this.a,s)}async o(i,t,s){const f=await this.p(s),a=i.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(f,`${a}.log`),y=`${s.identifier.value}.${a}`,S=this.l.createLogger(w,{id:y,name:i,logLevel:t,extensionId:s.identifier.value});return new m(y,i,S,this.a,s)}p(i){let t=this.d.get(i.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(f){if((0,b.$pl)(f)!==b.FileSystemProviderErrorCode.FileExists)throw f}return s})())}return t}q(i,t){let s=!1;const f=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return i},append(a){f(),t.then(w=>w.append(a))},appendLine(a){f(),t.then(w=>w.appendLine(a))},clear(){f(),t.then(a=>a.clear())},replace(a){f(),t.then(w=>w.replace(a))},show(a,w){f(),t.then(y=>y.show(a,w))},hide(){f(),t.then(a=>a.hide())},dispose(){s=!0,t.then(a=>a.dispose())}}}r(i,t,s){const f=new g.$Vc,a=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},w=f.add(new c.$me);function y(S){t=S,w.fire(S)}return s.then(S=>{f.add(S),S.logLevel!==t&&y(S.logLevel),f.add(S.onDidChangeLogLevel(D=>y(D)))}),{...this.q(i,s),get logLevel(){return t},onDidChangeLogLevel:w.event,trace(S,...D){a(),s.then(P=>P.trace(S,...D))},debug(S,...D){a(),s.then(P=>P.debug(S,...D))},info(S,...D){a(),s.then(P=>P.info(S,...D))},warn(S,...D){a(),s.then(P=>P.warn(S,...D))},error(S,...D){a(),s.then(P=>P.error(S,...D))},dispose(){f.dispose()}}}};e.$ipc=n,e.$ipc=n=Je([Ve(0,A.$WP),Ve(1,l.$aQ),Ve(2,$.$2nc),Ve(3,I.$Enc),Ve(4,L.$ak),Ve(5,L.$_j)],n),e.$jpc=(0,h.$Fi)("IExtHostOutputService")}),define(Ee[169],Se([1,0,5,9]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,r.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(A){let R=1/0;for(let O=0;O<this.maxSampleCount;O++){const $=await A.getRoundTripTime();if($===void 0)return;R=Math.min(R,$/2),await(0,h.$Gh)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((O,$)=>O+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((O,$)=>O+$,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[380],Se([1,0,246,71,37,46,45,3,4,169,11,25,9,150]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=void 0,e.$3K=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$4K=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$5K=Object.freeze({id:"security",scope:h.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$6K=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$7K=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$8K={ConfigurationMigration:"base.contributions.configuration.migration"};class b{constructor(){this.migrations=[],this.a=new $.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const c=new b;A.$po.add(e.$8K.ConfigurationMigration,c);let g=class extends O.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const s of t.added)await this.f(s,c.migrations)})),this.c(c.migrations),this.B(c.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(t=>this.g(t,o?.uri))])}async g(o,i){const t=this.a.inspect(o.key,{resource:i}),s=this.b.getWorkbenchState()===R.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[f,a]of s){const w=t[f];if(!w)continue;const y=[];if(w.value!==void 0){const S=await this.h(o,f,w.value,i,void 0);for(const D of S??[])y.push([D,[]])}for(const{identifiers:S,value:D}of w.overrides??[])if(D!==void 0){const P=await this.h(o,f,D,i,S);for(const C of P??[])y.push([C,S])}y.length&&await Promise.allSettled(y.map(async([[S,D],P])=>this.a.updateValue(S,D.value,{resource:i,overrideIdentifiers:P},a)))}}async h(o,i,t,s,f){const a=y=>{const D=this.a.inspect(y,{resource:s})[i];if(D)return f?D.overrides?.find(({identifiers:P})=>(0,E.$go)(P,f))?.value:D.value},w=await o.migrateFn(t,a);return Array.isArray(w)?w:[[o.key,w]]}};e.$9K=g,e.$9K=g=Je([Ve(0,L.$_i),Ve(1,R.$Oi)],g);let d=class extends O.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(o){super(),this.b=o,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$i&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;A.$po.as(h.$uo.Configuration).registerConfiguration({...e.$5K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:h.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:h.ConfigurationScope.MACHINE}}})}};e.$0K=d,e.$0K=d=Je([Ve(0,l.$Vm)],d),e.$$K="window.newWindowProfile";let m=class extends O.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(o,i){super(),this.c=o,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(t=>{t.source!==L.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$$K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const o=A.$po.as(h.$uo.Configuration),i={...e.$7K,properties:{[e.$$K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:h.ConfigurationScope.APPLICATION}}};this.a?o.updateConfigurations({add:[i],remove:[this.a]}):o.registerConfiguration(i),this.a=i}h(){const o=this.f.getValue(e.$$K);this.b=o?this.c.profiles.find(i=>i.name===o):void 0}j(){const o=this.f.getValue(e.$$K);if(!o)return;const i=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;o!==i?.name&&this.f.updateValue(e.$$K,i?.name)}};e.$_K=m,e.$_K=m=Je([Ve(0,k.$Ll),Ve(1,L.$_i)],m)}),define(Ee[381],Se([1,0,39,15,16,23,258,380,71,5,37]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$bL=e.$aL=void 0,e.$cL=c,e.$dL=g,r=We(r),e.$aL=(0,l.$Fi)("editorResolverService"),e.$bL="workbench.editorAssociations";const E=I.$po.as($.$uo.Configuration),u={...O.$4K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};E.registerConfiguration(u);var k;(function(d){d.builtin="builtin",d.option="option",d.exclusive="exclusive",d.default="default"})(k||(e.RegisteredEditorPriority=k={}));var b;(function(d){d[d.ABORT=1]="ABORT",d[d.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function c(d){switch(d){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function g(d,m){if(new Set([h.Schemas.extension,h.Schemas.webviewPanel,h.Schemas.vscodeWorkspaceTrust,h.Schemas.vscodeSettings]).has(m.scheme))return!1;const i=typeof d=="string"&&d.indexOf(A.$ic.sep)>=0?`${m.scheme}:${m.path}`:(0,R.$dh)(m);return r.$yk(typeof d=="string"?d.toLowerCase():d,i.toLowerCase())}}),define(Ee[382],Se([1,0,33,15,16,11,23,2,5,296,46,157,169]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0,e.$5M=(0,$.$Fi)("pathService");let b=k=class{constructor(g,d,m,n){this.d=g,this.e=d,this.f=m,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??g})()}hasValidBasename(g,d,m){return typeof d=="string"||typeof d>"u"?this.a.then(n=>this.h(g,n,d)):this.h(g,d,m)}h(g,d,m){return g.scheme===h.Schemas.file||g.scheme===h.Schemas.vscodeRemote?(0,r.$Cg)(m??(0,L.$dh)(g),d===R.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,d){if(g.remoteAuthority)return h.Schemas.vscodeRemote;const m=(0,l.$2M)(d.getWorkspace());if(m)return m;const n=d.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=d.getWorkspace().configuration;return o?o.scheme:h.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===R.OperatingSystem.Windows?A.$hc:A.$ic)}async fileURI(g){let d="";if(await this.a===R.OperatingSystem.Windows&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const n=g.indexOf("/",2);n===-1?(d=g.substring(2),g="/"):(d=g.substring(2,n),g=g.substring(n)||"/")}return O.URI.from({scheme:h.Schemas.file,authority:d,path:g,query:"",fragment:""})}};e.$6M=b,e.$6M=b=k=Je([Ve(1,u.$Vm),Ve(2,E.$NM),Ve(3,I.$Oi)],b)}),define(Ee[383],Se([1,0,260,59,4,60,3,2,45,266,12,72,151,93,46,157,26,21,18,25,36]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.OnPortForward=e.$SM=e.$RM=e.TunnelSource=e.TunnelCloseReason=e.$PM=e.$OM=void 0,e.$QM=a,e.$TM=S,e.$UM=D,e.$VM=P,e.$WM=p,r=We(r);const i=10*1e3,t="remote.tunnels.toRestore",s="remote.tunnels.toRestoreExpiration",f=1e3*60*60*24*14;e.$OM="onTunnel",e.$PM=new o.$Wj("forwardedPortsViewEnabled",!1,r.localize(0,null));function a(T){const M=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(M)return{host:M[1]?.substring(0,M[1].length-1)||"localhost",port:Number(M[2])}}var w;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(w||(e.TunnelCloseReason=w={}));var y;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$RM={source:y.User,description:r.localize(1,null)},e.$SM={source:y.Auto,description:r.localize(2,null)};function S(T,M,j){const z=T.get(P(M,j));if(z)return z;if((0,k.$Dw)(M))for(const F of k.$Cw){const B=P(F,j);if(T.has(B))return T.get(B)}else if((0,k.$Fw)(M))for(const F of k.$Ew){const B=P(F,j);if(T.has(B))return T.get(B)}}function D(T,M,j){const z=S(T,M,j);if(z)return z;const F=(0,k.$Fw)(M)?"localhost":(0,k.$Dw)(M)?"0.0.0.0":void 0;if(F)return S(T,F,j)}function P(T,M){return T+":"+M}var C;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})(C||(e.OnPortForward=C={}));function p(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}class v extends L.$Wc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(M){super(),this.r=M,this.j=[],this.n=new A.$me,this.onDidChangeAttributes=this.n.event,this.B(M.onDidChangeConfiguration(j=>{(j.affectsConfiguration(v.c)||j.affectsConfiguration(v.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(M,j,z){let F=this.w(M,j,z,this.j,0);const B={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;F>=0;){const _=this.j[F];_.key===M?(B.onAutoForward=_.onAutoForward??B.onAutoForward,B.elevateIfNeeded=_.elevateIfNeeded!==void 0?_.elevateIfNeeded:B.elevateIfNeeded,B.label=_.label??B.label,B.requireLocalPort=_.requireLocalPort,B.protocol=_.protocol):(B.onAutoForward=B.onAutoForward??_.onAutoForward,B.elevateIfNeeded=B.elevateIfNeeded!==void 0?B.elevateIfNeeded:_.elevateIfNeeded,B.label=B.label??_.label,B.requireLocalPort=B.requireLocalPort!==void 0?B.requireLocalPort:void 0,B.protocol=B.protocol??_.protocol),F=this.w(M,j,z,this.j,F+1)}return B.onAutoForward!==void 0||B.elevateIfNeeded!==void 0||B.label!==void 0||B.requireLocalPort!==void 0||B.protocol!==void 0?B:this.C()}t(M){return M.start!==void 0&&M.end!==void 0}u(M){return M.host!==void 0&&M.port!==void 0&&(0,m.$fg)(M.host)&&(0,m.$jg)(M.port)}w(M,j,z,F,B){if(B>=F.length)return-1;const _=!(0,k.$Dw)(j)&&!(0,k.$Fw)(j),U=F.slice(B).findIndex(G=>(0,m.$jg)(G.key)?_?!1:G.key===M:this.t(G.key)?_?!1:M>=G.key.start&&M<=G.key.end:this.u(G.key)?M===G.key.port&&j===G.key.host:z?G.key.test(z):!1);return U>=0?U+B:-1}y(){const M=this.r.getValue(v.c);if(!M||!(0,m.$hg)(M))return[];const j=[];for(const F in M){if(F===void 0)continue;const B=M[F];let _;if(Number(F))_=Number(F);else if((0,m.$fg)(F))if(v.g.test(F)){const re=F.match(v.g);_={start:Number(re[1]),end:Number(re[2])}}else if(v.h.test(F)){const re=F.match(v.h);_={host:re[1],port:Number(re[2])}}else{let re;try{re=RegExp(F)}catch{}re&&(_=re)}_&&j.push({key:_,elevateIfNeeded:B.elevateIfNeeded,onAutoForward:B.onAutoForward,label:B.label,requireLocalPort:B.requireLocalPort,protocol:B.protocol})}const z=this.r.getValue(v.f);return z&&(this.m={elevateIfNeeded:z.elevateIfNeeded,label:z.label,onAutoForward:z.onAutoForward,requireLocalPort:z.requireLocalPort,protocol:z.protocol}),this.z(j)}z(M){function j(z,F){return(0,m.$jg)(z.key)?z.key:F.t(z.key)?z.key.start:F.u(z.key)?z.key.port:Number.MAX_VALUE}return M.sort((z,F)=>j(z,this)-j(F,this))}C(){return this.m}static providedActionToAction(M){switch(M){case k.ProvidedOnAutoForward.Notify:return C.Notify;case k.ProvidedOnAutoForward.OpenBrowser:return C.OpenBrowser;case k.ProvidedOnAutoForward.OpenBrowserOnce:return C.OpenBrowserOnce;case k.ProvidedOnAutoForward.OpenPreview:return C.OpenPreview;case k.ProvidedOnAutoForward.Silent:return C.Silent;case k.ProvidedOnAutoForward.Ignore:return C.Ignore;default:return}}async addAttributes(M,j,z){const B=this.r.inspect(v.c).userRemoteValue;let _;!B||!(0,m.$hg)(B)?_={}:_=(0,n.$co)(B),_[`${M}`]||(_[`${M}`]={});for(const re in j)_[`${M}`][re]=j[re];return this.r.updateValue(v.c,_,z)}}e.$XM=v;let N=class extends L.$Wc{constructor(M,j,z,F,B,_,re,U,G,Q){super(),this.H=M,this.I=j,this.J=z,this.L=F,this.M=B,this.N=_,this.O=re,this.P=U,this.Q=G,this.R=Q,this.c=new Map,this.g=new A.$me,this.onForwardPort=this.g.event,this.h=new A.$me,this.onClosePort=this.h.event,this.j=new A.$me,this.onPortName=this.j.event,this.n=new A.$me,this.onCandidatesChanged=this.n.event,this.t=new A.$me,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$me,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new v(z),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async ee=>{const ue=await this.getAttributes(ee.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of ee)if(ne.localAddress){const De=P(ne.tunnelRemoteHost,ne.tunnelRemotePort),$e=D(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(De,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:ue?.get(ne.tunnelRemotePort)?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,ue?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:$e?.detail,hasRunningProcess:!!$e,pid:$e?.pid,privacy:ne.privacy,source:e.$RM}),this.f.set(De,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async ee=>{const ue=P(ee.tunnelRemoteHost,ee.tunnelRemotePort);if(!D(this.forwarded,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!D(this.detected,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&!D(this.c,ee.tunnelRemoteHost,ee.tunnelRemotePort)&&ee.localAddress){const ne=D(this.m??new Map,ee.tunnelRemoteHost,ee.tunnelRemotePort),De=(await this.getAttributes([{port:ee.tunnelRemotePort,host:ee.tunnelRemoteHost}]))?.get(ee.tunnelRemotePort);this.forwarded.set(ue,{remoteHost:ee.tunnelRemoteHost,remotePort:ee.tunnelRemotePort,localAddress:ee.localAddress,protocol:De?.protocol??k.TunnelProtocol.Http,localUri:await this.X(ee.localAddress,De),localPort:ee.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:ee.privacy,source:e.$RM})}await this.cb(),this.f.set(ue,ee),this.g.fire(this.forwarded.get(ue))})),this.B(this.H.onTunnelClosed(ee=>this.W(ee,w.Other))),this.U()}S(){return this.Q.extensions.find(M=>M.activationEvents?.includes(e.$OM))?(this.R.createKey(e.$PM.key,!0),!0):!1}U(){if(this.S())return;const M=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&M.dispose()}))}async W(M,j){const z=P(M.host,M.port);this.forwarded.has(z)&&(this.forwarded.delete(z),await this.cb(),this.h.fire(M))}X(M,j){if(M.startsWith("http"))return O.URI.parse(M);const z=j?.protocol??"http";return O.URI.parse(`${z}://${M}`)}async Y(M){const j=this.N.getWorkspace(),z=j.configuration?(0,R.$tj)(j.configuration.path):j.folders.length>0?(0,R.$tj)(j.folders[0].uri.path):void 0;if(z===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${M}.${this.L.remoteAuthority}.${z}`}async Z(){return this.Y(t)}async $(){return this.Y(s)}async ab(){const M=this.I.get(t,u.StorageScope.WORKSPACE);if(M)return this.I.remove(t,u.StorageScope.WORKSPACE),await this.cb(),M;const j=await this.Z();if(j)return this.I.get(j,u.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const M=await this.s;if(M&&M!==this.y){const j=JSON.parse(M)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(z=>z.remotePort).join(", ")}`);for(const z of j){const F=D(this.detected,z.remoteHost,z.remotePort);z.source.source!==y.Extension&&!F||z.source.source===y.Extension&&F?await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,elevateIfNeeded:!0,source:z.source}):z.source.source===y.Extension&&!F&&this.D.set(P(z.remoteHost,z.remotePort),z)}}}if(this.z=!0,this.C.fire(),!this.w){const M=await this.Z();this.w=this.B(new L.$Vc),this.w.add(this.I.onDidChangeValue(u.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===M&&(this.s=Promise.resolve(this.I.get(M,u.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const M=this.I.keys(u.StorageScope.PROFILE,u.StorageTarget.USER).filter(j=>j.startsWith(s));for(const j of M){const z=this.I.getNumber(j,u.StorageScope.PROFILE);if(z&&z<Date.now()){this.s=Promise.resolve(void 0);const F=j.replace(s,t);this.I.remove(j,u.StorageScope.PROFILE),this.I.remove(F,u.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const M=Array.from(this.forwarded.values()),j=M.map(_=>({remoteHost:_.remoteHost,remotePort:_.remotePort,localPort:_.localPort,name:_.name,localAddress:_.localAddress,localUri:_.localUri,protocol:_.protocol,source:_.source}));let z;M.length>0&&(z=JSON.stringify(j));const F=await this.Z(),B=await this.$();!z&&F&&B?(this.I.remove(F,u.StorageScope.PROFILE),this.I.remove(B,u.StorageScope.PROFILE)):z!==this.y&&F&&B&&(this.I.store(F,z,u.StorageScope.PROFILE,u.StorageTarget.USER),this.I.store(B,Date.now()+f,u.StorageScope.PROFILE,u.StorageTarget.USER)),this.y=z}}async eb(M,j,z){if(!M.tunnelLocalPort||!z?.requireLocalPort||M.tunnelLocalPort===j)return;const F=new Date;if(this.db.getTime()+i>F.getTime())return;this.db=F;const B=r.localize(3,null,j,M.tunnelRemotePort,M.tunnelLocalPort);return this.P.info(B)}async forward(M,j){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(M,j)}async fb(M,j){await this.Q.activateByEvent(e.$OM);const z=D(this.forwarded,M.remote.host,M.remote.port);j=j??(j!==null?(await this.getAttributes([M.remote]))?.get(M.remote.port):void 0);const F=M.local!==void 0?M.local:M.remote.port;let B;if(z)return this.hb(z,M,j);{const _=this.L.remoteAuthority,re=_?{getAddress:async()=>(await this.M.resolveAuthority(_)).authority}:void 0,U=P(M.remote.host,M.remote.port);this.c.set(U,!0),M=this.gb(U,M);const G=await this.H.openTunnel(re,M.remote.host,M.remote.port,void 0,F,M.elevateIfNeeded?M.elevateIfNeeded:j?.elevateIfNeeded,M.privacy,j?.protocol);if(typeof G=="string")B=G;else if(G&&G.localAddress){const Q=D(this.m??new Map,M.remote.host,M.remote.port),ee=G.protocol?G.protocol===k.TunnelProtocol.Https?k.TunnelProtocol.Https:k.TunnelProtocol.Http:j?.protocol??k.TunnelProtocol.Http,ue={remoteHost:G.tunnelRemoteHost,remotePort:G.tunnelRemotePort,localPort:G.tunnelLocalPort,name:j?.label??M.name,closeable:!0,localAddress:G.localAddress,protocol:ee,localUri:await this.X(G.localAddress,j),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:M.source??e.$RM,privacy:G.privacy};return this.forwarded.set(U,ue),this.f.set(U,G),this.c.delete(U),await this.cb(),await this.eb(G,F,j),this.g.fire(ue),G}this.c.delete(U)}return B}gb(M,j){const z=this.D.has(M)?this.D:this.F.has(M)?this.F:void 0;if(z){const F=z.get(M);z.delete(M),F&&(j.name=F.name??j.name,j.local=("local"in F?F.local:"localPort"in F?F.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(M,j,z){const F=z?.label??j.name;let B;(function(re){re[re.None=0]="None",re[re.Fire=1]="Fire",re[re.Reopen=2]="Reopen"})(B||(B={}));let _=B.None;switch(F!==M.name&&(M.name=F,_=B.Fire),(z?.protocol||M.protocol!==k.TunnelProtocol.Http)&&z?.protocol!==M.protocol&&(j.source=M.source,_=B.Reopen),j.privacy&&M.privacy!==j.privacy&&(_=B.Reopen),_){case B.Fire:{this.g.fire();break}case B.Reopen:await this.close(M.remoteHost,M.remotePort,w.User),await this.fb(j,z)}return D(this.f,j.remote.host,j.remote.port)}async name(M,j,z){const F=D(this.forwarded,M,j),B=P(M,j);if(F){F.name=z,await this.cb(),this.j.fire({host:M,port:j});return}else this.detected.has(B)&&(this.detected.get(B).name=z,this.j.fire({host:M,port:j}))}async close(M,j,z){const F=P(M,j),B=this.forwarded.get(F);return z===w.AutoForwardEnd&&B&&B.source.source===y.Auto&&this.F.set(F,{local:B.localPort,name:B.name,privacy:B.privacy}),await this.H.closeTunnel(M,j),this.W({host:M,port:j},z)}address(M,j){const z=P(M,j);return(this.forwarded.get(z)||this.detected.get(z))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(M){if(M)for(const j of M){const z=D(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),F=typeof j.localAddress=="string"?j.localAddress:P(j.localAddress.host,j.localAddress.port);this.detected.set(P(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:F,protocol:k.TunnelProtocol.Http,localUri:this.X(F),closeable:!1,runningProcess:z?.detail,hasRunningProcess:!!z,pid:z?.pid,privacy:k.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,F,k.TunnelPrivacyId.ConstantPrivate,k.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(M){this.r=M}async setCandidates(M){let j=M;this.r&&(j=await this.r(M));const z=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(z.values()).map(F=>F.port).join(", ")}`),this.n.fire(z)}ib(M){const j=this.m??new Map,z=new Map;return this.m=z,M.forEach(F=>{const B=P(F.host,F.port);z.set(B,{host:F.host,port:F.port,detail:F.detail,pid:F.pid}),j.has(B)&&j.delete(B);const _=D(this.forwarded,F.host,F.port);_&&(_.runningProcess=F.detail,_.hasRunningProcess=!0,_.pid=F.pid)}),j.forEach((F,B)=>{const _=a(B);if(!_)return;const re=D(this.forwarded,_.host,_.port);re&&(re.runningProcess=void 0,re.hasRunningProcess=!1,re.pid=void 0);const U=D(this.detected,_.host,_.port);U&&(U.runningProcess=void 0,U.hasRunningProcess=!1,U.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const M=Array.from(this.forwarded.values()),j=await this.getAttributes(M.map(z=>({port:z.remotePort,host:z.remoteHost})),!1);if(j)for(const z of M){const F=j.get(z.remotePort);(F?.protocol||z.protocol!==k.TunnelProtocol.Http)&&F?.protocol!==z.protocol&&await this.fb({remote:{host:z.remoteHost,port:z.remotePort},local:z.localPort,name:z.name,source:z.source},F),F&&F.label&&F.label!==z.name&&await this.name(z.remoteHost,z.remotePort,F.label)}}async getAttributes(M,j=!0){const z=new Map,F=new Map;M.forEach(G=>{const Q=D(this.m??new Map,k.$Cw[0],G.port)??G;if(Q){z.set(G.port,Q);const ee=p(Q)?Q.pid:void 0;F.has(ee)||F.set(ee,[]),F.get(ee)?.push(G.port)}});const B=new Map;if(M.forEach(G=>{const Q=this.configPortsAttributes.getAttributes(G.port,G.host,z.get(G.port)?.detail);Q&&B.set(G.port,Q)}),this.G.length===0||!j)return B.size>0?B:void 0;const _=await Promise.all(this.G.flatMap(G=>Array.from(F.entries()).map(Q=>{const ee=Q[1],ue=z.get(ee[0]);return G.providePortAttributes(ee,ue?.pid,ue?.detail,d.CancellationToken.None)}))),re=new Map;if(_.forEach(G=>G.forEach(Q=>{Q&&re.set(Q.port,Q)})),!B&&!re)return;const U=new Map;return M.forEach(G=>{const Q=B.get(G.port),ee=re.get(G.port);U.set(G.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??v.providedActionToAction(ee?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),U}addAttributesProvider(M){this.G.push(M)}};e.$YM=N,Je([(0,h.$$h)(1e3)],N.prototype,"cb",null),e.$YM=N=Je([Ve(0,k.$xw),Ve(1,u.$cq),Ve(2,$.$_i),Ve(3,c.$NM),Ve(4,E.$Ql),Ve(5,b.$Oi),Ve(6,I.$_j),Ve(7,l.$3w),Ve(8,g.$1G),Ve(9,o.$Xj)],N)}),define(Ee[100],Se([1,0]),function(ce,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GL=e.$FL=void 0;class r{constructor(L,O){this.line=L,this.character=O}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,O){return new r(0,0)}with(L){return new r(0,0)}}e.$FL=r;class h{constructor(L,O,$,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,O),this.end=new r($,l)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new h(0,0,0,0)}with(L){return new h(0,0,0,0)}}e.$GL=h;var A;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(A||(e.TextSearchCompleteMessageType=A={}))}),define(Ee[38],Se([1,0,19,39,25,33,13,5,16,14,100,9]),function(ce,e,r,h,A,R,L,O,$,l,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$5L=e.$XL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$UL=e.$TL=e.$SL=e.$RL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.TextSearchCompleteMessageType=void 0,e.$OL=d,e.$PL=m,e.$QL=n,e.$VL=S,e.$WL=D,e.$YL=p,e.$ZL=v,e.$1L=N,e.$2L=T,e.$3L=M,e.$4L=j,e.$6L=F,e.$8L=re,e.$9L=U,h=We(h),A=We(A),R=We(R),$=We($),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$HL="workbench.view.search",e.$IL="workbench.panel.search",e.$JL="workbench.view.search",e.$KL="search-result",e.$LL="search.exclude",e.$ML=2e4;const u="\u27EA ",k=" characters skipped \u27EB",b=(u.length+k.length+5)*2;e.$NL=(0,O.$Fi)("searchService");var c;(function(Q){Q[Q.file=0]="file",Q[Q.text=1]="text",Q[Q.aiText=2]="aiText"})(c||(e.SearchProviderType=c={}));var g;(function(Q){Q[Q.File=1]="File",Q[Q.Text=2]="Text",Q[Q.aiText=3]="aiText"})(g||(e.QueryType=g={}));function d(Q){return!!Q.preview}function m(Q){return!!Q.resource}function n(Q){return!!Q.message}var o;(function(Q){Q[Q.Normal=0]="Normal",Q[Q.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class i{constructor(ee){this.resource=ee,this.results=[]}}e.$RL=i;class t{constructor(ee,ue,ne,De){this.ranges=ue,this.webviewIndex=De;const $e=Array.isArray(ue)?ue:[ue];if(ne&&ne.matchLines===1&&s($e)){ee=(0,L.$$f)(ee,ne.matchLines);let K="",W=0,se=0;const oe=Math.floor(ne.charsPerLine/5),te=[];for(const le of $e){const he=Math.max(le.startColumn-oe,0),X=le.startColumn+ne.charsPerLine;if(he>se+oe+b){const ae=u+(he-se)+k;K+=ae+ee.slice(he,X),W+=he-(se+ae.length)}else K+=ee.slice(se,X);te.push(new a(0,le.startColumn-W,le.endColumn-W)),se=X}this.preview={text:K,matches:Array.isArray(this.ranges)?te:te[0]}}else{const K=Array.isArray(ue)?ue[0].startLineNumber:ue.startLineNumber;this.preview={text:ee,matches:(0,r.$3b)(ue,W=>new f(W.startLineNumber-K,W.startColumn,W.endLineNumber-K,W.endColumn))}}}}e.$SL=t;function s(Q){const ee=Q[0].startLineNumber;for(const ue of Q)if(ue.startLineNumber!==ee||ue.endLineNumber!==ee)return!1;return!0}class f{constructor(ee,ue,ne,De){this.startLineNumber=ee,this.startColumn=ue,this.endLineNumber=ne,this.endColumn=De}}e.$TL=f;class a extends f{constructor(ee,ue,ne){super(ee,ue,ee,ne)}}e.$UL=a;var w;(function(Q){Q.List="list",Q.Tree="tree"})(w||(e.ViewMode=w={}));var y;(function(Q){Q.Default="default",Q.FileNames="fileNames",Q.Type="type",Q.Modified="modified",Q.CountDescending="countDescending",Q.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function S(Q,ee=!0){const ue=Q&&Q.files&&Q.files.exclude,ne=ee&&Q&&Q.search&&Q.search.exclude;if(!ue&&!ne)return;if(!ue||!ne)return ue||ne;let De=Object.create(null);return De=A.$fo(De,A.$co(ue)),De=A.$fo(De,A.$co(ne),!0),De}function D(Q,ee){return Q.excludePattern&&h.$yk(Q.excludePattern,ee)?!1:Q.includePattern||Q.usingSearchPaths?Q.includePattern&&h.$yk(Q.includePattern,ee)?!0:Q.usingSearchPaths?!!Q.folderQueries&&Q.folderQueries.some(ue=>{const ne=ue.folder.fsPath;if(R.$Eg(ee,ne)){const De=$.$nc(ne,ee);return!ue.includePattern||!!h.$yk(ue.includePattern,De)}else return!1}):!1:!0}var P;(function(Q){Q[Q.unknownEncoding=1]="unknownEncoding",Q[Q.regexParseError=2]="regexParseError",Q[Q.globParseError=3]="globParseError",Q[Q.invalidLiteral=4]="invalidLiteral",Q[Q.rgProcessError=5]="rgProcessError",Q[Q.other=6]="other",Q[Q.canceled=7]="canceled"})(P||(e.SearchErrorCode=P={}));class C extends Error{constructor(ee,ue){super(ee),this.code=ue}}e.$XL=C;function p(Q){const ee=Q.message;if((0,l.$6)(Q))return new C(ee,P.canceled);try{const ue=JSON.parse(ee);return new C(ue.message,ue.code)}catch{return new C(ee,P.other)}}function v(Q){const ee={message:Q.message,code:Q.code};return new Error(JSON.stringify(ee))}function N(Q){return Q.type==="error"?!0:Q.type==="success"}function T(Q){return Q.type==="success"}function M(Q){return!!Q.path}function j(Q,ee,ue=!0){const ne=Q.searchPath?Q.searchPath:Q.relativePath;return ue?(0,L.$8f)(ne,ee):h.$yk(ee,ne)}class z{constructor(ee){this.path=ee,this.results=[]}addMatch(ee){this.results.push(ee)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$5L=z;function F(Q,ee){const ue={...Q||{},...ee||{}};return Object.keys(ue).filter(ne=>{const De=ue[ne];return typeof De=="boolean"&&De})}class B{constructor(ee,ue){this.c=null,this.a={...ee.excludePattern||{},...ue.excludePattern||{}},this.b=h.$zk(this.a);let ne=ee.includePattern;ue.includePattern&&(ne?ne={...ne,...ue.includePattern}:ne=ue.includePattern),ne&&(this.c=h.$zk(ne))}matchesExcludesSync(ee,ue,ne){return!!(this.b&&this.b(ee,ue,ne))}includedInQuerySync(ee,ue,ne){return!(this.b&&this.b(ee,ue,ne)||this.c&&!this.c(ee,ue,ne))}includedInQuery(ee,ue,ne){const De=this.b(ee,ue,ne),$e=()=>this.c?!!this.c(ee,ue,ne):!0;return(0,E.$rh)(De)?De.then(K=>K?!1:$e()):$e()}hasSiblingExcludeClauses(){return _(this.a)}}e.$7L=B;function _(Q){for(const ee in Q)if(typeof Q[ee]!="boolean")return!0;return!1}function re(Q){if(!Q)return;let ee;return ue=>(ee||(ee=(Q()||Promise.resolve([])).then(ne=>ne?G(ne):{})),ee.then(ne=>!!ne[ue]))}function U(Q){if(!Q)return;let ee;return ue=>{if(!ee){const ne=Q();ee=ne?G(ne):{}}return!!ee[ue]}}function G(Q){const ee={};for(const ue of Q)ee[ue]=!0;return ee}}),define(Ee[48],Se([1,0,19,9,21,4,3,85,15,134,23,13,2,244,28,5,12,280,46,63,30,20,17,10,73,38,6,57]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0;function S(M,j,z){return new I.$8g(F=>p(F,z)).isEqual(M,j)}function D(M,j,z){return S(M.uri,j.uri,z)?0:(0,E.$zf)(M.uri.toString(),j.uri.toString())}function P(M,j,z){return M.index!==j.index?M.index<j.index?-1:1:S(M.uri,j.uri,z)?(0,E.$zf)(M.name,j.name):(0,E.$zf)(M.uri.toString(),j.uri.toString())}function C(M,j,z,F){const B=M.slice(0).sort((re,U)=>z(re,U,F)),_=j.slice(0).sort((re,U)=>z(re,U,F));return(0,r.$Gb)(B,_,(re,U)=>z(re,U,F))}function p(M,j){const z=j.getCapabilities(M.scheme);return!(z&&z&b.FileSystemProviderCapabilities.PathCaseSensitive)}class v extends m.$Yi{static toExtHostWorkspace(j,z,F,B){if(!j)return{workspace:null,added:[],removed:[]};const{id:_,name:re,folders:U,configuration:G,transient:Q,isUntitled:ee}=j,ue=[],ne=z;z?U.forEach((W,se)=>{const oe=u.URI.revive(W.uri),te=v.o(F||z,oe,B);te?(te.name=W.name,te.index=W.index,ue.push(te)):ue.push({uri:oe,name:W.name,index:se})}):ue.push(...U.map(({uri:W,name:se,index:oe})=>({uri:u.URI.revive(W),name:se,index:oe}))),ue.sort((W,se)=>W.index<se.index?-1:1);const De=new v(_,re,ue,!!Q,G?u.URI.revive(G):null,!!ee,W=>p(W,B)),{added:$e,removed:K}=C(ne?ne.workspaceFolders:[],De.workspaceFolders,D,B);return{workspace:De,added:$e,removed:K}}static o(j,z,F){for(let B=0;B<j.folders.length;B++){const _=j.workspaceFolders[B];if(S(_.uri,z,F))return _}}constructor(j,z,F,B,_,re,U){super(j,F.map(G=>new m.$Zi(G)),B,_,U),this.t=z,this.u=re,this.q=[],this.s=O.$Li.forUris(U,()=>!0),F.forEach(G=>{this.q.push(G),this.s.set(G.uri,G)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,z){return z&&this.s.get(j)&&(j=(0,I.$fh)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let N=class{constructor(j,z,F,B,_){this.c=new R.$me,this.onDidChangeWorkspace=this.c.event,this.g=new R.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$oe,this.C=new Map,this.h=B,this.s=F,this.t=_,this.j=new l.$Mm,this.k=new h.$Eh,this.o=j.getProxy(w.$qN.MainThreadWorkspace),this.q=j.getProxy(w.$qN.MainThreadMessageService);const re=z.workspace;this.l=re?new v(re.id,re.name,[],!!re.transient,re.configuration?u.URI.revive(re.configuration):null,!!re.isUntitled,U=>p(U,F)):void 0}$initializeWorkspace(j,z){this.v=z,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,I.$dh)((0,I.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,z,F,...B){const _=[];if(Array.isArray(B)&&B.forEach(ee=>{u.URI.isUri(ee.uri)&&!_.some(ue=>S(ue.uri,ee.uri,this.s))&&_.push({uri:ee.uri,name:ee.name||(0,I.$ch)(ee.uri)})}),this.n||[z,F].some(ee=>typeof ee!="number"||ee<0)||F===0&&_.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(z+F>re.length)return!1;const U=re.slice(0);U.splice(z,F,..._.map(ee=>({uri:ee.uri,name:ee.name||(0,I.$ch)(ee.uri),index:void 0})));for(let ee=0;ee<U.length;ee++){const ue=U[ee];if(U.some((ne,De)=>De!==ee&&S(ue.uri,ne.uri,this.s)))return!1}U.forEach((ee,ue)=>ee.index=ue);const{added:G,removed:Q}=C(re,U,P,this.s);if(G.length===0&&Q.length===0)return!1;if(this.o){const ee=j.displayName||j.name;this.o.$updateWorkspaceFolders(ee,z,F,_).then(void 0,ue=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(d.Severity.Error,(0,k.localize)(0,null,ee,ue.toString()),ne,[])})}return this.y(U),!0}getWorkspaceFolder(j,z){if(this.x)return this.x.getWorkspaceFolder(j,z)}async getWorkspaceFolder2(j,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,z)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,z){let F,B="";if(typeof j=="string"?(F=u.URI.file(j),B=j):typeof j<"u"&&(F=j,B=j.fsPath),!F)return B;const _=this.getWorkspaceFolder(F,!0);if(!_)return B;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let re=(0,I.$ih)(_.uri,F);return z&&_.name&&(re=`${_.name}/${re}`),re}y(j){this.x&&(this.n=v.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:z,added:F,removed:B}=v.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:B}))}findFiles(j,z,F,B,_=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${B.value}, entryPoint: findFiles`);let re="",U=!0;return z===null?U=!1:z!==void 0&&(typeof z=="string"?re=z:re=z.pattern),this.z(j,void 0,{exclude:re,maxResults:F,useDefaultExcludes:U,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},_)}findFiles2(j,z={},F,B=A.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,j,z,B)}async z(j,z,F,B=A.CancellationToken.None){if(B&&B.isCancellationRequested)return Promise.resolve([]);const _=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,re={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:_,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let U;if(j){const{includePattern:G,folder:Q}=T(t.GlobPattern.from(j));U=Q,re.includePattern=G}else{const{includePattern:G,folder:Q}=T(t.GlobPattern.from(z));U=Q,re.filePattern=G}return this.o.$startFileSearch(U??null,re,B).then(G=>Array.isArray(G)?G.map(Q=>u.URI.revive(Q)):[])}async findTextInFiles(j,z,F,B,_=A.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${B.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),U=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:G,folder:Q}=T(t.GlobPattern.from(z.include)),ee=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,ue={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:U,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:G,excludePattern:ee},ne=!1;if(this.u[re]=De=>{if(ne)return;const $e=u.URI.revive(De.resource);De.results.forEach(K=>{const W=(0,y.$ci)(K);(0,a.$OL)(W)?F({uri:$e,preview:{text:W.preview.text,matches:(0,r.$3b)(W.preview.matches,se=>new s.$uN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,r.$3b)(W.ranges,se=>new s.$uN(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):F({uri:$e,text:W.text,lineNumber:W.lineNumber})})},_.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(j,Q??null,ue,re,_);return delete this.u[re],De||{}}catch(De){throw delete this.u[re],De}}$handleTextSearchResult(j,z){this.u[z]?.(j)}async save(j){const z=await this.o.$save(j,{saveAs:!1});return u.URI.revive(z)}async saveAs(j){const z=await this.o.$save(j,{saveAs:!0});return u.URI.revive(z)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,z){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,z);const F=this.t.transformOutgoingScheme(j),B=this.A++;return this.o.$registerEditSessionIdentityProvider(B,F),(0,L.$Uc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(B)})}async $getEditSessionIdentifier(j,z){this.h.info("Getting edit session identifier for workspaceFolder",j);const F=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const _=await B.provideEditSessionIdentity(F,z);if(this.h.info("Provider returned edit session identifier: ",_),!!_)return _}async $provideEditSessionIdentityMatch(j,z,F,B){this.h.info("Getting edit session identifier for workspaceFolder",j);const _=await this.resolveWorkspaceFolder(u.URI.revive(j));if(!_){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",_);const re=this.w.get(_.uri.scheme);if(this.h.info(`Provider for scheme ${_.uri.scheme} is defined: `,!!re),!re)return;const U=await re.provideEditSessionIdentityMatch?.(z,F,B);if(this.h.info("Provider returned edit session identifier match result: ",U),!!U)return U}getOnWillCreateEditSessionIdentityEvent(j){return(z,F,B)=>{const _=function(U){z.call(F,U)};return _.extension=j,this.B.event(_,void 0,B)}}async $onWillCreateEditSessionIdentity(j,z,F){const B=await this.resolveWorkspaceFolder(u.URI.revive(j));if(B===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:B},z,async(_,re)=>{const U=Date.now();await Promise.resolve(_),Date.now()-U>F&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(j,z){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,z);const F=this.t.transformOutgoingScheme(j),B=this.A++;return this.o.$registerCanonicalUriProvider(B,F),(0,L.$Uc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(B)})}async provideCanonicalUri(j,z,F){const B=this.C.get(j.scheme);if(!B)return;const _=await B.provideCanonicalUri?.(u.URI.revive(j),z,F);if(_)return _}async $provideCanonicalUri(j,z,F){return this.provideCanonicalUri(u.URI.revive(j),{targetScheme:z},F)}};e.$Vnc=N,e.$Vnc=N=Je([Ve(0,i.$WP),Ve(1,o.$aQ),Ve(2,n.$Enc),Ve(3,g.$_j),Ve(4,f.$Tnc)],N),e.$Wnc=(0,c.$Fi)("IExtHostWorkspace");function T(M){let j,z;return M&&(typeof M=="string"?j=M:(j=M.pattern,z=u.URI.revive(M.baseUri))),{includePattern:j,folder:z}}}),define(Ee[42],Se([1,0,25,4,48,6,10,45,282,71,18,9,5,20,12,2]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=e.$Xnc=void 0;function g(f,a){if(a){const w=a.split(".");let y=f;for(let S=0;y&&S<w.length;S++)y=y[w[S]];return y}}function d(f){return f instanceof c.URI}function m(f){return f&&f.uri instanceof c.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof c.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function i(f){if(d(f))return{resource:f};if(m(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let t=class{constructor(a,w,y){this.a=a.getProxy(R.$qN.MainThreadConfiguration),this.c=w,this.b=y,this.d=new E.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new s(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,w){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(a,w))}};e.$Xnc=t,e.$Xnc=t=Je([Ve(0,k.$WP),Ve(1,A.$Wnc),Ve(2,b.$_j)],t);class s{constructor(a,w,y,S){this.a=new h.$me,this.b=a,this.f=S,this.c=w,this.e=$.$No.parse(y,S),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,w){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$No.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(w,y))}getConfiguration(a,w,y){const S=i(w)||{},D=this.g(a?g(this.e.getValue(void 0,S,this.c.workspace),a):this.e.getValue(void 0,S,this.c.workspace));a&&this.h(a,S,y?.identifier);function P(p){if(p==null)return null;if(typeof p=="boolean")return p?O.ConfigurationTarget.USER:O.ConfigurationTarget.WORKSPACE;switch(p){case L.ConfigurationTarget.Global:return O.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return O.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return O.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(p){return typeof g(D,p)<"u"},get:(p,v)=>{this.h(a?`${a}.${p}`:p,S,y?.identifier);let N=g(D,p);if(typeof N>"u")N=v;else{let T;const M=(j,z)=>{if((0,I.$hg)(j)){let F;const B=()=>{T=T||(0,r.$co)(D),F=F||g(T,z)};return new Proxy(j,{get:(_,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return B(),()=>F;if(T)return F=F||g(T,z),F[re];const U=_[re];return typeof re=="string"?M(U,`${z}.${re}`):U},set:(_,re,U)=>(B(),F&&(F[re]=U),!0),deleteProperty:(_,re)=>(B(),F&&delete F[re],!0),defineProperty:(_,re,U)=>(B(),F&&Object.defineProperty(F,re,U),!0)})}return Array.isArray(j)?(0,r.$co)(j):j};N=M(N,p)}return N},update:(p,v,N,T)=>{p=a?`${a}.${p}`:p;const M=P(N);return v!==void 0?this.b.$updateConfigurationOption(M,p,v,S,T):this.b.$removeConfigurationOption(M,p,S,T)},inspect:p=>{p=a?`${a}.${p}`:p;const v=this.e.inspect(p,S,this.c.workspace);if(v)return{key:p,defaultValue:(0,r.$co)(v.policy?.value??v.default?.value),globalValue:(0,r.$co)(v.user?.value??v.application?.value),workspaceValue:(0,r.$co)(v.workspace?.value),workspaceFolderValue:(0,r.$co)(v.workspaceFolder?.value),defaultLanguageValue:(0,r.$co)(v.default?.override),globalLanguageValue:(0,r.$co)(v.user?.override??v.application?.override),workspaceLanguageValue:(0,r.$co)(v.workspace?.override),workspaceFolderLanguageValue:(0,r.$co)(v.workspaceFolder?.override),languageIds:(0,r.$co)(v.overrideIdentifiers)}}};return typeof D=="object"&&(0,r.$fo)(C,D,!1),Object.freeze(C)}g(a){const w=y=>(0,I.$hg)(y)?new Proxy(y,{get:(S,D)=>w(S[D]),set:(S,D,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(D)}' of object`)},deleteProperty:(S,D)=>{throw new Error(`TypeError: Cannot delete read only property '${String(D)}' of object`)},defineProperty:(S,D)=>{throw new Error(`TypeError: Cannot define property '${String(D)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return w(a)}h(a,w,y){const S=l.$Eo.test(a)?l.ConfigurationScope.RESOURCE:this.d.get(a),D=y?`[${y.value}] `:"";if(l.ConfigurationScope.RESOURCE===S){typeof w?.resource>"u"&&this.f.warn(`${D}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===S){w?.resource&&this.f.warn(`${D}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,w){const y=new $.$Po(a,w,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,D)=>y.affectsConfiguration(S,i(D))})}k(a){return a.reduce((w,y)=>(w.set(y[0],y[1]),w),new Map)}}e.$Ync=s,e.$Znc=(0,u.$Fi)("IExtHostConfiguration")}),define(Ee[101],Se([1,0,2,9,4,6,10,48,64,42,21,47,20,30,5,15,11,12,96,324,14]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=e.$upc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,L=We(L),g=We(g);var i;(function(T){function M(z){if(z!=null)return z}T.from=M;function j(z){if(z!=null)return z}T.to=j})(i||(i={}));var t;(function(T){function M(z){if(z!=null)return z}T.from=M;function j(z){if(z!=null)return z}T.to=j})(t||(t={}));var s;(function(T){function M(z){if(z!=null)return z}T.from=M;function j(z){if(z!=null)return z}T.to=j})(s||(s={}));var f;(function(T){function M(F){if(F){const B=F;return B&&!!B.process}else return!1}T.is=M;function j(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=s.from(F.options)),B}T.from=j;function z(F){if(F!=null)return new L.$cO(F.process,F.args,F.options)}T.to=z})(f||(f={}));var a;(function(T){function M(z){if(z!=null)return z}T.from=M;function j(z){if(z!=null)return z}T.to=j})(a||(a={}));var w;(function(T){function M(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}T.is=M;function j(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=a.from(F.options)),B}T.from=j;function z(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.$dO(F.commandLine,F.options):new L.$dO(F.command,F.args?F.args:[],F.options)}T.to=z})(w||(w={}));var y;(function(T){function M(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}T.is=M;function j(F){return{customExecution:"customExecution"}}T.from=j;function z(F,B){return B.get(F)}T.to=z})(y||(e.CustomExecutionDTO=y={}));var S;(function(T){function M(j,z){let F;return j.scope!==void 0&&typeof j.scope!="number"?F=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===L.TaskScope.Workspace&&z&&z.workspaceFile?F=z.workspaceFile:F=n.$EI),{id:j._id,workspaceFolder:F}}T.from=M})(S||(e.TaskHandleDTO=S={}));var D;(function(T){function M(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}T.from=M})(D||(D={}));var P;(function(T){function M(F,B){if(F==null)return[];const _=[];for(const re of F){const U=j(re,B);U&&_.push(U)}return _}T.fromMany=M;function j(F,B){if(F==null)return;let _;F.execution instanceof L.$cO?_=f.from(F.execution):F.execution instanceof L.$dO?_=w.from(F.execution):F.execution&&F.execution instanceof L.$eO&&(_=y.from(F.execution));const re=i.from(F.definition);let U;return F.scope?typeof F.scope=="number"?U=F.scope:U=F.scope.uri:U=L.TaskScope.Workspace,!re||!U?void 0:{_id:F._id,definition:re,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:U},execution:_,isBackground:F.isBackground,group:D.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}T.from=j;async function z(F,B,_){if(F==null)return;let re;f.is(F.execution)?re=f.to(F.execution):w.is(F.execution)?re=w.to(F.execution):y.is(F.execution)&&(re=y.to(F._id,_));const U=i.to(F.definition);let G;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?G=F.source.scope:G=await B.resolveWorkspaceFolder(r.URI.revive(F.source.scope)):G=L.TaskScope.Workspace),!U||!G)return;const Q=new L.$fO(U,G,F.name,F.source.label,re,F.problemMatchers);return F.isBackground!==void 0&&(Q.isBackground=F.isBackground),F.group!==void 0&&(Q.group=L.$bO.from(F.group._id),Q.group&&F.group.isDefault&&(Q.group=new L.$bO(Q.group.id,Q.group.label),F.group.isDefault===!0&&(Q.group.isDefault=F.group.isDefault))),F.presentationOptions&&(Q.presentationOptions=t.to(F.presentationOptions)),F._id&&(Q._id=F._id),F.detail&&(Q.detail=F.detail),Q}T.to=z})(P||(e.TaskDTO=P={}));var C;(function(T){function M(z){return z}T.from=M;function j(z){if(z)return Object.assign(Object.create(null),z)}T.to=j})(C||(C={}));class p{#e;constructor(M,j,z){this._id=j,this.a=z,this.#e=M}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(M){}fireDidEndProcess(M){}}let v=class{constructor(M,j,z,F,B,_,re,U){this.q=new A.$me,this.r=new A.$me,this.s=new A.$me,this.u=new A.$me,this.a=M.getProxy(R.$qN.MainThreadTask),this.b=z,this.c=F,this.d=B,this.e=_,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=re,this.g=U,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(M,j,z){if(!z)return new L.$sN(()=>{});const F=this.x();return this.j.set(F,{type:j,provider:z,extension:M}),this.a.$registerTaskProvider(F,j),new L.$sN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(M,j){this.a.$registerTaskSystem(M,j)}fetchTasks(M){return this.a.$fetchTasks(C.from(M)).then(async j=>{const z=[];for(const F of j){const B=await P.to(F,this.b,this.m);B&&z.push(B)}return z})}get taskExecutions(){const M=[];return this.k.forEach(j=>M.push(j)),M}terminateTask(M){if(!(M instanceof p))throw new Error("No valid task execution provided");return this.a.$terminateTask(M._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(M,j,z){const F=this.m.get(M.id);F&&(this.o.set(M.id,F),this.e.attachPtyToTerminal(j,await F.callback(z))),this.p=M.id,this.q.fire({execution:await this.z(M)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(M){if(!this.l.has(M.id))return;const j=await this.z(M);this.l.delete(M.id),this.k.delete(M.id),this.B(M),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(M){const j=await this.z(M.id);this.s.fire({execution:j,processId:M.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(M){const j=await this.z(M.id);this.u.fire({execution:j,exitCode:M.exitCode})}$provideTasks(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));const F=[],B=(0,h.$xh)(()=>z.provider.provideTasks(I.CancellationToken.None)).then(_=>this.v(j,F,z,_));return new Promise(_=>{B.then(re=>{Promise.all(F).then(()=>{_(re)})})})}async $resolveTask(M,j){const z=this.j.get(M);if(!z)return Promise.reject(new Error("no handler found"));if(j.definition.type!==z.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${z.type}].`);const F=await P.to(j,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await z.provider.resolveTask(F,I.CancellationToken.None);if(!B)return;this.A(B,z);const _=P.from(B,z.extension);if(!_)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return y.is(_.execution)&&await this.y(_,B,!0),await this.w(_)}x(){return this.h++}async y(M,j,z){const F=await this.a.$createTaskId(M);!z&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,j.execution)),this.m.set(F,j.execution)}async z(M,j){if(typeof M=="string"){const B=this.l.get(M);if(!B)throw new o.$db("Unexpected: The specified task is missing an execution");return B}const z=this.l.get(M.id);if(z)return z;let F;return j?F=Promise.resolve(new p(this,M.id,j)):F=P.to(M.task,this.b,this.m).then(B=>{if(!B)throw new o.$db("Unexpected: Task does not exist.");return new p(this,M.id,B)}),this.l.set(M.id,F),F.then(B=>(this.k.set(M.id,B),B))}A(M,j){M._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}B(M){this.o.get(M.id)&&this.o.delete(M.id),this.n.has(M.id)&&this.p!==M.id&&(this.m.delete(M.id),this.n.delete(M.id));const z=this.n.values();let F=z.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=z.next()}};e.$upc=v,e.$upc=v=Je([Ve(0,u.$WP),Ve(1,k.$aQ),Ve(2,O.$Wnc),Ve(3,$.$8P),Ve(4,l.$Znc),Ve(5,E.$loc),Ve(6,d.$_j),Ve(7,m.$Anc)],v);let N=class extends v{constructor(M,j,z,F,B,_,re,U){super(M,j,z,F,B,_,re,U),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$h(g.Platform.Web)})}async executeTask(M,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const z=P.from(j,M);if(z===void 0)throw new Error("Task is not valid");if(y.is(z.execution))await this.y(z,j,!1);else throw new o.$bb;const F=await this.z(await this.a.$getTaskExecution(z),j);return this.a.$executeTask(z).catch(B=>{throw new Error(B)}),F}v(M,j,z,F){const B=[];if(F)for(const _ of F){if(this.A(_,z),!_.definition||!M[_.definition.type]){const U=_.source?_.source:"No task source";this.f.warn(`The task [${U}, ${_.name}] uses an undefined task type. The task will be ignored in the future.`)}const re=P.from(_,z.extension);re&&y.is(re.execution)?(B.push(re),j.push(this.y(re,_,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:z.extension}}async w(M){if(y.is(M.execution))return M;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(M,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(M,j,z){}};e.$vpc=N,e.$vpc=N=Je([Ve(0,u.$WP),Ve(1,k.$aQ),Ve(2,O.$Wnc),Ve(3,$.$8P),Ve(4,l.$Znc),Ve(5,E.$loc),Ve(6,d.$_j),Ve(7,m.$Anc)],N),e.$wpc=(0,b.$Fi)("IExtHostTask")}),define(Ee[384],Se([1,0,38,31]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0,e.$cM=A,e.$eM=R;function A(L){return"cellResults"in L}e.$dM="rawCell#";function R(L,O){let $=-1;const l=[];let I=[];return L.forEach(u=>{u.range.startLineNumber!==$&&I.length>0&&(l.push([...I]),I=[]),I.push(u),$=u.range.endLineNumber}),I.length>0&&l.push([...I]),l.map(u=>{const k=[],b=u[0].range.startLineNumber,c=u[u.length-1].range.endLineNumber;for(let g=b;g<=c;g++)k.push(O.getLineContent(g));return new r.$SL(k.join(`
`)+`
`,u.map(g=>new h.$It(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}}),define(Ee[385],Se([1,0,238,22,4,3,29,41,13,18,2,28,119,6,35,17,10,51,357,164,25,15,38,313,384,381]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0,E=We(E),c=We(c),g=We(g);class w{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,D,P,C,p,v,N){this.q=P,this.r=C,this.s=p,this.t=v,this.u=N,this.f=new Map,this.g=new L.$Cc,this.h=new Map,this.j=new A.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new A.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new A.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new A.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$ync("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(k.$qN.MainThreadNotebook),this.c=S.getProxy(k.$qN.MainThreadNotebookDocuments),this.d=S.getProxy(k.$qN.MainThreadNotebookEditors),this.i=D.converter,D.registerArgumentProcessor({processArgument:T=>{if(T&&T.$mid===O.MarshalledId.NotebookCellActionContext){const M=T.notebookEditor?.notebookUri,j=T.cell.handle,F=this.g.get(M)?.getCell(j);if(F)return F.apiCell}if(T&&T.$mid===O.MarshalledId.NotebookActionContext){const M=T.uri,j=this.g.get(M);if(j)return j.apiNotebook}return T}}),w.C(D)}getEditorById(S){const D=this.h.get(S);if(!D)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return D}getIdByEditor(S){for(const[D,P]of this.h)if(P.apiEditor===S)return D}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,D){const P=this.g.get(S);if(!P&&!D)throw new Error(`NO notebook document for '${S}'`);return P}static w(S,D){if(!D)return;const P=D.filenamePattern.map(C=>c.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(D.filenamePattern&&!P){console.warn(`Notebook content provider view options file name pattern is invalid ${D.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:D.displayName,filenamePattern:P,priority:D.exclusive?a.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(S,D,P){const C=w.a++,p=typeof P.onDidChangeCellStatusBarItems=="function"?w.a++:void 0;this.f.set(C,P),this.b.$registerNotebookCellStatusBarItemProvider(C,p,D);let v;return p!==void 0&&(v=P.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(p))),new g.$sN(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,p),v?.dispose()})}async createNotebookDocument(S){const D=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&c.NotebookData.from(S.content)});return I.URI.revive(D)}async openNotebookDocument(S){const D=this.g.get(S);if(D)return D.apiNotebook;const P=await this.c.$tryOpenNotebook(S),C=this.g.get(I.URI.revive(P));return(0,l.$qg)(C?.apiNotebook)}async showNotebookDocument(S,D){I.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let P;typeof D=="object"?P={position:c.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selections:D.selections&&D.selections.map(c.NotebookRange.from),pinned:typeof D.preview=="boolean"?!D.preview:void 0}:P={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,P),p=C&&this.h.get(C)?.apiEditor;if(p)return p;throw C?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,D,P,C){const p=this.f.get(S),v=I.URI.revive(D),N=this.g.get(v);if(!N||!p)return;const T=N.getCellFromIndex(P);if(!T)return;const M=await p.provideCellStatusBarItems(T.apiCell,C);if(!M)return;const j=new R.$Vc,z=this.p.add([j]),B=(Array.isArray(M)?M:[M]).map(_=>c.NotebookStatusBarItem.from(_,this.i,j));return{cacheId:z,items:B}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,D,P,C,p){if((0,$.$df)(D))throw new Error("viewType cannot be empty or just whitespace");const v=this.x++;return this.y.set(v,{viewType:D,serializer:P,options:C}),this.b.$registerNotebookSerializer(v,{id:S.identifier,location:S.extensionLocation},D,c.NotebookDocumentContentOptions.from(C),w.w(S,p)),(0,R.$Uc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(S,D,P){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const p=await C.serializer.deserializeNotebook(D.buffer,P);return new d.$Qw(c.NotebookData.from(p))}async $notebookToData(S,D,P){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const p=await C.serializer.serializeNotebook(c.NotebookData.to(D.value),P);return h.$Oe.wrap(p)}async $saveNotebook(S,D,P,C,p){const v=I.URI.revive(D),N=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${P}, ${v.toString()})`),!N)throw new Error("NO serializer found");const T=this.g.get(v);if(!T)throw new Error("Document NOT found");if(T.versionId!==P)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new E.$ul((0,r.localize)(0,null,this.A(v)),E.FileOperationResult.FILE_PERMISSION_DENIED);const M={metadata:(0,o.$ko)(T.apiNotebook.metadata,_=>!(N.options?.transientDocumentMetadata??{})[_]),cells:[]};for(const _ of T.apiNotebook.getCells()){const re=new g.$VO(_.kind,_.document.getText(),_.document.languageId,_.mime,N.options?.transientOutputs?[]:[..._.outputs],_.metadata,_.executionSummary);re.metadata=(0,o.$ko)(_.metadata,U=>!(N.options?.transientCellMetadata??{})[U]),M.cells.push(re)}if(await this.z(v,C),p.isCancellationRequested)throw new Error("canceled");const j=await N.serializer.serializeNotebook(M,p);if(p.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${P} ${v.toString()}`),await this.s.value.writeFile(v,j),this.D(`Finished write versionId: ${P} ${v.toString()}`);const z=this.s.getFileSystemProviderExtUri(v.scheme),F=await this.s.value.stat(v),B={name:z.basename(v),isFile:(F.type&E.FileType.File)!==0,isDirectory:(F.type&E.FileType.Directory)!==0,isSymbolicLink:(F.type&E.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&E.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((F.permissions??0)&E.FilePermission.Locked),etag:E.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${P}, ${v.toString()})`),B}async $searchInNotebooks(S,D,P,C,p){const v=this.y.get(S)?.serializer;if(!v)return{limitHit:!1,results:[]};const N=new L.$Dc;await(async(F,B,_)=>{await Promise.all(F.map(async re=>await Promise.all(re.filenamePatterns.map(U=>{const G={_reason:_._reason,folderQueries:_.folderQueries,includePattern:_.includePattern,excludePattern:_.excludePattern,maxResults:_.maxResults,type:t.QueryType.File,filePattern:U};return this.t.doInternalFileSearchWithCustomCallback(G,B,Q=>{Q.forEach(ee=>{N.has(ee)||C.some(ne=>re.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(De=>(0,a.$dL)(De,ee)))||N.add(ee)})}).catch(Q=>{if(Q.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Q})}))))})(P,p,D);const M=new L.$Cc;let j=!1;const z=Array.from(N).map(async F=>{const B=[];try{if(p.isCancellationRequested)return;if(D.maxResults&&[...M.values()].reduce((G,Q)=>G+Q.cellResults.length,0)>D.maxResults){j=!0;return}const _=[],re=this.g.get(F);if(re)re.apiNotebook.getCells().forEach(Q=>_.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(ee=>ee.items.map(ue=>ue.data.toString()))}));else{const G=await this.s.value.readFile(F),Q=h.$Oe.fromString(G.toString()),ee=await v.deserializeNotebook(Q.buffer,p);if(p.isCancellationRequested)return;c.NotebookData.from(ee).cells.forEach(ne=>_.push({input:ne.source,outputs:ne.outputs.flatMap(De=>De.items.map($e=>$e.valueBytes.toString()))}))}if(p.isCancellationRequested)return;_.forEach((G,Q)=>{const ee=D.contentPattern.pattern,ue=new s.$VYb(G.input,void 0,G.outputs),ne=ue.findInInputs(ee),De=ue.findInOutputs(ee),$e=De.flatMap(K=>(0,f.$eM)(K.matches,K.textBuffer)).map((K,W)=>(K.webviewIndex=W,K));if(ne.length>0||De.length>0){const K={index:Q,contentResults:(0,f.$eM)(ne,ue.inputTextBuffer),webviewResults:$e};B.push(K)}});const U={resource:F,cellResults:B};M.set(F,U);return}catch{return}});return await Promise.all(z),{limitHit:j,results:[...M.values()]}}async z(S,D){const P=await this.s.value.stat(S);if(typeof D?.mtime=="number"&&typeof D.etag=="string"&&D.etag!==E.$El&&typeof P.mtime=="number"&&typeof P.size=="number"&&D.mtime<P.mtime&&D.etag!==E.$Fl({mtime:D.mtime,size:P.size}))throw new E.$ul((0,r.localize)(1,null),E.FileOperationResult.FILE_MODIFIED_SINCE,D)}A(S){return S.scheme===i.Schemas.file?S.fsPath:S.toString()}B(S,D,P){if(this.h.has(D))throw new Error(`editor with id ALREADY EXSIST: ${D}`);const C=new n.$1oc(D,this.d,S,P.visibleRanges.map(c.NotebookRange.to),P.selections.map(c.NotebookRange.to),typeof P.viewColumn=="number"?c.ViewColumn.to(P.viewColumn):void 0);this.h.set(D,C)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const P of S.value.removedDocuments){const C=I.URI.revive(P),p=this.g.get(C);p&&(p.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(p.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===C.toString()&&this.h.delete(v.id)}if(S.value.addedDocuments){const P=[];for(const C of S.value.addedDocuments){const p=I.URI.revive(C.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const v=new m.$Zoc(this.c,this.q,this.r,p,C);P.push(...C.cells.map(N=>m.$Yoc.asModelAddData(N))),this.g.get(p)?.dispose(),this.g.set(p,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:P}),this.m.fire(v.apiNotebook)}}if(S.value.addedEditors)for(const P of S.value.addedEditors){if(this.h.has(P.id))return;const C=I.URI.revive(P.documentUri),p=this.g.get(C);p&&this.B(p,P.id,P)}const D=[];if(S.value.removedEditors)for(const P of S.value.removedEditors){const C=this.h.get(P);C&&(this.h.delete(P),this.k?.id===C.id&&(this.k=void 0),D.push(C))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const P=new Set;this.l.forEach(C=>P.add(C.id));for(const C of this.h.values()){const p=P.has(C.id);C._acceptVisibility(p)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const D=b.$iQ.String.with("notebookType","A notebook type"),P=new b.$kQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[D,new b.$iQ("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>h.$Oe.wrap(p))],new b.$jQ("Notebook Data",p=>c.NotebookData.to(p.value))),C=new b.$kQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[D,new b.$iQ("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new d.$Qw(c.NotebookData.from(p)))],new b.$jQ("Bytes",p=>p.buffer));S.registerApiCommand(P),S.registerApiCommand(C)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$0oc=w}),define(Ee[386],Se([1,0,16,21,55,39,23,43,38]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0,r=We(r),R=We(R),L=We(L);class l{constructor(u,k,b){this.k=u,this.l=k,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&R.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&R.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const k=this.k.folderQueries||[];return new Promise((b,c)=>{const g=d=>{this.f++,u(d)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const m=d.toString(),n=r.$pc(m);this.j&&this.j(m,n)||this.v(g,{base:d,basename:n})}),Promise.all(k.map(d=>this.p(d,g))).then(d=>{b({limitHit:this.e,stats:d[0]||void 0})},d=>{c(new Error((0,A.$qj)(d)))})})}async p(u,k){const b=new h.$xe,c=this.q(u),g=this.r(),d=new $.$7L(this.k,u),m=!d.hasSiblingExcludeClauses();let n;try{this.h.add(b),n=O.$ge.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,b.token),i=n.elapsed(),t=O.$ge.create();return this.g&&!this.e||(o&&o.forEach(s=>{const f=r.$ic.relative(u.folder.path,s.path);if(m){const a=r.$pc(s.path);this.v(k,{base:u.folder,relativePath:f,basename:a});return}this.s(g,u.folder,f,k)}),this.g&&!this.e)?null:(this.u(g,d,k),{providerTime:i,postProcessTime:t.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(u){const k=(0,$.$6L)(this.k.includePattern,u.includePattern),b=(0,$.$6L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:b,includes:k,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},k,b,c){if(b===this.a){const d=r.$pc(this.a);this.v(c,{base:k,relativePath:this.a,basename:d})}function g(d){const m=r.$pc(d),n=r.$oc(d);let o=u[n];o||(o=u[n]=[],g(n)),o.push({base:k,relativePath:d,basename:m})}g(b)}u({rootEntries:u,pathToEntries:k},b,c){const g=this,d=this.a;function m(n){const o=(0,$.$9L)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const s=n[i],{relativePath:f,basename:a}=s;if(b.matchesExcludesSync(f,a,d!==a?o:void 0))continue;const w=k[f];if(w)m(w);else{if(f===d)continue;g.v(c,s)}if(g.e)break}}m(u)}v(u,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(k))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,k,b,c){const g=this.c(u.cacheKey),d=new l(u,k,g&&g.token);let m=0;const n=o=>{m+=o.length,b(o.map(i=>this.d(i)))};return this.e(d,I.a,n,c).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:m,detailStats:o.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new h.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:L.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,k,b,c){const g=c.onCancellationRequested(()=>{u.cancel()}),d=n=>{n&&(m.push(n),k>0&&m.length>=k&&(b(m),m=[]))};let m=[];return u.search(d).then(n=>(m.length&&b(m),g.dispose(),n),n=>(m.length&&b(m),g.dispose(),Promise.reject(n)))}}e.$2oc=I}),define(Ee[387],Se([1,0,19,79,39,110,29,15,16,23,13,18,2,107,261,45,12,46,156,382,38]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0,e.$8M=D,r=We(r),h=We(h),A=We(A),$=We($),I=We(I),b=We(b);let i=class{constructor(C,p,v,N,T){this.a=C,this.b=p,this.c=v,this.d=N,this.e=T}text(C,p,v={}){C=this.f(C,v);const N=this.a.getValue(),T=p&&p.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(p?.map(d.$1i),v),type:o.QueryType.Text,contentPattern:C,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:N.search.usePCRE2||T||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles}}f(C,p){const v=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const N={...C,wordSeparators:v.editor.wordSeparators};return this.j(C,p)&&(N.isCaseSensitive=!0),this.k(C)&&(N.isMultiline=!0),p.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=p.notebookSearchConfig.includeMarkupInput),p.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=p.notebookSearchConfig.includeMarkupPreview),p.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=p.notebookSearchConfig.includeCodeInput),p.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=p.notebookSearchConfig.includeOutput),N}file(C,p={}){return{...this.h(C,p),type:o.QueryType.File,filePattern:p.filePattern?p.filePattern.trim():p.filePattern,exists:p.exists,sortByScore:p.sortByScore,cacheKey:p.cacheKey,shouldGlobMatchFilePattern:p.shouldGlobSearch}}g(C,p){return C?(C=Array.isArray(C)?C.map(w):w(C),p?this.parseSearchPaths(C):{pattern:s(...Array.isArray(C)?C:[C])}):{}}h(C=[],p={}){const v=this.g(p.includePattern,p.expandPatterns),N=this.g(p.excludePattern,p.expandPatterns),T=C.length>1,M=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(F=>this.q(F,p,N)):C.map(F=>this.r(F,p,N,T))).filter(F=>!!F),j={_reason:p._reason,folderQueries:M,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:p.extraFileResources,excludePattern:N.pattern,includePattern:v.pattern,onlyOpenEditors:p.onlyOpenEditors,maxResults:p.maxResults};if(p.onlyOpenEditors){const F=r.$Jb(this.c.groups.flatMap(re=>re.editors.map(U=>U.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const B=F.filter(re=>(0,o.$WL)(j,re.fsPath)),_=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(_)),{...j,..._}}const z=p.extraFileResources&&p.extraFileResources.filter(F=>(0,o.$WL)(j,F.fsPath));return j.extraFileResources=z&&z.length?z:void 0,j}i(C){const p=[],v=new L.$Cc,N={};let T=!1;return C.forEach(M=>{if(M.scheme===O.Schemas.walkThrough)return;if((0,l.$kh)(M)){const z=this.b.getWorkspaceFolder(M)?.uri??M.with({path:$.$oc(M.fsPath)});let F=v.get(z);F||(T=!0,F={folder:z,includePattern:{}},p.push(F),v.set(z,F));const B=$.$nc(z.fsPath,M.fsPath);(0,E.$qg)(F.includePattern)[B.replace(/\\/g,"/")]=!0}else M.fsPath&&(T=!0,N[M.fsPath]=!0)}),{folderQueries:p,includePattern:N,usingSearchPaths:!0,excludePattern:T?void 0:{"**/*":!0}}}j(C,p){if(p.isSmartCase){if(C.isRegExp){if(I.$9f(C.pattern,!0))return!0}else if(I.$9f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,k.$$C)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const p=_=>$.$kc(_)||/^\.\.?([\/\\]|$)/.test(_),N=(Array.isArray(C)?C:f(C)).map(_=>{const re=this.e.resolvedUserHome;return re?(0,R.$Vw)(_,re.scheme===O.Schemas.file?re.fsPath:re.path):_}),T=h.$K(N,_=>p(_)?"searchPaths":"exprSegments"),M=(T.exprSegments||[]).map(_=>I.$of(_,"/")).map(_=>I.$of(_,"\\")).map(_=>(_[0]==="."&&(_="*"+_),a(_))),j={},z=this.m(T.searchPaths||[]);z&&z.length&&(j.searchPaths=z);const F=M.flat(),B=s(...F);return B&&(j.pattern=B),j}l(C,p){return p.disregardExcludeSettings?void 0:(0,o.$VL)(C,!p.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const p=C.flatMap(N=>{let{pathPortion:T,globPortion:M}=t(N);return M&&(M=y(M)),this.n(T).flatMap(z=>this.o(z,M))}),v=new Map;return p.forEach(N=>{const T=N.searchPath.toString(),M=v.get(T);M?N.pattern&&(M.pattern=M.pattern||{},M.pattern[N.pattern]=!0):v.set(T,{searchPath:N.searchPath,pattern:N.pattern?s(N.pattern):void 0})}),Array.from(v.values())}n(C){if($.$kc(C)){const p=this.b.getWorkspace().folders;return p[0]&&p[0].uri.scheme!==O.Schemas.file?[{searchPath:p[0].uri.with({path:C})}]:[{searchPath:u.URI.file($.$jc(C))}]}if(this.b.getWorkbenchState()===d.WorkbenchState.FOLDER){const p=this.b.getWorkspace().folders[0].uri;if(C=w(C),C.startsWith("../")||C===".."){const N=$.$ic.resolve(p.path,C);return[{searchPath:p.with({path:N})}]}const v=y(C);return[{searchPath:p,pattern:v}]}else{if(C==="./"||C===".\\")return[];{const p=C.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(T=>{const M=p.match(new RegExp(`^${I.$if(T.name)}(?:/(.*)|$)`));return M?{match:M,folder:T}:null}).filter(E.$ng);if(N.length)return N.map(T=>{const M=T.match[1];return{searchPath:T.folder.uri,pattern:M&&y(M)}});{const T=C.match(/\.[\/\\](.+)[\/\\]?/),M=T?T[1]:C,j=b.localize(0,null,M);throw new Error(j)}}}}o(C,p){const v=C.pattern&&p?`${C.pattern}/${p}`:C.pattern||p,N=[{searchPath:C.searchPath,pattern:v}];return v&&!v.endsWith("**")&&N.push({searchPath:C.searchPath,pattern:v+"/**"}),N}q(C,p,v){const N=this.r((0,d.$1i)(C.searchPath),p,v,!1);return N?{...N,includePattern:C.pattern}:null}r(C,p,v,N){let T;const M=u.URI.isUri(C)?C:C.uri;if(v.searchPaths){const _=v.searchPaths.filter(re=>(0,l.$_g)(re.searchPath,M))[0];if(_&&!_.pattern)return null;_&&(T=_.pattern)}const j=this.a.getValue({resource:M}),F={...this.l(j,p)||{},...T||{}},B=u.URI.isUri(C)?(0,l.$dh)(C):C.name;return{folder:M,folderName:N?B:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof p.disregardIgnoreFiles=="boolean"?p.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof p.disregardGlobalIgnoreFiles=="boolean"?p.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof p.disregardParentIgnoreFiles=="boolean"?p.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof p.ignoreSymlinks=="boolean"?p.ignoreSymlinks:!j.search.followSymlinks}}};e.$7M=i,e.$7M=i=Je([Ve(0,c.$_i),Ve(1,d.$Oi),Ve(2,m.$gE),Ve(3,g.$_j),Ve(4,n.$5M)],i);function t(P){const C=P.match(/[\*\{\}\(\)\[\]\?]/);if(C){const p=C.index,v=P.substr(0,p).match(/[/|\\][^/\\]*$/);if(v){let N=P.substr(0,v.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:P.substr((v.index||0)+1)}}}return{pathPortion:P}}function s(...P){return P.length?P.reduce((C,p)=>(C[p]=!0,C),Object.create(null)):void 0}function f(P){return A.$xk(P,",").map(C=>C.trim()).filter(C=>!!C.length)}function a(P){return[`**/${P}/**`,`**/${P}`].map(p=>p.replace(/\*\*\/\*\*/g,"**"))}function w(P){return P.replace(/\\/g,"/")}function y(P){return w(P).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(P){return P.replace(/([?*[\]])/g,"[$1]")}function D(P,C){P=r.$Ob(P,N=>N.toString());const p=[],v=C.getWorkspace();return P&&P.forEach(N=>{let T;if(C.getWorkbenchState()===d.WorkbenchState.FOLDER)T=(0,l.$ih)(v.folders[0].uri,N),T&&T!=="."&&(T="./"+T);else{const M=C.getWorkspaceFolder(N);if(M){const j=M.name;if(v.folders.filter(F=>F.name===j).length===1){const F=(0,l.$ih)(M.uri,N);F===""?T=`./${M.name}`:T=`./${M.name}/${F}`}else T=N.fsPath}}T&&p.push(S(T))}),p}}),define(Ee[388],Se([1,0,23,2,21,14,5,387,38,46,9]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=u,e.$Gxb=c,r=We(r),R=We(R);const E=7e3;function u(g,d){const m=d.activationEvents;if(!m)return Promise.resolve(void 0);const n=[],o=[];for(const w of m)if(/^workspaceContains:/.test(w)){const y=w.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||g.forceUsingSearch?o.push(y):n.push(y)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,I.$yh)(),s=w=>t({activationEvent:w}),f=Promise.all(n.map(w=>k(g,w,s))).then(()=>{}),a=b(g,d.identifier,o,s);return Promise.all([f,a]).then(()=>{t(void 0)}),i}async function k(g,d,m){for(const n of g.folders)if(await g.exists(r.$gh(h.URI.revive(n),d))){m(`workspaceContains:${d}`);return}}async function b(g,d,m,n){if(m.length===0)return Promise.resolve(void 0);const o=new A.$xe,i=g.checkExists(g.folders,m,o.token),t=setTimeout(async()=>{o.cancel(),g.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${m.join(",")}`)},E);let s=!1;try{s=await i}catch(f){R.$6(f)||R.$3(f)}o.dispose(),clearTimeout(t),s&&n(`workspaceContains:${m.join(",")}`)}function c(g,d,m,n){const o=g.get(L.$Ei),i=g.get($.$NL),s=o.createInstance(O.$7M).file(d.map(f=>(0,l.$1i)(h.URI.revive(f))),{_reason:"checkExists",includePattern:m,exists:!0});return i.fileSearch(s,n).then(f=>!!f.limitHit,f=>R.$6(f)?!1:Promise.reject(f))}}),define(Ee[52],Se([1,0,234,16,62,23,9,3,85,2,12,6,42,320,126,48,26,158,14,24,22,298,10,72,5,30,98,20,115,77,47,129,4,388,125,300,15,123,43,11,124]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a,w,y,S,D,P,C,p,v,N,T,M,j,z,F,B){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=e.$Boc=e.$Aoc=e.$zoc=e.$yoc=void 0,r=We(r),h=We(h),A=We(A),m=We(m),e.$yoc=(0,f.$Fi)("IHostUtils");let re=_=class extends O.$Wc{constructor(K,W,se,oe,te,le,he,X,ae,pe,be,Fe,Be){super(),this.Y=Fe,this.Z=Be,this.a=this.B(new p.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=W,this.g=se,this.f=he,this.j=oe,this.m=te,this.s=le,this.t=ae,this.u=pe,this.w=be,this.y=this.g.getProxy(E.$qN.MainThreadWorkspace),this.z=this.g.getProxy(E.$qN.MainThreadTelemetry),this.C=this.g.getProxy(E.$qN.MainThreadExtensionService),this.D=new L.$Eh,this.F=new L.$Eh,this.G=new L.$Eh,this.H=new L.$Eh,this.I=new De(this.f.extensions.activationEvents),this.L=new d.$5bc(this.I,this.f.extensions.allExtensions);const ke=new n.$rn(this.f.extensions.myExtensions);this.J=new d.$5bc(this.I,ue(this.L,ke)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new b.$hoc(this.g,this.s),this.N=new N.$roc(this.g),this.O=X,this.h=K.createChild(new S.$Di([b.$ioc,this.M],[N.$soc,this.N])),this.P=this.B(new k.$goc(this.J,this.L,{onExtensionActivationError:(Ie,Oe,q)=>{this.C.$onExtensionActivationError(Ie,m.$5(Oe),q)},actualActivateExtension:async(Ie,Oe)=>{if(d.$5bc.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Oe),new k.$foc;const q=this.J.getExtensionDescription(Ie);return this.fb(q,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),A.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(K){m.$3(K)}}async $(){this.O.onWillDeactivateAll();let K=[];try{K=this.J.getAllExtensionDescriptions().map(te=>te.identifier).filter(te=>this.isActivated(te)).map(te=>this.eb(te))}catch{}await Promise.all(K)}terminate(K,W=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${K}`),this.s.flush(),this.u.dispose(),this.P.dispose(),m.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const se=this.$();Promise.race([(0,L.$Gh)(5e3),se]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(K){return this.G.isOpen()?this.P.isActivated(K):!1}async getExtension(K){const W=await this.C.$getExtension(K);return W&&{...W,identifier:new n.$qn(W.identifier.value),extensionLocation:l.URI.revive(W.extensionLocation)}}ab(K,W){return this.P.activateByEvent(K,W)}bb(K,W){return this.P.activateById(K,W)}activateByIdWithErrors(K,W){return this.bb(K,W).then(()=>{const se=this.P.getActivatedExtension(K);if(se.activationFailed)return Promise.reject(se.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(K=>this.J)}getExtensionExports(K){if(this.G.isOpen())return this.P.getActivatedExtension(K).exports;try{return this.P.getActivatedExtension(K).exports}catch{return null}}async cb(K){if(K.scheme===M.Schemas.file&&this.c.fsRealpath){const W=K.fsPath;this.R.has(W)||this.R.set(W,this.c.fsRealpath(W));const se=await this.R.get(W);return l.URI.file(se)}return K}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(K=>new ne(K))),this.Q}async db(K){const W=$.$Li.forUris(se=>R.$0g.ignorePathCasing(se));return await Promise.all(K.map(async se=>{if(this.wb(se)){const oe=await this.cb(se.extensionLocation);W.set(oe,se)}})),W}eb(K){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(K))return W;const se=this.P.getActivatedExtension(K);if(!se)return W;try{typeof se.module.deactivate=="function"&&(W=Promise.resolve(se.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${K.value}':`),this.s.error(oe)}try{(0,O.$Rc)(se.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${K.value}':`),this.s.error(oe)}return W}async fb(K,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(K.identifier):await this.C.$onWillActivateExtension(K.identifier),this.hb(K,W).then(se=>{const oe=se.activationTimes;return this.C.$onDidActivateExtension(K.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,W),this.gb(K,W,"success",oe),se},se=>{throw this.gb(K,W,"failure"),se})}gb(K,W,se,oe){const te=G(K,W);this.z.$publicLog2("extensionActivationTimes",{...te,...oe||{},outcome:se})}hb(K,W){const se=G(K,W);this.z.$publicLog2("activatePlugin",se);const oe=this.wb(K);if(!oe)return Promise.resolve(new k.$eoc(k.$boc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${K.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${K.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const te=new k.$coc(W.startup);return Promise.all([this.xb(K,(0,R.$gh)(K.extensionLocation,oe),te),this.ib(K)]).then(le=>(A.mark(`code/extHost/willActivateExtension/${K.identifier.value}`),_.jb(this.s,K.identifier,le[0],le[1],te))).then(le=>(A.mark(`code/extHost/didActivateExtension/${K.identifier.value}`),le))}ib(K){const W=this.Z.createLanguageModelAccessInformation(K),se=new i.$koc(K,this.M),oe=new i.$joc(K.identifier.value,!1,this.M),te=new T.$toc(K,this.N),le=K.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${K.identifier.value}`),Promise.all([se.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const X=this;let ae,pe;const be=(0,g.$4G)(K,"ipc")?this.f.messagePorts?.get(n.$qn.toKey(K.identifier)):void 0;return Object.freeze({globalState:se,workspaceState:oe,secrets:te,subscriptions:[],get languageModelAccessInformation(){return W},get extensionUri(){return K.extensionLocation},get extensionPath(){return K.extensionLocation.fsPath},asAbsolutePath(Fe){return h.$lc(K.extensionLocation.fsPath,Fe)},get storagePath(){return X.O.workspaceValue(K)?.fsPath},get globalStoragePath(){return X.O.globalValue(K).fsPath},get logPath(){return h.$lc(X.f.logsLocation.fsPath,K.identifier.value)},get logUri(){return l.URI.joinPath(X.f.logsLocation,K.identifier.value)},get storageUri(){return X.O.workspaceValue(K)},get globalStorageUri(){return X.O.globalValue(K)},get extensionMode(){return le},get extension(){return ae===void 0&&(ae=new ee(X,K.identifier,K,he,!1)),ae},get extensionRuntime(){return(0,g.$5G)(K,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(K)},get messagePassingProtocol(){if(!pe){if(!be)return;const Fe=p.Event.buffer(p.Event.fromDOMEventEmitter(be,"message",Be=>Be.data));be.start(),pe={onDidReceiveMessage:Fe,postMessage:be.postMessage.bind(be)}}return pe}})})}static jb(K,W,se,oe,te){return se=se||{activate:void 0,deactivate:void 0},this.kb(K,W,se,oe,te).then(le=>new k.$doc(!1,null,te.build(),se,le,oe.subscriptions))}static kb(K,W,se,oe,te){if(typeof se.activate=="function")try{te.activateCallStart(),K.trace(`ExtensionService#_callActivateOptional ${W.value}`);const le=typeof global=="object"?global:self,he=se.activate.apply(le,[oe]);return te.activateCallStop(),te.activateResolveStart(),Promise.resolve(he).then(X=>(te.activateResolveStop(),X))}catch(le){return Promise.reject(le)}else return Promise.resolve(se)}lb(K,W){this.bb(K.identifier,{startup:!1,extensionId:K.identifier,activationEvent:W}).then(void 0,se=>{this.s.error(se)})}mb(K,W=0){const oe=Date.now();(0,F.$B)(()=>{for(let te=W;te<K.length;te+=1){const le=K[te];for(const he of le.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-oe>50){this.mb(K,te);break}else this.lb(le,he)}})}nb(){this.C.$setPerformanceMarks(A.getMarks()),this.m.getConfigProvider().then(K=>{const W=K.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),se=this.J.getAllExtensionDescriptions();if(W)this.mb(se);else for(const oe of se)if(oe.activationEvents)for(const te of oe.activationEvents)te==="onStartupFinished"&&this.lb(oe,te)})}ob(){const K=this.ab("*",!0).then(void 0,le=>{this.s.error(le)});this.B(this.j.onDidChangeWorkspace(le=>this.pb(le.added)));const W=this.j.workspace?this.j.workspace.folders:[],se=this.pb(W),oe=this.rb(),te=Promise.all([oe,K,se]).then(()=>{});return Promise.race([te,(0,L.$Gh)(1e4)]).then(()=>{this.nb()}),te}pb(K){return K.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.qb(K,W))).then(()=>{})}async qb(K,W){if(this.isActivated(W.identifier))return;const se=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:K.map(le=>le.uri),forceUsingSearch:se||!this.c.fsExists,exists:le=>this.c.fsExists(le.fsPath),checkExists:(le,he,X)=>this.y.$checkExists(le,he,X)},te=await(0,v.$Fxb)(oe,W);if(te)return this.bb(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:te.activationEvent}).then(void 0,le=>this.s.error(le))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(K){throw console.error(K),K}}async sb(){const{extensionDevelopmentLocationURI:K,extensionTestsLocationURI:W}=this.f.environment;if(!K||!W)throw new Error(r.localize(0,null));const se=await this.xb(null,W,new k.$coc(!1));if(!se||typeof se.run!="function")throw new Error(r.localize(1,null,W.toString()));return new Promise((oe,te)=>{const le=(ae,pe)=>{ae?(F.$t&&this.s.error("Test runner called back with error",ae),te(ae)):(F.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof pe=="number"&&pe>0?1:0))},he=(0,R.$7g)(W),X=se.run(he,le);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),oe(0)}).catch(ae=>{F.$t&&this.s.error("Test runner finished with error",ae),te(ae instanceof Error&&ae.stack?ae.stack:String(ae))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(K,W){return this.S[K]=W,(0,O.$Uc)(()=>{delete this.S[K]})}async getRemoteExecServer(K){const{resolver:W}=await this.ub(K);return W?.resolveExecServer?.(K,{resolveAttempt:0})}async ub(K){const W=K.indexOf("+");if(W===-1)throw new t.$yN("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const se=K.substr(0,W);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${se}`,!1),{authorityPrefix:se,resolver:this.S[se]}}async $resolveAuthority(K,W){const se=z.$ge.create(!1),oe=()=>`[resolveAuthority(${(0,s.$Ul)(K)},${W})][${se.elapsed()}ms] `,te=V=>this.s.info(`${oe()}${V}`),le=V=>this.s.warn(`${oe()}${V}`),he=(V,J=void 0)=>this.s.error(`${oe()}${V}`,J),X=V=>{if(V instanceof t.$yN)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},ae=async V=>{te(`activating resolver for ${V}...`);const{resolver:J,authorityPrefix:x}=await this.ub(V);if(!J)throw he(`no resolver for ${x}`),new t.$yN(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:J,authorityPrefix:x,remoteAuthority:V}},pe=K.split(/@|%40/g).reverse();te(`activating remote resolvers ${pe.join(" -> ")}`);let be;try{be=await Promise.all(pe.map(ae)).catch(async V=>{if(!(V instanceof t.$yN)||V._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return le(`resolving nested authorities failed: ${V.message}`),[await ae(K)]})}catch(V){return X(V)}const Fe=new L.$Qh;Fe.cancelAndSet(()=>te("waiting..."),1e3);let Be,ke;for(const[V,{authorityPrefix:J,resolver:x,remoteAuthority:fe}]of be.entries())try{if(V===be.length-1)te("invoking final resolve()..."),A.mark(`code/extHost/willResolveAuthority/${J}`),Be=await x.resolve(fe,{resolveAttempt:W,execServer:ke}),A.mark(`code/extHost/didResolveAuthorityOK/${J}`),te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,t.$xN.isManagedResolvedAuthority(Be)?Be:void 0));else{if(te(`invoking resolveExecServer() for ${fe}`),A.mark(`code/extHost/willResolveExecServer/${J}`),ke=await x.resolveExecServer?.(fe,{resolveAttempt:W,execServer:ke}),!ke)throw new t.$yN(`Exec server was not available for ${fe}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);A.mark(`code/extHost/didResolveExecServerOK/${J}`)}}catch(we){return A.mark(`code/extHost/didResolveAuthorityError/${J}`),he("returned an error",we),Fe.dispose(),X(we)}Fe.dispose();const Ie={environmentTunnels:Be.environmentTunnels,features:Be.tunnelFeatures?{elevation:Be.tunnelFeatures.elevation,privacyOptions:Be.tunnelFeatures.privacyOptions,protocol:Be.tunnelFeatures.protocol===void 0?!0:Be.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Be.extensionHostEnv,isTrusted:Be.isTrusted,authenticationSession:Be.authenticationSessionForInitializingExtensions?{id:Be.authenticationSessionForInitializingExtensions.id,providerId:Be.authenticationSessionForInitializingExtensions.providerId}:void 0};te(`returned ${t.$xN.isManagedResolvedAuthority(Be)?"managed authority":`${Be.host}:${Be.port}`}`);let q;if(t.$xN.isManagedResolvedAuthority(Be)){const V=W;this.Y.setFactory(V,Be.makeConnection),q={authority:K,connectTo:new s.$Rl(V),connectionToken:Be.connectionToken}}else q={authority:K,connectTo:new s.$Sl(Be.host,Be.port),connectionToken:Be.connectionToken};return{type:"ok",value:{authority:q,options:Oe,tunnelInformation:Ie}}}async $getCanonicalURI(K,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Ul)(K)})`);const{resolver:se}=await this.ub(K);if(!se)return null;const oe=l.URI.revive(W);if(typeof se.getCanonicalURI>"u")return oe;const te=await(0,L.$xh)(()=>se.getCanonicalURI(oe));return te||oe}async $startExtensionHost(K){K.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,K),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.tb()}$activateByEvent(K,W){return W===g.ActivationKind.Immediate?this.D.wait().then(se=>this.ab(K,!1)):this.G.wait().then(se=>this.ab(K,!1))}async $activate(K,W){return await this.G.wait(),this.J.getExtensionDescription(K)?(await this.bb(K,W),!0):!1}async $deltaExtensions(K){K.toAdd.forEach(le=>le.extensionLocation=l.URI.revive(le.extensionLocation));const{globalRegistry:W,myExtensions:se}=U(this.I,this.L,this.J,K),oe=await this.db(se);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(W.getAllExtensionDescriptions()),this.J.set(se),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(K){return K}async $test_up(K){return K.byteLength}async $test_down(K){const W=o.$Oe.alloc(K),se=Math.random()%256;for(let oe=0;oe<K;oe++)W.writeUInt8(se,oe);return W}async $updateRemoteConnectionData(K){this.X=K,this.a.fire()}};e.$zoc=re,e.$zoc=re=_=Je([Ve(0,f.$Ei),Ve(1,e.$yoc),Ve(2,y.$WP),Ve(3,c.$Wnc),Ve(4,u.$Znc),Ve(5,I.$_j),Ve(6,a.$aQ),Ve(7,w.$3nc),Ve(8,D.$mFb),Ve(9,P.$loc),Ve(10,j.$voc),Ve(11,B.$woc),Ve(12,C.$poc)],re);function U($e,K,W,se){$e.addActivationEvents(se.addActivationEvents);const oe=new d.$5bc($e,K.getAllExtensionDescriptions());oe.deltaExtensions(se.toAdd,se.toRemove);const te=new n.$rn(W.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of se.myToRemove)te.delete(he);for(const he of se.myToAdd)te.add(he);const le=ue(oe,te);return{globalRegistry:oe,myExtensions:le}}function G($e,K){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:K.activationEvent,reasonId:K.extensionId.value}}function Q($e){return $e.getAllExtensionDescriptions().map(K=>K.identifier.value).join(",")}e.$Aoc=(0,f.$Fi)("IExtHostExtensionService");class ee{#e;#t;#i;constructor(K,W,se,oe,te){this.#e=K,this.#t=W,this.#i=se.identifier,this.id=se.identifier.value,this.extensionUri=se.extensionLocation,this.extensionPath=h.$jc((0,R.$7g)(se.extensionLocation)),this.packageJSON=se,this.extensionKind=oe,this.isFromDifferentExtensionHost=te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Boc=ee;function ue($e,K){return $e.getAllExtensionDescriptions().filter(W=>K.has(W.identifier))}class ne{constructor(K){this.a=K}setSearchTree(K){this.a=K}findSubstr(K){return this.a.findSubstr(K)}forEach(K){return this.a.forEach(K)}}e.$Coc=ne;class De{constructor(K){this.a=new n.$sn,this.addActivationEvents(K)}readActivationEvents(K){return this.a.get(K.identifier)??[]}addActivationEvents(K){for(const W of Object.keys(K))this.a.set(W,K[W])}}}),define(Ee[389],Se([1,0,62,2,6,42,26,24,20,30,5,52,12,13]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,r=We(r);let c=class{constructor(o,i,t,s,f,a,w){this.c=o,this.d=i,this.e=t,this.f=s,this.g=f,this.h=a,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),r.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new d(this.c,i,this.d,o,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,i,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const i of o.nodeModuleName)this.a.set(i,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(i=>o.alternativeModuleName(i))}};e.$Mpc=c,e.$Mpc=c=Je([Ve(2,I.$Ei),Ve(3,R.$Znc),Ve(4,E.$Aoc),Ve(5,l.$aQ),Ve(6,u.$_j)],c);let g=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&b.a.size){const i=(0,k.$if)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",s=`@${t}+\\/${t}+|${t}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${f}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const i=this.b.exec(this.c(o));if(!i)return;const[,t,s,f]=i,a=b.a.get(s);if(a!==void 0)return console.warn(`${s} as been renamed to ${a}, please update your imports`),t+a+f}c(o){return o.replace(/\\/g,"/")}};g=b=Je([Ve(0,l.$aQ)],g);class d{constructor(o,i,t,s,f){this.c=o,this.d=i,this.e=t,this.f=s,this.g=f,this.nodeModuleName="vscode",this.a=new O.$sn}load(o,i){const t=this.d.findSubstr(i);if(t){let s=this.a.get(t.identifier);return s||(s=this.c(t,this.e,this.f),this.a.set(t.identifier,s)),s}if(!this.b){let s="";this.d.forEach((f,a)=>s+=`	${a} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${s}`),this.b=this.c(L.$YG,this.e,this.f)}return this.b}}let m=class{constructor(o,i,t){this.e=o,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(A.$qN.MainThreadTelemetry);const s=t.getProxy(A.$qN.MainThreadWindow);this.c=(f,a)=>{const w=h.URI.parse(f);return a?this.g(f,a):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,f,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,f,{}):this.g(f,a)}}load(o,i,t){const s=this.e.findSubstr(i);return s&&(this.a=s.identifier.value,this.h()),this.b=t(o),this.c}g(o,i){return this.i(),this.b(o,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=Je([Ve(2,$.$WP)],m)}),define(Ee[65],Se([1,0,49,3,16,56,5,64,78,52,10,48,317,42]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=e.$Doc=void 0,A=We(A),R=We(R),e.$Doc=(0,L.$Fi)("IExtHostVariableResolverProvider");class b extends u.$1Q{constructor(d,m,n,o,i,t,s){function f(){if(n){const a=n.activeEditor();if(a)return a.document.uri;const w=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof I.$eP||w.input instanceof I.$jP)return w.input.modified;if(w.input instanceof I.$dP||w.input instanceof I.$iP||w.input instanceof I.$gP)return w.input.uri}}}super({getFolderUri:a=>{const w=t.folders.filter(y=>y.name===a);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,w)=>i.getConfiguration(void 0,a).get(w),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=f();if(a)return A.$jc(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const a=f();if(a){const w=m.getWorkspaceFolder(a);if(w)return A.$jc(w.uri.fsPath)}}},getSelectedText:()=>{if(n){const a=n.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(n){const a=n.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>d.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let c=class extends h.$Wc{constructor(d,m,n,o,i){super(),this.b=d,this.c=m,this.g=n,this.h=o,this.j=i,this.a=new r.$X(async()=>{const t=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,t,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$Eoc=c,e.$Eoc=c=Je([Ve(0,l.$Aoc),Ve(1,E.$Wnc),Ve(2,O.$8P),Ve(3,k.$Znc),Ve(4,$.$_nc)],c)}),define(Ee[102],Se([1,0,9,4,2,3,24,5,6,78,52,20,10,48,153,120,308,42,65,50,35,17,19,99]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=e.$Moc=e.$Loc=e.$Koc=void 0,i=We(i),e.$Koc=(0,O.$Fi)("IExtHostDebugService");let f=class extends R.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(C,p,v,N,T,M,j,z){super(),this.Y=p,this.Z=v,this.$=N,this.ab=T,this.bb=M,this.cb=j,this.db=z,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new h.$me),this.z=this.B(new h.$me),this.C=this.B(new h.$me),this.F=this.B(new h.$me),this.u=C.getProxy($.$qN.MainThreadDebugService),this.I=this.B(new h.$me),this.L=this.B(new h.$me),this.G=new w(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(B=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(C,p){const v=this.gb(p);if(!v)return;const N=await this.Q.get(C)?.getTreeItem?.(v);return N?this.eb(C,N):void 0}registerDebugVisualizationTree(C,p,v){const N=L.$qn.toKey(C.identifier),T=this.ub(N,p);if(this.P.has(T))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.Q.set(T,v),this.u.$registerDebugVisualizerTree(T,!!v.editItem),(0,R.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(T),this.Q.delete(p)})}async $getVisualizerTreeItemChildren(C,p){const v=this.S.get(p)?.item;return v?(await this.Q.get(C)?.getChildren?.(v))?.map(T=>this.eb(C,T))||[]:[]}async $editVisualizerTreeItem(C,p){const v=this.S.get(C);if(!v)return;const N=await this.Q.get(v.provider)?.editItem?.(v.item,p);return this.eb(v.provider,N||v.item)}$disposeVisualizedTree(C){const p=this.S.get(C);if(!p)return;const v=[p.children];for(const N of v)if(N)for(const T of N)v.push(this.S.get(T)?.children),this.S.delete(T)}eb(C,p){let v=this.R.get(p);return v||(v=this.O++,this.R.set(p,v),this.S.set(v,{provider:C,item:p})),i.DebugTreeItem.from(p,v)}asDebugSourceUri(C,p){const v=C;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let N=`debug:${encodeURIComponent(v.path||"")}`,T="?";return p&&(N+=`${T}session=${encodeURIComponent(p.id)}`,T="&"),N+=`${T}ref=${v.sourceReference}`,A.URI.parse(N)}else{if(v.path)return A.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(C){const p=[];for(const v of C.getAllExtensionDescriptions())if(v.contributes){const N=v.contributes.debuggers;if(N&&N.length>0)for(const T of N)(0,g.$UH)(T)&&p.push(T.type)}this.u.$registerDebugTypes(p)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const C=[];return this.H.forEach(p=>C.push(p)),C}async $resolveDebugVisualizer(C,p){const v=this.W.get(C);if(!v)throw new Error(`No debug visualizer found with id '${C}'`);let{v:N,provider:T,extensionId:M}=v;if(N.visualization||(N=await T.resolveDebugVisualization?.(N,p)||N,v.v=N),!N.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${T}'`);return this.vb(M,N.visualization)}async $executeDebugVisualizerCommand(C){const p=this.W.get(C);if(!p)throw new Error(`No debug visualizer found with id '${C}'`);const v=p.v.visualization;v&&"command"in v&&this.cb.executeCommand(v.command,...v.arguments||[])}gb(C){const p=this.w.get(C.sessionId);return p&&{session:p.api,variable:C.variable,containerId:C.containerId,frameId:C.frameId,threadId:C.threadId}}async $provideDebugVisualizers(C,p,v,N){const T=this.gb(v),M=this.ub(C,p),j=this.P.get(M);if(!T||!j)return[];const z=await j.provideDebugVisualization(T,N);return z?z.map(F=>{const B=++this.X;this.W.set(B,{v:F,provider:j,extensionId:C});const _=F.iconPath?this.wb(F.iconPath):void 0;return{id:B,name:F.name,iconClass:_?.iconClass,iconPath:_?.iconPath,visualization:this.vb(C,F.visualization)}}):[]}$disposeDebugVisualizers(C){for(const p of C)this.W.delete(p)}registerDebugVisualizationProvider(C,p,v){if(!C.contributes?.debugVisualizers?.some(M=>M.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const N=L.$qn.toKey(C.identifier),T=this.ub(N,p);if(this.P.has(T))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.P.set(T,v),this.u.$registerDebugVisualizer(N,p),(0,R.$Uc)(()=>{this.u.$unregisterDebugVisualizer(N,p),this.P.delete(p)})}addBreakpoints(C){const p=C.filter(T=>{const M=T.id;return this.H.has(M)?!1:(this.H.set(M,T),!0)});this.rb(p,[],[]);const v=[],N=new Map;for(const T of p)if(T instanceof u.$uO){let M=N.get(T.location.uri.toString());M||(M={type:"sourceMulti",uri:T.location.uri,lines:[]},N.set(T.location.uri.toString(),M),v.push(M)),M.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character,mode:T.mode})}else T instanceof u.$vO&&v.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName,mode:T.mode});return this.u.$registerBreakpoints(v)}removeBreakpoints(C){const p=C.filter(M=>this.H.delete(M.id));this.rb([],p,[]);const v=p.filter(M=>M instanceof u.$uO).map(M=>M.id),N=p.filter(M=>M instanceof u.$vO).map(M=>M.id),T=p.filter(M=>M instanceof u.$wO).map(M=>M.id);return this.u.$unregisterBreakpoints(v,N,T)}startDebugging(C,p,v){const N=v.testRun&&this.db.getMetadataForRun(v.testRun);return this.u.$startDebugging(C?C.uri:void 0,p,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,testRun:N&&{runId:N.runId,taskId:N.taskId},suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(C){return this.u.$stopDebugging(C?C.id:void 0)}registerDebugConfigurationProvider(C,p,v){if(!p)return new u.$sN(()=>{});const N=this.f++;return this.g.push({type:C,handle:N,provider:p}),this.u.$registerDebugConfigurationProvider(C,v,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,N),new u.$sN(()=>{this.g=this.g.filter(T=>T.provider!==p),this.u.$unregisterDebugConfigurationProvider(N)})}registerDebugAdapterDescriptorFactory(C,p,v){if(!v)return new u.$sN(()=>{});if(!this.nb(C,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.kb(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const N=this.h++;return this.j.push({type:p,handle:N,factory:v}),this.u.$registerDebugAdapterDescriptorFactory(p,N),new u.$sN(()=>{this.j=this.j.filter(T=>T.factory!==v),this.u.$unregisterDebugAdapterDescriptorFactory(N)})}registerDebugAdapterTrackerFactory(C,p){if(!p)return new u.$sN(()=>{});const v=this.m++;return this.n.push({type:C,handle:v,factory:p}),new u.$sN(()=>{this.n=this.n.filter(N=>N.factory!==p)})}async $runInTerminal(C,p){return Promise.resolve(void 0)}async $substituteVariables(C,p){let v;const N=await this.tb(C);return N&&(v={uri:N.uri,name:N.name,index:N.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(v,p)}hb(C,p){if(C.type==="implementation")return new S(C.implementation)}ib(){}async $startDASession(C,p){const v=this,N=await this.sb(p);return this.pb(this.kb(N.type),N).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}' (extension might have failed to activate)`);const M=this.jb(T),j=this.hb(M,N);if(!j)throw new Error(`Couldn't create a debug adapter for type '${N.type}'.`);const z=j;return this.M.set(C,z),this.ob(N).then(F=>(F&&this.N.set(C,F),z.onMessage(async B=>{if(B.type==="request"&&B.command==="handshake"){const _=B,re={type:"response",seq:0,command:_.command,request_seq:_.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const U=await this.U.sign(_.arguments.value);re.body={signature:U},z.sendResponse(re)}else throw new Error("no signer")}catch(U){re.success=!1,re.message=U.message,z.sendResponse(re)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(B),B=(0,g.$ZH)(B,!0),v.u.$acceptDAMessage(C,B)}),z.onError(B=>{F&&F.onError&&F.onError(B),this.u.$acceptDAError(C,B.name,B.message,B.stack)}),z.onExit(B=>{F&&F.onExit&&F.onExit(B??void 0,void 0),this.u.$acceptDAExit(C,B??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),z.startSession()))})}$sendDAMessage(C,p){p=(0,g.$YH)(p,!1);const v=this.N.get(C);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(p),this.M.get(C)?.sendMessage(p)}$stopDASession(C){const p=this.N.get(C);this.N.delete(C),p&&p.onWillStopSession&&p.onWillStopSession();const v=this.M.get(C);return this.M.delete(C),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(C){const p=[],v=[],N=[];if(C.added)for(const T of C.added){const M=T.id;if(M&&!this.H.has(M)){let j;if(T.type==="function")j=new u.$vO(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage,T.mode);else if(T.type==="data")j=new u.$wO(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage,T.mode);else{const z=A.URI.revive(T.uri);j=new u.$uO(new u.$EN(z,new u.$tN(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage,T.mode)}(0,u.$sO)(j,M),this.H.set(M,j),p.push(j)}}if(C.removed)for(const T of C.removed){const M=this.H.get(T);M&&(this.H.delete(T),v.push(M))}if(C.changed){for(const T of C.changed)if(T.id){const M=this.H.get(T.id);if(M){if(M instanceof u.$vO&&T.type==="function"){const j=M;j.enabled=T.enabled,j.condition=T.condition,j.hitCondition=T.hitCondition,j.logMessage=T.logMessage,j.functionName=T.functionName}else if(M instanceof u.$uO&&T.type==="source"){const j=M;j.enabled=T.enabled,j.condition=T.condition,j.hitCondition=T.hitCondition,j.logMessage=T.logMessage,j.location=new u.$EN(A.URI.revive(T.uri),new u.$tN(T.line,T.character))}N.push(M)}}}this.rb(p,v,N)}async $acceptStackFrameFocus(C){let p;if(C){const v=await this.sb(C.sessionId);C.kind==="thread"?p=new u.$CO(v.api,C.threadId):p=new u.$BO(v.api,C.threadId,C.frameId)}this.J=p,this.L.fire(this.J)}$provideDebugConfigurations(C,p,v){return(0,r.$xh)(async()=>{const N=this.mb(C);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.tb(p);return N.provideDebugConfigurations(T,v)}).then(N=>{if(!N)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return N})}$resolveDebugConfiguration(C,p,v,N){return(0,r.$xh)(async()=>{const T=this.mb(C);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const M=await this.tb(p);return T.resolveDebugConfiguration(M,v,N)})}$resolveDebugConfigurationWithSubstitutedVariables(C,p,v,N){return(0,r.$xh)(async()=>{const T=this.mb(C);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const M=await this.tb(p);return T.resolveDebugConfigurationWithSubstitutedVariables(M,v,N)})}async $provideDebugAdapter(C,p){const v=this.lb(C);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const N=await this.sb(p);return this.pb(v,N).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${N.type}'`);return this.jb(T)})}async $acceptDebugSessionStarted(C){const p=await this.sb(C);this.y.fire(p.api)}async $acceptDebugSessionTerminated(C){const p=await this.sb(C);p&&(this.z.fire(p.api),this.w.delete(p.id))}async $acceptDebugSessionActiveChanged(C){this.D=C?await this.sb(C):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(C,p){(await this.sb(C))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(C,p){const N={session:(await this.sb(C)).api,event:p.event,body:p.body};this.F.fire(N)}jb(C){if(C instanceof u.$xO)return{type:"executable",command:C.command,args:C.args,options:C.options};if(C instanceof u.$yO)return{type:"server",port:C.port,host:C.host};if(C instanceof u.$zO)return{type:"pipeServer",path:C.path};if(C instanceof u.$AO)return{type:"implementation",implementation:C.implementation};throw new Error("convertToDto unexpected type")}kb(C){const p=this.j.filter(v=>v.type===C);if(p.length>0)return p[0].factory}lb(C){const p=this.j.filter(v=>v.handle===C);if(p.length>0)return p[0].factory}mb(C){const p=this.g.filter(v=>v.handle===C);if(p.length>0)return p[0].provider}nb(C,p){if(C.contributes){const v=C.contributes.debuggers;if(v&&v.length>0){for(const N of v)if(N.label&&N.type&&N.type===p)return!0}}return!1}ob(C){const v=C.configuration.type,N=this.n.filter(T=>T.type===v||T.type==="*").map(T=>(0,r.$xh)(()=>T.factory.createDebugAdapterTracker(C.api)).then(M=>M,M=>null));return Promise.race([Promise.all(N).then(T=>{const M=(0,t.$Jb)(T);if(M.length>0)return new y(M)}),new Promise(T=>setTimeout(()=>T(void 0),1e3))]).catch(T=>{})}async pb(C,p){const v=p.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new u.$yO(v));if(C){const T=await this.Z.getExtensionRegistry();return(0,r.$xh)(()=>C.createDebugAdapterDescriptor(p.api,this.qb(p,T))).then(M=>{if(M)return M})}const N=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(p,N))}qb(C,p){}rb(C,p,v){(C.length>0||p.length>0||v.length>0)&&this.I.fire(Object.freeze({added:C,removed:p,changed:v}))}async sb(C){if(C)if(typeof C=="string"){const p=this.w.get(C);if(p)return p}else{let p=this.w.get(C.id);if(!p){const v=await this.tb(C.folderUri),N=C.parent?this.w.get(C.parent):void 0;p=new a(this.u,C.id,C.type,C.name,v,C.configuration,N?.api),this.w.set(p.id,p),this.u.$sessionCached(p.id)}return p}throw new Error("cannot find session")}tb(C){if(C){const p=A.URI.revive(C);return this.Y.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}ub(C,p){return`${C}\0${p}`}vb(C,p){if(p){if("title"in p&&"command"in p)return{type:c.DebugVisualizationType.Command};if("treeId"in p)return{type:c.DebugVisualizationType.Tree,id:`${C}\0${p.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(C){const p=this.xb(C);let v,N;return"id"in p?N=n.ThemeIcon.asClassName(p):v=p,{iconPath:v,iconClass:N}}xb(C){if(C instanceof u.$pO)return{id:C.id};const p=typeof C=="object"&&"dark"in C?C.dark:C,v=typeof C=="object"&&"light"in C?C.light:C;return{dark:typeof p=="string"?A.URI.file(p):p,light:typeof v=="string"?A.URI.file(v):v}}};e.$Loc=f,e.$Loc=f=Je([Ve(0,E.$WP),Ve(1,k.$Wnc),Ve(2,I.$Aoc),Ve(3,d.$Znc),Ve(4,l.$_nc),Ve(5,m.$Doc),Ve(6,o.$gQ),Ve(7,s.$Foc)],f);class a{constructor(C,p,v,N,T,M,j){this.f=C,this.g=p,this.h=v,this.j=N,this.k=T,this.l=M,this.m=j}get api(){const C=this;return this.d??=Object.freeze({id:C.g,type:C.h,get name(){return C.j},set name(p){C.j=p,C.f.$setDebugSessionName(C.g,p)},parentSession:C.m,workspaceFolder:C.k,configuration:C.l,customRequest(p,v){return C.f.$customDebugAdapterRequest(C.g,p,v)},getDebugProtocolBreakpoint(p){return C.f.$getDebugProtocolBreakpoint(C.g,p.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(C){this.j=C}get configuration(){return this.l}}e.$Moc=a;class w{constructor(C){this.value=Object.freeze({append(p){C.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Noc=w;class y{constructor(C){this.d=C}onWillStartSession(){this.d.forEach(C=>C.onWillStartSession?C.onWillStartSession():void 0)}onWillReceiveMessage(C){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(C):void 0)}onDidSendMessage(C){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(C):void 0)}onWillStopSession(){this.d.forEach(C=>C.onWillStopSession?C.onWillStopSession():void 0)}onError(C){this.d.forEach(p=>p.onError?p.onError(C):void 0)}onExit(C,p){this.d.forEach(v=>v.onExit?v.onExit(C,p):void 0)}}class S extends b.$_sb{constructor(C){super(),this.h=C,C.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(C){this.h.handleMessage(C)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let D=class extends f{constructor(C,p,v,N,T,M,j,z){super(C,p,v,N,T,M,j,z)}};e.$Ooc=D,e.$Ooc=D=Je([Ve(0,E.$WP),Ve(1,k.$Wnc),Ve(2,I.$Aoc),Ve(3,d.$Znc),Ve(4,l.$_nc),Ve(5,m.$Doc),Ve(6,o.$gQ),Ve(7,s.$Foc)],D)}),define(Ee[390],Se([1,0,14,62,2,6,339,12,89,115,30,275,20,73,52,95]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0,r=We(r),h=We(h);class g{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(O.$_j),t=n.get(u.$WP).getProxy(R.$qN.MainThreadErrors);r.setUnexpectedErrorHandler(s=>{o.error(s);const f=r.$5(s);t.$onUnexpectedError(f)})}static async installFullHandler(n){const o=n.get(O.$_j),i=n.get(u.$WP),t=n.get(b.$Aoc),s=n.get(c.$eQ),f=i.getProxy(R.$qN.MainThreadExtensionService),a=i.getProxy(R.$qN.MainThreadErrors),w=await t.getExtensionPathIndex(),y=new WeakMap;function S(C,p){if(y.has(C))return y.get(C).stack;let v="",N,T;for(const j of p)v+=`
	at ${j.toString()}`,T=j.getFileName(),!N&&T&&(N=w.findSubstr(A.URI.file(T)));const M=`${C.name||"Error"}: ${C.message||""}${v}`;return y.set(C,{extensionIdentifier:N?.identifier,stack:M}),M}const D=Symbol("prepareStackTrace wrapped");let P=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return P},set(C){if(C===S||!C||C[D]){P=C||S;return}P=function(p,v){return S(p,v),C.call(Error,p,v)},Object.assign(P,{[D]:!0})}}),r.setUnexpectedErrorHandler(C=>{o.error(C);const p=r.$5(C),v=y.get(C);if(!v?.extensionIdentifier){a.$onUnexpectedError(p);return}f.$onExtensionRuntimeError(v.extensionIdentifier,p);const N=s.onExtensionError(v.extensionIdentifier,C);o.trace("forwarded error to extension?",N,v)})}}e.$Npc=g;class d{constructor(n,o,i,t,s){this.a=i,this.b=new L.$acc(n,null,t),o=d.e(o,this.b);const f=new l.$Di(...(0,$.$Ms)());f.set(I.$aQ,{_serviceBrand:void 0,...o,messagePorts:s}),f.set(u.$WP,new u.$XP(this.b)),f.set(k.$Tnc,new k.$Unc(t)),f.set(b.$yoc,i);const a=new E.$qr(f,!0);a.invokeFunction(g.installEarlyHandler),this.d=a.invokeFunction(w=>w.get(O.$_j)),h.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=a.invokeFunction(w=>w.get(b.$Aoc)),this.c.initialize(),a.invokeFunction(g.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(R.$qN.MainThreadExtensionService);return A.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=A.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=A.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>A.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=A.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=A.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=A.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=A.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$Opc=d}),define(Ee[391],Se([1,0,9,11,245,268,148,102,78,52,20,47,10,65,48,309,310,42,35,99]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ypc=void 0,h=We(h),A=We(A);let o=class extends O.$Loc{constructor(a,w,y,S,D,P,C,p,v){super(a,w,y,S,P,C,p,v),this.Ab=D,this.yb=new s}hb(a,w){switch(a.type){case"server":return new c.$Tpc(a);case"pipeServer":return new c.$Upc(a);case"executable":return new c.$Vpc(a,w.type)}return super.hb(a,w)}qb(a,w){const y=c.$Vpc.platformAdapterExecutable(w.getAllExtensionDescriptions(),a.type);if(y)return new u.$xO(y.command,y.args,y.options)}ib(){return new L.$0fc}async $runInTerminal(a,w){if(a.kind==="integrated"){this.zb||(this.zb=this.B(this.Ab.onDidCloseTerminal(z=>{this.yb.onTerminalClosed(z)})));const y=await this.$.getConfigProvider(),S=this.Ab.getDefaultShell(!0),D=this.Ab.getDefaultShellArgs(!0),P=a.title||A.localize(0,null),C=JSON.stringify({shell:S,shellArgs:D});let p=await this.yb.checkout(C,P),v,N=!1;if(p)v=a.cwd;else{const z={shellPath:S,shellArgs:D,cwd:a.cwd,name:P,iconPath:new u.$pO("debug")};N=!0,p=this.Ab.createTerminalFromOptions(z,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.yb.insert(p,C)}p.show(!0);const T=await p.processId;N?await new Promise(z=>setTimeout(z,1e3)):(p.state.isInteractedWith&&(p.sendText(""),await(0,r.$Gh)(200)),y.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?p.sendText("cls"):S.indexOf("bash")>=0?p.sendText("clear"):h.$i?p.sendText("cls"):p.sendText("clear")));const M=(0,g.$Xpc)(S,a.args,!!a.argsCanBeInterpretedByShell,v,a.env);p.sendText(M);const j=this.onDidTerminateDebugSession(z=>{z.id===w&&(this.yb.free(p),j.dispose())});return T}else if(a.kind==="external")return t(a,await this.$.getConfigProvider());return super.$runInTerminal(a,w)}};e.$Ypc=o,e.$Ypc=o=Je([Ve(0,I.$WP),Ve(1,b.$Wnc),Ve(2,l.$Aoc),Ve(3,d.$Znc),Ve(4,E.$loc),Ve(5,$.$_nc),Ve(6,k.$Doc),Ve(7,m.$gQ),Ve(8,n.$Foc)],o);let i;function t(f,a){if(!i)if(h.$i)i=new R.$Sec;else if(h.$j)i=new R.$Tec;else if(h.$k)i=new R.$Uec;else throw new Error("external terminals not supported on this platform");const w=a.getConfiguration("terminal");return i.runInTerminal(f.title,f.cwd,f.args,f.env||{},w.external||{})}class s{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,w,y=!1){const D=[...this.b.entries()].map(([P,C])=>(0,r.$sh)(async p=>{if(P.name!==w||C.lastUsedAt!==-1&&await(0,g.$Wpc)(await P.processId))return null;const v=Date.now();return C.lastUsedAt+s.a>v||p.isCancellationRequested?null:C.config!==a?(y&&P.dispose(),null):(C.lastUsedAt=v,P)}));return await(0,r.$Kh)(D,P=>!!P)}insert(a,w){this.b.set(a,{lastUsedAt:Date.now(),config:w})}free(a){const w=this.b.get(a);w&&(w.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(Ee[392],Se([1,0,16,2,112,48,64,42,46,47,20,30,101,15,12,96,23,68,65]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=void 0,r=We(r),g=We(g);let n=class extends u.$upc{constructor(i,t,s,f,a,w,y,S,D){super(i,t,s,f,a,w,y,S),this.C=s,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(i,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const f=u.TaskHandleDTO.from(s,this.C),a=await this.a.$getTaskExecution(f);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const w=await this.z(a,t);return this.a.$executeTask(f).catch(()=>{}),w}else{const f=u.TaskDTO.from(t,i);if(f===void 0)return Promise.reject(new Error("Task is not valid"));u.CustomExecutionDTO.is(f.execution)&&await this.y(f,t,!1);const a=await this.z(await this.a.$getTaskExecution(f),t);return this.a.$executeTask(f).catch(()=>{}),a}}v(i,t,s,f){const a=[];if(f)for(const w of f){this.A(w,s),(!w.definition||!i[w.definition.type])&&this.f.warn(`The task [${w.source}, ${w.name}] uses an undefined task type. The task will be ignored in the future.`);const y=u.TaskDTO.from(w,s.extension);y&&(a.push(y),u.CustomExecutionDTO.is(y.execution)&&t.push(this.y(y,w,!0)))}return{tasks:a,extension:s.extension}}async w(i){return i}async G(i){let t=i&&i.length>0?i[0]:void 0;if(!t){const s=h.URI.file((0,d.homedir)());t=new $.$Zi({uri:s,name:g.$dh(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(i,t){const s=h.URI.revive(i),f={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(s),w=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),S=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(w);for(const D of t.variables)f.variables[D]=await y.resolveAsync(S,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(r.$vc);for(let P=0;P<D.length;P++)D[P]=await y.resolveAsync(S,D[P])}f.process=await A.win32.findExecutable(await y.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await y.resolveAsync(S,t.process.cwd):void 0,D)}return f}async $jsonTasksSupported(){return!0}async $findExecutable(i,t,s){return A.win32.findExecutable(i,t,s)}};e.$Qpc=n,e.$Qpc=n=Je([Ve(0,I.$WP),Ve(1,E.$aQ),Ve(2,R.$Wnc),Ve(3,L.$8P),Ve(4,O.$Znc),Ve(5,l.$loc),Ve(6,b.$_j),Ve(7,c.$Anc),Ve(8,m.$Doc)],n)}),define(Ee[393],Se([1,0,68,65]),function(ce,e,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=void 0;class A extends h.$Eoc{m(){return(0,r.homedir)()}}e.$wqc=A}),define(Ee[170],Se([1,0,19,9,21,55,15,16,23,2,38]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$4oc=e.$3oc=void 0,e.$5oc=c,O=We(O),$=We($);class E{constructor(m,n,o){this.d=m,this.e=n,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(m,n){const o=this.g.folderQueries||[],i=new A.$xe(n);return new Promise((t,s)=>{this.a=new k(m);let f=!1;const a=(w,y)=>{if(!f&&!this.b){const S=this.h(w);c(w)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,f=!0,i.cancel(),w=this.j(w,this.g.maxResults-this.c));const D=this.h(w);this.c+=D,(D>0||!c(w))&&this.a.add(w,y)}};Promise.all(o.map((w,y)=>this.k(w,S=>a(S,y),i.token))).then(w=>{i.dispose(),this.a.flush();const y=w.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||y,messages:w.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},w=>{i.dispose();const y=(0,R.$qj)(w);s(new Error(y))})})}h(m){return c(m)?Array.isArray(m.ranges)?m.ranges.length:1:0}j(m,n){const o=Array.isArray(m.ranges)?m.ranges:[m.ranges],i=Array.isArray(m.preview.matches)?m.preview.matches:[m.preview.matches];return{ranges:o.slice(0,n),preview:{matches:i.slice(0,n),text:m.preview.text},uri:m.uri}}async k(m,n,o){const i=new I.$7L(this.g,m),t=[],s={report:w=>{if(!this.l(w))return;const y=m.folder.scheme===L.Schemas.file?(0,I.$8L)(()=>this.e.readdir($.$fh(w.uri))):void 0,S=$.$ih(m.folder,w.uri);if(S){const D=i.includedInQuery(S,O.$pc(S),y);(0,h.$rh)(D)?t.push(D.then(P=>{P&&n(w)})):D&&n(w)}}},f=this.n(m);let a;return this.d.query.type===I.QueryType.aiText?a=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,s,o):a=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),f,s,o),t.length&&await Promise.all(t),a}l(m){if(c(m)){if(Array.isArray(m.ranges)){if(!Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(m.preview.matches.length!==m.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(m.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(m){const n=(0,I.$6L)(this.g.includePattern,m.includePattern),o=(0,I.$6L)(this.g.excludePattern,m.excludePattern),i={folder:l.URI.from(m.folder),excludes:o,includes:n,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,encoding:m.fileEncoding&&this.e.toCanonicalName(m.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$ML,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$3oc=E;function u(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class k{constructor(m){this.e=m,this.b=-1,this.d=null,this.a=new g(512,n=>this.g(n))}add(m,n){this.d&&(this.b!==n||!$.$_g(this.c,m.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:m.uri,results:[]}),this.d.results.push(b(m))}f(){const m=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,m)}flush(){this.f(),this.a.flush()}g(m){this.e(m)}}e.$4oc=k;function b(d){return c(d)?{preview:{matches:(0,r.$3b)(d.preview.matches,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character})),text:d.preview.text},ranges:(0,r.$3b)(d.ranges,m=>({startLineNumber:m.start.line,startColumn:m.start.character,endLineNumber:m.end.line,endColumn:m.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function c(d){return!!d.preview}class g{static{this.a=4e3}static{this.b=50}constructor(m,n){this.g=m,this.h=n,this.c=0,this.d=[],this.e=0}addItem(m,n){m&&this.j(m,n)}addItems(m,n){m&&this.k(m,n)}j(m,n){this.d.push(m),this.e+=n,this.l()}k(m,n){this.d=this.d.concat(m),this.e+=n,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$6oc=g}),define(Ee[103],Se([1,0,3,6,5,386,20,73,12,2,170]),function(ce,e,r,h,A,R,L,O,$,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=void 0,e.$9oc=u,e.$7oc=(0,A.$Fi)("IExtHostSearch");let E=class{constructor(c,g,d){this.n=c,this.o=g,this.q=d,this.c=this.n.getProxy(h.$qN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new R.$2oc}s(c){return this.o.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const d=this.d++;return this.e.set(d,g),this.c.$registerTextSearchProvider(d,this.s(c)),(0,r.$Uc)(()=>{this.g.delete(c),this.e.delete(d),this.c.$unregisterProvider(d)})}registerAITextSearchProvider(c,g){if(this.i.has(c))throw new Error(`an AI text search provider for the scheme '${c}'is already registered`);this.i.add(c);const d=this.d++;return this.h.set(d,g),this.c.$registerAITextSearchProvider(d,this.s(c)),(0,r.$Uc)(()=>{this.i.delete(c),this.h.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(c,g){if(this.k.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.k.add(c);const d=this.d++;return this.j.set(d,g),this.c.$registerFileSearchProvider(d,this.s(c)),(0,r.$Uc)(()=>{this.k.delete(c),this.j.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(c,g,d,m){const n=u(d),o=this.j.get(c);if(o)return this.l.fileSearch(n,o,i=>{this.c.$handleFileMatch(c,g,i.map(t=>t.resource))},m);throw new Error("3 unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,d){return{messages:[]}}$clearCache(c){return this.l.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,d,m){const n=this.e.get(c);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${c}`);const o=u(d);return this.t(o,n).search(t=>this.c.$handleTextMatch(c,g,t),m)}$provideAITextSearchResults(c,g,d,m){const n=this.h.get(c);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${c}`);const o=u(d);return this.v(o,n).search(t=>this.c.$handleTextMatch(c,g,t),m)}$enableExtensionHostSearch(){}t(c,g){return new I.$3oc({query:c,provider:g},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}v(c,g){return new I.$3oc({query:c,provider:g},{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"aiTextSearchProvider")}};e.$8oc=E,e.$8oc=E=Je([Ve(0,L.$WP),Ve(1,O.$Tnc),Ve(2,$.$_j)],E);function u(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(k),extraFileResources:b.extraFileResources&&b.extraFileResources.map(c=>l.URI.revive(c))}}function k(b){return{...b,folder:l.URI.revive(b.folder)}}});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[394],Se([1,0,21,14,4,3,15,44,2,114,212,193,54,24,28,12,91,92,295,6,341,367,96,128,345,346,347,326,315,35,348,42,349,102,162,350,328,342,351,352,64,78,329,343,52,353,76,354,63,30,368,330,355,129,356,123,124,331,385,358,299,359,369,360,168,332,361,362,363,20,364,103,125,365,333,366,126,98,101,95,47,166,99,370,344,371,372,77,17,10,334,73,335,97,373,374,161,48,120,94,26,100]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a,w,y,S,D,P,C,p,v,N,T,M,j,z,F,B,_,re,U,G,Q,ee,ue,ne,De,$e,K,W,se,oe,te,le,he,X,ae,pe,be,Fe,Be,ke,Ie,Oe,q,V,J,x,fe,we,Ne,Ge,Ke,tt,rt,ot,nt,ct,$t,ht,at,Pe,ze,Ze,Te,Me,Y,de,Ce,Xe,_e,lt,gt,kt,Ot,Wt,ui,it,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=Zt,h=We(h),O=Ut(O),E=We(E),b=We(b),Me=We(Me),Y=We(Y);function Zt(mt){const bt=mt.get(De.$aQ),hi=mt.get(ne.$Enc),ei=mt.get(ee.$2nc),qt=mt.get(G.$Aoc),wt=mt.get(Ot.$Wnc),Vt=mt.get(nt.$eQ),Jt=mt.get(C.$Znc),Xt=mt.get(Ce.$Tnc),xe=mt.get(J.$WP),$i=mt.get(tt.$ioc),ti=mt.get(rt.$3nc),si=mt.get(c.$ak),Dt=mt.get(c.$_j),Kt=mt.get(Te.$mFb),Lt=mt.get(t.$Anc),Mt=mt.get(kt.$Hpc),ii=mt.get(we.$soc),ni=mt.get(_.$_nc),oi=mt.get(le.$woc),Bt=mt.get(s.$Knc),Qt=mt.get(se.$poc);xe.set(n.$rN.ExtHostFileSystemInfo,hi),xe.set(n.$rN.ExtHostLogLevelServiceShape,si),xe.set(n.$rN.ExtHostWorkspace,wt),xe.set(n.$rN.ExtHostConfiguration,Jt),xe.set(n.$rN.ExtHostExtensionService,qt),xe.set(n.$rN.ExtHostStorage,$i),xe.set(n.$rN.ExtHostTunnelService,Kt),xe.set(n.$rN.ExtHostWindow,Mt),xe.set(n.$rN.ExtHostSecretState,ii),xe.set(n.$rN.ExtHostTelemetry,Vt),xe.set(n.$rN.ExtHostEditorTabs,ni),xe.set(n.$rN.ExtHostManagedSockets,oi),xe.set(n.$rN.ExtHostAuthentication,Bt),xe.set(n.$rN.ExtHostChatProvider,Qt);const di=xe.set(n.$rN.ExtHostDecorations,mt.get(N.$Qoc)),jt=xe.set(n.$rN.ExtHostDocumentsAndEditors,mt.get(B.$8P)),vt=xe.set(n.$rN.ExtHostCommands,mt.get(D.$gQ)),Pt=xe.set(n.$rN.ExtHostTerminalService,mt.get(ct.$loc)),Tt=xe.set(n.$rN.ExtHostTerminalShellIntegration,mt.get($t.$xpc)),It=xe.set(n.$rN.ExtHostDebugService,mt.get(v.$Koc)),Yt=xe.set(n.$rN.ExtHostSearch,mt.get(fe.$7oc)),Ht=xe.set(n.$rN.ExtHostTask,mt.get(ot.$wpc)),pi=xe.set(n.$rN.ExtHostOutputService,mt.get(ke.$jpc)),fi=xe.set(n.$rN.ExtHostLocalization,mt.get(te.$voc)),Ai=xe.set(n.$rN.ExtHostUrls,new Xe.$Epc(xe)),Nt=xe.set(n.$rN.ExtHostDocuments,new F.$Hnc(xe,jt)),Oi=xe.set(n.$rN.ExtHostDocumentContentProviders,new j.$Soc(xe,jt,Dt)),ai=xe.set(n.$rN.ExtHostDocumentSaveParticipant,new z.$Toc(Dt,Nt,xe.getProxy(n.$qN.MainThreadBulkEdits))),Rt=xe.set(n.$rN.ExtHostNotebook,new X.$0oc(xe,vt,jt,Nt,ei,Yt,Dt)),Si=xe.set(n.$rN.ExtHostNotebookDocuments,new pe.$dpc(Rt)),Di=xe.set(n.$rN.ExtHostNotebookEditors,new be.$epc(Dt,Rt)),vi=xe.set(n.$rN.ExtHostNotebookKernels,new Fe.$fpc(xe,bt,Rt,vt,Dt)),Ti=xe.set(n.$rN.ExtHostNotebookRenderers,new Be.$hpc(xe,Rt)),gi=xe.set(n.$rN.ExtHostNotebookDocumentSaveParticipant,new ae.$cpc(Dt,Rt,xe.getProxy(n.$qN.MainThreadBulkEdits))),Gt=xe.set(n.$rN.ExtHostEditors,new at.$Qnc(xe,jt)),Ae=xe.set(n.$rN.ExtHostTreeViews,new Ze.$Cpc(xe.getProxy(n.$qN.MainThreadTreeViews),vt,Dt)),je=xe.set(n.$rN.ExtHostEditorInsets,new S.$Rnc(xe.getProxy(n.$qN.MainThreadEditorInsets),Gt,bt.remote)),ve=xe.set(n.$rN.ExtHostDiagnostics,new T.$Gnc(xe,Dt,hi,jt)),ie=xe.set(n.$rN.ExtHostLanguages,new oe.$apc(xe,Nt,vt.converter,Xt)),Re=xe.set(n.$rN.ExtHostLanguageFeatures,new W.$Inc(xe,Xt,Nt,vt,ve,Dt,Lt,Vt)),He=xe.set(n.$rN.ExtHostFileSystem,new Q.$Woc(xe,Re)),et=xe.set(n.$rN.ExtHostFileSystemEventService,new ue.$Xoc(xe,Dt,jt)),Qe=xe.set(n.$rN.ExtHostQuickOpen,(0,V.$npc)(xe,wt,vt)),ft=xe.set(n.$rN.ExtHostSCM,new x.$ppc(xe,vt,Nt,Dt)),At=xe.set(n.$rN.ExtHostQuickDiff,new q.$mpc(xe,Xt)),xt=xe.set(n.$rN.ExtHostShare,new Ne.$qpc(xe,Xt)),ci=xe.set(n.$rN.ExtHostComments,(0,P.$Snc)(xe,vt,Nt)),zt=xe.set(n.$rN.ExtHostProgress,new Oe.$lpc(xe.getProxy(n.$qN.MainThreadProgress))),ri=xe.set(n.$rN.ExtHostLabelService,new K.$_oc(xe)),Bi=xe.set(n.$rN.ExtHostTheming,new Pe.$zpc(xe)),Yi=xe.set(n.$rN.ExtHostTimeline,new ze.$Bpc(xe,vt)),Ui=xe.set(n.$rN.ExtHostWebviews,new _e.$7nc(xe,bt.remote,wt,Dt,Lt)),Ni=xe.set(n.$rN.ExtHostWebviewPanels,new lt.$0nc(xe,Ui,wt)),Wi=xe.set(n.$rN.ExtHostCustomEditors,new p.$$nc(xe,Nt,ti,Ui,Ni)),qi=xe.set(n.$rN.ExtHostWebviewViews,new gt.$Fpc(xe,Ui)),ki=xe.set(n.$rN.ExtHostTesting,mt.get(ht.$Foc)),xi=xe.set(n.$rN.ExtHostUriOpeners,new de.$Dpc(xe)),_i=xe.set(n.$rN.ExtHostProfileContentHandlers,new Ie.$kpc(xe));xe.set(n.$rN.ExtHostInteractive,new $e.$$oc(xe,Rt,jt,vt,Dt));const Fi=xe.set(n.$rN.ExtHostChatAgents2,new a.$Nnc(xe,Dt,vt,bt.quality)),en=xe.set(n.$rN.ExtHostChatVariables,new w.$Onc(xe)),Vi=xe.set(n.$rN.ExtHostAiRelatedInformation,new o.$znc(xe)),$n=xe.set(n.$rN.ExtHostAiEmbeddingVector,new U.$Voc(xe)),tn=xe.set(n.$rN.ExtHostStatusBar,new Ke.$tpc(xe,vt.converter)),Gi=xe.set(n.$rN.ExtHostSpeech,new Ge.$rpc(xe)),Ii=xe.set(n.$rN.ExtHostEmbeddings,new re.$Uoc(xe)),pn=Object.values(n.$rN);xe.assertRegistered(pn);const bn=new f.$Mnc(xe,jt),nn=new y.$Pnc(xe),Hi=new he.$bpc(xe,Dt),Mi=new M.$Roc(xe);return i.$Jnc.register(vt),function(qe,bi,Zi){function ut(ge){return(ye,Ue,dt)=>{const St=ge(Ft=>{try{ye.call(Ue,Ft)}catch(Pi){h.$4(new Error(`[ExtensionListenerError] Extension '${qe.identifier.value}' FAILED to handle event: ${Pi.toString()}`,{cause:Pi})),Vt.onExtensionError(qe.identifier,Pi)}});return dt?.push(St),St}}const yt=function(){let ge=!qe.isUnderDevelopment;function ye(){ge||(Dt.info(`Extension '${qe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ue(dt){if(Array.isArray(dt))dt.forEach(Ue);else if(typeof dt=="string")ye();else{const St=dt;typeof St.scheme>"u"&&ye(),typeof St.exclusive=="boolean"&&(0,it.$5G)(qe,"documentFiltersExclusive")}return dt}}(),rn={getSession(ge,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,it.$5G)(qe,"authLearnMore"),Ue?.account&&(0,it.$5G)(qe,"authGetSessions"),Bt.getSession(qe,ge,ye,Ue)},getSessions(ge,ye){return(0,it.$5G)(qe,"authGetSessions"),Bt.getSessions(qe,ge,ye)},getAccounts(ge){return(0,it.$5G)(qe,"authGetSessions"),Bt.getAccounts(ge)},async hasSession(ge,ye){return(0,it.$5G)(qe,"authSession"),!!await Bt.getSession(qe,ge,ye,{silent:!0})},get onDidChangeSessions(){return ut(Bt.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,Ue,dt){return Bt.registerAuthenticationProvider(ge,ye,Ue,dt)}},Ei={registerCommand(ge,ye,Ue){return vt.registerCommand(!0,ge,ye,Ue,void 0,qe)},registerTextEditorCommand(ge,ye,Ue){return vt.registerCommand(!0,ge,(...dt)=>{const St=Gt.getActiveTextEditor();if(!St){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return St.edit(Ft=>{ye.apply(Ue,[St,Ft,...dt])}).then(Ft=>{Ft||Dt.warn("Edits from command "+ge+" were not applied.")},Ft=>{Dt.warn("An error occurred while running command "+ge,Ft)})},void 0,void 0,qe)},registerDiffInformationCommand:(ge,ye,Ue)=>((0,it.$5G)(qe,"diffCommand"),vt.registerCommand(!0,ge,async(...dt)=>{const St=jt.activeEditor(!0);if(!St){Dt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Ft=await Gt.getDiffInformation(St.id);ye.apply(Ue,[Ft,...dt])},void 0,void 0,qe)),executeCommand(ge,...ye){return vt.executeCommand(ge,...ye)},getCommands(ge=!1){return vt.getCommands(ge)}},Li={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Pt.getDefaultShell(!1)},get onDidChangeShell(){return ut(Pt.onDidChangeShell)},get isTelemetryEnabled(){return Vt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ut(Vt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,it.$5G)(qe,"telemetry"),Vt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,it.$5G)(qe,"telemetry"),ut(Vt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,nt.$dQ)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return nt.$cQ.validateSender(ge),Vt.instantiateLogger(qe,ge,ye)},openExternal(ge,ye){return Mt.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return Ai.createAppUri(ge);try{return await Mt.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ye){if((0,L.$Og)(ge,L.Schemas.http)||(0,L.$Og)(ge,L.Schemas.https))return ge;throw ye}},get remoteName(){return(0,g.$hn)(bt.remote.authority)},get remoteAuthority(){return(0,it.$5G)(qe,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return Dt.getLevel()},get onDidChangeLogLevel(){return ut(Dt.onDidChangeLogLevel)},get appQuality(){return(0,it.$5G)(qe,"resolvers"),bt.quality},get appCommit(){return(0,it.$5G)(qe,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Li);const wn={createTestController(ge,ye,Ue){return ki.createTestController(qe,ge,ye,Ue)},createTestObserver(){return(0,it.$5G)(qe,"testObserver"),ki.createTestObserver()},runTests(ge){return(0,it.$5G)(qe,"testObserver"),ki.runTests(ge)},registerTestFollowupProvider(ge){return(0,it.$5G)(qe,"testObserver"),ki.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,it.$5G)(qe,"testObserver"),ut(ki.onResultsChanged)},get testResults(){return(0,it.$5G)(qe,"testObserver"),ki.results}},li=bt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,ji={getExtension(ge,ye){(0,it.$4G)(qe,"extensionsAny")||(ye=!1);const Ue=bi.mine.getExtensionDescription(ge);if(Ue)return new G.$Boc(qt,qe.identifier,Ue,li,!1);if(ye){const dt=bi.all.getExtensionDescription(ge);if(dt)return new G.$Boc(qt,qe.identifier,dt,li,!0)}},get all(){const ge=[];for(const ye of bi.mine.getAllExtensionDescriptions())ge.push(new G.$Boc(qt,qe.identifier,ye,li,!1));return ge},get allAcrossExtensionHosts(){(0,it.$5G)(qe,"extensionsAny");const ge=new k.$rn(bi.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of bi.all.getAllExtensionDescriptions()){const dt=!ge.has(Ue.identifier);ye.push(new G.$Boc(qt,qe.identifier,Ue,li,dt))}return ye},get onDidChange(){return(0,it.$4G)(qe,"extensionsAny")?ut(A.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ut(bi.mine.onDidChange)}},sn={createDiagnosticCollection(ge){return ve.createDiagnosticCollection(qe.identifier,ge)},get onDidChangeDiagnostics(){return ut(ve.onDidChangeDiagnostics)},getDiagnostics:ge=>ve.getDiagnostics(ge),getLanguages(){return ie.getLanguages()},setTextDocumentLanguage(ge,ye){return ie.changeLanguage(ge.uri,ye)},match(ge,ye){const Ue=Me.LanguageSelector.from(ge);let dt;return(0,I.$qu)(Ue)&&(dt=Rt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Ft=>Ft.document===ye))?.apiNotebook),(0,I.$pu)(Ue,ye.uri,ye.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,ye,Ue){return Re.registerCodeActionProvider(qe,yt(ge),ye,Ue)},registerDocumentPasteEditProvider(ge,ye,Ue){return(0,it.$5G)(qe,"documentPaste"),Re.registerDocumentPasteEditProvider(qe,yt(ge),ye,Ue)},registerCodeLensProvider(ge,ye){return Re.registerCodeLensProvider(qe,yt(ge),ye)},registerDefinitionProvider(ge,ye){return Re.registerDefinitionProvider(qe,yt(ge),ye)},registerDeclarationProvider(ge,ye){return Re.registerDeclarationProvider(qe,yt(ge),ye)},registerImplementationProvider(ge,ye){return Re.registerImplementationProvider(qe,yt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return Re.registerTypeDefinitionProvider(qe,yt(ge),ye)},registerHoverProvider(ge,ye){return Re.registerHoverProvider(qe,yt(ge),ye,qe.identifier)},registerEvaluatableExpressionProvider(ge,ye){return Re.registerEvaluatableExpressionProvider(qe,yt(ge),ye,qe.identifier)},registerInlineValuesProvider(ge,ye){return Re.registerInlineValuesProvider(qe,yt(ge),ye,qe.identifier)},registerDocumentHighlightProvider(ge,ye){return Re.registerDocumentHighlightProvider(qe,yt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return Re.registerMultiDocumentHighlightProvider(qe,yt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return Re.registerLinkedEditingRangeProvider(qe,yt(ge),ye)},registerReferenceProvider(ge,ye){return Re.registerReferenceProvider(qe,yt(ge),ye)},registerRenameProvider(ge,ye){return Re.registerRenameProvider(qe,yt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,it.$5G)(qe,"newSymbolNamesProvider"),Re.registerNewSymbolNamesProvider(qe,yt(ge),ye)},registerDocumentSymbolProvider(ge,ye,Ue){return Re.registerDocumentSymbolProvider(qe,yt(ge),ye,Ue)},registerWorkspaceSymbolProvider(ge){return Re.registerWorkspaceSymbolProvider(qe,ge)},registerDocumentFormattingEditProvider(ge,ye){return Re.registerDocumentFormattingEditProvider(qe,yt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return Re.registerDocumentRangeFormattingEditProvider(qe,yt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,Ue,...dt){return Re.registerOnTypeFormattingEditProvider(qe,yt(ge),ye,[Ue].concat(dt))},registerDocumentSemanticTokensProvider(ge,ye,Ue){return Re.registerDocumentSemanticTokensProvider(qe,yt(ge),ye,Ue)},registerDocumentRangeSemanticTokensProvider(ge,ye,Ue){return Re.registerDocumentRangeSemanticTokensProvider(qe,yt(ge),ye,Ue)},registerSignatureHelpProvider(ge,ye,Ue,...dt){return typeof Ue=="object"?Re.registerSignatureHelpProvider(qe,yt(ge),ye,Ue):Re.registerSignatureHelpProvider(qe,yt(ge),ye,typeof Ue>"u"?[]:[Ue,...dt])},registerCompletionItemProvider(ge,ye,...Ue){return Re.registerCompletionItemProvider(qe,yt(ge),ye,Ue)},registerInlineCompletionItemProvider(ge,ye,Ue){return ye.handleDidShowCompletionItem&&(0,it.$5G)(qe,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,it.$5G)(qe,"inlineCompletionsAdditions"),Ue&&(0,it.$5G)(qe,"inlineCompletionsAdditions"),Re.registerInlineCompletionsProvider(qe,yt(ge),ye,Ue)},registerInlineEditProvider(ge,ye){return(0,it.$5G)(qe,"inlineEdit"),Re.registerInlineEditProvider(qe,yt(ge),ye)},registerDocumentLinkProvider(ge,ye){return Re.registerDocumentLinkProvider(qe,yt(ge),ye)},registerColorProvider(ge,ye){return Re.registerColorProvider(qe,yt(ge),ye)},registerFoldingRangeProvider(ge,ye){return Re.registerFoldingRangeProvider(qe,yt(ge),ye)},registerSelectionRangeProvider(ge,ye){return Re.registerSelectionRangeProvider(qe,ge,ye)},registerCallHierarchyProvider(ge,ye){return Re.registerCallHierarchyProvider(qe,ge,ye)},registerTypeHierarchyProvider(ge,ye){return Re.registerTypeHierarchyProvider(qe,ge,ye)},setLanguageConfiguration:(ge,ye)=>Re.setLanguageConfiguration(qe,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,it.$5G)(qe,"tokenInformation"),ie.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return Re.registerInlayHintsProvider(qe,ge,ye)},createLanguageStatusItem(ge,ye){return ie.createLanguageStatusItem(qe,ge,ye)},registerDocumentDropEditProvider(ge,ye,Ue){return Re.registerDocumentOnDropEditProvider(qe,ge,ye,(0,it.$4G)(qe,"documentPaste")?Ue:void 0)}},on={get activeTextEditor(){return Gt.getActiveTextEditor()},get visibleTextEditors(){return Gt.getVisibleTextEditors()},get activeTerminal(){return Pt.activeTerminal},get terminals(){return Pt.terminals},async showTextDocument(ge,ye,Ue){$.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&Lt.report("workspace.showTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await($.URI.isUri(ge)?Promise.resolve(Ki.openTextDocument(ge)):Promise.resolve(ge));return Gt.showTextDocument(dt,ye,Ue)},createTextEditorDecorationType(ge){return Gt.createTextEditorDecorationType(qe,ge)},onDidChangeActiveTextEditor(ge,ye,Ue){return ut(Gt.onDidChangeActiveTextEditor)(ge,ye,Ue)},onDidChangeVisibleTextEditors(ge,ye,Ue){return ut(Gt.onDidChangeVisibleTextEditors)(ge,ye,Ue)},onDidChangeTextEditorSelection(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorSelection)(ge,ye,Ue)},onDidChangeTextEditorOptions(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorOptions)(ge,ye,Ue)},onDidChangeTextEditorVisibleRanges(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorVisibleRanges)(ge,ye,Ue)},onDidChangeTextEditorViewColumn(ge,ye,Ue){return ut(Gt.onDidChangeTextEditorViewColumn)(ge,ye,Ue)},onDidCloseTerminal(ge,ye,Ue){return ut(Pt.onDidCloseTerminal)(ge,ye,Ue)},onDidOpenTerminal(ge,ye,Ue){return ut(Pt.onDidOpenTerminal)(ge,ye,Ue)},onDidChangeActiveTerminal(ge,ye,Ue){return ut(Pt.onDidChangeActiveTerminal)(ge,ye,Ue)},onDidChangeTerminalDimensions(ge,ye,Ue){return(0,it.$5G)(qe,"terminalDimensions"),ut(Pt.onDidChangeTerminalDimensions)(ge,ye,Ue)},onDidChangeTerminalState(ge,ye,Ue){return ut(Pt.onDidChangeTerminalState)(ge,ye,Ue)},onDidWriteTerminalData(ge,ye,Ue){return(0,it.$5G)(qe,"terminalDataWriteEvent"),ut(Pt.onDidWriteTerminalData)(ge,ye,Ue)},onDidExecuteTerminalCommand(ge,ye,Ue){return(0,it.$5G)(qe,"terminalExecuteCommandEvent"),ut(Pt.onDidExecuteTerminalCommand)(ge,ye,Ue)},onDidChangeTerminalShellIntegration(ge,ye,Ue){return(0,it.$5G)(qe,"terminalShellIntegration"),ut(Tt.onDidChangeTerminalShellIntegration)(ge,ye,Ue)},onDidStartTerminalShellExecution(ge,ye,Ue){return(0,it.$5G)(qe,"terminalShellIntegration"),ut(Tt.onDidStartTerminalShellExecution)(ge,ye,Ue)},onDidEndTerminalShellExecution(ge,ye,Ue){return(0,it.$5G)(qe,"terminalShellIntegration"),ut(Tt.onDidEndTerminalShellExecution)(ge,ye,Ue)},get state(){return Mt.getState()},onDidChangeWindowState(ge,ye,Ue){return ut(Mt.onDidChangeWindowState)(ge,ye,Ue)},showInformationMessage(ge,...ye){return Hi.showMessage(qe,O.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return Hi.showMessage(qe,O.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return Hi.showMessage(qe,O.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,Ue){return Qe.showQuickPick(qe,ge,ye,Ue)},showWorkspaceFolderPick(ge){return Qe.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return Qe.showInput(ge,ye)},showOpenDialog(ge){return Mi.showOpenDialog(qe,ge)},showSaveDialog(ge){return Mi.showSaveDialog(ge)},createStatusBarItem(ge,ye,Ue){let dt,St,Ft;return typeof ge=="string"?(dt=ge,St=ye,Ft=Ue):(St=ge,Ft=ye),tn.createStatusBarEntry(qe,dt,St,Ft)},setStatusBarMessage(ge,ye){return tn.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Lt.report("window.withScmProgress",qe,"Use 'withProgress' instead."),zt.withProgress(qe,{location:Y.ProgressLocation.SourceControl},(ye,Ue)=>ge({report(dt){}}))},withProgress(ge,ye){return zt.withProgress(qe,ge,ye)},createOutputChannel(ge,ye){return pi.createOutputChannel(ge,ye,qe)},createWebviewPanel(ge,ye,Ue,dt){return Ni.createWebviewPanel(qe,ge,ye,Ue,dt)},createWebviewTextEditorInset(ge,ye,Ue,dt){return(0,it.$5G)(qe,"editorInsets"),je.createWebviewEditorInset(ge,ye,Ue,dt,qe)},createTerminal(ge,ye,Ue){return typeof ge=="object"?"pty"in ge?Pt.createExtensionTerminal(ge):Pt.createTerminalFromOptions(ge):Pt.createTerminal(ge,ye,Ue)},registerTerminalLinkProvider(ge){return Pt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Pt.registerProfileProvider(qe,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,it.$5G)(qe,"terminalQuickFixProvider"),Pt.registerTerminalQuickFixProvider(ge,qe.identifier.value,ye)},registerTreeDataProvider(ge,ye){return Ae.registerTreeDataProvider(ge,ye,qe)},createTreeView(ge,ye){return Ae.createTreeView(ge,ye,qe)},registerWebviewPanelSerializer:(ge,ye)=>Ni.registerWebviewPanelSerializer(qe,ge,ye),registerCustomEditorProvider:(ge,ye,Ue={})=>Wi.registerCustomEditorProvider(qe,ge,ye,Ue),registerFileDecorationProvider(ge){return di.registerFileDecorationProvider(ge,qe)},registerUriHandler(ge){return Ai.registerUriHandler(qe,ge)},createQuickPick(){return Qe.createQuickPick(qe)},createInputBox(){return Qe.createInputBox(qe)},get activeColorTheme(){return Bi.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,Ue){return ut(Bi.onDidChangeActiveColorTheme)(ge,ye,Ue)},registerWebviewViewProvider(ge,ye,Ue){return qi.registerWebviewViewProvider(qe,ge,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,Ue){return ut(Rt.onDidChangeActiveNotebookEditor)(ge,ye,Ue)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ut(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,Ue){return ut(Di.onDidChangeNotebookEditorSelection)(ge,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(ge,ye,Ue){return ut(Di.onDidChangeNotebookEditorVisibleRanges)(ge,ye,Ue)},showNotebookDocument(ge,ye){return Rt.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,Ue){return(0,it.$5G)(qe,"externalUriOpener"),xi.registerExternalUriOpener(qe.identifier,ge,ye,Ue)},registerProfileContentHandler(ge,ye){return(0,it.$5G)(qe,"profileContentHandlers"),_i.registerProfileContentHandler(qe,ge,ye)},registerQuickDiffProvider(ge,ye,Ue,dt){return(0,it.$5G)(qe,"quickDiffProvider"),At.registerQuickDiffProvider(yt(ge),ye,Ue,dt)},get tabGroups(){return ni.tabGroups},registerShareProvider(ge,ye){return(0,it.$5G)(qe,"shareProvider"),xt.registerShareProvider(yt(ge),ye)}},Ki={get rootPath(){return Lt.report("workspace.rootPath",qe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ge){throw new h.$$("rootPath")},getWorkspaceFolder(ge){return wt.getWorkspaceFolder(ge)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ge){throw new h.$$("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ge){throw new h.$$("workspaceFile")},updateWorkspaceFolders:(ge,ye,...Ue)=>wt.updateWorkspaceFolders(qe,ge,ye||0,...Ue),onDidChangeWorkspaceFolders:function(ge,ye,Ue){return ut(wt.onDidChangeWorkspace)(ge,ye,Ue)},asRelativePath:(ge,ye)=>wt.getRelativePath(ge,ye),findFiles:(ge,ye,Ue,dt)=>wt.findFiles(ge,ye,Ue,qe.identifier,dt),findFiles2:(ge,ye,Ue)=>((0,it.$5G)(qe,"findFiles2"),wt.findFiles2(ge,ye,qe.identifier,Ue)),findTextInFiles:(ge,ye,Ue,dt)=>{(0,it.$5G)(qe,"findTextInFiles");let St,Ft;return typeof ye=="object"?(St=ye,Ft=Ue):(St={},Ft=ye,dt=Ue),wt.findTextInFiles(ge,St||{},Ft,qe.identifier,dt)},save:ge=>wt.save(ge),saveAs:ge=>wt.saveAs(ge),saveAll:ge=>wt.saveAll(ge),applyEdit(ge,ye){return bn.applyWorkspaceEdit(ge,qe,ye)},createFileSystemWatcher:(ge,ye,Ue,dt)=>{let St;return typeof ye=="boolean"?St={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!dt,correlate:!1}:ye&&((0,it.$5G)(qe,"createFileSystemWatcher"),St={...ye,correlate:!0}),et.createFileSystemWatcher(wt,qe,ge,St)},get textDocuments(){return Nt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new h.$$("textDocuments")},openTextDocument(ge){let ye;const Ue=ge;if(typeof ge=="string")ye=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ye=Promise.resolve(ge);else if(!Ue||typeof Ue=="object")ye=Nt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&Lt.report("workspace.openTextDocument",qe,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(dt).then(St=>St.document)))},onDidOpenTextDocument:(ge,ye,Ue)=>ut(Nt.onDidAddDocument)(ge,ye,Ue),onDidCloseTextDocument:(ge,ye,Ue)=>ut(Nt.onDidRemoveDocument)(ge,ye,Ue),onDidChangeTextDocument:(ge,ye,Ue)=>ut(Nt.onDidChangeDocument)(ge,ye,Ue),onDidSaveTextDocument:(ge,ye,Ue)=>ut(Nt.onDidSaveDocument)(ge,ye,Ue),onWillSaveTextDocument:(ge,ye,Ue)=>ut(ai.getOnWillSaveTextDocumentEvent(qe))(ge,ye,Ue),get notebookDocuments(){return Rt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let Ue;if($.URI.isUri(ge))Ue=ge,await Rt.openNotebookDocument(ge);else if(typeof ge=="string")Ue=$.URI.revive(await Rt.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ge,ye,Ue){return ut(Si.onDidSaveNotebookDocument)(ge,ye,Ue)},onDidChangeNotebookDocument(ge,ye,Ue){return ut(Si.onDidChangeNotebookDocument)(ge,ye,Ue)},onWillSaveNotebookDocument(ge,ye,Ue){return ut(gi.getOnWillSaveNotebookDocumentEvent(qe))(ge,ye,Ue)},get onDidOpenNotebookDocument(){return ut(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ut(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,Ue,dt){return Rt.registerNotebookSerializer(qe,ge,ye,Ue,(0,it.$4G)(qe,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,ye,Ue)=>ut(Zi.onDidChangeConfiguration)(ge,ye,Ue),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,Zi.getConfiguration(ge,ye,qe)},registerTextDocumentContentProvider(ge,ye){return Oi.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Lt.report("window.registerTaskProvider",qe,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(qe,ge,ye)),registerFileSystemProvider(ge,ye,Ue){return(0,R.$Tc)(He.registerFileSystemProvider(qe,ge,ye,Ue),ei.addFileSystemProvider(ge,ye,Ue))},get fs(){return ei.value},registerFileSearchProvider:(ge,ye)=>((0,it.$5G)(qe,"fileSearchProvider"),Yt.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,it.$5G)(qe,"textSearchProvider"),Yt.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,it.$5G)(qe,"aiTextSearchProvider"),(0,it.$5G)(qe,"textSearchProvider"),Yt.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,it.$5G)(qe,"resolvers"),qt.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,it.$5G)(qe,"resolvers"),ri.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,it.$5G)(qe,"resolvers"),qt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,Ue)=>ut(et.onDidCreateFile)(ge,ye,Ue),onDidDeleteFiles:(ge,ye,Ue)=>ut(et.onDidDeleteFile)(ge,ye,Ue),onDidRenameFiles:(ge,ye,Ue)=>ut(et.onDidRenameFile)(ge,ye,Ue),onWillCreateFiles:(ge,ye,Ue)=>ut(et.getOnWillCreateFileEvent(qe))(ge,ye,Ue),onWillDeleteFiles:(ge,ye,Ue)=>ut(et.getOnWillDeleteFileEvent(qe))(ge,ye,Ue),onWillRenameFiles:(ge,ye,Ue)=>ut(et.getOnWillRenameFileEvent(qe))(ge,ye,Ue),openTunnel:ge=>((0,it.$5G)(qe,"tunnels"),Kt.openTunnel(qe,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,it.$5G)(qe,"tunnels"),Kt.getTunnels()},onDidChangeTunnels:(ge,ye,Ue)=>((0,it.$5G)(qe,"tunnels"),ut(Kt.onDidChangeTunnels)(ge,ye,Ue)),registerPortAttributesProvider:(ge,ye)=>((0,it.$5G)(qe,"portsAttributes"),Kt.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,it.$5G)(qe,"tunnelFactory"),Kt.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,it.$5G)(qe,"timeline"),Yi.registerTimelineProvider(ge,ye,qe.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ge=>((0,it.$5G)(qe,"workspaceTrust"),wt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,Ue)=>ut(wt.onDidGrantWorkspaceTrust)(ge,ye,Ue),registerEditSessionIdentityProvider:(ge,ye)=>((0,it.$5G)(qe,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,Ue)=>((0,it.$5G)(qe,"editSessionIdentityProvider"),ut(wt.getOnWillCreateEditSessionIdentityEvent(qe))(ge,ye,Ue)),registerCanonicalUriProvider:(ge,ye)=>((0,it.$5G)(qe,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,Ue)=>((0,it.$5G)(qe,"canonicalUriProvider"),wt.provideCanonicalUri(ge,ye,Ue))},an={get inputBox(){return Lt.report("scm.inputBox",qe,"Use 'SourceControl.inputBox' instead"),ft.getLastInputBox(qe)},createSourceControl(ge,ye,Ue){return ft.createSourceControl(qe,ge,ye,Ue)}},vn={createCommentController(ge,ye){return ci.createCommentController(qe,ge,ye)}},cn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,it.$5G)(qe,"debugVisualization"),It.registerDebugVisualizationProvider(qe,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,it.$5G)(qe,"debugVisualization"),It.registerDebugVisualizationTree(qe,ge,ye)},onDidStartDebugSession(ge,ye,Ue){return ut(It.onDidStartDebugSession)(ge,ye,Ue)},onDidTerminateDebugSession(ge,ye,Ue){return ut(It.onDidTerminateDebugSession)(ge,ye,Ue)},onDidChangeActiveDebugSession(ge,ye,Ue){return ut(It.onDidChangeActiveDebugSession)(ge,ye,Ue)},onDidReceiveDebugSessionCustomEvent(ge,ye,Ue){return ut(It.onDidReceiveDebugSessionCustomEvent)(ge,ye,Ue)},onDidChangeBreakpoints(ge,ye,Ue){return ut(It.onDidChangeBreakpoints)(ge,ye,Ue)},onDidChangeActiveStackItem(ge,ye,Ue){return ut(It.onDidChangeActiveStackItem)(ge,ye,Ue)},registerDebugConfigurationProvider(ge,ye,Ue){return It.registerDebugConfigurationProvider(ge,ye,Ue||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return It.registerDebugAdapterDescriptorFactory(qe,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return It.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?It.startDebugging(ge,ye,{parentSession:Ue}):It.startDebugging(ge,ye,Ue||{})},stopDebugging(ge){return It.stopDebugging(ge)},addBreakpoints(ge){return It.addBreakpoints(ge)},removeBreakpoints(ge){return It.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return It.asDebugSourceUri(ge,ye)}},ln={registerTaskProvider:(ge,ye)=>Ht.registerTaskProvider(qe,ge,ye),fetchTasks:ge=>Ht.fetchTasks(ge),executeTask:ge=>Ht.executeTask(qe,ge),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ge,ye,Ue)=>ut(Ht.onDidStartTask)(ge,ye,Ue),onDidEndTask:(ge,ye,Ue)=>ut(Ht.onDidEndTask)(ge,ye,Ue),onDidStartTaskProcess:(ge,ye,Ue)=>ut(Ht.onDidStartTaskProcess)(ge,ye,Ue),onDidEndTaskProcess:(ge,ye,Ue)=>ut(Ht.onDidEndTaskProcess)(ge,ye,Ue)},En={createNotebookController(ge,ye,Ue,dt,St){return vi.createNotebookController(qe,ge,ye,Ue,dt,(0,it.$4G)(qe,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>Rt.registerNotebookCellStatusBarItemProvider(qe,ge,ye),createRendererMessaging(ge){return Ti.createRendererMessaging(qe,ge)},createNotebookControllerDetectionTask(ge){return(0,it.$5G)(qe,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(qe,ge)},registerKernelSourceActionProvider(ge,ye){return(0,it.$5G)(qe,"notebookKernelSource"),vi.registerKernelSourceActionProvider(qe,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,Ue){return(0,it.$5G)(qe,"notebookCellExecutionState"),ut(vi.onDidChangeNotebookCellExecutionState)(ge,ye,Ue)}},yn={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),Ue=!ge||typeof ge[0]!="object"?ge:ge[0];return fi.getMessage(qe.identifier.value,{message:ye,args:Ue})}return fi.getMessage(qe.identifier.value,ge[0])},get bundle(){return fi.getBundle(qe.identifier.value)},get uri(){return fi.getBundleUri(qe.identifier.value)}},un={_version:1,transferActiveChat(ge){return(0,it.$5G)(qe,"interactive"),Fi.transferActiveChat(ge)}},Qi={getRelatedInformation(ge,ye){return(0,it.$5G)(qe,"aiRelatedInformation"),Vi.getRelatedInformation(qe,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,it.$5G)(qe,"aiRelatedInformation"),Vi.registerRelatedInformationProvider(qe,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,it.$5G)(qe,"aiRelatedInformation"),$n.registerEmbeddingVectorProvider(qe,ge,ye)}},hn={_version:1,registerChatResponseProvider(ge,ye,Ue){return(0,it.$5G)(qe,"chatProvider"),Qt.registerLanguageModel(qe,ge,ye,Ue)},registerChatVariableResolver(ge,ye,Ue,dt,St,Ft,Pi,zi){return(0,it.$5G)(qe,"chatVariableResolver"),en.registerVariableResolver(qe,ge,ye,Ue,dt,St,Ft,Pi,zi?.id)},registerMappedEditsProvider(ge,ye){return(0,it.$5G)(qe,"mappedEditsProvider"),Re.registerMappedEditsProvider(qe,ge,ye)},createChatParticipant(ge,ye){return Fi.createChatAgent(qe,ge,ye)},createDynamicChatParticipant(ge,ye,Ue){return(0,it.$5G)(qe,"chatParticipantPrivate"),Fi.createDynamicChatAgent(qe,ge,ye,Ue)}},dn={selectChatModels:ge=>bt.quality==="stable"?(console.warn(`[${k.$qn.toKey(qe.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):Qt.selectLanguageModels(qe,ge??{}),onDidChangeChatModels:(ge,ye,Ue)=>bt.quality==="stable"?(console.warn(`[${k.$qn.toKey(qe.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),A.Event.None(ge,ye,Ue)):Qt.onDidChangeProviders(ge,ye,Ue),registerChatModelProvider:(ge,ye,Ue)=>((0,it.$5G)(qe,"chatProvider"),Qt.registerLanguageModel(qe,ge,ye,Ue)),get embeddingModels(){return(0,it.$5G)(qe,"embeddings"),Ii.embeddingsModels},onDidChangeEmbeddingModels:(ge,ye,Ue)=>((0,it.$5G)(qe,"embeddings"),Ii.onDidChange(ge,ye,Ue)),registerEmbeddingsProvider(ge,ye){return(0,it.$5G)(qe,"embeddings"),Ii.registerEmbeddingsProvider(qe,ge,ye)},async computeEmbeddings(ge,ye,Ue){return(0,it.$5G)(qe,"embeddings"),Ii.computeEmbeddings(ge,ye,Ue)}},fn={registerSpeechProvider(ge,ye){return(0,it.$5G)(qe,"speech"),Gi.registerProvider(qe.identifier,ge,ye)}};return{version:bt.version,ai:Qi,authentication:rn,commands:Ei,comments:vn,chat:hn,debug:cn,env:Li,extensions:ji,interactive:un,l10n:yn,languages:sn,lm:dn,notebooks:En,scm:an,speech:fn,tasks:ln,tests:wn,window:on,workspace:Ki,Breakpoint:Y.$tO,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.$oP,CallHierarchyIncomingCall:Y.$RN,CallHierarchyItem:Y.$QN,CallHierarchyOutgoingCall:Y.$SN,CancellationError:h.$7,CancellationTokenSource:r.$xe,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.$NN,CodeActionKind:Y.$ON,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$TN,Color:Y.$7N,ColorInformation:Y.$8N,ColorPresentation:Y.$9N,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CompletionItem:Y.$1N,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$2N,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$eO,DebugAdapterExecutable:Y.$xO,DebugAdapterInlineImplementation:Y.$AO,DebugAdapterNamedPipeServer:Y.$zO,DebugAdapterServer:Y.$yO,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.$QO,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$GN,DiagnosticRelatedInformation:Y.$FN,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$sN,DocumentHighlight:Y.$JN,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.$KN,DocumentLink:Y.$6N,DocumentSymbol:Y.$MN,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$DO,InlineValueText:Y.$EO,InlineValueVariableLookup:Y.$FO,InlineValueEvaluatableExpression:Y.$GO,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:A.$me,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$SO,FileDecoration2:Y.$SO,FileSystemError:Y.$JO,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Y.$KO,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$vO,InlineCompletionItem:Y.$3N,InlineCompletionList:Y.$4N,Hover:Y.$HN,VerboseHover:Y.$IN,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:E.IndentAction,Location:Y.$EN,MarkdownString:Y.$UN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Y.$VN,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$tN,ProcessExecution:Y.$cO,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$RO,Range:Y.$uN,RelativePattern:Y.$rO,Selection:Y.$vN,SelectionRange:Y.$PN,SemanticTokens:Y.$NO,SemanticTokensBuilder:Y.$MO,SemanticTokensEdit:Y.$OO,SemanticTokensEdits:Y.$PO,SemanticTokensLegend:Y.$LO,ShellExecution:Y.$dO,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$XN,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$WN,SnippetString:Y.$DN,SourceBreakpoint:Y.$uO,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$LN,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$fO,TaskGroup:Y.$bO,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$0N,TerminalQuickFixTerminalCommand:Y.$_N,TerminalQuickFixOpener:Y.$$N,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$aO,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$zN,SnippetTextEdit:Y.$BN,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$qO,ThemeIcon:Y.$pO,TreeItem:Y.$gO,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$cP,UIKind:ui.UIKind,Uri:$.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$CN,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.$mO,DocumentDropOrPasteEditKind:Y.$nO,DocumentPasteEdit:Y.$oO,InlayHint:Y.$ZN,InlayHintLabelPart:Y.$YN,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$yN,ResolvedAuthority:Y.$wN,ManagedResolvedAuthority:Y.$xN,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$3O,NotebookRange:Y.$UO,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$VO,NotebookData:Y.$WO,NotebookRendererScript:Y.$1O,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$YO,NotebookCellOutputItem:Y.$XO,NotebookCellStatusBarItem:Y.$ZO,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$AN,NotebookKernelSourceAction:Y.$2O,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.$5O,LinkedEditingRanges:Y.$4O,TestResultState:Y.TestResultState,TestRunRequest:Y.$6O,TestMessage:Y.$7O,TestTag:Y.$8O,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:Y.$lO,DataTransferItem:Y.$hO,TestCoverageCount:Y.$9O,FileCoverage:Y.$$O,FileCoverage2:Y.$$O,StatementCoverage:Y.$_O,BranchCoverage:Y.$aP,DeclarationCoverage:Y.$bP,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$dP,TabInputTextDiff:Y.$eP,TabInputTextMerge:Y.$fP,TabInputCustom:Y.$gP,TabInputNotebook:Y.$iP,TabInputNotebookDiff:Y.$jP,TabInputWebview:Y.$hP,TabInputTerminal:Y.$kP,TabInputInteractiveWindow:Y.$lP,TabInputChat:Y.$mP,TabInputTextMultiDiff:Y.$nP,TelemetryTrustedValue:d.$tp,LogLevel:c.LogLevel,EditSessionIdentityMatch:m.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.$BO,DebugThread:Y.$CO,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.$pP,ChatResponseFileTreePart:Y.$tP,ChatResponseAnchorPart:Y.$uP,ChatResponseProgressPart:Y.$vP,ChatResponseProgressPart2:Y.$wP,ChatResponseReferencePart:Y.$zP,ChatResponseWarningPart:Y.$xP,ChatResponseTextEditPart:Y.$AP,ChatResponseMarkdownWithVulnerabilitiesPart:Y.$qP,ChatResponseCommandButtonPart:Y.$yP,ChatResponseDetectedParticipantPart:Y.$rP,ChatResponseConfirmationPart:Y.$sP,ChatRequestTurn:Y.$BP,ChatResponseTurn:Y.$CP,ChatLocation:Y.ChatLocation,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.$EP,LanguageModelChatMessageFunctionResultPart:Y.$DP,LanguageModelChatResponseTextPart:Y.$GP,LanguageModelChatResponseFunctionUsePart:Y.$FP,LanguageModelChatMessage2:Y.$EP,LanguageModelChatSystemMessage:Y.$HP,LanguageModelChatUserMessage:Y.$IP,LanguageModelChatAssistantMessage:Y.$JP,LanguageModelError:Y.$KP,NewSymbolName:Y.$IO,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.$LP,InlineEditTriggerKind:Y.InlineEditTriggerKind}}}}),define(Ee[395],Se([1,0,89,168,48,162,42,35,64,47,101,102,103,126,77,96,161,76,63,125,95,78,160,12,65,123,124,128,129,166,99]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f,a,w,y,S,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ls)(a.$voc,a.$uoc,r.InstantiationType.Delayed),(0,r.$Ls)(s.$ak,t.$Jpc,r.InstantiationType.Delayed),(0,r.$Ls)(c.$Anc,c.$Bnc,r.InstantiationType.Delayed),(0,r.$Ls)(O.$gQ,O.$fQ,r.InstantiationType.Eager),(0,r.$Ls)(y.$Knc,y.$Lnc,r.InstantiationType.Eager),(0,r.$Ls)(S.$poc,S.$qoc,r.InstantiationType.Eager),(0,r.$Ls)(L.$Znc,L.$Xnc,r.InstantiationType.Eager),(0,r.$Ls)(d.$2nc,d.$1nc,r.InstantiationType.Eager),(0,r.$Ls)(P.$Foc,P.$Goc,r.InstantiationType.Eager),(0,r.$Ls)(E.$Koc,E.$Ooc,r.InstantiationType.Eager),(0,r.$Ls)(R.$Qoc,R.$Poc,r.InstantiationType.Eager),(0,r.$Ls)($.$8P,$.$7P,r.InstantiationType.Eager),(0,r.$Ls)(w.$woc,w.$xoc,r.InstantiationType.Eager),(0,r.$Ls)(m.$Enc,m.$Dnc,r.InstantiationType.Eager),(0,r.$Ls)(h.$jpc,h.$ipc,r.InstantiationType.Delayed),(0,r.$Ls)(u.$7oc,u.$8oc,r.InstantiationType.Eager),(0,r.$Ls)(k.$ioc,k.$hoc,r.InstantiationType.Eager),(0,r.$Ls)(I.$wpc,I.$vpc,r.InstantiationType.Eager),(0,r.$Ls)(l.$loc,l.$ooc,r.InstantiationType.Eager),(0,r.$Ls)(D.$xpc,D.$ypc,r.InstantiationType.Eager),(0,r.$Ls)(b.$mFb,b.$nFb,r.InstantiationType.Eager),(0,r.$Ls)(g.$Hpc,g.$Gpc,r.InstantiationType.Eager),(0,r.$Ls)(A.$Wnc,A.$Vnc,r.InstantiationType.Eager),(0,r.$Ls)(n.$soc,n.$roc,r.InstantiationType.Eager),(0,r.$Ls)(o.$eQ,o.$bQ,r.InstantiationType.Eager),(0,r.$Ls)(i.$_nc,i.$aoc,r.InstantiationType.Eager),(0,r.$Ls)(f.$Doc,f.$Eoc,r.InstantiationType.Eager)}),define(Ee[130],Se([1,0,19,12,38,100]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2pc=void 0,e.$Zpc=L,e.$1pc=O,R=We(R);function L(E){return E.startsWith("**")||E.startsWith("/")?E:`/${E}`}function O(E,u,k,b){const c=(0,r.$3b)(k,$),g=new A.$SL(u,c,b),d=g.preview.matches;return{ranges:(0,r.$3b)(c,l),uri:E,preview:{text:g.preview.text,matches:(0,r.$3b)(d,l)}}}function $(E){return new A.$TL(E.start.line,E.start.character,E.end.line,E.end.character)}function l(E){return new R.$GL(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn)}let I=class{constructor(u,k){this.a=u,this.b=k}appendLine(u){this.b.debug(`${this.a}#search`,u)}};e.$2pc=I,e.$2pc=I=Je([Ve(1,h.$_j)],I)}),define(Ee[396],Se([1,0,58,16,82,33,11,13,130,397]),function(ce,e,r,h,A,R,L,O,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3pc=E,e.$4pc=g,e.$5pc=m,r=We(r),h=We(h),R=We(R),O=We(O);const I=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function E(n,o,i,t,s){const f=u(n,o,i,t,s),a=o.folder.fsPath;return{cmd:r.spawn(I,f.args,{cwd:a}),rgDiskPath:I,siblingClauses:f.siblingClauses,rgArgs:f,cwd:a}}function u(n,o,i,t,s){const f=["--files","--hidden","--case-sensitive","--no-require-git"];b([o],i,!1).forEach(w=>{const y=(0,$.$Zpc)(w);if(f.push("-g",y),L.$j){const S=(0,A.$nm)(y);S!==y&&f.push("-g",S)}});const a=k([o],t,void 0,!1);return a.globArgs.forEach(w=>{const y=`!${(0,$.$Zpc)(w)}`;if(f.push("-g",y),L.$j){const S=(0,A.$nm)(y);S!==y&&f.push("-g",S)}}),o.disregardIgnoreFiles!==!1?f.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),o.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),s&&f.push("--threads",`${s}`),f.push("--no-config"),o.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:a.siblingClauses}}function k(n,o,i,t=!0){const s=[];let f={};return n.forEach(a=>{const w=Object.assign({},a.excludePattern||{},o||{}),y=c(w,t?a.folder.fsPath:void 0,i);s.push(...y.globArgs),y.siblingClauses&&(f=Object.assign(f,y.siblingClauses))}),{globArgs:s,siblingClauses:f}}function b(n,o,i=!0){const t=[];return n.forEach(s=>{const f=Object.assign({},o||{},s.includePattern||{}),a=c(f,i?s.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function c(n,o,i){const t=[],s={};return Object.keys(n).forEach(f=>{if(i&&i.has(f)||!f)return;const a=n[f];f=d(o?g(o,f):f),f.startsWith("\\\\")?f="\\\\"+f.substr(2).replace(/\\/g,"/"):f=f.replace(/\\/g,"/"),typeof a=="boolean"&&a?(f.startsWith("\\\\")&&(f+="**"),t.push(m(f))):a&&a.when&&(s[f]=a)}),{globArgs:t,siblingClauses:s}}function g(n,o){return h.$kc(o)?o:h.$lc(n,o)}function d(n){return n=O.$of(n,"\\"),O.$of(n,"/")}function m(n){return R.$Ag(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}}),define(Ee[398],Se([1,0,58,61,16,399,19,55,39,82,33,11,43,13,18,34,38,396,141]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7pc=e.$6pc=void 0,r=We(r),h=We(h),A=We(A),L=We(L),$=We($),l=We(l),E=We(E),k=We(k),b=We(b);const n=new Set;process.on("exit",()=>{n.forEach(f=>f())});class o{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&$.$zk(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=a.shouldGlobMatchFilePattern?null:(0,m.$Lr)(this.b).normalizedLowercase),this.u=a.excludePattern&&$.$zk(a.excludePattern),this.t=new Map,a.folderQueries.forEach(w=>{const y=Object.assign({},w.excludePattern||{},this.a.excludePattern||{}),S=w.folder.fsPath;a.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==S).forEach(D=>{(0,I.$Eg)(D,S)&&(y[A.$nc(S,D)]=!0)}),this.t.set(S,new t(y,S))})}cancel(){this.l=!0,n.forEach(a=>a())}walk(a,w,y,S,D,P){if(this.m=u.$ge.create(!1),this.l)return P(null,this.j);w.forEach(C=>{const p=A.$pc(C.fsPath);this.u&&this.u(C.fsPath,p)||this.J(S,{relativePath:C.fsPath,searchPath:void 0})}),this.r=u.$ge.create(!1),this.w(a,(C,p)=>{this.x(this.y,this,C,y,S,D,v=>{if(v){const N=(0,O.$qj)(v);console.error(N),this.q.push(N),p(v,void 0)}else p(null,void 0)})},(C,p)=>{this.m.stop();const v=C?L.$Jb(C)[0]:null;P(v,this.j)})}w(a,w,y){const S=new Array(a.length),D=new Array(a.length);let P=!1,C=0;if(a.length===0)return y(null,[]);a.forEach((p,v)=>{w(p,(N,T)=>{if(N?(P=!0,S[v]=null,D[v]=N):(S[v]=T,D[v]=null),++C===a.length)return y(P?D:null,S)})})}x(a,w,...y){try{a.apply(w,y)}catch(S){y[y.length-1](S)}}y(a,w,y,S,D){const P=a.folder.fsPath,C=E.$j,p=()=>j&&j.kill();n.add(p);let v=_=>{n.delete(p),v=()=>{},D(_)},N="";const T=this.D(),M=(0,d.$3pc)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression,w),j=M.cmd,z=!Object.keys(M.siblingClauses).length,F=M.rgArgs.args.map(_=>_.match(/^-/)?_:`'${_}'`).join(" ");let B=`${M.rgDiskPath} ${F}
 - cwd: ${M.cwd}`;M.rgArgs.siblingClauses&&(B+=`
 - Sibling clauses: ${JSON.stringify(M.rgArgs.siblingClauses)}`),S({message:B}),this.s=0,this.z(j,"utf8",S,(_,re,U)=>{if(_){v(_);return}if(this.j){v();return}const Q=(N+(C?l.$mm(re||""):re)).split(`
`);if(U){const ee=Q.length;Q[ee-1]=Q[ee-1].trim(),Q[ee-1]||Q.pop()}else N=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=Q.length,z){for(const ee of Q)if(this.J(y,{base:P,relativePath:ee,searchPath:this.N(a,ee)}),this.j){p();break}(U||this.j)&&v();return}this.G(a,T,P,Q,y),U&&(this.H(T,P,y),v())})}spawnFindCmd(a){const w=this.t.get(a.folder.fsPath),y=w.getBasenameTerms(),S=w.getPathTerms(),D=["-L","."];if(y.length||S.length){D.push("-not","(","(");for(const P of y)D.push("-name",P),D.push("-o");for(const P of S)D.push("-path",P),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),r.spawn("find",D,{cwd:a.folder.fsPath})}readStdout(a,w,y){let S="";this.z(a,w,()=>{},(D,P,C)=>{if(D){y(D);return}S+=P,C&&y(null,S)})}z(a,w,y,S){let D=(p,v,N)=>{(p||N)&&(D=()=>{},this.r?.stop()),S(p,v,N)},P=!1;a.stdout?(this.A(a.stdout,w,D),a.stdout.once("data",()=>P=!0)):y({message:"stdout is null"});let C;a.stderr?C=this.B(a.stderr):y({message:"stderr is null"}),a.on("error",p=>{D(p)}),a.on("close",p=>{let v;!P&&(v=this.C(C,w))&&s(v)?D(new Error(`command failed with error code ${p}: ${this.C(C,w)}`)):(this.g&&p===0&&(this.j=!0),D(null,"",!0))})}A(a,w,y){const S=new R.StringDecoder(w);return a.on("data",D=>{y(null,S.write(D))}),S}B(a){const w=[];return a.on("data",y=>{w.push(y)}),w}C(a,w){const y=new R.StringDecoder(w);return a.map(S=>y.write(S)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:w},y,S,D){S.indexOf(this.b)!==-1&&this.J(D,{base:y,relativePath:this.b,searchPath:this.N(a,this.b)});const P=C=>{const p=A.$pc(C),v=A.$oc(C);let N=w[v];N||(N=w[v]=[],P(v)),N.push({base:y,relativePath:C,basename:p,searchPath:this.N(a,C)})};S.forEach(P)}H({rootEntries:a,pathToEntries:w},y,S){const D=this,P=this.t.get(y),C=this.b;function p(v){D.o++;const N=(0,g.$9L)(()=>v.map(T=>T.basename));for(let T=0,M=v.length;T<M;T++){const j=v[T],{relativePath:z,basename:F}=j;if(P.test(z,F,C!==F?N:void 0))continue;const B=w[z];if(B)p(B);else{if(D.p++,z===C)continue;D.J(S,j)}if(D.j)break}}p(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,w,y,S,D){const P=a.folder,C=(0,g.$9L)(()=>y);this.w(y,(p,v)=>{if(this.l||this.j)return v(null);const N=w?[w,p].join(A.sep):p;if(this.t.get(a.folder.fsPath).test(N,p,this.a.filePattern!==p?C:void 0))return v(null);const T=[P.fsPath,N].join(A.sep);h.lstat(T,(M,j)=>{if(M||this.l||this.j)return v(null);this.L(T,j,(z,F)=>z||this.l||this.j?v(null):F.isDirectory()?(this.o++,this.M(T,j,(B,_)=>B||this.l||this.j||(_=_||"",this.v[_])?v(null):(this.v[_]=!0,c.Promises.readdir(T).then(re=>{if(this.l||this.j)return v(null);this.I(a,N,re,S,U=>v(U||null))},re=>{v(null)})))):(this.p++,N===this.b||this.h&&b.$jg(F.size)&&F.size>this.h||this.J(S,{base:P.fsPath,relativePath:N,searchPath:this.N(a,N)}),v(null,void 0)))})},p=>{const v=p&&L.$Jb(p);return D(v&&v.length>0?v[0]:void 0)})}J(a,w){this.K(w)&&(!this.d||this.d(w.relativePath,A.$pc(w.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(w))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$4L)(a,this.c);if(this.b)return(0,g.$4L)(a,this.b,!1)}return!0}L(a,w,y){return w.isSymbolicLink()?h.stat(a,y):y(null,w)}M(a,w,y){return w.isSymbolicLink()?h.realpath(a,(S,D)=>S?y(S):y(null,D)):y(null,a)}N(a,w){return a.folderName?A.$lc(a.folderName,w):w}}e.$6pc=o;class i{constructor(a,w){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.d=w,this.c=new o(a)}search(a,w,y){this.c.walk(this.a,this.b,this.d,a,w,(S,D)=>{y(S,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$7pc=i;class t{constructor(a,w){this.expression=a,this.c=w,this.d(a)}d(a){let w,y;Object.keys(a).filter(S=>a[S]).forEach(S=>{A.$kc(S)?(w=w||$.$uk(),w[S]=a[S]):(y=y||$.$uk(),y[S]=a[S])}),this.a=w&&$.$zk(w,{trimForExclusions:!0}),this.b=y&&$.$zk(y,{trimForExclusions:!0})}test(a,w,y){return this.b&&this.b(a,w,y)||this.a&&this.a(A.$lc(this.c,a),w,y)}getBasenameTerms(){const a=[];return this.a&&a.push(...$.$Bk(this.a)),this.b&&a.push(...$.$Bk(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...$.$Ck(this.a)),this.b&&a.push(...$.$Ck(this.b)),a}}function s(f){const a=f.trim().split(`
`),w=a[0].trim();if(w.startsWith("Error parsing regex"))return w;if(w.startsWith("regex parse error"))return k.$0f(a[a.length-1].trim());if(w.startsWith("error parsing glob")||w.startsWith("unsupported encoding"))return w.charAt(0).toUpperCase()+w.substr(1);if(w==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(w.startsWith("Literal "))return w}}),define(Ee[400],Se([1,0,104,22,207,21,19]),function(ce,e,r,h,A,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HE=e.$GE=e.$yE=e.DecodeStreamErrorKind=e.$xE=e.$wE=e.$vE=e.$tE=e.$sE=e.$rE=e.$qE=void 0,e.$uE=O,e.$zE=c,e.$AE=g,e.$BE=d,e.$CE=m,e.$DE=n,e.$EE=y,e.$FE=S,e.$qE="utf8",e.$rE="utf8bom",e.$sE="utf16be",e.$tE="utf16le";function O(D){return[e.$qE,e.$rE,e.$sE,e.$tE].some(P=>P===D)}e.$vE=[254,255],e.$wE=[255,254],e.$xE=[239,187,191];const $=512,l=512,I=512*8,E=512*128;var u;(function(D){D[D.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(u||(e.DecodeStreamErrorKind=u={}));class k extends Error{constructor(P,C){super(P),this.decodeStreamErrorKind=C}}e.$yE=k;class b{static async create(P){let C;if(P!==e.$qE)C=(await(0,A.$pE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(m(P));else{const p=new TextDecoder;C={write(v){return p.decode(v,{stream:!0})},end(){return p.decode()}}}return new b(C)}constructor(P){this.a=P}write(P){return this.a.write(P)}end(){return this.a.end()}}function c(D,P){const C=P.minBytesRequiredForDetection??P.guessEncoding?I:l;return new Promise((p,v)=>{const N=(0,r.$Ce)(B=>B.join("")),T=[];let M=0,j;const z=new R.$xe,F=async()=>{try{const B=await S({buffer:h.$Oe.concat(T),bytesRead:M},P.guessEncoding,P.candidateGuessEncodings);if(B.seemsBinary&&P.acceptTextOnly)throw new k("Stream is binary but only text is accepted for decoding",u.STREAM_IS_BINARY);B.encoding=await P.overwriteEncoding(B.encoding),j=await b.create(B.encoding);const _=j.write(h.$Oe.concat(T).buffer);N.write(_),T.length=0,M=0,p({stream:N,detected:B})}catch(B){z.cancel(),N.destroy(),v(B)}};(0,r.$Ge)(D,{onData:async B=>{j?N.write(j.write(B.buffer)):(T.push(B),M+=B.byteLength,M>=C&&(D.pause(),await F(),setTimeout(()=>D.resume())))},onError:B=>N.error(B),onEnd:async()=>{j||await F(),N.end(j?.end())}},z.token)})}async function g(D,P,C){const v=(await(0,A.$pE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(m(P),C);let N=!1,T=!1;return{read(){if(T)return null;const M=D.read();if(typeof M!="string"){if(T=!0,!N&&C?.addBOM)switch(P){case e.$qE:case e.$rE:return h.$Oe.wrap(Uint8Array.from(e.$xE));case e.$sE:return h.$Oe.wrap(Uint8Array.from(e.$vE));case e.$tE:return h.$Oe.wrap(Uint8Array.from(e.$wE))}const j=v.end();return j&&j.length>0?(N=!0,h.$Oe.wrap(j)):null}return N=!0,h.$Oe.wrap(v.write(M))}}}async function d(D){return(await(0,A.$pE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(m(D))}function m(D){return D===e.$rE||D===null?e.$qE:D}function n(D,P){if(!D||P<e.$vE.length)return null;const C=D.readUInt8(0),p=D.readUInt8(1);if(C===e.$vE[0]&&p===e.$vE[1])return e.$sE;if(C===e.$wE[0]&&p===e.$wE[1])return e.$tE;if(P<e.$xE.length)return null;const v=D.readUInt8(2);return C===e.$xE[0]&&p===e.$xE[1]&&v===e.$xE[2]?e.$rE:null}const o=["ascii","utf-16","utf-32"];async function i(D,P){const C=await(0,A.$pE)("jschardet","dist/jschardet.min.js"),p=D.slice(0,E),v=w(p.buffer);P&&(P=(0,L.$Jb)(P.map(M=>a(M))),P.length===0&&(P=void 0));const N=C.detect(v,P?{detectEncodings:P}:void 0);if(!N||!N.encoding)return null;const T=N.encoding.toLowerCase();return 0<=o.indexOf(T)?null:f(N.encoding)}const t={ibm866:"cp866",big5:"cp950"};function s(D){return D.replace(/[^a-zA-Z0-9]/g,"").toLowerCase()}function f(D){const P=s(D);return t[P]||P}function a(D){const P=s(D);return e.$HE[P].guessableName}function w(D){let P="";for(let C=0;C<D.length;C++)P+=String.fromCharCode(D[C]);return P}function y(D){switch(D){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const P=D.match(/windows(\d+)/);return P?"windows-"+P[1]:D}}}function S({buffer:D,bytesRead:P},C,p){let v=n(D,P),N=!1;if(v!==e.$sE&&v!==e.$tE&&D){let T=!0,M=!0,j=!1;for(let z=0;z<P&&z<$;z++){const F=z%2===1,B=D.readUInt8(z)===0;if(B&&(j=!0),T&&(F&&!B||!F&&B)&&(T=!1),M&&(F&&B||!F&&!B)&&(M=!1),B&&!T&&!M)break}j&&(T?v=e.$tE:M?v=e.$sE:N=!0)}return C&&!N&&!v&&D?i(D.slice(0,P),p).then(T=>({seemsBinary:!1,encoding:T})):{seemsBinary:N,encoding:v}}e.$GE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom",guessableName:"UTF-8"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3,guessableName:"UTF-16LE"},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4,guessableName:"UTF-16BE"},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5,guessableName:"windows-1252"},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16,guessableName:"windows-1250"},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17,guessableName:"ISO-8859-2"},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19,guessableName:"windows-1251"},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20,guessableName:"IBM866"},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21,guessableName:"ISO-8859-5"},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22,guessableName:"KOI8-R"},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25,guessableName:"windows-1253"},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26,guessableName:"ISO-8859-7"},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27,guessableName:"windows-1255"},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28,guessableName:"ISO-8859-8"},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36,guessableName:"Big5"},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38,guessableName:"SHIFT_JIS"},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39,guessableName:"EUC-JP"},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40,guessableName:"EUC-KR"},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45,guessableName:"GB2312"},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}},e.$HE=(()=>{const D={};for(const P in e.$GE)e.$GE[P].guessableName&&(D[P]=e.$GE[P]);return D})()}),define(Ee[171],Se([1,0,400,34,170]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cqc=void 0,h=We(h);class R extends A.$3oc{constructor(O,$,l=h,I="searchProcess"){super({query:O,provider:$},{readdir:E=>l.Promises.readdir(E.fsPath),toCanonicalName:E=>(0,r.$EE)(E)},I)}}e.$cqc=R}),define(Ee[172],Se([1,0,58,415,399,19,79,39,13,2,38,100,416,397,130]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9pc=e.$8pc=void 0,e.$0pc=t,e.$$pc=f,e.$_pc=w,e.$aqc=y,e.$bqc=D,r=We(r);const c=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(C,p){this.a=C,this.b=p}provideTextSearchResults(C,p,v,N){return this.a.appendLine(`provideTextSearchResults ${C.pattern}, ${JSON.stringify({...p,folder:p.folder.toString()})}`),new Promise((T,M)=>{N.onCancellationRequested(()=>Q());const j={...p,numThreads:this.b},z=t(C,j),F=p.folder.fsPath,B=z.map($e=>$e.match(/^-/)?$e:`'${$e}'`).join(" ");this.a.appendLine(`${c} ${B}
 - cwd: ${F}`);let _=r.spawn(c,z,{cwd:F});_.on("error",$e=>{console.error($e),this.a.appendLine("Error: "+($e&&$e.message)),M((0,I.$ZL)(new I.$XL($e&&$e.message,I.SearchErrorCode.rgProcessError)))});let re=!1;const U=new n(p.maxResults,p.folder,p.previewOptions);U.on("result",$e=>{re=!0,ue="",v.report($e)});let G=!1;const Q=()=>{G=!0,_?.kill(),U?.cancel()};let ee=!1;U.on("hitLimit",()=>{ee=!0,Q()});let ue="";_.stdout.on("data",$e=>{U.handleData($e),re||(ue+=$e)});let ne=!1;_.stdout.once("data",()=>ne=!0);let De="";_.stderr.on("data",$e=>{const K=$e.toString();this.a.appendLine(K),De.length+K.length<1e6&&(De+=K)}),_.on("close",()=>{if(this.a.appendLine(ne?"Got data from stdout":"No data from stdout"),this.a.appendLine(re?"Got result from parser":"No result from parser"),ue&&this.a.appendLine(`Got data without result: ${ue}`),this.a.appendLine(""),G)T({limitHit:ee});else{U.flush(),_=null;let $e;De&&!ne&&($e=d(De))?M((0,I.$ZL)(new I.$XL($e.message,$e.code))):T({limitHit:ee})}})})}}e.$8pc=g;function d(P){const C=P.split(`
`),p=C[0].trim();if(C.some(N=>N.startsWith("regex parse error")))return new I.$XL(m(C),I.SearchErrorCode.regexParseError);const v=p.match(/grep config error: unknown encoding: (.*)/);if(v)return new I.$XL(`Unknown encoding: ${v[1]}`,I.SearchErrorCode.unknownEncoding);if(p.startsWith("error parsing glob"))return new I.$XL(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.globParseError);if(p.startsWith("the literal"))return new I.$XL(p.charAt(0).toUpperCase()+p.substr(1),I.SearchErrorCode.invalidLiteral);if(p.startsWith("PCRE2: error compiling pattern"))return new I.$XL(p,I.SearchErrorCode.regexParseError)}function m(P){const C=["Regex parse error"],p=P.filter(v=>v.startsWith("PCRE2:"));if(p.length>=1){const v=p[0].replace("PCRE2:","");if(v.indexOf(":")!==-1&&v.split(":").length>=2){const N=v.split(":")[1];C.push(":"+N)}}return C.join("")}class n extends h.EventEmitter{constructor(C,p,v){super(),this.g=C,this.h=p,this.j=v,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new A.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(C,p){return super.on(C,p),this}handleData(C){if(this.b)return;const p=typeof C=="string"?C:this.d.write(C);this.k(p)}k(C){let p=C.indexOf(`
`);const v=this.a+C;if(p>=0)p+=this.a.length;else{this.a=v;return}let N=0;for(;p>=0;)this.m(v.substring(N,p).trim()),N=p+1,p=v.indexOf(`
`,N);this.a=v.substring(N)}m(C){if(this.b||!C)return;let p;try{p=JSON.parse(C)}catch{throw new Error(`malformed line from rg: ${C}`)}if(p.type==="match"){const v=o(p.data.path),N=l.URI.joinPath(this.h,v),T=this.n(p.data,N);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(p.type==="context"){const v=o(p.data.path),N=l.URI.joinPath(this.h,v);this.o(p.data,N).forEach(M=>this.p(M))}}n(C,p){const v=C.line_number-1,N=o(C.lines),T=Buffer.from(N);let M=0,j=0,z=v;C.submatches.length===0&&C.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.$Jb)(C.submatches.map((B,_)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const re=o(B.match),U=T.slice(M,B.start).toString(),G=i(U),Q=G.numLines>0?G.lastLineLength:G.lastLineLength+j,ee=i(re),ue=G.numLines+z,ne=ee.numLines+ue,De=ee.numLines>0?ee.lastLineLength:ee.lastLineLength+Q;return M=B.end,j=De,z=ne,new E.$GL(ue,Q,ne,De)}));return(0,b.$1pc)(p,N,F,this.j)}o(C,p){const v=o(C.lines),N=C.line_number;return v.replace(/\r?\n$/,"").split(`
`).map((T,M)=>({text:T,uri:p,lineNumber:N+M}))}p(C){this.emit("result",C)}}e.$9pc=n;function o(P){return P.bytes?Buffer.from(P.bytes,"base64").toString():P.text}function i(P){const C=/\n/g;let p=0,v=-1,N;for(;N=C.exec(P);)p++,v=N.index;const T=v>=0?P.length-v-1:P.length;return{numLines:p,lastLineLength:T}}function t(P,C){const p=["--hidden","--no-require-git"];p.push(P.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:v,otherIncludes:N}=(0,L.$K)(C.includes,M=>M.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const M=new Set;N.forEach(j=>{M.add(j)}),p.push("-g","!*"),M.forEach(j=>{s(j).map(b.$Zpc).forEach(z=>{p.push("-g",z)})})}v&&v.length&&v.forEach(M=>{p.push("-g",M)}),C.excludes.map(b.$Zpc).forEach(M=>p.push("-g",`!${M}`)),C.maxFileSize&&p.push("--max-filesize",C.maxFileSize+""),C.useIgnoreFiles?C.useParentIgnoreFiles||p.push("--no-ignore-parent"):p.push("--no-ignore"),C.followSymlinks&&p.push("--follow"),C.encoding&&C.encoding!=="utf8"&&p.push("--encoding",C.encoding),C.numThreads&&p.push("--threads",`${C.numThreads}`),P.pattern==="--"&&(P.isRegExp=!0,P.pattern="\\-\\-"),P.isMultiline&&!P.isRegExp&&(P.pattern=(0,$.$if)(P.pattern),P.isRegExp=!0),C.usePCRE2&&p.push("--pcre2"),p.push("--crlf"),P.isRegExp&&(P.pattern=f(P.pattern),p.push("--engine","auto"));let T;if(P.isWordMatch){const j=(0,$.$rf)(P.pattern,!!P.isRegExp,{wholeWord:P.isWordMatch}).source.replace(/\\\//g,"/");p.push("--regexp",j)}else if(P.isRegExp){let M=w(P.pattern);M=y(M),p.push("--regexp",M)}else T=P.pattern,p.push("--fixed-strings");return p.push("--no-config"),C.useGlobalIgnoreFiles||p.push("--no-ignore-global"),p.push("--json"),P.isMultiline&&p.push("--multiline"),C.beforeContext&&p.push("--before-context",C.beforeContext+""),C.afterContext&&p.push("--after-context",C.afterContext+""),p.push("--"),T&&p.push(T),p.push("."),p}function s(P){return D(P).flatMap(p=>{const v=(0,O.$xk)(p,"/");return v.map((N,T)=>v.slice(0,T+1).join("/"))})}function f(P){const C=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;P.match(C);)P=P.replace(C,"$1\\x{$2}");const p=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;P.match(p);)P=P.replace(p,"$1\\x{$2}");return P}const a=P=>P.type==="Assertion"&&P.kind==="lookbehind";function w(P){let C;try{C=new u.RegExpParser().parsePattern(P)}catch{return P}let p="",v=0;const N=(j,z,F)=>{p+=P.slice(v,j)+F,v=z},T=[];return new u.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const z=T[0];if(!z)N(j.start,j.end,"\\r?\\n");else if(!T.some(a))if(z.type==="CharacterClass")if(z.negate){const F=P.slice(z.start+2,j.start)+P.slice(j.end,z.end-1);z.parent?.type==="Quantifier"?N(z.start,z.end,F?`[^${F}]`:"."):N(z.start,z.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=P.slice(z.start+1,j.start)+P.slice(j.end,z.end-1);N(z.start,z.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else z.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){T.unshift(j)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(j){T.unshift(j)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(j){T.unshift(j)},onCharacterClassLeave(){T.shift()},onAssertionEnter(j){a(j)&&T.push(j)},onAssertionLeave(j){T[0]===j&&T.shift()}}).visit(C),p+=P.slice(v),p}function y(P){return P.replace(/\n/g,"\\r?\\n")}function S(P){let C=!1,p=!1,v="",N="";for(let T=0;T<P.length;T++){const M=P[T];switch(M){case"\\":p?(C?N+="\\"+M:v+="\\"+M,p=!1):p=!0;break;case"{":if(p)C?N+=M:v+=M,p=!1;else{if(C)return{strInBraces:v+"{"+N+"{"+P.substring(T+1)};C=!0}break;case"}":if(p)C?N+=M:v+=M,p=!1;else{if(C)return{fixedStart:v,strInBraces:N,fixedEnd:P.substring(T+1)};v+=M}break;default:C?N+=(p?"\\":"")+M:v+=(p?"\\":"")+M,p=!1;break}}return{strInBraces:v+(C?"{"+N:"")}}function D(P){const{fixedStart:C,strInBraces:p,fixedEnd:v}=S(P);if(C===void 0||v===void 0)return[p];let N=(0,O.$xk)(p,",");N.length||(N=[""]);const T=D(v);return N.flatMap(M=>{const j=C+M;return T.map(z=>j+z)})}}),define(Ee[401],Se([1,0,21,172,90,15]),function(ce,e,r,h,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=void 0;class L{constructor(l,I){this.b=l,this.c=I,this.a=new Set,process.once("exit",()=>this.e())}async provideTextSearchResults(l,I,E,u){const k=await this.c(),b=new h.$8pc(this.b,k),c={...I,numThreads:k};if(I.folder.scheme===R.Schemas.vscodeUserData){const g={...c,folder:I.folder.with({scheme:R.Schemas.file})},d=new A.$sw(m=>E.report({...m,uri:m.uri.with({scheme:I.folder.scheme})}));return this.d(u,m=>b.provideTextSearchResults(l,g,d,m))}else return this.d(u,g=>b.provideTextSearchResults(l,c,E,g))}async d(l,I){const E=O(l);this.a.add(E);const u=await I(E.token);return this.a.delete(E),u}e(){this.a.forEach(l=>l.cancel())}}e.$fqc=L;function O($){const l=new r.$xe;return $.onCancellationRequested(()=>l.cancel()),l}}),define(Ee[402],Se([1,0,34,172,171]),function(ce,e,r,h,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=void 0,r=We(r);class R{constructor($,l){this.a=$,this.b=l}search($,l,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const E={appendLine(k){I({message:k})}},u=new A.$cqc(this.a,new h.$8pc(E,this.b),r);return new Promise((k,b)=>u.search(c=>{l(c.map(L))},$).then(c=>k({limitHit:c.limitHit??!1,type:"success",stats:c.stats,messages:[]}),b))}}e.$dqc=R;function L(O){return{path:O.resource&&O.resource.fsPath,results:O.results,numMatches:(O.results||[]).reduce(($,l)=>{if(l.ranges){const I=l;return $+(Array.isArray(I.ranges)?I.ranges.length:1)}else return $+1},0)}}}),define(Ee[403],Se([1,0,19,9,14,4,141,16,43,2,28,38,398,402]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eqc=void 0,r=We(r);class b{static{this.a=512}constructor(o="searchProcess",i){this.d=o,this.f=i,this.b=Object.create(null)}fileSearch(o){let i;const t=d(o),s=new R.$me({onDidAddFirstListener:()=>{i=(0,h.$sh)(async f=>{const a=await this.f?.();return this.doFileSearchWithEngine(u.$7pc,t,w=>s.fire(w),f,b.a,a)}),i.then(f=>s.fire(f),f=>s.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}textSearch(o){let i;const t=d(o),s=new R.$me({onDidAddFirstListener:()=>{i=(0,h.$sh)(f=>this.g(t,a=>s.fire(a),f)),i.then(f=>s.fire(f),f=>s.fire({type:"error",error:{message:f.message,stack:f.stack}}))},onDidRemoveLastListener:()=>{i.cancel()}});return s.event}async g(o,i,t){o.maxFileSize=this.h().maxFileSize;const s=await this.f?.();return new k.$dqc(o,s).search(t,i,i)}h(){return{maxFileSize:16*I.$Hl.GB}}doFileSearch(o,i,t,s){return this.doFileSearchWithEngine(u.$7pc,o,t,s,b.a,i)}doFileSearchWithEngine(o,i,t,s,f=b.a,a){let w=0;const y=D=>{Array.isArray(D)?(w+=D.length,t(D.map(P=>this.j(P)))):D.relativePath?(w++,t(this.j(D))):t(D)};if(i.sortByScore){let D=this.n(i,y,s);if(!D){const P=i.maxResults?Object.assign({},i,{maxResults:null}):i,C=new o(P,a);D=this.k(C,i,t,y,s)}return new Promise((P,C)=>{D.then(([p,v])=>{const N=v.map(T=>this.j(T));this.q(N,t,f),P(p)},C)})}const S=new o(i,a);return this.s(S,y,f,s).then(D=>({limitHit:D.limitHit,type:"success",stats:{detailStats:D.stats,type:this.d,fromCache:!1,resultCount:w,sortingTime:void 0},messages:[]}))}j(o){return{path:o.base?(0,O.$lc)(o.base,o.relativePath):o.relativePath}}k(o,i,t,s,f){const a=new R.$me;let w=(0,h.$sh)(S=>{let D=[];const P=C=>{Array.isArray(C)?D=C:(s(C),a.fire(C))};return this.s(o,P,-1,S).then(C=>[C,D])}),y;if(i.cacheKey){y=this.l(i.cacheKey);const S={promise:w,event:a.event,resolved:!1};y.resultsToSearchCache[i.filePattern||""]=S,w.then(()=>{S.resolved=!0},D=>{delete y.resultsToSearchCache[i.filePattern||""]}),w=this.t(w)}return w.then(([S,D])=>{const P=y?y.scorerCache:Object.create(null),C=(typeof i.maxResults!="number"||i.maxResults>0)&&$.$ge.create(!1);return this.o(i,D,P,f).then(p=>{const v=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:v,fromCache:!1,type:this.d,resultCount:p.length},messages:S.messages,limitHit:S.limitHit||typeof i.maxResults=="number"&&D.length>i.maxResults},p]})})}l(o){const i=this.b[o];return i||(this.b[o]=new c)}n(o,i,t){const s=o.cacheKey&&this.b[o.cacheKey];if(!s)return;const f=this.r(s,o.filePattern||"",i,t);if(f)return f.then(([a,w,y])=>{const S=$.$ge.create(!1);return this.o(o,w,s.scorerCache,t).then(D=>{const P=S.elapsed(),C={fromCache:!0,detailStats:y,type:this.d,resultCount:w.length,sortingTime:P};return[{type:"success",limitHit:a.limitHit||typeof o.maxResults=="number"&&w.length>o.maxResults,stats:C,messages:[]},D]})})}o(o,i,t,s){const f=(0,L.$Lr)(o.filePattern||""),a=(y,S)=>(0,L.$Kr)(y,S,f,!0,g,t),w=typeof o.maxResults=="number"?o.maxResults:E.$ML;return r.$Ib(i,a,w,1e4,s)}q(o,i,t){if(t&&t>0)for(let s=0;s<o.length;s+=t)i(o.slice(s,s+t));else i(o)}r(o,i,t,s){const f=$.$ge.create(!1),a=i.indexOf(O.sep)>=0;let w;for(const P in o.resultsToSearchCache)if(i.startsWith(P)){if(a&&P.indexOf(O.sep)<0&&P!=="")continue;const C=o.resultsToSearchCache[P];w={promise:this.t(C.promise),event:C.event,resolved:C.resolved};break}if(!w)return null;const y=f.elapsed(),S=$.$ge.create(!1),D=w.event(t);return s&&s.onCancellationRequested(()=>{D.dispose()}),w.promise.then(([P,C])=>{if(s&&s.isCancellationRequested)throw(0,A.$8)();const p=[],v=(0,L.$Lr)(i).normalizedLowercase;for(const N of C)(0,E.$4L)(N,v)&&p.push(N);return[P,p,{cacheWasResolved:w.resolved,cacheLookupTime:y,cacheFilterTime:S.elapsed(),cacheEntryCount:C.length}]})}s(o,i,t,s){return new Promise((f,a)=>{let w=[];s?.onCancellationRequested(()=>o.cancel()),o.search(y=>{y&&(t?(w.push(y),t>0&&w.length>=t&&(i(w),w=[])):i(y))},y=>{i(y)},(y,S)=>{w.length&&i(w),y?(i({message:"Search finished. Error: "+y.message}),a(y)):(i({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),f(S))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}t(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,t){return o.then(i,t)}catch(i){return this.then(void 0,i)}finally(i){return o.finally(i)}}}}e.$eqc=b;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(n){return(0,O.$pc)(n.relativePath)}getItemDescription(n){return(0,O.$oc)(n.relativePath)}getItemPath(n){return n.relativePath}};function d(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(m),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>l.URI.revive(o))}}function m(n){return{...n,folder:l.URI.revive(n.folder)}}}),define(Ee[404],Se([1,0,3,15,2,34,12,42,30,20,103,73,38,403,401,130,171]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0,R=We(R);let d=class extends I.$8oc{constructor(n,o,i,t,s){super(n,i,s),this.D=t,this.w=R,this.x=-1,this.y=null,this.z=!1,this.B=new r.$Vc,this.C=!1,this.getNumThreads=this.getNumThreads.bind(this),this.getNumThreadsCached=this.getNumThreadsCached.bind(this),this.E=this.E.bind(this);const f=new c.$2pc("RipgrepSearchUD",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.vscodeUserData,new b.$fqc(f,this.getNumThreadsCached))),o.remote.isRemote&&o.remote.authority&&this.F(),t.getConfigProvider().then(a=>{this.C||this.B.add(a.onDidChangeConfiguration(this.E))})}E(n){n.affectsConfiguration("search")&&(this.A=void 0)}async getNumThreads(){return(await this.D.getConfigProvider()).getConfiguration("search").get("ripgrep.maxThreads")}async getNumThreadsCached(){return this.A||(this.A=this.getNumThreads()),this.A}dispose(){this.C=!0,this.B.dispose()}$enableExtensionHostSearch(){this.F()}F(){if(this.z)return;this.z=!0;const n=new c.$2pc("RipgrepSearchEH",this.q);this.B.add(this.registerTextSearchProvider(h.Schemas.file,new b.$fqc(n,this.getNumThreadsCached))),this.B.add(this.G(h.Schemas.file,new k.$eqc("fileSearchProvider",this.getNumThreadsCached)))}G(n,o){const i=this.d++;return this.y=o,this.x=i,this.c.$registerFileSearchProvider(i,this.s(n)),(0,r.$Uc)(()=>{this.y=null,this.c.$unregisterProvider(i)})}$provideFileSearchResults(n,o,i,t){const s=(0,I.$9oc)(i);if(n===this.x){const f=Date.now();return this.H(n,o,s,t).then(a=>{const w=Date.now()-f;return this.q.debug(`Ext host file search time: ${w}ms`),a})}return super.$provideFileSearchResults(n,o,i,t)}async doInternalFileSearchWithCustomCallback(n,o,i){const t=f=>{if((0,u.$3L)(f)&&(f=[f]),Array.isArray(f)){i(f.map(a=>A.URI.file(a.path)));return}f.message&&this.q.debug("ExtHostSearch",f.message)};if(!this.y)throw new Error("No internal file search handler");const s=await this.getNumThreadsCached();return this.y.doFileSearch(n,s,t,o)}async H(n,o,i,t){return this.doInternalFileSearchWithCustomCallback(i,t,s=>{this.c.$handleFileMatch(n,o,s)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,o){return new g.$cqc(n,o,void 0,"textSearchProvider")}};e.$gqc=d,e.$gqc=d=Je([Ve(0,l.$WP),Ve(1,$.$aQ),Ve(2,E.$Tnc),Ve(3,O.$Znc),Ve(4,L.$_j)],d)}),define(Ee[131],Se([1,0,417,67,68,418,22,14,4,3,16,11,32,87,69]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e.$wi=e.$vi=e.$ui=void 0,e.$xi=a,e.$yi=w,e.$Ai=D,e.$Bi=P;const c=3e4;class g{traceSocketEvent(p,v){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,v)}constructor(p,v=""){this.f=!0,this.debugLabel=v,this.socket=p,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=T=>{if(this.traceSocketEvent(b.SocketDiagnosticsEventType.Error,{code:T?.code,message:T?.message}),T){if(T.code==="EPIPE")return;(0,O.$3)(T)}},this.socket.on("error",this.a);let N;this.b=T=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Close,{hadError:T}),this.f=!1,N&&clearTimeout(N)},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1,N=setTimeout(()=>p.destroy(),c)},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const v=N=>{this.traceSocketEvent(b.SocketDiagnosticsEventType.Read,N),p(L.$Oe.wrap(N))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(p){const v=N=>{p({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:N,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(p){const v=()=>{p()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(b.SocketDiagnosticsEventType.Write,p),this.socket.write(p.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,O.$3)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,O.$3)(v)}}end(){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((p,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),p();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent(b.SocketDiagnosticsEventType.NodeDrainEnd),p()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$ui=g;var d;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var m;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(m||(m={}));class n extends l.$Wc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,v){this.socket.traceSocketEvent(p,v)}constructor(p,v,N,T){super(),this.f=this.B(new $.$me),this.g=this.B(new $.$me),this.h=!1,this.j={state:m.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent(b.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:N?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new o(this,v,N,T,this.f,(M,j)=>this.m(M,j))),this.B(this.a.onError(M=>{console.error(M),(0,O.$3)(M),this.g.fire({type:b.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:M})})),this.b=new b.$pi,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let v=0;for(;v<p.byteLength;)this.a.writeMessage(p.slice(v,Math.min(v+d.MaxWebSocketMessageLength,p.byteLength)),{compressed:!0,opcode:2}),v+=d.MaxWebSocketMessageLength}m(p,{compressed:v,opcode:N}){if(this.h)return;this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,p);let T=d.MinHeaderByteSize;p.byteLength<126?T+=0:p.byteLength<2**16?T+=2:T+=8;const M=L.$Oe.alloc(T),j=v?64:0,z=N&15;if(M.writeUInt8(128|j|z,0),p.byteLength<126)M.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(p.byteLength>>>8&255,++F),M.writeUInt8(p.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(p.byteLength>>>24&255,++F),M.writeUInt8(p.byteLength>>>16&255,++F),M.writeUInt8(p.byteLength>>>8&255,++F),M.writeUInt8(p.byteLength>>>0&255,++F)}this.socket.write(L.$Oe.concat([M,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===m.PeekHeader){const v=this.b.peek(this.j.readLen),N=v.readUInt8(0),T=(N&128)>>>7,M=(N&64)>>>6,j=N&15,z=v.readUInt8(1),F=(z&128)>>>7,B=z&127;this.j.state=m.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(F?4:0)+(B===126?2:0)+(B===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=j,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===m.ReadHeader){const v=this.b.read(this.j.readLen),N=v.readUInt8(1),T=(N&128)>>>7;let M=N&127,j=1;M===126?M=v.readUInt8(++j)*2**8+v.readUInt8(++j):M===127&&(M=v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*0+v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j));let z=0;T&&(z=v.readUInt8(++j)*2**24+v.readUInt8(++j)*2**16+v.readUInt8(++j)*2**8+v.readUInt8(++j)),this.j.state=m.ReadBody,this.j.readLen=M,this.j.mask=z,this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===m.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),s(v,this.j.mask),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=m.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(b.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$vi=n;class o extends l.$Wc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Oe.alloc(0)}constructor(p,v,N,T,M,j){super(),this.n=p,this.r=M,this.s=j,this.a=this.B(new $.$me),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$me),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$me),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new i(this.n,T,N,{windowBits:15})),this.f=this.B(new t(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(p,v){this.g.push({data:p,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:v}=this.g.shift();if(this.f&&v.compressed){const N=await this.w(this.f,p);this.s(N,v)}else this.s(p,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,v){return new Promise((N,T)=>{p.write(v),p.flush(M=>N(M))})}acceptFrame(p,v,N){this.h.push({data:p,isCompressed:v,isLastFrameOfMessage:N}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const v=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,v,N){return new Promise((T,M)=>{p.write(v),N&&p.write(L.$Oe.fromByteArray([0,0,255,255])),p.flush(j=>T(j))})}}class i extends l.$Wc{get recordedInflateBytes(){return this.j?L.$Oe.concat(this.f):L.$Oe.alloc(0)}constructor(p,v,N,T){super(),this.h=p,this.j=v,this.a=this.B(new $.$me),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateError,{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateData,M),this.g.push(L.$Oe.wrap(M))}),N&&(this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialWrite,N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateWrite,p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent(b.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=L.$Oe.concat(this.g);this.g.length=0,p(v)})}}class t extends l.$Wc{constructor(p,v){super(),this.g=p,this.a=this.B(new $.$me),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateError,{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateData,N),this.f.push(L.$Oe.wrap(N))})}write(p){this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateWrite,p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent(b.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=L.$Oe.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),p(v)})}}function s(C,p){if(p===0)return;const v=C.byteLength>>>2;for(let F=0;F<v;F++){const B=C.readUInt32BE(F*4);C.writeUInt32BE(B^p,F*4)}const N=v*4,T=C.byteLength-N,M=p>>>24&255,j=p>>>16&255,z=p>>>8&255;T>=1&&C.writeUInt8(C.readUInt8(N)^M,N),T>=2&&C.writeUInt8(C.readUInt8(N+1)^j,N+1),T>=3&&C.writeUInt8(C.readUInt8(N+2)^z,N+2)}e.$wi=process.env.XDG_RUNTIME_DIR;const f={[E.Platform.Linux]:107,[E.Platform.Mac]:103};function a(){const C=(0,u.$2g)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const p=process.platform!=="darwin"&&e.$wi?e.$wi:(0,A.tmpdir)(),v=(0,I.$lc)(p,`vscode-ipc-${C}.sock`);return y(v),v}function w(C,p,v){const T=(0,r.createHash)("sha256").update(C).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${v}-${p}-sock`;const M=v.substr(0,4),j=p.substr(0,6);let z;return process.platform!=="darwin"&&e.$wi&&!process.env.VSCODE_PORTABLE?z=(0,I.$lc)(e.$wi,`vscode-${T}-${M}-${j}.sock`):z=(0,I.$lc)(C,`${M}-${j}.sock`),y(z),z}function y(C){const p=f[E.$u];typeof p=="number"&&C.length>=p&&console.warn(`WARNING: IPC handle "${C}" is longer than ${p} chars, try a shorter --user-data-dir`)}class S extends k.$ji{static b(p){const v=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(v,N=>({protocol:new b.$qi(new g(N,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(N,"close"))}))}constructor(p){super(S.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$zi=S;function D(C){return new Promise((p,v)=>{const N=(0,h.createServer)();N.on("error",v),N.listen(C,()=>{N.removeListener("error",v),p(new S(N))})})}function P(C,p){return new Promise((v,N)=>{const T=(0,h.createConnection)(C,()=>{T.removeListener("error",N),v(b.$ri.fromSocket(new g(T,`ipc-client${p}`),p))});T.once("error",N)})}}),define(Ee[405],Se([1,0,67,68,187,131,9,3,11,45,12,116,284,285,118,93,22]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=e.$6fc=e.$5fc=void 0,r=We(r),h=We(h);async function d(t,s,f,a,w){let y;for(let S=3;S&&(y?.dispose(),y=await new m(t,s,f,a,w).waitForReady(),!(w&&A.$5g[w]||!A.$5g[y.tunnelLocalPort]));S--);return y}class m extends O.$Wc{constructor(s,f,a,w,y){super(),this.m=f,this.n=y,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=s,this.b=r.createServer(),this.c=new L.$Eh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=w,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(f=>{f()})}async waitForReady(){const s=this.n??this.tunnelRemotePort,f=(0,c.$Fw)(this.m)?"0.0.0.0":"127.0.0.1";let a=await(0,A.$6g)(s,2,1e3,f),w=null;return this.b.listen(a,this.m),await this.c.wait(),w=this.b.address(),w||(a=0,this.b.listen(a,this.m),await this.c.wait(),w=this.b.address()),this.tunnelLocalPort=w.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${w.port}`,this}async r(s){s.pause();const f=(0,c.$Dw)(this.tunnelRemoteHost)||(0,c.$Fw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,u.$2l)(this.a,f,this.tunnelRemotePort),w=a.getSocket(),y=a.readEntireBuffer();a.dispose(),y.byteLength>0&&s.write(y.buffer),s.on("end",()=>{s.localAddress&&this.j.delete(s.localAddress),w.end()}),s.on("close",()=>w.end()),s.on("error",()=>{s.localAddress&&this.j.delete(s.localAddress),w instanceof R.$ui?w.socket.destroy():w.end()}),w instanceof R.$ui?this.t(s,w):this.s(s,w),s.localAddress&&this.j.set(s.localAddress,()=>{s.end(),w.end()})}s(s,f){f.onClose(()=>s.destroy()),f.onEnd(()=>s.end()),f.onData(a=>s.write(a.buffer)),s.on("data",a=>f.write(g.$Oe.wrap(a))),s.resume()}t(s,f){const a=f.socket;a.on("end",()=>s.end()),a.on("close",()=>s.end()),a.on("error",()=>{s.destroy()}),a.pipe(s),s.pipe(a)}}e.$5fc=m;let n=class extends c.$Iw{constructor(s,f,a,w,y){super(f,y),this.H=s,this.I=a,this.J=w}isPortPrivileged(s){return(0,c.$Gw)(s,this.t,$.OS,h.release())}F(s,f,a,w,y,S,D,P){const C=this.D(f,a);if(C)return++C.refcount,C.value;if((0,c.$zw)(s))return this.G(s,f,a,y,S,D,P);{this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${a} on local port ${y}.`);const p={commit:this.J.commit,quality:this.J.quality,addressProvider:s,remoteSocketFactoryService:this.H,signService:this.I,logService:this.r,ipcLogger:null},v=d(p,w,f,a,y);return this.r.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.z(f,a,v),v}}};e.$6fc=n,e.$6fc=n=Je([Ve(0,k.$Vl),Ve(1,I.$_j),Ve(2,b.$Yl),Ve(3,E.$sk),Ve(4,l.$_i)],n);let o=class extends n{constructor(s,f,a,w,y){super(s,f,a,w,y)}};e.$7fc=o,e.$7fc=o=Je([Ve(0,k.$Vl),Ve(1,I.$_j),Ve(2,b.$Yl),Ve(3,E.$sk),Ve(4,l.$_i)],o);let i=class extends O.$Wc{constructor(s,f,a,w,y){super(),this.b=s,this.c=f,this.f=a,this.g=w,this.h=y,this.a=new Map}async openTunnel(s,f,a,w,y,S,D,P,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${w} on local port ${S}.`),!this.a.has(s)){const p=new o(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(s,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(s))})}return this.a.get(s).openTunnel(f,a,w,y,S,D,P,C)}};e.$8fc=i,e.$8fc=i=Je([Ve(0,k.$Vl),Ve(1,I.$_j),Ve(2,E.$sk),Ve(3,b.$Yl),Ve(4,l.$_i)],i)}),define(Ee[406],Se([1,0,131,302,61,35,2,12,46]),function(ce,e,r,h,A,R,L,O,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.$lQ=void 0,h=We(h),A=We(A);class l{constructor(u,k,b){this.b=u,this.c=k,this.f=b,this.a=h.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(k.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",u=>this.c.error(u))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(u,k){const b=(g,d)=>{k.writeHead(g,{"content-type":"application/json"}),k.end(JSON.stringify(d||null),m=>m&&this.c.error(m))},c=[];u.setEncoding("utf8"),u.on("data",g=>c.push(g)),u.on("end",async()=>{try{const g=JSON.parse(c.join(""));let d;switch(g.type){case"open":d=await this.i(g);break;case"openExternal":d=await this.j(g);break;case"status":d=await this.l(g);break;case"extensionManagement":d=await this.k(g);break;default:b(404,`Unknown message type: ${g.type}`);break}b(200,d)}catch(g){const d=g instanceof Error?g.message:JSON.stringify(g);b(500,d),this.c.error("Error while processing pipe request",g)}})}async i(u){const{fileURIs:k,folderURIs:b,forceNewWindow:c,diffMode:g,mergeMode:d,addMode:m,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:i,remoteAuthority:t}=u,s=[];if(Array.isArray(b))for(const y of b)try{s.push({folderUri:L.URI.parse(y)})}catch{}if(Array.isArray(k))for(const y of k)try{(0,$.$$i)(y)?s.push({workspaceUri:L.URI.parse(y)}):s.push({fileUri:L.URI.parse(y)})}catch{}const f=i?L.URI.file(i):void 0,w={forceNewWindow:c,diffMode:g,mergeMode:d,addMode:m,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!f&&!m,waitMarkerFileURI:f,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,w)}async j(u){for(const k of u.uris){const b=L.URI.parse(k),c=b.scheme==="file"?b:k;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(u){const k=c=>c?.map(g=>/\.vsix$/i.test(g)?L.URI.parse(g):g),b={list:u.list,install:k(u.install),uninstall:k(u.uninstall),force:u.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",b)}async l(u){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&A.existsSync(this.f)&&A.unlinkSync(this.f)}}e.$lQ=l;let I=class extends l{constructor(u,k){super(u,k,(0,r.$xi)())}};e.$mQ=I,e.$mQ=I=Je([Ve(0,R.$gQ),Ve(1,O.$_j)],I)}),define(Ee[407],Se([1,0,62,394,389,301,52,376,2,15,10,406,111,337,375]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lqc=void 0,r=We(r);class c extends A.$Mpc{j(){const m=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(f,a,w){return f=t(f),m.a.has(f)?m.a.get(f).load(f,$.URI.file((0,u.$ir)(a.filename)),y=>o.apply(this,[y,a,w])):o.apply(this,arguments)};const i=n._resolveLookupPaths;n._resolveLookupPaths=(s,f)=>i.call(this,t(s),f);const t=s=>{for(const f of m.b){const a=f(s);if(a){s=a;break}}return s}}}class g extends L.$zoc{constructor(){super(...arguments),this.extensionRuntime=I.ExtensionRuntime.Node}async vb(){this.h.createInstance(k.$jqc);const m=this.h.invokeFunction(h.$Ipc);if(this.h.createInstance(O.$iqc),this.f.remote.isRemote&&this.f.remote.authority){const i=this.h.createInstance(E.$mQ);process.env.VSCODE_IPC_HOOK_CLI=i.ipcHandlePath}this.h.createInstance(b.$kqc),await this.h.createInstance(c,m,{mine:this.J,all:this.L}).install(),r.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,R.$hqc)(this.j,o,this,this.s,this.z,this.f),r.mark("code/extHost/didInitProxyResolver")}wb(m){return m.main}async xb(m,n,o){if(n.scheme!==l.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let i=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=m?.identifier.value;m&&await this.w.initializeLocalizedMessages(m);try{t&&r.mark(`code/extHost/willLoadExtensionCode/${t}`),i=ce.__$__nodeRequire(n.fsPath)}finally{t&&r.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return i}async $setRemoteEnvironment(m){if(this.f.remote.isRemote)for(const n in m){const o=m[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$lqc=g}),define(Ee[408],Se([1,0,58,22,4,3,134,11,23,2,34,69,12,283,72,118,93,405,30,20,77,383]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tqc=void 0,e.$mqc=t,e.$nqc=s,e.$oqc=f,e.$pqc=a,e.$qqc=y,e.$rqc=S,e.$sqc=D,$=We($),I=We(I);function t(p){const v=p.trim().split(`
`),N=[];return v.forEach(M=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(M);j&&j.length>=3&&N.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),N.reduce((M,j)=>(M[j.socket]=j,M),{})}function s(...p){const v=[].concat(...p.map(a));return[...new Map(v.filter(N=>N.st==="0A").map(N=>{const T=N.local_address.split(":");return{socket:parseInt(N.inode,10),ip:f(T[0]),port:parseInt(T[1],16)}}).map(N=>[N.ip+":"+N.port,N])).values()]}function f(p){let v="";if(p.length===8)for(let N=p.length-2;N>=0;N-=2)v+=parseInt(p.substr(N,2),16),N!==0&&(v+=".");else for(let N=0;N<p.length;N+=8){const T=p.substring(N,N+8);let M="";for(let j=8;j>=2;j-=2)M+=T.substring(j-2,j),(j===6||j===2)&&(M=parseInt(M,16).toString(16),v+=`${M}`,M="",N+j!==p.length-6&&(v+=":"))}return v}function a(p){const v=p.trim().split(`
`),N=v.shift().trim().split(/\s+/).filter(M=>M!=="rx_queue"&&M!=="tm->when");return v.map(M=>M.trim().split(/\s+/).reduce((j,z,F)=>(j[N[F]||F]=z,j),{}))}function w(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function y(p){const v=p.trim().split(`
`),N=[];return v.forEach(T=>{const M=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(T);M&&M.length>=4&&N.push({pid:parseInt(M[1],10),ppid:parseInt(M[2]),cmd:M[3]})}),N}async function S(p,v,N){const T=N.reduce((j,z)=>(j[z.pid]=z,j),{}),M=[];return p.forEach(({socket:j,ip:z,port:F})=>{const B=v[j]?v[j].pid:void 0,_=B?T[B]?.cmd:void 0;B&&_&&!w(_)&&M.push({host:z,port:F,detail:_,pid:B})}),M}function D(p,v,N){const T=new Map,M=y(v);for(const j of p){const z=N.get(j.port);if(z){T.set(j.port,z);continue}const F=M.find(B=>B.cmd.includes(`${j.port}`));if(F){let B=F,_;do _=M.find(re=>re.ppid===B.pid),_&&(B=_);while(_);T.set(j.port,{host:j.ip,port:j.port,pid:B.pid,detail:B.cmd,ppid:B.ppid})}else T.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return T}let P=class extends o.$nFb{constructor(v,N,T,M){super(v,N,T),this.D=N,this.F=M,this.y=void 0,this.z=new Map,this.C=!1,O.$k&&N.remote.isRemote&&N.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(v){if(v&&this.C)return;this.C=v;let N;this.y&&(N=this.y,await this.a.$onFoundNewCandidates(this.y));const T=new L.$Nm;let M=0;for(;this.C;){const j=new Date().getTime(),z=(await this.I()).filter(_=>(0,g.$Dw)(_.host)||(0,g.$Fw)(_.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(_=>_.port).join(", ")}`);const F=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${F} ms.`),M++>3&&T.update(F),(!N||JSON.stringify(N)!==JSON.stringify(z))&&(N=z,await this.a.$onFoundNewCandidates(N));const B=this.G(T.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${B} ms.`),await new Promise(_=>setTimeout(()=>_(),B))}}G(v){return Math.max(v*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(v=>v.port).join(", ")}`)}async I(){let v="",N="";try{v=await I.Promises.readFile("/proc/net/tcp","utf8"),N=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const T=s(v,N),M=await new Promise(G=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,ee,ue)=>{G(ee)})}),j=t(M),z=await I.Promises.readdir("/proc"),F=[];for(const G of z)try{const Q=Number(G),ee=$.$gh(l.URI.file("/proc"),G);if((await I.Promises.stat(ee.fsPath)).isDirectory()&&!isNaN(Q)){const ne=await I.Promises.readlink($.$gh(ee,"cwd").fsPath),De=await I.Promises.readFile($.$gh(ee,"cmdline").fsPath,"utf8");F.push({pid:Q,cwd:ne,cmd:De})}}catch{}const B=[],_=T.filter(G=>{const Q=j[G.socket];return Q||B.push(G),Q}),re=S(_,j,F);let U;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${B.length}`),B.length>0){const G=await new Promise(Q=>{(0,r.exec)("ps -F -A -l | grep root",(ee,ue,ne)=>{Q(ue)})});this.z=D(B,G,this.z),U=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${U.map(Q=>Q.port).join(", ")}`)}return re.then(G=>U?G.concat(U):G)}w(v){return async N=>{const T=new d.$5fc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,z,F,B){const _=await v.makeConnection();return C.connect(_,z,F,B)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new b.$Rl(0),connectionToken:v.connectionToken})}},signService:this.F},"localhost",N.remoteAddress.host||"localhost",N.remoteAddress.port,N.localAddressPort);await T.waitForReady();const M=new A.$me;return{localAddress:(0,i.$QM)(T.localAddress)??T.localAddress,remoteAddress:{port:T.tunnelRemotePort,host:T.tunnelRemoteHost},onDidDispose:M.event,dispose:()=>{T.dispose(),M.fire(),M.dispose()}}}}};e.$tqc=P,e.$tqc=P=Je([Ve(0,n.$WP),Ve(1,m.$aQ),Ve(2,u.$_j),Ve(3,c.$Yl)],P);class C extends k.$Hwb{static connect(v,N,T,M){const j=new R.$Vc,z={onClose:j.add(new A.$me),onData:j.add(new A.$me),onEnd:j.add(new A.$me)};j.add(v.onDidReceiveMessage(B=>z.onData.fire(h.$Oe.wrap(B)))),j.add(v.onDidEnd(()=>z.onEnd.fire())),j.add(v.onDidClose(B=>z.onClose.fire({type:E.SocketCloseEventType.NodeSocketCloseEvent,error:B,hadError:!!B})));const F=new C(v,M,z);return F.B(j),(0,k.$Gwb)(F,N,T,M,z)}constructor(v,N,T){super(N,T),this.n=v}write(v){this.n.send(v.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[409],Se([1,0,89,378,392,391,404,407,408,102,52,103,101,47,77,98,377,338,12,393,65,297,113,118,148]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d,m,n,o,i,t,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Ls)(I.$Aoc,O.$lqc,r.InstantiationType.Eager),(0,r.$Ls)(m.$ak,d.$vqc,r.InstantiationType.Delayed),(0,r.$Ls)(m.$_j,new t.$Ci(i.$Lpc,[!1],!0)),(0,r.$Ls)(s.$Yl,f.$0fc,r.InstantiationType.Delayed),(0,r.$Ls)(c.$3nc,g.$uqc,r.InstantiationType.Eager),(0,r.$Ls)(l.$Koc,R.$Ypc,r.InstantiationType.Eager),(0,r.$Ls)(E.$7oc,L.$gqc,r.InstantiationType.Eager),(0,r.$Ls)(u.$wpc,A.$Qpc,r.InstantiationType.Eager),(0,r.$Ls)(k.$loc,h.$Ppc,r.InstantiationType.Eager),(0,r.$Ls)(b.$mFb,$.$tqc,r.InstantiationType.Eager),(0,r.$Ls)(o.$Doc,n.$wqc,r.InstantiationType.Eager)});var Ut=this&&this.__importDefault||function(ce){return ce&&ce.__esModule?ce:{default:ce}};define(Ee[419],Se([1,0,420,67,9,22,14,62,111,34,69,131,114,281,390,303,319,94,395,409]),function(ce,e,r,h,A,R,L,O,$,l,I,E,u,k,b,c,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),r=Ut(r),h=We(h),O=We(O),k=Ut(k),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const m=(0,r.default)(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const y=globalThis._VSCODE_NODE_MODULES.module,S=y._load;y._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const n=process.exit.bind(process),o=process.on.bind(process);function i(y){process.exit=function(S){if(y)n(S);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(S,D){S==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),o(S,D)}}let t=function(y){n()};function s(){const y=(0,g.$fn)(process.env);if(y.type===g.ExtHostConnectionType.MessagePort)return new Promise((S,D)=>{const P=C=>{const p=C[0],v=new I.$si;p.on("message",N=>v.fire(R.$Oe.wrap(N.data))),p.on("close",()=>{t("renderer closed the MessagePort")}),p.start(),S({onMessage:v.event,send:N=>p.postMessage(N.buffer)})};process.parentPort.on("message",C=>P(C.ports))});if(y.type===g.ExtHostConnectionType.Socket)return new Promise((S,D)=>{let P=null;const C=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=I.ProtocolConstants.ReconnectionGraceTime,v=I.ProtocolConstants.ReconnectionShortGraceTime,N=new A.$Sh(()=>t("renderer disconnected for too long (1)"),p),T=new A.$Sh(()=>t("renderer disconnected for too long (2)"),v);process.on("message",(j,z)=>{if(j&&j.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const F=R.$Oe.wrap(Buffer.from(j.initialDataChunk,"base64"));let B;if(j.skipWebSocketFrames)B=new E.$ui(z,"extHost-socket");else{const _=R.$Oe.wrap(Buffer.from(j.inflateBytes,"base64"));B=new E.$vi(new E.$ui(z,"extHost-socket"),j.permessageDeflate,_,!1)}P?(N.cancel(),T.cancel(),P.beginAcceptReconnection(B,F),P.endAcceptReconnection(),P.sendResume()):(clearTimeout(C),P=new I.$ti({socket:B,initialChunk:F}),P.sendResume(),P.onDidDispose(()=>t("renderer disconnected")),S(P),P.onSocketClose(()=>{N.schedule()}))}if(j&&j.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(T.isScheduled())return;N.isScheduled()&&T.schedule()}});const M={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(M)});{const S=y.pipeName;return new Promise((D,P)=>{const C=h.createConnection(S,()=>{C.removeListener("error",P);const p=new I.$ti({socket:new E.$ui(C,"extHost-renderer")});p.sendResume(),D(p)});C.once("error",P),C.on("close",()=>{t("renderer closed the socket")})})}}async function f(){const y=await s();return new class{constructor(){this.a=new I.$si,this.onMessage=this.a.event,this.b=!1,this.d=y.onMessage(S=>{(0,d.$zn)(S,d.MessageType.Terminate)?(this.b=!0,this.d.dispose(),t("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||y.send(S)}async drain(){if(y.drain)return y.drain()}}}function a(y){return new Promise(S=>{const D=y.onMessage(P=>{D.dispose();const C=JSON.parse(P.toString()),p=C.commit,v=k.default.commit;if(p&&v&&p!==v&&n(d.ExtensionHostExitCode.VersionMismatch),C.parentPid){let N=0;setInterval(function(){try{process.kill(C.parentPid,0),N=0}catch(M){M&&M.code==="EPERM"?(N++,N>=3&&t(`parent process ${C.parentPid} does not exist anymore (3 x EPERM): ${M.message} (code: ${M.code}) (errno: ${M.errno})`)):t(`parent process ${C.parentPid} does not exist anymore: ${M.message} (code: ${M.code}) (errno: ${M.errno})`)}},1e3);let T;try{T=globalThis._VSCODE_NODE_MODULES["native-watchdog"],T.start(C.parentPid)}catch(M){(0,L.$3)(M)}}y.send((0,d.$yn)(d.MessageType.Initialized)),S({protocol:y,initData:C})});y.send((0,d.$yn)(d.MessageType.Ready))})}async function w(){const y=[];process.on("unhandledRejection",(N,T)=>{y.push(T),setTimeout(()=>{const M=y.indexOf(T);M>=0&&T.catch(j=>{y.splice(M,1),(0,L.$6)(j)||(console.warn(`rejected promise not handled within 1 second: ${j}`),j&&j.stack&&console.warn(`stack trace: ${j.stack}`),N&&(0,L.$3)(N))})},1e3)}),process.on("rejectionHandled",N=>{const T=y.indexOf(N);T>=0&&y.splice(T,1)}),process.on("uncaughtException",function(N){(0,L.$2)(N)||(0,L.$3)(N)}),O.mark("code/extHost/willConnectToRenderer");const S=await f();O.mark("code/extHost/didConnectToRenderer");const D=await a(S);O.mark("code/extHost/didWaitForInitData");const{initData:P}=D;i(!!P.environment.extensionTestsLocationURI),P.environment.useHostProxy=m.useHostProxy!==void 0?m.useHostProxy!=="false":void 0,P.environment.skipWorkspaceStorageLock=(0,u.boolean)(m.skipWorkspaceStorageLock,!1);const C=new class{constructor(){this.pid=process.pid}exit(T){n(T)}fsExists(T){return l.Promises.exists(T)}fsRealpath(T){return(0,$.$hr)(T)}};let p=null;P.remote.authority&&m.transformURIs&&(p=(0,c.$Ps)(P.remote.authority));const v=new b.$Opc(D.protocol,P,C,p);t=N=>v.terminate(N)}w().catch(y=>console.log(y))})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/0cb5ca1d55b8ac035764b4726b5a01b6da22147d/core/vs/workbench/api/node/extensionHostProcess.js.map
