/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/uuid","vs/base/common/marshallingIds","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/editor/common/model","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(oe){for(var e=[],w=0,C=oe.length;w<C;w++)e[w]=Ce[oe[w]];return e};define(Ce[72],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=C,e.$$h=P,e.$_h=T;function w(A){return(N,p,c)=>{let R=null,v=null;if(typeof c.value=="function"?(R="value",v=c.value):typeof c.get=="function"&&(R="get",v=c.get),!v)throw new Error("not supported");c[R]=A(v,p)}}function C(A,N,p){let c=null,R=null;if(typeof p.value=="function"?(c="value",R=p.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(c="get",R=p.get),!R)throw new Error("not supported");const v=`$memoize$${N}`;p[c]=function(...u){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,u)}),this[v]}}function P(A,N,p){return w((c,R)=>{const v=`$debounce$${R}`,u=`$debounce$result$${R}`;return function(...E){this[u]||(this[u]=p?p():void 0),clearTimeout(this[v]),N&&(this[u]=N(this[u],...E),E=[this[u]]),this[v]=setTimeout(()=>{c.apply(this,E),this[u]=p?p():void 0},A)}})}function T(A,N,p){return w((c,R)=>{const v=`$throttle$timer$${R}`,u=`$throttle$result$${R}`,E=`$throttle$lastRun$${R}`,d=`$throttle$pending$${R}`;return function(...r){if(this[u]||(this[u]=p?p():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),N&&(this[u]=N(this[u],...r)),this[d])return;const o=this[E]+A;o<=Date.now()?(this[E]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0):(this[d]=!0,this[v]=setTimeout(()=>{this[d]=!1,this[E]=Date.now(),c.apply(this,[this[u]]),this[u]=p?p():void 0},o-Date.now()))}})}});var Bn=this&&this.__createBinding||(Object.create?function(oe,e,w,C){C===void 0&&(C=w);var P=Object.getOwnPropertyDescriptor(e,w);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[w]}}),Object.defineProperty(oe,C,P)}:function(oe,e,w,C){C===void 0&&(C=w),oe[C]=e[w]}),Wn=this&&this.__setModuleDefault||(Object.create?function(oe,e){Object.defineProperty(oe,"default",{enumerable:!0,value:e})}:function(oe,e){oe.default=e}),qe=this&&this.__importStar||function(oe){if(oe&&oe.__esModule)return oe;var e={};if(oe!=null)for(var w in oe)w!=="default"&&Object.prototype.hasOwnProperty.call(oe,w)&&Bn(e,oe,w);return Wn(e,oe),e};define(Ce[134],Ie([1,0,18]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8c=void 0,e.$9c=P,e.$0c=T,e.$$c=A,e.$_c=N,e.$ad=p,e.$bd=c,w=qe(w);const C=(E,d)=>E===d;e.$8c=C;function P(E=e.$8c){return(d,r)=>w.$wb(d,r,E)}function T(){return(E,d)=>JSON.stringify(E)===JSON.stringify(d)}function A(){return(E,d)=>E.equals(d)}function N(E,d,r){if(r!==void 0){const o=E;return o==null||d===void 0||d===null?d===o:r(o,d)}else{const o=E;return(a,h)=>a==null||h===void 0||h===null?h===a:o(a,h)}}function p(E,d){if(E===d)return!0;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let r=0;r<E.length;r++)if(!p(E[r],d[r]))return!1;return!0}if(E&&typeof E=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(E)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=E,o=d,a=Object.keys(r),h=Object.keys(o),n=new Set(h);if(a.length!==h.length)return!1;for(const s of a)if(!n.has(s)||!p(r[s],o[s]))return!1;return!0}return!1}function c(E){return JSON.stringify(u(E))}let R=0;const v=new WeakMap;function u(E){if(Array.isArray(E))return E.map(u);if(E&&typeof E=="object")if(Object.getPrototypeOf(E)===Object.prototype){const d=E,r=Object.create(null);for(const o of Object.keys(d).sort())r[o]=u(d[o]);return r}else{let d=v.get(E);return d===void 0&&(d=R++,v.set(E,d)),d+"----2b76a038c20c4bcc"}return E}}),define(Ce[97],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=void 0;class w{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$2P=w,e.$3P=new w("id#")}),define(Ce[135],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Tn=A,e.$Un=v,e.$Vn=u,e.$Wn=E,e.$Xn=d,e.$Yn=r,e.$Zn=o,e.$1n=a,e.$2n=h,e.$3n=n,e.$4n=s,e.$5n=i;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(t,m=!1){let f=0;const l=t.length;let $="",I=0,D=C.Unknown,y=w.None;function S(G){let W=0,F=0;for(;W<G;){const V=t.charCodeAt(f);if(V>=R._0&&V<=R._9)F=F*16+V-R._0;else if(V>=R.A&&V<=R.F)F=F*16+V-R.A+10;else if(V>=R.a&&V<=R.f)F=F*16+V-R.a+10;else break;f++,W++}return W<G&&(F=-1),F}function k(G){f=G,$="",I=0,D=C.Unknown,y=w.None}function g(){const G=f;if(t.charCodeAt(f)===R._0)f++;else for(f++;f<t.length&&c(t.charCodeAt(f));)f++;if(f<t.length&&t.charCodeAt(f)===R.dot)if(f++,f<t.length&&c(t.charCodeAt(f)))for(f++;f<t.length&&c(t.charCodeAt(f));)f++;else return y=w.UnexpectedEndOfNumber,t.substring(G,f);let W=f;if(f<t.length&&(t.charCodeAt(f)===R.E||t.charCodeAt(f)===R.e))if(f++,(f<t.length&&t.charCodeAt(f)===R.plus||t.charCodeAt(f)===R.minus)&&f++,f<t.length&&c(t.charCodeAt(f))){for(f++;f<t.length&&c(t.charCodeAt(f));)f++;W=f}else y=w.UnexpectedEndOfNumber;return t.substring(G,W)}function b(){let G="",W=f;for(;;){if(f>=l){G+=t.substring(W,f),y=w.UnexpectedEndOfString;break}const F=t.charCodeAt(f);if(F===R.doubleQuote){G+=t.substring(W,f),f++;break}if(F===R.backslash){if(G+=t.substring(W,f),f++,f>=l){y=w.UnexpectedEndOfString;break}switch(t.charCodeAt(f++)){case R.doubleQuote:G+='"';break;case R.backslash:G+="\\";break;case R.slash:G+="/";break;case R.b:G+="\b";break;case R.f:G+="\f";break;case R.n:G+=`
`;break;case R.r:G+="\r";break;case R.t:G+="	";break;case R.u:{const ce=S(4);ce>=0?G+=String.fromCharCode(ce):y=w.InvalidUnicode;break}default:y=w.InvalidEscapeCharacter}W=f;continue}if(F>=0&&F<=31)if(p(F)){G+=t.substring(W,f),y=w.UnexpectedEndOfString;break}else y=w.InvalidCharacter;f++}return G}function L(){if($="",y=w.None,I=f,f>=l)return I=l,D=C.EOF;let G=t.charCodeAt(f);if(N(G)){do f++,$+=String.fromCharCode(G),G=t.charCodeAt(f);while(N(G));return D=C.Trivia}if(p(G))return f++,$+=String.fromCharCode(G),G===R.carriageReturn&&t.charCodeAt(f)===R.lineFeed&&(f++,$+=`
`),D=C.LineBreakTrivia;switch(G){case R.openBrace:return f++,D=C.OpenBraceToken;case R.closeBrace:return f++,D=C.CloseBraceToken;case R.openBracket:return f++,D=C.OpenBracketToken;case R.closeBracket:return f++,D=C.CloseBracketToken;case R.colon:return f++,D=C.ColonToken;case R.comma:return f++,D=C.CommaToken;case R.doubleQuote:return f++,$=b(),D=C.StringLiteral;case R.slash:{const W=f-1;if(t.charCodeAt(f+1)===R.slash){for(f+=2;f<l&&!p(t.charCodeAt(f));)f++;return $=t.substring(W,f),D=C.LineCommentTrivia}if(t.charCodeAt(f+1)===R.asterisk){f+=2;const F=l-1;let V=!1;for(;f<F;){if(t.charCodeAt(f)===R.asterisk&&t.charCodeAt(f+1)===R.slash){f+=2,V=!0;break}f++}return V||(f++,y=w.UnexpectedEndOfComment),$=t.substring(W,f),D=C.BlockCommentTrivia}return $+=String.fromCharCode(G),f++,D=C.Unknown}case R.minus:if($+=String.fromCharCode(G),f++,f===l||!c(t.charCodeAt(f)))return D=C.Unknown;case R._0:case R._1:case R._2:case R._3:case R._4:case R._5:case R._6:case R._7:case R._8:case R._9:return $+=g(),D=C.NumericLiteral;default:for(;f<l&&O(G);)f++,G=t.charCodeAt(f);if(I!==f){switch($=t.substring(I,f),$){case"true":return D=C.TrueKeyword;case"false":return D=C.FalseKeyword;case"null":return D=C.NullKeyword}return D=C.Unknown}return $+=String.fromCharCode(G),f++,D=C.Unknown}}function O(G){if(N(G)||p(G))return!1;switch(G){case R.closeBrace:case R.closeBracket:case R.openBrace:case R.openBracket:case R.doubleQuote:case R.colon:case R.comma:case R.slash:return!1}return!0}function q(){let G;do G=L();while(G>=C.LineCommentTrivia&&G<=C.Trivia);return G}return{setPosition:k,getPosition:()=>f,scan:m?q:L,getToken:()=>D,getTokenValue:()=>$,getTokenOffset:()=>I,getTokenLength:()=>f-I,getTokenError:()=>y}}function N(t){return t===R.space||t===R.tab||t===R.verticalTab||t===R.formFeed||t===R.nonBreakingSpace||t===R.ogham||t>=R.enQuad&&t<=R.zeroWidthSpace||t===R.narrowNoBreakSpace||t===R.mathematicalSpace||t===R.ideographicSpace||t===R.byteOrderMark}function p(t){return t===R.lineFeed||t===R.carriageReturn||t===R.lineSeparator||t===R.paragraphSeparator}function c(t){return t>=R._0&&t<=R._9}var R;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(R||(R={}));function v(t,m){const f=[],l=new Object;let $;const I={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function y(S,k,g,b){I.value=S,I.offset=k,I.length=g,I.type=b,I.colonOffset=void 0,$=I}try{n(t,{onObjectBegin:(S,k)=>{if(m<=S)throw l;$=void 0,D=m>S,f.push("")},onObjectProperty:(S,k,g)=>{if(m<k||(y(S,k,g,"property"),f[f.length-1]=S,m<=k+g))throw l},onObjectEnd:(S,k)=>{if(m<=S)throw l;$=void 0,f.pop()},onArrayBegin:(S,k)=>{if(m<=S)throw l;$=void 0,f.push(0)},onArrayEnd:(S,k)=>{if(m<=S)throw l;$=void 0,f.pop()},onLiteralValue:(S,k,g)=>{if(m<k||(y(S,k,g,i(S)),m<=k+g))throw l},onSeparator:(S,k,g)=>{if(m<=k)throw l;if(S===":"&&$&&$.type==="property")$.colonOffset=k,D=!1,$=void 0;else if(S===","){const b=f[f.length-1];typeof b=="number"?f[f.length-1]=b+1:(D=!0,f[f.length-1]=""),$=void 0}}})}catch(S){if(S!==l)throw S}return{path:f,previousNode:$,isAtPropertyKey:D,matches:S=>{let k=0;for(let g=0;k<S.length&&g<f.length;g++)if(S[k]===f[g]||S[k]==="*")k++;else if(S[k]!=="**")return!1;return k===S.length}}}function u(t,m=[],f=T.DEFAULT){let l=null,$=[];const I=[];function D(S){Array.isArray($)?$.push(S):l!==null&&($[l]=S)}return n(t,{onObjectBegin:()=>{const S={};D(S),I.push($),$=S,l=null},onObjectProperty:S=>{l=S},onObjectEnd:()=>{$=I.pop()},onArrayBegin:()=>{const S=[];D(S),I.push($),$=S,l=null},onArrayEnd:()=>{$=I.pop()},onLiteralValue:D,onError:(S,k,g)=>{m.push({error:S,offset:k,length:g})}},f),$[0]}function E(t,m=[],f=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function $(S){l.type==="property"&&(l.length=S-l.offset,l=l.parent)}function I(S){return l.children.push(S),S}n(t,{onObjectBegin:S=>{l=I({type:"object",offset:S,length:-1,parent:l,children:[]})},onObjectProperty:(S,k,g)=>{l=I({type:"property",offset:k,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:S,offset:k,length:g,parent:l})},onObjectEnd:(S,k)=>{l.length=S+k-l.offset,l=l.parent,$(S+k)},onArrayBegin:(S,k)=>{l=I({type:"array",offset:S,length:-1,parent:l,children:[]})},onArrayEnd:(S,k)=>{l.length=S+k-l.offset,l=l.parent,$(S+k)},onLiteralValue:(S,k,g)=>{I({type:i(S),offset:k,length:g,parent:l,value:S}),$(k+g)},onSeparator:(S,k,g)=>{l.type==="property"&&(S===":"?l.colonOffset=k:S===","&&$(k))},onError:(S,k,g)=>{m.push({error:S,offset:k,length:g})}},f);const y=l.children[0];return y&&delete y.parent,y}function d(t,m){if(!t)return;let f=t;for(const l of m)if(typeof l=="string"){if(f.type!=="object"||!Array.isArray(f.children))return;let $=!1;for(const I of f.children)if(Array.isArray(I.children)&&I.children[0].value===l){f=I.children[1],$=!0;break}if(!$)return}else{const $=l;if(f.type!=="array"||$<0||!Array.isArray(f.children)||$>=f.children.length)return;f=f.children[$]}return f}function r(t){if(!t.parent||!t.parent.children)return[];const m=r(t.parent);if(t.parent.type==="property"){const f=t.parent.children[0].value;m.push(f)}else if(t.parent.type==="array"){const f=t.parent.children.indexOf(t);f!==-1&&m.push(f)}return m}function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const m=Object.create(null);for(const f of t.children){const l=f.children[1];l&&(m[f.children[0].value]=o(l))}return m}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function a(t,m,f=!1){return m>=t.offset&&m<t.offset+t.length||f&&m===t.offset+t.length}function h(t,m,f=!1){if(a(t,m,f)){const l=t.children;if(Array.isArray(l))for(let $=0;$<l.length&&l[$].offset<=m;$++){const I=h(l[$],m,f);if(I)return I}return t}}function n(t,m,f=T.DEFAULT){const l=A(t,!1);function $(be){return be?()=>be(l.getTokenOffset(),l.getTokenLength()):()=>!0}function I(be){return be?re=>be(re,l.getTokenOffset(),l.getTokenLength()):()=>!0}const D=$(m.onObjectBegin),y=I(m.onObjectProperty),S=$(m.onObjectEnd),k=$(m.onArrayBegin),g=$(m.onArrayEnd),b=I(m.onLiteralValue),L=I(m.onSeparator),O=$(m.onComment),q=I(m.onError),G=f&&f.disallowComments,W=f&&f.allowTrailingComma;function F(){for(;;){const be=l.scan();switch(l.getTokenError()){case w.InvalidUnicode:V(P.InvalidUnicode);break;case w.InvalidEscapeCharacter:V(P.InvalidEscapeCharacter);break;case w.UnexpectedEndOfNumber:V(P.UnexpectedEndOfNumber);break;case w.UnexpectedEndOfComment:G||V(P.UnexpectedEndOfComment);break;case w.UnexpectedEndOfString:V(P.UnexpectedEndOfString);break;case w.InvalidCharacter:V(P.InvalidCharacter);break}switch(be){case C.LineCommentTrivia:case C.BlockCommentTrivia:G?V(P.InvalidCommentToken):O();break;case C.Unknown:V(P.InvalidSymbol);break;case C.Trivia:case C.LineBreakTrivia:break;default:return be}}}function V(be,re=[],Pe=[]){if(q(be),re.length+Pe.length>0){let Le=l.getToken();for(;Le!==C.EOF;){if(re.indexOf(Le)!==-1){F();break}else if(Pe.indexOf(Le)!==-1)break;Le=F()}}}function ce(be){const re=l.getTokenValue();return be?b(re):y(re),F(),!0}function ge(){switch(l.getToken()){case C.NumericLiteral:{let be=0;try{be=JSON.parse(l.getTokenValue()),typeof be!="number"&&(V(P.InvalidNumberFormat),be=0)}catch{V(P.InvalidNumberFormat)}b(be);break}case C.NullKeyword:b(null);break;case C.TrueKeyword:b(!0);break;case C.FalseKeyword:b(!1);break;default:return!1}return F(),!0}function te(){return l.getToken()!==C.StringLiteral?(V(P.PropertyNameExpected,[],[C.CloseBraceToken,C.CommaToken]),!1):(ce(!1),l.getToken()===C.ColonToken?(L(":"),F(),de()||V(P.ValueExpected,[],[C.CloseBraceToken,C.CommaToken])):V(P.ColonExpected,[],[C.CloseBraceToken,C.CommaToken]),!0)}function me(){D(),F();let be=!1;for(;l.getToken()!==C.CloseBraceToken&&l.getToken()!==C.EOF;){if(l.getToken()===C.CommaToken){if(be||V(P.ValueExpected,[],[]),L(","),F(),l.getToken()===C.CloseBraceToken&&W)break}else be&&V(P.CommaExpected,[],[]);te()||V(P.ValueExpected,[],[C.CloseBraceToken,C.CommaToken]),be=!0}return S(),l.getToken()!==C.CloseBraceToken?V(P.CloseBraceExpected,[C.CloseBraceToken],[]):F(),!0}function se(){k(),F();let be=!1;for(;l.getToken()!==C.CloseBracketToken&&l.getToken()!==C.EOF;){if(l.getToken()===C.CommaToken){if(be||V(P.ValueExpected,[],[]),L(","),F(),l.getToken()===C.CloseBracketToken&&W)break}else be&&V(P.CommaExpected,[],[]);de()||V(P.ValueExpected,[],[C.CloseBracketToken,C.CommaToken]),be=!0}return g(),l.getToken()!==C.CloseBracketToken?V(P.CloseBracketExpected,[C.CloseBracketToken],[]):F(),!0}function de(){switch(l.getToken()){case C.OpenBracketToken:return se();case C.OpenBraceToken:return me();case C.StringLiteral:return ce(!0);default:return ge()}}return F(),l.getToken()===C.EOF?f.allowEmptyContent?!0:(V(P.ValueExpected,[],[]),!1):de()?(l.getToken()!==C.EOF&&V(P.EndOfFileExpected,[],[]),!0):(V(P.ValueExpected,[],[]),!1)}function s(t,m){const f=A(t),l=[];let $,I=0,D;do switch(D=f.getPosition(),$=f.scan(),$){case C.LineCommentTrivia:case C.BlockCommentTrivia:case C.EOF:I!==D&&l.push(t.substring(I,D)),m!==void 0&&l.push(f.getTokenValue().replace(/[^\r\n]/g,m)),I=f.getPosition();break}while($!==C.EOF);return l.join("")}function i(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),function(oe,e){typeof define=="function"&&define.amd?define(Ce[136],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ae,we){for(var le=0;le<we.length;le++){var X=we[le];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ae,X.key,X)}}function w(ae,we,le){return we&&e(ae.prototype,we),le&&e(ae,le),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function C(ae,we){if(ae){if(typeof ae=="string")return P(ae,we);var le=Object.prototype.toString.call(ae).slice(8,-1);if(le==="Object"&&ae.constructor&&(le=ae.constructor.name),le==="Map"||le==="Set")return Array.from(ae);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return P(ae,we)}}function P(ae,we){(we==null||we>ae.length)&&(we=ae.length);for(var le=0,X=new Array(we);le<we;le++)X[le]=ae[le];return X}function T(ae,we){var le=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(le)return(le=le.call(ae)).next.bind(le);if(Array.isArray(ae)||(le=C(ae))||we&&ae&&typeof ae.length=="number"){le&&(ae=le);var X=0;return function(){return X>=ae.length?{done:!0}:{done:!1,value:ae[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=A();function N(ae){oe.defaults=ae}var p=/[&<>"']/,c=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(we){return u[we]};function d(ae,we){if(we){if(p.test(ae))return ae.replace(c,E)}else if(R.test(ae))return ae.replace(v,E);return ae}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ae){return ae.replace(r,function(we,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var a=/(^|[^\[])\^/g;function h(ae,we){ae=typeof ae=="string"?ae:ae.source,we=we||"";var le={replace:function(Z,pe){return pe=pe.source||pe,pe=pe.replace(a,"$1"),ae=ae.replace(Z,pe),le},getRegex:function(){return new RegExp(ae,we)}};return le}var n=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function i(ae,we,le){if(ae){var X;try{X=decodeURIComponent(o(le)).replace(n,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}we&&!s.test(le)&&(le=$(we,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},m=/^[^:]+:\/*[^/]*$/,f=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function $(ae,we){t[" "+ae]||(m.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=S(ae,"/",!0)),ae=t[" "+ae];var le=ae.indexOf(":")===-1;return we.substring(0,2)==="//"?le?we:ae.replace(f,"$1")+we:we.charAt(0)==="/"?le?we:ae.replace(l,"$1")+we:ae+we}var I={exec:function(){}};function D(ae){for(var we=1,le,X;we<arguments.length;we++){le=arguments[we];for(X in le)Object.prototype.hasOwnProperty.call(le,X)&&(ae[X]=le[X])}return ae}function y(ae,we){var le=ae.replace(/\|/g,function(pe,$e,Ne){for(var ze=!1,ke=$e;--ke>=0&&Ne[ke]==="\\";)ze=!ze;return ze?"|":" |"}),X=le.split(/ \|/),Z=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>we)X.splice(we);else for(;X.length<we;)X.push("");for(;Z<X.length;Z++)X[Z]=X[Z].trim().replace(/\\\|/g,"|");return X}function S(ae,we,le){var X=ae.length;if(X===0)return"";for(var Z=0;Z<X;){var pe=ae.charAt(X-Z-1);if(pe===we&&!le)Z++;else if(pe!==we&&le)Z++;else break}return ae.slice(0,X-Z)}function k(ae,we){if(ae.indexOf(we[1])===-1)return-1;for(var le=ae.length,X=0,Z=0;Z<le;Z++)if(ae[Z]==="\\")Z++;else if(ae[Z]===we[0])X++;else if(ae[Z]===we[1]&&(X--,X<0))return Z;return-1}function g(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ae,we){if(we<1)return"";for(var le="";we>1;)we&1&&(le+=ae),we>>=1,ae+=ae;return le+ae}function L(ae,we,le,X){var Z=we.href,pe=we.title?d(we.title):null,$e=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){X.state.inLink=!0;var Ne={type:"link",raw:le,href:Z,title:pe,text:$e,tokens:X.inlineTokens($e)};return X.state.inLink=!1,Ne}return{type:"image",raw:le,href:Z,title:pe,text:d($e)}}function O(ae,we){var le=ae.match(/^(\s+)(?:```)/);if(le===null)return we;var X=le[1];return we.split(`
`).map(function(Z){var pe=Z.match(/^\s+/);if(pe===null)return Z;var $e=pe[0];return $e.length>=X.length?Z.slice(X.length):Z}).join(`
`)}var q=function(){function ae(le){this.options=le||oe.defaults}var we=ae.prototype;return we.space=function(X){var Z=this.rules.block.newline.exec(X);if(Z&&Z[0].length>0)return{type:"space",raw:Z[0]}},we.code=function(X){var Z=this.rules.block.code.exec(X);if(Z){var pe=Z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Z[0],codeBlockStyle:"indented",text:this.options.pedantic?pe:S(pe,`
`)}}},we.fences=function(X){var Z=this.rules.block.fences.exec(X);if(Z){var pe=Z[0],$e=O(pe,Z[3]||"");return{type:"code",raw:pe,lang:Z[2]?Z[2].trim():Z[2],text:$e}}},we.heading=function(X){var Z=this.rules.block.heading.exec(X);if(Z){var pe=Z[2].trim();if(/#$/.test(pe)){var $e=S(pe,"#");(this.options.pedantic||!$e||/ $/.test($e))&&(pe=$e.trim())}return{type:"heading",raw:Z[0],depth:Z[1].length,text:pe,tokens:this.lexer.inline(pe)}}},we.hr=function(X){var Z=this.rules.block.hr.exec(X);if(Z)return{type:"hr",raw:Z[0]}},we.blockquote=function(X){var Z=this.rules.block.blockquote.exec(X);if(Z){var pe=Z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Z[0],tokens:this.lexer.blockTokens(pe,[]),text:pe}}},we.list=function(X){var Z=this.rules.block.list.exec(X);if(Z){var pe,$e,Ne,ze,ke,Re,Te,U,z,K,H,ne,fe=Z[1].trim(),Ae=fe.length>1,Ue={type:"list",raw:"",ordered:Ae,start:Ae?+fe.slice(0,-1):"",loose:!1,items:[]};fe=Ae?"\\d{1,9}\\"+fe.slice(-1):"\\"+fe,this.options.pedantic&&(fe=Ae?fe:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(ne=!1,!(!(Z=Ke.exec(X))||this.rules.block.hr.test(X)));){if(pe=Z[0],X=X.substring(pe.length),U=Z[2].split(`
`,1)[0],z=X.split(`
`,1)[0],this.options.pedantic?(ze=2,H=U.trimLeft()):(ze=Z[2].search(/[^ ]/),ze=ze>4?1:ze,H=U.slice(ze),ze+=Z[1].length),Re=!1,!U&&/^ *$/.test(z)&&(pe+=z+`
`,X=X.substring(z.length+1),ne=!0),!ne)for(var _e=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,ze-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,ze-1)+"}#");X&&(K=X.split(`
`,1)[0],U=K,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(U)||tt.test(U)||_e.test(U)||it.test(X)));){if(U.search(/[^ ]/)>=ze||!U.trim())H+=`
`+U.slice(ze);else if(!Re)H+=`
`+U;else break;!Re&&!U.trim()&&(Re=!0),pe+=K+`
`,X=X.substring(K.length+1)}Ue.loose||(Te?Ue.loose=!0:/\n *\n *$/.test(pe)&&(Te=!0)),this.options.gfm&&($e=/^\[[ xX]\] /.exec(H),$e&&(Ne=$e[0]!=="[ ] ",H=H.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:pe,task:!!$e,checked:Ne,loose:!1,text:H}),Ue.raw+=pe}Ue.items[Ue.items.length-1].raw=pe.trimRight(),Ue.items[Ue.items.length-1].text=H.trimRight(),Ue.raw=Ue.raw.trimRight();var rt=Ue.items.length;for(ke=0;ke<rt;ke++){this.lexer.state.top=!1,Ue.items[ke].tokens=this.lexer.blockTokens(Ue.items[ke].text,[]);var $t=Ue.items[ke].tokens.filter(function(st){return st.type==="space"}),lt=$t.every(function(st){for(var ct=st.raw.split(""),gt=0,mt=T(ct),Be;!(Be=mt()).done;){var je=Be.value;if(je===`
`&&(gt+=1),gt>1)return!0}return!1});!Ue.loose&&$t.length&&lt&&(Ue.loose=!0,Ue.items[ke].loose=!0)}return Ue}},we.html=function(X){var Z=this.rules.block.html.exec(X);if(Z){var pe={type:"html",raw:Z[0],pre:!this.options.sanitizer&&(Z[1]==="pre"||Z[1]==="script"||Z[1]==="style"),text:Z[0]};if(this.options.sanitize){var $e=this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]);pe.type="paragraph",pe.text=$e,pe.tokens=this.lexer.inline($e)}return pe}},we.def=function(X){var Z=this.rules.block.def.exec(X);if(Z){Z[3]&&(Z[3]=Z[3].substring(1,Z[3].length-1));var pe=Z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:pe,raw:Z[0],href:Z[2],title:Z[3]}}},we.table=function(X){var Z=this.rules.block.table.exec(X);if(Z){var pe={type:"table",header:y(Z[1]).map(function(Te){return{text:Te}}),align:Z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Z[3]&&Z[3].trim()?Z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(pe.header.length===pe.align.length){pe.raw=Z[0];var $e=pe.align.length,Ne,ze,ke,Re;for(Ne=0;Ne<$e;Ne++)/^ *-+: *$/.test(pe.align[Ne])?pe.align[Ne]="right":/^ *:-+: *$/.test(pe.align[Ne])?pe.align[Ne]="center":/^ *:-+ *$/.test(pe.align[Ne])?pe.align[Ne]="left":pe.align[Ne]=null;for($e=pe.rows.length,Ne=0;Ne<$e;Ne++)pe.rows[Ne]=y(pe.rows[Ne],pe.header.length).map(function(Te){return{text:Te}});for($e=pe.header.length,ze=0;ze<$e;ze++)pe.header[ze].tokens=this.lexer.inline(pe.header[ze].text);for($e=pe.rows.length,ze=0;ze<$e;ze++)for(Re=pe.rows[ze],ke=0;ke<Re.length;ke++)Re[ke].tokens=this.lexer.inline(Re[ke].text);return pe}}},we.lheading=function(X){var Z=this.rules.block.lheading.exec(X);if(Z)return{type:"heading",raw:Z[0],depth:Z[2].charAt(0)==="="?1:2,text:Z[1],tokens:this.lexer.inline(Z[1])}},we.paragraph=function(X){var Z=this.rules.block.paragraph.exec(X);if(Z){var pe=Z[1].charAt(Z[1].length-1)===`
`?Z[1].slice(0,-1):Z[1];return{type:"paragraph",raw:Z[0],text:pe,tokens:this.lexer.inline(pe)}}},we.text=function(X){var Z=this.rules.block.text.exec(X);if(Z)return{type:"text",raw:Z[0],text:Z[0],tokens:this.lexer.inline(Z[0])}},we.escape=function(X){var Z=this.rules.inline.escape.exec(X);if(Z)return{type:"escape",raw:Z[0],text:d(Z[1])}},we.tag=function(X){var Z=this.rules.inline.tag.exec(X);if(Z)return!this.lexer.state.inLink&&/^<a /i.test(Z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):d(Z[0]):Z[0]}},we.link=function(X){var Z=this.rules.inline.link.exec(X);if(Z){var pe=Z[2].trim();if(!this.options.pedantic&&/^</.test(pe)){if(!/>$/.test(pe))return;var $e=S(pe.slice(0,-1),"\\");if((pe.length-$e.length)%2===0)return}else{var Ne=k(Z[2],"()");if(Ne>-1){var ze=Z[0].indexOf("!")===0?5:4,ke=ze+Z[1].length+Ne;Z[2]=Z[2].substring(0,Ne),Z[0]=Z[0].substring(0,ke).trim(),Z[3]=""}}var Re=Z[2],Te="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);U&&(Re=U[1],Te=U[3])}else Te=Z[3]?Z[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(pe)?Re=Re.slice(1):Re=Re.slice(1,-1)),L(Z,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},Z[0],this.lexer)}},we.reflink=function(X,Z){var pe;if((pe=this.rules.inline.reflink.exec(X))||(pe=this.rules.inline.nolink.exec(X))){var $e=(pe[2]||pe[1]).replace(/\s+/g," ");if($e=Z[$e.toLowerCase()],!$e||!$e.href){var Ne=pe[0].charAt(0);return{type:"text",raw:Ne,text:Ne}}return L(pe,$e,pe[0],this.lexer)}},we.emStrong=function(X,Z,pe){pe===void 0&&(pe="");var $e=this.rules.inline.emStrong.lDelim.exec(X);if($e&&!($e[3]&&pe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ne=$e[1]||$e[2]||"";if(!Ne||Ne&&(pe===""||this.rules.inline.punctuation.exec(pe))){var ze=$e[0].length-1,ke,Re,Te=ze,U=0,z=$e[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,Z=Z.slice(-1*X.length+ze);($e=z.exec(Z))!=null;)if(ke=$e[1]||$e[2]||$e[3]||$e[4]||$e[5]||$e[6],!!ke){if(Re=ke.length,$e[3]||$e[4]){Te+=Re;continue}else if(($e[5]||$e[6])&&ze%3&&!((ze+Re)%3)){U+=Re;continue}if(Te-=Re,!(Te>0)){if(Re=Math.min(Re,Re+Te+U),Math.min(ze,Re)%2){var K=X.slice(1,ze+$e.index+Re);return{type:"em",raw:X.slice(0,ze+$e.index+Re+1),text:K,tokens:this.lexer.inlineTokens(K)}}var H=X.slice(2,ze+$e.index+Re-1);return{type:"strong",raw:X.slice(0,ze+$e.index+Re+1),text:H,tokens:this.lexer.inlineTokens(H)}}}}}},we.codespan=function(X){var Z=this.rules.inline.code.exec(X);if(Z){var pe=Z[2].replace(/\n/g," "),$e=/[^ ]/.test(pe),Ne=/^ /.test(pe)&&/ $/.test(pe);return $e&&Ne&&(pe=pe.substring(1,pe.length-1)),pe=d(pe,!0),{type:"codespan",raw:Z[0],text:pe}}},we.br=function(X){var Z=this.rules.inline.br.exec(X);if(Z)return{type:"br",raw:Z[0]}},we.del=function(X){var Z=this.rules.inline.del.exec(X);if(Z)return{type:"del",raw:Z[0],text:Z[2],tokens:this.lexer.inlineTokens(Z[2])}},we.autolink=function(X,Z){var pe=this.rules.inline.autolink.exec(X);if(pe){var $e,Ne;return pe[2]==="@"?($e=d(this.options.mangle?Z(pe[1]):pe[1]),Ne="mailto:"+$e):($e=d(pe[1]),Ne=$e),{type:"link",raw:pe[0],text:$e,href:Ne,tokens:[{type:"text",raw:$e,text:$e}]}}},we.url=function(X,Z){var pe;if(pe=this.rules.inline.url.exec(X)){var $e,Ne;if(pe[2]==="@")$e=d(this.options.mangle?Z(pe[0]):pe[0]),Ne="mailto:"+$e;else{var ze;do ze=pe[0],pe[0]=this.rules.inline._backpedal.exec(pe[0])[0];while(ze!==pe[0]);$e=d(pe[0]),pe[1]==="www."?Ne="http://"+$e:Ne=$e}return{type:"link",raw:pe[0],text:$e,href:Ne,tokens:[{type:"text",raw:$e,text:$e}]}}},we.inlineText=function(X,Z){var pe=this.rules.inline.text.exec(X);if(pe){var $e;return this.lexer.state.inRawBlock?$e=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(pe[0]):d(pe[0]):pe[0]:$e=d(this.options.smartypants?Z(pe[0]):pe[0]),{type:"text",raw:pe[0],text:$e}}},ae}(),G={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:I,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};G._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,G._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,G.def=h(G.def).replace("label",G._label).replace("title",G._title).getRegex(),G.bullet=/(?:[*+-]|\d{1,9}[.)])/,G.listItemStart=h(/^( *)(bull) */).replace("bull",G.bullet).getRegex(),G.list=h(G.list).replace(/bull/g,G.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+G.def.source+")").getRegex(),G._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",G._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,G.html=h(G.html,"i").replace("comment",G._comment).replace("tag",G._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),G.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.blockquote=h(G.blockquote).replace("paragraph",G.paragraph).getRegex(),G.normal=D({},G),G.gfm=D({},G.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),G.gfm.table=h(G.gfm.table).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.gfm.paragraph=h(G._paragraph).replace("hr",G.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",G.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",G._tag).getRegex(),G.pedantic=D({},G.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",G._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:I,paragraph:h(G.normal._paragraph).replace("hr",G.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",G.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:I,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:I,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=h(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=h(G._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=h(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=h(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=h(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=h(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=h(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=h(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=h(W.reflink).replace("label",W._label).replace("ref",G._label).getRegex(),W.nolink=h(W.nolink).replace("ref",G._label).getRegex(),W.reflinkSearch=h(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=D({},W),W.pedantic=D({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=D({},W.normal,{escape:h(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),W.gfm.url=h(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=D({},W.gfm,{br:h(W.br).replace("{2,}","*").getRegex(),text:h(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ae){var we="",le,X,Z=ae.length;for(le=0;le<Z;le++)X=ae.charCodeAt(le),Math.random()>.5&&(X="x"+X.toString(16)),we+="&#"+X+";";return we}var ce=function(){function ae(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||oe.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:G.normal,inline:W.normal};this.options.pedantic?(X.block=G.pedantic,X.inline=W.pedantic):this.options.gfm&&(X.block=G.gfm,this.options.breaks?X.inline=W.breaks:X.inline=W.gfm),this.tokenizer.rules=X}ae.lex=function(X,Z){var pe=new ae(Z);return pe.lex(X)},ae.lexInline=function(X,Z){var pe=new ae(Z);return pe.inlineTokens(X)};var we=ae.prototype;return we.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var Z;Z=this.inlineQueue.shift();)this.inlineTokens(Z.src,Z.tokens);return this.tokens},we.blockTokens=function(X,Z){var pe=this;Z===void 0&&(Z=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Te,U,z){return U+"    ".repeat(z.length)});for(var $e,Ne,ze,ke;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return($e=Te.call({lexer:pe},X,Z))?(X=X.substring($e.raw.length),Z.push($e),!0):!1}))){if($e=this.tokenizer.space(X)){X=X.substring($e.raw.length),$e.raw.length===1&&Z.length>0?Z[Z.length-1].raw+=`
`:Z.push($e);continue}if($e=this.tokenizer.code(X)){X=X.substring($e.raw.length),Ne=Z[Z.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Z.push($e);continue}if($e=this.tokenizer.fences(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.heading(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.hr(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.blockquote(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.list(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.html(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.def(X)){X=X.substring($e.raw.length),Ne=Z[Z.length-1],Ne&&(Ne.type==="paragraph"||Ne.type==="text")?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):this.tokens.links[$e.tag]||(this.tokens.links[$e.tag]={href:$e.href,title:$e.title});continue}if($e=this.tokenizer.table(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.lheading(X)){X=X.substring($e.raw.length),Z.push($e);continue}if(ze=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,U=X.slice(1),z=void 0;pe.options.extensions.startBlock.forEach(function(K){z=K.call({lexer:this},U),typeof z=="number"&&z>=0&&(Te=Math.min(Te,z))}),Te<1/0&&Te>=0&&(ze=X.substring(0,Te+1))}(),this.state.top&&($e=this.tokenizer.paragraph(ze))){Ne=Z[Z.length-1],ke&&Ne.type==="paragraph"?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Z.push($e),ke=ze.length!==X.length,X=X.substring($e.raw.length);continue}if($e=this.tokenizer.text(X)){X=X.substring($e.raw.length),Ne=Z[Z.length-1],Ne&&Ne.type==="text"?(Ne.raw+=`
`+$e.raw,Ne.text+=`
`+$e.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ne.text):Z.push($e);continue}if(X){var Re="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Z},we.inline=function(X,Z){return Z===void 0&&(Z=[]),this.inlineQueue.push({src:X,tokens:Z}),Z},we.inlineTokens=function(X,Z){var pe=this;Z===void 0&&(Z=[]);var $e,Ne,ze,ke=X,Re,Te,U;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)z.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"["+b("a",Re[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Re.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Te||(U=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(H){return($e=H.call({lexer:pe},X,Z))?(X=X.substring($e.raw.length),Z.push($e),!0):!1}))){if($e=this.tokenizer.escape(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.tag(X)){X=X.substring($e.raw.length),Ne=Z[Z.length-1],Ne&&$e.type==="text"&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):Z.push($e);continue}if($e=this.tokenizer.link(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring($e.raw.length),Ne=Z[Z.length-1],Ne&&$e.type==="text"&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):Z.push($e);continue}if($e=this.tokenizer.emStrong(X,ke,U)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.codespan(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.br(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.del(X)){X=X.substring($e.raw.length),Z.push($e);continue}if($e=this.tokenizer.autolink(X,V)){X=X.substring($e.raw.length),Z.push($e);continue}if(!this.state.inLink&&($e=this.tokenizer.url(X,V))){X=X.substring($e.raw.length),Z.push($e);continue}if(ze=X,this.options.extensions&&this.options.extensions.startInline&&function(){var H=1/0,ne=X.slice(1),fe=void 0;pe.options.extensions.startInline.forEach(function(Ae){fe=Ae.call({lexer:this},ne),typeof fe=="number"&&fe>=0&&(H=Math.min(H,fe))}),H<1/0&&H>=0&&(ze=X.substring(0,H+1))}(),$e=this.tokenizer.inlineText(ze,F)){X=X.substring($e.raw.length),$e.raw.slice(-1)!=="_"&&(U=$e.raw.slice(-1)),Te=!0,Ne=Z[Z.length-1],Ne&&Ne.type==="text"?(Ne.raw+=$e.raw,Ne.text+=$e.text):Z.push($e);continue}if(X){var K="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(K);break}else throw new Error(K)}}return Z},w(ae,null,[{key:"rules",get:function(){return{block:G,inline:W}}}]),ae}(),ge=function(){function ae(le){this.options=le||oe.defaults}var we=ae.prototype;return we.code=function(X,Z,pe){var $e=(Z||"").match(/\S*/)[0];if(this.options.highlight){var Ne=this.options.highlight(X,$e);Ne!=null&&Ne!==X&&(pe=!0,X=Ne)}return X=X.replace(/\n$/,"")+`
`,$e?'<pre><code class="'+this.options.langPrefix+d($e,!0)+'">'+(pe?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+(pe?X:d(X,!0))+`</code></pre>
`},we.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},we.html=function(X){return X},we.heading=function(X,Z,pe,$e){if(this.options.headerIds){var Ne=this.options.headerPrefix+$e.slug(pe);return"<h"+Z+' id="'+Ne+'">'+X+"</h"+Z+`>
`}return"<h"+Z+">"+X+"</h"+Z+`>
`},we.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},we.list=function(X,Z,pe){var $e=Z?"ol":"ul",Ne=Z&&pe!==1?' start="'+pe+'"':"";return"<"+$e+Ne+`>
`+X+"</"+$e+`>
`},we.listitem=function(X){return"<li>"+X+`</li>
`},we.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},we.paragraph=function(X){return"<p>"+X+`</p>
`},we.table=function(X,Z){return Z&&(Z="<tbody>"+Z+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+Z+`</table>
`},we.tablerow=function(X){return`<tr>
`+X+`</tr>
`},we.tablecell=function(X,Z){var pe=Z.header?"th":"td",$e=Z.align?"<"+pe+' align="'+Z.align+'">':"<"+pe+">";return $e+X+("</"+pe+`>
`)},we.strong=function(X){return"<strong>"+X+"</strong>"},we.em=function(X){return"<em>"+X+"</em>"},we.codespan=function(X){return"<code>"+X+"</code>"},we.br=function(){return this.options.xhtml?"<br/>":"<br>"},we.del=function(X){return"<del>"+X+"</del>"},we.link=function(X,Z,pe){if(X=i(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var $e='<a href="'+d(X)+'"';return Z&&($e+=' title="'+Z+'"'),$e+=">"+pe+"</a>",$e},we.image=function(X,Z,pe){if(X=i(this.options.sanitize,this.options.baseUrl,X),X===null)return pe;var $e='<img src="'+X+'" alt="'+pe+'"';return Z&&($e+=' title="'+Z+'"'),$e+=this.options.xhtml?"/>":">",$e},we.text=function(X){return X},ae}(),te=function(){function ae(){}var we=ae.prototype;return we.strong=function(X){return X},we.em=function(X){return X},we.codespan=function(X){return X},we.del=function(X){return X},we.html=function(X){return X},we.text=function(X){return X},we.link=function(X,Z,pe){return""+pe},we.image=function(X,Z,pe){return""+pe},we.br=function(){return""},ae}(),me=function(){function ae(){this.seen={}}var we=ae.prototype;return we.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},we.getNextSafeSlug=function(X,Z){var pe=X,$e=0;if(this.seen.hasOwnProperty(pe)){$e=this.seen[X];do $e++,pe=X+"-"+$e;while(this.seen.hasOwnProperty(pe))}return Z||(this.seen[X]=$e,this.seen[pe]=0),pe},we.slug=function(X,Z){Z===void 0&&(Z={});var pe=this.serialize(X);return this.getNextSafeSlug(pe,Z.dryrun)},ae}(),se=function(){function ae(le){this.options=le||oe.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new te,this.slugger=new me}ae.parse=function(X,Z){var pe=new ae(Z);return pe.parse(X)},ae.parseInline=function(X,Z){var pe=new ae(Z);return pe.parseInline(X)};var we=ae.prototype;return we.parse=function(X,Z){Z===void 0&&(Z=!0);var pe="",$e,Ne,ze,ke,Re,Te,U,z,K,H,ne,fe,Ae,Ue,Ke,_e,it,nt,tt,rt=X.length;for($e=0;$e<rt;$e++){if(H=X[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[H.type]&&(tt=this.options.extensions.renderers[H.type].call({parser:this},H),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(H.type))){pe+=tt||"";continue}switch(H.type){case"space":continue;case"hr":{pe+=this.renderer.hr();continue}case"heading":{pe+=this.renderer.heading(this.parseInline(H.tokens),H.depth,o(this.parseInline(H.tokens,this.textRenderer)),this.slugger);continue}case"code":{pe+=this.renderer.code(H.text,H.lang,H.escaped);continue}case"table":{for(z="",U="",ke=H.header.length,Ne=0;Ne<ke;Ne++)U+=this.renderer.tablecell(this.parseInline(H.header[Ne].tokens),{header:!0,align:H.align[Ne]});for(z+=this.renderer.tablerow(U),K="",ke=H.rows.length,Ne=0;Ne<ke;Ne++){for(Te=H.rows[Ne],U="",Re=Te.length,ze=0;ze<Re;ze++)U+=this.renderer.tablecell(this.parseInline(Te[ze].tokens),{header:!1,align:H.align[ze]});K+=this.renderer.tablerow(U)}pe+=this.renderer.table(z,K);continue}case"blockquote":{K=this.parse(H.tokens),pe+=this.renderer.blockquote(K);continue}case"list":{for(ne=H.ordered,fe=H.start,Ae=H.loose,ke=H.items.length,K="",Ne=0;Ne<ke;Ne++)Ke=H.items[Ne],_e=Ke.checked,it=Ke.task,Ue="",Ke.task&&(nt=this.renderer.checkbox(_e),Ae?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=nt+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=nt+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:nt}):Ue+=nt),Ue+=this.parse(Ke.tokens,Ae),K+=this.renderer.listitem(Ue,it,_e);pe+=this.renderer.list(K,ne,fe);continue}case"html":{pe+=this.renderer.html(H.text);continue}case"paragraph":{pe+=this.renderer.paragraph(this.parseInline(H.tokens));continue}case"text":{for(K=H.tokens?this.parseInline(H.tokens):H.text;$e+1<rt&&X[$e+1].type==="text";)H=X[++$e],K+=`
`+(H.tokens?this.parseInline(H.tokens):H.text);pe+=Z?this.renderer.paragraph(K):K;continue}default:{var $t='Token with "'+H.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return pe},we.parseInline=function(X,Z){Z=Z||this.renderer;var pe="",$e,Ne,ze,ke=X.length;for($e=0;$e<ke;$e++){if(Ne=X[$e],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ne.type]&&(ze=this.options.extensions.renderers[Ne.type].call({parser:this},Ne),ze!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ne.type))){pe+=ze||"";continue}switch(Ne.type){case"escape":{pe+=Z.text(Ne.text);break}case"html":{pe+=Z.html(Ne.text);break}case"link":{pe+=Z.link(Ne.href,Ne.title,this.parseInline(Ne.tokens,Z));break}case"image":{pe+=Z.image(Ne.href,Ne.title,Ne.text);break}case"strong":{pe+=Z.strong(this.parseInline(Ne.tokens,Z));break}case"em":{pe+=Z.em(this.parseInline(Ne.tokens,Z));break}case"codespan":{pe+=Z.codespan(Ne.text);break}case"br":{pe+=Z.br();break}case"del":{pe+=Z.del(this.parseInline(Ne.tokens,Z));break}case"text":{pe+=Z.text(Ne.text);break}default:{var Re='Token with "'+Ne.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return pe},ae}();function de(ae,we,le){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof we=="function"&&(le=we,we=null),we=D({},de.defaults,we||{}),g(we),le){var X=we.highlight,Z;try{Z=ce.lex(ae,we)}catch(ke){return le(ke)}var pe=function(Re){var Te;if(!Re)try{we.walkTokens&&de.walkTokens(Z,we.walkTokens),Te=se.parse(Z,we)}catch(U){Re=U}return we.highlight=X,Re?le(Re):le(null,Te)};if(!X||X.length<3||(delete we.highlight,!Z.length))return pe();var $e=0;de.walkTokens(Z,function(ke){ke.type==="code"&&($e++,setTimeout(function(){X(ke.text,ke.lang,function(Re,Te){if(Re)return pe(Re);Te!=null&&Te!==ke.text&&(ke.text=Te,ke.escaped=!0),$e--,$e===0&&pe()})},0))}),$e===0&&pe();return}function Ne(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(ke.message+"",!0)+"</pre>";throw ke}try{var ze=ce.lex(ae,we);if(we.walkTokens){if(we.async)return Promise.all(de.walkTokens(ze,we.walkTokens)).then(function(){return se.parse(ze,we)}).catch(Ne);de.walkTokens(ze,we.walkTokens)}return se.parse(ze,we)}catch(ke){Ne(ke)}}de.options=de.setOptions=function(ae){return D(de.defaults,ae),N(de.defaults),de},de.getDefaults=A,de.defaults=oe.defaults,de.use=function(){for(var ae=arguments.length,we=new Array(ae),le=0;le<ae;le++)we[le]=arguments[le];var X=D.apply(void 0,[{}].concat(we)),Z=de.defaults.extensions||{renderers:{},childTokens:{}},pe;we.forEach(function($e){if($e.extensions&&(pe=!0,$e.extensions.forEach(function(ze){if(!ze.name)throw new Error("extension name required");if(ze.renderer){var ke=Z.renderers?Z.renderers[ze.name]:null;ke?Z.renderers[ze.name]=function(){for(var Re=arguments.length,Te=new Array(Re),U=0;U<Re;U++)Te[U]=arguments[U];var z=ze.renderer.apply(this,Te);return z===!1&&(z=ke.apply(this,Te)),z}:Z.renderers[ze.name]=ze.renderer}if(ze.tokenizer){if(!ze.level||ze.level!=="block"&&ze.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Z[ze.level]?Z[ze.level].unshift(ze.tokenizer):Z[ze.level]=[ze.tokenizer],ze.start&&(ze.level==="block"?Z.startBlock?Z.startBlock.push(ze.start):Z.startBlock=[ze.start]:ze.level==="inline"&&(Z.startInline?Z.startInline.push(ze.start):Z.startInline=[ze.start]))}ze.childTokens&&(Z.childTokens[ze.name]=ze.childTokens)})),$e.renderer&&function(){var ze=de.defaults.renderer||new ge,ke=function(U){var z=ze[U];ze[U]=function(){for(var K=arguments.length,H=new Array(K),ne=0;ne<K;ne++)H[ne]=arguments[ne];var fe=$e.renderer[U].apply(ze,H);return fe===!1&&(fe=z.apply(ze,H)),fe}};for(var Re in $e.renderer)ke(Re);X.renderer=ze}(),$e.tokenizer&&function(){var ze=de.defaults.tokenizer||new q,ke=function(U){var z=ze[U];ze[U]=function(){for(var K=arguments.length,H=new Array(K),ne=0;ne<K;ne++)H[ne]=arguments[ne];var fe=$e.tokenizer[U].apply(ze,H);return fe===!1&&(fe=z.apply(ze,H)),fe}};for(var Re in $e.tokenizer)ke(Re);X.tokenizer=ze}(),$e.walkTokens){var Ne=de.defaults.walkTokens;X.walkTokens=function(ze){var ke=[];return ke.push($e.walkTokens.call(this,ze)),Ne&&(ke=ke.concat(Ne.call(this,ze))),ke}}pe&&(X.extensions=Z),de.setOptions(X)})},de.walkTokens=function(ae,we){for(var le=[],X=function(){var Ne=pe.value;switch(le=le.concat(we.call(de,Ne)),Ne.type){case"table":{for(var ze=T(Ne.header),ke;!(ke=ze()).done;){var Re=ke.value;le=le.concat(de.walkTokens(Re.tokens,we))}for(var Te=T(Ne.rows),U;!(U=Te()).done;)for(var z=U.value,K=T(z),H;!(H=K()).done;){var ne=H.value;le=le.concat(de.walkTokens(ne.tokens,we))}break}case"list":{le=le.concat(de.walkTokens(Ne.items,we));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[Ne.type]?de.defaults.extensions.childTokens[Ne.type].forEach(function(fe){le=le.concat(de.walkTokens(Ne[fe],we))}):Ne.tokens&&(le=le.concat(de.walkTokens(Ne.tokens,we)))}},Z=T(ae),pe;!(pe=Z()).done;)X();return le},de.parseInline=function(ae,we){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");we=D({},de.defaults,we||{}),g(we);try{var le=ce.lexInline(ae,we);return we.walkTokens&&de.walkTokens(le,we.walkTokens),se.parseInline(le,we)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,we.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},de.Parser=se,de.parser=se.parse,de.Renderer=ge,de.TextRenderer=te,de.Lexer=ce,de.lexer=ce.lex,de.Tokenizer=q,de.Slugger=me,de.parse=de;var be=de.options,re=de.setOptions,Pe=de.use,Le=de.walkTokens,Y=de.parseInline,B=de,_=se.parse,ve=ce.lex;oe.Lexer=ce,oe.Parser=se,oe.Renderer=ge,oe.Slugger=me,oe.TextRenderer=te,oe.Tokenizer=q,oe.getDefaults=A,oe.lexer=ve,oe.marked=de,oe.options=be,oe.parse=B,oe.parseInline=Y,oe.parser=_,oe.setOptions=re,oe.use=Pe,oe.walkTokens=Le,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ce[137],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=w;function w(r){const o=T(r);if(o&&o.length>0)return new Uint32Array(o)}let C=0;const P=new Uint32Array(10);function T(r){if(C=0,A(r,v,p.InitialConsonant),C>0||(A(r,u,p.Vowel),C>0)||(A(r,E,p.FinalConsonant),C>0)||(A(r,d,p.CompatibilityJamo),C))return P.subarray(0,C);if(r>=44032&&r<=55203){const o=r-44032,a=o%588,h=Math.floor(o/588),n=Math.floor(a/28),s=a%28-1;if(h<v.length?A(h,v,0):p.InitialConsonant+h-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+h,d,p.CompatibilityJamo),n<u.length?A(n,u,0):p.Vowel+n-p.CompatibilityJamo<d.length&&A(p.Vowel+n-p.CompatibilityJamo,d,p.CompatibilityJamo),s>=0&&(s<E.length?A(s,E,0):p.FinalConsonant+s-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+s-p.CompatibilityJamo,d,p.CompatibilityJamo)),C>0)return P.subarray(0,C)}}function A(r,o,a){r>=a&&r<a+o.length&&N(o[r-a])}function N(r){r!==c.NUL&&(P[C++]=r&255,r>>8&&(P[C++]=r>>8&255),r>>16&&(P[C++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var c;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(c||(c={}));var R;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(R||(R={}));const v=new Uint8Array([c.r,c.R,c.s,c.e,c.E,c.f,c.a,c.q,c.Q,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g]),u=new Uint16Array([c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,R.hk,R.ho,R.hl,c.y,c.n,R.nj,R.np,R.nl,c.b,c.m,R.ml,c.l]),E=new Uint16Array([c.r,c.R,R.rt,c.s,R.sw,R.sg,c.e,c.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,c.a,c.q,R.qt,c.t,c.T,c.d,c.w,c.c,c.z,c.x,c.v,c.g]),d=new Uint16Array([c.r,c.R,R.rt,c.s,R.sw,R.sg,c.e,c.E,c.f,R.fr,R.fa,R.fq,R.ft,R.fx,R.fv,R.fg,c.a,c.q,c.Q,R.qt,c.t,c.T,c.d,c.w,c.W,c.c,c.z,c.x,c.v,c.g,c.k,c.o,c.i,c.O,c.j,c.p,c.u,c.P,c.h,R.hk,R.ho,R.hl,c.y,c.n,R.nj,R.np,R.nl,c.b,c.m,R.ml,c.l])}),define(Ce[138],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=w,e.rot=C,e.$Pm=N;function w(p,c,R){return Math.min(Math.max(p,c),R)}function C(p,c){return(c+p%c)%c}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class T{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=T;class A{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const R=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=R,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function N(p,c,R,v,u,E,d,r){const o=d-R,a=r-v,h=u-R,n=E-v,s=p-R,i=c-v,t=o*o+a*a,m=o*h+a*n,f=o*s+a*i,l=h*h+n*n,$=h*s+n*i,I=1/(t*l-m*m),D=(l*f-m*$)*I,y=(t*$-m*f)*I;return D>=0&&y>=0&&D+y<1}}),define(Ce[139],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$dd=T,e.$ed=u;class w{constructor(d,r,o){this.owner=d,this.debugNameSource=r,this.referenceFn=o}getDebugName(d){return T(d,this)}}e.$cd=w;const C=new Map,P=new WeakMap;function T(E,d){const r=P.get(E);if(r)return r;const o=A(E,d);if(o){let a=C.get(o)??0;a++,C.set(o,a);const h=a===1?o:`${o}#${a}`;return P.set(E,h),h}}function A(E,d){const r=P.get(E);if(r)return r;const o=d.owner?R(d.owner)+".":"";let a;const h=d.debugNameSource;if(h!==void 0)if(typeof h=="function"){if(a=h(),a!==void 0)return o+a}else return o+h;const n=d.referenceFn;if(n!==void 0&&(a=u(n),a!==void 0))return o+a;if(d.owner!==void 0){const s=N(d.owner,E);if(s!==void 0)return o+s}}function N(E,d){for(const r in E)if(E[r]===d)return r}const p=new Map,c=new WeakMap;function R(E){const d=c.get(E);if(d)return d;const r=v(E);let o=p.get(r)??0;o++,p.set(r,o);const a=o===1?r:`${r}#${o}`;return c.set(E,a),a}function v(E){const d=E.constructor;return d?d.name:"Object"}function u(E){const d=E.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(o?o[1]:void 0)?.trim()}}),define(Ce[140],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0,e.$Ld=C,e.$Md=P;let w;function C(r){w=r}function P(){return w}class T{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([N(E("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[N(" "),c(R(o.oldValue,70),{color:"red",strikeThrough:!0}),N(" "),c(R(o.newValue,60),{color:"green"})]:[N(" (unchanged)")]:[N(" "),c(R(o.newValue,60),{color:"green"}),N(" (initial)")]}handleObservableChanged(o,a){console.log(...this.b([p("observable value changed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a)]))}formatChanges(o){if(o.size!==0)return c(" (changed deps: "+[...o].map(a=>a.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,n)=>(this.d.get(o).add(h),a.apply(o,[h,n]))}handleDerivedRecomputed(o,a){const h=this.d.get(o);console.log(...this.b([p("derived recomputed"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),this.formatChanges(h),{data:[{fn:o._debugNameData.referenceFn??o._computeFn}]}])),h.clear()}handleFromEventObservableTriggered(o,a){console.log(...this.b([p("observable from event triggered"),c(o.debugName,{color:"BlueViolet"}),...this.c(a),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const a=o.handleChange;this.d.set(o,new Set),o.handleChange=(h,n)=>(this.d.get(o).add(h),a.apply(o,[h,n]))}handleAutorunTriggered(o){const a=this.d.get(o);console.log(...this.b([p("autorun"),c(o.debugName,{color:"BlueViolet"}),this.formatChanges(a),{data:[{fn:o._debugNameData.referenceFn??o._runFn}]}])),a.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let a=o.getDebugName();a===void 0&&(a=""),console.log(...this.b([p("transaction"),c(a,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Nd=T;function A(r){const o=new Array,a=[];let h="";function n(i){if("length"in i)for(const t of i)t&&n(t);else"text"in i?(h+=`%c${i.text}`,o.push(i.style),i.data&&a.push(...i.data)):"data"in i&&a.push(...i.data)}n(r);const s=[h,...o];return s.push(...a),s}function N(r){return c(r,{color:"black"})}function p(r){return c(d(`${r}: `,10),{color:"black",bold:!0})}function c(r,o={color:"black"}){function a(n){return Object.entries(n).reduce((s,[i,t])=>`${s}${i}:${t};`,"")}const h={color:o.color};return o.strikeThrough&&(h["text-decoration"]="line-through"),o.bold&&(h["font-weight"]="bold"),{text:r,style:a(h)}}function R(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?v(r,o):u(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function v(r,o){let a="[ ",h=!0;for(const n of r){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${R(n,o-a.length)}`}return a+=" ]",a}function u(r,o){let a="{ ",h=!0;for(const[n,s]of Object.entries(r)){if(h||(a+=", "),a.length-5>o){a+="...";break}h=!1,a+=`${n}: ${R(s,o-a.length)}`}return a+=" }",a}function E(r,o){let a="";for(let h=1;h<=o;h++)a+=r;return a}function d(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ce[141],Ie([1,0,134,139,140]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0d=e.$8d=e.$6d=e.$1d=e.$Zd=void 0,e.$Wd=A,e.$Xd=p,e.$Yd=R,e.$2d=E,e.$3d=r,e.$4d=o,e.$5d=a,e.$7d=n,e.$9d=i;let T;function A(m){T=m}let N;function p(m){N=m}let c;function R(m){c=m}class v{get TChange(){return null}reportChanges(){this.get()}read(f){return f?f.readObservable(this):this.get()}map(f,l){const $=l===void 0?void 0:f,I=l===void 0?f:l;return c({owner:$,debugName:()=>{const D=(0,C.$ed)(I);if(D!==void 0)return D;const S=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(I.toString());if(S)return`${this.debugName}.${S[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:I},D=>I(this.read(D),D))}recomputeInitiallyAndOnChange(f,l){return f.add(T(this,l)),this}keepObserved(f){return f.add(N(this)),this}get a(){return this.get()}}e.$Zd=v;class u extends v{constructor(){super(...arguments),this.b=new Set}addObserver(f){const l=this.b.size;this.b.add(f),l===0&&this.c()}removeObserver(f){this.b.delete(f)&&this.b.size===0&&this.f()}c(){}f(){}}e.$1d=u;function E(m,f){const l=new h(m,f);try{m(l)}finally{l.finish()}}let d;function r(m){if(d)m(d);else{const f=new h(m,void 0);d=f;try{m(f)}finally{f.finish(),d=void 0}}}async function o(m,f){const l=new h(m,f);try{await m(l)}finally{l.finish()}}function a(m,f,l){m?f(m):E(f,l)}class h{constructor(f,l){this._fn=f,this.b=l,this.a=[],(0,P.$Md)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$ed)(this._fn)}updateObserver(f,l){this.a.push({observer:f,observable:l}),f.beginUpdate(l)}finish(){const f=this.a;for(let l=0;l<f.length;l++){const{observer:$,observable:I}=f[l];$.endUpdate(I)}this.a=null,(0,P.$Md)()?.handleEndTransaction()}}e.$6d=h;function n(m,f){let l;return typeof m=="string"?l=new C.$cd(void 0,m,void 0):l=new C.$cd(m,void 0,void 0),new s(l,f,w.$8c)}class s extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(f,l,$){super(),this.e=f,this.g=$,this.d=l}get(){return this.d}set(f,l,$){if($===void 0&&this.g(this.d,f))return;let I;l||(l=I=new h(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h(f),(0,P.$Md)()?.handleObservableChanged(this,{oldValue:D,newValue:f,change:$,didChange:!0,hadValue:!0});for(const y of this.b)l.updateObserver(y,this),y.handleChange(this,$)}finally{I&&I.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(f){this.d=f}}e.$8d=s;function i(m,f){let l;return typeof m=="string"?l=new C.$cd(void 0,m,void 0):l=new C.$cd(m,void 0,void 0),new t(l,f,w.$8c)}class t extends s{h(f){this.d!==f&&(this.d&&this.d.dispose(),this.d=f)}dispose(){this.d?.dispose()}}e.$0d=t}),function(){function oe(P){const T=[];typeof P=="number"&&T.push("code/timeOrigin",P);function A(p){T.push(p,Date.now())}function N(){const p=[];for(let c=0;c<T.length;c+=2)p.push({name:T[c],startTime:T[c+1]});return p}return{mark:A,getMarks:N}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(P+A.startTime)});return T}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function w(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=w(C))}(),define(Ce[142],Ie([1,0,40]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OI=void 0;const C=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||w.Iterable.empty()}insert(p,c,R){this.d(p,v=>v._value=c,R)}mutate(p,c){this.d(p,R=>R._value=c(R._value===C?void 0:R._value))}mutatePath(p,c){this.d(p,()=>{},R=>c(R))}delete(p){const c=this.c(p);if(!c)return;let R=c.length-1;const v=c[R].node._value;if(v!==C){for(this.b--,c[R].node._value=C;R>0;R--){const{node:u,part:E}=c[R];if(u.children?.size||u._value!==C)break;c[R-1].node.children.delete(E)}return v}}*deleteRecursive(p){const c=this.c(p);if(!c)return;const R=c[c.length-1].node;for(let v=c.length-1;v>0;v--){const u=c[v-1];if(u.node.children.delete(c[v].part),u.node.children.size>0||u.node._value!==C)break}for(const v of T(R))v._value!==C&&(this.b--,yield v._value)}find(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return;c=v}return c._value===C?void 0:c._value}hasKeyOrParent(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;if(v._value!==C)return!0;c=v}return!1}hasKeyOrChildren(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;c=v}return!0}hasKey(p){let c=this.a;for(const R of p){const v=c.children?.get(R);if(!v)return!1;c=v}return c._value!==C}c(p){const c=[{part:"",node:this.a}];let R=0;for(const v of p){const u=c[R].node.children?.get(v);if(!u)return;c.push({part:v,node:u}),R++}return c}d(p,c,R){let v=this.a;for(const d of p){if(v.children)if(v.children.has(d))v=v.children.get(d);else{const r=new A;v.children.set(d,r),v=r}else{const r=new A;v.children=new Map([[d,r]]),v=r}R?.(v)}const u=v._value===C?0:1;c(v);const E=v._value===C?0:1;this.b+=E-u}*values(){for(const{_value:p}of T(this.a))p!==C&&(yield p)}}e.$OI=P;function*T(N){const p=[N];for(;p.length>0;){const c=p.pop();if(yield c,c.children)for(const R of c.children.values())p.push(R)}}class A{constructor(){this._value=C}get value(){return this._value===C?void 0:this._value}set value(p){this._value=p===void 0?C:p}}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var C in w)(typeof exports=="object"?exports:oe)[C]=w[C]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function w(C){if(e[C])return e[C].exports;var P=e[C]={i:C,l:!1,exports:{}};return oe[C].call(P.exports,P,P.exports,w),P.l=!0,P.exports}return w.m=oe,w.c=e,w.d=function(C,P,T){w.o(C,P)||Object.defineProperty(C,P,{enumerable:!0,get:T})},w.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},w.t=function(C,P){if(1&P&&(C=w(C)),8&P||4&P&&typeof C=="object"&&C&&C.__esModule)return C;var T=Object.create(null);if(w.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:C}),2&P&&typeof C!="string")for(var A in C)w.d(T,A,function(N){return C[N]}.bind(null,A));return T},w.n=function(C){var P=C&&C.__esModule?function(){return C.default}:function(){return C};return w.d(P,"a",P),P},w.o=function(C,P){return Object.prototype.hasOwnProperty.call(C,P)},w.p="",w(w.s=0)}([function(oe,e,w){(function(C){var P;e=oe.exports=Pe,P=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,N=e.re=[],p=e.src=[],c=0,R=c++;p[R]="0|[1-9]\\d*";var v=c++;p[v]="[0-9]+";var u=c++;p[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=c++;p[E]="("+p[R]+")\\.("+p[R]+")\\.("+p[R]+")";var d=c++;p[d]="("+p[v]+")\\.("+p[v]+")\\.("+p[v]+")";var r=c++;p[r]="(?:"+p[R]+"|"+p[u]+")";var o=c++;p[o]="(?:"+p[v]+"|"+p[u]+")";var a=c++;p[a]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var h=c++;p[h]="(?:-?("+p[o]+"(?:\\."+p[o]+")*))";var n=c++;p[n]="[0-9A-Za-z-]+";var s=c++;p[s]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var i=c++,t="v?"+p[E]+p[a]+"?"+p[s]+"?";p[i]="^"+t+"$";var m="[v=\\s]*"+p[d]+p[h]+"?"+p[s]+"?",f=c++;p[f]="^"+m+"$";var l=c++;p[l]="((?:<|>)?=?)";var $=c++;p[$]=p[v]+"|x|X|\\*";var I=c++;p[I]=p[R]+"|x|X|\\*";var D=c++;p[D]="[v=\\s]*("+p[I]+")(?:\\.("+p[I]+")(?:\\.("+p[I]+")(?:"+p[a]+")?"+p[s]+"?)?)?";var y=c++;p[y]="[v=\\s]*("+p[$]+")(?:\\.("+p[$]+")(?:\\.("+p[$]+")(?:"+p[h]+")?"+p[s]+"?)?)?";var S=c++;p[S]="^"+p[l]+"\\s*"+p[D]+"$";var k=c++;p[k]="^"+p[l]+"\\s*"+p[y]+"$";var g=c++;p[g]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=c++;p[b]="(?:~>?)";var L=c++;p[L]="(\\s*)"+p[b]+"\\s+",N[L]=new RegExp(p[L],"g");var O=c++;p[O]="^"+p[b]+p[D]+"$";var q=c++;p[q]="^"+p[b]+p[y]+"$";var G=c++;p[G]="(?:\\^)";var W=c++;p[W]="(\\s*)"+p[G]+"\\s+",N[W]=new RegExp(p[W],"g");var F=c++;p[F]="^"+p[G]+p[D]+"$";var V=c++;p[V]="^"+p[G]+p[y]+"$";var ce=c++;p[ce]="^"+p[l]+"\\s*("+m+")$|^$";var ge=c++;p[ge]="^"+p[l]+"\\s*("+t+")$|^$";var te=c++;p[te]="(\\s*)"+p[l]+"\\s*("+m+"|"+p[D]+")",N[te]=new RegExp(p[te],"g");var me=c++;p[me]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var se=c++;p[se]="^\\s*("+p[y]+")\\s+-\\s+("+p[y]+")\\s*$";var de=c++;p[de]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)P(be,p[be]),N[be]||(N[be]=new RegExp(p[be]));function re(z,K){if(z instanceof Pe)return z;if(typeof z!="string"||z.length>T||!(K?N[f]:N[i]).test(z))return null;try{return new Pe(z,K)}catch{return null}}function Pe(z,K){if(z instanceof Pe){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Pe))return new Pe(z,K);P("SemVer",z,K),this.loose=K;var H=z.trim().match(K?N[f]:N[i]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(ne){if(/^[0-9]+$/.test(ne)){var fe=+ne;if(fe>=0&&fe<A)return fe}return ne}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}e.parse=re,e.valid=function(z,K){var H=re(z,K);return H?H.version:null},e.clean=function(z,K){var H=re(z.trim().replace(/^[=v]+/,""),K);return H?H.version:null},e.SemVer=Pe,Pe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Pe.prototype.toString=function(){return this.version},Pe.prototype.compare=function(z){return P("SemVer.compare",this.version,this.loose,z),z instanceof Pe||(z=new Pe(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Pe.prototype.compareMain=function(z){return z instanceof Pe||(z=new Pe(z,this.loose)),Y(this.major,z.major)||Y(this.minor,z.minor)||Y(this.patch,z.patch)},Pe.prototype.comparePre=function(z){if(z instanceof Pe||(z=new Pe(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var H=this.prerelease[K],ne=z.prerelease[K];if(P("prerelease compare",K,H,ne),H===void 0&&ne===void 0)return 0;if(ne===void 0)return 1;if(H===void 0)return-1;if(H!==ne)return Y(H,ne)}while(++K)},Pe.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,K,H,ne){typeof H=="string"&&(ne=H,H=void 0);try{return new Pe(z,H).inc(K,ne).version}catch{return null}},e.diff=function(z,K){if(ae(z,K))return null;var H=re(z),ne=re(K);if(H.prerelease.length||ne.prerelease.length){for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ne[fe])return"pre"+fe;return"prerelease"}for(var fe in H)if((fe==="major"||fe==="minor"||fe==="patch")&&H[fe]!==ne[fe])return fe},e.compareIdentifiers=Y;var Le=/^[0-9]+$/;function Y(z,K){var H=Le.test(z),ne=Le.test(K);return H&&ne&&(z=+z,K=+K),H&&!ne?-1:ne&&!H?1:z<K?-1:z>K?1:0}function B(z,K,H){return new Pe(z,H).compare(new Pe(K,H))}function _(z,K,H){return B(z,K,H)>0}function ve(z,K,H){return B(z,K,H)<0}function ae(z,K,H){return B(z,K,H)===0}function we(z,K,H){return B(z,K,H)!==0}function le(z,K,H){return B(z,K,H)>=0}function X(z,K,H){return B(z,K,H)<=0}function Z(z,K,H,ne){var fe;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),fe=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),fe=z!==H;break;case"":case"=":case"==":fe=ae(z,H,ne);break;case"!=":fe=we(z,H,ne);break;case">":fe=_(z,H,ne);break;case">=":fe=le(z,H,ne);break;case"<":fe=ve(z,H,ne);break;case"<=":fe=X(z,H,ne);break;default:throw new TypeError("Invalid operator: "+K)}return fe}function pe(z,K){if(z instanceof pe){if(z.loose===K)return z;z=z.value}if(!(this instanceof pe))return new pe(z,K);P("comparator",z,K),this.loose=K,this.parse(z),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(z,K){return Y(K,z)},e.major=function(z,K){return new Pe(z,K).major},e.minor=function(z,K){return new Pe(z,K).minor},e.patch=function(z,K){return new Pe(z,K).patch},e.compare=B,e.compareLoose=function(z,K){return B(z,K,!0)},e.rcompare=function(z,K,H){return B(K,z,H)},e.sort=function(z,K){return z.sort(function(H,ne){return e.compare(H,ne,K)})},e.rsort=function(z,K){return z.sort(function(H,ne){return e.rcompare(H,ne,K)})},e.gt=_,e.lt=ve,e.eq=ae,e.neq=we,e.gte=le,e.lte=X,e.cmp=Z,e.Comparator=pe;var $e={};function Ne(z,K){if(z instanceof Ne)return z.loose===K?z:new Ne(z.raw,K);if(z instanceof pe)return new Ne(z.value,K);if(!(this instanceof Ne))return new Ne(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function ze(z){return!z||z.toLowerCase()==="x"||z==="*"}function ke(z,K,H,ne,fe,Ae,Ue,Ke,_e,it,nt,tt,rt){return((K=ze(H)?"":ze(ne)?">="+H+".0.0":ze(fe)?">="+H+"."+ne+".0":">="+K)+" "+(Ke=ze(_e)?"":ze(it)?"<"+(+_e+1)+".0.0":ze(nt)?"<"+_e+"."+(+it+1)+".0":tt?"<="+_e+"."+it+"."+nt+"-"+tt:"<="+Ke)).trim()}function Re(z,K){for(var H=0;H<z.length;H++)if(!z[H].test(K))return!1;if(K.prerelease.length){for(H=0;H<z.length;H++)if(P(z[H].semver),z[H].semver!==$e&&z[H].semver.prerelease.length>0){var ne=z[H].semver;if(ne.major===K.major&&ne.minor===K.minor&&ne.patch===K.patch)return!0}return!1}return!0}function Te(z,K,H){try{K=new Ne(K,H)}catch{return!1}return K.test(z)}function U(z,K,H,ne){var fe,Ae,Ue,Ke,_e;switch(z=new Pe(z,ne),K=new Ne(K,ne),H){case">":fe=_,Ae=X,Ue=ve,Ke=">",_e=">=";break;case"<":fe=ve,Ae=le,Ue=_,Ke="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(z,K,ne))return!1;for(var it=0;it<K.set.length;++it){var nt=K.set[it],tt=null,rt=null;if(nt.forEach(function($t){$t.semver===$e&&($t=new pe(">=0.0.0")),tt=tt||$t,rt=rt||$t,fe($t.semver,tt.semver,ne)?tt=$t:Ue($t.semver,rt.semver,ne)&&(rt=$t)}),tt.operator===Ke||tt.operator===_e||(!rt.operator||rt.operator===Ke)&&Ae(z,rt.semver)||rt.operator===_e&&Ue(z,rt.semver))return!1}return!0}pe.prototype.parse=function(z){var K=this.loose?N[ce]:N[ge],H=z.match(K);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new Pe(H[2],this.loose):this.semver=$e},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(z){return P("Comparator.test",z,this.loose),this.semver===$e||(typeof z=="string"&&(z=new Pe(z,this.loose)),Z(z,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(z,K){if(!(z instanceof pe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new Ne(z.value,K),Te(this.value,H,K);if(z.operator==="")return H=new Ne(this.value,K),Te(z.semver,H,K);var ne=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),fe=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ae=this.semver.version===z.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ke=Z(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),_e=Z(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ne||fe||Ae&&Ue||Ke||_e},e.Range=Ne,Ne.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Ne.prototype.toString=function(){return this.range},Ne.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),P("range",z,K);var H=K?N[se]:N[me];z=z.replace(H,ke),P("hyphen replace",z),z=z.replace(N[te],"$1$2$3"),P("comparator trim",z,N[te]),z=(z=(z=z.replace(N[L],"$1~")).replace(N[W],"$1^")).split(/\s+/).join(" ");var ne=K?N[ce]:N[ge],fe=z.split(" ").map(function(Ae){return function(Ue,Ke){return P("comp",Ue),Ue=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){P("caret",tt,rt);var $t=rt?N[V]:N[F];return tt.replace($t,function(lt,st,ct,gt,mt){var Be;return P("caret",tt,lt,st,ct,gt,mt),ze(st)?Be="":ze(ct)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":mt?(P("replaceCaret pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),Be=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+mt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+mt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+mt+" <"+(+st+1)+".0.0"):(P("no pr"),Be=st==="0"?ct==="0"?">="+st+"."+ct+"."+gt+" <"+st+"."+ct+"."+(+gt+1):">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+gt+" <"+(+st+1)+".0.0"),P("caret return",Be),Be})}(nt,it)}).join(" ")}(Ue,Ke),P("caret",Ue),Ue=function(_e,it){return _e.trim().split(/\s+/).map(function(nt){return function(tt,rt){var $t=rt?N[q]:N[O];return tt.replace($t,function(lt,st,ct,gt,mt){var Be;return P("tilde",tt,lt,st,ct,gt,mt),ze(st)?Be="":ze(ct)?Be=">="+st+".0.0 <"+(+st+1)+".0.0":ze(gt)?Be=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":mt?(P("replaceTilde pr",mt),mt.charAt(0)!=="-"&&(mt="-"+mt),Be=">="+st+"."+ct+"."+gt+mt+" <"+st+"."+(+ct+1)+".0"):Be=">="+st+"."+ct+"."+gt+" <"+st+"."+(+ct+1)+".0",P("tilde return",Be),Be})}(nt,it)}).join(" ")}(Ue,Ke),P("tildes",Ue),Ue=function(_e,it){return P("replaceXRanges",_e,it),_e.split(/\s+/).map(function(nt){return function(tt,rt){tt=tt.trim();var $t=rt?N[k]:N[S];return tt.replace($t,function(lt,st,ct,gt,mt,Be){P("xRange",tt,lt,st,ct,gt,mt,Be);var je=ze(ct),Q=je||ze(gt),x=Q||ze(mt);return st==="="&&x&&(st=""),je?lt=st===">"||st==="<"?"<0.0.0":"*":st&&x?(Q&&(gt=0),x&&(mt=0),st===">"?(st=">=",Q?(ct=+ct+1,gt=0,mt=0):x&&(gt=+gt+1,mt=0)):st==="<="&&(st="<",Q?ct=+ct+1:gt=+gt+1),lt=st+ct+"."+gt+"."+mt):Q?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":x&&(lt=">="+ct+"."+gt+".0 <"+ct+"."+(+gt+1)+".0"),P("xRange return",lt),lt})}(nt,it)}).join(" ")}(Ue,Ke),P("xrange",Ue),Ue=function(_e,it){return P("replaceStars",_e,it),_e.trim().replace(N[de],"")}(Ue,Ke),P("stars",Ue),Ue}(Ae,K)}).join(" ").split(/\s+/);return this.loose&&(fe=fe.filter(function(Ae){return!!Ae.match(ne)})),fe=fe.map(function(Ae){return new pe(Ae,K)})},Ne.prototype.intersects=function(z,K){if(!(z instanceof Ne))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(ne){return z.set.some(function(fe){return fe.every(function(Ae){return ne.intersects(Ae,K)})})})})},e.toComparators=function(z,K){return new Ne(z,K).set.map(function(H){return H.map(function(ne){return ne.value}).join(" ").trim().split(" ")})},Ne.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Pe(z,this.loose));for(var K=0;K<this.set.length;K++)if(Re(this.set[K],z))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(z,K,H){var ne=null,fe=null;try{var Ae=new Ne(K,H)}catch{return null}return z.forEach(function(Ue){Ae.test(Ue)&&(ne&&fe.compare(Ue)!==-1||(fe=new Pe(ne=Ue,H)))}),ne},e.minSatisfying=function(z,K,H){var ne=null,fe=null;try{var Ae=new Ne(K,H)}catch{return null}return z.forEach(function(Ue){Ae.test(Ue)&&(ne&&fe.compare(Ue)!==1||(fe=new Pe(ne=Ue,H)))}),ne},e.validRange=function(z,K){try{return new Ne(z,K).range||"*"}catch{return null}},e.ltr=function(z,K,H){return U(z,K,"<",H)},e.gtr=function(z,K,H){return U(z,K,">",H)},e.outside=U,e.prerelease=function(z,K){var H=re(z,K);return H&&H.prerelease.length?H.prerelease:null},e.intersects=function(z,K,H){return z=new Ne(z,H),K=new Ne(K,H),z.intersects(K)},e.coerce=function(z){if(z instanceof Pe)return z;if(typeof z!="string")return null;var K=z.match(N[g]);return K==null?null:re((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,w(1))},function(oe,e){var w,C,P=oe.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function N(o){if(w===setTimeout)return setTimeout(o,0);if((w===T||!w)&&setTimeout)return w=setTimeout,setTimeout(o,0);try{return w(o,0)}catch{try{return w.call(null,o,0)}catch{return w.call(this,o,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:T}catch{w=T}try{C=typeof clearTimeout=="function"?clearTimeout:A}catch{C=A}})();var p,c=[],R=!1,v=-1;function u(){R&&p&&(R=!1,p.length?c=p.concat(c):v=-1,c.length&&E())}function E(){if(!R){var o=N(u);R=!0;for(var a=c.length;a;){for(p=c,c=[];++v<a;)p&&p[v].run();v=-1,a=c.length}p=null,R=!1,function(h){if(C===clearTimeout)return clearTimeout(h);if((C===A||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(h);try{C(h)}catch{try{return C.call(null,h)}catch{return C.call(this,h)}}}(o)}}function d(o,a){this.fun=o,this.array=a}function r(){}P.nextTick=function(o){var a=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)a[h-1]=arguments[h];c.push(new d(o,a)),c.length!==1||R||N(E)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(o){return[]},P.binding=function(o){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(o){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ce[143],Ie([1,0,4,5]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=e.ScrollbarVisibility=void 0;var P;(function(E){E[E.Auto=1]="Auto",E[E.Hidden=2]="Hidden",E[E.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class T{constructor(d,r,o,a,h,n,s){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,a=a|0,h=h|0,n=n|0,s=s|0),this.rawScrollLeft=a,this.rawScrollTop=s,r<0&&(r=0),a+r>o&&(a=o-r),a<0&&(a=0),h<0&&(h=0),s+h>n&&(s=n-h),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=a,this.height=h,this.scrollHeight=n,this.scrollTop=s}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new T(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new T(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const o=this.width!==d.width,a=this.scrollWidth!==d.scrollWidth,h=this.scrollLeft!==d.scrollLeft,n=this.height!==d.height,s=this.scrollHeight!==d.scrollHeight,i=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:a,scrollLeftChanged:h,heightChanged:n,scrollHeightChanged:s,scrollTopChanged:i}}}e.$0s=T;class A extends C.$Wc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new w.$me),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new T(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const o=this.g.withScrollDimensions(d,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const o=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let a;r?a=new R(this.h.from,o,this.h.startTime,this.h.duration):a=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=a}else{const o=this.g.withScrollPosition(d);this.h=R.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const o=this.g;o.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$$s=A;class N{constructor(d,r,o){this.scrollLeft=d,this.scrollTop=r,this.isDone=o}}e.$_s=N;function p(E,d){const r=d-E;return function(o){return E+r*u(o)}}function c(E,d,r){return function(o){return o<r?E(o/r):d((o-r)/(1-r))}}class R{constructor(d,r,o,a){this.from=d,this.to=r,this.duration=a,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,o){if(Math.abs(d-r)>2.5*o){let h,n;return d<r?(h=d+.75*o,n=r-.75*o):(h=d-.75*o,n=r+.75*o),c(p(d,h),p(n,r),.33)}return p(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const o=this.c(r),a=this.d(r);return new N(o,a,!1)}return new N(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,o){return R.start(d,r,o)}static start(d,r,o){o=o+10;const a=Date.now()-10;return new R(d,r,a,o)}}e.$at=R;function v(E){return Math.pow(E,3)}function u(E){return 1-v(1-E)}}),define(Ce[144],Ie([1,0,14,5]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=P,e.$Ae=T,e.$Be=A,e.$Ce=N,e.$De=c,e.$Ee=R,e.$Fe=v,e.$Ge=u,e.$He=E,e.$Ie=d,e.$Je=r,e.$Ke=o,e.$Le=a,e.$Me=h,e.$Ne=n;function P(s){const i=s;return i?typeof i.read=="function":!1}function T(s){const i=s;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function A(s){const i=s;return i?T(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function N(s,i){return new p(s,i)}class p{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,w.$3)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let m;switch(i){case"data":m=this.c.data;break;case"end":m=this.c.end;break;case"error":m=this.c.error;break}if(m){const f=m.indexOf(t);f>=0&&m.splice(f,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(m=>m())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(s,i){const t=[];let m;for(;(m=s.read())!==null;)t.push(m);return i(t)}function R(s,i,t){const m=[];let f;for(;(f=s.read())!==null&&m.length<t;)m.push(f);return f===null&&m.length>0?i(m):{read:()=>{if(m.length>0)return m.shift();if(typeof f<"u"){const l=f;return f=void 0,l}return s.read()}}}function v(s,i){return new Promise((t,m)=>{const f=[];u(s,{onData:l=>{i&&f.push(l)},onError:l=>{i?m(l):t(void 0)},onEnd:()=>{t(i?i(f):void 0)}})})}function u(s,i,t){s.on("error",m=>{t?.isCancellationRequested||i.onError(m)}),s.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),s.on("data",m=>{t?.isCancellationRequested||i.onData(m)})}function E(s,i){return new Promise((t,m)=>{const f=new C.$Vc,l=[],$=y=>{if(l.push(y),l.length>i)return f.dispose(),s.pause(),t({stream:s,buffer:l,ended:!1})},I=y=>(f.dispose(),m(y)),D=()=>(f.dispose(),t({stream:s,buffer:l,ended:!0}));f.add((0,C.$Uc)(()=>s.removeListener("error",I))),s.on("error",I),f.add((0,C.$Uc)(()=>s.removeListener("end",D))),s.on("end",D),f.add((0,C.$Uc)(()=>s.removeListener("data",$))),s.on("data",$)})}function d(s,i){const t=N(i);return t.end(s),t}function r(){const s=N(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let i=!1;return{read:()=>i?null:(i=!0,s)}}function a(s,i,t){const m=N(t);return u(s,{onData:f=>m.write(i.data(f)),onError:f=>m.error(i.error?i.error(f):f),onEnd:()=>m.end()}),m}function h(s,i,t){let m=!1;return{read:()=>{const f=i.read();return m?f:(m=!0,f!==null?t([s,f]):s)}}}function n(s,i,t){let m=!1;const f=N(t);return u(i,{onData:l=>m?f.write(l):(m=!0,f.write(t([s,l]))),onError:l=>f.error(l),onEnd:()=>{m||(m=!0,f.write(s)),f.end()}}),f}}),define(Ce[23],Ie([1,0,47,144]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oe=void 0,e.$Pe=c,e.$Qe=R,e.$Re=v,e.$Se=u,e.$Te=E,e.$Ue=d,e.$Ve=r,e.$We=o,e.$Xe=a,e.$Ye=h,e.$Ze=n,e.$1e=s,e.$2e=i,e.$3e=t,e.$4e=m,e.$5e=f,e.$6e=l,e.$7e=$,e.$8e=I,e.$9e=S,C=qe(C);const P=typeof Buffer<"u",T=new w.$X(()=>new Uint8Array(256));let A,N;class p{static alloc(g){return P?new p(Buffer.allocUnsafe(g)):new p(new Uint8Array(g))}static wrap(g){return P&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new p(g)}static fromString(g,b){return!(b?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(g)):(A||(A=new TextEncoder),new p(A.encode(g)))}static fromByteArray(g){const b=p.alloc(g.length);for(let L=0,O=g.length;L<O;L++)b.buffer[L]=g[L];return b}static concat(g,b){if(typeof b>"u"){b=0;for(let q=0,G=g.length;q<G;q++)b+=g[q].byteLength}const L=p.alloc(b);let O=0;for(let q=0,G=g.length;q<G;q++){const W=g[q];L.set(W,O),O+=W.byteLength}return L}constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}clone(){const g=p.alloc(this.byteLength);return g.set(this),g}toString(){return P?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice(g,b){return new p(this.buffer.subarray(g,b))}set(g,b){if(g instanceof p)this.buffer.set(g.buffer,b);else if(g instanceof Uint8Array)this.buffer.set(g,b);else if(g instanceof ArrayBuffer)this.buffer.set(new Uint8Array(g),b);else if(ArrayBuffer.isView(g))this.buffer.set(new Uint8Array(g.buffer,g.byteOffset,g.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(g){return u(this.buffer,g)}writeUInt32BE(g,b){E(this.buffer,g,b)}readUInt32LE(g){return d(this.buffer,g)}writeUInt32LE(g,b){r(this.buffer,g,b)}readUInt8(g){return o(this.buffer,g)}writeUInt8(g,b){a(this.buffer,g,b)}indexOf(g,b=0){return c(this.buffer,g instanceof p?g.buffer:g,b)}}e.$Oe=p;function c(k,g,b=0){const L=g.byteLength,O=k.byteLength;if(L===0)return 0;if(L===1)return k.indexOf(g[0]);if(L>O-b)return-1;const q=T.value;q.fill(g.length);for(let V=0;V<g.length;V++)q[g[V]]=g.length-V-1;let G=b+g.length-1,W=G,F=-1;for(;G<O;)if(k[G]===g[W]){if(W===0){F=G;break}G--,W--}else G+=Math.max(g.length-W,q[k[G]]),W=g.length-1;return F}function R(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0}function v(k,g,b){k[b+0]=g&255,g=g>>>8,k[b+1]=g&255}function u(k,g){return k[g]*2**24+k[g+1]*2**16+k[g+2]*2**8+k[g+3]}function E(k,g,b){k[b+3]=g,g=g>>>8,k[b+2]=g,g=g>>>8,k[b+1]=g,g=g>>>8,k[b]=g}function d(k,g){return k[g+0]<<0>>>0|k[g+1]<<8>>>0|k[g+2]<<16>>>0|k[g+3]<<24>>>0}function r(k,g,b){k[b+0]=g&255,g=g>>>8,k[b+1]=g&255,g=g>>>8,k[b+2]=g&255,g=g>>>8,k[b+3]=g&255}function o(k,g){return k[g]}function a(k,g,b){k[b]=g}function h(k){return C.$De(k,g=>p.concat(g))}function n(k){return C.$Ke(k)}function s(k){return C.$Fe(k,g=>p.concat(g))}async function i(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await s(k.stream)])}function t(k){return C.$Ie(k,g=>p.concat(g))}function m(k){return C.$Le(k,{data:g=>typeof g=="string"?p.fromString(g):p.wrap(g)},g=>p.concat(g))}function f(k){return C.$Ce(g=>p.concat(g),k)}function l(k,g){return C.$Me(k,g,b=>p.concat(b))}function $(k,g){return C.$Ne(k,g,b=>p.concat(b))}function I(k){let g=0,b=0,L=0;const O=new Uint8Array(Math.floor(k.length/4*3)),q=W=>{switch(b){case 3:O[L++]=g|W,b=0;break;case 2:O[L++]=g|W>>>2,g=W<<6,b=3;break;case 1:O[L++]=g|W>>>4,g=W<<4,b=2;break;default:g=W<<2,b=1}};for(let W=0;W<k.length;W++){const F=k.charCodeAt(W);if(F>=65&&F<=90)q(F-65);else if(F>=97&&F<=122)q(F-97+26);else if(F>=48&&F<=57)q(F-48+52);else if(F===43||F===45)q(62);else if(F===47||F===95)q(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${k[W]}`)}}const G=L;for(;b>0;)q(0);return p.wrap(O).slice(0,G)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:k},g=!0,b=!1){const L=b?y:D;let O="";const q=k.byteLength%3;let G=0;for(;G<k.byteLength-q;G+=3){const W=k[G+0],F=k[G+1],V=k[G+2];O+=L[W>>>2],O+=L[(W<<4|F>>>4)&63],O+=L[(F<<2|V>>>6)&63],O+=L[V&63]}if(q===1){const W=k[G+0];O+=L[W>>>2],O+=L[W<<4&63],g&&(O+="==")}else if(q===2){const W=k[G+0],F=k[G+1];O+=L[W>>>2],O+=L[(W<<4|F>>>4)&63],O+=L[F<<2&63],g&&(O+="=")}return O}}),define(Ce[145],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=void 0,e.$he=Symbol("MicrotaskDelay")}),define(Ce[35],Ie([1,0,98]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$6j=P;var C;(function(A){function N(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=N})(C||(e.ThemeColor=C={}));function P(A){return{id:A}}var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const N=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(h){const n=N.exec(h.id);if(!n)return p(w.$5j.error);const[,s,i]=n,t=["codicon","codicon-"+s];return i&&t.push("codicon-modifier-"+i.substring(1)),t}A.asClassNameArray=p;function c(h){return p(h).join(" ")}A.asClassName=c;function R(h){return"."+p(h).join(".")}A.asCSSSelector=R;function v(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||C.isThemeColor(h.color))}A.isThemeIcon=v;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function E(h){const n=u.exec(h);if(!n)return;const[,s]=n;return{id:s}}A.fromString=E;function d(h){return{id:h}}A.fromId=d;function r(h,n){let s=h.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}A.modify=r;function o(h){const n=h.id.lastIndexOf("~");if(n!==-1)return h.id.substring(n+1)}A.getModifier=o;function a(h,n){return h.id===n.id&&h.color?.id===n.color?.id}A.isEqual=a})(T||(e.ThemeIcon=T={}))}),define(Ce[146],Ie([1,0,28,29,137,13]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=A,e.$Ik=p,e.$Jk=c,e.$Kk=u,e.$Lk=D,e.$Mk=y,e.$Nk=O,e.$Ok=q,e.$Pk=G,e.$Qk=W,e.$Rk=_,e.$Tk=le,e.$Uk=pe,e.$Vk=$e,T=qe(T);function A(...ke){return function(Re,Te){for(let U=0,z=ke.length;U<z;U++){const K=ke[U](Re,Te);if(K)return K}return null}}e.$Gk=N.bind(void 0,!1),e.$Hk=N.bind(void 0,!0);function N(ke,Re,Te){if(!Te||Te.length<Re.length)return null;let U;return ke?U=T.$Hf(Te,Re):U=Te.indexOf(Re)===0,U?Re.length>0?[{start:0,end:Re.length}]:[]:null}function p(ke,Re){const Te=Re.toLowerCase().indexOf(ke.toLowerCase());return Te===-1?null:[{start:Te,end:Te+ke.length}]}function c(ke,Re){return R(ke.toLowerCase(),Re.toLowerCase(),0,0)}function R(ke,Re,Te,U){if(Te===ke.length)return[];if(U===Re.length)return null;if(ke[Te]===Re[U]){let z=null;return(z=R(ke,Re,Te+1,U+1))?i({start:U,end:U+1},z):null}return R(ke,Re,Te,U+1)}function v(ke){return w.CharCode.a<=ke&&ke<=w.CharCode.z}function u(ke){return w.CharCode.A<=ke&&ke<=w.CharCode.Z}function E(ke){return w.CharCode.Digit0<=ke&&ke<=w.CharCode.Digit9}function d(ke){return ke===w.CharCode.Space||ke===w.CharCode.Tab||ke===w.CharCode.LineFeed||ke===w.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ke=>r.add(ke.charCodeAt(0)));function o(ke){return d(ke)||r.has(ke)}function a(ke,Re){return ke===Re||o(ke)&&o(Re)}const h=new Map;function n(ke){if(h.has(ke))return h.get(ke);let Re;const Te=(0,P.$Ek)(ke);return Te&&(Re=Te),h.set(ke,Re),Re}function s(ke){return v(ke)||u(ke)||E(ke)}function i(ke,Re){return Re.length===0?Re=[ke]:ke.end===Re[0].start?Re[0].start=ke.start:Re.unshift(ke),Re}function t(ke,Re){for(let Te=Re;Te<ke.length;Te++){const U=ke.charCodeAt(Te);if(u(U)||E(U)||Te>0&&!s(ke.charCodeAt(Te-1)))return Te}return ke.length}function m(ke,Re,Te,U){if(Te===ke.length)return[];if(U===Re.length)return null;if(ke[Te]!==Re[U].toLowerCase())return null;{let z=null,K=U+1;for(z=m(ke,Re,Te+1,U+1);!z&&(K=t(Re,K))<Re.length;)z=m(ke,Re,Te+1,K),K++;return z===null?null:i({start:U,end:U+1},z)}}function f(ke){let Re=0,Te=0,U=0,z=0,K=0;for(let Ue=0;Ue<ke.length;Ue++)K=ke.charCodeAt(Ue),u(K)&&Re++,v(K)&&Te++,s(K)&&U++,E(K)&&z++;const H=Re/ke.length,ne=Te/ke.length,fe=U/ke.length,Ae=z/ke.length;return{upperPercent:H,lowerPercent:ne,alphaPercent:fe,numericPercent:Ae}}function l(ke){const{upperPercent:Re,lowerPercent:Te}=ke;return Te===0&&Re>.6}function $(ke){const{upperPercent:Re,lowerPercent:Te,alphaPercent:U,numericPercent:z}=ke;return Te>.2&&Re<.8&&U>.6&&z<.2}function I(ke){let Re=0,Te=0,U=0,z=0;for(let K=0;K<ke.length;K++)U=ke.charCodeAt(K),u(U)&&Re++,v(U)&&Te++,d(U)&&z++;return(Re===0||Te===0)&&z===0?ke.length<=30:Re<=5}function D(ke,Re){if(!Re||(Re=Re.trim(),Re.length===0)||!I(ke))return null;Re.length>60&&(Re=Re.substring(0,60));const Te=f(Re);if(!$(Te)){if(!l(Te))return null;Re=Re.toLowerCase()}let U=null,z=0;for(ke=ke.toLowerCase();z<Re.length&&(U=m(ke,Re,0,z))===null;)z=t(Re,z+1);return U}function y(ke,Re,Te=!1){if(!Re||Re.length===0)return null;let U=null,z=0;for(ke=ke.toLowerCase(),Re=Re.toLowerCase();z<Re.length&&(U=S(ke,Re,0,z,Te),U===null);)z=k(Re,z+1);return U}function S(ke,Re,Te,U,z){let K=0;if(Te===ke.length)return[];if(U===Re.length)return null;if(!a(ke.charCodeAt(Te),Re.charCodeAt(U))){const fe=n(ke.charCodeAt(Te));if(!fe)return null;for(let Ae=0;Ae<fe.length;Ae++)if(!a(fe[Ae],Re.charCodeAt(U+Ae)))return null;K+=fe.length-1}let H=null,ne=U+K+1;if(H=S(ke,Re,Te+1,ne,z),!z)for(;!H&&(ne=k(Re,ne))<Re.length;)H=S(ke,Re,Te+1,ne,z),ne++;if(!H)return null;if(ke.charCodeAt(Te)!==Re.charCodeAt(U)){const fe=n(ke.charCodeAt(Te));if(!fe)return H;for(let Ae=0;Ae<fe.length;Ae++)if(fe[Ae]!==Re.charCodeAt(U+Ae))return H}return i({start:U,end:U+K+1},H)}function k(ke,Re){for(let Te=Re;Te<ke.length;Te++)if(o(ke.charCodeAt(Te))||Te>0&&o(ke.charCodeAt(Te-1)))return Te;return ke.length}const g=A(e.$Hk,D,p),b=A(e.$Hk,D,c),L=new C.$Fc(1e4);function O(ke,Re,Te=!1){if(typeof ke!="string"||typeof Re!="string")return null;let U=L.get(ke);U||(U=new RegExp(T.$pf(ke),"i"),L.set(ke,U));const z=U.exec(Re);return z?[{start:z.index,end:z.index+z[0].length}]:Te?b(ke,Re):g(ke,Re)}function q(ke,Re){const Te=le(ke,ke.toLowerCase(),0,Re,Re.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?W(Te):null}function G(ke,Re,Te,U,z,K){const H=Math.min(13,ke.length);for(;Te<H;Te++){const ne=le(ke,Re,Te,U,z,K,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ne)return ne}return[0,K]}function W(ke){if(typeof ke>"u")return[];const Re=[],Te=ke[1];for(let U=ke.length-1;U>1;U--){const z=ke[U]+Te,K=Re[Re.length-1];K&&K.end===z?K.end=z+1:Re.push({start:z,end:z+1})}return Re}const F=128;function V(){const ke=[],Re=[];for(let Te=0;Te<=F;Te++)Re[Te]=0;for(let Te=0;Te<=F;Te++)ke.push(Re.slice(0));return ke}function ce(ke){const Re=[];for(let Te=0;Te<=ke;Te++)Re[Te]=0;return Re}const ge=ce(2*F),te=ce(2*F),me=V(),se=V(),de=V(),be=!1;function re(ke,Re,Te,U,z){function K(ne,fe,Ae=" "){for(;ne.length<fe;)ne=Ae+ne;return ne}let H=` |   |${U.split("").map(ne=>K(ne,3)).join("|")}
`;for(let ne=0;ne<=Te;ne++)ne===0?H+=" |":H+=`${Re[ne-1]}|`,H+=ke[ne].slice(0,z+1).map(fe=>K(fe.toString(),3)).join("|")+`
`;return H}function Pe(ke,Re,Te,U){ke=ke.substr(Re),Te=Te.substr(U),console.log(re(se,ke,ke.length,Te,Te.length)),console.log(re(de,ke,ke.length,Te,Te.length)),console.log(re(me,ke,ke.length,Te,Te.length))}function Le(ke,Re){if(Re<0||Re>=ke.length)return!1;const Te=ke.codePointAt(Re);switch(Te){case w.CharCode.Underline:case w.CharCode.Dash:case w.CharCode.Period:case w.CharCode.Space:case w.CharCode.Slash:case w.CharCode.Backslash:case w.CharCode.SingleQuote:case w.CharCode.DoubleQuote:case w.CharCode.Colon:case w.CharCode.DollarSign:case w.CharCode.LessThan:case w.CharCode.GreaterThan:case w.CharCode.OpenParen:case w.CharCode.CloseParen:case w.CharCode.OpenSquareBracket:case w.CharCode.CloseSquareBracket:case w.CharCode.OpenCurlyBrace:case w.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$Zf(Te)}}function Y(ke,Re){if(Re<0||Re>=ke.length)return!1;switch(ke.charCodeAt(Re)){case w.CharCode.Space:case w.CharCode.Tab:return!0;default:return!1}}function B(ke,Re,Te){return Re[ke]!==Te[ke]}function _(ke,Re,Te,U,z,K,H=!1){for(;Re<Te&&z<K;)ke[Re]===U[z]&&(H&&(ge[Re]=z),Re+=1),z+=1;return Re===Te}var ve;(function(ke){ke[ke.Diag=1]="Diag",ke[ke.Left=2]="Left",ke[ke.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var ae;(function(ke){ke.Default=[-100,0];function Re(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}ke.isDefault=Re})(ae||(e.FuzzyScore=ae={}));class we{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Re,Te){this.firstMatchCanBeWeak=Re,this.boostFullMatch=Te}}e.$Sk=we;function le(ke,Re,Te,U,z,K,H=we.default){const ne=ke.length>F?F:ke.length,fe=U.length>F?F:U.length;if(Te>=ne||K>=fe||ne-Te>fe-K||!_(Re,Te,ne,z,K,fe,!0))return;X(ne,fe,Te,K,Re,z);let Ae=1,Ue=1,Ke=Te,_e=K;const it=[!1];for(Ae=1,Ke=Te;Ke<ne;Ae++,Ke++){const lt=ge[Ke],st=te[Ke],ct=Ke+1<ne?te[Ke+1]:fe;for(Ue=lt-K+1,_e=lt;_e<ct;Ue++,_e++){let gt=Number.MIN_SAFE_INTEGER,mt=!1;_e<=st&&(gt=Z(ke,Re,Ke,Te,U,z,_e,fe,K,me[Ae-1][Ue-1]===0,it));let Be=0;gt!==Number.MAX_SAFE_INTEGER&&(mt=!0,Be=gt+se[Ae-1][Ue-1]);const je=_e>lt,Q=je?se[Ae][Ue-1]+(me[Ae][Ue-1]>0?-5:0):0,x=_e>lt+1&&me[Ae][Ue-1]>0,De=x?se[Ae][Ue-2]+(me[Ae][Ue-2]>0?-5:0):0;if(x&&(!je||De>=Q)&&(!mt||De>=Be))se[Ae][Ue]=De,de[Ae][Ue]=ve.LeftLeft,me[Ae][Ue]=0;else if(je&&(!mt||Q>=Be))se[Ae][Ue]=Q,de[Ae][Ue]=ve.Left,me[Ae][Ue]=0;else if(mt)se[Ae][Ue]=Be,de[Ae][Ue]=ve.Diag,me[Ae][Ue]=me[Ae-1][Ue-1]+1;else throw new Error("not possible")}}if(be&&Pe(ke,Te,U,K),!it[0]&&!H.firstMatchCanBeWeak)return;Ae--,Ue--;const nt=[se[Ae][Ue],K];let tt=0,rt=0;for(;Ae>=1;){let lt=Ue;do{const st=de[Ae][lt];if(st===ve.LeftLeft)lt=lt-2;else if(st===ve.Left)lt=lt-1;else break}while(lt>=1);tt>1&&Re[Te+Ae-1]===z[K+Ue-1]&&!B(lt+K-1,U,z)&&tt+1>me[Ae][lt]&&(lt=Ue),lt===Ue?tt++:tt=1,rt||(rt=lt),Ae--,Ue=lt-1,nt.push(Ue)}fe-K===ne&&H.boostFullMatch&&(nt[0]+=2);const $t=rt-ne;return nt[0]-=$t,nt}function X(ke,Re,Te,U,z,K){let H=ke-1,ne=Re-1;for(;H>=Te&&ne>=U;)z[H]===K[ne]&&(te[H]=ne,H--),ne--}function Z(ke,Re,Te,U,z,K,H,ne,fe,Ae,Ue){if(Re[Te]!==K[H])return Number.MIN_SAFE_INTEGER;let Ke=1,_e=!1;return H===Te-U?Ke=ke[Te]===z[H]?7:5:B(H,z,K)&&(H===0||!B(H-1,z,K))?(Ke=ke[Te]===z[H]?7:5,_e=!0):Le(K,H)&&(H===0||!Le(K,H-1))?Ke=5:(Le(K,H-1)||Y(K,H-1))&&(Ke=5,_e=!0),Ke>1&&Te===U&&(Ue[0]=!0),_e||(_e=B(H,z,K)||Le(K,H-1)||Y(K,H-1)),Te===U?H>fe&&(Ke-=_e?3:5):Ae?Ke+=_e?2:0:Ke+=_e?0:1,H+1===ne&&(Ke-=_e?3:5),Ke}function pe(ke,Re,Te,U,z,K,H){return Ne(ke,Re,Te,U,z,K,!0,H)}function $e(ke,Re,Te,U,z,K,H){return Ne(ke,Re,Te,U,z,K,!1,H)}function Ne(ke,Re,Te,U,z,K,H,ne){let fe=le(ke,Re,Te,U,z,K,ne);if(fe&&!H)return fe;if(ke.length>=3){const Ae=Math.min(7,ke.length-1);for(let Ue=Te+1;Ue<Ae;Ue++){const Ke=ze(ke,Ue);if(Ke){const _e=le(Ke,Ke.toLowerCase(),Te,U,z,K,ne);_e&&(_e[0]-=3,(!fe||_e[0]>fe[0])&&(fe=_e))}}}return fe}function ze(ke,Re){if(Re+1>=ke.length)return;const Te=ke[Re],U=ke[Re+1];if(Te!==U)return ke.slice(0,Re)+U+Te+ke.slice(Re+2)}}),define(Ce[99],Ie([1,0,146,13,35]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=p,e.$Xk=R,e.$Yk=u,e.$Zk=E,e.$1k=r,e.$2k=o;const T="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),N=new RegExp(`(\\\\)?${A.source}`,"g");function p(a){return a.replace(N,(h,n)=>n?h:`\\${h}`)}const c=new RegExp(`\\\\${A.source}`,"g");function R(a){return a.replace(c,h=>`\\${h}`)}const v=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(a){return a.indexOf(T)===-1?a:a.replace(v,(h,n,s,i)=>s?h:n||i||"")}function E(a){return a?a.replace(/\$\((.*?)\)/g,(h,n)=>` ${n} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(a){d.lastIndex=0;let h="";const n=[];let s=0;for(;;){const i=d.lastIndex,t=d.exec(a),m=a.substring(i,t?.index);if(m.length>0){h+=m;for(let f=0;f<m.length;f++)n.push(s)}if(!t)break;s+=t[0].length}return{text:h,iconOffsets:n}}function o(a,h,n=!1){const{text:s,iconOffsets:i}=h;if(!i||i.length===0)return(0,w.$Nk)(a,s,n);const t=(0,C.$nf)(s," "),m=s.length-t.length,f=(0,w.$Nk)(a,t,n);if(f)for(const l of f){const $=i[l.start+m]+m;l.start+=$,l.end+=$}return f}}),define(Ce[36],Ie([1,0,13]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),w=qe(w);var C;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(C||(C={})),function(P){const T="error",A="warning",N="warn",p="info",c="ignore";function R(u){return u?w.$Gf(T,u)?P.Error:w.$Gf(A,u)||w.$Gf(N,u)?P.Warning:w.$Gf(p,u)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function v(u){switch(u){case P.Error:return T;case P.Warning:return A;case P.Info:return p;default:return c}}P.toString=v}(C||(C={})),e.default=C}),define(Ce[59],Ie([1,0,18,28,13]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=void 0;class T{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Hi=T;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===C.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$Af)(d,this.b,0,d.length,this.c,this.d):(0,P.$Cf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Ii=A;class N{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===C.CharCode.Slash||this.f&&o===C.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===C.CharCode.Slash||this.f&&r===C.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$Af)(d,this.b,0,d.length,this.d,this.e):(0,P.$Cf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ji=N;var p;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(p||(p={}));class c{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new N(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,P.$Bf)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Bf)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,P.$zf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$zf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ki=c;class R{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(v||(v={}));class u{static forUris(d=()=>!1,r=()=>!1){return new u(new c(d,r))}static forPaths(d=!1){return new u(new N(void 0,!d))}static forStrings(){return new u(new T)}static forConfigKeys(){return new u(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const o=r.slice(0);(0,w.$Yb)(o);for(const a of o)this.set(a,d)}else{const o=d.slice(0);(0,w.$Yb)(o);for(const a of o)this.set(a[0],a[1])}}set(d,r){const o=this.b.reset(d);let a;this.c||(this.c=new R,this.c.segment=o.value());const h=[];for(a=this.c;;){const s=o.cmp(a.segment);if(s>0)a.left||(a.left=new R,a.left.segment=o.value()),h.push([v.Left,a]),a=a.left;else if(s<0)a.right||(a.right=new R,a.right.segment=o.value()),h.push([v.Right,a]),a=a.right;else if(o.hasNext())o.next(),a.mid||(a.mid=new R,a.mid.segment=o.value()),h.push([v.Mid,a]),a=a.mid;else break}const n=a.value;a.value=r,a.key=d;for(let s=h.length-1;s>=0;s--){const i=h[s][1];i.updateHeight();const t=i.balanceFactor();if(t<-1||t>1){const m=h[s][0],f=h[s+1][0];if(m===v.Right&&f===v.Right)h[s][1]=i.rotateLeft();else if(m===v.Left&&f===v.Left)h[s][1]=i.rotateRight();else if(m===v.Right&&f===v.Left)i.right=h[s+1][1]=h[s+1][1].rotateRight(),h[s][1]=i.rotateLeft();else if(m===v.Left&&f===v.Right)i.left=h[s+1][1]=h[s+1][1].rotateLeft(),h[s][1]=i.rotateRight();else throw new Error;if(s>0)switch(h[s-1][0]){case v.Left:h[s-1][1].left=h[s][1];break;case v.Right:h[s-1][1].right=h[s][1];break;case v.Mid:h[s-1][1].mid=h[s][1];break}else this.c=h[0][1]}}return n}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let o=this.c;for(;o;){const a=r.cmp(o.segment);if(a>0)o=o.left;else if(a<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const o=this.b.reset(d),a=[];let h=this.c;for(;h;){const n=o.cmp(h.segment);if(n>0)a.push([v.Left,h]),h=h.left;else if(n<0)a.push([v.Right,h]),h=h.right;else if(o.hasNext())o.next(),a.push([v.Mid,h]),h=h.mid;else break}if(h){if(r?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const n=this.f(h.right);if(n.key){const{key:s,value:i,segment:t}=n;this.e(n.key,!1),h.key=s,h.value=i,h.segment=t}}else{const n=h.left??h.right;if(a.length>0){const[s,i]=a[a.length-1];switch(s){case v.Left:i.left=n;break;case v.Mid:i.mid=n;break;case v.Right:i.right=n;break}}else this.c=n}for(let n=a.length-1;n>=0;n--){const s=a[n][1];s.updateHeight();const i=s.balanceFactor();if(i>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),a[n][1]=s.rotateLeft()):i<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),a[n][1]=s.rotateRight()),n>0)switch(a[n-1][0]){case v.Left:a[n-1][1].left=a[n][1];break;case v.Right:a[n-1][1].right=a[n][1];break;case v.Mid:a[n-1][1].mid=a[n][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let o=this.c,a;for(;o;){const h=r.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(r.hasNext())r.next(),a=o.value||a,o=o.mid;else break}return o&&o.value||a}findSuperstr(d){return this.g(d,!1)}g(d,r){const o=this.b.reset(d);let a=this.c;for(;a;){const h=o.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this.h(a.mid):r?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,o]of this)d(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Li=u}),define(Ce[37],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2g=void 0,e.$1g=C;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(P){return w.test(P)}e.$2g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(N){for(let p=0;p<N.length;p++)N[p]=Math.floor(Math.random()*256);return N};const T=new Uint8Array(16),A=[];for(let N=0;N<256;N++)A.push(N.toString(16).padStart(2,"0"));return function(){P(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let p=0,c="";return c+=A[T[p++]],c+=A[T[p++]],c+=A[T[p++]],c+=A[T[p++]],c+="-",c+=A[T[p++]],c+=A[T[p++]],c+="-",c+=A[T[p++]],c+=A[T[p++]],c+="-",c+=A[T[p++]],c+=A[T[p++]],c+="-",c+=A[T[p++]],c+=A[T[p++]],c+=A[T[p++]],c+=A[T[p++]],c+=A[T[p++]],c+=A[T[p++]],c}}()}),define(Ce[147],Ie([1,0,18,40,37]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mu=e.$ku=void 0,e.$iu=T,e.$ju=A,e.$lu=c;function T(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function A(v,u,E){const d={id:(0,P.$2g)(),name:v,uri:u,data:E};return{asString:async()=>"",asFile:()=>d,value:void 0}}class N{constructor(){this.a=new Map}get size(){let u=0;for(const E of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const E=[...this.a.keys()];return C.Iterable.some(this,([d,r])=>r.asFile())&&E.push("files"),R(p(u),E)}get(u){return this.a.get(this.b(u))?.[0]}append(u,E){const d=this.a.get(u);d?d.push(E):this.a.set(this.b(u),[E])}replace(u,E){this.a.set(this.b(u),[E])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,E]of this.a)for(const d of E)yield[u,d]}b(u){return p(u)}}e.$ku=N;function p(v){return v.toLowerCase()}function c(v,u){return R(p(v),u.map(p))}function R(v,u){if(v==="*/*")return u.length>0;if(u.includes(v))return!0;const E=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[d,r,o]=E;return o==="*"?u.some(a=>a.startsWith(r+"/")):!1}e.$mu=Object.freeze({create:v=>(0,w.$Ob)(v.map(u=>u.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$mu.split(v).filter(u=>!u.startsWith("#"))})}),define(Ce[148],Ie([1,0,28]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$su=P;var C;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function P(T){let A=0,N=0,p=0,c=C.Unknown;for(let R=0,v=T.length;R<v;R++){const u=T.charCodeAt(R);u===w.CharCode.CarriageReturn?(A===0&&(N=R),A++,R+1<v&&T.charCodeAt(R+1)===w.CharCode.LineFeed?(c|=C.CRLF,R++):c|=C.Invalid,p=R+1):u===w.CharCode.LineFeed&&(c|=C.LF,A===0&&(N=R),A++,p=R+1)}return A===0&&(N=T.length),[A,N,T.length-p,c]}}),define(Ce[149],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=void 0,e.$ft={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[150],Ie([1,0,28,151]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class T{constructor(c){if(this.e=null,this.f=!1,this.open=c.open,this.close=c.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(c.notIn))for(let R=0,v=c.notIn.length;R<v;R++)switch(c.notIn[R]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(c){switch(c){case C.StandardTokenType.Other:return!0;case C.StandardTokenType.Comment:return this.c;case C.StandardTokenType.String:return this.b;case C.StandardTokenType.RegEx:return this.d}}shouldAutoClose(c,R){if(c.getTokenCount()===0)return!0;const v=c.findTokenIndexAtOffset(R-2),u=c.getStandardTokenType(v);return this.isOK(u)}g(c,R){for(let v=c;v<=R;v++){const u=String.fromCharCode(v);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(w.CharCode.Digit0,w.CharCode.Digit9)),this.e||(this.e=this.g(w.CharCode.a,w.CharCode.z)),this.e||(this.e=this.g(w.CharCode.A,w.CharCode.Z))),this.e}}e.$Pu=T;class A{constructor(c){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const R of c)N(this.autoClosingPairsOpenByStart,R.open.charAt(0),R),N(this.autoClosingPairsOpenByEnd,R.open.charAt(R.open.length-1),R),N(this.autoClosingPairsCloseByStart,R.close.charAt(0),R),N(this.autoClosingPairsCloseByEnd,R.close.charAt(R.close.length-1),R),R.close.length===1&&R.open.length===1&&N(this.autoClosingPairsCloseSingleChar,R.close,R)}}e.$Qu=A;function N(p,c,R){p.has(c)?p.get(c).push(R):p.set(c,[R])}}),define(Ce[152],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.NodeColor=e.$ZC=void 0,e.$2C=P,e.$3C=T,e.$4C=c,e.$5C=R,e.$6C=v,e.$7C=u,e.$8C=E,e.$9C=d;class w{constructor(o,a){this.piece=o,this.color=a,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$1C)return P(this.right);let o=this;for(;o.parent!==e.$1C&&o.parent.left!==o;)o=o.parent;return o.parent===e.$1C?e.$1C:o.parent}prev(){if(this.left!==e.$1C)return T(this.left);let o=this;for(;o.parent!==e.$1C&&o.parent.right!==o;)o=o.parent;return o.parent===e.$1C?e.$1C:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$ZC=w;var C;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(C||(e.NodeColor=C={})),e.$1C=new w(null,C.Black),e.$1C.parent=e.$1C,e.$1C.left=e.$1C,e.$1C.right=e.$1C,e.$1C.color=C.Black;function P(r){for(;r.left!==e.$1C;)r=r.left;return r}function T(r){for(;r.right!==e.$1C;)r=r.right;return r}function A(r){return r===e.$1C?0:r.size_left+r.piece.length+A(r.right)}function N(r){return r===e.$1C?0:r.lf_left+r.piece.lineFeedCnt+N(r.right)}function p(){e.$1C.parent=e.$1C}function c(r,o){const a=o.right;a.size_left+=o.size_left+(o.piece?o.piece.length:0),a.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=a.left,a.left!==e.$1C&&(a.left.parent=o),a.parent=o.parent,o.parent===e.$1C?r.root=a:o.parent.left===o?o.parent.left=a:o.parent.right=a,a.left=o,o.parent=a}function R(r,o){const a=o.left;o.left=a.right,a.right!==e.$1C&&(a.right.parent=o),a.parent=o.parent,o.size_left-=a.size_left+(a.piece?a.piece.length:0),o.lf_left-=a.lf_left+(a.piece?a.piece.lineFeedCnt:0),o.parent===e.$1C?r.root=a:o===o.parent.right?o.parent.right=a:o.parent.left=a,a.right=o,o.parent=a}function v(r,o){let a,h;if(o.left===e.$1C?(h=o,a=h.right):o.right===e.$1C?(h=o,a=h.left):(h=P(o.right),a=h.right),h===r.root){r.root=a,a.color=C.Black,o.detach(),p(),r.root.parent=e.$1C;return}const n=h.color===C.Red;if(h===h.parent.left?h.parent.left=a:h.parent.right=a,h===o?(a.parent=h.parent,d(r,a)):(h.parent===o?a.parent=h:a.parent=h.parent,d(r,a),h.left=o.left,h.right=o.right,h.parent=o.parent,h.color=o.color,o===r.root?r.root=h:o===o.parent.left?o.parent.left=h:o.parent.right=h,h.left!==e.$1C&&(h.left.parent=h),h.right!==e.$1C&&(h.right.parent=h),h.size_left=o.size_left,h.lf_left=o.lf_left,d(r,h)),o.detach(),a.parent.left===a){const i=A(a),t=N(a);if(i!==a.parent.size_left||t!==a.parent.lf_left){const m=i-a.parent.size_left,f=t-a.parent.lf_left;a.parent.size_left=i,a.parent.lf_left=t,E(r,a.parent,m,f)}}if(d(r,a.parent),n){p();return}let s;for(;a!==r.root&&a.color===C.Black;)a===a.parent.left?(s=a.parent.right,s.color===C.Red&&(s.color=C.Black,a.parent.color=C.Red,c(r,a.parent),s=a.parent.right),s.left.color===C.Black&&s.right.color===C.Black?(s.color=C.Red,a=a.parent):(s.right.color===C.Black&&(s.left.color=C.Black,s.color=C.Red,R(r,s),s=a.parent.right),s.color=a.parent.color,a.parent.color=C.Black,s.right.color=C.Black,c(r,a.parent),a=r.root)):(s=a.parent.left,s.color===C.Red&&(s.color=C.Black,a.parent.color=C.Red,R(r,a.parent),s=a.parent.left),s.left.color===C.Black&&s.right.color===C.Black?(s.color=C.Red,a=a.parent):(s.left.color===C.Black&&(s.right.color=C.Black,s.color=C.Red,c(r,s),s=a.parent.left),s.color=a.parent.color,a.parent.color=C.Black,s.left.color=C.Black,R(r,a.parent),a=r.root));a.color=C.Black,p()}function u(r,o){for(d(r,o);o!==r.root&&o.parent.color===C.Red;)if(o.parent===o.parent.parent.left){const a=o.parent.parent.right;a.color===C.Red?(o.parent.color=C.Black,a.color=C.Black,o.parent.parent.color=C.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,c(r,o)),o.parent.color=C.Black,o.parent.parent.color=C.Red,R(r,o.parent.parent))}else{const a=o.parent.parent.left;a.color===C.Red?(o.parent.color=C.Black,a.color=C.Black,o.parent.parent.color=C.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,R(r,o)),o.parent.color=C.Black,o.parent.parent.color=C.Red,c(r,o.parent.parent))}r.root.color=C.Black}function E(r,o,a,h){for(;o!==r.root&&o!==e.$1C;)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}function d(r,o){let a=0,h=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,a=A(o.left)-o.size_left,h=N(o.left)-o.lf_left,o.size_left+=a,o.lf_left+=h;o!==r.root&&(a!==0||h!==0);)o.parent.left===o&&(o.parent.size_left+=a,o.parent.lf_left+=h),o=o.parent}}}),define(Ce[100],Ie([1,0,28,101,33,52,152,102]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hD=e.$gD=e.$fD=void 0,e.$dD=v,e.$eD=u;const p=65535;function c(h){let n;return h[h.length-1]<65536?n=new Uint16Array(h.length):n=new Uint32Array(h.length),n.set(h,0),n}class R{constructor(n,s,i,t,m){this.lineStarts=n,this.cr=s,this.lf=i,this.crlf=t,this.isBasicASCII=m}}function v(h,n=!0){const s=[0];let i=1;for(let t=0,m=h.length;t<m;t++){const f=h.charCodeAt(t);f===w.CharCode.CarriageReturn?t+1<m&&h.charCodeAt(t+1)===w.CharCode.LineFeed?(s[i++]=t+2,t++):s[i++]=t+1:f===w.CharCode.LineFeed&&(s[i++]=t+1)}return n?c(s):s}function u(h,n){h.length=0,h[0]=0;let s=1,i=0,t=0,m=0,f=!0;for(let $=0,I=n.length;$<I;$++){const D=n.charCodeAt($);D===w.CharCode.CarriageReturn?$+1<I&&n.charCodeAt($+1)===w.CharCode.LineFeed?(m++,h[s++]=$+2,$++):(i++,h[s++]=$+1):D===w.CharCode.LineFeed?(t++,h[s++]=$+1):f&&D!==w.CharCode.Tab&&(D<32||D>126)&&(f=!1)}const l=new R(c(h),i,t,m,f);return h.length=0,l}class E{constructor(n,s,i,t,m){this.bufferIndex=n,this.start=s,this.end=i,this.lineFeedCnt=t,this.length=m}}e.$fD=E;class d{constructor(n,s){this.buffer=n,this.lineStarts=s}}e.$gD=d;class r{constructor(n,s){this.a=[],this.c=n,this.d=s,this.b=0,n.root!==A.$1C&&n.iterate(n.root,i=>(i!==A.$1C&&this.a.push(i.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(n){this.a=n,this.b=[]}get(n){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartOffset<=n&&i.nodeStartOffset+i.node.piece.length>=n)return i}return null}get2(n){for(let s=this.b.length-1;s>=0;s--){const i=this.b[s];if(i.nodeStartLineNumber&&i.nodeStartLineNumber<n&&i.nodeStartLineNumber+i.node.piece.lineFeedCnt>=n)return i}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let s=!1;const i=this.b;for(let t=0;t<i.length;t++){const m=i[t];if(m.node.parent===null||m.nodeStartOffset>=n){i[t]=null,s=!0;continue}}if(s){const t=[];for(const m of i)m!==null&&t.push(m);this.b=t}}}class a{constructor(n,s,i){this.create(n,s,i)}create(n,s,i){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$1C,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=i;let t=null;for(let m=0,f=n.length;m<f;m++)if(n[m].buffer.length>0){n[m].lineStarts||(n[m].lineStarts=v(n[m].buffer));const l=new E(m+1,{line:0,column:0},{line:n[m].lineStarts.length-1,column:n[m].buffer.length-n[m].lineStarts[n[m].lineStarts.length-1]},n[m].lineStarts.length-1,n[m].buffer.length);this.a.push(n[m]),t=this.S(t,l)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const s=p,i=s-Math.floor(s/3),t=i*2;let m="",f=0;const l=[];if(this.iterate(this.root,$=>{const I=this.R($),D=I.length;if(f<=i||f+D<t)return m+=I,f+=D,!0;const y=m.replace(/\r\n|\r|\n/g,n);return l.push(new d(y,v(y))),m=I,f=D,!0}),f>0){const $=m.replace(/\r\n|\r|\n/g,n);l.push(new d($,v($)))}this.create(l,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new r(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let s=0;return this.iterate(this.root,t=>{if(t===A.$1C)return!0;const m=this.R(t),f=m.length,l=n.G(s),$=n.G(s+f),I=n.getValueInRange2(l,$);return s+=f,m===I})}getOffsetAt(n,s){let i=0,t=this.root;for(;t!==A.$1C;)if(t.left!==A.$1C&&t.lf_left+1>=n)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=n){i+=t.size_left;const m=this.B(t,n-t.lf_left-2);return i+=m+s-1}else n-=t.lf_left+t.piece.lineFeedCnt,i+=t.size_left+t.piece.length,t=t.right;return i}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let s=this.root,i=0;const t=n;for(;s!==A.$1C;)if(s.size_left!==0&&s.size_left>=n)s=s.left;else if(s.size_left+s.piece.length>=n){const m=this.A(s,n-s.size_left);if(i+=s.lf_left+m.index,m.index===0){const f=this.getOffsetAt(i+1,1),l=t-f;return new C.$Ht(i+1,l+1)}return new C.$Ht(i+1,m.remainder+1)}else if(n-=s.size_left+s.piece.length,i+=s.lf_left+s.piece.lineFeedCnt,s.right===A.$1C){const m=this.getOffsetAt(i+1,1),f=t-n-m;return new C.$Ht(i+1,f+1)}else s=s.right;return new C.$Ht(1,1)}getValueInRange(n,s){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const i=this.H(n.startLineNumber,n.startColumn),t=this.H(n.endLineNumber,n.endColumn),m=this.getValueInRange2(i,t);return s?s!==this.d||!this.f?m.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?m:m.replace(/\r\n|\r|\n/g,s):m}getValueInRange2(n,s){if(n.node===s.node){const l=n.node,$=this.a[l.piece.bufferIndex].buffer,I=this.u(l.piece.bufferIndex,l.piece.start);return $.substring(I+n.remainder,I+s.remainder)}let i=n.node;const t=this.a[i.piece.bufferIndex].buffer,m=this.u(i.piece.bufferIndex,i.piece.start);let f=t.substring(m+n.remainder,m+i.piece.length);for(i=i.next();i!==A.$1C;){const l=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(i===s.node){f+=l.substring($,$+s.remainder);break}else f+=l.substr($,i.piece.length);i=i.next()}return f}getLinesContent(){const n=[];let s=0,i="",t=!1;return this.iterate(this.root,m=>{if(m===A.$1C)return!0;const f=m.piece;let l=f.length;if(l===0)return!0;const $=this.a[f.bufferIndex].buffer,I=this.a[f.bufferIndex].lineStarts,D=f.start.line,y=f.end.line;let S=I[D]+f.start.column;if(t&&($.charCodeAt(S)===w.CharCode.LineFeed&&(S++,l--),n[s++]=i,i="",t=!1,l===0))return!0;if(D===y)return!this.f&&$.charCodeAt(S+l-1)===w.CharCode.CarriageReturn?(t=!0,i+=$.substr(S,l-1)):i+=$.substr(S,l),!0;i+=this.f?$.substring(S,Math.max(S,I[D+1]-this.e)):$.substring(S,I[D+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;for(let k=D+1;k<y;k++)i=this.f?$.substring(I[k],I[k+1]-this.e):$.substring(I[k],I[k+1]).replace(/(\r\n|\r|\n)$/,""),n[s++]=i;return!this.f&&$.charCodeAt(I[y]+f.end.column-1)===w.CharCode.CarriageReturn?(t=!0,f.end.column===0?s--:i=$.substr(I[y],f.end.column-1)):i=$.substr(I[y],f.end.column),!0}),t&&(n[s++]=i,i=""),n[s++]=i,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const s=n.node.next();if(!s)return 0;const i=this.a[s.piece.bufferIndex],t=this.u(s.piece.bufferIndex,s.piece.start);return i.buffer.charCodeAt(t)}else{const s=this.a[n.node.piece.bufferIndex],t=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return s.buffer.charCodeAt(t)}}getLineCharCode(n,s){const i=this.H(n,s+1);return this.l(i)}getLineLength(n){if(n===this.getLineCount()){const s=this.getOffsetAt(n,1);return this.getLength()-s}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const s=this.G(n);return this.l(s)}getNearestChunk(n){const s=this.G(n);if(s.remainder===s.node.piece.length){const i=s.node.next();if(!i||i===A.$1C)return"";const t=this.a[i.piece.bufferIndex],m=this.u(i.piece.bufferIndex,i.piece.start);return t.buffer.substring(m,m+i.piece.length)}else{const i=this.a[s.node.piece.bufferIndex],t=this.u(s.node.piece.bufferIndex,s.node.piece.start),m=t+s.remainder,f=t+s.node.piece.length;return i.buffer.substring(m,f)}}findMatchesInNode(n,s,i,t,m,f,l,$,I,D,y){const S=this.a[n.piece.bufferIndex],k=this.u(n.piece.bufferIndex,n.piece.start),g=this.u(n.piece.bufferIndex,m),b=this.u(n.piece.bufferIndex,f);let L;const O={line:0,column:0};let q,G;s._wordSeparators?(q=S.buffer.substring(g,b),G=W=>W+g,s.reset(0)):(q=S.buffer,G=W=>W,s.reset(g));do if(L=s.next(q),L){if(G(L.index)>=b)return D;this.s(n,G(L.index)-k,O);const W=this.t(n.piece.bufferIndex,m,O),F=O.line===m.line?O.column-m.column+t:O.column+1,V=F+L[0].length;if(y[D++]=(0,N.$_C)(new P.$It(i+W,F,i+W,V),L,$),G(L.index)+L[0].length>=b||D>=I)return D}while(L);return D}findMatchesLineByLine(n,s,i,t){const m=[];let f=0;const l=new N.$cD(s.wordSeparators,s.regex);let $=this.H(n.startLineNumber,n.startColumn);if($===null)return[];const I=this.H(n.endLineNumber,n.endColumn);if(I===null)return[];let D=this.s($.node,$.remainder);const y=this.s(I.node,I.remainder);if($.node===I.node)return this.findMatchesInNode($.node,l,n.startLineNumber,n.startColumn,D,y,s,i,t,f,m),m;let S=n.startLineNumber,k=$.node;for(;k!==I.node;){const b=this.t(k.piece.bufferIndex,D,k.piece.end);if(b>=1){const O=this.a[k.piece.bufferIndex].lineStarts,q=this.u(k.piece.bufferIndex,k.piece.start),G=O[D.line+b],W=S===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(k,l,S,W,D,this.s(k,G-q),s,i,t,f,m),f>=t)return m;S+=b}const L=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const O=this.getLineContent(S).substring(L,n.endColumn-1);return f=this.n(s,l,O,n.endLineNumber,L,f,m,i,t),m}if(f=this.n(s,l,this.getLineContent(S).substr(L),S,L,f,m,i,t),f>=t)return m;S++,$=this.H(S,1),k=$.node,D=this.s($.node,$.remainder)}if(S===n.endLineNumber){const b=S===n.startLineNumber?n.startColumn-1:0,L=this.getLineContent(S).substring(b,n.endColumn-1);return f=this.n(s,l,L,n.endLineNumber,b,f,m,i,t),m}const g=S===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(I.node,l,S,g,D,y,s,i,t,f,m),m}n(n,s,i,t,m,f,l,$,I){const D=n.wordSeparators;if(!$&&n.simpleSearch){const S=n.simpleSearch,k=S.length,g=i.length;let b=-k;for(;(b=i.indexOf(S,b+k))!==-1;)if((!D||(0,N.$bD)(D,i,g,b,k))&&(l[f++]=new T.$0v(new P.$It(t,b+1+m,t,b+1+k+m),null),f>=I))return f;return f}let y;s.reset(0);do if(y=s.next(i),y&&(l[f++]=(0,N.$_C)(new P.$It(t,y.index+1+m,t,y.index+1+y[0].length+m),y,$),f>=I))return f;while(y);return f}insert(n,s,i=!1){if(this.f=this.f&&i,this.j.lineNumber=0,this.j.value="",this.root!==A.$1C){const{node:t,remainder:m,nodeStartOffset:f}=this.G(n),l=t.piece,$=l.bufferIndex,I=this.s(t,m);if(t.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&f+l.length===n&&s.length<p){this.F(t,s),this.y();return}if(f===n)this.o(s,t),this.h.validate(n);else if(f+t.piece.length>n){const D=[];let y=new E(l.bufferIndex,I,l.end,this.t(l.bufferIndex,I,l.end),this.u($,l.end)-this.u($,I));if(this.K()&&this.M(s)&&this.I(t,m)===10){const b={line:y.start.line+1,column:0};y=new E(y.bufferIndex,b,y.end,this.t(y.bufferIndex,b,y.end),y.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(t,m-1)===13){const b=this.s(t,m-1);this.C(t,b),s="\r"+s,t.piece.length===0&&D.push(t)}else this.C(t,I);else this.C(t,I);const S=this.w(s);y.length>0&&this.S(t,y);let k=t;for(let g=0;g<S.length;g++)k=this.S(k,S[g]);this.v(D)}else this.q(s,t)}else{const t=this.w(s);let m=this.T(null,t[0]);for(let f=1;f<t.length;f++)m=this.S(m,t[f])}this.y()}delete(n,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===A.$1C)return;const i=this.G(n),t=this.G(n+s),m=i.node,f=t.node;if(m===f){const S=this.s(m,i.remainder),k=this.s(m,t.remainder);if(i.nodeStartOffset===n){if(s===m.piece.length){const g=m.next();(0,A.$6C)(this,m),this.N(g),this.y();return}this.D(m,k),this.h.validate(n),this.N(m),this.y();return}if(i.nodeStartOffset+m.piece.length===n+s){this.C(m,S),this.O(m),this.y();return}this.E(m,S,k),this.y();return}const l=[],$=this.s(m,i.remainder);this.C(m,$),this.h.validate(n),m.piece.length===0&&l.push(m);const I=this.s(f,t.remainder);this.D(f,I),f.piece.length===0&&l.push(f);const D=m.next();for(let S=D;S!==A.$1C&&S!==f;S=S.next())l.push(S);const y=m.piece.length===0?m.prev():m;this.v(l),this.O(y),this.y()}o(n,s){const i=[];if(this.K()&&this.M(n)&&this.L(s)){const f=s.piece,l={line:f.start.line+1,column:0},$=new E(f.bufferIndex,l,f.end,this.t(f.bufferIndex,l,f.end),f.length-1);s.piece=$,n+=`
`,(0,A.$8C)(this,s,-1,-1),s.piece.length===0&&i.push(s)}const t=this.w(n);let m=this.T(s,t[t.length-1]);for(let f=t.length-2;f>=0;f--)m=this.T(m,t[f]);this.N(m),this.v(i)}q(n,s){this.Q(n,s)&&(n+=`
`);const i=this.w(n),t=this.S(s,i[0]);let m=t;for(let f=1;f<i.length;f++)m=this.S(m,i[f]);this.N(t)}s(n,s,i){const t=n.piece,m=n.piece.bufferIndex,f=this.a[m].lineStarts,$=f[t.start.line]+t.start.column+s;let I=t.start.line,D=t.end.line,y=0,S=0,k=0;for(;I<=D&&(y=I+(D-I)/2|0,k=f[y],y!==D);)if(S=f[y+1],$<k)D=y-1;else if($>=S)I=y+1;else break;return i?(i.line=y,i.column=$-k,null):{line:y,column:$-k}}t(n,s,i){if(i.column===0)return i.line-s.line;const t=this.a[n].lineStarts;if(i.line===t.length-1)return i.line-s.line;const m=t[i.line+1],f=t[i.line]+i.column;if(m>f+1)return i.line-s.line;const l=f-1;return this.a[n].buffer.charCodeAt(l)===13?i.line-s.line+1:i.line-s.line}u(n,s){return this.a[n].lineStarts[s.line]+s.column}v(n){for(let s=0;s<n.length;s++)(0,A.$6C)(this,n[s])}w(n){if(n.length>p){const D=[];for(;n.length>p;){const S=n.charCodeAt(p-1);let k;S===w.CharCode.CarriageReturn||S>=55296&&S<=56319?(k=n.substring(0,p-1),n=n.substring(p-1)):(k=n.substring(0,p),n=n.substring(p));const g=v(k);D.push(new E(this.a.length,{line:0,column:0},{line:g.length-1,column:k.length-g[g.length-1]},g.length-1,k.length)),this.a.push(new d(k,g))}const y=v(n);return D.push(new E(this.a.length,{line:0,column:0},{line:y.length-1,column:n.length-y[y.length-1]},y.length-1,n.length)),this.a.push(new d(n,y)),D}let s=this.a[0].buffer.length;const i=v(n,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let D=0;D<i.length;D++)i[D]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+="_"+n,s+=1}else{if(s!==0)for(let D=0;D<i.length;D++)i[D]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1)),this.a[0].buffer+=n}const m=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,l=m-this.a[0].lineStarts[f],$={line:f,column:l},I=new E(0,t,$,this.t(0,t,$),m-s);return this.g=$,[I]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,s=0){let i=this.root,t="";const m=this.h.get2(n);if(m){i=m.node;const f=this.B(i,n-m.nodeStartLineNumber-1),l=this.a[i.piece.bufferIndex].buffer,$=this.u(i.piece.bufferIndex,i.piece.start);if(m.nodeStartLineNumber+i.piece.lineFeedCnt===n)t=l.substring($+f,$+i.piece.length);else{const I=this.B(i,n-m.nodeStartLineNumber);return l.substring($+f,$+I-s)}}else{let f=0;const l=n;for(;i!==A.$1C;)if(i.left!==A.$1C&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const $=this.B(i,n-i.lf_left-2),I=this.B(i,n-i.lf_left-1),D=this.a[i.piece.bufferIndex].buffer,y=this.u(i.piece.bufferIndex,i.piece.start);return f+=i.size_left,this.h.set({node:i,nodeStartOffset:f,nodeStartLineNumber:l-(n-1-i.lf_left)}),D.substring(y+$,y+I-s)}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const $=this.B(i,n-i.lf_left-2),I=this.a[i.piece.bufferIndex].buffer,D=this.u(i.piece.bufferIndex,i.piece.start);t=I.substring(D+$,D+i.piece.length);break}else n-=i.lf_left+i.piece.lineFeedCnt,f+=i.size_left+i.piece.length,i=i.right}for(i=i.next();i!==A.$1C;){const f=this.a[i.piece.bufferIndex].buffer;if(i.piece.lineFeedCnt>0){const l=this.B(i,0),$=this.u(i.piece.bufferIndex,i.piece.start);return t+=f.substring($,$+l-s),t}else{const l=this.u(i.piece.bufferIndex,i.piece.start);t+=f.substr(l,i.piece.length)}i=i.next()}return t}y(){let n=this.root,s=1,i=0;for(;n!==A.$1C;)s+=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;this.b=s,this.c=i,this.h.validate(this.c)}A(n,s){const i=n.piece,t=this.s(n,s),m=t.line-i.start.line;if(this.u(i.bufferIndex,i.end)-this.u(i.bufferIndex,i.start)===s){const f=this.t(n.piece.bufferIndex,i.start,t);if(f!==m)return{index:f,remainder:0}}return{index:m,remainder:t.column}}B(n,s){if(s<0)return 0;const i=n.piece,t=this.a[i.bufferIndex].lineStarts,m=i.start.line+s+1;return m>i.end.line?t[i.end.line]+i.end.column-t[i.start.line]-i.start.column:t[m]-t[i.start.line]-i.start.column}C(n,s){const i=n.piece,t=i.lineFeedCnt,m=this.u(i.bufferIndex,i.end),f=s,l=this.u(i.bufferIndex,f),$=this.t(i.bufferIndex,i.start,f),I=$-t,D=l-m,y=i.length+D;n.piece=new E(i.bufferIndex,i.start,f,$,y),(0,A.$8C)(this,n,D,I)}D(n,s){const i=n.piece,t=i.lineFeedCnt,m=this.u(i.bufferIndex,i.start),f=s,l=this.t(i.bufferIndex,f,i.end),$=this.u(i.bufferIndex,f),I=l-t,D=m-$,y=i.length+D;n.piece=new E(i.bufferIndex,f,i.end,l,y),(0,A.$8C)(this,n,D,I)}E(n,s,i){const t=n.piece,m=t.start,f=t.end,l=t.length,$=t.lineFeedCnt,I=s,D=this.t(t.bufferIndex,t.start,I),y=this.u(t.bufferIndex,s)-this.u(t.bufferIndex,m);n.piece=new E(t.bufferIndex,t.start,I,D,y),(0,A.$8C)(this,n,y-l,D-$);const S=new E(t.bufferIndex,i,f,this.t(t.bufferIndex,i,f),this.u(t.bufferIndex,f)-this.u(t.bufferIndex,i)),k=this.S(n,S);this.N(k)}F(n,s){this.Q(s,n)&&(s+=`
`);const i=this.K()&&this.L(s)&&this.M(n),t=this.a[0].buffer.length;this.a[0].buffer+=s;const m=v(s,!1);for(let k=0;k<m.length;k++)m[k]+=t;if(i){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(m.slice(1));const f=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[f],$={line:f,column:l},I=n.piece.length+s.length,D=n.piece.lineFeedCnt,y=this.t(0,n.piece.start,$),S=y-D;n.piece=new E(n.piece.bufferIndex,n.piece.start,$,y,I),this.g=$,(0,A.$8C)(this,n,s.length,S)}G(n){let s=this.root;const i=this.h.get(n);if(i)return{node:i.node,nodeStartOffset:i.nodeStartOffset,remainder:n-i.nodeStartOffset};let t=0;for(;s!==A.$1C;)if(s.size_left>n)s=s.left;else if(s.size_left+s.piece.length>=n){t+=s.size_left;const m={node:s,remainder:n-s.size_left,nodeStartOffset:t};return this.h.set(m),m}else n-=s.size_left+s.piece.length,t+=s.size_left+s.piece.length,s=s.right;return null}H(n,s){let i=this.root,t=0;for(;i!==A.$1C;)if(i.left!==A.$1C&&i.lf_left>=n-1)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt>n-1){const m=this.B(i,n-i.lf_left-2),f=this.B(i,n-i.lf_left-1);return t+=i.size_left,{node:i,remainder:Math.min(m+s-1,f),nodeStartOffset:t}}else if(i.lf_left+i.piece.lineFeedCnt===n-1){const m=this.B(i,n-i.lf_left-2);if(m+s-1<=i.piece.length)return{node:i,remainder:m+s-1,nodeStartOffset:t};s-=i.piece.length-m;break}else n-=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;for(i=i.next();i!==A.$1C;){if(i.piece.lineFeedCnt>0){const m=this.B(i,0),f=this.J(i);return{node:i,remainder:Math.min(s-1,m),nodeStartOffset:f}}else if(i.piece.length>=s-1){const m=this.J(i);return{node:i,remainder:s-1,nodeStartOffset:m}}else s-=i.piece.length;i=i.next()}return null}I(n,s){if(n.piece.lineFeedCnt<1)return-1;const i=this.a[n.piece.bufferIndex],t=this.u(n.piece.bufferIndex,n.piece.start)+s;return i.buffer.charCodeAt(t)}J(n){if(!n)return 0;let s=n.size_left;for(;n!==this.root;)n.parent.right===n&&(s+=n.parent.size_left+n.parent.piece.length),n=n.parent;return s}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===A.$1C||n.piece.lineFeedCnt===0)return!1;const s=n.piece,i=this.a[s.bufferIndex].lineStarts,t=s.start.line,m=i[t]+s.start.column;return t===i.length-1||i[t+1]>m+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(m)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===A.$1C||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const s=n.prev();this.M(s)&&this.P(s,n)}}O(n){if(this.K()&&this.M(n)){const s=n.next();this.L(s)&&this.P(n,s)}}P(n,s){const i=[],t=this.a[n.piece.bufferIndex].lineStarts;let m;n.piece.end.column===0?m={line:n.piece.end.line-1,column:t[n.piece.end.line]-t[n.piece.end.line-1]-1}:m={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,l=n.piece.lineFeedCnt-1;n.piece=new E(n.piece.bufferIndex,n.piece.start,m,l,f),(0,A.$8C)(this,n,-1,-1),n.piece.length===0&&i.push(n);const $={line:s.piece.start.line+1,column:0},I=s.piece.length-1,D=this.t(s.piece.bufferIndex,$,s.piece.end);s.piece=new E(s.piece.bufferIndex,$,s.piece.end,D,I),(0,A.$8C)(this,s,-1,-1),s.piece.length===0&&i.push(s);const y=this.w(`\r
`);this.S(n,y[0]);for(let S=0;S<i.length;S++)(0,A.$6C)(this,i[S])}Q(n,s){if(this.K()&&this.M(n)){const i=s.next();if(this.L(i)){if(n+=`
`,i.piece.length===1)(0,A.$6C)(this,i);else{const t=i.piece,m={line:t.start.line+1,column:0},f=t.length-1,l=this.t(t.bufferIndex,m,t.end);i.piece=new E(t.bufferIndex,m,t.end,l,f),(0,A.$8C)(this,i,-1,-1)}return!0}}return!1}iterate(n,s){if(n===A.$1C)return s(A.$1C);const i=this.iterate(n.left,s);return i&&s(n)&&this.iterate(n.right,s)}R(n){if(n===A.$1C)return"";const s=this.a[n.piece.bufferIndex],i=n.piece,t=this.u(i.bufferIndex,i.start),m=this.u(i.bufferIndex,i.end);return s.buffer.substring(t,m)}getPieceContent(n){const s=this.a[n.bufferIndex],i=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return s.buffer.substring(i,t)}S(n,s){const i=new A.$ZC(s,A.NodeColor.Red);if(i.left=A.$1C,i.right=A.$1C,i.parent=A.$1C,i.size_left=0,i.lf_left=0,this.root===A.$1C)this.root=i,i.color=A.NodeColor.Black;else if(n.right===A.$1C)n.right=i,i.parent=n;else{const m=(0,A.$2C)(n.right);m.left=i,i.parent=m}return(0,A.$7C)(this,i),i}T(n,s){const i=new A.$ZC(s,A.NodeColor.Red);if(i.left=A.$1C,i.right=A.$1C,i.parent=A.$1C,i.size_left=0,i.lf_left=0,this.root===A.$1C)this.root=i,i.color=A.NodeColor.Black;else if(n.left===A.$1C)n.left=i,i.parent=n;else{const t=(0,A.$3C)(n.left);t.right=i,i.parent=t}return(0,A.$7C)(this,i),i}U(n){let s="";return this.iterate(n,i=>(s+=this.R(i),!0)),s}}e.$hD=a}),define(Ce[153],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c_=e.$b_=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$b_=w;class C{constructor(T){this.identifier=T}}e.$c_=C}),define(Ce[154],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ce[155],Ie([1,0,4,5,154]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=void 0,e.$pj=R,P=qe(P);class T extends C.$Wc{constructor(u,E="",d="",r=!0,o){super(),this.j=this.B(new w.$me),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=E,this.w=d,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,E){this.D&&await this.D(u)}}e.$kj=T;class A extends C.$Wc{constructor(){super(...arguments),this.f=this.B(new w.$me),this.onWillRun=this.f.event,this.m=this.B(new w.$me),this.onDidRun=this.m.event}async run(u,E){if(!u.enabled)return;this.f.fire({action:u});let d;try{await this.u(u,E)}catch(r){d=r}this.m.fire({action:u,error:d})}async u(u,E){await u.run(E)}}e.$lj=A;class N{constructor(){this.id=N.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let E=[];for(const d of u)d.length&&(E.length?E=[...E,new N,...d]:E=d);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$mj=N;class p{get actions(){return this.a}constructor(u,E,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=E,this.class=r,this.a=d}async run(){}}e.$nj=p;class c extends T{static{this.ID="vs.actions.empty"}constructor(){super(c.ID,P.localize(0,null),void 0,!1)}}e.$oj=c;function R(v){return{id:v.id,label:v.label,tooltip:v.tooltip??v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...u)=>v.run(...u)}}}),define(Ce[156],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ce[157],Ie([1,0,156]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=c,e.$2m=R,e.$3m=v;const C=60,P=C*60,T=P*24,A=T*7,N=T*30,p=T*365;function c(u,E,d,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,w.localize)(0,null,c(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,w.localize)(1,null);let a;return o<C?(a=o,E?a===1?d?(0,w.localize)(2,null,a):(0,w.localize)(3,null,a):d?(0,w.localize)(4,null,a):(0,w.localize)(5,null,a):a===1?d?(0,w.localize)(6,null,a):(0,w.localize)(7,null,a):d?(0,w.localize)(8,null,a):(0,w.localize)(9,null,a)):o<P?(a=Math.floor(o/C),E?a===1?d?(0,w.localize)(10,null,a):(0,w.localize)(11,null,a):d?(0,w.localize)(12,null,a):(0,w.localize)(13,null,a):a===1?d?(0,w.localize)(14,null,a):(0,w.localize)(15,null,a):d?(0,w.localize)(16,null,a):(0,w.localize)(17,null,a)):o<T?(a=Math.floor(o/P),E?a===1?d?(0,w.localize)(18,null,a):(0,w.localize)(19,null,a):d?(0,w.localize)(20,null,a):(0,w.localize)(21,null,a):a===1?d?(0,w.localize)(22,null,a):(0,w.localize)(23,null,a):d?(0,w.localize)(24,null,a):(0,w.localize)(25,null,a)):o<A?(a=Math.floor(o/T),E?a===1?(0,w.localize)(26,null,a):(0,w.localize)(27,null,a):a===1?(0,w.localize)(28,null,a):(0,w.localize)(29,null,a)):o<N?(a=Math.floor(o/A),E?a===1?d?(0,w.localize)(30,null,a):(0,w.localize)(31,null,a):d?(0,w.localize)(32,null,a):(0,w.localize)(33,null,a):a===1?d?(0,w.localize)(34,null,a):(0,w.localize)(35,null,a):d?(0,w.localize)(36,null,a):(0,w.localize)(37,null,a)):o<p?(a=Math.floor(o/N),E?a===1?d?(0,w.localize)(38,null,a):(0,w.localize)(39,null,a):d?(0,w.localize)(40,null,a):(0,w.localize)(41,null,a):a===1?d?(0,w.localize)(42,null,a):(0,w.localize)(43,null,a):d?(0,w.localize)(44,null,a):(0,w.localize)(45,null,a)):(a=Math.floor(o/p),E?a===1?d?(0,w.localize)(46,null,a):(0,w.localize)(47,null,a):d?(0,w.localize)(48,null,a):(0,w.localize)(49,null,a):a===1?d?(0,w.localize)(50,null,a):(0,w.localize)(51,null,a):d?(0,w.localize)(52,null,a):(0,w.localize)(53,null,a))}function R(u,E){const d=Math.abs(u/1e3);return d<1?E?(0,w.localize)(54,null,u):(0,w.localize)(55,null,u):d<C?E?(0,w.localize)(56,null,Math.round(u)/1e3):(0,w.localize)(57,null,Math.round(u)/1e3):d<P?E?(0,w.localize)(58,null,Math.round(u/(1e3*C))):(0,w.localize)(59,null,Math.round(u/(1e3*C))):d<T?E?(0,w.localize)(60,null,Math.round(u/(1e3*P))):(0,w.localize)(61,null,Math.round(u/(1e3*P))):(0,w.localize)(62,null,Math.round(u/(1e3*T)))}function v(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[158],Ie([8,9]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ce[48],Ie([1,0,18,15,158]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=p,e.$rj=c,e.$sj=R,w=qe(w),C=qe(C),P=qe(P);function T(v,u){return u&&(v.stack||v.stacktrace)?P.localize(0,null,N(v),A(v.stack)||A(v.stacktrace)):N(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function N(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?P.localize(1,null,v.message):v.message||P.localize(2,null)}function p(v=null,u=!1){if(!v)return P.localize(3,null);if(Array.isArray(v)){const E=w.$Jb(v),d=p(E[0],u);return E.length>1?P.localize(4,null,d,E.length):d}if(C.$fg(v))return v;if(v.detail){const E=v.detail;if(E.error)return T(E.error,u);if(E.exception)return T(E.exception,u)}return v.stack?T(v,u):v.message?v.message:P.localize(5,null)}function c(v){const u=v;return u instanceof Error&&Array.isArray(u.actions)}function R(v,u){let E;return typeof v=="string"?E=new Error(v):E=v,E.actions=u,E}}),define(Ce[159],Ie([1,0,47,20]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=N,e.$vr=p,e.$wr=c,e.$xr=R,e.$yr=v,e.$zr=u,e.$Ar=E,e.$Br=d,e.$Cr=r,e.$Dr=o,e.$Er=$,e.$Fr=I,e.$Gr=D;const P=new w.$X(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new w.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new w.$X(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function N(y,S,k=!1){const g=y||"",b=S||"",L=P.value.collator.compare(g,b);return P.value.collatorIsNumeric&&L===0&&g!==b?g<b?-1:1:L}function p(y,S){const k=T.value.collator;return y=y||"",S=S||"",s(k,y,S)}function c(y,S){const k=T.value.collator;return y=y||"",S=S||"",f(y,S)||s(k,y,S)}function R(y,S){const k=T.value.collator;return y=y||"",S=S||"",m(y,S)||s(k,y,S)}function v(y,S){return y=y||"",S=S||"",y===S?0:y<S?-1:1}function u(y,S){const[k,g]=h(y),[b,L]=h(S);let O=P.value.collator.compare(g,L);if(O===0){if(P.value.collatorIsNumeric&&g!==L)return g<L?-1:1;if(O=P.value.collator.compare(k,b),P.value.collatorIsNumeric&&O===0&&k!==b)return k<b?-1:1}return O}function E(y,S){y=y||"",S=S||"";const k=n(y),g=n(S),b=T.value.collator,L=A.value.collator;return s(L,k,g)||s(b,y,S)}function d(y,S){y=y||"",S=S||"";const k=n(y),g=n(S),b=T.value.collator,L=A.value.collator;return s(L,k,g)||f(y,S)||s(b,y,S)}function r(y,S){y=y||"",S=S||"";const k=n(y),g=n(S),b=T.value.collator,L=A.value.collator;return s(L,k,g)||m(y,S)||s(b,y,S)}function o(y,S){y=y||"",S=S||"";const k=n(y).toLowerCase(),g=n(S).toLowerCase();return k!==g?k<g?-1:1:y!==S?y<S?-1:1:0}const a=/^(.*?)(\.([^.]*))?$/;function h(y,S=!1){const k=y?a.exec(y):[];let g=[k&&k[1]||"",k&&k[3]||""];return S&&(!g[0]&&g[1]||g[0]&&g[0].charAt(0)===".")&&(g=[g[0]+"."+g[1],""]),g}function n(y){const S=y?a.exec(y):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function s(y,S,k){const g=y.compare(S,k);return g!==0?g:S.length!==k.length?S.length<k.length?-1:1:0}function i(y){const S=y.charAt(0);return S.toLocaleUpperCase()!==S}function t(y){const S=y.charAt(0);return S.toLocaleLowerCase()!==S}function m(y,S){return i(y)&&t(S)?-1:t(y)&&i(S)?1:0}function f(y,S){return t(y)&&i(S)?-1:i(y)&&t(S)?1:0}function l(y,S,k=!1){return k||(y=y&&y.toLowerCase(),S=S&&S.toLowerCase()),y===S?0:y<S?-1:1}function $(y,S,k=!1){const g=y.split(C.sep),b=S.split(C.sep),L=g.length-1,O=b.length-1;let q,G;for(let W=0;;W++){if(q=L===W,G=O===W,q&&G)return N(g[W],b[W],k);if(q)return-1;if(G)return 1;const F=l(g[W],b[W],k);if(F!==0)return F}}function I(y,S,k){const g=y.toLowerCase(),b=S.toLowerCase(),L=D(y,S,k);if(L)return L;const O=g.endsWith(k),q=b.endsWith(k);if(O!==q)return O?-1:1;const G=N(g,b);return G!==0?G:g.localeCompare(b)}function D(y,S,k){const g=y.toLowerCase(),b=S.toLowerCase(),L=g.startsWith(k),O=b.startsWith(k);if(L!==O)return L?-1:1;if(L&&O){if(g.length<b.length)return-1;if(g.length>b.length)return 1}return 0}}),define(Ce[53],Ie([1,0,28,20,21,13,15]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xg=N,e.$yg=p,e.$zg=c,e.$Ag=R,e.$Bg=v,e.$Cg=r,e.$Dg=o,e.$Eg=a,e.$Fg=h,e.$Gg=n,e.$Hg=s,e.$Ig=i,e.$Jg=t,e.$Kg=m,e.$Lg=f,e.$Mg=l,e.$Ng=D;function N(y){return y===w.CharCode.Slash||y===w.CharCode.Backslash}function p(y){return y.replace(/[\\/]/g,C.$ic.sep)}function c(y){return y.indexOf("/")===-1&&(y=p(y)),/^[a-zA-Z]:(\/|$)/.test(y)&&(y="/"+y),y}function R(y,S=C.$ic.sep){if(!y)return"";const k=y.length,g=y.charCodeAt(0);if(N(g)){if(N(y.charCodeAt(1))&&!N(y.charCodeAt(2))){let L=3;const O=L;for(;L<k&&!N(y.charCodeAt(L));L++);if(O!==L&&!N(y.charCodeAt(L+1))){for(L+=1;L<k;L++)if(N(y.charCodeAt(L)))return y.slice(0,L+1).replace(/[\\/]/g,S)}}return S}else if(h(g)&&y.charCodeAt(1)===w.CharCode.Colon)return N(y.charCodeAt(2))?y.slice(0,2)+S:y.slice(0,2);let b=y.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(N(y.charCodeAt(b)))return y.slice(0,b+1)}return""}function v(y){if(!P.$i||!y||y.length<5)return!1;let S=y.charCodeAt(0);if(S!==w.CharCode.Backslash||(S=y.charCodeAt(1),S!==w.CharCode.Backslash))return!1;let k=2;const g=k;for(;k<y.length&&(S=y.charCodeAt(k),S!==w.CharCode.Backslash);k++);return!(g===k||(S=y.charCodeAt(k+1),isNaN(S)||S===w.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,E=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(y,S=P.$i){const k=S?u:E;return!(!y||y.length===0||/^\s+$/.test(y)||(k.lastIndex=0,k.test(y))||S&&d.test(y)||y==="."||y===".."||S&&y[y.length-1]==="."||S&&y.length!==y.trim().length||y.length>255)}function o(y,S,k){const g=y===S;return!k||g?g:!y||!S?!1:(0,T.$Gf)(y,S)}function a(y,S,k,g=C.sep){if(y===S)return!0;if(!y||!S||S.length>y.length)return!1;if(k){if(!(0,T.$Hf)(y,S))return!1;if(S.length===y.length)return!0;let L=S.length;return S.charAt(S.length-1)===g&&L--,y.charAt(L)===g}return S.charAt(S.length-1)!==g&&(S+=g),y.indexOf(S)===0}function h(y){return y>=w.CharCode.A&&y<=w.CharCode.Z||y>=w.CharCode.a&&y<=w.CharCode.z}function n(y,S){return P.$i&&y.endsWith(":")&&(y+=C.sep),(0,C.$kc)(y)||(y=(0,C.$lc)(S,y)),y=(0,C.$jc)(y),s(y)}function s(y){return P.$i?(y=(0,T.$of)(y,C.sep),y.endsWith(":")&&(y+=C.sep)):(y=(0,T.$of)(y,C.sep),y||(y=C.sep)),y}function i(y){const S=(0,C.$jc)(y);return P.$i?y.length>3?!1:t(S)&&(y.length===2||S.charCodeAt(2)===w.CharCode.Backslash):S===C.$ic.sep}function t(y,S=P.$i){return S?h(y.charCodeAt(0))&&y.charCodeAt(1)===w.CharCode.Colon:!1}function m(y,S=P.$i){return t(y,S)?y[0]:void 0}function f(y,S,k){return S.length>y.length?-1:y===S?0:(k&&(y=y.toLowerCase(),S=S.toLowerCase()),y.indexOf(S))}function l(y){const S=y.split(":");let k,g,b;for(const L of S){const O=Number(L);(0,A.$jg)(O)?g===void 0?g=O:b===void 0&&(b=O):k=k?[k,L].join(":"):L}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:g!==void 0?g:void 0,column:b!==void 0?b:g!==void 0?1:void 0}}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(y,S,k=8){let g="";for(let L=0;L<k;L++){let O;L===0&&P.$i&&!S&&(k===3||k===4)?O=I:O=$,g+=O.charAt(Math.floor(Math.random()*O.length))}let b;return S?b=`${S}-${g}`:b=g,y?(0,C.$lc)(y,b):b}}),define(Ce[73],Ie([1,0,20]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5s=void 0,e.$6s=T,e.$7s=A,e.$8s=N,e.$9s=c,e.$5s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(R){const v=(0,w.$qc)(R),u=C[v.toLowerCase()];return u!==void 0?u:A(R)}function A(R){const v=(0,w.$qc)(R);return P[v.toLowerCase()]}function N(R){for(const v in P)if(P[v]===R)return v}const p=/^(.+)\/(.+?)(;.+)?$/;function c(R,v){const u=p.exec(R);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:v?void 0:R}}),define(Ce[49],Ie([1,0,23,2,38]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=T,e.$bi=A,e.$ci=p;function T(c){return JSON.stringify(c,N)}function A(c){let R=JSON.parse(c);return R=p(R),R}function N(c,R){return R instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:R.source,flags:R.flags}:R}function p(c,R=0){if(!c||R>200)return c;if(typeof c=="object"){switch(c.$mid){case P.MarshalledId.Uri:return C.URI.revive(c);case P.MarshalledId.Regexp:return new RegExp(c.source,c.flags);case P.MarshalledId.Date:return new Date(c.source)}if(c instanceof w.$Oe||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let v=0;v<c.length;++v)c[v]=p(c[v],R+1);else for(const v in c)Object.hasOwnProperty.call(c,v)&&(c[v]=p(c[v],R+1))}return c}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Sg=e.$Rg=e.$Qg=e.Schemas=void 0,e.$Og=p,e.$Pg=c,e.$Tg=v,w=qe(w),C=qe(C),A=qe(A);var N;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(N||(e.Schemas=N={}));function p(d,r){return T.URI.isUri(d)?(0,P.$Gf)(d.scheme,r):(0,P.$Hf)(d,r+":")}function c(d,...r){return r.some(o=>p(d,o))}e.$Qg="vscode-tkn",e.$Rg="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=v(r,o)}getServerRootPath(){return this.f}get g(){return A.$ic.join(this.f,N.vscodeRemoteResource)}set(r,o,a){this.a[r]=o,this.b[r]=a}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(i){return w.$3(i),r}const o=r.authority;let a=this.a[o];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const h=this.b[o],n=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof n=="string"&&(s+=`&${e.$Rg}=${encodeURIComponent(n)}`),T.URI.from({scheme:C.$o?this.d:N.vscodeRemoteResource,authority:`${a}:${h}`,path:this.g,query:s})}}e.$Sg=new R;function v(d,r){return A.$ic.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Ug="vs/../../extensions",e.$Vg="vs/../../node_modules",e.$Wg="vs/../../node_modules.asar",e.$Xg="vs/../../node_modules.asar.unpacked",e.$Yg="vscode-app";class u{static{this.a=e.$Yg}asBrowserUri(r){const o=this.b(r,oe);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===N.vscodeRemote?e.$Sg.rewrite(r):r.scheme===N.file&&(C.$m||C.$q===`${N.vscodeFileResource}://${u.a}`)?r.with({scheme:N.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,oe);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===N.vscodeFileResource?r.with({scheme:N.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return T.URI.isUri(r)?r:T.URI.parse(o.toUrl(r))}}e.$Zg=new u;var E;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function a(n){let s;typeof n=="string"?s=new URL(n).searchParams:n instanceof URL?s=n.searchParams:T.URI.isUri(n)&&(s=new URL(n.toString(!0)).searchParams);const i=s?.get(o);if(i)return r.get(i)}d.getHeadersFromQuery=a;function h(n,s,i){if(!globalThis.crossOriginIsolated)return;const t=s&&i?"3":i?"2":"1";n instanceof URLSearchParams?n.set(o,t):n[o]=t}d.addSearchParam=h})(E||(e.COI=E={}))}),define(Ce[24],Ie([1,0,28,53,16,20,21,13,2]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=void 0,e.$7g=c,e.$ph=v,e.$qh=E,C=qe(C),T=qe(T);function c(d){return(0,p.$yc)(d,!0)}class R{constructor(r){this.a=r}compare(r,o,a=!1){return r===o?0:(0,N.$zf)(this.getComparisonKey(r,a),this.getComparisonKey(o,a))}isEqual(r,o,a=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,a)===this.getComparisonKey(o,a)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,a=!1){if(r.scheme===o.scheme){if(r.scheme===P.Schemas.file)return C.$Eg(c(r),c(o),this.a(r))&&r.query===o.query&&(a||r.fragment===o.fragment);if((0,e.$lh)(r.authority,o.authority))return C.$Eg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(a||r.fragment===o.fragment)}return!1}joinPath(r,...o){return p.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$dh)(r)||r.authority}basename(r){return T.$ic.basename(r.path)}extname(r){return T.$ic.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===P.Schemas.file?o=p.URI.file(T.$oc(c(r))).path:(o=T.$ic.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==w.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===P.Schemas.file?o=p.URI.file(T.$jc(c(r))).path:o=T.$ic.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$lh)(r.authority,o.authority))return;if(r.scheme===P.Schemas.file){const n=T.$nc(c(r),c(o));return A.$i?C.$yg(n):n}let a=r.path||"/";const h=o.path||"/";if(this.a(r)){let n=0;for(const s=Math.min(a.length,h.length);n<s&&!(a.charCodeAt(n)!==h.charCodeAt(n)&&a.charAt(n).toLowerCase()!==h.charAt(n).toLowerCase());n++);a=h.substr(0,n)+a.substr(n)}return T.$ic.relative(a,h)}resolvePath(r,o){if(r.scheme===P.Schemas.file){const a=p.URI.file(T.$mc(c(r),o));return r.with({authority:a.authority,path:a.path})}return o=C.$zg(o),r.with({path:T.$ic.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,N.$Gf)(r,o)}hasTrailingPathSeparator(r,o=T.sep){if(r.scheme===P.Schemas.file){const a=c(r);return a.length>C.$Ag(a).length&&a[a.length-1]===o}else{const a=r.path;return a.length>1&&a.charCodeAt(a.length-1)===w.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=T.sep){return(0,e.$mh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=T.sep){let a=!1;if(r.scheme===P.Schemas.file){const h=c(r);a=h!==void 0&&h.length===C.$Ag(h).length&&h[h.length-1]===o}else{o="/";const h=r.path;a=h.length===1&&h.charCodeAt(h.length-1)===w.CharCode.Slash}return!a&&!(0,e.$mh)(r,o)?r.with({path:r.path+"/"}):r}}e.$8g=R,e.$9g=new R(()=>!1),e.$0g=new R(d=>d.scheme===P.Schemas.file?!A.$k:!0),e.$$g=new R(d=>!0),e.$_g=e.$9g.isEqual.bind(e.$9g),e.$ah=e.$9g.isEqualOrParent.bind(e.$9g),e.$bh=e.$9g.getComparisonKey.bind(e.$9g),e.$ch=e.$9g.basenameOrAuthority.bind(e.$9g),e.$dh=e.$9g.basename.bind(e.$9g),e.$eh=e.$9g.extname.bind(e.$9g),e.$fh=e.$9g.dirname.bind(e.$9g),e.$gh=e.$9g.joinPath.bind(e.$9g),e.$hh=e.$9g.normalizePath.bind(e.$9g),e.$ih=e.$9g.relativePath.bind(e.$9g),e.$jh=e.$9g.resolvePath.bind(e.$9g),e.$kh=e.$9g.isAbsolutePath.bind(e.$9g),e.$lh=e.$9g.isEqualAuthority.bind(e.$9g),e.$mh=e.$9g.hasTrailingPathSeparator.bind(e.$9g),e.$nh=e.$9g.removeTrailingPathSeparator.bind(e.$9g),e.$oh=e.$9g.addTrailingPathSeparator.bind(e.$9g);function v(d,r){const o=[];for(let a=0;a<d.length;a++){const h=r(d[a]);d.some((n,s)=>s===a?!1:(0,e.$ah)(h,r(n)))||o.push(d[a])}return o}var u;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const a=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[i,t]=s.split(":");i&&t&&a.set(i,t)});const n=o.path.substring(0,o.path.indexOf(";"));return n&&a.set(d.META_DATA_MIME,n),a}d.parseMetaData=r})(u||(e.DataUri=u={}));function E(d,r,o){if(r){let a=d.path;return a&&a[0]!==T.$ic.sep&&(a=T.$ic.sep+a),d.with({scheme:o,authority:r,path:a})}return d.with({scheme:o})}}),define(Ce[11],Ie([1,0,22,14,4,5,24,21,145,47]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$7h=e.$6h=e.$5h=e.$4h=e.Promises=e.$3h=e.$2h=e.$1h=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=void 0,e.$rh=R,e.$sh=v,e.$th=u,e.$uh=E,e.$vh=d,e.$wh=r,e.$xh=o,e.$yh=a,e.$Gh=I,e.$Hh=D,e.$Ih=y,e.$Jh=S,e.$Kh=k,e.$Zh=me,e.$8h=ae;function R(le){return!!le&&typeof le.then=="function"}function v(le){const X=new w.$xe,Z=le(X.token),pe=new Promise(($e,Ne)=>{const ze=X.token.onCancellationRequested(()=>{ze.dispose(),Ne(new C.$7)});Promise.resolve(Z).then(ke=>{ze.dispose(),X.dispose(),$e(ke)},ke=>{ze.dispose(),X.dispose(),Ne(ke)})});return new class{cancel(){X.cancel(),X.dispose()}then($e,Ne){return pe.then($e,Ne)}catch($e){return this.then(void 0,$e)}finally($e){return pe.finally($e)}}}function u(le,X,Z){return new Promise((pe,$e)=>{const Ne=X.onCancellationRequested(()=>{Ne.dispose(),pe(Z)});le.then(pe,$e).finally(()=>Ne.dispose())})}function E(le,X){return new Promise((Z,pe)=>{const $e=X.onCancellationRequested(()=>{$e.dispose(),pe(new C.$7)});le.then(Z,pe).finally(()=>$e.dispose())})}async function d(le){let X=-1;const Z=le.map((pe,$e)=>pe.then(Ne=>(X=$e,Ne)));try{return await Promise.race(Z)}finally{le.forEach((pe,$e)=>{$e!==X&&pe.cancel()})}}function r(le,X,Z){let pe;const $e=setTimeout(()=>{pe?.(void 0),Z?.()},X);return Promise.race([le.finally(()=>clearTimeout($e)),new Promise(Ne=>pe=Ne)])}function o(le){return new Promise((X,Z)=>{const pe=le();R(pe)?pe.then(X,Z):X(pe)})}function a(){let le,X;return{promise:new Promise((pe,$e)=>{le=pe,X=$e}),resolve:le,reject:X}}class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const Z=()=>{if(this.b=null,this.f)return;const pe=this.queue(this.d);return this.d=null,pe};this.b=new Promise(pe=>{this.a.then(Z,Z).then(pe)})}return new Promise((Z,pe)=>{this.b.then(Z,pe)})}return this.a=X(),new Promise((Z,pe)=>{this.a.then($e=>{this.a=null,Z($e)},$e=>{this.a=null,pe($e)})})}dispose(){this.f=!0}}e.$zh=h;class n{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$Ah=n;class s{constructor(){this.a=new Map}queue(X,Z){const $e=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(Z).finally(()=>{this.a.get(X)===$e&&this.a.delete(X)});return this.a.set(X,$e),$e}}e.$Bh=s;const i=(le,X)=>{let Z=!0;const pe=setTimeout(()=>{Z=!1,X()},le);return{isTriggered:()=>Z,dispose:()=>{clearTimeout(pe),Z=!1}}},t=le=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,le())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class m{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,Z=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise(($e,Ne)=>{this.d=$e,this.f=Ne}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const pe=()=>{this.a=null,this.d?.(null)};return this.a=Z===p.$he?t(pe):i(Z,pe),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$7),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ch=m;class f{constructor(X){this.a=new m(X),this.b=new h}trigger(X,Z){return this.a.trigger(()=>this.b.queue(X),Z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Dh=f;class l{constructor(){this.a=!1,this.b=new Promise((X,Z)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Eh=l;class $ extends l{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Fh=$;function I(le,X){return X?new Promise((Z,pe)=>{const $e=setTimeout(()=>{Ne.dispose(),Z()},le),Ne=X.onCancellationRequested(()=>{clearTimeout($e),Ne.dispose(),pe(new C.$7)})}):v(Z=>I(le,Z))}function D(le,X=0,Z){const pe=setTimeout(()=>{le(),Z&&$e.dispose()},X),$e=(0,T.$Uc)(()=>{clearTimeout(pe),Z?.deleteAndLeak($e)});return Z?.add($e),$e}function y(le){const X=[];let Z=0;const pe=le.length;function $e(){return Z<pe?le[Z++]():null}function Ne(ze){ze!=null&&X.push(ze);const ke=$e();return ke?ke.then(Ne):Promise.resolve(X)}return Promise.resolve(null).then(Ne)}function S(le,X=pe=>!!pe,Z=null){let pe=0;const $e=le.length,Ne=()=>{if(pe>=$e)return Promise.resolve(Z);const ze=le[pe++];return Promise.resolve(ze()).then(Re=>X(Re)?Promise.resolve(Re):Ne())};return Ne()}function k(le,X=pe=>!!pe,Z=null){if(le.length===0)return Promise.resolve(Z);let pe=le.length;const $e=()=>{pe=-1;for(const Ne of le)Ne.cancel?.()};return new Promise((Ne,ze)=>{for(const ke of le)ke.then(Re=>{--pe>=0&&X(Re)?($e(),Ne(Re)):pe===0&&Ne(Z)}).catch(Re=>{--pe>=0&&($e(),ze(Re))})})}class g{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$me}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Z,pe)=>{this.g.push({factory:X,c:Z,e:pe}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const Z=X.factory();Z.then(X.c,X.e),Z.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Lh=g;class b extends g{constructor(){super(1)}}e.$Mh=b;class L{constructor(){this.a=new se,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Nh=L;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new re;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,Z=A.$9g){const pe=Z.getComparisonKey(X);return this.a.get(pe)?.size??0}queueFor(X,Z,pe=A.$9g){const $e=pe.getComparisonKey(X);let Ne=this.a.get($e);if(!Ne){Ne=new b;const ze=this.f++,ke=P.Event.once(Ne.onDrained)(()=>{Ne?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ze),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$6c),this.d.set(ze,ke),this.a.set($e,Ne)}return Ne.queue(Z)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Oh=O;class q{constructor(X,Z){this.b=!1,this.a=-1,typeof X=="function"&&typeof Z=="number"&&this.setIfNotSet(X,Z)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,Z){if(this.b)throw new C.$eb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},Z)}setIfNotSet(X,Z){if(this.b)throw new C.$eb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},Z))}}e.$Ph=q;class G{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,Z,pe=globalThis){if(this.f)throw new C.$eb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const $e=pe.setInterval(()=>{X()},Z);this.d=(0,T.$Uc)(()=>{pe.clearInterval($e),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Qh=G;class W{constructor(X,Z){this.b=-1,this.a=X,this.d=Z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Rh=W;class F{constructor(X,Z){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.a=X,this.b=Z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Sh=F;class V extends W{constructor(X,Z){super(X,Z),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Th=V;class ce extends T.$Wc{constructor(X,Z){super(),this.g=X,this.h=Z,this.a=[],this.b=this.B(new T.$Xc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Z of X)this.a.push(Z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Uh=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Wh=(le,X)=>{(0,N.$B)(()=>{if(Z)return;const pe=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,pe-Date.now())}}))});let Z=!1;return{dispose(){Z||(Z=!0)}}}:e.$Wh=(le,X,Z)=>{const pe=le.requestIdleCallback(X,typeof Z=="number"?{timeout:Z}:void 0);let $e=!1;return{dispose(){$e||($e=!0,le.cancelIdleCallback(pe))}}},e.$Vh=le=>(0,e.$Wh)(globalThis,le)}();class ge{constructor(X,Z){this.g=!1,this.d=()=>{try{this.j=Z()}catch(pe){this.l=pe}finally{this.g=!0}},this.f=(0,e.$Wh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Xh=ge;class te extends ge{constructor(X){super(globalThis,X)}}e.$Yh=te;async function me(le,X,Z){let pe;for(let $e=0;$e<Z;$e++)try{return await le()}catch(Ne){pe=Ne,await I(X)}throw pe}class se{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,Z,pe){return this.a={taskId:X,cancel:()=>pe?.(),promise:Z},Z.then(()=>this.d(X),()=>this.d(X)),Z}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:Z,resolve:pe,reject:$e}=a();this.b={run:X,promise:Z,promiseResolve:pe,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$1h=se;class de{constructor(X,Z=()=>Date.now()){this.d=X,this.f=Z,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$2h=de;var be;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(be||(be={}));class re{get isRejected(){return this.d?.outcome===be.Rejected}get isResolved(){return this.d?.outcome===be.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===be.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,Z)=>{this.a=X,this.b=Z})}complete(X){return new Promise(Z=>{this.a(X),this.d={outcome:be.Resolved,value:X},Z()})}error(X){return new Promise(Z=>{this.b(X),this.d={outcome:be.Rejected,value:X},Z()})}cancel(){return this.error(new C.$7)}}e.$3h=re;var Pe;(function(le){async function X(pe){let $e;const Ne=await Promise.all(pe.map(ze=>ze.then(ke=>ke,ke=>{$e||($e=ke)})));if(typeof $e<"u")throw $e;return Ne}le.settled=X;function Z(pe){return new Promise(async($e,Ne)=>{try{await pe($e,Ne)}catch(ze){Ne(ze)}})}le.withAsyncBody=Z})(Pe||(e.Promises=Pe={}));class Le{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(Z=>(this.a=Z,this.d=!0,Z),Z=>{throw this.b=Z,this.d=!0,Z})}requireValue(){if(!this.d)throw new C.$eb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$4h=Le;class Y{constructor(X){this.b=X,this.a=new c.$X(()=>new Le(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$5h=Y;var B;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(B||(B={}));class _{static fromArray(X){return new _(Z=>{Z.emitMany(X)})}static fromPromise(X){return new _(async Z=>{Z.emitMany(await X)})}static fromPromises(X){return new _(async Z=>{await Promise.all(X.map(async pe=>Z.emitOne(await pe)))})}static merge(X){return new _(async Z=>{await Promise.all(X.map(async pe=>{for await(const $e of pe)Z.emitOne($e)}))})}static{this.EMPTY=_.fromArray([])}constructor(X,Z){this.a=B.Initial,this.b=[],this.d=null,this.f=Z,this.g=new P.$me,queueMicrotask(async()=>{const pe={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(X(pe)),this.k()}catch($e){this.l($e)}finally{pe.emitOne=void 0,pe.emitMany=void 0,pe.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,Z){return new _(async pe=>{for await(const $e of X)pe.emitOne(Z($e))})}map(X){return _.map(this,X)}static filter(X,Z){return new _(async pe=>{for await(const $e of X)Z($e)&&pe.emitOne($e)})}filter(X){return _.filter(this,X)}static coalesce(X){return _.filter(X,Z=>!!Z)}coalesce(){return _.coalesce(this)}static async toPromise(X){const Z=[];for await(const pe of X)Z.push(pe);return Z}toPromise(){return _.toPromise(this)}h(X){this.a===B.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===B.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(X){this.a===B.Initial&&(this.a=B.DoneError,this.d=X,this.g.fire())}}e.$6h=_;class ve extends _{constructor(X,Z){super(Z),this.m=X}cancel(){this.m.cancel()}}e.$7h=ve;function ae(le){const X=new w.$xe,Z=le(X.token);return new ve(X,async pe=>{const $e=X.token.onCancellationRequested(()=>{$e.dispose(),X.dispose(),pe.reject(new C.$7)});try{for await(const Ne of Z){if(X.token.isCancellationRequested)return;pe.emitOne(Ne)}$e.dispose(),X.dispose()}catch(Ne){$e.dispose(),X.dispose(),pe.reject(Ne)}})}class we{constructor(X){this.a=new re,this.b=new _($e=>{if(Z){$e.reject(Z);return}return pe&&$e.emitMany(pe),this.d=Ne=>$e.reject(Ne),this.f=Ne=>$e.emitOne(Ne),this.a.p},X);let Z,pe;this.f=$e=>{pe||(pe=[]),pe.push($e)},this.d=$e=>{Z||(Z=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$9h=we}),define(Ce[41],Ie([1,0,18,11,28,53,29,20,21,13]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=R,e.$xk=r,e.$yk=L,e.$zk=O,e.$Ak=q,e.$Bk=G,e.$Ck=W,e.$Dk=ge;function R(){return Object.create(null)}e.$vk="**",e.$wk="/";const v="[/\\\\]",u="[^/\\\\]",E=/\//g;function d(te,me){switch(te){case 0:return"";case 1:return`${u}*?`;default:return`(?:${v}|${u}+${v}${me?`|${v}${u}+`:""})*?`}}function r(te,me){if(!te)return[];const se=[];let de=!1,be=!1,re="";for(const Pe of te){switch(Pe){case me:if(!de&&!be){se.push(re),re="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":be=!0;break;case"]":be=!1;break}re+=Pe}return re&&se.push(re),se}function o(te){if(!te)return"";let me="";const se=r(te,e.$wk);if(se.every(de=>de===e.$vk))me=".*";else{let de=!1;se.forEach((be,re)=>{if(be===e.$vk){if(de)return;me+=d(2,re===se.length-1)}else{let Pe=!1,Le="",Y=!1,B="";for(const _ of be){if(_!=="}"&&Pe){Le+=_;continue}if(Y&&(_!=="]"||!B)){let ve;_==="-"?ve=_:(_==="^"||_==="!")&&!B?ve="^":_===e.$wk?ve="":ve=(0,c.$if)(_),B+=ve;continue}switch(_){case"{":Pe=!0;continue;case"[":Y=!0;continue;case"}":{const ae=`(?:${r(Le,",").map(we=>o(we)).join("|")})`;me+=ae,Pe=!1,Le="";break}case"]":{me+="["+B+"]",Y=!1,B="";break}case"?":me+=u;continue;case"*":me+=d(1);continue;default:me+=(0,c.$if)(_)}}re<se.length-1&&(se[re+1]!==e.$vk||re+2<se.length)&&(me+=v)}de=be===e.$vk})}return me}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,i=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,m=new A.$Fc(1e4),f=function(){return!1},l=function(){return null};function $(te,me){if(!te)return l;let se;typeof te!="string"?se=te.pattern:se=te,se=se.trim();const de=`${se}_${!!me.trimForExclusions}`;let be=m.get(de);if(be)return I(be,te);let re;return a.test(se)?be=y(se.substr(4),se):(re=h.exec(D(se,me)))?be=S(re[1],se):(me.trimForExclusions?s:n).test(se)?be=k(se,me):(re=i.exec(D(se,me)))?be=g(re[1].substr(1),se,!0):(re=t.exec(D(se,me)))?be=g(re[1],se,!1):be=b(se),m.set(de,be),I(be,te)}function I(te,me){if(typeof me=="string")return te;const se=function(de,be){return(0,T.$Eg)(de,me.base,!p.$k)?te((0,c.$nf)(de.substr(me.base.length),N.sep),be):null};return se.allBasenames=te.allBasenames,se.allPaths=te.allPaths,se.basenames=te.basenames,se.patterns=te.patterns,se}function D(te,me){return me.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function y(te,me){return function(se,de){return typeof se=="string"&&se.endsWith(te)?me:null}}function S(te,me){const se=`/${te}`,de=`\\${te}`,be=function(Pe,Le){return typeof Pe!="string"?null:Le?Le===te?me:null:Pe===te||Pe.endsWith(se)||Pe.endsWith(de)?me:null},re=[te];return be.basenames=re,be.patterns=[me],be.allBasenames=re,be}function k(te,me){const se=ce(te.slice(1,-1).split(",").map(Le=>$(Le,me)).filter(Le=>Le!==l),te),de=se.length;if(!de)return l;if(de===1)return se[0];const be=function(Le,Y){for(let B=0,_=se.length;B<_;B++)if(se[B](Le,Y))return te;return null},re=se.find(Le=>!!Le.allBasenames);re&&(be.allBasenames=re.allBasenames);const Pe=se.reduce((Le,Y)=>Y.allPaths?Le.concat(Y.allPaths):Le,[]);return Pe.length&&(be.allPaths=Pe),be}function g(te,me,se){const de=N.sep===N.$ic.sep,be=de?te:te.replace(E,N.sep),re=N.sep+be,Pe=N.$ic.sep+te;let Le;return se?Le=function(Y,B){return typeof Y=="string"&&(Y===be||Y.endsWith(re)||!de&&(Y===te||Y.endsWith(Pe)))?me:null}:Le=function(Y,B){return typeof Y=="string"&&(Y===be||!de&&Y===te)?me:null},Le.allPaths=[(se?"*/":"./")+te],Le}function b(te){try{const me=new RegExp(`^${o(te)}$`);return function(se){return me.lastIndex=0,typeof se=="string"&&me.test(se)?te:null}}catch{return l}}function L(te,me,se){return!te||typeof me!="string"?!1:O(te)(me,void 0,se)}function O(te,me={}){if(!te)return f;if(typeof te=="string"||q(te)){const se=$(te,me);if(se===l)return f;const de=function(be,re){return!!se(be,re)};return se.allBasenames&&(de.allBasenames=se.allBasenames),se.allPaths&&(de.allPaths=se.allPaths),de}return F(te,me)}function q(te){const me=te;return me?typeof me.base=="string"&&typeof me.pattern=="string":!1}function G(te){return te.allBasenames||[]}function W(te){return te.allPaths||[]}function F(te,me){const se=ce(Object.getOwnPropertyNames(te).map(Le=>V(Le,te[Le],me)).filter(Le=>Le!==l)),de=se.length;if(!de)return l;if(!se.some(Le=>!!Le.requiresSiblings)){if(de===1)return se[0];const Le=function(_,ve){let ae;for(let we=0,le=se.length;we<le;we++){const X=se[we](_,ve);if(typeof X=="string")return X;(0,C.$rh)(X)&&(ae||(ae=[]),ae.push(X))}return ae?(async()=>{for(const we of ae){const le=await we;if(typeof le=="string")return le}return null})():null},Y=se.find(_=>!!_.allBasenames);Y&&(Le.allBasenames=Y.allBasenames);const B=se.reduce((_,ve)=>ve.allPaths?_.concat(ve.allPaths):_,[]);return B.length&&(Le.allPaths=B),Le}const be=function(Le,Y,B){let _,ve;for(let ae=0,we=se.length;ae<we;ae++){const le=se[ae];le.requiresSiblings&&B&&(Y||(Y=(0,N.$pc)(Le)),_||(_=Y.substr(0,Y.length-(0,N.$qc)(Le).length)));const X=le(Le,Y,_,B);if(typeof X=="string")return X;(0,C.$rh)(X)&&(ve||(ve=[]),ve.push(X))}return ve?(async()=>{for(const ae of ve){const we=await ae;if(typeof we=="string")return we}return null})():null},re=se.find(Le=>!!Le.allBasenames);re&&(be.allBasenames=re.allBasenames);const Pe=se.reduce((Le,Y)=>Y.allPaths?Le.concat(Y.allPaths):Le,[]);return Pe.length&&(be.allPaths=Pe),be}function V(te,me,se){if(me===!1)return l;const de=$(te,se);if(de===l)return l;if(typeof me=="boolean")return de;if(me){const be=me.when;if(typeof be=="string"){const re=(Pe,Le,Y,B)=>{if(!B||!de(Pe,Le))return null;const _=be.replace("$(basename)",()=>Y),ve=B(_);return(0,C.$rh)(ve)?ve.then(ae=>ae?te:null):ve?te:null};return re.requiresSiblings=!0,re}}return de}function ce(te,me){const se=te.filter(Le=>!!Le.basenames);if(se.length<2)return te;const de=se.reduce((Le,Y)=>{const B=Y.basenames;return B?Le.concat(B):Le},[]);let be;if(me){be=[];for(let Le=0,Y=de.length;Le<Y;Le++)be.push(me)}else be=se.reduce((Le,Y)=>{const B=Y.patterns;return B?Le.concat(B):Le},[]);const re=function(Le,Y){if(typeof Le!="string")return null;if(!Y){let _;for(_=Le.length;_>0;_--){const ve=Le.charCodeAt(_-1);if(ve===P.CharCode.Slash||ve===P.CharCode.Backslash)break}Y=Le.substr(_)}const B=de.indexOf(Y);return B!==-1?be[B]:null};re.basenames=de,re.patterns=be,re.allBasenames=de;const Pe=te.filter(Le=>!Le.basenames);return Pe.push(re),Pe}function ge(te,me){return(0,w.$wb)(te,me,(se,de)=>typeof se=="string"&&typeof de=="string"?se===de:typeof se!="string"&&typeof de!="string"?se.base===de.base&&se.pattern===de.pattern:!1)}}),define(Ce[60],Ie([1,0,14,99,24,13,2]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=c,e.$5k=R,e.$6k=v,e.$7k=u,e.$8k=E,e.$9k=d,e.$0k=r,e.$$k=o;var N;(function(a){a[a.Paragraph=0]="Paragraph",a[a.Break=1]="Break"})(N||(e.MarkdownStringTextNewlineStyle=N={}));class p{constructor(h="",n=!1){if(this.value=h,typeof this.value!="string")throw(0,w.$9)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(h,n=N.Paragraph){return this.value+=u(this.supportThemeIcons?(0,C.$Wk)(h):h).replace(/([ \t]+)/g,(s,i)=>"&nbsp;".repeat(i.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===N.Break?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,n){return this.value+=`
${E(n,h)}
`,this}appendLink(h,n,s){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(h),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(h,n){const s=new RegExp((0,T.$if)(n),"g");return h.replace(s,(i,t)=>h.charAt(t-1)!=="\\"?`\\${i}`:i)}}e.$3k=p;function c(a){return R(a)?!a.value:Array.isArray(a)?a.every(c):!0}function R(a){return a instanceof p?!0:a&&typeof a=="object"?typeof a.value=="string"&&(typeof a.isTrusted=="boolean"||typeof a.isTrusted=="object"||a.isTrusted===void 0)&&(typeof a.supportThemeIcons=="boolean"||a.supportThemeIcons===void 0):!1}function v(a,h){return a===h?!0:!a||!h?!1:a.value===h.value&&a.isTrusted===h.isTrusted&&a.supportThemeIcons===h.supportThemeIcons&&a.supportHtml===h.supportHtml&&(a.baseUri===h.baseUri||!!a.baseUri&&!!h.baseUri&&(0,P.$_g)(A.URI.from(a.baseUri),A.URI.from(h.baseUri)))}function u(a){return a.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(a,h){const n=a.match(/^`+/gm)?.reduce((i,t)=>i.length>t.length?i:t).length??0,s=n>=3?n+1:3;return[`${"`".repeat(s)}${h}`,a,`${"`".repeat(s)}`].join(`
`)}function d(a){return a.replace(/"/g,"&quot;")}function r(a){return a&&a.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(a){const h=[],n=a.split("|").map(i=>i.trim());a=n[0];const s=n[1];if(s){const i=/height=(\d+)/.exec(s),t=/width=(\d+)/.exec(s),m=i?i[1]:"",f=t?t[1]:"",l=isFinite(parseInt(f)),$=isFinite(parseInt(m));l&&h.push(`width="${f}"`),$&&h.push(`height="${m}"`)}return{href:a,dimensions:h}}}),define(Ce[103],Ie([1,0,18,53,20,21,24,13]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sw=p,e.$Tw=R,e.$Uw=u,e.$Vw=E,e.$Ww=a,e.$Xw=n,e.$Yw=s,e.$Zw=i,e.$1w=t,e.$2w=m;function p(l,$){const{os:I,tildify:D,relative:y}=$;if(y){const g=c(l,y,I);if(typeof g=="string")return g}let S=l.fsPath;if(I===T.OperatingSystem.Windows&&!T.$i?S=S.replace(/\//g,"\\"):I!==T.OperatingSystem.Windows&&T.$i&&(S=S.replace(/\\/g,"/")),I!==T.OperatingSystem.Windows&&D?.userHome){const g=D.userHome.fsPath;let b;l.scheme!==D.userHome.scheme&&l.path[0]===P.$ic.sep&&l.path[1]!==P.$ic.sep?b=D.userHome.with({path:l.path}).fsPath:b=S,S=u(b,g,I)}return(I===T.OperatingSystem.Windows?P.$hc:P.$ic).normalize(R(S,I===T.OperatingSystem.Windows))}function c(l,$,I){const D=I===T.OperatingSystem.Windows?P.$hc:P.$ic,y=I===T.OperatingSystem.Linux?A.$9g:A.$$g,S=$.getWorkspace(),k=(0,w.$Qb)(S.folders);if(!k)return;l.scheme!==k.uri.scheme&&l.path[0]===P.$ic.sep&&l.path[1]!==P.$ic.sep&&(l=k.uri.with({path:l.path}));const g=$.getWorkspaceFolder(l);if(!g)return;let b;if(y.isEqual(g.uri,l)?b="":b=y.relativePath(g.uri,l)??"",b&&(b=D.normalize(b)),S.folders.length>1&&!$.noPrefix){const L=g.name?g.name:y.basenameOrAuthority(g.uri);b=b?`${L} \u2022 ${b}`:L}return b}function R(l,$=T.$i){return(0,C.$Jg)(l,$)?l.charAt(0).toUpperCase()+l.slice(1):l}let v=Object.create(null);function u(l,$,I=T.OS){if(I===T.OperatingSystem.Windows||!l||!$)return l;let D=v.original===$?v.normalized:void 0;D||(D=$,T.$i&&(D=(0,C.$yg)(D)),D=`${(0,N.$of)(D,P.$ic.sep)}${P.$ic.sep}`,v={original:$,normalized:D});let y=l;return T.$i&&(y=(0,C.$yg)(y)),(I===T.OperatingSystem.Linux?y.startsWith(D):(0,N.$Hf)(y,D))?`~/${y.substr(D.length)}`:l}function E(l,$){return l.replace(/^~($|\/|\\)/,`${$}$1`)}const d="\u2026",r="\\\\",o="~";function a(l,$=P.sep){const I=new Array(l.length);let D=!1;for(let y=0;y<l.length;y++){const S=l[y];if(S===""){I[y]=`.${$}`;continue}if(!S){I[y]=S;continue}D=!0;let k="",g=S;g.indexOf(r)===0?(k=g.substr(0,g.indexOf(r)+r.length),g=g.substr(g.indexOf(r)+r.length)):g.indexOf($)===0?(k=g.substr(0,g.indexOf($)+$.length),g=g.substr(g.indexOf($)+$.length)):g.indexOf(o)===0&&(k=g.substr(0,g.indexOf(o)+o.length),g=g.substr(g.indexOf(o)+o.length));const b=g.split($);for(let L=1;D&&L<=b.length;L++)for(let O=b.length-L;D&&O>=0;O--){D=!1;let q=b.slice(O,O+L).join($);for(let G=0;!D&&G<l.length;G++)if(G!==y&&l[G]&&l[G].indexOf(q)>-1){const W=O+L===b.length,F=O>0&&l[G].indexOf($)>-1?$+q:q,V=l[G].endsWith(F);D=!W||V}if(!D){let G="";(b[0].endsWith(":")||k!=="")&&(O===1&&(O=0,L++,q=b[0]+$+q),O>0&&(G=b[0]+$),G=k+G),O>0&&(G=G+d+$),G=G+q,O+L<b.length&&(G=G+$+d),I[y]=G}}D&&(I[y]=S)}return I}var h;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function n(l,$=Object.create(null)){const I=[];let D=!1,y="";for(const S of l)if(S==="$"||D&&S==="{")y&&I.push({value:y,type:h.TEXT}),y="",D=!0;else if(S==="}"&&D){const k=$[y];if(typeof k=="string")k.length&&I.push({value:k,type:h.VARIABLE});else if(k){const g=I[I.length-1];(!g||g.type!==h.SEPARATOR)&&I.push({value:k.label,type:h.SEPARATOR})}y="",D=!1}else y+=S;return y&&!D&&I.push({value:y,type:h.TEXT}),I.filter((S,k)=>{if(S.type===h.SEPARATOR){const g=I[k-1],b=I[k+1];return[g,b].every(L=>L&&(L.type===h.VARIABLE||L.type===h.TEXT)&&L.value.length>0)}return!0}).map(S=>S.value).join("")}function s(l,$){return T.$j||$?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):l.replace(/&&|&/g,I=>I==="&"?"&&":"&")}function i(l,$){return T.$j||$?l.replace(/\(&&\w\)|&&/g,""):T.$i?l.replace(/&&|&/g,I=>I==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function m(l){if(l.endsWith("]")){const $=l.lastIndexOf(" [",l.length-2);if($!==-1){const I=f(l.substring(0,$)),D=l.substring($);return{name:I.name+D,parentPath:I.parentPath}}}return f(l)}function f(l){const $=l.indexOf("/")!==-1?P.$ic:P.$hc,I=$.basename(l),D=$.dirname(l);return I.length?{name:I,parentPath:D}:{name:D,parentPath:""}}}),define(Ce[160],Ie([1,0,23,38,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=void 0,e.$Ln=p,e.$Mn=R,e.$Nn=v;function T(u){return u.toJSON()}class A{constructor(E){this.a=E}transformIncoming(E){const d=this.a.transformIncoming(E);return d===E?E:T(P.URI.from(d))}transformOutgoing(E){const d=this.a.transformOutgoing(E);return d===E?E:T(P.URI.from(d))}transformOutgoingURI(E){const d=this.a.transformOutgoing(E);return d===E?E:P.URI.from(d)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$Jn=A,e.$Kn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function N(u,E,d){if(!u||d>200)return null;if(typeof u=="object"){if(u instanceof P.URI)return E.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const o=N(u[r],E,d+1);o!==null&&(u[r]=o)}}return null}function p(u,E){const d=N(u,E,0);return d===null?u:d}function c(u,E,d,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===C.MarshalledId.Uri)return d?P.URI.revive(E.transformIncoming(u)):E.transformIncoming(u);if(u instanceof w.$Oe)return null;for(const o in u)if(Object.hasOwnProperty.call(u,o)){const a=c(u[o],E,d,r+1);a!==null&&(u[o]=a)}}return null}function R(u,E){const d=c(u,E,!1,0);return d===null?u:d}function v(u,E){const d=c(u,E,!0,0);return d===null?u:d}}),define(Ce[161],Ie([1,0,11,4,5,49,15]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.StorageState=e.StorageHint=void 0,e.$0p=p;var N;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(N||(e.StorageHint=N={}));function p(u){const E=u;return E?.changed instanceof Map||E?.deleted instanceof Set}var c;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(c||(e.StorageState=c={}));class R extends P.$Wc{static{this.a=100}constructor(E,d=Object.create(null)){super(),this.r=E,this.s=d,this.b=this.B(new C.$pe),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new w.$Dh(R.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((d,r)=>this.w(r,d)),E.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(E,d){if(this.c===c.Closed)return;let r=!1;(0,A.$og)(d)?r=this.f.delete(E):this.f.get(E)!==d&&(this.f.set(E,d),r=!0),r&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==N.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,d){const r=this.f.get(E);return(0,A.$og)(r)?d:r}getBoolean(E,d){const r=this.get(E);return(0,A.$og)(r)?d:r==="true"}getNumber(E,d){const r=this.get(E);return(0,A.$og)(r)?d:parseInt(r,10)}getObject(E,d){const r=this.get(E);return(0,A.$og)(r)?d:(0,T.$bi)(r)}async set(E,d,r=!1){if(this.c===c.Closed)return;if((0,A.$og)(d))return this.delete(E,r);const o=(0,A.$hg)(d)||Array.isArray(d)?(0,T.$ai)(d):String(d);if(this.f.get(E)!==o)return this.f.set(E,o),this.j.set(E,o),this.h.delete(E),this.b.fire({key:E,external:r}),this.D()}async delete(E,d=!1){if(!(this.c===c.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(!(this.c===c.Closed||this.m))return this.D(E)}async D(E){return this.s.hint===N.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===N.STORAGE_IN_MEMORY}}e.$$p=R;class v{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((d,r)=>this.a.set(r,d)),E.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$_p=v}),define(Ce[162],Ie([1,0,13,21,23]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=void 0,e.$8t=R,e.$9t=v,w=qe(w),C=qe(C),P=qe(P);let T;function A(){return T||(T=new TextDecoder("UTF-16LE")),T}let N;function p(){return N||(N=new TextDecoder("UTF-16BE")),N}let c;function R(){return c||(c=C.$D()?A():p()),c}function v(d,r,o){const a=new Uint16Array(d.buffer,r,o);return o>0&&(a[0]===65279||a[0]===65534)?u(d,r,o):A().decode(a)}function u(d,r,o){const a=[];let h=0;for(let n=0;n<o;n++){const s=P.$Qe(d,r);r+=2,a[h++]=String.fromCharCode(s)}return a.join("")}class E{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return R().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||w.$Kf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let a=0;a<o;a++)this.b[this.d++]=r.charCodeAt(a)}}e.$0t=E}),define(Ce[163],Ie([1,0,23,162]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$t=void 0,e.$_t=A,w=qe(w);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(c,R,v,u){this.oldPosition=c,this.oldText=R,this.newPosition=v,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(c){return 4+2*c.length}static c(c,R,v){const u=R.length;w.$Te(c,u,v),v+=4;for(let E=0;E<u;E++)w.$Re(c,R.charCodeAt(E),v),v+=2;return v}static d(c,R){const v=w.$Se(c,R);return R+=4,(0,C.$9t)(c,R,v)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(c,R){return w.$Te(c,this.oldPosition,R),R+=4,w.$Te(c,this.newPosition,R),R+=4,R=T.c(c,this.oldText,R),R=T.c(c,this.newText,R),R}static read(c,R,v){const u=w.$Se(c,R);R+=4;const E=w.$Se(c,R);R+=4;const d=T.d(c,R);R+=T.a(d);const r=T.d(c,R);return R+=T.a(r),v.push(new T(u,d,E,r)),R}}e.$$t=T;function A(p,c){return p===null||p.length===0?c:new N(p,c).compress()}class N{constructor(c,R){this.a=c,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let c=0,R=0,v=this.n(c),u=this.l(R);for(;c<this.f||R<this.h;){if(v===null){this.k(u),u=this.l(++R);continue}if(u===null){this.m(v),v=this.n(++c);continue}if(u.oldEnd<=v.newPosition){this.k(u),u=this.l(++R);continue}if(v.newEnd<=u.oldPosition){this.m(v),v=this.n(++c);continue}if(u.oldPosition<v.newPosition){const[a,h]=N.r(u,v.newPosition-u.oldPosition);this.k(a),u=h;continue}if(v.newPosition<u.oldPosition){const[a,h]=N.q(v,u.oldPosition-v.newPosition);this.m(a),v=h;continue}let r,o;if(u.oldEnd===v.newEnd)r=v,o=u,v=this.n(++c),u=this.l(++R);else if(u.oldEnd<v.newEnd){const[a,h]=N.q(v,u.oldLength);r=a,o=u,v=h,u=this.l(++R)}else{const[a,h]=N.r(u,v.newLength);r=v,o=a,v=this.n(++c),u=h}this.d[this.e++]=new T(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const E=N.s(this.d);return N.t(E)}k(c){this.d[this.e++]=N.o(this.g,c),this.j+=c.newLength-c.oldLength}l(c){return c<this.h?this.c[c]:null}m(c){this.d[this.e++]=N.p(this.j,c),this.g+=c.newLength-c.oldLength}n(c){return c<this.f?this.a[c]:null}static o(c,R){return new T(R.oldPosition-c,R.oldText,R.newPosition,R.newText)}static p(c,R){return new T(R.oldPosition,R.oldText,R.newPosition+c,R.newText)}static q(c,R){const v=c.newText.substr(0,R),u=c.newText.substr(R);return[new T(c.oldPosition,c.oldText,c.newPosition,v),new T(c.oldEnd,"",c.newPosition+R,u)]}static r(c,R){const v=c.oldText.substr(0,R),u=c.oldText.substr(R);return[new T(c.oldPosition,v,c.newPosition,c.newText),new T(c.oldPosition+R,u,c.newEnd,"")]}static s(c){if(c.length===0)return c;const R=[];let v=0,u=c[0];for(let E=1;E<c.length;E++){const d=c[E];u.oldEnd===d.oldPosition?u=new T(u.oldPosition,u.oldText+d.oldText,u.newPosition,u.newText+d.newText):(R[v++]=u,u=d)}return R[v++]=u,R}static t(c){if(c.length===0)return c;const R=[];let v=0;for(let u=0;u<c.length;u++){const E=c[u];E.oldText!==E.newText&&(R[v++]=E)}return R}}}),define(Ce[164],Ie([1,0,41,20]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=P,e.$qu=T;function P(A,N,p,c,R,v){if(Array.isArray(A)){let u=0;for(const E of A){const d=P(E,N,p,c,R,v);if(d===10)return d;d>u&&(u=d)}return u}else{if(typeof A=="string")return c?A==="*"?5:A===p?10:0:0;if(A){const{language:u,pattern:E,scheme:d,hasAccessToAllModels:r,notebookType:o}=A;if(!c&&!r)return 0;o&&R&&(N=R);let a=0;if(d)if(d===N.scheme)a=10;else if(d==="*")a=5;else return 0;if(u)if(u===p)a=10;else if(u==="*")a=Math.max(a,5);else return 0;if(o)if(o===v)a=10;else if(o==="*"&&v!==void 0)a=Math.max(a,5);else return 0;if(E){let h;if(typeof E=="string"?h=E:h={...E,base:(0,C.$jc)(E.base)},h===N.fsPath||(0,w.$yk)(h,N.fsPath))a=10;else return 0}return a}else return 0}}function T(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(T):!!A.notebookType}}),define(Ce[165],Ie([1,0,4,13,33,52,100,148,163,5]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=void 0,C=qe(C);class R extends c.$Wc{constructor(u,E,d,r,o,a,h){super(),this.m=this.B(new w.$me),this.onDidChangeContent=this.m.event,this.f=E,this.j=!a,this.g=r,this.h=o,this.c=new A.$hD(u,d,h)}equals(u){return!(u instanceof R)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,E){return this.c.getOffsetAt(u,E)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,E){const d=u+E,r=this.getPositionAt(u),o=this.getPositionAt(d);return new P.$It(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,E=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const d=this.n(E);return this.c.getValueInRange(u,d)}getValueLengthInRange(u,E=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const d=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const a=this.n(E),h=this.getEOL();if(a.length!==h.length){const n=a.length-h.length,s=u.endLineNumber-u.startLineNumber;o=n*s}return r-d+o}getCharacterCountInRange(u,E=T.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=u.startLineNumber,o=u.endLineNumber;for(let a=r;a<=o;a++){const h=this.getLineContent(a),n=a===r?u.startColumn-1:0,s=a===o?u.endColumn-1:h.length;for(let i=n;i<s;i++)C.$Kf(h.charCodeAt(i))?(d=d+1,i=i+1):d=d+1}return d+=this.n(E).length*(o-r),d}return this.getValueLengthInRange(u,E)}getNearestChunk(u){return this.c.getNearestChunk(u)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,E){return this.c.getLineCharCode(u,E)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const E=C.$vf(this.getLineContent(u));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(u){const E=C.$xf(this.getLineContent(u));return E===-1?0:E+2}n(u){switch(u){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,E,d){let r=this.g,o=this.h,a=this.j,h=!0,n=[];for(let $=0;$<u.length;$++){const I=u[$];h&&I._isTracked&&(h=!1);const D=I.range;if(I.text){let b=!0;a||(b=!C.$Vf(I.text),a=b),!r&&b&&(r=C.$Uf(I.text)),!o&&b&&(o=C.$Xf(I.text))}let y="",S=0,k=0,g=0;if(I.text){let b;[S,k,g,b]=(0,N.$su)(I.text);const L=this.getEOL(),O=L===`\r
`?N.StringEOL.CRLF:N.StringEOL.LF;b===N.StringEOL.Unknown||b===O?y=I.text:y=I.text.replace(/\r\n|\r|\n/g,L)}n[$]={sortIndex:$,identifier:I.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:y,eolCount:S,firstLineLength:k,lastLineLength:g,forceMoveMarkers:!!I.forceMoveMarkers,isAutoWhitespaceEdit:I.isAutoWhitespaceEdit||!1}}n.sort(R.u);let s=!1;for(let $=0,I=n.length-1;$<I;$++){const D=n[$].range.getEndPosition(),y=n[$+1].range.getStartPosition();if(y.isBeforeOrEqual(D)){if(y.isBefore(D))throw new Error("Overlapping ranges are not allowed!");s=!0}}h&&(n=this.s(n));const i=d||E?R._getInverseEditRanges(n):[],t=[];if(E)for(let $=0;$<n.length;$++){const I=n[$],D=i[$];if(I.isAutoWhitespaceEdit&&I.range.isEmpty())for(let y=D.startLineNumber;y<=D.endLineNumber;y++){let S="";y===D.startLineNumber&&(S=this.getLineContent(I.range.startLineNumber),C.$vf(S)!==-1)||t.push({lineNumber:y,oldContent:S})}}let m=null;if(d){let $=0;m=[];for(let I=0;I<n.length;I++){const D=n[I],y=i[I],S=this.getValueInRange(D.range),k=D.rangeOffset+$;$+=D.text.length-S.length,m[I]={sortIndex:D.sortIndex,identifier:D.identifier,range:y,text:S,textChange:new p.$$t(D.rangeOffset,S,k,D.text)}}s||m.sort((I,D)=>I.sortIndex-D.sortIndex)}this.g=r,this.h=o,this.j=a;const f=this.t(n);let l=null;if(E&&t.length>0){t.sort(($,I)=>I.lineNumber-$.lineNumber),l=[];for(let $=0,I=t.length;$<I;$++){const D=t[$].lineNumber;if($>0&&t[$-1].lineNumber===D)continue;const y=t[$].oldContent,S=this.getLineContent(D);S.length===0||S===y||C.$vf(S)!==-1||l.push(D)}}return this.m.fire(),new T.$bw(m,f,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let E=!1;const d=u[0].range,r=u[u.length-1].range,o=new P.$It(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let a=d.startLineNumber,h=d.startColumn;const n=[];for(let f=0,l=u.length;f<l;f++){const $=u[f],I=$.range;E=E||$.forceMoveMarkers,n.push(this.getValueInRange(new P.$It(a,h,I.startLineNumber,I.startColumn))),$.text.length>0&&n.push($.text),a=I.endLineNumber,h=I.endColumn}const s=n.join(""),[i,t,m]=(0,N.$su)(s);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,T.EndOfLinePreference.TextDefined),text:s,eolCount:i,firstLineLength:t,lastLineLength:m,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(u){u.sort(R.w);const E=[];for(let d=0;d<u.length;d++){const r=u[d],o=r.range.startLineNumber,a=r.range.startColumn,h=r.range.endLineNumber,n=r.range.endColumn;if(o===h&&a===n&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new P.$It(o,a,h,n);E.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return E}findMatchesLineByLine(u,E,d,r){return this.c.findMatchesLineByLine(u,E,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,E){const d=u.startLineNumber,r=u.startColumn,[o,a,h]=(0,N.$su)(E);let n;if(E.length>0){const s=o+1;s===1?n=new P.$It(d,r,d,r+a):n=new P.$It(d,r,d+s-1,h+1)}else n=new P.$It(d,r,d,r);return n}static _getInverseEditRanges(u){const E=[];let d=0,r=0,o=null;for(let a=0,h=u.length;a<h;a++){const n=u[a];let s,i;o?o.range.endLineNumber===n.range.startLineNumber?(s=d,i=r+(n.range.startColumn-o.range.endColumn)):(s=d+(n.range.startLineNumber-o.range.endLineNumber),i=n.range.startColumn):(s=n.range.startLineNumber,i=n.range.startColumn);let t;if(n.text.length>0){const m=n.eolCount+1;m===1?t=new P.$It(s,i,s,i+n.firstLineLength):t=new P.$It(s,i,s+m-1,n.lastLineLength+1)}else t=new P.$It(s,i,s,i);d=t.endLineNumber,r=t.endColumn,E.push(t),o=n}return E}static u(u,E){const d=P.$It.compareRangesUsingEnds(u.range,E.range);return d===0?u.sortIndex-E.sortIndex:d}static w(u,E){const d=P.$It.compareRangesUsingEnds(u.range,E.range);return d===0?E.sortIndex-u.sortIndex:-d}}e.$iD=R}),define(Ce[166],Ie([1,0,28,13,52,100,165]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jD=void 0,C=qe(C);class N{constructor(R,v,u,E,d,r,o,a,h){this.a=R,this.b=v,this.c=u,this.d=E,this.e=d,this.f=r,this.g=o,this.h=a,this.j=h}k(R){const v=this.c+this.d+this.e,u=this.c+this.e;return v===0?R===P.DefaultEndOfLine.LF?`
`:`\r
`:u>v/2?`\r
`:`
`}create(R){const v=this.k(R),u=this.a;if(this.j&&(v===`\r
`&&(this.c>0||this.d>0)||v===`
`&&(this.c>0||this.e>0)))for(let d=0,r=u.length;d<r;d++){const o=u[d].buffer.replace(/\r\n|\r|\n/g,v),a=(0,T.$dD)(o);u[d]=new T.$gD(o,a)}const E=new A.$iD(u,this.b,v,this.f,this.g,this.h,this.j);return{textBuffer:E,disposable:E}}getFirstLineText(R){return this.a[0].buffer.substr(0,R).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(R){if(R.length===0)return;this.a.length===0&&C.$6f(R)&&(this.b=C.$5f,R=R.substr(1));const v=R.charCodeAt(R.length-1);v===w.CharCode.CarriageReturn||v>=55296&&v<=56319?(this.m(R.substr(0,R.length-1),!1),this.c=!0,this.d=v):(this.m(R,!1),this.c=!1,this.d=v)}m(R,v){!v&&R.length===0||(this.c?this.n(String.fromCharCode(this.d)+R):this.n(R))}n(R){const v=(0,T.$eD)(this.e,R);this.a.push(new T.$gD(R,v.lineStarts)),this.f+=v.cr,this.g+=v.lf,this.h+=v.crlf,v.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Uf(R)),this.k||(this.k=C.$Xf(R)))}finish(R=!0){return this.o(),new N(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,R)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const R=this.a[this.a.length-1];R.buffer+=String.fromCharCode(this.d);const v=(0,T.$dD)(R.buffer);R.lineStarts=v,this.d===w.CharCode.CarriageReturn&&this.f++}}}e.$jD=p}),define(Ce[104],Ie([1,0,23,21]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cb=p,e.$$cb=R,C=qe(C);var P;(function(v){v[v.Full=1]="Full",v[v.Delta=2]="Delta"})(P||(P={}));function T(v){for(let u=0,E=v.length;u<E;u+=4){const d=v[u+0],r=v[u+1],o=v[u+2],a=v[u+3];v[u+0]=a,v[u+1]=o,v[u+2]=r,v[u+3]=d}}function A(v){const u=new Uint8Array(v.buffer,v.byteOffset,v.length*4);return C.$D()||T(u),w.$Oe.wrap(u)}function N(v){const u=v.buffer;if(C.$D()||T(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const E=new Uint8Array(u.byteLength);return E.set(u),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function p(v){const u=new Uint32Array(c(v));let E=0;if(u[E++]=v.id,v.type==="full")u[E++]=P.Full,u[E++]=v.data.length,u.set(v.data,E),E+=v.data.length;else{u[E++]=P.Delta,u[E++]=v.deltas.length;for(const d of v.deltas)u[E++]=d.start,u[E++]=d.deleteCount,d.data?(u[E++]=d.data.length,u.set(d.data,E),E+=d.data.length):u[E++]=0}return A(u)}function c(v){let u=0;if(u+=2,v.type==="full")u+=1+v.data.length;else{u+=1,u+=3*v.deltas.length;for(const E of v.deltas)E.data&&(u+=E.data.length)}return u}function R(v){const u=N(v);let E=0;const d=u[E++];if(u[E++]===P.Full){const h=u[E++],n=u.subarray(E,E+h);return E+=h,{id:d,type:"full",data:n}}const o=u[E++],a=[];for(let h=0;h<o;h++){const n=u[E++],s=u[E++],i=u[E++];let t;i>0&&(t=u.subarray(E,E+i),E+=i),a[h]={start:n,deleteCount:s,data:t}}return{id:d,type:"delta",deltas:a}}}),define(Ce[167],Ie([8,9]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ce[168],Ie([8,9]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[169],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[170],Ie([8,9]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[171],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[172],Ie([8,9]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[173],Ie([8,9]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ce[174],Ie([8,9]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ce[175],Ie([8,9]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ce[176],Ie([8,9]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ce[177],Ie([8,9]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[178],Ie([8,9]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[179],Ie([8,9]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ce[180],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[181],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[182],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[183],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[184],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[185],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[186],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[187],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[188],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[189],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[190],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[191],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[192],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ce[193],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ce[194],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ce[195],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[196],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[197],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[198],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[199],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[200],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[201],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[202],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[203],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[204],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[205],Ie([8,9]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[206],Ie([1,0,28,14,170]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.TokenType=void 0;var T;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(T||(e.TokenType=T={}));function A(...R){switch(R.length){case 1:return(0,P.localize)(0,null,R[0]);case 2:return(0,P.localize)(1,null,R[0],R[1]);case 3:return(0,P.localize)(2,null,R[0],R[1],R[2]);default:return}}const N=(0,P.localize)(3,null),p=(0,P.localize)(4,null);class c{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return v.isTripleEq?"===":"==";case T.NotEq:return v.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return v.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return v.lexeme;case T.QuotedStr:return v.lexeme;case T.Error:return v.lexeme;case T.EOF:return"EOF";default:throw(0,C.$0)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case w.CharCode.OpenParen:this.k(T.LParen);break;case w.CharCode.CloseParen:this.k(T.RParen);break;case w.CharCode.ExclamationMark:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:u})}else this.k(T.Neg);break;case w.CharCode.SingleQuote:this.o();break;case w.CharCode.Slash:this.q();break;case w.CharCode.Equals:if(this.h(w.CharCode.Equals)){const u=this.h(w.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:u})}else this.h(w.CharCode.Tilde)?this.k(T.RegexOp):this.l(A("==","=~"));break;case w.CharCode.LessThan:this.k(this.h(w.CharCode.Equals)?T.LtEq:T.Lt);break;case w.CharCode.GreaterThan:this.k(this.h(w.CharCode.Equals)?T.GtEq:T.Gt);break;case w.CharCode.Ampersand:this.h(w.CharCode.Ampersand)?this.k(T.And):this.l(A("&&"));break;case w.CharCode.Pipe:this.h(w.CharCode.Pipe)?this.k(T.Or):this.l(A("||"));break;case w.CharCode.Space:case w.CharCode.CarriageReturn:case w.CharCode.Tab:case w.CharCode.LineFeed:case w.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?w.CharCode.Null:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const u=this.d,E=this.c.substring(this.d,this.e),d={type:T.Error,offset:this.d,lexeme:E};this.g.push({offset:u,lexeme:E,additionalInfo:v}),this.f.push(d)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const u=this.c.substring(this.d,this.e),E=c.b.get(u);E?this.k(E):this.f.push({type:T.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==w.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,u=!1,E=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(p);return}const r=this.c.charCodeAt(v);if(u)u=!1;else if(r===w.CharCode.Slash&&!E){v++;break}else r===w.CharCode.OpenSquareBracket?E=!0:r===w.CharCode.Backslash?u=!0:r===w.CharCode.CloseSquareBracket&&(E=!1);v++}for(;v<this.c.length&&c.a.has(this.c.charCodeAt(v));)v++;this.e=v;const d=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Aj=c});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[207],Ie([1,0,24,36,172,321]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=p,e.$Vp=c,e.$Wp=R,e.$Xp=v,e.$Yp=u,e.$Zp=E,e.$1p=d,C=ri(C),P=qe(P),T=qe(T);const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,N=/^-(\d{4})(\d{2})(\d{2})$/;function p(a){return a=a.trim(),a==="*"||A.test(a)}function c(a){if(!p(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=a.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}function R(a){if(!a)return null;const h=a.majorBase,n=a.majorMustEqual,s=a.minorBase;let i=a.minorMustEqual;const t=a.patchBase;let m=a.patchMustEqual;a.hasCaret&&(h===0||(i=!1),m=!1);let f=0;if(a.preRelease){const l=N.exec(a.preRelease);if(l){const[,$,I,D]=l;f=Date.UTC(Number($),Number(I)-1,Number(D))}}return{majorBase:h,majorMustEqual:n,minorBase:s,minorMustEqual:i,patchBase:t,patchMustEqual:m,isMinimum:a.hasGreaterEquals,notBefore:f}}function v(a,h,n){let s;typeof a=="string"?s=R(c(a)):s=a;let i;h instanceof Date?i=h.getTime():typeof h=="string"&&(i=new Date(h).getTime());let t;if(typeof n=="string"?t=R(c(n)):t=n,!s||!t)return!1;const m=s.majorBase,f=s.minorBase,l=s.patchBase;let $=t.majorBase,I=t.minorBase,D=t.patchBase;const y=t.notBefore;let S=t.majorMustEqual,k=t.minorMustEqual,g=t.patchMustEqual;return t.isMinimum?m>$?!0:m<$?!1:f>I?!0:f<I||i&&i<y?!1:l>=D:(m===1&&$===0&&(!S||!k||!g)&&($=1,I=0,D=0,S=!0,k=!1,g=!1),m<$?!1:m>$?!S:f<I?!1:f>I?!k:l<D?!1:l>D?!g:!(i&&i<y))}function u(a,h,n,s,i){const t=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return t.push([C.default.Error,P.localize(0,null)]),t;if(typeof s.name!="string")return t.push([C.default.Error,P.localize(1,null,"name")]),t;if(typeof s.version!="string")return t.push([C.default.Error,P.localize(2,null,"version")]),t;if(!s.engines)return t.push([C.default.Error,P.localize(3,null,"engines")]),t;if(typeof s.engines.vscode!="string")return t.push([C.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return t.push([C.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return t.push([C.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof s.main>"u"&&typeof s.browser>"u")return t.push([C.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&t.push([C.default.Warning,P.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return t.push([C.default.Error,P.localize(9,null,"main")]),t;{const l=(0,w.$gh)(n,s.main);(0,w.$ah)(l,n)||t.push([C.default.Warning,P.localize(10,null,l.path,n.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return t.push([C.default.Error,P.localize(11,null,"browser")]),t;{const l=(0,w.$gh)(n,s.browser);(0,w.$ah)(l,n)||t.push([C.default.Warning,P.localize(12,null,l.path,n.path)])}}if(!T.valid(s.version))return t.push([C.default.Error,P.localize(13,null)]),t;const m=[];if(!E(a,h,s,i,m))for(const l of m)t.push([C.default.Error,l]);return t}function E(a,h,n,s,i){return s||typeof n.main>"u"&&typeof n.browser>"u"?!0:r(a,h,n.engines.vscode,i)}function d(a,h,n){return a==="*"||r(h,n,a)}function r(a,h,n,s=[]){const i=R(c(n));if(!i)return s.push(P.localize(14,null,n)),!1;if(i.majorBase===0){if(!i.majorMustEqual||!i.minorMustEqual)return s.push(P.localize(15,null,n)),!1}else if(!i.majorMustEqual)return s.push(P.localize(16,null,n)),!1;return v(a,h,i)?!0:(s.push(P.localize(17,null,a,n)),!1)}function o(a){if(!Array.isArray(a))return!1;for(let h=0,n=a.length;h<n;h++)if(typeof a[h]!="string")return!1;return!0}}),define(Ce[74],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class w{constructor(P,T=[],A=!1){this.ctor=P,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$Ci=w}),define(Ce[61],Ie([1,0,74]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Ls=T,e.$Ms=A;const C=[];var P;(function(N){N[N.Eager=0]="Eager",N[N.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function T(N,p,c){p instanceof w.$Ci||(p=new w.$Ci(p,[],!!c)),C.push([N,p])}function A(){return C}}),define(Ce[208],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=e.$or=void 0;class w{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$or=w;class C{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const N=this.lookupOrInsertNode(T),p=this.lookupOrInsertNode(A);N.outgoing.set(p.key,p),p.incoming.set(N.key,N)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const N of this.a.values())N.outgoing.delete(A),N.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let N=this.a.get(A);return N||(N=new w(A,T),this.a.set(A,N)),N}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,N]of this.a)T.push(`${A}
	(-> incoming)[${[...N.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...N.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const N=new Set([T]),p=this.c(A,N);if(p)return p}}c(T,A){for(const[N,p]of T.outgoing){if(A.has(N))return[...A,N].join(" -> ");A.add(N);const c=this.c(p,A);if(c)return c;A.delete(N)}}}e.$pr=C}),define(Ce[3],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e._util=void 0,e.$Fi=P,e.$Gi=T;var w;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function N(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=N})(w||(e._util=w={})),e.$Ei=P("instantiationService");function C(A,N,p){N[w.DI_TARGET]===N?N[w.DI_DEPENDENCIES].push({id:A,index:p}):(N[w.DI_DEPENDENCIES]=[{id:A,index:p}],N[w.DI_TARGET]=N)}function P(A){if(w.serviceIds.has(A))return w.serviceIds.get(A);const N=function(p,c,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(N,p,R)};return N.toString=()=>A,w.serviceIds.set(A,N),N}function T(A){return A}}),define(Ce[42],Ie([1,0,15,2,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$_i=void 0,e.$aj=T,e.$bj=A,e.$cj=p,e.$dj=c,e.$ej=R,e.$fj=v,e.$gj=u,e.$hj=d,e.$ij=r,e.$jj=o,w=qe(w),e.$_i=(0,P.$Fi)("configurationService");function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof C.URI)}function A(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof C.URI)}var N;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(N||(e.ConfigurationTarget=N={}));function p(a){switch(a){case N.APPLICATION:return"APPLICATION";case N.USER:return"USER";case N.USER_LOCAL:return"USER_LOCAL";case N.USER_REMOTE:return"USER_REMOTE";case N.WORKSPACE:return"WORKSPACE";case N.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case N.DEFAULT:return"DEFAULT";case N.MEMORY:return"MEMORY"}}function c(a){return a.applicationValue!==void 0||a.userValue!==void 0||a.userLocalValue!==void 0||a.userRemoteValue!==void 0||a.workspaceValue!==void 0||a.workspaceFolderValue!==void 0}function R(a,h){const n=Object.create(null);for(const s in a)v(n,s,a[s],h);return n}function v(a,h,n,s){const i=h.split("."),t=i.pop();let m=a;for(let f=0;f<i.length;f++){const l=i[f];let $=m[l];switch(typeof $){case"undefined":$=m[l]=Object.create(null);break;case"object":if($===null){s(`Ignoring ${h} as ${i.slice(0,f+1).join(".")} is null`);return}break;default:s(`Ignoring ${h} as ${i.slice(0,f+1).join(".")} is ${JSON.stringify($)}`);return}m=$}if(typeof m=="object"&&m!==null)try{m[t]=n}catch{s(`Ignoring ${h} as ${i.join(".")} is ${JSON.stringify(m)}`)}else s(`Ignoring ${h} as ${i.join(".")} is ${JSON.stringify(m)}`)}function u(a,h){const n=h.split(".");E(a,n)}function E(a,h){const n=h.shift();if(h.length===0){delete a[n];return}if(Object.keys(a).indexOf(n)!==-1){const s=a[n];typeof s=="object"&&!Array.isArray(s)&&(E(s,h),Object.keys(s).length===0&&delete a[n])}}function d(a,h,n){function s(m,f){let l=m;for(const $ of f){if(typeof l!="object"||l===null)return;l=l[$]}return l}const i=h.split("."),t=s(a,i);return typeof t>"u"?n:t}function r(a,h,n){Object.keys(h).forEach(s=>{s!=="__proto__"&&(s in a?w.$hg(a[s])&&w.$hg(h[s])?r(a[s],h[s],n):n&&(a[s]=h[s]):a[s]=h[s])})}function o(a){return a.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,206,3,169,14]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Dj=e.$Cj=e.ContextKeyExprType=void 0,e.$Bj=R,e.$Ej=f,e.$Fj=l,e.$Yj=re;const c=new Map;c.set("false",!1),c.set("true",!0),c.set("isMac",C.$j),c.set("isLinux",C.$k),c.set("isWindows",C.$i),c.set("isWeb",C.$o),c.set("isMacNative",C.$j&&!C.$o),c.set("isEdge",C.$H),c.set("isFirefox",C.$F),c.set("isChrome",C.$E),c.set("isSafari",C.$G);function R(Y,B){if(c.get(Y)!==void 0)throw(0,p.$9)("contextkey.setConstant(k, v) invoked with already set constant `k`");c.set(Y,B)}const v=Object.prototype.hasOwnProperty;var u;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const E={regexParsingWithErrorRecovery:!0},d=(0,N.localize)(0,null),r=(0,N.localize)(1,null),o=(0,N.localize)(2,null),a=(0,N.localize)(3,null),h=(0,N.localize)(4,null),n=(0,N.localize)(5,null),s=(0,N.localize)(6,null),i=(0,N.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=E){this.k=B,this.d=new T.$Aj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ve=this.D(),ae=ve.type===T.TokenType.Str?n:void 0;throw this.h.push({message:h,offset:ve.offset,lexeme:T.$Aj.getLexeme(ve),additionalInfo:ae}),t.c}return _}catch(_){if(_!==t.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(T.TokenType.Or);){const _=this.o();B.push(_)}return B.length===1?B[0]:m.or(...B)}o(){const B=[this.s()];for(;this.y(T.TokenType.And);){const _=this.s();B.push(_)}return B.length===1?B[0]:m.and(...B)}s(){if(this.y(T.TokenType.Neg)){const B=this.D();switch(B.type){case T.TokenType.True:return this.z(),I.INSTANCE;case T.TokenType.False:return this.z(),D.INSTANCE;case T.TokenType.LParen:{this.z();const _=this.l();return this.A(T.TokenType.RParen,a),_?.negate()}case T.TokenType.Str:return this.z(),L.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case T.TokenType.True:return this.z(),m.true();case T.TokenType.False:return this.z(),m.false();case T.TokenType.LParen:{this.z();const _=this.l();return this.A(T.TokenType.RParen,a),_}case T.TokenType.Str:{const _=B.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ae.type!==T.TokenType.RegexStr)throw this.B("REGEX",ae);const we=ae.lexeme,le=we.lastIndexOf("/"),X=le===we.length-1?void 0:this.w(we.substring(le+1));let Z;try{Z=new RegExp(we.substring(1,le),X)}catch{throw this.B("REGEX",ae)}return V.create(_,Z)}switch(ae.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const we=[ae.lexeme];this.z();let le=this.D(),X=0;for(let ze=0;ze<ae.lexeme.length;ze++)ae.lexeme.charCodeAt(ze)===w.CharCode.OpenParen?X++:ae.lexeme.charCodeAt(ze)===w.CharCode.CloseParen&&X--;for(;!this.E()&&le.type!==T.TokenType.And&&le.type!==T.TokenType.Or;){switch(le.type){case T.TokenType.LParen:X++;break;case T.TokenType.RParen:X--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let ze=0;ze<le.lexeme.length;ze++)le.lexeme.charCodeAt(ze)===w.CharCode.OpenParen?X++:ae.lexeme.charCodeAt(ze)===w.CharCode.CloseParen&&X--}if(X<0)break;we.push(T.$Aj.getLexeme(le)),this.z(),le=this.D()}const Z=we.join(""),pe=Z.lastIndexOf("/"),$e=pe===Z.length-1?void 0:this.w(Z.substring(pe+1));let Ne;try{Ne=new RegExp(Z.substring(1,pe),$e)}catch{throw this.B("REGEX",ae)}return m.regex(_,Ne)}case T.TokenType.QuotedStr:{const we=ae.lexeme;this.z();let le=null;if(!(0,P.$df)(we)){const X=we.indexOf("/"),Z=we.lastIndexOf("/");if(X!==Z&&X>=0){const pe=we.slice(X+1,Z),$e=we[Z+1]==="i"?"i":"";try{le=new RegExp(pe,$e)}catch{throw this.B("REGEX",ae)}}}if(le===null)throw this.B("REGEX",ae);return V.create(_,le)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,o);const ae=this.u();return m.notIn(_,ae)}switch(this.D().type){case T.TokenType.Eq:{this.z();const ae=this.u();if(this.x().type===T.TokenType.QuotedStr)return m.equals(_,ae);switch(ae){case"true":return m.has(_);case"false":return m.not(_);default:return m.equals(_,ae)}}case T.TokenType.NotEq:{this.z();const ae=this.u();if(this.x().type===T.TokenType.QuotedStr)return m.notEquals(_,ae);switch(ae){case"true":return m.not(_);case"false":return m.has(_);default:return m.notEquals(_,ae)}}case T.TokenType.Lt:return this.z(),W.create(_,this.u());case T.TokenType.LtEq:return this.z(),F.create(_,this.u());case T.TokenType.Gt:return this.z(),q.create(_,this.u());case T.TokenType.GtEq:return this.z(),G.create(_,this.u());case T.TokenType.In:return this.z(),m.in(_,this.u());default:return m.has(_)}}case T.TokenType.EOF:throw this.h.push({message:s,offset:B.offset,lexeme:"",additionalInfo:i}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),B.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,ve){const ae=(0,N.localize)(8,null,B,T.$Aj.getLexeme(_)),we=_.offset,le=T.$Aj.getLexeme(_);return this.h.push({message:ae,offset:we,lexeme:le,additionalInfo:ve}),t.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$Cj=t;class m{static false(){return I.INSTANCE}static true(){return D.INSTANCE}static has(B){return y.create(B)}static equals(B,_){return S.create(B,_)}static notEquals(B,_){return b.create(B,_)}static regex(B,_){return V.create(B,_)}static in(B,_){return k.create(B,_)}static notIn(B,_){return g.create(B,_)}static not(B){return L.create(B)}static and(...B){return te.create(B,null,!0)}static or(...B){return me.create(B,null,!0)}static greater(B,_){return q.create(B,_)}static greaterEquals(B,_){return G.create(B,_)}static smaller(B,_){return W.create(B,_)}static smallerEquals(B,_){return F.create(B,_)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Dj=m;function f(Y){const B=new t({regexParsingWithErrorRecovery:!1});return Y.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,N.localize)(9,null,ve.additionalInfo):(0,N.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function l(Y,B){const _=Y?Y.substituteConstants():void 0,ve=B?B.substituteConstants():void 0;return!_&&!ve?!0:!_||!ve?!1:_.equals(ve)}function $(Y,B){return Y.cmp(B)}class I{static{this.INSTANCE=new I}constructor(){this.type=u.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return D.INSTANCE}}e.$Gj=I;class D{static{this.INSTANCE=new D}constructor(){this.type=u.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return I.INSTANCE}}e.$Hj=D;class y{static create(B,_=null){const ve=c.get(B);return typeof ve=="boolean"?ve?D.INSTANCE:I.INSTANCE:new y(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=u.Defined}cmp(B){return B.type!==this.type?this.type-B.type:de(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=c.get(this.key);return typeof B=="boolean"?B?D.INSTANCE:I.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ij=y;class S{static create(B,_,ve=null){if(typeof _=="boolean")return _?y.create(B,ve):L.create(B,ve);const ae=c.get(B);return typeof ae=="boolean"?_===(ae?"true":"false")?D.INSTANCE:I.INSTANCE:new S(B,_,ve)}constructor(B,_,ve){this.c=B,this.d=_,this.f=ve,this.type=u.Equals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?D.INSTANCE:I.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Jj=S;class k{static create(B,_){return new k(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=u.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:be(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),ve=B.getValue(this.d);return Array.isArray(_)?_.includes(ve):typeof ve=="string"&&typeof _=="object"&&_!==null?v.call(_,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Kj=k;class g{static create(B,_){return new g(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=u.NotIn,this.c=k.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Lj=g;class b{static create(B,_,ve=null){if(typeof _=="boolean")return _?L.create(B,ve):y.create(B,ve);const ae=c.get(B);return typeof ae=="boolean"?_===(ae?"true":"false")?I.INSTANCE:D.INSTANCE:new b(B,_,ve)}constructor(B,_,ve){this.c=B,this.d=_,this.f=ve,this.type=u.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=c.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?I.INSTANCE:D.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Mj=b;class L{static create(B,_=null){const ve=c.get(B);return typeof ve=="boolean"?ve?I.INSTANCE:D.INSTANCE:new L(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=u.Not}cmp(B){return B.type!==this.type?this.type-B.type:de(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=c.get(this.c);return typeof B=="boolean"?B?I.INSTANCE:D.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=y.create(this.c,this)),this.d}}e.$Nj=L;function O(Y,B){if(typeof Y=="string"){const _=parseFloat(Y);isNaN(_)||(Y=_)}return typeof Y=="string"||typeof Y=="number"?B(Y):I.INSTANCE}class q{static create(B,_,ve=null){return O(_,ae=>new q(B,ae,ve))}constructor(B,_,ve){this.c=B,this.d=_,this.f=ve,this.type=u.Greater}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Oj=q;class G{static create(B,_,ve=null){return O(_,ae=>new G(B,ae,ve))}constructor(B,_,ve){this.c=B,this.d=_,this.f=ve,this.type=u.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=G;class W{static create(B,_,ve=null){return O(_,ae=>new W(B,ae,ve))}constructor(B,_,ve){this.c=B,this.d=_,this.f=ve,this.type=u.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$Qj=W;class F{static create(B,_,ve=null){return O(_,ae=>new F(B,ae,ve))}constructor(B,_,ve){this.c=B,this.d=_,this.f=ve,this.type=u.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:be(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Rj=F;class V{static create(B,_){return new V(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=u.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",ve=B.f?B.f.source:"";return _<ve?-1:_>ve?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",ve=B.f?B.f.source:"";return this.d===B.d&&_===ve}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Sj=V;class ce{static create(B){return new ce(B)}constructor(B){this.c=B,this.type=u.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new ce(this.c.map(B))}negate(){return this.c}}e.$Tj=ce;function ge(Y){let B=null;for(let _=0,ve=Y.length;_<ve;_++){const ae=Y[_].substituteConstants();if(Y[_]!==ae&&B===null){B=[];for(let we=0;we<_;we++)B[we]=Y[we]}B!==null&&(B[_]=ae)}return B===null?Y:B}class te{static create(B,_,ve){return te.d(B,_,ve)}constructor(B,_){this.expr=B,this.c=_,this.type=u.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,ve=this.expr.length;_<ve;_++){const ae=$(this.expr[_],B.expr[_]);if(ae!==0)return ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=ge(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,ve){const ae=[];let we=!1;for(const le of B)if(le){if(le.type===u.True){we=!0;continue}if(le.type===u.False)return I.INSTANCE;if(le.type===u.And){ae.push(...le.expr);continue}ae.push(le)}if(ae.length===0&&we)return D.INSTANCE;if(ae.length!==0){if(ae.length===1)return ae[0];ae.sort($);for(let le=1;le<ae.length;le++)ae[le-1].equals(ae[le])&&(ae.splice(le,1),le--);if(ae.length===1)return ae[0];for(;ae.length>1;){const le=ae[ae.length-1];if(le.type!==u.Or)break;ae.pop();const X=ae.pop(),Z=ae.length===0,pe=me.create(le.expr.map($e=>te.create([$e,X],null,ve)),null,Z);pe&&(ae.push(pe),ae.sort($))}if(ae.length===1)return ae[0];if(ve){for(let le=0;le<ae.length;le++)for(let X=le+1;X<ae.length;X++)if(ae[le].negate().equals(ae[X]))return I.INSTANCE;if(ae.length===1)return ae[0]}return new te(ae,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new te(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=me.create(B,this,!0)}return this.c}}e.$Uj=te;class me{static create(B,_,ve){return me.d(B,_,ve)}constructor(B,_){this.expr=B,this.c=_,this.type=u.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,ve=this.expr.length;_<ve;_++){const ae=$(this.expr[_],B.expr[_]);if(ae!==0)return ae}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,ve=this.expr.length;_<ve;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=ge(this.expr);return B===this.expr?this:me.create(B,this.c,!1)}evaluate(B){for(let _=0,ve=this.expr.length;_<ve;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,ve){let ae=[],we=!1;if(B){for(let le=0,X=B.length;le<X;le++){const Z=B[le];if(Z){if(Z.type===u.False){we=!0;continue}if(Z.type===u.True)return D.INSTANCE;if(Z.type===u.Or){ae=ae.concat(Z.expr);continue}ae.push(Z)}}if(ae.length===0&&we)return I.INSTANCE;ae.sort($)}if(ae.length!==0){if(ae.length===1)return ae[0];for(let le=1;le<ae.length;le++)ae[le-1].equals(ae[le])&&(ae.splice(le,1),le--);if(ae.length===1)return ae[0];if(ve){for(let le=0;le<ae.length;le++)for(let X=le+1;X<ae.length;X++)if(ae[le].negate().equals(ae[X]))return D.INSTANCE;if(ae.length===1)return ae[0]}return new me(ae,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new me(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),ve=B.shift(),ae=[];for(const we of Le(_))for(const le of Le(ve))ae.push(te.create([we,le],null,!1));B.unshift(me.create(ae,null,!1))}this.c=me.create(B,this,!0)}return this.c}}e.$Vj=me;class se extends y{static{this.d=[]}static all(){return se.d.values()}constructor(B,_,ve){super(B,null),this.f=_,typeof ve=="object"?se.d.push({...ve,key:B}):ve!==!0&&se.d.push({key:B,description:ve,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return S.create(this.key,B)}notEqualsTo(B){return b.create(this.key,B)}}e.$Wj=se,e.$Xj=(0,A.$Fi)("contextKeyService");function de(Y,B){return Y<B?-1:Y>B?1:0}function be(Y,B,_,ve){return Y<_?-1:Y>_?1:B<ve?-1:B>ve?1:0}function re(Y,B){if(Y.type===u.False||B.type===u.True)return!0;if(Y.type===u.Or)return B.type===u.Or?Pe(Y.expr,B.expr):!1;if(B.type===u.Or){for(const _ of B.expr)if(re(Y,_))return!0;return!1}if(Y.type===u.And){if(B.type===u.And)return Pe(B.expr,Y.expr);for(const _ of Y.expr)if(re(_,B))return!0;return!1}return Y.equals(B)}function Pe(Y,B){let _=0,ve=0;for(;_<Y.length&&ve<B.length;){const ae=Y[_].cmp(B[ve]);if(ae<0)return!1;ae===0&&_++,ve++}return _===Y.length}function Le(Y){return Y.type===u.Or?Y.expr:[Y]}}),define(Ce[209],Ie([1,0,32,3]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=e.$mt=e.AccessibilitySupport=e.$lt=void 0,e.$nt=T,e.$lt=(0,C.$Fi)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$mt=new w.$Wj("accessibilityModeEnabled",!1);function T(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$ot="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[105],Ie([1,0,18,26,21,143,322,149,210,167,209]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=n,e.clampedInt=i,e.clampedFloat=m,e.stringSet=$,e.cursorStyleToString=O,e.filterValidationDecorations=Re,w=qe(w),C=qe(C),P=qe(P),c=qe(c);var v;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(v||(e.EditorAutoIndentStrategy=v={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=u;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class d{constructor(x,De,Xe,Ze){this.id=x,this.name=De,this.defaultValue=Xe,this.schema=Ze}applyUpdate(x,De){return o(x,De)}compute(x,De,Xe){return Xe}}class r{constructor(x,De){this.newValue=x,this.didChange=De}}e.ApplyUpdateResult=r;function o(Q,x){if(typeof Q!="object"||typeof x!="object"||!Q||!x)return new r(x,Q!==x);if(Array.isArray(Q)||Array.isArray(x)){const Xe=Array.isArray(Q)&&Array.isArray(x)&&w.$wb(Q,x);return new r(x,!Xe)}let De=!1;for(const Xe in x)if(x.hasOwnProperty(Xe)){const Ze=o(Q[Xe],x[Xe]);Ze.didChange&&(Q[Xe]=Ze.newValue,De=!0)}return new r(Q,De)}class a{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,De){return o(x,De)}validate(x){return this.defaultValue}}class h{constructor(x,De,Xe,Ze){this.id=x,this.name=De,this.defaultValue=Xe,this.schema=Ze}applyUpdate(x,De){return o(x,De)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,De,Xe){return Xe}}function n(Q,x){return typeof Q>"u"?x:Q==="false"?!1:!!Q}class s extends h{constructor(x,De,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=Xe),super(x,De,Xe,Ze)}validate(x){return n(x,this.defaultValue)}}function i(Q,x,De,Xe){if(typeof Q>"u")return x;let Ze=parseInt(Q,10);return isNaN(Ze)?x:(Ze=Math.max(De,Ze),Ze=Math.min(Xe,Ze),Ze|0)}class t extends h{static clampedInt(x,De,Xe,Ze){return i(x,De,Xe,Ze)}constructor(x,De,Xe,Ze,dt,pt=void 0){typeof pt<"u"&&(pt.type="integer",pt.default=Xe,pt.minimum=Ze,pt.maximum=dt),super(x,De,Xe,pt),this.minimum=Ze,this.maximum=dt}validate(x){return t.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function m(Q,x,De,Xe){if(typeof Q>"u")return x;const Ze=f.float(Q,x);return f.clamp(Ze,De,Xe)}class f extends h{static clamp(x,De,Xe){return x<De?De:x>Xe?Xe:x}static float(x,De){if(typeof x=="number")return x;if(typeof x>"u")return De;const Xe=parseFloat(x);return isNaN(Xe)?De:Xe}constructor(x,De,Xe,Ze,dt){typeof dt<"u"&&(dt.type="number",dt.default=Xe),super(x,De,Xe,dt),this.validationFn=Ze}validate(x){return this.validationFn(f.float(x,this.defaultValue))}}class l extends h{static string(x,De){return typeof x!="string"?De:x}constructor(x,De,Xe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=Xe),super(x,De,Xe,Ze)}validate(x){return l.string(x,this.defaultValue)}}function $(Q,x,De,Xe){return typeof Q!="string"?x:Xe&&Q in Xe?Xe[Q]:De.indexOf(Q)===-1?x:Q}class I extends h{constructor(x,De,Xe,Ze,dt=void 0){typeof dt<"u"&&(dt.type="string",dt.enum=Ze,dt.default=Xe),super(x,De,Xe,dt),this.c=Ze}validate(x){return $(x,this.defaultValue,this.c)}}class D extends d{constructor(x,De,Xe,Ze,dt,pt,Lt=void 0){typeof Lt<"u"&&(Lt.type="string",Lt.enum=dt,Lt.default=Ze),super(x,De,Xe,Lt),this.c=dt,this.d=pt}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function y(Q){switch(Q){case"none":return v.None;case"keep":return v.Keep;case"brackets":return v.Brackets;case"advanced":return v.Advanced;case"full":return v.Full}}class S extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",R.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[c.localize(0,null),c.localize(1,null),c.localize(2,null)],default:"auto",tags:["accessibility"],description:c.localize(3,null)})}validate(x){switch(x){case"auto":return R.AccessibilitySupport.Unknown;case"off":return R.AccessibilitySupport.Disabled;case"on":return R.AccessibilitySupport.Enabled}return this.defaultValue}compute(x,De,Xe){return Xe===R.AccessibilitySupport.Unknown?x.accessibilitySupport:Xe}}class k extends d{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:c.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:c.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertSpace:n(De.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:n(De.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(g||(e.TextEditorCursorBlinkingStyle=g={}));function b(Q){switch(Q){case"blink":return g.Blink;case"smooth":return g.Smooth;case"phase":return g.Phase;case"expand":return g.Expand;case"solid":return g.Solid}}var L;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(L||(e.TextEditorCursorStyle=L={}));function O(Q){switch(Q){case L.Line:return"line";case L.Block:return"block";case L.Underline:return"underline";case L.LineThin:return"line-thin";case L.BlockOutline:return"block-outline";case L.UnderlineThin:return"underline-thin"}}function q(Q){switch(Q){case"line":return L.Line;case"block":return L.Block;case"underline":return L.Underline;case"line-thin":return L.LineThin;case"block-outline":return L.BlockOutline;case"underline-thin":return L.UnderlineThin}}class G extends a{constructor(){super(je.editorClassName)}compute(x,De,Xe){const Ze=["monaco-editor"];return De.get(je.extraEditorClassName)&&Ze.push(De.get(je.extraEditorClassName)),x.extraEditorClassName&&Ze.push(x.extraEditorClassName),De.get(je.mouseStyle)==="default"?Ze.push("mouse-default"):De.get(je.mouseStyle)==="copy"&&Ze.push("mouse-copy"),De.get(je.showUnused)&&Ze.push("showUnused"),De.get(je.showDeprecated)&&Ze.push("showDeprecated"),Ze.join(" ")}}class W extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:c.localize(6,null)})}compute(x,De,Xe){return Xe&&x.emptySelectionClipboard}}class F extends d{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:c.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[c.localize(8,null),c.localize(9,null),c.localize(10,null)],description:c.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[c.localize(12,null),c.localize(13,null),c.localize(14,null)],description:c.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:c.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:c.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:c.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{cursorMoveOnType:n(De.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":$(De.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":$(De.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:n(De.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:n(De.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:n(De.loop,this.defaultValue.loop)}}}class V extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",V.OFF,{anyOf:[{type:"boolean",description:c.localize(19,null)},{type:"string",description:c.localize(20,null)}],description:c.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?V.OFF:x==="true"?V.ON:x:x?V.ON:V.OFF}}e.EditorFontLigatures=V;class ce extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",ce.OFF,{anyOf:[{type:"boolean",description:c.localize(22,null)},{type:"string",description:c.localize(23,null)}],description:c.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?ce.OFF:x==="true"?ce.TRANSLATE:x:x?ce.TRANSLATE:ce.OFF}compute(x,De,Xe){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=ce;class ge extends a{constructor(){super(je.fontInfo)}compute(x,De,Xe){return x.fontInfo}}class te extends h{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:c.localize(25,null)})}validate(x){const De=f.float(x,this.defaultValue);return De===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(De,6,100)}compute(x,De,Xe){return x.fontInfo.fontSize}}class me extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:me.d,maximum:me.e,errorMessage:c.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:me.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:c.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(t.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,me.d,me.e))}}class se extends d{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},De={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[c.localize(28,null),c.localize(29,null),c.localize(30,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:c.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:c.localize(32,null),...De},"editor.gotoLocation.multipleTypeDefinitions":{description:c.localize(33,null),...De},"editor.gotoLocation.multipleDeclarations":{description:c.localize(34,null),...De},"editor.gotoLocation.multipleImplementations":{description:c.localize(35,null),...De},"editor.gotoLocation.multipleReferences":{description:c.localize(36,null),...De},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Xe,description:c.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Xe,description:c.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Xe,description:c.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Xe,description:c.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Xe,description:c.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{multiple:$(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:De.multipleDefinitions??$(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:De.multipleTypeDefinitions??$(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:De.multipleDeclarations??$(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:De.multipleImplementations??$(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:De.multipleReferences??$(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class de extends d{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:c.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:c.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:c.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:c.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:c.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),delay:t.clampedInt(De.delay,this.defaultValue.delay,0,1e4),sticky:n(De.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(De.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:n(De.above,this.defaultValue.above)}}}var be;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(be||(e.RenderMinimap=be={}));class re extends a{constructor(){super(je.layoutInfo)}compute(x,De,Xe){return re.computeLayout(De,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const De=x.height/x.lineHeight,Xe=Math.floor(x.paddingTop/x.lineHeight);let Ze=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Ze=Math.max(Ze,De-1));const dt=(Xe+x.viewLineCount+Ze)/(x.pixelRatio*x.height),pt=Math.floor(x.viewLineCount/dt);return{typicalViewportLineCount:De,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:Ze,desiredRatio:dt,minimapLineCount:pt}}static c(x,De){const Xe=x.outerWidth,Ze=x.outerHeight,dt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:be.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(dt*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const pt=De.stableMinimapLayoutInput,Lt=pt&&x.outerHeight===pt.outerHeight&&x.lineHeight===pt.lineHeight&&x.typicalHalfwidthCharacterWidth===pt.typicalHalfwidthCharacterWidth&&x.pixelRatio===pt.pixelRatio&&x.scrollBeyondLastLine===pt.scrollBeyondLastLine&&x.paddingTop===pt.paddingTop&&x.paddingBottom===pt.paddingBottom&&x.minimap.enabled===pt.minimap.enabled&&x.minimap.side===pt.minimap.side&&x.minimap.size===pt.minimap.size&&x.minimap.showSlider===pt.minimap.showSlider&&x.minimap.renderCharacters===pt.minimap.renderCharacters&&x.minimap.maxColumn===pt.minimap.maxColumn&&x.minimap.scale===pt.minimap.scale&&x.verticalScrollbarWidth===pt.verticalScrollbarWidth&&x.isViewportWrapping===pt.isViewportWrapping,jt=x.lineHeight,xt=x.typicalHalfwidthCharacterWidth,li=x.scrollBeyondLastLine,xe=x.minimap.renderCharacters;let It=dt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const Gt=x.minimap.maxColumn,ht=x.minimap.size,bt=x.minimap.side,hi=x.verticalScrollbarWidth,_t=x.viewLineCount,Bt=x.remainingWidth,wt=x.isViewportWrapping,Wt=xe?2:3;let Ht=Math.floor(dt*Ze);const Jt=Ht/dt;let Je=!1,pi=!1,ei=Wt*It,si=It/dt,St=1;if(ht==="fill"||ht==="fit"){const{typicalViewportLineCount:Ut,extraLinesBeforeFirstLine:Qt,extraLinesBeyondLastLine:di,desiredRatio:Mt,minimapLineCount:vt}=re.computeContainedMinimapLineCount({viewLineCount:_t,scrollBeyondLastLine:li,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Ze,lineHeight:jt,pixelRatio:dt});if(_t/vt>1)Je=!0,pi=!0,It=1,ei=1,si=It/dt;else{let Ot=!1,kt=It+1;if(ht==="fit"){const Xt=Math.ceil((Qt+_t+di)*ei);wt&&Lt&&Bt<=De.stableFitRemainingWidth?(Ot=!0,kt=De.stableFitMaxMinimapScale):Ot=Xt>Ht}if(ht==="fill"||Ot){Je=!0;const Xt=It;ei=Math.min(jt*dt,Math.max(1,Math.floor(1/Mt))),wt&&Lt&&Bt<=De.stableFitRemainingWidth&&(kt=De.stableFitMaxMinimapScale),It=Math.min(kt,Math.max(1,Math.floor(ei/Wt))),It>Xt&&(St=Math.min(2,It/Xt)),si=It/dt/St,Ht=Math.ceil(Math.max(Ut,Qt+_t+di)*ei),wt?(De.stableMinimapLayoutInput=x,De.stableFitRemainingWidth=Bt,De.stableFitMaxMinimapScale=It):(De.stableMinimapLayoutInput=null,De.stableFitRemainingWidth=0)}}}const Kt=Math.floor(Gt*si),At=Math.min(Kt,Math.max(0,Math.floor((Bt-hi-2)*si/(xt+si)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(dt*At);const ti=Ft/dt;Ft=Math.floor(Ft*St);const ii=xe?be.Text:be.Blocks,oi=bt==="left"?0:Xe-At-hi;return{renderMinimap:ii,minimapLeft:oi,minimapWidth:At,minimapHeightIsEditorHeight:Je,minimapIsSampling:pi,minimapScale:It,minimapLineHeight:ei,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:Ht,minimapCanvasOuterWidth:ti,minimapCanvasOuterHeight:Jt}}static computeLayout(x,De){const Xe=De.outerWidth|0,Ze=De.outerHeight|0,dt=De.lineHeight|0,pt=De.lineNumbersDigitCount|0,Lt=De.typicalHalfwidthCharacterWidth,jt=De.maxDigitWidth,xt=De.pixelRatio,li=De.viewLineCount,xe=x.get(je.wordWrapOverride2),It=xe==="inherit"?x.get(je.wordWrapOverride1):xe,Gt=It==="inherit"?x.get(je.wordWrap):It,ht=x.get(je.wordWrapColumn),bt=De.isDominatedByLongLines,hi=x.get(je.glyphMargin),_t=x.get(je.lineNumbers).renderType!==ze.Off,Bt=x.get(je.lineNumbersMinChars),wt=x.get(je.scrollBeyondLastLine),Wt=x.get(je.padding),Ht=x.get(je.minimap),Jt=x.get(je.scrollbar),Je=Jt.verticalScrollbarSize,pi=Jt.verticalHasArrows,ei=Jt.arrowSize,si=Jt.horizontalScrollbarSize,St=x.get(je.folding),Kt=x.get(je.showFoldingControls)!=="never";let At=x.get(je.lineDecorationsWidth);St&&Kt&&(At+=16);let Ft=0;if(_t){const $i=Math.max(pt,Bt);Ft=Math.round($i*jt)}let ti=0;hi&&(ti=dt*De.glyphMarginDecorationLaneCount);let ii=0,oi=ii+ti,Ut=oi+Ft,Qt=Ut+At;const di=Xe-ti-Ft-At;let Mt=!1,vt=!1,Ct=-1;It==="inherit"&&bt?(Mt=!0,vt=!0):Gt==="on"||Gt==="bounded"?vt=!0:Gt==="wordWrapColumn"&&(Ct=ht);const Ot=re.c({outerWidth:Xe,outerHeight:Ze,lineHeight:dt,typicalHalfwidthCharacterWidth:Lt,pixelRatio:xt,scrollBeyondLastLine:wt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Ht,verticalScrollbarWidth:Je,viewLineCount:li,remainingWidth:di,isViewportWrapping:vt},De.memory||new E);Ot.renderMinimap!==be.None&&Ot.minimapLeft===0&&(ii+=Ot.minimapWidth,oi+=Ot.minimapWidth,Ut+=Ot.minimapWidth,Qt+=Ot.minimapWidth);const kt=di-Ot.minimapWidth,Xt=Math.max(1,Math.floor((kt-Je-2)/Lt)),qt=pi?ei:0;return vt&&(Ct=Math.max(1,Xt),Gt==="bounded"&&(Ct=Math.min(Ct,ht))),{width:Xe,height:Ze,glyphMarginLeft:ii,glyphMarginWidth:ti,glyphMarginDecorationLaneCount:De.glyphMarginDecorationLaneCount,lineNumbersLeft:oi,lineNumbersWidth:Ft,decorationsLeft:Ut,decorationsWidth:At,contentLeft:Qt,contentWidth:kt,minimap:Ot,viewportColumn:Xt,isWordWrapMinified:Mt,isViewportWrapping:vt,wrappingColumn:Ct,verticalScrollbarWidth:Je,horizontalScrollbarHeight:si,overviewRuler:{top:qt,width:Je,height:Ze-2*qt,right:0}}}}e.EditorLayoutInfoComputer=re;class Pe extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[c.localize(47,null),c.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:c.localize(49,null)}})}validate(x){return $(x,"simple",["simple","advanced"])}compute(x,De,Xe){return De.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?"advanced":Xe}}var Le;(function(Q){Q.Off="off",Q.OnCode="onCode",Q.On="on"})(Le||(e.ShowLightbulbIconMode=Le={}));class Y extends d{constructor(){const x={enabled:Le.On};super(je.lightbulb,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Le.Off,Le.OnCode,Le.On],default:x.enabled,enumDescriptions:[c.localize(50,null),c.localize(51,null),c.localize(52,null)],description:c.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:$(x.enabled,this.defaultValue.enabled,[Le.Off,Le.OnCode,Le.On])}}}class B extends d{constructor(){const x={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:c.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:20,description:c.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:c.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:c.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(De.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$(De.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:n(De.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends d{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:c.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[c.localize(59,null),c.localize(60,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(61,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),c.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:c.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:c.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:c.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return typeof De.enabled=="boolean"&&(De.enabled=De.enabled?"on":"off"),{enabled:$(De.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(De.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(De.fontFamily,this.defaultValue.fontFamily),padding:n(De.padding,this.defaultValue.padding)}}}class ve extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):t.clampedInt(x,this.defaultValue,0,1e3)}compute(x,De,Xe){return Xe<0?t.clampedInt(-Xe*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class ae extends f{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>f.clamp(x,0,150),{markdownDescription:c.localize(66,null)})}compute(x,De,Xe){return x.fontInfo.lineHeight}}class we extends d{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:c.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:c.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[c.localize(69,null),c.localize(70,null),c.localize(71,null)],default:x.size,description:c.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:c.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:c.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:c.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:c.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:c.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:x.showRegionSectionHeaders,description:c.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:x.showMarkSectionHeaders,description:c.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:x.sectionHeaderFontSize,description:c.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:x.sectionHeaderLetterSpacing,description:c.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),autohide:n(De.autohide,this.defaultValue.autohide),size:$(De.size,this.defaultValue.size,["proportional","fill","fit"]),side:$(De.side,this.defaultValue.side,["right","left"]),showSlider:$(De.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:n(De.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(De.scale,1,1,3),maxColumn:t.clampedInt(De.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:n(De.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:n(De.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:f.clamp(De.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:f.clamp(De.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function le(Q){return Q==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:c.localize(83,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{top:t.clampedInt(De.top,0,0,1e3),bottom:t.clampedInt(De.bottom,0,0,1e3)}}}class Z extends d{constructor(){const x={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:c.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:c.localize(85,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),cycle:n(De.cycle,this.defaultValue.cycle)}}}class pe extends a{constructor(){super(je.pixelRatio)}compute(x,De,Xe){return x.pixelRatio}}class $e extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x:this.defaultValue}}class Ne extends d{constructor(){const x={other:"on",comments:"off",strings:"off"},De=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[c.localize(86,null),c.localize(87,null),c.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:De,default:x.strings,description:c.localize(89,null)},comments:{anyOf:De,default:x.comments,description:c.localize(90,null)},other:{anyOf:De,default:x.other,description:c.localize(91,null)}},default:x,markdownDescription:c.localize(92,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const xt=x?"on":"off";return{comments:xt,strings:xt,other:xt}}if(!x||typeof x!="object")return this.defaultValue;const{other:De,comments:Xe,strings:Ze}=x,dt=["on","inline","off"];let pt,Lt,jt;return typeof De=="boolean"?pt=De?"on":"off":pt=$(De,this.defaultValue.other,dt),typeof Xe=="boolean"?Lt=Xe?"on":"off":Lt=$(Xe,this.defaultValue.comments,dt),typeof Ze=="boolean"?jt=Ze?"on":"off":jt=$(Ze,this.defaultValue.strings,dt),{other:pt,comments:Lt,strings:jt}}}var ze;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(ze||(e.RenderLineNumbersType=ze={}));class ke extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:ze.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[c.localize(93,null),c.localize(94,null),c.localize(95,null),c.localize(96,null)],default:"on",description:c.localize(97,null)})}validate(x){let De=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(De=ze.Custom,Xe=x):x==="interval"?De=ze.Interval:x==="relative"?De=ze.Relative:x==="on"?De=ze.On:De=ze.Off),{renderType:De,renderFn:Xe}}}function Re(Q){const x=Q.get(je.renderValidationDecorations);return x==="editable"?Q.get(je.readOnly):x!=="on"}class Te extends d{constructor(){const x=[],De={type:"number",description:c.localize(98,null)};super(je.rulers,"rulers",x,{type:"array",items:{anyOf:[De,{type:["object"],properties:{column:De,color:{type:"string",description:c.localize(99,null),format:"color-hex"}}}]},default:x,description:c.localize(100,null)})}validate(x){if(Array.isArray(x)){const De=[];for(const Xe of x)if(typeof Xe=="number")De.push({column:t.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const Ze=Xe;De.push({column:t.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return De.sort((Xe,Ze)=>Xe.column-Ze.column),De}return this.defaultValue}}class U extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function z(Q,x){if(typeof Q!="string")return x;switch(Q){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class K extends d{constructor(){const x={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(101,null),c.localize(102,null),c.localize(103,null)],default:"auto",description:c.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[c.localize(105,null),c.localize(106,null),c.localize(107,null)],default:"auto",description:c.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:c.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:c.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:c.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:c.localize(112,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x,Xe=t.clampedInt(De.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=t.clampedInt(De.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(De.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(De.vertical,this.defaultValue.vertical),horizontal:z(De.horizontal,this.defaultValue.horizontal),useShadows:n(De.useShadows,this.defaultValue.useShadows),verticalHasArrows:n(De.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:n(De.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:n(De.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:n(De.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:t.clampedInt(De.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:t.clampedInt(De.verticalSliderSize,Ze,0,1e3),scrollByPage:n(De.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:n(De.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class H extends d{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:c.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:c.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:c.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:c.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:c.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:c.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:c.localize(119,null)}})}applyUpdate(x,De){let Xe=!1;De.allowedCharacters&&x&&(C.$go(x.allowedCharacters,De.allowedCharacters)||(x={...x,allowedCharacters:De.allowedCharacters},Xe=!0)),De.allowedLocales&&x&&(C.$go(x.allowedLocales,De.allowedLocales)||(x={...x,allowedLocales:De.allowedLocales},Xe=!0));const Ze=super.applyUpdate(x,De);return Xe?new r(Ze.newValue,!0):Ze}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{nonBasicASCII:Ke(De.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:n(De.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:n(De.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ke(De.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ke(De.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,De){if(typeof x!="object"||!x)return De;const Xe={};for(const[Ze,dt]of Object.entries(x))dt===!0&&(Xe[Ze]=!0);return Xe}}class ne extends d{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:c.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(121,null),c.localize(122,null),c.localize(123,null)],description:c.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:c.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(126,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),mode:$(De.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:n(De.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:n(De.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(De.fontFamily,this.defaultValue.fontFamily)}}}class fe extends d{constructor(){const x={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",x,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:x.enabled,description:c.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[c.localize(128,null),c.localize(129,null),c.localize(130,null)],description:c.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:x.fontFamily,description:c.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:x.backgroundColoring,description:c.localize(133,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),showToolbar:$(De.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(De.fontFamily,this.defaultValue.fontFamily),keepOnBlur:n(De.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:n(De.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Ae extends d{constructor(){const x={enabled:N.$ft.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:N.$ft.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:c.localize(135,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:n(De.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ue extends d{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(136,null),c.localize(137,null),c.localize(138,null)],default:x.bracketPairs,description:c.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[c.localize(140,null),c.localize(141,null),c.localize(142,null)],default:x.bracketPairsHorizontal,description:c.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:c.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:c.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[c.localize(146,null),c.localize(147,null),c.localize(148,null)],default:x.highlightActiveIndentation,description:c.localize(149,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{bracketPairs:Ke(De.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ke(De.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:n(De.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:n(De.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ke(De.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ke(Q,x,De){const Xe=De.indexOf(Q);return Xe===-1?x:De[Xe]}class _e extends d{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[c.localize(150,null),c.localize(151,null)],default:x.insertMode,description:c.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:c.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:c.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:c.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[c.localize(156,null),c.localize(157,null),c.localize(158,null),c.localize(159,null)],default:x.selectionMode,markdownDescription:c.localize(160,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:c.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:c.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:c.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:c.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:c.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:c.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:c.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:c.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:c.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:c.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:c.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:c.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:c.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:c.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:c.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:c.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:c.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:c.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:c.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:c.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:c.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:c.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:c.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:c.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:c.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:c.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:c.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:c.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:c.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:c.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:c.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:c.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:c.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:c.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:c.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:c.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:c.localize(197,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{insertMode:$(De.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:n(De.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:n(De.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:n(De.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:n(De.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$(De.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:n(De.showIcons,this.defaultValue.showIcons),showStatusBar:n(De.showStatusBar,this.defaultValue.showStatusBar),preview:n(De.preview,this.defaultValue.preview),previewMode:$(De.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:n(De.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:n(De.showMethods,this.defaultValue.showMethods),showFunctions:n(De.showFunctions,this.defaultValue.showFunctions),showConstructors:n(De.showConstructors,this.defaultValue.showConstructors),showDeprecated:n(De.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:n(De.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:n(De.showFields,this.defaultValue.showFields),showVariables:n(De.showVariables,this.defaultValue.showVariables),showClasses:n(De.showClasses,this.defaultValue.showClasses),showStructs:n(De.showStructs,this.defaultValue.showStructs),showInterfaces:n(De.showInterfaces,this.defaultValue.showInterfaces),showModules:n(De.showModules,this.defaultValue.showModules),showProperties:n(De.showProperties,this.defaultValue.showProperties),showEvents:n(De.showEvents,this.defaultValue.showEvents),showOperators:n(De.showOperators,this.defaultValue.showOperators),showUnits:n(De.showUnits,this.defaultValue.showUnits),showValues:n(De.showValues,this.defaultValue.showValues),showConstants:n(De.showConstants,this.defaultValue.showConstants),showEnums:n(De.showEnums,this.defaultValue.showEnums),showEnumMembers:n(De.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:n(De.showKeywords,this.defaultValue.showKeywords),showWords:n(De.showWords,this.defaultValue.showWords),showColors:n(De.showColors,this.defaultValue.showColors),showFiles:n(De.showFiles,this.defaultValue.showFiles),showReferences:n(De.showReferences,this.defaultValue.showReferences),showFolders:n(De.showFolders,this.defaultValue.showFolders),showTypeParameters:n(De.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:n(De.showSnippets,this.defaultValue.showSnippets),showUsers:n(De.showUsers,this.defaultValue.showUsers),showIssues:n(De.showIssues,this.defaultValue.showIssues)}}}class it extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:c.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:c.localize(199,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:n(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:n(x.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const x=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",x,{anyOf:[{description:c.localize(200,null),type:"string"},{description:c.localize(201,null),type:"array",items:{type:"string"}}]})}validate(x){if(typeof x=="string"&&(x=[x]),Array.isArray(x)){const De=[];for(const Xe of x)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&De.push(Xe)}catch{}return De}return this.defaultValue}}var tt;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(tt||(e.WrappingIndent=tt={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",tt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[c.localize(202,null),c.localize(203,null),c.localize(204,null),c.localize(205,null)],description:c.localize(206,null),default:"same"}})}validate(x){switch(x){case"none":return tt.None;case"same":return tt.Same;case"indent":return tt.Indent;case"deepIndent":return tt.DeepIndent}return tt.Same}compute(x,De,Xe){return De.get(je.accessibilitySupport)===R.AccessibilitySupport.Enabled?tt.None:Xe}}class $t extends a{constructor(){super(je.wrappingInfo)}compute(x,De,Xe){const Ze=De.get(je.layoutInfo);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class lt extends d{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:c.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[c.localize(209,null),c.localize(210,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),showDropSelector:$(De.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:c.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:c.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[c.localize(213,null),c.localize(214,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const De=x;return{enabled:n(De.enabled,this.defaultValue.enabled),showPasteSelector:$(De.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",gt="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?gt:P.$k?mt:ct,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var je;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.autoClosingComments=7]="autoClosingComments",Q[Q.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=9]="autoClosingDelete",Q[Q.autoClosingOvertype=10]="autoClosingOvertype",Q[Q.autoClosingQuotes=11]="autoClosingQuotes",Q[Q.autoIndent=12]="autoIndent",Q[Q.automaticLayout=13]="automaticLayout",Q[Q.autoSurround=14]="autoSurround",Q[Q.bracketPairColorization=15]="bracketPairColorization",Q[Q.guides=16]="guides",Q[Q.codeLens=17]="codeLens",Q[Q.codeLensFontFamily=18]="codeLensFontFamily",Q[Q.codeLensFontSize=19]="codeLensFontSize",Q[Q.colorDecorators=20]="colorDecorators",Q[Q.colorDecoratorsLimit=21]="colorDecoratorsLimit",Q[Q.columnSelection=22]="columnSelection",Q[Q.comments=23]="comments",Q[Q.contextmenu=24]="contextmenu",Q[Q.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=26]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=28]="cursorStyle",Q[Q.cursorSurroundingLines=29]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=31]="cursorWidth",Q[Q.disableLayerHinting=32]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Q[Q.domReadOnly=34]="domReadOnly",Q[Q.dragAndDrop=35]="dragAndDrop",Q[Q.dropIntoEditor=36]="dropIntoEditor",Q[Q.emptySelectionClipboard=37]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=39]="extraEditorClassName",Q[Q.fastScrollSensitivity=40]="fastScrollSensitivity",Q[Q.find=41]="find",Q[Q.fixedOverflowWidgets=42]="fixedOverflowWidgets",Q[Q.folding=43]="folding",Q[Q.foldingStrategy=44]="foldingStrategy",Q[Q.foldingHighlight=45]="foldingHighlight",Q[Q.foldingImportsByDefault=46]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=47]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=49]="fontFamily",Q[Q.fontInfo=50]="fontInfo",Q[Q.fontLigatures=51]="fontLigatures",Q[Q.fontSize=52]="fontSize",Q[Q.fontWeight=53]="fontWeight",Q[Q.fontVariations=54]="fontVariations",Q[Q.formatOnPaste=55]="formatOnPaste",Q[Q.formatOnType=56]="formatOnType",Q[Q.glyphMargin=57]="glyphMargin",Q[Q.gotoLocation=58]="gotoLocation",Q[Q.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Q[Q.hover=60]="hover",Q[Q.inDiffEditor=61]="inDiffEditor",Q[Q.inlineSuggest=62]="inlineSuggest",Q[Q.inlineEdit=63]="inlineEdit",Q[Q.letterSpacing=64]="letterSpacing",Q[Q.lightbulb=65]="lightbulb",Q[Q.lineDecorationsWidth=66]="lineDecorationsWidth",Q[Q.lineHeight=67]="lineHeight",Q[Q.lineNumbers=68]="lineNumbers",Q[Q.lineNumbersMinChars=69]="lineNumbersMinChars",Q[Q.linkedEditing=70]="linkedEditing",Q[Q.links=71]="links",Q[Q.matchBrackets=72]="matchBrackets",Q[Q.minimap=73]="minimap",Q[Q.mouseStyle=74]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=76]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=78]="multiCursorModifier",Q[Q.multiCursorPaste=79]="multiCursorPaste",Q[Q.multiCursorLimit=80]="multiCursorLimit",Q[Q.occurrencesHighlight=81]="occurrencesHighlight",Q[Q.overviewRulerBorder=82]="overviewRulerBorder",Q[Q.overviewRulerLanes=83]="overviewRulerLanes",Q[Q.padding=84]="padding",Q[Q.pasteAs=85]="pasteAs",Q[Q.parameterHints=86]="parameterHints",Q[Q.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Q[Q.placeholder=88]="placeholder",Q[Q.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=90]="quickSuggestions",Q[Q.quickSuggestionsDelay=91]="quickSuggestionsDelay",Q[Q.readOnly=92]="readOnly",Q[Q.readOnlyMessage=93]="readOnlyMessage",Q[Q.renameOnType=94]="renameOnType",Q[Q.renderControlCharacters=95]="renderControlCharacters",Q[Q.renderFinalNewline=96]="renderFinalNewline",Q[Q.renderLineHighlight=97]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=99]="renderValidationDecorations",Q[Q.renderWhitespace=100]="renderWhitespace",Q[Q.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",Q[Q.roundedSelection=102]="roundedSelection",Q[Q.rulers=103]="rulers",Q[Q.scrollbar=104]="scrollbar",Q[Q.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=106]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=107]="scrollPredominantAxis",Q[Q.selectionClipboard=108]="selectionClipboard",Q[Q.selectionHighlight=109]="selectionHighlight",Q[Q.selectOnLineNumbers=110]="selectOnLineNumbers",Q[Q.showFoldingControls=111]="showFoldingControls",Q[Q.showUnused=112]="showUnused",Q[Q.snippetSuggestions=113]="snippetSuggestions",Q[Q.smartSelect=114]="smartSelect",Q[Q.smoothScrolling=115]="smoothScrolling",Q[Q.stickyScroll=116]="stickyScroll",Q[Q.stickyTabStops=117]="stickyTabStops",Q[Q.stopRenderingLineAfter=118]="stopRenderingLineAfter",Q[Q.suggest=119]="suggest",Q[Q.suggestFontSize=120]="suggestFontSize",Q[Q.suggestLineHeight=121]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",Q[Q.suggestSelection=123]="suggestSelection",Q[Q.tabCompletion=124]="tabCompletion",Q[Q.tabIndex=125]="tabIndex",Q[Q.unicodeHighlighting=126]="unicodeHighlighting",Q[Q.unusualLineTerminators=127]="unusualLineTerminators",Q[Q.useShadowDOM=128]="useShadowDOM",Q[Q.useTabStops=129]="useTabStops",Q[Q.wordBreak=130]="wordBreak",Q[Q.wordSegmenterLocales=131]="wordSegmenterLocales",Q[Q.wordSeparators=132]="wordSeparators",Q[Q.wordWrap=133]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=136]="wordWrapColumn",Q[Q.wordWrapOverride1=137]="wordWrapOverride1",Q[Q.wordWrapOverride2=138]="wordWrapOverride2",Q[Q.wrappingIndent=139]="wrappingIndent",Q[Q.wrappingStrategy=140]="wrappingStrategy",Q[Q.showDeprecated=141]="showDeprecated",Q[Q.inlayHints=142]="inlayHints",Q[Q.editorClassName=143]="editorClassName",Q[Q.pixelRatio=144]="pixelRatio",Q[Q.tabFocusMode=145]="tabFocusMode",Q[Q.layoutInfo=146]="layoutInfo",Q[Q.wrappingInfo=147]="wrappingInfo",Q[Q.defaultColorDecorators=148]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",Q[Q.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:c.localize(215,null)})),acceptSuggestionOnEnter:Be(new I(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",c.localize(216,null),""],markdownDescription:c.localize(217,null)})),accessibilitySupport:Be(new S),accessibilityPageSize:Be(new t(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(218,null),tags:["accessibility"]})),ariaLabel:Be(new l(je.ariaLabel,"ariaLabel",c.localize(219,null))),ariaRequired:Be(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Be(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:c.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Be(new I(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(221,null),c.localize(222,null),""],description:c.localize(223,null)})),autoClosingComments:Be(new I(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(224,null),c.localize(225,null),""],description:c.localize(226,null)})),autoClosingDelete:Be(new I(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",c.localize(227,null),""],description:c.localize(228,null)})),autoClosingOvertype:Be(new I(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",c.localize(229,null),""],description:c.localize(230,null)})),autoClosingQuotes:Be(new I(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",c.localize(231,null),c.localize(232,null),""],description:c.localize(233,null)})),autoIndent:Be(new D(je.autoIndent,"autoIndent",v.Full,"full",["none","keep","brackets","advanced","full"],y,{enumDescriptions:[c.localize(234,null),c.localize(235,null),c.localize(236,null),c.localize(237,null),c.localize(238,null)],description:c.localize(239,null)})),automaticLayout:Be(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:Be(new I(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[c.localize(240,null),c.localize(241,null),c.localize(242,null),""],description:c.localize(243,null)})),bracketPairColorization:Be(new Ae),bracketPairGuides:Be(new Ue),stickyTabStops:Be(new s(je.stickyTabStops,"stickyTabStops",!1,{description:c.localize(244,null)})),codeLens:Be(new s(je.codeLens,"codeLens",!0,{description:c.localize(245,null)})),codeLensFontFamily:Be(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:c.localize(246,null)})),codeLensFontSize:Be(new t(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:c.localize(247,null)})),colorDecorators:Be(new s(je.colorDecorators,"colorDecorators",!0,{description:c.localize(248,null)})),colorDecoratorActivatedOn:Be(new I(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[c.localize(249,null),c.localize(250,null),c.localize(251,null)],description:c.localize(252,null)})),colorDecoratorsLimit:Be(new t(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:c.localize(253,null)})),columnSelection:Be(new s(je.columnSelection,"columnSelection",!1,{description:c.localize(254,null)})),comments:Be(new k),contextmenu:Be(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:c.localize(255,null)})),cursorBlinking:Be(new D(je.cursorBlinking,"cursorBlinking",g.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:c.localize(256,null)})),cursorSmoothCaretAnimation:Be(new I(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[c.localize(257,null),c.localize(258,null),c.localize(259,null)],description:c.localize(260,null)})),cursorStyle:Be(new D(je.cursorStyle,"cursorStyle",L.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],q,{description:c.localize(261,null)})),cursorSurroundingLines:Be(new t(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(262,null)})),cursorSurroundingLinesStyle:Be(new I(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[c.localize(263,null),c.localize(264,null)],markdownDescription:c.localize(265,null)})),cursorWidth:Be(new t(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(266,null)})),disableLayerHinting:Be(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:Be(new s(je.dragAndDrop,"dragAndDrop",!0,{description:c.localize(267,null)})),emptySelectionClipboard:Be(new W),dropIntoEditor:Be(new lt),stickyScroll:Be(new B),experimentalWhitespaceRendering:Be(new I(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[c.localize(268,null),c.localize(269,null),c.localize(270,null)],description:c.localize(271,null)})),extraEditorClassName:Be(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Be(new f(je.fastScrollSensitivity,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:c.localize(272,null)})),find:Be(new F),fixedOverflowWidgets:Be(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Be(new s(je.folding,"folding",!0,{description:c.localize(273,null)})),foldingStrategy:Be(new I(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[c.localize(274,null),c.localize(275,null)],description:c.localize(276,null)})),foldingHighlight:Be(new s(je.foldingHighlight,"foldingHighlight",!0,{description:c.localize(277,null)})),foldingImportsByDefault:Be(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:c.localize(278,null)})),foldingMaximumRegions:Be(new t(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:c.localize(279,null)})),unfoldOnClickAfterEndOfLine:Be(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:c.localize(280,null)})),fontFamily:Be(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:c.localize(281,null)})),fontInfo:Be(new ge),fontLigatures2:Be(new V),fontSize:Be(new te),fontWeight:Be(new me),fontVariations:Be(new ce),formatOnPaste:Be(new s(je.formatOnPaste,"formatOnPaste",!1,{description:c.localize(282,null)})),formatOnType:Be(new s(je.formatOnType,"formatOnType",!1,{description:c.localize(283,null)})),glyphMargin:Be(new s(je.glyphMargin,"glyphMargin",!0,{description:c.localize(284,null)})),gotoLocation:Be(new se),hideCursorInOverviewRuler:Be(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:c.localize(285,null)})),hover:Be(new de),inDiffEditor:Be(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Be(new f(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>f.clamp(Q,-5,20),{description:c.localize(286,null)})),lightbulb:Be(new Y),lineDecorationsWidth:Be(new ve),lineHeight:Be(new ae),lineNumbers:Be(new ke),lineNumbersMinChars:Be(new t(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new s(je.linkedEditing,"linkedEditing",!1,{description:c.localize(287,null)})),links:Be(new s(je.links,"links",!0,{description:c.localize(288,null)})),matchBrackets:Be(new I(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:c.localize(289,null)})),minimap:Be(new we),mouseStyle:Be(new I(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new f(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:c.localize(290,null)})),mouseWheelZoom:Be(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$j?c.localize(291,null):c.localize(292,null)})),multiCursorMergeOverlapping:Be(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:c.localize(293,null)})),multiCursorModifier:Be(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[c.localize(294,null),c.localize(295,null)],markdownDescription:c.localize(296,null)})),multiCursorPaste:Be(new I(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[c.localize(297,null),c.localize(298,null)],markdownDescription:c.localize(299,null)})),multiCursorLimit:Be(new t(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:c.localize(300,null)})),occurrencesHighlight:Be(new I(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[c.localize(301,null),c.localize(302,null),c.localize(303,null)],markdownDescription:c.localize(304,null)})),overviewRulerBorder:Be(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:c.localize(305,null)})),overviewRulerLanes:Be(new t(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Be(new X),pasteAs:Be(new st),parameterHints:Be(new Z),peekWidgetDefaultFocus:Be(new I(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[c.localize(306,null),c.localize(307,null)],description:c.localize(308,null)})),placeholder:Be(new $e),definitionLinkOpensInPeek:Be(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:c.localize(309,null)})),quickSuggestions:Be(new Ne),quickSuggestionsDelay:Be(new t(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(310,null)})),readOnly:Be(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:Be(new U),renameOnType:Be(new s(je.renameOnType,"renameOnType",!1,{description:c.localize(311,null),markdownDeprecationMessage:c.localize(312,null)})),renderControlCharacters:Be(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:c.localize(313,null),restricted:!0})),renderFinalNewline:Be(new I(je.renderFinalNewline,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:c.localize(314,null)})),renderLineHighlight:Be(new I(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",c.localize(315,null)],description:c.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Be(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:c.localize(317,null)})),renderValidationDecorations:Be(new I(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new I(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",c.localize(318,null),c.localize(319,null),c.localize(320,null),""],description:c.localize(321,null)})),revealHorizontalRightPadding:Be(new t(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new s(je.roundedSelection,"roundedSelection",!0,{description:c.localize(322,null)})),rulers:Be(new Te),scrollbar:Be(new K),scrollBeyondLastColumn:Be(new t(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:c.localize(323,null)})),scrollBeyondLastLine:Be(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:c.localize(324,null)})),scrollPredominantAxis:Be(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:c.localize(325,null)})),selectionClipboard:Be(new s(je.selectionClipboard,"selectionClipboard",!0,{description:c.localize(326,null),included:P.$k})),selectionHighlight:Be(new s(je.selectionHighlight,"selectionHighlight",!0,{description:c.localize(327,null)})),selectOnLineNumbers:Be(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Be(new I(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[c.localize(328,null),c.localize(329,null),c.localize(330,null)],description:c.localize(331,null)})),showUnused:Be(new s(je.showUnused,"showUnused",!0,{description:c.localize(332,null)})),showDeprecated:Be(new s(je.showDeprecated,"showDeprecated",!0,{description:c.localize(333,null)})),inlayHints:Be(new _),snippetSuggestions:Be(new I(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[c.localize(334,null),c.localize(335,null),c.localize(336,null),c.localize(337,null)],description:c.localize(338,null)})),smartSelect:Be(new it),smoothScrolling:Be(new s(je.smoothScrolling,"smoothScrolling",!1,{description:c.localize(339,null)})),stopRenderingLineAfter:Be(new t(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Be(new _e),inlineSuggest:Be(new ne),inlineEdit:Be(new fe),inlineCompletionsAccessibilityVerbose:Be(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:c.localize(340,null)})),suggestFontSize:Be(new t(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:c.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new t(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:c.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:c.localize(343,null)})),suggestSelection:Be(new I(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[c.localize(344,null),c.localize(345,null),c.localize(346,null)],description:c.localize(347,null)})),tabCompletion:Be(new I(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[c.localize(348,null),c.localize(349,null),c.localize(350,null)],description:c.localize(351,null)})),tabIndex:Be(new t(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Be(new H),unusualLineTerminators:Be(new I(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[c.localize(352,null),c.localize(353,null),c.localize(354,null)],description:c.localize(355,null)})),useShadowDOM:Be(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:Be(new s(je.useTabStops,"useTabStops",!0,{description:c.localize(356,null)})),wordBreak:Be(new I(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[c.localize(357,null),c.localize(358,null)],description:c.localize(359,null)})),wordSegmenterLocales:Be(new nt),wordSeparators:Be(new l(je.wordSeparators,"wordSeparators",p.$gt,{description:c.localize(360,null)})),wordWrap:Be(new I(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[c.localize(361,null),c.localize(362,null),c.localize(363,null),c.localize(364,null)],description:c.localize(365,null)})),wordWrapBreakAfterCharacters:Be(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new t(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:c.localize(366,null)})),wordWrapOverride1:Be(new I(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new I(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new G),defaultColorDecorators:Be(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:c.localize(367,null)})),pixelRatio:Be(new pe),tabFocusMode:Be(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:c.localize(368,null)})),layoutInfo:Be(new re),wrappingInfo:Be(new $t),wrappingIndent:Be(new rt),wrappingStrategy:Be(new Pe)}}),define(Ce[106],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ni=e.$Mi=void 0,e.$Mi=(0,w.$Fi)("environmentService"),e.$Ni=(0,w.$Gi)(e.$Mi)}),define(Ce[30],Ie([1,0,59,20,13,15,2,173,3,21,16,47]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=u,e.$bl=o,e.$cl=h,e.$dl=n,e.$el=s,e.$fl=i,e.$gl=t,e.$hl=m,e.$il=f,e.$jl=l,e.$kl=$,e.$ml=y,e.$nl=S,e.$ol=k,e.$pl=g,e.$ql=b,e.$tl=W,e.$Fl=me,e.$Gl=se,e.$Il=be,e.$_k=(0,p.$Fi)("fileService");function u(re){return re.create===!0}var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var d;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(re){const Pe=re;return!!Pe&&typeof Pe.onDidChange=="function"}var a;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function h(re){return!!(re.capabilities&a.FileReadWrite)}function n(re){return!!(re.capabilities&a.FileFolderCopy)}function s(re){return!!(re.capabilities&a.FileClone)}function i(re){return!!(re.capabilities&a.FileOpenReadWriteClose)}function t(re){return!!(re.capabilities&a.FileReadStream)}function m(re){return h(re)?!!(re.capabilities&a.FileAtomicRead):!1}function f(re){return h(re)?!!(re.capabilities&a.FileAtomicWrite):!1}function l(re){return!!(re.capabilities&a.FileAtomicDelete)}function $(re){return!!(re.capabilities&a.Readonly)}var I;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(I||(e.FileSystemProviderErrorCode=I={}));class D extends Error{static create(Pe,Le){const Y=new D(Pe.toString(),Le);return k(Y,Le),Y}constructor(Pe,Le){super(Pe),this.code=Le}}e.$ll=D;function y(re,Pe){return D.create(re,Pe)}function S(re){return re||y((0,N.localize)(0,null),I.Unknown)}function k(re,Pe){return re.name=Pe?`${Pe} (FileSystemError)`:"FileSystemError",re}function g(re){if(!re)return I.Unknown;if(re instanceof D)return re.code;const Pe=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!Pe)return I.Unknown;switch(Pe[1]){case I.FileExists:return I.FileExists;case I.FileIsADirectory:return I.FileIsADirectory;case I.FileNotADirectory:return I.FileNotADirectory;case I.FileNotFound:return I.FileNotFound;case I.FileTooLarge:return I.FileTooLarge;case I.FileWriteLocked:return I.FileWriteLocked;case I.NoPermissions:return I.NoPermissions;case I.Unavailable:return I.Unavailable}return I.Unknown}function b(re){if(re instanceof F)return re.fileOperationResult;switch(g(re)){case I.FileNotFound:return ge.FILE_NOT_FOUND;case I.FileIsADirectory:return ge.FILE_IS_DIRECTORY;case I.FileNotADirectory:return ge.FILE_NOT_DIRECTORY;case I.FileWriteLocked:return ge.FILE_WRITE_LOCKED;case I.NoPermissions:return ge.FILE_PERMISSION_DENIED;case I.FileExists:return ge.FILE_MOVE_CONFLICT;case I.FileTooLarge:return ge.FILE_TOO_LARGE;default:return ge.FILE_OTHER_ERROR}}var L;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class O{constructor(Pe,Le,Y){this.resource=Pe,this.operation=Le,this.target=Y}isOperation(Pe){return this.operation===Pe}}e.$rl=O;var q;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(q||(e.FileChangeType=q={}));class G{static{this.a=null}constructor(Pe,Le){this.c=Le,this.b=void 0,this.d=new v.$X(()=>{const Y=w.$Li.forUris(()=>this.c);return Y.fill(this.rawAdded.map(B=>[B,!0])),Y}),this.f=new v.$X(()=>{const Y=w.$Li.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(B=>[B,!0])),Y}),this.g=new v.$X(()=>{const Y=w.$Li.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(B=>[B,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of Pe){switch(Y.type){case q.ADDED:this.rawAdded.push(Y.resource);break;case q.UPDATED:this.rawUpdated.push(Y.resource);break;case q.DELETED:this.rawDeleted.push(Y.resource);break}this.b!==G.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(Pe,...Le){return this.h(Pe,{includeChildren:!1},...Le)}affects(Pe,...Le){return this.h(Pe,{includeChildren:!0},...Le)}h(Pe,Le,...Y){if(!Pe)return!1;const B=Y.length>0;return!!((!B||Y.includes(q.ADDED))&&(this.d.value.get(Pe)||Le.includeChildren&&this.d.value.findSuperstr(Pe))||(!B||Y.includes(q.UPDATED))&&(this.f.value.get(Pe)||Le.includeChildren&&this.f.value.findSuperstr(Pe))||(!B||Y.includes(q.DELETED))&&(this.g.value.findSubstr(Pe)||Le.includeChildren&&this.g.value.findSuperstr(Pe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Pe){return this.b===Pe}hasCorrelation(){return typeof this.b=="number"}}e.$sl=G;function W(re,Pe,Le){return!re||!Pe||re===Pe||Pe.length>re.length?!1:(Pe.charAt(Pe.length-1)!==C.sep&&(Pe+=C.sep),Le?(0,P.$Hf)(re,Pe):re.indexOf(Pe)===0)}class F extends Error{constructor(Pe,Le,Y){super(Pe),this.fileOperationResult=Le,this.options=Y}}e.$ul=F;class V extends F{constructor(Pe,Le,Y,B){super(Pe,Le,B),this.fileOperationResult=Le,this.size=Y}}e.$vl=V;class ce extends F{constructor(Pe,Le,Y){super(Pe,ge.FILE_NOT_MODIFIED_SINCE,Y),this.stat=Le}}e.$wl=ce;var ge;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ge||(e.FileOperationResult=ge={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var te;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$El="";function me(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function se(re,Pe){if(!Pe.hasProvider(A.URI.from({scheme:re.scheme})))return new Promise(Le=>{const Y=Pe.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===re.scheme&&B.added&&(Y.dispose(),Le())})})}class de{static{this.KB=1024}static{this.MB=de.KB*de.KB}static{this.GB=de.MB*de.KB}static{this.TB=de.GB*de.KB}static formatSize(Pe){return(0,T.$jg)(Pe)||(Pe=0),Pe<de.KB?(0,N.localize)(1,null,Pe.toFixed(0)):Pe<de.MB?(0,N.localize)(2,null,(Pe/de.KB).toFixed(2)):Pe<de.GB?(0,N.localize)(3,null,(Pe/de.MB).toFixed(2)):Pe<de.TB?(0,N.localize)(4,null,(Pe/de.GB).toFixed(2)):(0,N.localize)(5,null,(Pe/de.TB).toFixed(2))}}e.$Hl=de;function be(re){const Pe=typeof re=="string"||re?.scheme===R.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===R.Schemas.file?1024*de.MB:Pe?10*de.MB:c.$o?50*de.MB:1024*de.MB}}),define(Ce[75],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=void 0;class w{constructor(...P){this.a=new Map;for(const[T,A]of P)this.set(T,A)}set(P,T){const A=this.a.get(P);return this.a.set(P,T),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Di=w}),define(Ce[211],Ie([1,0,11,14,5,74,208,3,75,212]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=void 0;const R=!1;class v extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new p.$Di,a=!1,h,n=R){this.i=o,this.j=a,this.k=h,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(N.$Ei,this),this._globalGraph=n?h?._globalGraph??new A.$pr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Rc)(this.h),this.h.clear();for(const o of this.g)(0,P.$Qc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,a){this.m();const h=this,n=new class extends u{dispose(){h.h.delete(n),super.dispose()}}(o,this.j,this,this.l);return this.h.add(n),a?.add(n),n}invokeFunction(o,...a){this.m();const h=d.traceInvocation(this.l,o);let n=!1;try{return o({get:i=>{if(n)throw(0,C.$0)("service accessor is only valid during the invocation of its target method");const t=this.s(i,h);if(!t)throw new Error(`[invokeFunction] unknown service '${i}'`);return t}},...a)}finally{n=!0,h.stop()}}createInstance(o,...a){this.m();let h,n;return o instanceof T.$Ci?(h=d.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(a),h)):(h=d.traceCreation(this.l,o),n=this.o(o,a,h)),h.stop(),n}o(o,a=[],h){const n=N._util.getServiceDependencies(o).sort((t,m)=>t.index-m.index),s=[];for(const t of n){const m=this.s(t.id,h);m||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),s.push(m)}const i=n.length>0?n[0].index:a.length;if(a.length!==i){console.trace(`[createInstance] First service dependency of ${o.name} at position ${i+1} conflicts with ${a.length} static arguments`);const t=i-a.length;t>0?a=a.concat(new Array(t)):a=a.slice(0,i)}return Reflect.construct(o,a.concat(s))}q(o,a){if(this.i.get(o)instanceof T.$Ci)this.i.set(o,a);else if(this.k)this.k.q(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const a=this.i.get(o);return!a&&this.k?this.k.r(o):a}s(o,a){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const h=this.r(o);return h instanceof T.$Ci?this.u(o,h,a.branch(o,!0)):(a.branch(o,!1),h)}u(o,a,h){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,a,h)}finally{this.t.delete(o)}}v(o,a,h){const n=new A.$pr(t=>t.id.toString());let s=0;const i=[{id:o,desc:a,_trace:h}];for(;i.length;){const t=i.pop();if(n.lookupOrInsertNode(t),s++>1e3)throw new v(n);for(const m of N._util.getServiceDependencies(t.desc.ctor)){const f=this.r(m.id);if(f||this.y(`[createInstance] ${o} depends on ${m.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(m.id)),f instanceof T.$Ci){const l={id:m.id,desc:f,_trace:t._trace.branch(m.id,!0)};n.insertEdge(t,l),i.push(l)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new v(n);break}for(const{data:m}of t){if(this.r(m.id)instanceof T.$Ci){const l=this.w(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this.q(m.id,l)}n.removeNode(m)}}return this.r(o)}w(o,a,h=[],n,s){if(this.i.get(o)instanceof T.$Ci)return this.x(o,a,h,n,s,this.g);if(this.k)return this.k.w(o,a,h,n,s);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}x(o,a,h=[],n,s,i){if(n){const t=new u(void 0,this.j,this,this.l);t.c=String(o);const m=new Map,f=new w.$Yh(()=>{const l=t.o(a,h,s);for(const[$,I]of m){const D=l[$];if(typeof D=="function")for(const y of I)y.disposable=D.apply(l,y.listener)}return m.clear(),i.add(l),l});return new Proxy(Object.create(null),{get(l,$){if(!f.isInitialized&&typeof $=="string"&&($.startsWith("onDid")||$.startsWith("onWill"))){let y=m.get($);return y||(y=new c.$7c,m.set($,y)),(k,g,b)=>{if(f.isInitialized)return f.value[$](k,g,b);{const L={listener:[k,g,b],disposable:void 0},O=y.push(L);return(0,P.$Uc)(()=>{O(),L.disposable?.dispose()})}}}if($ in l)return l[$];const I=f.value;let D=I[$];return typeof D!="function"||(D=D.bind(I),l[$]=D),D},set(l,$,I){return f.value[$]=I,!0},getPrototypeOf(l){return a.prototype}})}else{const t=this.o(a,h,s);return i.add(t),t}}y(o,a){if(a&&console.warn(o),this.j)throw new Error(o)}}e.$qr=u;var E;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(E||(E={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(E.None,null)}stop(){}branch(){return this}}}static traceInvocation(o,a){return o?new d(E.Invocation,a.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(o,a){return o?new d(E.Creation,a.name):d.c}static{this.f=0}constructor(o,a){this.type=o,this.name=a,this.g=Date.now(),this.h=[]}branch(o,a){const h=new d(E.Branch,o.toString());return this.h.push([o,a,h]),h}stop(){const o=Date.now()-this.g;d.f+=o;let a=!1;function h(s,i){const t=[],m=new Array(s+1).join("	");for(const[f,l,$]of i.h)if(l&&$){a=!0,t.push(`${m}CREATES -> ${f}`);const I=h(s+1,$);I&&t.push(I)}else t.push(`${m}uses -> ${f}`);return t.join(`
`)}const n=[`${this.type===E.Creation?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(o>2||a)&&d.all.add(n.join(`
`))}}e.$rr=d}),define(Ce[12],Ie([1,0,174,48,4,76,5,29,21,24,15,2,32,3]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=r,e.log=a,e.$nk=D,e.$ok=y,e.$pk=S,e.$qk=k,w=qe(w),e.$_j=(0,E.$Fi)("logService"),e.$ak=(0,E.$Fi)("loggerService");function d(){return new Date().toISOString()}function r(g){return(0,R.$jg)(g)}var o;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$ck=o.Info;function a(g,b,L){switch(b){case o.Trace:g.trace(L);break;case o.Debug:g.debug(L);break;case o.Info:g.info(L);break;case o.Warning:g.warn(L);break;case o.Error:g.error(L);break;case o.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function h(g,b=!1){let L="";for(let O=0;O<g.length;O++){let q=g[O];if(q instanceof Error&&(q=(0,C.$qj)(q,b)),typeof q=="object")try{q=JSON.stringify(q)}catch{}L+=(O>0?" ":"")+q}return L}class n extends A.$Wc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$me),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==o.Off&&this.b<=b}}e.$ek=n;class s extends n{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...L){this.f(o.Trace)&&this.g(o.Trace,h([b,...L],!0))}debug(b,...L){this.f(o.Debug)&&this.g(o.Debug,h([b,...L]))}info(b,...L){this.f(o.Info)&&this.g(o.Info,h([b,...L]))}warn(b,...L){this.f(o.Warning)&&this.g(o.Warning,h([b,...L]))}error(b,...L){if(this.f(o.Error))if(b instanceof Error){const O=Array.prototype.slice.call(arguments);O[0]=b.stack,this.g(o.Error,h(O))}else this.g(o.Error,h([b,...L]))}flush(){}}e.$fk=s;class i extends n{constructor(b=e.$ck){super(),this.setLevel(b),this.g=!p.$i}trace(b,...L){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}debug(b,...L){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}info(b,...L){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...L):console.log(`[main ${d()}]`,b,...L))}warn(b,...L){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...L):console.warn(`[main ${d()}]`,b,...L))}error(b,...L){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...L):console.error(`[main ${d()}]`,b,...L))}flush(){}}e.$gk=i;class t extends n{constructor(b=e.$ck,L=!0){super(),this.g=L,this.setLevel(b)}trace(b,...L){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...L):console.log(b,...L))}debug(b,...L){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...L):console.log(b,...L))}info(b,...L){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...L):console.log(b,...L))}warn(b,...L){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...L):console.log(b,...L))}error(b,...L){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...L):console.error(b,...L))}flush(){}}e.$hk=t;class m extends n{constructor(b,L=e.$ck){super(),this.g=b,this.setLevel(L)}trace(b,...L){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(b),...L])}debug(b,...L){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(b),...L])}info(b,...L){this.f(o.Info)&&this.g.log(o.Info,[this.h(b),...L])}warn(b,...L){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(b),...L])}error(b,...L){this.f(o.Error)&&this.g.log(o.Error,[this.h(b),...L])}h(b){return typeof b=="string"?b:(0,C.$qj)(b,this.f(o.Trace))}flush(){}}e.$ik=m;class f extends n{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const L of this.g)L.setLevel(b);super.setLevel(b)}trace(b,...L){for(const O of this.g)O.trace(b,...L)}debug(b,...L){for(const O of this.g)O.debug(b,...L)}info(b,...L){for(const O of this.g)O.info(b,...L)}warn(b,...L){for(const O of this.g)O.warn(b,...L)}error(b,...L){for(const O of this.g)O.error(b,...L)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$jk=f;class l extends A.$Wc{constructor(b,L,O){if(super(),this.h=b,this.j=L,this.b=new N.$Cc,this.c=this.B(new P.$me),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$me),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$me),this.onDidChangeVisibility=this.g.event,O)for(const q of O)this.b.set(q.resource,{logger:void 0,info:q})}m(b){return(0,R.$fg)(b)?[...this.b.values()].find(L=>L.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,L){const O=this.n(b),q=(0,R.$fg)(b)?b:L?.id??(0,T.$tj)(O.toString()).toString(16);let G=this.b.get(O)?.logger;const W=L?.logLevel==="always"?o.Trace:L?.logLevel;G||(G=this.s(O,W??this.getLogLevel(O)??this.h,{...L,id:q}));const F={logger:G,info:{resource:O,id:q,logLevel:W,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(F.info),this.b.set(O,F),G}n(b){return(0,R.$fg)(b)?(0,c.$gh)(this.j,`${b}.log`):b}setLogLevel(b,L){if(v.URI.isUri(b)){const O=b,q=L,G=this.b.get(O);G&&q!==G.info.logLevel&&(G.info.logLevel=q===this.h?void 0:q,G.logger?.setLevel(q),this.b.set(G.info.resource,G),this.f.fire([O,q]))}else{this.h=b;for(const[O,q]of this.b.entries())this.b.get(O)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,L){const O=this.m(b);O&&L!==!O.info.hidden&&(O.info.hidden=!L,this.b.set(O.info.resource,O),this.g.fire([O.info.resource,L]))}getLogLevel(b){let L;return b&&(L=this.b.get(b)?.info.logLevel),L??this.h}registerLogger(b){const L=this.b.get(b.resource);L?L.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const L=this.b.get(b);L&&(L.logger&&L.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=l;class ${constructor(){this.onDidChangeLogLevel=new P.$me().event}setLevel(b){}getLevel(){return o.Info}trace(b,...L){}debug(b,...L){}info(b,...L){}warn(b,...L){}error(b,...L){}critical(b,...L){}dispose(){}flush(){}}e.$lk=$;class I extends ${}e.$mk=I;function D(g){if(g.verbose)return o.Trace;if(typeof g.logLevel=="string"){const b=k(g.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ck}function y(g){switch(g){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function S(g){switch(g){case o.Trace:return{original:"Trace",value:w.localize(0,null)};case o.Debug:return{original:"Debug",value:w.localize(1,null)};case o.Info:return{original:"Info",value:w.localize(2,null)};case o.Warning:return{original:"Warning",value:w.localize(3,null)};case o.Error:return{original:"Error",value:w.localize(4,null)};case o.Off:return{original:"Off",value:w.localize(5,null)}}}function k(g){switch(g){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$rk=new u.$Wj("logLevel",y(o.Info))}),define(Ce[213],Ie([1,0,5,12]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kR=void 0;class P extends w.$Wc{constructor(A,N=[]){super(),this.a=new C.$jk([A,...N]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...N){this.a.trace(A,...N)}debug(A,...N){this.a.debug(A,...N)}info(A,...N){this.a.info(A,...N)}warn(A,...N){this.a.warn(A,...N)}error(A,...N){this.a.error(A,...N)}flush(){this.a.flush()}}e.$kR=P});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[107],Ie([1,0,36,175,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,w=ri(w);var T;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function c(d,r){return r-d}p.compare=c;const R=Object.create(null);R[p.Error]=(0,C.localize)(0,null),R[p.Warning]=(0,C.localize)(1,null),R[p.Info]=(0,C.localize)(2,null);function v(d){return R[d]||""}p.toString=v;function u(d){switch(d){case w.default.Error:return p.Error;case w.default.Warning:return p.Warning;case w.default.Info:return p.Info;case w.default.Ignore:return p.Hint}}p.fromSeverity=u;function E(d){switch(d){case p.Error:return w.default.Error;case p.Warning:return w.default.Warning;case p.Info:return w.default.Info;case p.Hint:return w.default.Ignore}}p.toSeverity=E}(A||(e.MarkerSeverity=A={}));var N;(function(p){const c="";function R(u){return v(u,!0)}p.makeKey=R;function v(u,E){const d=[c];return u.source?d.push(u.source.replace("\xA6","\\\xA6")):d.push(c),u.code?typeof u.code=="string"?d.push(u.code.replace("\xA6","\\\xA6")):d.push(u.code.value.replace("\xA6","\\\xA6")):d.push(c),u.severity!==void 0&&u.severity!==null?d.push(A.toString(u.severity)):d.push(c),u.message&&E?d.push(u.message.replace("\xA6","\\\xA6")):d.push(c),u.startLineNumber!==void 0&&u.startLineNumber!==null?d.push(u.startLineNumber.toString()):d.push(c),u.startColumn!==void 0&&u.startColumn!==null?d.push(u.startColumn.toString()):d.push(c),u.endLineNumber!==void 0&&u.endLineNumber!==null?d.push(u.endLineNumber.toString()):d.push(c),u.endColumn!==void 0&&u.endColumn!==null?d.push(u.endColumn.toString()):d.push(c),d.push(c),d.join("\xA6")}p.makeKeyOptionalMessage=v})(N||(e.IMarkerData=N={})),e.$zu=(0,P.$Fi)("markerService")});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[214],Ie([1,0,4,36,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pw=e.$ow=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$mw=e.Severity=void 0,e.$nw=N,C=ri(C),e.Severity=C.default,e.$mw=(0,P.$Fi)("notificationService");var T;(function(v){v[v.DEFAULT=0]="DEFAULT",v[v.SILENT=1]="SILENT",v[v.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(v){v[v.WORKSPACE=0]="WORKSPACE",v[v.PROFILE=1]="PROFILE",v[v.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function N(v){if(v){const u=v;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var p;(function(v){v[v.OFF=0]="OFF",v[v.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class c{constructor(){this.progress=new R,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$ow=c;class R{infinite(){}done(){}total(u){}worked(u){}}e.$pw=R}),define(Ce[108],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,w.$Fi)("productService"),e.$tk="vscode://schemas/vscode-product"});var Qe=this&&this.__decorate||function(oe,e,w,C){var P=arguments.length,T=P<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,w):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(oe,e,w,C);else for(var N=oe.length-1;N>=0;N--)(A=oe[N])&&(T=(P<3?A(T):P>3?A(e,w,T):A(e,w))||T);return P>3&&T&&Object.defineProperty(e,w,T),T},Ve=this&&this.__param||function(oe,e){return function(w,C){e(w,C,oe)}};define(Ce[77],Ie([1,0,11,22,5,3]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=e.$vw=e.$uw=e.$tw=e.$sw=e.$rw=e.ProgressLocation=e.$qw=void 0,e.$qw=(0,T.$Fi)("progressService");var A;(function(v){v[v.Explorer=1]="Explorer",v[v.Scm=3]="Scm",v[v.Extensions=5]="Extensions",v[v.Window=10]="Window",v[v.Notification=15]="Notification",v[v.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$rw=Object.freeze({total(){},worked(){},done(){}});class N{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$sw=N;class p{get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const E=this.d;this.d=()=>{E?.(),u()}}):Promise.resolve()}}e.$tw=p;let c=class extends P.$Wc{constructor(u,E){super(),this.a=new w.$3h,E.withProgress(u,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Uc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$uw=c,e.$uw=c=Qe([Ve(1,e.$qw)],c);class R extends P.$Wc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new P.$Vc)}start(u){this.stop();const E=++this.a,d=new C.$xe;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,P.$Uc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Uc)(()=>d.cancel())),this.b.add((0,P.$Uc)(()=>this.c?this.c.done():void 0)),{id:E,token:d.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$vw=R,e.$ww=(0,T.$Fi)("editorProgressService")}),define(Ce[31],Ie([1,0,62,15]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=void 0,w=qe(w),C=qe(C);class P{constructor(){this.a=new Map}add(A,N){w.ok(C.$fg(A)),w.ok(C.$hg(N)),w.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,N)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$po=new P}),define(Ce[78],Ie([1,0,4,31]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,C=qe(C),e.$qo={JSONContribution:"base.contributions.json"};function P(N){return N.length>0&&N.charAt(N.length-1)==="#"?N.substring(0,N.length-1):N}class T{constructor(){this.b=new w.$me,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,c){this.a[P(p)]=c,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;C.$po.add(e.$qo.JSONContribution,A)}),define(Ce[54],Ie([1,0,18,4,15,168,42,78,31]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.ConfigurationScope=e.$uo=e.EditPresentationTypes=void 0,e.$Fo=r,e.$Go=o,e.$Ho=a,e.$Io=n,e.$Jo=s,P=qe(P),T=qe(T);var c;(function(i){i.Multiline="multilineText",i.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$uo={Configuration:"base.contributions.configuration"};var R;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.MACHINE=2]="MACHINE",i[i.WINDOW=3]="WINDOW",i[i.RESOURCE=4]="RESOURCE",i[i.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",i[i.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$vo={properties:{},patternProperties:{}},e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo="vscode://schemas/settings/resourceLanguage",e.$Co="vscode://schemas/settings/configurationDefaults";const v=p.$po.as(N.$qo.JSONContribution);class u{constructor(){this.h=new Set,this.i=new C.$me,this.onDidSchemaChange=this.i.event,this.j=new C.$me,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$Bo,this.g),this.v()}registerConfiguration(t,m=!0){this.registerConfigurations([t],m)}registerConfigurations(t,m=!0){const f=new Set;this.n(t,m,f),v.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:f})}deregisterConfigurations(t){const m=new Set;this.o(t,m),v.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:m})}updateConfigurations({add:t,remove:m}){const f=new Set;this.o(m,f),this.n(t,!1,f),v.registerSchema(e.$Bo,this.g),this.i.fire(),this.j.fire({properties:f})}registerDefaultConfigurations(t){const m=new Set;this.k(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}k(t,m){const f=[];for(const{overrides:l,source:$}of t)for(const I in l)if(m.add(I),e.$Eo.test(I)){const D=this.a.get(I),y=D?.valuesSources??new Map;if($)for(const b of Object.keys(l[I]))y.set(b,$);const S={...D?.value||{},...l[I]};this.a.set(I,{source:$,value:S,valuesSources:y});const k=(0,A.$jj)(I),g={type:"object",default:S,description:T.localize(1,null,k),$ref:e.$Bo,defaultDefaultValue:S,source:P.$fg($)?void 0:$,defaultValueSource:$};f.push(...r(I)),this.d[I]=g,this.b.properties[I]=g}else{this.a.set(I,{value:l[I],source:$});const D=this.d[I];D&&(this.w(I,D),this.r(I,D))}this.m(f)}deregisterDefaultConfigurations(t){const m=new Set;this.l(t,m),this.i.fire(),this.j.fire({properties:m,defaultsOverrides:!0})}l(t,m){for(const{overrides:f,source:l}of t)for(const $ in f){const I=this.a.get($),D=P.$fg(l)?l:l?.id,y=P.$fg(I?.source)?I?.source:I?.source?.id;if(D===y)if(m.add($),this.a.delete($),e.$Eo.test($))delete this.d[$],delete this.b.properties[$];else{const S=this.d[$];S&&(this.w($,S),this.r($,S))}}this.u()}deltaConfiguration(t){let m=!1;const f=new Set;t.removedDefaults&&(this.l(t.removedDefaults,f),m=!0),t.addedDefaults&&(this.k(t.addedDefaults,f),m=!0),t.removedConfigurations&&this.o(t.removedConfigurations,f),t.addedConfigurations&&this.n(t.addedConfigurations,!1,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const m of t)this.h.add(m);this.u()}n(t,m,f){t.forEach(l=>{this.p(l,m,l.extensionInfo,l.restrictedProperties,void 0,f),this.c.push(l),this.q(l)})}o(t,m){const f=l=>{if(l.properties)for(const $ in l.properties){m.add($);const I=this.d[$];I?.policy?.name&&this.e.delete(I.policy.name),delete this.d[$],this.s($,l.properties[$])}l.allOf?.forEach($=>f($))};for(const l of t){f(l);const $=this.c.indexOf(l);$!==-1&&this.c.splice($,1)}}p(t,m=!0,f,l,$=R.WINDOW,I){$=P.$og(t.scope)?$:t.scope;const D=t.properties;if(D)for(const S in D){const k=D[S];if(m&&n(S,k)){delete D[S];continue}if(k.source=f,k.defaultDefaultValue=D[S].default,this.w(S,k),e.$Eo.test(S)?k.scope=void 0:(k.scope=P.$og(k.scope)?$:k.scope,k.restricted=P.$og(k.restricted)?!!l?.includes(S):k.restricted),D[S].hasOwnProperty("included")&&!D[S].included){this.f[S]=D[S],delete D[S];continue}else this.d[S]=D[S],D[S].policy?.name&&this.e.set(D[S].policy.name,S);!D[S].deprecationMessage&&D[S].markdownDeprecationMessage&&(D[S].deprecationMessage=D[S].markdownDeprecationMessage),I.add(S)}const y=t.allOf;if(y)for(const S of y)this.p(S,m,f,l,$,I)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const m=f=>{const l=f.properties;if(l)for(const I in l)this.r(I,l[I]);f.allOf?.forEach(m)};m(t)}r(t,m){switch(e.$vo.properties[t]=m,m.scope){case R.APPLICATION:e.$wo.properties[t]=m;break;case R.MACHINE:e.$xo.properties[t]=m;break;case R.MACHINE_OVERRIDABLE:e.$yo.properties[t]=m;break;case R.WINDOW:e.$zo.properties[t]=m;break;case R.RESOURCE:e.$Ao.properties[t]=m;break;case R.LANGUAGE_OVERRIDABLE:e.$Ao.properties[t]=m,this.g.properties[t]=m;break}}s(t,m){switch(delete e.$vo.properties[t],m.scope){case R.APPLICATION:delete e.$wo.properties[t];break;case R.MACHINE:delete e.$xo.properties[t];break;case R.MACHINE_OVERRIDABLE:delete e.$yo.properties[t];break;case R.WINDOW:delete e.$zo.properties[t];break;case R.RESOURCE:case R.LANGUAGE_OVERRIDABLE:delete e.$Ao.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const m=`[${t}]`,f={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$Bo};this.w(m,f),e.$vo.properties[m]=f,e.$wo.properties[m]=f,e.$xo.properties[m]=f,e.$yo.properties[m]=f,e.$zo.properties[m]=f,e.$Ao.properties[m]=f}}v(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$Bo};e.$vo.patternProperties[e.$Do]=t,e.$wo.patternProperties[e.$Do]=t,e.$xo.patternProperties[e.$Do]=t,e.$yo.patternProperties[e.$Do]=t,e.$zo.patternProperties[e.$Do]=t,e.$Ao.patternProperties[e.$Do]=t,this.i.fire()}w(t,m){const f=this.a.get(t);let l=f?.value,$=f?.source;P.$mg(l)&&(l=m.defaultDefaultValue,$=void 0),P.$mg(l)&&(l=a(m.type)),m.default=l,m.defaultValueSource=$}}const E="\\[([^\\]]+)\\]",d=new RegExp(E,"g");e.$Do=`^(${E})+$`,e.$Eo=new RegExp(e.$Do);function r(i){const t=[];if(e.$Eo.test(i)){let m=d.exec(i);for(;m?.length;){const f=m[1].trim();f&&t.push(f),m=d.exec(i)}}return(0,w.$Ob)(t)}function o(i){return i.reduce((t,m)=>`${t}[${m}]`,"")}function a(i){switch(Array.isArray(i)?i[0]:i){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const h=new u;p.$po.add(e.$uo.Configuration,h);function n(i,t){return i.trim()?e.$Eo.test(i)?T.localize(7,null,i):h.getConfigurationProperties()[i]!==void 0?T.localize(8,null,i):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,i,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}function s(){const i=[],t=h.getConfigurationProperties();for(const m of Object.keys(t))i.push([m,t[m].scope]);return i.push(["launch",R.RESOURCE]),i.push(["task",R.RESOURCE]),i}}),define(Ce[215],Ie([1,0,18,4,135,5,29,26,15,2,42,54,30,31]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$No=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Oo=s,w=qe(w),P=qe(P),N=qe(N),p=qe(p);function d(f){return Object.isFrozen(f)?f:N.$do(f)}class r{static createEmptyModel(l){return new r({},[],[],void 0,l)}constructor(l,$,I,D,y){this.b=l,this.c=$,this.d=I,this.raw=D,this.f=y,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map($=>{if($ instanceof r)return $;const I=new o("",this.f);return I.parseRaw($),I.configurationModel});this.g=l.reduce(($,I)=>I===$?I:$.merge(I),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,R.$hj)(this.contents,l):this.contents}inspect(l,$){const I=this;return{get value(){return d(I.rawConfiguration.getValue(l))},get override(){return $?d(I.rawConfiguration.getOverrideValue(l,$)):void 0},get merged(){return d($?I.rawConfiguration.override($).getValue(l):I.rawConfiguration.getValue(l))},get overrides(){const D=[];for(const{contents:y,identifiers:S,keys:k}of I.rawConfiguration.overrides){const g=new r(y,k,[],void 0,I.f).getValue(l);g!==void 0&&D.push({identifiers:S,value:g})}return D.length?d(D):void 0}}}getOverrideValue(l,$){const I=this.j($);return I?l?(0,R.$hj)(I,l):I:void 0}getKeysForOverrideIdentifier(l){const $=[];for(const I of this.overrides)I.identifiers.includes(l)&&$.push(...I.keys);return w.$Ob($)}getAllOverrideIdentifiers(){const l=[];for(const $ of this.overrides)l.push(...$.identifiers);return w.$Ob(l)}override(l){let $=this.a.get(l);return $||($=this.h(l),this.a.set(l,$)),$}merge(...l){const $=N.$co(this.contents),I=N.$co(this.overrides),D=[...this.keys],y=this.raw?.length?[...this.raw]:[this];for(const S of l)if(y.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i($,S.contents);for(const k of S.overrides){const[g]=I.filter(b=>w.$wb(b.identifiers,k.identifiers));g?(this.i(g.contents,k.contents),g.keys.push(...k.keys),g.keys=w.$Ob(g.keys)):I.push(N.$co(k))}for(const k of S.keys)D.indexOf(k)===-1&&D.push(k)}return new r($,D,I,y.every(S=>S instanceof r)?void 0:y,this.f)}h(l){const $=this.j(l);if(!$||typeof $!="object"||!Object.keys($).length)return this;const I={};for(const D of w.$Ob([...Object.keys(this.contents),...Object.keys($)])){let y=this.contents[D];const S=$[D];S&&(typeof y=="object"&&typeof S=="object"?(y=N.$co(y),this.i(y,S)):y=S),I[D]=y}return new r(I,this.keys,this.overrides,void 0,this.f)}i(l,$){for(const I of Object.keys($)){if(I in l&&p.$hg(l[I])&&p.$hg($[I])){this.i(l[I],$[I]);continue}l[I]=N.$co($[I])}}j(l){let $=null,I=null;const D=y=>{y&&(I?this.i(I,y):I=N.$co(y))};for(const y of this.overrides)y.identifiers.length===1&&y.identifiers[0]===l?$=y.contents:y.identifiers.includes(l)&&D(y.contents);return D($),I}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,$){this.k(l,$,!0)}setValue(l,$){this.k(l,$,!1)}removeValue(l){const $=this.keys.indexOf(l);$!==-1&&(this.keys.splice($,1),(0,R.$gj)(this.contents,l),v.$Eo.test(l)&&this.overrides.splice(this.overrides.findIndex(I=>w.$wb(I.identifiers,(0,v.$Fo)(l))),1))}k(l,$,I){(0,R.$fj)(this.contents,l,$,D=>this.f.error(D)),I=I||this.keys.indexOf(l)===-1,I&&this.keys.push(l),v.$Eo.test(l)&&this.overrides.push({identifiers:(0,v.$Fo)(l),keys:Object.keys(this.contents[l]),contents:(0,R.$ej)(this.contents[l],D=>this.f.error(D))})}}e.$Ko=r;class o{constructor(l,$){this.f=l,this.g=$,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,$){if(!p.$og(l)){const I=this.h(l);this.parseRaw(I,$)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,$){this.a=l;const{contents:I,keys:D,overrides:y,restricted:S,hasExcludedProperties:k}=this.i(l,$);this.b=new r(I,D,y,k?[l]:void 0,this.g),this.c=S||[]}h(l){let $={},I=null,D=[];const y=[],S=[];function k(b){Array.isArray(D)?D.push(b):I!==null&&(D[I]=b)}const g={onObjectBegin:()=>{const b={};k(b),y.push(D),D=b,I=null},onObjectProperty:b=>{I=b},onObjectEnd:()=>{D=y.pop()},onArrayBegin:()=>{const b=[];k(b),y.push(D),D=b,I=null},onArrayEnd:()=>{D=y.pop()},onLiteralValue:k,onError:(b,L,O)=>{S.push({error:b,offset:L,length:O})}};if(l)try{P.$3n(l,g),$=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return $}i(l,$){const I=E.$po.as(v.$uo.Configuration).getConfigurationProperties(),D=this.j(l,I,!0,$);l=D.raw;const y=(0,R.$ej)(l,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(l),k=this.l(l,g=>this.g.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:y,keys:S,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(l,$,I,D){let y=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:y};const S={},k=[];for(const g in l)if(v.$Eo.test(g)&&I){const b=this.j(l[g],$,!1,D);S[g]=b.raw,y=y||b.hasExcludedProperties,k.push(...b.restricted)}else{const b=$[g],L=b?typeof b.scope<"u"?b.scope:v.ConfigurationScope.WINDOW:void 0;b?.restricted&&k.push(g),!D.exclude?.includes(g)&&(D.include?.includes(g)||(L===void 0||D.scopes===void 0||D.scopes.includes(L))&&!(D.skipRestricted&&b?.restricted))?S[g]=l[g]:y=!0}return{raw:S,restricted:k,hasExcludedProperties:y}}l(l,$){const I=[];for(const D of Object.keys(l))if(v.$Eo.test(D)){const y={};for(const S in l[D])y[S]=l[D][S];I.push({identifiers:(0,v.$Fo)(D),keys:Object.keys(y),contents:(0,R.$ej)(y,$)})}return I}}e.$Lo=o;class a extends T.$Wc{constructor(l,$,I,D,y){super(),this.c=l,this.f=$,this.g=D,this.h=y,this.b=this.B(new C.$me),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),y),this.B(this.g.watch(I.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(u.FileOperation.CREATE)||S.isOperation(u.FileOperation.COPY)||S.isOperation(u.FileOperation.DELETE)||S.isOperation(u.FileOperation.WRITE))&&I.isEqual(S.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Mo=a;class h{constructor(l,$,I,D,y,S,k,g,b,L,O,q,G){this.a=l,this.b=$,this.c=I,this.overrideIdentifiers=D,this.d=y,this.f=S,this.g=k,this.h=g,this.i=b,this.j=L,this.k=O,this.l=q,this.m=G}get value(){return d(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(l,$,I,D,y,S,k,g,b,L){this.j=l,this.l=$,this.m=I,this.n=D,this.p=y,this.q=S,this.r=k,this.s=g,this.t=b,this.u=L,this.h=null,this.i=new A.$Cc,this.v=null}getValue(l,$,I){return this.w(l,$,I).getValue(l)}updateValue(l,$,I={}){let D;I.resource?(D=this.t.get(I.resource),D||(D=r.createEmptyModel(this.u),this.t.set(I.resource,D))):D=this.s,$===void 0?D.removeValue(l):D.setValue(l,$),I.resource||(this.h=null)}inspect(l,$,I){const D=this.w(l,$,I),y=this.A($.resource,I),S=$.resource?this.t.get($.resource)||this.s:this.s,k=new Set;for(const g of D.overrides)for(const b of g.identifiers)D.getOverrideValue(l,b)!==void 0&&k.add(b);return new h(l,$,D.getValue(l),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,I?this.q:void 0,y||void 0,S)}keys(l){const $=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:$?$.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,$){this.r.set(l,$),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,$){const I=[];if(!$){const{added:D,updated:y,removed:S}=t(this.j,l);$=[...D,...y,...S]}for(const D of $)for(const y of(0,v.$Fo)(D)){const S=this.j.getKeysForOverrideIdentifier(y),k=l.getKeysForOverrideIdentifier(y),g=[...k.filter(b=>S.indexOf(b)===-1),...S.filter(b=>k.indexOf(b)===-1),...S.filter(b=>!N.$go(this.j.override(y).getValue(b),l.override(y).getValue(b)))];I.push([y,g])}return this.updateDefaultConfiguration(l),{keys:$,overrides:I}}compareAndUpdatePolicyConfiguration(l){const{added:$,updated:I,removed:D}=t(this.l,l),y=[...$,...I,...D];return y.length&&this.updatePolicyConfiguration(l),{keys:y,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.applicationConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateApplicationConfiguration(l),{keys:S,overrides:y}}compareAndUpdateLocalUserConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.localUserConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateLocalUserConfiguration(l),{keys:S,overrides:y}}compareAndUpdateRemoteUserConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.remoteUserConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateRemoteUserConfiguration(l),{keys:S,overrides:y}}compareAndUpdateWorkspaceConfiguration(l){const{added:$,updated:I,removed:D,overrides:y}=t(this.workspaceConfiguration,l),S=[...$,...I,...D];return S.length&&this.updateWorkspaceConfiguration(l),{keys:S,overrides:y}}compareAndUpdateFolderConfiguration(l,$){const I=this.folderConfigurations.get(l),{added:D,updated:y,removed:S,overrides:k}=t(I,$),g=[...D,...y,...S];return(g.length||!I)&&this.updateFolderConfiguration(l,$),{keys:g,overrides:k}}compareAndDeleteFolderConfiguration(l){const $=this.folderConfigurations.get(l);if(!$)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:I,updated:D,removed:y,overrides:S}=t($,void 0);return{keys:[...I,...D,...y],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,$,I){let D=this.x($,I);return $.overrideIdentifier&&(D=D.override($.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(D=D.merge(this.l)),D}x({resource:l},$){let I=this.y();if($&&l){const D=$.getFolder(l);D&&(I=this.z(D.uri)||I);const y=this.t.get(l);y&&(I=I.merge(y))}return I}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let $=this.i.get(l);if(!$){const I=this.y(),D=this.r.get(l);D?($=I.merge(D),this.i.set(l,$)):$=I}return $}A(l,$){if($&&l){const I=$.getFolder(l);if(I)return this.r.get(I.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,$)=>{const{contents:I,overrides:D,keys:y}=this.r.get($);return l.push([$,{contents:I,overrides:D,keys:y}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach($=>l.add($)),this.userConfiguration.keys.forEach($=>l.add($)),this.q.keys.forEach($=>l.add($)),this.r.forEach($=>$.keys.forEach(I=>l.add(I))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach($=>l.add($)),this.userConfiguration.getAllOverrideIdentifiers().forEach($=>l.add($)),this.q.getAllOverrideIdentifiers().forEach($=>l.add($)),this.r.forEach($=>$.getAllOverrideIdentifiers().forEach(I=>l.add(I))),[...l.values()]}D(l){const $=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(I=>$.add(I)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(I=>$.add(I)),this.q.getKeysForOverrideIdentifier(l).forEach(I=>$.add(I)),this.r.forEach(I=>I.getKeysForOverrideIdentifier(l).forEach(D=>$.add(D))),[...$.values()]}static parse(l,$){const I=this.E(l.defaults,$),D=this.E(l.policy,$),y=this.E(l.application,$),S=this.E(l.user,$),k=this.E(l.workspace,$),g=l.folders.reduce((b,L)=>(b.set(c.URI.revive(L[0]),this.E(L[1],$)),b),new A.$Cc);return new n(I,D,y,S,r.createEmptyModel($),k,g,r.createEmptyModel($),new A.$Cc,$)}static E(l,$){return new r(l.contents,l.keys,l.overrides,void 0,$)}}e.$No=n;function s(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const l=new Set,$=new Map;for(const D of f)D.keys.forEach(y=>l.add(y)),D.overrides.forEach(([y,S])=>{const k=(0,A.$zc)($,y,new Set);S.forEach(g=>k.add(g))});const I=[];return $.forEach((D,y)=>I.push([y,[...D.values()]])),{keys:[...l.values()],overrides:I}}class i{constructor(l,$,I,D,y){this.change=l,this.f=$,this.g=I,this.h=D,this.i=y,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of l.keys)this.affectedKeys.add(S);for(const[,S]of l.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,$){const I=this.a+l,D=this.d.indexOf(I);if(D<0)return!1;const y=D+I.length;if(y>=this.d.length)return!1;const S=this.d.charCodeAt(y);if(S!==this.b&&S!==this.c)return!1;if($){const k=this.previousConfiguration?this.previousConfiguration.getValue(l,$,this.f?.workspace):void 0,g=this.g.getValue(l,$,this.h);return!N.$go(k,g)}return!0}}e.$Po=i;function t(f,l){const{added:$,removed:I,updated:D}=m(l?.rawConfiguration,f?.rawConfiguration),y=[],S=f?.getAllOverrideIdentifiers()||[],k=l?.getAllOverrideIdentifiers()||[];if(l){const g=k.filter(b=>!S.includes(b));for(const b of g)y.push([b,l.getKeysForOverrideIdentifier(b)])}if(f){const g=S.filter(b=>!k.includes(b));for(const b of g)y.push([b,f.getKeysForOverrideIdentifier(b)])}if(l&&f){for(const g of S)if(k.includes(g)){const b=m({contents:f.getOverrideValue(void 0,g)||{},keys:f.getKeysForOverrideIdentifier(g)},{contents:l.getOverrideValue(void 0,g)||{},keys:l.getKeysForOverrideIdentifier(g)});y.push([g,[...b.added,...b.removed,...b.updated]])}}return{added:$,removed:I,updated:D,overrides:y}}function m(f,l){const $=f?l?f.keys.filter(y=>l.keys.indexOf(y)===-1):[...f.keys]:[],I=l?f?l.keys.filter(y=>f.keys.indexOf(y)===-1):[...l.keys]:[],D=[];if(f&&l){for(const y of l.keys)if(f.keys.indexOf(y)!==-1){const S=(0,R.$hj)(l.contents,y),k=(0,R.$hj)(f.contents,y);N.$go(S,k)||D.push(y)}}return{added:$,removed:I,updated:D}}}),define(Ce[109],Ie([1,0,14,3]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=c,e.$Ql=(0,C.$Fi)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class T{constructor(v){this.id=v,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=T;class A{constructor(v,u){this.host=v,this.port=u,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var N;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(N||(e.RemoteAuthorityResolverErrorCode=N={}));class p extends w.$db{static isNotAvailable(v){return v instanceof p&&v._code===N.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof p&&v._code===N.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof p&&v._code===N.NoResolverFound}static isInvalidAuthority(v){return v instanceof p&&v._code===N.InvalidAuthority}static isHandled(v){return v instanceof p&&v.isHandled}constructor(v,u=N.Unknown,E){super(v),this._message=v,this._code=u,this._detail=E,this.isHandled=u===N.NotAvailable&&E===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tl=p;function c(R){const v=R.indexOf("+");return v===-1?R:R.substring(0,v)}}),define(Ce[63],Ie([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=C,e.$hn=P,e.$in=T,e.$jn=A;function C(p){return p.scheme===w.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const c=p.indexOf("+");return c<0?p:p.substr(0,c)}function T(p){const{host:c,port:R}=N(p);if(typeof R>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:R}}function A(p,c){let{host:R,port:v}=N(p);return typeof v>"u"&&(v=c),{host:R,port:v}}function N(p){const c=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const R=p.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const v=p.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:p,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,63]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=T,e.$tn=v,e.$un=u,e.$vn=E,e.$wn=d,w=qe(w),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function T(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$pn=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var N;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(N||(e.TargetPlatform=N={}));class p{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,a){if(typeof o>"u"||o===null)return typeof a>"u"||a===null;if(typeof a>"u"||a===null)return!1;if(typeof o=="string"||typeof a=="string"){const h=typeof o=="string"?o:o.value,n=typeof a=="string"?a:a.value;return w.$Gf(h,n)}return o._lower===a._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$qn=p;class c{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const a of o)this.add(a)}add(o){this.c.add(p.toKey(o))}delete(o){return this.c.delete(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}}e.$rn=c;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(p.toKey(o))}get(o){return this.c.get(p.toKey(o))}has(o){return this.c.has(p.toKey(o))}set(o,a){this.c.set(p.toKey(o),a)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=R;function v(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function E(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function d(r,o){if(o){const a=`onResolveRemoteAuthority:${(0,P.$hn)(o)}`;return!!r.activationEvents?.includes(a)}return!1}e.$xn=(0,C.$Fi)("IBuiltinExtensionsScannerService")}),define(Ce[110],Ie([1,0,21,171,19,3]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.ExtensionManagementErrorCode=e.$ip=e.ExtensionGalleryErrorCode=e.$hp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=void 0,e.$bp=N,e.$cp=p,e.$dp=c,e.$ep=R,e.$fp=v,e.$gp=u,e.$7o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$8o=new RegExp(e.$7o),e.$9o="__web_extension",e.$0o="skipWalkthrough",e.$$o="extensionInstallSource",e.$_o="dependecyOrPackExtensionInstall",e.$ap="clientTargetPlatform";var A;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function N(i){switch(i){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(i){switch(i){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function c(i,t){switch(i){case w.Platform.Windows:return t==="x64"?P.TargetPlatform.WIN32_X64:t==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Linux:return t==="x64"?P.TargetPlatform.LINUX_X64:t==="arm64"?P.TargetPlatform.LINUX_ARM64:t==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?P.TargetPlatform.ALPINE_X64:t==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Mac:return t==="x64"?P.TargetPlatform.DARWIN_X64:t==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case w.Platform.Web:return P.TargetPlatform.WEB}}function R(i,t){return t===P.TargetPlatform.WEB&&!i.includes(P.TargetPlatform.WEB)}function v(i,t,m){return R(t,m)?!1:i===P.TargetPlatform.UNDEFINED||i===P.TargetPlatform.UNIVERSAL?!0:i===P.TargetPlatform.UNKNOWN?!1:i===m}function u(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var E;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var d;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(i){i.Install="install",i.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$hp=(0,T.$Fi)("extensionGalleryService");var a;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(a||(e.ExtensionGalleryErrorCode=a={}));class h extends Error{constructor(t,m){super(t),this.code=m,this.name=m}}e.$ip=h;var n;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(n||(e.ExtensionManagementErrorCode=n={}));class s extends Error{constructor(t,m){super(t),this.code=m,this.name=m}}e.$jp=s,e.$kp=(0,T.$Fi)("extensionManagementService"),e.$lp="extensionsIdentifiers/disabled",e.$mp="extensionsIdentifiers/enabled",e.$np=(0,T.$Fi)("IGlobalExtensionEnablementService"),e.$op=(0,T.$Fi)("IExtensionTipsService"),e.$pp=(0,C.localize2)(0,"Extensions"),e.$qp=(0,C.localize2)(1,"Preferences")}),define(Ce[111],Ie([1,0,14,19]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JG=e.$IG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,N){this.a.set(A,N)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const N=Object.create(null);for(const p of A){const c=this.readActivationEvents(p);c.length>0&&(N[C.$qn.toKey(p.identifier)]=c)}return N}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const N=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<N.length;p++)N[p]==="onUri"&&(N[p]=`onUri:${C.$qn.toKey(A.identifier)}`);if(!A.contributes)return N;for(const p in A.contributes){const c=this.a.get(p);if(!c)continue;const R=A.contributes[p],v=Array.isArray(R)?R:[R];try{c(v,N)}catch(u){(0,w.$3)(u)}}return N}}e.$IG=P,e.$JG=new P}),define(Ce[216],Ie([1,0,23,14,5,176,54,3,12,31]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=e.$2p=void 0,e.$4p=u,e.$5p=E,e.$6p=d,e.$7p=r,e.$8p=o,e.$9p=a,e.$2p=(0,N.$Fi)("requestService");class R{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?i[t]="*****":i[t]=this.b[t];this.a=i}return this.a}}class v extends P.$Wc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,T.localize)(0,null),when:p.$rk.isEqualTo((0,p.$ok)(p.LogLevel.Trace)).serialize()})}async c(i,t,m){const f=`${i} #${++this.b}: ${t.url}`;this.a.trace(`${f} - begin`,t.type,new R(t.headers??{}));try{const l=await m();return this.a.trace(`${f} - end`,t.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${f} - error`,t.type,(0,C.$_)(l)),l}}}e.$3p=v;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function E(s){return s.res.statusCode===204}async function d(s){return E(s)?null:(await(0,w.$1e)(s.stream)).toString()}async function r(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return d(s)}async function o(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(E(s))return null;const t=(await(0,w.$1e)(s.stream)).toString();try{return JSON.parse(t)}catch(m){throw m.message+=`:
`+t,m}}function a(s){n(s)}let h;function n(s){const i=c.$po.as(A.$uo.Configuration),t=h;h={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},i.updateConfigurations({add:[h],remove:t?[t]:[]})}n(A.ConfigurationScope.APPLICATION)}),define(Ce[217],Ie([1,0,21,79,37]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=A,e.$sp=N;function T(p){if(w.$u===w.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,c,R,v,u,E,d,r,o,a){const h=Object.create(null);h["common.machineId"]=E,h["common.sqmId"]=d,h["common.devDeviceId"]=r,h.sessionID=(0,P.$2g)()+Date.now(),h.commitHash=v,h.version=u,h["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,w.$h)(w.$u),h["common.nodePlatform"]=C.$fc,h["common.nodeArch"]=R,h["common.product"]=a||"desktop",o&&(h["common.msftInternal"]=o);let n=0;const s=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),w.$l&&(h["common.snap"]="true");const i=T(c);return i&&(h["common.platformDetail"]=i),h}function N(p){const c=C.env.USERDNSDOMAIN;if(!c)return!1;const R=c.toLowerCase();return p.some(v=>R===v)}}),define(Ce[112],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,w.$Fi)("telemetryService"),e.$_l=(0,w.$Fi)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var C;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var P;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ce[64],Ie([1,0,26,15,63,217,112]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=void 0,e.$Ap=R,e.$Bp=v,e.$Cp=u,e.$Dp=E,e.$Ep=r,e.$Fp=a,e.$Gp=h,e.$Hp=i;class N{constructor(m){this.value=m,this.isTrustedTelemetryValue=!0}}e.$tp=N;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$up=p,e.$vp=new p;class c{async publicLog(m,f,l){}async publicLogError(m,f,l){}}e.$wp=c,e.$xp="telemetry",e.$yp="extensionTelemetryLog",e.$zp={log:()=>null,flush:()=>Promise.resolve(null)};function R(t,m){return!m.isBuilt&&!m.disableTelemetry?!0:!(m.disableTelemetry||!t.enableTelemetry)}function v(t,m){return m.extensionTestsLocationURI?!0:!(m.isBuilt||m.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function u(t){const m=t.getValue(A.$hm),f=t.getValue(A.$im);if(t.getValue(A.$jm)===!1||f===!1)return A.TelemetryLevel.NONE;switch(m??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function E(t){const m={},f={},l={};o(t,l);for(let $ in l){$=$.length>150?$.substr($.length-149):$;const I=l[$];typeof I=="number"?f[$]=I:typeof I=="boolean"?f[$]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${$} has been trimmed to 8192, the original length is ${I.length}`),m[$]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(m[$]=I)}return{properties:m,measurements:f}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const m=(0,P.$hn)(t);return d.has(m)?m:"other"}function o(t,m,f=0,l){if(t)for(const $ of Object.getOwnPropertyNames(t)){const I=t[$],D=l?l+$:$;Array.isArray(I)?m[D]=(0,w.$ho)(I):I instanceof Date?m[D]=I.toISOString():(0,C.$hg)(I)?f<2?o(I,m,f+1,D+"."):m[D]=(0,w.$ho)(I):m[D]=I}}function a(t,m){const f=t.msftInternalDomains||[],l=m.getValue("telemetry.internalTesting");return(0,T.$sp)(f)||l}function h(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function n(t,m){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let f=t;const l=[];for(const y of m)for(;;){const S=y.exec(t);if(!S)break;l.push([S.index,y.lastIndex])}const $=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(f="";;){const y=I.exec(t);if(!y)break;const S=l.some(([k,g])=>y.index<g&&k<I.lastIndex);!$.test(y[0])&&!S&&(f+=t.substring(D,y.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<t.length&&(f+=t.substr(D)),f}function s(t){if(!t)return t;const m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of m)if(f.regex.test(t))return`<REDACTED: ${f.label}>`;return t}function i(t,m){return(0,w.$eo)(t,f=>{if(f instanceof N||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let l=f.replaceAll("%20"," ");l=n(l,m);for(const $ of m)l=l.replace($,"");return l=s(l),l}})}}),define(Ce[218],Ie([1,0,13,110,19,21,2,14,79,64]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Jp=void 0,e.$Ip=R,e.$Kp=d,e.$Lp=r,e.$Mp=o,e.$Np=a,e.$Op=h,e.$Pp=n,e.$Qp=s,e.$Sp=i,e.$Tp=m;function R(f,l){return f.uuid&&l.uuid?f.uuid===l.uuid:f.id===l.id?!0:(0,w.$Bf)(f.id,l.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const $=l.manifest?l.manifest.version:l.version,I=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,$,I)}static parse(l){const $=v.exec(l);return $&&$[1]&&$[2]?new u({id:$[1]},$[2],$[4]||void 0):null}constructor(l,$,I=P.TargetPlatform.UNDEFINED){this.identifier=l,this.version=$,this.targetPlatform=I,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?R(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Jp=u;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(f){const l=E.exec(f);return l&&l[1]?[o(l[1]),l[2]]:[o(f),void 0]}function r(f,l){return`${f}.${l}`}function o(f){return f.toLowerCase()}function a(f,l){return o(r(f??P.$mn,l))}function h(f,l){const $=[],I=D=>{for(const y of $)if(y.some(S=>R(l(S),l(D))))return y;return null};for(const D of f){const y=I(D);y?y.push(D):$.push([D])}return $}function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}function s(f){return{id:new c.$tp(f.identifier.id),name:new c.$tp(f.name),version:f.version,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),isSigned:f.isSigned,...f.telemetryData}}e.$Rp=new P.$qn("pprice.better-merge");function i(f,l){const $=[],I=l.manifest.extensionDependencies?.slice(0)??[];for(;I.length;){const D=I.shift();if(D&&$.every(y=>!R(y.identifier,{id:D}))){const y=f.filter(S=>R(S.identifier,{id:D}));y.length===1&&($.push(y[0]),I.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return $}async function t(f,l){if(!T.$k)return!1;let $;try{$=(await f.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await f.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){l.debug("Error while getting the os-release file.",(0,N.$_)(D))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function m(f,l){const $=await t(f,l),I=(0,C.$dp)($?"alpine":T.$u,p.$gc);return l.debug("ComputeTargetPlatform:",I),I}}),define(Ce[219],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=w,e.$As=C,e.$Bs=P,e.$Cs=T,e.$Ds=A,e.$Es=N;function w(p){return[...p.entries()]}function C(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function T(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(c=>[c[0],w(c[1].map),C(c[1].descriptionMap)])}function N(p){return new Map(p.map(c=>[c[0],{map:P(c[1]),descriptionMap:T(c[2])}]))}}),define(Ce[220],Ie([1,0,3,32,31]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.$ls=e.$ks=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$js=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$is=void 0,e.$is=new C.$Wj("terminalTabFocusMode",!1,!0);var T;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var A;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var N;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(N||(e.PosixShellType=N={}));var p;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(p||(e.WindowsShellType=p={}));var c;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var R;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(R||(e.TerminalIpcChannels=R={}));var v;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$js=(0,w.$Fi)("ptyService");var u;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var E;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(E||(e.TerminalLocation=E={}));var d;(function(i){i.TerminalView="view",i.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var a;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var n;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(n||(e.TerminalExitReason=n={})),e.$ks={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const m=this.b(t.remoteAuthority);if(this.a.has(m))throw new Error(`A terminal backend with remote authority '${m}' was already registered.`);this.a.set(m,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$po.add(e.$ks.Backend,new s),e.$ls=(0,w.$Fi)("localPtyService"),e.$ms=(0,w.$Fi)("terminalLogService")}),define(Ce[221],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zwb=void 0;class w{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,T,A=5){const N=T(p=>{const c=typeof p=="string"?p:p.data;let R=this.a.get(P);if(R){R.data.push(c);return}const v=setTimeout(()=>this.flushBuffer(P),A);R={data:[c],timeoutId:v,dispose:()=>{clearTimeout(v),this.flushBuffer(P),N.dispose()}},this.a.set(P,R)});return N}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const T=this.a.get(P);T&&(this.a.delete(P),this.b(P,T.data.join("")))}}e.$Zwb=w}),define(Ce[222],Ie([1,0,11,98,323,35,4,15,2,177,78,31]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bx=e.$Ax=e.$zx=e.$yx=e.$xx=e.$wx=e.IconFontDefinition=e.IconContribution=e.$tx=void 0,e.$ux=o,e.$vx=a,v=qe(v),e.$tx={IconContribution:"base.contributions.icons"};var u;(function(i){function t(m,f){let l=m.defaults;for(;T.ThemeIcon.isThemeIcon(l);){const $=r.getIcon(l.id);if(!$)return;l=$.defaults}return l}i.getDefinition=t})(u||(e.IconContribution=u={}));var E;(function(i){function t(f){return{weight:f.weight,style:f.style,src:f.src.map(l=>({format:l.format,location:l.location.toString()}))}}i.toJSONObject=t;function m(f){const l=$=>(0,N.$fg)($)?$:void 0;if(f&&Array.isArray(f.src)&&f.src.every($=>(0,N.$fg)($.format)&&(0,N.$fg)($.location)))return{weight:l(f.weight),style:l(f.style),src:f.src.map($=>({format:$.format,location:p.URI.parse($.location)}))}}i.fromJSONObject=m})(E||(e.IconFontDefinition=E={}));class d{constructor(){this.a=new A.$me,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,m,f,l){const $=this.b[t];if($){if(f&&!$.description){$.description=f,this.d.properties[t].markdownDescription=`${f} $(${t})`;const y=this.e.enum.indexOf(t);y!==-1&&(this.e.enumDescriptions[y]=f),this.a.fire()}return $}const I={id:t,description:f,defaults:m,deprecationMessage:l};this.b[t]=I;const D={$ref:"#/definitions/icons"};return l&&(D.deprecationMessage=l),f&&(D.markdownDescription=`${f}: $(${t})`),this.d.properties[t]=D,this.e.enum.push(t),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const m=this.e.enum.indexOf(t);m!==-1&&(this.e.enum.splice(m,1),this.e.enumDescriptions.splice(m,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,m){const f=this.f[t];return f||(this.f[t]=m,this.a.fire(),m)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=($,I)=>$.id.localeCompare(I.id),m=$=>{for(;T.ThemeIcon.isThemeIcon($.defaults);)$=this.b[$.defaults.id];return`codicon codicon-${$?$.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map($=>this.b[$]);for(const $ of l.filter(I=>!!I.description).sort(t))f.push(`|<i class="${m($)}"></i>|${$.id}|${T.ThemeIcon.isThemeIcon($.defaults)?$.defaults.id:$.id}|${$.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const $ of l.filter(I=>!T.ThemeIcon.isThemeIcon(I.defaults)).sort(t))f.push(`|<i class="${m($)}"></i>|${$.id}|`);return f.join(`
`)}}const r=new d;v.$po.add(e.$tx.IconContribution,r);function o(i,t,m,f){return r.registerIcon(i,t,m,f)}function a(){return r}function h(){const i=(0,P.$1j)();for(const t in i){const m="\\"+i[t].toString(16);r.registerIcon(t,{fontCharacter:m})}}h(),e.$wx="vscode://schemas/icons";const n=v.$po.as(R.$qo.JSONContribution);n.registerSchema(e.$wx,r.getIconSchema());const s=new w.$Rh(()=>n.notifySchemaChanged(e.$wx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$xx=o("widget-close",C.$5j.close,(0,c.localize)(2,null)),e.$yx=o("goto-previous-location",C.$5j.arrowUp,(0,c.localize)(3,null)),e.$zx=o("goto-next-location",C.$5j.arrowDown,(0,c.localize)(4,null)),e.$Ax=T.ThemeIcon.modify(C.$5j.sync,"spin"),e.$Bx=T.ThemeIcon.modify(C.$5j.loading,"spin")}),define(Ce[223],Ie([1,0,4,5,21,2,42,3,12]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iw=e.$Hw=e.$Ew=e.$Cw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$yw=e.$xw=void 0,e.$zw=v,e.$Aw=E,e.$Bw=d,e.$Dw=r,e.$Fw=o,e.$Gw=a,e.$xw=(0,N.$Fi)("tunnelService"),e.$yw=(0,N.$Fi)("sharedTunnelsService");var c;(function(s){s.Http="http",s.Https="https"})(c||(e.TunnelProtocol=c={}));var R;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(R||(e.TunnelPrivacyId=R={}));function v(s){return!!s.forwardPort}var u;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function E(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(i)return{address:i[1],port:+i[2]}}function d(s){if(s.scheme!=="http"&&s.scheme!=="https"||!s.query)return;const i=s.query.split("&");for(const t of i){const m=t.split("=")[1];if(/^https?:/.exec(m)){const f=E(T.URI.parse(m));if(f)return f}}}e.$Cw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(s){return e.$Cw.indexOf(s)>=0}e.$Ew=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function o(s){return e.$Ew.indexOf(s)>=0}function a(s,i,t,m){if(t===P.OperatingSystem.Windows)return!1;if(t===P.OperatingSystem.Macintosh&&o(i)){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(f?.length===4&&parseInt(f[1])>=18)return!1}return s<1024}class h{constructor(i,t,m){this.remoteAddress=i,this.localAddress=t,this.b=m,this.a=new w.$me,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Hw=h;let n=class extends C.$Wc{constructor(i,t){super(),this.r=i,this.s=t,this.a=new w.$me,this.onTunnelOpened=this.a.event,this.b=new w.$me,this.onTunnelClosed=this.b.event,this.c=new w.$me,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const i=this.s.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.g=i,i?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.h=i.elevation,this.m=i.privacyOptions,this.j=i.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const i=[],t=Array.from(this.f.values());for(const m of t){const f=Array.from(m.values());for(const l of f){const $=await l.value;$&&typeof $!="string"&&i.push($)}}return i}async dispose(){super.dispose();for(const i of this.f.values()){for(const{value:t}of i.values())await t.then(m=>typeof m!="string"?m?.dispose():void 0);i.clear()}this.f.clear()}setEnvironmentTunnel(i,t,m,f,l){this.z(i,t,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:t,localAddress:m,privacy:f,protocol:l,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,t){(o(i)||r(i))&&(i=e.$Cw[0]);const m=this.D(i,t);if(m)return++m.refcount,m.value}openTunnel(i,t,m,f,l,$=!1,I,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${t}:${m} on local port ${l}.`);const y=this.g??i;if(!y)return;if(t||(t="localhost"),f||(f=this.t),this.g&&this.n.has(m)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const S=this.F(y,t,m,f,l,$,I,D);return S?S.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(t,m),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(t,m);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.w(k);return(k.tunnelRemoteHost!==t||k.tunnelRemotePort!==m)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),I&&k.privacy!==I&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(g),g}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),S)}w(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const t=this.f.get(i.tunnelRemoteHost);if(t){const m=t.get(i.tunnelRemotePort);m&&(m.refcount--,await this.y(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async y(i,t,m){if(m.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${t}.`);const f=m.value.then(async l=>{l&&typeof l!="string"&&(await l.dispose(!0),this.b.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this.f.has(i)&&this.f.get(i).delete(t),f}}async closeTunnel(i,t){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${t} `);const m=this.f.get(i);if(m&&m.has(t)){const f=m.get(t);f.refcount=0,await this.y(i,t,f)}}z(i,t,m){this.f.has(i)||this.f.set(i,new Map),this.f.get(i).set(t,{refcount:1,value:m})}async C(i,t){const m=this.f.get(i);if(m){const f=m.get(t),l=f?await f.value:void 0;(!l||typeof l=="string")&&m.delete(t),m.size===0&&this.f.delete(i)}}D(i,t){const m=[i];r(i)?(m.push(...e.$Cw),m.push(...e.$Ew)):o(i)&&m.push(...e.$Ew);const f=m.map(l=>this.f.get(l));for(const l of f){const $=l?.get(t);if($)return $}}canTunnel(i){return!!E(i)}G(i,t,m,f,l,$,I){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${t}:${m} on local port ${f}.`);const D=m;this.n.add(D);const y=f===void 0?m:f,S={elevationRequired:l?this.isPortPrivileged(y):!1},k={remoteAddress:{host:t,port:m},localAddressPort:f,privacy:$,public:$?$!==R.Private:void 0,protocol:I},g=i.forwardPort(k,S);return g?(this.z(t,m,g),g.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),g}};e.$Iw=n,e.$Iw=n=Qe([Ve(0,p.$_j),Ve(1,A.$_i)],n)}),define(Ce[224],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,w.$Fi)("IUriIdentityService")}),define(Ce[225],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Jw=void 0,e.$Jw=(0,w.$Fi)("editSessionIdentityService");var C;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(C||(e.EditSessionIdentityMatch=C={}))}),define(Ce[226],Ie([1,0,16]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=C,e.$1M=P,e.$2M=T,e.$3M=A,e.$4M=N;function C(p){return p.scheme!==w.Schemas.file&&p.scheme!==w.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(c=>C(c.uri))?p.folders[0].uri:void 0;if(p.configuration&&C(p.configuration))return p.configuration}function T(p){return P(p)?.scheme}function A(p){return P(p)?.authority}function N(p){return P(p)!==void 0}}),define(Ce[50],Ie([1,0,179,20,59,24,2,3,16]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8i=e.$5i=e.$4i=e.$3i=e.$2i=e.$Zi=e.$Yi=e.WorkbenchState=e.$Si=e.$Ri=e.$Oi=void 0,e.$Pi=c,e.$Qi=R,e.$Ti=v,e.$Ui=u,e.$Vi=E,e.$Wi=r,e.$Xi=o,e.$1i=n,e.$6i=s,e.$7i=i,e.$9i=t,e.$0i=m,e.$$i=f,e.$Oi=(0,N.$Fi)("contextService");function c(l){const $=l;return typeof $?.id=="string"&&A.URI.isUri($.uri)}function R(l){return typeof l?.id=="string"&&!c(l)&&!u(l)}e.$Ri={id:"ext-dev"},e.$Si={id:"empty-window"};function v(l,$){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,C.$pc)(l)}:$?e.$Ri:e.$Si;const I=l;return I.configuration?{id:I.id,configPath:I.configuration}:I.folders.length===1?{id:I.id,uri:I.folders[0].uri}:{id:I.id}}function u(l){const $=l;return typeof $?.id=="string"&&A.URI.isUri($.configPath)}function E(l){const $=l;if($?.uri)return{id:$.id,uri:A.URI.revive($.uri)};const I=l;if(I?.configPath)return{id:I.id,configPath:A.URI.revive(I.configPath)};if(l?.id)return{id:l.id}}var d;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(l){const $=l;return!!($&&typeof $=="object"&&typeof $.id=="string"&&Array.isArray($.folders))}function o(l){const $=l;return!!($&&typeof $=="object"&&A.URI.isUri($.uri)&&typeof $.name=="string"&&typeof $.toResource=="function")}class a{constructor($,I,D,y,S){this.h=$,this.j=D,this.k=y,this.l=S,this.c=P.$Li.forUris(this.l,()=>!0),this.folders=I}update($){this.h=$.id,this.k=$.configuration,this.j=$.transient,this.l=$.l,this.folders=$.folders}get folders(){return this.g}set folders($){this.g=$,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration($){this.k=$}getFolder($){return $&&this.c.findSubstr($)||null}n(){this.c=P.$Li.forUris(this.l,()=>!0);for(const $ of this.folders)this.c.set($.uri,$)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Yi=a;class h{constructor($,I){this.raw=I,this.uri=$.uri,this.index=$.index,this.name=$.name}toResource($){return(0,T.$gh)(this.uri,$)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Zi=h;function n(l){return new h({uri:l,index:0,name:(0,T.$ch)(l)},{uri:l.toString()})}e.$2i="code-workspace",e.$3i=`.${e.$2i}`,e.$4i=[{name:(0,w.localize)(0,null),extensions:[e.$2i]}],e.$5i="workspace.json";function s(l,$){return T.$0g.isEqualOrParent(l,$.untitledWorkspacesHome)}function i(l){let $;return A.URI.isUri(l)?$=l:$=l.configuration,$?.scheme===p.Schemas.tmp}e.$8i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$8i}function m(l,$){return!s(l,$)&&!i(l)}function f(l){return(typeof l=="string"?(0,C.$qc)(l):(0,T.$eh)(l))===e.$3i}}),define(Ce[113],Ie([1,0,76,4,5,24,2,178,106,30,3,12,50,29,224,11,37,13,15]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=s,e.$Ml=i,e.$Nl=t;var n;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function s(l){const $=l;return!!($&&typeof $=="object"&&typeof $.id=="string"&&typeof $.isDefault=="boolean"&&typeof $.name=="string"&&A.URI.isUri($.location)&&A.URI.isUri($.globalStorageHome)&&A.URI.isUri($.settingsResource)&&A.URI.isUri($.keybindingsResource)&&A.URI.isUri($.tasksResource)&&A.URI.isUri($.snippetsHome)&&A.URI.isUri($.extensionsResource))}e.$Ll=(0,R.$Fi)("IUserDataProfilesService");function i(l,$){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:$}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:$}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:$}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:$}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:$}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:$}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:$}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:$}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,$,I,D,y,S){return{id:l,name:$,location:I,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:S&&y?.useDefaultFlags?.globalState?S.globalStorageHome:(0,T.$gh)(I,"globalStorage"),settingsResource:S&&y?.useDefaultFlags?.settings?S.settingsResource:(0,T.$gh)(I,"settings.json"),keybindingsResource:S&&y?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,T.$gh)(I,"keybindings.json"),tasksResource:S&&y?.useDefaultFlags?.tasks?S.tasksResource:(0,T.$gh)(I,"tasks.json"),snippetsHome:S&&y?.useDefaultFlags?.snippets?S.snippetsHome:(0,T.$gh)(I,"snippets"),extensionsResource:S&&y?.useDefaultFlags?.extensions?S.extensionsResource:(0,T.$gh)(I,"extensions.json"),cacheHome:(0,T.$gh)(D,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let m=class extends P.$Wc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor($,I,D,y){super(),this.t=$,this.u=I,this.w=D,this.y=y,this.f=!0,this.h=this.B(new C.$me),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$me),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$me),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$me),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new E.$Cc,workspaces:new E.$Cc,emptyWindows:new Map},this.profilesHome=(0,T.$gh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$gh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement($){this.f!==$&&(this.z=void 0,this.f=$)}isEnabled(){return this.f}get C(){if(!this.z){const $=this.D(),I=[$];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,h.$fg)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}I.push(t((0,T.$dh)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},$))}}catch(S){this.y.error(S)}const D=new E.$Cc,y=new Map;if(I.length)try{const S=this.Q();if(S.workspaces)for(const[k,g]of Object.entries(S.workspaces)){const b=A.URI.parse(k),L=I.find(O=>O.id===g);L&&D.set(b,L)}if(S.emptyWindows)for(const[k,g]of Object.entries(S.emptyWindows)){const b=I.find(L=>L.id===g);b&&y.set(k,b)}}catch(S){this.y.error(S)}this.z={profiles:I,workspaces:D,emptyWindows:y}}return this.z}D(){const $=t("__default__profile__",(0,N.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...$,extensionsResource:this.S()??$.extensionsResource,isDefault:!0}}async createTransientProfile($){const I="Temp",D=new RegExp(`${(0,a.$if)(I)}\\s(\\d+)`);let y=0;for(const k of this.profiles){const g=D.exec(k.name),b=g?parseInt(g[1]):0;y=b>y?b:y}const S=`${I} ${y+1}`;return this.createProfile((0,w.$tj)((0,o.$2g)()).toString(16),S,{transient:!0},$)}async createNamedProfile($,I,D){return this.createProfile((0,w.$tj)((0,o.$2g)()).toString(16),$,I,D)}async createProfile($,I,D,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F($,I,D);return y&&await this.setProfileForWorkspace(y,S),S}async F($,I,D){if(!(0,h.$fg)(I)||!I)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get(I);return y||(y=(async()=>{try{if(this.profiles.find(b=>b.name===I||b.id===$))throw new Error(`Profile with ${I} name already exists`);const k=t($,I,(0,T.$gh)(this.profilesHome,$),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const g=[];return this.j.fire({profile:k,join(b){g.push(b)}}),await r.Promises.settled(g),this.I([k],[],[]),k}finally{this.r.delete(I)}})(),this.r.set(I,y)),y}async updateProfile($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(y=>y.id===$.id);if(!D)throw new Error(`Profile '${$.name}' does not exist`);return D=t(D.id,I.name??D.name,D.location,this.g,{shortName:I.shortName??D.shortName,icon:I.icon===null?void 0:I.icon??D.icon,transient:I.transient??D.isTransient,useDefaultFlags:I.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile($){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if($.isDefault)throw new Error("Cannot remove default profile");const I=this.profiles.find(y=>y.id===$.id);if(!I)throw new Error(`Profile '${$.name}' does not exist`);const D=[];this.m.fire({profile:I,join(y){D.push(y)}});try{await Promise.allSettled(D)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])I.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])I.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[I],[]);try{await this.u.del(I.cacheHome,{recursive:!0})}catch(y){(0,c.$ql)(y)!==c.FileOperationResult.FILE_NOT_FOUND&&this.y.error(y)}}async setProfileForWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(y=>y.id===I.id);if(!D)throw new Error(`Profile '${I.name}' does not exist`);this.L($,D)}unsetWorkspace($,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L($,void 0,I)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const $=await this.u.resolve(this.profilesHome);await Promise.all(($.children||[]).filter(I=>I.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,I.resource))).map(I=>this.u.del(I.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const $=this.s.profiles.filter(I=>!this.H(I));await Promise.allSettled($.map(I=>this.removeProfile(I)))}getProfileForWorkspace($){const I=this.G($),D=A.URI.isUri(I)?this.C.workspaces.get(I):this.C.emptyWindows.get(I);return D||((0,u.$Pi)($)?this.s.folders.get($.uri):(0,u.$Ui)($)?this.s.workspaces.get($.configPath):this.s.emptyWindows.get($.id))}G($){return(0,u.$Pi)($)?$.uri:(0,u.$Ui)($)?$.configPath:$.id}H($){return!!([...this.C.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.C.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.emptyWindows.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.workspaces.values()].some(I=>this.w.extUri.isEqual(I.location,$.location))||[...this.s.folders.values()].some(I=>this.w.extUri.isEqual(I.location,$.location)))}I($,I,D){const y=[...this.profiles,...$],S=[],k=this.s.profiles;this.s.profiles=[];for(let g of y){if(g.isDefault||I.some(L=>g.id===L.id))continue;g=D.find(L=>g.id===L.id)??g;const b=k.find(L=>g.id===L.id);if(g.isTransient)this.s.profiles.push(g);else{if(b){for(const[L,O]of this.s.emptyWindows.entries())if(g.id===O.id){this.L({id:L},g);break}for(const[L,O]of this.s.workspaces.entries())if(g.id===O.id){this.L({id:"",configPath:L},g);break}for(const[L,O]of this.s.folders.entries())if(g.id===O.id){this.L({id:"",uri:L},g);break}}S.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags})}}this.P(S),this.z=void 0,this.J($,I,D)}J($,I,D){this.h.fire({added:$,removed:I,updated:D,all:this.profiles})}L($,I,D){if(D=I?.isTransient?!0:D,D)(0,u.$Pi)($)?(this.s.folders.delete($.uri),I&&this.s.folders.set($.uri,I)):(0,u.$Ui)($)?(this.s.workspaces.delete($.configPath),I&&this.s.workspaces.set($.configPath,I)):(this.s.emptyWindows.delete($.id),I&&this.s.emptyWindows.set($.id,I));else{this.L($,void 0,!0);const y=this.G($);A.URI.isUri(y)?(this.C.workspaces.delete(y),I&&this.C.workspaces.set(y,I)):(this.C.emptyWindows.delete(y),I&&this.C.emptyWindows.set(y,I)),this.M()}}M(){const $={};for(const[D,y]of this.C.workspaces.entries())$[D.toString()]=y.id;const I={};for(const[D,y]of this.C.emptyWindows.entries())I[D.toString()]=y.id;this.R({workspaces:$,emptyWindows:I}),this.z=void 0}N($){const I={},D=this.D();if($.workspaces)for(const[S,k]of Object.entries($.workspaces)){const g=A.URI.parse(k);I[S]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}const y={};if($.emptyWindows)for(const[S,k]of Object.entries($.emptyWindows)){const g=A.URI.parse(k);y[S]=this.w.extUri.isEqual(g,D.location)?D.id:this.w.extUri.basename(g)}return{workspaces:I,emptyWindows:y}}O(){return[]}P($){throw new Error("not implemented")}Q(){return{}}R($){throw new Error("not implemented")}S(){}};e.$Ol=m,e.$Ol=m=Qe([Ve(0,p.$Mi),Ve(1,c.$_k),Ve(2,d.$Jl),Ve(3,v.$_j)],m);class f extends m{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P($){this.a=$}Q(){return this.X}R($){this.X=$}}e.$Pl=f}),define(Ce[227],Ie([1,0,11,4,5,65,15,161,3,113]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$eq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$cq=e.$bq=e.$aq=void 0,e.$dq=E,e.$fq=r,e.$hq=a,e.$aq="__$__isNewStorageMarker",e.$bq="__$__targetStorageMarker",e.$cq=(0,p.$Fi)("storageService");var R;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var v;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var u;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function E(h){const n=h.get(e.$bq);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}class d extends P.$Wc{static{this.a=60*1e3}constructor(n={flushInterval:d.a}){super(),this.m=n,this.b=this.B(new C.$pe),this.c=this.B(new C.$pe),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$me),this.onWillSaveState=this.f.event,this.h=this.B(new w.$Rh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Xc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,s,i){return C.Event.filter(this.b.event,t=>t.scope===n&&(s===void 0||t.key===s),i)}n(){this.j.value=(0,w.$Vh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Rc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,s){const{key:i,external:t}=s;if(i===e.$bq){switch(n){case v.APPLICATION:this.H=void 0;break;case v.PROFILE:this.F=void 0;break;case v.WORKSPACE:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:i,target:this.J(n)[i],external:t})}w(n){this.f.fire({reason:n})}get(n,s,i){return this.P(s)?.get(n,i)}getBoolean(n,s,i){return this.P(s)?.getBoolean(n,i)}getNumber(n,s,i){return this.P(s)?.getNumber(n,i)}getObject(n,s,i){return this.P(s)?.getObject(n,i)}storeAll(n,s){this.y(()=>{for(const i of n)this.store(i.key,i.value,i.scope,i.target,s)})}store(n,s,i,t,m=!1){if((0,A.$og)(s)){this.remove(n,i,m);return}this.y(()=>{this.z(n,i,t),this.P(i)?.set(n,s,m)})}remove(n,s,i=!1){this.y(()=>{this.z(n,s,void 0),this.P(s)?.delete(n,i)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,s){const i=[],t=this.J(n);for(const m of Object.keys(t))t[m]===s&&i.push(m);return i}z(n,s,i,t=!1){const m=this.J(s);typeof i=="number"?m[n]!==i&&(m[n]=i,this.P(s)?.set(e.$bq,JSON.stringify(m),t)):typeof m[n]=="number"&&(delete m[n],this.P(s)?.set(e.$bq,JSON.stringify(m),t))}get D(){return this.C||(this.C=this.L(v.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(v.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(v.APPLICATION)),this.H}J(n){switch(n){case v.APPLICATION:return this.I;case v.PROFILE:return this.G;default:return this.D}}L(n){const s=this.P(n);return s?E(s):Object.create(null)}isNew(n){return this.getBoolean(e.$aq,n)===!0}async flush(n=R.NONE){this.f.fire({reason:n});const s=this.P(v.APPLICATION),i=this.P(v.PROFILE),t=this.P(v.WORKSPACE);switch(n){case R.NONE:await w.Promises.settled([s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await w.Promises.settled([s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(v.APPLICATION)?.items??new Map,s=this.P(v.PROFILE)?.items??new Map,i=this.P(v.WORKSPACE)?.items??new Map;return a(n,s,i,this.Q(v.APPLICATION)??"",this.Q(v.PROFILE)??"",this.Q(v.WORKSPACE)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,s){return this.w(R.NONE),(0,c.$Kl)(n)?this.R(n,s):this.S(n,s)}M(n,s){return!(n.id===s.id||r(s)&&r(n))}N(n,s,i){this.y(()=>{const t=new Set;for(const[m,f]of n)t.add(m),s.get(m)!==f&&this.u(i,{key:m,external:!0});for(const[m]of s.items)t.has(m)||this.u(i,{key:m,external:!0})})}}e.$eq=d;function r(h){return h.isDefault||!!h.useDefaultFlags?.globalState}class o extends d{constructor(){super(),this.U=this.B(new N.$$p(new N.$_p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new N.$$p(new N.$_p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new N.$$p(new N.$_p,{hint:N.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(v.WORKSPACE,n))),this.B(this.W.onDidChangeStorage(n=>this.u(v.PROFILE,n))),this.B(this.U.onDidChangeStorage(n=>this.u(v.APPLICATION,n)))}P(n){switch(n){case v.APPLICATION:return this.U;case v.PROFILE:return this.W;default:return this.X}}Q(n){switch(n){case v.APPLICATION:return"inMemory (application)";case v.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$gq=o;async function a(h,n,s,i,t,m){const f=b=>{try{return JSON.parse(b)}catch{return b}},l=new Map,$=new Map;h.forEach((b,L)=>{l.set(L,b),$.set(L,f(b))});const I=new Map,D=new Map;n.forEach((b,L)=>{I.set(L,b),D.set(L,f(b))});const y=new Map,S=new Map;s.forEach((b,L)=>{y.set(L,b),S.set(L,f(b))}),console.group(i!==t?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const k=[];if(l.forEach((b,L)=>{k.push({key:L,value:b})}),console.table(k),console.groupEnd(),console.log($),i!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const b=[];I.forEach((L,O)=>{b.push({key:O,value:L})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${m})`);const g=[];y.forEach((b,L)=>{g.push({key:L,value:b})}),console.table(g),console.groupEnd(),console.log(S)}}),define(Ce[80],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=void 0;class w{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const T=this.c++;return this.b.set(T,P),this.e(),T}get(P,T){return this.b.has(P)?this.b.get(P)[T]:void 0}delete(P){this.b.delete(P),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$ync=w}),define(Ce[51],Ie([1,0,16,24,30,3]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=e.$Dnc=void 0;class A{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new C.$8g(p=>{const c=this.b.get(p.scheme);return!(c===void 0||c&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,c){c===null?this.b.delete(p.scheme):this.b.set(p.scheme,c)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Dnc=A,e.$Enc=(0,T.$Fi)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0,e.$aQ=(0,w.$Fi)("IExtHostInitDataService")}),define(Ce[228],Ie([1,0,184,12,213,27]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0;let A=class extends P.$kR{constructor(p,c,R){const v=R.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",u=R.remote.isRemote?(0,w.localize)(0,null):p?(0,w.localize)(1,null):(0,w.localize)(2,null);super(c.createLogger(v,{name:u}))}};e.$Lpc=A,e.$Lpc=A=Qe([Ve(1,C.$ak),Ve(2,T.$aQ)],A)}),define(Ce[229],Ie([1,0,11]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=e.$joc=void 0;class C{constructor(A,N,p){this.h=new Map,this.a=A,this.b=N,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(c=>(this.f=c,this)),this.g=this.c.onDidChangeStorage(c=>{c.shared===this.b&&c.key===this.a&&(this.f=c.value)}),this.i=new w.$Rh(()=>{const c=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of c.values())R.complete()}catch(R){for(const v of c.values())v.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,N){let p=this.f[A];return typeof p>"u"&&(p=N),p}update(A,N){this.f[A]=N;const p=this.h.get(A);if(p!==void 0)return p.p;const c=new w.$3h;return this.h.set(A,c),this.i.isScheduled()||this.i.schedule(),c.p}dispose(){this.g.dispose()}}e.$joc=C;class P extends C{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,N){super(A.identifier.value,!0,N),this.j=A}}e.$koc=P}),define(Ce[230],Ie([1,0,4,2]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;class P{constructor(A){this.c=A,this.a=new w.$me,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$me,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,N,p,c){const v=this.c.getNotebookDocument(C.URI.revive(A)).acceptModelChanged(N.value,p,c);this.b.fire(v)}$acceptDirtyStateChanged(A,N){this.c.getNotebookDocument(C.URI.revive(A)).acceptDirty(N)}$acceptModelSaved(A){const N=this.c.getNotebookDocument(C.URI.revive(A));this.a.fire(N.apiNotebook)}}e.$dpc=P}),define(Ce[17],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XP=e.$WP=void 0,e.$WP=(0,w.$Fi)("IExtHostRpcService");class C{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$XP=C}),define(Ce[231],Ie([1,0,19,4]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$toc=void 0;class P{#e;constructor(A,N){this.b=new C.$me,this.onDidChange=this.b.event,this.a=w.$qn.toKey(A.identifier),this.#e=N,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(A){return this.#e.get(this.a,A)}store(A,N){return this.#e.store(this.a,A,N)}delete(A){return this.#e.delete(this.a,A)}}e.$toc=P}),define(Ce[66],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=void 0,e.$Tnc=(0,w.$Fi)("IURITransformerService");class C{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Unc=C});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[114],Ie([1,0,193,15,2,5,3,31,30,16,48,155,36]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$bG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$4F=e.EditorInputCapabilities=e.$3F=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=void 0,e.$TF=r,e.$UF=o,e.$VF=a,e.$WF=h,e.$XF=n,e.$YF=s,e.$ZF=i,e.$1F=t,e.$2F=m,e.$5F=y,e.$6F=k,e.$7F=g,e.$8F=b,e.$9F=L,e.$0F=O,e.$$F=q,e.$_F=G,e.$aG=te,e.$cG=de,e.$dG=re,e.$eG=Pe,e.$fG=Le,u=ri(u),e.$OF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$PF={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$QF="workbench.editor.sidebysideEditor",e.$RF="workbench.editors.textDiffEditor",e.$SF="workbench.editors.binaryResourceDiffEditor";var E;(function(Y){Y[Y.PROGRAMMATIC=1]="PROGRAMMATIC",Y[Y.USER=2]="USER",Y[Y.EDIT=3]="EDIT",Y[Y.NAVIGATION=4]="NAVIGATION",Y[Y.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var d;(function(Y){Y[Y.IDENTICAL=1]="IDENTICAL",Y[Y.SIMILAR=2]="SIMILAR",Y[Y.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(Y){const B=Y;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function o(Y){const B=Y;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function a(Y,B,_){for(const ve of _.visibleEditorPanes)if(ve.group.id===B&&Y.matches(ve.input))return ve.getViewState()}function h(Y){if(y(Y))return!1;const B=Y;return P.URI.isUri(B?.resource)}function n(Y){if(y(Y))return!1;const B=Y;return B?.original!==void 0&&B.modified!==void 0}function s(Y){if(y(Y))return!1;const B=Y;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function i(Y){if(y(Y)||n(Y))return!1;const B=Y;return B?.primary!==void 0&&B.secondary!==void 0}function t(Y){if(y(Y))return!1;const B=Y;return B?B.resource===void 0||B.resource.scheme===c.Schemas.untitled||B.forceUntitled===!0:!1}function m(Y){if(y(Y))return!1;const B=Y;return P.URI.isUri(B?.base?.resource)&&P.URI.isUri(B?.input1?.resource)&&P.URI.isUri(B?.input2?.resource)&&P.URI.isUri(B?.result?.resource)}var f;(function(Y){Y[Y.SHORT=0]="SHORT",Y[Y.MEDIUM=1]="MEDIUM",Y[Y.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var l;(function(Y){Y[Y.EXPLICIT=1]="EXPLICIT",Y[Y.AUTO=2]="AUTO",Y[Y.FOCUS_CHANGE=3]="FOCUS_CHANGE",Y[Y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class ${constructor(){this.a=new Map}registerSource(B,_){let ve=this.a.get(B);return ve||(ve={source:B,label:_},this.a.set(B,ve)),ve.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$3F=new $;var I;(function(Y){Y[Y.None=0]="None",Y[Y.Readonly=2]="Readonly",Y[Y.Untitled=4]="Untitled",Y[Y.Singleton=8]="Singleton",Y[Y.RequiresTrust=16]="RequiresTrust",Y[Y.CanSplitInGroup=32]="CanSplitInGroup",Y[Y.ForceDescription=64]="ForceDescription",Y[Y.CanDropIntoEditor=128]="CanDropIntoEditor",Y[Y.MultipleEditors=256]="MultipleEditors",Y[Y.Scratchpad=512]="Scratchpad"})(I||(e.EditorInputCapabilities=I={}));class D extends T.$Wc{}e.$4F=D;function y(Y){return Y instanceof D}function S(Y){const B=Y;return P.URI.isUri(B?.preferredResource)}function k(Y){const B=Y;return y(B?.primary)&&y(B?.secondary)}function g(Y){const B=Y;return y(B?.modified)&&y(B?.original)}function b(Y,B,_,ve,ae){return Le(ve,[(0,v.$pj)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const we={..._,limits:{size:Number.MAX_VALUE}};Y.openEditor(B,we)}}),(0,v.$pj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>ae.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function L(Y){return y(Y?.editor)}function O(Y){const B=Y;return L(Y)&&B?.group!==void 0}function q(Y){const B=Y;return typeof B?.groupId=="number"&&y(B.editor)}function G(Y){return typeof Y?.groupId=="number"}var W;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.REPLACE=1]="REPLACE",Y[Y.MOVE=2]="MOVE",Y[Y.UNPIN=3]="UNPIN"})(W||(e.EditorCloseContext=W={}));var F;(function(Y){Y[Y.GROUP_ACTIVE=0]="GROUP_ACTIVE",Y[Y.GROUP_INDEX=1]="GROUP_INDEX",Y[Y.GROUP_LABEL=2]="GROUP_LABEL",Y[Y.GROUP_LOCKED=3]="GROUP_LOCKED",Y[Y.EDITORS_SELECTION=4]="EDITORS_SELECTION",Y[Y.EDITOR_OPEN=5]="EDITOR_OPEN",Y[Y.EDITOR_CLOSE=6]="EDITOR_CLOSE",Y[Y.EDITOR_MOVE=7]="EDITOR_MOVE",Y[Y.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Y[Y.EDITOR_LABEL=9]="EDITOR_LABEL",Y[Y.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Y[Y.EDITOR_PIN=11]="EDITOR_PIN",Y[Y.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Y[Y.EDITOR_STICKY=13]="EDITOR_STICKY",Y[Y.EDITOR_DIRTY=14]="EDITOR_DIRTY",Y[Y.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var V;(function(Y){Y[Y.PRIMARY=1]="PRIMARY",Y[Y.SECONDARY=2]="SECONDARY",Y[Y.BOTH=3]="BOTH",Y[Y.ANY=4]="ANY"})(V||(e.SideBySideEditor=V={}));class ce{getOriginalUri(B,_){if(!B)return;if(m(B))return e.$bG.getOriginalUri(B.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:we}=this.a(B);if(ae&&we){if(_?.supportSideBySide===V.BOTH)return{primary:this.getOriginalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(we,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getOriginalUri(ae,{filterByScheme:_.filterByScheme})??this.getOriginalUri(we,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===V.PRIMARY?ae:we}}if(n(B)||s(B)||i(B)||m(B))return;const ve=S(B)?B.preferredResource:B.resource;return!ve||!_||!_.filterByScheme?ve:this.b(ve,_.filterByScheme)}a(B){return k(B)||i(B)?{primary:B.primary,secondary:B.secondary}:g(B)||n(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,_){if(!B)return;if(m(B))return e.$bG.getCanonicalUri(B.result,_);if(_?.supportSideBySide){const{primary:ae,secondary:we}=this.a(B);if(ae&&we){if(_?.supportSideBySide===V.BOTH)return{primary:this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(we,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===V.ANY)return this.getCanonicalUri(ae,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(we,{filterByScheme:_.filterByScheme});B=_.supportSideBySide===V.PRIMARY?ae:we}}if(n(B)||s(B)||i(B)||m(B))return;const ve=B.resource;return!ve||!_||!_.filterByScheme?ve:this.b(ve,_.filterByScheme)}b(B,_){if(Array.isArray(_)){if(_.some(ve=>B.scheme===ve))return B}else if(_===B.scheme)return B}}var ge;(function(Y){Y[Y.UNKNOWN=0]="UNKNOWN",Y[Y.KEYBOARD=1]="KEYBOARD",Y[Y.MOUSE=2]="MOUSE"})(ge||(e.EditorCloseMethod=ge={}));function te(Y,B,_,ve){if(!Y.isSticky(B))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return _===ge.MOUSE||_===ge.KEYBOARD;case"mouse":return _===ge.MOUSE;case"keyboard":return _===ge.KEYBOARD}return!1}e.$bG=new ce;var me;(function(Y){Y[Y.LEFT=0]="LEFT",Y[Y.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class se{constructor(){this.c=new Map,this.d=new Map}start(B){const _=this.a=B.get(A.$Ei);for(const[ve,ae]of this.c)this.e(ve,ae,_);this.c.clear()}e(B,_,ve){const ae=ve.createInstance(_);this.d.set(B,ae)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,C.$qg)(this.b)}registerEditorSerializer(B,_){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,_,this.a):this.c.set(B,_),(0,T.$Uc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}N.$po.add(e.$OF.EditorFactory,new se);async function de(Y,B,_){return!Y||!Y.length?[]:await Promise.all(Y.map(async ve=>{const ae=P.URI.revive(ve.fileUri);if(!ae){_.info("Cannot resolve the path because it is not valid.",ve);return}if(!await B.canHandleResource(ae)){_.info("Cannot resolve the path because it cannot be handled",ve);return}let le=ve.exists,X=ve.type;if(typeof le!="boolean"||typeof X!="number")try{X=(await B.stat(ae)).isDirectory?p.FileType.Directory:p.FileType.Unknown,le=!0}catch(pe){_.error(pe),le=!1}if(!le&&ve.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",ve);return}if(X===p.FileType.Directory){_.info("Cannot resolve the path because it is a directory",ve);return}const Z={...ve.options,pinned:!0};return le?{resource:ae,options:Z}:{resource:ae,options:Z,forceUntitled:!0}}))}var be;(function(Y){Y[Y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Y[Y.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function re(Y){const B=Y;if(!B)return!1;const _=B;if(_.modified)return re(_.modified);const ve=B;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function Pe(Y){return(0,R.$rj)(Y)}function Le(Y,B,_){const ve=(0,R.$sj)(Y,B);return ve.forceMessage=_?.forceMessage,ve.forceSeverity=_?.forceSeverity,ve.allowDialog=_?.allowDialog,ve}}),define(Ce[232],Ie([1,0,4,194,3,5,29,31,26,98,222]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nG=e.$mG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$lG=e.ViewContentGroups=e.$jG=e.ViewContainerLocation=e.Extensions=e.$iG=e.$hG=e.$gG=void 0,e.$kG=E,e.$gG="views",e.$hG=(0,C.localize)(0,null),e.$iG=(0,R.$ux)("default-view-icon",c.$5j.window,(0,C.localize)(1,null));var v;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var u;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$jG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function E(t){switch(t){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class d extends T.$Wc{constructor(){super(...arguments),this.c=this.B(new w.$me),this.onDidRegister=this.c.event,this.f=this.B(new w.$me),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(m,f,l){const $=this.get(m.id);if($)return $;const I=m;return I.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$zc)(this.g,f,[]).push(I),l?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:f}),I}deregisterViewContainer(m){for(const f of this.g.keys()){const l=this.g.get(f),$=l?.indexOf(m);if($!==-1){l?.splice($,1),l.length===0&&this.g.delete(f),this.f.fire({viewContainer:m,viewContainerLocation:f});return}}}get(m){return this.all.filter(f=>f.id===m)[0]}getViewContainers(m){return[...this.g.get(m)||[]]}getViewContainerLocation(m){return[...this.g.keys()].filter(f=>this.getViewContainers(f).filter(l=>l?.id===m.id).length>0)[0]}getDefaultViewContainer(m){return this.h.find(f=>this.getViewContainerLocation(f)===m)}}N.$po.add(v.ViewContainersRegistry,new d);var r;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(t,m){const f=t.group??r.More,l=m.group??r.More;return f!==l?f.localeCompare(l):(t.order??5)-(m.order??5)}class a extends T.$Wc{constructor(){super(...arguments),this.c=this.B(new w.$me),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$me),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$me),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$me),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Jc}registerViews(m,f){this.registerViews2([{views:m,viewContainer:f}])}registerViews2(m){m.forEach(({views:f,viewContainer:l})=>this.r(f,l)),this.c.fire(m)}deregisterViews(m,f){const l=this.s(m,f);l.length&&this.f.fire({views:l,viewContainer:f})}moveViews(m,f){for(const l of this.m.keys())if(l!==f){const $=this.s(m,l);$.length&&(this.r($,f),this.g.fire({views:$,from:l,to:f}))}}getViews(m){return this.m.get(m)||[]}getView(m){for(const f of this.j){const l=(this.m.get(f)||[]).filter($=>$.id===m)[0];if(l)return l}return null}getViewContainer(m){for(const f of this.j)if((this.m.get(f)||[]).filter($=>$.id===m)[0])return f;return null}registerViewWelcomeContent(m,f){return this.n.add(m,f),this.h.fire(m),(0,T.$Uc)(()=>{this.n.delete(m,f),this.h.fire(m)})}registerViewWelcomeContent2(m,f){const l=new Map;for(const[$,I]of f)this.n.add(m,I),l.set($,(0,T.$Uc)(()=>{this.n.delete(m,I),this.h.fire(m)}));return this.h.fire(m),l}getViewWelcomeContent(m){const f=[];return this.n.forEach(m,l=>f.push(l)),f.sort(o)}r(m,f){let l=this.m.get(f);l||(l=[],this.m.set(f,l),this.j.push(f));for(const $ of m){if(this.getView($.id)!==null)throw new Error((0,C.localize)(2,null,$.id));l.push($)}}s(m,f){const l=this.m.get(f);if(!l)return[];const $=[],I=[];for(const D of l)m.includes(D)?$.push(D):I.push(D);return $.length&&(I.length?this.m.set(f,I):(this.m.delete(f),this.j.splice(this.j.indexOf(f),1))),$}}N.$po.add(v.ViewsRegistry,new a),e.$lG=(0,P.$Fi)("viewDescriptorService");var h;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})(h||(e.ViewVisibilityState=h={}));var n;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class s{constructor(m,f){this.c=!1,this.d=!1,(0,p.$fo)(this,m),this.d=!!f,this.resolve=async l=>{if(f&&!this.c){const $=await f(l);$&&(this.tooltip=this.tooltip??$.tooltip,this.command=this.command??$.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$mG=s;class i extends Error{constructor(m){super((0,C.localize)(3,null,m)),this.name="NoTreeViewError"}static is(m){return m.name==="NoTreeViewError"}}e.$nG=i}),define(Ce[233],Ie([1,0,195,32]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=void 0,e.$rG=new C.$Wj("chatSessionResponseVote","",{type:"string",description:(0,w.localize)(0,null)}),e.$sG=new C.$Wj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,w.localize)(1,null)}),e.$tG=new C.$Wj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,w.localize)(2,null)}),e.$uG=new C.$Wj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,w.localize)(3,null)}),e.$vG=new C.$Wj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,w.localize)(4,null)}),e.$wG=new C.$Wj("chatResponse",!1,{type:"boolean",description:(0,w.localize)(5,null)}),e.$xG=new C.$Wj("chatRequest",!1,{type:"boolean",description:(0,w.localize)(6,null)}),e.$yG=new C.$Wj("chatEditApplied",!1,{type:"boolean",description:(0,w.localize)(7,null)}),e.$zG=new C.$Wj("chatInputHasText",!1,{type:"boolean",description:(0,w.localize)(8,null)}),e.$AG=new C.$Wj("chatInputHasFocus",!1,{type:"boolean",description:(0,w.localize)(9,null)}),e.$BG=new C.$Wj("inChatInput",!1,{type:"boolean",description:(0,w.localize)(10,null)}),e.$CG=new C.$Wj("inChat",!1,{type:"boolean",description:(0,w.localize)(11,null)}),e.$DG=new C.$Wj("chatIsEnabled",!1,{type:"boolean",description:(0,w.localize)(12,null)}),e.$EG=new C.$Wj("chatCursorAtTop",!1),e.$FG=new C.$Wj("chatInputHasAgent",!1),e.$GG=new C.$Wj("chatLocation",void 0),e.$HG=new C.$Wj("quickChatHasFocus",!1,{type:"boolean",description:(0,w.localize)(13,null)})}),define(Ce[234],Ie([1,0,324,11,22,4,40,5,49,141,13,32,19,3,12,108,216,227,233]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.ChatAgentLocation=void 0,e.$MH=f,e.$NH=l;var s;(function($){$.Panel="panel",$.Terminal="terminal",$.Notebook="notebook",$.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function($){function I(D){switch(D){case"panel":return $.Panel;case"terminal":return $.Terminal;case"notebook":return $.Notebook;case"editor":return $.Editor}return $.Panel}$.fromRaw=I}(s||(e.ChatAgentLocation=s={})),e.$HH=(0,E.$Fi)("chatAgentService");let i=class{static{this.AGENT_LEADER="@"}constructor(I){this.f=I,this.b=new Map,this.d=new T.$me,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=h.$DG.bindTo(this.f)}registerAgent(I,D){if(this.getAgent(I))throw new Error(`Agent already registered: ${JSON.stringify(I)}`);const S=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(b=>!b.when||S.f.contextMatchesRules(v.$Dj.deserialize(b.when)))}};const g={data:D};return this.b.set(I,g),(0,N.$Uc)(()=>{this.b.delete(I),this.d.fire(void 0)})}registerAgentImplementation(I,D){const y=this.b.get(I);if(!y)throw new Error(`Unknown agent: ${JSON.stringify(I)}`);if(y.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(I)}`);return y.data.isDefault&&this.e.set(!0),y.impl=D,this.d.fire(new t(y.data,D)),(0,N.$Uc)(()=>{y.impl=void 0,this.d.fire(void 0),y.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(I,D){I.isDynamic=!0;const y={data:I,impl:D};return this.b.set(I.id,y),this.d.fire(new t(I,D)),(0,N.$Uc)(()=>{this.b.delete(I.id),this.d.fire(void 0)})}registerAgentCompletionProvider(I,D){return this.g.set(I,D),{dispose:()=>{this.g.delete(I)}}}async getAgentCompletionItems(I,D,y){return await this.g.get(I)?.(D,y)??[]}updateAgent(I,D){const y=this.b.get(I);if(!y?.impl)throw new Error(`No activated agent with id ${JSON.stringify(I)} registered`);y.data.metadata={...y.data.metadata,...D},this.d.fire(new t(y.data,y.impl))}getDefaultAgent(I){return(0,w.$hb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(I))}getContributedDefaultAgent(I){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(I))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),I=>!!I.data.metadata.isSecondary)?.data}getAgent(I){if(this.h(I))return this.b.get(I)?.data}h(I){const D=this.b.get(I);return!D?.data.when||this.f.contextMatchesRules(v.$Dj.deserialize(D.data.when))}getAgentByFullyQualifiedId(I){const D=A.Iterable.find(this.b.values(),y=>f(y.data)===I)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(I=>I.data).filter(I=>this.h(I.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(I=>!!I.impl).filter(I=>this.h(I.data.id)).map(I=>new t(I.data,I.impl))}getAgentsByName(I){return this.getAgents().filter(D=>D.name===I)}agentHasDupeName(I){const D=this.getAgent(I);return D?this.getAgentsByName(D.name).filter(y=>y.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(I,D,y,S,k){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return await g.impl.invoke(D,y,S,k)}async getFollowups(I,D,y,S,k){const g=this.b.get(I);if(!g?.impl)throw new Error(`No activated agent with id "${I}"`);return g.impl?.provideFollowups?g.impl.provideFollowups(D,y,S,k):[]}};e.$IH=i,e.$IH=i=Qe([Ve(0,v.$Xj)],i);class t{constructor(I,D){this.b=I,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(I,D,y,S){return this.d.invoke(I,D,y,S)}async provideFollowups(I,D,y,S){return this.d.provideFollowups?this.d.provideFollowups(I,D,y,S):[]}provideWelcomeMessage(I,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(I,D)}provideSampleQuestions(I,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(I,D)}}e.$JH=t,e.$KH=(0,E.$Fi)("chatAgentNameService");let m=class{static{n=this}static{this.b="chat.participantNameRegistry"}constructor(I,D,y,S){if(this.g=D,this.h=y,this.i=S,this.e=(0,c.$7d)(this,Object.create(null)),this.f=!1,!I.chatParticipantRegistry)return;this.d=I.chatParticipantRegistry;const k=S.get(n.b,a.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{S.remove(n.b,a.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(I=>this.h.warn("Failed to fetch chat participant registry",I)).then(()=>(0,C.$Gh)(5*60*1e3)).then(()=>this.j())}async k(){const I=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(I.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,o.$8p)(I);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const y=D.restrictedChatParticipants;this.e.set(y,void 0),this.i.store(n.b,JSON.stringify(y),a.StorageScope.APPLICATION,a.StorageTarget.MACHINE)}getAgentNameRestriction(I){const D=this.l(I.name,I).get(),y=!I.fullName||this.l(I.fullName.replace(/\s/g,""),I).get();return D&&y}l(I,D){return this.e.map(S=>S[I.toLowerCase()]).map(S=>S?S.some(k=>(0,R.$Gf)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$LH=m,e.$LH=m=n=Qe([Ve(0,r.$sk),Ve(1,o.$2p),Ve(2,d.$_j),Ve(3,a.$cq)],m);function f($){return`${$.extensionId.value}.${$.id}`}function l($){const I="name"in $?$:{...$,name:$.id};return"extensionPublisherId"in I||(I.extensionPublisherId=I.extensionPublisher??""),"extensionDisplayName"in I||(I.extensionDisplayName=""),"extensionId"in I||(I.extensionId=new u.$qn("")),(0,p.$ci)(I)}}),define(Ce[235],Ie([1,0,2,33,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gH=e.$fH=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$dH=T,e.$eH=A;function T(c){return!!c&&typeof c=="object"&&"uri"in c&&c.uri instanceof w.URI&&"version"in c&&typeof c.version=="number"&&"ranges"in c&&Array.isArray(c.ranges)&&c.ranges.every(C.$It.isIRange)}function A(c){return!!c&&typeof c=="object"&&"documents"in c&&Array.isArray(c.documents)&&c.documents.every(T)}var N;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(N||(e.ChatAgentVoteDirection=N={}));var p;(function(c){c[c.Action=1]="Action",c[c.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$fH=(0,P.$Fi)("IChatService"),e.$gH="accessibility.voice.keywordActivation"}),define(Ce[236],Ie([1,0,4,11,197]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_sb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new w.$me,this.o=new w.$me,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(N){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=N}onEvent(N){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=N}onRequest(N){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=N}sendResponse(N){N.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${N.command}`)):this.u("response",N)}sendRequest(N,p,c,R){const v={command:N};if(p&&Object.keys(p).length>0&&(v.arguments=p),this.u("request",v),typeof R=="number"){const u=setTimeout(()=>{clearTimeout(u);const E=this.f.get(v.seq);if(E){this.f.delete(v.seq);const d={type:"response",seq:0,request_seq:v.seq,success:!1,command:N,message:(0,P.localize)(0,null,R,N)};E(d)}},R)}return c&&this.f.set(v.seq,c),v.seq}acceptMessage(N){this.k?this.k(N):(this.m.push(N),this.m.length===1&&this.s())}q(N,p){return N.type!=="event"||p.type!=="event"}async s(){let N;for(;this.m.length;){if((!N||this.q(this.m[0],N))&&await(0,C.$Gh)(0),N=this.m.shift(),!N)return;switch(N.type){case"event":this.j?.(N);break;case"request":this.g?.(N);break;case"response":{const p=N,c=this.f.get(p.request_seq);c&&(this.f.delete(p.request_seq),c(p));break}}}}u(N,p){p.type=N,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const N=new Map;this.f.forEach((p,c)=>N.set(c,p)),await(0,C.$Gh)(500),N.forEach((p,c)=>{p({type:"response",seq:0,request_seq:c,success:!1,command:"canceled",message:"canceled"}),this.f.delete(c)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$_sb=T}),define(Ce[81],Ie([1,0,2,198,32,3]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$yK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$wK=e.MemoryRangeType=e.State=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=void 0,e.$vK=p,e.$xK=R,C=qe(C),e.$jJ="workbench.view.debug",e.$kJ="workbench.debug.variablesView",e.$lJ="workbench.debug.watchExpressionsView",e.$mJ="workbench.debug.callStackView",e.$nJ="workbench.debug.loadedScriptsView",e.$oJ="workbench.debug.breakPointsView",e.$pJ="workbench.debug.disassemblyView",e.$qJ="workbench.panel.repl",e.$rJ="workbench.panel.repl.view",e.$sJ=new P.$Wj("debugType",void 0,{type:"string",description:C.localize(0,null)}),e.$tJ=new P.$Wj("debugConfigurationType",void 0,{type:"string",description:C.localize(1,null)}),e.$uJ=new P.$Wj("debugState","inactive",{type:"string",description:C.localize(2,null)}),e.$vJ="debugUx",e.$wJ=new P.$Wj(e.$vJ,"default",{type:"string",description:C.localize(3,null)}),e.$xJ=new P.$Wj("hasDebugged",!1,{type:"boolean",description:C.localize(4,null)}),e.$yJ=new P.$Wj("inDebugMode",!1,{type:"boolean",description:C.localize(5,null)}),e.$zJ=new P.$Wj("inDebugRepl",!1,{type:"boolean",description:C.localize(6,null)}),e.$AJ=new P.$Wj("breakpointWidgetVisible",!1,{type:"boolean",description:C.localize(7,null)}),e.$BJ=new P.$Wj("inBreakpointWidget",!1,{type:"boolean",description:C.localize(8,null)}),e.$CJ=new P.$Wj("breakpointsFocused",!0,{type:"boolean",description:C.localize(9,null)}),e.$DJ=new P.$Wj("watchExpressionsFocused",!0,{type:"boolean",description:C.localize(10,null)}),e.$EJ=new P.$Wj("watchExpressionsExist",!1,{type:"boolean",description:C.localize(11,null)}),e.$FJ=new P.$Wj("variablesFocused",!0,{type:"boolean",description:C.localize(12,null)}),e.$GJ=new P.$Wj("expressionSelected",!1,{type:"boolean",description:C.localize(13,null)}),e.$HJ=new P.$Wj("breakpointInputFocused",!1,{type:"boolean",description:C.localize(14,null)}),e.$IJ=new P.$Wj("callStackItemType",void 0,{type:"string",description:C.localize(15,null)}),e.$JJ=new P.$Wj("callStackSessionIsAttach",!1,{type:"boolean",description:C.localize(16,null)}),e.$KJ=new P.$Wj("callStackItemStopped",!1,{type:"boolean",description:C.localize(17,null)}),e.$LJ=new P.$Wj("callStackSessionHasOneThread",!1,{type:"boolean",description:C.localize(18,null)}),e.$MJ=new P.$Wj("watchItemType",void 0,{type:"string",description:C.localize(19,null)}),e.$NJ=new P.$Wj("canViewMemory",void 0,{type:"boolean",description:C.localize(20,null)}),e.$OJ=new P.$Wj("breakpointItemType",void 0,{type:"string",description:C.localize(21,null)}),e.$PJ=new P.$Wj("breakpointItemBytes",void 0,{type:"boolean",description:C.localize(22,null)}),e.$QJ=new P.$Wj("breakpointHasModes",!1,{type:"boolean",description:C.localize(23,null)}),e.$RJ=new P.$Wj("breakpointSupportsCondition",!1,{type:"boolean",description:C.localize(24,null)}),e.$SJ=new P.$Wj("loadedScriptsSupported",!1,{type:"boolean",description:C.localize(25,null)}),e.$TJ=new P.$Wj("loadedScriptsItemType",void 0,{type:"string",description:C.localize(26,null)}),e.$UJ=new P.$Wj("focusedSessionIsAttach",!1,{type:"boolean",description:C.localize(27,null)}),e.$VJ=new P.$Wj("focusedSessionIsNoDebug",!1,{type:"boolean",description:C.localize(28,null)}),e.$WJ=new P.$Wj("stepBackSupported",!1,{type:"boolean",description:C.localize(29,null)}),e.$XJ=new P.$Wj("restartFrameSupported",!1,{type:"boolean",description:C.localize(30,null)}),e.$YJ=new P.$Wj("stackFrameSupportsRestart",!1,{type:"boolean",description:C.localize(31,null)}),e.$ZJ=new P.$Wj("jumpToCursorSupported",!1,{type:"boolean",description:C.localize(32,null)}),e.$1J=new P.$Wj("stepIntoTargetsSupported",!1,{type:"boolean",description:C.localize(33,null)}),e.$2J=new P.$Wj("breakpointsExist",!1,{type:"boolean",description:C.localize(34,null)}),e.$3J=new P.$Wj("debuggersAvailable",!1,{type:"boolean",description:C.localize(35,null)}),e.$4J=new P.$Wj("debugExtensionAvailable",!0,{type:"boolean",description:C.localize(36,null)}),e.$5J=new P.$Wj("debugProtocolVariableMenuContext",void 0,{type:"string",description:C.localize(37,null)}),e.$6J=new P.$Wj("debugSetVariableSupported",!1,{type:"boolean",description:C.localize(38,null)}),e.$7J=new P.$Wj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:C.localize(39,null)}),e.$8J=new P.$Wj("debugSetExpressionSupported",!1,{type:"boolean",description:C.localize(40,null)}),e.$9J=new P.$Wj("breakWhenValueChangesSupported",!1,{type:"boolean",description:C.localize(41,null)}),e.$0J=new P.$Wj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:C.localize(42,null)}),e.$$J=new P.$Wj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:C.localize(43,null)}),e.$_J=new P.$Wj("terminateDebuggeeSupported",!1,{type:"boolean",description:C.localize(44,null)}),e.$aK=new P.$Wj("suspendDebuggeeSupported",!1,{type:"boolean",description:C.localize(45,null)}),e.$bK=new P.$Wj("variableEvaluateNamePresent",!1,{type:"boolean",description:C.localize(46,null)}),e.$cK=new P.$Wj("variableIsReadonly",!1,{type:"boolean",description:C.localize(47,null)}),e.$dK=new P.$Wj("variableValue",!1,{type:"string",description:C.localize(48,null)}),e.$eK=new P.$Wj("variableType",!1,{type:"string",description:C.localize(49,null)}),e.$fK=new P.$Wj("variableInterfaces",!1,{type:"array",description:C.localize(50,null)}),e.$gK=new P.$Wj("variableName",!1,{type:"string",description:C.localize(51,null)}),e.$hK=new P.$Wj("variableLanguage",!1,{type:"string",description:C.localize(52,null)}),e.$iK=new P.$Wj("variableExtensionId",!1,{type:"string",description:C.localize(53,null)}),e.$jK=new P.$Wj("exceptionWidgetVisible",!1,{type:"boolean",description:C.localize(54,null)}),e.$kK=new P.$Wj("multiSessionRepl",!1,{type:"boolean",description:C.localize(55,null)}),e.$lK=new P.$Wj("multiSessionDebug",!1,{type:"boolean",description:C.localize(56,null)}),e.$mK=new P.$Wj("disassembleRequestSupported",!1,{type:"boolean",description:C.localize(57,null)}),e.$nK=new P.$Wj("disassemblyViewFocus",!1,{type:"boolean",description:C.localize(58,null)}),e.$oK=new P.$Wj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:C.localize(59,null)}),e.$pK=new P.$Wj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:C.localize(60,null)});const A=n=>C.localize(61,null,n);e.$qK=A,e.$rK="editor.contrib.debug",e.$sK="editor.contrib.breakpoint",e.$tK="debug",e.$uK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:C.localize(62,null)};var N;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(N||(e.State=N={}));function p(n){switch(n){case N.Initializing:return"initializing";case N.Stopped:return"stopped";case N.Running:return"running";default:return"inactive"}}var c;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(c||(e.MemoryRangeType=c={})),e.$wK="vscode-debug-memory";function R(n){const s=n.presentationHint??n.source.presentationHint;return s==="deemphasize"||s==="subtle"}var v;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(v||(e.DataBreakpointSetType=v={}));var u;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var E;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(E||(e.DebuggerString=E={})),e.$yK=(0,T.$Fi)("debugService");var d;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var a;(function(n){n.deserialize=s=>s,n.serialize=s=>s})(a||(e.IDebugVisualizationTreeItem=a={}));var h;(function(n){n.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:w.URI.revive(s.iconPath.light),dark:w.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),n.serialize=s=>s})(h||(e.IDebugVisualization=h={}))}),define(Ce[237],Ie([1,0,13,2,20,26,16,33,22,18]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3H=void 0,e.$QH=v,e.$RH=u,e.$SH=E,e.$TH=d,e.$UH=r,e.$VH=o,e.$WH=a,e.$XH=n,e.$YH=t,e.$ZH=m,e.$1H=l,e.$2H=I;const R=/{([^}]+)}/g;function v(y,S,k){return y.replace(R,function(g,b){return S&&b.length>0&&b[0]!=="_"?g:k&&k.hasOwnProperty(b)?k[b]:g})}function u(y){const S={};for(const k of Object.keys(y))k.startsWith("!")||(S[k]=y[k]);return S}function E(y){return y.configuration.request==="attach"&&!d(y)&&(!y.parentSession||E(y.parentSession))}function d(y){let S=y.configuration.type;if(S)return S==="vslsShare"&&(S=y.configuration.adapterProxy.configuration.type),(0,w.$Gf)(S,"extensionhost")||(0,w.$Gf)(S,"pwa-extensionhost")?y:y.parentSession?d(y.parentSession):void 0}function r(y){return y.type&&(y.label||y.program||y.runtime)}function o(y,S,k){let g,b=0;const L=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let O=null;for(;O=L.exec(y);){const q=O.index+1,G=q+O[0].length;if(q<=S&&G>=k){g=O[0],b=q;break}}if(g){const q=/\w+/g;let G=null;for(;(G=q.exec(g))&&!(G.index+1+b+G[0].length>=k););G&&(g=g.substring(0,q.lastIndex))}return g?{start:b,end:b+g.length-1}:{start:0,end:0}}async function a(y,S,k,g){if(y.evaluatableExpressionProvider.has(S)){const b=y.evaluatableExpressionProvider.ordered(S),L=(0,c.$Jb)(await Promise.all(b.map(async O=>{try{return await O.provideEvaluatableExpression(S,k,g??p.CancellationToken.None)}catch{return}})));if(L.length>0){let O=L[0].expression;const q=L[0].range;return O||(O=S.getLineContent(k.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:O}}}else{const b=S.getLineContent(k.lineNumber),{start:L,end:O}=o(b,k.column,k.column),q=b.substring(L-1,O);return{matchingExpression:q,range:new N.$It(k.lineNumber,L,k.lineNumber,L+q.length)}}return null}const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(y){return!!(y&&y.match(h))}function s(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(n(y.path))return C.URI.parse(y.path);if((0,P.$kc)(y.path))return C.URI.file(y.path)}return y.path}function i(y){if(typeof y.path=="object"){const S=C.URI.revive(y.path);if(S)return S.scheme===A.Schemas.file?S.fsPath:S.toString()}return y.path}function t(y,S){const k=S?s:i,g=(0,T.$co)(y);return f(g,(b,L)=>{b&&L&&(L.path=k(L))}),g}function m(y,S){const k=S?s:i,g=(0,T.$co)(y);return f(g,(b,L)=>{!b&&L&&(L.path=k(L))}),g}function f(y,S){switch(y.type){case"event":{const k=y;switch(k.event){case"output":S(!1,k.body.source);break;case"loadedSource":S(!1,k.body.source);break;case"breakpoint":S(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=y;switch(k.command){case"setBreakpoints":S(!0,k.arguments.source);break;case"breakpointLocations":S(!0,k.arguments.source);break;case"source":S(!0,k.arguments.source);break;case"gotoTargets":S(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(g=>S(!1,g));break;default:break}break}case"response":{const k=y;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(g=>S(!1,g.source));break;case"loadedSources":k.body.sources.forEach(g=>S(!1,g));break;case"scopes":k.body.scopes.forEach(g=>S(!1,g.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(g=>S(!1,g.source));break;case"setBreakpoints":k.body.breakpoints.forEach(g=>S(!1,g.source));break;case"disassemble":k.body?.instructions.forEach(b=>S(!1,b.location));break;default:break}break}}}function l(y){return y.filter(S=>!S.presentation?.hidden).sort((S,k)=>S.presentation?k.presentation?S.presentation.group?k.presentation.group?S.presentation.group!==k.presentation.group?S.presentation.group.localeCompare(k.presentation.group):$(S.presentation.order,k.presentation.order):-1:k.presentation.group?1:$(S.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function $(y,S){return typeof y!="number"?typeof S!="number"?0:1:typeof S!="number"?-1:y-S}async function I(y,S){const k=y.getValue("debug.saveBeforeStart",{overrideIdentifier:S.activeTextEditorLanguageId});if(k!=="none"&&(await S.saveAll(),k==="allEditorsInActiveGroup")){const g=S.activeEditorPane;g&&g.input.resource?.scheme===A.Schemas.untitled&&await S.save({editor:g.input,groupId:g.group.id})}await y.reloadConfiguration()}const D=(y,S)=>!y||!S?y===S:y.name===S.name&&y.path===S.path&&y.sourceReference===S.sourceReference;e.$3H=D}),define(Ce[238],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QK=e.CellExecutionUpdateType=void 0;var C;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(C||(e.CellExecutionUpdateType=C={})),e.$QK=(0,w.$Fi)("INotebookExecutionService")}),define(Ce[239],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UK=e.$TK=e.ProxyKernelState=e.$SK=void 0,e.$SK=100;var C;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(C||(e.ProxyKernelState=C={})),e.$TK=(0,w.$Fi)("INotebookKernelService"),e.$UK=(0,w.$Fi)("INotebookKernelHistoryService")}),define(Ce[240],Ie([1,0,5,33,52,166,102]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VYb=void 0;class N extends w.$Wc{constructor(c,R,v){super(),this._source=c,this.b=R,this.c=v,this.a=void 0}f(c){const R=c.getLineCount();return new C.$It(1,1,R,this.g(c,R))}g(c,R){if(R<1||R>c.getLineCount())throw new Error("Illegal value for lineNumber");return c.getLineLength(R)+1}get inputTextBuffer(){if(!this.b){const c=new T.$jD;c.acceptChunk(this._source);const R=c.finish(!0),{textBuffer:v,disposable:u}=R.create(P.DefaultEndOfLine.LF);this.b=v,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(c=>{const R=new T.$jD;R.acceptChunk(c);const v=R.finish(!0),{textBuffer:u,disposable:E}=v.create(P.DefaultEndOfLine.LF);return this.B(E),u})),this.a}findInInputs(c){const v=new A.$0C(c,!1,!1,null).parseSearchRequest();if(!v)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,v,!0,5e3)}findInOutputs(c){const v=new A.$0C(c,!1,!1,null).parseSearchRequest();return v?this.outputTextBuffers.map(u=>{const E=u.findMatchesLineByLine(this.f(u),v,!0,5e3);if(E.length!==0)return{textBuffer:u,matches:E}}).filter(u=>!!u):[]}}e.$VYb=N}),define(Ce[55],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(T){T.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var C;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class P{static fromExtHostTestItem(A,N,p=A.parent){if(A._isRoot)return new P([N]);const c=[A.id];for(let R=p;R&&R.id!==N;R=R.parent)c.push(R.id);return c.push(N),new P(c.reverse())}static isRoot(A){return!A.includes(w.Delimiter)}static root(A){const N=A.indexOf(w.Delimiter);return N===-1?A:A.slice(0,N)}static fromString(A){return new P(A.split(w.Delimiter))}static join(A,N){return new P([...A.path,N])}static joinToString(A,N){return A.toString()+w.Delimiter+N}static parentId(A){const N=A.lastIndexOf(w.Delimiter);return N===-1?void 0:A.slice(0,N)}static localId(A){const N=A.lastIndexOf(w.Delimiter);return N===-1?A:A.slice(N+w.Delimiter.length)}static isChild(A,N){return N.startsWith(A)&&N[A.length]===w.Delimiter}static compare(A,N){return A===N?C.IsSame:P.isChild(A,N)?C.IsChild:P.isChild(N,A)?C.IsParent:C.Disconnected}static getLengthOfCommonPrefix(A,N){if(A===0)return 0;let p=0;for(;p<A-1;){for(let c=1;c<A;c++){const R=N(c-1),v=N(c);if(R.path[p]!==v.path[p])return p}p++}return p}constructor(A,N=A.length){if(this.path=A,this.d=N,A.length===0||N<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let N=0;N<A.d&&N<this.d;N++)if(A.path[N]!==this.path[N])return C.Disconnected;return A.d>this.d?C.IsChild:A.d<this.d?C.IsParent:C.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=w.Delimiter,this.c+=this.path[A]}return this.c}}e.$PI=P}),define(Ce[56],Ie([1,0,2,101,33,55]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YI=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$XI=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$WI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$VI=e.$UI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$TI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$SI=e.$RI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$QI=e.TestResultState=void 0;var A;(function(W){W[W.Unset=0]="Unset",W[W.Queued=1]="Queued",W[W.Running=2]="Running",W[W.Passed=3]="Passed",W[W.Failed=4]="Failed",W[W.Skipped=5]="Skipped",W[W.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$QI={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var N;(function(W){W[W.Run=1]="Run",W[W.Debug=2]="Debug",W[W.Coverage=3]="Coverage"})(N||(e.ExtTestRunProfileKind=N={}));var p;(function(W){W[W.Run=2]="Run",W[W.Debug=4]="Debug",W[W.Coverage=8]="Coverage",W[W.HasNonDefaultProfile=16]="HasNonDefaultProfile",W[W.HasConfigurable=32]="HasConfigurable",W[W.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$RI=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const c=W=>"runId"in W;e.$SI=c;var R;(function(W){W.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),W.deserialize=(F,V)=>({range:P.$It.lift(V.range),uri:F.asCanonicalUri(w.URI.revive(V.uri))})})(R||(e.IRichLocation=R={}));var v;(function(W){W[W.Error=0]="Error",W[W.Output=1]="Output"})(v||(e.TestMessageType=v={}));var u;(function(W){W.serialize=F=>({message:F.message,type:v.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&R.serialize(F.location)}),W.deserialize=(F,V)=>({message:V.message,type:v.Error,expected:V.expected,actual:V.actual,contextValue:V.contextValue,location:V.location&&R.deserialize(F,V.location)})})(u||(e.ITestErrorMessage=u={}));const E=(W,F)=>`${F?"s":"e"}${W}`;e.$TI=E;var d;(function(W){W.serialize=F=>({message:F.message,type:v.Output,offset:F.offset,length:F.length,location:F.location&&R.serialize(F.location)}),W.deserialize=(F,V)=>({message:V.message,type:v.Output,offset:V.offset,length:V.length,location:V.location&&R.deserialize(F,V.location)})})(d||(e.ITestOutputMessage=d={}));var r;(function(W){W.serialize=F=>F.type===v.Error?u.serialize(F):d.serialize(F),W.deserialize=(F,V)=>V.type===v.Error?u.deserialize(F,V):d.deserialize(F,V)})(r||(e.ITestMessage=r={}));var o;(function(W){W.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),W.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(r.serialize)}),W.deserialize=(F,V)=>({state:V.state,duration:V.duration,messages:V.messages.map(ce=>r.deserialize(F,ce))})})(o||(e.ITestTaskState=o={}));const a="\0",h=(W,F)=>W+a+F;e.$UI=h;const n=W=>{const F=W.indexOf(a);return{ctrlId:W.slice(0,F),tagId:W.slice(F+1)}};e.$VI=n;var s;(function(W){W.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),W.deserialize=(F,V)=>({extId:V.extId,label:V.label,tags:V.tags,busy:V.busy,children:void 0,uri:V.uri?F.asCanonicalUri(w.URI.revive(V.uri)):void 0,range:V.range?P.$It.lift(V.range):null,description:V.description,error:V.error,sortText:V.sortText})})(s||(e.ITestItem=s={}));var i;(function(W){W[W.NotExpandable=0]="NotExpandable",W[W.Expandable=1]="Expandable",W[W.BusyExpanding=2]="BusyExpanding",W[W.Expanded=3]="Expanded"})(i||(e.TestItemExpandState=i={}));var t;(function(W){W.serialize=F=>({expand:F.expand,item:s.serialize(F.item)}),W.deserialize=(F,V)=>({controllerId:T.$PI.root(V.item.extId),expand:V.expand,item:s.deserialize(F,V.item)})})(t||(e.InternalTestItem=t={}));var m;(function(W){W.serialize=F=>{let V;return F.item&&(V={},F.item.label!==void 0&&(V.label=F.item.label),F.item.tags!==void 0&&(V.tags=F.item.tags),F.item.busy!==void 0&&(V.busy=F.item.busy),F.item.uri!==void 0&&(V.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(V.range=F.item.range?.toJSON()),F.item.description!==void 0&&(V.description=F.item.description),F.item.error!==void 0&&(V.error=F.item.error),F.item.sortText!==void 0&&(V.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:V}},W.deserialize=F=>{let V;return F.item&&(V={},F.item.label!==void 0&&(V.label=F.item.label),F.item.tags!==void 0&&(V.tags=F.item.tags),F.item.busy!==void 0&&(V.busy=F.item.busy),F.item.range!==void 0&&(V.range=F.item.range?P.$It.lift(F.item.range):null),F.item.description!==void 0&&(V.description=F.item.description),F.item.error!==void 0&&(V.error=F.item.error),F.item.sortText!==void 0&&(V.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:V}}})(m||(e.ITestItemUpdate=m={}));const f=(W,F)=>{F.expand!==void 0&&(W.expand=F.expand),F.item!==void 0&&(W.item=W.item?Object.assign(W.item,F.item):F.item)};e.$WI=f;var l;(function(W){W.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(o.serializeWithoutMessages)}),W.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(o.serialize)}),W.deserialize=(F,V)=>({...t.deserialize(F,V),ownComputedState:V.ownComputedState,computedState:V.computedState,tasks:V.tasks.map(ce=>o.deserialize(F,ce)),retired:!0})})(l||(e.TestResultItem=l={}));var $;(function(W){W.empty=()=>({covered:0,total:0}),W.sum=(F,V)=>{F.covered+=V.covered,F.total+=V.total}})($||(e.ICoverageCount=$={}));var I;(function(W){W.serialize=F=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testIds:F.testIds,uri:F.uri.toJSON()}),W.deserialize=(F,V)=>({id:V.id,statement:V.statement,branch:V.branch,declaration:V.declaration,testIds:V.testIds,uri:F.asCanonicalUri(w.URI.revive(V.uri))}),W.empty=(F,V)=>({id:F,uri:V,statement:$.empty()})})(I||(e.IFileCoverage=I={}));function D(W){return{...W,location:W.location?.toJSON()}}function y(W){return W.location=W.location?C.$Ht.isIPosition(W.location)?C.$Ht.lift(W.location):P.$It.lift(W.location):void 0,W}e.$XI=3;var S;(function(W){W[W.Declaration=0]="Declaration",W[W.Statement=1]="Statement",W[W.Branch=2]="Branch"})(S||(e.DetailType=S={}));var k;(function(W){W.serialize=F=>F.type===S.Declaration?b.serialize(F):L.serialize(F),W.deserialize=F=>F.type===S.Declaration?b.deserialize(F):L.deserialize(F)})(k||(e.CoverageDetails=k={}));var g;(function(W){W.serialize=D,W.deserialize=y})(g||(e.IBranchCoverage=g={}));var b;(function(W){W.serialize=D,W.deserialize=y})(b||(e.IDeclarationCoverage=b={}));var L;(function(W){W.serialize=F=>({...D(F),branches:F.branches?.map(g.serialize)}),W.deserialize=F=>({...y(F),branches:F.branches?.map(g.deserialize)})})(L||(e.IStatementCoverage=L={}));var O;(function(W){W[W.Add=0]="Add",W[W.Update=1]="Update",W[W.DocumentSynced=2]="DocumentSynced",W[W.Remove=3]="Remove",W[W.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",W[W.Retire=5]="Retire",W[W.AddTag=6]="AddTag",W[W.RemoveTag=7]="RemoveTag"})(O||(e.TestDiffOpType=O={}));var q;(function(W){W.deserialize=(F,V)=>V.op===O.Add?{op:V.op,item:t.deserialize(F,V.item)}:V.op===O.Update?{op:V.op,item:m.deserialize(V.item)}:V.op===O.DocumentSynced?{op:V.op,uri:F.asCanonicalUri(w.URI.revive(V.uri)),docv:V.docv}:V,W.serialize=F=>F.op===O.Add?{op:F.op,item:t.serialize(F.item)}:F.op===O.Update?{op:F.op,item:m.serialize(F.item)}:F})(q||(e.TestsDiffOp=q={}));class G{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const V=this.w();for(const ce of F)switch(ce.op){case O.Add:this.l(t.deserialize(this.k,ce.item),V);break;case O.Update:this.p(m.deserialize(ce.item),V);break;case O.Remove:this.q(ce.itemId,V);break;case O.Retire:this.v(ce.itemId);break;case O.IncrementPendingExtHosts:this.updatePendingRoots(ce.amount);break;case O.AddTag:this.c.set(ce.tag.id,ce.tag);break;case O.RemoveTag:this.c.delete(ce.id);break}V.complete?.()}l(F,V){const ce=T.$PI.parentId(F.item.extId)?.toString();let ge;if(!ce)ge=this.x(F),this.g.add(ge),this.f.set(F.item.extId,ge);else if(this.f.has(ce)){const te=this.f.get(ce);te.children.add(F.item.extId),ge=this.x(F,te),this.f.set(F.item.extId,ge)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return V.add?.(ge),F.expand===i.BusyExpanding&&this.h++,ge}p(F,V){const ce=this.f.get(F.extId);if(ce)return F.expand!==void 0&&(ce.expand===i.BusyExpanding&&this.h--,F.expand===i.BusyExpanding&&this.h++),(0,e.$WI)(ce,F),V.update?.(ce),ce}q(F,V){const ce=this.f.get(F);if(!ce)return;const ge=T.$PI.parentId(ce.item.extId)?.toString();ge?this.f.get(ge).children.delete(ce.item.extId):this.g.delete(ce);const te=[[F]];for(;te.length;)for(const me of te.pop()){const se=this.f.get(me);se&&(te.push(se.children),this.f.delete(me),V.remove?.(se,se!==ce),se.expand===i.BusyExpanding&&this.h--)}}v(F){}updatePendingRoots(F){this.j+=F}w(){return{}}}e.$YI=G}),define(Ce[241],Ie([1,0,99,201,56]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$PFb=e.$OFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(v){v.ViewletId="workbench.view.extension.test",v.ExplorerViewId="workbench.view.testing",v.OutputPeekContributionId="editor.contrib.testingOutputPeek",v.DecorationsContributionId="editor.contrib.testingDecorations",v.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",v.CoverageViewId="workbench.view.testCoverage",v.ResultsPanelId="workbench.panel.testResults",v.ResultsViewId="workbench.panel.testResults.view",v.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var A;(function(v){v.List="list",v.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var N;(function(v){v.ByLocation="location",v.ByStatus="status",v.ByDuration="duration"})(N||(e.TestExplorerViewSorting=N={}));const p={[P.TestResultState.Errored]:(0,C.localize)(0,null),[P.TestResultState.Failed]:(0,C.localize)(1,null),[P.TestResultState.Passed]:(0,C.localize)(2,null),[P.TestResultState.Queued]:(0,C.localize)(3,null),[P.TestResultState.Running]:(0,C.localize)(4,null),[P.TestResultState.Skipped]:(0,C.localize)(5,null),[P.TestResultState.Unset]:(0,C.localize)(6,null)},c=(v,u)=>(0,C.localize)(7,null,(0,w.$Yk)(v),p[u]);e.$OFb=c,e.$PFb={[P.TestRunProfileBitset.Debug]:(0,C.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,C.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,C.localize)(10,null)};var R;(function(v){v.CancelTestRefreshAction="testing.cancelTestRefresh",v.CancelTestRunAction="testing.cancelRun",v.ClearTestResultsAction="testing.clearTestResults",v.CollapseAllAction="testing.collapseAll",v.ConfigureTestProfilesAction="testing.configureProfile",v.ContinousRunUsingForTest="testing.continuousRunUsingForTest",v.CoverageAtCursor="testing.coverageAtCursor",v.CoverageByUri="testing.coverage.uri",v.CoverageClear="testing.coverage.close",v.CoverageCurrentFile="testing.coverageCurrentFile",v.CoverageFilterToTest="testing.coverageFilterToTest",v.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",v.CoverageLastRun="testing.coverageLastRun",v.CoverageSelectedAction="testing.coverageSelected",v.CoverageToggleToolbar="testing.coverageToggleToolbar",v.CoverageViewChangeSorting="testing.coverageViewChangeSorting",v.DebugAction="testing.debug",v.DebugAllAction="testing.debugAll",v.DebugAtCursor="testing.debugAtCursor",v.DebugByUri="testing.debug.uri",v.DebugCurrentFile="testing.debugCurrentFile",v.DebugFailedTests="testing.debugFailTests",v.DebugLastRun="testing.debugLastRun",v.DebugSelectedAction="testing.debugSelected",v.FilterAction="workbench.actions.treeView.testExplorer.filter",v.GetExplorerSelection="_testing.getExplorerSelection",v.GetSelectedProfiles="testing.getSelectedProfiles",v.GoToTest="testing.editFocusedTest",v.HideTestAction="testing.hideTest",v.OpenCoverage="testing.openCoverage",v.OpenOutputPeek="testing.openOutputPeek",v.RefreshTestsAction="testing.refreshTests",v.ReRunFailedTests="testing.reRunFailTests",v.ReRunLastRun="testing.reRunLastRun",v.RunAction="testing.run",v.RunAllAction="testing.runAll",v.RunAllWithCoverageAction="testing.coverageAll",v.RunAtCursor="testing.runAtCursor",v.RunByUri="testing.run.uri",v.RunCurrentFile="testing.runCurrentFile",v.RunSelectedAction="testing.runSelected",v.RunUsingProfileAction="testing.runUsing",v.RunWithCoverageAction="testing.coverage",v.SearchForTestExtension="testing.searchForTestExtension",v.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",v.ShowMostRecentOutputAction="testing.showMostRecentOutput",v.StartContinousRun="testing.startContinuousRun",v.StopContinousRun="testing.stopContinuousRun",v.TestingSortByDurationAction="testing.sortByDuration",v.TestingSortByLocationAction="testing.sortByLocation",v.TestingSortByStatusAction="testing.sortByStatus",v.TestingViewAsListAction="testing.viewAsList",v.TestingViewAsTreeAction="testing.viewAsTree",v.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",v.ToggleInlineTestOutput="testing.toggleInlineTestOutput",v.UnhideAllTestsAction="testing.unhideAllTests",v.UnhideTestAction="testing.unhideTest"})(R||(e.TestCommandId=R={}))}),define(Ce[82],Ie([1,0,11,4,5,62,56,55]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.TestItemEventOp=void 0;var p;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const c=(h,n)=>h===n,v=Object.entries({range:(h,n)=>h===n?!0:!h||!n?!1:h.equalsRange(n),busy:c,label:c,description:c,error:c,sortText:c,tags:(h,n)=>!(h.length!==n.length||h.some(s=>!n.includes(s)))}),u=(h,n)=>{let s;for(const[i,t]of v)t(h[i],n[i])||(s?s[i]=n[i]:s={[i]:n[i]});return s};class E extends P.$Wc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new w.$Rh(()=>this.flushDiff(),200)),this.g=this.B(new C.$me),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===n.uri){s.docv=n.docv;return}break}case A.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===n.item.extId){(0,A.$WI)(s.item,n.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===n.item.extId){(0,A.$WI)(s.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,s){const i=this.tree.get(n);if(i){if((i.expandLevels===void 0||s>i.expandLevels)&&(i.expandLevels=s),i.expand===A.TestItemExpandState.Expandable){const t=this.M(i);return t.isOpen()?this.L(i,s-1):t.wait().then(()=>this.L(i,s-1))}else if(i.expand===A.TestItemExpandState.Expanded)return i.resolveBarrier?.isOpen()===!1?i.resolveBarrier.wait().then(()=>this.L(i,s-1)):this.L(i,s-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,s){switch(s.op){case p.RemoveChild:this.O(N.$PI.joinToString(n.fullId,s.id));break;case p.Upsert:this.z(s.item,n);break;case p.Bulk:for(const i of s.ops)this.w(n,i);break;case p.SetTags:this.C(s.new,s.old,n.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(n);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n.fullId.toString(),item:s.update}});break;case p.DocumentSynced:this.y(n.actual.uri);break;default:(0,T.$gd)(s)}}y(n){n&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,s){const i=N.$PI.fromExtHostTestItem(n,this.root.id,s?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==s?.actual&&this.s.getChildren(t.parent).delete(n.id);let m=this.tree.get(i.toString());if(!m){m={fullId:i,actual:n,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},n.tags.forEach(this.D,this),this.tree.set(m.fullId.toString(),m),this.G(n,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:m.expand,item:this.s.toITestItem(n)}}),this.I(n,m,s);return}if(m.actual===n){this.H(n,m,s);return}if(m.actual.uri?.toString()!==n.uri?.toString())return this.O(i.toString()),this.z(n,s);const f=this.s.getChildren(m.actual),l=m.actual,$=u(this.s.toITestItem(l),this.s.toITestItem(n));this.s.getApiFor(l).listener=void 0,m.actual=n,m.resolveBarrier=void 0,m.expand=A.TestItemExpandState.NotExpandable,$&&($.hasOwnProperty("tags")&&(this.C(n.tags,l.tags,i.toString()),delete $.tags),this.w(m,{op:p.SetProp,update:$})),this.I(n,m,s);for(const[D,y]of f)this.s.getChildren(n).get(y.id)||this.O(N.$PI.joinToString(i,y.id));const I=m.expandLevels;I!==void 0&&queueMicrotask(()=>{m.expand===A.TestItemExpandState.Expandable&&(m.expandLevels=void 0,this.expand(i.toString(),I))}),this.y(m.actual.uri)}C(n,s,i){const t=new Set(s.map(m=>m.id));for(const m of n)t.delete(m.id)||this.D(m);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i,item:{tags:n.map(m=>(0,A.$UI)(this.s.controllerId,m.id))}}}),t.forEach(this.F,this)}D(n){const s=this.j.get(n.id);s?s.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$UI)(this.s.controllerId,n.id)}}))}F(n){const s=this.j.get(n);s&&!--s.refCount&&(this.j.delete(n),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$UI)(this.s.controllerId,n)}))}G(n,s){this.s.getApiFor(n).parent=s&&s.actual!==this.root?s.actual:void 0}H(n,s,i){this.G(n,i);const t=this.s.getApiFor(n);t.parent=i?.actual,t.listener=m=>this.w(s,m),this.J(s)}I(n,s,i){this.H(n,s,i);for(const[t,m]of this.s.getChildren(n))this.z(m,s)}J(n){let s;this.h?n.resolveBarrier?s=n.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=n.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==n.expand&&(n.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&n.expandLevels!==void 0&&this.M(n))}L(n,s){if(s<0)return;const i=[];for(const[t,m]of this.s.getChildren(n.actual)){const f=this.expand(N.$PI.joinToString(n.fullId,m.id),s);(0,w.$rh)(f)&&i.push(f)}if(i.length)return Promise.all(i).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const m=new w.$Eh;return m.open(),m}n.expand=A.TestItemExpandState.BusyExpanding,this.N(n);const s=n.resolveBarrier=new w.$Eh,i=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,m)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(m){i(m)}return(0,w.$rh)(t)?t.catch(i).then(()=>{s.open(),this.J(n)}):(s.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const s=this.tree.get(n);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:n});const i=[s];for(;i.length;){const t=i.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const m of t.actual.tags)this.F(m.id);this.tree.delete(t.fullId.toString());for(const[m,f]of this.s.getChildren(t.actual))i.push(this.tree.get(N.$PI.joinToString(t.fullId,f.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$MP=E;class d extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$NP=d;class r extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$OP=r;class o extends Error{constructor(n,s,i){super(`TestItem with ID "${n}" is from controller "${s}" and cannot be added as a child of an item from controller "${i}".`)}}e.$PP=o;const a=(h,n,s)=>{let i=new Map;return{get size(){return i.size},forEach(t,m){for(const f of i.values())t.call(m,f,this)},[Symbol.iterator](){return i.entries()},replace(t){const m=new Map,f=new Set(i.keys()),l={op:p.Bulk,ops:[]};for(const $ of t){if(!($ instanceof s))throw new r($.id);const I=n($).controllerId;if(I!==h.controllerId)throw new o($.id,I,h.controllerId);if(m.has($.id))throw new d($.id);m.set($.id,$),f.delete($.id),l.ops.push({op:p.Upsert,item:$})}for(const $ of f.keys())l.ops.push({op:p.RemoveChild,id:$});h.listener?.(l),i=m},add(t){if(!(t instanceof s))throw new r(t.id);i.set(t.id,t),h.listener?.({op:p.Upsert,item:t})},delete(t){i.delete(t)&&h.listener?.({op:p.RemoveChild,id:t})},get(t){return i.get(t)},toJSON(){return Array.from(i.values())}}};e.$QP=a}),define(Ce[115],Ie([1,0,82]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=e.$RP=void 0;const C=new WeakMap,P=(A,N)=>{const p={controllerId:N};return C.set(A,p),p};e.$RP=P;const T=A=>{const N=C.get(A);if(!N)throw new w.$OP(A?.id||"<unknown>");return N};e.$SP=T}),define(Ce[83],Ie([1,0,28,16,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ECb=e.$DCb=e.$CCb=void 0,e.$FCb=T,e.$GCb=N,e.$CCb="vscode-cdn.net",e.$DCb=`vscode-resource.${e.$CCb}`,e.$ECb=`'self' https://*.${e.$CCb}`;function T(p,c){return p.scheme===C.Schemas.http||p.scheme===C.Schemas.https?p:(c&&c.authority&&c.isRemote&&p.scheme===C.Schemas.file&&(p=P.URI.from({scheme:C.Schemas.vscodeRemote,authority:c.authority,path:p.path})),P.URI.from({scheme:C.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$DCb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,c=>{const R=c.charCodeAt(0);return R>=w.CharCode.a&&R<=w.CharCode.z||R>=w.CharCode.A&&R<=w.CharCode.Z||R>=w.CharCode.Digit0&&R<=w.CharCode.Digit9?c:"-"+R.toString(16).padStart(4,"0")})}function N(p){return p.replace(/-([0-9a-f]{4})/g,(c,R)=>String.fromCharCode(parseInt(R,16)))}}),define(Ce[242],Ie([1,0,4,5,83]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=void 0;class T{constructor(N,p,c){this.d=N,this.e=p,this.f=c,this.a=0,this.b=new C.$Vc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const R=p.getVisibleTextEditors();for(const v of this.c.values())R.indexOf(v.editor)<0&&v.inset.dispose()}))}dispose(){this.c.forEach(N=>N.inset.dispose()),this.b.dispose()}createWebviewEditorInset(N,p,c,R,v){let u;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===N){u=n;break}if(!u)throw new Error("not a visible editor");const E=this,d=this.a++,r=new w.$me,o=new w.$me,a=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,P.$FCb)(n,E.f)}get cspSource(){return P.$ECb}set options(n){this.b=n,E.d.$setOptions(d,n)}get options(){return this.b}set html(n){this.a=n,E.d.$setHtml(d,n)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(n){return E.d.$postMessage(d,n)}},h=new class{constructor(){this.editor=N,this.line=p,this.height=c,this.webview=a,this.onDidDispose=o.event}dispose(){E.c.has(d)&&(E.c.delete(d),E.d.$disposeEditorInset(d),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(d,u.id,u.value.document.uri,p+1,c,R||{},v.identifier,v.extensionLocation),this.c.set(d,{editor:N,inset:h,onDidReceiveMessage:r}),h}$onDidDispose(N){const p=this.c.get(N);p&&p.inset.dispose()}$onDidReceiveMessage(N,p){this.c.get(N)?.onDidReceiveMessage.fire(p)}}e.$Rnc=T}),define(Ce[116],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uM=e.$tM=e.$sM=void 0,e.$sM="__",e.$tM=(0,w.$Fi)("IAuthenticationService"),e.$uM=(0,w.$Fi)("IAuthenticationExtensionsService")}),define(Ce[243],Ie([1,0,3]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LQ=e.VariableKind=e.$KQ=void 0,e.$KQ=(0,w.$Fi)("configurationResolverService");var C;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class P extends Error{constructor(A,N){super(N),this.variable=A}}e.$LQ=P}),define(Ce[244],Ie([1,0,20,79,15,26,21,103,202,243,13]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Q=void 0,w=qe(w),C=qe(C),P=qe(P),T=qe(T);class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,d,r,o){this.h=new Map,this.a=E,this.b=d,this.g=r,o&&(this.c=o.then(a=>this.i(a)))}i(E){if(A.$i){const d=Object.create(null);return Object.keys(E).forEach(r=>{d[r.toLowerCase()]=E[r]}),d}return E}resolveWithEnvironment(E,d,r){return this.l({env:this.i(E),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(E,d){const r={env:await this.c,userHome:await this.g};return this.l(r,E?E.uri:void 0,d)}async j(E,d,r,o){const a=T.$co(d);A.$i&&a.windows?Object.keys(a.windows).forEach(n=>a[n]=a.windows[n]):A.$j&&a.osx?Object.keys(a.osx).forEach(n=>a[n]=a.osx[n]):A.$k&&a.linux&&Object.keys(a.linux).forEach(n=>a[n]=a.linux[n]),delete a.windows,delete a.osx,delete a.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,E?E.uri:void 0,a,r,o)}async resolveAnyAsync(E,d,r){return this.j(E,d,r)}async resolveAnyMap(E,d,r){const o=new Map;return{newConfig:await this.j(E,d,r,o),resolvedVariables:o}}resolveWithInteractionReplace(E,d,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,d,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,d){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,d)}async l(E,d,r,o,a){if(P.$fg(r))return this.m(E,d,r,o,a);if(Array.isArray(r))return Promise.all(r.map(h=>this.l(E,d,h,o,a)));if(P.$hg(r)){const h=Object.create(null),n=await Promise.all(Object.keys(r).map(async s=>[await this.m(E,d,s,o,a),await this.l(E,d,r[s],o,a)]));for(const[s,i]of n)h[s]=i;return h}return r}m(E,d,r,o,a){return(0,R.$yf)(r,v.VARIABLE_REGEXP,async(h,n)=>{if(n.includes(v.VARIABLE_LHS))return h;let s=await this.o(E,h,n,d,o);return a?.set(n,s),s!==h&&P.$fg(s)&&s.match(v.VARIABLE_REGEXP)&&(s=await this.m(E,d,s,o,a)),s})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,d,r,o,a){let h;const n=r.split(":");n.length>1&&(r=n[0],h=n[1]);const s=m=>{const f=this.a.getFilePath();if(f)return(0,N.$Tw)(f);throw new c.$LQ(m,(0,p.localize)(0,null,d))},i=m=>{const f=s(m);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,N.$Tw)(l)}throw new c.$LQ(m,(0,p.localize)(1,null,d,w.$pc(f)))},t=m=>{if(h){const f=this.a.getFolderUri(h);if(f)return f;throw new c.$LQ(m,(0,p.localize)(2,null,d,h))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new c.$LQ(m,(0,p.localize)(3,null,d)):new c.$LQ(m,(0,p.localize)(4,null,d))};switch(r){case"env":if(h){if(E.env){const m=E.env[A.$i?h.toLowerCase():h];if(P.$fg(m))return m}return""}throw new c.$LQ(c.VariableKind.Env,(0,p.localize)(5,null,d));case"config":if(h){const m=this.a.getConfigurationValue(o,h);if(P.$og(m))throw new c.$LQ(c.VariableKind.Config,(0,p.localize)(6,null,d,h));if(P.$hg(m))throw new c.$LQ(c.VariableKind.Config,(0,p.localize)(7,null,d,h));return m}throw new c.$LQ(c.VariableKind.Config,(0,p.localize)(8,null,d));case"command":return this.p(c.VariableKind.Command,d,h,a,"command");case"input":return this.p(c.VariableKind.Input,d,h,a,"input");case"extensionInstallFolder":if(h){const m=await this.a.getExtension(h);if(!m)throw new c.$LQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,d,h));return this.n(m.extensionLocation)}throw new c.$LQ(c.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,N.$Tw)(this.n(t(c.VariableKind.WorkspaceFolder)));case"cwd":return o||h?(0,N.$Tw)(this.n(t(c.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,N.$Tw)(w.$pc(this.n(t(c.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new c.$LQ(c.VariableKind.UserHome,(0,p.localize)(11,null,d))}case"lineNumber":{const m=this.a.getLineNumber();if(m)return m;throw new c.$LQ(c.VariableKind.LineNumber,(0,p.localize)(12,null,d))}case"selectedText":{const m=this.a.getSelectedText();if(m)return m;throw new c.$LQ(c.VariableKind.SelectedText,(0,p.localize)(13,null,d))}case"file":return s(c.VariableKind.File);case"fileWorkspaceFolder":return i(c.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return w.$pc(i(c.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||h?w.$nc(this.n(t(c.VariableKind.RelativeFile)),s(c.VariableKind.RelativeFile)):s(c.VariableKind.RelativeFile);case"relativeFileDirname":{const m=w.$oc(s(c.VariableKind.RelativeFileDirname));if(o||h){const f=w.$nc(this.n(t(c.VariableKind.RelativeFileDirname)),m);return f.length===0?".":f}return m}case"fileDirname":return w.$oc(s(c.VariableKind.FileDirname));case"fileExtname":return w.$qc(s(c.VariableKind.FileExtname));case"fileBasename":return w.$pc(s(c.VariableKind.FileBasename));case"fileBasenameNoExtension":{const m=w.$pc(s(c.VariableKind.FileBasenameNoExtension));return m.slice(0,m.length-w.$qc(m).length)}case"fileDirnameBasename":return w.$pc(w.$oc(s(c.VariableKind.FileDirnameBasename)));case"execPath":{const m=this.a.getExecPath();return m||d}case"execInstallFolder":{const m=this.a.getAppRoot();return m||d}case"pathSeparator":case"/":return w.sep;default:try{const m=h?`${r}:${h}`:r;return this.p(c.VariableKind.Unknown,d,m,a,void 0)}catch{return d}}}}p(E,d,r,o,a){if(r&&o){const h=a===void 0?o[r]:o[a+":"+r];if(typeof h=="string")return h;throw new c.$LQ(E,(0,p.localize)(14,null,d))}return d}}e.$1Q=v}),define(Ce[117],Ie([1,0,3,114]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$gE=void 0,e.$hE=c,e.$iE=u,e.$jE=E,e.$gE=(0,w.$Fi)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var T;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var N;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(N||(e.GroupsArrangement=N={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function c(d){const r=d;return(0,C.$5F)(r?.editor)&&(0,C.$5F)(r?.replacement)}var R;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var v;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function u(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function E(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ce[245],Ie([1,0,3,117]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nE=e.$mE=e.$lE=e.$kE=void 0,e.$oE=P,e.$kE=(0,w.$Fi)("editorService"),e.$lE=-1,e.$mE=-2,e.$nE=-3;function P(T){const A=T;return typeof T=="number"||(0,C.$iE)(A)}}),define(Ce[246],Ie([1,0,3,106]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=void 0,e.$NM=(0,w.$Gi)(C.$Mi)}),define(Ce[118],Ie([1,0,19,4,20,5,11]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=e.$6bc=e.$5bc=e.$4bc=void 0,P=qe(P);class N{constructor(h,n){this.versionId=h,this.removedDueToLooping=n}}e.$4bc=N;class p{static isHostExtension(h,n,s){if(n.getExtensionDescription(h))return!1;const i=s.getExtensionDescription(h);return i?!!((i.main||i.browser)&&i.api==="none"):!1}constructor(h,n){this.j=h,this.c=new C.$me,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(r),this.f=new w.$sn,this.g=[],this.h=new Map;for(const h of this.e){if(this.f.has(h.identifier)){console.error("Extension `"+h.identifier.value+"` is already registered");continue}this.f.set(h.identifier,h),this.g.push(h);const n=this.j.readActivationEvents(h);for(const s of n)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(h)}}set(h){return this.e=h,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(h,n){this.e=o(this.e,n),this.e=this.e.concat(h);const s=p.l(this.e);return this.e=o(this.e,s.map(i=>i.identifier)),this.k(),this.d++,this.c.fire(void 0),new N(this.d,s)}static l(h){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(f){this.d.has(f)||(this.d.add(f),this.e.push(f))}addArc(f,l){this.addNode(f),this.addNode(l),this.c.has(f)?this.c.get(f).push(l):this.c.set(f,[l])}getArcs(f){return this.c.has(f)?this.c.get(f):[]}hasOnlyGoodArcs(f,l){const $=n.getArcs(f);for(let I=0;I<$.length;I++)if(!l.has($[I]))return!1;return!0}getNodes(){return this.e}},s=new w.$sn;for(const f of h)if(s.set(f.identifier,f),f.extensionDependencies)for(const l of f.extensionDependencies)n.addArc(w.$qn.toKey(f.identifier),w.$qn.toKey(l));const i=new Set;n.getNodes().filter(f=>n.getArcs(f).length===0).forEach(f=>i.add(f));const t=n.getNodes().filter(f=>!i.has(f));let m;do{m=!1;for(let f=0;f<t.length;f++){const l=t[f];n.hasOnlyGoodArcs(l,i)&&(t.splice(f,1),f--,i.add(l),m=!0)}}while(m);return t.map(f=>s.get(f))}containsActivationEvent(h){return this.h.has(h)}containsExtension(h){return this.f.has(h)}getExtensionDescriptionsForActivationEvent(h){const n=this.h.get(h);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new c(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(h){const n=this.f.get(h);return n||void 0}getExtensionDescriptionByUUID(h){for(const n of this.g)if(n.uuid===h)return n}getExtensionDescriptionByIdOrUUID(h,n){return this.getExtensionDescription(h)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$5bc=p;class c{constructor(h,n){this.versionId=h,this.extensions=n}}e.$6bc=c;class R{constructor(h){this.d=new E,this.c=new p(h,[])}async acquireLock(h){const n=await this.d.acquire(h);return new v(this,n)}deltaExtensions(h,n,s){if(!h.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,s)}containsActivationEvent(h){return this.c.containsActivationEvent(h)}containsExtension(h){return this.c.containsExtension(h)}getExtensionDescriptionsForActivationEvent(h){return this.c.getExtensionDescriptionsForActivationEvent(h)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(h){return this.c.getExtensionDescription(h)}getExtensionDescriptionByUUID(h){return this.c.getExtensionDescriptionByUUID(h)}getExtensionDescriptionByIdOrUUID(h,n){return this.c.getExtensionDescriptionByIdOrUUID(h,n)}}e.$7bc=R;class v extends T.$Wc{constructor(h,n){super(),this.f=h,this.c=!1,this.B(n)}isAcquiredFor(h){return!this.c&&this.f===h}}e.$8bc=v;class u{constructor(h){this.name=h;const n=(0,A.$yh)();this.promise=n.promise,this.c=n.resolve}resolve(h){this.c(h)}}class E{constructor(){this.c=[],this.d=!1}async acquire(h){const n=new u(h);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const h=this.c.shift();this.d=!0;let n=!0;const s=setTimeout(()=>{n&&console.warn(`The customer named ${h.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),i=()=>{n&&(clearTimeout(s),n=!1,this.d=!1,this.e())};h.resolve((0,T.$Uc)(i))}}var d;(function(a){a[a.Builtin=0]="Builtin",a[a.User=1]="User",a[a.Dev=2]="Dev"})(d||(d={}));function r(a,h){const n=a.isBuiltin?d.Builtin:a.isUnderDevelopment?d.Dev:d.User,s=h.isBuiltin?d.Builtin:h.isUnderDevelopment?d.Dev:d.User;if(n!==s)return n-s;const i=P.$ic.basename(a.extensionLocation.path),t=P.$ic.basename(h.extensionLocation.path);return i<t?-1:i>t?1:0}function o(a,h){const n=new w.$rn(h);return a.filter(s=>!n.has(s.identifier))}}),define(Ce[84],Ie([1,0,23]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$yn=A,e.$zn=N;var C;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(C||(e.UIKind=C={}));var P;(function(c){c[c.VersionMismatch=55]="VersionMismatch",c[c.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var T;(function(c){c[c.Initialized=0]="Initialized",c[c.Ready=1]="Ready",c[c.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(c){const R=w.$Oe.alloc(1);switch(c){case T.Initialized:R.writeUInt8(1,0);break;case T.Ready:R.writeUInt8(2,0);break;case T.Terminate:R.writeUInt8(3,0);break}return R}function N(c,R){if(c.byteLength!==1)return!1;switch(c.readUInt8(0)){case 1:return R===T.Initialized;case 2:return R===T.Ready;case 3:return R===T.Terminate;default:return!1}}var p;(function(c){c.Start="START_NATIVE_LOG",c.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ce[67],Ie([1,0,3,4,112,12,27,84,63,64,26,2,5,187]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=e.$cQ=e.$bQ=void 0,e.$dQ=o;let d=class extends u.$Wc{constructor(h,n){super(),this.s=h,this.t=n,this.a=this.B(new C.$me),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$me),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=v.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:c.$yp,name:(0,E.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(s=>{(0,T.$bk)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(h,n,s){const i=this.getTelemetryDetails(),t=new r(n,s,h,this.n,this.j,this.getBuiltInCommonProperties(h),{isUsageEnabled:i.isUsageEnabled,isErrorsEnabled:i.isErrorsEnabled}),m=this.r.get(h.identifier.value)??[];return this.r.set(h.identifier.value,[...m,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(h,n,s){this.f=h,this.g=n,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(h){const n=Object.create(null);switch(n["common.extname"]=`${h.publisher}.${h.name}`,n["common.extversion"]=h.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case N.UIKind.Web:n["common.uikind"]="web";break;case N.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$hn)((0,c.$Ep)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const n=this.getTelemetryDetails();this.r.forEach((s,i)=>{const t=s.filter(m=>!m.isDisposed);t.length===0?this.r.delete(i):this.r.set(i,t)}),this.r.forEach(s=>{for(const i of s)i.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(h,n){const i=this.r.get(h.value)?.filter(m=>!m.isDisposed);if(!i)return this.r.delete(h.value),!1;let t=!1;for(const m of i)m.ignoreUnhandledExtHostErrors||(m.logError(n),t=!0);return t}};e.$bQ=d,e.$bQ=d=Qe([Ve(0,A.$aQ),Ve(1,T.$ak)],d);class r{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,n,s,i,t,m,f){this.g=s,this.h=i,this.i=t,this.j=m,this.a=new C.$me,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(h,n){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let n="properties"in h?h.properties??{}:h;return n=(0,c.$Hp)(n,[]),this.c&&(n=(0,R.$fo)(n,this.c)),this.b||(n=(0,R.$fo)(n,this.j)),"properties"in h?h.properties=n:h=n,h}k(h,n){this.f&&(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(h,n),this.h.trace(h,n))}logUsage(h,n){this.d.isUsageEnabled&&this.k(h,n)}logError(h,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof h=="string")this.k(h,n);else{const s={name:h.name,message:h.message,stack:h.stack,cause:h.cause},i=(0,c.$Hp)(s,[]),t=new Error(i.message,{cause:i.cause});t.stack=i.stack,t.name=i.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(t,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const h=this,n={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let h=this.f;this.f=void 0,Promise.resolve(h.flush()).then(h=void 0),this.e=void 0}else this.f=void 0}}e.$cQ=r;function o(a){const h=Date.now()-new Date(a).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.$eQ=(0,w.$Fi)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,218,111,19,3]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.ActivationKind=e.$7G=e.$6G=e.$3G=e.ExtensionHostStartup=e.$2G=e.$1G=e.$ZG=e.$YG=void 0,e.$4G=u,e.$5G=E,e.$8G=a,e.$9G=h,e.$YG=Object.freeze({identifier:new A.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:C.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$ZG="extensions.webWorker",e.$1G=(0,N.$Fi)("extensionService");class p{constructor(i){this.dependency=i}}e.$2G=p;var c;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(c||(e.ExtensionHostStartup=c={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(i,t,m){this.c=i,this.d=t.slice(0),this.e=m.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$JG.createActivationEventsMap(this.d)}}set(i,t,m){if(this.c>i)throw new Error(`ExtensionHostExtensions: invalid versionId ${i} (current: ${this.c})`);const f=[],l=[],$=[],I=[],D=v(this.d),y=v(t),S=(O,q)=>O.extensionLocation.toString()===q.extensionLocation.toString()||O.isBuiltin===q.isBuiltin||O.isUserBuiltin===q.isUserBuiltin||O.isUnderDevelopment===q.isUnderDevelopment;for(const O of this.d){const q=y.get(O.identifier);if(!q){f.push(O.identifier),D.delete(O.identifier);continue}if(!S(O,q)){f.push(O.identifier),D.delete(O.identifier);continue}}for(const O of t){const q=D.get(O.identifier);if(!q){l.push(O);continue}if(!S(q,O)){f.push(q.identifier),D.delete(q.identifier);continue}}const k=new A.$rn(this.e),g=new A.$rn(m);for(const O of this.e)g.has(O)||$.push(O);for(const O of m)k.has(O)||I.push(O);const b=T.$JG.createActivationEventsMap(l),L={versionId:i,toRemove:f,toAdd:l,addActivationEvents:b,myToRemove:$,myToAdd:I};return this.delta(L),L}delta(i){if(this.c>=i.versionId)return null;const{toRemove:t,toAdd:m,myToRemove:f,myToAdd:l}=i,$=new A.$rn(t),I=new A.$rn(f);for(let D=0;D<this.d.length;D++)$.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)I.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of m)this.d.push(D);for(const D of l)this.e.push(D);return this.f=null,i}containsExtension(i){for(const t of this.e)if(A.$qn.equals(t,i))return!0;return!1}containsActivationEvent(i){return this.f||(this.f=this.g()),this.f.has(i)}g(){const i=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const m=T.$JG.readActivationEvents(t);for(const f of m)i.add(f)}return i}}e.$3G=R;function v(s){const i=new A.$sn;for(const t of s)i.set(t.identifier,t);return i}function u(s,i){return s.enabledApiProposals?s.enabledApiProposals.includes(i):!1}function E(s,i){if(!u(s,i))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${i}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${i}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class d{constructor(i,t,m,f){this.codeLoadingTime=i,this.activateCallTime=t,this.activateResolvedTime=m,this.activationReason=f}}e.$6G=d;class r{constructor(i,t){this.description=i,this.value=t}}e.$7G=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function a(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,P.$Np)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function h(s,i){const t=(0,P.$Lp)(s.manifest.publisher,s.manifest.name);return{id:t,identifier:new A.$qn(t),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!i,extensionLocation:s.location,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName,...s.manifest}}class n{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(i){return Promise.resolve(void 0)}activateById(i,t){return Promise.resolve(void 0)}activationEventIsDone(i){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(i){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(i,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(i){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$0G=n}),define(Ce[247],Ie([1,0,14,118,19,25,12,11]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$foc=e.$eoc=e.$doc=e.$coc=e.$boc=void 0,w=qe(w);class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(a,h,n,s){this.startup=a,this.codeLoadingTime=h,this.activateCallTime=n,this.activateResolvedTime=s}}e.$boc=p;class c{constructor(a){this.a=a,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(a,h){return a===-1||h===-1?-1:h-a}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$coc=c;class R{constructor(a,h,n,s,i,t){this.activationFailed=a,this.activationFailedError=h,this.activationTimes=n,this.module=s,this.exports=i,this.subscriptions=t}}e.$doc=R;class v extends R{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.$eoc=v;class u extends R{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$foc=u;class E extends R{constructor(a){super(!0,a,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let d=class{constructor(a,h,n,s){this.g=s,this.a=a,this.b=h,this.c=n,this.d=new P.$sn,this.f=Object.create(null)}dispose(){for(const[a,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const a=[];for(const[h,n]of this.d)a.push(n.wait());await Promise.all(a)}isActivated(a){const h=this.d.get(a);return!!(h&&h.value)}getActivatedExtension(a){const h=this.d.get(a);if(!h||!h.value)throw new Error(`Extension '${a.value}' is not known or not activated`);return h.value}async activateByEvent(a,h){if(this.f[a])return;const n=this.a.getExtensionDescriptionsForActivationEvent(a);await this.h(n.map(s=>({id:s.identifier,reason:{startup:h,extensionId:s.identifier,activationEvent:a}}))),this.f[a]=!0}activateById(a,h){const n=this.a.getExtensionDescription(a);if(!n)throw new Error(`Extension '${a.value}' is not known`);return this.h([{id:n.identifier,reason:h}])}async h(a){const h=a.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(h.map(n=>n.wait()))}j(a){if(this.d.has(a.id))return this.d.get(a.id);if(this.l(a.id))return this.k(a,null,[],null);const h=this.a.getExtensionDescription(a.id);if(!h){const i=new Error(`Cannot activate unknown extension '${a.id.value}'`),t=this.k(a,null,[],new E(i));return this.c.onExtensionActivationError(a.id,i,new T.$2G(a.id.value)),t}const n=[],s=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const i of s){if(this.m(i))continue;const t=this.d.get(i);if(t){n.push(t);continue}if(this.l(i)){n.push(this.j({id:this.b.getExtensionDescription(i).identifier,reason:a.reason}));continue}const m=this.a.getExtensionDescription(i);if(m){if(!m.main&&!m.browser)continue;n.push(this.j({id:m.identifier,reason:a.reason}));continue}const f=h.displayName||h.identifier.value,l=new Error(`Cannot activate the '${f}' extension because it depends on unknown extension '${i}'`),$=this.k(a,h.displayName,[],new E(l));return this.c.onExtensionActivationError(h.identifier,l,new T.$2G(i)),$}return this.k(a,h.displayName,n,null)}k(a,h,n,s){const i=new r(a.id,h,a.reason,n,s,this.c,this.g);return this.d.set(a.id,i),i}l(a){return C.$5bc.isHostExtension(a,this.a,this.b)}m(a){const h=this.b.getExtensionDescription(a);return h?!h.main&&!h.browser:!1}};e.$goc=d,e.$goc=d=Qe([Ve(3,A.$_j)],d);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(a,h,n,s,i,t,m){this.c=a,this.d=h,this.f=n,this.g=s,this.h=i,this.j=t,this.k=m,this.a=new N.$Eh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let a=0;a<this.g.length;a++){const h=this.g[a];if(h.value&&!h.value.activationFailed){this.g.splice(a,1),a--;continue}if(h.value&&h.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);n.detail=h.value.activationFailedError,this.h=new E(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(a=>a.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(a){const h=new Error;if(a&&a.name&&(h.name=a.name),a&&a.message?h.message=`Activating extension '${this.c.value}' failed: ${a.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${a}.`,a&&a.stack&&(h.stack=a.stack),this.h=new E(h),this.b&&w.$6(a))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(a)}}};r=Qe([Ve(6,A.$_j)],r)}),define(Ce[248],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",lmTools:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testRunInDebug:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRunInDebug.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[119],Ie([1,0,204,14,36,110,78,31,19,248,108,111]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=void 0,w=qe(w),P=ri(P);const u=N.$po.as(A.$qo.JSONContribution);class E{constructor(i,t,m){this.a=i,this.b=t,this.c=m}d(i,t){this.a({type:i,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(i){this.d(P.default.Error,i)}warn(i){this.d(P.default.Warning,i)}info(i){this.d(P.default.Info,i)}}e.$SG=E;class d{static a(i){const t=new p.$rn;for(let m=0,f=i.length;m<f;m++)t.add(i[m].description.identifier);return t}static compute(i,t){if(!i||!i.length)return new d(t,[]);if(!t||!t.length)return new d([],i);const m=this.a(i),f=this.a(t),l=t.filter(I=>!m.has(I.description.identifier)),$=i.filter(I=>!f.has(I.description.identifier));return new d(l,$)}constructor(i,t){this.added=i,this.removed=t}}e.$TG=d;class r{constructor(i,t){this.name=i,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(i){if(this.a!==null)throw new Error("Handler already set!");return this.a=i,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(i){this.c=d.compute(this.b,i),this.b=i,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(i){(0,C.$3)(i)}}}e.$UG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},a="vscode://schemas/vscode-extensions";e.$VG={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$pn},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:w.localize(42,null)},{label:"*",description:w.localize(43,null),body:"*"}]}},badges:{type:"array",description:w.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(45,null)},href:{type:"string",description:w.localize(46,null)},description:{type:"string",description:w.localize(47,null)}}}},markdown:{type:"string",description:w.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$7o}},extensionPack:{description:w.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$7o}},extensionKind:{description:w.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(53,null)},{body:["workspace"],description:w.localize(54,null)},{body:["ui","workspace"],description:w.localize(55,null)},{body:["workspace","ui"],description:w.localize(56,null)},{body:[],description:w.localize(57,null)}]},capabilities:{description:w.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(61,null),w.localize(62,null),w.localize(63,null)]},description:{type:"string",markdownDescription:w.localize(64,null)}}},untrustedWorkspaces:{description:w.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(67,null),w.localize(68,null),w.localize(69,null)]},restrictedConfigurations:{description:w.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(71,null)}}}}},sponsor:{description:w.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(74,null),type:"string"},"vscode:uninstall":{description:w.localize(75,null),type:"string"}}},icon:{type:"string",description:w.localize(76,null)},l10n:{type:"string",description:w.localize(77,null)},pricing:{type:"string",markdownDescription:w.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class h{constructor(){this.a=new Map}registerExtensionPoint(i){if(this.a.has(i.extensionPoint))throw new Error("Duplicate extension point: "+i.extensionPoint);const t=new r(i.extensionPoint,i.defaultExtensionKind);return this.a.set(i.extensionPoint,t),i.activationEventsGenerator&&v.$JG.register(i.extensionPoint,i.activationEventsGenerator),e.$VG.properties.contributes.properties[i.extensionPoint]=i.jsonSchema,u.registerSchema(a,e.$VG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$WG=h;const n={ExtensionsRegistry:"ExtensionsRegistry"};N.$po.add(n.ExtensionsRegistry,new h),e.$XG=N.$po.as(n.ExtensionsRegistry),u.registerSchema(a,e.$VG),u.registerSchema(R.$tk,{properties:{extensionEnabledApiProposals:{description:w.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(c.allApiProposals),markdownEnumDescriptions:Object.values(c.allApiProposals)}}]}}}})}),define(Ce[249],Ie([1,0,4,40,5,13,196,19,3,12,25,119]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aH=e.$_G=e.$$G=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$$G=(0,p.$Fi)("ILanguageModelsService");const E={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$_G=v.$XG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[E,{type:"array",items:E}]},activationEventsGenerator:(r,o)=>{for(const a of r)o.push(`onLanguageModelChat:${a.vendor}`)}});let d=class{constructor(o,a){this.e=o,this.f=a,this.a=new P.$Vc,this.b=new Map,this.c=new Set,this.d=this.a.add(new w.$me),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$_G.setHandler(h=>{this.c.clear();for(const s of h){if(!(0,R.$4G)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const i of C.Iterable.wrap(s.value)){if(this.c.has(i.vendor)){s.collector.error((0,A.localize)(3,null,i.vendor));continue}if((0,T.$df)(i.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(i.vendor.trim()!==i.vendor){s.collector.error((0,A.localize)(5,null));continue}this.c.add(i.vendor)}}const n=[];for(const[s,i]of this.b)this.c.has(i.metadata.vendor)||(this.b.delete(s),n.push(s));n.length>0&&this.d.fire({removed:n})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const h=Array.from(this.c).map(n=>this.e.activateByEvent(`onLanguageModelChat:${n}`));await Promise.all(h)}const a=[];for(const[h,n]of this.b)(o.vendor===void 0||n.metadata.vendor===o.vendor)&&(o.family===void 0||n.metadata.family===o.family)&&(o.version===void 0||n.metadata.version===o.version)&&(o.identifier===void 0||n.metadata.id===o.identifier)&&(!n.metadata.targetExtensions||n.metadata.targetExtensions.some(s=>N.$qn.equals(s,o.extension)))&&a.push(h);return this.f.trace("[LM] selected language models",o,a),a}registerLanguageModelChat(o,a){if(this.f.trace("[LM] registering language model chat",o,a.metadata),!this.c.has(a.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${a.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,a),this.d.fire({added:[{identifier:o,metadata:a.metadata}]}),(0,P.$Uc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,a.metadata))})}makeLanguageModelChatRequest(o,a,h,n,s,i){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideChatResponse(h,a,n,s,i)}computeTokenLength(o,a,h){const n=this.b.get(o);if(!n)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return n.provideTokenCount(a,h)}};e.$aH=d,e.$aH=d=Qe([Ve(0,R.$1G),Ve(1,c.$_j)],d)}),define(Ce[250],Ie([1,0,199,15,26,119,32,4]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=void 0,w=qe(w),C=qe(C),P=qe(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var c;(function(u){function E(d,r,o){if(!d)return;const a=C.$fg(d.type)?d.type:void 0;if(!a||a.length===0){o.error(w.localize(3,null));return}const h=[];if(Array.isArray(d.required))for(const n of d.required)C.$fg(n)&&h.push(n);return{extensionId:r.value,taskType:a,required:h,properties:d.properties?P.$co(d.properties):{},when:d.when?A.$Dj.deserialize(d.when):void 0}}u.from=E})(c||(c={}));const R=T.$XG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,E)=>{for(const d of u)d.type&&E.push(`onTaskType:${d.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:p}});class v{constructor(){this.d=new N.$me,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,d)=>{R.setHandler((r,o)=>{this.c=void 0;try{for(const a of o.removed){const h=a.value;for(const n of h)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const a of o.added){const h=a.value;for(const n of h){const s=c.from(n,a.description.identifier,a.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$co(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},E.push(r)}this.c={oneOf:E}}return this.c}}e.$DI=new v}),define(Ce[251],Ie([1,0,200,15,24,26,32,250,42]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$NI=e.JsonSchemaVersion=e.ExecutionEngine=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$HI=e.ShellQuoting=e.$GI=e.$FI=e.$EI=void 0,w=qe(w),C=qe(C),P=qe(P),T=qe(T),e.$EI="settings",e.$FI=new A.$Wj("taskRunning",!1,w.localize(0,null)),e.$GI=w.localize2(2,"Tasks");var c;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(c||(e.ShellQuoting=c={})),e.$HI="$customized",function(F){function V(ce){if(!ce)return F.Strong;switch(ce.toLowerCase()){case"escape":return F.Escape;case"strong":return F.Strong;case"weak":return F.Weak;default:return F.Strong}}F.from=V}(c||(e.ShellQuoting=c={}));var R;(function(F){F.defaults={cwd:"${workspaceFolder}"}})(R||(e.CommandOptions=R={}));var v;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(v||(e.RevealKind=v={})),function(F){function V(ce){switch(ce.toLowerCase()){case"always":return F.Always;case"silent":return F.Silent;case"never":return F.Never;default:return F.Always}}F.fromString=V}(v||(e.RevealKind=v={}));var u;(function(F){F[F.Never=1]="Never",F[F.OnProblem=2]="OnProblem",F[F.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(F){function V(ce){switch(ce.toLowerCase()){case"always":return F.Always;case"never":return F.Never;case"onproblem":return F.OnProblem;default:return F.OnProblem}}F.fromString=V}(u||(e.RevealProblemKind=u={}));var E;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(E||(e.PanelKind=E={})),function(F){function V(ce){switch(ce.toLowerCase()){case"shared":return F.Shared;case"dedicated":return F.Dedicated;case"new":return F.New;default:return F.Shared}}F.fromString=V}(E||(e.PanelKind=E={}));var d;(function(F){F.defaults={echo:!0,reveal:v.Always,revealProblems:u.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(F){F[F.Shell=1]="Shell",F[F.Process=2]="Process",F[F.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(F){function V(ge){switch(ge.toLowerCase()){case"shell":return F.Shell;case"process":return F.Process;case"customExecution":return F.CustomExecution;default:return F.Process}}F.fromString=V;function ce(ge){switch(ge){case F.Shell:return"shell";case F.Process:return"process";case F.CustomExecution:return"customExecution";default:return"process"}}F.toString=ce}(r||(e.RuntimeType=r={}));var o;(function(F){function V(ce){return C.$fg(ce)?ce:ce.value}F.value=V})(o||(e.CommandString=o={}));var a;(function(F){F.Clean={_id:"clean",isDefault:!1},F.Build={_id:"build",isDefault:!1},F.Rebuild={_id:"rebuild",isDefault:!1},F.Test={_id:"test",isDefault:!1};function V(ge){return ge===F.Clean._id||ge===F.Build._id||ge===F.Rebuild._id||ge===F.Test._id}F.is=V;function ce(ge){if(ge!==void 0)return C.$fg(ge)?V(ge)?{_id:ge,isDefault:!1}:void 0:ge}F.from=ce})(a||(e.TaskGroup=a={}));var h;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.Folder=3]="Folder"})(h||(e.TaskScope=h={}));var n;(function(F){F.Workspace="workspace",F.Extension="extension",F.InMemory="inMemory",F.WorkspaceFile="workspaceFile",F.User="user";function V(ce){switch(ce){case F.User:return p.ConfigurationTarget.USER;case F.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}F.toConfigurationTarget=V})(n||(e.TaskSourceKind=n={}));var s;(function(F){F.parallel="parallel",F.sequence="sequence"})(s||(e.DependsOrder=s={}));var i;(function(F){F[F.default=1]="default",F[F.folderOpen=2]="folderOpen"})(i||(e.RunOnOptions=i={}));var t;(function(F){F.defaults={reevaluateOnRerun:!0,runOn:i.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class m{constructor(V,ce,ge,te,me,se){this._label="",this._id=V,ce&&(this._label=ce),ge&&(this.type=ge),this.runOptions=te,this.configurationProperties=me,this._source=se}getDefinition(V){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const V={folder:this.d(),id:this._id};return JSON.stringify(V)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(V,ce=!1){if(V===void 0)return!1;if(C.$fg(V))return V===this._label||V===this.configurationProperties.identifier||ce&&V===this._id;const ge=this.getDefinition(!0);return ge!==void 0&&ge._key===V._key}getQualifiedLabel(){const V=this.getWorkspaceFolder();return V?`${this._label} (${V.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(V){this.c===void 0&&(this.c=[]),V&&(this.c=this.c.concat(V))}get taskLoadMessages(){return this.c}}e.$II=m;class f extends m{constructor(V,ce,ge,te,me,se,de,be){super(V,ge,void 0,de,be,ce),this.command={},this._source=ce,this.hasDefinedMatchers=se,me&&(this.command=me)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(V=!1){if(V&&this._source.customizes!==void 0)return this._source.customizes;{let ce;switch(this.command?this.command.runtime:void 0){case r.Shell:ce="shell";break;case r.Process:ce="process";break;case r.CustomExecution:ce="customExecution";break;case void 0:ce="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ce,_key:this._id,id:this._id}}}static is(V){return V instanceof f}getMapKey(){const V=this._source.config.workspaceFolder;return V?`${V.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$EI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const V=this.d();if(!V)return;let ce=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(ce+=this._source.kind);const ge={type:e.$HI,folder:V,id:ce};return JSON.stringify(ge)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(V){return new f(V._id,V._source,V._label,V.type,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$JI=f;class l extends m{constructor(V,ce,ge,te,me,se,de){super(V,ge,te,se,de,ce),this._source=ce,this.configures=me}static is(V){return V instanceof l}f(V){return V}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$dh(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$EI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const V=this.d();if(!V)return;let ce=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(ce+=this._source.kind);const ge={type:e.$HI,folder:V,id:ce};return JSON.stringify(ge)}}e.$KI=l;class $ extends m{constructor(V,ce,ge,te,me,se,de,be,re){super(V,ge,te,be,re,ce),this.defines=me,this.hasDefinedMatchers=de,this.command=se,this.icon=re.icon,this.hide=re.hide}clone(){return new $(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(V){return V instanceof $}getMapKey(){const V=this._source.workspaceFolder;return V?`${this._source.scope.toString()}|${V.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===h.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const V={type:"contributed",scope:this._source.scope,id:this._id};return V.folder=this.d(),JSON.stringify(V)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(V){return new $(V._id,V._source,V._label,V.type,V.defines,V.command,V.hasDefinedMatchers,V.runOptions,V.configurationProperties)}}e.$LI=$;class I extends m{constructor(V,ce,ge,te,me,se){super(V,ge,te,me,se,ce),this._source=ce}clone(){return new I(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(V){return V instanceof I}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(V){return new I(V._id,V._source,V._label,V.type,V.runOptions,V.configurationProperties)}}e.$MI=I;var D;(function(F){F[F.Process=1]="Process",F[F.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(F){F._default=F.Terminal}(D||(e.ExecutionEngine=D={}));var y;(function(F){F[F.V0_1_0=1]="V0_1_0",F[F.V2_0_0=2]="V2_0_0"})(y||(e.JsonSchemaVersion=y={}));class S{constructor(V){this.c=new Map;for(let ce=0;ce<V.length;ce++)this.c.set(V[ce].uri.toString(),ce)}compare(V,ce){const ge=V.getWorkspaceFolder(),te=ce.getWorkspaceFolder();if(ge&&te){let me=this.c.get(ge.uri.toString());me=me===void 0?0:me+1;let se=this.c.get(te.uri.toString());return se=se===void 0?0:se+1,me===se?V._label.localeCompare(ce._label):me-se}else return!ge&&te?-1:ge&&!te?1:0}}e.$NI=S;var k;(function(F){F.DependsOnStarted="dependsOnStarted",F.AcquiredInput="acquiredInput",F.Start="start",F.ProcessStarted="processStarted",F.Active="active",F.Inactive="inactive",F.Changed="changed",F.Terminated="terminated",F.ProcessEnded="processEnded",F.End="end"})(k||(e.TaskEventKind=k={}));var g;(function(F){F.SingleRun="singleRun",F.Background="background"})(g||(e.TaskRunType=g={}));var b;(function(F){F[F.System=0]="System",F[F.User=1]="User",F[F.FolderOpen=2]="FolderOpen",F[F.ConfigurationChange=3]="ConfigurationChange",F[F.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var L;(function(F){function V(be){return{taskId:be._id,taskName:be.configurationProperties.name,runType:be.configurationProperties.isBackground?g.Background:g.SingleRun,group:be.configurationProperties.group,__task:be}}function ce(be,re,Pe){return{...V(be),kind:k.Start,terminalId:re,resolvedVariables:Pe}}F.start=ce;function ge(be,re,Pe){return{...V(be),kind:k.ProcessStarted,terminalId:re,processId:Pe}}F.processStarted=ge;function te(be,re,Pe){return{...V(be),kind:k.ProcessEnded,terminalId:re,exitCode:Pe}}F.processEnded=te;function me(be,re,Pe){return{...V(be),kind:k.Terminated,exitReason:Pe,terminalId:re}}F.terminated=me;function se(be,re,Pe){return{...V(re),kind:be,terminalId:Pe}}F.general=se;function de(){return{kind:k.Changed}}F.changed=de})(L||(e.TaskEvent=L={}));var O;(function(F){function V(ge){const te=Object.keys(ge).sort();let me="";for(const se of te){let de=ge[se];de instanceof Object?de=V(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),me+=se+","+de+","}return me}function ce(ge){const me={_key:V(ge),type:ge.taskType};return Object.assign(me,ge),me}F.create=ce})(O||(e.KeyedTaskIdentifier=O={}));var q;(function(F){F.AutoDetect="task.autoDetect",F.SaveBeforeRun="task.saveBeforeRun",F.ShowDecorations="task.showDecorations",F.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",F.SlowProviderWarning="task.slowProviderWarning",F.QuickOpenHistory="task.quickOpen.history",F.QuickOpenDetail="task.quickOpen.detail",F.QuickOpenSkip="task.quickOpen.skip",F.QuickOpenShowAll="task.quickOpen.showAll",F.AllowAutomaticTasks="task.allowAutomaticTasks",F.Reconnection="task.reconnection",F.VerboseLogging="task.verboseLogging"})(q||(e.TaskSettingId=q={}));var G;(function(F){F.Tasks="tasks",F.SuppressTaskName="tasks.suppressTaskName",F.Windows="tasks.windows",F.Osx="tasks.osx",F.Linux="tasks.linux",F.ShowOutput="tasks.showOutput",F.IsShellCommand="tasks.isShellCommand",F.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var W;(function(F){function V(ce,ge){const te=N.$DI.get(ce.type);if(te===void 0){const be=T.$co(ce);return delete be._key,O.create(be)}const me=Object.create(null);me.type=te.taskType;const se=new Set;te.required.forEach(be=>se.add(be));const de=te.properties;for(const be of Object.keys(de)){const re=ce[be];if(re!=null)me[be]=re;else if(se.has(be)){const Pe=de[be];if(Pe.default!==void 0)me[be]=T.$co(Pe.default);else switch(Pe.type){case"boolean":me[be]=!1;break;case"number":case"integer":me[be]=0;break;case"string":me[be]="";break;default:ge.error(w.localize(1,null,JSON.stringify(ce,void 0,0),be));return}}}return O.create(me)}F.createTaskIdentifier=V})(W||(e.TaskDefinition=W={}))}),define(Ce[252],Ie([1,0,14]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0;class C{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,N)=>{this.b=A,this.d=N,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,w.$3)(A))}then(A,N){return this.j().then(A,N)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$9bc=C;class P extends C{constructor(){super(),this.h=!0,this.i=new w.$7}}e.$0bc=P}),define(Ce[39],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qw=e.$Nw=void 0,e.$Ow=P,e.$Pw=T;class w{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++w.count}}e.$Nw=w;const C=[];function P(N){const p=new w(N);return C[p.nid]=p,p}function T(N){return C[N].sid}class A{constructor(p){this.value=p}}e.$Qw=A}),define(Ce[6],Ie([1,0,39]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$pN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var T;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var N;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(N||(e.WebviewMessageArrayBufferViewType=N={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var c;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(c||(e.NotebookEditorRevealType=c={}));var R;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(R||(e.CandidatePortSource=R={}));class v{static{this.a=0}static mixin(o){return o._id=v.a++,o}}e.$pN=v;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var E;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$qN={MainThreadAuthentication:(0,w.$Ow)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Ow)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,w.$Ow)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,w.$Ow)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,w.$Ow)("MainThreadChatAgents2"),MainThreadChatVariables:(0,w.$Ow)("MainThreadChatVariables"),MainThreadClipboard:(0,w.$Ow)("MainThreadClipboard"),MainThreadCommands:(0,w.$Ow)("MainThreadCommands"),MainThreadComments:(0,w.$Ow)("MainThreadComments"),MainThreadConfiguration:(0,w.$Ow)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Ow)("MainThreadConsole"),MainThreadDebugService:(0,w.$Ow)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Ow)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Ow)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Ow)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Ow)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Ow)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Ow)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Ow)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Ow)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Ow)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Ow)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Ow)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,w.$Ow)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Ow)("MainThreadLanguages"),MainThreadLogger:(0,w.$Ow)("MainThreadLogger"),MainThreadMessageService:(0,w.$Ow)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Ow)("MainThreadOutputService"),MainThreadProgress:(0,w.$Ow)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Ow)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Ow)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Ow)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Ow)("MainThreadSecretState"),MainThreadStorage:(0,w.$Ow)("MainThreadStorage"),MainThreadSpeech:(0,w.$Ow)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,w.$Ow)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Ow)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,w.$Ow)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,w.$Ow)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Ow)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Ow)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Ow)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Ow)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Ow)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Ow)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Ow)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Ow)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,w.$Ow)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,w.$Ow)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Ow)("MainThreadSCM"),MainThreadSearch:(0,w.$Ow)("MainThreadSearch"),MainThreadShare:(0,w.$Ow)("MainThreadShare"),MainThreadTask:(0,w.$Ow)("MainThreadTask"),MainThreadWindow:(0,w.$Ow)("MainThreadWindow"),MainThreadLabelService:(0,w.$Ow)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Ow)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Ow)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Ow)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Ow)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Ow)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Ow)("MainThreadInteractive"),MainThreadTheming:(0,w.$Ow)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Ow)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Ow)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Ow)("MainThreadTimeline"),MainThreadTesting:(0,w.$Ow)("MainThreadTesting"),MainThreadLocalization:(0,w.$Ow)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,w.$Ow)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,w.$Ow)("MainThreadAiEmbeddingVector")},e.$rN={ExtHostCommands:(0,w.$Ow)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Ow)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Ow)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Ow)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Ow)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Ow)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Ow)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Ow)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Ow)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Ow)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Ow)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Ow)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Ow)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Ow)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Ow)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Ow)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Ow)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Ow)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Ow)("ExtHostStatusBar"),ExtHostShare:(0,w.$Ow)("ExtHostShare"),ExtHostExtensionService:(0,w.$Ow)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Ow)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Ow)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,w.$Ow)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,w.$Ow)("ExtHostSCM"),ExtHostSearch:(0,w.$Ow)("ExtHostSearch"),ExtHostTask:(0,w.$Ow)("ExtHostTask"),ExtHostWorkspace:(0,w.$Ow)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Ow)("ExtHostWindow"),ExtHostWebviews:(0,w.$Ow)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Ow)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Ow)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Ow)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Ow)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Ow)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Ow)("ExtHostProgress"),ExtHostComments:(0,w.$Ow)("ExtHostComments"),ExtHostSecretState:(0,w.$Ow)("ExtHostSecretState"),ExtHostStorage:(0,w.$Ow)("ExtHostStorage"),ExtHostUrls:(0,w.$Ow)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Ow)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Ow)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Ow)("ExtHostOutputService"),ExtHostLabelService:(0,w.$Ow)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Ow)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Ow)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Ow)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Ow)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Ow)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Ow)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Ow)("ExtHostInteractive"),ExtHostChatAgents2:(0,w.$Ow)("ExtHostChatAgents"),ExtHostChatVariables:(0,w.$Ow)("ExtHostChatVariables"),ExtHostChatProvider:(0,w.$Ow)("ExtHostChatProvider"),ExtHostSpeech:(0,w.$Ow)("ExtHostSpeech"),ExtHostEmbeddings:(0,w.$Ow)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,w.$Ow)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,w.$Ow)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,w.$Ow)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Ow)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Ow)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Ow)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Ow)("ExtHostTimeline"),ExtHostTesting:(0,w.$Ow)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Ow)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Ow)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,6,17]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=e.$Anc=void 0,P=qe(P),e.$Anc=(0,w.$Fi)("IExtHostApiDeprecationService");let A=class{constructor(p,c){this.c=c,this.a=new Set,this.b=p.getProxy(P.$qN.MainThreadTelemetry)}report(p,c,R){const v=this.d(p,c);this.a.has(v)||(this.a.add(v),c.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:c.identifier.value,apiId:p}))}d(p,c){return`${p}-${c.identifier.value}`}};e.$Bnc=A,e.$Bnc=A=Qe([Ve(0,T.$WP),Ve(1,C.$_j)],A),e.$Cnc=Object.freeze(new class{report(N,p,c){}})}),define(Ce[253],Ie([1,0,6]),function(oe,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=void 0;class C{constructor(T){const A=T.getProxy(w.$qN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(N){return A.$writeText(N)}})}}e.$Pnc=C}),define(Ce[254],Ie([1,0,26,6,27,17]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0;let A=class{constructor(R,v){this.a=R.getProxy(C.$qN.MainThreadConsole),this.b=v.consoleForward.includeStack,this.c=v.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(R,v){const u=this,E=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){u.e(R,v,E,arguments)}})}e(R,v,u,E){this.a.$logExtensionHostMessage({type:"__$console",severity:v,arguments:p(E,this.b)}),this.c&&this.f(R,u,E)}};e.$Kpc=A,e.$Kpc=A=Qe([Ve(0,T.$WP),Ve(1,P.$aQ)],A);const N=1e5;function p(c,R){const v=[];if(c.length)for(let u=0;u<c.length;u++){let E=c[u];if(typeof E>"u")E="undefined";else if(E instanceof Error){const d=E;d.stack?E=d.stack:E=d.toString()}v.push(E)}if(R){const u=new Error().stack;u&&v.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,w.$ho)(v);return u.length>N?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[255],Ie([1,0,2,6,25]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Roc=void 0;class T{constructor(N){this.a=N.getProxy(C.$qN.MainThreadDialogs)}showOpenDialog(N,p){return p?.allowUIResources&&(0,P.$5G)(N,"showLocal"),this.a.$showOpenDialog(p).then(c=>c?c.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(N){return this.a.$showSaveDialog(N).then(p=>p?w.URI.revive(p):void 0)}}e.$Roc=T}),define(Ce[256],Ie([1,0,22,4,5,6]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class A{constructor(p){this.b=new Map,this.c=new C.$me,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(T.$qN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,c,R){if(this.d.has(c))throw new Error("An embeddings provider for this model is already registered");const v=this.e++;return this.a.$registerEmbeddingProvider(v,c),this.b.set(v,{id:c,provider:R}),(0,P.$Uc)(()=>{this.a.$unregisterEmbeddingProvider(v),this.b.delete(v)})}async computeEmbeddings(p,c,R){R??=w.CancellationToken.None;let v=!1;typeof c=="string"&&(c=[c],v=!0);const u=await this.a.$computeEmbeddings(p,c,R);if(u.length!==c.length)throw new Error;if(v){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings(p,c,R){const v=this.b.get(p);if(!v)return[];const u=await v.provider.provideEmbeddings(c,R);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Uoc=A}),define(Ce[257],Ie([1,0,5,6]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(C.$qN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const N=this.b++;return this.a.$registerResourceLabelFormatter(N,A),(0,w.$Uc)(()=>{this.a.$unregisterResourceLabelFormatter(N)})}}e.$_oc=P}),define(Ce[86],Ie([1,0,21,13,2,3,12,6,27,17]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$voc=e.$uoc=void 0;let R=class{constructor(u,E,d){this.f=d,this.d=new Map,this.a=E.getProxy(N.$qN.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===w.$g}getMessage(u,E){const{message:d,args:r,comment:o}=E;if(this.c)return(0,C.$ff)(d,r??{});let a=d;o&&o.length>0&&(a+=`/${Array.isArray(o)?o.join(""):o}`);const h=this.d.get(u)?.contents[a];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${a}`),(0,C.$ff)(h??d,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let E;const d=await this.g(u);if(!d){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),o=JSON.parse(r);E=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${d}: ${r.message}`);return}E&&this.d.set(u.identifier.value,{contents:E,uri:d})}async g(u){if(u.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return P.URI.revive(E)}return u.l10n?P.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$uoc=R,e.$uoc=R=Qe([Ve(0,p.$aQ),Ve(1,c.$WP),Ve(2,A.$_j)],R),e.$voc=(0,T.$Fi)("IExtHostLocalizationService")}),define(Ce[258],Ie([1,0,12,6,27,17,2,49]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=void 0;let p=class extends w.$kk{constructor(v,u){super(u.logLevel,u.logsLocation,u.loggers.map(E=>(0,N.$ci)(E))),this.r=v.getProxy(C.$qN.MainThreadLogger)}$setLogLevel(v,u){u?this.setLogLevel(A.URI.revive(u),v):this.setLogLevel(v)}setVisibility(v,u){super.setVisibility(v,u),this.r.$setVisibility(v,u)}s(v,u,E){return new c(this.r,v,u,E)}};e.$Jpc=p,e.$Jpc=p=Qe([Ve(0,T.$WP),Ve(1,P.$aQ)],p);class c extends w.$fk{constructor(v,u,E,d){super(d?.logLevel==="always"),this.r=v,this.s=u,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(u,d).then(()=>{this.u(this.n),this.m=!0})}g(v,u){const E=[[v,u]];this.m?this.u(E):this.n.push(...E)}u(v){this.r.$log(this.s,v)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,6,3,5,17,23]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=e.$woc=void 0,e.$woc=(0,C.$Fi)("IExtHostManagedSockets");let N=class{constructor(v){this.b=0,this.c=null,this.d=new Map,this.a=v.getProxy(w.$qN.MainThreadManagedSockets)}setFactory(v,u){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(v,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(v){if(!this.c||this.c.socketFactoryId!==v)throw new Error(`No socket factory with id ${v}`);const u=++this.b,E=await this.c.makeConnection(),d=new P.$Vc;return this.d.set(u,new c(u,E,d)),d.add((0,P.$Uc)(()=>this.d.delete(u))),d.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),d.dispose()})),d.add(E.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),d.dispose()})),d.add(E.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$Oe.wrap(r)))),u}$remoteSocketWrite(v,u){this.d.get(v)?.actual.send(u.buffer)}$remoteSocketEnd(v){const u=this.d.get(v);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(v){await this.d.get(v)?.actual.drain?.()}};e.$xoc=N,e.$xoc=N=Qe([Ve(0,T.$WP)],N);class p{constructor(v,u){this.socketFactoryId=v,this.makeConnection=u}}class c extends P.$Wc{constructor(v,u,E){super(),this.socketId=v,this.actual=u,this.B(E)}}}),define(Ce[259],Ie([1,0,6,12,25]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=void 0;function T(N){return N&&N.title}let A=class{constructor(p,c){this.b=c,this.a=p.getProxy(w.$qN.MainThreadMessageService)}showMessage(p,c,R,v,u){const E={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof v=="string"||T(v)?d=[v,...u]:(E.modal=v?.modal,E.useCustom=v?.useCustom,E.detail=v?.detail,d=u),E.useCustom&&(0,P.$5G)(p,"resolvers");const r=[];let o=!1;for(let a=0;a<d.length;a++){const h=d[a];if(typeof h=="string")r.push({title:h,handle:a,isCloseAffordance:!1});else if(typeof h=="object"){const{title:n,isCloseAffordance:s}=h;r.push({title:n,isCloseAffordance:!!s,handle:a}),s&&(o?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,h):o=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,h)}return this.a.$showMessage(c,R,E,r).then(a=>{if(typeof a=="number")return d[a]})}};e.$bpc=A,e.$bpc=A=Qe([Ve(1,C.$_j)],A)}),define(Ce[260],Ie([1,0,5,15,2,25,6]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kpc=void 0;class N{constructor(c){this.b=new Map,this.a=c.getProxy(A.$qN.MainThreadProfileContentHandlers)}registerProfileContentHandler(c,R,v){if((0,T.$5G)(c,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,v),this.a.$registerProfileContentHandler(R,v.name,v.description,c.identifier.value),(0,w.$Uc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(c,R,v,u){const E=this.b.get(c);if(!E)throw new Error(`Unknown handler with id: ${c}`);return E.saveProfile(R,v,u)}async $readProfile(c,R,v){const u=this.b.get(c);if(!u)throw new Error(`Unknown handler with id: ${c}`);return u.readProfile((0,C.$fg)(R)?R:P.URI.revive(R),v)}}e.$kpc=N}),define(Ce[88],Ie([1,0,6,4,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=e.$roc=void 0;class T{constructor(N){this.b=new C.$me,this.onDidChangePassword=this.b.event,this.a=N.getProxy(w.$qN.MainThreadSecretState)}async $onDidChangePassword(N){this.b.fire(N)}get(N,p){return this.a.$getPassword(N,p)}store(N,p,c){return this.a.$setPassword(N,p,c)}delete(N,p){return this.a.$deletePassword(N,p)}}e.$roc=T,e.$soc=(0,P.$Fi)("IExtHostSecretState")}),define(Ce[261],Ie([1,0,22,5,6]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=void 0;class T{static{this.a=1}constructor(N){this.c=new Map,this.d=new Map,this.f=new Map,this.b=N.getProxy(P.$qN.MainThreadSpeech)}async $createSpeechToTextSession(N,p,c){const R=this.c.get(N);if(!R)return;const v=new C.$Vc,u=new w.$xe;this.d.set(p,u);const E=await R.provideSpeechToTextSession(u.token,c?{language:c}:void 0);E&&(v.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),v.add(u.token.onCancellationRequested(()=>v.dispose())))}async $cancelSpeechToTextSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}async $createTextToSpeechSession(N,p,c){const R=this.c.get(N);if(!R)return;const v=new C.$Vc,u=new w.$xe;this.d.set(p,u);const E=await R.provideTextToSpeechSession(u.token,c?{language:c}:void 0);E&&(this.f.set(p,E),v.add(E.onDidChange(d=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),v.add(u.token.onCancellationRequested(()=>v.dispose())))}async $synthesizeSpeech(N,p){this.f.get(N)?.synthesize(p)}async $cancelTextToSpeechSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N),this.f.delete(N)}async $createKeywordRecognitionSession(N,p){const c=this.c.get(N);if(!c)return;const R=new C.$Vc,v=new w.$xe;this.d.set(p,v);const u=await c.provideKeywordRecognitionSession(v.token);u&&(R.add(u.onDidChange(E=>{v.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,E)})),R.add(v.token.onCancellationRequested(()=>R.dispose())))}async $cancelKeywordRecognitionSession(N){this.d.get(N)?.dispose(!0),this.d.delete(N)}registerProvider(N,p,c){const R=T.a++;return this.c.set(R,c),this.b.$registerProvider(R,p,{extension:N,displayName:N.value}),(0,C.$Uc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$rpc=T}),define(Ce[89],Ie([1,0,6,4,3]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0;class T{constructor(N,p){this.c=p,this.b=new C.$me,this.onDidChangeStorage=this.b.event,this.a=N.getProxy(w.$qN.MainThreadStorage)}registerExtensionStorageKeysToSync(N,p){this.a.$registerExtensionStorageKeysToSync(N,p)}async initializeExtensionStorage(N,p,c){const R=await this.a.$initializeExtensionStorage(N,p);let v;return R&&(v=this.d(N,p,R)),v||c}setValue(N,p,c){return this.a.$setValue(N,p,c)}$acceptValue(N,p,c){const R=this.d(N,p,c);R&&this.b.fire({shared:N,key:p,value:R})}d(N,p,c){try{return JSON.parse(c)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${N}): ${R}`)}}}e.$hoc=T,e.$ioc=(0,P.$Fi)("IExtHostStorage")}),define(Ce[262],Ie([1,0,5,16,2,6]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0;class A{static{this.a=new Set([C.Schemas.http,C.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(T.$qN.MainThreadUriOpeners)}registerExternalUriOpener(p,c,R,v){if(this.c.has(c))throw new Error(`Opener with id '${c}' already registered`);const u=v.schemes.find(E=>!A.a.has(E));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(c,R),this.b.$registerUriOpener(c,v.schemes,p,v.label),(0,w.$Uc)(()=>{this.c.delete(c),this.b.$unregisterUriOpener(c)})}async $canOpenUri(p,c,R){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener with id: ${p}`);const u=P.URI.revive(c);return v.canOpenExternalUri(u,R)}async $openUri(p,c,R){const v=this.c.get(p);if(!v)throw new Error(`Unknown opener id: '${p}'`);return v.openExternalUri(P.URI.revive(c.resolvedUri),{sourceUri:P.URI.revive(c.sourceUri)},R)}}e.$Dpc=A}),define(Ce[263],Ie([1,0,6,2,5,14,19]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class N{static{this.a=0}constructor(c){this.c=new A.$rn,this.d=new Map,this.b=c.getProxy(w.$qN.MainThreadUrls)}registerUriHandler(c,R){const v=c.identifier;if(this.c.has(v))throw new Error(`Protocol handler already registered for extension ${v}`);const u=N.a++;return this.c.add(v),this.d.set(u,R),this.b.$registerUriHandler(u,v,c.displayName||c.name),(0,P.$Uc)(()=>{this.c.delete(v),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(c,R){const v=this.d.get(c);if(!v)return Promise.resolve(void 0);try{v.handleUri(C.URI.revive(R))}catch(u){(0,T.$3)(u)}return Promise.resolve(void 0)}async createAppUri(c){return C.URI.revive(await this.b.$createAppUri(c))}}e.$Epc=N}),define(Ce[264],Ie([1,0,23,6]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ysb=T,e.$Zsb=N,C=qe(C);class P{constructor(){this.buffers=[]}add(c){let R=this.buffers.indexOf(c);return R<0&&(R=this.buffers.length,this.buffers.push(c)),R}}function T(p,c){if(c.serializeBuffersForPostMessage){const R=new P,u=JSON.stringify(p,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:R.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:R.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),E=R.buffers.map(d=>{const r=new Uint8Array(d);return w.$Oe.wrap(r)});return{message:u,buffers:E}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return C.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return C.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return C.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return C.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return C.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return C.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return C.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return C.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return C.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return C.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return C.WebviewMessageArrayBufferViewType.BigUint64Array}}function N(p,c){const R=c.map(E=>{const d=new ArrayBuffer(E.byteLength);return new Uint8Array(d).set(E.buffer),d}),v=c.length?(E,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,a=R[o];if(r.view)switch(r.view.type){case C.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(a,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(a,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(a,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(a,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(a,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(a,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(a,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(a,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(a,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(a,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case C.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(a,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return a}return d}:void 0;return{message:JSON.parse(p,v),arrayBuffers:R}}}),define(Ce[68],Ie([1,0,4,5,16,26,2,207,264,83,6]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=e.$5nc=void 0,e.$6nc=u,e.$8nc=r,e.$9nc=o,T=qe(T),R=qe(R);class v{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(s,i,t,m,f,l,$){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new w.$me,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$me,this._onDidDispose=this.#h.event,this.#e=s,this.#t=i,this.#o=t,this.#n=m,this.#s=f,this.#r=l,this.#l=u(l),this.#d=E(l),this.#i=$}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(s){return this.#u=!0,(0,c.$FCb)(s,this.#n)}get cspSource(){const s=this.#r.extensionLocation;if(s.scheme===P.Schemas.https||s.scheme===P.Schemas.http){let i=s.toString();return i.endsWith("/")||(i+="/"),i+" "+c.$ECb}return c.$ECb}get html(){return this.a(),this.#a}set html(s){this.a(),this.#a!==s&&(this.#a=s,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(s)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(s)))}get options(){return this.a(),this.#o}set options(s){this.a(),T.$go(this.#o,s)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,s)),this.#o=s}async postMessage(s){if(this.#c)return!1;const i=(0,p.$Ysb)(s,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,i.message,...i.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(s){if(!this.#d)return s;const i=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return s.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,f,l,$,I,D)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),S=(0,c.$FCb)(y,{isRemote:i,authority:t}).toString();return`${f}${S}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(m,f,l,$,I,D)=>{const y=A.URI.from({scheme:$||"file",path:decodeURIComponent(I)}),S=(0,c.$FCb)(y,{isRemote:i,authority:t}).toString();return`${f}${S}${D}`})}}e.$5nc=v;function u(n){try{const s=(0,N.$Wp)((0,N.$Vp)(n.engines.vscode));return!!s&&s.majorBase>=1&&s.minorBase>=57}catch{return!1}}function E(n){try{const s=(0,N.$Wp)((0,N.$Vp)(n.engines.vscode));return s?s.majorBase<1||s.majorBase===1&&s.minorBase<60:!1}catch{return!1}}class d extends C.$Wc{constructor(s,i,t,m,f){super(),this.c=i,this.f=t,this.g=m,this.h=f,this.b=new Map,this.a=s.getProxy(R.$qN.MainThreadWebviews)}dispose(){super.dispose();for(const s of this.b.values())s.dispose();this.b.clear()}$onMessage(s,i,t){const m=this.j(s);if(m){const{message:f}=(0,p.$Zsb)(i,t.value);m._onMessageEmitter.fire(f)}}$onMissingCsp(s,i){this.g.warn(`${i} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(s,i,t){const m=new v(s,this.a,a(i),this.c,this.f,t,this.h);this.b.set(s,m);const f=m._onDidDispose(()=>{f.dispose(),this.deleteWebview(s)});return m}deleteWebview(s){this.b.delete(s)}j(s){return this.b.get(s)}}e.$7nc=d;function r(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,s,i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots||h(n,s)}}function a(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(s=>A.URI.from(s))}}function h(n,s){return[...(s?.getWorkspaceFolders()||[]).map(i=>i.uri),n.extensionLocation]}}),define(Ce[120],Ie([1,0,4,16,13,2,3,17,6]),function(oe,e,w,C,P,T,A,N,p){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0;let R=class{static{c=this}static{this.a={focused:!0,active:!0}}getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new w.$me,this.onDidChangeWindowState=this.c.event,this.d=c.a,this.b=u.getProxy(p.$qN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:E,isActive:d})=>{this.onDidChangeWindowProperty("focused",E),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,E){E!==this.d[u]&&(this.d={...this.d,[u]:E},this.c.fire(this.d))}openUri(u,E){let d;if(typeof u=="string"){d=u;try{u=T.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,P.$df)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===C.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,d,E)}async asExternalUri(u,E){if((0,P.$df)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(u,E);return T.URI.from(d)}};e.$Gpc=R,e.$Gpc=R=c=Qe([Ve(0,N.$WP)],R),e.$Hpc=(0,A.$Fi)("IExtHostWindow")}),define(Ce[265],Ie([1,0,254,27,17]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Urc=void 0;let T=class extends w.$Kpc{constructor(N,p){super(N,p)}f(N,p,c){p.apply(console,c)}};e.$Urc=T,e.$Urc=T=Qe([Ve(0,P.$WP),Ve(1,C.$aQ)],T)}),define(Ce[266],Ie([1,0,11,23,22,28,14,4,5,38,160,252,39]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=e.ResponsiveState=e.RequestInitiator=void 0,e.$$bc=h,e.$_bc=n,A=qe(A);function d(L,O){try{return JSON.stringify(L,O)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class a{constructor(O,q){this.jsonString=O,this.referencedBuffers=q}}function h(L,O=null,q=!1){const G=[];return{jsonString:(q?d:JSON.stringify)(L,(F,V)=>{if(typeof V>"u")return o;if(typeof V=="object"){if(V instanceof C.$Oe){const ce=G.push(V)-1;return{[r]:ce}}if(O)return O(F,V)}return V}),referencedBuffers:G}}function n(L,O,q){return JSON.parse(L,(G,W)=>{if(W){const F=W[r];if(typeof F=="number")return O[F];if(q&&W.$mid===c.MarshalledId.Uri)return q.transformIncoming(W)}return W})}function s(L,O){return JSON.stringify(L,O)}function i(L){return L?(O,q)=>q&&q.$mid===c.MarshalledId.Uri?L.transformOutgoing(q):q:null}var t;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var m;(function(L){L[L.Responsive=0]="Responsive",L[L.Unresponsive=1]="Unresponsive"})(m||(e.ResponsiveState=m={}));const f=()=>{},l=Symbol.for("rpcProtocol"),$=Symbol.for("rpcProxy");class I extends p.$Wc{static{E=l}static{this.a=3*1e3}constructor(O,q=null,G=null){super(),this[E]=!0,this.b=this.B(new N.$me),this.onDidChangeResponsiveState=this.b.event,this.c=O,this.f=q,this.g=G,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,F=u.$Nw.count;W<F;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=m.Responsive,this.z=0,this.C=0,this.D=this.B(new w.$Rh(()=>this.H(),1e3)),this.B(this.c.onMessage(W=>this.L(W)))}dispose(){this.j=!0,Object.keys(this.w).forEach(O=>{const q=this.w[O];delete this.w[O],q.resolveErr(A.$8())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(O){this.z===0&&(this.C=Date.now()+I.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(O){this.C=Date.now()+I.a,this.z--,this.z===0&&this.D.cancel(),this.I(m.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(m.Unresponsive):this.D.schedule())}I(O){this.y!==O&&(this.y=O,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(O){return this.g?(0,R.$Mn)(O,this.g):O}getProxy(O){const{nid:q,sid:G}=O;return this.s[q]||(this.s[q]=this.J(q,G)),this.s[q]}J(O,q){const G={get:(W,F)=>(typeof F=="string"&&!W[F]&&F.charCodeAt(0)===T.CharCode.DollarSign&&(W[F]=(...V)=>this.U(O,F,V)),F===$?q:W[F])};return new Proxy(Object.create(null),G)}set(O,q){return this.m[O.nid]=q,q}assertRegistered(O){for(let q=0,G=O.length;q<G;q++){const W=O[q];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(O){if(this.j)return;const q=O.byteLength,G=y.read(O,0),W=G.readUInt8(),F=G.readUInt32();switch(W){case g.RequestJSONArgs:case g.RequestJSONArgsWithCancellation:{let{rpcId:V,method:ce,args:ge}=k.deserializeRequestJSONArgs(G);this.g&&(ge=(0,R.$Mn)(ge,this.g)),this.M(q,F,V,ce,ge,W===g.RequestJSONArgsWithCancellation);break}case g.RequestMixedArgs:case g.RequestMixedArgsWithCancellation:{let{rpcId:V,method:ce,args:ge}=k.deserializeRequestMixedArgs(G);this.g&&(ge=(0,R.$Mn)(ge,this.g)),this.M(q,F,V,ce,ge,W===g.RequestMixedArgsWithCancellation);break}case g.Acknowledged:{this.f?.logIncoming(q,F,t.LocalSide,"ack"),this.G(F);break}case g.Cancel:{this.N(q,F);break}case g.ReplyOKEmpty:{this.O(q,F,void 0);break}case g.ReplyOKJSON:{let V=k.deserializeReplyOKJSON(G);this.g&&(V=(0,R.$Mn)(V,this.g)),this.O(q,F,V);break}case g.ReplyOKJSONWithBuffers:{const V=k.deserializeReplyOKJSONWithBuffers(G,this.g);this.O(q,F,V);break}case g.ReplyOKVSBuffer:{const V=k.deserializeReplyOKVSBuffer(G);this.O(q,F,V);break}case g.ReplyErrError:{let V=k.deserializeReplyErrError(G);this.g&&(V=(0,R.$Mn)(V,this.g)),this.P(q,F,V);break}case g.ReplyErrEmpty:{this.P(q,F,void 0);break}default:console.error("received unexpected message"),console.error(O)}}M(O,q,G,W,F,V){this.f?.logIncoming(O,q,t.OtherSide,`receiveRequest ${(0,u.$Pw)(G)}.${W}(`,F);const ce=String(q);let ge,te;if(V){const se=new P.$xe;F.push(se.token),ge=this.Q(G,W,F),te=()=>se.cancel()}else ge=this.Q(G,W,F),te=f;this.u[ce]=te;const me=k.serializeAcknowledged(q);this.f?.logOutgoing(me.byteLength,q,t.OtherSide,"ack"),this.c.send(me),ge.then(se=>{delete this.u[ce];const de=k.serializeReplyOK(q,se,this.h);this.f?.logOutgoing(de.byteLength,q,t.OtherSide,"reply:",se),this.c.send(de)},se=>{delete this.u[ce];const de=k.serializeReplyErr(q,se);this.f?.logOutgoing(de.byteLength,q,t.OtherSide,"replyErr:",se),this.c.send(de)})}N(O,q){this.f?.logIncoming(O,q,t.OtherSide,"receiveCancel");const G=String(q);this.u[G]?.()}O(O,q,G){this.f?.logIncoming(O,q,t.LocalSide,"receiveReply:",G);const W=String(q);if(!this.w.hasOwnProperty(W))return;const F=this.w[W];delete this.w[W],F.resolveOk(G)}P(O,q,G){this.f?.logIncoming(O,q,t.LocalSide,"receiveReplyErr:",G);const W=String(q);if(!this.w.hasOwnProperty(W))return;const F=this.w[W];delete this.w[W];let V;G&&(G.$isError?(V=new Error,V.name=G.name,V.message=G.message,V.stack=G.stack):V=G),F.resolveErr(V)}Q(O,q,G){try{return Promise.resolve(this.S(O,q,G))}catch(W){return Promise.reject(W)}}S(O,q,G){const W=this.m[O];if(!W)throw new Error("Unknown actor "+(0,u.$Pw)(O));const F=W[q];if(typeof F!="function")throw new Error("Unknown method "+q+" on actor "+(0,u.$Pw)(O));return F.apply(W,G)}U(O,q,G){if(this.j)return new v.$0bc;let W=null;if(G.length>0&&P.CancellationToken.isCancellationToken(G[G.length-1])&&(W=G.pop()),W&&W.isCancellationRequested)return Promise.reject(A.$8());const F=k.serializeRequestArguments(G,this.h),V=++this.t,ce=String(V),ge=new v.$9bc,te=new p.$Vc;W&&te.add(W.onCancellationRequested(()=>{const se=k.serializeCancel(V);this.f?.logOutgoing(se.byteLength,V,t.LocalSide,"cancel"),this.c.send(k.serializeCancel(V))})),this.w[ce]=new D(ge,te),this.F(V);const me=k.serializeRequest(V,O,q,F,!!W);return this.f?.logOutgoing(me.byteLength,V,t.LocalSide,`request: ${(0,u.$Pw)(O)}.${q}(`,G),this.c.send(me),ge}}e.$acc=I;class D{constructor(O,q){this.a=O,this.b=q}resolveOk(O){this.a.resolveOk(O),this.b.dispose()}resolveErr(O){this.a.resolveErr(O),this.b.dispose()}}class y{static alloc(O,q,G){const W=new y(C.$Oe.alloc(G+1+4),0);return W.writeUInt8(O),W.writeUInt32(q),W}static read(O,q){return new y(O,q)}get buffer(){return this.a}constructor(O,q){this.a=O,this.b=q}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(O){this.a.writeUInt8(O,this.b),this.b+=1}readUInt8(){const O=this.a.readUInt8(this.b);return this.b+=1,O}writeUInt32(O){this.a.writeUInt32BE(O,this.b),this.b+=4}readUInt32(){const O=this.a.readUInt32BE(this.b);return this.b+=4,O}static sizeShortString(O){return 1+O.byteLength}writeShortString(O){this.a.writeUInt8(O.byteLength,this.b),this.b+=1,this.a.set(O,this.b),this.b+=O.byteLength}readShortString(){const O=this.a.readUInt8(this.b);this.b+=1;const G=this.a.slice(this.b,this.b+O).toString();return this.b+=O,G}static sizeLongString(O){return 4+O.byteLength}writeLongString(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readLongString(){const O=this.a.readUInt32BE(this.b);this.b+=4;const G=this.a.slice(this.b,this.b+O).toString();return this.b+=O,G}writeBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}static sizeVSBuffer(O){return 4+O.byteLength}writeVSBuffer(O){this.a.writeUInt32BE(O.byteLength,this.b),this.b+=4,this.a.set(O,this.b),this.b+=O.byteLength}readVSBuffer(){const O=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+O);return this.b+=O,q}static sizeMixedArray(O){let q=0;q+=1;for(let G=0,W=O.length;G<W;G++){const F=O[G];switch(q+=1,F.type){case b.String:q+=this.sizeLongString(F.value);break;case b.VSBuffer:q+=this.sizeVSBuffer(F.value);break;case b.SerializedObjectWithBuffers:q+=this.sizeUInt32,q+=this.sizeLongString(F.value);for(let V=0;V<F.buffers.length;++V)q+=this.sizeVSBuffer(F.buffers[V]);break;case b.Undefined:break}}return q}writeMixedArray(O){this.a.writeUInt8(O.length,this.b),this.b+=1;for(let q=0,G=O.length;q<G;q++){const W=O[q];switch(W.type){case b.String:this.writeUInt8(b.String),this.writeLongString(W.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(W.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let F=0;F<W.buffers.length;++F)this.writeBuffer(W.buffers[F]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const O=this.a.readUInt8(this.b);this.b+=1;const q=new Array(O);for(let G=0;G<O;G++)switch(this.readUInt8()){case b.String:q[G]=this.readLongString();break;case b.VSBuffer:q[G]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const F=this.readUInt32(),V=this.readLongString(),ce=[];for(let ge=0;ge<F;++ge)ce.push(this.readVSBuffer());q[G]=new u.$Qw(n(V,ce,null));break}case b.Undefined:q[G]=void 0;break}return q}}var S;(function(L){L[L.Simple=0]="Simple",L[L.Mixed=1]="Mixed"})(S||(S={}));class k{static a(O){for(let q=0,G=O.length;q<G;q++)if(O[q]instanceof C.$Oe||O[q]instanceof u.$Qw||typeof O[q]>"u")return!0;return!1}static serializeRequestArguments(O,q){if(this.a(O)){const G=[];for(let W=0,F=O.length;W<F;W++){const V=O[W];if(V instanceof C.$Oe)G[W]={type:b.VSBuffer,value:V};else if(typeof V>"u")G[W]={type:b.Undefined};else if(V instanceof u.$Qw){const{jsonString:ce,referencedBuffers:ge}=h(V.value,q);G[W]={type:b.SerializedObjectWithBuffers,value:C.$Oe.fromString(ce),buffers:ge}}else G[W]={type:b.String,value:C.$Oe.fromString(s(V,q))}}return{type:S.Mixed,args:G}}return{type:S.Simple,args:s(O,q)}}static serializeRequest(O,q,G,W,F){switch(W.type){case S.Simple:return this.b(O,q,G,W.args,F);case S.Mixed:return this.c(O,q,G,W.args,F)}}static b(O,q,G,W,F){const V=C.$Oe.fromString(G),ce=C.$Oe.fromString(W);let ge=0;ge+=y.sizeUInt8(),ge+=y.sizeShortString(V),ge+=y.sizeLongString(ce);const te=y.alloc(F?g.RequestJSONArgsWithCancellation:g.RequestJSONArgs,O,ge);return te.writeUInt8(q),te.writeShortString(V),te.writeLongString(ce),te.buffer}static deserializeRequestJSONArgs(O){const q=O.readUInt8(),G=O.readShortString(),W=O.readLongString();return{rpcId:q,method:G,args:JSON.parse(W)}}static c(O,q,G,W,F){const V=C.$Oe.fromString(G);let ce=0;ce+=y.sizeUInt8(),ce+=y.sizeShortString(V),ce+=y.sizeMixedArray(W);const ge=y.alloc(F?g.RequestMixedArgsWithCancellation:g.RequestMixedArgs,O,ce);return ge.writeUInt8(q),ge.writeShortString(V),ge.writeMixedArray(W),ge.buffer}static deserializeRequestMixedArgs(O){const q=O.readUInt8(),G=O.readShortString(),W=O.readMixedArray(),F=new Array(W.length);for(let V=0,ce=W.length;V<ce;V++){const ge=W[V];typeof ge=="string"?F[V]=JSON.parse(ge):F[V]=ge}return{rpcId:q,method:G,args:F}}static serializeAcknowledged(O){return y.alloc(g.Acknowledged,O,0).buffer}static serializeCancel(O){return y.alloc(g.Cancel,O,0).buffer}static serializeReplyOK(O,q,G){if(typeof q>"u")return this.d(O);if(q instanceof C.$Oe)return this.e(O,q);if(q instanceof u.$Qw){const{jsonString:W,referencedBuffers:F}=h(q.value,G,!0);return this.g(O,W,F)}else return this.f(O,d(q,G))}static d(O){return y.alloc(g.ReplyOKEmpty,O,0).buffer}static e(O,q){let G=0;G+=y.sizeVSBuffer(q);const W=y.alloc(g.ReplyOKVSBuffer,O,G);return W.writeVSBuffer(q),W.buffer}static deserializeReplyOKVSBuffer(O){return O.readVSBuffer()}static f(O,q){const G=C.$Oe.fromString(q);let W=0;W+=y.sizeLongString(G);const F=y.alloc(g.ReplyOKJSON,O,W);return F.writeLongString(G),F.buffer}static g(O,q,G){const W=C.$Oe.fromString(q);let F=0;F+=y.sizeUInt32,F+=y.sizeLongString(W);for(const ce of G)F+=y.sizeVSBuffer(ce);const V=y.alloc(g.ReplyOKJSONWithBuffers,O,F);V.writeUInt32(G.length),V.writeLongString(W);for(const ce of G)V.writeBuffer(ce);return V.buffer}static deserializeReplyOKJSON(O){const q=O.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(O,q){const G=O.readUInt32(),W=O.readLongString(),F=[];for(let V=0;V<G;++V)F.push(O.readVSBuffer());return new u.$Qw(n(W,F,q))}static serializeReplyErr(O,q){const G=q?d(A.$5(q),null):void 0;if(typeof G!="string")return this.h(O);const W=C.$Oe.fromString(G);let F=0;F+=y.sizeLongString(W);const V=y.alloc(g.ReplyErrError,O,F);return V.writeLongString(W),V.buffer}static deserializeReplyErrError(O){const q=O.readLongString();return JSON.parse(q)}static h(O){return y.alloc(g.ReplyErrEmpty,O,0).buffer}}var g;(function(L){L[L.RequestJSONArgs=1]="RequestJSONArgs",L[L.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",L[L.RequestMixedArgs=3]="RequestMixedArgs",L[L.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",L[L.Acknowledged=5]="Acknowledged",L[L.Cancel=6]="Cancel",L[L.ReplyOKEmpty=7]="ReplyOKEmpty",L[L.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",L[L.ReplyOKJSON=9]="ReplyOKJSON",L[L.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",L[L.ReplyErrError=11]="ReplyErrError",L[L.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var b;(function(L){L[L.String=1]="String",L[L.VSBuffer=2]="VSBuffer",L[L.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",L[L.Undefined=4]="Undefined"})(b||(b={}))}),define(Ce[267],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wrc=void 0;const w=function(T){const A=N=>{globalThis.removeEventListener("message",A);const p=N.data;Object.defineProperties(globalThis,{postMessage:{value(c,R){p.postMessage(c,R)}},onmessage:{get(){return p.onmessage},set(c){p.onmessage=c}}}),p.addEventListener("message",c=>{globalThis.dispatchEvent(new MessageEvent("message",{data:c.data,ports:c.ports?[...c.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class C extends EventTarget{constructor(T,A,N){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${w})('${A}'))`,c=new Blob([p],{type:"application/javascript"}),R=URL.createObjectURL(c),v=new MessageChannel,u=R,E={type:"_newWorker",id:u,port:v.port2,url:R,options:N};T(E,[v.port2]),this.postMessage=v.port1.postMessage.bind(v.port1),this.terminate=()=>{T({type:"_terminateWorker",id:u}),URL.revokeObjectURL(R),v.port1.close(),v.port2.close()},Object.defineProperties(this,{onmessage:{get(){return v.port1.onmessage},set(d){v.port1.onmessage=d}},onmessageerror:{get(){return v.port1.onmessageerror},set(d){v.port1.onmessageerror=d}}}),v.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),v.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),v.port1.start()}}e.$Wrc=C}),define(Ce[268],Ie([1,0,23,29,16,61,3]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$MK=void 0,e.$NK=R,e.$OK=v,e.$MK=(0,A.$Fi)("notebookDocumentService");const N=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${N.join("")}]+`),c=7;function R(E){if(E.scheme!==P.Schemas.vscodeNotebookCell)return;const d=E.fragment.indexOf("s");if(d<0)return;const r=parseInt(E.fragment.substring(0,d).replace(p,""),c),o=(0,w.$8e)(E.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:E.with({scheme:o,fragment:null})}}function v(E,d){const r=d.toString(c),a=`${r.length<N.length?N[r.length-1]:"z"}${r}s${(0,w.$9e)(w.$Oe.fromString(E.scheme),!0,!0)}`;return E.with({scheme:P.Schemas.vscodeNotebookCell,fragment:a})}class u{constructor(){this.a=new C.$Cc}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=R(d);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$PK=u,(0,T.$Ls)(e.$MK,u,T.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,41,40,73,16,20,21,32,268]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xL=e.$uL=e.CellStatusbarAlignment=e.$tL=e.NotebookEditorPriority=e.$qL=e.$pL=e.$nL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$mL=e.$lL=e.$kL=e.$jL=e.CellKind=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=void 0,e.$oL=m,e.$rL=l,e.$sL=$,e.$vL=y,e.$wL=k,C=qe(C),e.$eL="workbench.editor.notebook",e.$fL="workbench.editor.notebookTextDiffEditor",e.$gL="workbench.editor.interactive",e.$hL="workbench.editor.repl",e.$iL="replNotebook.input.execute";var v;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(v||(e.CellKind=v={})),e.$jL=["application/json","application/javascript","text/html","image/svg+xml",T.$5s.latex,T.$5s.markdown,"image/png","image/jpeg",T.$5s.text],e.$kL=[T.$5s.latex,T.$5s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$5s.text],e.$lL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$mL="_notAvailable";var u;(function(V){V[V.Running=1]="Running",V[V.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var E;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var d;(function(V){V[V.Unconfirmed=1]="Unconfirmed",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(V){V[V.WithHardKernelDependency=0]="WithHardKernelDependency",V[V.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",V[V.Pure=2]="Pure",V[V.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(V){V.Always="always",V.Never="never",V.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var a;(function(V){V[V.ModelChange=1]="ModelChange",V[V.Move=2]="Move",V[V.ChangeCellLanguage=5]="ChangeCellLanguage",V[V.Initialize=6]="Initialize",V[V.ChangeCellMetadata=7]="ChangeCellMetadata",V[V.Output=8]="Output",V[V.OutputItem=9]="OutputItem",V[V.ChangeCellContent=10]="ChangeCellContent",V[V.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",V[V.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",V[V.ChangeCellMime=13]="ChangeCellMime",V[V.Unknown=100]="Unknown"})(a||(e.NotebookCellsChangeType=a={}));var h;(function(V){V[V.Handle=0]="Handle",V[V.Index=1]="Index"})(h||(e.SelectionStateType=h={}));var n;(function(V){V[V.Replace=1]="Replace",V[V.Output=2]="Output",V[V.Metadata=3]="Metadata",V[V.CellLanguage=4]="CellLanguage",V[V.DocumentMetadata=5]="DocumentMetadata",V[V.Move=6]="Move",V[V.OutputItems=7]="OutputItems",V[V.PartialMetadata=8]="PartialMetadata",V[V.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var s;(function(V){V.scheme=A.Schemas.vscodeNotebookCell;function ce(be,re){return(0,R.$OK)(be,re)}V.generate=ce;function ge(be){return(0,R.$NK)(be)}V.parse=ge;function te(be,re){return be.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${be.scheme!==A.Schemas.file?be.scheme:""}`})}V.generateCellOutputUri=te;function me(be){if(be.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!re)return;const Pe=re[1]&&re[1]!==""?re[1]:void 0,Le=re[2];return{outputId:Pe,notebook:be.with({scheme:Le||A.Schemas.file,fragment:null})}}V.parseCellOutputUri=me;function se(be,re,Pe){return V.generate(be,re).with({scheme:Pe})}V.generateCellPropertyUri=se;function de(be,re){if(be.scheme===re)return V.parse(be.with({scheme:V.scheme}))}V.parseCellPropertyUri=de})(s||(e.CellUri=s={}));const i=V=>p.$i?V.replace(/\//g,"\\"):V;class t{constructor(ce=[],ge=e.$jL){this.e=ge,this.d=[...new Set(ce)].map(te=>({pattern:te,matches:C.$zk(i(te))}))}sort(ce){const ge=new Map(P.Iterable.map(ce,me=>[me,i(me)]));let te=[];for(const{matches:me}of this.d)for(const[se,de]of ge)if(me(de)){te.push(se),ge.delete(se);break}return ge.size&&(te=te.concat([...ge.keys()].sort((me,se)=>this.e.indexOf(me)-this.e.indexOf(se)))),te}prioritize(ce,ge){const te=this.f(ce);if(te===-1){this.d.unshift({pattern:ce,matches:C.$zk(i(ce))});return}const me=new Set(ge.map(de=>this.f(de,te)));me.delete(-1);const se=Array.from(me).sort();this.d.splice(te+1,0,...se.map(de=>this.d[de]));for(let de=se.length-1;de>=0;de--)this.d.splice(se[de],1)}toArray(){return this.d.map(ce=>ce.pattern)}f(ce,ge=this.d.length){const te=i(ce);for(let me=0;me<ge;me++)if(this.d[me].matches(te))return me;return-1}}e.$nL=t;function m(V,ce,ge,te=(me,se)=>me===se){const me=[];function se(re,Pe,Le){if(Pe===0&&Le.length===0)return;const Y=me[me.length-1];Y&&Y.start+Y.deleteCount===re?(Y.deleteCount+=Pe,Y.toInsert.push(...Le)):me.push({start:re,deleteCount:Pe,toInsert:Le})}let de=0,be=0;for(;;){if(de===V.length){se(de,0,ce.slice(be));break}if(be===ce.length){se(de,V.length-de,[]);break}const re=V[de],Pe=ce[be];if(te(re,Pe)){de+=1,be+=1;continue}ge(Pe)?(se(de,1,[]),de+=1):(se(de,0,[Pe]),be+=1)}return me}e.$pL=new c.$Wj("notebookEditorCursorAtBoundary","none"),e.$qL=new c.$Wj("notebookEditorCursorAtLineBoundary","none");var f;(function(V){V.default="default",V.option="option"})(f||(e.NotebookEditorPriority=f={}));function l(V){const ce=V;return!!((typeof ce.include=="string"||C.$Ak(ce.include))&&(typeof ce.exclude=="string"||C.$Ak(ce.exclude)))}function $(V,ce,ge){if(Array.isArray(V.viewType)&&V.viewType.indexOf(ce)>=0||V.viewType===ce)return!0;if(V.filenamePattern){const te=l(V.filenamePattern)?V.filenamePattern.include:V.filenamePattern,me=l(V.filenamePattern)?V.filenamePattern.exclude:void 0;if(C.$yk(te,(0,N.$pc)(ge.fsPath).toLowerCase()))return!(me&&C.$yk(me,(0,N.$pc)(ge.fsPath).toLowerCase()))}return!1}e.$tL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var I;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(I||(e.CellStatusbarAlignment=I={}));class D{static{this.d="notebook/"}static create(ce){return`${D.d}${ce}`}static parse(ce){if(ce.startsWith(D.d))return ce.substring(D.d.length)}}e.$uL=D;function y(V){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(V)}const S=new TextDecoder;function k(V){const ce=[];let ge=!1;for(const de of V)(ce.length===0||ge)&&(ce.push(de),ge=!0);let te=L(ce);const me=w.$Oe.concat(ce.map(de=>w.$Oe.wrap(de))),se=F(me);return te=te||se.byteLength!==me.byteLength,{data:se,didCompression:te}}e.$xL="\x1B[A";const g=e.$xL.split("").map(V=>V.charCodeAt(0)),b=10;function L(V){let ce=!1;return V.forEach((ge,te)=>{if(te===0||ge.length<e.$xL.length)return;const me=V[te-1],se=ge.subarray(0,e.$xL.length);if(se[0]===g[0]&&se[1]===g[1]&&se[2]===g[2]){const de=me.lastIndexOf(b);if(de===-1)return;ce=!0,V[te-1]=me.subarray(0,de),V[te]=ge.subarray(e.$xL.length)}}),ce}function O(V){let ce=V;do V=ce,ce=V.replace(/[^\n]\x08/gm,"");while(ce.length<V.length);return V}function q(V){for(V=V.replace(/\r+\n/gm,`
`);V.search(/\r[^$]/g)>-1;){const ce=V.match(/^(.*)\r+/m)[1];let ge=V.match(/\r+(.*)$/m)[1];ge=ge+ce.slice(ge.length,ce.length),V=V.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ge)}return V}const G=8,W=13;function F(V){return!V.buffer.includes(G)&&!V.buffer.includes(W)?V:w.$Oe.fromString(q(O(S.decode(V.buffer))))}}),define(Ce[7],Ie([1,0,18,14,60,29,73,13,15,2,37,19,30,109,90]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d){"use strict";var r,o,a,h,n,s,i,t,m,f,l,$,I,D,y,S,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$LP=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.LanguageModelChatMessageRole=e.ChatLocation=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.$xP=e.$wP=e.$vP=e.$uP=e.$tP=e.$sP=e.$rP=e.$qP=e.$pP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$oP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.$cP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$bP=e.$aP=e.$_O=e.$$O=e.$9O=e.$8O=e.$7O=e.$6O=e.TestRunProfileKind=e.TestResultState=e.$5O=e.$4O=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$3O=e.NotebookVariablesRequestKind=e.$2O=e.$1O=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$ZO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.ColorThemeKind=e.$TO=e.$SO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$RO=e.$QO=e.DebugConsoleMode=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$KO=e.$JO=e.FileChangeType=e.$IO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$HO=e.$GO=e.$FO=e.$EO=e.InlineCompletionTriggerKind=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$rO=e.ConfigurationTarget=e.$qO=e.$pO=e.$oO=e.$nO=e.DocumentPasteTriggerKind=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$gO=e.ViewBadge=e.ProgressLocation=e.$fO=e.$eO=e.TaskScope=e.ShellQuoting=e.$dO=e.$cO=e.$bO=e.TaskPanelKind=e.TaskRevealKind=e.$aO=e.TerminalLocation=e.$_N=e.$$N=e.$0N=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$9N=e.$8N=e.$7N=e.$6N=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$4N=e.$3N=e.$2N=e.$1N=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$ZN=e.$YN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.LanguageStatusSeverity=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.CodeActionTriggerKind=e.$MN=e.$LN=e.SymbolTag=e.SymbolKind=e.$KN=e.$JN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.DiagnosticSeverity=e.DiagnosticTag=e.$DN=e.$CN=e.FileEditType=e.$BN=e.$AN=e.$zN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$5N=Ze,e.$sO=Ti,e.$0O=Sn;function g(j){return Object.assign(j,{apply:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const Se=ie.length===1?[]:ie[1];return Reflect.construct(j,Se,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(j,[]);{const[Se,...He]=ie;return Reflect.construct(j,He,Se.constructor)}}})}var b;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var L;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(L||(e.TerminalQuickFixType=L={}));let O=r=class{static from(...M){let ie=M;return new r(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$sN=O,e.$sN=O=r=Qe([g],O);let q=o=class{static Min(...M){if(M.length===0)throw new TypeError;let ie=M[0];for(let Se=1;Se<M.length;Se++){const He=M[Se];He.isBefore(ie)&&(ie=He)}return ie}static Max(...M){if(M.length===0)throw new TypeError;let ie=M[0];for(let Se=1;Se<M.length;Se++){const He=M[Se];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(M){if(!M)return!1;if(M instanceof o)return!0;const{line:ie,character:Se}=M;return typeof ie=="number"&&typeof Se=="number"}static of(M){if(M instanceof o)return M;if(this.isPosition(M))return new o(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,ie){if(M<0)throw(0,C.$9)("line must be non-negative");if(ie<0)throw(0,C.$9)("character must be non-negative");this.c=M,this.e=ie}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,ie=0){if(M===null||ie===null)throw(0,C.$9)();let Se;return typeof M>"u"?Se=0:typeof M=="number"?Se=M:(Se=typeof M.lineDelta=="number"?M.lineDelta:0,ie=typeof M.characterDelta=="number"?M.characterDelta:0),Se===0&&ie===0?this:new o(this.line+Se,this.character+ie)}with(M,ie=this.character){if(M===null||ie===null)throw(0,C.$9)();let Se;return typeof M>"u"?Se=this.line:typeof M=="number"?Se=M:(Se=typeof M.line=="number"?M.line:this.line,ie=typeof M.character=="number"?M.character:this.character),Se===this.line&&ie===this.character?this:new o(Se,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$tN=q,e.$tN=q=o=Qe([g],q);let G=a=class{static isRange(M){return M instanceof a?!0:M?q.isPosition(M.start)&&q.isPosition(M.end):!1}static of(M){if(M instanceof a)return M;if(this.isRange(M))return new a(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,ie,Se,He){let et,ft;if(typeof M=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof He=="number"?(et=new q(M,ie),ft=new q(Se,He)):q.isPosition(M)&&q.isPosition(ie)&&(et=q.of(M),ft=q.of(ie)),!et||!ft)throw new Error("Invalid arguments");et.isBefore(ft)?(this.c=et,this.e=ft):(this.c=ft,this.e=et)}contains(M){return a.isRange(M)?this.contains(M.start)&&this.contains(M.end):q.isPosition(M)?!(q.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const ie=q.Max(M.start,this.c),Se=q.Min(M.end,this.e);if(!ie.isAfter(Se))return new a(ie,Se)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ie=q.Min(M.start,this.c),Se=q.Max(M.end,this.end);return new a(ie,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,ie=this.end){if(M===null||ie===null)throw(0,C.$9)();let Se;return M?q.isPosition(M)?Se=M:(Se=M.start||this.start,ie=M.end||this.end):Se=this.start,Se.isEqual(this.c)&&ie.isEqual(this.end)?this:new a(Se,ie)}toJSON(){return[this.start,this.end]}};e.$uN=G,e.$uN=G=a=Qe([g],G);let W=h=class extends G{static isSelection(M){return M instanceof h?!0:M?G.isRange(M)&&q.isPosition(M.anchor)&&q.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,ie,Se,He){let et,ft;if(typeof M=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof He=="number"?(et=new q(M,ie),ft=new q(Se,He)):q.isPosition(M)&&q.isPosition(ie)&&(et=q.of(M),ft=q.of(ie)),!et||!ft)throw new Error("Invalid arguments");super(et,ft),this.f=et,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$vN=W,e.$vN=W=h=Qe([g],W);const F=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,C.$9)("connectionToken")};class V{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ie,Se){if(typeof M!="string"||M.length===0)throw(0,C.$9)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,C.$9)("port");typeof Se<"u"&&F(Se),this.host=M,this.port=Math.round(ie),this.connectionToken=Se}}e.$wN=V;class ce{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,ie){this.makeConnection=M,this.connectionToken=ie,typeof ie<"u"&&F(ie)}}e.$xN=ce;class ge extends Error{static NotAvailable(M,ie){return new ge(M,E.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(M){return new ge(M,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,ie=E.RemoteAuthorityResolverErrorCode.Unknown,Se){super(M),this._message=M,this._code=ie,this._detail=Se,Object.setPrototypeOf(this,ge.prototype)}}e.$yN=ge;var te;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(te||(e.EndOfLine=te={}));var me;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(me||(e.EnvironmentVariableMutatorType=me={}));let se=n=class{static isTextEdit(M){return M instanceof n?!0:M?G.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ie){return new n(M,ie)}static insert(M,ie){return n.replace(new G(M,M),ie)}static delete(M){return n.replace(M,"")}static setEndOfLine(M){const ie=new n(new G(new q(0,0),new q(0,0)),"");return ie.newEol=M,ie}get range(){return this.c}set range(M){if(M&&!G.isRange(M))throw(0,C.$9)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,C.$9)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,C.$9)("newEol");this.f=M}constructor(M,ie){this.c=M,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$zN=se,e.$zN=se=n=Qe([g],se);let de=s=class{static isNotebookCellEdit(M){return M instanceof s?!0:M?yi.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,ie){return new s(M,ie)}static insertCells(M,ie){return new s(new yi(M,M),ie)}static deleteCells(M){return new s(M,[])}static updateCellMetadata(M,ie){const Se=new s(new yi(M,M),[]);return Se.newCellMetadata=ie,Se}static updateNotebookMetadata(M){const ie=new s(new yi(0,0),[]);return ie.newNotebookMetadata=M,ie}constructor(M,ie){this.range=M,this.newCells=ie}};e.$AN=de,e.$AN=de=s=Qe([g],de);class be{static isSnippetTextEdit(M){return M instanceof be?!0:M?G.isRange(M.range)&&Le.isSnippetString(M.snippet):!1}static replace(M,ie){return new be(M,ie)}static insert(M,ie){return be.replace(new G(M,M),ie)}constructor(M,ie){this.range=M,this.snippet=ie}}e.$BN=be;var re;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let Pe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,ie,Se,He){this.c.push({_type:re.File,from:M,to:ie,options:Se,metadata:He})}createFile(M,ie,Se){this.c.push({_type:re.File,from:void 0,to:M,options:ie,metadata:Se})}deleteFile(M,ie,Se){this.c.push({_type:re.File,from:M,to:void 0,options:ie,metadata:Se})}e(M,ie,Se){this.c.push({_type:re.Cell,metadata:Se,uri:M,edit:{editType:d.CellEditType.DocumentMetadata,metadata:ie},notebookMetadata:ie})}f(M,ie,Se,He){const et=ie.start,ft=ie.end;(et!==ft||Se.length>0)&&this.c.push({_type:re.CellReplace,uri:M,index:et,count:ft-et,cells:Se,metadata:He})}g(M,ie,Se,He){this.c.push({_type:re.Cell,metadata:He,uri:M,edit:{editType:d.CellEditType.Metadata,index:ie,metadata:Se}})}replace(M,ie,Se,He){this.c.push({_type:re.Text,uri:M,edit:new se(ie,Se),metadata:He})}insert(M,ie,Se,He){this.replace(M,new G(ie,ie),Se,He)}delete(M,ie,Se){this.replace(M,ie,"",Se)}has(M){return this.c.some(ie=>ie._type===re.Text&&ie.uri.toString()===M.toString())}set(M,ie){if(ie)for(const Se of ie){if(!Se)continue;let He,et;Array.isArray(Se)?(He=Se[0],et=Se[1]):He=Se,de.isNotebookCellEdit(He)?He.newCellMetadata?this.g(M,He.range.start,He.newCellMetadata,et):He.newNotebookMetadata?this.e(M,He.newNotebookMetadata,et):this.f(M,He.range,He.newCells,et):be.isSnippetTextEdit(He)?this.c.push({_type:re.Snippet,uri:M,range:He.range,edit:He.snippet,metadata:et}):this.c.push({_type:re.Text,uri:M,edit:He,metadata:et})}else{for(let Se=0;Se<this.c.length;Se++){const He=this.c[Se];switch(He._type){case re.Text:case re.Snippet:case re.Cell:case re.CellReplace:He.uri.toString()===M.toString()&&(this.c[Se]=void 0);break}}(0,w.$Kb)(this.c)}}get(M){const ie=[];for(const Se of this.c)Se._type===re.Text&&Se.uri.toString()===M.toString()&&ie.push(Se.edit);return ie}entries(){const M=new T.$Cc;for(const ie of this.c)if(ie._type===re.Text){let Se=M.get(ie.uri);Se||(Se=[ie.uri,[]],M.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$CN=Pe,e.$CN=Pe=Qe([g],Pe);let Le=i=class{static isSnippetString(M){return M instanceof i?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=i.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ie=this.e++){if(typeof M=="function"){const Se=new i;Se.e=this.e,M(Se),this.e=Se.e,M=Se.value}else M=i.c(M);return this.value+="${",this.value+=ie,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ie=this.e++){const Se=M.map(He=>He.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(M,ie){if(typeof ie=="function"){const Se=new i;Se.e=this.e,ie(Se),this.e=Se.e,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$DN=Le,e.$DN=Le=i=Qe([g],Le);var Y;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var B;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(B||(e.DiagnosticSeverity=B={}));let _=t=class{static isLocation(M){return M instanceof t?!0:M?G.isRange(M.range)&&c.URI.isUri(M.uri):!1}constructor(M,ie){if(this.uri=M,ie)if(G.isRange(ie))this.range=G.of(ie);else if(q.isPosition(ie))this.range=new G(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$EN=_,e.$EN=_=t=Qe([g],_);let ve=class{static is(M){return M?typeof M.message=="string"&&M.location&&G.isRange(M.location.range)&&c.URI.isUri(M.location.uri):!1}constructor(M,ie){this.location=M,this.message=ie}static isEqual(M,ie){return M===ie?!0:!M||!ie?!1:M.message===ie.message&&M.location.range.isEqual(ie.location.range)&&M.location.uri.toString()===ie.location.uri.toString()}};e.$FN=ve,e.$FN=ve=Qe([g],ve);let ae=class{constructor(M,ie,Se=B.Error){if(!G.isRange(M))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=M,this.message=ie,this.severity=Se}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ie){return M===ie?!0:!M||!ie?!1:M.message===ie.message&&M.severity===ie.severity&&M.code===ie.code&&M.severity===ie.severity&&M.source===ie.source&&M.range.isEqual(ie.range)&&(0,w.$wb)(M.tags,ie.tags)&&(0,w.$wb)(M.relatedInformation,ie.relatedInformation,ve.isEqual)}};e.$GN=ae,e.$GN=ae=Qe([g],ae);let we=class{constructor(M,ie){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ie}};e.$HN=we,e.$HN=we=Qe([g],we);let le=class extends we{constructor(M,ie,Se,He){super(M,ie),this.canIncreaseHover=Se,this.canDecreaseHover=He}};e.$IN=le,e.$IN=le=Qe([g],le);var X;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(X||(e.HoverVerbosityAction=X={}));var Z;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Z||(e.DocumentHighlightKind=Z={}));let pe=class{constructor(M,ie=Z.Text){this.range=M,this.kind=ie}toJSON(){return{range:this.range,kind:Z[this.kind]}}};e.$JN=pe,e.$JN=pe=Qe([g],pe);let $e=class{constructor(M,ie){this.uri=M,this.highlights=ie}toJSON(){return{uri:this.uri,highlights:this.highlights.map(M=>M.toJSON())}}};e.$KN=$e,e.$KN=$e=Qe([g],$e);var Ne;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Ne||(e.SymbolKind=Ne={}));var ze;(function(j){j[j.Deprecated=1]="Deprecated"})(ze||(e.SymbolTag=ze={}));let ke=m=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,ie,Se,He,et){this.name=M,this.kind=ie,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),He instanceof _?this.location=He:Se instanceof G&&(this.location=new _(He,Se)),m.validate(this)}toJSON(){return{name:this.name,kind:Ne[this.kind],location:this.location,containerName:this.containerName}}};e.$LN=ke,e.$LN=ke=m=Qe([g],ke);let Re=f=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(f.validate)}constructor(M,ie,Se,He,et){this.name=M,this.detail=ie,this.kind=Se,this.range=He,this.selectionRange=et,this.children=[],f.validate(this)}};e.$MN=Re,e.$MN=Re=f=Qe([g],Re);var Te;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let U=class{constructor(M,ie){this.title=M,this.kind=ie}};e.$NN=U,e.$NN=U=Qe([g],U);let z=class{static{l=this}static{this.c="."}constructor(M){this.value=M}append(M){return new l(this.value?this.value+l.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+l.c)}};e.$ON=z,e.$ON=z=l=Qe([g],z),z.Empty=new z(""),z.QuickFix=z.Empty.append("quickfix"),z.Refactor=z.Empty.append("refactor"),z.RefactorExtract=z.Refactor.append("extract"),z.RefactorInline=z.Refactor.append("inline"),z.RefactorMove=z.Refactor.append("move"),z.RefactorRewrite=z.Refactor.append("rewrite"),z.Source=z.Empty.append("source"),z.SourceOrganizeImports=z.Source.append("organizeImports"),z.SourceFixAll=z.Source.append("fixAll"),z.Notebook=z.Empty.append("notebook");let K=class{constructor(M,ie){if(this.range=M,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$PN=K,e.$PN=K=Qe([g],K);class H{constructor(M,ie,Se,He,et,ft){this.kind=M,this.name=ie,this.detail=Se,this.uri=He,this.range=et,this.selectionRange=ft}}e.$QN=H;class ne{constructor(M,ie){this.fromRanges=ie,this.from=M}}e.$RN=ne;class fe{constructor(M,ie){this.fromRanges=ie,this.to=M}}e.$SN=fe;var Ae;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let Ue=class{constructor(M,ie){this.range=M,this.command=ie}get isResolved(){return!!this.command}};e.$TN=Ue,e.$TN=Ue=Qe([g],Ue);let Ke=$=class{#e;static isMarkdownString(M){return M instanceof $?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,ie=!1){this.#e=new P.$3k(M,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,ie){return this.#e.appendCodeblock(ie??"",M),this}};e.$UN=Ke,e.$UN=Ke=$=Qe([g],Ke);let _e=class{constructor(M,ie){this.label=M,this.documentation=ie}};e.$VN=_e,e.$VN=_e=Qe([g],_e);let it=class{constructor(M,ie){this.label=M,this.documentation=ie,this.parameters=[]}};e.$WN=it,e.$WN=it=Qe([g],it);let nt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$XN=nt,e.$XN=nt=Qe([g],nt);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var rt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let $t=class{constructor(M){this.value=M}};e.$YN=$t,e.$YN=$t=Qe([g],$t);let lt=class{constructor(M,ie,Se){this.position=M,this.label=ie,this.kind=Se}};e.$ZN=lt,e.$ZN=lt=Qe([g],lt);var st;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var ct;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ct||(e.CompletionItemKind=ct={}));var gt;(function(j){j[j.Deprecated=1]="Deprecated"})(gt||(e.CompletionItemTag=gt={}));let mt=class{constructor(M,ie){this.label=M,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&ct[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$1N=mt,e.$1N=mt=Qe([g],mt);let Be=class{constructor(M=[],ie=!1){this.items=M,this.isIncomplete=ie}};e.$2N=Be,e.$2N=Be=Qe([g],Be);let je=class{constructor(M,ie,Se){this.insertText=M,this.range=ie,this.command=Se}};e.$3N=je,e.$3N=je=Qe([g],je);let Q=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$4N=Q,e.$4N=Q=Qe([g],Q);var x;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(x||(e.PartialAcceptTriggerKind=x={}));var De;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(De||(e.ViewColumn=De={}));var Xe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Xe||(e.StatusBarAlignment=Xe={}));function Ze(j,M){return`${v.$qn.toKey(j)}.${M}`}var dt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(dt||(e.TextEditorLineNumbersStyle=dt={}));var pt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(pt||(e.TextDocumentSaveReason=pt={}));var Lt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Lt||(e.TextEditorRevealType=Lt={}));var jt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var xt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(xt||(e.TextDocumentChangeReason=xt={}));var li;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(li||(e.DecorationRangeBehavior=li={})),function(j){function M(ie){switch(ie){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=M}(jt||(e.TextEditorSelectionChangeKind=jt={}));var xe;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(xe||(e.SyntaxTokenType=xe={})),function(j){function M(ie){switch(ie){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=M}(xe||(e.SyntaxTokenType=xe={}));let It=class{constructor(M,ie){if(ie&&!c.URI.isUri(ie))throw(0,C.$9)("target");if(!G.isRange(M)||M.isEmpty)throw(0,C.$9)("range");this.range=M,this.target=ie}};e.$6N=It,e.$6N=It=Qe([g],It);let Gt=class{constructor(M,ie,Se,He){this.red=M,this.green=ie,this.blue=Se,this.alpha=He}};e.$7N=Gt,e.$7N=Gt=Qe([g],Gt);let ht=class{constructor(M,ie){if(ie&&!(ie instanceof Gt))throw(0,C.$9)("color");if(!G.isRange(M)||M.isEmpty)throw(0,C.$9)("range");this.range=M,this.color=ie}};e.$8N=ht,e.$8N=ht=Qe([g],ht);let bt=class{constructor(M){if(!M||typeof M!="string")throw(0,C.$9)("label");this.label=M}};e.$9N=bt,e.$9N=bt=Qe([g],bt);var hi;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(hi||(e.ColorFormat=hi={}));var _t;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(_t||(e.SourceControlInputBoxValidationType=_t={}));var Bt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Bt||(e.TerminalExitReason=Bt={}));var wt;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(wt||(e.TerminalShellExecutionCommandLineConfidence=wt={}));class Wt{constructor(M,ie,Se){if(this.startIndex=M,this.length=ie,this.tooltip=Se,typeof M!="number"||M<0)throw(0,C.$9)("startIndex");if(typeof ie!="number"||ie<1)throw(0,C.$9)("length");if(Se!==void 0&&typeof Se!="string")throw(0,C.$9)("tooltip")}}e.$0N=Wt;class Ht{constructor(M){this.uri=M}}e.$$N=Ht;class Jt{constructor(M){this.terminalCommand=M}}e.$_N=Jt;var Je;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Je||(e.TerminalLocation=Je={}));class pi{constructor(M){if(this.options=M,typeof M!="object")throw(0,C.$9)("options")}}e.$aO=pi;var ei;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ei||(e.TaskRevealKind=ei={}));var si;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(si||(e.TaskPanelKind=si={}));let St=class{static{I=this}static{this.Clean=new I("clean","Clean")}static{this.Build=new I("build","Build")}static{this.Rebuild=new I("rebuild","Rebuild")}static{this.Test=new I("test","Test")}static from(M){switch(M){case"clean":return I.Clean;case"build":return I.Build;case"rebuild":return I.Rebuild;case"test":return I.Test;default:return}}constructor(M,ie){if(this.label=ie,typeof M!="string"||typeof ie!="string")throw(0,C.$9)("name");this.c=M}get id(){return this.c}};e.$bO=St,e.$bO=St=I=Qe([g],St);function Kt(j){let M="";for(let ie=0;ie<j.length;ie++)M+=j[ie].replace(/,/g,",,")+",";return M}let At=class{constructor(M,ie,Se){if(typeof M!="string")throw(0,C.$9)("process");this.e=[],this.c=M,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=Se):this.f=ie)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,C.$9)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)M.push(ie);return Kt(M)}};e.$cO=At,e.$cO=At=Qe([g],At);let Ft=class{constructor(M,ie,Se){if(this.f=[],Array.isArray(ie)){if(!M)throw(0,C.$9)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,C.$9)("command");this.e=M,this.f=ie,this.g=Se}else{if(typeof M!="string")throw(0,C.$9)("commandLine");this.c=M,this.g=ie}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,C.$9)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,C.$9)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)M.push(typeof ie=="string"?ie:ie.value);return Kt(M)}};e.$dO=Ft,e.$dO=Ft=Qe([g],Ft);var ti;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ti||(e.ShellQuoting=ti={}));var ii;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ii||(e.TaskScope=ii={}));class oi{constructor(M){this.c=M}computeId(){return"customExecution"+(0,R.$2g)()}set callback(M){this.c=M}get callback(){return this.c}}e.$eO=oi;let Ut=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,ie,Se,He,et,ft){this.k=!1,this.l=this.definition=M;let yt;typeof ie=="string"?(this.o=this.name=ie,this.w=this.source=Se,this.execution=He,yt=et,this.k=!0):ie===ii.Global||ie===ii.Workspace?(this.target=ie,this.o=this.name=Se,this.w=this.source=He,this.execution=et,yt=ft):(this.target=ie,this.o=this.name=Se,this.w=this.source=He,this.execution=et,yt=ft),typeof yt=="string"?(this.r=[yt],this.t=!0):Array.isArray(yt)?(this.r=yt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(M){this.j=M}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof At?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,R.$2g)()}}get definition(){return this.l}set definition(M){if(M==null)throw(0,C.$9)("Kind can't be undefined or null");this.B(),this.l=M}get scope(){return this.m}set target(M){this.B(),this.m=M}get name(){return this.o}set name(M){if(typeof M!="string")throw(0,C.$9)("name");this.B(),this.o=M}get execution(){return this.q}set execution(M){M===null&&(M=void 0),this.B(),this.q=M;const ie=this.l.type;(D.g===ie||D.e===ie||D.f===ie||D.c===ie)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(M){if(Array.isArray(M))this.B(),this.r=M,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.B(),this.u=M}get source(){return this.w}set source(M){if(typeof M!="string"||M.length===0)throw(0,C.$9)("source must be a string of length > 0");this.B(),this.w=M}get group(){return this.x}set group(M){M===null&&(M=void 0),this.B(),this.x=M}get detail(){return this.A}set detail(M){M===null&&(M=void 0),this.A=M}get presentationOptions(){return this.y}set presentationOptions(M){M==null&&(M=Object.create(null)),this.B(),this.y=M}get runOptions(){return this.z}set runOptions(M){M==null&&(M=Object.create(null)),this.B(),this.z=M}};e.$fO=Ut,e.$fO=Ut=D=Qe([g],Ut);var Qt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var di;(function(j){function M(ie){const Se=ie;return(0,p.$jg)(Se.value)?Se.tooltip&&!(0,p.$fg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}j.isViewBadge=M})(di||(e.ViewBadge=di={}));let Mt=y=class{static isTreeItem(M,ie){const Se=M;if(Se.checkboxState!==void 0){const He=(0,p.$jg)(Se.checkboxState)?Se.checkboxState:(0,p.$hg)(Se.checkboxState)&&(0,p.$jg)(Se.checkboxState.state)?Se.checkboxState.state:void 0,et=!(0,p.$jg)(Se.checkboxState)&&(0,p.$hg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(He===void 0||He!==Ct.Checked&&He!==Ct.Unchecked||et!==void 0&&!(0,p.$fg)(et))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(M instanceof y)return!0;if(Se.label!==void 0&&!(0,p.$fg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$fg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$fg)(Se.iconPath)&&!c.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$fg)(Se.iconPath.id))){const He=Se.iconPath;if(!He||!(0,p.$fg)(He.light)&&!c.URI.isUri(He.light)&&!(0,p.$fg)(He.dark)&&!c.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$fg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!c.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$fg)(Se.tooltip)&&!(Se.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<vt.None&&Se.collapsibleState>vt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$fg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(M,ie=vt.None){this.collapsibleState=ie,c.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$gO=Mt,e.$gO=Mt=y=Qe([g],Mt);var vt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(vt||(e.TreeItemCollapsibleState=vt={}));var Ct;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Ct||(e.TreeItemCheckboxState=Ct={}));let Ot=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$hO=Ot,e.$hO=Ot=Qe([g],Ot);class kt extends Ot{}e.$iO=kt;class Xt extends kt{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$jO=Xt;class qt{constructor(M,ie,Se,He){this.name=M,this.uri=ie,this._itemId=Se,this.c=He}data(){return this.c()}}e.$kO=qt;let $i=class{#e=new Map;constructor(M){for(const[ie,Se]of M??[]){const He=this.#e.get(this.#t(ie));He?He.push(Se):this.#e.set(this.#t(ie),[Se])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,ie){this.#e.set(this.#t(M),[ie])}forEach(M,ie){for(const[Se,He]of this.#e)for(const et of He)M.call(ie,et,Se,this)}*[Symbol.iterator](){for(const[M,ie]of this.#e)for(const Se of ie)yield[M,Se]}#t(M){return M.toLowerCase()}};e.$lO=$i,e.$lO=$i=Qe([g],$i);let fi=class{constructor(M,ie,Se){this.insertText=M,this.title=ie,this.kind=Se}};e.$mO=fi,e.$mO=fi=Qe([g],fi);var Ri;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(Ri||(e.DocumentPasteTriggerKind=Ri={}));class Nt{static{this.c="."}constructor(M){this.value=M}append(...M){return new Nt((this.value?[this.value,...M]:M).join(Nt.c))}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+Nt.c)}}e.$nO=Nt,Nt.Empty=new Nt("");class Oi{constructor(M,ie,Se){this.title=ie,this.insertText=M,this.kind=Se}}e.$oO=Oi;let ai=class{constructor(M,ie){this.id=M,this.color=ie}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$pO=ai,e.$pO=ai=Qe([g],ai),ai.File=new ai("file"),ai.Folder=new ai("folder");let Rt=class{constructor(M){this.id=M}};e.$qO=Rt,e.$qO=Rt=Qe([g],Rt);var Di;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Di||(e.ConfigurationTarget=Di={}));let Si=class{get base(){return this.c}set base(M){this.c=M,this.e=c.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,ie){if(typeof M!="string"&&(!M||!c.URI.isUri(M)&&!c.URI.isUri(M.uri)))throw(0,C.$9)("base");if(typeof ie!="string")throw(0,C.$9)("pattern");typeof M=="string"?this.baseUri=c.URI.file(M):c.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$rO=Si,e.$rO=Si=Qe([g],Si);const vi=new WeakMap;function Ti(j,M){vi.set(j,M)}let gi=class{constructor(M,ie,Se,He,et){this.enabled=typeof M=="boolean"?M:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof He=="string"&&(this.logMessage=He),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=vi.get(this)??(0,R.$2g)()),this.c}};e.$tO=gi,e.$tO=gi=Qe([g],gi);let Vt=class extends gi{constructor(M,ie,Se,He,et,ft){if(super(ie,Se,He,et,ft),M===null)throw(0,C.$9)("location");this.location=M}};e.$uO=Vt,e.$uO=Vt=Qe([g],Vt);let ye=class extends gi{constructor(M,ie,Se,He,et,ft){super(ie,Se,He,et,ft),this.functionName=M}};e.$vO=ye,e.$vO=ye=Qe([g],ye);let Oe=class extends gi{constructor(M,ie,Se,He,et,ft,yt,Zt){if(super(He,et,ft,yt,Zt),!ie)throw(0,C.$9)("dataId");this.label=M,this.dataId=ie,this.canPersist=Se}};e.$wO=Oe,e.$wO=Oe=Qe([g],Oe);let ue=class{constructor(M,ie,Se){this.command=M,this.args=ie||[],this.options=Se}};e.$xO=ue,e.$xO=ue=Qe([g],ue);let J=class{constructor(M,ie){this.port=M,this.host=ie}};e.$yO=J,e.$yO=J=Qe([g],J);let Ee=class{constructor(M){this.path=M}};e.$zO=Ee,e.$zO=Ee=Qe([g],Ee);let We=class{constructor(M){this.implementation=M}};e.$AO=We,e.$AO=We=Qe([g],We);class Ye{constructor(M,ie,Se){this.session=M,this.threadId=ie,this.frameId=Se}}e.$BO=Ye;class Ge{constructor(M,ie){this.session=M,this.threadId=ie}}e.$CO=Ge;let ut=class{constructor(M,ie){this.range=M,this.expression=ie}};e.$DO=ut,e.$DO=ut=Qe([g],ut);var Pt;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Pt||(e.InlineCompletionTriggerKind=Pt={}));let Yt=class{constructor(M,ie){this.range=M,this.text=ie}};e.$EO=Yt,e.$EO=Yt=Qe([g],Yt);let ci=class{constructor(M,ie,Se=!0){this.range=M,this.variableName=ie,this.caseSensitiveLookup=Se}};e.$FO=ci,e.$FO=ci=Qe([g],ci);let zt=class{constructor(M,ie){this.range=M,this.expression=ie}};e.$GO=zt,e.$GO=zt=Qe([g],zt);let ni=class{constructor(M,ie){this.frameId=M,this.stoppedLocation=ie}};e.$HO=ni,e.$HO=ni=Qe([g],ni);var ji;(function(j){j[j.AIGenerated=1]="AIGenerated"})(ji||(e.NewSymbolNameTag=ji={}));var Zi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Zi||(e.NewSymbolNameTriggerKind=Zi={}));class Bi{constructor(M,ie){this.newSymbolName=M,this.tags=ie}}e.$IO=Bi;var Fi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Wi=S=class extends Error{static FileExists(M){return new S(M,u.FileSystemProviderErrorCode.FileExists,S.FileExists)}static FileNotFound(M){return new S(M,u.FileSystemProviderErrorCode.FileNotFound,S.FileNotFound)}static FileNotADirectory(M){return new S(M,u.FileSystemProviderErrorCode.FileNotADirectory,S.FileNotADirectory)}static FileIsADirectory(M){return new S(M,u.FileSystemProviderErrorCode.FileIsADirectory,S.FileIsADirectory)}static NoPermissions(M){return new S(M,u.FileSystemProviderErrorCode.NoPermissions,S.NoPermissions)}static Unavailable(M){return new S(M,u.FileSystemProviderErrorCode.Unavailable,S.Unavailable)}constructor(M,ie=u.FileSystemProviderErrorCode.Unknown,Se){super(c.URI.isUri(M)?M.toString(!0):M),this.code=Se?.name??"Unknown",(0,u.$ol)(this,ie),Object.setPrototypeOf(this,S.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$JO=Wi,e.$JO=Wi=S=Qe([g],Wi);let Vi=class{constructor(M,ie,Se){this.start=M,this.end=ie,this.kind=Se}};e.$KO=Vi,e.$KO=Vi=Qe([g],Vi);var ki;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(xi||(e.CommentThreadCollapsibleState=xi={}));var _i;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(_i||(e.CommentMode=_i={}));var Li;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Li||(e.CommentState=Li={}));var en;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(en||(e.CommentThreadState=en={}));var qi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(qi||(e.CommentThreadApplicability=qi={}));class pn{constructor(M,ie=[]){this.tokenTypes=M,this.tokenModifiers=ie}}e.$LO=pn;function tn(j){return typeof j>"u"||(0,p.$gg)(j)}class Gi{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,M){this.m=!0;for(let ie=0,Se=M.tokenTypes.length;ie<Se;ie++)this.k.set(M.tokenTypes[ie],ie);for(let ie=0,Se=M.tokenModifiers.length;ie<Se;ie++)this.l.set(M.tokenModifiers[ie],ie)}}push(M,ie,Se,He,et){if(typeof M=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof He=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(M,ie,Se,He,et);if(G.isRange(M)&&typeof ie=="string"&&tn(Se))return this.o(M,ie,Se);throw(0,C.$9)()}o(M,ie,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=M.start.line,et=M.start.character,ft=M.end.character-M.start.character,yt=this.k.get(ie);let Zt=0;if(Se)for(const mi of Se){if(!this.l.has(mi))throw new Error("`tokenModifier` is not in the provided legend");const wi=this.l.get(mi);Zt|=1<<wi>>>0}this.q(He,et,ft,yt,Zt)}q(M,ie,Se,He,et){if(this.f&&(M<this.c||M===this.c&&ie<this.e)){this.f=!1;const Zt=this.g.length/5|0;let mi=0,wi=0;for(let Ei=0;Ei<Zt;Ei++){let Pi=this.g[5*Ei],Xi=this.g[5*Ei+1];Pi===0?(Pi=mi,Xi+=wi):Pi+=mi,this.g[5*Ei]=Pi,this.g[5*Ei+1]=Xi,mi=Pi,wi=Xi}}let ft=M,yt=ie;this.f&&this.j>0&&(ft-=this.c,ft===0&&(yt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=yt,this.g[this.j++]=Se,this.g[this.j++]=He,this.g[this.j++]=et,this.c=M,this.e=ie}static r(M){const ie=[],Se=M.length/5|0;for(let yt=0;yt<Se;yt++)ie[yt]=yt;ie.sort((yt,Zt)=>{const mi=M[5*yt],wi=M[5*Zt];if(mi===wi){const Ei=M[5*yt+1],Pi=M[5*Zt+1];return Ei-Pi}return mi-wi});const He=new Uint32Array(M.length);let et=0,ft=0;for(let yt=0;yt<Se;yt++){const Zt=5*ie[yt],mi=M[Zt+0],wi=M[Zt+1],Ei=M[Zt+2],Pi=M[Zt+3],Xi=M[Zt+4],jn=mi-et,kr=jn===0?wi-ft:wi,Yi=5*yt;He[Yi+0]=jn,He[Yi+1]=kr,He[Yi+2]=Ei,He[Yi+3]=Pi,He[Yi+4]=Xi,et=mi,ft=wi}return He}build(M){return this.f?new Ci(new Uint32Array(this.g),M):new Ci(Gi.r(this.g),M)}}e.$MO=Gi;class Ci{constructor(M,ie){this.resultId=ie,this.data=M}}e.$NO=Ci;class $n{constructor(M,ie,Se){this.start=M,this.deleteCount=ie,this.data=Se}}e.$OO=$n;class bn{constructor(M,ie){this.resultId=ie,this.edits=M}}e.$PO=bn;var nn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(nn||(e.DebugConsoleMode=nn={}));class Ki{constructor(M){this.name=M}}e.$QO=Ki;let Mi=class{static{this.Back={iconPath:new ai("arrow-left")}}constructor(){}};e.$RO=Mi,e.$RO=Mi=Qe([g],Mi);var Me;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Me||(e.QuickPickItemKind=Me={}));var bi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(bi||(e.InputBoxValidationSeverity=bi={}));var Qi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Qi||(e.ExtensionKind=Qi={}));class ot{static validate(M){if(typeof M.badge=="string"){let ie=(0,N.$Qf)(M.badge,0);if(ie<M.badge.length&&(ie+=(0,N.$Qf)(M.badge,ie)),M.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!ai.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,ie,Se){this.badge=M,this.tooltip=ie,this.color=Se}}e.$SO=ot;let Et=class{constructor(M){this.kind=M}};e.$TO=Et,e.$TO=Et=Qe([g],Et);var rn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(rn||(e.ColorThemeKind=rn={}));class yi{static isNotebookRange(M){return M instanceof yi?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,ie){if(M<0)throw(0,C.$9)("start must be positive");if(ie<0)throw(0,C.$9)("end must be positive");M<=ie?(this.c=M,this.e=ie):(this.c=ie,this.e=M)}with(M){let ie=this.c,Se=this.e;return M.start!==void 0&&(ie=M.start),M.end!==void 0&&(Se=M.end),ie===this.c&&Se===this.e?this:new yi(ie,Se)}}e.$UO=yi;class Ni{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ie=>Ni.isNotebookCellData(ie))}static isNotebookCellData(M){return!0}constructor(M,ie,Se,He,et,ft,yt){this.kind=M,this.value=ie,this.languageId=Se,this.mime=He,this.outputs=et??[],this.metadata=ft,this.executionSummary=yt,Ni.validate(this)}}e.$VO=Ni;class wn{constructor(M){this.cells=M}}e.$WO=wn;class ui{static isNotebookCellOutputItem(M){return M instanceof ui?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ie={name:M.name,message:M.message,stack:M.stack};return ui.json(ie,"application/vnd.code.notebook.error")}static stdout(M){return ui.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return ui.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ie="application/octet-stream"){return new ui(M,ie)}static#e=new TextEncoder;static text(M,ie=A.$5s.text){const Se=ui.#e.encode(String(M));return new ui(Se,ie)}static json(M,ie="text/x-json"){const Se=JSON.stringify(M,void 0,"	");return ui.text(Se,ie)}constructor(M,ie){this.data=M,this.mime=ie;const Se=(0,A.$9s)(ie,!0);if(!Se)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$XO=ui;class zi{static isNotebookCellOutput(M){return M instanceof zi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,ie=!1){const Se=new Set,He=new Set;for(let et=0;et<M.length;et++){const ft=M[et],yt=(0,A.$9s)(ft.mime);if(!Se.has(yt)||(0,d.$vL)(yt)){Se.add(yt);continue}He.add(et),ie&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return He.size===0?M:M.filter((et,ft)=>!He.has(ft))}constructor(M,ie,Se){this.items=zi.ensureUniqueMimeTypes(M,!0),typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=(0,R.$2g)(),this.metadata=ie??Se)}}e.$YO=zi;var sn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(sn||(e.NotebookCellKind=sn={}));var on;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(on||(e.NotebookCellExecutionState=on={}));var Hi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Hi||(e.NotebookCellStatusBarAlignment=Hi={}));var an;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(an||(e.NotebookEditorRevealType=an={}));class vn{constructor(M,ie){this.text=M,this.alignment=ie}}e.$ZO=vn;var cn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(cn||(e.NotebookControllerAffinity=cn={}));var un;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(un||(e.NotebookControllerAffinity2=un={}));class yn{constructor(M,ie=[]){this.uri=M,this.provides=(0,w.$4b)(ie)}}e.$1O=yn;class En{constructor(M){this.label=M}}e.$2O=En;var ln;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(ln||(e.NotebookVariablesRequestKind=ln={}));let Ji=class{constructor(M,ie){this.label=M,this.timestamp=ie}};e.$3O=Ji,e.$3O=Ji=Qe([g],Ji);var hn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(hn||(e.ExtensionMode=hn={}));var dn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(dn||(e.ExtensionRuntime=dn={}));var fn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(fn||(e.StandardTokenType=fn={}));class ee{constructor(M,ie){this.ranges=M,this.wordPattern=ie}}e.$4O=ee;class he{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$5O=he;var Fe;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Fe||(e.TestResultState=Fe={}));var at;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(at||(e.TestRunProfileKind=at={}));let Dt=class{constructor(M=void 0,ie=void 0,Se=void 0,He=!1,et=!0){this.include=M,this.exclude=ie,this.profile=Se,this.continuous=He,this.preserveFocus=et}};e.$6O=Dt,e.$6O=Dt=Qe([g],Dt);let Tt=k=class{static diff(M,ie,Se){const He=new k(M);return He.expectedOutput=ie,He.actualOutput=Se,He}constructor(M){this.message=M}};e.$7O=Tt,e.$7O=Tt=k=Qe([g],Tt);let Ii=class{constructor(M){this.id=M}};e.$8O=Ii,e.$8O=Ii=Qe([g],Ii);class Ui{constructor(M,ie){this.covered=M,this.total=ie,Sn(this)}}e.$9O=Ui;function Sn(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class Dn{static fromDetails(M,ie){const Se=new Ui(0,0),He=new Ui(0,0),et=new Ui(0,0);for(const yt of ie)if("branches"in yt){Se.total+=1,Se.covered+=yt.executed?1:0;for(const Zt of yt.branches)He.total+=1,He.covered+=Zt.executed?1:0}else et.total+=1,et.covered+=yt.executed?1:0;const ft=new Dn(M,Se,He.total>0?He:void 0,et.total>0?et:void 0);return ft.detailedCoverage=ie,ft}constructor(M,ie,Se,He,et=[]){this.uri=M,this.statementCoverage=ie,this.branchCoverage=Se,this.declarationCoverage=He,this.fromTests=et}}e.$$O=Dn;class Vn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ie,Se=[]){this.executed=M,this.location=ie,this.branches=Se}}e.$_O=Vn;class qn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ie,Se){this.executed=M,this.location=ie,this.label=Se}}e.$aP=qn;class Gn{get executionCount(){return+this.executed}set executionCount(M){this.executed=M}constructor(M,ie,Se){this.name=M,this.executed=ie,this.location=Se}}e.$bP=Gn;var kn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(kn||(e.ExternalUriOpenerPriority=kn={}));var Cn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Cn||(e.WorkspaceTrustState=Cn={}));var In;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(In||(e.PortAutoForwardAction=In={}));class Kn{constructor(M,ie,Se,He,et,ft){this.kind=M,this.name=ie,this.detail=Se,this.uri=He,this.range=et,this.selectionRange=ft}}e.$cP=Kn;class Qn{constructor(M){this.uri=M}}e.$dP=Qn;class Hn{constructor(M,ie){this.original=M,this.modified=ie}}e.$eP=Hn;class Jn{constructor(M,ie,Se,He){this.base=M,this.input1=ie,this.input2=Se,this.result=He}}e.$fP=Jn;class Xn{constructor(M,ie){this.uri=M,this.viewType=ie}}e.$gP=Xn;class Yn{constructor(M){this.viewType=M}}e.$hP=Yn;class Zn{constructor(M,ie){this.uri=M,this.notebookType=ie}}e.$iP=Zn;class xn{constructor(M,ie,Se){this.original=M,this.modified=ie,this.notebookType=Se}}e.$jP=xn;class _n{constructor(){}}e.$kP=_n;class er{constructor(M,ie){this.uri=M,this.inputBoxUri=ie}}e.$lP=er;class tr{constructor(){}}e.$mP=tr;class ir{constructor(M){this.textDiffs=M}}e.$nP=ir;var Pn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(Pn||(e.InteractiveSessionVoteDirection=Pn={}));var Rn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Rn||(e.ChatCopyKind=Rn={}));var An;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(An||(e.ChatVariableLevel=An={}));class nr{constructor(M,ie,Se){this.id=M,this.label=ie,this.values=Se}}e.$oP=nr;var On;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(On||(e.InteractiveEditorResponseFeedbackKind=On={}));var Nn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Nn||(e.ChatResultFeedbackKind=Nn={}));class rr{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new Ke(M):M}}e.$pP=rr;class sr{constructor(M,ie){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new Ke(M):M,this.vulnerabilities=ie}}e.$qP=sr;class or{constructor(M,ie){this.participant=M,this.command=ie}}e.$rP=or;class ar{constructor(M,ie,Se){this.title=M,this.message=ie,this.data=Se}}e.$sP=ar;class cr{constructor(M,ie){this.value=M,this.baseUri=ie}}e.$tP=cr;class ur{constructor(M,ie){this.value=M,this.title=ie}}e.$uP=ur;class lr{constructor(M){this.value=M}}e.$vP=lr;class hr{constructor(M,ie){this.value=M,this.task=ie}}e.$wP=hr;class dr{constructor(M){if(typeof M!="string"&&M.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof M=="string"?new Ke(M):M}}e.$xP=dr;class fr{constructor(M){this.value=M}}e.$yP=fr;class gr{constructor(M,ie){this.value=M,this.iconPath=ie}}e.$zP=gr;class mr{constructor(M,ie){this.uri=M,this.edits=Array.isArray(ie)?ie:[ie]}}e.$AP=mr;class pr{constructor(M,ie,Se,He){this.prompt=M,this.command=ie,this.references=Se,this.participant=He}}e.$BP=pr;class $r{constructor(M,ie,Se,He){this.response=M,this.result=ie,this.participant=Se,this.command=He}}e.$CP=$r;var Tn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(Tn||(e.ChatLocation=Tn={}));var gn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(gn||(e.LanguageModelChatMessageRole=gn={}));class br{constructor(M,ie,Se){this.name=M,this.content=ie,this.isError=Se??!1}}e.$DP=br;class mn{static User(M,ie){const Se=new mn(gn.User,typeof M=="string"?M:"",ie);return Se.content2=M,Se}static Assistant(M,ie){return new mn(gn.Assistant,M,ie)}constructor(M,ie,Se){this.role=M,this.content=ie,this.content2=ie,this.name=Se}}e.$EP=mn;class wr{constructor(M,ie){this.name=M,this.parameters=ie}}e.$FP=wr;class vr{constructor(M){this.value=M}}e.$GP=vr;class yr{constructor(M){this.content=M}}e.$HP=yr;class Er{constructor(M,ie){this.content=M,this.name=ie}}e.$IP=Er;class Dr{constructor(M,ie){this.content=M,this.name=ie}}e.$JP=Dr;class Ai extends Error{static NotFound(M){return new Ai(M,Ai.NotFound.name)}static NoPermissions(M){return new Ai(M,Ai.NoPermissions.name)}static Blocked(M){return new Ai(M,Ai.Blocked.name)}constructor(M,ie,Se){super(M,{cause:Se}),this.name="LanguageModelError",this.code=ie??""}}e.$KP=Ai;var Fn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Fn||(e.RelatedInformationType=Fn={}));var Ln;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Ln||(e.SpeechToTextStatus=Ln={}));var Mn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Mn||(e.TextToSpeechStatus=Mn={}));var zn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(zn||(e.KeywordRecognitionStatus=zn={}));class Sr{constructor(M,ie){this.text=M,this.range=ie}}e.$LP=Sr;var Un;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Un||(e.InlineEditTriggerKind=Un={}))}),define(Ce[269],Ie([1,0,6,7]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$qN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,N,p){if(this.a.size===0)throw new Error("No related information providers registered");const c=this.a.get(A);if(!c)throw new Error("related information provider not found");return await c.provideRelatedInformation(N,p)??[]}getRelatedInformation(A,N,p){return this.c.$getAiRelatedInformation(N,p)}registerRelatedInformationProvider(A,N,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiRelatedInformationProvider(c,N),new C.$sN(()=>{this.c.$unregisterAiRelatedInformationProvider(c),this.a.delete(c)})}}e.$znc=P}),define(Ce[91],Ie([1,0,4,6,7,19,116,3,17]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=void 0,e.$Knc=(0,N.$Fi)("IExtHostAuthentication");let c=class{constructor(u){this.b=new Map,this.c=new w.$me,this.onDidChangeSessions=this.c.event,this.d=new R,this.f=new R,this.a=u.getProxy(C.$qN.MainThreadAuthentication)}async getSession(u,E,d,r={}){const o=T.$qn.toKey(u.identifier),a=[...d].sort().join(" ");return await this.d.getOrCreate(`${o} ${E} ${a}`,async()=>{await this.a.$ensureProvider(E);const h=u.displayName||u.name;return this.a.$getSession(E,d,o,h,r)})}async getSessions(u,E,d){const r=T.$qn.toKey(u.identifier),o=[...d].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(E);const a=u.displayName||u.name;return this.a.$getSessions(E,d,r,a)})}async getAccounts(u){return await this.a.$ensureProvider(u),await this.a.$getAccounts(u)}async removeSession(u,E){const d=this.b.get(u);return d?d.provider.removeSession(E):this.a.$removeSession(u,E)}registerAuthenticationProvider(u,E,d,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:E,provider:d,options:r??{supportsMultipleAccounts:!1}});const o=d.onDidChangeSessions(a=>this.a.$sendDidChangeSessions(u,a));return this.a.$registerAuthenticationProvider(u,E,r?.supportsMultipleAccounts??!1),new P.$sN(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,E,d){const r=this.b.get(u);if(r)return await r.provider.createSession(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,E){const d=this.b.get(u);if(d)return await d.provider.removeSession(E);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,E,d){const r=this.b.get(u);if(r)return await r.provider.getSessions(E,d);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,E){return u.startsWith(A.$sM)||this.c.fire({provider:{id:u,label:E}}),Promise.resolve()}};e.$Lnc=c,e.$Lnc=c=Qe([Ve(0,p.$WP)],c);class R{constructor(){this.a=new Map}getOrCreate(u,E){const d=this.a.get(u);if(d)return d;const r=E().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Ce[121],Ie([1,0,2,6,7,3,17,12,18,13,20,25]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=e.$Poc=void 0;let E=class{static{u=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(C.$qN.MainThreadDecorations)}registerFileDecorationProvider(r,o){const a=u.c++;this.f.set(a,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(a,o.identifier.value);const h=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(a,null);return}const s=(0,p.$4b)(n);if(s.length<=u.d){this.g.$onDidChange(a,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const i=s.map(f=>({uri:f,rank:(0,c.$jf)(f.path,"/")})),t=(0,p.$Bb)(i,(f,l)=>f.rank-l.rank||(0,c.$zf)(f.uri.path,l.uri.path)),m=[];e:for(const f of t){let l;for(const $ of f){const I=(0,R.$oc)($.uri.path);if(l!==I&&(l=I,m.push($.uri)>=u.d))break e}}this.g.$onDidChange(a,m)});return new P.$sN(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(a),this.f.delete(a)})}async $provideDecorations(r,o,a){if(!this.f.has(r))return Object.create(null);const h=Object.create(null),{provider:n,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async i=>{try{const{uri:t,id:m}=i,f=await Promise.resolve(n.provideFileDecoration(w.URI.revive(t),a));if(!f)return;try{P.$SO.validate(f),f.badge&&typeof f.badge!="string"&&(0,v.$5G)(s,"codiconDecoration"),h[m]=[f.propagate,f.tooltip,f.badge,f.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),h}};e.$Poc=E,e.$Poc=E=u=Qe([Ve(0,A.$WP),Ve(1,N.$_j)],E),e.$Qoc=(0,T.$Fi)("IExtHostDecorations")}),define(Ce[270],Ie([1,0,14,2,7,6,16,22,13]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=void 0;class c{static{this.a=0}constructor(v,u,E){this.d=u,this.e=E,this.b=new Map,this.c=v.getProxy(T.$qN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(v,u){if(Object.keys(A.Schemas).indexOf(v)>=0)throw new Error(`scheme '${v}' already registered`);const E=c.a++;this.b.set(E,u),this.c.$registerTextContentProvider(E,v);let d;if(typeof u.onDidChange=="function"){let r;d=u.onDidChange(async o=>{if(o.scheme!==v){this.e.warn(`Provider for scheme '${v}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const a=this.$provideTextDocumentContent(E,o).then(async h=>{if(!h&&typeof h!="string")return;const n=this.d.getDocument(o);if(!n)return;const s=(0,p.$tf)(h);if(!n.equalLines(s))return this.c.$onVirtualDocumentChange(o,h)}).catch(w.$3).finally(()=>{r===a&&(r=void 0)});r=a})}return new P.$sN(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(v,u){const E=this.b.get(v);return E?Promise.resolve(E.provideTextDocumentContent(C.URI.revive(u),N.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Soc=c}),define(Ce[122],Ie([1,0,62,16,13,325,210,7,18]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=e.$ZP=void 0,e.$YP=R;const c=new Map;function R(d,r){r?c.set(d,r):c.delete(d)}function v(d){return c.get(d)}class u extends T.$iw{constructor(r,o,a,h,n,s,i){super(o,a,h,n),this.c=r,this.m=s,this.q=i,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$wb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===C.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?N.EndOfLine.LF:N.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,a){return r.y(o,a)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,w.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,w.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const a=this.g,h=o.start.line,n=o.end.line,s=[];s.push(this.f[h].substring(o.start.character));for(let i=h+1;i<n;i++)s.push(this.f[i]);return s.push(this.f[n].substring(0,o.end.character)),s.join(a)}t(r){let o;if(r instanceof N.$tN?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new E(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),a=this.f[o.index].length;return new N.$tN(o.index,Math.min(o.remainder,a))}w(r){if(!(r instanceof N.$uN))throw new Error("Invalid argument");const o=this.x(r.start),a=this.x(r.end);return o===r.start&&a===r.end?r:new N.$uN(o.line,o.character,a.line,a.character)}x(r){if(!(r instanceof N.$tN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:a}=r,h=!1;if(o<0)o=0,a=0,h=!0;else if(o>=this.f.length)o=this.f.length-1,a=this.f[o].length,h=!0;else{const n=this.f[o].length;a<0?(a=0,h=!0):a>n&&(a=n,h=!0)}return h?new N.$tN(o,a):r}y(r,o){const a=this.x(r);if(!o)o=v(this.m);else if((0,P.$sf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const h=(0,A.$kt)(a.character+1,(0,A.$it)(o),this.f[a.line],0);if(h)return new N.$uN(a.line,h.startColumn-1,a.line,h.endColumn-1)}}e.$ZP=u;class E{constructor(r,o,a){this.a=r,this.b=o,this.c=a}get lineNumber(){return this.a}get text(){return this.b}get range(){return new N.$uN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new N.$uN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$1P=E}),define(Ce[271],Ie([1,0,6,7]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(w.$qN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,N,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const c=this.a.get(A);if(!c)throw new Error("Embedding vector provider not found");const R=await c.provideEmbeddingVector(N,p);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,N,p){const c=this.b;return this.b++,this.a.set(c,p),this.c.$registerAiEmbeddingVectorProvider(N,c),new C.$sN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(c),this.a.delete(c)})}}e.$Voc=P}),define(Ce[69],Ie([1,0,6,30,7,23,3,17,51,5,11,24,16]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=void 0,C=qe(C);let d=E=class{constructor(o,a){this.b=new Map,this.c=new R.$Oh,this.a=o.getProxy(w.$qN.MainThreadFileSystem);const h=this;this.value=Object.freeze({async stat(n){try{let s;const i=h.b.get(n.scheme);return i?(await h.a.$ensureActivation(n.scheme),s=await i.impl.stat(n)):s=await h.a.$stat(n),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===C.FilePermission.Readonly?1:void 0}}catch(s){E.e(s)}},async readDirectory(n){try{const s=h.b.get(n.scheme);return s?(await h.a.$ensureActivation(n.scheme),(await s.impl.readDirectory(n)).slice()):await h.a.$readdir(n)}catch(s){return E.e(s)}},async createDirectory(n){try{const s=h.b.get(n.scheme);return s&&!s.isReadonly?(await h.a.$ensureActivation(n.scheme),await h.d(s.impl,s.extUri,n)):await h.a.$mkdir(n)}catch(s){return E.e(s)}},async readFile(n){try{const s=h.b.get(n.scheme);return s?(await h.a.$ensureActivation(n.scheme),(await s.impl.readFile(n)).slice()):(await h.a.$readFile(n)).buffer}catch(s){return E.e(s)}},async writeFile(n,s){try{const i=h.b.get(n.scheme);return i&&!i.isReadonly?(await h.a.$ensureActivation(n.scheme),await h.d(i.impl,i.extUri,i.extUri.dirname(n)),await h.c.queueFor(n,()=>Promise.resolve(i.impl.writeFile(n,s,{create:!0,overwrite:!0})))):await h.a.$writeFile(n,T.$Oe.wrap(s))}catch(i){return E.e(i)}},async delete(n,s){try{const i=h.b.get(n.scheme);return i&&!i.isReadonly&&!s?.useTrash?(await h.a.$ensureActivation(n.scheme),await i.impl.delete(n,{recursive:!1,...s})):await h.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(i){return E.e(i)}},async rename(n,s,i){try{return await h.a.$rename(n,s,{overwrite:!1,...i})}catch(t){return E.e(t)}},async copy(n,s,i){try{return await h.a.$copy(n,s,{overwrite:!1,...i})}catch(t){return E.e(t)}},isWritableFileSystem(n){const s=a.getCapabilities(n);if(typeof s=="number")return!(s&C.FileSystemProviderCapabilities.Readonly)}})}async d(o,a,h){const n=[];for(;!a.isEqual(h,a.dirname(h));)try{if(!((await o.stat(h)).type&C.FileType.Directory))throw P.$JO.FileExists(`Unable to create folder '${h.scheme===u.Schemas.file?h.fsPath:h.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(C.$pl(s)!==C.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(a.basename(h)),h=a.dirname(h)}for(let s=n.length-1;s>=0;s--){h=a.joinPath(h,n[s]);try{await o.createDirectory(h)}catch(i){if(C.$pl(i)!==C.FileSystemProviderErrorCode.FileExists)throw i}}}static e(o){if(o instanceof P.$JO)throw o;if(o instanceof C.$ll)switch(o.code){case C.FileSystemProviderErrorCode.FileExists:throw P.$JO.FileExists(o.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.$JO.FileNotFound(o.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.$JO.FileNotADirectory(o.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.$JO.FileIsADirectory(o.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.$JO.NoPermissions(o.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.$JO.Unavailable(o.message);default:throw new P.$JO(o.message,o.name)}if(!(o instanceof Error))throw new P.$JO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw P.$JO.Unavailable(o.message);switch(o.name){case C.FileSystemProviderErrorCode.FileExists:throw P.$JO.FileExists(o.message);case C.FileSystemProviderErrorCode.FileNotFound:throw P.$JO.FileNotFound(o.message);case C.FileSystemProviderErrorCode.FileNotADirectory:throw P.$JO.FileNotADirectory(o.message);case C.FileSystemProviderErrorCode.FileIsADirectory:throw P.$JO.FileIsADirectory(o.message);case C.FileSystemProviderErrorCode.NoPermissions:throw P.$JO.NoPermissions(o.message);case C.FileSystemProviderErrorCode.Unavailable:throw P.$JO.Unavailable(o.message);default:throw new P.$JO(o.message,o.name)}}addFileSystemProvider(o,a,h){return this.b.set(o,{impl:a,extUri:h?.isCaseSensitive?v.$9g:v.$$g,isReadonly:!!h?.isReadonly}),(0,c.$Uc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??v.$9g}};e.$1nc=d,e.$1nc=d=E=Qe([Ve(0,N.$WP),Ve(1,p.$Enc)],d),e.$2nc=(0,A.$Fi)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,69,2]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=e.$3nc=void 0,e.$3nc=(0,w.$Fi)("IExtensionStoragePaths");let N=class{constructor(c,R,v){this.d=R,this.f=v,this.a=c.workspace??void 0,this.b=c.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(c){return A.URI.joinPath(this.b.workspaceStorageHome,c)}async h(){if(!this.a)return Promise.resolve(void 0);const c=this.a.id,R=await this.g(c);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(v){this.d.error("[ExtHostStorage]",v);return}}workspaceValue(c){if(this.c)return A.URI.joinPath(this.c,c.identifier.value)}globalValue(c){return A.URI.joinPath(this.b.globalStorageHome,c.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$4nc=N,e.$4nc=N=Qe([Ve(0,C.$aQ),Ve(1,P.$_j),Ve(2,T.$2nc)],N)}),define(Ce[272],Ie([1,0,7,17,4]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0;let T=class{constructor(N){this.a=new w.$TO(w.ColorThemeKind.Dark),this.b=new P.$me}get activeColorTheme(){return this.a}$onColorThemeChange(N){let p;switch(N){case"light":p=w.ColorThemeKind.Light;break;case"hcDark":p=w.ColorThemeKind.HighContrast;break;case"hcLight":p=w.ColorThemeKind.HighContrastLight;break;default:p=w.ColorThemeKind.Dark}this.a=new w.$TO(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$zpc=T,e.$zpc=T=Qe([Ve(0,C.$WP)],T)}),define(Ce[93],Ie([1,0,22,4,5,190,3,12,223,6,27,17,7]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nFb=e.$mFb=e.TunnelDtoConverter=void 0,T=qe(T),u=qe(u);class E extends p.$Hw{}var d;(function(o){function a(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=a;function h(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=h})(d||(e.TunnelDtoConverter=d={})),e.$mFb=(0,A.$Fi)("IExtHostTunnelService");let r=class extends P.$Wc{constructor(a,h,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new C.$me,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=a.getProxy(c.$qN.MainThreadTunnelService)}async openTunnel(a,h){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${a.identifier.value} called openTunnel API for ${h.remoteAddress.host}:${h.remoteAddress.port}.`);const n=await this.a.$openTunnel(h,a.displayName);if(n){const s=new E(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(a,h){a.portRange===void 0&&a.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:a,provider:h}),this.a.$registerPortsAttributesProvider(a,n),new u.$sN(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(a,h,n,s,i){const t=[];for(const f of a){const l=this.r.get(f);if(!l)return[];t.push(...await Promise.all(h.map(async $=>{let I;try{I=await l.provider.providePortAttributes({port:$,pid:n,commandLine:s},i)}catch{I=await l.provider.providePortAttributes($,n,s,i)}return{providedAttributes:I,port:$}})))}const m=t.filter(f=>!!f.providedAttributes);return m.length>0?m.map(f=>({autoForwardAction:f.providedAttributes.autoForwardAction,port:f.port})):[]}async $registerCandidateFinder(a){}registerTunnelProvider(a,h){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,i)=>await a.provideTunnel(s,i,w.CancellationToken.None)??void 0;const n=h.tunnelFeatures?{elevation:!!h.tunnelFeatures?.elevation,privacyOptions:h.tunnelFeatures?.privacyOptions,protocol:h.tunnelFeatures.protocol===void 0?!0:h.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,P.$Uc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(a,h){if(a){a.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(a.candidatePortSource),a.showCandidatePort&&(this.f=a.showCandidatePort,this.a.$setCandidateFilter());const n=a.tunnelFactory??(h?this.w(h):void 0);if(n){this.b=n;let s=a.tunnelFeatures?.privacyOptions??[];a.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const i=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,public:!!a.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(i)}}else this.b=void 0;return(0,P.$Uc)(()=>{this.b=void 0})}w(a){}async $closeTunnel(a,h){if(this.g.has(a.host)){const n=this.g.get(a.host);n.has(a.port)&&(h&&n.get(a.port).disposeListener.dispose(),await n.get(a.port).tunnel.dispose(),n.delete(a.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(a,h){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(a,h);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const s=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(a.remoteAddress.host)||this.g.set(a.remoteAddress.host,new Map);const i=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(a.remoteAddress.host).set(a.remoteAddress.port,{tunnel:s,disposeListener:i}),d.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(a){const h=await Promise.all(a.map(s=>this.f(s.host,s.port,s.detail??""))),n=a.filter((s,i)=>h[i]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${a.map(s=>s.port).join(", ")} to ${n.map(s=>s.port).join(", ")}`),n}};e.$nFb=r,e.$nFb=r=Qe([Ve(0,v.$WP),Ve(1,R.$aQ),Ve(2,N.$_j)],r)}),define(Ce[10],Ie([1,0,18,23,147,273,60,29,136,49,73,26,142,24,35,15,2,105,33,151,94,52,107,77,115,114,234,249,81,90,55,56,245,7]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l,$,I,D,y,S,k,g,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$TP=de,e.$UP=re,e.$VP=Pe,A=qe(A),h=qe(h),n=qe(n),s=qe(s),I=qe(I),y=qe(y),b=qe(b);var L;(function(ye){function Oe(J){const{selectionStartLineNumber:Ee,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ge}=J,ut=new b.$tN(Ee-1,We-1),Pt=new b.$tN(Ye-1,Ge-1);return new b.$vN(ut,Pt)}ye.to=Oe;function ue(J){const{anchor:Ee,active:We}=J;return{selectionStartLineNumber:Ee.line+1,selectionStartColumn:Ee.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}ye.from=ue})(L||(e.Selection=L={}));var O;(function(ye){function Oe(J){if(!J)return;const{start:Ee,end:We}=J;return{startLineNumber:Ee.line+1,startColumn:Ee.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}ye.from=Oe;function ue(J){if(!J)return;const{startLineNumber:Ee,startColumn:We,endLineNumber:Ye,endColumn:Ge}=J;return new b.$uN(Ee-1,We-1,Ye-1,Ge-1)}ye.to=ue})(O||(e.Range=O={}));var q;(function(ye){function Oe(J){return{uri:J.uri,range:O.from(J.range)}}ye.from=Oe;function ue(J){return new b.$EN(o.URI.revive(J.uri),O.to(J.range))}ye.to=ue})(q||(e.Location=q={}));var G;(function(ye){function Oe(ue){switch(ue){case n.StandardTokenType.Comment:return b.StandardTokenType.Comment;case n.StandardTokenType.Other:return b.StandardTokenType.Other;case n.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case n.StandardTokenType.String:return b.StandardTokenType.String}}ye.to=Oe})(G||(e.TokenType=G={}));var W;(function(ye){function Oe(J){return new b.$tN(J.lineNumber-1,J.column-1)}ye.to=Oe;function ue(J){return{lineNumber:J.line+1,column:J.character+1}}ye.from=ue})(W||(e.Position=W={}));var F;(function(ye){function Oe(Ee,We,Ye){return(0,w.$Jb)((0,w.$4b)(Ee).map(Ge=>ue(Ge,We,Ye)))}ye.from=Oe;function ue(Ee,We,Ye){if(typeof Ee=="string")return{$serialized:!0,language:Ee,isBuiltin:Ye?.isBuiltin};if(Ee)return{$serialized:!0,language:Ee.language,scheme:J(Ee.scheme,We),pattern:Ze.from(Ee.pattern)??void 0,exclusive:Ee.exclusive,notebookType:Ee.notebookType,isBuiltin:Ye?.isBuiltin}}function J(Ee,We){return We&&typeof Ee=="string"?We.transformOutgoingScheme(Ee):Ee}})(F||(e.DocumentSelector=F={}));var V;(function(ye){function Oe(J){switch(J){case b.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}ye.from=Oe;function ue(J){switch(J){case t.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}ye.to=ue})(V||(e.DiagnosticTag=V={}));var ce;(function(ye){function Oe(J){let Ee;return J.code&&((0,r.$fg)(J.code)||(0,r.$jg)(J.code)?Ee=String(J.code):Ee={value:String(J.code.value),target:J.code.target}),{...O.from(J.range),message:J.message,source:J.source,code:Ee,severity:te.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(ge.from),tags:Array.isArray(J.tags)?(0,w.$Jb)(J.tags.map(V.from)):void 0}}ye.from=Oe;function ue(J){const Ee=new b.$GN(O.to(J),J.message,te.to(J.severity));return Ee.source=J.source,Ee.code=(0,r.$fg)(J.code)?J.code:J.code?.value,Ee.relatedInformation=J.relatedInformation&&J.relatedInformation.map(ge.to),Ee.tags=J.tags&&(0,w.$Jb)(J.tags.map(V.to)),Ee}ye.to=ue})(ce||(e.Diagnostic=ce={}));var ge;(function(ye){function Oe(J){return{...O.from(J.location.range),message:J.message,resource:J.location.uri}}ye.from=Oe;function ue(J){return new b.$FN(new b.$EN(J.resource,O.to(J)),J.message)}ye.to=ue})(ge||(e.DiagnosticRelatedInformation=ge={}));var te;(function(ye){function Oe(J){switch(J){case b.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ye.from=Oe;function ue(J){switch(J){case t.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}ye.to=ue})(te||(e.DiagnosticSeverity=te={}));var me;(function(ye){function Oe(J){return typeof J=="number"&&J>=b.ViewColumn.One?J-1:J===b.ViewColumn.Beside?g.$mE:g.$lE}ye.from=Oe;function ue(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=ue})(me||(e.ViewColumn=me={}));function se(ye){return typeof ye.range<"u"}function de(ye){return ye.length===0?!0:!!se(ye[0])}var be;(function(ye){function Oe(Ge){return Ge.map(ye.from)}ye.fromMany=Oe;function ue(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function J(Ge){let ut;if(ue(Ge)){const{language:zt,value:ni}=Ge;ut={value:"```"+zt+`
`+ni+"\n```\n"}}else b.$UN.isMarkdownString(Ge)?ut={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ut={value:Ge}:ut={value:""};const Pt=Object.create(null);ut.uris=Pt;const Yt=zt=>{try{let ni=o.URI.parse(zt,!0);ni=ni.with({query:Ee(ni.query,Pt)}),Pt[zt]=ni}catch{}return""},ci=new p.marked.Renderer;return ci.link=Yt,ci.image=zt=>typeof zt=="string"?Yt(A.$$k(zt).href):"",(0,p.marked)(ut.value,{renderer:ci}),ut}ye.from=J;function Ee(Ge,ut){if(!Ge)return Ge;let Pt;try{Pt=(0,c.$bi)(Ge)}catch{}if(!Pt)return Ge;let Yt=!1;return Pt=(0,v.$eo)(Pt,ci=>{if(o.URI.isUri(ci)){const zt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[zt]=ci,Yt=!0,zt}else return}),Yt?JSON.stringify(Pt):Ge}function We(Ge){const ut=new b.$UN(Ge.value,Ge.supportThemeIcons);return ut.isTrusted=Ge.isTrusted,ut.supportHtml=Ge.supportHtml,ut.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,ut}ye.to=We;function Ye(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=Ye})(be||(e.MarkdownString=be={}));function re(ye){return de(ye)?ye.map(Oe=>({range:O.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?be.fromMany(Oe.hoverMessage):Oe.hoverMessage?be.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):ye.map(Oe=>({range:O.from(Oe)}))}function Pe(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Le;(function(ye){function Oe(ue){return typeof ue>"u"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?Pe(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}ye.from=Oe})(Le||(e.ThemableDecorationAttachmentRenderOptions=Le={}));var Y;(function(ye){function Oe(ue){return typeof ue>"u"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Pe(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Le.from(ue.before):void 0,after:ue.after?Le.from(ue.after):void 0}}ye.from=Oe})(Y||(e.ThemableDecorationRenderOptions=Y={}));var B;(function(ye){function Oe(ue){if(typeof ue>"u")return ue;switch(ue){case b.DecorationRangeBehavior.OpenOpen:return i.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return i.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return i.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Oe})(B||(e.DecorationRangeBehavior=B={}));var _;(function(ye){function Oe(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?B.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?Y.from(ue.light):void 0,dark:ue.dark?Y.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?Pe(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?Le.from(ue.before):void 0,after:ue.after?Le.from(ue.after):void 0}}ye.from=Oe})(_||(e.DecorationRenderOptions=_={}));var ve;(function(ye){function Oe(J){return{text:J.newText,eol:J.newEol&&je.from(J.newEol),range:O.from(J.range)}}ye.from=Oe;function ue(J){const Ee=new b.$zN(O.to(J.range),J.text);return Ee.newEol=typeof J.eol>"u"?void 0:je.to(J.eol),Ee}ye.to=ue})(ve||(e.TextEdit=ve={}));var ae;(function(ye){function Oe(J,Ee){const We={edits:[]};if(J instanceof b.$CN){const Ye=new N.$Dc;for(const Ge of J._allEntries())Ge._type===b.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&Ye.add(Ge.to);for(const Ge of J._allEntries())if(Ge._type===b.FileEditType.File){let ut;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ut={type:"base64",value:(0,C.$9e)(C.$Oe.wrap(Ge.options.contents))}:ut={type:"dataTransferItem",id:Ge.options.contents._itemId}),We.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ut},metadata:Ge.metadata})}else Ge._type===b.FileEditType.Text?We.edits.push({resource:Ge.uri,textEdit:ve.from(Ge.edit),versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Snippet?We.edits.push({resource:Ge.uri,textEdit:{range:O.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ge.uri)?void 0:Ee?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===b.FileEditType.Cell?We.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===b.FileEditType.CellReplace&&We.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ee?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:y.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(It.from)}})}return We}ye.from=Oe;function ue(J){const Ee=new b.$CN,We=new N.$Cc;for(const Ye of J.edits)if(Ye.textEdit){const Ge=Ye,ut=o.URI.revive(Ge.resource),Pt=O.to(Ge.textEdit.range),Yt=Ge.textEdit.text,ci=Ge.textEdit.insertAsSnippet;let zt;ci?zt=b.$BN.replace(Pt,new b.$DN(Yt)):zt=b.$zN.replace(Pt,Yt);const ni=We.get(ut);ni?ni.push(zt):We.set(ut,[zt])}else Ee.renameFile(o.URI.revive(Ye.oldResource),o.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ge]of We)Ee.set(Ye,Ge);return Ee}ye.to=ue})(ae||(e.WorkspaceEdit=ae={}));var we;(function(ye){const Oe=Object.create(null);Oe[b.SymbolKind.File]=s.SymbolKind.File,Oe[b.SymbolKind.Module]=s.SymbolKind.Module,Oe[b.SymbolKind.Namespace]=s.SymbolKind.Namespace,Oe[b.SymbolKind.Package]=s.SymbolKind.Package,Oe[b.SymbolKind.Class]=s.SymbolKind.Class,Oe[b.SymbolKind.Method]=s.SymbolKind.Method,Oe[b.SymbolKind.Property]=s.SymbolKind.Property,Oe[b.SymbolKind.Field]=s.SymbolKind.Field,Oe[b.SymbolKind.Constructor]=s.SymbolKind.Constructor,Oe[b.SymbolKind.Enum]=s.SymbolKind.Enum,Oe[b.SymbolKind.Interface]=s.SymbolKind.Interface,Oe[b.SymbolKind.Function]=s.SymbolKind.Function,Oe[b.SymbolKind.Variable]=s.SymbolKind.Variable,Oe[b.SymbolKind.Constant]=s.SymbolKind.Constant,Oe[b.SymbolKind.String]=s.SymbolKind.String,Oe[b.SymbolKind.Number]=s.SymbolKind.Number,Oe[b.SymbolKind.Boolean]=s.SymbolKind.Boolean,Oe[b.SymbolKind.Array]=s.SymbolKind.Array,Oe[b.SymbolKind.Object]=s.SymbolKind.Object,Oe[b.SymbolKind.Key]=s.SymbolKind.Key,Oe[b.SymbolKind.Null]=s.SymbolKind.Null,Oe[b.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Oe[b.SymbolKind.Struct]=s.SymbolKind.Struct,Oe[b.SymbolKind.Event]=s.SymbolKind.Event,Oe[b.SymbolKind.Operator]=s.SymbolKind.Operator,Oe[b.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function ue(Ee){return typeof Oe[Ee]=="number"?Oe[Ee]:s.SymbolKind.Property}ye.from=ue;function J(Ee){for(const We in Oe)if(Oe[We]===Ee)return Number(We);return b.SymbolKind.Property}ye.to=J})(we||(e.SymbolKind=we={}));var le;(function(ye){function Oe(J){switch(J){case b.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}ye.from=Oe;function ue(J){switch(J){case s.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ye.to=ue})(le||(e.SymbolTag=le={}));var X;(function(ye){function Oe(J){return{name:J.name,kind:we.from(J.kind),tags:J.tags&&J.tags.map(le.from),containerName:J.containerName,location:ze.from(J.location)}}ye.from=Oe;function ue(J){const Ee=new b.$LN(J.name,we.to(J.kind),J.containerName,ze.to(J.location));return Ee.tags=J.tags&&J.tags.map(le.to),Ee}ye.to=ue})(X||(e.WorkspaceSymbol=X={}));var Z;(function(ye){function Oe(J){const Ee={name:J.name||"!!MISSING: name!!",detail:J.detail,range:O.from(J.range),selectionRange:O.from(J.selectionRange),kind:we.from(J.kind),tags:J.tags?.map(le.from)??[]};return J.children&&(Ee.children=J.children.map(Oe)),Ee}ye.from=Oe;function ue(J){const Ee=new b.$MN(J.name,J.detail,we.to(J.kind),O.to(J.range),O.to(J.selectionRange));return(0,w.$Nb)(J.tags)&&(Ee.tags=J.tags.map(le.to)),J.children&&(Ee.children=J.children.map(ue)),Ee}ye.to=ue})(Z||(e.DocumentSymbol=Z={}));var pe;(function(ye){function Oe(J){const Ee=new b.$QN(we.to(J.kind),J.name,J.detail||"",o.URI.revive(J.uri),O.to(J.range),O.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}ye.to=Oe;function ue(J,Ee,We){if(Ee=Ee??J._sessionId,We=We??J._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,name:J.name,detail:J.detail,kind:we.from(J.kind),uri:J.uri,range:O.from(J.range),selectionRange:O.from(J.selectionRange),tags:J.tags?.map(le.from)}}ye.from=ue})(pe||(e.CallHierarchyItem=pe={}));var $e;(function(ye){function Oe(ue){return new b.$RN(pe.to(ue.from),ue.fromRanges.map(J=>O.to(J)))}ye.to=Oe})($e||(e.CallHierarchyIncomingCall=$e={}));var Ne;(function(ye){function Oe(ue){return new b.$SN(pe.to(ue.to),ue.fromRanges.map(J=>O.to(J)))}ye.to=Oe})(Ne||(e.CallHierarchyOutgoingCall=Ne={}));var ze;(function(ye){function Oe(J){return{range:J.range&&O.from(J.range),uri:J.uri}}ye.from=Oe;function ue(J){return new b.$EN(o.URI.revive(J.uri),O.to(J.range))}ye.to=ue})(ze||(e.location=ze={}));var ke;(function(ye){function Oe(J){const Ee=J,We=J;return{originSelectionRange:Ee.originSelectionRange?O.from(Ee.originSelectionRange):void 0,uri:Ee.targetUri?Ee.targetUri:We.uri,range:O.from(Ee.targetRange?Ee.targetRange:We.range),targetSelectionRange:Ee.targetSelectionRange?O.from(Ee.targetSelectionRange):void 0}}ye.from=Oe;function ue(J){return{targetUri:o.URI.revive(J.uri),targetRange:O.to(J.range),targetSelectionRange:J.targetSelectionRange?O.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?O.to(J.originSelectionRange):void 0}}ye.to=ue})(ke||(e.DefinitionLink=ke={}));var Re;(function(ye){function Oe(J){return{range:O.from(J.range),contents:be.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ye.from=Oe;function ue(J){const Ee=J.contents.map(be.to),We=O.to(J.range),Ye=J.canIncreaseVerbosity,Ge=J.canDecreaseVerbosity;return new b.$IN(Ee,We,Ye,Ge)}ye.to=ue})(Re||(e.Hover=Re={}));var Te;(function(ye){function Oe(J){return{range:O.from(J.range),expression:J.expression}}ye.from=Oe;function ue(J){return new b.$DO(O.to(J.range),J.expression)}ye.to=ue})(Te||(e.EvaluatableExpression=Te={}));var U;(function(ye){function Oe(J){if(J instanceof b.$EO)return{type:"text",range:O.from(J.range),text:J.text};if(J instanceof b.$FO)return{type:"variable",range:O.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof b.$GO)return{type:"expression",range:O.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Oe;function ue(J){switch(J.type){case"text":return{range:O.to(J.range),text:J.text};case"variable":return{range:O.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:O.to(J.range),expression:J.expression}}}ye.to=ue})(U||(e.InlineValue=U={}));var z;(function(ye){function Oe(J){return{frameId:J.frameId,stoppedLocation:O.from(J.stoppedLocation)}}ye.from=Oe;function ue(J){return new b.$HO(J.frameId,O.to(J.stoppedLocation))}ye.to=ue})(z||(e.InlineValueContext=z={}));var K;(function(ye){function Oe(J){return{range:O.from(J.range),kind:J.kind}}ye.from=Oe;function ue(J){return new b.$JN(O.to(J.range),J.kind)}ye.to=ue})(K||(e.DocumentHighlight=K={}));var H;(function(ye){function Oe(J){return{uri:J.uri,highlights:J.highlights.map(K.from)}}ye.from=Oe;function ue(J){return new b.$KN(o.URI.revive(J.uri),J.highlights.map(K.to))}ye.to=ue})(H||(e.MultiDocumentHighlight=H={}));var ne;(function(ye){function Oe(ue){switch(ue){case s.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}ye.to=Oe})(ne||(e.CompletionTriggerKind=ne={}));var fe;(function(ye){function Oe(ue){return{triggerKind:ne.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}ye.to=Oe})(fe||(e.CompletionContext=fe={}));var Ae;(function(ye){function Oe(J){switch(J){case b.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}ye.from=Oe;function ue(J){switch(J){case s.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ye.to=ue})(Ae||(e.CompletionItemTag=Ae={}));var Ue;(function(ye){const Oe=new Map([[b.CompletionItemKind.Method,s.CompletionItemKind.Method],[b.CompletionItemKind.Function,s.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,s.CompletionItemKind.Field],[b.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[b.CompletionItemKind.Class,s.CompletionItemKind.Class],[b.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[b.CompletionItemKind.Module,s.CompletionItemKind.Module],[b.CompletionItemKind.Property,s.CompletionItemKind.Property],[b.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[b.CompletionItemKind.Value,s.CompletionItemKind.Value],[b.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,s.CompletionItemKind.Text],[b.CompletionItemKind.Color,s.CompletionItemKind.Color],[b.CompletionItemKind.File,s.CompletionItemKind.File],[b.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[b.CompletionItemKind.Event,s.CompletionItemKind.Event],[b.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[b.CompletionItemKind.User,s.CompletionItemKind.User]]);function ue(We){return Oe.get(We)??s.CompletionItemKind.Property}ye.from=ue;const J=new Map([[s.CompletionItemKind.Method,b.CompletionItemKind.Method],[s.CompletionItemKind.Function,b.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,b.CompletionItemKind.Field],[s.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[s.CompletionItemKind.Class,b.CompletionItemKind.Class],[s.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[s.CompletionItemKind.Module,b.CompletionItemKind.Module],[s.CompletionItemKind.Property,b.CompletionItemKind.Property],[s.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[s.CompletionItemKind.Value,b.CompletionItemKind.Value],[s.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,b.CompletionItemKind.Text],[s.CompletionItemKind.Color,b.CompletionItemKind.Color],[s.CompletionItemKind.File,b.CompletionItemKind.File],[s.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[s.CompletionItemKind.Event,b.CompletionItemKind.Event],[s.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,b.CompletionItemKind.User],[s.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Ee(We){return J.get(We)??b.CompletionItemKind.Property}ye.to=Ee})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ye){function Oe(ue,J){const Ee=new b.$1N(ue.label);return Ee.insertText=ue.insertText,Ee.kind=Ue.to(ue.kind),Ee.tags=ue.tags?.map(Ae.to),Ee.detail=ue.detail,Ee.documentation=A.$5k(ue.documentation)?be.to(ue.documentation):ue.documentation,Ee.sortText=ue.sortText,Ee.filterText=ue.filterText,Ee.preselect=ue.preselect,Ee.commitCharacters=ue.commitCharacters,h.$It.isIRange(ue.range)?Ee.range=O.to(ue.range):typeof ue.range=="object"&&(Ee.range={inserting:O.to(ue.range.insert),replacing:O.to(ue.range.replace)}),Ee.keepWhitespace=typeof ue.insertTextRules>"u"?!1:!!(ue.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof ue.insertTextRules<"u"&&ue.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ee.insertText=new b.$DN(ue.insertText):(Ee.insertText=ue.insertText,Ee.textEdit=Ee.range instanceof b.$uN?new b.$zN(Ee.range,Ee.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Ee.additionalTextEdits=ue.additionalTextEdits.map(We=>ve.to(We))),Ee.command=J&&ue.command?J.fromInternal(ue.command):void 0,Ee}ye.to=Oe})(Ke||(e.CompletionItem=Ke={}));var _e;(function(ye){function Oe(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:be.fromStrict(J.documentation)}}ye.from=Oe;function ue(J){return{label:J.label,documentation:A.$5k(J.documentation)?be.to(J.documentation):J.documentation}}ye.to=ue})(_e||(e.ParameterInformation=_e={}));var it;(function(ye){function Oe(J){return{label:J.label,documentation:be.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}ye.from=Oe;function ue(J){return{label:J.label,documentation:A.$5k(J.documentation)?be.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}ye.to=ue})(it||(e.SignatureInformation=it={}));var nt;(function(ye){function Oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(it.from):[]}}ye.from=Oe;function ue(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(it.to):[]}}ye.to=ue})(nt||(e.SignatureHelp=nt={}));var tt;(function(ye){function Oe(ue,J){const Ee=new b.$ZN(W.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,ue)),J.kind&&$t.to(J.kind));return Ee.textEdits=J.textEdits&&J.textEdits.map(ve.to),Ee.tooltip=A.$5k(J.tooltip)?be.to(J.tooltip):J.tooltip,Ee.paddingLeft=J.paddingLeft,Ee.paddingRight=J.paddingRight,Ee}ye.to=Oe})(tt||(e.InlayHint=tt={}));var rt;(function(ye){function Oe(ue,J){const Ee=new b.$YN(J.label);return Ee.tooltip=A.$5k(J.tooltip)?be.to(J.tooltip):J.tooltip,s.Command.is(J.command)&&(Ee.command=ue.fromInternal(J.command)),J.location&&(Ee.location=ze.to(J.location)),Ee}ye.to=Oe})(rt||(e.InlayHintLabelPart=rt={}));var $t;(function(ye){function Oe(J){return J}ye.from=Oe;function ue(J){return J}ye.to=ue})($t||(e.InlayHintKind=$t={}));var lt;(function(ye){function Oe(J){return{range:O.from(J.range),url:J.target,tooltip:J.tooltip}}ye.from=Oe;function ue(J){let Ee;if(J.url)try{Ee=typeof J.url=="string"?o.URI.parse(J.url,!0):o.URI.revive(J.url)}catch{}const We=new b.$6N(O.to(J.range),Ee);return We.tooltip=J.tooltip,We}ye.to=ue})(lt||(e.DocumentLink=lt={}));var st;(function(ye){function Oe(J){const Ee=new b.$9N(J.label);return J.textEdit&&(Ee.textEdit=ve.to(J.textEdit)),J.additionalTextEdits&&(Ee.additionalTextEdits=J.additionalTextEdits.map(We=>ve.to(We))),Ee}ye.to=Oe;function ue(J){return{label:J.label,textEdit:J.textEdit?ve.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ee=>ve.from(Ee)):void 0}}ye.from=ue})(st||(e.ColorPresentation=st={}));var ct;(function(ye){function Oe(J){return new b.$7N(J[0],J[1],J[2],J[3])}ye.to=Oe;function ue(J){return[J.red,J.green,J.blue,J.alpha]}ye.from=ue})(ct||(e.Color=ct={}));var gt;(function(ye){function Oe(J){return{range:O.from(J.range)}}ye.from=Oe;function ue(J){return new b.$PN(O.to(J.range))}ye.to=ue})(gt||(e.SelectionRange=gt={}));var mt;(function(ye){function Oe(ue){switch(ue){case l.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}ye.to=Oe})(mt||(e.TextDocumentSaveReason=mt={}));var Be;(function(ye){function Oe(J){switch(J){case b.TextEditorLineNumbersStyle.Off:return a.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return a.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return a.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return a.RenderLineNumbersType.On}}ye.from=Oe;function ue(J){switch(J){case a.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case a.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case a.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case a.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}ye.to=ue})(Be||(e.TextEditorLineNumbersStyle=Be={}));var je;(function(ye){function Oe(J){if(J===b.EndOfLine.CRLF)return i.EndOfLineSequence.CRLF;if(J===b.EndOfLine.LF)return i.EndOfLineSequence.LF}ye.from=Oe;function ue(J){if(J===i.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(J===i.EndOfLineSequence.LF)return b.EndOfLine.LF}ye.to=ue})(je||(e.EndOfLine=je={}));var Q;(function(ye){function Oe(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case b.ProgressLocation.SourceControl:return m.ProgressLocation.Scm;case b.ProgressLocation.Window:return m.ProgressLocation.Window;case b.ProgressLocation.Notification:return m.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Oe})(Q||(e.ProgressLocation=Q={}));var x;(function(ye){function Oe(J){const Ee={start:J.start+1,end:J.end+1};return J.kind&&(Ee.kind=De.from(J.kind)),Ee}ye.from=Oe;function ue(J){const Ee={start:J.start-1,end:J.end-1};return J.kind&&(Ee.kind=De.to(J.kind)),Ee}ye.to=ue})(x||(e.FoldingRange=x={}));var De;(function(ye){function Oe(J){if(J)switch(J){case b.FoldingRangeKind.Comment:return s.$Iu.Comment;case b.FoldingRangeKind.Imports:return s.$Iu.Imports;case b.FoldingRangeKind.Region:return s.$Iu.Region}}ye.from=Oe;function ue(J){if(J)switch(J.value){case s.$Iu.Comment.value:return b.FoldingRangeKind.Comment;case s.$Iu.Imports.value:return b.FoldingRangeKind.Imports;case s.$Iu.Region.value:return b.FoldingRangeKind.Region}}ye.to=ue})(De||(e.FoldingRangeKind=De={}));var Xe;(function(ye){function Oe(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?O.from(ue.selection):void 0,override:typeof ue.override=="boolean"?l.$PF.id:void 0}}ye.from=Oe})(Xe||(e.TextEditorOpenOptions=Xe={}));var Ze;(function(ye){function Oe(We){return We instanceof b.$rO?We.toJSON():typeof We=="string"?We:ue(We)||J(We)?new b.$rO(We.baseUri??We.base,We.pattern).toJSON():We}ye.from=Oe;function ue(We){const Ye=We;return Ye?o.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function J(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Ee(We){return typeof We=="string"?We:new b.$rO(o.URI.revive(We.baseUri),We.pattern)}ye.to=Ee})(Ze||(e.GlobPattern=Ze={}));var dt;(function(ye){function Oe(ue){if(ue){if(Array.isArray(ue))return ue.map(Oe);if(typeof ue=="string")return ue;{const J=ue;return{language:J.language,scheme:J.scheme,pattern:Ze.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ye.from=Oe})(dt||(e.LanguageSelector=dt={}));var pt;(function(ye){function Oe(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Ee=>Array.isArray(Ee)&&Ee.every(We=>We&&typeof We=="object"&&"uri"in We&&o.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(Ye=>Ye instanceof b.$uN)))}ye.is=Oe;function ue(J){return{documents:J.documents.map(Ee=>Ee.map(We=>({uri:o.URI.from(We.uri),version:We.version,ranges:We.ranges.map(Ye=>O.from(Ye))})))}}ye.from=ue})(pt||(e.MappedEditsContext=pt={}));var Lt;(function(ye){function Oe(J){return{start:J.start,end:J.end}}ye.from=Oe;function ue(J){return new b.$UO(J.start,J.end)}ye.to=ue})(Lt||(e.NotebookRange=Lt={}));var jt;(function(ye){function Oe(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ye.to=Oe;function ue(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ye.from=ue})(jt||(e.NotebookCellExecutionSummary=jt={}));var xt;(function(ye){function Oe(ue){if(ue===y.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ue===y.NotebookCellExecutionState.Pending)return;if(ue===y.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ue}`)}ye.to=Oe})(xt||(e.NotebookCellExecutionState=xt={}));var li;(function(ye){function Oe(J){switch(J){case b.NotebookCellKind.Markup:return y.CellKind.Markup;case b.NotebookCellKind.Code:default:return y.CellKind.Code}}ye.from=Oe;function ue(J){switch(J){case y.CellKind.Markup:return b.NotebookCellKind.Markup;case y.CellKind.Code:default:return b.NotebookCellKind.Code}}ye.to=ue})(li||(e.NotebookCellKind=li={}));var xe;(function(ye){function Oe(J){const Ee={metadata:J.metadata??Object.create(null),cells:[]};for(const We of J.cells)b.$VO.validate(We),Ee.cells.push(It.from(We));return Ee}ye.from=Oe;function ue(J){const Ee=new b.$WO(J.cells.map(It.to));return(0,r.$sg)(J.metadata)||(Ee.metadata=J.metadata),Ee}ye.to=ue})(xe||(e.NotebookData=xe={}));var It;(function(ye){function Oe(J){return{cellKind:li.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:jt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(ht.from):[]}}ye.from=Oe;function ue(J){return new b.$VO(li.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(ht.to):void 0,J.metadata,J.internalMetadata?jt.to(J.internalMetadata):void 0)}ye.to=ue})(It||(e.NotebookCellData=It={}));var Gt;(function(ye){function Oe(J){return{mime:J.mime,valueBytes:C.$Oe.wrap(J.data)}}ye.from=Oe;function ue(J){return new b.$XO(J.valueBytes.buffer,J.mime)}ye.to=ue})(Gt||(e.NotebookCellOutputItem=Gt={}));var ht;(function(ye){function Oe(J){return{outputId:J.id,items:J.items.map(Gt.from),metadata:J.metadata}}ye.from=Oe;function ue(J){const Ee=J.items.map(Gt.to);return new b.$YO(Ee,J.outputId,J.metadata)}ye.to=ue})(ht||(e.NotebookCellOutput=ht={}));var bt;(function(ye){function Oe(Ee){return J(Ee)?{include:Ze.from(Ee.include)??void 0,exclude:Ze.from(Ee.exclude)??void 0}:Ze.from(Ee)??void 0}ye.from=Oe;function ue(Ee){return J(Ee)?{include:Ze.to(Ee.include),exclude:Ze.to(Ee.exclude)}:Ze.to(Ee)}ye.to=ue;function J(Ee){const We=Ee;return We?!(0,r.$og)(We.include)&&!(0,r.$og)(We.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var hi;(function(ye){function Oe(ue,J,Ee){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===b.NotebookCellStatusBarAlignment.Left?y.CellStatusbarAlignment.Left:y.CellStatusbarAlignment.Right,command:J.toInternal(We,Ee),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}ye.from=Oe})(hi||(e.NotebookStatusBarItem=hi={}));var _t;(function(ye){function Oe(ue,J,Ee){const We=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{command:J.toInternal(We,Ee),label:ue.label,description:ue.description,detail:ue.detail,documentation:ue.documentation}}ye.from=Oe})(_t||(e.NotebookKernelSourceAction=_t={}));var Bt;(function(ye){function Oe(ue){return{transientOutputs:ue?.transientOutputs??!1,transientCellMetadata:ue?.transientCellMetadata??{},transientDocumentMetadata:ue?.transientDocumentMetadata??{},cellContentMetadata:ue?.cellContentMetadata??{}}}ye.from=Oe})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var wt;(function(ye){function Oe(J){return{uri:J.uri,provides:J.provides}}ye.from=Oe;function ue(J){return new b.$1O(o.URI.revive(J.uri),J.provides)}ye.to=ue})(wt||(e.NotebookRendererScript=wt={}));var Wt;(function(ye){function Oe(J){return{message:be.fromStrict(J.message)||"",type:k.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:O.from(J.location.range),uri:J.location.uri}}}ye.from=Oe;function ue(J){const Ee=new b.$7O(typeof J.message=="string"?J.message:be.to(J.message));return Ee.actualOutput=J.actual,Ee.expectedOutput=J.expected,Ee.contextValue=J.contextValue,Ee.location=J.location?ze.to(J.location):void 0,Ee}ye.to=ue})(Wt||(e.TestMessage=Wt={}));var Ht;(function(ye){ye.namespace=k.$UI,ye.denamespace=k.$VI})(Ht||(e.TestTag=Ht={}));var Jt;(function(ye){function Oe(J){const Ee=(0,f.$SP)(J).controllerId;return{extId:S.$PI.fromExtHostTestItem(J,Ee).toString(),label:J.label,uri:o.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(We=>Ht.namespace(Ee,We.id)),range:h.$It.lift(O.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&be.fromStrict(J.error)||null}}ye.from=Oe;function ue(J){return{parent:void 0,error:void 0,id:S.$PI.fromString(J.extId).localId,label:J.label,uri:o.URI.revive(J.uri),tags:(J.tags||[]).map(Ee=>{const{tagId:We}=Ht.denamespace(Ee);return new b.$8O(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:O.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ye.toPlain=ue})(Jt||(e.TestItem=Jt={})),function(ye){function Oe(J){return{id:J.id}}ye.from=Oe;function ue(J){return new b.$8O(J.id)}ye.to=ue}(Ht||(e.TestTag=Ht={}));var Je;(function(ye){const Oe=(J,Ee)=>{const We=J.value;if(!We)return;const Ye={...Jt.toPlain(We.item),parent:Ee,taskStates:We.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ut=>ut.type===k.TestMessageType.Error).map(Wt.to)})),children:[]};if(J.children)for(const Ge of J.children.values()){const ut=Oe(Ge,Ye);ut&&Ye.children.push(ut)}return Ye};function ue(J){const Ee=new u.$OI;for(const Ge of J.items)Ee.insert(S.$PI.fromString(Ge.item.extId).path,Ge);const We=[Ee.nodes],Ye=[];for(;We.length;)for(const Ge of We.pop())Ge.value?Ye.push(Ge):Ge.children&&We.push(Ge.children.values());return{completedAt:J.completedAt,results:Ye.map(Ge=>Oe(Ge)).filter(r.$ng)}}ye.to=ue})(Je||(e.TestResults=Je={}));var pi;(function(ye){function Oe(We){return{covered:We.covered,total:We.total}}function ue(We){return"line"in We?W.from(We):O.from(We)}function J(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ue(We.location),type:k.DetailType.Statement,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&ue(Ye.location),label:Ye.label})):void 0}:{type:k.DetailType.Declaration,name:We.name,count:We.executed,location:ue(We.location)}}ye.fromDetails=J;function Ee(We,Ye,Ge){return b.$0O(Ge.statementCoverage),b.$0O(Ge.branchCoverage),b.$0O(Ge.declarationCoverage),{id:Ye,uri:Ge.uri,statement:Oe(Ge.statementCoverage),branch:Ge.branchCoverage&&Oe(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Oe(Ge.declarationCoverage),testIds:Ge instanceof b.$$O&&Ge.fromTests.length?Ge.fromTests.map(ut=>S.$PI.fromExtHostTestItem(ut,We).toString()):void 0}}ye.fromFile=Ee})(pi||(e.TestCoverage=pi={}));var ei;(function(ye){function Oe(ue){switch(ue){case s.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}ye.to=Oe})(ei||(e.CodeActionTriggerKind=ei={}));var si;(function(ye){function Oe(J){const Ee=new b.$cP(we.to(J.kind),J.name,J.detail||"",o.URI.revive(J.uri),O.to(J.range),O.to(J.selectionRange));return Ee._sessionId=J._sessionId,Ee._itemId=J._itemId,Ee}ye.to=Oe;function ue(J,Ee,We){if(Ee=Ee??J._sessionId,We=We??J._itemId,Ee===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Ee,_itemId:We,kind:we.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:O.from(J.range),selectionRange:O.from(J.selectionRange),tags:J.tags?.map(le.from)}}ye.from=ue})(si||(e.TypeHierarchyItem=si={}));var St;(function(ye){function Oe(ue){if(ue)return{value:ue.value,tooltip:ue.tooltip}}ye.from=Oe})(St||(e.ViewBadge=St={}));var Kt;(function(ye){function Oe(We,Ye,Ge){const ut=Ye.fileData;return ut?new b.$jO(new b.$kO(ut.name,o.URI.revive(ut.uri),ut.id,(0,T.$fb)(()=>Ge(ut.id)))):We===R.$5s.uriList&&Ye.uriListData?new b.$iO(Ee(Ye.uriListData)):new b.$iO(Ye.asString)}ye.to=Oe;async function ue(We,Ye){const Ge=await Ye.asString();if(We===R.$5s.uriList)return{asString:Ge,fileData:void 0,uriListData:J(Ge)};const ut=Ye.asFile();return{asString:Ge,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}ye.from=ue;function J(We){return P.$mu.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return o.URI.parse(Ye)}catch{}return Ye})}function Ee(We){return P.$mu.create(We.map(Ye=>typeof Ye=="string"?Ye:o.URI.revive(Ye)))}})(Kt||(e.DataTransferItem=Kt={}));var At;(function(ye){function Oe(J,Ee){const We=J.items.map(([Ye,Ge])=>[Ye,Kt.to(Ye,Ge,Ee)]);return new b.$lO(We)}ye.toDataTransfer=Oe;async function ue(J){const Ee={items:[]},We=[];for(const[Ye,Ge]of J)We.push((async()=>{Ee.items.push([Ye,await Kt.from(Ye,Ge)])})());return await Promise.all(We),Ee}ye.from=ue})(At||(e.DataTransfer=At={}));var Ft;(function(ye){function Oe(J,Ee){return{kind:"reply",agentId:J.participant??Ee?.agentId??"",subCommand:J.command??Ee?.command,message:J.prompt,title:J.label}}ye.from=Oe;function ue(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ye.to=ue})(Ft||(e.ChatFollowup=Ft={}));var ti;(function(ye){function Oe(J){switch(J){case I.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case I.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case I.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}ye.to=Oe;function ue(J){switch(J){case b.LanguageModelChatMessageRole.System:return I.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return I.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return I.ChatMessageRole.Assistant}return I.ChatMessageRole.User}ye.from=ue})(ti||(e.LanguageModelChatMessageRole=ti={}));var ii;(function(ye){function Oe(J){let Ee="",We;J.content.type==="text"?Ee=J.content.value:We=new b.$DP(J.content.name,J.content.value,J.content.isError);const Ye=ti.to(J.role),Ge=new b.$EP(Ye,Ee,J.name);return We!==void 0&&(Ge.content2=We),Ge}ye.to=Oe;function ue(J){const Ee=ti.from(J.role),We=J.name;let Ye;return J.content2 instanceof b.$DP?Ye={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ye={type:"text",value:J.content},{role:Ee,name:We,content:Ye}}ye.from=ue})(ii||(e.LanguageModelChatMessage=ii={}));var oi;(function(ye){function Oe(J){return{kind:"markdownContent",content:be.from(J.value)}}ye.from=Oe;function ue(J){return new b.$pP(be.to(J.content))}ye.to=ue})(oi||(e.ChatResponseMarkdownPart=oi={}));var Ut;(function(ye){function Oe(J){return{kind:"markdownVuln",content:be.from(J.value),vulnerabilities:J.vulnerabilities}}ye.from=Oe;function ue(J){return new b.$qP(be.to(J.content),J.vulnerabilities)}ye.to=ue})(Ut||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ut={}));var Qt;(function(ye){function Oe(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ye.from=Oe;function ue(J){return new b.$rP(J.agentId,J.command)}ye.to=ue})(Qt||(e.ChatResponseDetectedParticipantPart=Qt={}));var di;(function(ye){function Oe(ue){return{kind:"confirmation",title:ue.title,message:ue.message,data:ue.data}}ye.from=Oe})(di||(e.ChatResponseConfirmationPart=di={}));var Mt;(function(ye){function Oe(J){const{value:Ee,baseUri:We}=J;function Ye(Ge,ut){return Ge.map(Pt=>{const Yt=o.URI.joinPath(ut,Pt.name);return{label:Pt.name,uri:Yt,children:Pt.children&&Ye(Pt.children,Yt)}})}return{kind:"treeData",treeData:{label:(0,E.$dh)(We),uri:We,children:Ye(Ee,We)}}}ye.from=Oe;function ue(J){const Ee=(0,c.$ci)(J.treeData);function We(ut){return ut.map(Pt=>({name:Pt.label,children:Pt.children&&We(Pt.children)}))}const Ye=Ee.uri,Ge=Ee.children?We(Ee.children):[];return new b.$tP(Ge,Ye)}ye.to=ue})(Mt||(e.ChatResponseFilesPart=Mt={}));var vt;(function(ye){function Oe(J){const Ee=We=>o.URI.isUri(We);return{kind:"inlineReference",name:J.title,inlineReference:Ee(J.value)?J.value:q.from(J.value)}}ye.from=Oe;function ue(J){const Ee=(0,c.$ci)(J);return new b.$uP(o.URI.isUri(Ee.inlineReference)?Ee.inlineReference:q.to(Ee.inlineReference),J.name)}ye.to=ue})(vt||(e.ChatResponseAnchorPart=vt={}));var Ct;(function(ye){function Oe(J){return{kind:"progressMessage",content:be.from(J.value)}}ye.from=Oe;function ue(J){return new b.$vP(J.content.value)}ye.to=ue})(Ct||(e.ChatResponseProgressPart=Ct={}));var Ot;(function(ye){function Oe(J){return{kind:"warning",content:be.from(J.value)}}ye.from=Oe;function ue(J){return new b.$xP(J.content.value)}ye.to=ue})(Ot||(e.ChatResponseWarningPart=Ot={}));var kt;(function(ye){function Oe(ue){return{kind:"progressTask",content:be.from(ue.value)}}ye.from=Oe})(kt||(e.ChatTask=kt={}));var Xt;(function(ye){function Oe(ue){return{kind:"progressTaskResult",content:typeof ue=="string"?be.from(ue):void 0}}ye.from=Oe})(Xt||(e.ChatTaskResult=Xt={}));var qt;(function(ye){function Oe(J,Ee,We){return{kind:"command",command:Ee.toInternal(J.value,We)??{command:J.value.command,title:J.value.title}}}ye.from=Oe;function ue(J,Ee){return new b.$yP(Ee.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ye.to=ue})(qt||(e.ChatResponseCommandButtonPart=qt={}));var $i;(function(ye){function Oe(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Ee=>ve.from(Ee))}}ye.from=Oe;function ue(J){return new b.$AP(o.URI.revive(J.uri),J.edits.map(Ee=>ve.to(Ee)))}ye.to=ue})($i||(e.ChatResponseTextEditPart=$i={}));var fi;(function(ye){function Oe(J){const Ee=d.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:o.URI.isUri(J.iconPath)?{light:o.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&o.URI.isUri(J.iconPath.light)&&o.URI.isUri(J.iconPath.dark)?{light:o.URI.revive(J.iconPath.light),dark:o.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:o.URI.isUri(J.value.value)||!J.value.value?J.value.value:q.from(J.value.value)},iconPath:Ee}:{kind:"reference",reference:o.URI.isUri(J.value)?J.value:q.from(J.value),iconPath:Ee}}ye.from=Oe;function ue(J){const Ee=(0,c.$ci)(J),We=Ye=>o.URI.isUri(Ye)?Ye:q.to(Ye);return new b.$zP("variableName"in Ee.reference?{variableName:Ee.reference.variableName,value:Ee.reference.value&&We(Ee.reference.value)}:We(Ee.reference))}ye.to=ue})(fi||(e.ChatResponseReferencePart=fi={}));var Ri;(function(ye){function Oe(Ee,We,Ye){return Ee instanceof b.$pP?oi.from(Ee):Ee instanceof b.$uP?vt.from(Ee):Ee instanceof b.$zP?fi.from(Ee):Ee instanceof b.$vP?Ct.from(Ee):Ee instanceof b.$tP?Mt.from(Ee):Ee instanceof b.$yP?qt.from(Ee,We,Ye):Ee instanceof b.$AP?$i.from(Ee):Ee instanceof b.$qP?Ut.from(Ee):Ee instanceof b.$rP?Qt.from(Ee):Ee instanceof b.$xP?Ot.from(Ee):{kind:"markdownContent",content:be.from("")}}ye.from=Oe;function ue(Ee,We){switch(Ee.kind){case"reference":return fi.to(Ee);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Ee,We)}}ye.to=ue;function J(Ee,We){switch(Ee.kind){case"markdownContent":return oi.to(Ee);case"inlineReference":return vt.to(Ee);case"progressMessage":return;case"treeData":return Mt.to(Ee);case"command":return qt.to(Ee,We)}}ye.toContent=J})(Ri||(e.ChatResponsePart=Ri={}));var Nt;(function(ye){function Oe(ue){return{prompt:ue.message,command:ue.command,attempt:ue.attempt??0,enableCommandDetection:ue.enableCommandDetection??!0,references:ue.variables.variables.map(ai.to),location:Oi.to(ue.location),acceptedConfirmationData:ue.acceptedConfirmationData,rejectedConfirmationData:ue.rejectedConfirmationData}}ye.to=Oe})(Nt||(e.ChatAgentRequest=Nt={}));var Oi;(function(ye){function Oe(J){switch(J){case $.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case $.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case $.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case $.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}ye.to=Oe;function ue(J){switch(J){case b.ChatLocation.Notebook:return $.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return $.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return $.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return $.ChatAgentLocation.Editor}}ye.from=ue})(Oi||(e.ChatLocation=Oi={}));var ai;(function(ye){function Oe(ue){const J=ue.value;if(!J)throw new Error("Invalid value reference");return{id:ue.id,name:ue.name,range:ue.range&&[ue.range.start,ue.range.endExclusive],value:(0,o.$xc)(J)?o.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,o.$xc)(J.uri)?q.to((0,c.$ci)(J)):J,modelDescription:ue.modelDescription}}ye.to=Oe})(ai||(e.ChatAgentValueReference=ai={}));var Rt;(function(ye){function Oe(ue,J,Ee){return{id:ue.id,label:ue.label,fullName:ue.fullName,icon:ue.icon?.id,value:ue.values[0].value,insertText:ue.insertText,detail:ue.detail,documentation:ue.documentation,command:J.toInternal(ue.command,Ee)}}ye.from=Oe})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Di;(function(ye){function Oe(ue){return{errorDetails:ue.errorDetails,metadata:ue.metadata}}ye.to=Oe})(Di||(e.ChatAgentResult=Di={}));var Si;(function(ye){function Oe(ue,J,Ee){if(J.action.kind==="vote")return;const We=Di.to(ue);if(J.action.kind==="command"){const Ye=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ee.fromInternal(Ye)??{command:Ye.id,title:Ye.title}}},result:We}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(J.action.followup)},result:We}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:We}:{action:J.action,result:We}}ye.to=Oe})(Si||(e.ChatAgentUserActionEvent=Si={}));var vi;(function(ye){function Oe(ue,J,Ee){return"terminalCommand"in ue?{terminalCommand:ue.terminalCommand,shouldExecute:ue.shouldExecute}:"uri"in ue?{uri:ue.uri}:J.toInternal(ue,Ee)}ye.from=Oe})(vi||(e.TerminalQuickFix=vi={}));var Ti;(function(ye){function Oe(ue){return{kind:gi.to(ue.kind)}}ye.to=Oe})(Ti||(e.PartialAcceptInfo=Ti={}));var gi;(function(ye){function Oe(ue){switch(ue){case s.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}ye.to=Oe})(gi||(e.PartialAcceptTriggerKind=gi={}));var Vt;(function(ye){function Oe(ue,J){return{id:J,label:ue.label,description:ue.description,canEdit:ue.canEdit,collapsibleState:ue.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:ue.contextValue}}ye.from=Oe})(Vt||(e.DebugTreeItem=Vt={}))}),define(Ce[274],Ie([1,0,6,17,10,39]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;let A=class{constructor(p,c){this.a=p.getProxy(w.$qN.MainThreadBulkEdits),this.b={getTextDocumentVersion:R=>c.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,c,R){const v=new T.$Qw(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(v,void 0,R?.isRefactoring??!1)}};e.$Mnc=A,e.$Mnc=A=Qe([Ve(0,C.$WP)],A)}),define(Ce[275],Ie([1,0,18,11,48,4,40,5,70,15,2,19,6,10,7,235,25]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0,E=qe(E),d=qe(d);class a{constructor(i,t,m,f,l){this.j=i,this.k=t,this.l=m,this.m=f,this.n=l,this.b=p.$ge.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(f){if(i.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,f),l}};const i=this;this.b.reset();const m=(f,l)=>{if(typeof this.d>"u"&&"content"in f&&(this.d=this.b.elapsed()),l){const $=this.l.$handleProgressChunk(this.k.requestId,f),I={report:D=>{$?.then(y=>{y&&(d.$UN.isMarkdownString(D.value)?this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseWarningPart.from(D),y):this.l.$handleProgressChunk(this.k.requestId,E.ChatResponseReferencePart.from(D),y))})}};Promise.all([$,l?.(I)]).then(([D,y])=>{D!==void 0&&y!==void 0&&this.l.$handleProgressChunk(this.k.requestId,E.ChatTaskResult.from(y),D)})}else this.l.$handleProgressChunk(this.k.requestId,f)};this.g={markdown(f){t(this.markdown);const l=new d.$pP(f),$=E.ChatResponseMarkdownPart.from(l);return m($),this},markdownWithVulnerabilities(f,l){t(this.markdown),l&&(0,o.$5G)(i.j,"chatParticipantAdditions");const $=new d.$qP(f,l),I=E.ChatResponseMarkdownWithVulnerabilitiesPart.from($);return m(I),this},filetree(f,l){t(this.filetree);const $=new d.$tP(f,l),I=E.ChatResponseFilesPart.from($);return m(I),this},anchor(f,l){t(this.anchor);const $=new d.$uP(f,l),I=E.ChatResponseAnchorPart.from($);return m(I),this},button(f){t(this.anchor);const l=new d.$yP(f),$=E.ChatResponseCommandButtonPart.from(l,i.m,i.n);return m($),this},progress(f,l){t(this.progress);const $=new d.$wP(f,l),I=l?E.ChatTask.from($):E.ChatResponseProgressPart.from($);return m(I,l),this},warning(f){t(this.progress),(0,o.$5G)(i.j,"chatParticipantAdditions");const l=new d.$xP(f),$=E.ChatResponseWarningPart.from(l);return m($),this},reference(f,l){if(t(this.reference),"variableName"in f&&(0,o.$5G)(i.j,"chatParticipantAdditions"),"variableName"in f&&!f.value){const $=i.k.variables.variables.find(I=>I.name===f.variableName);if($){let I;if($.references?.length)I=$.references.map(D=>({kind:"reference",reference:{variableName:f.variableName,value:D.reference}}));else{const D=new d.$zP(f,l);I=[E.ChatResponseReferencePart.from(D)]}return I.forEach(D=>m(D)),this}}else{const $=new d.$zP(f,l),I=E.ChatResponseReferencePart.from($);m(I)}return this},textEdit(f,l){t(this.textEdit),(0,o.$5G)(i.j,"chatParticipantAdditions");const $=new d.$AP(f,l),I=E.ChatResponseTextEditPart.from($);return m(I),this},detectedParticipant(f,l){t(this.detectedParticipant),(0,o.$5G)(i.j,"chatParticipantAdditions");const $=new d.$rP(f,l),I=E.ChatResponseDetectedParticipantPart.from($);return m(I),this},confirmation(f,l,$){t(this.confirmation),(0,o.$5G)(i.j,"chatParticipantAdditions");const I=new d.$sP(f,l,$),D=E.ChatResponseConfirmationPart.from(I);return m(D),this},push(f){if(t(this.push),(f instanceof d.$AP||f instanceof d.$qP||f instanceof d.$rP||f instanceof d.$xP||f instanceof d.$sP)&&(0,o.$5G)(i.j,"chatParticipantAdditions"),f instanceof d.$zP)this.reference(f.value,f.iconPath);else{const l=E.ChatResponsePart.from(f,i.m,i.n);m(l)}return this}}}return this.g}}class h extends N.$Wc{static{this.b=0}constructor(i,t,m,f){super(),this.n=t,this.s=m,this.t=f,this.c=new Map,this.j=this.B(new N.$6c),this.m=this.B(new N.$6c),this.g=i.getProxy(u.$qN.MainThreadChatAgents2)}transferActiveChat(i){this.g.$transferActiveChatSession(i)}createChatAgent(i,t,m){const f=h.b++,l=new n(i,this.t,t,this.g,f,m);return this.c.set(f,l),l.isAgentEnabled()&&this.g.$registerAgent(f,i.identifier,t,{},void 0),l.apiAgent}createDynamicChatAgent(i,t,m,f){const l=h.b++,$=new n(i,this.t,t,this.g,l,f);return this.c.set(l,$),this.g.$registerAgent(l,i.identifier,t,{isSticky:!0},m),$.apiAgent}async $invokeAgent(i,t,m,f){const l=this.c.get(i);if(!l)throw new Error(`[CHAT](${i}) CANNOT invoke agent because the agent is not registered`);let $=this.j.get(t.sessionId);$||($=new N.$Vc,this.j.set(t.sessionId,$));const I=new a(l.extension,t,this.g,this.s.converter,$);try{const D=await this.u(t.agentId,m),y=l.invoke(E.ChatAgentRequest.to(t),{history:D},I.apiObject,f);return await(0,C.$th)(Promise.resolve(y).then(S=>{if(S?.metadata)try{JSON.stringify(S.metadata)}catch(g){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${g.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${b}`,l.extension),{errorDetails:{message:b},timings:I.timings}}let k;return S?.errorDetails&&(k={...S.errorDetails,responseIsIncomplete:!0}),k?.responseIsRedacted&&(0,o.$5G)(l.extension,"chatParticipantPrivate"),{errorDetails:k,timings:I.timings,metadata:S?.metadata}}),f)}catch(D){return this.n.error(D,l.extension),D instanceof d.$KP&&D.cause&&(D=D.cause),{errorDetails:{message:(0,P.$qj)(D),responseIsIncomplete:!0}}}finally{I.close()}}async u(i,t){const m=[];for(const f of t.history){const l=E.ChatAgentResult.to(f.result),$=i===f.request.agentId?l:{...l,metadata:void 0};m.push(new d.$BP(f.request.message,f.request.command,f.request.variables.variables.map(E.ChatAgentValueReference.to),f.request.agentId));const I=(0,w.$Jb)(f.response.map(D=>E.ChatResponsePart.toContent(D,this.s.converter)));m.push(new d.$CP(I,$,f.request.agentId,f.request.command))}return m}$releaseSession(i){this.j.deleteAndDispose(i)}async $provideFollowups(i,t,m,f,l){const $=this.c.get(t);if(!$)return Promise.resolve([]);const I=await this.u($.id,f),D=E.ChatAgentResult.to(m);return(await $.provideFollowups(D,{history:I},l)).filter(y=>{const S=!y.participant||A.Iterable.some(this.c.values(),k=>k.id===y.participant&&v.$qn.equals(k.extension.identifier,$.extension.identifier));return S||this.n.warn(`[@${$.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),S}).map(y=>E.ChatFollowup.from(y,i))}$acceptFeedback(i,t,m,f){const l=this.c.get(i);if(!l)return;const $=E.ChatAgentResult.to(t);let I;switch(m){case r.ChatAgentVoteDirection.Down:I=d.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:I=d.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(f?{result:$,kind:I,reportIssue:f}:{result:$,kind:I}))}$acceptAction(i,t,m){const f=this.c.get(i);if(!f||m.action.kind==="vote")return;const l=E.ChatAgentUserActionEvent.to(t,m,this.s.converter);l&&f.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(i,t,m){const f=this.c.get(i);if(!f)return[];let l=this.m.get(i);return l?l.clear():(l=new N.$Vc,this.m.set(i,l)),(await f.invokeCompletionProvider(t,m)).map(I=>E.ChatAgentCompletionItem.from(I,this.s.converter,l))}async $provideWelcomeMessage(i,t,m){const f=this.c.get(i);if(f)return await f.provideWelcomeMessage(E.ChatLocation.to(t),m)}async $provideSampleQuestions(i,t,m){const f=this.c.get(i);if(f)return(await f.provideSampleQuestions(E.ChatLocation.to(t),m)).map(l=>E.ChatFollowup.from(l,void 0))}}e.$Nnc=h;class n{constructor(i,t,m,f,l,$){this.extension=i,this.w=t,this.id=m,this.x=f,this.y=l,this.z=$,this.m=new T.$me,this.n=new T.$me}acceptFeedback(i){this.m.fire(i)}acceptAction(i){this.n.fire(i)}async invokeCompletionProvider(i,t){return this.q?await this.q.provider.provideCompletionItems(i,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$4G)(this.extension,"chatParticipantPrivate"))}async provideFollowups(i,t,m){if(!this.b)return[];const f=await this.b.provideFollowups(i,t,m);return f?f.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(i,t){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(i,t);return m?m.map(f=>typeof f=="string"?f:E.MarkdownString.from(f)):[]}async provideSampleQuestions(i,t){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(i,t);return m||[]}get apiAgent(){let i=!1,t=!1;const m=()=>{i||t||(t=!0,queueMicrotask(()=>{f.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof R.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof d.$pO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:E.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:E.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:E.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},f=this;return{get id(){return f.id},get iconPath(){return f.c},set iconPath(l){f.c=l,m()},get requestHandler(){return f.z},set requestHandler(l){(0,c.$pg)(typeof l=="function","Invalid request handler"),f.z=l},get followupProvider(){return f.b},set followupProvider(l){f.b=l,m()},get isDefault(){return(0,o.$5G)(f.extension,"defaultChatParticipant"),f.d},set isDefault(l){(0,o.$5G)(f.extension,"defaultChatParticipant"),f.d=l,m()},get helpTextPrefix(){return(0,o.$5G)(f.extension,"defaultChatParticipant"),f.g},set helpTextPrefix(l){(0,o.$5G)(f.extension,"defaultChatParticipant"),f.g=l,m()},get helpTextVariablesPrefix(){return(0,o.$5G)(f.extension,"defaultChatParticipant"),f.j},set helpTextVariablesPrefix(l){(0,o.$5G)(f.extension,"defaultChatParticipant"),f.j=l,m()},get helpTextPostfix(){return(0,o.$5G)(f.extension,"defaultChatParticipant"),f.k},set helpTextPostfix(l){(0,o.$5G)(f.extension,"defaultChatParticipant"),f.k=l,m()},get isSecondary(){return(0,o.$5G)(f.extension,"defaultChatParticipant"),f.l},set isSecondary(l){(0,o.$5G)(f.extension,"defaultChatParticipant"),f.l=l,m()},get supportIssueReporting(){return(0,o.$5G)(f.extension,"chatParticipantPrivate"),f.o},set supportIssueReporting(l){(0,o.$5G)(f.extension,"chatParticipantPrivate"),f.o=l,m()},get onDidReceiveFeedback(){return f.m.event},set participantVariableProvider(l){if((0,o.$5G)(f.extension,"chatParticipantAdditions"),f.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");f.x.$registerAgentCompletionsProvider(f.y,f.id,l.triggerCharacters)}else f.x.$unregisterAgentCompletionsProvider(f.y,f.id)},get participantVariableProvider(){return(0,o.$5G)(f.extension,"chatParticipantAdditions"),f.q},set welcomeMessageProvider(l){(0,o.$5G)(f.extension,"defaultChatParticipant"),f.s=l,m()},get welcomeMessageProvider(){return(0,o.$5G)(f.extension,"defaultChatParticipant"),f.s},onDidPerformAction:(0,o.$4G)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){f.t=l,m()},get requester(){return f.t},set supportsSlowReferences(l){(0,o.$5G)(f.extension,"chatParticipantPrivate"),f.u=l,m()},get supportsSlowReferences(){return(0,o.$5G)(f.extension,"chatParticipantPrivate"),f.u},dispose(){i=!0,f.b=void 0,f.m.dispose(),f.x.$unregisterAgent(f.y)}}}invoke(i,t,m,f){return this.z(i,t,m,f)}}}),define(Ce[276],Ie([1,0,14,5,35,6,10,7,25]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0,A=qe(A),N=qe(N);class c{static{this.a=0}constructor(u){this.b=new Map,this.c=u.getProxy(T.$qN.MainThreadChatVariables)}async $resolveVariable(u,E,d,r){const o=this.b.get(u);if(o)try{if(o.resolver.resolve2){(0,p.$5G)(o.extension,"chatParticipantAdditions");const a=new R(E,this.c),h=await o.resolver.resolve2(o.data.name,{prompt:d},a.apiObject,r);if(h&&h[0])return h[0].value}else{const a=await o.resolver.resolve(o.data.name,{prompt:d},r);if(a&&a[0])return a[0].value}}catch(a){(0,w.$4)(a)}}registerVariableResolver(u,E,d,r,o,a,h,n,s){const i=c.a++,t=s?P.ThemeIcon.fromId(s):void 0;return this.b.set(i,{extension:u,data:{id:E,name:d,description:r,modelDescription:o,icon:t},resolver:h}),this.c.$registerVariable(i,{id:E,name:d,description:r,modelDescription:o,isSlow:a,fullName:n,icon:t}),(0,C.$Uc)(()=>{this.b.delete(i),this.c.$unregisterVariable(i)})}}e.$Onc=c;class R{constructor(u,E){this.c=u,this.d=E,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let E=function(r){if(u.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const u=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){E(this.progress);const o=new N.$vP(r),a=A.ChatResponseProgressPart.from(o);return d(a),this},reference(r){E(this.reference);const o=new N.$zP(r),a=A.ChatResponseReferencePart.from(o);return d(a),this},push(r){return E(this.push),r instanceof N.$zP?d(A.ChatResponseReferencePart.from(r)):r instanceof N.$vP&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ce[277],Ie([1,0,11,72,4,5,38,2,94,19,10,7,6,25]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=d,p=qe(p),R=qe(R),v=qe(v);function d(r,o,a){const h=r.getProxy(u.$qN.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new c.$sn,o.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===A.MarshalledId.CommentController){const S=this.b.get(y.handle);return S?S.value:y}else if(y&&y.$mid===A.MarshalledId.CommentThread){const S=y,k=this.b.get(S.commentControlHandle);if(!k)return S;const g=k.getCommentThread(S.commentThreadHandle);return g?g.value:S}else if(y&&(y.$mid===A.MarshalledId.CommentThreadReply||y.$mid===A.MarshalledId.CommentThreadInstance)){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);return k?y.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:y.text}:y}else if(y&&y.$mid===A.MarshalledId.CommentNode){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const g=y.commentUniqueId,b=k.getCommentByUniqueId(g);return b||y}else if(y&&y.$mid===A.MarshalledId.CommentThreadNode){const S=this.b.get(y.thread.commentControlHandle);if(!S)return y;const k=S.getCommentThread(y.thread.commentThreadHandle);if(!k)return y;const g=y.text,b=y.commentUniqueId,L=k.getCommentByUniqueId(b);return L?(typeof L.body=="string"?L.body=g:L.body=new v.$UN(g),L):y}return y}})}createCommentController(y,S,k){const g=n.a++,b=new i(y,g,S,k);this.b.set(b.handle,b);const L=this.c.get(y.identifier)||[];return L.push(b),this.c.set(y.identifier,L),b.value}async $createCommentThreadTemplate(y,S,k,g){const b=this.b.get(y);b&&b.$createCommentThreadTemplate(S,k,g)}async $setActiveComment(y,S){const k=this.b.get(y);k&&k.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(y,S,k){const g=this.b.get(y);g&&g.$updateCommentThreadTemplate(S,k)}$deleteCommentThread(y,S){this.b.get(y)?.$deleteCommentThread(S)}async $provideCommentingRanges(y,S,k){const g=this.b.get(y);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const b=await a.ensureDocumentData(N.URI.revive(S));return(0,w.$xh)(async()=>{const L=await g.commentingRangeProvider.provideCommentingRanges(b.document,k);let O;return Array.isArray(L)?O={ranges:L,fileComments:!1}:L?O={ranges:L.ranges||[],fileComments:L.fileComments||!1}:O=L??void 0,O}).then(L=>{let O;return L&&(O={ranges:L.ranges.map(q=>R.Range.from(q)),fileComments:L.fileComments}),O})}$toggleReaction(y,S,k,g,b){const L=this.b.get(y);return!L||!L.reactionHandler?Promise.resolve(void 0):(0,w.$xh)(()=>{const O=L.getCommentThread(S);if(O){const q=O.getCommentByUniqueId(g.uniqueIdInThread);if(L!==void 0&&q&&L.reactionHandler)return L.reactionHandler(q,f(b))}return Promise.resolve(void 0)})}}class s{static{this.a=0}set threadId(y){this.n=y}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(y){(y===void 0!=(this.p===void 0)||!y||!this.p||!y.isEqual(this.p))&&(this.p=y,this.b.range=y,this.c.fire())}get range(){return this.p}set canReply(y){this.d!==y&&(this.d=y,this.b.canReply=y,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(y){this.e=y,this.b.label=y,this.c.fire()}get contextValue(){return this.f}set contextValue(y){this.f=y,this.b.contextValue=y,this.c.fire()}get comments(){return this.q}set comments(y){this.q=y,this.b.comments=y,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(y){this.g=y,this.b.collapsibleState=y,this.c.fire()}get state(){return this.h}set state(y){this.h=y,typeof y=="object"?((0,E.$5G)(this.extensionDescription,"commentThreadApplicability"),this.b.state=y.resolved,this.b.applicability=y.applicability):this.b.state=y,this.c.fire()}get isDisposed(){return this.j}constructor(y,S,k,g,b,L,O,q,G){this.m=S,this.n=k,this.o=g,this.p=b,this.q=L,this.extensionDescription=O,this.r=q,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$me,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Xc,this.l.value=new T.$Vc,this.n===void 0&&(this.n=`${y}.${this.handle}`),h.$createCommentThread(S,this.handle,this.n,this.o,R.Range.from(this.p),O.identifier,this.r,G),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=L,this.i.push({dispose:()=>{h.$deleteCommentThread(S,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(F){W.range=F},get comments(){return W.comments},set comments(F){W.comments=F},get collapsibleState(){return W.collapsibleState},set collapsibleState(F){W.collapsibleState=F},get canReply(){return W.canReply},set canReply(F){W.canReply=F},get contextValue(){return W.contextValue},set contextValue(F){W.contextValue=F},get label(){return W.label},set label(F){W.label=F},get state(){return W.state},set state(F){W.state=F},reveal:F=>W.reveal(F),dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Vc);const y=k=>Object.prototype.hasOwnProperty.call(this.b,k),S={};y("range")&&(S.range=R.Range.from(this.p)),y("label")&&(S.label=this.label),y("contextValue")&&(S.contextValue=this.contextValue??null),y("comments")&&(S.comments=this.q.map(k=>t(this,k,this.k,this.extensionDescription))),y("collapsibleState")&&(S.collapseState=l(this.g)),y("canReply")&&(S.canReply=this.canReply),y("state")&&(S.state=$(this.h)),y("applicability")&&(S.applicability=I(this.h)),y("isTemplate")&&(S.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(y){for(const S of this.k){const k=S[0],g=S[1];if(y===g)return k}}async reveal(y){return(0,E.$5G)(this.extensionDescription,"commentReveal"),h.$revealCommentThread(this.m,this.handle,{preserveFocus:!1,focusReply:!1,...y})}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(y=>y.dispose())}}Qe([(0,C.$$h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class i{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(y){this.b=y,y?.resourceHints&&(0,E.$5G)(this.h,"commentingRangeHint"),h.$updateCommentingRanges(this.handle,y?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(y){this.c=y,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!y})}get options(){return this.d}set options(y){this.d=y,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,E.$5G)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,E.$5G)(this.h,"activeComment"),this.f}constructor(y,S,k,g){this.h=y,this.i=S,this.j=k,this.k=g,this.a=new Map,h.$registerCommentController(this.handle,k,g,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(L){b.options=L},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(L){b.commentingRangeProvider=L},get reactionHandler(){return b.reactionHandler},set reactionHandler(L){b.reactionHandler=L},get activeCommentThread(){return b.activeCommentThread},createCommentThread(L,O,q){return b.createCommentThread(L,O,q).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(y,S,k){S===void 0&&(0,E.$5G)(this.h,"fileComments");const g=new s(this.id,this.handle,void 0,y,S,k,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(y){if(!y){this.e=void 0,this.f=void 0;return}const S=this.a.get(y.commentThreadHandle);S&&(this.e=y.uniqueIdInThread?S.getCommentByUniqueId(y.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(y,S,k){const g=new s(this.id,this.handle,void 0,N.URI.revive(y),R.Range.to(S),[],this.h,!0,k);return g.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(g.handle,g),g}$updateCommentThreadTemplate(y,S){const k=this.a.get(y);k&&(k.range=R.Range.to(S))}$deleteCommentThread(y){this.a.get(y)?.dispose(),this.a.delete(y)}getCommentThread(y){return this.a.get(y)}dispose(){this.a.forEach(y=>{y.dispose()}),this.g.forEach(y=>y.dispose())}}function t(D,y,S,k){let g=S.get(y);return g||(g=++D.commentHandle,S.set(y,g)),y.state!==void 0&&(0,E.$5G)(k,"commentsDraftState"),y.reactions?.some(b=>b.reactors!==void 0)&&(0,E.$5G)(k,"commentReactor"),{mode:y.mode,contextValue:y.contextValue,uniqueIdInThread:g,body:typeof y.body=="string"?y.body:R.MarkdownString.from(y.body),userName:y.author.name,userIconPath:y.author.iconPath,label:y.label,commentReactions:y.reactions?y.reactions.map(b=>m(b)):void 0,state:y.state,timestamp:y.timestamp?.toJSON()}}function m(D){return{label:D.label,iconPath:D.iconPath?R.$VP(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(y=>y.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?N.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(y=>({name:y}))}}function l(D){if(D!==void 0)switch(D){case v.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case v.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function $(D){let y;if(typeof D=="object"?y=D.resolved:y=D,y!==void 0)switch(y){case v.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case v.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function I(D){let y;if(typeof D=="object"&&(y=D.applicability),y!==void 0)switch(y){case v.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case v.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Ce[278],Ie([1,0,22,76,5,16,24,2,10,68,80,6,7]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0,p=qe(p),v=qe(v),u=qe(u);class E{constructor(m,f){this.document=m,this.b=f,this.a=1,this.c=new R.$ync("custom documents")}addEdit(m){return this.c.add([m])}async undo(m,f){await this.f(m).undo(),f||this.disposeBackup()}async redo(m,f){await this.f(m).redo(),f||this.disposeBackup()}disposeEdits(m){for(const f of m)this.c.delete(f)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const m=i(this.document.uri)+this.a++;return(0,A.$gh)(this.b,m)}updateBackup(m){this.d?.delete(),this.d=m}disposeBackup(){this.d?.delete(),this.d=void 0}f(m){const f=this.c.get(m,0);if(!f)throw new Error("No edit found");return f}}class d{constructor(){this.a=new Map}get(m,f){return this.a.get(this.b(m,f))}add(m,f,l){const $=this.b(m,f.uri);if(this.a.has($))throw new Error(`Document already exists for viewType:${m} resource:${f.uri}`);const I=new E(f,l);return this.a.set($,I),I}delete(m,f){const l=this.b(m,f.uri);this.a.delete(l)}b(m,f){return`${m}@@@${f}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(m,f,l){return this.b(m,{type:r.Text,extension:f,provider:l})}addCustomProvider(m,f,l){return this.b(m,{type:r.Custom,extension:f,provider:l})}get(m){return this.a.get(m)}b(m,f){if(this.a.has(m))throw new Error(`Provider for viewType:${m} already registered`);return this.a.set(m,f),new u.$sN(()=>this.a.delete(m))}}class a{constructor(m,f,l,$,I){this.d=f,this.f=l,this.g=$,this.h=I,this.b=new o,this.c=new d,this.a=m.getProxy(v.$qN.MainThreadCustomEditors)}registerCustomEditorProvider(m,f,l,$){const I=new P.$Vc;return n(l)?(I.add(this.b.addTextProvider(f,m,l)),this.a.$registerTextEditorProvider((0,c.$8nc)(m),f,$.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,c.$6nc)(m))):(I.add(this.b.addCustomProvider(f,m,l)),h(l)&&I.add(l.onDidChangeCustomDocument(D=>{const y=this.i(f,D.document.uri);if(s(D)){const S=y.addEdit(D);this.a.$onDidEdit(D.document.uri,f,S,D.label)}else this.a.$onContentChange(D.document.uri,f)})),this.a.$registerCustomEditorProvider((0,c.$8nc)(m),f,$.webviewOptions||{},!!$.supportsMultipleEditorsPerDocument,(0,c.$6nc)(m))),u.$sN.from(I,new u.$sN(()=>{this.a.$unregisterEditorProvider(f)}))}async $createCustomDocument(m,f,l,$,I){const D=this.b.get(f);if(!D)throw new Error(`No provider found for '${f}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${f}'`);const y=N.URI.revive(m),S=await D.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:$?.buffer},I);let k;return h(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add(f,S,k),{editable:h(D.provider)}}async $disposeCustomDocument(m,f){const l=this.b.get(f);if(!l)throw new Error(`No provider found for '${f}'`);if(l.type!==r.Custom)throw new Error(`Invalid provider type for '${f}'`);const $=N.URI.revive(m),{document:I}=this.i(f,$);this.c.delete(f,I),I.dispose()}async $resolveCustomEditor(m,f,l,$,I,D){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const S=p.ViewColumn.to(I),k=this.g.createNewWebview(f,$.contentOptions,y.extension),g=this.h.createNewWebviewPanel(f,l,$.title,S,$.options,k,$.active),b=N.URI.revive(m);switch(y.type){case r.Custom:{const{document:L}=this.i(l,b);return y.provider.resolveCustomEditor(L,g,D)}case r.Text:{const L=this.d.getDocument(b);return y.provider.resolveCustomTextEditor(L,g,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(m,f,l){this.i(f,m).disposeEdits(l)}async $onMoveCustomEditor(m,f,l){const $=this.b.get(l);if(!$)throw new Error(`No provider found for '${l}'`);if(!$.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const I=this.h.getWebviewPanel(m);if(!I)throw new Error("No webview found");const D=N.URI.revive(f),y=this.d.getDocument(D);await $.provider.moveCustomTextEditor(y,I,w.CancellationToken.None)}async $undo(m,f,l,$){return this.i(f,m).undo(l,$)}async $redo(m,f,l,$){return this.i(f,m).redo(l,$)}async $revert(m,f,l){const $=this.i(f,m);await this.j(f).revertCustomDocument($.document,l),$.disposeBackup()}async $onSave(m,f,l){const $=this.i(f,m);await this.j(f).saveCustomDocument($.document,l),$.disposeBackup()}async $onSaveAs(m,f,l,$){const I=this.i(f,m);return this.j(f).saveCustomDocumentAs(I.document,N.URI.revive(l),$)}async $backup(m,f,l){const $=this.i(f,m),D=await this.j(f).backupCustomDocument($.document,{destination:$.getNewBackupUri()},l);return $.updateBackup(D),D.id}i(m,f){const l=this.c.get(m,N.URI.revive(f));if(!l)throw new Error("No custom document found");return l}j(m){const l=this.b.get(m)?.provider;if(!l||!h(l))throw new Error("Custom document is not editable");return l}}e.$$nc=a;function h(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function s(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function i(t){const m=t.scheme===T.Schemas.file||t.scheme===T.Schemas.untitled?t.fsPath:t.toString();return(0,C.$tj)(m)+""}}),define(Ce[279],Ie([1,0,180,107,2,6,7,10,4,12,29,51]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Fnc=void 0,N=qe(N);class E{#e;#t;#i;constructor(o,a,h,n,s,i,t,m){this.d=o,this.e=a,this.f=h,this.g=n,this.h=s,this.c=!1,this.f=Math.max(n,h),this.#i=new R.$Cc(f=>i.getComparisonKey(f)),this.#e=t,this.#t=m}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,a){if(!o){this.clear();return}this.j();let h=[];if(P.URI.isUri(o)){if(!a){this.delete(o);return}this.#i.set(o,a.slice()),h=[o]}else if(Array.isArray(o)){h=[];let i;o=[...o].sort(E.k);for(const t of o){const[m,f]=t;if((!i||m.toString()!==i.toString())&&(i&&this.#i.get(i).length===0&&this.#i.delete(i),i=m,h.push(m),this.#i.set(m,[])),f)this.#i.get(m)?.push(...f);else{const l=this.#i.get(m);l&&(l.length=0)}}}if(this.#t.fire(h),!this.#e)return;const n=[];let s=0;for(const i of h){let t=[];const m=this.#i.get(i);if(m)if(m.length>this.g){t=[];const f=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const $ of m)if($.severity===f[l]&&t.push({...N.Diagnostic.from($),modelVersionId:this.h(i)})===this.g)break e;t.push({severity:C.MarkerSeverity.Info,message:(0,w.localize)(0,null,m.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=m.map(f=>({...N.Diagnostic.from(f),modelVersionId:this.h(i)}));if(n.push([i,t]),s+=t.length,s>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,a){this.j();for(const[h,n]of this)o.call(a,h,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const a=this.#i.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.$Fnc=E;let d=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(o){const a=new R.$Cc;for(const h of o)a.set(h,h);return{uris:Object.freeze(Array.from(a.values()))}}constructor(o,a,h,n){this.j=a,this.k=h,this.l=n,this.g=new Map,this.h=new p.$qe({merge:s=>s.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,u._mapper),this.f=o.getProxy(T.$qN.MainThreadDiagnostics)}createDiagnosticCollection(o,a){const{g:h,f:n,h:s,j:i,k:t,l:m}=this,f=new class{$changeMany(I,D){n.$changeMany(I,D),i.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,I,D.length===0?"CLEARING":D)}$clear(I){n.$clear(I),i.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,I)}dispose(){n.dispose()}};let l;if(!a)a="_generated_diagnostic_collection_name_#"+u.c++,l=a;else if(!h.has(a))l=a;else{this.j.warn(`DiagnosticCollection with name '${a}' does already exist.`);do l=a+u.c++;while(h.has(l))}return new class extends E{constructor(){super(a,l,u.e,u.d,I=>m.getDocument(I)?.version,t.extUri,f,s),h.set(l,this)}dispose(){super.dispose(),h.delete(l)}}}getDiagnostics(o){if(o)return this.m(o);{const a=new Map,h=[];for(const n of this.g.values())n.forEach((s,i)=>{let t=a.get(s.toString());typeof t>"u"&&(t=h.length,a.set(s.toString(),t),h.push([s,[]])),h[t][1]=h[t][1].concat(...i)});return h}}m(o){let a=[];for(const h of this.g.values())h.has(o)&&(a=a.concat(h.get(o)));return a}$acceptMarkersChange(o){if(!this.n){const a="_generated_mirror",h=new E(a,a,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(a,h),this.n=h}for(const[a,h]of o)this.n.set(P.URI.revive(a),h.map(N.Diagnostic.to))}};e.$Gnc=d,e.$Gnc=d=u=Qe([Ve(1,c.$_j),Ve(2,v.$Enc)],d)}),define(Ce[280],Ie([1,0,2,14,7,10,212,39]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;class p{constructor(R,v,u,E={timeout:1500,errors:3}){this.c=R,this.d=v,this.f=u,this.g=E,this.a=new A.$7c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(R){return(v,u,E)=>{const r={dispose:this.a.push([v,u,R])};return Array.isArray(E)&&E.push(r),r}}async $participateInSave(R,v){const u=w.URI.revive(R);let E=!1;const d=setTimeout(()=>E=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(E)break;const a=this.d.getDocument(u),h=await this.h(o,{document:a,reason:T.TextDocumentSaveReason.to(v)});r.push(h)}}finally{clearTimeout(d)}return r}h([R,v,u],E){const d=this.b.get(R);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(u,R,v,E).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(R);this.b.set(R,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(R,v,u,E){const d=[],r=Date.now(),{document:o,reason:a}=E,{version:h}=o,n=Object.freeze({document:o,reason:a,waitUntil(s){if(Object.isFrozen(d))throw(0,C.$0)("waitUntil can not be called async");d.push(Promise.resolve(s))}});try{v.apply(u,[n])}catch(s){return Promise.reject(s)}return Object.freeze(d),new Promise((s,i)=>{const t=setTimeout(()=>i(new Error("timeout")),this.g.timeout);return Promise.all(d).then(m=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${R.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(t),s(m)}).catch(m=>{clearTimeout(t),i(m)})}).then(s=>{const i={edits:[]};for(const t of s)if(Array.isArray(t)&&t.every(m=>m instanceof P.$zN))for(const{newText:m,newEol:f,range:l}of t)i.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:l&&T.Range.from(l),text:m,eol:f&&T.EndOfLine.from(f)}});if(i.edits.length!==0)return h===o.version?this.f.$tryApplyWorkspaceEdit(new N.$Qw(i)):Promise.reject(new Error("concurrent_edits"))})}}e.$Toc=p}),define(Ce[281],Ie([1,0,4,5,2,6,122,10,15,26,7]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0,N=qe(N);class v{constructor(E,d){this.a=new w.$me,this.b=new w.$me,this.c=new w.$me,this.d=new w.$me,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new C.$Vc,this.h=new Map,this.f=E.getProxy(T.$qN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const d=this.g.getDocument(E);if(d)return d}getDocument(E){const d=this.getDocumentData(E);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return d.document}ensureDocumentData(E){const d=this.g.getDocument(E);if(d)return Promise.resolve(d);let r=this.h.get(E.toString());return r||(r=this.f.$tryOpenDocument(E).then(o=>{this.h.delete(E.toString());const a=P.URI.revive(o);return(0,p.$qg)(this.g.getDocument(a))},o=>(this.h.delete(E.toString()),Promise.reject(o))),this.h.set(E.toString(),r)),r}createDocumentData(E){return this.f.$tryCreateDocument(E).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(E,d){const r=P.URI.revive(E),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(d),this.a.fire(o.document)}$acceptModelSaved(E){const d=P.URI.revive(E),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(E,d){const r=P.URI.revive(E),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,d,r){const o=P.URI.revive(E),a=this.g.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(r),a.onEvents(d);let h;d.isUndoing?h=R.TextDocumentChangeReason.Undo:d.isRedoing&&(h=R.TextDocumentChangeReason.Redo),this.c.fire((0,c.$do)({document:a.document,contentChanges:d.changes.map(n=>({range:N.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:h}))}setWordDefinitionFor(E,d){(0,A.$YP)(E,d)}}e.$Hnc=v}),define(Ce[71],Ie([1,0,282,4,15,2,3,6,17,10,7]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0,c=qe(c),e.$_nc=(0,A.$Fi)("IExtHostEditorTabs");class v{constructor(o,a,h){this.e=h,this.d=a,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(a)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case N.TabInputKind.TextInput:return new R.$dP(T.URI.revive(this.b.input.uri));case N.TabInputKind.TextDiffInput:return new R.$eP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case N.TabInputKind.TextMergeInput:return new R.$fP(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case N.TabInputKind.CustomEditorInput:return new R.$gP(T.URI.revive(this.b.input.uri),this.b.input.viewType);case N.TabInputKind.WebviewEditorInput:return new R.$hP(this.b.input.viewType);case N.TabInputKind.NotebookInput:return new R.$iP(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case N.TabInputKind.NotebookDiffInput:return new R.$jP(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case N.TabInputKind.TerminalEditorInput:return new R.$kP;case N.TabInputKind.InteractiveEditorInput:return new R.$lP(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case N.TabInputKind.ChatEditorInput:return new R.$mP;case N.TabInputKind.MultiDiffEditorInput:return new R.$nP(this.b.input.diffEditors.map(o=>new R.$eP(T.URI.revive(o.original),T.URI.revive(o.modified))));default:return}}}class u{constructor(o,a){this.c=[],this.d="",this.b=o,this.e=a;for(const h of o.tabs)h.isActive&&(this.d=h.id),this.c.push(new v(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,a={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return c.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(h=>h.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(h=>h.apiObject))}};this.a=Object.freeze(a)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===N.TabModelOperationKind.TAB_OPEN){const h=new v(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,h),o.tabDto.isActive&&(this.d=h.tabId),h}else if(o.kind===N.TabModelOperationKind.TAB_CLOSE){const h=this.c.splice(o.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(o.kind===N.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(o.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,h),h}const a=this.c.find(h=>h.tabId===o.tabDto.id);if(!a)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),a.acceptDtoUpdate(o.tabDto),a}activeTabId(){return this.d}}let E=class{constructor(o){this.b=new C.$me,this.c=new C.$me,this.e=[],this.a=o.getProxy(N.$qN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,a={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(h=>h.apiObject))},get activeTabGroup(){const h=o.d;return(0,P.$qg)(o.e.find(s=>s.groupId===h)?.apiObject)},close:async(h,n)=>{const s=Array.isArray(h)?h:[h];return s.length?d(s[0])?this.j(s,n):this.i(s,n):!0}};this.f=Object.freeze(a)}return this.f}$acceptEditorTabModel(o){const a=new Set(this.e.map(f=>f.groupId)),h=new Set(o.map(f=>f.groupId)),n=(0,w.$L)(a,h),s=this.e.filter(f=>n.removed.includes(f.groupId)).map(f=>f.apiObject),i=[],t=[];this.e=o.map(f=>{const l=new u(f,()=>this.d);return n.added.includes(l.groupId)?i.push(l.apiObject):t.push(l.apiObject),l});const m=(0,P.$qg)(o.find(f=>f.isActive===!0)?.groupId);m!==void 0&&this.d!==m&&(this.d=m),this.c.fire(Object.freeze({opened:i,closed:s,changed:t}))}$acceptTabGroupUpdate(o){const a=this.e.find(h=>h.groupId===o.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const a=this.e.find(n=>n.groupId===o.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const h=a.acceptTabOperation(o);switch(o.kind){case N.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case N.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case N.TabModelOperationKind.TAB_MOVE:case N.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(o){for(const a of this.e)for(const h of a.tabs)if(h.apiObject===o)return h}h(o){return this.e.find(a=>a.apiObject===o)}async i(o,a){const h=[];for(const n of o){const s=this.g(n);if(!s)throw new Error("Tab close: Invalid tab not found!");h.push(s.tabId)}return this.a.$closeTab(h,a)}async j(o,a){const h=[];for(const n of o){const s=this.h(n);if(!s)throw new Error("Group close: Invalid group not found!");h.push(s.groupId)}return this.a.$closeGroup(h,a)}};e.$aoc=E,e.$aoc=E=Qe([Ve(0,p.$WP)],E);function d(r){return r.tabs!==void 0}}),define(Ce[283],Ie([1,0,2,6,30,5,7,10,326,13,28,23,25,60]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0,P=qe(P),N=qe(N);class d{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const h=this.a.indexOf(a);h>=0&&(this.a.splice(h,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),h=[];let n,s,i=p.State.LastKnownState,t=p.State.LastKnownState;for(const m of a){let f=n?(0,c.$If)(n,m):0;for(f===0?s=p.State.Start:s=t;f<m.length;f++)f+1===m.length?(i=t,t=p.State.BeforeColon):t+=1,h.push([s,m.toUpperCase().charCodeAt(f),t]),h.push([s,m.toLowerCase().charCodeAt(f),t]),s=t;n=m,t=i}h.push([p.State.BeforeColon,R.CharCode.Colon,p.State.AfterColon]),h.push([p.State.AfterColon,R.CharCode.Slash,p.State.End]),this.b=new p.$83(h)}}provideDocumentLinks(a){this.c();const h=[],n=p.$93.computeLinks({getLineContent(s){return a.lineAt(s-1).text},getLineCount(){return a.lineCount}},this.b);for(const s of n){const i=N.DocumentLink.to(s);i.target&&h.push(i)}return h}}class r{constructor(a,h){this.i=h,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(C.$qN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,h,n,s={}){if(r.j(n),this.d.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(h),this.d.add(h),this.c.set(i,n);let t=P.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(t+=P.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(t+=P.FileSystemProviderCapabilities.Readonly),typeof n.copy=="function"&&(t+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof n.open=="function"&&typeof n.close=="function"&&typeof n.read=="function"&&typeof n.write=="function"&&((0,u.$5G)(a,"fsChunks"),t+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let m;s.isReadonly&&(0,E.$5k)(s.isReadonly)&&s.isReadonly.value!==""&&(m={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(i,h,t,m).catch(l=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${h}`),console.error(l)});const f=n.onDidChangeFile(l=>{const $=[];for(const I of l){const{uri:D,type:y}=I;if(D.scheme!==h)continue;let S;switch(y){case A.FileChangeType.Changed:S=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:S=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:S=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}$.push({resource:D,type:S})}this.a.$onFileSystemChange(i,$)});return(0,T.$Uc)(()=>{f.dispose(),this.b.delete(h),this.d.delete(h),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:h,ctime:n,mtime:s,size:i,permissions:t}=a;return{type:h,ctime:n,mtime:s,size:i,permissions:t}}$stat(a,h){return Promise.resolve(this.l(a).stat(w.URI.revive(h))).then(n=>r.k(n))}$readdir(a,h){return Promise.resolve(this.l(a).readDirectory(w.URI.revive(h)))}$readFile(a,h){return Promise.resolve(this.l(a).readFile(w.URI.revive(h))).then(n=>v.$Oe.wrap(n))}$writeFile(a,h,n,s){return Promise.resolve(this.l(a).writeFile(w.URI.revive(h),n.buffer,s))}$delete(a,h,n){return Promise.resolve(this.l(a).delete(w.URI.revive(h),n))}$rename(a,h,n,s){return Promise.resolve(this.l(a).rename(w.URI.revive(h),w.URI.revive(n),s))}$copy(a,h,n,s){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(w.URI.revive(h),w.URI.revive(n),s))}$mkdir(a,h){return Promise.resolve(this.l(a).createDirectory(w.URI.revive(h)))}$watch(a,h,n,s){const i=this.l(a).watch(w.URI.revive(n),s);this.f.set(h,i)}$unwatch(a,h){const n=this.f.get(h);n&&(n.dispose(),this.f.delete(h))}$open(a,h,n){const s=this.l(a);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(w.URI.revive(h),n))}$close(a,h){const n=this.l(a);if(!n.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(n.close(h))}$read(a,h,n,s){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const t=v.$Oe.alloc(s);return Promise.resolve(i.read(h,n,t.buffer,0,s)).then(m=>t.slice(0,m))}$write(a,h,n,s){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(h,n,s.buffer,0,s.byteLength))}l(a){const h=this.c.get(a);if(!h){const n=new Error;throw n.name="ENOPRO",n.message="no provider",n}return h}}e.$Woc=r}),define(Ce[284],Ie([1,0,4,41,2,6,10,7,30,47]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xoc=void 0,A=qe(A);class R{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,o,a,h,n){this.a=Math.random(),this.b=new w.$me,this.c=new w.$me,this.d=new w.$me,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const s=(0,C.$zk)(h),i=typeof h=="string",t=n?.correlate,m=a(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(t&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const l of f.created){const $=P.URI.revive(l);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.b.fire($)}if(!n?.ignoreChangeEvents)for(const l of f.changed){const $=P.URI.revive(l);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.c.fire($)}if(!n?.ignoreDeleteEvents)for(const l of f.deleted){const $=P.URI.revive(l);s($.fsPath)&&(!i||r.getWorkspaceFolder($))&&this.d.fire($)}}});this.g=N.$sN.from(this.i(d,o,h,n,n?.correlate),this.b,this.c,this.d,m)}i(d,r,o,a,h){const n=N.$sN.from();if(typeof o=="string"||a?.ignoreChangeEvents&&a?.ignoreCreateEvents&&a?.ignoreDeleteEvents)return n;const s=d.getProxy(T.$qN.MainThreadFileSystemEventService);let i=!1;(o.pattern.includes(C.$vk)||o.pattern.includes(C.$wk))&&(i=!0);let t;return h&&(a?.ignoreChangeEvents||a?.ignoreCreateEvents||a?.ignoreDeleteEvents)&&(t=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,a?.ignoreChangeEvents&&(t&=~p.FileChangeFilter.UPDATED),a?.ignoreCreateEvents&&(t&=~p.FileChangeFilter.ADDED),a?.ignoreDeleteEvents&&(t&=~p.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:i,excludes:a?.excludes??[],filter:t},!!h),N.$sN.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class v{constructor(d){this.a=d,this.session=this.a.session,this.b=new c.$X(()=>this.a.created.map(P.URI.revive)),this.c=new c.$X(()=>this.a.changed.map(P.URI.revive)),this.d=new c.$X(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(d,r,o){this.j=d,this.k=r,this.l=o,this.a=new w.$me,this.b=new w.$me,this.c=new w.$me,this.d=new w.$me,this.g=new w.$oe,this.h=new w.$oe,this.i=new w.$oe,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,o,a){return new R(this.j,d,r,this.a.event,A.GlobPattern.from(o),a)}$onFileEvent(d){this.a.fire(new v(d))}$onDidRunFileOperation(d,r){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:P.URI.revive(o.source),newUri:P.URI.revive(o.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>P.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(o,a,h)=>{const n=function(i){o.call(a,i)};return n.extension=d,r.event(n,void 0,h)}}async $onWillRunFileOperation(d,r,o,a){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(h=>({oldUri:P.URI.revive(h.source),newUri:P.URI.revive(h.target)}))},o,a);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(h=>P.URI.revive(h.target))},o,a);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(h=>P.URI.revive(h.target))},o,a)}}async n(d,r,o,a){const h=new Set,n=[];if(await d.fireAsync(r,a,async(i,t)=>{const m=Date.now(),f=await Promise.resolve(i);f instanceof N.$CN&&(n.push([t.extension,f]),h.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-m>o&&this.k.warn("SLOW file-participant",t.extension.identifier)}),a.isCancellationRequested||n.length===0)return;const s={edits:[]};for(const[,i]of n){const{edits:t}=A.WorkspaceEdit.from(i,{getTextDocumentVersion:m=>this.l.getDocument(m)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(t)}return{edit:s,extensionNames:Array.from(h)}}}e.$Xoc=u}),define(Ce[285],Ie([1,0,18,11,22,14,97,5,26,70,13,15,2,33,327,94,104,182,19,10,7,25,80,6]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=void 0,r=qe(r),n=qe(n),m=qe(m);class f{constructor(U,z){this.d=U,this.e=z}async provideDocumentSymbols(U,z){const K=this.d.getDocument(U),H=await this.e.provideDocumentSymbols(K,z);if(!(0,w.$Mb)(H))return H[0]instanceof s.$MN?H.map(n.DocumentSymbol.from):f.f(H)}static f(U){U=U.slice(0).sort((H,ne)=>{let fe=H.location.range.start.compareTo(ne.location.range.start);return fe===0&&(fe=ne.location.range.end.compareTo(H.location.range.end)),fe});const z=[],K=[];for(const H of U){const ne={name:H.name||"!!MISSING: name!!",kind:n.SymbolKind.from(H.kind),tags:H.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:n.Range.from(H.location.range),selectionRange:n.Range.from(H.location.range),children:[]};for(;;){if(K.length===0){K.push(ne),z.push(ne);break}const fe=K[K.length-1];if(E.$It.containsRange(fe.range,ne.range)&&!E.$It.equalsRange(fe.range,ne.range)){fe.children?.push(ne),K.push(ne);break}K.pop()}}return z}}class l{constructor(U,z,K,H,ne,fe){this.f=U,this.g=z,this.h=K,this.j=H,this.k=ne,this.l=fe,this.d=new t.$ync("CodeLens"),this.e=new Map}async provideCodeLenses(U,z){const K=this.f.getDocument(U),H=await this.h.provideCodeLenses(K,z);if(!H||z.isCancellationRequested)return;const ne=this.d.add(H),fe=new N.$Vc;this.e.set(ne,fe);const Ae={cacheId:ne,lenses:[]};for(let Ue=0;Ue<H.length;Ue++)Ae.lenses.push({cacheId:[ne,Ue],range:n.Range.from(H[Ue].range),command:this.g.toInternal(H[Ue].command,fe)});return Ae}async resolveCodeLens(U,z){const K=U.cacheId&&this.d.get(...U.cacheId);if(!K)return;let H;if(typeof this.h.resolveCodeLens!="function"||K.isResolved?H=K:H=await this.h.resolveCodeLens(K,z),H||(H=K),z.isCancellationRequested)return;const ne=U.cacheId&&this.e.get(U.cacheId[0]);if(ne){if(!H.command){const fe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,fe),this.l.error(fe);return}return U.command=this.g.toInternal(H.command,ne),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function $(Te){return Array.isArray(Te)?Te.map(n.DefinitionLink.from):Te?[n.DefinitionLink.from(Te)]:[]}class I{constructor(U,z){this.d=U,this.e=z}async provideDefinition(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideDefinition(H,ne,K);return $(fe)}}class D{constructor(U,z){this.d=U,this.e=z}async provideDeclaration(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideDeclaration(H,ne,K);return $(fe)}}class y{constructor(U,z){this.d=U,this.e=z}async provideImplementation(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideImplementation(H,ne,K);return $(fe)}}class S{constructor(U,z){this.d=U,this.e=z}async provideTypeDefinition(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideTypeDefinition(H,ne,K);return $(fe)}}class k{static{this.f=10}constructor(U,z){this.g=U,this.h=z,this.d=0,this.e=new Map}async provideHover(U,z,K,H){const ne=this.g.getDocument(U),fe=n.Position.to(z);let Ae;if(K&&K.verbosityRequest){const it=K.verbosityRequest.previousHover.id,nt=this.e.get(it);if(!nt)throw new Error(`Hover with id ${it} not found`);const tt={verbosityDelta:K.verbosityRequest.verbosityDelta,previousHover:nt};Ae=await this.h.provideHover(ne,fe,H,tt)}else Ae=await this.h.provideHover(ne,fe,H);if(!Ae||(0,w.$Mb)(Ae.contents))return;Ae.range||(Ae.range=ne.getWordRangeAtPosition(fe)),Ae.range||(Ae.range=new s.$uN(fe,fe));const Ue=n.Hover.from(Ae),Ke=this.d;if(this.e.size===k.f){const it=Math.min(...this.e.keys());this.e.delete(it)}return this.e.set(Ke,Ae),this.d+=1,{...Ue,id:Ke}}releaseHover(U){this.e.delete(U)}}class g{constructor(U,z){this.d=U,this.e=z}async provideEvaluatableExpression(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideEvaluatableExpression(H,ne,K);if(fe)return n.EvaluatableExpression.from(fe)}}class b{constructor(U,z){this.d=U,this.e=z}async provideInlineValues(U,z,K,H){const ne=this.d.getDocument(U),fe=await this.e.provideInlineValues(ne,n.Range.to(z),n.InlineValueContext.to(K),H);if(Array.isArray(fe))return fe.map(Ae=>n.InlineValue.from(Ae))}}class L{constructor(U,z){this.d=U,this.e=z}async provideDocumentHighlights(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideDocumentHighlights(H,ne,K);if(Array.isArray(fe))return fe.map(n.DocumentHighlight.from)}}class O{constructor(U,z){this.d=U,this.e=z}async provideMultiDocumentHighlights(U,z,K,H){const ne=this.d.getDocument(U),fe=K.map(Ke=>this.d.getDocument(Ke)),Ae=n.Position.to(z),Ue=await this.e.provideMultiDocumentHighlights(ne,Ae,fe,H);if(Array.isArray(Ue))return Ue.map(n.MultiDocumentHighlight.from)}}class q{constructor(U,z){this.d=U,this.e=z}async provideLinkedEditingRanges(U,z,K){const H=this.d.getDocument(U),ne=n.Position.to(z),fe=await this.e.provideLinkedEditingRanges(H,ne,K);if(fe&&Array.isArray(fe.ranges))return{ranges:(0,w.$Jb)(fe.ranges.map(n.Range.from)),wordPattern:fe.wordPattern}}}class G{constructor(U,z){this.d=U,this.e=z}async provideReferences(U,z,K,H){const ne=this.d.getDocument(U),fe=n.Position.to(z),Ae=await this.e.provideReferences(ne,fe,K,H);if(Array.isArray(Ae))return Ae.map(n.location.from)}}class W{static{this.d=1e3}constructor(U,z,K,H,ne,fe,Ae){this.g=U,this.h=z,this.j=K,this.k=H,this.l=ne,this.m=fe,this.n=Ae,this.e=new t.$ync("CodeAction"),this.f=new Map}async provideCodeActions(U,z,K,H){const ne=this.g.getDocument(U),fe=d.$Kt.isISelection(z)?n.Selection.to(z):n.Range.to(z),Ae=[];for(const tt of this.j.getDiagnostics(U))if(fe.intersection(tt.range)&&Ae.push(tt)>W.d)break;const Ue={diagnostics:Ae,only:K.only?new s.$ON(K.only):void 0,triggerKind:n.CodeActionTriggerKind.to(K.trigger)},Ke=await this.k.provideCodeActions(ne,fe,Ue,H);if(!(0,w.$Nb)(Ke)||H.isCancellationRequested)return;const _e=this.e.add(Ke),it=new N.$Vc;this.f.set(_e,it);const nt=[];for(let tt=0;tt<Ke.length;tt++){const rt=Ke[tt];if(rt)if(W.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,it)});else{Ue.only&&(rt.kind?Ue.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=rt.ranges??[];nt.push({cacheId:[_e,tt],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,it),diagnostics:rt.diagnostics&&rt.diagnostics.map(n.Diagnostic.from),edit:rt.edit&&n.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,i.$4G)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,i.$4G)(this.m,"codeActionRanges")?(0,w.$Jb)($t.map(n.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(U,z){const[K,H]=U,ne=this.e.get(K,H);if(!ne||W.o(ne))return{};if(!this.k.resolveCodeAction)return{};const fe=await this.k.resolveCodeAction(ne,z)??ne;let Ae;fe.edit&&(Ae=n.WorkspaceEdit.from(fe.edit,void 0));let Ue;if(fe.command){const Ke=this.f.get(K);Ke&&(Ue=this.h.toInternal(fe.command,Ke))}return{edit:Ae,command:Ue}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class F{constructor(U,z,K,H,ne){this.e=U,this.f=z,this.g=K,this.h=H,this.j=ne,this.d=new t.$ync("DocumentPasteEdit")}async prepareDocumentPaste(U,z,K,H){if(!this.g.prepareDocumentPaste)return;const ne=this.f.getDocument(U),fe=z.map(Ke=>n.Range.to(Ke)),Ae=n.DataTransfer.toDataTransfer(K,()=>{throw new T.$ab});if(await this.g.prepareDocumentPaste(ne,fe,Ae,H),H.isCancellationRequested)return;const Ue=Array.from(Ae).filter(([,Ke])=>!(Ke instanceof s.$iO));return n.DataTransfer.from(Ue)}async providePasteEdits(U,z,K,H,ne,fe){if(!this.g.provideDocumentPasteEdits)return[];const Ae=this.f.getDocument(z),Ue=K.map(nt=>n.Range.to(nt)),Ke=n.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolvePasteFileData(this.h,U,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ae,Ue,Ke,{only:ne.only?new s.$nO(ne.only):void 0,triggerKind:ne.triggerKind},fe);if(!_e||fe.isCancellationRequested)return[];const it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,a.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,z){const[K,H]=U,ne=this.d.get(K,H);if(!ne||!this.g.resolveDocumentPasteEdit)return{};const fe=await this.g.resolveDocumentPasteEdit(ne,z)??ne;return{additionalEdit:fe.additionalEdit?n.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class V{constructor(U,z){this.d=U,this.e=z}async provideDocumentFormattingEdits(U,z,K){const H=this.d.getDocument(U),ne=await this.e.provideDocumentFormattingEdits(H,z,K);if(Array.isArray(ne))return ne.map(n.TextEdit.from)}}class ce{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeFormattingEdits(U,z,K,H){const ne=this.d.getDocument(U),fe=n.Range.to(z),Ae=await this.e.provideDocumentRangeFormattingEdits(ne,fe,K,H);if(Array.isArray(Ae))return Ae.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,z,K,H){(0,v.$pg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ne=this.d.getDocument(U),fe=z.map(n.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ne,fe,K,H);if(Array.isArray(Ae))return Ae.map(n.TextEdit.from)}}class ge{constructor(U,z){this.d=U,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,z,K,H,ne){const fe=this.d.getDocument(U),Ae=n.Position.to(z),Ue=await this.e.provideOnTypeFormattingEdits(fe,Ae,K,H,ne);if(Array.isArray(Ue))return Ue.map(n.TextEdit.from)}}class te{constructor(U,z){this.e=U,this.f=z,this.d=new t.$ync("WorkspaceSymbols")}async provideWorkspaceSymbols(U,z){const K=await this.e.provideWorkspaceSymbols(U,z);if(!(0,w.$Nb)(K))return{symbols:[]};const H=this.d.add(K),ne={cacheId:H,symbols:[]};for(let fe=0;fe<K.length;fe++){const Ae=K[fe];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ne.symbols.push({...n.WorkspaceSymbol.from(Ae),cacheId:[H,fe]})}return ne}async resolveWorkspaceSymbol(U,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const K=this.d.get(...U.cacheId);if(K){const H=await this.e.resolveWorkspaceSymbol(K,z);return H&&(0,p.$fo)(U,n.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class me{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,z,K){this.d=U,this.e=z,this.f=K}async provideRenameEdits(U,z,K,H){const ne=this.d.getDocument(U),fe=n.Position.to(z);try{const Ae=await this.e.provideRenameEdits(ne,fe,K,H);return Ae?n.WorkspaceEdit.from(Ae):void 0}catch(Ae){const Ue=me.g(Ae);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(U,z,K){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(U),ne=n.Position.to(z);try{const fe=await this.e.prepareRename(H,ne,K);let Ae,Ue;if(s.$uN.isRange(fe)?(Ae=fe,Ue=H.getText(fe)):(0,v.$hg)(fe)&&(Ae=fe.range,Ue=fe.placeholder),!Ae||!Ue)return;if(Ae.start.line>ne.line||Ae.end.line<ne.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Ae),text:Ue}}catch(fe){const Ae=me.g(fe);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(fe)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class se{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic}}constructor(U,z,K){this.e=U,this.f=z,this.g=K}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,z,K,H){const ne=this.e.getDocument(U),fe=n.Range.to(z);try{const Ae=se.d[K],Ue=await this.f.provideNewSymbolNames(ne,fe,Ae,H);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Ae){this.g.error(se.h(Ae)??JSON.stringify(Ae,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class de{constructor(U,z){this.resultId=U,this.tokens=z}}class be{constructor(U,z){this.f=U,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,z,K){const H=this.f.getDocument(U),ne=z!==0?this.d.get(z):null;let fe=typeof ne?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,ne.resultId,K):await this.g.provideDocumentSemanticTokens(H,K);return ne&&this.d.delete(z),fe?(fe=be.h(fe),this.o(be.n(ne,fe),fe)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return be.j(U)?be.k(U)?U:new s.$NO(new Uint32Array(U.data),U.resultId):be.l(U)?be.m(U)?U:new s.$PO(U.edits.map(z=>new s.$OO(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const z of U.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(U,z){if(!be.j(z)||!U||!U.tokens)return z;const K=U.tokens,H=K.length,ne=z.data,fe=ne.length;let Ae=0;const Ue=Math.min(H,fe);for(;Ae<Ue&&K[Ae]===ne[Ae];)Ae++;if(Ae===H&&Ae===fe)return new s.$PO([],z.resultId);let Ke=0;const _e=Ue-Ae;for(;Ke<_e&&K[H-Ke-1]===ne[fe-Ke-1];)Ke++;return new s.$PO([{start:Ae,deleteCount:H-Ae-Ke,data:ne.subarray(Ae,fe-Ke)}],z.resultId)}o(U,z){if(be.j(U)){const K=this.e++;return this.d.set(K,new de(U.resultId,U.data)),(0,o.$0cb)({id:K,type:"full",data:U.data})}if(be.l(U)){const K=this.e++;return be.j(z)?this.d.set(K,new de(z.resultId,z.data)):this.d.set(K,new de(U.resultId)),(0,o.$0cb)({id:K,type:"delta",deltas:(U.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class re{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeSemanticTokens(U,z,K){const H=this.d.getDocument(U),ne=await this.e.provideDocumentRangeSemanticTokens(H,n.Range.to(z),K);return ne?this.f(ne):null}f(U){return(0,o.$0cb)({id:0,type:"full",data:U.data})}}class Pe{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,z,K,H,ne){this.f=U,this.g=z,this.h=K,this.j=H,this.k=ne,this.d=new t.$ync("CompletionItem"),this.e=new Map}async provideCompletionItems(U,z,K,H){const ne=this.f.getDocument(U),fe=n.Position.to(z),Ae=ne.getWordRangeAtPosition(fe)||new s.$uN(fe,fe),Ue=Ae.with({end:fe}),Ke=new c.$ge,_e=await this.h.provideCompletionItems(ne,fe,H,n.CompletionContext.to(K));if(!_e||H.isCancellationRequested)return;const it=Array.isArray(_e)?new s.$2N(_e):_e,nt=Pe.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),tt=new N.$Vc;this.e.set(nt,tt);const rt=[],$t={x:nt,[m.ISuggestResultDtoField.completions]:rt,[m.ISuggestResultDtoField.defaultRanges]:{replace:n.Range.from(Ae),insert:n.Range.from(Ue)},[m.ISuggestResultDtoField.isIncomplete]:it.isIncomplete||void 0,[m.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let lt=0;lt<it.items.length;lt++){const st=it.items[lt],ct=this.l(st,[nt,lt],Ue,Ae);rt.push(ct)}return $t}async resolveCompletionItem(U,z){if(typeof this.h.resolveCompletionItem!="function")return;const K=this.d.get(...U);if(!K)return;const H=this.l(K,U),ne=await this.h.resolveCompletionItem(K,z);if(!ne)return;const fe=this.l(ne,U);return(H[m.ISuggestDataDtoField.insertText]!==fe[m.ISuggestDataDtoField.insertText]||H[m.ISuggestDataDtoField.insertTextRules]!==fe[m.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H[m.ISuggestDataDtoField.commandIdent]!==fe[m.ISuggestDataDtoField.commandIdent]||H[m.ISuggestDataDtoField.commandId]!==fe[m.ISuggestDataDtoField.commandId]||!(0,p.$go)(H[m.ISuggestDataDtoField.commandArguments],fe[m.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,[m.ISuggestDataDtoField.documentation]:fe[m.ISuggestDataDtoField.documentation],[m.ISuggestDataDtoField.detail]:fe[m.ISuggestDataDtoField.detail],[m.ISuggestDataDtoField.additionalTextEdits]:fe[m.ISuggestDataDtoField.additionalTextEdits],[m.ISuggestDataDtoField.insertText]:fe[m.ISuggestDataDtoField.insertText],[m.ISuggestDataDtoField.insertTextRules]:fe[m.ISuggestDataDtoField.insertTextRules],[m.ISuggestDataDtoField.commandIdent]:fe[m.ISuggestDataDtoField.commandIdent],[m.ISuggestDataDtoField.commandId]:fe[m.ISuggestDataDtoField.commandId],[m.ISuggestDataDtoField.commandArguments]:fe[m.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z,K,H){const ne=this.e.get(z[0]);if(!ne)throw Error("DisposableStore is missing...");const fe=this.g.toInternal(U.command,ne),Ae={x:z,[m.ISuggestDataDtoField.label]:U.label,[m.ISuggestDataDtoField.kind]:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,[m.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(n.CompletionItemTag.from),[m.ISuggestDataDtoField.detail]:U.detail,[m.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),[m.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[m.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[m.ISuggestDataDtoField.preselect]:U.preselect||void 0,[m.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[m.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[m.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),[m.ISuggestDataDtoField.commandIdent]:fe?.$ident,[m.ISuggestDataDtoField.commandId]:fe?.id,[m.ISuggestDataDtoField.commandArguments]:fe?.$ident?void 0:fe?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae[m.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Ae[m.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof s.$DN&&(Ae[m.ISuggestDataDtoField.insertText]=U.insertText.value,Ae[m.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return U.textEdit?Ue=U.textEdit.range:U.range&&(Ue=U.range),s.$uN.isRange(Ue)?Ae[m.ISuggestDataDtoField.range]=n.Range.from(Ue):Ue&&(!K?.isEqual(Ue.inserting)||!H?.isEqual(Ue.replacing))&&(Ae[m.ISuggestDataDtoField.range]={insert:n.Range.from(Ue.inserting),replace:n.Range.from(Ue.replacing)}),Ae}}class Le{async provideInlineCompletions(U,z,K,H){}disposeCompletions(U){}handleDidShowCompletionItem(U,z,K){}handlePartialAccept(U,z,K,H){}}class Y extends Le{constructor(U,z,K,H){super(),this.f=U,this.g=z,this.h=K,this.j=H,this.d=new _,this.e=(0,i.$4G)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$4G)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,z,K,H){const ne=this.g.getDocument(U),fe=n.Position.to(z),Ae=await this.h.provideInlineCompletionItems(ne,fe,{selectedCompletionInfo:K.selectedSuggestionInfo?{range:n.Range.to(K.selectedSuggestionInfo.range),text:K.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[K.triggerKind]},H);if(!Ae||H.isCancellationRequested)return;const Ue=Array.isArray(Ae)?Ae:Ae.items,Ke=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],_e=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Ue}),items:Ue.map((tt,rt)=>{let $t;tt.command&&(it||(it=new N.$Vc),$t=this.j.toInternal(tt.command,it));const lt=tt.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:tt.filterText,range:tt.range?n.Range.from(tt.range):void 0,command:$t,idx:rt,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ke.map(tt=>(it||(it=new N.$Vc),this.j.toInternal(tt,it))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,z,K){const H=this.d.get(U)?.items[z];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,K)}handlePartialAccept(U,z,K,H){const ne=this.d.get(U)?.items[z];ne&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ne,K),this.h.handleDidPartiallyAcceptCompletionItem(ne,n.PartialAcceptInfo.to(H)))}}class B{async provideInlineEdits(U,z,K){const H=this.f.getDocument(U),ne=await this.g.provideInlineEdit(H,{triggerKind:this.e[z.triggerKind]},K);if(!ne||K.isCancellationRequested)return;let fe;const Ae=this.d.createReferenceId({dispose(){fe?.dispose()},item:ne});let Ue;ne.accepted&&(fe||(fe=new N.$Vc),Ue=this.h.toInternal(ne.accepted,fe));let Ke;return ne.rejected&&(fe||(fe=new N.$Vc),Ke=this.h.toInternal(ne.rejected,fe)),{pid:Ae,text:ne.text,range:n.Range.from(ne.range),accepted:Ue,rejected:Ke}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,z,K,H){this.f=z,this.g=K,this.h=H,this.d=new _,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const z=this.e++;return this.d.set(z,U),z}disposeReferenceId(U){const z=this.d.get(U);return this.d.delete(U),z}get(U){return this.d.get(U)}}class ve{constructor(U,z){this.e=U,this.f=z,this.d=new t.$ync("SignatureHelp")}async provideSignatureHelp(U,z,K,H){const ne=this.e.getDocument(U),fe=n.Position.to(z),Ae=this.g(K),Ue=await this.f.provideSignatureHelp(ne,fe,H,Ae);if(Ue){const Ke=this.d.add([Ue]);return{...n.SignatureHelp.from(Ue),id:Ke}}}g(U){let z;if(U.activeSignatureHelp){const K=n.SignatureHelp.to(U.activeSignatureHelp),H=this.d.get(U.activeSignatureHelp.id,0);H?(z=H,z.activeSignature=K.activeSignature,z.activeParameter=K.activeParameter):z=K}return{...U,activeSignatureHelp:z}}releaseSignatureHelp(U){this.d.delete(U)}}class ae{constructor(U,z,K,H,ne){this.f=U,this.g=z,this.h=K,this.j=H,this.k=ne,this.d=new t.$ync("InlayHints"),this.e=new Map}async provideInlayHints(U,z,K){const H=this.f.getDocument(U),ne=n.Range.to(z),fe=await this.h.provideInlayHints(H,ne,K);if(!Array.isArray(fe)||fe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(K.isCancellationRequested)return;const Ae=this.d.add(fe);this.e.set(Ae,new N.$Vc);const Ue={hints:[],cacheId:Ae};for(let Ke=0;Ke<fe.length;Ke++)this.l(fe[Ke],ne)&&Ue.hints.push(this.m(fe[Ke],[Ae,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Ue}async resolveInlayHint(U,z){if(typeof this.h.resolveInlayHint!="function")return;const K=this.d.get(...U);if(!K)return;const H=await this.h.resolveInlayHint(K,z);if(H&&this.l(H))return this.m(H,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(K=>K.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(z&&!z.contains(U.position))}m(U,z){const K=this.e.get(z[0]);if(!K)throw Error("DisposableStore is missing...");const H={label:"",cacheId:z,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")H.label=U.label;else{const ne=[];H.label=ne;for(const fe of U.label){if(!fe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:fe.value,tooltip:n.MarkdownString.fromStrict(fe.tooltip)};s.$EN.isLocation(fe.location)&&(Ae.location=n.location.from(fe.location)),fe.command&&(Ae.command=this.g.toInternal(fe.command,K)),ne.push(Ae)}}return H}}class we{constructor(U,z){this.e=U,this.f=z,this.d=new t.$ync("DocumentLink")}async provideLinks(U,z){const K=this.e.getDocument(U),H=await this.f.provideDocumentLinks(K,z);if(!(!Array.isArray(H)||H.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(we.g).map(n.DocumentLink.from)};{const ne=this.d.add(H),fe={links:[],cacheId:ne};for(let Ae=0;Ae<H.length;Ae++){if(!we.g(H[Ae]))continue;const Ue=n.DocumentLink.from(H[Ae]);Ue.cacheId=[ne,Ae],fe.links.push(Ue)}return fe}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,z){if(typeof this.f.resolveDocumentLink!="function")return;const K=this.d.get(...U);if(!K)return;const H=await this.f.resolveDocumentLink(K,z);if(!(!H||!we.g(H)))return n.DocumentLink.from(H)}releaseLinks(U){this.d.delete(U)}}class le{constructor(U,z){this.d=U,this.e=z}async provideColors(U,z){const K=this.d.getDocument(U),H=await this.e.provideDocumentColors(K,z);return Array.isArray(H)?H.map(fe=>({color:n.Color.from(fe.color),range:n.Range.from(fe.range)})):[]}async provideColorPresentations(U,z,K){const H=this.d.getDocument(U),ne=n.Range.to(z.range),fe=n.Color.to(z.color),Ae=await this.e.provideColorPresentations(fe,{document:H,range:ne},K);if(Array.isArray(Ae))return Ae.map(n.ColorPresentation.from)}}class X{constructor(U,z){this.d=U,this.e=z}async provideFoldingRanges(U,z,K){const H=this.d.getDocument(U),ne=await this.e.provideFoldingRanges(H,z,K);if(Array.isArray(ne))return ne.map(n.FoldingRange.from)}}class Z{constructor(U,z,K){this.d=U,this.e=z,this.f=K}async provideSelectionRanges(U,z,K){const H=this.d.getDocument(U),ne=z.map(n.Position.to),fe=await this.e.provideSelectionRanges(H,ne,K);if(!(0,w.$Nb)(fe))return[];if(fe.length!==ne.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let Ue=0;Ue<ne.length;Ue++){const Ke=[];Ae.push(Ke);let _e=ne[Ue],it=fe[Ue];for(;;){if(!it.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(n.SelectionRange.from(it)),!it.parent)break;_e=it.range,it=it.parent}}return Ae}}class pe{constructor(U,z){this.f=U,this.g=z,this.d=new A.$2P(""),this.e=new Map}async prepareSession(U,z,K){const H=this.f.getDocument(U),ne=n.Position.to(z),fe=await this.g.prepareCallHierarchy(H,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Ae,Ue)):[this.h(Ae,fe)]}async provideCallsTo(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyIncomingCalls(H,K);if(ne)return ne.map(fe=>({from:this.h(U,fe.from),fromRanges:fe.fromRanges.map(Ae=>n.Range.from(Ae))}))}async provideCallsFrom(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing call hierarchy item");const ne=await this.g.provideCallHierarchyOutgoingCalls(H,K);if(ne)return ne.map(fe=>({to:this.h(U,fe.to),fromRanges:fe.fromRanges.map(Ae=>n.Range.from(Ae))}))}releaseSession(U){this.e.delete(U)}h(U,z){const K=this.e.get(U),H=n.CallHierarchyItem.from(z,U,K.size.toString(36));return K.set(H._itemId,z),H}j(U,z){return this.e.get(U)?.get(z)}}class $e{constructor(U,z){this.f=U,this.g=z,this.d=new A.$2P(""),this.e=new Map}async prepareSession(U,z,K){const H=this.f.getDocument(U),ne=n.Position.to(z),fe=await this.g.prepareTypeHierarchy(H,ne,K);if(!fe)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(fe)?fe.map(Ue=>this.h(Ae,Ue)):[this.h(Ae,fe)]}async provideSupertypes(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySupertypes(H,K);if(ne)return ne.map(fe=>this.h(U,fe))}async provideSubtypes(U,z,K){const H=this.j(U,z);if(!H)throw new Error("missing type hierarchy item");const ne=await this.g.provideTypeHierarchySubtypes(H,K);if(ne)return ne.map(fe=>this.h(U,fe))}releaseSession(U){this.e.delete(U)}h(U,z){const K=this.e.get(U),H=n.TypeHierarchyItem.from(z,U,K.size.toString(36));return K.set(H._itemId,z),H}j(U,z){return this.e.get(U)?.get(z)}}class Ne{constructor(U,z,K,H,ne){this.e=U,this.f=z,this.g=K,this.h=H,this.j=ne,this.d=new t.$ync("DocumentDropEdit")}async provideDocumentOnDropEdits(U,z,K,H,ne){const fe=this.f.getDocument(z),Ae=n.Position.to(K),Ue=n.DataTransfer.toDataTransfer(H,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,nt)).buffer),Ke=await this.g.provideDocumentDropEdits(fe,Ae,Ue,ne);if(!Ke)return;const _e=(0,w.$4b)(Ke),it=this.d.add(_e);return _e.map((nt,tt)=>({_cacheId:[it,tt],title:nt.title??(0,a.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?n.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,z){const[K,H]=U,ne=this.d.get(K,H);if(!ne||!this.g.resolveDocumentDropEdit)return{};const fe=await this.g.resolveDocumentDropEdit(ne,z)??ne;return{additionalEdit:fe.additionalEdit?n.WorkspaceEdit.from(fe.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class ze{constructor(U,z){this.d=U,this.e=z}async provideMappedEdits(U,z,K,H){const ne=u.URI.revive(U),fe=this.d.getDocument(ne),Ae=K.documents.map(_e=>_e.map(it=>({uri:u.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(nt=>n.Range.to(nt))}))),Ue={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(fe,z,Ue,H);return Ke?n.WorkspaceEdit.from(Ke):null}}class ke{constructor(U,z){this.adapter=U,this.extension=z}}class Re{static{this.d=0}constructor(U,z,K,H,ne,fe,Ae,Ue){this.g=z,this.h=K,this.j=H,this.k=ne,this.l=fe,this.m=Ae,this.n=Ue,this.f=new Map,this.e=U.getProxy(m.$qN.MainThreadLanguageFeatures)}o(U,z){return n.DocumentSelector.from(U,this.g,z)}p(U){return new s.$sN(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Re.d++}async s(U,z,K,H,ne,fe=!1){const Ae=this.f.get(U);if(!Ae||!(Ae.adapter instanceof z))return H;const Ue=Date.now();fe||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${K.toString().replace(/[\r\n]/g,"")}'`);const Ke=K(Ae.adapter,Ae.extension);return Promise.resolve(Ke).catch(_e=>{(0,T.$6)(_e)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ae.extension.identifier,_e))}).finally(()=>{fe||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),P.CancellationToken.isCancellationToken(ne)?(0,C.$uh)(Ke,ne):Ke}t(U,z){const K=this.q();return this.f.set(K,new ke(U,z)),K}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,z,K,H){const ne=this.t(new f(this.h,K),U),fe=H&&H.label||Re.u(U);return this.e.$registerDocumentSymbolProvider(ne,this.o(z,U),fe),this.p(ne)}$provideDocumentSymbols(U,z,K){return this.s(U,f,H=>H.provideDocumentSymbols(u.URI.revive(z),K),void 0,K)}registerCodeLensProvider(U,z,K){const H=this.q(),ne=typeof K.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new ke(new l(this.h,this.j.converter,K,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(H,this.o(z,U),ne);let fe=this.p(H);if(ne!==void 0){const Ae=K.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(ne));fe=s.$sN.from(fe,Ae)}return fe}$provideCodeLenses(U,z,K){return this.s(U,l,H=>H.provideCodeLenses(u.URI.revive(z),K),void 0,K)}$resolveCodeLens(U,z,K){return this.s(U,l,H=>H.resolveCodeLens(z,K),void 0,void 0)}$releaseCodeLenses(U,z){this.s(U,l,K=>Promise.resolve(K.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(U,z,K){const H=this.t(new I(this.h,K),U);return this.e.$registerDefinitionSupport(H,this.o(z,U)),this.p(H)}$provideDefinition(U,z,K,H){return this.s(U,I,ne=>ne.provideDefinition(u.URI.revive(z),K,H),[],H)}registerDeclarationProvider(U,z,K){const H=this.t(new D(this.h,K),U);return this.e.$registerDeclarationSupport(H,this.o(z,U)),this.p(H)}$provideDeclaration(U,z,K,H){return this.s(U,D,ne=>ne.provideDeclaration(u.URI.revive(z),K,H),[],H)}registerImplementationProvider(U,z,K){const H=this.t(new y(this.h,K),U);return this.e.$registerImplementationSupport(H,this.o(z,U)),this.p(H)}$provideImplementation(U,z,K,H){return this.s(U,y,ne=>ne.provideImplementation(u.URI.revive(z),K,H),[],H)}registerTypeDefinitionProvider(U,z,K){const H=this.t(new S(this.h,K),U);return this.e.$registerTypeDefinitionSupport(H,this.o(z,U)),this.p(H)}$provideTypeDefinition(U,z,K,H){return this.s(U,S,ne=>ne.provideTypeDefinition(u.URI.revive(z),K,H),[],H)}registerHoverProvider(U,z,K,H){const ne=this.t(new k(this.h,K),U);return this.e.$registerHoverProvider(ne,this.o(z,U)),this.p(ne)}$provideHover(U,z,K,H,ne){return this.s(U,k,fe=>fe.provideHover(u.URI.revive(z),K,H,ne),void 0,ne)}$releaseHover(U,z){this.s(U,k,K=>Promise.resolve(K.releaseHover(z)),void 0,void 0)}registerEvaluatableExpressionProvider(U,z,K,H){const ne=this.t(new g(this.h,K),U);return this.e.$registerEvaluatableExpressionProvider(ne,this.o(z,U)),this.p(ne)}$provideEvaluatableExpression(U,z,K,H){return this.s(U,g,ne=>ne.provideEvaluatableExpression(u.URI.revive(z),K,H),void 0,H)}registerInlineValuesProvider(U,z,K,H){const ne=typeof K.onDidChangeInlineValues=="function"?this.q():void 0,fe=this.t(new b(this.h,K),U);this.e.$registerInlineValuesProvider(fe,this.o(z,U),ne);let Ae=this.p(fe);if(ne!==void 0){const Ue=K.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(ne));Ae=s.$sN.from(Ae,Ue)}return Ae}$provideInlineValues(U,z,K,H,ne){return this.s(U,b,fe=>fe.provideInlineValues(u.URI.revive(z),K,H,ne),void 0,ne)}registerDocumentHighlightProvider(U,z,K){const H=this.t(new L(this.h,K),U);return this.e.$registerDocumentHighlightProvider(H,this.o(z,U)),this.p(H)}registerMultiDocumentHighlightProvider(U,z,K){const H=this.t(new O(this.h,K),U);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(z,U)),this.p(H)}$provideDocumentHighlights(U,z,K,H){return this.s(U,L,ne=>ne.provideDocumentHighlights(u.URI.revive(z),K,H),void 0,H)}$provideMultiDocumentHighlights(U,z,K,H,ne){return this.s(U,O,fe=>fe.provideMultiDocumentHighlights(u.URI.revive(z),K,H.map(Ae=>u.URI.revive(Ae)),ne),void 0,ne)}registerLinkedEditingRangeProvider(U,z,K){const H=this.t(new q(this.h,K),U);return this.e.$registerLinkedEditingRangeProvider(H,this.o(z,U)),this.p(H)}$provideLinkedEditingRanges(U,z,K,H){return this.s(U,q,async ne=>{const fe=await ne.provideLinkedEditingRanges(u.URI.revive(z),K,H);if(fe)return{ranges:fe.ranges,wordPattern:fe.wordPattern?Re.y(fe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(U,z,K){const H=this.t(new G(this.h,K),U);return this.e.$registerReferenceSupport(H,this.o(z,U)),this.p(H)}$provideReferences(U,z,K,H,ne){return this.s(U,G,fe=>fe.provideReferences(u.URI.revive(z),K,H,ne),void 0,ne)}registerCodeActionProvider(U,z,K,H){const ne=new N.$Vc,fe=this.t(new W(this.h,this.j.converter,this.k,K,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(fe,this.o(z,U),{providedKinds:H?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:H?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ne)}))},Re.u(U),Re.w(U),!!K.resolveCodeAction),ne.add(this.p(fe)),ne}$provideCodeActions(U,z,K,H,ne){return this.s(U,W,fe=>fe.provideCodeActions(u.URI.revive(z),K,H,ne),void 0,ne)}$resolveCodeAction(U,z,K){return this.s(U,W,H=>H.resolveCodeAction(z,K),{},void 0)}$releaseCodeActions(U,z){this.s(U,W,K=>Promise.resolve(K.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,z,K){const H=this.t(new V(this.h,K),U);return this.e.$registerDocumentFormattingSupport(H,this.o(z,U),U.identifier,U.displayName||U.name),this.p(H)}$provideDocumentFormattingEdits(U,z,K,H){return this.s(U,V,ne=>ne.provideDocumentFormattingEdits(u.URI.revive(z),K,H),void 0,H)}registerDocumentRangeFormattingEditProvider(U,z,K){const H=typeof K.provideDocumentRangesFormattingEdits=="function",ne=this.t(new ce(this.h,K),U);return this.e.$registerRangeFormattingSupport(ne,this.o(z,U),U.identifier,U.displayName||U.name,H),this.p(ne)}$provideDocumentRangeFormattingEdits(U,z,K,H,ne){return this.s(U,ce,fe=>fe.provideDocumentRangeFormattingEdits(u.URI.revive(z),K,H,ne),void 0,ne)}$provideDocumentRangesFormattingEdits(U,z,K,H,ne){return this.s(U,ce,fe=>fe.provideDocumentRangesFormattingEdits(u.URI.revive(z),K,H,ne),void 0,ne)}registerOnTypeFormattingEditProvider(U,z,K,H){const ne=this.t(new ge(this.h,K),U);return this.e.$registerOnTypeFormattingSupport(ne,this.o(z,U),H,U.identifier),this.p(ne)}$provideOnTypeFormattingEdits(U,z,K,H,ne,fe){return this.s(U,ge,Ae=>Ae.provideOnTypeFormattingEdits(u.URI.revive(z),K,H,ne,fe),void 0,fe)}registerWorkspaceSymbolProvider(U,z){const K=this.t(new te(z,this.l),U);return this.e.$registerNavigateTypeSupport(K,typeof z.resolveWorkspaceSymbol=="function"),this.p(K)}$provideWorkspaceSymbols(U,z,K){return this.s(U,te,H=>H.provideWorkspaceSymbols(z,K),{symbols:[]},K)}$resolveWorkspaceSymbol(U,z,K){return this.s(U,te,H=>H.resolveWorkspaceSymbol(z,K),void 0,void 0)}$releaseWorkspaceSymbols(U,z){this.s(U,te,K=>K.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(U,z,K){const H=this.t(new me(this.h,K,this.l),U);return this.e.$registerRenameSupport(H,this.o(z,U),me.supportsResolving(K)),this.p(H)}$provideRenameEdits(U,z,K,H,ne){return this.s(U,me,fe=>fe.provideRenameEdits(u.URI.revive(z),K,H,ne),void 0,ne)}$resolveRenameLocation(U,z,K,H){return this.s(U,me,ne=>ne.resolveRenameLocation(u.URI.revive(z),K,H),void 0,H)}registerNewSymbolNamesProvider(U,z,K){const H=this.t(new se(this.h,K,this.l),U);return this.e.$registerNewSymbolNamesProvider(H,this.o(z,U)),this.p(H)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,se,z=>z.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,z,K,H,ne){return this.s(U,se,fe=>fe.provideNewSymbolNames(u.URI.revive(z),K,H,ne),void 0,ne)}registerDocumentSemanticTokensProvider(U,z,K,H){const ne=this.t(new be(this.h,K),U),fe=typeof K.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ne,this.o(z,U),H,fe);let Ae=this.p(ne);if(fe){const Ue=K.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(fe));Ae=s.$sN.from(Ae,Ue)}return Ae}$provideDocumentSemanticTokens(U,z,K,H){return this.s(U,be,ne=>ne.provideDocumentSemanticTokens(u.URI.revive(z),K,H),null,H)}$releaseDocumentSemanticTokens(U,z){this.s(U,be,K=>K.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,z,K,H){const ne=this.t(new re(this.h,K),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ne,this.o(z,U),H),this.p(ne)}$provideDocumentRangeSemanticTokens(U,z,K,H){return this.s(U,re,ne=>ne.provideDocumentRangeSemanticTokens(u.URI.revive(z),K,H),null,H)}registerCompletionItemProvider(U,z,K,H){const ne=this.t(new Pe(this.h,this.j.converter,K,this.m,U),U);return this.e.$registerCompletionsProvider(ne,this.o(z,U),H,Pe.supportsResolving(K),U.identifier),this.p(ne)}$provideCompletionItems(U,z,K,H,ne){return this.s(U,Pe,fe=>fe.provideCompletionItems(u.URI.revive(z),K,H,ne),void 0,ne)}$resolveCompletionItem(U,z,K){return this.s(U,Pe,H=>H.resolveCompletionItem(z,K),void 0,K)}$releaseCompletionItems(U,z){this.s(U,Pe,K=>K.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(U,z,K,H){const ne=new Y(U,this.h,K,this.j.converter),fe=this.t(ne,U);return this.e.$registerInlineCompletionsSupport(fe,this.o(z,U),ne.supportsHandleEvents,h.$qn.toKey(U.identifier.value),H?.yieldTo?.map(Ae=>h.$qn.toKey(Ae))||[]),this.p(fe)}$provideInlineCompletions(U,z,K,H,ne){return this.s(U,Le,fe=>fe.provideInlineCompletions(u.URI.revive(z),K,H,ne),void 0,ne)}$handleInlineCompletionDidShow(U,z,K,H){this.s(U,Le,async ne=>{ne.handleDidShowCompletionItem(z,K,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,z,K,H,ne){this.s(U,Le,async fe=>{fe.handlePartialAccept(z,K,H,ne)},void 0,void 0)}$freeInlineCompletionsList(U,z){this.s(U,Le,async K=>{K.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(U,z,K){const H=new B(U,this.h,K,this.j.converter),ne=this.t(H,U);return this.e.$registerInlineEditProvider(ne,this.o(z,U),U.identifier),this.p(ne)}$provideInlineEdit(U,z,K,H){return this.s(U,B,ne=>ne.provideInlineEdits(u.URI.revive(z),K,H),void 0,H)}$freeInlineEdit(U,z){this.s(U,B,async K=>{K.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(U,z,K,H){const ne=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,fe=this.t(new ve(this.h,K),U);return this.e.$registerSignatureHelpProvider(fe,this.o(z,U),ne),this.p(fe)}$provideSignatureHelp(U,z,K,H,ne){return this.s(U,ve,fe=>fe.provideSignatureHelp(u.URI.revive(z),K,H,ne),void 0,ne)}$releaseSignatureHelp(U,z){this.s(U,ve,K=>K.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(U,z,K){const H=typeof K.onDidChangeInlayHints=="function"?this.q():void 0,ne=this.t(new ae(this.h,this.j.converter,K,this.l,U),U);this.e.$registerInlayHintsProvider(ne,this.o(z,U),typeof K.resolveInlayHint=="function",H,Re.u(U));let fe=this.p(ne);if(H!==void 0){const Ae=K.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(H));fe=s.$sN.from(fe,Ae)}return fe}$provideInlayHints(U,z,K,H){return this.s(U,ae,ne=>ne.provideInlayHints(u.URI.revive(z),K,H),void 0,H)}$resolveInlayHint(U,z,K){return this.s(U,ae,H=>H.resolveInlayHint(z,K),void 0,K)}$releaseInlayHints(U,z){this.s(U,ae,K=>K.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(U,z,K){const H=this.t(new we(this.h,K),U);return this.e.$registerDocumentLinkProvider(H,this.o(z,U),typeof K.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(U,z,K){return this.s(U,we,H=>H.provideLinks(u.URI.revive(z),K),void 0,K,z.scheme==="output")}$resolveDocumentLink(U,z,K){return this.s(U,we,H=>H.resolveLink(z,K),void 0,void 0,!0)}$releaseDocumentLinks(U,z){this.s(U,we,K=>K.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(U,z,K){const H=this.t(new le(this.h,K),U);return this.e.$registerDocumentColorProvider(H,this.o(z,U)),this.p(H)}$provideDocumentColors(U,z,K){return this.s(U,le,H=>H.provideColors(u.URI.revive(z),K),[],K)}$provideColorPresentations(U,z,K,H){return this.s(U,le,ne=>ne.provideColorPresentations(u.URI.revive(z),K,H),void 0,H)}registerFoldingRangeProvider(U,z,K){const H=this.q(),ne=typeof K.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new ke(new X(this.h,K),U)),this.e.$registerFoldingRangeProvider(H,this.o(z,U),U.identifier,ne);let fe=this.p(H);if(ne!==void 0){const Ae=K.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ne));fe=s.$sN.from(fe,Ae)}return fe}$provideFoldingRanges(U,z,K,H){return this.s(U,X,ne=>ne.provideFoldingRanges(u.URI.revive(z),K,H),void 0,H)}registerSelectionRangeProvider(U,z,K){const H=this.t(new Z(this.h,K,this.l),U);return this.e.$registerSelectionRangeProvider(H,this.o(z,U)),this.p(H)}$provideSelectionRanges(U,z,K,H){return this.s(U,Z,ne=>ne.provideSelectionRanges(u.URI.revive(z),K,H),[],H)}registerCallHierarchyProvider(U,z,K){const H=this.t(new pe(this.h,K),U);return this.e.$registerCallHierarchyProvider(H,this.o(z,U)),this.p(H)}$prepareCallHierarchy(U,z,K,H){return this.s(U,pe,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(z),K,H)),void 0,H)}$provideCallHierarchyIncomingCalls(U,z,K,H){return this.s(U,pe,ne=>ne.provideCallsTo(z,K,H),void 0,H)}$provideCallHierarchyOutgoingCalls(U,z,K,H){return this.s(U,pe,ne=>ne.provideCallsFrom(z,K,H),void 0,H)}$releaseCallHierarchy(U,z){this.s(U,pe,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(U,z,K){const H=this.t(new $e(this.h,K),U);return this.e.$registerTypeHierarchyProvider(H,this.o(z,U)),this.p(H)}$prepareTypeHierarchy(U,z,K,H){return this.s(U,$e,ne=>Promise.resolve(ne.prepareSession(u.URI.revive(z),K,H)),void 0,H)}$provideTypeHierarchySupertypes(U,z,K,H){return this.s(U,$e,ne=>ne.provideSupertypes(z,K,H),void 0,H)}$provideTypeHierarchySubtypes(U,z,K,H){return this.s(U,$e,ne=>ne.provideSubtypes(z,K,H),void 0,H)}$releaseTypeHierarchy(U,z){this.s(U,$e,K=>Promise.resolve(K.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,z,K,H){const ne=this.q();return this.f.set(ne,new ke(new Ne(this.e,this.h,K,ne,U),U)),this.e.$registerDocumentOnDropEditProvider(ne,this.o(z,U),(0,i.$4G)(U,"documentPaste")&&H?{supportsResolve:!!K.resolveDocumentDropEdit,dropMimeTypes:H.dropMimeTypes}:void 0),this.p(ne)}$provideDocumentOnDropEdits(U,z,K,H,ne,fe){return this.s(U,Ne,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(z,u.URI.revive(K),H,ne,fe)),void 0,void 0)}$resolveDropEdit(U,z,K){return this.s(U,Ne,H=>H.resolveDropEdit(z,K),{},void 0)}$releaseDocumentOnDropEdits(U,z){this.s(U,Ne,K=>Promise.resolve(K.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(U,z,K){const H=this.t(new ze(this.h,K),U);return this.e.$registerMappedEditsProvider(H,this.o(z,U)),this.p(H)}$provideMappedEdits(U,z,K,H,ne){return this.s(U,ze,fe=>Promise.resolve(fe.provideMappedEdits(z,K,H,ne)),null,ne)}registerDocumentPasteEditProvider(U,z,K,H){const ne=this.q();return this.f.set(ne,new ke(new F(this.e,this.h,K,ne,U),U)),this.e.$registerPasteEditProvider(ne,this.o(z,U),{supportsCopy:!!K.prepareDocumentPaste,supportsPaste:!!K.provideDocumentPasteEdits,supportsResolve:!!K.resolveDocumentPasteEdit,providedPasteEditKinds:H.providedPasteEditKinds?.map(fe=>fe.value),copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(ne)}$prepareDocumentPaste(U,z,K,H,ne){return this.s(U,F,fe=>fe.prepareDocumentPaste(u.URI.revive(z),K,H,ne),void 0,ne)}$providePasteEdits(U,z,K,H,ne,fe,Ae){return this.s(U,F,Ue=>Ue.providePasteEdits(z,u.URI.revive(K),H,ne,fe,Ae),void 0,Ae)}$resolvePasteEdit(U,z,K){return this.s(U,F,H=>H.resolvePasteEdit(z,K),{},void 0)}$releasePasteEdits(U,z){this.s(U,F,K=>Promise.resolve(K.releasePasteEdits(z)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Re.y(U.decreaseIndentPattern),increaseIndentPattern:Re.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Re.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Re.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Re.y(U.beforeText),afterText:U.afterText?Re.y(U.afterText):void 0,previousLineText:U.previousLineText?Re.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Re.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(z=>s.SyntaxTokenType.toString(z)):void 0}}static E(U){return U.map(Re.D)}setLanguageConfiguration(U,z,K){const{wordPattern:H}=K;if(H&&(0,R.$sf)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(z,H):this.h.setWordDefinitionFor(z,void 0),K.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),K.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ne=this.q(),fe={comments:K.comments,brackets:K.brackets,wordPattern:K.wordPattern?Re.y(K.wordPattern):void 0,indentationRules:K.indentationRules?Re.z(K.indentationRules):void 0,onEnterRules:K.onEnterRules?Re.C(K.onEnterRules):void 0,__electricCharacterSupport:K.__electricCharacterSupport,__characterPairSupport:K.__characterPairSupport,autoClosingPairs:K.autoClosingPairs?Re.E(K.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ne,z,fe),this.p(ne)}$setWordDefinitions(U){for(const z of U)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$Inc=Re}),define(Ce[95],Ie([1,0,11,22,14,4,40,5,183,19,3,12,77,6,91,17,10,7,116,25]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=e.$poc=void 0,o=qe(o),a=qe(a),e.$poc=(0,R.$Fi)("IExtHostLanguageModels");class i{constructor(l,$){this.option=l,this.stream=new w.$9h,this.stream=$??new w.$9h}}class t{constructor(){this.a=new Map,this.b=new w.$9h,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable,text:w.$6h.map(l.b.asyncIterable,$=>{if($ instanceof a.$GP)return $.value}).coalesce()}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let $=this.a.get(l.index);$||(this.a.size===0?$=new i(l.index,this.b):$=new i(l.index),this.a.set(l.index,$));let I;l.part.type==="text"?I=new a.$GP(l.part.value):I=new a.$FP(l.part.name,l.part.parameters),$.stream.emitOne(I)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const $ of this.f())$.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let m=class{static{s=this}static{this.a=1}constructor(l,$,I){this.j=$,this.k=I,this.c=new T.$me,this.d=new T.$me,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new c.$sn,this.i=new Map,this.r=new Set,this.b=l.getProxy(E.$qN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,$,I,D){const y=s.a++;this.f.set(y,{extension:l.identifier,provider:I,languageModelId:$});let S;D.auth&&(S={providerLabel:l.displayName||l.name,accountLabel:typeof D.auth=="object"?D.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${c.$qn.toKey(l.identifier)}/${y}/${$}`,{extension:l.identifier,id:$,vendor:D.vendor??c.$qn.toKey(l.identifier),name:D.name??"",family:D.family??"",version:D.version,maxInputTokens:D.maxInputTokens,maxOutputTokens:D.maxOutputTokens,auth:S,targetExtensions:D.extensions});const k=I.onDidReceiveLanguageModelResponse2?.(({extensionId:g,participant:b,tokenCount:L})=>{this.b.$whenLanguageModelChatRequestMade($,new c.$qn(g),b,L)});return(0,N.$Uc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),k?.dispose()})}async $provideLanguageModelResponse(l,$,I,D,y,S){const k=this.f.get(l);if(!k)return;const g=new u.$sw(async b=>{if(S.isCancellationRequested){this.j.warn(`[CHAT](${k.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(b.part instanceof a.$FP?L={type:"function_use",name:b.part.name,parameters:b.part.parameters}:b.part instanceof a.$GP&&(L={type:"text",value:b.part.value}),!L){this.j.warn(`[CHAT](${k.extension.value}) UNKNOWN part ${JSON.stringify(b)}`);return}this.b.$handleProgressChunk($,{index:b.index,part:L})});if(k.provider.provideLanguageModelResponse2)return k.provider.provideLanguageModelResponse2(D.map(o.LanguageModelChatMessage.to),y,c.$qn.toKey(I),g,S);{const b=new u.$sw(async L=>{g.report({index:L.index,part:new a.$GP(L.part)})});return k.provider.provideLanguageModelResponse(D.map(o.LanguageModelChatMessage.to),y?.modelOptions??{},c.$qn.toKey(I),b,S)}}$provideTokenLength(l,$,I){const D=this.f.get(l);return D?Promise.resolve(D.provider.provideTokenCount($,I)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:$,metadata:I}of l.added)this.g.set($,{metadata:I,apiObjects:new c.$sn});if(l.removed)for(const $ of l.removed){this.g.delete($);for(const[I,D]of this.i)D.languageModelId===$&&(D.res.reject(new P.$7),this.i.delete(I))}l.added?.forEach($=>this.p($.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,$){const I=await this.b.$selectChatModels({...$,extension:l.identifier}),D=[],y=this;for(const S of I){const k=this.g.get(S);if(!k)continue;this.o(l.identifier,k.metadata)&&await this.p(k.metadata);let g=k.apiObjects.get(l.identifier);g||(g={id:S,vendor:k.metadata.vendor,family:k.metadata.family,version:k.metadata.version,name:k.metadata.name,maxInputTokens:k.metadata.maxInputTokens,countTokens(b,L){if(!y.g.has(S))throw a.$KP.NotFound(S);return y.q(S,b,L??C.CancellationToken.None)},sendRequest(b,L,O){if(!y.g.has(S))throw a.$KP.NotFound(S);return y.l(l,S,b,L??{},O??C.CancellationToken.None)}},Object.freeze(g),k.apiObjects.set(l.identifier,g)),D.push(g)}return D}async l(l,$,I,D,y){const S=this.m(l,I),k=l.identifier,g=this.g.get($)?.metadata;if(!g||!this.g.has($))throw a.$KP.NotFound(`Language model '${$}' is unknown.`);if(this.o(k,g)&&(!await this.n(l,{identifier:g.extension,displayName:g.auth.providerLabel},D.justification,!1)||!this.h.get(k)?.has(g.extension)))throw a.$KP.NoPermissions(`Language model '${$}' cannot be used by '${k.value}'.`);const b=Math.random()*1e6|0,L=this.b.$fetchResponse(k,$,b,S,D,y),O=new w.$Eh,q=new t;this.i.set(b,{languageModelId:$,res:q});let G;if(L.catch(W=>{O.isOpen()?q.reject(W):G=W}).finally(()=>{this.i.delete(b),q.resolve(),O.open()}),await O.wait(),G)throw G.name===a.$KP.name?G:new a.$KP(`Language model '${$}' errored, check cause for more details`,"Unknown",G);return q.apiObject}m(l,$){const I=[];for(const D of $)D.role===a.LanguageModelChatMessageRole.System&&(0,n.$5G)(l,"languageModelSystem"),D.content2 instanceof a.$DP&&(0,n.$5G)(l,"lmTools"),I.push(o.LanguageModelChatMessage.from(D));return I}async $handleResponseFragment(l,$){const I=this.i.get(l);I&&I.res.handleFragment($)}async n(l,$,I,D){const y=h.$sM+$.identifier.value;if(await this.k.getSession(l,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:$.identifier,enabled:!0}]),!0;if(D)return!1;try{const k=I?(0,p.localize)(0,null,$.displayName,I):void 0;return await this.k.getSession(l,y,[],{forceNewSession:{detail:k}}),this.$updateModelAccesslist([{from:l.identifier,to:$.identifier,enabled:!0}]),!0}catch{return!1}}o(l,$){return!!$.auth&&!c.$qn.equals($.extension,l)}async p(l){if(l.auth)for(const $ of this.r)try{await this.n($,{identifier:l.extension,displayName:""},void 0,!0)}catch(I){this.j.error("Fake Auth request failed"),this.j.error(I)}}async q(l,$,I){if(!this.g.get(l))throw a.$KP.NotFound(`Language model '${l}' is unknown.`);const y=A.Iterable.find(this.f.values(),S=>S.languageModelId===l);return y?y.provider.provideTokenCount($,I):this.b.$countTokens(l,typeof $=="string"?$:o.LanguageModelChatMessage.from($),I)}$updateModelAccesslist(l){const $=new Array;for(const{from:I,to:D,enabled:y}of l){const S=this.h.get(I)??new c.$rn;if(S.has(D)!==y){y?S.add(D):S.delete(D),this.h.set(I,S);const g={from:I,to:D};$.push(g),this.c.fire(g)}}}createLanguageModelAccessInformation(l){this.r.add(l);const $=this,I=T.Event.signal(T.Event.filter(this.c.event,y=>c.$qn.equals(y.from,l.identifier))),D=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(I,D)},canSendRequest(y){let S;e:for(const[g,b]of $.g)for(const L of b.apiObjects.values())if(L===y){S=b.metadata;break e}if(!S)return;if(!$.o(l.identifier,S))return!0;const k=$.h.get(l.identifier);if(k)return k.has(S.extension)}}}};e.$qoc=m,e.$qoc=m=s=Qe([Ve(0,r.$WP),Ve(1,v.$_j),Ve(2,d.$Knc)],m)});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[286],Ie([1,0,6,10,7,36,11,5,25]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0,C=qe(C),T=ri(T);class c{constructor(v,u,E,d){this.c=u,this.d=E,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=v.getProxy(w.$qN.MainThreadLanguages)}$acceptLanguageIds(v){this.b=v}async getLanguages(){return this.b.slice(0)}async changeLanguage(v,u){await this.a.$changeLanguage(v,u);const E=this.c.getDocumentData(v);if(!E)throw new Error(`document '${v.toString()}' NOT found`);return E.document}async tokenAtPosition(v,u){const E=v.version,d=C.Position.from(u),r=await this.a.$tokensAtPosition(v.uri,d),o={type:P.StandardTokenType.Other,range:v.getWordRangeAtPosition(u)??new P.$uN(u.line,u.character,u.line,u.character)};if(!r)return o;const a={range:C.Range.to(r.range),type:C.TokenType.to(r.type)};return!a.range.contains(u)||E!==v.version?o:a}createLanguageStatusItem(v,u,E){const d=this.f++,r=this.a,o=this.g,a=`${v.identifier.value}/${u}`;if(o.has(a))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(a);const h={selector:E,id:u,name:v.displayName??v.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const s=new N.$Vc,i=()=>{if(n?.dispose(),!o.has(a)){console.warn(`LanguageStatusItem (${u}) from ${v.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,A.$Hh)(()=>{s.clear(),this.a.$setLanguageStatus(d,{id:a,name:h.name??v.displayName??v.name,source:v.displayName??v.name,selector:C.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===P.LanguageStatusSeverity.Error?T.default.Error:h.severity===P.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:h.command&&this.d.toInternal(h.command,s),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},t={dispose(){s.dispose(),n?.dispose(),r.$removeLanguageStatus(d),o.delete(a)},get id(){return h.id},get name(){return h.name},set name(m){h.name=m,i()},get selector(){return h.selector},set selector(m){h.selector=m,i()},get text(){return h.text},set text(m){h.text=m,i()},set text2(m){(0,p.$5G)(v,"languageStatusText"),h.text=m,i()},get text2(){return(0,p.$5G)(v,"languageStatusText"),h.text},get detail(){return h.detail},set detail(m){h.detail=m,i()},get severity(){return h.severity},set severity(m){h.severity=m,i()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(m){h.accessibilityInformation=m,i()},get command(){return h.command},set command(m){h.command=m,i()},get busy(){return h.busy},set busy(m){h.busy=m,i()}};return i(),t}}e.$apc=c}),define(Ce[287],Ie([1,0,16,2,10,7,90]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=e.$Yoc=void 0,P=qe(P),A=qe(A);class N{constructor(v,u,E,d){this.start=v,this.deletedCount=u,this.deletedItems=E,this.items=d}asApiEvent(){return{range:new T.$UO(this.start,this.start+this.deletedCount),addedCells:this.items.map(v=>v.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1}}constructor(v,u,E){this.notebook=v,this.h=u,this.j=E,this.handle=E.handle,this.uri=C.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(P.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const v=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return v.notebook.getCellIndex(v)},notebook:v.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return v.g},set mime(d){v.g=d},get outputs(){return v.a.slice(0)},get metadata(){return v.b},get executionSummary(){return v.d}};this.f=Object.freeze(E)}return this.f}setOutputs(v){this.a=v.map(P.NotebookCellOutput.to)}setOutputItems(v,u,E){const d=E.map(P.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===v);if(r&&(u||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(o=>A.$vL(o.mime)))){const o=new Map,a=[];r.items.forEach(h=>{let n;o.has(h.mime)?n=o.get(h.mime):(n=[],o.set(h.mime,n),a.push(h.mime)),n.push(h.data)}),r.items.length=0,a.forEach(h=>{const n=A.$wL(o.get(h));r.items.push({mime:h,data:n.data.buffer})})}}setMetadata(v){this.b=Object.freeze(v)}setInternalMetadata(v){this.e=v,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(v))}setMime(v){}}e.$Yoc=p;class c{static{this.a=0}constructor(v,u,E,d,r){this.k=v,this.l=u,this.m=E,this.uri=d,this.handle=c.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const v=this,u={get uri(){return v.uri},get version(){return v.g},get notebookType(){return v.d},get isDirty(){return v.h},get isUntitled(){return v.uri.scheme===w.Schemas.untitled},get isClosed(){return v.j},get metadata(){return v.f},get cellCount(){return v.b.length},cellAt(E){return E=v.n(E),v.b[E].apiCell},getCells(E){return(E?v.p(E):v.b).map(r=>r.apiCell)},save(){return v.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(v){v.metadata&&(this.f=Object.freeze({...this.f,...v.metadata}))}acceptDirty(v){this.h=v}acceptModelChanged(v,u,E){this.g=v.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:E});const d={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},r=[];for(const a of v.rawEvents)a.kind===A.NotebookCellsChangeType.ModelChange?this.r(a.changes,!1,d.contentChanges):a.kind===A.NotebookCellsChangeType.Move?this.s(a.index,a.length,a.newIdx,d.contentChanges):a.kind===A.NotebookCellsChangeType.Output?(this.t(a.index,a.outputs),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.OutputItem?(this.u(a.index,a.outputId,a.append,a.outputItems),r.push({cell:this.b[a.index].apiCell,outputs:this.b[a.index].apiCell.outputs})):a.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(a.index,a.language),r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document})):a.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[a.index].apiCell,document:this.b[a.index].apiCell.document}):a.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(a.index,a.mime):a.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(a.index,a.metadata),r.push({cell:this.b[a.index].apiCell,metadata:this.b[a.index].apiCell.metadata})):a.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(a.index,a.internalMetadata),r.push({cell:this.b[a.index].apiCell,executionSummary:this.b[a.index].apiCell.executionSummary}));const o=new Map;for(let a=0;a<r.length;a++){const h=r[a],n=o.get(h.cell);if(n===void 0){const s=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});o.set(h.cell,s-1)}else d.cellChanges[n]={...d.cellChanges[n],...h}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(v){return v=v|0,v<0?0:v>=this.b.length?this.b.length-1:v}o(v){let u=v.start|0,E=v.end|0;return u<0&&(u=0),E>this.b.length&&(E=this.b.length),v.with({start:u,end:E})}p(v){v=this.o(v);const u=[];for(let E=v.start;E<v.end;E++)u.push(this.b[E]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(v,u,E){if(this.j)return;const d=[],r=[],o=[];if(v.reverse().forEach(a=>{const n=a[2].map(t=>{const m=new p(this,this.l,t);return u||r.push(p.asModelAddData(t)),m}),s=new N(a[0],a[1],[],n),i=this.b.splice(a[0],a[1],...n);for(const t of i)o.push(t.uri),s.deletedItems.push(t.apiCell);d.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),E)for(const a of d)E.push(a.asApiEvent())}s(v,u,E,d){const r=this.b.splice(v,u);this.b.splice(E,0,...r);const o=[new N(v,u,r.map(a=>a.apiCell),[]),new N(E,0,[],r)];for(const a of o)d.push(a.asApiEvent())}t(v,u){this.b[v].setOutputs(u)}u(v,u,E,d){this.b[v].setOutputItems(u,E,d)}v(v,u){const E=this.b[v];E.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(E.uri,u)}w(v,u){const E=this.b[v];E.apiCell.mime=u}x(v,u){this.b[v].setMetadata(u)}y(v,u){this.b[v].setInternalMetadata(u)}getCellFromApiCell(v){return this.b.find(u=>u.apiCell===v)}getCellFromIndex(v){return this.b[v]}getCell(v){return this.b.find(u=>u.handle===v)}getCellIndex(v){return this.b.indexOf(v)}}e.$Zoc=c}),define(Ce[288],Ie([1,0,4,2,10,7,39]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cpc=void 0;class N{constructor(c,R,v,u={timeout:1500,errors:3}){this.b=c,this.c=R,this.d=v,this.f=u,this.a=new w.$oe}dispose(){}getOnWillSaveNotebookDocumentEvent(c){return(R,v,u)=>{const E=function(r){R.call(v,r)};return E.extension=c,this.a.event(E,void 0,u)}}async $participateInSave(c,R,v){const u=C.URI.revive(c),E=this.c.getNotebookDocument(u);if(!E)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:P.TextDocumentSaveReason.to(R)},v,async(o,a)=>{const h=Date.now(),n=await await Promise.resolve(o);Date.now()-h>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier),!v.isCancellationRequested&&n&&(n instanceof T.$CN?d.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",a.extension.identifier,"ignored due to invalid data"))}),v.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const o of d){const{edits:a}=P.WorkspaceEdit.from(o);r.edits=r.edits.concat(a)}return this.d.$tryApplyWorkspaceEdit(new A.$Qw(r))}}e.$cpc=N}),define(Ce[123],Ie([1,0,14,10,7]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0,C=qe(C),P=qe(P);class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(N,p,c,R,v,u){this.id=N,this.f=p,this.notebookData=c,this.a=[],this.b=[],this.d=!1,this.a=v,this.b=R,this.c=u}get apiEditor(){if(!this.e){const N=this;this.e={get notebook(){return N.notebookData.apiNotebook},get selection(){return N.a[0]},set selection(p){this.selections=[p]},get selections(){return N.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$UO.isNotebookRange))throw(0,w.$9)("selections");N.a=p,N.g(p)},get visibleRanges(){return N.b},revealRange(p,c){N.f.$tryRevealRange(N.id,C.NotebookRange.from(p),c??P.NotebookEditorRevealType.Default)},get viewColumn(){return N.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(N){this.d=N}_acceptVisibleRanges(N){this.b=N}_acceptSelections(N){this.a=N}g(N){this.f.$trySetSelections(this.id,N.map(C.NotebookRange.from))}_acceptViewColumn(N){this.c=N}}e.$1oc=T}),define(Ce[289],Ie([1,0,4,12,10]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$epc=void 0,P=qe(P);let T=class{constructor(N,p){this.c=N,this.d=p,this.a=new w.$me,this.b=new w.$me,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(N,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",N,p);const c=this.d.getEditorById(N);p.visibleRanges&&c._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&c._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:c.apiEditor,visibleRanges:c.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:c.apiEditor,selections:c.apiEditor.selections}))}$acceptEditorViewColumns(N){for(const p in N)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(N[p]))}};e.$epc=T,e.$epc=T=Qe([Ve(0,C.$_j)],T)}),define(Ce[290],Ie([1,0,4,6,123]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=void 0;class T{constructor(N,p){this.c=p,this.a=new Map,this.b=N.getProxy(C.$qN.MainThreadNotebookRenderers)}$postRendererMessage(N,p,c){const R=this.c.getEditorById(N);this.a.get(p)?.fire({editor:R.apiEditor,message:c})}createRendererMessaging(N,p){if(!N.contributes?.notebookRenderer?.some(R=>R.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(R,v,u)=>this.d(p).event(R,v,u),postMessage:(R,v)=>{P.$1oc.apiEditorsToExtHost.has(R)&&([R,v]=[v,R]);const u=v&&P.$1oc.apiEditorsToExtHost.get(v);return this.b.$postMessage(u?.id,p,R)}}}d(N){let p=this.a.get(N);return p||(p=new w.$me({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(N)}}),this.a.set(N,p),p)}}e.$hpc=T}),define(Ce[291],Ie([1,0,10,77,22,72,14]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;class N{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,u,E){const d=this.b++,{title:r,location:o,cancellable:a}=u,h={label:v.displayName||v.name,id:v.identifier.value};return this.a.$startProgress(d,{location:w.ProgressLocation.from(o),title:r,source:h,cancellable:a},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.$4),this.d(d,E,!!a)}d(v,u,E){let d;E&&(d=new P.$xe,this.c.set(v,d));const r=a=>{this.a.$progressEnd(a),this.c.delete(a),d?.dispose()};let o;try{o=u(new c(this.a,v),E&&d?d.token:P.CancellationToken.None)}catch(a){throw r(v),a}return o.then(a=>r(v),a=>r(v)),o}$acceptProgressCanceled(v){const u=this.c.get(v);u&&(u.cancel(),this.c.delete(v))}}e.$lpc=N;function p(R,v){return R.message=v.message,typeof v.increment=="number"&&(typeof R.increment=="number"?R.increment+=v.increment:R.increment=v.increment),R}class c extends C.$sw{constructor(v,u){super(E=>this.throttledReport(E)),this.c=v,this.d=u}throttledReport(v){this.c.$progressReport(this.d,v)}}Qe([(0,T.$_h)(100,(R,v)=>p(R,v),()=>Object.create(null))],c.prototype,"throttledReport",null)}),define(Ce[292],Ie([1,0,2,6,11,10]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0;class A{static{this.a=0}constructor(p,c){this.d=c,this.c=new Map,this.b=p.getProxy(C.$qN.MainThreadQuickDiff)}$provideOriginalResource(p,c,R){const v=w.URI.revive(c),u=this.c.get(p);return u?(0,P.$xh)(()=>u.provideOriginalResource(v,R)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider(p,c,R,v){const u=A.a++;return this.c.set(u,c),this.b.$registerQuickDiffProvider(u,T.DocumentSelector.from(p,this.d),R,v),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$mpc=A});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[293],Ie([1,0,22,4,5,6,2,7,14,18,36,35,25,10]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=d,R=ri(R);function d(r,o,a){const h=r.getProxy(T.$qN.MainThreadQuickOpen);class n{constructor(D,y){this.e=new Map,this.f=0,this.a=D,this.b=y}showQuickPick(D,y,S,k=w.CancellationToken.None){this.c=void 0;const g=Promise.resolve(y),b=++this.f,L=h.$show(b,{title:S?.title,placeHolder:S?.placeHolder,matchOnDescription:S?.matchOnDescription,matchOnDetail:S?.matchOnDetail,ignoreFocusLost:S?.ignoreFocusOut,canPickMany:S?.canPickMany},k),O={},q=L.then(()=>O);return Promise.race([q,g]).then(G=>{if(G===O)return;const W=(0,u.$4G)(D,"quickPickItemTooltip");return g.then(F=>{const V=[];for(let ce=0;ce<F.length;ce++){const ge=F[ce];if(typeof ge=="string")V.push({label:ge,handle:ce});else if(ge.kind===N.QuickPickItemKind.Separator)V.push({type:"separator",label:ge.label});else{ge.tooltip&&!W&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const te=ge.iconPath?f(ge.iconPath):void 0;V.push({label:ge.label,iconPath:te?.iconPath,iconClass:te?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:W?E.MarkdownString.fromStrict(ge.tooltip):void 0,handle:ce})}}return S&&typeof S.onDidSelectItem=="function"&&(this.c=ce=>{S.onDidSelectItem(F[ce])}),h.$setItems(b,V),L.then(ce=>{if(typeof ce=="number")return F[ce];if(Array.isArray(ce))return ce.map(ge=>F[ge])})})}).then(void 0,G=>{if(!(0,p.$6)(G))return h.$setError(b,G),Promise.reject(G)})}$onItemSelected(D){this.c?.(D)}showInput(D,y=w.CancellationToken.None){return this.d=D?.validateInput,h.$input(D,typeof this.d=="function",y).then(void 0,S=>{if(!(0,p.$6)(S))return Promise.reject(S)})}async $validateInput(D){if(!this.d)return;const y=await this.d(D);if(!y||typeof y=="string")return y;let S;switch(y.severity){case N.InputBoxValidationSeverity.Info:S=R.default.Info;break;case N.InputBoxValidationSeverity.Warning:S=R.default.Warning;break;case N.InputBoxValidationSeverity.Error:S=R.default.Error;break;default:S=y.message?R.default.Error:R.default.Ignore;break}return{content:y.message,severity:S}}async showWorkspaceFolderPick(D,y=w.CancellationToken.None){const S=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!S)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(g=>g.uri.toString()===S.uri.toString())}createQuickPick(D){const y=new l(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(D){const y=new $(D,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(D,y){this.e.get(D)?._fireDidChangeValue(y)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,y){const S=this.e.get(D);S instanceof l&&S._fireDidChangeActive(y)}$onDidChangeSelection(D,y){const S=this.e.get(D);S instanceof l&&S._fireDidChangeSelection(y)}$onDidTriggerButton(D,y){this.e.get(D)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(D,y,S){const k=this.e.get(D);k instanceof l&&k._fireDidTriggerItemButton(y,S)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class s{static{this.a=1}constructor(D,y){this.x=D,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new C.$me,this.q=new C.$me,this.r=new C.$me,this.s=new C.$me,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){this.n=D.slice(),this.o.clear(),D.forEach((y,S)=>{const k=y===N.$RO.Back?-1:S;this.o.set(k,y)}),this.z({buttons:D.map((y,S)=>({...f(y.iconPath),tooltip:y.tooltip,handle:y===N.$RO.Back?-1:S}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const y=this.o.get(D);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Rc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(D){if(!this.v){for(const y of Object.keys(D)){const S=D[y];this.u[y]=S===void 0?null:S}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}function i(I){if(I instanceof N.$pO)return{id:I.id};const D=m(I),y=t(I);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof y=="string"?A.URI.file(y):y}}function t(I){return typeof I=="object"&&"light"in I?I.light:I}function m(I){return typeof I=="object"&&"dark"in I?I.dark:I}function f(I){const D=i(I);let y,S;return"id"in D?S=v.ThemeIcon.asClassName(D):y=D,{iconPath:y,iconClass:S}}class l extends s{constructor(D,y){super(D.identifier,y),this.O=D,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new C.$me,this.L=[],this.M=new C.$me,this.N=new C.$me,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,g)=>{this.C.set(g,k),this.D.set(k,g)});const y=(0,u.$4G)(this.O,"quickPickItemTooltip"),S=[];for(let k=0;k<D.length;k++){const g=D[k];if(g.kind===N.QuickPickItemKind.Separator)S.push({type:"separator",label:g.label});else{g.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=g.iconPath?f(g.iconPath):void 0;S.push({handle:k,label:g.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:g.description,detail:g.detail,picked:g.picked,alwaysShow:g.alwaysShow,tooltip:y?E.MarkdownString.fromStrict(g.tooltip):void 0,buttons:g.buttons?.map((L,O)=>({...f(L.iconPath),tooltip:L.tooltip,handle:O}))})}}this.z({items:S})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(D){const y=(0,c.$Jb)(D.map(S=>this.C.get(S)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(D){const y=(0,c.$Jb)(D.map(S=>this.C.get(S)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(D,y){const S=this.C.get(D);if(!S||!S.buttons||!S.buttons.length)return;const k=S.buttons[y];k&&this.N.fire({button:k,item:S})}}class $ extends s{constructor(D,y){super(D.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:R.default.Error}):this.z({validationMessage:D.message,severity:D.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new n(o,a)}}),define(Ce[294],Ie([1,0,2,4,72,5,11,6,18,159,12,19,38,35,10,25,16,21]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=void 0;function n(L){return L instanceof w.URI}function s(L,O){return L.scheme===o.Schemas.file&&O.scheme===o.Schemas.file&&a.$k?L.toString()===O.toString():L.toString().toLowerCase()===O.toString().toLowerCase()}function i(L){if(L)return typeof L.iconPath=="string"?w.URI.file(L.iconPath):w.URI.isUri(L.iconPath)||E.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function t(L){if(L.icon){if(w.URI.isUri(L.icon))return L.icon;if(E.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const O=L.icon;return{light:O.light,dark:O.dark}}}else return}function m(L,O){if(!L.iconPath&&!O.iconPath)return 0;if(L.iconPath){if(!O.iconPath)return 1}else return-1;const q=typeof L.iconPath=="string"?L.iconPath:w.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,G=typeof O.iconPath=="string"?O.iconPath:w.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,c.$Er)(q,G)}function f(L,O){let q=0;if(L.strikeThrough!==O.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==O.faded)return L.faded?1:-1;if(L.tooltip!==O.tooltip)return(L.tooltip||"").localeCompare(O.tooltip||"");if(q=m(L,O),q!==0)return q;if(L.light&&O.light)q=m(L.light,O.light);else{if(L.light)return 1;if(O.light)return-1}if(q!==0)return q;if(L.dark&&O.dark)q=m(L.dark,O.dark);else{if(L.dark)return 1;if(O.dark)return-1}return q}function l(L,O){if(L.command!==O.command)return L.command<O.command?-1:1;if(L.title!==O.title)return L.title<O.title?-1:1;if(L.tooltip!==O.tooltip){if(L.tooltip!==void 0&&O.tooltip!==void 0)return L.tooltip<O.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(L.arguments===O.arguments)return 0;if(L.arguments)if(O.arguments){if(L.arguments.length!==O.arguments.length)return L.arguments.length-O.arguments.length}else return 1;else return-1;for(let q=0;q<L.arguments.length;q++){const G=L.arguments[q],W=O.arguments[q];if(G!==W&&!(n(G)&&n(W)&&s(G,W)))return G<W?-1:1}return 0}function $(L,O){let q=(0,c.$Er)(L.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(q!==0)return q;if(L.command&&O.command)q=l(L.command,O.command);else{if(L.command)return 1;if(O.command)return-1}if(q!==0)return q;if(L.decorations&&O.decorations)q=f(L.decorations,O.decorations);else{if(L.decorations)return 1;if(O.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)q=(0,c.$Er)(L.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)q=(0,c.$Er)(L.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return q}function I(L,O){for(let q=0;q<L.length;q++)if(L[q]!==O[q])return!1;return!0}function D(L,O){return L.command===O.command&&L.title===O.title&&L.tooltip===O.tooltip&&(L.arguments&&O.arguments?I(L.arguments,O.arguments):L.arguments===O.arguments)}function y(L,O){return(0,p.$wb)(L,O,D)}class S{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,r.$5G)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,r.$5G)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,r.$5G)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,q,G,W,F){this.k=O,this.l=W,this.m=F,this.d="",this.e=new C.$me,this.f="",this.h=!0,this.j=!0,this.#t=q,this.#e=G}showValidationMessage(O,q){(0,r.$5G)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,q)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$opc=S;class k{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,q,G,W,F,V,ce){this.q=O,this.s=q,this.t=G,this.u=W,this.v=F,this.multiDiffEditorEnableViewChanges=V,this.w=ce,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new C.$me,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new C.$me,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=k.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,q){const G=this.h.get(O);return G?(0,A.$xh)(()=>this.s.executeCommand(G.command,...G.arguments||[],q)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort($),G=(0,p.$Fb)(this.o,O,$).map(V=>{const ce=V.toInsert.map(ge=>{const te=this.e++;this.g.set(te,ge);const me=ge.resourceUri;let se;if(ge.command)if(ge.command.command==="vscode.open"||ge.command.command==="vscode.diff"||ge.command.command==="vscode.changes"){const X=new T.$Vc;se=this.s.converter.toInternal(ge.command,X),this.j.set(te,X)}else this.h.set(te,ge.command);const de=(0,r.$4G)(this.w,"scmMultiDiffEditor"),be=de?ge.multiDiffEditorOriginalUri:void 0,re=de?ge.multiFileDiffEditorModifiedUri:void 0,Pe=i(ge.decorations),Le=ge.decorations&&i(ge.decorations.light)||Pe,Y=ge.decorations&&i(ge.decorations.dark)||Pe,B=[Le,Y],_=ge.decorations&&ge.decorations.tooltip||"",ve=ge.decorations&&!!ge.decorations.strikeThrough,ae=ge.decorations&&!!ge.decorations.faded,we=ge.contextValue||"";return{rawResource:[te,me,B,_,ve,ae,we,se,be,re],handle:te}});return{start:V.start,deleteCount:V.deleteCount,toInsert:ce}}),W=G.map(({start:V,deleteCount:ce,toInsert:ge})=>[V,ce,ge.map(te=>te.rawResource)]),F=G.reverse();for(const{start:V,deleteCount:ce,toInsert:ge}of F){const te=ge.map(se=>se.handle),me=this.n.splice(V,ce,...te);for(const se of me)this.g.delete(se),this.h.delete(se),this.j.get(se)?.dispose(),this.j.delete(se)}return this.o=O,W}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let q;(0,r.$4G)(this.x,"quickDiffProvider")&&(q=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:q})}get historyProvider(){return(0,r.$5G)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,r.$5G)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new T.$Vc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new T.$Vc,this.o=O;const q=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:q})}get actionButton(){return(0,r.$5G)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,r.$5G)(this.x,"scmActionButton"),this.p.value=new T.$Vc,this.q=O;const q=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(G=>G.map(W=>this.y.converter.toInternal(W,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:q??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.z.info("ExtHostSourceControl#statusBarCommands",(O??[]).map(G=>G.command).join(", ")),this.t&&O&&y(this.t,O)){this.z.info("ExtHostSourceControl#statusBarCommands are equal");return}this.s.value=new T.$Vc,this.t=O;const q=(O||[]).map(G=>this.y.converter.toInternal(G,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:q})}get selected(){return this.u}constructor(O,q,G,W,F,V,ce,ge){this.x=O,this.y=W,this.z=F,this.A=V,this.B=ce,this.C=ge,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Xc,this.m=void 0,this.n=new T.$Xc,this.o=void 0,this.p=new T.$Xc,this.s=new T.$Xc,this.t=void 0,this.u=!1,this.v=new C.$me,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.D=new Map,this.E=new Set,this.#e=G;const te=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${V}/scm${this.w}/input`,query:ge?`rootUri=${encodeURIComponent(ge.toString())}`:void 0});this.f=new S(O,q,this.#e,this.w,te),this.#e.$registerSourceControl(this.w,V,ce,ge,te)}createResourceGroup(O,q,G){const W=(0,r.$4G)(this.x,"scmMultiDiffEditor")&&G?.multiDiffEditorEnableViewChanges===!0,F=new k(this.#e,this.y,this.w,O,q,W,this.x),V=C.Event.once(F.onDidDispose)(()=>this.D.delete(F));return this.D.set(F,V),this.eventuallyAddResourceGroups(),F}eventuallyAddResourceGroups(){const O=[],q=[];for(const[G,W]of this.D){W.dispose();const F=G.onDidUpdateResourceStates(()=>{this.E.add(G),this.eventuallyUpdateResourceStates()});C.Event.once(G.onDidDispose)(()=>{this.E.delete(G),F.dispose(),this.e.delete(G.handle),this.#e.$unregisterGroup(this.w,G.handle)}),O.push([G.handle,G.id,G.label,G.features,G.multiDiffEditorEnableViewChanges]);const V=G._takeResourceStateSnapshot();V.length>0&&q.push([G.handle,V]),this.e.set(G.handle,G)}this.#e.$registerGroups(this.w,O,q),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(q=>{const G=q._takeResourceStateSnapshot();G.length!==0&&O.push([q.handle,G])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.E.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Qe([(0,P.$$h)(100)],g.prototype,"eventuallyAddResourceGroups",null),Qe([(0,P.$$h)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{h=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,q,G,W){this.l=q,this.m=G,this.n=W,this.g=new Map,this.h=new v.$sn,this.j=new C.$me,this.e=O.getProxy(N.$qN.MainThreadSCM),this.f=O.getProxy(N.$qN.MainThreadTelemetry),q.registerArgumentProcessor({processArgument:F=>{if(F&&F.$mid===u.MarshalledId.ScmResource){const V=this.g.get(F.sourceControlHandle);if(!V)return F;const ce=V.getResourceGroup(F.groupHandle);return ce?ce.getResourceState(F.handle):F}else if(F&&F.$mid===u.MarshalledId.ScmResourceGroup){const V=this.g.get(F.sourceControlHandle);return V?V.getResourceGroup(F.groupHandle):F}else if(F&&F.$mid===u.MarshalledId.ScmProvider){const V=this.g.get(F.handle);return V||F}return F}})}createSourceControl(O,q,G,W){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,q,G,W),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const F=h.d++,V=new g(O,this.m,this.e,this.l,this.n,q,G,W);this.g.set(F,V);const ce=this.h.get(O.identifier)||[];return ce.push(V),this.h.set(O.identifier,ce),V}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const q=this.h.get(O.identifier),G=q&&q[q.length-1];return G&&G.inputBox}$provideOriginalResource(O,q,G){const W=w.URI.revive(q);this.n.trace("ExtHostSCM#$provideOriginalResource",O,W.toString());const F=this.g.get(O);return!F||!F.quickDiffProvider||!F.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$xh)(()=>F.quickDiffProvider.provideOriginalResource(W,G)).then(V=>V||null)}$onInputBoxValueChange(O,q){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const G=this.g.get(O);return G&&G.inputBox.$onInputBoxValueChange(q),Promise.resolve(void 0)}$executeResourceCommand(O,q,G,W){this.n.trace("ExtHostSCM#$executeResourceCommand",O,q,G);const F=this.g.get(O);if(!F)return Promise.resolve(void 0);const V=F.getResourceGroup(q);return V?V.$executeResourceCommand(G,W):Promise.resolve(void 0)}$validateInput(O,q,G){this.n.trace("ExtHostSCM#$validateInput",O);const W=this.g.get(O);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,A.$xh)(()=>W.inputBox.validateInput(q,G)).then(F=>{if(!F)return Promise.resolve(void 0);const V=d.MarkdownString.fromStrict(F.message);return V?Promise.resolve([V,F.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,q,G,W){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(q,G,W)??void 0}async $provideHistoryItems(O,q,G,W){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(q,G,W))?.map(ce=>({...ce,icon:t(ce)}))??void 0}async $provideHistoryItemSummary(O,q,G,W){const F=this.g.get(O)?.historyProvider;if(typeof F?.provideHistoryItemSummary!="function")return;const V=await F.provideHistoryItemSummary(q,G,W);return V?{...V,icon:t(V)}:void 0}async $provideHistoryItemChanges(O,q,G,W){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(q,G,W)??void 0}};e.$ppc=b,e.$ppc=b=h=Qe([Ve(3,R.$_j)],b)}),define(Ce[295],Ie([1,0,6,10,2]),function(oe,e,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qpc=void 0;class T{static{this.a=0}constructor(N,p){this.d=p,this.c=new Map,this.b=N.getProxy(w.$qN.MainThreadShare)}async $provideShare(N,p,c){return await this.c.get(N)?.provideShare({selection:C.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},c)??void 0}registerShareProvider(N,p){const c=T.a++;return this.c.set(c,p),this.b.$registerShareProvider(c,C.DocumentSelector.from(N,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(c),this.c.delete(c)}}}}e.$qpc=T}),define(Ce[296],Ie([1,0,7,6,186,5,10,15]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=e.$spc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$qO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$qO("statusBarItem.warningForeground")]])}#e;#t;constructor(u,E,d,r,o,a=w.StatusBarAlignment.Left,h){if(this.i=!1,this.k="",this.q=new T.$Vc,this.#e=u,this.#t=E,o&&r){this.c=(0,w.$5N)(r.identifier,o);const n=d.get(this.c);n&&(a=n.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,h=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=o,this.g=a,this.h=this.u(h)}u(u){if((0,N.$jg)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!p.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new T.$Vc,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let E;this.m?E=this.m:E=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,E,this.k,r,this.r?.internal,d,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$spc=p;class c{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const E={message:u};return this.b.unshift(E),this.c(),new w.$sN(()=>{const d=this.b.indexOf(E);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(u,E){this.e=new Map,this.a=u.getProxy(C.$qN.MainThreadStatusBar),this.b=E,this.c=new c(this)}$acceptStaticEntries(u){for(const E of u)this.e.set(E.entryId,E)}createStatusBarEntry(u,E,d,r){return new p(this.a,this.b,this.e,u,E,d,r)}setStatusBarMessage(u,E){const d=this.c.setMessage(u);let r;return typeof E=="number"?r=setTimeout(()=>d.dispose(),E):typeof E<"u"&&E.then(()=>d.dispose(),()=>d.dispose()),new w.$sN(()=>{d.dispose(),clearTimeout(r)})}}e.$tpc=R}),define(Ce[124],Ie([1,0,33,115,55,82,56,10,2]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=e.$0P=e.$9P=void 0,w=qe(w),N=qe(N);const c=(n,s,i,t)=>{let m=s;return{enumerable:!0,configurable:!1,get(){return m},set(f){if(!i(m,f)){const l=m;m=f,n.listener?.(t(f,l))}}}},R=(n,s)=>n===s,v={range:(n,s)=>n===s?!0:!n||!s?!1:n.isEqual(s),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(n,s)=>!(n.length!==s.length||n.some(i=>!s.find(t=>i.id===t.id)))},u=n=>s=>({op:T.TestItemEventOp.SetProp,update:n(s)}),E=(n,s)=>({range:(()=>{let i;const t=u(m=>({range:w.$It.lift(N.Range.from(m))}));return{enumerable:!0,configurable:!1,get(){return i},set(m){n.listener?.({op:T.TestItemEventOp.DocumentSynced}),v.range(i,m)||(i=m,n.listener?.(t(m)))}}})(),label:c(n,s,v.label,u(i=>({label:i}))),description:c(n,void 0,v.description,u(i=>({description:i}))),sortText:c(n,void 0,v.sortText,u(i=>({sortText:i}))),canResolveChildren:c(n,!1,v.canResolveChildren,i=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:i})),busy:c(n,!1,v.busy,u(i=>({busy:i}))),error:c(n,void 0,v.error,u(i=>({error:N.MarkdownString.fromStrict(i)||null}))),tags:c(n,[],v.tags,(i,t)=>({op:T.TestItemEventOp.SetTags,new:i.map(N.TestTag.from),old:t.map(N.TestTag.from)}))}),d=n=>{const s=P.$PI.fromString(n.extId),i=new o(s.controllerId,s.localId,n.label,p.URI.revive(n.uri)||void 0);return i.range=N.Range.to(n.range||void 0),i.description=n.description||void 0,i.sortText=n.sortText||void 0,i.tags=n.tags.map(t=>N.TestTag.to({id:(0,A.$VI)(t).tagId})),i},r=n=>{let s;for(const i of n.tests){const t=d(i.item);(0,C.$SP)(t).parent=s,s=t}return s};e.$9P=r;class o{constructor(s,i,t,m){if(i.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(i)} symbol`);const f=(0,C.$RP)(this,s);Object.defineProperties(this,{id:{value:i,enumerable:!0,writable:!1},uri:{value:m,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return f.parent instanceof a?void 0:f.parent}},children:{value:(0,T.$QP)(f,C.$SP,o),enumerable:!0,writable:!1},...E(f,t)})}}e.$0P=o;class a extends o{constructor(s,i){super(s,s,i,void 0),this._isRoot=!0}}e.$$P=a;class h extends T.$MP{constructor(s,i,t){super({controllerId:s,getDocumentVersion:m=>m&&t.getDocument(m)?.version,getApiFor:C.$SP,getChildren:m=>m.children,root:new a(s,i),toITestItem:N.TestItem.from})}}e.$_P=h}),define(Ce[34],Ie([1,0,15,7,10,26,6,18,12,49,33,101,2,5,3,17,124,23,39,48,70,64,67,37]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=e.$iQ=e.$hQ=e.$gQ=e.$fQ=void 0,C=qe(C),P=qe(P);let f=class{#e;#t;#i;constructor(S,k,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$qN.MainThreadCommands),this.d=k,this.#i=g,this.#t=S.getProxy(A.$qN.MainThreadTelemetry),this.converter=new l(this,b=>{const L=this.c.get(b);return L?.result===I.Void?L:void 0},k),this.f=[{processArgument(b){return(0,c.$ci)(b)}},{processArgument(b){return(0,T.$eo)(b,function(L){if(R.$It.isIRange(L))return P.Range.to(L);if(v.$Ht.isIPosition(L))return P.Position.to(L);if(R.$It.isIRange(L.range)&&u.URI.isUri(L.uri))return P.location.to(L);if(L instanceof a.$Oe)return L.buffer.buffer;if(!Array.isArray(L))return L})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const k=this.registerCommand(!1,S.id,async(...g)=>{const b=S.args.map((O,q)=>{if(!O.validate(g[q]))throw new Error(`Invalid argument '${O.name}' when running '${S.id}', received: ${typeof g[q]=="object"?JSON.stringify(g[q],null,"	"):g[q]} `);return O.convert(g[q])}),L=await this.executeCommand(S.internalId,...b);return S.result.convert(L,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new C.$sN(()=>{k.dispose(),this.c.delete(S.id)})}registerCommand(S,k,g,b,L,O){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:g,thisArg:b,metadata:L,extension:O}),S&&this.#e.$registerCommand(k),new C.$sN(()=>{this.b.delete(k)&&S&&this.#e.$unregisterCommand(k)})}executeCommand(S,...k){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,k,!0)}async g(S,k,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,k,!1);{let b=!1;const L=(0,T.$eo)(k,function(O){if(O instanceof C.$tN)return P.Position.from(O);if(O instanceof C.$uN)return P.Range.from(O);if(O instanceof C.$EN)return P.location.from(O);if(C.$UO.isNotebookRange(O))return P.NotebookRange.from(O);if(O instanceof ArrayBuffer)return b=!0,a.$Oe.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return b=!0,a.$Oe.wrap(O);if(O instanceof a.$Oe)return b=!0,O;if(!Array.isArray(O))return O});try{const O=await this.#e.$executeCommand(S,b?new h.$Qw(L):L,g);return(0,c.$ci)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(S,k,!1);throw O}}}async h(S,k,g){const b=this.b.get(S);if(!b)throw new Error("Unknown command");const{callback:L,thisArg:O,metadata:q}=b;if(q?.args)for(let W=0;W<q.args.length;W++)try{(0,w.$wg)(k[W],q.args[W].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${q.args[W].name}' - ${q.args[W].description}`)}const G=s.$ge.create();try{return await L.apply(O,k)}catch(W){if(S===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...k);F&&(S=F.command)}if(this.d.error(W,S,b.extension?.identifier),!g)throw W;if(b.extension?.identifier){const F=this.#i.onExtensionError(b.extension.identifier,W);this.d.trace("forwarded error to extension?",F,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$qj)(W)),this.id=S,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,S,G.elapsed())}}j(S,k,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new i.$tp(k),duration:g})}$executeContributedCommand(S,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?(k=k.map(b=>this.f.reduce((L,O)=>O.processArgument(L,g.extension?.identifier),b)),this.h(S,k,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(k=>(S&&(k=k.filter(g=>g[0]!=="_")),k))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[k,g]of this.b){const{metadata:b}=g;b&&(S[k]=b)}return Promise.resolve(S)}};e.$fQ=f,e.$fQ=f=Qe([Ve(0,r.$WP),Ve(1,p.$_j),Ve(2,t.$eQ)],f),e.$gQ=(0,d.$Fi)("IExtHostCommands");class l{constructor(S,k,g){this.d=S,this.f=k,this.g=g,this.delegatingCommandId=`__vsc${(0,m.$2g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,k){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const b=this.f(S.command);if(b)g.id=b.internalId,g.arguments=b.args.map((L,O)=>L.convert(S.arguments&&S.arguments[O]));else if((0,N.$Nb)(S.arguments)){const L=`${S.command} /${++this.c}`;this.b.set(L,S),k.add((0,E.$Uc)(()=>{this.b.delete(L),this.g.trace("CommandsConverter#DISPOSE",L)})),g.$ident=L,g.id=this.delegatingCommandId,g.arguments=[L],this.g.trace("CommandsConverter#CREATE",S.command,L)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const k=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$hQ=l;class ${static{this.Uri=new $("uri","Uri of a text document",S=>u.URI.isUri(S),S=>S)}static{this.Position=new $("position","A position in a text document",S=>C.$tN.isPosition(S),P.Position.from)}static{this.Range=new $("range","A range in a text document",S=>C.$uN.isRange(S),P.Range.from)}static{this.Selection=new $("selection","A selection in a text document",S=>C.$vN.isSelection(S),P.Selection.from)}static{this.Number=new $("number","",S=>typeof S=="number",S=>S)}static{this.String=new $("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=$.Arr($.String)}static Arr(S){return new $(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,k=>Array.isArray(k)&&k.every(g=>S.validate(g)),k=>k.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new $("item","A call hierarchy item",S=>S instanceof C.$QN,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new $("item","A type hierarchy item",S=>S instanceof C.$cP,P.TypeHierarchyItem.from)}static{this.TestItem=new $("testItem","A VS Code TestItem",S=>S instanceof o.$0P,P.TestItem.from)}constructor(S,k,g,b){this.name=S,this.description=k,this.validate=g,this.convert=b}optional(){return new $(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,k){return new $(S??this.name,k??this.description,this.validate,this.convert)}}e.$iQ=$;class I{static{this.Void=new I("no result",S=>S)}constructor(S,k){this.description=S,this.convert=k}}e.$jQ=I;class D{constructor(S,k,g,b,L){this.id=S,this.internalId=k,this.description=g,this.args=b,this.result=L}}e.$kQ=D}),define(Ce[297],Ie([1,0,18,16,2,94,104,32,34,10,7]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0,T=qe(T),c=qe(c),R=qe(R);const v=[new p.$kQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of DocumentHighlight-instances.",E(c.DocumentHighlight.to))),new p.$kQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$iQ.Uri],new p.$jQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,w.$Mb)(r))return;class a extends R.$LN{static to(n){const s=new a(n.name,c.SymbolKind.to(n.kind),n.containerName||"",new R.$EN(o[0],c.Range.to(n.range)));return s.detail=n.detail,s.range=s.location.range,s.selectionRange=c.Range.to(n.selectionRange),s.children=n.children?n.children.map(a.to):[],s}}return r.map(a.to)})),new p.$kQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$iQ.Uri,new p.$iQ("options","Formatting options",r=>!0,r=>r)],new p.$jQ("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$kQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$iQ.Uri,p.$iQ.Range,new p.$iQ("options","Formatting options",r=>!0,r=>r)],new p.$jQ("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$kQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$iQ.Uri,p.$iQ.Position,new p.$iQ("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$iQ("options","Formatting options",r=>!0,r=>r)],new p.$jQ("A promise that resolves to an array of TextEdits.",E(c.TextEdit.to))),new p.$kQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$kQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$kQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$kQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$kQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of Location-instances.",E(c.location.to))),new p.$kQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of Hover-instances.",E(c.Hover.to))),new p.$kQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$iQ.Uri,new p.$iQ("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>R.$tN.isPosition(o)),r=>r.map(c.Position.from))],new p.$jQ("A promise that resolves to an array of ranges.",r=>r.map(o=>{let a;for(const h of o.reverse())a=new R.$PN(c.Range.to(h),a);return a}))),new p.$kQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$iQ.String.with("query","Search string")],new p.$jQ("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(c.WorkspaceSymbol.to))),new p.$kQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(c.CallHierarchyItem.to))),new p.$kQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$iQ.CallHierarchyItem],new p.$jQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(c.CallHierarchyIncomingCall.to))),new p.$kQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$iQ.CallHierarchyItem],new p.$jQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(c.CallHierarchyOutgoingCall.to))),new p.$kQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:c.Range.to(r.range),placeholder:r.text}})),new p.$kQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$iQ.Uri,p.$iQ.Position,p.$iQ.String.with("newName","The new symbol name")],new p.$jQ("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return c.WorkspaceEdit.to(r)}})),new p.$kQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$iQ.Uri,p.$iQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$jQ("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(c.DocumentLink.to))),new p.$kQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$iQ.Uri],new p.$jQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$LO(r.tokenTypes,r.tokenModifiers)})),new p.$kQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$iQ.Uri],new p.$jQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$$cb)(r);if(o.type==="full")return new R.$NO(o.data,void 0)})),new p.$kQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$iQ.Uri,p.$iQ.Range.optional()],new p.$jQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new R.$LO(r.tokenTypes,r.tokenModifiers)})),new p.$kQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$iQ.Uri,p.$iQ.Range],new p.$jQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$$cb)(r);if(o.type==="full")return new R.$NO(o.data,void 0)})),new p.$kQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$iQ.Uri,p.$iQ.Position,p.$iQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$iQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$jQ("A promise that resolves to a CompletionList-instance.",(r,o,a)=>{if(!r)return new R.$2N([]);const h=r.suggestions.map(n=>c.CompletionItem.to(n,a));return new R.$2N(h,r.incomplete)})),new p.$kQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$iQ.Uri,p.$iQ.Position,p.$iQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$jQ("A promise that resolves to SignatureHelp.",r=>{if(r)return c.SignatureHelp.to(r)})),new p.$kQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$iQ.Uri,p.$iQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$jQ("A promise that resolves to an array of CodeLens-instances.",(r,o,a)=>E(h=>new R.$TN(c.Range.to(h.range),h.command&&a.fromInternal(h.command)))(r))),new p.$kQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$iQ.Uri,new p.$iQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>R.$uN.isRange(r),r=>R.$vN.isSelection(r)?c.Selection.from(r):c.Range.from(r)),p.$iQ.String.with("kind","Code action kind to return code actions for").optional(),p.$iQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$jQ("A promise that resolves to an array of Command-instances.",(r,o,a)=>E(h=>{if(h._isSynthetic){if(!h.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(h.command)}else{const n=new R.$NN(h.title,h.kind?new R.$ON(h.kind):void 0);return h.edit&&(n.edit=c.WorkspaceEdit.to(h.edit)),h.command&&(n.command=a.fromInternal(h.command)),n.isPreferred=h.isPreferred,n}})(r))),new p.$kQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$iQ.Uri],new p.$jQ("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new R.$8N(c.Range.to(o.range),c.Color.to(o.color))):[])),new p.$kQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$iQ("color","The color to show and insert",r=>r instanceof R.$7N,c.Color.from),new p.$iQ("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:c.Range.from(r.range)}))],new p.$jQ("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(c.ColorPresentation.to):[])),new p.$kQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$iQ.Uri,p.$iQ.Range],new p.$jQ("A promise that resolves to an array of Inlay objects",(r,o,a)=>r.map(c.InlayHint.to.bind(void 0,a)))),new p.$kQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$iQ.Uri],new p.$jQ("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(c.FoldingRange.to)})),new p.$kQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$jQ("A promise that resolves to an array of NotebookContentProvider static info objects.",E(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>c.NotebookExclusiveDocumentPattern.to(o))})))),new p.$kQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$iQ.Uri,p.$iQ.Range,new p.$iQ("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof R.$uN,r=>c.InlineValueContext.from(r))],new p.$jQ("A promise that resolves to an array of InlineValue objects",r=>r.map(c.InlineValue.to))),new p.$kQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$iQ("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,C.$Pg)(r,C.Schemas.http,C.Schemas.https),r=>r),new p.$iQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional(),p.$iQ.String.with("label","").optional()],p.$jQ.Void),new p.$kQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$iQ.Uri.with("resource","Resource to open"),p.$iQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$iQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[c.ViewColumn.from(r),void 0]:[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)])).optional()],p.$jQ.Void),new p.$kQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$iQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$iQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$iQ.String.with("title","Human readable title for the diff editor").optional(),new p.$iQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[c.ViewColumn.from(r.viewColumn),c.TextEditorOpenOptions.from(r)]).optional()],p.$jQ.Void),new p.$kQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$iQ.String.with("title","Human readable title for the changes editor"),new p.$iQ("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[a,h,n]=o;if(!P.URI.isUri(a)||!P.URI.isUri(h)&&h!==void 0&&h!==null||!P.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},r=>r)],p.$jQ.Void),new p.$kQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$iQ.Uri,p.$iQ.Position],new p.$jQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$kQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$iQ.TypeHierarchyItem],new p.$jQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$kQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$iQ.TypeHierarchyItem],new p.$jQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(c.TypeHierarchyItem.to))),new p.$kQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$iQ.TestItem],p.$jQ.Void),new p.$kQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$iQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$jQ.Void),new p.$kQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$iQ.String.with("name","The context key name"),new p.$iQ("value","The context key value",()=>!0,r=>r)],p.$jQ.Void),new p.$kQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$iQ.Uri,p.$iQ.StringArray,new p.$iQ("MappedEditsContext","Mapped Edits Context",r=>c.MappedEditsContext.is(r),r=>c.MappedEditsContext.from(r))],new p.$jQ("A promise that resolves to a workspace edit or null",r=>r?c.WorkspaceEdit.to(r):null)),new p.$kQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$iQ("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?c.Range.from(r.initialRange):void 0,initialSelection:R.$vN.isSelection(r.initialSelection)?c.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?c.Position.from(r.position):void 0}})],p.$jQ.Void)];class u{static register(o){v.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",N.$Ej)}}e.$Jnc=u;function E(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!Array.isArray(r))return;const o=[];for(const a of r)T.$Eu(a)?o.push(c.DefinitionLink.to(a)):o.push(c.location.to(a));return o}}),define(Ce[298],Ie([1,0,2,34]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;class P{constructor(A,N,p,c,R){this.a=N,this.b=p,this.c=c;const v=new C.$kQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new C.$iQ("showOptions","Show Options",u=>!0,u=>u),new C.$iQ("resource","Interactive resource Uri",u=>!0,u=>u),new C.$iQ("controllerId","Notebook controller Id",u=>!0,u=>u),new C.$iQ("title","Interactive editor title",u=>!0,u=>u)],new C.$jQ("Notebook and input URI",u=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const E=this.a.getEditorById(u.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri),notebookEditor:E.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:w.URI.revive(u.notebookUri),inputUri:w.URI.revive(u.inputUri)}}));this.c.registerApiCommand(v)}$willAddInteractiveDocument(A,N,p,c){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:N,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,N){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$$oc=P}),define(Ce[299],Ie([1,0,18,11,22,4,5,29,2,19,12,6,34,10,7,83,238,25,39,239]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fpc=void 0,e.$gpc=$,E=qe(E);let s=class{constructor(D,y,S,k,g){this.m=y,this.n=S,this.o=k,this.q=g,this.b=new N.$Cc,this.c=new N.$Cc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$me,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(v.$qN.MainThreadNotebookKernels);const b=new u.$kQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$iQ("options","Select kernel options",O=>!0,O=>{if(O&&"notebookEditor"in O&&"id"in O){const q=this.n.getIdByEditor(O.notebookEditor);return{id:O.id,extension:O.extension,notebookEditorId:q}}else if(O&&"notebookEditor"in O){const q=this.n.getIdByEditor(O.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${O.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return O})],u.$jQ.Void),L=new u.$kQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$iQ.Uri],new u.$jQ("A promise that resolves to an array of variables",(O,q)=>O.map(G=>({variable:{name:G.name,value:G.value,expression:G.expression,type:G.type,language:G.language},hasNamedChildren:G.hasNamedChildren,indexedChildrenCount:G.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(L)}createNotebookController(D,y,S,k,g,b){for(const re of this.j.values())if(re.controller.id===y&&c.$qn.equals(D.identifier,re.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const L=this.k++,O=this;this.q.trace(`NotebookController[${L}], CREATED by ${D.identifier.value}, ${y}`);const q=()=>console.warn(`NO execute handler from notebook controller '${V.id}' of extension: '${D.identifier}'`);let G=!1;const W=new T.$me,F=new T.$me,V={id:$(D.identifier,y),notebookType:S,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:b?b.map(E.NotebookRendererScript.from):[]};let ce=g??q,ge,te;this.a.$addKernel(L,V).catch(re=>{console.log(re),G=!0});let me=0;const se=()=>{if(G)return;const re=++me;Promise.resolve().then(()=>{re===me&&this.a.$updateKernel(L,V)})},de=new N.$Cc,be={get id(){return y},get notebookType(){return V.notebookType},onDidChangeSelectedNotebooks:W.event,get label(){return V.label},set label(re){V.label=re??D.displayName??D.name,se()},get detail(){return V.detail??""},set detail(re){V.detail=re,se()},get description(){return V.description??""},set description(re){V.description=re,se()},get supportedLanguages(){return V.supportedLanguages},set supportedLanguages(re){V.supportedLanguages=re,se()},get supportsExecutionOrder(){return V.supportsExecutionOrder??!1},set supportsExecutionOrder(re){V.supportsExecutionOrder=re,se()},get rendererScripts(){return V.preloads?V.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return ce},set executeHandler(re){ce=re??q},get interruptHandler(){return ge},set interruptHandler(re){ge=re,V.supportsInterrupt=!!re,se()},set variableProvider(re){(0,a.$5G)(D,"notebookVariableProvider"),te=re,V.hasVariableProvider=!!re,re?.onDidChangeVariables(Pe=>O.a.$variablesUpdated(Pe.uri)),se()},get variableProvider(){return te},createNotebookCellExecution(re){if(G)throw new Error("notebook controller is DISPOSED");if(!de.has(re.notebook.uri))throw O.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return O._createNotebookCellExecution(re,$(D.identifier,this.id))},createNotebookExecution(re){if((0,a.$5G)(D,"notebookExecution"),G)throw new Error("notebook controller is DISPOSED");if(!de.has(re.uri))throw O.q.trace(`NotebookController[${L}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(Pe=>Pe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return O._createNotebookExecution(re,$(D.identifier,this.id))},dispose:()=>{G||(this.q.trace(`NotebookController[${L}], DISPOSED`),G=!0,this.j.delete(L),W.dispose(),F.dispose(),this.a.$removeKernel(L))},updateNotebookAffinity(re,Pe){Pe===d.NotebookControllerAffinity2.Hidden&&(0,a.$5G)(D,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(L,re.uri,Pe)},onDidReceiveMessage:F.event,postMessage(re,Pe){return(0,a.$5G)(D,"notebookMessaging"),O.a.$postMessage(L,Pe&&O.n.getIdByEditor(Pe),re)},asWebviewUri(re){return(0,a.$5G)(D,"notebookMessaging"),(0,r.$FCb)(re,O.m.remote)}};return this.j.set(L,{extensionId:D.identifier,controller:be,onDidReceiveMessage:F,onDidChangeSelection:W,associatedNotebooks:de}),be}getIdByController(D){for(const[y,S]of this.j)if(S.controller===D)return $(S.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,y){const S=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(S,y);const g={dispose:()=>{this.f.delete(S),k.a.$removeKernelDetectionTask(S)}};return this.f.set(S,g),g}registerKernelSourceActionProvider(D,y,S){const k=this.i++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,b=this;this.h.set(k,S),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,y);let L;return g!==void 0&&(L=S.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.h.delete(k),b.a.$removeKernelSourceActionProvider(k,k),L?.dispose()}}}async $provideKernelSourceActions(D,y){const S=this.h.get(D);if(S){const k=new A.$Vc;return(await S.provideNotebookKernelSourceActions(y)??[]).map(b=>E.NotebookKernelSourceAction.from(b,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,y,S){const k=this.j.get(D);if(k){const g=this.n.getNotebookDocument(p.URI.revive(y));S?k.associatedNotebooks.set(g.uri,!0):k.associatedNotebooks.delete(g.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,g.uri.toString(),S),k.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getNotebookDocument(p.URI.revive(y)),b=[];for(const L of S){const O=g.getCell(L);O&&b.push(O.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,g.uri.toString(),b.length),await k.controller.executeHandler.call(k.controller,b,g.apiNotebook,k.controller)}catch(L){this.q.error(`NotebookController[${D}] execute cells FAILED`,L),console.error(L)}}async $cancelCells(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getNotebookDocument(p.URI.revive(y));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,g.apiNotebook);else for(const b of S){const L=g.getCell(b);L&&this.b.get(L.uri)?.cancel()}if(k.controller.interruptHandler){const b=this.c.get(g.uri);this.c.delete(g.uri),S.length&&Array.isArray(b)&&b.length&&b.forEach(L=>L.dispose())}}async $provideVariables(D,y,S,k,g,b,L){const O=this.j.get(D);if(!O)return;const q=this.n.getNotebookDocument(p.URI.revive(S)),G=O.controller.variableProvider;if(!G)return;let W;if(k!==void 0){if(W=this.s[k],!W)return}else this.s={};const F=g==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,V=G.provideVariables(q.apiNotebook,W,F,b,L);let ce=0;for await(const ge of V){if(L.isCancellationRequested)return;const te={id:this.r++,name:ge.variable.name,value:ge.variable.value,type:ge.variable.type,interfaces:ge.variable.interfaces,language:ge.variable.language,expression:ge.variable.expression,hasNamedChildren:ge.hasNamedChildren,indexedChildrenCount:ge.indexedChildrenCount,extensionId:O.extensionId.value};if(this.s[te.id]=ge.variable,this.a.$receiveVariable(y,te),ce++>=n.$SK)return}}$acceptKernelMessageFromRenderer(D,y,S){const k=this.j.get(D);if(!k)return;const g=this.n.getEditorById(y);k.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(D,y,S){const g=this.n.getNotebookDocument(p.URI.revive(D)).getCell(y);if(g){const b=S?E.NotebookCellExecutionState.to(S):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:g.apiCell,state:b})}}_createNotebookCellExecution(D,y){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const g=new t(y,k,this.a);this.b.set(k.uri,g);const b=g.onDidChangeState(()=>{g.state===i.Resolved&&(g.dispose(),b.dispose(),this.b.delete(k.uri))});return g.asApiObject()}_createNotebookExecution(D,y){const S=this.n.getNotebookDocument(D.uri),k=D.getCells().find(L=>{const O=S.getCellFromApiCell(L);return O&&this.b.has(O.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new f(y,S,this.a),b=g.onDidChangeState(()=>{g.state===m.Resolved&&(g.dispose(),b.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,b]),g.asApiObject()}};e.$fpc=s,e.$fpc=s=Qe([Ve(4,R.$_j)],s);var i;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(i||(i={}));class t extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,y,S){super(),this.m=y,this.n=S,this.b=t.a++,this.c=new T.$me,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new P.$xe),this.h=new l(10,k=>this.s(k)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const y=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new h.$Qw(y))}t(){if(this.f===i.Init)throw new Error("Must call start before modifying cell output");if(this.f===i.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let y=this.m;if(D&&(y=this.m.notebook.getCellFromApiCell(D)),!y)throw new Error("INVALID cell");return y.handle}y(D){return D.map(y=>{const S=d.$YO.ensureUniqueMimeTypes(y.items,!0);return S===y.items?E.NotebookCellOutput.from(y):E.NotebookCellOutput.from({items:S,id:y.id,metadata:y.metadata})})}async z(D,y,S){const k=this.w(y),g=this.y((0,w.$4b)(D));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:S,outputs:g})}async C(D,y,S){return D=d.$YO.ensureUniqueMimeTypes((0,w.$4b)(D),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:D.map(E.NotebookCellOutputItem.from),outputId:y.id,append:S})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(S){D.j=S,D.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(S){if(D.f===i.Resolved||D.f===i.Started)throw new Error("Cannot call start again");D.f=i.Started,D.c.fire(),D.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,k,g){if(D.f===i.Resolved)throw new Error("Cannot call resolve twice");D.f=i.Resolved,D.c.fire(),D.h.flush();const b=g?{message:g.message,stack:g.stack,location:g?.location?{startLineNumber:g.location.start.line,startColumn:g.location.start.character,endLineNumber:g.location.end.line,endColumn:g.location.end.character}:void 0,uri:g.uri}:void 0;D.n.$completeExecution(D.b,new h.$Qw({runEndTime:k,lastRunSuccess:S,error:b}))},clearOutput(S){return D.t(),D.z([],S,!1)},appendOutput(S,k){return D.t(),D.z(S,k,!0)},replaceOutput(S,k){return D.t(),D.z(S,k,!1)},appendOutputItems(S,k){return D.t(),D.C(S,k,!0)},replaceOutputItems(S,k){return D.t(),D.C(S,k,!1)}})}}var m;(function(I){I[I.Init=0]="Init",I[I.Started=1]="Started",I[I.Resolved=2]="Resolved"})(m||(m={}));class f extends A.$Wc{static{this.a=0}get state(){return this.f}constructor(D,y,S){super(),this.h=y,this.j=S,this.b=f.a++,this.c=new T.$me,this.onDidChangeState=this.c.event,this.f=m.Init,this.g=this.B(new P.$xe),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===m.Resolved||this.f===m.Started)throw new Error("Cannot call start again");this.f=m.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===m.Resolved)throw new Error("Cannot call resolve twice");this.f=m.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(D,y){this.f=D,this.g=y,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new C.$3h,this.b=Date.now(),(0,C.$Gh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>D.complete())}}function $(I,D){return`${I.value}/${D}`}}),define(Ce[57],Ie([1,0,4,6,3,2,17,5,7,188,14,219,22,37,220,221,35,11,10,34,38]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=e.$noc=e.$moc=e.$loc=void 0,e.$loc=(0,P.$Fi)("IExtHostTerminalService");class i extends N.$Wc{constructor(g,b,L,O){super(),this.u=g,this._id=b,this.w=L,this.y=O,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new w.$me),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(G=>this.g=G);const q=this;this.value={get name(){return q.y||""},get processId(){return q.b},get creationOptions(){return q.w},get exitStatus(){return q.j},get state(){return q.m},get selection(){return q.n},get shellIntegration(){return q.shellIntegration},sendText(G,W=!0){q.C(),q.u.$sendText(q._id,G,W)},show(G){q.C(),q.u.$show(q._id,G)},hide(){q.C(),q.u.$hide(q._id)},dispose(){q.a||(q.a=!0,q.u.$dispose(q._id))},get dimensions(){if(!(q.f===void 0||q.h===void 0))return{columns:q.f,rows:q.h}}}}dispose(){this.s.fire(),super.dispose()}async create(g,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??b?.cwd??void 0,env:g.env??void 0,icon:D(g.iconPath)??void 0,color:o.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(g.location,b?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,b,L,O,q){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:O,color:o.ThemeColor.isThemeColor(q)?q.id:void 0,location:b?.location||this.z(g,L),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(g,b){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in g?{viewColumn:h.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.y=g}setExitStatus(g,b){this.j=Object.freeze({code:g,reason:b})}setDimensions(g,b){return g===this.f&&b===this.h||g===0||b===0?!1:(this.f=g,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(g){this.n=g}_setProcessId(g){this.g?(this.g(g),this.g=void 0):this.b.then(b=>{b!==g&&(this.b=Promise.resolve(g))})}}e.$moc=i;class t{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new w.$me,this.onProcessData=this.a.event,this.b=new w.$me,this.d=new w.$me,this.onDidChangeProperty=this.d.event,this.f=new w.$me,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,b){this.g.setDimensions?.({columns:g,rows:b})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let m=1,f=class extends N.$Wc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,b,L){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new N.$Xc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new w.$me,this.onDidCloseTerminal=this.H.event,this.I=new w.$me,this.onDidOpenTerminal=this.I.event,this.J=new w.$me,this.onDidChangeActiveTerminal=this.J.event,this.L=new w.$me,this.onDidChangeTerminalDimensions=this.L.event,this.M=new w.$me,this.onDidChangeTerminalState=this.M.event,this.N=new w.$me,this.onDidChangeShell=this.N.event,this.O=new w.$me({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new w.$me({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=L.getProxy(C.$qN.MainThreadTerminalService),this.y=new r.$Zwb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:O=>{const q=G=>{const W=G;return this.getTerminalById(W.instanceId)?.value};switch(O?.$mid){case s.MarshalledId.TerminalContext:return q(O);default:{if(Array.isArray(O))for(let G=0;G<O.length&&O[G].$mid===s.MarshalledId.TerminalContext;G++)O[G]=q(O[G]);return O}}}}),this.B({dispose:()=>{for(const[O,q]of this.g)q.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,b){const L=new i(this.a,(0,E.$2g)(),g,g.name),O=new t(g.pty);return L.createExtensionTerminal(g.location,b,this.R(g,b).resolvedExtHostIdentifier,D(g.iconPath),y(g.color)).then(q=>{const G=this.S(q,O);this.h[q]=G}),this.f.push(L),L.value}R(g,b){if(b=b||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const L=g.location.parentTerminal;if(L){const O=this.f.find(q=>q.value===L);O&&(b.resolvedExtHostIdentifier=O._id)}}else g.location&&typeof g.location!="object"?b.location=g.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(g,b){if(!this.getTerminalById(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const O=new t(b),q=this.S(g,O);this.h[g]=q}async $acceptActiveTerminalChanged(g){const b=this.b;if(g===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const L=this.getTerminalById(g);L&&(this.b=L,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,b){const L=this.getTerminalById(g);L&&this.O.fire({terminal:L.value,data:b})}async $acceptTerminalDimensions(g,b,L){const O=this.getTerminalById(g);O&&O.setDimensions(b,L)&&this.L.fire({terminal:O.value,dimensions:O.value.dimensions})}async $acceptDidExecuteCommand(g,b){const L=this.getTerminalById(g);L&&this.P.fire({terminal:L.value,...b})}async $acceptTerminalMaximumDimensions(g,b,L){this.g.get(g)?.resize(b,L)}async $acceptTerminalTitleChange(g,b){const L=this.getTerminalById(g);L&&(L.name=b)}async $acceptTerminalClosed(g,b,L){const O=this.X(this.f,g);if(O!==null){const q=this.f.splice(O,1)[0];q.setExitStatus(b,L),this.H.fire(q.value)}}$acceptTerminalOpened(g,b,L,O){if(b){const W=this.X(this.f,b);if(W!==null){this.f[W]._id=g,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const q={name:O.name,shellPath:O.executable,shellArgs:O.args,cwd:typeof O.cwd=="string"?O.cwd:T.URI.revive(O.cwd),env:O.env,hideFromUser:O.hideFromUser},G=new i(this.a,g,q,L);this.f.push(G),this.I.fire(G.value),G.isOpen=!0}async $acceptTerminalProcessId(g,b){this.getTerminalById(g)?._setProcessId(b)}async $startExtensionTerminal(g,b){const L=this.getTerminalById(g);if(!L)return{message:(0,c.localize)(0,null,g)};L.isOpen||await new Promise(q=>{const G=this.onDidOpenTerminal(async W=>{W===L.value&&(G.dispose(),q())})});const O=this.g.get(g);O?O.startSendingEvents(b):this.j[g]={initialDimensions:b}}S(g,b){const L=new N.$Vc;L.add(b.onProcessReady(q=>this.a.$sendProcessReady(g,q.pid,q.cwd,q.windowsPty))),L.add(b.onDidChangeProperty(q=>this.a.$sendProcessProperty(g,q))),this.y.startBuffering(g,b.onProcessData),L.add(b.onProcessExit(q=>this.U(g,q))),this.g.set(g,b);const O=this.j[g];return O&&b instanceof t&&(b.startSendingEvents(O.initialDimensions),delete this.j[g]),L}$acceptProcessAckDataEvent(g,b){this.g.get(g)?.acknowledgeDataEvent(b)}$acceptProcessInput(g,b){this.g.get(g)?.input(b)}$acceptTerminalInteraction(g){const b=this.getTerminalById(g);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(g,b){this.getTerminalById(g)?.setSelection(b)}$acceptProcessResize(g,b,L){try{this.g.get(g)?.resize(b,L)}catch(O){if(O.code!=="EPIPE"&&O.code!=="ERR_IPC_CHANNEL_CLOSED")throw O}}$acceptProcessShutdown(g,b){this.g.get(g)?.shutdown(b)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(b=>this.a.$sendProcessProperty(g,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new p.$sN(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,b,L){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,L),this.a.$registerProfileProvider(b,g.identifier.value),new p.$sN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(g,b,L){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,L),this.a.$registerQuickFixProvider(g,b),new p.$sN(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,b){const L=new u.$xe().token;if(L.isCancellationRequested)return;const O=this.D.get(g);if(!O)return;const q=await O.provideTerminalQuickFixes(b,L);if(q===null||Array.isArray(q)&&q.length===0)return;const G=new N.$Vc;if(this.w.value=G,!Array.isArray(q))return q?h.TerminalQuickFix.from(q,this.Q.converter,G):void 0;const W=[];for(const F of q){const V=h.TerminalQuickFix.from(F,this.Q.converter,G);V&&W.push(V)}return W}async $createContributedProfileTerminal(g,b){const L=new u.$xe().token;let O=await this.C.get(g)?.provideTerminalProfile(L);if(!L.isCancellationRequested){if(O&&!("options"in O)&&(O={options:O}),!O||!("options"in O))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in O.options){this.createExtensionTerminal(O.options,b);return}this.createTerminalFromOptions(O.options,b)}}async $provideLinks(g,b){const L=this.getTerminalById(g);if(!L)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const q=new u.$xe;this.G.set(g,q);const G=[],W={terminal:L.value,line:b},F=[];for(const ge of this.z)F.push(a.Promises.withAsyncBody(async te=>{q.token.onCancellationRequested(()=>te({provider:ge,links:[]}));const me=await ge.provideTerminalLinks(W,q.token)||[];q.token.isCancellationRequested||te({provider:ge,links:me})}));const V=await Promise.all(F);if(q.token.isCancellationRequested)return[];const ce=new Map;for(const ge of V)ge&&ge.links.length>0&&G.push(...ge.links.map(te=>{const me={id:m++,startIndex:te.startIndex,length:te.length,label:te.tooltip};return ce.set(me.id,{provider:ge.provider,link:te}),me}));return this.F.set(g,ce),G}$activateLink(g,b){const L=this.F.get(g)?.get(b);L&&L.provider.handleTerminalLink(L.link)}U(g,b){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const L=this.h[g];L&&(L.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,b)}getTerminalById(g){return this.W(this.f,g)}getTerminalIdByApiObject(g){const b=this.f.findIndex(L=>L.value===g);return b>=0?b:null}W(g,b){const L=this.X(g,b);return L!==null?g[L]:null}X(g,b){const L=g.findIndex(O=>O._id===b);return L>=0?L:null}getEnvironmentVariableCollection(g){let b=this.n.get(g.identifier.value);return b||(b=this.B(new l),this.Z(g.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(g,b){const L=(0,v.$zs)(b.map),O=(0,v.$As)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(g,b.persistent,L.length===0?void 0:L,O)}$initEnvironmentVariableCollections(g){g.forEach(b=>{const L=b[0],O=this.B(new l(b[1]));this.Z(L,O)})}$acceptDefaultProfile(g,b){const L=this.s;this.s=g,this.u=b,L?.path!==g.path&&this.N.fire(g.path)}Z(g,b){this.n.set(g,b),this.B(b.onDidChangeCollection(()=>{this.Y(g,b)}))}};e.$noc=f,e.$noc=f=Qe([Ve(1,n.$gQ),Ve(2,A.$WP)],f);class l extends N.$Wc{get persistent(){return this.b}set persistent(g){this.b=g,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(g){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new w.$me,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const b=this.j(g);let L=this.a.get(b);return L||(L=new $(this,g),this.a.set(b,L),this.B(L.onDidChangeCollection(()=>this.f.fire()))),L}replace(g,b,L,O){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:L??{applyAtProcessCreation:!0},scope:O})}append(g,b,L,O){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:L??{applyAtProcessCreation:!0},scope:O})}prepend(g,b,L,O){this.g(g,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:L??{applyAtProcessCreation:!0},scope:O})}g(g,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const L=this.h(g,b.scope),O=this.map.get(L),q=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!O||O.value!==b.value||O.type!==b.type||O.options?.applyAtProcessCreation!==q.applyAtProcessCreation||O.options?.applyAtShellIntegration!==q.applyAtShellIntegration||O.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const G=this.h(g,b.scope),W={variable:g,...b,options:q};this.map.set(G,W),this.f.fire()}}get(g,b){const L=this.h(g,b),O=this.map.get(L);return O?S(O):void 0}h(g,b){const L=this.j(b);return L.length?`${g}:::${L}`:g}j(g){return this.m(g?.workspaceFolder)??""}m(g){return g?g.uri.toString():void 0}getVariableMap(g){const b=new Map;for(const[L,O]of this.map)this.j(O.scope)===this.j(g)&&b.set(O.variable,S(O));return b}delete(g,b){const L=this.h(g,b);this.map.delete(L),this.f.fire()}clear(g){if(g?.workspaceFolder){for(const[b,L]of this.map)L.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(b);this.n(g)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(g,b){const L=this.j(b),O=this.descriptionMap.get(L);if(!O||O.description!==g){let q;typeof g=="string"?q=g:q=g?.value.split(`

`)[0];const G={description:q,scope:b};this.descriptionMap.set(L,G),this.f.fire()}}getDescription(g){const b=this.j(g);return this.descriptionMap.get(b)?.description}n(g){const b=this.j(g);this.descriptionMap.delete(b)}}class ${get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,b){this.b=g,this.d=b,this.a=new w.$me}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,b,L){this.b.replace(g,b,L,this.d)}append(g,b,L){this.b.append(g,b,L,this.d)}prepend(g,b,L){this.b.prepend(g,b,L,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,b){this.b.getVariableMap(this.d).forEach((L,O)=>g.call(b,O,L,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let I=class extends f{constructor(g,b){super(!1,g,b)}createTerminal(g,b,L){throw new R.$bb}createTerminalFromOptions(g,b){throw new R.$bb}};e.$ooc=I,e.$ooc=I=Qe([Ve(0,n.$gQ),Ve(1,A.$WP)],I);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function y(k){return o.ThemeColor.isThemeColor(k)?k:void 0}function S(k){const g={...k};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Ce[125],Ie([1,0,7,5,3,6,17,57,4,2,11]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=void 0,e.$xpc=(0,P.$Fi)("IExtHostTerminalShellIntegration");let v=class extends C.$Wc{constructor(o,a){super(),this.h=a,this.b=new Map,this.c=new p.$me,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$me,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$me,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(T.$qN.MainThreadTerminalShellIntegration),this.B((0,C.$Uc)(()=>{for(const[h,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const a=this.h.getTerminalById(o);if(!a)return;const h=a.value;let n=this.b.get(o);n||(n=new u(a.value,this.f),this.b.set(o,n),n.store.add(a.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),n.store.add(n.onDidRequestEndExecution(s=>this.g.fire(s))),n.store.add(n.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),a.shellIntegration=n.value),this.c.fire({terminal:h,shellIntegration:n.value})}$shellExecutionStart(o,a,h,n,s){this.b.has(o)||this.$shellIntegrationChange(o);const i={value:a,confidence:h,isTrusted:n};this.b.get(o)?.startShellExecution(i,s)}$shellExecutionEnd(o,a,h,n,s){const i={value:a,confidence:h,isTrusted:n};this.b.get(o)?.endShellExecution(i,s)}$shellExecutionData(o,a){this.b.get(o)?.emitData(a)}$cwdChange(o,a){this.b.get(o)?.setCwd((0,c.$xc)(a)?c.URI.revive(a):a)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$ypc=v,e.$ypc=v=Qe([Ve(0,A.$WP),Ve(1,N.$loc)],v);class u extends C.$Wc{get currentExecution(){return this.a}constructor(o,a){super(),this.j=o,this.m=a,this.b=!1,this.store=this.B(new C.$Vc),this.f=this.B(new p.$me),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$me),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$me),this.onDidRequestEndExecution=this.h.event;const h=this;this.value={get cwd(){return h.c},executeCommand(n,s){let i=n;s&&(i+=` "${s.map(f=>`${f.replaceAll('"','\\"')}`).join('" "')}"`),h.g.fire(i);const t={value:i,confidence:w.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},m=h.startShellExecution(t,h.c,!0).value;return h.b=!0,m}}}startShellExecution(o,a,h){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new E(o,a);h?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,a){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:a}),this.a=void 0)}setCwd(o){let a=!1;c.URI.isUri(this.c)?a=!c.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(a=!0),a&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class E{constructor(o,a){this.c=o,this.cwd=a,this.b=!1;const h=this;this.value={get commandLine(){return h.c},get cwd(){return h.cwd},read(){return h.d()}}}d(){if(!this.a){if(this.b)return R.$6h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends C.$Wc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new R.$Eh);const o=this.a;return new R.$6h(async h=>{this.b.push(h),await o.wait()})}emitData(o){for(const a of this.b)a.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[126],Ie([1,0,62,14,97,10,7]),function(oe,e,w,C,P,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=e.$4P=void 0,T=qe(T);class N{static{this.c=new P.$2P("TextEditorDecorationType")}constructor(u,E,d){const r=N.c.nextId();u.$registerTextEditorDecorationType(E.identifier,r,T.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$4P=N;class p{constructor(u,E){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,E){this.k();let d=null;if(u instanceof A.$tN)d=new A.$uN(u,u);else if(u instanceof A.$uN)d=u;else throw new Error("Unrecognized location");this.l(d,E,!1)}insert(u,E){this.k(),this.l(new A.$uN(u,u),E,!0)}delete(u){this.k();let E=null;if(u instanceof A.$uN)E=u;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(u,E,d){const r=this.c.validateRange(u);this.g.push({range:r,text:E,forceMoveMarkers:d})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,C.$9)("endOfLine");this.h=u}}class c{constructor(u,E,d,r){this.c=u,this.d=E,this._accept(d),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(a){o.n(a)},get indentSize(){return o.g},set indentSize(a){o.p(a)},get insertSpaces(){return o.j},set insertSpaces(a){o.s(a)},get cursorStyle(){return o.k},set cursorStyle(a){o.t(a)},get lineNumbers(){return o.l},set lineNumbers(a){o.u(a)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}n(u){const E=this.m(u);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const E=Math.floor(u);return E>0?E:null}if(typeof u=="string"){const E=parseInt(u,10);return isNaN(E)?null:E>0?E:null}return null}p(u){const E=this.o(u);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const E=this.q(u);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(u)})))}assign(u){const E={};let d=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(d=!0,E.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,E.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(d=!0,E.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,E.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(d=!0,E.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,E.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,d=!0,E.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,d=!0,E.lineNumbers=T.TextEditorLineNumbersStyle.from(u.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(u,E){E.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(d)})}}e.$5P=c;class R{constructor(u,E,d,r,o,a,h,n){this.id=u,this.j=E,this.k=d,this.g=!1,this.h=new Set,this.c=o,this.d=new c(this.j,this.id,a,d),this.e=h,this.f=n;const s=this;this.value=Object.freeze({get document(){return r.value},set document(i){throw new C.$$("document")},get selection(){return s.c&&s.c[0]},set selection(i){if(!(i instanceof A.$vN))throw(0,C.$9)("selection");s.c=[i],s.l()},get selections(){return s.c},set selections(i){if(!Array.isArray(i)||i.some(t=>!(t instanceof A.$vN)))throw(0,C.$9)("selections");s.c=i,s.l()},get visibleRanges(){return s.e},set visibleRanges(i){throw new C.$$("visibleRanges")},get options(){return s.d.value},set options(i){s.g||s.d.assign(i)},get viewColumn(){return s.f},set viewColumn(i){throw new C.$$("viewColumn")},edit(i,t={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const m=new p(r.value,t);return i(m),s.m(m)},insertSnippet(i,t,m={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let f;if(!t||Array.isArray(t)&&t.length===0)f=s.c.map(l=>T.Range.from(l));else if(t instanceof A.$tN){const{lineNumber:l,column:$}=T.Position.from(t);f=[{startLineNumber:l,startColumn:$,endLineNumber:l,endColumn:$}]}else if(t instanceof A.$uN)f=[T.Range.from(t)];else{f=[];for(const l of t)if(l instanceof A.$uN)f.push(T.Range.from(l));else{const{lineNumber:$,column:I}=T.Position.from(l);f.push({startLineNumber:$,startColumn:I,endLineNumber:$,endColumn:I})}}return E.$tryInsertSnippet(u,r.value.version,i.value,f,m)},setDecorations(i,t){const m=t.length===0;m&&!s.h.has(i.key)||(m?s.h.delete(i.key):s.h.add(i.key),s.n(()=>{if(T.$TP(t))return E.$trySetDecorations(u,i.key,T.$UP(t));{const f=new Array(4*t.length);for(let l=0,$=t.length;l<$;l++){const I=t[l];f[4*l]=I.start.line+1,f[4*l+1]=I.start.character+1,f[4*l+2]=I.end.line+1,f[4*l+3]=I.end.character+1}return E.$trySetDecorationsFast(u,i.key,f)}}))},revealRange(i,t){s.n(()=>E.$tryRevealRange(u,T.Range.from(i),t||A.TextEditorRevealType.Default))},show(i){E.$tryShowEditor(u,T.ViewColumn.from(i))},hide(){E.$tryHideEditor(u)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,w.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,w.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,w.ok)(!this.g),this.f=u}_acceptSelections(u){(0,w.ok)(!this.g),this.c=u}async l(){const u=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const E=u.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const d=E.edits.map(o=>o.range);d.sort((o,a)=>o.end.line===a.end.line?o.end.character===a.end.character?o.start.line===a.start.line?o.start.character-a.start.character:o.start.line-a.start.line:o.end.character-a.end.character:o.end.line-a.end.line);for(let o=0,a=d.length-1;o<a;o++){const h=d[o].end;if(d[o+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=E.edits.map(o=>({range:T.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,r,{setEndOfLine:typeof E.setEndOfLine=="number"?T.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$6P=R}),define(Ce[58],Ie([1,0,62,4,5,2,3,6,122,17,126,10,12,29,16,40,47]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0,w=qe(w),v=qe(v);class a{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=class{constructor(s,i){this.h=s,this.i=i,this.a=null,this.b=new Map,this.c=new E.$Cc,this.d=new C.$me,this.e=new C.$me,this.f=new C.$me,this.g=new C.$me,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const i=[],t=[],m=[];if(s.removedDocuments)for(const f of s.removedDocuments){const l=T.URI.revive(f),$=this.c.get(l);$?.unref()&&(this.c.delete(l),i.push($.value))}if(s.addedDocuments)for(const f of s.addedDocuments){const l=T.URI.revive(f.uri);let $=this.c.get(l);if($&&l.scheme!==d.Schemas.vscodeNotebookCell&&l.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);$||($=new a(new p.$ZP(this.h.getProxy(N.$qN.MainThreadDocuments),l,f.lines,f.EOL,f.versionId,f.languageId,f.isDirty)),this.c.set(l,$),t.push($.value)),$.ref()}if(s.removedEditors)for(const f of s.removedEditors){const l=this.b.get(f);this.b.delete(f),l&&m.push(l)}if(s.addedEditors)for(const f of s.addedEditors){const l=T.URI.revive(f.documentUri);w.ok(this.c.has(l),`document '${l}' does not exist`),w.ok(!this.b.has(f.id),`editor '${f.id}' already exists!`);const $=this.c.get(l).value,I=new R.$6P(f.id,this.h.getProxy(N.$qN.MainThreadTextEditors),this.i,new o.$X(()=>$.document),f.selections.map(v.Selection.to),f.options,f.visibleRanges.map(D=>v.Range.to(D)),typeof f.editorPosition=="number"?v.ViewColumn.to(f.editorPosition):void 0);this.b.set(f.id,I)}s.newActiveEditor!==void 0&&(w.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,P.$Rc)(i),(0,P.$Rc)(m),s.removedDocuments&&this.e.fire(i),s.addedDocuments&&this.d.fire(t),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(f=>f.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const i=this.b.get(this.a);return s?i:i?.value}allEditors(){return[...this.b.values()]}};e.$7P=h,e.$7P=h=Qe([Ve(0,c.$WP),Ve(1,u.$_j)],h),e.$8P=(0,A.$Fi)("IExtHostDocumentsAndEditors")}),define(Ce[96],Ie([1,0,11,23,22,4,273,76,5,38,15,37,3,12,6,34,58,17,124,10,7,241,55,82,56,25]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=e.$Hoc=e.$Goc=e.$Foc=void 0,n=qe(n);let $=0;const I=new WeakMap;e.$Foc=(0,u.$Fi)("IExtHostTesting");let D=class extends p.$Wc{constructor(te,me,se,de){super(),this.C=me,this.D=se,this.F=de,this.f=this.B(new T.$me),this.g=new Map,this.w=this.B(new T.$me),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=te.getProxy(d.$qN.MainThreadTesting),this.m=new G(this.h),this.j=new g(this.h,me),se.registerArgumentProcessor({processArgument:be=>{switch(be?.$mid){case c.MarshalledId.TestItemContext:{const re=be,Pe=re.tests[re.tests.length-1].item.extId;return this.g.get(t.$PI.root(Pe))?.collection.tree.get(Pe)?.actual??(0,h.$9P)(be)}case c.MarshalledId.TestMessageMenuArgs:{const{test:re,message:Pe}=be,Le=re.item.extId;return{test:this.g.get(t.$PI.root(Le))?.collection.tree.get(Le)?.actual??(0,h.$9P)({$mid:c.MarshalledId.TestItemContext,tests:[re]}),message:n.TestMessage.to(Pe)}}default:return be}}}),se.registerCommand(!1,"testing.getExplorerSelection",async()=>{const be=await se.executeCommand(i.TestCommandId.GetExplorerSelection),re=Pe=>{const Le=this.g.get(t.$PI.root(Pe));if(Le)return t.$PI.isRoot(Pe)?Le.controller:Le.collection.tree.get(Pe)?.actual};return{include:be?.include.map(re).filter(R.$ng)||[],exclude:be?.exclude.map(re).filter(R.$ng)||[]}})}createTestController(te,me,se,de){if(this.g.has(me))throw new Error(`Attempt to insert a duplicate controller with ID "${me}"`);const be=new p.$Vc,re=be.add(new h.$_P(me,se,this.F));re.root.label=se;const Pe=new Map,Le=new Set,Y=this.h,B={items:re.root.children,get label(){return se},set label(ve){se=ve,re.root.label=ve,Y.$updateController(me,{label:se})},get refreshHandler(){return de},set refreshHandler(ve){de=ve,Y.$updateController(me,{canRefresh:!!ve})},get id(){return me},createRunProfile:(ve,ae,we,le,X,Z)=>{let pe=(0,N.$tj)(ve);for(;Pe.has(pe);)pe++;return new F(this.h,Pe,Le,this.w.event,me,pe,ve,ae,we,le,X,Z)},createTestItem(ve,ae,we){return new h.$0P(me,ve,ae,we)},createTestRun:(ve,ae,we=!0)=>this.j.createTestRun(te,me,re,ve,ae,we),invalidateTestResults:ve=>{if(ve===void 0)this.h.$markTestRetired(void 0);else{const ae=ve instanceof Array?ve:[ve];this.h.$markTestRetired(ae.map(we=>t.$PI.fromExtHostTestItem(we,me).toString()))}},set resolveHandler(ve){re.resolveHandler=ve},get resolveHandler(){return re.resolveHandler},dispose:()=>{be.dispose()}};Y.$registerTestController(me,se,!!de),be.add((0,p.$Uc)(()=>Y.$unregisterTestController(me)));const _={controller:B,collection:re,profiles:Pe,extension:te,activeProfiles:Le};return this.g.set(me,_),be.add((0,p.$Uc)(()=>this.g.delete(me))),be.add(re.onDidGenerateDiff(ve=>Y.$publishDiff(me,ve.map(f.TestsDiffOp.serialize)))),B}createTestObserver(){return this.m.checkout()}async runTests(te,me=P.CancellationToken.None){const se=b(te);if(!se)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const de=this.g.get(se.controllerId);if(!de)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:te.preserveFocus??!0,group:V[se.kind],targets:[{testIds:te.include?.map(be=>t.$PI.fromExtHostTestItem(be,de.collection.root.id).toString())??[de.collection.root.id],profileId:se.profileId,controllerId:se.controllerId}],exclude:te.exclude?.map(be=>be.id)},me)}registerTestFollowupProvider(te){return this.y.add(te),{dispose:()=>{this.y.delete(te)}}}$syncTests(){for(const{collection:te}of this.g.values())te.flushDiff();return Promise.resolve()}async $getCoverageDetails(te,me,se){return(await this.j.getCoverageDetails(te,me,se))?.map(n.TestCoverage.fromDetails)}async $disposeRun(te){this.j.disposeTestRun(te)}$configureRunProfile(te,me){this.g.get(te)?.profiles.get(me)?.configureHandler?.()}$setDefaultRunProfiles(te){const me=new Map;for(const[se,de]of Object.entries(te)){const be=this.g.get(se);if(!be)continue;const re=new Map,Pe=de.filter(Y=>!be.activeProfiles.has(Y)),Le=[...be.activeProfiles].filter(Y=>!de.includes(Y));for(const Y of Pe)re.set(Y,!0),be.activeProfiles.add(Y);for(const Y of Le)re.set(Y,!1),be.activeProfiles.delete(Y);re.size&&me.set(se,re)}this.w.fire(me)}async $refreshTests(te,me){await this.g.get(te)?.controller.refreshHandler?.(me)}$publishTestResults(te){this.results=Object.freeze(te.map(me=>{const se=n.TestResults.to(me);return I.set(se,me.id),se}).concat(this.results).sort((me,se)=>se.completedAt-me.completedAt).slice(0,32)),this.f.fire()}async $expandTest(te,me){const se=this.g.get(t.$PI.fromString(te).controllerId)?.collection;se&&(await se.expand(te,me<0?1/0:me),se.flushDiff())}$acceptDiff(te){this.m.applyDiff(te.map(me=>f.TestsDiffOp.deserialize({asCanonicalUri:se=>se},me)))}async $runControllerTests(te,me){return Promise.all(te.map(se=>this.G(se,!1,me)))}async $startContinuousRun(te,me){const se=new P.$xe(me),de=await Promise.all(te.map(be=>this.G(be,!0,se.token)));return!me.isCancellationRequested&&!de.some(be=>be.error)&&await new Promise(be=>me.onCancellationRequested(be)),se.dispose(!0),de}async $provideTestFollowups(te,me){const se=this.results.find(re=>I.get(re)===te.resultId),de=se&&ce(t.$PI.fromString(te.extId),se?.results);if(!de)return[];let be=[];return await Promise.all([...this.y].map(async re=>{try{const Pe=await re.provideFollowup(se,de,te.taskIndex,te.messageIndex,me);Pe&&(be=be.concat(Pe))}catch(Pe){this.C.error("Error thrown while providing followup for test message",Pe)}})),me.isCancellationRequested?[]:be.map(re=>{const Pe=$++;return this.z.set(Pe,re),{title:re.title,id:Pe}})}$disposeTestFollowups(te){for(const me of te)this.z.delete(me)}$executeTestFollowup(te){const me=this.z.get(te);return me?this.D.executeCommand(me.command,...me.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(te){te===void 0?this.j.cancelAllRuns():this.j.cancelRunById(te)}getMetadataForRun(te){for(const me of this.j.trackers){const se=me.getTaskIdForRun(te);if(se)return{taskId:se,runId:me.id}}}async G(te,me,se){const de=this.g.get(te.controllerId);if(!de)return{};const{collection:be,profiles:re,extension:Pe}=de,Le=re.get(te.profileId);if(!Le)return{};const Y=te.testIds.map(ae=>be.tree.get(ae)).filter(R.$ng),B=te.excludeExtIds.map(ae=>de.collection.tree.get(ae)).filter(R.$ng).filter(ae=>Y.some(we=>we.fullId.compare(ae.fullId)===t.TestPosition.IsChild));if(!Y.length)return{};const _=new s.$6O(Y.some(ae=>ae.actual instanceof h.$$P)?void 0:Y.map(ae=>ae.actual),B.map(ae=>ae.actual),Le,me),ve=(0,f.$SI)(te)&&this.j.prepareForMainThreadTestRun(Pe,_,L.fromInternal(te,de.collection),Le,se);try{return await Le.runHandler(_,se),{}}catch(ae){return{error:String(ae)}}finally{ve&&ve.hasRunningTasks&&!se.isCancellationRequested&&await T.Event.toPromise(ve.onEnd)}}};e.$Goc=D,e.$Goc=D=Qe([Ve(0,a.$WP),Ve(1,E.$_j),Ve(2,r.$gQ),Ve(3,o.$8P)],D);const y=1e4;var S;(function(ge){ge[ge.Running=0]="Running",ge[ge.Cancelling=1]="Cancelling",ge[ge.Ended=2]="Ended"})(S||(S={}));class k extends p.$Wc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(te,me,se,de,be,re){super(),this.z=te,this.C=me,this.D=se,this.F=de,this.G=be,this.c=S.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$me),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$xe(re));const Pe=this.B(new w.$Rh(()=>this.H(),y));this.B(this.j.token.onCancellationRequested(()=>Pe.schedule()));const Le=new T.$me;this.w=Le.event,this.B((0,p.$Uc)(()=>{Le.fire(),Le.dispose()}))}getTaskIdForRun(te){for(const[me,{run:se}]of this.g)if(se===te)return me}cancel(){this.c===S.Running?(this.j.cancel(),this.c=S.Cancelling):this.c===S.Cancelling&&this.H()}getCoverageDetails(te,me,se){const[,de]=t.$PI.fromString(te).path,be=this.y.get(te);if(!be)return[];const{report:re,extIds:Pe}=be,Le=this.g.get(de);if(!Le)throw new Error("unreachable: run task was not found");let Y;if(me&&re instanceof s.$$O){const B=Pe.indexOf(me);if(B===-1)return[];Y=re.fromTests[B]}return this.F?.loadDetailedCoverage?.(Le.run,re,se,Y)??[]}createRun(te){const me=this.z.id,se=this.z.controllerId,de=(0,v.$2g)(),be=Y=>(B,..._)=>{if(Pe){this.D.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}this.J(B),Y(B,..._)},re=(Y,B)=>{const _=B instanceof Array?B.map(n.TestMessage.from):[n.TestMessage.from(B)];if(Y.uri&&Y.range){const ve={range:n.Range.from(Y.range),uri:Y.uri};for(const ae of _)ae.location=ae.location||ve}this.C.$appendTestMessagesInRun(me,de,t.$PI.fromExtHostTestItem(Y,se).toString(),_)};let Pe=!1;const Le={isPersisted:this.z.isPersisted,token:this.j.token,name:te,onDidDispose:this.w,addCoverage:Y=>{if(Pe)return;const B=Y instanceof s.$$O?Y.fromTests:[];if(B.length){(0,l.$5G)(this.G,"attributableCoverage");for(const ae of B)this.J(ae)}const _=Y.uri.toString(),ve=new t.$PI([me,de,_]).toString();this.y.set(ve,{report:Y,extIds:B.map(ae=>t.$PI.fromExtHostTestItem(ae,se).toString())}),this.C.$appendCoverage(me,de,n.TestCoverage.fromFile(se,ve,Y))},enqueued:be(Y=>{this.C.$updateTestStateInRun(me,de,t.$PI.fromExtHostTestItem(Y,se).toString(),f.TestResultState.Queued)}),skipped:be(Y=>{this.C.$updateTestStateInRun(me,de,t.$PI.fromExtHostTestItem(Y,se).toString(),f.TestResultState.Skipped)}),started:be(Y=>{this.C.$updateTestStateInRun(me,de,t.$PI.fromExtHostTestItem(Y,se).toString(),f.TestResultState.Running)}),errored:be((Y,B,_)=>{re(Y,B),this.C.$updateTestStateInRun(me,de,t.$PI.fromExtHostTestItem(Y,se).toString(),f.TestResultState.Errored,_)}),failed:be((Y,B,_)=>{re(Y,B),this.C.$updateTestStateInRun(me,de,t.$PI.fromExtHostTestItem(Y,se).toString(),f.TestResultState.Failed,_)}),passed:be((Y,B)=>{this.C.$updateTestStateInRun(me,de,t.$PI.fromExtHostTestItem(Y,this.z.controllerId).toString(),f.TestResultState.Passed,B)}),appendOutput:(Y,B,_)=>{Pe||(_&&this.J(_),this.C.$appendOutputToRun(me,de,C.$Oe.fromString(Y),B&&n.location.from(B),_&&t.$PI.fromExtHostTestItem(_,se).toString()))},end:()=>{Pe||(Pe=!0,this.C.$finishedTestRunTask(me,de),--this.f||this.I())}};return this.f++,this.g.set(de,{run:Le}),this.C.$startedTestRunTask(me,{id:de,name:te,running:!0}),Le}H(){for(const{run:te}of this.g.values())te.end()}I(){this.c!==S.Ended&&(this.c=S.Ended,this.m.fire())}J(te){if(!(te instanceof h.$0P))throw new m.$OP(te.id);if(this.h.has(t.$PI.fromExtHostTestItem(te,this.z.controllerId).toString()))return;const me=[],se=this.z.colllection.root;for(;;){const de=n.TestItem.from(te);if(me.unshift(de),this.h.has(de.extId)||(this.h.add(de.extId),te===se))break;te=te.parent||se}this.C.$addTestsToRun(this.z.controllerId,this.z.id,me)}dispose(){this.I(),super.dispose()}}class g{get trackers(){return this.c.values()}constructor(te,me){this.g=te,this.h=me,this.c=new Map,this.f=new Map}getCoverageDetails(te,me,se){const de=t.$PI.root(te);return this.f.get(de)?.getCoverageDetails(te,me,se)||[]}disposeTestRun(te){this.f.get(te)?.dispose(),this.f.delete(te);for(const[me,{id:se}]of this.c)se===te&&this.c.delete(me)}prepareForMainThreadTestRun(te,me,se,de,be){return this.j(me,se,de,te,be)}cancelRunById(te){this.f.get(te)?.cancel()}cancelAllRuns(){for(const te of this.c.values())te.cancel()}createTestRun(te,me,se,de,be,re){const Pe=this.c.get(de);if(Pe)return Pe.createRun(be);const Le=L.fromPublic(me,se,de,re),Y=b(de);this.g.$startedExtensionTestRun({controllerId:me,continuous:!!de.continuous,profile:Y&&{group:V[Y.kind],id:Y.profileId},exclude:de.exclude?.map(_=>t.$PI.fromExtHostTestItem(_,se.root.id).toString())??[],id:Le.id,include:de.include?.map(_=>t.$PI.fromExtHostTestItem(_,se.root.id).toString())??[se.root.id],preserveFocus:de.preserveFocus??!0,persist:re});const B=this.j(de,Le,de.profile,te);return T.Event.once(B.onEnd)(()=>{this.g.$finishedExtensionTestRun(Le.id)}),B.createRun(be)}j(te,me,se,de,be){const re=new k(me,this.g,this.h,se,de,be);return this.c.set(te,re),this.f.set(re.id,re),re}}e.$Hoc=g;const b=ge=>{if(ge.profile){if(!(ge.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ge.profile}};class L{static fromPublic(te,me,se,de){return new L(te,(0,v.$2g)(),de,me)}static fromInternal(te,me){return new L(te.controllerId,te.runId,!0,me)}constructor(te,me,se,de){this.controllerId=te,this.id=me,this.isPersisted=se,this.colllection=de}}e.$Ioc=L;class O{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(te){this.j=te,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(te){this.c.add(te)}update(te){Object.assign(te.revived,n.TestItem.toPlain(te.item)),this.c.has(te)||this.f.add(te)}remove(te){if(this.c.has(te)){this.c.delete(te);return}this.f.delete(te);const me=t.$PI.parentId(te.item.extId);if(me&&this.h.has(me.toString())){this.h.add(te.item.extId);return}this.g.add(te)}getChangeEvent(){const{c:te,f:me,g:se}=this;return{get added(){return[...te].map(de=>de.revived)},get updated(){return[...me].map(de=>de.revived)},get removed(){return[...se].map(de=>de.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class q extends f.$YI{constructor(){super(...arguments),this.y=new T.$me,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(te){return this.f.get(te)}getMirroredTestDataByReference(te){return this.f.get(te.id)}x(te,me){return{...te,revived:n.TestItem.toPlain(te.item),depth:me?me.depth+1:0,children:new Set}}w(){return new O(this.y)}}class G{constructor(te){this.f=te}checkout(){this.c||(this.c=this.g());const te=this.c;return te.observers++,{onDidChangeTest:te.tests.onDidChangeTests,get tests(){return[...te.tests.rootTests].map(me=>me.revived)},dispose:(0,A.$fb)(()=>{--te.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(te){return this.c?.tests.getMirroredTestDataByReference(te)}applyDiff(te){this.c?.tests.apply(te)}g(){const te=new q({asCanonicalUri:me=>me});return this.f.$subscribeToDiffs(),{observers:0,tests:te}}}const W=(ge,te,me,se)=>{me?Object.assign(me,se):te.$updateTestRunConfig(ge.controllerId,ge.profileId,se)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(te){te!==this.f&&(this.f=te,W(this,this.#e,this.#n,{label:te}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(te){te!==this.g&&(this.g=te,W(this,this.#e,this.#n,{supportsContinuousRun:te}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(te){te!==this.isDefault&&(te?this.#t.add(this.profileId):this.#t.delete(this.profileId),W(this,this.#e,this.#n,{isDefault:te}))}get tag(){return this._tag}set tag(te){te?.id!==this._tag?.id&&(this._tag=te,W(this,this.#e,this.#n,{tag:te?n.TestTag.namespace(this.controllerId,te.id):null}))}get configureHandler(){return this.c}set configureHandler(te){te!==this.c&&(this.c=te,W(this,this.#e,this.#n,{hasConfigurationHandler:!!te}))}get onDidChangeDefault(){return T.Event.chain(this.#i,te=>te.map(me=>me.get(this.controllerId)?.get(this.profileId)).filter(R.$ng))}constructor(te,me,se,de,be,re,Pe,Le,Y,B=!1,_=void 0,ve=!1){this.controllerId=be,this.profileId=re,this.f=Pe,this.kind=Le,this.runHandler=Y,this._tag=_,this.g=ve,this.#e=te,this.#s=me,this.#t=se,this.#i=de,me.set(re,this);const ae=V[Le];if(typeof ae!="number")throw new Error(`Unknown TestRunProfile.group ${Le}`);B&&se.add(re),this.#n={profileId:re,controllerId:be,tag:_?n.TestTag.namespace(this.controllerId,_.id):null,label:Pe,group:ae,isDefault:B,hasConfigurationHandler:!1,supportsContinuousRun:ve},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Joc=F;const V={[s.TestRunProfileKind.Coverage]:f.TestRunProfileBitset.Coverage,[s.TestRunProfileKind.Debug]:f.TestRunProfileBitset.Debug,[s.TestRunProfileKind.Run]:f.TestRunProfileBitset.Run};function ce(ge,te){for(let me=0;me<ge.path.length;me++){const se=te.find(de=>de.id===ge.path[me]);if(!se)return;if(me===ge.path.length-1)return se;te=se.children}}}),define(Ce[300],Ie([1,0,18,4,5,6,126,10,7]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qnc=void 0,w=qe(w),N=qe(N);class c extends P.$Wc{constructor(v,u){super(),this.m=u,this.a=new C.$me,this.b=new C.$me,this.c=new C.$me,this.f=new C.$me,this.g=new C.$me,this.h=new C.$me,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=v.getProxy(T.$qN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(E=>this.h.fire(E))),this.B(this.m.onDidChangeActiveTextEditor(E=>this.g.fire(E)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(v){const u=this.m.allEditors();return v?u:u.map(E=>E.value)}async showTextDocument(v,u,E){let d;typeof u=="number"?d={position:N.ViewColumn.from(u),preserveFocus:E}:typeof u=="object"?d={position:N.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?N.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(v.uri,d),o=r&&this.m.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${v.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${v.uri.toString()}".`)}createTextEditorDecorationType(v,u){return new A.$4P(this.j,v,u).value}$acceptEditorPropertiesChanged(v,u){const E=this.m.getEditor(v);if(!E)throw new Error("unknown text editor");if(u.options&&E._acceptOptions(u.options),u.selections){const d=u.selections.selections.map(N.Selection.to);E._acceptSelections(d)}if(u.visibleRanges){const d=w.$Jb(u.visibleRanges.map(N.Range.to));E._acceptVisibleRanges(d)}if(u.options&&this.b.fire({textEditor:E.value,options:{...u.options,lineNumbers:N.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const d=p.TextEditorSelectionChangeKind.fromValue(u.selections.source),r=u.selections.selections.map(N.Selection.to);this.a.fire({textEditor:E.value,selections:r,kind:d})}if(u.visibleRanges){const d=w.$Jb(u.visibleRanges.map(N.Range.to));this.c.fire({textEditor:E.value,visibleRanges:d})}}$acceptEditorPositionData(v){for(const u in v){const E=this.m.getEditor(u);if(!E)throw new Error("Unknown text editor");const d=N.ViewColumn.to(v[u]);E.value.viewColumn!==d&&(E._acceptViewColumn(d),this.f.fire({textEditor:E.value,viewColumn:d}))}}getDiffInformation(v){return Promise.resolve(this.j.$getDiffInformation(v))}}e.$Qnc=c}),define(Ce[301],Ie([1,0,2,3,6,5,7,10,19,38,15]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=e.$Apc=void 0,e.$Apc=(0,C.$Fi)("IExtHostTimeline");class v{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$qN.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,a)=>{if(o&&o.$mid===c.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&p.$qn.equals(a,this.b.get(o.source)?.extension)){const h=o.uri===void 0?void 0:w.URI.revive(o.uri);return this.c.get(o.source)?.get(u(h))?.get(o.handle)}else return;return o}})}async $getTimeline(d,r,o,a){return this.b.get(d)?.provider.provideTimeline(w.URI.revive(r),o,a)}registerTimelineProvider(d,r,o,a){const h=new T.$Vc,n=this.d(r.id,a,h).bind(this);let s;r.onDidChange&&(s=r.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:r.id}),this));const i=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(t,m,f){m?.resetCache&&(h.clear(),i.get(r.id)?.clear());const l=await r.provideTimeline(t,m,f);if(l==null)return;const $=n(t,m);return{...l,source:r.id,items:l.items.map($)}},dispose(){for(const t of i.values())t.get(r.id)?.clear();s?.dispose(),h.dispose()}},o)}d(d,r,o){return(a,h)=>{let n;if(h?.cacheResults){let s=this.c.get(d);s===void 0&&(s=new Map,this.c.set(d,s));const i=u(a);n=s.get(i),n===void 0&&(n=new Map,s.set(i,n))}return s=>{const{iconPath:i,...t}=s,m=`${d}|${s.id??s.timestamp}`;n?.set(m,s);let f,l,$;s.iconPath&&(i instanceof A.$pO?$={id:i.id,color:i.color}:w.URI.isUri(i)?(f=i,l=i):{light:f,dark:l}=i);let I;return A.$UN.isMarkdownString(t.tooltip)?I=N.MarkdownString.from(t.tooltip):(0,R.$fg)(t.tooltip)?I=t.tooltip:A.$UN.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=N.MarkdownString.from(t.detail)):(0,R.$fg)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),I=t.detail),{...t,id:t.id??void 0,handle:m,source:d,command:s.command?r.toInternal(s.command,o):void 0,icon:f,iconDark:l,themeIcon:$,tooltip:I,accessibilityInformation:s.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,T.$Uc)(()=>{for(const a of this.c.values())a.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$Bpc=v;function u(E){return E?.toString()}}),define(Ce[302],Ie([1,0,189,24,2,4,5,232,11,7,15,18,10,60,22,153,25]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0,c=qe(c);function a(s,i){if((0,R.$fg)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let t;return Array.isArray(s.highlights)&&(t=s.highlights.filter(m=>m.length===2&&typeof m[0]=="number"&&typeof m[1]=="number"),t=t.length?t:void 0),{label:s.label,highlights:t}}}class h extends A.$Wc{constructor(i,t,m){super(),this.f=i,this.g=t,this.h=m,this.a=new Map,this.b=new r.$b_;function f(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>f(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map($=>f($)?this.r($):$):l})}registerTreeDataProvider(i,t,m){const f=this.createTreeView(i,{treeDataProvider:t},m);return{dispose:()=>f.dispose()}}createTreeView(i,t,m){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],$=!!t.dragAndDropController?.handleDrag,I=!!t.dragAndDropController?.handleDrop,D=this.m(i,t,m),y={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:f,dragMimeTypes:l,hasHandleDrag:$,hasHandleDrop:I,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},S=this.f.$registerTreeViewDataProvider(i,y),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,o.$5G)(m,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,o.$5G)(m,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(g){(0,E.$5k)(g)&&(0,o.$5G)(m,"treeViewMarkdownMessage"),D.message=g},get title(){return D.title},set title(g){D.title=g},get description(){return D.description},set description(g){D.description=g},get badge(){return D.badge},set badge(g){g!==void 0&&c.ViewBadge.isViewBadge(g)?D.badge={value:Math.floor(Math.abs(g.value)),tooltip:g.tooltip}:g===void 0&&(D.badge=void 0)},reveal:(g,b)=>D.reveal(g,b),dispose:async()=>{await S,this.a.delete(i),D.dispose()}};return this.B(k),k}$getChildren(i,t){const m=this.a.get(i);return m?m.getChildren(t):Promise.reject(new N.$nG(i))}async $handleDrop(i,t,m,f,l,$,I,D){const y=this.a.get(i);if(!y)return Promise.reject(new N.$nG(i));const S=u.DataTransfer.toDataTransfer(m,async k=>(await this.f.$resolveDropFileData(i,t,k)).buffer);return I===i&&D&&await this.j(S,y,D,l,$),y.onDrop(S,f,l)}async j(i,t,m,f,l){const $=this.b.removeDragOperationTransfer(l);if($)(await $)?.forEach((I,D)=>{I&&i.set(D,I)});else if(l&&t.handleDrag){const I=t.handleDrag(m,i,f);this.b.addDragOperationTransfer(l,I),await I}return i}async $handleDrag(i,t,m,f){const l=this.a.get(i);if(!l)return Promise.reject(new N.$nG(i));const $=await this.j(new c.$lO,l,t,f,m);if(!(!$||f.isCancellationRequested))return u.DataTransfer.from($)}async $hasResolve(i){const t=this.a.get(i);if(!t)throw new N.$nG(i);return t.hasResolve}$resolve(i,t,m){const f=this.a.get(i);if(!f)throw new N.$nG(i);return f.resolveTreeItem(t,m)}$setExpanded(i,t,m){const f=this.a.get(i);if(!f)throw new N.$nG(i);f.setExpanded(t,m)}$setSelectionAndFocus(i,t,m){const f=this.a.get(i);if(!f)throw new N.$nG(i);f.setSelectionAndFocus(t,m)}$setVisible(i,t){const m=this.a.get(i);if(!m){if(!t)return;throw new N.$nG(i)}m.setVisible(t)}$changeCheckboxState(i,t){const m=this.a.get(i);if(!m)throw new N.$nG(i);m.setCheckboxState(t)}m(i,t,m){const f=this.B(new n(i,t,this.f,this.g.converter,this.h,m));return this.a.set(i,f),f}r(i){const t=this.a.get(i.$treeViewId);return t&&"$treeItemHandle"in i?t.getExtensionElement(i.$treeItemHandle):t&&"$focusedTreeItem"in i&&i.$focusedTreeItem?t.focusedElement:null}}e.$Cpc=h;class n extends A.$Wc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(i=>this.getExtensionElement(i)).filter(i=>!(0,R.$og)(i))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(i,t,m,f,l,$){if(super(),this.I=i,this.J=m,this.L=f,this.M=l,this.N=$,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$me),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$me),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$me),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$me),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$me),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$me),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$me),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$xe,$.contributes&&$.contributes.views)for(const S in $.contributes.views)for(const k of $.contributes.views[S])k.id===i&&(this.P=k.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(S=>{Array.isArray(S)&&S.length===0||this.F.fire({message:!1,element:S})}));let I,D;const y=T.Event.debounce(this.F.event,(S,k)=>(S||(S={message:!1,elements:[]}),k.element!==!1&&(I||(I=new Promise(g=>D=g),this.G=this.G.then(()=>I)),Array.isArray(k.element)?S.elements.push(...k.element):S.elements.push(k.element)),k.message&&(S.message=!0),S),200,!0);this.B(y(({message:S,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const g=D;return I=null,this.$(k).then(()=>g())})),S&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(i){const t=i?this.getExtensionElement(i):void 0;if(i&&!t)return this.M.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let m=this.X(i);return m||(m=await this.Y(t)),m?m.map(f=>f.item):void 0}getExtensionElement(i){return this.j.get(i)}reveal(i,t){t=t||{select:!0,focus:!1};const m=(0,R.$og)(t.select)?!0:t.select,f=(0,R.$og)(t.focus)?!1:t.focus,l=(0,R.$og)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.G.then(()=>this.S(i)).then($=>this.W(i,$[$.length-1]).then(I=>this.J.$reveal(this.I,{item:I.item,parentChain:$.map(D=>D.item)},{select:m,focus:f,expand:l})),$=>this.M.error($)):this.J.$reveal(this.I,void 0,{select:m,focus:f,expand:l})}get message(){return this.O}set message(i){this.O=i,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(i){this.P=i,this.J.$setTitle(this.I,i,this.Q)}get description(){return this.Q}set description(i){this.Q=i,this.J.$setTitle(this.I,this.P,i)}get badge(){return this.R}set badge(i){this.R?.value===i?.value&&this.R?.tooltip===i?.tooltip||(this.R=u.ViewBadge.from(i),this.J.$setBadge(this.I,i))}setExpanded(i,t){const m=this.getExtensionElement(i);m&&(t?this.u.fire(Object.freeze({element:m})):this.w.fire(Object.freeze({element:m})))}setSelectionAndFocus(i,t){const m=!(0,v.$wb)(this.s,i);this.s=i;const f=this.t!==t;this.t=t,m&&this.y.fire(Object.freeze({selection:this.selectedElements})),f&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.r&&(this.r=i,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(i){const t=(await Promise.all(i.map(async m=>{const f=this.getExtensionElement(m.treeItemHandle);return f?{extensionItem:f,treeItem:await this.f.getTreeItem(f),newState:m.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(m=>m!==void 0);t.forEach(m=>{m.treeItem.checkboxState=m.newState?c.TreeItemCheckboxState.Checked:c.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(m=>[m.extensionItem,m.newState])})}async handleDrag(i,t,m){const f=[];for(const l of i){const $=this.getExtensionElement(l);$&&f.push($)}if(!(!this.g?.handleDrag||f.length===0))return await this.g.handleDrag(f,t,m),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,t,m){const f=t?this.getExtensionElement(t):void 0;if(!(!f&&t||!this.g?.handleDrop))return(0,p.$xh)(()=>this.g?.handleDrop?this.g.handleDrop(f,i,m):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,t){if(!this.f.resolveTreeItem)return;const m=this.j.get(i);if(m){const f=this.m.get(m);if(f){const l=await this.f.resolveTreeItem(f.extensionItem,m,t)??f.extensionItem;return this.hb(l),f.item.tooltip=this.eb(l.tooltip),f.item.command=this.fb(f.disposableStore,l.command),f.item}}}S(i){return this.U(i).then(t=>t?this.S(t).then(m=>this.W(t,m[m.length-1]).then(f=>(m.push(f),m))):Promise.resolve([]))}U(i){const t=this.m.get(i);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$xh)(()=>this.f.getParent(i))}W(i,t){const m=this.m.get(i);return m?Promise.resolve(m):(0,p.$xh)(()=>this.f.getTreeItem(i)).then(f=>this.kb(i,f,t,!0)).then(f=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(f);if(l){const $=this.m.get(l);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${f} from extension ${this.N.identifier.value}`)}))}X(i){if(i){let t;if(typeof i=="string"){const m=this.getExtensionElement(i);t=m?this.m.get(m):void 0}else t=i;return t&&t.children||void 0}return this.h}async Y(i){this.rb(i);const t=new d.$xe(this.Z.token);try{const m=i?this.m.get(i):void 0,f=await this.f.getChildren(i);if(t.token.isCancellationRequested)return;const l=(0,v.$Jb)(f||[]),$=await Promise.all((0,v.$Jb)(l).map(D=>this.f.getTreeItem(D)));if(t.token.isCancellationRequested)return;const I=$.map((D,y)=>D?this.db(l[y],D,m):null);return(0,v.$Jb)(I)}finally{t.dispose()}}$(i){if(i.some(m=>!m))return this.Z.dispose(!0),this.Z=new d.$xe,this.tb(),this.J.$refresh(this.I);{const m=this.ab(i);if(m.length)return this.bb(m)}return Promise.resolve(void 0)}ab(i){const t=new Set,m=i.map(l=>this.m.get(l));for(const l of m)if(l&&!t.has(l.item.handle)){let $=l;for(;$&&$.parent&&m.findIndex(I=>$&&$.parent&&I&&I.item.handle===$.parent.item.handle)===-1;){const I=this.j.get($.parent.item.handle);$=I?this.m.get(I):void 0}$&&!$.parent&&t.add(l.item.handle)}const f=[];return t.forEach(l=>{const $=this.j.get(l);if($){const I=this.m.get($);I&&(!I.parent||!t.has(I.parent.item.handle))&&f.push(l)}}),f}bb(i){const t={};return Promise.all(i.map(m=>this.cb(m).then(f=>{f&&(t[m]=f.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(i){const t=this.getExtensionElement(i);if(t){const m=this.m.get(t);if(m)return this.rb(t),(0,p.$xh)(()=>this.f.getTreeItem(t)).then(f=>{if(f){const l=this.ib(t,f,m.parent);return this.pb(t,l,m,m.parent),m.dispose(),l}return null})}return Promise.resolve(null)}db(i,t,m){const f=this.ib(i,t,m);if(t.id&&this.j.has(f.item.handle))throw new Error((0,w.localize)(0,null,t.id));return this.ob(i,f),this.qb(f,m),f}eb(i){return c.$UN.isMarkdownString(i)?u.MarkdownString.from(i):i}fb(i,t){return t?{...this.L.toInternal(t,i),originalId:t.command}:void 0}gb(i){if(i.checkboxState===void 0)return;let t,m,f;return typeof i.checkboxState=="number"?t=i.checkboxState:(t=i.checkboxState.state,m=i.checkboxState.tooltip,f=i.checkboxState.accessibilityInformation),{isChecked:t===c.TreeItemCheckboxState.Checked,tooltip:m,accessibilityInformation:f}}hb(i){if(!c.$gO.isTreeItem(i,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(i,t,m){this.hb(t);const f=this.B(new A.$Vc),l=this.kb(i,t,m),$=this.lb(t);return{item:{handle:l,parentHandle:m?m.item.handle:void 0,label:a(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(f,t.command),contextValue:t.contextValue,icon:$,iconDark:this.mb(t)||$,themeIcon:this.jb(t),collapsibleState:(0,R.$og)(t.collapsibleState)?c.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:m,children:void 0,disposableStore:f,dispose(){f.dispose()}}}jb(i){return i.iconPath instanceof c.$pO?i.iconPath:void 0}kb(i,{id:t,label:m,resourceUri:f},l,$){if(t)return`${n.b}/${t}`;const I=a(m,this.N),D=l?l.item.handle:n.a;let y=I?I.label:f?(0,C.$dh)(f):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const S=this.m.has(i)?this.m.get(i).item.handle:void 0,k=this.X(l)||[];let g,b=0;do{if(g=`${D}/${b}:${y}`,$||!this.j.has(g)||S===g)break;b++}while(b<=k.length);return g}lb(i){if(i.iconPath&&!(i.iconPath instanceof c.$pO))return typeof i.iconPath=="string"||P.URI.isUri(i.iconPath)?this.nb(i.iconPath):this.nb(i.iconPath.light)}mb(i){if(i.iconPath&&!(i.iconPath instanceof c.$pO)&&i.iconPath.dark)return this.nb(i.iconPath.dark)}nb(i){return P.URI.isUri(i)?i:P.URI.file(i)}ob(i,t){this.j.set(t.item.handle,i),this.m.set(i,t)}pb(i,t,m,f){this.j.delete(t.item.handle),this.m.delete(i),t.item.handle!==m.item.handle&&this.j.delete(m.item.handle),this.ob(i,t);const l=this.X(f)||[],$=l.filter(I=>I.item.handle===m.item.handle)[0];$&&l.splice(l.indexOf($),1,t)}qb(i,t){t?(t.children||(t.children=[]),t.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}rb(i){if(i){const t=this.m.get(i);if(t){if(t.children)for(const m of t.children){const f=this.j.get(m.item.handle);f&&this.sb(f)}t.children=void 0}}else this.tb()}sb(i){const t=this.m.get(i);if(t){if(t.children)for(const m of t.children){const f=this.j.get(m.item.handle);f&&this.sb(f)}this.m.delete(i),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(i=>i.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[303],Ie([1,0,4,5,2,37,10,68,6,7]),function(oe,e,w,C,P,T,A,N,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0,A=qe(A),p=qe(p),c=qe(c);class R extends C.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(d,r,o,a){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new w.$me),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$me),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=o,this.#i=a.viewType,this.#s=a.panelOptions,this.#o=a.viewColumn,this.#r=a.title,this.#u=a.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(d){this.#l||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#u=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class v extends C.$Wc{static c(){return(0,T.$2g)()}constructor(d,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$qN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,o,a,h={}){const n=typeof a=="object"?a.viewColumn:a,s={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof a=="object"&&!!a.preserveFocus},i=(0,N.$6nc)(d),t=v.c();this.f.$createWebviewPanel((0,N.$8nc)(d),t,r,{title:o,panelOptions:u(h),webviewOptions:(0,N.$9nc)(d,this.m,h),serializeBuffersForPostMessage:i},s);const m=this.j.createNewWebview(t,h,d);return this.createNewWebviewPanel(t,r,o,n,h,m,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((o,a)=>{const h=d[o],n=d[a];return h.active?1:n.active?-1:+h.visible-+n.visible});for(const o of r){const a=this.getWebviewPanel(o);if(!a)continue;const h=d[o];a._updateViewState({active:h.active,visible:h.visible,viewColumn:A.ViewColumn.to(h.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,N.$6nc)(d)}),new c.$sN(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,o,a){const h=this.h.get(r);if(!h)throw new Error(`No serializer found for '${r}'`);const{serializer:n,extension:s}=h,i=this.j.createNewWebview(d,o.webviewOptions,s),t=this.createNewWebviewPanel(d,r,o.title,a,o.panelOptions,i,o.active);await n.deserializeWebviewPanel(t,o.state)}createNewWebviewPanel(d,r,o,a,h,n,s){const i=new R(d,this.f,n,{viewType:r,title:o,viewColumn:a,panelOptions:h,active:s});return this.g.set(d,i),i}getWebviewPanel(d){return this.g.get(d)}}e.$0nc=v;function u(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(Ce[304],Ie([1,0,4,5,68,10,6,7]),function(oe,e,w,C,P,T,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=void 0,A=qe(A),N=qe(N);class p extends C.$Wc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(v,u,E,d,r,o){super(),this.#s=!1,this.#u=this.B(new w.$me),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new w.$me),this.onDidDispose=this.#l.event,this.#i=E,this.#a=d,this.#e=v,this.#t=u,this.#n=r,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(v){this.a(),this.#a!==v&&(this.#a=v,this.#t.$setWebviewViewTitle(this.#e,v))}get description(){return this.a(),this.#o}set description(v){this.a(),this.#o!==v&&(this.#o=v,this.#t.$setWebviewViewDescription(this.#e,v))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(v){v===this.#r||this.#s||(this.#r=v,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(v){this.a(),!(v?.value===this.#c?.value&&v?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(v),this.#t.$setWebviewViewBadge(this.#e,v))}show(v){this.a(),this.#t.$show(this.#e,!!v)}a(){if(this.#s)throw new Error("Webview is disposed")}}class c{constructor(v,u){this.d=u,this.b=new Map,this.c=new Map,this.a=v.getProxy(A.$qN.MainThreadWebviewViews)}registerWebviewViewProvider(v,u,E,d){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:E,extension:v}),this.a.$registerWebviewViewProvider((0,P.$8nc)(v),u,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$6nc)(v)}),new N.$sN(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(v,u,E,d,r){const o=this.b.get(u);if(!o)throw new Error(`No view provider found for '${u}'`);const{provider:a,extension:h}=o,n=this.d.createNewWebview(v,{},h),s=new p(v,this.a,u,E,n,!0);this.c.set(v,s),await a.resolveWebviewView(s,{state:d},r)}async $onDidChangeWebviewViewVisibility(v,u){this.e(v)._setVisible(u)}async $disposeWebviewView(v){const u=this.e(v);this.c.delete(v),u.dispose(),this.d.deleteWebview(v)}e(v){const u=this.c.get(v);if(!u)throw new Error("No webview found");return u}}e.$Fpc=c}),define(Ce[305],Ie([1,0,4,31,32,3]),function(oe,e,w,C,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.OutputChannelUpdateMode=e.$KM=e.$JM=e.$IM=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=void 0,e.$yM="text/x-code-output",e.$zM="output",e.$AM="Log",e.$BM="text/x-code-log-output",e.$CM="log",e.$DM="workbench.panel.output",e.$EM=new P.$Wj("inOutput",!1),e.$FM=new P.$Wj("activeLogOutput",!1),e.$GM=new P.$Wj("activeLogOutput.levelSettable",!1),e.$HM=new P.$Wj("activeLogOutput.level",""),e.$IM=new P.$Wj("activeLogOutput.levelIsDefault",!1),e.$JM=new P.$Wj("outputView.scrollLock",!1),e.$KM=(0,T.$Fi)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$LM={OutputChannels:"workbench.contributions.outputChannels"};class N{constructor(){this.a=new Map,this.b=new w.$me,this.onDidRegisterChannel=this.b.event,this.c=new w.$me,this.onDidRemoveChannel=this.c.event}registerChannel(c){this.a.has(c.id)||(this.a.set(c.id,c),this.b.fire(c.id))}getChannels(){const c=[];return this.a.forEach(R=>c.push(R)),c}getChannel(c){return this.a.get(c)}removeChannel(c){this.a.delete(c),this.c.fire(c)}}C.$po.add(e.$LM.OutputChannels,new N),e.$MM=new P.$Wj("activeOutputChannel","")}),define(Ce[127],Ie([1,0,6,3,17,19,12,305,69,27,51,157,23,15,30,4,5]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jpc=e.$ipc=void 0;class a extends A.$fk{get disposed(){return this.n}constructor(i,t,m,f,l){super(),this.id=i,this.name=t,this.r=m,this.s=f,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(m.getLevel()),this.B(m.onDidChangeLogLevel($=>this.setLevel($)))}get logLevel(){return this.getLevel()}appendLine(i){this.append(i+`
`)}append(i){this.info(i)}clear(){const i=this.m;this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Clear,i)}replace(i){const t=this.m;this.info(i),this.s.$update(this.id,N.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(i,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof i=="boolean"?i:t))}hide(){this.s.$close(this.id)}g(i,t){this.m+=u.$Oe.fromString(t).byteLength,(0,A.log)(this.r,i,t),this.visible&&(this.r.flush(),this.s.$update(this.id,N.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class h extends a{appendLine(i){this.append(i)}}let n=class{constructor(i,t,m,f,l,$){this.i=t,this.j=m,this.k=f,this.l=l,this.m=$,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=i.getProxy(w.$qN.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,v.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(i){this.h=i;for(const[t,m]of this.g)m.visible=t===this.h}createOutputChannel(i,t,m){if(i=i.trim(),!i)throw new Error("illegal argument `name`. must not be falsy");const f=typeof t=="object"&&t.log,l=(0,E.$fg)(t)?t:void 0;if((0,E.$fg)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let $;const I=this.i.environment.extensionLogLevel?.find(([y])=>T.$qn.equals(m.identifier,y))?.[1];I&&($=(0,A.$qk)(I));const D=f?this.o(i,$,m):this.n(i,l,m);return D.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),f?this.r(i,$??this.m.getLevel(),D):this.q(i,D)}async n(i,t,m){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const f=await this.c,l=this.k.extUri.joinPath(f,`${this.f++}-${i.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),$=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),I=await this.a.$register(i,l,t,m.identifier.value);return new a(I,i,$,this.a,m)}async o(i,t,m){const f=await this.p(m),l=i.replace(/[\\/:\*\?"<>\|]/g,""),$=this.k.extUri.joinPath(f,`${l}.log`),I=`${m.identifier.value}.${l}`,D=this.l.createLogger($,{id:I,name:i,logLevel:t,extensionId:m.identifier.value});return new h(I,i,D,this.a,m)}p(i){let t=this.d.get(i.identifier.value);if(!t){const m=this.k.extUri.joinPath(this.i.logsLocation,i.identifier.value);this.d.set(i.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(m)}catch(f){if((0,d.$pl)(f)!==d.FileSystemProviderErrorCode.FileExists)throw f}return m})())}return t}q(i,t){let m=!1;const f=()=>{if(m)throw new Error("Channel has been closed")};return{get name(){return i},append(l){f(),t.then($=>$.append(l))},appendLine(l){f(),t.then($=>$.appendLine(l))},clear(){f(),t.then(l=>l.clear())},replace(l){f(),t.then($=>$.replace(l))},show(l,$){f(),t.then(I=>I.show(l,$))},hide(){f(),t.then(l=>l.hide())},dispose(){m=!0,t.then(l=>l.dispose())}}}r(i,t,m){const f=new o.$Vc,l=()=>{if(f.isDisposed)throw new Error("Channel has been closed")},$=f.add(new r.$me);function I(D){t=D,$.fire(D)}return m.then(D=>{f.add(D),D.logLevel!==t&&I(D.logLevel),f.add(D.onDidChangeLogLevel(y=>I(y)))}),{...this.q(i,m),get logLevel(){return t},onDidChangeLogLevel:$.event,trace(D,...y){l(),m.then(S=>S.trace(D,...y))},debug(D,...y){l(),m.then(S=>S.debug(D,...y))},info(D,...y){l(),m.then(S=>S.info(D,...y))},warn(D,...y){l(),m.then(S=>S.warn(D,...y))},error(D,...y){l(),m.then(S=>S.error(D,...y))},dispose(){f.dispose()}}}};e.$ipc=n,e.$ipc=n=Qe([Ve(0,P.$WP),Ve(1,c.$aQ),Ve(2,p.$2nc),Ve(3,R.$Enc),Ve(4,A.$ak),Ve(5,A.$_j)],n),e.$jpc=(0,C.$Fi)("IExtHostOutputService")}),define(Ce[128],Ie([1,0,3,11]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,w.$Fi)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let T=1/0;for(let N=0;N<this.maxSampleCount;N++){const p=await P.getRoundTripTime();if(p===void 0)return;T=Math.min(T,p/2),await(0,C.$Gh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((N,p)=>N+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((N,p)=>N+p,0)/this.average.length,high:typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[306],Ie([1,0,192,54,31,50,42,5,4,128,21,26,11,113]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=void 0,e.$3K=Object.freeze({id:"application",order:100,title:(0,w.localize)(0,null),type:"object"}),e.$4K=Object.freeze({id:"workbench",order:7,title:(0,w.localize)(1,null),type:"object"}),e.$5K=Object.freeze({id:"security",scope:C.ConfigurationScope.APPLICATION,title:(0,w.localize)(2,null),type:"object",order:7}),e.$6K=Object.freeze({id:"problems",title:(0,w.localize)(3,null),type:"object",order:101}),e.$7K=Object.freeze({id:"window",order:8,title:(0,w.localize)(4,null),type:"object"}),e.$8K={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$me,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const r=new d;P.$po.add(e.$8K.ConfigurationMigration,r);let o=class extends N.$Wc{static{this.ID="workbench.contrib.configurationMigration"}constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async t=>{for(const m of t.added)await this.f(m,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(t=>this.c(t)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(t=>this.g(t,s?.uri))])}async g(s,i){const t=this.a.inspect(s.key,{resource:i}),m=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[f,l]of m){const $=t[f];if(!$)continue;const I=[];if($.value!==void 0){const D=await this.h(s,f,$.value,i,void 0);for(const y of D??[])I.push([y,[]])}for(const{identifiers:D,value:y}of $.overrides??[])if(y!==void 0){const S=await this.h(s,f,y,i,D);for(const k of S??[])I.push([k,D])}I.length&&await Promise.allSettled(I.map(async([[D,y],S])=>this.a.updateValue(D,y.value,{resource:i,overrideIdentifiers:S},l)))}}async h(s,i,t,m,f){const l=I=>{const y=this.a.inspect(I,{resource:m})[i];if(y)return f?y.overrides?.find(({identifiers:S})=>(0,v.$go)(S,f))?.value:y.value},$=await s.migrateFn(t,l);return Array.isArray($)?$:[[s.key,$]]}};e.$9K=o,e.$9K=o=Qe([Ve(0,A.$_i),Ve(1,T.$Oi)],o);let a=class extends N.$Wc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(s){super(),this.b=s,this.a=new u.$3h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!R.$i&&(await this.b.getEnvironment())?.os!==R.OperatingSystem.Windows)return;P.$po.as(C.$uo.Configuration).registerConfiguration({...e.$5K,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,w.localize)(5,null)},default:[],markdownDescription:(0,w.localize)(6,null),scope:C.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,w.localize)(7,null),scope:C.ConfigurationScope.MACHINE}}})}};e.$0K=a,e.$0K=a=Qe([Ve(0,c.$Vm)],a),e.$$K="window.newWindowProfile";let h=class extends N.$Wc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(s,i){super(),this.c=s,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(t=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(t=>{t.source!==A.ConfigurationTarget.DEFAULT&&t.affectsConfiguration(e.$$K)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const s=P.$po.as(C.$uo.Configuration),i={...e.$7K,properties:{[e.$$K]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(t=>t.name),null],enumItemLabels:[...this.c.profiles.map(t=>""),(0,w.localize)(8,null)],description:(0,w.localize)(9,null),scope:C.ConfigurationScope.APPLICATION}}};this.a?s.updateConfigurations({add:[i],remove:[this.a]}):s.registerConfiguration(i),this.a=i}h(){const s=this.f.getValue(e.$$K);this.b=s?this.c.profiles.find(i=>i.name===s):void 0}j(){const s=this.f.getValue(e.$$K);if(!s)return;const i=this.b?this.c.profiles.find(t=>t.id===this.b.id):void 0;s!==i?.name&&this.f.updateValue(e.$$K,i?.name)}};e.$_K=h,e.$_K=h=Qe([Ve(0,E.$Ll),Ve(1,A.$_i)],h)}),define(Ce[307],Ie([1,0,41,16,20,24,203,306,54,3,31]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$bL=e.$aL=void 0,e.$cL=r,e.$dL=o,w=qe(w),e.$aL=(0,c.$Fi)("editorResolverService"),e.$bL="workbench.editorAssociations";const v=R.$po.as(p.$uo.Configuration),u={...N.$4K,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};v.registerConfiguration(u);var E;(function(a){a.builtin="builtin",a.option="option",a.exclusive="exclusive",a.default="default"})(E||(e.RegisteredEditorPriority=E={}));var d;(function(a){a[a.ABORT=1]="ABORT",a[a.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(a){switch(a){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function o(a,h){if(new Set([C.Schemas.extension,C.Schemas.webviewPanel,C.Schemas.vscodeWorkspaceTrust,C.Schemas.vscodeSettings]).has(h.scheme))return!1;const i=typeof a=="string"&&a.indexOf(P.$ic.sep)>=0?`${h.scheme}:${h.path}`:(0,T.$dh)(h);return w.$yk(typeof a=="string"?a.toLowerCase():a,i.toLowerCase())}}),define(Ce[308],Ie([1,0,53,16,20,21,24,2,3,226,50,246,128]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=void 0,e.$5M=(0,p.$Fi)("pathService");let d=E=class{constructor(o,a,h,n){this.d=o,this.e=a,this.f=h,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,a,h){return typeof a=="string"||typeof a>"u"?this.a.then(n=>this.h(o,n,a)):this.h(o,a,h)}h(o,a,h){return o.scheme===C.Schemas.file||o.scheme===C.Schemas.vscodeRemote?(0,w.$Cg)(h??(0,A.$dh)(o),a===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,a){if(o.remoteAuthority)return C.Schemas.vscodeRemote;const h=(0,c.$2M)(a.getWorkspace());if(h)return h;const n=a.getWorkspace().folders[0];if(n)return n.uri.scheme;const s=a.getWorkspace().configuration;return s?s.scheme:C.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===T.OperatingSystem.Windows?P.$hc:P.$ic)}async fileURI(o){let a="";if(await this.a===T.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(a=o.substring(2),o="/"):(a=o.substring(2,n),o=o.substring(n)||"/")}return N.URI.from({scheme:C.Schemas.file,authority:a,path:o,query:"",fragment:""})}};e.$6M=d,e.$6M=d=E=Qe([Ve(1,u.$Vm),Ve(2,v.$NM),Ve(3,R.$Oi)],d)}),define(Ce[129],Ie([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$GL=e.$FL=void 0;class w{constructor(A,N){this.line=A,this.character=N}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,N){return new w(0,0)}with(A){return new w(0,0)}}e.$FL=w;class C{constructor(A,N,p,c){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(A,N),this.end=new w(p,c)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new C(0,0,0,0)}with(A){return new C(0,0,0,0)}}e.$GL=C;var P;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ce[43],Ie([1,0,18,41,26,53,13,3,20,14,129,11]),function(oe,e,w,C,P,T,A,N,p,c,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7L=e.$5L=e.$XL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$UL=e.$TL=e.$SL=e.$RL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.TextSearchCompleteMessageType=void 0,e.$OL=a,e.$PL=h,e.$QL=n,e.$VL=D,e.$WL=y,e.$YL=g,e.$ZL=b,e.$1L=L,e.$2L=O,e.$3L=q,e.$4L=G,e.$6L=F,e.$8L=ge,e.$9L=te,C=qe(C),P=qe(P),T=qe(T),p=qe(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$HL="workbench.view.search",e.$IL="workbench.panel.search",e.$JL="workbench.view.search",e.$KL="search-result",e.$LL="search.exclude",e.$ML=2e4;const u="\u27EA ",E=" characters skipped \u27EB",d=(u.length+E.length+5)*2;e.$NL=(0,N.$Fi)("searchService");var r;(function(se){se[se.file=0]="file",se[se.text=1]="text",se[se.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(se){se[se.File=1]="File",se[se.Text=2]="Text",se[se.aiText=3]="aiText"})(o||(e.QueryType=o={}));function a(se){return!!se.preview}function h(se){return!!se.resource}function n(se){return!!se.message}var s;(function(se){se[se.Normal=0]="Normal",se[se.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class i{constructor(de){this.resource=de,this.results=[]}}e.$RL=i;class t{constructor(de,be,re,Pe){this.ranges=be,this.webviewIndex=Pe;const Le=Array.isArray(be)?be:[be];if(re&&re.matchLines===1&&m(Le)){de=(0,A.$$f)(de,re.matchLines);let Y="",B=0,_=0;const ve=Math.floor(re.charsPerLine/5),ae=[];for(const we of Le){const le=Math.max(we.startColumn-ve,0),X=we.startColumn+re.charsPerLine;if(le>_+ve+d){const Z=u+(le-_)+E;Y+=Z+de.slice(le,X),B+=le-(_+Z.length)}else Y+=de.slice(_,X);ae.push(new l(0,we.startColumn-B,we.endColumn-B)),_=X}this.preview={text:Y,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const Y=Array.isArray(be)?be[0].startLineNumber:be.startLineNumber;this.preview={text:de,matches:(0,w.$3b)(be,B=>new f(B.startLineNumber-Y,B.startColumn,B.endLineNumber-Y,B.endColumn))}}}}e.$SL=t;function m(se){const de=se[0].startLineNumber;for(const be of se)if(be.startLineNumber!==de||be.endLineNumber!==de)return!1;return!0}class f{constructor(de,be,re,Pe){this.startLineNumber=de,this.startColumn=be,this.endLineNumber=re,this.endColumn=Pe}}e.$TL=f;class l extends f{constructor(de,be,re){super(de,be,de,re)}}e.$UL=l;var $;(function(se){se.List="list",se.Tree="tree"})($||(e.ViewMode=$={}));var I;(function(se){se.Default="default",se.FileNames="fileNames",se.Type="type",se.Modified="modified",se.CountDescending="countDescending",se.CountAscending="countAscending"})(I||(e.SearchSortOrder=I={}));function D(se,de=!0){const be=se&&se.files&&se.files.exclude,re=de&&se&&se.search&&se.search.exclude;if(!be&&!re)return;if(!be||!re)return be||re;let Pe=Object.create(null);return Pe=P.$fo(Pe,P.$co(be)),Pe=P.$fo(Pe,P.$co(re),!0),Pe}function y(se,de){return se.excludePattern&&C.$yk(se.excludePattern,de)?!1:se.includePattern||se.usingSearchPaths?se.includePattern&&C.$yk(se.includePattern,de)?!0:se.usingSearchPaths?!!se.folderQueries&&se.folderQueries.some(be=>{const re=be.folder.fsPath;if(T.$Eg(de,re)){const Pe=p.$nc(re,de);return!be.includePattern||!!C.$yk(be.includePattern,Pe)}else return!1}):!1:!0}var S;(function(se){se[se.unknownEncoding=1]="unknownEncoding",se[se.regexParseError=2]="regexParseError",se[se.globParseError=3]="globParseError",se[se.invalidLiteral=4]="invalidLiteral",se[se.rgProcessError=5]="rgProcessError",se[se.other=6]="other",se[se.canceled=7]="canceled"})(S||(e.SearchErrorCode=S={}));class k extends Error{constructor(de,be){super(de),this.code=be}}e.$XL=k;function g(se){const de=se.message;if((0,c.$6)(se))return new k(de,S.canceled);try{const be=JSON.parse(de);return new k(be.message,be.code)}catch{return new k(de,S.other)}}function b(se){const de={message:se.message,code:se.code};return new Error(JSON.stringify(de))}function L(se){return se.type==="error"?!0:se.type==="success"}function O(se){return se.type==="success"}function q(se){return!!se.path}function G(se,de,be=!0){const re=se.searchPath?se.searchPath:se.relativePath;return be?(0,A.$8f)(re,de):C.$yk(de,re)}class W{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$5L=W;function F(se,de){const be={...se||{},...de||{}};return Object.keys(be).filter(re=>{const Pe=be[re];return typeof Pe=="boolean"&&Pe})}class V{constructor(de,be){this.c=null,this.a={...de.excludePattern||{},...be.excludePattern||{}},this.b=C.$zk(this.a);let re=de.includePattern;be.includePattern&&(re?re={...re,...be.includePattern}:re=be.includePattern),re&&(this.c=C.$zk(re))}matchesExcludesSync(de,be,re){return!!(this.b&&this.b(de,be,re))}includedInQuerySync(de,be,re){return!(this.b&&this.b(de,be,re)||this.c&&!this.c(de,be,re))}includedInQuery(de,be,re){const Pe=this.b(de,be,re),Le=()=>this.c?!!this.c(de,be,re):!0;return(0,v.$rh)(Pe)?Pe.then(Y=>Y?!1:Le()):Le()}hasSiblingExcludeClauses(){return ce(this.a)}}e.$7L=V;function ce(se){for(const de in se)if(typeof se[de]!="boolean")return!0;return!1}function ge(se){if(!se)return;let de;return be=>(de||(de=(se()||Promise.resolve([])).then(re=>re?me(re):{})),de.then(re=>!!re[be]))}function te(se){if(!se)return;let de;return be=>{if(!de){const re=se();de=re?me(re):{}}return!!de[be]}}function me(se){const de={};for(const be of se)de[be]=!0;return de}}),define(Ce[44],Ie([1,0,18,11,22,4,5,59,16,138,24,13,2,191,30,3,12,214,50,51,27,17,10,7,66,43,6,49]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l,$,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0;function D(q,G,W){return new R.$8g(F=>g(F,W)).isEqual(q,G)}function y(q,G,W){return D(q.uri,G.uri,W)?0:(0,v.$zf)(q.uri.toString(),G.uri.toString())}function S(q,G,W){return q.index!==G.index?q.index<G.index?-1:1:D(q.uri,G.uri,W)?(0,v.$zf)(q.name,G.name):(0,v.$zf)(q.uri.toString(),G.uri.toString())}function k(q,G,W,F){const V=q.slice(0).sort((ge,te)=>W(ge,te,F)),ce=G.slice(0).sort((ge,te)=>W(ge,te,F));return(0,w.$Gb)(V,ce,(ge,te)=>W(ge,te,F))}function g(q,G){const W=G.getCapabilities(q.scheme);return!(W&&W&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends h.$Yi{static toExtHostWorkspace(G,W,F,V){if(!G)return{workspace:null,added:[],removed:[]};const{id:ce,name:ge,folders:te,configuration:me,transient:se,isUntitled:de}=G,be=[],re=W;W?te.forEach((B,_)=>{const ve=u.URI.revive(B.uri),ae=b.o(F||W,ve,V);ae?(ae.name=B.name,ae.index=B.index,be.push(ae)):be.push({uri:ve,name:B.name,index:_})}):be.push(...te.map(({uri:B,name:_,index:ve})=>({uri:u.URI.revive(B),name:_,index:ve}))),be.sort((B,_)=>B.index<_.index?-1:1);const Pe=new b(ce,ge,be,!!se,me?u.URI.revive(me):null,!!de,B=>g(B,V)),{added:Le,removed:Y}=k(re?re.workspaceFolders:[],Pe.workspaceFolders,y,V);return{workspace:Pe,added:Le,removed:Y}}static o(G,W,F){for(let V=0;V<G.folders.length;V++){const ce=G.workspaceFolders[V];if(D(ce.uri,W,F))return ce}}constructor(G,W,F,V,ce,ge,te){super(G,F.map(me=>new h.$Zi(me)),V,ce,te),this.t=W,this.u=ge,this.q=[],this.s=N.$Li.forUris(te,()=>!0),F.forEach(me=>{this.q.push(me),this.s.set(me.uri,me)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,W){return W&&this.s.get(G)&&(G=(0,R.$fh)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let L=class{constructor(G,W,F,V,ce){this.c=new T.$me,this.onDidChangeWorkspace=this.c.event,this.g=new T.$me,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$oe,this.C=new Map,this.h=V,this.s=F,this.t=ce,this.j=new c.$Mm,this.k=new C.$Eh,this.o=G.getProxy($.$qN.MainThreadWorkspace),this.q=G.getProxy($.$qN.MainThreadMessageService);const ge=W.workspace;this.l=ge?new b(ge.id,ge.name,[],!!ge.transient,ge.configuration?u.URI.revive(ge.configuration):null,!!ge.isUntitled,te=>g(te,F)):void 0}$initializeWorkspace(G,W){this.v=W,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:p.Schemas.untitled,path:(0,R.$dh)((0,R.$fh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,W,F,...V){const ce=[];if(Array.isArray(V)&&V.forEach(de=>{u.URI.isUri(de.uri)&&!ce.some(be=>D(be.uri,de.uri,this.s))&&ce.push({uri:de.uri,name:de.name||(0,R.$ch)(de.uri)})}),this.n||[W,F].some(de=>typeof de!="number"||de<0)||F===0&&ce.length===0)return!1;const ge=this.x?this.x.workspaceFolders:[];if(W+F>ge.length)return!1;const te=ge.slice(0);te.splice(W,F,...ce.map(de=>({uri:de.uri,name:de.name||(0,R.$ch)(de.uri),index:void 0})));for(let de=0;de<te.length;de++){const be=te[de];if(te.some((re,Pe)=>Pe!==de&&D(be.uri,re.uri,this.s)))return!1}te.forEach((de,be)=>de.index=be);const{added:me,removed:se}=k(ge,te,S,this.s);if(me.length===0&&se.length===0)return!1;if(this.o){const de=G.displayName||G.name;this.o.$updateWorkspaceFolders(de,W,F,ce).then(void 0,be=>{this.n=void 0;const re={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(a.Severity.Error,(0,E.localize)(0,null,de,be.toString()),re,[])})}return this.y(te),!0}getWorkspaceFolder(G,W){if(this.x)return this.x.getWorkspaceFolder(G,W)}async getWorkspaceFolder2(G,W){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,W)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,W){let F,V="";if(typeof G=="string"?(F=u.URI.file(G),V=G):typeof G<"u"&&(F=G,V=G.fsPath),!F)return V;const ce=this.getWorkspaceFolder(F,!0);if(!ce)return V;typeof W>"u"&&this.x&&(W=this.x.folders.length>1);let ge=(0,R.$ih)(ce.uri,F);return W&&ce.name&&(ge=`${ce.name}/${ge}`),ge}y(G){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:W,added:F,removed:V}=b.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=W||void 0,this.n=void 0,this.c.fire(Object.freeze({added:F,removed:V}))}findFiles(G,W,F,V,ce=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let ge="",te=!0;return W===null?te=!1:W!==void 0&&(typeof W=="string"?ge=W:ge=W.pattern),this.z(G,void 0,{exclude:ge,maxResults:F,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ce)}findFiles2(G,W={},F,V=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${F.value}, entryPoint: findFiles2`),this.z(void 0,G,W,V)}async z(G,W,F,V=P.CancellationToken.None){if(V&&V.isCancellationRequested)return Promise.resolve([]);const ce=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,ge={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof F.useDefaultSearchExcludes=="boolean"?!F.useDefaultSearchExcludes:!1,maxResults:F.maxResults,excludePattern:ce,shouldGlobSearch:typeof F.fuzzy=="boolean"?!F.fuzzy:!0,_reason:"startFileSearch"};let te;if(G){const{includePattern:me,folder:se}=O(t.GlobPattern.from(G));te=se,ge.includePattern=me}else{const{includePattern:me,folder:se}=O(t.GlobPattern.from(W));te=se,ge.filePattern=me}return this.o.$startFileSearch(te??null,ge,V).then(me=>Array.isArray(me)?me.map(se=>u.URI.revive(se)):[])}async findTextInFiles(G,W,F,V,ce=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const ge=this.j.getNext(),te=typeof W.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:W.previewOptions,{includePattern:me,folder:se}=O(t.GlobPattern.from(W.include)),de=typeof W.exclude=="string"?W.exclude:W.exclude?W.exclude.pattern:void 0,be={ignoreSymlinks:typeof W.followSymlinks=="boolean"?!W.followSymlinks:void 0,disregardIgnoreFiles:typeof W.useIgnoreFiles=="boolean"?!W.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof W.useGlobalIgnoreFiles=="boolean"?!W.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof W.useParentIgnoreFiles=="boolean"?!W.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof W.useDefaultExcludes=="boolean"?!W.useDefaultExcludes:!0,fileEncoding:W.encoding,maxResults:W.maxResults,previewOptions:te,afterContext:W.afterContext,beforeContext:W.beforeContext,includePattern:me,excludePattern:de},re=!1;if(this.u[ge]=Pe=>{if(re)return;const Le=u.URI.revive(Pe.resource);Pe.results.forEach(Y=>{const B=(0,I.$ci)(Y);(0,l.$OL)(B)?F({uri:Le,preview:{text:B.preview.text,matches:(0,w.$3b)(B.preview.matches,_=>new m.$uN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,w.$3b)(B.ranges,_=>new m.$uN(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):F({uri:Le,text:B.text,lineNumber:B.lineNumber})})},ce.isCancellationRequested)return{};try{const Pe=await this.o.$startTextSearch(G,se??null,be,ge,ce);return delete this.u[ge],Pe||{}}catch(Pe){throw delete this.u[ge],Pe}}$handleTextSearchResult(G,W){this.u[W]?.(G)}async save(G){const W=await this.o.$save(G,{saveAs:!1});return u.URI.revive(W)}async saveAs(G){const W=await this.o.$save(G,{saveAs:!0});return u.URI.revive(W)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,W){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,W);const F=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerEditSessionIdentityProvider(V,F),(0,A.$Uc)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(V)})}async $getEditSessionIdentifier(G,W){this.h.info("Getting edit session identifier for workspaceFolder",G);const F=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const V=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!V),!V)return;const ce=await V.provideEditSessionIdentity(F,W);if(this.h.info("Provider returned edit session identifier: ",ce),!!ce)return ce}async $provideEditSessionIdentityMatch(G,W,F,V){this.h.info("Getting edit session identifier for workspaceFolder",G);const ce=await this.resolveWorkspaceFolder(u.URI.revive(G));if(!ce){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ce);const ge=this.w.get(ce.uri.scheme);if(this.h.info(`Provider for scheme ${ce.uri.scheme} is defined: `,!!ge),!ge)return;const te=await ge.provideEditSessionIdentityMatch?.(W,F,V);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(G){return(W,F,V)=>{const ce=function(te){W.call(F,te)};return ce.extension=G,this.B.event(ce,void 0,V)}}async $onWillCreateEditSessionIdentity(G,W,F){const V=await this.resolveWorkspaceFolder(u.URI.revive(G));if(V===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:V},W,async(ce,ge)=>{const te=Date.now();await Promise.resolve(ce),Date.now()-te>F&&this.h.warn("SLOW edit session create-participant",ge.extension.identifier)}),W.isCancellationRequested}registerCanonicalUriProvider(G,W){if(this.C.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.C.set(G,W);const F=this.t.transformOutgoingScheme(G),V=this.A++;return this.o.$registerCanonicalUriProvider(V,F),(0,A.$Uc)(()=>{this.C.delete(G),this.o.$unregisterCanonicalUriProvider(V)})}async provideCanonicalUri(G,W,F){const V=this.C.get(G.scheme);if(!V)return;const ce=await V.provideCanonicalUri?.(u.URI.revive(G),W,F);if(ce)return ce}async $provideCanonicalUri(G,W,F){return this.provideCanonicalUri(u.URI.revive(G),{targetScheme:W},F)}};e.$Vnc=L,e.$Vnc=L=Qe([Ve(0,i.$WP),Ve(1,s.$aQ),Ve(2,n.$Enc),Ve(3,o.$_j),Ve(4,f.$Tnc)],L),e.$Wnc=(0,r.$Fi)("IExtHostWorkspace");function O(q){let G,W;return q&&(typeof q=="string"?G=q:(G=q.pattern,W=u.URI.revive(q.baseUri))),{includePattern:G,folder:W}}}),define(Ce[45],Ie([1,0,26,4,44,6,7,42,215,54,15,11,3,17,12,2]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Znc=e.$Ync=e.$Xnc=void 0;function o(f,l){if(l){const $=l.split(".");let I=f;for(let D=0;I&&D<$.length;D++)I=I[$[D]];return I}}function a(f){return f instanceof r.URI}function h(f){return f&&f.uri instanceof r.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function s(f){return f&&f.uri instanceof r.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function i(f){if(a(f))return{resource:f};if(h(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(s(f))return{resource:f.uri};if(f===null)return{resource:null}}let t=class{constructor(l,$,I){this.a=l.getProxy(T.$qN.MainThreadConfiguration),this.c=$,this.b=I,this.d=new v.$Eh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new m(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,$){this.getConfigProvider().then(I=>I.$acceptConfigurationChanged(l,$))}};e.$Xnc=t,e.$Xnc=t=Qe([Ve(0,E.$WP),Ve(1,P.$Wnc),Ve(2,d.$_j)],t);class m{constructor(l,$,I,D){this.a=new C.$me,this.b=l,this.f=D,this.c=$,this.e=p.$No.parse(I,D),this.d=this.k(I.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,$){const I={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$No.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j($,I))}getConfiguration(l,$,I){const D=i($)||{},y=this.g(l?o(this.e.getValue(void 0,D,this.c.workspace),l):this.e.getValue(void 0,D,this.c.workspace));l&&this.h(l,D,I?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?N.ConfigurationTarget.USER:N.ConfigurationTarget.WORKSPACE;switch(g){case A.ConfigurationTarget.Global:return N.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return N.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return N.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(g){return typeof o(y,g)<"u"},get:(g,b)=>{this.h(l?`${l}.${g}`:g,D,I?.identifier);let L=o(y,g);if(typeof L>"u")L=b;else{let O;const q=(G,W)=>{if((0,R.$hg)(G)){let F;const V=()=>{O=O||(0,w.$co)(y),F=F||o(O,W)};return new Proxy(G,{get:(ce,ge)=>{if(typeof ge=="string"&&ge.toLowerCase()==="tojson")return V(),()=>F;if(O)return F=F||o(O,W),F[ge];const te=ce[ge];return typeof ge=="string"?q(te,`${W}.${ge}`):te},set:(ce,ge,te)=>(V(),F&&(F[ge]=te),!0),deleteProperty:(ce,ge)=>(V(),F&&delete F[ge],!0),defineProperty:(ce,ge,te)=>(V(),F&&Object.defineProperty(F,ge,te),!0)})}return Array.isArray(G)?(0,w.$co)(G):G};L=q(L,g)}return L},update:(g,b,L,O)=>{g=l?`${l}.${g}`:g;const q=S(L);return b!==void 0?this.b.$updateConfigurationOption(q,g,b,D,O):this.b.$removeConfigurationOption(q,g,D,O)},inspect:g=>{g=l?`${l}.${g}`:g;const b=this.e.inspect(g,D,this.c.workspace);if(b)return{key:g,defaultValue:(0,w.$co)(b.policy?.value??b.default?.value),globalValue:(0,w.$co)(b.user?.value??b.application?.value),workspaceValue:(0,w.$co)(b.workspace?.value),workspaceFolderValue:(0,w.$co)(b.workspaceFolder?.value),defaultLanguageValue:(0,w.$co)(b.default?.override),globalLanguageValue:(0,w.$co)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,w.$co)(b.workspace?.override),workspaceFolderLanguageValue:(0,w.$co)(b.workspaceFolder?.override),languageIds:(0,w.$co)(b.overrideIdentifiers)}}};return typeof y=="object"&&(0,w.$fo)(k,y,!1),Object.freeze(k)}g(l){const $=I=>(0,R.$hg)(I)?new Proxy(I,{get:(D,y)=>$(D[y]),set:(D,y,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(y)}' of object`)},deleteProperty:(D,y)=>{throw new Error(`TypeError: Cannot delete read only property '${String(y)}' of object`)},defineProperty:(D,y)=>{throw new Error(`TypeError: Cannot define property '${String(y)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):I;return $(l)}h(l,$,I){const D=c.$Eo.test(l)?c.ConfigurationScope.RESOURCE:this.d.get(l),y=I?`[${I.value}] `:"";if(c.ConfigurationScope.RESOURCE===D){typeof $?.resource>"u"&&this.f.warn(`${y}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c.ConfigurationScope.WINDOW===D){$?.resource&&this.f.warn(`${y}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,$){const I=new p.$Po(l,$,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,y)=>I.affectsConfiguration(D,i(y))})}k(l){return l.reduce(($,I)=>($.set(I[0],I[1]),$),new Map)}}e.$Ync=m,e.$Znc=(0,u.$Fi)("IExtHostConfiguration")}),define(Ce[130],Ie([1,0,2,11,4,6,7,44,58,45,22,57,17,27,3,16,21,12,85,251,14]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=e.$vpc=e.$upc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=qe(A),o=qe(o);var i;(function(O){function q(W){if(W!=null)return W}O.from=q;function G(W){if(W!=null)return W}O.to=G})(i||(i={}));var t;(function(O){function q(W){if(W!=null)return W}O.from=q;function G(W){if(W!=null)return W}O.to=G})(t||(t={}));var m;(function(O){function q(W){if(W!=null)return W}O.from=q;function G(W){if(W!=null)return W}O.to=G})(m||(m={}));var f;(function(O){function q(F){if(F){const V=F;return V&&!!V.process}else return!1}O.is=q;function G(F){if(F==null)return;const V={process:F.process,args:F.args};return F.options&&(V.options=m.from(F.options)),V}O.from=G;function W(F){if(F!=null)return new A.$cO(F.process,F.args,F.options)}O.to=W})(f||(f={}));var l;(function(O){function q(W){if(W!=null)return W}O.from=q;function G(W){if(W!=null)return W}O.to=G})(l||(l={}));var $;(function(O){function q(F){if(F){const V=F;return V&&(!!V.commandLine||!!V.command)}else return!1}O.is=q;function G(F){if(F==null)return;const V={};return F.commandLine!==void 0?V.commandLine=F.commandLine:(V.command=F.command,V.args=F.args),F.options&&(V.options=l.from(F.options)),V}O.from=G;function W(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$dO(F.commandLine,F.options):new A.$dO(F.command,F.args?F.args:[],F.options)}O.to=W})($||($={}));var I;(function(O){function q(F){if(F){const V=F;return V&&V.customExecution==="customExecution"}else return!1}O.is=q;function G(F){return{customExecution:"customExecution"}}O.from=G;function W(F,V){return V.get(F)}O.to=W})(I||(e.CustomExecutionDTO=I={}));var D;(function(O){function q(G,W){let F;return G.scope!==void 0&&typeof G.scope!="number"?F=G.scope.uri:G.scope!==void 0&&typeof G.scope=="number"&&(G.scope===A.TaskScope.Workspace&&W&&W.workspaceFile?F=W.workspaceFile:F=n.$EI),{id:G._id,workspaceFolder:F}}O.from=q})(D||(e.TaskHandleDTO=D={}));var y;(function(O){function q(G){if(G!=null)return{_id:G.id,isDefault:G.isDefault}}O.from=q})(y||(y={}));var S;(function(O){function q(F,V){if(F==null)return[];const ce=[];for(const ge of F){const te=G(ge,V);te&&ce.push(te)}return ce}O.fromMany=q;function G(F,V){if(F==null)return;let ce;F.execution instanceof A.$cO?ce=f.from(F.execution):F.execution instanceof A.$dO?ce=$.from(F.execution):F.execution&&F.execution instanceof A.$eO&&(ce=I.from(F.execution));const ge=i.from(F.definition);let te;return F.scope?typeof F.scope=="number"?te=F.scope:te=F.scope.uri:te=A.TaskScope.Workspace,!ge||!te?void 0:{_id:F._id,definition:ge,name:F.name,source:{extensionId:V.identifier.value,label:F.source,scope:te},execution:ce,isBackground:F.isBackground,group:y.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}O.from=G;async function W(F,V,ce){if(F==null)return;let ge;f.is(F.execution)?ge=f.to(F.execution):$.is(F.execution)?ge=$.to(F.execution):I.is(F.execution)&&(ge=I.to(F._id,ce));const te=i.to(F.definition);let me;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?me=F.source.scope:me=await V.resolveWorkspaceFolder(w.URI.revive(F.source.scope)):me=A.TaskScope.Workspace),!te||!me)return;const se=new A.$fO(te,me,F.name,F.source.label,ge,F.problemMatchers);return F.isBackground!==void 0&&(se.isBackground=F.isBackground),F.group!==void 0&&(se.group=A.$bO.from(F.group._id),se.group&&F.group.isDefault&&(se.group=new A.$bO(se.group.id,se.group.label),F.group.isDefault===!0&&(se.group.isDefault=F.group.isDefault))),F.presentationOptions&&(se.presentationOptions=t.to(F.presentationOptions)),F._id&&(se._id=F._id),F.detail&&(se.detail=F.detail),se}O.to=W})(S||(e.TaskDTO=S={}));var k;(function(O){function q(W){return W}O.from=q;function G(W){if(W)return Object.assign(Object.create(null),W)}O.to=G})(k||(k={}));class g{#e;constructor(q,G,W){this._id=G,this.a=W,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let b=class{constructor(q,G,W,F,V,ce,ge,te){this.q=new P.$me,this.r=new P.$me,this.s=new P.$me,this.u=new P.$me,this.a=q.getProxy(T.$qN.MainThreadTask),this.b=W,this.c=F,this.d=V,this.e=ce,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=te,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,G,W){if(!W)return new A.$sN(()=>{});const F=this.x();return this.j.set(F,{type:G,provider:W,extension:q}),this.a.$registerTaskProvider(F,G),new A.$sN(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(q,G){this.a.$registerTaskSystem(q,G)}fetchTasks(q){return this.a.$fetchTasks(k.from(q)).then(async G=>{const W=[];for(const F of G){const V=await S.to(F,this.b,this.m);V&&W.push(V)}return W})}get taskExecutions(){const q=[];return this.k.forEach(G=>q.push(G)),q}terminateTask(q){if(!(q instanceof g))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,G,W){const F=this.m.get(q.id);F&&(this.o.set(q.id,F),this.e.attachPtyToTerminal(G,await F.callback(W))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const G=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:G})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const G=await this.z(q.id);this.s.fire({execution:G,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const G=await this.z(q.id);this.u.fire({execution:G,exitCode:q.exitCode})}$provideTasks(q,G){const W=this.j.get(q);if(!W)return Promise.reject(new Error("no handler found"));const F=[],V=(0,C.$xh)(()=>W.provider.provideTasks(R.CancellationToken.None)).then(ce=>this.v(G,F,W,ce));return new Promise(ce=>{V.then(ge=>{Promise.all(F).then(()=>{ce(ge)})})})}async $resolveTask(q,G){const W=this.j.get(q);if(!W)return Promise.reject(new Error("no handler found"));if(G.definition.type!==W.type)throw new Error(`Unexpected: Task of type [${G.definition.type}] cannot be resolved by provider of type [${W.type}].`);const F=await S.to(G,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const V=await W.provider.resolveTask(F,R.CancellationToken.None);if(!V)return;this.A(V,W);const ce=S.from(V,W.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(V.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return I.is(ce.execution)&&await this.y(ce,V,!0),await this.w(ce)}x(){return this.h++}async y(q,G,W){const F=await this.a.$createTaskId(q);!W&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,G.execution)),this.m.set(F,G.execution)}async z(q,G){if(typeof q=="string"){const V=this.l.get(q);if(!V)throw new s.$db("Unexpected: The specified task is missing an execution");return V}const W=this.l.get(q.id);if(W)return W;let F;return G?F=Promise.resolve(new g(this,q.id,G)):F=S.to(q.task,this.b,this.m).then(V=>{if(!V)throw new s.$db("Unexpected: Task does not exist.");return new g(this,q.id,V)}),this.l.set(q.id,F),F.then(V=>(this.k.set(q.id,V),V))}A(q,G){q._deprecated&&this.g.report("Task.constructor",G.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const W=this.n.values();let F=W.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=W.next()}};e.$upc=b,e.$upc=b=Qe([Ve(0,u.$WP),Ve(1,E.$aQ),Ve(2,N.$Wnc),Ve(3,p.$8P),Ve(4,c.$Znc),Ve(5,v.$loc),Ve(6,a.$_j),Ve(7,h.$Anc)],b);let L=class extends b{constructor(q,G,W,F,V,ce,ge,te){super(q,G,W,F,V,ce,ge,te),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(o.Platform.Web)})}async executeTask(q,G){if(!G.execution)throw new Error("Tasks to execute must include an execution");const W=S.from(G,q);if(W===void 0)throw new Error("Task is not valid");if(I.is(W.execution))await this.y(W,G,!1);else throw new s.$bb;const F=await this.z(await this.a.$getTaskExecution(W),G);return this.a.$executeTask(W).catch(V=>{throw new Error(V)}),F}v(q,G,W,F){const V=[];if(F)for(const ce of F){if(this.A(ce,W),!ce.definition||!q[ce.definition.type]){const te=ce.source?ce.source:"No task source";this.f.warn(`The task [${te}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`)}const ge=S.from(ce,W.extension);ge&&I.is(ge.execution)?(V.push(ge),G.push(this.y(ge,ce,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:V,extension:W.extension}}async w(q){if(I.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,G){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,G,W){}};e.$vpc=L,e.$vpc=L=Qe([Ve(0,u.$WP),Ve(1,E.$aQ),Ve(2,N.$Wnc),Ve(3,p.$8P),Ve(4,c.$Znc),Ve(5,v.$loc),Ve(6,a.$_j),Ve(7,h.$Anc)],L),e.$wpc=(0,d.$Fi)("IExtHostTask")}),define(Ce[309],Ie([1,0,43,33]),function(oe,e,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dM=void 0,e.$cM=P,e.$eM=T;function P(A){return"cellResults"in A}e.$dM="rawCell#";function T(A,N){let p=-1;const c=[];let R=[];return A.forEach(u=>{u.range.startLineNumber!==p&&R.length>0&&(c.push([...R]),R=[]),R.push(u),p=u.range.endLineNumber}),R.length>0&&c.push([...R]),c.map(u=>{const E=[],d=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=d;o<=r;o++)E.push(N.getLineContent(o));return new w.$SL(E.join(`
`)+`
`,u.map(o=>new C.$It(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[310],Ie([1,0,185,23,4,5,29,38,13,15,2,30,80,6,34,10,7,39,287,123,26,16,43,240,309,307]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0oc=void 0,v=qe(v),r=qe(r),o=qe(o);class ${static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,y,S,k,g,b,L){this.q=S,this.r=k,this.s=g,this.t=b,this.u=L,this.f=new Map,this.g=new A.$Cc,this.h=new Map,this.j=new P.$me,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$me,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$me,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$me,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$ync("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(E.$qN.MainThreadNotebook),this.c=D.getProxy(E.$qN.MainThreadNotebookDocuments),this.d=D.getProxy(E.$qN.MainThreadNotebookEditors),this.i=y.converter,y.registerArgumentProcessor({processArgument:O=>{if(O&&O.$mid===N.MarshalledId.NotebookCellActionContext){const q=O.notebookEditor?.notebookUri,G=O.cell.handle,F=this.g.get(q)?.getCell(G);if(F)return F.apiCell}if(O&&O.$mid===N.MarshalledId.NotebookActionContext){const q=O.uri,G=this.g.get(q);if(G)return G.apiNotebook}return O}}),$.C(y)}getEditorById(D){const y=this.h.get(D);if(!y)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return y}getIdByEditor(D){for(const[y,S]of this.h)if(S.apiEditor===D)return y}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,y){const S=this.g.get(D);if(!S&&!y)throw new Error(`NO notebook document for '${D}'`);return S}static w(D,y){if(!y)return;const S=y.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(y.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${y.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:y.displayName,filenamePattern:S,priority:y.exclusive?l.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,y,S){const k=$.a++,g=typeof S.onDidChangeCellStatusBarItems=="function"?$.a++:void 0;this.f.set(k,S),this.b.$registerNotebookCellStatusBarItemProvider(k,g,y);let b;return g!==void 0&&(b=S.onDidChangeCellStatusBarItems(L=>this.b.$emitCellStatusBarEvent(g))),new o.$sN(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,g),b?.dispose()})}async createNotebookDocument(D){const y=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return R.URI.revive(y)}async openNotebookDocument(D){const y=this.g.get(D);if(y)return y.apiNotebook;const S=await this.c.$tryOpenNotebook(D),k=this.g.get(R.URI.revive(S));return(0,c.$qg)(k?.apiNotebook)}async showNotebookDocument(D,y){R.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let S;typeof y=="object"?S={position:r.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selections:y.selections&&y.selections.map(r.NotebookRange.from),pinned:typeof y.preview=="boolean"?!y.preview:void 0}:S={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,S),g=k&&this.h.get(k)?.apiEditor;if(g)return g;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,y,S,k){const g=this.f.get(D),b=R.URI.revive(y),L=this.g.get(b);if(!L||!g)return;const O=L.getCellFromIndex(S);if(!O)return;const q=await g.provideCellStatusBarItems(O.apiCell,k);if(!q)return;const G=new T.$Vc,W=this.p.add([G]),V=(Array.isArray(q)?q:[q]).map(ce=>r.NotebookStatusBarItem.from(ce,this.i,G));return{cacheId:W,items:V}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,y,S,k,g){if((0,p.$df)(y))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:y,serializer:S,options:k}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},y,r.NotebookDocumentContentOptions.from(k),$.w(D,g)),(0,T.$Uc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,y,S){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const g=await k.serializer.deserializeNotebook(y.buffer,S);return new a.$Qw(r.NotebookData.from(g))}async $notebookToData(D,y,S){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const g=await k.serializer.serializeNotebook(r.NotebookData.to(y.value),S);return C.$Oe.wrap(g)}async $saveNotebook(D,y,S,k,g){const b=R.URI.revive(y),L=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${S}, ${b.toString()})`),!L)throw new Error("NO serializer found");const O=this.g.get(b);if(!O)throw new Error("Document NOT found");if(O.versionId!==S)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new v.$ul((0,w.localize)(0,null,this.A(b)),v.FileOperationResult.FILE_PERMISSION_DENIED);const q={metadata:(0,s.$ko)(O.apiNotebook.metadata,ce=>!(L.options?.transientDocumentMetadata??{})[ce]),cells:[]};for(const ce of O.apiNotebook.getCells()){const ge=new o.$VO(ce.kind,ce.document.getText(),ce.document.languageId,ce.mime,L.options?.transientOutputs?[]:[...ce.outputs],ce.metadata,ce.executionSummary);ge.metadata=(0,s.$ko)(ce.metadata,te=>!(L.options?.transientCellMetadata??{})[te]),q.cells.push(ge)}if(await this.z(b,k),g.isCancellationRequested)throw new Error("canceled");const G=await L.serializer.serializeNotebook(q,g);if(g.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${S} ${b.toString()}`),await this.s.value.writeFile(b,G),this.D(`Finished write versionId: ${S} ${b.toString()}`);const W=this.s.getFileSystemProviderExtUri(b.scheme),F=await this.s.value.stat(b),V={name:W.basename(b),isFile:(F.type&v.FileType.File)!==0,isDirectory:(F.type&v.FileType.Directory)!==0,isSymbolicLink:(F.type&v.FileType.SymbolicLink)!==0,mtime:F.mtime,ctime:F.ctime,size:F.size,readonly:!!((F.permissions??0)&v.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((F.permissions??0)&v.FilePermission.Locked),etag:v.$Fl({mtime:F.mtime,size:F.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${S}, ${b.toString()})`),V}async $searchInNotebooks(D,y,S,k,g){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const L=new A.$Dc;await(async(F,V,ce)=>{await Promise.all(F.map(async ge=>await Promise.all(ge.filenamePatterns.map(te=>{const me={_reason:ce._reason,folderQueries:ce.folderQueries,includePattern:ce.includePattern,excludePattern:ce.excludePattern,maxResults:ce.maxResults,type:t.QueryType.File,filePattern:te};return this.t.doInternalFileSearchWithCustomCallback(me,V,se=>{se.forEach(de=>{L.has(de)||k.some(re=>ge.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Pe=>(0,l.$dL)(Pe,de)))||L.add(de)})}).catch(se=>{if(se.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw se})}))))})(S,g,y);const q=new A.$Cc;let G=!1;const W=Array.from(L).map(async F=>{const V=[];try{if(g.isCancellationRequested)return;if(y.maxResults&&[...q.values()].reduce((me,se)=>me+se.cellResults.length,0)>y.maxResults){G=!0;return}const ce=[],ge=this.g.get(F);if(ge)ge.apiNotebook.getCells().forEach(se=>ce.push({input:se.document.getText(),outputs:se.outputs.flatMap(de=>de.items.map(be=>be.data.toString()))}));else{const me=await this.s.value.readFile(F),se=C.$Oe.fromString(me.toString()),de=await b.deserializeNotebook(se.buffer,g);if(g.isCancellationRequested)return;r.NotebookData.from(de).cells.forEach(re=>ce.push({input:re.source,outputs:re.outputs.flatMap(Pe=>Pe.items.map(Le=>Le.valueBytes.toString()))}))}if(g.isCancellationRequested)return;ce.forEach((me,se)=>{const de=y.contentPattern.pattern,be=new m.$VYb(me.input,void 0,me.outputs),re=be.findInInputs(de),Pe=be.findInOutputs(de),Le=Pe.flatMap(Y=>(0,f.$eM)(Y.matches,Y.textBuffer)).map((Y,B)=>(Y.webviewIndex=B,Y));if(re.length>0||Pe.length>0){const Y={index:se,contentResults:(0,f.$eM)(re,be.inputTextBuffer),webviewResults:Le};V.push(Y)}});const te={resource:F,cellResults:V};q.set(F,te);return}catch{return}});return await Promise.all(W),{limitHit:G,results:[...q.values()]}}async z(D,y){const S=await this.s.value.stat(D);if(typeof y?.mtime=="number"&&typeof y.etag=="string"&&y.etag!==v.$El&&typeof S.mtime=="number"&&typeof S.size=="number"&&y.mtime<S.mtime&&y.etag!==v.$Fl({mtime:y.mtime,size:S.size}))throw new v.$ul((0,w.localize)(1,null),v.FileOperationResult.FILE_MODIFIED_SINCE,y)}A(D){return D.scheme===i.Schemas.file?D.fsPath:D.toString()}B(D,y,S){if(this.h.has(y))throw new Error(`editor with id ALREADY EXSIST: ${y}`);const k=new n.$1oc(y,this.d,D,S.visibleRanges.map(r.NotebookRange.to),S.selections.map(r.NotebookRange.to),typeof S.viewColumn=="number"?r.ViewColumn.to(S.viewColumn):void 0);this.h.set(y,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const S of D.value.removedDocuments){const k=R.URI.revive(S),g=this.g.get(k);g&&(g.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(g.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===k.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const S=[];for(const k of D.value.addedDocuments){const g=R.URI.revive(k.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const b=new h.$Zoc(this.c,this.q,this.r,g,k);S.push(...k.cells.map(L=>h.$Yoc.asModelAddData(L))),this.g.get(g)?.dispose(),this.g.set(g,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const S of D.value.addedEditors){if(this.h.has(S.id))return;const k=R.URI.revive(S.documentUri),g=this.g.get(k);g&&this.B(g,S.id,S)}const y=[];if(D.value.removedEditors)for(const S of D.value.removedEditors){const k=this.h.get(S);k&&(this.h.delete(S),this.k?.id===k.id&&(this.k=void 0),y.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const S=new Set;this.l.forEach(k=>S.add(k.id));for(const k of this.h.values()){const g=S.has(k.id);k._acceptVisibility(g)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const y=d.$iQ.String.with("notebookType","A notebook type"),S=new d.$kQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[y,new d.$iQ("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>C.$Oe.wrap(g))],new d.$jQ("Notebook Data",g=>r.NotebookData.to(g.value))),k=new d.$kQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[y,new d.$iQ("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new a.$Qw(r.NotebookData.from(g)))],new d.$jQ("Bytes",g=>g.buffer));D.registerApiCommand(S),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$0oc=$}),define(Ce[311],Ie([1,0,20,22,48,41,24,70,43]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0,w=qe(w),T=qe(T),A=qe(A);class c{constructor(u,E,d){this.k=u,this.l=E,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&T.$zk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&T.$zk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const E=this.k.folderQueries||[];return new Promise((d,r)=>{const o=a=>{this.f++,u(a)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(a=>{const h=a.toString(),n=w.$pc(h);this.j&&this.j(h,n)||this.v(o,{base:a,basename:n})}),Promise.all(E.map(a=>this.p(a,o))).then(a=>{d({limitHit:this.e,stats:a[0]||void 0})},a=>{r(new Error((0,P.$qj)(a)))})})}async p(u,E){const d=new C.$xe,r=this.q(u),o=this.r(),a=new p.$7L(this.k,u),h=!a.hasSiblingExcludeClauses();let n;try{this.h.add(d),n=N.$ge.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),i=n.elapsed(),t=N.$ge.create();return this.g&&!this.e||(s&&s.forEach(m=>{const f=w.$ic.relative(u.folder.path,m.path);if(h){const l=w.$pc(m.path);this.v(E,{base:u.folder,relativePath:f,basename:l});return}this.s(o,u.folder,f,E)}),this.g&&!this.e)?null:(this.u(o,a,E),{providerTime:i,postProcessTime:t.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(u){const E=(0,p.$6L)(this.k.includePattern,u.includePattern),d=(0,p.$6L)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:d,includes:E,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},E,d,r){if(d===this.a){const a=w.$pc(this.a);this.v(r,{base:E,relativePath:this.a,basename:a})}function o(a){const h=w.$pc(a),n=w.$oc(a);let s=u[n];s||(s=u[n]=[],o(n)),s.push({base:E,relativePath:a,basename:h})}o(d)}u({rootEntries:u,pathToEntries:E},d,r){const o=this,a=this.a;function h(n){const s=(0,p.$9L)(()=>n.map(i=>i.basename));for(let i=0,t=n.length;i<t;i++){const m=n[i],{relativePath:f,basename:l}=m;if(d.matchesExcludesSync(f,l,a!==l?s:void 0))continue;const $=E[f];if($)h($);else{if(f===a)continue;o.v(r,m)}if(o.e)break}}h(u)}v(u,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(E))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,E,d,r){const o=this.c(u.cacheKey),a=new c(u,E,o&&o.token);let h=0;const n=s=>{h+=s.length,d(s.map(i=>this.d(i)))};return this.e(a,R.a,n,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new C.$xe),this.b.get(u)}d(u){return u.relativePath?{resource:A.$gh(u.base,u.relativePath)}:{resource:u.base}}e(u,E,d,r){const o=r.onCancellationRequested(()=>{u.cancel()}),a=n=>{n&&(h.push(n),E>0&&h.length>=E&&(d(h),h=[]))};let h=[];return u.search(a).then(n=>(h.length&&d(h),o.dispose(),n),n=>(h.length&&d(h),o.dispose(),Promise.reject(n)))}}e.$2oc=R}),define(Ce[312],Ie([1,0,18,282,41,103,29,16,20,24,13,15,2,102,205,42,12,50,117,308,43]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0,e.$8M=y,w=qe(w),C=qe(C),P=qe(P),p=qe(p),R=qe(R),d=qe(d);let i=class{constructor(k,g,b,L,O){this.a=k,this.b=g,this.c=b,this.d=L,this.e=O}text(k,g,b={}){k=this.f(k,b);const L=this.a.getValue(),O=g&&g.some(G=>!this.a.getValue({resource:G}).search.useRipgrep);return{...this.h(g?.map(a.$1i),b),type:s.QueryType.Text,contentPattern:k,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:L.search.usePCRE2||O||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(k,g){const b=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const L={...k,wordSeparators:b.editor.wordSeparators};return this.j(k,g)&&(L.isCaseSensitive=!0),this.k(k)&&(L.isMultiline=!0),g.notebookSearchConfig?.includeMarkupInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownInput=g.notebookSearchConfig.includeMarkupInput),g.notebookSearchConfig?.includeMarkupPreview&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookMarkdownPreview=g.notebookSearchConfig.includeMarkupPreview),g.notebookSearchConfig?.includeCodeInput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellInput=g.notebookSearchConfig.includeCodeInput),g.notebookSearchConfig?.includeOutput&&(L.notebookInfo||(L.notebookInfo={}),L.notebookInfo.isInNotebookCellOutput=g.notebookSearchConfig.includeOutput),L}file(k,g={}){return{...this.h(k,g),type:s.QueryType.File,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey,shouldGlobMatchFilePattern:g.shouldGlobSearch}}g(k,g){return k?(k=Array.isArray(k)?k.map($):$(k),g?this.parseSearchPaths(k):{pattern:m(...Array.isArray(k)?k:[k])}):{}}h(k=[],g={}){const b=this.g(g.includePattern,g.expandPatterns),L=this.g(g.excludePattern,g.expandPatterns),O=k.length>1,q=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(F=>this.q(F,g,L)):k.map(F=>this.r(F,g,L,O))).filter(F=>!!F),G={_reason:g._reason,folderQueries:q,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:L.pattern,includePattern:b.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const F=w.$Jb(this.c.groups.flatMap(ge=>ge.editors.map(te=>te.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const V=F.filter(ge=>(0,s.$WL)(G,ge.fsPath)),ce=this.i(V);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ce)),{...G,...ce}}const W=g.extraFileResources&&g.extraFileResources.filter(F=>(0,s.$WL)(G,F.fsPath));return G.extraFileResources=W&&W.length?W:void 0,G}i(k){const g=[],b=new A.$Cc,L={};let O=!1;return k.forEach(q=>{if(q.scheme===N.Schemas.walkThrough)return;if((0,c.$kh)(q)){const W=this.b.getWorkspaceFolder(q)?.uri??q.with({path:p.$oc(q.fsPath)});let F=b.get(W);F||(O=!0,F={folder:W,includePattern:{}},g.push(F),b.set(W,F));const V=p.$nc(W.fsPath,q.fsPath);(0,v.$qg)(F.includePattern)[V.replace(/\\/g,"/")]=!0}else q.fsPath&&(O=!0,L[q.fsPath]=!0)}),{folderQueries:g,includePattern:L,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}j(k,g){if(g.isSmartCase){if(k.isRegExp){if(R.$9f(k.pattern,!0))return!0}else if(R.$9f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,E.$$C)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const g=ce=>p.$kc(ce)||/^\.\.?([\/\\]|$)/.test(ce),L=(Array.isArray(k)?k:f(k)).map(ce=>{const ge=this.e.resolvedUserHome;return ge?(0,T.$Vw)(ce,ge.scheme===N.Schemas.file?ge.fsPath:ge.path):ce}),O=C.$K(L,ce=>g(ce)?"searchPaths":"exprSegments"),q=(O.exprSegments||[]).map(ce=>R.$of(ce,"/")).map(ce=>R.$of(ce,"\\")).map(ce=>(ce[0]==="."&&(ce="*"+ce),l(ce))),G={},W=this.m(O.searchPaths||[]);W&&W.length&&(G.searchPaths=W);const F=q.flat(),V=m(...F);return V&&(G.pattern=V),G}l(k,g){return g.disregardExcludeSettings?void 0:(0,s.$VL)(k,!g.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const g=k.flatMap(L=>{let{pathPortion:O,globPortion:q}=t(L);return q&&(q=I(q)),this.n(O).flatMap(W=>this.o(W,q))}),b=new Map;return g.forEach(L=>{const O=L.searchPath.toString(),q=b.get(O);q?L.pattern&&(q.pattern=q.pattern||{},q.pattern[L.pattern]=!0):b.set(O,{searchPath:L.searchPath,pattern:L.pattern?m(L.pattern):void 0})}),Array.from(b.values())}n(k){if(p.$kc(k)){const g=this.b.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==N.Schemas.file?[{searchPath:g[0].uri.with({path:k})}]:[{searchPath:u.URI.file(p.$jc(k))}]}if(this.b.getWorkbenchState()===a.WorkbenchState.FOLDER){const g=this.b.getWorkspace().folders[0].uri;if(k=$(k),k.startsWith("../")||k===".."){const L=p.$ic.resolve(g.path,k);return[{searchPath:g.with({path:L})}]}const b=I(k);return[{searchPath:g,pattern:b}]}else{if(k==="./"||k===".\\")return[];{const g=k.replace(/^\.[\/\\]/,""),L=this.b.getWorkspace().folders.map(O=>{const q=g.match(new RegExp(`^${R.$if(O.name)}(?:/(.*)|$)`));return q?{match:q,folder:O}:null}).filter(v.$ng);if(L.length)return L.map(O=>{const q=O.match[1];return{searchPath:O.folder.uri,pattern:q&&I(q)}});{const O=k.match(/\.[\/\\](.+)[\/\\]?/),q=O?O[1]:k,G=d.localize(0,null,q);throw new Error(G)}}}}o(k,g){const b=k.pattern&&g?`${k.pattern}/${g}`:k.pattern||g,L=[{searchPath:k.searchPath,pattern:b}];return b&&!b.endsWith("**")&&L.push({searchPath:k.searchPath,pattern:b+"/**"}),L}q(k,g,b){const L=this.r((0,a.$1i)(k.searchPath),g,b,!1);return L?{...L,includePattern:k.pattern}:null}r(k,g,b,L){let O;const q=u.URI.isUri(k)?k:k.uri;if(b.searchPaths){const ce=b.searchPaths.filter(ge=>(0,c.$_g)(ge.searchPath,q))[0];if(ce&&!ce.pattern)return null;ce&&(O=ce.pattern)}const G=this.a.getValue({resource:q}),F={...this.l(G,g)||{},...O||{}},V=u.URI.isUri(k)?(0,c.$dh)(k):k.name;return{folder:q,folderName:L?V:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:G.files&&G.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!G.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!G.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!G.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!G.search.followSymlinks}}};e.$7M=i,e.$7M=i=Qe([Ve(0,r.$_i),Ve(1,a.$Oi),Ve(2,h.$gE),Ve(3,o.$_j),Ve(4,n.$5M)],i);function t(S){const k=S.match(/[\*\{\}\(\)\[\]\?]/);if(k){const g=k.index,b=S.substr(0,g).match(/[/|\\][^/\\]*$/);if(b){let L=S.substr(0,b.index);return L.match(/[/\\]/)||(L+="/"),{pathPortion:L,globPortion:S.substr((b.index||0)+1)}}}return{pathPortion:S}}function m(...S){return S.length?S.reduce((k,g)=>(k[g]=!0,k),Object.create(null)):void 0}function f(S){return P.$xk(S,",").map(k=>k.trim()).filter(k=>!!k.length)}function l(S){return[`**/${S}/**`,`**/${S}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function $(S){return S.replace(/\\/g,"/")}function I(S){return $(S).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(S){return S.replace(/([?*[\]])/g,"[$1]")}function y(S,k){S=w.$Ob(S,L=>L.toString());const g=[],b=k.getWorkspace();return S&&S.forEach(L=>{let O;if(k.getWorkbenchState()===a.WorkbenchState.FOLDER)O=(0,c.$ih)(b.folders[0].uri,L),O&&O!=="."&&(O="./"+O);else{const q=k.getWorkspaceFolder(L);if(q){const G=q.name;if(b.folders.filter(F=>F.name===G).length===1){const F=(0,c.$ih)(q.uri,L);F===""?O=`./${q.name}`:O=`./${q.name}/${F}`}else O=L.fsPath}}O&&g.push(D(O))}),g}}),define(Ce[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fxb=u,e.$Gxb=r,w=qe(w),T=qe(T);const v=7e3;function u(o,a){const h=a.activationEvents;if(!h)return Promise.resolve(void 0);const n=[],s=[];for(const $ of h)if(/^workspaceContains:/.test($)){const I=$.substr(18);I.indexOf("*")>=0||I.indexOf("?")>=0||o.forceUsingSearch?s.push(I):n.push(I)}if(n.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:i,resolve:t}=(0,R.$yh)(),m=$=>t({activationEvent:$}),f=Promise.all(n.map($=>E(o,$,m))).then(()=>{}),l=d(o,a.identifier,s,m);return Promise.all([f,l]).then(()=>{t(void 0)}),i}async function E(o,a,h){for(const n of o.folders)if(await o.exists(w.$gh(C.URI.revive(n),a))){h(`workspaceContains:${a}`);return}}async function d(o,a,h,n){if(h.length===0)return Promise.resolve(void 0);const s=new P.$xe,i=o.checkExists(o.folders,h,s.token),t=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${a.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},v);let m=!1;try{m=await i}catch(f){T.$6(f)||T.$3(f)}s.dispose(),clearTimeout(t),m&&n(`workspaceContains:${h.join(",")}`)}function r(o,a,h,n){const s=o.get(A.$Ei),i=o.get(p.$NL),m=s.createInstance(N.$7M).file(a.map(f=>(0,c.$1i)(C.URI.revive(f))),{_reason:"checkExists",includePattern:h,exists:!0});return i.fileSearch(m,n).then(f=>!!f.limitHit,f=>T.$6(f)?!1:Promise.reject(f))}}),define(Ce[46],Ie([1,0,181,20,65,24,11,5,59,2,12,6,45,247,89,44,25,118,14,19,23,229,7,109,3,27,92,17,75,93,57,95,4,313,88,231,16,86,70,21,87]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l,$,I,D,y,S,k,g,b,L,O,q,G,W,F,V){"use strict";var ce;Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=e.$Boc=e.$Aoc=e.$zoc=e.$yoc=void 0,w=qe(w),C=qe(C),P=qe(P),h=qe(h),e.$yoc=(0,f.$Fi)("IHostUtils");let ge=ce=class extends N.$Wc{constructor(Y,B,_,ve,ae,we,le,X,Z,pe,$e,Ne,ze){super(),this.Y=Ne,this.Z=ze,this.a=this.B(new g.$me),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=_,this.f=le,this.j=ve,this.m=ae,this.s=we,this.t=Z,this.u=pe,this.w=$e,this.y=this.g.getProxy(v.$qN.MainThreadWorkspace),this.z=this.g.getProxy(v.$qN.MainThreadTelemetry),this.C=this.g.getProxy(v.$qN.MainThreadExtensionService),this.D=new A.$Eh,this.F=new A.$Eh,this.G=new A.$Eh,this.H=new A.$Eh,this.I=new Pe(this.f.extensions.activationEvents),this.L=new a.$5bc(this.I,this.f.extensions.allExtensions);const ke=new n.$rn(this.f.extensions.myExtensions);this.J=new a.$5bc(this.I,be(this.L,ke)),F.$t&&(this.s.info(`Creating extension host with the following global extensions: ${se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${se(this.J)}`)),this.M=new d.$hoc(this.g,this.s),this.N=new L.$roc(this.g),this.O=X,this.h=Y.createChild(new D.$Di([d.$ioc,this.M],[L.$soc,this.N])),this.P=this.B(new E.$goc(this.J,this.L,{onExtensionActivationError:(Re,Te,U)=>{this.C.$onExtensionActivationError(Re,h.$5(Te),U)},actualActivateExtension:async(Re,Te)=>{if(a.$5bc.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Te),new E.$foc;const U=this.J.getExtensionDescription(Re);return this.fb(U,Te)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Y){h.$3(Y)}}async $(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(Y)}terminate(Y,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),h.setUnexpectedErrorHandler(ve=>{this.s.error(ve)}),this.g.dispose();const _=this.$();Promise.race([(0,A.$Gh)(5e3),_]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const B=await this.C.$getExtension(Y);return B&&{...B,identifier:new n.$qn(B.identifier.value),extensionLocation:c.URI.revive(B.extensionLocation)}}ab(Y,B){return this.P.activateByEvent(Y,B)}bb(Y,B){return this.P.activateById(Y,B)}activateByIdWithErrors(Y,B){return this.bb(Y,B).then(()=>{const _=this.P.getActivatedExtension(Y);if(_.activationFailed)return Promise.reject(_.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async cb(Y){if(Y.scheme===q.Schemas.file&&this.c.fsRealpath){const B=Y.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const _=await this.R.get(B);return c.URI.file(_)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Y=>new re(Y))),this.Q}async db(Y){const B=p.$Li.forUris(_=>T.$0g.ignorePathCasing(_));return await Promise.all(Y.map(async _=>{if(this.wb(_)){const ve=await this.cb(_.extensionLocation);B.set(ve,_)}})),B}eb(Y){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return B;const _=this.P.getActivatedExtension(Y);if(!_)return B;try{typeof _.module.deactivate=="function"&&(B=Promise.resolve(_.module.deactivate()).then(void 0,ve=>(this.s.error(ve),Promise.resolve(void 0))))}catch(ve){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(ve)}try{(0,N.$Rc)(_.subscriptions)}catch(ve){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(ve)}return B}async fb(Y,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.hb(Y,B).then(_=>{const ve=_.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,ve.codeLoadingTime,ve.activateCallTime,ve.activateResolvedTime,B),this.gb(Y,B,"success",ve),_},_=>{throw this.gb(Y,B,"failure"),_})}gb(Y,B,_,ve){const ae=me(Y,B);this.z.$publicLog2("extensionActivationTimes",{...ae,...ve||{},outcome:_})}hb(Y,B){const _=me(Y,B);this.z.$publicLog2("activatePlugin",_);const ve=this.wb(Y);if(!ve)return Promise.resolve(new E.$eoc(E.$boc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Y.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const ae=new E.$coc(B.startup);return Promise.all([this.xb(Y,(0,T.$gh)(Y.extensionLocation,ve),ae),this.ib(Y)]).then(we=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),ce.jb(this.s,Y.identifier,we[0],we[1],ae))).then(we=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),we))}ib(Y){const B=this.Z.createLanguageModelAccessInformation(Y),_=new i.$koc(Y,this.M),ve=new i.$joc(Y.identifier.value,!1,this.M),ae=new O.$toc(Y,this.N),we=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([_.whenReady,ve.whenReady,this.O.whenReady]).then(()=>{const X=this;let Z,pe;const $e=(0,o.$4G)(Y,"ipc")?this.f.messagePorts?.get(n.$qn.toKey(Y.identifier)):void 0;return Object.freeze({globalState:_,workspaceState:ve,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return B},get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Ne){return C.$lc(Y.extensionLocation.fsPath,Ne)},get storagePath(){return X.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return X.O.globalValue(Y).fsPath},get logPath(){return C.$lc(X.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return c.URI.joinPath(X.f.logsLocation,Y.identifier.value)},get storageUri(){return X.O.workspaceValue(Y)},get globalStorageUri(){return X.O.globalValue(Y)},get extensionMode(){return we},get extension(){return Z===void 0&&(Z=new de(X,Y.identifier,Y,le,!1)),Z},get extensionRuntime(){return(0,o.$5G)(Y,"extensionRuntime"),X.extensionRuntime},get environmentVariableCollection(){return X.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!pe){if(!$e)return;const Ne=g.Event.buffer(g.Event.fromDOMEventEmitter($e,"message",ze=>ze.data));$e.start(),pe={onDidReceiveMessage:Ne,postMessage:$e.postMessage.bind($e)}}return pe}})})}static jb(Y,B,_,ve,ae){return _=_||{activate:void 0,deactivate:void 0},this.kb(Y,B,_,ve,ae).then(we=>new E.$doc(!1,null,ae.build(),_,we,ve.subscriptions))}static kb(Y,B,_,ve,ae){if(typeof _.activate=="function")try{ae.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${B.value}`);const we=typeof global=="object"?global:self,le=_.activate.apply(we,[ve]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(le).then(X=>(ae.activateResolveStop(),X))}catch(we){return Promise.reject(we)}else return Promise.resolve(_)}lb(Y,B){this.bb(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:B}).then(void 0,_=>{this.s.error(_)})}mb(Y,B=0){const ve=Date.now();(0,F.$B)(()=>{for(let ae=B;ae<Y.length;ae+=1){const we=Y[ae];for(const le of we.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-ve>50){this.mb(Y,ae);break}else this.lb(we,le)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const B=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),_=this.J.getAllExtensionDescriptions();if(B)this.mb(_);else for(const ve of _)if(ve.activationEvents)for(const ae of ve.activationEvents)ae==="onStartupFinished"&&this.lb(ve,ae)})}ob(){const Y=this.ab("*",!0).then(void 0,we=>{this.s.error(we)});this.B(this.j.onDidChangeWorkspace(we=>this.pb(we.added)));const B=this.j.workspace?this.j.workspace.folders:[],_=this.pb(B),ve=this.rb(),ae=Promise.all([ve,Y,_]).then(()=>{});return Promise.race([ae,(0,A.$Gh)(1e4)]).then(()=>{this.nb()}),ae}pb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(Y,B))).then(()=>{})}async qb(Y,B){if(this.isActivated(B.identifier))return;const _=!this.f.remote.isRemote&&!!this.f.remote.authority,ve={logService:this.s,folders:Y.map(we=>we.uri),forceUsingSearch:_||!this.c.fsExists,exists:we=>this.c.fsExists(we.fsPath),checkExists:(we,le,X)=>this.y.$checkExists(we,le,X)},ae=await(0,b.$Fxb)(ve,B);if(ae)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:ae.activationEvent}).then(void 0,we=>this.s.error(we))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Y){throw console.error(Y),Y}}async sb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:B}=this.f.environment;if(!Y||!B)throw new Error(w.localize(0,null));const _=await this.xb(null,B,new E.$coc(!1));if(!_||typeof _.run!="function")throw new Error(w.localize(1,null,B.toString()));return new Promise((ve,ae)=>{const we=(Z,pe)=>{Z?(F.$t&&this.s.error("Test runner called back with error",Z),ae(Z)):(F.$t&&(pe?this.s.info(`Test runner called back with ${pe} failures.`):this.s.info("Test runner called back with successful outcome.")),ve(typeof pe=="number"&&pe>0?1:0))},le=(0,T.$7g)(B),X=_.run(le,we);X&&X.then&&X.then(()=>{F.$t&&this.s.info("Test runner finished successfully."),ve(0)}).catch(Z=>{F.$t&&this.s.error("Test runner finished with error",Z),ae(Z instanceof Error&&Z.stack?Z.stack:String(Z))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Gh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,B){return this.S[Y]=B,(0,N.$Uc)(()=>{delete this.S[Y]})}async getRemoteExecServer(Y){const{resolver:B}=await this.ub(Y);return B?.resolveExecServer?.(Y,{resolveAttempt:0})}async ub(Y){const B=Y.indexOf("+");if(B===-1)throw new t.$yN("Not an authority that can be resolved!",m.RemoteAuthorityResolverErrorCode.InvalidAuthority);const _=Y.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${_}`,!1),{authorityPrefix:_,resolver:this.S[_]}}async $resolveAuthority(Y,B){const _=W.$ge.create(!1),ve=()=>`[resolveAuthority(${(0,m.$Ul)(Y)},${B})][${_.elapsed()}ms] `,ae=z=>this.s.info(`${ve()}${z}`),we=z=>this.s.warn(`${ve()}${z}`),le=(z,K=void 0)=>this.s.error(`${ve()}${z}`,K),X=z=>{if(z instanceof t.$yN)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},Z=async z=>{ae(`activating resolver for ${z}...`);const{resolver:K,authorityPrefix:H}=await this.ub(z);if(!K)throw le(`no resolver for ${H}`),new t.$yN(`No remote extension installed to resolve ${H}.`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:H,remoteAuthority:z}},pe=Y.split(/@|%40/g).reverse();ae(`activating remote resolvers ${pe.join(" -> ")}`);let $e;try{$e=await Promise.all(pe.map(Z)).catch(async z=>{if(!(z instanceof t.$yN)||z._code!==m.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return we(`resolving nested authorities failed: ${z.message}`),[await Z(Y)]})}catch(z){return X(z)}const Ne=new A.$Qh;Ne.cancelAndSet(()=>ae("waiting..."),1e3);let ze,ke;for(const[z,{authorityPrefix:K,resolver:H,remoteAuthority:ne}]of $e.entries())try{if(z===$e.length-1)ae("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${K}`),ze=await H.resolve(ne,{resolveAttempt:B,execServer:ke}),P.mark(`code/extHost/didResolveAuthorityOK/${K}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$xN.isManagedResolvedAuthority(ze)?ze:void 0));else{if(ae(`invoking resolveExecServer() for ${ne}`),P.mark(`code/extHost/willResolveExecServer/${K}`),ke=await H.resolveExecServer?.(ne,{resolveAttempt:B,execServer:ke}),!ke)throw new t.$yN(`Exec server was not available for ${ne}`,m.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(fe){return P.mark(`code/extHost/didResolveAuthorityError/${K}`),le("returned an error",fe),Ne.dispose(),X(fe)}Ne.dispose();const Re={environmentTunnels:ze.environmentTunnels,features:ze.tunnelFeatures?{elevation:ze.tunnelFeatures.elevation,privacyOptions:ze.tunnelFeatures.privacyOptions,protocol:ze.tunnelFeatures.protocol===void 0?!0:ze.tunnelFeatures.protocol}:void 0},Te={extensionHostEnv:ze.extensionHostEnv,isTrusted:ze.isTrusted,authenticationSession:ze.authenticationSessionForInitializingExtensions?{id:ze.authenticationSessionForInitializingExtensions.id,providerId:ze.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$xN.isManagedResolvedAuthority(ze)?"managed authority":`${ze.host}:${ze.port}`}`);let U;if(t.$xN.isManagedResolvedAuthority(ze)){const z=B;this.Y.setFactory(z,ze.makeConnection),U={authority:Y,connectTo:new m.$Rl(z),connectionToken:ze.connectionToken}}else U={authority:Y,connectTo:new m.$Sl(ze.host,ze.port),connectionToken:ze.connectionToken};return{type:"ok",value:{authority:U,options:Te,tunnelInformation:Re}}}async $getCanonicalURI(Y,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,m.$Ul)(Y)})`);const{resolver:_}=await this.ub(Y);if(!_)return null;const ve=c.URI.revive(B);if(typeof _.getCanonicalURI>"u")return ve;const ae=await(0,A.$xh)(()=>_.getCanonicalURI(ve));return ae||ve}async $startExtensionHost(Y){Y.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:B,myExtensions:_}=te(this.I,this.L,this.J,Y),ve=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(B.getAllExtensionDescriptions()),this.J.set(_),F.$t&&(this.s.info(`$startExtensionHost: global extensions: ${se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${se(this.J)}`)),this.tb()}$activateByEvent(Y,B){return B===o.ActivationKind.Immediate?this.D.wait().then(_=>this.ab(Y,!1)):this.G.wait().then(_=>this.ab(Y,!1))}async $activate(Y,B){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.bb(Y,B),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(we=>we.extensionLocation=c.URI.revive(we.extensionLocation));const{globalRegistry:B,myExtensions:_}=te(this.I,this.L,this.J,Y),ve=await this.db(_);return(await this.getExtensionPathIndex()).setSearchTree(ve),this.L.set(B.getAllExtensionDescriptions()),this.J.set(_),F.$t&&(this.s.info(`$deltaExtensions: global extensions: ${se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const B=s.$Oe.alloc(Y),_=Math.random()%256;for(let ve=0;ve<Y;ve++)B.writeUInt8(_,ve);return B}async $updateRemoteConnectionData(Y){this.X=Y,this.a.fire()}};e.$zoc=ge,e.$zoc=ge=ce=Qe([Ve(0,f.$Ei),Ve(1,e.$yoc),Ve(2,I.$WP),Ve(3,r.$Wnc),Ve(4,u.$Znc),Ve(5,R.$_j),Ve(6,l.$aQ),Ve(7,$.$3nc),Ve(8,y.$mFb),Ve(9,S.$loc),Ve(10,G.$voc),Ve(11,V.$woc),Ve(12,k.$poc)],ge);function te(Le,Y,B,_){Le.addActivationEvents(_.addActivationEvents);const ve=new a.$5bc(Le,Y.getAllExtensionDescriptions());ve.deltaExtensions(_.toAdd,_.toRemove);const ae=new n.$rn(B.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of _.myToRemove)ae.delete(le);for(const le of _.myToAdd)ae.add(le);const we=be(ve,ae);return{globalRegistry:ve,myExtensions:we}}function me(Le,Y){return{id:Le.identifier.value,name:Le.name,extensionVersion:Le.version,publisherDisplayName:Le.publisher,activationEvents:Le.activationEvents?Le.activationEvents.join(","):null,isBuiltin:Le.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function se(Le){return Le.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$Aoc=(0,f.$Fi)("IExtHostExtensionService");class de{#e;#t;#i;constructor(Y,B,_,ve,ae){this.#e=Y,this.#t=B,this.#i=_.identifier,this.id=_.identifier.value,this.extensionUri=_.extensionLocation,this.extensionPath=C.$jc((0,T.$7g)(_.extensionLocation)),this.packageJSON=_,this.extensionKind=ve,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Boc=de;function be(Le,Y){return Le.getAllExtensionDescriptions().filter(B=>Y.has(B.identifier))}class re{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$Coc=re;class Pe{constructor(Y){this.a=new n.$sn,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const B of Object.keys(Y))this.a.set(B,Y[B])}}}),define(Ce[314],Ie([1,0,65,2,6,45,25,19,17,27,3,46,12,13]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0,w=qe(w);let r=class{constructor(s,i,t,m,f,l,$){this.c=s,this.d=i,this.e=t,this.f=m,this.g=f,this.h=l,this.i=$,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const s=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new a(this.c,i,this.d,s,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(h,i,this.h.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const i of s.nodeModuleName)this.a.set(i,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(i=>s.alternativeModuleName(i))}};e.$Mpc=r,e.$Mpc=r=Qe([Ve(2,R.$Ei),Ve(3,T.$Znc),Ve(4,v.$Aoc),Ve(5,c.$aQ),Ve(6,u.$_j)],r);let o=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(s){if(s.environment.appRoot&&d.a.size){const i=(0,E.$if)(this.c(s.environment.appRoot.fsPath)),t="[a-z0-9_.-]",m=`@${t}+\\/${t}+|${t}+`,f="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${f}\\/)(${m})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const i=this.b.exec(this.c(s));if(!i)return;const[,t,m,f]=i,l=d.a.get(m);if(l!==void 0)return console.warn(`${m} as been renamed to ${l}, please update your imports`),t+l+f}c(s){return s.replace(/\\/g,"/")}};o=d=Qe([Ve(0,c.$aQ)],o);class a{constructor(s,i,t,m,f){this.c=s,this.d=i,this.e=t,this.f=m,this.g=f,this.nodeModuleName="vscode",this.a=new N.$sn}load(s,i){const t=this.d.findSubstr(i);if(t){let m=this.a.get(t.identifier);return m||(m=this.c(t,this.e,this.f),this.a.set(t.identifier,m)),m}if(!this.b){let m="";this.d.forEach((f,l)=>m+=`	${l} -> ${f.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${m}`),this.b=this.c(A.$YG,this.e,this.f)}return this.b}}let h=class{constructor(s,i,t){this.e=s,this.f=i,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$qN.MainThreadTelemetry);const m=t.getProxy(P.$qN.MainThreadWindow);this.c=(f,l)=>{const $=C.URI.parse(f);return l?this.g(f,l):$.scheme==="http"||$.scheme==="https"?m.$openUri($,f,{allowTunneling:!0}):$.scheme==="mailto"||$.scheme===this.f?m.$openUri($,f,{}):this.g(f,l)}}load(s,i,t){const m=this.e.findSubstr(i);return m&&(this.a=m.identifier.value,this.h()),this.b=t(s),this.c}g(s,i){return this.i(),this.b(s,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};h=Qe([Ve(2,p.$WP)],h)}),define(Ce[131],Ie([1,0,47,5,20,79,3,58,71,46,7,44,244,45]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=e.$Doc=void 0,P=qe(P),T=qe(T),e.$Doc=(0,A.$Fi)("IExtHostVariableResolverProvider");class d extends u.$1Q{constructor(a,h,n,s,i,t,m){function f(){if(n){const l=n.activeEditor();if(l)return l.document.uri;const $=s.tabGroups.all.find(I=>I.isActive)?.activeTab;if($!==void 0){if($.input instanceof R.$eP||$.input instanceof R.$jP)return $.input.modified;if($.input instanceof R.$dP||$.input instanceof R.$iP||$.input instanceof R.$gP)return $.input.uri}}}super({getFolderUri:l=>{const $=t.folders.filter(I=>I.name===l);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,$)=>i.getConfiguration(void 0,l).get($),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=f();if(l)return P.$jc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const l=f();if(l){const $=h.getWorkspaceFolder(l);if($)return P.$jc($.uri.fsPath)}}},getSelectedText:()=>{if(n){const l=n.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(n){const l=n.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>a.getExtension(l)},void 0,m?Promise.resolve(m):void 0,Promise.resolve(T.env))}}let r=class extends C.$Wc{constructor(a,h,n,s,i){super(),this.b=a,this.c=h,this.g=n,this.h=s,this.j=i,this.a=new w.$X(async()=>{const t=await this.h.getConfigProvider(),f={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{f.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,t,f,this.m())})}getResolver(){return this.a.value}m(){}};e.$Eoc=r,e.$Eoc=r=Qe([Ve(0,c.$Aoc),Ve(1,v.$Wnc),Ve(2,N.$8P),Ve(3,E.$Znc),Ve(4,p.$_nc)],r)}),define(Ce[132],Ie([1,0,11,4,2,5,19,3,6,71,46,17,7,44,236,81,237,45,131,35,34,10,18,96]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ooc=e.$Noc=e.$Moc=e.$Loc=e.$Koc=void 0,i=qe(i),e.$Koc=(0,N.$Fi)("IExtHostDebugService");let f=class extends T.$Wc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(k,g,b,L,O,q,G,W){super(),this.Y=g,this.Z=b,this.$=L,this.ab=O,this.bb=q,this.cb=G,this.db=W,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new C.$me),this.z=this.B(new C.$me),this.C=this.B(new C.$me),this.F=this.B(new C.$me),this.u=k.getProxy(p.$qN.MainThreadDebugService),this.I=this.B(new C.$me),this.L=this.B(new C.$me),this.G=new $(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(F=>{this.B(F.onDidChange(V=>{this.fb(F)})),this.fb(F)})}async $getVisualizerTreeItem(k,g){const b=this.gb(g);if(!b)return;const L=await this.Q.get(k)?.getTreeItem?.(b);return L?this.eb(k,L):void 0}registerDebugVisualizationTree(k,g,b){const L=A.$qn.toKey(k.identifier),O=this.ub(L,g);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.Q.set(O,b),this.u.$registerDebugVisualizerTree(O,!!b.editItem),(0,T.$Uc)(()=>{this.u.$unregisterDebugVisualizerTree(O),this.Q.delete(g)})}async $getVisualizerTreeItemChildren(k,g){const b=this.S.get(g)?.item;return b?(await this.Q.get(k)?.getChildren?.(b))?.map(O=>this.eb(k,O))||[]:[]}async $editVisualizerTreeItem(k,g){const b=this.S.get(k);if(!b)return;const L=await this.Q.get(b.provider)?.editItem?.(b.item,g);return this.eb(b.provider,L||b.item)}$disposeVisualizedTree(k){const g=this.S.get(k);if(!g)return;const b=[g.children];for(const L of b)if(L)for(const O of L)b.push(this.S.get(O)?.children),this.S.delete(O)}eb(k,g){let b=this.R.get(g);return b||(b=this.O++,this.R.set(g,b),this.S.set(b,{provider:k,item:g})),i.DebugTreeItem.from(g,b)}asDebugSourceUri(k,g){const b=k;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let L=`debug:${encodeURIComponent(b.path||"")}`,O="?";return g&&(L+=`${O}session=${encodeURIComponent(g.id)}`,O="&"),L+=`${O}ref=${b.sourceReference}`,P.URI.parse(L)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(k){const g=[];for(const b of k.getAllExtensionDescriptions())if(b.contributes){const L=b.contributes.debuggers;if(L&&L.length>0)for(const O of L)(0,o.$UH)(O)&&g.push(O.type)}this.u.$registerDebugTypes(g)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const k=[];return this.H.forEach(g=>k.push(g)),k}async $resolveDebugVisualizer(k,g){const b=this.W.get(k);if(!b)throw new Error(`No debug visualizer found with id '${k}'`);let{v:L,provider:O,extensionId:q}=b;if(L.visualization||(L=await O.resolveDebugVisualization?.(L,g)||L,b.v=L),!L.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.vb(q,L.visualization)}async $executeDebugVisualizerCommand(k){const g=this.W.get(k);if(!g)throw new Error(`No debug visualizer found with id '${k}'`);const b=g.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(k){const g=this.w.get(k.sessionId);return g&&{session:g.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,g,b,L){const O=this.gb(b),q=this.ub(k,g),G=this.P.get(q);if(!O||!G)return[];const W=await G.provideDebugVisualization(O,L);return W?W.map(F=>{const V=++this.X;this.W.set(V,{v:F,provider:G,extensionId:k});const ce=F.iconPath?this.wb(F.iconPath):void 0;return{id:V,name:F.name,iconClass:ce?.iconClass,iconPath:ce?.iconPath,visualization:this.vb(k,F.visualization)}}):[]}$disposeDebugVisualizers(k){for(const g of k)this.W.delete(g)}registerDebugVisualizationProvider(k,g,b){if(!k.contributes?.debugVisualizers?.some(q=>q.id===g))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${g})`);const L=A.$qn.toKey(k.identifier),O=this.ub(L,g);if(this.P.has(O))throw new Error(`A debug visualization provider with id '${g}' is already registered`);return this.P.set(O,b),this.u.$registerDebugVisualizer(L,g),(0,T.$Uc)(()=>{this.u.$unregisterDebugVisualizer(L,g),this.P.delete(g)})}addBreakpoints(k){const g=k.filter(O=>{const q=O.id;return this.H.has(q)?!1:(this.H.set(q,O),!0)});this.rb(g,[],[]);const b=[],L=new Map;for(const O of g)if(O instanceof u.$uO){let q=L.get(O.location.uri.toString());q||(q={type:"sourceMulti",uri:O.location.uri,lines:[]},L.set(O.location.uri.toString(),q),b.push(q)),q.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof u.$vO&&b.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(k){const g=k.filter(q=>this.H.delete(q.id));this.rb([],g,[]);const b=g.filter(q=>q instanceof u.$uO).map(q=>q.id),L=g.filter(q=>q instanceof u.$vO).map(q=>q.id),O=g.filter(q=>q instanceof u.$wO).map(q=>q.id);return this.u.$unregisterBreakpoints(b,L,O)}startDebugging(k,g,b){const L=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(k?k.uri:void 0,g,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===u.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:L&&{runId:L.runId,taskId:L.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(k){return this.u.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,g,b){if(!g)return new u.$sN(()=>{});const L=this.f++;return this.g.push({type:k,handle:L,provider:g}),this.u.$registerDebugConfigurationProvider(k,b,!!g.provideDebugConfigurations,!!g.resolveDebugConfiguration,!!g.resolveDebugConfigurationWithSubstitutedVariables,L),new u.$sN(()=>{this.g=this.g.filter(O=>O.provider!==g),this.u.$unregisterDebugConfigurationProvider(L)})}registerDebugAdapterDescriptorFactory(k,g,b){if(!b)return new u.$sN(()=>{});if(!this.nb(k,g))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${g}' debugger.`);if(this.kb(g))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const L=this.h++;return this.j.push({type:g,handle:L,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(g,L),new u.$sN(()=>{this.j=this.j.filter(O=>O.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(L)})}registerDebugAdapterTrackerFactory(k,g){if(!g)return new u.$sN(()=>{});const b=this.m++;return this.n.push({type:k,handle:b,factory:g}),new u.$sN(()=>{this.n=this.n.filter(L=>L.factory!==g)})}async $runInTerminal(k,g){return Promise.resolve(void 0)}async $substituteVariables(k,g){let b;const L=await this.tb(k);return L&&(b={uri:L.uri,name:L.name,index:L.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,g)}hb(k,g){if(k.type==="implementation")return new D(k.implementation)}ib(){}async $startDASession(k,g){const b=this,L=await this.sb(g);return this.pb(this.kb(L.type),L).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}' (extension might have failed to activate)`);const q=this.jb(O),G=this.hb(q,L);if(!G)throw new Error(`Couldn't create a debug adapter for type '${L.type}'.`);const W=G;return this.M.set(k,W),this.ob(L).then(F=>(F&&this.N.set(k,F),W.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const ce=V,ge={type:"response",seq:0,command:ce.command,request_seq:ce.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const te=await this.U.sign(ce.arguments.value);ge.body={signature:te},W.sendResponse(ge)}else throw new Error("no signer")}catch(te){ge.success=!1,ge.message=te.message,W.sendResponse(ge)}}else F&&F.onDidSendMessage&&F.onDidSendMessage(V),V=(0,o.$ZH)(V,!0),b.u.$acceptDAMessage(k,V)}),W.onError(V=>{F&&F.onError&&F.onError(V),this.u.$acceptDAError(k,V.name,V.message,V.stack)}),W.onExit(V=>{F&&F.onExit&&F.onExit(V??void 0,void 0),this.u.$acceptDAExit(k,V??void 0,void 0)}),F&&F.onWillStartSession&&F.onWillStartSession(),W.startSession()))})}$sendDAMessage(k,g){g=(0,o.$YH)(g,!1);const b=this.N.get(k);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(g),this.M.get(k)?.sendMessage(g)}$stopDASession(k){const g=this.N.get(k);this.N.delete(k),g&&g.onWillStopSession&&g.onWillStopSession();const b=this.M.get(k);return this.M.delete(k),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const g=[],b=[],L=[];if(k.added)for(const O of k.added){const q=O.id;if(q&&!this.H.has(q)){let G;if(O.type==="function")G=new u.$vO(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")G=new u.$wO(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const W=P.URI.revive(O.uri);G=new u.$uO(new u.$EN(W,new u.$tN(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,u.$sO)(G,q),this.H.set(q,G),g.push(G)}}if(k.removed)for(const O of k.removed){const q=this.H.get(O);q&&(this.H.delete(O),b.push(q))}if(k.changed){for(const O of k.changed)if(O.id){const q=this.H.get(O.id);if(q){if(q instanceof u.$vO&&O.type==="function"){const G=q;G.enabled=O.enabled,G.condition=O.condition,G.hitCondition=O.hitCondition,G.logMessage=O.logMessage,G.functionName=O.functionName}else if(q instanceof u.$uO&&O.type==="source"){const G=q;G.enabled=O.enabled,G.condition=O.condition,G.hitCondition=O.hitCondition,G.logMessage=O.logMessage,G.location=new u.$EN(P.URI.revive(O.uri),new u.$tN(O.line,O.character))}L.push(q)}}}this.rb(g,b,L)}async $acceptStackFrameFocus(k){let g;if(k){const b=await this.sb(k.sessionId);k.kind==="thread"?g=new u.$CO(b.api,k.threadId):g=new u.$BO(b.api,k.threadId,k.frameId)}this.J=g,this.L.fire(this.J)}$provideDebugConfigurations(k,g,b){return(0,w.$xh)(async()=>{const L=this.mb(k);if(!L)throw new Error("no DebugConfigurationProvider found");if(!L.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.tb(g);return L.provideDebugConfigurations(O,b)}).then(L=>{if(!L)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return L})}$resolveDebugConfiguration(k,g,b,L){return(0,w.$xh)(async()=>{const O=this.mb(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const q=await this.tb(g);return O.resolveDebugConfiguration(q,b,L)})}$resolveDebugConfigurationWithSubstitutedVariables(k,g,b,L){return(0,w.$xh)(async()=>{const O=this.mb(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const q=await this.tb(g);return O.resolveDebugConfigurationWithSubstitutedVariables(q,b,L)})}async $provideDebugAdapter(k,g){const b=this.lb(k);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const L=await this.sb(g);return this.pb(b,L).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${L.type}'`);return this.jb(O)})}async $acceptDebugSessionStarted(k){const g=await this.sb(k);this.y.fire(g.api)}async $acceptDebugSessionTerminated(k){const g=await this.sb(k);g&&(this.z.fire(g.api),this.w.delete(g.id))}async $acceptDebugSessionActiveChanged(k){this.D=k?await this.sb(k):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(k,g){(await this.sb(k))?._acceptNameChanged(g)}async $acceptDebugSessionCustomEvent(k,g){const L={session:(await this.sb(k)).api,event:g.event,body:g.body};this.F.fire(L)}jb(k){if(k instanceof u.$xO)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof u.$yO)return{type:"server",port:k.port,host:k.host};if(k instanceof u.$zO)return{type:"pipeServer",path:k.path};if(k instanceof u.$AO)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}kb(k){const g=this.j.filter(b=>b.type===k);if(g.length>0)return g[0].factory}lb(k){const g=this.j.filter(b=>b.handle===k);if(g.length>0)return g[0].factory}mb(k){const g=this.g.filter(b=>b.handle===k);if(g.length>0)return g[0].provider}nb(k,g){if(k.contributes){const b=k.contributes.debuggers;if(b&&b.length>0){for(const L of b)if(L.label&&L.type&&L.type===g)return!0}}return!1}ob(k){const b=k.configuration.type,L=this.n.filter(O=>O.type===b||O.type==="*").map(O=>(0,w.$xh)(()=>O.factory.createDebugAdapterTracker(k.api)).then(q=>q,q=>null));return Promise.race([Promise.all(L).then(O=>{const q=(0,t.$Jb)(O);if(q.length>0)return new I(q)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async pb(k,g){const b=g.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new u.$yO(b));if(k){const O=await this.Z.getExtensionRegistry();return(0,w.$xh)(()=>k.createDebugAdapterDescriptor(g.api,this.qb(g,O))).then(q=>{if(q)return q})}const L=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(g,L))}qb(k,g){}rb(k,g,b){(k.length>0||g.length>0||b.length>0)&&this.I.fire(Object.freeze({added:k,removed:g,changed:b}))}async sb(k){if(k)if(typeof k=="string"){const g=this.w.get(k);if(g)return g}else{let g=this.w.get(k.id);if(!g){const b=await this.tb(k.folderUri),L=k.parent?this.w.get(k.parent):void 0;g=new l(this.u,k.id,k.type,k.name,b,k.configuration,L?.api),this.w.set(g.id,g),this.u.$sessionCached(g.id)}return g}throw new Error("cannot find session")}tb(k){if(k){const g=P.URI.revive(k);return this.Y.resolveWorkspaceFolder(g)}return Promise.resolve(void 0)}ub(k,g){return`${k}\0${g}`}vb(k,g){if(g){if("title"in g&&"command"in g)return{type:r.DebugVisualizationType.Command};if("treeId"in g)return{type:r.DebugVisualizationType.Tree,id:`${k}\0${g.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(k){const g=this.xb(k);let b,L;return"id"in g?L=n.ThemeIcon.asClassName(g):b=g,{iconPath:b,iconClass:L}}xb(k){if(k instanceof u.$pO)return{id:k.id};const g=typeof k=="object"&&"dark"in k?k.dark:k,b=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof g=="string"?P.URI.file(g):g,light:typeof b=="string"?P.URI.file(b):b}}};e.$Loc=f,e.$Loc=f=Qe([Ve(0,v.$WP),Ve(1,E.$Wnc),Ve(2,R.$Aoc),Ve(3,a.$Znc),Ve(4,c.$_nc),Ve(5,h.$Doc),Ve(6,s.$gQ),Ve(7,m.$Foc)],f);class l{constructor(k,g,b,L,O,q,G){this.f=k,this.g=g,this.h=b,this.j=L,this.k=O,this.l=q,this.m=G}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(g){k.j=g,k.f.$setDebugSessionName(k.g,g)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(g,b){return k.f.$customDebugAdapterRequest(k.g,g,b)},getDebugProtocolBreakpoint(g){return k.f.$getDebugProtocolBreakpoint(k.g,g.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$Moc=l;class ${constructor(k){this.value=Object.freeze({append(g){k.$appendDebugConsole(g)},appendLine(g){this.append(g+`
`)}})}}e.$Noc=$;class I{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(g=>g.onWillReceiveMessage?g.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(g=>g.onDidSendMessage?g.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(g=>g.onError?g.onError(k):void 0)}onExit(k,g){this.d.forEach(b=>b.onExit?b.onExit(k,g):void 0)}}class D extends d.$_sb{constructor(k){super(),this.h=k,k.onDidSendMessage(g=>{this.acceptMessage(g)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let y=class extends f{constructor(k,g,b,L,O,q,G,W){super(k,g,b,L,O,q,G,W)}};e.$Ooc=y,e.$Ooc=y=Qe([Ve(0,v.$WP),Ve(1,E.$Wnc),Ve(2,R.$Aoc),Ve(3,a.$Znc),Ve(4,c.$_nc),Ve(5,h.$Doc),Ve(6,s.$gQ),Ve(7,m.$Foc)],y)}),define(Ce[315],Ie([1,0,14,65,2,6,266,12,61,75,27,211,17,66,46,67]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0,w=qe(w),C=qe(C);class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const s=n.get(N.$_j),t=n.get(u.$WP).getProxy(T.$qN.MainThreadErrors);w.setUnexpectedErrorHandler(m=>{s.error(m);const f=w.$5(m);t.$onUnexpectedError(f)})}static async installFullHandler(n){const s=n.get(N.$_j),i=n.get(u.$WP),t=n.get(d.$Aoc),m=n.get(r.$eQ),f=i.getProxy(T.$qN.MainThreadExtensionService),l=i.getProxy(T.$qN.MainThreadErrors),$=await t.getExtensionPathIndex(),I=new WeakMap;function D(k,g){if(I.has(k))return I.get(k).stack;let b="",L,O;for(const G of g)b+=`
	at ${G.toString()}`,O=G.getFileName(),!L&&O&&(L=$.findSubstr(P.URI.file(O)));const q=`${k.name||"Error"}: ${k.message||""}${b}`;return I.set(k,{extensionIdentifier:L?.identifier,stack:q}),q}const y=Symbol("prepareStackTrace wrapped");let S=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return S},set(k){if(k===D||!k||k[y]){S=k||D;return}S=function(g,b){return D(g,b),k.call(Error,g,b)},Object.assign(S,{[y]:!0})}}),w.setUnexpectedErrorHandler(k=>{s.error(k);const g=w.$5(k),b=I.get(k);if(!b?.extensionIdentifier){l.$onUnexpectedError(g);return}f.$onExtensionRuntimeError(b.extensionIdentifier,g);const L=m.onExtensionError(b.extensionIdentifier,k);s.trace("forwarded error to extension?",L,b)})}}e.$Npc=o;class a{constructor(n,s,i,t,m){this.a=i,this.b=new A.$acc(n,null,t),s=a.e(s,this.b);const f=new c.$Di(...(0,p.$Ms)());f.set(R.$aQ,{_serviceBrand:void 0,...s,messagePorts:m}),f.set(u.$WP,new u.$XP(this.b)),f.set(E.$Tnc,new E.$Unc(t)),f.set(d.$yoc,i);const l=new v.$qr(f,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction($=>$.get(N.$_j)),C.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction($=>$.get(d.$Aoc)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const s=this.b.getProxy(T.$qN.MainThreadExtensionService);return P.URI.revive(await s.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,s){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(s.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=P.URI.revive(s.transformIncomingURIs(n.environment.appRoot));const i=n.environment.extensionDevelopmentLocationURI;return i&&(n.environment.extensionDevelopmentLocationURI=i.map(t=>P.URI.revive(s.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=P.URI.revive(s.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=P.URI.revive(s.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=P.URI.revive(s.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=P.URI.revive(s.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=P.URI.revive(s.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=P.URI.revive(s.transformIncomingURIs(n.logsLocation)),n.workspace=s.transformIncomingURIs(n.workspace),n}}e.$Opc=a}),define(Ce[316],Ie([1,0,18,11,22,48,16,20,24,2,43]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$4oc=e.$3oc=void 0,e.$5oc=r,N=qe(N),p=qe(p);class v{constructor(h,n,s){this.d=h,this.e=n,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(h,n){const s=this.g.folderQueries||[],i=new P.$xe(n);return new Promise((t,m)=>{this.a=new E(h);let f=!1;const l=($,I)=>{if(!f&&!this.b){const D=this.h($);r($)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,f=!0,i.cancel(),$=this.j($,this.g.maxResults-this.c));const y=this.h($);this.c+=y,(y>0||!r($))&&this.a.add($,I)}};Promise.all(s.map(($,I)=>this.k($,D=>l(D,I),i.token))).then($=>{i.dispose(),this.a.flush();const I=$.some(D=>!!D&&!!D.limitHit);t({limitHit:this.b||I,messages:$.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},$=>{i.dispose();const I=(0,T.$qj)($);m(new Error(I))})})}h(h){return r(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,n){const s=Array.isArray(h.ranges)?h.ranges:[h.ranges],i=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:s.slice(0,n),preview:{matches:i.slice(0,n),text:h.preview.text},uri:h.uri}}async k(h,n,s){const i=new R.$7L(this.g,h),t=[],m={report:$=>{if(!this.l($))return;const I=h.folder.scheme===A.Schemas.file?(0,R.$8L)(()=>this.e.readdir(p.$fh($.uri))):void 0,D=p.$ih(h.folder,$.uri);if(D){const y=i.includedInQuery(D,N.$pc(D),I);(0,C.$rh)(y)?t.push(y.then(S=>{S&&n($)})):y&&n($)}}},f=this.n(h);let l;return this.d.query.type===R.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,f,m,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),f,m,s),t.length&&await Promise.all(t),l}l(h){if(r(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const n=(0,R.$6L)(this.g.includePattern,h.includePattern),s=(0,R.$6L)(this.g.excludePattern,h.excludePattern),i={folder:c.URI.from(h.folder),excludes:s,includes:n,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.e.toCanonicalName(h.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??R.$ML,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(i.usePCRE2=this.g.usePCRE2),i}}e.$3oc=v;function u(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class E{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(h,n){this.d&&(this.b!==n||!p.$_g(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:h.uri,results:[]}),this.d.results.push(d(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.$4oc=E;function d(a){return r(a)?{preview:{matches:(0,w.$3b)(a.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:a.preview.text},ranges:(0,w.$3b)(a.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function r(a){return!!a.preview}class o{static{this.a=4e3}static{this.b=50}constructor(h,n){this.g=h,this.h=n,this.c=0,this.d=[],this.e=0}addItem(h,n){h&&this.j(h,n)}addItems(h,n){h&&this.k(h,n)}j(h,n){this.d.push(h),this.e+=n,this.l()}k(h,n){this.d=this.d.concat(h),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$6oc=o}),define(Ce[133],Ie([1,0,5,6,3,311,17,66,12,2,316]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=e.$7oc=void 0,e.$9oc=u,e.$7oc=(0,P.$Fi)("IExtHostSearch");let v=class{constructor(r,o,a){this.n=r,this.o=o,this.q=a,this.c=this.n.getProxy(C.$qN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$2oc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const a=this.d++;return this.e.set(a,o),this.c.$registerTextSearchProvider(a,this.s(r)),(0,w.$Uc)(()=>{this.g.delete(r),this.e.delete(a),this.c.$unregisterProvider(a)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const a=this.d++;return this.h.set(a,o),this.c.$registerAITextSearchProvider(a,this.s(r)),(0,w.$Uc)(()=>{this.i.delete(r),this.h.delete(a),this.c.$unregisterProvider(a)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const a=this.d++;return this.j.set(a,o),this.c.$registerFileSearchProvider(a,this.s(r)),(0,w.$Uc)(()=>{this.k.delete(r),this.j.delete(a),this.c.$unregisterProvider(a)})}$provideFileSearchResults(r,o,a,h){const n=u(a),s=this.j.get(r);if(s)return this.l.fileSearch(n,s,i=>{this.c.$handleFileMatch(r,o,i.map(t=>t.resource))},h);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,a){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,a,h){const n=this.e.get(r);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const s=u(a);return this.t(s,n).search(t=>this.c.$handleTextMatch(r,o,t),h)}$provideAITextSearchResults(r,o,a,h){const n=this.h.get(r);if(!n||!n.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const s=u(a);return this.v(s,n).search(t=>this.c.$handleTextMatch(r,o,t),h)}$enableExtensionHostSearch(){}t(r,o){return new R.$3oc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}v(r,o){return new R.$3oc({query:r,provider:o},{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"aiTextSearchProvider")}};e.$8oc=v,e.$8oc=v=Qe([Ve(0,A.$WP),Ve(1,N.$Tnc),Ve(2,p.$_j)],v);function u(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(E),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>c.URI.revive(r))}}function E(d){return{...d,folder:c.URI.revive(d.folder)}}});var ri=this&&this.__importDefault||function(oe){return oe&&oe.__esModule?oe:{default:oe}};define(Ce[317],Ie([1,0,22,14,4,5,16,36,2,105,164,150,52,19,30,12,63,64,225,6,269,297,85,91,274,275,276,253,242,34,277,45,278,132,121,279,255,270,280,281,58,71,256,271,46,283,69,284,51,27,298,257,285,95,286,86,87,259,310,288,230,289,299,290,127,260,291,292,293,17,294,133,88,295,261,296,89,92,130,67,57,125,96,300,272,301,302,93,10,7,262,66,263,68,303,304,120,44,81,84,25,129]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l,$,I,D,y,S,k,g,b,L,O,q,G,W,F,V,ce,ge,te,me,se,de,be,re,Pe,Le,Y,B,_,ve,ae,we,le,X,Z,pe,$e,Ne,ze,ke,Re,Te,U,z,K,H,ne,fe,Ae,Ue,Ke,_e,it,nt,tt,rt,$t,lt,st,ct,gt,mt,Be,je,Q,x,De,Xe,Ze,dt,pt,Lt,jt,xt,li,xe,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ipc=Gt,C=qe(C),N=ri(N),v=qe(v),d=qe(d),je=qe(je),Q=qe(Q);function Gt(ht){const bt=ht.get(Pe.$aQ),hi=ht.get(re.$Enc),_t=ht.get(de.$2nc),Bt=ht.get(me.$Aoc),wt=ht.get(jt.$Wnc),Wt=ht.get(tt.$eQ),Ht=ht.get(k.$Znc),Jt=ht.get(De.$Tnc),Je=ht.get(K.$WP),pi=ht.get(_e.$ioc),ei=ht.get(it.$3nc),si=ht.get(r.$ak),St=ht.get(r.$_j),Kt=ht.get(Be.$mFb),At=ht.get(t.$Anc),Ft=ht.get(Lt.$Hpc),ti=ht.get(fe.$soc),ii=ht.get(ce.$_nc),oi=ht.get(we.$woc),Ut=ht.get(m.$Knc),Qt=ht.get(_.$poc);Je.set(n.$rN.ExtHostFileSystemInfo,hi),Je.set(n.$rN.ExtHostLogLevelServiceShape,si),Je.set(n.$rN.ExtHostWorkspace,wt),Je.set(n.$rN.ExtHostConfiguration,Ht),Je.set(n.$rN.ExtHostExtensionService,Bt),Je.set(n.$rN.ExtHostStorage,pi),Je.set(n.$rN.ExtHostTunnelService,Kt),Je.set(n.$rN.ExtHostWindow,Ft),Je.set(n.$rN.ExtHostSecretState,ti),Je.set(n.$rN.ExtHostTelemetry,Wt),Je.set(n.$rN.ExtHostEditorTabs,ii),Je.set(n.$rN.ExtHostManagedSockets,oi),Je.set(n.$rN.ExtHostAuthentication,Ut),Je.set(n.$rN.ExtHostChatProvider,Qt);const di=Je.set(n.$rN.ExtHostDecorations,ht.get(L.$Qoc)),Mt=Je.set(n.$rN.ExtHostDocumentsAndEditors,ht.get(V.$8P)),vt=Je.set(n.$rN.ExtHostCommands,ht.get(y.$gQ)),Ct=Je.set(n.$rN.ExtHostTerminalService,ht.get(rt.$loc)),Ot=Je.set(n.$rN.ExtHostTerminalShellIntegration,ht.get($t.$xpc)),kt=Je.set(n.$rN.ExtHostDebugService,ht.get(b.$Koc)),Xt=Je.set(n.$rN.ExtHostSearch,ht.get(ne.$7oc)),qt=Je.set(n.$rN.ExtHostTask,ht.get(nt.$wpc)),$i=Je.set(n.$rN.ExtHostOutputService,ht.get(ke.$jpc)),fi=Je.set(n.$rN.ExtHostLocalization,ht.get(ae.$voc)),Ri=Je.set(n.$rN.ExtHostUrls,new Xe.$Epc(Je)),Nt=Je.set(n.$rN.ExtHostDocuments,new F.$Hnc(Je,Mt)),Oi=Je.set(n.$rN.ExtHostDocumentContentProviders,new G.$Soc(Je,Mt,St)),ai=Je.set(n.$rN.ExtHostDocumentSaveParticipant,new W.$Toc(St,Nt,Je.getProxy(n.$qN.MainThreadBulkEdits))),Rt=Je.set(n.$rN.ExtHostNotebook,new X.$0oc(Je,vt,Mt,Nt,_t,Xt,St)),Di=Je.set(n.$rN.ExtHostNotebookDocuments,new pe.$dpc(Rt)),Si=Je.set(n.$rN.ExtHostNotebookEditors,new $e.$epc(St,Rt)),vi=Je.set(n.$rN.ExtHostNotebookKernels,new Ne.$fpc(Je,bt,Rt,vt,St)),Ti=Je.set(n.$rN.ExtHostNotebookRenderers,new ze.$hpc(Je,Rt)),gi=Je.set(n.$rN.ExtHostNotebookDocumentSaveParticipant,new Z.$cpc(St,Rt,Je.getProxy(n.$qN.MainThreadBulkEdits))),Vt=Je.set(n.$rN.ExtHostEditors,new st.$Qnc(Je,Mt)),ye=Je.set(n.$rN.ExtHostTreeViews,new mt.$Cpc(Je.getProxy(n.$qN.MainThreadTreeViews),vt,St)),Oe=Je.set(n.$rN.ExtHostEditorInsets,new D.$Rnc(Je.getProxy(n.$qN.MainThreadEditorInsets),Vt,bt.remote)),ue=Je.set(n.$rN.ExtHostDiagnostics,new O.$Gnc(Je,St,hi,Mt)),J=Je.set(n.$rN.ExtHostLanguages,new ve.$apc(Je,Nt,vt.converter,Jt)),Ee=Je.set(n.$rN.ExtHostLanguageFeatures,new B.$Inc(Je,Jt,Nt,vt,ue,St,At,Wt)),We=Je.set(n.$rN.ExtHostFileSystem,new se.$Woc(Je,Ee)),Ye=Je.set(n.$rN.ExtHostFileSystemEventService,new be.$Xoc(Je,St,Mt)),Ge=Je.set(n.$rN.ExtHostQuickOpen,(0,z.$npc)(Je,wt,vt)),ut=Je.set(n.$rN.ExtHostSCM,new H.$ppc(Je,vt,Nt,St)),Pt=Je.set(n.$rN.ExtHostQuickDiff,new U.$mpc(Je,Jt)),Yt=Je.set(n.$rN.ExtHostShare,new Ae.$qpc(Je,Jt)),ci=Je.set(n.$rN.ExtHostComments,(0,S.$Snc)(Je,vt,Nt)),zt=Je.set(n.$rN.ExtHostProgress,new Te.$lpc(Je.getProxy(n.$qN.MainThreadProgress))),ni=Je.set(n.$rN.ExtHostLabelService,new Y.$_oc(Je)),ji=Je.set(n.$rN.ExtHostTheming,new ct.$zpc(Je)),Zi=Je.set(n.$rN.ExtHostTimeline,new gt.$Bpc(Je,vt)),Bi=Je.set(n.$rN.ExtHostWebviews,new Ze.$7nc(Je,bt.remote,wt,St,At)),Fi=Je.set(n.$rN.ExtHostWebviewPanels,new dt.$0nc(Je,Bi,wt)),Wi=Je.set(n.$rN.ExtHostCustomEditors,new g.$$nc(Je,Nt,ei,Bi,Fi)),Vi=Je.set(n.$rN.ExtHostWebviewViews,new pt.$Fpc(Je,Bi)),ki=Je.set(n.$rN.ExtHostTesting,ht.get(lt.$Foc)),xi=Je.set(n.$rN.ExtHostUriOpeners,new x.$Dpc(Je)),_i=Je.set(n.$rN.ExtHostProfileContentHandlers,new Re.$kpc(Je));Je.set(n.$rN.ExtHostInteractive,new Le.$$oc(Je,Rt,Mt,vt,St));const Li=Je.set(n.$rN.ExtHostChatAgents2,new l.$Nnc(Je,St,vt,bt.quality)),en=Je.set(n.$rN.ExtHostChatVariables,new $.$Onc(Je)),qi=Je.set(n.$rN.ExtHostAiRelatedInformation,new s.$znc(Je)),pn=Je.set(n.$rN.ExtHostAiEmbeddingVector,new te.$Voc(Je)),tn=Je.set(n.$rN.ExtHostStatusBar,new Ke.$tpc(Je,vt.converter)),Gi=Je.set(n.$rN.ExtHostSpeech,new Ue.$rpc(Je)),Ci=Je.set(n.$rN.ExtHostEmbeddings,new ge.$Uoc(Je)),$n=Object.values(n.$rN);Je.assertRegistered($n);const bn=new f.$Mnc(Je,Mt),nn=new I.$Pnc(Je),Ki=new le.$bpc(Je,St),Mi=new q.$Roc(Je);return i.$Jnc.register(vt),function(Me,bi,Qi){function ot(ee){return(he,Fe,at)=>{const Dt=ee(Tt=>{try{he.call(Fe,Tt)}catch(Ii){C.$4(new Error(`[ExtensionListenerError] Extension '${Me.identifier.value}' FAILED to handle event: ${Ii.toString()}`,{cause:Ii})),Wt.onExtensionError(Me.identifier,Ii)}});return at?.push(Dt),Dt}}const Et=function(){let ee=!Me.isUnderDevelopment;function he(){ee||(St.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Fe(at){if(Array.isArray(at))at.forEach(Fe);else if(typeof at=="string")he();else{const Dt=at;typeof Dt.scheme>"u"&&he(),typeof Dt.exclusive=="boolean"&&(0,xe.$5G)(Me,"documentFiltersExclusive")}return at}}(),rn={getSession(ee,he,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,xe.$5G)(Me,"authLearnMore"),Fe?.account&&(0,xe.$5G)(Me,"authGetSessions"),Ut.getSession(Me,ee,he,Fe)},getSessions(ee,he){return(0,xe.$5G)(Me,"authGetSessions"),Ut.getSessions(Me,ee,he)},getAccounts(ee){return(0,xe.$5G)(Me,"authGetSessions"),Ut.getAccounts(ee)},async hasSession(ee,he){return(0,xe.$5G)(Me,"authSession"),!!await Ut.getSession(Me,ee,he,{silent:!0})},get onDidChangeSessions(){return ot(Ut.onDidChangeSessions)},registerAuthenticationProvider(ee,he,Fe,at){return Ut.registerAuthenticationProvider(ee,he,Fe,at)}},yi={registerCommand(ee,he,Fe){return vt.registerCommand(!0,ee,he,Fe,void 0,Me)},registerTextEditorCommand(ee,he,Fe){return vt.registerCommand(!0,ee,(...at)=>{const Dt=Vt.getActiveTextEditor();if(!Dt){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}return Dt.edit(Tt=>{he.apply(Fe,[Dt,Tt,...at])}).then(Tt=>{Tt||St.warn("Edits from command "+ee+" were not applied.")},Tt=>{St.warn("An error occurred while running command "+ee,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(ee,he,Fe)=>((0,xe.$5G)(Me,"diffCommand"),vt.registerCommand(!0,ee,async(...at)=>{const Dt=Mt.activeEditor(!0);if(!Dt){St.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Tt=await Vt.getDiffInformation(Dt.id);he.apply(Fe,[Tt,...at])},void 0,void 0,Me)),executeCommand(ee,...he){return vt.executeCommand(ee,...he)},getCommands(ee=!1){return vt.getCommands(ee)}},Ni={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return Ct.getDefaultShell(!1)},get onDidChangeShell(){return ot(Ct.onDidChangeShell)},get isTelemetryEnabled(){return Wt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Wt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$5G)(Me,"telemetry"),Wt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$5G)(Me,"telemetry"),ot(Wt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$dQ)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,he){return tt.$cQ.validateSender(ee),Wt.instantiateLogger(Me,ee,he)},openExternal(ee,he){return Ft.openUri(ee,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===bt.environment.appUriScheme)return Ri.createAppUri(ee);try{return await Ft.asExternalUri(ee,{allowTunneling:!!bt.remote.authority})}catch(he){if((0,A.$Og)(ee,A.Schemas.http)||(0,A.$Og)(ee,A.Schemas.https))return ee;throw he}},get remoteName(){return(0,o.$hn)(bt.remote.authority)},get remoteAuthority(){return(0,xe.$5G)(Me,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return St.getLevel()},get onDidChangeLogLevel(){return ot(St.onDidChangeLogLevel)},get appQuality(){return(0,xe.$5G)(Me,"resolvers"),bt.quality},get appCommit(){return(0,xe.$5G)(Me,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Ni);const wn={createTestController(ee,he,Fe){return ki.createTestController(Me,ee,he,Fe)},createTestObserver(){return(0,xe.$5G)(Me,"testObserver"),ki.createTestObserver()},runTests(ee){return(0,xe.$5G)(Me,"testObserver"),ki.runTests(ee)},registerTestFollowupProvider(ee){return(0,xe.$5G)(Me,"testObserver"),ki.registerTestFollowupProvider(ee)},get onDidChangeTestResults(){return(0,xe.$5G)(Me,"testObserver"),ot(ki.onResultsChanged)},get testResults(){return(0,xe.$5G)(Me,"testObserver"),ki.results}},ui=bt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,zi={getExtension(ee,he){(0,xe.$4G)(Me,"extensionsAny")||(he=!1);const Fe=bi.mine.getExtensionDescription(ee);if(Fe)return new me.$Boc(Bt,Me.identifier,Fe,ui,!1);if(he){const at=bi.all.getExtensionDescription(ee);if(at)return new me.$Boc(Bt,Me.identifier,at,ui,!0)}},get all(){const ee=[];for(const he of bi.mine.getAllExtensionDescriptions())ee.push(new me.$Boc(Bt,Me.identifier,he,ui,!1));return ee},get allAcrossExtensionHosts(){(0,xe.$5G)(Me,"extensionsAny");const ee=new E.$rn(bi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),he=[];for(const Fe of bi.all.getAllExtensionDescriptions()){const at=!ee.has(Fe.identifier);he.push(new me.$Boc(Bt,Me.identifier,Fe,ui,at))}return he},get onDidChange(){return(0,xe.$4G)(Me,"extensionsAny")?ot(P.Event.any(bi.mine.onDidChange,bi.all.onDidChange)):ot(bi.mine.onDidChange)}},sn={createDiagnosticCollection(ee){return ue.createDiagnosticCollection(Me.identifier,ee)},get onDidChangeDiagnostics(){return ot(ue.onDidChangeDiagnostics)},getDiagnostics:ee=>ue.getDiagnostics(ee),getLanguages(){return J.getLanguages()},setTextDocumentLanguage(ee,he){return J.changeLanguage(ee.uri,he)},match(ee,he){const Fe=je.LanguageSelector.from(ee);let at;return(0,R.$qu)(Fe)&&(at=Rt.notebookDocuments.find(Dt=>Dt.apiNotebook.getCells().find(Tt=>Tt.document===he))?.apiNotebook),(0,R.$pu)(Fe,he.uri,he.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(ee,he,Fe){return Ee.registerCodeActionProvider(Me,Et(ee),he,Fe)},registerDocumentPasteEditProvider(ee,he,Fe){return(0,xe.$5G)(Me,"documentPaste"),Ee.registerDocumentPasteEditProvider(Me,Et(ee),he,Fe)},registerCodeLensProvider(ee,he){return Ee.registerCodeLensProvider(Me,Et(ee),he)},registerDefinitionProvider(ee,he){return Ee.registerDefinitionProvider(Me,Et(ee),he)},registerDeclarationProvider(ee,he){return Ee.registerDeclarationProvider(Me,Et(ee),he)},registerImplementationProvider(ee,he){return Ee.registerImplementationProvider(Me,Et(ee),he)},registerTypeDefinitionProvider(ee,he){return Ee.registerTypeDefinitionProvider(Me,Et(ee),he)},registerHoverProvider(ee,he){return Ee.registerHoverProvider(Me,Et(ee),he,Me.identifier)},registerEvaluatableExpressionProvider(ee,he){return Ee.registerEvaluatableExpressionProvider(Me,Et(ee),he,Me.identifier)},registerInlineValuesProvider(ee,he){return Ee.registerInlineValuesProvider(Me,Et(ee),he,Me.identifier)},registerDocumentHighlightProvider(ee,he){return Ee.registerDocumentHighlightProvider(Me,Et(ee),he)},registerMultiDocumentHighlightProvider(ee,he){return Ee.registerMultiDocumentHighlightProvider(Me,Et(ee),he)},registerLinkedEditingRangeProvider(ee,he){return Ee.registerLinkedEditingRangeProvider(Me,Et(ee),he)},registerReferenceProvider(ee,he){return Ee.registerReferenceProvider(Me,Et(ee),he)},registerRenameProvider(ee,he){return Ee.registerRenameProvider(Me,Et(ee),he)},registerNewSymbolNamesProvider(ee,he){return(0,xe.$5G)(Me,"newSymbolNamesProvider"),Ee.registerNewSymbolNamesProvider(Me,Et(ee),he)},registerDocumentSymbolProvider(ee,he,Fe){return Ee.registerDocumentSymbolProvider(Me,Et(ee),he,Fe)},registerWorkspaceSymbolProvider(ee){return Ee.registerWorkspaceSymbolProvider(Me,ee)},registerDocumentFormattingEditProvider(ee,he){return Ee.registerDocumentFormattingEditProvider(Me,Et(ee),he)},registerDocumentRangeFormattingEditProvider(ee,he){return Ee.registerDocumentRangeFormattingEditProvider(Me,Et(ee),he)},registerOnTypeFormattingEditProvider(ee,he,Fe,...at){return Ee.registerOnTypeFormattingEditProvider(Me,Et(ee),he,[Fe].concat(at))},registerDocumentSemanticTokensProvider(ee,he,Fe){return Ee.registerDocumentSemanticTokensProvider(Me,Et(ee),he,Fe)},registerDocumentRangeSemanticTokensProvider(ee,he,Fe){return Ee.registerDocumentRangeSemanticTokensProvider(Me,Et(ee),he,Fe)},registerSignatureHelpProvider(ee,he,Fe,...at){return typeof Fe=="object"?Ee.registerSignatureHelpProvider(Me,Et(ee),he,Fe):Ee.registerSignatureHelpProvider(Me,Et(ee),he,typeof Fe>"u"?[]:[Fe,...at])},registerCompletionItemProvider(ee,he,...Fe){return Ee.registerCompletionItemProvider(Me,Et(ee),he,Fe)},registerInlineCompletionItemProvider(ee,he,Fe){return he.handleDidShowCompletionItem&&(0,xe.$5G)(Me,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,xe.$5G)(Me,"inlineCompletionsAdditions"),Fe&&(0,xe.$5G)(Me,"inlineCompletionsAdditions"),Ee.registerInlineCompletionsProvider(Me,Et(ee),he,Fe)},registerInlineEditProvider(ee,he){return(0,xe.$5G)(Me,"inlineEdit"),Ee.registerInlineEditProvider(Me,Et(ee),he)},registerDocumentLinkProvider(ee,he){return Ee.registerDocumentLinkProvider(Me,Et(ee),he)},registerColorProvider(ee,he){return Ee.registerColorProvider(Me,Et(ee),he)},registerFoldingRangeProvider(ee,he){return Ee.registerFoldingRangeProvider(Me,Et(ee),he)},registerSelectionRangeProvider(ee,he){return Ee.registerSelectionRangeProvider(Me,ee,he)},registerCallHierarchyProvider(ee,he){return Ee.registerCallHierarchyProvider(Me,ee,he)},registerTypeHierarchyProvider(ee,he){return Ee.registerTypeHierarchyProvider(Me,ee,he)},setLanguageConfiguration:(ee,he)=>Ee.setLanguageConfiguration(Me,ee,he),getTokenInformationAtPosition(ee,he){return(0,xe.$5G)(Me,"tokenInformation"),J.tokenAtPosition(ee,he)},registerInlayHintsProvider(ee,he){return Ee.registerInlayHintsProvider(Me,ee,he)},createLanguageStatusItem(ee,he){return J.createLanguageStatusItem(Me,ee,he)},registerDocumentDropEditProvider(ee,he,Fe){return Ee.registerDocumentOnDropEditProvider(Me,ee,he,(0,xe.$4G)(Me,"documentPaste")?Fe:void 0)}},on={get activeTextEditor(){return Vt.getActiveTextEditor()},get visibleTextEditors(){return Vt.getVisibleTextEditors()},get activeTerminal(){return Ct.activeTerminal},get terminals(){return Ct.terminals},async showTextDocument(ee,he,Fe){p.URI.isUri(ee)&&ee.scheme===A.Schemas.vscodeRemote&&!ee.authority&&At.report("workspace.showTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(ee)?Promise.resolve(Hi.openTextDocument(ee)):Promise.resolve(ee));return Vt.showTextDocument(at,he,Fe)},createTextEditorDecorationType(ee){return Vt.createTextEditorDecorationType(Me,ee)},onDidChangeActiveTextEditor(ee,he,Fe){return ot(Vt.onDidChangeActiveTextEditor)(ee,he,Fe)},onDidChangeVisibleTextEditors(ee,he,Fe){return ot(Vt.onDidChangeVisibleTextEditors)(ee,he,Fe)},onDidChangeTextEditorSelection(ee,he,Fe){return ot(Vt.onDidChangeTextEditorSelection)(ee,he,Fe)},onDidChangeTextEditorOptions(ee,he,Fe){return ot(Vt.onDidChangeTextEditorOptions)(ee,he,Fe)},onDidChangeTextEditorVisibleRanges(ee,he,Fe){return ot(Vt.onDidChangeTextEditorVisibleRanges)(ee,he,Fe)},onDidChangeTextEditorViewColumn(ee,he,Fe){return ot(Vt.onDidChangeTextEditorViewColumn)(ee,he,Fe)},onDidCloseTerminal(ee,he,Fe){return ot(Ct.onDidCloseTerminal)(ee,he,Fe)},onDidOpenTerminal(ee,he,Fe){return ot(Ct.onDidOpenTerminal)(ee,he,Fe)},onDidChangeActiveTerminal(ee,he,Fe){return ot(Ct.onDidChangeActiveTerminal)(ee,he,Fe)},onDidChangeTerminalDimensions(ee,he,Fe){return(0,xe.$5G)(Me,"terminalDimensions"),ot(Ct.onDidChangeTerminalDimensions)(ee,he,Fe)},onDidChangeTerminalState(ee,he,Fe){return ot(Ct.onDidChangeTerminalState)(ee,he,Fe)},onDidWriteTerminalData(ee,he,Fe){return(0,xe.$5G)(Me,"terminalDataWriteEvent"),ot(Ct.onDidWriteTerminalData)(ee,he,Fe)},onDidExecuteTerminalCommand(ee,he,Fe){return(0,xe.$5G)(Me,"terminalExecuteCommandEvent"),ot(Ct.onDidExecuteTerminalCommand)(ee,he,Fe)},onDidChangeTerminalShellIntegration(ee,he,Fe){return(0,xe.$5G)(Me,"terminalShellIntegration"),ot(Ot.onDidChangeTerminalShellIntegration)(ee,he,Fe)},onDidStartTerminalShellExecution(ee,he,Fe){return(0,xe.$5G)(Me,"terminalShellIntegration"),ot(Ot.onDidStartTerminalShellExecution)(ee,he,Fe)},onDidEndTerminalShellExecution(ee,he,Fe){return(0,xe.$5G)(Me,"terminalShellIntegration"),ot(Ot.onDidEndTerminalShellExecution)(ee,he,Fe)},get state(){return Ft.getState()},onDidChangeWindowState(ee,he,Fe){return ot(Ft.onDidChangeWindowState)(ee,he,Fe)},showInformationMessage(ee,...he){return Ki.showMessage(Me,N.default.Info,ee,he[0],he.slice(1))},showWarningMessage(ee,...he){return Ki.showMessage(Me,N.default.Warning,ee,he[0],he.slice(1))},showErrorMessage(ee,...he){return Ki.showMessage(Me,N.default.Error,ee,he[0],he.slice(1))},showQuickPick(ee,he,Fe){return Ge.showQuickPick(Me,ee,he,Fe)},showWorkspaceFolderPick(ee){return Ge.showWorkspaceFolderPick(ee)},showInputBox(ee,he){return Ge.showInput(ee,he)},showOpenDialog(ee){return Mi.showOpenDialog(Me,ee)},showSaveDialog(ee){return Mi.showSaveDialog(ee)},createStatusBarItem(ee,he,Fe){let at,Dt,Tt;return typeof ee=="string"?(at=ee,Dt=he,Tt=Fe):(Dt=ee,Tt=he),tn.createStatusBarEntry(Me,at,Dt,Tt)},setStatusBarMessage(ee,he){return tn.setStatusBarMessage(ee,he)},withScmProgress(ee){return At.report("window.withScmProgress",Me,"Use 'withProgress' instead."),zt.withProgress(Me,{location:Q.ProgressLocation.SourceControl},(he,Fe)=>ee({report(at){}}))},withProgress(ee,he){return zt.withProgress(Me,ee,he)},createOutputChannel(ee,he){return $i.createOutputChannel(ee,he,Me)},createWebviewPanel(ee,he,Fe,at){return Fi.createWebviewPanel(Me,ee,he,Fe,at)},createWebviewTextEditorInset(ee,he,Fe,at){return(0,xe.$5G)(Me,"editorInsets"),Oe.createWebviewEditorInset(ee,he,Fe,at,Me)},createTerminal(ee,he,Fe){return typeof ee=="object"?"pty"in ee?Ct.createExtensionTerminal(ee):Ct.createTerminalFromOptions(ee):Ct.createTerminal(ee,he,Fe)},registerTerminalLinkProvider(ee){return Ct.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,he){return Ct.registerProfileProvider(Me,ee,he)},registerTerminalQuickFixProvider(ee,he){return(0,xe.$5G)(Me,"terminalQuickFixProvider"),Ct.registerTerminalQuickFixProvider(ee,Me.identifier.value,he)},registerTreeDataProvider(ee,he){return ye.registerTreeDataProvider(ee,he,Me)},createTreeView(ee,he){return ye.createTreeView(ee,he,Me)},registerWebviewPanelSerializer:(ee,he)=>Fi.registerWebviewPanelSerializer(Me,ee,he),registerCustomEditorProvider:(ee,he,Fe={})=>Wi.registerCustomEditorProvider(Me,ee,he,Fe),registerFileDecorationProvider(ee){return di.registerFileDecorationProvider(ee,Me)},registerUriHandler(ee){return Ri.registerUriHandler(Me,ee)},createQuickPick(){return Ge.createQuickPick(Me)},createInputBox(){return Ge.createInputBox(Me)},get activeColorTheme(){return ji.activeColorTheme},onDidChangeActiveColorTheme(ee,he,Fe){return ot(ji.onDidChangeActiveColorTheme)(ee,he,Fe)},registerWebviewViewProvider(ee,he,Fe){return Vi.registerWebviewViewProvider(Me,ee,he,Fe?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,he,Fe){return ot(Rt.onDidChangeActiveNotebookEditor)(ee,he,Fe)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,he,Fe){return ot(Si.onDidChangeNotebookEditorSelection)(ee,he,Fe)},onDidChangeNotebookEditorVisibleRanges(ee,he,Fe){return ot(Si.onDidChangeNotebookEditorVisibleRanges)(ee,he,Fe)},showNotebookDocument(ee,he){return Rt.showNotebookDocument(ee,he)},registerExternalUriOpener(ee,he,Fe){return(0,xe.$5G)(Me,"externalUriOpener"),xi.registerExternalUriOpener(Me.identifier,ee,he,Fe)},registerProfileContentHandler(ee,he){return(0,xe.$5G)(Me,"profileContentHandlers"),_i.registerProfileContentHandler(Me,ee,he)},registerQuickDiffProvider(ee,he,Fe,at){return(0,xe.$5G)(Me,"quickDiffProvider"),Pt.registerQuickDiffProvider(Et(ee),he,Fe,at)},get tabGroups(){return ii.tabGroups},registerShareProvider(ee,he){return(0,xe.$5G)(Me,"shareProvider"),Yt.registerShareProvider(Et(ee),he)}},Hi={get rootPath(){return At.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ee){throw new C.$$("rootPath")},getWorkspaceFolder(ee){return wt.getWorkspaceFolder(ee)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ee){throw new C.$$("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ee){throw new C.$$("workspaceFile")},updateWorkspaceFolders:(ee,he,...Fe)=>wt.updateWorkspaceFolders(Me,ee,he||0,...Fe),onDidChangeWorkspaceFolders:function(ee,he,Fe){return ot(wt.onDidChangeWorkspace)(ee,he,Fe)},asRelativePath:(ee,he)=>wt.getRelativePath(ee,he),findFiles:(ee,he,Fe,at)=>wt.findFiles(ee,he,Fe,Me.identifier,at),findFiles2:(ee,he,Fe)=>((0,xe.$5G)(Me,"findFiles2"),wt.findFiles2(ee,he,Me.identifier,Fe)),findTextInFiles:(ee,he,Fe,at)=>{(0,xe.$5G)(Me,"findTextInFiles");let Dt,Tt;return typeof he=="object"?(Dt=he,Tt=Fe):(Dt={},Tt=he,at=Fe),wt.findTextInFiles(ee,Dt||{},Tt,Me.identifier,at)},save:ee=>wt.save(ee),saveAs:ee=>wt.saveAs(ee),saveAll:ee=>wt.saveAll(ee),applyEdit(ee,he){return bn.applyWorkspaceEdit(ee,Me,he)},createFileSystemWatcher:(ee,he,Fe,at)=>{let Dt;return typeof he=="boolean"?Dt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!at,correlate:!1}:he&&((0,xe.$5G)(Me,"createFileSystemWatcher"),Dt={...he,correlate:!0}),Ye.createFileSystemWatcher(wt,Me,ee,Dt)},get textDocuments(){return Nt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new C.$$("textDocuments")},openTextDocument(ee){let he;const Fe=ee;if(typeof ee=="string")he=Promise.resolve(p.URI.file(ee));else if(p.URI.isUri(ee))he=Promise.resolve(ee);else if(!Fe||typeof Fe=="object")he=Nt.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(at=>(at.scheme===A.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Me,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(at).then(Dt=>Dt.document)))},onDidOpenTextDocument:(ee,he,Fe)=>ot(Nt.onDidAddDocument)(ee,he,Fe),onDidCloseTextDocument:(ee,he,Fe)=>ot(Nt.onDidRemoveDocument)(ee,he,Fe),onDidChangeTextDocument:(ee,he,Fe)=>ot(Nt.onDidChangeDocument)(ee,he,Fe),onDidSaveTextDocument:(ee,he,Fe)=>ot(Nt.onDidSaveDocument)(ee,he,Fe),onWillSaveTextDocument:(ee,he,Fe)=>ot(ai.getOnWillSaveTextDocumentEvent(Me))(ee,he,Fe),get notebookDocuments(){return Rt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,he){let Fe;if(p.URI.isUri(ee))Fe=ee,await Rt.openNotebookDocument(ee);else if(typeof ee=="string")Fe=p.URI.revive(await Rt.createNotebookDocument({viewType:ee,content:he}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(ee,he,Fe){return ot(Di.onDidSaveNotebookDocument)(ee,he,Fe)},onDidChangeNotebookDocument(ee,he,Fe){return ot(Di.onDidChangeNotebookDocument)(ee,he,Fe)},onWillSaveNotebookDocument(ee,he,Fe){return ot(gi.getOnWillSaveNotebookDocumentEvent(Me))(ee,he,Fe)},get onDidOpenNotebookDocument(){return ot(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,he,Fe,at){return Rt.registerNotebookSerializer(Me,ee,he,Fe,(0,xe.$4G)(Me,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(ee,he,Fe)=>ot(Qi.onDidChangeConfiguration)(ee,he,Fe),getConfiguration(ee,he){return he=arguments.length===1?void 0:he,Qi.getConfiguration(ee,he,Me)},registerTextDocumentContentProvider(ee,he){return Oi.registerTextDocumentContentProvider(ee,he)},registerTaskProvider:(ee,he)=>(At.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(Me,ee,he)),registerFileSystemProvider(ee,he,Fe){return(0,T.$Tc)(We.registerFileSystemProvider(Me,ee,he,Fe),_t.addFileSystemProvider(ee,he,Fe))},get fs(){return _t.value},registerFileSearchProvider:(ee,he)=>((0,xe.$5G)(Me,"fileSearchProvider"),Xt.registerFileSearchProvider(ee,he)),registerTextSearchProvider:(ee,he)=>((0,xe.$5G)(Me,"textSearchProvider"),Xt.registerTextSearchProvider(ee,he)),registerAITextSearchProvider:(ee,he)=>((0,xe.$5G)(Me,"aiTextSearchProvider"),(0,xe.$5G)(Me,"textSearchProvider"),Xt.registerAITextSearchProvider(ee,he)),registerRemoteAuthorityResolver:(ee,he)=>((0,xe.$5G)(Me,"resolvers"),Bt.registerRemoteAuthorityResolver(ee,he)),registerResourceLabelFormatter:ee=>((0,xe.$5G)(Me,"resolvers"),ni.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,xe.$5G)(Me,"resolvers"),Bt.getRemoteExecServer(ee)),onDidCreateFiles:(ee,he,Fe)=>ot(Ye.onDidCreateFile)(ee,he,Fe),onDidDeleteFiles:(ee,he,Fe)=>ot(Ye.onDidDeleteFile)(ee,he,Fe),onDidRenameFiles:(ee,he,Fe)=>ot(Ye.onDidRenameFile)(ee,he,Fe),onWillCreateFiles:(ee,he,Fe)=>ot(Ye.getOnWillCreateFileEvent(Me))(ee,he,Fe),onWillDeleteFiles:(ee,he,Fe)=>ot(Ye.getOnWillDeleteFileEvent(Me))(ee,he,Fe),onWillRenameFiles:(ee,he,Fe)=>ot(Ye.getOnWillRenameFileEvent(Me))(ee,he,Fe),openTunnel:ee=>((0,xe.$5G)(Me,"tunnels"),Kt.openTunnel(Me,ee).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,xe.$5G)(Me,"tunnels"),Kt.getTunnels()},onDidChangeTunnels:(ee,he,Fe)=>((0,xe.$5G)(Me,"tunnels"),ot(Kt.onDidChangeTunnels)(ee,he,Fe)),registerPortAttributesProvider:(ee,he)=>((0,xe.$5G)(Me,"portsAttributes"),Kt.registerPortsAttributesProvider(ee,he)),registerTunnelProvider:(ee,he)=>((0,xe.$5G)(Me,"tunnelFactory"),Kt.registerTunnelProvider(ee,he)),registerTimelineProvider:(ee,he)=>((0,xe.$5G)(Me,"timeline"),Zi.registerTimelineProvider(ee,he,Me.identifier,vt.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ee=>((0,xe.$5G)(Me,"workspaceTrust"),wt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,he,Fe)=>ot(wt.onDidGrantWorkspaceTrust)(ee,he,Fe),registerEditSessionIdentityProvider:(ee,he)=>((0,xe.$5G)(Me,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ee,he)),onWillCreateEditSessionIdentity:(ee,he,Fe)=>((0,xe.$5G)(Me,"editSessionIdentityProvider"),ot(wt.getOnWillCreateEditSessionIdentityEvent(Me))(ee,he,Fe)),registerCanonicalUriProvider:(ee,he)=>((0,xe.$5G)(Me,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ee,he)),getCanonicalUri:(ee,he,Fe)=>((0,xe.$5G)(Me,"canonicalUriProvider"),wt.provideCanonicalUri(ee,he,Fe))},an={get inputBox(){return At.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Me)},createSourceControl(ee,he,Fe){return ut.createSourceControl(Me,ee,he,Fe)}},vn={createCommentController(ee,he){return ci.createCommentController(Me,ee,he)}},cn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(ee,he){return(0,xe.$5G)(Me,"debugVisualization"),kt.registerDebugVisualizationProvider(Me,ee,he)},registerDebugVisualizationTreeProvider(ee,he){return(0,xe.$5G)(Me,"debugVisualization"),kt.registerDebugVisualizationTree(Me,ee,he)},onDidStartDebugSession(ee,he,Fe){return ot(kt.onDidStartDebugSession)(ee,he,Fe)},onDidTerminateDebugSession(ee,he,Fe){return ot(kt.onDidTerminateDebugSession)(ee,he,Fe)},onDidChangeActiveDebugSession(ee,he,Fe){return ot(kt.onDidChangeActiveDebugSession)(ee,he,Fe)},onDidReceiveDebugSessionCustomEvent(ee,he,Fe){return ot(kt.onDidReceiveDebugSessionCustomEvent)(ee,he,Fe)},onDidChangeBreakpoints(ee,he,Fe){return ot(kt.onDidChangeBreakpoints)(ee,he,Fe)},onDidChangeActiveStackItem(ee,he,Fe){return ot(kt.onDidChangeActiveStackItem)(ee,he,Fe)},registerDebugConfigurationProvider(ee,he,Fe){return kt.registerDebugConfigurationProvider(ee,he,Fe||xt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,he){return kt.registerDebugAdapterDescriptorFactory(Me,ee,he)},registerDebugAdapterTrackerFactory(ee,he){return kt.registerDebugAdapterTrackerFactory(ee,he)},startDebugging(ee,he,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?kt.startDebugging(ee,he,{parentSession:Fe}):kt.startDebugging(ee,he,Fe||{})},stopDebugging(ee){return kt.stopDebugging(ee)},addBreakpoints(ee){return kt.addBreakpoints(ee)},removeBreakpoints(ee){return kt.removeBreakpoints(ee)},asDebugSourceUri(ee,he){return kt.asDebugSourceUri(ee,he)}},un={registerTaskProvider:(ee,he)=>qt.registerTaskProvider(Me,ee,he),fetchTasks:ee=>qt.fetchTasks(ee),executeTask:ee=>qt.executeTask(Me,ee),get taskExecutions(){return qt.taskExecutions},onDidStartTask:(ee,he,Fe)=>ot(qt.onDidStartTask)(ee,he,Fe),onDidEndTask:(ee,he,Fe)=>ot(qt.onDidEndTask)(ee,he,Fe),onDidStartTaskProcess:(ee,he,Fe)=>ot(qt.onDidStartTaskProcess)(ee,he,Fe),onDidEndTaskProcess:(ee,he,Fe)=>ot(qt.onDidEndTaskProcess)(ee,he,Fe)},yn={createNotebookController(ee,he,Fe,at,Dt){return vi.createNotebookController(Me,ee,he,Fe,at,(0,xe.$4G)(Me,"notebookMessaging")?Dt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,he)=>Rt.registerNotebookCellStatusBarItemProvider(Me,ee,he),createRendererMessaging(ee){return Ti.createRendererMessaging(Me,ee)},createNotebookControllerDetectionTask(ee){return(0,xe.$5G)(Me,"notebookKernelSource"),vi.createNotebookControllerDetectionTask(Me,ee)},registerKernelSourceActionProvider(ee,he){return(0,xe.$5G)(Me,"notebookKernelSource"),vi.registerKernelSourceActionProvider(Me,ee,he)},onDidChangeNotebookCellExecutionState(ee,he,Fe){return(0,xe.$5G)(Me,"notebookCellExecutionState"),ot(vi.onDidChangeNotebookCellExecutionState)(ee,he,Fe)}},En={t(...ee){if(typeof ee[0]=="string"){const he=ee.shift(),Fe=!ee||typeof ee[0]!="object"?ee:ee[0];return fi.getMessage(Me.identifier.value,{message:he,args:Fe})}return fi.getMessage(Me.identifier.value,ee[0])},get bundle(){return fi.getBundle(Me.identifier.value)},get uri(){return fi.getBundleUri(Me.identifier.value)}},ln={_version:1,transferActiveChat(ee){return(0,xe.$5G)(Me,"interactive"),Li.transferActiveChat(ee)}},Ji={getRelatedInformation(ee,he){return(0,xe.$5G)(Me,"aiRelatedInformation"),qi.getRelatedInformation(Me,ee,he)},registerRelatedInformationProvider(ee,he){return(0,xe.$5G)(Me,"aiRelatedInformation"),qi.registerRelatedInformationProvider(Me,ee,he)},registerEmbeddingVectorProvider(ee,he){return(0,xe.$5G)(Me,"aiRelatedInformation"),pn.registerEmbeddingVectorProvider(Me,ee,he)}},hn={_version:1,registerChatResponseProvider(ee,he,Fe){return(0,xe.$5G)(Me,"chatProvider"),Qt.registerLanguageModel(Me,ee,he,Fe)},registerChatVariableResolver(ee,he,Fe,at,Dt,Tt,Ii,Ui){return(0,xe.$5G)(Me,"chatVariableResolver"),en.registerVariableResolver(Me,ee,he,Fe,at,Dt,Tt,Ii,Ui?.id)},registerMappedEditsProvider(ee,he){return(0,xe.$5G)(Me,"mappedEditsProvider"),Ee.registerMappedEditsProvider(Me,ee,he)},createChatParticipant(ee,he){return Li.createChatAgent(Me,ee,he)},createDynamicChatParticipant(ee,he,Fe){return(0,xe.$5G)(Me,"chatParticipantPrivate"),Li.createDynamicChatAgent(Me,ee,he,Fe)}},dn={selectChatModels:ee=>bt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Me.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):Qt.selectLanguageModels(Me,ee??{}),onDidChangeChatModels:(ee,he,Fe)=>bt.quality==="stable"?(console.warn(`[${E.$qn.toKey(Me.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),P.Event.None(ee,he,Fe)):Qt.onDidChangeProviders(ee,he,Fe),registerChatModelProvider:(ee,he,Fe)=>((0,xe.$5G)(Me,"chatProvider"),Qt.registerLanguageModel(Me,ee,he,Fe)),get embeddingModels(){return(0,xe.$5G)(Me,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ee,he,Fe)=>((0,xe.$5G)(Me,"embeddings"),Ci.onDidChange(ee,he,Fe)),registerEmbeddingsProvider(ee,he){return(0,xe.$5G)(Me,"embeddings"),Ci.registerEmbeddingsProvider(Me,ee,he)},async computeEmbeddings(ee,he,Fe){return(0,xe.$5G)(Me,"embeddings"),Ci.computeEmbeddings(ee,he,Fe)}},fn={registerSpeechProvider(ee,he){return(0,xe.$5G)(Me,"speech"),Gi.registerProvider(Me.identifier,ee,he)}};return{version:bt.version,ai:Ji,authentication:rn,commands:yi,comments:vn,chat:hn,debug:cn,env:Ni,extensions:zi,interactive:ln,l10n:En,languages:sn,lm:dn,notebooks:yn,scm:an,speech:fn,tasks:un,tests:wn,window:on,workspace:Hi,Breakpoint:Q.$tO,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$oP,CallHierarchyIncomingCall:Q.$RN,CallHierarchyItem:Q.$QN,CallHierarchyOutgoingCall:Q.$SN,CancellationError:C.$7,CancellationTokenSource:w.$xe,CandidatePortSource:n.CandidatePortSource,CodeAction:Q.$NN,CodeActionKind:Q.$ON,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$TN,Color:Q.$7N,ColorInformation:Q.$8N,ColorPresentation:Q.$9N,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.$1N,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$2N,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$eO,DebugAdapterExecutable:Q.$xO,DebugAdapterInlineImplementation:Q.$AO,DebugAdapterNamedPipeServer:Q.$zO,DebugAdapterServer:Q.$yO,DebugConfigurationProviderTriggerKind:xt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$QO,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$GN,DiagnosticRelatedInformation:Q.$FN,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$sN,DocumentHighlight:Q.$JN,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$KN,DocumentLink:Q.$6N,DocumentSymbol:Q.$MN,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$DO,InlineValueText:Q.$EO,InlineValueVariableLookup:Q.$FO,InlineValueEvaluatableExpression:Q.$GO,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:P.$me,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$SO,FileDecoration2:Q.$SO,FileSystemError:Q.$JO,FileType:d.FileType,FilePermission:d.FilePermission,FoldingRange:Q.$KO,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$vO,InlineCompletionItem:Q.$3N,InlineCompletionList:Q.$4N,Hover:Q.$HN,VerboseHover:Q.$IN,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:v.IndentAction,Location:Q.$EN,MarkdownString:Q.$UN,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:Q.$VN,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$tN,ProcessExecution:Q.$cO,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$RO,Range:Q.$uN,RelativePattern:Q.$rO,Selection:Q.$vN,SelectionRange:Q.$PN,SemanticTokens:Q.$NO,SemanticTokensBuilder:Q.$MO,SemanticTokensEdit:Q.$OO,SemanticTokensEdits:Q.$PO,SemanticTokensLegend:Q.$LO,ShellExecution:Q.$dO,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$XN,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$WN,SnippetString:Q.$DN,SourceBreakpoint:Q.$uO,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$LN,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$fO,TaskGroup:Q.$bO,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$0N,TerminalQuickFixTerminalCommand:Q.$_N,TerminalQuickFixOpener:Q.$$N,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$aO,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$zN,SnippetTextEdit:Q.$BN,TextEditorCursorStyle:c.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$qO,ThemeIcon:Q.$pO,TreeItem:Q.$gO,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$cP,UIKind:li.UIKind,Uri:p.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$CN,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$mO,DocumentDropOrPasteEditKind:Q.$nO,DocumentPasteEdit:Q.$oO,InlayHint:Q.$ZN,InlayHintLabelPart:Q.$YN,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$yN,ResolvedAuthority:Q.$wN,ManagedResolvedAuthority:Q.$xN,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$3O,NotebookRange:Q.$UO,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$VO,NotebookData:Q.$WO,NotebookRendererScript:Q.$1O,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$YO,NotebookCellOutputItem:Q.$XO,NotebookCellStatusBarItem:Q.$ZO,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$AN,NotebookKernelSourceAction:Q.$2O,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$5O,LinkedEditingRanges:Q.$4O,TestResultState:Q.TestResultState,TestRunRequest:Q.$6O,TestMessage:Q.$7O,TestTag:Q.$8O,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:It.TextSearchCompleteMessageType,DataTransfer:Q.$lO,DataTransferItem:Q.$hO,TestCoverageCount:Q.$9O,FileCoverage:Q.$$O,FileCoverage2:Q.$$O,StatementCoverage:Q.$_O,BranchCoverage:Q.$aP,DeclarationCoverage:Q.$bP,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$dP,TabInputTextDiff:Q.$eP,TabInputTextMerge:Q.$fP,TabInputCustom:Q.$gP,TabInputNotebook:Q.$iP,TabInputNotebookDiff:Q.$jP,TabInputWebview:Q.$hP,TabInputTerminal:Q.$kP,TabInputInteractiveWindow:Q.$lP,TabInputChat:Q.$mP,TabInputTextMultiDiff:Q.$nP,TelemetryTrustedValue:a.$tp,LogLevel:r.LogLevel,EditSessionIdentityMatch:h.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$BO,DebugThread:Q.$CO,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$pP,ChatResponseFileTreePart:Q.$tP,ChatResponseAnchorPart:Q.$uP,ChatResponseProgressPart:Q.$vP,ChatResponseProgressPart2:Q.$wP,ChatResponseReferencePart:Q.$zP,ChatResponseWarningPart:Q.$xP,ChatResponseTextEditPart:Q.$AP,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$qP,ChatResponseCommandButtonPart:Q.$yP,ChatResponseDetectedParticipantPart:Q.$rP,ChatResponseConfirmationPart:Q.$sP,ChatRequestTurn:Q.$BP,ChatResponseTurn:Q.$CP,ChatLocation:Q.ChatLocation,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$EP,LanguageModelChatMessageFunctionResultPart:Q.$DP,LanguageModelChatResponseTextPart:Q.$GP,LanguageModelChatResponseFunctionUsePart:Q.$FP,LanguageModelChatMessage2:Q.$EP,LanguageModelChatSystemMessage:Q.$HP,LanguageModelChatUserMessage:Q.$IP,LanguageModelChatAssistantMessage:Q.$JP,LanguageModelError:Q.$KP,NewSymbolName:Q.$IO,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$LP,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Ce[318],Ie([1,0,61,127,44,121,45,34,58,57,130,132,133,89,93,85,120,69,51,88,67,71,258,12,131,86,87,91,95,125,96]),function(oe,e,w,C,P,T,A,N,p,c,R,v,u,E,d,r,o,a,h,n,s,i,t,m,f,l,$,I,D,y,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$Ls)(l.$voc,l.$uoc,w.InstantiationType.Delayed),(0,w.$Ls)(m.$ak,t.$Jpc,w.InstantiationType.Delayed),(0,w.$Ls)(r.$Anc,r.$Bnc,w.InstantiationType.Delayed),(0,w.$Ls)(N.$gQ,N.$fQ,w.InstantiationType.Eager),(0,w.$Ls)(I.$Knc,I.$Lnc,w.InstantiationType.Eager),(0,w.$Ls)(D.$poc,D.$qoc,w.InstantiationType.Eager),(0,w.$Ls)(A.$Znc,A.$Xnc,w.InstantiationType.Eager),(0,w.$Ls)(a.$2nc,a.$1nc,w.InstantiationType.Eager),(0,w.$Ls)(S.$Foc,S.$Goc,w.InstantiationType.Eager),(0,w.$Ls)(v.$Koc,v.$Ooc,w.InstantiationType.Eager),(0,w.$Ls)(T.$Qoc,T.$Poc,w.InstantiationType.Eager),(0,w.$Ls)(p.$8P,p.$7P,w.InstantiationType.Eager),(0,w.$Ls)($.$woc,$.$xoc,w.InstantiationType.Eager),(0,w.$Ls)(h.$Enc,h.$Dnc,w.InstantiationType.Eager),(0,w.$Ls)(C.$jpc,C.$ipc,w.InstantiationType.Delayed),(0,w.$Ls)(u.$7oc,u.$8oc,w.InstantiationType.Eager),(0,w.$Ls)(E.$ioc,E.$hoc,w.InstantiationType.Eager),(0,w.$Ls)(R.$wpc,R.$vpc,w.InstantiationType.Eager),(0,w.$Ls)(c.$loc,c.$ooc,w.InstantiationType.Eager),(0,w.$Ls)(y.$xpc,y.$ypc,w.InstantiationType.Eager),(0,w.$Ls)(d.$mFb,d.$nFb,w.InstantiationType.Eager),(0,w.$Ls)(o.$Hpc,o.$Gpc,w.InstantiationType.Eager),(0,w.$Ls)(P.$Wnc,P.$Vnc,w.InstantiationType.Eager),(0,w.$Ls)(n.$soc,n.$roc,w.InstantiationType.Eager),(0,w.$Ls)(s.$eQ,s.$bQ,w.InstantiationType.Eager),(0,w.$Ls)(i.$_nc,i.$aoc,w.InstantiationType.Eager),(0,w.$Ls)(f.$Doc,f.$Eoc,w.InstantiationType.Eager)}),define(Ce[319],Ie([1,0,317,46,2,314,7,11,265]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vrc=void 0;class c extends T.$Mpc{j(){}getModule(E,d){for(const r of this.b){const o=r(E);if(o){E=o;break}}if(this.a.has(E))return this.a.get(E).load(E,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends C.$zoc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Urc);const E=this.h.invokeFunction(w.$Ipc);this.r=this.h.createInstance(c,E,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(E){return E.browser}async xb(E,d,r){d=d.with({path:v(d.path,".js")});const o=E?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const a=P.URI.revive(await this.C.$asBrowserUri(d)),h=await fetch(a.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),h.status!==200)throw new Error(h.statusText);const n=await h.text(),s=`${d.toString(!0)}#vscode-extension`,i=`${n}
//# sourceURL=${s}`;let t;try{t=new Function("module","exports","require",i)}catch($){throw console.error(o?`Loading code for extension ${o} failed: ${$.message}`:`Loading code failed: ${$.message}`),console.error(`${d.toString(!0)}${typeof $.line=="number"?` line ${$.line}`:""}${typeof $.column=="number"?` column ${$.column}`:""}`),console.error($),$}E&&await this.w.initializeLocalizedMessages(E);const m={},f={exports:m},l=$=>{const I=this.r.getModule($,d);if(I===void 0)throw new Error(`Cannot load module '${$}'`);return I};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),t(f,m,l),f.exports!==m?f.exports:m}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(E){}async Bb(E=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+E;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,N.$Gh)(10)}}e.$Vrc=R;function v(u,E){return u.endsWith(E)?u:u+E}}),define(Ce[320],Ie([1,0,74,61,12,46,228,92,319]),function(oe,e,w,C,P,T,A,N,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Ls)(P.$_j,new w.$Ci(A.$Lpc,[!0],!0)),(0,C.$Ls)(T.$Aoc,p.$Vrc,C.InstantiationType.Eager),(0,C.$Ls)(N.$3nc,N.$4nc,C.InstantiationType.Eager)}),define(Ce[328],Ie([1,0,23,4,84,315,267,20,65,16,2,318,320]),function(oe,e,w,C,P,T,A,N,p,c,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=i,N=qe(N),p=qe(p);const v=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function E(t){return/^(file|vscode-remote):/i.test(t)}const d=fetch.bind(self);function r(t){self.fetch=async function(m,f){return m instanceof Request||E(String(m))&&(m=(await t(R.URI.parse(String(m)))).toString(!0)),d(m,f)},self.XMLHttpRequest=class extends XMLHttpRequest{open(m,f,l,$,I){(async()=>(E(f.toString())&&(f=(await t(R.URI.parse(f.toString()))).toString(!0)),super.open(m,f,l??!0,$,I)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(m,f){if(/^file:/i.test(m.toString()))m=c.$Zg.uriToBrowserUri(R.URI.parse(m.toString())).toString(!0);else if(/^vscode-remote:/i.test(m.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const $=`(${function(S){function k(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const g=fetch.bind(self);self.fetch=function(L,O){return L instanceof Request?g(L,O):g(k(L),O)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,O,q,G,W){return super.open(L,k(O),q??!0,G,W)}};const b=importScripts.bind(self);self.importScripts=(...L)=>{b(...L.map(k))},b(S)}.toString()}('${m}'))`;f=f||{},f.name=`${name} -> ${f.name||N.$pc(m.toString())}`;const I=new Blob([$],{type:"application/javascript"}),D=URL.createObjectURL(I);return new t(D,f)}}else self.Worker=class extends A.$Wrc{constructor(t,m){super(u,t,{name:N.$pc(t.toString()),...m})}};const o=new class{constructor(){this.pid=void 0}exit(t){v()}};class a{constructor(){const m=new MessageChannel,f=new C.$me;let l=!1;u(m.port2,[m.port2]),m.port1.onmessage=$=>{const{data:I}=$;if(!(I instanceof ArrayBuffer)){console.warn("UNKNOWN data received",I);return}const D=w.$Oe.wrap(new Uint8Array(I,0,I.byteLength));if((0,P.$zn)(D,P.MessageType.Terminate)){l=!0,n("received terminate message from renderer");return}f.fire(D)},this.protocol={onMessage:f.event,send:$=>{if(!l){const I=$.buffer.buffer.slice($.buffer.byteOffset,$.buffer.byteOffset+$.buffer.byteLength);m.port1.postMessage(I,[I])}}}}}function h(t){return new Promise(m=>{const f=t.onMessage(l=>{f.dispose();const $=JSON.parse(l.toString());t.send((0,P.$yn)(P.MessageType.Initialized)),m({protocol:t,initData:$})});t.send((0,P.$yn)(P.MessageType.Ready))})}let n=t=>v();function s(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function i(){p.mark("code/extHost/willConnectToRenderer");const t=new a;return{onmessage(m){s(m)&&h(t.protocol).then(f=>{p.mark("code/extHost/didWaitForInitData");const l=new T.$Opc(f.protocol,f.initData,o,null,m.data);r($=>l.asBrowserUri($)),n=$=>l.terminate($)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/0cb5ca1d55b8ac035764b4726b5a01b6da22147d/core/vs/workbench/api/worker/extensionHostWorker.js.map
